#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 4717
#define LARGE_STATE_COUNT 1962
#define SYMBOL_COUNT 361
#define ALIAS_COUNT 3
#define TOKEN_COUNT 146
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 45
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 154

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_LF = 2,
  anon_sym_CR = 3,
  anon_sym_CR_LF = 4,
  anon_sym_POUND_BANG = 5,
  aux_sym_shebang_token1 = 6,
  anon_sym_SLASH_SLASH = 7,
  anon_sym_SLASH_STAR = 8,
  aux_sym_block_comment_token1 = 9,
  aux_sym_block_comment_token2 = 10,
  anon_sym_STAR_SLASH = 11,
  anon_sym_module = 12,
  anon_sym_import = 13,
  anon_sym_SEMI = 14,
  anon_sym_DOT = 15,
  anon_sym_as = 16,
  anon_sym_LBRACE = 17,
  anon_sym_COMMA = 18,
  anon_sym_RBRACE = 19,
  anon_sym_const = 20,
  anon_sym_LPAREN = 21,
  anon_sym_RPAREN = 22,
  anon_sym_EQ = 23,
  anon_sym___global = 24,
  anon_sym_type = 25,
  anon_sym_fn = 26,
  anon_sym_PLUS = 27,
  anon_sym_DASH = 28,
  anon_sym_STAR = 29,
  anon_sym_SLASH = 30,
  anon_sym_PERCENT = 31,
  anon_sym_LT = 32,
  anon_sym_GT = 33,
  anon_sym_EQ_EQ = 34,
  anon_sym_BANG_EQ = 35,
  anon_sym_LT_EQ = 36,
  anon_sym_GT_EQ = 37,
  anon_sym_DOT_DOT_DOT = 38,
  anon_sym_LBRACK = 39,
  anon_sym_LT2 = 40,
  anon_sym_RBRACK = 41,
  anon_sym_struct = 42,
  anon_sym_union = 43,
  anon_sym_pub = 44,
  anon_sym_mut = 45,
  anon_sym_COLON = 46,
  anon_sym_enum = 47,
  anon_sym_interface = 48,
  anon_sym_PLUS_PLUS = 49,
  anon_sym_DASH_DASH = 50,
  anon_sym_QMARK = 51,
  anon_sym_BANG = 52,
  anon_sym_go = 53,
  anon_sym_spawn = 54,
  anon_sym_json_DOTdecode = 55,
  anon_sym_PIPE = 56,
  anon_sym_LBRACK2 = 57,
  anon_sym_TILDE = 58,
  anon_sym_CARET = 59,
  anon_sym_AMP = 60,
  anon_sym_LT_DASH = 61,
  anon_sym_LT_LT = 62,
  anon_sym_GT_GT = 63,
  anon_sym_GT_GT_GT = 64,
  anon_sym_AMP_CARET = 65,
  anon_sym_AMP_AMP = 66,
  anon_sym_PIPE_PIPE = 67,
  anon_sym_or = 68,
  sym_escape_sequence = 69,
  sym_none = 70,
  sym_true = 71,
  sym_false = 72,
  sym_nil = 73,
  anon_sym_QMARK_DOT = 74,
  anon_sym_DOLLAR_LPAREN = 75,
  anon_sym_POUND_LBRACK = 76,
  anon_sym_if = 77,
  anon_sym_else = 78,
  anon_sym_DOLLARif = 79,
  anon_sym_DOLLARelse = 80,
  anon_sym_is = 81,
  anon_sym_BANGis = 82,
  anon_sym_in = 83,
  anon_sym_BANGin = 84,
  anon_sym_match = 85,
  anon_sym_select = 86,
  anon_sym_STAR_EQ = 87,
  anon_sym_SLASH_EQ = 88,
  anon_sym_PERCENT_EQ = 89,
  anon_sym_LT_LT_EQ = 90,
  anon_sym_GT_GT_EQ = 91,
  anon_sym_GT_GT_GT_EQ = 92,
  anon_sym_AMP_EQ = 93,
  anon_sym_AMP_CARET_EQ = 94,
  anon_sym_PLUS_EQ = 95,
  anon_sym_DASH_EQ = 96,
  anon_sym_PIPE_EQ = 97,
  anon_sym_CARET_EQ = 98,
  anon_sym_COLON_EQ = 99,
  anon_sym_lock = 100,
  anon_sym_rlock = 101,
  anon_sym_unsafe = 102,
  anon_sym_sql = 103,
  sym_int_literal = 104,
  sym_float_literal = 105,
  sym_rune_literal = 106,
  anon_sym_SQUOTE = 107,
  aux_sym_interpreted_string_literal_token1 = 108,
  anon_sym_DOLLAR = 109,
  anon_sym_DQUOTE = 110,
  aux_sym_interpreted_string_literal_token2 = 111,
  anon_sym_c_SQUOTE = 112,
  anon_sym_c_DQUOTE = 113,
  anon_sym_r_SQUOTE = 114,
  aux_sym_raw_string_literal_token1 = 115,
  anon_sym_r_DQUOTE = 116,
  aux_sym_raw_string_literal_token2 = 117,
  anon_sym_DOLLAR_LBRACE = 118,
  aux_sym_format_specifier_token1 = 119,
  aux_sym_format_specifier_token2 = 120,
  anon_sym_0 = 121,
  sym_pseudo_compile_time_identifier = 122,
  anon_sym_static = 123,
  anon_sym_volatile = 124,
  anon_sym_shared = 125,
  aux_sym_sum_type_token1 = 126,
  anon_sym_PIPE2 = 127,
  anon_sym_map_LBRACK = 128,
  anon_sym_chan = 129,
  anon_sym_thread = 130,
  anon_sym_atomic = 131,
  anon_sym_assert = 132,
  anon_sym_defer = 133,
  anon_sym_goto = 134,
  anon_sym_break = 135,
  anon_sym_continue = 136,
  anon_sym_return = 137,
  anon_sym_DOLLARfor = 138,
  anon_sym_for = 139,
  anon_sym_DOT_DOT = 140,
  anon_sym_POUND = 141,
  aux_sym_hash_statement_token1 = 142,
  anon_sym_asm = 143,
  aux_sym__content_block_token1 = 144,
  anon_sym_AT_LBRACK = 145,
  sym_source_file = 146,
  sym_shebang = 147,
  sym_line_comment = 148,
  sym_block_comment = 149,
  sym_module_clause = 150,
  sym_import_list = 151,
  sym_import_declaration = 152,
  sym_import_spec = 153,
  sym_import_path = 154,
  sym_import_name = 155,
  sym_import_alias = 156,
  sym_selective_import_list = 157,
  sym_const_declaration = 158,
  sym_const_definition = 159,
  sym_global_var_declaration = 160,
  sym_global_var_definition = 161,
  sym__global_var_value = 162,
  sym_type_declaration = 163,
  sym_function_declaration = 164,
  sym_static_method_declaration = 165,
  sym_static_receiver = 166,
  sym__function_name = 167,
  sym_overridable_operator = 168,
  sym_receiver = 169,
  sym_signature = 170,
  sym_parameter_list = 171,
  sym_parameter_declaration = 172,
  sym_type_parameter_list = 173,
  sym_type_parameter_declaration = 174,
  sym_generic_parameters = 175,
  sym_generic_parameter = 176,
  sym_struct_declaration = 177,
  sym__struct_body = 178,
  sym_struct_field_scope = 179,
  sym_struct_field_declaration = 180,
  sym__struct_field_definition = 181,
  sym_embedded_definition = 182,
  sym_enum_declaration = 183,
  sym_enum_backed_type = 184,
  sym__enum_body = 185,
  sym_enum_field_definition = 186,
  sym_interface_declaration = 187,
  sym__interface_body = 188,
  sym_interface_method_definition = 189,
  sym__expression = 190,
  sym__expression_without_blocks = 191,
  sym__expression_with_blocks = 192,
  sym_strictly_expression_list = 193,
  sym_inc_expression = 194,
  sym_dec_expression = 195,
  sym_or_block_expression = 196,
  sym_option_propagation_expression = 197,
  sym_result_propagation_expression = 198,
  sym_anon_struct_value_expression = 199,
  sym_go_expression = 200,
  sym_spawn_expression = 201,
  sym_parenthesized_expression = 202,
  sym_call_expression = 203,
  sym_type_parameters = 204,
  sym_argument_list = 205,
  sym_short_lambda = 206,
  sym_argument = 207,
  sym_special_argument_list = 208,
  sym_type_initializer = 209,
  sym_type_initializer_body = 210,
  sym_element_list = 211,
  sym_short_element_list = 212,
  sym_field_name = 213,
  sym_keyed_element = 214,
  sym_function_literal = 215,
  sym_capture_list = 216,
  sym_capture = 217,
  sym_reference_expression = 218,
  sym_type_reference_expression = 219,
  sym_unary_expression = 220,
  sym_receive_expression = 221,
  sym_binary_expression = 222,
  sym_as_type_cast_expression = 223,
  sym_or_block = 224,
  sym__max_group = 225,
  sym_literal = 226,
  sym_spread_expression = 227,
  sym_map_init_expression = 228,
  sym_map_keyed_element = 229,
  sym_array_creation = 230,
  sym_fixed_array_creation = 231,
  sym_selector_expression = 232,
  sym_compile_time_selector_expression = 233,
  sym_index_expression = 234,
  sym_slice_expression = 235,
  sym_if_expression = 236,
  sym_else_branch = 237,
  sym_compile_time_if_expression = 238,
  sym_is_expression = 239,
  sym_in_expression = 240,
  sym_enum_fetch = 241,
  sym_match_expression = 242,
  sym_match_arms = 243,
  sym_match_arm = 244,
  sym_match_expression_list = 245,
  sym_match_arm_type = 246,
  sym_match_else_arm_clause = 247,
  sym_select_expression = 248,
  sym_select_arm = 249,
  sym_select_arm_statement = 250,
  sym__select_arm_assignment_statement = 251,
  sym_select_var_declaration = 252,
  sym_select_else_arn_clause = 253,
  sym_lock_expression = 254,
  sym_unsafe_expression = 255,
  sym_sql_expression = 256,
  sym_interpreted_string_literal = 257,
  sym_c_string_literal = 258,
  sym_raw_string_literal = 259,
  sym_string_interpolation = 260,
  sym_format_specifier = 261,
  sym_visibility_modifiers = 262,
  sym_mutability_modifiers = 263,
  sym_mutable_identifier = 264,
  sym_mutable_expression = 265,
  sym_identifier_list = 266,
  sym_expression_list = 267,
  sym_expression_without_blocks_list = 268,
  sym_sum_type = 269,
  sym_plain_type = 270,
  sym__plain_type_without_special = 271,
  sym_anon_struct_type = 272,
  sym_multi_return_type = 273,
  sym_result_type = 274,
  sym_option_type = 275,
  sym_qualified_type = 276,
  sym_fixed_array_type = 277,
  sym_array_type = 278,
  sym_pointer_type = 279,
  sym_wrong_pointer_type = 280,
  sym_map_type = 281,
  sym_channel_type = 282,
  sym_shared_type = 283,
  sym_thread_type = 284,
  sym_atomic_type = 285,
  sym_generic_type = 286,
  sym_function_type = 287,
  sym__statement = 288,
  sym_simple_statement = 289,
  sym_assert_statement = 290,
  sym_append_statement = 291,
  sym_send_statement = 292,
  sym_var_declaration = 293,
  sym_var_definition_list = 294,
  sym_var_definition = 295,
  sym_assignment_statement = 296,
  sym_block = 297,
  sym_defer_statement = 298,
  sym_label_reference = 299,
  sym_goto_statement = 300,
  sym_break_statement = 301,
  sym_continue_statement = 302,
  sym_return_statement = 303,
  sym_label_definition = 304,
  sym_labeled_statement = 305,
  sym_compile_time_for_statement = 306,
  sym_for_statement = 307,
  sym_is_clause = 308,
  sym_range_clause = 309,
  sym_for_clause = 310,
  sym__definite_range = 311,
  sym_range = 312,
  sym_hash_statement = 313,
  sym_asm_statement = 314,
  sym__content_block = 315,
  sym_attributes = 316,
  sym_attribute = 317,
  sym_attribute_expression = 318,
  sym_if_attribute = 319,
  sym__plain_attribute = 320,
  sym_literal_attribute = 321,
  sym_value_attribute = 322,
  sym_key_value_attribute = 323,
  aux_sym_source_file_repeat1 = 324,
  aux_sym_block_comment_repeat1 = 325,
  aux_sym_import_list_repeat1 = 326,
  aux_sym_import_path_repeat1 = 327,
  aux_sym_selective_import_list_repeat1 = 328,
  aux_sym_const_declaration_repeat1 = 329,
  aux_sym_global_var_declaration_repeat1 = 330,
  aux_sym_parameter_list_repeat1 = 331,
  aux_sym_type_parameter_list_repeat1 = 332,
  aux_sym_generic_parameters_repeat1 = 333,
  aux_sym__struct_body_repeat1 = 334,
  aux_sym__enum_body_repeat1 = 335,
  aux_sym__interface_body_repeat1 = 336,
  aux_sym_strictly_expression_list_repeat1 = 337,
  aux_sym_type_parameters_repeat1 = 338,
  aux_sym_argument_list_repeat1 = 339,
  aux_sym_short_lambda_repeat1 = 340,
  aux_sym_element_list_repeat1 = 341,
  aux_sym_short_element_list_repeat1 = 342,
  aux_sym_capture_list_repeat1 = 343,
  aux_sym_map_init_expression_repeat1 = 344,
  aux_sym__array_repeat1 = 345,
  aux_sym_match_arms_repeat1 = 346,
  aux_sym_match_expression_list_repeat1 = 347,
  aux_sym_select_expression_repeat1 = 348,
  aux_sym_interpreted_string_literal_repeat1 = 349,
  aux_sym_interpreted_string_literal_repeat2 = 350,
  aux_sym_raw_string_literal_repeat1 = 351,
  aux_sym_raw_string_literal_repeat2 = 352,
  aux_sym_string_interpolation_repeat1 = 353,
  aux_sym_identifier_list_repeat1 = 354,
  aux_sym_expression_without_blocks_list_repeat1 = 355,
  aux_sym_sum_type_repeat1 = 356,
  aux_sym_var_definition_list_repeat1 = 357,
  aux_sym_block_repeat1 = 358,
  aux_sym_attributes_repeat1 = 359,
  aux_sym_attribute_repeat1 = 360,
  alias_sym_element = 361,
  alias_sym_interpolation_closing = 362,
  alias_sym_interpolation_expression = 363,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_LF] = "\n",
  [anon_sym_CR] = "\r",
  [anon_sym_CR_LF] = "\r\n",
  [anon_sym_POUND_BANG] = "#!",
  [aux_sym_shebang_token1] = "shebang_token1",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_SLASH_STAR] = "/*",
  [aux_sym_block_comment_token1] = "block_comment_token1",
  [aux_sym_block_comment_token2] = "block_comment_token2",
  [anon_sym_STAR_SLASH] = "*/",
  [anon_sym_module] = "module",
  [anon_sym_import] = "import",
  [anon_sym_SEMI] = ";",
  [anon_sym_DOT] = ".",
  [anon_sym_as] = "as",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_const] = "const",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_EQ] = "=",
  [anon_sym___global] = "__global",
  [anon_sym_type] = "type",
  [anon_sym_fn] = "fn",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_LBRACK] = "[",
  [anon_sym_LT2] = "<",
  [anon_sym_RBRACK] = "]",
  [anon_sym_struct] = "struct",
  [anon_sym_union] = "union",
  [anon_sym_pub] = "pub",
  [anon_sym_mut] = "mut",
  [anon_sym_COLON] = ":",
  [anon_sym_enum] = "enum",
  [anon_sym_interface] = "interface",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_QMARK] = "\?",
  [anon_sym_BANG] = "!",
  [anon_sym_go] = "go",
  [anon_sym_spawn] = "spawn",
  [anon_sym_json_DOTdecode] = "json.decode",
  [anon_sym_PIPE] = "|",
  [anon_sym_LBRACK2] = "[",
  [anon_sym_TILDE] = "~",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_AMP_CARET] = "&^",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_or] = "or",
  [sym_escape_sequence] = "escape_sequence",
  [sym_none] = "none",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_nil] = "nil",
  [anon_sym_QMARK_DOT] = "\?.",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_POUND_LBRACK] = "#[",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_DOLLARif] = "$if",
  [anon_sym_DOLLARelse] = "$else",
  [anon_sym_is] = "is",
  [anon_sym_BANGis] = "!is",
  [anon_sym_in] = "in",
  [anon_sym_BANGin] = "!in",
  [anon_sym_match] = "match",
  [anon_sym_select] = "select",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_AMP_CARET_EQ] = "&^=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_lock] = "lock",
  [anon_sym_rlock] = "rlock",
  [anon_sym_unsafe] = "unsafe",
  [anon_sym_sql] = "sql",
  [sym_int_literal] = "int_literal",
  [sym_float_literal] = "float_literal",
  [sym_rune_literal] = "rune_literal",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_interpreted_string_literal_token1] = "interpreted_string_literal_token1",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_interpreted_string_literal_token2] = "interpreted_string_literal_token2",
  [anon_sym_c_SQUOTE] = "c'",
  [anon_sym_c_DQUOTE] = "c\"",
  [anon_sym_r_SQUOTE] = "r'",
  [aux_sym_raw_string_literal_token1] = "raw_string_literal_token1",
  [anon_sym_r_DQUOTE] = "r\"",
  [aux_sym_raw_string_literal_token2] = "raw_string_literal_token2",
  [anon_sym_DOLLAR_LBRACE] = "interpolation_opening",
  [aux_sym_format_specifier_token1] = "format_specifier_token1",
  [aux_sym_format_specifier_token2] = "format_specifier_token2",
  [anon_sym_0] = "0",
  [sym_pseudo_compile_time_identifier] = "pseudo_compile_time_identifier",
  [anon_sym_static] = "static",
  [anon_sym_volatile] = "volatile",
  [anon_sym_shared] = "shared",
  [aux_sym_sum_type_token1] = "sum_type_token1",
  [anon_sym_PIPE2] = "|",
  [anon_sym_map_LBRACK] = "map[",
  [anon_sym_chan] = "chan",
  [anon_sym_thread] = "thread",
  [anon_sym_atomic] = "atomic",
  [anon_sym_assert] = "assert",
  [anon_sym_defer] = "defer",
  [anon_sym_goto] = "goto",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_return] = "return",
  [anon_sym_DOLLARfor] = "$for",
  [anon_sym_for] = "for",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_POUND] = "#",
  [aux_sym_hash_statement_token1] = "hash_statement_token1",
  [anon_sym_asm] = "asm",
  [aux_sym__content_block_token1] = "_content_block_token1",
  [anon_sym_AT_LBRACK] = "@[",
  [sym_source_file] = "source_file",
  [sym_shebang] = "shebang",
  [sym_line_comment] = "line_comment",
  [sym_block_comment] = "block_comment",
  [sym_module_clause] = "module_clause",
  [sym_import_list] = "import_list",
  [sym_import_declaration] = "import_declaration",
  [sym_import_spec] = "import_spec",
  [sym_import_path] = "import_path",
  [sym_import_name] = "import_name",
  [sym_import_alias] = "import_alias",
  [sym_selective_import_list] = "selective_import_list",
  [sym_const_declaration] = "const_declaration",
  [sym_const_definition] = "const_definition",
  [sym_global_var_declaration] = "global_var_declaration",
  [sym_global_var_definition] = "global_var_definition",
  [sym__global_var_value] = "_global_var_value",
  [sym_type_declaration] = "type_declaration",
  [sym_function_declaration] = "function_declaration",
  [sym_static_method_declaration] = "static_method_declaration",
  [sym_static_receiver] = "static_receiver",
  [sym__function_name] = "_function_name",
  [sym_overridable_operator] = "overridable_operator",
  [sym_receiver] = "receiver",
  [sym_signature] = "signature",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_type_parameter_list] = "type_parameter_list",
  [sym_type_parameter_declaration] = "type_parameter_declaration",
  [sym_generic_parameters] = "generic_parameters",
  [sym_generic_parameter] = "generic_parameter",
  [sym_struct_declaration] = "struct_declaration",
  [sym__struct_body] = "_struct_body",
  [sym_struct_field_scope] = "struct_field_scope",
  [sym_struct_field_declaration] = "struct_field_declaration",
  [sym__struct_field_definition] = "_struct_field_definition",
  [sym_embedded_definition] = "embedded_definition",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_backed_type] = "enum_backed_type",
  [sym__enum_body] = "_enum_body",
  [sym_enum_field_definition] = "enum_field_definition",
  [sym_interface_declaration] = "interface_declaration",
  [sym__interface_body] = "_interface_body",
  [sym_interface_method_definition] = "interface_method_definition",
  [sym__expression] = "_expression",
  [sym__expression_without_blocks] = "_expression_without_blocks",
  [sym__expression_with_blocks] = "_expression_with_blocks",
  [sym_strictly_expression_list] = "expression_list",
  [sym_inc_expression] = "inc_expression",
  [sym_dec_expression] = "dec_expression",
  [sym_or_block_expression] = "or_block_expression",
  [sym_option_propagation_expression] = "option_propagation_expression",
  [sym_result_propagation_expression] = "result_propagation_expression",
  [sym_anon_struct_value_expression] = "anon_struct_value_expression",
  [sym_go_expression] = "go_expression",
  [sym_spawn_expression] = "spawn_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_call_expression] = "call_expression",
  [sym_type_parameters] = "type_parameters",
  [sym_argument_list] = "argument_list",
  [sym_short_lambda] = "short_lambda",
  [sym_argument] = "argument",
  [sym_special_argument_list] = "special_argument_list",
  [sym_type_initializer] = "type_initializer",
  [sym_type_initializer_body] = "type_initializer_body",
  [sym_element_list] = "element_list",
  [sym_short_element_list] = "short_element_list",
  [sym_field_name] = "field_name",
  [sym_keyed_element] = "keyed_element",
  [sym_function_literal] = "function_literal",
  [sym_capture_list] = "capture_list",
  [sym_capture] = "capture",
  [sym_reference_expression] = "reference_expression",
  [sym_type_reference_expression] = "type_reference_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_receive_expression] = "receive_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_as_type_cast_expression] = "as_type_cast_expression",
  [sym_or_block] = "or_block",
  [sym__max_group] = "_max_group",
  [sym_literal] = "literal",
  [sym_spread_expression] = "spread_expression",
  [sym_map_init_expression] = "map_init_expression",
  [sym_map_keyed_element] = "map_keyed_element",
  [sym_array_creation] = "array_creation",
  [sym_fixed_array_creation] = "fixed_array_creation",
  [sym_selector_expression] = "selector_expression",
  [sym_compile_time_selector_expression] = "compile_time_selector_expression",
  [sym_index_expression] = "index_expression",
  [sym_slice_expression] = "slice_expression",
  [sym_if_expression] = "if_expression",
  [sym_else_branch] = "else_branch",
  [sym_compile_time_if_expression] = "compile_time_if_expression",
  [sym_is_expression] = "is_expression",
  [sym_in_expression] = "in_expression",
  [sym_enum_fetch] = "enum_fetch",
  [sym_match_expression] = "match_expression",
  [sym_match_arms] = "match_arms",
  [sym_match_arm] = "match_arm",
  [sym_match_expression_list] = "match_expression_list",
  [sym_match_arm_type] = "match_arm_type",
  [sym_match_else_arm_clause] = "match_else_arm_clause",
  [sym_select_expression] = "select_expression",
  [sym_select_arm] = "select_arm",
  [sym_select_arm_statement] = "select_arm_statement",
  [sym__select_arm_assignment_statement] = "_select_arm_assignment_statement",
  [sym_select_var_declaration] = "var_declaration",
  [sym_select_else_arn_clause] = "select_else_arn_clause",
  [sym_lock_expression] = "lock_expression",
  [sym_unsafe_expression] = "unsafe_expression",
  [sym_sql_expression] = "sql_expression",
  [sym_interpreted_string_literal] = "interpreted_string_literal",
  [sym_c_string_literal] = "c_string_literal",
  [sym_raw_string_literal] = "raw_string_literal",
  [sym_string_interpolation] = "string_interpolation",
  [sym_format_specifier] = "format_specifier",
  [sym_visibility_modifiers] = "visibility_modifiers",
  [sym_mutability_modifiers] = "mutability_modifiers",
  [sym_mutable_identifier] = "mutable_identifier",
  [sym_mutable_expression] = "mutable_expression",
  [sym_identifier_list] = "identifier_list",
  [sym_expression_list] = "expression_list",
  [sym_expression_without_blocks_list] = "expression_list",
  [sym_sum_type] = "sum_type",
  [sym_plain_type] = "plain_type",
  [sym__plain_type_without_special] = "_plain_type_without_special",
  [sym_anon_struct_type] = "anon_struct_type",
  [sym_multi_return_type] = "multi_return_type",
  [sym_result_type] = "result_type",
  [sym_option_type] = "option_type",
  [sym_qualified_type] = "qualified_type",
  [sym_fixed_array_type] = "fixed_array_type",
  [sym_array_type] = "array_type",
  [sym_pointer_type] = "pointer_type",
  [sym_wrong_pointer_type] = "wrong_pointer_type",
  [sym_map_type] = "map_type",
  [sym_channel_type] = "channel_type",
  [sym_shared_type] = "shared_type",
  [sym_thread_type] = "thread_type",
  [sym_atomic_type] = "atomic_type",
  [sym_generic_type] = "generic_type",
  [sym_function_type] = "function_type",
  [sym__statement] = "_statement",
  [sym_simple_statement] = "simple_statement",
  [sym_assert_statement] = "assert_statement",
  [sym_append_statement] = "append_statement",
  [sym_send_statement] = "send_statement",
  [sym_var_declaration] = "var_declaration",
  [sym_var_definition_list] = "var_definition_list",
  [sym_var_definition] = "var_definition",
  [sym_assignment_statement] = "assignment_statement",
  [sym_block] = "block",
  [sym_defer_statement] = "defer_statement",
  [sym_label_reference] = "label_reference",
  [sym_goto_statement] = "goto_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_return_statement] = "return_statement",
  [sym_label_definition] = "label_definition",
  [sym_labeled_statement] = "labeled_statement",
  [sym_compile_time_for_statement] = "compile_time_for_statement",
  [sym_for_statement] = "for_statement",
  [sym_is_clause] = "is_clause",
  [sym_range_clause] = "range_clause",
  [sym_for_clause] = "for_clause",
  [sym__definite_range] = "range",
  [sym_range] = "range",
  [sym_hash_statement] = "hash_statement",
  [sym_asm_statement] = "asm_statement",
  [sym__content_block] = "_content_block",
  [sym_attributes] = "attributes",
  [sym_attribute] = "attribute",
  [sym_attribute_expression] = "attribute_expression",
  [sym_if_attribute] = "if_attribute",
  [sym__plain_attribute] = "_plain_attribute",
  [sym_literal_attribute] = "literal_attribute",
  [sym_value_attribute] = "value_attribute",
  [sym_key_value_attribute] = "key_value_attribute",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_block_comment_repeat1] = "block_comment_repeat1",
  [aux_sym_import_list_repeat1] = "import_list_repeat1",
  [aux_sym_import_path_repeat1] = "import_path_repeat1",
  [aux_sym_selective_import_list_repeat1] = "selective_import_list_repeat1",
  [aux_sym_const_declaration_repeat1] = "const_declaration_repeat1",
  [aux_sym_global_var_declaration_repeat1] = "global_var_declaration_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_type_parameter_list_repeat1] = "type_parameter_list_repeat1",
  [aux_sym_generic_parameters_repeat1] = "generic_parameters_repeat1",
  [aux_sym__struct_body_repeat1] = "_struct_body_repeat1",
  [aux_sym__enum_body_repeat1] = "_enum_body_repeat1",
  [aux_sym__interface_body_repeat1] = "_interface_body_repeat1",
  [aux_sym_strictly_expression_list_repeat1] = "strictly_expression_list_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_short_lambda_repeat1] = "short_lambda_repeat1",
  [aux_sym_element_list_repeat1] = "element_list_repeat1",
  [aux_sym_short_element_list_repeat1] = "short_element_list_repeat1",
  [aux_sym_capture_list_repeat1] = "capture_list_repeat1",
  [aux_sym_map_init_expression_repeat1] = "map_init_expression_repeat1",
  [aux_sym__array_repeat1] = "_array_repeat1",
  [aux_sym_match_arms_repeat1] = "match_arms_repeat1",
  [aux_sym_match_expression_list_repeat1] = "match_expression_list_repeat1",
  [aux_sym_select_expression_repeat1] = "select_expression_repeat1",
  [aux_sym_interpreted_string_literal_repeat1] = "interpreted_string_literal_repeat1",
  [aux_sym_interpreted_string_literal_repeat2] = "interpreted_string_literal_repeat2",
  [aux_sym_raw_string_literal_repeat1] = "raw_string_literal_repeat1",
  [aux_sym_raw_string_literal_repeat2] = "raw_string_literal_repeat2",
  [aux_sym_string_interpolation_repeat1] = "string_interpolation_repeat1",
  [aux_sym_identifier_list_repeat1] = "identifier_list_repeat1",
  [aux_sym_expression_without_blocks_list_repeat1] = "expression_without_blocks_list_repeat1",
  [aux_sym_sum_type_repeat1] = "sum_type_repeat1",
  [aux_sym_var_definition_list_repeat1] = "var_definition_list_repeat1",
  [aux_sym_block_repeat1] = "block_repeat1",
  [aux_sym_attributes_repeat1] = "attributes_repeat1",
  [aux_sym_attribute_repeat1] = "attribute_repeat1",
  [alias_sym_element] = "element",
  [alias_sym_interpolation_closing] = "interpolation_closing",
  [alias_sym_interpolation_expression] = "interpolation_expression",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_CR] = anon_sym_CR,
  [anon_sym_CR_LF] = anon_sym_CR_LF,
  [anon_sym_POUND_BANG] = anon_sym_POUND_BANG,
  [aux_sym_shebang_token1] = aux_sym_shebang_token1,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [anon_sym_SLASH_STAR] = anon_sym_SLASH_STAR,
  [aux_sym_block_comment_token1] = aux_sym_block_comment_token1,
  [aux_sym_block_comment_token2] = aux_sym_block_comment_token2,
  [anon_sym_STAR_SLASH] = anon_sym_STAR_SLASH,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym___global] = anon_sym___global,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_fn] = anon_sym_fn,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_LT2] = anon_sym_LT,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_pub] = anon_sym_pub,
  [anon_sym_mut] = anon_sym_mut,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_go] = anon_sym_go,
  [anon_sym_spawn] = anon_sym_spawn,
  [anon_sym_json_DOTdecode] = anon_sym_json_DOTdecode,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_LBRACK2] = anon_sym_LBRACK,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_AMP_CARET] = anon_sym_AMP_CARET,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_or] = anon_sym_or,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_none] = sym_none,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_nil] = sym_nil,
  [anon_sym_QMARK_DOT] = anon_sym_QMARK_DOT,
  [anon_sym_DOLLAR_LPAREN] = anon_sym_DOLLAR_LPAREN,
  [anon_sym_POUND_LBRACK] = anon_sym_POUND_LBRACK,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_DOLLARif] = anon_sym_DOLLARif,
  [anon_sym_DOLLARelse] = anon_sym_DOLLARelse,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_BANGis] = anon_sym_BANGis,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_BANGin] = anon_sym_BANGin,
  [anon_sym_match] = anon_sym_match,
  [anon_sym_select] = anon_sym_select,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_AMP_CARET_EQ] = anon_sym_AMP_CARET_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_lock] = anon_sym_lock,
  [anon_sym_rlock] = anon_sym_rlock,
  [anon_sym_unsafe] = anon_sym_unsafe,
  [anon_sym_sql] = anon_sym_sql,
  [sym_int_literal] = sym_int_literal,
  [sym_float_literal] = sym_float_literal,
  [sym_rune_literal] = sym_rune_literal,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_interpreted_string_literal_token1] = aux_sym_interpreted_string_literal_token1,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_interpreted_string_literal_token2] = aux_sym_interpreted_string_literal_token2,
  [anon_sym_c_SQUOTE] = anon_sym_c_SQUOTE,
  [anon_sym_c_DQUOTE] = anon_sym_c_DQUOTE,
  [anon_sym_r_SQUOTE] = anon_sym_r_SQUOTE,
  [aux_sym_raw_string_literal_token1] = aux_sym_raw_string_literal_token1,
  [anon_sym_r_DQUOTE] = anon_sym_r_DQUOTE,
  [aux_sym_raw_string_literal_token2] = aux_sym_raw_string_literal_token2,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [aux_sym_format_specifier_token1] = aux_sym_format_specifier_token1,
  [aux_sym_format_specifier_token2] = aux_sym_format_specifier_token2,
  [anon_sym_0] = anon_sym_0,
  [sym_pseudo_compile_time_identifier] = sym_pseudo_compile_time_identifier,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_shared] = anon_sym_shared,
  [aux_sym_sum_type_token1] = aux_sym_sum_type_token1,
  [anon_sym_PIPE2] = anon_sym_PIPE,
  [anon_sym_map_LBRACK] = anon_sym_map_LBRACK,
  [anon_sym_chan] = anon_sym_chan,
  [anon_sym_thread] = anon_sym_thread,
  [anon_sym_atomic] = anon_sym_atomic,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_defer] = anon_sym_defer,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_DOLLARfor] = anon_sym_DOLLARfor,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_POUND] = anon_sym_POUND,
  [aux_sym_hash_statement_token1] = aux_sym_hash_statement_token1,
  [anon_sym_asm] = anon_sym_asm,
  [aux_sym__content_block_token1] = aux_sym__content_block_token1,
  [anon_sym_AT_LBRACK] = anon_sym_AT_LBRACK,
  [sym_source_file] = sym_source_file,
  [sym_shebang] = sym_shebang,
  [sym_line_comment] = sym_line_comment,
  [sym_block_comment] = sym_block_comment,
  [sym_module_clause] = sym_module_clause,
  [sym_import_list] = sym_import_list,
  [sym_import_declaration] = sym_import_declaration,
  [sym_import_spec] = sym_import_spec,
  [sym_import_path] = sym_import_path,
  [sym_import_name] = sym_import_name,
  [sym_import_alias] = sym_import_alias,
  [sym_selective_import_list] = sym_selective_import_list,
  [sym_const_declaration] = sym_const_declaration,
  [sym_const_definition] = sym_const_definition,
  [sym_global_var_declaration] = sym_global_var_declaration,
  [sym_global_var_definition] = sym_global_var_definition,
  [sym__global_var_value] = sym__global_var_value,
  [sym_type_declaration] = sym_type_declaration,
  [sym_function_declaration] = sym_function_declaration,
  [sym_static_method_declaration] = sym_static_method_declaration,
  [sym_static_receiver] = sym_static_receiver,
  [sym__function_name] = sym__function_name,
  [sym_overridable_operator] = sym_overridable_operator,
  [sym_receiver] = sym_receiver,
  [sym_signature] = sym_signature,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter_declaration] = sym_parameter_declaration,
  [sym_type_parameter_list] = sym_type_parameter_list,
  [sym_type_parameter_declaration] = sym_type_parameter_declaration,
  [sym_generic_parameters] = sym_generic_parameters,
  [sym_generic_parameter] = sym_generic_parameter,
  [sym_struct_declaration] = sym_struct_declaration,
  [sym__struct_body] = sym__struct_body,
  [sym_struct_field_scope] = sym_struct_field_scope,
  [sym_struct_field_declaration] = sym_struct_field_declaration,
  [sym__struct_field_definition] = sym__struct_field_definition,
  [sym_embedded_definition] = sym_embedded_definition,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_backed_type] = sym_enum_backed_type,
  [sym__enum_body] = sym__enum_body,
  [sym_enum_field_definition] = sym_enum_field_definition,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym__interface_body] = sym__interface_body,
  [sym_interface_method_definition] = sym_interface_method_definition,
  [sym__expression] = sym__expression,
  [sym__expression_without_blocks] = sym__expression_without_blocks,
  [sym__expression_with_blocks] = sym__expression_with_blocks,
  [sym_strictly_expression_list] = sym_expression_list,
  [sym_inc_expression] = sym_inc_expression,
  [sym_dec_expression] = sym_dec_expression,
  [sym_or_block_expression] = sym_or_block_expression,
  [sym_option_propagation_expression] = sym_option_propagation_expression,
  [sym_result_propagation_expression] = sym_result_propagation_expression,
  [sym_anon_struct_value_expression] = sym_anon_struct_value_expression,
  [sym_go_expression] = sym_go_expression,
  [sym_spawn_expression] = sym_spawn_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_type_parameters] = sym_type_parameters,
  [sym_argument_list] = sym_argument_list,
  [sym_short_lambda] = sym_short_lambda,
  [sym_argument] = sym_argument,
  [sym_special_argument_list] = sym_special_argument_list,
  [sym_type_initializer] = sym_type_initializer,
  [sym_type_initializer_body] = sym_type_initializer_body,
  [sym_element_list] = sym_element_list,
  [sym_short_element_list] = sym_short_element_list,
  [sym_field_name] = sym_field_name,
  [sym_keyed_element] = sym_keyed_element,
  [sym_function_literal] = sym_function_literal,
  [sym_capture_list] = sym_capture_list,
  [sym_capture] = sym_capture,
  [sym_reference_expression] = sym_reference_expression,
  [sym_type_reference_expression] = sym_type_reference_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_receive_expression] = sym_receive_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_as_type_cast_expression] = sym_as_type_cast_expression,
  [sym_or_block] = sym_or_block,
  [sym__max_group] = sym__max_group,
  [sym_literal] = sym_literal,
  [sym_spread_expression] = sym_spread_expression,
  [sym_map_init_expression] = sym_map_init_expression,
  [sym_map_keyed_element] = sym_map_keyed_element,
  [sym_array_creation] = sym_array_creation,
  [sym_fixed_array_creation] = sym_fixed_array_creation,
  [sym_selector_expression] = sym_selector_expression,
  [sym_compile_time_selector_expression] = sym_compile_time_selector_expression,
  [sym_index_expression] = sym_index_expression,
  [sym_slice_expression] = sym_slice_expression,
  [sym_if_expression] = sym_if_expression,
  [sym_else_branch] = sym_else_branch,
  [sym_compile_time_if_expression] = sym_compile_time_if_expression,
  [sym_is_expression] = sym_is_expression,
  [sym_in_expression] = sym_in_expression,
  [sym_enum_fetch] = sym_enum_fetch,
  [sym_match_expression] = sym_match_expression,
  [sym_match_arms] = sym_match_arms,
  [sym_match_arm] = sym_match_arm,
  [sym_match_expression_list] = sym_match_expression_list,
  [sym_match_arm_type] = sym_match_arm_type,
  [sym_match_else_arm_clause] = sym_match_else_arm_clause,
  [sym_select_expression] = sym_select_expression,
  [sym_select_arm] = sym_select_arm,
  [sym_select_arm_statement] = sym_select_arm_statement,
  [sym__select_arm_assignment_statement] = sym__select_arm_assignment_statement,
  [sym_select_var_declaration] = sym_var_declaration,
  [sym_select_else_arn_clause] = sym_select_else_arn_clause,
  [sym_lock_expression] = sym_lock_expression,
  [sym_unsafe_expression] = sym_unsafe_expression,
  [sym_sql_expression] = sym_sql_expression,
  [sym_interpreted_string_literal] = sym_interpreted_string_literal,
  [sym_c_string_literal] = sym_c_string_literal,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [sym_string_interpolation] = sym_string_interpolation,
  [sym_format_specifier] = sym_format_specifier,
  [sym_visibility_modifiers] = sym_visibility_modifiers,
  [sym_mutability_modifiers] = sym_mutability_modifiers,
  [sym_mutable_identifier] = sym_mutable_identifier,
  [sym_mutable_expression] = sym_mutable_expression,
  [sym_identifier_list] = sym_identifier_list,
  [sym_expression_list] = sym_expression_list,
  [sym_expression_without_blocks_list] = sym_expression_list,
  [sym_sum_type] = sym_sum_type,
  [sym_plain_type] = sym_plain_type,
  [sym__plain_type_without_special] = sym__plain_type_without_special,
  [sym_anon_struct_type] = sym_anon_struct_type,
  [sym_multi_return_type] = sym_multi_return_type,
  [sym_result_type] = sym_result_type,
  [sym_option_type] = sym_option_type,
  [sym_qualified_type] = sym_qualified_type,
  [sym_fixed_array_type] = sym_fixed_array_type,
  [sym_array_type] = sym_array_type,
  [sym_pointer_type] = sym_pointer_type,
  [sym_wrong_pointer_type] = sym_wrong_pointer_type,
  [sym_map_type] = sym_map_type,
  [sym_channel_type] = sym_channel_type,
  [sym_shared_type] = sym_shared_type,
  [sym_thread_type] = sym_thread_type,
  [sym_atomic_type] = sym_atomic_type,
  [sym_generic_type] = sym_generic_type,
  [sym_function_type] = sym_function_type,
  [sym__statement] = sym__statement,
  [sym_simple_statement] = sym_simple_statement,
  [sym_assert_statement] = sym_assert_statement,
  [sym_append_statement] = sym_append_statement,
  [sym_send_statement] = sym_send_statement,
  [sym_var_declaration] = sym_var_declaration,
  [sym_var_definition_list] = sym_var_definition_list,
  [sym_var_definition] = sym_var_definition,
  [sym_assignment_statement] = sym_assignment_statement,
  [sym_block] = sym_block,
  [sym_defer_statement] = sym_defer_statement,
  [sym_label_reference] = sym_label_reference,
  [sym_goto_statement] = sym_goto_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_label_definition] = sym_label_definition,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_compile_time_for_statement] = sym_compile_time_for_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_is_clause] = sym_is_clause,
  [sym_range_clause] = sym_range_clause,
  [sym_for_clause] = sym_for_clause,
  [sym__definite_range] = sym_range,
  [sym_range] = sym_range,
  [sym_hash_statement] = sym_hash_statement,
  [sym_asm_statement] = sym_asm_statement,
  [sym__content_block] = sym__content_block,
  [sym_attributes] = sym_attributes,
  [sym_attribute] = sym_attribute,
  [sym_attribute_expression] = sym_attribute_expression,
  [sym_if_attribute] = sym_if_attribute,
  [sym__plain_attribute] = sym__plain_attribute,
  [sym_literal_attribute] = sym_literal_attribute,
  [sym_value_attribute] = sym_value_attribute,
  [sym_key_value_attribute] = sym_key_value_attribute,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_block_comment_repeat1] = aux_sym_block_comment_repeat1,
  [aux_sym_import_list_repeat1] = aux_sym_import_list_repeat1,
  [aux_sym_import_path_repeat1] = aux_sym_import_path_repeat1,
  [aux_sym_selective_import_list_repeat1] = aux_sym_selective_import_list_repeat1,
  [aux_sym_const_declaration_repeat1] = aux_sym_const_declaration_repeat1,
  [aux_sym_global_var_declaration_repeat1] = aux_sym_global_var_declaration_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_type_parameter_list_repeat1] = aux_sym_type_parameter_list_repeat1,
  [aux_sym_generic_parameters_repeat1] = aux_sym_generic_parameters_repeat1,
  [aux_sym__struct_body_repeat1] = aux_sym__struct_body_repeat1,
  [aux_sym__enum_body_repeat1] = aux_sym__enum_body_repeat1,
  [aux_sym__interface_body_repeat1] = aux_sym__interface_body_repeat1,
  [aux_sym_strictly_expression_list_repeat1] = aux_sym_strictly_expression_list_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_short_lambda_repeat1] = aux_sym_short_lambda_repeat1,
  [aux_sym_element_list_repeat1] = aux_sym_element_list_repeat1,
  [aux_sym_short_element_list_repeat1] = aux_sym_short_element_list_repeat1,
  [aux_sym_capture_list_repeat1] = aux_sym_capture_list_repeat1,
  [aux_sym_map_init_expression_repeat1] = aux_sym_map_init_expression_repeat1,
  [aux_sym__array_repeat1] = aux_sym__array_repeat1,
  [aux_sym_match_arms_repeat1] = aux_sym_match_arms_repeat1,
  [aux_sym_match_expression_list_repeat1] = aux_sym_match_expression_list_repeat1,
  [aux_sym_select_expression_repeat1] = aux_sym_select_expression_repeat1,
  [aux_sym_interpreted_string_literal_repeat1] = aux_sym_interpreted_string_literal_repeat1,
  [aux_sym_interpreted_string_literal_repeat2] = aux_sym_interpreted_string_literal_repeat2,
  [aux_sym_raw_string_literal_repeat1] = aux_sym_raw_string_literal_repeat1,
  [aux_sym_raw_string_literal_repeat2] = aux_sym_raw_string_literal_repeat2,
  [aux_sym_string_interpolation_repeat1] = aux_sym_string_interpolation_repeat1,
  [aux_sym_identifier_list_repeat1] = aux_sym_identifier_list_repeat1,
  [aux_sym_expression_without_blocks_list_repeat1] = aux_sym_expression_without_blocks_list_repeat1,
  [aux_sym_sum_type_repeat1] = aux_sym_sum_type_repeat1,
  [aux_sym_var_definition_list_repeat1] = aux_sym_var_definition_list_repeat1,
  [aux_sym_block_repeat1] = aux_sym_block_repeat1,
  [aux_sym_attributes_repeat1] = aux_sym_attributes_repeat1,
  [aux_sym_attribute_repeat1] = aux_sym_attribute_repeat1,
  [alias_sym_element] = alias_sym_element,
  [alias_sym_interpolation_closing] = alias_sym_interpolation_closing,
  [alias_sym_interpolation_expression] = alias_sym_interpolation_expression,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CR_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND_BANG] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_shebang_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_STAR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_block_comment_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_comment_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_STAR_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pub] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mut] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_go] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_spawn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_json_DOTdecode] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_none] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLARif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLARelse] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANGis] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANGin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_select] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lock] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rlock] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsafe] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sql] = {
    .visible = true,
    .named = false,
  },
  [sym_int_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_float_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_rune_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_interpreted_string_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_interpreted_string_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_c_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_c_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_r_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_raw_string_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_r_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_raw_string_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_format_specifier_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_specifier_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = false,
  },
  [sym_pseudo_compile_time_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shared] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_sum_type_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_PIPE2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_map_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_chan] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thread] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLARfor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_hash_statement_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_asm] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__content_block_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_AT_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_shebang] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_module_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_import_list] = {
    .visible = true,
    .named = true,
  },
  [sym_import_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_import_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_import_path] = {
    .visible = true,
    .named = true,
  },
  [sym_import_name] = {
    .visible = true,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_selective_import_list] = {
    .visible = true,
    .named = true,
  },
  [sym_const_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_const_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_global_var_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_global_var_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__global_var_value] = {
    .visible = false,
    .named = true,
  },
  [sym_type_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_static_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_static_receiver] = {
    .visible = true,
    .named = true,
  },
  [sym__function_name] = {
    .visible = false,
    .named = true,
  },
  [sym_overridable_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_receiver] = {
    .visible = true,
    .named = true,
  },
  [sym_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__struct_body] = {
    .visible = false,
    .named = true,
  },
  [sym_struct_field_scope] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__struct_field_definition] = {
    .visible = false,
    .named = true,
  },
  [sym_embedded_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_backed_type] = {
    .visible = true,
    .named = true,
  },
  [sym__enum_body] = {
    .visible = false,
    .named = true,
  },
  [sym_enum_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__interface_body] = {
    .visible = false,
    .named = true,
  },
  [sym_interface_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__expression_without_blocks] = {
    .visible = false,
    .named = true,
  },
  [sym__expression_with_blocks] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_strictly_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_inc_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_dec_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_or_block_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_option_propagation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_result_propagation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anon_struct_value_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_go_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_spawn_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_short_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_special_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_type_initializer_body] = {
    .visible = true,
    .named = true,
  },
  [sym_element_list] = {
    .visible = true,
    .named = true,
  },
  [sym_short_element_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_name] = {
    .visible = true,
    .named = true,
  },
  [sym_keyed_element] = {
    .visible = true,
    .named = true,
  },
  [sym_function_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_capture_list] = {
    .visible = true,
    .named = true,
  },
  [sym_capture] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_reference_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_receive_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_as_type_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_or_block] = {
    .visible = true,
    .named = true,
  },
  [sym__max_group] = {
    .visible = false,
    .named = true,
  },
  [sym_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_spread_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_map_init_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_map_keyed_element] = {
    .visible = true,
    .named = true,
  },
  [sym_array_creation] = {
    .visible = true,
    .named = true,
  },
  [sym_fixed_array_creation] = {
    .visible = true,
    .named = true,
  },
  [sym_selector_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compile_time_selector_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_if_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_else_branch] = {
    .visible = true,
    .named = true,
  },
  [sym_compile_time_if_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_is_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_in_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_fetch] = {
    .visible = true,
    .named = true,
  },
  [sym_match_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_match_arms] = {
    .visible = true,
    .named = true,
  },
  [sym_match_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_match_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_match_arm_type] = {
    .visible = true,
    .named = true,
  },
  [sym_match_else_arm_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_select_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_select_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_select_arm_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__select_arm_assignment_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_select_var_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_select_else_arn_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_lock_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unsafe_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sql_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_interpreted_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_c_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_format_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_visibility_modifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_mutability_modifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_mutable_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_mutable_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier_list] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_without_blocks_list] = {
    .visible = true,
    .named = true,
  },
  [sym_sum_type] = {
    .visible = true,
    .named = true,
  },
  [sym_plain_type] = {
    .visible = true,
    .named = true,
  },
  [sym__plain_type_without_special] = {
    .visible = false,
    .named = true,
  },
  [sym_anon_struct_type] = {
    .visible = true,
    .named = true,
  },
  [sym_multi_return_type] = {
    .visible = true,
    .named = true,
  },
  [sym_result_type] = {
    .visible = true,
    .named = true,
  },
  [sym_option_type] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type] = {
    .visible = true,
    .named = true,
  },
  [sym_fixed_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_wrong_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_map_type] = {
    .visible = true,
    .named = true,
  },
  [sym_channel_type] = {
    .visible = true,
    .named = true,
  },
  [sym_shared_type] = {
    .visible = true,
    .named = true,
  },
  [sym_thread_type] = {
    .visible = true,
    .named = true,
  },
  [sym_atomic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_simple_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_append_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_send_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_var_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_var_definition_list] = {
    .visible = true,
    .named = true,
  },
  [sym_var_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_defer_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_label_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_label_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_compile_time_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_is_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_range_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__definite_range] = {
    .visible = true,
    .named = true,
  },
  [sym_range] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_asm_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__content_block] = {
    .visible = false,
    .named = true,
  },
  [sym_attributes] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_if_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym__plain_attribute] = {
    .visible = false,
    .named = true,
  },
  [sym_literal_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_value_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_key_value_attribute] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_comment_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_path_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_selective_import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_const_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_var_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__struct_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__interface_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_strictly_expression_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_short_lambda_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_element_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_short_element_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_capture_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_map_init_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_arms_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_expression_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_select_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpreted_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpreted_string_literal_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_raw_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_raw_string_literal_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_interpolation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_identifier_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expression_without_blocks_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sum_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_var_definition_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attributes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_element] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_interpolation_closing] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_interpolation_expression] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_arguments = 1,
  field_attributes = 2,
  field_block = 3,
  field_body = 4,
  field_capture_list = 5,
  field_channel = 6,
  field_condition = 7,
  field_default_value = 8,
  field_element = 9,
  field_element_list = 10,
  field_else_branch = 11,
  field_end = 12,
  field_expression = 13,
  field_expression_list = 14,
  field_field = 15,
  field_function = 16,
  field_generic_parameters = 17,
  field_guard = 18,
  field_index = 19,
  field_initializer = 20,
  field_key = 21,
  field_left = 22,
  field_locked_variables = 23,
  field_modifiers = 24,
  field_module = 25,
  field_mutability = 26,
  field_name = 27,
  field_operand = 28,
  field_operator = 29,
  field_parameters = 30,
  field_receiver = 31,
  field_result = 32,
  field_right = 33,
  field_selected_variables = 34,
  field_short_element_list = 35,
  field_signature = 36,
  field_size = 37,
  field_start = 38,
  field_static_receiver = 39,
  field_type = 40,
  field_type_parameters = 41,
  field_update = 42,
  field_value = 43,
  field_var_list = 44,
  field_variadic = 45,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_arguments] = "arguments",
  [field_attributes] = "attributes",
  [field_block] = "block",
  [field_body] = "body",
  [field_capture_list] = "capture_list",
  [field_channel] = "channel",
  [field_condition] = "condition",
  [field_default_value] = "default_value",
  [field_element] = "element",
  [field_element_list] = "element_list",
  [field_else_branch] = "else_branch",
  [field_end] = "end",
  [field_expression] = "expression",
  [field_expression_list] = "expression_list",
  [field_field] = "field",
  [field_function] = "function",
  [field_generic_parameters] = "generic_parameters",
  [field_guard] = "guard",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_left] = "left",
  [field_locked_variables] = "locked_variables",
  [field_modifiers] = "modifiers",
  [field_module] = "module",
  [field_mutability] = "mutability",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_receiver] = "receiver",
  [field_result] = "result",
  [field_right] = "right",
  [field_selected_variables] = "selected_variables",
  [field_short_element_list] = "short_element_list",
  [field_signature] = "signature",
  [field_size] = "size",
  [field_start] = "start",
  [field_static_receiver] = "static_receiver",
  [field_type] = "type",
  [field_type_parameters] = "type_parameters",
  [field_update] = "update",
  [field_value] = "value",
  [field_var_list] = "var_list",
  [field_variadic] = "variadic",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 2},
  [4] = {.index = 4, .length = 2},
  [5] = {.index = 6, .length = 1},
  [6] = {.index = 6, .length = 1},
  [7] = {.index = 7, .length = 1},
  [8] = {.index = 8, .length = 1},
  [9] = {.index = 9, .length = 2},
  [10] = {.index = 11, .length = 2},
  [11] = {.index = 13, .length = 1},
  [12] = {.index = 14, .length = 2},
  [13] = {.index = 16, .length = 1},
  [14] = {.index = 17, .length = 2},
  [15] = {.index = 19, .length = 2},
  [16] = {.index = 21, .length = 2},
  [17] = {.index = 23, .length = 4},
  [19] = {.index = 27, .length = 1},
  [20] = {.index = 28, .length = 1},
  [21] = {.index = 29, .length = 2},
  [22] = {.index = 31, .length = 2},
  [23] = {.index = 33, .length = 2},
  [26] = {.index = 35, .length = 2},
  [27] = {.index = 37, .length = 1},
  [29] = {.index = 38, .length = 2},
  [30] = {.index = 40, .length = 3},
  [31] = {.index = 43, .length = 1},
  [32] = {.index = 44, .length = 2},
  [33] = {.index = 46, .length = 2},
  [34] = {.index = 48, .length = 1},
  [35] = {.index = 49, .length = 3},
  [36] = {.index = 52, .length = 2},
  [37] = {.index = 54, .length = 2},
  [38] = {.index = 56, .length = 1},
  [39] = {.index = 57, .length = 2},
  [40] = {.index = 59, .length = 2},
  [41] = {.index = 61, .length = 1},
  [42] = {.index = 62, .length = 2},
  [43] = {.index = 64, .length = 2},
  [44] = {.index = 66, .length = 2},
  [45] = {.index = 68, .length = 1},
  [46] = {.index = 69, .length = 3},
  [47] = {.index = 72, .length = 3},
  [48] = {.index = 75, .length = 3},
  [49] = {.index = 78, .length = 3},
  [50] = {.index = 81, .length = 3},
  [51] = {.index = 84, .length = 1},
  [52] = {.index = 85, .length = 1},
  [53] = {.index = 86, .length = 2},
  [55] = {.index = 88, .length = 2},
  [56] = {.index = 90, .length = 1},
  [57] = {.index = 91, .length = 3},
  [58] = {.index = 94, .length = 1},
  [59] = {.index = 95, .length = 3},
  [60] = {.index = 98, .length = 1},
  [62] = {.index = 99, .length = 2},
  [63] = {.index = 101, .length = 5},
  [64] = {.index = 106, .length = 1},
  [65] = {.index = 107, .length = 1},
  [66] = {.index = 108, .length = 2},
  [67] = {.index = 110, .length = 2},
  [68] = {.index = 112, .length = 2},
  [69] = {.index = 114, .length = 1},
  [70] = {.index = 115, .length = 2},
  [71] = {.index = 117, .length = 1},
  [72] = {.index = 118, .length = 3},
  [73] = {.index = 121, .length = 1},
  [74] = {.index = 122, .length = 1},
  [75] = {.index = 123, .length = 3},
  [76] = {.index = 126, .length = 2},
  [77] = {.index = 128, .length = 3},
  [78] = {.index = 131, .length = 3},
  [79] = {.index = 134, .length = 2},
  [80] = {.index = 136, .length = 2},
  [81] = {.index = 138, .length = 3},
  [82] = {.index = 141, .length = 3},
  [83] = {.index = 144, .length = 4},
  [84] = {.index = 148, .length = 4},
  [85] = {.index = 152, .length = 4},
  [86] = {.index = 156, .length = 4},
  [87] = {.index = 160, .length = 3},
  [88] = {.index = 163, .length = 2},
  [89] = {.index = 165, .length = 2},
  [90] = {.index = 167, .length = 1},
  [91] = {.index = 168, .length = 3},
  [92] = {.index = 171, .length = 2},
  [94] = {.index = 173, .length = 2},
  [95] = {.index = 175, .length = 2},
  [96] = {.index = 177, .length = 2},
  [97] = {.index = 179, .length = 1},
  [98] = {.index = 180, .length = 3},
  [99] = {.index = 183, .length = 2},
  [100] = {.index = 185, .length = 3},
  [101] = {.index = 188, .length = 3},
  [102] = {.index = 191, .length = 3},
  [103] = {.index = 194, .length = 2},
  [104] = {.index = 196, .length = 4},
  [105] = {.index = 200, .length = 4},
  [106] = {.index = 204, .length = 4},
  [107] = {.index = 208, .length = 3},
  [108] = {.index = 211, .length = 3},
  [109] = {.index = 214, .length = 2},
  [110] = {.index = 216, .length = 4},
  [111] = {.index = 220, .length = 3},
  [112] = {.index = 223, .length = 4},
  [113] = {.index = 227, .length = 4},
  [114] = {.index = 231, .length = 5},
  [115] = {.index = 236, .length = 3},
  [116] = {.index = 239, .length = 3},
  [117] = {.index = 242, .length = 3},
  [118] = {.index = 245, .length = 4},
  [119] = {.index = 249, .length = 3},
  [120] = {.index = 252, .length = 3},
  [121] = {.index = 255, .length = 3},
  [122] = {.index = 258, .length = 3},
  [123] = {.index = 261, .length = 4},
  [124] = {.index = 265, .length = 4},
  [125] = {.index = 269, .length = 4},
  [126] = {.index = 273, .length = 4},
  [127] = {.index = 277, .length = 5},
  [128] = {.index = 282, .length = 5},
  [129] = {.index = 287, .length = 5},
  [130] = {.index = 292, .length = 4},
  [131] = {.index = 296, .length = 4},
  [132] = {.index = 300, .length = 4},
  [133] = {.index = 304, .length = 3},
  [134] = {.index = 307, .length = 5},
  [135] = {.index = 312, .length = 4},
  [136] = {.index = 316, .length = 3},
  [137] = {.index = 319, .length = 4},
  [138] = {.index = 323, .length = 4},
  [139] = {.index = 327, .length = 4},
  [140] = {.index = 331, .length = 5},
  [141] = {.index = 336, .length = 5},
  [142] = {.index = 341, .length = 5},
  [143] = {.index = 346, .length = 6},
  [144] = {.index = 352, .length = 4},
  [145] = {.index = 356, .length = 5},
  [146] = {.index = 361, .length = 5},
  [147] = {.index = 366, .length = 5},
  [148] = {.index = 371, .length = 5},
  [149] = {.index = 376, .length = 6},
  [150] = {.index = 382, .length = 5},
  [151] = {.index = 387, .length = 5},
  [152] = {.index = 392, .length = 6},
  [153] = {.index = 398, .length = 6},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_signature, 1},
  [1] =
    {field_parameters, 0},
  [2] =
    {field_operand, 1},
    {field_operator, 0},
  [4] =
    {field_arguments, 1},
    {field_function, 0},
  [6] =
    {field_name, 0},
  [7] =
    {field_body, 1},
  [8] =
    {field_expression_list, 1},
  [9] =
    {field_arguments, 1},
    {field_name, 0},
  [11] =
    {field_body, 1},
    {field_type, 0},
  [13] =
    {field_expression, 1},
  [14] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [16] =
    {field_type, 0},
  [17] =
    {field_name, 1},
    {field_signature, 2},
  [19] =
    {field_body, 2},
    {field_signature, 1},
  [21] =
    {field_parameters, 0},
    {field_result, 1},
  [23] =
    {field_attributes, 0, .inherited = true},
    {field_default_value, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [27] =
    {field_name, 1},
  [28] =
    {field_element, 2},
  [29] =
    {field_block, 2},
    {field_condition, 1},
  [31] =
    {field_block, 2},
    {field_guard, 1},
  [33] =
    {field_body, 2},
    {field_locked_variables, 1},
  [35] =
    {field_modifiers, 0},
    {field_name, 1},
  [37] =
    {field_body, 2},
  [38] =
    {field_field, 2},
    {field_operand, 0},
  [40] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [43] =
    {field_operator, 0},
  [44] =
    {field_channel, 0},
    {field_value, 2},
  [46] =
    {field_left, 0},
    {field_right, 2},
  [48] =
    {field_block, 1},
  [49] =
    {field_arguments, 2},
    {field_name, 0},
    {field_type_parameters, 1},
  [52] =
    {field_module, 0},
    {field_name, 2},
  [54] =
    {field_expression_list, 2},
    {field_var_list, 0},
  [56] =
    {field_attributes, 0},
  [57] =
    {field_key, 0},
    {field_value, 2},
  [59] =
    {field_name, 0},
    {field_value, 2},
  [61] =
    {field_value, 1},
  [62] =
    {field_name, 1},
    {field_type, 3},
  [64] =
    {field_type, 1},
    {field_variadic, 0},
  [66] =
    {field_name, 0},
    {field_type, 1},
  [68] =
    {field_type, 1},
  [69] =
    {field_body, 3},
    {field_name, 1},
    {field_signature, 2},
  [72] =
    {field_generic_parameters, 2},
    {field_name, 1},
    {field_signature, 3},
  [75] =
    {field_name, 2},
    {field_receiver, 1},
    {field_signature, 3},
  [78] =
    {field_body, 3},
    {field_generic_parameters, 1},
    {field_signature, 2},
  [81] =
    {field_body, 3},
    {field_capture_list, 1},
    {field_signature, 2},
  [84] =
    {field_element_list, 2},
  [85] =
    {field_short_element_list, 2},
  [86] =
    {field_generic_parameters, 2},
    {field_name, 1},
  [88] =
    {field_element, 3},
    {field_size, 1},
  [90] =
    {field_value, 2},
  [91] =
    {field_block, 3},
    {field_condition, 1},
    {field_condition, 2},
  [94] =
    {field_condition, 1},
  [95] =
    {field_end, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_start, 0, .inherited = true},
  [98] =
    {field_selected_variables, 1},
  [99] =
    {field_key, 1},
    {field_value, 3},
  [101] =
    {field_end, 2, .inherited = true},
    {field_left, 0},
    {field_operator, 2, .inherited = true},
    {field_right, 2},
    {field_start, 2, .inherited = true},
  [106] =
    {field_update, 2},
  [107] =
    {field_initializer, 0},
  [108] =
    {field_end, 1},
    {field_operator, 0},
  [110] =
    {field_index, 2},
    {field_operand, 0},
  [112] =
    {field_operator, 1},
    {field_start, 0},
  [114] =
    {field_operand, 0},
  [115] =
    {field_name, 2},
    {field_signature, 3},
  [117] =
    {field_name, 2},
  [118] =
    {field_left, 0},
    {field_left, 1},
    {field_right, 3},
  [121] =
    {field_element_list, 1},
  [122] =
    {field_short_element_list, 1},
  [123] =
    {field_attributes, 0},
    {field_name, 2},
    {field_signature, 3},
  [126] =
    {field_attributes, 0},
    {field_name, 2},
  [128] =
    {field_generic_parameters, 2},
    {field_name, 1},
    {field_type, 4},
  [131] =
    {field_name, 0},
    {field_type, 2},
    {field_variadic, 1},
  [134] =
    {field_name, 1},
    {field_type, 2},
  [136] =
    {field_type, 2},
    {field_variadic, 1},
  [138] =
    {field_mutability, 0},
    {field_name, 1},
    {field_type, 2},
  [141] =
    {field_name, 3},
    {field_signature, 4},
    {field_static_receiver, 1},
  [144] =
    {field_body, 4},
    {field_generic_parameters, 2},
    {field_name, 1},
    {field_signature, 3},
  [148] =
    {field_body, 4},
    {field_name, 2},
    {field_receiver, 1},
    {field_signature, 3},
  [152] =
    {field_generic_parameters, 3},
    {field_name, 2},
    {field_receiver, 1},
    {field_signature, 4},
  [156] =
    {field_body, 4},
    {field_capture_list, 1},
    {field_generic_parameters, 2},
    {field_signature, 3},
  [160] =
    {field_attributes, 2},
    {field_name, 0},
    {field_type, 1},
  [163] =
    {field_attributes, 1},
    {field_name, 0},
  [165] =
    {field_name, 0},
    {field_signature, 1},
  [167] =
    {field_else_branch, 1},
  [168] =
    {field_block, 2},
    {field_condition, 1},
    {field_else_branch, 4},
  [171] =
    {field_block, 1},
    {field_value, 0},
  [173] =
    {field_condition, 1},
    {field_update, 3},
  [175] =
    {field_initializer, 0},
    {field_update, 3},
  [177] =
    {field_condition, 2},
    {field_initializer, 0},
  [179] =
    {field_field, 1},
  [180] =
    {field_end, 2},
    {field_operator, 1},
    {field_start, 0},
  [183] =
    {field_name, 2},
    {field_type, 4},
  [185] =
    {field_body, 4},
    {field_name, 2},
    {field_signature, 3},
  [188] =
    {field_generic_parameters, 3},
    {field_name, 2},
    {field_signature, 4},
  [191] =
    {field_name, 3},
    {field_receiver, 2},
    {field_signature, 4},
  [194] =
    {field_generic_parameters, 3},
    {field_name, 2},
  [196] =
    {field_attributes, 0},
    {field_body, 4},
    {field_name, 2},
    {field_signature, 3},
  [200] =
    {field_attributes, 0},
    {field_generic_parameters, 3},
    {field_name, 2},
    {field_signature, 4},
  [204] =
    {field_attributes, 0},
    {field_name, 3},
    {field_receiver, 2},
    {field_signature, 4},
  [208] =
    {field_attributes, 0},
    {field_generic_parameters, 3},
    {field_name, 2},
  [211] =
    {field_attributes, 0},
    {field_name, 3},
    {field_signature, 4},
  [214] =
    {field_attributes, 0},
    {field_name, 3},
  [216] =
    {field_mutability, 0},
    {field_name, 1},
    {field_type, 3},
    {field_variadic, 2},
  [220] =
    {field_mutability, 1},
    {field_name, 2},
    {field_type, 3},
  [223] =
    {field_body, 5},
    {field_name, 3},
    {field_signature, 4},
    {field_static_receiver, 1},
  [227] =
    {field_generic_parameters, 4},
    {field_name, 3},
    {field_signature, 5},
    {field_static_receiver, 1},
  [231] =
    {field_body, 5},
    {field_generic_parameters, 3},
    {field_name, 2},
    {field_receiver, 1},
    {field_signature, 4},
  [236] =
    {field_default_value, 3},
    {field_name, 0},
    {field_type, 1},
  [239] =
    {field_attributes, 2},
    {field_name, 0},
    {field_signature, 1},
  [242] =
    {field_generic_parameters, 1},
    {field_name, 0},
    {field_signature, 2},
  [245] =
    {field_block, 3},
    {field_condition, 1},
    {field_condition, 2},
    {field_else_branch, 5},
  [249] =
    {field_end, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_start, 1, .inherited = true},
  [252] =
    {field_condition, 2},
    {field_initializer, 0},
    {field_update, 4},
  [255] =
    {field_generic_parameters, 3},
    {field_name, 2},
    {field_type, 5},
  [258] =
    {field_name, 4},
    {field_signature, 5},
    {field_static_receiver, 2},
  [261] =
    {field_body, 5},
    {field_generic_parameters, 3},
    {field_name, 2},
    {field_signature, 4},
  [265] =
    {field_body, 5},
    {field_name, 3},
    {field_receiver, 2},
    {field_signature, 4},
  [269] =
    {field_generic_parameters, 4},
    {field_name, 3},
    {field_receiver, 2},
    {field_signature, 5},
  [273] =
    {field_attributes, 0},
    {field_name, 4},
    {field_signature, 5},
    {field_static_receiver, 2},
  [277] =
    {field_attributes, 0},
    {field_body, 5},
    {field_generic_parameters, 3},
    {field_name, 2},
    {field_signature, 4},
  [282] =
    {field_attributes, 0},
    {field_body, 5},
    {field_name, 3},
    {field_receiver, 2},
    {field_signature, 4},
  [287] =
    {field_attributes, 0},
    {field_generic_parameters, 4},
    {field_name, 3},
    {field_receiver, 2},
    {field_signature, 5},
  [292] =
    {field_attributes, 0},
    {field_body, 5},
    {field_name, 3},
    {field_signature, 4},
  [296] =
    {field_attributes, 0},
    {field_generic_parameters, 4},
    {field_name, 3},
    {field_signature, 5},
  [300] =
    {field_attributes, 0},
    {field_name, 4},
    {field_receiver, 3},
    {field_signature, 5},
  [304] =
    {field_attributes, 0},
    {field_generic_parameters, 4},
    {field_name, 3},
  [307] =
    {field_body, 6},
    {field_generic_parameters, 4},
    {field_name, 3},
    {field_signature, 5},
    {field_static_receiver, 1},
  [312] =
    {field_attributes, 4},
    {field_default_value, 3},
    {field_name, 0},
    {field_type, 1},
  [316] =
    {field_attributes, 3},
    {field_name, 0},
    {field_value, 2},
  [319] =
    {field_attributes, 3},
    {field_generic_parameters, 1},
    {field_name, 0},
    {field_signature, 2},
  [323] =
    {field_body, 6},
    {field_name, 4},
    {field_signature, 5},
    {field_static_receiver, 2},
  [327] =
    {field_generic_parameters, 5},
    {field_name, 4},
    {field_signature, 6},
    {field_static_receiver, 2},
  [331] =
    {field_body, 6},
    {field_generic_parameters, 4},
    {field_name, 3},
    {field_receiver, 2},
    {field_signature, 5},
  [336] =
    {field_attributes, 0},
    {field_body, 6},
    {field_name, 4},
    {field_signature, 5},
    {field_static_receiver, 2},
  [341] =
    {field_attributes, 0},
    {field_generic_parameters, 5},
    {field_name, 4},
    {field_signature, 6},
    {field_static_receiver, 2},
  [346] =
    {field_attributes, 0},
    {field_body, 6},
    {field_generic_parameters, 4},
    {field_name, 3},
    {field_receiver, 2},
    {field_signature, 5},
  [352] =
    {field_attributes, 0},
    {field_name, 5},
    {field_signature, 6},
    {field_static_receiver, 3},
  [356] =
    {field_attributes, 0},
    {field_body, 6},
    {field_generic_parameters, 4},
    {field_name, 3},
    {field_signature, 5},
  [361] =
    {field_attributes, 0},
    {field_body, 6},
    {field_name, 4},
    {field_receiver, 3},
    {field_signature, 5},
  [366] =
    {field_attributes, 0},
    {field_generic_parameters, 5},
    {field_name, 4},
    {field_receiver, 3},
    {field_signature, 6},
  [371] =
    {field_body, 7},
    {field_generic_parameters, 5},
    {field_name, 4},
    {field_signature, 6},
    {field_static_receiver, 2},
  [376] =
    {field_attributes, 0},
    {field_body, 7},
    {field_generic_parameters, 5},
    {field_name, 4},
    {field_signature, 6},
    {field_static_receiver, 2},
  [382] =
    {field_attributes, 0},
    {field_body, 7},
    {field_name, 5},
    {field_signature, 6},
    {field_static_receiver, 3},
  [387] =
    {field_attributes, 0},
    {field_generic_parameters, 6},
    {field_name, 5},
    {field_signature, 7},
    {field_static_receiver, 3},
  [392] =
    {field_attributes, 0},
    {field_body, 7},
    {field_generic_parameters, 5},
    {field_name, 4},
    {field_receiver, 3},
    {field_signature, 6},
  [398] =
    {field_attributes, 0},
    {field_body, 8},
    {field_generic_parameters, 6},
    {field_name, 5},
    {field_signature, 7},
    {field_static_receiver, 3},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [5] = {
    [0] = sym_reference_expression,
  },
  [18] = {
    [0] = alias_sym_element,
  },
  [24] = {
    [1] = alias_sym_interpolation_closing,
  },
  [25] = {
    [0] = alias_sym_interpolation_expression,
  },
  [28] = {
    [0] = sym_mutability_modifiers,
  },
  [54] = {
    [1] = sym_plain_type,
  },
  [61] = {
    [2] = alias_sym_interpolation_closing,
  },
  [79] = {
    [2] = sym_plain_type,
  },
  [93] = {
    [1] = alias_sym_interpolation_expression,
    [3] = alias_sym_interpolation_closing,
  },
  [111] = {
    [3] = sym_plain_type,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__expression, 3,
    sym__expression,
    alias_sym_element,
    alias_sym_interpolation_expression,
  sym__plain_type_without_special, 2,
    sym__plain_type_without_special,
    sym_plain_type,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 13,
  [15] = 15,
  [16] = 15,
  [17] = 15,
  [18] = 15,
  [19] = 15,
  [20] = 15,
  [21] = 15,
  [22] = 15,
  [23] = 15,
  [24] = 15,
  [25] = 15,
  [26] = 15,
  [27] = 15,
  [28] = 15,
  [29] = 15,
  [30] = 15,
  [31] = 15,
  [32] = 15,
  [33] = 15,
  [34] = 15,
  [35] = 15,
  [36] = 15,
  [37] = 15,
  [38] = 15,
  [39] = 15,
  [40] = 15,
  [41] = 15,
  [42] = 42,
  [43] = 43,
  [44] = 42,
  [45] = 43,
  [46] = 43,
  [47] = 42,
  [48] = 43,
  [49] = 43,
  [50] = 43,
  [51] = 42,
  [52] = 42,
  [53] = 43,
  [54] = 43,
  [55] = 43,
  [56] = 43,
  [57] = 42,
  [58] = 42,
  [59] = 42,
  [60] = 42,
  [61] = 43,
  [62] = 43,
  [63] = 42,
  [64] = 42,
  [65] = 42,
  [66] = 42,
  [67] = 42,
  [68] = 42,
  [69] = 43,
  [70] = 43,
  [71] = 42,
  [72] = 43,
  [73] = 42,
  [74] = 42,
  [75] = 43,
  [76] = 42,
  [77] = 42,
  [78] = 43,
  [79] = 43,
  [80] = 42,
  [81] = 81,
  [82] = 43,
  [83] = 42,
  [84] = 43,
  [85] = 43,
  [86] = 42,
  [87] = 43,
  [88] = 43,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 89,
  [96] = 96,
  [97] = 96,
  [98] = 96,
  [99] = 92,
  [100] = 96,
  [101] = 93,
  [102] = 96,
  [103] = 96,
  [104] = 90,
  [105] = 96,
  [106] = 96,
  [107] = 91,
  [108] = 96,
  [109] = 96,
  [110] = 96,
  [111] = 94,
  [112] = 96,
  [113] = 96,
  [114] = 114,
  [115] = 114,
  [116] = 114,
  [117] = 114,
  [118] = 114,
  [119] = 114,
  [120] = 114,
  [121] = 121,
  [122] = 114,
  [123] = 114,
  [124] = 114,
  [125] = 114,
  [126] = 121,
  [127] = 114,
  [128] = 114,
  [129] = 114,
  [130] = 114,
  [131] = 114,
  [132] = 114,
  [133] = 114,
  [134] = 114,
  [135] = 114,
  [136] = 114,
  [137] = 114,
  [138] = 114,
  [139] = 139,
  [140] = 139,
  [141] = 141,
  [142] = 141,
  [143] = 141,
  [144] = 144,
  [145] = 139,
  [146] = 144,
  [147] = 139,
  [148] = 139,
  [149] = 141,
  [150] = 141,
  [151] = 141,
  [152] = 144,
  [153] = 139,
  [154] = 141,
  [155] = 144,
  [156] = 144,
  [157] = 144,
  [158] = 141,
  [159] = 141,
  [160] = 141,
  [161] = 139,
  [162] = 144,
  [163] = 139,
  [164] = 144,
  [165] = 144,
  [166] = 139,
  [167] = 144,
  [168] = 144,
  [169] = 139,
  [170] = 141,
  [171] = 139,
  [172] = 139,
  [173] = 144,
  [174] = 141,
  [175] = 141,
  [176] = 139,
  [177] = 144,
  [178] = 178,
  [179] = 178,
  [180] = 178,
  [181] = 178,
  [182] = 178,
  [183] = 183,
  [184] = 178,
  [185] = 178,
  [186] = 178,
  [187] = 178,
  [188] = 178,
  [189] = 178,
  [190] = 178,
  [191] = 191,
  [192] = 192,
  [193] = 191,
  [194] = 191,
  [195] = 192,
  [196] = 192,
  [197] = 191,
  [198] = 191,
  [199] = 191,
  [200] = 192,
  [201] = 191,
  [202] = 191,
  [203] = 192,
  [204] = 192,
  [205] = 191,
  [206] = 192,
  [207] = 192,
  [208] = 192,
  [209] = 192,
  [210] = 191,
  [211] = 192,
  [212] = 191,
  [213] = 192,
  [214] = 191,
  [215] = 192,
  [216] = 191,
  [217] = 94,
  [218] = 218,
  [219] = 218,
  [220] = 220,
  [221] = 218,
  [222] = 222,
  [223] = 90,
  [224] = 218,
  [225] = 218,
  [226] = 218,
  [227] = 92,
  [228] = 218,
  [229] = 229,
  [230] = 91,
  [231] = 218,
  [232] = 218,
  [233] = 218,
  [234] = 218,
  [235] = 235,
  [236] = 93,
  [237] = 237,
  [238] = 218,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 260,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 264,
  [268] = 263,
  [269] = 260,
  [270] = 264,
  [271] = 271,
  [272] = 266,
  [273] = 266,
  [274] = 266,
  [275] = 264,
  [276] = 263,
  [277] = 260,
  [278] = 264,
  [279] = 264,
  [280] = 266,
  [281] = 271,
  [282] = 263,
  [283] = 264,
  [284] = 263,
  [285] = 260,
  [286] = 266,
  [287] = 265,
  [288] = 288,
  [289] = 260,
  [290] = 290,
  [291] = 291,
  [292] = 264,
  [293] = 266,
  [294] = 264,
  [295] = 263,
  [296] = 264,
  [297] = 264,
  [298] = 266,
  [299] = 266,
  [300] = 264,
  [301] = 266,
  [302] = 260,
  [303] = 264,
  [304] = 260,
  [305] = 260,
  [306] = 263,
  [307] = 263,
  [308] = 264,
  [309] = 264,
  [310] = 310,
  [311] = 264,
  [312] = 288,
  [313] = 313,
  [314] = 260,
  [315] = 263,
  [316] = 266,
  [317] = 264,
  [318] = 260,
  [319] = 266,
  [320] = 264,
  [321] = 264,
  [322] = 263,
  [323] = 260,
  [324] = 263,
  [325] = 264,
  [326] = 263,
  [327] = 264,
  [328] = 260,
  [329] = 263,
  [330] = 264,
  [331] = 266,
  [332] = 264,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 337,
  [340] = 335,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 335,
  [346] = 346,
  [347] = 337,
  [348] = 348,
  [349] = 344,
  [350] = 338,
  [351] = 351,
  [352] = 335,
  [353] = 344,
  [354] = 338,
  [355] = 337,
  [356] = 344,
  [357] = 357,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 335,
  [362] = 338,
  [363] = 337,
  [364] = 338,
  [365] = 337,
  [366] = 335,
  [367] = 367,
  [368] = 335,
  [369] = 338,
  [370] = 370,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 343,
  [376] = 337,
  [377] = 337,
  [378] = 338,
  [379] = 379,
  [380] = 380,
  [381] = 335,
  [382] = 335,
  [383] = 383,
  [384] = 335,
  [385] = 335,
  [386] = 386,
  [387] = 387,
  [388] = 357,
  [389] = 389,
  [390] = 390,
  [391] = 335,
  [392] = 392,
  [393] = 335,
  [394] = 335,
  [395] = 395,
  [396] = 343,
  [397] = 373,
  [398] = 337,
  [399] = 338,
  [400] = 337,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 335,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 338,
  [411] = 371,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 335,
  [416] = 344,
  [417] = 335,
  [418] = 343,
  [419] = 335,
  [420] = 335,
  [421] = 421,
  [422] = 335,
  [423] = 335,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 337,
  [433] = 338,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 335,
  [438] = 438,
  [439] = 344,
  [440] = 440,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 344,
  [445] = 313,
  [446] = 446,
  [447] = 447,
  [448] = 357,
  [449] = 343,
  [450] = 450,
  [451] = 430,
  [452] = 452,
  [453] = 453,
  [454] = 454,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 338,
  [459] = 346,
  [460] = 460,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 343,
  [465] = 344,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 343,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 343,
  [477] = 477,
  [478] = 343,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 344,
  [487] = 487,
  [488] = 371,
  [489] = 335,
  [490] = 490,
  [491] = 373,
  [492] = 462,
  [493] = 493,
  [494] = 494,
  [495] = 344,
  [496] = 338,
  [497] = 497,
  [498] = 343,
  [499] = 499,
  [500] = 337,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 344,
  [505] = 505,
  [506] = 403,
  [507] = 344,
  [508] = 508,
  [509] = 343,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 344,
  [517] = 517,
  [518] = 344,
  [519] = 519,
  [520] = 520,
  [521] = 371,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 373,
  [526] = 526,
  [527] = 343,
  [528] = 528,
  [529] = 529,
  [530] = 344,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 532,
  [535] = 346,
  [536] = 532,
  [537] = 537,
  [538] = 532,
  [539] = 532,
  [540] = 540,
  [541] = 541,
  [542] = 92,
  [543] = 532,
  [544] = 93,
  [545] = 532,
  [546] = 532,
  [547] = 94,
  [548] = 90,
  [549] = 532,
  [550] = 537,
  [551] = 532,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 532,
  [556] = 553,
  [557] = 553,
  [558] = 553,
  [559] = 559,
  [560] = 533,
  [561] = 553,
  [562] = 562,
  [563] = 553,
  [564] = 564,
  [565] = 537,
  [566] = 91,
  [567] = 532,
  [568] = 553,
  [569] = 553,
  [570] = 553,
  [571] = 553,
  [572] = 532,
  [573] = 533,
  [574] = 537,
  [575] = 553,
  [576] = 537,
  [577] = 537,
  [578] = 532,
  [579] = 532,
  [580] = 532,
  [581] = 532,
  [582] = 533,
  [583] = 553,
  [584] = 553,
  [585] = 346,
  [586] = 586,
  [587] = 587,
  [588] = 588,
  [589] = 586,
  [590] = 590,
  [591] = 346,
  [592] = 592,
  [593] = 587,
  [594] = 346,
  [595] = 595,
  [596] = 590,
  [597] = 597,
  [598] = 598,
  [599] = 599,
  [600] = 346,
  [601] = 601,
  [602] = 587,
  [603] = 603,
  [604] = 604,
  [605] = 599,
  [606] = 606,
  [607] = 590,
  [608] = 608,
  [609] = 609,
  [610] = 598,
  [611] = 595,
  [612] = 612,
  [613] = 590,
  [614] = 586,
  [615] = 603,
  [616] = 616,
  [617] = 604,
  [618] = 587,
  [619] = 619,
  [620] = 598,
  [621] = 619,
  [622] = 616,
  [623] = 590,
  [624] = 619,
  [625] = 601,
  [626] = 616,
  [627] = 590,
  [628] = 628,
  [629] = 601,
  [630] = 592,
  [631] = 597,
  [632] = 597,
  [633] = 587,
  [634] = 346,
  [635] = 346,
  [636] = 587,
  [637] = 592,
  [638] = 597,
  [639] = 587,
  [640] = 592,
  [641] = 601,
  [642] = 590,
  [643] = 616,
  [644] = 592,
  [645] = 587,
  [646] = 346,
  [647] = 597,
  [648] = 601,
  [649] = 590,
  [650] = 616,
  [651] = 595,
  [652] = 612,
  [653] = 616,
  [654] = 586,
  [655] = 590,
  [656] = 603,
  [657] = 592,
  [658] = 601,
  [659] = 604,
  [660] = 597,
  [661] = 597,
  [662] = 599,
  [663] = 663,
  [664] = 587,
  [665] = 609,
  [666] = 601,
  [667] = 592,
  [668] = 616,
  [669] = 587,
  [670] = 346,
  [671] = 590,
  [672] = 612,
  [673] = 606,
  [674] = 674,
  [675] = 608,
  [676] = 609,
  [677] = 598,
  [678] = 678,
  [679] = 616,
  [680] = 590,
  [681] = 606,
  [682] = 601,
  [683] = 597,
  [684] = 346,
  [685] = 608,
  [686] = 587,
  [687] = 687,
  [688] = 592,
  [689] = 609,
  [690] = 598,
  [691] = 606,
  [692] = 595,
  [693] = 599,
  [694] = 612,
  [695] = 604,
  [696] = 586,
  [697] = 603,
  [698] = 603,
  [699] = 608,
  [700] = 604,
  [701] = 599,
  [702] = 586,
  [703] = 609,
  [704] = 612,
  [705] = 598,
  [706] = 595,
  [707] = 606,
  [708] = 608,
  [709] = 609,
  [710] = 598,
  [711] = 606,
  [712] = 712,
  [713] = 608,
  [714] = 619,
  [715] = 616,
  [716] = 590,
  [717] = 601,
  [718] = 609,
  [719] = 597,
  [720] = 346,
  [721] = 598,
  [722] = 606,
  [723] = 608,
  [724] = 587,
  [725] = 592,
  [726] = 609,
  [727] = 598,
  [728] = 592,
  [729] = 606,
  [730] = 608,
  [731] = 616,
  [732] = 590,
  [733] = 733,
  [734] = 609,
  [735] = 601,
  [736] = 598,
  [737] = 587,
  [738] = 606,
  [739] = 597,
  [740] = 740,
  [741] = 608,
  [742] = 587,
  [743] = 592,
  [744] = 744,
  [745] = 609,
  [746] = 616,
  [747] = 599,
  [748] = 590,
  [749] = 606,
  [750] = 608,
  [751] = 595,
  [752] = 612,
  [753] = 601,
  [754] = 754,
  [755] = 597,
  [756] = 346,
  [757] = 757,
  [758] = 346,
  [759] = 587,
  [760] = 597,
  [761] = 592,
  [762] = 609,
  [763] = 598,
  [764] = 601,
  [765] = 606,
  [766] = 590,
  [767] = 608,
  [768] = 586,
  [769] = 603,
  [770] = 609,
  [771] = 598,
  [772] = 608,
  [773] = 595,
  [774] = 774,
  [775] = 604,
  [776] = 612,
  [777] = 604,
  [778] = 616,
  [779] = 603,
  [780] = 780,
  [781] = 687,
  [782] = 586,
  [783] = 612,
  [784] = 599,
  [785] = 604,
  [786] = 595,
  [787] = 599,
  [788] = 619,
  [789] = 789,
  [790] = 599,
  [791] = 774,
  [792] = 604,
  [793] = 603,
  [794] = 612,
  [795] = 616,
  [796] = 590,
  [797] = 601,
  [798] = 612,
  [799] = 595,
  [800] = 597,
  [801] = 346,
  [802] = 802,
  [803] = 587,
  [804] = 592,
  [805] = 603,
  [806] = 586,
  [807] = 612,
  [808] = 595,
  [809] = 595,
  [810] = 612,
  [811] = 586,
  [812] = 599,
  [813] = 619,
  [814] = 604,
  [815] = 603,
  [816] = 586,
  [817] = 612,
  [818] = 595,
  [819] = 628,
  [820] = 599,
  [821] = 588,
  [822] = 603,
  [823] = 674,
  [824] = 604,
  [825] = 599,
  [826] = 595,
  [827] = 612,
  [828] = 586,
  [829] = 595,
  [830] = 612,
  [831] = 586,
  [832] = 603,
  [833] = 604,
  [834] = 599,
  [835] = 603,
  [836] = 604,
  [837] = 599,
  [838] = 604,
  [839] = 595,
  [840] = 603,
  [841] = 612,
  [842] = 586,
  [843] = 603,
  [844] = 604,
  [845] = 599,
  [846] = 712,
  [847] = 733,
  [848] = 740,
  [849] = 616,
  [850] = 590,
  [851] = 601,
  [852] = 597,
  [853] = 346,
  [854] = 687,
  [855] = 595,
  [856] = 612,
  [857] = 586,
  [858] = 603,
  [859] = 587,
  [860] = 592,
  [861] = 604,
  [862] = 599,
  [863] = 595,
  [864] = 603,
  [865] = 586,
  [866] = 603,
  [867] = 604,
  [868] = 599,
  [869] = 619,
  [870] = 870,
  [871] = 595,
  [872] = 612,
  [873] = 586,
  [874] = 616,
  [875] = 586,
  [876] = 604,
  [877] = 592,
  [878] = 878,
  [879] = 599,
  [880] = 587,
  [881] = 780,
  [882] = 789,
  [883] = 346,
  [884] = 619,
  [885] = 595,
  [886] = 612,
  [887] = 597,
  [888] = 592,
  [889] = 587,
  [890] = 586,
  [891] = 590,
  [892] = 601,
  [893] = 590,
  [894] = 894,
  [895] = 346,
  [896] = 597,
  [897] = 601,
  [898] = 590,
  [899] = 616,
  [900] = 592,
  [901] = 616,
  [902] = 601,
  [903] = 599,
  [904] = 597,
  [905] = 587,
  [906] = 616,
  [907] = 590,
  [908] = 601,
  [909] = 597,
  [910] = 346,
  [911] = 587,
  [912] = 604,
  [913] = 603,
  [914] = 586,
  [915] = 612,
  [916] = 595,
  [917] = 346,
  [918] = 619,
  [919] = 592,
  [920] = 597,
  [921] = 601,
  [922] = 590,
  [923] = 346,
  [924] = 616,
  [925] = 592,
  [926] = 603,
  [927] = 604,
  [928] = 599,
  [929] = 597,
  [930] = 601,
  [931] = 616,
  [932] = 619,
  [933] = 587,
  [934] = 346,
  [935] = 587,
  [936] = 592,
  [937] = 590,
  [938] = 619,
  [939] = 789,
  [940] = 595,
  [941] = 619,
  [942] = 870,
  [943] = 789,
  [944] = 789,
  [945] = 603,
  [946] = 612,
  [947] = 789,
  [948] = 789,
  [949] = 789,
  [950] = 789,
  [951] = 608,
  [952] = 619,
  [953] = 616,
  [954] = 590,
  [955] = 789,
  [956] = 601,
  [957] = 597,
  [958] = 346,
  [959] = 789,
  [960] = 586,
  [961] = 586,
  [962] = 599,
  [963] = 604,
  [964] = 789,
  [965] = 789,
  [966] = 619,
  [967] = 612,
  [968] = 616,
  [969] = 587,
  [970] = 590,
  [971] = 601,
  [972] = 597,
  [973] = 595,
  [974] = 592,
  [975] = 603,
  [976] = 604,
  [977] = 599,
  [978] = 346,
  [979] = 587,
  [980] = 592,
  [981] = 606,
  [982] = 255,
  [983] = 254,
  [984] = 244,
  [985] = 248,
  [986] = 245,
  [987] = 249,
  [988] = 250,
  [989] = 247,
  [990] = 256,
  [991] = 253,
  [992] = 246,
  [993] = 242,
  [994] = 251,
  [995] = 258,
  [996] = 257,
  [997] = 252,
  [998] = 259,
  [999] = 261,
  [1000] = 271,
  [1001] = 271,
  [1002] = 288,
  [1003] = 291,
  [1004] = 288,
  [1005] = 429,
  [1006] = 313,
  [1007] = 421,
  [1008] = 342,
  [1009] = 446,
  [1010] = 358,
  [1011] = 360,
  [1012] = 408,
  [1013] = 407,
  [1014] = 405,
  [1015] = 404,
  [1016] = 390,
  [1017] = 389,
  [1018] = 471,
  [1019] = 523,
  [1020] = 474,
  [1021] = 370,
  [1022] = 481,
  [1023] = 351,
  [1024] = 359,
  [1025] = 341,
  [1026] = 333,
  [1027] = 483,
  [1028] = 290,
  [1029] = 290,
  [1030] = 348,
  [1031] = 357,
  [1032] = 520,
  [1033] = 508,
  [1034] = 334,
  [1035] = 505,
  [1036] = 443,
  [1037] = 412,
  [1038] = 313,
  [1039] = 436,
  [1040] = 426,
  [1041] = 403,
  [1042] = 336,
  [1043] = 383,
  [1044] = 380,
  [1045] = 401,
  [1046] = 379,
  [1047] = 453,
  [1048] = 454,
  [1049] = 409,
  [1050] = 463,
  [1051] = 424,
  [1052] = 455,
  [1053] = 427,
  [1054] = 466,
  [1055] = 431,
  [1056] = 434,
  [1057] = 435,
  [1058] = 467,
  [1059] = 442,
  [1060] = 367,
  [1061] = 395,
  [1062] = 456,
  [1063] = 457,
  [1064] = 468,
  [1065] = 461,
  [1066] = 460,
  [1067] = 450,
  [1068] = 386,
  [1069] = 490,
  [1070] = 469,
  [1071] = 470,
  [1072] = 473,
  [1073] = 475,
  [1074] = 479,
  [1075] = 480,
  [1076] = 477,
  [1077] = 482,
  [1078] = 485,
  [1079] = 512,
  [1080] = 387,
  [1081] = 513,
  [1082] = 357,
  [1083] = 499,
  [1084] = 514,
  [1085] = 515,
  [1086] = 517,
  [1087] = 519,
  [1088] = 528,
  [1089] = 428,
  [1090] = 425,
  [1091] = 529,
  [1092] = 414,
  [1093] = 413,
  [1094] = 531,
  [1095] = 441,
  [1096] = 438,
  [1097] = 484,
  [1098] = 403,
  [1099] = 511,
  [1100] = 526,
  [1101] = 524,
  [1102] = 510,
  [1103] = 522,
  [1104] = 503,
  [1105] = 497,
  [1106] = 494,
  [1107] = 502,
  [1108] = 501,
  [1109] = 447,
  [1110] = 493,
  [1111] = 452,
  [1112] = 1112,
  [1113] = 357,
  [1114] = 93,
  [1115] = 91,
  [1116] = 94,
  [1117] = 92,
  [1118] = 90,
  [1119] = 1119,
  [1120] = 248,
  [1121] = 246,
  [1122] = 252,
  [1123] = 1123,
  [1124] = 245,
  [1125] = 247,
  [1126] = 254,
  [1127] = 256,
  [1128] = 251,
  [1129] = 249,
  [1130] = 253,
  [1131] = 250,
  [1132] = 1132,
  [1133] = 1133,
  [1134] = 254,
  [1135] = 257,
  [1136] = 1136,
  [1137] = 251,
  [1138] = 245,
  [1139] = 258,
  [1140] = 1140,
  [1141] = 1141,
  [1142] = 246,
  [1143] = 253,
  [1144] = 247,
  [1145] = 256,
  [1146] = 90,
  [1147] = 92,
  [1148] = 291,
  [1149] = 94,
  [1150] = 271,
  [1151] = 271,
  [1152] = 93,
  [1153] = 288,
  [1154] = 288,
  [1155] = 259,
  [1156] = 91,
  [1157] = 261,
  [1158] = 515,
  [1159] = 514,
  [1160] = 523,
  [1161] = 508,
  [1162] = 334,
  [1163] = 505,
  [1164] = 443,
  [1165] = 436,
  [1166] = 426,
  [1167] = 336,
  [1168] = 383,
  [1169] = 380,
  [1170] = 455,
  [1171] = 395,
  [1172] = 379,
  [1173] = 367,
  [1174] = 403,
  [1175] = 483,
  [1176] = 386,
  [1177] = 387,
  [1178] = 475,
  [1179] = 477,
  [1180] = 438,
  [1181] = 447,
  [1182] = 452,
  [1183] = 494,
  [1184] = 497,
  [1185] = 503,
  [1186] = 522,
  [1187] = 524,
  [1188] = 526,
  [1189] = 484,
  [1190] = 441,
  [1191] = 413,
  [1192] = 414,
  [1193] = 425,
  [1194] = 428,
  [1195] = 499,
  [1196] = 529,
  [1197] = 482,
  [1198] = 480,
  [1199] = 479,
  [1200] = 460,
  [1201] = 457,
  [1202] = 456,
  [1203] = 357,
  [1204] = 435,
  [1205] = 434,
  [1206] = 431,
  [1207] = 313,
  [1208] = 427,
  [1209] = 403,
  [1210] = 342,
  [1211] = 424,
  [1212] = 461,
  [1213] = 401,
  [1214] = 429,
  [1215] = 442,
  [1216] = 360,
  [1217] = 357,
  [1218] = 450,
  [1219] = 358,
  [1220] = 348,
  [1221] = 493,
  [1222] = 469,
  [1223] = 341,
  [1224] = 470,
  [1225] = 351,
  [1226] = 473,
  [1227] = 370,
  [1228] = 389,
  [1229] = 390,
  [1230] = 404,
  [1231] = 405,
  [1232] = 407,
  [1233] = 408,
  [1234] = 501,
  [1235] = 502,
  [1236] = 510,
  [1237] = 511,
  [1238] = 453,
  [1239] = 454,
  [1240] = 463,
  [1241] = 466,
  [1242] = 467,
  [1243] = 468,
  [1244] = 490,
  [1245] = 409,
  [1246] = 412,
  [1247] = 313,
  [1248] = 520,
  [1249] = 531,
  [1250] = 481,
  [1251] = 474,
  [1252] = 471,
  [1253] = 528,
  [1254] = 519,
  [1255] = 517,
  [1256] = 446,
  [1257] = 421,
  [1258] = 485,
  [1259] = 513,
  [1260] = 512,
  [1261] = 359,
  [1262] = 333,
  [1263] = 409,
  [1264] = 1119,
  [1265] = 254,
  [1266] = 246,
  [1267] = 253,
  [1268] = 256,
  [1269] = 247,
  [1270] = 1132,
  [1271] = 245,
  [1272] = 251,
  [1273] = 252,
  [1274] = 1123,
  [1275] = 248,
  [1276] = 249,
  [1277] = 250,
  [1278] = 257,
  [1279] = 258,
  [1280] = 92,
  [1281] = 93,
  [1282] = 251,
  [1283] = 256,
  [1284] = 246,
  [1285] = 90,
  [1286] = 245,
  [1287] = 247,
  [1288] = 1136,
  [1289] = 1133,
  [1290] = 253,
  [1291] = 254,
  [1292] = 288,
  [1293] = 288,
  [1294] = 261,
  [1295] = 259,
  [1296] = 271,
  [1297] = 271,
  [1298] = 291,
  [1299] = 387,
  [1300] = 380,
  [1301] = 460,
  [1302] = 456,
  [1303] = 485,
  [1304] = 435,
  [1305] = 434,
  [1306] = 512,
  [1307] = 357,
  [1308] = 403,
  [1309] = 431,
  [1310] = 479,
  [1311] = 421,
  [1312] = 493,
  [1313] = 446,
  [1314] = 471,
  [1315] = 450,
  [1316] = 480,
  [1317] = 474,
  [1318] = 409,
  [1319] = 481,
  [1320] = 342,
  [1321] = 520,
  [1322] = 461,
  [1323] = 490,
  [1324] = 442,
  [1325] = 358,
  [1326] = 468,
  [1327] = 429,
  [1328] = 529,
  [1329] = 467,
  [1330] = 466,
  [1331] = 463,
  [1332] = 469,
  [1333] = 494,
  [1334] = 454,
  [1335] = 453,
  [1336] = 470,
  [1337] = 473,
  [1338] = 408,
  [1339] = 407,
  [1340] = 93,
  [1341] = 403,
  [1342] = 313,
  [1343] = 405,
  [1344] = 508,
  [1345] = 334,
  [1346] = 505,
  [1347] = 412,
  [1348] = 443,
  [1349] = 436,
  [1350] = 426,
  [1351] = 336,
  [1352] = 383,
  [1353] = 510,
  [1354] = 379,
  [1355] = 404,
  [1356] = 367,
  [1357] = 513,
  [1358] = 386,
  [1359] = 457,
  [1360] = 390,
  [1361] = 389,
  [1362] = 455,
  [1363] = 483,
  [1364] = 438,
  [1365] = 482,
  [1366] = 92,
  [1367] = 370,
  [1368] = 511,
  [1369] = 477,
  [1370] = 475,
  [1371] = 447,
  [1372] = 313,
  [1373] = 90,
  [1374] = 409,
  [1375] = 452,
  [1376] = 531,
  [1377] = 351,
  [1378] = 359,
  [1379] = 523,
  [1380] = 497,
  [1381] = 503,
  [1382] = 522,
  [1383] = 501,
  [1384] = 360,
  [1385] = 341,
  [1386] = 333,
  [1387] = 524,
  [1388] = 526,
  [1389] = 484,
  [1390] = 348,
  [1391] = 514,
  [1392] = 515,
  [1393] = 401,
  [1394] = 502,
  [1395] = 424,
  [1396] = 441,
  [1397] = 528,
  [1398] = 427,
  [1399] = 413,
  [1400] = 414,
  [1401] = 425,
  [1402] = 428,
  [1403] = 357,
  [1404] = 519,
  [1405] = 395,
  [1406] = 517,
  [1407] = 499,
  [1408] = 1408,
  [1409] = 250,
  [1410] = 256,
  [1411] = 248,
  [1412] = 254,
  [1413] = 251,
  [1414] = 249,
  [1415] = 246,
  [1416] = 253,
  [1417] = 247,
  [1418] = 245,
  [1419] = 252,
  [1420] = 1420,
  [1421] = 1421,
  [1422] = 1422,
  [1423] = 258,
  [1424] = 257,
  [1425] = 288,
  [1426] = 291,
  [1427] = 1427,
  [1428] = 403,
  [1429] = 271,
  [1430] = 261,
  [1431] = 288,
  [1432] = 259,
  [1433] = 271,
  [1434] = 1434,
  [1435] = 379,
  [1436] = 529,
  [1437] = 91,
  [1438] = 523,
  [1439] = 424,
  [1440] = 92,
  [1441] = 1441,
  [1442] = 427,
  [1443] = 93,
  [1444] = 431,
  [1445] = 91,
  [1446] = 434,
  [1447] = 454,
  [1448] = 435,
  [1449] = 90,
  [1450] = 456,
  [1451] = 457,
  [1452] = 460,
  [1453] = 342,
  [1454] = 479,
  [1455] = 480,
  [1456] = 482,
  [1457] = 461,
  [1458] = 453,
  [1459] = 358,
  [1460] = 469,
  [1461] = 470,
  [1462] = 94,
  [1463] = 463,
  [1464] = 473,
  [1465] = 341,
  [1466] = 485,
  [1467] = 409,
  [1468] = 360,
  [1469] = 494,
  [1470] = 351,
  [1471] = 370,
  [1472] = 428,
  [1473] = 499,
  [1474] = 425,
  [1475] = 421,
  [1476] = 403,
  [1477] = 1477,
  [1478] = 92,
  [1479] = 414,
  [1480] = 413,
  [1481] = 441,
  [1482] = 359,
  [1483] = 484,
  [1484] = 333,
  [1485] = 526,
  [1486] = 524,
  [1487] = 522,
  [1488] = 93,
  [1489] = 466,
  [1490] = 503,
  [1491] = 497,
  [1492] = 446,
  [1493] = 471,
  [1494] = 474,
  [1495] = 467,
  [1496] = 481,
  [1497] = 452,
  [1498] = 447,
  [1499] = 468,
  [1500] = 313,
  [1501] = 404,
  [1502] = 438,
  [1503] = 387,
  [1504] = 512,
  [1505] = 386,
  [1506] = 520,
  [1507] = 367,
  [1508] = 348,
  [1509] = 380,
  [1510] = 383,
  [1511] = 508,
  [1512] = 513,
  [1513] = 511,
  [1514] = 390,
  [1515] = 443,
  [1516] = 389,
  [1517] = 90,
  [1518] = 514,
  [1519] = 515,
  [1520] = 408,
  [1521] = 505,
  [1522] = 426,
  [1523] = 91,
  [1524] = 334,
  [1525] = 407,
  [1526] = 336,
  [1527] = 483,
  [1528] = 429,
  [1529] = 442,
  [1530] = 405,
  [1531] = 450,
  [1532] = 493,
  [1533] = 94,
  [1534] = 501,
  [1535] = 502,
  [1536] = 517,
  [1537] = 1441,
  [1538] = 477,
  [1539] = 475,
  [1540] = 357,
  [1541] = 510,
  [1542] = 436,
  [1543] = 490,
  [1544] = 412,
  [1545] = 519,
  [1546] = 395,
  [1547] = 531,
  [1548] = 401,
  [1549] = 528,
  [1550] = 455,
  [1551] = 357,
  [1552] = 250,
  [1553] = 248,
  [1554] = 94,
  [1555] = 249,
  [1556] = 1556,
  [1557] = 257,
  [1558] = 1556,
  [1559] = 258,
  [1560] = 288,
  [1561] = 261,
  [1562] = 251,
  [1563] = 291,
  [1564] = 421,
  [1565] = 463,
  [1566] = 454,
  [1567] = 251,
  [1568] = 453,
  [1569] = 254,
  [1570] = 271,
  [1571] = 245,
  [1572] = 288,
  [1573] = 259,
  [1574] = 1574,
  [1575] = 254,
  [1576] = 431,
  [1577] = 434,
  [1578] = 435,
  [1579] = 246,
  [1580] = 403,
  [1581] = 253,
  [1582] = 1408,
  [1583] = 256,
  [1584] = 247,
  [1585] = 271,
  [1586] = 246,
  [1587] = 253,
  [1588] = 256,
  [1589] = 247,
  [1590] = 245,
  [1591] = 414,
  [1592] = 522,
  [1593] = 508,
  [1594] = 505,
  [1595] = 360,
  [1596] = 443,
  [1597] = 436,
  [1598] = 426,
  [1599] = 336,
  [1600] = 383,
  [1601] = 380,
  [1602] = 379,
  [1603] = 367,
  [1604] = 1604,
  [1605] = 386,
  [1606] = 387,
  [1607] = 483,
  [1608] = 342,
  [1609] = 455,
  [1610] = 395,
  [1611] = 438,
  [1612] = 479,
  [1613] = 461,
  [1614] = 475,
  [1615] = 477,
  [1616] = 447,
  [1617] = 452,
  [1618] = 358,
  [1619] = 469,
  [1620] = 494,
  [1621] = 497,
  [1622] = 503,
  [1623] = 334,
  [1624] = 524,
  [1625] = 470,
  [1626] = 473,
  [1627] = 526,
  [1628] = 403,
  [1629] = 484,
  [1630] = 529,
  [1631] = 441,
  [1632] = 413,
  [1633] = 485,
  [1634] = 523,
  [1635] = 359,
  [1636] = 333,
  [1637] = 425,
  [1638] = 428,
  [1639] = 499,
  [1640] = 482,
  [1641] = 480,
  [1642] = 446,
  [1643] = 512,
  [1644] = 427,
  [1645] = 460,
  [1646] = 513,
  [1647] = 514,
  [1648] = 515,
  [1649] = 357,
  [1650] = 517,
  [1651] = 457,
  [1652] = 519,
  [1653] = 528,
  [1654] = 471,
  [1655] = 429,
  [1656] = 474,
  [1657] = 442,
  [1658] = 456,
  [1659] = 481,
  [1660] = 520,
  [1661] = 531,
  [1662] = 424,
  [1663] = 450,
  [1664] = 490,
  [1665] = 401,
  [1666] = 348,
  [1667] = 468,
  [1668] = 467,
  [1669] = 412,
  [1670] = 466,
  [1671] = 493,
  [1672] = 408,
  [1673] = 407,
  [1674] = 405,
  [1675] = 341,
  [1676] = 351,
  [1677] = 511,
  [1678] = 510,
  [1679] = 502,
  [1680] = 404,
  [1681] = 1681,
  [1682] = 390,
  [1683] = 389,
  [1684] = 370,
  [1685] = 501,
  [1686] = 1686,
  [1687] = 313,
  [1688] = 1688,
  [1689] = 409,
  [1690] = 91,
  [1691] = 409,
  [1692] = 1692,
  [1693] = 1693,
  [1694] = 90,
  [1695] = 93,
  [1696] = 92,
  [1697] = 94,
  [1698] = 313,
  [1699] = 291,
  [1700] = 93,
  [1701] = 333,
  [1702] = 1702,
  [1703] = 1703,
  [1704] = 1704,
  [1705] = 1705,
  [1706] = 92,
  [1707] = 1707,
  [1708] = 1708,
  [1709] = 403,
  [1710] = 90,
  [1711] = 359,
  [1712] = 512,
  [1713] = 91,
  [1714] = 395,
  [1715] = 1715,
  [1716] = 529,
  [1717] = 1717,
  [1718] = 358,
  [1719] = 429,
  [1720] = 485,
  [1721] = 442,
  [1722] = 450,
  [1723] = 475,
  [1724] = 477,
  [1725] = 473,
  [1726] = 493,
  [1727] = 501,
  [1728] = 502,
  [1729] = 342,
  [1730] = 291,
  [1731] = 461,
  [1732] = 510,
  [1733] = 455,
  [1734] = 1734,
  [1735] = 511,
  [1736] = 1736,
  [1737] = 1737,
  [1738] = 531,
  [1739] = 528,
  [1740] = 1740,
  [1741] = 519,
  [1742] = 469,
  [1743] = 470,
  [1744] = 513,
  [1745] = 517,
  [1746] = 412,
  [1747] = 514,
  [1748] = 515,
  [1749] = 1749,
  [1750] = 1750,
  [1751] = 1751,
  [1752] = 403,
  [1753] = 1753,
  [1754] = 1754,
  [1755] = 1755,
  [1756] = 1756,
  [1757] = 1757,
  [1758] = 1758,
  [1759] = 1759,
  [1760] = 1760,
  [1761] = 1761,
  [1762] = 1762,
  [1763] = 1763,
  [1764] = 1764,
  [1765] = 1765,
  [1766] = 1766,
  [1767] = 1767,
  [1768] = 1768,
  [1769] = 1769,
  [1770] = 1770,
  [1771] = 1771,
  [1772] = 1772,
  [1773] = 1773,
  [1774] = 359,
  [1775] = 333,
  [1776] = 1776,
  [1777] = 1777,
  [1778] = 1778,
  [1779] = 501,
  [1780] = 1780,
  [1781] = 1781,
  [1782] = 1782,
  [1783] = 1783,
  [1784] = 1784,
  [1785] = 1785,
  [1786] = 1786,
  [1787] = 1787,
  [1788] = 1788,
  [1789] = 1789,
  [1790] = 1790,
  [1791] = 1791,
  [1792] = 1792,
  [1793] = 1793,
  [1794] = 1794,
  [1795] = 1795,
  [1796] = 1796,
  [1797] = 1797,
  [1798] = 1798,
  [1799] = 1799,
  [1800] = 1800,
  [1801] = 395,
  [1802] = 455,
  [1803] = 1803,
  [1804] = 1804,
  [1805] = 1805,
  [1806] = 485,
  [1807] = 513,
  [1808] = 1808,
  [1809] = 358,
  [1810] = 1810,
  [1811] = 469,
  [1812] = 1812,
  [1813] = 1813,
  [1814] = 1814,
  [1815] = 1815,
  [1816] = 1816,
  [1817] = 1817,
  [1818] = 1818,
  [1819] = 511,
  [1820] = 1820,
  [1821] = 1821,
  [1822] = 1822,
  [1823] = 1823,
  [1824] = 91,
  [1825] = 1825,
  [1826] = 1826,
  [1827] = 1827,
  [1828] = 288,
  [1829] = 1829,
  [1830] = 470,
  [1831] = 1831,
  [1832] = 1832,
  [1833] = 473,
  [1834] = 475,
  [1835] = 1835,
  [1836] = 477,
  [1837] = 1837,
  [1838] = 91,
  [1839] = 412,
  [1840] = 1840,
  [1841] = 1841,
  [1842] = 342,
  [1843] = 1843,
  [1844] = 493,
  [1845] = 1845,
  [1846] = 1846,
  [1847] = 1847,
  [1848] = 531,
  [1849] = 1849,
  [1850] = 1850,
  [1851] = 450,
  [1852] = 271,
  [1853] = 494,
  [1854] = 1854,
  [1855] = 1855,
  [1856] = 461,
  [1857] = 1857,
  [1858] = 512,
  [1859] = 517,
  [1860] = 1860,
  [1861] = 529,
  [1862] = 502,
  [1863] = 1863,
  [1864] = 1864,
  [1865] = 1865,
  [1866] = 1866,
  [1867] = 1867,
  [1868] = 1868,
  [1869] = 1869,
  [1870] = 528,
  [1871] = 1871,
  [1872] = 1872,
  [1873] = 1873,
  [1874] = 1874,
  [1875] = 429,
  [1876] = 1876,
  [1877] = 1877,
  [1878] = 519,
  [1879] = 1879,
  [1880] = 1880,
  [1881] = 442,
  [1882] = 1882,
  [1883] = 510,
  [1884] = 1884,
  [1885] = 1885,
  [1886] = 1886,
  [1887] = 1887,
  [1888] = 1888,
  [1889] = 1889,
  [1890] = 1890,
  [1891] = 514,
  [1892] = 1892,
  [1893] = 1893,
  [1894] = 1894,
  [1895] = 1895,
  [1896] = 1896,
  [1897] = 1897,
  [1898] = 1898,
  [1899] = 94,
  [1900] = 1900,
  [1901] = 1901,
  [1902] = 1902,
  [1903] = 515,
  [1904] = 1904,
  [1905] = 1905,
  [1906] = 90,
  [1907] = 93,
  [1908] = 92,
  [1909] = 94,
  [1910] = 92,
  [1911] = 93,
  [1912] = 91,
  [1913] = 90,
  [1914] = 94,
  [1915] = 1915,
  [1916] = 1916,
  [1917] = 1917,
  [1918] = 94,
  [1919] = 94,
  [1920] = 1920,
  [1921] = 1921,
  [1922] = 1922,
  [1923] = 1923,
  [1924] = 1740,
  [1925] = 1717,
  [1926] = 1715,
  [1927] = 1737,
  [1928] = 1773,
  [1929] = 1777,
  [1930] = 1766,
  [1931] = 1790,
  [1932] = 1932,
  [1933] = 1796,
  [1934] = 1813,
  [1935] = 1782,
  [1936] = 288,
  [1937] = 1800,
  [1938] = 1900,
  [1939] = 1892,
  [1940] = 1876,
  [1941] = 494,
  [1942] = 1901,
  [1943] = 271,
  [1944] = 1820,
  [1945] = 1793,
  [1946] = 1810,
  [1947] = 1815,
  [1948] = 1792,
  [1949] = 1874,
  [1950] = 1804,
  [1951] = 1814,
  [1952] = 395,
  [1953] = 475,
  [1954] = 529,
  [1955] = 455,
  [1956] = 475,
  [1957] = 455,
  [1958] = 477,
  [1959] = 529,
  [1960] = 395,
  [1961] = 477,
  [1962] = 1962,
  [1963] = 1963,
  [1964] = 1963,
  [1965] = 246,
  [1966] = 254,
  [1967] = 249,
  [1968] = 253,
  [1969] = 256,
  [1970] = 248,
  [1971] = 250,
  [1972] = 254,
  [1973] = 251,
  [1974] = 245,
  [1975] = 253,
  [1976] = 1976,
  [1977] = 247,
  [1978] = 242,
  [1979] = 242,
  [1980] = 251,
  [1981] = 246,
  [1982] = 249,
  [1983] = 250,
  [1984] = 245,
  [1985] = 248,
  [1986] = 247,
  [1987] = 256,
  [1988] = 395,
  [1989] = 251,
  [1990] = 455,
  [1991] = 529,
  [1992] = 245,
  [1993] = 252,
  [1994] = 288,
  [1995] = 256,
  [1996] = 258,
  [1997] = 253,
  [1998] = 246,
  [1999] = 257,
  [2000] = 254,
  [2001] = 258,
  [2002] = 475,
  [2003] = 288,
  [2004] = 271,
  [2005] = 247,
  [2006] = 271,
  [2007] = 257,
  [2008] = 2008,
  [2009] = 477,
  [2010] = 252,
  [2011] = 1132,
  [2012] = 261,
  [2013] = 2013,
  [2014] = 261,
  [2015] = 259,
  [2016] = 259,
  [2017] = 291,
  [2018] = 2018,
  [2019] = 291,
  [2020] = 252,
  [2021] = 252,
  [2022] = 2022,
  [2023] = 252,
  [2024] = 457,
  [2025] = 447,
  [2026] = 414,
  [2027] = 474,
  [2028] = 483,
  [2029] = 522,
  [2030] = 412,
  [2031] = 421,
  [2032] = 511,
  [2033] = 510,
  [2034] = 520,
  [2035] = 357,
  [2036] = 502,
  [2037] = 501,
  [2038] = 336,
  [2039] = 426,
  [2040] = 473,
  [2041] = 493,
  [2042] = 494,
  [2043] = 446,
  [2044] = 499,
  [2045] = 450,
  [2046] = 471,
  [2047] = 490,
  [2048] = 523,
  [2049] = 436,
  [2050] = 357,
  [2051] = 442,
  [2052] = 429,
  [2053] = 313,
  [2054] = 474,
  [2055] = 463,
  [2056] = 454,
  [2057] = 453,
  [2058] = 481,
  [2059] = 520,
  [2060] = 512,
  [2061] = 513,
  [2062] = 485,
  [2063] = 514,
  [2064] = 421,
  [2065] = 408,
  [2066] = 407,
  [2067] = 405,
  [2068] = 404,
  [2069] = 446,
  [2070] = 524,
  [2071] = 515,
  [2072] = 390,
  [2073] = 389,
  [2074] = 517,
  [2075] = 519,
  [2076] = 409,
  [2077] = 526,
  [2078] = 528,
  [2079] = 497,
  [2080] = 341,
  [2081] = 531,
  [2082] = 471,
  [2083] = 348,
  [2084] = 470,
  [2085] = 490,
  [2086] = 359,
  [2087] = 333,
  [2088] = 468,
  [2089] = 443,
  [2090] = 469,
  [2091] = 358,
  [2092] = 467,
  [2093] = 461,
  [2094] = 401,
  [2095] = 466,
  [2096] = 463,
  [2097] = 2097,
  [2098] = 409,
  [2099] = 454,
  [2100] = 342,
  [2101] = 2101,
  [2102] = 431,
  [2103] = 434,
  [2104] = 435,
  [2105] = 453,
  [2106] = 456,
  [2107] = 505,
  [2108] = 460,
  [2109] = 494,
  [2110] = 429,
  [2111] = 442,
  [2112] = 334,
  [2113] = 427,
  [2114] = 479,
  [2115] = 480,
  [2116] = 408,
  [2117] = 482,
  [2118] = 407,
  [2119] = 405,
  [2120] = 404,
  [2121] = 450,
  [2122] = 508,
  [2123] = 493,
  [2124] = 428,
  [2125] = 425,
  [2126] = 501,
  [2127] = 502,
  [2128] = 510,
  [2129] = 441,
  [2130] = 511,
  [2131] = 484,
  [2132] = 412,
  [2133] = 531,
  [2134] = 390,
  [2135] = 389,
  [2136] = 528,
  [2137] = 519,
  [2138] = 517,
  [2139] = 515,
  [2140] = 452,
  [2141] = 503,
  [2142] = 370,
  [2143] = 438,
  [2144] = 357,
  [2145] = 424,
  [2146] = 351,
  [2147] = 514,
  [2148] = 341,
  [2149] = 348,
  [2150] = 367,
  [2151] = 513,
  [2152] = 512,
  [2153] = 403,
  [2154] = 401,
  [2155] = 333,
  [2156] = 359,
  [2157] = 443,
  [2158] = 424,
  [2159] = 505,
  [2160] = 485,
  [2161] = 481,
  [2162] = 427,
  [2163] = 403,
  [2164] = 508,
  [2165] = 431,
  [2166] = 484,
  [2167] = 473,
  [2168] = 523,
  [2169] = 403,
  [2170] = 360,
  [2171] = 403,
  [2172] = 470,
  [2173] = 403,
  [2174] = 360,
  [2175] = 469,
  [2176] = 367,
  [2177] = 313,
  [2178] = 435,
  [2179] = 456,
  [2180] = 334,
  [2181] = 351,
  [2182] = 457,
  [2183] = 460,
  [2184] = 479,
  [2185] = 480,
  [2186] = 370,
  [2187] = 441,
  [2188] = 409,
  [2189] = 313,
  [2190] = 358,
  [2191] = 357,
  [2192] = 461,
  [2193] = 452,
  [2194] = 526,
  [2195] = 524,
  [2196] = 383,
  [2197] = 522,
  [2198] = 503,
  [2199] = 2199,
  [2200] = 483,
  [2201] = 497,
  [2202] = 380,
  [2203] = 379,
  [2204] = 482,
  [2205] = 434,
  [2206] = 499,
  [2207] = 386,
  [2208] = 387,
  [2209] = 413,
  [2210] = 386,
  [2211] = 342,
  [2212] = 447,
  [2213] = 428,
  [2214] = 466,
  [2215] = 467,
  [2216] = 468,
  [2217] = 387,
  [2218] = 425,
  [2219] = 438,
  [2220] = 414,
  [2221] = 379,
  [2222] = 380,
  [2223] = 383,
  [2224] = 413,
  [2225] = 336,
  [2226] = 426,
  [2227] = 436,
  [2228] = 395,
  [2229] = 455,
  [2230] = 529,
  [2231] = 475,
  [2232] = 477,
  [2233] = 249,
  [2234] = 250,
  [2235] = 2235,
  [2236] = 248,
  [2237] = 2237,
  [2238] = 258,
  [2239] = 257,
  [2240] = 2240,
  [2241] = 261,
  [2242] = 288,
  [2243] = 2243,
  [2244] = 291,
  [2245] = 2245,
  [2246] = 2246,
  [2247] = 271,
  [2248] = 2248,
  [2249] = 2249,
  [2250] = 271,
  [2251] = 2251,
  [2252] = 271,
  [2253] = 288,
  [2254] = 2254,
  [2255] = 288,
  [2256] = 403,
  [2257] = 259,
  [2258] = 405,
  [2259] = 528,
  [2260] = 333,
  [2261] = 359,
  [2262] = 499,
  [2263] = 485,
  [2264] = 2264,
  [2265] = 523,
  [2266] = 428,
  [2267] = 425,
  [2268] = 414,
  [2269] = 413,
  [2270] = 473,
  [2271] = 441,
  [2272] = 470,
  [2273] = 484,
  [2274] = 526,
  [2275] = 524,
  [2276] = 421,
  [2277] = 522,
  [2278] = 503,
  [2279] = 497,
  [2280] = 480,
  [2281] = 469,
  [2282] = 452,
  [2283] = 447,
  [2284] = 358,
  [2285] = 438,
  [2286] = 479,
  [2287] = 387,
  [2288] = 386,
  [2289] = 461,
  [2290] = 477,
  [2291] = 460,
  [2292] = 367,
  [2293] = 379,
  [2294] = 380,
  [2295] = 383,
  [2296] = 336,
  [2297] = 426,
  [2298] = 436,
  [2299] = 443,
  [2300] = 342,
  [2301] = 505,
  [2302] = 334,
  [2303] = 508,
  [2304] = 475,
  [2305] = 457,
  [2306] = 395,
  [2307] = 456,
  [2308] = 455,
  [2309] = 529,
  [2310] = 435,
  [2311] = 434,
  [2312] = 431,
  [2313] = 427,
  [2314] = 245,
  [2315] = 424,
  [2316] = 401,
  [2317] = 512,
  [2318] = 513,
  [2319] = 254,
  [2320] = 2320,
  [2321] = 514,
  [2322] = 515,
  [2323] = 517,
  [2324] = 246,
  [2325] = 253,
  [2326] = 519,
  [2327] = 482,
  [2328] = 494,
  [2329] = 348,
  [2330] = 531,
  [2331] = 2331,
  [2332] = 341,
  [2333] = 360,
  [2334] = 256,
  [2335] = 351,
  [2336] = 370,
  [2337] = 412,
  [2338] = 389,
  [2339] = 247,
  [2340] = 390,
  [2341] = 404,
  [2342] = 407,
  [2343] = 2343,
  [2344] = 408,
  [2345] = 2345,
  [2346] = 511,
  [2347] = 510,
  [2348] = 502,
  [2349] = 251,
  [2350] = 501,
  [2351] = 453,
  [2352] = 454,
  [2353] = 463,
  [2354] = 466,
  [2355] = 467,
  [2356] = 468,
  [2357] = 490,
  [2358] = 446,
  [2359] = 471,
  [2360] = 357,
  [2361] = 493,
  [2362] = 450,
  [2363] = 520,
  [2364] = 403,
  [2365] = 442,
  [2366] = 429,
  [2367] = 483,
  [2368] = 481,
  [2369] = 474,
  [2370] = 253,
  [2371] = 1422,
  [2372] = 288,
  [2373] = 271,
  [2374] = 2374,
  [2375] = 249,
  [2376] = 1420,
  [2377] = 313,
  [2378] = 248,
  [2379] = 409,
  [2380] = 256,
  [2381] = 246,
  [2382] = 251,
  [2383] = 250,
  [2384] = 254,
  [2385] = 247,
  [2386] = 2386,
  [2387] = 245,
  [2388] = 2388,
  [2389] = 257,
  [2390] = 258,
  [2391] = 409,
  [2392] = 259,
  [2393] = 261,
  [2394] = 313,
  [2395] = 291,
  [2396] = 2396,
  [2397] = 387,
  [2398] = 359,
  [2399] = 434,
  [2400] = 431,
  [2401] = 427,
  [2402] = 348,
  [2403] = 424,
  [2404] = 341,
  [2405] = 531,
  [2406] = 360,
  [2407] = 401,
  [2408] = 2396,
  [2409] = 351,
  [2410] = 333,
  [2411] = 2396,
  [2412] = 460,
  [2413] = 480,
  [2414] = 457,
  [2415] = 2396,
  [2416] = 429,
  [2417] = 442,
  [2418] = 461,
  [2419] = 370,
  [2420] = 456,
  [2421] = 479,
  [2422] = 469,
  [2423] = 412,
  [2424] = 389,
  [2425] = 519,
  [2426] = 390,
  [2427] = 499,
  [2428] = 404,
  [2429] = 405,
  [2430] = 470,
  [2431] = 407,
  [2432] = 408,
  [2433] = 428,
  [2434] = 2396,
  [2435] = 450,
  [2436] = 425,
  [2437] = 414,
  [2438] = 413,
  [2439] = 2396,
  [2440] = 482,
  [2441] = 528,
  [2442] = 441,
  [2443] = 2396,
  [2444] = 508,
  [2445] = 493,
  [2446] = 484,
  [2447] = 403,
  [2448] = 421,
  [2449] = 526,
  [2450] = 524,
  [2451] = 446,
  [2452] = 2396,
  [2453] = 342,
  [2454] = 2396,
  [2455] = 515,
  [2456] = 336,
  [2457] = 522,
  [2458] = 512,
  [2459] = 473,
  [2460] = 2396,
  [2461] = 503,
  [2462] = 471,
  [2463] = 497,
  [2464] = 494,
  [2465] = 523,
  [2466] = 474,
  [2467] = 453,
  [2468] = 454,
  [2469] = 334,
  [2470] = 481,
  [2471] = 463,
  [2472] = 466,
  [2473] = 483,
  [2474] = 467,
  [2475] = 468,
  [2476] = 452,
  [2477] = 520,
  [2478] = 505,
  [2479] = 2396,
  [2480] = 443,
  [2481] = 447,
  [2482] = 436,
  [2483] = 513,
  [2484] = 501,
  [2485] = 502,
  [2486] = 2396,
  [2487] = 438,
  [2488] = 358,
  [2489] = 514,
  [2490] = 357,
  [2491] = 426,
  [2492] = 367,
  [2493] = 510,
  [2494] = 386,
  [2495] = 511,
  [2496] = 383,
  [2497] = 380,
  [2498] = 485,
  [2499] = 435,
  [2500] = 490,
  [2501] = 379,
  [2502] = 2396,
  [2503] = 517,
  [2504] = 246,
  [2505] = 251,
  [2506] = 254,
  [2507] = 245,
  [2508] = 247,
  [2509] = 256,
  [2510] = 253,
  [2511] = 245,
  [2512] = 246,
  [2513] = 249,
  [2514] = 251,
  [2515] = 1141,
  [2516] = 409,
  [2517] = 254,
  [2518] = 249,
  [2519] = 403,
  [2520] = 248,
  [2521] = 313,
  [2522] = 247,
  [2523] = 256,
  [2524] = 403,
  [2525] = 1112,
  [2526] = 250,
  [2527] = 1140,
  [2528] = 248,
  [2529] = 90,
  [2530] = 253,
  [2531] = 251,
  [2532] = 93,
  [2533] = 92,
  [2534] = 246,
  [2535] = 250,
  [2536] = 253,
  [2537] = 256,
  [2538] = 247,
  [2539] = 254,
  [2540] = 245,
  [2541] = 245,
  [2542] = 251,
  [2543] = 245,
  [2544] = 247,
  [2545] = 271,
  [2546] = 256,
  [2547] = 253,
  [2548] = 357,
  [2549] = 257,
  [2550] = 258,
  [2551] = 2551,
  [2552] = 246,
  [2553] = 257,
  [2554] = 254,
  [2555] = 256,
  [2556] = 258,
  [2557] = 254,
  [2558] = 1119,
  [2559] = 1132,
  [2560] = 253,
  [2561] = 409,
  [2562] = 251,
  [2563] = 246,
  [2564] = 313,
  [2565] = 1119,
  [2566] = 246,
  [2567] = 253,
  [2568] = 256,
  [2569] = 288,
  [2570] = 247,
  [2571] = 288,
  [2572] = 271,
  [2573] = 247,
  [2574] = 251,
  [2575] = 254,
  [2576] = 245,
  [2577] = 2577,
  [2578] = 2578,
  [2579] = 2579,
  [2580] = 252,
  [2581] = 2577,
  [2582] = 2582,
  [2583] = 2577,
  [2584] = 2582,
  [2585] = 259,
  [2586] = 2577,
  [2587] = 252,
  [2588] = 2582,
  [2589] = 291,
  [2590] = 2577,
  [2591] = 261,
  [2592] = 2582,
  [2593] = 2582,
  [2594] = 2577,
  [2595] = 2595,
  [2596] = 2596,
  [2597] = 2577,
  [2598] = 252,
  [2599] = 409,
  [2600] = 2577,
  [2601] = 259,
  [2602] = 2577,
  [2603] = 2582,
  [2604] = 2582,
  [2605] = 2582,
  [2606] = 313,
  [2607] = 2582,
  [2608] = 2577,
  [2609] = 291,
  [2610] = 2577,
  [2611] = 261,
  [2612] = 2577,
  [2613] = 2582,
  [2614] = 2577,
  [2615] = 2615,
  [2616] = 2582,
  [2617] = 403,
  [2618] = 403,
  [2619] = 2582,
  [2620] = 1132,
  [2621] = 389,
  [2622] = 408,
  [2623] = 447,
  [2624] = 438,
  [2625] = 387,
  [2626] = 386,
  [2627] = 367,
  [2628] = 379,
  [2629] = 380,
  [2630] = 383,
  [2631] = 336,
  [2632] = 426,
  [2633] = 436,
  [2634] = 443,
  [2635] = 505,
  [2636] = 334,
  [2637] = 508,
  [2638] = 313,
  [2639] = 2639,
  [2640] = 2640,
  [2641] = 471,
  [2642] = 481,
  [2643] = 2643,
  [2644] = 2644,
  [2645] = 2639,
  [2646] = 2640,
  [2647] = 2640,
  [2648] = 468,
  [2649] = 467,
  [2650] = 466,
  [2651] = 370,
  [2652] = 2640,
  [2653] = 351,
  [2654] = 360,
  [2655] = 2655,
  [2656] = 2643,
  [2657] = 409,
  [2658] = 424,
  [2659] = 427,
  [2660] = 2660,
  [2661] = 499,
  [2662] = 414,
  [2663] = 413,
  [2664] = 526,
  [2665] = 524,
  [2666] = 522,
  [2667] = 503,
  [2668] = 497,
  [2669] = 497,
  [2670] = 2639,
  [2671] = 503,
  [2672] = 387,
  [2673] = 386,
  [2674] = 522,
  [2675] = 524,
  [2676] = 526,
  [2677] = 379,
  [2678] = 380,
  [2679] = 383,
  [2680] = 336,
  [2681] = 426,
  [2682] = 436,
  [2683] = 484,
  [2684] = 334,
  [2685] = 508,
  [2686] = 441,
  [2687] = 2687,
  [2688] = 2640,
  [2689] = 2644,
  [2690] = 413,
  [2691] = 414,
  [2692] = 425,
  [2693] = 523,
  [2694] = 313,
  [2695] = 428,
  [2696] = 499,
  [2697] = 482,
  [2698] = 2643,
  [2699] = 480,
  [2700] = 2640,
  [2701] = 2644,
  [2702] = 479,
  [2703] = 2644,
  [2704] = 2640,
  [2705] = 460,
  [2706] = 457,
  [2707] = 456,
  [2708] = 409,
  [2709] = 435,
  [2710] = 2640,
  [2711] = 288,
  [2712] = 434,
  [2713] = 431,
  [2714] = 427,
  [2715] = 424,
  [2716] = 409,
  [2717] = 401,
  [2718] = 2639,
  [2719] = 2639,
  [2720] = 2640,
  [2721] = 348,
  [2722] = 341,
  [2723] = 523,
  [2724] = 360,
  [2725] = 271,
  [2726] = 2640,
  [2727] = 351,
  [2728] = 2643,
  [2729] = 370,
  [2730] = 389,
  [2731] = 390,
  [2732] = 404,
  [2733] = 405,
  [2734] = 494,
  [2735] = 407,
  [2736] = 408,
  [2737] = 453,
  [2738] = 454,
  [2739] = 463,
  [2740] = 466,
  [2741] = 467,
  [2742] = 468,
  [2743] = 2644,
  [2744] = 2640,
  [2745] = 2745,
  [2746] = 258,
  [2747] = 429,
  [2748] = 442,
  [2749] = 313,
  [2750] = 2639,
  [2751] = 490,
  [2752] = 450,
  [2753] = 2643,
  [2754] = 257,
  [2755] = 2755,
  [2756] = 252,
  [2757] = 493,
  [2758] = 2640,
  [2759] = 2643,
  [2760] = 501,
  [2761] = 502,
  [2762] = 510,
  [2763] = 511,
  [2764] = 412,
  [2765] = 2643,
  [2766] = 2640,
  [2767] = 531,
  [2768] = 2639,
  [2769] = 528,
  [2770] = 519,
  [2771] = 517,
  [2772] = 515,
  [2773] = 514,
  [2774] = 2644,
  [2775] = 513,
  [2776] = 512,
  [2777] = 2644,
  [2778] = 520,
  [2779] = 1133,
  [2780] = 2639,
  [2781] = 333,
  [2782] = 359,
  [2783] = 485,
  [2784] = 483,
  [2785] = 481,
  [2786] = 473,
  [2787] = 470,
  [2788] = 494,
  [2789] = 469,
  [2790] = 358,
  [2791] = 474,
  [2792] = 461,
  [2793] = 471,
  [2794] = 2644,
  [2795] = 342,
  [2796] = 2639,
  [2797] = 367,
  [2798] = 446,
  [2799] = 452,
  [2800] = 2800,
  [2801] = 245,
  [2802] = 421,
  [2803] = 505,
  [2804] = 342,
  [2805] = 443,
  [2806] = 247,
  [2807] = 256,
  [2808] = 461,
  [2809] = 438,
  [2810] = 358,
  [2811] = 447,
  [2812] = 452,
  [2813] = 469,
  [2814] = 2639,
  [2815] = 484,
  [2816] = 470,
  [2817] = 441,
  [2818] = 473,
  [2819] = 425,
  [2820] = 428,
  [2821] = 485,
  [2822] = 359,
  [2823] = 333,
  [2824] = 482,
  [2825] = 480,
  [2826] = 479,
  [2827] = 460,
  [2828] = 457,
  [2829] = 357,
  [2830] = 456,
  [2831] = 403,
  [2832] = 2832,
  [2833] = 409,
  [2834] = 435,
  [2835] = 2835,
  [2836] = 434,
  [2837] = 431,
  [2838] = 401,
  [2839] = 2643,
  [2840] = 512,
  [2841] = 313,
  [2842] = 513,
  [2843] = 2843,
  [2844] = 514,
  [2845] = 515,
  [2846] = 517,
  [2847] = 519,
  [2848] = 528,
  [2849] = 348,
  [2850] = 531,
  [2851] = 403,
  [2852] = 403,
  [2853] = 403,
  [2854] = 421,
  [2855] = 341,
  [2856] = 246,
  [2857] = 412,
  [2858] = 390,
  [2859] = 404,
  [2860] = 405,
  [2861] = 253,
  [2862] = 407,
  [2863] = 256,
  [2864] = 511,
  [2865] = 2615,
  [2866] = 247,
  [2867] = 2643,
  [2868] = 2868,
  [2869] = 2643,
  [2870] = 245,
  [2871] = 2644,
  [2872] = 2643,
  [2873] = 510,
  [2874] = 2639,
  [2875] = 2644,
  [2876] = 502,
  [2877] = 446,
  [2878] = 501,
  [2879] = 2639,
  [2880] = 474,
  [2881] = 453,
  [2882] = 454,
  [2883] = 463,
  [2884] = 483,
  [2885] = 2644,
  [2886] = 2639,
  [2887] = 253,
  [2888] = 429,
  [2889] = 442,
  [2890] = 246,
  [2891] = 520,
  [2892] = 251,
  [2893] = 2644,
  [2894] = 2639,
  [2895] = 490,
  [2896] = 251,
  [2897] = 493,
  [2898] = 254,
  [2899] = 2639,
  [2900] = 254,
  [2901] = 2643,
  [2902] = 450,
  [2903] = 2903,
  [2904] = 2904,
  [2905] = 2905,
  [2906] = 2904,
  [2907] = 2904,
  [2908] = 1688,
  [2909] = 2909,
  [2910] = 2910,
  [2911] = 2904,
  [2912] = 259,
  [2913] = 2904,
  [2914] = 2904,
  [2915] = 2904,
  [2916] = 2916,
  [2917] = 2910,
  [2918] = 261,
  [2919] = 357,
  [2920] = 2904,
  [2921] = 2910,
  [2922] = 2904,
  [2923] = 2904,
  [2924] = 2904,
  [2925] = 2910,
  [2926] = 2013,
  [2927] = 2904,
  [2928] = 2904,
  [2929] = 2929,
  [2930] = 2930,
  [2931] = 2931,
  [2932] = 468,
  [2933] = 2930,
  [2934] = 2930,
  [2935] = 481,
  [2936] = 2235,
  [2937] = 467,
  [2938] = 92,
  [2939] = 466,
  [2940] = 93,
  [2941] = 93,
  [2942] = 360,
  [2943] = 2930,
  [2944] = 2930,
  [2945] = 2930,
  [2946] = 2930,
  [2947] = 370,
  [2948] = 2948,
  [2949] = 494,
  [2950] = 2930,
  [2951] = 2930,
  [2952] = 424,
  [2953] = 90,
  [2954] = 471,
  [2955] = 427,
  [2956] = 508,
  [2957] = 413,
  [2958] = 2930,
  [2959] = 90,
  [2960] = 2930,
  [2961] = 526,
  [2962] = 351,
  [2963] = 92,
  [2964] = 524,
  [2965] = 414,
  [2966] = 334,
  [2967] = 2930,
  [2968] = 436,
  [2969] = 426,
  [2970] = 336,
  [2971] = 383,
  [2972] = 499,
  [2973] = 380,
  [2974] = 2930,
  [2975] = 379,
  [2976] = 386,
  [2977] = 387,
  [2978] = 497,
  [2979] = 503,
  [2980] = 522,
  [2981] = 1693,
  [2982] = 1693,
  [2983] = 2983,
  [2984] = 1692,
  [2985] = 1692,
  [2986] = 1686,
  [2987] = 1686,
  [2988] = 2988,
  [2989] = 1692,
  [2990] = 1693,
  [2991] = 2991,
  [2992] = 2983,
  [2993] = 1693,
  [2994] = 1692,
  [2995] = 2983,
  [2996] = 2991,
  [2997] = 1686,
  [2998] = 2991,
  [2999] = 2999,
  [3000] = 2983,
  [3001] = 1686,
  [3002] = 1686,
  [3003] = 1692,
  [3004] = 1686,
  [3005] = 1692,
  [3006] = 1686,
  [3007] = 1692,
  [3008] = 1693,
  [3009] = 2983,
  [3010] = 1693,
  [3011] = 2991,
  [3012] = 1693,
  [3013] = 1692,
  [3014] = 1686,
  [3015] = 1686,
  [3016] = 1692,
  [3017] = 1686,
  [3018] = 1692,
  [3019] = 3019,
  [3020] = 1692,
  [3021] = 1693,
  [3022] = 1686,
  [3023] = 1686,
  [3024] = 1692,
  [3025] = 1693,
  [3026] = 2983,
  [3027] = 1693,
  [3028] = 2991,
  [3029] = 2991,
  [3030] = 1692,
  [3031] = 1693,
  [3032] = 2983,
  [3033] = 3033,
  [3034] = 2991,
  [3035] = 1693,
  [3036] = 1686,
  [3037] = 1692,
  [3038] = 1686,
  [3039] = 1693,
  [3040] = 1686,
  [3041] = 1692,
  [3042] = 1693,
  [3043] = 1693,
  [3044] = 2983,
  [3045] = 2983,
  [3046] = 1686,
  [3047] = 2983,
  [3048] = 2991,
  [3049] = 2991,
  [3050] = 2983,
  [3051] = 2983,
  [3052] = 2991,
  [3053] = 1693,
  [3054] = 2991,
  [3055] = 1686,
  [3056] = 1692,
  [3057] = 2991,
  [3058] = 1692,
  [3059] = 1693,
  [3060] = 3060,
  [3061] = 3060,
  [3062] = 3062,
  [3063] = 3062,
  [3064] = 3064,
  [3065] = 3062,
  [3066] = 3066,
  [3067] = 3066,
  [3068] = 3068,
  [3069] = 3066,
  [3070] = 3062,
  [3071] = 1916,
  [3072] = 3066,
  [3073] = 3073,
  [3074] = 3074,
  [3075] = 3066,
  [3076] = 3066,
  [3077] = 3066,
  [3078] = 3066,
  [3079] = 3066,
  [3080] = 3062,
  [3081] = 3062,
  [3082] = 3066,
  [3083] = 3062,
  [3084] = 3084,
  [3085] = 3062,
  [3086] = 3062,
  [3087] = 3066,
  [3088] = 3066,
  [3089] = 3066,
  [3090] = 3090,
  [3091] = 3062,
  [3092] = 3092,
  [3093] = 3066,
  [3094] = 3062,
  [3095] = 3062,
  [3096] = 3096,
  [3097] = 3066,
  [3098] = 3062,
  [3099] = 3099,
  [3100] = 3062,
  [3101] = 3062,
  [3102] = 3102,
  [3103] = 3103,
  [3104] = 3104,
  [3105] = 3105,
  [3106] = 3106,
  [3107] = 3107,
  [3108] = 3108,
  [3109] = 3106,
  [3110] = 3110,
  [3111] = 3107,
  [3112] = 3112,
  [3113] = 3112,
  [3114] = 3114,
  [3115] = 3107,
  [3116] = 3116,
  [3117] = 3112,
  [3118] = 3105,
  [3119] = 3107,
  [3120] = 3102,
  [3121] = 3106,
  [3122] = 3105,
  [3123] = 3105,
  [3124] = 3110,
  [3125] = 3104,
  [3126] = 3108,
  [3127] = 3127,
  [3128] = 3102,
  [3129] = 3129,
  [3130] = 3116,
  [3131] = 3102,
  [3132] = 3129,
  [3133] = 3108,
  [3134] = 3103,
  [3135] = 3135,
  [3136] = 3127,
  [3137] = 3137,
  [3138] = 3127,
  [3139] = 3110,
  [3140] = 3129,
  [3141] = 3112,
  [3142] = 3129,
  [3143] = 3104,
  [3144] = 3116,
  [3145] = 3127,
  [3146] = 3137,
  [3147] = 3137,
  [3148] = 3116,
  [3149] = 3149,
  [3150] = 3137,
  [3151] = 3108,
  [3152] = 3105,
  [3153] = 3107,
  [3154] = 3135,
  [3155] = 3110,
  [3156] = 3104,
  [3157] = 3116,
  [3158] = 3103,
  [3159] = 3110,
  [3160] = 3106,
  [3161] = 3102,
  [3162] = 3102,
  [3163] = 3135,
  [3164] = 3103,
  [3165] = 3103,
  [3166] = 3104,
  [3167] = 3103,
  [3168] = 3103,
  [3169] = 3104,
  [3170] = 3107,
  [3171] = 3116,
  [3172] = 3103,
  [3173] = 3129,
  [3174] = 3174,
  [3175] = 3135,
  [3176] = 3104,
  [3177] = 3137,
  [3178] = 3110,
  [3179] = 3102,
  [3180] = 3180,
  [3181] = 3106,
  [3182] = 3135,
  [3183] = 3127,
  [3184] = 3102,
  [3185] = 3107,
  [3186] = 3135,
  [3187] = 3116,
  [3188] = 3103,
  [3189] = 3137,
  [3190] = 3116,
  [3191] = 3106,
  [3192] = 3105,
  [3193] = 3102,
  [3194] = 3108,
  [3195] = 3135,
  [3196] = 3112,
  [3197] = 3106,
  [3198] = 3112,
  [3199] = 3104,
  [3200] = 3112,
  [3201] = 3129,
  [3202] = 3202,
  [3203] = 3106,
  [3204] = 3108,
  [3205] = 3105,
  [3206] = 3127,
  [3207] = 3129,
  [3208] = 3129,
  [3209] = 3110,
  [3210] = 3202,
  [3211] = 3137,
  [3212] = 3127,
  [3213] = 3129,
  [3214] = 3116,
  [3215] = 3215,
  [3216] = 3102,
  [3217] = 3107,
  [3218] = 3102,
  [3219] = 3129,
  [3220] = 3116,
  [3221] = 3127,
  [3222] = 3105,
  [3223] = 3129,
  [3224] = 3129,
  [3225] = 3108,
  [3226] = 3135,
  [3227] = 3106,
  [3228] = 3228,
  [3229] = 3129,
  [3230] = 3137,
  [3231] = 3112,
  [3232] = 3127,
  [3233] = 3129,
  [3234] = 3129,
  [3235] = 3137,
  [3236] = 3127,
  [3237] = 3129,
  [3238] = 3116,
  [3239] = 3103,
  [3240] = 3116,
  [3241] = 3137,
  [3242] = 3105,
  [3243] = 3104,
  [3244] = 3110,
  [3245] = 3129,
  [3246] = 3116,
  [3247] = 3107,
  [3248] = 3105,
  [3249] = 3108,
  [3250] = 3116,
  [3251] = 3102,
  [3252] = 3135,
  [3253] = 3135,
  [3254] = 3129,
  [3255] = 3137,
  [3256] = 3110,
  [3257] = 3107,
  [3258] = 3105,
  [3259] = 3108,
  [3260] = 3137,
  [3261] = 3127,
  [3262] = 3116,
  [3263] = 3129,
  [3264] = 3108,
  [3265] = 3105,
  [3266] = 3135,
  [3267] = 3103,
  [3268] = 3129,
  [3269] = 3104,
  [3270] = 3103,
  [3271] = 3104,
  [3272] = 3108,
  [3273] = 3129,
  [3274] = 3105,
  [3275] = 3202,
  [3276] = 3107,
  [3277] = 3110,
  [3278] = 3107,
  [3279] = 3104,
  [3280] = 3110,
  [3281] = 3110,
  [3282] = 3127,
  [3283] = 3102,
  [3284] = 3104,
  [3285] = 3104,
  [3286] = 3286,
  [3287] = 3127,
  [3288] = 3106,
  [3289] = 3137,
  [3290] = 3110,
  [3291] = 3135,
  [3292] = 3104,
  [3293] = 3103,
  [3294] = 3116,
  [3295] = 3137,
  [3296] = 3135,
  [3297] = 3110,
  [3298] = 3107,
  [3299] = 3108,
  [3300] = 3105,
  [3301] = 3108,
  [3302] = 3137,
  [3303] = 3127,
  [3304] = 3112,
  [3305] = 3135,
  [3306] = 3108,
  [3307] = 3106,
  [3308] = 3104,
  [3309] = 3103,
  [3310] = 3103,
  [3311] = 3107,
  [3312] = 3135,
  [3313] = 3110,
  [3314] = 3127,
  [3315] = 3110,
  [3316] = 3129,
  [3317] = 3106,
  [3318] = 3107,
  [3319] = 3116,
  [3320] = 3102,
  [3321] = 3112,
  [3322] = 3112,
  [3323] = 3127,
  [3324] = 3137,
  [3325] = 3137,
  [3326] = 3102,
  [3327] = 3127,
  [3328] = 3135,
  [3329] = 3135,
  [3330] = 3108,
  [3331] = 3108,
  [3332] = 3108,
  [3333] = 3105,
  [3334] = 3105,
  [3335] = 3129,
  [3336] = 3107,
  [3337] = 3110,
  [3338] = 3104,
  [3339] = 3103,
  [3340] = 3107,
  [3341] = 3103,
  [3342] = 3202,
  [3343] = 3343,
  [3344] = 3112,
  [3345] = 3105,
  [3346] = 3346,
  [3347] = 3347,
  [3348] = 3348,
  [3349] = 3348,
  [3350] = 3348,
  [3351] = 3348,
  [3352] = 3352,
  [3353] = 3348,
  [3354] = 3348,
  [3355] = 3355,
  [3356] = 3348,
  [3357] = 3348,
  [3358] = 3348,
  [3359] = 3348,
  [3360] = 3348,
  [3361] = 3348,
  [3362] = 3362,
  [3363] = 477,
  [3364] = 475,
  [3365] = 529,
  [3366] = 395,
  [3367] = 455,
  [3368] = 475,
  [3369] = 455,
  [3370] = 395,
  [3371] = 3371,
  [3372] = 3372,
  [3373] = 3373,
  [3374] = 529,
  [3375] = 477,
  [3376] = 3376,
  [3377] = 1766,
  [3378] = 3378,
  [3379] = 1408,
  [3380] = 1408,
  [3381] = 3381,
  [3382] = 2248,
  [3383] = 3383,
  [3384] = 2331,
  [3385] = 1717,
  [3386] = 3383,
  [3387] = 3383,
  [3388] = 3388,
  [3389] = 1737,
  [3390] = 3383,
  [3391] = 3391,
  [3392] = 3392,
  [3393] = 2386,
  [3394] = 2374,
  [3395] = 3395,
  [3396] = 3396,
  [3397] = 3397,
  [3398] = 3398,
  [3399] = 333,
  [3400] = 3398,
  [3401] = 3398,
  [3402] = 3402,
  [3403] = 3398,
  [3404] = 3404,
  [3405] = 3398,
  [3406] = 403,
  [3407] = 3407,
  [3408] = 3408,
  [3409] = 3398,
  [3410] = 3398,
  [3411] = 3408,
  [3412] = 3408,
  [3413] = 3398,
  [3414] = 3408,
  [3415] = 3398,
  [3416] = 3416,
  [3417] = 3398,
  [3418] = 3408,
  [3419] = 3408,
  [3420] = 3408,
  [3421] = 3408,
  [3422] = 3398,
  [3423] = 291,
  [3424] = 359,
  [3425] = 3408,
  [3426] = 3398,
  [3427] = 3408,
  [3428] = 3408,
  [3429] = 3408,
  [3430] = 3430,
  [3431] = 3404,
  [3432] = 3432,
  [3433] = 3433,
  [3434] = 3398,
  [3435] = 3408,
  [3436] = 3404,
  [3437] = 3398,
  [3438] = 3408,
  [3439] = 3398,
  [3440] = 3440,
  [3441] = 3441,
  [3442] = 3442,
  [3443] = 3443,
  [3444] = 3408,
  [3445] = 3404,
  [3446] = 3446,
  [3447] = 342,
  [3448] = 412,
  [3449] = 3449,
  [3450] = 358,
  [3451] = 3451,
  [3452] = 3452,
  [3453] = 3453,
  [3454] = 3454,
  [3455] = 519,
  [3456] = 514,
  [3457] = 3457,
  [3458] = 429,
  [3459] = 442,
  [3460] = 450,
  [3461] = 493,
  [3462] = 473,
  [3463] = 513,
  [3464] = 470,
  [3465] = 501,
  [3466] = 469,
  [3467] = 515,
  [3468] = 461,
  [3469] = 512,
  [3470] = 3470,
  [3471] = 502,
  [3472] = 485,
  [3473] = 510,
  [3474] = 511,
  [3475] = 531,
  [3476] = 517,
  [3477] = 3477,
  [3478] = 528,
  [3479] = 3479,
  [3480] = 3480,
  [3481] = 3481,
  [3482] = 3482,
  [3483] = 3483,
  [3484] = 3482,
  [3485] = 3482,
  [3486] = 3482,
  [3487] = 3487,
  [3488] = 3482,
  [3489] = 3489,
  [3490] = 3482,
  [3491] = 3482,
  [3492] = 3482,
  [3493] = 3482,
  [3494] = 523,
  [3495] = 3495,
  [3496] = 3482,
  [3497] = 3497,
  [3498] = 3482,
  [3499] = 3482,
  [3500] = 3500,
  [3501] = 3501,
  [3502] = 3502,
  [3503] = 3503,
  [3504] = 3504,
  [3505] = 3505,
  [3506] = 3506,
  [3507] = 3507,
  [3508] = 3508,
  [3509] = 3509,
  [3510] = 3510,
  [3511] = 3511,
  [3512] = 3512,
  [3513] = 3513,
  [3514] = 3514,
  [3515] = 3515,
  [3516] = 3516,
  [3517] = 3517,
  [3518] = 3518,
  [3519] = 3519,
  [3520] = 3519,
  [3521] = 3521,
  [3522] = 3519,
  [3523] = 3523,
  [3524] = 3524,
  [3525] = 3521,
  [3526] = 3526,
  [3527] = 3527,
  [3528] = 3528,
  [3529] = 3529,
  [3530] = 3530,
  [3531] = 3531,
  [3532] = 3532,
  [3533] = 3519,
  [3534] = 3523,
  [3535] = 3535,
  [3536] = 3535,
  [3537] = 3523,
  [3538] = 3523,
  [3539] = 3519,
  [3540] = 3540,
  [3541] = 3521,
  [3542] = 3524,
  [3543] = 3535,
  [3544] = 3519,
  [3545] = 3521,
  [3546] = 3527,
  [3547] = 3547,
  [3548] = 3527,
  [3549] = 3528,
  [3550] = 3529,
  [3551] = 3530,
  [3552] = 3528,
  [3553] = 3529,
  [3554] = 3530,
  [3555] = 3527,
  [3556] = 3556,
  [3557] = 3528,
  [3558] = 3529,
  [3559] = 3530,
  [3560] = 3524,
  [3561] = 3561,
  [3562] = 3535,
  [3563] = 3563,
  [3564] = 3535,
  [3565] = 3523,
  [3566] = 3528,
  [3567] = 3521,
  [3568] = 3530,
  [3569] = 3524,
  [3570] = 3530,
  [3571] = 3529,
  [3572] = 3528,
  [3573] = 3527,
  [3574] = 3529,
  [3575] = 3527,
  [3576] = 3528,
  [3577] = 3529,
  [3578] = 3524,
  [3579] = 3579,
  [3580] = 3527,
  [3581] = 3528,
  [3582] = 3529,
  [3583] = 3530,
  [3584] = 3535,
  [3585] = 3530,
  [3586] = 3523,
  [3587] = 3535,
  [3588] = 3519,
  [3589] = 3528,
  [3590] = 3521,
  [3591] = 3519,
  [3592] = 3524,
  [3593] = 3523,
  [3594] = 3527,
  [3595] = 3595,
  [3596] = 3524,
  [3597] = 3523,
  [3598] = 3524,
  [3599] = 3521,
  [3600] = 3519,
  [3601] = 3523,
  [3602] = 3535,
  [3603] = 3527,
  [3604] = 3521,
  [3605] = 3605,
  [3606] = 3530,
  [3607] = 3529,
  [3608] = 3529,
  [3609] = 3530,
  [3610] = 3610,
  [3611] = 3611,
  [3612] = 3528,
  [3613] = 3527,
  [3614] = 3535,
  [3615] = 3615,
  [3616] = 3616,
  [3617] = 3523,
  [3618] = 3519,
  [3619] = 3521,
  [3620] = 3524,
  [3621] = 3535,
  [3622] = 3622,
  [3623] = 3623,
  [3624] = 3527,
  [3625] = 3528,
  [3626] = 3529,
  [3627] = 3530,
  [3628] = 3524,
  [3629] = 3629,
  [3630] = 3630,
  [3631] = 3535,
  [3632] = 3530,
  [3633] = 3521,
  [3634] = 3529,
  [3635] = 3528,
  [3636] = 3527,
  [3637] = 3521,
  [3638] = 3535,
  [3639] = 3519,
  [3640] = 3524,
  [3641] = 3523,
  [3642] = 3523,
  [3643] = 3519,
  [3644] = 3521,
  [3645] = 3524,
  [3646] = 3646,
  [3647] = 3647,
  [3648] = 3648,
  [3649] = 291,
  [3650] = 3650,
  [3651] = 403,
  [3652] = 3652,
  [3653] = 3653,
  [3654] = 3654,
  [3655] = 3655,
  [3656] = 3656,
  [3657] = 3657,
  [3658] = 3658,
  [3659] = 3659,
  [3660] = 3660,
  [3661] = 3661,
  [3662] = 3662,
  [3663] = 3663,
  [3664] = 3664,
  [3665] = 3665,
  [3666] = 3666,
  [3667] = 3667,
  [3668] = 3668,
  [3669] = 523,
  [3670] = 3670,
  [3671] = 3671,
  [3672] = 3672,
  [3673] = 3673,
  [3674] = 3674,
  [3675] = 3675,
  [3676] = 3676,
  [3677] = 3677,
  [3678] = 3678,
  [3679] = 3679,
  [3680] = 3680,
  [3681] = 3681,
  [3682] = 3682,
  [3683] = 3683,
  [3684] = 3657,
  [3685] = 3663,
  [3686] = 3686,
  [3687] = 3673,
  [3688] = 3688,
  [3689] = 3689,
  [3690] = 3670,
  [3691] = 3660,
  [3692] = 3692,
  [3693] = 3693,
  [3694] = 3694,
  [3695] = 3695,
  [3696] = 3696,
  [3697] = 3697,
  [3698] = 3698,
  [3699] = 3699,
  [3700] = 3693,
  [3701] = 3701,
  [3702] = 3702,
  [3703] = 3703,
  [3704] = 3694,
  [3705] = 3693,
  [3706] = 3706,
  [3707] = 3707,
  [3708] = 3708,
  [3709] = 3693,
  [3710] = 3710,
  [3711] = 3693,
  [3712] = 3694,
  [3713] = 3713,
  [3714] = 3698,
  [3715] = 3693,
  [3716] = 3716,
  [3717] = 3699,
  [3718] = 3718,
  [3719] = 3719,
  [3720] = 3701,
  [3721] = 3693,
  [3722] = 3698,
  [3723] = 3723,
  [3724] = 3699,
  [3725] = 3725,
  [3726] = 3701,
  [3727] = 3693,
  [3728] = 3728,
  [3729] = 3729,
  [3730] = 3699,
  [3731] = 3701,
  [3732] = 3732,
  [3733] = 3733,
  [3734] = 3734,
  [3735] = 3693,
  [3736] = 3736,
  [3737] = 3737,
  [3738] = 3738,
  [3739] = 3739,
  [3740] = 3694,
  [3741] = 3736,
  [3742] = 3698,
  [3743] = 3701,
  [3744] = 3699,
  [3745] = 3693,
  [3746] = 3746,
  [3747] = 3701,
  [3748] = 3699,
  [3749] = 3699,
  [3750] = 3693,
  [3751] = 3698,
  [3752] = 3701,
  [3753] = 3694,
  [3754] = 3754,
  [3755] = 3755,
  [3756] = 3701,
  [3757] = 3757,
  [3758] = 3699,
  [3759] = 3759,
  [3760] = 3760,
  [3761] = 3698,
  [3762] = 3762,
  [3763] = 3698,
  [3764] = 3764,
  [3765] = 3694,
  [3766] = 3766,
  [3767] = 3698,
  [3768] = 3768,
  [3769] = 3769,
  [3770] = 3770,
  [3771] = 3771,
  [3772] = 3772,
  [3773] = 3694,
  [3774] = 3774,
  [3775] = 3699,
  [3776] = 3701,
  [3777] = 3694,
  [3778] = 1835,
  [3779] = 3779,
  [3780] = 3780,
  [3781] = 3698,
  [3782] = 3693,
  [3783] = 3693,
  [3784] = 3784,
  [3785] = 3785,
  [3786] = 1840,
  [3787] = 3787,
  [3788] = 3694,
  [3789] = 3754,
  [3790] = 3736,
  [3791] = 3693,
  [3792] = 3754,
  [3793] = 3736,
  [3794] = 3693,
  [3795] = 3754,
  [3796] = 3736,
  [3797] = 3797,
  [3798] = 3699,
  [3799] = 3698,
  [3800] = 3754,
  [3801] = 3801,
  [3802] = 3701,
  [3803] = 3803,
  [3804] = 3694,
  [3805] = 3736,
  [3806] = 3806,
  [3807] = 3754,
  [3808] = 3699,
  [3809] = 3701,
  [3810] = 3736,
  [3811] = 3811,
  [3812] = 3693,
  [3813] = 3754,
  [3814] = 3814,
  [3815] = 3815,
  [3816] = 3736,
  [3817] = 3736,
  [3818] = 3818,
  [3819] = 3754,
  [3820] = 3701,
  [3821] = 3699,
  [3822] = 3698,
  [3823] = 3736,
  [3824] = 3824,
  [3825] = 3825,
  [3826] = 3826,
  [3827] = 3754,
  [3828] = 3828,
  [3829] = 3754,
  [3830] = 3698,
  [3831] = 3754,
  [3832] = 3736,
  [3833] = 3694,
  [3834] = 3693,
  [3835] = 3835,
  [3836] = 3694,
  [3837] = 3736,
  [3838] = 3698,
  [3839] = 3701,
  [3840] = 3699,
  [3841] = 3754,
  [3842] = 3842,
  [3843] = 3843,
  [3844] = 3844,
  [3845] = 3845,
  [3846] = 3846,
  [3847] = 3847,
  [3848] = 3848,
  [3849] = 3849,
  [3850] = 3850,
  [3851] = 3851,
  [3852] = 3852,
  [3853] = 3853,
  [3854] = 3844,
  [3855] = 3849,
  [3856] = 3856,
  [3857] = 3857,
  [3858] = 3853,
  [3859] = 3847,
  [3860] = 3860,
  [3861] = 3861,
  [3862] = 3860,
  [3863] = 3863,
  [3864] = 3845,
  [3865] = 3857,
  [3866] = 3860,
  [3867] = 3853,
  [3868] = 3849,
  [3869] = 3846,
  [3870] = 3848,
  [3871] = 3850,
  [3872] = 3851,
  [3873] = 3844,
  [3874] = 3874,
  [3875] = 3849,
  [3876] = 3863,
  [3877] = 3686,
  [3878] = 3662,
  [3879] = 3861,
  [3880] = 3853,
  [3881] = 3860,
  [3882] = 3857,
  [3883] = 3683,
  [3884] = 3857,
  [3885] = 3692,
  [3886] = 3850,
  [3887] = 3844,
  [3888] = 3851,
  [3889] = 3889,
  [3890] = 3850,
  [3891] = 3863,
  [3892] = 3892,
  [3893] = 3847,
  [3894] = 3861,
  [3895] = 3849,
  [3896] = 3844,
  [3897] = 3861,
  [3898] = 3863,
  [3899] = 3853,
  [3900] = 3900,
  [3901] = 3845,
  [3902] = 3846,
  [3903] = 3860,
  [3904] = 3863,
  [3905] = 3848,
  [3906] = 3906,
  [3907] = 1737,
  [3908] = 3861,
  [3909] = 3860,
  [3910] = 3853,
  [3911] = 3849,
  [3912] = 3851,
  [3913] = 3913,
  [3914] = 3914,
  [3915] = 3861,
  [3916] = 3844,
  [3917] = 3844,
  [3918] = 3918,
  [3919] = 3919,
  [3920] = 3920,
  [3921] = 3863,
  [3922] = 3847,
  [3923] = 3848,
  [3924] = 3924,
  [3925] = 3925,
  [3926] = 3846,
  [3927] = 3845,
  [3928] = 3857,
  [3929] = 3857,
  [3930] = 3930,
  [3931] = 3848,
  [3932] = 3846,
  [3933] = 3845,
  [3934] = 3851,
  [3935] = 3850,
  [3936] = 3860,
  [3937] = 3844,
  [3938] = 3844,
  [3939] = 3853,
  [3940] = 3849,
  [3941] = 1740,
  [3942] = 3848,
  [3943] = 3846,
  [3944] = 3944,
  [3945] = 3847,
  [3946] = 3946,
  [3947] = 3947,
  [3948] = 3844,
  [3949] = 3949,
  [3950] = 3848,
  [3951] = 3844,
  [3952] = 3845,
  [3953] = 3953,
  [3954] = 3863,
  [3955] = 3861,
  [3956] = 3857,
  [3957] = 3957,
  [3958] = 3391,
  [3959] = 3959,
  [3960] = 3960,
  [3961] = 3845,
  [3962] = 3847,
  [3963] = 3963,
  [3964] = 3851,
  [3965] = 3850,
  [3966] = 3846,
  [3967] = 3848,
  [3968] = 3847,
  [3969] = 3969,
  [3970] = 1717,
  [3971] = 3971,
  [3972] = 1715,
  [3973] = 3845,
  [3974] = 3846,
  [3975] = 3975,
  [3976] = 3976,
  [3977] = 3388,
  [3978] = 3847,
  [3979] = 3850,
  [3980] = 1737,
  [3981] = 3981,
  [3982] = 1715,
  [3983] = 3983,
  [3984] = 3847,
  [3985] = 3851,
  [3986] = 3850,
  [3987] = 3851,
  [3988] = 3850,
  [3989] = 3844,
  [3990] = 3851,
  [3991] = 3851,
  [3992] = 3844,
  [3993] = 3857,
  [3994] = 3861,
  [3995] = 3863,
  [3996] = 3850,
  [3997] = 3845,
  [3998] = 3846,
  [3999] = 3848,
  [4000] = 2248,
  [4001] = 3857,
  [4002] = 4002,
  [4003] = 4003,
  [4004] = 3857,
  [4005] = 4005,
  [4006] = 3860,
  [4007] = 3853,
  [4008] = 3849,
  [4009] = 4009,
  [4010] = 1717,
  [4011] = 4011,
  [4012] = 4012,
  [4013] = 1740,
  [4014] = 3861,
  [4015] = 3863,
  [4016] = 4016,
  [4017] = 3860,
  [4018] = 4018,
  [4019] = 3853,
  [4020] = 3849,
  [4021] = 1717,
  [4022] = 4022,
  [4023] = 4023,
  [4024] = 4024,
  [4025] = 4025,
  [4026] = 3857,
  [4027] = 3849,
  [4028] = 4028,
  [4029] = 3849,
  [4030] = 3853,
  [4031] = 3851,
  [4032] = 3850,
  [4033] = 4033,
  [4034] = 3853,
  [4035] = 3860,
  [4036] = 3847,
  [4037] = 3850,
  [4038] = 3851,
  [4039] = 3857,
  [4040] = 3860,
  [4041] = 3857,
  [4042] = 3847,
  [4043] = 3849,
  [4044] = 3849,
  [4045] = 3853,
  [4046] = 3860,
  [4047] = 3851,
  [4048] = 3853,
  [4049] = 3850,
  [4050] = 4050,
  [4051] = 3860,
  [4052] = 3863,
  [4053] = 3861,
  [4054] = 4054,
  [4055] = 3863,
  [4056] = 3845,
  [4057] = 4057,
  [4058] = 3847,
  [4059] = 3847,
  [4060] = 3861,
  [4061] = 3850,
  [4062] = 3851,
  [4063] = 4063,
  [4064] = 3847,
  [4065] = 3857,
  [4066] = 1737,
  [4067] = 3849,
  [4068] = 3853,
  [4069] = 3863,
  [4070] = 3860,
  [4071] = 3861,
  [4072] = 3844,
  [4073] = 3848,
  [4074] = 3846,
  [4075] = 3844,
  [4076] = 3845,
  [4077] = 4077,
  [4078] = 3860,
  [4079] = 3853,
  [4080] = 3849,
  [4081] = 3848,
  [4082] = 3846,
  [4083] = 1715,
  [4084] = 3857,
  [4085] = 3848,
  [4086] = 3846,
  [4087] = 3851,
  [4088] = 3850,
  [4089] = 3845,
  [4090] = 4090,
  [4091] = 3845,
  [4092] = 3847,
  [4093] = 4093,
  [4094] = 4094,
  [4095] = 4095,
  [4096] = 4096,
  [4097] = 4097,
  [4098] = 3686,
  [4099] = 4099,
  [4100] = 3662,
  [4101] = 4101,
  [4102] = 4095,
  [4103] = 3662,
  [4104] = 3686,
  [4105] = 4105,
  [4106] = 3683,
  [4107] = 4107,
  [4108] = 3692,
  [4109] = 4109,
  [4110] = 4110,
  [4111] = 4111,
  [4112] = 4095,
  [4113] = 4105,
  [4114] = 4107,
  [4115] = 4115,
  [4116] = 1814,
  [4117] = 4101,
  [4118] = 4118,
  [4119] = 4105,
  [4120] = 4107,
  [4121] = 4099,
  [4122] = 4122,
  [4123] = 4101,
  [4124] = 4122,
  [4125] = 4095,
  [4126] = 4126,
  [4127] = 4127,
  [4128] = 4128,
  [4129] = 4107,
  [4130] = 4128,
  [4131] = 4115,
  [4132] = 4132,
  [4133] = 3692,
  [4134] = 4115,
  [4135] = 4107,
  [4136] = 4105,
  [4137] = 3683,
  [4138] = 4128,
  [4139] = 2331,
  [4140] = 4140,
  [4141] = 4107,
  [4142] = 4126,
  [4143] = 4097,
  [4144] = 4095,
  [4145] = 4145,
  [4146] = 4097,
  [4147] = 4107,
  [4148] = 4148,
  [4149] = 4126,
  [4150] = 4150,
  [4151] = 4105,
  [4152] = 3686,
  [4153] = 4153,
  [4154] = 4107,
  [4155] = 3662,
  [4156] = 4122,
  [4157] = 4107,
  [4158] = 4105,
  [4159] = 4159,
  [4160] = 4160,
  [4161] = 4132,
  [4162] = 4122,
  [4163] = 4107,
  [4164] = 1796,
  [4165] = 4140,
  [4166] = 3683,
  [4167] = 4107,
  [4168] = 3692,
  [4169] = 4115,
  [4170] = 4128,
  [4171] = 4153,
  [4172] = 4126,
  [4173] = 4159,
  [4174] = 4122,
  [4175] = 4175,
  [4176] = 4097,
  [4177] = 4177,
  [4178] = 4178,
  [4179] = 4145,
  [4180] = 4180,
  [4181] = 4181,
  [4182] = 4153,
  [4183] = 4183,
  [4184] = 4183,
  [4185] = 4159,
  [4186] = 4186,
  [4187] = 4122,
  [4188] = 4188,
  [4189] = 4181,
  [4190] = 4181,
  [4191] = 4107,
  [4192] = 4175,
  [4193] = 4193,
  [4194] = 4181,
  [4195] = 4195,
  [4196] = 4183,
  [4197] = 4183,
  [4198] = 4198,
  [4199] = 4199,
  [4200] = 4095,
  [4201] = 4122,
  [4202] = 4175,
  [4203] = 4159,
  [4204] = 4153,
  [4205] = 1815,
  [4206] = 4206,
  [4207] = 4207,
  [4208] = 4208,
  [4209] = 4175,
  [4210] = 4126,
  [4211] = 4175,
  [4212] = 4128,
  [4213] = 4213,
  [4214] = 4115,
  [4215] = 3692,
  [4216] = 3683,
  [4217] = 4217,
  [4218] = 4105,
  [4219] = 4145,
  [4220] = 3686,
  [4221] = 3662,
  [4222] = 3662,
  [4223] = 4223,
  [4224] = 4183,
  [4225] = 4181,
  [4226] = 3686,
  [4227] = 4097,
  [4228] = 4145,
  [4229] = 4105,
  [4230] = 4122,
  [4231] = 4159,
  [4232] = 4232,
  [4233] = 4153,
  [4234] = 4234,
  [4235] = 4145,
  [4236] = 3683,
  [4237] = 4237,
  [4238] = 3683,
  [4239] = 4101,
  [4240] = 4099,
  [4241] = 4099,
  [4242] = 4242,
  [4243] = 4126,
  [4244] = 4244,
  [4245] = 4128,
  [4246] = 4095,
  [4247] = 4247,
  [4248] = 3692,
  [4249] = 4249,
  [4250] = 4115,
  [4251] = 4115,
  [4252] = 4128,
  [4253] = 4126,
  [4254] = 4254,
  [4255] = 4097,
  [4256] = 4256,
  [4257] = 4257,
  [4258] = 4101,
  [4259] = 3692,
  [4260] = 3683,
  [4261] = 4261,
  [4262] = 4105,
  [4263] = 4145,
  [4264] = 4099,
  [4265] = 4145,
  [4266] = 3662,
  [4267] = 3686,
  [4268] = 4268,
  [4269] = 4269,
  [4270] = 4097,
  [4271] = 4271,
  [4272] = 4095,
  [4273] = 4273,
  [4274] = 4274,
  [4275] = 4275,
  [4276] = 4276,
  [4277] = 4095,
  [4278] = 4177,
  [4279] = 4101,
  [4280] = 4178,
  [4281] = 4180,
  [4282] = 4282,
  [4283] = 4107,
  [4284] = 4097,
  [4285] = 4285,
  [4286] = 4286,
  [4287] = 4181,
  [4288] = 4099,
  [4289] = 4099,
  [4290] = 4175,
  [4291] = 4099,
  [4292] = 4101,
  [4293] = 4159,
  [4294] = 4099,
  [4295] = 4101,
  [4296] = 3686,
  [4297] = 3662,
  [4298] = 4183,
  [4299] = 4181,
  [4300] = 4122,
  [4301] = 4105,
  [4302] = 4097,
  [4303] = 3683,
  [4304] = 4105,
  [4305] = 4145,
  [4306] = 3692,
  [4307] = 4307,
  [4308] = 4095,
  [4309] = 4122,
  [4310] = 4115,
  [4311] = 4159,
  [4312] = 4312,
  [4313] = 4115,
  [4314] = 4314,
  [4315] = 4153,
  [4316] = 4128,
  [4317] = 4126,
  [4318] = 4128,
  [4319] = 4097,
  [4320] = 4320,
  [4321] = 4175,
  [4322] = 4126,
  [4323] = 4128,
  [4324] = 4115,
  [4325] = 4325,
  [4326] = 3692,
  [4327] = 4126,
  [4328] = 4153,
  [4329] = 4183,
  [4330] = 4105,
  [4331] = 4159,
  [4332] = 4122,
  [4333] = 4181,
  [4334] = 4183,
  [4335] = 3662,
  [4336] = 3686,
  [4337] = 3686,
  [4338] = 4097,
  [4339] = 3662,
  [4340] = 4122,
  [4341] = 4159,
  [4342] = 4153,
  [4343] = 4153,
  [4344] = 4145,
  [4345] = 4345,
  [4346] = 4159,
  [4347] = 4175,
  [4348] = 4348,
  [4349] = 4349,
  [4350] = 4095,
  [4351] = 4101,
  [4352] = 4099,
  [4353] = 4105,
  [4354] = 4354,
  [4355] = 3683,
  [4356] = 4356,
  [4357] = 4122,
  [4358] = 3692,
  [4359] = 4359,
  [4360] = 4181,
  [4361] = 4183,
  [4362] = 4115,
  [4363] = 4128,
  [4364] = 4175,
  [4365] = 4145,
  [4366] = 4126,
  [4367] = 4175,
  [4368] = 4101,
  [4369] = 4175,
  [4370] = 4128,
  [4371] = 4145,
  [4372] = 4126,
  [4373] = 4373,
  [4374] = 4115,
  [4375] = 4101,
  [4376] = 4153,
  [4377] = 4099,
  [4378] = 4145,
  [4379] = 4379,
  [4380] = 4095,
  [4381] = 4183,
  [4382] = 4099,
  [4383] = 4097,
  [4384] = 3686,
  [4385] = 4385,
  [4386] = 4386,
  [4387] = 4387,
  [4388] = 3662,
  [4389] = 4105,
  [4390] = 4390,
  [4391] = 4181,
  [4392] = 4392,
  [4393] = 4175,
  [4394] = 4101,
  [4395] = 4105,
  [4396] = 4183,
  [4397] = 4181,
  [4398] = 4181,
  [4399] = 4097,
  [4400] = 4183,
  [4401] = 3683,
  [4402] = 4153,
  [4403] = 4122,
  [4404] = 3692,
  [4405] = 4115,
  [4406] = 4128,
  [4407] = 4126,
  [4408] = 4408,
  [4409] = 4159,
  [4410] = 4153,
  [4411] = 4159,
  [4412] = 4095,
  [4413] = 4122,
  [4414] = 4414,
  [4415] = 4415,
  [4416] = 4416,
  [4417] = 4417,
  [4418] = 4418,
  [4419] = 4419,
  [4420] = 4420,
  [4421] = 4421,
  [4422] = 4422,
  [4423] = 4423,
  [4424] = 4424,
  [4425] = 4423,
  [4426] = 4424,
  [4427] = 4421,
  [4428] = 4419,
  [4429] = 4429,
  [4430] = 4430,
  [4431] = 4431,
  [4432] = 4416,
  [4433] = 4433,
  [4434] = 4434,
  [4435] = 4435,
  [4436] = 4436,
  [4437] = 4414,
  [4438] = 4438,
  [4439] = 4419,
  [4440] = 4421,
  [4441] = 4424,
  [4442] = 4414,
  [4443] = 4443,
  [4444] = 4423,
  [4445] = 4445,
  [4446] = 4431,
  [4447] = 4424,
  [4448] = 4421,
  [4449] = 4419,
  [4450] = 4416,
  [4451] = 4451,
  [4452] = 4452,
  [4453] = 4453,
  [4454] = 4423,
  [4455] = 4431,
  [4456] = 4456,
  [4457] = 4457,
  [4458] = 4458,
  [4459] = 4434,
  [4460] = 4458,
  [4461] = 4414,
  [4462] = 4434,
  [4463] = 4435,
  [4464] = 4464,
  [4465] = 4423,
  [4466] = 4445,
  [4467] = 4451,
  [4468] = 4424,
  [4469] = 4421,
  [4470] = 4419,
  [4471] = 4471,
  [4472] = 4453,
  [4473] = 4456,
  [4474] = 4436,
  [4475] = 4436,
  [4476] = 4435,
  [4477] = 4477,
  [4478] = 4478,
  [4479] = 4445,
  [4480] = 4456,
  [4481] = 4453,
  [4482] = 4451,
  [4483] = 4416,
  [4484] = 4431,
  [4485] = 4419,
  [4486] = 4423,
  [4487] = 4458,
  [4488] = 4457,
  [4489] = 4424,
  [4490] = 4421,
  [4491] = 4414,
  [4492] = 4421,
  [4493] = 4445,
  [4494] = 4436,
  [4495] = 4458,
  [4496] = 4435,
  [4497] = 4424,
  [4498] = 4414,
  [4499] = 4434,
  [4500] = 4423,
  [4501] = 4429,
  [4502] = 4502,
  [4503] = 4416,
  [4504] = 4434,
  [4505] = 4505,
  [4506] = 4435,
  [4507] = 4423,
  [4508] = 4457,
  [4509] = 4419,
  [4510] = 4424,
  [4511] = 4421,
  [4512] = 4419,
  [4513] = 4434,
  [4514] = 4429,
  [4515] = 4456,
  [4516] = 4453,
  [4517] = 4451,
  [4518] = 4421,
  [4519] = 4519,
  [4520] = 4520,
  [4521] = 4521,
  [4522] = 4424,
  [4523] = 4423,
  [4524] = 4429,
  [4525] = 4431,
  [4526] = 4416,
  [4527] = 4434,
  [4528] = 4423,
  [4529] = 4435,
  [4530] = 4429,
  [4531] = 4424,
  [4532] = 4421,
  [4533] = 4419,
  [4534] = 4436,
  [4535] = 4535,
  [4536] = 4445,
  [4537] = 4436,
  [4538] = 4538,
  [4539] = 4539,
  [4540] = 4540,
  [4541] = 4445,
  [4542] = 4542,
  [4543] = 4457,
  [4544] = 4458,
  [4545] = 4423,
  [4546] = 4546,
  [4547] = 4424,
  [4548] = 4421,
  [4549] = 4419,
  [4550] = 4456,
  [4551] = 4453,
  [4552] = 4451,
  [4553] = 4423,
  [4554] = 4419,
  [4555] = 2386,
  [4556] = 4457,
  [4557] = 4423,
  [4558] = 4419,
  [4559] = 4458,
  [4560] = 4416,
  [4561] = 4561,
  [4562] = 4431,
  [4563] = 4416,
  [4564] = 4456,
  [4565] = 4431,
  [4566] = 4419,
  [4567] = 4414,
  [4568] = 4568,
  [4569] = 4569,
  [4570] = 4570,
  [4571] = 4571,
  [4572] = 4434,
  [4573] = 4435,
  [4574] = 4436,
  [4575] = 4575,
  [4576] = 4445,
  [4577] = 4577,
  [4578] = 4578,
  [4579] = 4457,
  [4580] = 4580,
  [4581] = 4429,
  [4582] = 4458,
  [4583] = 4451,
  [4584] = 4453,
  [4585] = 4456,
  [4586] = 4418,
  [4587] = 4429,
  [4588] = 4419,
  [4589] = 4421,
  [4590] = 4590,
  [4591] = 4451,
  [4592] = 4424,
  [4593] = 4419,
  [4594] = 4453,
  [4595] = 4421,
  [4596] = 4424,
  [4597] = 4453,
  [4598] = 4451,
  [4599] = 4599,
  [4600] = 4414,
  [4601] = 4423,
  [4602] = 4414,
  [4603] = 4603,
  [4604] = 4458,
  [4605] = 4605,
  [4606] = 4414,
  [4607] = 4456,
  [4608] = 4457,
  [4609] = 4423,
  [4610] = 4457,
  [4611] = 4429,
  [4612] = 4445,
  [4613] = 4436,
  [4614] = 4451,
  [4615] = 4453,
  [4616] = 4456,
  [4617] = 4458,
  [4618] = 4435,
  [4619] = 4457,
  [4620] = 4431,
  [4621] = 4621,
  [4622] = 4458,
  [4623] = 4457,
  [4624] = 4445,
  [4625] = 4416,
  [4626] = 4626,
  [4627] = 4627,
  [4628] = 4445,
  [4629] = 4629,
  [4630] = 4436,
  [4631] = 4436,
  [4632] = 4435,
  [4633] = 4434,
  [4634] = 4429,
  [4635] = 4435,
  [4636] = 4636,
  [4637] = 4434,
  [4638] = 4434,
  [4639] = 4431,
  [4640] = 4416,
  [4641] = 4431,
  [4642] = 4434,
  [4643] = 4429,
  [4644] = 4644,
  [4645] = 4435,
  [4646] = 4603,
  [4647] = 4416,
  [4648] = 4436,
  [4649] = 4431,
  [4650] = 4456,
  [4651] = 4445,
  [4652] = 4429,
  [4653] = 4457,
  [4654] = 4458,
  [4655] = 4655,
  [4656] = 4656,
  [4657] = 4657,
  [4658] = 4658,
  [4659] = 4431,
  [4660] = 4456,
  [4661] = 4416,
  [4662] = 4429,
  [4663] = 4663,
  [4664] = 4434,
  [4665] = 4453,
  [4666] = 4451,
  [4667] = 4667,
  [4668] = 4435,
  [4669] = 4453,
  [4670] = 4451,
  [4671] = 4605,
  [4672] = 4672,
  [4673] = 4673,
  [4674] = 4436,
  [4675] = 4445,
  [4676] = 4435,
  [4677] = 4414,
  [4678] = 4457,
  [4679] = 4458,
  [4680] = 4429,
  [4681] = 4429,
  [4682] = 4590,
  [4683] = 4683,
  [4684] = 4429,
  [4685] = 4685,
  [4686] = 4686,
  [4687] = 4687,
  [4688] = 4456,
  [4689] = 4673,
  [4690] = 4453,
  [4691] = 4451,
  [4692] = 4435,
  [4693] = 4414,
  [4694] = 4694,
  [4695] = 4429,
  [4696] = 4429,
  [4697] = 4697,
  [4698] = 4698,
  [4699] = 4699,
  [4700] = 2374,
  [4701] = 4701,
  [4702] = 4416,
  [4703] = 4458,
  [4704] = 4704,
  [4705] = 4705,
  [4706] = 4414,
  [4707] = 4457,
  [4708] = 4451,
  [4709] = 4709,
  [4710] = 4453,
  [4711] = 4456,
  [4712] = 4435,
  [4713] = 4431,
  [4714] = 4714,
  [4715] = 4715,
  [4716] = 4716,
};

static TSCharacterRange sym_rune_literal_character_set_1[] = {
  {'"', '"'}, {'\'', '\''}, {'0', '7'}, {'U', 'U'}, {'\\', '\\'}, {'`', 'b'}, {'e', 'f'}, {'n', 'n'},
  {'r', 'r'}, {'t', 'v'}, {'x', 'x'},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(187);
      ADVANCE_MAP(
        '!', 266,
        '"', 341,
        '#', 394,
        '$', 339,
        '%', 239,
        '&', 276,
        '\'', 335,
        '(', 221,
        ')', 222,
        '*', 234,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 210,
        '/', 237,
        '0', 357,
        ':', 260,
        ';', 208,
        '<', 256,
        '=', 224,
        '>', 247,
        '?', 264,
        '@', 78,
        'C', 363,
        'J', 367,
        '[', 254,
        '\\', 21,
        ']', 258,
        '^', 274,
        '`', 114,
        'a', 380,
        'c', 360,
        'i', 373,
        'j', 381,
        'm', 369,
        'o', 378,
        'r', 361,
        '{', 218,
        '|', 387,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(183);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(329);
      if (('A' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(292);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 266,
        '"', 341,
        '#', 113,
        '$', 110,
        '%', 238,
        '&', 277,
        '\'', 335,
        '(', 221,
        ')', 222,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 212,
        '/', 236,
        '0', 324,
        ':', 259,
        ';', 208,
        '<', 241,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 79,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 273,
        '`', 114,
        'a', 380,
        'c', 360,
        'i', 373,
        'j', 381,
        'm', 369,
        'o', 378,
        'r', 361,
        '{', 218,
        '|', 270,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(3);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 266,
        '"', 341,
        '#', 113,
        '$', 110,
        '%', 238,
        '&', 277,
        '\'', 335,
        '(', 221,
        ')', 222,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 212,
        '/', 236,
        '0', 324,
        ':', 259,
        ';', 208,
        '<', 241,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 79,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 273,
        '`', 114,
        'a', 380,
        'c', 360,
        'i', 373,
        'j', 381,
        'm', 369,
        'o', 378,
        'r', 361,
        '{', 218,
        '|', 270,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(3);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 266,
        '"', 341,
        '#', 113,
        '$', 107,
        '%', 238,
        '&', 277,
        '\'', 335,
        '(', 221,
        ')', 222,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 212,
        '/', 236,
        '0', 324,
        ';', 208,
        '<', 241,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 79,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 273,
        '`', 114,
        'a', 380,
        'c', 360,
        'i', 373,
        'j', 381,
        'm', 369,
        'o', 378,
        'r', 361,
        '{', 218,
        '|', 270,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(5);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 266,
        '"', 341,
        '#', 113,
        '$', 107,
        '%', 238,
        '&', 277,
        '\'', 335,
        '(', 221,
        ')', 222,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 212,
        '/', 236,
        '0', 324,
        ';', 208,
        '<', 241,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 79,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 273,
        '`', 114,
        'a', 380,
        'c', 360,
        'i', 373,
        'j', 381,
        'm', 369,
        'o', 378,
        'r', 361,
        '{', 218,
        '|', 270,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(5);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 211,
        '/', 236,
        ';', 208,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 76,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 273,
        'a', 380,
        'i', 373,
        'm', 369,
        'o', 378,
        '{', 218,
        '|', 270,
        '}', 220,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(8);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 211,
        '/', 236,
        ';', 208,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 76,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 273,
        'a', 380,
        'i', 373,
        'o', 378,
        '{', 218,
        '|', 270,
        '}', 220,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(9);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 211,
        '/', 236,
        ';', 208,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 76,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 273,
        'a', 380,
        'i', 373,
        'm', 369,
        'o', 378,
        '{', 218,
        '|', 270,
        '}', 220,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(8);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 211,
        '/', 236,
        ';', 208,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 76,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 273,
        'a', 380,
        'i', 373,
        'o', 378,
        '{', 218,
        '|', 270,
        '}', 220,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(9);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 266,
        '#', 113,
        '$', 108,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 211,
        '/', 236,
        ';', 208,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 76,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 273,
        'a', 380,
        'i', 373,
        'o', 378,
        '|', 270,
        '}', 220,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(11);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 266,
        '#', 113,
        '$', 108,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 211,
        '/', 236,
        ';', 208,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 76,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 273,
        'a', 380,
        'i', 373,
        'o', 378,
        '|', 270,
        '}', 220,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(11);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 266,
        '#', 113,
        '$', 126,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 209,
        '/', 236,
        ';', 208,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '[', 254,
        '^', 273,
        'a', 135,
        'i', 132,
        'o', 134,
        '{', 218,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(13);
      END_STATE();
    case 13:
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 266,
        '#', 113,
        '$', 126,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 209,
        '/', 236,
        ';', 208,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '[', 271,
        '^', 273,
        'a', 135,
        'i', 132,
        'o', 134,
        '{', 218,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(13);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 265,
        '"', 341,
        '$', 110,
        '&', 275,
        '\'', 335,
        '(', 221,
        ')', 222,
        '*', 233,
        '+', 225,
        ',', 219,
        '-', 229,
        '.', 212,
        '/', 83,
        '0', 324,
        ';', 208,
        '<', 86,
        '?', 263,
        '@', 79,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 273,
        '`', 114,
        'c', 360,
        'j', 381,
        'm', 369,
        'r', 361,
        '{', 218,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(14);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 15:
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 265,
        '$', 111,
        '&', 275,
        '(', 221,
        '*', 233,
        '.', 209,
        '/', 83,
        '<', 255,
        '?', 263,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 254,
        'm', 369,
        '}', 220,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(16);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 16:
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 265,
        '$', 111,
        '&', 275,
        '(', 221,
        '*', 233,
        '.', 209,
        '/', 83,
        '?', 263,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 271,
        'm', 369,
        '}', 220,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(16);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 17:
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 265,
        '$', 111,
        '&', 275,
        '(', 221,
        '*', 233,
        '/', 83,
        ';', 208,
        '=', 223,
        '?', 263,
        '@', 76,
        'C', 363,
        'J', 367,
        '[', 271,
        'm', 369,
        '}', 220,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(17);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 18:
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '$', 111,
        ',', 219,
        '.', 89,
        '/', 83,
        ':', 259,
        ';', 208,
        '=', 223,
        '@', 76,
        'C', 363,
        'J', 367,
        '[', 271,
        '{', 218,
        '}', 220,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(18);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 19:
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '$', 111,
        '.', 209,
        '/', 83,
        ';', 208,
        '=', 223,
        '@', 76,
        'C', 363,
        'J', 367,
        '[', 254,
        '{', 218,
        '}', 220,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(20);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 20:
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '$', 111,
        '.', 209,
        '/', 83,
        ';', 208,
        '=', 223,
        '@', 76,
        'C', 363,
        'J', 367,
        '[', 271,
        '{', 218,
        '}', 220,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(20);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 21:
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead == 'U') ADVANCE(294);
      if (lookahead == 'u') ADVANCE(296);
      if (lookahead == 'x') ADVANCE(295);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(293);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          (lookahead < 0x0b || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(292);
      END_STATE();
    case 22:
      ADVANCE_MAP(
        '!', 266,
        '"', 341,
        '#', 113,
        '$', 110,
        '%', 238,
        '&', 277,
        '\'', 335,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 215,
        '/', 236,
        '0', 324,
        ':', 259,
        ';', 208,
        '<', 241,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 79,
        'C', 363,
        'J', 367,
        '[', 254,
        ']', 258,
        '^', 273,
        '`', 114,
        'a', 380,
        'c', 360,
        'i', 373,
        'j', 381,
        'm', 369,
        'o', 378,
        'r', 361,
        '{', 218,
        '|', 270,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(23);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 23:
      ADVANCE_MAP(
        '!', 266,
        '"', 341,
        '#', 113,
        '$', 110,
        '%', 238,
        '&', 277,
        '\'', 335,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 215,
        '/', 236,
        '0', 324,
        ':', 259,
        ';', 208,
        '<', 241,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 79,
        'C', 363,
        'J', 367,
        '[', 271,
        ']', 258,
        '^', 273,
        '`', 114,
        'a', 380,
        'c', 360,
        'i', 373,
        'j', 381,
        'm', 369,
        'o', 378,
        'r', 361,
        '{', 218,
        '|', 270,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(23);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 24:
      ADVANCE_MAP(
        '!', 266,
        '"', 341,
        '#', 113,
        '$', 107,
        '%', 238,
        '&', 277,
        '\'', 335,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 215,
        '/', 236,
        '0', 324,
        ':', 259,
        '<', 241,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 79,
        'C', 363,
        'J', 367,
        '[', 254,
        ']', 258,
        '^', 273,
        '`', 114,
        'a', 380,
        'c', 360,
        'i', 373,
        'j', 381,
        'm', 369,
        'o', 378,
        'r', 361,
        '{', 218,
        '|', 270,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(25);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 25:
      ADVANCE_MAP(
        '!', 266,
        '"', 341,
        '#', 113,
        '$', 107,
        '%', 238,
        '&', 277,
        '\'', 335,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 215,
        '/', 236,
        '0', 324,
        ':', 259,
        '<', 241,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 79,
        'C', 363,
        'J', 367,
        '[', 271,
        ']', 258,
        '^', 273,
        '`', 114,
        'a', 380,
        'c', 360,
        'i', 373,
        'j', 381,
        'm', 369,
        'o', 378,
        'r', 361,
        '{', 218,
        '|', 270,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(25);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 26:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 239,
        '&', 276,
        '(', 221,
        '*', 235,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 209,
        '/', 237,
        '0', 327,
        ':', 98,
        ';', 208,
        '<', 242,
        '=', 224,
        '>', 247,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 274,
        'a', 380,
        'i', 373,
        'm', 369,
        'o', 378,
        '{', 218,
        '|', 269,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(27);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(329);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 27:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 239,
        '&', 276,
        '(', 221,
        '*', 235,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 209,
        '/', 237,
        '0', 327,
        ':', 98,
        ';', 208,
        '<', 242,
        '=', 224,
        '>', 247,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 274,
        'a', 380,
        'i', 373,
        'm', 369,
        'o', 378,
        '{', 218,
        '|', 269,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(27);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(329);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 28:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 239,
        '&', 276,
        '(', 221,
        '*', 235,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 209,
        '/', 237,
        ':', 259,
        '<', 240,
        '=', 224,
        '>', 247,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 274,
        'a', 380,
        'i', 373,
        'm', 369,
        'o', 378,
        '{', 218,
        '|', 269,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(30);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 29:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 239,
        '&', 276,
        '(', 221,
        '*', 235,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 209,
        '/', 237,
        ':', 259,
        '<', 240,
        '=', 224,
        '>', 247,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 274,
        'a', 380,
        'i', 373,
        'o', 378,
        '{', 218,
        '|', 269,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(31);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 30:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 239,
        '&', 276,
        '(', 221,
        '*', 235,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 209,
        '/', 237,
        ':', 259,
        '<', 240,
        '=', 224,
        '>', 247,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 274,
        'a', 380,
        'i', 373,
        'm', 369,
        'o', 378,
        '{', 218,
        '|', 269,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(30);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 31:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 239,
        '&', 276,
        '(', 221,
        '*', 235,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 209,
        '/', 237,
        ':', 259,
        '<', 240,
        '=', 224,
        '>', 247,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 274,
        'a', 380,
        'i', 373,
        'o', 378,
        '{', 218,
        '|', 269,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(31);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 32:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 239,
        '&', 276,
        '(', 221,
        '*', 235,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 209,
        '/', 237,
        ':', 98,
        ';', 208,
        '<', 242,
        '=', 224,
        '>', 247,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 274,
        'a', 380,
        'i', 373,
        'o', 378,
        '{', 218,
        '|', 269,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(33);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 33:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 239,
        '&', 276,
        '(', 221,
        '*', 235,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 209,
        '/', 237,
        ':', 98,
        ';', 208,
        '<', 242,
        '=', 224,
        '>', 247,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 274,
        'a', 380,
        'i', 373,
        'o', 378,
        '{', 218,
        '|', 269,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(33);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 34:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 238,
        '&', 277,
        '(', 221,
        ')', 222,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 213,
        '/', 236,
        ':', 260,
        ';', 208,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 254,
        ']', 258,
        '^', 273,
        'a', 380,
        'i', 373,
        'm', 369,
        'o', 378,
        '{', 218,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 35:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 238,
        '&', 277,
        '(', 221,
        ')', 222,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 213,
        '/', 236,
        ':', 260,
        ';', 208,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 254,
        ']', 258,
        '^', 273,
        'a', 380,
        'i', 373,
        'o', 378,
        '{', 218,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(37);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 36:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 238,
        '&', 277,
        '(', 221,
        ')', 222,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 213,
        '/', 236,
        ':', 260,
        ';', 208,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 271,
        ']', 258,
        '^', 273,
        'a', 380,
        'i', 373,
        'm', 369,
        'o', 378,
        '{', 218,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 37:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 238,
        '&', 277,
        '(', 221,
        ')', 222,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 213,
        '/', 236,
        ':', 260,
        ';', 208,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 271,
        ']', 258,
        '^', 273,
        'a', 380,
        'i', 373,
        'o', 378,
        '{', 218,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(37);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 38:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 210,
        '/', 236,
        ':', 98,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 273,
        'a', 380,
        'i', 373,
        'm', 369,
        'o', 378,
        '{', 218,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(39);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 39:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 210,
        '/', 236,
        ':', 98,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 273,
        'a', 380,
        'i', 373,
        'm', 369,
        'o', 378,
        '{', 218,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(39);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 40:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 210,
        '/', 236,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 273,
        'a', 380,
        'i', 373,
        'o', 378,
        '{', 218,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(41);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 41:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 210,
        '/', 236,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 273,
        'a', 380,
        'i', 373,
        'o', 378,
        '{', 218,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(41);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 42:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        '-', 230,
        '.', 209,
        '/', 236,
        ':', 259,
        '<', 241,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 273,
        'a', 380,
        'i', 373,
        'o', 378,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(43);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 43:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 111,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        '-', 230,
        '.', 209,
        '/', 236,
        ':', 259,
        '<', 241,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 273,
        'a', 380,
        'i', 373,
        'o', 378,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(43);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 44:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 127,
        '%', 239,
        '&', 276,
        '(', 221,
        '*', 235,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 209,
        '/', 237,
        ':', 98,
        ';', 208,
        '<', 242,
        '=', 224,
        '>', 247,
        '?', 264,
        '[', 254,
        '^', 274,
        'a', 135,
        'i', 132,
        'o', 134,
        '{', 218,
        '|', 269,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(45);
      END_STATE();
    case 45:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 127,
        '%', 239,
        '&', 276,
        '(', 221,
        '*', 235,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 209,
        '/', 237,
        ':', 98,
        ';', 208,
        '<', 242,
        '=', 224,
        '>', 247,
        '?', 264,
        '[', 271,
        '^', 274,
        'a', 135,
        'i', 132,
        'o', 134,
        '{', 218,
        '|', 269,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(45);
      END_STATE();
    case 46:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 108,
        '%', 239,
        '&', 276,
        '(', 221,
        '*', 235,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 209,
        '/', 237,
        ':', 259,
        '<', 240,
        '=', 224,
        '>', 247,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 274,
        'a', 380,
        'i', 373,
        'o', 378,
        '{', 218,
        '|', 269,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(47);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 47:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 108,
        '%', 239,
        '&', 276,
        '(', 221,
        '*', 235,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 209,
        '/', 237,
        ':', 259,
        '<', 240,
        '=', 224,
        '>', 247,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 274,
        'a', 380,
        'i', 373,
        'o', 378,
        '{', 218,
        '|', 269,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(47);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 48:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 108,
        '%', 239,
        '&', 276,
        '(', 221,
        '*', 235,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 209,
        '/', 237,
        ':', 98,
        ';', 208,
        '<', 242,
        '=', 224,
        '>', 247,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 274,
        'a', 380,
        'i', 373,
        'o', 378,
        '{', 218,
        '|', 269,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 49:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 108,
        '%', 239,
        '&', 276,
        '(', 221,
        '*', 235,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 209,
        '/', 237,
        ':', 98,
        ';', 208,
        '<', 242,
        '=', 224,
        '>', 247,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 274,
        'a', 380,
        'i', 373,
        'o', 378,
        '{', 218,
        '|', 269,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 50:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 108,
        '%', 238,
        '&', 277,
        '(', 221,
        ')', 222,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 213,
        '/', 236,
        ':', 260,
        ';', 208,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 254,
        ']', 258,
        '^', 273,
        'a', 380,
        'i', 373,
        'o', 378,
        '{', 218,
        '|', 270,
        '}', 220,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(51);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 51:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 108,
        '%', 238,
        '&', 277,
        '(', 221,
        ')', 222,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 213,
        '/', 236,
        ':', 260,
        ';', 208,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 271,
        ']', 258,
        '^', 273,
        'a', 380,
        'i', 373,
        'o', 378,
        '{', 218,
        '|', 270,
        '}', 220,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(51);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 52:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 108,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 210,
        '/', 236,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 273,
        'a', 380,
        'i', 373,
        'o', 378,
        '{', 218,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(53);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 53:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 108,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 210,
        '/', 236,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 273,
        'a', 380,
        'i', 373,
        'o', 378,
        '{', 218,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(53);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 54:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 108,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        '-', 230,
        '.', 209,
        '/', 236,
        ':', 259,
        '<', 241,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 273,
        'a', 380,
        'i', 373,
        'o', 378,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(55);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 55:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 108,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        '-', 230,
        '.', 209,
        '/', 236,
        ':', 259,
        '<', 241,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 273,
        'a', 380,
        'i', 373,
        'o', 378,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(55);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 56:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 126,
        '%', 239,
        '&', 276,
        '(', 221,
        '*', 235,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 209,
        '/', 237,
        ':', 260,
        '<', 240,
        '=', 224,
        '>', 247,
        '?', 264,
        '[', 254,
        '^', 274,
        'a', 135,
        'i', 132,
        'o', 134,
        '{', 218,
        '|', 269,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(57);
      END_STATE();
    case 57:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 126,
        '%', 239,
        '&', 276,
        '(', 221,
        '*', 235,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 209,
        '/', 237,
        ':', 260,
        '<', 240,
        '=', 224,
        '>', 247,
        '?', 264,
        '[', 271,
        '^', 274,
        'a', 135,
        'i', 132,
        'o', 134,
        '{', 218,
        '|', 269,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(57);
      END_STATE();
    case 58:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 126,
        '%', 238,
        '&', 277,
        '(', 221,
        ')', 222,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 213,
        '/', 236,
        ':', 260,
        ';', 208,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '[', 254,
        ']', 258,
        '^', 273,
        'a', 135,
        'i', 132,
        'o', 134,
        '{', 218,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(59);
      END_STATE();
    case 59:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 126,
        '%', 238,
        '&', 277,
        '(', 221,
        ')', 222,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 213,
        '/', 236,
        ':', 260,
        ';', 208,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '[', 271,
        ']', 258,
        '^', 273,
        'a', 135,
        'i', 132,
        'o', 134,
        '{', 218,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(59);
      END_STATE();
    case 60:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 126,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 210,
        '/', 236,
        ':', 98,
        ';', 208,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '[', 254,
        ']', 258,
        '^', 273,
        'a', 135,
        'i', 132,
        'o', 134,
        '{', 218,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(61);
      END_STATE();
    case 61:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 126,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 210,
        '/', 236,
        ':', 98,
        ';', 208,
        '<', 243,
        '=', 99,
        '>', 248,
        '?', 264,
        '[', 271,
        ']', 258,
        '^', 273,
        'a', 135,
        'i', 132,
        'o', 134,
        '{', 218,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(61);
      END_STATE();
    case 62:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 126,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 209,
        '/', 236,
        ':', 259,
        '<', 241,
        '=', 99,
        '>', 248,
        '?', 264,
        '[', 254,
        '^', 273,
        'a', 135,
        'i', 132,
        'o', 134,
        '{', 218,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(63);
      END_STATE();
    case 63:
      ADVANCE_MAP(
        '!', 266,
        '#', 113,
        '$', 126,
        '%', 238,
        '&', 277,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 209,
        '/', 236,
        ':', 259,
        '<', 241,
        '=', 99,
        '>', 248,
        '?', 264,
        '[', 271,
        '^', 273,
        'a', 135,
        'i', 132,
        'o', 134,
        '{', 218,
        '|', 270,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(63);
      END_STATE();
    case 64:
      ADVANCE_MAP(
        '!', 265,
        '"', 341,
        '$', 110,
        '&', 275,
        '\'', 335,
        '(', 221,
        ')', 222,
        '*', 233,
        '+', 225,
        ',', 219,
        '-', 229,
        '.', 212,
        '/', 83,
        '0', 324,
        ':', 259,
        ';', 208,
        '<', 86,
        '?', 263,
        '@', 79,
        'C', 363,
        'J', 367,
        '[', 271,
        ']', 258,
        '^', 273,
        '`', 114,
        'c', 360,
        'j', 381,
        'm', 369,
        'r', 361,
        '{', 218,
        '|', 268,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(64);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 65:
      ADVANCE_MAP(
        '!', 265,
        '"', 341,
        '$', 110,
        '&', 275,
        '\'', 335,
        '(', 221,
        '*', 233,
        '+', 225,
        '-', 229,
        '.', 214,
        '/', 83,
        '0', 324,
        '<', 86,
        '?', 263,
        '@', 79,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 273,
        '`', 114,
        'c', 360,
        'j', 381,
        'm', 369,
        'r', 361,
        '{', 218,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(65);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 66:
      ADVANCE_MAP(
        '!', 265,
        '$', 111,
        '&', 275,
        '(', 221,
        ')', 222,
        '*', 233,
        ',', 219,
        '.', 211,
        '/', 83,
        '<', 255,
        '=', 223,
        '?', 263,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 254,
        'm', 369,
        '{', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(67);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 67:
      ADVANCE_MAP(
        '!', 265,
        '$', 111,
        '&', 275,
        '(', 221,
        ')', 222,
        '*', 233,
        ',', 219,
        '.', 211,
        '/', 83,
        '=', 223,
        '?', 263,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 271,
        'm', 369,
        '{', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(67);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 68:
      ADVANCE_MAP(
        '!', 265,
        '$', 111,
        '&', 275,
        '(', 221,
        ')', 222,
        '*', 233,
        ',', 219,
        '.', 89,
        '/', 83,
        '=', 223,
        '?', 263,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 271,
        ']', 258,
        'm', 369,
        '{', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(68);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 69:
      ADVANCE_MAP(
        '!', 96,
        '$', 111,
        '%', 238,
        '(', 221,
        ')', 222,
        '*', 233,
        '+', 225,
        '-', 229,
        '.', 211,
        '/', 236,
        '0', 327,
        ':', 259,
        '<', 244,
        '=', 99,
        '>', 246,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 271,
        ']', 258,
        '{', 218,
        '|', 268,
        '}', 220,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(69);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(329);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 70:
      ADVANCE_MAP(
        '!', 96,
        '$', 111,
        '%', 238,
        '(', 221,
        '*', 233,
        '+', 225,
        '-', 229,
        '/', 236,
        '<', 244,
        '=', 99,
        '>', 246,
        '@', 76,
        'C', 363,
        'J', 367,
        '[', 271,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(70);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 71:
      ADVANCE_MAP(
        '!', 96,
        '$', 82,
        '%', 238,
        '(', 221,
        ')', 222,
        '*', 233,
        '+', 225,
        '-', 229,
        '.', 211,
        '/', 236,
        '0', 327,
        ':', 259,
        '<', 257,
        '=', 99,
        '>', 246,
        '@', 77,
        'C', 363,
        'J', 367,
        '[', 254,
        ']', 258,
        '{', 218,
        '|', 268,
        '}', 220,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(69);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(329);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 72:
      ADVANCE_MAP(
        '"', 341,
        '$', 111,
        '\'', 335,
        '.', 147,
        '/', 83,
        '0', 324,
        '@', 77,
        'C', 363,
        'J', 367,
        '`', 114,
        'c', 360,
        'r', 361,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(72);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 73:
      if (lookahead == '"') ADVANCE(341);
      if (lookahead == '$') ADVANCE(340);
      if (lookahead == '/') ADVANCE(342);
      if (lookahead == '\\') ADVANCE(21);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(343);
      if (lookahead != 0) ADVANCE(344);
      END_STATE();
    case 74:
      if (lookahead == '"') ADVANCE(341);
      if (lookahead == '/') ADVANCE(352);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(353);
      if (lookahead != 0) ADVANCE(354);
      END_STATE();
    case 75:
      ADVANCE_MAP(
        '$', 111,
        '.', 209,
        '/', 83,
        '0', 357,
        '>', 245,
        '@', 77,
        'C', 363,
        'J', 367,
        ']', 258,
        '}', 220,
        '+', 356,
        '-', 356,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(75);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(329);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 76:
      if (lookahead == '$') ADVANCE(111);
      if (lookahead == 'C') ADVANCE(363);
      if (lookahead == 'J') ADVANCE(367);
      if (lookahead == '[') ADVANCE(402);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 77:
      if (lookahead == '$') ADVANCE(111);
      if (lookahead == 'C') ADVANCE(363);
      if (lookahead == 'J') ADVANCE(367);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 78:
      if (lookahead == '$') ADVANCE(111);
      if (lookahead == 'C') ADVANCE(362);
      if (lookahead == 'J') ADVANCE(366);
      if (lookahead == '[') ADVANCE(402);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(383);
      if (lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 79:
      if (lookahead == '$') ADVANCE(111);
      if (lookahead == 'C') ADVANCE(362);
      if (lookahead == 'J') ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(383);
      if (lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 80:
      if (lookahead == '$') ADVANCE(340);
      if (lookahead == '\'') ADVANCE(335);
      if (lookahead == '/') ADVANCE(336);
      if (lookahead == '\\') ADVANCE(21);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(337);
      if (lookahead != 0) ADVANCE(338);
      END_STATE();
    case 81:
      if (lookahead == '\'') ADVANCE(335);
      if (lookahead == '/') ADVANCE(348);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(349);
      if (lookahead != 0) ADVANCE(350);
      END_STATE();
    case 82:
      if (lookahead == '(') ADVANCE(298);
      if (lookahead == 'C') ADVANCE(363);
      if (lookahead == 'J') ADVANCE(367);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 83:
      if (lookahead == '*') ADVANCE(199);
      if (lookahead == '/') ADVANCE(196);
      END_STATE();
    case 84:
      if (lookahead == '*') ADVANCE(199);
      if (lookahead == '/') ADVANCE(196);
      if (lookahead == '=') ADVANCE(311);
      END_STATE();
    case 85:
      if (lookahead == '*') ADVANCE(202);
      if (lookahead == '/') ADVANCE(204);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(205);
      if (lookahead != 0) ADVANCE(206);
      END_STATE();
    case 86:
      if (lookahead == '-') ADVANCE(279);
      END_STATE();
    case 87:
      if (lookahead == '-') ADVANCE(279);
      if (lookahead == '<') ADVANCE(102);
      END_STATE();
    case 88:
      if (lookahead == '.') ADVANCE(253);
      END_STATE();
    case 89:
      if (lookahead == '.') ADVANCE(88);
      END_STATE();
    case 90:
      if (lookahead == '.') ADVANCE(147);
      if (lookahead == '_') ADVANCE(148);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(137);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(90);
      END_STATE();
    case 91:
      if (lookahead == '.') ADVANCE(154);
      if (lookahead == '_') ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(323);
      END_STATE();
    case 92:
      if (lookahead == '/') ADVANCE(83);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(92);
      END_STATE();
    case 93:
      if (lookahead == '/') ADVANCE(399);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(400);
      if (lookahead != 0 &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(401);
      END_STATE();
    case 94:
      if (lookahead == '/') ADVANCE(396);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(92);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(397);
      if (lookahead != 0 &&
          lookahead != '\\') ADVANCE(398);
      END_STATE();
    case 95:
      if (lookahead == '0') ADVANCE(120);
      if (lookahead == 'U') ADVANCE(167);
      if (lookahead == 'u') ADVANCE(160);
      if (lookahead == 'x') ADVANCE(156);
      if (('1' <= lookahead && lookahead <= '7')) ADVANCE(143);
      if (set_contains(sym_rune_literal_character_set_1, 11, lookahead)) ADVANCE(119);
      END_STATE();
    case 96:
      if (lookahead == '=') ADVANCE(250);
      END_STATE();
    case 97:
      if (lookahead == '=') ADVANCE(312);
      END_STATE();
    case 98:
      if (lookahead == '=') ADVANCE(322);
      END_STATE();
    case 99:
      if (lookahead == '=') ADVANCE(249);
      END_STATE();
    case 100:
      if (lookahead == '=') ADVANCE(320);
      END_STATE();
    case 101:
      if (lookahead == '=') ADVANCE(317);
      END_STATE();
    case 102:
      if (lookahead == '=') ADVANCE(313);
      END_STATE();
    case 103:
      if (lookahead == '=') ADVANCE(314);
      if (lookahead == '>') ADVANCE(104);
      END_STATE();
    case 104:
      if (lookahead == '=') ADVANCE(315);
      END_STATE();
    case 105:
      if (lookahead == '>') ADVANCE(103);
      END_STATE();
    case 106:
      if (lookahead == 'C') ADVANCE(363);
      if (lookahead == 'J') ADVANCE(367);
      if (lookahead == 'e') ADVANCE(372);
      if (lookahead == 'f') ADVANCE(376);
      if (lookahead == 'i') ADVANCE(371);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 107:
      if (lookahead == 'C') ADVANCE(363);
      if (lookahead == 'J') ADVANCE(367);
      if (lookahead == 'e') ADVANCE(372);
      if (lookahead == 'i') ADVANCE(371);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 108:
      if (lookahead == 'C') ADVANCE(363);
      if (lookahead == 'J') ADVANCE(367);
      if (lookahead == 'e') ADVANCE(372);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 109:
      if (lookahead == 'C') ADVANCE(363);
      if (lookahead == 'J') ADVANCE(367);
      if (lookahead == 'f') ADVANCE(376);
      if (lookahead == 'i') ADVANCE(371);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 110:
      if (lookahead == 'C') ADVANCE(363);
      if (lookahead == 'J') ADVANCE(367);
      if (lookahead == 'i') ADVANCE(371);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 111:
      if (lookahead == 'C') ADVANCE(363);
      if (lookahead == 'J') ADVANCE(367);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 112:
      if (lookahead == 'J') ADVANCE(367);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 113:
      if (lookahead == '[') ADVANCE(299);
      END_STATE();
    case 114:
      if (lookahead == '\\') ADVANCE(95);
      if (lookahead != 0) ADVANCE(119);
      END_STATE();
    case 115:
      if (lookahead == '_') ADVANCE(141);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(328);
      END_STATE();
    case 116:
      if (lookahead == '_') ADVANCE(139);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(330);
      END_STATE();
    case 117:
      if (lookahead == '_') ADVANCE(152);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(331);
      END_STATE();
    case 118:
      if (lookahead == '_') ADVANCE(154);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(137);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(118);
      END_STATE();
    case 119:
      if (lookahead == '`') ADVANCE(334);
      END_STATE();
    case 120:
      if (lookahead == '`') ADVANCE(334);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(142);
      END_STATE();
    case 121:
      if (lookahead == 'c') ADVANCE(133);
      END_STATE();
    case 122:
      if (lookahead == 'd') ADVANCE(124);
      END_STATE();
    case 123:
      if (lookahead == 'd') ADVANCE(125);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(267);
      END_STATE();
    case 126:
      if (lookahead == 'e') ADVANCE(130);
      END_STATE();
    case 127:
      if (lookahead == 'e') ADVANCE(130);
      if (lookahead == 'i') ADVANCE(129);
      END_STATE();
    case 128:
      if (lookahead == 'e') ADVANCE(302);
      END_STATE();
    case 129:
      if (lookahead == 'f') ADVANCE(300);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(136);
      END_STATE();
    case 131:
      if (lookahead == 'n') ADVANCE(309);
      if (lookahead == 's') ADVANCE(306);
      END_STATE();
    case 132:
      if (lookahead == 'n') ADVANCE(307);
      if (lookahead == 's') ADVANCE(304);
      END_STATE();
    case 133:
      if (lookahead == 'o') ADVANCE(123);
      END_STATE();
    case 134:
      if (lookahead == 'r') ADVANCE(290);
      END_STATE();
    case 135:
      if (lookahead == 's') ADVANCE(216);
      END_STATE();
    case 136:
      if (lookahead == 's') ADVANCE(128);
      END_STATE();
    case 137:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(149);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(333);
      END_STATE();
    case 138:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(137);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(118);
      END_STATE();
    case 139:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(330);
      END_STATE();
    case 140:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(90);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(325);
      END_STATE();
    case 141:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(328);
      END_STATE();
    case 142:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(119);
      END_STATE();
    case 143:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(142);
      END_STATE();
    case 144:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(329);
      END_STATE();
    case 145:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(292);
      END_STATE();
    case 146:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(326);
      END_STATE();
    case 147:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(332);
      END_STATE();
    case 148:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(90);
      END_STATE();
    case 149:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(333);
      END_STATE();
    case 150:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(292);
      END_STATE();
    case 151:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(119);
      END_STATE();
    case 152:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(331);
      END_STATE();
    case 153:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(323);
      END_STATE();
    case 154:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(118);
      END_STATE();
    case 155:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(150);
      END_STATE();
    case 156:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(151);
      END_STATE();
    case 157:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(156);
      END_STATE();
    case 158:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(155);
      END_STATE();
    case 159:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(158);
      END_STATE();
    case 160:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(157);
      END_STATE();
    case 161:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(160);
      END_STATE();
    case 162:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(159);
      END_STATE();
    case 163:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(162);
      END_STATE();
    case 164:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(161);
      END_STATE();
    case 165:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(163);
      END_STATE();
    case 166:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(164);
      END_STATE();
    case 167:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(166);
      END_STATE();
    case 168:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 169:
      if (eof) ADVANCE(187);
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 266,
        '"', 341,
        '#', 395,
        '$', 109,
        '%', 239,
        '&', 276,
        '\'', 335,
        '(', 221,
        '*', 235,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 215,
        '/', 237,
        '0', 324,
        ':', 260,
        ';', 208,
        '<', 240,
        '=', 224,
        '>', 247,
        '?', 264,
        '@', 78,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 274,
        '`', 114,
        'a', 380,
        'c', 360,
        'i', 373,
        'j', 381,
        'm', 369,
        'o', 378,
        'r', 361,
        '{', 218,
        '|', 269,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(170);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 170:
      if (eof) ADVANCE(187);
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 266,
        '"', 341,
        '#', 395,
        '$', 109,
        '%', 239,
        '&', 276,
        '\'', 335,
        '(', 221,
        '*', 235,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 215,
        '/', 237,
        '0', 324,
        ':', 260,
        ';', 208,
        '<', 240,
        '=', 224,
        '>', 247,
        '?', 264,
        '@', 78,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 274,
        '`', 114,
        'a', 380,
        'c', 360,
        'i', 373,
        'j', 381,
        'm', 369,
        'o', 378,
        'r', 361,
        '{', 218,
        '|', 269,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(170);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 171:
      if (eof) ADVANCE(187);
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 266,
        '"', 341,
        '#', 395,
        '$', 109,
        '%', 238,
        '&', 277,
        '\'', 335,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 215,
        '/', 236,
        '0', 324,
        ';', 208,
        '<', 241,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 78,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 273,
        '`', 114,
        'a', 380,
        'c', 360,
        'i', 373,
        'j', 381,
        'm', 369,
        'o', 378,
        'r', 361,
        '{', 218,
        '|', 270,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(172);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 172:
      if (eof) ADVANCE(187);
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 266,
        '"', 341,
        '#', 395,
        '$', 109,
        '%', 238,
        '&', 277,
        '\'', 335,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 215,
        '/', 236,
        '0', 324,
        ';', 208,
        '<', 241,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 78,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 273,
        '`', 114,
        'a', 380,
        'c', 360,
        'i', 373,
        'j', 381,
        'm', 369,
        'o', 378,
        'r', 361,
        '{', 218,
        '|', 270,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(172);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 173:
      if (eof) ADVANCE(187);
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 266,
        '"', 341,
        '#', 395,
        '$', 106,
        '%', 239,
        '&', 276,
        '\'', 335,
        '(', 221,
        '*', 235,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 215,
        '/', 237,
        '0', 324,
        ':', 260,
        ';', 208,
        '<', 240,
        '=', 224,
        '>', 247,
        '?', 264,
        '@', 78,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 274,
        '`', 114,
        'a', 380,
        'c', 360,
        'i', 373,
        'j', 381,
        'm', 369,
        'o', 378,
        'r', 361,
        '{', 218,
        '|', 269,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(174);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 174:
      if (eof) ADVANCE(187);
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 266,
        '"', 341,
        '#', 395,
        '$', 106,
        '%', 239,
        '&', 276,
        '\'', 335,
        '(', 221,
        '*', 235,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 215,
        '/', 237,
        '0', 324,
        ':', 260,
        ';', 208,
        '<', 240,
        '=', 224,
        '>', 247,
        '?', 264,
        '@', 78,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 274,
        '`', 114,
        'a', 380,
        'c', 360,
        'i', 373,
        'j', 381,
        'm', 369,
        'o', 378,
        'r', 361,
        '{', 218,
        '|', 269,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(174);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 175:
      if (eof) ADVANCE(187);
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 266,
        '"', 341,
        '#', 395,
        '$', 106,
        '%', 238,
        '&', 277,
        '\'', 335,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 215,
        '/', 236,
        '0', 324,
        ';', 208,
        '<', 241,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 78,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 273,
        '`', 114,
        'a', 380,
        'c', 360,
        'i', 373,
        'j', 381,
        'm', 369,
        'o', 378,
        'r', 361,
        '{', 218,
        '|', 270,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(176);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 176:
      if (eof) ADVANCE(187);
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 266,
        '"', 341,
        '#', 395,
        '$', 106,
        '%', 238,
        '&', 277,
        '\'', 335,
        '(', 221,
        '*', 233,
        '+', 226,
        ',', 219,
        '-', 230,
        '.', 215,
        '/', 236,
        '0', 324,
        ';', 208,
        '<', 241,
        '=', 99,
        '>', 248,
        '?', 264,
        '@', 78,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 273,
        '`', 114,
        'a', 380,
        'c', 360,
        'i', 373,
        'j', 381,
        'm', 369,
        'o', 378,
        'r', 361,
        '{', 218,
        '|', 270,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(176);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 177:
      if (eof) ADVANCE(187);
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 265,
        '"', 341,
        '#', 392,
        '$', 109,
        '%', 97,
        '&', 278,
        '\'', 335,
        '(', 221,
        '*', 235,
        '+', 228,
        ',', 219,
        '-', 232,
        '.', 215,
        '/', 84,
        '0', 324,
        ':', 98,
        ';', 208,
        '<', 87,
        '=', 223,
        '>', 105,
        '?', 263,
        '@', 78,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 274,
        '`', 114,
        'c', 360,
        'j', 381,
        'm', 369,
        'r', 361,
        '{', 218,
        '|', 100,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(177);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 178:
      if (eof) ADVANCE(187);
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 265,
        '"', 341,
        '#', 392,
        '$', 109,
        '&', 275,
        '\'', 335,
        '(', 221,
        '*', 233,
        '+', 225,
        ',', 219,
        '-', 229,
        '.', 215,
        '/', 83,
        '0', 324,
        ';', 208,
        '<', 86,
        '?', 263,
        '@', 78,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 273,
        '`', 114,
        'c', 360,
        'j', 381,
        'm', 369,
        'r', 361,
        '{', 218,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(178);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 179:
      if (eof) ADVANCE(187);
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 265,
        '"', 341,
        '#', 392,
        '$', 109,
        '&', 275,
        '\'', 335,
        '(', 221,
        '*', 233,
        '+', 225,
        '-', 229,
        '.', 215,
        '/', 83,
        '0', 324,
        '<', 86,
        '?', 263,
        '@', 78,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 273,
        '`', 114,
        'c', 360,
        'j', 381,
        'm', 369,
        'r', 361,
        '{', 218,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(180);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 180:
      if (eof) ADVANCE(187);
      ADVANCE_MAP(
        '\n', 188,
        '\r', 190,
        '!', 265,
        '"', 341,
        '#', 392,
        '$', 109,
        '&', 275,
        '\'', 335,
        '(', 221,
        '*', 233,
        '+', 225,
        '-', 229,
        '.', 215,
        '/', 83,
        '0', 324,
        '<', 86,
        '?', 263,
        '@', 78,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 273,
        '`', 114,
        'c', 360,
        'j', 381,
        'm', 369,
        'r', 361,
        '{', 218,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(180);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 181:
      if (eof) ADVANCE(187);
      ADVANCE_MAP(
        '\n', 189,
        '\r', 191,
        '!', 265,
        '"', 341,
        '#', 392,
        '$', 109,
        '&', 275,
        '\'', 335,
        '(', 221,
        '*', 233,
        '+', 225,
        '-', 229,
        '.', 215,
        '/', 83,
        '0', 324,
        '<', 86,
        '?', 263,
        '@', 78,
        'C', 363,
        'J', 367,
        '[', 254,
        '^', 273,
        '`', 114,
        'c', 360,
        'j', 381,
        'm', 369,
        'r', 361,
        '{', 218,
        '|', 386,
        '~', 272,
        '\t', 385,
        0x0b, 385,
        '\f', 385,
        ' ', 385,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 182:
      if (eof) ADVANCE(187);
      ADVANCE_MAP(
        '\n', 189,
        '\r', 191,
        '!', 265,
        '"', 341,
        '#', 392,
        '$', 109,
        '&', 275,
        '\'', 335,
        '(', 221,
        '*', 233,
        '+', 225,
        '-', 229,
        '.', 215,
        '/', 83,
        '0', 324,
        '<', 86,
        '?', 263,
        '@', 78,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 273,
        '`', 114,
        'c', 360,
        'j', 381,
        'm', 369,
        'r', 361,
        '{', 218,
        '|', 386,
        '~', 272,
        '\t', 385,
        0x0b, 385,
        '\f', 385,
        ' ', 385,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 183:
      if (eof) ADVANCE(187);
      ADVANCE_MAP(
        '!', 266,
        '"', 341,
        '#', 394,
        '$', 339,
        '%', 239,
        '&', 276,
        '\'', 335,
        '(', 221,
        ')', 222,
        '*', 234,
        '+', 227,
        ',', 219,
        '-', 231,
        '.', 210,
        '/', 237,
        '0', 357,
        ':', 260,
        ';', 208,
        '<', 240,
        '=', 224,
        '>', 247,
        '?', 264,
        '@', 78,
        'C', 363,
        'J', 367,
        '[', 271,
        '\\', 21,
        ']', 258,
        '^', 274,
        '`', 114,
        'a', 380,
        'c', 360,
        'i', 373,
        'j', 381,
        'm', 369,
        'o', 378,
        'r', 361,
        '{', 218,
        '|', 269,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(183);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(329);
      if (('A' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 184:
      if (eof) ADVANCE(187);
      ADVANCE_MAP(
        '!', 265,
        '"', 341,
        '#', 393,
        '$', 109,
        '&', 275,
        '\'', 335,
        '(', 221,
        '*', 233,
        '+', 225,
        ',', 219,
        '-', 229,
        '.', 215,
        '/', 83,
        '0', 324,
        ';', 208,
        '<', 86,
        '>', 245,
        '?', 263,
        '@', 78,
        'C', 363,
        'J', 367,
        '[', 271,
        ']', 258,
        '^', 273,
        '`', 114,
        'c', 360,
        'j', 381,
        'm', 369,
        'r', 361,
        '{', 218,
        '|', 268,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(184);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 185:
      if (eof) ADVANCE(187);
      ADVANCE_MAP(
        '!', 265,
        '"', 341,
        '#', 392,
        '$', 109,
        '&', 275,
        '\'', 335,
        '(', 221,
        '*', 233,
        '+', 225,
        '-', 229,
        '.', 215,
        '/', 83,
        '0', 324,
        '<', 86,
        '?', 263,
        '@', 78,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 273,
        '`', 114,
        'c', 360,
        'j', 381,
        'm', 369,
        'r', 361,
        '{', 218,
        '|', 386,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(186);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 186:
      if (eof) ADVANCE(187);
      ADVANCE_MAP(
        '!', 265,
        '"', 341,
        '#', 392,
        '$', 109,
        '&', 275,
        '\'', 335,
        '(', 221,
        '*', 233,
        '+', 225,
        '-', 229,
        '.', 215,
        '/', 83,
        '0', 324,
        '<', 86,
        '?', 263,
        '@', 78,
        'C', 363,
        'J', 367,
        '[', 271,
        '^', 273,
        '`', 114,
        'c', 360,
        'j', 381,
        'm', 369,
        'r', 361,
        '{', 218,
        '}', 220,
        '~', 272,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(186);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(188);
      if (lookahead == '\r') ADVANCE(190);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(189);
      if (lookahead == '\r') ADVANCE(191);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(385);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_CR);
      if (lookahead == '\n') ADVANCE(188);
      if (lookahead == '\r') ADVANCE(190);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_CR);
      if (lookahead == '\n') ADVANCE(189);
      if (lookahead == '\r') ADVANCE(191);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(385);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_POUND_BANG);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(aux_sym_shebang_token1);
      if (lookahead == '*') ADVANCE(201);
      if (lookahead == '/') ADVANCE(198);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(195);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(aux_sym_shebang_token1);
      if (lookahead == '/') ADVANCE(193);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(194);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(195);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(aux_sym_shebang_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(195);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '\\') ADVANCE(398);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(195);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_SLASH_STAR);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_SLASH_STAR);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '\\') ADVANCE(398);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_SLASH_STAR);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(195);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(aux_sym_block_comment_token1);
      if (lookahead == '/') ADVANCE(207);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(aux_sym_block_comment_token2);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(aux_sym_block_comment_token2);
      if (lookahead == '*') ADVANCE(199);
      if (lookahead == '/') ADVANCE(196);
      if (lookahead != 0) ADVANCE(203);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(aux_sym_block_comment_token2);
      if (lookahead == '/') ADVANCE(204);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(205);
      if (lookahead != 0 &&
          lookahead != '*') ADVANCE(206);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(aux_sym_block_comment_token2);
      if (lookahead == '/') ADVANCE(203);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_STAR_SLASH);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(391);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(88);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(88);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(332);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(390);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(390);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(332);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(332);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_as);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(249);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(261);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(261);
      if (lookahead == '=') ADVANCE(318);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(318);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(262);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(262);
      if (lookahead == '=') ADVANCE(319);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(319);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '/') ADVANCE(207);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(310);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(199);
      if (lookahead == '/') ADVANCE(196);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(199);
      if (lookahead == '/') ADVANCE(196);
      if (lookahead == '=') ADVANCE(311);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(312);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '-') ADVANCE(279);
      if (lookahead == '<') ADVANCE(281);
      if (lookahead == '=') ADVANCE(251);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '-') ADVANCE(279);
      if (lookahead == '<') ADVANCE(280);
      if (lookahead == '=') ADVANCE(251);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(281);
      if (lookahead == '=') ADVANCE(251);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(280);
      if (lookahead == '=') ADVANCE(251);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(251);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(252);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(252);
      if (lookahead == '>') ADVANCE(282);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(252);
      if (lookahead == '>') ADVANCE(283);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_LT2);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_LT2);
      if (lookahead == '-') ADVANCE(279);
      if (lookahead == '<') ADVANCE(281);
      if (lookahead == '=') ADVANCE(251);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_LT2);
      if (lookahead == '=') ADVANCE(251);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(322);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(297);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(250);
      if (lookahead == 'i') ADVANCE(131);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_json_DOTdecode);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(320);
      if (lookahead == '|') ADVANCE(289);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(289);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_LBRACK2);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(321);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(288);
      if (lookahead == '=') ADVANCE(316);
      if (lookahead == '^') ADVANCE(287);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(288);
      if (lookahead == '^') ADVANCE(286);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '=') ADVANCE(316);
      if (lookahead == '^') ADVANCE(101);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(313);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(314);
      if (lookahead == '>') ADVANCE(285);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(284);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(315);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_AMP_CARET);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_AMP_CARET);
      if (lookahead == '=') ADVANCE(317);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_or);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(145);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(165);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(150);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(158);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_POUND_LBRACK);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_DOLLARif);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_DOLLARif);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_DOLLARelse);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_DOLLARelse);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_is);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_BANGis);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_in);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_BANGin);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(anon_sym_AMP_CARET_EQ);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(138);
      if (lookahead == '_') ADVANCE(153);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(137);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(323);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(sym_int_literal);
      ADVANCE_MAP(
        '.', 147,
        '_', 140,
        'B', 116,
        'b', 116,
        'E', 137,
        'e', 137,
        'O', 115,
        'o', 115,
        'X', 91,
        'x', 91,
        '8', 90,
        '9', 90,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(325);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(147);
      if (lookahead == '_') ADVANCE(140);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(137);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(90);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(325);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(147);
      if (lookahead == '_') ADVANCE(146);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(137);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(326);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '_') ADVANCE(141);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(116);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(115);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(117);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(328);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '_') ADVANCE(141);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(328);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '_') ADVANCE(144);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(329);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '_') ADVANCE(139);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(330);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '_') ADVANCE(152);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(331);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == '_') ADVANCE(147);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(137);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(332);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == '_') ADVANCE(149);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(333);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(sym_rune_literal);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(aux_sym_interpreted_string_literal_token1);
      if (lookahead == '*') ADVANCE(338);
      if (lookahead == '/') ADVANCE(338);
      if (lookahead != 0 &&
          lookahead != '$' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(338);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(aux_sym_interpreted_string_literal_token1);
      if (lookahead == '/') ADVANCE(336);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(337);
      if (lookahead != 0 &&
          lookahead != '$' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(338);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(aux_sym_interpreted_string_literal_token1);
      if (lookahead != 0 &&
          lookahead != '$' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(338);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == 'C') ADVANCE(363);
      if (lookahead == 'J') ADVANCE(367);
      if (lookahead == '{') ADVANCE(355);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '{') ADVANCE(355);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(aux_sym_interpreted_string_literal_token2);
      if (lookahead == '*') ADVANCE(344);
      if (lookahead == '/') ADVANCE(344);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\') ADVANCE(344);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(aux_sym_interpreted_string_literal_token2);
      if (lookahead == '/') ADVANCE(342);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(343);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\') ADVANCE(344);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(aux_sym_interpreted_string_literal_token2);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\') ADVANCE(344);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_c_SQUOTE);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(anon_sym_c_DQUOTE);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(anon_sym_r_SQUOTE);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(aux_sym_raw_string_literal_token1);
      if (lookahead == '*') ADVANCE(350);
      if (lookahead == '/') ADVANCE(350);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(350);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(aux_sym_raw_string_literal_token1);
      if (lookahead == '/') ADVANCE(348);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(349);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(350);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(aux_sym_raw_string_literal_token1);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(350);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym_r_DQUOTE);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(aux_sym_raw_string_literal_token2);
      if (lookahead == '*') ADVANCE(354);
      if (lookahead == '/') ADVANCE(354);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(354);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(aux_sym_raw_string_literal_token2);
      if (lookahead == '/') ADVANCE(352);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(353);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(354);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(aux_sym_raw_string_literal_token2);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(354);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(aux_sym_format_specifier_token2);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead == '_') ADVANCE(141);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(116);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(115);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(117);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(328);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(sym_pseudo_compile_time_identifier);
      if (lookahead == '.') ADVANCE(168);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(359);
      if (('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(sym_pseudo_compile_time_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(359);
      if (('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(346);
      if (lookahead == '\'') ADVANCE(345);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(351);
      if (lookahead == '\'') ADVANCE(347);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(112);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(359);
      if (('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(112);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(168);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(122);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'S') ADVANCE(358);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(359);
      if (('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'S') ADVANCE(364);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '[') ADVANCE(388);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(377);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(303);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(301);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(382);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(308);
      if (lookahead == 's') ADVANCE(305);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(365);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(374);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(379);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p') ADVANCE(368);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(291);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(389);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(217);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(375);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(370);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(359);
      if (('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(aux_sym_sum_type_token1);
      if (lookahead == '\n') ADVANCE(189);
      if (lookahead == '\r') ADVANCE(191);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(385);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(anon_sym_PIPE2);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(anon_sym_PIPE2);
      if (lookahead == '=') ADVANCE(320);
      if (lookahead == '|') ADVANCE(289);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(anon_sym_map_LBRACK);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(anon_sym_DOLLARfor);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 0xb5 ||
          (0x391 <= lookahead && lookahead <= 0x3a9) ||
          (0x3b1 <= lookahead && lookahead <= 0x3c9)) ADVANCE(384);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(253);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == '!') ADVANCE(192);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == '!') ADVANCE(192);
      if (lookahead == '[') ADVANCE(299);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == '[') ADVANCE(299);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(aux_sym_hash_statement_token1);
      if (lookahead == '*') ADVANCE(200);
      if (lookahead == '/') ADVANCE(197);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '\\') ADVANCE(398);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(aux_sym_hash_statement_token1);
      if (lookahead == '/') ADVANCE(396);
      if (lookahead == '\t' ||
          lookahead == 0x0b ||
          lookahead == '\f' ||
          lookahead == ' ') ADVANCE(397);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '\\') ADVANCE(398);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(aux_sym_hash_statement_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '\\') ADVANCE(398);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(aux_sym__content_block_token1);
      if (lookahead == '*') ADVANCE(401);
      if (lookahead == '/') ADVANCE(401);
      if (lookahead != 0 &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(401);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(aux_sym__content_block_token1);
      if (lookahead == '/') ADVANCE(399);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(400);
      if (lookahead != 0 &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(401);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(aux_sym__content_block_token1);
      if (lookahead != 0 &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(401);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_AT_LBRACK);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        '_', 1,
        'a', 2,
        'b', 3,
        'c', 4,
        'd', 5,
        'e', 6,
        'f', 7,
        'g', 8,
        'i', 9,
        'l', 10,
        'm', 11,
        'n', 12,
        'p', 13,
        'r', 14,
        's', 15,
        't', 16,
        'u', 17,
        'v', 18,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      if (('E' <= lookahead && lookahead <= 'G') ||
          lookahead == 'S' ||
          lookahead == 'X' ||
          lookahead == 'o' ||
          lookahead == 'x') ADVANCE(19);
      END_STATE();
    case 1:
      if (lookahead == '_') ADVANCE(20);
      END_STATE();
    case 2:
      if (lookahead == 's') ADVANCE(21);
      if (lookahead == 't') ADVANCE(22);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == 'r') ADVANCE(23);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == 'h') ADVANCE(24);
      if (lookahead == 'o') ADVANCE(25);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == 'e') ADVANCE(26);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == 'l') ADVANCE(27);
      if (lookahead == 'n') ADVANCE(28);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == 'a') ADVANCE(29);
      if (lookahead == 'n') ADVANCE(30);
      if (lookahead == 'o') ADVANCE(31);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 9:
      if (lookahead == 'f') ADVANCE(33);
      if (lookahead == 'm') ADVANCE(34);
      if (lookahead == 'n') ADVANCE(35);
      END_STATE();
    case 10:
      if (lookahead == 'o') ADVANCE(36);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'u') ADVANCE(39);
      END_STATE();
    case 12:
      if (lookahead == 'i') ADVANCE(40);
      if (lookahead == 'o') ADVANCE(41);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == 'u') ADVANCE(42);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(43);
      if (lookahead == 'l') ADVANCE(44);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == 'e') ADVANCE(45);
      if (lookahead == 'h') ADVANCE(46);
      if (lookahead == 'p') ADVANCE(47);
      if (lookahead == 'q') ADVANCE(48);
      if (lookahead == 't') ADVANCE(49);
      END_STATE();
    case 16:
      if (lookahead == 'h') ADVANCE(50);
      if (lookahead == 'r') ADVANCE(51);
      if (lookahead == 'y') ADVANCE(52);
      END_STATE();
    case 17:
      if (lookahead == 'n') ADVANCE(53);
      END_STATE();
    case 18:
      if (lookahead == 'o') ADVANCE(54);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      END_STATE();
    case 20:
      if (lookahead == 'g') ADVANCE(55);
      END_STATE();
    case 21:
      if (lookahead == 'm') ADVANCE(56);
      if (lookahead == 's') ADVANCE(57);
      END_STATE();
    case 22:
      if (lookahead == 'o') ADVANCE(58);
      END_STATE();
    case 23:
      if (lookahead == 'e') ADVANCE(59);
      END_STATE();
    case 24:
      if (lookahead == 'a') ADVANCE(60);
      END_STATE();
    case 25:
      if (lookahead == 'n') ADVANCE(61);
      END_STATE();
    case 26:
      if (lookahead == 'f') ADVANCE(62);
      END_STATE();
    case 27:
      if (lookahead == 's') ADVANCE(63);
      END_STATE();
    case 28:
      if (lookahead == 'u') ADVANCE(64);
      END_STATE();
    case 29:
      if (lookahead == 'l') ADVANCE(65);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 31:
      if (lookahead == 'r') ADVANCE(66);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_go);
      if (lookahead == 't') ADVANCE(67);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 34:
      if (lookahead == 'p') ADVANCE(68);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(69);
      END_STATE();
    case 36:
      if (lookahead == 'c') ADVANCE(70);
      END_STATE();
    case 37:
      if (lookahead == 't') ADVANCE(71);
      END_STATE();
    case 38:
      if (lookahead == 'd') ADVANCE(72);
      END_STATE();
    case 39:
      if (lookahead == 't') ADVANCE(73);
      END_STATE();
    case 40:
      if (lookahead == 'l') ADVANCE(74);
      END_STATE();
    case 41:
      if (lookahead == 'n') ADVANCE(75);
      END_STATE();
    case 42:
      if (lookahead == 'b') ADVANCE(76);
      END_STATE();
    case 43:
      if (lookahead == 't') ADVANCE(77);
      END_STATE();
    case 44:
      if (lookahead == 'o') ADVANCE(78);
      END_STATE();
    case 45:
      if (lookahead == 'l') ADVANCE(79);
      END_STATE();
    case 46:
      if (lookahead == 'a') ADVANCE(80);
      END_STATE();
    case 47:
      if (lookahead == 'a') ADVANCE(81);
      END_STATE();
    case 48:
      if (lookahead == 'l') ADVANCE(82);
      END_STATE();
    case 49:
      if (lookahead == 'a') ADVANCE(83);
      if (lookahead == 'r') ADVANCE(84);
      END_STATE();
    case 50:
      if (lookahead == 'r') ADVANCE(85);
      END_STATE();
    case 51:
      if (lookahead == 'u') ADVANCE(86);
      END_STATE();
    case 52:
      if (lookahead == 'p') ADVANCE(87);
      END_STATE();
    case 53:
      if (lookahead == 'i') ADVANCE(88);
      if (lookahead == 's') ADVANCE(89);
      END_STATE();
    case 54:
      if (lookahead == 'l') ADVANCE(90);
      END_STATE();
    case 55:
      if (lookahead == 'l') ADVANCE(91);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_asm);
      END_STATE();
    case 57:
      if (lookahead == 'e') ADVANCE(92);
      END_STATE();
    case 58:
      if (lookahead == 'm') ADVANCE(93);
      END_STATE();
    case 59:
      if (lookahead == 'a') ADVANCE(94);
      END_STATE();
    case 60:
      if (lookahead == 'n') ADVANCE(95);
      END_STATE();
    case 61:
      if (lookahead == 's') ADVANCE(96);
      if (lookahead == 't') ADVANCE(97);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(98);
      END_STATE();
    case 63:
      if (lookahead == 'e') ADVANCE(99);
      END_STATE();
    case 64:
      if (lookahead == 'm') ADVANCE(100);
      END_STATE();
    case 65:
      if (lookahead == 's') ADVANCE(101);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 67:
      if (lookahead == 'o') ADVANCE(102);
      END_STATE();
    case 68:
      if (lookahead == 'o') ADVANCE(103);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(104);
      END_STATE();
    case 70:
      if (lookahead == 'k') ADVANCE(105);
      END_STATE();
    case 71:
      if (lookahead == 'c') ADVANCE(106);
      END_STATE();
    case 72:
      if (lookahead == 'u') ADVANCE(107);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_mut);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_nil);
      END_STATE();
    case 75:
      if (lookahead == 'e') ADVANCE(108);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_pub);
      END_STATE();
    case 77:
      if (lookahead == 'u') ADVANCE(109);
      END_STATE();
    case 78:
      if (lookahead == 'c') ADVANCE(110);
      END_STATE();
    case 79:
      if (lookahead == 'e') ADVANCE(111);
      END_STATE();
    case 80:
      if (lookahead == 'r') ADVANCE(112);
      END_STATE();
    case 81:
      if (lookahead == 'w') ADVANCE(113);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_sql);
      END_STATE();
    case 83:
      if (lookahead == 't') ADVANCE(114);
      END_STATE();
    case 84:
      if (lookahead == 'u') ADVANCE(115);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(116);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(117);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(118);
      END_STATE();
    case 88:
      if (lookahead == 'o') ADVANCE(119);
      END_STATE();
    case 89:
      if (lookahead == 'a') ADVANCE(120);
      END_STATE();
    case 90:
      if (lookahead == 'a') ADVANCE(121);
      END_STATE();
    case 91:
      if (lookahead == 'o') ADVANCE(122);
      END_STATE();
    case 92:
      if (lookahead == 'r') ADVANCE(123);
      END_STATE();
    case 93:
      if (lookahead == 'i') ADVANCE(124);
      END_STATE();
    case 94:
      if (lookahead == 'k') ADVANCE(125);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_chan);
      END_STATE();
    case 96:
      if (lookahead == 't') ADVANCE(126);
      END_STATE();
    case 97:
      if (lookahead == 'i') ADVANCE(127);
      END_STATE();
    case 98:
      if (lookahead == 'r') ADVANCE(128);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 101:
      if (lookahead == 'e') ADVANCE(129);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 103:
      if (lookahead == 'r') ADVANCE(130);
      END_STATE();
    case 104:
      if (lookahead == 'r') ADVANCE(131);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_lock);
      END_STATE();
    case 106:
      if (lookahead == 'h') ADVANCE(132);
      END_STATE();
    case 107:
      if (lookahead == 'l') ADVANCE(133);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_none);
      END_STATE();
    case 109:
      if (lookahead == 'r') ADVANCE(134);
      END_STATE();
    case 110:
      if (lookahead == 'k') ADVANCE(135);
      END_STATE();
    case 111:
      if (lookahead == 'c') ADVANCE(136);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(137);
      END_STATE();
    case 113:
      if (lookahead == 'n') ADVANCE(138);
      END_STATE();
    case 114:
      if (lookahead == 'i') ADVANCE(139);
      END_STATE();
    case 115:
      if (lookahead == 'c') ADVANCE(140);
      END_STATE();
    case 116:
      if (lookahead == 'a') ADVANCE(141);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 119:
      if (lookahead == 'n') ADVANCE(142);
      END_STATE();
    case 120:
      if (lookahead == 'f') ADVANCE(143);
      END_STATE();
    case 121:
      if (lookahead == 't') ADVANCE(144);
      END_STATE();
    case 122:
      if (lookahead == 'b') ADVANCE(145);
      END_STATE();
    case 123:
      if (lookahead == 't') ADVANCE(146);
      END_STATE();
    case 124:
      if (lookahead == 'c') ADVANCE(147);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 127:
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_defer);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 130:
      if (lookahead == 't') ADVANCE(149);
      END_STATE();
    case 131:
      if (lookahead == 'f') ADVANCE(150);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 133:
      if (lookahead == 'e') ADVANCE(151);
      END_STATE();
    case 134:
      if (lookahead == 'n') ADVANCE(152);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_rlock);
      END_STATE();
    case 136:
      if (lookahead == 't') ADVANCE(153);
      END_STATE();
    case 137:
      if (lookahead == 'd') ADVANCE(154);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_spawn);
      END_STATE();
    case 139:
      if (lookahead == 'c') ADVANCE(155);
      END_STATE();
    case 140:
      if (lookahead == 't') ADVANCE(156);
      END_STATE();
    case 141:
      if (lookahead == 'd') ADVANCE(157);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 143:
      if (lookahead == 'e') ADVANCE(158);
      END_STATE();
    case 144:
      if (lookahead == 'i') ADVANCE(159);
      END_STATE();
    case 145:
      if (lookahead == 'a') ADVANCE(160);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_atomic);
      END_STATE();
    case 148:
      if (lookahead == 'u') ADVANCE(161);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 150:
      if (lookahead == 'a') ADVANCE(162);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_select);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_shared);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_thread);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_unsafe);
      END_STATE();
    case 159:
      if (lookahead == 'l') ADVANCE(163);
      END_STATE();
    case 160:
      if (lookahead == 'l') ADVANCE(164);
      END_STATE();
    case 161:
      if (lookahead == 'e') ADVANCE(165);
      END_STATE();
    case 162:
      if (lookahead == 'c') ADVANCE(166);
      END_STATE();
    case 163:
      if (lookahead == 'e') ADVANCE(167);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym___global);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 166:
      if (lookahead == 'e') ADVANCE(168);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 184},
  [2] = {.lex_state = 185},
  [3] = {.lex_state = 185},
  [4] = {.lex_state = 185},
  [5] = {.lex_state = 185},
  [6] = {.lex_state = 185},
  [7] = {.lex_state = 185},
  [8] = {.lex_state = 185},
  [9] = {.lex_state = 185},
  [10] = {.lex_state = 185},
  [11] = {.lex_state = 185},
  [12] = {.lex_state = 185},
  [13] = {.lex_state = 178},
  [14] = {.lex_state = 178},
  [15] = {.lex_state = 185},
  [16] = {.lex_state = 185},
  [17] = {.lex_state = 185},
  [18] = {.lex_state = 185},
  [19] = {.lex_state = 185},
  [20] = {.lex_state = 185},
  [21] = {.lex_state = 185},
  [22] = {.lex_state = 185},
  [23] = {.lex_state = 185},
  [24] = {.lex_state = 185},
  [25] = {.lex_state = 185},
  [26] = {.lex_state = 185},
  [27] = {.lex_state = 185},
  [28] = {.lex_state = 185},
  [29] = {.lex_state = 185},
  [30] = {.lex_state = 185},
  [31] = {.lex_state = 185},
  [32] = {.lex_state = 185},
  [33] = {.lex_state = 185},
  [34] = {.lex_state = 185},
  [35] = {.lex_state = 185},
  [36] = {.lex_state = 185},
  [37] = {.lex_state = 185},
  [38] = {.lex_state = 185},
  [39] = {.lex_state = 185},
  [40] = {.lex_state = 185},
  [41] = {.lex_state = 185},
  [42] = {.lex_state = 185},
  [43] = {.lex_state = 185},
  [44] = {.lex_state = 185},
  [45] = {.lex_state = 185},
  [46] = {.lex_state = 185},
  [47] = {.lex_state = 185},
  [48] = {.lex_state = 185},
  [49] = {.lex_state = 185},
  [50] = {.lex_state = 185},
  [51] = {.lex_state = 185},
  [52] = {.lex_state = 185},
  [53] = {.lex_state = 185},
  [54] = {.lex_state = 185},
  [55] = {.lex_state = 185},
  [56] = {.lex_state = 185},
  [57] = {.lex_state = 185},
  [58] = {.lex_state = 185},
  [59] = {.lex_state = 185},
  [60] = {.lex_state = 185},
  [61] = {.lex_state = 185},
  [62] = {.lex_state = 185},
  [63] = {.lex_state = 185},
  [64] = {.lex_state = 185},
  [65] = {.lex_state = 185},
  [66] = {.lex_state = 185},
  [67] = {.lex_state = 185},
  [68] = {.lex_state = 185},
  [69] = {.lex_state = 185},
  [70] = {.lex_state = 185},
  [71] = {.lex_state = 185},
  [72] = {.lex_state = 185},
  [73] = {.lex_state = 185},
  [74] = {.lex_state = 185},
  [75] = {.lex_state = 185},
  [76] = {.lex_state = 185},
  [77] = {.lex_state = 185},
  [78] = {.lex_state = 185},
  [79] = {.lex_state = 185},
  [80] = {.lex_state = 185},
  [81] = {.lex_state = 185},
  [82] = {.lex_state = 185},
  [83] = {.lex_state = 185},
  [84] = {.lex_state = 185},
  [85] = {.lex_state = 185},
  [86] = {.lex_state = 185},
  [87] = {.lex_state = 185},
  [88] = {.lex_state = 185},
  [89] = {.lex_state = 178},
  [90] = {.lex_state = 169},
  [91] = {.lex_state = 169},
  [92] = {.lex_state = 169},
  [93] = {.lex_state = 169},
  [94] = {.lex_state = 169},
  [95] = {.lex_state = 178},
  [96] = {.lex_state = 64},
  [97] = {.lex_state = 64},
  [98] = {.lex_state = 64},
  [99] = {.lex_state = 169},
  [100] = {.lex_state = 64},
  [101] = {.lex_state = 169},
  [102] = {.lex_state = 64},
  [103] = {.lex_state = 64},
  [104] = {.lex_state = 169},
  [105] = {.lex_state = 64},
  [106] = {.lex_state = 64},
  [107] = {.lex_state = 169},
  [108] = {.lex_state = 64},
  [109] = {.lex_state = 64},
  [110] = {.lex_state = 64},
  [111] = {.lex_state = 169},
  [112] = {.lex_state = 64},
  [113] = {.lex_state = 64},
  [114] = {.lex_state = 64},
  [115] = {.lex_state = 64},
  [116] = {.lex_state = 64},
  [117] = {.lex_state = 64},
  [118] = {.lex_state = 64},
  [119] = {.lex_state = 64},
  [120] = {.lex_state = 64},
  [121] = {.lex_state = 64},
  [122] = {.lex_state = 64},
  [123] = {.lex_state = 64},
  [124] = {.lex_state = 64},
  [125] = {.lex_state = 64},
  [126] = {.lex_state = 64},
  [127] = {.lex_state = 64},
  [128] = {.lex_state = 64},
  [129] = {.lex_state = 64},
  [130] = {.lex_state = 64},
  [131] = {.lex_state = 64},
  [132] = {.lex_state = 64},
  [133] = {.lex_state = 64},
  [134] = {.lex_state = 64},
  [135] = {.lex_state = 64},
  [136] = {.lex_state = 64},
  [137] = {.lex_state = 64},
  [138] = {.lex_state = 64},
  [139] = {.lex_state = 64},
  [140] = {.lex_state = 64},
  [141] = {.lex_state = 64},
  [142] = {.lex_state = 64},
  [143] = {.lex_state = 64},
  [144] = {.lex_state = 64},
  [145] = {.lex_state = 64},
  [146] = {.lex_state = 64},
  [147] = {.lex_state = 64},
  [148] = {.lex_state = 64},
  [149] = {.lex_state = 64},
  [150] = {.lex_state = 64},
  [151] = {.lex_state = 64},
  [152] = {.lex_state = 64},
  [153] = {.lex_state = 64},
  [154] = {.lex_state = 64},
  [155] = {.lex_state = 64},
  [156] = {.lex_state = 64},
  [157] = {.lex_state = 64},
  [158] = {.lex_state = 64},
  [159] = {.lex_state = 64},
  [160] = {.lex_state = 64},
  [161] = {.lex_state = 64},
  [162] = {.lex_state = 64},
  [163] = {.lex_state = 64},
  [164] = {.lex_state = 64},
  [165] = {.lex_state = 64},
  [166] = {.lex_state = 64},
  [167] = {.lex_state = 64},
  [168] = {.lex_state = 64},
  [169] = {.lex_state = 64},
  [170] = {.lex_state = 64},
  [171] = {.lex_state = 64},
  [172] = {.lex_state = 64},
  [173] = {.lex_state = 64},
  [174] = {.lex_state = 64},
  [175] = {.lex_state = 64},
  [176] = {.lex_state = 64},
  [177] = {.lex_state = 64},
  [178] = {.lex_state = 64},
  [179] = {.lex_state = 64},
  [180] = {.lex_state = 64},
  [181] = {.lex_state = 64},
  [182] = {.lex_state = 64},
  [183] = {.lex_state = 64},
  [184] = {.lex_state = 64},
  [185] = {.lex_state = 64},
  [186] = {.lex_state = 64},
  [187] = {.lex_state = 64},
  [188] = {.lex_state = 64},
  [189] = {.lex_state = 64},
  [190] = {.lex_state = 64},
  [191] = {.lex_state = 64},
  [192] = {.lex_state = 64},
  [193] = {.lex_state = 64},
  [194] = {.lex_state = 64},
  [195] = {.lex_state = 64},
  [196] = {.lex_state = 64},
  [197] = {.lex_state = 64},
  [198] = {.lex_state = 64},
  [199] = {.lex_state = 64},
  [200] = {.lex_state = 64},
  [201] = {.lex_state = 64},
  [202] = {.lex_state = 64},
  [203] = {.lex_state = 64},
  [204] = {.lex_state = 64},
  [205] = {.lex_state = 64},
  [206] = {.lex_state = 64},
  [207] = {.lex_state = 64},
  [208] = {.lex_state = 64},
  [209] = {.lex_state = 64},
  [210] = {.lex_state = 64},
  [211] = {.lex_state = 64},
  [212] = {.lex_state = 64},
  [213] = {.lex_state = 64},
  [214] = {.lex_state = 64},
  [215] = {.lex_state = 64},
  [216] = {.lex_state = 64},
  [217] = {.lex_state = 171},
  [218] = {.lex_state = 64},
  [219] = {.lex_state = 64},
  [220] = {.lex_state = 64},
  [221] = {.lex_state = 64},
  [222] = {.lex_state = 64},
  [223] = {.lex_state = 171},
  [224] = {.lex_state = 64},
  [225] = {.lex_state = 64},
  [226] = {.lex_state = 64},
  [227] = {.lex_state = 171},
  [228] = {.lex_state = 64},
  [229] = {.lex_state = 64},
  [230] = {.lex_state = 171},
  [231] = {.lex_state = 64},
  [232] = {.lex_state = 64},
  [233] = {.lex_state = 64},
  [234] = {.lex_state = 64},
  [235] = {.lex_state = 65},
  [236] = {.lex_state = 171},
  [237] = {.lex_state = 64},
  [238] = {.lex_state = 64},
  [239] = {.lex_state = 64},
  [240] = {.lex_state = 64},
  [241] = {.lex_state = 64},
  [242] = {.lex_state = 169},
  [243] = {.lex_state = 64},
  [244] = {.lex_state = 169},
  [245] = {.lex_state = 169},
  [246] = {.lex_state = 169},
  [247] = {.lex_state = 169},
  [248] = {.lex_state = 169},
  [249] = {.lex_state = 169},
  [250] = {.lex_state = 169},
  [251] = {.lex_state = 169},
  [252] = {.lex_state = 169},
  [253] = {.lex_state = 169},
  [254] = {.lex_state = 169},
  [255] = {.lex_state = 169},
  [256] = {.lex_state = 169},
  [257] = {.lex_state = 169},
  [258] = {.lex_state = 169},
  [259] = {.lex_state = 173},
  [260] = {.lex_state = 64},
  [261] = {.lex_state = 173},
  [262] = {.lex_state = 64},
  [263] = {.lex_state = 64},
  [264] = {.lex_state = 64},
  [265] = {.lex_state = 64},
  [266] = {.lex_state = 64},
  [267] = {.lex_state = 64},
  [268] = {.lex_state = 64},
  [269] = {.lex_state = 64},
  [270] = {.lex_state = 64},
  [271] = {.lex_state = 173},
  [272] = {.lex_state = 64},
  [273] = {.lex_state = 64},
  [274] = {.lex_state = 64},
  [275] = {.lex_state = 64},
  [276] = {.lex_state = 64},
  [277] = {.lex_state = 64},
  [278] = {.lex_state = 64},
  [279] = {.lex_state = 64},
  [280] = {.lex_state = 64},
  [281] = {.lex_state = 169},
  [282] = {.lex_state = 64},
  [283] = {.lex_state = 64},
  [284] = {.lex_state = 64},
  [285] = {.lex_state = 64},
  [286] = {.lex_state = 64},
  [287] = {.lex_state = 64},
  [288] = {.lex_state = 169},
  [289] = {.lex_state = 64},
  [290] = {.lex_state = 169},
  [291] = {.lex_state = 169},
  [292] = {.lex_state = 64},
  [293] = {.lex_state = 64},
  [294] = {.lex_state = 64},
  [295] = {.lex_state = 64},
  [296] = {.lex_state = 64},
  [297] = {.lex_state = 64},
  [298] = {.lex_state = 64},
  [299] = {.lex_state = 64},
  [300] = {.lex_state = 64},
  [301] = {.lex_state = 64},
  [302] = {.lex_state = 64},
  [303] = {.lex_state = 64},
  [304] = {.lex_state = 64},
  [305] = {.lex_state = 64},
  [306] = {.lex_state = 64},
  [307] = {.lex_state = 64},
  [308] = {.lex_state = 64},
  [309] = {.lex_state = 64},
  [310] = {.lex_state = 64},
  [311] = {.lex_state = 64},
  [312] = {.lex_state = 173},
  [313] = {.lex_state = 169},
  [314] = {.lex_state = 64},
  [315] = {.lex_state = 64},
  [316] = {.lex_state = 64},
  [317] = {.lex_state = 64},
  [318] = {.lex_state = 64},
  [319] = {.lex_state = 64},
  [320] = {.lex_state = 64},
  [321] = {.lex_state = 64},
  [322] = {.lex_state = 64},
  [323] = {.lex_state = 64},
  [324] = {.lex_state = 64},
  [325] = {.lex_state = 64},
  [326] = {.lex_state = 64},
  [327] = {.lex_state = 64},
  [328] = {.lex_state = 64},
  [329] = {.lex_state = 64},
  [330] = {.lex_state = 64},
  [331] = {.lex_state = 64},
  [332] = {.lex_state = 64},
  [333] = {.lex_state = 169},
  [334] = {.lex_state = 169},
  [335] = {.lex_state = 64},
  [336] = {.lex_state = 169},
  [337] = {.lex_state = 65},
  [338] = {.lex_state = 65},
  [339] = {.lex_state = 65},
  [340] = {.lex_state = 64},
  [341] = {.lex_state = 169},
  [342] = {.lex_state = 169},
  [343] = {.lex_state = 64},
  [344] = {.lex_state = 64},
  [345] = {.lex_state = 64},
  [346] = {.lex_state = 64},
  [347] = {.lex_state = 65},
  [348] = {.lex_state = 169},
  [349] = {.lex_state = 64},
  [350] = {.lex_state = 65},
  [351] = {.lex_state = 169},
  [352] = {.lex_state = 64},
  [353] = {.lex_state = 64},
  [354] = {.lex_state = 65},
  [355] = {.lex_state = 65},
  [356] = {.lex_state = 64},
  [357] = {.lex_state = 169},
  [358] = {.lex_state = 169},
  [359] = {.lex_state = 169},
  [360] = {.lex_state = 169},
  [361] = {.lex_state = 64},
  [362] = {.lex_state = 65},
  [363] = {.lex_state = 65},
  [364] = {.lex_state = 65},
  [365] = {.lex_state = 65},
  [366] = {.lex_state = 64},
  [367] = {.lex_state = 169},
  [368] = {.lex_state = 64},
  [369] = {.lex_state = 65},
  [370] = {.lex_state = 169},
  [371] = {.lex_state = 64},
  [372] = {.lex_state = 64},
  [373] = {.lex_state = 64},
  [374] = {.lex_state = 64},
  [375] = {.lex_state = 64},
  [376] = {.lex_state = 65},
  [377] = {.lex_state = 65},
  [378] = {.lex_state = 65},
  [379] = {.lex_state = 169},
  [380] = {.lex_state = 169},
  [381] = {.lex_state = 64},
  [382] = {.lex_state = 64},
  [383] = {.lex_state = 169},
  [384] = {.lex_state = 64},
  [385] = {.lex_state = 64},
  [386] = {.lex_state = 169},
  [387] = {.lex_state = 169},
  [388] = {.lex_state = 169},
  [389] = {.lex_state = 169},
  [390] = {.lex_state = 169},
  [391] = {.lex_state = 64},
  [392] = {.lex_state = 64},
  [393] = {.lex_state = 64},
  [394] = {.lex_state = 64},
  [395] = {.lex_state = 169},
  [396] = {.lex_state = 64},
  [397] = {.lex_state = 64},
  [398] = {.lex_state = 65},
  [399] = {.lex_state = 65},
  [400] = {.lex_state = 65},
  [401] = {.lex_state = 169},
  [402] = {.lex_state = 64},
  [403] = {.lex_state = 169},
  [404] = {.lex_state = 169},
  [405] = {.lex_state = 169},
  [406] = {.lex_state = 64},
  [407] = {.lex_state = 169},
  [408] = {.lex_state = 169},
  [409] = {.lex_state = 169},
  [410] = {.lex_state = 65},
  [411] = {.lex_state = 64},
  [412] = {.lex_state = 169},
  [413] = {.lex_state = 169},
  [414] = {.lex_state = 169},
  [415] = {.lex_state = 64},
  [416] = {.lex_state = 64},
  [417] = {.lex_state = 64},
  [418] = {.lex_state = 64},
  [419] = {.lex_state = 64},
  [420] = {.lex_state = 64},
  [421] = {.lex_state = 169},
  [422] = {.lex_state = 64},
  [423] = {.lex_state = 64},
  [424] = {.lex_state = 169},
  [425] = {.lex_state = 169},
  [426] = {.lex_state = 169},
  [427] = {.lex_state = 169},
  [428] = {.lex_state = 169},
  [429] = {.lex_state = 169},
  [430] = {.lex_state = 64},
  [431] = {.lex_state = 169},
  [432] = {.lex_state = 65},
  [433] = {.lex_state = 65},
  [434] = {.lex_state = 169},
  [435] = {.lex_state = 169},
  [436] = {.lex_state = 169},
  [437] = {.lex_state = 64},
  [438] = {.lex_state = 169},
  [439] = {.lex_state = 64},
  [440] = {.lex_state = 64},
  [441] = {.lex_state = 169},
  [442] = {.lex_state = 169},
  [443] = {.lex_state = 169},
  [444] = {.lex_state = 64},
  [445] = {.lex_state = 169},
  [446] = {.lex_state = 169},
  [447] = {.lex_state = 169},
  [448] = {.lex_state = 169},
  [449] = {.lex_state = 64},
  [450] = {.lex_state = 169},
  [451] = {.lex_state = 64},
  [452] = {.lex_state = 169},
  [453] = {.lex_state = 169},
  [454] = {.lex_state = 169},
  [455] = {.lex_state = 169},
  [456] = {.lex_state = 169},
  [457] = {.lex_state = 169},
  [458] = {.lex_state = 65},
  [459] = {.lex_state = 64},
  [460] = {.lex_state = 169},
  [461] = {.lex_state = 169},
  [462] = {.lex_state = 64},
  [463] = {.lex_state = 169},
  [464] = {.lex_state = 64},
  [465] = {.lex_state = 64},
  [466] = {.lex_state = 169},
  [467] = {.lex_state = 169},
  [468] = {.lex_state = 169},
  [469] = {.lex_state = 169},
  [470] = {.lex_state = 169},
  [471] = {.lex_state = 169},
  [472] = {.lex_state = 64},
  [473] = {.lex_state = 169},
  [474] = {.lex_state = 169},
  [475] = {.lex_state = 169},
  [476] = {.lex_state = 64},
  [477] = {.lex_state = 169},
  [478] = {.lex_state = 64},
  [479] = {.lex_state = 169},
  [480] = {.lex_state = 169},
  [481] = {.lex_state = 169},
  [482] = {.lex_state = 169},
  [483] = {.lex_state = 169},
  [484] = {.lex_state = 169},
  [485] = {.lex_state = 169},
  [486] = {.lex_state = 64},
  [487] = {.lex_state = 64},
  [488] = {.lex_state = 64},
  [489] = {.lex_state = 64},
  [490] = {.lex_state = 169},
  [491] = {.lex_state = 64},
  [492] = {.lex_state = 64},
  [493] = {.lex_state = 169},
  [494] = {.lex_state = 169},
  [495] = {.lex_state = 64},
  [496] = {.lex_state = 65},
  [497] = {.lex_state = 169},
  [498] = {.lex_state = 64},
  [499] = {.lex_state = 169},
  [500] = {.lex_state = 65},
  [501] = {.lex_state = 169},
  [502] = {.lex_state = 169},
  [503] = {.lex_state = 169},
  [504] = {.lex_state = 64},
  [505] = {.lex_state = 169},
  [506] = {.lex_state = 169},
  [507] = {.lex_state = 64},
  [508] = {.lex_state = 169},
  [509] = {.lex_state = 64},
  [510] = {.lex_state = 169},
  [511] = {.lex_state = 169},
  [512] = {.lex_state = 169},
  [513] = {.lex_state = 169},
  [514] = {.lex_state = 169},
  [515] = {.lex_state = 169},
  [516] = {.lex_state = 64},
  [517] = {.lex_state = 169},
  [518] = {.lex_state = 64},
  [519] = {.lex_state = 169},
  [520] = {.lex_state = 169},
  [521] = {.lex_state = 64},
  [522] = {.lex_state = 169},
  [523] = {.lex_state = 169},
  [524] = {.lex_state = 169},
  [525] = {.lex_state = 64},
  [526] = {.lex_state = 169},
  [527] = {.lex_state = 64},
  [528] = {.lex_state = 169},
  [529] = {.lex_state = 169},
  [530] = {.lex_state = 64},
  [531] = {.lex_state = 169},
  [532] = {.lex_state = 64},
  [533] = {.lex_state = 64},
  [534] = {.lex_state = 64},
  [535] = {.lex_state = 64},
  [536] = {.lex_state = 64},
  [537] = {.lex_state = 64},
  [538] = {.lex_state = 64},
  [539] = {.lex_state = 64},
  [540] = {.lex_state = 64},
  [541] = {.lex_state = 64},
  [542] = {.lex_state = 171},
  [543] = {.lex_state = 64},
  [544] = {.lex_state = 171},
  [545] = {.lex_state = 64},
  [546] = {.lex_state = 64},
  [547] = {.lex_state = 171},
  [548] = {.lex_state = 171},
  [549] = {.lex_state = 64},
  [550] = {.lex_state = 64},
  [551] = {.lex_state = 64},
  [552] = {.lex_state = 64},
  [553] = {.lex_state = 64},
  [554] = {.lex_state = 64},
  [555] = {.lex_state = 64},
  [556] = {.lex_state = 64},
  [557] = {.lex_state = 64},
  [558] = {.lex_state = 64},
  [559] = {.lex_state = 64},
  [560] = {.lex_state = 64},
  [561] = {.lex_state = 64},
  [562] = {.lex_state = 64},
  [563] = {.lex_state = 64},
  [564] = {.lex_state = 64},
  [565] = {.lex_state = 64},
  [566] = {.lex_state = 171},
  [567] = {.lex_state = 64},
  [568] = {.lex_state = 64},
  [569] = {.lex_state = 64},
  [570] = {.lex_state = 64},
  [571] = {.lex_state = 64},
  [572] = {.lex_state = 64},
  [573] = {.lex_state = 64},
  [574] = {.lex_state = 64},
  [575] = {.lex_state = 64},
  [576] = {.lex_state = 64},
  [577] = {.lex_state = 64},
  [578] = {.lex_state = 64},
  [579] = {.lex_state = 64},
  [580] = {.lex_state = 64},
  [581] = {.lex_state = 64},
  [582] = {.lex_state = 64},
  [583] = {.lex_state = 64},
  [584] = {.lex_state = 64},
  [585] = {.lex_state = 64},
  [586] = {.lex_state = 64},
  [587] = {.lex_state = 64},
  [588] = {.lex_state = 64},
  [589] = {.lex_state = 64},
  [590] = {.lex_state = 64},
  [591] = {.lex_state = 64},
  [592] = {.lex_state = 64},
  [593] = {.lex_state = 64},
  [594] = {.lex_state = 64},
  [595] = {.lex_state = 64},
  [596] = {.lex_state = 64},
  [597] = {.lex_state = 64},
  [598] = {.lex_state = 64},
  [599] = {.lex_state = 64},
  [600] = {.lex_state = 64},
  [601] = {.lex_state = 64},
  [602] = {.lex_state = 64},
  [603] = {.lex_state = 64},
  [604] = {.lex_state = 64},
  [605] = {.lex_state = 64},
  [606] = {.lex_state = 64},
  [607] = {.lex_state = 64},
  [608] = {.lex_state = 64},
  [609] = {.lex_state = 64},
  [610] = {.lex_state = 64},
  [611] = {.lex_state = 64},
  [612] = {.lex_state = 64},
  [613] = {.lex_state = 64},
  [614] = {.lex_state = 64},
  [615] = {.lex_state = 64},
  [616] = {.lex_state = 64},
  [617] = {.lex_state = 64},
  [618] = {.lex_state = 64},
  [619] = {.lex_state = 64},
  [620] = {.lex_state = 64},
  [621] = {.lex_state = 64},
  [622] = {.lex_state = 64},
  [623] = {.lex_state = 64},
  [624] = {.lex_state = 64},
  [625] = {.lex_state = 64},
  [626] = {.lex_state = 64},
  [627] = {.lex_state = 64},
  [628] = {.lex_state = 64},
  [629] = {.lex_state = 64},
  [630] = {.lex_state = 64},
  [631] = {.lex_state = 64},
  [632] = {.lex_state = 64},
  [633] = {.lex_state = 64},
  [634] = {.lex_state = 64},
  [635] = {.lex_state = 64},
  [636] = {.lex_state = 64},
  [637] = {.lex_state = 64},
  [638] = {.lex_state = 64},
  [639] = {.lex_state = 64},
  [640] = {.lex_state = 64},
  [641] = {.lex_state = 64},
  [642] = {.lex_state = 64},
  [643] = {.lex_state = 64},
  [644] = {.lex_state = 64},
  [645] = {.lex_state = 64},
  [646] = {.lex_state = 64},
  [647] = {.lex_state = 64},
  [648] = {.lex_state = 64},
  [649] = {.lex_state = 64},
  [650] = {.lex_state = 64},
  [651] = {.lex_state = 64},
  [652] = {.lex_state = 64},
  [653] = {.lex_state = 64},
  [654] = {.lex_state = 64},
  [655] = {.lex_state = 64},
  [656] = {.lex_state = 64},
  [657] = {.lex_state = 64},
  [658] = {.lex_state = 64},
  [659] = {.lex_state = 64},
  [660] = {.lex_state = 64},
  [661] = {.lex_state = 64},
  [662] = {.lex_state = 64},
  [663] = {.lex_state = 64},
  [664] = {.lex_state = 64},
  [665] = {.lex_state = 64},
  [666] = {.lex_state = 64},
  [667] = {.lex_state = 64},
  [668] = {.lex_state = 64},
  [669] = {.lex_state = 64},
  [670] = {.lex_state = 64},
  [671] = {.lex_state = 64},
  [672] = {.lex_state = 64},
  [673] = {.lex_state = 64},
  [674] = {.lex_state = 64},
  [675] = {.lex_state = 64},
  [676] = {.lex_state = 64},
  [677] = {.lex_state = 64},
  [678] = {.lex_state = 64},
  [679] = {.lex_state = 64},
  [680] = {.lex_state = 64},
  [681] = {.lex_state = 64},
  [682] = {.lex_state = 64},
  [683] = {.lex_state = 64},
  [684] = {.lex_state = 64},
  [685] = {.lex_state = 64},
  [686] = {.lex_state = 64},
  [687] = {.lex_state = 64},
  [688] = {.lex_state = 64},
  [689] = {.lex_state = 64},
  [690] = {.lex_state = 64},
  [691] = {.lex_state = 64},
  [692] = {.lex_state = 64},
  [693] = {.lex_state = 64},
  [694] = {.lex_state = 64},
  [695] = {.lex_state = 64},
  [696] = {.lex_state = 64},
  [697] = {.lex_state = 64},
  [698] = {.lex_state = 64},
  [699] = {.lex_state = 64},
  [700] = {.lex_state = 64},
  [701] = {.lex_state = 64},
  [702] = {.lex_state = 64},
  [703] = {.lex_state = 64},
  [704] = {.lex_state = 64},
  [705] = {.lex_state = 64},
  [706] = {.lex_state = 64},
  [707] = {.lex_state = 64},
  [708] = {.lex_state = 64},
  [709] = {.lex_state = 64},
  [710] = {.lex_state = 64},
  [711] = {.lex_state = 64},
  [712] = {.lex_state = 64},
  [713] = {.lex_state = 64},
  [714] = {.lex_state = 64},
  [715] = {.lex_state = 64},
  [716] = {.lex_state = 64},
  [717] = {.lex_state = 64},
  [718] = {.lex_state = 64},
  [719] = {.lex_state = 64},
  [720] = {.lex_state = 64},
  [721] = {.lex_state = 64},
  [722] = {.lex_state = 64},
  [723] = {.lex_state = 64},
  [724] = {.lex_state = 64},
  [725] = {.lex_state = 64},
  [726] = {.lex_state = 64},
  [727] = {.lex_state = 64},
  [728] = {.lex_state = 64},
  [729] = {.lex_state = 64},
  [730] = {.lex_state = 64},
  [731] = {.lex_state = 64},
  [732] = {.lex_state = 64},
  [733] = {.lex_state = 64},
  [734] = {.lex_state = 64},
  [735] = {.lex_state = 64},
  [736] = {.lex_state = 64},
  [737] = {.lex_state = 64},
  [738] = {.lex_state = 64},
  [739] = {.lex_state = 64},
  [740] = {.lex_state = 64},
  [741] = {.lex_state = 64},
  [742] = {.lex_state = 64},
  [743] = {.lex_state = 64},
  [744] = {.lex_state = 64},
  [745] = {.lex_state = 64},
  [746] = {.lex_state = 64},
  [747] = {.lex_state = 64},
  [748] = {.lex_state = 64},
  [749] = {.lex_state = 64},
  [750] = {.lex_state = 64},
  [751] = {.lex_state = 64},
  [752] = {.lex_state = 64},
  [753] = {.lex_state = 64},
  [754] = {.lex_state = 64},
  [755] = {.lex_state = 64},
  [756] = {.lex_state = 64},
  [757] = {.lex_state = 64},
  [758] = {.lex_state = 64},
  [759] = {.lex_state = 64},
  [760] = {.lex_state = 64},
  [761] = {.lex_state = 64},
  [762] = {.lex_state = 64},
  [763] = {.lex_state = 64},
  [764] = {.lex_state = 64},
  [765] = {.lex_state = 64},
  [766] = {.lex_state = 64},
  [767] = {.lex_state = 64},
  [768] = {.lex_state = 64},
  [769] = {.lex_state = 64},
  [770] = {.lex_state = 64},
  [771] = {.lex_state = 64},
  [772] = {.lex_state = 64},
  [773] = {.lex_state = 64},
  [774] = {.lex_state = 64},
  [775] = {.lex_state = 64},
  [776] = {.lex_state = 64},
  [777] = {.lex_state = 64},
  [778] = {.lex_state = 64},
  [779] = {.lex_state = 64},
  [780] = {.lex_state = 64},
  [781] = {.lex_state = 64},
  [782] = {.lex_state = 64},
  [783] = {.lex_state = 64},
  [784] = {.lex_state = 64},
  [785] = {.lex_state = 64},
  [786] = {.lex_state = 64},
  [787] = {.lex_state = 64},
  [788] = {.lex_state = 64},
  [789] = {.lex_state = 64},
  [790] = {.lex_state = 64},
  [791] = {.lex_state = 64},
  [792] = {.lex_state = 64},
  [793] = {.lex_state = 64},
  [794] = {.lex_state = 64},
  [795] = {.lex_state = 64},
  [796] = {.lex_state = 64},
  [797] = {.lex_state = 64},
  [798] = {.lex_state = 64},
  [799] = {.lex_state = 64},
  [800] = {.lex_state = 64},
  [801] = {.lex_state = 64},
  [802] = {.lex_state = 64},
  [803] = {.lex_state = 64},
  [804] = {.lex_state = 64},
  [805] = {.lex_state = 64},
  [806] = {.lex_state = 64},
  [807] = {.lex_state = 64},
  [808] = {.lex_state = 64},
  [809] = {.lex_state = 64},
  [810] = {.lex_state = 64},
  [811] = {.lex_state = 64},
  [812] = {.lex_state = 64},
  [813] = {.lex_state = 64},
  [814] = {.lex_state = 64},
  [815] = {.lex_state = 64},
  [816] = {.lex_state = 64},
  [817] = {.lex_state = 64},
  [818] = {.lex_state = 64},
  [819] = {.lex_state = 64},
  [820] = {.lex_state = 64},
  [821] = {.lex_state = 64},
  [822] = {.lex_state = 64},
  [823] = {.lex_state = 64},
  [824] = {.lex_state = 64},
  [825] = {.lex_state = 64},
  [826] = {.lex_state = 64},
  [827] = {.lex_state = 64},
  [828] = {.lex_state = 64},
  [829] = {.lex_state = 64},
  [830] = {.lex_state = 64},
  [831] = {.lex_state = 64},
  [832] = {.lex_state = 64},
  [833] = {.lex_state = 64},
  [834] = {.lex_state = 64},
  [835] = {.lex_state = 64},
  [836] = {.lex_state = 64},
  [837] = {.lex_state = 64},
  [838] = {.lex_state = 64},
  [839] = {.lex_state = 64},
  [840] = {.lex_state = 64},
  [841] = {.lex_state = 64},
  [842] = {.lex_state = 64},
  [843] = {.lex_state = 64},
  [844] = {.lex_state = 64},
  [845] = {.lex_state = 64},
  [846] = {.lex_state = 64},
  [847] = {.lex_state = 64},
  [848] = {.lex_state = 64},
  [849] = {.lex_state = 64},
  [850] = {.lex_state = 64},
  [851] = {.lex_state = 64},
  [852] = {.lex_state = 64},
  [853] = {.lex_state = 64},
  [854] = {.lex_state = 64},
  [855] = {.lex_state = 64},
  [856] = {.lex_state = 64},
  [857] = {.lex_state = 64},
  [858] = {.lex_state = 64},
  [859] = {.lex_state = 64},
  [860] = {.lex_state = 64},
  [861] = {.lex_state = 64},
  [862] = {.lex_state = 64},
  [863] = {.lex_state = 64},
  [864] = {.lex_state = 64},
  [865] = {.lex_state = 64},
  [866] = {.lex_state = 64},
  [867] = {.lex_state = 64},
  [868] = {.lex_state = 64},
  [869] = {.lex_state = 64},
  [870] = {.lex_state = 64},
  [871] = {.lex_state = 64},
  [872] = {.lex_state = 64},
  [873] = {.lex_state = 64},
  [874] = {.lex_state = 64},
  [875] = {.lex_state = 64},
  [876] = {.lex_state = 64},
  [877] = {.lex_state = 64},
  [878] = {.lex_state = 64},
  [879] = {.lex_state = 64},
  [880] = {.lex_state = 64},
  [881] = {.lex_state = 64},
  [882] = {.lex_state = 64},
  [883] = {.lex_state = 64},
  [884] = {.lex_state = 64},
  [885] = {.lex_state = 64},
  [886] = {.lex_state = 64},
  [887] = {.lex_state = 64},
  [888] = {.lex_state = 64},
  [889] = {.lex_state = 64},
  [890] = {.lex_state = 64},
  [891] = {.lex_state = 64},
  [892] = {.lex_state = 64},
  [893] = {.lex_state = 64},
  [894] = {.lex_state = 169},
  [895] = {.lex_state = 64},
  [896] = {.lex_state = 64},
  [897] = {.lex_state = 64},
  [898] = {.lex_state = 64},
  [899] = {.lex_state = 64},
  [900] = {.lex_state = 64},
  [901] = {.lex_state = 64},
  [902] = {.lex_state = 64},
  [903] = {.lex_state = 64},
  [904] = {.lex_state = 64},
  [905] = {.lex_state = 64},
  [906] = {.lex_state = 64},
  [907] = {.lex_state = 64},
  [908] = {.lex_state = 64},
  [909] = {.lex_state = 64},
  [910] = {.lex_state = 64},
  [911] = {.lex_state = 64},
  [912] = {.lex_state = 64},
  [913] = {.lex_state = 64},
  [914] = {.lex_state = 64},
  [915] = {.lex_state = 64},
  [916] = {.lex_state = 64},
  [917] = {.lex_state = 64},
  [918] = {.lex_state = 64},
  [919] = {.lex_state = 64},
  [920] = {.lex_state = 64},
  [921] = {.lex_state = 64},
  [922] = {.lex_state = 64},
  [923] = {.lex_state = 64},
  [924] = {.lex_state = 64},
  [925] = {.lex_state = 64},
  [926] = {.lex_state = 64},
  [927] = {.lex_state = 64},
  [928] = {.lex_state = 64},
  [929] = {.lex_state = 64},
  [930] = {.lex_state = 64},
  [931] = {.lex_state = 64},
  [932] = {.lex_state = 64},
  [933] = {.lex_state = 64},
  [934] = {.lex_state = 64},
  [935] = {.lex_state = 64},
  [936] = {.lex_state = 64},
  [937] = {.lex_state = 64},
  [938] = {.lex_state = 64},
  [939] = {.lex_state = 64},
  [940] = {.lex_state = 64},
  [941] = {.lex_state = 64},
  [942] = {.lex_state = 64},
  [943] = {.lex_state = 64},
  [944] = {.lex_state = 64},
  [945] = {.lex_state = 64},
  [946] = {.lex_state = 64},
  [947] = {.lex_state = 64},
  [948] = {.lex_state = 64},
  [949] = {.lex_state = 64},
  [950] = {.lex_state = 64},
  [951] = {.lex_state = 64},
  [952] = {.lex_state = 64},
  [953] = {.lex_state = 64},
  [954] = {.lex_state = 64},
  [955] = {.lex_state = 64},
  [956] = {.lex_state = 64},
  [957] = {.lex_state = 64},
  [958] = {.lex_state = 64},
  [959] = {.lex_state = 64},
  [960] = {.lex_state = 64},
  [961] = {.lex_state = 64},
  [962] = {.lex_state = 64},
  [963] = {.lex_state = 64},
  [964] = {.lex_state = 64},
  [965] = {.lex_state = 64},
  [966] = {.lex_state = 64},
  [967] = {.lex_state = 64},
  [968] = {.lex_state = 64},
  [969] = {.lex_state = 64},
  [970] = {.lex_state = 64},
  [971] = {.lex_state = 64},
  [972] = {.lex_state = 64},
  [973] = {.lex_state = 64},
  [974] = {.lex_state = 64},
  [975] = {.lex_state = 64},
  [976] = {.lex_state = 64},
  [977] = {.lex_state = 64},
  [978] = {.lex_state = 64},
  [979] = {.lex_state = 64},
  [980] = {.lex_state = 64},
  [981] = {.lex_state = 64},
  [982] = {.lex_state = 169},
  [983] = {.lex_state = 169},
  [984] = {.lex_state = 169},
  [985] = {.lex_state = 169},
  [986] = {.lex_state = 169},
  [987] = {.lex_state = 169},
  [988] = {.lex_state = 169},
  [989] = {.lex_state = 169},
  [990] = {.lex_state = 169},
  [991] = {.lex_state = 169},
  [992] = {.lex_state = 169},
  [993] = {.lex_state = 169},
  [994] = {.lex_state = 169},
  [995] = {.lex_state = 169},
  [996] = {.lex_state = 169},
  [997] = {.lex_state = 169},
  [998] = {.lex_state = 173},
  [999] = {.lex_state = 173},
  [1000] = {.lex_state = 169},
  [1001] = {.lex_state = 173},
  [1002] = {.lex_state = 173},
  [1003] = {.lex_state = 169},
  [1004] = {.lex_state = 169},
  [1005] = {.lex_state = 169},
  [1006] = {.lex_state = 169},
  [1007] = {.lex_state = 169},
  [1008] = {.lex_state = 169},
  [1009] = {.lex_state = 169},
  [1010] = {.lex_state = 169},
  [1011] = {.lex_state = 169},
  [1012] = {.lex_state = 169},
  [1013] = {.lex_state = 169},
  [1014] = {.lex_state = 169},
  [1015] = {.lex_state = 169},
  [1016] = {.lex_state = 169},
  [1017] = {.lex_state = 169},
  [1018] = {.lex_state = 169},
  [1019] = {.lex_state = 169},
  [1020] = {.lex_state = 169},
  [1021] = {.lex_state = 169},
  [1022] = {.lex_state = 169},
  [1023] = {.lex_state = 169},
  [1024] = {.lex_state = 169},
  [1025] = {.lex_state = 169},
  [1026] = {.lex_state = 169},
  [1027] = {.lex_state = 169},
  [1028] = {.lex_state = 169},
  [1029] = {.lex_state = 169},
  [1030] = {.lex_state = 169},
  [1031] = {.lex_state = 169},
  [1032] = {.lex_state = 169},
  [1033] = {.lex_state = 169},
  [1034] = {.lex_state = 169},
  [1035] = {.lex_state = 169},
  [1036] = {.lex_state = 169},
  [1037] = {.lex_state = 169},
  [1038] = {.lex_state = 169},
  [1039] = {.lex_state = 169},
  [1040] = {.lex_state = 169},
  [1041] = {.lex_state = 169},
  [1042] = {.lex_state = 169},
  [1043] = {.lex_state = 169},
  [1044] = {.lex_state = 169},
  [1045] = {.lex_state = 169},
  [1046] = {.lex_state = 169},
  [1047] = {.lex_state = 169},
  [1048] = {.lex_state = 169},
  [1049] = {.lex_state = 169},
  [1050] = {.lex_state = 169},
  [1051] = {.lex_state = 169},
  [1052] = {.lex_state = 169},
  [1053] = {.lex_state = 169},
  [1054] = {.lex_state = 169},
  [1055] = {.lex_state = 169},
  [1056] = {.lex_state = 169},
  [1057] = {.lex_state = 169},
  [1058] = {.lex_state = 169},
  [1059] = {.lex_state = 169},
  [1060] = {.lex_state = 169},
  [1061] = {.lex_state = 169},
  [1062] = {.lex_state = 169},
  [1063] = {.lex_state = 169},
  [1064] = {.lex_state = 169},
  [1065] = {.lex_state = 169},
  [1066] = {.lex_state = 169},
  [1067] = {.lex_state = 169},
  [1068] = {.lex_state = 169},
  [1069] = {.lex_state = 169},
  [1070] = {.lex_state = 169},
  [1071] = {.lex_state = 169},
  [1072] = {.lex_state = 169},
  [1073] = {.lex_state = 169},
  [1074] = {.lex_state = 169},
  [1075] = {.lex_state = 169},
  [1076] = {.lex_state = 169},
  [1077] = {.lex_state = 169},
  [1078] = {.lex_state = 169},
  [1079] = {.lex_state = 169},
  [1080] = {.lex_state = 169},
  [1081] = {.lex_state = 169},
  [1082] = {.lex_state = 169},
  [1083] = {.lex_state = 169},
  [1084] = {.lex_state = 169},
  [1085] = {.lex_state = 169},
  [1086] = {.lex_state = 169},
  [1087] = {.lex_state = 169},
  [1088] = {.lex_state = 169},
  [1089] = {.lex_state = 169},
  [1090] = {.lex_state = 169},
  [1091] = {.lex_state = 169},
  [1092] = {.lex_state = 169},
  [1093] = {.lex_state = 169},
  [1094] = {.lex_state = 169},
  [1095] = {.lex_state = 169},
  [1096] = {.lex_state = 169},
  [1097] = {.lex_state = 169},
  [1098] = {.lex_state = 169},
  [1099] = {.lex_state = 169},
  [1100] = {.lex_state = 169},
  [1101] = {.lex_state = 169},
  [1102] = {.lex_state = 169},
  [1103] = {.lex_state = 169},
  [1104] = {.lex_state = 169},
  [1105] = {.lex_state = 169},
  [1106] = {.lex_state = 169},
  [1107] = {.lex_state = 169},
  [1108] = {.lex_state = 169},
  [1109] = {.lex_state = 169},
  [1110] = {.lex_state = 169},
  [1111] = {.lex_state = 169},
  [1112] = {.lex_state = 2},
  [1113] = {.lex_state = 169},
  [1114] = {.lex_state = 2},
  [1115] = {.lex_state = 2},
  [1116] = {.lex_state = 2},
  [1117] = {.lex_state = 2},
  [1118] = {.lex_state = 2},
  [1119] = {.lex_state = 171},
  [1120] = {.lex_state = 171},
  [1121] = {.lex_state = 171},
  [1122] = {.lex_state = 171},
  [1123] = {.lex_state = 171},
  [1124] = {.lex_state = 171},
  [1125] = {.lex_state = 171},
  [1126] = {.lex_state = 171},
  [1127] = {.lex_state = 171},
  [1128] = {.lex_state = 171},
  [1129] = {.lex_state = 171},
  [1130] = {.lex_state = 171},
  [1131] = {.lex_state = 171},
  [1132] = {.lex_state = 171},
  [1133] = {.lex_state = 171},
  [1134] = {.lex_state = 171},
  [1135] = {.lex_state = 171},
  [1136] = {.lex_state = 171},
  [1137] = {.lex_state = 171},
  [1138] = {.lex_state = 171},
  [1139] = {.lex_state = 171},
  [1140] = {.lex_state = 171},
  [1141] = {.lex_state = 171},
  [1142] = {.lex_state = 171},
  [1143] = {.lex_state = 171},
  [1144] = {.lex_state = 171},
  [1145] = {.lex_state = 171},
  [1146] = {.lex_state = 22},
  [1147] = {.lex_state = 22},
  [1148] = {.lex_state = 171},
  [1149] = {.lex_state = 22},
  [1150] = {.lex_state = 171},
  [1151] = {.lex_state = 175},
  [1152] = {.lex_state = 22},
  [1153] = {.lex_state = 175},
  [1154] = {.lex_state = 171},
  [1155] = {.lex_state = 175},
  [1156] = {.lex_state = 22},
  [1157] = {.lex_state = 175},
  [1158] = {.lex_state = 171},
  [1159] = {.lex_state = 171},
  [1160] = {.lex_state = 171},
  [1161] = {.lex_state = 171},
  [1162] = {.lex_state = 171},
  [1163] = {.lex_state = 171},
  [1164] = {.lex_state = 171},
  [1165] = {.lex_state = 171},
  [1166] = {.lex_state = 171},
  [1167] = {.lex_state = 171},
  [1168] = {.lex_state = 171},
  [1169] = {.lex_state = 171},
  [1170] = {.lex_state = 171},
  [1171] = {.lex_state = 171},
  [1172] = {.lex_state = 171},
  [1173] = {.lex_state = 171},
  [1174] = {.lex_state = 171},
  [1175] = {.lex_state = 171},
  [1176] = {.lex_state = 171},
  [1177] = {.lex_state = 171},
  [1178] = {.lex_state = 171},
  [1179] = {.lex_state = 171},
  [1180] = {.lex_state = 171},
  [1181] = {.lex_state = 171},
  [1182] = {.lex_state = 171},
  [1183] = {.lex_state = 171},
  [1184] = {.lex_state = 171},
  [1185] = {.lex_state = 171},
  [1186] = {.lex_state = 171},
  [1187] = {.lex_state = 171},
  [1188] = {.lex_state = 171},
  [1189] = {.lex_state = 171},
  [1190] = {.lex_state = 171},
  [1191] = {.lex_state = 171},
  [1192] = {.lex_state = 171},
  [1193] = {.lex_state = 171},
  [1194] = {.lex_state = 171},
  [1195] = {.lex_state = 171},
  [1196] = {.lex_state = 171},
  [1197] = {.lex_state = 171},
  [1198] = {.lex_state = 171},
  [1199] = {.lex_state = 171},
  [1200] = {.lex_state = 171},
  [1201] = {.lex_state = 171},
  [1202] = {.lex_state = 171},
  [1203] = {.lex_state = 171},
  [1204] = {.lex_state = 171},
  [1205] = {.lex_state = 171},
  [1206] = {.lex_state = 171},
  [1207] = {.lex_state = 171},
  [1208] = {.lex_state = 171},
  [1209] = {.lex_state = 171},
  [1210] = {.lex_state = 171},
  [1211] = {.lex_state = 171},
  [1212] = {.lex_state = 171},
  [1213] = {.lex_state = 171},
  [1214] = {.lex_state = 171},
  [1215] = {.lex_state = 171},
  [1216] = {.lex_state = 171},
  [1217] = {.lex_state = 171},
  [1218] = {.lex_state = 171},
  [1219] = {.lex_state = 171},
  [1220] = {.lex_state = 171},
  [1221] = {.lex_state = 171},
  [1222] = {.lex_state = 171},
  [1223] = {.lex_state = 171},
  [1224] = {.lex_state = 171},
  [1225] = {.lex_state = 171},
  [1226] = {.lex_state = 171},
  [1227] = {.lex_state = 171},
  [1228] = {.lex_state = 171},
  [1229] = {.lex_state = 171},
  [1230] = {.lex_state = 171},
  [1231] = {.lex_state = 171},
  [1232] = {.lex_state = 171},
  [1233] = {.lex_state = 171},
  [1234] = {.lex_state = 171},
  [1235] = {.lex_state = 171},
  [1236] = {.lex_state = 171},
  [1237] = {.lex_state = 171},
  [1238] = {.lex_state = 171},
  [1239] = {.lex_state = 171},
  [1240] = {.lex_state = 171},
  [1241] = {.lex_state = 171},
  [1242] = {.lex_state = 171},
  [1243] = {.lex_state = 171},
  [1244] = {.lex_state = 171},
  [1245] = {.lex_state = 171},
  [1246] = {.lex_state = 171},
  [1247] = {.lex_state = 171},
  [1248] = {.lex_state = 171},
  [1249] = {.lex_state = 171},
  [1250] = {.lex_state = 171},
  [1251] = {.lex_state = 171},
  [1252] = {.lex_state = 171},
  [1253] = {.lex_state = 171},
  [1254] = {.lex_state = 171},
  [1255] = {.lex_state = 171},
  [1256] = {.lex_state = 171},
  [1257] = {.lex_state = 171},
  [1258] = {.lex_state = 171},
  [1259] = {.lex_state = 171},
  [1260] = {.lex_state = 171},
  [1261] = {.lex_state = 171},
  [1262] = {.lex_state = 171},
  [1263] = {.lex_state = 171},
  [1264] = {.lex_state = 171},
  [1265] = {.lex_state = 171},
  [1266] = {.lex_state = 171},
  [1267] = {.lex_state = 171},
  [1268] = {.lex_state = 171},
  [1269] = {.lex_state = 171},
  [1270] = {.lex_state = 171},
  [1271] = {.lex_state = 171},
  [1272] = {.lex_state = 171},
  [1273] = {.lex_state = 171},
  [1274] = {.lex_state = 171},
  [1275] = {.lex_state = 171},
  [1276] = {.lex_state = 171},
  [1277] = {.lex_state = 171},
  [1278] = {.lex_state = 171},
  [1279] = {.lex_state = 171},
  [1280] = {.lex_state = 182},
  [1281] = {.lex_state = 182},
  [1282] = {.lex_state = 171},
  [1283] = {.lex_state = 171},
  [1284] = {.lex_state = 171},
  [1285] = {.lex_state = 182},
  [1286] = {.lex_state = 171},
  [1287] = {.lex_state = 171},
  [1288] = {.lex_state = 171},
  [1289] = {.lex_state = 171},
  [1290] = {.lex_state = 171},
  [1291] = {.lex_state = 171},
  [1292] = {.lex_state = 175},
  [1293] = {.lex_state = 171},
  [1294] = {.lex_state = 175},
  [1295] = {.lex_state = 175},
  [1296] = {.lex_state = 175},
  [1297] = {.lex_state = 171},
  [1298] = {.lex_state = 171},
  [1299] = {.lex_state = 171},
  [1300] = {.lex_state = 171},
  [1301] = {.lex_state = 171},
  [1302] = {.lex_state = 171},
  [1303] = {.lex_state = 171},
  [1304] = {.lex_state = 171},
  [1305] = {.lex_state = 171},
  [1306] = {.lex_state = 171},
  [1307] = {.lex_state = 171},
  [1308] = {.lex_state = 171},
  [1309] = {.lex_state = 171},
  [1310] = {.lex_state = 171},
  [1311] = {.lex_state = 171},
  [1312] = {.lex_state = 171},
  [1313] = {.lex_state = 171},
  [1314] = {.lex_state = 171},
  [1315] = {.lex_state = 171},
  [1316] = {.lex_state = 171},
  [1317] = {.lex_state = 171},
  [1318] = {.lex_state = 171},
  [1319] = {.lex_state = 171},
  [1320] = {.lex_state = 171},
  [1321] = {.lex_state = 171},
  [1322] = {.lex_state = 171},
  [1323] = {.lex_state = 171},
  [1324] = {.lex_state = 171},
  [1325] = {.lex_state = 171},
  [1326] = {.lex_state = 171},
  [1327] = {.lex_state = 171},
  [1328] = {.lex_state = 171},
  [1329] = {.lex_state = 171},
  [1330] = {.lex_state = 171},
  [1331] = {.lex_state = 171},
  [1332] = {.lex_state = 171},
  [1333] = {.lex_state = 171},
  [1334] = {.lex_state = 171},
  [1335] = {.lex_state = 171},
  [1336] = {.lex_state = 171},
  [1337] = {.lex_state = 171},
  [1338] = {.lex_state = 171},
  [1339] = {.lex_state = 171},
  [1340] = {.lex_state = 178},
  [1341] = {.lex_state = 171},
  [1342] = {.lex_state = 171},
  [1343] = {.lex_state = 171},
  [1344] = {.lex_state = 171},
  [1345] = {.lex_state = 171},
  [1346] = {.lex_state = 171},
  [1347] = {.lex_state = 171},
  [1348] = {.lex_state = 171},
  [1349] = {.lex_state = 171},
  [1350] = {.lex_state = 171},
  [1351] = {.lex_state = 171},
  [1352] = {.lex_state = 171},
  [1353] = {.lex_state = 171},
  [1354] = {.lex_state = 171},
  [1355] = {.lex_state = 171},
  [1356] = {.lex_state = 171},
  [1357] = {.lex_state = 171},
  [1358] = {.lex_state = 171},
  [1359] = {.lex_state = 171},
  [1360] = {.lex_state = 171},
  [1361] = {.lex_state = 171},
  [1362] = {.lex_state = 171},
  [1363] = {.lex_state = 171},
  [1364] = {.lex_state = 171},
  [1365] = {.lex_state = 171},
  [1366] = {.lex_state = 178},
  [1367] = {.lex_state = 171},
  [1368] = {.lex_state = 171},
  [1369] = {.lex_state = 171},
  [1370] = {.lex_state = 171},
  [1371] = {.lex_state = 171},
  [1372] = {.lex_state = 171},
  [1373] = {.lex_state = 178},
  [1374] = {.lex_state = 171},
  [1375] = {.lex_state = 171},
  [1376] = {.lex_state = 171},
  [1377] = {.lex_state = 171},
  [1378] = {.lex_state = 171},
  [1379] = {.lex_state = 171},
  [1380] = {.lex_state = 171},
  [1381] = {.lex_state = 171},
  [1382] = {.lex_state = 171},
  [1383] = {.lex_state = 171},
  [1384] = {.lex_state = 171},
  [1385] = {.lex_state = 171},
  [1386] = {.lex_state = 171},
  [1387] = {.lex_state = 171},
  [1388] = {.lex_state = 171},
  [1389] = {.lex_state = 171},
  [1390] = {.lex_state = 171},
  [1391] = {.lex_state = 171},
  [1392] = {.lex_state = 171},
  [1393] = {.lex_state = 171},
  [1394] = {.lex_state = 171},
  [1395] = {.lex_state = 171},
  [1396] = {.lex_state = 171},
  [1397] = {.lex_state = 171},
  [1398] = {.lex_state = 171},
  [1399] = {.lex_state = 171},
  [1400] = {.lex_state = 171},
  [1401] = {.lex_state = 171},
  [1402] = {.lex_state = 171},
  [1403] = {.lex_state = 171},
  [1404] = {.lex_state = 171},
  [1405] = {.lex_state = 171},
  [1406] = {.lex_state = 171},
  [1407] = {.lex_state = 171},
  [1408] = {.lex_state = 177},
  [1409] = {.lex_state = 2},
  [1410] = {.lex_state = 2},
  [1411] = {.lex_state = 2},
  [1412] = {.lex_state = 2},
  [1413] = {.lex_state = 2},
  [1414] = {.lex_state = 2},
  [1415] = {.lex_state = 2},
  [1416] = {.lex_state = 2},
  [1417] = {.lex_state = 2},
  [1418] = {.lex_state = 2},
  [1419] = {.lex_state = 2},
  [1420] = {.lex_state = 2},
  [1421] = {.lex_state = 2},
  [1422] = {.lex_state = 2},
  [1423] = {.lex_state = 2},
  [1424] = {.lex_state = 2},
  [1425] = {.lex_state = 4},
  [1426] = {.lex_state = 2},
  [1427] = {.lex_state = 2},
  [1428] = {.lex_state = 2},
  [1429] = {.lex_state = 2},
  [1430] = {.lex_state = 4},
  [1431] = {.lex_state = 2},
  [1432] = {.lex_state = 4},
  [1433] = {.lex_state = 4},
  [1434] = {.lex_state = 2},
  [1435] = {.lex_state = 2},
  [1436] = {.lex_state = 2},
  [1437] = {.lex_state = 26},
  [1438] = {.lex_state = 2},
  [1439] = {.lex_state = 2},
  [1440] = {.lex_state = 26},
  [1441] = {.lex_state = 2},
  [1442] = {.lex_state = 2},
  [1443] = {.lex_state = 26},
  [1444] = {.lex_state = 2},
  [1445] = {.lex_state = 26},
  [1446] = {.lex_state = 2},
  [1447] = {.lex_state = 2},
  [1448] = {.lex_state = 2},
  [1449] = {.lex_state = 26},
  [1450] = {.lex_state = 2},
  [1451] = {.lex_state = 2},
  [1452] = {.lex_state = 2},
  [1453] = {.lex_state = 2},
  [1454] = {.lex_state = 2},
  [1455] = {.lex_state = 2},
  [1456] = {.lex_state = 2},
  [1457] = {.lex_state = 2},
  [1458] = {.lex_state = 2},
  [1459] = {.lex_state = 2},
  [1460] = {.lex_state = 2},
  [1461] = {.lex_state = 2},
  [1462] = {.lex_state = 26},
  [1463] = {.lex_state = 2},
  [1464] = {.lex_state = 2},
  [1465] = {.lex_state = 2},
  [1466] = {.lex_state = 2},
  [1467] = {.lex_state = 2},
  [1468] = {.lex_state = 2},
  [1469] = {.lex_state = 2},
  [1470] = {.lex_state = 2},
  [1471] = {.lex_state = 2},
  [1472] = {.lex_state = 2},
  [1473] = {.lex_state = 2},
  [1474] = {.lex_state = 2},
  [1475] = {.lex_state = 2},
  [1476] = {.lex_state = 2},
  [1477] = {.lex_state = 2},
  [1478] = {.lex_state = 28},
  [1479] = {.lex_state = 2},
  [1480] = {.lex_state = 2},
  [1481] = {.lex_state = 2},
  [1482] = {.lex_state = 2},
  [1483] = {.lex_state = 2},
  [1484] = {.lex_state = 2},
  [1485] = {.lex_state = 2},
  [1486] = {.lex_state = 2},
  [1487] = {.lex_state = 2},
  [1488] = {.lex_state = 28},
  [1489] = {.lex_state = 2},
  [1490] = {.lex_state = 2},
  [1491] = {.lex_state = 2},
  [1492] = {.lex_state = 2},
  [1493] = {.lex_state = 2},
  [1494] = {.lex_state = 2},
  [1495] = {.lex_state = 2},
  [1496] = {.lex_state = 2},
  [1497] = {.lex_state = 2},
  [1498] = {.lex_state = 2},
  [1499] = {.lex_state = 2},
  [1500] = {.lex_state = 2},
  [1501] = {.lex_state = 2},
  [1502] = {.lex_state = 2},
  [1503] = {.lex_state = 2},
  [1504] = {.lex_state = 2},
  [1505] = {.lex_state = 2},
  [1506] = {.lex_state = 2},
  [1507] = {.lex_state = 2},
  [1508] = {.lex_state = 2},
  [1509] = {.lex_state = 2},
  [1510] = {.lex_state = 2},
  [1511] = {.lex_state = 2},
  [1512] = {.lex_state = 2},
  [1513] = {.lex_state = 2},
  [1514] = {.lex_state = 2},
  [1515] = {.lex_state = 2},
  [1516] = {.lex_state = 2},
  [1517] = {.lex_state = 28},
  [1518] = {.lex_state = 2},
  [1519] = {.lex_state = 2},
  [1520] = {.lex_state = 2},
  [1521] = {.lex_state = 2},
  [1522] = {.lex_state = 2},
  [1523] = {.lex_state = 28},
  [1524] = {.lex_state = 2},
  [1525] = {.lex_state = 2},
  [1526] = {.lex_state = 2},
  [1527] = {.lex_state = 2},
  [1528] = {.lex_state = 2},
  [1529] = {.lex_state = 2},
  [1530] = {.lex_state = 2},
  [1531] = {.lex_state = 2},
  [1532] = {.lex_state = 2},
  [1533] = {.lex_state = 28},
  [1534] = {.lex_state = 2},
  [1535] = {.lex_state = 2},
  [1536] = {.lex_state = 2},
  [1537] = {.lex_state = 2},
  [1538] = {.lex_state = 2},
  [1539] = {.lex_state = 2},
  [1540] = {.lex_state = 2},
  [1541] = {.lex_state = 2},
  [1542] = {.lex_state = 2},
  [1543] = {.lex_state = 2},
  [1544] = {.lex_state = 2},
  [1545] = {.lex_state = 2},
  [1546] = {.lex_state = 2},
  [1547] = {.lex_state = 2},
  [1548] = {.lex_state = 2},
  [1549] = {.lex_state = 2},
  [1550] = {.lex_state = 2},
  [1551] = {.lex_state = 2},
  [1552] = {.lex_state = 22},
  [1553] = {.lex_state = 22},
  [1554] = {.lex_state = 26},
  [1555] = {.lex_state = 22},
  [1556] = {.lex_state = 22},
  [1557] = {.lex_state = 22},
  [1558] = {.lex_state = 22},
  [1559] = {.lex_state = 22},
  [1560] = {.lex_state = 22},
  [1561] = {.lex_state = 24},
  [1562] = {.lex_state = 22},
  [1563] = {.lex_state = 22},
  [1564] = {.lex_state = 22},
  [1565] = {.lex_state = 22},
  [1566] = {.lex_state = 22},
  [1567] = {.lex_state = 22},
  [1568] = {.lex_state = 22},
  [1569] = {.lex_state = 22},
  [1570] = {.lex_state = 22},
  [1571] = {.lex_state = 22},
  [1572] = {.lex_state = 24},
  [1573] = {.lex_state = 24},
  [1574] = {.lex_state = 22},
  [1575] = {.lex_state = 22},
  [1576] = {.lex_state = 22},
  [1577] = {.lex_state = 22},
  [1578] = {.lex_state = 22},
  [1579] = {.lex_state = 22},
  [1580] = {.lex_state = 22},
  [1581] = {.lex_state = 22},
  [1582] = {.lex_state = 177},
  [1583] = {.lex_state = 22},
  [1584] = {.lex_state = 22},
  [1585] = {.lex_state = 24},
  [1586] = {.lex_state = 22},
  [1587] = {.lex_state = 22},
  [1588] = {.lex_state = 22},
  [1589] = {.lex_state = 22},
  [1590] = {.lex_state = 22},
  [1591] = {.lex_state = 22},
  [1592] = {.lex_state = 22},
  [1593] = {.lex_state = 22},
  [1594] = {.lex_state = 22},
  [1595] = {.lex_state = 22},
  [1596] = {.lex_state = 22},
  [1597] = {.lex_state = 22},
  [1598] = {.lex_state = 22},
  [1599] = {.lex_state = 22},
  [1600] = {.lex_state = 22},
  [1601] = {.lex_state = 22},
  [1602] = {.lex_state = 22},
  [1603] = {.lex_state = 22},
  [1604] = {.lex_state = 22},
  [1605] = {.lex_state = 22},
  [1606] = {.lex_state = 22},
  [1607] = {.lex_state = 22},
  [1608] = {.lex_state = 22},
  [1609] = {.lex_state = 22},
  [1610] = {.lex_state = 22},
  [1611] = {.lex_state = 22},
  [1612] = {.lex_state = 22},
  [1613] = {.lex_state = 22},
  [1614] = {.lex_state = 22},
  [1615] = {.lex_state = 22},
  [1616] = {.lex_state = 22},
  [1617] = {.lex_state = 22},
  [1618] = {.lex_state = 22},
  [1619] = {.lex_state = 22},
  [1620] = {.lex_state = 22},
  [1621] = {.lex_state = 22},
  [1622] = {.lex_state = 22},
  [1623] = {.lex_state = 22},
  [1624] = {.lex_state = 22},
  [1625] = {.lex_state = 22},
  [1626] = {.lex_state = 22},
  [1627] = {.lex_state = 22},
  [1628] = {.lex_state = 22},
  [1629] = {.lex_state = 22},
  [1630] = {.lex_state = 22},
  [1631] = {.lex_state = 22},
  [1632] = {.lex_state = 22},
  [1633] = {.lex_state = 22},
  [1634] = {.lex_state = 22},
  [1635] = {.lex_state = 22},
  [1636] = {.lex_state = 22},
  [1637] = {.lex_state = 22},
  [1638] = {.lex_state = 22},
  [1639] = {.lex_state = 22},
  [1640] = {.lex_state = 22},
  [1641] = {.lex_state = 22},
  [1642] = {.lex_state = 22},
  [1643] = {.lex_state = 22},
  [1644] = {.lex_state = 22},
  [1645] = {.lex_state = 22},
  [1646] = {.lex_state = 22},
  [1647] = {.lex_state = 22},
  [1648] = {.lex_state = 22},
  [1649] = {.lex_state = 22},
  [1650] = {.lex_state = 22},
  [1651] = {.lex_state = 22},
  [1652] = {.lex_state = 22},
  [1653] = {.lex_state = 22},
  [1654] = {.lex_state = 22},
  [1655] = {.lex_state = 22},
  [1656] = {.lex_state = 22},
  [1657] = {.lex_state = 22},
  [1658] = {.lex_state = 22},
  [1659] = {.lex_state = 22},
  [1660] = {.lex_state = 22},
  [1661] = {.lex_state = 22},
  [1662] = {.lex_state = 22},
  [1663] = {.lex_state = 22},
  [1664] = {.lex_state = 22},
  [1665] = {.lex_state = 22},
  [1666] = {.lex_state = 22},
  [1667] = {.lex_state = 22},
  [1668] = {.lex_state = 22},
  [1669] = {.lex_state = 22},
  [1670] = {.lex_state = 22},
  [1671] = {.lex_state = 22},
  [1672] = {.lex_state = 22},
  [1673] = {.lex_state = 22},
  [1674] = {.lex_state = 22},
  [1675] = {.lex_state = 22},
  [1676] = {.lex_state = 22},
  [1677] = {.lex_state = 22},
  [1678] = {.lex_state = 22},
  [1679] = {.lex_state = 22},
  [1680] = {.lex_state = 22},
  [1681] = {.lex_state = 22},
  [1682] = {.lex_state = 22},
  [1683] = {.lex_state = 22},
  [1684] = {.lex_state = 22},
  [1685] = {.lex_state = 22},
  [1686] = {.lex_state = 22},
  [1687] = {.lex_state = 22},
  [1688] = {.lex_state = 22},
  [1689] = {.lex_state = 22},
  [1690] = {.lex_state = 6},
  [1691] = {.lex_state = 22},
  [1692] = {.lex_state = 22},
  [1693] = {.lex_state = 22},
  [1694] = {.lex_state = 6},
  [1695] = {.lex_state = 6},
  [1696] = {.lex_state = 6},
  [1697] = {.lex_state = 6},
  [1698] = {.lex_state = 22},
  [1699] = {.lex_state = 181},
  [1700] = {.lex_state = 34},
  [1701] = {.lex_state = 181},
  [1702] = {.lex_state = 182},
  [1703] = {.lex_state = 182},
  [1704] = {.lex_state = 182},
  [1705] = {.lex_state = 182},
  [1706] = {.lex_state = 34},
  [1707] = {.lex_state = 182},
  [1708] = {.lex_state = 182},
  [1709] = {.lex_state = 181},
  [1710] = {.lex_state = 34},
  [1711] = {.lex_state = 181},
  [1712] = {.lex_state = 182},
  [1713] = {.lex_state = 34},
  [1714] = {.lex_state = 182},
  [1715] = {.lex_state = 178},
  [1716] = {.lex_state = 182},
  [1717] = {.lex_state = 178},
  [1718] = {.lex_state = 182},
  [1719] = {.lex_state = 182},
  [1720] = {.lex_state = 182},
  [1721] = {.lex_state = 182},
  [1722] = {.lex_state = 182},
  [1723] = {.lex_state = 182},
  [1724] = {.lex_state = 182},
  [1725] = {.lex_state = 182},
  [1726] = {.lex_state = 182},
  [1727] = {.lex_state = 182},
  [1728] = {.lex_state = 182},
  [1729] = {.lex_state = 182},
  [1730] = {.lex_state = 179},
  [1731] = {.lex_state = 182},
  [1732] = {.lex_state = 182},
  [1733] = {.lex_state = 182},
  [1734] = {.lex_state = 182},
  [1735] = {.lex_state = 182},
  [1736] = {.lex_state = 182},
  [1737] = {.lex_state = 178},
  [1738] = {.lex_state = 182},
  [1739] = {.lex_state = 182},
  [1740] = {.lex_state = 178},
  [1741] = {.lex_state = 182},
  [1742] = {.lex_state = 182},
  [1743] = {.lex_state = 182},
  [1744] = {.lex_state = 182},
  [1745] = {.lex_state = 182},
  [1746] = {.lex_state = 182},
  [1747] = {.lex_state = 182},
  [1748] = {.lex_state = 182},
  [1749] = {.lex_state = 178},
  [1750] = {.lex_state = 178},
  [1751] = {.lex_state = 178},
  [1752] = {.lex_state = 179},
  [1753] = {.lex_state = 178},
  [1754] = {.lex_state = 178},
  [1755] = {.lex_state = 178},
  [1756] = {.lex_state = 178},
  [1757] = {.lex_state = 178},
  [1758] = {.lex_state = 178},
  [1759] = {.lex_state = 178},
  [1760] = {.lex_state = 178},
  [1761] = {.lex_state = 178},
  [1762] = {.lex_state = 178},
  [1763] = {.lex_state = 178},
  [1764] = {.lex_state = 178},
  [1765] = {.lex_state = 178},
  [1766] = {.lex_state = 178},
  [1767] = {.lex_state = 178},
  [1768] = {.lex_state = 178},
  [1769] = {.lex_state = 178},
  [1770] = {.lex_state = 178},
  [1771] = {.lex_state = 178},
  [1772] = {.lex_state = 178},
  [1773] = {.lex_state = 178},
  [1774] = {.lex_state = 179},
  [1775] = {.lex_state = 179},
  [1776] = {.lex_state = 178},
  [1777] = {.lex_state = 178},
  [1778] = {.lex_state = 178},
  [1779] = {.lex_state = 178},
  [1780] = {.lex_state = 178},
  [1781] = {.lex_state = 178},
  [1782] = {.lex_state = 178},
  [1783] = {.lex_state = 185},
  [1784] = {.lex_state = 178},
  [1785] = {.lex_state = 178},
  [1786] = {.lex_state = 178},
  [1787] = {.lex_state = 178},
  [1788] = {.lex_state = 178},
  [1789] = {.lex_state = 178},
  [1790] = {.lex_state = 178},
  [1791] = {.lex_state = 178},
  [1792] = {.lex_state = 178},
  [1793] = {.lex_state = 178},
  [1794] = {.lex_state = 178},
  [1795] = {.lex_state = 178},
  [1796] = {.lex_state = 178},
  [1797] = {.lex_state = 178},
  [1798] = {.lex_state = 178},
  [1799] = {.lex_state = 178},
  [1800] = {.lex_state = 178},
  [1801] = {.lex_state = 178},
  [1802] = {.lex_state = 178},
  [1803] = {.lex_state = 178},
  [1804] = {.lex_state = 178},
  [1805] = {.lex_state = 185},
  [1806] = {.lex_state = 178},
  [1807] = {.lex_state = 178},
  [1808] = {.lex_state = 178},
  [1809] = {.lex_state = 178},
  [1810] = {.lex_state = 178},
  [1811] = {.lex_state = 178},
  [1812] = {.lex_state = 178},
  [1813] = {.lex_state = 178},
  [1814] = {.lex_state = 178},
  [1815] = {.lex_state = 178},
  [1816] = {.lex_state = 178},
  [1817] = {.lex_state = 178},
  [1818] = {.lex_state = 178},
  [1819] = {.lex_state = 178},
  [1820] = {.lex_state = 178},
  [1821] = {.lex_state = 178},
  [1822] = {.lex_state = 178},
  [1823] = {.lex_state = 178},
  [1824] = {.lex_state = 38},
  [1825] = {.lex_state = 178},
  [1826] = {.lex_state = 178},
  [1827] = {.lex_state = 178},
  [1828] = {.lex_state = 178},
  [1829] = {.lex_state = 178},
  [1830] = {.lex_state = 178},
  [1831] = {.lex_state = 178},
  [1832] = {.lex_state = 178},
  [1833] = {.lex_state = 178},
  [1834] = {.lex_state = 178},
  [1835] = {.lex_state = 178},
  [1836] = {.lex_state = 178},
  [1837] = {.lex_state = 178},
  [1838] = {.lex_state = 6},
  [1839] = {.lex_state = 178},
  [1840] = {.lex_state = 178},
  [1841] = {.lex_state = 178},
  [1842] = {.lex_state = 178},
  [1843] = {.lex_state = 178},
  [1844] = {.lex_state = 178},
  [1845] = {.lex_state = 178},
  [1846] = {.lex_state = 178},
  [1847] = {.lex_state = 178},
  [1848] = {.lex_state = 178},
  [1849] = {.lex_state = 178},
  [1850] = {.lex_state = 178},
  [1851] = {.lex_state = 178},
  [1852] = {.lex_state = 178},
  [1853] = {.lex_state = 178},
  [1854] = {.lex_state = 178},
  [1855] = {.lex_state = 178},
  [1856] = {.lex_state = 178},
  [1857] = {.lex_state = 178},
  [1858] = {.lex_state = 178},
  [1859] = {.lex_state = 178},
  [1860] = {.lex_state = 178},
  [1861] = {.lex_state = 178},
  [1862] = {.lex_state = 178},
  [1863] = {.lex_state = 178},
  [1864] = {.lex_state = 178},
  [1865] = {.lex_state = 178},
  [1866] = {.lex_state = 178},
  [1867] = {.lex_state = 178},
  [1868] = {.lex_state = 178},
  [1869] = {.lex_state = 178},
  [1870] = {.lex_state = 178},
  [1871] = {.lex_state = 178},
  [1872] = {.lex_state = 178},
  [1873] = {.lex_state = 178},
  [1874] = {.lex_state = 178},
  [1875] = {.lex_state = 178},
  [1876] = {.lex_state = 178},
  [1877] = {.lex_state = 178},
  [1878] = {.lex_state = 178},
  [1879] = {.lex_state = 178},
  [1880] = {.lex_state = 178},
  [1881] = {.lex_state = 178},
  [1882] = {.lex_state = 178},
  [1883] = {.lex_state = 178},
  [1884] = {.lex_state = 178},
  [1885] = {.lex_state = 178},
  [1886] = {.lex_state = 178},
  [1887] = {.lex_state = 178},
  [1888] = {.lex_state = 178},
  [1889] = {.lex_state = 178},
  [1890] = {.lex_state = 178},
  [1891] = {.lex_state = 178},
  [1892] = {.lex_state = 178},
  [1893] = {.lex_state = 178},
  [1894] = {.lex_state = 178},
  [1895] = {.lex_state = 178},
  [1896] = {.lex_state = 178},
  [1897] = {.lex_state = 178},
  [1898] = {.lex_state = 178},
  [1899] = {.lex_state = 34},
  [1900] = {.lex_state = 178},
  [1901] = {.lex_state = 178},
  [1902] = {.lex_state = 178},
  [1903] = {.lex_state = 178},
  [1904] = {.lex_state = 178},
  [1905] = {.lex_state = 178},
  [1906] = {.lex_state = 38},
  [1907] = {.lex_state = 38},
  [1908] = {.lex_state = 38},
  [1909] = {.lex_state = 6},
  [1910] = {.lex_state = 6},
  [1911] = {.lex_state = 6},
  [1912] = {.lex_state = 34},
  [1913] = {.lex_state = 6},
  [1914] = {.lex_state = 38},
  [1915] = {.lex_state = 185},
  [1916] = {.lex_state = 64},
  [1917] = {.lex_state = 185},
  [1918] = {.lex_state = 34},
  [1919] = {.lex_state = 34},
  [1920] = {.lex_state = 185},
  [1921] = {.lex_state = 185},
  [1922] = {.lex_state = 185},
  [1923] = {.lex_state = 185},
  [1924] = {.lex_state = 178},
  [1925] = {.lex_state = 178},
  [1926] = {.lex_state = 178},
  [1927] = {.lex_state = 178},
  [1928] = {.lex_state = 178},
  [1929] = {.lex_state = 178},
  [1930] = {.lex_state = 178},
  [1931] = {.lex_state = 178},
  [1932] = {.lex_state = 178},
  [1933] = {.lex_state = 178},
  [1934] = {.lex_state = 178},
  [1935] = {.lex_state = 178},
  [1936] = {.lex_state = 178},
  [1937] = {.lex_state = 178},
  [1938] = {.lex_state = 178},
  [1939] = {.lex_state = 178},
  [1940] = {.lex_state = 178},
  [1941] = {.lex_state = 178},
  [1942] = {.lex_state = 178},
  [1943] = {.lex_state = 178},
  [1944] = {.lex_state = 178},
  [1945] = {.lex_state = 178},
  [1946] = {.lex_state = 178},
  [1947] = {.lex_state = 178},
  [1948] = {.lex_state = 178},
  [1949] = {.lex_state = 178},
  [1950] = {.lex_state = 178},
  [1951] = {.lex_state = 178},
  [1952] = {.lex_state = 26},
  [1953] = {.lex_state = 28},
  [1954] = {.lex_state = 26},
  [1955] = {.lex_state = 28},
  [1956] = {.lex_state = 26},
  [1957] = {.lex_state = 26},
  [1958] = {.lex_state = 26},
  [1959] = {.lex_state = 28},
  [1960] = {.lex_state = 28},
  [1961] = {.lex_state = 28},
  [1962] = {.lex_state = 185},
  [1963] = {.lex_state = 44},
  [1964] = {.lex_state = 44},
  [1965] = {.lex_state = 56},
  [1966] = {.lex_state = 56},
  [1967] = {.lex_state = 44},
  [1968] = {.lex_state = 44},
  [1969] = {.lex_state = 44},
  [1970] = {.lex_state = 56},
  [1971] = {.lex_state = 56},
  [1972] = {.lex_state = 44},
  [1973] = {.lex_state = 44},
  [1974] = {.lex_state = 44},
  [1975] = {.lex_state = 56},
  [1976] = {.lex_state = 44},
  [1977] = {.lex_state = 44},
  [1978] = {.lex_state = 44},
  [1979] = {.lex_state = 44},
  [1980] = {.lex_state = 56},
  [1981] = {.lex_state = 44},
  [1982] = {.lex_state = 56},
  [1983] = {.lex_state = 44},
  [1984] = {.lex_state = 56},
  [1985] = {.lex_state = 44},
  [1986] = {.lex_state = 56},
  [1987] = {.lex_state = 56},
  [1988] = {.lex_state = 6},
  [1989] = {.lex_state = 44},
  [1990] = {.lex_state = 6},
  [1991] = {.lex_state = 6},
  [1992] = {.lex_state = 44},
  [1993] = {.lex_state = 44},
  [1994] = {.lex_state = 48},
  [1995] = {.lex_state = 44},
  [1996] = {.lex_state = 32},
  [1997] = {.lex_state = 44},
  [1998] = {.lex_state = 44},
  [1999] = {.lex_state = 32},
  [2000] = {.lex_state = 44},
  [2001] = {.lex_state = 29},
  [2002] = {.lex_state = 6},
  [2003] = {.lex_state = 46},
  [2004] = {.lex_state = 48},
  [2005] = {.lex_state = 44},
  [2006] = {.lex_state = 46},
  [2007] = {.lex_state = 29},
  [2008] = {.lex_state = 56},
  [2009] = {.lex_state = 6},
  [2010] = {.lex_state = 44},
  [2011] = {.lex_state = 44},
  [2012] = {.lex_state = 44},
  [2013] = {.lex_state = 56},
  [2014] = {.lex_state = 56},
  [2015] = {.lex_state = 44},
  [2016] = {.lex_state = 56},
  [2017] = {.lex_state = 56},
  [2018] = {.lex_state = 14},
  [2019] = {.lex_state = 44},
  [2020] = {.lex_state = 44},
  [2021] = {.lex_state = 44},
  [2022] = {.lex_state = 14},
  [2023] = {.lex_state = 44},
  [2024] = {.lex_state = 56},
  [2025] = {.lex_state = 56},
  [2026] = {.lex_state = 56},
  [2027] = {.lex_state = 56},
  [2028] = {.lex_state = 56},
  [2029] = {.lex_state = 44},
  [2030] = {.lex_state = 44},
  [2031] = {.lex_state = 44},
  [2032] = {.lex_state = 44},
  [2033] = {.lex_state = 44},
  [2034] = {.lex_state = 56},
  [2035] = {.lex_state = 44},
  [2036] = {.lex_state = 44},
  [2037] = {.lex_state = 44},
  [2038] = {.lex_state = 44},
  [2039] = {.lex_state = 44},
  [2040] = {.lex_state = 44},
  [2041] = {.lex_state = 44},
  [2042] = {.lex_state = 56},
  [2043] = {.lex_state = 44},
  [2044] = {.lex_state = 56},
  [2045] = {.lex_state = 44},
  [2046] = {.lex_state = 44},
  [2047] = {.lex_state = 56},
  [2048] = {.lex_state = 56},
  [2049] = {.lex_state = 44},
  [2050] = {.lex_state = 44},
  [2051] = {.lex_state = 44},
  [2052] = {.lex_state = 44},
  [2053] = {.lex_state = 56},
  [2054] = {.lex_state = 44},
  [2055] = {.lex_state = 56},
  [2056] = {.lex_state = 56},
  [2057] = {.lex_state = 56},
  [2058] = {.lex_state = 44},
  [2059] = {.lex_state = 44},
  [2060] = {.lex_state = 44},
  [2061] = {.lex_state = 44},
  [2062] = {.lex_state = 44},
  [2063] = {.lex_state = 44},
  [2064] = {.lex_state = 56},
  [2065] = {.lex_state = 56},
  [2066] = {.lex_state = 56},
  [2067] = {.lex_state = 56},
  [2068] = {.lex_state = 56},
  [2069] = {.lex_state = 56},
  [2070] = {.lex_state = 44},
  [2071] = {.lex_state = 44},
  [2072] = {.lex_state = 56},
  [2073] = {.lex_state = 56},
  [2074] = {.lex_state = 44},
  [2075] = {.lex_state = 44},
  [2076] = {.lex_state = 44},
  [2077] = {.lex_state = 44},
  [2078] = {.lex_state = 44},
  [2079] = {.lex_state = 44},
  [2080] = {.lex_state = 56},
  [2081] = {.lex_state = 44},
  [2082] = {.lex_state = 56},
  [2083] = {.lex_state = 56},
  [2084] = {.lex_state = 44},
  [2085] = {.lex_state = 44},
  [2086] = {.lex_state = 44},
  [2087] = {.lex_state = 44},
  [2088] = {.lex_state = 44},
  [2089] = {.lex_state = 44},
  [2090] = {.lex_state = 44},
  [2091] = {.lex_state = 44},
  [2092] = {.lex_state = 44},
  [2093] = {.lex_state = 44},
  [2094] = {.lex_state = 56},
  [2095] = {.lex_state = 44},
  [2096] = {.lex_state = 44},
  [2097] = {.lex_state = 44},
  [2098] = {.lex_state = 44},
  [2099] = {.lex_state = 44},
  [2100] = {.lex_state = 44},
  [2101] = {.lex_state = 44},
  [2102] = {.lex_state = 56},
  [2103] = {.lex_state = 56},
  [2104] = {.lex_state = 56},
  [2105] = {.lex_state = 44},
  [2106] = {.lex_state = 56},
  [2107] = {.lex_state = 44},
  [2108] = {.lex_state = 56},
  [2109] = {.lex_state = 44},
  [2110] = {.lex_state = 56},
  [2111] = {.lex_state = 56},
  [2112] = {.lex_state = 44},
  [2113] = {.lex_state = 56},
  [2114] = {.lex_state = 56},
  [2115] = {.lex_state = 56},
  [2116] = {.lex_state = 44},
  [2117] = {.lex_state = 56},
  [2118] = {.lex_state = 44},
  [2119] = {.lex_state = 44},
  [2120] = {.lex_state = 44},
  [2121] = {.lex_state = 56},
  [2122] = {.lex_state = 44},
  [2123] = {.lex_state = 56},
  [2124] = {.lex_state = 56},
  [2125] = {.lex_state = 56},
  [2126] = {.lex_state = 56},
  [2127] = {.lex_state = 56},
  [2128] = {.lex_state = 56},
  [2129] = {.lex_state = 56},
  [2130] = {.lex_state = 56},
  [2131] = {.lex_state = 56},
  [2132] = {.lex_state = 56},
  [2133] = {.lex_state = 56},
  [2134] = {.lex_state = 44},
  [2135] = {.lex_state = 44},
  [2136] = {.lex_state = 56},
  [2137] = {.lex_state = 56},
  [2138] = {.lex_state = 56},
  [2139] = {.lex_state = 56},
  [2140] = {.lex_state = 56},
  [2141] = {.lex_state = 44},
  [2142] = {.lex_state = 44},
  [2143] = {.lex_state = 56},
  [2144] = {.lex_state = 44},
  [2145] = {.lex_state = 56},
  [2146] = {.lex_state = 44},
  [2147] = {.lex_state = 56},
  [2148] = {.lex_state = 44},
  [2149] = {.lex_state = 44},
  [2150] = {.lex_state = 56},
  [2151] = {.lex_state = 56},
  [2152] = {.lex_state = 56},
  [2153] = {.lex_state = 44},
  [2154] = {.lex_state = 44},
  [2155] = {.lex_state = 56},
  [2156] = {.lex_state = 56},
  [2157] = {.lex_state = 56},
  [2158] = {.lex_state = 44},
  [2159] = {.lex_state = 56},
  [2160] = {.lex_state = 56},
  [2161] = {.lex_state = 56},
  [2162] = {.lex_state = 44},
  [2163] = {.lex_state = 56},
  [2164] = {.lex_state = 56},
  [2165] = {.lex_state = 44},
  [2166] = {.lex_state = 44},
  [2167] = {.lex_state = 56},
  [2168] = {.lex_state = 44},
  [2169] = {.lex_state = 44},
  [2170] = {.lex_state = 44},
  [2171] = {.lex_state = 44},
  [2172] = {.lex_state = 56},
  [2173] = {.lex_state = 56},
  [2174] = {.lex_state = 56},
  [2175] = {.lex_state = 56},
  [2176] = {.lex_state = 44},
  [2177] = {.lex_state = 44},
  [2178] = {.lex_state = 44},
  [2179] = {.lex_state = 44},
  [2180] = {.lex_state = 56},
  [2181] = {.lex_state = 56},
  [2182] = {.lex_state = 44},
  [2183] = {.lex_state = 44},
  [2184] = {.lex_state = 44},
  [2185] = {.lex_state = 44},
  [2186] = {.lex_state = 56},
  [2187] = {.lex_state = 44},
  [2188] = {.lex_state = 56},
  [2189] = {.lex_state = 44},
  [2190] = {.lex_state = 56},
  [2191] = {.lex_state = 56},
  [2192] = {.lex_state = 56},
  [2193] = {.lex_state = 44},
  [2194] = {.lex_state = 56},
  [2195] = {.lex_state = 56},
  [2196] = {.lex_state = 44},
  [2197] = {.lex_state = 56},
  [2198] = {.lex_state = 56},
  [2199] = {.lex_state = 14},
  [2200] = {.lex_state = 44},
  [2201] = {.lex_state = 56},
  [2202] = {.lex_state = 44},
  [2203] = {.lex_state = 44},
  [2204] = {.lex_state = 44},
  [2205] = {.lex_state = 44},
  [2206] = {.lex_state = 44},
  [2207] = {.lex_state = 44},
  [2208] = {.lex_state = 56},
  [2209] = {.lex_state = 56},
  [2210] = {.lex_state = 56},
  [2211] = {.lex_state = 56},
  [2212] = {.lex_state = 44},
  [2213] = {.lex_state = 44},
  [2214] = {.lex_state = 56},
  [2215] = {.lex_state = 56},
  [2216] = {.lex_state = 56},
  [2217] = {.lex_state = 44},
  [2218] = {.lex_state = 44},
  [2219] = {.lex_state = 44},
  [2220] = {.lex_state = 44},
  [2221] = {.lex_state = 56},
  [2222] = {.lex_state = 56},
  [2223] = {.lex_state = 56},
  [2224] = {.lex_state = 44},
  [2225] = {.lex_state = 56},
  [2226] = {.lex_state = 56},
  [2227] = {.lex_state = 56},
  [2228] = {.lex_state = 34},
  [2229] = {.lex_state = 34},
  [2230] = {.lex_state = 34},
  [2231] = {.lex_state = 34},
  [2232] = {.lex_state = 34},
  [2233] = {.lex_state = 7},
  [2234] = {.lex_state = 7},
  [2235] = {.lex_state = 44},
  [2236] = {.lex_state = 7},
  [2237] = {.lex_state = 64},
  [2238] = {.lex_state = 7},
  [2239] = {.lex_state = 7},
  [2240] = {.lex_state = 64},
  [2241] = {.lex_state = 10},
  [2242] = {.lex_state = 10},
  [2243] = {.lex_state = 64},
  [2244] = {.lex_state = 7},
  [2245] = {.lex_state = 64},
  [2246] = {.lex_state = 64},
  [2247] = {.lex_state = 10},
  [2248] = {.lex_state = 64},
  [2249] = {.lex_state = 64},
  [2250] = {.lex_state = 64},
  [2251] = {.lex_state = 7},
  [2252] = {.lex_state = 7},
  [2253] = {.lex_state = 7},
  [2254] = {.lex_state = 64},
  [2255] = {.lex_state = 64},
  [2256] = {.lex_state = 7},
  [2257] = {.lex_state = 10},
  [2258] = {.lex_state = 7},
  [2259] = {.lex_state = 7},
  [2260] = {.lex_state = 7},
  [2261] = {.lex_state = 7},
  [2262] = {.lex_state = 7},
  [2263] = {.lex_state = 7},
  [2264] = {.lex_state = 64},
  [2265] = {.lex_state = 7},
  [2266] = {.lex_state = 7},
  [2267] = {.lex_state = 7},
  [2268] = {.lex_state = 7},
  [2269] = {.lex_state = 7},
  [2270] = {.lex_state = 7},
  [2271] = {.lex_state = 7},
  [2272] = {.lex_state = 7},
  [2273] = {.lex_state = 7},
  [2274] = {.lex_state = 7},
  [2275] = {.lex_state = 7},
  [2276] = {.lex_state = 7},
  [2277] = {.lex_state = 7},
  [2278] = {.lex_state = 7},
  [2279] = {.lex_state = 7},
  [2280] = {.lex_state = 7},
  [2281] = {.lex_state = 7},
  [2282] = {.lex_state = 7},
  [2283] = {.lex_state = 7},
  [2284] = {.lex_state = 7},
  [2285] = {.lex_state = 7},
  [2286] = {.lex_state = 7},
  [2287] = {.lex_state = 7},
  [2288] = {.lex_state = 7},
  [2289] = {.lex_state = 7},
  [2290] = {.lex_state = 38},
  [2291] = {.lex_state = 7},
  [2292] = {.lex_state = 7},
  [2293] = {.lex_state = 7},
  [2294] = {.lex_state = 7},
  [2295] = {.lex_state = 7},
  [2296] = {.lex_state = 7},
  [2297] = {.lex_state = 7},
  [2298] = {.lex_state = 7},
  [2299] = {.lex_state = 7},
  [2300] = {.lex_state = 7},
  [2301] = {.lex_state = 7},
  [2302] = {.lex_state = 7},
  [2303] = {.lex_state = 7},
  [2304] = {.lex_state = 38},
  [2305] = {.lex_state = 7},
  [2306] = {.lex_state = 38},
  [2307] = {.lex_state = 7},
  [2308] = {.lex_state = 38},
  [2309] = {.lex_state = 38},
  [2310] = {.lex_state = 7},
  [2311] = {.lex_state = 7},
  [2312] = {.lex_state = 7},
  [2313] = {.lex_state = 7},
  [2314] = {.lex_state = 7},
  [2315] = {.lex_state = 7},
  [2316] = {.lex_state = 7},
  [2317] = {.lex_state = 7},
  [2318] = {.lex_state = 7},
  [2319] = {.lex_state = 7},
  [2320] = {.lex_state = 64},
  [2321] = {.lex_state = 7},
  [2322] = {.lex_state = 7},
  [2323] = {.lex_state = 7},
  [2324] = {.lex_state = 7},
  [2325] = {.lex_state = 7},
  [2326] = {.lex_state = 7},
  [2327] = {.lex_state = 7},
  [2328] = {.lex_state = 7},
  [2329] = {.lex_state = 7},
  [2330] = {.lex_state = 7},
  [2331] = {.lex_state = 64},
  [2332] = {.lex_state = 7},
  [2333] = {.lex_state = 7},
  [2334] = {.lex_state = 7},
  [2335] = {.lex_state = 7},
  [2336] = {.lex_state = 7},
  [2337] = {.lex_state = 7},
  [2338] = {.lex_state = 7},
  [2339] = {.lex_state = 7},
  [2340] = {.lex_state = 7},
  [2341] = {.lex_state = 7},
  [2342] = {.lex_state = 7},
  [2343] = {.lex_state = 15},
  [2344] = {.lex_state = 7},
  [2345] = {.lex_state = 64},
  [2346] = {.lex_state = 7},
  [2347] = {.lex_state = 7},
  [2348] = {.lex_state = 7},
  [2349] = {.lex_state = 7},
  [2350] = {.lex_state = 7},
  [2351] = {.lex_state = 7},
  [2352] = {.lex_state = 7},
  [2353] = {.lex_state = 7},
  [2354] = {.lex_state = 7},
  [2355] = {.lex_state = 7},
  [2356] = {.lex_state = 7},
  [2357] = {.lex_state = 7},
  [2358] = {.lex_state = 7},
  [2359] = {.lex_state = 7},
  [2360] = {.lex_state = 7},
  [2361] = {.lex_state = 7},
  [2362] = {.lex_state = 7},
  [2363] = {.lex_state = 7},
  [2364] = {.lex_state = 7},
  [2365] = {.lex_state = 7},
  [2366] = {.lex_state = 7},
  [2367] = {.lex_state = 7},
  [2368] = {.lex_state = 7},
  [2369] = {.lex_state = 7},
  [2370] = {.lex_state = 7},
  [2371] = {.lex_state = 7},
  [2372] = {.lex_state = 50},
  [2373] = {.lex_state = 50},
  [2374] = {.lex_state = 64},
  [2375] = {.lex_state = 58},
  [2376] = {.lex_state = 7},
  [2377] = {.lex_state = 7},
  [2378] = {.lex_state = 58},
  [2379] = {.lex_state = 7},
  [2380] = {.lex_state = 7},
  [2381] = {.lex_state = 7},
  [2382] = {.lex_state = 7},
  [2383] = {.lex_state = 58},
  [2384] = {.lex_state = 7},
  [2385] = {.lex_state = 7},
  [2386] = {.lex_state = 64},
  [2387] = {.lex_state = 7},
  [2388] = {.lex_state = 7},
  [2389] = {.lex_state = 35},
  [2390] = {.lex_state = 35},
  [2391] = {.lex_state = 7},
  [2392] = {.lex_state = 58},
  [2393] = {.lex_state = 58},
  [2394] = {.lex_state = 7},
  [2395] = {.lex_state = 58},
  [2396] = {.lex_state = 58},
  [2397] = {.lex_state = 58},
  [2398] = {.lex_state = 58},
  [2399] = {.lex_state = 58},
  [2400] = {.lex_state = 58},
  [2401] = {.lex_state = 58},
  [2402] = {.lex_state = 58},
  [2403] = {.lex_state = 58},
  [2404] = {.lex_state = 58},
  [2405] = {.lex_state = 58},
  [2406] = {.lex_state = 58},
  [2407] = {.lex_state = 58},
  [2408] = {.lex_state = 58},
  [2409] = {.lex_state = 58},
  [2410] = {.lex_state = 58},
  [2411] = {.lex_state = 58},
  [2412] = {.lex_state = 58},
  [2413] = {.lex_state = 58},
  [2414] = {.lex_state = 58},
  [2415] = {.lex_state = 58},
  [2416] = {.lex_state = 58},
  [2417] = {.lex_state = 58},
  [2418] = {.lex_state = 58},
  [2419] = {.lex_state = 58},
  [2420] = {.lex_state = 58},
  [2421] = {.lex_state = 58},
  [2422] = {.lex_state = 58},
  [2423] = {.lex_state = 58},
  [2424] = {.lex_state = 58},
  [2425] = {.lex_state = 58},
  [2426] = {.lex_state = 58},
  [2427] = {.lex_state = 58},
  [2428] = {.lex_state = 58},
  [2429] = {.lex_state = 58},
  [2430] = {.lex_state = 58},
  [2431] = {.lex_state = 58},
  [2432] = {.lex_state = 58},
  [2433] = {.lex_state = 58},
  [2434] = {.lex_state = 58},
  [2435] = {.lex_state = 58},
  [2436] = {.lex_state = 58},
  [2437] = {.lex_state = 58},
  [2438] = {.lex_state = 58},
  [2439] = {.lex_state = 58},
  [2440] = {.lex_state = 58},
  [2441] = {.lex_state = 58},
  [2442] = {.lex_state = 58},
  [2443] = {.lex_state = 58},
  [2444] = {.lex_state = 58},
  [2445] = {.lex_state = 58},
  [2446] = {.lex_state = 58},
  [2447] = {.lex_state = 58},
  [2448] = {.lex_state = 58},
  [2449] = {.lex_state = 58},
  [2450] = {.lex_state = 58},
  [2451] = {.lex_state = 58},
  [2452] = {.lex_state = 58},
  [2453] = {.lex_state = 58},
  [2454] = {.lex_state = 58},
  [2455] = {.lex_state = 58},
  [2456] = {.lex_state = 58},
  [2457] = {.lex_state = 58},
  [2458] = {.lex_state = 58},
  [2459] = {.lex_state = 58},
  [2460] = {.lex_state = 58},
  [2461] = {.lex_state = 58},
  [2462] = {.lex_state = 58},
  [2463] = {.lex_state = 58},
  [2464] = {.lex_state = 58},
  [2465] = {.lex_state = 58},
  [2466] = {.lex_state = 58},
  [2467] = {.lex_state = 58},
  [2468] = {.lex_state = 58},
  [2469] = {.lex_state = 58},
  [2470] = {.lex_state = 58},
  [2471] = {.lex_state = 58},
  [2472] = {.lex_state = 58},
  [2473] = {.lex_state = 58},
  [2474] = {.lex_state = 58},
  [2475] = {.lex_state = 58},
  [2476] = {.lex_state = 58},
  [2477] = {.lex_state = 58},
  [2478] = {.lex_state = 58},
  [2479] = {.lex_state = 58},
  [2480] = {.lex_state = 58},
  [2481] = {.lex_state = 58},
  [2482] = {.lex_state = 58},
  [2483] = {.lex_state = 58},
  [2484] = {.lex_state = 58},
  [2485] = {.lex_state = 58},
  [2486] = {.lex_state = 58},
  [2487] = {.lex_state = 58},
  [2488] = {.lex_state = 58},
  [2489] = {.lex_state = 58},
  [2490] = {.lex_state = 58},
  [2491] = {.lex_state = 58},
  [2492] = {.lex_state = 58},
  [2493] = {.lex_state = 58},
  [2494] = {.lex_state = 58},
  [2495] = {.lex_state = 58},
  [2496] = {.lex_state = 58},
  [2497] = {.lex_state = 58},
  [2498] = {.lex_state = 58},
  [2499] = {.lex_state = 58},
  [2500] = {.lex_state = 58},
  [2501] = {.lex_state = 58},
  [2502] = {.lex_state = 58},
  [2503] = {.lex_state = 58},
  [2504] = {.lex_state = 12},
  [2505] = {.lex_state = 60},
  [2506] = {.lex_state = 58},
  [2507] = {.lex_state = 58},
  [2508] = {.lex_state = 58},
  [2509] = {.lex_state = 58},
  [2510] = {.lex_state = 58},
  [2511] = {.lex_state = 12},
  [2512] = {.lex_state = 58},
  [2513] = {.lex_state = 60},
  [2514] = {.lex_state = 58},
  [2515] = {.lex_state = 12},
  [2516] = {.lex_state = 58},
  [2517] = {.lex_state = 60},
  [2518] = {.lex_state = 12},
  [2519] = {.lex_state = 58},
  [2520] = {.lex_state = 60},
  [2521] = {.lex_state = 58},
  [2522] = {.lex_state = 12},
  [2523] = {.lex_state = 12},
  [2524] = {.lex_state = 60},
  [2525] = {.lex_state = 15},
  [2526] = {.lex_state = 60},
  [2527] = {.lex_state = 12},
  [2528] = {.lex_state = 12},
  [2529] = {.lex_state = 17},
  [2530] = {.lex_state = 12},
  [2531] = {.lex_state = 12},
  [2532] = {.lex_state = 17},
  [2533] = {.lex_state = 17},
  [2534] = {.lex_state = 60},
  [2535] = {.lex_state = 12},
  [2536] = {.lex_state = 60},
  [2537] = {.lex_state = 60},
  [2538] = {.lex_state = 60},
  [2539] = {.lex_state = 12},
  [2540] = {.lex_state = 60},
  [2541] = {.lex_state = 58},
  [2542] = {.lex_state = 58},
  [2543] = {.lex_state = 58},
  [2544] = {.lex_state = 58},
  [2545] = {.lex_state = 52},
  [2546] = {.lex_state = 58},
  [2547] = {.lex_state = 58},
  [2548] = {.lex_state = 60},
  [2549] = {.lex_state = 40},
  [2550] = {.lex_state = 40},
  [2551] = {.lex_state = 60},
  [2552] = {.lex_state = 58},
  [2553] = {.lex_state = 7},
  [2554] = {.lex_state = 58},
  [2555] = {.lex_state = 58},
  [2556] = {.lex_state = 7},
  [2557] = {.lex_state = 60},
  [2558] = {.lex_state = 58},
  [2559] = {.lex_state = 58},
  [2560] = {.lex_state = 58},
  [2561] = {.lex_state = 12},
  [2562] = {.lex_state = 58},
  [2563] = {.lex_state = 58},
  [2564] = {.lex_state = 12},
  [2565] = {.lex_state = 58},
  [2566] = {.lex_state = 60},
  [2567] = {.lex_state = 60},
  [2568] = {.lex_state = 60},
  [2569] = {.lex_state = 52},
  [2570] = {.lex_state = 58},
  [2571] = {.lex_state = 10},
  [2572] = {.lex_state = 10},
  [2573] = {.lex_state = 60},
  [2574] = {.lex_state = 60},
  [2575] = {.lex_state = 58},
  [2576] = {.lex_state = 60},
  [2577] = {.lex_state = 58},
  [2578] = {.lex_state = 60},
  [2579] = {.lex_state = 60},
  [2580] = {.lex_state = 58},
  [2581] = {.lex_state = 58},
  [2582] = {.lex_state = 58},
  [2583] = {.lex_state = 58},
  [2584] = {.lex_state = 58},
  [2585] = {.lex_state = 12},
  [2586] = {.lex_state = 58},
  [2587] = {.lex_state = 58},
  [2588] = {.lex_state = 58},
  [2589] = {.lex_state = 60},
  [2590] = {.lex_state = 58},
  [2591] = {.lex_state = 60},
  [2592] = {.lex_state = 58},
  [2593] = {.lex_state = 58},
  [2594] = {.lex_state = 58},
  [2595] = {.lex_state = 62},
  [2596] = {.lex_state = 58},
  [2597] = {.lex_state = 58},
  [2598] = {.lex_state = 58},
  [2599] = {.lex_state = 60},
  [2600] = {.lex_state = 58},
  [2601] = {.lex_state = 60},
  [2602] = {.lex_state = 58},
  [2603] = {.lex_state = 58},
  [2604] = {.lex_state = 58},
  [2605] = {.lex_state = 58},
  [2606] = {.lex_state = 60},
  [2607] = {.lex_state = 58},
  [2608] = {.lex_state = 58},
  [2609] = {.lex_state = 12},
  [2610] = {.lex_state = 58},
  [2611] = {.lex_state = 12},
  [2612] = {.lex_state = 58},
  [2613] = {.lex_state = 58},
  [2614] = {.lex_state = 58},
  [2615] = {.lex_state = 58},
  [2616] = {.lex_state = 58},
  [2617] = {.lex_state = 58},
  [2618] = {.lex_state = 12},
  [2619] = {.lex_state = 58},
  [2620] = {.lex_state = 58},
  [2621] = {.lex_state = 12},
  [2622] = {.lex_state = 12},
  [2623] = {.lex_state = 60},
  [2624] = {.lex_state = 60},
  [2625] = {.lex_state = 12},
  [2626] = {.lex_state = 12},
  [2627] = {.lex_state = 60},
  [2628] = {.lex_state = 12},
  [2629] = {.lex_state = 12},
  [2630] = {.lex_state = 12},
  [2631] = {.lex_state = 12},
  [2632] = {.lex_state = 12},
  [2633] = {.lex_state = 12},
  [2634] = {.lex_state = 60},
  [2635] = {.lex_state = 60},
  [2636] = {.lex_state = 12},
  [2637] = {.lex_state = 12},
  [2638] = {.lex_state = 60},
  [2639] = {.lex_state = 68},
  [2640] = {.lex_state = 58},
  [2641] = {.lex_state = 60},
  [2642] = {.lex_state = 60},
  [2643] = {.lex_state = 58},
  [2644] = {.lex_state = 58},
  [2645] = {.lex_state = 68},
  [2646] = {.lex_state = 58},
  [2647] = {.lex_state = 58},
  [2648] = {.lex_state = 60},
  [2649] = {.lex_state = 60},
  [2650] = {.lex_state = 60},
  [2651] = {.lex_state = 60},
  [2652] = {.lex_state = 58},
  [2653] = {.lex_state = 60},
  [2654] = {.lex_state = 60},
  [2655] = {.lex_state = 58},
  [2656] = {.lex_state = 58},
  [2657] = {.lex_state = 62},
  [2658] = {.lex_state = 60},
  [2659] = {.lex_state = 60},
  [2660] = {.lex_state = 60},
  [2661] = {.lex_state = 60},
  [2662] = {.lex_state = 60},
  [2663] = {.lex_state = 60},
  [2664] = {.lex_state = 60},
  [2665] = {.lex_state = 60},
  [2666] = {.lex_state = 60},
  [2667] = {.lex_state = 60},
  [2668] = {.lex_state = 60},
  [2669] = {.lex_state = 12},
  [2670] = {.lex_state = 68},
  [2671] = {.lex_state = 12},
  [2672] = {.lex_state = 60},
  [2673] = {.lex_state = 60},
  [2674] = {.lex_state = 12},
  [2675] = {.lex_state = 12},
  [2676] = {.lex_state = 12},
  [2677] = {.lex_state = 60},
  [2678] = {.lex_state = 60},
  [2679] = {.lex_state = 60},
  [2680] = {.lex_state = 60},
  [2681] = {.lex_state = 60},
  [2682] = {.lex_state = 60},
  [2683] = {.lex_state = 60},
  [2684] = {.lex_state = 60},
  [2685] = {.lex_state = 60},
  [2686] = {.lex_state = 60},
  [2687] = {.lex_state = 58},
  [2688] = {.lex_state = 58},
  [2689] = {.lex_state = 58},
  [2690] = {.lex_state = 12},
  [2691] = {.lex_state = 12},
  [2692] = {.lex_state = 60},
  [2693] = {.lex_state = 60},
  [2694] = {.lex_state = 58},
  [2695] = {.lex_state = 60},
  [2696] = {.lex_state = 12},
  [2697] = {.lex_state = 60},
  [2698] = {.lex_state = 58},
  [2699] = {.lex_state = 60},
  [2700] = {.lex_state = 58},
  [2701] = {.lex_state = 58},
  [2702] = {.lex_state = 60},
  [2703] = {.lex_state = 58},
  [2704] = {.lex_state = 58},
  [2705] = {.lex_state = 60},
  [2706] = {.lex_state = 60},
  [2707] = {.lex_state = 60},
  [2708] = {.lex_state = 60},
  [2709] = {.lex_state = 60},
  [2710] = {.lex_state = 58},
  [2711] = {.lex_state = 54},
  [2712] = {.lex_state = 60},
  [2713] = {.lex_state = 60},
  [2714] = {.lex_state = 12},
  [2715] = {.lex_state = 12},
  [2716] = {.lex_state = 58},
  [2717] = {.lex_state = 60},
  [2718] = {.lex_state = 68},
  [2719] = {.lex_state = 68},
  [2720] = {.lex_state = 58},
  [2721] = {.lex_state = 60},
  [2722] = {.lex_state = 60},
  [2723] = {.lex_state = 12},
  [2724] = {.lex_state = 12},
  [2725] = {.lex_state = 54},
  [2726] = {.lex_state = 58},
  [2727] = {.lex_state = 12},
  [2728] = {.lex_state = 58},
  [2729] = {.lex_state = 12},
  [2730] = {.lex_state = 60},
  [2731] = {.lex_state = 60},
  [2732] = {.lex_state = 60},
  [2733] = {.lex_state = 60},
  [2734] = {.lex_state = 12},
  [2735] = {.lex_state = 60},
  [2736] = {.lex_state = 60},
  [2737] = {.lex_state = 60},
  [2738] = {.lex_state = 60},
  [2739] = {.lex_state = 60},
  [2740] = {.lex_state = 12},
  [2741] = {.lex_state = 12},
  [2742] = {.lex_state = 12},
  [2743] = {.lex_state = 58},
  [2744] = {.lex_state = 58},
  [2745] = {.lex_state = 58},
  [2746] = {.lex_state = 42},
  [2747] = {.lex_state = 60},
  [2748] = {.lex_state = 60},
  [2749] = {.lex_state = 62},
  [2750] = {.lex_state = 68},
  [2751] = {.lex_state = 60},
  [2752] = {.lex_state = 60},
  [2753] = {.lex_state = 58},
  [2754] = {.lex_state = 42},
  [2755] = {.lex_state = 58},
  [2756] = {.lex_state = 58},
  [2757] = {.lex_state = 60},
  [2758] = {.lex_state = 58},
  [2759] = {.lex_state = 58},
  [2760] = {.lex_state = 60},
  [2761] = {.lex_state = 60},
  [2762] = {.lex_state = 60},
  [2763] = {.lex_state = 60},
  [2764] = {.lex_state = 60},
  [2765] = {.lex_state = 58},
  [2766] = {.lex_state = 58},
  [2767] = {.lex_state = 60},
  [2768] = {.lex_state = 68},
  [2769] = {.lex_state = 60},
  [2770] = {.lex_state = 60},
  [2771] = {.lex_state = 60},
  [2772] = {.lex_state = 60},
  [2773] = {.lex_state = 60},
  [2774] = {.lex_state = 58},
  [2775] = {.lex_state = 60},
  [2776] = {.lex_state = 60},
  [2777] = {.lex_state = 58},
  [2778] = {.lex_state = 60},
  [2779] = {.lex_state = 58},
  [2780] = {.lex_state = 68},
  [2781] = {.lex_state = 60},
  [2782] = {.lex_state = 60},
  [2783] = {.lex_state = 60},
  [2784] = {.lex_state = 60},
  [2785] = {.lex_state = 12},
  [2786] = {.lex_state = 60},
  [2787] = {.lex_state = 60},
  [2788] = {.lex_state = 60},
  [2789] = {.lex_state = 60},
  [2790] = {.lex_state = 60},
  [2791] = {.lex_state = 60},
  [2792] = {.lex_state = 60},
  [2793] = {.lex_state = 12},
  [2794] = {.lex_state = 58},
  [2795] = {.lex_state = 60},
  [2796] = {.lex_state = 68},
  [2797] = {.lex_state = 12},
  [2798] = {.lex_state = 60},
  [2799] = {.lex_state = 60},
  [2800] = {.lex_state = 62},
  [2801] = {.lex_state = 58},
  [2802] = {.lex_state = 60},
  [2803] = {.lex_state = 12},
  [2804] = {.lex_state = 12},
  [2805] = {.lex_state = 12},
  [2806] = {.lex_state = 58},
  [2807] = {.lex_state = 58},
  [2808] = {.lex_state = 12},
  [2809] = {.lex_state = 12},
  [2810] = {.lex_state = 12},
  [2811] = {.lex_state = 12},
  [2812] = {.lex_state = 12},
  [2813] = {.lex_state = 12},
  [2814] = {.lex_state = 68},
  [2815] = {.lex_state = 12},
  [2816] = {.lex_state = 12},
  [2817] = {.lex_state = 12},
  [2818] = {.lex_state = 12},
  [2819] = {.lex_state = 12},
  [2820] = {.lex_state = 12},
  [2821] = {.lex_state = 12},
  [2822] = {.lex_state = 12},
  [2823] = {.lex_state = 12},
  [2824] = {.lex_state = 12},
  [2825] = {.lex_state = 12},
  [2826] = {.lex_state = 12},
  [2827] = {.lex_state = 12},
  [2828] = {.lex_state = 12},
  [2829] = {.lex_state = 12},
  [2830] = {.lex_state = 12},
  [2831] = {.lex_state = 60},
  [2832] = {.lex_state = 68},
  [2833] = {.lex_state = 60},
  [2834] = {.lex_state = 12},
  [2835] = {.lex_state = 58},
  [2836] = {.lex_state = 12},
  [2837] = {.lex_state = 12},
  [2838] = {.lex_state = 12},
  [2839] = {.lex_state = 58},
  [2840] = {.lex_state = 12},
  [2841] = {.lex_state = 60},
  [2842] = {.lex_state = 12},
  [2843] = {.lex_state = 58},
  [2844] = {.lex_state = 12},
  [2845] = {.lex_state = 12},
  [2846] = {.lex_state = 12},
  [2847] = {.lex_state = 12},
  [2848] = {.lex_state = 12},
  [2849] = {.lex_state = 12},
  [2850] = {.lex_state = 12},
  [2851] = {.lex_state = 12},
  [2852] = {.lex_state = 58},
  [2853] = {.lex_state = 60},
  [2854] = {.lex_state = 12},
  [2855] = {.lex_state = 12},
  [2856] = {.lex_state = 58},
  [2857] = {.lex_state = 12},
  [2858] = {.lex_state = 12},
  [2859] = {.lex_state = 12},
  [2860] = {.lex_state = 12},
  [2861] = {.lex_state = 58},
  [2862] = {.lex_state = 12},
  [2863] = {.lex_state = 58},
  [2864] = {.lex_state = 12},
  [2865] = {.lex_state = 58},
  [2866] = {.lex_state = 58},
  [2867] = {.lex_state = 58},
  [2868] = {.lex_state = 68},
  [2869] = {.lex_state = 58},
  [2870] = {.lex_state = 58},
  [2871] = {.lex_state = 58},
  [2872] = {.lex_state = 58},
  [2873] = {.lex_state = 12},
  [2874] = {.lex_state = 68},
  [2875] = {.lex_state = 58},
  [2876] = {.lex_state = 12},
  [2877] = {.lex_state = 12},
  [2878] = {.lex_state = 12},
  [2879] = {.lex_state = 68},
  [2880] = {.lex_state = 12},
  [2881] = {.lex_state = 12},
  [2882] = {.lex_state = 12},
  [2883] = {.lex_state = 12},
  [2884] = {.lex_state = 12},
  [2885] = {.lex_state = 58},
  [2886] = {.lex_state = 68},
  [2887] = {.lex_state = 58},
  [2888] = {.lex_state = 12},
  [2889] = {.lex_state = 12},
  [2890] = {.lex_state = 58},
  [2891] = {.lex_state = 12},
  [2892] = {.lex_state = 58},
  [2893] = {.lex_state = 58},
  [2894] = {.lex_state = 68},
  [2895] = {.lex_state = 12},
  [2896] = {.lex_state = 58},
  [2897] = {.lex_state = 12},
  [2898] = {.lex_state = 58},
  [2899] = {.lex_state = 68},
  [2900] = {.lex_state = 58},
  [2901] = {.lex_state = 58},
  [2902] = {.lex_state = 12},
  [2903] = {.lex_state = 58},
  [2904] = {.lex_state = 58},
  [2905] = {.lex_state = 66},
  [2906] = {.lex_state = 58},
  [2907] = {.lex_state = 58},
  [2908] = {.lex_state = 58},
  [2909] = {.lex_state = 66},
  [2910] = {.lex_state = 58},
  [2911] = {.lex_state = 58},
  [2912] = {.lex_state = 62},
  [2913] = {.lex_state = 58},
  [2914] = {.lex_state = 58},
  [2915] = {.lex_state = 58},
  [2916] = {.lex_state = 66},
  [2917] = {.lex_state = 58},
  [2918] = {.lex_state = 62},
  [2919] = {.lex_state = 58},
  [2920] = {.lex_state = 58},
  [2921] = {.lex_state = 58},
  [2922] = {.lex_state = 58},
  [2923] = {.lex_state = 58},
  [2924] = {.lex_state = 58},
  [2925] = {.lex_state = 58},
  [2926] = {.lex_state = 58},
  [2927] = {.lex_state = 58},
  [2928] = {.lex_state = 58},
  [2929] = {.lex_state = 66},
  [2930] = {.lex_state = 58},
  [2931] = {.lex_state = 68},
  [2932] = {.lex_state = 62},
  [2933] = {.lex_state = 58},
  [2934] = {.lex_state = 58},
  [2935] = {.lex_state = 62},
  [2936] = {.lex_state = 58},
  [2937] = {.lex_state = 62},
  [2938] = {.lex_state = 17},
  [2939] = {.lex_state = 62},
  [2940] = {.lex_state = 17},
  [2941] = {.lex_state = 68},
  [2942] = {.lex_state = 62},
  [2943] = {.lex_state = 58},
  [2944] = {.lex_state = 58},
  [2945] = {.lex_state = 58},
  [2946] = {.lex_state = 58},
  [2947] = {.lex_state = 62},
  [2948] = {.lex_state = 58},
  [2949] = {.lex_state = 62},
  [2950] = {.lex_state = 58},
  [2951] = {.lex_state = 58},
  [2952] = {.lex_state = 62},
  [2953] = {.lex_state = 68},
  [2954] = {.lex_state = 62},
  [2955] = {.lex_state = 62},
  [2956] = {.lex_state = 62},
  [2957] = {.lex_state = 62},
  [2958] = {.lex_state = 58},
  [2959] = {.lex_state = 17},
  [2960] = {.lex_state = 58},
  [2961] = {.lex_state = 62},
  [2962] = {.lex_state = 62},
  [2963] = {.lex_state = 68},
  [2964] = {.lex_state = 62},
  [2965] = {.lex_state = 62},
  [2966] = {.lex_state = 62},
  [2967] = {.lex_state = 58},
  [2968] = {.lex_state = 62},
  [2969] = {.lex_state = 62},
  [2970] = {.lex_state = 62},
  [2971] = {.lex_state = 62},
  [2972] = {.lex_state = 62},
  [2973] = {.lex_state = 62},
  [2974] = {.lex_state = 58},
  [2975] = {.lex_state = 62},
  [2976] = {.lex_state = 62},
  [2977] = {.lex_state = 62},
  [2978] = {.lex_state = 62},
  [2979] = {.lex_state = 62},
  [2980] = {.lex_state = 62},
  [2981] = {.lex_state = 58},
  [2982] = {.lex_state = 58},
  [2983] = {.lex_state = 58},
  [2984] = {.lex_state = 58},
  [2985] = {.lex_state = 58},
  [2986] = {.lex_state = 58},
  [2987] = {.lex_state = 58},
  [2988] = {.lex_state = 58},
  [2989] = {.lex_state = 58},
  [2990] = {.lex_state = 58},
  [2991] = {.lex_state = 58},
  [2992] = {.lex_state = 58},
  [2993] = {.lex_state = 58},
  [2994] = {.lex_state = 58},
  [2995] = {.lex_state = 58},
  [2996] = {.lex_state = 58},
  [2997] = {.lex_state = 58},
  [2998] = {.lex_state = 58},
  [2999] = {.lex_state = 58},
  [3000] = {.lex_state = 58},
  [3001] = {.lex_state = 58},
  [3002] = {.lex_state = 58},
  [3003] = {.lex_state = 58},
  [3004] = {.lex_state = 58},
  [3005] = {.lex_state = 58},
  [3006] = {.lex_state = 58},
  [3007] = {.lex_state = 58},
  [3008] = {.lex_state = 58},
  [3009] = {.lex_state = 58},
  [3010] = {.lex_state = 58},
  [3011] = {.lex_state = 58},
  [3012] = {.lex_state = 58},
  [3013] = {.lex_state = 58},
  [3014] = {.lex_state = 58},
  [3015] = {.lex_state = 58},
  [3016] = {.lex_state = 58},
  [3017] = {.lex_state = 58},
  [3018] = {.lex_state = 58},
  [3019] = {.lex_state = 58},
  [3020] = {.lex_state = 58},
  [3021] = {.lex_state = 58},
  [3022] = {.lex_state = 58},
  [3023] = {.lex_state = 58},
  [3024] = {.lex_state = 58},
  [3025] = {.lex_state = 58},
  [3026] = {.lex_state = 58},
  [3027] = {.lex_state = 58},
  [3028] = {.lex_state = 58},
  [3029] = {.lex_state = 58},
  [3030] = {.lex_state = 58},
  [3031] = {.lex_state = 58},
  [3032] = {.lex_state = 58},
  [3033] = {.lex_state = 58},
  [3034] = {.lex_state = 58},
  [3035] = {.lex_state = 58},
  [3036] = {.lex_state = 58},
  [3037] = {.lex_state = 58},
  [3038] = {.lex_state = 58},
  [3039] = {.lex_state = 58},
  [3040] = {.lex_state = 58},
  [3041] = {.lex_state = 58},
  [3042] = {.lex_state = 58},
  [3043] = {.lex_state = 58},
  [3044] = {.lex_state = 58},
  [3045] = {.lex_state = 58},
  [3046] = {.lex_state = 58},
  [3047] = {.lex_state = 58},
  [3048] = {.lex_state = 58},
  [3049] = {.lex_state = 58},
  [3050] = {.lex_state = 58},
  [3051] = {.lex_state = 58},
  [3052] = {.lex_state = 58},
  [3053] = {.lex_state = 58},
  [3054] = {.lex_state = 58},
  [3055] = {.lex_state = 58},
  [3056] = {.lex_state = 58},
  [3057] = {.lex_state = 58},
  [3058] = {.lex_state = 58},
  [3059] = {.lex_state = 58},
  [3060] = {.lex_state = 68},
  [3061] = {.lex_state = 68},
  [3062] = {.lex_state = 68},
  [3063] = {.lex_state = 68},
  [3064] = {.lex_state = 68},
  [3065] = {.lex_state = 68},
  [3066] = {.lex_state = 68},
  [3067] = {.lex_state = 68},
  [3068] = {.lex_state = 68},
  [3069] = {.lex_state = 68},
  [3070] = {.lex_state = 68},
  [3071] = {.lex_state = 68},
  [3072] = {.lex_state = 68},
  [3073] = {.lex_state = 68},
  [3074] = {.lex_state = 68},
  [3075] = {.lex_state = 68},
  [3076] = {.lex_state = 68},
  [3077] = {.lex_state = 68},
  [3078] = {.lex_state = 68},
  [3079] = {.lex_state = 68},
  [3080] = {.lex_state = 68},
  [3081] = {.lex_state = 68},
  [3082] = {.lex_state = 68},
  [3083] = {.lex_state = 68},
  [3084] = {.lex_state = 68},
  [3085] = {.lex_state = 68},
  [3086] = {.lex_state = 68},
  [3087] = {.lex_state = 68},
  [3088] = {.lex_state = 68},
  [3089] = {.lex_state = 68},
  [3090] = {.lex_state = 68},
  [3091] = {.lex_state = 68},
  [3092] = {.lex_state = 68},
  [3093] = {.lex_state = 68},
  [3094] = {.lex_state = 68},
  [3095] = {.lex_state = 68},
  [3096] = {.lex_state = 68},
  [3097] = {.lex_state = 68},
  [3098] = {.lex_state = 68},
  [3099] = {.lex_state = 68},
  [3100] = {.lex_state = 68},
  [3101] = {.lex_state = 68},
  [3102] = {.lex_state = 68},
  [3103] = {.lex_state = 68},
  [3104] = {.lex_state = 68},
  [3105] = {.lex_state = 68},
  [3106] = {.lex_state = 68},
  [3107] = {.lex_state = 68},
  [3108] = {.lex_state = 68},
  [3109] = {.lex_state = 68},
  [3110] = {.lex_state = 68},
  [3111] = {.lex_state = 68},
  [3112] = {.lex_state = 68},
  [3113] = {.lex_state = 68},
  [3114] = {.lex_state = 68},
  [3115] = {.lex_state = 68},
  [3116] = {.lex_state = 68},
  [3117] = {.lex_state = 68},
  [3118] = {.lex_state = 68},
  [3119] = {.lex_state = 68},
  [3120] = {.lex_state = 68},
  [3121] = {.lex_state = 68},
  [3122] = {.lex_state = 68},
  [3123] = {.lex_state = 68},
  [3124] = {.lex_state = 68},
  [3125] = {.lex_state = 68},
  [3126] = {.lex_state = 68},
  [3127] = {.lex_state = 68},
  [3128] = {.lex_state = 68},
  [3129] = {.lex_state = 68},
  [3130] = {.lex_state = 68},
  [3131] = {.lex_state = 68},
  [3132] = {.lex_state = 68},
  [3133] = {.lex_state = 68},
  [3134] = {.lex_state = 68},
  [3135] = {.lex_state = 68},
  [3136] = {.lex_state = 68},
  [3137] = {.lex_state = 68},
  [3138] = {.lex_state = 68},
  [3139] = {.lex_state = 68},
  [3140] = {.lex_state = 68},
  [3141] = {.lex_state = 68},
  [3142] = {.lex_state = 68},
  [3143] = {.lex_state = 68},
  [3144] = {.lex_state = 68},
  [3145] = {.lex_state = 68},
  [3146] = {.lex_state = 68},
  [3147] = {.lex_state = 68},
  [3148] = {.lex_state = 68},
  [3149] = {.lex_state = 68},
  [3150] = {.lex_state = 68},
  [3151] = {.lex_state = 68},
  [3152] = {.lex_state = 68},
  [3153] = {.lex_state = 68},
  [3154] = {.lex_state = 68},
  [3155] = {.lex_state = 68},
  [3156] = {.lex_state = 68},
  [3157] = {.lex_state = 68},
  [3158] = {.lex_state = 68},
  [3159] = {.lex_state = 68},
  [3160] = {.lex_state = 68},
  [3161] = {.lex_state = 68},
  [3162] = {.lex_state = 68},
  [3163] = {.lex_state = 68},
  [3164] = {.lex_state = 68},
  [3165] = {.lex_state = 68},
  [3166] = {.lex_state = 68},
  [3167] = {.lex_state = 68},
  [3168] = {.lex_state = 68},
  [3169] = {.lex_state = 68},
  [3170] = {.lex_state = 68},
  [3171] = {.lex_state = 68},
  [3172] = {.lex_state = 68},
  [3173] = {.lex_state = 68},
  [3174] = {.lex_state = 68},
  [3175] = {.lex_state = 68},
  [3176] = {.lex_state = 68},
  [3177] = {.lex_state = 68},
  [3178] = {.lex_state = 68},
  [3179] = {.lex_state = 68},
  [3180] = {.lex_state = 68},
  [3181] = {.lex_state = 68},
  [3182] = {.lex_state = 68},
  [3183] = {.lex_state = 68},
  [3184] = {.lex_state = 68},
  [3185] = {.lex_state = 68},
  [3186] = {.lex_state = 68},
  [3187] = {.lex_state = 68},
  [3188] = {.lex_state = 68},
  [3189] = {.lex_state = 68},
  [3190] = {.lex_state = 68},
  [3191] = {.lex_state = 68},
  [3192] = {.lex_state = 68},
  [3193] = {.lex_state = 68},
  [3194] = {.lex_state = 68},
  [3195] = {.lex_state = 68},
  [3196] = {.lex_state = 68},
  [3197] = {.lex_state = 68},
  [3198] = {.lex_state = 68},
  [3199] = {.lex_state = 68},
  [3200] = {.lex_state = 68},
  [3201] = {.lex_state = 68},
  [3202] = {.lex_state = 68},
  [3203] = {.lex_state = 68},
  [3204] = {.lex_state = 68},
  [3205] = {.lex_state = 68},
  [3206] = {.lex_state = 68},
  [3207] = {.lex_state = 68},
  [3208] = {.lex_state = 68},
  [3209] = {.lex_state = 68},
  [3210] = {.lex_state = 68},
  [3211] = {.lex_state = 68},
  [3212] = {.lex_state = 68},
  [3213] = {.lex_state = 68},
  [3214] = {.lex_state = 68},
  [3215] = {.lex_state = 68},
  [3216] = {.lex_state = 68},
  [3217] = {.lex_state = 68},
  [3218] = {.lex_state = 68},
  [3219] = {.lex_state = 68},
  [3220] = {.lex_state = 68},
  [3221] = {.lex_state = 68},
  [3222] = {.lex_state = 68},
  [3223] = {.lex_state = 68},
  [3224] = {.lex_state = 68},
  [3225] = {.lex_state = 68},
  [3226] = {.lex_state = 68},
  [3227] = {.lex_state = 68},
  [3228] = {.lex_state = 68},
  [3229] = {.lex_state = 68},
  [3230] = {.lex_state = 68},
  [3231] = {.lex_state = 68},
  [3232] = {.lex_state = 68},
  [3233] = {.lex_state = 68},
  [3234] = {.lex_state = 68},
  [3235] = {.lex_state = 68},
  [3236] = {.lex_state = 68},
  [3237] = {.lex_state = 68},
  [3238] = {.lex_state = 68},
  [3239] = {.lex_state = 68},
  [3240] = {.lex_state = 68},
  [3241] = {.lex_state = 68},
  [3242] = {.lex_state = 68},
  [3243] = {.lex_state = 68},
  [3244] = {.lex_state = 68},
  [3245] = {.lex_state = 68},
  [3246] = {.lex_state = 68},
  [3247] = {.lex_state = 68},
  [3248] = {.lex_state = 68},
  [3249] = {.lex_state = 68},
  [3250] = {.lex_state = 68},
  [3251] = {.lex_state = 68},
  [3252] = {.lex_state = 68},
  [3253] = {.lex_state = 68},
  [3254] = {.lex_state = 68},
  [3255] = {.lex_state = 68},
  [3256] = {.lex_state = 68},
  [3257] = {.lex_state = 68},
  [3258] = {.lex_state = 68},
  [3259] = {.lex_state = 68},
  [3260] = {.lex_state = 68},
  [3261] = {.lex_state = 68},
  [3262] = {.lex_state = 68},
  [3263] = {.lex_state = 68},
  [3264] = {.lex_state = 68},
  [3265] = {.lex_state = 68},
  [3266] = {.lex_state = 68},
  [3267] = {.lex_state = 68},
  [3268] = {.lex_state = 68},
  [3269] = {.lex_state = 68},
  [3270] = {.lex_state = 68},
  [3271] = {.lex_state = 68},
  [3272] = {.lex_state = 68},
  [3273] = {.lex_state = 68},
  [3274] = {.lex_state = 68},
  [3275] = {.lex_state = 68},
  [3276] = {.lex_state = 68},
  [3277] = {.lex_state = 68},
  [3278] = {.lex_state = 68},
  [3279] = {.lex_state = 68},
  [3280] = {.lex_state = 68},
  [3281] = {.lex_state = 68},
  [3282] = {.lex_state = 68},
  [3283] = {.lex_state = 68},
  [3284] = {.lex_state = 68},
  [3285] = {.lex_state = 68},
  [3286] = {.lex_state = 68},
  [3287] = {.lex_state = 68},
  [3288] = {.lex_state = 68},
  [3289] = {.lex_state = 68},
  [3290] = {.lex_state = 68},
  [3291] = {.lex_state = 68},
  [3292] = {.lex_state = 68},
  [3293] = {.lex_state = 68},
  [3294] = {.lex_state = 68},
  [3295] = {.lex_state = 68},
  [3296] = {.lex_state = 68},
  [3297] = {.lex_state = 68},
  [3298] = {.lex_state = 68},
  [3299] = {.lex_state = 68},
  [3300] = {.lex_state = 68},
  [3301] = {.lex_state = 68},
  [3302] = {.lex_state = 68},
  [3303] = {.lex_state = 68},
  [3304] = {.lex_state = 68},
  [3305] = {.lex_state = 68},
  [3306] = {.lex_state = 68},
  [3307] = {.lex_state = 68},
  [3308] = {.lex_state = 68},
  [3309] = {.lex_state = 68},
  [3310] = {.lex_state = 68},
  [3311] = {.lex_state = 68},
  [3312] = {.lex_state = 68},
  [3313] = {.lex_state = 68},
  [3314] = {.lex_state = 68},
  [3315] = {.lex_state = 68},
  [3316] = {.lex_state = 68},
  [3317] = {.lex_state = 68},
  [3318] = {.lex_state = 68},
  [3319] = {.lex_state = 68},
  [3320] = {.lex_state = 68},
  [3321] = {.lex_state = 68},
  [3322] = {.lex_state = 68},
  [3323] = {.lex_state = 68},
  [3324] = {.lex_state = 68},
  [3325] = {.lex_state = 68},
  [3326] = {.lex_state = 68},
  [3327] = {.lex_state = 68},
  [3328] = {.lex_state = 68},
  [3329] = {.lex_state = 68},
  [3330] = {.lex_state = 68},
  [3331] = {.lex_state = 68},
  [3332] = {.lex_state = 68},
  [3333] = {.lex_state = 68},
  [3334] = {.lex_state = 68},
  [3335] = {.lex_state = 68},
  [3336] = {.lex_state = 68},
  [3337] = {.lex_state = 68},
  [3338] = {.lex_state = 68},
  [3339] = {.lex_state = 68},
  [3340] = {.lex_state = 68},
  [3341] = {.lex_state = 68},
  [3342] = {.lex_state = 68},
  [3343] = {.lex_state = 68},
  [3344] = {.lex_state = 68},
  [3345] = {.lex_state = 68},
  [3346] = {.lex_state = 68},
  [3347] = {.lex_state = 72},
  [3348] = {.lex_state = 68},
  [3349] = {.lex_state = 68},
  [3350] = {.lex_state = 68},
  [3351] = {.lex_state = 68},
  [3352] = {.lex_state = 68},
  [3353] = {.lex_state = 68},
  [3354] = {.lex_state = 68},
  [3355] = {.lex_state = 72},
  [3356] = {.lex_state = 68},
  [3357] = {.lex_state = 68},
  [3358] = {.lex_state = 68},
  [3359] = {.lex_state = 68},
  [3360] = {.lex_state = 68},
  [3361] = {.lex_state = 68},
  [3362] = {.lex_state = 71},
  [3363] = {.lex_state = 17},
  [3364] = {.lex_state = 17},
  [3365] = {.lex_state = 17},
  [3366] = {.lex_state = 17},
  [3367] = {.lex_state = 17},
  [3368] = {.lex_state = 68},
  [3369] = {.lex_state = 68},
  [3370] = {.lex_state = 68},
  [3371] = {.lex_state = 70},
  [3372] = {.lex_state = 70},
  [3373] = {.lex_state = 72},
  [3374] = {.lex_state = 68},
  [3375] = {.lex_state = 68},
  [3376] = {.lex_state = 70},
  [3377] = {.lex_state = 26},
  [3378] = {.lex_state = 18},
  [3379] = {.lex_state = 26},
  [3380] = {.lex_state = 26},
  [3381] = {.lex_state = 18},
  [3382] = {.lex_state = 68},
  [3383] = {.lex_state = 26},
  [3384] = {.lex_state = 68},
  [3385] = {.lex_state = 26},
  [3386] = {.lex_state = 26},
  [3387] = {.lex_state = 26},
  [3388] = {.lex_state = 26},
  [3389] = {.lex_state = 26},
  [3390] = {.lex_state = 26},
  [3391] = {.lex_state = 26},
  [3392] = {.lex_state = 26},
  [3393] = {.lex_state = 68},
  [3394] = {.lex_state = 68},
  [3395] = {.lex_state = 71},
  [3396] = {.lex_state = 71},
  [3397] = {.lex_state = 71},
  [3398] = {.lex_state = 71},
  [3399] = {.lex_state = 19},
  [3400] = {.lex_state = 71},
  [3401] = {.lex_state = 71},
  [3402] = {.lex_state = 71},
  [3403] = {.lex_state = 71},
  [3404] = {.lex_state = 26},
  [3405] = {.lex_state = 71},
  [3406] = {.lex_state = 19},
  [3407] = {.lex_state = 18},
  [3408] = {.lex_state = 71},
  [3409] = {.lex_state = 71},
  [3410] = {.lex_state = 71},
  [3411] = {.lex_state = 71},
  [3412] = {.lex_state = 71},
  [3413] = {.lex_state = 71},
  [3414] = {.lex_state = 71},
  [3415] = {.lex_state = 71},
  [3416] = {.lex_state = 70},
  [3417] = {.lex_state = 71},
  [3418] = {.lex_state = 71},
  [3419] = {.lex_state = 71},
  [3420] = {.lex_state = 71},
  [3421] = {.lex_state = 71},
  [3422] = {.lex_state = 71},
  [3423] = {.lex_state = 19},
  [3424] = {.lex_state = 19},
  [3425] = {.lex_state = 71},
  [3426] = {.lex_state = 71},
  [3427] = {.lex_state = 71},
  [3428] = {.lex_state = 71},
  [3429] = {.lex_state = 71},
  [3430] = {.lex_state = 70},
  [3431] = {.lex_state = 26},
  [3432] = {.lex_state = 70},
  [3433] = {.lex_state = 70},
  [3434] = {.lex_state = 71},
  [3435] = {.lex_state = 71},
  [3436] = {.lex_state = 26},
  [3437] = {.lex_state = 71},
  [3438] = {.lex_state = 71},
  [3439] = {.lex_state = 71},
  [3440] = {.lex_state = 70},
  [3441] = {.lex_state = 70},
  [3442] = {.lex_state = 70},
  [3443] = {.lex_state = 70},
  [3444] = {.lex_state = 71},
  [3445] = {.lex_state = 26},
  [3446] = {.lex_state = 70},
  [3447] = {.lex_state = 18},
  [3448] = {.lex_state = 18},
  [3449] = {.lex_state = 70},
  [3450] = {.lex_state = 18},
  [3451] = {.lex_state = 70},
  [3452] = {.lex_state = 18},
  [3453] = {.lex_state = 70},
  [3454] = {.lex_state = 18},
  [3455] = {.lex_state = 18},
  [3456] = {.lex_state = 18},
  [3457] = {.lex_state = 19},
  [3458] = {.lex_state = 18},
  [3459] = {.lex_state = 18},
  [3460] = {.lex_state = 18},
  [3461] = {.lex_state = 18},
  [3462] = {.lex_state = 18},
  [3463] = {.lex_state = 18},
  [3464] = {.lex_state = 18},
  [3465] = {.lex_state = 18},
  [3466] = {.lex_state = 18},
  [3467] = {.lex_state = 18},
  [3468] = {.lex_state = 18},
  [3469] = {.lex_state = 18},
  [3470] = {.lex_state = 70},
  [3471] = {.lex_state = 18},
  [3472] = {.lex_state = 18},
  [3473] = {.lex_state = 18},
  [3474] = {.lex_state = 18},
  [3475] = {.lex_state = 18},
  [3476] = {.lex_state = 18},
  [3477] = {.lex_state = 18},
  [3478] = {.lex_state = 18},
  [3479] = {.lex_state = 71},
  [3480] = {.lex_state = 71},
  [3481] = {.lex_state = 19},
  [3482] = {.lex_state = 66},
  [3483] = {.lex_state = 18},
  [3484] = {.lex_state = 66},
  [3485] = {.lex_state = 66},
  [3486] = {.lex_state = 66},
  [3487] = {.lex_state = 71},
  [3488] = {.lex_state = 66},
  [3489] = {.lex_state = 18},
  [3490] = {.lex_state = 66},
  [3491] = {.lex_state = 66},
  [3492] = {.lex_state = 66},
  [3493] = {.lex_state = 66},
  [3494] = {.lex_state = 18},
  [3495] = {.lex_state = 18},
  [3496] = {.lex_state = 66},
  [3497] = {.lex_state = 71},
  [3498] = {.lex_state = 66},
  [3499] = {.lex_state = 66},
  [3500] = {.lex_state = 18},
  [3501] = {.lex_state = 18},
  [3502] = {.lex_state = 12},
  [3503] = {.lex_state = 18},
  [3504] = {.lex_state = 18},
  [3505] = {.lex_state = 18},
  [3506] = {.lex_state = 18},
  [3507] = {.lex_state = 18},
  [3508] = {.lex_state = 18},
  [3509] = {.lex_state = 18},
  [3510] = {.lex_state = 71},
  [3511] = {.lex_state = 12},
  [3512] = {.lex_state = 12},
  [3513] = {.lex_state = 12},
  [3514] = {.lex_state = 18},
  [3515] = {.lex_state = 71},
  [3516] = {.lex_state = 18},
  [3517] = {.lex_state = 18},
  [3518] = {.lex_state = 12},
  [3519] = {.lex_state = 80},
  [3520] = {.lex_state = 80},
  [3521] = {.lex_state = 73},
  [3522] = {.lex_state = 80},
  [3523] = {.lex_state = 73},
  [3524] = {.lex_state = 80},
  [3525] = {.lex_state = 73},
  [3526] = {.lex_state = 66},
  [3527] = {.lex_state = 73},
  [3528] = {.lex_state = 80},
  [3529] = {.lex_state = 73},
  [3530] = {.lex_state = 80},
  [3531] = {.lex_state = 12},
  [3532] = {.lex_state = 66},
  [3533] = {.lex_state = 80},
  [3534] = {.lex_state = 73},
  [3535] = {.lex_state = 66},
  [3536] = {.lex_state = 66},
  [3537] = {.lex_state = 73},
  [3538] = {.lex_state = 73},
  [3539] = {.lex_state = 80},
  [3540] = {.lex_state = 66},
  [3541] = {.lex_state = 73},
  [3542] = {.lex_state = 80},
  [3543] = {.lex_state = 66},
  [3544] = {.lex_state = 80},
  [3545] = {.lex_state = 73},
  [3546] = {.lex_state = 73},
  [3547] = {.lex_state = 71},
  [3548] = {.lex_state = 73},
  [3549] = {.lex_state = 80},
  [3550] = {.lex_state = 73},
  [3551] = {.lex_state = 80},
  [3552] = {.lex_state = 80},
  [3553] = {.lex_state = 73},
  [3554] = {.lex_state = 80},
  [3555] = {.lex_state = 73},
  [3556] = {.lex_state = 66},
  [3557] = {.lex_state = 80},
  [3558] = {.lex_state = 73},
  [3559] = {.lex_state = 80},
  [3560] = {.lex_state = 80},
  [3561] = {.lex_state = 66},
  [3562] = {.lex_state = 66},
  [3563] = {.lex_state = 71},
  [3564] = {.lex_state = 66},
  [3565] = {.lex_state = 73},
  [3566] = {.lex_state = 80},
  [3567] = {.lex_state = 73},
  [3568] = {.lex_state = 80},
  [3569] = {.lex_state = 80},
  [3570] = {.lex_state = 80},
  [3571] = {.lex_state = 73},
  [3572] = {.lex_state = 80},
  [3573] = {.lex_state = 73},
  [3574] = {.lex_state = 73},
  [3575] = {.lex_state = 73},
  [3576] = {.lex_state = 80},
  [3577] = {.lex_state = 73},
  [3578] = {.lex_state = 80},
  [3579] = {.lex_state = 71},
  [3580] = {.lex_state = 73},
  [3581] = {.lex_state = 80},
  [3582] = {.lex_state = 73},
  [3583] = {.lex_state = 80},
  [3584] = {.lex_state = 66},
  [3585] = {.lex_state = 80},
  [3586] = {.lex_state = 73},
  [3587] = {.lex_state = 66},
  [3588] = {.lex_state = 80},
  [3589] = {.lex_state = 80},
  [3590] = {.lex_state = 73},
  [3591] = {.lex_state = 80},
  [3592] = {.lex_state = 80},
  [3593] = {.lex_state = 73},
  [3594] = {.lex_state = 73},
  [3595] = {.lex_state = 18},
  [3596] = {.lex_state = 80},
  [3597] = {.lex_state = 73},
  [3598] = {.lex_state = 80},
  [3599] = {.lex_state = 73},
  [3600] = {.lex_state = 80},
  [3601] = {.lex_state = 73},
  [3602] = {.lex_state = 66},
  [3603] = {.lex_state = 73},
  [3604] = {.lex_state = 73},
  [3605] = {.lex_state = 66},
  [3606] = {.lex_state = 80},
  [3607] = {.lex_state = 73},
  [3608] = {.lex_state = 73},
  [3609] = {.lex_state = 80},
  [3610] = {.lex_state = 66},
  [3611] = {.lex_state = 66},
  [3612] = {.lex_state = 80},
  [3613] = {.lex_state = 73},
  [3614] = {.lex_state = 66},
  [3615] = {.lex_state = 66},
  [3616] = {.lex_state = 71},
  [3617] = {.lex_state = 73},
  [3618] = {.lex_state = 80},
  [3619] = {.lex_state = 73},
  [3620] = {.lex_state = 80},
  [3621] = {.lex_state = 66},
  [3622] = {.lex_state = 73},
  [3623] = {.lex_state = 80},
  [3624] = {.lex_state = 73},
  [3625] = {.lex_state = 80},
  [3626] = {.lex_state = 73},
  [3627] = {.lex_state = 80},
  [3628] = {.lex_state = 80},
  [3629] = {.lex_state = 66},
  [3630] = {.lex_state = 66},
  [3631] = {.lex_state = 66},
  [3632] = {.lex_state = 80},
  [3633] = {.lex_state = 73},
  [3634] = {.lex_state = 73},
  [3635] = {.lex_state = 80},
  [3636] = {.lex_state = 73},
  [3637] = {.lex_state = 73},
  [3638] = {.lex_state = 66},
  [3639] = {.lex_state = 80},
  [3640] = {.lex_state = 80},
  [3641] = {.lex_state = 73},
  [3642] = {.lex_state = 73},
  [3643] = {.lex_state = 80},
  [3644] = {.lex_state = 73},
  [3645] = {.lex_state = 80},
  [3646] = {.lex_state = 66},
  [3647] = {.lex_state = 71},
  [3648] = {.lex_state = 178},
  [3649] = {.lex_state = 0},
  [3650] = {.lex_state = 75},
  [3651] = {.lex_state = 0},
  [3652] = {.lex_state = 71},
  [3653] = {.lex_state = 178},
  [3654] = {.lex_state = 71},
  [3655] = {.lex_state = 178},
  [3656] = {.lex_state = 178},
  [3657] = {.lex_state = 80},
  [3658] = {.lex_state = 71},
  [3659] = {.lex_state = 66},
  [3660] = {.lex_state = 71},
  [3661] = {.lex_state = 66},
  [3662] = {.lex_state = 0},
  [3663] = {.lex_state = 73},
  [3664] = {.lex_state = 73},
  [3665] = {.lex_state = 66},
  [3666] = {.lex_state = 18},
  [3667] = {.lex_state = 71},
  [3668] = {.lex_state = 178},
  [3669] = {.lex_state = 184},
  [3670] = {.lex_state = 73},
  [3671] = {.lex_state = 178},
  [3672] = {.lex_state = 71},
  [3673] = {.lex_state = 0},
  [3674] = {.lex_state = 66},
  [3675] = {.lex_state = 18},
  [3676] = {.lex_state = 66},
  [3677] = {.lex_state = 80},
  [3678] = {.lex_state = 71},
  [3679] = {.lex_state = 66},
  [3680] = {.lex_state = 18},
  [3681] = {.lex_state = 66},
  [3682] = {.lex_state = 66},
  [3683] = {.lex_state = 0},
  [3684] = {.lex_state = 73},
  [3685] = {.lex_state = 80},
  [3686] = {.lex_state = 0},
  [3687] = {.lex_state = 0},
  [3688] = {.lex_state = 0},
  [3689] = {.lex_state = 0},
  [3690] = {.lex_state = 80},
  [3691] = {.lex_state = 71},
  [3692] = {.lex_state = 0},
  [3693] = {.lex_state = 0},
  [3694] = {.lex_state = 71},
  [3695] = {.lex_state = 85},
  [3696] = {.lex_state = 71},
  [3697] = {.lex_state = 0},
  [3698] = {.lex_state = 44},
  [3699] = {.lex_state = 44},
  [3700] = {.lex_state = 0},
  [3701] = {.lex_state = 71},
  [3702] = {.lex_state = 0},
  [3703] = {.lex_state = 0},
  [3704] = {.lex_state = 71},
  [3705] = {.lex_state = 0},
  [3706] = {.lex_state = 71},
  [3707] = {.lex_state = 0},
  [3708] = {.lex_state = 71},
  [3709] = {.lex_state = 0},
  [3710] = {.lex_state = 71},
  [3711] = {.lex_state = 0},
  [3712] = {.lex_state = 71},
  [3713] = {.lex_state = 71},
  [3714] = {.lex_state = 44},
  [3715] = {.lex_state = 0},
  [3716] = {.lex_state = 44},
  [3717] = {.lex_state = 44},
  [3718] = {.lex_state = 178},
  [3719] = {.lex_state = 85},
  [3720] = {.lex_state = 71},
  [3721] = {.lex_state = 0},
  [3722] = {.lex_state = 44},
  [3723] = {.lex_state = 178},
  [3724] = {.lex_state = 44},
  [3725] = {.lex_state = 71},
  [3726] = {.lex_state = 71},
  [3727] = {.lex_state = 0},
  [3728] = {.lex_state = 71},
  [3729] = {.lex_state = 66},
  [3730] = {.lex_state = 44},
  [3731] = {.lex_state = 71},
  [3732] = {.lex_state = 66},
  [3733] = {.lex_state = 71},
  [3734] = {.lex_state = 0},
  [3735] = {.lex_state = 0},
  [3736] = {.lex_state = 0},
  [3737] = {.lex_state = 184},
  [3738] = {.lex_state = 75},
  [3739] = {.lex_state = 44},
  [3740] = {.lex_state = 71},
  [3741] = {.lex_state = 0},
  [3742] = {.lex_state = 44},
  [3743] = {.lex_state = 71},
  [3744] = {.lex_state = 44},
  [3745] = {.lex_state = 0},
  [3746] = {.lex_state = 75},
  [3747] = {.lex_state = 71},
  [3748] = {.lex_state = 44},
  [3749] = {.lex_state = 44},
  [3750] = {.lex_state = 0},
  [3751] = {.lex_state = 44},
  [3752] = {.lex_state = 71},
  [3753] = {.lex_state = 71},
  [3754] = {.lex_state = 0},
  [3755] = {.lex_state = 71},
  [3756] = {.lex_state = 71},
  [3757] = {.lex_state = 184},
  [3758] = {.lex_state = 44},
  [3759] = {.lex_state = 0},
  [3760] = {.lex_state = 71},
  [3761] = {.lex_state = 44},
  [3762] = {.lex_state = 0},
  [3763] = {.lex_state = 44},
  [3764] = {.lex_state = 178},
  [3765] = {.lex_state = 71},
  [3766] = {.lex_state = 71},
  [3767] = {.lex_state = 44},
  [3768] = {.lex_state = 44},
  [3769] = {.lex_state = 0},
  [3770] = {.lex_state = 71},
  [3771] = {.lex_state = 71},
  [3772] = {.lex_state = 0},
  [3773] = {.lex_state = 71},
  [3774] = {.lex_state = 44},
  [3775] = {.lex_state = 44},
  [3776] = {.lex_state = 71},
  [3777] = {.lex_state = 71},
  [3778] = {.lex_state = 178},
  [3779] = {.lex_state = 71},
  [3780] = {.lex_state = 66},
  [3781] = {.lex_state = 44},
  [3782] = {.lex_state = 0},
  [3783] = {.lex_state = 0},
  [3784] = {.lex_state = 178},
  [3785] = {.lex_state = 71},
  [3786] = {.lex_state = 178},
  [3787] = {.lex_state = 0},
  [3788] = {.lex_state = 71},
  [3789] = {.lex_state = 0},
  [3790] = {.lex_state = 0},
  [3791] = {.lex_state = 0},
  [3792] = {.lex_state = 0},
  [3793] = {.lex_state = 0},
  [3794] = {.lex_state = 0},
  [3795] = {.lex_state = 0},
  [3796] = {.lex_state = 0},
  [3797] = {.lex_state = 71},
  [3798] = {.lex_state = 44},
  [3799] = {.lex_state = 44},
  [3800] = {.lex_state = 0},
  [3801] = {.lex_state = 85},
  [3802] = {.lex_state = 71},
  [3803] = {.lex_state = 0},
  [3804] = {.lex_state = 71},
  [3805] = {.lex_state = 0},
  [3806] = {.lex_state = 178},
  [3807] = {.lex_state = 0},
  [3808] = {.lex_state = 44},
  [3809] = {.lex_state = 71},
  [3810] = {.lex_state = 0},
  [3811] = {.lex_state = 71},
  [3812] = {.lex_state = 0},
  [3813] = {.lex_state = 0},
  [3814] = {.lex_state = 178},
  [3815] = {.lex_state = 71},
  [3816] = {.lex_state = 0},
  [3817] = {.lex_state = 0},
  [3818] = {.lex_state = 71},
  [3819] = {.lex_state = 0},
  [3820] = {.lex_state = 71},
  [3821] = {.lex_state = 44},
  [3822] = {.lex_state = 44},
  [3823] = {.lex_state = 0},
  [3824] = {.lex_state = 0},
  [3825] = {.lex_state = 178},
  [3826] = {.lex_state = 71},
  [3827] = {.lex_state = 0},
  [3828] = {.lex_state = 0},
  [3829] = {.lex_state = 0},
  [3830] = {.lex_state = 44},
  [3831] = {.lex_state = 0},
  [3832] = {.lex_state = 0},
  [3833] = {.lex_state = 71},
  [3834] = {.lex_state = 0},
  [3835] = {.lex_state = 0},
  [3836] = {.lex_state = 71},
  [3837] = {.lex_state = 0},
  [3838] = {.lex_state = 44},
  [3839] = {.lex_state = 71},
  [3840] = {.lex_state = 44},
  [3841] = {.lex_state = 0},
  [3842] = {.lex_state = 184},
  [3843] = {.lex_state = 184},
  [3844] = {.lex_state = 0},
  [3845] = {.lex_state = 71},
  [3846] = {.lex_state = 81},
  [3847] = {.lex_state = 0},
  [3848] = {.lex_state = 74},
  [3849] = {.lex_state = 0},
  [3850] = {.lex_state = 0},
  [3851] = {.lex_state = 0},
  [3852] = {.lex_state = 0},
  [3853] = {.lex_state = 0},
  [3854] = {.lex_state = 0},
  [3855] = {.lex_state = 0},
  [3856] = {.lex_state = 184},
  [3857] = {.lex_state = 0},
  [3858] = {.lex_state = 0},
  [3859] = {.lex_state = 0},
  [3860] = {.lex_state = 0},
  [3861] = {.lex_state = 81},
  [3862] = {.lex_state = 0},
  [3863] = {.lex_state = 74},
  [3864] = {.lex_state = 71},
  [3865] = {.lex_state = 0},
  [3866] = {.lex_state = 0},
  [3867] = {.lex_state = 0},
  [3868] = {.lex_state = 0},
  [3869] = {.lex_state = 81},
  [3870] = {.lex_state = 74},
  [3871] = {.lex_state = 0},
  [3872] = {.lex_state = 0},
  [3873] = {.lex_state = 0},
  [3874] = {.lex_state = 71},
  [3875] = {.lex_state = 0},
  [3876] = {.lex_state = 74},
  [3877] = {.lex_state = 0},
  [3878] = {.lex_state = 0},
  [3879] = {.lex_state = 81},
  [3880] = {.lex_state = 0},
  [3881] = {.lex_state = 0},
  [3882] = {.lex_state = 0},
  [3883] = {.lex_state = 0},
  [3884] = {.lex_state = 0},
  [3885] = {.lex_state = 0},
  [3886] = {.lex_state = 0},
  [3887] = {.lex_state = 0},
  [3888] = {.lex_state = 0},
  [3889] = {.lex_state = 0},
  [3890] = {.lex_state = 0},
  [3891] = {.lex_state = 74},
  [3892] = {.lex_state = 0},
  [3893] = {.lex_state = 0},
  [3894] = {.lex_state = 81},
  [3895] = {.lex_state = 0},
  [3896] = {.lex_state = 0},
  [3897] = {.lex_state = 81},
  [3898] = {.lex_state = 74},
  [3899] = {.lex_state = 0},
  [3900] = {.lex_state = 0},
  [3901] = {.lex_state = 71},
  [3902] = {.lex_state = 81},
  [3903] = {.lex_state = 0},
  [3904] = {.lex_state = 74},
  [3905] = {.lex_state = 74},
  [3906] = {.lex_state = 0},
  [3907] = {.lex_state = 0},
  [3908] = {.lex_state = 81},
  [3909] = {.lex_state = 0},
  [3910] = {.lex_state = 0},
  [3911] = {.lex_state = 0},
  [3912] = {.lex_state = 0},
  [3913] = {.lex_state = 74},
  [3914] = {.lex_state = 71},
  [3915] = {.lex_state = 81},
  [3916] = {.lex_state = 0},
  [3917] = {.lex_state = 0},
  [3918] = {.lex_state = 71},
  [3919] = {.lex_state = 44},
  [3920] = {.lex_state = 0},
  [3921] = {.lex_state = 74},
  [3922] = {.lex_state = 0},
  [3923] = {.lex_state = 74},
  [3924] = {.lex_state = 184},
  [3925] = {.lex_state = 71},
  [3926] = {.lex_state = 81},
  [3927] = {.lex_state = 71},
  [3928] = {.lex_state = 0},
  [3929] = {.lex_state = 0},
  [3930] = {.lex_state = 71},
  [3931] = {.lex_state = 74},
  [3932] = {.lex_state = 81},
  [3933] = {.lex_state = 71},
  [3934] = {.lex_state = 0},
  [3935] = {.lex_state = 0},
  [3936] = {.lex_state = 0},
  [3937] = {.lex_state = 0},
  [3938] = {.lex_state = 0},
  [3939] = {.lex_state = 0},
  [3940] = {.lex_state = 0},
  [3941] = {.lex_state = 0},
  [3942] = {.lex_state = 74},
  [3943] = {.lex_state = 81},
  [3944] = {.lex_state = 0},
  [3945] = {.lex_state = 0},
  [3946] = {.lex_state = 0},
  [3947] = {.lex_state = 44},
  [3948] = {.lex_state = 0},
  [3949] = {.lex_state = 71},
  [3950] = {.lex_state = 74},
  [3951] = {.lex_state = 0},
  [3952] = {.lex_state = 71},
  [3953] = {.lex_state = 81},
  [3954] = {.lex_state = 74},
  [3955] = {.lex_state = 81},
  [3956] = {.lex_state = 0},
  [3957] = {.lex_state = 0},
  [3958] = {.lex_state = 0},
  [3959] = {.lex_state = 0},
  [3960] = {.lex_state = 66},
  [3961] = {.lex_state = 71},
  [3962] = {.lex_state = 0},
  [3963] = {.lex_state = 0},
  [3964] = {.lex_state = 0},
  [3965] = {.lex_state = 0},
  [3966] = {.lex_state = 81},
  [3967] = {.lex_state = 74},
  [3968] = {.lex_state = 0},
  [3969] = {.lex_state = 0},
  [3970] = {.lex_state = 0},
  [3971] = {.lex_state = 66},
  [3972] = {.lex_state = 0},
  [3973] = {.lex_state = 71},
  [3974] = {.lex_state = 81},
  [3975] = {.lex_state = 0},
  [3976] = {.lex_state = 0},
  [3977] = {.lex_state = 0},
  [3978] = {.lex_state = 0},
  [3979] = {.lex_state = 0},
  [3980] = {.lex_state = 0},
  [3981] = {.lex_state = 184},
  [3982] = {.lex_state = 0},
  [3983] = {.lex_state = 0},
  [3984] = {.lex_state = 0},
  [3985] = {.lex_state = 0},
  [3986] = {.lex_state = 0},
  [3987] = {.lex_state = 0},
  [3988] = {.lex_state = 0},
  [3989] = {.lex_state = 0},
  [3990] = {.lex_state = 0},
  [3991] = {.lex_state = 0},
  [3992] = {.lex_state = 0},
  [3993] = {.lex_state = 0},
  [3994] = {.lex_state = 81},
  [3995] = {.lex_state = 74},
  [3996] = {.lex_state = 0},
  [3997] = {.lex_state = 71},
  [3998] = {.lex_state = 81},
  [3999] = {.lex_state = 74},
  [4000] = {.lex_state = 71},
  [4001] = {.lex_state = 0},
  [4002] = {.lex_state = 0},
  [4003] = {.lex_state = 0},
  [4004] = {.lex_state = 0},
  [4005] = {.lex_state = 66},
  [4006] = {.lex_state = 0},
  [4007] = {.lex_state = 0},
  [4008] = {.lex_state = 0},
  [4009] = {.lex_state = 0},
  [4010] = {.lex_state = 0},
  [4011] = {.lex_state = 0},
  [4012] = {.lex_state = 71},
  [4013] = {.lex_state = 0},
  [4014] = {.lex_state = 81},
  [4015] = {.lex_state = 74},
  [4016] = {.lex_state = 66},
  [4017] = {.lex_state = 0},
  [4018] = {.lex_state = 0},
  [4019] = {.lex_state = 0},
  [4020] = {.lex_state = 0},
  [4021] = {.lex_state = 0},
  [4022] = {.lex_state = 66},
  [4023] = {.lex_state = 0},
  [4024] = {.lex_state = 0},
  [4025] = {.lex_state = 0},
  [4026] = {.lex_state = 0},
  [4027] = {.lex_state = 0},
  [4028] = {.lex_state = 0},
  [4029] = {.lex_state = 0},
  [4030] = {.lex_state = 0},
  [4031] = {.lex_state = 0},
  [4032] = {.lex_state = 0},
  [4033] = {.lex_state = 0},
  [4034] = {.lex_state = 0},
  [4035] = {.lex_state = 0},
  [4036] = {.lex_state = 0},
  [4037] = {.lex_state = 0},
  [4038] = {.lex_state = 0},
  [4039] = {.lex_state = 0},
  [4040] = {.lex_state = 0},
  [4041] = {.lex_state = 0},
  [4042] = {.lex_state = 0},
  [4043] = {.lex_state = 0},
  [4044] = {.lex_state = 0},
  [4045] = {.lex_state = 0},
  [4046] = {.lex_state = 0},
  [4047] = {.lex_state = 0},
  [4048] = {.lex_state = 0},
  [4049] = {.lex_state = 0},
  [4050] = {.lex_state = 44},
  [4051] = {.lex_state = 0},
  [4052] = {.lex_state = 74},
  [4053] = {.lex_state = 81},
  [4054] = {.lex_state = 85},
  [4055] = {.lex_state = 74},
  [4056] = {.lex_state = 71},
  [4057] = {.lex_state = 184},
  [4058] = {.lex_state = 0},
  [4059] = {.lex_state = 0},
  [4060] = {.lex_state = 81},
  [4061] = {.lex_state = 0},
  [4062] = {.lex_state = 0},
  [4063] = {.lex_state = 71},
  [4064] = {.lex_state = 0},
  [4065] = {.lex_state = 0},
  [4066] = {.lex_state = 0},
  [4067] = {.lex_state = 0},
  [4068] = {.lex_state = 0},
  [4069] = {.lex_state = 74},
  [4070] = {.lex_state = 0},
  [4071] = {.lex_state = 81},
  [4072] = {.lex_state = 0},
  [4073] = {.lex_state = 74},
  [4074] = {.lex_state = 81},
  [4075] = {.lex_state = 0},
  [4076] = {.lex_state = 71},
  [4077] = {.lex_state = 184},
  [4078] = {.lex_state = 0},
  [4079] = {.lex_state = 0},
  [4080] = {.lex_state = 0},
  [4081] = {.lex_state = 74},
  [4082] = {.lex_state = 81},
  [4083] = {.lex_state = 0},
  [4084] = {.lex_state = 0},
  [4085] = {.lex_state = 74},
  [4086] = {.lex_state = 81},
  [4087] = {.lex_state = 0},
  [4088] = {.lex_state = 0},
  [4089] = {.lex_state = 71},
  [4090] = {.lex_state = 71},
  [4091] = {.lex_state = 71},
  [4092] = {.lex_state = 0},
  [4093] = {.lex_state = 71},
  [4094] = {.lex_state = 0},
  [4095] = {.lex_state = 0},
  [4096] = {.lex_state = 184},
  [4097] = {.lex_state = 0},
  [4098] = {.lex_state = 0},
  [4099] = {.lex_state = 71},
  [4100] = {.lex_state = 0},
  [4101] = {.lex_state = 0},
  [4102] = {.lex_state = 0},
  [4103] = {.lex_state = 0},
  [4104] = {.lex_state = 0},
  [4105] = {.lex_state = 0},
  [4106] = {.lex_state = 0},
  [4107] = {.lex_state = 0},
  [4108] = {.lex_state = 0},
  [4109] = {.lex_state = 0},
  [4110] = {.lex_state = 0},
  [4111] = {.lex_state = 0},
  [4112] = {.lex_state = 0},
  [4113] = {.lex_state = 0},
  [4114] = {.lex_state = 0},
  [4115] = {.lex_state = 0},
  [4116] = {.lex_state = 0},
  [4117] = {.lex_state = 0},
  [4118] = {.lex_state = 0},
  [4119] = {.lex_state = 0},
  [4120] = {.lex_state = 0},
  [4121] = {.lex_state = 71},
  [4122] = {.lex_state = 71},
  [4123] = {.lex_state = 0},
  [4124] = {.lex_state = 71},
  [4125] = {.lex_state = 0},
  [4126] = {.lex_state = 0},
  [4127] = {.lex_state = 0},
  [4128] = {.lex_state = 0},
  [4129] = {.lex_state = 0},
  [4130] = {.lex_state = 0},
  [4131] = {.lex_state = 0},
  [4132] = {.lex_state = 0},
  [4133] = {.lex_state = 0},
  [4134] = {.lex_state = 0},
  [4135] = {.lex_state = 0},
  [4136] = {.lex_state = 0},
  [4137] = {.lex_state = 0},
  [4138] = {.lex_state = 0},
  [4139] = {.lex_state = 71},
  [4140] = {.lex_state = 71},
  [4141] = {.lex_state = 0},
  [4142] = {.lex_state = 0},
  [4143] = {.lex_state = 0},
  [4144] = {.lex_state = 0},
  [4145] = {.lex_state = 0},
  [4146] = {.lex_state = 0},
  [4147] = {.lex_state = 0},
  [4148] = {.lex_state = 44},
  [4149] = {.lex_state = 0},
  [4150] = {.lex_state = 0},
  [4151] = {.lex_state = 0},
  [4152] = {.lex_state = 0},
  [4153] = {.lex_state = 0},
  [4154] = {.lex_state = 0},
  [4155] = {.lex_state = 0},
  [4156] = {.lex_state = 71},
  [4157] = {.lex_state = 0},
  [4158] = {.lex_state = 0},
  [4159] = {.lex_state = 0},
  [4160] = {.lex_state = 0},
  [4161] = {.lex_state = 0},
  [4162] = {.lex_state = 71},
  [4163] = {.lex_state = 0},
  [4164] = {.lex_state = 0},
  [4165] = {.lex_state = 71},
  [4166] = {.lex_state = 0},
  [4167] = {.lex_state = 0},
  [4168] = {.lex_state = 0},
  [4169] = {.lex_state = 0},
  [4170] = {.lex_state = 0},
  [4171] = {.lex_state = 0},
  [4172] = {.lex_state = 0},
  [4173] = {.lex_state = 0},
  [4174] = {.lex_state = 71},
  [4175] = {.lex_state = 0},
  [4176] = {.lex_state = 0},
  [4177] = {.lex_state = 0},
  [4178] = {.lex_state = 0},
  [4179] = {.lex_state = 0},
  [4180] = {.lex_state = 0},
  [4181] = {.lex_state = 0},
  [4182] = {.lex_state = 0},
  [4183] = {.lex_state = 0},
  [4184] = {.lex_state = 0},
  [4185] = {.lex_state = 0},
  [4186] = {.lex_state = 0},
  [4187] = {.lex_state = 71},
  [4188] = {.lex_state = 0},
  [4189] = {.lex_state = 0},
  [4190] = {.lex_state = 0},
  [4191] = {.lex_state = 0},
  [4192] = {.lex_state = 0},
  [4193] = {.lex_state = 0},
  [4194] = {.lex_state = 0},
  [4195] = {.lex_state = 0},
  [4196] = {.lex_state = 0},
  [4197] = {.lex_state = 0},
  [4198] = {.lex_state = 0},
  [4199] = {.lex_state = 0},
  [4200] = {.lex_state = 0},
  [4201] = {.lex_state = 71},
  [4202] = {.lex_state = 0},
  [4203] = {.lex_state = 0},
  [4204] = {.lex_state = 0},
  [4205] = {.lex_state = 0},
  [4206] = {.lex_state = 71},
  [4207] = {.lex_state = 0},
  [4208] = {.lex_state = 71},
  [4209] = {.lex_state = 0},
  [4210] = {.lex_state = 0},
  [4211] = {.lex_state = 0},
  [4212] = {.lex_state = 0},
  [4213] = {.lex_state = 71},
  [4214] = {.lex_state = 0},
  [4215] = {.lex_state = 0},
  [4216] = {.lex_state = 0},
  [4217] = {.lex_state = 0},
  [4218] = {.lex_state = 0},
  [4219] = {.lex_state = 0},
  [4220] = {.lex_state = 0},
  [4221] = {.lex_state = 0},
  [4222] = {.lex_state = 0},
  [4223] = {.lex_state = 0},
  [4224] = {.lex_state = 0},
  [4225] = {.lex_state = 0},
  [4226] = {.lex_state = 0},
  [4227] = {.lex_state = 0},
  [4228] = {.lex_state = 0},
  [4229] = {.lex_state = 0},
  [4230] = {.lex_state = 71},
  [4231] = {.lex_state = 0},
  [4232] = {.lex_state = 0},
  [4233] = {.lex_state = 0},
  [4234] = {.lex_state = 0},
  [4235] = {.lex_state = 0},
  [4236] = {.lex_state = 0},
  [4237] = {.lex_state = 0},
  [4238] = {.lex_state = 0},
  [4239] = {.lex_state = 0},
  [4240] = {.lex_state = 71},
  [4241] = {.lex_state = 71},
  [4242] = {.lex_state = 0},
  [4243] = {.lex_state = 0},
  [4244] = {.lex_state = 0},
  [4245] = {.lex_state = 0},
  [4246] = {.lex_state = 0},
  [4247] = {.lex_state = 0},
  [4248] = {.lex_state = 0},
  [4249] = {.lex_state = 0},
  [4250] = {.lex_state = 0},
  [4251] = {.lex_state = 0},
  [4252] = {.lex_state = 0},
  [4253] = {.lex_state = 0},
  [4254] = {.lex_state = 0},
  [4255] = {.lex_state = 0},
  [4256] = {.lex_state = 71},
  [4257] = {.lex_state = 0},
  [4258] = {.lex_state = 0},
  [4259] = {.lex_state = 0},
  [4260] = {.lex_state = 0},
  [4261] = {.lex_state = 0},
  [4262] = {.lex_state = 0},
  [4263] = {.lex_state = 0},
  [4264] = {.lex_state = 71},
  [4265] = {.lex_state = 0},
  [4266] = {.lex_state = 0},
  [4267] = {.lex_state = 0},
  [4268] = {.lex_state = 71},
  [4269] = {.lex_state = 0},
  [4270] = {.lex_state = 0},
  [4271] = {.lex_state = 81},
  [4272] = {.lex_state = 0},
  [4273] = {.lex_state = 74},
  [4274] = {.lex_state = 71},
  [4275] = {.lex_state = 71},
  [4276] = {.lex_state = 44},
  [4277] = {.lex_state = 0},
  [4278] = {.lex_state = 0},
  [4279] = {.lex_state = 0},
  [4280] = {.lex_state = 0},
  [4281] = {.lex_state = 0},
  [4282] = {.lex_state = 71},
  [4283] = {.lex_state = 0},
  [4284] = {.lex_state = 0},
  [4285] = {.lex_state = 0},
  [4286] = {.lex_state = 0},
  [4287] = {.lex_state = 0},
  [4288] = {.lex_state = 71},
  [4289] = {.lex_state = 71},
  [4290] = {.lex_state = 0},
  [4291] = {.lex_state = 71},
  [4292] = {.lex_state = 0},
  [4293] = {.lex_state = 0},
  [4294] = {.lex_state = 71},
  [4295] = {.lex_state = 0},
  [4296] = {.lex_state = 0},
  [4297] = {.lex_state = 0},
  [4298] = {.lex_state = 0},
  [4299] = {.lex_state = 0},
  [4300] = {.lex_state = 71},
  [4301] = {.lex_state = 0},
  [4302] = {.lex_state = 0},
  [4303] = {.lex_state = 0},
  [4304] = {.lex_state = 0},
  [4305] = {.lex_state = 0},
  [4306] = {.lex_state = 0},
  [4307] = {.lex_state = 0},
  [4308] = {.lex_state = 0},
  [4309] = {.lex_state = 71},
  [4310] = {.lex_state = 0},
  [4311] = {.lex_state = 0},
  [4312] = {.lex_state = 0},
  [4313] = {.lex_state = 0},
  [4314] = {.lex_state = 0},
  [4315] = {.lex_state = 0},
  [4316] = {.lex_state = 0},
  [4317] = {.lex_state = 0},
  [4318] = {.lex_state = 0},
  [4319] = {.lex_state = 0},
  [4320] = {.lex_state = 44},
  [4321] = {.lex_state = 0},
  [4322] = {.lex_state = 0},
  [4323] = {.lex_state = 0},
  [4324] = {.lex_state = 0},
  [4325] = {.lex_state = 71},
  [4326] = {.lex_state = 0},
  [4327] = {.lex_state = 0},
  [4328] = {.lex_state = 0},
  [4329] = {.lex_state = 0},
  [4330] = {.lex_state = 0},
  [4331] = {.lex_state = 0},
  [4332] = {.lex_state = 71},
  [4333] = {.lex_state = 0},
  [4334] = {.lex_state = 0},
  [4335] = {.lex_state = 0},
  [4336] = {.lex_state = 0},
  [4337] = {.lex_state = 0},
  [4338] = {.lex_state = 0},
  [4339] = {.lex_state = 0},
  [4340] = {.lex_state = 71},
  [4341] = {.lex_state = 0},
  [4342] = {.lex_state = 0},
  [4343] = {.lex_state = 0},
  [4344] = {.lex_state = 0},
  [4345] = {.lex_state = 0},
  [4346] = {.lex_state = 0},
  [4347] = {.lex_state = 0},
  [4348] = {.lex_state = 0},
  [4349] = {.lex_state = 0},
  [4350] = {.lex_state = 0},
  [4351] = {.lex_state = 0},
  [4352] = {.lex_state = 71},
  [4353] = {.lex_state = 0},
  [4354] = {.lex_state = 71},
  [4355] = {.lex_state = 0},
  [4356] = {.lex_state = 71},
  [4357] = {.lex_state = 71},
  [4358] = {.lex_state = 0},
  [4359] = {.lex_state = 71},
  [4360] = {.lex_state = 0},
  [4361] = {.lex_state = 0},
  [4362] = {.lex_state = 0},
  [4363] = {.lex_state = 0},
  [4364] = {.lex_state = 0},
  [4365] = {.lex_state = 0},
  [4366] = {.lex_state = 0},
  [4367] = {.lex_state = 0},
  [4368] = {.lex_state = 0},
  [4369] = {.lex_state = 0},
  [4370] = {.lex_state = 0},
  [4371] = {.lex_state = 0},
  [4372] = {.lex_state = 0},
  [4373] = {.lex_state = 0},
  [4374] = {.lex_state = 0},
  [4375] = {.lex_state = 0},
  [4376] = {.lex_state = 0},
  [4377] = {.lex_state = 71},
  [4378] = {.lex_state = 0},
  [4379] = {.lex_state = 0},
  [4380] = {.lex_state = 0},
  [4381] = {.lex_state = 0},
  [4382] = {.lex_state = 71},
  [4383] = {.lex_state = 0},
  [4384] = {.lex_state = 0},
  [4385] = {.lex_state = 0},
  [4386] = {.lex_state = 0},
  [4387] = {.lex_state = 71},
  [4388] = {.lex_state = 0},
  [4389] = {.lex_state = 0},
  [4390] = {.lex_state = 0},
  [4391] = {.lex_state = 0},
  [4392] = {.lex_state = 71},
  [4393] = {.lex_state = 0},
  [4394] = {.lex_state = 0},
  [4395] = {.lex_state = 0},
  [4396] = {.lex_state = 0},
  [4397] = {.lex_state = 0},
  [4398] = {.lex_state = 0},
  [4399] = {.lex_state = 0},
  [4400] = {.lex_state = 0},
  [4401] = {.lex_state = 0},
  [4402] = {.lex_state = 0},
  [4403] = {.lex_state = 71},
  [4404] = {.lex_state = 0},
  [4405] = {.lex_state = 0},
  [4406] = {.lex_state = 0},
  [4407] = {.lex_state = 0},
  [4408] = {.lex_state = 71},
  [4409] = {.lex_state = 0},
  [4410] = {.lex_state = 0},
  [4411] = {.lex_state = 0},
  [4412] = {.lex_state = 0},
  [4413] = {.lex_state = 71},
  [4414] = {.lex_state = 0},
  [4415] = {.lex_state = 0},
  [4416] = {.lex_state = 0},
  [4417] = {.lex_state = 0},
  [4418] = {.lex_state = 0},
  [4419] = {.lex_state = 93},
  [4420] = {.lex_state = 0},
  [4421] = {.lex_state = 0},
  [4422] = {.lex_state = 0},
  [4423] = {.lex_state = 0},
  [4424] = {.lex_state = 0},
  [4425] = {.lex_state = 0},
  [4426] = {.lex_state = 0},
  [4427] = {.lex_state = 0},
  [4428] = {.lex_state = 93},
  [4429] = {.lex_state = 0},
  [4430] = {.lex_state = 0},
  [4431] = {.lex_state = 0},
  [4432] = {.lex_state = 0},
  [4433] = {.lex_state = 26},
  [4434] = {.lex_state = 0},
  [4435] = {.lex_state = 0},
  [4436] = {.lex_state = 0},
  [4437] = {.lex_state = 0},
  [4438] = {.lex_state = 0},
  [4439] = {.lex_state = 93},
  [4440] = {.lex_state = 0},
  [4441] = {.lex_state = 0},
  [4442] = {.lex_state = 0},
  [4443] = {.lex_state = 71},
  [4444] = {.lex_state = 0},
  [4445] = {.lex_state = 0},
  [4446] = {.lex_state = 0},
  [4447] = {.lex_state = 0},
  [4448] = {.lex_state = 0},
  [4449] = {.lex_state = 93},
  [4450] = {.lex_state = 0},
  [4451] = {.lex_state = 0},
  [4452] = {.lex_state = 0},
  [4453] = {.lex_state = 0},
  [4454] = {.lex_state = 0},
  [4455] = {.lex_state = 0},
  [4456] = {.lex_state = 0},
  [4457] = {.lex_state = 0},
  [4458] = {.lex_state = 0},
  [4459] = {.lex_state = 0},
  [4460] = {.lex_state = 0},
  [4461] = {.lex_state = 0},
  [4462] = {.lex_state = 0},
  [4463] = {.lex_state = 0},
  [4464] = {.lex_state = 0},
  [4465] = {.lex_state = 0},
  [4466] = {.lex_state = 0},
  [4467] = {.lex_state = 0},
  [4468] = {.lex_state = 0},
  [4469] = {.lex_state = 0},
  [4470] = {.lex_state = 93},
  [4471] = {.lex_state = 0},
  [4472] = {.lex_state = 0},
  [4473] = {.lex_state = 0},
  [4474] = {.lex_state = 0},
  [4475] = {.lex_state = 0},
  [4476] = {.lex_state = 0},
  [4477] = {.lex_state = 0},
  [4478] = {.lex_state = 71},
  [4479] = {.lex_state = 0},
  [4480] = {.lex_state = 0},
  [4481] = {.lex_state = 0},
  [4482] = {.lex_state = 0},
  [4483] = {.lex_state = 0},
  [4484] = {.lex_state = 0},
  [4485] = {.lex_state = 93},
  [4486] = {.lex_state = 0},
  [4487] = {.lex_state = 0},
  [4488] = {.lex_state = 0},
  [4489] = {.lex_state = 0},
  [4490] = {.lex_state = 0},
  [4491] = {.lex_state = 0},
  [4492] = {.lex_state = 0},
  [4493] = {.lex_state = 0},
  [4494] = {.lex_state = 0},
  [4495] = {.lex_state = 0},
  [4496] = {.lex_state = 0},
  [4497] = {.lex_state = 0},
  [4498] = {.lex_state = 0},
  [4499] = {.lex_state = 0},
  [4500] = {.lex_state = 0},
  [4501] = {.lex_state = 0},
  [4502] = {.lex_state = 0},
  [4503] = {.lex_state = 0},
  [4504] = {.lex_state = 0},
  [4505] = {.lex_state = 0},
  [4506] = {.lex_state = 0},
  [4507] = {.lex_state = 0},
  [4508] = {.lex_state = 0},
  [4509] = {.lex_state = 93},
  [4510] = {.lex_state = 0},
  [4511] = {.lex_state = 0},
  [4512] = {.lex_state = 93},
  [4513] = {.lex_state = 0},
  [4514] = {.lex_state = 0},
  [4515] = {.lex_state = 0},
  [4516] = {.lex_state = 0},
  [4517] = {.lex_state = 0},
  [4518] = {.lex_state = 0},
  [4519] = {.lex_state = 71},
  [4520] = {.lex_state = 71},
  [4521] = {.lex_state = 71},
  [4522] = {.lex_state = 0},
  [4523] = {.lex_state = 0},
  [4524] = {.lex_state = 0},
  [4525] = {.lex_state = 0},
  [4526] = {.lex_state = 0},
  [4527] = {.lex_state = 0},
  [4528] = {.lex_state = 0},
  [4529] = {.lex_state = 0},
  [4530] = {.lex_state = 0},
  [4531] = {.lex_state = 0},
  [4532] = {.lex_state = 0},
  [4533] = {.lex_state = 93},
  [4534] = {.lex_state = 0},
  [4535] = {.lex_state = 71},
  [4536] = {.lex_state = 0},
  [4537] = {.lex_state = 0},
  [4538] = {.lex_state = 71},
  [4539] = {.lex_state = 71},
  [4540] = {.lex_state = 71},
  [4541] = {.lex_state = 0},
  [4542] = {.lex_state = 71},
  [4543] = {.lex_state = 0},
  [4544] = {.lex_state = 0},
  [4545] = {.lex_state = 0},
  [4546] = {.lex_state = 0},
  [4547] = {.lex_state = 0},
  [4548] = {.lex_state = 0},
  [4549] = {.lex_state = 93},
  [4550] = {.lex_state = 0},
  [4551] = {.lex_state = 0},
  [4552] = {.lex_state = 0},
  [4553] = {.lex_state = 0},
  [4554] = {.lex_state = 93},
  [4555] = {.lex_state = 71},
  [4556] = {.lex_state = 0},
  [4557] = {.lex_state = 0},
  [4558] = {.lex_state = 93},
  [4559] = {.lex_state = 0},
  [4560] = {.lex_state = 0},
  [4561] = {.lex_state = 0},
  [4562] = {.lex_state = 0},
  [4563] = {.lex_state = 0},
  [4564] = {.lex_state = 0},
  [4565] = {.lex_state = 0},
  [4566] = {.lex_state = 93},
  [4567] = {.lex_state = 0},
  [4568] = {.lex_state = 71},
  [4569] = {.lex_state = 71},
  [4570] = {.lex_state = 0},
  [4571] = {.lex_state = 71},
  [4572] = {.lex_state = 0},
  [4573] = {.lex_state = 0},
  [4574] = {.lex_state = 0},
  [4575] = {.lex_state = 0},
  [4576] = {.lex_state = 0},
  [4577] = {.lex_state = 26},
  [4578] = {.lex_state = 44},
  [4579] = {.lex_state = 0},
  [4580] = {.lex_state = 71},
  [4581] = {.lex_state = 0},
  [4582] = {.lex_state = 0},
  [4583] = {.lex_state = 0},
  [4584] = {.lex_state = 0},
  [4585] = {.lex_state = 0},
  [4586] = {.lex_state = 0},
  [4587] = {.lex_state = 0},
  [4588] = {.lex_state = 93},
  [4589] = {.lex_state = 0},
  [4590] = {.lex_state = 0},
  [4591] = {.lex_state = 0},
  [4592] = {.lex_state = 0},
  [4593] = {.lex_state = 93},
  [4594] = {.lex_state = 0},
  [4595] = {.lex_state = 0},
  [4596] = {.lex_state = 0},
  [4597] = {.lex_state = 0},
  [4598] = {.lex_state = 0},
  [4599] = {.lex_state = 0},
  [4600] = {.lex_state = 0},
  [4601] = {.lex_state = 0},
  [4602] = {.lex_state = 0},
  [4603] = {.lex_state = 0},
  [4604] = {.lex_state = 0},
  [4605] = {.lex_state = 71},
  [4606] = {.lex_state = 0},
  [4607] = {.lex_state = 0},
  [4608] = {.lex_state = 0},
  [4609] = {.lex_state = 0},
  [4610] = {.lex_state = 0},
  [4611] = {.lex_state = 0},
  [4612] = {.lex_state = 0},
  [4613] = {.lex_state = 0},
  [4614] = {.lex_state = 0},
  [4615] = {.lex_state = 0},
  [4616] = {.lex_state = 0},
  [4617] = {.lex_state = 0},
  [4618] = {.lex_state = 0},
  [4619] = {.lex_state = 0},
  [4620] = {.lex_state = 0},
  [4621] = {.lex_state = 0},
  [4622] = {.lex_state = 0},
  [4623] = {.lex_state = 0},
  [4624] = {.lex_state = 0},
  [4625] = {.lex_state = 0},
  [4626] = {.lex_state = 194},
  [4627] = {.lex_state = 0},
  [4628] = {.lex_state = 0},
  [4629] = {.lex_state = 0},
  [4630] = {.lex_state = 0},
  [4631] = {.lex_state = 0},
  [4632] = {.lex_state = 0},
  [4633] = {.lex_state = 0},
  [4634] = {.lex_state = 0},
  [4635] = {.lex_state = 0},
  [4636] = {.lex_state = 0},
  [4637] = {.lex_state = 0},
  [4638] = {.lex_state = 0},
  [4639] = {.lex_state = 0},
  [4640] = {.lex_state = 0},
  [4641] = {.lex_state = 0},
  [4642] = {.lex_state = 0},
  [4643] = {.lex_state = 0},
  [4644] = {.lex_state = 26},
  [4645] = {.lex_state = 0},
  [4646] = {.lex_state = 0},
  [4647] = {.lex_state = 0},
  [4648] = {.lex_state = 0},
  [4649] = {.lex_state = 0},
  [4650] = {.lex_state = 0},
  [4651] = {.lex_state = 0},
  [4652] = {.lex_state = 0},
  [4653] = {.lex_state = 0},
  [4654] = {.lex_state = 0},
  [4655] = {.lex_state = 194},
  [4656] = {.lex_state = 0},
  [4657] = {.lex_state = 71},
  [4658] = {.lex_state = 0},
  [4659] = {.lex_state = 0},
  [4660] = {.lex_state = 0},
  [4661] = {.lex_state = 0},
  [4662] = {.lex_state = 0},
  [4663] = {.lex_state = 0},
  [4664] = {.lex_state = 0},
  [4665] = {.lex_state = 0},
  [4666] = {.lex_state = 0},
  [4667] = {.lex_state = 0},
  [4668] = {.lex_state = 0},
  [4669] = {.lex_state = 0},
  [4670] = {.lex_state = 0},
  [4671] = {.lex_state = 71},
  [4672] = {.lex_state = 71},
  [4673] = {.lex_state = 94},
  [4674] = {.lex_state = 0},
  [4675] = {.lex_state = 0},
  [4676] = {.lex_state = 0},
  [4677] = {.lex_state = 0},
  [4678] = {.lex_state = 0},
  [4679] = {.lex_state = 0},
  [4680] = {.lex_state = 0},
  [4681] = {.lex_state = 0},
  [4682] = {.lex_state = 0},
  [4683] = {.lex_state = 0},
  [4684] = {.lex_state = 0},
  [4685] = {.lex_state = 185},
  [4686] = {.lex_state = 0},
  [4687] = {.lex_state = 0},
  [4688] = {.lex_state = 0},
  [4689] = {.lex_state = 94},
  [4690] = {.lex_state = 0},
  [4691] = {.lex_state = 0},
  [4692] = {.lex_state = 0},
  [4693] = {.lex_state = 0},
  [4694] = {.lex_state = 0},
  [4695] = {.lex_state = 0},
  [4696] = {.lex_state = 0},
  [4697] = {.lex_state = 0},
  [4698] = {.lex_state = 71},
  [4699] = {.lex_state = 71},
  [4700] = {.lex_state = 71},
  [4701] = {.lex_state = 71},
  [4702] = {.lex_state = 0},
  [4703] = {.lex_state = 0},
  [4704] = {.lex_state = 71},
  [4705] = {.lex_state = 0},
  [4706] = {.lex_state = 0},
  [4707] = {.lex_state = 0},
  [4708] = {.lex_state = 0},
  [4709] = {.lex_state = 71},
  [4710] = {.lex_state = 0},
  [4711] = {.lex_state = 0},
  [4712] = {.lex_state = 0},
  [4713] = {.lex_state = 0},
  [4714] = {(TSStateId)(-1)},
  [4715] = {(TSStateId)(-1)},
  [4716] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_line_comment] = STATE(0),
    [sym_block_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_POUND_BANG] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [aux_sym_block_comment_token1] = ACTIONS(1),
    [anon_sym_STAR_SLASH] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym___global] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_LT2] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_pub] = ACTIONS(1),
    [anon_sym_mut] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_go] = ACTIONS(1),
    [anon_sym_spawn] = ACTIONS(1),
    [anon_sym_json_DOTdecode] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_LBRACK2] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_LT_DASH] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_AMP_CARET] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_none] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_nil] = ACTIONS(1),
    [anon_sym_QMARK_DOT] = ACTIONS(1),
    [anon_sym_POUND_LBRACK] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_BANGis] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_BANGin] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_select] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_lock] = ACTIONS(1),
    [anon_sym_rlock] = ACTIONS(1),
    [anon_sym_unsafe] = ACTIONS(1),
    [anon_sym_sql] = ACTIONS(1),
    [sym_int_literal] = ACTIONS(1),
    [sym_rune_literal] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_c_SQUOTE] = ACTIONS(1),
    [anon_sym_c_DQUOTE] = ACTIONS(1),
    [anon_sym_r_SQUOTE] = ACTIONS(1),
    [anon_sym_r_DQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [aux_sym_format_specifier_token1] = ACTIONS(1),
    [aux_sym_format_specifier_token2] = ACTIONS(1),
    [anon_sym_0] = ACTIONS(1),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_shared] = ACTIONS(1),
    [anon_sym_PIPE2] = ACTIONS(1),
    [anon_sym_map_LBRACK] = ACTIONS(1),
    [anon_sym_chan] = ACTIONS(1),
    [anon_sym_thread] = ACTIONS(1),
    [anon_sym_atomic] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_defer] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_asm] = ACTIONS(1),
    [anon_sym_AT_LBRACK] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(4667),
    [sym_shebang] = STATE(2),
    [sym_line_comment] = STATE(1),
    [sym_block_comment] = STATE(1),
    [sym_module_clause] = STATE(4),
    [sym_import_list] = STATE(5),
    [sym_import_declaration] = STATE(1920),
    [sym_const_declaration] = STATE(1788),
    [sym_global_var_declaration] = STATE(1788),
    [sym_type_declaration] = STATE(1788),
    [sym_function_declaration] = STATE(1788),
    [sym_static_method_declaration] = STATE(1788),
    [sym_struct_declaration] = STATE(1788),
    [sym_enum_declaration] = STATE(1788),
    [sym_interface_declaration] = STATE(1788),
    [sym__expression] = STATE(244),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_strictly_expression_list] = STATE(1796),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_visibility_modifiers] = STATE(3616),
    [sym_mutability_modifiers] = STATE(932),
    [sym_mutable_expression] = STATE(3390),
    [sym_expression_list] = STATE(3404),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1788),
    [sym_simple_statement] = STATE(1804),
    [sym_assert_statement] = STATE(1804),
    [sym_append_statement] = STATE(1804),
    [sym_send_statement] = STATE(1804),
    [sym_var_declaration] = STATE(1796),
    [sym_assignment_statement] = STATE(1796),
    [sym_block] = STATE(1804),
    [sym_defer_statement] = STATE(1804),
    [sym_goto_statement] = STATE(1804),
    [sym_break_statement] = STATE(1804),
    [sym_continue_statement] = STATE(1804),
    [sym_return_statement] = STATE(1804),
    [sym_label_definition] = STATE(13),
    [sym_labeled_statement] = STATE(1804),
    [sym_compile_time_for_statement] = STATE(1804),
    [sym_for_statement] = STATE(1804),
    [sym_hash_statement] = STATE(1804),
    [sym_asm_statement] = STATE(1804),
    [sym_attributes] = STATE(3480),
    [sym_attribute] = STATE(3407),
    [aux_sym_source_file_repeat1] = STATE(11),
    [aux_sym_import_list_repeat1] = STATE(1805),
    [aux_sym_attributes_repeat1] = STATE(3449),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_POUND_BANG] = ACTIONS(11),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym___global] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(27),
    [anon_sym_fn] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_pub] = ACTIONS(39),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_enum] = ACTIONS(43),
    [anon_sym_interface] = ACTIONS(45),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(105),
    [anon_sym_defer] = ACTIONS(107),
    [anon_sym_goto] = ACTIONS(109),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_continue] = ACTIONS(113),
    [anon_sym_return] = ACTIONS(115),
    [anon_sym_DOLLARfor] = ACTIONS(117),
    [anon_sym_for] = ACTIONS(119),
    [anon_sym_POUND] = ACTIONS(121),
    [anon_sym_asm] = ACTIONS(123),
    [anon_sym_AT_LBRACK] = ACTIONS(125),
  },
  [2] = {
    [sym_line_comment] = STATE(2),
    [sym_block_comment] = STATE(2),
    [sym_module_clause] = STATE(3),
    [sym_import_list] = STATE(9),
    [sym_import_declaration] = STATE(1920),
    [sym_const_declaration] = STATE(1788),
    [sym_global_var_declaration] = STATE(1788),
    [sym_type_declaration] = STATE(1788),
    [sym_function_declaration] = STATE(1788),
    [sym_static_method_declaration] = STATE(1788),
    [sym_struct_declaration] = STATE(1788),
    [sym_enum_declaration] = STATE(1788),
    [sym_interface_declaration] = STATE(1788),
    [sym__expression] = STATE(244),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_strictly_expression_list] = STATE(1796),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_visibility_modifiers] = STATE(3616),
    [sym_mutability_modifiers] = STATE(932),
    [sym_mutable_expression] = STATE(3390),
    [sym_expression_list] = STATE(3404),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1788),
    [sym_simple_statement] = STATE(1804),
    [sym_assert_statement] = STATE(1804),
    [sym_append_statement] = STATE(1804),
    [sym_send_statement] = STATE(1804),
    [sym_var_declaration] = STATE(1796),
    [sym_assignment_statement] = STATE(1796),
    [sym_block] = STATE(1804),
    [sym_defer_statement] = STATE(1804),
    [sym_goto_statement] = STATE(1804),
    [sym_break_statement] = STATE(1804),
    [sym_continue_statement] = STATE(1804),
    [sym_return_statement] = STATE(1804),
    [sym_label_definition] = STATE(13),
    [sym_labeled_statement] = STATE(1804),
    [sym_compile_time_for_statement] = STATE(1804),
    [sym_for_statement] = STATE(1804),
    [sym_hash_statement] = STATE(1804),
    [sym_asm_statement] = STATE(1804),
    [sym_attributes] = STATE(3480),
    [sym_attribute] = STATE(3407),
    [aux_sym_source_file_repeat1] = STATE(10),
    [aux_sym_import_list_repeat1] = STATE(1805),
    [aux_sym_attributes_repeat1] = STATE(3449),
    [ts_builtin_sym_end] = ACTIONS(127),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym___global] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(27),
    [anon_sym_fn] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_pub] = ACTIONS(39),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_enum] = ACTIONS(43),
    [anon_sym_interface] = ACTIONS(45),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(105),
    [anon_sym_defer] = ACTIONS(107),
    [anon_sym_goto] = ACTIONS(109),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_continue] = ACTIONS(113),
    [anon_sym_return] = ACTIONS(115),
    [anon_sym_DOLLARfor] = ACTIONS(117),
    [anon_sym_for] = ACTIONS(119),
    [anon_sym_POUND] = ACTIONS(129),
    [anon_sym_asm] = ACTIONS(123),
    [anon_sym_AT_LBRACK] = ACTIONS(125),
  },
  [3] = {
    [sym_line_comment] = STATE(3),
    [sym_block_comment] = STATE(3),
    [sym_import_list] = STATE(8),
    [sym_import_declaration] = STATE(1920),
    [sym_const_declaration] = STATE(1788),
    [sym_global_var_declaration] = STATE(1788),
    [sym_type_declaration] = STATE(1788),
    [sym_function_declaration] = STATE(1788),
    [sym_static_method_declaration] = STATE(1788),
    [sym_struct_declaration] = STATE(1788),
    [sym_enum_declaration] = STATE(1788),
    [sym_interface_declaration] = STATE(1788),
    [sym__expression] = STATE(244),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_strictly_expression_list] = STATE(1796),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_visibility_modifiers] = STATE(3616),
    [sym_mutability_modifiers] = STATE(932),
    [sym_mutable_expression] = STATE(3390),
    [sym_expression_list] = STATE(3404),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1788),
    [sym_simple_statement] = STATE(1804),
    [sym_assert_statement] = STATE(1804),
    [sym_append_statement] = STATE(1804),
    [sym_send_statement] = STATE(1804),
    [sym_var_declaration] = STATE(1796),
    [sym_assignment_statement] = STATE(1796),
    [sym_block] = STATE(1804),
    [sym_defer_statement] = STATE(1804),
    [sym_goto_statement] = STATE(1804),
    [sym_break_statement] = STATE(1804),
    [sym_continue_statement] = STATE(1804),
    [sym_return_statement] = STATE(1804),
    [sym_label_definition] = STATE(13),
    [sym_labeled_statement] = STATE(1804),
    [sym_compile_time_for_statement] = STATE(1804),
    [sym_for_statement] = STATE(1804),
    [sym_hash_statement] = STATE(1804),
    [sym_asm_statement] = STATE(1804),
    [sym_attributes] = STATE(3487),
    [sym_attribute] = STATE(3407),
    [aux_sym_source_file_repeat1] = STATE(7),
    [aux_sym_import_list_repeat1] = STATE(1805),
    [aux_sym_attributes_repeat1] = STATE(3449),
    [ts_builtin_sym_end] = ACTIONS(131),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym___global] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(27),
    [anon_sym_fn] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_pub] = ACTIONS(39),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_enum] = ACTIONS(43),
    [anon_sym_interface] = ACTIONS(45),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(105),
    [anon_sym_defer] = ACTIONS(107),
    [anon_sym_goto] = ACTIONS(109),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_continue] = ACTIONS(113),
    [anon_sym_return] = ACTIONS(115),
    [anon_sym_DOLLARfor] = ACTIONS(117),
    [anon_sym_for] = ACTIONS(119),
    [anon_sym_POUND] = ACTIONS(129),
    [anon_sym_asm] = ACTIONS(123),
    [anon_sym_AT_LBRACK] = ACTIONS(125),
  },
  [4] = {
    [sym_line_comment] = STATE(4),
    [sym_block_comment] = STATE(4),
    [sym_import_list] = STATE(9),
    [sym_import_declaration] = STATE(1920),
    [sym_const_declaration] = STATE(1788),
    [sym_global_var_declaration] = STATE(1788),
    [sym_type_declaration] = STATE(1788),
    [sym_function_declaration] = STATE(1788),
    [sym_static_method_declaration] = STATE(1788),
    [sym_struct_declaration] = STATE(1788),
    [sym_enum_declaration] = STATE(1788),
    [sym_interface_declaration] = STATE(1788),
    [sym__expression] = STATE(244),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_strictly_expression_list] = STATE(1796),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_visibility_modifiers] = STATE(3616),
    [sym_mutability_modifiers] = STATE(932),
    [sym_mutable_expression] = STATE(3390),
    [sym_expression_list] = STATE(3404),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1788),
    [sym_simple_statement] = STATE(1804),
    [sym_assert_statement] = STATE(1804),
    [sym_append_statement] = STATE(1804),
    [sym_send_statement] = STATE(1804),
    [sym_var_declaration] = STATE(1796),
    [sym_assignment_statement] = STATE(1796),
    [sym_block] = STATE(1804),
    [sym_defer_statement] = STATE(1804),
    [sym_goto_statement] = STATE(1804),
    [sym_break_statement] = STATE(1804),
    [sym_continue_statement] = STATE(1804),
    [sym_return_statement] = STATE(1804),
    [sym_label_definition] = STATE(13),
    [sym_labeled_statement] = STATE(1804),
    [sym_compile_time_for_statement] = STATE(1804),
    [sym_for_statement] = STATE(1804),
    [sym_hash_statement] = STATE(1804),
    [sym_asm_statement] = STATE(1804),
    [sym_attributes] = STATE(3487),
    [sym_attribute] = STATE(3407),
    [aux_sym_source_file_repeat1] = STATE(10),
    [aux_sym_import_list_repeat1] = STATE(1805),
    [aux_sym_attributes_repeat1] = STATE(3449),
    [ts_builtin_sym_end] = ACTIONS(127),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym___global] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(27),
    [anon_sym_fn] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_pub] = ACTIONS(39),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_enum] = ACTIONS(43),
    [anon_sym_interface] = ACTIONS(45),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(105),
    [anon_sym_defer] = ACTIONS(107),
    [anon_sym_goto] = ACTIONS(109),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_continue] = ACTIONS(113),
    [anon_sym_return] = ACTIONS(115),
    [anon_sym_DOLLARfor] = ACTIONS(117),
    [anon_sym_for] = ACTIONS(119),
    [anon_sym_POUND] = ACTIONS(129),
    [anon_sym_asm] = ACTIONS(123),
    [anon_sym_AT_LBRACK] = ACTIONS(125),
  },
  [5] = {
    [sym_line_comment] = STATE(5),
    [sym_block_comment] = STATE(5),
    [sym_const_declaration] = STATE(1788),
    [sym_global_var_declaration] = STATE(1788),
    [sym_type_declaration] = STATE(1788),
    [sym_function_declaration] = STATE(1788),
    [sym_static_method_declaration] = STATE(1788),
    [sym_struct_declaration] = STATE(1788),
    [sym_enum_declaration] = STATE(1788),
    [sym_interface_declaration] = STATE(1788),
    [sym__expression] = STATE(244),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_strictly_expression_list] = STATE(1796),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_visibility_modifiers] = STATE(3616),
    [sym_mutability_modifiers] = STATE(932),
    [sym_mutable_expression] = STATE(3390),
    [sym_expression_list] = STATE(3404),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1788),
    [sym_simple_statement] = STATE(1804),
    [sym_assert_statement] = STATE(1804),
    [sym_append_statement] = STATE(1804),
    [sym_send_statement] = STATE(1804),
    [sym_var_declaration] = STATE(1796),
    [sym_assignment_statement] = STATE(1796),
    [sym_block] = STATE(1804),
    [sym_defer_statement] = STATE(1804),
    [sym_goto_statement] = STATE(1804),
    [sym_break_statement] = STATE(1804),
    [sym_continue_statement] = STATE(1804),
    [sym_return_statement] = STATE(1804),
    [sym_label_definition] = STATE(13),
    [sym_labeled_statement] = STATE(1804),
    [sym_compile_time_for_statement] = STATE(1804),
    [sym_for_statement] = STATE(1804),
    [sym_hash_statement] = STATE(1804),
    [sym_asm_statement] = STATE(1804),
    [sym_attributes] = STATE(3487),
    [sym_attribute] = STATE(3407),
    [aux_sym_source_file_repeat1] = STATE(10),
    [aux_sym_attributes_repeat1] = STATE(3449),
    [ts_builtin_sym_end] = ACTIONS(127),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym___global] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(27),
    [anon_sym_fn] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_pub] = ACTIONS(39),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_enum] = ACTIONS(43),
    [anon_sym_interface] = ACTIONS(45),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(105),
    [anon_sym_defer] = ACTIONS(107),
    [anon_sym_goto] = ACTIONS(109),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_continue] = ACTIONS(113),
    [anon_sym_return] = ACTIONS(115),
    [anon_sym_DOLLARfor] = ACTIONS(117),
    [anon_sym_for] = ACTIONS(119),
    [anon_sym_POUND] = ACTIONS(129),
    [anon_sym_asm] = ACTIONS(123),
    [anon_sym_AT_LBRACK] = ACTIONS(125),
  },
  [6] = {
    [sym_line_comment] = STATE(6),
    [sym_block_comment] = STATE(6),
    [sym_const_declaration] = STATE(1788),
    [sym_global_var_declaration] = STATE(1788),
    [sym_type_declaration] = STATE(1788),
    [sym_function_declaration] = STATE(1788),
    [sym_static_method_declaration] = STATE(1788),
    [sym_struct_declaration] = STATE(1788),
    [sym_enum_declaration] = STATE(1788),
    [sym_interface_declaration] = STATE(1788),
    [sym__expression] = STATE(244),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_strictly_expression_list] = STATE(1796),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_visibility_modifiers] = STATE(3616),
    [sym_mutability_modifiers] = STATE(932),
    [sym_mutable_expression] = STATE(3390),
    [sym_expression_list] = STATE(3404),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1788),
    [sym_simple_statement] = STATE(1804),
    [sym_assert_statement] = STATE(1804),
    [sym_append_statement] = STATE(1804),
    [sym_send_statement] = STATE(1804),
    [sym_var_declaration] = STATE(1796),
    [sym_assignment_statement] = STATE(1796),
    [sym_block] = STATE(1804),
    [sym_defer_statement] = STATE(1804),
    [sym_goto_statement] = STATE(1804),
    [sym_break_statement] = STATE(1804),
    [sym_continue_statement] = STATE(1804),
    [sym_return_statement] = STATE(1804),
    [sym_label_definition] = STATE(13),
    [sym_labeled_statement] = STATE(1804),
    [sym_compile_time_for_statement] = STATE(1804),
    [sym_for_statement] = STATE(1804),
    [sym_hash_statement] = STATE(1804),
    [sym_asm_statement] = STATE(1804),
    [sym_attributes] = STATE(3487),
    [sym_attribute] = STATE(3407),
    [aux_sym_source_file_repeat1] = STATE(12),
    [aux_sym_attributes_repeat1] = STATE(3449),
    [ts_builtin_sym_end] = ACTIONS(133),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym___global] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(27),
    [anon_sym_fn] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_pub] = ACTIONS(39),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_enum] = ACTIONS(43),
    [anon_sym_interface] = ACTIONS(45),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(105),
    [anon_sym_defer] = ACTIONS(107),
    [anon_sym_goto] = ACTIONS(109),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_continue] = ACTIONS(113),
    [anon_sym_return] = ACTIONS(115),
    [anon_sym_DOLLARfor] = ACTIONS(117),
    [anon_sym_for] = ACTIONS(119),
    [anon_sym_POUND] = ACTIONS(129),
    [anon_sym_asm] = ACTIONS(123),
    [anon_sym_AT_LBRACK] = ACTIONS(125),
  },
  [7] = {
    [sym_line_comment] = STATE(7),
    [sym_block_comment] = STATE(7),
    [sym_const_declaration] = STATE(1788),
    [sym_global_var_declaration] = STATE(1788),
    [sym_type_declaration] = STATE(1788),
    [sym_function_declaration] = STATE(1788),
    [sym_static_method_declaration] = STATE(1788),
    [sym_struct_declaration] = STATE(1788),
    [sym_enum_declaration] = STATE(1788),
    [sym_interface_declaration] = STATE(1788),
    [sym__expression] = STATE(244),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_strictly_expression_list] = STATE(1796),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_visibility_modifiers] = STATE(3616),
    [sym_mutability_modifiers] = STATE(932),
    [sym_mutable_expression] = STATE(3390),
    [sym_expression_list] = STATE(3404),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1788),
    [sym_simple_statement] = STATE(1804),
    [sym_assert_statement] = STATE(1804),
    [sym_append_statement] = STATE(1804),
    [sym_send_statement] = STATE(1804),
    [sym_var_declaration] = STATE(1796),
    [sym_assignment_statement] = STATE(1796),
    [sym_block] = STATE(1804),
    [sym_defer_statement] = STATE(1804),
    [sym_goto_statement] = STATE(1804),
    [sym_break_statement] = STATE(1804),
    [sym_continue_statement] = STATE(1804),
    [sym_return_statement] = STATE(1804),
    [sym_label_definition] = STATE(13),
    [sym_labeled_statement] = STATE(1804),
    [sym_compile_time_for_statement] = STATE(1804),
    [sym_for_statement] = STATE(1804),
    [sym_hash_statement] = STATE(1804),
    [sym_asm_statement] = STATE(1804),
    [sym_attributes] = STATE(3487),
    [sym_attribute] = STATE(3407),
    [aux_sym_source_file_repeat1] = STATE(12),
    [aux_sym_attributes_repeat1] = STATE(3449),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym___global] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(27),
    [anon_sym_fn] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_pub] = ACTIONS(39),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_enum] = ACTIONS(43),
    [anon_sym_interface] = ACTIONS(45),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(105),
    [anon_sym_defer] = ACTIONS(107),
    [anon_sym_goto] = ACTIONS(109),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_continue] = ACTIONS(113),
    [anon_sym_return] = ACTIONS(115),
    [anon_sym_DOLLARfor] = ACTIONS(117),
    [anon_sym_for] = ACTIONS(119),
    [anon_sym_POUND] = ACTIONS(129),
    [anon_sym_asm] = ACTIONS(123),
    [anon_sym_AT_LBRACK] = ACTIONS(125),
  },
  [8] = {
    [sym_line_comment] = STATE(8),
    [sym_block_comment] = STATE(8),
    [sym_const_declaration] = STATE(1788),
    [sym_global_var_declaration] = STATE(1788),
    [sym_type_declaration] = STATE(1788),
    [sym_function_declaration] = STATE(1788),
    [sym_static_method_declaration] = STATE(1788),
    [sym_struct_declaration] = STATE(1788),
    [sym_enum_declaration] = STATE(1788),
    [sym_interface_declaration] = STATE(1788),
    [sym__expression] = STATE(244),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_strictly_expression_list] = STATE(1796),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_visibility_modifiers] = STATE(3616),
    [sym_mutability_modifiers] = STATE(932),
    [sym_mutable_expression] = STATE(3390),
    [sym_expression_list] = STATE(3404),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1788),
    [sym_simple_statement] = STATE(1804),
    [sym_assert_statement] = STATE(1804),
    [sym_append_statement] = STATE(1804),
    [sym_send_statement] = STATE(1804),
    [sym_var_declaration] = STATE(1796),
    [sym_assignment_statement] = STATE(1796),
    [sym_block] = STATE(1804),
    [sym_defer_statement] = STATE(1804),
    [sym_goto_statement] = STATE(1804),
    [sym_break_statement] = STATE(1804),
    [sym_continue_statement] = STATE(1804),
    [sym_return_statement] = STATE(1804),
    [sym_label_definition] = STATE(13),
    [sym_labeled_statement] = STATE(1804),
    [sym_compile_time_for_statement] = STATE(1804),
    [sym_for_statement] = STATE(1804),
    [sym_hash_statement] = STATE(1804),
    [sym_asm_statement] = STATE(1804),
    [sym_attributes] = STATE(3487),
    [sym_attribute] = STATE(3407),
    [aux_sym_source_file_repeat1] = STATE(6),
    [aux_sym_attributes_repeat1] = STATE(3449),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym___global] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(27),
    [anon_sym_fn] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_pub] = ACTIONS(39),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_enum] = ACTIONS(43),
    [anon_sym_interface] = ACTIONS(45),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(105),
    [anon_sym_defer] = ACTIONS(107),
    [anon_sym_goto] = ACTIONS(109),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_continue] = ACTIONS(113),
    [anon_sym_return] = ACTIONS(115),
    [anon_sym_DOLLARfor] = ACTIONS(117),
    [anon_sym_for] = ACTIONS(119),
    [anon_sym_POUND] = ACTIONS(129),
    [anon_sym_asm] = ACTIONS(123),
    [anon_sym_AT_LBRACK] = ACTIONS(125),
  },
  [9] = {
    [sym_line_comment] = STATE(9),
    [sym_block_comment] = STATE(9),
    [sym_const_declaration] = STATE(1788),
    [sym_global_var_declaration] = STATE(1788),
    [sym_type_declaration] = STATE(1788),
    [sym_function_declaration] = STATE(1788),
    [sym_static_method_declaration] = STATE(1788),
    [sym_struct_declaration] = STATE(1788),
    [sym_enum_declaration] = STATE(1788),
    [sym_interface_declaration] = STATE(1788),
    [sym__expression] = STATE(244),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_strictly_expression_list] = STATE(1796),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_visibility_modifiers] = STATE(3616),
    [sym_mutability_modifiers] = STATE(932),
    [sym_mutable_expression] = STATE(3390),
    [sym_expression_list] = STATE(3404),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1788),
    [sym_simple_statement] = STATE(1804),
    [sym_assert_statement] = STATE(1804),
    [sym_append_statement] = STATE(1804),
    [sym_send_statement] = STATE(1804),
    [sym_var_declaration] = STATE(1796),
    [sym_assignment_statement] = STATE(1796),
    [sym_block] = STATE(1804),
    [sym_defer_statement] = STATE(1804),
    [sym_goto_statement] = STATE(1804),
    [sym_break_statement] = STATE(1804),
    [sym_continue_statement] = STATE(1804),
    [sym_return_statement] = STATE(1804),
    [sym_label_definition] = STATE(13),
    [sym_labeled_statement] = STATE(1804),
    [sym_compile_time_for_statement] = STATE(1804),
    [sym_for_statement] = STATE(1804),
    [sym_hash_statement] = STATE(1804),
    [sym_asm_statement] = STATE(1804),
    [sym_attributes] = STATE(3487),
    [sym_attribute] = STATE(3407),
    [aux_sym_source_file_repeat1] = STATE(7),
    [aux_sym_attributes_repeat1] = STATE(3449),
    [ts_builtin_sym_end] = ACTIONS(131),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym___global] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(27),
    [anon_sym_fn] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_pub] = ACTIONS(39),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_enum] = ACTIONS(43),
    [anon_sym_interface] = ACTIONS(45),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(105),
    [anon_sym_defer] = ACTIONS(107),
    [anon_sym_goto] = ACTIONS(109),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_continue] = ACTIONS(113),
    [anon_sym_return] = ACTIONS(115),
    [anon_sym_DOLLARfor] = ACTIONS(117),
    [anon_sym_for] = ACTIONS(119),
    [anon_sym_POUND] = ACTIONS(129),
    [anon_sym_asm] = ACTIONS(123),
    [anon_sym_AT_LBRACK] = ACTIONS(125),
  },
  [10] = {
    [sym_line_comment] = STATE(10),
    [sym_block_comment] = STATE(10),
    [sym_const_declaration] = STATE(1788),
    [sym_global_var_declaration] = STATE(1788),
    [sym_type_declaration] = STATE(1788),
    [sym_function_declaration] = STATE(1788),
    [sym_static_method_declaration] = STATE(1788),
    [sym_struct_declaration] = STATE(1788),
    [sym_enum_declaration] = STATE(1788),
    [sym_interface_declaration] = STATE(1788),
    [sym__expression] = STATE(244),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_strictly_expression_list] = STATE(1796),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_visibility_modifiers] = STATE(3616),
    [sym_mutability_modifiers] = STATE(932),
    [sym_mutable_expression] = STATE(3390),
    [sym_expression_list] = STATE(3404),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1788),
    [sym_simple_statement] = STATE(1804),
    [sym_assert_statement] = STATE(1804),
    [sym_append_statement] = STATE(1804),
    [sym_send_statement] = STATE(1804),
    [sym_var_declaration] = STATE(1796),
    [sym_assignment_statement] = STATE(1796),
    [sym_block] = STATE(1804),
    [sym_defer_statement] = STATE(1804),
    [sym_goto_statement] = STATE(1804),
    [sym_break_statement] = STATE(1804),
    [sym_continue_statement] = STATE(1804),
    [sym_return_statement] = STATE(1804),
    [sym_label_definition] = STATE(13),
    [sym_labeled_statement] = STATE(1804),
    [sym_compile_time_for_statement] = STATE(1804),
    [sym_for_statement] = STATE(1804),
    [sym_hash_statement] = STATE(1804),
    [sym_asm_statement] = STATE(1804),
    [sym_attributes] = STATE(3487),
    [sym_attribute] = STATE(3407),
    [aux_sym_source_file_repeat1] = STATE(12),
    [aux_sym_attributes_repeat1] = STATE(3449),
    [ts_builtin_sym_end] = ACTIONS(131),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym___global] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(27),
    [anon_sym_fn] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_pub] = ACTIONS(39),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_enum] = ACTIONS(43),
    [anon_sym_interface] = ACTIONS(45),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(105),
    [anon_sym_defer] = ACTIONS(107),
    [anon_sym_goto] = ACTIONS(109),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_continue] = ACTIONS(113),
    [anon_sym_return] = ACTIONS(115),
    [anon_sym_DOLLARfor] = ACTIONS(117),
    [anon_sym_for] = ACTIONS(119),
    [anon_sym_POUND] = ACTIONS(129),
    [anon_sym_asm] = ACTIONS(123),
    [anon_sym_AT_LBRACK] = ACTIONS(125),
  },
  [11] = {
    [sym_line_comment] = STATE(11),
    [sym_block_comment] = STATE(11),
    [sym_const_declaration] = STATE(1788),
    [sym_global_var_declaration] = STATE(1788),
    [sym_type_declaration] = STATE(1788),
    [sym_function_declaration] = STATE(1788),
    [sym_static_method_declaration] = STATE(1788),
    [sym_struct_declaration] = STATE(1788),
    [sym_enum_declaration] = STATE(1788),
    [sym_interface_declaration] = STATE(1788),
    [sym__expression] = STATE(244),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_strictly_expression_list] = STATE(1796),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_visibility_modifiers] = STATE(3616),
    [sym_mutability_modifiers] = STATE(932),
    [sym_mutable_expression] = STATE(3390),
    [sym_expression_list] = STATE(3404),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1788),
    [sym_simple_statement] = STATE(1804),
    [sym_assert_statement] = STATE(1804),
    [sym_append_statement] = STATE(1804),
    [sym_send_statement] = STATE(1804),
    [sym_var_declaration] = STATE(1796),
    [sym_assignment_statement] = STATE(1796),
    [sym_block] = STATE(1804),
    [sym_defer_statement] = STATE(1804),
    [sym_goto_statement] = STATE(1804),
    [sym_break_statement] = STATE(1804),
    [sym_continue_statement] = STATE(1804),
    [sym_return_statement] = STATE(1804),
    [sym_label_definition] = STATE(13),
    [sym_labeled_statement] = STATE(1804),
    [sym_compile_time_for_statement] = STATE(1804),
    [sym_for_statement] = STATE(1804),
    [sym_hash_statement] = STATE(1804),
    [sym_asm_statement] = STATE(1804),
    [sym_attributes] = STATE(3487),
    [sym_attribute] = STATE(3407),
    [aux_sym_source_file_repeat1] = STATE(12),
    [aux_sym_attributes_repeat1] = STATE(3449),
    [ts_builtin_sym_end] = ACTIONS(127),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym___global] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(27),
    [anon_sym_fn] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_pub] = ACTIONS(39),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_enum] = ACTIONS(43),
    [anon_sym_interface] = ACTIONS(45),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(105),
    [anon_sym_defer] = ACTIONS(107),
    [anon_sym_goto] = ACTIONS(109),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_continue] = ACTIONS(113),
    [anon_sym_return] = ACTIONS(115),
    [anon_sym_DOLLARfor] = ACTIONS(117),
    [anon_sym_for] = ACTIONS(119),
    [anon_sym_POUND] = ACTIONS(129),
    [anon_sym_asm] = ACTIONS(123),
    [anon_sym_AT_LBRACK] = ACTIONS(125),
  },
  [12] = {
    [sym_line_comment] = STATE(12),
    [sym_block_comment] = STATE(12),
    [sym_const_declaration] = STATE(1788),
    [sym_global_var_declaration] = STATE(1788),
    [sym_type_declaration] = STATE(1788),
    [sym_function_declaration] = STATE(1788),
    [sym_static_method_declaration] = STATE(1788),
    [sym_struct_declaration] = STATE(1788),
    [sym_enum_declaration] = STATE(1788),
    [sym_interface_declaration] = STATE(1788),
    [sym__expression] = STATE(244),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_strictly_expression_list] = STATE(1796),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_visibility_modifiers] = STATE(3616),
    [sym_mutability_modifiers] = STATE(932),
    [sym_mutable_expression] = STATE(3390),
    [sym_expression_list] = STATE(3404),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1788),
    [sym_simple_statement] = STATE(1804),
    [sym_assert_statement] = STATE(1804),
    [sym_append_statement] = STATE(1804),
    [sym_send_statement] = STATE(1804),
    [sym_var_declaration] = STATE(1796),
    [sym_assignment_statement] = STATE(1796),
    [sym_block] = STATE(1804),
    [sym_defer_statement] = STATE(1804),
    [sym_goto_statement] = STATE(1804),
    [sym_break_statement] = STATE(1804),
    [sym_continue_statement] = STATE(1804),
    [sym_return_statement] = STATE(1804),
    [sym_label_definition] = STATE(13),
    [sym_labeled_statement] = STATE(1804),
    [sym_compile_time_for_statement] = STATE(1804),
    [sym_for_statement] = STATE(1804),
    [sym_hash_statement] = STATE(1804),
    [sym_asm_statement] = STATE(1804),
    [sym_attributes] = STATE(3487),
    [sym_attribute] = STATE(3407),
    [aux_sym_source_file_repeat1] = STATE(12),
    [aux_sym_attributes_repeat1] = STATE(3449),
    [ts_builtin_sym_end] = ACTIONS(137),
    [sym_identifier] = ACTIONS(139),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(142),
    [anon_sym_LBRACE] = ACTIONS(145),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym___global] = ACTIONS(154),
    [anon_sym_type] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(166),
    [anon_sym_struct] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(172),
    [anon_sym_pub] = ACTIONS(175),
    [anon_sym_mut] = ACTIONS(178),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_interface] = ACTIONS(184),
    [anon_sym_QMARK] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(190),
    [anon_sym_go] = ACTIONS(193),
    [anon_sym_spawn] = ACTIONS(196),
    [anon_sym_json_DOTdecode] = ACTIONS(199),
    [anon_sym_LBRACK2] = ACTIONS(202),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_AMP] = ACTIONS(205),
    [anon_sym_LT_DASH] = ACTIONS(208),
    [sym_none] = ACTIONS(211),
    [sym_true] = ACTIONS(211),
    [sym_false] = ACTIONS(211),
    [sym_nil] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(214),
    [anon_sym_DOLLARif] = ACTIONS(217),
    [anon_sym_match] = ACTIONS(220),
    [anon_sym_select] = ACTIONS(223),
    [anon_sym_lock] = ACTIONS(226),
    [anon_sym_rlock] = ACTIONS(226),
    [anon_sym_unsafe] = ACTIONS(229),
    [anon_sym_sql] = ACTIONS(232),
    [sym_int_literal] = ACTIONS(211),
    [sym_float_literal] = ACTIONS(235),
    [sym_rune_literal] = ACTIONS(235),
    [anon_sym_SQUOTE] = ACTIONS(238),
    [anon_sym_DQUOTE] = ACTIONS(241),
    [anon_sym_c_SQUOTE] = ACTIONS(244),
    [anon_sym_c_DQUOTE] = ACTIONS(247),
    [anon_sym_r_SQUOTE] = ACTIONS(250),
    [anon_sym_r_DQUOTE] = ACTIONS(253),
    [sym_pseudo_compile_time_identifier] = ACTIONS(256),
    [anon_sym_shared] = ACTIONS(259),
    [anon_sym_map_LBRACK] = ACTIONS(262),
    [anon_sym_chan] = ACTIONS(265),
    [anon_sym_thread] = ACTIONS(268),
    [anon_sym_atomic] = ACTIONS(271),
    [anon_sym_assert] = ACTIONS(274),
    [anon_sym_defer] = ACTIONS(277),
    [anon_sym_goto] = ACTIONS(280),
    [anon_sym_break] = ACTIONS(283),
    [anon_sym_continue] = ACTIONS(286),
    [anon_sym_return] = ACTIONS(289),
    [anon_sym_DOLLARfor] = ACTIONS(292),
    [anon_sym_for] = ACTIONS(295),
    [anon_sym_POUND] = ACTIONS(298),
    [anon_sym_asm] = ACTIONS(301),
    [anon_sym_AT_LBRACK] = ACTIONS(304),
  },
  [13] = {
    [sym_line_comment] = STATE(13),
    [sym_block_comment] = STATE(13),
    [sym__expression] = STATE(244),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_strictly_expression_list] = STATE(1796),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_mutability_modifiers] = STATE(932),
    [sym_mutable_expression] = STATE(3390),
    [sym_expression_list] = STATE(3404),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1782),
    [sym_simple_statement] = STATE(1804),
    [sym_assert_statement] = STATE(1804),
    [sym_append_statement] = STATE(1804),
    [sym_send_statement] = STATE(1804),
    [sym_var_declaration] = STATE(1796),
    [sym_assignment_statement] = STATE(1796),
    [sym_block] = STATE(1804),
    [sym_defer_statement] = STATE(1804),
    [sym_goto_statement] = STATE(1804),
    [sym_break_statement] = STATE(1804),
    [sym_continue_statement] = STATE(1804),
    [sym_return_statement] = STATE(1804),
    [sym_label_definition] = STATE(13),
    [sym_labeled_statement] = STATE(1804),
    [sym_compile_time_for_statement] = STATE(1804),
    [sym_for_statement] = STATE(1804),
    [sym_hash_statement] = STATE(1804),
    [sym_asm_statement] = STATE(1804),
    [ts_builtin_sym_end] = ACTIONS(307),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LF] = ACTIONS(309),
    [anon_sym_CR] = ACTIONS(309),
    [anon_sym_CR_LF] = ACTIONS(309),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(315),
    [anon_sym_const] = ACTIONS(309),
    [anon_sym_LPAREN] = ACTIONS(317),
    [anon_sym___global] = ACTIONS(309),
    [anon_sym_type] = ACTIONS(309),
    [anon_sym_fn] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(321),
    [anon_sym_DASH] = ACTIONS(321),
    [anon_sym_STAR] = ACTIONS(323),
    [anon_sym_struct] = ACTIONS(325),
    [anon_sym_union] = ACTIONS(309),
    [anon_sym_pub] = ACTIONS(309),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_enum] = ACTIONS(309),
    [anon_sym_interface] = ACTIONS(309),
    [anon_sym_QMARK] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(329),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(331),
    [anon_sym_LBRACK2] = ACTIONS(333),
    [anon_sym_TILDE] = ACTIONS(321),
    [anon_sym_CARET] = ACTIONS(321),
    [anon_sym_AMP] = ACTIONS(335),
    [anon_sym_LT_DASH] = ACTIONS(337),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(63),
    [sym_rune_literal] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [anon_sym_c_SQUOTE] = ACTIONS(343),
    [anon_sym_c_DQUOTE] = ACTIONS(345),
    [anon_sym_r_SQUOTE] = ACTIONS(347),
    [anon_sym_r_DQUOTE] = ACTIONS(349),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(351),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(105),
    [anon_sym_defer] = ACTIONS(107),
    [anon_sym_goto] = ACTIONS(109),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_continue] = ACTIONS(113),
    [anon_sym_return] = ACTIONS(115),
    [anon_sym_DOLLARfor] = ACTIONS(117),
    [anon_sym_for] = ACTIONS(119),
    [anon_sym_POUND] = ACTIONS(121),
    [anon_sym_asm] = ACTIONS(123),
    [anon_sym_AT_LBRACK] = ACTIONS(309),
  },
  [14] = {
    [sym_line_comment] = STATE(14),
    [sym_block_comment] = STATE(14),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1935),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_LF] = ACTIONS(309),
    [anon_sym_CR] = ACTIONS(309),
    [anon_sym_CR_LF] = ACTIONS(309),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_RBRACE] = ACTIONS(309),
    [anon_sym_LPAREN] = ACTIONS(359),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(365),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(369),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(375),
    [anon_sym_LBRACK2] = ACTIONS(377),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_LT_DASH] = ACTIONS(381),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(383),
    [sym_rune_literal] = ACTIONS(383),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_DQUOTE] = ACTIONS(401),
    [anon_sym_c_SQUOTE] = ACTIONS(403),
    [anon_sym_c_DQUOTE] = ACTIONS(405),
    [anon_sym_r_SQUOTE] = ACTIONS(407),
    [anon_sym_r_DQUOTE] = ACTIONS(409),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(351),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(429),
    [anon_sym_asm] = ACTIONS(431),
  },
  [15] = {
    [sym_line_comment] = STATE(15),
    [sym_block_comment] = STATE(15),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(46),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [16] = {
    [sym_line_comment] = STATE(16),
    [sym_block_comment] = STATE(16),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(56),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(471),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [17] = {
    [sym_line_comment] = STATE(17),
    [sym_block_comment] = STATE(17),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(55),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [18] = {
    [sym_line_comment] = STATE(18),
    [sym_block_comment] = STATE(18),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(54),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(475),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [19] = {
    [sym_line_comment] = STATE(19),
    [sym_block_comment] = STATE(19),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(78),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(477),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [20] = {
    [sym_line_comment] = STATE(20),
    [sym_block_comment] = STATE(20),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(82),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [21] = {
    [sym_line_comment] = STATE(21),
    [sym_block_comment] = STATE(21),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(55),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(471),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [22] = {
    [sym_line_comment] = STATE(22),
    [sym_block_comment] = STATE(22),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(304),
    [aux_sym_block_repeat1] = STATE(45),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [23] = {
    [sym_line_comment] = STATE(23),
    [sym_block_comment] = STATE(23),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(46),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [24] = {
    [sym_line_comment] = STATE(24),
    [sym_block_comment] = STATE(24),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(55),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(485),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [25] = {
    [sym_line_comment] = STATE(25),
    [sym_block_comment] = STATE(25),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(56),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [26] = {
    [sym_line_comment] = STATE(26),
    [sym_block_comment] = STATE(26),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(43),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [27] = {
    [sym_line_comment] = STATE(27),
    [sym_block_comment] = STATE(27),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(84),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(491),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [28] = {
    [sym_line_comment] = STATE(28),
    [sym_block_comment] = STATE(28),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(78),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(493),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [29] = {
    [sym_line_comment] = STATE(29),
    [sym_block_comment] = STATE(29),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(54),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [30] = {
    [sym_line_comment] = STATE(30),
    [sym_block_comment] = STATE(30),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(43),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(497),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [31] = {
    [sym_line_comment] = STATE(31),
    [sym_block_comment] = STATE(31),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(323),
    [aux_sym_block_repeat1] = STATE(75),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [32] = {
    [sym_line_comment] = STATE(32),
    [sym_block_comment] = STATE(32),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(49),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(501),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [33] = {
    [sym_line_comment] = STATE(33),
    [sym_block_comment] = STATE(33),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(85),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [34] = {
    [sym_line_comment] = STATE(34),
    [sym_block_comment] = STATE(34),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(69),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [35] = {
    [sym_line_comment] = STATE(35),
    [sym_block_comment] = STATE(35),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(277),
    [aux_sym_block_repeat1] = STATE(45),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [36] = {
    [sym_line_comment] = STATE(36),
    [sym_block_comment] = STATE(36),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(304),
    [aux_sym_block_repeat1] = STATE(75),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [37] = {
    [sym_line_comment] = STATE(37),
    [sym_block_comment] = STATE(37),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(56),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [38] = {
    [sym_line_comment] = STATE(38),
    [sym_block_comment] = STATE(38),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(53),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [39] = {
    [sym_line_comment] = STATE(39),
    [sym_block_comment] = STATE(39),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(48),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [40] = {
    [sym_line_comment] = STATE(40),
    [sym_block_comment] = STATE(40),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(55),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(511),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [41] = {
    [sym_line_comment] = STATE(41),
    [sym_block_comment] = STATE(41),
    [sym__expression] = STATE(894),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_block_repeat1] = STATE(69),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [42] = {
    [sym_line_comment] = STATE(42),
    [sym_block_comment] = STATE(42),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(48),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [43] = {
    [sym_line_comment] = STATE(43),
    [sym_block_comment] = STATE(43),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(517),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [44] = {
    [sym_line_comment] = STATE(44),
    [sym_block_comment] = STATE(44),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(82),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(519),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [45] = {
    [sym_line_comment] = STATE(45),
    [sym_block_comment] = STATE(45),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(521),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [46] = {
    [sym_line_comment] = STATE(46),
    [sym_block_comment] = STATE(46),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(523),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [47] = {
    [sym_line_comment] = STATE(47),
    [sym_block_comment] = STATE(47),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(56),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(525),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [48] = {
    [sym_line_comment] = STATE(48),
    [sym_block_comment] = STATE(48),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [49] = {
    [sym_line_comment] = STATE(49),
    [sym_block_comment] = STATE(49),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [50] = {
    [sym_line_comment] = STATE(50),
    [sym_block_comment] = STATE(50),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(531),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [51] = {
    [sym_line_comment] = STATE(51),
    [sym_block_comment] = STATE(51),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(88),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [52] = {
    [sym_line_comment] = STATE(52),
    [sym_block_comment] = STATE(52),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(72),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(535),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [53] = {
    [sym_line_comment] = STATE(53),
    [sym_block_comment] = STATE(53),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [54] = {
    [sym_line_comment] = STATE(54),
    [sym_block_comment] = STATE(54),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [55] = {
    [sym_line_comment] = STATE(55),
    [sym_block_comment] = STATE(55),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [56] = {
    [sym_line_comment] = STATE(56),
    [sym_block_comment] = STATE(56),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(543),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [57] = {
    [sym_line_comment] = STATE(57),
    [sym_block_comment] = STATE(57),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(53),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [58] = {
    [sym_line_comment] = STATE(58),
    [sym_block_comment] = STATE(58),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(79),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(547),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [59] = {
    [sym_line_comment] = STATE(59),
    [sym_block_comment] = STATE(59),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(45),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [60] = {
    [sym_line_comment] = STATE(60),
    [sym_block_comment] = STATE(60),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(54),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [61] = {
    [sym_line_comment] = STATE(61),
    [sym_block_comment] = STATE(61),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [62] = {
    [sym_line_comment] = STATE(62),
    [sym_block_comment] = STATE(62),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(555),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [63] = {
    [sym_line_comment] = STATE(63),
    [sym_block_comment] = STATE(63),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(62),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(557),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [64] = {
    [sym_line_comment] = STATE(64),
    [sym_block_comment] = STATE(64),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(84),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [65] = {
    [sym_line_comment] = STATE(65),
    [sym_block_comment] = STATE(65),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(70),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(561),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [66] = {
    [sym_line_comment] = STATE(66),
    [sym_block_comment] = STATE(66),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(49),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(563),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [67] = {
    [sym_line_comment] = STATE(67),
    [sym_block_comment] = STATE(67),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(61),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [68] = {
    [sym_line_comment] = STATE(68),
    [sym_block_comment] = STATE(68),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(78),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(567),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [69] = {
    [sym_line_comment] = STATE(69),
    [sym_block_comment] = STATE(69),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [70] = {
    [sym_line_comment] = STATE(70),
    [sym_block_comment] = STATE(70),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [71] = {
    [sym_line_comment] = STATE(71),
    [sym_block_comment] = STATE(71),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(75),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [72] = {
    [sym_line_comment] = STATE(72),
    [sym_block_comment] = STATE(72),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(575),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [73] = {
    [sym_line_comment] = STATE(73),
    [sym_block_comment] = STATE(73),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(46),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(577),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [74] = {
    [sym_line_comment] = STATE(74),
    [sym_block_comment] = STATE(74),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(50),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [75] = {
    [sym_line_comment] = STATE(75),
    [sym_block_comment] = STATE(75),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(581),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [76] = {
    [sym_line_comment] = STATE(76),
    [sym_block_comment] = STATE(76),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(87),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [77] = {
    [sym_line_comment] = STATE(77),
    [sym_block_comment] = STATE(77),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(43),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(585),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [78] = {
    [sym_line_comment] = STATE(78),
    [sym_block_comment] = STATE(78),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(587),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [79] = {
    [sym_line_comment] = STATE(79),
    [sym_block_comment] = STATE(79),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(589),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [80] = {
    [sym_line_comment] = STATE(80),
    [sym_block_comment] = STATE(80),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(69),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(591),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [81] = {
    [sym_line_comment] = STATE(81),
    [sym_block_comment] = STATE(81),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(593),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(596),
    [anon_sym_LBRACE] = ACTIONS(599),
    [anon_sym_RBRACE] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(604),
    [anon_sym_fn] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(610),
    [anon_sym_DASH] = ACTIONS(610),
    [anon_sym_STAR] = ACTIONS(613),
    [anon_sym_struct] = ACTIONS(616),
    [anon_sym_mut] = ACTIONS(619),
    [anon_sym_QMARK] = ACTIONS(622),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_go] = ACTIONS(628),
    [anon_sym_spawn] = ACTIONS(631),
    [anon_sym_json_DOTdecode] = ACTIONS(634),
    [anon_sym_LBRACK2] = ACTIONS(637),
    [anon_sym_TILDE] = ACTIONS(610),
    [anon_sym_CARET] = ACTIONS(610),
    [anon_sym_AMP] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(643),
    [sym_none] = ACTIONS(646),
    [sym_true] = ACTIONS(646),
    [sym_false] = ACTIONS(646),
    [sym_nil] = ACTIONS(646),
    [anon_sym_if] = ACTIONS(649),
    [anon_sym_DOLLARif] = ACTIONS(652),
    [anon_sym_match] = ACTIONS(655),
    [anon_sym_select] = ACTIONS(658),
    [anon_sym_lock] = ACTIONS(661),
    [anon_sym_rlock] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(664),
    [anon_sym_sql] = ACTIONS(667),
    [sym_int_literal] = ACTIONS(646),
    [sym_float_literal] = ACTIONS(670),
    [sym_rune_literal] = ACTIONS(670),
    [anon_sym_SQUOTE] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(676),
    [anon_sym_c_SQUOTE] = ACTIONS(679),
    [anon_sym_c_DQUOTE] = ACTIONS(682),
    [anon_sym_r_SQUOTE] = ACTIONS(685),
    [anon_sym_r_DQUOTE] = ACTIONS(688),
    [sym_pseudo_compile_time_identifier] = ACTIONS(691),
    [anon_sym_shared] = ACTIONS(694),
    [anon_sym_map_LBRACK] = ACTIONS(697),
    [anon_sym_chan] = ACTIONS(700),
    [anon_sym_thread] = ACTIONS(703),
    [anon_sym_atomic] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(709),
    [anon_sym_defer] = ACTIONS(712),
    [anon_sym_goto] = ACTIONS(715),
    [anon_sym_break] = ACTIONS(718),
    [anon_sym_continue] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(724),
    [anon_sym_DOLLARfor] = ACTIONS(727),
    [anon_sym_for] = ACTIONS(730),
    [anon_sym_POUND] = ACTIONS(733),
    [anon_sym_asm] = ACTIONS(736),
  },
  [82] = {
    [sym_line_comment] = STATE(82),
    [sym_block_comment] = STATE(82),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(739),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [83] = {
    [sym_line_comment] = STATE(83),
    [sym_block_comment] = STATE(83),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(55),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(741),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [84] = {
    [sym_line_comment] = STATE(84),
    [sym_block_comment] = STATE(84),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [85] = {
    [sym_line_comment] = STATE(85),
    [sym_block_comment] = STATE(85),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [86] = {
    [sym_line_comment] = STATE(86),
    [sym_block_comment] = STATE(86),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(85),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(747),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [87] = {
    [sym_line_comment] = STATE(87),
    [sym_block_comment] = STATE(87),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(749),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [88] = {
    [sym_line_comment] = STATE(88),
    [sym_block_comment] = STATE(88),
    [sym__expression] = STATE(984),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_strictly_expression_list] = STATE(1933),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(788),
    [sym_mutable_expression] = STATE(3383),
    [sym_expression_list] = STATE(3445),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__statement] = STATE(1932),
    [sym_simple_statement] = STATE(1950),
    [sym_assert_statement] = STATE(1950),
    [sym_append_statement] = STATE(1950),
    [sym_send_statement] = STATE(1950),
    [sym_var_declaration] = STATE(1933),
    [sym_assignment_statement] = STATE(1933),
    [sym_block] = STATE(1950),
    [sym_defer_statement] = STATE(1950),
    [sym_goto_statement] = STATE(1950),
    [sym_break_statement] = STATE(1950),
    [sym_continue_statement] = STATE(1950),
    [sym_return_statement] = STATE(1950),
    [sym_label_definition] = STATE(14),
    [sym_labeled_statement] = STATE(1950),
    [sym_compile_time_for_statement] = STATE(1950),
    [sym_for_statement] = STATE(1950),
    [sym_hash_statement] = STATE(1950),
    [sym_asm_statement] = STATE(1950),
    [aux_sym_block_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(413),
    [anon_sym_defer] = ACTIONS(415),
    [anon_sym_goto] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_DOLLARfor] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_POUND] = ACTIONS(469),
    [anon_sym_asm] = ACTIONS(431),
  },
  [89] = {
    [sym_line_comment] = STATE(89),
    [sym_block_comment] = STATE(89),
    [sym__expression] = STATE(1119),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(621),
    [sym_mutable_expression] = STATE(1715),
    [sym_expression_list] = STATE(1892),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [ts_builtin_sym_end] = ACTIONS(753),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_LF] = ACTIONS(757),
    [anon_sym_CR] = ACTIONS(757),
    [anon_sym_CR_LF] = ACTIONS(757),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(761),
    [anon_sym_const] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(763),
    [anon_sym___global] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(769),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_union] = ACTIONS(757),
    [anon_sym_pub] = ACTIONS(757),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_enum] = ACTIONS(757),
    [anon_sym_interface] = ACTIONS(757),
    [anon_sym_QMARK] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(773),
    [anon_sym_go] = ACTIONS(775),
    [anon_sym_spawn] = ACTIONS(777),
    [anon_sym_json_DOTdecode] = ACTIONS(779),
    [anon_sym_LBRACK2] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_LT_DASH] = ACTIONS(785),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(795),
    [anon_sym_lock] = ACTIONS(797),
    [anon_sym_rlock] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(787),
    [sym_rune_literal] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(803),
    [anon_sym_DQUOTE] = ACTIONS(805),
    [anon_sym_c_SQUOTE] = ACTIONS(807),
    [anon_sym_c_DQUOTE] = ACTIONS(809),
    [anon_sym_r_SQUOTE] = ACTIONS(811),
    [anon_sym_r_DQUOTE] = ACTIONS(813),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(351),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(757),
    [anon_sym_defer] = ACTIONS(757),
    [anon_sym_goto] = ACTIONS(757),
    [anon_sym_break] = ACTIONS(757),
    [anon_sym_continue] = ACTIONS(757),
    [anon_sym_return] = ACTIONS(757),
    [anon_sym_DOLLARfor] = ACTIONS(757),
    [anon_sym_for] = ACTIONS(757),
    [anon_sym_POUND] = ACTIONS(757),
    [anon_sym_asm] = ACTIONS(757),
    [anon_sym_AT_LBRACK] = ACTIONS(757),
  },
  [90] = {
    [sym_line_comment] = STATE(90),
    [sym_block_comment] = STATE(90),
    [sym_reference_expression] = STATE(4523),
    [sym_type_reference_expression] = STATE(291),
    [sym_plain_type] = STATE(493),
    [sym__plain_type_without_special] = STATE(429),
    [sym_anon_struct_type] = STATE(442),
    [sym_multi_return_type] = STATE(429),
    [sym_result_type] = STATE(429),
    [sym_option_type] = STATE(429),
    [sym_qualified_type] = STATE(291),
    [sym_fixed_array_type] = STATE(442),
    [sym_array_type] = STATE(442),
    [sym_pointer_type] = STATE(442),
    [sym_wrong_pointer_type] = STATE(442),
    [sym_map_type] = STATE(442),
    [sym_channel_type] = STATE(442),
    [sym_shared_type] = STATE(442),
    [sym_thread_type] = STATE(442),
    [sym_atomic_type] = STATE(442),
    [sym_generic_type] = STATE(442),
    [sym_function_type] = STATE(442),
    [ts_builtin_sym_end] = ACTIONS(817),
    [sym_identifier] = ACTIONS(819),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_CR] = ACTIONS(821),
    [anon_sym_CR_LF] = ACTIONS(821),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(821),
    [anon_sym_as] = ACTIONS(821),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_COMMA] = ACTIONS(821),
    [anon_sym_const] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_EQ] = ACTIONS(821),
    [anon_sym___global] = ACTIONS(821),
    [anon_sym_type] = ACTIONS(821),
    [anon_sym_fn] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(821),
    [anon_sym_DASH] = ACTIONS(821),
    [anon_sym_STAR] = ACTIONS(827),
    [anon_sym_SLASH] = ACTIONS(821),
    [anon_sym_PERCENT] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(821),
    [anon_sym_GT] = ACTIONS(821),
    [anon_sym_EQ_EQ] = ACTIONS(821),
    [anon_sym_BANG_EQ] = ACTIONS(821),
    [anon_sym_LT_EQ] = ACTIONS(821),
    [anon_sym_GT_EQ] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(817),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_union] = ACTIONS(821),
    [anon_sym_pub] = ACTIONS(821),
    [anon_sym_mut] = ACTIONS(821),
    [anon_sym_enum] = ACTIONS(821),
    [anon_sym_interface] = ACTIONS(821),
    [anon_sym_PLUS_PLUS] = ACTIONS(821),
    [anon_sym_DASH_DASH] = ACTIONS(821),
    [anon_sym_QMARK] = ACTIONS(831),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_go] = ACTIONS(821),
    [anon_sym_spawn] = ACTIONS(821),
    [anon_sym_json_DOTdecode] = ACTIONS(821),
    [anon_sym_PIPE] = ACTIONS(821),
    [anon_sym_LBRACK2] = ACTIONS(835),
    [anon_sym_TILDE] = ACTIONS(821),
    [anon_sym_CARET] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(837),
    [anon_sym_LT_DASH] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(821),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_GT_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_CARET] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_or] = ACTIONS(821),
    [sym_none] = ACTIONS(821),
    [sym_true] = ACTIONS(821),
    [sym_false] = ACTIONS(821),
    [sym_nil] = ACTIONS(821),
    [anon_sym_QMARK_DOT] = ACTIONS(821),
    [anon_sym_POUND_LBRACK] = ACTIONS(821),
    [anon_sym_if] = ACTIONS(821),
    [anon_sym_DOLLARif] = ACTIONS(821),
    [anon_sym_is] = ACTIONS(821),
    [anon_sym_BANGis] = ACTIONS(821),
    [anon_sym_in] = ACTIONS(821),
    [anon_sym_BANGin] = ACTIONS(821),
    [anon_sym_match] = ACTIONS(821),
    [anon_sym_select] = ACTIONS(821),
    [anon_sym_STAR_EQ] = ACTIONS(821),
    [anon_sym_SLASH_EQ] = ACTIONS(821),
    [anon_sym_PERCENT_EQ] = ACTIONS(821),
    [anon_sym_LT_LT_EQ] = ACTIONS(821),
    [anon_sym_GT_GT_EQ] = ACTIONS(821),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(821),
    [anon_sym_AMP_EQ] = ACTIONS(821),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(821),
    [anon_sym_PLUS_EQ] = ACTIONS(821),
    [anon_sym_DASH_EQ] = ACTIONS(821),
    [anon_sym_PIPE_EQ] = ACTIONS(821),
    [anon_sym_CARET_EQ] = ACTIONS(821),
    [anon_sym_COLON_EQ] = ACTIONS(821),
    [anon_sym_lock] = ACTIONS(821),
    [anon_sym_rlock] = ACTIONS(821),
    [anon_sym_unsafe] = ACTIONS(821),
    [anon_sym_sql] = ACTIONS(821),
    [sym_int_literal] = ACTIONS(821),
    [sym_float_literal] = ACTIONS(821),
    [sym_rune_literal] = ACTIONS(821),
    [anon_sym_SQUOTE] = ACTIONS(821),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [anon_sym_c_SQUOTE] = ACTIONS(821),
    [anon_sym_c_DQUOTE] = ACTIONS(821),
    [anon_sym_r_SQUOTE] = ACTIONS(821),
    [anon_sym_r_DQUOTE] = ACTIONS(821),
    [sym_pseudo_compile_time_identifier] = ACTIONS(821),
    [anon_sym_shared] = ACTIONS(839),
    [anon_sym_map_LBRACK] = ACTIONS(841),
    [anon_sym_chan] = ACTIONS(843),
    [anon_sym_thread] = ACTIONS(845),
    [anon_sym_atomic] = ACTIONS(847),
    [anon_sym_assert] = ACTIONS(821),
    [anon_sym_defer] = ACTIONS(821),
    [anon_sym_goto] = ACTIONS(821),
    [anon_sym_break] = ACTIONS(821),
    [anon_sym_continue] = ACTIONS(821),
    [anon_sym_return] = ACTIONS(821),
    [anon_sym_DOLLARfor] = ACTIONS(821),
    [anon_sym_for] = ACTIONS(821),
    [anon_sym_POUND] = ACTIONS(821),
    [anon_sym_asm] = ACTIONS(821),
    [anon_sym_AT_LBRACK] = ACTIONS(821),
  },
  [91] = {
    [sym_line_comment] = STATE(91),
    [sym_block_comment] = STATE(91),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2489),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [ts_builtin_sym_end] = ACTIONS(849),
    [sym_identifier] = ACTIONS(851),
    [anon_sym_LF] = ACTIONS(851),
    [anon_sym_CR] = ACTIONS(851),
    [anon_sym_CR_LF] = ACTIONS(851),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(851),
    [anon_sym_COMMA] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_EQ] = ACTIONS(851),
    [anon_sym___global] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_fn] = ACTIONS(851),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(851),
    [anon_sym_SLASH] = ACTIONS(851),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_struct] = ACTIONS(851),
    [anon_sym_union] = ACTIONS(851),
    [anon_sym_pub] = ACTIONS(851),
    [anon_sym_mut] = ACTIONS(851),
    [anon_sym_enum] = ACTIONS(851),
    [anon_sym_interface] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(851),
    [anon_sym_DASH_DASH] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_go] = ACTIONS(851),
    [anon_sym_spawn] = ACTIONS(851),
    [anon_sym_json_DOTdecode] = ACTIONS(851),
    [anon_sym_PIPE] = ACTIONS(851),
    [anon_sym_LBRACK2] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_CARET] = ACTIONS(851),
    [anon_sym_AMP] = ACTIONS(851),
    [anon_sym_LT_DASH] = ACTIONS(851),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_CARET] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(851),
    [anon_sym_PIPE_PIPE] = ACTIONS(851),
    [anon_sym_or] = ACTIONS(851),
    [sym_none] = ACTIONS(851),
    [sym_true] = ACTIONS(851),
    [sym_false] = ACTIONS(851),
    [sym_nil] = ACTIONS(851),
    [anon_sym_QMARK_DOT] = ACTIONS(851),
    [anon_sym_POUND_LBRACK] = ACTIONS(851),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_DOLLARif] = ACTIONS(851),
    [anon_sym_is] = ACTIONS(851),
    [anon_sym_BANGis] = ACTIONS(851),
    [anon_sym_in] = ACTIONS(851),
    [anon_sym_BANGin] = ACTIONS(851),
    [anon_sym_match] = ACTIONS(851),
    [anon_sym_select] = ACTIONS(851),
    [anon_sym_STAR_EQ] = ACTIONS(851),
    [anon_sym_SLASH_EQ] = ACTIONS(851),
    [anon_sym_PERCENT_EQ] = ACTIONS(851),
    [anon_sym_LT_LT_EQ] = ACTIONS(851),
    [anon_sym_GT_GT_EQ] = ACTIONS(851),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(851),
    [anon_sym_AMP_EQ] = ACTIONS(851),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(851),
    [anon_sym_PLUS_EQ] = ACTIONS(851),
    [anon_sym_DASH_EQ] = ACTIONS(851),
    [anon_sym_PIPE_EQ] = ACTIONS(851),
    [anon_sym_CARET_EQ] = ACTIONS(851),
    [anon_sym_COLON_EQ] = ACTIONS(851),
    [anon_sym_lock] = ACTIONS(851),
    [anon_sym_rlock] = ACTIONS(851),
    [anon_sym_unsafe] = ACTIONS(851),
    [anon_sym_sql] = ACTIONS(851),
    [sym_int_literal] = ACTIONS(851),
    [sym_float_literal] = ACTIONS(851),
    [sym_rune_literal] = ACTIONS(851),
    [anon_sym_SQUOTE] = ACTIONS(851),
    [anon_sym_DQUOTE] = ACTIONS(851),
    [anon_sym_c_SQUOTE] = ACTIONS(851),
    [anon_sym_c_DQUOTE] = ACTIONS(851),
    [anon_sym_r_SQUOTE] = ACTIONS(851),
    [anon_sym_r_DQUOTE] = ACTIONS(851),
    [sym_pseudo_compile_time_identifier] = ACTIONS(851),
    [anon_sym_shared] = ACTIONS(851),
    [anon_sym_map_LBRACK] = ACTIONS(851),
    [anon_sym_chan] = ACTIONS(851),
    [anon_sym_thread] = ACTIONS(851),
    [anon_sym_atomic] = ACTIONS(851),
    [anon_sym_assert] = ACTIONS(851),
    [anon_sym_defer] = ACTIONS(851),
    [anon_sym_goto] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(851),
    [anon_sym_continue] = ACTIONS(851),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_DOLLARfor] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(851),
    [anon_sym_asm] = ACTIONS(851),
    [anon_sym_AT_LBRACK] = ACTIONS(851),
  },
  [92] = {
    [sym_line_comment] = STATE(92),
    [sym_block_comment] = STATE(92),
    [sym_reference_expression] = STATE(4523),
    [sym_type_reference_expression] = STATE(291),
    [sym_plain_type] = STATE(514),
    [sym__plain_type_without_special] = STATE(429),
    [sym_anon_struct_type] = STATE(442),
    [sym_multi_return_type] = STATE(429),
    [sym_result_type] = STATE(429),
    [sym_option_type] = STATE(429),
    [sym_qualified_type] = STATE(291),
    [sym_fixed_array_type] = STATE(442),
    [sym_array_type] = STATE(442),
    [sym_pointer_type] = STATE(442),
    [sym_wrong_pointer_type] = STATE(442),
    [sym_map_type] = STATE(442),
    [sym_channel_type] = STATE(442),
    [sym_shared_type] = STATE(442),
    [sym_thread_type] = STATE(442),
    [sym_atomic_type] = STATE(442),
    [sym_generic_type] = STATE(442),
    [sym_function_type] = STATE(442),
    [ts_builtin_sym_end] = ACTIONS(853),
    [sym_identifier] = ACTIONS(819),
    [anon_sym_LF] = ACTIONS(855),
    [anon_sym_CR] = ACTIONS(855),
    [anon_sym_CR_LF] = ACTIONS(855),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(855),
    [anon_sym_as] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(855),
    [anon_sym_const] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_EQ] = ACTIONS(855),
    [anon_sym___global] = ACTIONS(855),
    [anon_sym_type] = ACTIONS(855),
    [anon_sym_fn] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(827),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_PERCENT] = ACTIONS(855),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_GT] = ACTIONS(855),
    [anon_sym_EQ_EQ] = ACTIONS(855),
    [anon_sym_BANG_EQ] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(855),
    [anon_sym_GT_EQ] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_union] = ACTIONS(855),
    [anon_sym_pub] = ACTIONS(855),
    [anon_sym_mut] = ACTIONS(855),
    [anon_sym_enum] = ACTIONS(855),
    [anon_sym_interface] = ACTIONS(855),
    [anon_sym_PLUS_PLUS] = ACTIONS(855),
    [anon_sym_DASH_DASH] = ACTIONS(855),
    [anon_sym_QMARK] = ACTIONS(831),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_go] = ACTIONS(855),
    [anon_sym_spawn] = ACTIONS(855),
    [anon_sym_json_DOTdecode] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(855),
    [anon_sym_LBRACK2] = ACTIONS(835),
    [anon_sym_TILDE] = ACTIONS(855),
    [anon_sym_CARET] = ACTIONS(855),
    [anon_sym_AMP] = ACTIONS(837),
    [anon_sym_LT_DASH] = ACTIONS(855),
    [anon_sym_LT_LT] = ACTIONS(855),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_GT_GT_GT] = ACTIONS(855),
    [anon_sym_AMP_CARET] = ACTIONS(855),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_PIPE_PIPE] = ACTIONS(855),
    [anon_sym_or] = ACTIONS(855),
    [sym_none] = ACTIONS(855),
    [sym_true] = ACTIONS(855),
    [sym_false] = ACTIONS(855),
    [sym_nil] = ACTIONS(855),
    [anon_sym_QMARK_DOT] = ACTIONS(855),
    [anon_sym_POUND_LBRACK] = ACTIONS(855),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_DOLLARif] = ACTIONS(855),
    [anon_sym_is] = ACTIONS(855),
    [anon_sym_BANGis] = ACTIONS(855),
    [anon_sym_in] = ACTIONS(855),
    [anon_sym_BANGin] = ACTIONS(855),
    [anon_sym_match] = ACTIONS(855),
    [anon_sym_select] = ACTIONS(855),
    [anon_sym_STAR_EQ] = ACTIONS(855),
    [anon_sym_SLASH_EQ] = ACTIONS(855),
    [anon_sym_PERCENT_EQ] = ACTIONS(855),
    [anon_sym_LT_LT_EQ] = ACTIONS(855),
    [anon_sym_GT_GT_EQ] = ACTIONS(855),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(855),
    [anon_sym_AMP_EQ] = ACTIONS(855),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(855),
    [anon_sym_PLUS_EQ] = ACTIONS(855),
    [anon_sym_DASH_EQ] = ACTIONS(855),
    [anon_sym_PIPE_EQ] = ACTIONS(855),
    [anon_sym_CARET_EQ] = ACTIONS(855),
    [anon_sym_COLON_EQ] = ACTIONS(855),
    [anon_sym_lock] = ACTIONS(855),
    [anon_sym_rlock] = ACTIONS(855),
    [anon_sym_unsafe] = ACTIONS(855),
    [anon_sym_sql] = ACTIONS(855),
    [sym_int_literal] = ACTIONS(855),
    [sym_float_literal] = ACTIONS(855),
    [sym_rune_literal] = ACTIONS(855),
    [anon_sym_SQUOTE] = ACTIONS(855),
    [anon_sym_DQUOTE] = ACTIONS(855),
    [anon_sym_c_SQUOTE] = ACTIONS(855),
    [anon_sym_c_DQUOTE] = ACTIONS(855),
    [anon_sym_r_SQUOTE] = ACTIONS(855),
    [anon_sym_r_DQUOTE] = ACTIONS(855),
    [sym_pseudo_compile_time_identifier] = ACTIONS(855),
    [anon_sym_shared] = ACTIONS(839),
    [anon_sym_map_LBRACK] = ACTIONS(841),
    [anon_sym_chan] = ACTIONS(843),
    [anon_sym_thread] = ACTIONS(845),
    [anon_sym_atomic] = ACTIONS(847),
    [anon_sym_assert] = ACTIONS(855),
    [anon_sym_defer] = ACTIONS(855),
    [anon_sym_goto] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(855),
    [anon_sym_continue] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(855),
    [anon_sym_DOLLARfor] = ACTIONS(855),
    [anon_sym_for] = ACTIONS(855),
    [anon_sym_POUND] = ACTIONS(855),
    [anon_sym_asm] = ACTIONS(855),
    [anon_sym_AT_LBRACK] = ACTIONS(855),
  },
  [93] = {
    [sym_line_comment] = STATE(93),
    [sym_block_comment] = STATE(93),
    [sym_reference_expression] = STATE(4523),
    [sym_type_reference_expression] = STATE(291),
    [sym_plain_type] = STATE(528),
    [sym__plain_type_without_special] = STATE(429),
    [sym_anon_struct_type] = STATE(442),
    [sym_multi_return_type] = STATE(429),
    [sym_result_type] = STATE(429),
    [sym_option_type] = STATE(429),
    [sym_qualified_type] = STATE(291),
    [sym_fixed_array_type] = STATE(442),
    [sym_array_type] = STATE(442),
    [sym_pointer_type] = STATE(442),
    [sym_wrong_pointer_type] = STATE(442),
    [sym_map_type] = STATE(442),
    [sym_channel_type] = STATE(442),
    [sym_shared_type] = STATE(442),
    [sym_thread_type] = STATE(442),
    [sym_atomic_type] = STATE(442),
    [sym_generic_type] = STATE(442),
    [sym_function_type] = STATE(442),
    [ts_builtin_sym_end] = ACTIONS(857),
    [sym_identifier] = ACTIONS(819),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_CR] = ACTIONS(859),
    [anon_sym_CR_LF] = ACTIONS(859),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(859),
    [anon_sym_as] = ACTIONS(859),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_const] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_EQ] = ACTIONS(859),
    [anon_sym___global] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(859),
    [anon_sym_fn] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(827),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_union] = ACTIONS(859),
    [anon_sym_pub] = ACTIONS(859),
    [anon_sym_mut] = ACTIONS(859),
    [anon_sym_enum] = ACTIONS(859),
    [anon_sym_interface] = ACTIONS(859),
    [anon_sym_PLUS_PLUS] = ACTIONS(859),
    [anon_sym_DASH_DASH] = ACTIONS(859),
    [anon_sym_QMARK] = ACTIONS(831),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_go] = ACTIONS(859),
    [anon_sym_spawn] = ACTIONS(859),
    [anon_sym_json_DOTdecode] = ACTIONS(859),
    [anon_sym_PIPE] = ACTIONS(859),
    [anon_sym_LBRACK2] = ACTIONS(835),
    [anon_sym_TILDE] = ACTIONS(859),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(837),
    [anon_sym_LT_DASH] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_GT_GT_GT] = ACTIONS(859),
    [anon_sym_AMP_CARET] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_or] = ACTIONS(859),
    [sym_none] = ACTIONS(859),
    [sym_true] = ACTIONS(859),
    [sym_false] = ACTIONS(859),
    [sym_nil] = ACTIONS(859),
    [anon_sym_QMARK_DOT] = ACTIONS(859),
    [anon_sym_POUND_LBRACK] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_DOLLARif] = ACTIONS(859),
    [anon_sym_is] = ACTIONS(859),
    [anon_sym_BANGis] = ACTIONS(859),
    [anon_sym_in] = ACTIONS(859),
    [anon_sym_BANGin] = ACTIONS(859),
    [anon_sym_match] = ACTIONS(859),
    [anon_sym_select] = ACTIONS(859),
    [anon_sym_STAR_EQ] = ACTIONS(859),
    [anon_sym_SLASH_EQ] = ACTIONS(859),
    [anon_sym_PERCENT_EQ] = ACTIONS(859),
    [anon_sym_LT_LT_EQ] = ACTIONS(859),
    [anon_sym_GT_GT_EQ] = ACTIONS(859),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(859),
    [anon_sym_AMP_EQ] = ACTIONS(859),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(859),
    [anon_sym_PLUS_EQ] = ACTIONS(859),
    [anon_sym_DASH_EQ] = ACTIONS(859),
    [anon_sym_PIPE_EQ] = ACTIONS(859),
    [anon_sym_CARET_EQ] = ACTIONS(859),
    [anon_sym_COLON_EQ] = ACTIONS(859),
    [anon_sym_lock] = ACTIONS(859),
    [anon_sym_rlock] = ACTIONS(859),
    [anon_sym_unsafe] = ACTIONS(859),
    [anon_sym_sql] = ACTIONS(859),
    [sym_int_literal] = ACTIONS(859),
    [sym_float_literal] = ACTIONS(859),
    [sym_rune_literal] = ACTIONS(859),
    [anon_sym_SQUOTE] = ACTIONS(859),
    [anon_sym_DQUOTE] = ACTIONS(859),
    [anon_sym_c_SQUOTE] = ACTIONS(859),
    [anon_sym_c_DQUOTE] = ACTIONS(859),
    [anon_sym_r_SQUOTE] = ACTIONS(859),
    [anon_sym_r_DQUOTE] = ACTIONS(859),
    [sym_pseudo_compile_time_identifier] = ACTIONS(859),
    [anon_sym_shared] = ACTIONS(839),
    [anon_sym_map_LBRACK] = ACTIONS(841),
    [anon_sym_chan] = ACTIONS(843),
    [anon_sym_thread] = ACTIONS(845),
    [anon_sym_atomic] = ACTIONS(847),
    [anon_sym_assert] = ACTIONS(859),
    [anon_sym_defer] = ACTIONS(859),
    [anon_sym_goto] = ACTIONS(859),
    [anon_sym_break] = ACTIONS(859),
    [anon_sym_continue] = ACTIONS(859),
    [anon_sym_return] = ACTIONS(859),
    [anon_sym_DOLLARfor] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(859),
    [anon_sym_POUND] = ACTIONS(859),
    [anon_sym_asm] = ACTIONS(859),
    [anon_sym_AT_LBRACK] = ACTIONS(859),
  },
  [94] = {
    [sym_line_comment] = STATE(94),
    [sym_block_comment] = STATE(94),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2458),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [ts_builtin_sym_end] = ACTIONS(861),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_LF] = ACTIONS(865),
    [anon_sym_CR] = ACTIONS(865),
    [anon_sym_CR_LF] = ACTIONS(865),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_COMMA] = ACTIONS(865),
    [anon_sym_const] = ACTIONS(865),
    [anon_sym_LPAREN] = ACTIONS(867),
    [anon_sym_EQ] = ACTIONS(865),
    [anon_sym___global] = ACTIONS(865),
    [anon_sym_type] = ACTIONS(865),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_STAR] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_PERCENT] = ACTIONS(865),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(865),
    [anon_sym_BANG_EQ] = ACTIONS(865),
    [anon_sym_LT_EQ] = ACTIONS(865),
    [anon_sym_GT_EQ] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_union] = ACTIONS(865),
    [anon_sym_pub] = ACTIONS(865),
    [anon_sym_mut] = ACTIONS(865),
    [anon_sym_enum] = ACTIONS(865),
    [anon_sym_interface] = ACTIONS(865),
    [anon_sym_PLUS_PLUS] = ACTIONS(865),
    [anon_sym_DASH_DASH] = ACTIONS(865),
    [anon_sym_QMARK] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_go] = ACTIONS(865),
    [anon_sym_spawn] = ACTIONS(865),
    [anon_sym_json_DOTdecode] = ACTIONS(865),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_LBRACK2] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(865),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT_DASH] = ACTIONS(865),
    [anon_sym_LT_LT] = ACTIONS(865),
    [anon_sym_GT_GT] = ACTIONS(865),
    [anon_sym_GT_GT_GT] = ACTIONS(865),
    [anon_sym_AMP_CARET] = ACTIONS(865),
    [anon_sym_AMP_AMP] = ACTIONS(865),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_or] = ACTIONS(865),
    [sym_none] = ACTIONS(865),
    [sym_true] = ACTIONS(865),
    [sym_false] = ACTIONS(865),
    [sym_nil] = ACTIONS(865),
    [anon_sym_QMARK_DOT] = ACTIONS(865),
    [anon_sym_POUND_LBRACK] = ACTIONS(865),
    [anon_sym_if] = ACTIONS(865),
    [anon_sym_DOLLARif] = ACTIONS(865),
    [anon_sym_is] = ACTIONS(865),
    [anon_sym_BANGis] = ACTIONS(865),
    [anon_sym_in] = ACTIONS(865),
    [anon_sym_BANGin] = ACTIONS(865),
    [anon_sym_match] = ACTIONS(865),
    [anon_sym_select] = ACTIONS(865),
    [anon_sym_STAR_EQ] = ACTIONS(865),
    [anon_sym_SLASH_EQ] = ACTIONS(865),
    [anon_sym_PERCENT_EQ] = ACTIONS(865),
    [anon_sym_LT_LT_EQ] = ACTIONS(865),
    [anon_sym_GT_GT_EQ] = ACTIONS(865),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(865),
    [anon_sym_AMP_EQ] = ACTIONS(865),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(865),
    [anon_sym_PLUS_EQ] = ACTIONS(865),
    [anon_sym_DASH_EQ] = ACTIONS(865),
    [anon_sym_PIPE_EQ] = ACTIONS(865),
    [anon_sym_CARET_EQ] = ACTIONS(865),
    [anon_sym_COLON_EQ] = ACTIONS(865),
    [anon_sym_lock] = ACTIONS(865),
    [anon_sym_rlock] = ACTIONS(865),
    [anon_sym_unsafe] = ACTIONS(865),
    [anon_sym_sql] = ACTIONS(865),
    [sym_int_literal] = ACTIONS(865),
    [sym_float_literal] = ACTIONS(865),
    [sym_rune_literal] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(865),
    [anon_sym_DQUOTE] = ACTIONS(865),
    [anon_sym_c_SQUOTE] = ACTIONS(865),
    [anon_sym_c_DQUOTE] = ACTIONS(865),
    [anon_sym_r_SQUOTE] = ACTIONS(865),
    [anon_sym_r_DQUOTE] = ACTIONS(865),
    [sym_pseudo_compile_time_identifier] = ACTIONS(865),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(351),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(865),
    [anon_sym_defer] = ACTIONS(865),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_break] = ACTIONS(865),
    [anon_sym_continue] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(865),
    [anon_sym_DOLLARfor] = ACTIONS(865),
    [anon_sym_for] = ACTIONS(865),
    [anon_sym_POUND] = ACTIONS(865),
    [anon_sym_asm] = ACTIONS(865),
    [anon_sym_AT_LBRACK] = ACTIONS(865),
  },
  [95] = {
    [sym_line_comment] = STATE(95),
    [sym_block_comment] = STATE(95),
    [sym__expression] = STATE(1264),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(619),
    [sym_mutable_expression] = STATE(1926),
    [sym_expression_list] = STATE(1939),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(757),
    [anon_sym_CR] = ACTIONS(757),
    [anon_sym_CR_LF] = ACTIONS(757),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(757),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(887),
    [anon_sym_RBRACE] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(889),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(895),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(899),
    [anon_sym_go] = ACTIONS(901),
    [anon_sym_spawn] = ACTIONS(903),
    [anon_sym_json_DOTdecode] = ACTIONS(905),
    [anon_sym_LBRACK2] = ACTIONS(907),
    [anon_sym_TILDE] = ACTIONS(893),
    [anon_sym_CARET] = ACTIONS(893),
    [anon_sym_AMP] = ACTIONS(909),
    [anon_sym_LT_DASH] = ACTIONS(911),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(921),
    [anon_sym_lock] = ACTIONS(923),
    [anon_sym_rlock] = ACTIONS(923),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(913),
    [sym_rune_literal] = ACTIONS(913),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(931),
    [anon_sym_c_SQUOTE] = ACTIONS(933),
    [anon_sym_c_DQUOTE] = ACTIONS(935),
    [anon_sym_r_SQUOTE] = ACTIONS(937),
    [anon_sym_r_DQUOTE] = ACTIONS(939),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(351),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(757),
    [anon_sym_defer] = ACTIONS(757),
    [anon_sym_goto] = ACTIONS(757),
    [anon_sym_break] = ACTIONS(757),
    [anon_sym_continue] = ACTIONS(757),
    [anon_sym_return] = ACTIONS(757),
    [anon_sym_DOLLARfor] = ACTIONS(757),
    [anon_sym_for] = ACTIONS(757),
    [anon_sym_POUND] = ACTIONS(757),
    [anon_sym_asm] = ACTIONS(757),
  },
  [96] = {
    [sym_line_comment] = STATE(96),
    [sym_block_comment] = STATE(96),
    [sym_struct_field_scope] = STATE(3506),
    [sym_struct_field_declaration] = STATE(3506),
    [sym__struct_field_definition] = STATE(3507),
    [sym_embedded_definition] = STATE(3508),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4649),
    [sym_short_element_list] = STATE(4647),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1537),
    [sym_type_reference_expression] = STATE(3457),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3457),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(3489),
    [sym_function_type] = STATE(2417),
    [aux_sym__struct_body_repeat1] = STATE(3420),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(943),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym___global] = ACTIONS(953),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_pub] = ACTIONS(965),
    [anon_sym_mut] = ACTIONS(967),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [97] = {
    [sym_line_comment] = STATE(97),
    [sym_block_comment] = STATE(97),
    [sym_struct_field_scope] = STATE(3506),
    [sym_struct_field_declaration] = STATE(3506),
    [sym__struct_field_definition] = STATE(3507),
    [sym_embedded_definition] = STATE(3508),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4641),
    [sym_short_element_list] = STATE(4640),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1537),
    [sym_type_reference_expression] = STATE(3457),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3457),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(3489),
    [sym_function_type] = STATE(2417),
    [aux_sym__struct_body_repeat1] = STATE(3420),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(943),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym___global] = ACTIONS(953),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_pub] = ACTIONS(965),
    [anon_sym_mut] = ACTIONS(967),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [98] = {
    [sym_line_comment] = STATE(98),
    [sym_block_comment] = STATE(98),
    [sym_struct_field_scope] = STATE(3506),
    [sym_struct_field_declaration] = STATE(3506),
    [sym__struct_field_definition] = STATE(3507),
    [sym_embedded_definition] = STATE(3508),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4525),
    [sym_short_element_list] = STATE(4526),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1537),
    [sym_type_reference_expression] = STATE(3457),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3457),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(3489),
    [sym_function_type] = STATE(2417),
    [aux_sym__struct_body_repeat1] = STATE(3420),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(943),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym___global] = ACTIONS(953),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_pub] = ACTIONS(965),
    [anon_sym_mut] = ACTIONS(967),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [99] = {
    [sym_line_comment] = STATE(99),
    [sym_block_comment] = STATE(99),
    [sym_reference_expression] = STATE(4500),
    [sym_type_reference_expression] = STATE(1003),
    [sym_plain_type] = STATE(1084),
    [sym__plain_type_without_special] = STATE(1005),
    [sym_anon_struct_type] = STATE(1059),
    [sym_multi_return_type] = STATE(1005),
    [sym_result_type] = STATE(1005),
    [sym_option_type] = STATE(1005),
    [sym_qualified_type] = STATE(1003),
    [sym_fixed_array_type] = STATE(1059),
    [sym_array_type] = STATE(1059),
    [sym_pointer_type] = STATE(1059),
    [sym_wrong_pointer_type] = STATE(1059),
    [sym_map_type] = STATE(1059),
    [sym_channel_type] = STATE(1059),
    [sym_shared_type] = STATE(1059),
    [sym_thread_type] = STATE(1059),
    [sym_atomic_type] = STATE(1059),
    [sym_generic_type] = STATE(1059),
    [sym_function_type] = STATE(1059),
    [sym_identifier] = ACTIONS(1015),
    [anon_sym_LF] = ACTIONS(855),
    [anon_sym_CR] = ACTIONS(855),
    [anon_sym_CR_LF] = ACTIONS(855),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(855),
    [anon_sym_DOT] = ACTIONS(855),
    [anon_sym_as] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(855),
    [anon_sym_RBRACE] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(1017),
    [anon_sym_EQ] = ACTIONS(855),
    [anon_sym_fn] = ACTIONS(1019),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(1021),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_PERCENT] = ACTIONS(855),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_GT] = ACTIONS(855),
    [anon_sym_EQ_EQ] = ACTIONS(855),
    [anon_sym_BANG_EQ] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(855),
    [anon_sym_GT_EQ] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_struct] = ACTIONS(1023),
    [anon_sym_mut] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(855),
    [anon_sym_PLUS_PLUS] = ACTIONS(855),
    [anon_sym_DASH_DASH] = ACTIONS(855),
    [anon_sym_QMARK] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_go] = ACTIONS(855),
    [anon_sym_spawn] = ACTIONS(855),
    [anon_sym_json_DOTdecode] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(855),
    [anon_sym_LBRACK2] = ACTIONS(1029),
    [anon_sym_TILDE] = ACTIONS(855),
    [anon_sym_CARET] = ACTIONS(855),
    [anon_sym_AMP] = ACTIONS(1031),
    [anon_sym_LT_DASH] = ACTIONS(855),
    [anon_sym_LT_LT] = ACTIONS(855),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_GT_GT_GT] = ACTIONS(855),
    [anon_sym_AMP_CARET] = ACTIONS(855),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_PIPE_PIPE] = ACTIONS(855),
    [anon_sym_or] = ACTIONS(855),
    [sym_none] = ACTIONS(855),
    [sym_true] = ACTIONS(855),
    [sym_false] = ACTIONS(855),
    [sym_nil] = ACTIONS(855),
    [anon_sym_QMARK_DOT] = ACTIONS(855),
    [anon_sym_POUND_LBRACK] = ACTIONS(855),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_DOLLARif] = ACTIONS(855),
    [anon_sym_is] = ACTIONS(855),
    [anon_sym_BANGis] = ACTIONS(855),
    [anon_sym_in] = ACTIONS(855),
    [anon_sym_BANGin] = ACTIONS(855),
    [anon_sym_match] = ACTIONS(855),
    [anon_sym_select] = ACTIONS(855),
    [anon_sym_STAR_EQ] = ACTIONS(855),
    [anon_sym_SLASH_EQ] = ACTIONS(855),
    [anon_sym_PERCENT_EQ] = ACTIONS(855),
    [anon_sym_LT_LT_EQ] = ACTIONS(855),
    [anon_sym_GT_GT_EQ] = ACTIONS(855),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(855),
    [anon_sym_AMP_EQ] = ACTIONS(855),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(855),
    [anon_sym_PLUS_EQ] = ACTIONS(855),
    [anon_sym_DASH_EQ] = ACTIONS(855),
    [anon_sym_PIPE_EQ] = ACTIONS(855),
    [anon_sym_CARET_EQ] = ACTIONS(855),
    [anon_sym_COLON_EQ] = ACTIONS(855),
    [anon_sym_lock] = ACTIONS(855),
    [anon_sym_rlock] = ACTIONS(855),
    [anon_sym_unsafe] = ACTIONS(855),
    [anon_sym_sql] = ACTIONS(855),
    [sym_int_literal] = ACTIONS(855),
    [sym_float_literal] = ACTIONS(855),
    [sym_rune_literal] = ACTIONS(855),
    [anon_sym_SQUOTE] = ACTIONS(855),
    [anon_sym_DQUOTE] = ACTIONS(855),
    [anon_sym_c_SQUOTE] = ACTIONS(855),
    [anon_sym_c_DQUOTE] = ACTIONS(855),
    [anon_sym_r_SQUOTE] = ACTIONS(855),
    [anon_sym_r_DQUOTE] = ACTIONS(855),
    [sym_pseudo_compile_time_identifier] = ACTIONS(855),
    [anon_sym_shared] = ACTIONS(1033),
    [anon_sym_map_LBRACK] = ACTIONS(1035),
    [anon_sym_chan] = ACTIONS(1037),
    [anon_sym_thread] = ACTIONS(1039),
    [anon_sym_atomic] = ACTIONS(1041),
    [anon_sym_assert] = ACTIONS(855),
    [anon_sym_defer] = ACTIONS(855),
    [anon_sym_goto] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(855),
    [anon_sym_continue] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(855),
    [anon_sym_DOLLARfor] = ACTIONS(855),
    [anon_sym_for] = ACTIONS(855),
    [anon_sym_POUND] = ACTIONS(855),
    [anon_sym_asm] = ACTIONS(855),
  },
  [100] = {
    [sym_line_comment] = STATE(100),
    [sym_block_comment] = STATE(100),
    [sym_struct_field_scope] = STATE(3506),
    [sym_struct_field_declaration] = STATE(3506),
    [sym__struct_field_definition] = STATE(3507),
    [sym_embedded_definition] = STATE(3508),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4455),
    [sym_short_element_list] = STATE(4503),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1537),
    [sym_type_reference_expression] = STATE(3457),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3457),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(3489),
    [sym_function_type] = STATE(2417),
    [aux_sym__struct_body_repeat1] = STATE(3420),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(943),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym___global] = ACTIONS(953),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_pub] = ACTIONS(965),
    [anon_sym_mut] = ACTIONS(967),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [101] = {
    [sym_line_comment] = STATE(101),
    [sym_block_comment] = STATE(101),
    [sym_reference_expression] = STATE(4500),
    [sym_type_reference_expression] = STATE(1003),
    [sym_plain_type] = STATE(1088),
    [sym__plain_type_without_special] = STATE(1005),
    [sym_anon_struct_type] = STATE(1059),
    [sym_multi_return_type] = STATE(1005),
    [sym_result_type] = STATE(1005),
    [sym_option_type] = STATE(1005),
    [sym_qualified_type] = STATE(1003),
    [sym_fixed_array_type] = STATE(1059),
    [sym_array_type] = STATE(1059),
    [sym_pointer_type] = STATE(1059),
    [sym_wrong_pointer_type] = STATE(1059),
    [sym_map_type] = STATE(1059),
    [sym_channel_type] = STATE(1059),
    [sym_shared_type] = STATE(1059),
    [sym_thread_type] = STATE(1059),
    [sym_atomic_type] = STATE(1059),
    [sym_generic_type] = STATE(1059),
    [sym_function_type] = STATE(1059),
    [sym_identifier] = ACTIONS(1015),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_CR] = ACTIONS(859),
    [anon_sym_CR_LF] = ACTIONS(859),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(859),
    [anon_sym_as] = ACTIONS(859),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(1017),
    [anon_sym_EQ] = ACTIONS(859),
    [anon_sym_fn] = ACTIONS(1019),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(1021),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_struct] = ACTIONS(1023),
    [anon_sym_mut] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(859),
    [anon_sym_PLUS_PLUS] = ACTIONS(859),
    [anon_sym_DASH_DASH] = ACTIONS(859),
    [anon_sym_QMARK] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_go] = ACTIONS(859),
    [anon_sym_spawn] = ACTIONS(859),
    [anon_sym_json_DOTdecode] = ACTIONS(859),
    [anon_sym_PIPE] = ACTIONS(859),
    [anon_sym_LBRACK2] = ACTIONS(1029),
    [anon_sym_TILDE] = ACTIONS(859),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(1031),
    [anon_sym_LT_DASH] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_GT_GT_GT] = ACTIONS(859),
    [anon_sym_AMP_CARET] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_or] = ACTIONS(859),
    [sym_none] = ACTIONS(859),
    [sym_true] = ACTIONS(859),
    [sym_false] = ACTIONS(859),
    [sym_nil] = ACTIONS(859),
    [anon_sym_QMARK_DOT] = ACTIONS(859),
    [anon_sym_POUND_LBRACK] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_DOLLARif] = ACTIONS(859),
    [anon_sym_is] = ACTIONS(859),
    [anon_sym_BANGis] = ACTIONS(859),
    [anon_sym_in] = ACTIONS(859),
    [anon_sym_BANGin] = ACTIONS(859),
    [anon_sym_match] = ACTIONS(859),
    [anon_sym_select] = ACTIONS(859),
    [anon_sym_STAR_EQ] = ACTIONS(859),
    [anon_sym_SLASH_EQ] = ACTIONS(859),
    [anon_sym_PERCENT_EQ] = ACTIONS(859),
    [anon_sym_LT_LT_EQ] = ACTIONS(859),
    [anon_sym_GT_GT_EQ] = ACTIONS(859),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(859),
    [anon_sym_AMP_EQ] = ACTIONS(859),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(859),
    [anon_sym_PLUS_EQ] = ACTIONS(859),
    [anon_sym_DASH_EQ] = ACTIONS(859),
    [anon_sym_PIPE_EQ] = ACTIONS(859),
    [anon_sym_CARET_EQ] = ACTIONS(859),
    [anon_sym_COLON_EQ] = ACTIONS(859),
    [anon_sym_lock] = ACTIONS(859),
    [anon_sym_rlock] = ACTIONS(859),
    [anon_sym_unsafe] = ACTIONS(859),
    [anon_sym_sql] = ACTIONS(859),
    [sym_int_literal] = ACTIONS(859),
    [sym_float_literal] = ACTIONS(859),
    [sym_rune_literal] = ACTIONS(859),
    [anon_sym_SQUOTE] = ACTIONS(859),
    [anon_sym_DQUOTE] = ACTIONS(859),
    [anon_sym_c_SQUOTE] = ACTIONS(859),
    [anon_sym_c_DQUOTE] = ACTIONS(859),
    [anon_sym_r_SQUOTE] = ACTIONS(859),
    [anon_sym_r_DQUOTE] = ACTIONS(859),
    [sym_pseudo_compile_time_identifier] = ACTIONS(859),
    [anon_sym_shared] = ACTIONS(1033),
    [anon_sym_map_LBRACK] = ACTIONS(1035),
    [anon_sym_chan] = ACTIONS(1037),
    [anon_sym_thread] = ACTIONS(1039),
    [anon_sym_atomic] = ACTIONS(1041),
    [anon_sym_assert] = ACTIONS(859),
    [anon_sym_defer] = ACTIONS(859),
    [anon_sym_goto] = ACTIONS(859),
    [anon_sym_break] = ACTIONS(859),
    [anon_sym_continue] = ACTIONS(859),
    [anon_sym_return] = ACTIONS(859),
    [anon_sym_DOLLARfor] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(859),
    [anon_sym_POUND] = ACTIONS(859),
    [anon_sym_asm] = ACTIONS(859),
  },
  [102] = {
    [sym_line_comment] = STATE(102),
    [sym_block_comment] = STATE(102),
    [sym_struct_field_scope] = STATE(3506),
    [sym_struct_field_declaration] = STATE(3506),
    [sym__struct_field_definition] = STATE(3507),
    [sym_embedded_definition] = STATE(3508),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4484),
    [sym_short_element_list] = STATE(4483),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1537),
    [sym_type_reference_expression] = STATE(3457),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3457),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(3489),
    [sym_function_type] = STATE(2417),
    [aux_sym__struct_body_repeat1] = STATE(3420),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(943),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym___global] = ACTIONS(953),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_pub] = ACTIONS(965),
    [anon_sym_mut] = ACTIONS(967),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [103] = {
    [sym_line_comment] = STATE(103),
    [sym_block_comment] = STATE(103),
    [sym_struct_field_scope] = STATE(3506),
    [sym_struct_field_declaration] = STATE(3506),
    [sym__struct_field_definition] = STATE(3507),
    [sym_embedded_definition] = STATE(3508),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4565),
    [sym_short_element_list] = STATE(4416),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1537),
    [sym_type_reference_expression] = STATE(3457),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3457),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(3489),
    [sym_function_type] = STATE(2417),
    [aux_sym__struct_body_repeat1] = STATE(3420),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(943),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym___global] = ACTIONS(953),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_pub] = ACTIONS(965),
    [anon_sym_mut] = ACTIONS(967),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [104] = {
    [sym_line_comment] = STATE(104),
    [sym_block_comment] = STATE(104),
    [sym_reference_expression] = STATE(4500),
    [sym_type_reference_expression] = STATE(1003),
    [sym_plain_type] = STATE(1110),
    [sym__plain_type_without_special] = STATE(1005),
    [sym_anon_struct_type] = STATE(1059),
    [sym_multi_return_type] = STATE(1005),
    [sym_result_type] = STATE(1005),
    [sym_option_type] = STATE(1005),
    [sym_qualified_type] = STATE(1003),
    [sym_fixed_array_type] = STATE(1059),
    [sym_array_type] = STATE(1059),
    [sym_pointer_type] = STATE(1059),
    [sym_wrong_pointer_type] = STATE(1059),
    [sym_map_type] = STATE(1059),
    [sym_channel_type] = STATE(1059),
    [sym_shared_type] = STATE(1059),
    [sym_thread_type] = STATE(1059),
    [sym_atomic_type] = STATE(1059),
    [sym_generic_type] = STATE(1059),
    [sym_function_type] = STATE(1059),
    [sym_identifier] = ACTIONS(1015),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_CR] = ACTIONS(821),
    [anon_sym_CR_LF] = ACTIONS(821),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(821),
    [anon_sym_DOT] = ACTIONS(821),
    [anon_sym_as] = ACTIONS(821),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_COMMA] = ACTIONS(821),
    [anon_sym_RBRACE] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(1017),
    [anon_sym_EQ] = ACTIONS(821),
    [anon_sym_fn] = ACTIONS(1019),
    [anon_sym_PLUS] = ACTIONS(821),
    [anon_sym_DASH] = ACTIONS(821),
    [anon_sym_STAR] = ACTIONS(1021),
    [anon_sym_SLASH] = ACTIONS(821),
    [anon_sym_PERCENT] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(821),
    [anon_sym_GT] = ACTIONS(821),
    [anon_sym_EQ_EQ] = ACTIONS(821),
    [anon_sym_BANG_EQ] = ACTIONS(821),
    [anon_sym_LT_EQ] = ACTIONS(821),
    [anon_sym_GT_EQ] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(817),
    [anon_sym_struct] = ACTIONS(1023),
    [anon_sym_mut] = ACTIONS(821),
    [anon_sym_COLON] = ACTIONS(821),
    [anon_sym_PLUS_PLUS] = ACTIONS(821),
    [anon_sym_DASH_DASH] = ACTIONS(821),
    [anon_sym_QMARK] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_go] = ACTIONS(821),
    [anon_sym_spawn] = ACTIONS(821),
    [anon_sym_json_DOTdecode] = ACTIONS(821),
    [anon_sym_PIPE] = ACTIONS(821),
    [anon_sym_LBRACK2] = ACTIONS(1029),
    [anon_sym_TILDE] = ACTIONS(821),
    [anon_sym_CARET] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(1031),
    [anon_sym_LT_DASH] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(821),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_GT_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_CARET] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_or] = ACTIONS(821),
    [sym_none] = ACTIONS(821),
    [sym_true] = ACTIONS(821),
    [sym_false] = ACTIONS(821),
    [sym_nil] = ACTIONS(821),
    [anon_sym_QMARK_DOT] = ACTIONS(821),
    [anon_sym_POUND_LBRACK] = ACTIONS(821),
    [anon_sym_if] = ACTIONS(821),
    [anon_sym_DOLLARif] = ACTIONS(821),
    [anon_sym_is] = ACTIONS(821),
    [anon_sym_BANGis] = ACTIONS(821),
    [anon_sym_in] = ACTIONS(821),
    [anon_sym_BANGin] = ACTIONS(821),
    [anon_sym_match] = ACTIONS(821),
    [anon_sym_select] = ACTIONS(821),
    [anon_sym_STAR_EQ] = ACTIONS(821),
    [anon_sym_SLASH_EQ] = ACTIONS(821),
    [anon_sym_PERCENT_EQ] = ACTIONS(821),
    [anon_sym_LT_LT_EQ] = ACTIONS(821),
    [anon_sym_GT_GT_EQ] = ACTIONS(821),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(821),
    [anon_sym_AMP_EQ] = ACTIONS(821),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(821),
    [anon_sym_PLUS_EQ] = ACTIONS(821),
    [anon_sym_DASH_EQ] = ACTIONS(821),
    [anon_sym_PIPE_EQ] = ACTIONS(821),
    [anon_sym_CARET_EQ] = ACTIONS(821),
    [anon_sym_COLON_EQ] = ACTIONS(821),
    [anon_sym_lock] = ACTIONS(821),
    [anon_sym_rlock] = ACTIONS(821),
    [anon_sym_unsafe] = ACTIONS(821),
    [anon_sym_sql] = ACTIONS(821),
    [sym_int_literal] = ACTIONS(821),
    [sym_float_literal] = ACTIONS(821),
    [sym_rune_literal] = ACTIONS(821),
    [anon_sym_SQUOTE] = ACTIONS(821),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [anon_sym_c_SQUOTE] = ACTIONS(821),
    [anon_sym_c_DQUOTE] = ACTIONS(821),
    [anon_sym_r_SQUOTE] = ACTIONS(821),
    [anon_sym_r_DQUOTE] = ACTIONS(821),
    [sym_pseudo_compile_time_identifier] = ACTIONS(821),
    [anon_sym_shared] = ACTIONS(1033),
    [anon_sym_map_LBRACK] = ACTIONS(1035),
    [anon_sym_chan] = ACTIONS(1037),
    [anon_sym_thread] = ACTIONS(1039),
    [anon_sym_atomic] = ACTIONS(1041),
    [anon_sym_assert] = ACTIONS(821),
    [anon_sym_defer] = ACTIONS(821),
    [anon_sym_goto] = ACTIONS(821),
    [anon_sym_break] = ACTIONS(821),
    [anon_sym_continue] = ACTIONS(821),
    [anon_sym_return] = ACTIONS(821),
    [anon_sym_DOLLARfor] = ACTIONS(821),
    [anon_sym_for] = ACTIONS(821),
    [anon_sym_POUND] = ACTIONS(821),
    [anon_sym_asm] = ACTIONS(821),
  },
  [105] = {
    [sym_line_comment] = STATE(105),
    [sym_block_comment] = STATE(105),
    [sym_struct_field_scope] = STATE(3506),
    [sym_struct_field_declaration] = STATE(3506),
    [sym__struct_field_definition] = STATE(3507),
    [sym_embedded_definition] = STATE(3508),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4639),
    [sym_short_element_list] = STATE(4702),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1537),
    [sym_type_reference_expression] = STATE(3457),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3457),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(3489),
    [sym_function_type] = STATE(2417),
    [aux_sym__struct_body_repeat1] = STATE(3420),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(943),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym___global] = ACTIONS(953),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_pub] = ACTIONS(965),
    [anon_sym_mut] = ACTIONS(967),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [106] = {
    [sym_line_comment] = STATE(106),
    [sym_block_comment] = STATE(106),
    [sym_struct_field_scope] = STATE(3506),
    [sym_struct_field_declaration] = STATE(3506),
    [sym__struct_field_definition] = STATE(3507),
    [sym_embedded_definition] = STATE(3508),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4446),
    [sym_short_element_list] = STATE(4450),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1537),
    [sym_type_reference_expression] = STATE(3457),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3457),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(3489),
    [sym_function_type] = STATE(2417),
    [aux_sym__struct_body_repeat1] = STATE(3420),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(943),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym___global] = ACTIONS(953),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_pub] = ACTIONS(965),
    [anon_sym_mut] = ACTIONS(967),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [107] = {
    [sym_line_comment] = STATE(107),
    [sym_block_comment] = STATE(107),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2489),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(851),
    [anon_sym_LF] = ACTIONS(851),
    [anon_sym_CR] = ACTIONS(851),
    [anon_sym_CR_LF] = ACTIONS(851),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(851),
    [anon_sym_DOT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(851),
    [anon_sym_COMMA] = ACTIONS(851),
    [anon_sym_RBRACE] = ACTIONS(851),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_EQ] = ACTIONS(851),
    [anon_sym_fn] = ACTIONS(851),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(851),
    [anon_sym_SLASH] = ACTIONS(851),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_struct] = ACTIONS(851),
    [anon_sym_mut] = ACTIONS(851),
    [anon_sym_COLON] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(851),
    [anon_sym_DASH_DASH] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_go] = ACTIONS(851),
    [anon_sym_spawn] = ACTIONS(851),
    [anon_sym_json_DOTdecode] = ACTIONS(851),
    [anon_sym_PIPE] = ACTIONS(851),
    [anon_sym_LBRACK2] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_CARET] = ACTIONS(851),
    [anon_sym_AMP] = ACTIONS(851),
    [anon_sym_LT_DASH] = ACTIONS(851),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_CARET] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(851),
    [anon_sym_PIPE_PIPE] = ACTIONS(851),
    [anon_sym_or] = ACTIONS(851),
    [sym_none] = ACTIONS(851),
    [sym_true] = ACTIONS(851),
    [sym_false] = ACTIONS(851),
    [sym_nil] = ACTIONS(851),
    [anon_sym_QMARK_DOT] = ACTIONS(851),
    [anon_sym_POUND_LBRACK] = ACTIONS(851),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_DOLLARif] = ACTIONS(851),
    [anon_sym_is] = ACTIONS(851),
    [anon_sym_BANGis] = ACTIONS(851),
    [anon_sym_in] = ACTIONS(851),
    [anon_sym_BANGin] = ACTIONS(851),
    [anon_sym_match] = ACTIONS(851),
    [anon_sym_select] = ACTIONS(851),
    [anon_sym_STAR_EQ] = ACTIONS(851),
    [anon_sym_SLASH_EQ] = ACTIONS(851),
    [anon_sym_PERCENT_EQ] = ACTIONS(851),
    [anon_sym_LT_LT_EQ] = ACTIONS(851),
    [anon_sym_GT_GT_EQ] = ACTIONS(851),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(851),
    [anon_sym_AMP_EQ] = ACTIONS(851),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(851),
    [anon_sym_PLUS_EQ] = ACTIONS(851),
    [anon_sym_DASH_EQ] = ACTIONS(851),
    [anon_sym_PIPE_EQ] = ACTIONS(851),
    [anon_sym_CARET_EQ] = ACTIONS(851),
    [anon_sym_COLON_EQ] = ACTIONS(851),
    [anon_sym_lock] = ACTIONS(851),
    [anon_sym_rlock] = ACTIONS(851),
    [anon_sym_unsafe] = ACTIONS(851),
    [anon_sym_sql] = ACTIONS(851),
    [sym_int_literal] = ACTIONS(851),
    [sym_float_literal] = ACTIONS(851),
    [sym_rune_literal] = ACTIONS(851),
    [anon_sym_SQUOTE] = ACTIONS(851),
    [anon_sym_DQUOTE] = ACTIONS(851),
    [anon_sym_c_SQUOTE] = ACTIONS(851),
    [anon_sym_c_DQUOTE] = ACTIONS(851),
    [anon_sym_r_SQUOTE] = ACTIONS(851),
    [anon_sym_r_DQUOTE] = ACTIONS(851),
    [sym_pseudo_compile_time_identifier] = ACTIONS(851),
    [anon_sym_shared] = ACTIONS(851),
    [anon_sym_map_LBRACK] = ACTIONS(851),
    [anon_sym_chan] = ACTIONS(851),
    [anon_sym_thread] = ACTIONS(851),
    [anon_sym_atomic] = ACTIONS(851),
    [anon_sym_assert] = ACTIONS(851),
    [anon_sym_defer] = ACTIONS(851),
    [anon_sym_goto] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(851),
    [anon_sym_continue] = ACTIONS(851),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_DOLLARfor] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(851),
    [anon_sym_asm] = ACTIONS(851),
  },
  [108] = {
    [sym_line_comment] = STATE(108),
    [sym_block_comment] = STATE(108),
    [sym_struct_field_scope] = STATE(3506),
    [sym_struct_field_declaration] = STATE(3506),
    [sym__struct_field_definition] = STATE(3507),
    [sym_embedded_definition] = STATE(3508),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4431),
    [sym_short_element_list] = STATE(4432),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1537),
    [sym_type_reference_expression] = STATE(3457),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3457),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(3489),
    [sym_function_type] = STATE(2417),
    [aux_sym__struct_body_repeat1] = STATE(3420),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(943),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym___global] = ACTIONS(953),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_pub] = ACTIONS(965),
    [anon_sym_mut] = ACTIONS(967),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [109] = {
    [sym_line_comment] = STATE(109),
    [sym_block_comment] = STATE(109),
    [sym_struct_field_scope] = STATE(3506),
    [sym_struct_field_declaration] = STATE(3506),
    [sym__struct_field_definition] = STATE(3507),
    [sym_embedded_definition] = STATE(3508),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4659),
    [sym_short_element_list] = STATE(4661),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1537),
    [sym_type_reference_expression] = STATE(3457),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3457),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(3489),
    [sym_function_type] = STATE(2417),
    [aux_sym__struct_body_repeat1] = STATE(3420),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(943),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym___global] = ACTIONS(953),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_pub] = ACTIONS(965),
    [anon_sym_mut] = ACTIONS(967),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [110] = {
    [sym_line_comment] = STATE(110),
    [sym_block_comment] = STATE(110),
    [sym_struct_field_scope] = STATE(3506),
    [sym_struct_field_declaration] = STATE(3506),
    [sym__struct_field_definition] = STATE(3507),
    [sym_embedded_definition] = STATE(3508),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4620),
    [sym_short_element_list] = STATE(4625),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1537),
    [sym_type_reference_expression] = STATE(3457),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3457),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(3489),
    [sym_function_type] = STATE(2417),
    [aux_sym__struct_body_repeat1] = STATE(3420),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(943),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym___global] = ACTIONS(953),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_pub] = ACTIONS(965),
    [anon_sym_mut] = ACTIONS(967),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [111] = {
    [sym_line_comment] = STATE(111),
    [sym_block_comment] = STATE(111),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2458),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_LF] = ACTIONS(865),
    [anon_sym_CR] = ACTIONS(865),
    [anon_sym_CR_LF] = ACTIONS(865),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_COMMA] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(865),
    [anon_sym_LPAREN] = ACTIONS(867),
    [anon_sym_EQ] = ACTIONS(865),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_STAR] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_PERCENT] = ACTIONS(865),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(865),
    [anon_sym_BANG_EQ] = ACTIONS(865),
    [anon_sym_LT_EQ] = ACTIONS(865),
    [anon_sym_GT_EQ] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_mut] = ACTIONS(865),
    [anon_sym_COLON] = ACTIONS(865),
    [anon_sym_PLUS_PLUS] = ACTIONS(865),
    [anon_sym_DASH_DASH] = ACTIONS(865),
    [anon_sym_QMARK] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_go] = ACTIONS(865),
    [anon_sym_spawn] = ACTIONS(865),
    [anon_sym_json_DOTdecode] = ACTIONS(865),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_LBRACK2] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(865),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT_DASH] = ACTIONS(865),
    [anon_sym_LT_LT] = ACTIONS(865),
    [anon_sym_GT_GT] = ACTIONS(865),
    [anon_sym_GT_GT_GT] = ACTIONS(865),
    [anon_sym_AMP_CARET] = ACTIONS(865),
    [anon_sym_AMP_AMP] = ACTIONS(865),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_or] = ACTIONS(865),
    [sym_none] = ACTIONS(865),
    [sym_true] = ACTIONS(865),
    [sym_false] = ACTIONS(865),
    [sym_nil] = ACTIONS(865),
    [anon_sym_QMARK_DOT] = ACTIONS(865),
    [anon_sym_POUND_LBRACK] = ACTIONS(865),
    [anon_sym_if] = ACTIONS(865),
    [anon_sym_DOLLARif] = ACTIONS(865),
    [anon_sym_is] = ACTIONS(865),
    [anon_sym_BANGis] = ACTIONS(865),
    [anon_sym_in] = ACTIONS(865),
    [anon_sym_BANGin] = ACTIONS(865),
    [anon_sym_match] = ACTIONS(865),
    [anon_sym_select] = ACTIONS(865),
    [anon_sym_STAR_EQ] = ACTIONS(865),
    [anon_sym_SLASH_EQ] = ACTIONS(865),
    [anon_sym_PERCENT_EQ] = ACTIONS(865),
    [anon_sym_LT_LT_EQ] = ACTIONS(865),
    [anon_sym_GT_GT_EQ] = ACTIONS(865),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(865),
    [anon_sym_AMP_EQ] = ACTIONS(865),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(865),
    [anon_sym_PLUS_EQ] = ACTIONS(865),
    [anon_sym_DASH_EQ] = ACTIONS(865),
    [anon_sym_PIPE_EQ] = ACTIONS(865),
    [anon_sym_CARET_EQ] = ACTIONS(865),
    [anon_sym_COLON_EQ] = ACTIONS(865),
    [anon_sym_lock] = ACTIONS(865),
    [anon_sym_rlock] = ACTIONS(865),
    [anon_sym_unsafe] = ACTIONS(865),
    [anon_sym_sql] = ACTIONS(865),
    [sym_int_literal] = ACTIONS(865),
    [sym_float_literal] = ACTIONS(865),
    [sym_rune_literal] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(865),
    [anon_sym_DQUOTE] = ACTIONS(865),
    [anon_sym_c_SQUOTE] = ACTIONS(865),
    [anon_sym_c_DQUOTE] = ACTIONS(865),
    [anon_sym_r_SQUOTE] = ACTIONS(865),
    [anon_sym_r_DQUOTE] = ACTIONS(865),
    [sym_pseudo_compile_time_identifier] = ACTIONS(865),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(351),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(865),
    [anon_sym_defer] = ACTIONS(865),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_break] = ACTIONS(865),
    [anon_sym_continue] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(865),
    [anon_sym_DOLLARfor] = ACTIONS(865),
    [anon_sym_for] = ACTIONS(865),
    [anon_sym_POUND] = ACTIONS(865),
    [anon_sym_asm] = ACTIONS(865),
  },
  [112] = {
    [sym_line_comment] = STATE(112),
    [sym_block_comment] = STATE(112),
    [sym_struct_field_scope] = STATE(3506),
    [sym_struct_field_declaration] = STATE(3506),
    [sym__struct_field_definition] = STATE(3507),
    [sym_embedded_definition] = STATE(3508),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4562),
    [sym_short_element_list] = STATE(4563),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1537),
    [sym_type_reference_expression] = STATE(3457),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3457),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(3489),
    [sym_function_type] = STATE(2417),
    [aux_sym__struct_body_repeat1] = STATE(3420),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(943),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym___global] = ACTIONS(953),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_pub] = ACTIONS(965),
    [anon_sym_mut] = ACTIONS(967),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [113] = {
    [sym_line_comment] = STATE(113),
    [sym_block_comment] = STATE(113),
    [sym_struct_field_scope] = STATE(3506),
    [sym_struct_field_declaration] = STATE(3506),
    [sym__struct_field_definition] = STATE(3507),
    [sym_embedded_definition] = STATE(3508),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4713),
    [sym_short_element_list] = STATE(4560),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1537),
    [sym_type_reference_expression] = STATE(3457),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3457),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(3489),
    [sym_function_type] = STATE(2417),
    [aux_sym__struct_body_repeat1] = STATE(3420),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(943),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym___global] = ACTIONS(953),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_pub] = ACTIONS(965),
    [anon_sym_mut] = ACTIONS(967),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [114] = {
    [sym_line_comment] = STATE(114),
    [sym_block_comment] = STATE(114),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4459),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(163),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [115] = {
    [sym_line_comment] = STATE(115),
    [sym_block_comment] = STATE(115),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4664),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(147),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [116] = {
    [sym_line_comment] = STATE(116),
    [sym_block_comment] = STATE(116),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4499),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(148),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1113),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [117] = {
    [sym_line_comment] = STATE(117),
    [sym_block_comment] = STATE(117),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4462),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(171),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1115),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [118] = {
    [sym_line_comment] = STATE(118),
    [sym_block_comment] = STATE(118),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4664),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(147),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1117),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [119] = {
    [sym_line_comment] = STATE(119),
    [sym_block_comment] = STATE(119),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4434),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(139),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [120] = {
    [sym_line_comment] = STATE(120),
    [sym_block_comment] = STATE(120),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4572),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(161),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1121),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [121] = {
    [sym_line_comment] = STATE(121),
    [sym_block_comment] = STATE(121),
    [sym__expression] = STATE(1963),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_strictly_expression_list] = STATE(4164),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2097),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(938),
    [sym_mutable_expression] = STATE(3387),
    [sym_expression_list] = STATE(3431),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_simple_statement] = STATE(4575),
    [sym_var_declaration] = STATE(4164),
    [sym_var_definition_list] = STATE(4578),
    [sym_var_definition] = STATE(3947),
    [sym_assignment_statement] = STATE(4164),
    [sym_block] = STATE(1876),
    [sym_is_clause] = STATE(4280),
    [sym_range_clause] = STATE(4280),
    [sym_for_clause] = STATE(4280),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(1141),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(1165),
    [anon_sym_lock] = ACTIONS(1167),
    [anon_sym_rlock] = ACTIONS(1167),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [122] = {
    [sym_line_comment] = STATE(122),
    [sym_block_comment] = STATE(122),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4633),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(153),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [123] = {
    [sym_line_comment] = STATE(123),
    [sym_block_comment] = STATE(123),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4504),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(172),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1191),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [124] = {
    [sym_line_comment] = STATE(124),
    [sym_block_comment] = STATE(124),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4462),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(171),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1193),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [125] = {
    [sym_line_comment] = STATE(125),
    [sym_block_comment] = STATE(125),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4638),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(169),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1195),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [126] = {
    [sym_line_comment] = STATE(126),
    [sym_block_comment] = STATE(126),
    [sym__expression] = STATE(1964),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_strictly_expression_list] = STATE(4164),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2097),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(938),
    [sym_mutable_expression] = STATE(3387),
    [sym_expression_list] = STATE(3431),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_simple_statement] = STATE(4575),
    [sym_var_declaration] = STATE(4164),
    [sym_var_definition_list] = STATE(4578),
    [sym_var_definition] = STATE(3947),
    [sym_assignment_statement] = STATE(4164),
    [sym_block] = STATE(1940),
    [sym_is_clause] = STATE(4178),
    [sym_range_clause] = STATE(4178),
    [sym_for_clause] = STATE(4178),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(1141),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(1165),
    [anon_sym_lock] = ACTIONS(1167),
    [anon_sym_rlock] = ACTIONS(1167),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [127] = {
    [sym_line_comment] = STATE(127),
    [sym_block_comment] = STATE(127),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4499),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(148),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [128] = {
    [sym_line_comment] = STATE(128),
    [sym_block_comment] = STATE(128),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4633),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(153),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [129] = {
    [sym_line_comment] = STATE(129),
    [sym_block_comment] = STATE(129),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4499),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(148),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1203),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [130] = {
    [sym_line_comment] = STATE(130),
    [sym_block_comment] = STATE(130),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4572),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(161),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [131] = {
    [sym_line_comment] = STATE(131),
    [sym_block_comment] = STATE(131),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4527),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(140),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [132] = {
    [sym_line_comment] = STATE(132),
    [sym_block_comment] = STATE(132),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4642),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(145),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [133] = {
    [sym_line_comment] = STATE(133),
    [sym_block_comment] = STATE(133),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4499),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(148),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [134] = {
    [sym_line_comment] = STATE(134),
    [sym_block_comment] = STATE(134),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4527),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(140),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [135] = {
    [sym_line_comment] = STATE(135),
    [sym_block_comment] = STATE(135),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4513),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(166),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1213),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [136] = {
    [sym_line_comment] = STATE(136),
    [sym_block_comment] = STATE(136),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4434),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(139),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1215),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [137] = {
    [sym_line_comment] = STATE(137),
    [sym_block_comment] = STATE(137),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4527),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(140),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1113),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [138] = {
    [sym_line_comment] = STATE(138),
    [sym_block_comment] = STATE(138),
    [sym__expression] = STATE(2595),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4637),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [aux_sym_select_expression_repeat1] = STATE(176),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1217),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [139] = {
    [sym_line_comment] = STATE(139),
    [sym_block_comment] = STATE(139),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4481),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1219),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [140] = {
    [sym_line_comment] = STATE(140),
    [sym_block_comment] = STATE(140),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4551),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1221),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [141] = {
    [sym_line_comment] = STATE(141),
    [sym_block_comment] = STATE(141),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4677),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [142] = {
    [sym_line_comment] = STATE(142),
    [sym_block_comment] = STATE(142),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4437),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [143] = {
    [sym_line_comment] = STATE(143),
    [sym_block_comment] = STATE(143),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4498),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1227),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [144] = {
    [sym_line_comment] = STATE(144),
    [sym_block_comment] = STATE(144),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4670),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [145] = {
    [sym_line_comment] = STATE(145),
    [sym_block_comment] = STATE(145),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4669),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [146] = {
    [sym_line_comment] = STATE(146),
    [sym_block_comment] = STATE(146),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4691),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(160),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [147] = {
    [sym_line_comment] = STATE(147),
    [sym_block_comment] = STATE(147),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4690),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [148] = {
    [sym_line_comment] = STATE(148),
    [sym_block_comment] = STATE(148),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4472),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [149] = {
    [sym_line_comment] = STATE(149),
    [sym_block_comment] = STATE(149),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4491),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [150] = {
    [sym_line_comment] = STATE(150),
    [sym_block_comment] = STATE(150),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4602),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [151] = {
    [sym_line_comment] = STATE(151),
    [sym_block_comment] = STATE(151),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4567),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1243),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [152] = {
    [sym_line_comment] = STATE(152),
    [sym_block_comment] = STATE(152),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4583),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(149),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [153] = {
    [sym_line_comment] = STATE(153),
    [sym_block_comment] = STATE(153),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4584),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [154] = {
    [sym_line_comment] = STATE(154),
    [sym_block_comment] = STATE(154),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4442),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1249),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [155] = {
    [sym_line_comment] = STATE(155),
    [sym_block_comment] = STATE(155),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4467),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(175),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1251),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [156] = {
    [sym_line_comment] = STATE(156),
    [sym_block_comment] = STATE(156),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4598),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(150),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [157] = {
    [sym_line_comment] = STATE(157),
    [sym_block_comment] = STATE(157),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4666),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(142),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1255),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [158] = {
    [sym_line_comment] = STATE(158),
    [sym_block_comment] = STATE(158),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4606),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1257),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [159] = {
    [sym_line_comment] = STATE(159),
    [sym_block_comment] = STATE(159),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4600),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1259),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [160] = {
    [sym_line_comment] = STATE(160),
    [sym_block_comment] = STATE(160),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4693),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1261),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [161] = {
    [sym_line_comment] = STATE(161),
    [sym_block_comment] = STATE(161),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4594),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [162] = {
    [sym_line_comment] = STATE(162),
    [sym_block_comment] = STATE(162),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4552),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(159),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [163] = {
    [sym_line_comment] = STATE(163),
    [sym_block_comment] = STATE(163),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4516),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1267),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [164] = {
    [sym_line_comment] = STATE(164),
    [sym_block_comment] = STATE(164),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4591),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(151),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [165] = {
    [sym_line_comment] = STATE(165),
    [sym_block_comment] = STATE(165),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4614),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(158),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [166] = {
    [sym_line_comment] = STATE(166),
    [sym_block_comment] = STATE(166),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4710),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [167] = {
    [sym_line_comment] = STATE(167),
    [sym_block_comment] = STATE(167),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4708),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(170),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1275),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [168] = {
    [sym_line_comment] = STATE(168),
    [sym_block_comment] = STATE(168),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4517),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(174),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [169] = {
    [sym_line_comment] = STATE(169),
    [sym_block_comment] = STATE(169),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4615),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [170] = {
    [sym_line_comment] = STATE(170),
    [sym_block_comment] = STATE(170),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4706),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1281),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [171] = {
    [sym_line_comment] = STATE(171),
    [sym_block_comment] = STATE(171),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4453),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1283),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [172] = {
    [sym_line_comment] = STATE(172),
    [sym_block_comment] = STATE(172),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4665),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1285),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [173] = {
    [sym_line_comment] = STATE(173),
    [sym_block_comment] = STATE(173),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4482),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1287),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [174] = {
    [sym_line_comment] = STATE(174),
    [sym_block_comment] = STATE(174),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4414),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [175] = {
    [sym_line_comment] = STATE(175),
    [sym_block_comment] = STATE(175),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4461),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1291),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [176] = {
    [sym_line_comment] = STATE(176),
    [sym_block_comment] = STATE(176),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4597),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [177] = {
    [sym_line_comment] = STATE(177),
    [sym_block_comment] = STATE(177),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_select_else_arn_clause] = STATE(4451),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(154),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1295),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOLLARif] = ACTIONS(1083),
    [anon_sym_match] = ACTIONS(1085),
    [anon_sym_select] = ACTIONS(1087),
    [anon_sym_lock] = ACTIONS(1089),
    [anon_sym_rlock] = ACTIONS(1089),
    [anon_sym_unsafe] = ACTIONS(1091),
    [anon_sym_sql] = ACTIONS(1093),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [178] = {
    [sym_line_comment] = STATE(178),
    [sym_block_comment] = STATE(178),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_short_lambda] = STATE(4574),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1299),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [179] = {
    [sym_line_comment] = STATE(179),
    [sym_block_comment] = STATE(179),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_short_lambda] = STATE(4436),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(225),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1305),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [180] = {
    [sym_line_comment] = STATE(180),
    [sym_block_comment] = STATE(180),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_short_lambda] = STATE(4537),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(228),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1307),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [181] = {
    [sym_line_comment] = STATE(181),
    [sym_block_comment] = STATE(181),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_short_lambda] = STATE(4534),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(231),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1309),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [182] = {
    [sym_line_comment] = STATE(182),
    [sym_block_comment] = STATE(182),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_short_lambda] = STATE(4494),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(226),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1311),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [183] = {
    [sym_line_comment] = STATE(183),
    [sym_block_comment] = STATE(183),
    [sym__expression] = STATE(2800),
    [sym__expression_without_blocks] = STATE(2013),
    [sym__expression_with_blocks] = STATE(2954),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2935),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2935),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2935),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2935),
    [sym_compile_time_if_expression] = STATE(2935),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2935),
    [sym_select_expression] = STATE(2935),
    [sym_select_arm] = STATE(2243),
    [sym_select_arm_statement] = STATE(4348),
    [sym_select_var_declaration] = STATE(4502),
    [sym_lock_expression] = STATE(2935),
    [sym_unsafe_expression] = STATE(2935),
    [sym_sql_expression] = STATE(2935),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(678),
    [sym_mutable_identifier] = STATE(3900),
    [sym_identifier_list] = STATE(4505),
    [sym_expression_without_blocks_list] = STATE(3392),
    [sym_plain_type] = STATE(4255),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_send_statement] = STATE(4502),
    [aux_sym_select_expression_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(1313),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_LBRACE] = ACTIONS(1319),
    [anon_sym_RBRACE] = ACTIONS(1322),
    [anon_sym_LPAREN] = ACTIONS(1324),
    [anon_sym_fn] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_struct] = ACTIONS(1336),
    [anon_sym_mut] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1342),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_go] = ACTIONS(1348),
    [anon_sym_spawn] = ACTIONS(1351),
    [anon_sym_json_DOTdecode] = ACTIONS(1354),
    [anon_sym_LBRACK2] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1330),
    [anon_sym_CARET] = ACTIONS(1330),
    [anon_sym_AMP] = ACTIONS(1360),
    [anon_sym_LT_DASH] = ACTIONS(1363),
    [sym_none] = ACTIONS(1366),
    [sym_true] = ACTIONS(1366),
    [sym_false] = ACTIONS(1366),
    [sym_nil] = ACTIONS(1366),
    [anon_sym_if] = ACTIONS(1369),
    [anon_sym_else] = ACTIONS(1372),
    [anon_sym_DOLLARif] = ACTIONS(1374),
    [anon_sym_match] = ACTIONS(1377),
    [anon_sym_select] = ACTIONS(1380),
    [anon_sym_lock] = ACTIONS(1383),
    [anon_sym_rlock] = ACTIONS(1383),
    [anon_sym_unsafe] = ACTIONS(1386),
    [anon_sym_sql] = ACTIONS(1389),
    [sym_int_literal] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1392),
    [sym_rune_literal] = ACTIONS(1392),
    [anon_sym_SQUOTE] = ACTIONS(1395),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_c_SQUOTE] = ACTIONS(1401),
    [anon_sym_c_DQUOTE] = ACTIONS(1404),
    [anon_sym_r_SQUOTE] = ACTIONS(1407),
    [anon_sym_r_DQUOTE] = ACTIONS(1410),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1413),
    [anon_sym_shared] = ACTIONS(1416),
    [anon_sym_map_LBRACK] = ACTIONS(1419),
    [anon_sym_chan] = ACTIONS(1422),
    [anon_sym_thread] = ACTIONS(1425),
    [anon_sym_atomic] = ACTIONS(1428),
  },
  [184] = {
    [sym_line_comment] = STATE(184),
    [sym_block_comment] = STATE(184),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_short_lambda] = STATE(4474),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1431),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [185] = {
    [sym_line_comment] = STATE(185),
    [sym_block_comment] = STATE(185),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_short_lambda] = STATE(4613),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(234),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1433),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [186] = {
    [sym_line_comment] = STATE(186),
    [sym_block_comment] = STATE(186),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_short_lambda] = STATE(4631),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(221),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1435),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [187] = {
    [sym_line_comment] = STATE(187),
    [sym_block_comment] = STATE(187),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_short_lambda] = STATE(4674),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(219),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1437),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [188] = {
    [sym_line_comment] = STATE(188),
    [sym_block_comment] = STATE(188),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_short_lambda] = STATE(4630),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1439),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [189] = {
    [sym_line_comment] = STATE(189),
    [sym_block_comment] = STATE(189),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_short_lambda] = STATE(4648),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(238),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1441),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [190] = {
    [sym_line_comment] = STATE(190),
    [sym_block_comment] = STATE(190),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_short_lambda] = STATE(4475),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(224),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1443),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [191] = {
    [sym_line_comment] = STATE(191),
    [sym_block_comment] = STATE(191),
    [sym__expression] = STATE(2578),
    [sym__expression_without_blocks] = STATE(2579),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_match_arms] = STATE(4473),
    [sym_match_arm] = STATE(2245),
    [sym_match_expression_list] = STATE(4186),
    [sym_match_arm_type] = STATE(4024),
    [sym_match_else_arm_clause] = STATE(2245),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4025),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__definite_range] = STATE(4028),
    [aux_sym_match_arms_repeat1] = STATE(237),
    [sym_identifier] = ACTIONS(1445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_RBRACE] = ACTIONS(1451),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_else] = ACTIONS(1481),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(1487),
    [anon_sym_lock] = ACTIONS(1489),
    [anon_sym_rlock] = ACTIONS(1489),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [192] = {
    [sym_line_comment] = STATE(192),
    [sym_block_comment] = STATE(192),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4457),
    [sym_short_element_list] = STATE(4458),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1441),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(1511),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [193] = {
    [sym_line_comment] = STATE(193),
    [sym_block_comment] = STATE(193),
    [sym__expression] = STATE(2578),
    [sym__expression_without_blocks] = STATE(2579),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_match_arms] = STATE(4564),
    [sym_match_arm] = STATE(2245),
    [sym_match_expression_list] = STATE(4186),
    [sym_match_arm_type] = STATE(4024),
    [sym_match_else_arm_clause] = STATE(2245),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4025),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__definite_range] = STATE(4028),
    [aux_sym_match_arms_repeat1] = STATE(237),
    [sym_identifier] = ACTIONS(1445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_RBRACE] = ACTIONS(1513),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_else] = ACTIONS(1481),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(1487),
    [anon_sym_lock] = ACTIONS(1489),
    [anon_sym_rlock] = ACTIONS(1489),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [194] = {
    [sym_line_comment] = STATE(194),
    [sym_block_comment] = STATE(194),
    [sym__expression] = STATE(2578),
    [sym__expression_without_blocks] = STATE(2579),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_match_arms] = STATE(4650),
    [sym_match_arm] = STATE(2245),
    [sym_match_expression_list] = STATE(4186),
    [sym_match_arm_type] = STATE(4024),
    [sym_match_else_arm_clause] = STATE(2245),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4025),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__definite_range] = STATE(4028),
    [aux_sym_match_arms_repeat1] = STATE(237),
    [sym_identifier] = ACTIONS(1445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_RBRACE] = ACTIONS(1515),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_else] = ACTIONS(1481),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(1487),
    [anon_sym_lock] = ACTIONS(1489),
    [anon_sym_rlock] = ACTIONS(1489),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [195] = {
    [sym_line_comment] = STATE(195),
    [sym_block_comment] = STATE(195),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4579),
    [sym_short_element_list] = STATE(4582),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1441),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [196] = {
    [sym_line_comment] = STATE(196),
    [sym_block_comment] = STATE(196),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4488),
    [sym_short_element_list] = STATE(4487),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1441),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(1519),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [197] = {
    [sym_line_comment] = STATE(197),
    [sym_block_comment] = STATE(197),
    [sym__expression] = STATE(2578),
    [sym__expression_without_blocks] = STATE(2579),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_match_arms] = STATE(4550),
    [sym_match_arm] = STATE(2245),
    [sym_match_expression_list] = STATE(4186),
    [sym_match_arm_type] = STATE(4024),
    [sym_match_else_arm_clause] = STATE(2245),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4025),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__definite_range] = STATE(4028),
    [aux_sym_match_arms_repeat1] = STATE(237),
    [sym_identifier] = ACTIONS(1445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_RBRACE] = ACTIONS(1521),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_else] = ACTIONS(1481),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(1487),
    [anon_sym_lock] = ACTIONS(1489),
    [anon_sym_rlock] = ACTIONS(1489),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [198] = {
    [sym_line_comment] = STATE(198),
    [sym_block_comment] = STATE(198),
    [sym__expression] = STATE(2578),
    [sym__expression_without_blocks] = STATE(2579),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_match_arms] = STATE(4616),
    [sym_match_arm] = STATE(2245),
    [sym_match_expression_list] = STATE(4186),
    [sym_match_arm_type] = STATE(4024),
    [sym_match_else_arm_clause] = STATE(2245),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4025),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__definite_range] = STATE(4028),
    [aux_sym_match_arms_repeat1] = STATE(237),
    [sym_identifier] = ACTIONS(1445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_RBRACE] = ACTIONS(1523),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_else] = ACTIONS(1481),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(1487),
    [anon_sym_lock] = ACTIONS(1489),
    [anon_sym_rlock] = ACTIONS(1489),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [199] = {
    [sym_line_comment] = STATE(199),
    [sym_block_comment] = STATE(199),
    [sym__expression] = STATE(2578),
    [sym__expression_without_blocks] = STATE(2579),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_match_arms] = STATE(4711),
    [sym_match_arm] = STATE(2245),
    [sym_match_expression_list] = STATE(4186),
    [sym_match_arm_type] = STATE(4024),
    [sym_match_else_arm_clause] = STATE(2245),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4025),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__definite_range] = STATE(4028),
    [aux_sym_match_arms_repeat1] = STATE(237),
    [sym_identifier] = ACTIONS(1445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_RBRACE] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_else] = ACTIONS(1481),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(1487),
    [anon_sym_lock] = ACTIONS(1489),
    [anon_sym_rlock] = ACTIONS(1489),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [200] = {
    [sym_line_comment] = STATE(200),
    [sym_block_comment] = STATE(200),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4623),
    [sym_short_element_list] = STATE(4622),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1441),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(1527),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [201] = {
    [sym_line_comment] = STATE(201),
    [sym_block_comment] = STATE(201),
    [sym__expression] = STATE(2578),
    [sym__expression_without_blocks] = STATE(2579),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_match_arms] = STATE(4688),
    [sym_match_arm] = STATE(2245),
    [sym_match_expression_list] = STATE(4186),
    [sym_match_arm_type] = STATE(4024),
    [sym_match_else_arm_clause] = STATE(2245),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4025),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__definite_range] = STATE(4028),
    [aux_sym_match_arms_repeat1] = STATE(237),
    [sym_identifier] = ACTIONS(1445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_RBRACE] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_else] = ACTIONS(1481),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(1487),
    [anon_sym_lock] = ACTIONS(1489),
    [anon_sym_rlock] = ACTIONS(1489),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [202] = {
    [sym_line_comment] = STATE(202),
    [sym_block_comment] = STATE(202),
    [sym__expression] = STATE(2578),
    [sym__expression_without_blocks] = STATE(2579),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_match_arms] = STATE(4480),
    [sym_match_arm] = STATE(2245),
    [sym_match_expression_list] = STATE(4186),
    [sym_match_arm_type] = STATE(4024),
    [sym_match_else_arm_clause] = STATE(2245),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4025),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__definite_range] = STATE(4028),
    [aux_sym_match_arms_repeat1] = STATE(237),
    [sym_identifier] = ACTIONS(1445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_RBRACE] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_else] = ACTIONS(1481),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(1487),
    [anon_sym_lock] = ACTIONS(1489),
    [anon_sym_rlock] = ACTIONS(1489),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [203] = {
    [sym_line_comment] = STATE(203),
    [sym_block_comment] = STATE(203),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4508),
    [sym_short_element_list] = STATE(4460),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1441),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(1533),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [204] = {
    [sym_line_comment] = STATE(204),
    [sym_block_comment] = STATE(204),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4543),
    [sym_short_element_list] = STATE(4544),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1441),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(1535),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [205] = {
    [sym_line_comment] = STATE(205),
    [sym_block_comment] = STATE(205),
    [sym__expression] = STATE(2578),
    [sym__expression_without_blocks] = STATE(2579),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_match_arms] = STATE(4660),
    [sym_match_arm] = STATE(2245),
    [sym_match_expression_list] = STATE(4186),
    [sym_match_arm_type] = STATE(4024),
    [sym_match_else_arm_clause] = STATE(2245),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4025),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__definite_range] = STATE(4028),
    [aux_sym_match_arms_repeat1] = STATE(237),
    [sym_identifier] = ACTIONS(1445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_RBRACE] = ACTIONS(1537),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_else] = ACTIONS(1481),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(1487),
    [anon_sym_lock] = ACTIONS(1489),
    [anon_sym_rlock] = ACTIONS(1489),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [206] = {
    [sym_line_comment] = STATE(206),
    [sym_block_comment] = STATE(206),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4707),
    [sym_short_element_list] = STATE(4703),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1441),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [207] = {
    [sym_line_comment] = STATE(207),
    [sym_block_comment] = STATE(207),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4653),
    [sym_short_element_list] = STATE(4654),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1441),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(1541),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [208] = {
    [sym_line_comment] = STATE(208),
    [sym_block_comment] = STATE(208),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4678),
    [sym_short_element_list] = STATE(4679),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1441),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(1543),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [209] = {
    [sym_line_comment] = STATE(209),
    [sym_block_comment] = STATE(209),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4556),
    [sym_short_element_list] = STATE(4559),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1441),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(1545),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [210] = {
    [sym_line_comment] = STATE(210),
    [sym_block_comment] = STATE(210),
    [sym__expression] = STATE(2578),
    [sym__expression_without_blocks] = STATE(2579),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_match_arms] = STATE(4456),
    [sym_match_arm] = STATE(2245),
    [sym_match_expression_list] = STATE(4186),
    [sym_match_arm_type] = STATE(4024),
    [sym_match_else_arm_clause] = STATE(2245),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4025),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__definite_range] = STATE(4028),
    [aux_sym_match_arms_repeat1] = STATE(237),
    [sym_identifier] = ACTIONS(1445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_RBRACE] = ACTIONS(1547),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_else] = ACTIONS(1481),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(1487),
    [anon_sym_lock] = ACTIONS(1489),
    [anon_sym_rlock] = ACTIONS(1489),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [211] = {
    [sym_line_comment] = STATE(211),
    [sym_block_comment] = STATE(211),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4619),
    [sym_short_element_list] = STATE(4617),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1441),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [212] = {
    [sym_line_comment] = STATE(212),
    [sym_block_comment] = STATE(212),
    [sym__expression] = STATE(2578),
    [sym__expression_without_blocks] = STATE(2579),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_match_arms] = STATE(4515),
    [sym_match_arm] = STATE(2245),
    [sym_match_expression_list] = STATE(4186),
    [sym_match_arm_type] = STATE(4024),
    [sym_match_else_arm_clause] = STATE(2245),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4025),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__definite_range] = STATE(4028),
    [aux_sym_match_arms_repeat1] = STATE(237),
    [sym_identifier] = ACTIONS(1445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_RBRACE] = ACTIONS(1551),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_else] = ACTIONS(1481),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(1487),
    [anon_sym_lock] = ACTIONS(1489),
    [anon_sym_rlock] = ACTIONS(1489),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [213] = {
    [sym_line_comment] = STATE(213),
    [sym_block_comment] = STATE(213),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4610),
    [sym_short_element_list] = STATE(4495),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1441),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [214] = {
    [sym_line_comment] = STATE(214),
    [sym_block_comment] = STATE(214),
    [sym__expression] = STATE(2578),
    [sym__expression_without_blocks] = STATE(2579),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_match_arms] = STATE(4607),
    [sym_match_arm] = STATE(2245),
    [sym_match_expression_list] = STATE(4186),
    [sym_match_arm_type] = STATE(4024),
    [sym_match_else_arm_clause] = STATE(2245),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4025),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__definite_range] = STATE(4028),
    [aux_sym_match_arms_repeat1] = STATE(237),
    [sym_identifier] = ACTIONS(1445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_RBRACE] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_else] = ACTIONS(1481),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(1487),
    [anon_sym_lock] = ACTIONS(1489),
    [anon_sym_rlock] = ACTIONS(1489),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [215] = {
    [sym_line_comment] = STATE(215),
    [sym_block_comment] = STATE(215),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_element_list] = STATE(4608),
    [sym_short_element_list] = STATE(4604),
    [sym_field_name] = STATE(4418),
    [sym_keyed_element] = STATE(3509),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1441),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(3509),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_element_list_repeat1] = STATE(3510),
    [aux_sym_short_element_list_repeat1] = STATE(372),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(1557),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [216] = {
    [sym_line_comment] = STATE(216),
    [sym_block_comment] = STATE(216),
    [sym__expression] = STATE(2578),
    [sym__expression_without_blocks] = STATE(2579),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_match_arms] = STATE(4585),
    [sym_match_arm] = STATE(2245),
    [sym_match_expression_list] = STATE(4186),
    [sym_match_arm_type] = STATE(4024),
    [sym_match_else_arm_clause] = STATE(2245),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4025),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__definite_range] = STATE(4028),
    [aux_sym_match_arms_repeat1] = STATE(237),
    [sym_identifier] = ACTIONS(1445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_RBRACE] = ACTIONS(1559),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_else] = ACTIONS(1481),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(1487),
    [anon_sym_lock] = ACTIONS(1489),
    [anon_sym_rlock] = ACTIONS(1489),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [217] = {
    [sym_line_comment] = STATE(217),
    [sym_block_comment] = STATE(217),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2458),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [ts_builtin_sym_end] = ACTIONS(861),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_LF] = ACTIONS(865),
    [anon_sym_CR] = ACTIONS(865),
    [anon_sym_CR_LF] = ACTIONS(865),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_COMMA] = ACTIONS(865),
    [anon_sym_const] = ACTIONS(865),
    [anon_sym_LPAREN] = ACTIONS(867),
    [anon_sym___global] = ACTIONS(865),
    [anon_sym_type] = ACTIONS(865),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_STAR] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_PERCENT] = ACTIONS(865),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(865),
    [anon_sym_BANG_EQ] = ACTIONS(865),
    [anon_sym_LT_EQ] = ACTIONS(865),
    [anon_sym_GT_EQ] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_union] = ACTIONS(865),
    [anon_sym_pub] = ACTIONS(865),
    [anon_sym_mut] = ACTIONS(865),
    [anon_sym_enum] = ACTIONS(865),
    [anon_sym_interface] = ACTIONS(865),
    [anon_sym_PLUS_PLUS] = ACTIONS(865),
    [anon_sym_DASH_DASH] = ACTIONS(865),
    [anon_sym_QMARK] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(1561),
    [anon_sym_go] = ACTIONS(865),
    [anon_sym_spawn] = ACTIONS(865),
    [anon_sym_json_DOTdecode] = ACTIONS(865),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_LBRACK2] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(865),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT_DASH] = ACTIONS(865),
    [anon_sym_LT_LT] = ACTIONS(865),
    [anon_sym_GT_GT] = ACTIONS(865),
    [anon_sym_GT_GT_GT] = ACTIONS(865),
    [anon_sym_AMP_CARET] = ACTIONS(865),
    [anon_sym_AMP_AMP] = ACTIONS(865),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_or] = ACTIONS(865),
    [sym_none] = ACTIONS(865),
    [sym_true] = ACTIONS(865),
    [sym_false] = ACTIONS(865),
    [sym_nil] = ACTIONS(865),
    [anon_sym_QMARK_DOT] = ACTIONS(865),
    [anon_sym_POUND_LBRACK] = ACTIONS(865),
    [anon_sym_if] = ACTIONS(865),
    [anon_sym_DOLLARif] = ACTIONS(865),
    [anon_sym_is] = ACTIONS(865),
    [anon_sym_BANGis] = ACTIONS(865),
    [anon_sym_in] = ACTIONS(865),
    [anon_sym_BANGin] = ACTIONS(865),
    [anon_sym_match] = ACTIONS(865),
    [anon_sym_select] = ACTIONS(865),
    [anon_sym_lock] = ACTIONS(865),
    [anon_sym_rlock] = ACTIONS(865),
    [anon_sym_unsafe] = ACTIONS(865),
    [anon_sym_sql] = ACTIONS(865),
    [sym_int_literal] = ACTIONS(865),
    [sym_float_literal] = ACTIONS(865),
    [sym_rune_literal] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(865),
    [anon_sym_DQUOTE] = ACTIONS(865),
    [anon_sym_c_SQUOTE] = ACTIONS(865),
    [anon_sym_c_DQUOTE] = ACTIONS(865),
    [anon_sym_r_SQUOTE] = ACTIONS(865),
    [anon_sym_r_DQUOTE] = ACTIONS(865),
    [sym_pseudo_compile_time_identifier] = ACTIONS(865),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(351),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(865),
    [anon_sym_defer] = ACTIONS(865),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_break] = ACTIONS(865),
    [anon_sym_continue] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(865),
    [anon_sym_DOLLARfor] = ACTIONS(865),
    [anon_sym_for] = ACTIONS(865),
    [anon_sym_POUND] = ACTIONS(865),
    [anon_sym_asm] = ACTIONS(865),
    [anon_sym_AT_LBRACK] = ACTIONS(865),
  },
  [218] = {
    [sym_line_comment] = STATE(218),
    [sym_block_comment] = STATE(218),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1563),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [219] = {
    [sym_line_comment] = STATE(219),
    [sym_block_comment] = STATE(219),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1565),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [220] = {
    [sym_line_comment] = STATE(220),
    [sym_block_comment] = STATE(220),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1681),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1688),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1692),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_attribute_expression] = STATE(3976),
    [sym_if_attribute] = STATE(4242),
    [sym__plain_attribute] = STATE(4242),
    [sym_literal_attribute] = STATE(4244),
    [sym_value_attribute] = STATE(3975),
    [sym_key_value_attribute] = STATE(4244),
    [aux_sym__array_repeat1] = STATE(478),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(1581),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(1601),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(1611),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1615),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [221] = {
    [sym_line_comment] = STATE(221),
    [sym_block_comment] = STATE(221),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1633),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [222] = {
    [sym_line_comment] = STATE(222),
    [sym_block_comment] = STATE(222),
    [sym__expression] = STATE(2578),
    [sym__expression_without_blocks] = STATE(2579),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_match_arm] = STATE(2245),
    [sym_match_expression_list] = STATE(4186),
    [sym_match_arm_type] = STATE(4024),
    [sym_match_else_arm_clause] = STATE(2245),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4025),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__definite_range] = STATE(4028),
    [aux_sym_match_arms_repeat1] = STATE(222),
    [sym_identifier] = ACTIONS(1635),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1638),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_RBRACE] = ACTIONS(1644),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_fn] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1652),
    [anon_sym_DASH] = ACTIONS(1652),
    [anon_sym_STAR] = ACTIONS(1655),
    [anon_sym_struct] = ACTIONS(1658),
    [anon_sym_mut] = ACTIONS(1661),
    [anon_sym_QMARK] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1667),
    [anon_sym_go] = ACTIONS(1670),
    [anon_sym_spawn] = ACTIONS(1673),
    [anon_sym_json_DOTdecode] = ACTIONS(1676),
    [anon_sym_LBRACK2] = ACTIONS(1679),
    [anon_sym_TILDE] = ACTIONS(1652),
    [anon_sym_CARET] = ACTIONS(1652),
    [anon_sym_AMP] = ACTIONS(1682),
    [anon_sym_LT_DASH] = ACTIONS(1685),
    [sym_none] = ACTIONS(1688),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_nil] = ACTIONS(1688),
    [anon_sym_if] = ACTIONS(1691),
    [anon_sym_else] = ACTIONS(1694),
    [anon_sym_DOLLARif] = ACTIONS(1697),
    [anon_sym_match] = ACTIONS(1700),
    [anon_sym_select] = ACTIONS(1703),
    [anon_sym_lock] = ACTIONS(1706),
    [anon_sym_rlock] = ACTIONS(1706),
    [anon_sym_unsafe] = ACTIONS(1709),
    [anon_sym_sql] = ACTIONS(1712),
    [sym_int_literal] = ACTIONS(1688),
    [sym_float_literal] = ACTIONS(1715),
    [sym_rune_literal] = ACTIONS(1715),
    [anon_sym_SQUOTE] = ACTIONS(1718),
    [anon_sym_DQUOTE] = ACTIONS(1721),
    [anon_sym_c_SQUOTE] = ACTIONS(1724),
    [anon_sym_c_DQUOTE] = ACTIONS(1727),
    [anon_sym_r_SQUOTE] = ACTIONS(1730),
    [anon_sym_r_DQUOTE] = ACTIONS(1733),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1736),
    [anon_sym_shared] = ACTIONS(1739),
    [anon_sym_map_LBRACK] = ACTIONS(1742),
    [anon_sym_chan] = ACTIONS(1745),
    [anon_sym_thread] = ACTIONS(1748),
    [anon_sym_atomic] = ACTIONS(1751),
  },
  [223] = {
    [sym_line_comment] = STATE(223),
    [sym_block_comment] = STATE(223),
    [sym_reference_expression] = STATE(4444),
    [sym_type_reference_expression] = STATE(1148),
    [sym_plain_type] = STATE(1221),
    [sym__plain_type_without_special] = STATE(1214),
    [sym_anon_struct_type] = STATE(1215),
    [sym_multi_return_type] = STATE(1214),
    [sym_result_type] = STATE(1214),
    [sym_option_type] = STATE(1214),
    [sym_qualified_type] = STATE(1148),
    [sym_fixed_array_type] = STATE(1215),
    [sym_array_type] = STATE(1215),
    [sym_pointer_type] = STATE(1215),
    [sym_wrong_pointer_type] = STATE(1215),
    [sym_map_type] = STATE(1215),
    [sym_channel_type] = STATE(1215),
    [sym_shared_type] = STATE(1215),
    [sym_thread_type] = STATE(1215),
    [sym_atomic_type] = STATE(1215),
    [sym_generic_type] = STATE(1215),
    [sym_function_type] = STATE(1215),
    [ts_builtin_sym_end] = ACTIONS(817),
    [sym_identifier] = ACTIONS(1754),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_CR] = ACTIONS(821),
    [anon_sym_CR_LF] = ACTIONS(821),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(821),
    [anon_sym_as] = ACTIONS(821),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_COMMA] = ACTIONS(821),
    [anon_sym_const] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(1756),
    [anon_sym___global] = ACTIONS(821),
    [anon_sym_type] = ACTIONS(821),
    [anon_sym_fn] = ACTIONS(1758),
    [anon_sym_PLUS] = ACTIONS(821),
    [anon_sym_DASH] = ACTIONS(821),
    [anon_sym_STAR] = ACTIONS(1760),
    [anon_sym_SLASH] = ACTIONS(821),
    [anon_sym_PERCENT] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(821),
    [anon_sym_GT] = ACTIONS(821),
    [anon_sym_EQ_EQ] = ACTIONS(821),
    [anon_sym_BANG_EQ] = ACTIONS(821),
    [anon_sym_LT_EQ] = ACTIONS(821),
    [anon_sym_GT_EQ] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(817),
    [anon_sym_struct] = ACTIONS(1762),
    [anon_sym_union] = ACTIONS(821),
    [anon_sym_pub] = ACTIONS(821),
    [anon_sym_mut] = ACTIONS(821),
    [anon_sym_enum] = ACTIONS(821),
    [anon_sym_interface] = ACTIONS(821),
    [anon_sym_PLUS_PLUS] = ACTIONS(821),
    [anon_sym_DASH_DASH] = ACTIONS(821),
    [anon_sym_QMARK] = ACTIONS(1764),
    [anon_sym_BANG] = ACTIONS(1766),
    [anon_sym_go] = ACTIONS(821),
    [anon_sym_spawn] = ACTIONS(821),
    [anon_sym_json_DOTdecode] = ACTIONS(821),
    [anon_sym_PIPE] = ACTIONS(821),
    [anon_sym_LBRACK2] = ACTIONS(1768),
    [anon_sym_TILDE] = ACTIONS(821),
    [anon_sym_CARET] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(1770),
    [anon_sym_LT_DASH] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(821),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_GT_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_CARET] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_or] = ACTIONS(821),
    [sym_none] = ACTIONS(821),
    [sym_true] = ACTIONS(821),
    [sym_false] = ACTIONS(821),
    [sym_nil] = ACTIONS(821),
    [anon_sym_QMARK_DOT] = ACTIONS(821),
    [anon_sym_POUND_LBRACK] = ACTIONS(821),
    [anon_sym_if] = ACTIONS(821),
    [anon_sym_DOLLARif] = ACTIONS(821),
    [anon_sym_is] = ACTIONS(821),
    [anon_sym_BANGis] = ACTIONS(821),
    [anon_sym_in] = ACTIONS(821),
    [anon_sym_BANGin] = ACTIONS(821),
    [anon_sym_match] = ACTIONS(821),
    [anon_sym_select] = ACTIONS(821),
    [anon_sym_lock] = ACTIONS(821),
    [anon_sym_rlock] = ACTIONS(821),
    [anon_sym_unsafe] = ACTIONS(821),
    [anon_sym_sql] = ACTIONS(821),
    [sym_int_literal] = ACTIONS(821),
    [sym_float_literal] = ACTIONS(821),
    [sym_rune_literal] = ACTIONS(821),
    [anon_sym_SQUOTE] = ACTIONS(821),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [anon_sym_c_SQUOTE] = ACTIONS(821),
    [anon_sym_c_DQUOTE] = ACTIONS(821),
    [anon_sym_r_SQUOTE] = ACTIONS(821),
    [anon_sym_r_DQUOTE] = ACTIONS(821),
    [sym_pseudo_compile_time_identifier] = ACTIONS(821),
    [anon_sym_shared] = ACTIONS(1772),
    [anon_sym_map_LBRACK] = ACTIONS(1774),
    [anon_sym_chan] = ACTIONS(1776),
    [anon_sym_thread] = ACTIONS(1778),
    [anon_sym_atomic] = ACTIONS(1780),
    [anon_sym_assert] = ACTIONS(821),
    [anon_sym_defer] = ACTIONS(821),
    [anon_sym_goto] = ACTIONS(821),
    [anon_sym_break] = ACTIONS(821),
    [anon_sym_continue] = ACTIONS(821),
    [anon_sym_return] = ACTIONS(821),
    [anon_sym_DOLLARfor] = ACTIONS(821),
    [anon_sym_for] = ACTIONS(821),
    [anon_sym_POUND] = ACTIONS(821),
    [anon_sym_asm] = ACTIONS(821),
    [anon_sym_AT_LBRACK] = ACTIONS(821),
  },
  [224] = {
    [sym_line_comment] = STATE(224),
    [sym_block_comment] = STATE(224),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1782),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [225] = {
    [sym_line_comment] = STATE(225),
    [sym_block_comment] = STATE(225),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1784),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [226] = {
    [sym_line_comment] = STATE(226),
    [sym_block_comment] = STATE(226),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1786),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [227] = {
    [sym_line_comment] = STATE(227),
    [sym_block_comment] = STATE(227),
    [sym_reference_expression] = STATE(4444),
    [sym_type_reference_expression] = STATE(1148),
    [sym_plain_type] = STATE(1159),
    [sym__plain_type_without_special] = STATE(1214),
    [sym_anon_struct_type] = STATE(1215),
    [sym_multi_return_type] = STATE(1214),
    [sym_result_type] = STATE(1214),
    [sym_option_type] = STATE(1214),
    [sym_qualified_type] = STATE(1148),
    [sym_fixed_array_type] = STATE(1215),
    [sym_array_type] = STATE(1215),
    [sym_pointer_type] = STATE(1215),
    [sym_wrong_pointer_type] = STATE(1215),
    [sym_map_type] = STATE(1215),
    [sym_channel_type] = STATE(1215),
    [sym_shared_type] = STATE(1215),
    [sym_thread_type] = STATE(1215),
    [sym_atomic_type] = STATE(1215),
    [sym_generic_type] = STATE(1215),
    [sym_function_type] = STATE(1215),
    [ts_builtin_sym_end] = ACTIONS(853),
    [sym_identifier] = ACTIONS(1754),
    [anon_sym_LF] = ACTIONS(855),
    [anon_sym_CR] = ACTIONS(855),
    [anon_sym_CR_LF] = ACTIONS(855),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(855),
    [anon_sym_as] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(855),
    [anon_sym_const] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(1756),
    [anon_sym___global] = ACTIONS(855),
    [anon_sym_type] = ACTIONS(855),
    [anon_sym_fn] = ACTIONS(1758),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(1760),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_PERCENT] = ACTIONS(855),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_GT] = ACTIONS(855),
    [anon_sym_EQ_EQ] = ACTIONS(855),
    [anon_sym_BANG_EQ] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(855),
    [anon_sym_GT_EQ] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_struct] = ACTIONS(1762),
    [anon_sym_union] = ACTIONS(855),
    [anon_sym_pub] = ACTIONS(855),
    [anon_sym_mut] = ACTIONS(855),
    [anon_sym_enum] = ACTIONS(855),
    [anon_sym_interface] = ACTIONS(855),
    [anon_sym_PLUS_PLUS] = ACTIONS(855),
    [anon_sym_DASH_DASH] = ACTIONS(855),
    [anon_sym_QMARK] = ACTIONS(1764),
    [anon_sym_BANG] = ACTIONS(1766),
    [anon_sym_go] = ACTIONS(855),
    [anon_sym_spawn] = ACTIONS(855),
    [anon_sym_json_DOTdecode] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(855),
    [anon_sym_LBRACK2] = ACTIONS(1768),
    [anon_sym_TILDE] = ACTIONS(855),
    [anon_sym_CARET] = ACTIONS(855),
    [anon_sym_AMP] = ACTIONS(1770),
    [anon_sym_LT_DASH] = ACTIONS(855),
    [anon_sym_LT_LT] = ACTIONS(855),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_GT_GT_GT] = ACTIONS(855),
    [anon_sym_AMP_CARET] = ACTIONS(855),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_PIPE_PIPE] = ACTIONS(855),
    [anon_sym_or] = ACTIONS(855),
    [sym_none] = ACTIONS(855),
    [sym_true] = ACTIONS(855),
    [sym_false] = ACTIONS(855),
    [sym_nil] = ACTIONS(855),
    [anon_sym_QMARK_DOT] = ACTIONS(855),
    [anon_sym_POUND_LBRACK] = ACTIONS(855),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_DOLLARif] = ACTIONS(855),
    [anon_sym_is] = ACTIONS(855),
    [anon_sym_BANGis] = ACTIONS(855),
    [anon_sym_in] = ACTIONS(855),
    [anon_sym_BANGin] = ACTIONS(855),
    [anon_sym_match] = ACTIONS(855),
    [anon_sym_select] = ACTIONS(855),
    [anon_sym_lock] = ACTIONS(855),
    [anon_sym_rlock] = ACTIONS(855),
    [anon_sym_unsafe] = ACTIONS(855),
    [anon_sym_sql] = ACTIONS(855),
    [sym_int_literal] = ACTIONS(855),
    [sym_float_literal] = ACTIONS(855),
    [sym_rune_literal] = ACTIONS(855),
    [anon_sym_SQUOTE] = ACTIONS(855),
    [anon_sym_DQUOTE] = ACTIONS(855),
    [anon_sym_c_SQUOTE] = ACTIONS(855),
    [anon_sym_c_DQUOTE] = ACTIONS(855),
    [anon_sym_r_SQUOTE] = ACTIONS(855),
    [anon_sym_r_DQUOTE] = ACTIONS(855),
    [sym_pseudo_compile_time_identifier] = ACTIONS(855),
    [anon_sym_shared] = ACTIONS(1772),
    [anon_sym_map_LBRACK] = ACTIONS(1774),
    [anon_sym_chan] = ACTIONS(1776),
    [anon_sym_thread] = ACTIONS(1778),
    [anon_sym_atomic] = ACTIONS(1780),
    [anon_sym_assert] = ACTIONS(855),
    [anon_sym_defer] = ACTIONS(855),
    [anon_sym_goto] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(855),
    [anon_sym_continue] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(855),
    [anon_sym_DOLLARfor] = ACTIONS(855),
    [anon_sym_for] = ACTIONS(855),
    [anon_sym_POUND] = ACTIONS(855),
    [anon_sym_asm] = ACTIONS(855),
    [anon_sym_AT_LBRACK] = ACTIONS(855),
  },
  [228] = {
    [sym_line_comment] = STATE(228),
    [sym_block_comment] = STATE(228),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1788),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [229] = {
    [sym_line_comment] = STATE(229),
    [sym_block_comment] = STATE(229),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(1790),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1793),
    [anon_sym_LBRACE] = ACTIONS(1796),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_RPAREN] = ACTIONS(1802),
    [anon_sym_fn] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1813),
    [anon_sym_struct] = ACTIONS(1816),
    [anon_sym_mut] = ACTIONS(1819),
    [anon_sym_QMARK] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_go] = ACTIONS(1828),
    [anon_sym_spawn] = ACTIONS(1831),
    [anon_sym_json_DOTdecode] = ACTIONS(1834),
    [anon_sym_LBRACK2] = ACTIONS(1837),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_LT_DASH] = ACTIONS(1843),
    [sym_none] = ACTIONS(1846),
    [sym_true] = ACTIONS(1846),
    [sym_false] = ACTIONS(1846),
    [sym_nil] = ACTIONS(1846),
    [anon_sym_if] = ACTIONS(1849),
    [anon_sym_DOLLARif] = ACTIONS(1852),
    [anon_sym_match] = ACTIONS(1855),
    [anon_sym_select] = ACTIONS(1858),
    [anon_sym_lock] = ACTIONS(1861),
    [anon_sym_rlock] = ACTIONS(1861),
    [anon_sym_unsafe] = ACTIONS(1864),
    [anon_sym_sql] = ACTIONS(1867),
    [sym_int_literal] = ACTIONS(1846),
    [sym_float_literal] = ACTIONS(1870),
    [sym_rune_literal] = ACTIONS(1870),
    [anon_sym_SQUOTE] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1876),
    [anon_sym_c_SQUOTE] = ACTIONS(1879),
    [anon_sym_c_DQUOTE] = ACTIONS(1882),
    [anon_sym_r_SQUOTE] = ACTIONS(1885),
    [anon_sym_r_DQUOTE] = ACTIONS(1888),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1891),
    [anon_sym_shared] = ACTIONS(1894),
    [anon_sym_map_LBRACK] = ACTIONS(1897),
    [anon_sym_chan] = ACTIONS(1900),
    [anon_sym_thread] = ACTIONS(1903),
    [anon_sym_atomic] = ACTIONS(1906),
  },
  [230] = {
    [sym_line_comment] = STATE(230),
    [sym_block_comment] = STATE(230),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2489),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [ts_builtin_sym_end] = ACTIONS(849),
    [sym_identifier] = ACTIONS(851),
    [anon_sym_LF] = ACTIONS(851),
    [anon_sym_CR] = ACTIONS(851),
    [anon_sym_CR_LF] = ACTIONS(851),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(851),
    [anon_sym_COMMA] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym___global] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_fn] = ACTIONS(851),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(851),
    [anon_sym_SLASH] = ACTIONS(851),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_struct] = ACTIONS(851),
    [anon_sym_union] = ACTIONS(851),
    [anon_sym_pub] = ACTIONS(851),
    [anon_sym_mut] = ACTIONS(851),
    [anon_sym_enum] = ACTIONS(851),
    [anon_sym_interface] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(851),
    [anon_sym_DASH_DASH] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_go] = ACTIONS(851),
    [anon_sym_spawn] = ACTIONS(851),
    [anon_sym_json_DOTdecode] = ACTIONS(851),
    [anon_sym_PIPE] = ACTIONS(851),
    [anon_sym_LBRACK2] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_CARET] = ACTIONS(851),
    [anon_sym_AMP] = ACTIONS(851),
    [anon_sym_LT_DASH] = ACTIONS(851),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_CARET] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(851),
    [anon_sym_PIPE_PIPE] = ACTIONS(851),
    [anon_sym_or] = ACTIONS(851),
    [sym_none] = ACTIONS(851),
    [sym_true] = ACTIONS(851),
    [sym_false] = ACTIONS(851),
    [sym_nil] = ACTIONS(851),
    [anon_sym_QMARK_DOT] = ACTIONS(851),
    [anon_sym_POUND_LBRACK] = ACTIONS(851),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_DOLLARif] = ACTIONS(851),
    [anon_sym_is] = ACTIONS(851),
    [anon_sym_BANGis] = ACTIONS(851),
    [anon_sym_in] = ACTIONS(851),
    [anon_sym_BANGin] = ACTIONS(851),
    [anon_sym_match] = ACTIONS(851),
    [anon_sym_select] = ACTIONS(851),
    [anon_sym_lock] = ACTIONS(851),
    [anon_sym_rlock] = ACTIONS(851),
    [anon_sym_unsafe] = ACTIONS(851),
    [anon_sym_sql] = ACTIONS(851),
    [sym_int_literal] = ACTIONS(851),
    [sym_float_literal] = ACTIONS(851),
    [sym_rune_literal] = ACTIONS(851),
    [anon_sym_SQUOTE] = ACTIONS(851),
    [anon_sym_DQUOTE] = ACTIONS(851),
    [anon_sym_c_SQUOTE] = ACTIONS(851),
    [anon_sym_c_DQUOTE] = ACTIONS(851),
    [anon_sym_r_SQUOTE] = ACTIONS(851),
    [anon_sym_r_DQUOTE] = ACTIONS(851),
    [sym_pseudo_compile_time_identifier] = ACTIONS(851),
    [anon_sym_shared] = ACTIONS(851),
    [anon_sym_map_LBRACK] = ACTIONS(851),
    [anon_sym_chan] = ACTIONS(851),
    [anon_sym_thread] = ACTIONS(851),
    [anon_sym_atomic] = ACTIONS(851),
    [anon_sym_assert] = ACTIONS(851),
    [anon_sym_defer] = ACTIONS(851),
    [anon_sym_goto] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(851),
    [anon_sym_continue] = ACTIONS(851),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_DOLLARfor] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(851),
    [anon_sym_asm] = ACTIONS(851),
    [anon_sym_AT_LBRACK] = ACTIONS(851),
  },
  [231] = {
    [sym_line_comment] = STATE(231),
    [sym_block_comment] = STATE(231),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1909),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [232] = {
    [sym_line_comment] = STATE(232),
    [sym_block_comment] = STATE(232),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1911),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [233] = {
    [sym_line_comment] = STATE(233),
    [sym_block_comment] = STATE(233),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1913),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [234] = {
    [sym_line_comment] = STATE(234),
    [sym_block_comment] = STATE(234),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1915),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [235] = {
    [sym_line_comment] = STATE(235),
    [sym_block_comment] = STATE(235),
    [sym__expression] = STATE(2584),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2687),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2908),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4466),
    [sym_attribute_expression] = STATE(3976),
    [sym_if_attribute] = STATE(4242),
    [sym__plain_attribute] = STATE(4242),
    [sym_literal_attribute] = STATE(4244),
    [sym_value_attribute] = STATE(3975),
    [sym_key_value_attribute] = STATE(4244),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(1949),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(1959),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [236] = {
    [sym_line_comment] = STATE(236),
    [sym_block_comment] = STATE(236),
    [sym_reference_expression] = STATE(4444),
    [sym_type_reference_expression] = STATE(1148),
    [sym_plain_type] = STATE(1253),
    [sym__plain_type_without_special] = STATE(1214),
    [sym_anon_struct_type] = STATE(1215),
    [sym_multi_return_type] = STATE(1214),
    [sym_result_type] = STATE(1214),
    [sym_option_type] = STATE(1214),
    [sym_qualified_type] = STATE(1148),
    [sym_fixed_array_type] = STATE(1215),
    [sym_array_type] = STATE(1215),
    [sym_pointer_type] = STATE(1215),
    [sym_wrong_pointer_type] = STATE(1215),
    [sym_map_type] = STATE(1215),
    [sym_channel_type] = STATE(1215),
    [sym_shared_type] = STATE(1215),
    [sym_thread_type] = STATE(1215),
    [sym_atomic_type] = STATE(1215),
    [sym_generic_type] = STATE(1215),
    [sym_function_type] = STATE(1215),
    [ts_builtin_sym_end] = ACTIONS(857),
    [sym_identifier] = ACTIONS(1754),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_CR] = ACTIONS(859),
    [anon_sym_CR_LF] = ACTIONS(859),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(859),
    [anon_sym_as] = ACTIONS(859),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_const] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(1756),
    [anon_sym___global] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(859),
    [anon_sym_fn] = ACTIONS(1758),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(1760),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_struct] = ACTIONS(1762),
    [anon_sym_union] = ACTIONS(859),
    [anon_sym_pub] = ACTIONS(859),
    [anon_sym_mut] = ACTIONS(859),
    [anon_sym_enum] = ACTIONS(859),
    [anon_sym_interface] = ACTIONS(859),
    [anon_sym_PLUS_PLUS] = ACTIONS(859),
    [anon_sym_DASH_DASH] = ACTIONS(859),
    [anon_sym_QMARK] = ACTIONS(1764),
    [anon_sym_BANG] = ACTIONS(1766),
    [anon_sym_go] = ACTIONS(859),
    [anon_sym_spawn] = ACTIONS(859),
    [anon_sym_json_DOTdecode] = ACTIONS(859),
    [anon_sym_PIPE] = ACTIONS(859),
    [anon_sym_LBRACK2] = ACTIONS(1768),
    [anon_sym_TILDE] = ACTIONS(859),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(1770),
    [anon_sym_LT_DASH] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_GT_GT_GT] = ACTIONS(859),
    [anon_sym_AMP_CARET] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_or] = ACTIONS(859),
    [sym_none] = ACTIONS(859),
    [sym_true] = ACTIONS(859),
    [sym_false] = ACTIONS(859),
    [sym_nil] = ACTIONS(859),
    [anon_sym_QMARK_DOT] = ACTIONS(859),
    [anon_sym_POUND_LBRACK] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_DOLLARif] = ACTIONS(859),
    [anon_sym_is] = ACTIONS(859),
    [anon_sym_BANGis] = ACTIONS(859),
    [anon_sym_in] = ACTIONS(859),
    [anon_sym_BANGin] = ACTIONS(859),
    [anon_sym_match] = ACTIONS(859),
    [anon_sym_select] = ACTIONS(859),
    [anon_sym_lock] = ACTIONS(859),
    [anon_sym_rlock] = ACTIONS(859),
    [anon_sym_unsafe] = ACTIONS(859),
    [anon_sym_sql] = ACTIONS(859),
    [sym_int_literal] = ACTIONS(859),
    [sym_float_literal] = ACTIONS(859),
    [sym_rune_literal] = ACTIONS(859),
    [anon_sym_SQUOTE] = ACTIONS(859),
    [anon_sym_DQUOTE] = ACTIONS(859),
    [anon_sym_c_SQUOTE] = ACTIONS(859),
    [anon_sym_c_DQUOTE] = ACTIONS(859),
    [anon_sym_r_SQUOTE] = ACTIONS(859),
    [anon_sym_r_DQUOTE] = ACTIONS(859),
    [sym_pseudo_compile_time_identifier] = ACTIONS(859),
    [anon_sym_shared] = ACTIONS(1772),
    [anon_sym_map_LBRACK] = ACTIONS(1774),
    [anon_sym_chan] = ACTIONS(1776),
    [anon_sym_thread] = ACTIONS(1778),
    [anon_sym_atomic] = ACTIONS(1780),
    [anon_sym_assert] = ACTIONS(859),
    [anon_sym_defer] = ACTIONS(859),
    [anon_sym_goto] = ACTIONS(859),
    [anon_sym_break] = ACTIONS(859),
    [anon_sym_continue] = ACTIONS(859),
    [anon_sym_return] = ACTIONS(859),
    [anon_sym_DOLLARfor] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(859),
    [anon_sym_POUND] = ACTIONS(859),
    [anon_sym_asm] = ACTIONS(859),
    [anon_sym_AT_LBRACK] = ACTIONS(859),
  },
  [237] = {
    [sym_line_comment] = STATE(237),
    [sym_block_comment] = STATE(237),
    [sym__expression] = STATE(2578),
    [sym__expression_without_blocks] = STATE(2579),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_match_arm] = STATE(2245),
    [sym_match_expression_list] = STATE(4186),
    [sym_match_arm_type] = STATE(4024),
    [sym_match_else_arm_clause] = STATE(2245),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4025),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__definite_range] = STATE(4028),
    [aux_sym_match_arms_repeat1] = STATE(222),
    [sym_identifier] = ACTIONS(1445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_else] = ACTIONS(1481),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(1487),
    [anon_sym_lock] = ACTIONS(1489),
    [anon_sym_rlock] = ACTIONS(1489),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [238] = {
    [sym_line_comment] = STATE(238),
    [sym_block_comment] = STATE(238),
    [sym__expression] = STATE(1421),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_argument] = STATE(2022),
    [sym_type_initializer] = STATE(1496),
    [sym_field_name] = STATE(4586),
    [sym_keyed_element] = STATE(2018),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1477),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_spread_expression] = STATE(2018),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(813),
    [sym_mutable_expression] = STATE(2018),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_argument_list_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(1983),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [239] = {
    [sym_line_comment] = STATE(239),
    [sym_block_comment] = STATE(239),
    [sym__expression] = STATE(1976),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_strictly_expression_list] = STATE(4164),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(938),
    [sym_mutable_expression] = STATE(3386),
    [sym_expression_list] = STATE(3436),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_simple_statement] = STATE(4686),
    [sym_var_declaration] = STATE(4164),
    [sym_assignment_statement] = STATE(4164),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(1987),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(1165),
    [anon_sym_lock] = ACTIONS(1167),
    [anon_sym_rlock] = ACTIONS(1167),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [240] = {
    [sym_line_comment] = STATE(240),
    [sym_block_comment] = STATE(240),
    [sym__expression] = STATE(1976),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_strictly_expression_list] = STATE(4164),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(938),
    [sym_mutable_expression] = STATE(3386),
    [sym_expression_list] = STATE(3436),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_simple_statement] = STATE(4422),
    [sym_var_declaration] = STATE(4164),
    [sym_assignment_statement] = STATE(4164),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(1989),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(1165),
    [anon_sym_lock] = ACTIONS(1167),
    [anon_sym_rlock] = ACTIONS(1167),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [241] = {
    [sym_line_comment] = STATE(241),
    [sym_block_comment] = STATE(241),
    [sym__expression] = STATE(1976),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_strictly_expression_list] = STATE(4164),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(938),
    [sym_mutable_expression] = STATE(3386),
    [sym_expression_list] = STATE(3436),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_simple_statement] = STATE(4420),
    [sym_var_declaration] = STATE(4164),
    [sym_assignment_statement] = STATE(4164),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(1165),
    [anon_sym_lock] = ACTIONS(1167),
    [anon_sym_rlock] = ACTIONS(1167),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [242] = {
    [sym_line_comment] = STATE(242),
    [sym_block_comment] = STATE(242),
    [sym_type_parameters] = STATE(4293),
    [sym_argument_list] = STATE(390),
    [sym_or_block] = STATE(389),
    [aux_sym_strictly_expression_list_repeat1] = STATE(1740),
    [ts_builtin_sym_end] = ACTIONS(1993),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_LF] = ACTIONS(1995),
    [anon_sym_CR] = ACTIONS(1995),
    [anon_sym_CR_LF] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(1997),
    [anon_sym_as] = ACTIONS(1999),
    [anon_sym_LBRACE] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(2001),
    [anon_sym_const] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_EQ] = ACTIONS(2001),
    [anon_sym___global] = ACTIONS(1995),
    [anon_sym_type] = ACTIONS(1995),
    [anon_sym_fn] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_DASH] = ACTIONS(2005),
    [anon_sym_STAR] = ACTIONS(2007),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(2009),
    [anon_sym_BANG_EQ] = ACTIONS(2009),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2009),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(1995),
    [anon_sym_union] = ACTIONS(1995),
    [anon_sym_pub] = ACTIONS(1995),
    [anon_sym_mut] = ACTIONS(1995),
    [anon_sym_enum] = ACTIONS(1995),
    [anon_sym_interface] = ACTIONS(1995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2013),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_QMARK] = ACTIONS(2017),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_go] = ACTIONS(1995),
    [anon_sym_spawn] = ACTIONS(1995),
    [anon_sym_json_DOTdecode] = ACTIONS(1995),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_LBRACK2] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_DASH] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(2007),
    [anon_sym_GT_GT] = ACTIONS(2007),
    [anon_sym_GT_GT_GT] = ACTIONS(2007),
    [anon_sym_AMP_CARET] = ACTIONS(2007),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_PIPE_PIPE] = ACTIONS(2025),
    [anon_sym_or] = ACTIONS(2027),
    [sym_none] = ACTIONS(1995),
    [sym_true] = ACTIONS(1995),
    [sym_false] = ACTIONS(1995),
    [sym_nil] = ACTIONS(1995),
    [anon_sym_QMARK_DOT] = ACTIONS(1997),
    [anon_sym_POUND_LBRACK] = ACTIONS(2021),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_DOLLARif] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(2029),
    [anon_sym_BANGis] = ACTIONS(2029),
    [anon_sym_in] = ACTIONS(2031),
    [anon_sym_BANGin] = ACTIONS(2031),
    [anon_sym_match] = ACTIONS(1995),
    [anon_sym_select] = ACTIONS(1995),
    [anon_sym_STAR_EQ] = ACTIONS(2001),
    [anon_sym_SLASH_EQ] = ACTIONS(2001),
    [anon_sym_PERCENT_EQ] = ACTIONS(2001),
    [anon_sym_LT_LT_EQ] = ACTIONS(2001),
    [anon_sym_GT_GT_EQ] = ACTIONS(2001),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2001),
    [anon_sym_AMP_EQ] = ACTIONS(2001),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2001),
    [anon_sym_PLUS_EQ] = ACTIONS(2001),
    [anon_sym_DASH_EQ] = ACTIONS(2001),
    [anon_sym_PIPE_EQ] = ACTIONS(2001),
    [anon_sym_CARET_EQ] = ACTIONS(2001),
    [anon_sym_COLON_EQ] = ACTIONS(2001),
    [anon_sym_lock] = ACTIONS(1995),
    [anon_sym_rlock] = ACTIONS(1995),
    [anon_sym_unsafe] = ACTIONS(1995),
    [anon_sym_sql] = ACTIONS(1995),
    [sym_int_literal] = ACTIONS(1995),
    [sym_float_literal] = ACTIONS(1995),
    [sym_rune_literal] = ACTIONS(1995),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_DQUOTE] = ACTIONS(1995),
    [anon_sym_c_SQUOTE] = ACTIONS(1995),
    [anon_sym_c_DQUOTE] = ACTIONS(1995),
    [anon_sym_r_SQUOTE] = ACTIONS(1995),
    [anon_sym_r_DQUOTE] = ACTIONS(1995),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1995),
    [anon_sym_shared] = ACTIONS(1995),
    [anon_sym_map_LBRACK] = ACTIONS(1995),
    [anon_sym_chan] = ACTIONS(1995),
    [anon_sym_thread] = ACTIONS(1995),
    [anon_sym_atomic] = ACTIONS(1995),
    [anon_sym_assert] = ACTIONS(1995),
    [anon_sym_defer] = ACTIONS(1995),
    [anon_sym_goto] = ACTIONS(1995),
    [anon_sym_break] = ACTIONS(1995),
    [anon_sym_continue] = ACTIONS(1995),
    [anon_sym_return] = ACTIONS(1995),
    [anon_sym_DOLLARfor] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_POUND] = ACTIONS(1995),
    [anon_sym_asm] = ACTIONS(1995),
    [anon_sym_AT_LBRACK] = ACTIONS(1995),
  },
  [243] = {
    [sym_line_comment] = STATE(243),
    [sym_block_comment] = STATE(243),
    [sym__expression] = STATE(1976),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_strictly_expression_list] = STATE(4164),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(938),
    [sym_mutable_expression] = STATE(3386),
    [sym_expression_list] = STATE(3436),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_simple_statement] = STATE(4687),
    [sym_var_declaration] = STATE(4164),
    [sym_assignment_statement] = STATE(4164),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(2033),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(1165),
    [anon_sym_lock] = ACTIONS(1167),
    [anon_sym_rlock] = ACTIONS(1167),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [244] = {
    [sym_line_comment] = STATE(244),
    [sym_block_comment] = STATE(244),
    [sym_type_parameters] = STATE(4293),
    [sym_argument_list] = STATE(390),
    [sym_or_block] = STATE(389),
    [aux_sym_strictly_expression_list_repeat1] = STATE(3389),
    [ts_builtin_sym_end] = ACTIONS(2035),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_LF] = ACTIONS(2037),
    [anon_sym_CR] = ACTIONS(2037),
    [anon_sym_CR_LF] = ACTIONS(2037),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(1997),
    [anon_sym_as] = ACTIONS(1999),
    [anon_sym_LBRACE] = ACTIONS(2037),
    [anon_sym_COMMA] = ACTIONS(2039),
    [anon_sym_const] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_EQ] = ACTIONS(2041),
    [anon_sym___global] = ACTIONS(2037),
    [anon_sym_type] = ACTIONS(2037),
    [anon_sym_fn] = ACTIONS(2037),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_DASH] = ACTIONS(2005),
    [anon_sym_STAR] = ACTIONS(2007),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(2009),
    [anon_sym_BANG_EQ] = ACTIONS(2009),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2009),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(2037),
    [anon_sym_union] = ACTIONS(2037),
    [anon_sym_pub] = ACTIONS(2037),
    [anon_sym_mut] = ACTIONS(2037),
    [anon_sym_enum] = ACTIONS(2037),
    [anon_sym_interface] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2013),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_QMARK] = ACTIONS(2017),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_go] = ACTIONS(2037),
    [anon_sym_spawn] = ACTIONS(2037),
    [anon_sym_json_DOTdecode] = ACTIONS(2037),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_LBRACK2] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_CARET] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_DASH] = ACTIONS(2043),
    [anon_sym_LT_LT] = ACTIONS(2045),
    [anon_sym_GT_GT] = ACTIONS(2007),
    [anon_sym_GT_GT_GT] = ACTIONS(2007),
    [anon_sym_AMP_CARET] = ACTIONS(2007),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_PIPE_PIPE] = ACTIONS(2025),
    [anon_sym_or] = ACTIONS(2027),
    [sym_none] = ACTIONS(2037),
    [sym_true] = ACTIONS(2037),
    [sym_false] = ACTIONS(2037),
    [sym_nil] = ACTIONS(2037),
    [anon_sym_QMARK_DOT] = ACTIONS(1997),
    [anon_sym_POUND_LBRACK] = ACTIONS(2021),
    [anon_sym_if] = ACTIONS(2037),
    [anon_sym_DOLLARif] = ACTIONS(2037),
    [anon_sym_is] = ACTIONS(2029),
    [anon_sym_BANGis] = ACTIONS(2029),
    [anon_sym_in] = ACTIONS(2031),
    [anon_sym_BANGin] = ACTIONS(2031),
    [anon_sym_match] = ACTIONS(2037),
    [anon_sym_select] = ACTIONS(2037),
    [anon_sym_STAR_EQ] = ACTIONS(2041),
    [anon_sym_SLASH_EQ] = ACTIONS(2041),
    [anon_sym_PERCENT_EQ] = ACTIONS(2041),
    [anon_sym_LT_LT_EQ] = ACTIONS(2041),
    [anon_sym_GT_GT_EQ] = ACTIONS(2041),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2041),
    [anon_sym_AMP_EQ] = ACTIONS(2041),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2041),
    [anon_sym_PLUS_EQ] = ACTIONS(2041),
    [anon_sym_DASH_EQ] = ACTIONS(2041),
    [anon_sym_PIPE_EQ] = ACTIONS(2041),
    [anon_sym_CARET_EQ] = ACTIONS(2041),
    [anon_sym_COLON_EQ] = ACTIONS(2041),
    [anon_sym_lock] = ACTIONS(2037),
    [anon_sym_rlock] = ACTIONS(2037),
    [anon_sym_unsafe] = ACTIONS(2037),
    [anon_sym_sql] = ACTIONS(2037),
    [sym_int_literal] = ACTIONS(2037),
    [sym_float_literal] = ACTIONS(2037),
    [sym_rune_literal] = ACTIONS(2037),
    [anon_sym_SQUOTE] = ACTIONS(2037),
    [anon_sym_DQUOTE] = ACTIONS(2037),
    [anon_sym_c_SQUOTE] = ACTIONS(2037),
    [anon_sym_c_DQUOTE] = ACTIONS(2037),
    [anon_sym_r_SQUOTE] = ACTIONS(2037),
    [anon_sym_r_DQUOTE] = ACTIONS(2037),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2037),
    [anon_sym_shared] = ACTIONS(2037),
    [anon_sym_map_LBRACK] = ACTIONS(2037),
    [anon_sym_chan] = ACTIONS(2037),
    [anon_sym_thread] = ACTIONS(2037),
    [anon_sym_atomic] = ACTIONS(2037),
    [anon_sym_assert] = ACTIONS(2037),
    [anon_sym_defer] = ACTIONS(2037),
    [anon_sym_goto] = ACTIONS(2037),
    [anon_sym_break] = ACTIONS(2037),
    [anon_sym_continue] = ACTIONS(2037),
    [anon_sym_return] = ACTIONS(2037),
    [anon_sym_DOLLARfor] = ACTIONS(2037),
    [anon_sym_for] = ACTIONS(2037),
    [anon_sym_POUND] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2037),
    [anon_sym_AT_LBRACK] = ACTIONS(2037),
  },
  [245] = {
    [sym_line_comment] = STATE(245),
    [sym_block_comment] = STATE(245),
    [sym_type_parameters] = STATE(4293),
    [sym_argument_list] = STATE(390),
    [sym_or_block] = STATE(389),
    [ts_builtin_sym_end] = ACTIONS(2047),
    [sym_identifier] = ACTIONS(2049),
    [anon_sym_LF] = ACTIONS(2049),
    [anon_sym_CR] = ACTIONS(2049),
    [anon_sym_CR_LF] = ACTIONS(2049),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(1997),
    [anon_sym_as] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(2049),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_const] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_EQ] = ACTIONS(2049),
    [anon_sym___global] = ACTIONS(2049),
    [anon_sym_type] = ACTIONS(2049),
    [anon_sym_fn] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_DASH] = ACTIONS(2005),
    [anon_sym_STAR] = ACTIONS(2007),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(2049),
    [anon_sym_union] = ACTIONS(2049),
    [anon_sym_pub] = ACTIONS(2049),
    [anon_sym_mut] = ACTIONS(2049),
    [anon_sym_enum] = ACTIONS(2049),
    [anon_sym_interface] = ACTIONS(2049),
    [anon_sym_PLUS_PLUS] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2017),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_go] = ACTIONS(2049),
    [anon_sym_spawn] = ACTIONS(2049),
    [anon_sym_json_DOTdecode] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_LBRACK2] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2049),
    [anon_sym_CARET] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_DASH] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2007),
    [anon_sym_GT_GT] = ACTIONS(2007),
    [anon_sym_GT_GT_GT] = ACTIONS(2007),
    [anon_sym_AMP_CARET] = ACTIONS(2007),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_or] = ACTIONS(2049),
    [sym_none] = ACTIONS(2049),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [sym_nil] = ACTIONS(2049),
    [anon_sym_QMARK_DOT] = ACTIONS(1997),
    [anon_sym_POUND_LBRACK] = ACTIONS(2021),
    [anon_sym_if] = ACTIONS(2049),
    [anon_sym_DOLLARif] = ACTIONS(2049),
    [anon_sym_is] = ACTIONS(2049),
    [anon_sym_BANGis] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_BANGin] = ACTIONS(2049),
    [anon_sym_match] = ACTIONS(2049),
    [anon_sym_select] = ACTIONS(2049),
    [anon_sym_STAR_EQ] = ACTIONS(2049),
    [anon_sym_SLASH_EQ] = ACTIONS(2049),
    [anon_sym_PERCENT_EQ] = ACTIONS(2049),
    [anon_sym_LT_LT_EQ] = ACTIONS(2049),
    [anon_sym_GT_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2049),
    [anon_sym_AMP_EQ] = ACTIONS(2049),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2049),
    [anon_sym_PLUS_EQ] = ACTIONS(2049),
    [anon_sym_DASH_EQ] = ACTIONS(2049),
    [anon_sym_PIPE_EQ] = ACTIONS(2049),
    [anon_sym_CARET_EQ] = ACTIONS(2049),
    [anon_sym_COLON_EQ] = ACTIONS(2049),
    [anon_sym_lock] = ACTIONS(2049),
    [anon_sym_rlock] = ACTIONS(2049),
    [anon_sym_unsafe] = ACTIONS(2049),
    [anon_sym_sql] = ACTIONS(2049),
    [sym_int_literal] = ACTIONS(2049),
    [sym_float_literal] = ACTIONS(2049),
    [sym_rune_literal] = ACTIONS(2049),
    [anon_sym_SQUOTE] = ACTIONS(2049),
    [anon_sym_DQUOTE] = ACTIONS(2049),
    [anon_sym_c_SQUOTE] = ACTIONS(2049),
    [anon_sym_c_DQUOTE] = ACTIONS(2049),
    [anon_sym_r_SQUOTE] = ACTIONS(2049),
    [anon_sym_r_DQUOTE] = ACTIONS(2049),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2049),
    [anon_sym_shared] = ACTIONS(2049),
    [anon_sym_map_LBRACK] = ACTIONS(2049),
    [anon_sym_chan] = ACTIONS(2049),
    [anon_sym_thread] = ACTIONS(2049),
    [anon_sym_atomic] = ACTIONS(2049),
    [anon_sym_assert] = ACTIONS(2049),
    [anon_sym_defer] = ACTIONS(2049),
    [anon_sym_goto] = ACTIONS(2049),
    [anon_sym_break] = ACTIONS(2049),
    [anon_sym_continue] = ACTIONS(2049),
    [anon_sym_return] = ACTIONS(2049),
    [anon_sym_DOLLARfor] = ACTIONS(2049),
    [anon_sym_for] = ACTIONS(2049),
    [anon_sym_POUND] = ACTIONS(2049),
    [anon_sym_asm] = ACTIONS(2049),
    [anon_sym_AT_LBRACK] = ACTIONS(2049),
  },
  [246] = {
    [sym_line_comment] = STATE(246),
    [sym_block_comment] = STATE(246),
    [sym_type_parameters] = STATE(4293),
    [sym_argument_list] = STATE(390),
    [sym_or_block] = STATE(389),
    [ts_builtin_sym_end] = ACTIONS(2051),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(1997),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_const] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym___global] = ACTIONS(2053),
    [anon_sym_type] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_DASH] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2007),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_union] = ACTIONS(2053),
    [anon_sym_pub] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_enum] = ACTIONS(2053),
    [anon_sym_interface] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2017),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_LBRACK2] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2007),
    [anon_sym_GT_GT] = ACTIONS(2007),
    [anon_sym_GT_GT_GT] = ACTIONS(2007),
    [anon_sym_AMP_CARET] = ACTIONS(2007),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(1997),
    [anon_sym_POUND_LBRACK] = ACTIONS(2021),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2053),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_STAR_EQ] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2053),
    [anon_sym_PERCENT_EQ] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2053),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2053),
    [anon_sym_PLUS_EQ] = ACTIONS(2053),
    [anon_sym_DASH_EQ] = ACTIONS(2053),
    [anon_sym_PIPE_EQ] = ACTIONS(2053),
    [anon_sym_CARET_EQ] = ACTIONS(2053),
    [anon_sym_COLON_EQ] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
    [anon_sym_AT_LBRACK] = ACTIONS(2053),
  },
  [247] = {
    [sym_line_comment] = STATE(247),
    [sym_block_comment] = STATE(247),
    [sym_type_parameters] = STATE(4293),
    [sym_argument_list] = STATE(390),
    [sym_or_block] = STATE(389),
    [ts_builtin_sym_end] = ACTIONS(2051),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(1997),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_const] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym___global] = ACTIONS(2053),
    [anon_sym_type] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_DASH] = ACTIONS(2005),
    [anon_sym_STAR] = ACTIONS(2007),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(2009),
    [anon_sym_BANG_EQ] = ACTIONS(2009),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2009),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_union] = ACTIONS(2053),
    [anon_sym_pub] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_enum] = ACTIONS(2053),
    [anon_sym_interface] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2017),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_LBRACK2] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2007),
    [anon_sym_GT_GT] = ACTIONS(2007),
    [anon_sym_GT_GT_GT] = ACTIONS(2007),
    [anon_sym_AMP_CARET] = ACTIONS(2007),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(1997),
    [anon_sym_POUND_LBRACK] = ACTIONS(2021),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2031),
    [anon_sym_BANGin] = ACTIONS(2031),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_STAR_EQ] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2053),
    [anon_sym_PERCENT_EQ] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2053),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2053),
    [anon_sym_PLUS_EQ] = ACTIONS(2053),
    [anon_sym_DASH_EQ] = ACTIONS(2053),
    [anon_sym_PIPE_EQ] = ACTIONS(2053),
    [anon_sym_CARET_EQ] = ACTIONS(2053),
    [anon_sym_COLON_EQ] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
    [anon_sym_AT_LBRACK] = ACTIONS(2053),
  },
  [248] = {
    [sym_line_comment] = STATE(248),
    [sym_block_comment] = STATE(248),
    [sym_type_parameters] = STATE(4293),
    [sym_argument_list] = STATE(390),
    [sym_or_block] = STATE(389),
    [ts_builtin_sym_end] = ACTIONS(2055),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_LF] = ACTIONS(2057),
    [anon_sym_CR] = ACTIONS(2057),
    [anon_sym_CR_LF] = ACTIONS(2057),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(1997),
    [anon_sym_as] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2057),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_EQ] = ACTIONS(2057),
    [anon_sym___global] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_fn] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_PERCENT] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_GT] = ACTIONS(2057),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2057),
    [anon_sym_LT_EQ] = ACTIONS(2057),
    [anon_sym_GT_EQ] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(2057),
    [anon_sym_union] = ACTIONS(2057),
    [anon_sym_pub] = ACTIONS(2057),
    [anon_sym_mut] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [anon_sym_QMARK] = ACTIONS(2017),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_go] = ACTIONS(2057),
    [anon_sym_spawn] = ACTIONS(2057),
    [anon_sym_json_DOTdecode] = ACTIONS(2057),
    [anon_sym_PIPE] = ACTIONS(2057),
    [anon_sym_LBRACK2] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_CARET] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2057),
    [anon_sym_LT_DASH] = ACTIONS(2057),
    [anon_sym_LT_LT] = ACTIONS(2057),
    [anon_sym_GT_GT] = ACTIONS(2057),
    [anon_sym_GT_GT_GT] = ACTIONS(2057),
    [anon_sym_AMP_CARET] = ACTIONS(2057),
    [anon_sym_AMP_AMP] = ACTIONS(2057),
    [anon_sym_PIPE_PIPE] = ACTIONS(2057),
    [anon_sym_or] = ACTIONS(2057),
    [sym_none] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_nil] = ACTIONS(2057),
    [anon_sym_QMARK_DOT] = ACTIONS(1997),
    [anon_sym_POUND_LBRACK] = ACTIONS(2021),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_DOLLARif] = ACTIONS(2057),
    [anon_sym_is] = ACTIONS(2057),
    [anon_sym_BANGis] = ACTIONS(2057),
    [anon_sym_in] = ACTIONS(2057),
    [anon_sym_BANGin] = ACTIONS(2057),
    [anon_sym_match] = ACTIONS(2057),
    [anon_sym_select] = ACTIONS(2057),
    [anon_sym_STAR_EQ] = ACTIONS(2057),
    [anon_sym_SLASH_EQ] = ACTIONS(2057),
    [anon_sym_PERCENT_EQ] = ACTIONS(2057),
    [anon_sym_LT_LT_EQ] = ACTIONS(2057),
    [anon_sym_GT_GT_EQ] = ACTIONS(2057),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2057),
    [anon_sym_AMP_EQ] = ACTIONS(2057),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2057),
    [anon_sym_PLUS_EQ] = ACTIONS(2057),
    [anon_sym_DASH_EQ] = ACTIONS(2057),
    [anon_sym_PIPE_EQ] = ACTIONS(2057),
    [anon_sym_CARET_EQ] = ACTIONS(2057),
    [anon_sym_COLON_EQ] = ACTIONS(2057),
    [anon_sym_lock] = ACTIONS(2057),
    [anon_sym_rlock] = ACTIONS(2057),
    [anon_sym_unsafe] = ACTIONS(2057),
    [anon_sym_sql] = ACTIONS(2057),
    [sym_int_literal] = ACTIONS(2057),
    [sym_float_literal] = ACTIONS(2057),
    [sym_rune_literal] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_c_SQUOTE] = ACTIONS(2057),
    [anon_sym_c_DQUOTE] = ACTIONS(2057),
    [anon_sym_r_SQUOTE] = ACTIONS(2057),
    [anon_sym_r_DQUOTE] = ACTIONS(2057),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2057),
    [anon_sym_shared] = ACTIONS(2057),
    [anon_sym_map_LBRACK] = ACTIONS(2057),
    [anon_sym_chan] = ACTIONS(2057),
    [anon_sym_thread] = ACTIONS(2057),
    [anon_sym_atomic] = ACTIONS(2057),
    [anon_sym_assert] = ACTIONS(2057),
    [anon_sym_defer] = ACTIONS(2057),
    [anon_sym_goto] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_DOLLARfor] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_POUND] = ACTIONS(2057),
    [anon_sym_asm] = ACTIONS(2057),
    [anon_sym_AT_LBRACK] = ACTIONS(2057),
  },
  [249] = {
    [sym_line_comment] = STATE(249),
    [sym_block_comment] = STATE(249),
    [sym_type_parameters] = STATE(4293),
    [sym_argument_list] = STATE(390),
    [sym_or_block] = STATE(389),
    [ts_builtin_sym_end] = ACTIONS(2059),
    [sym_identifier] = ACTIONS(2061),
    [anon_sym_LF] = ACTIONS(2061),
    [anon_sym_CR] = ACTIONS(2061),
    [anon_sym_CR_LF] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(1997),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_LBRACE] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_const] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_EQ] = ACTIONS(2061),
    [anon_sym___global] = ACTIONS(2061),
    [anon_sym_type] = ACTIONS(2061),
    [anon_sym_fn] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2061),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(2061),
    [anon_sym_union] = ACTIONS(2061),
    [anon_sym_pub] = ACTIONS(2061),
    [anon_sym_mut] = ACTIONS(2061),
    [anon_sym_enum] = ACTIONS(2061),
    [anon_sym_interface] = ACTIONS(2061),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_QMARK] = ACTIONS(2017),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_go] = ACTIONS(2061),
    [anon_sym_spawn] = ACTIONS(2061),
    [anon_sym_json_DOTdecode] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_LBRACK2] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_LT_DASH] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_GT_GT_GT] = ACTIONS(2061),
    [anon_sym_AMP_CARET] = ACTIONS(2061),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [sym_none] = ACTIONS(2061),
    [sym_true] = ACTIONS(2061),
    [sym_false] = ACTIONS(2061),
    [sym_nil] = ACTIONS(2061),
    [anon_sym_QMARK_DOT] = ACTIONS(1997),
    [anon_sym_POUND_LBRACK] = ACTIONS(2021),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_DOLLARif] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_BANGis] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_BANGin] = ACTIONS(2061),
    [anon_sym_match] = ACTIONS(2061),
    [anon_sym_select] = ACTIONS(2061),
    [anon_sym_STAR_EQ] = ACTIONS(2061),
    [anon_sym_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_PERCENT_EQ] = ACTIONS(2061),
    [anon_sym_LT_LT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_AMP_EQ] = ACTIONS(2061),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2061),
    [anon_sym_PLUS_EQ] = ACTIONS(2061),
    [anon_sym_DASH_EQ] = ACTIONS(2061),
    [anon_sym_PIPE_EQ] = ACTIONS(2061),
    [anon_sym_CARET_EQ] = ACTIONS(2061),
    [anon_sym_COLON_EQ] = ACTIONS(2061),
    [anon_sym_lock] = ACTIONS(2061),
    [anon_sym_rlock] = ACTIONS(2061),
    [anon_sym_unsafe] = ACTIONS(2061),
    [anon_sym_sql] = ACTIONS(2061),
    [sym_int_literal] = ACTIONS(2061),
    [sym_float_literal] = ACTIONS(2061),
    [sym_rune_literal] = ACTIONS(2061),
    [anon_sym_SQUOTE] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(2061),
    [anon_sym_c_SQUOTE] = ACTIONS(2061),
    [anon_sym_c_DQUOTE] = ACTIONS(2061),
    [anon_sym_r_SQUOTE] = ACTIONS(2061),
    [anon_sym_r_DQUOTE] = ACTIONS(2061),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2061),
    [anon_sym_shared] = ACTIONS(2061),
    [anon_sym_map_LBRACK] = ACTIONS(2061),
    [anon_sym_chan] = ACTIONS(2061),
    [anon_sym_thread] = ACTIONS(2061),
    [anon_sym_atomic] = ACTIONS(2061),
    [anon_sym_assert] = ACTIONS(2061),
    [anon_sym_defer] = ACTIONS(2061),
    [anon_sym_goto] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2061),
    [anon_sym_continue] = ACTIONS(2061),
    [anon_sym_return] = ACTIONS(2061),
    [anon_sym_DOLLARfor] = ACTIONS(2061),
    [anon_sym_for] = ACTIONS(2061),
    [anon_sym_POUND] = ACTIONS(2061),
    [anon_sym_asm] = ACTIONS(2061),
    [anon_sym_AT_LBRACK] = ACTIONS(2061),
  },
  [250] = {
    [sym_line_comment] = STATE(250),
    [sym_block_comment] = STATE(250),
    [sym_type_parameters] = STATE(4293),
    [sym_argument_list] = STATE(390),
    [sym_or_block] = STATE(389),
    [ts_builtin_sym_end] = ACTIONS(2051),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(1997),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_const] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym___global] = ACTIONS(2053),
    [anon_sym_type] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_DASH] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_SLASH] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_union] = ACTIONS(2053),
    [anon_sym_pub] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_enum] = ACTIONS(2053),
    [anon_sym_interface] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2017),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_LBRACK2] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_GT_GT_GT] = ACTIONS(2053),
    [anon_sym_AMP_CARET] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(1997),
    [anon_sym_POUND_LBRACK] = ACTIONS(2021),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2053),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_STAR_EQ] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2053),
    [anon_sym_PERCENT_EQ] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2053),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2053),
    [anon_sym_PLUS_EQ] = ACTIONS(2053),
    [anon_sym_DASH_EQ] = ACTIONS(2053),
    [anon_sym_PIPE_EQ] = ACTIONS(2053),
    [anon_sym_CARET_EQ] = ACTIONS(2053),
    [anon_sym_COLON_EQ] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
    [anon_sym_AT_LBRACK] = ACTIONS(2053),
  },
  [251] = {
    [sym_line_comment] = STATE(251),
    [sym_block_comment] = STATE(251),
    [sym_type_parameters] = STATE(4293),
    [sym_argument_list] = STATE(390),
    [sym_or_block] = STATE(389),
    [ts_builtin_sym_end] = ACTIONS(2063),
    [sym_identifier] = ACTIONS(2065),
    [anon_sym_LF] = ACTIONS(2065),
    [anon_sym_CR] = ACTIONS(2065),
    [anon_sym_CR_LF] = ACTIONS(2065),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(1997),
    [anon_sym_as] = ACTIONS(1999),
    [anon_sym_LBRACE] = ACTIONS(2065),
    [anon_sym_COMMA] = ACTIONS(2065),
    [anon_sym_const] = ACTIONS(2065),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_EQ] = ACTIONS(2065),
    [anon_sym___global] = ACTIONS(2065),
    [anon_sym_type] = ACTIONS(2065),
    [anon_sym_fn] = ACTIONS(2065),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_DASH] = ACTIONS(2005),
    [anon_sym_STAR] = ACTIONS(2007),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(2009),
    [anon_sym_BANG_EQ] = ACTIONS(2009),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2009),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(2065),
    [anon_sym_union] = ACTIONS(2065),
    [anon_sym_pub] = ACTIONS(2065),
    [anon_sym_mut] = ACTIONS(2065),
    [anon_sym_enum] = ACTIONS(2065),
    [anon_sym_interface] = ACTIONS(2065),
    [anon_sym_PLUS_PLUS] = ACTIONS(2013),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_QMARK] = ACTIONS(2017),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_go] = ACTIONS(2065),
    [anon_sym_spawn] = ACTIONS(2065),
    [anon_sym_json_DOTdecode] = ACTIONS(2065),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_LBRACK2] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2065),
    [anon_sym_CARET] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_DASH] = ACTIONS(2065),
    [anon_sym_LT_LT] = ACTIONS(2007),
    [anon_sym_GT_GT] = ACTIONS(2007),
    [anon_sym_GT_GT_GT] = ACTIONS(2007),
    [anon_sym_AMP_CARET] = ACTIONS(2007),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_PIPE_PIPE] = ACTIONS(2025),
    [anon_sym_or] = ACTIONS(2027),
    [sym_none] = ACTIONS(2065),
    [sym_true] = ACTIONS(2065),
    [sym_false] = ACTIONS(2065),
    [sym_nil] = ACTIONS(2065),
    [anon_sym_QMARK_DOT] = ACTIONS(1997),
    [anon_sym_POUND_LBRACK] = ACTIONS(2021),
    [anon_sym_if] = ACTIONS(2065),
    [anon_sym_DOLLARif] = ACTIONS(2065),
    [anon_sym_is] = ACTIONS(2029),
    [anon_sym_BANGis] = ACTIONS(2029),
    [anon_sym_in] = ACTIONS(2031),
    [anon_sym_BANGin] = ACTIONS(2031),
    [anon_sym_match] = ACTIONS(2065),
    [anon_sym_select] = ACTIONS(2065),
    [anon_sym_STAR_EQ] = ACTIONS(2065),
    [anon_sym_SLASH_EQ] = ACTIONS(2065),
    [anon_sym_PERCENT_EQ] = ACTIONS(2065),
    [anon_sym_LT_LT_EQ] = ACTIONS(2065),
    [anon_sym_GT_GT_EQ] = ACTIONS(2065),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2065),
    [anon_sym_AMP_EQ] = ACTIONS(2065),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2065),
    [anon_sym_PLUS_EQ] = ACTIONS(2065),
    [anon_sym_DASH_EQ] = ACTIONS(2065),
    [anon_sym_PIPE_EQ] = ACTIONS(2065),
    [anon_sym_CARET_EQ] = ACTIONS(2065),
    [anon_sym_COLON_EQ] = ACTIONS(2065),
    [anon_sym_lock] = ACTIONS(2065),
    [anon_sym_rlock] = ACTIONS(2065),
    [anon_sym_unsafe] = ACTIONS(2065),
    [anon_sym_sql] = ACTIONS(2065),
    [sym_int_literal] = ACTIONS(2065),
    [sym_float_literal] = ACTIONS(2065),
    [sym_rune_literal] = ACTIONS(2065),
    [anon_sym_SQUOTE] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2065),
    [anon_sym_c_SQUOTE] = ACTIONS(2065),
    [anon_sym_c_DQUOTE] = ACTIONS(2065),
    [anon_sym_r_SQUOTE] = ACTIONS(2065),
    [anon_sym_r_DQUOTE] = ACTIONS(2065),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2065),
    [anon_sym_shared] = ACTIONS(2065),
    [anon_sym_map_LBRACK] = ACTIONS(2065),
    [anon_sym_chan] = ACTIONS(2065),
    [anon_sym_thread] = ACTIONS(2065),
    [anon_sym_atomic] = ACTIONS(2065),
    [anon_sym_assert] = ACTIONS(2065),
    [anon_sym_defer] = ACTIONS(2065),
    [anon_sym_goto] = ACTIONS(2065),
    [anon_sym_break] = ACTIONS(2065),
    [anon_sym_continue] = ACTIONS(2065),
    [anon_sym_return] = ACTIONS(2065),
    [anon_sym_DOLLARfor] = ACTIONS(2065),
    [anon_sym_for] = ACTIONS(2065),
    [anon_sym_POUND] = ACTIONS(2065),
    [anon_sym_asm] = ACTIONS(2065),
    [anon_sym_AT_LBRACK] = ACTIONS(2065),
  },
  [252] = {
    [sym_line_comment] = STATE(252),
    [sym_block_comment] = STATE(252),
    [sym_type_parameters] = STATE(4293),
    [sym_argument_list] = STATE(390),
    [sym_or_block] = STATE(389),
    [ts_builtin_sym_end] = ACTIONS(2067),
    [sym_identifier] = ACTIONS(2069),
    [anon_sym_LF] = ACTIONS(2069),
    [anon_sym_CR] = ACTIONS(2069),
    [anon_sym_CR_LF] = ACTIONS(2069),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(1997),
    [anon_sym_as] = ACTIONS(1999),
    [anon_sym_LBRACE] = ACTIONS(2069),
    [anon_sym_COMMA] = ACTIONS(2069),
    [anon_sym_const] = ACTIONS(2069),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_EQ] = ACTIONS(2069),
    [anon_sym___global] = ACTIONS(2069),
    [anon_sym_type] = ACTIONS(2069),
    [anon_sym_fn] = ACTIONS(2069),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_DASH] = ACTIONS(2005),
    [anon_sym_STAR] = ACTIONS(2007),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(2009),
    [anon_sym_BANG_EQ] = ACTIONS(2009),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2009),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(2069),
    [anon_sym_union] = ACTIONS(2069),
    [anon_sym_pub] = ACTIONS(2069),
    [anon_sym_mut] = ACTIONS(2069),
    [anon_sym_enum] = ACTIONS(2069),
    [anon_sym_interface] = ACTIONS(2069),
    [anon_sym_PLUS_PLUS] = ACTIONS(2013),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_QMARK] = ACTIONS(2017),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_go] = ACTIONS(2069),
    [anon_sym_spawn] = ACTIONS(2069),
    [anon_sym_json_DOTdecode] = ACTIONS(2069),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_LBRACK2] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2069),
    [anon_sym_CARET] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_DASH] = ACTIONS(2069),
    [anon_sym_LT_LT] = ACTIONS(2007),
    [anon_sym_GT_GT] = ACTIONS(2007),
    [anon_sym_GT_GT_GT] = ACTIONS(2007),
    [anon_sym_AMP_CARET] = ACTIONS(2007),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_PIPE_PIPE] = ACTIONS(2025),
    [anon_sym_or] = ACTIONS(2027),
    [sym_none] = ACTIONS(2069),
    [sym_true] = ACTIONS(2069),
    [sym_false] = ACTIONS(2069),
    [sym_nil] = ACTIONS(2069),
    [anon_sym_QMARK_DOT] = ACTIONS(1997),
    [anon_sym_POUND_LBRACK] = ACTIONS(2021),
    [anon_sym_if] = ACTIONS(2069),
    [anon_sym_DOLLARif] = ACTIONS(2069),
    [anon_sym_is] = ACTIONS(2071),
    [anon_sym_BANGis] = ACTIONS(2071),
    [anon_sym_in] = ACTIONS(2031),
    [anon_sym_BANGin] = ACTIONS(2031),
    [anon_sym_match] = ACTIONS(2069),
    [anon_sym_select] = ACTIONS(2069),
    [anon_sym_STAR_EQ] = ACTIONS(2069),
    [anon_sym_SLASH_EQ] = ACTIONS(2069),
    [anon_sym_PERCENT_EQ] = ACTIONS(2069),
    [anon_sym_LT_LT_EQ] = ACTIONS(2069),
    [anon_sym_GT_GT_EQ] = ACTIONS(2069),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2069),
    [anon_sym_AMP_EQ] = ACTIONS(2069),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2069),
    [anon_sym_PLUS_EQ] = ACTIONS(2069),
    [anon_sym_DASH_EQ] = ACTIONS(2069),
    [anon_sym_PIPE_EQ] = ACTIONS(2069),
    [anon_sym_CARET_EQ] = ACTIONS(2069),
    [anon_sym_COLON_EQ] = ACTIONS(2069),
    [anon_sym_lock] = ACTIONS(2069),
    [anon_sym_rlock] = ACTIONS(2069),
    [anon_sym_unsafe] = ACTIONS(2069),
    [anon_sym_sql] = ACTIONS(2069),
    [sym_int_literal] = ACTIONS(2069),
    [sym_float_literal] = ACTIONS(2069),
    [sym_rune_literal] = ACTIONS(2069),
    [anon_sym_SQUOTE] = ACTIONS(2069),
    [anon_sym_DQUOTE] = ACTIONS(2069),
    [anon_sym_c_SQUOTE] = ACTIONS(2069),
    [anon_sym_c_DQUOTE] = ACTIONS(2069),
    [anon_sym_r_SQUOTE] = ACTIONS(2069),
    [anon_sym_r_DQUOTE] = ACTIONS(2069),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2069),
    [anon_sym_shared] = ACTIONS(2069),
    [anon_sym_map_LBRACK] = ACTIONS(2069),
    [anon_sym_chan] = ACTIONS(2069),
    [anon_sym_thread] = ACTIONS(2069),
    [anon_sym_atomic] = ACTIONS(2069),
    [anon_sym_assert] = ACTIONS(2069),
    [anon_sym_defer] = ACTIONS(2069),
    [anon_sym_goto] = ACTIONS(2069),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_continue] = ACTIONS(2069),
    [anon_sym_return] = ACTIONS(2069),
    [anon_sym_DOLLARfor] = ACTIONS(2069),
    [anon_sym_for] = ACTIONS(2069),
    [anon_sym_POUND] = ACTIONS(2069),
    [anon_sym_asm] = ACTIONS(2069),
    [anon_sym_AT_LBRACK] = ACTIONS(2069),
  },
  [253] = {
    [sym_line_comment] = STATE(253),
    [sym_block_comment] = STATE(253),
    [sym_type_parameters] = STATE(4293),
    [sym_argument_list] = STATE(390),
    [sym_or_block] = STATE(389),
    [ts_builtin_sym_end] = ACTIONS(2051),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(1997),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_const] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym___global] = ACTIONS(2053),
    [anon_sym_type] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_DASH] = ACTIONS(2005),
    [anon_sym_STAR] = ACTIONS(2007),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_union] = ACTIONS(2053),
    [anon_sym_pub] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_enum] = ACTIONS(2053),
    [anon_sym_interface] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2017),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_LBRACK2] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2007),
    [anon_sym_GT_GT] = ACTIONS(2007),
    [anon_sym_GT_GT_GT] = ACTIONS(2007),
    [anon_sym_AMP_CARET] = ACTIONS(2007),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(1997),
    [anon_sym_POUND_LBRACK] = ACTIONS(2021),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2053),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_STAR_EQ] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2053),
    [anon_sym_PERCENT_EQ] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2053),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2053),
    [anon_sym_PLUS_EQ] = ACTIONS(2053),
    [anon_sym_DASH_EQ] = ACTIONS(2053),
    [anon_sym_PIPE_EQ] = ACTIONS(2053),
    [anon_sym_CARET_EQ] = ACTIONS(2053),
    [anon_sym_COLON_EQ] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
    [anon_sym_AT_LBRACK] = ACTIONS(2053),
  },
  [254] = {
    [sym_line_comment] = STATE(254),
    [sym_block_comment] = STATE(254),
    [sym_type_parameters] = STATE(4293),
    [sym_argument_list] = STATE(390),
    [sym_or_block] = STATE(389),
    [ts_builtin_sym_end] = ACTIONS(2073),
    [sym_identifier] = ACTIONS(2075),
    [anon_sym_LF] = ACTIONS(2075),
    [anon_sym_CR] = ACTIONS(2075),
    [anon_sym_CR_LF] = ACTIONS(2075),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(1997),
    [anon_sym_as] = ACTIONS(1999),
    [anon_sym_LBRACE] = ACTIONS(2075),
    [anon_sym_COMMA] = ACTIONS(2075),
    [anon_sym_const] = ACTIONS(2075),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_EQ] = ACTIONS(2075),
    [anon_sym___global] = ACTIONS(2075),
    [anon_sym_type] = ACTIONS(2075),
    [anon_sym_fn] = ACTIONS(2075),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_DASH] = ACTIONS(2005),
    [anon_sym_STAR] = ACTIONS(2007),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(2009),
    [anon_sym_BANG_EQ] = ACTIONS(2009),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2009),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(2075),
    [anon_sym_union] = ACTIONS(2075),
    [anon_sym_pub] = ACTIONS(2075),
    [anon_sym_mut] = ACTIONS(2075),
    [anon_sym_enum] = ACTIONS(2075),
    [anon_sym_interface] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2013),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_QMARK] = ACTIONS(2017),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_go] = ACTIONS(2075),
    [anon_sym_spawn] = ACTIONS(2075),
    [anon_sym_json_DOTdecode] = ACTIONS(2075),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_LBRACK2] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_CARET] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_DASH] = ACTIONS(2075),
    [anon_sym_LT_LT] = ACTIONS(2007),
    [anon_sym_GT_GT] = ACTIONS(2007),
    [anon_sym_GT_GT_GT] = ACTIONS(2007),
    [anon_sym_AMP_CARET] = ACTIONS(2007),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_PIPE_PIPE] = ACTIONS(2025),
    [anon_sym_or] = ACTIONS(2027),
    [sym_none] = ACTIONS(2075),
    [sym_true] = ACTIONS(2075),
    [sym_false] = ACTIONS(2075),
    [sym_nil] = ACTIONS(2075),
    [anon_sym_QMARK_DOT] = ACTIONS(1997),
    [anon_sym_POUND_LBRACK] = ACTIONS(2021),
    [anon_sym_if] = ACTIONS(2075),
    [anon_sym_DOLLARif] = ACTIONS(2075),
    [anon_sym_is] = ACTIONS(2029),
    [anon_sym_BANGis] = ACTIONS(2029),
    [anon_sym_in] = ACTIONS(2031),
    [anon_sym_BANGin] = ACTIONS(2031),
    [anon_sym_match] = ACTIONS(2075),
    [anon_sym_select] = ACTIONS(2075),
    [anon_sym_STAR_EQ] = ACTIONS(2075),
    [anon_sym_SLASH_EQ] = ACTIONS(2075),
    [anon_sym_PERCENT_EQ] = ACTIONS(2075),
    [anon_sym_LT_LT_EQ] = ACTIONS(2075),
    [anon_sym_GT_GT_EQ] = ACTIONS(2075),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2075),
    [anon_sym_AMP_EQ] = ACTIONS(2075),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2075),
    [anon_sym_PLUS_EQ] = ACTIONS(2075),
    [anon_sym_DASH_EQ] = ACTIONS(2075),
    [anon_sym_PIPE_EQ] = ACTIONS(2075),
    [anon_sym_CARET_EQ] = ACTIONS(2075),
    [anon_sym_COLON_EQ] = ACTIONS(2075),
    [anon_sym_lock] = ACTIONS(2075),
    [anon_sym_rlock] = ACTIONS(2075),
    [anon_sym_unsafe] = ACTIONS(2075),
    [anon_sym_sql] = ACTIONS(2075),
    [sym_int_literal] = ACTIONS(2075),
    [sym_float_literal] = ACTIONS(2075),
    [sym_rune_literal] = ACTIONS(2075),
    [anon_sym_SQUOTE] = ACTIONS(2075),
    [anon_sym_DQUOTE] = ACTIONS(2075),
    [anon_sym_c_SQUOTE] = ACTIONS(2075),
    [anon_sym_c_DQUOTE] = ACTIONS(2075),
    [anon_sym_r_SQUOTE] = ACTIONS(2075),
    [anon_sym_r_DQUOTE] = ACTIONS(2075),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2075),
    [anon_sym_shared] = ACTIONS(2075),
    [anon_sym_map_LBRACK] = ACTIONS(2075),
    [anon_sym_chan] = ACTIONS(2075),
    [anon_sym_thread] = ACTIONS(2075),
    [anon_sym_atomic] = ACTIONS(2075),
    [anon_sym_assert] = ACTIONS(2075),
    [anon_sym_defer] = ACTIONS(2075),
    [anon_sym_goto] = ACTIONS(2075),
    [anon_sym_break] = ACTIONS(2075),
    [anon_sym_continue] = ACTIONS(2075),
    [anon_sym_return] = ACTIONS(2075),
    [anon_sym_DOLLARfor] = ACTIONS(2075),
    [anon_sym_for] = ACTIONS(2075),
    [anon_sym_POUND] = ACTIONS(2075),
    [anon_sym_asm] = ACTIONS(2075),
    [anon_sym_AT_LBRACK] = ACTIONS(2075),
  },
  [255] = {
    [sym_line_comment] = STATE(255),
    [sym_block_comment] = STATE(255),
    [sym_type_parameters] = STATE(4293),
    [sym_argument_list] = STATE(390),
    [sym_or_block] = STATE(389),
    [ts_builtin_sym_end] = ACTIONS(2077),
    [sym_identifier] = ACTIONS(2079),
    [anon_sym_LF] = ACTIONS(2079),
    [anon_sym_CR] = ACTIONS(2079),
    [anon_sym_CR_LF] = ACTIONS(2079),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(1997),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2079),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_const] = ACTIONS(2079),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym___global] = ACTIONS(2079),
    [anon_sym_type] = ACTIONS(2079),
    [anon_sym_fn] = ACTIONS(2079),
    [anon_sym_PLUS] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2079),
    [anon_sym_STAR] = ACTIONS(2079),
    [anon_sym_SLASH] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(2079),
    [anon_sym_union] = ACTIONS(2079),
    [anon_sym_pub] = ACTIONS(2079),
    [anon_sym_mut] = ACTIONS(2079),
    [anon_sym_enum] = ACTIONS(2079),
    [anon_sym_interface] = ACTIONS(2079),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2017),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_go] = ACTIONS(2079),
    [anon_sym_spawn] = ACTIONS(2079),
    [anon_sym_json_DOTdecode] = ACTIONS(2079),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_LBRACK2] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_CARET] = ACTIONS(2079),
    [anon_sym_AMP] = ACTIONS(2079),
    [anon_sym_LT_DASH] = ACTIONS(2079),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_GT_GT_GT] = ACTIONS(2053),
    [anon_sym_AMP_CARET] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2079),
    [sym_true] = ACTIONS(2079),
    [sym_false] = ACTIONS(2079),
    [sym_nil] = ACTIONS(2079),
    [anon_sym_QMARK_DOT] = ACTIONS(1997),
    [anon_sym_POUND_LBRACK] = ACTIONS(2021),
    [anon_sym_if] = ACTIONS(2079),
    [anon_sym_DOLLARif] = ACTIONS(2079),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2053),
    [anon_sym_match] = ACTIONS(2079),
    [anon_sym_select] = ACTIONS(2079),
    [anon_sym_STAR_EQ] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2053),
    [anon_sym_PERCENT_EQ] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2053),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2053),
    [anon_sym_PLUS_EQ] = ACTIONS(2053),
    [anon_sym_DASH_EQ] = ACTIONS(2053),
    [anon_sym_PIPE_EQ] = ACTIONS(2053),
    [anon_sym_CARET_EQ] = ACTIONS(2053),
    [anon_sym_COLON_EQ] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2079),
    [anon_sym_rlock] = ACTIONS(2079),
    [anon_sym_unsafe] = ACTIONS(2079),
    [anon_sym_sql] = ACTIONS(2079),
    [sym_int_literal] = ACTIONS(2079),
    [sym_float_literal] = ACTIONS(2079),
    [sym_rune_literal] = ACTIONS(2079),
    [anon_sym_SQUOTE] = ACTIONS(2079),
    [anon_sym_DQUOTE] = ACTIONS(2079),
    [anon_sym_c_SQUOTE] = ACTIONS(2079),
    [anon_sym_c_DQUOTE] = ACTIONS(2079),
    [anon_sym_r_SQUOTE] = ACTIONS(2079),
    [anon_sym_r_DQUOTE] = ACTIONS(2079),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2079),
    [anon_sym_shared] = ACTIONS(2079),
    [anon_sym_map_LBRACK] = ACTIONS(2079),
    [anon_sym_chan] = ACTIONS(2079),
    [anon_sym_thread] = ACTIONS(2079),
    [anon_sym_atomic] = ACTIONS(2079),
    [anon_sym_assert] = ACTIONS(2079),
    [anon_sym_defer] = ACTIONS(2079),
    [anon_sym_goto] = ACTIONS(2079),
    [anon_sym_break] = ACTIONS(2079),
    [anon_sym_continue] = ACTIONS(2079),
    [anon_sym_return] = ACTIONS(2079),
    [anon_sym_DOLLARfor] = ACTIONS(2079),
    [anon_sym_for] = ACTIONS(2079),
    [anon_sym_POUND] = ACTIONS(2079),
    [anon_sym_asm] = ACTIONS(2079),
    [anon_sym_AT_LBRACK] = ACTIONS(2079),
  },
  [256] = {
    [sym_line_comment] = STATE(256),
    [sym_block_comment] = STATE(256),
    [sym_type_parameters] = STATE(4293),
    [sym_argument_list] = STATE(390),
    [sym_or_block] = STATE(389),
    [ts_builtin_sym_end] = ACTIONS(2051),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(1997),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_const] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym___global] = ACTIONS(2053),
    [anon_sym_type] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_DASH] = ACTIONS(2005),
    [anon_sym_STAR] = ACTIONS(2007),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(2009),
    [anon_sym_BANG_EQ] = ACTIONS(2009),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2009),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_union] = ACTIONS(2053),
    [anon_sym_pub] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_enum] = ACTIONS(2053),
    [anon_sym_interface] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2017),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_LBRACK2] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2007),
    [anon_sym_GT_GT] = ACTIONS(2007),
    [anon_sym_GT_GT_GT] = ACTIONS(2007),
    [anon_sym_AMP_CARET] = ACTIONS(2007),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(1997),
    [anon_sym_POUND_LBRACK] = ACTIONS(2021),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2031),
    [anon_sym_BANGin] = ACTIONS(2031),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_STAR_EQ] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2053),
    [anon_sym_PERCENT_EQ] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2053),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2053),
    [anon_sym_PLUS_EQ] = ACTIONS(2053),
    [anon_sym_DASH_EQ] = ACTIONS(2053),
    [anon_sym_PIPE_EQ] = ACTIONS(2053),
    [anon_sym_CARET_EQ] = ACTIONS(2053),
    [anon_sym_COLON_EQ] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
    [anon_sym_AT_LBRACK] = ACTIONS(2053),
  },
  [257] = {
    [sym_line_comment] = STATE(257),
    [sym_block_comment] = STATE(257),
    [sym_else_branch] = STATE(524),
    [ts_builtin_sym_end] = ACTIONS(2081),
    [sym_identifier] = ACTIONS(2083),
    [anon_sym_LF] = ACTIONS(2083),
    [anon_sym_CR] = ACTIONS(2083),
    [anon_sym_CR_LF] = ACTIONS(2083),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2083),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(2083),
    [anon_sym_COMMA] = ACTIONS(2083),
    [anon_sym_const] = ACTIONS(2083),
    [anon_sym_LPAREN] = ACTIONS(2083),
    [anon_sym_EQ] = ACTIONS(2083),
    [anon_sym___global] = ACTIONS(2083),
    [anon_sym_type] = ACTIONS(2083),
    [anon_sym_fn] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2083),
    [anon_sym_SLASH] = ACTIONS(2083),
    [anon_sym_PERCENT] = ACTIONS(2083),
    [anon_sym_LT] = ACTIONS(2083),
    [anon_sym_GT] = ACTIONS(2083),
    [anon_sym_EQ_EQ] = ACTIONS(2083),
    [anon_sym_BANG_EQ] = ACTIONS(2083),
    [anon_sym_LT_EQ] = ACTIONS(2083),
    [anon_sym_GT_EQ] = ACTIONS(2083),
    [anon_sym_LBRACK] = ACTIONS(2081),
    [anon_sym_struct] = ACTIONS(2083),
    [anon_sym_union] = ACTIONS(2083),
    [anon_sym_pub] = ACTIONS(2083),
    [anon_sym_mut] = ACTIONS(2083),
    [anon_sym_enum] = ACTIONS(2083),
    [anon_sym_interface] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_QMARK] = ACTIONS(2083),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_go] = ACTIONS(2083),
    [anon_sym_spawn] = ACTIONS(2083),
    [anon_sym_json_DOTdecode] = ACTIONS(2083),
    [anon_sym_PIPE] = ACTIONS(2083),
    [anon_sym_LBRACK2] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_LT_DASH] = ACTIONS(2083),
    [anon_sym_LT_LT] = ACTIONS(2083),
    [anon_sym_GT_GT] = ACTIONS(2083),
    [anon_sym_GT_GT_GT] = ACTIONS(2083),
    [anon_sym_AMP_CARET] = ACTIONS(2083),
    [anon_sym_AMP_AMP] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(2083),
    [anon_sym_or] = ACTIONS(2083),
    [sym_none] = ACTIONS(2083),
    [sym_true] = ACTIONS(2083),
    [sym_false] = ACTIONS(2083),
    [sym_nil] = ACTIONS(2083),
    [anon_sym_QMARK_DOT] = ACTIONS(2083),
    [anon_sym_POUND_LBRACK] = ACTIONS(2083),
    [anon_sym_if] = ACTIONS(2083),
    [anon_sym_else] = ACTIONS(2085),
    [anon_sym_DOLLARif] = ACTIONS(2083),
    [anon_sym_is] = ACTIONS(2083),
    [anon_sym_BANGis] = ACTIONS(2083),
    [anon_sym_in] = ACTIONS(2083),
    [anon_sym_BANGin] = ACTIONS(2083),
    [anon_sym_match] = ACTIONS(2083),
    [anon_sym_select] = ACTIONS(2083),
    [anon_sym_STAR_EQ] = ACTIONS(2083),
    [anon_sym_SLASH_EQ] = ACTIONS(2083),
    [anon_sym_PERCENT_EQ] = ACTIONS(2083),
    [anon_sym_LT_LT_EQ] = ACTIONS(2083),
    [anon_sym_GT_GT_EQ] = ACTIONS(2083),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2083),
    [anon_sym_AMP_EQ] = ACTIONS(2083),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2083),
    [anon_sym_PLUS_EQ] = ACTIONS(2083),
    [anon_sym_DASH_EQ] = ACTIONS(2083),
    [anon_sym_PIPE_EQ] = ACTIONS(2083),
    [anon_sym_CARET_EQ] = ACTIONS(2083),
    [anon_sym_COLON_EQ] = ACTIONS(2083),
    [anon_sym_lock] = ACTIONS(2083),
    [anon_sym_rlock] = ACTIONS(2083),
    [anon_sym_unsafe] = ACTIONS(2083),
    [anon_sym_sql] = ACTIONS(2083),
    [sym_int_literal] = ACTIONS(2083),
    [sym_float_literal] = ACTIONS(2083),
    [sym_rune_literal] = ACTIONS(2083),
    [anon_sym_SQUOTE] = ACTIONS(2083),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_c_SQUOTE] = ACTIONS(2083),
    [anon_sym_c_DQUOTE] = ACTIONS(2083),
    [anon_sym_r_SQUOTE] = ACTIONS(2083),
    [anon_sym_r_DQUOTE] = ACTIONS(2083),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2083),
    [anon_sym_shared] = ACTIONS(2083),
    [anon_sym_map_LBRACK] = ACTIONS(2083),
    [anon_sym_chan] = ACTIONS(2083),
    [anon_sym_thread] = ACTIONS(2083),
    [anon_sym_atomic] = ACTIONS(2083),
    [anon_sym_assert] = ACTIONS(2083),
    [anon_sym_defer] = ACTIONS(2083),
    [anon_sym_goto] = ACTIONS(2083),
    [anon_sym_break] = ACTIONS(2083),
    [anon_sym_continue] = ACTIONS(2083),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_DOLLARfor] = ACTIONS(2083),
    [anon_sym_for] = ACTIONS(2083),
    [anon_sym_POUND] = ACTIONS(2083),
    [anon_sym_asm] = ACTIONS(2083),
    [anon_sym_AT_LBRACK] = ACTIONS(2083),
  },
  [258] = {
    [sym_line_comment] = STATE(258),
    [sym_block_comment] = STATE(258),
    [sym_else_branch] = STATE(526),
    [ts_builtin_sym_end] = ACTIONS(2087),
    [sym_identifier] = ACTIONS(2089),
    [anon_sym_LF] = ACTIONS(2089),
    [anon_sym_CR] = ACTIONS(2089),
    [anon_sym_CR_LF] = ACTIONS(2089),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2089),
    [anon_sym_as] = ACTIONS(2089),
    [anon_sym_LBRACE] = ACTIONS(2089),
    [anon_sym_COMMA] = ACTIONS(2089),
    [anon_sym_const] = ACTIONS(2089),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_EQ] = ACTIONS(2089),
    [anon_sym___global] = ACTIONS(2089),
    [anon_sym_type] = ACTIONS(2089),
    [anon_sym_fn] = ACTIONS(2089),
    [anon_sym_PLUS] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2089),
    [anon_sym_SLASH] = ACTIONS(2089),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_LT] = ACTIONS(2089),
    [anon_sym_GT] = ACTIONS(2089),
    [anon_sym_EQ_EQ] = ACTIONS(2089),
    [anon_sym_BANG_EQ] = ACTIONS(2089),
    [anon_sym_LT_EQ] = ACTIONS(2089),
    [anon_sym_GT_EQ] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2087),
    [anon_sym_struct] = ACTIONS(2089),
    [anon_sym_union] = ACTIONS(2089),
    [anon_sym_pub] = ACTIONS(2089),
    [anon_sym_mut] = ACTIONS(2089),
    [anon_sym_enum] = ACTIONS(2089),
    [anon_sym_interface] = ACTIONS(2089),
    [anon_sym_PLUS_PLUS] = ACTIONS(2089),
    [anon_sym_DASH_DASH] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2089),
    [anon_sym_BANG] = ACTIONS(2089),
    [anon_sym_go] = ACTIONS(2089),
    [anon_sym_spawn] = ACTIONS(2089),
    [anon_sym_json_DOTdecode] = ACTIONS(2089),
    [anon_sym_PIPE] = ACTIONS(2089),
    [anon_sym_LBRACK2] = ACTIONS(2089),
    [anon_sym_TILDE] = ACTIONS(2089),
    [anon_sym_CARET] = ACTIONS(2089),
    [anon_sym_AMP] = ACTIONS(2089),
    [anon_sym_LT_DASH] = ACTIONS(2089),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_GT_GT] = ACTIONS(2089),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_AMP_CARET] = ACTIONS(2089),
    [anon_sym_AMP_AMP] = ACTIONS(2089),
    [anon_sym_PIPE_PIPE] = ACTIONS(2089),
    [anon_sym_or] = ACTIONS(2089),
    [sym_none] = ACTIONS(2089),
    [sym_true] = ACTIONS(2089),
    [sym_false] = ACTIONS(2089),
    [sym_nil] = ACTIONS(2089),
    [anon_sym_QMARK_DOT] = ACTIONS(2089),
    [anon_sym_POUND_LBRACK] = ACTIONS(2089),
    [anon_sym_if] = ACTIONS(2089),
    [anon_sym_else] = ACTIONS(2085),
    [anon_sym_DOLLARif] = ACTIONS(2089),
    [anon_sym_is] = ACTIONS(2089),
    [anon_sym_BANGis] = ACTIONS(2089),
    [anon_sym_in] = ACTIONS(2089),
    [anon_sym_BANGin] = ACTIONS(2089),
    [anon_sym_match] = ACTIONS(2089),
    [anon_sym_select] = ACTIONS(2089),
    [anon_sym_STAR_EQ] = ACTIONS(2089),
    [anon_sym_SLASH_EQ] = ACTIONS(2089),
    [anon_sym_PERCENT_EQ] = ACTIONS(2089),
    [anon_sym_LT_LT_EQ] = ACTIONS(2089),
    [anon_sym_GT_GT_EQ] = ACTIONS(2089),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2089),
    [anon_sym_AMP_EQ] = ACTIONS(2089),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2089),
    [anon_sym_PLUS_EQ] = ACTIONS(2089),
    [anon_sym_DASH_EQ] = ACTIONS(2089),
    [anon_sym_PIPE_EQ] = ACTIONS(2089),
    [anon_sym_CARET_EQ] = ACTIONS(2089),
    [anon_sym_COLON_EQ] = ACTIONS(2089),
    [anon_sym_lock] = ACTIONS(2089),
    [anon_sym_rlock] = ACTIONS(2089),
    [anon_sym_unsafe] = ACTIONS(2089),
    [anon_sym_sql] = ACTIONS(2089),
    [sym_int_literal] = ACTIONS(2089),
    [sym_float_literal] = ACTIONS(2089),
    [sym_rune_literal] = ACTIONS(2089),
    [anon_sym_SQUOTE] = ACTIONS(2089),
    [anon_sym_DQUOTE] = ACTIONS(2089),
    [anon_sym_c_SQUOTE] = ACTIONS(2089),
    [anon_sym_c_DQUOTE] = ACTIONS(2089),
    [anon_sym_r_SQUOTE] = ACTIONS(2089),
    [anon_sym_r_DQUOTE] = ACTIONS(2089),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2089),
    [anon_sym_shared] = ACTIONS(2089),
    [anon_sym_map_LBRACK] = ACTIONS(2089),
    [anon_sym_chan] = ACTIONS(2089),
    [anon_sym_thread] = ACTIONS(2089),
    [anon_sym_atomic] = ACTIONS(2089),
    [anon_sym_assert] = ACTIONS(2089),
    [anon_sym_defer] = ACTIONS(2089),
    [anon_sym_goto] = ACTIONS(2089),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_continue] = ACTIONS(2089),
    [anon_sym_return] = ACTIONS(2089),
    [anon_sym_DOLLARfor] = ACTIONS(2089),
    [anon_sym_for] = ACTIONS(2089),
    [anon_sym_POUND] = ACTIONS(2089),
    [anon_sym_asm] = ACTIONS(2089),
    [anon_sym_AT_LBRACK] = ACTIONS(2089),
  },
  [259] = {
    [sym_line_comment] = STATE(259),
    [sym_block_comment] = STATE(259),
    [ts_builtin_sym_end] = ACTIONS(2091),
    [sym_identifier] = ACTIONS(2093),
    [anon_sym_LF] = ACTIONS(2093),
    [anon_sym_CR] = ACTIONS(2093),
    [anon_sym_CR_LF] = ACTIONS(2093),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2093),
    [anon_sym_as] = ACTIONS(2093),
    [anon_sym_LBRACE] = ACTIONS(2093),
    [anon_sym_COMMA] = ACTIONS(2093),
    [anon_sym_const] = ACTIONS(2093),
    [anon_sym_LPAREN] = ACTIONS(2093),
    [anon_sym_EQ] = ACTIONS(2093),
    [anon_sym___global] = ACTIONS(2093),
    [anon_sym_type] = ACTIONS(2093),
    [anon_sym_fn] = ACTIONS(2093),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(2093),
    [anon_sym_SLASH] = ACTIONS(2093),
    [anon_sym_PERCENT] = ACTIONS(2093),
    [anon_sym_LT] = ACTIONS(2093),
    [anon_sym_GT] = ACTIONS(2093),
    [anon_sym_EQ_EQ] = ACTIONS(2093),
    [anon_sym_BANG_EQ] = ACTIONS(2093),
    [anon_sym_LT_EQ] = ACTIONS(2093),
    [anon_sym_GT_EQ] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2091),
    [anon_sym_struct] = ACTIONS(2093),
    [anon_sym_union] = ACTIONS(2093),
    [anon_sym_pub] = ACTIONS(2093),
    [anon_sym_mut] = ACTIONS(2093),
    [anon_sym_enum] = ACTIONS(2093),
    [anon_sym_interface] = ACTIONS(2093),
    [anon_sym_PLUS_PLUS] = ACTIONS(2093),
    [anon_sym_DASH_DASH] = ACTIONS(2093),
    [anon_sym_QMARK] = ACTIONS(2093),
    [anon_sym_BANG] = ACTIONS(2093),
    [anon_sym_go] = ACTIONS(2093),
    [anon_sym_spawn] = ACTIONS(2093),
    [anon_sym_json_DOTdecode] = ACTIONS(2093),
    [anon_sym_PIPE] = ACTIONS(2093),
    [anon_sym_LBRACK2] = ACTIONS(2093),
    [anon_sym_TILDE] = ACTIONS(2093),
    [anon_sym_CARET] = ACTIONS(2093),
    [anon_sym_AMP] = ACTIONS(2093),
    [anon_sym_LT_DASH] = ACTIONS(2093),
    [anon_sym_LT_LT] = ACTIONS(2093),
    [anon_sym_GT_GT] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2093),
    [anon_sym_AMP_CARET] = ACTIONS(2093),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_PIPE_PIPE] = ACTIONS(2093),
    [anon_sym_or] = ACTIONS(2093),
    [sym_none] = ACTIONS(2093),
    [sym_true] = ACTIONS(2093),
    [sym_false] = ACTIONS(2093),
    [sym_nil] = ACTIONS(2093),
    [anon_sym_QMARK_DOT] = ACTIONS(2093),
    [anon_sym_POUND_LBRACK] = ACTIONS(2093),
    [anon_sym_if] = ACTIONS(2093),
    [anon_sym_DOLLARif] = ACTIONS(2093),
    [anon_sym_DOLLARelse] = ACTIONS(2095),
    [anon_sym_is] = ACTIONS(2093),
    [anon_sym_BANGis] = ACTIONS(2093),
    [anon_sym_in] = ACTIONS(2093),
    [anon_sym_BANGin] = ACTIONS(2093),
    [anon_sym_match] = ACTIONS(2093),
    [anon_sym_select] = ACTIONS(2093),
    [anon_sym_STAR_EQ] = ACTIONS(2093),
    [anon_sym_SLASH_EQ] = ACTIONS(2093),
    [anon_sym_PERCENT_EQ] = ACTIONS(2093),
    [anon_sym_LT_LT_EQ] = ACTIONS(2093),
    [anon_sym_GT_GT_EQ] = ACTIONS(2093),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2093),
    [anon_sym_AMP_EQ] = ACTIONS(2093),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2093),
    [anon_sym_PLUS_EQ] = ACTIONS(2093),
    [anon_sym_DASH_EQ] = ACTIONS(2093),
    [anon_sym_PIPE_EQ] = ACTIONS(2093),
    [anon_sym_CARET_EQ] = ACTIONS(2093),
    [anon_sym_COLON_EQ] = ACTIONS(2093),
    [anon_sym_lock] = ACTIONS(2093),
    [anon_sym_rlock] = ACTIONS(2093),
    [anon_sym_unsafe] = ACTIONS(2093),
    [anon_sym_sql] = ACTIONS(2093),
    [sym_int_literal] = ACTIONS(2093),
    [sym_float_literal] = ACTIONS(2093),
    [sym_rune_literal] = ACTIONS(2093),
    [anon_sym_SQUOTE] = ACTIONS(2093),
    [anon_sym_DQUOTE] = ACTIONS(2093),
    [anon_sym_c_SQUOTE] = ACTIONS(2093),
    [anon_sym_c_DQUOTE] = ACTIONS(2093),
    [anon_sym_r_SQUOTE] = ACTIONS(2093),
    [anon_sym_r_DQUOTE] = ACTIONS(2093),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2093),
    [anon_sym_shared] = ACTIONS(2093),
    [anon_sym_map_LBRACK] = ACTIONS(2093),
    [anon_sym_chan] = ACTIONS(2093),
    [anon_sym_thread] = ACTIONS(2093),
    [anon_sym_atomic] = ACTIONS(2093),
    [anon_sym_assert] = ACTIONS(2093),
    [anon_sym_defer] = ACTIONS(2093),
    [anon_sym_goto] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2093),
    [anon_sym_continue] = ACTIONS(2093),
    [anon_sym_return] = ACTIONS(2093),
    [anon_sym_DOLLARfor] = ACTIONS(2093),
    [anon_sym_for] = ACTIONS(2093),
    [anon_sym_POUND] = ACTIONS(2093),
    [anon_sym_asm] = ACTIONS(2093),
    [anon_sym_AT_LBRACK] = ACTIONS(2093),
  },
  [260] = {
    [sym_line_comment] = STATE(260),
    [sym_block_comment] = STATE(260),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(310),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2097),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [261] = {
    [sym_line_comment] = STATE(261),
    [sym_block_comment] = STATE(261),
    [ts_builtin_sym_end] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2105),
    [anon_sym_LF] = ACTIONS(2105),
    [anon_sym_CR] = ACTIONS(2105),
    [anon_sym_CR_LF] = ACTIONS(2105),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2105),
    [anon_sym_as] = ACTIONS(2105),
    [anon_sym_LBRACE] = ACTIONS(2105),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_const] = ACTIONS(2105),
    [anon_sym_LPAREN] = ACTIONS(2105),
    [anon_sym_EQ] = ACTIONS(2105),
    [anon_sym___global] = ACTIONS(2105),
    [anon_sym_type] = ACTIONS(2105),
    [anon_sym_fn] = ACTIONS(2105),
    [anon_sym_PLUS] = ACTIONS(2105),
    [anon_sym_DASH] = ACTIONS(2105),
    [anon_sym_STAR] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2105),
    [anon_sym_PERCENT] = ACTIONS(2105),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_GT] = ACTIONS(2105),
    [anon_sym_EQ_EQ] = ACTIONS(2105),
    [anon_sym_BANG_EQ] = ACTIONS(2105),
    [anon_sym_LT_EQ] = ACTIONS(2105),
    [anon_sym_GT_EQ] = ACTIONS(2105),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_struct] = ACTIONS(2105),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_pub] = ACTIONS(2105),
    [anon_sym_mut] = ACTIONS(2105),
    [anon_sym_enum] = ACTIONS(2105),
    [anon_sym_interface] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_QMARK] = ACTIONS(2105),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_go] = ACTIONS(2105),
    [anon_sym_spawn] = ACTIONS(2105),
    [anon_sym_json_DOTdecode] = ACTIONS(2105),
    [anon_sym_PIPE] = ACTIONS(2105),
    [anon_sym_LBRACK2] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_LT_DASH] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(2105),
    [anon_sym_GT_GT] = ACTIONS(2105),
    [anon_sym_GT_GT_GT] = ACTIONS(2105),
    [anon_sym_AMP_CARET] = ACTIONS(2105),
    [anon_sym_AMP_AMP] = ACTIONS(2105),
    [anon_sym_PIPE_PIPE] = ACTIONS(2105),
    [anon_sym_or] = ACTIONS(2105),
    [sym_none] = ACTIONS(2105),
    [sym_true] = ACTIONS(2105),
    [sym_false] = ACTIONS(2105),
    [sym_nil] = ACTIONS(2105),
    [anon_sym_QMARK_DOT] = ACTIONS(2105),
    [anon_sym_POUND_LBRACK] = ACTIONS(2105),
    [anon_sym_if] = ACTIONS(2105),
    [anon_sym_DOLLARif] = ACTIONS(2105),
    [anon_sym_DOLLARelse] = ACTIONS(2107),
    [anon_sym_is] = ACTIONS(2105),
    [anon_sym_BANGis] = ACTIONS(2105),
    [anon_sym_in] = ACTIONS(2105),
    [anon_sym_BANGin] = ACTIONS(2105),
    [anon_sym_match] = ACTIONS(2105),
    [anon_sym_select] = ACTIONS(2105),
    [anon_sym_STAR_EQ] = ACTIONS(2105),
    [anon_sym_SLASH_EQ] = ACTIONS(2105),
    [anon_sym_PERCENT_EQ] = ACTIONS(2105),
    [anon_sym_LT_LT_EQ] = ACTIONS(2105),
    [anon_sym_GT_GT_EQ] = ACTIONS(2105),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2105),
    [anon_sym_AMP_EQ] = ACTIONS(2105),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2105),
    [anon_sym_PLUS_EQ] = ACTIONS(2105),
    [anon_sym_DASH_EQ] = ACTIONS(2105),
    [anon_sym_PIPE_EQ] = ACTIONS(2105),
    [anon_sym_CARET_EQ] = ACTIONS(2105),
    [anon_sym_COLON_EQ] = ACTIONS(2105),
    [anon_sym_lock] = ACTIONS(2105),
    [anon_sym_rlock] = ACTIONS(2105),
    [anon_sym_unsafe] = ACTIONS(2105),
    [anon_sym_sql] = ACTIONS(2105),
    [sym_int_literal] = ACTIONS(2105),
    [sym_float_literal] = ACTIONS(2105),
    [sym_rune_literal] = ACTIONS(2105),
    [anon_sym_SQUOTE] = ACTIONS(2105),
    [anon_sym_DQUOTE] = ACTIONS(2105),
    [anon_sym_c_SQUOTE] = ACTIONS(2105),
    [anon_sym_c_DQUOTE] = ACTIONS(2105),
    [anon_sym_r_SQUOTE] = ACTIONS(2105),
    [anon_sym_r_DQUOTE] = ACTIONS(2105),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2105),
    [anon_sym_shared] = ACTIONS(2105),
    [anon_sym_map_LBRACK] = ACTIONS(2105),
    [anon_sym_chan] = ACTIONS(2105),
    [anon_sym_thread] = ACTIONS(2105),
    [anon_sym_atomic] = ACTIONS(2105),
    [anon_sym_assert] = ACTIONS(2105),
    [anon_sym_defer] = ACTIONS(2105),
    [anon_sym_goto] = ACTIONS(2105),
    [anon_sym_break] = ACTIONS(2105),
    [anon_sym_continue] = ACTIONS(2105),
    [anon_sym_return] = ACTIONS(2105),
    [anon_sym_DOLLARfor] = ACTIONS(2105),
    [anon_sym_for] = ACTIONS(2105),
    [anon_sym_POUND] = ACTIONS(2105),
    [anon_sym_asm] = ACTIONS(2105),
    [anon_sym_AT_LBRACK] = ACTIONS(2105),
  },
  [262] = {
    [sym_line_comment] = STATE(262),
    [sym_block_comment] = STATE(262),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(310),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [263] = {
    [sym_line_comment] = STATE(263),
    [sym_block_comment] = STATE(263),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(262),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [264] = {
    [sym_line_comment] = STATE(264),
    [sym_block_comment] = STATE(264),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4316),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(2475),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2115),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [265] = {
    [sym_line_comment] = STATE(265),
    [sym_block_comment] = STATE(265),
    [sym__expression] = STATE(2460),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2596),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(869),
    [sym_mutable_expression] = STATE(3972),
    [sym_expression_list] = STATE(4599),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_var_declaration] = STATE(4313),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [266] = {
    [sym_line_comment] = STATE(266),
    [sym_block_comment] = STATE(266),
    [sym__expression] = STATE(2479),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(869),
    [sym_mutable_expression] = STATE(3972),
    [sym_expression_list] = STATE(4599),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_var_declaration] = STATE(4214),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [267] = {
    [sym_line_comment] = STATE(267),
    [sym_block_comment] = STATE(267),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4170),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(1064),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2137),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [268] = {
    [sym_line_comment] = STATE(268),
    [sym_block_comment] = STATE(268),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(269),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2139),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [269] = {
    [sym_line_comment] = STATE(269),
    [sym_block_comment] = STATE(269),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(310),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2141),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [270] = {
    [sym_line_comment] = STATE(270),
    [sym_block_comment] = STATE(270),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4370),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(2648),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2143),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [271] = {
    [sym_line_comment] = STATE(271),
    [sym_block_comment] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(2145),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_CR] = ACTIONS(2147),
    [anon_sym_CR_LF] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_COMMA] = ACTIONS(2147),
    [anon_sym_const] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym_EQ] = ACTIONS(2147),
    [anon_sym___global] = ACTIONS(2147),
    [anon_sym_type] = ACTIONS(2147),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2147),
    [anon_sym_BANG_EQ] = ACTIONS(2147),
    [anon_sym_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2147),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_union] = ACTIONS(2147),
    [anon_sym_pub] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_enum] = ACTIONS(2147),
    [anon_sym_interface] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2147),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2147),
    [anon_sym_AMP_CARET] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [anon_sym_or] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2147),
    [anon_sym_POUND_LBRACK] = ACTIONS(2147),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_DOLLARelse] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2147),
    [anon_sym_BANGis] = ACTIONS(2147),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANGin] = ACTIONS(2147),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_STAR_EQ] = ACTIONS(2147),
    [anon_sym_SLASH_EQ] = ACTIONS(2147),
    [anon_sym_PERCENT_EQ] = ACTIONS(2147),
    [anon_sym_LT_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_GT_EQ] = ACTIONS(2147),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2147),
    [anon_sym_AMP_EQ] = ACTIONS(2147),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2147),
    [anon_sym_PLUS_EQ] = ACTIONS(2147),
    [anon_sym_DASH_EQ] = ACTIONS(2147),
    [anon_sym_PIPE_EQ] = ACTIONS(2147),
    [anon_sym_CARET_EQ] = ACTIONS(2147),
    [anon_sym_COLON_EQ] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2147),
    [sym_rune_literal] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_c_SQUOTE] = ACTIONS(2147),
    [anon_sym_c_DQUOTE] = ACTIONS(2147),
    [anon_sym_r_SQUOTE] = ACTIONS(2147),
    [anon_sym_r_DQUOTE] = ACTIONS(2147),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2147),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
    [anon_sym_assert] = ACTIONS(2147),
    [anon_sym_defer] = ACTIONS(2147),
    [anon_sym_goto] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_continue] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2147),
    [anon_sym_DOLLARfor] = ACTIONS(2147),
    [anon_sym_for] = ACTIONS(2147),
    [anon_sym_POUND] = ACTIONS(2147),
    [anon_sym_asm] = ACTIONS(2147),
    [anon_sym_AT_LBRACK] = ACTIONS(2147),
  },
  [272] = {
    [sym_line_comment] = STATE(272),
    [sym_block_comment] = STATE(272),
    [sym__expression] = STATE(2415),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(869),
    [sym_mutable_expression] = STATE(3972),
    [sym_expression_list] = STATE(4599),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_var_declaration] = STATE(4131),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [273] = {
    [sym_line_comment] = STATE(273),
    [sym_block_comment] = STATE(273),
    [sym__expression] = STATE(2439),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(869),
    [sym_mutable_expression] = STATE(3972),
    [sym_expression_list] = STATE(4599),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_var_declaration] = STATE(4169),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [274] = {
    [sym_line_comment] = STATE(274),
    [sym_block_comment] = STATE(274),
    [sym__expression] = STATE(2408),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(869),
    [sym_mutable_expression] = STATE(3972),
    [sym_expression_list] = STATE(4599),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_var_declaration] = STATE(4324),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [275] = {
    [sym_line_comment] = STATE(275),
    [sym_block_comment] = STATE(275),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4370),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(2648),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2149),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [276] = {
    [sym_line_comment] = STATE(276),
    [sym_block_comment] = STATE(276),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(304),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2151),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [277] = {
    [sym_line_comment] = STATE(277),
    [sym_block_comment] = STATE(277),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(310),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2153),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [278] = {
    [sym_line_comment] = STATE(278),
    [sym_block_comment] = STATE(278),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4130),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(2932),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2155),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [279] = {
    [sym_line_comment] = STATE(279),
    [sym_block_comment] = STATE(279),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4316),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(2475),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2157),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [280] = {
    [sym_line_comment] = STATE(280),
    [sym_block_comment] = STATE(280),
    [sym__expression] = STATE(2502),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(869),
    [sym_mutable_expression] = STATE(3972),
    [sym_expression_list] = STATE(4599),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_var_declaration] = STATE(4405),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [281] = {
    [sym_line_comment] = STATE(281),
    [sym_block_comment] = STATE(281),
    [ts_builtin_sym_end] = ACTIONS(2145),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_CR] = ACTIONS(2147),
    [anon_sym_CR_LF] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_COMMA] = ACTIONS(2147),
    [anon_sym_const] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym_EQ] = ACTIONS(2147),
    [anon_sym___global] = ACTIONS(2147),
    [anon_sym_type] = ACTIONS(2147),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2147),
    [anon_sym_BANG_EQ] = ACTIONS(2147),
    [anon_sym_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2147),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_union] = ACTIONS(2147),
    [anon_sym_pub] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_enum] = ACTIONS(2147),
    [anon_sym_interface] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2147),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2147),
    [anon_sym_AMP_CARET] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [anon_sym_or] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2147),
    [anon_sym_POUND_LBRACK] = ACTIONS(2147),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_else] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2147),
    [anon_sym_BANGis] = ACTIONS(2147),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANGin] = ACTIONS(2147),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_STAR_EQ] = ACTIONS(2147),
    [anon_sym_SLASH_EQ] = ACTIONS(2147),
    [anon_sym_PERCENT_EQ] = ACTIONS(2147),
    [anon_sym_LT_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_GT_EQ] = ACTIONS(2147),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2147),
    [anon_sym_AMP_EQ] = ACTIONS(2147),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2147),
    [anon_sym_PLUS_EQ] = ACTIONS(2147),
    [anon_sym_DASH_EQ] = ACTIONS(2147),
    [anon_sym_PIPE_EQ] = ACTIONS(2147),
    [anon_sym_CARET_EQ] = ACTIONS(2147),
    [anon_sym_COLON_EQ] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2147),
    [sym_rune_literal] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_c_SQUOTE] = ACTIONS(2147),
    [anon_sym_c_DQUOTE] = ACTIONS(2147),
    [anon_sym_r_SQUOTE] = ACTIONS(2147),
    [anon_sym_r_DQUOTE] = ACTIONS(2147),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2147),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
    [anon_sym_assert] = ACTIONS(2147),
    [anon_sym_defer] = ACTIONS(2147),
    [anon_sym_goto] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_continue] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2147),
    [anon_sym_DOLLARfor] = ACTIONS(2147),
    [anon_sym_for] = ACTIONS(2147),
    [anon_sym_POUND] = ACTIONS(2147),
    [anon_sym_asm] = ACTIONS(2147),
    [anon_sym_AT_LBRACK] = ACTIONS(2147),
  },
  [282] = {
    [sym_line_comment] = STATE(282),
    [sym_block_comment] = STATE(282),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(285),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2159),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [283] = {
    [sym_line_comment] = STATE(283),
    [sym_block_comment] = STATE(283),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4138),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(1326),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [284] = {
    [sym_line_comment] = STATE(284),
    [sym_block_comment] = STATE(284),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(318),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2163),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [285] = {
    [sym_line_comment] = STATE(285),
    [sym_block_comment] = STATE(285),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(310),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2165),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [286] = {
    [sym_line_comment] = STATE(286),
    [sym_block_comment] = STATE(286),
    [sym__expression] = STATE(2396),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(869),
    [sym_mutable_expression] = STATE(3972),
    [sym_expression_list] = STATE(4599),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_var_declaration] = STATE(4251),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [287] = {
    [sym_line_comment] = STATE(287),
    [sym_block_comment] = STATE(287),
    [sym__expression] = STATE(2502),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2596),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(869),
    [sym_mutable_expression] = STATE(3972),
    [sym_expression_list] = STATE(4599),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_var_declaration] = STATE(4405),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [288] = {
    [sym_line_comment] = STATE(288),
    [sym_block_comment] = STATE(288),
    [ts_builtin_sym_end] = ACTIONS(2167),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_LF] = ACTIONS(2169),
    [anon_sym_CR] = ACTIONS(2169),
    [anon_sym_CR_LF] = ACTIONS(2169),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2169),
    [anon_sym_as] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_COMMA] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_LPAREN] = ACTIONS(2169),
    [anon_sym_EQ] = ACTIONS(2169),
    [anon_sym___global] = ACTIONS(2169),
    [anon_sym_type] = ACTIONS(2169),
    [anon_sym_fn] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_SLASH] = ACTIONS(2169),
    [anon_sym_PERCENT] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2169),
    [anon_sym_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ] = ACTIONS(2169),
    [anon_sym_LT_EQ] = ACTIONS(2169),
    [anon_sym_GT_EQ] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_union] = ACTIONS(2169),
    [anon_sym_pub] = ACTIONS(2169),
    [anon_sym_mut] = ACTIONS(2169),
    [anon_sym_enum] = ACTIONS(2169),
    [anon_sym_interface] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_go] = ACTIONS(2169),
    [anon_sym_spawn] = ACTIONS(2169),
    [anon_sym_json_DOTdecode] = ACTIONS(2169),
    [anon_sym_PIPE] = ACTIONS(2169),
    [anon_sym_LBRACK2] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT_DASH] = ACTIONS(2169),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_GT_GT_GT] = ACTIONS(2169),
    [anon_sym_AMP_CARET] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_PIPE_PIPE] = ACTIONS(2169),
    [anon_sym_or] = ACTIONS(2169),
    [sym_none] = ACTIONS(2169),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [sym_nil] = ACTIONS(2169),
    [anon_sym_QMARK_DOT] = ACTIONS(2169),
    [anon_sym_POUND_LBRACK] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(2169),
    [anon_sym_DOLLARif] = ACTIONS(2169),
    [anon_sym_is] = ACTIONS(2169),
    [anon_sym_BANGis] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_BANGin] = ACTIONS(2169),
    [anon_sym_match] = ACTIONS(2169),
    [anon_sym_select] = ACTIONS(2169),
    [anon_sym_STAR_EQ] = ACTIONS(2169),
    [anon_sym_SLASH_EQ] = ACTIONS(2169),
    [anon_sym_PERCENT_EQ] = ACTIONS(2169),
    [anon_sym_LT_LT_EQ] = ACTIONS(2169),
    [anon_sym_GT_GT_EQ] = ACTIONS(2169),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2169),
    [anon_sym_AMP_EQ] = ACTIONS(2169),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2169),
    [anon_sym_PLUS_EQ] = ACTIONS(2169),
    [anon_sym_DASH_EQ] = ACTIONS(2169),
    [anon_sym_PIPE_EQ] = ACTIONS(2169),
    [anon_sym_CARET_EQ] = ACTIONS(2169),
    [anon_sym_COLON_EQ] = ACTIONS(2169),
    [anon_sym_lock] = ACTIONS(2169),
    [anon_sym_rlock] = ACTIONS(2169),
    [anon_sym_unsafe] = ACTIONS(2169),
    [anon_sym_sql] = ACTIONS(2169),
    [sym_int_literal] = ACTIONS(2169),
    [sym_float_literal] = ACTIONS(2169),
    [sym_rune_literal] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [anon_sym_c_SQUOTE] = ACTIONS(2169),
    [anon_sym_c_DQUOTE] = ACTIONS(2169),
    [anon_sym_r_SQUOTE] = ACTIONS(2169),
    [anon_sym_r_DQUOTE] = ACTIONS(2169),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_map_LBRACK] = ACTIONS(2169),
    [anon_sym_chan] = ACTIONS(2169),
    [anon_sym_thread] = ACTIONS(2169),
    [anon_sym_atomic] = ACTIONS(2169),
    [anon_sym_assert] = ACTIONS(2169),
    [anon_sym_defer] = ACTIONS(2169),
    [anon_sym_goto] = ACTIONS(2169),
    [anon_sym_break] = ACTIONS(2169),
    [anon_sym_continue] = ACTIONS(2169),
    [anon_sym_return] = ACTIONS(2169),
    [anon_sym_DOLLARfor] = ACTIONS(2169),
    [anon_sym_for] = ACTIONS(2169),
    [anon_sym_POUND] = ACTIONS(2169),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym_AT_LBRACK] = ACTIONS(2169),
  },
  [289] = {
    [sym_line_comment] = STATE(289),
    [sym_block_comment] = STATE(289),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(310),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2171),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [290] = {
    [sym_line_comment] = STATE(290),
    [sym_block_comment] = STATE(290),
    [ts_builtin_sym_end] = ACTIONS(2173),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LF] = ACTIONS(2175),
    [anon_sym_CR] = ACTIONS(2175),
    [anon_sym_CR_LF] = ACTIONS(2175),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2175),
    [anon_sym_as] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2177),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym_const] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_EQ] = ACTIONS(2175),
    [anon_sym___global] = ACTIONS(2175),
    [anon_sym_type] = ACTIONS(2175),
    [anon_sym_fn] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2175),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_PERCENT] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_GT] = ACTIONS(2175),
    [anon_sym_EQ_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ] = ACTIONS(2175),
    [anon_sym_LT_EQ] = ACTIONS(2175),
    [anon_sym_GT_EQ] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2180),
    [anon_sym_struct] = ACTIONS(2175),
    [anon_sym_union] = ACTIONS(2175),
    [anon_sym_pub] = ACTIONS(2175),
    [anon_sym_mut] = ACTIONS(2175),
    [anon_sym_COLON] = ACTIONS(2183),
    [anon_sym_enum] = ACTIONS(2175),
    [anon_sym_interface] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [anon_sym_QMARK] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_go] = ACTIONS(2175),
    [anon_sym_spawn] = ACTIONS(2175),
    [anon_sym_json_DOTdecode] = ACTIONS(2175),
    [anon_sym_PIPE] = ACTIONS(2175),
    [anon_sym_LBRACK2] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_CARET] = ACTIONS(2175),
    [anon_sym_AMP] = ACTIONS(2175),
    [anon_sym_LT_DASH] = ACTIONS(2175),
    [anon_sym_LT_LT] = ACTIONS(2175),
    [anon_sym_GT_GT] = ACTIONS(2175),
    [anon_sym_GT_GT_GT] = ACTIONS(2175),
    [anon_sym_AMP_CARET] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(2175),
    [anon_sym_PIPE_PIPE] = ACTIONS(2175),
    [anon_sym_or] = ACTIONS(2175),
    [sym_none] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_nil] = ACTIONS(2175),
    [anon_sym_QMARK_DOT] = ACTIONS(2175),
    [anon_sym_POUND_LBRACK] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_DOLLARif] = ACTIONS(2175),
    [anon_sym_is] = ACTIONS(2175),
    [anon_sym_BANGis] = ACTIONS(2175),
    [anon_sym_in] = ACTIONS(2175),
    [anon_sym_BANGin] = ACTIONS(2175),
    [anon_sym_match] = ACTIONS(2175),
    [anon_sym_select] = ACTIONS(2175),
    [anon_sym_STAR_EQ] = ACTIONS(2175),
    [anon_sym_SLASH_EQ] = ACTIONS(2175),
    [anon_sym_PERCENT_EQ] = ACTIONS(2175),
    [anon_sym_LT_LT_EQ] = ACTIONS(2175),
    [anon_sym_GT_GT_EQ] = ACTIONS(2175),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2175),
    [anon_sym_AMP_EQ] = ACTIONS(2175),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2175),
    [anon_sym_PLUS_EQ] = ACTIONS(2175),
    [anon_sym_DASH_EQ] = ACTIONS(2175),
    [anon_sym_PIPE_EQ] = ACTIONS(2175),
    [anon_sym_CARET_EQ] = ACTIONS(2175),
    [anon_sym_COLON_EQ] = ACTIONS(2175),
    [anon_sym_lock] = ACTIONS(2175),
    [anon_sym_rlock] = ACTIONS(2175),
    [anon_sym_unsafe] = ACTIONS(2175),
    [anon_sym_sql] = ACTIONS(2175),
    [sym_int_literal] = ACTIONS(2175),
    [sym_float_literal] = ACTIONS(2175),
    [sym_rune_literal] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_c_SQUOTE] = ACTIONS(2175),
    [anon_sym_c_DQUOTE] = ACTIONS(2175),
    [anon_sym_r_SQUOTE] = ACTIONS(2175),
    [anon_sym_r_DQUOTE] = ACTIONS(2175),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2175),
    [anon_sym_shared] = ACTIONS(2175),
    [anon_sym_map_LBRACK] = ACTIONS(2175),
    [anon_sym_chan] = ACTIONS(2175),
    [anon_sym_thread] = ACTIONS(2175),
    [anon_sym_atomic] = ACTIONS(2175),
    [anon_sym_assert] = ACTIONS(2175),
    [anon_sym_defer] = ACTIONS(2175),
    [anon_sym_goto] = ACTIONS(2175),
    [anon_sym_break] = ACTIONS(2175),
    [anon_sym_continue] = ACTIONS(2175),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_DOLLARfor] = ACTIONS(2175),
    [anon_sym_for] = ACTIONS(2175),
    [anon_sym_POUND] = ACTIONS(2175),
    [anon_sym_asm] = ACTIONS(2175),
    [anon_sym_AT_LBRACK] = ACTIONS(2175),
  },
  [291] = {
    [sym_line_comment] = STATE(291),
    [sym_block_comment] = STATE(291),
    [sym_type_parameters] = STATE(412),
    [ts_builtin_sym_end] = ACTIONS(2185),
    [sym_identifier] = ACTIONS(2187),
    [anon_sym_LF] = ACTIONS(2187),
    [anon_sym_CR] = ACTIONS(2187),
    [anon_sym_CR_LF] = ACTIONS(2187),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2187),
    [anon_sym_as] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_const] = ACTIONS(2187),
    [anon_sym_LPAREN] = ACTIONS(2187),
    [anon_sym_EQ] = ACTIONS(2187),
    [anon_sym___global] = ACTIONS(2187),
    [anon_sym_type] = ACTIONS(2187),
    [anon_sym_fn] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [anon_sym_LT] = ACTIONS(2187),
    [anon_sym_GT] = ACTIONS(2187),
    [anon_sym_EQ_EQ] = ACTIONS(2187),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2187),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2185),
    [anon_sym_struct] = ACTIONS(2187),
    [anon_sym_union] = ACTIONS(2187),
    [anon_sym_pub] = ACTIONS(2187),
    [anon_sym_mut] = ACTIONS(2187),
    [anon_sym_enum] = ACTIONS(2187),
    [anon_sym_interface] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_go] = ACTIONS(2187),
    [anon_sym_spawn] = ACTIONS(2187),
    [anon_sym_json_DOTdecode] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2187),
    [anon_sym_LBRACK2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_LT_DASH] = ACTIONS(2187),
    [anon_sym_LT_LT] = ACTIONS(2187),
    [anon_sym_GT_GT] = ACTIONS(2187),
    [anon_sym_GT_GT_GT] = ACTIONS(2187),
    [anon_sym_AMP_CARET] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2187),
    [sym_none] = ACTIONS(2187),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [sym_nil] = ACTIONS(2187),
    [anon_sym_QMARK_DOT] = ACTIONS(2187),
    [anon_sym_POUND_LBRACK] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_DOLLARif] = ACTIONS(2187),
    [anon_sym_is] = ACTIONS(2187),
    [anon_sym_BANGis] = ACTIONS(2187),
    [anon_sym_in] = ACTIONS(2187),
    [anon_sym_BANGin] = ACTIONS(2187),
    [anon_sym_match] = ACTIONS(2187),
    [anon_sym_select] = ACTIONS(2187),
    [anon_sym_STAR_EQ] = ACTIONS(2187),
    [anon_sym_SLASH_EQ] = ACTIONS(2187),
    [anon_sym_PERCENT_EQ] = ACTIONS(2187),
    [anon_sym_LT_LT_EQ] = ACTIONS(2187),
    [anon_sym_GT_GT_EQ] = ACTIONS(2187),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2187),
    [anon_sym_AMP_EQ] = ACTIONS(2187),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2187),
    [anon_sym_PLUS_EQ] = ACTIONS(2187),
    [anon_sym_DASH_EQ] = ACTIONS(2187),
    [anon_sym_PIPE_EQ] = ACTIONS(2187),
    [anon_sym_CARET_EQ] = ACTIONS(2187),
    [anon_sym_COLON_EQ] = ACTIONS(2187),
    [anon_sym_lock] = ACTIONS(2187),
    [anon_sym_rlock] = ACTIONS(2187),
    [anon_sym_unsafe] = ACTIONS(2187),
    [anon_sym_sql] = ACTIONS(2187),
    [sym_int_literal] = ACTIONS(2187),
    [sym_float_literal] = ACTIONS(2187),
    [sym_rune_literal] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(2187),
    [anon_sym_DQUOTE] = ACTIONS(2187),
    [anon_sym_c_SQUOTE] = ACTIONS(2187),
    [anon_sym_c_DQUOTE] = ACTIONS(2187),
    [anon_sym_r_SQUOTE] = ACTIONS(2187),
    [anon_sym_r_DQUOTE] = ACTIONS(2187),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2187),
    [anon_sym_shared] = ACTIONS(2187),
    [anon_sym_map_LBRACK] = ACTIONS(2187),
    [anon_sym_chan] = ACTIONS(2187),
    [anon_sym_thread] = ACTIONS(2187),
    [anon_sym_atomic] = ACTIONS(2187),
    [anon_sym_assert] = ACTIONS(2187),
    [anon_sym_defer] = ACTIONS(2187),
    [anon_sym_goto] = ACTIONS(2187),
    [anon_sym_break] = ACTIONS(2187),
    [anon_sym_continue] = ACTIONS(2187),
    [anon_sym_return] = ACTIONS(2187),
    [anon_sym_DOLLARfor] = ACTIONS(2187),
    [anon_sym_for] = ACTIONS(2187),
    [anon_sym_POUND] = ACTIONS(2187),
    [anon_sym_asm] = ACTIONS(2187),
    [anon_sym_AT_LBRACK] = ACTIONS(2187),
  },
  [292] = {
    [sym_line_comment] = STATE(292),
    [sym_block_comment] = STATE(292),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4252),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(468),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [293] = {
    [sym_line_comment] = STATE(293),
    [sym_block_comment] = STATE(293),
    [sym__expression] = STATE(2460),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(869),
    [sym_mutable_expression] = STATE(3972),
    [sym_expression_list] = STATE(4599),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_var_declaration] = STATE(4313),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [294] = {
    [sym_line_comment] = STATE(294),
    [sym_block_comment] = STATE(294),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4370),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(2648),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2191),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [295] = {
    [sym_line_comment] = STATE(295),
    [sym_block_comment] = STATE(295),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(302),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2193),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [296] = {
    [sym_line_comment] = STATE(296),
    [sym_block_comment] = STATE(296),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4318),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(2356),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2195),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [297] = {
    [sym_line_comment] = STATE(297),
    [sym_block_comment] = STATE(297),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4212),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(2088),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2197),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [298] = {
    [sym_line_comment] = STATE(298),
    [sym_block_comment] = STATE(298),
    [sym__expression] = STATE(2452),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(869),
    [sym_mutable_expression] = STATE(3972),
    [sym_expression_list] = STATE(4599),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_var_declaration] = STATE(4374),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [299] = {
    [sym_line_comment] = STATE(299),
    [sym_block_comment] = STATE(299),
    [sym__expression] = STATE(2486),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(869),
    [sym_mutable_expression] = STATE(3972),
    [sym_expression_list] = STATE(4599),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_var_declaration] = STATE(4134),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [300] = {
    [sym_line_comment] = STATE(300),
    [sym_block_comment] = STATE(300),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4245),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(2216),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2199),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [301] = {
    [sym_line_comment] = STATE(301),
    [sym_block_comment] = STATE(301),
    [sym__expression] = STATE(2454),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(869),
    [sym_mutable_expression] = STATE(3972),
    [sym_expression_list] = STATE(4599),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_var_declaration] = STATE(4250),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [302] = {
    [sym_line_comment] = STATE(302),
    [sym_block_comment] = STATE(302),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(310),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2201),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [303] = {
    [sym_line_comment] = STATE(303),
    [sym_block_comment] = STATE(303),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4323),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(1243),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2203),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [304] = {
    [sym_line_comment] = STATE(304),
    [sym_block_comment] = STATE(304),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(310),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2205),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [305] = {
    [sym_line_comment] = STATE(305),
    [sym_block_comment] = STATE(305),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(310),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2207),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [306] = {
    [sym_line_comment] = STATE(306),
    [sym_block_comment] = STATE(306),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(289),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2209),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [307] = {
    [sym_line_comment] = STATE(307),
    [sym_block_comment] = STATE(307),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(305),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2211),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [308] = {
    [sym_line_comment] = STATE(308),
    [sym_block_comment] = STATE(308),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4128),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(2742),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2213),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [309] = {
    [sym_line_comment] = STATE(309),
    [sym_block_comment] = STATE(309),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4318),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(2356),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [310] = {
    [sym_line_comment] = STATE(310),
    [sym_block_comment] = STATE(310),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(310),
    [sym_identifier] = ACTIONS(2217),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2220),
    [anon_sym_LBRACE] = ACTIONS(2223),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_LPAREN] = ACTIONS(2228),
    [anon_sym_fn] = ACTIONS(2231),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2237),
    [anon_sym_struct] = ACTIONS(2240),
    [anon_sym_mut] = ACTIONS(2243),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_BANG] = ACTIONS(2249),
    [anon_sym_go] = ACTIONS(2252),
    [anon_sym_spawn] = ACTIONS(2255),
    [anon_sym_json_DOTdecode] = ACTIONS(2258),
    [anon_sym_LBRACK2] = ACTIONS(2261),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_LT_DASH] = ACTIONS(2267),
    [sym_none] = ACTIONS(2270),
    [sym_true] = ACTIONS(2270),
    [sym_false] = ACTIONS(2270),
    [sym_nil] = ACTIONS(2270),
    [anon_sym_if] = ACTIONS(2273),
    [anon_sym_DOLLARif] = ACTIONS(2276),
    [anon_sym_match] = ACTIONS(2279),
    [anon_sym_select] = ACTIONS(2282),
    [anon_sym_lock] = ACTIONS(2285),
    [anon_sym_rlock] = ACTIONS(2285),
    [anon_sym_unsafe] = ACTIONS(2288),
    [anon_sym_sql] = ACTIONS(2291),
    [sym_int_literal] = ACTIONS(2270),
    [sym_float_literal] = ACTIONS(2294),
    [sym_rune_literal] = ACTIONS(2294),
    [anon_sym_SQUOTE] = ACTIONS(2297),
    [anon_sym_DQUOTE] = ACTIONS(2300),
    [anon_sym_c_SQUOTE] = ACTIONS(2303),
    [anon_sym_c_DQUOTE] = ACTIONS(2306),
    [anon_sym_r_SQUOTE] = ACTIONS(2309),
    [anon_sym_r_DQUOTE] = ACTIONS(2312),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2315),
    [anon_sym_shared] = ACTIONS(2318),
    [anon_sym_map_LBRACK] = ACTIONS(2321),
    [anon_sym_chan] = ACTIONS(2324),
    [anon_sym_thread] = ACTIONS(2327),
    [anon_sym_atomic] = ACTIONS(2330),
  },
  [311] = {
    [sym_line_comment] = STATE(311),
    [sym_block_comment] = STATE(311),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4316),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(2475),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2333),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [312] = {
    [sym_line_comment] = STATE(312),
    [sym_block_comment] = STATE(312),
    [ts_builtin_sym_end] = ACTIONS(2167),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_LF] = ACTIONS(2169),
    [anon_sym_CR] = ACTIONS(2169),
    [anon_sym_CR_LF] = ACTIONS(2169),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2169),
    [anon_sym_as] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_COMMA] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_LPAREN] = ACTIONS(2169),
    [anon_sym_EQ] = ACTIONS(2169),
    [anon_sym___global] = ACTIONS(2169),
    [anon_sym_type] = ACTIONS(2169),
    [anon_sym_fn] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_SLASH] = ACTIONS(2169),
    [anon_sym_PERCENT] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2169),
    [anon_sym_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ] = ACTIONS(2169),
    [anon_sym_LT_EQ] = ACTIONS(2169),
    [anon_sym_GT_EQ] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_union] = ACTIONS(2169),
    [anon_sym_pub] = ACTIONS(2169),
    [anon_sym_mut] = ACTIONS(2169),
    [anon_sym_enum] = ACTIONS(2169),
    [anon_sym_interface] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_go] = ACTIONS(2169),
    [anon_sym_spawn] = ACTIONS(2169),
    [anon_sym_json_DOTdecode] = ACTIONS(2169),
    [anon_sym_PIPE] = ACTIONS(2169),
    [anon_sym_LBRACK2] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT_DASH] = ACTIONS(2169),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_GT_GT_GT] = ACTIONS(2169),
    [anon_sym_AMP_CARET] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_PIPE_PIPE] = ACTIONS(2169),
    [anon_sym_or] = ACTIONS(2169),
    [sym_none] = ACTIONS(2169),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [sym_nil] = ACTIONS(2169),
    [anon_sym_QMARK_DOT] = ACTIONS(2169),
    [anon_sym_POUND_LBRACK] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_DOLLARif] = ACTIONS(2169),
    [anon_sym_DOLLARelse] = ACTIONS(2169),
    [anon_sym_is] = ACTIONS(2169),
    [anon_sym_BANGis] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_BANGin] = ACTIONS(2169),
    [anon_sym_match] = ACTIONS(2169),
    [anon_sym_select] = ACTIONS(2169),
    [anon_sym_STAR_EQ] = ACTIONS(2169),
    [anon_sym_SLASH_EQ] = ACTIONS(2169),
    [anon_sym_PERCENT_EQ] = ACTIONS(2169),
    [anon_sym_LT_LT_EQ] = ACTIONS(2169),
    [anon_sym_GT_GT_EQ] = ACTIONS(2169),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2169),
    [anon_sym_AMP_EQ] = ACTIONS(2169),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2169),
    [anon_sym_PLUS_EQ] = ACTIONS(2169),
    [anon_sym_DASH_EQ] = ACTIONS(2169),
    [anon_sym_PIPE_EQ] = ACTIONS(2169),
    [anon_sym_CARET_EQ] = ACTIONS(2169),
    [anon_sym_COLON_EQ] = ACTIONS(2169),
    [anon_sym_lock] = ACTIONS(2169),
    [anon_sym_rlock] = ACTIONS(2169),
    [anon_sym_unsafe] = ACTIONS(2169),
    [anon_sym_sql] = ACTIONS(2169),
    [sym_int_literal] = ACTIONS(2169),
    [sym_float_literal] = ACTIONS(2169),
    [sym_rune_literal] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [anon_sym_c_SQUOTE] = ACTIONS(2169),
    [anon_sym_c_DQUOTE] = ACTIONS(2169),
    [anon_sym_r_SQUOTE] = ACTIONS(2169),
    [anon_sym_r_DQUOTE] = ACTIONS(2169),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_map_LBRACK] = ACTIONS(2169),
    [anon_sym_chan] = ACTIONS(2169),
    [anon_sym_thread] = ACTIONS(2169),
    [anon_sym_atomic] = ACTIONS(2169),
    [anon_sym_assert] = ACTIONS(2169),
    [anon_sym_defer] = ACTIONS(2169),
    [anon_sym_goto] = ACTIONS(2169),
    [anon_sym_break] = ACTIONS(2169),
    [anon_sym_continue] = ACTIONS(2169),
    [anon_sym_return] = ACTIONS(2169),
    [anon_sym_DOLLARfor] = ACTIONS(2169),
    [anon_sym_for] = ACTIONS(2169),
    [anon_sym_POUND] = ACTIONS(2169),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym_AT_LBRACK] = ACTIONS(2169),
  },
  [313] = {
    [sym_line_comment] = STATE(313),
    [sym_block_comment] = STATE(313),
    [ts_builtin_sym_end] = ACTIONS(2145),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_CR] = ACTIONS(2147),
    [anon_sym_CR_LF] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2335),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2335),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_COMMA] = ACTIONS(2335),
    [anon_sym_const] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym_EQ] = ACTIONS(2335),
    [anon_sym___global] = ACTIONS(2147),
    [anon_sym_type] = ACTIONS(2147),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2335),
    [anon_sym_PERCENT] = ACTIONS(2335),
    [anon_sym_LT] = ACTIONS(2335),
    [anon_sym_GT] = ACTIONS(2335),
    [anon_sym_EQ_EQ] = ACTIONS(2335),
    [anon_sym_BANG_EQ] = ACTIONS(2335),
    [anon_sym_LT_EQ] = ACTIONS(2335),
    [anon_sym_GT_EQ] = ACTIONS(2335),
    [anon_sym_LBRACK] = ACTIONS(2337),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_union] = ACTIONS(2147),
    [anon_sym_pub] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_enum] = ACTIONS(2147),
    [anon_sym_interface] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2335),
    [anon_sym_DASH_DASH] = ACTIONS(2335),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2147),
    [anon_sym_PIPE] = ACTIONS(2335),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2335),
    [anon_sym_GT_GT] = ACTIONS(2335),
    [anon_sym_GT_GT_GT] = ACTIONS(2335),
    [anon_sym_AMP_CARET] = ACTIONS(2335),
    [anon_sym_AMP_AMP] = ACTIONS(2335),
    [anon_sym_PIPE_PIPE] = ACTIONS(2335),
    [anon_sym_or] = ACTIONS(2335),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2335),
    [anon_sym_POUND_LBRACK] = ACTIONS(2335),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2335),
    [anon_sym_BANGis] = ACTIONS(2335),
    [anon_sym_in] = ACTIONS(2335),
    [anon_sym_BANGin] = ACTIONS(2335),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_STAR_EQ] = ACTIONS(2335),
    [anon_sym_SLASH_EQ] = ACTIONS(2335),
    [anon_sym_PERCENT_EQ] = ACTIONS(2335),
    [anon_sym_LT_LT_EQ] = ACTIONS(2335),
    [anon_sym_GT_GT_EQ] = ACTIONS(2335),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2335),
    [anon_sym_AMP_EQ] = ACTIONS(2335),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2335),
    [anon_sym_PLUS_EQ] = ACTIONS(2335),
    [anon_sym_DASH_EQ] = ACTIONS(2335),
    [anon_sym_PIPE_EQ] = ACTIONS(2335),
    [anon_sym_CARET_EQ] = ACTIONS(2335),
    [anon_sym_COLON_EQ] = ACTIONS(2335),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2147),
    [sym_rune_literal] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_c_SQUOTE] = ACTIONS(2147),
    [anon_sym_c_DQUOTE] = ACTIONS(2147),
    [anon_sym_r_SQUOTE] = ACTIONS(2147),
    [anon_sym_r_DQUOTE] = ACTIONS(2147),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2147),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
    [anon_sym_assert] = ACTIONS(2147),
    [anon_sym_defer] = ACTIONS(2147),
    [anon_sym_goto] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_continue] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2147),
    [anon_sym_DOLLARfor] = ACTIONS(2147),
    [anon_sym_for] = ACTIONS(2147),
    [anon_sym_POUND] = ACTIONS(2147),
    [anon_sym_asm] = ACTIONS(2147),
    [anon_sym_AT_LBRACK] = ACTIONS(2147),
  },
  [314] = {
    [sym_line_comment] = STATE(314),
    [sym_block_comment] = STATE(314),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(310),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [315] = {
    [sym_line_comment] = STATE(315),
    [sym_block_comment] = STATE(315),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(277),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2341),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [316] = {
    [sym_line_comment] = STATE(316),
    [sym_block_comment] = STATE(316),
    [sym__expression] = STATE(2434),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(869),
    [sym_mutable_expression] = STATE(3972),
    [sym_expression_list] = STATE(4599),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_var_declaration] = STATE(4362),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [317] = {
    [sym_line_comment] = STATE(317),
    [sym_block_comment] = STATE(317),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4138),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(1326),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2343),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [318] = {
    [sym_line_comment] = STATE(318),
    [sym_block_comment] = STATE(318),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(310),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2345),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [319] = {
    [sym_line_comment] = STATE(319),
    [sym_block_comment] = STATE(319),
    [sym__expression] = STATE(2443),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(869),
    [sym_mutable_expression] = STATE(3972),
    [sym_expression_list] = STATE(4599),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_var_declaration] = STATE(4310),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [320] = {
    [sym_line_comment] = STATE(320),
    [sym_block_comment] = STATE(320),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4212),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(2088),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [321] = {
    [sym_line_comment] = STATE(321),
    [sym_block_comment] = STATE(321),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4406),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(1667),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2349),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [322] = {
    [sym_line_comment] = STATE(322),
    [sym_block_comment] = STATE(322),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(314),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2351),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [323] = {
    [sym_line_comment] = STATE(323),
    [sym_block_comment] = STATE(323),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(310),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [324] = {
    [sym_line_comment] = STATE(324),
    [sym_block_comment] = STATE(324),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(260),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2355),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [325] = {
    [sym_line_comment] = STATE(325),
    [sym_block_comment] = STATE(325),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4363),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(1499),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2357),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [326] = {
    [sym_line_comment] = STATE(326),
    [sym_block_comment] = STATE(326),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(328),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2359),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [327] = {
    [sym_line_comment] = STATE(327),
    [sym_block_comment] = STATE(327),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4316),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(2475),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [328] = {
    [sym_line_comment] = STATE(328),
    [sym_block_comment] = STATE(328),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(310),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [329] = {
    [sym_line_comment] = STATE(329),
    [sym_block_comment] = STATE(329),
    [sym__expression] = STATE(2655),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_map_keyed_element] = STATE(2199),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_map_init_expression_repeat1] = STATE(323),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(2365),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [330] = {
    [sym_line_comment] = STATE(330),
    [sym_block_comment] = STATE(330),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4406),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(1667),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [331] = {
    [sym_line_comment] = STATE(331),
    [sym_block_comment] = STATE(331),
    [sym__expression] = STATE(2411),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(869),
    [sym_mutable_expression] = STATE(3972),
    [sym_expression_list] = STATE(4599),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_var_declaration] = STATE(4115),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [332] = {
    [sym_line_comment] = STATE(332),
    [sym_block_comment] = STATE(332),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4323),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_block] = STATE(1243),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2369),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [333] = {
    [sym_line_comment] = STATE(333),
    [sym_block_comment] = STATE(333),
    [ts_builtin_sym_end] = ACTIONS(2371),
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2373),
    [anon_sym_CR] = ACTIONS(2373),
    [anon_sym_CR_LF] = ACTIONS(2373),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2373),
    [anon_sym_as] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2373),
    [anon_sym_COMMA] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym_EQ] = ACTIONS(2373),
    [anon_sym___global] = ACTIONS(2373),
    [anon_sym_type] = ACTIONS(2373),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_SLASH] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2373),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_pub] = ACTIONS(2373),
    [anon_sym_mut] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2373),
    [anon_sym_QMARK] = ACTIONS(2373),
    [anon_sym_BANG] = ACTIONS(2373),
    [anon_sym_go] = ACTIONS(2373),
    [anon_sym_spawn] = ACTIONS(2373),
    [anon_sym_json_DOTdecode] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_LBRACK2] = ACTIONS(2373),
    [anon_sym_TILDE] = ACTIONS(2373),
    [anon_sym_CARET] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_LT_DASH] = ACTIONS(2373),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2373),
    [anon_sym_AMP_CARET] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2373),
    [anon_sym_or] = ACTIONS(2373),
    [sym_none] = ACTIONS(2373),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [sym_nil] = ACTIONS(2373),
    [anon_sym_QMARK_DOT] = ACTIONS(2373),
    [anon_sym_POUND_LBRACK] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_DOLLARif] = ACTIONS(2373),
    [anon_sym_is] = ACTIONS(2373),
    [anon_sym_BANGis] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_BANGin] = ACTIONS(2373),
    [anon_sym_match] = ACTIONS(2373),
    [anon_sym_select] = ACTIONS(2373),
    [anon_sym_STAR_EQ] = ACTIONS(2373),
    [anon_sym_SLASH_EQ] = ACTIONS(2373),
    [anon_sym_PERCENT_EQ] = ACTIONS(2373),
    [anon_sym_LT_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT_GT_EQ] = ACTIONS(2373),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2373),
    [anon_sym_AMP_EQ] = ACTIONS(2373),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2373),
    [anon_sym_PLUS_EQ] = ACTIONS(2373),
    [anon_sym_DASH_EQ] = ACTIONS(2373),
    [anon_sym_PIPE_EQ] = ACTIONS(2373),
    [anon_sym_CARET_EQ] = ACTIONS(2373),
    [anon_sym_COLON_EQ] = ACTIONS(2373),
    [anon_sym_lock] = ACTIONS(2373),
    [anon_sym_rlock] = ACTIONS(2373),
    [anon_sym_unsafe] = ACTIONS(2373),
    [anon_sym_sql] = ACTIONS(2373),
    [sym_int_literal] = ACTIONS(2373),
    [sym_float_literal] = ACTIONS(2373),
    [sym_rune_literal] = ACTIONS(2373),
    [anon_sym_SQUOTE] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(2373),
    [anon_sym_c_SQUOTE] = ACTIONS(2373),
    [anon_sym_c_DQUOTE] = ACTIONS(2373),
    [anon_sym_r_SQUOTE] = ACTIONS(2373),
    [anon_sym_r_DQUOTE] = ACTIONS(2373),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_map_LBRACK] = ACTIONS(2373),
    [anon_sym_chan] = ACTIONS(2373),
    [anon_sym_thread] = ACTIONS(2373),
    [anon_sym_atomic] = ACTIONS(2373),
    [anon_sym_assert] = ACTIONS(2373),
    [anon_sym_defer] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_DOLLARfor] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_POUND] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym_AT_LBRACK] = ACTIONS(2373),
  },
  [334] = {
    [sym_line_comment] = STATE(334),
    [sym_block_comment] = STATE(334),
    [ts_builtin_sym_end] = ACTIONS(2375),
    [sym_identifier] = ACTIONS(2377),
    [anon_sym_LF] = ACTIONS(2377),
    [anon_sym_CR] = ACTIONS(2377),
    [anon_sym_CR_LF] = ACTIONS(2377),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2377),
    [anon_sym_as] = ACTIONS(2377),
    [anon_sym_LBRACE] = ACTIONS(2377),
    [anon_sym_COMMA] = ACTIONS(2377),
    [anon_sym_const] = ACTIONS(2377),
    [anon_sym_LPAREN] = ACTIONS(2377),
    [anon_sym_EQ] = ACTIONS(2377),
    [anon_sym___global] = ACTIONS(2377),
    [anon_sym_type] = ACTIONS(2377),
    [anon_sym_fn] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2377),
    [anon_sym_DASH] = ACTIONS(2377),
    [anon_sym_STAR] = ACTIONS(2377),
    [anon_sym_SLASH] = ACTIONS(2377),
    [anon_sym_PERCENT] = ACTIONS(2377),
    [anon_sym_LT] = ACTIONS(2377),
    [anon_sym_GT] = ACTIONS(2377),
    [anon_sym_EQ_EQ] = ACTIONS(2377),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2377),
    [anon_sym_GT_EQ] = ACTIONS(2377),
    [anon_sym_LBRACK] = ACTIONS(2375),
    [anon_sym_struct] = ACTIONS(2377),
    [anon_sym_union] = ACTIONS(2377),
    [anon_sym_pub] = ACTIONS(2377),
    [anon_sym_mut] = ACTIONS(2377),
    [anon_sym_enum] = ACTIONS(2377),
    [anon_sym_interface] = ACTIONS(2377),
    [anon_sym_PLUS_PLUS] = ACTIONS(2377),
    [anon_sym_DASH_DASH] = ACTIONS(2377),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2377),
    [anon_sym_go] = ACTIONS(2377),
    [anon_sym_spawn] = ACTIONS(2377),
    [anon_sym_json_DOTdecode] = ACTIONS(2377),
    [anon_sym_PIPE] = ACTIONS(2377),
    [anon_sym_LBRACK2] = ACTIONS(2377),
    [anon_sym_TILDE] = ACTIONS(2377),
    [anon_sym_CARET] = ACTIONS(2377),
    [anon_sym_AMP] = ACTIONS(2377),
    [anon_sym_LT_DASH] = ACTIONS(2377),
    [anon_sym_LT_LT] = ACTIONS(2377),
    [anon_sym_GT_GT] = ACTIONS(2377),
    [anon_sym_GT_GT_GT] = ACTIONS(2377),
    [anon_sym_AMP_CARET] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_or] = ACTIONS(2377),
    [sym_none] = ACTIONS(2377),
    [sym_true] = ACTIONS(2377),
    [sym_false] = ACTIONS(2377),
    [sym_nil] = ACTIONS(2377),
    [anon_sym_QMARK_DOT] = ACTIONS(2377),
    [anon_sym_POUND_LBRACK] = ACTIONS(2377),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_DOLLARif] = ACTIONS(2377),
    [anon_sym_is] = ACTIONS(2377),
    [anon_sym_BANGis] = ACTIONS(2377),
    [anon_sym_in] = ACTIONS(2377),
    [anon_sym_BANGin] = ACTIONS(2377),
    [anon_sym_match] = ACTIONS(2377),
    [anon_sym_select] = ACTIONS(2377),
    [anon_sym_STAR_EQ] = ACTIONS(2377),
    [anon_sym_SLASH_EQ] = ACTIONS(2377),
    [anon_sym_PERCENT_EQ] = ACTIONS(2377),
    [anon_sym_LT_LT_EQ] = ACTIONS(2377),
    [anon_sym_GT_GT_EQ] = ACTIONS(2377),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2377),
    [anon_sym_AMP_EQ] = ACTIONS(2377),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2377),
    [anon_sym_PLUS_EQ] = ACTIONS(2377),
    [anon_sym_DASH_EQ] = ACTIONS(2377),
    [anon_sym_PIPE_EQ] = ACTIONS(2377),
    [anon_sym_CARET_EQ] = ACTIONS(2377),
    [anon_sym_COLON_EQ] = ACTIONS(2377),
    [anon_sym_lock] = ACTIONS(2377),
    [anon_sym_rlock] = ACTIONS(2377),
    [anon_sym_unsafe] = ACTIONS(2377),
    [anon_sym_sql] = ACTIONS(2377),
    [sym_int_literal] = ACTIONS(2377),
    [sym_float_literal] = ACTIONS(2377),
    [sym_rune_literal] = ACTIONS(2377),
    [anon_sym_SQUOTE] = ACTIONS(2377),
    [anon_sym_DQUOTE] = ACTIONS(2377),
    [anon_sym_c_SQUOTE] = ACTIONS(2377),
    [anon_sym_c_DQUOTE] = ACTIONS(2377),
    [anon_sym_r_SQUOTE] = ACTIONS(2377),
    [anon_sym_r_DQUOTE] = ACTIONS(2377),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2377),
    [anon_sym_shared] = ACTIONS(2377),
    [anon_sym_map_LBRACK] = ACTIONS(2377),
    [anon_sym_chan] = ACTIONS(2377),
    [anon_sym_thread] = ACTIONS(2377),
    [anon_sym_atomic] = ACTIONS(2377),
    [anon_sym_assert] = ACTIONS(2377),
    [anon_sym_defer] = ACTIONS(2377),
    [anon_sym_goto] = ACTIONS(2377),
    [anon_sym_break] = ACTIONS(2377),
    [anon_sym_continue] = ACTIONS(2377),
    [anon_sym_return] = ACTIONS(2377),
    [anon_sym_DOLLARfor] = ACTIONS(2377),
    [anon_sym_for] = ACTIONS(2377),
    [anon_sym_POUND] = ACTIONS(2377),
    [anon_sym_asm] = ACTIONS(2377),
    [anon_sym_AT_LBRACK] = ACTIONS(2377),
  },
  [335] = {
    [sym_line_comment] = STATE(335),
    [sym_block_comment] = STATE(335),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4421),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [336] = {
    [sym_line_comment] = STATE(336),
    [sym_block_comment] = STATE(336),
    [ts_builtin_sym_end] = ACTIONS(2381),
    [sym_identifier] = ACTIONS(2383),
    [anon_sym_LF] = ACTIONS(2383),
    [anon_sym_CR] = ACTIONS(2383),
    [anon_sym_CR_LF] = ACTIONS(2383),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2383),
    [anon_sym_as] = ACTIONS(2383),
    [anon_sym_LBRACE] = ACTIONS(2383),
    [anon_sym_COMMA] = ACTIONS(2383),
    [anon_sym_const] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2383),
    [anon_sym_EQ] = ACTIONS(2383),
    [anon_sym___global] = ACTIONS(2383),
    [anon_sym_type] = ACTIONS(2383),
    [anon_sym_fn] = ACTIONS(2383),
    [anon_sym_PLUS] = ACTIONS(2383),
    [anon_sym_DASH] = ACTIONS(2383),
    [anon_sym_STAR] = ACTIONS(2383),
    [anon_sym_SLASH] = ACTIONS(2383),
    [anon_sym_PERCENT] = ACTIONS(2383),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_GT] = ACTIONS(2383),
    [anon_sym_EQ_EQ] = ACTIONS(2383),
    [anon_sym_BANG_EQ] = ACTIONS(2383),
    [anon_sym_LT_EQ] = ACTIONS(2383),
    [anon_sym_GT_EQ] = ACTIONS(2383),
    [anon_sym_LBRACK] = ACTIONS(2381),
    [anon_sym_struct] = ACTIONS(2383),
    [anon_sym_union] = ACTIONS(2383),
    [anon_sym_pub] = ACTIONS(2383),
    [anon_sym_mut] = ACTIONS(2383),
    [anon_sym_enum] = ACTIONS(2383),
    [anon_sym_interface] = ACTIONS(2383),
    [anon_sym_PLUS_PLUS] = ACTIONS(2383),
    [anon_sym_DASH_DASH] = ACTIONS(2383),
    [anon_sym_QMARK] = ACTIONS(2383),
    [anon_sym_BANG] = ACTIONS(2383),
    [anon_sym_go] = ACTIONS(2383),
    [anon_sym_spawn] = ACTIONS(2383),
    [anon_sym_json_DOTdecode] = ACTIONS(2383),
    [anon_sym_PIPE] = ACTIONS(2383),
    [anon_sym_LBRACK2] = ACTIONS(2383),
    [anon_sym_TILDE] = ACTIONS(2383),
    [anon_sym_CARET] = ACTIONS(2383),
    [anon_sym_AMP] = ACTIONS(2383),
    [anon_sym_LT_DASH] = ACTIONS(2383),
    [anon_sym_LT_LT] = ACTIONS(2383),
    [anon_sym_GT_GT] = ACTIONS(2383),
    [anon_sym_GT_GT_GT] = ACTIONS(2383),
    [anon_sym_AMP_CARET] = ACTIONS(2383),
    [anon_sym_AMP_AMP] = ACTIONS(2383),
    [anon_sym_PIPE_PIPE] = ACTIONS(2383),
    [anon_sym_or] = ACTIONS(2383),
    [sym_none] = ACTIONS(2383),
    [sym_true] = ACTIONS(2383),
    [sym_false] = ACTIONS(2383),
    [sym_nil] = ACTIONS(2383),
    [anon_sym_QMARK_DOT] = ACTIONS(2383),
    [anon_sym_POUND_LBRACK] = ACTIONS(2383),
    [anon_sym_if] = ACTIONS(2383),
    [anon_sym_DOLLARif] = ACTIONS(2383),
    [anon_sym_is] = ACTIONS(2383),
    [anon_sym_BANGis] = ACTIONS(2383),
    [anon_sym_in] = ACTIONS(2383),
    [anon_sym_BANGin] = ACTIONS(2383),
    [anon_sym_match] = ACTIONS(2383),
    [anon_sym_select] = ACTIONS(2383),
    [anon_sym_STAR_EQ] = ACTIONS(2383),
    [anon_sym_SLASH_EQ] = ACTIONS(2383),
    [anon_sym_PERCENT_EQ] = ACTIONS(2383),
    [anon_sym_LT_LT_EQ] = ACTIONS(2383),
    [anon_sym_GT_GT_EQ] = ACTIONS(2383),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2383),
    [anon_sym_AMP_EQ] = ACTIONS(2383),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2383),
    [anon_sym_PLUS_EQ] = ACTIONS(2383),
    [anon_sym_DASH_EQ] = ACTIONS(2383),
    [anon_sym_PIPE_EQ] = ACTIONS(2383),
    [anon_sym_CARET_EQ] = ACTIONS(2383),
    [anon_sym_COLON_EQ] = ACTIONS(2383),
    [anon_sym_lock] = ACTIONS(2383),
    [anon_sym_rlock] = ACTIONS(2383),
    [anon_sym_unsafe] = ACTIONS(2383),
    [anon_sym_sql] = ACTIONS(2383),
    [sym_int_literal] = ACTIONS(2383),
    [sym_float_literal] = ACTIONS(2383),
    [sym_rune_literal] = ACTIONS(2383),
    [anon_sym_SQUOTE] = ACTIONS(2383),
    [anon_sym_DQUOTE] = ACTIONS(2383),
    [anon_sym_c_SQUOTE] = ACTIONS(2383),
    [anon_sym_c_DQUOTE] = ACTIONS(2383),
    [anon_sym_r_SQUOTE] = ACTIONS(2383),
    [anon_sym_r_DQUOTE] = ACTIONS(2383),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2383),
    [anon_sym_shared] = ACTIONS(2383),
    [anon_sym_map_LBRACK] = ACTIONS(2383),
    [anon_sym_chan] = ACTIONS(2383),
    [anon_sym_thread] = ACTIONS(2383),
    [anon_sym_atomic] = ACTIONS(2383),
    [anon_sym_assert] = ACTIONS(2383),
    [anon_sym_defer] = ACTIONS(2383),
    [anon_sym_goto] = ACTIONS(2383),
    [anon_sym_break] = ACTIONS(2383),
    [anon_sym_continue] = ACTIONS(2383),
    [anon_sym_return] = ACTIONS(2383),
    [anon_sym_DOLLARfor] = ACTIONS(2383),
    [anon_sym_for] = ACTIONS(2383),
    [anon_sym_POUND] = ACTIONS(2383),
    [anon_sym_asm] = ACTIONS(2383),
    [anon_sym_AT_LBRACK] = ACTIONS(2383),
  },
  [337] = {
    [sym_line_comment] = STATE(337),
    [sym_block_comment] = STATE(337),
    [sym__expression] = STATE(2607),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4479),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [338] = {
    [sym_line_comment] = STATE(338),
    [sym_block_comment] = STATE(338),
    [sym__expression] = STATE(2607),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3688),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4479),
    [sym_identifier] = ACTIONS(2385),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(2387),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2389),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(2391),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [339] = {
    [sym_line_comment] = STATE(339),
    [sym_block_comment] = STATE(339),
    [sym__expression] = STATE(2605),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4624),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [340] = {
    [sym_line_comment] = STATE(340),
    [sym_block_comment] = STATE(340),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4421),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2393),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [341] = {
    [sym_line_comment] = STATE(341),
    [sym_block_comment] = STATE(341),
    [ts_builtin_sym_end] = ACTIONS(2395),
    [sym_identifier] = ACTIONS(2397),
    [anon_sym_LF] = ACTIONS(2397),
    [anon_sym_CR] = ACTIONS(2397),
    [anon_sym_CR_LF] = ACTIONS(2397),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2397),
    [anon_sym_as] = ACTIONS(2397),
    [anon_sym_LBRACE] = ACTIONS(2397),
    [anon_sym_COMMA] = ACTIONS(2397),
    [anon_sym_const] = ACTIONS(2397),
    [anon_sym_LPAREN] = ACTIONS(2397),
    [anon_sym_EQ] = ACTIONS(2397),
    [anon_sym___global] = ACTIONS(2397),
    [anon_sym_type] = ACTIONS(2397),
    [anon_sym_fn] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(2397),
    [anon_sym_DASH] = ACTIONS(2397),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_SLASH] = ACTIONS(2397),
    [anon_sym_PERCENT] = ACTIONS(2397),
    [anon_sym_LT] = ACTIONS(2397),
    [anon_sym_GT] = ACTIONS(2397),
    [anon_sym_EQ_EQ] = ACTIONS(2397),
    [anon_sym_BANG_EQ] = ACTIONS(2397),
    [anon_sym_LT_EQ] = ACTIONS(2397),
    [anon_sym_GT_EQ] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(2395),
    [anon_sym_struct] = ACTIONS(2397),
    [anon_sym_union] = ACTIONS(2397),
    [anon_sym_pub] = ACTIONS(2397),
    [anon_sym_mut] = ACTIONS(2397),
    [anon_sym_enum] = ACTIONS(2397),
    [anon_sym_interface] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2397),
    [anon_sym_DASH_DASH] = ACTIONS(2397),
    [anon_sym_QMARK] = ACTIONS(2397),
    [anon_sym_BANG] = ACTIONS(2397),
    [anon_sym_go] = ACTIONS(2397),
    [anon_sym_spawn] = ACTIONS(2397),
    [anon_sym_json_DOTdecode] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(2397),
    [anon_sym_LBRACK2] = ACTIONS(2397),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_CARET] = ACTIONS(2397),
    [anon_sym_AMP] = ACTIONS(2397),
    [anon_sym_LT_DASH] = ACTIONS(2397),
    [anon_sym_LT_LT] = ACTIONS(2397),
    [anon_sym_GT_GT] = ACTIONS(2397),
    [anon_sym_GT_GT_GT] = ACTIONS(2397),
    [anon_sym_AMP_CARET] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(2397),
    [anon_sym_PIPE_PIPE] = ACTIONS(2397),
    [anon_sym_or] = ACTIONS(2397),
    [sym_none] = ACTIONS(2397),
    [sym_true] = ACTIONS(2397),
    [sym_false] = ACTIONS(2397),
    [sym_nil] = ACTIONS(2397),
    [anon_sym_QMARK_DOT] = ACTIONS(2397),
    [anon_sym_POUND_LBRACK] = ACTIONS(2397),
    [anon_sym_if] = ACTIONS(2397),
    [anon_sym_DOLLARif] = ACTIONS(2397),
    [anon_sym_is] = ACTIONS(2397),
    [anon_sym_BANGis] = ACTIONS(2397),
    [anon_sym_in] = ACTIONS(2397),
    [anon_sym_BANGin] = ACTIONS(2397),
    [anon_sym_match] = ACTIONS(2397),
    [anon_sym_select] = ACTIONS(2397),
    [anon_sym_STAR_EQ] = ACTIONS(2397),
    [anon_sym_SLASH_EQ] = ACTIONS(2397),
    [anon_sym_PERCENT_EQ] = ACTIONS(2397),
    [anon_sym_LT_LT_EQ] = ACTIONS(2397),
    [anon_sym_GT_GT_EQ] = ACTIONS(2397),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2397),
    [anon_sym_AMP_EQ] = ACTIONS(2397),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2397),
    [anon_sym_PLUS_EQ] = ACTIONS(2397),
    [anon_sym_DASH_EQ] = ACTIONS(2397),
    [anon_sym_PIPE_EQ] = ACTIONS(2397),
    [anon_sym_CARET_EQ] = ACTIONS(2397),
    [anon_sym_COLON_EQ] = ACTIONS(2397),
    [anon_sym_lock] = ACTIONS(2397),
    [anon_sym_rlock] = ACTIONS(2397),
    [anon_sym_unsafe] = ACTIONS(2397),
    [anon_sym_sql] = ACTIONS(2397),
    [sym_int_literal] = ACTIONS(2397),
    [sym_float_literal] = ACTIONS(2397),
    [sym_rune_literal] = ACTIONS(2397),
    [anon_sym_SQUOTE] = ACTIONS(2397),
    [anon_sym_DQUOTE] = ACTIONS(2397),
    [anon_sym_c_SQUOTE] = ACTIONS(2397),
    [anon_sym_c_DQUOTE] = ACTIONS(2397),
    [anon_sym_r_SQUOTE] = ACTIONS(2397),
    [anon_sym_r_DQUOTE] = ACTIONS(2397),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2397),
    [anon_sym_shared] = ACTIONS(2397),
    [anon_sym_map_LBRACK] = ACTIONS(2397),
    [anon_sym_chan] = ACTIONS(2397),
    [anon_sym_thread] = ACTIONS(2397),
    [anon_sym_atomic] = ACTIONS(2397),
    [anon_sym_assert] = ACTIONS(2397),
    [anon_sym_defer] = ACTIONS(2397),
    [anon_sym_goto] = ACTIONS(2397),
    [anon_sym_break] = ACTIONS(2397),
    [anon_sym_continue] = ACTIONS(2397),
    [anon_sym_return] = ACTIONS(2397),
    [anon_sym_DOLLARfor] = ACTIONS(2397),
    [anon_sym_for] = ACTIONS(2397),
    [anon_sym_POUND] = ACTIONS(2397),
    [anon_sym_asm] = ACTIONS(2397),
    [anon_sym_AT_LBRACK] = ACTIONS(2397),
  },
  [342] = {
    [sym_line_comment] = STATE(342),
    [sym_block_comment] = STATE(342),
    [ts_builtin_sym_end] = ACTIONS(2399),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_LF] = ACTIONS(2401),
    [anon_sym_CR] = ACTIONS(2401),
    [anon_sym_CR_LF] = ACTIONS(2401),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2401),
    [anon_sym_as] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(2401),
    [anon_sym_COMMA] = ACTIONS(2401),
    [anon_sym_const] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2401),
    [anon_sym_EQ] = ACTIONS(2401),
    [anon_sym___global] = ACTIONS(2401),
    [anon_sym_type] = ACTIONS(2401),
    [anon_sym_fn] = ACTIONS(2401),
    [anon_sym_PLUS] = ACTIONS(2401),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_STAR] = ACTIONS(2401),
    [anon_sym_SLASH] = ACTIONS(2401),
    [anon_sym_PERCENT] = ACTIONS(2401),
    [anon_sym_LT] = ACTIONS(2401),
    [anon_sym_GT] = ACTIONS(2401),
    [anon_sym_EQ_EQ] = ACTIONS(2401),
    [anon_sym_BANG_EQ] = ACTIONS(2401),
    [anon_sym_LT_EQ] = ACTIONS(2401),
    [anon_sym_GT_EQ] = ACTIONS(2401),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_struct] = ACTIONS(2401),
    [anon_sym_union] = ACTIONS(2401),
    [anon_sym_pub] = ACTIONS(2401),
    [anon_sym_mut] = ACTIONS(2401),
    [anon_sym_enum] = ACTIONS(2401),
    [anon_sym_interface] = ACTIONS(2401),
    [anon_sym_PLUS_PLUS] = ACTIONS(2401),
    [anon_sym_DASH_DASH] = ACTIONS(2401),
    [anon_sym_QMARK] = ACTIONS(2401),
    [anon_sym_BANG] = ACTIONS(2401),
    [anon_sym_go] = ACTIONS(2401),
    [anon_sym_spawn] = ACTIONS(2401),
    [anon_sym_json_DOTdecode] = ACTIONS(2401),
    [anon_sym_PIPE] = ACTIONS(2401),
    [anon_sym_LBRACK2] = ACTIONS(2401),
    [anon_sym_TILDE] = ACTIONS(2401),
    [anon_sym_CARET] = ACTIONS(2401),
    [anon_sym_AMP] = ACTIONS(2401),
    [anon_sym_LT_DASH] = ACTIONS(2401),
    [anon_sym_LT_LT] = ACTIONS(2401),
    [anon_sym_GT_GT] = ACTIONS(2401),
    [anon_sym_GT_GT_GT] = ACTIONS(2401),
    [anon_sym_AMP_CARET] = ACTIONS(2401),
    [anon_sym_AMP_AMP] = ACTIONS(2401),
    [anon_sym_PIPE_PIPE] = ACTIONS(2401),
    [anon_sym_or] = ACTIONS(2401),
    [sym_none] = ACTIONS(2401),
    [sym_true] = ACTIONS(2401),
    [sym_false] = ACTIONS(2401),
    [sym_nil] = ACTIONS(2401),
    [anon_sym_QMARK_DOT] = ACTIONS(2401),
    [anon_sym_POUND_LBRACK] = ACTIONS(2401),
    [anon_sym_if] = ACTIONS(2401),
    [anon_sym_DOLLARif] = ACTIONS(2401),
    [anon_sym_is] = ACTIONS(2401),
    [anon_sym_BANGis] = ACTIONS(2401),
    [anon_sym_in] = ACTIONS(2401),
    [anon_sym_BANGin] = ACTIONS(2401),
    [anon_sym_match] = ACTIONS(2401),
    [anon_sym_select] = ACTIONS(2401),
    [anon_sym_STAR_EQ] = ACTIONS(2401),
    [anon_sym_SLASH_EQ] = ACTIONS(2401),
    [anon_sym_PERCENT_EQ] = ACTIONS(2401),
    [anon_sym_LT_LT_EQ] = ACTIONS(2401),
    [anon_sym_GT_GT_EQ] = ACTIONS(2401),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2401),
    [anon_sym_AMP_EQ] = ACTIONS(2401),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2401),
    [anon_sym_PLUS_EQ] = ACTIONS(2401),
    [anon_sym_DASH_EQ] = ACTIONS(2401),
    [anon_sym_PIPE_EQ] = ACTIONS(2401),
    [anon_sym_CARET_EQ] = ACTIONS(2401),
    [anon_sym_COLON_EQ] = ACTIONS(2401),
    [anon_sym_lock] = ACTIONS(2401),
    [anon_sym_rlock] = ACTIONS(2401),
    [anon_sym_unsafe] = ACTIONS(2401),
    [anon_sym_sql] = ACTIONS(2401),
    [sym_int_literal] = ACTIONS(2401),
    [sym_float_literal] = ACTIONS(2401),
    [sym_rune_literal] = ACTIONS(2401),
    [anon_sym_SQUOTE] = ACTIONS(2401),
    [anon_sym_DQUOTE] = ACTIONS(2401),
    [anon_sym_c_SQUOTE] = ACTIONS(2401),
    [anon_sym_c_DQUOTE] = ACTIONS(2401),
    [anon_sym_r_SQUOTE] = ACTIONS(2401),
    [anon_sym_r_DQUOTE] = ACTIONS(2401),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2401),
    [anon_sym_shared] = ACTIONS(2401),
    [anon_sym_map_LBRACK] = ACTIONS(2401),
    [anon_sym_chan] = ACTIONS(2401),
    [anon_sym_thread] = ACTIONS(2401),
    [anon_sym_atomic] = ACTIONS(2401),
    [anon_sym_assert] = ACTIONS(2401),
    [anon_sym_defer] = ACTIONS(2401),
    [anon_sym_goto] = ACTIONS(2401),
    [anon_sym_break] = ACTIONS(2401),
    [anon_sym_continue] = ACTIONS(2401),
    [anon_sym_return] = ACTIONS(2401),
    [anon_sym_DOLLARfor] = ACTIONS(2401),
    [anon_sym_for] = ACTIONS(2401),
    [anon_sym_POUND] = ACTIONS(2401),
    [anon_sym_asm] = ACTIONS(2401),
    [anon_sym_AT_LBRACK] = ACTIONS(2401),
  },
  [343] = {
    [sym_line_comment] = STATE(343),
    [sym_block_comment] = STATE(343),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(402),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(2403),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [344] = {
    [sym_line_comment] = STATE(344),
    [sym_block_comment] = STATE(344),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1693),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1692),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(449),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(2409),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1615),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [345] = {
    [sym_line_comment] = STATE(345),
    [sym_block_comment] = STATE(345),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4427),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [346] = {
    [sym_line_comment] = STATE(346),
    [sym_block_comment] = STATE(346),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3683),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_COMMA] = ACTIONS(853),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_RPAREN] = ACTIONS(853),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(2415),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2417),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2423),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [347] = {
    [sym_line_comment] = STATE(347),
    [sym_block_comment] = STATE(347),
    [sym__expression] = STATE(2588),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4612),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [348] = {
    [sym_line_comment] = STATE(348),
    [sym_block_comment] = STATE(348),
    [ts_builtin_sym_end] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2429),
    [anon_sym_LF] = ACTIONS(2429),
    [anon_sym_CR] = ACTIONS(2429),
    [anon_sym_CR_LF] = ACTIONS(2429),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2429),
    [anon_sym_as] = ACTIONS(2429),
    [anon_sym_LBRACE] = ACTIONS(2429),
    [anon_sym_COMMA] = ACTIONS(2429),
    [anon_sym_const] = ACTIONS(2429),
    [anon_sym_LPAREN] = ACTIONS(2429),
    [anon_sym_EQ] = ACTIONS(2429),
    [anon_sym___global] = ACTIONS(2429),
    [anon_sym_type] = ACTIONS(2429),
    [anon_sym_fn] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(2429),
    [anon_sym_DASH] = ACTIONS(2429),
    [anon_sym_STAR] = ACTIONS(2429),
    [anon_sym_SLASH] = ACTIONS(2429),
    [anon_sym_PERCENT] = ACTIONS(2429),
    [anon_sym_LT] = ACTIONS(2429),
    [anon_sym_GT] = ACTIONS(2429),
    [anon_sym_EQ_EQ] = ACTIONS(2429),
    [anon_sym_BANG_EQ] = ACTIONS(2429),
    [anon_sym_LT_EQ] = ACTIONS(2429),
    [anon_sym_GT_EQ] = ACTIONS(2429),
    [anon_sym_LBRACK] = ACTIONS(2427),
    [anon_sym_struct] = ACTIONS(2429),
    [anon_sym_union] = ACTIONS(2429),
    [anon_sym_pub] = ACTIONS(2429),
    [anon_sym_mut] = ACTIONS(2429),
    [anon_sym_enum] = ACTIONS(2429),
    [anon_sym_interface] = ACTIONS(2429),
    [anon_sym_PLUS_PLUS] = ACTIONS(2429),
    [anon_sym_DASH_DASH] = ACTIONS(2429),
    [anon_sym_QMARK] = ACTIONS(2429),
    [anon_sym_BANG] = ACTIONS(2429),
    [anon_sym_go] = ACTIONS(2429),
    [anon_sym_spawn] = ACTIONS(2429),
    [anon_sym_json_DOTdecode] = ACTIONS(2429),
    [anon_sym_PIPE] = ACTIONS(2429),
    [anon_sym_LBRACK2] = ACTIONS(2429),
    [anon_sym_TILDE] = ACTIONS(2429),
    [anon_sym_CARET] = ACTIONS(2429),
    [anon_sym_AMP] = ACTIONS(2429),
    [anon_sym_LT_DASH] = ACTIONS(2429),
    [anon_sym_LT_LT] = ACTIONS(2429),
    [anon_sym_GT_GT] = ACTIONS(2429),
    [anon_sym_GT_GT_GT] = ACTIONS(2429),
    [anon_sym_AMP_CARET] = ACTIONS(2429),
    [anon_sym_AMP_AMP] = ACTIONS(2429),
    [anon_sym_PIPE_PIPE] = ACTIONS(2429),
    [anon_sym_or] = ACTIONS(2429),
    [sym_none] = ACTIONS(2429),
    [sym_true] = ACTIONS(2429),
    [sym_false] = ACTIONS(2429),
    [sym_nil] = ACTIONS(2429),
    [anon_sym_QMARK_DOT] = ACTIONS(2429),
    [anon_sym_POUND_LBRACK] = ACTIONS(2429),
    [anon_sym_if] = ACTIONS(2429),
    [anon_sym_DOLLARif] = ACTIONS(2429),
    [anon_sym_is] = ACTIONS(2429),
    [anon_sym_BANGis] = ACTIONS(2429),
    [anon_sym_in] = ACTIONS(2429),
    [anon_sym_BANGin] = ACTIONS(2429),
    [anon_sym_match] = ACTIONS(2429),
    [anon_sym_select] = ACTIONS(2429),
    [anon_sym_STAR_EQ] = ACTIONS(2429),
    [anon_sym_SLASH_EQ] = ACTIONS(2429),
    [anon_sym_PERCENT_EQ] = ACTIONS(2429),
    [anon_sym_LT_LT_EQ] = ACTIONS(2429),
    [anon_sym_GT_GT_EQ] = ACTIONS(2429),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2429),
    [anon_sym_AMP_EQ] = ACTIONS(2429),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2429),
    [anon_sym_PLUS_EQ] = ACTIONS(2429),
    [anon_sym_DASH_EQ] = ACTIONS(2429),
    [anon_sym_PIPE_EQ] = ACTIONS(2429),
    [anon_sym_CARET_EQ] = ACTIONS(2429),
    [anon_sym_COLON_EQ] = ACTIONS(2429),
    [anon_sym_lock] = ACTIONS(2429),
    [anon_sym_rlock] = ACTIONS(2429),
    [anon_sym_unsafe] = ACTIONS(2429),
    [anon_sym_sql] = ACTIONS(2429),
    [sym_int_literal] = ACTIONS(2429),
    [sym_float_literal] = ACTIONS(2429),
    [sym_rune_literal] = ACTIONS(2429),
    [anon_sym_SQUOTE] = ACTIONS(2429),
    [anon_sym_DQUOTE] = ACTIONS(2429),
    [anon_sym_c_SQUOTE] = ACTIONS(2429),
    [anon_sym_c_DQUOTE] = ACTIONS(2429),
    [anon_sym_r_SQUOTE] = ACTIONS(2429),
    [anon_sym_r_DQUOTE] = ACTIONS(2429),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2429),
    [anon_sym_shared] = ACTIONS(2429),
    [anon_sym_map_LBRACK] = ACTIONS(2429),
    [anon_sym_chan] = ACTIONS(2429),
    [anon_sym_thread] = ACTIONS(2429),
    [anon_sym_atomic] = ACTIONS(2429),
    [anon_sym_assert] = ACTIONS(2429),
    [anon_sym_defer] = ACTIONS(2429),
    [anon_sym_goto] = ACTIONS(2429),
    [anon_sym_break] = ACTIONS(2429),
    [anon_sym_continue] = ACTIONS(2429),
    [anon_sym_return] = ACTIONS(2429),
    [anon_sym_DOLLARfor] = ACTIONS(2429),
    [anon_sym_for] = ACTIONS(2429),
    [anon_sym_POUND] = ACTIONS(2429),
    [anon_sym_asm] = ACTIONS(2429),
    [anon_sym_AT_LBRACK] = ACTIONS(2429),
  },
  [349] = {
    [sym_line_comment] = STATE(349),
    [sym_block_comment] = STATE(349),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1693),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1692),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(476),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(2431),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1615),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [350] = {
    [sym_line_comment] = STATE(350),
    [sym_block_comment] = STATE(350),
    [sym__expression] = STATE(2588),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3688),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4612),
    [sym_identifier] = ACTIONS(2385),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(2387),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2389),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(2391),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [351] = {
    [sym_line_comment] = STATE(351),
    [sym_block_comment] = STATE(351),
    [ts_builtin_sym_end] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2435),
    [anon_sym_LF] = ACTIONS(2435),
    [anon_sym_CR] = ACTIONS(2435),
    [anon_sym_CR_LF] = ACTIONS(2435),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2435),
    [anon_sym_as] = ACTIONS(2435),
    [anon_sym_LBRACE] = ACTIONS(2435),
    [anon_sym_COMMA] = ACTIONS(2435),
    [anon_sym_const] = ACTIONS(2435),
    [anon_sym_LPAREN] = ACTIONS(2435),
    [anon_sym_EQ] = ACTIONS(2435),
    [anon_sym___global] = ACTIONS(2435),
    [anon_sym_type] = ACTIONS(2435),
    [anon_sym_fn] = ACTIONS(2435),
    [anon_sym_PLUS] = ACTIONS(2435),
    [anon_sym_DASH] = ACTIONS(2435),
    [anon_sym_STAR] = ACTIONS(2435),
    [anon_sym_SLASH] = ACTIONS(2435),
    [anon_sym_PERCENT] = ACTIONS(2435),
    [anon_sym_LT] = ACTIONS(2435),
    [anon_sym_GT] = ACTIONS(2435),
    [anon_sym_EQ_EQ] = ACTIONS(2435),
    [anon_sym_BANG_EQ] = ACTIONS(2435),
    [anon_sym_LT_EQ] = ACTIONS(2435),
    [anon_sym_GT_EQ] = ACTIONS(2435),
    [anon_sym_LBRACK] = ACTIONS(2433),
    [anon_sym_struct] = ACTIONS(2435),
    [anon_sym_union] = ACTIONS(2435),
    [anon_sym_pub] = ACTIONS(2435),
    [anon_sym_mut] = ACTIONS(2435),
    [anon_sym_enum] = ACTIONS(2435),
    [anon_sym_interface] = ACTIONS(2435),
    [anon_sym_PLUS_PLUS] = ACTIONS(2435),
    [anon_sym_DASH_DASH] = ACTIONS(2435),
    [anon_sym_QMARK] = ACTIONS(2435),
    [anon_sym_BANG] = ACTIONS(2435),
    [anon_sym_go] = ACTIONS(2435),
    [anon_sym_spawn] = ACTIONS(2435),
    [anon_sym_json_DOTdecode] = ACTIONS(2435),
    [anon_sym_PIPE] = ACTIONS(2435),
    [anon_sym_LBRACK2] = ACTIONS(2435),
    [anon_sym_TILDE] = ACTIONS(2435),
    [anon_sym_CARET] = ACTIONS(2435),
    [anon_sym_AMP] = ACTIONS(2435),
    [anon_sym_LT_DASH] = ACTIONS(2435),
    [anon_sym_LT_LT] = ACTIONS(2435),
    [anon_sym_GT_GT] = ACTIONS(2435),
    [anon_sym_GT_GT_GT] = ACTIONS(2435),
    [anon_sym_AMP_CARET] = ACTIONS(2435),
    [anon_sym_AMP_AMP] = ACTIONS(2435),
    [anon_sym_PIPE_PIPE] = ACTIONS(2435),
    [anon_sym_or] = ACTIONS(2435),
    [sym_none] = ACTIONS(2435),
    [sym_true] = ACTIONS(2435),
    [sym_false] = ACTIONS(2435),
    [sym_nil] = ACTIONS(2435),
    [anon_sym_QMARK_DOT] = ACTIONS(2435),
    [anon_sym_POUND_LBRACK] = ACTIONS(2435),
    [anon_sym_if] = ACTIONS(2435),
    [anon_sym_DOLLARif] = ACTIONS(2435),
    [anon_sym_is] = ACTIONS(2435),
    [anon_sym_BANGis] = ACTIONS(2435),
    [anon_sym_in] = ACTIONS(2435),
    [anon_sym_BANGin] = ACTIONS(2435),
    [anon_sym_match] = ACTIONS(2435),
    [anon_sym_select] = ACTIONS(2435),
    [anon_sym_STAR_EQ] = ACTIONS(2435),
    [anon_sym_SLASH_EQ] = ACTIONS(2435),
    [anon_sym_PERCENT_EQ] = ACTIONS(2435),
    [anon_sym_LT_LT_EQ] = ACTIONS(2435),
    [anon_sym_GT_GT_EQ] = ACTIONS(2435),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2435),
    [anon_sym_AMP_EQ] = ACTIONS(2435),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2435),
    [anon_sym_PLUS_EQ] = ACTIONS(2435),
    [anon_sym_DASH_EQ] = ACTIONS(2435),
    [anon_sym_PIPE_EQ] = ACTIONS(2435),
    [anon_sym_CARET_EQ] = ACTIONS(2435),
    [anon_sym_COLON_EQ] = ACTIONS(2435),
    [anon_sym_lock] = ACTIONS(2435),
    [anon_sym_rlock] = ACTIONS(2435),
    [anon_sym_unsafe] = ACTIONS(2435),
    [anon_sym_sql] = ACTIONS(2435),
    [sym_int_literal] = ACTIONS(2435),
    [sym_float_literal] = ACTIONS(2435),
    [sym_rune_literal] = ACTIONS(2435),
    [anon_sym_SQUOTE] = ACTIONS(2435),
    [anon_sym_DQUOTE] = ACTIONS(2435),
    [anon_sym_c_SQUOTE] = ACTIONS(2435),
    [anon_sym_c_DQUOTE] = ACTIONS(2435),
    [anon_sym_r_SQUOTE] = ACTIONS(2435),
    [anon_sym_r_DQUOTE] = ACTIONS(2435),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2435),
    [anon_sym_shared] = ACTIONS(2435),
    [anon_sym_map_LBRACK] = ACTIONS(2435),
    [anon_sym_chan] = ACTIONS(2435),
    [anon_sym_thread] = ACTIONS(2435),
    [anon_sym_atomic] = ACTIONS(2435),
    [anon_sym_assert] = ACTIONS(2435),
    [anon_sym_defer] = ACTIONS(2435),
    [anon_sym_goto] = ACTIONS(2435),
    [anon_sym_break] = ACTIONS(2435),
    [anon_sym_continue] = ACTIONS(2435),
    [anon_sym_return] = ACTIONS(2435),
    [anon_sym_DOLLARfor] = ACTIONS(2435),
    [anon_sym_for] = ACTIONS(2435),
    [anon_sym_POUND] = ACTIONS(2435),
    [anon_sym_asm] = ACTIONS(2435),
    [anon_sym_AT_LBRACK] = ACTIONS(2435),
  },
  [352] = {
    [sym_line_comment] = STATE(352),
    [sym_block_comment] = STATE(352),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4440),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2437),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [353] = {
    [sym_line_comment] = STATE(353),
    [sym_block_comment] = STATE(353),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1693),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1692),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(478),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(1581),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1615),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [354] = {
    [sym_line_comment] = STATE(354),
    [sym_block_comment] = STATE(354),
    [sym__expression] = STATE(2584),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3688),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4466),
    [sym_identifier] = ACTIONS(2385),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(2387),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2389),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(2391),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [355] = {
    [sym_line_comment] = STATE(355),
    [sym_block_comment] = STATE(355),
    [sym__expression] = STATE(2584),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4466),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [356] = {
    [sym_line_comment] = STATE(356),
    [sym_block_comment] = STATE(356),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1693),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1692),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(509),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(2439),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1615),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [357] = {
    [sym_line_comment] = STATE(357),
    [sym_block_comment] = STATE(357),
    [ts_builtin_sym_end] = ACTIONS(2441),
    [sym_identifier] = ACTIONS(2443),
    [anon_sym_LF] = ACTIONS(2443),
    [anon_sym_CR] = ACTIONS(2443),
    [anon_sym_CR_LF] = ACTIONS(2443),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2445),
    [anon_sym_as] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(2443),
    [anon_sym_COMMA] = ACTIONS(2443),
    [anon_sym_const] = ACTIONS(2443),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym_EQ] = ACTIONS(2443),
    [anon_sym___global] = ACTIONS(2443),
    [anon_sym_type] = ACTIONS(2443),
    [anon_sym_fn] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2445),
    [anon_sym_STAR] = ACTIONS(2445),
    [anon_sym_SLASH] = ACTIONS(2445),
    [anon_sym_PERCENT] = ACTIONS(2445),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_GT] = ACTIONS(2445),
    [anon_sym_EQ_EQ] = ACTIONS(2445),
    [anon_sym_BANG_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_struct] = ACTIONS(2443),
    [anon_sym_union] = ACTIONS(2443),
    [anon_sym_pub] = ACTIONS(2443),
    [anon_sym_mut] = ACTIONS(2443),
    [anon_sym_enum] = ACTIONS(2443),
    [anon_sym_interface] = ACTIONS(2443),
    [anon_sym_PLUS_PLUS] = ACTIONS(2445),
    [anon_sym_DASH_DASH] = ACTIONS(2445),
    [anon_sym_QMARK] = ACTIONS(2445),
    [anon_sym_BANG] = ACTIONS(2445),
    [anon_sym_go] = ACTIONS(2443),
    [anon_sym_spawn] = ACTIONS(2443),
    [anon_sym_json_DOTdecode] = ACTIONS(2443),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_LBRACK2] = ACTIONS(2445),
    [anon_sym_TILDE] = ACTIONS(2443),
    [anon_sym_CARET] = ACTIONS(2445),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_LT_DASH] = ACTIONS(2443),
    [anon_sym_LT_LT] = ACTIONS(2445),
    [anon_sym_GT_GT] = ACTIONS(2445),
    [anon_sym_GT_GT_GT] = ACTIONS(2445),
    [anon_sym_AMP_CARET] = ACTIONS(2445),
    [anon_sym_AMP_AMP] = ACTIONS(2445),
    [anon_sym_PIPE_PIPE] = ACTIONS(2445),
    [anon_sym_or] = ACTIONS(2445),
    [sym_none] = ACTIONS(2443),
    [sym_true] = ACTIONS(2443),
    [sym_false] = ACTIONS(2443),
    [sym_nil] = ACTIONS(2443),
    [anon_sym_QMARK_DOT] = ACTIONS(2445),
    [anon_sym_POUND_LBRACK] = ACTIONS(2445),
    [anon_sym_if] = ACTIONS(2443),
    [anon_sym_DOLLARif] = ACTIONS(2443),
    [anon_sym_is] = ACTIONS(2445),
    [anon_sym_BANGis] = ACTIONS(2445),
    [anon_sym_in] = ACTIONS(2445),
    [anon_sym_BANGin] = ACTIONS(2445),
    [anon_sym_match] = ACTIONS(2443),
    [anon_sym_select] = ACTIONS(2443),
    [anon_sym_STAR_EQ] = ACTIONS(2443),
    [anon_sym_SLASH_EQ] = ACTIONS(2443),
    [anon_sym_PERCENT_EQ] = ACTIONS(2443),
    [anon_sym_LT_LT_EQ] = ACTIONS(2443),
    [anon_sym_GT_GT_EQ] = ACTIONS(2443),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2443),
    [anon_sym_AMP_EQ] = ACTIONS(2443),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2443),
    [anon_sym_PLUS_EQ] = ACTIONS(2443),
    [anon_sym_DASH_EQ] = ACTIONS(2443),
    [anon_sym_PIPE_EQ] = ACTIONS(2443),
    [anon_sym_CARET_EQ] = ACTIONS(2443),
    [anon_sym_COLON_EQ] = ACTIONS(2443),
    [anon_sym_lock] = ACTIONS(2443),
    [anon_sym_rlock] = ACTIONS(2443),
    [anon_sym_unsafe] = ACTIONS(2443),
    [anon_sym_sql] = ACTIONS(2443),
    [sym_int_literal] = ACTIONS(2443),
    [sym_float_literal] = ACTIONS(2443),
    [sym_rune_literal] = ACTIONS(2443),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [anon_sym_DQUOTE] = ACTIONS(2443),
    [anon_sym_c_SQUOTE] = ACTIONS(2443),
    [anon_sym_c_DQUOTE] = ACTIONS(2443),
    [anon_sym_r_SQUOTE] = ACTIONS(2443),
    [anon_sym_r_DQUOTE] = ACTIONS(2443),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2443),
    [anon_sym_shared] = ACTIONS(2443),
    [anon_sym_map_LBRACK] = ACTIONS(2443),
    [anon_sym_chan] = ACTIONS(2443),
    [anon_sym_thread] = ACTIONS(2443),
    [anon_sym_atomic] = ACTIONS(2443),
    [anon_sym_assert] = ACTIONS(2443),
    [anon_sym_defer] = ACTIONS(2443),
    [anon_sym_goto] = ACTIONS(2443),
    [anon_sym_break] = ACTIONS(2443),
    [anon_sym_continue] = ACTIONS(2443),
    [anon_sym_return] = ACTIONS(2443),
    [anon_sym_DOLLARfor] = ACTIONS(2443),
    [anon_sym_for] = ACTIONS(2443),
    [anon_sym_POUND] = ACTIONS(2443),
    [anon_sym_asm] = ACTIONS(2443),
    [anon_sym_AT_LBRACK] = ACTIONS(2443),
  },
  [358] = {
    [sym_line_comment] = STATE(358),
    [sym_block_comment] = STATE(358),
    [ts_builtin_sym_end] = ACTIONS(2451),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LF] = ACTIONS(2453),
    [anon_sym_CR] = ACTIONS(2453),
    [anon_sym_CR_LF] = ACTIONS(2453),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2453),
    [anon_sym_as] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [anon_sym_COMMA] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_EQ] = ACTIONS(2453),
    [anon_sym___global] = ACTIONS(2453),
    [anon_sym_type] = ACTIONS(2453),
    [anon_sym_fn] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2453),
    [anon_sym_SLASH] = ACTIONS(2453),
    [anon_sym_PERCENT] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2453),
    [anon_sym_EQ_EQ] = ACTIONS(2453),
    [anon_sym_BANG_EQ] = ACTIONS(2453),
    [anon_sym_LT_EQ] = ACTIONS(2453),
    [anon_sym_GT_EQ] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2451),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [anon_sym_pub] = ACTIONS(2453),
    [anon_sym_mut] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_interface] = ACTIONS(2453),
    [anon_sym_PLUS_PLUS] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2453),
    [anon_sym_QMARK] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(2453),
    [anon_sym_go] = ACTIONS(2453),
    [anon_sym_spawn] = ACTIONS(2453),
    [anon_sym_json_DOTdecode] = ACTIONS(2453),
    [anon_sym_PIPE] = ACTIONS(2453),
    [anon_sym_LBRACK2] = ACTIONS(2453),
    [anon_sym_TILDE] = ACTIONS(2453),
    [anon_sym_CARET] = ACTIONS(2453),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_LT_DASH] = ACTIONS(2453),
    [anon_sym_LT_LT] = ACTIONS(2453),
    [anon_sym_GT_GT] = ACTIONS(2453),
    [anon_sym_GT_GT_GT] = ACTIONS(2453),
    [anon_sym_AMP_CARET] = ACTIONS(2453),
    [anon_sym_AMP_AMP] = ACTIONS(2453),
    [anon_sym_PIPE_PIPE] = ACTIONS(2453),
    [anon_sym_or] = ACTIONS(2453),
    [sym_none] = ACTIONS(2453),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [sym_nil] = ACTIONS(2453),
    [anon_sym_QMARK_DOT] = ACTIONS(2453),
    [anon_sym_POUND_LBRACK] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_DOLLARif] = ACTIONS(2453),
    [anon_sym_is] = ACTIONS(2453),
    [anon_sym_BANGis] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_BANGin] = ACTIONS(2453),
    [anon_sym_match] = ACTIONS(2453),
    [anon_sym_select] = ACTIONS(2453),
    [anon_sym_STAR_EQ] = ACTIONS(2453),
    [anon_sym_SLASH_EQ] = ACTIONS(2453),
    [anon_sym_PERCENT_EQ] = ACTIONS(2453),
    [anon_sym_LT_LT_EQ] = ACTIONS(2453),
    [anon_sym_GT_GT_EQ] = ACTIONS(2453),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2453),
    [anon_sym_AMP_EQ] = ACTIONS(2453),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2453),
    [anon_sym_PLUS_EQ] = ACTIONS(2453),
    [anon_sym_DASH_EQ] = ACTIONS(2453),
    [anon_sym_PIPE_EQ] = ACTIONS(2453),
    [anon_sym_CARET_EQ] = ACTIONS(2453),
    [anon_sym_COLON_EQ] = ACTIONS(2453),
    [anon_sym_lock] = ACTIONS(2453),
    [anon_sym_rlock] = ACTIONS(2453),
    [anon_sym_unsafe] = ACTIONS(2453),
    [anon_sym_sql] = ACTIONS(2453),
    [sym_int_literal] = ACTIONS(2453),
    [sym_float_literal] = ACTIONS(2453),
    [sym_rune_literal] = ACTIONS(2453),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2453),
    [anon_sym_c_SQUOTE] = ACTIONS(2453),
    [anon_sym_c_DQUOTE] = ACTIONS(2453),
    [anon_sym_r_SQUOTE] = ACTIONS(2453),
    [anon_sym_r_DQUOTE] = ACTIONS(2453),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_map_LBRACK] = ACTIONS(2453),
    [anon_sym_chan] = ACTIONS(2453),
    [anon_sym_thread] = ACTIONS(2453),
    [anon_sym_atomic] = ACTIONS(2453),
    [anon_sym_assert] = ACTIONS(2453),
    [anon_sym_defer] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_DOLLARfor] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_POUND] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
    [anon_sym_AT_LBRACK] = ACTIONS(2453),
  },
  [359] = {
    [sym_line_comment] = STATE(359),
    [sym_block_comment] = STATE(359),
    [ts_builtin_sym_end] = ACTIONS(2455),
    [sym_identifier] = ACTIONS(2457),
    [anon_sym_LF] = ACTIONS(2457),
    [anon_sym_CR] = ACTIONS(2457),
    [anon_sym_CR_LF] = ACTIONS(2457),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2457),
    [anon_sym_as] = ACTIONS(2457),
    [anon_sym_LBRACE] = ACTIONS(2457),
    [anon_sym_COMMA] = ACTIONS(2457),
    [anon_sym_const] = ACTIONS(2457),
    [anon_sym_LPAREN] = ACTIONS(2457),
    [anon_sym_EQ] = ACTIONS(2457),
    [anon_sym___global] = ACTIONS(2457),
    [anon_sym_type] = ACTIONS(2457),
    [anon_sym_fn] = ACTIONS(2457),
    [anon_sym_PLUS] = ACTIONS(2457),
    [anon_sym_DASH] = ACTIONS(2457),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_PERCENT] = ACTIONS(2457),
    [anon_sym_LT] = ACTIONS(2457),
    [anon_sym_GT] = ACTIONS(2457),
    [anon_sym_EQ_EQ] = ACTIONS(2457),
    [anon_sym_BANG_EQ] = ACTIONS(2457),
    [anon_sym_LT_EQ] = ACTIONS(2457),
    [anon_sym_GT_EQ] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_struct] = ACTIONS(2457),
    [anon_sym_union] = ACTIONS(2457),
    [anon_sym_pub] = ACTIONS(2457),
    [anon_sym_mut] = ACTIONS(2457),
    [anon_sym_enum] = ACTIONS(2457),
    [anon_sym_interface] = ACTIONS(2457),
    [anon_sym_PLUS_PLUS] = ACTIONS(2457),
    [anon_sym_DASH_DASH] = ACTIONS(2457),
    [anon_sym_QMARK] = ACTIONS(2457),
    [anon_sym_BANG] = ACTIONS(2457),
    [anon_sym_go] = ACTIONS(2457),
    [anon_sym_spawn] = ACTIONS(2457),
    [anon_sym_json_DOTdecode] = ACTIONS(2457),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_LBRACK2] = ACTIONS(2457),
    [anon_sym_TILDE] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2457),
    [anon_sym_AMP] = ACTIONS(2457),
    [anon_sym_LT_DASH] = ACTIONS(2457),
    [anon_sym_LT_LT] = ACTIONS(2457),
    [anon_sym_GT_GT] = ACTIONS(2457),
    [anon_sym_GT_GT_GT] = ACTIONS(2457),
    [anon_sym_AMP_CARET] = ACTIONS(2457),
    [anon_sym_AMP_AMP] = ACTIONS(2457),
    [anon_sym_PIPE_PIPE] = ACTIONS(2457),
    [anon_sym_or] = ACTIONS(2457),
    [sym_none] = ACTIONS(2457),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [sym_nil] = ACTIONS(2457),
    [anon_sym_QMARK_DOT] = ACTIONS(2457),
    [anon_sym_POUND_LBRACK] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2457),
    [anon_sym_DOLLARif] = ACTIONS(2457),
    [anon_sym_is] = ACTIONS(2457),
    [anon_sym_BANGis] = ACTIONS(2457),
    [anon_sym_in] = ACTIONS(2457),
    [anon_sym_BANGin] = ACTIONS(2457),
    [anon_sym_match] = ACTIONS(2457),
    [anon_sym_select] = ACTIONS(2457),
    [anon_sym_STAR_EQ] = ACTIONS(2457),
    [anon_sym_SLASH_EQ] = ACTIONS(2457),
    [anon_sym_PERCENT_EQ] = ACTIONS(2457),
    [anon_sym_LT_LT_EQ] = ACTIONS(2457),
    [anon_sym_GT_GT_EQ] = ACTIONS(2457),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2457),
    [anon_sym_AMP_EQ] = ACTIONS(2457),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2457),
    [anon_sym_PLUS_EQ] = ACTIONS(2457),
    [anon_sym_DASH_EQ] = ACTIONS(2457),
    [anon_sym_PIPE_EQ] = ACTIONS(2457),
    [anon_sym_CARET_EQ] = ACTIONS(2457),
    [anon_sym_COLON_EQ] = ACTIONS(2457),
    [anon_sym_lock] = ACTIONS(2457),
    [anon_sym_rlock] = ACTIONS(2457),
    [anon_sym_unsafe] = ACTIONS(2457),
    [anon_sym_sql] = ACTIONS(2457),
    [sym_int_literal] = ACTIONS(2457),
    [sym_float_literal] = ACTIONS(2457),
    [sym_rune_literal] = ACTIONS(2457),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_DQUOTE] = ACTIONS(2457),
    [anon_sym_c_SQUOTE] = ACTIONS(2457),
    [anon_sym_c_DQUOTE] = ACTIONS(2457),
    [anon_sym_r_SQUOTE] = ACTIONS(2457),
    [anon_sym_r_DQUOTE] = ACTIONS(2457),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2457),
    [anon_sym_shared] = ACTIONS(2457),
    [anon_sym_map_LBRACK] = ACTIONS(2457),
    [anon_sym_chan] = ACTIONS(2457),
    [anon_sym_thread] = ACTIONS(2457),
    [anon_sym_atomic] = ACTIONS(2457),
    [anon_sym_assert] = ACTIONS(2457),
    [anon_sym_defer] = ACTIONS(2457),
    [anon_sym_goto] = ACTIONS(2457),
    [anon_sym_break] = ACTIONS(2457),
    [anon_sym_continue] = ACTIONS(2457),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_DOLLARfor] = ACTIONS(2457),
    [anon_sym_for] = ACTIONS(2457),
    [anon_sym_POUND] = ACTIONS(2457),
    [anon_sym_asm] = ACTIONS(2457),
    [anon_sym_AT_LBRACK] = ACTIONS(2457),
  },
  [360] = {
    [sym_line_comment] = STATE(360),
    [sym_block_comment] = STATE(360),
    [ts_builtin_sym_end] = ACTIONS(2337),
    [sym_identifier] = ACTIONS(2335),
    [anon_sym_LF] = ACTIONS(2335),
    [anon_sym_CR] = ACTIONS(2335),
    [anon_sym_CR_LF] = ACTIONS(2335),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2335),
    [anon_sym_as] = ACTIONS(2335),
    [anon_sym_LBRACE] = ACTIONS(2335),
    [anon_sym_COMMA] = ACTIONS(2335),
    [anon_sym_const] = ACTIONS(2335),
    [anon_sym_LPAREN] = ACTIONS(2335),
    [anon_sym_EQ] = ACTIONS(2335),
    [anon_sym___global] = ACTIONS(2335),
    [anon_sym_type] = ACTIONS(2335),
    [anon_sym_fn] = ACTIONS(2335),
    [anon_sym_PLUS] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2335),
    [anon_sym_STAR] = ACTIONS(2335),
    [anon_sym_SLASH] = ACTIONS(2335),
    [anon_sym_PERCENT] = ACTIONS(2335),
    [anon_sym_LT] = ACTIONS(2335),
    [anon_sym_GT] = ACTIONS(2335),
    [anon_sym_EQ_EQ] = ACTIONS(2335),
    [anon_sym_BANG_EQ] = ACTIONS(2335),
    [anon_sym_LT_EQ] = ACTIONS(2335),
    [anon_sym_GT_EQ] = ACTIONS(2335),
    [anon_sym_LBRACK] = ACTIONS(2337),
    [anon_sym_struct] = ACTIONS(2335),
    [anon_sym_union] = ACTIONS(2335),
    [anon_sym_pub] = ACTIONS(2335),
    [anon_sym_mut] = ACTIONS(2335),
    [anon_sym_enum] = ACTIONS(2335),
    [anon_sym_interface] = ACTIONS(2335),
    [anon_sym_PLUS_PLUS] = ACTIONS(2335),
    [anon_sym_DASH_DASH] = ACTIONS(2335),
    [anon_sym_QMARK] = ACTIONS(2335),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_go] = ACTIONS(2335),
    [anon_sym_spawn] = ACTIONS(2335),
    [anon_sym_json_DOTdecode] = ACTIONS(2335),
    [anon_sym_PIPE] = ACTIONS(2335),
    [anon_sym_LBRACK2] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [anon_sym_CARET] = ACTIONS(2335),
    [anon_sym_AMP] = ACTIONS(2335),
    [anon_sym_LT_DASH] = ACTIONS(2335),
    [anon_sym_LT_LT] = ACTIONS(2335),
    [anon_sym_GT_GT] = ACTIONS(2335),
    [anon_sym_GT_GT_GT] = ACTIONS(2335),
    [anon_sym_AMP_CARET] = ACTIONS(2335),
    [anon_sym_AMP_AMP] = ACTIONS(2335),
    [anon_sym_PIPE_PIPE] = ACTIONS(2335),
    [anon_sym_or] = ACTIONS(2335),
    [sym_none] = ACTIONS(2335),
    [sym_true] = ACTIONS(2335),
    [sym_false] = ACTIONS(2335),
    [sym_nil] = ACTIONS(2335),
    [anon_sym_QMARK_DOT] = ACTIONS(2335),
    [anon_sym_POUND_LBRACK] = ACTIONS(2335),
    [anon_sym_if] = ACTIONS(2335),
    [anon_sym_DOLLARif] = ACTIONS(2335),
    [anon_sym_is] = ACTIONS(2335),
    [anon_sym_BANGis] = ACTIONS(2335),
    [anon_sym_in] = ACTIONS(2335),
    [anon_sym_BANGin] = ACTIONS(2335),
    [anon_sym_match] = ACTIONS(2335),
    [anon_sym_select] = ACTIONS(2335),
    [anon_sym_STAR_EQ] = ACTIONS(2335),
    [anon_sym_SLASH_EQ] = ACTIONS(2335),
    [anon_sym_PERCENT_EQ] = ACTIONS(2335),
    [anon_sym_LT_LT_EQ] = ACTIONS(2335),
    [anon_sym_GT_GT_EQ] = ACTIONS(2335),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2335),
    [anon_sym_AMP_EQ] = ACTIONS(2335),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2335),
    [anon_sym_PLUS_EQ] = ACTIONS(2335),
    [anon_sym_DASH_EQ] = ACTIONS(2335),
    [anon_sym_PIPE_EQ] = ACTIONS(2335),
    [anon_sym_CARET_EQ] = ACTIONS(2335),
    [anon_sym_COLON_EQ] = ACTIONS(2335),
    [anon_sym_lock] = ACTIONS(2335),
    [anon_sym_rlock] = ACTIONS(2335),
    [anon_sym_unsafe] = ACTIONS(2335),
    [anon_sym_sql] = ACTIONS(2335),
    [sym_int_literal] = ACTIONS(2335),
    [sym_float_literal] = ACTIONS(2335),
    [sym_rune_literal] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2335),
    [anon_sym_DQUOTE] = ACTIONS(2335),
    [anon_sym_c_SQUOTE] = ACTIONS(2335),
    [anon_sym_c_DQUOTE] = ACTIONS(2335),
    [anon_sym_r_SQUOTE] = ACTIONS(2335),
    [anon_sym_r_DQUOTE] = ACTIONS(2335),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2335),
    [anon_sym_shared] = ACTIONS(2335),
    [anon_sym_map_LBRACK] = ACTIONS(2335),
    [anon_sym_chan] = ACTIONS(2335),
    [anon_sym_thread] = ACTIONS(2335),
    [anon_sym_atomic] = ACTIONS(2335),
    [anon_sym_assert] = ACTIONS(2335),
    [anon_sym_defer] = ACTIONS(2335),
    [anon_sym_goto] = ACTIONS(2335),
    [anon_sym_break] = ACTIONS(2335),
    [anon_sym_continue] = ACTIONS(2335),
    [anon_sym_return] = ACTIONS(2335),
    [anon_sym_DOLLARfor] = ACTIONS(2335),
    [anon_sym_for] = ACTIONS(2335),
    [anon_sym_POUND] = ACTIONS(2335),
    [anon_sym_asm] = ACTIONS(2335),
    [anon_sym_AT_LBRACK] = ACTIONS(2335),
  },
  [361] = {
    [sym_line_comment] = STATE(361),
    [sym_block_comment] = STATE(361),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4448),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2459),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [362] = {
    [sym_line_comment] = STATE(362),
    [sym_block_comment] = STATE(362),
    [sym__expression] = STATE(2603),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3688),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4536),
    [sym_identifier] = ACTIONS(2385),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(2387),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2389),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(2391),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [363] = {
    [sym_line_comment] = STATE(363),
    [sym_block_comment] = STATE(363),
    [sym__expression] = STATE(2604),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4675),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [364] = {
    [sym_line_comment] = STATE(364),
    [sym_block_comment] = STATE(364),
    [sym__expression] = STATE(2604),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3688),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4675),
    [sym_identifier] = ACTIONS(2385),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(2387),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2389),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(2391),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [365] = {
    [sym_line_comment] = STATE(365),
    [sym_block_comment] = STATE(365),
    [sym__expression] = STATE(2603),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4536),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [366] = {
    [sym_line_comment] = STATE(366),
    [sym_block_comment] = STATE(366),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4518),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2461),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [367] = {
    [sym_line_comment] = STATE(367),
    [sym_block_comment] = STATE(367),
    [ts_builtin_sym_end] = ACTIONS(2463),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_LF] = ACTIONS(2465),
    [anon_sym_CR] = ACTIONS(2465),
    [anon_sym_CR_LF] = ACTIONS(2465),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2465),
    [anon_sym_as] = ACTIONS(2465),
    [anon_sym_LBRACE] = ACTIONS(2465),
    [anon_sym_COMMA] = ACTIONS(2465),
    [anon_sym_const] = ACTIONS(2465),
    [anon_sym_LPAREN] = ACTIONS(2465),
    [anon_sym_EQ] = ACTIONS(2465),
    [anon_sym___global] = ACTIONS(2465),
    [anon_sym_type] = ACTIONS(2465),
    [anon_sym_fn] = ACTIONS(2465),
    [anon_sym_PLUS] = ACTIONS(2465),
    [anon_sym_DASH] = ACTIONS(2465),
    [anon_sym_STAR] = ACTIONS(2465),
    [anon_sym_SLASH] = ACTIONS(2465),
    [anon_sym_PERCENT] = ACTIONS(2465),
    [anon_sym_LT] = ACTIONS(2465),
    [anon_sym_GT] = ACTIONS(2465),
    [anon_sym_EQ_EQ] = ACTIONS(2465),
    [anon_sym_BANG_EQ] = ACTIONS(2465),
    [anon_sym_LT_EQ] = ACTIONS(2465),
    [anon_sym_GT_EQ] = ACTIONS(2465),
    [anon_sym_LBRACK] = ACTIONS(2463),
    [anon_sym_struct] = ACTIONS(2465),
    [anon_sym_union] = ACTIONS(2465),
    [anon_sym_pub] = ACTIONS(2465),
    [anon_sym_mut] = ACTIONS(2465),
    [anon_sym_enum] = ACTIONS(2465),
    [anon_sym_interface] = ACTIONS(2465),
    [anon_sym_PLUS_PLUS] = ACTIONS(2465),
    [anon_sym_DASH_DASH] = ACTIONS(2465),
    [anon_sym_QMARK] = ACTIONS(2465),
    [anon_sym_BANG] = ACTIONS(2465),
    [anon_sym_go] = ACTIONS(2465),
    [anon_sym_spawn] = ACTIONS(2465),
    [anon_sym_json_DOTdecode] = ACTIONS(2465),
    [anon_sym_PIPE] = ACTIONS(2465),
    [anon_sym_LBRACK2] = ACTIONS(2465),
    [anon_sym_TILDE] = ACTIONS(2465),
    [anon_sym_CARET] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_LT_DASH] = ACTIONS(2465),
    [anon_sym_LT_LT] = ACTIONS(2465),
    [anon_sym_GT_GT] = ACTIONS(2465),
    [anon_sym_GT_GT_GT] = ACTIONS(2465),
    [anon_sym_AMP_CARET] = ACTIONS(2465),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_PIPE_PIPE] = ACTIONS(2465),
    [anon_sym_or] = ACTIONS(2465),
    [sym_none] = ACTIONS(2465),
    [sym_true] = ACTIONS(2465),
    [sym_false] = ACTIONS(2465),
    [sym_nil] = ACTIONS(2465),
    [anon_sym_QMARK_DOT] = ACTIONS(2465),
    [anon_sym_POUND_LBRACK] = ACTIONS(2465),
    [anon_sym_if] = ACTIONS(2465),
    [anon_sym_DOLLARif] = ACTIONS(2465),
    [anon_sym_is] = ACTIONS(2465),
    [anon_sym_BANGis] = ACTIONS(2465),
    [anon_sym_in] = ACTIONS(2465),
    [anon_sym_BANGin] = ACTIONS(2465),
    [anon_sym_match] = ACTIONS(2465),
    [anon_sym_select] = ACTIONS(2465),
    [anon_sym_STAR_EQ] = ACTIONS(2465),
    [anon_sym_SLASH_EQ] = ACTIONS(2465),
    [anon_sym_PERCENT_EQ] = ACTIONS(2465),
    [anon_sym_LT_LT_EQ] = ACTIONS(2465),
    [anon_sym_GT_GT_EQ] = ACTIONS(2465),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2465),
    [anon_sym_AMP_EQ] = ACTIONS(2465),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2465),
    [anon_sym_PLUS_EQ] = ACTIONS(2465),
    [anon_sym_DASH_EQ] = ACTIONS(2465),
    [anon_sym_PIPE_EQ] = ACTIONS(2465),
    [anon_sym_CARET_EQ] = ACTIONS(2465),
    [anon_sym_COLON_EQ] = ACTIONS(2465),
    [anon_sym_lock] = ACTIONS(2465),
    [anon_sym_rlock] = ACTIONS(2465),
    [anon_sym_unsafe] = ACTIONS(2465),
    [anon_sym_sql] = ACTIONS(2465),
    [sym_int_literal] = ACTIONS(2465),
    [sym_float_literal] = ACTIONS(2465),
    [sym_rune_literal] = ACTIONS(2465),
    [anon_sym_SQUOTE] = ACTIONS(2465),
    [anon_sym_DQUOTE] = ACTIONS(2465),
    [anon_sym_c_SQUOTE] = ACTIONS(2465),
    [anon_sym_c_DQUOTE] = ACTIONS(2465),
    [anon_sym_r_SQUOTE] = ACTIONS(2465),
    [anon_sym_r_DQUOTE] = ACTIONS(2465),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2465),
    [anon_sym_shared] = ACTIONS(2465),
    [anon_sym_map_LBRACK] = ACTIONS(2465),
    [anon_sym_chan] = ACTIONS(2465),
    [anon_sym_thread] = ACTIONS(2465),
    [anon_sym_atomic] = ACTIONS(2465),
    [anon_sym_assert] = ACTIONS(2465),
    [anon_sym_defer] = ACTIONS(2465),
    [anon_sym_goto] = ACTIONS(2465),
    [anon_sym_break] = ACTIONS(2465),
    [anon_sym_continue] = ACTIONS(2465),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_DOLLARfor] = ACTIONS(2465),
    [anon_sym_for] = ACTIONS(2465),
    [anon_sym_POUND] = ACTIONS(2465),
    [anon_sym_asm] = ACTIONS(2465),
    [anon_sym_AT_LBRACK] = ACTIONS(2465),
  },
  [368] = {
    [sym_line_comment] = STATE(368),
    [sym_block_comment] = STATE(368),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4518),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [369] = {
    [sym_line_comment] = STATE(369),
    [sym_block_comment] = STATE(369),
    [sym__expression] = STATE(2582),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3688),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4651),
    [sym_identifier] = ACTIONS(2385),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(2387),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2389),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(2391),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [370] = {
    [sym_line_comment] = STATE(370),
    [sym_block_comment] = STATE(370),
    [ts_builtin_sym_end] = ACTIONS(2469),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LF] = ACTIONS(2471),
    [anon_sym_CR] = ACTIONS(2471),
    [anon_sym_CR_LF] = ACTIONS(2471),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2471),
    [anon_sym_as] = ACTIONS(2471),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_COMMA] = ACTIONS(2471),
    [anon_sym_const] = ACTIONS(2471),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_EQ] = ACTIONS(2471),
    [anon_sym___global] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2471),
    [anon_sym_fn] = ACTIONS(2471),
    [anon_sym_PLUS] = ACTIONS(2471),
    [anon_sym_DASH] = ACTIONS(2471),
    [anon_sym_STAR] = ACTIONS(2471),
    [anon_sym_SLASH] = ACTIONS(2471),
    [anon_sym_PERCENT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2471),
    [anon_sym_GT] = ACTIONS(2471),
    [anon_sym_EQ_EQ] = ACTIONS(2471),
    [anon_sym_BANG_EQ] = ACTIONS(2471),
    [anon_sym_LT_EQ] = ACTIONS(2471),
    [anon_sym_GT_EQ] = ACTIONS(2471),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_struct] = ACTIONS(2471),
    [anon_sym_union] = ACTIONS(2471),
    [anon_sym_pub] = ACTIONS(2471),
    [anon_sym_mut] = ACTIONS(2471),
    [anon_sym_enum] = ACTIONS(2471),
    [anon_sym_interface] = ACTIONS(2471),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_go] = ACTIONS(2471),
    [anon_sym_spawn] = ACTIONS(2471),
    [anon_sym_json_DOTdecode] = ACTIONS(2471),
    [anon_sym_PIPE] = ACTIONS(2471),
    [anon_sym_LBRACK2] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_CARET] = ACTIONS(2471),
    [anon_sym_AMP] = ACTIONS(2471),
    [anon_sym_LT_DASH] = ACTIONS(2471),
    [anon_sym_LT_LT] = ACTIONS(2471),
    [anon_sym_GT_GT] = ACTIONS(2471),
    [anon_sym_GT_GT_GT] = ACTIONS(2471),
    [anon_sym_AMP_CARET] = ACTIONS(2471),
    [anon_sym_AMP_AMP] = ACTIONS(2471),
    [anon_sym_PIPE_PIPE] = ACTIONS(2471),
    [anon_sym_or] = ACTIONS(2471),
    [sym_none] = ACTIONS(2471),
    [sym_true] = ACTIONS(2471),
    [sym_false] = ACTIONS(2471),
    [sym_nil] = ACTIONS(2471),
    [anon_sym_QMARK_DOT] = ACTIONS(2471),
    [anon_sym_POUND_LBRACK] = ACTIONS(2471),
    [anon_sym_if] = ACTIONS(2471),
    [anon_sym_DOLLARif] = ACTIONS(2471),
    [anon_sym_is] = ACTIONS(2471),
    [anon_sym_BANGis] = ACTIONS(2471),
    [anon_sym_in] = ACTIONS(2471),
    [anon_sym_BANGin] = ACTIONS(2471),
    [anon_sym_match] = ACTIONS(2471),
    [anon_sym_select] = ACTIONS(2471),
    [anon_sym_STAR_EQ] = ACTIONS(2471),
    [anon_sym_SLASH_EQ] = ACTIONS(2471),
    [anon_sym_PERCENT_EQ] = ACTIONS(2471),
    [anon_sym_LT_LT_EQ] = ACTIONS(2471),
    [anon_sym_GT_GT_EQ] = ACTIONS(2471),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2471),
    [anon_sym_AMP_EQ] = ACTIONS(2471),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2471),
    [anon_sym_PLUS_EQ] = ACTIONS(2471),
    [anon_sym_DASH_EQ] = ACTIONS(2471),
    [anon_sym_PIPE_EQ] = ACTIONS(2471),
    [anon_sym_CARET_EQ] = ACTIONS(2471),
    [anon_sym_COLON_EQ] = ACTIONS(2471),
    [anon_sym_lock] = ACTIONS(2471),
    [anon_sym_rlock] = ACTIONS(2471),
    [anon_sym_unsafe] = ACTIONS(2471),
    [anon_sym_sql] = ACTIONS(2471),
    [sym_int_literal] = ACTIONS(2471),
    [sym_float_literal] = ACTIONS(2471),
    [sym_rune_literal] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_c_SQUOTE] = ACTIONS(2471),
    [anon_sym_c_DQUOTE] = ACTIONS(2471),
    [anon_sym_r_SQUOTE] = ACTIONS(2471),
    [anon_sym_r_DQUOTE] = ACTIONS(2471),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2471),
    [anon_sym_shared] = ACTIONS(2471),
    [anon_sym_map_LBRACK] = ACTIONS(2471),
    [anon_sym_chan] = ACTIONS(2471),
    [anon_sym_thread] = ACTIONS(2471),
    [anon_sym_atomic] = ACTIONS(2471),
    [anon_sym_assert] = ACTIONS(2471),
    [anon_sym_defer] = ACTIONS(2471),
    [anon_sym_goto] = ACTIONS(2471),
    [anon_sym_break] = ACTIONS(2471),
    [anon_sym_continue] = ACTIONS(2471),
    [anon_sym_return] = ACTIONS(2471),
    [anon_sym_DOLLARfor] = ACTIONS(2471),
    [anon_sym_for] = ACTIONS(2471),
    [anon_sym_POUND] = ACTIONS(2471),
    [anon_sym_asm] = ACTIONS(2471),
    [anon_sym_AT_LBRACK] = ACTIONS(2471),
  },
  [371] = {
    [sym_line_comment] = STATE(371),
    [sym_block_comment] = STATE(371),
    [sym__expression] = STATE(1119),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(621),
    [sym_mutable_expression] = STATE(1715),
    [sym_expression_list] = STATE(1815),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2481),
    [anon_sym_go] = ACTIONS(775),
    [anon_sym_spawn] = ACTIONS(777),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_LT_DASH] = ACTIONS(2489),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(795),
    [anon_sym_lock] = ACTIONS(797),
    [anon_sym_rlock] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [372] = {
    [sym_line_comment] = STATE(372),
    [sym_block_comment] = STATE(372),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1527),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_short_element_list_repeat1] = STATE(374),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(2505),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [373] = {
    [sym_line_comment] = STATE(373),
    [sym_block_comment] = STATE(373),
    [sym__expression] = STATE(1119),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(621),
    [sym_mutable_expression] = STATE(1715),
    [sym_expression_list] = STATE(1814),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2481),
    [anon_sym_go] = ACTIONS(775),
    [anon_sym_spawn] = ACTIONS(777),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_LT_DASH] = ACTIONS(2489),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(795),
    [anon_sym_lock] = ACTIONS(797),
    [anon_sym_rlock] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [374] = {
    [sym_line_comment] = STATE(374),
    [sym_block_comment] = STATE(374),
    [sym__expression] = STATE(1434),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1527),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_short_element_list_repeat1] = STATE(374),
    [sym_identifier] = ACTIONS(2507),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2510),
    [anon_sym_LBRACE] = ACTIONS(2513),
    [anon_sym_RBRACE] = ACTIONS(2516),
    [anon_sym_LPAREN] = ACTIONS(2518),
    [anon_sym_fn] = ACTIONS(2521),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2527),
    [anon_sym_struct] = ACTIONS(2530),
    [anon_sym_mut] = ACTIONS(2533),
    [anon_sym_QMARK] = ACTIONS(2536),
    [anon_sym_BANG] = ACTIONS(2539),
    [anon_sym_go] = ACTIONS(2542),
    [anon_sym_spawn] = ACTIONS(2545),
    [anon_sym_json_DOTdecode] = ACTIONS(2548),
    [anon_sym_LBRACK2] = ACTIONS(2551),
    [anon_sym_TILDE] = ACTIONS(2524),
    [anon_sym_CARET] = ACTIONS(2524),
    [anon_sym_AMP] = ACTIONS(2554),
    [anon_sym_LT_DASH] = ACTIONS(2557),
    [sym_none] = ACTIONS(2560),
    [sym_true] = ACTIONS(2560),
    [sym_false] = ACTIONS(2560),
    [sym_nil] = ACTIONS(2560),
    [anon_sym_if] = ACTIONS(2563),
    [anon_sym_DOLLARif] = ACTIONS(2566),
    [anon_sym_match] = ACTIONS(2569),
    [anon_sym_select] = ACTIONS(2572),
    [anon_sym_lock] = ACTIONS(2575),
    [anon_sym_rlock] = ACTIONS(2575),
    [anon_sym_unsafe] = ACTIONS(2578),
    [anon_sym_sql] = ACTIONS(2581),
    [sym_int_literal] = ACTIONS(2560),
    [sym_float_literal] = ACTIONS(2584),
    [sym_rune_literal] = ACTIONS(2584),
    [anon_sym_SQUOTE] = ACTIONS(2587),
    [anon_sym_DQUOTE] = ACTIONS(2590),
    [anon_sym_c_SQUOTE] = ACTIONS(2593),
    [anon_sym_c_DQUOTE] = ACTIONS(2596),
    [anon_sym_r_SQUOTE] = ACTIONS(2599),
    [anon_sym_r_DQUOTE] = ACTIONS(2602),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2605),
    [anon_sym_shared] = ACTIONS(2608),
    [anon_sym_map_LBRACK] = ACTIONS(2611),
    [anon_sym_chan] = ACTIONS(2614),
    [anon_sym_thread] = ACTIONS(2617),
    [anon_sym_atomic] = ACTIONS(2620),
  },
  [375] = {
    [sym_line_comment] = STATE(375),
    [sym_block_comment] = STATE(375),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(402),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(2623),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [376] = {
    [sym_line_comment] = STATE(376),
    [sym_block_comment] = STATE(376),
    [sym__expression] = STATE(2582),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4651),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [377] = {
    [sym_line_comment] = STATE(377),
    [sym_block_comment] = STATE(377),
    [sym__expression] = STATE(2592),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4576),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [378] = {
    [sym_line_comment] = STATE(378),
    [sym_block_comment] = STATE(378),
    [sym__expression] = STATE(2592),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3688),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4576),
    [sym_identifier] = ACTIONS(2385),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(2387),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2389),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(2391),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [379] = {
    [sym_line_comment] = STATE(379),
    [sym_block_comment] = STATE(379),
    [ts_builtin_sym_end] = ACTIONS(2625),
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_LF] = ACTIONS(2627),
    [anon_sym_CR] = ACTIONS(2627),
    [anon_sym_CR_LF] = ACTIONS(2627),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2627),
    [anon_sym_as] = ACTIONS(2627),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_COMMA] = ACTIONS(2627),
    [anon_sym_const] = ACTIONS(2627),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym___global] = ACTIONS(2627),
    [anon_sym_type] = ACTIONS(2627),
    [anon_sym_fn] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_SLASH] = ACTIONS(2627),
    [anon_sym_PERCENT] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2627),
    [anon_sym_GT] = ACTIONS(2627),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT_EQ] = ACTIONS(2627),
    [anon_sym_GT_EQ] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2625),
    [anon_sym_struct] = ACTIONS(2627),
    [anon_sym_union] = ACTIONS(2627),
    [anon_sym_pub] = ACTIONS(2627),
    [anon_sym_mut] = ACTIONS(2627),
    [anon_sym_enum] = ACTIONS(2627),
    [anon_sym_interface] = ACTIONS(2627),
    [anon_sym_PLUS_PLUS] = ACTIONS(2627),
    [anon_sym_DASH_DASH] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2627),
    [anon_sym_BANG] = ACTIONS(2627),
    [anon_sym_go] = ACTIONS(2627),
    [anon_sym_spawn] = ACTIONS(2627),
    [anon_sym_json_DOTdecode] = ACTIONS(2627),
    [anon_sym_PIPE] = ACTIONS(2627),
    [anon_sym_LBRACK2] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2627),
    [anon_sym_CARET] = ACTIONS(2627),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_LT_DASH] = ACTIONS(2627),
    [anon_sym_LT_LT] = ACTIONS(2627),
    [anon_sym_GT_GT] = ACTIONS(2627),
    [anon_sym_GT_GT_GT] = ACTIONS(2627),
    [anon_sym_AMP_CARET] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_PIPE_PIPE] = ACTIONS(2627),
    [anon_sym_or] = ACTIONS(2627),
    [sym_none] = ACTIONS(2627),
    [sym_true] = ACTIONS(2627),
    [sym_false] = ACTIONS(2627),
    [sym_nil] = ACTIONS(2627),
    [anon_sym_QMARK_DOT] = ACTIONS(2627),
    [anon_sym_POUND_LBRACK] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_DOLLARif] = ACTIONS(2627),
    [anon_sym_is] = ACTIONS(2627),
    [anon_sym_BANGis] = ACTIONS(2627),
    [anon_sym_in] = ACTIONS(2627),
    [anon_sym_BANGin] = ACTIONS(2627),
    [anon_sym_match] = ACTIONS(2627),
    [anon_sym_select] = ACTIONS(2627),
    [anon_sym_STAR_EQ] = ACTIONS(2627),
    [anon_sym_SLASH_EQ] = ACTIONS(2627),
    [anon_sym_PERCENT_EQ] = ACTIONS(2627),
    [anon_sym_LT_LT_EQ] = ACTIONS(2627),
    [anon_sym_GT_GT_EQ] = ACTIONS(2627),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2627),
    [anon_sym_AMP_EQ] = ACTIONS(2627),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2627),
    [anon_sym_PLUS_EQ] = ACTIONS(2627),
    [anon_sym_DASH_EQ] = ACTIONS(2627),
    [anon_sym_PIPE_EQ] = ACTIONS(2627),
    [anon_sym_CARET_EQ] = ACTIONS(2627),
    [anon_sym_COLON_EQ] = ACTIONS(2627),
    [anon_sym_lock] = ACTIONS(2627),
    [anon_sym_rlock] = ACTIONS(2627),
    [anon_sym_unsafe] = ACTIONS(2627),
    [anon_sym_sql] = ACTIONS(2627),
    [sym_int_literal] = ACTIONS(2627),
    [sym_float_literal] = ACTIONS(2627),
    [sym_rune_literal] = ACTIONS(2627),
    [anon_sym_SQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [anon_sym_c_SQUOTE] = ACTIONS(2627),
    [anon_sym_c_DQUOTE] = ACTIONS(2627),
    [anon_sym_r_SQUOTE] = ACTIONS(2627),
    [anon_sym_r_DQUOTE] = ACTIONS(2627),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2627),
    [anon_sym_shared] = ACTIONS(2627),
    [anon_sym_map_LBRACK] = ACTIONS(2627),
    [anon_sym_chan] = ACTIONS(2627),
    [anon_sym_thread] = ACTIONS(2627),
    [anon_sym_atomic] = ACTIONS(2627),
    [anon_sym_assert] = ACTIONS(2627),
    [anon_sym_defer] = ACTIONS(2627),
    [anon_sym_goto] = ACTIONS(2627),
    [anon_sym_break] = ACTIONS(2627),
    [anon_sym_continue] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_DOLLARfor] = ACTIONS(2627),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_POUND] = ACTIONS(2627),
    [anon_sym_asm] = ACTIONS(2627),
    [anon_sym_AT_LBRACK] = ACTIONS(2627),
  },
  [380] = {
    [sym_line_comment] = STATE(380),
    [sym_block_comment] = STATE(380),
    [ts_builtin_sym_end] = ACTIONS(2629),
    [sym_identifier] = ACTIONS(2631),
    [anon_sym_LF] = ACTIONS(2631),
    [anon_sym_CR] = ACTIONS(2631),
    [anon_sym_CR_LF] = ACTIONS(2631),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2631),
    [anon_sym_as] = ACTIONS(2631),
    [anon_sym_LBRACE] = ACTIONS(2631),
    [anon_sym_COMMA] = ACTIONS(2631),
    [anon_sym_const] = ACTIONS(2631),
    [anon_sym_LPAREN] = ACTIONS(2631),
    [anon_sym_EQ] = ACTIONS(2631),
    [anon_sym___global] = ACTIONS(2631),
    [anon_sym_type] = ACTIONS(2631),
    [anon_sym_fn] = ACTIONS(2631),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_DASH] = ACTIONS(2631),
    [anon_sym_STAR] = ACTIONS(2631),
    [anon_sym_SLASH] = ACTIONS(2631),
    [anon_sym_PERCENT] = ACTIONS(2631),
    [anon_sym_LT] = ACTIONS(2631),
    [anon_sym_GT] = ACTIONS(2631),
    [anon_sym_EQ_EQ] = ACTIONS(2631),
    [anon_sym_BANG_EQ] = ACTIONS(2631),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LBRACK] = ACTIONS(2629),
    [anon_sym_struct] = ACTIONS(2631),
    [anon_sym_union] = ACTIONS(2631),
    [anon_sym_pub] = ACTIONS(2631),
    [anon_sym_mut] = ACTIONS(2631),
    [anon_sym_enum] = ACTIONS(2631),
    [anon_sym_interface] = ACTIONS(2631),
    [anon_sym_PLUS_PLUS] = ACTIONS(2631),
    [anon_sym_DASH_DASH] = ACTIONS(2631),
    [anon_sym_QMARK] = ACTIONS(2631),
    [anon_sym_BANG] = ACTIONS(2631),
    [anon_sym_go] = ACTIONS(2631),
    [anon_sym_spawn] = ACTIONS(2631),
    [anon_sym_json_DOTdecode] = ACTIONS(2631),
    [anon_sym_PIPE] = ACTIONS(2631),
    [anon_sym_LBRACK2] = ACTIONS(2631),
    [anon_sym_TILDE] = ACTIONS(2631),
    [anon_sym_CARET] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2631),
    [anon_sym_LT_DASH] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2631),
    [anon_sym_GT_GT] = ACTIONS(2631),
    [anon_sym_GT_GT_GT] = ACTIONS(2631),
    [anon_sym_AMP_CARET] = ACTIONS(2631),
    [anon_sym_AMP_AMP] = ACTIONS(2631),
    [anon_sym_PIPE_PIPE] = ACTIONS(2631),
    [anon_sym_or] = ACTIONS(2631),
    [sym_none] = ACTIONS(2631),
    [sym_true] = ACTIONS(2631),
    [sym_false] = ACTIONS(2631),
    [sym_nil] = ACTIONS(2631),
    [anon_sym_QMARK_DOT] = ACTIONS(2631),
    [anon_sym_POUND_LBRACK] = ACTIONS(2631),
    [anon_sym_if] = ACTIONS(2631),
    [anon_sym_DOLLARif] = ACTIONS(2631),
    [anon_sym_is] = ACTIONS(2631),
    [anon_sym_BANGis] = ACTIONS(2631),
    [anon_sym_in] = ACTIONS(2631),
    [anon_sym_BANGin] = ACTIONS(2631),
    [anon_sym_match] = ACTIONS(2631),
    [anon_sym_select] = ACTIONS(2631),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_COLON_EQ] = ACTIONS(2631),
    [anon_sym_lock] = ACTIONS(2631),
    [anon_sym_rlock] = ACTIONS(2631),
    [anon_sym_unsafe] = ACTIONS(2631),
    [anon_sym_sql] = ACTIONS(2631),
    [sym_int_literal] = ACTIONS(2631),
    [sym_float_literal] = ACTIONS(2631),
    [sym_rune_literal] = ACTIONS(2631),
    [anon_sym_SQUOTE] = ACTIONS(2631),
    [anon_sym_DQUOTE] = ACTIONS(2631),
    [anon_sym_c_SQUOTE] = ACTIONS(2631),
    [anon_sym_c_DQUOTE] = ACTIONS(2631),
    [anon_sym_r_SQUOTE] = ACTIONS(2631),
    [anon_sym_r_DQUOTE] = ACTIONS(2631),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2631),
    [anon_sym_shared] = ACTIONS(2631),
    [anon_sym_map_LBRACK] = ACTIONS(2631),
    [anon_sym_chan] = ACTIONS(2631),
    [anon_sym_thread] = ACTIONS(2631),
    [anon_sym_atomic] = ACTIONS(2631),
    [anon_sym_assert] = ACTIONS(2631),
    [anon_sym_defer] = ACTIONS(2631),
    [anon_sym_goto] = ACTIONS(2631),
    [anon_sym_break] = ACTIONS(2631),
    [anon_sym_continue] = ACTIONS(2631),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_DOLLARfor] = ACTIONS(2631),
    [anon_sym_for] = ACTIONS(2631),
    [anon_sym_POUND] = ACTIONS(2631),
    [anon_sym_asm] = ACTIONS(2631),
    [anon_sym_AT_LBRACK] = ACTIONS(2631),
  },
  [381] = {
    [sym_line_comment] = STATE(381),
    [sym_block_comment] = STATE(381),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4518),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [382] = {
    [sym_line_comment] = STATE(382),
    [sym_block_comment] = STATE(382),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4469),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [383] = {
    [sym_line_comment] = STATE(383),
    [sym_block_comment] = STATE(383),
    [ts_builtin_sym_end] = ACTIONS(2637),
    [sym_identifier] = ACTIONS(2639),
    [anon_sym_LF] = ACTIONS(2639),
    [anon_sym_CR] = ACTIONS(2639),
    [anon_sym_CR_LF] = ACTIONS(2639),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2639),
    [anon_sym_as] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2639),
    [anon_sym_COMMA] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(2639),
    [anon_sym_EQ] = ACTIONS(2639),
    [anon_sym___global] = ACTIONS(2639),
    [anon_sym_type] = ACTIONS(2639),
    [anon_sym_fn] = ACTIONS(2639),
    [anon_sym_PLUS] = ACTIONS(2639),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_SLASH] = ACTIONS(2639),
    [anon_sym_PERCENT] = ACTIONS(2639),
    [anon_sym_LT] = ACTIONS(2639),
    [anon_sym_GT] = ACTIONS(2639),
    [anon_sym_EQ_EQ] = ACTIONS(2639),
    [anon_sym_BANG_EQ] = ACTIONS(2639),
    [anon_sym_LT_EQ] = ACTIONS(2639),
    [anon_sym_GT_EQ] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [anon_sym_pub] = ACTIONS(2639),
    [anon_sym_mut] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_interface] = ACTIONS(2639),
    [anon_sym_PLUS_PLUS] = ACTIONS(2639),
    [anon_sym_DASH_DASH] = ACTIONS(2639),
    [anon_sym_QMARK] = ACTIONS(2639),
    [anon_sym_BANG] = ACTIONS(2639),
    [anon_sym_go] = ACTIONS(2639),
    [anon_sym_spawn] = ACTIONS(2639),
    [anon_sym_json_DOTdecode] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_LBRACK2] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_LT_DASH] = ACTIONS(2639),
    [anon_sym_LT_LT] = ACTIONS(2639),
    [anon_sym_GT_GT] = ACTIONS(2639),
    [anon_sym_GT_GT_GT] = ACTIONS(2639),
    [anon_sym_AMP_CARET] = ACTIONS(2639),
    [anon_sym_AMP_AMP] = ACTIONS(2639),
    [anon_sym_PIPE_PIPE] = ACTIONS(2639),
    [anon_sym_or] = ACTIONS(2639),
    [sym_none] = ACTIONS(2639),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [sym_nil] = ACTIONS(2639),
    [anon_sym_QMARK_DOT] = ACTIONS(2639),
    [anon_sym_POUND_LBRACK] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2639),
    [anon_sym_DOLLARif] = ACTIONS(2639),
    [anon_sym_is] = ACTIONS(2639),
    [anon_sym_BANGis] = ACTIONS(2639),
    [anon_sym_in] = ACTIONS(2639),
    [anon_sym_BANGin] = ACTIONS(2639),
    [anon_sym_match] = ACTIONS(2639),
    [anon_sym_select] = ACTIONS(2639),
    [anon_sym_STAR_EQ] = ACTIONS(2639),
    [anon_sym_SLASH_EQ] = ACTIONS(2639),
    [anon_sym_PERCENT_EQ] = ACTIONS(2639),
    [anon_sym_LT_LT_EQ] = ACTIONS(2639),
    [anon_sym_GT_GT_EQ] = ACTIONS(2639),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2639),
    [anon_sym_AMP_EQ] = ACTIONS(2639),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2639),
    [anon_sym_PLUS_EQ] = ACTIONS(2639),
    [anon_sym_DASH_EQ] = ACTIONS(2639),
    [anon_sym_PIPE_EQ] = ACTIONS(2639),
    [anon_sym_CARET_EQ] = ACTIONS(2639),
    [anon_sym_COLON_EQ] = ACTIONS(2639),
    [anon_sym_lock] = ACTIONS(2639),
    [anon_sym_rlock] = ACTIONS(2639),
    [anon_sym_unsafe] = ACTIONS(2639),
    [anon_sym_sql] = ACTIONS(2639),
    [sym_int_literal] = ACTIONS(2639),
    [sym_float_literal] = ACTIONS(2639),
    [sym_rune_literal] = ACTIONS(2639),
    [anon_sym_SQUOTE] = ACTIONS(2639),
    [anon_sym_DQUOTE] = ACTIONS(2639),
    [anon_sym_c_SQUOTE] = ACTIONS(2639),
    [anon_sym_c_DQUOTE] = ACTIONS(2639),
    [anon_sym_r_SQUOTE] = ACTIONS(2639),
    [anon_sym_r_DQUOTE] = ACTIONS(2639),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2639),
    [anon_sym_shared] = ACTIONS(2639),
    [anon_sym_map_LBRACK] = ACTIONS(2639),
    [anon_sym_chan] = ACTIONS(2639),
    [anon_sym_thread] = ACTIONS(2639),
    [anon_sym_atomic] = ACTIONS(2639),
    [anon_sym_assert] = ACTIONS(2639),
    [anon_sym_defer] = ACTIONS(2639),
    [anon_sym_goto] = ACTIONS(2639),
    [anon_sym_break] = ACTIONS(2639),
    [anon_sym_continue] = ACTIONS(2639),
    [anon_sym_return] = ACTIONS(2639),
    [anon_sym_DOLLARfor] = ACTIONS(2639),
    [anon_sym_for] = ACTIONS(2639),
    [anon_sym_POUND] = ACTIONS(2639),
    [anon_sym_asm] = ACTIONS(2639),
    [anon_sym_AT_LBRACK] = ACTIONS(2639),
  },
  [384] = {
    [sym_line_comment] = STATE(384),
    [sym_block_comment] = STATE(384),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4492),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2641),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [385] = {
    [sym_line_comment] = STATE(385),
    [sym_block_comment] = STATE(385),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4440),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [386] = {
    [sym_line_comment] = STATE(386),
    [sym_block_comment] = STATE(386),
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2647),
    [anon_sym_LF] = ACTIONS(2647),
    [anon_sym_CR] = ACTIONS(2647),
    [anon_sym_CR_LF] = ACTIONS(2647),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2647),
    [anon_sym_as] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_const] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_EQ] = ACTIONS(2647),
    [anon_sym___global] = ACTIONS(2647),
    [anon_sym_type] = ACTIONS(2647),
    [anon_sym_fn] = ACTIONS(2647),
    [anon_sym_PLUS] = ACTIONS(2647),
    [anon_sym_DASH] = ACTIONS(2647),
    [anon_sym_STAR] = ACTIONS(2647),
    [anon_sym_SLASH] = ACTIONS(2647),
    [anon_sym_PERCENT] = ACTIONS(2647),
    [anon_sym_LT] = ACTIONS(2647),
    [anon_sym_GT] = ACTIONS(2647),
    [anon_sym_EQ_EQ] = ACTIONS(2647),
    [anon_sym_BANG_EQ] = ACTIONS(2647),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_struct] = ACTIONS(2647),
    [anon_sym_union] = ACTIONS(2647),
    [anon_sym_pub] = ACTIONS(2647),
    [anon_sym_mut] = ACTIONS(2647),
    [anon_sym_enum] = ACTIONS(2647),
    [anon_sym_interface] = ACTIONS(2647),
    [anon_sym_PLUS_PLUS] = ACTIONS(2647),
    [anon_sym_DASH_DASH] = ACTIONS(2647),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_go] = ACTIONS(2647),
    [anon_sym_spawn] = ACTIONS(2647),
    [anon_sym_json_DOTdecode] = ACTIONS(2647),
    [anon_sym_PIPE] = ACTIONS(2647),
    [anon_sym_LBRACK2] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [anon_sym_CARET] = ACTIONS(2647),
    [anon_sym_AMP] = ACTIONS(2647),
    [anon_sym_LT_DASH] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2647),
    [anon_sym_GT_GT] = ACTIONS(2647),
    [anon_sym_GT_GT_GT] = ACTIONS(2647),
    [anon_sym_AMP_CARET] = ACTIONS(2647),
    [anon_sym_AMP_AMP] = ACTIONS(2647),
    [anon_sym_PIPE_PIPE] = ACTIONS(2647),
    [anon_sym_or] = ACTIONS(2647),
    [sym_none] = ACTIONS(2647),
    [sym_true] = ACTIONS(2647),
    [sym_false] = ACTIONS(2647),
    [sym_nil] = ACTIONS(2647),
    [anon_sym_QMARK_DOT] = ACTIONS(2647),
    [anon_sym_POUND_LBRACK] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(2647),
    [anon_sym_DOLLARif] = ACTIONS(2647),
    [anon_sym_is] = ACTIONS(2647),
    [anon_sym_BANGis] = ACTIONS(2647),
    [anon_sym_in] = ACTIONS(2647),
    [anon_sym_BANGin] = ACTIONS(2647),
    [anon_sym_match] = ACTIONS(2647),
    [anon_sym_select] = ACTIONS(2647),
    [anon_sym_STAR_EQ] = ACTIONS(2647),
    [anon_sym_SLASH_EQ] = ACTIONS(2647),
    [anon_sym_PERCENT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_GT_EQ] = ACTIONS(2647),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2647),
    [anon_sym_AMP_EQ] = ACTIONS(2647),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2647),
    [anon_sym_PLUS_EQ] = ACTIONS(2647),
    [anon_sym_DASH_EQ] = ACTIONS(2647),
    [anon_sym_PIPE_EQ] = ACTIONS(2647),
    [anon_sym_CARET_EQ] = ACTIONS(2647),
    [anon_sym_COLON_EQ] = ACTIONS(2647),
    [anon_sym_lock] = ACTIONS(2647),
    [anon_sym_rlock] = ACTIONS(2647),
    [anon_sym_unsafe] = ACTIONS(2647),
    [anon_sym_sql] = ACTIONS(2647),
    [sym_int_literal] = ACTIONS(2647),
    [sym_float_literal] = ACTIONS(2647),
    [sym_rune_literal] = ACTIONS(2647),
    [anon_sym_SQUOTE] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(2647),
    [anon_sym_c_SQUOTE] = ACTIONS(2647),
    [anon_sym_c_DQUOTE] = ACTIONS(2647),
    [anon_sym_r_SQUOTE] = ACTIONS(2647),
    [anon_sym_r_DQUOTE] = ACTIONS(2647),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2647),
    [anon_sym_shared] = ACTIONS(2647),
    [anon_sym_map_LBRACK] = ACTIONS(2647),
    [anon_sym_chan] = ACTIONS(2647),
    [anon_sym_thread] = ACTIONS(2647),
    [anon_sym_atomic] = ACTIONS(2647),
    [anon_sym_assert] = ACTIONS(2647),
    [anon_sym_defer] = ACTIONS(2647),
    [anon_sym_goto] = ACTIONS(2647),
    [anon_sym_break] = ACTIONS(2647),
    [anon_sym_continue] = ACTIONS(2647),
    [anon_sym_return] = ACTIONS(2647),
    [anon_sym_DOLLARfor] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2647),
    [anon_sym_POUND] = ACTIONS(2647),
    [anon_sym_asm] = ACTIONS(2647),
    [anon_sym_AT_LBRACK] = ACTIONS(2647),
  },
  [387] = {
    [sym_line_comment] = STATE(387),
    [sym_block_comment] = STATE(387),
    [ts_builtin_sym_end] = ACTIONS(2649),
    [sym_identifier] = ACTIONS(2651),
    [anon_sym_LF] = ACTIONS(2651),
    [anon_sym_CR] = ACTIONS(2651),
    [anon_sym_CR_LF] = ACTIONS(2651),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2651),
    [anon_sym_as] = ACTIONS(2651),
    [anon_sym_LBRACE] = ACTIONS(2651),
    [anon_sym_COMMA] = ACTIONS(2651),
    [anon_sym_const] = ACTIONS(2651),
    [anon_sym_LPAREN] = ACTIONS(2651),
    [anon_sym_EQ] = ACTIONS(2651),
    [anon_sym___global] = ACTIONS(2651),
    [anon_sym_type] = ACTIONS(2651),
    [anon_sym_fn] = ACTIONS(2651),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_STAR] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2651),
    [anon_sym_PERCENT] = ACTIONS(2651),
    [anon_sym_LT] = ACTIONS(2651),
    [anon_sym_GT] = ACTIONS(2651),
    [anon_sym_EQ_EQ] = ACTIONS(2651),
    [anon_sym_BANG_EQ] = ACTIONS(2651),
    [anon_sym_LT_EQ] = ACTIONS(2651),
    [anon_sym_GT_EQ] = ACTIONS(2651),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_struct] = ACTIONS(2651),
    [anon_sym_union] = ACTIONS(2651),
    [anon_sym_pub] = ACTIONS(2651),
    [anon_sym_mut] = ACTIONS(2651),
    [anon_sym_enum] = ACTIONS(2651),
    [anon_sym_interface] = ACTIONS(2651),
    [anon_sym_PLUS_PLUS] = ACTIONS(2651),
    [anon_sym_DASH_DASH] = ACTIONS(2651),
    [anon_sym_QMARK] = ACTIONS(2651),
    [anon_sym_BANG] = ACTIONS(2651),
    [anon_sym_go] = ACTIONS(2651),
    [anon_sym_spawn] = ACTIONS(2651),
    [anon_sym_json_DOTdecode] = ACTIONS(2651),
    [anon_sym_PIPE] = ACTIONS(2651),
    [anon_sym_LBRACK2] = ACTIONS(2651),
    [anon_sym_TILDE] = ACTIONS(2651),
    [anon_sym_CARET] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2651),
    [anon_sym_LT_DASH] = ACTIONS(2651),
    [anon_sym_LT_LT] = ACTIONS(2651),
    [anon_sym_GT_GT] = ACTIONS(2651),
    [anon_sym_GT_GT_GT] = ACTIONS(2651),
    [anon_sym_AMP_CARET] = ACTIONS(2651),
    [anon_sym_AMP_AMP] = ACTIONS(2651),
    [anon_sym_PIPE_PIPE] = ACTIONS(2651),
    [anon_sym_or] = ACTIONS(2651),
    [sym_none] = ACTIONS(2651),
    [sym_true] = ACTIONS(2651),
    [sym_false] = ACTIONS(2651),
    [sym_nil] = ACTIONS(2651),
    [anon_sym_QMARK_DOT] = ACTIONS(2651),
    [anon_sym_POUND_LBRACK] = ACTIONS(2651),
    [anon_sym_if] = ACTIONS(2651),
    [anon_sym_DOLLARif] = ACTIONS(2651),
    [anon_sym_is] = ACTIONS(2651),
    [anon_sym_BANGis] = ACTIONS(2651),
    [anon_sym_in] = ACTIONS(2651),
    [anon_sym_BANGin] = ACTIONS(2651),
    [anon_sym_match] = ACTIONS(2651),
    [anon_sym_select] = ACTIONS(2651),
    [anon_sym_STAR_EQ] = ACTIONS(2651),
    [anon_sym_SLASH_EQ] = ACTIONS(2651),
    [anon_sym_PERCENT_EQ] = ACTIONS(2651),
    [anon_sym_LT_LT_EQ] = ACTIONS(2651),
    [anon_sym_GT_GT_EQ] = ACTIONS(2651),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2651),
    [anon_sym_AMP_EQ] = ACTIONS(2651),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2651),
    [anon_sym_PLUS_EQ] = ACTIONS(2651),
    [anon_sym_DASH_EQ] = ACTIONS(2651),
    [anon_sym_PIPE_EQ] = ACTIONS(2651),
    [anon_sym_CARET_EQ] = ACTIONS(2651),
    [anon_sym_COLON_EQ] = ACTIONS(2651),
    [anon_sym_lock] = ACTIONS(2651),
    [anon_sym_rlock] = ACTIONS(2651),
    [anon_sym_unsafe] = ACTIONS(2651),
    [anon_sym_sql] = ACTIONS(2651),
    [sym_int_literal] = ACTIONS(2651),
    [sym_float_literal] = ACTIONS(2651),
    [sym_rune_literal] = ACTIONS(2651),
    [anon_sym_SQUOTE] = ACTIONS(2651),
    [anon_sym_DQUOTE] = ACTIONS(2651),
    [anon_sym_c_SQUOTE] = ACTIONS(2651),
    [anon_sym_c_DQUOTE] = ACTIONS(2651),
    [anon_sym_r_SQUOTE] = ACTIONS(2651),
    [anon_sym_r_DQUOTE] = ACTIONS(2651),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2651),
    [anon_sym_shared] = ACTIONS(2651),
    [anon_sym_map_LBRACK] = ACTIONS(2651),
    [anon_sym_chan] = ACTIONS(2651),
    [anon_sym_thread] = ACTIONS(2651),
    [anon_sym_atomic] = ACTIONS(2651),
    [anon_sym_assert] = ACTIONS(2651),
    [anon_sym_defer] = ACTIONS(2651),
    [anon_sym_goto] = ACTIONS(2651),
    [anon_sym_break] = ACTIONS(2651),
    [anon_sym_continue] = ACTIONS(2651),
    [anon_sym_return] = ACTIONS(2651),
    [anon_sym_DOLLARfor] = ACTIONS(2651),
    [anon_sym_for] = ACTIONS(2651),
    [anon_sym_POUND] = ACTIONS(2651),
    [anon_sym_asm] = ACTIONS(2651),
    [anon_sym_AT_LBRACK] = ACTIONS(2651),
  },
  [388] = {
    [sym_line_comment] = STATE(388),
    [sym_block_comment] = STATE(388),
    [ts_builtin_sym_end] = ACTIONS(2441),
    [sym_identifier] = ACTIONS(2443),
    [anon_sym_LF] = ACTIONS(2443),
    [anon_sym_CR] = ACTIONS(2443),
    [anon_sym_CR_LF] = ACTIONS(2443),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2445),
    [anon_sym_as] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(2443),
    [anon_sym_COMMA] = ACTIONS(2445),
    [anon_sym_const] = ACTIONS(2443),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym_EQ] = ACTIONS(2445),
    [anon_sym___global] = ACTIONS(2443),
    [anon_sym_type] = ACTIONS(2443),
    [anon_sym_fn] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2445),
    [anon_sym_STAR] = ACTIONS(2445),
    [anon_sym_SLASH] = ACTIONS(2445),
    [anon_sym_PERCENT] = ACTIONS(2445),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_GT] = ACTIONS(2445),
    [anon_sym_EQ_EQ] = ACTIONS(2445),
    [anon_sym_BANG_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_struct] = ACTIONS(2443),
    [anon_sym_union] = ACTIONS(2443),
    [anon_sym_pub] = ACTIONS(2443),
    [anon_sym_mut] = ACTIONS(2443),
    [anon_sym_enum] = ACTIONS(2443),
    [anon_sym_interface] = ACTIONS(2443),
    [anon_sym_PLUS_PLUS] = ACTIONS(2445),
    [anon_sym_DASH_DASH] = ACTIONS(2445),
    [anon_sym_QMARK] = ACTIONS(2445),
    [anon_sym_BANG] = ACTIONS(2445),
    [anon_sym_go] = ACTIONS(2443),
    [anon_sym_spawn] = ACTIONS(2443),
    [anon_sym_json_DOTdecode] = ACTIONS(2443),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_LBRACK2] = ACTIONS(2445),
    [anon_sym_TILDE] = ACTIONS(2443),
    [anon_sym_CARET] = ACTIONS(2445),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_LT_DASH] = ACTIONS(2443),
    [anon_sym_LT_LT] = ACTIONS(2445),
    [anon_sym_GT_GT] = ACTIONS(2445),
    [anon_sym_GT_GT_GT] = ACTIONS(2445),
    [anon_sym_AMP_CARET] = ACTIONS(2445),
    [anon_sym_AMP_AMP] = ACTIONS(2445),
    [anon_sym_PIPE_PIPE] = ACTIONS(2445),
    [anon_sym_or] = ACTIONS(2445),
    [sym_none] = ACTIONS(2443),
    [sym_true] = ACTIONS(2443),
    [sym_false] = ACTIONS(2443),
    [sym_nil] = ACTIONS(2443),
    [anon_sym_QMARK_DOT] = ACTIONS(2445),
    [anon_sym_POUND_LBRACK] = ACTIONS(2445),
    [anon_sym_if] = ACTIONS(2443),
    [anon_sym_DOLLARif] = ACTIONS(2443),
    [anon_sym_is] = ACTIONS(2445),
    [anon_sym_BANGis] = ACTIONS(2445),
    [anon_sym_in] = ACTIONS(2445),
    [anon_sym_BANGin] = ACTIONS(2445),
    [anon_sym_match] = ACTIONS(2443),
    [anon_sym_select] = ACTIONS(2443),
    [anon_sym_STAR_EQ] = ACTIONS(2445),
    [anon_sym_SLASH_EQ] = ACTIONS(2445),
    [anon_sym_PERCENT_EQ] = ACTIONS(2445),
    [anon_sym_LT_LT_EQ] = ACTIONS(2445),
    [anon_sym_GT_GT_EQ] = ACTIONS(2445),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2445),
    [anon_sym_AMP_EQ] = ACTIONS(2445),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2445),
    [anon_sym_PLUS_EQ] = ACTIONS(2445),
    [anon_sym_DASH_EQ] = ACTIONS(2445),
    [anon_sym_PIPE_EQ] = ACTIONS(2445),
    [anon_sym_CARET_EQ] = ACTIONS(2445),
    [anon_sym_COLON_EQ] = ACTIONS(2445),
    [anon_sym_lock] = ACTIONS(2443),
    [anon_sym_rlock] = ACTIONS(2443),
    [anon_sym_unsafe] = ACTIONS(2443),
    [anon_sym_sql] = ACTIONS(2443),
    [sym_int_literal] = ACTIONS(2443),
    [sym_float_literal] = ACTIONS(2443),
    [sym_rune_literal] = ACTIONS(2443),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [anon_sym_DQUOTE] = ACTIONS(2443),
    [anon_sym_c_SQUOTE] = ACTIONS(2443),
    [anon_sym_c_DQUOTE] = ACTIONS(2443),
    [anon_sym_r_SQUOTE] = ACTIONS(2443),
    [anon_sym_r_DQUOTE] = ACTIONS(2443),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2443),
    [anon_sym_shared] = ACTIONS(2443),
    [anon_sym_map_LBRACK] = ACTIONS(2443),
    [anon_sym_chan] = ACTIONS(2443),
    [anon_sym_thread] = ACTIONS(2443),
    [anon_sym_atomic] = ACTIONS(2443),
    [anon_sym_assert] = ACTIONS(2443),
    [anon_sym_defer] = ACTIONS(2443),
    [anon_sym_goto] = ACTIONS(2443),
    [anon_sym_break] = ACTIONS(2443),
    [anon_sym_continue] = ACTIONS(2443),
    [anon_sym_return] = ACTIONS(2443),
    [anon_sym_DOLLARfor] = ACTIONS(2443),
    [anon_sym_for] = ACTIONS(2443),
    [anon_sym_POUND] = ACTIONS(2443),
    [anon_sym_asm] = ACTIONS(2443),
    [anon_sym_AT_LBRACK] = ACTIONS(2443),
  },
  [389] = {
    [sym_line_comment] = STATE(389),
    [sym_block_comment] = STATE(389),
    [ts_builtin_sym_end] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2655),
    [anon_sym_LF] = ACTIONS(2655),
    [anon_sym_CR] = ACTIONS(2655),
    [anon_sym_CR_LF] = ACTIONS(2655),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2655),
    [anon_sym_as] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2655),
    [anon_sym_COMMA] = ACTIONS(2655),
    [anon_sym_const] = ACTIONS(2655),
    [anon_sym_LPAREN] = ACTIONS(2655),
    [anon_sym_EQ] = ACTIONS(2655),
    [anon_sym___global] = ACTIONS(2655),
    [anon_sym_type] = ACTIONS(2655),
    [anon_sym_fn] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_DASH] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_SLASH] = ACTIONS(2655),
    [anon_sym_PERCENT] = ACTIONS(2655),
    [anon_sym_LT] = ACTIONS(2655),
    [anon_sym_GT] = ACTIONS(2655),
    [anon_sym_EQ_EQ] = ACTIONS(2655),
    [anon_sym_BANG_EQ] = ACTIONS(2655),
    [anon_sym_LT_EQ] = ACTIONS(2655),
    [anon_sym_GT_EQ] = ACTIONS(2655),
    [anon_sym_LBRACK] = ACTIONS(2653),
    [anon_sym_struct] = ACTIONS(2655),
    [anon_sym_union] = ACTIONS(2655),
    [anon_sym_pub] = ACTIONS(2655),
    [anon_sym_mut] = ACTIONS(2655),
    [anon_sym_enum] = ACTIONS(2655),
    [anon_sym_interface] = ACTIONS(2655),
    [anon_sym_PLUS_PLUS] = ACTIONS(2655),
    [anon_sym_DASH_DASH] = ACTIONS(2655),
    [anon_sym_QMARK] = ACTIONS(2655),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_go] = ACTIONS(2655),
    [anon_sym_spawn] = ACTIONS(2655),
    [anon_sym_json_DOTdecode] = ACTIONS(2655),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_LBRACK2] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [anon_sym_CARET] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2655),
    [anon_sym_LT_DASH] = ACTIONS(2655),
    [anon_sym_LT_LT] = ACTIONS(2655),
    [anon_sym_GT_GT] = ACTIONS(2655),
    [anon_sym_GT_GT_GT] = ACTIONS(2655),
    [anon_sym_AMP_CARET] = ACTIONS(2655),
    [anon_sym_AMP_AMP] = ACTIONS(2655),
    [anon_sym_PIPE_PIPE] = ACTIONS(2655),
    [anon_sym_or] = ACTIONS(2655),
    [sym_none] = ACTIONS(2655),
    [sym_true] = ACTIONS(2655),
    [sym_false] = ACTIONS(2655),
    [sym_nil] = ACTIONS(2655),
    [anon_sym_QMARK_DOT] = ACTIONS(2655),
    [anon_sym_POUND_LBRACK] = ACTIONS(2655),
    [anon_sym_if] = ACTIONS(2655),
    [anon_sym_DOLLARif] = ACTIONS(2655),
    [anon_sym_is] = ACTIONS(2655),
    [anon_sym_BANGis] = ACTIONS(2655),
    [anon_sym_in] = ACTIONS(2655),
    [anon_sym_BANGin] = ACTIONS(2655),
    [anon_sym_match] = ACTIONS(2655),
    [anon_sym_select] = ACTIONS(2655),
    [anon_sym_STAR_EQ] = ACTIONS(2655),
    [anon_sym_SLASH_EQ] = ACTIONS(2655),
    [anon_sym_PERCENT_EQ] = ACTIONS(2655),
    [anon_sym_LT_LT_EQ] = ACTIONS(2655),
    [anon_sym_GT_GT_EQ] = ACTIONS(2655),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2655),
    [anon_sym_AMP_EQ] = ACTIONS(2655),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2655),
    [anon_sym_PLUS_EQ] = ACTIONS(2655),
    [anon_sym_DASH_EQ] = ACTIONS(2655),
    [anon_sym_PIPE_EQ] = ACTIONS(2655),
    [anon_sym_CARET_EQ] = ACTIONS(2655),
    [anon_sym_COLON_EQ] = ACTIONS(2655),
    [anon_sym_lock] = ACTIONS(2655),
    [anon_sym_rlock] = ACTIONS(2655),
    [anon_sym_unsafe] = ACTIONS(2655),
    [anon_sym_sql] = ACTIONS(2655),
    [sym_int_literal] = ACTIONS(2655),
    [sym_float_literal] = ACTIONS(2655),
    [sym_rune_literal] = ACTIONS(2655),
    [anon_sym_SQUOTE] = ACTIONS(2655),
    [anon_sym_DQUOTE] = ACTIONS(2655),
    [anon_sym_c_SQUOTE] = ACTIONS(2655),
    [anon_sym_c_DQUOTE] = ACTIONS(2655),
    [anon_sym_r_SQUOTE] = ACTIONS(2655),
    [anon_sym_r_DQUOTE] = ACTIONS(2655),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2655),
    [anon_sym_shared] = ACTIONS(2655),
    [anon_sym_map_LBRACK] = ACTIONS(2655),
    [anon_sym_chan] = ACTIONS(2655),
    [anon_sym_thread] = ACTIONS(2655),
    [anon_sym_atomic] = ACTIONS(2655),
    [anon_sym_assert] = ACTIONS(2655),
    [anon_sym_defer] = ACTIONS(2655),
    [anon_sym_goto] = ACTIONS(2655),
    [anon_sym_break] = ACTIONS(2655),
    [anon_sym_continue] = ACTIONS(2655),
    [anon_sym_return] = ACTIONS(2655),
    [anon_sym_DOLLARfor] = ACTIONS(2655),
    [anon_sym_for] = ACTIONS(2655),
    [anon_sym_POUND] = ACTIONS(2655),
    [anon_sym_asm] = ACTIONS(2655),
    [anon_sym_AT_LBRACK] = ACTIONS(2655),
  },
  [390] = {
    [sym_line_comment] = STATE(390),
    [sym_block_comment] = STATE(390),
    [ts_builtin_sym_end] = ACTIONS(2657),
    [sym_identifier] = ACTIONS(2659),
    [anon_sym_LF] = ACTIONS(2659),
    [anon_sym_CR] = ACTIONS(2659),
    [anon_sym_CR_LF] = ACTIONS(2659),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2659),
    [anon_sym_as] = ACTIONS(2659),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_COMMA] = ACTIONS(2659),
    [anon_sym_const] = ACTIONS(2659),
    [anon_sym_LPAREN] = ACTIONS(2659),
    [anon_sym_EQ] = ACTIONS(2659),
    [anon_sym___global] = ACTIONS(2659),
    [anon_sym_type] = ACTIONS(2659),
    [anon_sym_fn] = ACTIONS(2659),
    [anon_sym_PLUS] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_SLASH] = ACTIONS(2659),
    [anon_sym_PERCENT] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(2659),
    [anon_sym_GT] = ACTIONS(2659),
    [anon_sym_EQ_EQ] = ACTIONS(2659),
    [anon_sym_BANG_EQ] = ACTIONS(2659),
    [anon_sym_LT_EQ] = ACTIONS(2659),
    [anon_sym_GT_EQ] = ACTIONS(2659),
    [anon_sym_LBRACK] = ACTIONS(2657),
    [anon_sym_struct] = ACTIONS(2659),
    [anon_sym_union] = ACTIONS(2659),
    [anon_sym_pub] = ACTIONS(2659),
    [anon_sym_mut] = ACTIONS(2659),
    [anon_sym_enum] = ACTIONS(2659),
    [anon_sym_interface] = ACTIONS(2659),
    [anon_sym_PLUS_PLUS] = ACTIONS(2659),
    [anon_sym_DASH_DASH] = ACTIONS(2659),
    [anon_sym_QMARK] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_go] = ACTIONS(2659),
    [anon_sym_spawn] = ACTIONS(2659),
    [anon_sym_json_DOTdecode] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(2659),
    [anon_sym_LBRACK2] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_CARET] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2659),
    [anon_sym_LT_DASH] = ACTIONS(2659),
    [anon_sym_LT_LT] = ACTIONS(2659),
    [anon_sym_GT_GT] = ACTIONS(2659),
    [anon_sym_GT_GT_GT] = ACTIONS(2659),
    [anon_sym_AMP_CARET] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_PIPE_PIPE] = ACTIONS(2659),
    [anon_sym_or] = ACTIONS(2659),
    [sym_none] = ACTIONS(2659),
    [sym_true] = ACTIONS(2659),
    [sym_false] = ACTIONS(2659),
    [sym_nil] = ACTIONS(2659),
    [anon_sym_QMARK_DOT] = ACTIONS(2659),
    [anon_sym_POUND_LBRACK] = ACTIONS(2659),
    [anon_sym_if] = ACTIONS(2659),
    [anon_sym_DOLLARif] = ACTIONS(2659),
    [anon_sym_is] = ACTIONS(2659),
    [anon_sym_BANGis] = ACTIONS(2659),
    [anon_sym_in] = ACTIONS(2659),
    [anon_sym_BANGin] = ACTIONS(2659),
    [anon_sym_match] = ACTIONS(2659),
    [anon_sym_select] = ACTIONS(2659),
    [anon_sym_STAR_EQ] = ACTIONS(2659),
    [anon_sym_SLASH_EQ] = ACTIONS(2659),
    [anon_sym_PERCENT_EQ] = ACTIONS(2659),
    [anon_sym_LT_LT_EQ] = ACTIONS(2659),
    [anon_sym_GT_GT_EQ] = ACTIONS(2659),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2659),
    [anon_sym_AMP_EQ] = ACTIONS(2659),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2659),
    [anon_sym_PLUS_EQ] = ACTIONS(2659),
    [anon_sym_DASH_EQ] = ACTIONS(2659),
    [anon_sym_PIPE_EQ] = ACTIONS(2659),
    [anon_sym_CARET_EQ] = ACTIONS(2659),
    [anon_sym_COLON_EQ] = ACTIONS(2659),
    [anon_sym_lock] = ACTIONS(2659),
    [anon_sym_rlock] = ACTIONS(2659),
    [anon_sym_unsafe] = ACTIONS(2659),
    [anon_sym_sql] = ACTIONS(2659),
    [sym_int_literal] = ACTIONS(2659),
    [sym_float_literal] = ACTIONS(2659),
    [sym_rune_literal] = ACTIONS(2659),
    [anon_sym_SQUOTE] = ACTIONS(2659),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [anon_sym_c_SQUOTE] = ACTIONS(2659),
    [anon_sym_c_DQUOTE] = ACTIONS(2659),
    [anon_sym_r_SQUOTE] = ACTIONS(2659),
    [anon_sym_r_DQUOTE] = ACTIONS(2659),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2659),
    [anon_sym_shared] = ACTIONS(2659),
    [anon_sym_map_LBRACK] = ACTIONS(2659),
    [anon_sym_chan] = ACTIONS(2659),
    [anon_sym_thread] = ACTIONS(2659),
    [anon_sym_atomic] = ACTIONS(2659),
    [anon_sym_assert] = ACTIONS(2659),
    [anon_sym_defer] = ACTIONS(2659),
    [anon_sym_goto] = ACTIONS(2659),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_continue] = ACTIONS(2659),
    [anon_sym_return] = ACTIONS(2659),
    [anon_sym_DOLLARfor] = ACTIONS(2659),
    [anon_sym_for] = ACTIONS(2659),
    [anon_sym_POUND] = ACTIONS(2659),
    [anon_sym_asm] = ACTIONS(2659),
    [anon_sym_AT_LBRACK] = ACTIONS(2659),
  },
  [391] = {
    [sym_line_comment] = STATE(391),
    [sym_block_comment] = STATE(391),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4427),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2661),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [392] = {
    [sym_line_comment] = STATE(392),
    [sym_block_comment] = STATE(392),
    [sym__expression] = STATE(2578),
    [sym__expression_without_blocks] = STATE(2660),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_match_arm_type] = STATE(4237),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4025),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__definite_range] = STATE(4217),
    [sym_identifier] = ACTIONS(1445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(1487),
    [anon_sym_lock] = ACTIONS(1489),
    [anon_sym_rlock] = ACTIONS(1489),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [393] = {
    [sym_line_comment] = STATE(393),
    [sym_block_comment] = STATE(393),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4490),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2663),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [394] = {
    [sym_line_comment] = STATE(394),
    [sym_block_comment] = STATE(394),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4511),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2665),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [395] = {
    [sym_line_comment] = STATE(395),
    [sym_block_comment] = STATE(395),
    [ts_builtin_sym_end] = ACTIONS(2667),
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_LF] = ACTIONS(2669),
    [anon_sym_CR] = ACTIONS(2669),
    [anon_sym_CR_LF] = ACTIONS(2669),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2669),
    [anon_sym_as] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2669),
    [anon_sym_COMMA] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_LPAREN] = ACTIONS(2669),
    [anon_sym_EQ] = ACTIONS(2669),
    [anon_sym___global] = ACTIONS(2669),
    [anon_sym_type] = ACTIONS(2669),
    [anon_sym_fn] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2669),
    [anon_sym_SLASH] = ACTIONS(2669),
    [anon_sym_PERCENT] = ACTIONS(2669),
    [anon_sym_LT] = ACTIONS(2669),
    [anon_sym_GT] = ACTIONS(2669),
    [anon_sym_EQ_EQ] = ACTIONS(2669),
    [anon_sym_BANG_EQ] = ACTIONS(2669),
    [anon_sym_LT_EQ] = ACTIONS(2669),
    [anon_sym_GT_EQ] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2667),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_union] = ACTIONS(2669),
    [anon_sym_pub] = ACTIONS(2669),
    [anon_sym_mut] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [anon_sym_interface] = ACTIONS(2669),
    [anon_sym_PLUS_PLUS] = ACTIONS(2669),
    [anon_sym_DASH_DASH] = ACTIONS(2669),
    [anon_sym_QMARK] = ACTIONS(2669),
    [anon_sym_BANG] = ACTIONS(2669),
    [anon_sym_go] = ACTIONS(2669),
    [anon_sym_spawn] = ACTIONS(2669),
    [anon_sym_json_DOTdecode] = ACTIONS(2669),
    [anon_sym_PIPE] = ACTIONS(2669),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_TILDE] = ACTIONS(2669),
    [anon_sym_CARET] = ACTIONS(2669),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_LT_DASH] = ACTIONS(2669),
    [anon_sym_LT_LT] = ACTIONS(2669),
    [anon_sym_GT_GT] = ACTIONS(2669),
    [anon_sym_GT_GT_GT] = ACTIONS(2669),
    [anon_sym_AMP_CARET] = ACTIONS(2669),
    [anon_sym_AMP_AMP] = ACTIONS(2669),
    [anon_sym_PIPE_PIPE] = ACTIONS(2669),
    [anon_sym_or] = ACTIONS(2669),
    [sym_none] = ACTIONS(2669),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [sym_nil] = ACTIONS(2669),
    [anon_sym_QMARK_DOT] = ACTIONS(2669),
    [anon_sym_POUND_LBRACK] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_DOLLARif] = ACTIONS(2669),
    [anon_sym_is] = ACTIONS(2669),
    [anon_sym_BANGis] = ACTIONS(2669),
    [anon_sym_in] = ACTIONS(2669),
    [anon_sym_BANGin] = ACTIONS(2669),
    [anon_sym_match] = ACTIONS(2669),
    [anon_sym_select] = ACTIONS(2669),
    [anon_sym_STAR_EQ] = ACTIONS(2669),
    [anon_sym_SLASH_EQ] = ACTIONS(2669),
    [anon_sym_PERCENT_EQ] = ACTIONS(2669),
    [anon_sym_LT_LT_EQ] = ACTIONS(2669),
    [anon_sym_GT_GT_EQ] = ACTIONS(2669),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2669),
    [anon_sym_AMP_EQ] = ACTIONS(2669),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2669),
    [anon_sym_PLUS_EQ] = ACTIONS(2669),
    [anon_sym_DASH_EQ] = ACTIONS(2669),
    [anon_sym_PIPE_EQ] = ACTIONS(2669),
    [anon_sym_CARET_EQ] = ACTIONS(2669),
    [anon_sym_COLON_EQ] = ACTIONS(2669),
    [anon_sym_lock] = ACTIONS(2669),
    [anon_sym_rlock] = ACTIONS(2669),
    [anon_sym_unsafe] = ACTIONS(2669),
    [anon_sym_sql] = ACTIONS(2669),
    [sym_int_literal] = ACTIONS(2669),
    [sym_float_literal] = ACTIONS(2669),
    [sym_rune_literal] = ACTIONS(2669),
    [anon_sym_SQUOTE] = ACTIONS(2669),
    [anon_sym_DQUOTE] = ACTIONS(2669),
    [anon_sym_c_SQUOTE] = ACTIONS(2669),
    [anon_sym_c_DQUOTE] = ACTIONS(2669),
    [anon_sym_r_SQUOTE] = ACTIONS(2669),
    [anon_sym_r_DQUOTE] = ACTIONS(2669),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2669),
    [anon_sym_shared] = ACTIONS(2669),
    [anon_sym_map_LBRACK] = ACTIONS(2669),
    [anon_sym_chan] = ACTIONS(2669),
    [anon_sym_thread] = ACTIONS(2669),
    [anon_sym_atomic] = ACTIONS(2669),
    [anon_sym_assert] = ACTIONS(2669),
    [anon_sym_defer] = ACTIONS(2669),
    [anon_sym_goto] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_DOLLARfor] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_POUND] = ACTIONS(2669),
    [anon_sym_asm] = ACTIONS(2669),
    [anon_sym_AT_LBRACK] = ACTIONS(2669),
  },
  [396] = {
    [sym_line_comment] = STATE(396),
    [sym_block_comment] = STATE(396),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(402),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(2671),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [397] = {
    [sym_line_comment] = STATE(397),
    [sym_block_comment] = STATE(397),
    [sym__expression] = STATE(2565),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(624),
    [sym_mutable_expression] = STATE(4083),
    [sym_expression_list] = STATE(4116),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_go] = ACTIONS(2681),
    [anon_sym_spawn] = ACTIONS(2683),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_CARET] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2691),
    [anon_sym_lock] = ACTIONS(2693),
    [anon_sym_rlock] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [398] = {
    [sym_line_comment] = STATE(398),
    [sym_block_comment] = STATE(398),
    [sym__expression] = STATE(2613),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4445),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [399] = {
    [sym_line_comment] = STATE(399),
    [sym_block_comment] = STATE(399),
    [sym__expression] = STATE(2613),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3688),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4445),
    [sym_identifier] = ACTIONS(2385),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(2387),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2389),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(2391),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [400] = {
    [sym_line_comment] = STATE(400),
    [sym_block_comment] = STATE(400),
    [sym__expression] = STATE(2593),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4541),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [401] = {
    [sym_line_comment] = STATE(401),
    [sym_block_comment] = STATE(401),
    [ts_builtin_sym_end] = ACTIONS(2695),
    [sym_identifier] = ACTIONS(2697),
    [anon_sym_LF] = ACTIONS(2697),
    [anon_sym_CR] = ACTIONS(2697),
    [anon_sym_CR_LF] = ACTIONS(2697),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2697),
    [anon_sym_as] = ACTIONS(2697),
    [anon_sym_LBRACE] = ACTIONS(2697),
    [anon_sym_COMMA] = ACTIONS(2697),
    [anon_sym_const] = ACTIONS(2697),
    [anon_sym_LPAREN] = ACTIONS(2697),
    [anon_sym_EQ] = ACTIONS(2697),
    [anon_sym___global] = ACTIONS(2697),
    [anon_sym_type] = ACTIONS(2697),
    [anon_sym_fn] = ACTIONS(2697),
    [anon_sym_PLUS] = ACTIONS(2697),
    [anon_sym_DASH] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2697),
    [anon_sym_SLASH] = ACTIONS(2697),
    [anon_sym_PERCENT] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2697),
    [anon_sym_GT] = ACTIONS(2697),
    [anon_sym_EQ_EQ] = ACTIONS(2697),
    [anon_sym_BANG_EQ] = ACTIONS(2697),
    [anon_sym_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT_EQ] = ACTIONS(2697),
    [anon_sym_LBRACK] = ACTIONS(2695),
    [anon_sym_struct] = ACTIONS(2697),
    [anon_sym_union] = ACTIONS(2697),
    [anon_sym_pub] = ACTIONS(2697),
    [anon_sym_mut] = ACTIONS(2697),
    [anon_sym_enum] = ACTIONS(2697),
    [anon_sym_interface] = ACTIONS(2697),
    [anon_sym_PLUS_PLUS] = ACTIONS(2697),
    [anon_sym_DASH_DASH] = ACTIONS(2697),
    [anon_sym_QMARK] = ACTIONS(2697),
    [anon_sym_BANG] = ACTIONS(2699),
    [anon_sym_go] = ACTIONS(2697),
    [anon_sym_spawn] = ACTIONS(2697),
    [anon_sym_json_DOTdecode] = ACTIONS(2697),
    [anon_sym_PIPE] = ACTIONS(2697),
    [anon_sym_LBRACK2] = ACTIONS(2697),
    [anon_sym_TILDE] = ACTIONS(2697),
    [anon_sym_CARET] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2697),
    [anon_sym_LT_DASH] = ACTIONS(2697),
    [anon_sym_LT_LT] = ACTIONS(2697),
    [anon_sym_GT_GT] = ACTIONS(2697),
    [anon_sym_GT_GT_GT] = ACTIONS(2697),
    [anon_sym_AMP_CARET] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_PIPE_PIPE] = ACTIONS(2697),
    [anon_sym_or] = ACTIONS(2697),
    [sym_none] = ACTIONS(2697),
    [sym_true] = ACTIONS(2697),
    [sym_false] = ACTIONS(2697),
    [sym_nil] = ACTIONS(2697),
    [anon_sym_QMARK_DOT] = ACTIONS(2697),
    [anon_sym_POUND_LBRACK] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(2697),
    [anon_sym_DOLLARif] = ACTIONS(2697),
    [anon_sym_is] = ACTIONS(2697),
    [anon_sym_BANGis] = ACTIONS(2697),
    [anon_sym_in] = ACTIONS(2697),
    [anon_sym_BANGin] = ACTIONS(2697),
    [anon_sym_match] = ACTIONS(2697),
    [anon_sym_select] = ACTIONS(2697),
    [anon_sym_STAR_EQ] = ACTIONS(2697),
    [anon_sym_SLASH_EQ] = ACTIONS(2697),
    [anon_sym_PERCENT_EQ] = ACTIONS(2697),
    [anon_sym_LT_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT_GT_EQ] = ACTIONS(2697),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2697),
    [anon_sym_AMP_EQ] = ACTIONS(2697),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2697),
    [anon_sym_PLUS_EQ] = ACTIONS(2697),
    [anon_sym_DASH_EQ] = ACTIONS(2697),
    [anon_sym_PIPE_EQ] = ACTIONS(2697),
    [anon_sym_CARET_EQ] = ACTIONS(2697),
    [anon_sym_COLON_EQ] = ACTIONS(2697),
    [anon_sym_lock] = ACTIONS(2697),
    [anon_sym_rlock] = ACTIONS(2697),
    [anon_sym_unsafe] = ACTIONS(2697),
    [anon_sym_sql] = ACTIONS(2697),
    [sym_int_literal] = ACTIONS(2697),
    [sym_float_literal] = ACTIONS(2697),
    [sym_rune_literal] = ACTIONS(2697),
    [anon_sym_SQUOTE] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [anon_sym_c_SQUOTE] = ACTIONS(2697),
    [anon_sym_c_DQUOTE] = ACTIONS(2697),
    [anon_sym_r_SQUOTE] = ACTIONS(2697),
    [anon_sym_r_DQUOTE] = ACTIONS(2697),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2697),
    [anon_sym_shared] = ACTIONS(2697),
    [anon_sym_map_LBRACK] = ACTIONS(2697),
    [anon_sym_chan] = ACTIONS(2697),
    [anon_sym_thread] = ACTIONS(2697),
    [anon_sym_atomic] = ACTIONS(2697),
    [anon_sym_assert] = ACTIONS(2697),
    [anon_sym_defer] = ACTIONS(2697),
    [anon_sym_goto] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2697),
    [anon_sym_continue] = ACTIONS(2697),
    [anon_sym_return] = ACTIONS(2697),
    [anon_sym_DOLLARfor] = ACTIONS(2697),
    [anon_sym_for] = ACTIONS(2697),
    [anon_sym_POUND] = ACTIONS(2697),
    [anon_sym_asm] = ACTIONS(2697),
    [anon_sym_AT_LBRACK] = ACTIONS(2697),
  },
  [402] = {
    [sym_line_comment] = STATE(402),
    [sym_block_comment] = STATE(402),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(402),
    [sym_identifier] = ACTIONS(2701),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2704),
    [anon_sym_LBRACE] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(2710),
    [anon_sym_fn] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2716),
    [anon_sym_DASH] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_RBRACK] = ACTIONS(2722),
    [anon_sym_struct] = ACTIONS(2724),
    [anon_sym_mut] = ACTIONS(2727),
    [anon_sym_QMARK] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_go] = ACTIONS(2736),
    [anon_sym_spawn] = ACTIONS(2739),
    [anon_sym_json_DOTdecode] = ACTIONS(2742),
    [anon_sym_LBRACK2] = ACTIONS(2745),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_CARET] = ACTIONS(2716),
    [anon_sym_AMP] = ACTIONS(2748),
    [anon_sym_LT_DASH] = ACTIONS(2751),
    [sym_none] = ACTIONS(2754),
    [sym_true] = ACTIONS(2754),
    [sym_false] = ACTIONS(2754),
    [sym_nil] = ACTIONS(2754),
    [anon_sym_if] = ACTIONS(2757),
    [anon_sym_DOLLARif] = ACTIONS(2760),
    [anon_sym_match] = ACTIONS(2763),
    [anon_sym_select] = ACTIONS(2766),
    [anon_sym_lock] = ACTIONS(2769),
    [anon_sym_rlock] = ACTIONS(2769),
    [anon_sym_unsafe] = ACTIONS(2772),
    [anon_sym_sql] = ACTIONS(2775),
    [sym_int_literal] = ACTIONS(2754),
    [sym_float_literal] = ACTIONS(2778),
    [sym_rune_literal] = ACTIONS(2778),
    [anon_sym_SQUOTE] = ACTIONS(2781),
    [anon_sym_DQUOTE] = ACTIONS(2784),
    [anon_sym_c_SQUOTE] = ACTIONS(2787),
    [anon_sym_c_DQUOTE] = ACTIONS(2790),
    [anon_sym_r_SQUOTE] = ACTIONS(2793),
    [anon_sym_r_DQUOTE] = ACTIONS(2796),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2799),
    [anon_sym_shared] = ACTIONS(2802),
    [anon_sym_map_LBRACK] = ACTIONS(2805),
    [anon_sym_chan] = ACTIONS(2808),
    [anon_sym_thread] = ACTIONS(2811),
    [anon_sym_atomic] = ACTIONS(2814),
  },
  [403] = {
    [sym_line_comment] = STATE(403),
    [sym_block_comment] = STATE(403),
    [ts_builtin_sym_end] = ACTIONS(2173),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LF] = ACTIONS(2175),
    [anon_sym_CR] = ACTIONS(2175),
    [anon_sym_CR_LF] = ACTIONS(2175),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2175),
    [anon_sym_as] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2177),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym_const] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_EQ] = ACTIONS(2175),
    [anon_sym___global] = ACTIONS(2175),
    [anon_sym_type] = ACTIONS(2175),
    [anon_sym_fn] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2175),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_PERCENT] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_GT] = ACTIONS(2175),
    [anon_sym_EQ_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ] = ACTIONS(2175),
    [anon_sym_LT_EQ] = ACTIONS(2175),
    [anon_sym_GT_EQ] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2180),
    [anon_sym_struct] = ACTIONS(2175),
    [anon_sym_union] = ACTIONS(2175),
    [anon_sym_pub] = ACTIONS(2175),
    [anon_sym_mut] = ACTIONS(2175),
    [anon_sym_enum] = ACTIONS(2175),
    [anon_sym_interface] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [anon_sym_QMARK] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_go] = ACTIONS(2175),
    [anon_sym_spawn] = ACTIONS(2175),
    [anon_sym_json_DOTdecode] = ACTIONS(2175),
    [anon_sym_PIPE] = ACTIONS(2175),
    [anon_sym_LBRACK2] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_CARET] = ACTIONS(2175),
    [anon_sym_AMP] = ACTIONS(2175),
    [anon_sym_LT_DASH] = ACTIONS(2175),
    [anon_sym_LT_LT] = ACTIONS(2175),
    [anon_sym_GT_GT] = ACTIONS(2175),
    [anon_sym_GT_GT_GT] = ACTIONS(2175),
    [anon_sym_AMP_CARET] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(2175),
    [anon_sym_PIPE_PIPE] = ACTIONS(2175),
    [anon_sym_or] = ACTIONS(2175),
    [sym_none] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_nil] = ACTIONS(2175),
    [anon_sym_QMARK_DOT] = ACTIONS(2175),
    [anon_sym_POUND_LBRACK] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_DOLLARif] = ACTIONS(2175),
    [anon_sym_is] = ACTIONS(2175),
    [anon_sym_BANGis] = ACTIONS(2175),
    [anon_sym_in] = ACTIONS(2175),
    [anon_sym_BANGin] = ACTIONS(2175),
    [anon_sym_match] = ACTIONS(2175),
    [anon_sym_select] = ACTIONS(2175),
    [anon_sym_STAR_EQ] = ACTIONS(2175),
    [anon_sym_SLASH_EQ] = ACTIONS(2175),
    [anon_sym_PERCENT_EQ] = ACTIONS(2175),
    [anon_sym_LT_LT_EQ] = ACTIONS(2175),
    [anon_sym_GT_GT_EQ] = ACTIONS(2175),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2175),
    [anon_sym_AMP_EQ] = ACTIONS(2175),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2175),
    [anon_sym_PLUS_EQ] = ACTIONS(2175),
    [anon_sym_DASH_EQ] = ACTIONS(2175),
    [anon_sym_PIPE_EQ] = ACTIONS(2175),
    [anon_sym_CARET_EQ] = ACTIONS(2175),
    [anon_sym_COLON_EQ] = ACTIONS(2175),
    [anon_sym_lock] = ACTIONS(2175),
    [anon_sym_rlock] = ACTIONS(2175),
    [anon_sym_unsafe] = ACTIONS(2175),
    [anon_sym_sql] = ACTIONS(2175),
    [sym_int_literal] = ACTIONS(2175),
    [sym_float_literal] = ACTIONS(2175),
    [sym_rune_literal] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_c_SQUOTE] = ACTIONS(2175),
    [anon_sym_c_DQUOTE] = ACTIONS(2175),
    [anon_sym_r_SQUOTE] = ACTIONS(2175),
    [anon_sym_r_DQUOTE] = ACTIONS(2175),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2175),
    [anon_sym_shared] = ACTIONS(2175),
    [anon_sym_map_LBRACK] = ACTIONS(2175),
    [anon_sym_chan] = ACTIONS(2175),
    [anon_sym_thread] = ACTIONS(2175),
    [anon_sym_atomic] = ACTIONS(2175),
    [anon_sym_assert] = ACTIONS(2175),
    [anon_sym_defer] = ACTIONS(2175),
    [anon_sym_goto] = ACTIONS(2175),
    [anon_sym_break] = ACTIONS(2175),
    [anon_sym_continue] = ACTIONS(2175),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_DOLLARfor] = ACTIONS(2175),
    [anon_sym_for] = ACTIONS(2175),
    [anon_sym_POUND] = ACTIONS(2175),
    [anon_sym_asm] = ACTIONS(2175),
    [anon_sym_AT_LBRACK] = ACTIONS(2175),
  },
  [404] = {
    [sym_line_comment] = STATE(404),
    [sym_block_comment] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(2817),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_LF] = ACTIONS(2819),
    [anon_sym_CR] = ACTIONS(2819),
    [anon_sym_CR_LF] = ACTIONS(2819),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2819),
    [anon_sym_as] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2819),
    [anon_sym_const] = ACTIONS(2819),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_EQ] = ACTIONS(2819),
    [anon_sym___global] = ACTIONS(2819),
    [anon_sym_type] = ACTIONS(2819),
    [anon_sym_fn] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_LT] = ACTIONS(2819),
    [anon_sym_GT] = ACTIONS(2819),
    [anon_sym_EQ_EQ] = ACTIONS(2819),
    [anon_sym_BANG_EQ] = ACTIONS(2819),
    [anon_sym_LT_EQ] = ACTIONS(2819),
    [anon_sym_GT_EQ] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2817),
    [anon_sym_struct] = ACTIONS(2819),
    [anon_sym_union] = ACTIONS(2819),
    [anon_sym_pub] = ACTIONS(2819),
    [anon_sym_mut] = ACTIONS(2819),
    [anon_sym_enum] = ACTIONS(2819),
    [anon_sym_interface] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2819),
    [anon_sym_DASH_DASH] = ACTIONS(2819),
    [anon_sym_QMARK] = ACTIONS(2819),
    [anon_sym_BANG] = ACTIONS(2819),
    [anon_sym_go] = ACTIONS(2819),
    [anon_sym_spawn] = ACTIONS(2819),
    [anon_sym_json_DOTdecode] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(2819),
    [anon_sym_LBRACK2] = ACTIONS(2819),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_CARET] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_LT_DASH] = ACTIONS(2819),
    [anon_sym_LT_LT] = ACTIONS(2819),
    [anon_sym_GT_GT] = ACTIONS(2819),
    [anon_sym_GT_GT_GT] = ACTIONS(2819),
    [anon_sym_AMP_CARET] = ACTIONS(2819),
    [anon_sym_AMP_AMP] = ACTIONS(2819),
    [anon_sym_PIPE_PIPE] = ACTIONS(2819),
    [anon_sym_or] = ACTIONS(2819),
    [sym_none] = ACTIONS(2819),
    [sym_true] = ACTIONS(2819),
    [sym_false] = ACTIONS(2819),
    [sym_nil] = ACTIONS(2819),
    [anon_sym_QMARK_DOT] = ACTIONS(2819),
    [anon_sym_POUND_LBRACK] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_DOLLARif] = ACTIONS(2819),
    [anon_sym_is] = ACTIONS(2819),
    [anon_sym_BANGis] = ACTIONS(2819),
    [anon_sym_in] = ACTIONS(2819),
    [anon_sym_BANGin] = ACTIONS(2819),
    [anon_sym_match] = ACTIONS(2819),
    [anon_sym_select] = ACTIONS(2819),
    [anon_sym_STAR_EQ] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(2819),
    [anon_sym_LT_LT_EQ] = ACTIONS(2819),
    [anon_sym_GT_GT_EQ] = ACTIONS(2819),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2819),
    [anon_sym_AMP_EQ] = ACTIONS(2819),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2819),
    [anon_sym_PLUS_EQ] = ACTIONS(2819),
    [anon_sym_DASH_EQ] = ACTIONS(2819),
    [anon_sym_PIPE_EQ] = ACTIONS(2819),
    [anon_sym_CARET_EQ] = ACTIONS(2819),
    [anon_sym_COLON_EQ] = ACTIONS(2819),
    [anon_sym_lock] = ACTIONS(2819),
    [anon_sym_rlock] = ACTIONS(2819),
    [anon_sym_unsafe] = ACTIONS(2819),
    [anon_sym_sql] = ACTIONS(2819),
    [sym_int_literal] = ACTIONS(2819),
    [sym_float_literal] = ACTIONS(2819),
    [sym_rune_literal] = ACTIONS(2819),
    [anon_sym_SQUOTE] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2819),
    [anon_sym_c_SQUOTE] = ACTIONS(2819),
    [anon_sym_c_DQUOTE] = ACTIONS(2819),
    [anon_sym_r_SQUOTE] = ACTIONS(2819),
    [anon_sym_r_DQUOTE] = ACTIONS(2819),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2819),
    [anon_sym_shared] = ACTIONS(2819),
    [anon_sym_map_LBRACK] = ACTIONS(2819),
    [anon_sym_chan] = ACTIONS(2819),
    [anon_sym_thread] = ACTIONS(2819),
    [anon_sym_atomic] = ACTIONS(2819),
    [anon_sym_assert] = ACTIONS(2819),
    [anon_sym_defer] = ACTIONS(2819),
    [anon_sym_goto] = ACTIONS(2819),
    [anon_sym_break] = ACTIONS(2819),
    [anon_sym_continue] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_DOLLARfor] = ACTIONS(2819),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_POUND] = ACTIONS(2819),
    [anon_sym_asm] = ACTIONS(2819),
    [anon_sym_AT_LBRACK] = ACTIONS(2819),
  },
  [405] = {
    [sym_line_comment] = STATE(405),
    [sym_block_comment] = STATE(405),
    [ts_builtin_sym_end] = ACTIONS(2821),
    [sym_identifier] = ACTIONS(2823),
    [anon_sym_LF] = ACTIONS(2823),
    [anon_sym_CR] = ACTIONS(2823),
    [anon_sym_CR_LF] = ACTIONS(2823),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2823),
    [anon_sym_as] = ACTIONS(2823),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_COMMA] = ACTIONS(2823),
    [anon_sym_const] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_EQ] = ACTIONS(2823),
    [anon_sym___global] = ACTIONS(2823),
    [anon_sym_type] = ACTIONS(2823),
    [anon_sym_fn] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2823),
    [anon_sym_DASH] = ACTIONS(2823),
    [anon_sym_STAR] = ACTIONS(2823),
    [anon_sym_SLASH] = ACTIONS(2823),
    [anon_sym_PERCENT] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2823),
    [anon_sym_GT] = ACTIONS(2823),
    [anon_sym_EQ_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_EQ] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(2821),
    [anon_sym_struct] = ACTIONS(2823),
    [anon_sym_union] = ACTIONS(2823),
    [anon_sym_pub] = ACTIONS(2823),
    [anon_sym_mut] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2823),
    [anon_sym_interface] = ACTIONS(2823),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_QMARK] = ACTIONS(2823),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_go] = ACTIONS(2823),
    [anon_sym_spawn] = ACTIONS(2823),
    [anon_sym_json_DOTdecode] = ACTIONS(2823),
    [anon_sym_PIPE] = ACTIONS(2823),
    [anon_sym_LBRACK2] = ACTIONS(2823),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_CARET] = ACTIONS(2823),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_LT_DASH] = ACTIONS(2823),
    [anon_sym_LT_LT] = ACTIONS(2823),
    [anon_sym_GT_GT] = ACTIONS(2823),
    [anon_sym_GT_GT_GT] = ACTIONS(2823),
    [anon_sym_AMP_CARET] = ACTIONS(2823),
    [anon_sym_AMP_AMP] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2823),
    [anon_sym_or] = ACTIONS(2823),
    [sym_none] = ACTIONS(2823),
    [sym_true] = ACTIONS(2823),
    [sym_false] = ACTIONS(2823),
    [sym_nil] = ACTIONS(2823),
    [anon_sym_QMARK_DOT] = ACTIONS(2823),
    [anon_sym_POUND_LBRACK] = ACTIONS(2823),
    [anon_sym_if] = ACTIONS(2823),
    [anon_sym_DOLLARif] = ACTIONS(2823),
    [anon_sym_is] = ACTIONS(2823),
    [anon_sym_BANGis] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(2823),
    [anon_sym_BANGin] = ACTIONS(2823),
    [anon_sym_match] = ACTIONS(2823),
    [anon_sym_select] = ACTIONS(2823),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_COLON_EQ] = ACTIONS(2823),
    [anon_sym_lock] = ACTIONS(2823),
    [anon_sym_rlock] = ACTIONS(2823),
    [anon_sym_unsafe] = ACTIONS(2823),
    [anon_sym_sql] = ACTIONS(2823),
    [sym_int_literal] = ACTIONS(2823),
    [sym_float_literal] = ACTIONS(2823),
    [sym_rune_literal] = ACTIONS(2823),
    [anon_sym_SQUOTE] = ACTIONS(2823),
    [anon_sym_DQUOTE] = ACTIONS(2823),
    [anon_sym_c_SQUOTE] = ACTIONS(2823),
    [anon_sym_c_DQUOTE] = ACTIONS(2823),
    [anon_sym_r_SQUOTE] = ACTIONS(2823),
    [anon_sym_r_DQUOTE] = ACTIONS(2823),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2823),
    [anon_sym_shared] = ACTIONS(2823),
    [anon_sym_map_LBRACK] = ACTIONS(2823),
    [anon_sym_chan] = ACTIONS(2823),
    [anon_sym_thread] = ACTIONS(2823),
    [anon_sym_atomic] = ACTIONS(2823),
    [anon_sym_assert] = ACTIONS(2823),
    [anon_sym_defer] = ACTIONS(2823),
    [anon_sym_goto] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2823),
    [anon_sym_continue] = ACTIONS(2823),
    [anon_sym_return] = ACTIONS(2823),
    [anon_sym_DOLLARfor] = ACTIONS(2823),
    [anon_sym_for] = ACTIONS(2823),
    [anon_sym_POUND] = ACTIONS(2823),
    [anon_sym_asm] = ACTIONS(2823),
    [anon_sym_AT_LBRACK] = ACTIONS(2823),
  },
  [406] = {
    [sym_line_comment] = STATE(406),
    [sym_block_comment] = STATE(406),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4492),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [407] = {
    [sym_line_comment] = STATE(407),
    [sym_block_comment] = STATE(407),
    [ts_builtin_sym_end] = ACTIONS(2827),
    [sym_identifier] = ACTIONS(2829),
    [anon_sym_LF] = ACTIONS(2829),
    [anon_sym_CR] = ACTIONS(2829),
    [anon_sym_CR_LF] = ACTIONS(2829),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2829),
    [anon_sym_as] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_const] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_EQ] = ACTIONS(2829),
    [anon_sym___global] = ACTIONS(2829),
    [anon_sym_type] = ACTIONS(2829),
    [anon_sym_fn] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(2829),
    [anon_sym_SLASH] = ACTIONS(2829),
    [anon_sym_PERCENT] = ACTIONS(2829),
    [anon_sym_LT] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2829),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LBRACK] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2829),
    [anon_sym_pub] = ACTIONS(2829),
    [anon_sym_mut] = ACTIONS(2829),
    [anon_sym_enum] = ACTIONS(2829),
    [anon_sym_interface] = ACTIONS(2829),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_QMARK] = ACTIONS(2829),
    [anon_sym_BANG] = ACTIONS(2829),
    [anon_sym_go] = ACTIONS(2829),
    [anon_sym_spawn] = ACTIONS(2829),
    [anon_sym_json_DOTdecode] = ACTIONS(2829),
    [anon_sym_PIPE] = ACTIONS(2829),
    [anon_sym_LBRACK2] = ACTIONS(2829),
    [anon_sym_TILDE] = ACTIONS(2829),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_AMP] = ACTIONS(2829),
    [anon_sym_LT_DASH] = ACTIONS(2829),
    [anon_sym_LT_LT] = ACTIONS(2829),
    [anon_sym_GT_GT] = ACTIONS(2829),
    [anon_sym_GT_GT_GT] = ACTIONS(2829),
    [anon_sym_AMP_CARET] = ACTIONS(2829),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_or] = ACTIONS(2829),
    [sym_none] = ACTIONS(2829),
    [sym_true] = ACTIONS(2829),
    [sym_false] = ACTIONS(2829),
    [sym_nil] = ACTIONS(2829),
    [anon_sym_QMARK_DOT] = ACTIONS(2829),
    [anon_sym_POUND_LBRACK] = ACTIONS(2829),
    [anon_sym_if] = ACTIONS(2829),
    [anon_sym_DOLLARif] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2829),
    [anon_sym_BANGis] = ACTIONS(2829),
    [anon_sym_in] = ACTIONS(2829),
    [anon_sym_BANGin] = ACTIONS(2829),
    [anon_sym_match] = ACTIONS(2829),
    [anon_sym_select] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_COLON_EQ] = ACTIONS(2829),
    [anon_sym_lock] = ACTIONS(2829),
    [anon_sym_rlock] = ACTIONS(2829),
    [anon_sym_unsafe] = ACTIONS(2829),
    [anon_sym_sql] = ACTIONS(2829),
    [sym_int_literal] = ACTIONS(2829),
    [sym_float_literal] = ACTIONS(2829),
    [sym_rune_literal] = ACTIONS(2829),
    [anon_sym_SQUOTE] = ACTIONS(2829),
    [anon_sym_DQUOTE] = ACTIONS(2829),
    [anon_sym_c_SQUOTE] = ACTIONS(2829),
    [anon_sym_c_DQUOTE] = ACTIONS(2829),
    [anon_sym_r_SQUOTE] = ACTIONS(2829),
    [anon_sym_r_DQUOTE] = ACTIONS(2829),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2829),
    [anon_sym_shared] = ACTIONS(2829),
    [anon_sym_map_LBRACK] = ACTIONS(2829),
    [anon_sym_chan] = ACTIONS(2829),
    [anon_sym_thread] = ACTIONS(2829),
    [anon_sym_atomic] = ACTIONS(2829),
    [anon_sym_assert] = ACTIONS(2829),
    [anon_sym_defer] = ACTIONS(2829),
    [anon_sym_goto] = ACTIONS(2829),
    [anon_sym_break] = ACTIONS(2829),
    [anon_sym_continue] = ACTIONS(2829),
    [anon_sym_return] = ACTIONS(2829),
    [anon_sym_DOLLARfor] = ACTIONS(2829),
    [anon_sym_for] = ACTIONS(2829),
    [anon_sym_POUND] = ACTIONS(2829),
    [anon_sym_asm] = ACTIONS(2829),
    [anon_sym_AT_LBRACK] = ACTIONS(2829),
  },
  [408] = {
    [sym_line_comment] = STATE(408),
    [sym_block_comment] = STATE(408),
    [ts_builtin_sym_end] = ACTIONS(2831),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_LF] = ACTIONS(2833),
    [anon_sym_CR] = ACTIONS(2833),
    [anon_sym_CR_LF] = ACTIONS(2833),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2833),
    [anon_sym_as] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_const] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2833),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym___global] = ACTIONS(2833),
    [anon_sym_type] = ACTIONS(2833),
    [anon_sym_fn] = ACTIONS(2833),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(2833),
    [anon_sym_SLASH] = ACTIONS(2833),
    [anon_sym_PERCENT] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(2833),
    [anon_sym_EQ_EQ] = ACTIONS(2833),
    [anon_sym_BANG_EQ] = ACTIONS(2833),
    [anon_sym_LT_EQ] = ACTIONS(2833),
    [anon_sym_GT_EQ] = ACTIONS(2833),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_struct] = ACTIONS(2833),
    [anon_sym_union] = ACTIONS(2833),
    [anon_sym_pub] = ACTIONS(2833),
    [anon_sym_mut] = ACTIONS(2833),
    [anon_sym_enum] = ACTIONS(2833),
    [anon_sym_interface] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_QMARK] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_go] = ACTIONS(2833),
    [anon_sym_spawn] = ACTIONS(2833),
    [anon_sym_json_DOTdecode] = ACTIONS(2833),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_LBRACK2] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2833),
    [anon_sym_CARET] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2833),
    [anon_sym_LT_DASH] = ACTIONS(2833),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_GT] = ACTIONS(2833),
    [anon_sym_AMP_CARET] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2833),
    [anon_sym_or] = ACTIONS(2833),
    [sym_none] = ACTIONS(2833),
    [sym_true] = ACTIONS(2833),
    [sym_false] = ACTIONS(2833),
    [sym_nil] = ACTIONS(2833),
    [anon_sym_QMARK_DOT] = ACTIONS(2833),
    [anon_sym_POUND_LBRACK] = ACTIONS(2833),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_DOLLARif] = ACTIONS(2833),
    [anon_sym_is] = ACTIONS(2833),
    [anon_sym_BANGis] = ACTIONS(2833),
    [anon_sym_in] = ACTIONS(2833),
    [anon_sym_BANGin] = ACTIONS(2833),
    [anon_sym_match] = ACTIONS(2833),
    [anon_sym_select] = ACTIONS(2833),
    [anon_sym_STAR_EQ] = ACTIONS(2833),
    [anon_sym_SLASH_EQ] = ACTIONS(2833),
    [anon_sym_PERCENT_EQ] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(2833),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2833),
    [anon_sym_AMP_EQ] = ACTIONS(2833),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2833),
    [anon_sym_PLUS_EQ] = ACTIONS(2833),
    [anon_sym_DASH_EQ] = ACTIONS(2833),
    [anon_sym_PIPE_EQ] = ACTIONS(2833),
    [anon_sym_CARET_EQ] = ACTIONS(2833),
    [anon_sym_COLON_EQ] = ACTIONS(2833),
    [anon_sym_lock] = ACTIONS(2833),
    [anon_sym_rlock] = ACTIONS(2833),
    [anon_sym_unsafe] = ACTIONS(2833),
    [anon_sym_sql] = ACTIONS(2833),
    [sym_int_literal] = ACTIONS(2833),
    [sym_float_literal] = ACTIONS(2833),
    [sym_rune_literal] = ACTIONS(2833),
    [anon_sym_SQUOTE] = ACTIONS(2833),
    [anon_sym_DQUOTE] = ACTIONS(2833),
    [anon_sym_c_SQUOTE] = ACTIONS(2833),
    [anon_sym_c_DQUOTE] = ACTIONS(2833),
    [anon_sym_r_SQUOTE] = ACTIONS(2833),
    [anon_sym_r_DQUOTE] = ACTIONS(2833),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2833),
    [anon_sym_shared] = ACTIONS(2833),
    [anon_sym_map_LBRACK] = ACTIONS(2833),
    [anon_sym_chan] = ACTIONS(2833),
    [anon_sym_thread] = ACTIONS(2833),
    [anon_sym_atomic] = ACTIONS(2833),
    [anon_sym_assert] = ACTIONS(2833),
    [anon_sym_defer] = ACTIONS(2833),
    [anon_sym_goto] = ACTIONS(2833),
    [anon_sym_break] = ACTIONS(2833),
    [anon_sym_continue] = ACTIONS(2833),
    [anon_sym_return] = ACTIONS(2833),
    [anon_sym_DOLLARfor] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2833),
    [anon_sym_POUND] = ACTIONS(2833),
    [anon_sym_asm] = ACTIONS(2833),
    [anon_sym_AT_LBRACK] = ACTIONS(2833),
  },
  [409] = {
    [sym_line_comment] = STATE(409),
    [sym_block_comment] = STATE(409),
    [ts_builtin_sym_end] = ACTIONS(2835),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_LF] = ACTIONS(2837),
    [anon_sym_CR] = ACTIONS(2837),
    [anon_sym_CR_LF] = ACTIONS(2837),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2837),
    [anon_sym_as] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2837),
    [anon_sym_EQ] = ACTIONS(2837),
    [anon_sym___global] = ACTIONS(2837),
    [anon_sym_type] = ACTIONS(2837),
    [anon_sym_fn] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2837),
    [anon_sym_DASH] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2837),
    [anon_sym_SLASH] = ACTIONS(2837),
    [anon_sym_PERCENT] = ACTIONS(2837),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(2837),
    [anon_sym_BANG_EQ] = ACTIONS(2837),
    [anon_sym_LT_EQ] = ACTIONS(2837),
    [anon_sym_GT_EQ] = ACTIONS(2837),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_struct] = ACTIONS(2837),
    [anon_sym_union] = ACTIONS(2837),
    [anon_sym_pub] = ACTIONS(2837),
    [anon_sym_mut] = ACTIONS(2837),
    [anon_sym_enum] = ACTIONS(2837),
    [anon_sym_interface] = ACTIONS(2837),
    [anon_sym_PLUS_PLUS] = ACTIONS(2837),
    [anon_sym_DASH_DASH] = ACTIONS(2837),
    [anon_sym_QMARK] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(2837),
    [anon_sym_go] = ACTIONS(2837),
    [anon_sym_spawn] = ACTIONS(2837),
    [anon_sym_json_DOTdecode] = ACTIONS(2837),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_LBRACK2] = ACTIONS(2837),
    [anon_sym_TILDE] = ACTIONS(2837),
    [anon_sym_CARET] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2837),
    [anon_sym_LT_DASH] = ACTIONS(2837),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_GT_GT_GT] = ACTIONS(2837),
    [anon_sym_AMP_CARET] = ACTIONS(2837),
    [anon_sym_AMP_AMP] = ACTIONS(2837),
    [anon_sym_PIPE_PIPE] = ACTIONS(2837),
    [anon_sym_or] = ACTIONS(2837),
    [sym_none] = ACTIONS(2837),
    [sym_true] = ACTIONS(2837),
    [sym_false] = ACTIONS(2837),
    [sym_nil] = ACTIONS(2837),
    [anon_sym_QMARK_DOT] = ACTIONS(2837),
    [anon_sym_POUND_LBRACK] = ACTIONS(2837),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_DOLLARif] = ACTIONS(2837),
    [anon_sym_is] = ACTIONS(2837),
    [anon_sym_BANGis] = ACTIONS(2837),
    [anon_sym_in] = ACTIONS(2837),
    [anon_sym_BANGin] = ACTIONS(2837),
    [anon_sym_match] = ACTIONS(2837),
    [anon_sym_select] = ACTIONS(2837),
    [anon_sym_STAR_EQ] = ACTIONS(2837),
    [anon_sym_SLASH_EQ] = ACTIONS(2837),
    [anon_sym_PERCENT_EQ] = ACTIONS(2837),
    [anon_sym_LT_LT_EQ] = ACTIONS(2837),
    [anon_sym_GT_GT_EQ] = ACTIONS(2837),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2837),
    [anon_sym_AMP_EQ] = ACTIONS(2837),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2837),
    [anon_sym_PLUS_EQ] = ACTIONS(2837),
    [anon_sym_DASH_EQ] = ACTIONS(2837),
    [anon_sym_PIPE_EQ] = ACTIONS(2837),
    [anon_sym_CARET_EQ] = ACTIONS(2837),
    [anon_sym_COLON_EQ] = ACTIONS(2837),
    [anon_sym_lock] = ACTIONS(2837),
    [anon_sym_rlock] = ACTIONS(2837),
    [anon_sym_unsafe] = ACTIONS(2837),
    [anon_sym_sql] = ACTIONS(2837),
    [sym_int_literal] = ACTIONS(2837),
    [sym_float_literal] = ACTIONS(2837),
    [sym_rune_literal] = ACTIONS(2837),
    [anon_sym_SQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE] = ACTIONS(2837),
    [anon_sym_c_SQUOTE] = ACTIONS(2837),
    [anon_sym_c_DQUOTE] = ACTIONS(2837),
    [anon_sym_r_SQUOTE] = ACTIONS(2837),
    [anon_sym_r_DQUOTE] = ACTIONS(2837),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2837),
    [anon_sym_shared] = ACTIONS(2837),
    [anon_sym_map_LBRACK] = ACTIONS(2837),
    [anon_sym_chan] = ACTIONS(2837),
    [anon_sym_thread] = ACTIONS(2837),
    [anon_sym_atomic] = ACTIONS(2837),
    [anon_sym_assert] = ACTIONS(2837),
    [anon_sym_defer] = ACTIONS(2837),
    [anon_sym_goto] = ACTIONS(2837),
    [anon_sym_break] = ACTIONS(2837),
    [anon_sym_continue] = ACTIONS(2837),
    [anon_sym_return] = ACTIONS(2837),
    [anon_sym_DOLLARfor] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2837),
    [anon_sym_POUND] = ACTIONS(2837),
    [anon_sym_asm] = ACTIONS(2837),
    [anon_sym_AT_LBRACK] = ACTIONS(2837),
  },
  [410] = {
    [sym_line_comment] = STATE(410),
    [sym_block_comment] = STATE(410),
    [sym__expression] = STATE(2593),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3688),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4541),
    [sym_identifier] = ACTIONS(2385),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(2387),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2389),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(2391),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [411] = {
    [sym_line_comment] = STATE(411),
    [sym_block_comment] = STATE(411),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4205),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [412] = {
    [sym_line_comment] = STATE(412),
    [sym_block_comment] = STATE(412),
    [ts_builtin_sym_end] = ACTIONS(2839),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_LF] = ACTIONS(2841),
    [anon_sym_CR] = ACTIONS(2841),
    [anon_sym_CR_LF] = ACTIONS(2841),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2841),
    [anon_sym_as] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_const] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2841),
    [anon_sym_EQ] = ACTIONS(2841),
    [anon_sym___global] = ACTIONS(2841),
    [anon_sym_type] = ACTIONS(2841),
    [anon_sym_fn] = ACTIONS(2841),
    [anon_sym_PLUS] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(2841),
    [anon_sym_SLASH] = ACTIONS(2841),
    [anon_sym_PERCENT] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_GT] = ACTIONS(2841),
    [anon_sym_EQ_EQ] = ACTIONS(2841),
    [anon_sym_BANG_EQ] = ACTIONS(2841),
    [anon_sym_LT_EQ] = ACTIONS(2841),
    [anon_sym_GT_EQ] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_struct] = ACTIONS(2841),
    [anon_sym_union] = ACTIONS(2841),
    [anon_sym_pub] = ACTIONS(2841),
    [anon_sym_mut] = ACTIONS(2841),
    [anon_sym_enum] = ACTIONS(2841),
    [anon_sym_interface] = ACTIONS(2841),
    [anon_sym_PLUS_PLUS] = ACTIONS(2841),
    [anon_sym_DASH_DASH] = ACTIONS(2841),
    [anon_sym_QMARK] = ACTIONS(2841),
    [anon_sym_BANG] = ACTIONS(2841),
    [anon_sym_go] = ACTIONS(2841),
    [anon_sym_spawn] = ACTIONS(2841),
    [anon_sym_json_DOTdecode] = ACTIONS(2841),
    [anon_sym_PIPE] = ACTIONS(2841),
    [anon_sym_LBRACK2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2841),
    [anon_sym_LT_DASH] = ACTIONS(2841),
    [anon_sym_LT_LT] = ACTIONS(2841),
    [anon_sym_GT_GT] = ACTIONS(2841),
    [anon_sym_GT_GT_GT] = ACTIONS(2841),
    [anon_sym_AMP_CARET] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_PIPE_PIPE] = ACTIONS(2841),
    [anon_sym_or] = ACTIONS(2841),
    [sym_none] = ACTIONS(2841),
    [sym_true] = ACTIONS(2841),
    [sym_false] = ACTIONS(2841),
    [sym_nil] = ACTIONS(2841),
    [anon_sym_QMARK_DOT] = ACTIONS(2841),
    [anon_sym_POUND_LBRACK] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2841),
    [anon_sym_DOLLARif] = ACTIONS(2841),
    [anon_sym_is] = ACTIONS(2841),
    [anon_sym_BANGis] = ACTIONS(2841),
    [anon_sym_in] = ACTIONS(2841),
    [anon_sym_BANGin] = ACTIONS(2841),
    [anon_sym_match] = ACTIONS(2841),
    [anon_sym_select] = ACTIONS(2841),
    [anon_sym_STAR_EQ] = ACTIONS(2841),
    [anon_sym_SLASH_EQ] = ACTIONS(2841),
    [anon_sym_PERCENT_EQ] = ACTIONS(2841),
    [anon_sym_LT_LT_EQ] = ACTIONS(2841),
    [anon_sym_GT_GT_EQ] = ACTIONS(2841),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2841),
    [anon_sym_AMP_EQ] = ACTIONS(2841),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2841),
    [anon_sym_PLUS_EQ] = ACTIONS(2841),
    [anon_sym_DASH_EQ] = ACTIONS(2841),
    [anon_sym_PIPE_EQ] = ACTIONS(2841),
    [anon_sym_CARET_EQ] = ACTIONS(2841),
    [anon_sym_COLON_EQ] = ACTIONS(2841),
    [anon_sym_lock] = ACTIONS(2841),
    [anon_sym_rlock] = ACTIONS(2841),
    [anon_sym_unsafe] = ACTIONS(2841),
    [anon_sym_sql] = ACTIONS(2841),
    [sym_int_literal] = ACTIONS(2841),
    [sym_float_literal] = ACTIONS(2841),
    [sym_rune_literal] = ACTIONS(2841),
    [anon_sym_SQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE] = ACTIONS(2841),
    [anon_sym_c_SQUOTE] = ACTIONS(2841),
    [anon_sym_c_DQUOTE] = ACTIONS(2841),
    [anon_sym_r_SQUOTE] = ACTIONS(2841),
    [anon_sym_r_DQUOTE] = ACTIONS(2841),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2841),
    [anon_sym_shared] = ACTIONS(2841),
    [anon_sym_map_LBRACK] = ACTIONS(2841),
    [anon_sym_chan] = ACTIONS(2841),
    [anon_sym_thread] = ACTIONS(2841),
    [anon_sym_atomic] = ACTIONS(2841),
    [anon_sym_assert] = ACTIONS(2841),
    [anon_sym_defer] = ACTIONS(2841),
    [anon_sym_goto] = ACTIONS(2841),
    [anon_sym_break] = ACTIONS(2841),
    [anon_sym_continue] = ACTIONS(2841),
    [anon_sym_return] = ACTIONS(2841),
    [anon_sym_DOLLARfor] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2841),
    [anon_sym_POUND] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2841),
    [anon_sym_AT_LBRACK] = ACTIONS(2841),
  },
  [413] = {
    [sym_line_comment] = STATE(413),
    [sym_block_comment] = STATE(413),
    [ts_builtin_sym_end] = ACTIONS(2843),
    [sym_identifier] = ACTIONS(2845),
    [anon_sym_LF] = ACTIONS(2845),
    [anon_sym_CR] = ACTIONS(2845),
    [anon_sym_CR_LF] = ACTIONS(2845),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2845),
    [anon_sym_as] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2845),
    [anon_sym_COMMA] = ACTIONS(2845),
    [anon_sym_const] = ACTIONS(2845),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_EQ] = ACTIONS(2845),
    [anon_sym___global] = ACTIONS(2845),
    [anon_sym_type] = ACTIONS(2845),
    [anon_sym_fn] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2845),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_SLASH] = ACTIONS(2845),
    [anon_sym_PERCENT] = ACTIONS(2845),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_GT] = ACTIONS(2845),
    [anon_sym_EQ_EQ] = ACTIONS(2845),
    [anon_sym_BANG_EQ] = ACTIONS(2845),
    [anon_sym_LT_EQ] = ACTIONS(2845),
    [anon_sym_GT_EQ] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2845),
    [anon_sym_union] = ACTIONS(2845),
    [anon_sym_pub] = ACTIONS(2845),
    [anon_sym_mut] = ACTIONS(2845),
    [anon_sym_enum] = ACTIONS(2845),
    [anon_sym_interface] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2845),
    [anon_sym_DASH_DASH] = ACTIONS(2845),
    [anon_sym_QMARK] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_go] = ACTIONS(2845),
    [anon_sym_spawn] = ACTIONS(2845),
    [anon_sym_json_DOTdecode] = ACTIONS(2845),
    [anon_sym_PIPE] = ACTIONS(2845),
    [anon_sym_LBRACK2] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_CARET] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2845),
    [anon_sym_LT_DASH] = ACTIONS(2845),
    [anon_sym_LT_LT] = ACTIONS(2845),
    [anon_sym_GT_GT] = ACTIONS(2845),
    [anon_sym_GT_GT_GT] = ACTIONS(2845),
    [anon_sym_AMP_CARET] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_PIPE_PIPE] = ACTIONS(2845),
    [anon_sym_or] = ACTIONS(2845),
    [sym_none] = ACTIONS(2845),
    [sym_true] = ACTIONS(2845),
    [sym_false] = ACTIONS(2845),
    [sym_nil] = ACTIONS(2845),
    [anon_sym_QMARK_DOT] = ACTIONS(2845),
    [anon_sym_POUND_LBRACK] = ACTIONS(2845),
    [anon_sym_if] = ACTIONS(2845),
    [anon_sym_DOLLARif] = ACTIONS(2845),
    [anon_sym_is] = ACTIONS(2845),
    [anon_sym_BANGis] = ACTIONS(2845),
    [anon_sym_in] = ACTIONS(2845),
    [anon_sym_BANGin] = ACTIONS(2845),
    [anon_sym_match] = ACTIONS(2845),
    [anon_sym_select] = ACTIONS(2845),
    [anon_sym_STAR_EQ] = ACTIONS(2845),
    [anon_sym_SLASH_EQ] = ACTIONS(2845),
    [anon_sym_PERCENT_EQ] = ACTIONS(2845),
    [anon_sym_LT_LT_EQ] = ACTIONS(2845),
    [anon_sym_GT_GT_EQ] = ACTIONS(2845),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2845),
    [anon_sym_AMP_EQ] = ACTIONS(2845),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2845),
    [anon_sym_PLUS_EQ] = ACTIONS(2845),
    [anon_sym_DASH_EQ] = ACTIONS(2845),
    [anon_sym_PIPE_EQ] = ACTIONS(2845),
    [anon_sym_CARET_EQ] = ACTIONS(2845),
    [anon_sym_COLON_EQ] = ACTIONS(2845),
    [anon_sym_lock] = ACTIONS(2845),
    [anon_sym_rlock] = ACTIONS(2845),
    [anon_sym_unsafe] = ACTIONS(2845),
    [anon_sym_sql] = ACTIONS(2845),
    [sym_int_literal] = ACTIONS(2845),
    [sym_float_literal] = ACTIONS(2845),
    [sym_rune_literal] = ACTIONS(2845),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2845),
    [anon_sym_c_SQUOTE] = ACTIONS(2845),
    [anon_sym_c_DQUOTE] = ACTIONS(2845),
    [anon_sym_r_SQUOTE] = ACTIONS(2845),
    [anon_sym_r_DQUOTE] = ACTIONS(2845),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2845),
    [anon_sym_shared] = ACTIONS(2845),
    [anon_sym_map_LBRACK] = ACTIONS(2845),
    [anon_sym_chan] = ACTIONS(2845),
    [anon_sym_thread] = ACTIONS(2845),
    [anon_sym_atomic] = ACTIONS(2845),
    [anon_sym_assert] = ACTIONS(2845),
    [anon_sym_defer] = ACTIONS(2845),
    [anon_sym_goto] = ACTIONS(2845),
    [anon_sym_break] = ACTIONS(2845),
    [anon_sym_continue] = ACTIONS(2845),
    [anon_sym_return] = ACTIONS(2845),
    [anon_sym_DOLLARfor] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2845),
    [anon_sym_POUND] = ACTIONS(2845),
    [anon_sym_asm] = ACTIONS(2845),
    [anon_sym_AT_LBRACK] = ACTIONS(2845),
  },
  [414] = {
    [sym_line_comment] = STATE(414),
    [sym_block_comment] = STATE(414),
    [ts_builtin_sym_end] = ACTIONS(2847),
    [sym_identifier] = ACTIONS(2849),
    [anon_sym_LF] = ACTIONS(2849),
    [anon_sym_CR] = ACTIONS(2849),
    [anon_sym_CR_LF] = ACTIONS(2849),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2849),
    [anon_sym_as] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_COMMA] = ACTIONS(2849),
    [anon_sym_const] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2849),
    [anon_sym_EQ] = ACTIONS(2849),
    [anon_sym___global] = ACTIONS(2849),
    [anon_sym_type] = ACTIONS(2849),
    [anon_sym_fn] = ACTIONS(2849),
    [anon_sym_PLUS] = ACTIONS(2849),
    [anon_sym_DASH] = ACTIONS(2849),
    [anon_sym_STAR] = ACTIONS(2849),
    [anon_sym_SLASH] = ACTIONS(2849),
    [anon_sym_PERCENT] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_GT] = ACTIONS(2849),
    [anon_sym_EQ_EQ] = ACTIONS(2849),
    [anon_sym_BANG_EQ] = ACTIONS(2849),
    [anon_sym_LT_EQ] = ACTIONS(2849),
    [anon_sym_GT_EQ] = ACTIONS(2849),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_struct] = ACTIONS(2849),
    [anon_sym_union] = ACTIONS(2849),
    [anon_sym_pub] = ACTIONS(2849),
    [anon_sym_mut] = ACTIONS(2849),
    [anon_sym_enum] = ACTIONS(2849),
    [anon_sym_interface] = ACTIONS(2849),
    [anon_sym_PLUS_PLUS] = ACTIONS(2849),
    [anon_sym_DASH_DASH] = ACTIONS(2849),
    [anon_sym_QMARK] = ACTIONS(2849),
    [anon_sym_BANG] = ACTIONS(2849),
    [anon_sym_go] = ACTIONS(2849),
    [anon_sym_spawn] = ACTIONS(2849),
    [anon_sym_json_DOTdecode] = ACTIONS(2849),
    [anon_sym_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACK2] = ACTIONS(2849),
    [anon_sym_TILDE] = ACTIONS(2849),
    [anon_sym_CARET] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2849),
    [anon_sym_LT_DASH] = ACTIONS(2849),
    [anon_sym_LT_LT] = ACTIONS(2849),
    [anon_sym_GT_GT] = ACTIONS(2849),
    [anon_sym_GT_GT_GT] = ACTIONS(2849),
    [anon_sym_AMP_CARET] = ACTIONS(2849),
    [anon_sym_AMP_AMP] = ACTIONS(2849),
    [anon_sym_PIPE_PIPE] = ACTIONS(2849),
    [anon_sym_or] = ACTIONS(2849),
    [sym_none] = ACTIONS(2849),
    [sym_true] = ACTIONS(2849),
    [sym_false] = ACTIONS(2849),
    [sym_nil] = ACTIONS(2849),
    [anon_sym_QMARK_DOT] = ACTIONS(2849),
    [anon_sym_POUND_LBRACK] = ACTIONS(2849),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_DOLLARif] = ACTIONS(2849),
    [anon_sym_is] = ACTIONS(2849),
    [anon_sym_BANGis] = ACTIONS(2849),
    [anon_sym_in] = ACTIONS(2849),
    [anon_sym_BANGin] = ACTIONS(2849),
    [anon_sym_match] = ACTIONS(2849),
    [anon_sym_select] = ACTIONS(2849),
    [anon_sym_STAR_EQ] = ACTIONS(2849),
    [anon_sym_SLASH_EQ] = ACTIONS(2849),
    [anon_sym_PERCENT_EQ] = ACTIONS(2849),
    [anon_sym_LT_LT_EQ] = ACTIONS(2849),
    [anon_sym_GT_GT_EQ] = ACTIONS(2849),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2849),
    [anon_sym_AMP_EQ] = ACTIONS(2849),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2849),
    [anon_sym_PLUS_EQ] = ACTIONS(2849),
    [anon_sym_DASH_EQ] = ACTIONS(2849),
    [anon_sym_PIPE_EQ] = ACTIONS(2849),
    [anon_sym_CARET_EQ] = ACTIONS(2849),
    [anon_sym_COLON_EQ] = ACTIONS(2849),
    [anon_sym_lock] = ACTIONS(2849),
    [anon_sym_rlock] = ACTIONS(2849),
    [anon_sym_unsafe] = ACTIONS(2849),
    [anon_sym_sql] = ACTIONS(2849),
    [sym_int_literal] = ACTIONS(2849),
    [sym_float_literal] = ACTIONS(2849),
    [sym_rune_literal] = ACTIONS(2849),
    [anon_sym_SQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [anon_sym_c_SQUOTE] = ACTIONS(2849),
    [anon_sym_c_DQUOTE] = ACTIONS(2849),
    [anon_sym_r_SQUOTE] = ACTIONS(2849),
    [anon_sym_r_DQUOTE] = ACTIONS(2849),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2849),
    [anon_sym_shared] = ACTIONS(2849),
    [anon_sym_map_LBRACK] = ACTIONS(2849),
    [anon_sym_chan] = ACTIONS(2849),
    [anon_sym_thread] = ACTIONS(2849),
    [anon_sym_atomic] = ACTIONS(2849),
    [anon_sym_assert] = ACTIONS(2849),
    [anon_sym_defer] = ACTIONS(2849),
    [anon_sym_goto] = ACTIONS(2849),
    [anon_sym_break] = ACTIONS(2849),
    [anon_sym_continue] = ACTIONS(2849),
    [anon_sym_return] = ACTIONS(2849),
    [anon_sym_DOLLARfor] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2849),
    [anon_sym_POUND] = ACTIONS(2849),
    [anon_sym_asm] = ACTIONS(2849),
    [anon_sym_AT_LBRACK] = ACTIONS(2849),
  },
  [415] = {
    [sym_line_comment] = STATE(415),
    [sym_block_comment] = STATE(415),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4532),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2851),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [416] = {
    [sym_line_comment] = STATE(416),
    [sym_block_comment] = STATE(416),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1693),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1692),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(418),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(2853),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1615),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [417] = {
    [sym_line_comment] = STATE(417),
    [sym_block_comment] = STATE(417),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4511),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2855),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [418] = {
    [sym_line_comment] = STATE(418),
    [sym_block_comment] = STATE(418),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(402),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(2857),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [419] = {
    [sym_line_comment] = STATE(419),
    [sym_block_comment] = STATE(419),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4548),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [420] = {
    [sym_line_comment] = STATE(420),
    [sym_block_comment] = STATE(420),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4511),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2861),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [421] = {
    [sym_line_comment] = STATE(421),
    [sym_block_comment] = STATE(421),
    [ts_builtin_sym_end] = ACTIONS(2863),
    [sym_identifier] = ACTIONS(2865),
    [anon_sym_LF] = ACTIONS(2865),
    [anon_sym_CR] = ACTIONS(2865),
    [anon_sym_CR_LF] = ACTIONS(2865),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2865),
    [anon_sym_as] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2865),
    [anon_sym_COMMA] = ACTIONS(2865),
    [anon_sym_const] = ACTIONS(2865),
    [anon_sym_LPAREN] = ACTIONS(2865),
    [anon_sym_EQ] = ACTIONS(2865),
    [anon_sym___global] = ACTIONS(2865),
    [anon_sym_type] = ACTIONS(2865),
    [anon_sym_fn] = ACTIONS(2865),
    [anon_sym_PLUS] = ACTIONS(2865),
    [anon_sym_DASH] = ACTIONS(2865),
    [anon_sym_STAR] = ACTIONS(2865),
    [anon_sym_SLASH] = ACTIONS(2865),
    [anon_sym_PERCENT] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_GT] = ACTIONS(2865),
    [anon_sym_EQ_EQ] = ACTIONS(2865),
    [anon_sym_BANG_EQ] = ACTIONS(2865),
    [anon_sym_LT_EQ] = ACTIONS(2865),
    [anon_sym_GT_EQ] = ACTIONS(2865),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_struct] = ACTIONS(2865),
    [anon_sym_union] = ACTIONS(2865),
    [anon_sym_pub] = ACTIONS(2865),
    [anon_sym_mut] = ACTIONS(2865),
    [anon_sym_enum] = ACTIONS(2865),
    [anon_sym_interface] = ACTIONS(2865),
    [anon_sym_PLUS_PLUS] = ACTIONS(2865),
    [anon_sym_DASH_DASH] = ACTIONS(2865),
    [anon_sym_QMARK] = ACTIONS(2865),
    [anon_sym_BANG] = ACTIONS(2865),
    [anon_sym_go] = ACTIONS(2865),
    [anon_sym_spawn] = ACTIONS(2865),
    [anon_sym_json_DOTdecode] = ACTIONS(2865),
    [anon_sym_PIPE] = ACTIONS(2865),
    [anon_sym_LBRACK2] = ACTIONS(2865),
    [anon_sym_TILDE] = ACTIONS(2865),
    [anon_sym_CARET] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2865),
    [anon_sym_LT_DASH] = ACTIONS(2865),
    [anon_sym_LT_LT] = ACTIONS(2865),
    [anon_sym_GT_GT] = ACTIONS(2865),
    [anon_sym_GT_GT_GT] = ACTIONS(2865),
    [anon_sym_AMP_CARET] = ACTIONS(2865),
    [anon_sym_AMP_AMP] = ACTIONS(2865),
    [anon_sym_PIPE_PIPE] = ACTIONS(2865),
    [anon_sym_or] = ACTIONS(2865),
    [sym_none] = ACTIONS(2865),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_nil] = ACTIONS(2865),
    [anon_sym_QMARK_DOT] = ACTIONS(2865),
    [anon_sym_POUND_LBRACK] = ACTIONS(2865),
    [anon_sym_if] = ACTIONS(2865),
    [anon_sym_DOLLARif] = ACTIONS(2865),
    [anon_sym_is] = ACTIONS(2865),
    [anon_sym_BANGis] = ACTIONS(2865),
    [anon_sym_in] = ACTIONS(2865),
    [anon_sym_BANGin] = ACTIONS(2865),
    [anon_sym_match] = ACTIONS(2865),
    [anon_sym_select] = ACTIONS(2865),
    [anon_sym_STAR_EQ] = ACTIONS(2865),
    [anon_sym_SLASH_EQ] = ACTIONS(2865),
    [anon_sym_PERCENT_EQ] = ACTIONS(2865),
    [anon_sym_LT_LT_EQ] = ACTIONS(2865),
    [anon_sym_GT_GT_EQ] = ACTIONS(2865),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2865),
    [anon_sym_AMP_EQ] = ACTIONS(2865),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2865),
    [anon_sym_PLUS_EQ] = ACTIONS(2865),
    [anon_sym_DASH_EQ] = ACTIONS(2865),
    [anon_sym_PIPE_EQ] = ACTIONS(2865),
    [anon_sym_CARET_EQ] = ACTIONS(2865),
    [anon_sym_COLON_EQ] = ACTIONS(2865),
    [anon_sym_lock] = ACTIONS(2865),
    [anon_sym_rlock] = ACTIONS(2865),
    [anon_sym_unsafe] = ACTIONS(2865),
    [anon_sym_sql] = ACTIONS(2865),
    [sym_int_literal] = ACTIONS(2865),
    [sym_float_literal] = ACTIONS(2865),
    [sym_rune_literal] = ACTIONS(2865),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_DQUOTE] = ACTIONS(2865),
    [anon_sym_c_SQUOTE] = ACTIONS(2865),
    [anon_sym_c_DQUOTE] = ACTIONS(2865),
    [anon_sym_r_SQUOTE] = ACTIONS(2865),
    [anon_sym_r_DQUOTE] = ACTIONS(2865),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2865),
    [anon_sym_shared] = ACTIONS(2865),
    [anon_sym_map_LBRACK] = ACTIONS(2865),
    [anon_sym_chan] = ACTIONS(2865),
    [anon_sym_thread] = ACTIONS(2865),
    [anon_sym_atomic] = ACTIONS(2865),
    [anon_sym_assert] = ACTIONS(2865),
    [anon_sym_defer] = ACTIONS(2865),
    [anon_sym_goto] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2865),
    [anon_sym_continue] = ACTIONS(2865),
    [anon_sym_return] = ACTIONS(2865),
    [anon_sym_DOLLARfor] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2865),
    [anon_sym_POUND] = ACTIONS(2865),
    [anon_sym_asm] = ACTIONS(2865),
    [anon_sym_AT_LBRACK] = ACTIONS(2865),
  },
  [422] = {
    [sym_line_comment] = STATE(422),
    [sym_block_comment] = STATE(422),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4490),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [423] = {
    [sym_line_comment] = STATE(423),
    [sym_block_comment] = STATE(423),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4595),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [424] = {
    [sym_line_comment] = STATE(424),
    [sym_block_comment] = STATE(424),
    [ts_builtin_sym_end] = ACTIONS(2871),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_CR] = ACTIONS(2873),
    [anon_sym_CR_LF] = ACTIONS(2873),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2873),
    [anon_sym_as] = ACTIONS(2873),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2873),
    [anon_sym_const] = ACTIONS(2873),
    [anon_sym_LPAREN] = ACTIONS(2873),
    [anon_sym_EQ] = ACTIONS(2873),
    [anon_sym___global] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_fn] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2873),
    [anon_sym_STAR] = ACTIONS(2873),
    [anon_sym_SLASH] = ACTIONS(2873),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2873),
    [anon_sym_GT] = ACTIONS(2873),
    [anon_sym_EQ_EQ] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_LT_EQ] = ACTIONS(2873),
    [anon_sym_GT_EQ] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2873),
    [anon_sym_union] = ACTIONS(2873),
    [anon_sym_pub] = ACTIONS(2873),
    [anon_sym_mut] = ACTIONS(2873),
    [anon_sym_enum] = ACTIONS(2873),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_PLUS_PLUS] = ACTIONS(2873),
    [anon_sym_DASH_DASH] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_BANG] = ACTIONS(2873),
    [anon_sym_go] = ACTIONS(2873),
    [anon_sym_spawn] = ACTIONS(2873),
    [anon_sym_json_DOTdecode] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2873),
    [anon_sym_LBRACK2] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2873),
    [anon_sym_CARET] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LT_DASH] = ACTIONS(2873),
    [anon_sym_LT_LT] = ACTIONS(2873),
    [anon_sym_GT_GT] = ACTIONS(2873),
    [anon_sym_GT_GT_GT] = ACTIONS(2873),
    [anon_sym_AMP_CARET] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [sym_none] = ACTIONS(2873),
    [sym_true] = ACTIONS(2873),
    [sym_false] = ACTIONS(2873),
    [sym_nil] = ACTIONS(2873),
    [anon_sym_QMARK_DOT] = ACTIONS(2873),
    [anon_sym_POUND_LBRACK] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_DOLLARif] = ACTIONS(2873),
    [anon_sym_is] = ACTIONS(2873),
    [anon_sym_BANGis] = ACTIONS(2873),
    [anon_sym_in] = ACTIONS(2873),
    [anon_sym_BANGin] = ACTIONS(2873),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_select] = ACTIONS(2873),
    [anon_sym_STAR_EQ] = ACTIONS(2873),
    [anon_sym_SLASH_EQ] = ACTIONS(2873),
    [anon_sym_PERCENT_EQ] = ACTIONS(2873),
    [anon_sym_LT_LT_EQ] = ACTIONS(2873),
    [anon_sym_GT_GT_EQ] = ACTIONS(2873),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2873),
    [anon_sym_AMP_EQ] = ACTIONS(2873),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(2873),
    [anon_sym_DASH_EQ] = ACTIONS(2873),
    [anon_sym_PIPE_EQ] = ACTIONS(2873),
    [anon_sym_CARET_EQ] = ACTIONS(2873),
    [anon_sym_COLON_EQ] = ACTIONS(2873),
    [anon_sym_lock] = ACTIONS(2873),
    [anon_sym_rlock] = ACTIONS(2873),
    [anon_sym_unsafe] = ACTIONS(2873),
    [anon_sym_sql] = ACTIONS(2873),
    [sym_int_literal] = ACTIONS(2873),
    [sym_float_literal] = ACTIONS(2873),
    [sym_rune_literal] = ACTIONS(2873),
    [anon_sym_SQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_c_SQUOTE] = ACTIONS(2873),
    [anon_sym_c_DQUOTE] = ACTIONS(2873),
    [anon_sym_r_SQUOTE] = ACTIONS(2873),
    [anon_sym_r_DQUOTE] = ACTIONS(2873),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2873),
    [anon_sym_shared] = ACTIONS(2873),
    [anon_sym_map_LBRACK] = ACTIONS(2873),
    [anon_sym_chan] = ACTIONS(2873),
    [anon_sym_thread] = ACTIONS(2873),
    [anon_sym_atomic] = ACTIONS(2873),
    [anon_sym_assert] = ACTIONS(2873),
    [anon_sym_defer] = ACTIONS(2873),
    [anon_sym_goto] = ACTIONS(2873),
    [anon_sym_break] = ACTIONS(2873),
    [anon_sym_continue] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_DOLLARfor] = ACTIONS(2873),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_POUND] = ACTIONS(2873),
    [anon_sym_asm] = ACTIONS(2873),
    [anon_sym_AT_LBRACK] = ACTIONS(2873),
  },
  [425] = {
    [sym_line_comment] = STATE(425),
    [sym_block_comment] = STATE(425),
    [ts_builtin_sym_end] = ACTIONS(2875),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_LF] = ACTIONS(2877),
    [anon_sym_CR] = ACTIONS(2877),
    [anon_sym_CR_LF] = ACTIONS(2877),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2877),
    [anon_sym_as] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2877),
    [anon_sym_const] = ACTIONS(2877),
    [anon_sym_LPAREN] = ACTIONS(2877),
    [anon_sym_EQ] = ACTIONS(2877),
    [anon_sym___global] = ACTIONS(2877),
    [anon_sym_type] = ACTIONS(2877),
    [anon_sym_fn] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_STAR] = ACTIONS(2877),
    [anon_sym_SLASH] = ACTIONS(2877),
    [anon_sym_PERCENT] = ACTIONS(2877),
    [anon_sym_LT] = ACTIONS(2877),
    [anon_sym_GT] = ACTIONS(2877),
    [anon_sym_EQ_EQ] = ACTIONS(2877),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_LT_EQ] = ACTIONS(2877),
    [anon_sym_GT_EQ] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2875),
    [anon_sym_struct] = ACTIONS(2877),
    [anon_sym_union] = ACTIONS(2877),
    [anon_sym_pub] = ACTIONS(2877),
    [anon_sym_mut] = ACTIONS(2877),
    [anon_sym_enum] = ACTIONS(2877),
    [anon_sym_interface] = ACTIONS(2877),
    [anon_sym_PLUS_PLUS] = ACTIONS(2877),
    [anon_sym_DASH_DASH] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2877),
    [anon_sym_go] = ACTIONS(2877),
    [anon_sym_spawn] = ACTIONS(2877),
    [anon_sym_json_DOTdecode] = ACTIONS(2877),
    [anon_sym_PIPE] = ACTIONS(2877),
    [anon_sym_LBRACK2] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2877),
    [anon_sym_CARET] = ACTIONS(2877),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_LT_DASH] = ACTIONS(2877),
    [anon_sym_LT_LT] = ACTIONS(2877),
    [anon_sym_GT_GT] = ACTIONS(2877),
    [anon_sym_GT_GT_GT] = ACTIONS(2877),
    [anon_sym_AMP_CARET] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_PIPE_PIPE] = ACTIONS(2877),
    [anon_sym_or] = ACTIONS(2877),
    [sym_none] = ACTIONS(2877),
    [sym_true] = ACTIONS(2877),
    [sym_false] = ACTIONS(2877),
    [sym_nil] = ACTIONS(2877),
    [anon_sym_QMARK_DOT] = ACTIONS(2877),
    [anon_sym_POUND_LBRACK] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_DOLLARif] = ACTIONS(2877),
    [anon_sym_is] = ACTIONS(2877),
    [anon_sym_BANGis] = ACTIONS(2877),
    [anon_sym_in] = ACTIONS(2877),
    [anon_sym_BANGin] = ACTIONS(2877),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_select] = ACTIONS(2877),
    [anon_sym_STAR_EQ] = ACTIONS(2877),
    [anon_sym_SLASH_EQ] = ACTIONS(2877),
    [anon_sym_PERCENT_EQ] = ACTIONS(2877),
    [anon_sym_LT_LT_EQ] = ACTIONS(2877),
    [anon_sym_GT_GT_EQ] = ACTIONS(2877),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2877),
    [anon_sym_AMP_EQ] = ACTIONS(2877),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2877),
    [anon_sym_PLUS_EQ] = ACTIONS(2877),
    [anon_sym_DASH_EQ] = ACTIONS(2877),
    [anon_sym_PIPE_EQ] = ACTIONS(2877),
    [anon_sym_CARET_EQ] = ACTIONS(2877),
    [anon_sym_COLON_EQ] = ACTIONS(2877),
    [anon_sym_lock] = ACTIONS(2877),
    [anon_sym_rlock] = ACTIONS(2877),
    [anon_sym_unsafe] = ACTIONS(2877),
    [anon_sym_sql] = ACTIONS(2877),
    [sym_int_literal] = ACTIONS(2877),
    [sym_float_literal] = ACTIONS(2877),
    [sym_rune_literal] = ACTIONS(2877),
    [anon_sym_SQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [anon_sym_c_SQUOTE] = ACTIONS(2877),
    [anon_sym_c_DQUOTE] = ACTIONS(2877),
    [anon_sym_r_SQUOTE] = ACTIONS(2877),
    [anon_sym_r_DQUOTE] = ACTIONS(2877),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2877),
    [anon_sym_shared] = ACTIONS(2877),
    [anon_sym_map_LBRACK] = ACTIONS(2877),
    [anon_sym_chan] = ACTIONS(2877),
    [anon_sym_thread] = ACTIONS(2877),
    [anon_sym_atomic] = ACTIONS(2877),
    [anon_sym_assert] = ACTIONS(2877),
    [anon_sym_defer] = ACTIONS(2877),
    [anon_sym_goto] = ACTIONS(2877),
    [anon_sym_break] = ACTIONS(2877),
    [anon_sym_continue] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_DOLLARfor] = ACTIONS(2877),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_POUND] = ACTIONS(2877),
    [anon_sym_asm] = ACTIONS(2877),
    [anon_sym_AT_LBRACK] = ACTIONS(2877),
  },
  [426] = {
    [sym_line_comment] = STATE(426),
    [sym_block_comment] = STATE(426),
    [ts_builtin_sym_end] = ACTIONS(2879),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_LF] = ACTIONS(2881),
    [anon_sym_CR] = ACTIONS(2881),
    [anon_sym_CR_LF] = ACTIONS(2881),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2881),
    [anon_sym_as] = ACTIONS(2881),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_const] = ACTIONS(2881),
    [anon_sym_LPAREN] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2881),
    [anon_sym___global] = ACTIONS(2881),
    [anon_sym_type] = ACTIONS(2881),
    [anon_sym_fn] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_SLASH] = ACTIONS(2881),
    [anon_sym_PERCENT] = ACTIONS(2881),
    [anon_sym_LT] = ACTIONS(2881),
    [anon_sym_GT] = ACTIONS(2881),
    [anon_sym_EQ_EQ] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_LT_EQ] = ACTIONS(2881),
    [anon_sym_GT_EQ] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_struct] = ACTIONS(2881),
    [anon_sym_union] = ACTIONS(2881),
    [anon_sym_pub] = ACTIONS(2881),
    [anon_sym_mut] = ACTIONS(2881),
    [anon_sym_enum] = ACTIONS(2881),
    [anon_sym_interface] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_go] = ACTIONS(2881),
    [anon_sym_spawn] = ACTIONS(2881),
    [anon_sym_json_DOTdecode] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2881),
    [anon_sym_LBRACK2] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_CARET] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2881),
    [anon_sym_LT_DASH] = ACTIONS(2881),
    [anon_sym_LT_LT] = ACTIONS(2881),
    [anon_sym_GT_GT] = ACTIONS(2881),
    [anon_sym_GT_GT_GT] = ACTIONS(2881),
    [anon_sym_AMP_CARET] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2881),
    [sym_none] = ACTIONS(2881),
    [sym_true] = ACTIONS(2881),
    [sym_false] = ACTIONS(2881),
    [sym_nil] = ACTIONS(2881),
    [anon_sym_QMARK_DOT] = ACTIONS(2881),
    [anon_sym_POUND_LBRACK] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_DOLLARif] = ACTIONS(2881),
    [anon_sym_is] = ACTIONS(2881),
    [anon_sym_BANGis] = ACTIONS(2881),
    [anon_sym_in] = ACTIONS(2881),
    [anon_sym_BANGin] = ACTIONS(2881),
    [anon_sym_match] = ACTIONS(2881),
    [anon_sym_select] = ACTIONS(2881),
    [anon_sym_STAR_EQ] = ACTIONS(2881),
    [anon_sym_SLASH_EQ] = ACTIONS(2881),
    [anon_sym_PERCENT_EQ] = ACTIONS(2881),
    [anon_sym_LT_LT_EQ] = ACTIONS(2881),
    [anon_sym_GT_GT_EQ] = ACTIONS(2881),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2881),
    [anon_sym_AMP_EQ] = ACTIONS(2881),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2881),
    [anon_sym_PLUS_EQ] = ACTIONS(2881),
    [anon_sym_DASH_EQ] = ACTIONS(2881),
    [anon_sym_PIPE_EQ] = ACTIONS(2881),
    [anon_sym_CARET_EQ] = ACTIONS(2881),
    [anon_sym_COLON_EQ] = ACTIONS(2881),
    [anon_sym_lock] = ACTIONS(2881),
    [anon_sym_rlock] = ACTIONS(2881),
    [anon_sym_unsafe] = ACTIONS(2881),
    [anon_sym_sql] = ACTIONS(2881),
    [sym_int_literal] = ACTIONS(2881),
    [sym_float_literal] = ACTIONS(2881),
    [sym_rune_literal] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_c_SQUOTE] = ACTIONS(2881),
    [anon_sym_c_DQUOTE] = ACTIONS(2881),
    [anon_sym_r_SQUOTE] = ACTIONS(2881),
    [anon_sym_r_DQUOTE] = ACTIONS(2881),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2881),
    [anon_sym_shared] = ACTIONS(2881),
    [anon_sym_map_LBRACK] = ACTIONS(2881),
    [anon_sym_chan] = ACTIONS(2881),
    [anon_sym_thread] = ACTIONS(2881),
    [anon_sym_atomic] = ACTIONS(2881),
    [anon_sym_assert] = ACTIONS(2881),
    [anon_sym_defer] = ACTIONS(2881),
    [anon_sym_goto] = ACTIONS(2881),
    [anon_sym_break] = ACTIONS(2881),
    [anon_sym_continue] = ACTIONS(2881),
    [anon_sym_return] = ACTIONS(2881),
    [anon_sym_DOLLARfor] = ACTIONS(2881),
    [anon_sym_for] = ACTIONS(2881),
    [anon_sym_POUND] = ACTIONS(2881),
    [anon_sym_asm] = ACTIONS(2881),
    [anon_sym_AT_LBRACK] = ACTIONS(2881),
  },
  [427] = {
    [sym_line_comment] = STATE(427),
    [sym_block_comment] = STATE(427),
    [ts_builtin_sym_end] = ACTIONS(2883),
    [sym_identifier] = ACTIONS(2885),
    [anon_sym_LF] = ACTIONS(2885),
    [anon_sym_CR] = ACTIONS(2885),
    [anon_sym_CR_LF] = ACTIONS(2885),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2885),
    [anon_sym_as] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2885),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym___global] = ACTIONS(2885),
    [anon_sym_type] = ACTIONS(2885),
    [anon_sym_fn] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2885),
    [anon_sym_SLASH] = ACTIONS(2885),
    [anon_sym_PERCENT] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_GT] = ACTIONS(2885),
    [anon_sym_EQ_EQ] = ACTIONS(2885),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2885),
    [anon_sym_GT_EQ] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_union] = ACTIONS(2885),
    [anon_sym_pub] = ACTIONS(2885),
    [anon_sym_mut] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [anon_sym_interface] = ACTIONS(2885),
    [anon_sym_PLUS_PLUS] = ACTIONS(2885),
    [anon_sym_DASH_DASH] = ACTIONS(2885),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_BANG] = ACTIONS(2885),
    [anon_sym_go] = ACTIONS(2885),
    [anon_sym_spawn] = ACTIONS(2885),
    [anon_sym_json_DOTdecode] = ACTIONS(2885),
    [anon_sym_PIPE] = ACTIONS(2885),
    [anon_sym_LBRACK2] = ACTIONS(2885),
    [anon_sym_TILDE] = ACTIONS(2885),
    [anon_sym_CARET] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_LT_DASH] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2885),
    [anon_sym_GT_GT] = ACTIONS(2885),
    [anon_sym_GT_GT_GT] = ACTIONS(2885),
    [anon_sym_AMP_CARET] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_or] = ACTIONS(2885),
    [sym_none] = ACTIONS(2885),
    [sym_true] = ACTIONS(2885),
    [sym_false] = ACTIONS(2885),
    [sym_nil] = ACTIONS(2885),
    [anon_sym_QMARK_DOT] = ACTIONS(2885),
    [anon_sym_POUND_LBRACK] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_DOLLARif] = ACTIONS(2885),
    [anon_sym_is] = ACTIONS(2885),
    [anon_sym_BANGis] = ACTIONS(2885),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_BANGin] = ACTIONS(2885),
    [anon_sym_match] = ACTIONS(2885),
    [anon_sym_select] = ACTIONS(2885),
    [anon_sym_STAR_EQ] = ACTIONS(2885),
    [anon_sym_SLASH_EQ] = ACTIONS(2885),
    [anon_sym_PERCENT_EQ] = ACTIONS(2885),
    [anon_sym_LT_LT_EQ] = ACTIONS(2885),
    [anon_sym_GT_GT_EQ] = ACTIONS(2885),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2885),
    [anon_sym_AMP_EQ] = ACTIONS(2885),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2885),
    [anon_sym_PLUS_EQ] = ACTIONS(2885),
    [anon_sym_DASH_EQ] = ACTIONS(2885),
    [anon_sym_PIPE_EQ] = ACTIONS(2885),
    [anon_sym_CARET_EQ] = ACTIONS(2885),
    [anon_sym_COLON_EQ] = ACTIONS(2885),
    [anon_sym_lock] = ACTIONS(2885),
    [anon_sym_rlock] = ACTIONS(2885),
    [anon_sym_unsafe] = ACTIONS(2885),
    [anon_sym_sql] = ACTIONS(2885),
    [sym_int_literal] = ACTIONS(2885),
    [sym_float_literal] = ACTIONS(2885),
    [sym_rune_literal] = ACTIONS(2885),
    [anon_sym_SQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE] = ACTIONS(2885),
    [anon_sym_c_SQUOTE] = ACTIONS(2885),
    [anon_sym_c_DQUOTE] = ACTIONS(2885),
    [anon_sym_r_SQUOTE] = ACTIONS(2885),
    [anon_sym_r_DQUOTE] = ACTIONS(2885),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2885),
    [anon_sym_shared] = ACTIONS(2885),
    [anon_sym_map_LBRACK] = ACTIONS(2885),
    [anon_sym_chan] = ACTIONS(2885),
    [anon_sym_thread] = ACTIONS(2885),
    [anon_sym_atomic] = ACTIONS(2885),
    [anon_sym_assert] = ACTIONS(2885),
    [anon_sym_defer] = ACTIONS(2885),
    [anon_sym_goto] = ACTIONS(2885),
    [anon_sym_break] = ACTIONS(2885),
    [anon_sym_continue] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_DOLLARfor] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_POUND] = ACTIONS(2885),
    [anon_sym_asm] = ACTIONS(2885),
    [anon_sym_AT_LBRACK] = ACTIONS(2885),
  },
  [428] = {
    [sym_line_comment] = STATE(428),
    [sym_block_comment] = STATE(428),
    [ts_builtin_sym_end] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2889),
    [anon_sym_LF] = ACTIONS(2889),
    [anon_sym_CR] = ACTIONS(2889),
    [anon_sym_CR_LF] = ACTIONS(2889),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2889),
    [anon_sym_as] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2889),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_const] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2889),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym___global] = ACTIONS(2889),
    [anon_sym_type] = ACTIONS(2889),
    [anon_sym_fn] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2889),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_SLASH] = ACTIONS(2889),
    [anon_sym_PERCENT] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_GT] = ACTIONS(2889),
    [anon_sym_EQ_EQ] = ACTIONS(2889),
    [anon_sym_BANG_EQ] = ACTIONS(2889),
    [anon_sym_LT_EQ] = ACTIONS(2889),
    [anon_sym_GT_EQ] = ACTIONS(2889),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_struct] = ACTIONS(2889),
    [anon_sym_union] = ACTIONS(2889),
    [anon_sym_pub] = ACTIONS(2889),
    [anon_sym_mut] = ACTIONS(2889),
    [anon_sym_enum] = ACTIONS(2889),
    [anon_sym_interface] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2889),
    [anon_sym_DASH_DASH] = ACTIONS(2889),
    [anon_sym_QMARK] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2889),
    [anon_sym_go] = ACTIONS(2889),
    [anon_sym_spawn] = ACTIONS(2889),
    [anon_sym_json_DOTdecode] = ACTIONS(2889),
    [anon_sym_PIPE] = ACTIONS(2889),
    [anon_sym_LBRACK2] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_CARET] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2889),
    [anon_sym_LT_DASH] = ACTIONS(2889),
    [anon_sym_LT_LT] = ACTIONS(2889),
    [anon_sym_GT_GT] = ACTIONS(2889),
    [anon_sym_GT_GT_GT] = ACTIONS(2889),
    [anon_sym_AMP_CARET] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2889),
    [anon_sym_or] = ACTIONS(2889),
    [sym_none] = ACTIONS(2889),
    [sym_true] = ACTIONS(2889),
    [sym_false] = ACTIONS(2889),
    [sym_nil] = ACTIONS(2889),
    [anon_sym_QMARK_DOT] = ACTIONS(2889),
    [anon_sym_POUND_LBRACK] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_DOLLARif] = ACTIONS(2889),
    [anon_sym_is] = ACTIONS(2889),
    [anon_sym_BANGis] = ACTIONS(2889),
    [anon_sym_in] = ACTIONS(2889),
    [anon_sym_BANGin] = ACTIONS(2889),
    [anon_sym_match] = ACTIONS(2889),
    [anon_sym_select] = ACTIONS(2889),
    [anon_sym_STAR_EQ] = ACTIONS(2889),
    [anon_sym_SLASH_EQ] = ACTIONS(2889),
    [anon_sym_PERCENT_EQ] = ACTIONS(2889),
    [anon_sym_LT_LT_EQ] = ACTIONS(2889),
    [anon_sym_GT_GT_EQ] = ACTIONS(2889),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2889),
    [anon_sym_AMP_EQ] = ACTIONS(2889),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2889),
    [anon_sym_PLUS_EQ] = ACTIONS(2889),
    [anon_sym_DASH_EQ] = ACTIONS(2889),
    [anon_sym_PIPE_EQ] = ACTIONS(2889),
    [anon_sym_CARET_EQ] = ACTIONS(2889),
    [anon_sym_COLON_EQ] = ACTIONS(2889),
    [anon_sym_lock] = ACTIONS(2889),
    [anon_sym_rlock] = ACTIONS(2889),
    [anon_sym_unsafe] = ACTIONS(2889),
    [anon_sym_sql] = ACTIONS(2889),
    [sym_int_literal] = ACTIONS(2889),
    [sym_float_literal] = ACTIONS(2889),
    [sym_rune_literal] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [anon_sym_c_SQUOTE] = ACTIONS(2889),
    [anon_sym_c_DQUOTE] = ACTIONS(2889),
    [anon_sym_r_SQUOTE] = ACTIONS(2889),
    [anon_sym_r_DQUOTE] = ACTIONS(2889),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2889),
    [anon_sym_shared] = ACTIONS(2889),
    [anon_sym_map_LBRACK] = ACTIONS(2889),
    [anon_sym_chan] = ACTIONS(2889),
    [anon_sym_thread] = ACTIONS(2889),
    [anon_sym_atomic] = ACTIONS(2889),
    [anon_sym_assert] = ACTIONS(2889),
    [anon_sym_defer] = ACTIONS(2889),
    [anon_sym_goto] = ACTIONS(2889),
    [anon_sym_break] = ACTIONS(2889),
    [anon_sym_continue] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_DOLLARfor] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_POUND] = ACTIONS(2889),
    [anon_sym_asm] = ACTIONS(2889),
    [anon_sym_AT_LBRACK] = ACTIONS(2889),
  },
  [429] = {
    [sym_line_comment] = STATE(429),
    [sym_block_comment] = STATE(429),
    [ts_builtin_sym_end] = ACTIONS(2891),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LF] = ACTIONS(2893),
    [anon_sym_CR] = ACTIONS(2893),
    [anon_sym_CR_LF] = ACTIONS(2893),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2893),
    [anon_sym_as] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2893),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym___global] = ACTIONS(2893),
    [anon_sym_type] = ACTIONS(2893),
    [anon_sym_fn] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_PERCENT] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_GT] = ACTIONS(2893),
    [anon_sym_EQ_EQ] = ACTIONS(2893),
    [anon_sym_BANG_EQ] = ACTIONS(2893),
    [anon_sym_LT_EQ] = ACTIONS(2893),
    [anon_sym_GT_EQ] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [anon_sym_pub] = ACTIONS(2893),
    [anon_sym_mut] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_interface] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2893),
    [anon_sym_DASH_DASH] = ACTIONS(2893),
    [anon_sym_QMARK] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_go] = ACTIONS(2893),
    [anon_sym_spawn] = ACTIONS(2893),
    [anon_sym_json_DOTdecode] = ACTIONS(2893),
    [anon_sym_PIPE] = ACTIONS(2893),
    [anon_sym_LBRACK2] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_LT_DASH] = ACTIONS(2893),
    [anon_sym_LT_LT] = ACTIONS(2893),
    [anon_sym_GT_GT] = ACTIONS(2893),
    [anon_sym_GT_GT_GT] = ACTIONS(2893),
    [anon_sym_AMP_CARET] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2893),
    [anon_sym_PIPE_PIPE] = ACTIONS(2893),
    [anon_sym_or] = ACTIONS(2893),
    [sym_none] = ACTIONS(2893),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [sym_nil] = ACTIONS(2893),
    [anon_sym_QMARK_DOT] = ACTIONS(2893),
    [anon_sym_POUND_LBRACK] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_DOLLARif] = ACTIONS(2893),
    [anon_sym_is] = ACTIONS(2893),
    [anon_sym_BANGis] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_BANGin] = ACTIONS(2893),
    [anon_sym_match] = ACTIONS(2893),
    [anon_sym_select] = ACTIONS(2893),
    [anon_sym_STAR_EQ] = ACTIONS(2893),
    [anon_sym_SLASH_EQ] = ACTIONS(2893),
    [anon_sym_PERCENT_EQ] = ACTIONS(2893),
    [anon_sym_LT_LT_EQ] = ACTIONS(2893),
    [anon_sym_GT_GT_EQ] = ACTIONS(2893),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2893),
    [anon_sym_AMP_EQ] = ACTIONS(2893),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2893),
    [anon_sym_PLUS_EQ] = ACTIONS(2893),
    [anon_sym_DASH_EQ] = ACTIONS(2893),
    [anon_sym_PIPE_EQ] = ACTIONS(2893),
    [anon_sym_CARET_EQ] = ACTIONS(2893),
    [anon_sym_COLON_EQ] = ACTIONS(2893),
    [anon_sym_lock] = ACTIONS(2893),
    [anon_sym_rlock] = ACTIONS(2893),
    [anon_sym_unsafe] = ACTIONS(2893),
    [anon_sym_sql] = ACTIONS(2893),
    [sym_int_literal] = ACTIONS(2893),
    [sym_float_literal] = ACTIONS(2893),
    [sym_rune_literal] = ACTIONS(2893),
    [anon_sym_SQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(2893),
    [anon_sym_c_SQUOTE] = ACTIONS(2893),
    [anon_sym_c_DQUOTE] = ACTIONS(2893),
    [anon_sym_r_SQUOTE] = ACTIONS(2893),
    [anon_sym_r_DQUOTE] = ACTIONS(2893),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_map_LBRACK] = ACTIONS(2893),
    [anon_sym_chan] = ACTIONS(2893),
    [anon_sym_thread] = ACTIONS(2893),
    [anon_sym_atomic] = ACTIONS(2893),
    [anon_sym_assert] = ACTIONS(2893),
    [anon_sym_defer] = ACTIONS(2893),
    [anon_sym_goto] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_DOLLARfor] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_POUND] = ACTIONS(2893),
    [anon_sym_asm] = ACTIONS(2893),
    [anon_sym_AT_LBRACK] = ACTIONS(2893),
  },
  [430] = {
    [sym_line_comment] = STATE(430),
    [sym_block_comment] = STATE(430),
    [sym__expression] = STATE(1604),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_string_interpolation_repeat1] = STATE(487),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_go] = ACTIONS(2903),
    [anon_sym_spawn] = ACTIONS(2905),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_LT_DASH] = ACTIONS(2909),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(2911),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_rlock] = ACTIONS(2913),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [431] = {
    [sym_line_comment] = STATE(431),
    [sym_block_comment] = STATE(431),
    [ts_builtin_sym_end] = ACTIONS(2915),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_LF] = ACTIONS(2917),
    [anon_sym_CR] = ACTIONS(2917),
    [anon_sym_CR_LF] = ACTIONS(2917),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2917),
    [anon_sym_as] = ACTIONS(2917),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_COMMA] = ACTIONS(2917),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_LPAREN] = ACTIONS(2917),
    [anon_sym_EQ] = ACTIONS(2917),
    [anon_sym___global] = ACTIONS(2917),
    [anon_sym_type] = ACTIONS(2917),
    [anon_sym_fn] = ACTIONS(2917),
    [anon_sym_PLUS] = ACTIONS(2917),
    [anon_sym_DASH] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2917),
    [anon_sym_SLASH] = ACTIONS(2917),
    [anon_sym_PERCENT] = ACTIONS(2917),
    [anon_sym_LT] = ACTIONS(2917),
    [anon_sym_GT] = ACTIONS(2917),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2917),
    [anon_sym_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT_EQ] = ACTIONS(2917),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2917),
    [anon_sym_union] = ACTIONS(2917),
    [anon_sym_pub] = ACTIONS(2917),
    [anon_sym_mut] = ACTIONS(2917),
    [anon_sym_enum] = ACTIONS(2917),
    [anon_sym_interface] = ACTIONS(2917),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_QMARK] = ACTIONS(2917),
    [anon_sym_BANG] = ACTIONS(2917),
    [anon_sym_go] = ACTIONS(2917),
    [anon_sym_spawn] = ACTIONS(2917),
    [anon_sym_json_DOTdecode] = ACTIONS(2917),
    [anon_sym_PIPE] = ACTIONS(2917),
    [anon_sym_LBRACK2] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_CARET] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2917),
    [anon_sym_LT_DASH] = ACTIONS(2917),
    [anon_sym_LT_LT] = ACTIONS(2917),
    [anon_sym_GT_GT] = ACTIONS(2917),
    [anon_sym_GT_GT_GT] = ACTIONS(2917),
    [anon_sym_AMP_CARET] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_PIPE_PIPE] = ACTIONS(2917),
    [anon_sym_or] = ACTIONS(2917),
    [sym_none] = ACTIONS(2917),
    [sym_true] = ACTIONS(2917),
    [sym_false] = ACTIONS(2917),
    [sym_nil] = ACTIONS(2917),
    [anon_sym_QMARK_DOT] = ACTIONS(2917),
    [anon_sym_POUND_LBRACK] = ACTIONS(2917),
    [anon_sym_if] = ACTIONS(2917),
    [anon_sym_DOLLARif] = ACTIONS(2917),
    [anon_sym_is] = ACTIONS(2917),
    [anon_sym_BANGis] = ACTIONS(2917),
    [anon_sym_in] = ACTIONS(2917),
    [anon_sym_BANGin] = ACTIONS(2917),
    [anon_sym_match] = ACTIONS(2917),
    [anon_sym_select] = ACTIONS(2917),
    [anon_sym_STAR_EQ] = ACTIONS(2917),
    [anon_sym_SLASH_EQ] = ACTIONS(2917),
    [anon_sym_PERCENT_EQ] = ACTIONS(2917),
    [anon_sym_LT_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT_GT_EQ] = ACTIONS(2917),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2917),
    [anon_sym_AMP_EQ] = ACTIONS(2917),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2917),
    [anon_sym_PLUS_EQ] = ACTIONS(2917),
    [anon_sym_DASH_EQ] = ACTIONS(2917),
    [anon_sym_PIPE_EQ] = ACTIONS(2917),
    [anon_sym_CARET_EQ] = ACTIONS(2917),
    [anon_sym_COLON_EQ] = ACTIONS(2917),
    [anon_sym_lock] = ACTIONS(2917),
    [anon_sym_rlock] = ACTIONS(2917),
    [anon_sym_unsafe] = ACTIONS(2917),
    [anon_sym_sql] = ACTIONS(2917),
    [sym_int_literal] = ACTIONS(2917),
    [sym_float_literal] = ACTIONS(2917),
    [sym_rune_literal] = ACTIONS(2917),
    [anon_sym_SQUOTE] = ACTIONS(2917),
    [anon_sym_DQUOTE] = ACTIONS(2917),
    [anon_sym_c_SQUOTE] = ACTIONS(2917),
    [anon_sym_c_DQUOTE] = ACTIONS(2917),
    [anon_sym_r_SQUOTE] = ACTIONS(2917),
    [anon_sym_r_DQUOTE] = ACTIONS(2917),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2917),
    [anon_sym_shared] = ACTIONS(2917),
    [anon_sym_map_LBRACK] = ACTIONS(2917),
    [anon_sym_chan] = ACTIONS(2917),
    [anon_sym_thread] = ACTIONS(2917),
    [anon_sym_atomic] = ACTIONS(2917),
    [anon_sym_assert] = ACTIONS(2917),
    [anon_sym_defer] = ACTIONS(2917),
    [anon_sym_goto] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2917),
    [anon_sym_continue] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2917),
    [anon_sym_DOLLARfor] = ACTIONS(2917),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_POUND] = ACTIONS(2917),
    [anon_sym_asm] = ACTIONS(2917),
    [anon_sym_AT_LBRACK] = ACTIONS(2917),
  },
  [432] = {
    [sym_line_comment] = STATE(432),
    [sym_block_comment] = STATE(432),
    [sym__expression] = STATE(2619),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4493),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [433] = {
    [sym_line_comment] = STATE(433),
    [sym_block_comment] = STATE(433),
    [sym__expression] = STATE(2619),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3688),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4493),
    [sym_identifier] = ACTIONS(2385),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(2387),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2389),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(2391),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [434] = {
    [sym_line_comment] = STATE(434),
    [sym_block_comment] = STATE(434),
    [ts_builtin_sym_end] = ACTIONS(2919),
    [sym_identifier] = ACTIONS(2921),
    [anon_sym_LF] = ACTIONS(2921),
    [anon_sym_CR] = ACTIONS(2921),
    [anon_sym_CR_LF] = ACTIONS(2921),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_as] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_COMMA] = ACTIONS(2921),
    [anon_sym_const] = ACTIONS(2921),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_EQ] = ACTIONS(2921),
    [anon_sym___global] = ACTIONS(2921),
    [anon_sym_type] = ACTIONS(2921),
    [anon_sym_fn] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2921),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2921),
    [anon_sym_LT] = ACTIONS(2921),
    [anon_sym_GT] = ACTIONS(2921),
    [anon_sym_EQ_EQ] = ACTIONS(2921),
    [anon_sym_BANG_EQ] = ACTIONS(2921),
    [anon_sym_LT_EQ] = ACTIONS(2921),
    [anon_sym_GT_EQ] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2919),
    [anon_sym_struct] = ACTIONS(2921),
    [anon_sym_union] = ACTIONS(2921),
    [anon_sym_pub] = ACTIONS(2921),
    [anon_sym_mut] = ACTIONS(2921),
    [anon_sym_enum] = ACTIONS(2921),
    [anon_sym_interface] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2921),
    [anon_sym_DASH_DASH] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_go] = ACTIONS(2921),
    [anon_sym_spawn] = ACTIONS(2921),
    [anon_sym_json_DOTdecode] = ACTIONS(2921),
    [anon_sym_PIPE] = ACTIONS(2921),
    [anon_sym_LBRACK2] = ACTIONS(2921),
    [anon_sym_TILDE] = ACTIONS(2921),
    [anon_sym_CARET] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2921),
    [anon_sym_LT_DASH] = ACTIONS(2921),
    [anon_sym_LT_LT] = ACTIONS(2921),
    [anon_sym_GT_GT] = ACTIONS(2921),
    [anon_sym_GT_GT_GT] = ACTIONS(2921),
    [anon_sym_AMP_CARET] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE] = ACTIONS(2921),
    [anon_sym_or] = ACTIONS(2921),
    [sym_none] = ACTIONS(2921),
    [sym_true] = ACTIONS(2921),
    [sym_false] = ACTIONS(2921),
    [sym_nil] = ACTIONS(2921),
    [anon_sym_QMARK_DOT] = ACTIONS(2921),
    [anon_sym_POUND_LBRACK] = ACTIONS(2921),
    [anon_sym_if] = ACTIONS(2921),
    [anon_sym_DOLLARif] = ACTIONS(2921),
    [anon_sym_is] = ACTIONS(2921),
    [anon_sym_BANGis] = ACTIONS(2921),
    [anon_sym_in] = ACTIONS(2921),
    [anon_sym_BANGin] = ACTIONS(2921),
    [anon_sym_match] = ACTIONS(2921),
    [anon_sym_select] = ACTIONS(2921),
    [anon_sym_STAR_EQ] = ACTIONS(2921),
    [anon_sym_SLASH_EQ] = ACTIONS(2921),
    [anon_sym_PERCENT_EQ] = ACTIONS(2921),
    [anon_sym_LT_LT_EQ] = ACTIONS(2921),
    [anon_sym_GT_GT_EQ] = ACTIONS(2921),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2921),
    [anon_sym_AMP_EQ] = ACTIONS(2921),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2921),
    [anon_sym_PLUS_EQ] = ACTIONS(2921),
    [anon_sym_DASH_EQ] = ACTIONS(2921),
    [anon_sym_PIPE_EQ] = ACTIONS(2921),
    [anon_sym_CARET_EQ] = ACTIONS(2921),
    [anon_sym_COLON_EQ] = ACTIONS(2921),
    [anon_sym_lock] = ACTIONS(2921),
    [anon_sym_rlock] = ACTIONS(2921),
    [anon_sym_unsafe] = ACTIONS(2921),
    [anon_sym_sql] = ACTIONS(2921),
    [sym_int_literal] = ACTIONS(2921),
    [sym_float_literal] = ACTIONS(2921),
    [sym_rune_literal] = ACTIONS(2921),
    [anon_sym_SQUOTE] = ACTIONS(2921),
    [anon_sym_DQUOTE] = ACTIONS(2921),
    [anon_sym_c_SQUOTE] = ACTIONS(2921),
    [anon_sym_c_DQUOTE] = ACTIONS(2921),
    [anon_sym_r_SQUOTE] = ACTIONS(2921),
    [anon_sym_r_DQUOTE] = ACTIONS(2921),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2921),
    [anon_sym_shared] = ACTIONS(2921),
    [anon_sym_map_LBRACK] = ACTIONS(2921),
    [anon_sym_chan] = ACTIONS(2921),
    [anon_sym_thread] = ACTIONS(2921),
    [anon_sym_atomic] = ACTIONS(2921),
    [anon_sym_assert] = ACTIONS(2921),
    [anon_sym_defer] = ACTIONS(2921),
    [anon_sym_goto] = ACTIONS(2921),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2921),
    [anon_sym_return] = ACTIONS(2921),
    [anon_sym_DOLLARfor] = ACTIONS(2921),
    [anon_sym_for] = ACTIONS(2921),
    [anon_sym_POUND] = ACTIONS(2921),
    [anon_sym_asm] = ACTIONS(2921),
    [anon_sym_AT_LBRACK] = ACTIONS(2921),
  },
  [435] = {
    [sym_line_comment] = STATE(435),
    [sym_block_comment] = STATE(435),
    [ts_builtin_sym_end] = ACTIONS(2923),
    [sym_identifier] = ACTIONS(2925),
    [anon_sym_LF] = ACTIONS(2925),
    [anon_sym_CR] = ACTIONS(2925),
    [anon_sym_CR_LF] = ACTIONS(2925),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2925),
    [anon_sym_as] = ACTIONS(2925),
    [anon_sym_LBRACE] = ACTIONS(2925),
    [anon_sym_COMMA] = ACTIONS(2925),
    [anon_sym_const] = ACTIONS(2925),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_EQ] = ACTIONS(2925),
    [anon_sym___global] = ACTIONS(2925),
    [anon_sym_type] = ACTIONS(2925),
    [anon_sym_fn] = ACTIONS(2925),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_STAR] = ACTIONS(2925),
    [anon_sym_SLASH] = ACTIONS(2925),
    [anon_sym_PERCENT] = ACTIONS(2925),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_GT] = ACTIONS(2925),
    [anon_sym_EQ_EQ] = ACTIONS(2925),
    [anon_sym_BANG_EQ] = ACTIONS(2925),
    [anon_sym_LT_EQ] = ACTIONS(2925),
    [anon_sym_GT_EQ] = ACTIONS(2925),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_struct] = ACTIONS(2925),
    [anon_sym_union] = ACTIONS(2925),
    [anon_sym_pub] = ACTIONS(2925),
    [anon_sym_mut] = ACTIONS(2925),
    [anon_sym_enum] = ACTIONS(2925),
    [anon_sym_interface] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2925),
    [anon_sym_DASH_DASH] = ACTIONS(2925),
    [anon_sym_QMARK] = ACTIONS(2925),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_go] = ACTIONS(2925),
    [anon_sym_spawn] = ACTIONS(2925),
    [anon_sym_json_DOTdecode] = ACTIONS(2925),
    [anon_sym_PIPE] = ACTIONS(2925),
    [anon_sym_LBRACK2] = ACTIONS(2925),
    [anon_sym_TILDE] = ACTIONS(2925),
    [anon_sym_CARET] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym_LT_DASH] = ACTIONS(2925),
    [anon_sym_LT_LT] = ACTIONS(2925),
    [anon_sym_GT_GT] = ACTIONS(2925),
    [anon_sym_GT_GT_GT] = ACTIONS(2925),
    [anon_sym_AMP_CARET] = ACTIONS(2925),
    [anon_sym_AMP_AMP] = ACTIONS(2925),
    [anon_sym_PIPE_PIPE] = ACTIONS(2925),
    [anon_sym_or] = ACTIONS(2925),
    [sym_none] = ACTIONS(2925),
    [sym_true] = ACTIONS(2925),
    [sym_false] = ACTIONS(2925),
    [sym_nil] = ACTIONS(2925),
    [anon_sym_QMARK_DOT] = ACTIONS(2925),
    [anon_sym_POUND_LBRACK] = ACTIONS(2925),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_DOLLARif] = ACTIONS(2925),
    [anon_sym_is] = ACTIONS(2925),
    [anon_sym_BANGis] = ACTIONS(2925),
    [anon_sym_in] = ACTIONS(2925),
    [anon_sym_BANGin] = ACTIONS(2925),
    [anon_sym_match] = ACTIONS(2925),
    [anon_sym_select] = ACTIONS(2925),
    [anon_sym_STAR_EQ] = ACTIONS(2925),
    [anon_sym_SLASH_EQ] = ACTIONS(2925),
    [anon_sym_PERCENT_EQ] = ACTIONS(2925),
    [anon_sym_LT_LT_EQ] = ACTIONS(2925),
    [anon_sym_GT_GT_EQ] = ACTIONS(2925),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2925),
    [anon_sym_AMP_EQ] = ACTIONS(2925),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(2925),
    [anon_sym_DASH_EQ] = ACTIONS(2925),
    [anon_sym_PIPE_EQ] = ACTIONS(2925),
    [anon_sym_CARET_EQ] = ACTIONS(2925),
    [anon_sym_COLON_EQ] = ACTIONS(2925),
    [anon_sym_lock] = ACTIONS(2925),
    [anon_sym_rlock] = ACTIONS(2925),
    [anon_sym_unsafe] = ACTIONS(2925),
    [anon_sym_sql] = ACTIONS(2925),
    [sym_int_literal] = ACTIONS(2925),
    [sym_float_literal] = ACTIONS(2925),
    [sym_rune_literal] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2925),
    [anon_sym_DQUOTE] = ACTIONS(2925),
    [anon_sym_c_SQUOTE] = ACTIONS(2925),
    [anon_sym_c_DQUOTE] = ACTIONS(2925),
    [anon_sym_r_SQUOTE] = ACTIONS(2925),
    [anon_sym_r_DQUOTE] = ACTIONS(2925),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2925),
    [anon_sym_shared] = ACTIONS(2925),
    [anon_sym_map_LBRACK] = ACTIONS(2925),
    [anon_sym_chan] = ACTIONS(2925),
    [anon_sym_thread] = ACTIONS(2925),
    [anon_sym_atomic] = ACTIONS(2925),
    [anon_sym_assert] = ACTIONS(2925),
    [anon_sym_defer] = ACTIONS(2925),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2925),
    [anon_sym_continue] = ACTIONS(2925),
    [anon_sym_return] = ACTIONS(2925),
    [anon_sym_DOLLARfor] = ACTIONS(2925),
    [anon_sym_for] = ACTIONS(2925),
    [anon_sym_POUND] = ACTIONS(2925),
    [anon_sym_asm] = ACTIONS(2925),
    [anon_sym_AT_LBRACK] = ACTIONS(2925),
  },
  [436] = {
    [sym_line_comment] = STATE(436),
    [sym_block_comment] = STATE(436),
    [ts_builtin_sym_end] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [anon_sym_LF] = ACTIONS(2929),
    [anon_sym_CR] = ACTIONS(2929),
    [anon_sym_CR_LF] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2929),
    [anon_sym_as] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2929),
    [anon_sym_COMMA] = ACTIONS(2929),
    [anon_sym_const] = ACTIONS(2929),
    [anon_sym_LPAREN] = ACTIONS(2929),
    [anon_sym_EQ] = ACTIONS(2929),
    [anon_sym___global] = ACTIONS(2929),
    [anon_sym_type] = ACTIONS(2929),
    [anon_sym_fn] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2929),
    [anon_sym_GT] = ACTIONS(2929),
    [anon_sym_EQ_EQ] = ACTIONS(2929),
    [anon_sym_BANG_EQ] = ACTIONS(2929),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2929),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2929),
    [anon_sym_union] = ACTIONS(2929),
    [anon_sym_pub] = ACTIONS(2929),
    [anon_sym_mut] = ACTIONS(2929),
    [anon_sym_enum] = ACTIONS(2929),
    [anon_sym_interface] = ACTIONS(2929),
    [anon_sym_PLUS_PLUS] = ACTIONS(2929),
    [anon_sym_DASH_DASH] = ACTIONS(2929),
    [anon_sym_QMARK] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2929),
    [anon_sym_go] = ACTIONS(2929),
    [anon_sym_spawn] = ACTIONS(2929),
    [anon_sym_json_DOTdecode] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(2929),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2929),
    [anon_sym_CARET] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_LT_DASH] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(2929),
    [anon_sym_GT_GT] = ACTIONS(2929),
    [anon_sym_GT_GT_GT] = ACTIONS(2929),
    [anon_sym_AMP_CARET] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_or] = ACTIONS(2929),
    [sym_none] = ACTIONS(2929),
    [sym_true] = ACTIONS(2929),
    [sym_false] = ACTIONS(2929),
    [sym_nil] = ACTIONS(2929),
    [anon_sym_QMARK_DOT] = ACTIONS(2929),
    [anon_sym_POUND_LBRACK] = ACTIONS(2929),
    [anon_sym_if] = ACTIONS(2929),
    [anon_sym_DOLLARif] = ACTIONS(2929),
    [anon_sym_is] = ACTIONS(2929),
    [anon_sym_BANGis] = ACTIONS(2929),
    [anon_sym_in] = ACTIONS(2929),
    [anon_sym_BANGin] = ACTIONS(2929),
    [anon_sym_match] = ACTIONS(2929),
    [anon_sym_select] = ACTIONS(2929),
    [anon_sym_STAR_EQ] = ACTIONS(2929),
    [anon_sym_SLASH_EQ] = ACTIONS(2929),
    [anon_sym_PERCENT_EQ] = ACTIONS(2929),
    [anon_sym_LT_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_GT_EQ] = ACTIONS(2929),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2929),
    [anon_sym_AMP_EQ] = ACTIONS(2929),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2929),
    [anon_sym_PLUS_EQ] = ACTIONS(2929),
    [anon_sym_DASH_EQ] = ACTIONS(2929),
    [anon_sym_PIPE_EQ] = ACTIONS(2929),
    [anon_sym_CARET_EQ] = ACTIONS(2929),
    [anon_sym_COLON_EQ] = ACTIONS(2929),
    [anon_sym_lock] = ACTIONS(2929),
    [anon_sym_rlock] = ACTIONS(2929),
    [anon_sym_unsafe] = ACTIONS(2929),
    [anon_sym_sql] = ACTIONS(2929),
    [sym_int_literal] = ACTIONS(2929),
    [sym_float_literal] = ACTIONS(2929),
    [sym_rune_literal] = ACTIONS(2929),
    [anon_sym_SQUOTE] = ACTIONS(2929),
    [anon_sym_DQUOTE] = ACTIONS(2929),
    [anon_sym_c_SQUOTE] = ACTIONS(2929),
    [anon_sym_c_DQUOTE] = ACTIONS(2929),
    [anon_sym_r_SQUOTE] = ACTIONS(2929),
    [anon_sym_r_DQUOTE] = ACTIONS(2929),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2929),
    [anon_sym_shared] = ACTIONS(2929),
    [anon_sym_map_LBRACK] = ACTIONS(2929),
    [anon_sym_chan] = ACTIONS(2929),
    [anon_sym_thread] = ACTIONS(2929),
    [anon_sym_atomic] = ACTIONS(2929),
    [anon_sym_assert] = ACTIONS(2929),
    [anon_sym_defer] = ACTIONS(2929),
    [anon_sym_goto] = ACTIONS(2929),
    [anon_sym_break] = ACTIONS(2929),
    [anon_sym_continue] = ACTIONS(2929),
    [anon_sym_return] = ACTIONS(2929),
    [anon_sym_DOLLARfor] = ACTIONS(2929),
    [anon_sym_for] = ACTIONS(2929),
    [anon_sym_POUND] = ACTIONS(2929),
    [anon_sym_asm] = ACTIONS(2929),
    [anon_sym_AT_LBRACK] = ACTIONS(2929),
  },
  [437] = {
    [sym_line_comment] = STATE(437),
    [sym_block_comment] = STATE(437),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4518),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [438] = {
    [sym_line_comment] = STATE(438),
    [sym_block_comment] = STATE(438),
    [ts_builtin_sym_end] = ACTIONS(2933),
    [sym_identifier] = ACTIONS(2935),
    [anon_sym_LF] = ACTIONS(2935),
    [anon_sym_CR] = ACTIONS(2935),
    [anon_sym_CR_LF] = ACTIONS(2935),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2935),
    [anon_sym_as] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(2935),
    [anon_sym_COMMA] = ACTIONS(2935),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_LPAREN] = ACTIONS(2935),
    [anon_sym_EQ] = ACTIONS(2935),
    [anon_sym___global] = ACTIONS(2935),
    [anon_sym_type] = ACTIONS(2935),
    [anon_sym_fn] = ACTIONS(2935),
    [anon_sym_PLUS] = ACTIONS(2935),
    [anon_sym_DASH] = ACTIONS(2935),
    [anon_sym_STAR] = ACTIONS(2935),
    [anon_sym_SLASH] = ACTIONS(2935),
    [anon_sym_PERCENT] = ACTIONS(2935),
    [anon_sym_LT] = ACTIONS(2935),
    [anon_sym_GT] = ACTIONS(2935),
    [anon_sym_EQ_EQ] = ACTIONS(2935),
    [anon_sym_BANG_EQ] = ACTIONS(2935),
    [anon_sym_LT_EQ] = ACTIONS(2935),
    [anon_sym_GT_EQ] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2933),
    [anon_sym_struct] = ACTIONS(2935),
    [anon_sym_union] = ACTIONS(2935),
    [anon_sym_pub] = ACTIONS(2935),
    [anon_sym_mut] = ACTIONS(2935),
    [anon_sym_enum] = ACTIONS(2935),
    [anon_sym_interface] = ACTIONS(2935),
    [anon_sym_PLUS_PLUS] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2935),
    [anon_sym_QMARK] = ACTIONS(2935),
    [anon_sym_BANG] = ACTIONS(2935),
    [anon_sym_go] = ACTIONS(2935),
    [anon_sym_spawn] = ACTIONS(2935),
    [anon_sym_json_DOTdecode] = ACTIONS(2935),
    [anon_sym_PIPE] = ACTIONS(2935),
    [anon_sym_LBRACK2] = ACTIONS(2935),
    [anon_sym_TILDE] = ACTIONS(2935),
    [anon_sym_CARET] = ACTIONS(2935),
    [anon_sym_AMP] = ACTIONS(2935),
    [anon_sym_LT_DASH] = ACTIONS(2935),
    [anon_sym_LT_LT] = ACTIONS(2935),
    [anon_sym_GT_GT] = ACTIONS(2935),
    [anon_sym_GT_GT_GT] = ACTIONS(2935),
    [anon_sym_AMP_CARET] = ACTIONS(2935),
    [anon_sym_AMP_AMP] = ACTIONS(2935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2935),
    [anon_sym_or] = ACTIONS(2935),
    [sym_none] = ACTIONS(2935),
    [sym_true] = ACTIONS(2935),
    [sym_false] = ACTIONS(2935),
    [sym_nil] = ACTIONS(2935),
    [anon_sym_QMARK_DOT] = ACTIONS(2935),
    [anon_sym_POUND_LBRACK] = ACTIONS(2935),
    [anon_sym_if] = ACTIONS(2935),
    [anon_sym_DOLLARif] = ACTIONS(2935),
    [anon_sym_is] = ACTIONS(2935),
    [anon_sym_BANGis] = ACTIONS(2935),
    [anon_sym_in] = ACTIONS(2935),
    [anon_sym_BANGin] = ACTIONS(2935),
    [anon_sym_match] = ACTIONS(2935),
    [anon_sym_select] = ACTIONS(2935),
    [anon_sym_STAR_EQ] = ACTIONS(2935),
    [anon_sym_SLASH_EQ] = ACTIONS(2935),
    [anon_sym_PERCENT_EQ] = ACTIONS(2935),
    [anon_sym_LT_LT_EQ] = ACTIONS(2935),
    [anon_sym_GT_GT_EQ] = ACTIONS(2935),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2935),
    [anon_sym_AMP_EQ] = ACTIONS(2935),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2935),
    [anon_sym_PLUS_EQ] = ACTIONS(2935),
    [anon_sym_DASH_EQ] = ACTIONS(2935),
    [anon_sym_PIPE_EQ] = ACTIONS(2935),
    [anon_sym_CARET_EQ] = ACTIONS(2935),
    [anon_sym_COLON_EQ] = ACTIONS(2935),
    [anon_sym_lock] = ACTIONS(2935),
    [anon_sym_rlock] = ACTIONS(2935),
    [anon_sym_unsafe] = ACTIONS(2935),
    [anon_sym_sql] = ACTIONS(2935),
    [sym_int_literal] = ACTIONS(2935),
    [sym_float_literal] = ACTIONS(2935),
    [sym_rune_literal] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(2935),
    [anon_sym_DQUOTE] = ACTIONS(2935),
    [anon_sym_c_SQUOTE] = ACTIONS(2935),
    [anon_sym_c_DQUOTE] = ACTIONS(2935),
    [anon_sym_r_SQUOTE] = ACTIONS(2935),
    [anon_sym_r_DQUOTE] = ACTIONS(2935),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2935),
    [anon_sym_shared] = ACTIONS(2935),
    [anon_sym_map_LBRACK] = ACTIONS(2935),
    [anon_sym_chan] = ACTIONS(2935),
    [anon_sym_thread] = ACTIONS(2935),
    [anon_sym_atomic] = ACTIONS(2935),
    [anon_sym_assert] = ACTIONS(2935),
    [anon_sym_defer] = ACTIONS(2935),
    [anon_sym_goto] = ACTIONS(2935),
    [anon_sym_break] = ACTIONS(2935),
    [anon_sym_continue] = ACTIONS(2935),
    [anon_sym_return] = ACTIONS(2935),
    [anon_sym_DOLLARfor] = ACTIONS(2935),
    [anon_sym_for] = ACTIONS(2935),
    [anon_sym_POUND] = ACTIONS(2935),
    [anon_sym_asm] = ACTIONS(2935),
    [anon_sym_AT_LBRACK] = ACTIONS(2935),
  },
  [439] = {
    [sym_line_comment] = STATE(439),
    [sym_block_comment] = STATE(439),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1693),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1692),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(375),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(2937),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1615),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [440] = {
    [sym_line_comment] = STATE(440),
    [sym_block_comment] = STATE(440),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(3019),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2939),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_static] = ACTIONS(2941),
    [anon_sym_volatile] = ACTIONS(2943),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [441] = {
    [sym_line_comment] = STATE(441),
    [sym_block_comment] = STATE(441),
    [ts_builtin_sym_end] = ACTIONS(2945),
    [sym_identifier] = ACTIONS(2947),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_CR] = ACTIONS(2947),
    [anon_sym_CR_LF] = ACTIONS(2947),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2947),
    [anon_sym_as] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_COMMA] = ACTIONS(2947),
    [anon_sym_const] = ACTIONS(2947),
    [anon_sym_LPAREN] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(2947),
    [anon_sym___global] = ACTIONS(2947),
    [anon_sym_type] = ACTIONS(2947),
    [anon_sym_fn] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_STAR] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(2947),
    [anon_sym_PERCENT] = ACTIONS(2947),
    [anon_sym_LT] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2947),
    [anon_sym_EQ_EQ] = ACTIONS(2947),
    [anon_sym_BANG_EQ] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2947),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2945),
    [anon_sym_struct] = ACTIONS(2947),
    [anon_sym_union] = ACTIONS(2947),
    [anon_sym_pub] = ACTIONS(2947),
    [anon_sym_mut] = ACTIONS(2947),
    [anon_sym_enum] = ACTIONS(2947),
    [anon_sym_interface] = ACTIONS(2947),
    [anon_sym_PLUS_PLUS] = ACTIONS(2947),
    [anon_sym_DASH_DASH] = ACTIONS(2947),
    [anon_sym_QMARK] = ACTIONS(2947),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_go] = ACTIONS(2947),
    [anon_sym_spawn] = ACTIONS(2947),
    [anon_sym_json_DOTdecode] = ACTIONS(2947),
    [anon_sym_PIPE] = ACTIONS(2947),
    [anon_sym_LBRACK2] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2947),
    [anon_sym_CARET] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2947),
    [anon_sym_LT_DASH] = ACTIONS(2947),
    [anon_sym_LT_LT] = ACTIONS(2947),
    [anon_sym_GT_GT] = ACTIONS(2947),
    [anon_sym_GT_GT_GT] = ACTIONS(2947),
    [anon_sym_AMP_CARET] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [anon_sym_or] = ACTIONS(2947),
    [sym_none] = ACTIONS(2947),
    [sym_true] = ACTIONS(2947),
    [sym_false] = ACTIONS(2947),
    [sym_nil] = ACTIONS(2947),
    [anon_sym_QMARK_DOT] = ACTIONS(2947),
    [anon_sym_POUND_LBRACK] = ACTIONS(2947),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_DOLLARif] = ACTIONS(2947),
    [anon_sym_is] = ACTIONS(2947),
    [anon_sym_BANGis] = ACTIONS(2947),
    [anon_sym_in] = ACTIONS(2947),
    [anon_sym_BANGin] = ACTIONS(2947),
    [anon_sym_match] = ACTIONS(2947),
    [anon_sym_select] = ACTIONS(2947),
    [anon_sym_STAR_EQ] = ACTIONS(2947),
    [anon_sym_SLASH_EQ] = ACTIONS(2947),
    [anon_sym_PERCENT_EQ] = ACTIONS(2947),
    [anon_sym_LT_LT_EQ] = ACTIONS(2947),
    [anon_sym_GT_GT_EQ] = ACTIONS(2947),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2947),
    [anon_sym_AMP_EQ] = ACTIONS(2947),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2947),
    [anon_sym_PLUS_EQ] = ACTIONS(2947),
    [anon_sym_DASH_EQ] = ACTIONS(2947),
    [anon_sym_PIPE_EQ] = ACTIONS(2947),
    [anon_sym_CARET_EQ] = ACTIONS(2947),
    [anon_sym_COLON_EQ] = ACTIONS(2947),
    [anon_sym_lock] = ACTIONS(2947),
    [anon_sym_rlock] = ACTIONS(2947),
    [anon_sym_unsafe] = ACTIONS(2947),
    [anon_sym_sql] = ACTIONS(2947),
    [sym_int_literal] = ACTIONS(2947),
    [sym_float_literal] = ACTIONS(2947),
    [sym_rune_literal] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(2947),
    [anon_sym_DQUOTE] = ACTIONS(2947),
    [anon_sym_c_SQUOTE] = ACTIONS(2947),
    [anon_sym_c_DQUOTE] = ACTIONS(2947),
    [anon_sym_r_SQUOTE] = ACTIONS(2947),
    [anon_sym_r_DQUOTE] = ACTIONS(2947),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2947),
    [anon_sym_shared] = ACTIONS(2947),
    [anon_sym_map_LBRACK] = ACTIONS(2947),
    [anon_sym_chan] = ACTIONS(2947),
    [anon_sym_thread] = ACTIONS(2947),
    [anon_sym_atomic] = ACTIONS(2947),
    [anon_sym_assert] = ACTIONS(2947),
    [anon_sym_defer] = ACTIONS(2947),
    [anon_sym_goto] = ACTIONS(2947),
    [anon_sym_break] = ACTIONS(2947),
    [anon_sym_continue] = ACTIONS(2947),
    [anon_sym_return] = ACTIONS(2947),
    [anon_sym_DOLLARfor] = ACTIONS(2947),
    [anon_sym_for] = ACTIONS(2947),
    [anon_sym_POUND] = ACTIONS(2947),
    [anon_sym_asm] = ACTIONS(2947),
    [anon_sym_AT_LBRACK] = ACTIONS(2947),
  },
  [442] = {
    [sym_line_comment] = STATE(442),
    [sym_block_comment] = STATE(442),
    [ts_builtin_sym_end] = ACTIONS(2185),
    [sym_identifier] = ACTIONS(2187),
    [anon_sym_LF] = ACTIONS(2187),
    [anon_sym_CR] = ACTIONS(2187),
    [anon_sym_CR_LF] = ACTIONS(2187),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2187),
    [anon_sym_as] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_const] = ACTIONS(2187),
    [anon_sym_LPAREN] = ACTIONS(2187),
    [anon_sym_EQ] = ACTIONS(2187),
    [anon_sym___global] = ACTIONS(2187),
    [anon_sym_type] = ACTIONS(2187),
    [anon_sym_fn] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [anon_sym_LT] = ACTIONS(2187),
    [anon_sym_GT] = ACTIONS(2187),
    [anon_sym_EQ_EQ] = ACTIONS(2187),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2187),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2185),
    [anon_sym_struct] = ACTIONS(2187),
    [anon_sym_union] = ACTIONS(2187),
    [anon_sym_pub] = ACTIONS(2187),
    [anon_sym_mut] = ACTIONS(2187),
    [anon_sym_enum] = ACTIONS(2187),
    [anon_sym_interface] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_go] = ACTIONS(2187),
    [anon_sym_spawn] = ACTIONS(2187),
    [anon_sym_json_DOTdecode] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2187),
    [anon_sym_LBRACK2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_LT_DASH] = ACTIONS(2187),
    [anon_sym_LT_LT] = ACTIONS(2187),
    [anon_sym_GT_GT] = ACTIONS(2187),
    [anon_sym_GT_GT_GT] = ACTIONS(2187),
    [anon_sym_AMP_CARET] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2187),
    [sym_none] = ACTIONS(2187),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [sym_nil] = ACTIONS(2187),
    [anon_sym_QMARK_DOT] = ACTIONS(2187),
    [anon_sym_POUND_LBRACK] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_DOLLARif] = ACTIONS(2187),
    [anon_sym_is] = ACTIONS(2187),
    [anon_sym_BANGis] = ACTIONS(2187),
    [anon_sym_in] = ACTIONS(2187),
    [anon_sym_BANGin] = ACTIONS(2187),
    [anon_sym_match] = ACTIONS(2187),
    [anon_sym_select] = ACTIONS(2187),
    [anon_sym_STAR_EQ] = ACTIONS(2187),
    [anon_sym_SLASH_EQ] = ACTIONS(2187),
    [anon_sym_PERCENT_EQ] = ACTIONS(2187),
    [anon_sym_LT_LT_EQ] = ACTIONS(2187),
    [anon_sym_GT_GT_EQ] = ACTIONS(2187),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2187),
    [anon_sym_AMP_EQ] = ACTIONS(2187),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2187),
    [anon_sym_PLUS_EQ] = ACTIONS(2187),
    [anon_sym_DASH_EQ] = ACTIONS(2187),
    [anon_sym_PIPE_EQ] = ACTIONS(2187),
    [anon_sym_CARET_EQ] = ACTIONS(2187),
    [anon_sym_COLON_EQ] = ACTIONS(2187),
    [anon_sym_lock] = ACTIONS(2187),
    [anon_sym_rlock] = ACTIONS(2187),
    [anon_sym_unsafe] = ACTIONS(2187),
    [anon_sym_sql] = ACTIONS(2187),
    [sym_int_literal] = ACTIONS(2187),
    [sym_float_literal] = ACTIONS(2187),
    [sym_rune_literal] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(2187),
    [anon_sym_DQUOTE] = ACTIONS(2187),
    [anon_sym_c_SQUOTE] = ACTIONS(2187),
    [anon_sym_c_DQUOTE] = ACTIONS(2187),
    [anon_sym_r_SQUOTE] = ACTIONS(2187),
    [anon_sym_r_DQUOTE] = ACTIONS(2187),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2187),
    [anon_sym_shared] = ACTIONS(2187),
    [anon_sym_map_LBRACK] = ACTIONS(2187),
    [anon_sym_chan] = ACTIONS(2187),
    [anon_sym_thread] = ACTIONS(2187),
    [anon_sym_atomic] = ACTIONS(2187),
    [anon_sym_assert] = ACTIONS(2187),
    [anon_sym_defer] = ACTIONS(2187),
    [anon_sym_goto] = ACTIONS(2187),
    [anon_sym_break] = ACTIONS(2187),
    [anon_sym_continue] = ACTIONS(2187),
    [anon_sym_return] = ACTIONS(2187),
    [anon_sym_DOLLARfor] = ACTIONS(2187),
    [anon_sym_for] = ACTIONS(2187),
    [anon_sym_POUND] = ACTIONS(2187),
    [anon_sym_asm] = ACTIONS(2187),
    [anon_sym_AT_LBRACK] = ACTIONS(2187),
  },
  [443] = {
    [sym_line_comment] = STATE(443),
    [sym_block_comment] = STATE(443),
    [ts_builtin_sym_end] = ACTIONS(2949),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_LF] = ACTIONS(2951),
    [anon_sym_CR] = ACTIONS(2951),
    [anon_sym_CR_LF] = ACTIONS(2951),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2951),
    [anon_sym_as] = ACTIONS(2951),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2951),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_EQ] = ACTIONS(2951),
    [anon_sym___global] = ACTIONS(2951),
    [anon_sym_type] = ACTIONS(2951),
    [anon_sym_fn] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_LT] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2949),
    [anon_sym_struct] = ACTIONS(2951),
    [anon_sym_union] = ACTIONS(2951),
    [anon_sym_pub] = ACTIONS(2951),
    [anon_sym_mut] = ACTIONS(2951),
    [anon_sym_enum] = ACTIONS(2951),
    [anon_sym_interface] = ACTIONS(2951),
    [anon_sym_PLUS_PLUS] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2951),
    [anon_sym_QMARK] = ACTIONS(2951),
    [anon_sym_BANG] = ACTIONS(2951),
    [anon_sym_go] = ACTIONS(2951),
    [anon_sym_spawn] = ACTIONS(2951),
    [anon_sym_json_DOTdecode] = ACTIONS(2951),
    [anon_sym_PIPE] = ACTIONS(2951),
    [anon_sym_LBRACK2] = ACTIONS(2951),
    [anon_sym_TILDE] = ACTIONS(2951),
    [anon_sym_CARET] = ACTIONS(2951),
    [anon_sym_AMP] = ACTIONS(2951),
    [anon_sym_LT_DASH] = ACTIONS(2951),
    [anon_sym_LT_LT] = ACTIONS(2951),
    [anon_sym_GT_GT] = ACTIONS(2951),
    [anon_sym_GT_GT_GT] = ACTIONS(2951),
    [anon_sym_AMP_CARET] = ACTIONS(2951),
    [anon_sym_AMP_AMP] = ACTIONS(2951),
    [anon_sym_PIPE_PIPE] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [sym_none] = ACTIONS(2951),
    [sym_true] = ACTIONS(2951),
    [sym_false] = ACTIONS(2951),
    [sym_nil] = ACTIONS(2951),
    [anon_sym_QMARK_DOT] = ACTIONS(2951),
    [anon_sym_POUND_LBRACK] = ACTIONS(2951),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_DOLLARif] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_BANGis] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_BANGin] = ACTIONS(2951),
    [anon_sym_match] = ACTIONS(2951),
    [anon_sym_select] = ACTIONS(2951),
    [anon_sym_STAR_EQ] = ACTIONS(2951),
    [anon_sym_SLASH_EQ] = ACTIONS(2951),
    [anon_sym_PERCENT_EQ] = ACTIONS(2951),
    [anon_sym_LT_LT_EQ] = ACTIONS(2951),
    [anon_sym_GT_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2951),
    [anon_sym_AMP_EQ] = ACTIONS(2951),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2951),
    [anon_sym_PLUS_EQ] = ACTIONS(2951),
    [anon_sym_DASH_EQ] = ACTIONS(2951),
    [anon_sym_PIPE_EQ] = ACTIONS(2951),
    [anon_sym_CARET_EQ] = ACTIONS(2951),
    [anon_sym_COLON_EQ] = ACTIONS(2951),
    [anon_sym_lock] = ACTIONS(2951),
    [anon_sym_rlock] = ACTIONS(2951),
    [anon_sym_unsafe] = ACTIONS(2951),
    [anon_sym_sql] = ACTIONS(2951),
    [sym_int_literal] = ACTIONS(2951),
    [sym_float_literal] = ACTIONS(2951),
    [sym_rune_literal] = ACTIONS(2951),
    [anon_sym_SQUOTE] = ACTIONS(2951),
    [anon_sym_DQUOTE] = ACTIONS(2951),
    [anon_sym_c_SQUOTE] = ACTIONS(2951),
    [anon_sym_c_DQUOTE] = ACTIONS(2951),
    [anon_sym_r_SQUOTE] = ACTIONS(2951),
    [anon_sym_r_DQUOTE] = ACTIONS(2951),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2951),
    [anon_sym_shared] = ACTIONS(2951),
    [anon_sym_map_LBRACK] = ACTIONS(2951),
    [anon_sym_chan] = ACTIONS(2951),
    [anon_sym_thread] = ACTIONS(2951),
    [anon_sym_atomic] = ACTIONS(2951),
    [anon_sym_assert] = ACTIONS(2951),
    [anon_sym_defer] = ACTIONS(2951),
    [anon_sym_goto] = ACTIONS(2951),
    [anon_sym_break] = ACTIONS(2951),
    [anon_sym_continue] = ACTIONS(2951),
    [anon_sym_return] = ACTIONS(2951),
    [anon_sym_DOLLARfor] = ACTIONS(2951),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_POUND] = ACTIONS(2951),
    [anon_sym_asm] = ACTIONS(2951),
    [anon_sym_AT_LBRACK] = ACTIONS(2951),
  },
  [444] = {
    [sym_line_comment] = STATE(444),
    [sym_block_comment] = STATE(444),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1693),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1692),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(464),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(2953),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1615),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [445] = {
    [sym_line_comment] = STATE(445),
    [sym_block_comment] = STATE(445),
    [ts_builtin_sym_end] = ACTIONS(2145),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_CR] = ACTIONS(2147),
    [anon_sym_CR_LF] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_COMMA] = ACTIONS(2147),
    [anon_sym_const] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym_EQ] = ACTIONS(2147),
    [anon_sym___global] = ACTIONS(2147),
    [anon_sym_type] = ACTIONS(2147),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2147),
    [anon_sym_BANG_EQ] = ACTIONS(2147),
    [anon_sym_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2147),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_union] = ACTIONS(2147),
    [anon_sym_pub] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_enum] = ACTIONS(2147),
    [anon_sym_interface] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2147),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2147),
    [anon_sym_AMP_CARET] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [anon_sym_or] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2147),
    [anon_sym_POUND_LBRACK] = ACTIONS(2147),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2147),
    [anon_sym_BANGis] = ACTIONS(2147),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANGin] = ACTIONS(2147),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_STAR_EQ] = ACTIONS(2147),
    [anon_sym_SLASH_EQ] = ACTIONS(2147),
    [anon_sym_PERCENT_EQ] = ACTIONS(2147),
    [anon_sym_LT_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_GT_EQ] = ACTIONS(2147),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2147),
    [anon_sym_AMP_EQ] = ACTIONS(2147),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2147),
    [anon_sym_PLUS_EQ] = ACTIONS(2147),
    [anon_sym_DASH_EQ] = ACTIONS(2147),
    [anon_sym_PIPE_EQ] = ACTIONS(2147),
    [anon_sym_CARET_EQ] = ACTIONS(2147),
    [anon_sym_COLON_EQ] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2147),
    [sym_rune_literal] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_c_SQUOTE] = ACTIONS(2147),
    [anon_sym_c_DQUOTE] = ACTIONS(2147),
    [anon_sym_r_SQUOTE] = ACTIONS(2147),
    [anon_sym_r_DQUOTE] = ACTIONS(2147),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2147),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
    [anon_sym_assert] = ACTIONS(2147),
    [anon_sym_defer] = ACTIONS(2147),
    [anon_sym_goto] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_continue] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2147),
    [anon_sym_DOLLARfor] = ACTIONS(2147),
    [anon_sym_for] = ACTIONS(2147),
    [anon_sym_POUND] = ACTIONS(2147),
    [anon_sym_asm] = ACTIONS(2147),
    [anon_sym_AT_LBRACK] = ACTIONS(2147),
  },
  [446] = {
    [sym_line_comment] = STATE(446),
    [sym_block_comment] = STATE(446),
    [ts_builtin_sym_end] = ACTIONS(2955),
    [sym_identifier] = ACTIONS(2957),
    [anon_sym_LF] = ACTIONS(2957),
    [anon_sym_CR] = ACTIONS(2957),
    [anon_sym_CR_LF] = ACTIONS(2957),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2957),
    [anon_sym_as] = ACTIONS(2957),
    [anon_sym_LBRACE] = ACTIONS(2957),
    [anon_sym_COMMA] = ACTIONS(2957),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_LPAREN] = ACTIONS(2957),
    [anon_sym_EQ] = ACTIONS(2957),
    [anon_sym___global] = ACTIONS(2957),
    [anon_sym_type] = ACTIONS(2957),
    [anon_sym_fn] = ACTIONS(2957),
    [anon_sym_PLUS] = ACTIONS(2957),
    [anon_sym_DASH] = ACTIONS(2957),
    [anon_sym_STAR] = ACTIONS(2957),
    [anon_sym_SLASH] = ACTIONS(2957),
    [anon_sym_PERCENT] = ACTIONS(2957),
    [anon_sym_LT] = ACTIONS(2957),
    [anon_sym_GT] = ACTIONS(2957),
    [anon_sym_EQ_EQ] = ACTIONS(2957),
    [anon_sym_BANG_EQ] = ACTIONS(2957),
    [anon_sym_LT_EQ] = ACTIONS(2957),
    [anon_sym_GT_EQ] = ACTIONS(2957),
    [anon_sym_LBRACK] = ACTIONS(2955),
    [anon_sym_struct] = ACTIONS(2957),
    [anon_sym_union] = ACTIONS(2957),
    [anon_sym_pub] = ACTIONS(2957),
    [anon_sym_mut] = ACTIONS(2957),
    [anon_sym_enum] = ACTIONS(2957),
    [anon_sym_interface] = ACTIONS(2957),
    [anon_sym_PLUS_PLUS] = ACTIONS(2957),
    [anon_sym_DASH_DASH] = ACTIONS(2957),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_BANG] = ACTIONS(2957),
    [anon_sym_go] = ACTIONS(2957),
    [anon_sym_spawn] = ACTIONS(2957),
    [anon_sym_json_DOTdecode] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2957),
    [anon_sym_LBRACK2] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2957),
    [anon_sym_CARET] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2957),
    [anon_sym_LT_DASH] = ACTIONS(2957),
    [anon_sym_LT_LT] = ACTIONS(2957),
    [anon_sym_GT_GT] = ACTIONS(2957),
    [anon_sym_GT_GT_GT] = ACTIONS(2957),
    [anon_sym_AMP_CARET] = ACTIONS(2957),
    [anon_sym_AMP_AMP] = ACTIONS(2957),
    [anon_sym_PIPE_PIPE] = ACTIONS(2957),
    [anon_sym_or] = ACTIONS(2957),
    [sym_none] = ACTIONS(2957),
    [sym_true] = ACTIONS(2957),
    [sym_false] = ACTIONS(2957),
    [sym_nil] = ACTIONS(2957),
    [anon_sym_QMARK_DOT] = ACTIONS(2957),
    [anon_sym_POUND_LBRACK] = ACTIONS(2957),
    [anon_sym_if] = ACTIONS(2957),
    [anon_sym_DOLLARif] = ACTIONS(2957),
    [anon_sym_is] = ACTIONS(2957),
    [anon_sym_BANGis] = ACTIONS(2957),
    [anon_sym_in] = ACTIONS(2957),
    [anon_sym_BANGin] = ACTIONS(2957),
    [anon_sym_match] = ACTIONS(2957),
    [anon_sym_select] = ACTIONS(2957),
    [anon_sym_STAR_EQ] = ACTIONS(2957),
    [anon_sym_SLASH_EQ] = ACTIONS(2957),
    [anon_sym_PERCENT_EQ] = ACTIONS(2957),
    [anon_sym_LT_LT_EQ] = ACTIONS(2957),
    [anon_sym_GT_GT_EQ] = ACTIONS(2957),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2957),
    [anon_sym_AMP_EQ] = ACTIONS(2957),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2957),
    [anon_sym_PLUS_EQ] = ACTIONS(2957),
    [anon_sym_DASH_EQ] = ACTIONS(2957),
    [anon_sym_PIPE_EQ] = ACTIONS(2957),
    [anon_sym_CARET_EQ] = ACTIONS(2957),
    [anon_sym_COLON_EQ] = ACTIONS(2957),
    [anon_sym_lock] = ACTIONS(2957),
    [anon_sym_rlock] = ACTIONS(2957),
    [anon_sym_unsafe] = ACTIONS(2957),
    [anon_sym_sql] = ACTIONS(2957),
    [sym_int_literal] = ACTIONS(2957),
    [sym_float_literal] = ACTIONS(2957),
    [sym_rune_literal] = ACTIONS(2957),
    [anon_sym_SQUOTE] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(2957),
    [anon_sym_c_SQUOTE] = ACTIONS(2957),
    [anon_sym_c_DQUOTE] = ACTIONS(2957),
    [anon_sym_r_SQUOTE] = ACTIONS(2957),
    [anon_sym_r_DQUOTE] = ACTIONS(2957),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2957),
    [anon_sym_shared] = ACTIONS(2957),
    [anon_sym_map_LBRACK] = ACTIONS(2957),
    [anon_sym_chan] = ACTIONS(2957),
    [anon_sym_thread] = ACTIONS(2957),
    [anon_sym_atomic] = ACTIONS(2957),
    [anon_sym_assert] = ACTIONS(2957),
    [anon_sym_defer] = ACTIONS(2957),
    [anon_sym_goto] = ACTIONS(2957),
    [anon_sym_break] = ACTIONS(2957),
    [anon_sym_continue] = ACTIONS(2957),
    [anon_sym_return] = ACTIONS(2957),
    [anon_sym_DOLLARfor] = ACTIONS(2957),
    [anon_sym_for] = ACTIONS(2957),
    [anon_sym_POUND] = ACTIONS(2957),
    [anon_sym_asm] = ACTIONS(2957),
    [anon_sym_AT_LBRACK] = ACTIONS(2957),
  },
  [447] = {
    [sym_line_comment] = STATE(447),
    [sym_block_comment] = STATE(447),
    [ts_builtin_sym_end] = ACTIONS(2959),
    [sym_identifier] = ACTIONS(2961),
    [anon_sym_LF] = ACTIONS(2961),
    [anon_sym_CR] = ACTIONS(2961),
    [anon_sym_CR_LF] = ACTIONS(2961),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2961),
    [anon_sym_as] = ACTIONS(2961),
    [anon_sym_LBRACE] = ACTIONS(2961),
    [anon_sym_COMMA] = ACTIONS(2961),
    [anon_sym_const] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(2961),
    [anon_sym_EQ] = ACTIONS(2961),
    [anon_sym___global] = ACTIONS(2961),
    [anon_sym_type] = ACTIONS(2961),
    [anon_sym_fn] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2961),
    [anon_sym_DASH] = ACTIONS(2961),
    [anon_sym_STAR] = ACTIONS(2961),
    [anon_sym_SLASH] = ACTIONS(2961),
    [anon_sym_PERCENT] = ACTIONS(2961),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_GT] = ACTIONS(2961),
    [anon_sym_EQ_EQ] = ACTIONS(2961),
    [anon_sym_BANG_EQ] = ACTIONS(2961),
    [anon_sym_LT_EQ] = ACTIONS(2961),
    [anon_sym_GT_EQ] = ACTIONS(2961),
    [anon_sym_LBRACK] = ACTIONS(2959),
    [anon_sym_struct] = ACTIONS(2961),
    [anon_sym_union] = ACTIONS(2961),
    [anon_sym_pub] = ACTIONS(2961),
    [anon_sym_mut] = ACTIONS(2961),
    [anon_sym_enum] = ACTIONS(2961),
    [anon_sym_interface] = ACTIONS(2961),
    [anon_sym_PLUS_PLUS] = ACTIONS(2961),
    [anon_sym_DASH_DASH] = ACTIONS(2961),
    [anon_sym_QMARK] = ACTIONS(2961),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_go] = ACTIONS(2961),
    [anon_sym_spawn] = ACTIONS(2961),
    [anon_sym_json_DOTdecode] = ACTIONS(2961),
    [anon_sym_PIPE] = ACTIONS(2961),
    [anon_sym_LBRACK2] = ACTIONS(2961),
    [anon_sym_TILDE] = ACTIONS(2961),
    [anon_sym_CARET] = ACTIONS(2961),
    [anon_sym_AMP] = ACTIONS(2961),
    [anon_sym_LT_DASH] = ACTIONS(2961),
    [anon_sym_LT_LT] = ACTIONS(2961),
    [anon_sym_GT_GT] = ACTIONS(2961),
    [anon_sym_GT_GT_GT] = ACTIONS(2961),
    [anon_sym_AMP_CARET] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2961),
    [anon_sym_PIPE_PIPE] = ACTIONS(2961),
    [anon_sym_or] = ACTIONS(2961),
    [sym_none] = ACTIONS(2961),
    [sym_true] = ACTIONS(2961),
    [sym_false] = ACTIONS(2961),
    [sym_nil] = ACTIONS(2961),
    [anon_sym_QMARK_DOT] = ACTIONS(2961),
    [anon_sym_POUND_LBRACK] = ACTIONS(2961),
    [anon_sym_if] = ACTIONS(2961),
    [anon_sym_DOLLARif] = ACTIONS(2961),
    [anon_sym_is] = ACTIONS(2961),
    [anon_sym_BANGis] = ACTIONS(2961),
    [anon_sym_in] = ACTIONS(2961),
    [anon_sym_BANGin] = ACTIONS(2961),
    [anon_sym_match] = ACTIONS(2961),
    [anon_sym_select] = ACTIONS(2961),
    [anon_sym_STAR_EQ] = ACTIONS(2961),
    [anon_sym_SLASH_EQ] = ACTIONS(2961),
    [anon_sym_PERCENT_EQ] = ACTIONS(2961),
    [anon_sym_LT_LT_EQ] = ACTIONS(2961),
    [anon_sym_GT_GT_EQ] = ACTIONS(2961),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2961),
    [anon_sym_AMP_EQ] = ACTIONS(2961),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2961),
    [anon_sym_PLUS_EQ] = ACTIONS(2961),
    [anon_sym_DASH_EQ] = ACTIONS(2961),
    [anon_sym_PIPE_EQ] = ACTIONS(2961),
    [anon_sym_CARET_EQ] = ACTIONS(2961),
    [anon_sym_COLON_EQ] = ACTIONS(2961),
    [anon_sym_lock] = ACTIONS(2961),
    [anon_sym_rlock] = ACTIONS(2961),
    [anon_sym_unsafe] = ACTIONS(2961),
    [anon_sym_sql] = ACTIONS(2961),
    [sym_int_literal] = ACTIONS(2961),
    [sym_float_literal] = ACTIONS(2961),
    [sym_rune_literal] = ACTIONS(2961),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_DQUOTE] = ACTIONS(2961),
    [anon_sym_c_SQUOTE] = ACTIONS(2961),
    [anon_sym_c_DQUOTE] = ACTIONS(2961),
    [anon_sym_r_SQUOTE] = ACTIONS(2961),
    [anon_sym_r_DQUOTE] = ACTIONS(2961),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2961),
    [anon_sym_shared] = ACTIONS(2961),
    [anon_sym_map_LBRACK] = ACTIONS(2961),
    [anon_sym_chan] = ACTIONS(2961),
    [anon_sym_thread] = ACTIONS(2961),
    [anon_sym_atomic] = ACTIONS(2961),
    [anon_sym_assert] = ACTIONS(2961),
    [anon_sym_defer] = ACTIONS(2961),
    [anon_sym_goto] = ACTIONS(2961),
    [anon_sym_break] = ACTIONS(2961),
    [anon_sym_continue] = ACTIONS(2961),
    [anon_sym_return] = ACTIONS(2961),
    [anon_sym_DOLLARfor] = ACTIONS(2961),
    [anon_sym_for] = ACTIONS(2961),
    [anon_sym_POUND] = ACTIONS(2961),
    [anon_sym_asm] = ACTIONS(2961),
    [anon_sym_AT_LBRACK] = ACTIONS(2961),
  },
  [448] = {
    [sym_line_comment] = STATE(448),
    [sym_block_comment] = STATE(448),
    [ts_builtin_sym_end] = ACTIONS(2448),
    [sym_identifier] = ACTIONS(2445),
    [anon_sym_LF] = ACTIONS(2445),
    [anon_sym_CR] = ACTIONS(2445),
    [anon_sym_CR_LF] = ACTIONS(2445),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2445),
    [anon_sym_as] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(2445),
    [anon_sym_COMMA] = ACTIONS(2445),
    [anon_sym_const] = ACTIONS(2445),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym_EQ] = ACTIONS(2445),
    [anon_sym___global] = ACTIONS(2445),
    [anon_sym_type] = ACTIONS(2445),
    [anon_sym_fn] = ACTIONS(2445),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2445),
    [anon_sym_STAR] = ACTIONS(2445),
    [anon_sym_SLASH] = ACTIONS(2445),
    [anon_sym_PERCENT] = ACTIONS(2445),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_GT] = ACTIONS(2445),
    [anon_sym_EQ_EQ] = ACTIONS(2445),
    [anon_sym_BANG_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_struct] = ACTIONS(2445),
    [anon_sym_union] = ACTIONS(2445),
    [anon_sym_pub] = ACTIONS(2445),
    [anon_sym_mut] = ACTIONS(2445),
    [anon_sym_enum] = ACTIONS(2445),
    [anon_sym_interface] = ACTIONS(2445),
    [anon_sym_PLUS_PLUS] = ACTIONS(2445),
    [anon_sym_DASH_DASH] = ACTIONS(2445),
    [anon_sym_QMARK] = ACTIONS(2445),
    [anon_sym_BANG] = ACTIONS(2445),
    [anon_sym_go] = ACTIONS(2445),
    [anon_sym_spawn] = ACTIONS(2445),
    [anon_sym_json_DOTdecode] = ACTIONS(2445),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_LBRACK2] = ACTIONS(2445),
    [anon_sym_TILDE] = ACTIONS(2445),
    [anon_sym_CARET] = ACTIONS(2445),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_LT_DASH] = ACTIONS(2445),
    [anon_sym_LT_LT] = ACTIONS(2445),
    [anon_sym_GT_GT] = ACTIONS(2445),
    [anon_sym_GT_GT_GT] = ACTIONS(2445),
    [anon_sym_AMP_CARET] = ACTIONS(2445),
    [anon_sym_AMP_AMP] = ACTIONS(2445),
    [anon_sym_PIPE_PIPE] = ACTIONS(2445),
    [anon_sym_or] = ACTIONS(2445),
    [sym_none] = ACTIONS(2445),
    [sym_true] = ACTIONS(2445),
    [sym_false] = ACTIONS(2445),
    [sym_nil] = ACTIONS(2445),
    [anon_sym_QMARK_DOT] = ACTIONS(2445),
    [anon_sym_POUND_LBRACK] = ACTIONS(2445),
    [anon_sym_if] = ACTIONS(2445),
    [anon_sym_DOLLARif] = ACTIONS(2445),
    [anon_sym_is] = ACTIONS(2445),
    [anon_sym_BANGis] = ACTIONS(2445),
    [anon_sym_in] = ACTIONS(2445),
    [anon_sym_BANGin] = ACTIONS(2445),
    [anon_sym_match] = ACTIONS(2445),
    [anon_sym_select] = ACTIONS(2445),
    [anon_sym_STAR_EQ] = ACTIONS(2445),
    [anon_sym_SLASH_EQ] = ACTIONS(2445),
    [anon_sym_PERCENT_EQ] = ACTIONS(2445),
    [anon_sym_LT_LT_EQ] = ACTIONS(2445),
    [anon_sym_GT_GT_EQ] = ACTIONS(2445),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2445),
    [anon_sym_AMP_EQ] = ACTIONS(2445),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2445),
    [anon_sym_PLUS_EQ] = ACTIONS(2445),
    [anon_sym_DASH_EQ] = ACTIONS(2445),
    [anon_sym_PIPE_EQ] = ACTIONS(2445),
    [anon_sym_CARET_EQ] = ACTIONS(2445),
    [anon_sym_COLON_EQ] = ACTIONS(2445),
    [anon_sym_lock] = ACTIONS(2445),
    [anon_sym_rlock] = ACTIONS(2445),
    [anon_sym_unsafe] = ACTIONS(2445),
    [anon_sym_sql] = ACTIONS(2445),
    [sym_int_literal] = ACTIONS(2445),
    [sym_float_literal] = ACTIONS(2445),
    [sym_rune_literal] = ACTIONS(2445),
    [anon_sym_SQUOTE] = ACTIONS(2445),
    [anon_sym_DQUOTE] = ACTIONS(2445),
    [anon_sym_c_SQUOTE] = ACTIONS(2445),
    [anon_sym_c_DQUOTE] = ACTIONS(2445),
    [anon_sym_r_SQUOTE] = ACTIONS(2445),
    [anon_sym_r_DQUOTE] = ACTIONS(2445),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2445),
    [anon_sym_shared] = ACTIONS(2445),
    [anon_sym_map_LBRACK] = ACTIONS(2445),
    [anon_sym_chan] = ACTIONS(2445),
    [anon_sym_thread] = ACTIONS(2445),
    [anon_sym_atomic] = ACTIONS(2445),
    [anon_sym_assert] = ACTIONS(2445),
    [anon_sym_defer] = ACTIONS(2445),
    [anon_sym_goto] = ACTIONS(2445),
    [anon_sym_break] = ACTIONS(2445),
    [anon_sym_continue] = ACTIONS(2445),
    [anon_sym_return] = ACTIONS(2445),
    [anon_sym_DOLLARfor] = ACTIONS(2445),
    [anon_sym_for] = ACTIONS(2445),
    [anon_sym_POUND] = ACTIONS(2445),
    [anon_sym_asm] = ACTIONS(2445),
    [anon_sym_AT_LBRACK] = ACTIONS(2445),
  },
  [449] = {
    [sym_line_comment] = STATE(449),
    [sym_block_comment] = STATE(449),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(402),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(2963),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [450] = {
    [sym_line_comment] = STATE(450),
    [sym_block_comment] = STATE(450),
    [ts_builtin_sym_end] = ACTIONS(2965),
    [sym_identifier] = ACTIONS(2967),
    [anon_sym_LF] = ACTIONS(2967),
    [anon_sym_CR] = ACTIONS(2967),
    [anon_sym_CR_LF] = ACTIONS(2967),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2967),
    [anon_sym_as] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2967),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(2967),
    [anon_sym_EQ] = ACTIONS(2967),
    [anon_sym___global] = ACTIONS(2967),
    [anon_sym_type] = ACTIONS(2967),
    [anon_sym_fn] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2967),
    [anon_sym_SLASH] = ACTIONS(2967),
    [anon_sym_PERCENT] = ACTIONS(2967),
    [anon_sym_LT] = ACTIONS(2967),
    [anon_sym_GT] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2967),
    [anon_sym_BANG_EQ] = ACTIONS(2967),
    [anon_sym_LT_EQ] = ACTIONS(2967),
    [anon_sym_GT_EQ] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2965),
    [anon_sym_struct] = ACTIONS(2967),
    [anon_sym_union] = ACTIONS(2967),
    [anon_sym_pub] = ACTIONS(2967),
    [anon_sym_mut] = ACTIONS(2967),
    [anon_sym_enum] = ACTIONS(2967),
    [anon_sym_interface] = ACTIONS(2967),
    [anon_sym_PLUS_PLUS] = ACTIONS(2967),
    [anon_sym_DASH_DASH] = ACTIONS(2967),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_BANG] = ACTIONS(2967),
    [anon_sym_go] = ACTIONS(2967),
    [anon_sym_spawn] = ACTIONS(2967),
    [anon_sym_json_DOTdecode] = ACTIONS(2967),
    [anon_sym_PIPE] = ACTIONS(2967),
    [anon_sym_LBRACK2] = ACTIONS(2967),
    [anon_sym_TILDE] = ACTIONS(2967),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_AMP] = ACTIONS(2967),
    [anon_sym_LT_DASH] = ACTIONS(2967),
    [anon_sym_LT_LT] = ACTIONS(2967),
    [anon_sym_GT_GT] = ACTIONS(2967),
    [anon_sym_GT_GT_GT] = ACTIONS(2967),
    [anon_sym_AMP_CARET] = ACTIONS(2967),
    [anon_sym_AMP_AMP] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE] = ACTIONS(2967),
    [anon_sym_or] = ACTIONS(2967),
    [sym_none] = ACTIONS(2967),
    [sym_true] = ACTIONS(2967),
    [sym_false] = ACTIONS(2967),
    [sym_nil] = ACTIONS(2967),
    [anon_sym_QMARK_DOT] = ACTIONS(2967),
    [anon_sym_POUND_LBRACK] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_DOLLARif] = ACTIONS(2967),
    [anon_sym_is] = ACTIONS(2967),
    [anon_sym_BANGis] = ACTIONS(2967),
    [anon_sym_in] = ACTIONS(2967),
    [anon_sym_BANGin] = ACTIONS(2967),
    [anon_sym_match] = ACTIONS(2967),
    [anon_sym_select] = ACTIONS(2967),
    [anon_sym_STAR_EQ] = ACTIONS(2967),
    [anon_sym_SLASH_EQ] = ACTIONS(2967),
    [anon_sym_PERCENT_EQ] = ACTIONS(2967),
    [anon_sym_LT_LT_EQ] = ACTIONS(2967),
    [anon_sym_GT_GT_EQ] = ACTIONS(2967),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2967),
    [anon_sym_AMP_EQ] = ACTIONS(2967),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2967),
    [anon_sym_PLUS_EQ] = ACTIONS(2967),
    [anon_sym_DASH_EQ] = ACTIONS(2967),
    [anon_sym_PIPE_EQ] = ACTIONS(2967),
    [anon_sym_CARET_EQ] = ACTIONS(2967),
    [anon_sym_COLON_EQ] = ACTIONS(2967),
    [anon_sym_lock] = ACTIONS(2967),
    [anon_sym_rlock] = ACTIONS(2967),
    [anon_sym_unsafe] = ACTIONS(2967),
    [anon_sym_sql] = ACTIONS(2967),
    [sym_int_literal] = ACTIONS(2967),
    [sym_float_literal] = ACTIONS(2967),
    [sym_rune_literal] = ACTIONS(2967),
    [anon_sym_SQUOTE] = ACTIONS(2967),
    [anon_sym_DQUOTE] = ACTIONS(2967),
    [anon_sym_c_SQUOTE] = ACTIONS(2967),
    [anon_sym_c_DQUOTE] = ACTIONS(2967),
    [anon_sym_r_SQUOTE] = ACTIONS(2967),
    [anon_sym_r_DQUOTE] = ACTIONS(2967),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2967),
    [anon_sym_shared] = ACTIONS(2967),
    [anon_sym_map_LBRACK] = ACTIONS(2967),
    [anon_sym_chan] = ACTIONS(2967),
    [anon_sym_thread] = ACTIONS(2967),
    [anon_sym_atomic] = ACTIONS(2967),
    [anon_sym_assert] = ACTIONS(2967),
    [anon_sym_defer] = ACTIONS(2967),
    [anon_sym_goto] = ACTIONS(2967),
    [anon_sym_break] = ACTIONS(2967),
    [anon_sym_continue] = ACTIONS(2967),
    [anon_sym_return] = ACTIONS(2967),
    [anon_sym_DOLLARfor] = ACTIONS(2967),
    [anon_sym_for] = ACTIONS(2967),
    [anon_sym_POUND] = ACTIONS(2967),
    [anon_sym_asm] = ACTIONS(2967),
    [anon_sym_AT_LBRACK] = ACTIONS(2967),
  },
  [451] = {
    [sym_line_comment] = STATE(451),
    [sym_block_comment] = STATE(451),
    [sym__expression] = STATE(1604),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_string_interpolation_repeat1] = STATE(487),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_RBRACE] = ACTIONS(2969),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_go] = ACTIONS(2903),
    [anon_sym_spawn] = ACTIONS(2905),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_LT_DASH] = ACTIONS(2909),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(2911),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_rlock] = ACTIONS(2913),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [452] = {
    [sym_line_comment] = STATE(452),
    [sym_block_comment] = STATE(452),
    [ts_builtin_sym_end] = ACTIONS(2971),
    [sym_identifier] = ACTIONS(2973),
    [anon_sym_LF] = ACTIONS(2973),
    [anon_sym_CR] = ACTIONS(2973),
    [anon_sym_CR_LF] = ACTIONS(2973),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2973),
    [anon_sym_as] = ACTIONS(2973),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_COMMA] = ACTIONS(2973),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_EQ] = ACTIONS(2973),
    [anon_sym___global] = ACTIONS(2973),
    [anon_sym_type] = ACTIONS(2973),
    [anon_sym_fn] = ACTIONS(2973),
    [anon_sym_PLUS] = ACTIONS(2973),
    [anon_sym_DASH] = ACTIONS(2973),
    [anon_sym_STAR] = ACTIONS(2973),
    [anon_sym_SLASH] = ACTIONS(2973),
    [anon_sym_PERCENT] = ACTIONS(2973),
    [anon_sym_LT] = ACTIONS(2973),
    [anon_sym_GT] = ACTIONS(2973),
    [anon_sym_EQ_EQ] = ACTIONS(2973),
    [anon_sym_BANG_EQ] = ACTIONS(2973),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LBRACK] = ACTIONS(2971),
    [anon_sym_struct] = ACTIONS(2973),
    [anon_sym_union] = ACTIONS(2973),
    [anon_sym_pub] = ACTIONS(2973),
    [anon_sym_mut] = ACTIONS(2973),
    [anon_sym_enum] = ACTIONS(2973),
    [anon_sym_interface] = ACTIONS(2973),
    [anon_sym_PLUS_PLUS] = ACTIONS(2973),
    [anon_sym_DASH_DASH] = ACTIONS(2973),
    [anon_sym_QMARK] = ACTIONS(2973),
    [anon_sym_BANG] = ACTIONS(2973),
    [anon_sym_go] = ACTIONS(2973),
    [anon_sym_spawn] = ACTIONS(2973),
    [anon_sym_json_DOTdecode] = ACTIONS(2973),
    [anon_sym_PIPE] = ACTIONS(2973),
    [anon_sym_LBRACK2] = ACTIONS(2973),
    [anon_sym_TILDE] = ACTIONS(2973),
    [anon_sym_CARET] = ACTIONS(2973),
    [anon_sym_AMP] = ACTIONS(2973),
    [anon_sym_LT_DASH] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2973),
    [anon_sym_GT_GT] = ACTIONS(2973),
    [anon_sym_GT_GT_GT] = ACTIONS(2973),
    [anon_sym_AMP_CARET] = ACTIONS(2973),
    [anon_sym_AMP_AMP] = ACTIONS(2973),
    [anon_sym_PIPE_PIPE] = ACTIONS(2973),
    [anon_sym_or] = ACTIONS(2973),
    [sym_none] = ACTIONS(2973),
    [sym_true] = ACTIONS(2973),
    [sym_false] = ACTIONS(2973),
    [sym_nil] = ACTIONS(2973),
    [anon_sym_QMARK_DOT] = ACTIONS(2973),
    [anon_sym_POUND_LBRACK] = ACTIONS(2973),
    [anon_sym_if] = ACTIONS(2973),
    [anon_sym_DOLLARif] = ACTIONS(2973),
    [anon_sym_is] = ACTIONS(2973),
    [anon_sym_BANGis] = ACTIONS(2973),
    [anon_sym_in] = ACTIONS(2973),
    [anon_sym_BANGin] = ACTIONS(2973),
    [anon_sym_match] = ACTIONS(2973),
    [anon_sym_select] = ACTIONS(2973),
    [anon_sym_STAR_EQ] = ACTIONS(2973),
    [anon_sym_SLASH_EQ] = ACTIONS(2973),
    [anon_sym_PERCENT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_GT_EQ] = ACTIONS(2973),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2973),
    [anon_sym_AMP_EQ] = ACTIONS(2973),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2973),
    [anon_sym_PLUS_EQ] = ACTIONS(2973),
    [anon_sym_DASH_EQ] = ACTIONS(2973),
    [anon_sym_PIPE_EQ] = ACTIONS(2973),
    [anon_sym_CARET_EQ] = ACTIONS(2973),
    [anon_sym_COLON_EQ] = ACTIONS(2973),
    [anon_sym_lock] = ACTIONS(2973),
    [anon_sym_rlock] = ACTIONS(2973),
    [anon_sym_unsafe] = ACTIONS(2973),
    [anon_sym_sql] = ACTIONS(2973),
    [sym_int_literal] = ACTIONS(2973),
    [sym_float_literal] = ACTIONS(2973),
    [sym_rune_literal] = ACTIONS(2973),
    [anon_sym_SQUOTE] = ACTIONS(2973),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [anon_sym_c_SQUOTE] = ACTIONS(2973),
    [anon_sym_c_DQUOTE] = ACTIONS(2973),
    [anon_sym_r_SQUOTE] = ACTIONS(2973),
    [anon_sym_r_DQUOTE] = ACTIONS(2973),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2973),
    [anon_sym_shared] = ACTIONS(2973),
    [anon_sym_map_LBRACK] = ACTIONS(2973),
    [anon_sym_chan] = ACTIONS(2973),
    [anon_sym_thread] = ACTIONS(2973),
    [anon_sym_atomic] = ACTIONS(2973),
    [anon_sym_assert] = ACTIONS(2973),
    [anon_sym_defer] = ACTIONS(2973),
    [anon_sym_goto] = ACTIONS(2973),
    [anon_sym_break] = ACTIONS(2973),
    [anon_sym_continue] = ACTIONS(2973),
    [anon_sym_return] = ACTIONS(2973),
    [anon_sym_DOLLARfor] = ACTIONS(2973),
    [anon_sym_for] = ACTIONS(2973),
    [anon_sym_POUND] = ACTIONS(2973),
    [anon_sym_asm] = ACTIONS(2973),
    [anon_sym_AT_LBRACK] = ACTIONS(2973),
  },
  [453] = {
    [sym_line_comment] = STATE(453),
    [sym_block_comment] = STATE(453),
    [ts_builtin_sym_end] = ACTIONS(2975),
    [sym_identifier] = ACTIONS(2977),
    [anon_sym_LF] = ACTIONS(2977),
    [anon_sym_CR] = ACTIONS(2977),
    [anon_sym_CR_LF] = ACTIONS(2977),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2977),
    [anon_sym_as] = ACTIONS(2977),
    [anon_sym_LBRACE] = ACTIONS(2977),
    [anon_sym_COMMA] = ACTIONS(2977),
    [anon_sym_const] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(2977),
    [anon_sym_EQ] = ACTIONS(2977),
    [anon_sym___global] = ACTIONS(2977),
    [anon_sym_type] = ACTIONS(2977),
    [anon_sym_fn] = ACTIONS(2977),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_PERCENT] = ACTIONS(2977),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_EQ_EQ] = ACTIONS(2977),
    [anon_sym_BANG_EQ] = ACTIONS(2977),
    [anon_sym_LT_EQ] = ACTIONS(2977),
    [anon_sym_GT_EQ] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(2975),
    [anon_sym_struct] = ACTIONS(2977),
    [anon_sym_union] = ACTIONS(2977),
    [anon_sym_pub] = ACTIONS(2977),
    [anon_sym_mut] = ACTIONS(2977),
    [anon_sym_enum] = ACTIONS(2977),
    [anon_sym_interface] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2977),
    [anon_sym_DASH_DASH] = ACTIONS(2977),
    [anon_sym_QMARK] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_go] = ACTIONS(2977),
    [anon_sym_spawn] = ACTIONS(2977),
    [anon_sym_json_DOTdecode] = ACTIONS(2977),
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_LBRACK2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2977),
    [anon_sym_CARET] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_LT_DASH] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2977),
    [anon_sym_GT_GT] = ACTIONS(2977),
    [anon_sym_GT_GT_GT] = ACTIONS(2977),
    [anon_sym_AMP_CARET] = ACTIONS(2977),
    [anon_sym_AMP_AMP] = ACTIONS(2977),
    [anon_sym_PIPE_PIPE] = ACTIONS(2977),
    [anon_sym_or] = ACTIONS(2977),
    [sym_none] = ACTIONS(2977),
    [sym_true] = ACTIONS(2977),
    [sym_false] = ACTIONS(2977),
    [sym_nil] = ACTIONS(2977),
    [anon_sym_QMARK_DOT] = ACTIONS(2977),
    [anon_sym_POUND_LBRACK] = ACTIONS(2977),
    [anon_sym_if] = ACTIONS(2977),
    [anon_sym_DOLLARif] = ACTIONS(2977),
    [anon_sym_is] = ACTIONS(2977),
    [anon_sym_BANGis] = ACTIONS(2977),
    [anon_sym_in] = ACTIONS(2977),
    [anon_sym_BANGin] = ACTIONS(2977),
    [anon_sym_match] = ACTIONS(2977),
    [anon_sym_select] = ACTIONS(2977),
    [anon_sym_STAR_EQ] = ACTIONS(2977),
    [anon_sym_SLASH_EQ] = ACTIONS(2977),
    [anon_sym_PERCENT_EQ] = ACTIONS(2977),
    [anon_sym_LT_LT_EQ] = ACTIONS(2977),
    [anon_sym_GT_GT_EQ] = ACTIONS(2977),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2977),
    [anon_sym_AMP_EQ] = ACTIONS(2977),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2977),
    [anon_sym_PLUS_EQ] = ACTIONS(2977),
    [anon_sym_DASH_EQ] = ACTIONS(2977),
    [anon_sym_PIPE_EQ] = ACTIONS(2977),
    [anon_sym_CARET_EQ] = ACTIONS(2977),
    [anon_sym_COLON_EQ] = ACTIONS(2977),
    [anon_sym_lock] = ACTIONS(2977),
    [anon_sym_rlock] = ACTIONS(2977),
    [anon_sym_unsafe] = ACTIONS(2977),
    [anon_sym_sql] = ACTIONS(2977),
    [sym_int_literal] = ACTIONS(2977),
    [sym_float_literal] = ACTIONS(2977),
    [sym_rune_literal] = ACTIONS(2977),
    [anon_sym_SQUOTE] = ACTIONS(2977),
    [anon_sym_DQUOTE] = ACTIONS(2977),
    [anon_sym_c_SQUOTE] = ACTIONS(2977),
    [anon_sym_c_DQUOTE] = ACTIONS(2977),
    [anon_sym_r_SQUOTE] = ACTIONS(2977),
    [anon_sym_r_DQUOTE] = ACTIONS(2977),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2977),
    [anon_sym_shared] = ACTIONS(2977),
    [anon_sym_map_LBRACK] = ACTIONS(2977),
    [anon_sym_chan] = ACTIONS(2977),
    [anon_sym_thread] = ACTIONS(2977),
    [anon_sym_atomic] = ACTIONS(2977),
    [anon_sym_assert] = ACTIONS(2977),
    [anon_sym_defer] = ACTIONS(2977),
    [anon_sym_goto] = ACTIONS(2977),
    [anon_sym_break] = ACTIONS(2977),
    [anon_sym_continue] = ACTIONS(2977),
    [anon_sym_return] = ACTIONS(2977),
    [anon_sym_DOLLARfor] = ACTIONS(2977),
    [anon_sym_for] = ACTIONS(2977),
    [anon_sym_POUND] = ACTIONS(2977),
    [anon_sym_asm] = ACTIONS(2977),
    [anon_sym_AT_LBRACK] = ACTIONS(2977),
  },
  [454] = {
    [sym_line_comment] = STATE(454),
    [sym_block_comment] = STATE(454),
    [ts_builtin_sym_end] = ACTIONS(2979),
    [sym_identifier] = ACTIONS(2981),
    [anon_sym_LF] = ACTIONS(2981),
    [anon_sym_CR] = ACTIONS(2981),
    [anon_sym_CR_LF] = ACTIONS(2981),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2981),
    [anon_sym_as] = ACTIONS(2981),
    [anon_sym_LBRACE] = ACTIONS(2981),
    [anon_sym_COMMA] = ACTIONS(2981),
    [anon_sym_const] = ACTIONS(2981),
    [anon_sym_LPAREN] = ACTIONS(2981),
    [anon_sym_EQ] = ACTIONS(2981),
    [anon_sym___global] = ACTIONS(2981),
    [anon_sym_type] = ACTIONS(2981),
    [anon_sym_fn] = ACTIONS(2981),
    [anon_sym_PLUS] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_PERCENT] = ACTIONS(2981),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_GT] = ACTIONS(2981),
    [anon_sym_EQ_EQ] = ACTIONS(2981),
    [anon_sym_BANG_EQ] = ACTIONS(2981),
    [anon_sym_LT_EQ] = ACTIONS(2981),
    [anon_sym_GT_EQ] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_struct] = ACTIONS(2981),
    [anon_sym_union] = ACTIONS(2981),
    [anon_sym_pub] = ACTIONS(2981),
    [anon_sym_mut] = ACTIONS(2981),
    [anon_sym_enum] = ACTIONS(2981),
    [anon_sym_interface] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2981),
    [anon_sym_DASH_DASH] = ACTIONS(2981),
    [anon_sym_QMARK] = ACTIONS(2981),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_go] = ACTIONS(2981),
    [anon_sym_spawn] = ACTIONS(2981),
    [anon_sym_json_DOTdecode] = ACTIONS(2981),
    [anon_sym_PIPE] = ACTIONS(2981),
    [anon_sym_LBRACK2] = ACTIONS(2981),
    [anon_sym_TILDE] = ACTIONS(2981),
    [anon_sym_CARET] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2981),
    [anon_sym_LT_DASH] = ACTIONS(2981),
    [anon_sym_LT_LT] = ACTIONS(2981),
    [anon_sym_GT_GT] = ACTIONS(2981),
    [anon_sym_GT_GT_GT] = ACTIONS(2981),
    [anon_sym_AMP_CARET] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(2981),
    [anon_sym_PIPE_PIPE] = ACTIONS(2981),
    [anon_sym_or] = ACTIONS(2981),
    [sym_none] = ACTIONS(2981),
    [sym_true] = ACTIONS(2981),
    [sym_false] = ACTIONS(2981),
    [sym_nil] = ACTIONS(2981),
    [anon_sym_QMARK_DOT] = ACTIONS(2981),
    [anon_sym_POUND_LBRACK] = ACTIONS(2981),
    [anon_sym_if] = ACTIONS(2981),
    [anon_sym_DOLLARif] = ACTIONS(2981),
    [anon_sym_is] = ACTIONS(2981),
    [anon_sym_BANGis] = ACTIONS(2981),
    [anon_sym_in] = ACTIONS(2981),
    [anon_sym_BANGin] = ACTIONS(2981),
    [anon_sym_match] = ACTIONS(2981),
    [anon_sym_select] = ACTIONS(2981),
    [anon_sym_STAR_EQ] = ACTIONS(2981),
    [anon_sym_SLASH_EQ] = ACTIONS(2981),
    [anon_sym_PERCENT_EQ] = ACTIONS(2981),
    [anon_sym_LT_LT_EQ] = ACTIONS(2981),
    [anon_sym_GT_GT_EQ] = ACTIONS(2981),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2981),
    [anon_sym_AMP_EQ] = ACTIONS(2981),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2981),
    [anon_sym_PLUS_EQ] = ACTIONS(2981),
    [anon_sym_DASH_EQ] = ACTIONS(2981),
    [anon_sym_PIPE_EQ] = ACTIONS(2981),
    [anon_sym_CARET_EQ] = ACTIONS(2981),
    [anon_sym_COLON_EQ] = ACTIONS(2981),
    [anon_sym_lock] = ACTIONS(2981),
    [anon_sym_rlock] = ACTIONS(2981),
    [anon_sym_unsafe] = ACTIONS(2981),
    [anon_sym_sql] = ACTIONS(2981),
    [sym_int_literal] = ACTIONS(2981),
    [sym_float_literal] = ACTIONS(2981),
    [sym_rune_literal] = ACTIONS(2981),
    [anon_sym_SQUOTE] = ACTIONS(2981),
    [anon_sym_DQUOTE] = ACTIONS(2981),
    [anon_sym_c_SQUOTE] = ACTIONS(2981),
    [anon_sym_c_DQUOTE] = ACTIONS(2981),
    [anon_sym_r_SQUOTE] = ACTIONS(2981),
    [anon_sym_r_DQUOTE] = ACTIONS(2981),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2981),
    [anon_sym_shared] = ACTIONS(2981),
    [anon_sym_map_LBRACK] = ACTIONS(2981),
    [anon_sym_chan] = ACTIONS(2981),
    [anon_sym_thread] = ACTIONS(2981),
    [anon_sym_atomic] = ACTIONS(2981),
    [anon_sym_assert] = ACTIONS(2981),
    [anon_sym_defer] = ACTIONS(2981),
    [anon_sym_goto] = ACTIONS(2981),
    [anon_sym_break] = ACTIONS(2981),
    [anon_sym_continue] = ACTIONS(2981),
    [anon_sym_return] = ACTIONS(2981),
    [anon_sym_DOLLARfor] = ACTIONS(2981),
    [anon_sym_for] = ACTIONS(2981),
    [anon_sym_POUND] = ACTIONS(2981),
    [anon_sym_asm] = ACTIONS(2981),
    [anon_sym_AT_LBRACK] = ACTIONS(2981),
  },
  [455] = {
    [sym_line_comment] = STATE(455),
    [sym_block_comment] = STATE(455),
    [ts_builtin_sym_end] = ACTIONS(2983),
    [sym_identifier] = ACTIONS(2985),
    [anon_sym_LF] = ACTIONS(2985),
    [anon_sym_CR] = ACTIONS(2985),
    [anon_sym_CR_LF] = ACTIONS(2985),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_as] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2985),
    [anon_sym___global] = ACTIONS(2985),
    [anon_sym_type] = ACTIONS(2985),
    [anon_sym_fn] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2985),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_PERCENT] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_EQ_EQ] = ACTIONS(2985),
    [anon_sym_BANG_EQ] = ACTIONS(2985),
    [anon_sym_LT_EQ] = ACTIONS(2985),
    [anon_sym_GT_EQ] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_union] = ACTIONS(2985),
    [anon_sym_pub] = ACTIONS(2985),
    [anon_sym_mut] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [anon_sym_interface] = ACTIONS(2985),
    [anon_sym_PLUS_PLUS] = ACTIONS(2985),
    [anon_sym_DASH_DASH] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_go] = ACTIONS(2985),
    [anon_sym_spawn] = ACTIONS(2985),
    [anon_sym_json_DOTdecode] = ACTIONS(2985),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(2985),
    [anon_sym_CARET] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_DASH] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2985),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_GT_GT_GT] = ACTIONS(2985),
    [anon_sym_AMP_CARET] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_or] = ACTIONS(2985),
    [sym_none] = ACTIONS(2985),
    [sym_true] = ACTIONS(2985),
    [sym_false] = ACTIONS(2985),
    [sym_nil] = ACTIONS(2985),
    [anon_sym_QMARK_DOT] = ACTIONS(2985),
    [anon_sym_POUND_LBRACK] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_DOLLARif] = ACTIONS(2985),
    [anon_sym_is] = ACTIONS(2985),
    [anon_sym_BANGis] = ACTIONS(2985),
    [anon_sym_in] = ACTIONS(2985),
    [anon_sym_BANGin] = ACTIONS(2985),
    [anon_sym_match] = ACTIONS(2985),
    [anon_sym_select] = ACTIONS(2985),
    [anon_sym_STAR_EQ] = ACTIONS(2985),
    [anon_sym_SLASH_EQ] = ACTIONS(2985),
    [anon_sym_PERCENT_EQ] = ACTIONS(2985),
    [anon_sym_LT_LT_EQ] = ACTIONS(2985),
    [anon_sym_GT_GT_EQ] = ACTIONS(2985),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2985),
    [anon_sym_AMP_EQ] = ACTIONS(2985),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2985),
    [anon_sym_PLUS_EQ] = ACTIONS(2985),
    [anon_sym_DASH_EQ] = ACTIONS(2985),
    [anon_sym_PIPE_EQ] = ACTIONS(2985),
    [anon_sym_CARET_EQ] = ACTIONS(2985),
    [anon_sym_COLON_EQ] = ACTIONS(2985),
    [anon_sym_lock] = ACTIONS(2985),
    [anon_sym_rlock] = ACTIONS(2985),
    [anon_sym_unsafe] = ACTIONS(2985),
    [anon_sym_sql] = ACTIONS(2985),
    [sym_int_literal] = ACTIONS(2985),
    [sym_float_literal] = ACTIONS(2985),
    [sym_rune_literal] = ACTIONS(2985),
    [anon_sym_SQUOTE] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_c_SQUOTE] = ACTIONS(2985),
    [anon_sym_c_DQUOTE] = ACTIONS(2985),
    [anon_sym_r_SQUOTE] = ACTIONS(2985),
    [anon_sym_r_DQUOTE] = ACTIONS(2985),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2985),
    [anon_sym_shared] = ACTIONS(2985),
    [anon_sym_map_LBRACK] = ACTIONS(2985),
    [anon_sym_chan] = ACTIONS(2985),
    [anon_sym_thread] = ACTIONS(2985),
    [anon_sym_atomic] = ACTIONS(2985),
    [anon_sym_assert] = ACTIONS(2985),
    [anon_sym_defer] = ACTIONS(2985),
    [anon_sym_goto] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_DOLLARfor] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_POUND] = ACTIONS(2985),
    [anon_sym_asm] = ACTIONS(2985),
    [anon_sym_AT_LBRACK] = ACTIONS(2985),
  },
  [456] = {
    [sym_line_comment] = STATE(456),
    [sym_block_comment] = STATE(456),
    [ts_builtin_sym_end] = ACTIONS(2987),
    [sym_identifier] = ACTIONS(2989),
    [anon_sym_LF] = ACTIONS(2989),
    [anon_sym_CR] = ACTIONS(2989),
    [anon_sym_CR_LF] = ACTIONS(2989),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_as] = ACTIONS(2989),
    [anon_sym_LBRACE] = ACTIONS(2989),
    [anon_sym_COMMA] = ACTIONS(2989),
    [anon_sym_const] = ACTIONS(2989),
    [anon_sym_LPAREN] = ACTIONS(2989),
    [anon_sym_EQ] = ACTIONS(2989),
    [anon_sym___global] = ACTIONS(2989),
    [anon_sym_type] = ACTIONS(2989),
    [anon_sym_fn] = ACTIONS(2989),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2989),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2989),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_EQ_EQ] = ACTIONS(2989),
    [anon_sym_BANG_EQ] = ACTIONS(2989),
    [anon_sym_LT_EQ] = ACTIONS(2989),
    [anon_sym_GT_EQ] = ACTIONS(2989),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_struct] = ACTIONS(2989),
    [anon_sym_union] = ACTIONS(2989),
    [anon_sym_pub] = ACTIONS(2989),
    [anon_sym_mut] = ACTIONS(2989),
    [anon_sym_enum] = ACTIONS(2989),
    [anon_sym_interface] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2989),
    [anon_sym_DASH_DASH] = ACTIONS(2989),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_go] = ACTIONS(2989),
    [anon_sym_spawn] = ACTIONS(2989),
    [anon_sym_json_DOTdecode] = ACTIONS(2989),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_LBRACK2] = ACTIONS(2989),
    [anon_sym_TILDE] = ACTIONS(2989),
    [anon_sym_CARET] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_LT_DASH] = ACTIONS(2989),
    [anon_sym_LT_LT] = ACTIONS(2989),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2989),
    [anon_sym_AMP_CARET] = ACTIONS(2989),
    [anon_sym_AMP_AMP] = ACTIONS(2989),
    [anon_sym_PIPE_PIPE] = ACTIONS(2989),
    [anon_sym_or] = ACTIONS(2989),
    [sym_none] = ACTIONS(2989),
    [sym_true] = ACTIONS(2989),
    [sym_false] = ACTIONS(2989),
    [sym_nil] = ACTIONS(2989),
    [anon_sym_QMARK_DOT] = ACTIONS(2989),
    [anon_sym_POUND_LBRACK] = ACTIONS(2989),
    [anon_sym_if] = ACTIONS(2989),
    [anon_sym_DOLLARif] = ACTIONS(2989),
    [anon_sym_is] = ACTIONS(2989),
    [anon_sym_BANGis] = ACTIONS(2989),
    [anon_sym_in] = ACTIONS(2989),
    [anon_sym_BANGin] = ACTIONS(2989),
    [anon_sym_match] = ACTIONS(2989),
    [anon_sym_select] = ACTIONS(2989),
    [anon_sym_STAR_EQ] = ACTIONS(2989),
    [anon_sym_SLASH_EQ] = ACTIONS(2989),
    [anon_sym_PERCENT_EQ] = ACTIONS(2989),
    [anon_sym_LT_LT_EQ] = ACTIONS(2989),
    [anon_sym_GT_GT_EQ] = ACTIONS(2989),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2989),
    [anon_sym_AMP_EQ] = ACTIONS(2989),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2989),
    [anon_sym_PLUS_EQ] = ACTIONS(2989),
    [anon_sym_DASH_EQ] = ACTIONS(2989),
    [anon_sym_PIPE_EQ] = ACTIONS(2989),
    [anon_sym_CARET_EQ] = ACTIONS(2989),
    [anon_sym_COLON_EQ] = ACTIONS(2989),
    [anon_sym_lock] = ACTIONS(2989),
    [anon_sym_rlock] = ACTIONS(2989),
    [anon_sym_unsafe] = ACTIONS(2989),
    [anon_sym_sql] = ACTIONS(2989),
    [sym_int_literal] = ACTIONS(2989),
    [sym_float_literal] = ACTIONS(2989),
    [sym_rune_literal] = ACTIONS(2989),
    [anon_sym_SQUOTE] = ACTIONS(2989),
    [anon_sym_DQUOTE] = ACTIONS(2989),
    [anon_sym_c_SQUOTE] = ACTIONS(2989),
    [anon_sym_c_DQUOTE] = ACTIONS(2989),
    [anon_sym_r_SQUOTE] = ACTIONS(2989),
    [anon_sym_r_DQUOTE] = ACTIONS(2989),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2989),
    [anon_sym_shared] = ACTIONS(2989),
    [anon_sym_map_LBRACK] = ACTIONS(2989),
    [anon_sym_chan] = ACTIONS(2989),
    [anon_sym_thread] = ACTIONS(2989),
    [anon_sym_atomic] = ACTIONS(2989),
    [anon_sym_assert] = ACTIONS(2989),
    [anon_sym_defer] = ACTIONS(2989),
    [anon_sym_goto] = ACTIONS(2989),
    [anon_sym_break] = ACTIONS(2989),
    [anon_sym_continue] = ACTIONS(2989),
    [anon_sym_return] = ACTIONS(2989),
    [anon_sym_DOLLARfor] = ACTIONS(2989),
    [anon_sym_for] = ACTIONS(2989),
    [anon_sym_POUND] = ACTIONS(2989),
    [anon_sym_asm] = ACTIONS(2989),
    [anon_sym_AT_LBRACK] = ACTIONS(2989),
  },
  [457] = {
    [sym_line_comment] = STATE(457),
    [sym_block_comment] = STATE(457),
    [ts_builtin_sym_end] = ACTIONS(2991),
    [sym_identifier] = ACTIONS(2993),
    [anon_sym_LF] = ACTIONS(2993),
    [anon_sym_CR] = ACTIONS(2993),
    [anon_sym_CR_LF] = ACTIONS(2993),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2993),
    [anon_sym_as] = ACTIONS(2993),
    [anon_sym_LBRACE] = ACTIONS(2993),
    [anon_sym_COMMA] = ACTIONS(2993),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2993),
    [anon_sym_EQ] = ACTIONS(2993),
    [anon_sym___global] = ACTIONS(2993),
    [anon_sym_type] = ACTIONS(2993),
    [anon_sym_fn] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2993),
    [anon_sym_DASH] = ACTIONS(2993),
    [anon_sym_STAR] = ACTIONS(2993),
    [anon_sym_SLASH] = ACTIONS(2993),
    [anon_sym_PERCENT] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(2993),
    [anon_sym_EQ_EQ] = ACTIONS(2993),
    [anon_sym_BANG_EQ] = ACTIONS(2993),
    [anon_sym_LT_EQ] = ACTIONS(2993),
    [anon_sym_GT_EQ] = ACTIONS(2993),
    [anon_sym_LBRACK] = ACTIONS(2991),
    [anon_sym_struct] = ACTIONS(2993),
    [anon_sym_union] = ACTIONS(2993),
    [anon_sym_pub] = ACTIONS(2993),
    [anon_sym_mut] = ACTIONS(2993),
    [anon_sym_enum] = ACTIONS(2993),
    [anon_sym_interface] = ACTIONS(2993),
    [anon_sym_PLUS_PLUS] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2993),
    [anon_sym_QMARK] = ACTIONS(2993),
    [anon_sym_BANG] = ACTIONS(2993),
    [anon_sym_go] = ACTIONS(2993),
    [anon_sym_spawn] = ACTIONS(2993),
    [anon_sym_json_DOTdecode] = ACTIONS(2993),
    [anon_sym_PIPE] = ACTIONS(2993),
    [anon_sym_LBRACK2] = ACTIONS(2993),
    [anon_sym_TILDE] = ACTIONS(2993),
    [anon_sym_CARET] = ACTIONS(2993),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_LT_DASH] = ACTIONS(2993),
    [anon_sym_LT_LT] = ACTIONS(2993),
    [anon_sym_GT_GT] = ACTIONS(2993),
    [anon_sym_GT_GT_GT] = ACTIONS(2993),
    [anon_sym_AMP_CARET] = ACTIONS(2993),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [anon_sym_or] = ACTIONS(2993),
    [sym_none] = ACTIONS(2993),
    [sym_true] = ACTIONS(2993),
    [sym_false] = ACTIONS(2993),
    [sym_nil] = ACTIONS(2993),
    [anon_sym_QMARK_DOT] = ACTIONS(2993),
    [anon_sym_POUND_LBRACK] = ACTIONS(2993),
    [anon_sym_if] = ACTIONS(2993),
    [anon_sym_DOLLARif] = ACTIONS(2993),
    [anon_sym_is] = ACTIONS(2993),
    [anon_sym_BANGis] = ACTIONS(2993),
    [anon_sym_in] = ACTIONS(2993),
    [anon_sym_BANGin] = ACTIONS(2993),
    [anon_sym_match] = ACTIONS(2993),
    [anon_sym_select] = ACTIONS(2993),
    [anon_sym_STAR_EQ] = ACTIONS(2993),
    [anon_sym_SLASH_EQ] = ACTIONS(2993),
    [anon_sym_PERCENT_EQ] = ACTIONS(2993),
    [anon_sym_LT_LT_EQ] = ACTIONS(2993),
    [anon_sym_GT_GT_EQ] = ACTIONS(2993),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2993),
    [anon_sym_AMP_EQ] = ACTIONS(2993),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2993),
    [anon_sym_PLUS_EQ] = ACTIONS(2993),
    [anon_sym_DASH_EQ] = ACTIONS(2993),
    [anon_sym_PIPE_EQ] = ACTIONS(2993),
    [anon_sym_CARET_EQ] = ACTIONS(2993),
    [anon_sym_COLON_EQ] = ACTIONS(2993),
    [anon_sym_lock] = ACTIONS(2993),
    [anon_sym_rlock] = ACTIONS(2993),
    [anon_sym_unsafe] = ACTIONS(2993),
    [anon_sym_sql] = ACTIONS(2993),
    [sym_int_literal] = ACTIONS(2993),
    [sym_float_literal] = ACTIONS(2993),
    [sym_rune_literal] = ACTIONS(2993),
    [anon_sym_SQUOTE] = ACTIONS(2993),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [anon_sym_c_SQUOTE] = ACTIONS(2993),
    [anon_sym_c_DQUOTE] = ACTIONS(2993),
    [anon_sym_r_SQUOTE] = ACTIONS(2993),
    [anon_sym_r_DQUOTE] = ACTIONS(2993),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2993),
    [anon_sym_shared] = ACTIONS(2993),
    [anon_sym_map_LBRACK] = ACTIONS(2993),
    [anon_sym_chan] = ACTIONS(2993),
    [anon_sym_thread] = ACTIONS(2993),
    [anon_sym_atomic] = ACTIONS(2993),
    [anon_sym_assert] = ACTIONS(2993),
    [anon_sym_defer] = ACTIONS(2993),
    [anon_sym_goto] = ACTIONS(2993),
    [anon_sym_break] = ACTIONS(2993),
    [anon_sym_continue] = ACTIONS(2993),
    [anon_sym_return] = ACTIONS(2993),
    [anon_sym_DOLLARfor] = ACTIONS(2993),
    [anon_sym_for] = ACTIONS(2993),
    [anon_sym_POUND] = ACTIONS(2993),
    [anon_sym_asm] = ACTIONS(2993),
    [anon_sym_AT_LBRACK] = ACTIONS(2993),
  },
  [458] = {
    [sym_line_comment] = STATE(458),
    [sym_block_comment] = STATE(458),
    [sym__expression] = STATE(2605),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3688),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4624),
    [sym_identifier] = ACTIONS(2385),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(2387),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2389),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(2391),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [459] = {
    [sym_line_comment] = STATE(459),
    [sym_block_comment] = STATE(459),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3683),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2385),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_COMMA] = ACTIONS(853),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(2387),
    [anon_sym_RBRACK] = ACTIONS(853),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2389),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(2391),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [460] = {
    [sym_line_comment] = STATE(460),
    [sym_block_comment] = STATE(460),
    [ts_builtin_sym_end] = ACTIONS(2995),
    [sym_identifier] = ACTIONS(2997),
    [anon_sym_LF] = ACTIONS(2997),
    [anon_sym_CR] = ACTIONS(2997),
    [anon_sym_CR_LF] = ACTIONS(2997),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2997),
    [anon_sym_as] = ACTIONS(2997),
    [anon_sym_LBRACE] = ACTIONS(2997),
    [anon_sym_COMMA] = ACTIONS(2997),
    [anon_sym_const] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(2997),
    [anon_sym_EQ] = ACTIONS(2997),
    [anon_sym___global] = ACTIONS(2997),
    [anon_sym_type] = ACTIONS(2997),
    [anon_sym_fn] = ACTIONS(2997),
    [anon_sym_PLUS] = ACTIONS(2997),
    [anon_sym_DASH] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(2997),
    [anon_sym_SLASH] = ACTIONS(2997),
    [anon_sym_PERCENT] = ACTIONS(2997),
    [anon_sym_LT] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(2997),
    [anon_sym_EQ_EQ] = ACTIONS(2997),
    [anon_sym_BANG_EQ] = ACTIONS(2997),
    [anon_sym_LT_EQ] = ACTIONS(2997),
    [anon_sym_GT_EQ] = ACTIONS(2997),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_struct] = ACTIONS(2997),
    [anon_sym_union] = ACTIONS(2997),
    [anon_sym_pub] = ACTIONS(2997),
    [anon_sym_mut] = ACTIONS(2997),
    [anon_sym_enum] = ACTIONS(2997),
    [anon_sym_interface] = ACTIONS(2997),
    [anon_sym_PLUS_PLUS] = ACTIONS(2997),
    [anon_sym_DASH_DASH] = ACTIONS(2997),
    [anon_sym_QMARK] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2997),
    [anon_sym_go] = ACTIONS(2997),
    [anon_sym_spawn] = ACTIONS(2997),
    [anon_sym_json_DOTdecode] = ACTIONS(2997),
    [anon_sym_PIPE] = ACTIONS(2997),
    [anon_sym_LBRACK2] = ACTIONS(2997),
    [anon_sym_TILDE] = ACTIONS(2997),
    [anon_sym_CARET] = ACTIONS(2997),
    [anon_sym_AMP] = ACTIONS(2997),
    [anon_sym_LT_DASH] = ACTIONS(2997),
    [anon_sym_LT_LT] = ACTIONS(2997),
    [anon_sym_GT_GT] = ACTIONS(2997),
    [anon_sym_GT_GT_GT] = ACTIONS(2997),
    [anon_sym_AMP_CARET] = ACTIONS(2997),
    [anon_sym_AMP_AMP] = ACTIONS(2997),
    [anon_sym_PIPE_PIPE] = ACTIONS(2997),
    [anon_sym_or] = ACTIONS(2997),
    [sym_none] = ACTIONS(2997),
    [sym_true] = ACTIONS(2997),
    [sym_false] = ACTIONS(2997),
    [sym_nil] = ACTIONS(2997),
    [anon_sym_QMARK_DOT] = ACTIONS(2997),
    [anon_sym_POUND_LBRACK] = ACTIONS(2997),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_DOLLARif] = ACTIONS(2997),
    [anon_sym_is] = ACTIONS(2997),
    [anon_sym_BANGis] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(2997),
    [anon_sym_BANGin] = ACTIONS(2997),
    [anon_sym_match] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [anon_sym_STAR_EQ] = ACTIONS(2997),
    [anon_sym_SLASH_EQ] = ACTIONS(2997),
    [anon_sym_PERCENT_EQ] = ACTIONS(2997),
    [anon_sym_LT_LT_EQ] = ACTIONS(2997),
    [anon_sym_GT_GT_EQ] = ACTIONS(2997),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2997),
    [anon_sym_AMP_EQ] = ACTIONS(2997),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2997),
    [anon_sym_PLUS_EQ] = ACTIONS(2997),
    [anon_sym_DASH_EQ] = ACTIONS(2997),
    [anon_sym_PIPE_EQ] = ACTIONS(2997),
    [anon_sym_CARET_EQ] = ACTIONS(2997),
    [anon_sym_COLON_EQ] = ACTIONS(2997),
    [anon_sym_lock] = ACTIONS(2997),
    [anon_sym_rlock] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(2997),
    [anon_sym_sql] = ACTIONS(2997),
    [sym_int_literal] = ACTIONS(2997),
    [sym_float_literal] = ACTIONS(2997),
    [sym_rune_literal] = ACTIONS(2997),
    [anon_sym_SQUOTE] = ACTIONS(2997),
    [anon_sym_DQUOTE] = ACTIONS(2997),
    [anon_sym_c_SQUOTE] = ACTIONS(2997),
    [anon_sym_c_DQUOTE] = ACTIONS(2997),
    [anon_sym_r_SQUOTE] = ACTIONS(2997),
    [anon_sym_r_DQUOTE] = ACTIONS(2997),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2997),
    [anon_sym_shared] = ACTIONS(2997),
    [anon_sym_map_LBRACK] = ACTIONS(2997),
    [anon_sym_chan] = ACTIONS(2997),
    [anon_sym_thread] = ACTIONS(2997),
    [anon_sym_atomic] = ACTIONS(2997),
    [anon_sym_assert] = ACTIONS(2997),
    [anon_sym_defer] = ACTIONS(2997),
    [anon_sym_goto] = ACTIONS(2997),
    [anon_sym_break] = ACTIONS(2997),
    [anon_sym_continue] = ACTIONS(2997),
    [anon_sym_return] = ACTIONS(2997),
    [anon_sym_DOLLARfor] = ACTIONS(2997),
    [anon_sym_for] = ACTIONS(2997),
    [anon_sym_POUND] = ACTIONS(2997),
    [anon_sym_asm] = ACTIONS(2997),
    [anon_sym_AT_LBRACK] = ACTIONS(2997),
  },
  [461] = {
    [sym_line_comment] = STATE(461),
    [sym_block_comment] = STATE(461),
    [ts_builtin_sym_end] = ACTIONS(2999),
    [sym_identifier] = ACTIONS(3001),
    [anon_sym_LF] = ACTIONS(3001),
    [anon_sym_CR] = ACTIONS(3001),
    [anon_sym_CR_LF] = ACTIONS(3001),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3001),
    [anon_sym_as] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_COMMA] = ACTIONS(3001),
    [anon_sym_const] = ACTIONS(3001),
    [anon_sym_LPAREN] = ACTIONS(3001),
    [anon_sym_EQ] = ACTIONS(3001),
    [anon_sym___global] = ACTIONS(3001),
    [anon_sym_type] = ACTIONS(3001),
    [anon_sym_fn] = ACTIONS(3001),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_STAR] = ACTIONS(3001),
    [anon_sym_SLASH] = ACTIONS(3001),
    [anon_sym_PERCENT] = ACTIONS(3001),
    [anon_sym_LT] = ACTIONS(3001),
    [anon_sym_GT] = ACTIONS(3001),
    [anon_sym_EQ_EQ] = ACTIONS(3001),
    [anon_sym_BANG_EQ] = ACTIONS(3001),
    [anon_sym_LT_EQ] = ACTIONS(3001),
    [anon_sym_GT_EQ] = ACTIONS(3001),
    [anon_sym_LBRACK] = ACTIONS(2999),
    [anon_sym_struct] = ACTIONS(3001),
    [anon_sym_union] = ACTIONS(3001),
    [anon_sym_pub] = ACTIONS(3001),
    [anon_sym_mut] = ACTIONS(3001),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_interface] = ACTIONS(3001),
    [anon_sym_PLUS_PLUS] = ACTIONS(3001),
    [anon_sym_DASH_DASH] = ACTIONS(3001),
    [anon_sym_QMARK] = ACTIONS(3001),
    [anon_sym_BANG] = ACTIONS(3001),
    [anon_sym_go] = ACTIONS(3001),
    [anon_sym_spawn] = ACTIONS(3001),
    [anon_sym_json_DOTdecode] = ACTIONS(3001),
    [anon_sym_PIPE] = ACTIONS(3001),
    [anon_sym_LBRACK2] = ACTIONS(3001),
    [anon_sym_TILDE] = ACTIONS(3001),
    [anon_sym_CARET] = ACTIONS(3001),
    [anon_sym_AMP] = ACTIONS(3001),
    [anon_sym_LT_DASH] = ACTIONS(3001),
    [anon_sym_LT_LT] = ACTIONS(3001),
    [anon_sym_GT_GT] = ACTIONS(3001),
    [anon_sym_GT_GT_GT] = ACTIONS(3001),
    [anon_sym_AMP_CARET] = ACTIONS(3001),
    [anon_sym_AMP_AMP] = ACTIONS(3001),
    [anon_sym_PIPE_PIPE] = ACTIONS(3001),
    [anon_sym_or] = ACTIONS(3001),
    [sym_none] = ACTIONS(3001),
    [sym_true] = ACTIONS(3001),
    [sym_false] = ACTIONS(3001),
    [sym_nil] = ACTIONS(3001),
    [anon_sym_QMARK_DOT] = ACTIONS(3001),
    [anon_sym_POUND_LBRACK] = ACTIONS(3001),
    [anon_sym_if] = ACTIONS(3001),
    [anon_sym_DOLLARif] = ACTIONS(3001),
    [anon_sym_is] = ACTIONS(3001),
    [anon_sym_BANGis] = ACTIONS(3001),
    [anon_sym_in] = ACTIONS(3001),
    [anon_sym_BANGin] = ACTIONS(3001),
    [anon_sym_match] = ACTIONS(3001),
    [anon_sym_select] = ACTIONS(3001),
    [anon_sym_STAR_EQ] = ACTIONS(3001),
    [anon_sym_SLASH_EQ] = ACTIONS(3001),
    [anon_sym_PERCENT_EQ] = ACTIONS(3001),
    [anon_sym_LT_LT_EQ] = ACTIONS(3001),
    [anon_sym_GT_GT_EQ] = ACTIONS(3001),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3001),
    [anon_sym_AMP_EQ] = ACTIONS(3001),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3001),
    [anon_sym_PLUS_EQ] = ACTIONS(3001),
    [anon_sym_DASH_EQ] = ACTIONS(3001),
    [anon_sym_PIPE_EQ] = ACTIONS(3001),
    [anon_sym_CARET_EQ] = ACTIONS(3001),
    [anon_sym_COLON_EQ] = ACTIONS(3001),
    [anon_sym_lock] = ACTIONS(3001),
    [anon_sym_rlock] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(3001),
    [anon_sym_sql] = ACTIONS(3001),
    [sym_int_literal] = ACTIONS(3001),
    [sym_float_literal] = ACTIONS(3001),
    [sym_rune_literal] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3001),
    [anon_sym_DQUOTE] = ACTIONS(3001),
    [anon_sym_c_SQUOTE] = ACTIONS(3001),
    [anon_sym_c_DQUOTE] = ACTIONS(3001),
    [anon_sym_r_SQUOTE] = ACTIONS(3001),
    [anon_sym_r_DQUOTE] = ACTIONS(3001),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3001),
    [anon_sym_shared] = ACTIONS(3001),
    [anon_sym_map_LBRACK] = ACTIONS(3001),
    [anon_sym_chan] = ACTIONS(3001),
    [anon_sym_thread] = ACTIONS(3001),
    [anon_sym_atomic] = ACTIONS(3001),
    [anon_sym_assert] = ACTIONS(3001),
    [anon_sym_defer] = ACTIONS(3001),
    [anon_sym_goto] = ACTIONS(3001),
    [anon_sym_break] = ACTIONS(3001),
    [anon_sym_continue] = ACTIONS(3001),
    [anon_sym_return] = ACTIONS(3001),
    [anon_sym_DOLLARfor] = ACTIONS(3001),
    [anon_sym_for] = ACTIONS(3001),
    [anon_sym_POUND] = ACTIONS(3001),
    [anon_sym_asm] = ACTIONS(3001),
    [anon_sym_AT_LBRACK] = ACTIONS(3001),
  },
  [462] = {
    [sym_line_comment] = STATE(462),
    [sym_block_comment] = STATE(462),
    [sym__expression] = STATE(1556),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_string_interpolation_repeat1] = STATE(430),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_RBRACE] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_go] = ACTIONS(2903),
    [anon_sym_spawn] = ACTIONS(2905),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_LT_DASH] = ACTIONS(2909),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(2911),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_rlock] = ACTIONS(2913),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [463] = {
    [sym_line_comment] = STATE(463),
    [sym_block_comment] = STATE(463),
    [ts_builtin_sym_end] = ACTIONS(3005),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_LF] = ACTIONS(3007),
    [anon_sym_CR] = ACTIONS(3007),
    [anon_sym_CR_LF] = ACTIONS(3007),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3007),
    [anon_sym_as] = ACTIONS(3007),
    [anon_sym_LBRACE] = ACTIONS(3007),
    [anon_sym_COMMA] = ACTIONS(3007),
    [anon_sym_const] = ACTIONS(3007),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_EQ] = ACTIONS(3007),
    [anon_sym___global] = ACTIONS(3007),
    [anon_sym_type] = ACTIONS(3007),
    [anon_sym_fn] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_STAR] = ACTIONS(3007),
    [anon_sym_SLASH] = ACTIONS(3007),
    [anon_sym_PERCENT] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(3007),
    [anon_sym_GT] = ACTIONS(3007),
    [anon_sym_EQ_EQ] = ACTIONS(3007),
    [anon_sym_BANG_EQ] = ACTIONS(3007),
    [anon_sym_LT_EQ] = ACTIONS(3007),
    [anon_sym_GT_EQ] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3005),
    [anon_sym_struct] = ACTIONS(3007),
    [anon_sym_union] = ACTIONS(3007),
    [anon_sym_pub] = ACTIONS(3007),
    [anon_sym_mut] = ACTIONS(3007),
    [anon_sym_enum] = ACTIONS(3007),
    [anon_sym_interface] = ACTIONS(3007),
    [anon_sym_PLUS_PLUS] = ACTIONS(3007),
    [anon_sym_DASH_DASH] = ACTIONS(3007),
    [anon_sym_QMARK] = ACTIONS(3007),
    [anon_sym_BANG] = ACTIONS(3007),
    [anon_sym_go] = ACTIONS(3007),
    [anon_sym_spawn] = ACTIONS(3007),
    [anon_sym_json_DOTdecode] = ACTIONS(3007),
    [anon_sym_PIPE] = ACTIONS(3007),
    [anon_sym_LBRACK2] = ACTIONS(3007),
    [anon_sym_TILDE] = ACTIONS(3007),
    [anon_sym_CARET] = ACTIONS(3007),
    [anon_sym_AMP] = ACTIONS(3007),
    [anon_sym_LT_DASH] = ACTIONS(3007),
    [anon_sym_LT_LT] = ACTIONS(3007),
    [anon_sym_GT_GT] = ACTIONS(3007),
    [anon_sym_GT_GT_GT] = ACTIONS(3007),
    [anon_sym_AMP_CARET] = ACTIONS(3007),
    [anon_sym_AMP_AMP] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3007),
    [anon_sym_or] = ACTIONS(3007),
    [sym_none] = ACTIONS(3007),
    [sym_true] = ACTIONS(3007),
    [sym_false] = ACTIONS(3007),
    [sym_nil] = ACTIONS(3007),
    [anon_sym_QMARK_DOT] = ACTIONS(3007),
    [anon_sym_POUND_LBRACK] = ACTIONS(3007),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_DOLLARif] = ACTIONS(3007),
    [anon_sym_is] = ACTIONS(3007),
    [anon_sym_BANGis] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3007),
    [anon_sym_BANGin] = ACTIONS(3007),
    [anon_sym_match] = ACTIONS(3007),
    [anon_sym_select] = ACTIONS(3007),
    [anon_sym_STAR_EQ] = ACTIONS(3007),
    [anon_sym_SLASH_EQ] = ACTIONS(3007),
    [anon_sym_PERCENT_EQ] = ACTIONS(3007),
    [anon_sym_LT_LT_EQ] = ACTIONS(3007),
    [anon_sym_GT_GT_EQ] = ACTIONS(3007),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3007),
    [anon_sym_AMP_EQ] = ACTIONS(3007),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3007),
    [anon_sym_PLUS_EQ] = ACTIONS(3007),
    [anon_sym_DASH_EQ] = ACTIONS(3007),
    [anon_sym_PIPE_EQ] = ACTIONS(3007),
    [anon_sym_CARET_EQ] = ACTIONS(3007),
    [anon_sym_COLON_EQ] = ACTIONS(3007),
    [anon_sym_lock] = ACTIONS(3007),
    [anon_sym_rlock] = ACTIONS(3007),
    [anon_sym_unsafe] = ACTIONS(3007),
    [anon_sym_sql] = ACTIONS(3007),
    [sym_int_literal] = ACTIONS(3007),
    [sym_float_literal] = ACTIONS(3007),
    [sym_rune_literal] = ACTIONS(3007),
    [anon_sym_SQUOTE] = ACTIONS(3007),
    [anon_sym_DQUOTE] = ACTIONS(3007),
    [anon_sym_c_SQUOTE] = ACTIONS(3007),
    [anon_sym_c_DQUOTE] = ACTIONS(3007),
    [anon_sym_r_SQUOTE] = ACTIONS(3007),
    [anon_sym_r_DQUOTE] = ACTIONS(3007),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3007),
    [anon_sym_shared] = ACTIONS(3007),
    [anon_sym_map_LBRACK] = ACTIONS(3007),
    [anon_sym_chan] = ACTIONS(3007),
    [anon_sym_thread] = ACTIONS(3007),
    [anon_sym_atomic] = ACTIONS(3007),
    [anon_sym_assert] = ACTIONS(3007),
    [anon_sym_defer] = ACTIONS(3007),
    [anon_sym_goto] = ACTIONS(3007),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_continue] = ACTIONS(3007),
    [anon_sym_return] = ACTIONS(3007),
    [anon_sym_DOLLARfor] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3007),
    [anon_sym_POUND] = ACTIONS(3007),
    [anon_sym_asm] = ACTIONS(3007),
    [anon_sym_AT_LBRACK] = ACTIONS(3007),
  },
  [464] = {
    [sym_line_comment] = STATE(464),
    [sym_block_comment] = STATE(464),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(402),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(3009),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [465] = {
    [sym_line_comment] = STATE(465),
    [sym_block_comment] = STATE(465),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1693),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1692),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(343),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(3011),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1615),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [466] = {
    [sym_line_comment] = STATE(466),
    [sym_block_comment] = STATE(466),
    [ts_builtin_sym_end] = ACTIONS(3013),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_LF] = ACTIONS(3015),
    [anon_sym_CR] = ACTIONS(3015),
    [anon_sym_CR_LF] = ACTIONS(3015),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3015),
    [anon_sym_as] = ACTIONS(3015),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_COMMA] = ACTIONS(3015),
    [anon_sym_const] = ACTIONS(3015),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_EQ] = ACTIONS(3015),
    [anon_sym___global] = ACTIONS(3015),
    [anon_sym_type] = ACTIONS(3015),
    [anon_sym_fn] = ACTIONS(3015),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(3015),
    [anon_sym_SLASH] = ACTIONS(3015),
    [anon_sym_PERCENT] = ACTIONS(3015),
    [anon_sym_LT] = ACTIONS(3015),
    [anon_sym_GT] = ACTIONS(3015),
    [anon_sym_EQ_EQ] = ACTIONS(3015),
    [anon_sym_BANG_EQ] = ACTIONS(3015),
    [anon_sym_LT_EQ] = ACTIONS(3015),
    [anon_sym_GT_EQ] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3013),
    [anon_sym_struct] = ACTIONS(3015),
    [anon_sym_union] = ACTIONS(3015),
    [anon_sym_pub] = ACTIONS(3015),
    [anon_sym_mut] = ACTIONS(3015),
    [anon_sym_enum] = ACTIONS(3015),
    [anon_sym_interface] = ACTIONS(3015),
    [anon_sym_PLUS_PLUS] = ACTIONS(3015),
    [anon_sym_DASH_DASH] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_BANG] = ACTIONS(3015),
    [anon_sym_go] = ACTIONS(3015),
    [anon_sym_spawn] = ACTIONS(3015),
    [anon_sym_json_DOTdecode] = ACTIONS(3015),
    [anon_sym_PIPE] = ACTIONS(3015),
    [anon_sym_LBRACK2] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3015),
    [anon_sym_CARET] = ACTIONS(3015),
    [anon_sym_AMP] = ACTIONS(3015),
    [anon_sym_LT_DASH] = ACTIONS(3015),
    [anon_sym_LT_LT] = ACTIONS(3015),
    [anon_sym_GT_GT] = ACTIONS(3015),
    [anon_sym_GT_GT_GT] = ACTIONS(3015),
    [anon_sym_AMP_CARET] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_or] = ACTIONS(3015),
    [sym_none] = ACTIONS(3015),
    [sym_true] = ACTIONS(3015),
    [sym_false] = ACTIONS(3015),
    [sym_nil] = ACTIONS(3015),
    [anon_sym_QMARK_DOT] = ACTIONS(3015),
    [anon_sym_POUND_LBRACK] = ACTIONS(3015),
    [anon_sym_if] = ACTIONS(3015),
    [anon_sym_DOLLARif] = ACTIONS(3015),
    [anon_sym_is] = ACTIONS(3015),
    [anon_sym_BANGis] = ACTIONS(3015),
    [anon_sym_in] = ACTIONS(3015),
    [anon_sym_BANGin] = ACTIONS(3015),
    [anon_sym_match] = ACTIONS(3015),
    [anon_sym_select] = ACTIONS(3015),
    [anon_sym_STAR_EQ] = ACTIONS(3015),
    [anon_sym_SLASH_EQ] = ACTIONS(3015),
    [anon_sym_PERCENT_EQ] = ACTIONS(3015),
    [anon_sym_LT_LT_EQ] = ACTIONS(3015),
    [anon_sym_GT_GT_EQ] = ACTIONS(3015),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3015),
    [anon_sym_AMP_EQ] = ACTIONS(3015),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3015),
    [anon_sym_PLUS_EQ] = ACTIONS(3015),
    [anon_sym_DASH_EQ] = ACTIONS(3015),
    [anon_sym_PIPE_EQ] = ACTIONS(3015),
    [anon_sym_CARET_EQ] = ACTIONS(3015),
    [anon_sym_COLON_EQ] = ACTIONS(3015),
    [anon_sym_lock] = ACTIONS(3015),
    [anon_sym_rlock] = ACTIONS(3015),
    [anon_sym_unsafe] = ACTIONS(3015),
    [anon_sym_sql] = ACTIONS(3015),
    [sym_int_literal] = ACTIONS(3015),
    [sym_float_literal] = ACTIONS(3015),
    [sym_rune_literal] = ACTIONS(3015),
    [anon_sym_SQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_c_SQUOTE] = ACTIONS(3015),
    [anon_sym_c_DQUOTE] = ACTIONS(3015),
    [anon_sym_r_SQUOTE] = ACTIONS(3015),
    [anon_sym_r_DQUOTE] = ACTIONS(3015),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3015),
    [anon_sym_shared] = ACTIONS(3015),
    [anon_sym_map_LBRACK] = ACTIONS(3015),
    [anon_sym_chan] = ACTIONS(3015),
    [anon_sym_thread] = ACTIONS(3015),
    [anon_sym_atomic] = ACTIONS(3015),
    [anon_sym_assert] = ACTIONS(3015),
    [anon_sym_defer] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3015),
    [anon_sym_break] = ACTIONS(3015),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_return] = ACTIONS(3015),
    [anon_sym_DOLLARfor] = ACTIONS(3015),
    [anon_sym_for] = ACTIONS(3015),
    [anon_sym_POUND] = ACTIONS(3015),
    [anon_sym_asm] = ACTIONS(3015),
    [anon_sym_AT_LBRACK] = ACTIONS(3015),
  },
  [467] = {
    [sym_line_comment] = STATE(467),
    [sym_block_comment] = STATE(467),
    [ts_builtin_sym_end] = ACTIONS(3017),
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_LF] = ACTIONS(3019),
    [anon_sym_CR] = ACTIONS(3019),
    [anon_sym_CR_LF] = ACTIONS(3019),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3019),
    [anon_sym_as] = ACTIONS(3019),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_COMMA] = ACTIONS(3019),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym_EQ] = ACTIONS(3019),
    [anon_sym___global] = ACTIONS(3019),
    [anon_sym_type] = ACTIONS(3019),
    [anon_sym_fn] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_STAR] = ACTIONS(3019),
    [anon_sym_SLASH] = ACTIONS(3019),
    [anon_sym_PERCENT] = ACTIONS(3019),
    [anon_sym_LT] = ACTIONS(3019),
    [anon_sym_GT] = ACTIONS(3019),
    [anon_sym_EQ_EQ] = ACTIONS(3019),
    [anon_sym_BANG_EQ] = ACTIONS(3019),
    [anon_sym_LT_EQ] = ACTIONS(3019),
    [anon_sym_GT_EQ] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3017),
    [anon_sym_struct] = ACTIONS(3019),
    [anon_sym_union] = ACTIONS(3019),
    [anon_sym_pub] = ACTIONS(3019),
    [anon_sym_mut] = ACTIONS(3019),
    [anon_sym_enum] = ACTIONS(3019),
    [anon_sym_interface] = ACTIONS(3019),
    [anon_sym_PLUS_PLUS] = ACTIONS(3019),
    [anon_sym_DASH_DASH] = ACTIONS(3019),
    [anon_sym_QMARK] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_go] = ACTIONS(3019),
    [anon_sym_spawn] = ACTIONS(3019),
    [anon_sym_json_DOTdecode] = ACTIONS(3019),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_LBRACK2] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_LT_DASH] = ACTIONS(3019),
    [anon_sym_LT_LT] = ACTIONS(3019),
    [anon_sym_GT_GT] = ACTIONS(3019),
    [anon_sym_GT_GT_GT] = ACTIONS(3019),
    [anon_sym_AMP_CARET] = ACTIONS(3019),
    [anon_sym_AMP_AMP] = ACTIONS(3019),
    [anon_sym_PIPE_PIPE] = ACTIONS(3019),
    [anon_sym_or] = ACTIONS(3019),
    [sym_none] = ACTIONS(3019),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_nil] = ACTIONS(3019),
    [anon_sym_QMARK_DOT] = ACTIONS(3019),
    [anon_sym_POUND_LBRACK] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_DOLLARif] = ACTIONS(3019),
    [anon_sym_is] = ACTIONS(3019),
    [anon_sym_BANGis] = ACTIONS(3019),
    [anon_sym_in] = ACTIONS(3019),
    [anon_sym_BANGin] = ACTIONS(3019),
    [anon_sym_match] = ACTIONS(3019),
    [anon_sym_select] = ACTIONS(3019),
    [anon_sym_STAR_EQ] = ACTIONS(3019),
    [anon_sym_SLASH_EQ] = ACTIONS(3019),
    [anon_sym_PERCENT_EQ] = ACTIONS(3019),
    [anon_sym_LT_LT_EQ] = ACTIONS(3019),
    [anon_sym_GT_GT_EQ] = ACTIONS(3019),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3019),
    [anon_sym_AMP_EQ] = ACTIONS(3019),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3019),
    [anon_sym_PLUS_EQ] = ACTIONS(3019),
    [anon_sym_DASH_EQ] = ACTIONS(3019),
    [anon_sym_PIPE_EQ] = ACTIONS(3019),
    [anon_sym_CARET_EQ] = ACTIONS(3019),
    [anon_sym_COLON_EQ] = ACTIONS(3019),
    [anon_sym_lock] = ACTIONS(3019),
    [anon_sym_rlock] = ACTIONS(3019),
    [anon_sym_unsafe] = ACTIONS(3019),
    [anon_sym_sql] = ACTIONS(3019),
    [sym_int_literal] = ACTIONS(3019),
    [sym_float_literal] = ACTIONS(3019),
    [sym_rune_literal] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_c_SQUOTE] = ACTIONS(3019),
    [anon_sym_c_DQUOTE] = ACTIONS(3019),
    [anon_sym_r_SQUOTE] = ACTIONS(3019),
    [anon_sym_r_DQUOTE] = ACTIONS(3019),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3019),
    [anon_sym_shared] = ACTIONS(3019),
    [anon_sym_map_LBRACK] = ACTIONS(3019),
    [anon_sym_chan] = ACTIONS(3019),
    [anon_sym_thread] = ACTIONS(3019),
    [anon_sym_atomic] = ACTIONS(3019),
    [anon_sym_assert] = ACTIONS(3019),
    [anon_sym_defer] = ACTIONS(3019),
    [anon_sym_goto] = ACTIONS(3019),
    [anon_sym_break] = ACTIONS(3019),
    [anon_sym_continue] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_DOLLARfor] = ACTIONS(3019),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_POUND] = ACTIONS(3019),
    [anon_sym_asm] = ACTIONS(3019),
    [anon_sym_AT_LBRACK] = ACTIONS(3019),
  },
  [468] = {
    [sym_line_comment] = STATE(468),
    [sym_block_comment] = STATE(468),
    [ts_builtin_sym_end] = ACTIONS(3021),
    [sym_identifier] = ACTIONS(3023),
    [anon_sym_LF] = ACTIONS(3023),
    [anon_sym_CR] = ACTIONS(3023),
    [anon_sym_CR_LF] = ACTIONS(3023),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3023),
    [anon_sym_as] = ACTIONS(3023),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_COMMA] = ACTIONS(3023),
    [anon_sym_const] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_EQ] = ACTIONS(3023),
    [anon_sym___global] = ACTIONS(3023),
    [anon_sym_type] = ACTIONS(3023),
    [anon_sym_fn] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_STAR] = ACTIONS(3023),
    [anon_sym_SLASH] = ACTIONS(3023),
    [anon_sym_PERCENT] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3023),
    [anon_sym_GT] = ACTIONS(3023),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT_EQ] = ACTIONS(3023),
    [anon_sym_GT_EQ] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3021),
    [anon_sym_struct] = ACTIONS(3023),
    [anon_sym_union] = ACTIONS(3023),
    [anon_sym_pub] = ACTIONS(3023),
    [anon_sym_mut] = ACTIONS(3023),
    [anon_sym_enum] = ACTIONS(3023),
    [anon_sym_interface] = ACTIONS(3023),
    [anon_sym_PLUS_PLUS] = ACTIONS(3023),
    [anon_sym_DASH_DASH] = ACTIONS(3023),
    [anon_sym_QMARK] = ACTIONS(3023),
    [anon_sym_BANG] = ACTIONS(3023),
    [anon_sym_go] = ACTIONS(3023),
    [anon_sym_spawn] = ACTIONS(3023),
    [anon_sym_json_DOTdecode] = ACTIONS(3023),
    [anon_sym_PIPE] = ACTIONS(3023),
    [anon_sym_LBRACK2] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3023),
    [anon_sym_CARET] = ACTIONS(3023),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_LT_DASH] = ACTIONS(3023),
    [anon_sym_LT_LT] = ACTIONS(3023),
    [anon_sym_GT_GT] = ACTIONS(3023),
    [anon_sym_GT_GT_GT] = ACTIONS(3023),
    [anon_sym_AMP_CARET] = ACTIONS(3023),
    [anon_sym_AMP_AMP] = ACTIONS(3023),
    [anon_sym_PIPE_PIPE] = ACTIONS(3023),
    [anon_sym_or] = ACTIONS(3023),
    [sym_none] = ACTIONS(3023),
    [sym_true] = ACTIONS(3023),
    [sym_false] = ACTIONS(3023),
    [sym_nil] = ACTIONS(3023),
    [anon_sym_QMARK_DOT] = ACTIONS(3023),
    [anon_sym_POUND_LBRACK] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_DOLLARif] = ACTIONS(3023),
    [anon_sym_is] = ACTIONS(3023),
    [anon_sym_BANGis] = ACTIONS(3023),
    [anon_sym_in] = ACTIONS(3023),
    [anon_sym_BANGin] = ACTIONS(3023),
    [anon_sym_match] = ACTIONS(3023),
    [anon_sym_select] = ACTIONS(3023),
    [anon_sym_STAR_EQ] = ACTIONS(3023),
    [anon_sym_SLASH_EQ] = ACTIONS(3023),
    [anon_sym_PERCENT_EQ] = ACTIONS(3023),
    [anon_sym_LT_LT_EQ] = ACTIONS(3023),
    [anon_sym_GT_GT_EQ] = ACTIONS(3023),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3023),
    [anon_sym_AMP_EQ] = ACTIONS(3023),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3023),
    [anon_sym_PLUS_EQ] = ACTIONS(3023),
    [anon_sym_DASH_EQ] = ACTIONS(3023),
    [anon_sym_PIPE_EQ] = ACTIONS(3023),
    [anon_sym_CARET_EQ] = ACTIONS(3023),
    [anon_sym_COLON_EQ] = ACTIONS(3023),
    [anon_sym_lock] = ACTIONS(3023),
    [anon_sym_rlock] = ACTIONS(3023),
    [anon_sym_unsafe] = ACTIONS(3023),
    [anon_sym_sql] = ACTIONS(3023),
    [sym_int_literal] = ACTIONS(3023),
    [sym_float_literal] = ACTIONS(3023),
    [sym_rune_literal] = ACTIONS(3023),
    [anon_sym_SQUOTE] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_c_SQUOTE] = ACTIONS(3023),
    [anon_sym_c_DQUOTE] = ACTIONS(3023),
    [anon_sym_r_SQUOTE] = ACTIONS(3023),
    [anon_sym_r_DQUOTE] = ACTIONS(3023),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3023),
    [anon_sym_shared] = ACTIONS(3023),
    [anon_sym_map_LBRACK] = ACTIONS(3023),
    [anon_sym_chan] = ACTIONS(3023),
    [anon_sym_thread] = ACTIONS(3023),
    [anon_sym_atomic] = ACTIONS(3023),
    [anon_sym_assert] = ACTIONS(3023),
    [anon_sym_defer] = ACTIONS(3023),
    [anon_sym_goto] = ACTIONS(3023),
    [anon_sym_break] = ACTIONS(3023),
    [anon_sym_continue] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_DOLLARfor] = ACTIONS(3023),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_POUND] = ACTIONS(3023),
    [anon_sym_asm] = ACTIONS(3023),
    [anon_sym_AT_LBRACK] = ACTIONS(3023),
  },
  [469] = {
    [sym_line_comment] = STATE(469),
    [sym_block_comment] = STATE(469),
    [ts_builtin_sym_end] = ACTIONS(3025),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_LF] = ACTIONS(3027),
    [anon_sym_CR] = ACTIONS(3027),
    [anon_sym_CR_LF] = ACTIONS(3027),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3027),
    [anon_sym_as] = ACTIONS(3027),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_COMMA] = ACTIONS(3027),
    [anon_sym_const] = ACTIONS(3027),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym_EQ] = ACTIONS(3027),
    [anon_sym___global] = ACTIONS(3027),
    [anon_sym_type] = ACTIONS(3027),
    [anon_sym_fn] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_STAR] = ACTIONS(3027),
    [anon_sym_SLASH] = ACTIONS(3027),
    [anon_sym_PERCENT] = ACTIONS(3027),
    [anon_sym_LT] = ACTIONS(3027),
    [anon_sym_GT] = ACTIONS(3027),
    [anon_sym_EQ_EQ] = ACTIONS(3027),
    [anon_sym_BANG_EQ] = ACTIONS(3027),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3025),
    [anon_sym_struct] = ACTIONS(3027),
    [anon_sym_union] = ACTIONS(3027),
    [anon_sym_pub] = ACTIONS(3027),
    [anon_sym_mut] = ACTIONS(3027),
    [anon_sym_enum] = ACTIONS(3027),
    [anon_sym_interface] = ACTIONS(3027),
    [anon_sym_PLUS_PLUS] = ACTIONS(3027),
    [anon_sym_DASH_DASH] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_BANG] = ACTIONS(3027),
    [anon_sym_go] = ACTIONS(3027),
    [anon_sym_spawn] = ACTIONS(3027),
    [anon_sym_json_DOTdecode] = ACTIONS(3027),
    [anon_sym_PIPE] = ACTIONS(3027),
    [anon_sym_LBRACK2] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3027),
    [anon_sym_CARET] = ACTIONS(3027),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_LT_DASH] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3027),
    [anon_sym_GT_GT] = ACTIONS(3027),
    [anon_sym_GT_GT_GT] = ACTIONS(3027),
    [anon_sym_AMP_CARET] = ACTIONS(3027),
    [anon_sym_AMP_AMP] = ACTIONS(3027),
    [anon_sym_PIPE_PIPE] = ACTIONS(3027),
    [anon_sym_or] = ACTIONS(3027),
    [sym_none] = ACTIONS(3027),
    [sym_true] = ACTIONS(3027),
    [sym_false] = ACTIONS(3027),
    [sym_nil] = ACTIONS(3027),
    [anon_sym_QMARK_DOT] = ACTIONS(3027),
    [anon_sym_POUND_LBRACK] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_DOLLARif] = ACTIONS(3027),
    [anon_sym_is] = ACTIONS(3027),
    [anon_sym_BANGis] = ACTIONS(3027),
    [anon_sym_in] = ACTIONS(3027),
    [anon_sym_BANGin] = ACTIONS(3027),
    [anon_sym_match] = ACTIONS(3027),
    [anon_sym_select] = ACTIONS(3027),
    [anon_sym_STAR_EQ] = ACTIONS(3027),
    [anon_sym_SLASH_EQ] = ACTIONS(3027),
    [anon_sym_PERCENT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_GT_EQ] = ACTIONS(3027),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3027),
    [anon_sym_AMP_EQ] = ACTIONS(3027),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3027),
    [anon_sym_PLUS_EQ] = ACTIONS(3027),
    [anon_sym_DASH_EQ] = ACTIONS(3027),
    [anon_sym_PIPE_EQ] = ACTIONS(3027),
    [anon_sym_CARET_EQ] = ACTIONS(3027),
    [anon_sym_COLON_EQ] = ACTIONS(3027),
    [anon_sym_lock] = ACTIONS(3027),
    [anon_sym_rlock] = ACTIONS(3027),
    [anon_sym_unsafe] = ACTIONS(3027),
    [anon_sym_sql] = ACTIONS(3027),
    [sym_int_literal] = ACTIONS(3027),
    [sym_float_literal] = ACTIONS(3027),
    [sym_rune_literal] = ACTIONS(3027),
    [anon_sym_SQUOTE] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_c_SQUOTE] = ACTIONS(3027),
    [anon_sym_c_DQUOTE] = ACTIONS(3027),
    [anon_sym_r_SQUOTE] = ACTIONS(3027),
    [anon_sym_r_DQUOTE] = ACTIONS(3027),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3027),
    [anon_sym_shared] = ACTIONS(3027),
    [anon_sym_map_LBRACK] = ACTIONS(3027),
    [anon_sym_chan] = ACTIONS(3027),
    [anon_sym_thread] = ACTIONS(3027),
    [anon_sym_atomic] = ACTIONS(3027),
    [anon_sym_assert] = ACTIONS(3027),
    [anon_sym_defer] = ACTIONS(3027),
    [anon_sym_goto] = ACTIONS(3027),
    [anon_sym_break] = ACTIONS(3027),
    [anon_sym_continue] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_DOLLARfor] = ACTIONS(3027),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_POUND] = ACTIONS(3027),
    [anon_sym_asm] = ACTIONS(3027),
    [anon_sym_AT_LBRACK] = ACTIONS(3027),
  },
  [470] = {
    [sym_line_comment] = STATE(470),
    [sym_block_comment] = STATE(470),
    [ts_builtin_sym_end] = ACTIONS(3029),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_LF] = ACTIONS(3031),
    [anon_sym_CR] = ACTIONS(3031),
    [anon_sym_CR_LF] = ACTIONS(3031),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3031),
    [anon_sym_as] = ACTIONS(3031),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_COMMA] = ACTIONS(3031),
    [anon_sym_const] = ACTIONS(3031),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym_EQ] = ACTIONS(3031),
    [anon_sym___global] = ACTIONS(3031),
    [anon_sym_type] = ACTIONS(3031),
    [anon_sym_fn] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_STAR] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3031),
    [anon_sym_PERCENT] = ACTIONS(3031),
    [anon_sym_LT] = ACTIONS(3031),
    [anon_sym_GT] = ACTIONS(3031),
    [anon_sym_EQ_EQ] = ACTIONS(3031),
    [anon_sym_BANG_EQ] = ACTIONS(3031),
    [anon_sym_LT_EQ] = ACTIONS(3031),
    [anon_sym_GT_EQ] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3029),
    [anon_sym_struct] = ACTIONS(3031),
    [anon_sym_union] = ACTIONS(3031),
    [anon_sym_pub] = ACTIONS(3031),
    [anon_sym_mut] = ACTIONS(3031),
    [anon_sym_enum] = ACTIONS(3031),
    [anon_sym_interface] = ACTIONS(3031),
    [anon_sym_PLUS_PLUS] = ACTIONS(3031),
    [anon_sym_DASH_DASH] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_BANG] = ACTIONS(3031),
    [anon_sym_go] = ACTIONS(3031),
    [anon_sym_spawn] = ACTIONS(3031),
    [anon_sym_json_DOTdecode] = ACTIONS(3031),
    [anon_sym_PIPE] = ACTIONS(3031),
    [anon_sym_LBRACK2] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3031),
    [anon_sym_CARET] = ACTIONS(3031),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_LT_DASH] = ACTIONS(3031),
    [anon_sym_LT_LT] = ACTIONS(3031),
    [anon_sym_GT_GT] = ACTIONS(3031),
    [anon_sym_GT_GT_GT] = ACTIONS(3031),
    [anon_sym_AMP_CARET] = ACTIONS(3031),
    [anon_sym_AMP_AMP] = ACTIONS(3031),
    [anon_sym_PIPE_PIPE] = ACTIONS(3031),
    [anon_sym_or] = ACTIONS(3031),
    [sym_none] = ACTIONS(3031),
    [sym_true] = ACTIONS(3031),
    [sym_false] = ACTIONS(3031),
    [sym_nil] = ACTIONS(3031),
    [anon_sym_QMARK_DOT] = ACTIONS(3031),
    [anon_sym_POUND_LBRACK] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_DOLLARif] = ACTIONS(3031),
    [anon_sym_is] = ACTIONS(3031),
    [anon_sym_BANGis] = ACTIONS(3031),
    [anon_sym_in] = ACTIONS(3031),
    [anon_sym_BANGin] = ACTIONS(3031),
    [anon_sym_match] = ACTIONS(3031),
    [anon_sym_select] = ACTIONS(3031),
    [anon_sym_STAR_EQ] = ACTIONS(3031),
    [anon_sym_SLASH_EQ] = ACTIONS(3031),
    [anon_sym_PERCENT_EQ] = ACTIONS(3031),
    [anon_sym_LT_LT_EQ] = ACTIONS(3031),
    [anon_sym_GT_GT_EQ] = ACTIONS(3031),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3031),
    [anon_sym_AMP_EQ] = ACTIONS(3031),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3031),
    [anon_sym_PLUS_EQ] = ACTIONS(3031),
    [anon_sym_DASH_EQ] = ACTIONS(3031),
    [anon_sym_PIPE_EQ] = ACTIONS(3031),
    [anon_sym_CARET_EQ] = ACTIONS(3031),
    [anon_sym_COLON_EQ] = ACTIONS(3031),
    [anon_sym_lock] = ACTIONS(3031),
    [anon_sym_rlock] = ACTIONS(3031),
    [anon_sym_unsafe] = ACTIONS(3031),
    [anon_sym_sql] = ACTIONS(3031),
    [sym_int_literal] = ACTIONS(3031),
    [sym_float_literal] = ACTIONS(3031),
    [sym_rune_literal] = ACTIONS(3031),
    [anon_sym_SQUOTE] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_c_SQUOTE] = ACTIONS(3031),
    [anon_sym_c_DQUOTE] = ACTIONS(3031),
    [anon_sym_r_SQUOTE] = ACTIONS(3031),
    [anon_sym_r_DQUOTE] = ACTIONS(3031),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3031),
    [anon_sym_shared] = ACTIONS(3031),
    [anon_sym_map_LBRACK] = ACTIONS(3031),
    [anon_sym_chan] = ACTIONS(3031),
    [anon_sym_thread] = ACTIONS(3031),
    [anon_sym_atomic] = ACTIONS(3031),
    [anon_sym_assert] = ACTIONS(3031),
    [anon_sym_defer] = ACTIONS(3031),
    [anon_sym_goto] = ACTIONS(3031),
    [anon_sym_break] = ACTIONS(3031),
    [anon_sym_continue] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_DOLLARfor] = ACTIONS(3031),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_POUND] = ACTIONS(3031),
    [anon_sym_asm] = ACTIONS(3031),
    [anon_sym_AT_LBRACK] = ACTIONS(3031),
  },
  [471] = {
    [sym_line_comment] = STATE(471),
    [sym_block_comment] = STATE(471),
    [ts_builtin_sym_end] = ACTIONS(3033),
    [sym_identifier] = ACTIONS(3035),
    [anon_sym_LF] = ACTIONS(3035),
    [anon_sym_CR] = ACTIONS(3035),
    [anon_sym_CR_LF] = ACTIONS(3035),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3035),
    [anon_sym_as] = ACTIONS(3035),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_COMMA] = ACTIONS(3035),
    [anon_sym_const] = ACTIONS(3035),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym___global] = ACTIONS(3035),
    [anon_sym_type] = ACTIONS(3035),
    [anon_sym_fn] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3035),
    [anon_sym_SLASH] = ACTIONS(3035),
    [anon_sym_PERCENT] = ACTIONS(3035),
    [anon_sym_LT] = ACTIONS(3035),
    [anon_sym_GT] = ACTIONS(3035),
    [anon_sym_EQ_EQ] = ACTIONS(3035),
    [anon_sym_BANG_EQ] = ACTIONS(3035),
    [anon_sym_LT_EQ] = ACTIONS(3035),
    [anon_sym_GT_EQ] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3033),
    [anon_sym_struct] = ACTIONS(3035),
    [anon_sym_union] = ACTIONS(3035),
    [anon_sym_pub] = ACTIONS(3035),
    [anon_sym_mut] = ACTIONS(3035),
    [anon_sym_enum] = ACTIONS(3035),
    [anon_sym_interface] = ACTIONS(3035),
    [anon_sym_PLUS_PLUS] = ACTIONS(3035),
    [anon_sym_DASH_DASH] = ACTIONS(3035),
    [anon_sym_QMARK] = ACTIONS(3035),
    [anon_sym_BANG] = ACTIONS(3035),
    [anon_sym_go] = ACTIONS(3035),
    [anon_sym_spawn] = ACTIONS(3035),
    [anon_sym_json_DOTdecode] = ACTIONS(3035),
    [anon_sym_PIPE] = ACTIONS(3035),
    [anon_sym_LBRACK2] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3035),
    [anon_sym_CARET] = ACTIONS(3035),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_LT_DASH] = ACTIONS(3035),
    [anon_sym_LT_LT] = ACTIONS(3035),
    [anon_sym_GT_GT] = ACTIONS(3035),
    [anon_sym_GT_GT_GT] = ACTIONS(3035),
    [anon_sym_AMP_CARET] = ACTIONS(3035),
    [anon_sym_AMP_AMP] = ACTIONS(3035),
    [anon_sym_PIPE_PIPE] = ACTIONS(3035),
    [anon_sym_or] = ACTIONS(3035),
    [sym_none] = ACTIONS(3035),
    [sym_true] = ACTIONS(3035),
    [sym_false] = ACTIONS(3035),
    [sym_nil] = ACTIONS(3035),
    [anon_sym_QMARK_DOT] = ACTIONS(3035),
    [anon_sym_POUND_LBRACK] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_DOLLARif] = ACTIONS(3035),
    [anon_sym_is] = ACTIONS(3035),
    [anon_sym_BANGis] = ACTIONS(3035),
    [anon_sym_in] = ACTIONS(3035),
    [anon_sym_BANGin] = ACTIONS(3035),
    [anon_sym_match] = ACTIONS(3035),
    [anon_sym_select] = ACTIONS(3035),
    [anon_sym_STAR_EQ] = ACTIONS(3035),
    [anon_sym_SLASH_EQ] = ACTIONS(3035),
    [anon_sym_PERCENT_EQ] = ACTIONS(3035),
    [anon_sym_LT_LT_EQ] = ACTIONS(3035),
    [anon_sym_GT_GT_EQ] = ACTIONS(3035),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3035),
    [anon_sym_AMP_EQ] = ACTIONS(3035),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3035),
    [anon_sym_PLUS_EQ] = ACTIONS(3035),
    [anon_sym_DASH_EQ] = ACTIONS(3035),
    [anon_sym_PIPE_EQ] = ACTIONS(3035),
    [anon_sym_CARET_EQ] = ACTIONS(3035),
    [anon_sym_COLON_EQ] = ACTIONS(3035),
    [anon_sym_lock] = ACTIONS(3035),
    [anon_sym_rlock] = ACTIONS(3035),
    [anon_sym_unsafe] = ACTIONS(3035),
    [anon_sym_sql] = ACTIONS(3035),
    [sym_int_literal] = ACTIONS(3035),
    [sym_float_literal] = ACTIONS(3035),
    [sym_rune_literal] = ACTIONS(3035),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_c_SQUOTE] = ACTIONS(3035),
    [anon_sym_c_DQUOTE] = ACTIONS(3035),
    [anon_sym_r_SQUOTE] = ACTIONS(3035),
    [anon_sym_r_DQUOTE] = ACTIONS(3035),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3035),
    [anon_sym_shared] = ACTIONS(3035),
    [anon_sym_map_LBRACK] = ACTIONS(3035),
    [anon_sym_chan] = ACTIONS(3035),
    [anon_sym_thread] = ACTIONS(3035),
    [anon_sym_atomic] = ACTIONS(3035),
    [anon_sym_assert] = ACTIONS(3035),
    [anon_sym_defer] = ACTIONS(3035),
    [anon_sym_goto] = ACTIONS(3035),
    [anon_sym_break] = ACTIONS(3035),
    [anon_sym_continue] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_DOLLARfor] = ACTIONS(3035),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_POUND] = ACTIONS(3035),
    [anon_sym_asm] = ACTIONS(3035),
    [anon_sym_AT_LBRACK] = ACTIONS(3035),
  },
  [472] = {
    [sym_line_comment] = STATE(472),
    [sym_block_comment] = STATE(472),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(402),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(3037),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [473] = {
    [sym_line_comment] = STATE(473),
    [sym_block_comment] = STATE(473),
    [ts_builtin_sym_end] = ACTIONS(3039),
    [sym_identifier] = ACTIONS(3041),
    [anon_sym_LF] = ACTIONS(3041),
    [anon_sym_CR] = ACTIONS(3041),
    [anon_sym_CR_LF] = ACTIONS(3041),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3041),
    [anon_sym_as] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3041),
    [anon_sym_COMMA] = ACTIONS(3041),
    [anon_sym_const] = ACTIONS(3041),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_EQ] = ACTIONS(3041),
    [anon_sym___global] = ACTIONS(3041),
    [anon_sym_type] = ACTIONS(3041),
    [anon_sym_fn] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3041),
    [anon_sym_DASH] = ACTIONS(3041),
    [anon_sym_STAR] = ACTIONS(3041),
    [anon_sym_SLASH] = ACTIONS(3041),
    [anon_sym_PERCENT] = ACTIONS(3041),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_GT] = ACTIONS(3041),
    [anon_sym_EQ_EQ] = ACTIONS(3041),
    [anon_sym_BANG_EQ] = ACTIONS(3041),
    [anon_sym_LT_EQ] = ACTIONS(3041),
    [anon_sym_GT_EQ] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_struct] = ACTIONS(3041),
    [anon_sym_union] = ACTIONS(3041),
    [anon_sym_pub] = ACTIONS(3041),
    [anon_sym_mut] = ACTIONS(3041),
    [anon_sym_enum] = ACTIONS(3041),
    [anon_sym_interface] = ACTIONS(3041),
    [anon_sym_PLUS_PLUS] = ACTIONS(3041),
    [anon_sym_DASH_DASH] = ACTIONS(3041),
    [anon_sym_QMARK] = ACTIONS(3041),
    [anon_sym_BANG] = ACTIONS(3041),
    [anon_sym_go] = ACTIONS(3041),
    [anon_sym_spawn] = ACTIONS(3041),
    [anon_sym_json_DOTdecode] = ACTIONS(3041),
    [anon_sym_PIPE] = ACTIONS(3041),
    [anon_sym_LBRACK2] = ACTIONS(3041),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_CARET] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3041),
    [anon_sym_LT_DASH] = ACTIONS(3041),
    [anon_sym_LT_LT] = ACTIONS(3041),
    [anon_sym_GT_GT] = ACTIONS(3041),
    [anon_sym_GT_GT_GT] = ACTIONS(3041),
    [anon_sym_AMP_CARET] = ACTIONS(3041),
    [anon_sym_AMP_AMP] = ACTIONS(3041),
    [anon_sym_PIPE_PIPE] = ACTIONS(3041),
    [anon_sym_or] = ACTIONS(3041),
    [sym_none] = ACTIONS(3041),
    [sym_true] = ACTIONS(3041),
    [sym_false] = ACTIONS(3041),
    [sym_nil] = ACTIONS(3041),
    [anon_sym_QMARK_DOT] = ACTIONS(3041),
    [anon_sym_POUND_LBRACK] = ACTIONS(3041),
    [anon_sym_if] = ACTIONS(3041),
    [anon_sym_DOLLARif] = ACTIONS(3041),
    [anon_sym_is] = ACTIONS(3041),
    [anon_sym_BANGis] = ACTIONS(3041),
    [anon_sym_in] = ACTIONS(3041),
    [anon_sym_BANGin] = ACTIONS(3041),
    [anon_sym_match] = ACTIONS(3041),
    [anon_sym_select] = ACTIONS(3041),
    [anon_sym_STAR_EQ] = ACTIONS(3041),
    [anon_sym_SLASH_EQ] = ACTIONS(3041),
    [anon_sym_PERCENT_EQ] = ACTIONS(3041),
    [anon_sym_LT_LT_EQ] = ACTIONS(3041),
    [anon_sym_GT_GT_EQ] = ACTIONS(3041),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3041),
    [anon_sym_AMP_EQ] = ACTIONS(3041),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3041),
    [anon_sym_PLUS_EQ] = ACTIONS(3041),
    [anon_sym_DASH_EQ] = ACTIONS(3041),
    [anon_sym_PIPE_EQ] = ACTIONS(3041),
    [anon_sym_CARET_EQ] = ACTIONS(3041),
    [anon_sym_COLON_EQ] = ACTIONS(3041),
    [anon_sym_lock] = ACTIONS(3041),
    [anon_sym_rlock] = ACTIONS(3041),
    [anon_sym_unsafe] = ACTIONS(3041),
    [anon_sym_sql] = ACTIONS(3041),
    [sym_int_literal] = ACTIONS(3041),
    [sym_float_literal] = ACTIONS(3041),
    [sym_rune_literal] = ACTIONS(3041),
    [anon_sym_SQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE] = ACTIONS(3041),
    [anon_sym_c_SQUOTE] = ACTIONS(3041),
    [anon_sym_c_DQUOTE] = ACTIONS(3041),
    [anon_sym_r_SQUOTE] = ACTIONS(3041),
    [anon_sym_r_DQUOTE] = ACTIONS(3041),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3041),
    [anon_sym_shared] = ACTIONS(3041),
    [anon_sym_map_LBRACK] = ACTIONS(3041),
    [anon_sym_chan] = ACTIONS(3041),
    [anon_sym_thread] = ACTIONS(3041),
    [anon_sym_atomic] = ACTIONS(3041),
    [anon_sym_assert] = ACTIONS(3041),
    [anon_sym_defer] = ACTIONS(3041),
    [anon_sym_goto] = ACTIONS(3041),
    [anon_sym_break] = ACTIONS(3041),
    [anon_sym_continue] = ACTIONS(3041),
    [anon_sym_return] = ACTIONS(3041),
    [anon_sym_DOLLARfor] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3041),
    [anon_sym_POUND] = ACTIONS(3041),
    [anon_sym_asm] = ACTIONS(3041),
    [anon_sym_AT_LBRACK] = ACTIONS(3041),
  },
  [474] = {
    [sym_line_comment] = STATE(474),
    [sym_block_comment] = STATE(474),
    [ts_builtin_sym_end] = ACTIONS(3043),
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_LF] = ACTIONS(3045),
    [anon_sym_CR] = ACTIONS(3045),
    [anon_sym_CR_LF] = ACTIONS(3045),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3045),
    [anon_sym_as] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3045),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_const] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3045),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym___global] = ACTIONS(3045),
    [anon_sym_type] = ACTIONS(3045),
    [anon_sym_fn] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3045),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_PERCENT] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_GT] = ACTIONS(3045),
    [anon_sym_EQ_EQ] = ACTIONS(3045),
    [anon_sym_BANG_EQ] = ACTIONS(3045),
    [anon_sym_LT_EQ] = ACTIONS(3045),
    [anon_sym_GT_EQ] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_struct] = ACTIONS(3045),
    [anon_sym_union] = ACTIONS(3045),
    [anon_sym_pub] = ACTIONS(3045),
    [anon_sym_mut] = ACTIONS(3045),
    [anon_sym_enum] = ACTIONS(3045),
    [anon_sym_interface] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3045),
    [anon_sym_go] = ACTIONS(3045),
    [anon_sym_spawn] = ACTIONS(3045),
    [anon_sym_json_DOTdecode] = ACTIONS(3045),
    [anon_sym_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACK2] = ACTIONS(3045),
    [anon_sym_TILDE] = ACTIONS(3045),
    [anon_sym_CARET] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3045),
    [anon_sym_LT_DASH] = ACTIONS(3045),
    [anon_sym_LT_LT] = ACTIONS(3045),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_GT_GT_GT] = ACTIONS(3045),
    [anon_sym_AMP_CARET] = ACTIONS(3045),
    [anon_sym_AMP_AMP] = ACTIONS(3045),
    [anon_sym_PIPE_PIPE] = ACTIONS(3045),
    [anon_sym_or] = ACTIONS(3045),
    [sym_none] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_nil] = ACTIONS(3045),
    [anon_sym_QMARK_DOT] = ACTIONS(3045),
    [anon_sym_POUND_LBRACK] = ACTIONS(3045),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_DOLLARif] = ACTIONS(3045),
    [anon_sym_is] = ACTIONS(3045),
    [anon_sym_BANGis] = ACTIONS(3045),
    [anon_sym_in] = ACTIONS(3045),
    [anon_sym_BANGin] = ACTIONS(3045),
    [anon_sym_match] = ACTIONS(3045),
    [anon_sym_select] = ACTIONS(3045),
    [anon_sym_STAR_EQ] = ACTIONS(3045),
    [anon_sym_SLASH_EQ] = ACTIONS(3045),
    [anon_sym_PERCENT_EQ] = ACTIONS(3045),
    [anon_sym_LT_LT_EQ] = ACTIONS(3045),
    [anon_sym_GT_GT_EQ] = ACTIONS(3045),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3045),
    [anon_sym_AMP_EQ] = ACTIONS(3045),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3045),
    [anon_sym_PLUS_EQ] = ACTIONS(3045),
    [anon_sym_DASH_EQ] = ACTIONS(3045),
    [anon_sym_PIPE_EQ] = ACTIONS(3045),
    [anon_sym_CARET_EQ] = ACTIONS(3045),
    [anon_sym_COLON_EQ] = ACTIONS(3045),
    [anon_sym_lock] = ACTIONS(3045),
    [anon_sym_rlock] = ACTIONS(3045),
    [anon_sym_unsafe] = ACTIONS(3045),
    [anon_sym_sql] = ACTIONS(3045),
    [sym_int_literal] = ACTIONS(3045),
    [sym_float_literal] = ACTIONS(3045),
    [sym_rune_literal] = ACTIONS(3045),
    [anon_sym_SQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE] = ACTIONS(3045),
    [anon_sym_c_SQUOTE] = ACTIONS(3045),
    [anon_sym_c_DQUOTE] = ACTIONS(3045),
    [anon_sym_r_SQUOTE] = ACTIONS(3045),
    [anon_sym_r_DQUOTE] = ACTIONS(3045),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3045),
    [anon_sym_shared] = ACTIONS(3045),
    [anon_sym_map_LBRACK] = ACTIONS(3045),
    [anon_sym_chan] = ACTIONS(3045),
    [anon_sym_thread] = ACTIONS(3045),
    [anon_sym_atomic] = ACTIONS(3045),
    [anon_sym_assert] = ACTIONS(3045),
    [anon_sym_defer] = ACTIONS(3045),
    [anon_sym_goto] = ACTIONS(3045),
    [anon_sym_break] = ACTIONS(3045),
    [anon_sym_continue] = ACTIONS(3045),
    [anon_sym_return] = ACTIONS(3045),
    [anon_sym_DOLLARfor] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3045),
    [anon_sym_POUND] = ACTIONS(3045),
    [anon_sym_asm] = ACTIONS(3045),
    [anon_sym_AT_LBRACK] = ACTIONS(3045),
  },
  [475] = {
    [sym_line_comment] = STATE(475),
    [sym_block_comment] = STATE(475),
    [ts_builtin_sym_end] = ACTIONS(3047),
    [sym_identifier] = ACTIONS(3049),
    [anon_sym_LF] = ACTIONS(3049),
    [anon_sym_CR] = ACTIONS(3049),
    [anon_sym_CR_LF] = ACTIONS(3049),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3049),
    [anon_sym_as] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_COMMA] = ACTIONS(3049),
    [anon_sym_const] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym___global] = ACTIONS(3049),
    [anon_sym_type] = ACTIONS(3049),
    [anon_sym_fn] = ACTIONS(3049),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_STAR] = ACTIONS(3049),
    [anon_sym_SLASH] = ACTIONS(3049),
    [anon_sym_PERCENT] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_GT] = ACTIONS(3049),
    [anon_sym_EQ_EQ] = ACTIONS(3049),
    [anon_sym_BANG_EQ] = ACTIONS(3049),
    [anon_sym_LT_EQ] = ACTIONS(3049),
    [anon_sym_GT_EQ] = ACTIONS(3049),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_struct] = ACTIONS(3049),
    [anon_sym_union] = ACTIONS(3049),
    [anon_sym_pub] = ACTIONS(3049),
    [anon_sym_mut] = ACTIONS(3049),
    [anon_sym_enum] = ACTIONS(3049),
    [anon_sym_interface] = ACTIONS(3049),
    [anon_sym_PLUS_PLUS] = ACTIONS(3049),
    [anon_sym_DASH_DASH] = ACTIONS(3049),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_BANG] = ACTIONS(3049),
    [anon_sym_go] = ACTIONS(3049),
    [anon_sym_spawn] = ACTIONS(3049),
    [anon_sym_json_DOTdecode] = ACTIONS(3049),
    [anon_sym_PIPE] = ACTIONS(3049),
    [anon_sym_LBRACK2] = ACTIONS(3049),
    [anon_sym_TILDE] = ACTIONS(3049),
    [anon_sym_CARET] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_LT_DASH] = ACTIONS(3049),
    [anon_sym_LT_LT] = ACTIONS(3049),
    [anon_sym_GT_GT] = ACTIONS(3049),
    [anon_sym_GT_GT_GT] = ACTIONS(3049),
    [anon_sym_AMP_CARET] = ACTIONS(3049),
    [anon_sym_AMP_AMP] = ACTIONS(3049),
    [anon_sym_PIPE_PIPE] = ACTIONS(3049),
    [anon_sym_or] = ACTIONS(3049),
    [sym_none] = ACTIONS(3049),
    [sym_true] = ACTIONS(3049),
    [sym_false] = ACTIONS(3049),
    [sym_nil] = ACTIONS(3049),
    [anon_sym_QMARK_DOT] = ACTIONS(3049),
    [anon_sym_POUND_LBRACK] = ACTIONS(3049),
    [anon_sym_if] = ACTIONS(3049),
    [anon_sym_DOLLARif] = ACTIONS(3049),
    [anon_sym_is] = ACTIONS(3049),
    [anon_sym_BANGis] = ACTIONS(3049),
    [anon_sym_in] = ACTIONS(3049),
    [anon_sym_BANGin] = ACTIONS(3049),
    [anon_sym_match] = ACTIONS(3049),
    [anon_sym_select] = ACTIONS(3049),
    [anon_sym_STAR_EQ] = ACTIONS(3049),
    [anon_sym_SLASH_EQ] = ACTIONS(3049),
    [anon_sym_PERCENT_EQ] = ACTIONS(3049),
    [anon_sym_LT_LT_EQ] = ACTIONS(3049),
    [anon_sym_GT_GT_EQ] = ACTIONS(3049),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3049),
    [anon_sym_AMP_EQ] = ACTIONS(3049),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3049),
    [anon_sym_PLUS_EQ] = ACTIONS(3049),
    [anon_sym_DASH_EQ] = ACTIONS(3049),
    [anon_sym_PIPE_EQ] = ACTIONS(3049),
    [anon_sym_CARET_EQ] = ACTIONS(3049),
    [anon_sym_COLON_EQ] = ACTIONS(3049),
    [anon_sym_lock] = ACTIONS(3049),
    [anon_sym_rlock] = ACTIONS(3049),
    [anon_sym_unsafe] = ACTIONS(3049),
    [anon_sym_sql] = ACTIONS(3049),
    [sym_int_literal] = ACTIONS(3049),
    [sym_float_literal] = ACTIONS(3049),
    [sym_rune_literal] = ACTIONS(3049),
    [anon_sym_SQUOTE] = ACTIONS(3049),
    [anon_sym_DQUOTE] = ACTIONS(3049),
    [anon_sym_c_SQUOTE] = ACTIONS(3049),
    [anon_sym_c_DQUOTE] = ACTIONS(3049),
    [anon_sym_r_SQUOTE] = ACTIONS(3049),
    [anon_sym_r_DQUOTE] = ACTIONS(3049),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3049),
    [anon_sym_shared] = ACTIONS(3049),
    [anon_sym_map_LBRACK] = ACTIONS(3049),
    [anon_sym_chan] = ACTIONS(3049),
    [anon_sym_thread] = ACTIONS(3049),
    [anon_sym_atomic] = ACTIONS(3049),
    [anon_sym_assert] = ACTIONS(3049),
    [anon_sym_defer] = ACTIONS(3049),
    [anon_sym_goto] = ACTIONS(3049),
    [anon_sym_break] = ACTIONS(3049),
    [anon_sym_continue] = ACTIONS(3049),
    [anon_sym_return] = ACTIONS(3049),
    [anon_sym_DOLLARfor] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3049),
    [anon_sym_POUND] = ACTIONS(3049),
    [anon_sym_asm] = ACTIONS(3049),
    [anon_sym_AT_LBRACK] = ACTIONS(3049),
  },
  [476] = {
    [sym_line_comment] = STATE(476),
    [sym_block_comment] = STATE(476),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(402),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(3051),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [477] = {
    [sym_line_comment] = STATE(477),
    [sym_block_comment] = STATE(477),
    [ts_builtin_sym_end] = ACTIONS(3053),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_LF] = ACTIONS(3055),
    [anon_sym_CR] = ACTIONS(3055),
    [anon_sym_CR_LF] = ACTIONS(3055),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_as] = ACTIONS(3055),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3055),
    [anon_sym_const] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_EQ] = ACTIONS(3055),
    [anon_sym___global] = ACTIONS(3055),
    [anon_sym_type] = ACTIONS(3055),
    [anon_sym_fn] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3055),
    [anon_sym_SLASH] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(3055),
    [anon_sym_GT] = ACTIONS(3055),
    [anon_sym_EQ_EQ] = ACTIONS(3055),
    [anon_sym_BANG_EQ] = ACTIONS(3055),
    [anon_sym_LT_EQ] = ACTIONS(3055),
    [anon_sym_GT_EQ] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_struct] = ACTIONS(3055),
    [anon_sym_union] = ACTIONS(3055),
    [anon_sym_pub] = ACTIONS(3055),
    [anon_sym_mut] = ACTIONS(3055),
    [anon_sym_enum] = ACTIONS(3055),
    [anon_sym_interface] = ACTIONS(3055),
    [anon_sym_PLUS_PLUS] = ACTIONS(3055),
    [anon_sym_DASH_DASH] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_BANG] = ACTIONS(3055),
    [anon_sym_go] = ACTIONS(3055),
    [anon_sym_spawn] = ACTIONS(3055),
    [anon_sym_json_DOTdecode] = ACTIONS(3055),
    [anon_sym_PIPE] = ACTIONS(3055),
    [anon_sym_LBRACK2] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3055),
    [anon_sym_CARET] = ACTIONS(3055),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT_DASH] = ACTIONS(3055),
    [anon_sym_LT_LT] = ACTIONS(3055),
    [anon_sym_GT_GT] = ACTIONS(3055),
    [anon_sym_GT_GT_GT] = ACTIONS(3055),
    [anon_sym_AMP_CARET] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3055),
    [anon_sym_or] = ACTIONS(3055),
    [sym_none] = ACTIONS(3055),
    [sym_true] = ACTIONS(3055),
    [sym_false] = ACTIONS(3055),
    [sym_nil] = ACTIONS(3055),
    [anon_sym_QMARK_DOT] = ACTIONS(3055),
    [anon_sym_POUND_LBRACK] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_DOLLARif] = ACTIONS(3055),
    [anon_sym_is] = ACTIONS(3055),
    [anon_sym_BANGis] = ACTIONS(3055),
    [anon_sym_in] = ACTIONS(3055),
    [anon_sym_BANGin] = ACTIONS(3055),
    [anon_sym_match] = ACTIONS(3055),
    [anon_sym_select] = ACTIONS(3055),
    [anon_sym_STAR_EQ] = ACTIONS(3055),
    [anon_sym_SLASH_EQ] = ACTIONS(3055),
    [anon_sym_PERCENT_EQ] = ACTIONS(3055),
    [anon_sym_LT_LT_EQ] = ACTIONS(3055),
    [anon_sym_GT_GT_EQ] = ACTIONS(3055),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3055),
    [anon_sym_AMP_EQ] = ACTIONS(3055),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3055),
    [anon_sym_PLUS_EQ] = ACTIONS(3055),
    [anon_sym_DASH_EQ] = ACTIONS(3055),
    [anon_sym_PIPE_EQ] = ACTIONS(3055),
    [anon_sym_CARET_EQ] = ACTIONS(3055),
    [anon_sym_COLON_EQ] = ACTIONS(3055),
    [anon_sym_lock] = ACTIONS(3055),
    [anon_sym_rlock] = ACTIONS(3055),
    [anon_sym_unsafe] = ACTIONS(3055),
    [anon_sym_sql] = ACTIONS(3055),
    [sym_int_literal] = ACTIONS(3055),
    [sym_float_literal] = ACTIONS(3055),
    [sym_rune_literal] = ACTIONS(3055),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_c_SQUOTE] = ACTIONS(3055),
    [anon_sym_c_DQUOTE] = ACTIONS(3055),
    [anon_sym_r_SQUOTE] = ACTIONS(3055),
    [anon_sym_r_DQUOTE] = ACTIONS(3055),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3055),
    [anon_sym_shared] = ACTIONS(3055),
    [anon_sym_map_LBRACK] = ACTIONS(3055),
    [anon_sym_chan] = ACTIONS(3055),
    [anon_sym_thread] = ACTIONS(3055),
    [anon_sym_atomic] = ACTIONS(3055),
    [anon_sym_assert] = ACTIONS(3055),
    [anon_sym_defer] = ACTIONS(3055),
    [anon_sym_goto] = ACTIONS(3055),
    [anon_sym_break] = ACTIONS(3055),
    [anon_sym_continue] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_DOLLARfor] = ACTIONS(3055),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_POUND] = ACTIONS(3055),
    [anon_sym_asm] = ACTIONS(3055),
    [anon_sym_AT_LBRACK] = ACTIONS(3055),
  },
  [478] = {
    [sym_line_comment] = STATE(478),
    [sym_block_comment] = STATE(478),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(402),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(3057),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [479] = {
    [sym_line_comment] = STATE(479),
    [sym_block_comment] = STATE(479),
    [ts_builtin_sym_end] = ACTIONS(3059),
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_LF] = ACTIONS(3061),
    [anon_sym_CR] = ACTIONS(3061),
    [anon_sym_CR_LF] = ACTIONS(3061),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3061),
    [anon_sym_as] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3061),
    [anon_sym_COMMA] = ACTIONS(3061),
    [anon_sym_const] = ACTIONS(3061),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_EQ] = ACTIONS(3061),
    [anon_sym___global] = ACTIONS(3061),
    [anon_sym_type] = ACTIONS(3061),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_PLUS] = ACTIONS(3061),
    [anon_sym_DASH] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(3061),
    [anon_sym_SLASH] = ACTIONS(3061),
    [anon_sym_PERCENT] = ACTIONS(3061),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_GT] = ACTIONS(3061),
    [anon_sym_EQ_EQ] = ACTIONS(3061),
    [anon_sym_BANG_EQ] = ACTIONS(3061),
    [anon_sym_LT_EQ] = ACTIONS(3061),
    [anon_sym_GT_EQ] = ACTIONS(3061),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_struct] = ACTIONS(3061),
    [anon_sym_union] = ACTIONS(3061),
    [anon_sym_pub] = ACTIONS(3061),
    [anon_sym_mut] = ACTIONS(3061),
    [anon_sym_enum] = ACTIONS(3061),
    [anon_sym_interface] = ACTIONS(3061),
    [anon_sym_PLUS_PLUS] = ACTIONS(3061),
    [anon_sym_DASH_DASH] = ACTIONS(3061),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_BANG] = ACTIONS(3061),
    [anon_sym_go] = ACTIONS(3061),
    [anon_sym_spawn] = ACTIONS(3061),
    [anon_sym_json_DOTdecode] = ACTIONS(3061),
    [anon_sym_PIPE] = ACTIONS(3061),
    [anon_sym_LBRACK2] = ACTIONS(3061),
    [anon_sym_TILDE] = ACTIONS(3061),
    [anon_sym_CARET] = ACTIONS(3061),
    [anon_sym_AMP] = ACTIONS(3061),
    [anon_sym_LT_DASH] = ACTIONS(3061),
    [anon_sym_LT_LT] = ACTIONS(3061),
    [anon_sym_GT_GT] = ACTIONS(3061),
    [anon_sym_GT_GT_GT] = ACTIONS(3061),
    [anon_sym_AMP_CARET] = ACTIONS(3061),
    [anon_sym_AMP_AMP] = ACTIONS(3061),
    [anon_sym_PIPE_PIPE] = ACTIONS(3061),
    [anon_sym_or] = ACTIONS(3061),
    [sym_none] = ACTIONS(3061),
    [sym_true] = ACTIONS(3061),
    [sym_false] = ACTIONS(3061),
    [sym_nil] = ACTIONS(3061),
    [anon_sym_QMARK_DOT] = ACTIONS(3061),
    [anon_sym_POUND_LBRACK] = ACTIONS(3061),
    [anon_sym_if] = ACTIONS(3061),
    [anon_sym_DOLLARif] = ACTIONS(3061),
    [anon_sym_is] = ACTIONS(3061),
    [anon_sym_BANGis] = ACTIONS(3061),
    [anon_sym_in] = ACTIONS(3061),
    [anon_sym_BANGin] = ACTIONS(3061),
    [anon_sym_match] = ACTIONS(3061),
    [anon_sym_select] = ACTIONS(3061),
    [anon_sym_STAR_EQ] = ACTIONS(3061),
    [anon_sym_SLASH_EQ] = ACTIONS(3061),
    [anon_sym_PERCENT_EQ] = ACTIONS(3061),
    [anon_sym_LT_LT_EQ] = ACTIONS(3061),
    [anon_sym_GT_GT_EQ] = ACTIONS(3061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3061),
    [anon_sym_AMP_EQ] = ACTIONS(3061),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3061),
    [anon_sym_PLUS_EQ] = ACTIONS(3061),
    [anon_sym_DASH_EQ] = ACTIONS(3061),
    [anon_sym_PIPE_EQ] = ACTIONS(3061),
    [anon_sym_CARET_EQ] = ACTIONS(3061),
    [anon_sym_COLON_EQ] = ACTIONS(3061),
    [anon_sym_lock] = ACTIONS(3061),
    [anon_sym_rlock] = ACTIONS(3061),
    [anon_sym_unsafe] = ACTIONS(3061),
    [anon_sym_sql] = ACTIONS(3061),
    [sym_int_literal] = ACTIONS(3061),
    [sym_float_literal] = ACTIONS(3061),
    [sym_rune_literal] = ACTIONS(3061),
    [anon_sym_SQUOTE] = ACTIONS(3061),
    [anon_sym_DQUOTE] = ACTIONS(3061),
    [anon_sym_c_SQUOTE] = ACTIONS(3061),
    [anon_sym_c_DQUOTE] = ACTIONS(3061),
    [anon_sym_r_SQUOTE] = ACTIONS(3061),
    [anon_sym_r_DQUOTE] = ACTIONS(3061),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3061),
    [anon_sym_shared] = ACTIONS(3061),
    [anon_sym_map_LBRACK] = ACTIONS(3061),
    [anon_sym_chan] = ACTIONS(3061),
    [anon_sym_thread] = ACTIONS(3061),
    [anon_sym_atomic] = ACTIONS(3061),
    [anon_sym_assert] = ACTIONS(3061),
    [anon_sym_defer] = ACTIONS(3061),
    [anon_sym_goto] = ACTIONS(3061),
    [anon_sym_break] = ACTIONS(3061),
    [anon_sym_continue] = ACTIONS(3061),
    [anon_sym_return] = ACTIONS(3061),
    [anon_sym_DOLLARfor] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(3061),
    [anon_sym_POUND] = ACTIONS(3061),
    [anon_sym_asm] = ACTIONS(3061),
    [anon_sym_AT_LBRACK] = ACTIONS(3061),
  },
  [480] = {
    [sym_line_comment] = STATE(480),
    [sym_block_comment] = STATE(480),
    [ts_builtin_sym_end] = ACTIONS(3063),
    [sym_identifier] = ACTIONS(3065),
    [anon_sym_LF] = ACTIONS(3065),
    [anon_sym_CR] = ACTIONS(3065),
    [anon_sym_CR_LF] = ACTIONS(3065),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3065),
    [anon_sym_as] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_COMMA] = ACTIONS(3065),
    [anon_sym_const] = ACTIONS(3065),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_EQ] = ACTIONS(3065),
    [anon_sym___global] = ACTIONS(3065),
    [anon_sym_type] = ACTIONS(3065),
    [anon_sym_fn] = ACTIONS(3065),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_SLASH] = ACTIONS(3065),
    [anon_sym_PERCENT] = ACTIONS(3065),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_GT] = ACTIONS(3065),
    [anon_sym_EQ_EQ] = ACTIONS(3065),
    [anon_sym_BANG_EQ] = ACTIONS(3065),
    [anon_sym_LT_EQ] = ACTIONS(3065),
    [anon_sym_GT_EQ] = ACTIONS(3065),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3065),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_pub] = ACTIONS(3065),
    [anon_sym_mut] = ACTIONS(3065),
    [anon_sym_enum] = ACTIONS(3065),
    [anon_sym_interface] = ACTIONS(3065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_QMARK] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_go] = ACTIONS(3065),
    [anon_sym_spawn] = ACTIONS(3065),
    [anon_sym_json_DOTdecode] = ACTIONS(3065),
    [anon_sym_PIPE] = ACTIONS(3065),
    [anon_sym_LBRACK2] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_CARET] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3065),
    [anon_sym_LT_DASH] = ACTIONS(3065),
    [anon_sym_LT_LT] = ACTIONS(3065),
    [anon_sym_GT_GT] = ACTIONS(3065),
    [anon_sym_GT_GT_GT] = ACTIONS(3065),
    [anon_sym_AMP_CARET] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_PIPE_PIPE] = ACTIONS(3065),
    [anon_sym_or] = ACTIONS(3065),
    [sym_none] = ACTIONS(3065),
    [sym_true] = ACTIONS(3065),
    [sym_false] = ACTIONS(3065),
    [sym_nil] = ACTIONS(3065),
    [anon_sym_QMARK_DOT] = ACTIONS(3065),
    [anon_sym_POUND_LBRACK] = ACTIONS(3065),
    [anon_sym_if] = ACTIONS(3065),
    [anon_sym_DOLLARif] = ACTIONS(3065),
    [anon_sym_is] = ACTIONS(3065),
    [anon_sym_BANGis] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3065),
    [anon_sym_BANGin] = ACTIONS(3065),
    [anon_sym_match] = ACTIONS(3065),
    [anon_sym_select] = ACTIONS(3065),
    [anon_sym_STAR_EQ] = ACTIONS(3065),
    [anon_sym_SLASH_EQ] = ACTIONS(3065),
    [anon_sym_PERCENT_EQ] = ACTIONS(3065),
    [anon_sym_LT_LT_EQ] = ACTIONS(3065),
    [anon_sym_GT_GT_EQ] = ACTIONS(3065),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3065),
    [anon_sym_AMP_EQ] = ACTIONS(3065),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3065),
    [anon_sym_PLUS_EQ] = ACTIONS(3065),
    [anon_sym_DASH_EQ] = ACTIONS(3065),
    [anon_sym_PIPE_EQ] = ACTIONS(3065),
    [anon_sym_CARET_EQ] = ACTIONS(3065),
    [anon_sym_COLON_EQ] = ACTIONS(3065),
    [anon_sym_lock] = ACTIONS(3065),
    [anon_sym_rlock] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(3065),
    [anon_sym_sql] = ACTIONS(3065),
    [sym_int_literal] = ACTIONS(3065),
    [sym_float_literal] = ACTIONS(3065),
    [sym_rune_literal] = ACTIONS(3065),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [anon_sym_c_SQUOTE] = ACTIONS(3065),
    [anon_sym_c_DQUOTE] = ACTIONS(3065),
    [anon_sym_r_SQUOTE] = ACTIONS(3065),
    [anon_sym_r_DQUOTE] = ACTIONS(3065),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3065),
    [anon_sym_shared] = ACTIONS(3065),
    [anon_sym_map_LBRACK] = ACTIONS(3065),
    [anon_sym_chan] = ACTIONS(3065),
    [anon_sym_thread] = ACTIONS(3065),
    [anon_sym_atomic] = ACTIONS(3065),
    [anon_sym_assert] = ACTIONS(3065),
    [anon_sym_defer] = ACTIONS(3065),
    [anon_sym_goto] = ACTIONS(3065),
    [anon_sym_break] = ACTIONS(3065),
    [anon_sym_continue] = ACTIONS(3065),
    [anon_sym_return] = ACTIONS(3065),
    [anon_sym_DOLLARfor] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3065),
    [anon_sym_POUND] = ACTIONS(3065),
    [anon_sym_asm] = ACTIONS(3065),
    [anon_sym_AT_LBRACK] = ACTIONS(3065),
  },
  [481] = {
    [sym_line_comment] = STATE(481),
    [sym_block_comment] = STATE(481),
    [ts_builtin_sym_end] = ACTIONS(3067),
    [sym_identifier] = ACTIONS(3069),
    [anon_sym_LF] = ACTIONS(3069),
    [anon_sym_CR] = ACTIONS(3069),
    [anon_sym_CR_LF] = ACTIONS(3069),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3069),
    [anon_sym_as] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3069),
    [anon_sym_COMMA] = ACTIONS(3069),
    [anon_sym_const] = ACTIONS(3069),
    [anon_sym_LPAREN] = ACTIONS(3069),
    [anon_sym_EQ] = ACTIONS(3069),
    [anon_sym___global] = ACTIONS(3069),
    [anon_sym_type] = ACTIONS(3069),
    [anon_sym_fn] = ACTIONS(3069),
    [anon_sym_PLUS] = ACTIONS(3069),
    [anon_sym_DASH] = ACTIONS(3069),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_SLASH] = ACTIONS(3069),
    [anon_sym_PERCENT] = ACTIONS(3069),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_GT] = ACTIONS(3069),
    [anon_sym_EQ_EQ] = ACTIONS(3069),
    [anon_sym_BANG_EQ] = ACTIONS(3069),
    [anon_sym_LT_EQ] = ACTIONS(3069),
    [anon_sym_GT_EQ] = ACTIONS(3069),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_struct] = ACTIONS(3069),
    [anon_sym_union] = ACTIONS(3069),
    [anon_sym_pub] = ACTIONS(3069),
    [anon_sym_mut] = ACTIONS(3069),
    [anon_sym_enum] = ACTIONS(3069),
    [anon_sym_interface] = ACTIONS(3069),
    [anon_sym_PLUS_PLUS] = ACTIONS(3069),
    [anon_sym_DASH_DASH] = ACTIONS(3069),
    [anon_sym_QMARK] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(3069),
    [anon_sym_go] = ACTIONS(3069),
    [anon_sym_spawn] = ACTIONS(3069),
    [anon_sym_json_DOTdecode] = ACTIONS(3069),
    [anon_sym_PIPE] = ACTIONS(3069),
    [anon_sym_LBRACK2] = ACTIONS(3069),
    [anon_sym_TILDE] = ACTIONS(3069),
    [anon_sym_CARET] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3069),
    [anon_sym_LT_DASH] = ACTIONS(3069),
    [anon_sym_LT_LT] = ACTIONS(3069),
    [anon_sym_GT_GT] = ACTIONS(3069),
    [anon_sym_GT_GT_GT] = ACTIONS(3069),
    [anon_sym_AMP_CARET] = ACTIONS(3069),
    [anon_sym_AMP_AMP] = ACTIONS(3069),
    [anon_sym_PIPE_PIPE] = ACTIONS(3069),
    [anon_sym_or] = ACTIONS(3069),
    [sym_none] = ACTIONS(3069),
    [sym_true] = ACTIONS(3069),
    [sym_false] = ACTIONS(3069),
    [sym_nil] = ACTIONS(3069),
    [anon_sym_QMARK_DOT] = ACTIONS(3069),
    [anon_sym_POUND_LBRACK] = ACTIONS(3069),
    [anon_sym_if] = ACTIONS(3069),
    [anon_sym_DOLLARif] = ACTIONS(3069),
    [anon_sym_is] = ACTIONS(3069),
    [anon_sym_BANGis] = ACTIONS(3069),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_BANGin] = ACTIONS(3069),
    [anon_sym_match] = ACTIONS(3069),
    [anon_sym_select] = ACTIONS(3069),
    [anon_sym_STAR_EQ] = ACTIONS(3069),
    [anon_sym_SLASH_EQ] = ACTIONS(3069),
    [anon_sym_PERCENT_EQ] = ACTIONS(3069),
    [anon_sym_LT_LT_EQ] = ACTIONS(3069),
    [anon_sym_GT_GT_EQ] = ACTIONS(3069),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3069),
    [anon_sym_AMP_EQ] = ACTIONS(3069),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3069),
    [anon_sym_PLUS_EQ] = ACTIONS(3069),
    [anon_sym_DASH_EQ] = ACTIONS(3069),
    [anon_sym_PIPE_EQ] = ACTIONS(3069),
    [anon_sym_CARET_EQ] = ACTIONS(3069),
    [anon_sym_COLON_EQ] = ACTIONS(3069),
    [anon_sym_lock] = ACTIONS(3069),
    [anon_sym_rlock] = ACTIONS(3069),
    [anon_sym_unsafe] = ACTIONS(3069),
    [anon_sym_sql] = ACTIONS(3069),
    [sym_int_literal] = ACTIONS(3069),
    [sym_float_literal] = ACTIONS(3069),
    [sym_rune_literal] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE] = ACTIONS(3069),
    [anon_sym_c_SQUOTE] = ACTIONS(3069),
    [anon_sym_c_DQUOTE] = ACTIONS(3069),
    [anon_sym_r_SQUOTE] = ACTIONS(3069),
    [anon_sym_r_DQUOTE] = ACTIONS(3069),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3069),
    [anon_sym_shared] = ACTIONS(3069),
    [anon_sym_map_LBRACK] = ACTIONS(3069),
    [anon_sym_chan] = ACTIONS(3069),
    [anon_sym_thread] = ACTIONS(3069),
    [anon_sym_atomic] = ACTIONS(3069),
    [anon_sym_assert] = ACTIONS(3069),
    [anon_sym_defer] = ACTIONS(3069),
    [anon_sym_goto] = ACTIONS(3069),
    [anon_sym_break] = ACTIONS(3069),
    [anon_sym_continue] = ACTIONS(3069),
    [anon_sym_return] = ACTIONS(3069),
    [anon_sym_DOLLARfor] = ACTIONS(3069),
    [anon_sym_for] = ACTIONS(3069),
    [anon_sym_POUND] = ACTIONS(3069),
    [anon_sym_asm] = ACTIONS(3069),
    [anon_sym_AT_LBRACK] = ACTIONS(3069),
  },
  [482] = {
    [sym_line_comment] = STATE(482),
    [sym_block_comment] = STATE(482),
    [ts_builtin_sym_end] = ACTIONS(3071),
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_LF] = ACTIONS(3073),
    [anon_sym_CR] = ACTIONS(3073),
    [anon_sym_CR_LF] = ACTIONS(3073),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3073),
    [anon_sym_as] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3073),
    [anon_sym_COMMA] = ACTIONS(3073),
    [anon_sym_const] = ACTIONS(3073),
    [anon_sym_LPAREN] = ACTIONS(3073),
    [anon_sym_EQ] = ACTIONS(3073),
    [anon_sym___global] = ACTIONS(3073),
    [anon_sym_type] = ACTIONS(3073),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(3073),
    [anon_sym_DASH] = ACTIONS(3073),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_SLASH] = ACTIONS(3073),
    [anon_sym_PERCENT] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_GT] = ACTIONS(3073),
    [anon_sym_EQ_EQ] = ACTIONS(3073),
    [anon_sym_BANG_EQ] = ACTIONS(3073),
    [anon_sym_LT_EQ] = ACTIONS(3073),
    [anon_sym_GT_EQ] = ACTIONS(3073),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3073),
    [anon_sym_union] = ACTIONS(3073),
    [anon_sym_pub] = ACTIONS(3073),
    [anon_sym_mut] = ACTIONS(3073),
    [anon_sym_enum] = ACTIONS(3073),
    [anon_sym_interface] = ACTIONS(3073),
    [anon_sym_PLUS_PLUS] = ACTIONS(3073),
    [anon_sym_DASH_DASH] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3073),
    [anon_sym_BANG] = ACTIONS(3073),
    [anon_sym_go] = ACTIONS(3073),
    [anon_sym_spawn] = ACTIONS(3073),
    [anon_sym_json_DOTdecode] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(3073),
    [anon_sym_LBRACK2] = ACTIONS(3073),
    [anon_sym_TILDE] = ACTIONS(3073),
    [anon_sym_CARET] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3073),
    [anon_sym_LT_DASH] = ACTIONS(3073),
    [anon_sym_LT_LT] = ACTIONS(3073),
    [anon_sym_GT_GT] = ACTIONS(3073),
    [anon_sym_GT_GT_GT] = ACTIONS(3073),
    [anon_sym_AMP_CARET] = ACTIONS(3073),
    [anon_sym_AMP_AMP] = ACTIONS(3073),
    [anon_sym_PIPE_PIPE] = ACTIONS(3073),
    [anon_sym_or] = ACTIONS(3073),
    [sym_none] = ACTIONS(3073),
    [sym_true] = ACTIONS(3073),
    [sym_false] = ACTIONS(3073),
    [sym_nil] = ACTIONS(3073),
    [anon_sym_QMARK_DOT] = ACTIONS(3073),
    [anon_sym_POUND_LBRACK] = ACTIONS(3073),
    [anon_sym_if] = ACTIONS(3073),
    [anon_sym_DOLLARif] = ACTIONS(3073),
    [anon_sym_is] = ACTIONS(3073),
    [anon_sym_BANGis] = ACTIONS(3073),
    [anon_sym_in] = ACTIONS(3073),
    [anon_sym_BANGin] = ACTIONS(3073),
    [anon_sym_match] = ACTIONS(3073),
    [anon_sym_select] = ACTIONS(3073),
    [anon_sym_STAR_EQ] = ACTIONS(3073),
    [anon_sym_SLASH_EQ] = ACTIONS(3073),
    [anon_sym_PERCENT_EQ] = ACTIONS(3073),
    [anon_sym_LT_LT_EQ] = ACTIONS(3073),
    [anon_sym_GT_GT_EQ] = ACTIONS(3073),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3073),
    [anon_sym_AMP_EQ] = ACTIONS(3073),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3073),
    [anon_sym_PLUS_EQ] = ACTIONS(3073),
    [anon_sym_DASH_EQ] = ACTIONS(3073),
    [anon_sym_PIPE_EQ] = ACTIONS(3073),
    [anon_sym_CARET_EQ] = ACTIONS(3073),
    [anon_sym_COLON_EQ] = ACTIONS(3073),
    [anon_sym_lock] = ACTIONS(3073),
    [anon_sym_rlock] = ACTIONS(3073),
    [anon_sym_unsafe] = ACTIONS(3073),
    [anon_sym_sql] = ACTIONS(3073),
    [sym_int_literal] = ACTIONS(3073),
    [sym_float_literal] = ACTIONS(3073),
    [sym_rune_literal] = ACTIONS(3073),
    [anon_sym_SQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE] = ACTIONS(3073),
    [anon_sym_c_SQUOTE] = ACTIONS(3073),
    [anon_sym_c_DQUOTE] = ACTIONS(3073),
    [anon_sym_r_SQUOTE] = ACTIONS(3073),
    [anon_sym_r_DQUOTE] = ACTIONS(3073),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3073),
    [anon_sym_shared] = ACTIONS(3073),
    [anon_sym_map_LBRACK] = ACTIONS(3073),
    [anon_sym_chan] = ACTIONS(3073),
    [anon_sym_thread] = ACTIONS(3073),
    [anon_sym_atomic] = ACTIONS(3073),
    [anon_sym_assert] = ACTIONS(3073),
    [anon_sym_defer] = ACTIONS(3073),
    [anon_sym_goto] = ACTIONS(3073),
    [anon_sym_break] = ACTIONS(3073),
    [anon_sym_continue] = ACTIONS(3073),
    [anon_sym_return] = ACTIONS(3073),
    [anon_sym_DOLLARfor] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(3073),
    [anon_sym_POUND] = ACTIONS(3073),
    [anon_sym_asm] = ACTIONS(3073),
    [anon_sym_AT_LBRACK] = ACTIONS(3073),
  },
  [483] = {
    [sym_line_comment] = STATE(483),
    [sym_block_comment] = STATE(483),
    [ts_builtin_sym_end] = ACTIONS(3043),
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_LF] = ACTIONS(3045),
    [anon_sym_CR] = ACTIONS(3045),
    [anon_sym_CR_LF] = ACTIONS(3045),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_as] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3045),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_const] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3045),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym___global] = ACTIONS(3045),
    [anon_sym_type] = ACTIONS(3045),
    [anon_sym_fn] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3045),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_PERCENT] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_GT] = ACTIONS(3045),
    [anon_sym_EQ_EQ] = ACTIONS(3045),
    [anon_sym_BANG_EQ] = ACTIONS(3045),
    [anon_sym_LT_EQ] = ACTIONS(3045),
    [anon_sym_GT_EQ] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_struct] = ACTIONS(3045),
    [anon_sym_union] = ACTIONS(3045),
    [anon_sym_pub] = ACTIONS(3045),
    [anon_sym_mut] = ACTIONS(3045),
    [anon_sym_enum] = ACTIONS(3045),
    [anon_sym_interface] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3045),
    [anon_sym_go] = ACTIONS(3045),
    [anon_sym_spawn] = ACTIONS(3045),
    [anon_sym_json_DOTdecode] = ACTIONS(3045),
    [anon_sym_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACK2] = ACTIONS(3045),
    [anon_sym_TILDE] = ACTIONS(3045),
    [anon_sym_CARET] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3045),
    [anon_sym_LT_DASH] = ACTIONS(3045),
    [anon_sym_LT_LT] = ACTIONS(3045),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_GT_GT_GT] = ACTIONS(3045),
    [anon_sym_AMP_CARET] = ACTIONS(3045),
    [anon_sym_AMP_AMP] = ACTIONS(3045),
    [anon_sym_PIPE_PIPE] = ACTIONS(3045),
    [anon_sym_or] = ACTIONS(3045),
    [sym_none] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_nil] = ACTIONS(3045),
    [anon_sym_QMARK_DOT] = ACTIONS(3045),
    [anon_sym_POUND_LBRACK] = ACTIONS(3045),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_DOLLARif] = ACTIONS(3045),
    [anon_sym_is] = ACTIONS(3045),
    [anon_sym_BANGis] = ACTIONS(3045),
    [anon_sym_in] = ACTIONS(3045),
    [anon_sym_BANGin] = ACTIONS(3045),
    [anon_sym_match] = ACTIONS(3045),
    [anon_sym_select] = ACTIONS(3045),
    [anon_sym_STAR_EQ] = ACTIONS(3045),
    [anon_sym_SLASH_EQ] = ACTIONS(3045),
    [anon_sym_PERCENT_EQ] = ACTIONS(3045),
    [anon_sym_LT_LT_EQ] = ACTIONS(3045),
    [anon_sym_GT_GT_EQ] = ACTIONS(3045),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3045),
    [anon_sym_AMP_EQ] = ACTIONS(3045),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3045),
    [anon_sym_PLUS_EQ] = ACTIONS(3045),
    [anon_sym_DASH_EQ] = ACTIONS(3045),
    [anon_sym_PIPE_EQ] = ACTIONS(3045),
    [anon_sym_CARET_EQ] = ACTIONS(3045),
    [anon_sym_COLON_EQ] = ACTIONS(3045),
    [anon_sym_lock] = ACTIONS(3045),
    [anon_sym_rlock] = ACTIONS(3045),
    [anon_sym_unsafe] = ACTIONS(3045),
    [anon_sym_sql] = ACTIONS(3045),
    [sym_int_literal] = ACTIONS(3045),
    [sym_float_literal] = ACTIONS(3045),
    [sym_rune_literal] = ACTIONS(3045),
    [anon_sym_SQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE] = ACTIONS(3045),
    [anon_sym_c_SQUOTE] = ACTIONS(3045),
    [anon_sym_c_DQUOTE] = ACTIONS(3045),
    [anon_sym_r_SQUOTE] = ACTIONS(3045),
    [anon_sym_r_DQUOTE] = ACTIONS(3045),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3045),
    [anon_sym_shared] = ACTIONS(3045),
    [anon_sym_map_LBRACK] = ACTIONS(3045),
    [anon_sym_chan] = ACTIONS(3045),
    [anon_sym_thread] = ACTIONS(3045),
    [anon_sym_atomic] = ACTIONS(3045),
    [anon_sym_assert] = ACTIONS(3045),
    [anon_sym_defer] = ACTIONS(3045),
    [anon_sym_goto] = ACTIONS(3045),
    [anon_sym_break] = ACTIONS(3045),
    [anon_sym_continue] = ACTIONS(3045),
    [anon_sym_return] = ACTIONS(3045),
    [anon_sym_DOLLARfor] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3045),
    [anon_sym_POUND] = ACTIONS(3045),
    [anon_sym_asm] = ACTIONS(3045),
    [anon_sym_AT_LBRACK] = ACTIONS(3045),
  },
  [484] = {
    [sym_line_comment] = STATE(484),
    [sym_block_comment] = STATE(484),
    [ts_builtin_sym_end] = ACTIONS(3078),
    [sym_identifier] = ACTIONS(3080),
    [anon_sym_LF] = ACTIONS(3080),
    [anon_sym_CR] = ACTIONS(3080),
    [anon_sym_CR_LF] = ACTIONS(3080),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3080),
    [anon_sym_as] = ACTIONS(3080),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_COMMA] = ACTIONS(3080),
    [anon_sym_const] = ACTIONS(3080),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_EQ] = ACTIONS(3080),
    [anon_sym___global] = ACTIONS(3080),
    [anon_sym_type] = ACTIONS(3080),
    [anon_sym_fn] = ACTIONS(3080),
    [anon_sym_PLUS] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3080),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_SLASH] = ACTIONS(3080),
    [anon_sym_PERCENT] = ACTIONS(3080),
    [anon_sym_LT] = ACTIONS(3080),
    [anon_sym_GT] = ACTIONS(3080),
    [anon_sym_EQ_EQ] = ACTIONS(3080),
    [anon_sym_BANG_EQ] = ACTIONS(3080),
    [anon_sym_LT_EQ] = ACTIONS(3080),
    [anon_sym_GT_EQ] = ACTIONS(3080),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_struct] = ACTIONS(3080),
    [anon_sym_union] = ACTIONS(3080),
    [anon_sym_pub] = ACTIONS(3080),
    [anon_sym_mut] = ACTIONS(3080),
    [anon_sym_enum] = ACTIONS(3080),
    [anon_sym_interface] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_QMARK] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_go] = ACTIONS(3080),
    [anon_sym_spawn] = ACTIONS(3080),
    [anon_sym_json_DOTdecode] = ACTIONS(3080),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_LBRACK2] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_CARET] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3080),
    [anon_sym_LT_DASH] = ACTIONS(3080),
    [anon_sym_LT_LT] = ACTIONS(3080),
    [anon_sym_GT_GT] = ACTIONS(3080),
    [anon_sym_GT_GT_GT] = ACTIONS(3080),
    [anon_sym_AMP_CARET] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_PIPE_PIPE] = ACTIONS(3080),
    [anon_sym_or] = ACTIONS(3080),
    [sym_none] = ACTIONS(3080),
    [sym_true] = ACTIONS(3080),
    [sym_false] = ACTIONS(3080),
    [sym_nil] = ACTIONS(3080),
    [anon_sym_QMARK_DOT] = ACTIONS(3080),
    [anon_sym_POUND_LBRACK] = ACTIONS(3080),
    [anon_sym_if] = ACTIONS(3080),
    [anon_sym_DOLLARif] = ACTIONS(3080),
    [anon_sym_is] = ACTIONS(3080),
    [anon_sym_BANGis] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3080),
    [anon_sym_BANGin] = ACTIONS(3080),
    [anon_sym_match] = ACTIONS(3080),
    [anon_sym_select] = ACTIONS(3080),
    [anon_sym_STAR_EQ] = ACTIONS(3080),
    [anon_sym_SLASH_EQ] = ACTIONS(3080),
    [anon_sym_PERCENT_EQ] = ACTIONS(3080),
    [anon_sym_LT_LT_EQ] = ACTIONS(3080),
    [anon_sym_GT_GT_EQ] = ACTIONS(3080),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3080),
    [anon_sym_AMP_EQ] = ACTIONS(3080),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3080),
    [anon_sym_PLUS_EQ] = ACTIONS(3080),
    [anon_sym_DASH_EQ] = ACTIONS(3080),
    [anon_sym_PIPE_EQ] = ACTIONS(3080),
    [anon_sym_CARET_EQ] = ACTIONS(3080),
    [anon_sym_COLON_EQ] = ACTIONS(3080),
    [anon_sym_lock] = ACTIONS(3080),
    [anon_sym_rlock] = ACTIONS(3080),
    [anon_sym_unsafe] = ACTIONS(3080),
    [anon_sym_sql] = ACTIONS(3080),
    [sym_int_literal] = ACTIONS(3080),
    [sym_float_literal] = ACTIONS(3080),
    [sym_rune_literal] = ACTIONS(3080),
    [anon_sym_SQUOTE] = ACTIONS(3080),
    [anon_sym_DQUOTE] = ACTIONS(3080),
    [anon_sym_c_SQUOTE] = ACTIONS(3080),
    [anon_sym_c_DQUOTE] = ACTIONS(3080),
    [anon_sym_r_SQUOTE] = ACTIONS(3080),
    [anon_sym_r_DQUOTE] = ACTIONS(3080),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3080),
    [anon_sym_shared] = ACTIONS(3080),
    [anon_sym_map_LBRACK] = ACTIONS(3080),
    [anon_sym_chan] = ACTIONS(3080),
    [anon_sym_thread] = ACTIONS(3080),
    [anon_sym_atomic] = ACTIONS(3080),
    [anon_sym_assert] = ACTIONS(3080),
    [anon_sym_defer] = ACTIONS(3080),
    [anon_sym_goto] = ACTIONS(3080),
    [anon_sym_break] = ACTIONS(3080),
    [anon_sym_continue] = ACTIONS(3080),
    [anon_sym_return] = ACTIONS(3080),
    [anon_sym_DOLLARfor] = ACTIONS(3080),
    [anon_sym_for] = ACTIONS(3080),
    [anon_sym_POUND] = ACTIONS(3080),
    [anon_sym_asm] = ACTIONS(3080),
    [anon_sym_AT_LBRACK] = ACTIONS(3080),
  },
  [485] = {
    [sym_line_comment] = STATE(485),
    [sym_block_comment] = STATE(485),
    [ts_builtin_sym_end] = ACTIONS(3082),
    [sym_identifier] = ACTIONS(3084),
    [anon_sym_LF] = ACTIONS(3084),
    [anon_sym_CR] = ACTIONS(3084),
    [anon_sym_CR_LF] = ACTIONS(3084),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3084),
    [anon_sym_as] = ACTIONS(3084),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_COMMA] = ACTIONS(3084),
    [anon_sym_const] = ACTIONS(3084),
    [anon_sym_LPAREN] = ACTIONS(3084),
    [anon_sym_EQ] = ACTIONS(3084),
    [anon_sym___global] = ACTIONS(3084),
    [anon_sym_type] = ACTIONS(3084),
    [anon_sym_fn] = ACTIONS(3084),
    [anon_sym_PLUS] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_SLASH] = ACTIONS(3084),
    [anon_sym_PERCENT] = ACTIONS(3084),
    [anon_sym_LT] = ACTIONS(3084),
    [anon_sym_GT] = ACTIONS(3084),
    [anon_sym_EQ_EQ] = ACTIONS(3084),
    [anon_sym_BANG_EQ] = ACTIONS(3084),
    [anon_sym_LT_EQ] = ACTIONS(3084),
    [anon_sym_GT_EQ] = ACTIONS(3084),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3084),
    [anon_sym_union] = ACTIONS(3084),
    [anon_sym_pub] = ACTIONS(3084),
    [anon_sym_mut] = ACTIONS(3084),
    [anon_sym_enum] = ACTIONS(3084),
    [anon_sym_interface] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_QMARK] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_go] = ACTIONS(3084),
    [anon_sym_spawn] = ACTIONS(3084),
    [anon_sym_json_DOTdecode] = ACTIONS(3084),
    [anon_sym_PIPE] = ACTIONS(3084),
    [anon_sym_LBRACK2] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_CARET] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3084),
    [anon_sym_LT_DASH] = ACTIONS(3084),
    [anon_sym_LT_LT] = ACTIONS(3084),
    [anon_sym_GT_GT] = ACTIONS(3084),
    [anon_sym_GT_GT_GT] = ACTIONS(3084),
    [anon_sym_AMP_CARET] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_PIPE_PIPE] = ACTIONS(3084),
    [anon_sym_or] = ACTIONS(3084),
    [sym_none] = ACTIONS(3084),
    [sym_true] = ACTIONS(3084),
    [sym_false] = ACTIONS(3084),
    [sym_nil] = ACTIONS(3084),
    [anon_sym_QMARK_DOT] = ACTIONS(3084),
    [anon_sym_POUND_LBRACK] = ACTIONS(3084),
    [anon_sym_if] = ACTIONS(3084),
    [anon_sym_DOLLARif] = ACTIONS(3084),
    [anon_sym_is] = ACTIONS(3084),
    [anon_sym_BANGis] = ACTIONS(3084),
    [anon_sym_in] = ACTIONS(3084),
    [anon_sym_BANGin] = ACTIONS(3084),
    [anon_sym_match] = ACTIONS(3084),
    [anon_sym_select] = ACTIONS(3084),
    [anon_sym_STAR_EQ] = ACTIONS(3084),
    [anon_sym_SLASH_EQ] = ACTIONS(3084),
    [anon_sym_PERCENT_EQ] = ACTIONS(3084),
    [anon_sym_LT_LT_EQ] = ACTIONS(3084),
    [anon_sym_GT_GT_EQ] = ACTIONS(3084),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3084),
    [anon_sym_AMP_EQ] = ACTIONS(3084),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3084),
    [anon_sym_PLUS_EQ] = ACTIONS(3084),
    [anon_sym_DASH_EQ] = ACTIONS(3084),
    [anon_sym_PIPE_EQ] = ACTIONS(3084),
    [anon_sym_CARET_EQ] = ACTIONS(3084),
    [anon_sym_COLON_EQ] = ACTIONS(3084),
    [anon_sym_lock] = ACTIONS(3084),
    [anon_sym_rlock] = ACTIONS(3084),
    [anon_sym_unsafe] = ACTIONS(3084),
    [anon_sym_sql] = ACTIONS(3084),
    [sym_int_literal] = ACTIONS(3084),
    [sym_float_literal] = ACTIONS(3084),
    [sym_rune_literal] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [anon_sym_c_SQUOTE] = ACTIONS(3084),
    [anon_sym_c_DQUOTE] = ACTIONS(3084),
    [anon_sym_r_SQUOTE] = ACTIONS(3084),
    [anon_sym_r_DQUOTE] = ACTIONS(3084),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3084),
    [anon_sym_shared] = ACTIONS(3084),
    [anon_sym_map_LBRACK] = ACTIONS(3084),
    [anon_sym_chan] = ACTIONS(3084),
    [anon_sym_thread] = ACTIONS(3084),
    [anon_sym_atomic] = ACTIONS(3084),
    [anon_sym_assert] = ACTIONS(3084),
    [anon_sym_defer] = ACTIONS(3084),
    [anon_sym_goto] = ACTIONS(3084),
    [anon_sym_break] = ACTIONS(3084),
    [anon_sym_continue] = ACTIONS(3084),
    [anon_sym_return] = ACTIONS(3084),
    [anon_sym_DOLLARfor] = ACTIONS(3084),
    [anon_sym_for] = ACTIONS(3084),
    [anon_sym_POUND] = ACTIONS(3084),
    [anon_sym_asm] = ACTIONS(3084),
    [anon_sym_AT_LBRACK] = ACTIONS(3084),
  },
  [486] = {
    [sym_line_comment] = STATE(486),
    [sym_block_comment] = STATE(486),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1693),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1692),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(396),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1615),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [487] = {
    [sym_line_comment] = STATE(487),
    [sym_block_comment] = STATE(487),
    [sym__expression] = STATE(1604),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_string_interpolation_repeat1] = STATE(487),
    [sym_identifier] = ACTIONS(3088),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3091),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_RBRACE] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_fn] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3105),
    [anon_sym_DASH] = ACTIONS(3105),
    [anon_sym_STAR] = ACTIONS(3108),
    [anon_sym_struct] = ACTIONS(3111),
    [anon_sym_mut] = ACTIONS(3114),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_go] = ACTIONS(3123),
    [anon_sym_spawn] = ACTIONS(3126),
    [anon_sym_json_DOTdecode] = ACTIONS(3129),
    [anon_sym_LBRACK2] = ACTIONS(3132),
    [anon_sym_TILDE] = ACTIONS(3105),
    [anon_sym_CARET] = ACTIONS(3105),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_LT_DASH] = ACTIONS(3138),
    [sym_none] = ACTIONS(3141),
    [sym_true] = ACTIONS(3141),
    [sym_false] = ACTIONS(3141),
    [sym_nil] = ACTIONS(3141),
    [anon_sym_if] = ACTIONS(3144),
    [anon_sym_DOLLARif] = ACTIONS(3147),
    [anon_sym_match] = ACTIONS(3150),
    [anon_sym_select] = ACTIONS(3153),
    [anon_sym_lock] = ACTIONS(3156),
    [anon_sym_rlock] = ACTIONS(3156),
    [anon_sym_unsafe] = ACTIONS(3159),
    [anon_sym_sql] = ACTIONS(3162),
    [sym_int_literal] = ACTIONS(3141),
    [sym_float_literal] = ACTIONS(3165),
    [sym_rune_literal] = ACTIONS(3165),
    [anon_sym_SQUOTE] = ACTIONS(3168),
    [anon_sym_DQUOTE] = ACTIONS(3171),
    [anon_sym_c_SQUOTE] = ACTIONS(3174),
    [anon_sym_c_DQUOTE] = ACTIONS(3177),
    [anon_sym_r_SQUOTE] = ACTIONS(3180),
    [anon_sym_r_DQUOTE] = ACTIONS(3183),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3186),
    [anon_sym_shared] = ACTIONS(3189),
    [anon_sym_map_LBRACK] = ACTIONS(3192),
    [anon_sym_chan] = ACTIONS(3195),
    [anon_sym_thread] = ACTIONS(3198),
    [anon_sym_atomic] = ACTIONS(3201),
  },
  [488] = {
    [sym_line_comment] = STATE(488),
    [sym_block_comment] = STATE(488),
    [sym__expression] = STATE(1264),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(619),
    [sym_mutable_expression] = STATE(1926),
    [sym_expression_list] = STATE(1947),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [anon_sym_STAR] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_go] = ACTIONS(901),
    [anon_sym_spawn] = ACTIONS(903),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3208),
    [anon_sym_CARET] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_LT_DASH] = ACTIONS(3220),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(921),
    [anon_sym_lock] = ACTIONS(923),
    [anon_sym_rlock] = ACTIONS(923),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [489] = {
    [sym_line_comment] = STATE(489),
    [sym_block_comment] = STATE(489),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4589),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [490] = {
    [sym_line_comment] = STATE(490),
    [sym_block_comment] = STATE(490),
    [ts_builtin_sym_end] = ACTIONS(3238),
    [sym_identifier] = ACTIONS(3240),
    [anon_sym_LF] = ACTIONS(3240),
    [anon_sym_CR] = ACTIONS(3240),
    [anon_sym_CR_LF] = ACTIONS(3240),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3240),
    [anon_sym_as] = ACTIONS(3240),
    [anon_sym_LBRACE] = ACTIONS(3240),
    [anon_sym_COMMA] = ACTIONS(3240),
    [anon_sym_const] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(3240),
    [anon_sym_EQ] = ACTIONS(3240),
    [anon_sym___global] = ACTIONS(3240),
    [anon_sym_type] = ACTIONS(3240),
    [anon_sym_fn] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3240),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [anon_sym_LT] = ACTIONS(3240),
    [anon_sym_GT] = ACTIONS(3240),
    [anon_sym_EQ_EQ] = ACTIONS(3240),
    [anon_sym_BANG_EQ] = ACTIONS(3240),
    [anon_sym_LT_EQ] = ACTIONS(3240),
    [anon_sym_GT_EQ] = ACTIONS(3240),
    [anon_sym_LBRACK] = ACTIONS(3238),
    [anon_sym_struct] = ACTIONS(3240),
    [anon_sym_union] = ACTIONS(3240),
    [anon_sym_pub] = ACTIONS(3240),
    [anon_sym_mut] = ACTIONS(3240),
    [anon_sym_enum] = ACTIONS(3240),
    [anon_sym_interface] = ACTIONS(3240),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_QMARK] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_go] = ACTIONS(3240),
    [anon_sym_spawn] = ACTIONS(3240),
    [anon_sym_json_DOTdecode] = ACTIONS(3240),
    [anon_sym_PIPE] = ACTIONS(3240),
    [anon_sym_LBRACK2] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [anon_sym_CARET] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_LT_DASH] = ACTIONS(3240),
    [anon_sym_LT_LT] = ACTIONS(3240),
    [anon_sym_GT_GT] = ACTIONS(3240),
    [anon_sym_GT_GT_GT] = ACTIONS(3240),
    [anon_sym_AMP_CARET] = ACTIONS(3240),
    [anon_sym_AMP_AMP] = ACTIONS(3240),
    [anon_sym_PIPE_PIPE] = ACTIONS(3240),
    [anon_sym_or] = ACTIONS(3240),
    [sym_none] = ACTIONS(3240),
    [sym_true] = ACTIONS(3240),
    [sym_false] = ACTIONS(3240),
    [sym_nil] = ACTIONS(3240),
    [anon_sym_QMARK_DOT] = ACTIONS(3240),
    [anon_sym_POUND_LBRACK] = ACTIONS(3240),
    [anon_sym_if] = ACTIONS(3240),
    [anon_sym_DOLLARif] = ACTIONS(3240),
    [anon_sym_is] = ACTIONS(3240),
    [anon_sym_BANGis] = ACTIONS(3240),
    [anon_sym_in] = ACTIONS(3240),
    [anon_sym_BANGin] = ACTIONS(3240),
    [anon_sym_match] = ACTIONS(3240),
    [anon_sym_select] = ACTIONS(3240),
    [anon_sym_STAR_EQ] = ACTIONS(3240),
    [anon_sym_SLASH_EQ] = ACTIONS(3240),
    [anon_sym_PERCENT_EQ] = ACTIONS(3240),
    [anon_sym_LT_LT_EQ] = ACTIONS(3240),
    [anon_sym_GT_GT_EQ] = ACTIONS(3240),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3240),
    [anon_sym_AMP_EQ] = ACTIONS(3240),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3240),
    [anon_sym_PLUS_EQ] = ACTIONS(3240),
    [anon_sym_DASH_EQ] = ACTIONS(3240),
    [anon_sym_PIPE_EQ] = ACTIONS(3240),
    [anon_sym_CARET_EQ] = ACTIONS(3240),
    [anon_sym_COLON_EQ] = ACTIONS(3240),
    [anon_sym_lock] = ACTIONS(3240),
    [anon_sym_rlock] = ACTIONS(3240),
    [anon_sym_unsafe] = ACTIONS(3240),
    [anon_sym_sql] = ACTIONS(3240),
    [sym_int_literal] = ACTIONS(3240),
    [sym_float_literal] = ACTIONS(3240),
    [sym_rune_literal] = ACTIONS(3240),
    [anon_sym_SQUOTE] = ACTIONS(3240),
    [anon_sym_DQUOTE] = ACTIONS(3240),
    [anon_sym_c_SQUOTE] = ACTIONS(3240),
    [anon_sym_c_DQUOTE] = ACTIONS(3240),
    [anon_sym_r_SQUOTE] = ACTIONS(3240),
    [anon_sym_r_DQUOTE] = ACTIONS(3240),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3240),
    [anon_sym_shared] = ACTIONS(3240),
    [anon_sym_map_LBRACK] = ACTIONS(3240),
    [anon_sym_chan] = ACTIONS(3240),
    [anon_sym_thread] = ACTIONS(3240),
    [anon_sym_atomic] = ACTIONS(3240),
    [anon_sym_assert] = ACTIONS(3240),
    [anon_sym_defer] = ACTIONS(3240),
    [anon_sym_goto] = ACTIONS(3240),
    [anon_sym_break] = ACTIONS(3240),
    [anon_sym_continue] = ACTIONS(3240),
    [anon_sym_return] = ACTIONS(3240),
    [anon_sym_DOLLARfor] = ACTIONS(3240),
    [anon_sym_for] = ACTIONS(3240),
    [anon_sym_POUND] = ACTIONS(3240),
    [anon_sym_asm] = ACTIONS(3240),
    [anon_sym_AT_LBRACK] = ACTIONS(3240),
  },
  [491] = {
    [sym_line_comment] = STATE(491),
    [sym_block_comment] = STATE(491),
    [sym__expression] = STATE(1264),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(619),
    [sym_mutable_expression] = STATE(1926),
    [sym_expression_list] = STATE(1951),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [anon_sym_STAR] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_go] = ACTIONS(901),
    [anon_sym_spawn] = ACTIONS(903),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3208),
    [anon_sym_CARET] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_LT_DASH] = ACTIONS(3220),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(921),
    [anon_sym_lock] = ACTIONS(923),
    [anon_sym_rlock] = ACTIONS(923),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [492] = {
    [sym_line_comment] = STATE(492),
    [sym_block_comment] = STATE(492),
    [sym__expression] = STATE(1558),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym_string_interpolation_repeat1] = STATE(451),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_RBRACE] = ACTIONS(3242),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_go] = ACTIONS(2903),
    [anon_sym_spawn] = ACTIONS(2905),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_LT_DASH] = ACTIONS(2909),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(2911),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_rlock] = ACTIONS(2913),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [493] = {
    [sym_line_comment] = STATE(493),
    [sym_block_comment] = STATE(493),
    [ts_builtin_sym_end] = ACTIONS(3244),
    [sym_identifier] = ACTIONS(3246),
    [anon_sym_LF] = ACTIONS(3246),
    [anon_sym_CR] = ACTIONS(3246),
    [anon_sym_CR_LF] = ACTIONS(3246),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3246),
    [anon_sym_as] = ACTIONS(3246),
    [anon_sym_LBRACE] = ACTIONS(3246),
    [anon_sym_COMMA] = ACTIONS(3246),
    [anon_sym_const] = ACTIONS(3246),
    [anon_sym_LPAREN] = ACTIONS(3246),
    [anon_sym_EQ] = ACTIONS(3246),
    [anon_sym___global] = ACTIONS(3246),
    [anon_sym_type] = ACTIONS(3246),
    [anon_sym_fn] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3246),
    [anon_sym_DASH] = ACTIONS(3246),
    [anon_sym_STAR] = ACTIONS(3246),
    [anon_sym_SLASH] = ACTIONS(3246),
    [anon_sym_PERCENT] = ACTIONS(3246),
    [anon_sym_LT] = ACTIONS(3246),
    [anon_sym_GT] = ACTIONS(3246),
    [anon_sym_EQ_EQ] = ACTIONS(3246),
    [anon_sym_BANG_EQ] = ACTIONS(3246),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3246),
    [anon_sym_LBRACK] = ACTIONS(3244),
    [anon_sym_struct] = ACTIONS(3246),
    [anon_sym_union] = ACTIONS(3246),
    [anon_sym_pub] = ACTIONS(3246),
    [anon_sym_mut] = ACTIONS(3246),
    [anon_sym_enum] = ACTIONS(3246),
    [anon_sym_interface] = ACTIONS(3246),
    [anon_sym_PLUS_PLUS] = ACTIONS(3246),
    [anon_sym_DASH_DASH] = ACTIONS(3246),
    [anon_sym_QMARK] = ACTIONS(3246),
    [anon_sym_BANG] = ACTIONS(3246),
    [anon_sym_go] = ACTIONS(3246),
    [anon_sym_spawn] = ACTIONS(3246),
    [anon_sym_json_DOTdecode] = ACTIONS(3246),
    [anon_sym_PIPE] = ACTIONS(3246),
    [anon_sym_LBRACK2] = ACTIONS(3246),
    [anon_sym_TILDE] = ACTIONS(3246),
    [anon_sym_CARET] = ACTIONS(3246),
    [anon_sym_AMP] = ACTIONS(3246),
    [anon_sym_LT_DASH] = ACTIONS(3246),
    [anon_sym_LT_LT] = ACTIONS(3246),
    [anon_sym_GT_GT] = ACTIONS(3246),
    [anon_sym_GT_GT_GT] = ACTIONS(3246),
    [anon_sym_AMP_CARET] = ACTIONS(3246),
    [anon_sym_AMP_AMP] = ACTIONS(3246),
    [anon_sym_PIPE_PIPE] = ACTIONS(3246),
    [anon_sym_or] = ACTIONS(3246),
    [sym_none] = ACTIONS(3246),
    [sym_true] = ACTIONS(3246),
    [sym_false] = ACTIONS(3246),
    [sym_nil] = ACTIONS(3246),
    [anon_sym_QMARK_DOT] = ACTIONS(3246),
    [anon_sym_POUND_LBRACK] = ACTIONS(3246),
    [anon_sym_if] = ACTIONS(3246),
    [anon_sym_DOLLARif] = ACTIONS(3246),
    [anon_sym_is] = ACTIONS(3246),
    [anon_sym_BANGis] = ACTIONS(3246),
    [anon_sym_in] = ACTIONS(3246),
    [anon_sym_BANGin] = ACTIONS(3246),
    [anon_sym_match] = ACTIONS(3246),
    [anon_sym_select] = ACTIONS(3246),
    [anon_sym_STAR_EQ] = ACTIONS(3246),
    [anon_sym_SLASH_EQ] = ACTIONS(3246),
    [anon_sym_PERCENT_EQ] = ACTIONS(3246),
    [anon_sym_LT_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT_GT_EQ] = ACTIONS(3246),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3246),
    [anon_sym_AMP_EQ] = ACTIONS(3246),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3246),
    [anon_sym_PLUS_EQ] = ACTIONS(3246),
    [anon_sym_DASH_EQ] = ACTIONS(3246),
    [anon_sym_PIPE_EQ] = ACTIONS(3246),
    [anon_sym_CARET_EQ] = ACTIONS(3246),
    [anon_sym_COLON_EQ] = ACTIONS(3246),
    [anon_sym_lock] = ACTIONS(3246),
    [anon_sym_rlock] = ACTIONS(3246),
    [anon_sym_unsafe] = ACTIONS(3246),
    [anon_sym_sql] = ACTIONS(3246),
    [sym_int_literal] = ACTIONS(3246),
    [sym_float_literal] = ACTIONS(3246),
    [sym_rune_literal] = ACTIONS(3246),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_DQUOTE] = ACTIONS(3246),
    [anon_sym_c_SQUOTE] = ACTIONS(3246),
    [anon_sym_c_DQUOTE] = ACTIONS(3246),
    [anon_sym_r_SQUOTE] = ACTIONS(3246),
    [anon_sym_r_DQUOTE] = ACTIONS(3246),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3246),
    [anon_sym_shared] = ACTIONS(3246),
    [anon_sym_map_LBRACK] = ACTIONS(3246),
    [anon_sym_chan] = ACTIONS(3246),
    [anon_sym_thread] = ACTIONS(3246),
    [anon_sym_atomic] = ACTIONS(3246),
    [anon_sym_assert] = ACTIONS(3246),
    [anon_sym_defer] = ACTIONS(3246),
    [anon_sym_goto] = ACTIONS(3246),
    [anon_sym_break] = ACTIONS(3246),
    [anon_sym_continue] = ACTIONS(3246),
    [anon_sym_return] = ACTIONS(3246),
    [anon_sym_DOLLARfor] = ACTIONS(3246),
    [anon_sym_for] = ACTIONS(3246),
    [anon_sym_POUND] = ACTIONS(3246),
    [anon_sym_asm] = ACTIONS(3246),
    [anon_sym_AT_LBRACK] = ACTIONS(3246),
  },
  [494] = {
    [sym_line_comment] = STATE(494),
    [sym_block_comment] = STATE(494),
    [ts_builtin_sym_end] = ACTIONS(3248),
    [sym_identifier] = ACTIONS(3250),
    [anon_sym_LF] = ACTIONS(3250),
    [anon_sym_CR] = ACTIONS(3250),
    [anon_sym_CR_LF] = ACTIONS(3250),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3250),
    [anon_sym_as] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3250),
    [anon_sym_COMMA] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_LPAREN] = ACTIONS(3250),
    [anon_sym_EQ] = ACTIONS(3250),
    [anon_sym___global] = ACTIONS(3250),
    [anon_sym_type] = ACTIONS(3250),
    [anon_sym_fn] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_STAR] = ACTIONS(3250),
    [anon_sym_SLASH] = ACTIONS(3250),
    [anon_sym_PERCENT] = ACTIONS(3250),
    [anon_sym_LT] = ACTIONS(3250),
    [anon_sym_GT] = ACTIONS(3250),
    [anon_sym_EQ_EQ] = ACTIONS(3250),
    [anon_sym_BANG_EQ] = ACTIONS(3250),
    [anon_sym_LT_EQ] = ACTIONS(3250),
    [anon_sym_GT_EQ] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3248),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_union] = ACTIONS(3250),
    [anon_sym_pub] = ACTIONS(3250),
    [anon_sym_mut] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [anon_sym_interface] = ACTIONS(3250),
    [anon_sym_PLUS_PLUS] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3250),
    [anon_sym_QMARK] = ACTIONS(3250),
    [anon_sym_BANG] = ACTIONS(3250),
    [anon_sym_go] = ACTIONS(3250),
    [anon_sym_spawn] = ACTIONS(3250),
    [anon_sym_json_DOTdecode] = ACTIONS(3250),
    [anon_sym_PIPE] = ACTIONS(3250),
    [anon_sym_LBRACK2] = ACTIONS(3250),
    [anon_sym_TILDE] = ACTIONS(3250),
    [anon_sym_CARET] = ACTIONS(3250),
    [anon_sym_AMP] = ACTIONS(3250),
    [anon_sym_LT_DASH] = ACTIONS(3250),
    [anon_sym_LT_LT] = ACTIONS(3250),
    [anon_sym_GT_GT] = ACTIONS(3250),
    [anon_sym_GT_GT_GT] = ACTIONS(3250),
    [anon_sym_AMP_CARET] = ACTIONS(3250),
    [anon_sym_AMP_AMP] = ACTIONS(3250),
    [anon_sym_PIPE_PIPE] = ACTIONS(3250),
    [anon_sym_or] = ACTIONS(3250),
    [sym_none] = ACTIONS(3250),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [sym_nil] = ACTIONS(3250),
    [anon_sym_QMARK_DOT] = ACTIONS(3250),
    [anon_sym_POUND_LBRACK] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_DOLLARif] = ACTIONS(3250),
    [anon_sym_is] = ACTIONS(3250),
    [anon_sym_BANGis] = ACTIONS(3250),
    [anon_sym_in] = ACTIONS(3250),
    [anon_sym_BANGin] = ACTIONS(3250),
    [anon_sym_match] = ACTIONS(3250),
    [anon_sym_select] = ACTIONS(3250),
    [anon_sym_STAR_EQ] = ACTIONS(3250),
    [anon_sym_SLASH_EQ] = ACTIONS(3250),
    [anon_sym_PERCENT_EQ] = ACTIONS(3250),
    [anon_sym_LT_LT_EQ] = ACTIONS(3250),
    [anon_sym_GT_GT_EQ] = ACTIONS(3250),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3250),
    [anon_sym_AMP_EQ] = ACTIONS(3250),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3250),
    [anon_sym_PLUS_EQ] = ACTIONS(3250),
    [anon_sym_DASH_EQ] = ACTIONS(3250),
    [anon_sym_PIPE_EQ] = ACTIONS(3250),
    [anon_sym_CARET_EQ] = ACTIONS(3250),
    [anon_sym_COLON_EQ] = ACTIONS(3250),
    [anon_sym_lock] = ACTIONS(3250),
    [anon_sym_rlock] = ACTIONS(3250),
    [anon_sym_unsafe] = ACTIONS(3250),
    [anon_sym_sql] = ACTIONS(3250),
    [sym_int_literal] = ACTIONS(3250),
    [sym_float_literal] = ACTIONS(3250),
    [sym_rune_literal] = ACTIONS(3250),
    [anon_sym_SQUOTE] = ACTIONS(3250),
    [anon_sym_DQUOTE] = ACTIONS(3250),
    [anon_sym_c_SQUOTE] = ACTIONS(3250),
    [anon_sym_c_DQUOTE] = ACTIONS(3250),
    [anon_sym_r_SQUOTE] = ACTIONS(3250),
    [anon_sym_r_DQUOTE] = ACTIONS(3250),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3250),
    [anon_sym_shared] = ACTIONS(3250),
    [anon_sym_map_LBRACK] = ACTIONS(3250),
    [anon_sym_chan] = ACTIONS(3250),
    [anon_sym_thread] = ACTIONS(3250),
    [anon_sym_atomic] = ACTIONS(3250),
    [anon_sym_assert] = ACTIONS(3250),
    [anon_sym_defer] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_DOLLARfor] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_POUND] = ACTIONS(3250),
    [anon_sym_asm] = ACTIONS(3250),
    [anon_sym_AT_LBRACK] = ACTIONS(3250),
  },
  [495] = {
    [sym_line_comment] = STATE(495),
    [sym_block_comment] = STATE(495),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1693),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1692),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(449),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(3252),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1615),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [496] = {
    [sym_line_comment] = STATE(496),
    [sym_block_comment] = STATE(496),
    [sym__expression] = STATE(2616),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3688),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4628),
    [sym_identifier] = ACTIONS(2385),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(2387),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2389),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(2391),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [497] = {
    [sym_line_comment] = STATE(497),
    [sym_block_comment] = STATE(497),
    [ts_builtin_sym_end] = ACTIONS(3254),
    [sym_identifier] = ACTIONS(3256),
    [anon_sym_LF] = ACTIONS(3256),
    [anon_sym_CR] = ACTIONS(3256),
    [anon_sym_CR_LF] = ACTIONS(3256),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3256),
    [anon_sym_as] = ACTIONS(3256),
    [anon_sym_LBRACE] = ACTIONS(3256),
    [anon_sym_COMMA] = ACTIONS(3256),
    [anon_sym_const] = ACTIONS(3256),
    [anon_sym_LPAREN] = ACTIONS(3256),
    [anon_sym_EQ] = ACTIONS(3256),
    [anon_sym___global] = ACTIONS(3256),
    [anon_sym_type] = ACTIONS(3256),
    [anon_sym_fn] = ACTIONS(3256),
    [anon_sym_PLUS] = ACTIONS(3256),
    [anon_sym_DASH] = ACTIONS(3256),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_SLASH] = ACTIONS(3256),
    [anon_sym_PERCENT] = ACTIONS(3256),
    [anon_sym_LT] = ACTIONS(3256),
    [anon_sym_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(3256),
    [anon_sym_BANG_EQ] = ACTIONS(3256),
    [anon_sym_LT_EQ] = ACTIONS(3256),
    [anon_sym_GT_EQ] = ACTIONS(3256),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [anon_sym_struct] = ACTIONS(3256),
    [anon_sym_union] = ACTIONS(3256),
    [anon_sym_pub] = ACTIONS(3256),
    [anon_sym_mut] = ACTIONS(3256),
    [anon_sym_enum] = ACTIONS(3256),
    [anon_sym_interface] = ACTIONS(3256),
    [anon_sym_PLUS_PLUS] = ACTIONS(3256),
    [anon_sym_DASH_DASH] = ACTIONS(3256),
    [anon_sym_QMARK] = ACTIONS(3256),
    [anon_sym_BANG] = ACTIONS(3256),
    [anon_sym_go] = ACTIONS(3256),
    [anon_sym_spawn] = ACTIONS(3256),
    [anon_sym_json_DOTdecode] = ACTIONS(3256),
    [anon_sym_PIPE] = ACTIONS(3256),
    [anon_sym_LBRACK2] = ACTIONS(3256),
    [anon_sym_TILDE] = ACTIONS(3256),
    [anon_sym_CARET] = ACTIONS(3256),
    [anon_sym_AMP] = ACTIONS(3256),
    [anon_sym_LT_DASH] = ACTIONS(3256),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_GT_GT_GT] = ACTIONS(3256),
    [anon_sym_AMP_CARET] = ACTIONS(3256),
    [anon_sym_AMP_AMP] = ACTIONS(3256),
    [anon_sym_PIPE_PIPE] = ACTIONS(3256),
    [anon_sym_or] = ACTIONS(3256),
    [sym_none] = ACTIONS(3256),
    [sym_true] = ACTIONS(3256),
    [sym_false] = ACTIONS(3256),
    [sym_nil] = ACTIONS(3256),
    [anon_sym_QMARK_DOT] = ACTIONS(3256),
    [anon_sym_POUND_LBRACK] = ACTIONS(3256),
    [anon_sym_if] = ACTIONS(3256),
    [anon_sym_DOLLARif] = ACTIONS(3256),
    [anon_sym_is] = ACTIONS(3256),
    [anon_sym_BANGis] = ACTIONS(3256),
    [anon_sym_in] = ACTIONS(3256),
    [anon_sym_BANGin] = ACTIONS(3256),
    [anon_sym_match] = ACTIONS(3256),
    [anon_sym_select] = ACTIONS(3256),
    [anon_sym_STAR_EQ] = ACTIONS(3256),
    [anon_sym_SLASH_EQ] = ACTIONS(3256),
    [anon_sym_PERCENT_EQ] = ACTIONS(3256),
    [anon_sym_LT_LT_EQ] = ACTIONS(3256),
    [anon_sym_GT_GT_EQ] = ACTIONS(3256),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3256),
    [anon_sym_AMP_EQ] = ACTIONS(3256),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3256),
    [anon_sym_PLUS_EQ] = ACTIONS(3256),
    [anon_sym_DASH_EQ] = ACTIONS(3256),
    [anon_sym_PIPE_EQ] = ACTIONS(3256),
    [anon_sym_CARET_EQ] = ACTIONS(3256),
    [anon_sym_COLON_EQ] = ACTIONS(3256),
    [anon_sym_lock] = ACTIONS(3256),
    [anon_sym_rlock] = ACTIONS(3256),
    [anon_sym_unsafe] = ACTIONS(3256),
    [anon_sym_sql] = ACTIONS(3256),
    [sym_int_literal] = ACTIONS(3256),
    [sym_float_literal] = ACTIONS(3256),
    [sym_rune_literal] = ACTIONS(3256),
    [anon_sym_SQUOTE] = ACTIONS(3256),
    [anon_sym_DQUOTE] = ACTIONS(3256),
    [anon_sym_c_SQUOTE] = ACTIONS(3256),
    [anon_sym_c_DQUOTE] = ACTIONS(3256),
    [anon_sym_r_SQUOTE] = ACTIONS(3256),
    [anon_sym_r_DQUOTE] = ACTIONS(3256),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3256),
    [anon_sym_shared] = ACTIONS(3256),
    [anon_sym_map_LBRACK] = ACTIONS(3256),
    [anon_sym_chan] = ACTIONS(3256),
    [anon_sym_thread] = ACTIONS(3256),
    [anon_sym_atomic] = ACTIONS(3256),
    [anon_sym_assert] = ACTIONS(3256),
    [anon_sym_defer] = ACTIONS(3256),
    [anon_sym_goto] = ACTIONS(3256),
    [anon_sym_break] = ACTIONS(3256),
    [anon_sym_continue] = ACTIONS(3256),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_DOLLARfor] = ACTIONS(3256),
    [anon_sym_for] = ACTIONS(3256),
    [anon_sym_POUND] = ACTIONS(3256),
    [anon_sym_asm] = ACTIONS(3256),
    [anon_sym_AT_LBRACK] = ACTIONS(3256),
  },
  [498] = {
    [sym_line_comment] = STATE(498),
    [sym_block_comment] = STATE(498),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(402),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(3258),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [499] = {
    [sym_line_comment] = STATE(499),
    [sym_block_comment] = STATE(499),
    [ts_builtin_sym_end] = ACTIONS(3260),
    [sym_identifier] = ACTIONS(3262),
    [anon_sym_LF] = ACTIONS(3262),
    [anon_sym_CR] = ACTIONS(3262),
    [anon_sym_CR_LF] = ACTIONS(3262),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3262),
    [anon_sym_as] = ACTIONS(3262),
    [anon_sym_LBRACE] = ACTIONS(3262),
    [anon_sym_COMMA] = ACTIONS(3262),
    [anon_sym_const] = ACTIONS(3262),
    [anon_sym_LPAREN] = ACTIONS(3262),
    [anon_sym_EQ] = ACTIONS(3262),
    [anon_sym___global] = ACTIONS(3262),
    [anon_sym_type] = ACTIONS(3262),
    [anon_sym_fn] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3262),
    [anon_sym_DASH] = ACTIONS(3262),
    [anon_sym_STAR] = ACTIONS(3262),
    [anon_sym_SLASH] = ACTIONS(3262),
    [anon_sym_PERCENT] = ACTIONS(3262),
    [anon_sym_LT] = ACTIONS(3262),
    [anon_sym_GT] = ACTIONS(3262),
    [anon_sym_EQ_EQ] = ACTIONS(3262),
    [anon_sym_BANG_EQ] = ACTIONS(3262),
    [anon_sym_LT_EQ] = ACTIONS(3262),
    [anon_sym_GT_EQ] = ACTIONS(3262),
    [anon_sym_LBRACK] = ACTIONS(3260),
    [anon_sym_struct] = ACTIONS(3262),
    [anon_sym_union] = ACTIONS(3262),
    [anon_sym_pub] = ACTIONS(3262),
    [anon_sym_mut] = ACTIONS(3262),
    [anon_sym_enum] = ACTIONS(3262),
    [anon_sym_interface] = ACTIONS(3262),
    [anon_sym_PLUS_PLUS] = ACTIONS(3262),
    [anon_sym_DASH_DASH] = ACTIONS(3262),
    [anon_sym_QMARK] = ACTIONS(3262),
    [anon_sym_BANG] = ACTIONS(3262),
    [anon_sym_go] = ACTIONS(3262),
    [anon_sym_spawn] = ACTIONS(3262),
    [anon_sym_json_DOTdecode] = ACTIONS(3262),
    [anon_sym_PIPE] = ACTIONS(3262),
    [anon_sym_LBRACK2] = ACTIONS(3262),
    [anon_sym_TILDE] = ACTIONS(3262),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_AMP] = ACTIONS(3262),
    [anon_sym_LT_DASH] = ACTIONS(3262),
    [anon_sym_LT_LT] = ACTIONS(3262),
    [anon_sym_GT_GT] = ACTIONS(3262),
    [anon_sym_GT_GT_GT] = ACTIONS(3262),
    [anon_sym_AMP_CARET] = ACTIONS(3262),
    [anon_sym_AMP_AMP] = ACTIONS(3262),
    [anon_sym_PIPE_PIPE] = ACTIONS(3262),
    [anon_sym_or] = ACTIONS(3262),
    [sym_none] = ACTIONS(3262),
    [sym_true] = ACTIONS(3262),
    [sym_false] = ACTIONS(3262),
    [sym_nil] = ACTIONS(3262),
    [anon_sym_QMARK_DOT] = ACTIONS(3262),
    [anon_sym_POUND_LBRACK] = ACTIONS(3262),
    [anon_sym_if] = ACTIONS(3262),
    [anon_sym_DOLLARif] = ACTIONS(3262),
    [anon_sym_is] = ACTIONS(3262),
    [anon_sym_BANGis] = ACTIONS(3262),
    [anon_sym_in] = ACTIONS(3262),
    [anon_sym_BANGin] = ACTIONS(3262),
    [anon_sym_match] = ACTIONS(3262),
    [anon_sym_select] = ACTIONS(3262),
    [anon_sym_STAR_EQ] = ACTIONS(3262),
    [anon_sym_SLASH_EQ] = ACTIONS(3262),
    [anon_sym_PERCENT_EQ] = ACTIONS(3262),
    [anon_sym_LT_LT_EQ] = ACTIONS(3262),
    [anon_sym_GT_GT_EQ] = ACTIONS(3262),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3262),
    [anon_sym_AMP_EQ] = ACTIONS(3262),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3262),
    [anon_sym_PLUS_EQ] = ACTIONS(3262),
    [anon_sym_DASH_EQ] = ACTIONS(3262),
    [anon_sym_PIPE_EQ] = ACTIONS(3262),
    [anon_sym_CARET_EQ] = ACTIONS(3262),
    [anon_sym_COLON_EQ] = ACTIONS(3262),
    [anon_sym_lock] = ACTIONS(3262),
    [anon_sym_rlock] = ACTIONS(3262),
    [anon_sym_unsafe] = ACTIONS(3262),
    [anon_sym_sql] = ACTIONS(3262),
    [sym_int_literal] = ACTIONS(3262),
    [sym_float_literal] = ACTIONS(3262),
    [sym_rune_literal] = ACTIONS(3262),
    [anon_sym_SQUOTE] = ACTIONS(3262),
    [anon_sym_DQUOTE] = ACTIONS(3262),
    [anon_sym_c_SQUOTE] = ACTIONS(3262),
    [anon_sym_c_DQUOTE] = ACTIONS(3262),
    [anon_sym_r_SQUOTE] = ACTIONS(3262),
    [anon_sym_r_DQUOTE] = ACTIONS(3262),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3262),
    [anon_sym_shared] = ACTIONS(3262),
    [anon_sym_map_LBRACK] = ACTIONS(3262),
    [anon_sym_chan] = ACTIONS(3262),
    [anon_sym_thread] = ACTIONS(3262),
    [anon_sym_atomic] = ACTIONS(3262),
    [anon_sym_assert] = ACTIONS(3262),
    [anon_sym_defer] = ACTIONS(3262),
    [anon_sym_goto] = ACTIONS(3262),
    [anon_sym_break] = ACTIONS(3262),
    [anon_sym_continue] = ACTIONS(3262),
    [anon_sym_return] = ACTIONS(3262),
    [anon_sym_DOLLARfor] = ACTIONS(3262),
    [anon_sym_for] = ACTIONS(3262),
    [anon_sym_POUND] = ACTIONS(3262),
    [anon_sym_asm] = ACTIONS(3262),
    [anon_sym_AT_LBRACK] = ACTIONS(3262),
  },
  [500] = {
    [sym_line_comment] = STATE(500),
    [sym_block_comment] = STATE(500),
    [sym__expression] = STATE(2616),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_range] = STATE(4628),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(1979),
  },
  [501] = {
    [sym_line_comment] = STATE(501),
    [sym_block_comment] = STATE(501),
    [ts_builtin_sym_end] = ACTIONS(3264),
    [sym_identifier] = ACTIONS(3266),
    [anon_sym_LF] = ACTIONS(3266),
    [anon_sym_CR] = ACTIONS(3266),
    [anon_sym_CR_LF] = ACTIONS(3266),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3266),
    [anon_sym_as] = ACTIONS(3266),
    [anon_sym_LBRACE] = ACTIONS(3266),
    [anon_sym_COMMA] = ACTIONS(3266),
    [anon_sym_const] = ACTIONS(3266),
    [anon_sym_LPAREN] = ACTIONS(3266),
    [anon_sym_EQ] = ACTIONS(3266),
    [anon_sym___global] = ACTIONS(3266),
    [anon_sym_type] = ACTIONS(3266),
    [anon_sym_fn] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3266),
    [anon_sym_DASH] = ACTIONS(3266),
    [anon_sym_STAR] = ACTIONS(3266),
    [anon_sym_SLASH] = ACTIONS(3266),
    [anon_sym_PERCENT] = ACTIONS(3266),
    [anon_sym_LT] = ACTIONS(3266),
    [anon_sym_GT] = ACTIONS(3266),
    [anon_sym_EQ_EQ] = ACTIONS(3266),
    [anon_sym_BANG_EQ] = ACTIONS(3266),
    [anon_sym_LT_EQ] = ACTIONS(3266),
    [anon_sym_GT_EQ] = ACTIONS(3266),
    [anon_sym_LBRACK] = ACTIONS(3264),
    [anon_sym_struct] = ACTIONS(3266),
    [anon_sym_union] = ACTIONS(3266),
    [anon_sym_pub] = ACTIONS(3266),
    [anon_sym_mut] = ACTIONS(3266),
    [anon_sym_enum] = ACTIONS(3266),
    [anon_sym_interface] = ACTIONS(3266),
    [anon_sym_PLUS_PLUS] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3266),
    [anon_sym_QMARK] = ACTIONS(3266),
    [anon_sym_BANG] = ACTIONS(3266),
    [anon_sym_go] = ACTIONS(3266),
    [anon_sym_spawn] = ACTIONS(3266),
    [anon_sym_json_DOTdecode] = ACTIONS(3266),
    [anon_sym_PIPE] = ACTIONS(3266),
    [anon_sym_LBRACK2] = ACTIONS(3266),
    [anon_sym_TILDE] = ACTIONS(3266),
    [anon_sym_CARET] = ACTIONS(3266),
    [anon_sym_AMP] = ACTIONS(3266),
    [anon_sym_LT_DASH] = ACTIONS(3266),
    [anon_sym_LT_LT] = ACTIONS(3266),
    [anon_sym_GT_GT] = ACTIONS(3266),
    [anon_sym_GT_GT_GT] = ACTIONS(3266),
    [anon_sym_AMP_CARET] = ACTIONS(3266),
    [anon_sym_AMP_AMP] = ACTIONS(3266),
    [anon_sym_PIPE_PIPE] = ACTIONS(3266),
    [anon_sym_or] = ACTIONS(3266),
    [sym_none] = ACTIONS(3266),
    [sym_true] = ACTIONS(3266),
    [sym_false] = ACTIONS(3266),
    [sym_nil] = ACTIONS(3266),
    [anon_sym_QMARK_DOT] = ACTIONS(3266),
    [anon_sym_POUND_LBRACK] = ACTIONS(3266),
    [anon_sym_if] = ACTIONS(3266),
    [anon_sym_DOLLARif] = ACTIONS(3266),
    [anon_sym_is] = ACTIONS(3266),
    [anon_sym_BANGis] = ACTIONS(3266),
    [anon_sym_in] = ACTIONS(3266),
    [anon_sym_BANGin] = ACTIONS(3266),
    [anon_sym_match] = ACTIONS(3266),
    [anon_sym_select] = ACTIONS(3266),
    [anon_sym_STAR_EQ] = ACTIONS(3266),
    [anon_sym_SLASH_EQ] = ACTIONS(3266),
    [anon_sym_PERCENT_EQ] = ACTIONS(3266),
    [anon_sym_LT_LT_EQ] = ACTIONS(3266),
    [anon_sym_GT_GT_EQ] = ACTIONS(3266),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3266),
    [anon_sym_AMP_EQ] = ACTIONS(3266),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3266),
    [anon_sym_PLUS_EQ] = ACTIONS(3266),
    [anon_sym_DASH_EQ] = ACTIONS(3266),
    [anon_sym_PIPE_EQ] = ACTIONS(3266),
    [anon_sym_CARET_EQ] = ACTIONS(3266),
    [anon_sym_COLON_EQ] = ACTIONS(3266),
    [anon_sym_lock] = ACTIONS(3266),
    [anon_sym_rlock] = ACTIONS(3266),
    [anon_sym_unsafe] = ACTIONS(3266),
    [anon_sym_sql] = ACTIONS(3266),
    [sym_int_literal] = ACTIONS(3266),
    [sym_float_literal] = ACTIONS(3266),
    [sym_rune_literal] = ACTIONS(3266),
    [anon_sym_SQUOTE] = ACTIONS(3266),
    [anon_sym_DQUOTE] = ACTIONS(3266),
    [anon_sym_c_SQUOTE] = ACTIONS(3266),
    [anon_sym_c_DQUOTE] = ACTIONS(3266),
    [anon_sym_r_SQUOTE] = ACTIONS(3266),
    [anon_sym_r_DQUOTE] = ACTIONS(3266),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3266),
    [anon_sym_shared] = ACTIONS(3266),
    [anon_sym_map_LBRACK] = ACTIONS(3266),
    [anon_sym_chan] = ACTIONS(3266),
    [anon_sym_thread] = ACTIONS(3266),
    [anon_sym_atomic] = ACTIONS(3266),
    [anon_sym_assert] = ACTIONS(3266),
    [anon_sym_defer] = ACTIONS(3266),
    [anon_sym_goto] = ACTIONS(3266),
    [anon_sym_break] = ACTIONS(3266),
    [anon_sym_continue] = ACTIONS(3266),
    [anon_sym_return] = ACTIONS(3266),
    [anon_sym_DOLLARfor] = ACTIONS(3266),
    [anon_sym_for] = ACTIONS(3266),
    [anon_sym_POUND] = ACTIONS(3266),
    [anon_sym_asm] = ACTIONS(3266),
    [anon_sym_AT_LBRACK] = ACTIONS(3266),
  },
  [502] = {
    [sym_line_comment] = STATE(502),
    [sym_block_comment] = STATE(502),
    [ts_builtin_sym_end] = ACTIONS(3268),
    [sym_identifier] = ACTIONS(3270),
    [anon_sym_LF] = ACTIONS(3270),
    [anon_sym_CR] = ACTIONS(3270),
    [anon_sym_CR_LF] = ACTIONS(3270),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3270),
    [anon_sym_as] = ACTIONS(3270),
    [anon_sym_LBRACE] = ACTIONS(3270),
    [anon_sym_COMMA] = ACTIONS(3270),
    [anon_sym_const] = ACTIONS(3270),
    [anon_sym_LPAREN] = ACTIONS(3270),
    [anon_sym_EQ] = ACTIONS(3270),
    [anon_sym___global] = ACTIONS(3270),
    [anon_sym_type] = ACTIONS(3270),
    [anon_sym_fn] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3270),
    [anon_sym_DASH] = ACTIONS(3270),
    [anon_sym_STAR] = ACTIONS(3270),
    [anon_sym_SLASH] = ACTIONS(3270),
    [anon_sym_PERCENT] = ACTIONS(3270),
    [anon_sym_LT] = ACTIONS(3270),
    [anon_sym_GT] = ACTIONS(3270),
    [anon_sym_EQ_EQ] = ACTIONS(3270),
    [anon_sym_BANG_EQ] = ACTIONS(3270),
    [anon_sym_LT_EQ] = ACTIONS(3270),
    [anon_sym_GT_EQ] = ACTIONS(3270),
    [anon_sym_LBRACK] = ACTIONS(3268),
    [anon_sym_struct] = ACTIONS(3270),
    [anon_sym_union] = ACTIONS(3270),
    [anon_sym_pub] = ACTIONS(3270),
    [anon_sym_mut] = ACTIONS(3270),
    [anon_sym_enum] = ACTIONS(3270),
    [anon_sym_interface] = ACTIONS(3270),
    [anon_sym_PLUS_PLUS] = ACTIONS(3270),
    [anon_sym_DASH_DASH] = ACTIONS(3270),
    [anon_sym_QMARK] = ACTIONS(3270),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_go] = ACTIONS(3270),
    [anon_sym_spawn] = ACTIONS(3270),
    [anon_sym_json_DOTdecode] = ACTIONS(3270),
    [anon_sym_PIPE] = ACTIONS(3270),
    [anon_sym_LBRACK2] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3270),
    [anon_sym_CARET] = ACTIONS(3270),
    [anon_sym_AMP] = ACTIONS(3270),
    [anon_sym_LT_DASH] = ACTIONS(3270),
    [anon_sym_LT_LT] = ACTIONS(3270),
    [anon_sym_GT_GT] = ACTIONS(3270),
    [anon_sym_GT_GT_GT] = ACTIONS(3270),
    [anon_sym_AMP_CARET] = ACTIONS(3270),
    [anon_sym_AMP_AMP] = ACTIONS(3270),
    [anon_sym_PIPE_PIPE] = ACTIONS(3270),
    [anon_sym_or] = ACTIONS(3270),
    [sym_none] = ACTIONS(3270),
    [sym_true] = ACTIONS(3270),
    [sym_false] = ACTIONS(3270),
    [sym_nil] = ACTIONS(3270),
    [anon_sym_QMARK_DOT] = ACTIONS(3270),
    [anon_sym_POUND_LBRACK] = ACTIONS(3270),
    [anon_sym_if] = ACTIONS(3270),
    [anon_sym_DOLLARif] = ACTIONS(3270),
    [anon_sym_is] = ACTIONS(3270),
    [anon_sym_BANGis] = ACTIONS(3270),
    [anon_sym_in] = ACTIONS(3270),
    [anon_sym_BANGin] = ACTIONS(3270),
    [anon_sym_match] = ACTIONS(3270),
    [anon_sym_select] = ACTIONS(3270),
    [anon_sym_STAR_EQ] = ACTIONS(3270),
    [anon_sym_SLASH_EQ] = ACTIONS(3270),
    [anon_sym_PERCENT_EQ] = ACTIONS(3270),
    [anon_sym_LT_LT_EQ] = ACTIONS(3270),
    [anon_sym_GT_GT_EQ] = ACTIONS(3270),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3270),
    [anon_sym_AMP_EQ] = ACTIONS(3270),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3270),
    [anon_sym_PLUS_EQ] = ACTIONS(3270),
    [anon_sym_DASH_EQ] = ACTIONS(3270),
    [anon_sym_PIPE_EQ] = ACTIONS(3270),
    [anon_sym_CARET_EQ] = ACTIONS(3270),
    [anon_sym_COLON_EQ] = ACTIONS(3270),
    [anon_sym_lock] = ACTIONS(3270),
    [anon_sym_rlock] = ACTIONS(3270),
    [anon_sym_unsafe] = ACTIONS(3270),
    [anon_sym_sql] = ACTIONS(3270),
    [sym_int_literal] = ACTIONS(3270),
    [sym_float_literal] = ACTIONS(3270),
    [sym_rune_literal] = ACTIONS(3270),
    [anon_sym_SQUOTE] = ACTIONS(3270),
    [anon_sym_DQUOTE] = ACTIONS(3270),
    [anon_sym_c_SQUOTE] = ACTIONS(3270),
    [anon_sym_c_DQUOTE] = ACTIONS(3270),
    [anon_sym_r_SQUOTE] = ACTIONS(3270),
    [anon_sym_r_DQUOTE] = ACTIONS(3270),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3270),
    [anon_sym_shared] = ACTIONS(3270),
    [anon_sym_map_LBRACK] = ACTIONS(3270),
    [anon_sym_chan] = ACTIONS(3270),
    [anon_sym_thread] = ACTIONS(3270),
    [anon_sym_atomic] = ACTIONS(3270),
    [anon_sym_assert] = ACTIONS(3270),
    [anon_sym_defer] = ACTIONS(3270),
    [anon_sym_goto] = ACTIONS(3270),
    [anon_sym_break] = ACTIONS(3270),
    [anon_sym_continue] = ACTIONS(3270),
    [anon_sym_return] = ACTIONS(3270),
    [anon_sym_DOLLARfor] = ACTIONS(3270),
    [anon_sym_for] = ACTIONS(3270),
    [anon_sym_POUND] = ACTIONS(3270),
    [anon_sym_asm] = ACTIONS(3270),
    [anon_sym_AT_LBRACK] = ACTIONS(3270),
  },
  [503] = {
    [sym_line_comment] = STATE(503),
    [sym_block_comment] = STATE(503),
    [ts_builtin_sym_end] = ACTIONS(3272),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_LF] = ACTIONS(3274),
    [anon_sym_CR] = ACTIONS(3274),
    [anon_sym_CR_LF] = ACTIONS(3274),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_as] = ACTIONS(3274),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3274),
    [anon_sym_const] = ACTIONS(3274),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3274),
    [anon_sym___global] = ACTIONS(3274),
    [anon_sym_type] = ACTIONS(3274),
    [anon_sym_fn] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_SLASH] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_LT] = ACTIONS(3274),
    [anon_sym_GT] = ACTIONS(3274),
    [anon_sym_EQ_EQ] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_LT_EQ] = ACTIONS(3274),
    [anon_sym_GT_EQ] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3272),
    [anon_sym_struct] = ACTIONS(3274),
    [anon_sym_union] = ACTIONS(3274),
    [anon_sym_pub] = ACTIONS(3274),
    [anon_sym_mut] = ACTIONS(3274),
    [anon_sym_enum] = ACTIONS(3274),
    [anon_sym_interface] = ACTIONS(3274),
    [anon_sym_PLUS_PLUS] = ACTIONS(3274),
    [anon_sym_DASH_DASH] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_BANG] = ACTIONS(3274),
    [anon_sym_go] = ACTIONS(3274),
    [anon_sym_spawn] = ACTIONS(3274),
    [anon_sym_json_DOTdecode] = ACTIONS(3274),
    [anon_sym_PIPE] = ACTIONS(3274),
    [anon_sym_LBRACK2] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3274),
    [anon_sym_CARET] = ACTIONS(3274),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_LT_LT] = ACTIONS(3274),
    [anon_sym_GT_GT] = ACTIONS(3274),
    [anon_sym_GT_GT_GT] = ACTIONS(3274),
    [anon_sym_AMP_CARET] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_or] = ACTIONS(3274),
    [sym_none] = ACTIONS(3274),
    [sym_true] = ACTIONS(3274),
    [sym_false] = ACTIONS(3274),
    [sym_nil] = ACTIONS(3274),
    [anon_sym_QMARK_DOT] = ACTIONS(3274),
    [anon_sym_POUND_LBRACK] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_DOLLARif] = ACTIONS(3274),
    [anon_sym_is] = ACTIONS(3274),
    [anon_sym_BANGis] = ACTIONS(3274),
    [anon_sym_in] = ACTIONS(3274),
    [anon_sym_BANGin] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_select] = ACTIONS(3274),
    [anon_sym_STAR_EQ] = ACTIONS(3274),
    [anon_sym_SLASH_EQ] = ACTIONS(3274),
    [anon_sym_PERCENT_EQ] = ACTIONS(3274),
    [anon_sym_LT_LT_EQ] = ACTIONS(3274),
    [anon_sym_GT_GT_EQ] = ACTIONS(3274),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3274),
    [anon_sym_AMP_EQ] = ACTIONS(3274),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3274),
    [anon_sym_PLUS_EQ] = ACTIONS(3274),
    [anon_sym_DASH_EQ] = ACTIONS(3274),
    [anon_sym_PIPE_EQ] = ACTIONS(3274),
    [anon_sym_CARET_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3274),
    [anon_sym_lock] = ACTIONS(3274),
    [anon_sym_rlock] = ACTIONS(3274),
    [anon_sym_unsafe] = ACTIONS(3274),
    [anon_sym_sql] = ACTIONS(3274),
    [sym_int_literal] = ACTIONS(3274),
    [sym_float_literal] = ACTIONS(3274),
    [sym_rune_literal] = ACTIONS(3274),
    [anon_sym_SQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_c_SQUOTE] = ACTIONS(3274),
    [anon_sym_c_DQUOTE] = ACTIONS(3274),
    [anon_sym_r_SQUOTE] = ACTIONS(3274),
    [anon_sym_r_DQUOTE] = ACTIONS(3274),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3274),
    [anon_sym_shared] = ACTIONS(3274),
    [anon_sym_map_LBRACK] = ACTIONS(3274),
    [anon_sym_chan] = ACTIONS(3274),
    [anon_sym_thread] = ACTIONS(3274),
    [anon_sym_atomic] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_defer] = ACTIONS(3274),
    [anon_sym_goto] = ACTIONS(3274),
    [anon_sym_break] = ACTIONS(3274),
    [anon_sym_continue] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_DOLLARfor] = ACTIONS(3274),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_POUND] = ACTIONS(3274),
    [anon_sym_asm] = ACTIONS(3274),
    [anon_sym_AT_LBRACK] = ACTIONS(3274),
  },
  [504] = {
    [sym_line_comment] = STATE(504),
    [sym_block_comment] = STATE(504),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1693),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1692),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(375),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(3276),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1615),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [505] = {
    [sym_line_comment] = STATE(505),
    [sym_block_comment] = STATE(505),
    [ts_builtin_sym_end] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3280),
    [anon_sym_LF] = ACTIONS(3280),
    [anon_sym_CR] = ACTIONS(3280),
    [anon_sym_CR_LF] = ACTIONS(3280),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3280),
    [anon_sym_as] = ACTIONS(3280),
    [anon_sym_LBRACE] = ACTIONS(3280),
    [anon_sym_COMMA] = ACTIONS(3280),
    [anon_sym_const] = ACTIONS(3280),
    [anon_sym_LPAREN] = ACTIONS(3280),
    [anon_sym_EQ] = ACTIONS(3280),
    [anon_sym___global] = ACTIONS(3280),
    [anon_sym_type] = ACTIONS(3280),
    [anon_sym_fn] = ACTIONS(3280),
    [anon_sym_PLUS] = ACTIONS(3280),
    [anon_sym_DASH] = ACTIONS(3280),
    [anon_sym_STAR] = ACTIONS(3280),
    [anon_sym_SLASH] = ACTIONS(3280),
    [anon_sym_PERCENT] = ACTIONS(3280),
    [anon_sym_LT] = ACTIONS(3280),
    [anon_sym_GT] = ACTIONS(3280),
    [anon_sym_EQ_EQ] = ACTIONS(3280),
    [anon_sym_BANG_EQ] = ACTIONS(3280),
    [anon_sym_LT_EQ] = ACTIONS(3280),
    [anon_sym_GT_EQ] = ACTIONS(3280),
    [anon_sym_LBRACK] = ACTIONS(3278),
    [anon_sym_struct] = ACTIONS(3280),
    [anon_sym_union] = ACTIONS(3280),
    [anon_sym_pub] = ACTIONS(3280),
    [anon_sym_mut] = ACTIONS(3280),
    [anon_sym_enum] = ACTIONS(3280),
    [anon_sym_interface] = ACTIONS(3280),
    [anon_sym_PLUS_PLUS] = ACTIONS(3280),
    [anon_sym_DASH_DASH] = ACTIONS(3280),
    [anon_sym_QMARK] = ACTIONS(3280),
    [anon_sym_BANG] = ACTIONS(3280),
    [anon_sym_go] = ACTIONS(3280),
    [anon_sym_spawn] = ACTIONS(3280),
    [anon_sym_json_DOTdecode] = ACTIONS(3280),
    [anon_sym_PIPE] = ACTIONS(3280),
    [anon_sym_LBRACK2] = ACTIONS(3280),
    [anon_sym_TILDE] = ACTIONS(3280),
    [anon_sym_CARET] = ACTIONS(3280),
    [anon_sym_AMP] = ACTIONS(3280),
    [anon_sym_LT_DASH] = ACTIONS(3280),
    [anon_sym_LT_LT] = ACTIONS(3280),
    [anon_sym_GT_GT] = ACTIONS(3280),
    [anon_sym_GT_GT_GT] = ACTIONS(3280),
    [anon_sym_AMP_CARET] = ACTIONS(3280),
    [anon_sym_AMP_AMP] = ACTIONS(3280),
    [anon_sym_PIPE_PIPE] = ACTIONS(3280),
    [anon_sym_or] = ACTIONS(3280),
    [sym_none] = ACTIONS(3280),
    [sym_true] = ACTIONS(3280),
    [sym_false] = ACTIONS(3280),
    [sym_nil] = ACTIONS(3280),
    [anon_sym_QMARK_DOT] = ACTIONS(3280),
    [anon_sym_POUND_LBRACK] = ACTIONS(3280),
    [anon_sym_if] = ACTIONS(3280),
    [anon_sym_DOLLARif] = ACTIONS(3280),
    [anon_sym_is] = ACTIONS(3280),
    [anon_sym_BANGis] = ACTIONS(3280),
    [anon_sym_in] = ACTIONS(3280),
    [anon_sym_BANGin] = ACTIONS(3280),
    [anon_sym_match] = ACTIONS(3280),
    [anon_sym_select] = ACTIONS(3280),
    [anon_sym_STAR_EQ] = ACTIONS(3280),
    [anon_sym_SLASH_EQ] = ACTIONS(3280),
    [anon_sym_PERCENT_EQ] = ACTIONS(3280),
    [anon_sym_LT_LT_EQ] = ACTIONS(3280),
    [anon_sym_GT_GT_EQ] = ACTIONS(3280),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3280),
    [anon_sym_AMP_EQ] = ACTIONS(3280),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3280),
    [anon_sym_PLUS_EQ] = ACTIONS(3280),
    [anon_sym_DASH_EQ] = ACTIONS(3280),
    [anon_sym_PIPE_EQ] = ACTIONS(3280),
    [anon_sym_CARET_EQ] = ACTIONS(3280),
    [anon_sym_COLON_EQ] = ACTIONS(3280),
    [anon_sym_lock] = ACTIONS(3280),
    [anon_sym_rlock] = ACTIONS(3280),
    [anon_sym_unsafe] = ACTIONS(3280),
    [anon_sym_sql] = ACTIONS(3280),
    [sym_int_literal] = ACTIONS(3280),
    [sym_float_literal] = ACTIONS(3280),
    [sym_rune_literal] = ACTIONS(3280),
    [anon_sym_SQUOTE] = ACTIONS(3280),
    [anon_sym_DQUOTE] = ACTIONS(3280),
    [anon_sym_c_SQUOTE] = ACTIONS(3280),
    [anon_sym_c_DQUOTE] = ACTIONS(3280),
    [anon_sym_r_SQUOTE] = ACTIONS(3280),
    [anon_sym_r_DQUOTE] = ACTIONS(3280),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3280),
    [anon_sym_shared] = ACTIONS(3280),
    [anon_sym_map_LBRACK] = ACTIONS(3280),
    [anon_sym_chan] = ACTIONS(3280),
    [anon_sym_thread] = ACTIONS(3280),
    [anon_sym_atomic] = ACTIONS(3280),
    [anon_sym_assert] = ACTIONS(3280),
    [anon_sym_defer] = ACTIONS(3280),
    [anon_sym_goto] = ACTIONS(3280),
    [anon_sym_break] = ACTIONS(3280),
    [anon_sym_continue] = ACTIONS(3280),
    [anon_sym_return] = ACTIONS(3280),
    [anon_sym_DOLLARfor] = ACTIONS(3280),
    [anon_sym_for] = ACTIONS(3280),
    [anon_sym_POUND] = ACTIONS(3280),
    [anon_sym_asm] = ACTIONS(3280),
    [anon_sym_AT_LBRACK] = ACTIONS(3280),
  },
  [506] = {
    [sym_line_comment] = STATE(506),
    [sym_block_comment] = STATE(506),
    [ts_builtin_sym_end] = ACTIONS(2371),
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2373),
    [anon_sym_CR] = ACTIONS(2373),
    [anon_sym_CR_LF] = ACTIONS(2373),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2177),
    [anon_sym_as] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2373),
    [anon_sym_COMMA] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym_EQ] = ACTIONS(2373),
    [anon_sym___global] = ACTIONS(2373),
    [anon_sym_type] = ACTIONS(2373),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_SLASH] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2373),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_pub] = ACTIONS(2373),
    [anon_sym_mut] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2373),
    [anon_sym_QMARK] = ACTIONS(2373),
    [anon_sym_BANG] = ACTIONS(2373),
    [anon_sym_go] = ACTIONS(2373),
    [anon_sym_spawn] = ACTIONS(2373),
    [anon_sym_json_DOTdecode] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_LBRACK2] = ACTIONS(2373),
    [anon_sym_TILDE] = ACTIONS(2373),
    [anon_sym_CARET] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_LT_DASH] = ACTIONS(2373),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2373),
    [anon_sym_AMP_CARET] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2373),
    [anon_sym_or] = ACTIONS(2373),
    [sym_none] = ACTIONS(2373),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [sym_nil] = ACTIONS(2373),
    [anon_sym_QMARK_DOT] = ACTIONS(2373),
    [anon_sym_POUND_LBRACK] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_DOLLARif] = ACTIONS(2373),
    [anon_sym_is] = ACTIONS(2373),
    [anon_sym_BANGis] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_BANGin] = ACTIONS(2373),
    [anon_sym_match] = ACTIONS(2373),
    [anon_sym_select] = ACTIONS(2373),
    [anon_sym_STAR_EQ] = ACTIONS(2373),
    [anon_sym_SLASH_EQ] = ACTIONS(2373),
    [anon_sym_PERCENT_EQ] = ACTIONS(2373),
    [anon_sym_LT_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT_GT_EQ] = ACTIONS(2373),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2373),
    [anon_sym_AMP_EQ] = ACTIONS(2373),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2373),
    [anon_sym_PLUS_EQ] = ACTIONS(2373),
    [anon_sym_DASH_EQ] = ACTIONS(2373),
    [anon_sym_PIPE_EQ] = ACTIONS(2373),
    [anon_sym_CARET_EQ] = ACTIONS(2373),
    [anon_sym_COLON_EQ] = ACTIONS(2373),
    [anon_sym_lock] = ACTIONS(2373),
    [anon_sym_rlock] = ACTIONS(2373),
    [anon_sym_unsafe] = ACTIONS(2373),
    [anon_sym_sql] = ACTIONS(2373),
    [sym_int_literal] = ACTIONS(2373),
    [sym_float_literal] = ACTIONS(2373),
    [sym_rune_literal] = ACTIONS(2373),
    [anon_sym_SQUOTE] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(2373),
    [anon_sym_c_SQUOTE] = ACTIONS(2373),
    [anon_sym_c_DQUOTE] = ACTIONS(2373),
    [anon_sym_r_SQUOTE] = ACTIONS(2373),
    [anon_sym_r_DQUOTE] = ACTIONS(2373),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_map_LBRACK] = ACTIONS(2373),
    [anon_sym_chan] = ACTIONS(2373),
    [anon_sym_thread] = ACTIONS(2373),
    [anon_sym_atomic] = ACTIONS(2373),
    [anon_sym_assert] = ACTIONS(2373),
    [anon_sym_defer] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_DOLLARfor] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_POUND] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym_AT_LBRACK] = ACTIONS(2373),
  },
  [507] = {
    [sym_line_comment] = STATE(507),
    [sym_block_comment] = STATE(507),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1693),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1692),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(375),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(3282),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1615),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [508] = {
    [sym_line_comment] = STATE(508),
    [sym_block_comment] = STATE(508),
    [ts_builtin_sym_end] = ACTIONS(3284),
    [sym_identifier] = ACTIONS(3286),
    [anon_sym_LF] = ACTIONS(3286),
    [anon_sym_CR] = ACTIONS(3286),
    [anon_sym_CR_LF] = ACTIONS(3286),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3286),
    [anon_sym_as] = ACTIONS(3286),
    [anon_sym_LBRACE] = ACTIONS(3286),
    [anon_sym_COMMA] = ACTIONS(3286),
    [anon_sym_const] = ACTIONS(3286),
    [anon_sym_LPAREN] = ACTIONS(3286),
    [anon_sym_EQ] = ACTIONS(3286),
    [anon_sym___global] = ACTIONS(3286),
    [anon_sym_type] = ACTIONS(3286),
    [anon_sym_fn] = ACTIONS(3286),
    [anon_sym_PLUS] = ACTIONS(3286),
    [anon_sym_DASH] = ACTIONS(3286),
    [anon_sym_STAR] = ACTIONS(3286),
    [anon_sym_SLASH] = ACTIONS(3286),
    [anon_sym_PERCENT] = ACTIONS(3286),
    [anon_sym_LT] = ACTIONS(3286),
    [anon_sym_GT] = ACTIONS(3286),
    [anon_sym_EQ_EQ] = ACTIONS(3286),
    [anon_sym_BANG_EQ] = ACTIONS(3286),
    [anon_sym_LT_EQ] = ACTIONS(3286),
    [anon_sym_GT_EQ] = ACTIONS(3286),
    [anon_sym_LBRACK] = ACTIONS(3284),
    [anon_sym_struct] = ACTIONS(3286),
    [anon_sym_union] = ACTIONS(3286),
    [anon_sym_pub] = ACTIONS(3286),
    [anon_sym_mut] = ACTIONS(3286),
    [anon_sym_enum] = ACTIONS(3286),
    [anon_sym_interface] = ACTIONS(3286),
    [anon_sym_PLUS_PLUS] = ACTIONS(3286),
    [anon_sym_DASH_DASH] = ACTIONS(3286),
    [anon_sym_QMARK] = ACTIONS(3286),
    [anon_sym_BANG] = ACTIONS(3286),
    [anon_sym_go] = ACTIONS(3286),
    [anon_sym_spawn] = ACTIONS(3286),
    [anon_sym_json_DOTdecode] = ACTIONS(3286),
    [anon_sym_PIPE] = ACTIONS(3286),
    [anon_sym_LBRACK2] = ACTIONS(3286),
    [anon_sym_TILDE] = ACTIONS(3286),
    [anon_sym_CARET] = ACTIONS(3286),
    [anon_sym_AMP] = ACTIONS(3286),
    [anon_sym_LT_DASH] = ACTIONS(3286),
    [anon_sym_LT_LT] = ACTIONS(3286),
    [anon_sym_GT_GT] = ACTIONS(3286),
    [anon_sym_GT_GT_GT] = ACTIONS(3286),
    [anon_sym_AMP_CARET] = ACTIONS(3286),
    [anon_sym_AMP_AMP] = ACTIONS(3286),
    [anon_sym_PIPE_PIPE] = ACTIONS(3286),
    [anon_sym_or] = ACTIONS(3286),
    [sym_none] = ACTIONS(3286),
    [sym_true] = ACTIONS(3286),
    [sym_false] = ACTIONS(3286),
    [sym_nil] = ACTIONS(3286),
    [anon_sym_QMARK_DOT] = ACTIONS(3286),
    [anon_sym_POUND_LBRACK] = ACTIONS(3286),
    [anon_sym_if] = ACTIONS(3286),
    [anon_sym_DOLLARif] = ACTIONS(3286),
    [anon_sym_is] = ACTIONS(3286),
    [anon_sym_BANGis] = ACTIONS(3286),
    [anon_sym_in] = ACTIONS(3286),
    [anon_sym_BANGin] = ACTIONS(3286),
    [anon_sym_match] = ACTIONS(3286),
    [anon_sym_select] = ACTIONS(3286),
    [anon_sym_STAR_EQ] = ACTIONS(3286),
    [anon_sym_SLASH_EQ] = ACTIONS(3286),
    [anon_sym_PERCENT_EQ] = ACTIONS(3286),
    [anon_sym_LT_LT_EQ] = ACTIONS(3286),
    [anon_sym_GT_GT_EQ] = ACTIONS(3286),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3286),
    [anon_sym_AMP_EQ] = ACTIONS(3286),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3286),
    [anon_sym_PLUS_EQ] = ACTIONS(3286),
    [anon_sym_DASH_EQ] = ACTIONS(3286),
    [anon_sym_PIPE_EQ] = ACTIONS(3286),
    [anon_sym_CARET_EQ] = ACTIONS(3286),
    [anon_sym_COLON_EQ] = ACTIONS(3286),
    [anon_sym_lock] = ACTIONS(3286),
    [anon_sym_rlock] = ACTIONS(3286),
    [anon_sym_unsafe] = ACTIONS(3286),
    [anon_sym_sql] = ACTIONS(3286),
    [sym_int_literal] = ACTIONS(3286),
    [sym_float_literal] = ACTIONS(3286),
    [sym_rune_literal] = ACTIONS(3286),
    [anon_sym_SQUOTE] = ACTIONS(3286),
    [anon_sym_DQUOTE] = ACTIONS(3286),
    [anon_sym_c_SQUOTE] = ACTIONS(3286),
    [anon_sym_c_DQUOTE] = ACTIONS(3286),
    [anon_sym_r_SQUOTE] = ACTIONS(3286),
    [anon_sym_r_DQUOTE] = ACTIONS(3286),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3286),
    [anon_sym_shared] = ACTIONS(3286),
    [anon_sym_map_LBRACK] = ACTIONS(3286),
    [anon_sym_chan] = ACTIONS(3286),
    [anon_sym_thread] = ACTIONS(3286),
    [anon_sym_atomic] = ACTIONS(3286),
    [anon_sym_assert] = ACTIONS(3286),
    [anon_sym_defer] = ACTIONS(3286),
    [anon_sym_goto] = ACTIONS(3286),
    [anon_sym_break] = ACTIONS(3286),
    [anon_sym_continue] = ACTIONS(3286),
    [anon_sym_return] = ACTIONS(3286),
    [anon_sym_DOLLARfor] = ACTIONS(3286),
    [anon_sym_for] = ACTIONS(3286),
    [anon_sym_POUND] = ACTIONS(3286),
    [anon_sym_asm] = ACTIONS(3286),
    [anon_sym_AT_LBRACK] = ACTIONS(3286),
  },
  [509] = {
    [sym_line_comment] = STATE(509),
    [sym_block_comment] = STATE(509),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(402),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(3288),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [510] = {
    [sym_line_comment] = STATE(510),
    [sym_block_comment] = STATE(510),
    [ts_builtin_sym_end] = ACTIONS(3290),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_LF] = ACTIONS(3292),
    [anon_sym_CR] = ACTIONS(3292),
    [anon_sym_CR_LF] = ACTIONS(3292),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(3292),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_COMMA] = ACTIONS(3292),
    [anon_sym_const] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_EQ] = ACTIONS(3292),
    [anon_sym___global] = ACTIONS(3292),
    [anon_sym_type] = ACTIONS(3292),
    [anon_sym_fn] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_LT] = ACTIONS(3292),
    [anon_sym_GT] = ACTIONS(3292),
    [anon_sym_EQ_EQ] = ACTIONS(3292),
    [anon_sym_BANG_EQ] = ACTIONS(3292),
    [anon_sym_LT_EQ] = ACTIONS(3292),
    [anon_sym_GT_EQ] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3290),
    [anon_sym_struct] = ACTIONS(3292),
    [anon_sym_union] = ACTIONS(3292),
    [anon_sym_pub] = ACTIONS(3292),
    [anon_sym_mut] = ACTIONS(3292),
    [anon_sym_enum] = ACTIONS(3292),
    [anon_sym_interface] = ACTIONS(3292),
    [anon_sym_PLUS_PLUS] = ACTIONS(3292),
    [anon_sym_DASH_DASH] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3292),
    [anon_sym_BANG] = ACTIONS(3292),
    [anon_sym_go] = ACTIONS(3292),
    [anon_sym_spawn] = ACTIONS(3292),
    [anon_sym_json_DOTdecode] = ACTIONS(3292),
    [anon_sym_PIPE] = ACTIONS(3292),
    [anon_sym_LBRACK2] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3292),
    [anon_sym_CARET] = ACTIONS(3292),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LT_DASH] = ACTIONS(3292),
    [anon_sym_LT_LT] = ACTIONS(3292),
    [anon_sym_GT_GT] = ACTIONS(3292),
    [anon_sym_GT_GT_GT] = ACTIONS(3292),
    [anon_sym_AMP_CARET] = ACTIONS(3292),
    [anon_sym_AMP_AMP] = ACTIONS(3292),
    [anon_sym_PIPE_PIPE] = ACTIONS(3292),
    [anon_sym_or] = ACTIONS(3292),
    [sym_none] = ACTIONS(3292),
    [sym_true] = ACTIONS(3292),
    [sym_false] = ACTIONS(3292),
    [sym_nil] = ACTIONS(3292),
    [anon_sym_QMARK_DOT] = ACTIONS(3292),
    [anon_sym_POUND_LBRACK] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_DOLLARif] = ACTIONS(3292),
    [anon_sym_is] = ACTIONS(3292),
    [anon_sym_BANGis] = ACTIONS(3292),
    [anon_sym_in] = ACTIONS(3292),
    [anon_sym_BANGin] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_select] = ACTIONS(3292),
    [anon_sym_STAR_EQ] = ACTIONS(3292),
    [anon_sym_SLASH_EQ] = ACTIONS(3292),
    [anon_sym_PERCENT_EQ] = ACTIONS(3292),
    [anon_sym_LT_LT_EQ] = ACTIONS(3292),
    [anon_sym_GT_GT_EQ] = ACTIONS(3292),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3292),
    [anon_sym_AMP_EQ] = ACTIONS(3292),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3292),
    [anon_sym_PLUS_EQ] = ACTIONS(3292),
    [anon_sym_DASH_EQ] = ACTIONS(3292),
    [anon_sym_PIPE_EQ] = ACTIONS(3292),
    [anon_sym_CARET_EQ] = ACTIONS(3292),
    [anon_sym_COLON_EQ] = ACTIONS(3292),
    [anon_sym_lock] = ACTIONS(3292),
    [anon_sym_rlock] = ACTIONS(3292),
    [anon_sym_unsafe] = ACTIONS(3292),
    [anon_sym_sql] = ACTIONS(3292),
    [sym_int_literal] = ACTIONS(3292),
    [sym_float_literal] = ACTIONS(3292),
    [sym_rune_literal] = ACTIONS(3292),
    [anon_sym_SQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_c_SQUOTE] = ACTIONS(3292),
    [anon_sym_c_DQUOTE] = ACTIONS(3292),
    [anon_sym_r_SQUOTE] = ACTIONS(3292),
    [anon_sym_r_DQUOTE] = ACTIONS(3292),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3292),
    [anon_sym_shared] = ACTIONS(3292),
    [anon_sym_map_LBRACK] = ACTIONS(3292),
    [anon_sym_chan] = ACTIONS(3292),
    [anon_sym_thread] = ACTIONS(3292),
    [anon_sym_atomic] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_defer] = ACTIONS(3292),
    [anon_sym_goto] = ACTIONS(3292),
    [anon_sym_break] = ACTIONS(3292),
    [anon_sym_continue] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_DOLLARfor] = ACTIONS(3292),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_POUND] = ACTIONS(3292),
    [anon_sym_asm] = ACTIONS(3292),
    [anon_sym_AT_LBRACK] = ACTIONS(3292),
  },
  [511] = {
    [sym_line_comment] = STATE(511),
    [sym_block_comment] = STATE(511),
    [ts_builtin_sym_end] = ACTIONS(3294),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_LF] = ACTIONS(3296),
    [anon_sym_CR] = ACTIONS(3296),
    [anon_sym_CR_LF] = ACTIONS(3296),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3296),
    [anon_sym_as] = ACTIONS(3296),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3296),
    [anon_sym_const] = ACTIONS(3296),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3296),
    [anon_sym___global] = ACTIONS(3296),
    [anon_sym_type] = ACTIONS(3296),
    [anon_sym_fn] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_SLASH] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_LT] = ACTIONS(3296),
    [anon_sym_GT] = ACTIONS(3296),
    [anon_sym_EQ_EQ] = ACTIONS(3296),
    [anon_sym_BANG_EQ] = ACTIONS(3296),
    [anon_sym_LT_EQ] = ACTIONS(3296),
    [anon_sym_GT_EQ] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3294),
    [anon_sym_struct] = ACTIONS(3296),
    [anon_sym_union] = ACTIONS(3296),
    [anon_sym_pub] = ACTIONS(3296),
    [anon_sym_mut] = ACTIONS(3296),
    [anon_sym_enum] = ACTIONS(3296),
    [anon_sym_interface] = ACTIONS(3296),
    [anon_sym_PLUS_PLUS] = ACTIONS(3296),
    [anon_sym_DASH_DASH] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3296),
    [anon_sym_BANG] = ACTIONS(3296),
    [anon_sym_go] = ACTIONS(3296),
    [anon_sym_spawn] = ACTIONS(3296),
    [anon_sym_json_DOTdecode] = ACTIONS(3296),
    [anon_sym_PIPE] = ACTIONS(3296),
    [anon_sym_LBRACK2] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3296),
    [anon_sym_CARET] = ACTIONS(3296),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3296),
    [anon_sym_LT_LT] = ACTIONS(3296),
    [anon_sym_GT_GT] = ACTIONS(3296),
    [anon_sym_GT_GT_GT] = ACTIONS(3296),
    [anon_sym_AMP_CARET] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3296),
    [anon_sym_or] = ACTIONS(3296),
    [sym_none] = ACTIONS(3296),
    [sym_true] = ACTIONS(3296),
    [sym_false] = ACTIONS(3296),
    [sym_nil] = ACTIONS(3296),
    [anon_sym_QMARK_DOT] = ACTIONS(3296),
    [anon_sym_POUND_LBRACK] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_DOLLARif] = ACTIONS(3296),
    [anon_sym_is] = ACTIONS(3296),
    [anon_sym_BANGis] = ACTIONS(3296),
    [anon_sym_in] = ACTIONS(3296),
    [anon_sym_BANGin] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_select] = ACTIONS(3296),
    [anon_sym_STAR_EQ] = ACTIONS(3296),
    [anon_sym_SLASH_EQ] = ACTIONS(3296),
    [anon_sym_PERCENT_EQ] = ACTIONS(3296),
    [anon_sym_LT_LT_EQ] = ACTIONS(3296),
    [anon_sym_GT_GT_EQ] = ACTIONS(3296),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3296),
    [anon_sym_AMP_EQ] = ACTIONS(3296),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3296),
    [anon_sym_PLUS_EQ] = ACTIONS(3296),
    [anon_sym_DASH_EQ] = ACTIONS(3296),
    [anon_sym_PIPE_EQ] = ACTIONS(3296),
    [anon_sym_CARET_EQ] = ACTIONS(3296),
    [anon_sym_COLON_EQ] = ACTIONS(3296),
    [anon_sym_lock] = ACTIONS(3296),
    [anon_sym_rlock] = ACTIONS(3296),
    [anon_sym_unsafe] = ACTIONS(3296),
    [anon_sym_sql] = ACTIONS(3296),
    [sym_int_literal] = ACTIONS(3296),
    [sym_float_literal] = ACTIONS(3296),
    [sym_rune_literal] = ACTIONS(3296),
    [anon_sym_SQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_c_SQUOTE] = ACTIONS(3296),
    [anon_sym_c_DQUOTE] = ACTIONS(3296),
    [anon_sym_r_SQUOTE] = ACTIONS(3296),
    [anon_sym_r_DQUOTE] = ACTIONS(3296),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3296),
    [anon_sym_shared] = ACTIONS(3296),
    [anon_sym_map_LBRACK] = ACTIONS(3296),
    [anon_sym_chan] = ACTIONS(3296),
    [anon_sym_thread] = ACTIONS(3296),
    [anon_sym_atomic] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_defer] = ACTIONS(3296),
    [anon_sym_goto] = ACTIONS(3296),
    [anon_sym_break] = ACTIONS(3296),
    [anon_sym_continue] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_DOLLARfor] = ACTIONS(3296),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_POUND] = ACTIONS(3296),
    [anon_sym_asm] = ACTIONS(3296),
    [anon_sym_AT_LBRACK] = ACTIONS(3296),
  },
  [512] = {
    [sym_line_comment] = STATE(512),
    [sym_block_comment] = STATE(512),
    [ts_builtin_sym_end] = ACTIONS(3298),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_LF] = ACTIONS(3300),
    [anon_sym_CR] = ACTIONS(3300),
    [anon_sym_CR_LF] = ACTIONS(3300),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3300),
    [anon_sym_as] = ACTIONS(3300),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(3300),
    [anon_sym_const] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_EQ] = ACTIONS(3300),
    [anon_sym___global] = ACTIONS(3300),
    [anon_sym_type] = ACTIONS(3300),
    [anon_sym_fn] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_SLASH] = ACTIONS(3300),
    [anon_sym_PERCENT] = ACTIONS(3300),
    [anon_sym_LT] = ACTIONS(3300),
    [anon_sym_GT] = ACTIONS(3300),
    [anon_sym_EQ_EQ] = ACTIONS(3300),
    [anon_sym_BANG_EQ] = ACTIONS(3300),
    [anon_sym_LT_EQ] = ACTIONS(3300),
    [anon_sym_GT_EQ] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_struct] = ACTIONS(3300),
    [anon_sym_union] = ACTIONS(3300),
    [anon_sym_pub] = ACTIONS(3300),
    [anon_sym_mut] = ACTIONS(3300),
    [anon_sym_enum] = ACTIONS(3300),
    [anon_sym_interface] = ACTIONS(3300),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_go] = ACTIONS(3300),
    [anon_sym_spawn] = ACTIONS(3300),
    [anon_sym_json_DOTdecode] = ACTIONS(3300),
    [anon_sym_PIPE] = ACTIONS(3300),
    [anon_sym_LBRACK2] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [anon_sym_CARET] = ACTIONS(3300),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LT_DASH] = ACTIONS(3300),
    [anon_sym_LT_LT] = ACTIONS(3300),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3300),
    [anon_sym_AMP_CARET] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_PIPE_PIPE] = ACTIONS(3300),
    [anon_sym_or] = ACTIONS(3300),
    [sym_none] = ACTIONS(3300),
    [sym_true] = ACTIONS(3300),
    [sym_false] = ACTIONS(3300),
    [sym_nil] = ACTIONS(3300),
    [anon_sym_QMARK_DOT] = ACTIONS(3300),
    [anon_sym_POUND_LBRACK] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_DOLLARif] = ACTIONS(3300),
    [anon_sym_is] = ACTIONS(3300),
    [anon_sym_BANGis] = ACTIONS(3300),
    [anon_sym_in] = ACTIONS(3300),
    [anon_sym_BANGin] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_select] = ACTIONS(3300),
    [anon_sym_STAR_EQ] = ACTIONS(3300),
    [anon_sym_SLASH_EQ] = ACTIONS(3300),
    [anon_sym_PERCENT_EQ] = ACTIONS(3300),
    [anon_sym_LT_LT_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_AMP_EQ] = ACTIONS(3300),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3300),
    [anon_sym_PLUS_EQ] = ACTIONS(3300),
    [anon_sym_DASH_EQ] = ACTIONS(3300),
    [anon_sym_PIPE_EQ] = ACTIONS(3300),
    [anon_sym_CARET_EQ] = ACTIONS(3300),
    [anon_sym_COLON_EQ] = ACTIONS(3300),
    [anon_sym_lock] = ACTIONS(3300),
    [anon_sym_rlock] = ACTIONS(3300),
    [anon_sym_unsafe] = ACTIONS(3300),
    [anon_sym_sql] = ACTIONS(3300),
    [sym_int_literal] = ACTIONS(3300),
    [sym_float_literal] = ACTIONS(3300),
    [sym_rune_literal] = ACTIONS(3300),
    [anon_sym_SQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_c_SQUOTE] = ACTIONS(3300),
    [anon_sym_c_DQUOTE] = ACTIONS(3300),
    [anon_sym_r_SQUOTE] = ACTIONS(3300),
    [anon_sym_r_DQUOTE] = ACTIONS(3300),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3300),
    [anon_sym_shared] = ACTIONS(3300),
    [anon_sym_map_LBRACK] = ACTIONS(3300),
    [anon_sym_chan] = ACTIONS(3300),
    [anon_sym_thread] = ACTIONS(3300),
    [anon_sym_atomic] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_defer] = ACTIONS(3300),
    [anon_sym_goto] = ACTIONS(3300),
    [anon_sym_break] = ACTIONS(3300),
    [anon_sym_continue] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_DOLLARfor] = ACTIONS(3300),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_POUND] = ACTIONS(3300),
    [anon_sym_asm] = ACTIONS(3300),
    [anon_sym_AT_LBRACK] = ACTIONS(3300),
  },
  [513] = {
    [sym_line_comment] = STATE(513),
    [sym_block_comment] = STATE(513),
    [ts_builtin_sym_end] = ACTIONS(3302),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_LF] = ACTIONS(3304),
    [anon_sym_CR] = ACTIONS(3304),
    [anon_sym_CR_LF] = ACTIONS(3304),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_as] = ACTIONS(3304),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_COMMA] = ACTIONS(3304),
    [anon_sym_const] = ACTIONS(3304),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_EQ] = ACTIONS(3304),
    [anon_sym___global] = ACTIONS(3304),
    [anon_sym_type] = ACTIONS(3304),
    [anon_sym_fn] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [anon_sym_LT] = ACTIONS(3304),
    [anon_sym_GT] = ACTIONS(3304),
    [anon_sym_EQ_EQ] = ACTIONS(3304),
    [anon_sym_BANG_EQ] = ACTIONS(3304),
    [anon_sym_LT_EQ] = ACTIONS(3304),
    [anon_sym_GT_EQ] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3302),
    [anon_sym_struct] = ACTIONS(3304),
    [anon_sym_union] = ACTIONS(3304),
    [anon_sym_pub] = ACTIONS(3304),
    [anon_sym_mut] = ACTIONS(3304),
    [anon_sym_enum] = ACTIONS(3304),
    [anon_sym_interface] = ACTIONS(3304),
    [anon_sym_PLUS_PLUS] = ACTIONS(3304),
    [anon_sym_DASH_DASH] = ACTIONS(3304),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_go] = ACTIONS(3304),
    [anon_sym_spawn] = ACTIONS(3304),
    [anon_sym_json_DOTdecode] = ACTIONS(3304),
    [anon_sym_PIPE] = ACTIONS(3304),
    [anon_sym_LBRACK2] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LT_DASH] = ACTIONS(3304),
    [anon_sym_LT_LT] = ACTIONS(3304),
    [anon_sym_GT_GT] = ACTIONS(3304),
    [anon_sym_GT_GT_GT] = ACTIONS(3304),
    [anon_sym_AMP_CARET] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_PIPE_PIPE] = ACTIONS(3304),
    [anon_sym_or] = ACTIONS(3304),
    [sym_none] = ACTIONS(3304),
    [sym_true] = ACTIONS(3304),
    [sym_false] = ACTIONS(3304),
    [sym_nil] = ACTIONS(3304),
    [anon_sym_QMARK_DOT] = ACTIONS(3304),
    [anon_sym_POUND_LBRACK] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_DOLLARif] = ACTIONS(3304),
    [anon_sym_is] = ACTIONS(3304),
    [anon_sym_BANGis] = ACTIONS(3304),
    [anon_sym_in] = ACTIONS(3304),
    [anon_sym_BANGin] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_select] = ACTIONS(3304),
    [anon_sym_STAR_EQ] = ACTIONS(3304),
    [anon_sym_SLASH_EQ] = ACTIONS(3304),
    [anon_sym_PERCENT_EQ] = ACTIONS(3304),
    [anon_sym_LT_LT_EQ] = ACTIONS(3304),
    [anon_sym_GT_GT_EQ] = ACTIONS(3304),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3304),
    [anon_sym_AMP_EQ] = ACTIONS(3304),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3304),
    [anon_sym_PLUS_EQ] = ACTIONS(3304),
    [anon_sym_DASH_EQ] = ACTIONS(3304),
    [anon_sym_PIPE_EQ] = ACTIONS(3304),
    [anon_sym_CARET_EQ] = ACTIONS(3304),
    [anon_sym_COLON_EQ] = ACTIONS(3304),
    [anon_sym_lock] = ACTIONS(3304),
    [anon_sym_rlock] = ACTIONS(3304),
    [anon_sym_unsafe] = ACTIONS(3304),
    [anon_sym_sql] = ACTIONS(3304),
    [sym_int_literal] = ACTIONS(3304),
    [sym_float_literal] = ACTIONS(3304),
    [sym_rune_literal] = ACTIONS(3304),
    [anon_sym_SQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_c_SQUOTE] = ACTIONS(3304),
    [anon_sym_c_DQUOTE] = ACTIONS(3304),
    [anon_sym_r_SQUOTE] = ACTIONS(3304),
    [anon_sym_r_DQUOTE] = ACTIONS(3304),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3304),
    [anon_sym_shared] = ACTIONS(3304),
    [anon_sym_map_LBRACK] = ACTIONS(3304),
    [anon_sym_chan] = ACTIONS(3304),
    [anon_sym_thread] = ACTIONS(3304),
    [anon_sym_atomic] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_defer] = ACTIONS(3304),
    [anon_sym_goto] = ACTIONS(3304),
    [anon_sym_break] = ACTIONS(3304),
    [anon_sym_continue] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_DOLLARfor] = ACTIONS(3304),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_POUND] = ACTIONS(3304),
    [anon_sym_asm] = ACTIONS(3304),
    [anon_sym_AT_LBRACK] = ACTIONS(3304),
  },
  [514] = {
    [sym_line_comment] = STATE(514),
    [sym_block_comment] = STATE(514),
    [ts_builtin_sym_end] = ACTIONS(3306),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_LF] = ACTIONS(3308),
    [anon_sym_CR] = ACTIONS(3308),
    [anon_sym_CR_LF] = ACTIONS(3308),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_as] = ACTIONS(3308),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_COMMA] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3308),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_EQ] = ACTIONS(3308),
    [anon_sym___global] = ACTIONS(3308),
    [anon_sym_type] = ACTIONS(3308),
    [anon_sym_fn] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_SLASH] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_EQ_EQ] = ACTIONS(3308),
    [anon_sym_BANG_EQ] = ACTIONS(3308),
    [anon_sym_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT_EQ] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_struct] = ACTIONS(3308),
    [anon_sym_union] = ACTIONS(3308),
    [anon_sym_pub] = ACTIONS(3308),
    [anon_sym_mut] = ACTIONS(3308),
    [anon_sym_enum] = ACTIONS(3308),
    [anon_sym_interface] = ACTIONS(3308),
    [anon_sym_PLUS_PLUS] = ACTIONS(3308),
    [anon_sym_DASH_DASH] = ACTIONS(3308),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_BANG] = ACTIONS(3308),
    [anon_sym_go] = ACTIONS(3308),
    [anon_sym_spawn] = ACTIONS(3308),
    [anon_sym_json_DOTdecode] = ACTIONS(3308),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_LBRACK2] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3308),
    [anon_sym_CARET] = ACTIONS(3308),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LT_DASH] = ACTIONS(3308),
    [anon_sym_LT_LT] = ACTIONS(3308),
    [anon_sym_GT_GT] = ACTIONS(3308),
    [anon_sym_GT_GT_GT] = ACTIONS(3308),
    [anon_sym_AMP_CARET] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(3308),
    [anon_sym_PIPE_PIPE] = ACTIONS(3308),
    [anon_sym_or] = ACTIONS(3308),
    [sym_none] = ACTIONS(3308),
    [sym_true] = ACTIONS(3308),
    [sym_false] = ACTIONS(3308),
    [sym_nil] = ACTIONS(3308),
    [anon_sym_QMARK_DOT] = ACTIONS(3308),
    [anon_sym_POUND_LBRACK] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_DOLLARif] = ACTIONS(3308),
    [anon_sym_is] = ACTIONS(3308),
    [anon_sym_BANGis] = ACTIONS(3308),
    [anon_sym_in] = ACTIONS(3308),
    [anon_sym_BANGin] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_select] = ACTIONS(3308),
    [anon_sym_STAR_EQ] = ACTIONS(3308),
    [anon_sym_SLASH_EQ] = ACTIONS(3308),
    [anon_sym_PERCENT_EQ] = ACTIONS(3308),
    [anon_sym_LT_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT_GT_EQ] = ACTIONS(3308),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3308),
    [anon_sym_AMP_EQ] = ACTIONS(3308),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3308),
    [anon_sym_PLUS_EQ] = ACTIONS(3308),
    [anon_sym_DASH_EQ] = ACTIONS(3308),
    [anon_sym_PIPE_EQ] = ACTIONS(3308),
    [anon_sym_CARET_EQ] = ACTIONS(3308),
    [anon_sym_COLON_EQ] = ACTIONS(3308),
    [anon_sym_lock] = ACTIONS(3308),
    [anon_sym_rlock] = ACTIONS(3308),
    [anon_sym_unsafe] = ACTIONS(3308),
    [anon_sym_sql] = ACTIONS(3308),
    [sym_int_literal] = ACTIONS(3308),
    [sym_float_literal] = ACTIONS(3308),
    [sym_rune_literal] = ACTIONS(3308),
    [anon_sym_SQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_c_SQUOTE] = ACTIONS(3308),
    [anon_sym_c_DQUOTE] = ACTIONS(3308),
    [anon_sym_r_SQUOTE] = ACTIONS(3308),
    [anon_sym_r_DQUOTE] = ACTIONS(3308),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3308),
    [anon_sym_shared] = ACTIONS(3308),
    [anon_sym_map_LBRACK] = ACTIONS(3308),
    [anon_sym_chan] = ACTIONS(3308),
    [anon_sym_thread] = ACTIONS(3308),
    [anon_sym_atomic] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_defer] = ACTIONS(3308),
    [anon_sym_goto] = ACTIONS(3308),
    [anon_sym_break] = ACTIONS(3308),
    [anon_sym_continue] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_DOLLARfor] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_POUND] = ACTIONS(3308),
    [anon_sym_asm] = ACTIONS(3308),
    [anon_sym_AT_LBRACK] = ACTIONS(3308),
  },
  [515] = {
    [sym_line_comment] = STATE(515),
    [sym_block_comment] = STATE(515),
    [ts_builtin_sym_end] = ACTIONS(3310),
    [sym_identifier] = ACTIONS(3312),
    [anon_sym_LF] = ACTIONS(3312),
    [anon_sym_CR] = ACTIONS(3312),
    [anon_sym_CR_LF] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3312),
    [anon_sym_as] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_const] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3312),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym___global] = ACTIONS(3312),
    [anon_sym_type] = ACTIONS(3312),
    [anon_sym_fn] = ACTIONS(3312),
    [anon_sym_PLUS] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_SLASH] = ACTIONS(3312),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_GT] = ACTIONS(3312),
    [anon_sym_EQ_EQ] = ACTIONS(3312),
    [anon_sym_BANG_EQ] = ACTIONS(3312),
    [anon_sym_LT_EQ] = ACTIONS(3312),
    [anon_sym_GT_EQ] = ACTIONS(3312),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_struct] = ACTIONS(3312),
    [anon_sym_union] = ACTIONS(3312),
    [anon_sym_pub] = ACTIONS(3312),
    [anon_sym_mut] = ACTIONS(3312),
    [anon_sym_enum] = ACTIONS(3312),
    [anon_sym_interface] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3312),
    [anon_sym_DASH_DASH] = ACTIONS(3312),
    [anon_sym_QMARK] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_go] = ACTIONS(3312),
    [anon_sym_spawn] = ACTIONS(3312),
    [anon_sym_json_DOTdecode] = ACTIONS(3312),
    [anon_sym_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACK2] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_CARET] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3312),
    [anon_sym_LT_DASH] = ACTIONS(3312),
    [anon_sym_LT_LT] = ACTIONS(3312),
    [anon_sym_GT_GT] = ACTIONS(3312),
    [anon_sym_GT_GT_GT] = ACTIONS(3312),
    [anon_sym_AMP_CARET] = ACTIONS(3312),
    [anon_sym_AMP_AMP] = ACTIONS(3312),
    [anon_sym_PIPE_PIPE] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3312),
    [sym_none] = ACTIONS(3312),
    [sym_true] = ACTIONS(3312),
    [sym_false] = ACTIONS(3312),
    [sym_nil] = ACTIONS(3312),
    [anon_sym_QMARK_DOT] = ACTIONS(3312),
    [anon_sym_POUND_LBRACK] = ACTIONS(3312),
    [anon_sym_if] = ACTIONS(3312),
    [anon_sym_DOLLARif] = ACTIONS(3312),
    [anon_sym_is] = ACTIONS(3312),
    [anon_sym_BANGis] = ACTIONS(3312),
    [anon_sym_in] = ACTIONS(3312),
    [anon_sym_BANGin] = ACTIONS(3312),
    [anon_sym_match] = ACTIONS(3312),
    [anon_sym_select] = ACTIONS(3312),
    [anon_sym_STAR_EQ] = ACTIONS(3312),
    [anon_sym_SLASH_EQ] = ACTIONS(3312),
    [anon_sym_PERCENT_EQ] = ACTIONS(3312),
    [anon_sym_LT_LT_EQ] = ACTIONS(3312),
    [anon_sym_GT_GT_EQ] = ACTIONS(3312),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3312),
    [anon_sym_AMP_EQ] = ACTIONS(3312),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3312),
    [anon_sym_PLUS_EQ] = ACTIONS(3312),
    [anon_sym_DASH_EQ] = ACTIONS(3312),
    [anon_sym_PIPE_EQ] = ACTIONS(3312),
    [anon_sym_CARET_EQ] = ACTIONS(3312),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_lock] = ACTIONS(3312),
    [anon_sym_rlock] = ACTIONS(3312),
    [anon_sym_unsafe] = ACTIONS(3312),
    [anon_sym_sql] = ACTIONS(3312),
    [sym_int_literal] = ACTIONS(3312),
    [sym_float_literal] = ACTIONS(3312),
    [sym_rune_literal] = ACTIONS(3312),
    [anon_sym_SQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3312),
    [anon_sym_c_SQUOTE] = ACTIONS(3312),
    [anon_sym_c_DQUOTE] = ACTIONS(3312),
    [anon_sym_r_SQUOTE] = ACTIONS(3312),
    [anon_sym_r_DQUOTE] = ACTIONS(3312),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3312),
    [anon_sym_shared] = ACTIONS(3312),
    [anon_sym_map_LBRACK] = ACTIONS(3312),
    [anon_sym_chan] = ACTIONS(3312),
    [anon_sym_thread] = ACTIONS(3312),
    [anon_sym_atomic] = ACTIONS(3312),
    [anon_sym_assert] = ACTIONS(3312),
    [anon_sym_defer] = ACTIONS(3312),
    [anon_sym_goto] = ACTIONS(3312),
    [anon_sym_break] = ACTIONS(3312),
    [anon_sym_continue] = ACTIONS(3312),
    [anon_sym_return] = ACTIONS(3312),
    [anon_sym_DOLLARfor] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3312),
    [anon_sym_POUND] = ACTIONS(3312),
    [anon_sym_asm] = ACTIONS(3312),
    [anon_sym_AT_LBRACK] = ACTIONS(3312),
  },
  [516] = {
    [sym_line_comment] = STATE(516),
    [sym_block_comment] = STATE(516),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1693),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1692),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(527),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(3314),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1615),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [517] = {
    [sym_line_comment] = STATE(517),
    [sym_block_comment] = STATE(517),
    [ts_builtin_sym_end] = ACTIONS(3316),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LF] = ACTIONS(3318),
    [anon_sym_CR] = ACTIONS(3318),
    [anon_sym_CR_LF] = ACTIONS(3318),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_as] = ACTIONS(3318),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3318),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_EQ] = ACTIONS(3318),
    [anon_sym___global] = ACTIONS(3318),
    [anon_sym_type] = ACTIONS(3318),
    [anon_sym_fn] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_SLASH] = ACTIONS(3318),
    [anon_sym_PERCENT] = ACTIONS(3318),
    [anon_sym_LT] = ACTIONS(3318),
    [anon_sym_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_LT_EQ] = ACTIONS(3318),
    [anon_sym_GT_EQ] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3316),
    [anon_sym_struct] = ACTIONS(3318),
    [anon_sym_union] = ACTIONS(3318),
    [anon_sym_pub] = ACTIONS(3318),
    [anon_sym_mut] = ACTIONS(3318),
    [anon_sym_enum] = ACTIONS(3318),
    [anon_sym_interface] = ACTIONS(3318),
    [anon_sym_PLUS_PLUS] = ACTIONS(3318),
    [anon_sym_DASH_DASH] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_BANG] = ACTIONS(3318),
    [anon_sym_go] = ACTIONS(3318),
    [anon_sym_spawn] = ACTIONS(3318),
    [anon_sym_json_DOTdecode] = ACTIONS(3318),
    [anon_sym_PIPE] = ACTIONS(3318),
    [anon_sym_LBRACK2] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3318),
    [anon_sym_CARET] = ACTIONS(3318),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LT_DASH] = ACTIONS(3318),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_GT_GT_GT] = ACTIONS(3318),
    [anon_sym_AMP_CARET] = ACTIONS(3318),
    [anon_sym_AMP_AMP] = ACTIONS(3318),
    [anon_sym_PIPE_PIPE] = ACTIONS(3318),
    [anon_sym_or] = ACTIONS(3318),
    [sym_none] = ACTIONS(3318),
    [sym_true] = ACTIONS(3318),
    [sym_false] = ACTIONS(3318),
    [sym_nil] = ACTIONS(3318),
    [anon_sym_QMARK_DOT] = ACTIONS(3318),
    [anon_sym_POUND_LBRACK] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_DOLLARif] = ACTIONS(3318),
    [anon_sym_is] = ACTIONS(3318),
    [anon_sym_BANGis] = ACTIONS(3318),
    [anon_sym_in] = ACTIONS(3318),
    [anon_sym_BANGin] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_select] = ACTIONS(3318),
    [anon_sym_STAR_EQ] = ACTIONS(3318),
    [anon_sym_SLASH_EQ] = ACTIONS(3318),
    [anon_sym_PERCENT_EQ] = ACTIONS(3318),
    [anon_sym_LT_LT_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_AMP_EQ] = ACTIONS(3318),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3318),
    [anon_sym_PLUS_EQ] = ACTIONS(3318),
    [anon_sym_DASH_EQ] = ACTIONS(3318),
    [anon_sym_PIPE_EQ] = ACTIONS(3318),
    [anon_sym_CARET_EQ] = ACTIONS(3318),
    [anon_sym_COLON_EQ] = ACTIONS(3318),
    [anon_sym_lock] = ACTIONS(3318),
    [anon_sym_rlock] = ACTIONS(3318),
    [anon_sym_unsafe] = ACTIONS(3318),
    [anon_sym_sql] = ACTIONS(3318),
    [sym_int_literal] = ACTIONS(3318),
    [sym_float_literal] = ACTIONS(3318),
    [sym_rune_literal] = ACTIONS(3318),
    [anon_sym_SQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_c_SQUOTE] = ACTIONS(3318),
    [anon_sym_c_DQUOTE] = ACTIONS(3318),
    [anon_sym_r_SQUOTE] = ACTIONS(3318),
    [anon_sym_r_DQUOTE] = ACTIONS(3318),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3318),
    [anon_sym_shared] = ACTIONS(3318),
    [anon_sym_map_LBRACK] = ACTIONS(3318),
    [anon_sym_chan] = ACTIONS(3318),
    [anon_sym_thread] = ACTIONS(3318),
    [anon_sym_atomic] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_defer] = ACTIONS(3318),
    [anon_sym_goto] = ACTIONS(3318),
    [anon_sym_break] = ACTIONS(3318),
    [anon_sym_continue] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_DOLLARfor] = ACTIONS(3318),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_POUND] = ACTIONS(3318),
    [anon_sym_asm] = ACTIONS(3318),
    [anon_sym_AT_LBRACK] = ACTIONS(3318),
  },
  [518] = {
    [sym_line_comment] = STATE(518),
    [sym_block_comment] = STATE(518),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1693),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1692),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(498),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(3320),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1615),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [519] = {
    [sym_line_comment] = STATE(519),
    [sym_block_comment] = STATE(519),
    [ts_builtin_sym_end] = ACTIONS(3322),
    [sym_identifier] = ACTIONS(3324),
    [anon_sym_LF] = ACTIONS(3324),
    [anon_sym_CR] = ACTIONS(3324),
    [anon_sym_CR_LF] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3324),
    [anon_sym_as] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3324),
    [anon_sym_COMMA] = ACTIONS(3324),
    [anon_sym_const] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3324),
    [anon_sym_EQ] = ACTIONS(3324),
    [anon_sym___global] = ACTIONS(3324),
    [anon_sym_type] = ACTIONS(3324),
    [anon_sym_fn] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3324),
    [anon_sym_DASH] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3324),
    [anon_sym_SLASH] = ACTIONS(3324),
    [anon_sym_PERCENT] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_GT] = ACTIONS(3324),
    [anon_sym_EQ_EQ] = ACTIONS(3324),
    [anon_sym_BANG_EQ] = ACTIONS(3324),
    [anon_sym_LT_EQ] = ACTIONS(3324),
    [anon_sym_GT_EQ] = ACTIONS(3324),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_struct] = ACTIONS(3324),
    [anon_sym_union] = ACTIONS(3324),
    [anon_sym_pub] = ACTIONS(3324),
    [anon_sym_mut] = ACTIONS(3324),
    [anon_sym_enum] = ACTIONS(3324),
    [anon_sym_interface] = ACTIONS(3324),
    [anon_sym_PLUS_PLUS] = ACTIONS(3324),
    [anon_sym_DASH_DASH] = ACTIONS(3324),
    [anon_sym_QMARK] = ACTIONS(3324),
    [anon_sym_BANG] = ACTIONS(3324),
    [anon_sym_go] = ACTIONS(3324),
    [anon_sym_spawn] = ACTIONS(3324),
    [anon_sym_json_DOTdecode] = ACTIONS(3324),
    [anon_sym_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACK2] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3324),
    [anon_sym_LT_DASH] = ACTIONS(3324),
    [anon_sym_LT_LT] = ACTIONS(3324),
    [anon_sym_GT_GT] = ACTIONS(3324),
    [anon_sym_GT_GT_GT] = ACTIONS(3324),
    [anon_sym_AMP_CARET] = ACTIONS(3324),
    [anon_sym_AMP_AMP] = ACTIONS(3324),
    [anon_sym_PIPE_PIPE] = ACTIONS(3324),
    [anon_sym_or] = ACTIONS(3324),
    [sym_none] = ACTIONS(3324),
    [sym_true] = ACTIONS(3324),
    [sym_false] = ACTIONS(3324),
    [sym_nil] = ACTIONS(3324),
    [anon_sym_QMARK_DOT] = ACTIONS(3324),
    [anon_sym_POUND_LBRACK] = ACTIONS(3324),
    [anon_sym_if] = ACTIONS(3324),
    [anon_sym_DOLLARif] = ACTIONS(3324),
    [anon_sym_is] = ACTIONS(3324),
    [anon_sym_BANGis] = ACTIONS(3324),
    [anon_sym_in] = ACTIONS(3324),
    [anon_sym_BANGin] = ACTIONS(3324),
    [anon_sym_match] = ACTIONS(3324),
    [anon_sym_select] = ACTIONS(3324),
    [anon_sym_STAR_EQ] = ACTIONS(3324),
    [anon_sym_SLASH_EQ] = ACTIONS(3324),
    [anon_sym_PERCENT_EQ] = ACTIONS(3324),
    [anon_sym_LT_LT_EQ] = ACTIONS(3324),
    [anon_sym_GT_GT_EQ] = ACTIONS(3324),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3324),
    [anon_sym_AMP_EQ] = ACTIONS(3324),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3324),
    [anon_sym_PLUS_EQ] = ACTIONS(3324),
    [anon_sym_DASH_EQ] = ACTIONS(3324),
    [anon_sym_PIPE_EQ] = ACTIONS(3324),
    [anon_sym_CARET_EQ] = ACTIONS(3324),
    [anon_sym_COLON_EQ] = ACTIONS(3324),
    [anon_sym_lock] = ACTIONS(3324),
    [anon_sym_rlock] = ACTIONS(3324),
    [anon_sym_unsafe] = ACTIONS(3324),
    [anon_sym_sql] = ACTIONS(3324),
    [sym_int_literal] = ACTIONS(3324),
    [sym_float_literal] = ACTIONS(3324),
    [sym_rune_literal] = ACTIONS(3324),
    [anon_sym_SQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE] = ACTIONS(3324),
    [anon_sym_c_SQUOTE] = ACTIONS(3324),
    [anon_sym_c_DQUOTE] = ACTIONS(3324),
    [anon_sym_r_SQUOTE] = ACTIONS(3324),
    [anon_sym_r_DQUOTE] = ACTIONS(3324),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3324),
    [anon_sym_shared] = ACTIONS(3324),
    [anon_sym_map_LBRACK] = ACTIONS(3324),
    [anon_sym_chan] = ACTIONS(3324),
    [anon_sym_thread] = ACTIONS(3324),
    [anon_sym_atomic] = ACTIONS(3324),
    [anon_sym_assert] = ACTIONS(3324),
    [anon_sym_defer] = ACTIONS(3324),
    [anon_sym_goto] = ACTIONS(3324),
    [anon_sym_break] = ACTIONS(3324),
    [anon_sym_continue] = ACTIONS(3324),
    [anon_sym_return] = ACTIONS(3324),
    [anon_sym_DOLLARfor] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3324),
    [anon_sym_POUND] = ACTIONS(3324),
    [anon_sym_asm] = ACTIONS(3324),
    [anon_sym_AT_LBRACK] = ACTIONS(3324),
  },
  [520] = {
    [sym_line_comment] = STATE(520),
    [sym_block_comment] = STATE(520),
    [ts_builtin_sym_end] = ACTIONS(3326),
    [sym_identifier] = ACTIONS(3328),
    [anon_sym_LF] = ACTIONS(3328),
    [anon_sym_CR] = ACTIONS(3328),
    [anon_sym_CR_LF] = ACTIONS(3328),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3328),
    [anon_sym_as] = ACTIONS(3328),
    [anon_sym_LBRACE] = ACTIONS(3328),
    [anon_sym_COMMA] = ACTIONS(3328),
    [anon_sym_const] = ACTIONS(3328),
    [anon_sym_LPAREN] = ACTIONS(3328),
    [anon_sym_EQ] = ACTIONS(3328),
    [anon_sym___global] = ACTIONS(3328),
    [anon_sym_type] = ACTIONS(3328),
    [anon_sym_fn] = ACTIONS(3328),
    [anon_sym_PLUS] = ACTIONS(3328),
    [anon_sym_DASH] = ACTIONS(3328),
    [anon_sym_STAR] = ACTIONS(3328),
    [anon_sym_SLASH] = ACTIONS(3328),
    [anon_sym_PERCENT] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(3328),
    [anon_sym_GT] = ACTIONS(3328),
    [anon_sym_EQ_EQ] = ACTIONS(3328),
    [anon_sym_BANG_EQ] = ACTIONS(3328),
    [anon_sym_LT_EQ] = ACTIONS(3328),
    [anon_sym_GT_EQ] = ACTIONS(3328),
    [anon_sym_LBRACK] = ACTIONS(3326),
    [anon_sym_struct] = ACTIONS(3328),
    [anon_sym_union] = ACTIONS(3328),
    [anon_sym_pub] = ACTIONS(3328),
    [anon_sym_mut] = ACTIONS(3328),
    [anon_sym_enum] = ACTIONS(3328),
    [anon_sym_interface] = ACTIONS(3328),
    [anon_sym_PLUS_PLUS] = ACTIONS(3328),
    [anon_sym_DASH_DASH] = ACTIONS(3328),
    [anon_sym_QMARK] = ACTIONS(3328),
    [anon_sym_BANG] = ACTIONS(3328),
    [anon_sym_go] = ACTIONS(3328),
    [anon_sym_spawn] = ACTIONS(3328),
    [anon_sym_json_DOTdecode] = ACTIONS(3328),
    [anon_sym_PIPE] = ACTIONS(3328),
    [anon_sym_LBRACK2] = ACTIONS(3328),
    [anon_sym_TILDE] = ACTIONS(3328),
    [anon_sym_CARET] = ACTIONS(3328),
    [anon_sym_AMP] = ACTIONS(3328),
    [anon_sym_LT_DASH] = ACTIONS(3328),
    [anon_sym_LT_LT] = ACTIONS(3328),
    [anon_sym_GT_GT] = ACTIONS(3328),
    [anon_sym_GT_GT_GT] = ACTIONS(3328),
    [anon_sym_AMP_CARET] = ACTIONS(3328),
    [anon_sym_AMP_AMP] = ACTIONS(3328),
    [anon_sym_PIPE_PIPE] = ACTIONS(3328),
    [anon_sym_or] = ACTIONS(3328),
    [sym_none] = ACTIONS(3328),
    [sym_true] = ACTIONS(3328),
    [sym_false] = ACTIONS(3328),
    [sym_nil] = ACTIONS(3328),
    [anon_sym_QMARK_DOT] = ACTIONS(3328),
    [anon_sym_POUND_LBRACK] = ACTIONS(3328),
    [anon_sym_if] = ACTIONS(3328),
    [anon_sym_DOLLARif] = ACTIONS(3328),
    [anon_sym_is] = ACTIONS(3328),
    [anon_sym_BANGis] = ACTIONS(3328),
    [anon_sym_in] = ACTIONS(3328),
    [anon_sym_BANGin] = ACTIONS(3328),
    [anon_sym_match] = ACTIONS(3328),
    [anon_sym_select] = ACTIONS(3328),
    [anon_sym_STAR_EQ] = ACTIONS(3328),
    [anon_sym_SLASH_EQ] = ACTIONS(3328),
    [anon_sym_PERCENT_EQ] = ACTIONS(3328),
    [anon_sym_LT_LT_EQ] = ACTIONS(3328),
    [anon_sym_GT_GT_EQ] = ACTIONS(3328),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3328),
    [anon_sym_AMP_EQ] = ACTIONS(3328),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3328),
    [anon_sym_PLUS_EQ] = ACTIONS(3328),
    [anon_sym_DASH_EQ] = ACTIONS(3328),
    [anon_sym_PIPE_EQ] = ACTIONS(3328),
    [anon_sym_CARET_EQ] = ACTIONS(3328),
    [anon_sym_COLON_EQ] = ACTIONS(3328),
    [anon_sym_lock] = ACTIONS(3328),
    [anon_sym_rlock] = ACTIONS(3328),
    [anon_sym_unsafe] = ACTIONS(3328),
    [anon_sym_sql] = ACTIONS(3328),
    [sym_int_literal] = ACTIONS(3328),
    [sym_float_literal] = ACTIONS(3328),
    [sym_rune_literal] = ACTIONS(3328),
    [anon_sym_SQUOTE] = ACTIONS(3328),
    [anon_sym_DQUOTE] = ACTIONS(3328),
    [anon_sym_c_SQUOTE] = ACTIONS(3328),
    [anon_sym_c_DQUOTE] = ACTIONS(3328),
    [anon_sym_r_SQUOTE] = ACTIONS(3328),
    [anon_sym_r_DQUOTE] = ACTIONS(3328),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3328),
    [anon_sym_shared] = ACTIONS(3328),
    [anon_sym_map_LBRACK] = ACTIONS(3328),
    [anon_sym_chan] = ACTIONS(3328),
    [anon_sym_thread] = ACTIONS(3328),
    [anon_sym_atomic] = ACTIONS(3328),
    [anon_sym_assert] = ACTIONS(3328),
    [anon_sym_defer] = ACTIONS(3328),
    [anon_sym_goto] = ACTIONS(3328),
    [anon_sym_break] = ACTIONS(3328),
    [anon_sym_continue] = ACTIONS(3328),
    [anon_sym_return] = ACTIONS(3328),
    [anon_sym_DOLLARfor] = ACTIONS(3328),
    [anon_sym_for] = ACTIONS(3328),
    [anon_sym_POUND] = ACTIONS(3328),
    [anon_sym_asm] = ACTIONS(3328),
    [anon_sym_AT_LBRACK] = ACTIONS(3328),
  },
  [521] = {
    [sym_line_comment] = STATE(521),
    [sym_block_comment] = STATE(521),
    [sym__expression] = STATE(2565),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(624),
    [sym_mutable_expression] = STATE(4083),
    [sym_expression_list] = STATE(4205),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_go] = ACTIONS(2681),
    [anon_sym_spawn] = ACTIONS(2683),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_CARET] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2691),
    [anon_sym_lock] = ACTIONS(2693),
    [anon_sym_rlock] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [522] = {
    [sym_line_comment] = STATE(522),
    [sym_block_comment] = STATE(522),
    [ts_builtin_sym_end] = ACTIONS(3330),
    [sym_identifier] = ACTIONS(3332),
    [anon_sym_LF] = ACTIONS(3332),
    [anon_sym_CR] = ACTIONS(3332),
    [anon_sym_CR_LF] = ACTIONS(3332),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3332),
    [anon_sym_as] = ACTIONS(3332),
    [anon_sym_LBRACE] = ACTIONS(3332),
    [anon_sym_COMMA] = ACTIONS(3332),
    [anon_sym_const] = ACTIONS(3332),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_EQ] = ACTIONS(3332),
    [anon_sym___global] = ACTIONS(3332),
    [anon_sym_type] = ACTIONS(3332),
    [anon_sym_fn] = ACTIONS(3332),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_DASH] = ACTIONS(3332),
    [anon_sym_STAR] = ACTIONS(3332),
    [anon_sym_SLASH] = ACTIONS(3332),
    [anon_sym_PERCENT] = ACTIONS(3332),
    [anon_sym_LT] = ACTIONS(3332),
    [anon_sym_GT] = ACTIONS(3332),
    [anon_sym_EQ_EQ] = ACTIONS(3332),
    [anon_sym_BANG_EQ] = ACTIONS(3332),
    [anon_sym_LT_EQ] = ACTIONS(3332),
    [anon_sym_GT_EQ] = ACTIONS(3332),
    [anon_sym_LBRACK] = ACTIONS(3330),
    [anon_sym_struct] = ACTIONS(3332),
    [anon_sym_union] = ACTIONS(3332),
    [anon_sym_pub] = ACTIONS(3332),
    [anon_sym_mut] = ACTIONS(3332),
    [anon_sym_enum] = ACTIONS(3332),
    [anon_sym_interface] = ACTIONS(3332),
    [anon_sym_PLUS_PLUS] = ACTIONS(3332),
    [anon_sym_DASH_DASH] = ACTIONS(3332),
    [anon_sym_QMARK] = ACTIONS(3332),
    [anon_sym_BANG] = ACTIONS(3332),
    [anon_sym_go] = ACTIONS(3332),
    [anon_sym_spawn] = ACTIONS(3332),
    [anon_sym_json_DOTdecode] = ACTIONS(3332),
    [anon_sym_PIPE] = ACTIONS(3332),
    [anon_sym_LBRACK2] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3332),
    [anon_sym_CARET] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3332),
    [anon_sym_LT_DASH] = ACTIONS(3332),
    [anon_sym_LT_LT] = ACTIONS(3332),
    [anon_sym_GT_GT] = ACTIONS(3332),
    [anon_sym_GT_GT_GT] = ACTIONS(3332),
    [anon_sym_AMP_CARET] = ACTIONS(3332),
    [anon_sym_AMP_AMP] = ACTIONS(3332),
    [anon_sym_PIPE_PIPE] = ACTIONS(3332),
    [anon_sym_or] = ACTIONS(3332),
    [sym_none] = ACTIONS(3332),
    [sym_true] = ACTIONS(3332),
    [sym_false] = ACTIONS(3332),
    [sym_nil] = ACTIONS(3332),
    [anon_sym_QMARK_DOT] = ACTIONS(3332),
    [anon_sym_POUND_LBRACK] = ACTIONS(3332),
    [anon_sym_if] = ACTIONS(3332),
    [anon_sym_DOLLARif] = ACTIONS(3332),
    [anon_sym_is] = ACTIONS(3332),
    [anon_sym_BANGis] = ACTIONS(3332),
    [anon_sym_in] = ACTIONS(3332),
    [anon_sym_BANGin] = ACTIONS(3332),
    [anon_sym_match] = ACTIONS(3332),
    [anon_sym_select] = ACTIONS(3332),
    [anon_sym_STAR_EQ] = ACTIONS(3332),
    [anon_sym_SLASH_EQ] = ACTIONS(3332),
    [anon_sym_PERCENT_EQ] = ACTIONS(3332),
    [anon_sym_LT_LT_EQ] = ACTIONS(3332),
    [anon_sym_GT_GT_EQ] = ACTIONS(3332),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3332),
    [anon_sym_AMP_EQ] = ACTIONS(3332),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3332),
    [anon_sym_PLUS_EQ] = ACTIONS(3332),
    [anon_sym_DASH_EQ] = ACTIONS(3332),
    [anon_sym_PIPE_EQ] = ACTIONS(3332),
    [anon_sym_CARET_EQ] = ACTIONS(3332),
    [anon_sym_COLON_EQ] = ACTIONS(3332),
    [anon_sym_lock] = ACTIONS(3332),
    [anon_sym_rlock] = ACTIONS(3332),
    [anon_sym_unsafe] = ACTIONS(3332),
    [anon_sym_sql] = ACTIONS(3332),
    [sym_int_literal] = ACTIONS(3332),
    [sym_float_literal] = ACTIONS(3332),
    [sym_rune_literal] = ACTIONS(3332),
    [anon_sym_SQUOTE] = ACTIONS(3332),
    [anon_sym_DQUOTE] = ACTIONS(3332),
    [anon_sym_c_SQUOTE] = ACTIONS(3332),
    [anon_sym_c_DQUOTE] = ACTIONS(3332),
    [anon_sym_r_SQUOTE] = ACTIONS(3332),
    [anon_sym_r_DQUOTE] = ACTIONS(3332),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3332),
    [anon_sym_shared] = ACTIONS(3332),
    [anon_sym_map_LBRACK] = ACTIONS(3332),
    [anon_sym_chan] = ACTIONS(3332),
    [anon_sym_thread] = ACTIONS(3332),
    [anon_sym_atomic] = ACTIONS(3332),
    [anon_sym_assert] = ACTIONS(3332),
    [anon_sym_defer] = ACTIONS(3332),
    [anon_sym_goto] = ACTIONS(3332),
    [anon_sym_break] = ACTIONS(3332),
    [anon_sym_continue] = ACTIONS(3332),
    [anon_sym_return] = ACTIONS(3332),
    [anon_sym_DOLLARfor] = ACTIONS(3332),
    [anon_sym_for] = ACTIONS(3332),
    [anon_sym_POUND] = ACTIONS(3332),
    [anon_sym_asm] = ACTIONS(3332),
    [anon_sym_AT_LBRACK] = ACTIONS(3332),
  },
  [523] = {
    [sym_line_comment] = STATE(523),
    [sym_block_comment] = STATE(523),
    [ts_builtin_sym_end] = ACTIONS(2173),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LF] = ACTIONS(2175),
    [anon_sym_CR] = ACTIONS(2175),
    [anon_sym_CR_LF] = ACTIONS(2175),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2175),
    [anon_sym_as] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2175),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym_const] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_EQ] = ACTIONS(2175),
    [anon_sym___global] = ACTIONS(2175),
    [anon_sym_type] = ACTIONS(2175),
    [anon_sym_fn] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2175),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_PERCENT] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_GT] = ACTIONS(2175),
    [anon_sym_EQ_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ] = ACTIONS(2175),
    [anon_sym_LT_EQ] = ACTIONS(2175),
    [anon_sym_GT_EQ] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2173),
    [anon_sym_struct] = ACTIONS(2175),
    [anon_sym_union] = ACTIONS(2175),
    [anon_sym_pub] = ACTIONS(2175),
    [anon_sym_mut] = ACTIONS(2175),
    [anon_sym_enum] = ACTIONS(2175),
    [anon_sym_interface] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [anon_sym_QMARK] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_go] = ACTIONS(2175),
    [anon_sym_spawn] = ACTIONS(2175),
    [anon_sym_json_DOTdecode] = ACTIONS(2175),
    [anon_sym_PIPE] = ACTIONS(2175),
    [anon_sym_LBRACK2] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_CARET] = ACTIONS(2175),
    [anon_sym_AMP] = ACTIONS(2175),
    [anon_sym_LT_DASH] = ACTIONS(2175),
    [anon_sym_LT_LT] = ACTIONS(2175),
    [anon_sym_GT_GT] = ACTIONS(2175),
    [anon_sym_GT_GT_GT] = ACTIONS(2175),
    [anon_sym_AMP_CARET] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(2175),
    [anon_sym_PIPE_PIPE] = ACTIONS(2175),
    [anon_sym_or] = ACTIONS(2175),
    [sym_none] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_nil] = ACTIONS(2175),
    [anon_sym_QMARK_DOT] = ACTIONS(2175),
    [anon_sym_POUND_LBRACK] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_DOLLARif] = ACTIONS(2175),
    [anon_sym_is] = ACTIONS(2175),
    [anon_sym_BANGis] = ACTIONS(2175),
    [anon_sym_in] = ACTIONS(2175),
    [anon_sym_BANGin] = ACTIONS(2175),
    [anon_sym_match] = ACTIONS(2175),
    [anon_sym_select] = ACTIONS(2175),
    [anon_sym_STAR_EQ] = ACTIONS(2175),
    [anon_sym_SLASH_EQ] = ACTIONS(2175),
    [anon_sym_PERCENT_EQ] = ACTIONS(2175),
    [anon_sym_LT_LT_EQ] = ACTIONS(2175),
    [anon_sym_GT_GT_EQ] = ACTIONS(2175),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2175),
    [anon_sym_AMP_EQ] = ACTIONS(2175),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2175),
    [anon_sym_PLUS_EQ] = ACTIONS(2175),
    [anon_sym_DASH_EQ] = ACTIONS(2175),
    [anon_sym_PIPE_EQ] = ACTIONS(2175),
    [anon_sym_CARET_EQ] = ACTIONS(2175),
    [anon_sym_COLON_EQ] = ACTIONS(2175),
    [anon_sym_lock] = ACTIONS(2175),
    [anon_sym_rlock] = ACTIONS(2175),
    [anon_sym_unsafe] = ACTIONS(2175),
    [anon_sym_sql] = ACTIONS(2175),
    [sym_int_literal] = ACTIONS(2175),
    [sym_float_literal] = ACTIONS(2175),
    [sym_rune_literal] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_c_SQUOTE] = ACTIONS(2175),
    [anon_sym_c_DQUOTE] = ACTIONS(2175),
    [anon_sym_r_SQUOTE] = ACTIONS(2175),
    [anon_sym_r_DQUOTE] = ACTIONS(2175),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2175),
    [anon_sym_shared] = ACTIONS(2175),
    [anon_sym_map_LBRACK] = ACTIONS(2175),
    [anon_sym_chan] = ACTIONS(2175),
    [anon_sym_thread] = ACTIONS(2175),
    [anon_sym_atomic] = ACTIONS(2175),
    [anon_sym_assert] = ACTIONS(2175),
    [anon_sym_defer] = ACTIONS(2175),
    [anon_sym_goto] = ACTIONS(2175),
    [anon_sym_break] = ACTIONS(2175),
    [anon_sym_continue] = ACTIONS(2175),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_DOLLARfor] = ACTIONS(2175),
    [anon_sym_for] = ACTIONS(2175),
    [anon_sym_POUND] = ACTIONS(2175),
    [anon_sym_asm] = ACTIONS(2175),
    [anon_sym_AT_LBRACK] = ACTIONS(2175),
  },
  [524] = {
    [sym_line_comment] = STATE(524),
    [sym_block_comment] = STATE(524),
    [ts_builtin_sym_end] = ACTIONS(3334),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_LF] = ACTIONS(3336),
    [anon_sym_CR] = ACTIONS(3336),
    [anon_sym_CR_LF] = ACTIONS(3336),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3336),
    [anon_sym_as] = ACTIONS(3336),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3336),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_EQ] = ACTIONS(3336),
    [anon_sym___global] = ACTIONS(3336),
    [anon_sym_type] = ACTIONS(3336),
    [anon_sym_fn] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_SLASH] = ACTIONS(3336),
    [anon_sym_PERCENT] = ACTIONS(3336),
    [anon_sym_LT] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3336),
    [anon_sym_EQ_EQ] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_LT_EQ] = ACTIONS(3336),
    [anon_sym_GT_EQ] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_union] = ACTIONS(3336),
    [anon_sym_pub] = ACTIONS(3336),
    [anon_sym_mut] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(3336),
    [anon_sym_interface] = ACTIONS(3336),
    [anon_sym_PLUS_PLUS] = ACTIONS(3336),
    [anon_sym_DASH_DASH] = ACTIONS(3336),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_BANG] = ACTIONS(3336),
    [anon_sym_go] = ACTIONS(3336),
    [anon_sym_spawn] = ACTIONS(3336),
    [anon_sym_json_DOTdecode] = ACTIONS(3336),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3336),
    [anon_sym_CARET] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LT_DASH] = ACTIONS(3336),
    [anon_sym_LT_LT] = ACTIONS(3336),
    [anon_sym_GT_GT] = ACTIONS(3336),
    [anon_sym_GT_GT_GT] = ACTIONS(3336),
    [anon_sym_AMP_CARET] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_or] = ACTIONS(3336),
    [sym_none] = ACTIONS(3336),
    [sym_true] = ACTIONS(3336),
    [sym_false] = ACTIONS(3336),
    [sym_nil] = ACTIONS(3336),
    [anon_sym_QMARK_DOT] = ACTIONS(3336),
    [anon_sym_POUND_LBRACK] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_DOLLARif] = ACTIONS(3336),
    [anon_sym_is] = ACTIONS(3336),
    [anon_sym_BANGis] = ACTIONS(3336),
    [anon_sym_in] = ACTIONS(3336),
    [anon_sym_BANGin] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_select] = ACTIONS(3336),
    [anon_sym_STAR_EQ] = ACTIONS(3336),
    [anon_sym_SLASH_EQ] = ACTIONS(3336),
    [anon_sym_PERCENT_EQ] = ACTIONS(3336),
    [anon_sym_LT_LT_EQ] = ACTIONS(3336),
    [anon_sym_GT_GT_EQ] = ACTIONS(3336),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3336),
    [anon_sym_AMP_EQ] = ACTIONS(3336),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3336),
    [anon_sym_PLUS_EQ] = ACTIONS(3336),
    [anon_sym_DASH_EQ] = ACTIONS(3336),
    [anon_sym_PIPE_EQ] = ACTIONS(3336),
    [anon_sym_CARET_EQ] = ACTIONS(3336),
    [anon_sym_COLON_EQ] = ACTIONS(3336),
    [anon_sym_lock] = ACTIONS(3336),
    [anon_sym_rlock] = ACTIONS(3336),
    [anon_sym_unsafe] = ACTIONS(3336),
    [anon_sym_sql] = ACTIONS(3336),
    [sym_int_literal] = ACTIONS(3336),
    [sym_float_literal] = ACTIONS(3336),
    [sym_rune_literal] = ACTIONS(3336),
    [anon_sym_SQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_c_SQUOTE] = ACTIONS(3336),
    [anon_sym_c_DQUOTE] = ACTIONS(3336),
    [anon_sym_r_SQUOTE] = ACTIONS(3336),
    [anon_sym_r_DQUOTE] = ACTIONS(3336),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3336),
    [anon_sym_shared] = ACTIONS(3336),
    [anon_sym_map_LBRACK] = ACTIONS(3336),
    [anon_sym_chan] = ACTIONS(3336),
    [anon_sym_thread] = ACTIONS(3336),
    [anon_sym_atomic] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_defer] = ACTIONS(3336),
    [anon_sym_goto] = ACTIONS(3336),
    [anon_sym_break] = ACTIONS(3336),
    [anon_sym_continue] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_DOLLARfor] = ACTIONS(3336),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_POUND] = ACTIONS(3336),
    [anon_sym_asm] = ACTIONS(3336),
    [anon_sym_AT_LBRACK] = ACTIONS(3336),
  },
  [525] = {
    [sym_line_comment] = STATE(525),
    [sym_block_comment] = STATE(525),
    [sym__expression] = STATE(2558),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3982),
    [sym_expression_list] = STATE(4116),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [526] = {
    [sym_line_comment] = STATE(526),
    [sym_block_comment] = STATE(526),
    [ts_builtin_sym_end] = ACTIONS(3338),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LF] = ACTIONS(3340),
    [anon_sym_CR] = ACTIONS(3340),
    [anon_sym_CR_LF] = ACTIONS(3340),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3340),
    [anon_sym_as] = ACTIONS(3340),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_COMMA] = ACTIONS(3340),
    [anon_sym_const] = ACTIONS(3340),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_EQ] = ACTIONS(3340),
    [anon_sym___global] = ACTIONS(3340),
    [anon_sym_type] = ACTIONS(3340),
    [anon_sym_fn] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_STAR] = ACTIONS(3340),
    [anon_sym_SLASH] = ACTIONS(3340),
    [anon_sym_PERCENT] = ACTIONS(3340),
    [anon_sym_LT] = ACTIONS(3340),
    [anon_sym_GT] = ACTIONS(3340),
    [anon_sym_EQ_EQ] = ACTIONS(3340),
    [anon_sym_BANG_EQ] = ACTIONS(3340),
    [anon_sym_LT_EQ] = ACTIONS(3340),
    [anon_sym_GT_EQ] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3338),
    [anon_sym_struct] = ACTIONS(3340),
    [anon_sym_union] = ACTIONS(3340),
    [anon_sym_pub] = ACTIONS(3340),
    [anon_sym_mut] = ACTIONS(3340),
    [anon_sym_enum] = ACTIONS(3340),
    [anon_sym_interface] = ACTIONS(3340),
    [anon_sym_PLUS_PLUS] = ACTIONS(3340),
    [anon_sym_DASH_DASH] = ACTIONS(3340),
    [anon_sym_QMARK] = ACTIONS(3340),
    [anon_sym_BANG] = ACTIONS(3340),
    [anon_sym_go] = ACTIONS(3340),
    [anon_sym_spawn] = ACTIONS(3340),
    [anon_sym_json_DOTdecode] = ACTIONS(3340),
    [anon_sym_PIPE] = ACTIONS(3340),
    [anon_sym_LBRACK2] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3340),
    [anon_sym_CARET] = ACTIONS(3340),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LT_DASH] = ACTIONS(3340),
    [anon_sym_LT_LT] = ACTIONS(3340),
    [anon_sym_GT_GT] = ACTIONS(3340),
    [anon_sym_GT_GT_GT] = ACTIONS(3340),
    [anon_sym_AMP_CARET] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3340),
    [anon_sym_PIPE_PIPE] = ACTIONS(3340),
    [anon_sym_or] = ACTIONS(3340),
    [sym_none] = ACTIONS(3340),
    [sym_true] = ACTIONS(3340),
    [sym_false] = ACTIONS(3340),
    [sym_nil] = ACTIONS(3340),
    [anon_sym_QMARK_DOT] = ACTIONS(3340),
    [anon_sym_POUND_LBRACK] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_DOLLARif] = ACTIONS(3340),
    [anon_sym_is] = ACTIONS(3340),
    [anon_sym_BANGis] = ACTIONS(3340),
    [anon_sym_in] = ACTIONS(3340),
    [anon_sym_BANGin] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_select] = ACTIONS(3340),
    [anon_sym_STAR_EQ] = ACTIONS(3340),
    [anon_sym_SLASH_EQ] = ACTIONS(3340),
    [anon_sym_PERCENT_EQ] = ACTIONS(3340),
    [anon_sym_LT_LT_EQ] = ACTIONS(3340),
    [anon_sym_GT_GT_EQ] = ACTIONS(3340),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3340),
    [anon_sym_AMP_EQ] = ACTIONS(3340),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3340),
    [anon_sym_PLUS_EQ] = ACTIONS(3340),
    [anon_sym_DASH_EQ] = ACTIONS(3340),
    [anon_sym_PIPE_EQ] = ACTIONS(3340),
    [anon_sym_CARET_EQ] = ACTIONS(3340),
    [anon_sym_COLON_EQ] = ACTIONS(3340),
    [anon_sym_lock] = ACTIONS(3340),
    [anon_sym_rlock] = ACTIONS(3340),
    [anon_sym_unsafe] = ACTIONS(3340),
    [anon_sym_sql] = ACTIONS(3340),
    [sym_int_literal] = ACTIONS(3340),
    [sym_float_literal] = ACTIONS(3340),
    [sym_rune_literal] = ACTIONS(3340),
    [anon_sym_SQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_c_SQUOTE] = ACTIONS(3340),
    [anon_sym_c_DQUOTE] = ACTIONS(3340),
    [anon_sym_r_SQUOTE] = ACTIONS(3340),
    [anon_sym_r_DQUOTE] = ACTIONS(3340),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3340),
    [anon_sym_shared] = ACTIONS(3340),
    [anon_sym_map_LBRACK] = ACTIONS(3340),
    [anon_sym_chan] = ACTIONS(3340),
    [anon_sym_thread] = ACTIONS(3340),
    [anon_sym_atomic] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_defer] = ACTIONS(3340),
    [anon_sym_goto] = ACTIONS(3340),
    [anon_sym_break] = ACTIONS(3340),
    [anon_sym_continue] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_DOLLARfor] = ACTIONS(3340),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_POUND] = ACTIONS(3340),
    [anon_sym_asm] = ACTIONS(3340),
    [anon_sym_AT_LBRACK] = ACTIONS(3340),
  },
  [527] = {
    [sym_line_comment] = STATE(527),
    [sym_block_comment] = STATE(527),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(402),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(3342),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [528] = {
    [sym_line_comment] = STATE(528),
    [sym_block_comment] = STATE(528),
    [ts_builtin_sym_end] = ACTIONS(3344),
    [sym_identifier] = ACTIONS(3346),
    [anon_sym_LF] = ACTIONS(3346),
    [anon_sym_CR] = ACTIONS(3346),
    [anon_sym_CR_LF] = ACTIONS(3346),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3346),
    [anon_sym_as] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_COMMA] = ACTIONS(3346),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3346),
    [anon_sym_EQ] = ACTIONS(3346),
    [anon_sym___global] = ACTIONS(3346),
    [anon_sym_type] = ACTIONS(3346),
    [anon_sym_fn] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_SLASH] = ACTIONS(3346),
    [anon_sym_PERCENT] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_GT] = ACTIONS(3346),
    [anon_sym_EQ_EQ] = ACTIONS(3346),
    [anon_sym_BANG_EQ] = ACTIONS(3346),
    [anon_sym_LT_EQ] = ACTIONS(3346),
    [anon_sym_GT_EQ] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3346),
    [anon_sym_union] = ACTIONS(3346),
    [anon_sym_pub] = ACTIONS(3346),
    [anon_sym_mut] = ACTIONS(3346),
    [anon_sym_enum] = ACTIONS(3346),
    [anon_sym_interface] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_QMARK] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_go] = ACTIONS(3346),
    [anon_sym_spawn] = ACTIONS(3346),
    [anon_sym_json_DOTdecode] = ACTIONS(3346),
    [anon_sym_PIPE] = ACTIONS(3346),
    [anon_sym_LBRACK2] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_CARET] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym_LT_DASH] = ACTIONS(3346),
    [anon_sym_LT_LT] = ACTIONS(3346),
    [anon_sym_GT_GT] = ACTIONS(3346),
    [anon_sym_GT_GT_GT] = ACTIONS(3346),
    [anon_sym_AMP_CARET] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_PIPE_PIPE] = ACTIONS(3346),
    [anon_sym_or] = ACTIONS(3346),
    [sym_none] = ACTIONS(3346),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [sym_nil] = ACTIONS(3346),
    [anon_sym_QMARK_DOT] = ACTIONS(3346),
    [anon_sym_POUND_LBRACK] = ACTIONS(3346),
    [anon_sym_if] = ACTIONS(3346),
    [anon_sym_DOLLARif] = ACTIONS(3346),
    [anon_sym_is] = ACTIONS(3346),
    [anon_sym_BANGis] = ACTIONS(3346),
    [anon_sym_in] = ACTIONS(3346),
    [anon_sym_BANGin] = ACTIONS(3346),
    [anon_sym_match] = ACTIONS(3346),
    [anon_sym_select] = ACTIONS(3346),
    [anon_sym_STAR_EQ] = ACTIONS(3346),
    [anon_sym_SLASH_EQ] = ACTIONS(3346),
    [anon_sym_PERCENT_EQ] = ACTIONS(3346),
    [anon_sym_LT_LT_EQ] = ACTIONS(3346),
    [anon_sym_GT_GT_EQ] = ACTIONS(3346),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3346),
    [anon_sym_AMP_EQ] = ACTIONS(3346),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3346),
    [anon_sym_PLUS_EQ] = ACTIONS(3346),
    [anon_sym_DASH_EQ] = ACTIONS(3346),
    [anon_sym_PIPE_EQ] = ACTIONS(3346),
    [anon_sym_CARET_EQ] = ACTIONS(3346),
    [anon_sym_COLON_EQ] = ACTIONS(3346),
    [anon_sym_lock] = ACTIONS(3346),
    [anon_sym_rlock] = ACTIONS(3346),
    [anon_sym_unsafe] = ACTIONS(3346),
    [anon_sym_sql] = ACTIONS(3346),
    [sym_int_literal] = ACTIONS(3346),
    [sym_float_literal] = ACTIONS(3346),
    [sym_rune_literal] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [anon_sym_c_SQUOTE] = ACTIONS(3346),
    [anon_sym_c_DQUOTE] = ACTIONS(3346),
    [anon_sym_r_SQUOTE] = ACTIONS(3346),
    [anon_sym_r_DQUOTE] = ACTIONS(3346),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3346),
    [anon_sym_shared] = ACTIONS(3346),
    [anon_sym_map_LBRACK] = ACTIONS(3346),
    [anon_sym_chan] = ACTIONS(3346),
    [anon_sym_thread] = ACTIONS(3346),
    [anon_sym_atomic] = ACTIONS(3346),
    [anon_sym_assert] = ACTIONS(3346),
    [anon_sym_defer] = ACTIONS(3346),
    [anon_sym_goto] = ACTIONS(3346),
    [anon_sym_break] = ACTIONS(3346),
    [anon_sym_continue] = ACTIONS(3346),
    [anon_sym_return] = ACTIONS(3346),
    [anon_sym_DOLLARfor] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3346),
    [anon_sym_POUND] = ACTIONS(3346),
    [anon_sym_asm] = ACTIONS(3346),
    [anon_sym_AT_LBRACK] = ACTIONS(3346),
  },
  [529] = {
    [sym_line_comment] = STATE(529),
    [sym_block_comment] = STATE(529),
    [ts_builtin_sym_end] = ACTIONS(3348),
    [sym_identifier] = ACTIONS(3350),
    [anon_sym_LF] = ACTIONS(3350),
    [anon_sym_CR] = ACTIONS(3350),
    [anon_sym_CR_LF] = ACTIONS(3350),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3350),
    [anon_sym_as] = ACTIONS(3350),
    [anon_sym_LBRACE] = ACTIONS(3350),
    [anon_sym_COMMA] = ACTIONS(3350),
    [anon_sym_const] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(3350),
    [anon_sym_EQ] = ACTIONS(3350),
    [anon_sym___global] = ACTIONS(3350),
    [anon_sym_type] = ACTIONS(3350),
    [anon_sym_fn] = ACTIONS(3350),
    [anon_sym_PLUS] = ACTIONS(3350),
    [anon_sym_DASH] = ACTIONS(3350),
    [anon_sym_STAR] = ACTIONS(3350),
    [anon_sym_SLASH] = ACTIONS(3350),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_LT] = ACTIONS(3350),
    [anon_sym_GT] = ACTIONS(3350),
    [anon_sym_EQ_EQ] = ACTIONS(3350),
    [anon_sym_BANG_EQ] = ACTIONS(3350),
    [anon_sym_LT_EQ] = ACTIONS(3350),
    [anon_sym_GT_EQ] = ACTIONS(3350),
    [anon_sym_LBRACK] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3350),
    [anon_sym_union] = ACTIONS(3350),
    [anon_sym_pub] = ACTIONS(3350),
    [anon_sym_mut] = ACTIONS(3350),
    [anon_sym_enum] = ACTIONS(3350),
    [anon_sym_interface] = ACTIONS(3350),
    [anon_sym_PLUS_PLUS] = ACTIONS(3350),
    [anon_sym_DASH_DASH] = ACTIONS(3350),
    [anon_sym_QMARK] = ACTIONS(3350),
    [anon_sym_BANG] = ACTIONS(3350),
    [anon_sym_go] = ACTIONS(3350),
    [anon_sym_spawn] = ACTIONS(3350),
    [anon_sym_json_DOTdecode] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3350),
    [anon_sym_LBRACK2] = ACTIONS(3350),
    [anon_sym_TILDE] = ACTIONS(3350),
    [anon_sym_CARET] = ACTIONS(3350),
    [anon_sym_AMP] = ACTIONS(3350),
    [anon_sym_LT_DASH] = ACTIONS(3350),
    [anon_sym_LT_LT] = ACTIONS(3350),
    [anon_sym_GT_GT] = ACTIONS(3350),
    [anon_sym_GT_GT_GT] = ACTIONS(3350),
    [anon_sym_AMP_CARET] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_PIPE_PIPE] = ACTIONS(3350),
    [anon_sym_or] = ACTIONS(3350),
    [sym_none] = ACTIONS(3350),
    [sym_true] = ACTIONS(3350),
    [sym_false] = ACTIONS(3350),
    [sym_nil] = ACTIONS(3350),
    [anon_sym_QMARK_DOT] = ACTIONS(3350),
    [anon_sym_POUND_LBRACK] = ACTIONS(3350),
    [anon_sym_if] = ACTIONS(3350),
    [anon_sym_DOLLARif] = ACTIONS(3350),
    [anon_sym_is] = ACTIONS(3350),
    [anon_sym_BANGis] = ACTIONS(3350),
    [anon_sym_in] = ACTIONS(3350),
    [anon_sym_BANGin] = ACTIONS(3350),
    [anon_sym_match] = ACTIONS(3350),
    [anon_sym_select] = ACTIONS(3350),
    [anon_sym_STAR_EQ] = ACTIONS(3350),
    [anon_sym_SLASH_EQ] = ACTIONS(3350),
    [anon_sym_PERCENT_EQ] = ACTIONS(3350),
    [anon_sym_LT_LT_EQ] = ACTIONS(3350),
    [anon_sym_GT_GT_EQ] = ACTIONS(3350),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3350),
    [anon_sym_AMP_EQ] = ACTIONS(3350),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3350),
    [anon_sym_PLUS_EQ] = ACTIONS(3350),
    [anon_sym_DASH_EQ] = ACTIONS(3350),
    [anon_sym_PIPE_EQ] = ACTIONS(3350),
    [anon_sym_CARET_EQ] = ACTIONS(3350),
    [anon_sym_COLON_EQ] = ACTIONS(3350),
    [anon_sym_lock] = ACTIONS(3350),
    [anon_sym_rlock] = ACTIONS(3350),
    [anon_sym_unsafe] = ACTIONS(3350),
    [anon_sym_sql] = ACTIONS(3350),
    [sym_int_literal] = ACTIONS(3350),
    [sym_float_literal] = ACTIONS(3350),
    [sym_rune_literal] = ACTIONS(3350),
    [anon_sym_SQUOTE] = ACTIONS(3350),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [anon_sym_c_SQUOTE] = ACTIONS(3350),
    [anon_sym_c_DQUOTE] = ACTIONS(3350),
    [anon_sym_r_SQUOTE] = ACTIONS(3350),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3350),
    [anon_sym_shared] = ACTIONS(3350),
    [anon_sym_map_LBRACK] = ACTIONS(3350),
    [anon_sym_chan] = ACTIONS(3350),
    [anon_sym_thread] = ACTIONS(3350),
    [anon_sym_atomic] = ACTIONS(3350),
    [anon_sym_assert] = ACTIONS(3350),
    [anon_sym_defer] = ACTIONS(3350),
    [anon_sym_goto] = ACTIONS(3350),
    [anon_sym_break] = ACTIONS(3350),
    [anon_sym_continue] = ACTIONS(3350),
    [anon_sym_return] = ACTIONS(3350),
    [anon_sym_DOLLARfor] = ACTIONS(3350),
    [anon_sym_for] = ACTIONS(3350),
    [anon_sym_POUND] = ACTIONS(3350),
    [anon_sym_asm] = ACTIONS(3350),
    [anon_sym_AT_LBRACK] = ACTIONS(3350),
  },
  [530] = {
    [sym_line_comment] = STATE(530),
    [sym_block_comment] = STATE(530),
    [sym__expression] = STATE(1574),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1693),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1692),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [aux_sym__array_repeat1] = STATE(472),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(3352),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1615),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [531] = {
    [sym_line_comment] = STATE(531),
    [sym_block_comment] = STATE(531),
    [ts_builtin_sym_end] = ACTIONS(3354),
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_LF] = ACTIONS(3356),
    [anon_sym_CR] = ACTIONS(3356),
    [anon_sym_CR_LF] = ACTIONS(3356),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3356),
    [anon_sym_as] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3356),
    [anon_sym_COMMA] = ACTIONS(3356),
    [anon_sym_const] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3356),
    [anon_sym_EQ] = ACTIONS(3356),
    [anon_sym___global] = ACTIONS(3356),
    [anon_sym_type] = ACTIONS(3356),
    [anon_sym_fn] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_STAR] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_PERCENT] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_GT] = ACTIONS(3356),
    [anon_sym_EQ_EQ] = ACTIONS(3356),
    [anon_sym_BANG_EQ] = ACTIONS(3356),
    [anon_sym_LT_EQ] = ACTIONS(3356),
    [anon_sym_GT_EQ] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3354),
    [anon_sym_struct] = ACTIONS(3356),
    [anon_sym_union] = ACTIONS(3356),
    [anon_sym_pub] = ACTIONS(3356),
    [anon_sym_mut] = ACTIONS(3356),
    [anon_sym_enum] = ACTIONS(3356),
    [anon_sym_interface] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3356),
    [anon_sym_DASH_DASH] = ACTIONS(3356),
    [anon_sym_QMARK] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3356),
    [anon_sym_go] = ACTIONS(3356),
    [anon_sym_spawn] = ACTIONS(3356),
    [anon_sym_json_DOTdecode] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(3356),
    [anon_sym_LBRACK2] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3356),
    [anon_sym_CARET] = ACTIONS(3356),
    [anon_sym_AMP] = ACTIONS(3356),
    [anon_sym_LT_DASH] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(3356),
    [anon_sym_GT_GT] = ACTIONS(3356),
    [anon_sym_GT_GT_GT] = ACTIONS(3356),
    [anon_sym_AMP_CARET] = ACTIONS(3356),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_PIPE_PIPE] = ACTIONS(3356),
    [anon_sym_or] = ACTIONS(3356),
    [sym_none] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_nil] = ACTIONS(3356),
    [anon_sym_QMARK_DOT] = ACTIONS(3356),
    [anon_sym_POUND_LBRACK] = ACTIONS(3356),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_DOLLARif] = ACTIONS(3356),
    [anon_sym_is] = ACTIONS(3356),
    [anon_sym_BANGis] = ACTIONS(3356),
    [anon_sym_in] = ACTIONS(3356),
    [anon_sym_BANGin] = ACTIONS(3356),
    [anon_sym_match] = ACTIONS(3356),
    [anon_sym_select] = ACTIONS(3356),
    [anon_sym_STAR_EQ] = ACTIONS(3356),
    [anon_sym_SLASH_EQ] = ACTIONS(3356),
    [anon_sym_PERCENT_EQ] = ACTIONS(3356),
    [anon_sym_LT_LT_EQ] = ACTIONS(3356),
    [anon_sym_GT_GT_EQ] = ACTIONS(3356),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3356),
    [anon_sym_AMP_EQ] = ACTIONS(3356),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3356),
    [anon_sym_PLUS_EQ] = ACTIONS(3356),
    [anon_sym_DASH_EQ] = ACTIONS(3356),
    [anon_sym_PIPE_EQ] = ACTIONS(3356),
    [anon_sym_CARET_EQ] = ACTIONS(3356),
    [anon_sym_COLON_EQ] = ACTIONS(3356),
    [anon_sym_lock] = ACTIONS(3356),
    [anon_sym_rlock] = ACTIONS(3356),
    [anon_sym_unsafe] = ACTIONS(3356),
    [anon_sym_sql] = ACTIONS(3356),
    [sym_int_literal] = ACTIONS(3356),
    [sym_float_literal] = ACTIONS(3356),
    [sym_rune_literal] = ACTIONS(3356),
    [anon_sym_SQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [anon_sym_c_SQUOTE] = ACTIONS(3356),
    [anon_sym_c_DQUOTE] = ACTIONS(3356),
    [anon_sym_r_SQUOTE] = ACTIONS(3356),
    [anon_sym_r_DQUOTE] = ACTIONS(3356),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3356),
    [anon_sym_shared] = ACTIONS(3356),
    [anon_sym_map_LBRACK] = ACTIONS(3356),
    [anon_sym_chan] = ACTIONS(3356),
    [anon_sym_thread] = ACTIONS(3356),
    [anon_sym_atomic] = ACTIONS(3356),
    [anon_sym_assert] = ACTIONS(3356),
    [anon_sym_defer] = ACTIONS(3356),
    [anon_sym_goto] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_DOLLARfor] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_POUND] = ACTIONS(3356),
    [anon_sym_asm] = ACTIONS(3356),
    [anon_sym_AT_LBRACK] = ACTIONS(3356),
  },
  [532] = {
    [sym_line_comment] = STATE(532),
    [sym_block_comment] = STATE(532),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3010),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3007),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_RBRACK] = ACTIONS(3358),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(3360),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [533] = {
    [sym_line_comment] = STATE(533),
    [sym_block_comment] = STATE(533),
    [sym__expression] = STATE(1979),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(941),
    [sym_mutable_expression] = STATE(3379),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_go] = ACTIONS(3372),
    [anon_sym_spawn] = ACTIONS(3374),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_LT_DASH] = ACTIONS(3380),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(3382),
    [anon_sym_lock] = ACTIONS(3384),
    [anon_sym_rlock] = ACTIONS(3384),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [534] = {
    [sym_line_comment] = STATE(534),
    [sym_block_comment] = STATE(534),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3042),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3041),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_RBRACK] = ACTIONS(3386),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(3388),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [535] = {
    [sym_line_comment] = STATE(535),
    [sym_block_comment] = STATE(535),
    [sym__expression] = STATE(2520),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(3883),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_COMMA] = ACTIONS(853),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3390),
    [anon_sym_lock] = ACTIONS(3392),
    [anon_sym_rlock] = ACTIONS(3392),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [536] = {
    [sym_line_comment] = STATE(536),
    [sym_block_comment] = STATE(536),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2984),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_RBRACK] = ACTIONS(3394),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(3396),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [537] = {
    [sym_line_comment] = STATE(537),
    [sym_block_comment] = STATE(537),
    [sym__expression] = STATE(2011),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(938),
    [sym_mutable_expression] = STATE(3377),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_go] = ACTIONS(3372),
    [anon_sym_spawn] = ACTIONS(3374),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_LT_DASH] = ACTIONS(3380),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(3382),
    [anon_sym_lock] = ACTIONS(3384),
    [anon_sym_rlock] = ACTIONS(3384),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [538] = {
    [sym_line_comment] = STATE(538),
    [sym_block_comment] = STATE(538),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3008),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3005),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_RBRACK] = ACTIONS(3398),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(3400),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [539] = {
    [sym_line_comment] = STATE(539),
    [sym_block_comment] = STATE(539),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2982),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3003),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_RBRACK] = ACTIONS(3402),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(3404),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [540] = {
    [sym_line_comment] = STATE(540),
    [sym_block_comment] = STATE(540),
    [sym__expression] = STATE(2910),
    [sym__expression_without_blocks] = STATE(2926),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_expression_without_blocks_list] = STATE(4464),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [541] = {
    [sym_line_comment] = STATE(541),
    [sym_block_comment] = STATE(541),
    [sym__expression] = STATE(2910),
    [sym__expression_without_blocks] = STATE(2926),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_expression_without_blocks_list] = STATE(4452),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [542] = {
    [sym_line_comment] = STATE(542),
    [sym_block_comment] = STATE(542),
    [sym_reference_expression] = STATE(4486),
    [sym_type_reference_expression] = STATE(1298),
    [sym_plain_type] = STATE(1391),
    [sym__plain_type_without_special] = STATE(1327),
    [sym_anon_struct_type] = STATE(1324),
    [sym_multi_return_type] = STATE(1327),
    [sym_result_type] = STATE(1327),
    [sym_option_type] = STATE(1327),
    [sym_qualified_type] = STATE(1298),
    [sym_fixed_array_type] = STATE(1324),
    [sym_array_type] = STATE(1324),
    [sym_pointer_type] = STATE(1324),
    [sym_wrong_pointer_type] = STATE(1324),
    [sym_map_type] = STATE(1324),
    [sym_channel_type] = STATE(1324),
    [sym_shared_type] = STATE(1324),
    [sym_thread_type] = STATE(1324),
    [sym_atomic_type] = STATE(1324),
    [sym_generic_type] = STATE(1324),
    [sym_function_type] = STATE(1324),
    [sym_identifier] = ACTIONS(3406),
    [anon_sym_LF] = ACTIONS(855),
    [anon_sym_CR] = ACTIONS(855),
    [anon_sym_CR_LF] = ACTIONS(855),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(855),
    [anon_sym_DOT] = ACTIONS(855),
    [anon_sym_as] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(855),
    [anon_sym_RBRACE] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(3408),
    [anon_sym_fn] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(3412),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_PERCENT] = ACTIONS(855),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_GT] = ACTIONS(855),
    [anon_sym_EQ_EQ] = ACTIONS(855),
    [anon_sym_BANG_EQ] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(855),
    [anon_sym_GT_EQ] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_struct] = ACTIONS(3414),
    [anon_sym_mut] = ACTIONS(855),
    [anon_sym_PLUS_PLUS] = ACTIONS(855),
    [anon_sym_DASH_DASH] = ACTIONS(855),
    [anon_sym_QMARK] = ACTIONS(3416),
    [anon_sym_BANG] = ACTIONS(3418),
    [anon_sym_go] = ACTIONS(855),
    [anon_sym_spawn] = ACTIONS(855),
    [anon_sym_json_DOTdecode] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(855),
    [anon_sym_LBRACK2] = ACTIONS(3420),
    [anon_sym_TILDE] = ACTIONS(855),
    [anon_sym_CARET] = ACTIONS(855),
    [anon_sym_AMP] = ACTIONS(3422),
    [anon_sym_LT_DASH] = ACTIONS(855),
    [anon_sym_LT_LT] = ACTIONS(855),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_GT_GT_GT] = ACTIONS(855),
    [anon_sym_AMP_CARET] = ACTIONS(855),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_PIPE_PIPE] = ACTIONS(855),
    [anon_sym_or] = ACTIONS(855),
    [sym_none] = ACTIONS(855),
    [sym_true] = ACTIONS(855),
    [sym_false] = ACTIONS(855),
    [sym_nil] = ACTIONS(855),
    [anon_sym_QMARK_DOT] = ACTIONS(855),
    [anon_sym_POUND_LBRACK] = ACTIONS(855),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_DOLLARif] = ACTIONS(855),
    [anon_sym_is] = ACTIONS(855),
    [anon_sym_BANGis] = ACTIONS(855),
    [anon_sym_in] = ACTIONS(855),
    [anon_sym_BANGin] = ACTIONS(855),
    [anon_sym_match] = ACTIONS(855),
    [anon_sym_select] = ACTIONS(855),
    [anon_sym_lock] = ACTIONS(855),
    [anon_sym_rlock] = ACTIONS(855),
    [anon_sym_unsafe] = ACTIONS(855),
    [anon_sym_sql] = ACTIONS(855),
    [sym_int_literal] = ACTIONS(855),
    [sym_float_literal] = ACTIONS(855),
    [sym_rune_literal] = ACTIONS(855),
    [anon_sym_SQUOTE] = ACTIONS(855),
    [anon_sym_DQUOTE] = ACTIONS(855),
    [anon_sym_c_SQUOTE] = ACTIONS(855),
    [anon_sym_c_DQUOTE] = ACTIONS(855),
    [anon_sym_r_SQUOTE] = ACTIONS(855),
    [anon_sym_r_DQUOTE] = ACTIONS(855),
    [sym_pseudo_compile_time_identifier] = ACTIONS(855),
    [anon_sym_shared] = ACTIONS(3424),
    [anon_sym_map_LBRACK] = ACTIONS(3426),
    [anon_sym_chan] = ACTIONS(3428),
    [anon_sym_thread] = ACTIONS(3430),
    [anon_sym_atomic] = ACTIONS(3432),
    [anon_sym_assert] = ACTIONS(855),
    [anon_sym_defer] = ACTIONS(855),
    [anon_sym_goto] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(855),
    [anon_sym_continue] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(855),
    [anon_sym_DOLLARfor] = ACTIONS(855),
    [anon_sym_for] = ACTIONS(855),
    [anon_sym_POUND] = ACTIONS(855),
    [anon_sym_asm] = ACTIONS(855),
  },
  [543] = {
    [sym_line_comment] = STATE(543),
    [sym_block_comment] = STATE(543),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3012),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2985),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_RBRACK] = ACTIONS(3434),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(3436),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [544] = {
    [sym_line_comment] = STATE(544),
    [sym_block_comment] = STATE(544),
    [sym_reference_expression] = STATE(4486),
    [sym_type_reference_expression] = STATE(1298),
    [sym_plain_type] = STATE(1397),
    [sym__plain_type_without_special] = STATE(1327),
    [sym_anon_struct_type] = STATE(1324),
    [sym_multi_return_type] = STATE(1327),
    [sym_result_type] = STATE(1327),
    [sym_option_type] = STATE(1327),
    [sym_qualified_type] = STATE(1298),
    [sym_fixed_array_type] = STATE(1324),
    [sym_array_type] = STATE(1324),
    [sym_pointer_type] = STATE(1324),
    [sym_wrong_pointer_type] = STATE(1324),
    [sym_map_type] = STATE(1324),
    [sym_channel_type] = STATE(1324),
    [sym_shared_type] = STATE(1324),
    [sym_thread_type] = STATE(1324),
    [sym_atomic_type] = STATE(1324),
    [sym_generic_type] = STATE(1324),
    [sym_function_type] = STATE(1324),
    [sym_identifier] = ACTIONS(3406),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_CR] = ACTIONS(859),
    [anon_sym_CR_LF] = ACTIONS(859),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(859),
    [anon_sym_as] = ACTIONS(859),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(3408),
    [anon_sym_fn] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(3412),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_struct] = ACTIONS(3414),
    [anon_sym_mut] = ACTIONS(859),
    [anon_sym_PLUS_PLUS] = ACTIONS(859),
    [anon_sym_DASH_DASH] = ACTIONS(859),
    [anon_sym_QMARK] = ACTIONS(3416),
    [anon_sym_BANG] = ACTIONS(3418),
    [anon_sym_go] = ACTIONS(859),
    [anon_sym_spawn] = ACTIONS(859),
    [anon_sym_json_DOTdecode] = ACTIONS(859),
    [anon_sym_PIPE] = ACTIONS(859),
    [anon_sym_LBRACK2] = ACTIONS(3420),
    [anon_sym_TILDE] = ACTIONS(859),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(3422),
    [anon_sym_LT_DASH] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_GT_GT_GT] = ACTIONS(859),
    [anon_sym_AMP_CARET] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_or] = ACTIONS(859),
    [sym_none] = ACTIONS(859),
    [sym_true] = ACTIONS(859),
    [sym_false] = ACTIONS(859),
    [sym_nil] = ACTIONS(859),
    [anon_sym_QMARK_DOT] = ACTIONS(859),
    [anon_sym_POUND_LBRACK] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_DOLLARif] = ACTIONS(859),
    [anon_sym_is] = ACTIONS(859),
    [anon_sym_BANGis] = ACTIONS(859),
    [anon_sym_in] = ACTIONS(859),
    [anon_sym_BANGin] = ACTIONS(859),
    [anon_sym_match] = ACTIONS(859),
    [anon_sym_select] = ACTIONS(859),
    [anon_sym_lock] = ACTIONS(859),
    [anon_sym_rlock] = ACTIONS(859),
    [anon_sym_unsafe] = ACTIONS(859),
    [anon_sym_sql] = ACTIONS(859),
    [sym_int_literal] = ACTIONS(859),
    [sym_float_literal] = ACTIONS(859),
    [sym_rune_literal] = ACTIONS(859),
    [anon_sym_SQUOTE] = ACTIONS(859),
    [anon_sym_DQUOTE] = ACTIONS(859),
    [anon_sym_c_SQUOTE] = ACTIONS(859),
    [anon_sym_c_DQUOTE] = ACTIONS(859),
    [anon_sym_r_SQUOTE] = ACTIONS(859),
    [anon_sym_r_DQUOTE] = ACTIONS(859),
    [sym_pseudo_compile_time_identifier] = ACTIONS(859),
    [anon_sym_shared] = ACTIONS(3424),
    [anon_sym_map_LBRACK] = ACTIONS(3426),
    [anon_sym_chan] = ACTIONS(3428),
    [anon_sym_thread] = ACTIONS(3430),
    [anon_sym_atomic] = ACTIONS(3432),
    [anon_sym_assert] = ACTIONS(859),
    [anon_sym_defer] = ACTIONS(859),
    [anon_sym_goto] = ACTIONS(859),
    [anon_sym_break] = ACTIONS(859),
    [anon_sym_continue] = ACTIONS(859),
    [anon_sym_return] = ACTIONS(859),
    [anon_sym_DOLLARfor] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(859),
    [anon_sym_POUND] = ACTIONS(859),
    [anon_sym_asm] = ACTIONS(859),
  },
  [545] = {
    [sym_line_comment] = STATE(545),
    [sym_block_comment] = STATE(545),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3053),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3030),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_RBRACK] = ACTIONS(3438),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(3440),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [546] = {
    [sym_line_comment] = STATE(546),
    [sym_block_comment] = STATE(546),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2993),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2994),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_RBRACK] = ACTIONS(3442),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(3444),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [547] = {
    [sym_line_comment] = STATE(547),
    [sym_block_comment] = STATE(547),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2458),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_LF] = ACTIONS(865),
    [anon_sym_CR] = ACTIONS(865),
    [anon_sym_CR_LF] = ACTIONS(865),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_COMMA] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(865),
    [anon_sym_LPAREN] = ACTIONS(867),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_STAR] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_PERCENT] = ACTIONS(865),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(865),
    [anon_sym_BANG_EQ] = ACTIONS(865),
    [anon_sym_LT_EQ] = ACTIONS(865),
    [anon_sym_GT_EQ] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_mut] = ACTIONS(865),
    [anon_sym_PLUS_PLUS] = ACTIONS(865),
    [anon_sym_DASH_DASH] = ACTIONS(865),
    [anon_sym_QMARK] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(3446),
    [anon_sym_go] = ACTIONS(865),
    [anon_sym_spawn] = ACTIONS(865),
    [anon_sym_json_DOTdecode] = ACTIONS(865),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_LBRACK2] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(865),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT_DASH] = ACTIONS(865),
    [anon_sym_LT_LT] = ACTIONS(865),
    [anon_sym_GT_GT] = ACTIONS(865),
    [anon_sym_GT_GT_GT] = ACTIONS(865),
    [anon_sym_AMP_CARET] = ACTIONS(865),
    [anon_sym_AMP_AMP] = ACTIONS(865),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_or] = ACTIONS(865),
    [sym_none] = ACTIONS(865),
    [sym_true] = ACTIONS(865),
    [sym_false] = ACTIONS(865),
    [sym_nil] = ACTIONS(865),
    [anon_sym_QMARK_DOT] = ACTIONS(865),
    [anon_sym_POUND_LBRACK] = ACTIONS(865),
    [anon_sym_if] = ACTIONS(865),
    [anon_sym_DOLLARif] = ACTIONS(865),
    [anon_sym_is] = ACTIONS(865),
    [anon_sym_BANGis] = ACTIONS(865),
    [anon_sym_in] = ACTIONS(865),
    [anon_sym_BANGin] = ACTIONS(865),
    [anon_sym_match] = ACTIONS(865),
    [anon_sym_select] = ACTIONS(865),
    [anon_sym_lock] = ACTIONS(865),
    [anon_sym_rlock] = ACTIONS(865),
    [anon_sym_unsafe] = ACTIONS(865),
    [anon_sym_sql] = ACTIONS(865),
    [sym_int_literal] = ACTIONS(865),
    [sym_float_literal] = ACTIONS(865),
    [sym_rune_literal] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(865),
    [anon_sym_DQUOTE] = ACTIONS(865),
    [anon_sym_c_SQUOTE] = ACTIONS(865),
    [anon_sym_c_DQUOTE] = ACTIONS(865),
    [anon_sym_r_SQUOTE] = ACTIONS(865),
    [anon_sym_r_DQUOTE] = ACTIONS(865),
    [sym_pseudo_compile_time_identifier] = ACTIONS(865),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(351),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_assert] = ACTIONS(865),
    [anon_sym_defer] = ACTIONS(865),
    [anon_sym_goto] = ACTIONS(865),
    [anon_sym_break] = ACTIONS(865),
    [anon_sym_continue] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(865),
    [anon_sym_DOLLARfor] = ACTIONS(865),
    [anon_sym_for] = ACTIONS(865),
    [anon_sym_POUND] = ACTIONS(865),
    [anon_sym_asm] = ACTIONS(865),
  },
  [548] = {
    [sym_line_comment] = STATE(548),
    [sym_block_comment] = STATE(548),
    [sym_reference_expression] = STATE(4486),
    [sym_type_reference_expression] = STATE(1298),
    [sym_plain_type] = STATE(1312),
    [sym__plain_type_without_special] = STATE(1327),
    [sym_anon_struct_type] = STATE(1324),
    [sym_multi_return_type] = STATE(1327),
    [sym_result_type] = STATE(1327),
    [sym_option_type] = STATE(1327),
    [sym_qualified_type] = STATE(1298),
    [sym_fixed_array_type] = STATE(1324),
    [sym_array_type] = STATE(1324),
    [sym_pointer_type] = STATE(1324),
    [sym_wrong_pointer_type] = STATE(1324),
    [sym_map_type] = STATE(1324),
    [sym_channel_type] = STATE(1324),
    [sym_shared_type] = STATE(1324),
    [sym_thread_type] = STATE(1324),
    [sym_atomic_type] = STATE(1324),
    [sym_generic_type] = STATE(1324),
    [sym_function_type] = STATE(1324),
    [sym_identifier] = ACTIONS(3406),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_CR] = ACTIONS(821),
    [anon_sym_CR_LF] = ACTIONS(821),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(821),
    [anon_sym_DOT] = ACTIONS(821),
    [anon_sym_as] = ACTIONS(821),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_COMMA] = ACTIONS(821),
    [anon_sym_RBRACE] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(3408),
    [anon_sym_fn] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(821),
    [anon_sym_DASH] = ACTIONS(821),
    [anon_sym_STAR] = ACTIONS(3412),
    [anon_sym_SLASH] = ACTIONS(821),
    [anon_sym_PERCENT] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(821),
    [anon_sym_GT] = ACTIONS(821),
    [anon_sym_EQ_EQ] = ACTIONS(821),
    [anon_sym_BANG_EQ] = ACTIONS(821),
    [anon_sym_LT_EQ] = ACTIONS(821),
    [anon_sym_GT_EQ] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(817),
    [anon_sym_struct] = ACTIONS(3414),
    [anon_sym_mut] = ACTIONS(821),
    [anon_sym_PLUS_PLUS] = ACTIONS(821),
    [anon_sym_DASH_DASH] = ACTIONS(821),
    [anon_sym_QMARK] = ACTIONS(3416),
    [anon_sym_BANG] = ACTIONS(3418),
    [anon_sym_go] = ACTIONS(821),
    [anon_sym_spawn] = ACTIONS(821),
    [anon_sym_json_DOTdecode] = ACTIONS(821),
    [anon_sym_PIPE] = ACTIONS(821),
    [anon_sym_LBRACK2] = ACTIONS(3420),
    [anon_sym_TILDE] = ACTIONS(821),
    [anon_sym_CARET] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(3422),
    [anon_sym_LT_DASH] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(821),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_GT_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_CARET] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_or] = ACTIONS(821),
    [sym_none] = ACTIONS(821),
    [sym_true] = ACTIONS(821),
    [sym_false] = ACTIONS(821),
    [sym_nil] = ACTIONS(821),
    [anon_sym_QMARK_DOT] = ACTIONS(821),
    [anon_sym_POUND_LBRACK] = ACTIONS(821),
    [anon_sym_if] = ACTIONS(821),
    [anon_sym_DOLLARif] = ACTIONS(821),
    [anon_sym_is] = ACTIONS(821),
    [anon_sym_BANGis] = ACTIONS(821),
    [anon_sym_in] = ACTIONS(821),
    [anon_sym_BANGin] = ACTIONS(821),
    [anon_sym_match] = ACTIONS(821),
    [anon_sym_select] = ACTIONS(821),
    [anon_sym_lock] = ACTIONS(821),
    [anon_sym_rlock] = ACTIONS(821),
    [anon_sym_unsafe] = ACTIONS(821),
    [anon_sym_sql] = ACTIONS(821),
    [sym_int_literal] = ACTIONS(821),
    [sym_float_literal] = ACTIONS(821),
    [sym_rune_literal] = ACTIONS(821),
    [anon_sym_SQUOTE] = ACTIONS(821),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [anon_sym_c_SQUOTE] = ACTIONS(821),
    [anon_sym_c_DQUOTE] = ACTIONS(821),
    [anon_sym_r_SQUOTE] = ACTIONS(821),
    [anon_sym_r_DQUOTE] = ACTIONS(821),
    [sym_pseudo_compile_time_identifier] = ACTIONS(821),
    [anon_sym_shared] = ACTIONS(3424),
    [anon_sym_map_LBRACK] = ACTIONS(3426),
    [anon_sym_chan] = ACTIONS(3428),
    [anon_sym_thread] = ACTIONS(3430),
    [anon_sym_atomic] = ACTIONS(3432),
    [anon_sym_assert] = ACTIONS(821),
    [anon_sym_defer] = ACTIONS(821),
    [anon_sym_goto] = ACTIONS(821),
    [anon_sym_break] = ACTIONS(821),
    [anon_sym_continue] = ACTIONS(821),
    [anon_sym_return] = ACTIONS(821),
    [anon_sym_DOLLARfor] = ACTIONS(821),
    [anon_sym_for] = ACTIONS(821),
    [anon_sym_POUND] = ACTIONS(821),
    [anon_sym_asm] = ACTIONS(821),
  },
  [549] = {
    [sym_line_comment] = STATE(549),
    [sym_block_comment] = STATE(549),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3021),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3020),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_RBRACK] = ACTIONS(3448),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(3450),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [550] = {
    [sym_line_comment] = STATE(550),
    [sym_block_comment] = STATE(550),
    [sym__expression] = STATE(2620),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(884),
    [sym_mutable_expression] = STATE(3377),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [551] = {
    [sym_line_comment] = STATE(551),
    [sym_block_comment] = STATE(551),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2981),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3037),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_RBRACK] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(3454),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [552] = {
    [sym_line_comment] = STATE(552),
    [sym_block_comment] = STATE(552),
    [sym__expression] = STATE(2843),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_RBRACK] = ACTIONS(3456),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [553] = {
    [sym_line_comment] = STATE(553),
    [sym_block_comment] = STATE(553),
    [sym__expression] = STATE(2744),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(714),
    [sym_mutable_expression] = STATE(4522),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [554] = {
    [sym_line_comment] = STATE(554),
    [sym_block_comment] = STATE(554),
    [sym__expression] = STATE(2835),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [555] = {
    [sym_line_comment] = STATE(555),
    [sym_block_comment] = STATE(555),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3043),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3013),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_RBRACK] = ACTIONS(3478),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(3480),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [556] = {
    [sym_line_comment] = STATE(556),
    [sym_block_comment] = STATE(556),
    [sym__expression] = STATE(2726),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(714),
    [sym_mutable_expression] = STATE(4497),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [557] = {
    [sym_line_comment] = STATE(557),
    [sym_block_comment] = STATE(557),
    [sym__expression] = STATE(2720),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(714),
    [sym_mutable_expression] = STATE(4441),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [558] = {
    [sym_line_comment] = STATE(558),
    [sym_block_comment] = STATE(558),
    [sym__expression] = STATE(2710),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(714),
    [sym_mutable_expression] = STATE(4424),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [559] = {
    [sym_line_comment] = STATE(559),
    [sym_block_comment] = STATE(559),
    [sym__expression] = STATE(2755),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_RBRACK] = ACTIONS(3482),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [560] = {
    [sym_line_comment] = STATE(560),
    [sym_block_comment] = STATE(560),
    [sym__expression] = STATE(1978),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(966),
    [sym_mutable_expression] = STATE(3380),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(1165),
    [anon_sym_lock] = ACTIONS(1167),
    [anon_sym_rlock] = ACTIONS(1167),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [561] = {
    [sym_line_comment] = STATE(561),
    [sym_block_comment] = STATE(561),
    [sym__expression] = STATE(2704),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(714),
    [sym_mutable_expression] = STATE(4426),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [562] = {
    [sym_line_comment] = STATE(562),
    [sym_block_comment] = STATE(562),
    [sym__expression] = STATE(2745),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(3484),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [563] = {
    [sym_line_comment] = STATE(563),
    [sym_block_comment] = STATE(563),
    [sym__expression] = STATE(2700),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(714),
    [sym_mutable_expression] = STATE(4447),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [564] = {
    [sym_line_comment] = STATE(564),
    [sym_block_comment] = STATE(564),
    [sym__expression] = STATE(2551),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4270),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym__definite_range] = STATE(4683),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3486),
    [anon_sym_STAR] = ACTIONS(3488),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3490),
    [anon_sym_go] = ACTIONS(3492),
    [anon_sym_spawn] = ACTIONS(3494),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(3486),
    [anon_sym_CARET] = ACTIONS(3486),
    [anon_sym_AMP] = ACTIONS(3496),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3500),
    [anon_sym_lock] = ACTIONS(3502),
    [anon_sym_rlock] = ACTIONS(3502),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [565] = {
    [sym_line_comment] = STATE(565),
    [sym_block_comment] = STATE(565),
    [sym__expression] = STATE(2559),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(624),
    [sym_mutable_expression] = STATE(3377),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_go] = ACTIONS(2681),
    [anon_sym_spawn] = ACTIONS(2683),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_CARET] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2691),
    [anon_sym_lock] = ACTIONS(2693),
    [anon_sym_rlock] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [566] = {
    [sym_line_comment] = STATE(566),
    [sym_block_comment] = STATE(566),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2489),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(851),
    [anon_sym_LF] = ACTIONS(851),
    [anon_sym_CR] = ACTIONS(851),
    [anon_sym_CR_LF] = ACTIONS(851),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(851),
    [anon_sym_DOT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(851),
    [anon_sym_COMMA] = ACTIONS(851),
    [anon_sym_RBRACE] = ACTIONS(851),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_fn] = ACTIONS(851),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(851),
    [anon_sym_SLASH] = ACTIONS(851),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_struct] = ACTIONS(851),
    [anon_sym_mut] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(851),
    [anon_sym_DASH_DASH] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_go] = ACTIONS(851),
    [anon_sym_spawn] = ACTIONS(851),
    [anon_sym_json_DOTdecode] = ACTIONS(851),
    [anon_sym_PIPE] = ACTIONS(851),
    [anon_sym_LBRACK2] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_CARET] = ACTIONS(851),
    [anon_sym_AMP] = ACTIONS(851),
    [anon_sym_LT_DASH] = ACTIONS(851),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_CARET] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(851),
    [anon_sym_PIPE_PIPE] = ACTIONS(851),
    [anon_sym_or] = ACTIONS(851),
    [sym_none] = ACTIONS(851),
    [sym_true] = ACTIONS(851),
    [sym_false] = ACTIONS(851),
    [sym_nil] = ACTIONS(851),
    [anon_sym_QMARK_DOT] = ACTIONS(851),
    [anon_sym_POUND_LBRACK] = ACTIONS(851),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_DOLLARif] = ACTIONS(851),
    [anon_sym_is] = ACTIONS(851),
    [anon_sym_BANGis] = ACTIONS(851),
    [anon_sym_in] = ACTIONS(851),
    [anon_sym_BANGin] = ACTIONS(851),
    [anon_sym_match] = ACTIONS(851),
    [anon_sym_select] = ACTIONS(851),
    [anon_sym_lock] = ACTIONS(851),
    [anon_sym_rlock] = ACTIONS(851),
    [anon_sym_unsafe] = ACTIONS(851),
    [anon_sym_sql] = ACTIONS(851),
    [sym_int_literal] = ACTIONS(851),
    [sym_float_literal] = ACTIONS(851),
    [sym_rune_literal] = ACTIONS(851),
    [anon_sym_SQUOTE] = ACTIONS(851),
    [anon_sym_DQUOTE] = ACTIONS(851),
    [anon_sym_c_SQUOTE] = ACTIONS(851),
    [anon_sym_c_DQUOTE] = ACTIONS(851),
    [anon_sym_r_SQUOTE] = ACTIONS(851),
    [anon_sym_r_DQUOTE] = ACTIONS(851),
    [sym_pseudo_compile_time_identifier] = ACTIONS(851),
    [anon_sym_shared] = ACTIONS(851),
    [anon_sym_map_LBRACK] = ACTIONS(851),
    [anon_sym_chan] = ACTIONS(851),
    [anon_sym_thread] = ACTIONS(851),
    [anon_sym_atomic] = ACTIONS(851),
    [anon_sym_assert] = ACTIONS(851),
    [anon_sym_defer] = ACTIONS(851),
    [anon_sym_goto] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(851),
    [anon_sym_continue] = ACTIONS(851),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_DOLLARfor] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(851),
    [anon_sym_asm] = ACTIONS(851),
  },
  [567] = {
    [sym_line_comment] = STATE(567),
    [sym_block_comment] = STATE(567),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3035),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3058),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_RBRACK] = ACTIONS(3504),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(3506),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [568] = {
    [sym_line_comment] = STATE(568),
    [sym_block_comment] = STATE(568),
    [sym__expression] = STATE(2640),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(714),
    [sym_mutable_expression] = STATE(4468),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [569] = {
    [sym_line_comment] = STATE(569),
    [sym_block_comment] = STATE(569),
    [sym__expression] = STATE(2646),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(714),
    [sym_mutable_expression] = STATE(4489),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [570] = {
    [sym_line_comment] = STATE(570),
    [sym_block_comment] = STATE(570),
    [sym__expression] = STATE(2758),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(714),
    [sym_mutable_expression] = STATE(4592),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [571] = {
    [sym_line_comment] = STATE(571),
    [sym_block_comment] = STATE(571),
    [sym__expression] = STATE(2766),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(714),
    [sym_mutable_expression] = STATE(4596),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [572] = {
    [sym_line_comment] = STATE(572),
    [sym_block_comment] = STATE(572),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3059),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3056),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_RBRACK] = ACTIONS(3508),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(3510),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [573] = {
    [sym_line_comment] = STATE(573),
    [sym_block_comment] = STATE(573),
    [sym__expression] = STATE(242),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_mutability_modifiers] = STATE(952),
    [sym_mutable_expression] = STATE(1408),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(3514),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(325),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(3516),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [574] = {
    [sym_line_comment] = STATE(574),
    [sym_block_comment] = STATE(574),
    [sym__expression] = STATE(1132),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(621),
    [sym_mutable_expression] = STATE(1766),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2481),
    [anon_sym_go] = ACTIONS(775),
    [anon_sym_spawn] = ACTIONS(777),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_LT_DASH] = ACTIONS(2489),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(795),
    [anon_sym_lock] = ACTIONS(797),
    [anon_sym_rlock] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [575] = {
    [sym_line_comment] = STATE(575),
    [sym_block_comment] = STATE(575),
    [sym__expression] = STATE(2647),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(714),
    [sym_mutable_expression] = STATE(4510),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [576] = {
    [sym_line_comment] = STATE(576),
    [sym_block_comment] = STATE(576),
    [sym__expression] = STATE(2559),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(869),
    [sym_mutable_expression] = STATE(3377),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_go] = ACTIONS(2681),
    [anon_sym_spawn] = ACTIONS(2683),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_CARET] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2691),
    [anon_sym_lock] = ACTIONS(2693),
    [anon_sym_rlock] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [577] = {
    [sym_line_comment] = STATE(577),
    [sym_block_comment] = STATE(577),
    [sym__expression] = STATE(1270),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(619),
    [sym_mutable_expression] = STATE(1930),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [anon_sym_STAR] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_go] = ACTIONS(901),
    [anon_sym_spawn] = ACTIONS(903),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3208),
    [anon_sym_CARET] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_LT_DASH] = ACTIONS(3220),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(921),
    [anon_sym_lock] = ACTIONS(923),
    [anon_sym_rlock] = ACTIONS(923),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [578] = {
    [sym_line_comment] = STATE(578),
    [sym_block_comment] = STATE(578),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3025),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3024),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_RBRACK] = ACTIONS(3518),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(3520),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [579] = {
    [sym_line_comment] = STATE(579),
    [sym_block_comment] = STATE(579),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2990),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2989),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_RBRACK] = ACTIONS(3522),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(3524),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [580] = {
    [sym_line_comment] = STATE(580),
    [sym_block_comment] = STATE(580),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3031),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3016),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_RBRACK] = ACTIONS(3526),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(3528),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [581] = {
    [sym_line_comment] = STATE(581),
    [sym_block_comment] = STATE(581),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3039),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3018),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_RBRACK] = ACTIONS(3530),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(3532),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [582] = {
    [sym_line_comment] = STATE(582),
    [sym_block_comment] = STATE(582),
    [sym__expression] = STATE(993),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(918),
    [sym_mutable_expression] = STATE(1582),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3534),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(3536),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [583] = {
    [sym_line_comment] = STATE(583),
    [sym_block_comment] = STATE(583),
    [sym__expression] = STATE(2652),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(714),
    [sym_mutable_expression] = STATE(4531),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [584] = {
    [sym_line_comment] = STATE(584),
    [sym_block_comment] = STATE(584),
    [sym__expression] = STATE(2688),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(714),
    [sym_mutable_expression] = STATE(4547),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [585] = {
    [sym_line_comment] = STATE(585),
    [sym_block_comment] = STATE(585),
    [sym__expression] = STATE(1553),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4401),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [586] = {
    [sym_line_comment] = STATE(586),
    [sym_block_comment] = STATE(586),
    [sym__expression] = STATE(1997),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_go] = ACTIONS(3372),
    [anon_sym_spawn] = ACTIONS(3374),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_LT_DASH] = ACTIONS(3380),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(3382),
    [anon_sym_lock] = ACTIONS(3384),
    [anon_sym_rlock] = ACTIONS(3384),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [587] = {
    [sym_line_comment] = STATE(587),
    [sym_block_comment] = STATE(587),
    [sym__expression] = STATE(2528),
    [sym__expression_without_blocks] = STATE(2793),
    [sym__expression_with_blocks] = STATE(2793),
    [sym_inc_expression] = STATE(2880),
    [sym_dec_expression] = STATE(2880),
    [sym_or_block_expression] = STATE(2880),
    [sym_option_propagation_expression] = STATE(2880),
    [sym_result_propagation_expression] = STATE(2880),
    [sym_anon_struct_value_expression] = STATE(2785),
    [sym_go_expression] = STATE(2880),
    [sym_spawn_expression] = STATE(2880),
    [sym_parenthesized_expression] = STATE(2880),
    [sym_call_expression] = STATE(2880),
    [sym_type_initializer] = STATE(2785),
    [sym_function_literal] = STATE(2880),
    [sym_reference_expression] = STATE(2884),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2880),
    [sym_receive_expression] = STATE(2880),
    [sym_binary_expression] = STATE(2880),
    [sym_as_type_cast_expression] = STATE(2880),
    [sym__max_group] = STATE(2880),
    [sym_literal] = STATE(2877),
    [sym_map_init_expression] = STATE(2785),
    [sym_array_creation] = STATE(2880),
    [sym_fixed_array_creation] = STATE(2880),
    [sym_selector_expression] = STATE(2880),
    [sym_index_expression] = STATE(2880),
    [sym_slice_expression] = STATE(2880),
    [sym_if_expression] = STATE(2785),
    [sym_compile_time_if_expression] = STATE(2785),
    [sym_is_expression] = STATE(2880),
    [sym_in_expression] = STATE(2880),
    [sym_enum_fetch] = STATE(2880),
    [sym_match_expression] = STATE(2785),
    [sym_select_expression] = STATE(2785),
    [sym_lock_expression] = STATE(2785),
    [sym_unsafe_expression] = STATE(2785),
    [sym_sql_expression] = STATE(2785),
    [sym_interpreted_string_literal] = STATE(2854),
    [sym_c_string_literal] = STATE(2854),
    [sym_raw_string_literal] = STATE(2854),
    [sym_mutability_modifiers] = STATE(965),
    [sym_plain_type] = STATE(4266),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LPAREN] = ACTIONS(3544),
    [anon_sym_fn] = ACTIONS(3546),
    [anon_sym_PLUS] = ACTIONS(3548),
    [anon_sym_DASH] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3550),
    [anon_sym_struct] = ACTIONS(3552),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3554),
    [anon_sym_go] = ACTIONS(3556),
    [anon_sym_spawn] = ACTIONS(3558),
    [anon_sym_json_DOTdecode] = ACTIONS(3560),
    [anon_sym_LBRACK2] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3548),
    [anon_sym_CARET] = ACTIONS(3548),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_LT_DASH] = ACTIONS(3566),
    [sym_none] = ACTIONS(3568),
    [sym_true] = ACTIONS(3568),
    [sym_false] = ACTIONS(3568),
    [sym_nil] = ACTIONS(3568),
    [anon_sym_if] = ACTIONS(3570),
    [anon_sym_DOLLARif] = ACTIONS(3572),
    [anon_sym_match] = ACTIONS(3574),
    [anon_sym_select] = ACTIONS(3576),
    [anon_sym_lock] = ACTIONS(3578),
    [anon_sym_rlock] = ACTIONS(3578),
    [anon_sym_unsafe] = ACTIONS(3580),
    [anon_sym_sql] = ACTIONS(3582),
    [sym_int_literal] = ACTIONS(3568),
    [sym_float_literal] = ACTIONS(3584),
    [sym_rune_literal] = ACTIONS(3584),
    [anon_sym_SQUOTE] = ACTIONS(3586),
    [anon_sym_DQUOTE] = ACTIONS(3588),
    [anon_sym_c_SQUOTE] = ACTIONS(3590),
    [anon_sym_c_DQUOTE] = ACTIONS(3592),
    [anon_sym_r_SQUOTE] = ACTIONS(3594),
    [anon_sym_r_DQUOTE] = ACTIONS(3596),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3598),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [588] = {
    [sym_line_comment] = STATE(588),
    [sym_block_comment] = STATE(588),
    [sym__expression] = STATE(2371),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_DASH] = ACTIONS(3610),
    [anon_sym_STAR] = ACTIONS(3612),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_go] = ACTIONS(3618),
    [anon_sym_spawn] = ACTIONS(3620),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3610),
    [anon_sym_CARET] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3626),
    [anon_sym_LT_DASH] = ACTIONS(3628),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3638),
    [anon_sym_lock] = ACTIONS(3640),
    [anon_sym_rlock] = ACTIONS(3640),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [589] = {
    [sym_line_comment] = STATE(589),
    [sym_block_comment] = STATE(589),
    [sym__expression] = STATE(1968),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(1165),
    [anon_sym_lock] = ACTIONS(1167),
    [anon_sym_rlock] = ACTIONS(1167),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [590] = {
    [sym_line_comment] = STATE(590),
    [sym_block_comment] = STATE(590),
    [sym__expression] = STATE(2528),
    [sym__expression_without_blocks] = STATE(2793),
    [sym__expression_with_blocks] = STATE(2793),
    [sym_inc_expression] = STATE(2880),
    [sym_dec_expression] = STATE(2880),
    [sym_or_block_expression] = STATE(2880),
    [sym_option_propagation_expression] = STATE(2880),
    [sym_result_propagation_expression] = STATE(2880),
    [sym_anon_struct_value_expression] = STATE(2785),
    [sym_go_expression] = STATE(2880),
    [sym_spawn_expression] = STATE(2880),
    [sym_parenthesized_expression] = STATE(2880),
    [sym_call_expression] = STATE(2880),
    [sym_type_initializer] = STATE(2785),
    [sym_function_literal] = STATE(2880),
    [sym_reference_expression] = STATE(2884),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2880),
    [sym_receive_expression] = STATE(2880),
    [sym_binary_expression] = STATE(2880),
    [sym_as_type_cast_expression] = STATE(2880),
    [sym__max_group] = STATE(2880),
    [sym_literal] = STATE(2877),
    [sym_map_init_expression] = STATE(2785),
    [sym_array_creation] = STATE(2880),
    [sym_fixed_array_creation] = STATE(2880),
    [sym_selector_expression] = STATE(2880),
    [sym_index_expression] = STATE(2880),
    [sym_slice_expression] = STATE(2880),
    [sym_if_expression] = STATE(2785),
    [sym_compile_time_if_expression] = STATE(2785),
    [sym_is_expression] = STATE(2880),
    [sym_in_expression] = STATE(2880),
    [sym_enum_fetch] = STATE(2880),
    [sym_match_expression] = STATE(2785),
    [sym_select_expression] = STATE(2785),
    [sym_lock_expression] = STATE(2785),
    [sym_unsafe_expression] = STATE(2785),
    [sym_sql_expression] = STATE(2785),
    [sym_interpreted_string_literal] = STATE(2854),
    [sym_c_string_literal] = STATE(2854),
    [sym_raw_string_literal] = STATE(2854),
    [sym_mutability_modifiers] = STATE(965),
    [sym_plain_type] = STATE(4259),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LPAREN] = ACTIONS(3544),
    [anon_sym_fn] = ACTIONS(3546),
    [anon_sym_PLUS] = ACTIONS(3548),
    [anon_sym_DASH] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3550),
    [anon_sym_struct] = ACTIONS(3552),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3554),
    [anon_sym_go] = ACTIONS(3556),
    [anon_sym_spawn] = ACTIONS(3558),
    [anon_sym_json_DOTdecode] = ACTIONS(3560),
    [anon_sym_LBRACK2] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3548),
    [anon_sym_CARET] = ACTIONS(3548),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_LT_DASH] = ACTIONS(3566),
    [sym_none] = ACTIONS(3568),
    [sym_true] = ACTIONS(3568),
    [sym_false] = ACTIONS(3568),
    [sym_nil] = ACTIONS(3568),
    [anon_sym_if] = ACTIONS(3570),
    [anon_sym_DOLLARif] = ACTIONS(3572),
    [anon_sym_match] = ACTIONS(3574),
    [anon_sym_select] = ACTIONS(3576),
    [anon_sym_lock] = ACTIONS(3578),
    [anon_sym_rlock] = ACTIONS(3578),
    [anon_sym_unsafe] = ACTIONS(3580),
    [anon_sym_sql] = ACTIONS(3582),
    [sym_int_literal] = ACTIONS(3568),
    [sym_float_literal] = ACTIONS(3584),
    [sym_rune_literal] = ACTIONS(3584),
    [anon_sym_SQUOTE] = ACTIONS(3586),
    [anon_sym_DQUOTE] = ACTIONS(3588),
    [anon_sym_c_SQUOTE] = ACTIONS(3590),
    [anon_sym_c_DQUOTE] = ACTIONS(3592),
    [anon_sym_r_SQUOTE] = ACTIONS(3594),
    [anon_sym_r_DQUOTE] = ACTIONS(3596),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3598),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [591] = {
    [sym_line_comment] = STATE(591),
    [sym_block_comment] = STATE(591),
    [sym__expression] = STATE(2528),
    [sym__expression_without_blocks] = STATE(2793),
    [sym__expression_with_blocks] = STATE(2793),
    [sym_inc_expression] = STATE(2880),
    [sym_dec_expression] = STATE(2880),
    [sym_or_block_expression] = STATE(2880),
    [sym_option_propagation_expression] = STATE(2880),
    [sym_result_propagation_expression] = STATE(2880),
    [sym_anon_struct_value_expression] = STATE(2785),
    [sym_go_expression] = STATE(2880),
    [sym_spawn_expression] = STATE(2880),
    [sym_parenthesized_expression] = STATE(2880),
    [sym_call_expression] = STATE(2880),
    [sym_type_initializer] = STATE(2785),
    [sym_function_literal] = STATE(2880),
    [sym_reference_expression] = STATE(2884),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2880),
    [sym_receive_expression] = STATE(2880),
    [sym_binary_expression] = STATE(2880),
    [sym_as_type_cast_expression] = STATE(2880),
    [sym__max_group] = STATE(2880),
    [sym_literal] = STATE(2877),
    [sym_map_init_expression] = STATE(2785),
    [sym_array_creation] = STATE(2880),
    [sym_fixed_array_creation] = STATE(2880),
    [sym_selector_expression] = STATE(2880),
    [sym_index_expression] = STATE(2880),
    [sym_slice_expression] = STATE(2880),
    [sym_if_expression] = STATE(2785),
    [sym_compile_time_if_expression] = STATE(2785),
    [sym_is_expression] = STATE(2880),
    [sym_in_expression] = STATE(2880),
    [sym_enum_fetch] = STATE(2880),
    [sym_match_expression] = STATE(2785),
    [sym_select_expression] = STATE(2785),
    [sym_lock_expression] = STATE(2785),
    [sym_unsafe_expression] = STATE(2785),
    [sym_sql_expression] = STATE(2785),
    [sym_interpreted_string_literal] = STATE(2854),
    [sym_c_string_literal] = STATE(2854),
    [sym_raw_string_literal] = STATE(2854),
    [sym_mutability_modifiers] = STATE(965),
    [sym_plain_type] = STATE(4260),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LPAREN] = ACTIONS(3544),
    [anon_sym_fn] = ACTIONS(3546),
    [anon_sym_PLUS] = ACTIONS(3548),
    [anon_sym_DASH] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3550),
    [anon_sym_struct] = ACTIONS(3552),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3554),
    [anon_sym_go] = ACTIONS(3556),
    [anon_sym_spawn] = ACTIONS(3558),
    [anon_sym_json_DOTdecode] = ACTIONS(3560),
    [anon_sym_LBRACK2] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3548),
    [anon_sym_CARET] = ACTIONS(3548),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_LT_DASH] = ACTIONS(3566),
    [sym_none] = ACTIONS(3568),
    [sym_true] = ACTIONS(3568),
    [sym_false] = ACTIONS(3568),
    [sym_nil] = ACTIONS(3568),
    [anon_sym_if] = ACTIONS(3570),
    [anon_sym_DOLLARif] = ACTIONS(3572),
    [anon_sym_match] = ACTIONS(3574),
    [anon_sym_select] = ACTIONS(3576),
    [anon_sym_lock] = ACTIONS(3578),
    [anon_sym_rlock] = ACTIONS(3578),
    [anon_sym_unsafe] = ACTIONS(3580),
    [anon_sym_sql] = ACTIONS(3582),
    [sym_int_literal] = ACTIONS(3568),
    [sym_float_literal] = ACTIONS(3584),
    [sym_rune_literal] = ACTIONS(3584),
    [anon_sym_SQUOTE] = ACTIONS(3586),
    [anon_sym_DQUOTE] = ACTIONS(3588),
    [anon_sym_c_SQUOTE] = ACTIONS(3590),
    [anon_sym_c_DQUOTE] = ACTIONS(3592),
    [anon_sym_r_SQUOTE] = ACTIONS(3594),
    [anon_sym_r_DQUOTE] = ACTIONS(3596),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3598),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [592] = {
    [sym_line_comment] = STATE(592),
    [sym_block_comment] = STATE(592),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [593] = {
    [sym_line_comment] = STATE(593),
    [sym_block_comment] = STATE(593),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(3662),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [594] = {
    [sym_line_comment] = STATE(594),
    [sym_block_comment] = STATE(594),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(3683),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [595] = {
    [sym_line_comment] = STATE(595),
    [sym_block_comment] = STATE(595),
    [sym__expression] = STATE(1981),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(1165),
    [anon_sym_lock] = ACTIONS(1167),
    [anon_sym_rlock] = ACTIONS(1167),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [596] = {
    [sym_line_comment] = STATE(596),
    [sym_block_comment] = STATE(596),
    [sym__expression] = STATE(2520),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(3885),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3486),
    [anon_sym_STAR] = ACTIONS(3488),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3490),
    [anon_sym_go] = ACTIONS(3492),
    [anon_sym_spawn] = ACTIONS(3494),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(3486),
    [anon_sym_CARET] = ACTIONS(3486),
    [anon_sym_AMP] = ACTIONS(3496),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3500),
    [anon_sym_lock] = ACTIONS(3502),
    [anon_sym_rlock] = ACTIONS(3502),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [597] = {
    [sym_line_comment] = STATE(597),
    [sym_block_comment] = STATE(597),
    [sym__expression] = STATE(2575),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [598] = {
    [sym_line_comment] = STATE(598),
    [sym_block_comment] = STATE(598),
    [sym__expression] = STATE(2839),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [599] = {
    [sym_line_comment] = STATE(599),
    [sym_block_comment] = STATE(599),
    [sym__expression] = STATE(2541),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_go] = ACTIONS(2681),
    [anon_sym_spawn] = ACTIONS(2683),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_CARET] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2691),
    [anon_sym_lock] = ACTIONS(2693),
    [anon_sym_rlock] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [600] = {
    [sym_line_comment] = STATE(600),
    [sym_block_comment] = STATE(600),
    [sym__expression] = STATE(2520),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(3883),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3486),
    [anon_sym_STAR] = ACTIONS(3488),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3490),
    [anon_sym_go] = ACTIONS(3492),
    [anon_sym_spawn] = ACTIONS(3494),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(3486),
    [anon_sym_CARET] = ACTIONS(3486),
    [anon_sym_AMP] = ACTIONS(3496),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3500),
    [anon_sym_lock] = ACTIONS(3502),
    [anon_sym_rlock] = ACTIONS(3502),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [601] = {
    [sym_line_comment] = STATE(601),
    [sym_block_comment] = STATE(601),
    [sym__expression] = STATE(2542),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [602] = {
    [sym_line_comment] = STATE(602),
    [sym_block_comment] = STATE(602),
    [sym__expression] = STATE(2520),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(3878),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3486),
    [anon_sym_STAR] = ACTIONS(3488),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3490),
    [anon_sym_go] = ACTIONS(3492),
    [anon_sym_spawn] = ACTIONS(3494),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(3486),
    [anon_sym_CARET] = ACTIONS(3486),
    [anon_sym_AMP] = ACTIONS(3496),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3500),
    [anon_sym_lock] = ACTIONS(3502),
    [anon_sym_rlock] = ACTIONS(3502),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [603] = {
    [sym_line_comment] = STATE(603),
    [sym_block_comment] = STATE(603),
    [sym__expression] = STATE(1969),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(1165),
    [anon_sym_lock] = ACTIONS(1167),
    [anon_sym_rlock] = ACTIONS(1167),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [604] = {
    [sym_line_comment] = STATE(604),
    [sym_block_comment] = STATE(604),
    [sym__expression] = STATE(1977),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(1165),
    [anon_sym_lock] = ACTIONS(1167),
    [anon_sym_rlock] = ACTIONS(1167),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [605] = {
    [sym_line_comment] = STATE(605),
    [sym_block_comment] = STATE(605),
    [sym__expression] = STATE(1974),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(1165),
    [anon_sym_lock] = ACTIONS(1167),
    [anon_sym_rlock] = ACTIONS(1167),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [606] = {
    [sym_line_comment] = STATE(606),
    [sym_block_comment] = STATE(606),
    [sym__expression] = STATE(2885),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3689),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(2415),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2417),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2423),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [607] = {
    [sym_line_comment] = STATE(607),
    [sym_block_comment] = STATE(607),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(3692),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [608] = {
    [sym_line_comment] = STATE(608),
    [sym_block_comment] = STATE(608),
    [sym__expression] = STATE(2586),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [609] = {
    [sym_line_comment] = STATE(609),
    [sym_block_comment] = STATE(609),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2991),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2992),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [610] = {
    [sym_line_comment] = STATE(610),
    [sym_block_comment] = STATE(610),
    [sym__expression] = STATE(2759),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [611] = {
    [sym_line_comment] = STATE(611),
    [sym_block_comment] = STATE(611),
    [sym__expression] = STATE(2563),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_go] = ACTIONS(2681),
    [anon_sym_spawn] = ACTIONS(2683),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_CARET] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2691),
    [anon_sym_lock] = ACTIONS(2693),
    [anon_sym_rlock] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [612] = {
    [sym_line_comment] = STATE(612),
    [sym_block_comment] = STATE(612),
    [sym__expression] = STATE(2383),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_go] = ACTIONS(2681),
    [anon_sym_spawn] = ACTIONS(2683),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_CARET] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2691),
    [anon_sym_lock] = ACTIONS(2693),
    [anon_sym_rlock] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [613] = {
    [sym_line_comment] = STATE(613),
    [sym_block_comment] = STATE(613),
    [sym__expression] = STATE(2520),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(3885),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3390),
    [anon_sym_lock] = ACTIONS(3392),
    [anon_sym_rlock] = ACTIONS(3392),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [614] = {
    [sym_line_comment] = STATE(614),
    [sym_block_comment] = STATE(614),
    [sym__expression] = STATE(2560),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_go] = ACTIONS(2681),
    [anon_sym_spawn] = ACTIONS(2683),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_CARET] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2691),
    [anon_sym_lock] = ACTIONS(2693),
    [anon_sym_rlock] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [615] = {
    [sym_line_comment] = STATE(615),
    [sym_block_comment] = STATE(615),
    [sym__expression] = STATE(2555),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_go] = ACTIONS(2681),
    [anon_sym_spawn] = ACTIONS(2683),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_CARET] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2691),
    [anon_sym_lock] = ACTIONS(2693),
    [anon_sym_rlock] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [616] = {
    [sym_line_comment] = STATE(616),
    [sym_block_comment] = STATE(616),
    [sym__expression] = STATE(2375),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [617] = {
    [sym_line_comment] = STATE(617),
    [sym_block_comment] = STATE(617),
    [sym__expression] = STATE(2570),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_go] = ACTIONS(2681),
    [anon_sym_spawn] = ACTIONS(2683),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_CARET] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2691),
    [anon_sym_lock] = ACTIONS(2693),
    [anon_sym_rlock] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [618] = {
    [sym_line_comment] = STATE(618),
    [sym_block_comment] = STATE(618),
    [sym__expression] = STATE(2520),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(3878),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3390),
    [anon_sym_lock] = ACTIONS(3392),
    [anon_sym_rlock] = ACTIONS(3392),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [619] = {
    [sym_line_comment] = STATE(619),
    [sym_block_comment] = STATE(619),
    [sym__expression] = STATE(1273),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [anon_sym_STAR] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_go] = ACTIONS(901),
    [anon_sym_spawn] = ACTIONS(903),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3208),
    [anon_sym_CARET] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_LT_DASH] = ACTIONS(3220),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(921),
    [anon_sym_lock] = ACTIONS(923),
    [anon_sym_rlock] = ACTIONS(923),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [620] = {
    [sym_line_comment] = STATE(620),
    [sym_block_comment] = STATE(620),
    [sym__expression] = STATE(2728),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [621] = {
    [sym_line_comment] = STATE(621),
    [sym_block_comment] = STATE(621),
    [sym__expression] = STATE(1122),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2481),
    [anon_sym_go] = ACTIONS(775),
    [anon_sym_spawn] = ACTIONS(777),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_LT_DASH] = ACTIONS(2489),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(795),
    [anon_sym_lock] = ACTIONS(797),
    [anon_sym_rlock] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [622] = {
    [sym_line_comment] = STATE(622),
    [sym_block_comment] = STATE(622),
    [sym__expression] = STATE(1555),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [623] = {
    [sym_line_comment] = STATE(623),
    [sym_block_comment] = STATE(623),
    [sym__expression] = STATE(1553),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4404),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [624] = {
    [sym_line_comment] = STATE(624),
    [sym_block_comment] = STATE(624),
    [sym__expression] = STATE(2587),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_go] = ACTIONS(2681),
    [anon_sym_spawn] = ACTIONS(2683),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_CARET] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2691),
    [anon_sym_lock] = ACTIONS(2693),
    [anon_sym_rlock] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [625] = {
    [sym_line_comment] = STATE(625),
    [sym_block_comment] = STATE(625),
    [sym__expression] = STATE(1562),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [626] = {
    [sym_line_comment] = STATE(626),
    [sym_block_comment] = STATE(626),
    [sym__expression] = STATE(2518),
    [sym__expression_without_blocks] = STATE(2793),
    [sym__expression_with_blocks] = STATE(2793),
    [sym_inc_expression] = STATE(2880),
    [sym_dec_expression] = STATE(2880),
    [sym_or_block_expression] = STATE(2880),
    [sym_option_propagation_expression] = STATE(2880),
    [sym_result_propagation_expression] = STATE(2880),
    [sym_anon_struct_value_expression] = STATE(2785),
    [sym_go_expression] = STATE(2880),
    [sym_spawn_expression] = STATE(2880),
    [sym_parenthesized_expression] = STATE(2880),
    [sym_call_expression] = STATE(2880),
    [sym_type_initializer] = STATE(2785),
    [sym_function_literal] = STATE(2880),
    [sym_reference_expression] = STATE(2884),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2880),
    [sym_receive_expression] = STATE(2880),
    [sym_binary_expression] = STATE(2880),
    [sym_as_type_cast_expression] = STATE(2880),
    [sym__max_group] = STATE(2880),
    [sym_literal] = STATE(2877),
    [sym_map_init_expression] = STATE(2785),
    [sym_array_creation] = STATE(2880),
    [sym_fixed_array_creation] = STATE(2880),
    [sym_selector_expression] = STATE(2880),
    [sym_index_expression] = STATE(2880),
    [sym_slice_expression] = STATE(2880),
    [sym_if_expression] = STATE(2785),
    [sym_compile_time_if_expression] = STATE(2785),
    [sym_is_expression] = STATE(2880),
    [sym_in_expression] = STATE(2880),
    [sym_enum_fetch] = STATE(2880),
    [sym_match_expression] = STATE(2785),
    [sym_select_expression] = STATE(2785),
    [sym_lock_expression] = STATE(2785),
    [sym_unsafe_expression] = STATE(2785),
    [sym_sql_expression] = STATE(2785),
    [sym_interpreted_string_literal] = STATE(2854),
    [sym_c_string_literal] = STATE(2854),
    [sym_raw_string_literal] = STATE(2854),
    [sym_mutability_modifiers] = STATE(965),
    [sym_plain_type] = STATE(4143),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LPAREN] = ACTIONS(3544),
    [anon_sym_fn] = ACTIONS(3546),
    [anon_sym_PLUS] = ACTIONS(3548),
    [anon_sym_DASH] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3550),
    [anon_sym_struct] = ACTIONS(3552),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3554),
    [anon_sym_go] = ACTIONS(3556),
    [anon_sym_spawn] = ACTIONS(3558),
    [anon_sym_json_DOTdecode] = ACTIONS(3560),
    [anon_sym_LBRACK2] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3548),
    [anon_sym_CARET] = ACTIONS(3548),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_LT_DASH] = ACTIONS(3566),
    [sym_none] = ACTIONS(3568),
    [sym_true] = ACTIONS(3568),
    [sym_false] = ACTIONS(3568),
    [sym_nil] = ACTIONS(3568),
    [anon_sym_if] = ACTIONS(3570),
    [anon_sym_DOLLARif] = ACTIONS(3572),
    [anon_sym_match] = ACTIONS(3574),
    [anon_sym_select] = ACTIONS(3576),
    [anon_sym_lock] = ACTIONS(3578),
    [anon_sym_rlock] = ACTIONS(3578),
    [anon_sym_unsafe] = ACTIONS(3580),
    [anon_sym_sql] = ACTIONS(3582),
    [sym_int_literal] = ACTIONS(3568),
    [sym_float_literal] = ACTIONS(3584),
    [sym_rune_literal] = ACTIONS(3584),
    [anon_sym_SQUOTE] = ACTIONS(3586),
    [anon_sym_DQUOTE] = ACTIONS(3588),
    [anon_sym_c_SQUOTE] = ACTIONS(3590),
    [anon_sym_c_DQUOTE] = ACTIONS(3592),
    [anon_sym_r_SQUOTE] = ACTIONS(3594),
    [anon_sym_r_DQUOTE] = ACTIONS(3596),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3598),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [627] = {
    [sym_line_comment] = STATE(627),
    [sym_block_comment] = STATE(627),
    [sym__expression] = STATE(2236),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4306),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_DASH] = ACTIONS(3610),
    [anon_sym_STAR] = ACTIONS(3612),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_go] = ACTIONS(3618),
    [anon_sym_spawn] = ACTIONS(3620),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3610),
    [anon_sym_CARET] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3626),
    [anon_sym_LT_DASH] = ACTIONS(3628),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3638),
    [anon_sym_lock] = ACTIONS(3640),
    [anon_sym_rlock] = ACTIONS(3640),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [628] = {
    [sym_line_comment] = STATE(628),
    [sym_block_comment] = STATE(628),
    [sym__expression] = STATE(2917),
    [sym__expression_without_blocks] = STATE(2235),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [629] = {
    [sym_line_comment] = STATE(629),
    [sym_block_comment] = STATE(629),
    [sym__expression] = STATE(2531),
    [sym__expression_without_blocks] = STATE(2793),
    [sym__expression_with_blocks] = STATE(2793),
    [sym_inc_expression] = STATE(2880),
    [sym_dec_expression] = STATE(2880),
    [sym_or_block_expression] = STATE(2880),
    [sym_option_propagation_expression] = STATE(2880),
    [sym_result_propagation_expression] = STATE(2880),
    [sym_anon_struct_value_expression] = STATE(2785),
    [sym_go_expression] = STATE(2880),
    [sym_spawn_expression] = STATE(2880),
    [sym_parenthesized_expression] = STATE(2880),
    [sym_call_expression] = STATE(2880),
    [sym_type_initializer] = STATE(2785),
    [sym_function_literal] = STATE(2880),
    [sym_reference_expression] = STATE(2884),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2880),
    [sym_receive_expression] = STATE(2880),
    [sym_binary_expression] = STATE(2880),
    [sym_as_type_cast_expression] = STATE(2880),
    [sym__max_group] = STATE(2880),
    [sym_literal] = STATE(2877),
    [sym_map_init_expression] = STATE(2785),
    [sym_array_creation] = STATE(2880),
    [sym_fixed_array_creation] = STATE(2880),
    [sym_selector_expression] = STATE(2880),
    [sym_index_expression] = STATE(2880),
    [sym_slice_expression] = STATE(2880),
    [sym_if_expression] = STATE(2785),
    [sym_compile_time_if_expression] = STATE(2785),
    [sym_is_expression] = STATE(2880),
    [sym_in_expression] = STATE(2880),
    [sym_enum_fetch] = STATE(2880),
    [sym_match_expression] = STATE(2785),
    [sym_select_expression] = STATE(2785),
    [sym_lock_expression] = STATE(2785),
    [sym_unsafe_expression] = STATE(2785),
    [sym_sql_expression] = STATE(2785),
    [sym_interpreted_string_literal] = STATE(2854),
    [sym_c_string_literal] = STATE(2854),
    [sym_raw_string_literal] = STATE(2854),
    [sym_mutability_modifiers] = STATE(965),
    [sym_plain_type] = STATE(4143),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LPAREN] = ACTIONS(3544),
    [anon_sym_fn] = ACTIONS(3546),
    [anon_sym_PLUS] = ACTIONS(3548),
    [anon_sym_DASH] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3550),
    [anon_sym_struct] = ACTIONS(3552),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3554),
    [anon_sym_go] = ACTIONS(3556),
    [anon_sym_spawn] = ACTIONS(3558),
    [anon_sym_json_DOTdecode] = ACTIONS(3560),
    [anon_sym_LBRACK2] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3548),
    [anon_sym_CARET] = ACTIONS(3548),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_LT_DASH] = ACTIONS(3566),
    [sym_none] = ACTIONS(3568),
    [sym_true] = ACTIONS(3568),
    [sym_false] = ACTIONS(3568),
    [sym_nil] = ACTIONS(3568),
    [anon_sym_if] = ACTIONS(3570),
    [anon_sym_DOLLARif] = ACTIONS(3572),
    [anon_sym_match] = ACTIONS(3574),
    [anon_sym_select] = ACTIONS(3576),
    [anon_sym_lock] = ACTIONS(3578),
    [anon_sym_rlock] = ACTIONS(3578),
    [anon_sym_unsafe] = ACTIONS(3580),
    [anon_sym_sql] = ACTIONS(3582),
    [sym_int_literal] = ACTIONS(3568),
    [sym_float_literal] = ACTIONS(3584),
    [sym_rune_literal] = ACTIONS(3584),
    [anon_sym_SQUOTE] = ACTIONS(3586),
    [anon_sym_DQUOTE] = ACTIONS(3588),
    [anon_sym_c_SQUOTE] = ACTIONS(3590),
    [anon_sym_c_DQUOTE] = ACTIONS(3592),
    [anon_sym_r_SQUOTE] = ACTIONS(3594),
    [anon_sym_r_DQUOTE] = ACTIONS(3596),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3598),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [630] = {
    [sym_line_comment] = STATE(630),
    [sym_block_comment] = STATE(630),
    [sym__expression] = STATE(1120),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(3668),
    [anon_sym_DASH] = ACTIONS(3668),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3672),
    [anon_sym_go] = ACTIONS(3674),
    [anon_sym_spawn] = ACTIONS(3676),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_DASH] = ACTIONS(3680),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(3682),
    [anon_sym_lock] = ACTIONS(3684),
    [anon_sym_rlock] = ACTIONS(3684),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [631] = {
    [sym_line_comment] = STATE(631),
    [sym_block_comment] = STATE(631),
    [sym__expression] = STATE(1575),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [632] = {
    [sym_line_comment] = STATE(632),
    [sym_block_comment] = STATE(632),
    [sym__expression] = STATE(2539),
    [sym__expression_without_blocks] = STATE(2793),
    [sym__expression_with_blocks] = STATE(2793),
    [sym_inc_expression] = STATE(2880),
    [sym_dec_expression] = STATE(2880),
    [sym_or_block_expression] = STATE(2880),
    [sym_option_propagation_expression] = STATE(2880),
    [sym_result_propagation_expression] = STATE(2880),
    [sym_anon_struct_value_expression] = STATE(2785),
    [sym_go_expression] = STATE(2880),
    [sym_spawn_expression] = STATE(2880),
    [sym_parenthesized_expression] = STATE(2880),
    [sym_call_expression] = STATE(2880),
    [sym_type_initializer] = STATE(2785),
    [sym_function_literal] = STATE(2880),
    [sym_reference_expression] = STATE(2884),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2880),
    [sym_receive_expression] = STATE(2880),
    [sym_binary_expression] = STATE(2880),
    [sym_as_type_cast_expression] = STATE(2880),
    [sym__max_group] = STATE(2880),
    [sym_literal] = STATE(2877),
    [sym_map_init_expression] = STATE(2785),
    [sym_array_creation] = STATE(2880),
    [sym_fixed_array_creation] = STATE(2880),
    [sym_selector_expression] = STATE(2880),
    [sym_index_expression] = STATE(2880),
    [sym_slice_expression] = STATE(2880),
    [sym_if_expression] = STATE(2785),
    [sym_compile_time_if_expression] = STATE(2785),
    [sym_is_expression] = STATE(2880),
    [sym_in_expression] = STATE(2880),
    [sym_enum_fetch] = STATE(2880),
    [sym_match_expression] = STATE(2785),
    [sym_select_expression] = STATE(2785),
    [sym_lock_expression] = STATE(2785),
    [sym_unsafe_expression] = STATE(2785),
    [sym_sql_expression] = STATE(2785),
    [sym_interpreted_string_literal] = STATE(2854),
    [sym_c_string_literal] = STATE(2854),
    [sym_raw_string_literal] = STATE(2854),
    [sym_mutability_modifiers] = STATE(965),
    [sym_plain_type] = STATE(4143),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LPAREN] = ACTIONS(3544),
    [anon_sym_fn] = ACTIONS(3546),
    [anon_sym_PLUS] = ACTIONS(3548),
    [anon_sym_DASH] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3550),
    [anon_sym_struct] = ACTIONS(3552),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3554),
    [anon_sym_go] = ACTIONS(3556),
    [anon_sym_spawn] = ACTIONS(3558),
    [anon_sym_json_DOTdecode] = ACTIONS(3560),
    [anon_sym_LBRACK2] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3548),
    [anon_sym_CARET] = ACTIONS(3548),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_LT_DASH] = ACTIONS(3566),
    [sym_none] = ACTIONS(3568),
    [sym_true] = ACTIONS(3568),
    [sym_false] = ACTIONS(3568),
    [sym_nil] = ACTIONS(3568),
    [anon_sym_if] = ACTIONS(3570),
    [anon_sym_DOLLARif] = ACTIONS(3572),
    [anon_sym_match] = ACTIONS(3574),
    [anon_sym_select] = ACTIONS(3576),
    [anon_sym_lock] = ACTIONS(3578),
    [anon_sym_rlock] = ACTIONS(3578),
    [anon_sym_unsafe] = ACTIONS(3580),
    [anon_sym_sql] = ACTIONS(3582),
    [sym_int_literal] = ACTIONS(3568),
    [sym_float_literal] = ACTIONS(3584),
    [sym_rune_literal] = ACTIONS(3584),
    [anon_sym_SQUOTE] = ACTIONS(3586),
    [anon_sym_DQUOTE] = ACTIONS(3588),
    [anon_sym_c_SQUOTE] = ACTIONS(3590),
    [anon_sym_c_DQUOTE] = ACTIONS(3592),
    [anon_sym_r_SQUOTE] = ACTIONS(3594),
    [anon_sym_r_DQUOTE] = ACTIONS(3596),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3598),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [633] = {
    [sym_line_comment] = STATE(633),
    [sym_block_comment] = STATE(633),
    [sym__expression] = STATE(1120),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4335),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(3668),
    [anon_sym_DASH] = ACTIONS(3668),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3672),
    [anon_sym_go] = ACTIONS(3674),
    [anon_sym_spawn] = ACTIONS(3676),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_DASH] = ACTIONS(3680),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(3682),
    [anon_sym_lock] = ACTIONS(3684),
    [anon_sym_rlock] = ACTIONS(3684),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [634] = {
    [sym_line_comment] = STATE(634),
    [sym_block_comment] = STATE(634),
    [sym__expression] = STATE(1120),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4236),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(3668),
    [anon_sym_DASH] = ACTIONS(3668),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3672),
    [anon_sym_go] = ACTIONS(3674),
    [anon_sym_spawn] = ACTIONS(3676),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_DASH] = ACTIONS(3680),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(3682),
    [anon_sym_lock] = ACTIONS(3684),
    [anon_sym_rlock] = ACTIONS(3684),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [635] = {
    [sym_line_comment] = STATE(635),
    [sym_block_comment] = STATE(635),
    [sym__expression] = STATE(2236),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4303),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_DASH] = ACTIONS(3610),
    [anon_sym_STAR] = ACTIONS(3612),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_go] = ACTIONS(3618),
    [anon_sym_spawn] = ACTIONS(3620),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3610),
    [anon_sym_CARET] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3626),
    [anon_sym_LT_DASH] = ACTIONS(3628),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3638),
    [anon_sym_lock] = ACTIONS(3640),
    [anon_sym_rlock] = ACTIONS(3640),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [636] = {
    [sym_line_comment] = STATE(636),
    [sym_block_comment] = STATE(636),
    [sym__expression] = STATE(2236),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4297),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_DASH] = ACTIONS(3610),
    [anon_sym_STAR] = ACTIONS(3612),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_go] = ACTIONS(3618),
    [anon_sym_spawn] = ACTIONS(3620),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3610),
    [anon_sym_CARET] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3626),
    [anon_sym_LT_DASH] = ACTIONS(3628),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3638),
    [anon_sym_lock] = ACTIONS(3640),
    [anon_sym_rlock] = ACTIONS(3640),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [637] = {
    [sym_line_comment] = STATE(637),
    [sym_block_comment] = STATE(637),
    [sym__expression] = STATE(2528),
    [sym__expression_without_blocks] = STATE(2793),
    [sym__expression_with_blocks] = STATE(2793),
    [sym_inc_expression] = STATE(2880),
    [sym_dec_expression] = STATE(2880),
    [sym_or_block_expression] = STATE(2880),
    [sym_option_propagation_expression] = STATE(2880),
    [sym_result_propagation_expression] = STATE(2880),
    [sym_anon_struct_value_expression] = STATE(2785),
    [sym_go_expression] = STATE(2880),
    [sym_spawn_expression] = STATE(2880),
    [sym_parenthesized_expression] = STATE(2880),
    [sym_call_expression] = STATE(2880),
    [sym_type_initializer] = STATE(2785),
    [sym_function_literal] = STATE(2880),
    [sym_reference_expression] = STATE(2884),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2880),
    [sym_receive_expression] = STATE(2880),
    [sym_binary_expression] = STATE(2880),
    [sym_as_type_cast_expression] = STATE(2880),
    [sym__max_group] = STATE(2880),
    [sym_literal] = STATE(2877),
    [sym_map_init_expression] = STATE(2785),
    [sym_array_creation] = STATE(2880),
    [sym_fixed_array_creation] = STATE(2880),
    [sym_selector_expression] = STATE(2880),
    [sym_index_expression] = STATE(2880),
    [sym_slice_expression] = STATE(2880),
    [sym_if_expression] = STATE(2785),
    [sym_compile_time_if_expression] = STATE(2785),
    [sym_is_expression] = STATE(2880),
    [sym_in_expression] = STATE(2880),
    [sym_enum_fetch] = STATE(2880),
    [sym_match_expression] = STATE(2785),
    [sym_select_expression] = STATE(2785),
    [sym_lock_expression] = STATE(2785),
    [sym_unsafe_expression] = STATE(2785),
    [sym_sql_expression] = STATE(2785),
    [sym_interpreted_string_literal] = STATE(2854),
    [sym_c_string_literal] = STATE(2854),
    [sym_raw_string_literal] = STATE(2854),
    [sym_mutability_modifiers] = STATE(965),
    [sym_plain_type] = STATE(4143),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LPAREN] = ACTIONS(3544),
    [anon_sym_fn] = ACTIONS(3546),
    [anon_sym_PLUS] = ACTIONS(3548),
    [anon_sym_DASH] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3550),
    [anon_sym_struct] = ACTIONS(3552),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3554),
    [anon_sym_go] = ACTIONS(3556),
    [anon_sym_spawn] = ACTIONS(3558),
    [anon_sym_json_DOTdecode] = ACTIONS(3560),
    [anon_sym_LBRACK2] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3548),
    [anon_sym_CARET] = ACTIONS(3548),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_LT_DASH] = ACTIONS(3566),
    [sym_none] = ACTIONS(3568),
    [sym_true] = ACTIONS(3568),
    [sym_false] = ACTIONS(3568),
    [sym_nil] = ACTIONS(3568),
    [anon_sym_if] = ACTIONS(3570),
    [anon_sym_DOLLARif] = ACTIONS(3572),
    [anon_sym_match] = ACTIONS(3574),
    [anon_sym_select] = ACTIONS(3576),
    [anon_sym_lock] = ACTIONS(3578),
    [anon_sym_rlock] = ACTIONS(3578),
    [anon_sym_unsafe] = ACTIONS(3580),
    [anon_sym_sql] = ACTIONS(3582),
    [sym_int_literal] = ACTIONS(3568),
    [sym_float_literal] = ACTIONS(3584),
    [sym_rune_literal] = ACTIONS(3584),
    [anon_sym_SQUOTE] = ACTIONS(3586),
    [anon_sym_DQUOTE] = ACTIONS(3588),
    [anon_sym_c_SQUOTE] = ACTIONS(3590),
    [anon_sym_c_DQUOTE] = ACTIONS(3592),
    [anon_sym_r_SQUOTE] = ACTIONS(3594),
    [anon_sym_r_DQUOTE] = ACTIONS(3596),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3598),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [638] = {
    [sym_line_comment] = STATE(638),
    [sym_block_comment] = STATE(638),
    [sym__expression] = STATE(1134),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(3668),
    [anon_sym_DASH] = ACTIONS(3668),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3672),
    [anon_sym_go] = ACTIONS(3674),
    [anon_sym_spawn] = ACTIONS(3676),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_DASH] = ACTIONS(3680),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(3682),
    [anon_sym_lock] = ACTIONS(3684),
    [anon_sym_rlock] = ACTIONS(3684),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [639] = {
    [sym_line_comment] = STATE(639),
    [sym_block_comment] = STATE(639),
    [sym__expression] = STATE(1553),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4388),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [640] = {
    [sym_line_comment] = STATE(640),
    [sym_block_comment] = STATE(640),
    [sym__expression] = STATE(1553),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [641] = {
    [sym_line_comment] = STATE(641),
    [sym_block_comment] = STATE(641),
    [sym__expression] = STATE(1137),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(3668),
    [anon_sym_DASH] = ACTIONS(3668),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3672),
    [anon_sym_go] = ACTIONS(3674),
    [anon_sym_spawn] = ACTIONS(3676),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_DASH] = ACTIONS(3680),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(3682),
    [anon_sym_lock] = ACTIONS(3684),
    [anon_sym_rlock] = ACTIONS(3684),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [642] = {
    [sym_line_comment] = STATE(642),
    [sym_block_comment] = STATE(642),
    [sym__expression] = STATE(1120),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4326),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(3668),
    [anon_sym_DASH] = ACTIONS(3668),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3672),
    [anon_sym_go] = ACTIONS(3674),
    [anon_sym_spawn] = ACTIONS(3676),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_DASH] = ACTIONS(3680),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(3682),
    [anon_sym_lock] = ACTIONS(3684),
    [anon_sym_rlock] = ACTIONS(3684),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [643] = {
    [sym_line_comment] = STATE(643),
    [sym_block_comment] = STATE(643),
    [sym__expression] = STATE(1129),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(3668),
    [anon_sym_DASH] = ACTIONS(3668),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3672),
    [anon_sym_go] = ACTIONS(3674),
    [anon_sym_spawn] = ACTIONS(3676),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_DASH] = ACTIONS(3680),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(3682),
    [anon_sym_lock] = ACTIONS(3684),
    [anon_sym_rlock] = ACTIONS(3684),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [644] = {
    [sym_line_comment] = STATE(644),
    [sym_block_comment] = STATE(644),
    [sym__expression] = STATE(1275),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_DASH] = ACTIONS(3686),
    [anon_sym_STAR] = ACTIONS(3688),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3690),
    [anon_sym_go] = ACTIONS(3692),
    [anon_sym_spawn] = ACTIONS(3694),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3686),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_AMP] = ACTIONS(3696),
    [anon_sym_LT_DASH] = ACTIONS(3698),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(3700),
    [anon_sym_lock] = ACTIONS(3702),
    [anon_sym_rlock] = ACTIONS(3702),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [645] = {
    [sym_line_comment] = STATE(645),
    [sym_block_comment] = STATE(645),
    [sym__expression] = STATE(1275),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4103),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_DASH] = ACTIONS(3686),
    [anon_sym_STAR] = ACTIONS(3688),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3690),
    [anon_sym_go] = ACTIONS(3692),
    [anon_sym_spawn] = ACTIONS(3694),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3686),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_AMP] = ACTIONS(3696),
    [anon_sym_LT_DASH] = ACTIONS(3698),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(3700),
    [anon_sym_lock] = ACTIONS(3702),
    [anon_sym_rlock] = ACTIONS(3702),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [646] = {
    [sym_line_comment] = STATE(646),
    [sym_block_comment] = STATE(646),
    [sym__expression] = STATE(1275),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4137),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_DASH] = ACTIONS(3686),
    [anon_sym_STAR] = ACTIONS(3688),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3690),
    [anon_sym_go] = ACTIONS(3692),
    [anon_sym_spawn] = ACTIONS(3694),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3686),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_AMP] = ACTIONS(3696),
    [anon_sym_LT_DASH] = ACTIONS(3698),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(3700),
    [anon_sym_lock] = ACTIONS(3702),
    [anon_sym_rlock] = ACTIONS(3702),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [647] = {
    [sym_line_comment] = STATE(647),
    [sym_block_comment] = STATE(647),
    [sym__expression] = STATE(1291),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_DASH] = ACTIONS(3686),
    [anon_sym_STAR] = ACTIONS(3688),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3690),
    [anon_sym_go] = ACTIONS(3692),
    [anon_sym_spawn] = ACTIONS(3694),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3686),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_AMP] = ACTIONS(3696),
    [anon_sym_LT_DASH] = ACTIONS(3698),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(3700),
    [anon_sym_lock] = ACTIONS(3702),
    [anon_sym_rlock] = ACTIONS(3702),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [648] = {
    [sym_line_comment] = STATE(648),
    [sym_block_comment] = STATE(648),
    [sym__expression] = STATE(1282),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_DASH] = ACTIONS(3686),
    [anon_sym_STAR] = ACTIONS(3688),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3690),
    [anon_sym_go] = ACTIONS(3692),
    [anon_sym_spawn] = ACTIONS(3694),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3686),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_AMP] = ACTIONS(3696),
    [anon_sym_LT_DASH] = ACTIONS(3698),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(3700),
    [anon_sym_lock] = ACTIONS(3702),
    [anon_sym_rlock] = ACTIONS(3702),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [649] = {
    [sym_line_comment] = STATE(649),
    [sym_block_comment] = STATE(649),
    [sym__expression] = STATE(1275),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4133),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_DASH] = ACTIONS(3686),
    [anon_sym_STAR] = ACTIONS(3688),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3690),
    [anon_sym_go] = ACTIONS(3692),
    [anon_sym_spawn] = ACTIONS(3694),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3686),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_AMP] = ACTIONS(3696),
    [anon_sym_LT_DASH] = ACTIONS(3698),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(3700),
    [anon_sym_lock] = ACTIONS(3702),
    [anon_sym_rlock] = ACTIONS(3702),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [650] = {
    [sym_line_comment] = STATE(650),
    [sym_block_comment] = STATE(650),
    [sym__expression] = STATE(1276),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_DASH] = ACTIONS(3686),
    [anon_sym_STAR] = ACTIONS(3688),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3690),
    [anon_sym_go] = ACTIONS(3692),
    [anon_sym_spawn] = ACTIONS(3694),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3686),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_AMP] = ACTIONS(3696),
    [anon_sym_LT_DASH] = ACTIONS(3698),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(3700),
    [anon_sym_lock] = ACTIONS(3702),
    [anon_sym_rlock] = ACTIONS(3702),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [651] = {
    [sym_line_comment] = STATE(651),
    [sym_block_comment] = STATE(651),
    [sym__expression] = STATE(1266),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [anon_sym_STAR] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_go] = ACTIONS(901),
    [anon_sym_spawn] = ACTIONS(903),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3208),
    [anon_sym_CARET] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_LT_DASH] = ACTIONS(3220),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(921),
    [anon_sym_lock] = ACTIONS(923),
    [anon_sym_rlock] = ACTIONS(923),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [652] = {
    [sym_line_comment] = STATE(652),
    [sym_block_comment] = STATE(652),
    [sym__expression] = STATE(1277),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [anon_sym_STAR] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_go] = ACTIONS(901),
    [anon_sym_spawn] = ACTIONS(903),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3208),
    [anon_sym_CARET] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_LT_DASH] = ACTIONS(3220),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(921),
    [anon_sym_lock] = ACTIONS(923),
    [anon_sym_rlock] = ACTIONS(923),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [653] = {
    [sym_line_comment] = STATE(653),
    [sym_block_comment] = STATE(653),
    [sym__expression] = STATE(2513),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4270),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(3708),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3390),
    [anon_sym_lock] = ACTIONS(3392),
    [anon_sym_rlock] = ACTIONS(3392),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [654] = {
    [sym_line_comment] = STATE(654),
    [sym_block_comment] = STATE(654),
    [sym__expression] = STATE(1267),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [anon_sym_STAR] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_go] = ACTIONS(901),
    [anon_sym_spawn] = ACTIONS(903),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3208),
    [anon_sym_CARET] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_LT_DASH] = ACTIONS(3220),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(921),
    [anon_sym_lock] = ACTIONS(923),
    [anon_sym_rlock] = ACTIONS(923),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [655] = {
    [sym_line_comment] = STATE(655),
    [sym_block_comment] = STATE(655),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3692),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2385),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(2387),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2389),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(2391),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [656] = {
    [sym_line_comment] = STATE(656),
    [sym_block_comment] = STATE(656),
    [sym__expression] = STATE(1268),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [anon_sym_STAR] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_go] = ACTIONS(901),
    [anon_sym_spawn] = ACTIONS(903),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3208),
    [anon_sym_CARET] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_LT_DASH] = ACTIONS(3220),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(921),
    [anon_sym_lock] = ACTIONS(923),
    [anon_sym_rlock] = ACTIONS(923),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [657] = {
    [sym_line_comment] = STATE(657),
    [sym_block_comment] = STATE(657),
    [sym__expression] = STATE(2236),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3714),
    [anon_sym_go] = ACTIONS(3716),
    [anon_sym_spawn] = ACTIONS(3718),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3710),
    [anon_sym_CARET] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3720),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3724),
    [anon_sym_lock] = ACTIONS(3726),
    [anon_sym_rlock] = ACTIONS(3726),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [658] = {
    [sym_line_comment] = STATE(658),
    [sym_block_comment] = STATE(658),
    [sym__expression] = STATE(2505),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4270),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(3708),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3390),
    [anon_sym_lock] = ACTIONS(3392),
    [anon_sym_rlock] = ACTIONS(3392),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [659] = {
    [sym_line_comment] = STATE(659),
    [sym_block_comment] = STATE(659),
    [sym__expression] = STATE(1269),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [anon_sym_STAR] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_go] = ACTIONS(901),
    [anon_sym_spawn] = ACTIONS(903),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3208),
    [anon_sym_CARET] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_LT_DASH] = ACTIONS(3220),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(921),
    [anon_sym_lock] = ACTIONS(923),
    [anon_sym_rlock] = ACTIONS(923),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [660] = {
    [sym_line_comment] = STATE(660),
    [sym_block_comment] = STATE(660),
    [sym__expression] = STATE(2517),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4270),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(3708),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3390),
    [anon_sym_lock] = ACTIONS(3392),
    [anon_sym_rlock] = ACTIONS(3392),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [661] = {
    [sym_line_comment] = STATE(661),
    [sym_block_comment] = STATE(661),
    [sym__expression] = STATE(2319),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3714),
    [anon_sym_go] = ACTIONS(3716),
    [anon_sym_spawn] = ACTIONS(3718),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3710),
    [anon_sym_CARET] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3720),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3724),
    [anon_sym_lock] = ACTIONS(3726),
    [anon_sym_rlock] = ACTIONS(3726),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [662] = {
    [sym_line_comment] = STATE(662),
    [sym_block_comment] = STATE(662),
    [sym__expression] = STATE(1271),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [anon_sym_STAR] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_go] = ACTIONS(901),
    [anon_sym_spawn] = ACTIONS(903),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3208),
    [anon_sym_CARET] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_LT_DASH] = ACTIONS(3220),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(921),
    [anon_sym_lock] = ACTIONS(923),
    [anon_sym_rlock] = ACTIONS(923),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [663] = {
    [sym_line_comment] = STATE(663),
    [sym_block_comment] = STATE(663),
    [sym__expression] = STATE(2921),
    [sym__expression_without_blocks] = STATE(2999),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [664] = {
    [sym_line_comment] = STATE(664),
    [sym_block_comment] = STATE(664),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3662),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2385),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(2387),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2389),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(2391),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [665] = {
    [sym_line_comment] = STATE(665),
    [sym_block_comment] = STATE(665),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3032),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [666] = {
    [sym_line_comment] = STATE(666),
    [sym_block_comment] = STATE(666),
    [sym__expression] = STATE(2349),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3714),
    [anon_sym_go] = ACTIONS(3716),
    [anon_sym_spawn] = ACTIONS(3718),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3710),
    [anon_sym_CARET] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3720),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3724),
    [anon_sym_lock] = ACTIONS(3726),
    [anon_sym_rlock] = ACTIONS(3726),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [667] = {
    [sym_line_comment] = STATE(667),
    [sym_block_comment] = STATE(667),
    [sym__expression] = STATE(2520),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4270),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(3708),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3390),
    [anon_sym_lock] = ACTIONS(3392),
    [anon_sym_rlock] = ACTIONS(3392),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [668] = {
    [sym_line_comment] = STATE(668),
    [sym_block_comment] = STATE(668),
    [sym__expression] = STATE(2233),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3714),
    [anon_sym_go] = ACTIONS(3716),
    [anon_sym_spawn] = ACTIONS(3718),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3710),
    [anon_sym_CARET] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3720),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3724),
    [anon_sym_lock] = ACTIONS(3726),
    [anon_sym_rlock] = ACTIONS(3726),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [669] = {
    [sym_line_comment] = STATE(669),
    [sym_block_comment] = STATE(669),
    [sym__expression] = STATE(2236),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4297),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3714),
    [anon_sym_go] = ACTIONS(3716),
    [anon_sym_spawn] = ACTIONS(3718),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3710),
    [anon_sym_CARET] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3720),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3724),
    [anon_sym_lock] = ACTIONS(3726),
    [anon_sym_rlock] = ACTIONS(3726),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [670] = {
    [sym_line_comment] = STATE(670),
    [sym_block_comment] = STATE(670),
    [sym__expression] = STATE(2236),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4303),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3714),
    [anon_sym_go] = ACTIONS(3716),
    [anon_sym_spawn] = ACTIONS(3718),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3710),
    [anon_sym_CARET] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3720),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3724),
    [anon_sym_lock] = ACTIONS(3726),
    [anon_sym_rlock] = ACTIONS(3726),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [671] = {
    [sym_line_comment] = STATE(671),
    [sym_block_comment] = STATE(671),
    [sym__expression] = STATE(2236),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4306),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3714),
    [anon_sym_go] = ACTIONS(3716),
    [anon_sym_spawn] = ACTIONS(3718),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3710),
    [anon_sym_CARET] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3720),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3724),
    [anon_sym_lock] = ACTIONS(3726),
    [anon_sym_rlock] = ACTIONS(3726),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [672] = {
    [sym_line_comment] = STATE(672),
    [sym_block_comment] = STATE(672),
    [sym__expression] = STATE(988),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(947),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3534),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(3536),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [673] = {
    [sym_line_comment] = STATE(673),
    [sym_block_comment] = STATE(673),
    [sym__expression] = STATE(2703),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3689),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(2415),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2417),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2423),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [674] = {
    [sym_line_comment] = STATE(674),
    [sym_block_comment] = STATE(674),
    [sym__expression] = STATE(1136),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(3668),
    [anon_sym_DASH] = ACTIONS(3668),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3672),
    [anon_sym_go] = ACTIONS(3674),
    [anon_sym_spawn] = ACTIONS(3676),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_DASH] = ACTIONS(3680),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(3682),
    [anon_sym_lock] = ACTIONS(3684),
    [anon_sym_rlock] = ACTIONS(3684),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [675] = {
    [sym_line_comment] = STATE(675),
    [sym_block_comment] = STATE(675),
    [sym__expression] = STATE(2597),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [676] = {
    [sym_line_comment] = STATE(676),
    [sym_block_comment] = STATE(676),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3011),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3009),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [677] = {
    [sym_line_comment] = STATE(677),
    [sym_block_comment] = STATE(677),
    [sym__expression] = STATE(2643),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [678] = {
    [sym_line_comment] = STATE(678),
    [sym_block_comment] = STATE(678),
    [sym__expression] = STATE(2906),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [679] = {
    [sym_line_comment] = STATE(679),
    [sym_block_comment] = STATE(679),
    [sym__expression] = STATE(2233),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_DASH] = ACTIONS(3610),
    [anon_sym_STAR] = ACTIONS(3612),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_go] = ACTIONS(3618),
    [anon_sym_spawn] = ACTIONS(3620),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3610),
    [anon_sym_CARET] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3626),
    [anon_sym_LT_DASH] = ACTIONS(3628),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3638),
    [anon_sym_lock] = ACTIONS(3640),
    [anon_sym_rlock] = ACTIONS(3640),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [680] = {
    [sym_line_comment] = STATE(680),
    [sym_block_comment] = STATE(680),
    [sym__expression] = STATE(1970),
    [sym__expression_without_blocks] = STATE(2082),
    [sym__expression_with_blocks] = STATE(2082),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2161),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2161),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2161),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2161),
    [sym_compile_time_if_expression] = STATE(2161),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2161),
    [sym_select_expression] = STATE(2161),
    [sym_lock_expression] = STATE(2161),
    [sym_unsafe_expression] = STATE(2161),
    [sym_sql_expression] = STATE(2161),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(964),
    [sym_plain_type] = STATE(4108),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(3734),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_DOLLARif] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3740),
    [anon_sym_select] = ACTIONS(3742),
    [anon_sym_lock] = ACTIONS(3744),
    [anon_sym_rlock] = ACTIONS(3744),
    [anon_sym_unsafe] = ACTIONS(3746),
    [anon_sym_sql] = ACTIONS(3748),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [681] = {
    [sym_line_comment] = STATE(681),
    [sym_block_comment] = STATE(681),
    [sym__expression] = STATE(2701),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3689),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(2415),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2417),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2423),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [682] = {
    [sym_line_comment] = STATE(682),
    [sym_block_comment] = STATE(682),
    [sym__expression] = STATE(2382),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_DASH] = ACTIONS(3610),
    [anon_sym_STAR] = ACTIONS(3612),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_go] = ACTIONS(3618),
    [anon_sym_spawn] = ACTIONS(3620),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3610),
    [anon_sym_CARET] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3626),
    [anon_sym_LT_DASH] = ACTIONS(3628),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3638),
    [anon_sym_lock] = ACTIONS(3640),
    [anon_sym_rlock] = ACTIONS(3640),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [683] = {
    [sym_line_comment] = STATE(683),
    [sym_block_comment] = STATE(683),
    [sym__expression] = STATE(2384),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_DASH] = ACTIONS(3610),
    [anon_sym_STAR] = ACTIONS(3612),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_go] = ACTIONS(3618),
    [anon_sym_spawn] = ACTIONS(3620),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3610),
    [anon_sym_CARET] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3626),
    [anon_sym_LT_DASH] = ACTIONS(3628),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3638),
    [anon_sym_lock] = ACTIONS(3640),
    [anon_sym_rlock] = ACTIONS(3640),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [684] = {
    [sym_line_comment] = STATE(684),
    [sym_block_comment] = STATE(684),
    [sym__expression] = STATE(1970),
    [sym__expression_without_blocks] = STATE(2082),
    [sym__expression_with_blocks] = STATE(2082),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2161),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2161),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2161),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2161),
    [sym_compile_time_if_expression] = STATE(2161),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2161),
    [sym_select_expression] = STATE(2161),
    [sym_lock_expression] = STATE(2161),
    [sym_unsafe_expression] = STATE(2161),
    [sym_sql_expression] = STATE(2161),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(964),
    [sym_plain_type] = STATE(4106),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(3734),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_DOLLARif] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3740),
    [anon_sym_select] = ACTIONS(3742),
    [anon_sym_lock] = ACTIONS(3744),
    [anon_sym_rlock] = ACTIONS(3744),
    [anon_sym_unsafe] = ACTIONS(3746),
    [anon_sym_sql] = ACTIONS(3748),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [685] = {
    [sym_line_comment] = STATE(685),
    [sym_block_comment] = STATE(685),
    [sym__expression] = STATE(2581),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [686] = {
    [sym_line_comment] = STATE(686),
    [sym_block_comment] = STATE(686),
    [sym__expression] = STATE(1970),
    [sym__expression_without_blocks] = STATE(2082),
    [sym__expression_with_blocks] = STATE(2082),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2161),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2161),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2161),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2161),
    [sym_compile_time_if_expression] = STATE(2161),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2161),
    [sym_select_expression] = STATE(2161),
    [sym_lock_expression] = STATE(2161),
    [sym_unsafe_expression] = STATE(2161),
    [sym_sql_expression] = STATE(2161),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(964),
    [sym_plain_type] = STATE(4100),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(3734),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_DOLLARif] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3740),
    [anon_sym_select] = ACTIONS(3742),
    [anon_sym_lock] = ACTIONS(3744),
    [anon_sym_rlock] = ACTIONS(3744),
    [anon_sym_unsafe] = ACTIONS(3746),
    [anon_sym_sql] = ACTIONS(3748),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [687] = {
    [sym_line_comment] = STATE(687),
    [sym_block_comment] = STATE(687),
    [sym__expression] = STATE(2779),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [688] = {
    [sym_line_comment] = STATE(688),
    [sym_block_comment] = STATE(688),
    [sym__expression] = STATE(2236),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_DASH] = ACTIONS(3610),
    [anon_sym_STAR] = ACTIONS(3612),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_go] = ACTIONS(3618),
    [anon_sym_spawn] = ACTIONS(3620),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3610),
    [anon_sym_CARET] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3626),
    [anon_sym_LT_DASH] = ACTIONS(3628),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3638),
    [anon_sym_lock] = ACTIONS(3640),
    [anon_sym_rlock] = ACTIONS(3640),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [689] = {
    [sym_line_comment] = STATE(689),
    [sym_block_comment] = STATE(689),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3048),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3047),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [690] = {
    [sym_line_comment] = STATE(690),
    [sym_block_comment] = STATE(690),
    [sym__expression] = STATE(2753),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [691] = {
    [sym_line_comment] = STATE(691),
    [sym_block_comment] = STATE(691),
    [sym__expression] = STATE(2743),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3689),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(2415),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2417),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2423),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [692] = {
    [sym_line_comment] = STATE(692),
    [sym_block_comment] = STATE(692),
    [sym__expression] = STATE(2512),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [693] = {
    [sym_line_comment] = STATE(693),
    [sym_block_comment] = STATE(693),
    [sym__expression] = STATE(1124),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2481),
    [anon_sym_go] = ACTIONS(775),
    [anon_sym_spawn] = ACTIONS(777),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_LT_DASH] = ACTIONS(2489),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(795),
    [anon_sym_lock] = ACTIONS(797),
    [anon_sym_rlock] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [694] = {
    [sym_line_comment] = STATE(694),
    [sym_block_comment] = STATE(694),
    [sym__expression] = STATE(2383),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [695] = {
    [sym_line_comment] = STATE(695),
    [sym_block_comment] = STATE(695),
    [sym__expression] = STATE(1125),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2481),
    [anon_sym_go] = ACTIONS(775),
    [anon_sym_spawn] = ACTIONS(777),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_LT_DASH] = ACTIONS(2489),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(795),
    [anon_sym_lock] = ACTIONS(797),
    [anon_sym_rlock] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [696] = {
    [sym_line_comment] = STATE(696),
    [sym_block_comment] = STATE(696),
    [sym__expression] = STATE(2510),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [697] = {
    [sym_line_comment] = STATE(697),
    [sym_block_comment] = STATE(697),
    [sym__expression] = STATE(2509),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [698] = {
    [sym_line_comment] = STATE(698),
    [sym_block_comment] = STATE(698),
    [sym__expression] = STATE(1127),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2481),
    [anon_sym_go] = ACTIONS(775),
    [anon_sym_spawn] = ACTIONS(777),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_LT_DASH] = ACTIONS(2489),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(795),
    [anon_sym_lock] = ACTIONS(797),
    [anon_sym_rlock] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [699] = {
    [sym_line_comment] = STATE(699),
    [sym_block_comment] = STATE(699),
    [sym__expression] = STATE(2602),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [700] = {
    [sym_line_comment] = STATE(700),
    [sym_block_comment] = STATE(700),
    [sym__expression] = STATE(2508),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [701] = {
    [sym_line_comment] = STATE(701),
    [sym_block_comment] = STATE(701),
    [sym__expression] = STATE(2507),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [702] = {
    [sym_line_comment] = STATE(702),
    [sym_block_comment] = STATE(702),
    [sym__expression] = STATE(1130),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2481),
    [anon_sym_go] = ACTIONS(775),
    [anon_sym_spawn] = ACTIONS(777),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_LT_DASH] = ACTIONS(2489),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(795),
    [anon_sym_lock] = ACTIONS(797),
    [anon_sym_rlock] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [703] = {
    [sym_line_comment] = STATE(703),
    [sym_block_comment] = STATE(703),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2996),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2995),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [704] = {
    [sym_line_comment] = STATE(704),
    [sym_block_comment] = STATE(704),
    [sym__expression] = STATE(1131),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2481),
    [anon_sym_go] = ACTIONS(775),
    [anon_sym_spawn] = ACTIONS(777),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_LT_DASH] = ACTIONS(2489),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(795),
    [anon_sym_lock] = ACTIONS(797),
    [anon_sym_rlock] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [705] = {
    [sym_line_comment] = STATE(705),
    [sym_block_comment] = STATE(705),
    [sym__expression] = STATE(2765),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [706] = {
    [sym_line_comment] = STATE(706),
    [sym_block_comment] = STATE(706),
    [sym__expression] = STATE(1121),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2481),
    [anon_sym_go] = ACTIONS(775),
    [anon_sym_spawn] = ACTIONS(777),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_LT_DASH] = ACTIONS(2489),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(795),
    [anon_sym_lock] = ACTIONS(797),
    [anon_sym_rlock] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [707] = {
    [sym_line_comment] = STATE(707),
    [sym_block_comment] = STATE(707),
    [sym__expression] = STATE(2777),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3689),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(2415),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2417),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2423),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [708] = {
    [sym_line_comment] = STATE(708),
    [sym_block_comment] = STATE(708),
    [sym__expression] = STATE(2614),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [709] = {
    [sym_line_comment] = STATE(709),
    [sym_block_comment] = STATE(709),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3049),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3050),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [710] = {
    [sym_line_comment] = STATE(710),
    [sym_block_comment] = STATE(710),
    [sym__expression] = STATE(2872),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [711] = {
    [sym_line_comment] = STATE(711),
    [sym_block_comment] = STATE(711),
    [sym__expression] = STATE(2893),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3689),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(2415),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2417),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2423),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [712] = {
    [sym_line_comment] = STATE(712),
    [sym_block_comment] = STATE(712),
    [sym__expression] = STATE(2376),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_DASH] = ACTIONS(3610),
    [anon_sym_STAR] = ACTIONS(3612),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_go] = ACTIONS(3618),
    [anon_sym_spawn] = ACTIONS(3620),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3610),
    [anon_sym_CARET] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3626),
    [anon_sym_LT_DASH] = ACTIONS(3628),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3638),
    [anon_sym_lock] = ACTIONS(3640),
    [anon_sym_rlock] = ACTIONS(3640),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [713] = {
    [sym_line_comment] = STATE(713),
    [sym_block_comment] = STATE(713),
    [sym__expression] = STATE(2612),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [714] = {
    [sym_line_comment] = STATE(714),
    [sym_block_comment] = STATE(714),
    [sym__expression] = STATE(2756),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [715] = {
    [sym_line_comment] = STATE(715),
    [sym_block_comment] = STATE(715),
    [sym__expression] = STATE(1982),
    [sym__expression_without_blocks] = STATE(2082),
    [sym__expression_with_blocks] = STATE(2082),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2161),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2161),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2161),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2161),
    [sym_compile_time_if_expression] = STATE(2161),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2161),
    [sym_select_expression] = STATE(2161),
    [sym_lock_expression] = STATE(2161),
    [sym_unsafe_expression] = STATE(2161),
    [sym_sql_expression] = STATE(2161),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(964),
    [sym_plain_type] = STATE(4399),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(3734),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_DOLLARif] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3740),
    [anon_sym_select] = ACTIONS(3742),
    [anon_sym_lock] = ACTIONS(3744),
    [anon_sym_rlock] = ACTIONS(3744),
    [anon_sym_unsafe] = ACTIONS(3746),
    [anon_sym_sql] = ACTIONS(3748),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [716] = {
    [sym_line_comment] = STATE(716),
    [sym_block_comment] = STATE(716),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(3692),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_go] = ACTIONS(2681),
    [anon_sym_spawn] = ACTIONS(2683),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_CARET] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2691),
    [anon_sym_lock] = ACTIONS(2693),
    [anon_sym_rlock] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [717] = {
    [sym_line_comment] = STATE(717),
    [sym_block_comment] = STATE(717),
    [sym__expression] = STATE(1980),
    [sym__expression_without_blocks] = STATE(2082),
    [sym__expression_with_blocks] = STATE(2082),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2161),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2161),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2161),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2161),
    [sym_compile_time_if_expression] = STATE(2161),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2161),
    [sym_select_expression] = STATE(2161),
    [sym_lock_expression] = STATE(2161),
    [sym_unsafe_expression] = STATE(2161),
    [sym_sql_expression] = STATE(2161),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(964),
    [sym_plain_type] = STATE(4399),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(3734),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_DOLLARif] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3740),
    [anon_sym_select] = ACTIONS(3742),
    [anon_sym_lock] = ACTIONS(3744),
    [anon_sym_rlock] = ACTIONS(3744),
    [anon_sym_unsafe] = ACTIONS(3746),
    [anon_sym_sql] = ACTIONS(3748),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [718] = {
    [sym_line_comment] = STATE(718),
    [sym_block_comment] = STATE(718),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3054),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3045),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [719] = {
    [sym_line_comment] = STATE(719),
    [sym_block_comment] = STATE(719),
    [sym__expression] = STATE(1966),
    [sym__expression_without_blocks] = STATE(2082),
    [sym__expression_with_blocks] = STATE(2082),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2161),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2161),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2161),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2161),
    [sym_compile_time_if_expression] = STATE(2161),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2161),
    [sym_select_expression] = STATE(2161),
    [sym_lock_expression] = STATE(2161),
    [sym_unsafe_expression] = STATE(2161),
    [sym_sql_expression] = STATE(2161),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(964),
    [sym_plain_type] = STATE(4399),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(3734),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_DOLLARif] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3740),
    [anon_sym_select] = ACTIONS(3742),
    [anon_sym_lock] = ACTIONS(3744),
    [anon_sym_rlock] = ACTIONS(3744),
    [anon_sym_unsafe] = ACTIONS(3746),
    [anon_sym_sql] = ACTIONS(3748),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [720] = {
    [sym_line_comment] = STATE(720),
    [sym_block_comment] = STATE(720),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(3683),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_go] = ACTIONS(2681),
    [anon_sym_spawn] = ACTIONS(2683),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_CARET] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2691),
    [anon_sym_lock] = ACTIONS(2693),
    [anon_sym_rlock] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [721] = {
    [sym_line_comment] = STATE(721),
    [sym_block_comment] = STATE(721),
    [sym__expression] = STATE(2869),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [722] = {
    [sym_line_comment] = STATE(722),
    [sym_block_comment] = STATE(722),
    [sym__expression] = STATE(2794),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3689),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(2415),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2417),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2423),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [723] = {
    [sym_line_comment] = STATE(723),
    [sym_block_comment] = STATE(723),
    [sym__expression] = STATE(2583),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [724] = {
    [sym_line_comment] = STATE(724),
    [sym_block_comment] = STATE(724),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(3662),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_go] = ACTIONS(2681),
    [anon_sym_spawn] = ACTIONS(2683),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_CARET] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2691),
    [anon_sym_lock] = ACTIONS(2693),
    [anon_sym_rlock] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [725] = {
    [sym_line_comment] = STATE(725),
    [sym_block_comment] = STATE(725),
    [sym__expression] = STATE(1970),
    [sym__expression_without_blocks] = STATE(2082),
    [sym__expression_with_blocks] = STATE(2082),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2161),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2161),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2161),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2161),
    [sym_compile_time_if_expression] = STATE(2161),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2161),
    [sym_select_expression] = STATE(2161),
    [sym_lock_expression] = STATE(2161),
    [sym_unsafe_expression] = STATE(2161),
    [sym_sql_expression] = STATE(2161),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(964),
    [sym_plain_type] = STATE(4399),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(3734),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_DOLLARif] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3740),
    [anon_sym_select] = ACTIONS(3742),
    [anon_sym_lock] = ACTIONS(3744),
    [anon_sym_rlock] = ACTIONS(3744),
    [anon_sym_unsafe] = ACTIONS(3746),
    [anon_sym_sql] = ACTIONS(3748),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [726] = {
    [sym_line_comment] = STATE(726),
    [sym_block_comment] = STATE(726),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3052),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3051),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [727] = {
    [sym_line_comment] = STATE(727),
    [sym_block_comment] = STATE(727),
    [sym__expression] = STATE(2698),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [728] = {
    [sym_line_comment] = STATE(728),
    [sym_block_comment] = STATE(728),
    [sym__expression] = STATE(1120),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2481),
    [anon_sym_go] = ACTIONS(775),
    [anon_sym_spawn] = ACTIONS(777),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_LT_DASH] = ACTIONS(2489),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(795),
    [anon_sym_lock] = ACTIONS(797),
    [anon_sym_rlock] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [729] = {
    [sym_line_comment] = STATE(729),
    [sym_block_comment] = STATE(729),
    [sym__expression] = STATE(2644),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3689),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(2415),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2417),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2423),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [730] = {
    [sym_line_comment] = STATE(730),
    [sym_block_comment] = STATE(730),
    [sym__expression] = STATE(2600),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [731] = {
    [sym_line_comment] = STATE(731),
    [sym_block_comment] = STATE(731),
    [sym__expression] = STATE(2375),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [732] = {
    [sym_line_comment] = STATE(732),
    [sym_block_comment] = STATE(732),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3692),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(2415),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2417),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2423),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [733] = {
    [sym_line_comment] = STATE(733),
    [sym_block_comment] = STATE(733),
    [sym__expression] = STATE(1140),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(3668),
    [anon_sym_DASH] = ACTIONS(3668),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3672),
    [anon_sym_go] = ACTIONS(3674),
    [anon_sym_spawn] = ACTIONS(3676),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_DASH] = ACTIONS(3680),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(3682),
    [anon_sym_lock] = ACTIONS(3684),
    [anon_sym_rlock] = ACTIONS(3684),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [734] = {
    [sym_line_comment] = STATE(734),
    [sym_block_comment] = STATE(734),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3057),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3000),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [735] = {
    [sym_line_comment] = STATE(735),
    [sym_block_comment] = STATE(735),
    [sym__expression] = STATE(2892),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [736] = {
    [sym_line_comment] = STATE(736),
    [sym_block_comment] = STATE(736),
    [sym__expression] = STATE(2656),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [737] = {
    [sym_line_comment] = STATE(737),
    [sym_block_comment] = STATE(737),
    [sym__expression] = STATE(1120),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4335),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2481),
    [anon_sym_go] = ACTIONS(775),
    [anon_sym_spawn] = ACTIONS(777),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_LT_DASH] = ACTIONS(2489),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(795),
    [anon_sym_lock] = ACTIONS(797),
    [anon_sym_rlock] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [738] = {
    [sym_line_comment] = STATE(738),
    [sym_block_comment] = STATE(738),
    [sym__expression] = STATE(2689),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3689),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(2415),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2417),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2423),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [739] = {
    [sym_line_comment] = STATE(739),
    [sym_block_comment] = STATE(739),
    [sym__expression] = STATE(2900),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [740] = {
    [sym_line_comment] = STATE(740),
    [sym_block_comment] = STATE(740),
    [sym__expression] = STATE(1141),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(3668),
    [anon_sym_DASH] = ACTIONS(3668),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3672),
    [anon_sym_go] = ACTIONS(3674),
    [anon_sym_spawn] = ACTIONS(3676),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_DASH] = ACTIONS(3680),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(3682),
    [anon_sym_lock] = ACTIONS(3684),
    [anon_sym_rlock] = ACTIONS(3684),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [741] = {
    [sym_line_comment] = STATE(741),
    [sym_block_comment] = STATE(741),
    [sym__expression] = STATE(2610),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [742] = {
    [sym_line_comment] = STATE(742),
    [sym_block_comment] = STATE(742),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3662),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(2415),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2417),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2423),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [743] = {
    [sym_line_comment] = STATE(743),
    [sym_block_comment] = STATE(743),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [744] = {
    [sym_line_comment] = STATE(744),
    [sym_block_comment] = STATE(744),
    [sym__expression] = STATE(1427),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1527),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [745] = {
    [sym_line_comment] = STATE(745),
    [sym_block_comment] = STATE(745),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3029),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3026),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [746] = {
    [sym_line_comment] = STATE(746),
    [sym_block_comment] = STATE(746),
    [sym__expression] = STATE(2375),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_go] = ACTIONS(2681),
    [anon_sym_spawn] = ACTIONS(2683),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_CARET] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2691),
    [anon_sym_lock] = ACTIONS(2693),
    [anon_sym_rlock] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [747] = {
    [sym_line_comment] = STATE(747),
    [sym_block_comment] = STATE(747),
    [sym__expression] = STATE(245),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_mutability_modifiers] = STATE(789),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(3514),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(325),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(3516),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [748] = {
    [sym_line_comment] = STATE(748),
    [sym_block_comment] = STATE(748),
    [sym__expression] = STATE(1411),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1527),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4358),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [749] = {
    [sym_line_comment] = STATE(749),
    [sym_block_comment] = STATE(749),
    [sym__expression] = STATE(2774),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3689),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(2415),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2417),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2423),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [750] = {
    [sym_line_comment] = STATE(750),
    [sym_block_comment] = STATE(750),
    [sym__expression] = STATE(2590),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [751] = {
    [sym_line_comment] = STATE(751),
    [sym_block_comment] = STATE(751),
    [sym__expression] = STATE(1415),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1527),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [752] = {
    [sym_line_comment] = STATE(752),
    [sym_block_comment] = STATE(752),
    [sym__expression] = STATE(1409),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1527),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [753] = {
    [sym_line_comment] = STATE(753),
    [sym_block_comment] = STATE(753),
    [sym__expression] = STATE(2562),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_go] = ACTIONS(2681),
    [anon_sym_spawn] = ACTIONS(2683),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_CARET] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2691),
    [anon_sym_lock] = ACTIONS(2693),
    [anon_sym_rlock] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [754] = {
    [sym_line_comment] = STATE(754),
    [sym_block_comment] = STATE(754),
    [sym__expression] = STATE(2251),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3714),
    [anon_sym_go] = ACTIONS(3716),
    [anon_sym_spawn] = ACTIONS(3718),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3710),
    [anon_sym_CARET] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3720),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3724),
    [anon_sym_lock] = ACTIONS(3726),
    [anon_sym_rlock] = ACTIONS(3726),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [755] = {
    [sym_line_comment] = STATE(755),
    [sym_block_comment] = STATE(755),
    [sym__expression] = STATE(2554),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_go] = ACTIONS(2681),
    [anon_sym_spawn] = ACTIONS(2683),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_CARET] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2691),
    [anon_sym_lock] = ACTIONS(2693),
    [anon_sym_rlock] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [756] = {
    [sym_line_comment] = STATE(756),
    [sym_block_comment] = STATE(756),
    [sym__expression] = STATE(1120),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4236),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2481),
    [anon_sym_go] = ACTIONS(775),
    [anon_sym_spawn] = ACTIONS(777),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_LT_DASH] = ACTIONS(2489),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(795),
    [anon_sym_lock] = ACTIONS(797),
    [anon_sym_rlock] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [757] = {
    [sym_line_comment] = STATE(757),
    [sym_block_comment] = STATE(757),
    [sym__expression] = STATE(2388),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3714),
    [anon_sym_go] = ACTIONS(3716),
    [anon_sym_spawn] = ACTIONS(3718),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3710),
    [anon_sym_CARET] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3720),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3724),
    [anon_sym_lock] = ACTIONS(3726),
    [anon_sym_rlock] = ACTIONS(3726),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [758] = {
    [sym_line_comment] = STATE(758),
    [sym_block_comment] = STATE(758),
    [sym__expression] = STATE(1411),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1527),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4355),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [759] = {
    [sym_line_comment] = STATE(759),
    [sym_block_comment] = STATE(759),
    [sym__expression] = STATE(1411),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1527),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4339),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [760] = {
    [sym_line_comment] = STATE(760),
    [sym_block_comment] = STATE(760),
    [sym__expression] = STATE(1126),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2481),
    [anon_sym_go] = ACTIONS(775),
    [anon_sym_spawn] = ACTIONS(777),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_LT_DASH] = ACTIONS(2489),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(795),
    [anon_sym_lock] = ACTIONS(797),
    [anon_sym_rlock] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [761] = {
    [sym_line_comment] = STATE(761),
    [sym_block_comment] = STATE(761),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_go] = ACTIONS(2681),
    [anon_sym_spawn] = ACTIONS(2683),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_CARET] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2691),
    [anon_sym_lock] = ACTIONS(2693),
    [anon_sym_rlock] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [762] = {
    [sym_line_comment] = STATE(762),
    [sym_block_comment] = STATE(762),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(3034),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(3044),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [763] = {
    [sym_line_comment] = STATE(763),
    [sym_block_comment] = STATE(763),
    [sym__expression] = STATE(2867),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [764] = {
    [sym_line_comment] = STATE(764),
    [sym_block_comment] = STATE(764),
    [sym__expression] = STATE(1128),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2481),
    [anon_sym_go] = ACTIONS(775),
    [anon_sym_spawn] = ACTIONS(777),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_LT_DASH] = ACTIONS(2489),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(795),
    [anon_sym_lock] = ACTIONS(797),
    [anon_sym_rlock] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [765] = {
    [sym_line_comment] = STATE(765),
    [sym_block_comment] = STATE(765),
    [sym__expression] = STATE(2875),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3689),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(2415),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2417),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2423),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [766] = {
    [sym_line_comment] = STATE(766),
    [sym_block_comment] = STATE(766),
    [sym__expression] = STATE(1120),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4326),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2481),
    [anon_sym_go] = ACTIONS(775),
    [anon_sym_spawn] = ACTIONS(777),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_LT_DASH] = ACTIONS(2489),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(795),
    [anon_sym_lock] = ACTIONS(797),
    [anon_sym_rlock] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [767] = {
    [sym_line_comment] = STATE(767),
    [sym_block_comment] = STATE(767),
    [sym__expression] = STATE(2577),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [768] = {
    [sym_line_comment] = STATE(768),
    [sym_block_comment] = STATE(768),
    [sym__expression] = STATE(1416),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1527),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [769] = {
    [sym_line_comment] = STATE(769),
    [sym_block_comment] = STATE(769),
    [sym__expression] = STATE(1410),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1527),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [770] = {
    [sym_line_comment] = STATE(770),
    [sym_block_comment] = STATE(770),
    [sym__expression] = STATE(2925),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2998),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2983),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [771] = {
    [sym_line_comment] = STATE(771),
    [sym_block_comment] = STATE(771),
    [sym__expression] = STATE(2901),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [772] = {
    [sym_line_comment] = STATE(772),
    [sym_block_comment] = STATE(772),
    [sym__expression] = STATE(2594),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [773] = {
    [sym_line_comment] = STATE(773),
    [sym_block_comment] = STATE(773),
    [sym__expression] = STATE(992),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(947),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3534),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(3536),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [774] = {
    [sym_line_comment] = STATE(774),
    [sym_block_comment] = STATE(774),
    [sym__expression] = STATE(2615),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [775] = {
    [sym_line_comment] = STATE(775),
    [sym_block_comment] = STATE(775),
    [sym__expression] = STATE(1417),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1527),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [776] = {
    [sym_line_comment] = STATE(776),
    [sym_block_comment] = STATE(776),
    [sym__expression] = STATE(2526),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4270),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3486),
    [anon_sym_STAR] = ACTIONS(3488),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3490),
    [anon_sym_go] = ACTIONS(3492),
    [anon_sym_spawn] = ACTIONS(3494),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(3486),
    [anon_sym_CARET] = ACTIONS(3486),
    [anon_sym_AMP] = ACTIONS(3496),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3500),
    [anon_sym_lock] = ACTIONS(3502),
    [anon_sym_rlock] = ACTIONS(3502),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [777] = {
    [sym_line_comment] = STATE(777),
    [sym_block_comment] = STATE(777),
    [sym__expression] = STATE(247),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_mutability_modifiers] = STATE(789),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(3514),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(325),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(3516),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [778] = {
    [sym_line_comment] = STATE(778),
    [sym_block_comment] = STATE(778),
    [sym__expression] = STATE(1129),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2481),
    [anon_sym_go] = ACTIONS(775),
    [anon_sym_spawn] = ACTIONS(777),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_LT_DASH] = ACTIONS(2489),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(795),
    [anon_sym_lock] = ACTIONS(797),
    [anon_sym_rlock] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [779] = {
    [sym_line_comment] = STATE(779),
    [sym_block_comment] = STATE(779),
    [sym__expression] = STATE(256),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_mutability_modifiers] = STATE(789),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(3514),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(325),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(3516),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [780] = {
    [sym_line_comment] = STATE(780),
    [sym_block_comment] = STATE(780),
    [sym__expression] = STATE(255),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_mutability_modifiers] = STATE(789),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(3514),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(325),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(3516),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [781] = {
    [sym_line_comment] = STATE(781),
    [sym_block_comment] = STATE(781),
    [sym__expression] = STATE(1133),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(3668),
    [anon_sym_DASH] = ACTIONS(3668),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3672),
    [anon_sym_go] = ACTIONS(3674),
    [anon_sym_spawn] = ACTIONS(3676),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_DASH] = ACTIONS(3680),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(3682),
    [anon_sym_lock] = ACTIONS(3684),
    [anon_sym_rlock] = ACTIONS(3684),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [782] = {
    [sym_line_comment] = STATE(782),
    [sym_block_comment] = STATE(782),
    [sym__expression] = STATE(253),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_mutability_modifiers] = STATE(789),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(3514),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(325),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(3516),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [783] = {
    [sym_line_comment] = STATE(783),
    [sym_block_comment] = STATE(783),
    [sym__expression] = STATE(250),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_mutability_modifiers] = STATE(789),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(3514),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(325),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(3516),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [784] = {
    [sym_line_comment] = STATE(784),
    [sym_block_comment] = STATE(784),
    [sym__expression] = STATE(1590),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [785] = {
    [sym_line_comment] = STATE(785),
    [sym_block_comment] = STATE(785),
    [sym__expression] = STATE(1584),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [786] = {
    [sym_line_comment] = STATE(786),
    [sym_block_comment] = STATE(786),
    [sym__expression] = STATE(246),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_mutability_modifiers] = STATE(789),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(3514),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(325),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(3516),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [787] = {
    [sym_line_comment] = STATE(787),
    [sym_block_comment] = STATE(787),
    [sym__expression] = STATE(1418),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1527),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [788] = {
    [sym_line_comment] = STATE(788),
    [sym_block_comment] = STATE(788),
    [sym__expression] = STATE(2021),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_go] = ACTIONS(3372),
    [anon_sym_spawn] = ACTIONS(3374),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_LT_DASH] = ACTIONS(3380),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(3382),
    [anon_sym_lock] = ACTIONS(3384),
    [anon_sym_rlock] = ACTIONS(3384),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [789] = {
    [sym_line_comment] = STATE(789),
    [sym_block_comment] = STATE(789),
    [sym__expression] = STATE(2904),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [790] = {
    [sym_line_comment] = STATE(790),
    [sym_block_comment] = STATE(790),
    [sym__expression] = STATE(1992),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_go] = ACTIONS(3372),
    [anon_sym_spawn] = ACTIONS(3374),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_LT_DASH] = ACTIONS(3380),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(3382),
    [anon_sym_lock] = ACTIONS(3384),
    [anon_sym_rlock] = ACTIONS(3384),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [791] = {
    [sym_line_comment] = STATE(791),
    [sym_block_comment] = STATE(791),
    [sym__expression] = STATE(2865),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [792] = {
    [sym_line_comment] = STATE(792),
    [sym_block_comment] = STATE(792),
    [sym__expression] = STATE(2005),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_go] = ACTIONS(3372),
    [anon_sym_spawn] = ACTIONS(3374),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_LT_DASH] = ACTIONS(3380),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(3382),
    [anon_sym_lock] = ACTIONS(3384),
    [anon_sym_rlock] = ACTIONS(3384),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [793] = {
    [sym_line_comment] = STATE(793),
    [sym_block_comment] = STATE(793),
    [sym__expression] = STATE(1995),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_go] = ACTIONS(3372),
    [anon_sym_spawn] = ACTIONS(3374),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_LT_DASH] = ACTIONS(3380),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(3382),
    [anon_sym_lock] = ACTIONS(3384),
    [anon_sym_rlock] = ACTIONS(3384),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [794] = {
    [sym_line_comment] = STATE(794),
    [sym_block_comment] = STATE(794),
    [sym__expression] = STATE(1983),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(1165),
    [anon_sym_lock] = ACTIONS(1167),
    [anon_sym_rlock] = ACTIONS(1167),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [795] = {
    [sym_line_comment] = STATE(795),
    [sym_block_comment] = STATE(795),
    [sym__expression] = STATE(1414),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1527),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [796] = {
    [sym_line_comment] = STATE(796),
    [sym_block_comment] = STATE(796),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3692),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [797] = {
    [sym_line_comment] = STATE(797),
    [sym_block_comment] = STATE(797),
    [sym__expression] = STATE(1413),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1527),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [798] = {
    [sym_line_comment] = STATE(798),
    [sym_block_comment] = STATE(798),
    [sym__expression] = STATE(1983),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_go] = ACTIONS(3372),
    [anon_sym_spawn] = ACTIONS(3374),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_LT_DASH] = ACTIONS(3380),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(3382),
    [anon_sym_lock] = ACTIONS(3384),
    [anon_sym_rlock] = ACTIONS(3384),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [799] = {
    [sym_line_comment] = STATE(799),
    [sym_block_comment] = STATE(799),
    [sym__expression] = STATE(1998),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_go] = ACTIONS(3372),
    [anon_sym_spawn] = ACTIONS(3374),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_LT_DASH] = ACTIONS(3380),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(3382),
    [anon_sym_lock] = ACTIONS(3384),
    [anon_sym_rlock] = ACTIONS(3384),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [800] = {
    [sym_line_comment] = STATE(800),
    [sym_block_comment] = STATE(800),
    [sym__expression] = STATE(1412),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1527),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [801] = {
    [sym_line_comment] = STATE(801),
    [sym_block_comment] = STATE(801),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3683),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [802] = {
    [sym_line_comment] = STATE(802),
    [sym_block_comment] = STATE(802),
    [sym__expression] = STATE(2921),
    [sym__expression_without_blocks] = STATE(2988),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [803] = {
    [sym_line_comment] = STATE(803),
    [sym_block_comment] = STATE(803),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3662),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [804] = {
    [sym_line_comment] = STATE(804),
    [sym_block_comment] = STATE(804),
    [sym__expression] = STATE(1411),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1527),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [805] = {
    [sym_line_comment] = STATE(805),
    [sym_block_comment] = STATE(805),
    [sym__expression] = STATE(1583),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [806] = {
    [sym_line_comment] = STATE(806),
    [sym_block_comment] = STATE(806),
    [sym__expression] = STATE(1581),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [807] = {
    [sym_line_comment] = STATE(807),
    [sym_block_comment] = STATE(807),
    [sym__expression] = STATE(1552),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [808] = {
    [sym_line_comment] = STATE(808),
    [sym_block_comment] = STATE(808),
    [sym__expression] = STATE(1579),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_go] = ACTIONS(1587),
    [anon_sym_spawn] = ACTIONS(1589),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_DASH] = ACTIONS(1597),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1609),
    [anon_sym_rlock] = ACTIONS(1609),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [809] = {
    [sym_line_comment] = STATE(809),
    [sym_block_comment] = STATE(809),
    [sym__expression] = STATE(1586),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_go] = ACTIONS(2903),
    [anon_sym_spawn] = ACTIONS(2905),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_LT_DASH] = ACTIONS(2909),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(2911),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_rlock] = ACTIONS(2913),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [810] = {
    [sym_line_comment] = STATE(810),
    [sym_block_comment] = STATE(810),
    [sym__expression] = STATE(1552),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_go] = ACTIONS(2903),
    [anon_sym_spawn] = ACTIONS(2905),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_LT_DASH] = ACTIONS(2909),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(2911),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_rlock] = ACTIONS(2913),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [811] = {
    [sym_line_comment] = STATE(811),
    [sym_block_comment] = STATE(811),
    [sym__expression] = STATE(1587),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_go] = ACTIONS(2903),
    [anon_sym_spawn] = ACTIONS(2905),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_LT_DASH] = ACTIONS(2909),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(2911),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_rlock] = ACTIONS(2913),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [812] = {
    [sym_line_comment] = STATE(812),
    [sym_block_comment] = STATE(812),
    [sym__expression] = STATE(2543),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [813] = {
    [sym_line_comment] = STATE(813),
    [sym_block_comment] = STATE(813),
    [sym__expression] = STATE(1419),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1527),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [814] = {
    [sym_line_comment] = STATE(814),
    [sym_block_comment] = STATE(814),
    [sym__expression] = STATE(2544),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [815] = {
    [sym_line_comment] = STATE(815),
    [sym_block_comment] = STATE(815),
    [sym__expression] = STATE(2546),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [816] = {
    [sym_line_comment] = STATE(816),
    [sym_block_comment] = STATE(816),
    [sym__expression] = STATE(2547),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [817] = {
    [sym_line_comment] = STATE(817),
    [sym_block_comment] = STATE(817),
    [sym__expression] = STATE(2383),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [818] = {
    [sym_line_comment] = STATE(818),
    [sym_block_comment] = STATE(818),
    [sym__expression] = STATE(2552),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [819] = {
    [sym_line_comment] = STATE(819),
    [sym_block_comment] = STATE(819),
    [sym__expression] = STATE(2910),
    [sym__expression_without_blocks] = STATE(2936),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [820] = {
    [sym_line_comment] = STATE(820),
    [sym_block_comment] = STATE(820),
    [sym__expression] = STATE(2511),
    [sym__expression_without_blocks] = STATE(2793),
    [sym__expression_with_blocks] = STATE(2793),
    [sym_inc_expression] = STATE(2880),
    [sym_dec_expression] = STATE(2880),
    [sym_or_block_expression] = STATE(2880),
    [sym_option_propagation_expression] = STATE(2880),
    [sym_result_propagation_expression] = STATE(2880),
    [sym_anon_struct_value_expression] = STATE(2785),
    [sym_go_expression] = STATE(2880),
    [sym_spawn_expression] = STATE(2880),
    [sym_parenthesized_expression] = STATE(2880),
    [sym_call_expression] = STATE(2880),
    [sym_type_initializer] = STATE(2785),
    [sym_function_literal] = STATE(2880),
    [sym_reference_expression] = STATE(2884),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2880),
    [sym_receive_expression] = STATE(2880),
    [sym_binary_expression] = STATE(2880),
    [sym_as_type_cast_expression] = STATE(2880),
    [sym__max_group] = STATE(2880),
    [sym_literal] = STATE(2877),
    [sym_map_init_expression] = STATE(2785),
    [sym_array_creation] = STATE(2880),
    [sym_fixed_array_creation] = STATE(2880),
    [sym_selector_expression] = STATE(2880),
    [sym_index_expression] = STATE(2880),
    [sym_slice_expression] = STATE(2880),
    [sym_if_expression] = STATE(2785),
    [sym_compile_time_if_expression] = STATE(2785),
    [sym_is_expression] = STATE(2880),
    [sym_in_expression] = STATE(2880),
    [sym_enum_fetch] = STATE(2880),
    [sym_match_expression] = STATE(2785),
    [sym_select_expression] = STATE(2785),
    [sym_lock_expression] = STATE(2785),
    [sym_unsafe_expression] = STATE(2785),
    [sym_sql_expression] = STATE(2785),
    [sym_interpreted_string_literal] = STATE(2854),
    [sym_c_string_literal] = STATE(2854),
    [sym_raw_string_literal] = STATE(2854),
    [sym_mutability_modifiers] = STATE(965),
    [sym_plain_type] = STATE(4143),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LPAREN] = ACTIONS(3544),
    [anon_sym_fn] = ACTIONS(3546),
    [anon_sym_PLUS] = ACTIONS(3548),
    [anon_sym_DASH] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3550),
    [anon_sym_struct] = ACTIONS(3552),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3554),
    [anon_sym_go] = ACTIONS(3556),
    [anon_sym_spawn] = ACTIONS(3558),
    [anon_sym_json_DOTdecode] = ACTIONS(3560),
    [anon_sym_LBRACK2] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3548),
    [anon_sym_CARET] = ACTIONS(3548),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_LT_DASH] = ACTIONS(3566),
    [sym_none] = ACTIONS(3568),
    [sym_true] = ACTIONS(3568),
    [sym_false] = ACTIONS(3568),
    [sym_nil] = ACTIONS(3568),
    [anon_sym_if] = ACTIONS(3570),
    [anon_sym_DOLLARif] = ACTIONS(3572),
    [anon_sym_match] = ACTIONS(3574),
    [anon_sym_select] = ACTIONS(3576),
    [anon_sym_lock] = ACTIONS(3578),
    [anon_sym_rlock] = ACTIONS(3578),
    [anon_sym_unsafe] = ACTIONS(3580),
    [anon_sym_sql] = ACTIONS(3582),
    [sym_int_literal] = ACTIONS(3568),
    [sym_float_literal] = ACTIONS(3584),
    [sym_rune_literal] = ACTIONS(3584),
    [anon_sym_SQUOTE] = ACTIONS(3586),
    [anon_sym_DQUOTE] = ACTIONS(3588),
    [anon_sym_c_SQUOTE] = ACTIONS(3590),
    [anon_sym_c_DQUOTE] = ACTIONS(3592),
    [anon_sym_r_SQUOTE] = ACTIONS(3594),
    [anon_sym_r_DQUOTE] = ACTIONS(3596),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3598),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [821] = {
    [sym_line_comment] = STATE(821),
    [sym_block_comment] = STATE(821),
    [sym__expression] = STATE(1422),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1527),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [822] = {
    [sym_line_comment] = STATE(822),
    [sym_block_comment] = STATE(822),
    [sym__expression] = STATE(1588),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_go] = ACTIONS(2903),
    [anon_sym_spawn] = ACTIONS(2905),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_LT_DASH] = ACTIONS(2909),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(2911),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_rlock] = ACTIONS(2913),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [823] = {
    [sym_line_comment] = STATE(823),
    [sym_block_comment] = STATE(823),
    [sym__expression] = STATE(1288),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_DASH] = ACTIONS(3686),
    [anon_sym_STAR] = ACTIONS(3688),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3690),
    [anon_sym_go] = ACTIONS(3692),
    [anon_sym_spawn] = ACTIONS(3694),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3686),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_AMP] = ACTIONS(3696),
    [anon_sym_LT_DASH] = ACTIONS(3698),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(3700),
    [anon_sym_lock] = ACTIONS(3702),
    [anon_sym_rlock] = ACTIONS(3702),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [824] = {
    [sym_line_comment] = STATE(824),
    [sym_block_comment] = STATE(824),
    [sym__expression] = STATE(1589),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_go] = ACTIONS(2903),
    [anon_sym_spawn] = ACTIONS(2905),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_LT_DASH] = ACTIONS(2909),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(2911),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_rlock] = ACTIONS(2913),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [825] = {
    [sym_line_comment] = STATE(825),
    [sym_block_comment] = STATE(825),
    [sym__expression] = STATE(1571),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_go] = ACTIONS(2903),
    [anon_sym_spawn] = ACTIONS(2905),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_LT_DASH] = ACTIONS(2909),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(2911),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_rlock] = ACTIONS(2913),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [826] = {
    [sym_line_comment] = STATE(826),
    [sym_block_comment] = STATE(826),
    [sym__expression] = STATE(1965),
    [sym__expression_without_blocks] = STATE(2082),
    [sym__expression_with_blocks] = STATE(2082),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2161),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2161),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2161),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2161),
    [sym_compile_time_if_expression] = STATE(2161),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2161),
    [sym_select_expression] = STATE(2161),
    [sym_lock_expression] = STATE(2161),
    [sym_unsafe_expression] = STATE(2161),
    [sym_sql_expression] = STATE(2161),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(964),
    [sym_plain_type] = STATE(4399),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(3734),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_DOLLARif] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3740),
    [anon_sym_select] = ACTIONS(3742),
    [anon_sym_lock] = ACTIONS(3744),
    [anon_sym_rlock] = ACTIONS(3744),
    [anon_sym_unsafe] = ACTIONS(3746),
    [anon_sym_sql] = ACTIONS(3748),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [827] = {
    [sym_line_comment] = STATE(827),
    [sym_block_comment] = STATE(827),
    [sym__expression] = STATE(1971),
    [sym__expression_without_blocks] = STATE(2082),
    [sym__expression_with_blocks] = STATE(2082),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2161),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2161),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2161),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2161),
    [sym_compile_time_if_expression] = STATE(2161),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2161),
    [sym_select_expression] = STATE(2161),
    [sym_lock_expression] = STATE(2161),
    [sym_unsafe_expression] = STATE(2161),
    [sym_sql_expression] = STATE(2161),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(964),
    [sym_plain_type] = STATE(4399),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(3734),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_DOLLARif] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3740),
    [anon_sym_select] = ACTIONS(3742),
    [anon_sym_lock] = ACTIONS(3744),
    [anon_sym_rlock] = ACTIONS(3744),
    [anon_sym_unsafe] = ACTIONS(3746),
    [anon_sym_sql] = ACTIONS(3748),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [828] = {
    [sym_line_comment] = STATE(828),
    [sym_block_comment] = STATE(828),
    [sym__expression] = STATE(1975),
    [sym__expression_without_blocks] = STATE(2082),
    [sym__expression_with_blocks] = STATE(2082),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2161),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2161),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2161),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2161),
    [sym_compile_time_if_expression] = STATE(2161),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2161),
    [sym_select_expression] = STATE(2161),
    [sym_lock_expression] = STATE(2161),
    [sym_unsafe_expression] = STATE(2161),
    [sym_sql_expression] = STATE(2161),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(964),
    [sym_plain_type] = STATE(4399),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(3734),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_DOLLARif] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3740),
    [anon_sym_select] = ACTIONS(3742),
    [anon_sym_lock] = ACTIONS(3744),
    [anon_sym_rlock] = ACTIONS(3744),
    [anon_sym_unsafe] = ACTIONS(3746),
    [anon_sym_sql] = ACTIONS(3748),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [829] = {
    [sym_line_comment] = STATE(829),
    [sym_block_comment] = STATE(829),
    [sym__expression] = STATE(1142),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(3668),
    [anon_sym_DASH] = ACTIONS(3668),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3672),
    [anon_sym_go] = ACTIONS(3674),
    [anon_sym_spawn] = ACTIONS(3676),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_DASH] = ACTIONS(3680),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(3682),
    [anon_sym_lock] = ACTIONS(3684),
    [anon_sym_rlock] = ACTIONS(3684),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [830] = {
    [sym_line_comment] = STATE(830),
    [sym_block_comment] = STATE(830),
    [sym__expression] = STATE(1131),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(3668),
    [anon_sym_DASH] = ACTIONS(3668),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3672),
    [anon_sym_go] = ACTIONS(3674),
    [anon_sym_spawn] = ACTIONS(3676),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_DASH] = ACTIONS(3680),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(3682),
    [anon_sym_lock] = ACTIONS(3684),
    [anon_sym_rlock] = ACTIONS(3684),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [831] = {
    [sym_line_comment] = STATE(831),
    [sym_block_comment] = STATE(831),
    [sym__expression] = STATE(1143),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(3668),
    [anon_sym_DASH] = ACTIONS(3668),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3672),
    [anon_sym_go] = ACTIONS(3674),
    [anon_sym_spawn] = ACTIONS(3676),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_DASH] = ACTIONS(3680),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(3682),
    [anon_sym_lock] = ACTIONS(3684),
    [anon_sym_rlock] = ACTIONS(3684),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [832] = {
    [sym_line_comment] = STATE(832),
    [sym_block_comment] = STATE(832),
    [sym__expression] = STATE(1145),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(3668),
    [anon_sym_DASH] = ACTIONS(3668),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3672),
    [anon_sym_go] = ACTIONS(3674),
    [anon_sym_spawn] = ACTIONS(3676),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_DASH] = ACTIONS(3680),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(3682),
    [anon_sym_lock] = ACTIONS(3684),
    [anon_sym_rlock] = ACTIONS(3684),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [833] = {
    [sym_line_comment] = STATE(833),
    [sym_block_comment] = STATE(833),
    [sym__expression] = STATE(1144),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(3668),
    [anon_sym_DASH] = ACTIONS(3668),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3672),
    [anon_sym_go] = ACTIONS(3674),
    [anon_sym_spawn] = ACTIONS(3676),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_DASH] = ACTIONS(3680),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(3682),
    [anon_sym_lock] = ACTIONS(3684),
    [anon_sym_rlock] = ACTIONS(3684),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [834] = {
    [sym_line_comment] = STATE(834),
    [sym_block_comment] = STATE(834),
    [sym__expression] = STATE(1138),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(3668),
    [anon_sym_DASH] = ACTIONS(3668),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3672),
    [anon_sym_go] = ACTIONS(3674),
    [anon_sym_spawn] = ACTIONS(3676),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_DASH] = ACTIONS(3680),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(3682),
    [anon_sym_lock] = ACTIONS(3684),
    [anon_sym_rlock] = ACTIONS(3684),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [835] = {
    [sym_line_comment] = STATE(835),
    [sym_block_comment] = STATE(835),
    [sym__expression] = STATE(1987),
    [sym__expression_without_blocks] = STATE(2082),
    [sym__expression_with_blocks] = STATE(2082),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2161),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2161),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2161),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2161),
    [sym_compile_time_if_expression] = STATE(2161),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2161),
    [sym_select_expression] = STATE(2161),
    [sym_lock_expression] = STATE(2161),
    [sym_unsafe_expression] = STATE(2161),
    [sym_sql_expression] = STATE(2161),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(964),
    [sym_plain_type] = STATE(4399),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(3734),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_DOLLARif] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3740),
    [anon_sym_select] = ACTIONS(3742),
    [anon_sym_lock] = ACTIONS(3744),
    [anon_sym_rlock] = ACTIONS(3744),
    [anon_sym_unsafe] = ACTIONS(3746),
    [anon_sym_sql] = ACTIONS(3748),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [836] = {
    [sym_line_comment] = STATE(836),
    [sym_block_comment] = STATE(836),
    [sym__expression] = STATE(1986),
    [sym__expression_without_blocks] = STATE(2082),
    [sym__expression_with_blocks] = STATE(2082),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2161),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2161),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2161),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2161),
    [sym_compile_time_if_expression] = STATE(2161),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2161),
    [sym_select_expression] = STATE(2161),
    [sym_lock_expression] = STATE(2161),
    [sym_unsafe_expression] = STATE(2161),
    [sym_sql_expression] = STATE(2161),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(964),
    [sym_plain_type] = STATE(4399),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(3734),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_DOLLARif] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3740),
    [anon_sym_select] = ACTIONS(3742),
    [anon_sym_lock] = ACTIONS(3744),
    [anon_sym_rlock] = ACTIONS(3744),
    [anon_sym_unsafe] = ACTIONS(3746),
    [anon_sym_sql] = ACTIONS(3748),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [837] = {
    [sym_line_comment] = STATE(837),
    [sym_block_comment] = STATE(837),
    [sym__expression] = STATE(1984),
    [sym__expression_without_blocks] = STATE(2082),
    [sym__expression_with_blocks] = STATE(2082),
    [sym_inc_expression] = STATE(2027),
    [sym_dec_expression] = STATE(2027),
    [sym_or_block_expression] = STATE(2027),
    [sym_option_propagation_expression] = STATE(2027),
    [sym_result_propagation_expression] = STATE(2027),
    [sym_anon_struct_value_expression] = STATE(2161),
    [sym_go_expression] = STATE(2027),
    [sym_spawn_expression] = STATE(2027),
    [sym_parenthesized_expression] = STATE(2027),
    [sym_call_expression] = STATE(2027),
    [sym_type_initializer] = STATE(2161),
    [sym_function_literal] = STATE(2027),
    [sym_reference_expression] = STATE(2028),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2027),
    [sym_receive_expression] = STATE(2027),
    [sym_binary_expression] = STATE(2027),
    [sym_as_type_cast_expression] = STATE(2027),
    [sym__max_group] = STATE(2027),
    [sym_literal] = STATE(2069),
    [sym_map_init_expression] = STATE(2161),
    [sym_array_creation] = STATE(2027),
    [sym_fixed_array_creation] = STATE(2027),
    [sym_selector_expression] = STATE(2027),
    [sym_index_expression] = STATE(2027),
    [sym_slice_expression] = STATE(2027),
    [sym_if_expression] = STATE(2161),
    [sym_compile_time_if_expression] = STATE(2161),
    [sym_is_expression] = STATE(2027),
    [sym_in_expression] = STATE(2027),
    [sym_enum_fetch] = STATE(2027),
    [sym_match_expression] = STATE(2161),
    [sym_select_expression] = STATE(2161),
    [sym_lock_expression] = STATE(2161),
    [sym_unsafe_expression] = STATE(2161),
    [sym_sql_expression] = STATE(2161),
    [sym_interpreted_string_literal] = STATE(2064),
    [sym_c_string_literal] = STATE(2064),
    [sym_raw_string_literal] = STATE(2064),
    [sym_mutability_modifiers] = STATE(964),
    [sym_plain_type] = STATE(4399),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(3734),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_go] = ACTIONS(1065),
    [anon_sym_spawn] = ACTIONS(1067),
    [anon_sym_json_DOTdecode] = ACTIONS(1069),
    [anon_sym_LBRACK2] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT_DASH] = ACTIONS(1075),
    [sym_none] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_nil] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_DOLLARif] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3740),
    [anon_sym_select] = ACTIONS(3742),
    [anon_sym_lock] = ACTIONS(3744),
    [anon_sym_rlock] = ACTIONS(3744),
    [anon_sym_unsafe] = ACTIONS(3746),
    [anon_sym_sql] = ACTIONS(3748),
    [sym_int_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1095),
    [sym_rune_literal] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_c_SQUOTE] = ACTIONS(1101),
    [anon_sym_c_DQUOTE] = ACTIONS(1103),
    [anon_sym_r_SQUOTE] = ACTIONS(1105),
    [anon_sym_r_DQUOTE] = ACTIONS(1107),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1109),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [838] = {
    [sym_line_comment] = STATE(838),
    [sym_block_comment] = STATE(838),
    [sym__expression] = STATE(2522),
    [sym__expression_without_blocks] = STATE(2793),
    [sym__expression_with_blocks] = STATE(2793),
    [sym_inc_expression] = STATE(2880),
    [sym_dec_expression] = STATE(2880),
    [sym_or_block_expression] = STATE(2880),
    [sym_option_propagation_expression] = STATE(2880),
    [sym_result_propagation_expression] = STATE(2880),
    [sym_anon_struct_value_expression] = STATE(2785),
    [sym_go_expression] = STATE(2880),
    [sym_spawn_expression] = STATE(2880),
    [sym_parenthesized_expression] = STATE(2880),
    [sym_call_expression] = STATE(2880),
    [sym_type_initializer] = STATE(2785),
    [sym_function_literal] = STATE(2880),
    [sym_reference_expression] = STATE(2884),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2880),
    [sym_receive_expression] = STATE(2880),
    [sym_binary_expression] = STATE(2880),
    [sym_as_type_cast_expression] = STATE(2880),
    [sym__max_group] = STATE(2880),
    [sym_literal] = STATE(2877),
    [sym_map_init_expression] = STATE(2785),
    [sym_array_creation] = STATE(2880),
    [sym_fixed_array_creation] = STATE(2880),
    [sym_selector_expression] = STATE(2880),
    [sym_index_expression] = STATE(2880),
    [sym_slice_expression] = STATE(2880),
    [sym_if_expression] = STATE(2785),
    [sym_compile_time_if_expression] = STATE(2785),
    [sym_is_expression] = STATE(2880),
    [sym_in_expression] = STATE(2880),
    [sym_enum_fetch] = STATE(2880),
    [sym_match_expression] = STATE(2785),
    [sym_select_expression] = STATE(2785),
    [sym_lock_expression] = STATE(2785),
    [sym_unsafe_expression] = STATE(2785),
    [sym_sql_expression] = STATE(2785),
    [sym_interpreted_string_literal] = STATE(2854),
    [sym_c_string_literal] = STATE(2854),
    [sym_raw_string_literal] = STATE(2854),
    [sym_mutability_modifiers] = STATE(965),
    [sym_plain_type] = STATE(4143),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LPAREN] = ACTIONS(3544),
    [anon_sym_fn] = ACTIONS(3546),
    [anon_sym_PLUS] = ACTIONS(3548),
    [anon_sym_DASH] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3550),
    [anon_sym_struct] = ACTIONS(3552),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3554),
    [anon_sym_go] = ACTIONS(3556),
    [anon_sym_spawn] = ACTIONS(3558),
    [anon_sym_json_DOTdecode] = ACTIONS(3560),
    [anon_sym_LBRACK2] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3548),
    [anon_sym_CARET] = ACTIONS(3548),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_LT_DASH] = ACTIONS(3566),
    [sym_none] = ACTIONS(3568),
    [sym_true] = ACTIONS(3568),
    [sym_false] = ACTIONS(3568),
    [sym_nil] = ACTIONS(3568),
    [anon_sym_if] = ACTIONS(3570),
    [anon_sym_DOLLARif] = ACTIONS(3572),
    [anon_sym_match] = ACTIONS(3574),
    [anon_sym_select] = ACTIONS(3576),
    [anon_sym_lock] = ACTIONS(3578),
    [anon_sym_rlock] = ACTIONS(3578),
    [anon_sym_unsafe] = ACTIONS(3580),
    [anon_sym_sql] = ACTIONS(3582),
    [sym_int_literal] = ACTIONS(3568),
    [sym_float_literal] = ACTIONS(3584),
    [sym_rune_literal] = ACTIONS(3584),
    [anon_sym_SQUOTE] = ACTIONS(3586),
    [anon_sym_DQUOTE] = ACTIONS(3588),
    [anon_sym_c_SQUOTE] = ACTIONS(3590),
    [anon_sym_c_DQUOTE] = ACTIONS(3592),
    [anon_sym_r_SQUOTE] = ACTIONS(3594),
    [anon_sym_r_DQUOTE] = ACTIONS(3596),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3598),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [839] = {
    [sym_line_comment] = STATE(839),
    [sym_block_comment] = STATE(839),
    [sym__expression] = STATE(1284),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_DASH] = ACTIONS(3686),
    [anon_sym_STAR] = ACTIONS(3688),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3690),
    [anon_sym_go] = ACTIONS(3692),
    [anon_sym_spawn] = ACTIONS(3694),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3686),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_AMP] = ACTIONS(3696),
    [anon_sym_LT_DASH] = ACTIONS(3698),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(3700),
    [anon_sym_lock] = ACTIONS(3702),
    [anon_sym_rlock] = ACTIONS(3702),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [840] = {
    [sym_line_comment] = STATE(840),
    [sym_block_comment] = STATE(840),
    [sym__expression] = STATE(990),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(947),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3534),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(3536),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [841] = {
    [sym_line_comment] = STATE(841),
    [sym_block_comment] = STATE(841),
    [sym__expression] = STATE(1277),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_DASH] = ACTIONS(3686),
    [anon_sym_STAR] = ACTIONS(3688),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3690),
    [anon_sym_go] = ACTIONS(3692),
    [anon_sym_spawn] = ACTIONS(3694),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3686),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_AMP] = ACTIONS(3696),
    [anon_sym_LT_DASH] = ACTIONS(3698),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(3700),
    [anon_sym_lock] = ACTIONS(3702),
    [anon_sym_rlock] = ACTIONS(3702),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [842] = {
    [sym_line_comment] = STATE(842),
    [sym_block_comment] = STATE(842),
    [sym__expression] = STATE(1290),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_DASH] = ACTIONS(3686),
    [anon_sym_STAR] = ACTIONS(3688),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3690),
    [anon_sym_go] = ACTIONS(3692),
    [anon_sym_spawn] = ACTIONS(3694),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3686),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_AMP] = ACTIONS(3696),
    [anon_sym_LT_DASH] = ACTIONS(3698),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(3700),
    [anon_sym_lock] = ACTIONS(3702),
    [anon_sym_rlock] = ACTIONS(3702),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [843] = {
    [sym_line_comment] = STATE(843),
    [sym_block_comment] = STATE(843),
    [sym__expression] = STATE(1283),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_DASH] = ACTIONS(3686),
    [anon_sym_STAR] = ACTIONS(3688),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3690),
    [anon_sym_go] = ACTIONS(3692),
    [anon_sym_spawn] = ACTIONS(3694),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3686),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_AMP] = ACTIONS(3696),
    [anon_sym_LT_DASH] = ACTIONS(3698),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(3700),
    [anon_sym_lock] = ACTIONS(3702),
    [anon_sym_rlock] = ACTIONS(3702),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [844] = {
    [sym_line_comment] = STATE(844),
    [sym_block_comment] = STATE(844),
    [sym__expression] = STATE(1287),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_DASH] = ACTIONS(3686),
    [anon_sym_STAR] = ACTIONS(3688),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3690),
    [anon_sym_go] = ACTIONS(3692),
    [anon_sym_spawn] = ACTIONS(3694),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3686),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_AMP] = ACTIONS(3696),
    [anon_sym_LT_DASH] = ACTIONS(3698),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(3700),
    [anon_sym_lock] = ACTIONS(3702),
    [anon_sym_rlock] = ACTIONS(3702),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [845] = {
    [sym_line_comment] = STATE(845),
    [sym_block_comment] = STATE(845),
    [sym__expression] = STATE(1286),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_DASH] = ACTIONS(3686),
    [anon_sym_STAR] = ACTIONS(3688),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3690),
    [anon_sym_go] = ACTIONS(3692),
    [anon_sym_spawn] = ACTIONS(3694),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3686),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_AMP] = ACTIONS(3696),
    [anon_sym_LT_DASH] = ACTIONS(3698),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(3700),
    [anon_sym_lock] = ACTIONS(3702),
    [anon_sym_rlock] = ACTIONS(3702),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [846] = {
    [sym_line_comment] = STATE(846),
    [sym_block_comment] = STATE(846),
    [sym__expression] = STATE(1420),
    [sym__expression_without_blocks] = STATE(1493),
    [sym__expression_with_blocks] = STATE(1493),
    [sym_inc_expression] = STATE(1494),
    [sym_dec_expression] = STATE(1494),
    [sym_or_block_expression] = STATE(1494),
    [sym_option_propagation_expression] = STATE(1494),
    [sym_result_propagation_expression] = STATE(1494),
    [sym_anon_struct_value_expression] = STATE(1496),
    [sym_go_expression] = STATE(1494),
    [sym_spawn_expression] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1494),
    [sym_call_expression] = STATE(1494),
    [sym_type_initializer] = STATE(1496),
    [sym_function_literal] = STATE(1494),
    [sym_reference_expression] = STATE(1527),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1494),
    [sym_receive_expression] = STATE(1494),
    [sym_binary_expression] = STATE(1494),
    [sym_as_type_cast_expression] = STATE(1494),
    [sym__max_group] = STATE(1494),
    [sym_literal] = STATE(1492),
    [sym_map_init_expression] = STATE(1496),
    [sym_array_creation] = STATE(1494),
    [sym_fixed_array_creation] = STATE(1494),
    [sym_selector_expression] = STATE(1494),
    [sym_index_expression] = STATE(1494),
    [sym_slice_expression] = STATE(1494),
    [sym_if_expression] = STATE(1496),
    [sym_compile_time_if_expression] = STATE(1496),
    [sym_is_expression] = STATE(1494),
    [sym_in_expression] = STATE(1494),
    [sym_enum_fetch] = STATE(1494),
    [sym_match_expression] = STATE(1496),
    [sym_select_expression] = STATE(1496),
    [sym_lock_expression] = STATE(1496),
    [sym_unsafe_expression] = STATE(1496),
    [sym_sql_expression] = STATE(1496),
    [sym_interpreted_string_literal] = STATE(1475),
    [sym_c_string_literal] = STATE(1475),
    [sym_raw_string_literal] = STATE(1475),
    [sym_mutability_modifiers] = STATE(949),
    [sym_plain_type] = STATE(4319),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_go] = ACTIONS(971),
    [anon_sym_spawn] = ACTIONS(973),
    [anon_sym_json_DOTdecode] = ACTIONS(975),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [sym_none] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_nil] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_DOLLARif] = ACTIONS(987),
    [anon_sym_match] = ACTIONS(989),
    [anon_sym_select] = ACTIONS(991),
    [anon_sym_lock] = ACTIONS(993),
    [anon_sym_rlock] = ACTIONS(993),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_sql] = ACTIONS(997),
    [sym_int_literal] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(999),
    [sym_rune_literal] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_c_SQUOTE] = ACTIONS(1005),
    [anon_sym_c_DQUOTE] = ACTIONS(1007),
    [anon_sym_r_SQUOTE] = ACTIONS(1009),
    [anon_sym_r_DQUOTE] = ACTIONS(1011),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [847] = {
    [sym_line_comment] = STATE(847),
    [sym_block_comment] = STATE(847),
    [sym__expression] = STATE(2527),
    [sym__expression_without_blocks] = STATE(2793),
    [sym__expression_with_blocks] = STATE(2793),
    [sym_inc_expression] = STATE(2880),
    [sym_dec_expression] = STATE(2880),
    [sym_or_block_expression] = STATE(2880),
    [sym_option_propagation_expression] = STATE(2880),
    [sym_result_propagation_expression] = STATE(2880),
    [sym_anon_struct_value_expression] = STATE(2785),
    [sym_go_expression] = STATE(2880),
    [sym_spawn_expression] = STATE(2880),
    [sym_parenthesized_expression] = STATE(2880),
    [sym_call_expression] = STATE(2880),
    [sym_type_initializer] = STATE(2785),
    [sym_function_literal] = STATE(2880),
    [sym_reference_expression] = STATE(2884),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2880),
    [sym_receive_expression] = STATE(2880),
    [sym_binary_expression] = STATE(2880),
    [sym_as_type_cast_expression] = STATE(2880),
    [sym__max_group] = STATE(2880),
    [sym_literal] = STATE(2877),
    [sym_map_init_expression] = STATE(2785),
    [sym_array_creation] = STATE(2880),
    [sym_fixed_array_creation] = STATE(2880),
    [sym_selector_expression] = STATE(2880),
    [sym_index_expression] = STATE(2880),
    [sym_slice_expression] = STATE(2880),
    [sym_if_expression] = STATE(2785),
    [sym_compile_time_if_expression] = STATE(2785),
    [sym_is_expression] = STATE(2880),
    [sym_in_expression] = STATE(2880),
    [sym_enum_fetch] = STATE(2880),
    [sym_match_expression] = STATE(2785),
    [sym_select_expression] = STATE(2785),
    [sym_lock_expression] = STATE(2785),
    [sym_unsafe_expression] = STATE(2785),
    [sym_sql_expression] = STATE(2785),
    [sym_interpreted_string_literal] = STATE(2854),
    [sym_c_string_literal] = STATE(2854),
    [sym_raw_string_literal] = STATE(2854),
    [sym_mutability_modifiers] = STATE(965),
    [sym_plain_type] = STATE(4143),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LPAREN] = ACTIONS(3544),
    [anon_sym_fn] = ACTIONS(3546),
    [anon_sym_PLUS] = ACTIONS(3548),
    [anon_sym_DASH] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3550),
    [anon_sym_struct] = ACTIONS(3552),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3554),
    [anon_sym_go] = ACTIONS(3556),
    [anon_sym_spawn] = ACTIONS(3558),
    [anon_sym_json_DOTdecode] = ACTIONS(3560),
    [anon_sym_LBRACK2] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3548),
    [anon_sym_CARET] = ACTIONS(3548),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_LT_DASH] = ACTIONS(3566),
    [sym_none] = ACTIONS(3568),
    [sym_true] = ACTIONS(3568),
    [sym_false] = ACTIONS(3568),
    [sym_nil] = ACTIONS(3568),
    [anon_sym_if] = ACTIONS(3570),
    [anon_sym_DOLLARif] = ACTIONS(3572),
    [anon_sym_match] = ACTIONS(3574),
    [anon_sym_select] = ACTIONS(3576),
    [anon_sym_lock] = ACTIONS(3578),
    [anon_sym_rlock] = ACTIONS(3578),
    [anon_sym_unsafe] = ACTIONS(3580),
    [anon_sym_sql] = ACTIONS(3582),
    [sym_int_literal] = ACTIONS(3568),
    [sym_float_literal] = ACTIONS(3584),
    [sym_rune_literal] = ACTIONS(3584),
    [anon_sym_SQUOTE] = ACTIONS(3586),
    [anon_sym_DQUOTE] = ACTIONS(3588),
    [anon_sym_c_SQUOTE] = ACTIONS(3590),
    [anon_sym_c_DQUOTE] = ACTIONS(3592),
    [anon_sym_r_SQUOTE] = ACTIONS(3594),
    [anon_sym_r_DQUOTE] = ACTIONS(3596),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3598),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [848] = {
    [sym_line_comment] = STATE(848),
    [sym_block_comment] = STATE(848),
    [sym__expression] = STATE(2515),
    [sym__expression_without_blocks] = STATE(2793),
    [sym__expression_with_blocks] = STATE(2793),
    [sym_inc_expression] = STATE(2880),
    [sym_dec_expression] = STATE(2880),
    [sym_or_block_expression] = STATE(2880),
    [sym_option_propagation_expression] = STATE(2880),
    [sym_result_propagation_expression] = STATE(2880),
    [sym_anon_struct_value_expression] = STATE(2785),
    [sym_go_expression] = STATE(2880),
    [sym_spawn_expression] = STATE(2880),
    [sym_parenthesized_expression] = STATE(2880),
    [sym_call_expression] = STATE(2880),
    [sym_type_initializer] = STATE(2785),
    [sym_function_literal] = STATE(2880),
    [sym_reference_expression] = STATE(2884),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2880),
    [sym_receive_expression] = STATE(2880),
    [sym_binary_expression] = STATE(2880),
    [sym_as_type_cast_expression] = STATE(2880),
    [sym__max_group] = STATE(2880),
    [sym_literal] = STATE(2877),
    [sym_map_init_expression] = STATE(2785),
    [sym_array_creation] = STATE(2880),
    [sym_fixed_array_creation] = STATE(2880),
    [sym_selector_expression] = STATE(2880),
    [sym_index_expression] = STATE(2880),
    [sym_slice_expression] = STATE(2880),
    [sym_if_expression] = STATE(2785),
    [sym_compile_time_if_expression] = STATE(2785),
    [sym_is_expression] = STATE(2880),
    [sym_in_expression] = STATE(2880),
    [sym_enum_fetch] = STATE(2880),
    [sym_match_expression] = STATE(2785),
    [sym_select_expression] = STATE(2785),
    [sym_lock_expression] = STATE(2785),
    [sym_unsafe_expression] = STATE(2785),
    [sym_sql_expression] = STATE(2785),
    [sym_interpreted_string_literal] = STATE(2854),
    [sym_c_string_literal] = STATE(2854),
    [sym_raw_string_literal] = STATE(2854),
    [sym_mutability_modifiers] = STATE(965),
    [sym_plain_type] = STATE(4143),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LPAREN] = ACTIONS(3544),
    [anon_sym_fn] = ACTIONS(3546),
    [anon_sym_PLUS] = ACTIONS(3548),
    [anon_sym_DASH] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3550),
    [anon_sym_struct] = ACTIONS(3552),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3554),
    [anon_sym_go] = ACTIONS(3556),
    [anon_sym_spawn] = ACTIONS(3558),
    [anon_sym_json_DOTdecode] = ACTIONS(3560),
    [anon_sym_LBRACK2] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3548),
    [anon_sym_CARET] = ACTIONS(3548),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_LT_DASH] = ACTIONS(3566),
    [sym_none] = ACTIONS(3568),
    [sym_true] = ACTIONS(3568),
    [sym_false] = ACTIONS(3568),
    [sym_nil] = ACTIONS(3568),
    [anon_sym_if] = ACTIONS(3570),
    [anon_sym_DOLLARif] = ACTIONS(3572),
    [anon_sym_match] = ACTIONS(3574),
    [anon_sym_select] = ACTIONS(3576),
    [anon_sym_lock] = ACTIONS(3578),
    [anon_sym_rlock] = ACTIONS(3578),
    [anon_sym_unsafe] = ACTIONS(3580),
    [anon_sym_sql] = ACTIONS(3582),
    [sym_int_literal] = ACTIONS(3568),
    [sym_float_literal] = ACTIONS(3584),
    [sym_rune_literal] = ACTIONS(3584),
    [anon_sym_SQUOTE] = ACTIONS(3586),
    [anon_sym_DQUOTE] = ACTIONS(3588),
    [anon_sym_c_SQUOTE] = ACTIONS(3590),
    [anon_sym_c_DQUOTE] = ACTIONS(3592),
    [anon_sym_r_SQUOTE] = ACTIONS(3594),
    [anon_sym_r_DQUOTE] = ACTIONS(3596),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3598),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [849] = {
    [sym_line_comment] = STATE(849),
    [sym_block_comment] = STATE(849),
    [sym__expression] = STATE(2375),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [850] = {
    [sym_line_comment] = STATE(850),
    [sym_block_comment] = STATE(850),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3692),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [851] = {
    [sym_line_comment] = STATE(851),
    [sym_block_comment] = STATE(851),
    [sym__expression] = STATE(2514),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [852] = {
    [sym_line_comment] = STATE(852),
    [sym_block_comment] = STATE(852),
    [sym__expression] = STATE(2506),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [853] = {
    [sym_line_comment] = STATE(853),
    [sym_block_comment] = STATE(853),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3683),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [854] = {
    [sym_line_comment] = STATE(854),
    [sym_block_comment] = STATE(854),
    [sym__expression] = STATE(1289),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_DASH] = ACTIONS(3686),
    [anon_sym_STAR] = ACTIONS(3688),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3690),
    [anon_sym_go] = ACTIONS(3692),
    [anon_sym_spawn] = ACTIONS(3694),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3686),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_AMP] = ACTIONS(3696),
    [anon_sym_LT_DASH] = ACTIONS(3698),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(3700),
    [anon_sym_lock] = ACTIONS(3702),
    [anon_sym_rlock] = ACTIONS(3702),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [855] = {
    [sym_line_comment] = STATE(855),
    [sym_block_comment] = STATE(855),
    [sym__expression] = STATE(2324),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3714),
    [anon_sym_go] = ACTIONS(3716),
    [anon_sym_spawn] = ACTIONS(3718),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3710),
    [anon_sym_CARET] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3720),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3724),
    [anon_sym_lock] = ACTIONS(3726),
    [anon_sym_rlock] = ACTIONS(3726),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [856] = {
    [sym_line_comment] = STATE(856),
    [sym_block_comment] = STATE(856),
    [sym__expression] = STATE(2234),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3714),
    [anon_sym_go] = ACTIONS(3716),
    [anon_sym_spawn] = ACTIONS(3718),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3710),
    [anon_sym_CARET] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3720),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3724),
    [anon_sym_lock] = ACTIONS(3726),
    [anon_sym_rlock] = ACTIONS(3726),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [857] = {
    [sym_line_comment] = STATE(857),
    [sym_block_comment] = STATE(857),
    [sym__expression] = STATE(2325),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3714),
    [anon_sym_go] = ACTIONS(3716),
    [anon_sym_spawn] = ACTIONS(3718),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3710),
    [anon_sym_CARET] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3720),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3724),
    [anon_sym_lock] = ACTIONS(3726),
    [anon_sym_rlock] = ACTIONS(3726),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [858] = {
    [sym_line_comment] = STATE(858),
    [sym_block_comment] = STATE(858),
    [sym__expression] = STATE(2334),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3714),
    [anon_sym_go] = ACTIONS(3716),
    [anon_sym_spawn] = ACTIONS(3718),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3710),
    [anon_sym_CARET] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3720),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3724),
    [anon_sym_lock] = ACTIONS(3726),
    [anon_sym_rlock] = ACTIONS(3726),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [859] = {
    [sym_line_comment] = STATE(859),
    [sym_block_comment] = STATE(859),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3662),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [860] = {
    [sym_line_comment] = STATE(860),
    [sym_block_comment] = STATE(860),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [861] = {
    [sym_line_comment] = STATE(861),
    [sym_block_comment] = STATE(861),
    [sym__expression] = STATE(2339),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3714),
    [anon_sym_go] = ACTIONS(3716),
    [anon_sym_spawn] = ACTIONS(3718),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3710),
    [anon_sym_CARET] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3720),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3724),
    [anon_sym_lock] = ACTIONS(3726),
    [anon_sym_rlock] = ACTIONS(3726),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [862] = {
    [sym_line_comment] = STATE(862),
    [sym_block_comment] = STATE(862),
    [sym__expression] = STATE(2314),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3714),
    [anon_sym_go] = ACTIONS(3716),
    [anon_sym_spawn] = ACTIONS(3718),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3710),
    [anon_sym_CARET] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3720),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3724),
    [anon_sym_lock] = ACTIONS(3726),
    [anon_sym_rlock] = ACTIONS(3726),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [863] = {
    [sym_line_comment] = STATE(863),
    [sym_block_comment] = STATE(863),
    [sym__expression] = STATE(2566),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4270),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3486),
    [anon_sym_STAR] = ACTIONS(3488),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3490),
    [anon_sym_go] = ACTIONS(3492),
    [anon_sym_spawn] = ACTIONS(3494),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(3486),
    [anon_sym_CARET] = ACTIONS(3486),
    [anon_sym_AMP] = ACTIONS(3496),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3500),
    [anon_sym_lock] = ACTIONS(3502),
    [anon_sym_rlock] = ACTIONS(3502),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [864] = {
    [sym_line_comment] = STATE(864),
    [sym_block_comment] = STATE(864),
    [sym__expression] = STATE(2863),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [865] = {
    [sym_line_comment] = STATE(865),
    [sym_block_comment] = STATE(865),
    [sym__expression] = STATE(2567),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4270),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3486),
    [anon_sym_STAR] = ACTIONS(3488),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3490),
    [anon_sym_go] = ACTIONS(3492),
    [anon_sym_spawn] = ACTIONS(3494),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(3486),
    [anon_sym_CARET] = ACTIONS(3486),
    [anon_sym_AMP] = ACTIONS(3496),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3500),
    [anon_sym_lock] = ACTIONS(3502),
    [anon_sym_rlock] = ACTIONS(3502),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [866] = {
    [sym_line_comment] = STATE(866),
    [sym_block_comment] = STATE(866),
    [sym__expression] = STATE(2568),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4270),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3486),
    [anon_sym_STAR] = ACTIONS(3488),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3490),
    [anon_sym_go] = ACTIONS(3492),
    [anon_sym_spawn] = ACTIONS(3494),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(3486),
    [anon_sym_CARET] = ACTIONS(3486),
    [anon_sym_AMP] = ACTIONS(3496),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3500),
    [anon_sym_lock] = ACTIONS(3502),
    [anon_sym_rlock] = ACTIONS(3502),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [867] = {
    [sym_line_comment] = STATE(867),
    [sym_block_comment] = STATE(867),
    [sym__expression] = STATE(2573),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4270),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3486),
    [anon_sym_STAR] = ACTIONS(3488),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3490),
    [anon_sym_go] = ACTIONS(3492),
    [anon_sym_spawn] = ACTIONS(3494),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(3486),
    [anon_sym_CARET] = ACTIONS(3486),
    [anon_sym_AMP] = ACTIONS(3496),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3500),
    [anon_sym_lock] = ACTIONS(3502),
    [anon_sym_rlock] = ACTIONS(3502),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [868] = {
    [sym_line_comment] = STATE(868),
    [sym_block_comment] = STATE(868),
    [sym__expression] = STATE(2576),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4270),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3486),
    [anon_sym_STAR] = ACTIONS(3488),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3490),
    [anon_sym_go] = ACTIONS(3492),
    [anon_sym_spawn] = ACTIONS(3494),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(3486),
    [anon_sym_CARET] = ACTIONS(3486),
    [anon_sym_AMP] = ACTIONS(3496),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3500),
    [anon_sym_lock] = ACTIONS(3502),
    [anon_sym_rlock] = ACTIONS(3502),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [869] = {
    [sym_line_comment] = STATE(869),
    [sym_block_comment] = STATE(869),
    [sym__expression] = STATE(2598),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_go] = ACTIONS(2681),
    [anon_sym_spawn] = ACTIONS(2683),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_CARET] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2691),
    [anon_sym_lock] = ACTIONS(2693),
    [anon_sym_rlock] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [870] = {
    [sym_line_comment] = STATE(870),
    [sym_block_comment] = STATE(870),
    [sym__expression] = STATE(1274),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [anon_sym_STAR] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_go] = ACTIONS(901),
    [anon_sym_spawn] = ACTIONS(903),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3208),
    [anon_sym_CARET] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_LT_DASH] = ACTIONS(3220),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(921),
    [anon_sym_lock] = ACTIONS(923),
    [anon_sym_rlock] = ACTIONS(923),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [871] = {
    [sym_line_comment] = STATE(871),
    [sym_block_comment] = STATE(871),
    [sym__expression] = STATE(2856),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [872] = {
    [sym_line_comment] = STATE(872),
    [sym_block_comment] = STATE(872),
    [sym__expression] = STATE(2383),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [873] = {
    [sym_line_comment] = STATE(873),
    [sym_block_comment] = STATE(873),
    [sym__expression] = STATE(2861),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [874] = {
    [sym_line_comment] = STATE(874),
    [sym_block_comment] = STATE(874),
    [sym__expression] = STATE(987),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(947),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3534),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(3536),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [875] = {
    [sym_line_comment] = STATE(875),
    [sym_block_comment] = STATE(875),
    [sym__expression] = STATE(991),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(947),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3534),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(3536),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [876] = {
    [sym_line_comment] = STATE(876),
    [sym_block_comment] = STATE(876),
    [sym__expression] = STATE(2866),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [877] = {
    [sym_line_comment] = STATE(877),
    [sym_block_comment] = STATE(877),
    [sym__expression] = STATE(1985),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(1165),
    [anon_sym_lock] = ACTIONS(1167),
    [anon_sym_rlock] = ACTIONS(1167),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [878] = {
    [sym_line_comment] = STATE(878),
    [sym_block_comment] = STATE(878),
    [sym__expression] = STATE(2921),
    [sym__expression_without_blocks] = STATE(3033),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [879] = {
    [sym_line_comment] = STATE(879),
    [sym_block_comment] = STATE(879),
    [sym__expression] = STATE(2870),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [880] = {
    [sym_line_comment] = STATE(880),
    [sym_block_comment] = STATE(880),
    [sym__expression] = STATE(1985),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4222),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(1165),
    [anon_sym_lock] = ACTIONS(1167),
    [anon_sym_rlock] = ACTIONS(1167),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [881] = {
    [sym_line_comment] = STATE(881),
    [sym_block_comment] = STATE(881),
    [sym__expression] = STATE(982),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(947),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3534),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(3536),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [882] = {
    [sym_line_comment] = STATE(882),
    [sym_block_comment] = STATE(882),
    [sym__expression] = STATE(2922),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [883] = {
    [sym_line_comment] = STATE(883),
    [sym_block_comment] = STATE(883),
    [sym__expression] = STATE(1985),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4216),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(1165),
    [anon_sym_lock] = ACTIONS(1167),
    [anon_sym_rlock] = ACTIONS(1167),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [884] = {
    [sym_line_comment] = STATE(884),
    [sym_block_comment] = STATE(884),
    [sym__expression] = STATE(2580),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(950),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_go] = ACTIONS(2123),
    [anon_sym_spawn] = ACTIONS(2125),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(2133),
    [anon_sym_lock] = ACTIONS(2135),
    [anon_sym_rlock] = ACTIONS(2135),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [885] = {
    [sym_line_comment] = STATE(885),
    [sym_block_comment] = STATE(885),
    [sym__expression] = STATE(2381),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_DASH] = ACTIONS(3610),
    [anon_sym_STAR] = ACTIONS(3612),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_go] = ACTIONS(3618),
    [anon_sym_spawn] = ACTIONS(3620),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3610),
    [anon_sym_CARET] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3626),
    [anon_sym_LT_DASH] = ACTIONS(3628),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3638),
    [anon_sym_lock] = ACTIONS(3640),
    [anon_sym_rlock] = ACTIONS(3640),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [886] = {
    [sym_line_comment] = STATE(886),
    [sym_block_comment] = STATE(886),
    [sym__expression] = STATE(2234),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_DASH] = ACTIONS(3610),
    [anon_sym_STAR] = ACTIONS(3612),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_go] = ACTIONS(3618),
    [anon_sym_spawn] = ACTIONS(3620),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3610),
    [anon_sym_CARET] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3626),
    [anon_sym_LT_DASH] = ACTIONS(3628),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3638),
    [anon_sym_lock] = ACTIONS(3640),
    [anon_sym_rlock] = ACTIONS(3640),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [887] = {
    [sym_line_comment] = STATE(887),
    [sym_block_comment] = STATE(887),
    [sym__expression] = STATE(1972),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(1165),
    [anon_sym_lock] = ACTIONS(1167),
    [anon_sym_rlock] = ACTIONS(1167),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [888] = {
    [sym_line_comment] = STATE(888),
    [sym_block_comment] = STATE(888),
    [sym__expression] = STATE(1553),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_go] = ACTIONS(2903),
    [anon_sym_spawn] = ACTIONS(2905),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_LT_DASH] = ACTIONS(2909),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(2911),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_rlock] = ACTIONS(2913),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [889] = {
    [sym_line_comment] = STATE(889),
    [sym_block_comment] = STATE(889),
    [sym__expression] = STATE(1553),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4388),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_go] = ACTIONS(2903),
    [anon_sym_spawn] = ACTIONS(2905),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_LT_DASH] = ACTIONS(2909),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(2911),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_rlock] = ACTIONS(2913),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [890] = {
    [sym_line_comment] = STATE(890),
    [sym_block_comment] = STATE(890),
    [sym__expression] = STATE(2370),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_DASH] = ACTIONS(3610),
    [anon_sym_STAR] = ACTIONS(3612),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_go] = ACTIONS(3618),
    [anon_sym_spawn] = ACTIONS(3620),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3610),
    [anon_sym_CARET] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3626),
    [anon_sym_LT_DASH] = ACTIONS(3628),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3638),
    [anon_sym_lock] = ACTIONS(3640),
    [anon_sym_rlock] = ACTIONS(3640),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [891] = {
    [sym_line_comment] = STATE(891),
    [sym_block_comment] = STATE(891),
    [sym__expression] = STATE(985),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(947),
    [sym_plain_type] = STATE(4168),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3534),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(3536),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [892] = {
    [sym_line_comment] = STATE(892),
    [sym_block_comment] = STATE(892),
    [sym__expression] = STATE(1973),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(1165),
    [anon_sym_lock] = ACTIONS(1167),
    [anon_sym_rlock] = ACTIONS(1167),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [893] = {
    [sym_line_comment] = STATE(893),
    [sym_block_comment] = STATE(893),
    [sym__expression] = STATE(1985),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4215),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(1165),
    [anon_sym_lock] = ACTIONS(1167),
    [anon_sym_rlock] = ACTIONS(1167),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [894] = {
    [sym_line_comment] = STATE(894),
    [sym_block_comment] = STATE(894),
    [sym_type_parameters] = STATE(4185),
    [sym_argument_list] = STATE(1016),
    [sym_or_block] = STATE(1017),
    [aux_sym_strictly_expression_list_repeat1] = STATE(3389),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_LF] = ACTIONS(2037),
    [anon_sym_CR] = ACTIONS(2037),
    [anon_sym_CR_LF] = ACTIONS(2037),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2037),
    [anon_sym_DOT] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3752),
    [anon_sym_LBRACE] = ACTIONS(2037),
    [anon_sym_COMMA] = ACTIONS(3754),
    [anon_sym_RBRACE] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(2041),
    [anon_sym_fn] = ACTIONS(2037),
    [anon_sym_PLUS] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3758),
    [anon_sym_STAR] = ACTIONS(3760),
    [anon_sym_SLASH] = ACTIONS(3760),
    [anon_sym_PERCENT] = ACTIONS(3760),
    [anon_sym_LT] = ACTIONS(3762),
    [anon_sym_GT] = ACTIONS(3762),
    [anon_sym_EQ_EQ] = ACTIONS(3762),
    [anon_sym_BANG_EQ] = ACTIONS(3762),
    [anon_sym_LT_EQ] = ACTIONS(3762),
    [anon_sym_GT_EQ] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_struct] = ACTIONS(2037),
    [anon_sym_mut] = ACTIONS(2037),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_PLUS_PLUS] = ACTIONS(3768),
    [anon_sym_DASH_DASH] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3772),
    [anon_sym_BANG] = ACTIONS(3774),
    [anon_sym_go] = ACTIONS(2037),
    [anon_sym_spawn] = ACTIONS(2037),
    [anon_sym_json_DOTdecode] = ACTIONS(2037),
    [anon_sym_PIPE] = ACTIONS(3758),
    [anon_sym_LBRACK2] = ACTIONS(3776),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_CARET] = ACTIONS(3758),
    [anon_sym_AMP] = ACTIONS(3760),
    [anon_sym_LT_DASH] = ACTIONS(3778),
    [anon_sym_LT_LT] = ACTIONS(3780),
    [anon_sym_GT_GT] = ACTIONS(3760),
    [anon_sym_GT_GT_GT] = ACTIONS(3760),
    [anon_sym_AMP_CARET] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_or] = ACTIONS(3786),
    [sym_none] = ACTIONS(2037),
    [sym_true] = ACTIONS(2037),
    [sym_false] = ACTIONS(2037),
    [sym_nil] = ACTIONS(2037),
    [anon_sym_QMARK_DOT] = ACTIONS(3750),
    [anon_sym_POUND_LBRACK] = ACTIONS(3776),
    [anon_sym_if] = ACTIONS(2037),
    [anon_sym_DOLLARif] = ACTIONS(2037),
    [anon_sym_is] = ACTIONS(3788),
    [anon_sym_BANGis] = ACTIONS(3788),
    [anon_sym_in] = ACTIONS(3790),
    [anon_sym_BANGin] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(2037),
    [anon_sym_select] = ACTIONS(2037),
    [anon_sym_STAR_EQ] = ACTIONS(2041),
    [anon_sym_SLASH_EQ] = ACTIONS(2041),
    [anon_sym_PERCENT_EQ] = ACTIONS(2041),
    [anon_sym_LT_LT_EQ] = ACTIONS(2041),
    [anon_sym_GT_GT_EQ] = ACTIONS(2041),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2041),
    [anon_sym_AMP_EQ] = ACTIONS(2041),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2041),
    [anon_sym_PLUS_EQ] = ACTIONS(2041),
    [anon_sym_DASH_EQ] = ACTIONS(2041),
    [anon_sym_PIPE_EQ] = ACTIONS(2041),
    [anon_sym_CARET_EQ] = ACTIONS(2041),
    [anon_sym_COLON_EQ] = ACTIONS(2041),
    [anon_sym_lock] = ACTIONS(2037),
    [anon_sym_rlock] = ACTIONS(2037),
    [anon_sym_unsafe] = ACTIONS(2037),
    [anon_sym_sql] = ACTIONS(2037),
    [sym_int_literal] = ACTIONS(2037),
    [sym_float_literal] = ACTIONS(2037),
    [sym_rune_literal] = ACTIONS(2037),
    [anon_sym_SQUOTE] = ACTIONS(2037),
    [anon_sym_DQUOTE] = ACTIONS(2037),
    [anon_sym_c_SQUOTE] = ACTIONS(2037),
    [anon_sym_c_DQUOTE] = ACTIONS(2037),
    [anon_sym_r_SQUOTE] = ACTIONS(2037),
    [anon_sym_r_DQUOTE] = ACTIONS(2037),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2037),
    [anon_sym_shared] = ACTIONS(2037),
    [anon_sym_map_LBRACK] = ACTIONS(2037),
    [anon_sym_chan] = ACTIONS(2037),
    [anon_sym_thread] = ACTIONS(2037),
    [anon_sym_atomic] = ACTIONS(2037),
    [anon_sym_assert] = ACTIONS(2037),
    [anon_sym_defer] = ACTIONS(2037),
    [anon_sym_goto] = ACTIONS(2037),
    [anon_sym_break] = ACTIONS(2037),
    [anon_sym_continue] = ACTIONS(2037),
    [anon_sym_return] = ACTIONS(2037),
    [anon_sym_DOLLARfor] = ACTIONS(2037),
    [anon_sym_for] = ACTIONS(2037),
    [anon_sym_POUND] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2037),
  },
  [895] = {
    [sym_line_comment] = STATE(895),
    [sym_block_comment] = STATE(895),
    [sym__expression] = STATE(1553),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4401),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_go] = ACTIONS(2903),
    [anon_sym_spawn] = ACTIONS(2905),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_LT_DASH] = ACTIONS(2909),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(2911),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_rlock] = ACTIONS(2913),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [896] = {
    [sym_line_comment] = STATE(896),
    [sym_block_comment] = STATE(896),
    [sym__expression] = STATE(1569),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_go] = ACTIONS(2903),
    [anon_sym_spawn] = ACTIONS(2905),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_LT_DASH] = ACTIONS(2909),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(2911),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_rlock] = ACTIONS(2913),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [897] = {
    [sym_line_comment] = STATE(897),
    [sym_block_comment] = STATE(897),
    [sym__expression] = STATE(1567),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_go] = ACTIONS(2903),
    [anon_sym_spawn] = ACTIONS(2905),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_LT_DASH] = ACTIONS(2909),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(2911),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_rlock] = ACTIONS(2913),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [898] = {
    [sym_line_comment] = STATE(898),
    [sym_block_comment] = STATE(898),
    [sym__expression] = STATE(1553),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4404),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_go] = ACTIONS(2903),
    [anon_sym_spawn] = ACTIONS(2905),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_LT_DASH] = ACTIONS(2909),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(2911),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_rlock] = ACTIONS(2913),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [899] = {
    [sym_line_comment] = STATE(899),
    [sym_block_comment] = STATE(899),
    [sym__expression] = STATE(1555),
    [sym__expression_without_blocks] = STATE(1654),
    [sym__expression_with_blocks] = STATE(1654),
    [sym_inc_expression] = STATE(1656),
    [sym_dec_expression] = STATE(1656),
    [sym_or_block_expression] = STATE(1656),
    [sym_option_propagation_expression] = STATE(1656),
    [sym_result_propagation_expression] = STATE(1656),
    [sym_anon_struct_value_expression] = STATE(1659),
    [sym_go_expression] = STATE(1656),
    [sym_spawn_expression] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_type_initializer] = STATE(1659),
    [sym_function_literal] = STATE(1656),
    [sym_reference_expression] = STATE(1607),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1656),
    [sym_receive_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_as_type_cast_expression] = STATE(1656),
    [sym__max_group] = STATE(1656),
    [sym_literal] = STATE(1642),
    [sym_map_init_expression] = STATE(1659),
    [sym_array_creation] = STATE(1656),
    [sym_fixed_array_creation] = STATE(1656),
    [sym_selector_expression] = STATE(1656),
    [sym_index_expression] = STATE(1656),
    [sym_slice_expression] = STATE(1656),
    [sym_if_expression] = STATE(1659),
    [sym_compile_time_if_expression] = STATE(1659),
    [sym_is_expression] = STATE(1656),
    [sym_in_expression] = STATE(1656),
    [sym_enum_fetch] = STATE(1656),
    [sym_match_expression] = STATE(1659),
    [sym_select_expression] = STATE(1659),
    [sym_lock_expression] = STATE(1659),
    [sym_unsafe_expression] = STATE(1659),
    [sym_sql_expression] = STATE(1659),
    [sym_interpreted_string_literal] = STATE(1564),
    [sym_c_string_literal] = STATE(1564),
    [sym_raw_string_literal] = STATE(1564),
    [sym_mutability_modifiers] = STATE(939),
    [sym_plain_type] = STATE(4302),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_go] = ACTIONS(2903),
    [anon_sym_spawn] = ACTIONS(2905),
    [anon_sym_json_DOTdecode] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_LT_DASH] = ACTIONS(2909),
    [sym_none] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_nil] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_DOLLARif] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1605),
    [anon_sym_select] = ACTIONS(2911),
    [anon_sym_lock] = ACTIONS(2913),
    [anon_sym_rlock] = ACTIONS(2913),
    [anon_sym_unsafe] = ACTIONS(2407),
    [anon_sym_sql] = ACTIONS(1613),
    [sym_int_literal] = ACTIONS(1599),
    [sym_float_literal] = ACTIONS(1617),
    [sym_rune_literal] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_c_SQUOTE] = ACTIONS(1623),
    [anon_sym_c_DQUOTE] = ACTIONS(1625),
    [anon_sym_r_SQUOTE] = ACTIONS(1627),
    [anon_sym_r_DQUOTE] = ACTIONS(1629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1631),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [900] = {
    [sym_line_comment] = STATE(900),
    [sym_block_comment] = STATE(900),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [901] = {
    [sym_line_comment] = STATE(901),
    [sym_block_comment] = STATE(901),
    [sym__expression] = STATE(1967),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(1165),
    [anon_sym_lock] = ACTIONS(1167),
    [anon_sym_rlock] = ACTIONS(1167),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [902] = {
    [sym_line_comment] = STATE(902),
    [sym_block_comment] = STATE(902),
    [sym__expression] = STATE(994),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(947),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3534),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(3536),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [903] = {
    [sym_line_comment] = STATE(903),
    [sym_block_comment] = STATE(903),
    [sym__expression] = STATE(2801),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [904] = {
    [sym_line_comment] = STATE(904),
    [sym_block_comment] = STATE(904),
    [sym__expression] = STATE(983),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(947),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3534),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(3536),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [905] = {
    [sym_line_comment] = STATE(905),
    [sym_block_comment] = STATE(905),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3662),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [906] = {
    [sym_line_comment] = STATE(906),
    [sym_block_comment] = STATE(906),
    [sym__expression] = STATE(1276),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [anon_sym_STAR] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_go] = ACTIONS(901),
    [anon_sym_spawn] = ACTIONS(903),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3208),
    [anon_sym_CARET] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_LT_DASH] = ACTIONS(3220),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(921),
    [anon_sym_lock] = ACTIONS(923),
    [anon_sym_rlock] = ACTIONS(923),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [907] = {
    [sym_line_comment] = STATE(907),
    [sym_block_comment] = STATE(907),
    [sym__expression] = STATE(1275),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4133),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [anon_sym_STAR] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_go] = ACTIONS(901),
    [anon_sym_spawn] = ACTIONS(903),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3208),
    [anon_sym_CARET] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_LT_DASH] = ACTIONS(3220),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(921),
    [anon_sym_lock] = ACTIONS(923),
    [anon_sym_rlock] = ACTIONS(923),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [908] = {
    [sym_line_comment] = STATE(908),
    [sym_block_comment] = STATE(908),
    [sym__expression] = STATE(1272),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [anon_sym_STAR] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_go] = ACTIONS(901),
    [anon_sym_spawn] = ACTIONS(903),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3208),
    [anon_sym_CARET] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_LT_DASH] = ACTIONS(3220),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(921),
    [anon_sym_lock] = ACTIONS(923),
    [anon_sym_rlock] = ACTIONS(923),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [909] = {
    [sym_line_comment] = STATE(909),
    [sym_block_comment] = STATE(909),
    [sym__expression] = STATE(1265),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [anon_sym_STAR] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_go] = ACTIONS(901),
    [anon_sym_spawn] = ACTIONS(903),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3208),
    [anon_sym_CARET] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_LT_DASH] = ACTIONS(3220),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(921),
    [anon_sym_lock] = ACTIONS(923),
    [anon_sym_rlock] = ACTIONS(923),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [910] = {
    [sym_line_comment] = STATE(910),
    [sym_block_comment] = STATE(910),
    [sym__expression] = STATE(1275),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4137),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [anon_sym_STAR] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_go] = ACTIONS(901),
    [anon_sym_spawn] = ACTIONS(903),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3208),
    [anon_sym_CARET] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_LT_DASH] = ACTIONS(3220),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(921),
    [anon_sym_lock] = ACTIONS(923),
    [anon_sym_rlock] = ACTIONS(923),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [911] = {
    [sym_line_comment] = STATE(911),
    [sym_block_comment] = STATE(911),
    [sym__expression] = STATE(1275),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4103),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [anon_sym_STAR] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_go] = ACTIONS(901),
    [anon_sym_spawn] = ACTIONS(903),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3208),
    [anon_sym_CARET] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_LT_DASH] = ACTIONS(3220),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(921),
    [anon_sym_lock] = ACTIONS(923),
    [anon_sym_rlock] = ACTIONS(923),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [912] = {
    [sym_line_comment] = STATE(912),
    [sym_block_comment] = STATE(912),
    [sym__expression] = STATE(2806),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [913] = {
    [sym_line_comment] = STATE(913),
    [sym_block_comment] = STATE(913),
    [sym__expression] = STATE(2807),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [914] = {
    [sym_line_comment] = STATE(914),
    [sym_block_comment] = STATE(914),
    [sym__expression] = STATE(2887),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [915] = {
    [sym_line_comment] = STATE(915),
    [sym_block_comment] = STATE(915),
    [sym__expression] = STATE(2383),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [916] = {
    [sym_line_comment] = STATE(916),
    [sym_block_comment] = STATE(916),
    [sym__expression] = STATE(2890),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [917] = {
    [sym_line_comment] = STATE(917),
    [sym_block_comment] = STATE(917),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3683),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [918] = {
    [sym_line_comment] = STATE(918),
    [sym_block_comment] = STATE(918),
    [sym__expression] = STATE(997),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(947),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3534),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(3536),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [919] = {
    [sym_line_comment] = STATE(919),
    [sym_block_comment] = STATE(919),
    [sym__expression] = STATE(1275),
    [sym__expression_without_blocks] = STATE(1314),
    [sym__expression_with_blocks] = STATE(1314),
    [sym_inc_expression] = STATE(1317),
    [sym_dec_expression] = STATE(1317),
    [sym_or_block_expression] = STATE(1317),
    [sym_option_propagation_expression] = STATE(1317),
    [sym_result_propagation_expression] = STATE(1317),
    [sym_anon_struct_value_expression] = STATE(1319),
    [sym_go_expression] = STATE(1317),
    [sym_spawn_expression] = STATE(1317),
    [sym_parenthesized_expression] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_type_initializer] = STATE(1319),
    [sym_function_literal] = STATE(1317),
    [sym_reference_expression] = STATE(1363),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1317),
    [sym_receive_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_as_type_cast_expression] = STATE(1317),
    [sym__max_group] = STATE(1317),
    [sym_literal] = STATE(1313),
    [sym_map_init_expression] = STATE(1319),
    [sym_array_creation] = STATE(1317),
    [sym_fixed_array_creation] = STATE(1317),
    [sym_selector_expression] = STATE(1317),
    [sym_index_expression] = STATE(1317),
    [sym_slice_expression] = STATE(1317),
    [sym_if_expression] = STATE(1319),
    [sym_compile_time_if_expression] = STATE(1319),
    [sym_is_expression] = STATE(1317),
    [sym_in_expression] = STATE(1317),
    [sym_enum_fetch] = STATE(1317),
    [sym_match_expression] = STATE(1319),
    [sym_select_expression] = STATE(1319),
    [sym_lock_expression] = STATE(1319),
    [sym_unsafe_expression] = STATE(1319),
    [sym_sql_expression] = STATE(1319),
    [sym_interpreted_string_literal] = STATE(1311),
    [sym_c_string_literal] = STATE(1311),
    [sym_raw_string_literal] = STATE(1311),
    [sym_mutability_modifiers] = STATE(948),
    [sym_plain_type] = STATE(4097),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [anon_sym_STAR] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_go] = ACTIONS(901),
    [anon_sym_spawn] = ACTIONS(903),
    [anon_sym_json_DOTdecode] = ACTIONS(3214),
    [anon_sym_LBRACK2] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3208),
    [anon_sym_CARET] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_LT_DASH] = ACTIONS(3220),
    [sym_none] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_nil] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_DOLLARif] = ACTIONS(917),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_select] = ACTIONS(921),
    [anon_sym_lock] = ACTIONS(923),
    [anon_sym_rlock] = ACTIONS(923),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_sql] = ACTIONS(927),
    [sym_int_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(3222),
    [sym_rune_literal] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_c_SQUOTE] = ACTIONS(3228),
    [anon_sym_c_DQUOTE] = ACTIONS(3230),
    [anon_sym_r_SQUOTE] = ACTIONS(3232),
    [anon_sym_r_DQUOTE] = ACTIONS(3234),
    [sym_pseudo_compile_time_identifier] = ACTIONS(941),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [920] = {
    [sym_line_comment] = STATE(920),
    [sym_block_comment] = STATE(920),
    [sym__expression] = STATE(2898),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [921] = {
    [sym_line_comment] = STATE(921),
    [sym_block_comment] = STATE(921),
    [sym__expression] = STATE(2896),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [922] = {
    [sym_line_comment] = STATE(922),
    [sym_block_comment] = STATE(922),
    [sym__expression] = STATE(2378),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3692),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [923] = {
    [sym_line_comment] = STATE(923),
    [sym_block_comment] = STATE(923),
    [sym__expression] = STATE(985),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(947),
    [sym_plain_type] = STATE(4166),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3534),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(3536),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [924] = {
    [sym_line_comment] = STATE(924),
    [sym_block_comment] = STATE(924),
    [sym__expression] = STATE(2375),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [925] = {
    [sym_line_comment] = STATE(925),
    [sym_block_comment] = STATE(925),
    [sym__expression] = STATE(2520),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4270),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3486),
    [anon_sym_STAR] = ACTIONS(3488),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3490),
    [anon_sym_go] = ACTIONS(3492),
    [anon_sym_spawn] = ACTIONS(3494),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(3486),
    [anon_sym_CARET] = ACTIONS(3486),
    [anon_sym_AMP] = ACTIONS(3496),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3500),
    [anon_sym_lock] = ACTIONS(3502),
    [anon_sym_rlock] = ACTIONS(3502),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [926] = {
    [sym_line_comment] = STATE(926),
    [sym_block_comment] = STATE(926),
    [sym__expression] = STATE(2380),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_DASH] = ACTIONS(3610),
    [anon_sym_STAR] = ACTIONS(3612),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_go] = ACTIONS(3618),
    [anon_sym_spawn] = ACTIONS(3620),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3610),
    [anon_sym_CARET] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3626),
    [anon_sym_LT_DASH] = ACTIONS(3628),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3638),
    [anon_sym_lock] = ACTIONS(3640),
    [anon_sym_rlock] = ACTIONS(3640),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [927] = {
    [sym_line_comment] = STATE(927),
    [sym_block_comment] = STATE(927),
    [sym__expression] = STATE(2385),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_DASH] = ACTIONS(3610),
    [anon_sym_STAR] = ACTIONS(3612),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_go] = ACTIONS(3618),
    [anon_sym_spawn] = ACTIONS(3620),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3610),
    [anon_sym_CARET] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3626),
    [anon_sym_LT_DASH] = ACTIONS(3628),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3638),
    [anon_sym_lock] = ACTIONS(3640),
    [anon_sym_rlock] = ACTIONS(3640),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [928] = {
    [sym_line_comment] = STATE(928),
    [sym_block_comment] = STATE(928),
    [sym__expression] = STATE(2387),
    [sym__expression_without_blocks] = STATE(2359),
    [sym__expression_with_blocks] = STATE(2359),
    [sym_inc_expression] = STATE(2369),
    [sym_dec_expression] = STATE(2369),
    [sym_or_block_expression] = STATE(2369),
    [sym_option_propagation_expression] = STATE(2369),
    [sym_result_propagation_expression] = STATE(2369),
    [sym_anon_struct_value_expression] = STATE(2368),
    [sym_go_expression] = STATE(2369),
    [sym_spawn_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_type_initializer] = STATE(2368),
    [sym_function_literal] = STATE(2369),
    [sym_reference_expression] = STATE(2367),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2369),
    [sym_receive_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_as_type_cast_expression] = STATE(2369),
    [sym__max_group] = STATE(2369),
    [sym_literal] = STATE(2358),
    [sym_map_init_expression] = STATE(2368),
    [sym_array_creation] = STATE(2369),
    [sym_fixed_array_creation] = STATE(2369),
    [sym_selector_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_slice_expression] = STATE(2369),
    [sym_if_expression] = STATE(2368),
    [sym_compile_time_if_expression] = STATE(2368),
    [sym_is_expression] = STATE(2369),
    [sym_in_expression] = STATE(2369),
    [sym_enum_fetch] = STATE(2369),
    [sym_match_expression] = STATE(2368),
    [sym_select_expression] = STATE(2368),
    [sym_lock_expression] = STATE(2368),
    [sym_unsafe_expression] = STATE(2368),
    [sym_sql_expression] = STATE(2368),
    [sym_interpreted_string_literal] = STATE(2276),
    [sym_c_string_literal] = STATE(2276),
    [sym_raw_string_literal] = STATE(2276),
    [sym_mutability_modifiers] = STATE(955),
    [sym_plain_type] = STATE(4284),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_fn] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_DASH] = ACTIONS(3610),
    [anon_sym_STAR] = ACTIONS(3612),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_go] = ACTIONS(3618),
    [anon_sym_spawn] = ACTIONS(3620),
    [anon_sym_json_DOTdecode] = ACTIONS(3622),
    [anon_sym_LBRACK2] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3610),
    [anon_sym_CARET] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3626),
    [anon_sym_LT_DASH] = ACTIONS(3628),
    [sym_none] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_nil] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_DOLLARif] = ACTIONS(3634),
    [anon_sym_match] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3638),
    [anon_sym_lock] = ACTIONS(3640),
    [anon_sym_rlock] = ACTIONS(3640),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_sql] = ACTIONS(3644),
    [sym_int_literal] = ACTIONS(3630),
    [sym_float_literal] = ACTIONS(3646),
    [sym_rune_literal] = ACTIONS(3646),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [anon_sym_c_SQUOTE] = ACTIONS(3652),
    [anon_sym_c_DQUOTE] = ACTIONS(3654),
    [anon_sym_r_SQUOTE] = ACTIONS(3656),
    [anon_sym_r_DQUOTE] = ACTIONS(3658),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3660),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [929] = {
    [sym_line_comment] = STATE(929),
    [sym_block_comment] = STATE(929),
    [sym__expression] = STATE(2557),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4270),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3486),
    [anon_sym_STAR] = ACTIONS(3488),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3490),
    [anon_sym_go] = ACTIONS(3492),
    [anon_sym_spawn] = ACTIONS(3494),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(3486),
    [anon_sym_CARET] = ACTIONS(3486),
    [anon_sym_AMP] = ACTIONS(3496),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3500),
    [anon_sym_lock] = ACTIONS(3502),
    [anon_sym_rlock] = ACTIONS(3502),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [930] = {
    [sym_line_comment] = STATE(930),
    [sym_block_comment] = STATE(930),
    [sym__expression] = STATE(2574),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4270),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3486),
    [anon_sym_STAR] = ACTIONS(3488),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3490),
    [anon_sym_go] = ACTIONS(3492),
    [anon_sym_spawn] = ACTIONS(3494),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(3486),
    [anon_sym_CARET] = ACTIONS(3486),
    [anon_sym_AMP] = ACTIONS(3496),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3500),
    [anon_sym_lock] = ACTIONS(3502),
    [anon_sym_rlock] = ACTIONS(3502),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [931] = {
    [sym_line_comment] = STATE(931),
    [sym_block_comment] = STATE(931),
    [sym__expression] = STATE(2513),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4270),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3486),
    [anon_sym_STAR] = ACTIONS(3488),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3490),
    [anon_sym_go] = ACTIONS(3492),
    [anon_sym_spawn] = ACTIONS(3494),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(3486),
    [anon_sym_CARET] = ACTIONS(3486),
    [anon_sym_AMP] = ACTIONS(3496),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3500),
    [anon_sym_lock] = ACTIONS(3502),
    [anon_sym_rlock] = ACTIONS(3502),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [932] = {
    [sym_line_comment] = STATE(932),
    [sym_block_comment] = STATE(932),
    [sym__expression] = STATE(2023),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_go] = ACTIONS(3372),
    [anon_sym_spawn] = ACTIONS(3374),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_LT_DASH] = ACTIONS(3380),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(3382),
    [anon_sym_lock] = ACTIONS(3384),
    [anon_sym_rlock] = ACTIONS(3384),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [933] = {
    [sym_line_comment] = STATE(933),
    [sym_block_comment] = STATE(933),
    [sym__expression] = STATE(2520),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(3878),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(3708),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3390),
    [anon_sym_lock] = ACTIONS(3392),
    [anon_sym_rlock] = ACTIONS(3392),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [934] = {
    [sym_line_comment] = STATE(934),
    [sym_block_comment] = STATE(934),
    [sym__expression] = STATE(2520),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(3883),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(3708),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3390),
    [anon_sym_lock] = ACTIONS(3392),
    [anon_sym_rlock] = ACTIONS(3392),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [935] = {
    [sym_line_comment] = STATE(935),
    [sym_block_comment] = STATE(935),
    [sym__expression] = STATE(985),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(947),
    [sym_plain_type] = STATE(4155),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3534),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(3536),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [936] = {
    [sym_line_comment] = STATE(936),
    [sym_block_comment] = STATE(936),
    [sym__expression] = STATE(985),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(947),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3534),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(3536),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [937] = {
    [sym_line_comment] = STATE(937),
    [sym_block_comment] = STATE(937),
    [sym__expression] = STATE(2520),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(3885),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(3708),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3390),
    [anon_sym_lock] = ACTIONS(3392),
    [anon_sym_rlock] = ACTIONS(3392),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [938] = {
    [sym_line_comment] = STATE(938),
    [sym_block_comment] = STATE(938),
    [sym__expression] = STATE(2020),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_go] = ACTIONS(3372),
    [anon_sym_spawn] = ACTIONS(3374),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_LT_DASH] = ACTIONS(3380),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(3382),
    [anon_sym_lock] = ACTIONS(3384),
    [anon_sym_rlock] = ACTIONS(3384),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [939] = {
    [sym_line_comment] = STATE(939),
    [sym_block_comment] = STATE(939),
    [sym__expression] = STATE(2927),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [940] = {
    [sym_line_comment] = STATE(940),
    [sym_block_comment] = STATE(940),
    [sym__expression] = STATE(2534),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4270),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(3708),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3390),
    [anon_sym_lock] = ACTIONS(3392),
    [anon_sym_rlock] = ACTIONS(3392),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [941] = {
    [sym_line_comment] = STATE(941),
    [sym_block_comment] = STATE(941),
    [sym__expression] = STATE(1993),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_go] = ACTIONS(3372),
    [anon_sym_spawn] = ACTIONS(3374),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_LT_DASH] = ACTIONS(3380),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(3382),
    [anon_sym_lock] = ACTIONS(3384),
    [anon_sym_rlock] = ACTIONS(3384),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [942] = {
    [sym_line_comment] = STATE(942),
    [sym_block_comment] = STATE(942),
    [sym__expression] = STATE(1123),
    [sym__expression_without_blocks] = STATE(1252),
    [sym__expression_with_blocks] = STATE(1252),
    [sym_inc_expression] = STATE(1251),
    [sym_dec_expression] = STATE(1251),
    [sym_or_block_expression] = STATE(1251),
    [sym_option_propagation_expression] = STATE(1251),
    [sym_result_propagation_expression] = STATE(1251),
    [sym_anon_struct_value_expression] = STATE(1250),
    [sym_go_expression] = STATE(1251),
    [sym_spawn_expression] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_call_expression] = STATE(1251),
    [sym_type_initializer] = STATE(1250),
    [sym_function_literal] = STATE(1251),
    [sym_reference_expression] = STATE(1175),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1251),
    [sym_receive_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_as_type_cast_expression] = STATE(1251),
    [sym__max_group] = STATE(1251),
    [sym_literal] = STATE(1256),
    [sym_map_init_expression] = STATE(1250),
    [sym_array_creation] = STATE(1251),
    [sym_fixed_array_creation] = STATE(1251),
    [sym_selector_expression] = STATE(1251),
    [sym_index_expression] = STATE(1251),
    [sym_slice_expression] = STATE(1251),
    [sym_if_expression] = STATE(1250),
    [sym_compile_time_if_expression] = STATE(1250),
    [sym_is_expression] = STATE(1251),
    [sym_in_expression] = STATE(1251),
    [sym_enum_fetch] = STATE(1251),
    [sym_match_expression] = STATE(1250),
    [sym_select_expression] = STATE(1250),
    [sym_lock_expression] = STATE(1250),
    [sym_unsafe_expression] = STATE(1250),
    [sym_sql_expression] = STATE(1250),
    [sym_interpreted_string_literal] = STATE(1257),
    [sym_c_string_literal] = STATE(1257),
    [sym_raw_string_literal] = STATE(1257),
    [sym_mutability_modifiers] = STATE(943),
    [sym_plain_type] = STATE(4338),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_fn] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2481),
    [anon_sym_go] = ACTIONS(775),
    [anon_sym_spawn] = ACTIONS(777),
    [anon_sym_json_DOTdecode] = ACTIONS(2483),
    [anon_sym_LBRACK2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_LT_DASH] = ACTIONS(2489),
    [sym_none] = ACTIONS(787),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_nil] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_DOLLARif] = ACTIONS(791),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_select] = ACTIONS(795),
    [anon_sym_lock] = ACTIONS(797),
    [anon_sym_rlock] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(799),
    [anon_sym_sql] = ACTIONS(801),
    [sym_int_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(2491),
    [sym_rune_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_c_SQUOTE] = ACTIONS(2497),
    [anon_sym_c_DQUOTE] = ACTIONS(2499),
    [anon_sym_r_SQUOTE] = ACTIONS(2501),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [sym_pseudo_compile_time_identifier] = ACTIONS(815),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [943] = {
    [sym_line_comment] = STATE(943),
    [sym_block_comment] = STATE(943),
    [sym__expression] = STATE(2928),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [944] = {
    [sym_line_comment] = STATE(944),
    [sym_block_comment] = STATE(944),
    [sym__expression] = STATE(2923),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [945] = {
    [sym_line_comment] = STATE(945),
    [sym_block_comment] = STATE(945),
    [sym__expression] = STATE(2523),
    [sym__expression_without_blocks] = STATE(2793),
    [sym__expression_with_blocks] = STATE(2793),
    [sym_inc_expression] = STATE(2880),
    [sym_dec_expression] = STATE(2880),
    [sym_or_block_expression] = STATE(2880),
    [sym_option_propagation_expression] = STATE(2880),
    [sym_result_propagation_expression] = STATE(2880),
    [sym_anon_struct_value_expression] = STATE(2785),
    [sym_go_expression] = STATE(2880),
    [sym_spawn_expression] = STATE(2880),
    [sym_parenthesized_expression] = STATE(2880),
    [sym_call_expression] = STATE(2880),
    [sym_type_initializer] = STATE(2785),
    [sym_function_literal] = STATE(2880),
    [sym_reference_expression] = STATE(2884),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2880),
    [sym_receive_expression] = STATE(2880),
    [sym_binary_expression] = STATE(2880),
    [sym_as_type_cast_expression] = STATE(2880),
    [sym__max_group] = STATE(2880),
    [sym_literal] = STATE(2877),
    [sym_map_init_expression] = STATE(2785),
    [sym_array_creation] = STATE(2880),
    [sym_fixed_array_creation] = STATE(2880),
    [sym_selector_expression] = STATE(2880),
    [sym_index_expression] = STATE(2880),
    [sym_slice_expression] = STATE(2880),
    [sym_if_expression] = STATE(2785),
    [sym_compile_time_if_expression] = STATE(2785),
    [sym_is_expression] = STATE(2880),
    [sym_in_expression] = STATE(2880),
    [sym_enum_fetch] = STATE(2880),
    [sym_match_expression] = STATE(2785),
    [sym_select_expression] = STATE(2785),
    [sym_lock_expression] = STATE(2785),
    [sym_unsafe_expression] = STATE(2785),
    [sym_sql_expression] = STATE(2785),
    [sym_interpreted_string_literal] = STATE(2854),
    [sym_c_string_literal] = STATE(2854),
    [sym_raw_string_literal] = STATE(2854),
    [sym_mutability_modifiers] = STATE(965),
    [sym_plain_type] = STATE(4143),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LPAREN] = ACTIONS(3544),
    [anon_sym_fn] = ACTIONS(3546),
    [anon_sym_PLUS] = ACTIONS(3548),
    [anon_sym_DASH] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3550),
    [anon_sym_struct] = ACTIONS(3552),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3554),
    [anon_sym_go] = ACTIONS(3556),
    [anon_sym_spawn] = ACTIONS(3558),
    [anon_sym_json_DOTdecode] = ACTIONS(3560),
    [anon_sym_LBRACK2] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3548),
    [anon_sym_CARET] = ACTIONS(3548),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_LT_DASH] = ACTIONS(3566),
    [sym_none] = ACTIONS(3568),
    [sym_true] = ACTIONS(3568),
    [sym_false] = ACTIONS(3568),
    [sym_nil] = ACTIONS(3568),
    [anon_sym_if] = ACTIONS(3570),
    [anon_sym_DOLLARif] = ACTIONS(3572),
    [anon_sym_match] = ACTIONS(3574),
    [anon_sym_select] = ACTIONS(3576),
    [anon_sym_lock] = ACTIONS(3578),
    [anon_sym_rlock] = ACTIONS(3578),
    [anon_sym_unsafe] = ACTIONS(3580),
    [anon_sym_sql] = ACTIONS(3582),
    [sym_int_literal] = ACTIONS(3568),
    [sym_float_literal] = ACTIONS(3584),
    [sym_rune_literal] = ACTIONS(3584),
    [anon_sym_SQUOTE] = ACTIONS(3586),
    [anon_sym_DQUOTE] = ACTIONS(3588),
    [anon_sym_c_SQUOTE] = ACTIONS(3590),
    [anon_sym_c_DQUOTE] = ACTIONS(3592),
    [anon_sym_r_SQUOTE] = ACTIONS(3594),
    [anon_sym_r_DQUOTE] = ACTIONS(3596),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3598),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [946] = {
    [sym_line_comment] = STATE(946),
    [sym_block_comment] = STATE(946),
    [sym__expression] = STATE(2526),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4270),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(3708),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3390),
    [anon_sym_lock] = ACTIONS(3392),
    [anon_sym_rlock] = ACTIONS(3392),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [947] = {
    [sym_line_comment] = STATE(947),
    [sym_block_comment] = STATE(947),
    [sym__expression] = STATE(2920),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [948] = {
    [sym_line_comment] = STATE(948),
    [sym_block_comment] = STATE(948),
    [sym__expression] = STATE(2915),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [949] = {
    [sym_line_comment] = STATE(949),
    [sym_block_comment] = STATE(949),
    [sym__expression] = STATE(2914),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [950] = {
    [sym_line_comment] = STATE(950),
    [sym_block_comment] = STATE(950),
    [sym__expression] = STATE(2907),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [951] = {
    [sym_line_comment] = STATE(951),
    [sym_block_comment] = STATE(951),
    [sym__expression] = STATE(2608),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3462),
    [anon_sym_go] = ACTIONS(3464),
    [anon_sym_spawn] = ACTIONS(3466),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3470),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(3472),
    [anon_sym_lock] = ACTIONS(3474),
    [anon_sym_rlock] = ACTIONS(3474),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [952] = {
    [sym_line_comment] = STATE(952),
    [sym_block_comment] = STATE(952),
    [sym__expression] = STATE(252),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_mutability_modifiers] = STATE(789),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(3514),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(325),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(3516),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [953] = {
    [sym_line_comment] = STATE(953),
    [sym_block_comment] = STATE(953),
    [sym__expression] = STATE(249),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_mutability_modifiers] = STATE(789),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(3514),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(325),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(3516),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [954] = {
    [sym_line_comment] = STATE(954),
    [sym_block_comment] = STATE(954),
    [sym__expression] = STATE(248),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_mutability_modifiers] = STATE(789),
    [sym_plain_type] = STATE(4248),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(3514),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(325),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(3516),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [955] = {
    [sym_line_comment] = STATE(955),
    [sym_block_comment] = STATE(955),
    [sym__expression] = STATE(2913),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [956] = {
    [sym_line_comment] = STATE(956),
    [sym_block_comment] = STATE(956),
    [sym__expression] = STATE(251),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_mutability_modifiers] = STATE(789),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(3514),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(325),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(3516),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [957] = {
    [sym_line_comment] = STATE(957),
    [sym_block_comment] = STATE(957),
    [sym__expression] = STATE(254),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_mutability_modifiers] = STATE(789),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(3514),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(325),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(3516),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [958] = {
    [sym_line_comment] = STATE(958),
    [sym_block_comment] = STATE(958),
    [sym__expression] = STATE(248),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_mutability_modifiers] = STATE(789),
    [sym_plain_type] = STATE(4238),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(3514),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(325),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(3516),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [959] = {
    [sym_line_comment] = STATE(959),
    [sym_block_comment] = STATE(959),
    [sym__expression] = STATE(2911),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [960] = {
    [sym_line_comment] = STATE(960),
    [sym_block_comment] = STATE(960),
    [sym__expression] = STATE(2536),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4270),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(3708),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3390),
    [anon_sym_lock] = ACTIONS(3392),
    [anon_sym_rlock] = ACTIONS(3392),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [961] = {
    [sym_line_comment] = STATE(961),
    [sym_block_comment] = STATE(961),
    [sym__expression] = STATE(2530),
    [sym__expression_without_blocks] = STATE(2793),
    [sym__expression_with_blocks] = STATE(2793),
    [sym_inc_expression] = STATE(2880),
    [sym_dec_expression] = STATE(2880),
    [sym_or_block_expression] = STATE(2880),
    [sym_option_propagation_expression] = STATE(2880),
    [sym_result_propagation_expression] = STATE(2880),
    [sym_anon_struct_value_expression] = STATE(2785),
    [sym_go_expression] = STATE(2880),
    [sym_spawn_expression] = STATE(2880),
    [sym_parenthesized_expression] = STATE(2880),
    [sym_call_expression] = STATE(2880),
    [sym_type_initializer] = STATE(2785),
    [sym_function_literal] = STATE(2880),
    [sym_reference_expression] = STATE(2884),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2880),
    [sym_receive_expression] = STATE(2880),
    [sym_binary_expression] = STATE(2880),
    [sym_as_type_cast_expression] = STATE(2880),
    [sym__max_group] = STATE(2880),
    [sym_literal] = STATE(2877),
    [sym_map_init_expression] = STATE(2785),
    [sym_array_creation] = STATE(2880),
    [sym_fixed_array_creation] = STATE(2880),
    [sym_selector_expression] = STATE(2880),
    [sym_index_expression] = STATE(2880),
    [sym_slice_expression] = STATE(2880),
    [sym_if_expression] = STATE(2785),
    [sym_compile_time_if_expression] = STATE(2785),
    [sym_is_expression] = STATE(2880),
    [sym_in_expression] = STATE(2880),
    [sym_enum_fetch] = STATE(2880),
    [sym_match_expression] = STATE(2785),
    [sym_select_expression] = STATE(2785),
    [sym_lock_expression] = STATE(2785),
    [sym_unsafe_expression] = STATE(2785),
    [sym_sql_expression] = STATE(2785),
    [sym_interpreted_string_literal] = STATE(2854),
    [sym_c_string_literal] = STATE(2854),
    [sym_raw_string_literal] = STATE(2854),
    [sym_mutability_modifiers] = STATE(965),
    [sym_plain_type] = STATE(4143),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LPAREN] = ACTIONS(3544),
    [anon_sym_fn] = ACTIONS(3546),
    [anon_sym_PLUS] = ACTIONS(3548),
    [anon_sym_DASH] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3550),
    [anon_sym_struct] = ACTIONS(3552),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3554),
    [anon_sym_go] = ACTIONS(3556),
    [anon_sym_spawn] = ACTIONS(3558),
    [anon_sym_json_DOTdecode] = ACTIONS(3560),
    [anon_sym_LBRACK2] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3548),
    [anon_sym_CARET] = ACTIONS(3548),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_LT_DASH] = ACTIONS(3566),
    [sym_none] = ACTIONS(3568),
    [sym_true] = ACTIONS(3568),
    [sym_false] = ACTIONS(3568),
    [sym_nil] = ACTIONS(3568),
    [anon_sym_if] = ACTIONS(3570),
    [anon_sym_DOLLARif] = ACTIONS(3572),
    [anon_sym_match] = ACTIONS(3574),
    [anon_sym_select] = ACTIONS(3576),
    [anon_sym_lock] = ACTIONS(3578),
    [anon_sym_rlock] = ACTIONS(3578),
    [anon_sym_unsafe] = ACTIONS(3580),
    [anon_sym_sql] = ACTIONS(3582),
    [sym_int_literal] = ACTIONS(3568),
    [sym_float_literal] = ACTIONS(3584),
    [sym_rune_literal] = ACTIONS(3584),
    [anon_sym_SQUOTE] = ACTIONS(3586),
    [anon_sym_DQUOTE] = ACTIONS(3588),
    [anon_sym_c_SQUOTE] = ACTIONS(3590),
    [anon_sym_c_DQUOTE] = ACTIONS(3592),
    [anon_sym_r_SQUOTE] = ACTIONS(3594),
    [anon_sym_r_DQUOTE] = ACTIONS(3596),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3598),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [962] = {
    [sym_line_comment] = STATE(962),
    [sym_block_comment] = STATE(962),
    [sym__expression] = STATE(986),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(947),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3534),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(3536),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [963] = {
    [sym_line_comment] = STATE(963),
    [sym_block_comment] = STATE(963),
    [sym__expression] = STATE(989),
    [sym__expression_without_blocks] = STATE(1018),
    [sym__expression_with_blocks] = STATE(1018),
    [sym_inc_expression] = STATE(1020),
    [sym_dec_expression] = STATE(1020),
    [sym_or_block_expression] = STATE(1020),
    [sym_option_propagation_expression] = STATE(1020),
    [sym_result_propagation_expression] = STATE(1020),
    [sym_anon_struct_value_expression] = STATE(1022),
    [sym_go_expression] = STATE(1020),
    [sym_spawn_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_type_initializer] = STATE(1022),
    [sym_function_literal] = STATE(1020),
    [sym_reference_expression] = STATE(1027),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(1020),
    [sym_receive_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_as_type_cast_expression] = STATE(1020),
    [sym__max_group] = STATE(1020),
    [sym_literal] = STATE(1009),
    [sym_map_init_expression] = STATE(1022),
    [sym_array_creation] = STATE(1020),
    [sym_fixed_array_creation] = STATE(1020),
    [sym_selector_expression] = STATE(1020),
    [sym_index_expression] = STATE(1020),
    [sym_slice_expression] = STATE(1020),
    [sym_if_expression] = STATE(1022),
    [sym_compile_time_if_expression] = STATE(1022),
    [sym_is_expression] = STATE(1020),
    [sym_in_expression] = STATE(1020),
    [sym_enum_fetch] = STATE(1020),
    [sym_match_expression] = STATE(1022),
    [sym_select_expression] = STATE(1022),
    [sym_lock_expression] = STATE(1022),
    [sym_unsafe_expression] = STATE(1022),
    [sym_sql_expression] = STATE(1022),
    [sym_interpreted_string_literal] = STATE(1007),
    [sym_c_string_literal] = STATE(1007),
    [sym_raw_string_literal] = STATE(1007),
    [sym_mutability_modifiers] = STATE(947),
    [sym_plain_type] = STATE(4146),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3534),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(3536),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_fn] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_struct] = ACTIONS(367),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_go] = ACTIONS(371),
    [anon_sym_spawn] = ACTIONS(373),
    [anon_sym_json_DOTdecode] = ACTIONS(447),
    [anon_sym_LBRACK2] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [sym_none] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_nil] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_DOLLARif] = ACTIONS(387),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_lock] = ACTIONS(393),
    [anon_sym_rlock] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(395),
    [anon_sym_sql] = ACTIONS(397),
    [sym_int_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(455),
    [sym_rune_literal] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_c_SQUOTE] = ACTIONS(461),
    [anon_sym_c_DQUOTE] = ACTIONS(463),
    [anon_sym_r_SQUOTE] = ACTIONS(465),
    [anon_sym_r_DQUOTE] = ACTIONS(467),
    [sym_pseudo_compile_time_identifier] = ACTIONS(411),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [964] = {
    [sym_line_comment] = STATE(964),
    [sym_block_comment] = STATE(964),
    [sym__expression] = STATE(2906),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [965] = {
    [sym_line_comment] = STATE(965),
    [sym_block_comment] = STATE(965),
    [sym__expression] = STATE(2924),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(4383),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_go] = ACTIONS(1935),
    [anon_sym_spawn] = ACTIONS(1937),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_DASH] = ACTIONS(1945),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [966] = {
    [sym_line_comment] = STATE(966),
    [sym_block_comment] = STATE(966),
    [sym__expression] = STATE(2010),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_go] = ACTIONS(1145),
    [anon_sym_spawn] = ACTIONS(1147),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_LT_DASH] = ACTIONS(1155),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(1165),
    [anon_sym_lock] = ACTIONS(1167),
    [anon_sym_rlock] = ACTIONS(1167),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [967] = {
    [sym_line_comment] = STATE(967),
    [sym_block_comment] = STATE(967),
    [sym__expression] = STATE(2535),
    [sym__expression_without_blocks] = STATE(2793),
    [sym__expression_with_blocks] = STATE(2793),
    [sym_inc_expression] = STATE(2880),
    [sym_dec_expression] = STATE(2880),
    [sym_or_block_expression] = STATE(2880),
    [sym_option_propagation_expression] = STATE(2880),
    [sym_result_propagation_expression] = STATE(2880),
    [sym_anon_struct_value_expression] = STATE(2785),
    [sym_go_expression] = STATE(2880),
    [sym_spawn_expression] = STATE(2880),
    [sym_parenthesized_expression] = STATE(2880),
    [sym_call_expression] = STATE(2880),
    [sym_type_initializer] = STATE(2785),
    [sym_function_literal] = STATE(2880),
    [sym_reference_expression] = STATE(2884),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2880),
    [sym_receive_expression] = STATE(2880),
    [sym_binary_expression] = STATE(2880),
    [sym_as_type_cast_expression] = STATE(2880),
    [sym__max_group] = STATE(2880),
    [sym_literal] = STATE(2877),
    [sym_map_init_expression] = STATE(2785),
    [sym_array_creation] = STATE(2880),
    [sym_fixed_array_creation] = STATE(2880),
    [sym_selector_expression] = STATE(2880),
    [sym_index_expression] = STATE(2880),
    [sym_slice_expression] = STATE(2880),
    [sym_if_expression] = STATE(2785),
    [sym_compile_time_if_expression] = STATE(2785),
    [sym_is_expression] = STATE(2880),
    [sym_in_expression] = STATE(2880),
    [sym_enum_fetch] = STATE(2880),
    [sym_match_expression] = STATE(2785),
    [sym_select_expression] = STATE(2785),
    [sym_lock_expression] = STATE(2785),
    [sym_unsafe_expression] = STATE(2785),
    [sym_sql_expression] = STATE(2785),
    [sym_interpreted_string_literal] = STATE(2854),
    [sym_c_string_literal] = STATE(2854),
    [sym_raw_string_literal] = STATE(2854),
    [sym_mutability_modifiers] = STATE(965),
    [sym_plain_type] = STATE(4143),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LPAREN] = ACTIONS(3544),
    [anon_sym_fn] = ACTIONS(3546),
    [anon_sym_PLUS] = ACTIONS(3548),
    [anon_sym_DASH] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3550),
    [anon_sym_struct] = ACTIONS(3552),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3554),
    [anon_sym_go] = ACTIONS(3556),
    [anon_sym_spawn] = ACTIONS(3558),
    [anon_sym_json_DOTdecode] = ACTIONS(3560),
    [anon_sym_LBRACK2] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3548),
    [anon_sym_CARET] = ACTIONS(3548),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_LT_DASH] = ACTIONS(3566),
    [sym_none] = ACTIONS(3568),
    [sym_true] = ACTIONS(3568),
    [sym_false] = ACTIONS(3568),
    [sym_nil] = ACTIONS(3568),
    [anon_sym_if] = ACTIONS(3570),
    [anon_sym_DOLLARif] = ACTIONS(3572),
    [anon_sym_match] = ACTIONS(3574),
    [anon_sym_select] = ACTIONS(3576),
    [anon_sym_lock] = ACTIONS(3578),
    [anon_sym_rlock] = ACTIONS(3578),
    [anon_sym_unsafe] = ACTIONS(3580),
    [anon_sym_sql] = ACTIONS(3582),
    [sym_int_literal] = ACTIONS(3568),
    [sym_float_literal] = ACTIONS(3584),
    [sym_rune_literal] = ACTIONS(3584),
    [anon_sym_SQUOTE] = ACTIONS(3586),
    [anon_sym_DQUOTE] = ACTIONS(3588),
    [anon_sym_c_SQUOTE] = ACTIONS(3590),
    [anon_sym_c_DQUOTE] = ACTIONS(3592),
    [anon_sym_r_SQUOTE] = ACTIONS(3594),
    [anon_sym_r_DQUOTE] = ACTIONS(3596),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3598),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [968] = {
    [sym_line_comment] = STATE(968),
    [sym_block_comment] = STATE(968),
    [sym__expression] = STATE(1967),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_go] = ACTIONS(3372),
    [anon_sym_spawn] = ACTIONS(3374),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_LT_DASH] = ACTIONS(3380),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(3382),
    [anon_sym_lock] = ACTIONS(3384),
    [anon_sym_rlock] = ACTIONS(3384),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [969] = {
    [sym_line_comment] = STATE(969),
    [sym_block_comment] = STATE(969),
    [sym__expression] = STATE(248),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_mutability_modifiers] = STATE(789),
    [sym_plain_type] = STATE(4221),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(3514),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(325),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(3516),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [970] = {
    [sym_line_comment] = STATE(970),
    [sym_block_comment] = STATE(970),
    [sym__expression] = STATE(1985),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4215),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_go] = ACTIONS(3372),
    [anon_sym_spawn] = ACTIONS(3374),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_LT_DASH] = ACTIONS(3380),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(3382),
    [anon_sym_lock] = ACTIONS(3384),
    [anon_sym_rlock] = ACTIONS(3384),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [971] = {
    [sym_line_comment] = STATE(971),
    [sym_block_comment] = STATE(971),
    [sym__expression] = STATE(1989),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_go] = ACTIONS(3372),
    [anon_sym_spawn] = ACTIONS(3374),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_LT_DASH] = ACTIONS(3380),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(3382),
    [anon_sym_lock] = ACTIONS(3384),
    [anon_sym_rlock] = ACTIONS(3384),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [972] = {
    [sym_line_comment] = STATE(972),
    [sym_block_comment] = STATE(972),
    [sym__expression] = STATE(2000),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_go] = ACTIONS(3372),
    [anon_sym_spawn] = ACTIONS(3374),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_LT_DASH] = ACTIONS(3380),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(3382),
    [anon_sym_lock] = ACTIONS(3384),
    [anon_sym_rlock] = ACTIONS(3384),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [973] = {
    [sym_line_comment] = STATE(973),
    [sym_block_comment] = STATE(973),
    [sym__expression] = STATE(2504),
    [sym__expression_without_blocks] = STATE(2793),
    [sym__expression_with_blocks] = STATE(2793),
    [sym_inc_expression] = STATE(2880),
    [sym_dec_expression] = STATE(2880),
    [sym_or_block_expression] = STATE(2880),
    [sym_option_propagation_expression] = STATE(2880),
    [sym_result_propagation_expression] = STATE(2880),
    [sym_anon_struct_value_expression] = STATE(2785),
    [sym_go_expression] = STATE(2880),
    [sym_spawn_expression] = STATE(2880),
    [sym_parenthesized_expression] = STATE(2880),
    [sym_call_expression] = STATE(2880),
    [sym_type_initializer] = STATE(2785),
    [sym_function_literal] = STATE(2880),
    [sym_reference_expression] = STATE(2884),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2880),
    [sym_receive_expression] = STATE(2880),
    [sym_binary_expression] = STATE(2880),
    [sym_as_type_cast_expression] = STATE(2880),
    [sym__max_group] = STATE(2880),
    [sym_literal] = STATE(2877),
    [sym_map_init_expression] = STATE(2785),
    [sym_array_creation] = STATE(2880),
    [sym_fixed_array_creation] = STATE(2880),
    [sym_selector_expression] = STATE(2880),
    [sym_index_expression] = STATE(2880),
    [sym_slice_expression] = STATE(2880),
    [sym_if_expression] = STATE(2785),
    [sym_compile_time_if_expression] = STATE(2785),
    [sym_is_expression] = STATE(2880),
    [sym_in_expression] = STATE(2880),
    [sym_enum_fetch] = STATE(2880),
    [sym_match_expression] = STATE(2785),
    [sym_select_expression] = STATE(2785),
    [sym_lock_expression] = STATE(2785),
    [sym_unsafe_expression] = STATE(2785),
    [sym_sql_expression] = STATE(2785),
    [sym_interpreted_string_literal] = STATE(2854),
    [sym_c_string_literal] = STATE(2854),
    [sym_raw_string_literal] = STATE(2854),
    [sym_mutability_modifiers] = STATE(965),
    [sym_plain_type] = STATE(4143),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LPAREN] = ACTIONS(3544),
    [anon_sym_fn] = ACTIONS(3546),
    [anon_sym_PLUS] = ACTIONS(3548),
    [anon_sym_DASH] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3550),
    [anon_sym_struct] = ACTIONS(3552),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3554),
    [anon_sym_go] = ACTIONS(3556),
    [anon_sym_spawn] = ACTIONS(3558),
    [anon_sym_json_DOTdecode] = ACTIONS(3560),
    [anon_sym_LBRACK2] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3548),
    [anon_sym_CARET] = ACTIONS(3548),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_LT_DASH] = ACTIONS(3566),
    [sym_none] = ACTIONS(3568),
    [sym_true] = ACTIONS(3568),
    [sym_false] = ACTIONS(3568),
    [sym_nil] = ACTIONS(3568),
    [anon_sym_if] = ACTIONS(3570),
    [anon_sym_DOLLARif] = ACTIONS(3572),
    [anon_sym_match] = ACTIONS(3574),
    [anon_sym_select] = ACTIONS(3576),
    [anon_sym_lock] = ACTIONS(3578),
    [anon_sym_rlock] = ACTIONS(3578),
    [anon_sym_unsafe] = ACTIONS(3580),
    [anon_sym_sql] = ACTIONS(3582),
    [sym_int_literal] = ACTIONS(3568),
    [sym_float_literal] = ACTIONS(3584),
    [sym_rune_literal] = ACTIONS(3584),
    [anon_sym_SQUOTE] = ACTIONS(3586),
    [anon_sym_DQUOTE] = ACTIONS(3588),
    [anon_sym_c_SQUOTE] = ACTIONS(3590),
    [anon_sym_c_DQUOTE] = ACTIONS(3592),
    [anon_sym_r_SQUOTE] = ACTIONS(3594),
    [anon_sym_r_DQUOTE] = ACTIONS(3596),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3598),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [974] = {
    [sym_line_comment] = STATE(974),
    [sym_block_comment] = STATE(974),
    [sym__expression] = STATE(248),
    [sym__expression_without_blocks] = STATE(471),
    [sym__expression_with_blocks] = STATE(471),
    [sym_inc_expression] = STATE(474),
    [sym_dec_expression] = STATE(474),
    [sym_or_block_expression] = STATE(474),
    [sym_option_propagation_expression] = STATE(474),
    [sym_result_propagation_expression] = STATE(474),
    [sym_anon_struct_value_expression] = STATE(481),
    [sym_go_expression] = STATE(474),
    [sym_spawn_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_call_expression] = STATE(474),
    [sym_type_initializer] = STATE(481),
    [sym_function_literal] = STATE(474),
    [sym_reference_expression] = STATE(483),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(474),
    [sym_receive_expression] = STATE(474),
    [sym_binary_expression] = STATE(474),
    [sym_as_type_cast_expression] = STATE(474),
    [sym__max_group] = STATE(474),
    [sym_literal] = STATE(446),
    [sym_map_init_expression] = STATE(481),
    [sym_array_creation] = STATE(474),
    [sym_fixed_array_creation] = STATE(474),
    [sym_selector_expression] = STATE(474),
    [sym_index_expression] = STATE(474),
    [sym_slice_expression] = STATE(474),
    [sym_if_expression] = STATE(481),
    [sym_compile_time_if_expression] = STATE(481),
    [sym_is_expression] = STATE(474),
    [sym_in_expression] = STATE(474),
    [sym_enum_fetch] = STATE(474),
    [sym_match_expression] = STATE(481),
    [sym_select_expression] = STATE(481),
    [sym_lock_expression] = STATE(481),
    [sym_unsafe_expression] = STATE(481),
    [sym_sql_expression] = STATE(481),
    [sym_interpreted_string_literal] = STATE(421),
    [sym_c_string_literal] = STATE(421),
    [sym_raw_string_literal] = STATE(421),
    [sym_mutability_modifiers] = STATE(789),
    [sym_plain_type] = STATE(4176),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(3514),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(325),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_spawn] = ACTIONS(53),
    [anon_sym_json_DOTdecode] = ACTIONS(55),
    [anon_sym_LBRACK2] = ACTIONS(3516),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_CARET] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_LT_DASH] = ACTIONS(61),
    [sym_none] = ACTIONS(63),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_nil] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_DOLLARif] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_select] = ACTIONS(71),
    [anon_sym_lock] = ACTIONS(73),
    [anon_sym_rlock] = ACTIONS(73),
    [anon_sym_unsafe] = ACTIONS(75),
    [anon_sym_sql] = ACTIONS(77),
    [sym_int_literal] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(79),
    [sym_rune_literal] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_c_SQUOTE] = ACTIONS(85),
    [anon_sym_c_DQUOTE] = ACTIONS(87),
    [anon_sym_r_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [sym_pseudo_compile_time_identifier] = ACTIONS(93),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [975] = {
    [sym_line_comment] = STATE(975),
    [sym_block_comment] = STATE(975),
    [sym__expression] = STATE(2537),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4270),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(3708),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3390),
    [anon_sym_lock] = ACTIONS(3392),
    [anon_sym_rlock] = ACTIONS(3392),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [976] = {
    [sym_line_comment] = STATE(976),
    [sym_block_comment] = STATE(976),
    [sym__expression] = STATE(2538),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4270),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(3708),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3390),
    [anon_sym_lock] = ACTIONS(3392),
    [anon_sym_rlock] = ACTIONS(3392),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [977] = {
    [sym_line_comment] = STATE(977),
    [sym_block_comment] = STATE(977),
    [sym__expression] = STATE(2540),
    [sym__expression_without_blocks] = STATE(2641),
    [sym__expression_with_blocks] = STATE(2641),
    [sym_inc_expression] = STATE(2791),
    [sym_dec_expression] = STATE(2791),
    [sym_or_block_expression] = STATE(2791),
    [sym_option_propagation_expression] = STATE(2791),
    [sym_result_propagation_expression] = STATE(2791),
    [sym_anon_struct_value_expression] = STATE(2642),
    [sym_go_expression] = STATE(2791),
    [sym_spawn_expression] = STATE(2791),
    [sym_parenthesized_expression] = STATE(2791),
    [sym_call_expression] = STATE(2791),
    [sym_type_initializer] = STATE(2642),
    [sym_function_literal] = STATE(2791),
    [sym_reference_expression] = STATE(2784),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2791),
    [sym_receive_expression] = STATE(2791),
    [sym_binary_expression] = STATE(2791),
    [sym_as_type_cast_expression] = STATE(2791),
    [sym__max_group] = STATE(2791),
    [sym_literal] = STATE(2798),
    [sym_map_init_expression] = STATE(2642),
    [sym_array_creation] = STATE(2791),
    [sym_fixed_array_creation] = STATE(2791),
    [sym_selector_expression] = STATE(2791),
    [sym_index_expression] = STATE(2791),
    [sym_slice_expression] = STATE(2791),
    [sym_if_expression] = STATE(2642),
    [sym_compile_time_if_expression] = STATE(2642),
    [sym_is_expression] = STATE(2791),
    [sym_in_expression] = STATE(2791),
    [sym_enum_fetch] = STATE(2791),
    [sym_match_expression] = STATE(2642),
    [sym_select_expression] = STATE(2642),
    [sym_lock_expression] = STATE(2642),
    [sym_unsafe_expression] = STATE(2642),
    [sym_sql_expression] = STATE(2642),
    [sym_interpreted_string_literal] = STATE(2802),
    [sym_c_string_literal] = STATE(2802),
    [sym_raw_string_literal] = STATE(2802),
    [sym_mutability_modifiers] = STATE(959),
    [sym_plain_type] = STATE(4270),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_go] = ACTIONS(1465),
    [anon_sym_spawn] = ACTIONS(1467),
    [anon_sym_json_DOTdecode] = ACTIONS(1469),
    [anon_sym_LBRACK2] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(3708),
    [anon_sym_LT_DASH] = ACTIONS(1475),
    [sym_none] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_nil] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_DOLLARif] = ACTIONS(1483),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_select] = ACTIONS(3390),
    [anon_sym_lock] = ACTIONS(3392),
    [anon_sym_rlock] = ACTIONS(3392),
    [anon_sym_unsafe] = ACTIONS(1491),
    [anon_sym_sql] = ACTIONS(1493),
    [sym_int_literal] = ACTIONS(1477),
    [sym_float_literal] = ACTIONS(1495),
    [sym_rune_literal] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_c_SQUOTE] = ACTIONS(1501),
    [anon_sym_c_DQUOTE] = ACTIONS(1503),
    [anon_sym_r_SQUOTE] = ACTIONS(1505),
    [anon_sym_r_DQUOTE] = ACTIONS(1507),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [978] = {
    [sym_line_comment] = STATE(978),
    [sym_block_comment] = STATE(978),
    [sym__expression] = STATE(1985),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4216),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_go] = ACTIONS(3372),
    [anon_sym_spawn] = ACTIONS(3374),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_LT_DASH] = ACTIONS(3380),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(3382),
    [anon_sym_lock] = ACTIONS(3384),
    [anon_sym_rlock] = ACTIONS(3384),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [979] = {
    [sym_line_comment] = STATE(979),
    [sym_block_comment] = STATE(979),
    [sym__expression] = STATE(1985),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4222),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_go] = ACTIONS(3372),
    [anon_sym_spawn] = ACTIONS(3374),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_LT_DASH] = ACTIONS(3380),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(3382),
    [anon_sym_lock] = ACTIONS(3384),
    [anon_sym_rlock] = ACTIONS(3384),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [980] = {
    [sym_line_comment] = STATE(980),
    [sym_block_comment] = STATE(980),
    [sym__expression] = STATE(1985),
    [sym__expression_without_blocks] = STATE(2046),
    [sym__expression_with_blocks] = STATE(2046),
    [sym_inc_expression] = STATE(2054),
    [sym_dec_expression] = STATE(2054),
    [sym_or_block_expression] = STATE(2054),
    [sym_option_propagation_expression] = STATE(2054),
    [sym_result_propagation_expression] = STATE(2054),
    [sym_anon_struct_value_expression] = STATE(2058),
    [sym_go_expression] = STATE(2054),
    [sym_spawn_expression] = STATE(2054),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_type_initializer] = STATE(2058),
    [sym_function_literal] = STATE(2054),
    [sym_reference_expression] = STATE(2200),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2054),
    [sym_receive_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_as_type_cast_expression] = STATE(2054),
    [sym__max_group] = STATE(2054),
    [sym_literal] = STATE(2043),
    [sym_map_init_expression] = STATE(2058),
    [sym_array_creation] = STATE(2054),
    [sym_fixed_array_creation] = STATE(2054),
    [sym_selector_expression] = STATE(2054),
    [sym_index_expression] = STATE(2054),
    [sym_slice_expression] = STATE(2054),
    [sym_if_expression] = STATE(2058),
    [sym_compile_time_if_expression] = STATE(2058),
    [sym_is_expression] = STATE(2054),
    [sym_in_expression] = STATE(2054),
    [sym_enum_fetch] = STATE(2054),
    [sym_match_expression] = STATE(2058),
    [sym_select_expression] = STATE(2058),
    [sym_lock_expression] = STATE(2058),
    [sym_unsafe_expression] = STATE(2058),
    [sym_sql_expression] = STATE(2058),
    [sym_interpreted_string_literal] = STATE(2031),
    [sym_c_string_literal] = STATE(2031),
    [sym_raw_string_literal] = STATE(2031),
    [sym_mutability_modifiers] = STATE(944),
    [sym_plain_type] = STATE(4227),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(1139),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_go] = ACTIONS(3372),
    [anon_sym_spawn] = ACTIONS(3374),
    [anon_sym_json_DOTdecode] = ACTIONS(1149),
    [anon_sym_LBRACK2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_LT_DASH] = ACTIONS(3380),
    [sym_none] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_nil] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_DOLLARif] = ACTIONS(1161),
    [anon_sym_match] = ACTIONS(1163),
    [anon_sym_select] = ACTIONS(3382),
    [anon_sym_lock] = ACTIONS(3384),
    [anon_sym_rlock] = ACTIONS(3384),
    [anon_sym_unsafe] = ACTIONS(1169),
    [anon_sym_sql] = ACTIONS(1171),
    [sym_int_literal] = ACTIONS(1157),
    [sym_float_literal] = ACTIONS(1173),
    [sym_rune_literal] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_c_SQUOTE] = ACTIONS(1179),
    [anon_sym_c_DQUOTE] = ACTIONS(1181),
    [anon_sym_r_SQUOTE] = ACTIONS(1183),
    [anon_sym_r_DQUOTE] = ACTIONS(1185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1187),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [981] = {
    [sym_line_comment] = STATE(981),
    [sym_block_comment] = STATE(981),
    [sym__expression] = STATE(2871),
    [sym__expression_without_blocks] = STATE(2462),
    [sym__expression_with_blocks] = STATE(2462),
    [sym_inc_expression] = STATE(2466),
    [sym_dec_expression] = STATE(2466),
    [sym_or_block_expression] = STATE(2466),
    [sym_option_propagation_expression] = STATE(2466),
    [sym_result_propagation_expression] = STATE(2466),
    [sym_anon_struct_value_expression] = STATE(2470),
    [sym_go_expression] = STATE(2466),
    [sym_spawn_expression] = STATE(2466),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_type_initializer] = STATE(2470),
    [sym_function_literal] = STATE(2466),
    [sym_reference_expression] = STATE(2473),
    [sym_type_reference_expression] = STATE(3649),
    [sym_unary_expression] = STATE(2466),
    [sym_receive_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_as_type_cast_expression] = STATE(2466),
    [sym__max_group] = STATE(2466),
    [sym_literal] = STATE(2451),
    [sym_map_init_expression] = STATE(2470),
    [sym_array_creation] = STATE(2466),
    [sym_fixed_array_creation] = STATE(2466),
    [sym_selector_expression] = STATE(2466),
    [sym_index_expression] = STATE(2466),
    [sym_slice_expression] = STATE(2466),
    [sym_if_expression] = STATE(2470),
    [sym_compile_time_if_expression] = STATE(2470),
    [sym_is_expression] = STATE(2466),
    [sym_in_expression] = STATE(2466),
    [sym_enum_fetch] = STATE(2466),
    [sym_match_expression] = STATE(2470),
    [sym_select_expression] = STATE(2470),
    [sym_lock_expression] = STATE(2470),
    [sym_unsafe_expression] = STATE(2470),
    [sym_sql_expression] = STATE(2470),
    [sym_interpreted_string_literal] = STATE(2448),
    [sym_c_string_literal] = STATE(2448),
    [sym_raw_string_literal] = STATE(2448),
    [sym_mutability_modifiers] = STATE(882),
    [sym_plain_type] = STATE(3689),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(2415),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_mut] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(2417),
    [anon_sym_go] = ACTIONS(2419),
    [anon_sym_spawn] = ACTIONS(2421),
    [anon_sym_json_DOTdecode] = ACTIONS(1939),
    [anon_sym_LBRACK2] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2423),
    [anon_sym_LT_DASH] = ACTIONS(2425),
    [sym_none] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_nil] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_DOLLARif] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1953),
    [anon_sym_select] = ACTIONS(1955),
    [anon_sym_lock] = ACTIONS(1957),
    [anon_sym_rlock] = ACTIONS(1957),
    [anon_sym_unsafe] = ACTIONS(2101),
    [anon_sym_sql] = ACTIONS(1961),
    [sym_int_literal] = ACTIONS(1947),
    [sym_float_literal] = ACTIONS(1963),
    [sym_rune_literal] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_c_SQUOTE] = ACTIONS(1969),
    [anon_sym_c_DQUOTE] = ACTIONS(1971),
    [anon_sym_r_SQUOTE] = ACTIONS(1973),
    [anon_sym_r_DQUOTE] = ACTIONS(1975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1977),
    [anon_sym_shared] = ACTIONS(95),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [982] = {
    [sym_line_comment] = STATE(982),
    [sym_block_comment] = STATE(982),
    [sym_type_parameters] = STATE(4185),
    [sym_argument_list] = STATE(1016),
    [sym_or_block] = STATE(1017),
    [sym_identifier] = ACTIONS(2079),
    [anon_sym_LF] = ACTIONS(2079),
    [anon_sym_CR] = ACTIONS(2079),
    [anon_sym_CR_LF] = ACTIONS(2079),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2079),
    [anon_sym_DOT] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2079),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2079),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2079),
    [anon_sym_PLUS] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2079),
    [anon_sym_STAR] = ACTIONS(2079),
    [anon_sym_SLASH] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_struct] = ACTIONS(2079),
    [anon_sym_mut] = ACTIONS(2079),
    [anon_sym_COLON] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(3772),
    [anon_sym_BANG] = ACTIONS(3774),
    [anon_sym_go] = ACTIONS(2079),
    [anon_sym_spawn] = ACTIONS(2079),
    [anon_sym_json_DOTdecode] = ACTIONS(2079),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_LBRACK2] = ACTIONS(3776),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_CARET] = ACTIONS(2079),
    [anon_sym_AMP] = ACTIONS(2079),
    [anon_sym_LT_DASH] = ACTIONS(2079),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_GT_GT_GT] = ACTIONS(2053),
    [anon_sym_AMP_CARET] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2079),
    [sym_true] = ACTIONS(2079),
    [sym_false] = ACTIONS(2079),
    [sym_nil] = ACTIONS(2079),
    [anon_sym_QMARK_DOT] = ACTIONS(3750),
    [anon_sym_POUND_LBRACK] = ACTIONS(3776),
    [anon_sym_if] = ACTIONS(2079),
    [anon_sym_DOLLARif] = ACTIONS(2079),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2053),
    [anon_sym_match] = ACTIONS(2079),
    [anon_sym_select] = ACTIONS(2079),
    [anon_sym_STAR_EQ] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2053),
    [anon_sym_PERCENT_EQ] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2053),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2053),
    [anon_sym_PLUS_EQ] = ACTIONS(2053),
    [anon_sym_DASH_EQ] = ACTIONS(2053),
    [anon_sym_PIPE_EQ] = ACTIONS(2053),
    [anon_sym_CARET_EQ] = ACTIONS(2053),
    [anon_sym_COLON_EQ] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2079),
    [anon_sym_rlock] = ACTIONS(2079),
    [anon_sym_unsafe] = ACTIONS(2079),
    [anon_sym_sql] = ACTIONS(2079),
    [sym_int_literal] = ACTIONS(2079),
    [sym_float_literal] = ACTIONS(2079),
    [sym_rune_literal] = ACTIONS(2079),
    [anon_sym_SQUOTE] = ACTIONS(2079),
    [anon_sym_DQUOTE] = ACTIONS(2079),
    [anon_sym_c_SQUOTE] = ACTIONS(2079),
    [anon_sym_c_DQUOTE] = ACTIONS(2079),
    [anon_sym_r_SQUOTE] = ACTIONS(2079),
    [anon_sym_r_DQUOTE] = ACTIONS(2079),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2079),
    [anon_sym_shared] = ACTIONS(2079),
    [anon_sym_map_LBRACK] = ACTIONS(2079),
    [anon_sym_chan] = ACTIONS(2079),
    [anon_sym_thread] = ACTIONS(2079),
    [anon_sym_atomic] = ACTIONS(2079),
    [anon_sym_assert] = ACTIONS(2079),
    [anon_sym_defer] = ACTIONS(2079),
    [anon_sym_goto] = ACTIONS(2079),
    [anon_sym_break] = ACTIONS(2079),
    [anon_sym_continue] = ACTIONS(2079),
    [anon_sym_return] = ACTIONS(2079),
    [anon_sym_DOLLARfor] = ACTIONS(2079),
    [anon_sym_for] = ACTIONS(2079),
    [anon_sym_POUND] = ACTIONS(2079),
    [anon_sym_asm] = ACTIONS(2079),
  },
  [983] = {
    [sym_line_comment] = STATE(983),
    [sym_block_comment] = STATE(983),
    [sym_type_parameters] = STATE(4185),
    [sym_argument_list] = STATE(1016),
    [sym_or_block] = STATE(1017),
    [sym_identifier] = ACTIONS(2075),
    [anon_sym_LF] = ACTIONS(2075),
    [anon_sym_CR] = ACTIONS(2075),
    [anon_sym_CR_LF] = ACTIONS(2075),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2075),
    [anon_sym_DOT] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3752),
    [anon_sym_LBRACE] = ACTIONS(2075),
    [anon_sym_COMMA] = ACTIONS(2075),
    [anon_sym_RBRACE] = ACTIONS(2075),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(2075),
    [anon_sym_fn] = ACTIONS(2075),
    [anon_sym_PLUS] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3758),
    [anon_sym_STAR] = ACTIONS(3760),
    [anon_sym_SLASH] = ACTIONS(3760),
    [anon_sym_PERCENT] = ACTIONS(3760),
    [anon_sym_LT] = ACTIONS(3762),
    [anon_sym_GT] = ACTIONS(3762),
    [anon_sym_EQ_EQ] = ACTIONS(3762),
    [anon_sym_BANG_EQ] = ACTIONS(3762),
    [anon_sym_LT_EQ] = ACTIONS(3762),
    [anon_sym_GT_EQ] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_struct] = ACTIONS(2075),
    [anon_sym_mut] = ACTIONS(2075),
    [anon_sym_COLON] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(3768),
    [anon_sym_DASH_DASH] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3772),
    [anon_sym_BANG] = ACTIONS(3774),
    [anon_sym_go] = ACTIONS(2075),
    [anon_sym_spawn] = ACTIONS(2075),
    [anon_sym_json_DOTdecode] = ACTIONS(2075),
    [anon_sym_PIPE] = ACTIONS(3758),
    [anon_sym_LBRACK2] = ACTIONS(3776),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_CARET] = ACTIONS(3758),
    [anon_sym_AMP] = ACTIONS(3760),
    [anon_sym_LT_DASH] = ACTIONS(2075),
    [anon_sym_LT_LT] = ACTIONS(3760),
    [anon_sym_GT_GT] = ACTIONS(3760),
    [anon_sym_GT_GT_GT] = ACTIONS(3760),
    [anon_sym_AMP_CARET] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_or] = ACTIONS(3786),
    [sym_none] = ACTIONS(2075),
    [sym_true] = ACTIONS(2075),
    [sym_false] = ACTIONS(2075),
    [sym_nil] = ACTIONS(2075),
    [anon_sym_QMARK_DOT] = ACTIONS(3750),
    [anon_sym_POUND_LBRACK] = ACTIONS(3776),
    [anon_sym_if] = ACTIONS(2075),
    [anon_sym_DOLLARif] = ACTIONS(2075),
    [anon_sym_is] = ACTIONS(3788),
    [anon_sym_BANGis] = ACTIONS(3788),
    [anon_sym_in] = ACTIONS(3790),
    [anon_sym_BANGin] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(2075),
    [anon_sym_select] = ACTIONS(2075),
    [anon_sym_STAR_EQ] = ACTIONS(2075),
    [anon_sym_SLASH_EQ] = ACTIONS(2075),
    [anon_sym_PERCENT_EQ] = ACTIONS(2075),
    [anon_sym_LT_LT_EQ] = ACTIONS(2075),
    [anon_sym_GT_GT_EQ] = ACTIONS(2075),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2075),
    [anon_sym_AMP_EQ] = ACTIONS(2075),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2075),
    [anon_sym_PLUS_EQ] = ACTIONS(2075),
    [anon_sym_DASH_EQ] = ACTIONS(2075),
    [anon_sym_PIPE_EQ] = ACTIONS(2075),
    [anon_sym_CARET_EQ] = ACTIONS(2075),
    [anon_sym_COLON_EQ] = ACTIONS(2075),
    [anon_sym_lock] = ACTIONS(2075),
    [anon_sym_rlock] = ACTIONS(2075),
    [anon_sym_unsafe] = ACTIONS(2075),
    [anon_sym_sql] = ACTIONS(2075),
    [sym_int_literal] = ACTIONS(2075),
    [sym_float_literal] = ACTIONS(2075),
    [sym_rune_literal] = ACTIONS(2075),
    [anon_sym_SQUOTE] = ACTIONS(2075),
    [anon_sym_DQUOTE] = ACTIONS(2075),
    [anon_sym_c_SQUOTE] = ACTIONS(2075),
    [anon_sym_c_DQUOTE] = ACTIONS(2075),
    [anon_sym_r_SQUOTE] = ACTIONS(2075),
    [anon_sym_r_DQUOTE] = ACTIONS(2075),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2075),
    [anon_sym_shared] = ACTIONS(2075),
    [anon_sym_map_LBRACK] = ACTIONS(2075),
    [anon_sym_chan] = ACTIONS(2075),
    [anon_sym_thread] = ACTIONS(2075),
    [anon_sym_atomic] = ACTIONS(2075),
    [anon_sym_assert] = ACTIONS(2075),
    [anon_sym_defer] = ACTIONS(2075),
    [anon_sym_goto] = ACTIONS(2075),
    [anon_sym_break] = ACTIONS(2075),
    [anon_sym_continue] = ACTIONS(2075),
    [anon_sym_return] = ACTIONS(2075),
    [anon_sym_DOLLARfor] = ACTIONS(2075),
    [anon_sym_for] = ACTIONS(2075),
    [anon_sym_POUND] = ACTIONS(2075),
    [anon_sym_asm] = ACTIONS(2075),
  },
  [984] = {
    [sym_line_comment] = STATE(984),
    [sym_block_comment] = STATE(984),
    [sym_type_parameters] = STATE(4185),
    [sym_argument_list] = STATE(1016),
    [sym_or_block] = STATE(1017),
    [aux_sym_strictly_expression_list_repeat1] = STATE(3389),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_LF] = ACTIONS(2037),
    [anon_sym_CR] = ACTIONS(2037),
    [anon_sym_CR_LF] = ACTIONS(2037),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2037),
    [anon_sym_DOT] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3752),
    [anon_sym_LBRACE] = ACTIONS(2037),
    [anon_sym_COMMA] = ACTIONS(3754),
    [anon_sym_RBRACE] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(2041),
    [anon_sym_fn] = ACTIONS(2037),
    [anon_sym_PLUS] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3758),
    [anon_sym_STAR] = ACTIONS(3760),
    [anon_sym_SLASH] = ACTIONS(3760),
    [anon_sym_PERCENT] = ACTIONS(3760),
    [anon_sym_LT] = ACTIONS(3762),
    [anon_sym_GT] = ACTIONS(3762),
    [anon_sym_EQ_EQ] = ACTIONS(3762),
    [anon_sym_BANG_EQ] = ACTIONS(3762),
    [anon_sym_LT_EQ] = ACTIONS(3762),
    [anon_sym_GT_EQ] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_struct] = ACTIONS(2037),
    [anon_sym_mut] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(3768),
    [anon_sym_DASH_DASH] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3772),
    [anon_sym_BANG] = ACTIONS(3774),
    [anon_sym_go] = ACTIONS(2037),
    [anon_sym_spawn] = ACTIONS(2037),
    [anon_sym_json_DOTdecode] = ACTIONS(2037),
    [anon_sym_PIPE] = ACTIONS(3758),
    [anon_sym_LBRACK2] = ACTIONS(3776),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_CARET] = ACTIONS(3758),
    [anon_sym_AMP] = ACTIONS(3760),
    [anon_sym_LT_DASH] = ACTIONS(3778),
    [anon_sym_LT_LT] = ACTIONS(3780),
    [anon_sym_GT_GT] = ACTIONS(3760),
    [anon_sym_GT_GT_GT] = ACTIONS(3760),
    [anon_sym_AMP_CARET] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_or] = ACTIONS(3786),
    [sym_none] = ACTIONS(2037),
    [sym_true] = ACTIONS(2037),
    [sym_false] = ACTIONS(2037),
    [sym_nil] = ACTIONS(2037),
    [anon_sym_QMARK_DOT] = ACTIONS(3750),
    [anon_sym_POUND_LBRACK] = ACTIONS(3776),
    [anon_sym_if] = ACTIONS(2037),
    [anon_sym_DOLLARif] = ACTIONS(2037),
    [anon_sym_is] = ACTIONS(3788),
    [anon_sym_BANGis] = ACTIONS(3788),
    [anon_sym_in] = ACTIONS(3790),
    [anon_sym_BANGin] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(2037),
    [anon_sym_select] = ACTIONS(2037),
    [anon_sym_STAR_EQ] = ACTIONS(2041),
    [anon_sym_SLASH_EQ] = ACTIONS(2041),
    [anon_sym_PERCENT_EQ] = ACTIONS(2041),
    [anon_sym_LT_LT_EQ] = ACTIONS(2041),
    [anon_sym_GT_GT_EQ] = ACTIONS(2041),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2041),
    [anon_sym_AMP_EQ] = ACTIONS(2041),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2041),
    [anon_sym_PLUS_EQ] = ACTIONS(2041),
    [anon_sym_DASH_EQ] = ACTIONS(2041),
    [anon_sym_PIPE_EQ] = ACTIONS(2041),
    [anon_sym_CARET_EQ] = ACTIONS(2041),
    [anon_sym_COLON_EQ] = ACTIONS(2041),
    [anon_sym_lock] = ACTIONS(2037),
    [anon_sym_rlock] = ACTIONS(2037),
    [anon_sym_unsafe] = ACTIONS(2037),
    [anon_sym_sql] = ACTIONS(2037),
    [sym_int_literal] = ACTIONS(2037),
    [sym_float_literal] = ACTIONS(2037),
    [sym_rune_literal] = ACTIONS(2037),
    [anon_sym_SQUOTE] = ACTIONS(2037),
    [anon_sym_DQUOTE] = ACTIONS(2037),
    [anon_sym_c_SQUOTE] = ACTIONS(2037),
    [anon_sym_c_DQUOTE] = ACTIONS(2037),
    [anon_sym_r_SQUOTE] = ACTIONS(2037),
    [anon_sym_r_DQUOTE] = ACTIONS(2037),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2037),
    [anon_sym_shared] = ACTIONS(2037),
    [anon_sym_map_LBRACK] = ACTIONS(2037),
    [anon_sym_chan] = ACTIONS(2037),
    [anon_sym_thread] = ACTIONS(2037),
    [anon_sym_atomic] = ACTIONS(2037),
    [anon_sym_assert] = ACTIONS(2037),
    [anon_sym_defer] = ACTIONS(2037),
    [anon_sym_goto] = ACTIONS(2037),
    [anon_sym_break] = ACTIONS(2037),
    [anon_sym_continue] = ACTIONS(2037),
    [anon_sym_return] = ACTIONS(2037),
    [anon_sym_DOLLARfor] = ACTIONS(2037),
    [anon_sym_for] = ACTIONS(2037),
    [anon_sym_POUND] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2037),
  },
  [985] = {
    [sym_line_comment] = STATE(985),
    [sym_block_comment] = STATE(985),
    [sym_type_parameters] = STATE(4185),
    [sym_argument_list] = STATE(1016),
    [sym_or_block] = STATE(1017),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_LF] = ACTIONS(2057),
    [anon_sym_CR] = ACTIONS(2057),
    [anon_sym_CR_LF] = ACTIONS(2057),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2057),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(2057),
    [anon_sym_fn] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_PERCENT] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_GT] = ACTIONS(2057),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2057),
    [anon_sym_LT_EQ] = ACTIONS(2057),
    [anon_sym_GT_EQ] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_struct] = ACTIONS(2057),
    [anon_sym_mut] = ACTIONS(2057),
    [anon_sym_COLON] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [anon_sym_QMARK] = ACTIONS(3772),
    [anon_sym_BANG] = ACTIONS(3774),
    [anon_sym_go] = ACTIONS(2057),
    [anon_sym_spawn] = ACTIONS(2057),
    [anon_sym_json_DOTdecode] = ACTIONS(2057),
    [anon_sym_PIPE] = ACTIONS(2057),
    [anon_sym_LBRACK2] = ACTIONS(3776),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_CARET] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2057),
    [anon_sym_LT_DASH] = ACTIONS(2057),
    [anon_sym_LT_LT] = ACTIONS(2057),
    [anon_sym_GT_GT] = ACTIONS(2057),
    [anon_sym_GT_GT_GT] = ACTIONS(2057),
    [anon_sym_AMP_CARET] = ACTIONS(2057),
    [anon_sym_AMP_AMP] = ACTIONS(2057),
    [anon_sym_PIPE_PIPE] = ACTIONS(2057),
    [anon_sym_or] = ACTIONS(2057),
    [sym_none] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_nil] = ACTIONS(2057),
    [anon_sym_QMARK_DOT] = ACTIONS(3750),
    [anon_sym_POUND_LBRACK] = ACTIONS(3776),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_DOLLARif] = ACTIONS(2057),
    [anon_sym_is] = ACTIONS(2057),
    [anon_sym_BANGis] = ACTIONS(2057),
    [anon_sym_in] = ACTIONS(2057),
    [anon_sym_BANGin] = ACTIONS(2057),
    [anon_sym_match] = ACTIONS(2057),
    [anon_sym_select] = ACTIONS(2057),
    [anon_sym_STAR_EQ] = ACTIONS(2057),
    [anon_sym_SLASH_EQ] = ACTIONS(2057),
    [anon_sym_PERCENT_EQ] = ACTIONS(2057),
    [anon_sym_LT_LT_EQ] = ACTIONS(2057),
    [anon_sym_GT_GT_EQ] = ACTIONS(2057),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2057),
    [anon_sym_AMP_EQ] = ACTIONS(2057),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2057),
    [anon_sym_PLUS_EQ] = ACTIONS(2057),
    [anon_sym_DASH_EQ] = ACTIONS(2057),
    [anon_sym_PIPE_EQ] = ACTIONS(2057),
    [anon_sym_CARET_EQ] = ACTIONS(2057),
    [anon_sym_COLON_EQ] = ACTIONS(2057),
    [anon_sym_lock] = ACTIONS(2057),
    [anon_sym_rlock] = ACTIONS(2057),
    [anon_sym_unsafe] = ACTIONS(2057),
    [anon_sym_sql] = ACTIONS(2057),
    [sym_int_literal] = ACTIONS(2057),
    [sym_float_literal] = ACTIONS(2057),
    [sym_rune_literal] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_c_SQUOTE] = ACTIONS(2057),
    [anon_sym_c_DQUOTE] = ACTIONS(2057),
    [anon_sym_r_SQUOTE] = ACTIONS(2057),
    [anon_sym_r_DQUOTE] = ACTIONS(2057),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2057),
    [anon_sym_shared] = ACTIONS(2057),
    [anon_sym_map_LBRACK] = ACTIONS(2057),
    [anon_sym_chan] = ACTIONS(2057),
    [anon_sym_thread] = ACTIONS(2057),
    [anon_sym_atomic] = ACTIONS(2057),
    [anon_sym_assert] = ACTIONS(2057),
    [anon_sym_defer] = ACTIONS(2057),
    [anon_sym_goto] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_DOLLARfor] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_POUND] = ACTIONS(2057),
    [anon_sym_asm] = ACTIONS(2057),
  },
  [986] = {
    [sym_line_comment] = STATE(986),
    [sym_block_comment] = STATE(986),
    [sym_type_parameters] = STATE(4185),
    [sym_argument_list] = STATE(1016),
    [sym_or_block] = STATE(1017),
    [sym_identifier] = ACTIONS(2049),
    [anon_sym_LF] = ACTIONS(2049),
    [anon_sym_CR] = ACTIONS(2049),
    [anon_sym_CR_LF] = ACTIONS(2049),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(2049),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(2049),
    [anon_sym_fn] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3758),
    [anon_sym_STAR] = ACTIONS(3760),
    [anon_sym_SLASH] = ACTIONS(3760),
    [anon_sym_PERCENT] = ACTIONS(3760),
    [anon_sym_LT] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_struct] = ACTIONS(2049),
    [anon_sym_mut] = ACTIONS(2049),
    [anon_sym_COLON] = ACTIONS(2049),
    [anon_sym_PLUS_PLUS] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(3772),
    [anon_sym_BANG] = ACTIONS(3774),
    [anon_sym_go] = ACTIONS(2049),
    [anon_sym_spawn] = ACTIONS(2049),
    [anon_sym_json_DOTdecode] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(3758),
    [anon_sym_LBRACK2] = ACTIONS(3776),
    [anon_sym_TILDE] = ACTIONS(2049),
    [anon_sym_CARET] = ACTIONS(3758),
    [anon_sym_AMP] = ACTIONS(3760),
    [anon_sym_LT_DASH] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(3760),
    [anon_sym_GT_GT] = ACTIONS(3760),
    [anon_sym_GT_GT_GT] = ACTIONS(3760),
    [anon_sym_AMP_CARET] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_or] = ACTIONS(2049),
    [sym_none] = ACTIONS(2049),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [sym_nil] = ACTIONS(2049),
    [anon_sym_QMARK_DOT] = ACTIONS(3750),
    [anon_sym_POUND_LBRACK] = ACTIONS(3776),
    [anon_sym_if] = ACTIONS(2049),
    [anon_sym_DOLLARif] = ACTIONS(2049),
    [anon_sym_is] = ACTIONS(2049),
    [anon_sym_BANGis] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_BANGin] = ACTIONS(2049),
    [anon_sym_match] = ACTIONS(2049),
    [anon_sym_select] = ACTIONS(2049),
    [anon_sym_STAR_EQ] = ACTIONS(2049),
    [anon_sym_SLASH_EQ] = ACTIONS(2049),
    [anon_sym_PERCENT_EQ] = ACTIONS(2049),
    [anon_sym_LT_LT_EQ] = ACTIONS(2049),
    [anon_sym_GT_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2049),
    [anon_sym_AMP_EQ] = ACTIONS(2049),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2049),
    [anon_sym_PLUS_EQ] = ACTIONS(2049),
    [anon_sym_DASH_EQ] = ACTIONS(2049),
    [anon_sym_PIPE_EQ] = ACTIONS(2049),
    [anon_sym_CARET_EQ] = ACTIONS(2049),
    [anon_sym_COLON_EQ] = ACTIONS(2049),
    [anon_sym_lock] = ACTIONS(2049),
    [anon_sym_rlock] = ACTIONS(2049),
    [anon_sym_unsafe] = ACTIONS(2049),
    [anon_sym_sql] = ACTIONS(2049),
    [sym_int_literal] = ACTIONS(2049),
    [sym_float_literal] = ACTIONS(2049),
    [sym_rune_literal] = ACTIONS(2049),
    [anon_sym_SQUOTE] = ACTIONS(2049),
    [anon_sym_DQUOTE] = ACTIONS(2049),
    [anon_sym_c_SQUOTE] = ACTIONS(2049),
    [anon_sym_c_DQUOTE] = ACTIONS(2049),
    [anon_sym_r_SQUOTE] = ACTIONS(2049),
    [anon_sym_r_DQUOTE] = ACTIONS(2049),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2049),
    [anon_sym_shared] = ACTIONS(2049),
    [anon_sym_map_LBRACK] = ACTIONS(2049),
    [anon_sym_chan] = ACTIONS(2049),
    [anon_sym_thread] = ACTIONS(2049),
    [anon_sym_atomic] = ACTIONS(2049),
    [anon_sym_assert] = ACTIONS(2049),
    [anon_sym_defer] = ACTIONS(2049),
    [anon_sym_goto] = ACTIONS(2049),
    [anon_sym_break] = ACTIONS(2049),
    [anon_sym_continue] = ACTIONS(2049),
    [anon_sym_return] = ACTIONS(2049),
    [anon_sym_DOLLARfor] = ACTIONS(2049),
    [anon_sym_for] = ACTIONS(2049),
    [anon_sym_POUND] = ACTIONS(2049),
    [anon_sym_asm] = ACTIONS(2049),
  },
  [987] = {
    [sym_line_comment] = STATE(987),
    [sym_block_comment] = STATE(987),
    [sym_type_parameters] = STATE(4185),
    [sym_argument_list] = STATE(1016),
    [sym_or_block] = STATE(1017),
    [sym_identifier] = ACTIONS(2061),
    [anon_sym_LF] = ACTIONS(2061),
    [anon_sym_CR] = ACTIONS(2061),
    [anon_sym_CR_LF] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_LBRACE] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(2061),
    [anon_sym_fn] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2061),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_struct] = ACTIONS(2061),
    [anon_sym_mut] = ACTIONS(2061),
    [anon_sym_COLON] = ACTIONS(2061),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_QMARK] = ACTIONS(3772),
    [anon_sym_BANG] = ACTIONS(3774),
    [anon_sym_go] = ACTIONS(2061),
    [anon_sym_spawn] = ACTIONS(2061),
    [anon_sym_json_DOTdecode] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_LBRACK2] = ACTIONS(3776),
    [anon_sym_TILDE] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_LT_DASH] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_GT_GT_GT] = ACTIONS(2061),
    [anon_sym_AMP_CARET] = ACTIONS(2061),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [sym_none] = ACTIONS(2061),
    [sym_true] = ACTIONS(2061),
    [sym_false] = ACTIONS(2061),
    [sym_nil] = ACTIONS(2061),
    [anon_sym_QMARK_DOT] = ACTIONS(3750),
    [anon_sym_POUND_LBRACK] = ACTIONS(3776),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_DOLLARif] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_BANGis] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_BANGin] = ACTIONS(2061),
    [anon_sym_match] = ACTIONS(2061),
    [anon_sym_select] = ACTIONS(2061),
    [anon_sym_STAR_EQ] = ACTIONS(2061),
    [anon_sym_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_PERCENT_EQ] = ACTIONS(2061),
    [anon_sym_LT_LT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_AMP_EQ] = ACTIONS(2061),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2061),
    [anon_sym_PLUS_EQ] = ACTIONS(2061),
    [anon_sym_DASH_EQ] = ACTIONS(2061),
    [anon_sym_PIPE_EQ] = ACTIONS(2061),
    [anon_sym_CARET_EQ] = ACTIONS(2061),
    [anon_sym_COLON_EQ] = ACTIONS(2061),
    [anon_sym_lock] = ACTIONS(2061),
    [anon_sym_rlock] = ACTIONS(2061),
    [anon_sym_unsafe] = ACTIONS(2061),
    [anon_sym_sql] = ACTIONS(2061),
    [sym_int_literal] = ACTIONS(2061),
    [sym_float_literal] = ACTIONS(2061),
    [sym_rune_literal] = ACTIONS(2061),
    [anon_sym_SQUOTE] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(2061),
    [anon_sym_c_SQUOTE] = ACTIONS(2061),
    [anon_sym_c_DQUOTE] = ACTIONS(2061),
    [anon_sym_r_SQUOTE] = ACTIONS(2061),
    [anon_sym_r_DQUOTE] = ACTIONS(2061),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2061),
    [anon_sym_shared] = ACTIONS(2061),
    [anon_sym_map_LBRACK] = ACTIONS(2061),
    [anon_sym_chan] = ACTIONS(2061),
    [anon_sym_thread] = ACTIONS(2061),
    [anon_sym_atomic] = ACTIONS(2061),
    [anon_sym_assert] = ACTIONS(2061),
    [anon_sym_defer] = ACTIONS(2061),
    [anon_sym_goto] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2061),
    [anon_sym_continue] = ACTIONS(2061),
    [anon_sym_return] = ACTIONS(2061),
    [anon_sym_DOLLARfor] = ACTIONS(2061),
    [anon_sym_for] = ACTIONS(2061),
    [anon_sym_POUND] = ACTIONS(2061),
    [anon_sym_asm] = ACTIONS(2061),
  },
  [988] = {
    [sym_line_comment] = STATE(988),
    [sym_block_comment] = STATE(988),
    [sym_type_parameters] = STATE(4185),
    [sym_argument_list] = STATE(1016),
    [sym_or_block] = STATE(1017),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_DASH] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_SLASH] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_COLON] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(3772),
    [anon_sym_BANG] = ACTIONS(3774),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_LBRACK2] = ACTIONS(3776),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_GT_GT_GT] = ACTIONS(2053),
    [anon_sym_AMP_CARET] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3750),
    [anon_sym_POUND_LBRACK] = ACTIONS(3776),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2053),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_STAR_EQ] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2053),
    [anon_sym_PERCENT_EQ] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2053),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2053),
    [anon_sym_PLUS_EQ] = ACTIONS(2053),
    [anon_sym_DASH_EQ] = ACTIONS(2053),
    [anon_sym_PIPE_EQ] = ACTIONS(2053),
    [anon_sym_CARET_EQ] = ACTIONS(2053),
    [anon_sym_COLON_EQ] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
  },
  [989] = {
    [sym_line_comment] = STATE(989),
    [sym_block_comment] = STATE(989),
    [sym_type_parameters] = STATE(4185),
    [sym_argument_list] = STATE(1016),
    [sym_or_block] = STATE(1017),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3758),
    [anon_sym_STAR] = ACTIONS(3760),
    [anon_sym_SLASH] = ACTIONS(3760),
    [anon_sym_PERCENT] = ACTIONS(3760),
    [anon_sym_LT] = ACTIONS(3762),
    [anon_sym_GT] = ACTIONS(3762),
    [anon_sym_EQ_EQ] = ACTIONS(3762),
    [anon_sym_BANG_EQ] = ACTIONS(3762),
    [anon_sym_LT_EQ] = ACTIONS(3762),
    [anon_sym_GT_EQ] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_COLON] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(3772),
    [anon_sym_BANG] = ACTIONS(3774),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(3758),
    [anon_sym_LBRACK2] = ACTIONS(3776),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(3758),
    [anon_sym_AMP] = ACTIONS(3760),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(3760),
    [anon_sym_GT_GT] = ACTIONS(3760),
    [anon_sym_GT_GT_GT] = ACTIONS(3760),
    [anon_sym_AMP_CARET] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3750),
    [anon_sym_POUND_LBRACK] = ACTIONS(3776),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(3790),
    [anon_sym_BANGin] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_STAR_EQ] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2053),
    [anon_sym_PERCENT_EQ] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2053),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2053),
    [anon_sym_PLUS_EQ] = ACTIONS(2053),
    [anon_sym_DASH_EQ] = ACTIONS(2053),
    [anon_sym_PIPE_EQ] = ACTIONS(2053),
    [anon_sym_CARET_EQ] = ACTIONS(2053),
    [anon_sym_COLON_EQ] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
  },
  [990] = {
    [sym_line_comment] = STATE(990),
    [sym_block_comment] = STATE(990),
    [sym_type_parameters] = STATE(4185),
    [sym_argument_list] = STATE(1016),
    [sym_or_block] = STATE(1017),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3758),
    [anon_sym_STAR] = ACTIONS(3760),
    [anon_sym_SLASH] = ACTIONS(3760),
    [anon_sym_PERCENT] = ACTIONS(3760),
    [anon_sym_LT] = ACTIONS(3762),
    [anon_sym_GT] = ACTIONS(3762),
    [anon_sym_EQ_EQ] = ACTIONS(3762),
    [anon_sym_BANG_EQ] = ACTIONS(3762),
    [anon_sym_LT_EQ] = ACTIONS(3762),
    [anon_sym_GT_EQ] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_COLON] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(3772),
    [anon_sym_BANG] = ACTIONS(3774),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(3758),
    [anon_sym_LBRACK2] = ACTIONS(3776),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(3758),
    [anon_sym_AMP] = ACTIONS(3760),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(3760),
    [anon_sym_GT_GT] = ACTIONS(3760),
    [anon_sym_GT_GT_GT] = ACTIONS(3760),
    [anon_sym_AMP_CARET] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3750),
    [anon_sym_POUND_LBRACK] = ACTIONS(3776),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(3790),
    [anon_sym_BANGin] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_STAR_EQ] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2053),
    [anon_sym_PERCENT_EQ] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2053),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2053),
    [anon_sym_PLUS_EQ] = ACTIONS(2053),
    [anon_sym_DASH_EQ] = ACTIONS(2053),
    [anon_sym_PIPE_EQ] = ACTIONS(2053),
    [anon_sym_CARET_EQ] = ACTIONS(2053),
    [anon_sym_COLON_EQ] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
  },
  [991] = {
    [sym_line_comment] = STATE(991),
    [sym_block_comment] = STATE(991),
    [sym_type_parameters] = STATE(4185),
    [sym_argument_list] = STATE(1016),
    [sym_or_block] = STATE(1017),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3758),
    [anon_sym_STAR] = ACTIONS(3760),
    [anon_sym_SLASH] = ACTIONS(3760),
    [anon_sym_PERCENT] = ACTIONS(3760),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_COLON] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(3772),
    [anon_sym_BANG] = ACTIONS(3774),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(3758),
    [anon_sym_LBRACK2] = ACTIONS(3776),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(3758),
    [anon_sym_AMP] = ACTIONS(3760),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(3760),
    [anon_sym_GT_GT] = ACTIONS(3760),
    [anon_sym_GT_GT_GT] = ACTIONS(3760),
    [anon_sym_AMP_CARET] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3750),
    [anon_sym_POUND_LBRACK] = ACTIONS(3776),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2053),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_STAR_EQ] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2053),
    [anon_sym_PERCENT_EQ] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2053),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2053),
    [anon_sym_PLUS_EQ] = ACTIONS(2053),
    [anon_sym_DASH_EQ] = ACTIONS(2053),
    [anon_sym_PIPE_EQ] = ACTIONS(2053),
    [anon_sym_CARET_EQ] = ACTIONS(2053),
    [anon_sym_COLON_EQ] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
  },
  [992] = {
    [sym_line_comment] = STATE(992),
    [sym_block_comment] = STATE(992),
    [sym_type_parameters] = STATE(4185),
    [sym_argument_list] = STATE(1016),
    [sym_or_block] = STATE(1017),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_DASH] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(3760),
    [anon_sym_SLASH] = ACTIONS(3760),
    [anon_sym_PERCENT] = ACTIONS(3760),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_COLON] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(3772),
    [anon_sym_BANG] = ACTIONS(3774),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_LBRACK2] = ACTIONS(3776),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(3760),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(3760),
    [anon_sym_GT_GT] = ACTIONS(3760),
    [anon_sym_GT_GT_GT] = ACTIONS(3760),
    [anon_sym_AMP_CARET] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3750),
    [anon_sym_POUND_LBRACK] = ACTIONS(3776),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2053),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_STAR_EQ] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2053),
    [anon_sym_PERCENT_EQ] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2053),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2053),
    [anon_sym_PLUS_EQ] = ACTIONS(2053),
    [anon_sym_DASH_EQ] = ACTIONS(2053),
    [anon_sym_PIPE_EQ] = ACTIONS(2053),
    [anon_sym_CARET_EQ] = ACTIONS(2053),
    [anon_sym_COLON_EQ] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
  },
  [993] = {
    [sym_line_comment] = STATE(993),
    [sym_block_comment] = STATE(993),
    [sym_type_parameters] = STATE(4185),
    [sym_argument_list] = STATE(1016),
    [sym_or_block] = STATE(1017),
    [aux_sym_strictly_expression_list_repeat1] = STATE(1924),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_LF] = ACTIONS(1995),
    [anon_sym_CR] = ACTIONS(1995),
    [anon_sym_CR_LF] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3752),
    [anon_sym_LBRACE] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(2001),
    [anon_sym_fn] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3758),
    [anon_sym_STAR] = ACTIONS(3760),
    [anon_sym_SLASH] = ACTIONS(3760),
    [anon_sym_PERCENT] = ACTIONS(3760),
    [anon_sym_LT] = ACTIONS(3762),
    [anon_sym_GT] = ACTIONS(3762),
    [anon_sym_EQ_EQ] = ACTIONS(3762),
    [anon_sym_BANG_EQ] = ACTIONS(3762),
    [anon_sym_LT_EQ] = ACTIONS(3762),
    [anon_sym_GT_EQ] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_struct] = ACTIONS(1995),
    [anon_sym_mut] = ACTIONS(1995),
    [anon_sym_PLUS_PLUS] = ACTIONS(3768),
    [anon_sym_DASH_DASH] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3772),
    [anon_sym_BANG] = ACTIONS(3774),
    [anon_sym_go] = ACTIONS(1995),
    [anon_sym_spawn] = ACTIONS(1995),
    [anon_sym_json_DOTdecode] = ACTIONS(1995),
    [anon_sym_PIPE] = ACTIONS(3758),
    [anon_sym_LBRACK2] = ACTIONS(3776),
    [anon_sym_TILDE] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(3758),
    [anon_sym_AMP] = ACTIONS(3760),
    [anon_sym_LT_DASH] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(3760),
    [anon_sym_GT_GT] = ACTIONS(3760),
    [anon_sym_GT_GT_GT] = ACTIONS(3760),
    [anon_sym_AMP_CARET] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_or] = ACTIONS(3786),
    [sym_none] = ACTIONS(1995),
    [sym_true] = ACTIONS(1995),
    [sym_false] = ACTIONS(1995),
    [sym_nil] = ACTIONS(1995),
    [anon_sym_QMARK_DOT] = ACTIONS(3750),
    [anon_sym_POUND_LBRACK] = ACTIONS(3776),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_DOLLARif] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(3788),
    [anon_sym_BANGis] = ACTIONS(3788),
    [anon_sym_in] = ACTIONS(3790),
    [anon_sym_BANGin] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(1995),
    [anon_sym_select] = ACTIONS(1995),
    [anon_sym_STAR_EQ] = ACTIONS(2001),
    [anon_sym_SLASH_EQ] = ACTIONS(2001),
    [anon_sym_PERCENT_EQ] = ACTIONS(2001),
    [anon_sym_LT_LT_EQ] = ACTIONS(2001),
    [anon_sym_GT_GT_EQ] = ACTIONS(2001),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2001),
    [anon_sym_AMP_EQ] = ACTIONS(2001),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2001),
    [anon_sym_PLUS_EQ] = ACTIONS(2001),
    [anon_sym_DASH_EQ] = ACTIONS(2001),
    [anon_sym_PIPE_EQ] = ACTIONS(2001),
    [anon_sym_CARET_EQ] = ACTIONS(2001),
    [anon_sym_COLON_EQ] = ACTIONS(2001),
    [anon_sym_lock] = ACTIONS(1995),
    [anon_sym_rlock] = ACTIONS(1995),
    [anon_sym_unsafe] = ACTIONS(1995),
    [anon_sym_sql] = ACTIONS(1995),
    [sym_int_literal] = ACTIONS(1995),
    [sym_float_literal] = ACTIONS(1995),
    [sym_rune_literal] = ACTIONS(1995),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_DQUOTE] = ACTIONS(1995),
    [anon_sym_c_SQUOTE] = ACTIONS(1995),
    [anon_sym_c_DQUOTE] = ACTIONS(1995),
    [anon_sym_r_SQUOTE] = ACTIONS(1995),
    [anon_sym_r_DQUOTE] = ACTIONS(1995),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1995),
    [anon_sym_shared] = ACTIONS(1995),
    [anon_sym_map_LBRACK] = ACTIONS(1995),
    [anon_sym_chan] = ACTIONS(1995),
    [anon_sym_thread] = ACTIONS(1995),
    [anon_sym_atomic] = ACTIONS(1995),
    [anon_sym_assert] = ACTIONS(1995),
    [anon_sym_defer] = ACTIONS(1995),
    [anon_sym_goto] = ACTIONS(1995),
    [anon_sym_break] = ACTIONS(1995),
    [anon_sym_continue] = ACTIONS(1995),
    [anon_sym_return] = ACTIONS(1995),
    [anon_sym_DOLLARfor] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_POUND] = ACTIONS(1995),
    [anon_sym_asm] = ACTIONS(1995),
  },
  [994] = {
    [sym_line_comment] = STATE(994),
    [sym_block_comment] = STATE(994),
    [sym_type_parameters] = STATE(4185),
    [sym_argument_list] = STATE(1016),
    [sym_or_block] = STATE(1017),
    [sym_identifier] = ACTIONS(2065),
    [anon_sym_LF] = ACTIONS(2065),
    [anon_sym_CR] = ACTIONS(2065),
    [anon_sym_CR_LF] = ACTIONS(2065),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_DOT] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3752),
    [anon_sym_LBRACE] = ACTIONS(2065),
    [anon_sym_COMMA] = ACTIONS(2065),
    [anon_sym_RBRACE] = ACTIONS(2065),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(2065),
    [anon_sym_fn] = ACTIONS(2065),
    [anon_sym_PLUS] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3758),
    [anon_sym_STAR] = ACTIONS(3760),
    [anon_sym_SLASH] = ACTIONS(3760),
    [anon_sym_PERCENT] = ACTIONS(3760),
    [anon_sym_LT] = ACTIONS(3762),
    [anon_sym_GT] = ACTIONS(3762),
    [anon_sym_EQ_EQ] = ACTIONS(3762),
    [anon_sym_BANG_EQ] = ACTIONS(3762),
    [anon_sym_LT_EQ] = ACTIONS(3762),
    [anon_sym_GT_EQ] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_struct] = ACTIONS(2065),
    [anon_sym_mut] = ACTIONS(2065),
    [anon_sym_COLON] = ACTIONS(2065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3768),
    [anon_sym_DASH_DASH] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3772),
    [anon_sym_BANG] = ACTIONS(3774),
    [anon_sym_go] = ACTIONS(2065),
    [anon_sym_spawn] = ACTIONS(2065),
    [anon_sym_json_DOTdecode] = ACTIONS(2065),
    [anon_sym_PIPE] = ACTIONS(3758),
    [anon_sym_LBRACK2] = ACTIONS(3776),
    [anon_sym_TILDE] = ACTIONS(2065),
    [anon_sym_CARET] = ACTIONS(3758),
    [anon_sym_AMP] = ACTIONS(3760),
    [anon_sym_LT_DASH] = ACTIONS(2065),
    [anon_sym_LT_LT] = ACTIONS(3760),
    [anon_sym_GT_GT] = ACTIONS(3760),
    [anon_sym_GT_GT_GT] = ACTIONS(3760),
    [anon_sym_AMP_CARET] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_or] = ACTIONS(3786),
    [sym_none] = ACTIONS(2065),
    [sym_true] = ACTIONS(2065),
    [sym_false] = ACTIONS(2065),
    [sym_nil] = ACTIONS(2065),
    [anon_sym_QMARK_DOT] = ACTIONS(3750),
    [anon_sym_POUND_LBRACK] = ACTIONS(3776),
    [anon_sym_if] = ACTIONS(2065),
    [anon_sym_DOLLARif] = ACTIONS(2065),
    [anon_sym_is] = ACTIONS(3788),
    [anon_sym_BANGis] = ACTIONS(3788),
    [anon_sym_in] = ACTIONS(3790),
    [anon_sym_BANGin] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(2065),
    [anon_sym_select] = ACTIONS(2065),
    [anon_sym_STAR_EQ] = ACTIONS(2065),
    [anon_sym_SLASH_EQ] = ACTIONS(2065),
    [anon_sym_PERCENT_EQ] = ACTIONS(2065),
    [anon_sym_LT_LT_EQ] = ACTIONS(2065),
    [anon_sym_GT_GT_EQ] = ACTIONS(2065),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2065),
    [anon_sym_AMP_EQ] = ACTIONS(2065),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2065),
    [anon_sym_PLUS_EQ] = ACTIONS(2065),
    [anon_sym_DASH_EQ] = ACTIONS(2065),
    [anon_sym_PIPE_EQ] = ACTIONS(2065),
    [anon_sym_CARET_EQ] = ACTIONS(2065),
    [anon_sym_COLON_EQ] = ACTIONS(2065),
    [anon_sym_lock] = ACTIONS(2065),
    [anon_sym_rlock] = ACTIONS(2065),
    [anon_sym_unsafe] = ACTIONS(2065),
    [anon_sym_sql] = ACTIONS(2065),
    [sym_int_literal] = ACTIONS(2065),
    [sym_float_literal] = ACTIONS(2065),
    [sym_rune_literal] = ACTIONS(2065),
    [anon_sym_SQUOTE] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2065),
    [anon_sym_c_SQUOTE] = ACTIONS(2065),
    [anon_sym_c_DQUOTE] = ACTIONS(2065),
    [anon_sym_r_SQUOTE] = ACTIONS(2065),
    [anon_sym_r_DQUOTE] = ACTIONS(2065),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2065),
    [anon_sym_shared] = ACTIONS(2065),
    [anon_sym_map_LBRACK] = ACTIONS(2065),
    [anon_sym_chan] = ACTIONS(2065),
    [anon_sym_thread] = ACTIONS(2065),
    [anon_sym_atomic] = ACTIONS(2065),
    [anon_sym_assert] = ACTIONS(2065),
    [anon_sym_defer] = ACTIONS(2065),
    [anon_sym_goto] = ACTIONS(2065),
    [anon_sym_break] = ACTIONS(2065),
    [anon_sym_continue] = ACTIONS(2065),
    [anon_sym_return] = ACTIONS(2065),
    [anon_sym_DOLLARfor] = ACTIONS(2065),
    [anon_sym_for] = ACTIONS(2065),
    [anon_sym_POUND] = ACTIONS(2065),
    [anon_sym_asm] = ACTIONS(2065),
  },
  [995] = {
    [sym_line_comment] = STATE(995),
    [sym_block_comment] = STATE(995),
    [sym_else_branch] = STATE(1100),
    [sym_identifier] = ACTIONS(2089),
    [anon_sym_LF] = ACTIONS(2089),
    [anon_sym_CR] = ACTIONS(2089),
    [anon_sym_CR_LF] = ACTIONS(2089),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2089),
    [anon_sym_DOT] = ACTIONS(2089),
    [anon_sym_as] = ACTIONS(2089),
    [anon_sym_LBRACE] = ACTIONS(2089),
    [anon_sym_COMMA] = ACTIONS(2089),
    [anon_sym_RBRACE] = ACTIONS(2089),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_EQ] = ACTIONS(2089),
    [anon_sym_fn] = ACTIONS(2089),
    [anon_sym_PLUS] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2089),
    [anon_sym_SLASH] = ACTIONS(2089),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_LT] = ACTIONS(2089),
    [anon_sym_GT] = ACTIONS(2089),
    [anon_sym_EQ_EQ] = ACTIONS(2089),
    [anon_sym_BANG_EQ] = ACTIONS(2089),
    [anon_sym_LT_EQ] = ACTIONS(2089),
    [anon_sym_GT_EQ] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2087),
    [anon_sym_struct] = ACTIONS(2089),
    [anon_sym_mut] = ACTIONS(2089),
    [anon_sym_COLON] = ACTIONS(2089),
    [anon_sym_PLUS_PLUS] = ACTIONS(2089),
    [anon_sym_DASH_DASH] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2089),
    [anon_sym_BANG] = ACTIONS(2089),
    [anon_sym_go] = ACTIONS(2089),
    [anon_sym_spawn] = ACTIONS(2089),
    [anon_sym_json_DOTdecode] = ACTIONS(2089),
    [anon_sym_PIPE] = ACTIONS(2089),
    [anon_sym_LBRACK2] = ACTIONS(2089),
    [anon_sym_TILDE] = ACTIONS(2089),
    [anon_sym_CARET] = ACTIONS(2089),
    [anon_sym_AMP] = ACTIONS(2089),
    [anon_sym_LT_DASH] = ACTIONS(2089),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_GT_GT] = ACTIONS(2089),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_AMP_CARET] = ACTIONS(2089),
    [anon_sym_AMP_AMP] = ACTIONS(2089),
    [anon_sym_PIPE_PIPE] = ACTIONS(2089),
    [anon_sym_or] = ACTIONS(2089),
    [sym_none] = ACTIONS(2089),
    [sym_true] = ACTIONS(2089),
    [sym_false] = ACTIONS(2089),
    [sym_nil] = ACTIONS(2089),
    [anon_sym_QMARK_DOT] = ACTIONS(2089),
    [anon_sym_POUND_LBRACK] = ACTIONS(2089),
    [anon_sym_if] = ACTIONS(2089),
    [anon_sym_else] = ACTIONS(3792),
    [anon_sym_DOLLARif] = ACTIONS(2089),
    [anon_sym_is] = ACTIONS(2089),
    [anon_sym_BANGis] = ACTIONS(2089),
    [anon_sym_in] = ACTIONS(2089),
    [anon_sym_BANGin] = ACTIONS(2089),
    [anon_sym_match] = ACTIONS(2089),
    [anon_sym_select] = ACTIONS(2089),
    [anon_sym_STAR_EQ] = ACTIONS(2089),
    [anon_sym_SLASH_EQ] = ACTIONS(2089),
    [anon_sym_PERCENT_EQ] = ACTIONS(2089),
    [anon_sym_LT_LT_EQ] = ACTIONS(2089),
    [anon_sym_GT_GT_EQ] = ACTIONS(2089),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2089),
    [anon_sym_AMP_EQ] = ACTIONS(2089),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2089),
    [anon_sym_PLUS_EQ] = ACTIONS(2089),
    [anon_sym_DASH_EQ] = ACTIONS(2089),
    [anon_sym_PIPE_EQ] = ACTIONS(2089),
    [anon_sym_CARET_EQ] = ACTIONS(2089),
    [anon_sym_COLON_EQ] = ACTIONS(2089),
    [anon_sym_lock] = ACTIONS(2089),
    [anon_sym_rlock] = ACTIONS(2089),
    [anon_sym_unsafe] = ACTIONS(2089),
    [anon_sym_sql] = ACTIONS(2089),
    [sym_int_literal] = ACTIONS(2089),
    [sym_float_literal] = ACTIONS(2089),
    [sym_rune_literal] = ACTIONS(2089),
    [anon_sym_SQUOTE] = ACTIONS(2089),
    [anon_sym_DQUOTE] = ACTIONS(2089),
    [anon_sym_c_SQUOTE] = ACTIONS(2089),
    [anon_sym_c_DQUOTE] = ACTIONS(2089),
    [anon_sym_r_SQUOTE] = ACTIONS(2089),
    [anon_sym_r_DQUOTE] = ACTIONS(2089),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2089),
    [anon_sym_shared] = ACTIONS(2089),
    [anon_sym_map_LBRACK] = ACTIONS(2089),
    [anon_sym_chan] = ACTIONS(2089),
    [anon_sym_thread] = ACTIONS(2089),
    [anon_sym_atomic] = ACTIONS(2089),
    [anon_sym_assert] = ACTIONS(2089),
    [anon_sym_defer] = ACTIONS(2089),
    [anon_sym_goto] = ACTIONS(2089),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_continue] = ACTIONS(2089),
    [anon_sym_return] = ACTIONS(2089),
    [anon_sym_DOLLARfor] = ACTIONS(2089),
    [anon_sym_for] = ACTIONS(2089),
    [anon_sym_POUND] = ACTIONS(2089),
    [anon_sym_asm] = ACTIONS(2089),
  },
  [996] = {
    [sym_line_comment] = STATE(996),
    [sym_block_comment] = STATE(996),
    [sym_else_branch] = STATE(1101),
    [sym_identifier] = ACTIONS(2083),
    [anon_sym_LF] = ACTIONS(2083),
    [anon_sym_CR] = ACTIONS(2083),
    [anon_sym_CR_LF] = ACTIONS(2083),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2083),
    [anon_sym_DOT] = ACTIONS(2083),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(2083),
    [anon_sym_COMMA] = ACTIONS(2083),
    [anon_sym_RBRACE] = ACTIONS(2083),
    [anon_sym_LPAREN] = ACTIONS(2083),
    [anon_sym_EQ] = ACTIONS(2083),
    [anon_sym_fn] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2083),
    [anon_sym_SLASH] = ACTIONS(2083),
    [anon_sym_PERCENT] = ACTIONS(2083),
    [anon_sym_LT] = ACTIONS(2083),
    [anon_sym_GT] = ACTIONS(2083),
    [anon_sym_EQ_EQ] = ACTIONS(2083),
    [anon_sym_BANG_EQ] = ACTIONS(2083),
    [anon_sym_LT_EQ] = ACTIONS(2083),
    [anon_sym_GT_EQ] = ACTIONS(2083),
    [anon_sym_LBRACK] = ACTIONS(2081),
    [anon_sym_struct] = ACTIONS(2083),
    [anon_sym_mut] = ACTIONS(2083),
    [anon_sym_COLON] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_QMARK] = ACTIONS(2083),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_go] = ACTIONS(2083),
    [anon_sym_spawn] = ACTIONS(2083),
    [anon_sym_json_DOTdecode] = ACTIONS(2083),
    [anon_sym_PIPE] = ACTIONS(2083),
    [anon_sym_LBRACK2] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_LT_DASH] = ACTIONS(2083),
    [anon_sym_LT_LT] = ACTIONS(2083),
    [anon_sym_GT_GT] = ACTIONS(2083),
    [anon_sym_GT_GT_GT] = ACTIONS(2083),
    [anon_sym_AMP_CARET] = ACTIONS(2083),
    [anon_sym_AMP_AMP] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(2083),
    [anon_sym_or] = ACTIONS(2083),
    [sym_none] = ACTIONS(2083),
    [sym_true] = ACTIONS(2083),
    [sym_false] = ACTIONS(2083),
    [sym_nil] = ACTIONS(2083),
    [anon_sym_QMARK_DOT] = ACTIONS(2083),
    [anon_sym_POUND_LBRACK] = ACTIONS(2083),
    [anon_sym_if] = ACTIONS(2083),
    [anon_sym_else] = ACTIONS(3792),
    [anon_sym_DOLLARif] = ACTIONS(2083),
    [anon_sym_is] = ACTIONS(2083),
    [anon_sym_BANGis] = ACTIONS(2083),
    [anon_sym_in] = ACTIONS(2083),
    [anon_sym_BANGin] = ACTIONS(2083),
    [anon_sym_match] = ACTIONS(2083),
    [anon_sym_select] = ACTIONS(2083),
    [anon_sym_STAR_EQ] = ACTIONS(2083),
    [anon_sym_SLASH_EQ] = ACTIONS(2083),
    [anon_sym_PERCENT_EQ] = ACTIONS(2083),
    [anon_sym_LT_LT_EQ] = ACTIONS(2083),
    [anon_sym_GT_GT_EQ] = ACTIONS(2083),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2083),
    [anon_sym_AMP_EQ] = ACTIONS(2083),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2083),
    [anon_sym_PLUS_EQ] = ACTIONS(2083),
    [anon_sym_DASH_EQ] = ACTIONS(2083),
    [anon_sym_PIPE_EQ] = ACTIONS(2083),
    [anon_sym_CARET_EQ] = ACTIONS(2083),
    [anon_sym_COLON_EQ] = ACTIONS(2083),
    [anon_sym_lock] = ACTIONS(2083),
    [anon_sym_rlock] = ACTIONS(2083),
    [anon_sym_unsafe] = ACTIONS(2083),
    [anon_sym_sql] = ACTIONS(2083),
    [sym_int_literal] = ACTIONS(2083),
    [sym_float_literal] = ACTIONS(2083),
    [sym_rune_literal] = ACTIONS(2083),
    [anon_sym_SQUOTE] = ACTIONS(2083),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_c_SQUOTE] = ACTIONS(2083),
    [anon_sym_c_DQUOTE] = ACTIONS(2083),
    [anon_sym_r_SQUOTE] = ACTIONS(2083),
    [anon_sym_r_DQUOTE] = ACTIONS(2083),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2083),
    [anon_sym_shared] = ACTIONS(2083),
    [anon_sym_map_LBRACK] = ACTIONS(2083),
    [anon_sym_chan] = ACTIONS(2083),
    [anon_sym_thread] = ACTIONS(2083),
    [anon_sym_atomic] = ACTIONS(2083),
    [anon_sym_assert] = ACTIONS(2083),
    [anon_sym_defer] = ACTIONS(2083),
    [anon_sym_goto] = ACTIONS(2083),
    [anon_sym_break] = ACTIONS(2083),
    [anon_sym_continue] = ACTIONS(2083),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_DOLLARfor] = ACTIONS(2083),
    [anon_sym_for] = ACTIONS(2083),
    [anon_sym_POUND] = ACTIONS(2083),
    [anon_sym_asm] = ACTIONS(2083),
  },
  [997] = {
    [sym_line_comment] = STATE(997),
    [sym_block_comment] = STATE(997),
    [sym_type_parameters] = STATE(4185),
    [sym_argument_list] = STATE(1016),
    [sym_or_block] = STATE(1017),
    [sym_identifier] = ACTIONS(2069),
    [anon_sym_LF] = ACTIONS(2069),
    [anon_sym_CR] = ACTIONS(2069),
    [anon_sym_CR_LF] = ACTIONS(2069),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2069),
    [anon_sym_DOT] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3752),
    [anon_sym_LBRACE] = ACTIONS(2069),
    [anon_sym_COMMA] = ACTIONS(2069),
    [anon_sym_RBRACE] = ACTIONS(2069),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(2069),
    [anon_sym_fn] = ACTIONS(2069),
    [anon_sym_PLUS] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3758),
    [anon_sym_STAR] = ACTIONS(3760),
    [anon_sym_SLASH] = ACTIONS(3760),
    [anon_sym_PERCENT] = ACTIONS(3760),
    [anon_sym_LT] = ACTIONS(3762),
    [anon_sym_GT] = ACTIONS(3762),
    [anon_sym_EQ_EQ] = ACTIONS(3762),
    [anon_sym_BANG_EQ] = ACTIONS(3762),
    [anon_sym_LT_EQ] = ACTIONS(3762),
    [anon_sym_GT_EQ] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_struct] = ACTIONS(2069),
    [anon_sym_mut] = ACTIONS(2069),
    [anon_sym_PLUS_PLUS] = ACTIONS(3768),
    [anon_sym_DASH_DASH] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3772),
    [anon_sym_BANG] = ACTIONS(3774),
    [anon_sym_go] = ACTIONS(2069),
    [anon_sym_spawn] = ACTIONS(2069),
    [anon_sym_json_DOTdecode] = ACTIONS(2069),
    [anon_sym_PIPE] = ACTIONS(3758),
    [anon_sym_LBRACK2] = ACTIONS(3776),
    [anon_sym_TILDE] = ACTIONS(2069),
    [anon_sym_CARET] = ACTIONS(3758),
    [anon_sym_AMP] = ACTIONS(3760),
    [anon_sym_LT_DASH] = ACTIONS(2069),
    [anon_sym_LT_LT] = ACTIONS(3760),
    [anon_sym_GT_GT] = ACTIONS(3760),
    [anon_sym_GT_GT_GT] = ACTIONS(3760),
    [anon_sym_AMP_CARET] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_or] = ACTIONS(3786),
    [sym_none] = ACTIONS(2069),
    [sym_true] = ACTIONS(2069),
    [sym_false] = ACTIONS(2069),
    [sym_nil] = ACTIONS(2069),
    [anon_sym_QMARK_DOT] = ACTIONS(3750),
    [anon_sym_POUND_LBRACK] = ACTIONS(3776),
    [anon_sym_if] = ACTIONS(2069),
    [anon_sym_DOLLARif] = ACTIONS(2069),
    [anon_sym_is] = ACTIONS(3794),
    [anon_sym_BANGis] = ACTIONS(3794),
    [anon_sym_in] = ACTIONS(3790),
    [anon_sym_BANGin] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(2069),
    [anon_sym_select] = ACTIONS(2069),
    [anon_sym_STAR_EQ] = ACTIONS(2069),
    [anon_sym_SLASH_EQ] = ACTIONS(2069),
    [anon_sym_PERCENT_EQ] = ACTIONS(2069),
    [anon_sym_LT_LT_EQ] = ACTIONS(2069),
    [anon_sym_GT_GT_EQ] = ACTIONS(2069),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2069),
    [anon_sym_AMP_EQ] = ACTIONS(2069),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2069),
    [anon_sym_PLUS_EQ] = ACTIONS(2069),
    [anon_sym_DASH_EQ] = ACTIONS(2069),
    [anon_sym_PIPE_EQ] = ACTIONS(2069),
    [anon_sym_CARET_EQ] = ACTIONS(2069),
    [anon_sym_COLON_EQ] = ACTIONS(2069),
    [anon_sym_lock] = ACTIONS(2069),
    [anon_sym_rlock] = ACTIONS(2069),
    [anon_sym_unsafe] = ACTIONS(2069),
    [anon_sym_sql] = ACTIONS(2069),
    [sym_int_literal] = ACTIONS(2069),
    [sym_float_literal] = ACTIONS(2069),
    [sym_rune_literal] = ACTIONS(2069),
    [anon_sym_SQUOTE] = ACTIONS(2069),
    [anon_sym_DQUOTE] = ACTIONS(2069),
    [anon_sym_c_SQUOTE] = ACTIONS(2069),
    [anon_sym_c_DQUOTE] = ACTIONS(2069),
    [anon_sym_r_SQUOTE] = ACTIONS(2069),
    [anon_sym_r_DQUOTE] = ACTIONS(2069),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2069),
    [anon_sym_shared] = ACTIONS(2069),
    [anon_sym_map_LBRACK] = ACTIONS(2069),
    [anon_sym_chan] = ACTIONS(2069),
    [anon_sym_thread] = ACTIONS(2069),
    [anon_sym_atomic] = ACTIONS(2069),
    [anon_sym_assert] = ACTIONS(2069),
    [anon_sym_defer] = ACTIONS(2069),
    [anon_sym_goto] = ACTIONS(2069),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_continue] = ACTIONS(2069),
    [anon_sym_return] = ACTIONS(2069),
    [anon_sym_DOLLARfor] = ACTIONS(2069),
    [anon_sym_for] = ACTIONS(2069),
    [anon_sym_POUND] = ACTIONS(2069),
    [anon_sym_asm] = ACTIONS(2069),
  },
  [998] = {
    [sym_line_comment] = STATE(998),
    [sym_block_comment] = STATE(998),
    [sym_identifier] = ACTIONS(2093),
    [anon_sym_LF] = ACTIONS(2093),
    [anon_sym_CR] = ACTIONS(2093),
    [anon_sym_CR_LF] = ACTIONS(2093),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2093),
    [anon_sym_DOT] = ACTIONS(2093),
    [anon_sym_as] = ACTIONS(2093),
    [anon_sym_LBRACE] = ACTIONS(2093),
    [anon_sym_COMMA] = ACTIONS(2093),
    [anon_sym_RBRACE] = ACTIONS(2093),
    [anon_sym_LPAREN] = ACTIONS(2093),
    [anon_sym_EQ] = ACTIONS(2093),
    [anon_sym_fn] = ACTIONS(2093),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(2093),
    [anon_sym_SLASH] = ACTIONS(2093),
    [anon_sym_PERCENT] = ACTIONS(2093),
    [anon_sym_LT] = ACTIONS(2093),
    [anon_sym_GT] = ACTIONS(2093),
    [anon_sym_EQ_EQ] = ACTIONS(2093),
    [anon_sym_BANG_EQ] = ACTIONS(2093),
    [anon_sym_LT_EQ] = ACTIONS(2093),
    [anon_sym_GT_EQ] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2091),
    [anon_sym_struct] = ACTIONS(2093),
    [anon_sym_mut] = ACTIONS(2093),
    [anon_sym_COLON] = ACTIONS(2093),
    [anon_sym_PLUS_PLUS] = ACTIONS(2093),
    [anon_sym_DASH_DASH] = ACTIONS(2093),
    [anon_sym_QMARK] = ACTIONS(2093),
    [anon_sym_BANG] = ACTIONS(2093),
    [anon_sym_go] = ACTIONS(2093),
    [anon_sym_spawn] = ACTIONS(2093),
    [anon_sym_json_DOTdecode] = ACTIONS(2093),
    [anon_sym_PIPE] = ACTIONS(2093),
    [anon_sym_LBRACK2] = ACTIONS(2093),
    [anon_sym_TILDE] = ACTIONS(2093),
    [anon_sym_CARET] = ACTIONS(2093),
    [anon_sym_AMP] = ACTIONS(2093),
    [anon_sym_LT_DASH] = ACTIONS(2093),
    [anon_sym_LT_LT] = ACTIONS(2093),
    [anon_sym_GT_GT] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2093),
    [anon_sym_AMP_CARET] = ACTIONS(2093),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_PIPE_PIPE] = ACTIONS(2093),
    [anon_sym_or] = ACTIONS(2093),
    [sym_none] = ACTIONS(2093),
    [sym_true] = ACTIONS(2093),
    [sym_false] = ACTIONS(2093),
    [sym_nil] = ACTIONS(2093),
    [anon_sym_QMARK_DOT] = ACTIONS(2093),
    [anon_sym_POUND_LBRACK] = ACTIONS(2093),
    [anon_sym_if] = ACTIONS(2093),
    [anon_sym_DOLLARif] = ACTIONS(2093),
    [anon_sym_DOLLARelse] = ACTIONS(3796),
    [anon_sym_is] = ACTIONS(2093),
    [anon_sym_BANGis] = ACTIONS(2093),
    [anon_sym_in] = ACTIONS(2093),
    [anon_sym_BANGin] = ACTIONS(2093),
    [anon_sym_match] = ACTIONS(2093),
    [anon_sym_select] = ACTIONS(2093),
    [anon_sym_STAR_EQ] = ACTIONS(2093),
    [anon_sym_SLASH_EQ] = ACTIONS(2093),
    [anon_sym_PERCENT_EQ] = ACTIONS(2093),
    [anon_sym_LT_LT_EQ] = ACTIONS(2093),
    [anon_sym_GT_GT_EQ] = ACTIONS(2093),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2093),
    [anon_sym_AMP_EQ] = ACTIONS(2093),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2093),
    [anon_sym_PLUS_EQ] = ACTIONS(2093),
    [anon_sym_DASH_EQ] = ACTIONS(2093),
    [anon_sym_PIPE_EQ] = ACTIONS(2093),
    [anon_sym_CARET_EQ] = ACTIONS(2093),
    [anon_sym_COLON_EQ] = ACTIONS(2093),
    [anon_sym_lock] = ACTIONS(2093),
    [anon_sym_rlock] = ACTIONS(2093),
    [anon_sym_unsafe] = ACTIONS(2093),
    [anon_sym_sql] = ACTIONS(2093),
    [sym_int_literal] = ACTIONS(2093),
    [sym_float_literal] = ACTIONS(2093),
    [sym_rune_literal] = ACTIONS(2093),
    [anon_sym_SQUOTE] = ACTIONS(2093),
    [anon_sym_DQUOTE] = ACTIONS(2093),
    [anon_sym_c_SQUOTE] = ACTIONS(2093),
    [anon_sym_c_DQUOTE] = ACTIONS(2093),
    [anon_sym_r_SQUOTE] = ACTIONS(2093),
    [anon_sym_r_DQUOTE] = ACTIONS(2093),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2093),
    [anon_sym_shared] = ACTIONS(2093),
    [anon_sym_map_LBRACK] = ACTIONS(2093),
    [anon_sym_chan] = ACTIONS(2093),
    [anon_sym_thread] = ACTIONS(2093),
    [anon_sym_atomic] = ACTIONS(2093),
    [anon_sym_assert] = ACTIONS(2093),
    [anon_sym_defer] = ACTIONS(2093),
    [anon_sym_goto] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2093),
    [anon_sym_continue] = ACTIONS(2093),
    [anon_sym_return] = ACTIONS(2093),
    [anon_sym_DOLLARfor] = ACTIONS(2093),
    [anon_sym_for] = ACTIONS(2093),
    [anon_sym_POUND] = ACTIONS(2093),
    [anon_sym_asm] = ACTIONS(2093),
  },
  [999] = {
    [sym_line_comment] = STATE(999),
    [sym_block_comment] = STATE(999),
    [sym_identifier] = ACTIONS(2105),
    [anon_sym_LF] = ACTIONS(2105),
    [anon_sym_CR] = ACTIONS(2105),
    [anon_sym_CR_LF] = ACTIONS(2105),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2105),
    [anon_sym_DOT] = ACTIONS(2105),
    [anon_sym_as] = ACTIONS(2105),
    [anon_sym_LBRACE] = ACTIONS(2105),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_RBRACE] = ACTIONS(2105),
    [anon_sym_LPAREN] = ACTIONS(2105),
    [anon_sym_EQ] = ACTIONS(2105),
    [anon_sym_fn] = ACTIONS(2105),
    [anon_sym_PLUS] = ACTIONS(2105),
    [anon_sym_DASH] = ACTIONS(2105),
    [anon_sym_STAR] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2105),
    [anon_sym_PERCENT] = ACTIONS(2105),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_GT] = ACTIONS(2105),
    [anon_sym_EQ_EQ] = ACTIONS(2105),
    [anon_sym_BANG_EQ] = ACTIONS(2105),
    [anon_sym_LT_EQ] = ACTIONS(2105),
    [anon_sym_GT_EQ] = ACTIONS(2105),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_struct] = ACTIONS(2105),
    [anon_sym_mut] = ACTIONS(2105),
    [anon_sym_COLON] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_QMARK] = ACTIONS(2105),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_go] = ACTIONS(2105),
    [anon_sym_spawn] = ACTIONS(2105),
    [anon_sym_json_DOTdecode] = ACTIONS(2105),
    [anon_sym_PIPE] = ACTIONS(2105),
    [anon_sym_LBRACK2] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_LT_DASH] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(2105),
    [anon_sym_GT_GT] = ACTIONS(2105),
    [anon_sym_GT_GT_GT] = ACTIONS(2105),
    [anon_sym_AMP_CARET] = ACTIONS(2105),
    [anon_sym_AMP_AMP] = ACTIONS(2105),
    [anon_sym_PIPE_PIPE] = ACTIONS(2105),
    [anon_sym_or] = ACTIONS(2105),
    [sym_none] = ACTIONS(2105),
    [sym_true] = ACTIONS(2105),
    [sym_false] = ACTIONS(2105),
    [sym_nil] = ACTIONS(2105),
    [anon_sym_QMARK_DOT] = ACTIONS(2105),
    [anon_sym_POUND_LBRACK] = ACTIONS(2105),
    [anon_sym_if] = ACTIONS(2105),
    [anon_sym_DOLLARif] = ACTIONS(2105),
    [anon_sym_DOLLARelse] = ACTIONS(3798),
    [anon_sym_is] = ACTIONS(2105),
    [anon_sym_BANGis] = ACTIONS(2105),
    [anon_sym_in] = ACTIONS(2105),
    [anon_sym_BANGin] = ACTIONS(2105),
    [anon_sym_match] = ACTIONS(2105),
    [anon_sym_select] = ACTIONS(2105),
    [anon_sym_STAR_EQ] = ACTIONS(2105),
    [anon_sym_SLASH_EQ] = ACTIONS(2105),
    [anon_sym_PERCENT_EQ] = ACTIONS(2105),
    [anon_sym_LT_LT_EQ] = ACTIONS(2105),
    [anon_sym_GT_GT_EQ] = ACTIONS(2105),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2105),
    [anon_sym_AMP_EQ] = ACTIONS(2105),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2105),
    [anon_sym_PLUS_EQ] = ACTIONS(2105),
    [anon_sym_DASH_EQ] = ACTIONS(2105),
    [anon_sym_PIPE_EQ] = ACTIONS(2105),
    [anon_sym_CARET_EQ] = ACTIONS(2105),
    [anon_sym_COLON_EQ] = ACTIONS(2105),
    [anon_sym_lock] = ACTIONS(2105),
    [anon_sym_rlock] = ACTIONS(2105),
    [anon_sym_unsafe] = ACTIONS(2105),
    [anon_sym_sql] = ACTIONS(2105),
    [sym_int_literal] = ACTIONS(2105),
    [sym_float_literal] = ACTIONS(2105),
    [sym_rune_literal] = ACTIONS(2105),
    [anon_sym_SQUOTE] = ACTIONS(2105),
    [anon_sym_DQUOTE] = ACTIONS(2105),
    [anon_sym_c_SQUOTE] = ACTIONS(2105),
    [anon_sym_c_DQUOTE] = ACTIONS(2105),
    [anon_sym_r_SQUOTE] = ACTIONS(2105),
    [anon_sym_r_DQUOTE] = ACTIONS(2105),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2105),
    [anon_sym_shared] = ACTIONS(2105),
    [anon_sym_map_LBRACK] = ACTIONS(2105),
    [anon_sym_chan] = ACTIONS(2105),
    [anon_sym_thread] = ACTIONS(2105),
    [anon_sym_atomic] = ACTIONS(2105),
    [anon_sym_assert] = ACTIONS(2105),
    [anon_sym_defer] = ACTIONS(2105),
    [anon_sym_goto] = ACTIONS(2105),
    [anon_sym_break] = ACTIONS(2105),
    [anon_sym_continue] = ACTIONS(2105),
    [anon_sym_return] = ACTIONS(2105),
    [anon_sym_DOLLARfor] = ACTIONS(2105),
    [anon_sym_for] = ACTIONS(2105),
    [anon_sym_POUND] = ACTIONS(2105),
    [anon_sym_asm] = ACTIONS(2105),
  },
  [1000] = {
    [sym_line_comment] = STATE(1000),
    [sym_block_comment] = STATE(1000),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_CR] = ACTIONS(2147),
    [anon_sym_CR_LF] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_COMMA] = ACTIONS(2147),
    [anon_sym_RBRACE] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym_EQ] = ACTIONS(2147),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2147),
    [anon_sym_BANG_EQ] = ACTIONS(2147),
    [anon_sym_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2147),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_COLON] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2147),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2147),
    [anon_sym_AMP_CARET] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [anon_sym_or] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2147),
    [anon_sym_POUND_LBRACK] = ACTIONS(2147),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_else] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2147),
    [anon_sym_BANGis] = ACTIONS(2147),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANGin] = ACTIONS(2147),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_STAR_EQ] = ACTIONS(2147),
    [anon_sym_SLASH_EQ] = ACTIONS(2147),
    [anon_sym_PERCENT_EQ] = ACTIONS(2147),
    [anon_sym_LT_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_GT_EQ] = ACTIONS(2147),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2147),
    [anon_sym_AMP_EQ] = ACTIONS(2147),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2147),
    [anon_sym_PLUS_EQ] = ACTIONS(2147),
    [anon_sym_DASH_EQ] = ACTIONS(2147),
    [anon_sym_PIPE_EQ] = ACTIONS(2147),
    [anon_sym_CARET_EQ] = ACTIONS(2147),
    [anon_sym_COLON_EQ] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2147),
    [sym_rune_literal] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_c_SQUOTE] = ACTIONS(2147),
    [anon_sym_c_DQUOTE] = ACTIONS(2147),
    [anon_sym_r_SQUOTE] = ACTIONS(2147),
    [anon_sym_r_DQUOTE] = ACTIONS(2147),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2147),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
    [anon_sym_assert] = ACTIONS(2147),
    [anon_sym_defer] = ACTIONS(2147),
    [anon_sym_goto] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_continue] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2147),
    [anon_sym_DOLLARfor] = ACTIONS(2147),
    [anon_sym_for] = ACTIONS(2147),
    [anon_sym_POUND] = ACTIONS(2147),
    [anon_sym_asm] = ACTIONS(2147),
  },
  [1001] = {
    [sym_line_comment] = STATE(1001),
    [sym_block_comment] = STATE(1001),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_CR] = ACTIONS(2147),
    [anon_sym_CR_LF] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_COMMA] = ACTIONS(2147),
    [anon_sym_RBRACE] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym_EQ] = ACTIONS(2147),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2147),
    [anon_sym_BANG_EQ] = ACTIONS(2147),
    [anon_sym_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2147),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_COLON] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2147),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2147),
    [anon_sym_AMP_CARET] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [anon_sym_or] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2147),
    [anon_sym_POUND_LBRACK] = ACTIONS(2147),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_DOLLARelse] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2147),
    [anon_sym_BANGis] = ACTIONS(2147),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANGin] = ACTIONS(2147),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_STAR_EQ] = ACTIONS(2147),
    [anon_sym_SLASH_EQ] = ACTIONS(2147),
    [anon_sym_PERCENT_EQ] = ACTIONS(2147),
    [anon_sym_LT_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_GT_EQ] = ACTIONS(2147),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2147),
    [anon_sym_AMP_EQ] = ACTIONS(2147),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2147),
    [anon_sym_PLUS_EQ] = ACTIONS(2147),
    [anon_sym_DASH_EQ] = ACTIONS(2147),
    [anon_sym_PIPE_EQ] = ACTIONS(2147),
    [anon_sym_CARET_EQ] = ACTIONS(2147),
    [anon_sym_COLON_EQ] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2147),
    [sym_rune_literal] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_c_SQUOTE] = ACTIONS(2147),
    [anon_sym_c_DQUOTE] = ACTIONS(2147),
    [anon_sym_r_SQUOTE] = ACTIONS(2147),
    [anon_sym_r_DQUOTE] = ACTIONS(2147),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2147),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
    [anon_sym_assert] = ACTIONS(2147),
    [anon_sym_defer] = ACTIONS(2147),
    [anon_sym_goto] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_continue] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2147),
    [anon_sym_DOLLARfor] = ACTIONS(2147),
    [anon_sym_for] = ACTIONS(2147),
    [anon_sym_POUND] = ACTIONS(2147),
    [anon_sym_asm] = ACTIONS(2147),
  },
  [1002] = {
    [sym_line_comment] = STATE(1002),
    [sym_block_comment] = STATE(1002),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_LF] = ACTIONS(2169),
    [anon_sym_CR] = ACTIONS(2169),
    [anon_sym_CR_LF] = ACTIONS(2169),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2169),
    [anon_sym_as] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_COMMA] = ACTIONS(2169),
    [anon_sym_RBRACE] = ACTIONS(2169),
    [anon_sym_LPAREN] = ACTIONS(2169),
    [anon_sym_EQ] = ACTIONS(2169),
    [anon_sym_fn] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_SLASH] = ACTIONS(2169),
    [anon_sym_PERCENT] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2169),
    [anon_sym_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ] = ACTIONS(2169),
    [anon_sym_LT_EQ] = ACTIONS(2169),
    [anon_sym_GT_EQ] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_mut] = ACTIONS(2169),
    [anon_sym_COLON] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_go] = ACTIONS(2169),
    [anon_sym_spawn] = ACTIONS(2169),
    [anon_sym_json_DOTdecode] = ACTIONS(2169),
    [anon_sym_PIPE] = ACTIONS(2169),
    [anon_sym_LBRACK2] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT_DASH] = ACTIONS(2169),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_GT_GT_GT] = ACTIONS(2169),
    [anon_sym_AMP_CARET] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_PIPE_PIPE] = ACTIONS(2169),
    [anon_sym_or] = ACTIONS(2169),
    [sym_none] = ACTIONS(2169),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [sym_nil] = ACTIONS(2169),
    [anon_sym_QMARK_DOT] = ACTIONS(2169),
    [anon_sym_POUND_LBRACK] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_DOLLARif] = ACTIONS(2169),
    [anon_sym_DOLLARelse] = ACTIONS(2169),
    [anon_sym_is] = ACTIONS(2169),
    [anon_sym_BANGis] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_BANGin] = ACTIONS(2169),
    [anon_sym_match] = ACTIONS(2169),
    [anon_sym_select] = ACTIONS(2169),
    [anon_sym_STAR_EQ] = ACTIONS(2169),
    [anon_sym_SLASH_EQ] = ACTIONS(2169),
    [anon_sym_PERCENT_EQ] = ACTIONS(2169),
    [anon_sym_LT_LT_EQ] = ACTIONS(2169),
    [anon_sym_GT_GT_EQ] = ACTIONS(2169),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2169),
    [anon_sym_AMP_EQ] = ACTIONS(2169),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2169),
    [anon_sym_PLUS_EQ] = ACTIONS(2169),
    [anon_sym_DASH_EQ] = ACTIONS(2169),
    [anon_sym_PIPE_EQ] = ACTIONS(2169),
    [anon_sym_CARET_EQ] = ACTIONS(2169),
    [anon_sym_COLON_EQ] = ACTIONS(2169),
    [anon_sym_lock] = ACTIONS(2169),
    [anon_sym_rlock] = ACTIONS(2169),
    [anon_sym_unsafe] = ACTIONS(2169),
    [anon_sym_sql] = ACTIONS(2169),
    [sym_int_literal] = ACTIONS(2169),
    [sym_float_literal] = ACTIONS(2169),
    [sym_rune_literal] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [anon_sym_c_SQUOTE] = ACTIONS(2169),
    [anon_sym_c_DQUOTE] = ACTIONS(2169),
    [anon_sym_r_SQUOTE] = ACTIONS(2169),
    [anon_sym_r_DQUOTE] = ACTIONS(2169),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_map_LBRACK] = ACTIONS(2169),
    [anon_sym_chan] = ACTIONS(2169),
    [anon_sym_thread] = ACTIONS(2169),
    [anon_sym_atomic] = ACTIONS(2169),
    [anon_sym_assert] = ACTIONS(2169),
    [anon_sym_defer] = ACTIONS(2169),
    [anon_sym_goto] = ACTIONS(2169),
    [anon_sym_break] = ACTIONS(2169),
    [anon_sym_continue] = ACTIONS(2169),
    [anon_sym_return] = ACTIONS(2169),
    [anon_sym_DOLLARfor] = ACTIONS(2169),
    [anon_sym_for] = ACTIONS(2169),
    [anon_sym_POUND] = ACTIONS(2169),
    [anon_sym_asm] = ACTIONS(2169),
  },
  [1003] = {
    [sym_line_comment] = STATE(1003),
    [sym_block_comment] = STATE(1003),
    [sym_type_parameters] = STATE(1037),
    [sym_identifier] = ACTIONS(2187),
    [anon_sym_LF] = ACTIONS(2187),
    [anon_sym_CR] = ACTIONS(2187),
    [anon_sym_CR_LF] = ACTIONS(2187),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2187),
    [anon_sym_DOT] = ACTIONS(2187),
    [anon_sym_as] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_RBRACE] = ACTIONS(2187),
    [anon_sym_LPAREN] = ACTIONS(2187),
    [anon_sym_EQ] = ACTIONS(2187),
    [anon_sym_fn] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [anon_sym_LT] = ACTIONS(2187),
    [anon_sym_GT] = ACTIONS(2187),
    [anon_sym_EQ_EQ] = ACTIONS(2187),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2187),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2185),
    [anon_sym_struct] = ACTIONS(2187),
    [anon_sym_mut] = ACTIONS(2187),
    [anon_sym_COLON] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_go] = ACTIONS(2187),
    [anon_sym_spawn] = ACTIONS(2187),
    [anon_sym_json_DOTdecode] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2187),
    [anon_sym_LBRACK2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_LT_DASH] = ACTIONS(2187),
    [anon_sym_LT_LT] = ACTIONS(2187),
    [anon_sym_GT_GT] = ACTIONS(2187),
    [anon_sym_GT_GT_GT] = ACTIONS(2187),
    [anon_sym_AMP_CARET] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2187),
    [sym_none] = ACTIONS(2187),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [sym_nil] = ACTIONS(2187),
    [anon_sym_QMARK_DOT] = ACTIONS(2187),
    [anon_sym_POUND_LBRACK] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_DOLLARif] = ACTIONS(2187),
    [anon_sym_is] = ACTIONS(2187),
    [anon_sym_BANGis] = ACTIONS(2187),
    [anon_sym_in] = ACTIONS(2187),
    [anon_sym_BANGin] = ACTIONS(2187),
    [anon_sym_match] = ACTIONS(2187),
    [anon_sym_select] = ACTIONS(2187),
    [anon_sym_STAR_EQ] = ACTIONS(2187),
    [anon_sym_SLASH_EQ] = ACTIONS(2187),
    [anon_sym_PERCENT_EQ] = ACTIONS(2187),
    [anon_sym_LT_LT_EQ] = ACTIONS(2187),
    [anon_sym_GT_GT_EQ] = ACTIONS(2187),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2187),
    [anon_sym_AMP_EQ] = ACTIONS(2187),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2187),
    [anon_sym_PLUS_EQ] = ACTIONS(2187),
    [anon_sym_DASH_EQ] = ACTIONS(2187),
    [anon_sym_PIPE_EQ] = ACTIONS(2187),
    [anon_sym_CARET_EQ] = ACTIONS(2187),
    [anon_sym_COLON_EQ] = ACTIONS(2187),
    [anon_sym_lock] = ACTIONS(2187),
    [anon_sym_rlock] = ACTIONS(2187),
    [anon_sym_unsafe] = ACTIONS(2187),
    [anon_sym_sql] = ACTIONS(2187),
    [sym_int_literal] = ACTIONS(2187),
    [sym_float_literal] = ACTIONS(2187),
    [sym_rune_literal] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(2187),
    [anon_sym_DQUOTE] = ACTIONS(2187),
    [anon_sym_c_SQUOTE] = ACTIONS(2187),
    [anon_sym_c_DQUOTE] = ACTIONS(2187),
    [anon_sym_r_SQUOTE] = ACTIONS(2187),
    [anon_sym_r_DQUOTE] = ACTIONS(2187),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2187),
    [anon_sym_shared] = ACTIONS(2187),
    [anon_sym_map_LBRACK] = ACTIONS(2187),
    [anon_sym_chan] = ACTIONS(2187),
    [anon_sym_thread] = ACTIONS(2187),
    [anon_sym_atomic] = ACTIONS(2187),
    [anon_sym_assert] = ACTIONS(2187),
    [anon_sym_defer] = ACTIONS(2187),
    [anon_sym_goto] = ACTIONS(2187),
    [anon_sym_break] = ACTIONS(2187),
    [anon_sym_continue] = ACTIONS(2187),
    [anon_sym_return] = ACTIONS(2187),
    [anon_sym_DOLLARfor] = ACTIONS(2187),
    [anon_sym_for] = ACTIONS(2187),
    [anon_sym_POUND] = ACTIONS(2187),
    [anon_sym_asm] = ACTIONS(2187),
  },
  [1004] = {
    [sym_line_comment] = STATE(1004),
    [sym_block_comment] = STATE(1004),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_LF] = ACTIONS(2169),
    [anon_sym_CR] = ACTIONS(2169),
    [anon_sym_CR_LF] = ACTIONS(2169),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2169),
    [anon_sym_as] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_COMMA] = ACTIONS(2169),
    [anon_sym_RBRACE] = ACTIONS(2169),
    [anon_sym_LPAREN] = ACTIONS(2169),
    [anon_sym_EQ] = ACTIONS(2169),
    [anon_sym_fn] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_SLASH] = ACTIONS(2169),
    [anon_sym_PERCENT] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2169),
    [anon_sym_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ] = ACTIONS(2169),
    [anon_sym_LT_EQ] = ACTIONS(2169),
    [anon_sym_GT_EQ] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_mut] = ACTIONS(2169),
    [anon_sym_COLON] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_go] = ACTIONS(2169),
    [anon_sym_spawn] = ACTIONS(2169),
    [anon_sym_json_DOTdecode] = ACTIONS(2169),
    [anon_sym_PIPE] = ACTIONS(2169),
    [anon_sym_LBRACK2] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT_DASH] = ACTIONS(2169),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_GT_GT_GT] = ACTIONS(2169),
    [anon_sym_AMP_CARET] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_PIPE_PIPE] = ACTIONS(2169),
    [anon_sym_or] = ACTIONS(2169),
    [sym_none] = ACTIONS(2169),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [sym_nil] = ACTIONS(2169),
    [anon_sym_QMARK_DOT] = ACTIONS(2169),
    [anon_sym_POUND_LBRACK] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(2169),
    [anon_sym_DOLLARif] = ACTIONS(2169),
    [anon_sym_is] = ACTIONS(2169),
    [anon_sym_BANGis] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_BANGin] = ACTIONS(2169),
    [anon_sym_match] = ACTIONS(2169),
    [anon_sym_select] = ACTIONS(2169),
    [anon_sym_STAR_EQ] = ACTIONS(2169),
    [anon_sym_SLASH_EQ] = ACTIONS(2169),
    [anon_sym_PERCENT_EQ] = ACTIONS(2169),
    [anon_sym_LT_LT_EQ] = ACTIONS(2169),
    [anon_sym_GT_GT_EQ] = ACTIONS(2169),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2169),
    [anon_sym_AMP_EQ] = ACTIONS(2169),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2169),
    [anon_sym_PLUS_EQ] = ACTIONS(2169),
    [anon_sym_DASH_EQ] = ACTIONS(2169),
    [anon_sym_PIPE_EQ] = ACTIONS(2169),
    [anon_sym_CARET_EQ] = ACTIONS(2169),
    [anon_sym_COLON_EQ] = ACTIONS(2169),
    [anon_sym_lock] = ACTIONS(2169),
    [anon_sym_rlock] = ACTIONS(2169),
    [anon_sym_unsafe] = ACTIONS(2169),
    [anon_sym_sql] = ACTIONS(2169),
    [sym_int_literal] = ACTIONS(2169),
    [sym_float_literal] = ACTIONS(2169),
    [sym_rune_literal] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [anon_sym_c_SQUOTE] = ACTIONS(2169),
    [anon_sym_c_DQUOTE] = ACTIONS(2169),
    [anon_sym_r_SQUOTE] = ACTIONS(2169),
    [anon_sym_r_DQUOTE] = ACTIONS(2169),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_map_LBRACK] = ACTIONS(2169),
    [anon_sym_chan] = ACTIONS(2169),
    [anon_sym_thread] = ACTIONS(2169),
    [anon_sym_atomic] = ACTIONS(2169),
    [anon_sym_assert] = ACTIONS(2169),
    [anon_sym_defer] = ACTIONS(2169),
    [anon_sym_goto] = ACTIONS(2169),
    [anon_sym_break] = ACTIONS(2169),
    [anon_sym_continue] = ACTIONS(2169),
    [anon_sym_return] = ACTIONS(2169),
    [anon_sym_DOLLARfor] = ACTIONS(2169),
    [anon_sym_for] = ACTIONS(2169),
    [anon_sym_POUND] = ACTIONS(2169),
    [anon_sym_asm] = ACTIONS(2169),
  },
  [1005] = {
    [sym_line_comment] = STATE(1005),
    [sym_block_comment] = STATE(1005),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LF] = ACTIONS(2893),
    [anon_sym_CR] = ACTIONS(2893),
    [anon_sym_CR_LF] = ACTIONS(2893),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2893),
    [anon_sym_as] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_RBRACE] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2893),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_fn] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_PERCENT] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_GT] = ACTIONS(2893),
    [anon_sym_EQ_EQ] = ACTIONS(2893),
    [anon_sym_BANG_EQ] = ACTIONS(2893),
    [anon_sym_LT_EQ] = ACTIONS(2893),
    [anon_sym_GT_EQ] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_mut] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2893),
    [anon_sym_DASH_DASH] = ACTIONS(2893),
    [anon_sym_QMARK] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_go] = ACTIONS(2893),
    [anon_sym_spawn] = ACTIONS(2893),
    [anon_sym_json_DOTdecode] = ACTIONS(2893),
    [anon_sym_PIPE] = ACTIONS(2893),
    [anon_sym_LBRACK2] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_LT_DASH] = ACTIONS(2893),
    [anon_sym_LT_LT] = ACTIONS(2893),
    [anon_sym_GT_GT] = ACTIONS(2893),
    [anon_sym_GT_GT_GT] = ACTIONS(2893),
    [anon_sym_AMP_CARET] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2893),
    [anon_sym_PIPE_PIPE] = ACTIONS(2893),
    [anon_sym_or] = ACTIONS(2893),
    [sym_none] = ACTIONS(2893),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [sym_nil] = ACTIONS(2893),
    [anon_sym_QMARK_DOT] = ACTIONS(2893),
    [anon_sym_POUND_LBRACK] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_DOLLARif] = ACTIONS(2893),
    [anon_sym_is] = ACTIONS(2893),
    [anon_sym_BANGis] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_BANGin] = ACTIONS(2893),
    [anon_sym_match] = ACTIONS(2893),
    [anon_sym_select] = ACTIONS(2893),
    [anon_sym_STAR_EQ] = ACTIONS(2893),
    [anon_sym_SLASH_EQ] = ACTIONS(2893),
    [anon_sym_PERCENT_EQ] = ACTIONS(2893),
    [anon_sym_LT_LT_EQ] = ACTIONS(2893),
    [anon_sym_GT_GT_EQ] = ACTIONS(2893),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2893),
    [anon_sym_AMP_EQ] = ACTIONS(2893),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2893),
    [anon_sym_PLUS_EQ] = ACTIONS(2893),
    [anon_sym_DASH_EQ] = ACTIONS(2893),
    [anon_sym_PIPE_EQ] = ACTIONS(2893),
    [anon_sym_CARET_EQ] = ACTIONS(2893),
    [anon_sym_COLON_EQ] = ACTIONS(2893),
    [anon_sym_lock] = ACTIONS(2893),
    [anon_sym_rlock] = ACTIONS(2893),
    [anon_sym_unsafe] = ACTIONS(2893),
    [anon_sym_sql] = ACTIONS(2893),
    [sym_int_literal] = ACTIONS(2893),
    [sym_float_literal] = ACTIONS(2893),
    [sym_rune_literal] = ACTIONS(2893),
    [anon_sym_SQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(2893),
    [anon_sym_c_SQUOTE] = ACTIONS(2893),
    [anon_sym_c_DQUOTE] = ACTIONS(2893),
    [anon_sym_r_SQUOTE] = ACTIONS(2893),
    [anon_sym_r_DQUOTE] = ACTIONS(2893),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_map_LBRACK] = ACTIONS(2893),
    [anon_sym_chan] = ACTIONS(2893),
    [anon_sym_thread] = ACTIONS(2893),
    [anon_sym_atomic] = ACTIONS(2893),
    [anon_sym_assert] = ACTIONS(2893),
    [anon_sym_defer] = ACTIONS(2893),
    [anon_sym_goto] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_DOLLARfor] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_POUND] = ACTIONS(2893),
    [anon_sym_asm] = ACTIONS(2893),
  },
  [1006] = {
    [sym_line_comment] = STATE(1006),
    [sym_block_comment] = STATE(1006),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_CR] = ACTIONS(2147),
    [anon_sym_CR_LF] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_COMMA] = ACTIONS(2147),
    [anon_sym_RBRACE] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym_EQ] = ACTIONS(2147),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2147),
    [anon_sym_BANG_EQ] = ACTIONS(2147),
    [anon_sym_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2147),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_COLON] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2147),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2147),
    [anon_sym_AMP_CARET] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [anon_sym_or] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2147),
    [anon_sym_POUND_LBRACK] = ACTIONS(2147),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2147),
    [anon_sym_BANGis] = ACTIONS(2147),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANGin] = ACTIONS(2147),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_STAR_EQ] = ACTIONS(2147),
    [anon_sym_SLASH_EQ] = ACTIONS(2147),
    [anon_sym_PERCENT_EQ] = ACTIONS(2147),
    [anon_sym_LT_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_GT_EQ] = ACTIONS(2147),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2147),
    [anon_sym_AMP_EQ] = ACTIONS(2147),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2147),
    [anon_sym_PLUS_EQ] = ACTIONS(2147),
    [anon_sym_DASH_EQ] = ACTIONS(2147),
    [anon_sym_PIPE_EQ] = ACTIONS(2147),
    [anon_sym_CARET_EQ] = ACTIONS(2147),
    [anon_sym_COLON_EQ] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2147),
    [sym_rune_literal] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_c_SQUOTE] = ACTIONS(2147),
    [anon_sym_c_DQUOTE] = ACTIONS(2147),
    [anon_sym_r_SQUOTE] = ACTIONS(2147),
    [anon_sym_r_DQUOTE] = ACTIONS(2147),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2147),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
    [anon_sym_assert] = ACTIONS(2147),
    [anon_sym_defer] = ACTIONS(2147),
    [anon_sym_goto] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_continue] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2147),
    [anon_sym_DOLLARfor] = ACTIONS(2147),
    [anon_sym_for] = ACTIONS(2147),
    [anon_sym_POUND] = ACTIONS(2147),
    [anon_sym_asm] = ACTIONS(2147),
  },
  [1007] = {
    [sym_line_comment] = STATE(1007),
    [sym_block_comment] = STATE(1007),
    [sym_identifier] = ACTIONS(2865),
    [anon_sym_LF] = ACTIONS(2865),
    [anon_sym_CR] = ACTIONS(2865),
    [anon_sym_CR_LF] = ACTIONS(2865),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2865),
    [anon_sym_DOT] = ACTIONS(2865),
    [anon_sym_as] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2865),
    [anon_sym_COMMA] = ACTIONS(2865),
    [anon_sym_RBRACE] = ACTIONS(2865),
    [anon_sym_LPAREN] = ACTIONS(2865),
    [anon_sym_EQ] = ACTIONS(2865),
    [anon_sym_fn] = ACTIONS(2865),
    [anon_sym_PLUS] = ACTIONS(2865),
    [anon_sym_DASH] = ACTIONS(2865),
    [anon_sym_STAR] = ACTIONS(2865),
    [anon_sym_SLASH] = ACTIONS(2865),
    [anon_sym_PERCENT] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_GT] = ACTIONS(2865),
    [anon_sym_EQ_EQ] = ACTIONS(2865),
    [anon_sym_BANG_EQ] = ACTIONS(2865),
    [anon_sym_LT_EQ] = ACTIONS(2865),
    [anon_sym_GT_EQ] = ACTIONS(2865),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_struct] = ACTIONS(2865),
    [anon_sym_mut] = ACTIONS(2865),
    [anon_sym_COLON] = ACTIONS(2865),
    [anon_sym_PLUS_PLUS] = ACTIONS(2865),
    [anon_sym_DASH_DASH] = ACTIONS(2865),
    [anon_sym_QMARK] = ACTIONS(2865),
    [anon_sym_BANG] = ACTIONS(2865),
    [anon_sym_go] = ACTIONS(2865),
    [anon_sym_spawn] = ACTIONS(2865),
    [anon_sym_json_DOTdecode] = ACTIONS(2865),
    [anon_sym_PIPE] = ACTIONS(2865),
    [anon_sym_LBRACK2] = ACTIONS(2865),
    [anon_sym_TILDE] = ACTIONS(2865),
    [anon_sym_CARET] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2865),
    [anon_sym_LT_DASH] = ACTIONS(2865),
    [anon_sym_LT_LT] = ACTIONS(2865),
    [anon_sym_GT_GT] = ACTIONS(2865),
    [anon_sym_GT_GT_GT] = ACTIONS(2865),
    [anon_sym_AMP_CARET] = ACTIONS(2865),
    [anon_sym_AMP_AMP] = ACTIONS(2865),
    [anon_sym_PIPE_PIPE] = ACTIONS(2865),
    [anon_sym_or] = ACTIONS(2865),
    [sym_none] = ACTIONS(2865),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_nil] = ACTIONS(2865),
    [anon_sym_QMARK_DOT] = ACTIONS(2865),
    [anon_sym_POUND_LBRACK] = ACTIONS(2865),
    [anon_sym_if] = ACTIONS(2865),
    [anon_sym_DOLLARif] = ACTIONS(2865),
    [anon_sym_is] = ACTIONS(2865),
    [anon_sym_BANGis] = ACTIONS(2865),
    [anon_sym_in] = ACTIONS(2865),
    [anon_sym_BANGin] = ACTIONS(2865),
    [anon_sym_match] = ACTIONS(2865),
    [anon_sym_select] = ACTIONS(2865),
    [anon_sym_STAR_EQ] = ACTIONS(2865),
    [anon_sym_SLASH_EQ] = ACTIONS(2865),
    [anon_sym_PERCENT_EQ] = ACTIONS(2865),
    [anon_sym_LT_LT_EQ] = ACTIONS(2865),
    [anon_sym_GT_GT_EQ] = ACTIONS(2865),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2865),
    [anon_sym_AMP_EQ] = ACTIONS(2865),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2865),
    [anon_sym_PLUS_EQ] = ACTIONS(2865),
    [anon_sym_DASH_EQ] = ACTIONS(2865),
    [anon_sym_PIPE_EQ] = ACTIONS(2865),
    [anon_sym_CARET_EQ] = ACTIONS(2865),
    [anon_sym_COLON_EQ] = ACTIONS(2865),
    [anon_sym_lock] = ACTIONS(2865),
    [anon_sym_rlock] = ACTIONS(2865),
    [anon_sym_unsafe] = ACTIONS(2865),
    [anon_sym_sql] = ACTIONS(2865),
    [sym_int_literal] = ACTIONS(2865),
    [sym_float_literal] = ACTIONS(2865),
    [sym_rune_literal] = ACTIONS(2865),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_DQUOTE] = ACTIONS(2865),
    [anon_sym_c_SQUOTE] = ACTIONS(2865),
    [anon_sym_c_DQUOTE] = ACTIONS(2865),
    [anon_sym_r_SQUOTE] = ACTIONS(2865),
    [anon_sym_r_DQUOTE] = ACTIONS(2865),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2865),
    [anon_sym_shared] = ACTIONS(2865),
    [anon_sym_map_LBRACK] = ACTIONS(2865),
    [anon_sym_chan] = ACTIONS(2865),
    [anon_sym_thread] = ACTIONS(2865),
    [anon_sym_atomic] = ACTIONS(2865),
    [anon_sym_assert] = ACTIONS(2865),
    [anon_sym_defer] = ACTIONS(2865),
    [anon_sym_goto] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2865),
    [anon_sym_continue] = ACTIONS(2865),
    [anon_sym_return] = ACTIONS(2865),
    [anon_sym_DOLLARfor] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2865),
    [anon_sym_POUND] = ACTIONS(2865),
    [anon_sym_asm] = ACTIONS(2865),
  },
  [1008] = {
    [sym_line_comment] = STATE(1008),
    [sym_block_comment] = STATE(1008),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_LF] = ACTIONS(2401),
    [anon_sym_CR] = ACTIONS(2401),
    [anon_sym_CR_LF] = ACTIONS(2401),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2401),
    [anon_sym_DOT] = ACTIONS(2401),
    [anon_sym_as] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(2401),
    [anon_sym_COMMA] = ACTIONS(2401),
    [anon_sym_RBRACE] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2401),
    [anon_sym_EQ] = ACTIONS(2401),
    [anon_sym_fn] = ACTIONS(2401),
    [anon_sym_PLUS] = ACTIONS(2401),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_STAR] = ACTIONS(2401),
    [anon_sym_SLASH] = ACTIONS(2401),
    [anon_sym_PERCENT] = ACTIONS(2401),
    [anon_sym_LT] = ACTIONS(2401),
    [anon_sym_GT] = ACTIONS(2401),
    [anon_sym_EQ_EQ] = ACTIONS(2401),
    [anon_sym_BANG_EQ] = ACTIONS(2401),
    [anon_sym_LT_EQ] = ACTIONS(2401),
    [anon_sym_GT_EQ] = ACTIONS(2401),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_struct] = ACTIONS(2401),
    [anon_sym_mut] = ACTIONS(2401),
    [anon_sym_COLON] = ACTIONS(2401),
    [anon_sym_PLUS_PLUS] = ACTIONS(2401),
    [anon_sym_DASH_DASH] = ACTIONS(2401),
    [anon_sym_QMARK] = ACTIONS(2401),
    [anon_sym_BANG] = ACTIONS(2401),
    [anon_sym_go] = ACTIONS(2401),
    [anon_sym_spawn] = ACTIONS(2401),
    [anon_sym_json_DOTdecode] = ACTIONS(2401),
    [anon_sym_PIPE] = ACTIONS(2401),
    [anon_sym_LBRACK2] = ACTIONS(2401),
    [anon_sym_TILDE] = ACTIONS(2401),
    [anon_sym_CARET] = ACTIONS(2401),
    [anon_sym_AMP] = ACTIONS(2401),
    [anon_sym_LT_DASH] = ACTIONS(2401),
    [anon_sym_LT_LT] = ACTIONS(2401),
    [anon_sym_GT_GT] = ACTIONS(2401),
    [anon_sym_GT_GT_GT] = ACTIONS(2401),
    [anon_sym_AMP_CARET] = ACTIONS(2401),
    [anon_sym_AMP_AMP] = ACTIONS(2401),
    [anon_sym_PIPE_PIPE] = ACTIONS(2401),
    [anon_sym_or] = ACTIONS(2401),
    [sym_none] = ACTIONS(2401),
    [sym_true] = ACTIONS(2401),
    [sym_false] = ACTIONS(2401),
    [sym_nil] = ACTIONS(2401),
    [anon_sym_QMARK_DOT] = ACTIONS(2401),
    [anon_sym_POUND_LBRACK] = ACTIONS(2401),
    [anon_sym_if] = ACTIONS(2401),
    [anon_sym_DOLLARif] = ACTIONS(2401),
    [anon_sym_is] = ACTIONS(2401),
    [anon_sym_BANGis] = ACTIONS(2401),
    [anon_sym_in] = ACTIONS(2401),
    [anon_sym_BANGin] = ACTIONS(2401),
    [anon_sym_match] = ACTIONS(2401),
    [anon_sym_select] = ACTIONS(2401),
    [anon_sym_STAR_EQ] = ACTIONS(2401),
    [anon_sym_SLASH_EQ] = ACTIONS(2401),
    [anon_sym_PERCENT_EQ] = ACTIONS(2401),
    [anon_sym_LT_LT_EQ] = ACTIONS(2401),
    [anon_sym_GT_GT_EQ] = ACTIONS(2401),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2401),
    [anon_sym_AMP_EQ] = ACTIONS(2401),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2401),
    [anon_sym_PLUS_EQ] = ACTIONS(2401),
    [anon_sym_DASH_EQ] = ACTIONS(2401),
    [anon_sym_PIPE_EQ] = ACTIONS(2401),
    [anon_sym_CARET_EQ] = ACTIONS(2401),
    [anon_sym_COLON_EQ] = ACTIONS(2401),
    [anon_sym_lock] = ACTIONS(2401),
    [anon_sym_rlock] = ACTIONS(2401),
    [anon_sym_unsafe] = ACTIONS(2401),
    [anon_sym_sql] = ACTIONS(2401),
    [sym_int_literal] = ACTIONS(2401),
    [sym_float_literal] = ACTIONS(2401),
    [sym_rune_literal] = ACTIONS(2401),
    [anon_sym_SQUOTE] = ACTIONS(2401),
    [anon_sym_DQUOTE] = ACTIONS(2401),
    [anon_sym_c_SQUOTE] = ACTIONS(2401),
    [anon_sym_c_DQUOTE] = ACTIONS(2401),
    [anon_sym_r_SQUOTE] = ACTIONS(2401),
    [anon_sym_r_DQUOTE] = ACTIONS(2401),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2401),
    [anon_sym_shared] = ACTIONS(2401),
    [anon_sym_map_LBRACK] = ACTIONS(2401),
    [anon_sym_chan] = ACTIONS(2401),
    [anon_sym_thread] = ACTIONS(2401),
    [anon_sym_atomic] = ACTIONS(2401),
    [anon_sym_assert] = ACTIONS(2401),
    [anon_sym_defer] = ACTIONS(2401),
    [anon_sym_goto] = ACTIONS(2401),
    [anon_sym_break] = ACTIONS(2401),
    [anon_sym_continue] = ACTIONS(2401),
    [anon_sym_return] = ACTIONS(2401),
    [anon_sym_DOLLARfor] = ACTIONS(2401),
    [anon_sym_for] = ACTIONS(2401),
    [anon_sym_POUND] = ACTIONS(2401),
    [anon_sym_asm] = ACTIONS(2401),
  },
  [1009] = {
    [sym_line_comment] = STATE(1009),
    [sym_block_comment] = STATE(1009),
    [sym_identifier] = ACTIONS(2957),
    [anon_sym_LF] = ACTIONS(2957),
    [anon_sym_CR] = ACTIONS(2957),
    [anon_sym_CR_LF] = ACTIONS(2957),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2957),
    [anon_sym_DOT] = ACTIONS(2957),
    [anon_sym_as] = ACTIONS(2957),
    [anon_sym_LBRACE] = ACTIONS(2957),
    [anon_sym_COMMA] = ACTIONS(2957),
    [anon_sym_RBRACE] = ACTIONS(2957),
    [anon_sym_LPAREN] = ACTIONS(2957),
    [anon_sym_EQ] = ACTIONS(2957),
    [anon_sym_fn] = ACTIONS(2957),
    [anon_sym_PLUS] = ACTIONS(2957),
    [anon_sym_DASH] = ACTIONS(2957),
    [anon_sym_STAR] = ACTIONS(2957),
    [anon_sym_SLASH] = ACTIONS(2957),
    [anon_sym_PERCENT] = ACTIONS(2957),
    [anon_sym_LT] = ACTIONS(2957),
    [anon_sym_GT] = ACTIONS(2957),
    [anon_sym_EQ_EQ] = ACTIONS(2957),
    [anon_sym_BANG_EQ] = ACTIONS(2957),
    [anon_sym_LT_EQ] = ACTIONS(2957),
    [anon_sym_GT_EQ] = ACTIONS(2957),
    [anon_sym_LBRACK] = ACTIONS(2955),
    [anon_sym_struct] = ACTIONS(2957),
    [anon_sym_mut] = ACTIONS(2957),
    [anon_sym_COLON] = ACTIONS(2957),
    [anon_sym_PLUS_PLUS] = ACTIONS(2957),
    [anon_sym_DASH_DASH] = ACTIONS(2957),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_BANG] = ACTIONS(2957),
    [anon_sym_go] = ACTIONS(2957),
    [anon_sym_spawn] = ACTIONS(2957),
    [anon_sym_json_DOTdecode] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2957),
    [anon_sym_LBRACK2] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2957),
    [anon_sym_CARET] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2957),
    [anon_sym_LT_DASH] = ACTIONS(2957),
    [anon_sym_LT_LT] = ACTIONS(2957),
    [anon_sym_GT_GT] = ACTIONS(2957),
    [anon_sym_GT_GT_GT] = ACTIONS(2957),
    [anon_sym_AMP_CARET] = ACTIONS(2957),
    [anon_sym_AMP_AMP] = ACTIONS(2957),
    [anon_sym_PIPE_PIPE] = ACTIONS(2957),
    [anon_sym_or] = ACTIONS(2957),
    [sym_none] = ACTIONS(2957),
    [sym_true] = ACTIONS(2957),
    [sym_false] = ACTIONS(2957),
    [sym_nil] = ACTIONS(2957),
    [anon_sym_QMARK_DOT] = ACTIONS(2957),
    [anon_sym_POUND_LBRACK] = ACTIONS(2957),
    [anon_sym_if] = ACTIONS(2957),
    [anon_sym_DOLLARif] = ACTIONS(2957),
    [anon_sym_is] = ACTIONS(2957),
    [anon_sym_BANGis] = ACTIONS(2957),
    [anon_sym_in] = ACTIONS(2957),
    [anon_sym_BANGin] = ACTIONS(2957),
    [anon_sym_match] = ACTIONS(2957),
    [anon_sym_select] = ACTIONS(2957),
    [anon_sym_STAR_EQ] = ACTIONS(2957),
    [anon_sym_SLASH_EQ] = ACTIONS(2957),
    [anon_sym_PERCENT_EQ] = ACTIONS(2957),
    [anon_sym_LT_LT_EQ] = ACTIONS(2957),
    [anon_sym_GT_GT_EQ] = ACTIONS(2957),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2957),
    [anon_sym_AMP_EQ] = ACTIONS(2957),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2957),
    [anon_sym_PLUS_EQ] = ACTIONS(2957),
    [anon_sym_DASH_EQ] = ACTIONS(2957),
    [anon_sym_PIPE_EQ] = ACTIONS(2957),
    [anon_sym_CARET_EQ] = ACTIONS(2957),
    [anon_sym_COLON_EQ] = ACTIONS(2957),
    [anon_sym_lock] = ACTIONS(2957),
    [anon_sym_rlock] = ACTIONS(2957),
    [anon_sym_unsafe] = ACTIONS(2957),
    [anon_sym_sql] = ACTIONS(2957),
    [sym_int_literal] = ACTIONS(2957),
    [sym_float_literal] = ACTIONS(2957),
    [sym_rune_literal] = ACTIONS(2957),
    [anon_sym_SQUOTE] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(2957),
    [anon_sym_c_SQUOTE] = ACTIONS(2957),
    [anon_sym_c_DQUOTE] = ACTIONS(2957),
    [anon_sym_r_SQUOTE] = ACTIONS(2957),
    [anon_sym_r_DQUOTE] = ACTIONS(2957),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2957),
    [anon_sym_shared] = ACTIONS(2957),
    [anon_sym_map_LBRACK] = ACTIONS(2957),
    [anon_sym_chan] = ACTIONS(2957),
    [anon_sym_thread] = ACTIONS(2957),
    [anon_sym_atomic] = ACTIONS(2957),
    [anon_sym_assert] = ACTIONS(2957),
    [anon_sym_defer] = ACTIONS(2957),
    [anon_sym_goto] = ACTIONS(2957),
    [anon_sym_break] = ACTIONS(2957),
    [anon_sym_continue] = ACTIONS(2957),
    [anon_sym_return] = ACTIONS(2957),
    [anon_sym_DOLLARfor] = ACTIONS(2957),
    [anon_sym_for] = ACTIONS(2957),
    [anon_sym_POUND] = ACTIONS(2957),
    [anon_sym_asm] = ACTIONS(2957),
  },
  [1010] = {
    [sym_line_comment] = STATE(1010),
    [sym_block_comment] = STATE(1010),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LF] = ACTIONS(2453),
    [anon_sym_CR] = ACTIONS(2453),
    [anon_sym_CR_LF] = ACTIONS(2453),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2453),
    [anon_sym_DOT] = ACTIONS(2453),
    [anon_sym_as] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [anon_sym_COMMA] = ACTIONS(2453),
    [anon_sym_RBRACE] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_EQ] = ACTIONS(2453),
    [anon_sym_fn] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2453),
    [anon_sym_SLASH] = ACTIONS(2453),
    [anon_sym_PERCENT] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2453),
    [anon_sym_EQ_EQ] = ACTIONS(2453),
    [anon_sym_BANG_EQ] = ACTIONS(2453),
    [anon_sym_LT_EQ] = ACTIONS(2453),
    [anon_sym_GT_EQ] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2451),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_mut] = ACTIONS(2453),
    [anon_sym_COLON] = ACTIONS(2453),
    [anon_sym_PLUS_PLUS] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2453),
    [anon_sym_QMARK] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(2453),
    [anon_sym_go] = ACTIONS(2453),
    [anon_sym_spawn] = ACTIONS(2453),
    [anon_sym_json_DOTdecode] = ACTIONS(2453),
    [anon_sym_PIPE] = ACTIONS(2453),
    [anon_sym_LBRACK2] = ACTIONS(2453),
    [anon_sym_TILDE] = ACTIONS(2453),
    [anon_sym_CARET] = ACTIONS(2453),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_LT_DASH] = ACTIONS(2453),
    [anon_sym_LT_LT] = ACTIONS(2453),
    [anon_sym_GT_GT] = ACTIONS(2453),
    [anon_sym_GT_GT_GT] = ACTIONS(2453),
    [anon_sym_AMP_CARET] = ACTIONS(2453),
    [anon_sym_AMP_AMP] = ACTIONS(2453),
    [anon_sym_PIPE_PIPE] = ACTIONS(2453),
    [anon_sym_or] = ACTIONS(2453),
    [sym_none] = ACTIONS(2453),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [sym_nil] = ACTIONS(2453),
    [anon_sym_QMARK_DOT] = ACTIONS(2453),
    [anon_sym_POUND_LBRACK] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_DOLLARif] = ACTIONS(2453),
    [anon_sym_is] = ACTIONS(2453),
    [anon_sym_BANGis] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_BANGin] = ACTIONS(2453),
    [anon_sym_match] = ACTIONS(2453),
    [anon_sym_select] = ACTIONS(2453),
    [anon_sym_STAR_EQ] = ACTIONS(2453),
    [anon_sym_SLASH_EQ] = ACTIONS(2453),
    [anon_sym_PERCENT_EQ] = ACTIONS(2453),
    [anon_sym_LT_LT_EQ] = ACTIONS(2453),
    [anon_sym_GT_GT_EQ] = ACTIONS(2453),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2453),
    [anon_sym_AMP_EQ] = ACTIONS(2453),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2453),
    [anon_sym_PLUS_EQ] = ACTIONS(2453),
    [anon_sym_DASH_EQ] = ACTIONS(2453),
    [anon_sym_PIPE_EQ] = ACTIONS(2453),
    [anon_sym_CARET_EQ] = ACTIONS(2453),
    [anon_sym_COLON_EQ] = ACTIONS(2453),
    [anon_sym_lock] = ACTIONS(2453),
    [anon_sym_rlock] = ACTIONS(2453),
    [anon_sym_unsafe] = ACTIONS(2453),
    [anon_sym_sql] = ACTIONS(2453),
    [sym_int_literal] = ACTIONS(2453),
    [sym_float_literal] = ACTIONS(2453),
    [sym_rune_literal] = ACTIONS(2453),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2453),
    [anon_sym_c_SQUOTE] = ACTIONS(2453),
    [anon_sym_c_DQUOTE] = ACTIONS(2453),
    [anon_sym_r_SQUOTE] = ACTIONS(2453),
    [anon_sym_r_DQUOTE] = ACTIONS(2453),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_map_LBRACK] = ACTIONS(2453),
    [anon_sym_chan] = ACTIONS(2453),
    [anon_sym_thread] = ACTIONS(2453),
    [anon_sym_atomic] = ACTIONS(2453),
    [anon_sym_assert] = ACTIONS(2453),
    [anon_sym_defer] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_DOLLARfor] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_POUND] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
  },
  [1011] = {
    [sym_line_comment] = STATE(1011),
    [sym_block_comment] = STATE(1011),
    [sym_identifier] = ACTIONS(2335),
    [anon_sym_LF] = ACTIONS(2335),
    [anon_sym_CR] = ACTIONS(2335),
    [anon_sym_CR_LF] = ACTIONS(2335),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2335),
    [anon_sym_DOT] = ACTIONS(2335),
    [anon_sym_as] = ACTIONS(2335),
    [anon_sym_LBRACE] = ACTIONS(2335),
    [anon_sym_COMMA] = ACTIONS(2335),
    [anon_sym_RBRACE] = ACTIONS(2335),
    [anon_sym_LPAREN] = ACTIONS(2335),
    [anon_sym_EQ] = ACTIONS(2335),
    [anon_sym_fn] = ACTIONS(2335),
    [anon_sym_PLUS] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2335),
    [anon_sym_STAR] = ACTIONS(2335),
    [anon_sym_SLASH] = ACTIONS(2335),
    [anon_sym_PERCENT] = ACTIONS(2335),
    [anon_sym_LT] = ACTIONS(2335),
    [anon_sym_GT] = ACTIONS(2335),
    [anon_sym_EQ_EQ] = ACTIONS(2335),
    [anon_sym_BANG_EQ] = ACTIONS(2335),
    [anon_sym_LT_EQ] = ACTIONS(2335),
    [anon_sym_GT_EQ] = ACTIONS(2335),
    [anon_sym_LBRACK] = ACTIONS(2337),
    [anon_sym_struct] = ACTIONS(2335),
    [anon_sym_mut] = ACTIONS(2335),
    [anon_sym_COLON] = ACTIONS(2335),
    [anon_sym_PLUS_PLUS] = ACTIONS(2335),
    [anon_sym_DASH_DASH] = ACTIONS(2335),
    [anon_sym_QMARK] = ACTIONS(2335),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_go] = ACTIONS(2335),
    [anon_sym_spawn] = ACTIONS(2335),
    [anon_sym_json_DOTdecode] = ACTIONS(2335),
    [anon_sym_PIPE] = ACTIONS(2335),
    [anon_sym_LBRACK2] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [anon_sym_CARET] = ACTIONS(2335),
    [anon_sym_AMP] = ACTIONS(2335),
    [anon_sym_LT_DASH] = ACTIONS(2335),
    [anon_sym_LT_LT] = ACTIONS(2335),
    [anon_sym_GT_GT] = ACTIONS(2335),
    [anon_sym_GT_GT_GT] = ACTIONS(2335),
    [anon_sym_AMP_CARET] = ACTIONS(2335),
    [anon_sym_AMP_AMP] = ACTIONS(2335),
    [anon_sym_PIPE_PIPE] = ACTIONS(2335),
    [anon_sym_or] = ACTIONS(2335),
    [sym_none] = ACTIONS(2335),
    [sym_true] = ACTIONS(2335),
    [sym_false] = ACTIONS(2335),
    [sym_nil] = ACTIONS(2335),
    [anon_sym_QMARK_DOT] = ACTIONS(2335),
    [anon_sym_POUND_LBRACK] = ACTIONS(2335),
    [anon_sym_if] = ACTIONS(2335),
    [anon_sym_DOLLARif] = ACTIONS(2335),
    [anon_sym_is] = ACTIONS(2335),
    [anon_sym_BANGis] = ACTIONS(2335),
    [anon_sym_in] = ACTIONS(2335),
    [anon_sym_BANGin] = ACTIONS(2335),
    [anon_sym_match] = ACTIONS(2335),
    [anon_sym_select] = ACTIONS(2335),
    [anon_sym_STAR_EQ] = ACTIONS(2335),
    [anon_sym_SLASH_EQ] = ACTIONS(2335),
    [anon_sym_PERCENT_EQ] = ACTIONS(2335),
    [anon_sym_LT_LT_EQ] = ACTIONS(2335),
    [anon_sym_GT_GT_EQ] = ACTIONS(2335),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2335),
    [anon_sym_AMP_EQ] = ACTIONS(2335),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2335),
    [anon_sym_PLUS_EQ] = ACTIONS(2335),
    [anon_sym_DASH_EQ] = ACTIONS(2335),
    [anon_sym_PIPE_EQ] = ACTIONS(2335),
    [anon_sym_CARET_EQ] = ACTIONS(2335),
    [anon_sym_COLON_EQ] = ACTIONS(2335),
    [anon_sym_lock] = ACTIONS(2335),
    [anon_sym_rlock] = ACTIONS(2335),
    [anon_sym_unsafe] = ACTIONS(2335),
    [anon_sym_sql] = ACTIONS(2335),
    [sym_int_literal] = ACTIONS(2335),
    [sym_float_literal] = ACTIONS(2335),
    [sym_rune_literal] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2335),
    [anon_sym_DQUOTE] = ACTIONS(2335),
    [anon_sym_c_SQUOTE] = ACTIONS(2335),
    [anon_sym_c_DQUOTE] = ACTIONS(2335),
    [anon_sym_r_SQUOTE] = ACTIONS(2335),
    [anon_sym_r_DQUOTE] = ACTIONS(2335),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2335),
    [anon_sym_shared] = ACTIONS(2335),
    [anon_sym_map_LBRACK] = ACTIONS(2335),
    [anon_sym_chan] = ACTIONS(2335),
    [anon_sym_thread] = ACTIONS(2335),
    [anon_sym_atomic] = ACTIONS(2335),
    [anon_sym_assert] = ACTIONS(2335),
    [anon_sym_defer] = ACTIONS(2335),
    [anon_sym_goto] = ACTIONS(2335),
    [anon_sym_break] = ACTIONS(2335),
    [anon_sym_continue] = ACTIONS(2335),
    [anon_sym_return] = ACTIONS(2335),
    [anon_sym_DOLLARfor] = ACTIONS(2335),
    [anon_sym_for] = ACTIONS(2335),
    [anon_sym_POUND] = ACTIONS(2335),
    [anon_sym_asm] = ACTIONS(2335),
  },
  [1012] = {
    [sym_line_comment] = STATE(1012),
    [sym_block_comment] = STATE(1012),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_LF] = ACTIONS(2833),
    [anon_sym_CR] = ACTIONS(2833),
    [anon_sym_CR_LF] = ACTIONS(2833),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2833),
    [anon_sym_DOT] = ACTIONS(2833),
    [anon_sym_as] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_RBRACE] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2833),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_fn] = ACTIONS(2833),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(2833),
    [anon_sym_SLASH] = ACTIONS(2833),
    [anon_sym_PERCENT] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(2833),
    [anon_sym_EQ_EQ] = ACTIONS(2833),
    [anon_sym_BANG_EQ] = ACTIONS(2833),
    [anon_sym_LT_EQ] = ACTIONS(2833),
    [anon_sym_GT_EQ] = ACTIONS(2833),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_struct] = ACTIONS(2833),
    [anon_sym_mut] = ACTIONS(2833),
    [anon_sym_COLON] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_QMARK] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_go] = ACTIONS(2833),
    [anon_sym_spawn] = ACTIONS(2833),
    [anon_sym_json_DOTdecode] = ACTIONS(2833),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_LBRACK2] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2833),
    [anon_sym_CARET] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2833),
    [anon_sym_LT_DASH] = ACTIONS(2833),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_GT] = ACTIONS(2833),
    [anon_sym_AMP_CARET] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2833),
    [anon_sym_or] = ACTIONS(2833),
    [sym_none] = ACTIONS(2833),
    [sym_true] = ACTIONS(2833),
    [sym_false] = ACTIONS(2833),
    [sym_nil] = ACTIONS(2833),
    [anon_sym_QMARK_DOT] = ACTIONS(2833),
    [anon_sym_POUND_LBRACK] = ACTIONS(2833),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_DOLLARif] = ACTIONS(2833),
    [anon_sym_is] = ACTIONS(2833),
    [anon_sym_BANGis] = ACTIONS(2833),
    [anon_sym_in] = ACTIONS(2833),
    [anon_sym_BANGin] = ACTIONS(2833),
    [anon_sym_match] = ACTIONS(2833),
    [anon_sym_select] = ACTIONS(2833),
    [anon_sym_STAR_EQ] = ACTIONS(2833),
    [anon_sym_SLASH_EQ] = ACTIONS(2833),
    [anon_sym_PERCENT_EQ] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(2833),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2833),
    [anon_sym_AMP_EQ] = ACTIONS(2833),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2833),
    [anon_sym_PLUS_EQ] = ACTIONS(2833),
    [anon_sym_DASH_EQ] = ACTIONS(2833),
    [anon_sym_PIPE_EQ] = ACTIONS(2833),
    [anon_sym_CARET_EQ] = ACTIONS(2833),
    [anon_sym_COLON_EQ] = ACTIONS(2833),
    [anon_sym_lock] = ACTIONS(2833),
    [anon_sym_rlock] = ACTIONS(2833),
    [anon_sym_unsafe] = ACTIONS(2833),
    [anon_sym_sql] = ACTIONS(2833),
    [sym_int_literal] = ACTIONS(2833),
    [sym_float_literal] = ACTIONS(2833),
    [sym_rune_literal] = ACTIONS(2833),
    [anon_sym_SQUOTE] = ACTIONS(2833),
    [anon_sym_DQUOTE] = ACTIONS(2833),
    [anon_sym_c_SQUOTE] = ACTIONS(2833),
    [anon_sym_c_DQUOTE] = ACTIONS(2833),
    [anon_sym_r_SQUOTE] = ACTIONS(2833),
    [anon_sym_r_DQUOTE] = ACTIONS(2833),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2833),
    [anon_sym_shared] = ACTIONS(2833),
    [anon_sym_map_LBRACK] = ACTIONS(2833),
    [anon_sym_chan] = ACTIONS(2833),
    [anon_sym_thread] = ACTIONS(2833),
    [anon_sym_atomic] = ACTIONS(2833),
    [anon_sym_assert] = ACTIONS(2833),
    [anon_sym_defer] = ACTIONS(2833),
    [anon_sym_goto] = ACTIONS(2833),
    [anon_sym_break] = ACTIONS(2833),
    [anon_sym_continue] = ACTIONS(2833),
    [anon_sym_return] = ACTIONS(2833),
    [anon_sym_DOLLARfor] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2833),
    [anon_sym_POUND] = ACTIONS(2833),
    [anon_sym_asm] = ACTIONS(2833),
  },
  [1013] = {
    [sym_line_comment] = STATE(1013),
    [sym_block_comment] = STATE(1013),
    [sym_identifier] = ACTIONS(2829),
    [anon_sym_LF] = ACTIONS(2829),
    [anon_sym_CR] = ACTIONS(2829),
    [anon_sym_CR_LF] = ACTIONS(2829),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_DOT] = ACTIONS(2829),
    [anon_sym_as] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_EQ] = ACTIONS(2829),
    [anon_sym_fn] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(2829),
    [anon_sym_SLASH] = ACTIONS(2829),
    [anon_sym_PERCENT] = ACTIONS(2829),
    [anon_sym_LT] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2829),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LBRACK] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_mut] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(2829),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_QMARK] = ACTIONS(2829),
    [anon_sym_BANG] = ACTIONS(2829),
    [anon_sym_go] = ACTIONS(2829),
    [anon_sym_spawn] = ACTIONS(2829),
    [anon_sym_json_DOTdecode] = ACTIONS(2829),
    [anon_sym_PIPE] = ACTIONS(2829),
    [anon_sym_LBRACK2] = ACTIONS(2829),
    [anon_sym_TILDE] = ACTIONS(2829),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_AMP] = ACTIONS(2829),
    [anon_sym_LT_DASH] = ACTIONS(2829),
    [anon_sym_LT_LT] = ACTIONS(2829),
    [anon_sym_GT_GT] = ACTIONS(2829),
    [anon_sym_GT_GT_GT] = ACTIONS(2829),
    [anon_sym_AMP_CARET] = ACTIONS(2829),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_or] = ACTIONS(2829),
    [sym_none] = ACTIONS(2829),
    [sym_true] = ACTIONS(2829),
    [sym_false] = ACTIONS(2829),
    [sym_nil] = ACTIONS(2829),
    [anon_sym_QMARK_DOT] = ACTIONS(2829),
    [anon_sym_POUND_LBRACK] = ACTIONS(2829),
    [anon_sym_if] = ACTIONS(2829),
    [anon_sym_DOLLARif] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2829),
    [anon_sym_BANGis] = ACTIONS(2829),
    [anon_sym_in] = ACTIONS(2829),
    [anon_sym_BANGin] = ACTIONS(2829),
    [anon_sym_match] = ACTIONS(2829),
    [anon_sym_select] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_COLON_EQ] = ACTIONS(2829),
    [anon_sym_lock] = ACTIONS(2829),
    [anon_sym_rlock] = ACTIONS(2829),
    [anon_sym_unsafe] = ACTIONS(2829),
    [anon_sym_sql] = ACTIONS(2829),
    [sym_int_literal] = ACTIONS(2829),
    [sym_float_literal] = ACTIONS(2829),
    [sym_rune_literal] = ACTIONS(2829),
    [anon_sym_SQUOTE] = ACTIONS(2829),
    [anon_sym_DQUOTE] = ACTIONS(2829),
    [anon_sym_c_SQUOTE] = ACTIONS(2829),
    [anon_sym_c_DQUOTE] = ACTIONS(2829),
    [anon_sym_r_SQUOTE] = ACTIONS(2829),
    [anon_sym_r_DQUOTE] = ACTIONS(2829),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2829),
    [anon_sym_shared] = ACTIONS(2829),
    [anon_sym_map_LBRACK] = ACTIONS(2829),
    [anon_sym_chan] = ACTIONS(2829),
    [anon_sym_thread] = ACTIONS(2829),
    [anon_sym_atomic] = ACTIONS(2829),
    [anon_sym_assert] = ACTIONS(2829),
    [anon_sym_defer] = ACTIONS(2829),
    [anon_sym_goto] = ACTIONS(2829),
    [anon_sym_break] = ACTIONS(2829),
    [anon_sym_continue] = ACTIONS(2829),
    [anon_sym_return] = ACTIONS(2829),
    [anon_sym_DOLLARfor] = ACTIONS(2829),
    [anon_sym_for] = ACTIONS(2829),
    [anon_sym_POUND] = ACTIONS(2829),
    [anon_sym_asm] = ACTIONS(2829),
  },
  [1014] = {
    [sym_line_comment] = STATE(1014),
    [sym_block_comment] = STATE(1014),
    [sym_identifier] = ACTIONS(2823),
    [anon_sym_LF] = ACTIONS(2823),
    [anon_sym_CR] = ACTIONS(2823),
    [anon_sym_CR_LF] = ACTIONS(2823),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2823),
    [anon_sym_DOT] = ACTIONS(2823),
    [anon_sym_as] = ACTIONS(2823),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_COMMA] = ACTIONS(2823),
    [anon_sym_RBRACE] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_EQ] = ACTIONS(2823),
    [anon_sym_fn] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2823),
    [anon_sym_DASH] = ACTIONS(2823),
    [anon_sym_STAR] = ACTIONS(2823),
    [anon_sym_SLASH] = ACTIONS(2823),
    [anon_sym_PERCENT] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2823),
    [anon_sym_GT] = ACTIONS(2823),
    [anon_sym_EQ_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_EQ] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(2821),
    [anon_sym_struct] = ACTIONS(2823),
    [anon_sym_mut] = ACTIONS(2823),
    [anon_sym_COLON] = ACTIONS(2823),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_QMARK] = ACTIONS(2823),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_go] = ACTIONS(2823),
    [anon_sym_spawn] = ACTIONS(2823),
    [anon_sym_json_DOTdecode] = ACTIONS(2823),
    [anon_sym_PIPE] = ACTIONS(2823),
    [anon_sym_LBRACK2] = ACTIONS(2823),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_CARET] = ACTIONS(2823),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_LT_DASH] = ACTIONS(2823),
    [anon_sym_LT_LT] = ACTIONS(2823),
    [anon_sym_GT_GT] = ACTIONS(2823),
    [anon_sym_GT_GT_GT] = ACTIONS(2823),
    [anon_sym_AMP_CARET] = ACTIONS(2823),
    [anon_sym_AMP_AMP] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2823),
    [anon_sym_or] = ACTIONS(2823),
    [sym_none] = ACTIONS(2823),
    [sym_true] = ACTIONS(2823),
    [sym_false] = ACTIONS(2823),
    [sym_nil] = ACTIONS(2823),
    [anon_sym_QMARK_DOT] = ACTIONS(2823),
    [anon_sym_POUND_LBRACK] = ACTIONS(2823),
    [anon_sym_if] = ACTIONS(2823),
    [anon_sym_DOLLARif] = ACTIONS(2823),
    [anon_sym_is] = ACTIONS(2823),
    [anon_sym_BANGis] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(2823),
    [anon_sym_BANGin] = ACTIONS(2823),
    [anon_sym_match] = ACTIONS(2823),
    [anon_sym_select] = ACTIONS(2823),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_COLON_EQ] = ACTIONS(2823),
    [anon_sym_lock] = ACTIONS(2823),
    [anon_sym_rlock] = ACTIONS(2823),
    [anon_sym_unsafe] = ACTIONS(2823),
    [anon_sym_sql] = ACTIONS(2823),
    [sym_int_literal] = ACTIONS(2823),
    [sym_float_literal] = ACTIONS(2823),
    [sym_rune_literal] = ACTIONS(2823),
    [anon_sym_SQUOTE] = ACTIONS(2823),
    [anon_sym_DQUOTE] = ACTIONS(2823),
    [anon_sym_c_SQUOTE] = ACTIONS(2823),
    [anon_sym_c_DQUOTE] = ACTIONS(2823),
    [anon_sym_r_SQUOTE] = ACTIONS(2823),
    [anon_sym_r_DQUOTE] = ACTIONS(2823),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2823),
    [anon_sym_shared] = ACTIONS(2823),
    [anon_sym_map_LBRACK] = ACTIONS(2823),
    [anon_sym_chan] = ACTIONS(2823),
    [anon_sym_thread] = ACTIONS(2823),
    [anon_sym_atomic] = ACTIONS(2823),
    [anon_sym_assert] = ACTIONS(2823),
    [anon_sym_defer] = ACTIONS(2823),
    [anon_sym_goto] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2823),
    [anon_sym_continue] = ACTIONS(2823),
    [anon_sym_return] = ACTIONS(2823),
    [anon_sym_DOLLARfor] = ACTIONS(2823),
    [anon_sym_for] = ACTIONS(2823),
    [anon_sym_POUND] = ACTIONS(2823),
    [anon_sym_asm] = ACTIONS(2823),
  },
  [1015] = {
    [sym_line_comment] = STATE(1015),
    [sym_block_comment] = STATE(1015),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_LF] = ACTIONS(2819),
    [anon_sym_CR] = ACTIONS(2819),
    [anon_sym_CR_LF] = ACTIONS(2819),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2819),
    [anon_sym_DOT] = ACTIONS(2819),
    [anon_sym_as] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(2819),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_EQ] = ACTIONS(2819),
    [anon_sym_fn] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_LT] = ACTIONS(2819),
    [anon_sym_GT] = ACTIONS(2819),
    [anon_sym_EQ_EQ] = ACTIONS(2819),
    [anon_sym_BANG_EQ] = ACTIONS(2819),
    [anon_sym_LT_EQ] = ACTIONS(2819),
    [anon_sym_GT_EQ] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2817),
    [anon_sym_struct] = ACTIONS(2819),
    [anon_sym_mut] = ACTIONS(2819),
    [anon_sym_COLON] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2819),
    [anon_sym_DASH_DASH] = ACTIONS(2819),
    [anon_sym_QMARK] = ACTIONS(2819),
    [anon_sym_BANG] = ACTIONS(2819),
    [anon_sym_go] = ACTIONS(2819),
    [anon_sym_spawn] = ACTIONS(2819),
    [anon_sym_json_DOTdecode] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(2819),
    [anon_sym_LBRACK2] = ACTIONS(2819),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_CARET] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_LT_DASH] = ACTIONS(2819),
    [anon_sym_LT_LT] = ACTIONS(2819),
    [anon_sym_GT_GT] = ACTIONS(2819),
    [anon_sym_GT_GT_GT] = ACTIONS(2819),
    [anon_sym_AMP_CARET] = ACTIONS(2819),
    [anon_sym_AMP_AMP] = ACTIONS(2819),
    [anon_sym_PIPE_PIPE] = ACTIONS(2819),
    [anon_sym_or] = ACTIONS(2819),
    [sym_none] = ACTIONS(2819),
    [sym_true] = ACTIONS(2819),
    [sym_false] = ACTIONS(2819),
    [sym_nil] = ACTIONS(2819),
    [anon_sym_QMARK_DOT] = ACTIONS(2819),
    [anon_sym_POUND_LBRACK] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_DOLLARif] = ACTIONS(2819),
    [anon_sym_is] = ACTIONS(2819),
    [anon_sym_BANGis] = ACTIONS(2819),
    [anon_sym_in] = ACTIONS(2819),
    [anon_sym_BANGin] = ACTIONS(2819),
    [anon_sym_match] = ACTIONS(2819),
    [anon_sym_select] = ACTIONS(2819),
    [anon_sym_STAR_EQ] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(2819),
    [anon_sym_LT_LT_EQ] = ACTIONS(2819),
    [anon_sym_GT_GT_EQ] = ACTIONS(2819),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2819),
    [anon_sym_AMP_EQ] = ACTIONS(2819),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2819),
    [anon_sym_PLUS_EQ] = ACTIONS(2819),
    [anon_sym_DASH_EQ] = ACTIONS(2819),
    [anon_sym_PIPE_EQ] = ACTIONS(2819),
    [anon_sym_CARET_EQ] = ACTIONS(2819),
    [anon_sym_COLON_EQ] = ACTIONS(2819),
    [anon_sym_lock] = ACTIONS(2819),
    [anon_sym_rlock] = ACTIONS(2819),
    [anon_sym_unsafe] = ACTIONS(2819),
    [anon_sym_sql] = ACTIONS(2819),
    [sym_int_literal] = ACTIONS(2819),
    [sym_float_literal] = ACTIONS(2819),
    [sym_rune_literal] = ACTIONS(2819),
    [anon_sym_SQUOTE] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2819),
    [anon_sym_c_SQUOTE] = ACTIONS(2819),
    [anon_sym_c_DQUOTE] = ACTIONS(2819),
    [anon_sym_r_SQUOTE] = ACTIONS(2819),
    [anon_sym_r_DQUOTE] = ACTIONS(2819),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2819),
    [anon_sym_shared] = ACTIONS(2819),
    [anon_sym_map_LBRACK] = ACTIONS(2819),
    [anon_sym_chan] = ACTIONS(2819),
    [anon_sym_thread] = ACTIONS(2819),
    [anon_sym_atomic] = ACTIONS(2819),
    [anon_sym_assert] = ACTIONS(2819),
    [anon_sym_defer] = ACTIONS(2819),
    [anon_sym_goto] = ACTIONS(2819),
    [anon_sym_break] = ACTIONS(2819),
    [anon_sym_continue] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_DOLLARfor] = ACTIONS(2819),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_POUND] = ACTIONS(2819),
    [anon_sym_asm] = ACTIONS(2819),
  },
  [1016] = {
    [sym_line_comment] = STATE(1016),
    [sym_block_comment] = STATE(1016),
    [sym_identifier] = ACTIONS(2659),
    [anon_sym_LF] = ACTIONS(2659),
    [anon_sym_CR] = ACTIONS(2659),
    [anon_sym_CR_LF] = ACTIONS(2659),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2659),
    [anon_sym_DOT] = ACTIONS(2659),
    [anon_sym_as] = ACTIONS(2659),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_COMMA] = ACTIONS(2659),
    [anon_sym_RBRACE] = ACTIONS(2659),
    [anon_sym_LPAREN] = ACTIONS(2659),
    [anon_sym_EQ] = ACTIONS(2659),
    [anon_sym_fn] = ACTIONS(2659),
    [anon_sym_PLUS] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_SLASH] = ACTIONS(2659),
    [anon_sym_PERCENT] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(2659),
    [anon_sym_GT] = ACTIONS(2659),
    [anon_sym_EQ_EQ] = ACTIONS(2659),
    [anon_sym_BANG_EQ] = ACTIONS(2659),
    [anon_sym_LT_EQ] = ACTIONS(2659),
    [anon_sym_GT_EQ] = ACTIONS(2659),
    [anon_sym_LBRACK] = ACTIONS(2657),
    [anon_sym_struct] = ACTIONS(2659),
    [anon_sym_mut] = ACTIONS(2659),
    [anon_sym_COLON] = ACTIONS(2659),
    [anon_sym_PLUS_PLUS] = ACTIONS(2659),
    [anon_sym_DASH_DASH] = ACTIONS(2659),
    [anon_sym_QMARK] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_go] = ACTIONS(2659),
    [anon_sym_spawn] = ACTIONS(2659),
    [anon_sym_json_DOTdecode] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(2659),
    [anon_sym_LBRACK2] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_CARET] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2659),
    [anon_sym_LT_DASH] = ACTIONS(2659),
    [anon_sym_LT_LT] = ACTIONS(2659),
    [anon_sym_GT_GT] = ACTIONS(2659),
    [anon_sym_GT_GT_GT] = ACTIONS(2659),
    [anon_sym_AMP_CARET] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_PIPE_PIPE] = ACTIONS(2659),
    [anon_sym_or] = ACTIONS(2659),
    [sym_none] = ACTIONS(2659),
    [sym_true] = ACTIONS(2659),
    [sym_false] = ACTIONS(2659),
    [sym_nil] = ACTIONS(2659),
    [anon_sym_QMARK_DOT] = ACTIONS(2659),
    [anon_sym_POUND_LBRACK] = ACTIONS(2659),
    [anon_sym_if] = ACTIONS(2659),
    [anon_sym_DOLLARif] = ACTIONS(2659),
    [anon_sym_is] = ACTIONS(2659),
    [anon_sym_BANGis] = ACTIONS(2659),
    [anon_sym_in] = ACTIONS(2659),
    [anon_sym_BANGin] = ACTIONS(2659),
    [anon_sym_match] = ACTIONS(2659),
    [anon_sym_select] = ACTIONS(2659),
    [anon_sym_STAR_EQ] = ACTIONS(2659),
    [anon_sym_SLASH_EQ] = ACTIONS(2659),
    [anon_sym_PERCENT_EQ] = ACTIONS(2659),
    [anon_sym_LT_LT_EQ] = ACTIONS(2659),
    [anon_sym_GT_GT_EQ] = ACTIONS(2659),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2659),
    [anon_sym_AMP_EQ] = ACTIONS(2659),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2659),
    [anon_sym_PLUS_EQ] = ACTIONS(2659),
    [anon_sym_DASH_EQ] = ACTIONS(2659),
    [anon_sym_PIPE_EQ] = ACTIONS(2659),
    [anon_sym_CARET_EQ] = ACTIONS(2659),
    [anon_sym_COLON_EQ] = ACTIONS(2659),
    [anon_sym_lock] = ACTIONS(2659),
    [anon_sym_rlock] = ACTIONS(2659),
    [anon_sym_unsafe] = ACTIONS(2659),
    [anon_sym_sql] = ACTIONS(2659),
    [sym_int_literal] = ACTIONS(2659),
    [sym_float_literal] = ACTIONS(2659),
    [sym_rune_literal] = ACTIONS(2659),
    [anon_sym_SQUOTE] = ACTIONS(2659),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [anon_sym_c_SQUOTE] = ACTIONS(2659),
    [anon_sym_c_DQUOTE] = ACTIONS(2659),
    [anon_sym_r_SQUOTE] = ACTIONS(2659),
    [anon_sym_r_DQUOTE] = ACTIONS(2659),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2659),
    [anon_sym_shared] = ACTIONS(2659),
    [anon_sym_map_LBRACK] = ACTIONS(2659),
    [anon_sym_chan] = ACTIONS(2659),
    [anon_sym_thread] = ACTIONS(2659),
    [anon_sym_atomic] = ACTIONS(2659),
    [anon_sym_assert] = ACTIONS(2659),
    [anon_sym_defer] = ACTIONS(2659),
    [anon_sym_goto] = ACTIONS(2659),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_continue] = ACTIONS(2659),
    [anon_sym_return] = ACTIONS(2659),
    [anon_sym_DOLLARfor] = ACTIONS(2659),
    [anon_sym_for] = ACTIONS(2659),
    [anon_sym_POUND] = ACTIONS(2659),
    [anon_sym_asm] = ACTIONS(2659),
  },
  [1017] = {
    [sym_line_comment] = STATE(1017),
    [sym_block_comment] = STATE(1017),
    [sym_identifier] = ACTIONS(2655),
    [anon_sym_LF] = ACTIONS(2655),
    [anon_sym_CR] = ACTIONS(2655),
    [anon_sym_CR_LF] = ACTIONS(2655),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym_DOT] = ACTIONS(2655),
    [anon_sym_as] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2655),
    [anon_sym_COMMA] = ACTIONS(2655),
    [anon_sym_RBRACE] = ACTIONS(2655),
    [anon_sym_LPAREN] = ACTIONS(2655),
    [anon_sym_EQ] = ACTIONS(2655),
    [anon_sym_fn] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_DASH] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_SLASH] = ACTIONS(2655),
    [anon_sym_PERCENT] = ACTIONS(2655),
    [anon_sym_LT] = ACTIONS(2655),
    [anon_sym_GT] = ACTIONS(2655),
    [anon_sym_EQ_EQ] = ACTIONS(2655),
    [anon_sym_BANG_EQ] = ACTIONS(2655),
    [anon_sym_LT_EQ] = ACTIONS(2655),
    [anon_sym_GT_EQ] = ACTIONS(2655),
    [anon_sym_LBRACK] = ACTIONS(2653),
    [anon_sym_struct] = ACTIONS(2655),
    [anon_sym_mut] = ACTIONS(2655),
    [anon_sym_COLON] = ACTIONS(2655),
    [anon_sym_PLUS_PLUS] = ACTIONS(2655),
    [anon_sym_DASH_DASH] = ACTIONS(2655),
    [anon_sym_QMARK] = ACTIONS(2655),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_go] = ACTIONS(2655),
    [anon_sym_spawn] = ACTIONS(2655),
    [anon_sym_json_DOTdecode] = ACTIONS(2655),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_LBRACK2] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [anon_sym_CARET] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2655),
    [anon_sym_LT_DASH] = ACTIONS(2655),
    [anon_sym_LT_LT] = ACTIONS(2655),
    [anon_sym_GT_GT] = ACTIONS(2655),
    [anon_sym_GT_GT_GT] = ACTIONS(2655),
    [anon_sym_AMP_CARET] = ACTIONS(2655),
    [anon_sym_AMP_AMP] = ACTIONS(2655),
    [anon_sym_PIPE_PIPE] = ACTIONS(2655),
    [anon_sym_or] = ACTIONS(2655),
    [sym_none] = ACTIONS(2655),
    [sym_true] = ACTIONS(2655),
    [sym_false] = ACTIONS(2655),
    [sym_nil] = ACTIONS(2655),
    [anon_sym_QMARK_DOT] = ACTIONS(2655),
    [anon_sym_POUND_LBRACK] = ACTIONS(2655),
    [anon_sym_if] = ACTIONS(2655),
    [anon_sym_DOLLARif] = ACTIONS(2655),
    [anon_sym_is] = ACTIONS(2655),
    [anon_sym_BANGis] = ACTIONS(2655),
    [anon_sym_in] = ACTIONS(2655),
    [anon_sym_BANGin] = ACTIONS(2655),
    [anon_sym_match] = ACTIONS(2655),
    [anon_sym_select] = ACTIONS(2655),
    [anon_sym_STAR_EQ] = ACTIONS(2655),
    [anon_sym_SLASH_EQ] = ACTIONS(2655),
    [anon_sym_PERCENT_EQ] = ACTIONS(2655),
    [anon_sym_LT_LT_EQ] = ACTIONS(2655),
    [anon_sym_GT_GT_EQ] = ACTIONS(2655),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2655),
    [anon_sym_AMP_EQ] = ACTIONS(2655),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2655),
    [anon_sym_PLUS_EQ] = ACTIONS(2655),
    [anon_sym_DASH_EQ] = ACTIONS(2655),
    [anon_sym_PIPE_EQ] = ACTIONS(2655),
    [anon_sym_CARET_EQ] = ACTIONS(2655),
    [anon_sym_COLON_EQ] = ACTIONS(2655),
    [anon_sym_lock] = ACTIONS(2655),
    [anon_sym_rlock] = ACTIONS(2655),
    [anon_sym_unsafe] = ACTIONS(2655),
    [anon_sym_sql] = ACTIONS(2655),
    [sym_int_literal] = ACTIONS(2655),
    [sym_float_literal] = ACTIONS(2655),
    [sym_rune_literal] = ACTIONS(2655),
    [anon_sym_SQUOTE] = ACTIONS(2655),
    [anon_sym_DQUOTE] = ACTIONS(2655),
    [anon_sym_c_SQUOTE] = ACTIONS(2655),
    [anon_sym_c_DQUOTE] = ACTIONS(2655),
    [anon_sym_r_SQUOTE] = ACTIONS(2655),
    [anon_sym_r_DQUOTE] = ACTIONS(2655),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2655),
    [anon_sym_shared] = ACTIONS(2655),
    [anon_sym_map_LBRACK] = ACTIONS(2655),
    [anon_sym_chan] = ACTIONS(2655),
    [anon_sym_thread] = ACTIONS(2655),
    [anon_sym_atomic] = ACTIONS(2655),
    [anon_sym_assert] = ACTIONS(2655),
    [anon_sym_defer] = ACTIONS(2655),
    [anon_sym_goto] = ACTIONS(2655),
    [anon_sym_break] = ACTIONS(2655),
    [anon_sym_continue] = ACTIONS(2655),
    [anon_sym_return] = ACTIONS(2655),
    [anon_sym_DOLLARfor] = ACTIONS(2655),
    [anon_sym_for] = ACTIONS(2655),
    [anon_sym_POUND] = ACTIONS(2655),
    [anon_sym_asm] = ACTIONS(2655),
  },
  [1018] = {
    [sym_line_comment] = STATE(1018),
    [sym_block_comment] = STATE(1018),
    [sym_identifier] = ACTIONS(3035),
    [anon_sym_LF] = ACTIONS(3035),
    [anon_sym_CR] = ACTIONS(3035),
    [anon_sym_CR_LF] = ACTIONS(3035),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym_DOT] = ACTIONS(3035),
    [anon_sym_as] = ACTIONS(3035),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_COMMA] = ACTIONS(3035),
    [anon_sym_RBRACE] = ACTIONS(3035),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_fn] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3035),
    [anon_sym_SLASH] = ACTIONS(3035),
    [anon_sym_PERCENT] = ACTIONS(3035),
    [anon_sym_LT] = ACTIONS(3035),
    [anon_sym_GT] = ACTIONS(3035),
    [anon_sym_EQ_EQ] = ACTIONS(3035),
    [anon_sym_BANG_EQ] = ACTIONS(3035),
    [anon_sym_LT_EQ] = ACTIONS(3035),
    [anon_sym_GT_EQ] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3033),
    [anon_sym_struct] = ACTIONS(3035),
    [anon_sym_mut] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3035),
    [anon_sym_PLUS_PLUS] = ACTIONS(3035),
    [anon_sym_DASH_DASH] = ACTIONS(3035),
    [anon_sym_QMARK] = ACTIONS(3035),
    [anon_sym_BANG] = ACTIONS(3035),
    [anon_sym_go] = ACTIONS(3035),
    [anon_sym_spawn] = ACTIONS(3035),
    [anon_sym_json_DOTdecode] = ACTIONS(3035),
    [anon_sym_PIPE] = ACTIONS(3035),
    [anon_sym_LBRACK2] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3035),
    [anon_sym_CARET] = ACTIONS(3035),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_LT_DASH] = ACTIONS(3035),
    [anon_sym_LT_LT] = ACTIONS(3035),
    [anon_sym_GT_GT] = ACTIONS(3035),
    [anon_sym_GT_GT_GT] = ACTIONS(3035),
    [anon_sym_AMP_CARET] = ACTIONS(3035),
    [anon_sym_AMP_AMP] = ACTIONS(3035),
    [anon_sym_PIPE_PIPE] = ACTIONS(3035),
    [anon_sym_or] = ACTIONS(3035),
    [sym_none] = ACTIONS(3035),
    [sym_true] = ACTIONS(3035),
    [sym_false] = ACTIONS(3035),
    [sym_nil] = ACTIONS(3035),
    [anon_sym_QMARK_DOT] = ACTIONS(3035),
    [anon_sym_POUND_LBRACK] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_DOLLARif] = ACTIONS(3035),
    [anon_sym_is] = ACTIONS(3035),
    [anon_sym_BANGis] = ACTIONS(3035),
    [anon_sym_in] = ACTIONS(3035),
    [anon_sym_BANGin] = ACTIONS(3035),
    [anon_sym_match] = ACTIONS(3035),
    [anon_sym_select] = ACTIONS(3035),
    [anon_sym_STAR_EQ] = ACTIONS(3035),
    [anon_sym_SLASH_EQ] = ACTIONS(3035),
    [anon_sym_PERCENT_EQ] = ACTIONS(3035),
    [anon_sym_LT_LT_EQ] = ACTIONS(3035),
    [anon_sym_GT_GT_EQ] = ACTIONS(3035),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3035),
    [anon_sym_AMP_EQ] = ACTIONS(3035),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3035),
    [anon_sym_PLUS_EQ] = ACTIONS(3035),
    [anon_sym_DASH_EQ] = ACTIONS(3035),
    [anon_sym_PIPE_EQ] = ACTIONS(3035),
    [anon_sym_CARET_EQ] = ACTIONS(3035),
    [anon_sym_COLON_EQ] = ACTIONS(3035),
    [anon_sym_lock] = ACTIONS(3035),
    [anon_sym_rlock] = ACTIONS(3035),
    [anon_sym_unsafe] = ACTIONS(3035),
    [anon_sym_sql] = ACTIONS(3035),
    [sym_int_literal] = ACTIONS(3035),
    [sym_float_literal] = ACTIONS(3035),
    [sym_rune_literal] = ACTIONS(3035),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_c_SQUOTE] = ACTIONS(3035),
    [anon_sym_c_DQUOTE] = ACTIONS(3035),
    [anon_sym_r_SQUOTE] = ACTIONS(3035),
    [anon_sym_r_DQUOTE] = ACTIONS(3035),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3035),
    [anon_sym_shared] = ACTIONS(3035),
    [anon_sym_map_LBRACK] = ACTIONS(3035),
    [anon_sym_chan] = ACTIONS(3035),
    [anon_sym_thread] = ACTIONS(3035),
    [anon_sym_atomic] = ACTIONS(3035),
    [anon_sym_assert] = ACTIONS(3035),
    [anon_sym_defer] = ACTIONS(3035),
    [anon_sym_goto] = ACTIONS(3035),
    [anon_sym_break] = ACTIONS(3035),
    [anon_sym_continue] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_DOLLARfor] = ACTIONS(3035),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_POUND] = ACTIONS(3035),
    [anon_sym_asm] = ACTIONS(3035),
  },
  [1019] = {
    [sym_line_comment] = STATE(1019),
    [sym_block_comment] = STATE(1019),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LF] = ACTIONS(2175),
    [anon_sym_CR] = ACTIONS(2175),
    [anon_sym_CR_LF] = ACTIONS(2175),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_DOT] = ACTIONS(2175),
    [anon_sym_as] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2175),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_EQ] = ACTIONS(2175),
    [anon_sym_fn] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2175),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_PERCENT] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_GT] = ACTIONS(2175),
    [anon_sym_EQ_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ] = ACTIONS(2175),
    [anon_sym_LT_EQ] = ACTIONS(2175),
    [anon_sym_GT_EQ] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2173),
    [anon_sym_struct] = ACTIONS(2175),
    [anon_sym_mut] = ACTIONS(2175),
    [anon_sym_COLON] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [anon_sym_QMARK] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_go] = ACTIONS(2175),
    [anon_sym_spawn] = ACTIONS(2175),
    [anon_sym_json_DOTdecode] = ACTIONS(2175),
    [anon_sym_PIPE] = ACTIONS(2175),
    [anon_sym_LBRACK2] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_CARET] = ACTIONS(2175),
    [anon_sym_AMP] = ACTIONS(2175),
    [anon_sym_LT_DASH] = ACTIONS(2175),
    [anon_sym_LT_LT] = ACTIONS(2175),
    [anon_sym_GT_GT] = ACTIONS(2175),
    [anon_sym_GT_GT_GT] = ACTIONS(2175),
    [anon_sym_AMP_CARET] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(2175),
    [anon_sym_PIPE_PIPE] = ACTIONS(2175),
    [anon_sym_or] = ACTIONS(2175),
    [sym_none] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_nil] = ACTIONS(2175),
    [anon_sym_QMARK_DOT] = ACTIONS(2175),
    [anon_sym_POUND_LBRACK] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_DOLLARif] = ACTIONS(2175),
    [anon_sym_is] = ACTIONS(2175),
    [anon_sym_BANGis] = ACTIONS(2175),
    [anon_sym_in] = ACTIONS(2175),
    [anon_sym_BANGin] = ACTIONS(2175),
    [anon_sym_match] = ACTIONS(2175),
    [anon_sym_select] = ACTIONS(2175),
    [anon_sym_STAR_EQ] = ACTIONS(2175),
    [anon_sym_SLASH_EQ] = ACTIONS(2175),
    [anon_sym_PERCENT_EQ] = ACTIONS(2175),
    [anon_sym_LT_LT_EQ] = ACTIONS(2175),
    [anon_sym_GT_GT_EQ] = ACTIONS(2175),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2175),
    [anon_sym_AMP_EQ] = ACTIONS(2175),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2175),
    [anon_sym_PLUS_EQ] = ACTIONS(2175),
    [anon_sym_DASH_EQ] = ACTIONS(2175),
    [anon_sym_PIPE_EQ] = ACTIONS(2175),
    [anon_sym_CARET_EQ] = ACTIONS(2175),
    [anon_sym_COLON_EQ] = ACTIONS(2175),
    [anon_sym_lock] = ACTIONS(2175),
    [anon_sym_rlock] = ACTIONS(2175),
    [anon_sym_unsafe] = ACTIONS(2175),
    [anon_sym_sql] = ACTIONS(2175),
    [sym_int_literal] = ACTIONS(2175),
    [sym_float_literal] = ACTIONS(2175),
    [sym_rune_literal] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_c_SQUOTE] = ACTIONS(2175),
    [anon_sym_c_DQUOTE] = ACTIONS(2175),
    [anon_sym_r_SQUOTE] = ACTIONS(2175),
    [anon_sym_r_DQUOTE] = ACTIONS(2175),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2175),
    [anon_sym_shared] = ACTIONS(2175),
    [anon_sym_map_LBRACK] = ACTIONS(2175),
    [anon_sym_chan] = ACTIONS(2175),
    [anon_sym_thread] = ACTIONS(2175),
    [anon_sym_atomic] = ACTIONS(2175),
    [anon_sym_assert] = ACTIONS(2175),
    [anon_sym_defer] = ACTIONS(2175),
    [anon_sym_goto] = ACTIONS(2175),
    [anon_sym_break] = ACTIONS(2175),
    [anon_sym_continue] = ACTIONS(2175),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_DOLLARfor] = ACTIONS(2175),
    [anon_sym_for] = ACTIONS(2175),
    [anon_sym_POUND] = ACTIONS(2175),
    [anon_sym_asm] = ACTIONS(2175),
  },
  [1020] = {
    [sym_line_comment] = STATE(1020),
    [sym_block_comment] = STATE(1020),
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_LF] = ACTIONS(3045),
    [anon_sym_CR] = ACTIONS(3045),
    [anon_sym_CR_LF] = ACTIONS(3045),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3045),
    [anon_sym_DOT] = ACTIONS(3045),
    [anon_sym_as] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3045),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_RBRACE] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3045),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym_fn] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3045),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_PERCENT] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_GT] = ACTIONS(3045),
    [anon_sym_EQ_EQ] = ACTIONS(3045),
    [anon_sym_BANG_EQ] = ACTIONS(3045),
    [anon_sym_LT_EQ] = ACTIONS(3045),
    [anon_sym_GT_EQ] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_struct] = ACTIONS(3045),
    [anon_sym_mut] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3045),
    [anon_sym_go] = ACTIONS(3045),
    [anon_sym_spawn] = ACTIONS(3045),
    [anon_sym_json_DOTdecode] = ACTIONS(3045),
    [anon_sym_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACK2] = ACTIONS(3045),
    [anon_sym_TILDE] = ACTIONS(3045),
    [anon_sym_CARET] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3045),
    [anon_sym_LT_DASH] = ACTIONS(3045),
    [anon_sym_LT_LT] = ACTIONS(3045),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_GT_GT_GT] = ACTIONS(3045),
    [anon_sym_AMP_CARET] = ACTIONS(3045),
    [anon_sym_AMP_AMP] = ACTIONS(3045),
    [anon_sym_PIPE_PIPE] = ACTIONS(3045),
    [anon_sym_or] = ACTIONS(3045),
    [sym_none] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_nil] = ACTIONS(3045),
    [anon_sym_QMARK_DOT] = ACTIONS(3045),
    [anon_sym_POUND_LBRACK] = ACTIONS(3045),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_DOLLARif] = ACTIONS(3045),
    [anon_sym_is] = ACTIONS(3045),
    [anon_sym_BANGis] = ACTIONS(3045),
    [anon_sym_in] = ACTIONS(3045),
    [anon_sym_BANGin] = ACTIONS(3045),
    [anon_sym_match] = ACTIONS(3045),
    [anon_sym_select] = ACTIONS(3045),
    [anon_sym_STAR_EQ] = ACTIONS(3045),
    [anon_sym_SLASH_EQ] = ACTIONS(3045),
    [anon_sym_PERCENT_EQ] = ACTIONS(3045),
    [anon_sym_LT_LT_EQ] = ACTIONS(3045),
    [anon_sym_GT_GT_EQ] = ACTIONS(3045),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3045),
    [anon_sym_AMP_EQ] = ACTIONS(3045),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3045),
    [anon_sym_PLUS_EQ] = ACTIONS(3045),
    [anon_sym_DASH_EQ] = ACTIONS(3045),
    [anon_sym_PIPE_EQ] = ACTIONS(3045),
    [anon_sym_CARET_EQ] = ACTIONS(3045),
    [anon_sym_COLON_EQ] = ACTIONS(3045),
    [anon_sym_lock] = ACTIONS(3045),
    [anon_sym_rlock] = ACTIONS(3045),
    [anon_sym_unsafe] = ACTIONS(3045),
    [anon_sym_sql] = ACTIONS(3045),
    [sym_int_literal] = ACTIONS(3045),
    [sym_float_literal] = ACTIONS(3045),
    [sym_rune_literal] = ACTIONS(3045),
    [anon_sym_SQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE] = ACTIONS(3045),
    [anon_sym_c_SQUOTE] = ACTIONS(3045),
    [anon_sym_c_DQUOTE] = ACTIONS(3045),
    [anon_sym_r_SQUOTE] = ACTIONS(3045),
    [anon_sym_r_DQUOTE] = ACTIONS(3045),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3045),
    [anon_sym_shared] = ACTIONS(3045),
    [anon_sym_map_LBRACK] = ACTIONS(3045),
    [anon_sym_chan] = ACTIONS(3045),
    [anon_sym_thread] = ACTIONS(3045),
    [anon_sym_atomic] = ACTIONS(3045),
    [anon_sym_assert] = ACTIONS(3045),
    [anon_sym_defer] = ACTIONS(3045),
    [anon_sym_goto] = ACTIONS(3045),
    [anon_sym_break] = ACTIONS(3045),
    [anon_sym_continue] = ACTIONS(3045),
    [anon_sym_return] = ACTIONS(3045),
    [anon_sym_DOLLARfor] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3045),
    [anon_sym_POUND] = ACTIONS(3045),
    [anon_sym_asm] = ACTIONS(3045),
  },
  [1021] = {
    [sym_line_comment] = STATE(1021),
    [sym_block_comment] = STATE(1021),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LF] = ACTIONS(2471),
    [anon_sym_CR] = ACTIONS(2471),
    [anon_sym_CR_LF] = ACTIONS(2471),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_DOT] = ACTIONS(2471),
    [anon_sym_as] = ACTIONS(2471),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_COMMA] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_EQ] = ACTIONS(2471),
    [anon_sym_fn] = ACTIONS(2471),
    [anon_sym_PLUS] = ACTIONS(2471),
    [anon_sym_DASH] = ACTIONS(2471),
    [anon_sym_STAR] = ACTIONS(2471),
    [anon_sym_SLASH] = ACTIONS(2471),
    [anon_sym_PERCENT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2471),
    [anon_sym_GT] = ACTIONS(2471),
    [anon_sym_EQ_EQ] = ACTIONS(2471),
    [anon_sym_BANG_EQ] = ACTIONS(2471),
    [anon_sym_LT_EQ] = ACTIONS(2471),
    [anon_sym_GT_EQ] = ACTIONS(2471),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_struct] = ACTIONS(2471),
    [anon_sym_mut] = ACTIONS(2471),
    [anon_sym_COLON] = ACTIONS(2471),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_go] = ACTIONS(2471),
    [anon_sym_spawn] = ACTIONS(2471),
    [anon_sym_json_DOTdecode] = ACTIONS(2471),
    [anon_sym_PIPE] = ACTIONS(2471),
    [anon_sym_LBRACK2] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_CARET] = ACTIONS(2471),
    [anon_sym_AMP] = ACTIONS(2471),
    [anon_sym_LT_DASH] = ACTIONS(2471),
    [anon_sym_LT_LT] = ACTIONS(2471),
    [anon_sym_GT_GT] = ACTIONS(2471),
    [anon_sym_GT_GT_GT] = ACTIONS(2471),
    [anon_sym_AMP_CARET] = ACTIONS(2471),
    [anon_sym_AMP_AMP] = ACTIONS(2471),
    [anon_sym_PIPE_PIPE] = ACTIONS(2471),
    [anon_sym_or] = ACTIONS(2471),
    [sym_none] = ACTIONS(2471),
    [sym_true] = ACTIONS(2471),
    [sym_false] = ACTIONS(2471),
    [sym_nil] = ACTIONS(2471),
    [anon_sym_QMARK_DOT] = ACTIONS(2471),
    [anon_sym_POUND_LBRACK] = ACTIONS(2471),
    [anon_sym_if] = ACTIONS(2471),
    [anon_sym_DOLLARif] = ACTIONS(2471),
    [anon_sym_is] = ACTIONS(2471),
    [anon_sym_BANGis] = ACTIONS(2471),
    [anon_sym_in] = ACTIONS(2471),
    [anon_sym_BANGin] = ACTIONS(2471),
    [anon_sym_match] = ACTIONS(2471),
    [anon_sym_select] = ACTIONS(2471),
    [anon_sym_STAR_EQ] = ACTIONS(2471),
    [anon_sym_SLASH_EQ] = ACTIONS(2471),
    [anon_sym_PERCENT_EQ] = ACTIONS(2471),
    [anon_sym_LT_LT_EQ] = ACTIONS(2471),
    [anon_sym_GT_GT_EQ] = ACTIONS(2471),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2471),
    [anon_sym_AMP_EQ] = ACTIONS(2471),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2471),
    [anon_sym_PLUS_EQ] = ACTIONS(2471),
    [anon_sym_DASH_EQ] = ACTIONS(2471),
    [anon_sym_PIPE_EQ] = ACTIONS(2471),
    [anon_sym_CARET_EQ] = ACTIONS(2471),
    [anon_sym_COLON_EQ] = ACTIONS(2471),
    [anon_sym_lock] = ACTIONS(2471),
    [anon_sym_rlock] = ACTIONS(2471),
    [anon_sym_unsafe] = ACTIONS(2471),
    [anon_sym_sql] = ACTIONS(2471),
    [sym_int_literal] = ACTIONS(2471),
    [sym_float_literal] = ACTIONS(2471),
    [sym_rune_literal] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_c_SQUOTE] = ACTIONS(2471),
    [anon_sym_c_DQUOTE] = ACTIONS(2471),
    [anon_sym_r_SQUOTE] = ACTIONS(2471),
    [anon_sym_r_DQUOTE] = ACTIONS(2471),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2471),
    [anon_sym_shared] = ACTIONS(2471),
    [anon_sym_map_LBRACK] = ACTIONS(2471),
    [anon_sym_chan] = ACTIONS(2471),
    [anon_sym_thread] = ACTIONS(2471),
    [anon_sym_atomic] = ACTIONS(2471),
    [anon_sym_assert] = ACTIONS(2471),
    [anon_sym_defer] = ACTIONS(2471),
    [anon_sym_goto] = ACTIONS(2471),
    [anon_sym_break] = ACTIONS(2471),
    [anon_sym_continue] = ACTIONS(2471),
    [anon_sym_return] = ACTIONS(2471),
    [anon_sym_DOLLARfor] = ACTIONS(2471),
    [anon_sym_for] = ACTIONS(2471),
    [anon_sym_POUND] = ACTIONS(2471),
    [anon_sym_asm] = ACTIONS(2471),
  },
  [1022] = {
    [sym_line_comment] = STATE(1022),
    [sym_block_comment] = STATE(1022),
    [sym_identifier] = ACTIONS(3069),
    [anon_sym_LF] = ACTIONS(3069),
    [anon_sym_CR] = ACTIONS(3069),
    [anon_sym_CR_LF] = ACTIONS(3069),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3069),
    [anon_sym_DOT] = ACTIONS(3069),
    [anon_sym_as] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3069),
    [anon_sym_COMMA] = ACTIONS(3069),
    [anon_sym_RBRACE] = ACTIONS(3069),
    [anon_sym_LPAREN] = ACTIONS(3069),
    [anon_sym_EQ] = ACTIONS(3069),
    [anon_sym_fn] = ACTIONS(3069),
    [anon_sym_PLUS] = ACTIONS(3069),
    [anon_sym_DASH] = ACTIONS(3069),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_SLASH] = ACTIONS(3069),
    [anon_sym_PERCENT] = ACTIONS(3069),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_GT] = ACTIONS(3069),
    [anon_sym_EQ_EQ] = ACTIONS(3069),
    [anon_sym_BANG_EQ] = ACTIONS(3069),
    [anon_sym_LT_EQ] = ACTIONS(3069),
    [anon_sym_GT_EQ] = ACTIONS(3069),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_struct] = ACTIONS(3069),
    [anon_sym_mut] = ACTIONS(3069),
    [anon_sym_COLON] = ACTIONS(3069),
    [anon_sym_PLUS_PLUS] = ACTIONS(3069),
    [anon_sym_DASH_DASH] = ACTIONS(3069),
    [anon_sym_QMARK] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(3069),
    [anon_sym_go] = ACTIONS(3069),
    [anon_sym_spawn] = ACTIONS(3069),
    [anon_sym_json_DOTdecode] = ACTIONS(3069),
    [anon_sym_PIPE] = ACTIONS(3069),
    [anon_sym_LBRACK2] = ACTIONS(3069),
    [anon_sym_TILDE] = ACTIONS(3069),
    [anon_sym_CARET] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3069),
    [anon_sym_LT_DASH] = ACTIONS(3069),
    [anon_sym_LT_LT] = ACTIONS(3069),
    [anon_sym_GT_GT] = ACTIONS(3069),
    [anon_sym_GT_GT_GT] = ACTIONS(3069),
    [anon_sym_AMP_CARET] = ACTIONS(3069),
    [anon_sym_AMP_AMP] = ACTIONS(3069),
    [anon_sym_PIPE_PIPE] = ACTIONS(3069),
    [anon_sym_or] = ACTIONS(3069),
    [sym_none] = ACTIONS(3069),
    [sym_true] = ACTIONS(3069),
    [sym_false] = ACTIONS(3069),
    [sym_nil] = ACTIONS(3069),
    [anon_sym_QMARK_DOT] = ACTIONS(3069),
    [anon_sym_POUND_LBRACK] = ACTIONS(3069),
    [anon_sym_if] = ACTIONS(3069),
    [anon_sym_DOLLARif] = ACTIONS(3069),
    [anon_sym_is] = ACTIONS(3069),
    [anon_sym_BANGis] = ACTIONS(3069),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_BANGin] = ACTIONS(3069),
    [anon_sym_match] = ACTIONS(3069),
    [anon_sym_select] = ACTIONS(3069),
    [anon_sym_STAR_EQ] = ACTIONS(3069),
    [anon_sym_SLASH_EQ] = ACTIONS(3069),
    [anon_sym_PERCENT_EQ] = ACTIONS(3069),
    [anon_sym_LT_LT_EQ] = ACTIONS(3069),
    [anon_sym_GT_GT_EQ] = ACTIONS(3069),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3069),
    [anon_sym_AMP_EQ] = ACTIONS(3069),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3069),
    [anon_sym_PLUS_EQ] = ACTIONS(3069),
    [anon_sym_DASH_EQ] = ACTIONS(3069),
    [anon_sym_PIPE_EQ] = ACTIONS(3069),
    [anon_sym_CARET_EQ] = ACTIONS(3069),
    [anon_sym_COLON_EQ] = ACTIONS(3069),
    [anon_sym_lock] = ACTIONS(3069),
    [anon_sym_rlock] = ACTIONS(3069),
    [anon_sym_unsafe] = ACTIONS(3069),
    [anon_sym_sql] = ACTIONS(3069),
    [sym_int_literal] = ACTIONS(3069),
    [sym_float_literal] = ACTIONS(3069),
    [sym_rune_literal] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE] = ACTIONS(3069),
    [anon_sym_c_SQUOTE] = ACTIONS(3069),
    [anon_sym_c_DQUOTE] = ACTIONS(3069),
    [anon_sym_r_SQUOTE] = ACTIONS(3069),
    [anon_sym_r_DQUOTE] = ACTIONS(3069),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3069),
    [anon_sym_shared] = ACTIONS(3069),
    [anon_sym_map_LBRACK] = ACTIONS(3069),
    [anon_sym_chan] = ACTIONS(3069),
    [anon_sym_thread] = ACTIONS(3069),
    [anon_sym_atomic] = ACTIONS(3069),
    [anon_sym_assert] = ACTIONS(3069),
    [anon_sym_defer] = ACTIONS(3069),
    [anon_sym_goto] = ACTIONS(3069),
    [anon_sym_break] = ACTIONS(3069),
    [anon_sym_continue] = ACTIONS(3069),
    [anon_sym_return] = ACTIONS(3069),
    [anon_sym_DOLLARfor] = ACTIONS(3069),
    [anon_sym_for] = ACTIONS(3069),
    [anon_sym_POUND] = ACTIONS(3069),
    [anon_sym_asm] = ACTIONS(3069),
  },
  [1023] = {
    [sym_line_comment] = STATE(1023),
    [sym_block_comment] = STATE(1023),
    [sym_identifier] = ACTIONS(2435),
    [anon_sym_LF] = ACTIONS(2435),
    [anon_sym_CR] = ACTIONS(2435),
    [anon_sym_CR_LF] = ACTIONS(2435),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2435),
    [anon_sym_DOT] = ACTIONS(2435),
    [anon_sym_as] = ACTIONS(2435),
    [anon_sym_LBRACE] = ACTIONS(2435),
    [anon_sym_COMMA] = ACTIONS(2435),
    [anon_sym_RBRACE] = ACTIONS(2435),
    [anon_sym_LPAREN] = ACTIONS(2435),
    [anon_sym_EQ] = ACTIONS(2435),
    [anon_sym_fn] = ACTIONS(2435),
    [anon_sym_PLUS] = ACTIONS(2435),
    [anon_sym_DASH] = ACTIONS(2435),
    [anon_sym_STAR] = ACTIONS(2435),
    [anon_sym_SLASH] = ACTIONS(2435),
    [anon_sym_PERCENT] = ACTIONS(2435),
    [anon_sym_LT] = ACTIONS(2435),
    [anon_sym_GT] = ACTIONS(2435),
    [anon_sym_EQ_EQ] = ACTIONS(2435),
    [anon_sym_BANG_EQ] = ACTIONS(2435),
    [anon_sym_LT_EQ] = ACTIONS(2435),
    [anon_sym_GT_EQ] = ACTIONS(2435),
    [anon_sym_LBRACK] = ACTIONS(2433),
    [anon_sym_struct] = ACTIONS(2435),
    [anon_sym_mut] = ACTIONS(2435),
    [anon_sym_COLON] = ACTIONS(2435),
    [anon_sym_PLUS_PLUS] = ACTIONS(2435),
    [anon_sym_DASH_DASH] = ACTIONS(2435),
    [anon_sym_QMARK] = ACTIONS(2435),
    [anon_sym_BANG] = ACTIONS(2435),
    [anon_sym_go] = ACTIONS(2435),
    [anon_sym_spawn] = ACTIONS(2435),
    [anon_sym_json_DOTdecode] = ACTIONS(2435),
    [anon_sym_PIPE] = ACTIONS(2435),
    [anon_sym_LBRACK2] = ACTIONS(2435),
    [anon_sym_TILDE] = ACTIONS(2435),
    [anon_sym_CARET] = ACTIONS(2435),
    [anon_sym_AMP] = ACTIONS(2435),
    [anon_sym_LT_DASH] = ACTIONS(2435),
    [anon_sym_LT_LT] = ACTIONS(2435),
    [anon_sym_GT_GT] = ACTIONS(2435),
    [anon_sym_GT_GT_GT] = ACTIONS(2435),
    [anon_sym_AMP_CARET] = ACTIONS(2435),
    [anon_sym_AMP_AMP] = ACTIONS(2435),
    [anon_sym_PIPE_PIPE] = ACTIONS(2435),
    [anon_sym_or] = ACTIONS(2435),
    [sym_none] = ACTIONS(2435),
    [sym_true] = ACTIONS(2435),
    [sym_false] = ACTIONS(2435),
    [sym_nil] = ACTIONS(2435),
    [anon_sym_QMARK_DOT] = ACTIONS(2435),
    [anon_sym_POUND_LBRACK] = ACTIONS(2435),
    [anon_sym_if] = ACTIONS(2435),
    [anon_sym_DOLLARif] = ACTIONS(2435),
    [anon_sym_is] = ACTIONS(2435),
    [anon_sym_BANGis] = ACTIONS(2435),
    [anon_sym_in] = ACTIONS(2435),
    [anon_sym_BANGin] = ACTIONS(2435),
    [anon_sym_match] = ACTIONS(2435),
    [anon_sym_select] = ACTIONS(2435),
    [anon_sym_STAR_EQ] = ACTIONS(2435),
    [anon_sym_SLASH_EQ] = ACTIONS(2435),
    [anon_sym_PERCENT_EQ] = ACTIONS(2435),
    [anon_sym_LT_LT_EQ] = ACTIONS(2435),
    [anon_sym_GT_GT_EQ] = ACTIONS(2435),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2435),
    [anon_sym_AMP_EQ] = ACTIONS(2435),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2435),
    [anon_sym_PLUS_EQ] = ACTIONS(2435),
    [anon_sym_DASH_EQ] = ACTIONS(2435),
    [anon_sym_PIPE_EQ] = ACTIONS(2435),
    [anon_sym_CARET_EQ] = ACTIONS(2435),
    [anon_sym_COLON_EQ] = ACTIONS(2435),
    [anon_sym_lock] = ACTIONS(2435),
    [anon_sym_rlock] = ACTIONS(2435),
    [anon_sym_unsafe] = ACTIONS(2435),
    [anon_sym_sql] = ACTIONS(2435),
    [sym_int_literal] = ACTIONS(2435),
    [sym_float_literal] = ACTIONS(2435),
    [sym_rune_literal] = ACTIONS(2435),
    [anon_sym_SQUOTE] = ACTIONS(2435),
    [anon_sym_DQUOTE] = ACTIONS(2435),
    [anon_sym_c_SQUOTE] = ACTIONS(2435),
    [anon_sym_c_DQUOTE] = ACTIONS(2435),
    [anon_sym_r_SQUOTE] = ACTIONS(2435),
    [anon_sym_r_DQUOTE] = ACTIONS(2435),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2435),
    [anon_sym_shared] = ACTIONS(2435),
    [anon_sym_map_LBRACK] = ACTIONS(2435),
    [anon_sym_chan] = ACTIONS(2435),
    [anon_sym_thread] = ACTIONS(2435),
    [anon_sym_atomic] = ACTIONS(2435),
    [anon_sym_assert] = ACTIONS(2435),
    [anon_sym_defer] = ACTIONS(2435),
    [anon_sym_goto] = ACTIONS(2435),
    [anon_sym_break] = ACTIONS(2435),
    [anon_sym_continue] = ACTIONS(2435),
    [anon_sym_return] = ACTIONS(2435),
    [anon_sym_DOLLARfor] = ACTIONS(2435),
    [anon_sym_for] = ACTIONS(2435),
    [anon_sym_POUND] = ACTIONS(2435),
    [anon_sym_asm] = ACTIONS(2435),
  },
  [1024] = {
    [sym_line_comment] = STATE(1024),
    [sym_block_comment] = STATE(1024),
    [sym_identifier] = ACTIONS(2457),
    [anon_sym_LF] = ACTIONS(2457),
    [anon_sym_CR] = ACTIONS(2457),
    [anon_sym_CR_LF] = ACTIONS(2457),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2457),
    [anon_sym_DOT] = ACTIONS(2457),
    [anon_sym_as] = ACTIONS(2457),
    [anon_sym_LBRACE] = ACTIONS(2457),
    [anon_sym_COMMA] = ACTIONS(2457),
    [anon_sym_RBRACE] = ACTIONS(2457),
    [anon_sym_LPAREN] = ACTIONS(2457),
    [anon_sym_EQ] = ACTIONS(2457),
    [anon_sym_fn] = ACTIONS(2457),
    [anon_sym_PLUS] = ACTIONS(2457),
    [anon_sym_DASH] = ACTIONS(2457),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_PERCENT] = ACTIONS(2457),
    [anon_sym_LT] = ACTIONS(2457),
    [anon_sym_GT] = ACTIONS(2457),
    [anon_sym_EQ_EQ] = ACTIONS(2457),
    [anon_sym_BANG_EQ] = ACTIONS(2457),
    [anon_sym_LT_EQ] = ACTIONS(2457),
    [anon_sym_GT_EQ] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_struct] = ACTIONS(2457),
    [anon_sym_mut] = ACTIONS(2457),
    [anon_sym_COLON] = ACTIONS(2457),
    [anon_sym_PLUS_PLUS] = ACTIONS(2457),
    [anon_sym_DASH_DASH] = ACTIONS(2457),
    [anon_sym_QMARK] = ACTIONS(2457),
    [anon_sym_BANG] = ACTIONS(2457),
    [anon_sym_go] = ACTIONS(2457),
    [anon_sym_spawn] = ACTIONS(2457),
    [anon_sym_json_DOTdecode] = ACTIONS(2457),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_LBRACK2] = ACTIONS(2457),
    [anon_sym_TILDE] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2457),
    [anon_sym_AMP] = ACTIONS(2457),
    [anon_sym_LT_DASH] = ACTIONS(2457),
    [anon_sym_LT_LT] = ACTIONS(2457),
    [anon_sym_GT_GT] = ACTIONS(2457),
    [anon_sym_GT_GT_GT] = ACTIONS(2457),
    [anon_sym_AMP_CARET] = ACTIONS(2457),
    [anon_sym_AMP_AMP] = ACTIONS(2457),
    [anon_sym_PIPE_PIPE] = ACTIONS(2457),
    [anon_sym_or] = ACTIONS(2457),
    [sym_none] = ACTIONS(2457),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [sym_nil] = ACTIONS(2457),
    [anon_sym_QMARK_DOT] = ACTIONS(2457),
    [anon_sym_POUND_LBRACK] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2457),
    [anon_sym_DOLLARif] = ACTIONS(2457),
    [anon_sym_is] = ACTIONS(2457),
    [anon_sym_BANGis] = ACTIONS(2457),
    [anon_sym_in] = ACTIONS(2457),
    [anon_sym_BANGin] = ACTIONS(2457),
    [anon_sym_match] = ACTIONS(2457),
    [anon_sym_select] = ACTIONS(2457),
    [anon_sym_STAR_EQ] = ACTIONS(2457),
    [anon_sym_SLASH_EQ] = ACTIONS(2457),
    [anon_sym_PERCENT_EQ] = ACTIONS(2457),
    [anon_sym_LT_LT_EQ] = ACTIONS(2457),
    [anon_sym_GT_GT_EQ] = ACTIONS(2457),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2457),
    [anon_sym_AMP_EQ] = ACTIONS(2457),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2457),
    [anon_sym_PLUS_EQ] = ACTIONS(2457),
    [anon_sym_DASH_EQ] = ACTIONS(2457),
    [anon_sym_PIPE_EQ] = ACTIONS(2457),
    [anon_sym_CARET_EQ] = ACTIONS(2457),
    [anon_sym_COLON_EQ] = ACTIONS(2457),
    [anon_sym_lock] = ACTIONS(2457),
    [anon_sym_rlock] = ACTIONS(2457),
    [anon_sym_unsafe] = ACTIONS(2457),
    [anon_sym_sql] = ACTIONS(2457),
    [sym_int_literal] = ACTIONS(2457),
    [sym_float_literal] = ACTIONS(2457),
    [sym_rune_literal] = ACTIONS(2457),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_DQUOTE] = ACTIONS(2457),
    [anon_sym_c_SQUOTE] = ACTIONS(2457),
    [anon_sym_c_DQUOTE] = ACTIONS(2457),
    [anon_sym_r_SQUOTE] = ACTIONS(2457),
    [anon_sym_r_DQUOTE] = ACTIONS(2457),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2457),
    [anon_sym_shared] = ACTIONS(2457),
    [anon_sym_map_LBRACK] = ACTIONS(2457),
    [anon_sym_chan] = ACTIONS(2457),
    [anon_sym_thread] = ACTIONS(2457),
    [anon_sym_atomic] = ACTIONS(2457),
    [anon_sym_assert] = ACTIONS(2457),
    [anon_sym_defer] = ACTIONS(2457),
    [anon_sym_goto] = ACTIONS(2457),
    [anon_sym_break] = ACTIONS(2457),
    [anon_sym_continue] = ACTIONS(2457),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_DOLLARfor] = ACTIONS(2457),
    [anon_sym_for] = ACTIONS(2457),
    [anon_sym_POUND] = ACTIONS(2457),
    [anon_sym_asm] = ACTIONS(2457),
  },
  [1025] = {
    [sym_line_comment] = STATE(1025),
    [sym_block_comment] = STATE(1025),
    [sym_identifier] = ACTIONS(2397),
    [anon_sym_LF] = ACTIONS(2397),
    [anon_sym_CR] = ACTIONS(2397),
    [anon_sym_CR_LF] = ACTIONS(2397),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2397),
    [anon_sym_DOT] = ACTIONS(2397),
    [anon_sym_as] = ACTIONS(2397),
    [anon_sym_LBRACE] = ACTIONS(2397),
    [anon_sym_COMMA] = ACTIONS(2397),
    [anon_sym_RBRACE] = ACTIONS(2397),
    [anon_sym_LPAREN] = ACTIONS(2397),
    [anon_sym_EQ] = ACTIONS(2397),
    [anon_sym_fn] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(2397),
    [anon_sym_DASH] = ACTIONS(2397),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_SLASH] = ACTIONS(2397),
    [anon_sym_PERCENT] = ACTIONS(2397),
    [anon_sym_LT] = ACTIONS(2397),
    [anon_sym_GT] = ACTIONS(2397),
    [anon_sym_EQ_EQ] = ACTIONS(2397),
    [anon_sym_BANG_EQ] = ACTIONS(2397),
    [anon_sym_LT_EQ] = ACTIONS(2397),
    [anon_sym_GT_EQ] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(2395),
    [anon_sym_struct] = ACTIONS(2397),
    [anon_sym_mut] = ACTIONS(2397),
    [anon_sym_COLON] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2397),
    [anon_sym_DASH_DASH] = ACTIONS(2397),
    [anon_sym_QMARK] = ACTIONS(2397),
    [anon_sym_BANG] = ACTIONS(2397),
    [anon_sym_go] = ACTIONS(2397),
    [anon_sym_spawn] = ACTIONS(2397),
    [anon_sym_json_DOTdecode] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(2397),
    [anon_sym_LBRACK2] = ACTIONS(2397),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_CARET] = ACTIONS(2397),
    [anon_sym_AMP] = ACTIONS(2397),
    [anon_sym_LT_DASH] = ACTIONS(2397),
    [anon_sym_LT_LT] = ACTIONS(2397),
    [anon_sym_GT_GT] = ACTIONS(2397),
    [anon_sym_GT_GT_GT] = ACTIONS(2397),
    [anon_sym_AMP_CARET] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(2397),
    [anon_sym_PIPE_PIPE] = ACTIONS(2397),
    [anon_sym_or] = ACTIONS(2397),
    [sym_none] = ACTIONS(2397),
    [sym_true] = ACTIONS(2397),
    [sym_false] = ACTIONS(2397),
    [sym_nil] = ACTIONS(2397),
    [anon_sym_QMARK_DOT] = ACTIONS(2397),
    [anon_sym_POUND_LBRACK] = ACTIONS(2397),
    [anon_sym_if] = ACTIONS(2397),
    [anon_sym_DOLLARif] = ACTIONS(2397),
    [anon_sym_is] = ACTIONS(2397),
    [anon_sym_BANGis] = ACTIONS(2397),
    [anon_sym_in] = ACTIONS(2397),
    [anon_sym_BANGin] = ACTIONS(2397),
    [anon_sym_match] = ACTIONS(2397),
    [anon_sym_select] = ACTIONS(2397),
    [anon_sym_STAR_EQ] = ACTIONS(2397),
    [anon_sym_SLASH_EQ] = ACTIONS(2397),
    [anon_sym_PERCENT_EQ] = ACTIONS(2397),
    [anon_sym_LT_LT_EQ] = ACTIONS(2397),
    [anon_sym_GT_GT_EQ] = ACTIONS(2397),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2397),
    [anon_sym_AMP_EQ] = ACTIONS(2397),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2397),
    [anon_sym_PLUS_EQ] = ACTIONS(2397),
    [anon_sym_DASH_EQ] = ACTIONS(2397),
    [anon_sym_PIPE_EQ] = ACTIONS(2397),
    [anon_sym_CARET_EQ] = ACTIONS(2397),
    [anon_sym_COLON_EQ] = ACTIONS(2397),
    [anon_sym_lock] = ACTIONS(2397),
    [anon_sym_rlock] = ACTIONS(2397),
    [anon_sym_unsafe] = ACTIONS(2397),
    [anon_sym_sql] = ACTIONS(2397),
    [sym_int_literal] = ACTIONS(2397),
    [sym_float_literal] = ACTIONS(2397),
    [sym_rune_literal] = ACTIONS(2397),
    [anon_sym_SQUOTE] = ACTIONS(2397),
    [anon_sym_DQUOTE] = ACTIONS(2397),
    [anon_sym_c_SQUOTE] = ACTIONS(2397),
    [anon_sym_c_DQUOTE] = ACTIONS(2397),
    [anon_sym_r_SQUOTE] = ACTIONS(2397),
    [anon_sym_r_DQUOTE] = ACTIONS(2397),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2397),
    [anon_sym_shared] = ACTIONS(2397),
    [anon_sym_map_LBRACK] = ACTIONS(2397),
    [anon_sym_chan] = ACTIONS(2397),
    [anon_sym_thread] = ACTIONS(2397),
    [anon_sym_atomic] = ACTIONS(2397),
    [anon_sym_assert] = ACTIONS(2397),
    [anon_sym_defer] = ACTIONS(2397),
    [anon_sym_goto] = ACTIONS(2397),
    [anon_sym_break] = ACTIONS(2397),
    [anon_sym_continue] = ACTIONS(2397),
    [anon_sym_return] = ACTIONS(2397),
    [anon_sym_DOLLARfor] = ACTIONS(2397),
    [anon_sym_for] = ACTIONS(2397),
    [anon_sym_POUND] = ACTIONS(2397),
    [anon_sym_asm] = ACTIONS(2397),
  },
  [1026] = {
    [sym_line_comment] = STATE(1026),
    [sym_block_comment] = STATE(1026),
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2373),
    [anon_sym_CR] = ACTIONS(2373),
    [anon_sym_CR_LF] = ACTIONS(2373),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_DOT] = ACTIONS(2373),
    [anon_sym_as] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2373),
    [anon_sym_COMMA] = ACTIONS(2373),
    [anon_sym_RBRACE] = ACTIONS(2373),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym_EQ] = ACTIONS(2373),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_SLASH] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2373),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_mut] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2373),
    [anon_sym_QMARK] = ACTIONS(2373),
    [anon_sym_BANG] = ACTIONS(2373),
    [anon_sym_go] = ACTIONS(2373),
    [anon_sym_spawn] = ACTIONS(2373),
    [anon_sym_json_DOTdecode] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_LBRACK2] = ACTIONS(2373),
    [anon_sym_TILDE] = ACTIONS(2373),
    [anon_sym_CARET] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_LT_DASH] = ACTIONS(2373),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2373),
    [anon_sym_AMP_CARET] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2373),
    [anon_sym_or] = ACTIONS(2373),
    [sym_none] = ACTIONS(2373),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [sym_nil] = ACTIONS(2373),
    [anon_sym_QMARK_DOT] = ACTIONS(2373),
    [anon_sym_POUND_LBRACK] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_DOLLARif] = ACTIONS(2373),
    [anon_sym_is] = ACTIONS(2373),
    [anon_sym_BANGis] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_BANGin] = ACTIONS(2373),
    [anon_sym_match] = ACTIONS(2373),
    [anon_sym_select] = ACTIONS(2373),
    [anon_sym_STAR_EQ] = ACTIONS(2373),
    [anon_sym_SLASH_EQ] = ACTIONS(2373),
    [anon_sym_PERCENT_EQ] = ACTIONS(2373),
    [anon_sym_LT_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT_GT_EQ] = ACTIONS(2373),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2373),
    [anon_sym_AMP_EQ] = ACTIONS(2373),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2373),
    [anon_sym_PLUS_EQ] = ACTIONS(2373),
    [anon_sym_DASH_EQ] = ACTIONS(2373),
    [anon_sym_PIPE_EQ] = ACTIONS(2373),
    [anon_sym_CARET_EQ] = ACTIONS(2373),
    [anon_sym_COLON_EQ] = ACTIONS(2373),
    [anon_sym_lock] = ACTIONS(2373),
    [anon_sym_rlock] = ACTIONS(2373),
    [anon_sym_unsafe] = ACTIONS(2373),
    [anon_sym_sql] = ACTIONS(2373),
    [sym_int_literal] = ACTIONS(2373),
    [sym_float_literal] = ACTIONS(2373),
    [sym_rune_literal] = ACTIONS(2373),
    [anon_sym_SQUOTE] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(2373),
    [anon_sym_c_SQUOTE] = ACTIONS(2373),
    [anon_sym_c_DQUOTE] = ACTIONS(2373),
    [anon_sym_r_SQUOTE] = ACTIONS(2373),
    [anon_sym_r_DQUOTE] = ACTIONS(2373),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_map_LBRACK] = ACTIONS(2373),
    [anon_sym_chan] = ACTIONS(2373),
    [anon_sym_thread] = ACTIONS(2373),
    [anon_sym_atomic] = ACTIONS(2373),
    [anon_sym_assert] = ACTIONS(2373),
    [anon_sym_defer] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_DOLLARfor] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_POUND] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
  },
  [1027] = {
    [sym_line_comment] = STATE(1027),
    [sym_block_comment] = STATE(1027),
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_LF] = ACTIONS(3045),
    [anon_sym_CR] = ACTIONS(3045),
    [anon_sym_CR_LF] = ACTIONS(3045),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3045),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_as] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3045),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_RBRACE] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3045),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym_fn] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3045),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_PERCENT] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_GT] = ACTIONS(3045),
    [anon_sym_EQ_EQ] = ACTIONS(3045),
    [anon_sym_BANG_EQ] = ACTIONS(3045),
    [anon_sym_LT_EQ] = ACTIONS(3045),
    [anon_sym_GT_EQ] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_struct] = ACTIONS(3045),
    [anon_sym_mut] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3045),
    [anon_sym_go] = ACTIONS(3045),
    [anon_sym_spawn] = ACTIONS(3045),
    [anon_sym_json_DOTdecode] = ACTIONS(3045),
    [anon_sym_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACK2] = ACTIONS(3045),
    [anon_sym_TILDE] = ACTIONS(3045),
    [anon_sym_CARET] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3045),
    [anon_sym_LT_DASH] = ACTIONS(3045),
    [anon_sym_LT_LT] = ACTIONS(3045),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_GT_GT_GT] = ACTIONS(3045),
    [anon_sym_AMP_CARET] = ACTIONS(3045),
    [anon_sym_AMP_AMP] = ACTIONS(3045),
    [anon_sym_PIPE_PIPE] = ACTIONS(3045),
    [anon_sym_or] = ACTIONS(3045),
    [sym_none] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_nil] = ACTIONS(3045),
    [anon_sym_QMARK_DOT] = ACTIONS(3045),
    [anon_sym_POUND_LBRACK] = ACTIONS(3045),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_DOLLARif] = ACTIONS(3045),
    [anon_sym_is] = ACTIONS(3045),
    [anon_sym_BANGis] = ACTIONS(3045),
    [anon_sym_in] = ACTIONS(3045),
    [anon_sym_BANGin] = ACTIONS(3045),
    [anon_sym_match] = ACTIONS(3045),
    [anon_sym_select] = ACTIONS(3045),
    [anon_sym_STAR_EQ] = ACTIONS(3045),
    [anon_sym_SLASH_EQ] = ACTIONS(3045),
    [anon_sym_PERCENT_EQ] = ACTIONS(3045),
    [anon_sym_LT_LT_EQ] = ACTIONS(3045),
    [anon_sym_GT_GT_EQ] = ACTIONS(3045),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3045),
    [anon_sym_AMP_EQ] = ACTIONS(3045),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3045),
    [anon_sym_PLUS_EQ] = ACTIONS(3045),
    [anon_sym_DASH_EQ] = ACTIONS(3045),
    [anon_sym_PIPE_EQ] = ACTIONS(3045),
    [anon_sym_CARET_EQ] = ACTIONS(3045),
    [anon_sym_COLON_EQ] = ACTIONS(3045),
    [anon_sym_lock] = ACTIONS(3045),
    [anon_sym_rlock] = ACTIONS(3045),
    [anon_sym_unsafe] = ACTIONS(3045),
    [anon_sym_sql] = ACTIONS(3045),
    [sym_int_literal] = ACTIONS(3045),
    [sym_float_literal] = ACTIONS(3045),
    [sym_rune_literal] = ACTIONS(3045),
    [anon_sym_SQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE] = ACTIONS(3045),
    [anon_sym_c_SQUOTE] = ACTIONS(3045),
    [anon_sym_c_DQUOTE] = ACTIONS(3045),
    [anon_sym_r_SQUOTE] = ACTIONS(3045),
    [anon_sym_r_DQUOTE] = ACTIONS(3045),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3045),
    [anon_sym_shared] = ACTIONS(3045),
    [anon_sym_map_LBRACK] = ACTIONS(3045),
    [anon_sym_chan] = ACTIONS(3045),
    [anon_sym_thread] = ACTIONS(3045),
    [anon_sym_atomic] = ACTIONS(3045),
    [anon_sym_assert] = ACTIONS(3045),
    [anon_sym_defer] = ACTIONS(3045),
    [anon_sym_goto] = ACTIONS(3045),
    [anon_sym_break] = ACTIONS(3045),
    [anon_sym_continue] = ACTIONS(3045),
    [anon_sym_return] = ACTIONS(3045),
    [anon_sym_DOLLARfor] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3045),
    [anon_sym_POUND] = ACTIONS(3045),
    [anon_sym_asm] = ACTIONS(3045),
  },
  [1028] = {
    [sym_line_comment] = STATE(1028),
    [sym_block_comment] = STATE(1028),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LF] = ACTIONS(2175),
    [anon_sym_CR] = ACTIONS(2175),
    [anon_sym_CR_LF] = ACTIONS(2175),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_DOT] = ACTIONS(2175),
    [anon_sym_as] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2177),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_EQ] = ACTIONS(2175),
    [anon_sym_fn] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2175),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_PERCENT] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_GT] = ACTIONS(2175),
    [anon_sym_EQ_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ] = ACTIONS(2175),
    [anon_sym_LT_EQ] = ACTIONS(2175),
    [anon_sym_GT_EQ] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2180),
    [anon_sym_struct] = ACTIONS(2175),
    [anon_sym_mut] = ACTIONS(2175),
    [anon_sym_COLON] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [anon_sym_QMARK] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_go] = ACTIONS(2175),
    [anon_sym_spawn] = ACTIONS(2175),
    [anon_sym_json_DOTdecode] = ACTIONS(2175),
    [anon_sym_PIPE] = ACTIONS(2175),
    [anon_sym_LBRACK2] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_CARET] = ACTIONS(2175),
    [anon_sym_AMP] = ACTIONS(2175),
    [anon_sym_LT_DASH] = ACTIONS(2175),
    [anon_sym_LT_LT] = ACTIONS(2175),
    [anon_sym_GT_GT] = ACTIONS(2175),
    [anon_sym_GT_GT_GT] = ACTIONS(2175),
    [anon_sym_AMP_CARET] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(2175),
    [anon_sym_PIPE_PIPE] = ACTIONS(2175),
    [anon_sym_or] = ACTIONS(2175),
    [sym_none] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_nil] = ACTIONS(2175),
    [anon_sym_QMARK_DOT] = ACTIONS(2175),
    [anon_sym_POUND_LBRACK] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_DOLLARif] = ACTIONS(2175),
    [anon_sym_is] = ACTIONS(2175),
    [anon_sym_BANGis] = ACTIONS(2175),
    [anon_sym_in] = ACTIONS(2175),
    [anon_sym_BANGin] = ACTIONS(2175),
    [anon_sym_match] = ACTIONS(2175),
    [anon_sym_select] = ACTIONS(2175),
    [anon_sym_STAR_EQ] = ACTIONS(2175),
    [anon_sym_SLASH_EQ] = ACTIONS(2175),
    [anon_sym_PERCENT_EQ] = ACTIONS(2175),
    [anon_sym_LT_LT_EQ] = ACTIONS(2175),
    [anon_sym_GT_GT_EQ] = ACTIONS(2175),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2175),
    [anon_sym_AMP_EQ] = ACTIONS(2175),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2175),
    [anon_sym_PLUS_EQ] = ACTIONS(2175),
    [anon_sym_DASH_EQ] = ACTIONS(2175),
    [anon_sym_PIPE_EQ] = ACTIONS(2175),
    [anon_sym_CARET_EQ] = ACTIONS(2175),
    [anon_sym_COLON_EQ] = ACTIONS(2175),
    [anon_sym_lock] = ACTIONS(2175),
    [anon_sym_rlock] = ACTIONS(2175),
    [anon_sym_unsafe] = ACTIONS(2175),
    [anon_sym_sql] = ACTIONS(2175),
    [sym_int_literal] = ACTIONS(2175),
    [sym_float_literal] = ACTIONS(2175),
    [sym_rune_literal] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_c_SQUOTE] = ACTIONS(2175),
    [anon_sym_c_DQUOTE] = ACTIONS(2175),
    [anon_sym_r_SQUOTE] = ACTIONS(2175),
    [anon_sym_r_DQUOTE] = ACTIONS(2175),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2175),
    [anon_sym_shared] = ACTIONS(2175),
    [anon_sym_map_LBRACK] = ACTIONS(2175),
    [anon_sym_chan] = ACTIONS(2175),
    [anon_sym_thread] = ACTIONS(2175),
    [anon_sym_atomic] = ACTIONS(2175),
    [anon_sym_assert] = ACTIONS(2175),
    [anon_sym_defer] = ACTIONS(2175),
    [anon_sym_goto] = ACTIONS(2175),
    [anon_sym_break] = ACTIONS(2175),
    [anon_sym_continue] = ACTIONS(2175),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_DOLLARfor] = ACTIONS(2175),
    [anon_sym_for] = ACTIONS(2175),
    [anon_sym_POUND] = ACTIONS(2175),
    [anon_sym_asm] = ACTIONS(2175),
  },
  [1029] = {
    [sym_line_comment] = STATE(1029),
    [sym_block_comment] = STATE(1029),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LF] = ACTIONS(2175),
    [anon_sym_CR] = ACTIONS(2175),
    [anon_sym_CR_LF] = ACTIONS(2175),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_DOT] = ACTIONS(2175),
    [anon_sym_as] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2177),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_EQ] = ACTIONS(2175),
    [anon_sym_fn] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2175),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_PERCENT] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_GT] = ACTIONS(2175),
    [anon_sym_EQ_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ] = ACTIONS(2175),
    [anon_sym_LT_EQ] = ACTIONS(2175),
    [anon_sym_GT_EQ] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2180),
    [anon_sym_struct] = ACTIONS(2175),
    [anon_sym_mut] = ACTIONS(2175),
    [anon_sym_COLON] = ACTIONS(3800),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [anon_sym_QMARK] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_go] = ACTIONS(2175),
    [anon_sym_spawn] = ACTIONS(2175),
    [anon_sym_json_DOTdecode] = ACTIONS(2175),
    [anon_sym_PIPE] = ACTIONS(2175),
    [anon_sym_LBRACK2] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_CARET] = ACTIONS(2175),
    [anon_sym_AMP] = ACTIONS(2175),
    [anon_sym_LT_DASH] = ACTIONS(2175),
    [anon_sym_LT_LT] = ACTIONS(2175),
    [anon_sym_GT_GT] = ACTIONS(2175),
    [anon_sym_GT_GT_GT] = ACTIONS(2175),
    [anon_sym_AMP_CARET] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(2175),
    [anon_sym_PIPE_PIPE] = ACTIONS(2175),
    [anon_sym_or] = ACTIONS(2175),
    [sym_none] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_nil] = ACTIONS(2175),
    [anon_sym_QMARK_DOT] = ACTIONS(2175),
    [anon_sym_POUND_LBRACK] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_DOLLARif] = ACTIONS(2175),
    [anon_sym_is] = ACTIONS(2175),
    [anon_sym_BANGis] = ACTIONS(2175),
    [anon_sym_in] = ACTIONS(2175),
    [anon_sym_BANGin] = ACTIONS(2175),
    [anon_sym_match] = ACTIONS(2175),
    [anon_sym_select] = ACTIONS(2175),
    [anon_sym_STAR_EQ] = ACTIONS(2175),
    [anon_sym_SLASH_EQ] = ACTIONS(2175),
    [anon_sym_PERCENT_EQ] = ACTIONS(2175),
    [anon_sym_LT_LT_EQ] = ACTIONS(2175),
    [anon_sym_GT_GT_EQ] = ACTIONS(2175),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2175),
    [anon_sym_AMP_EQ] = ACTIONS(2175),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2175),
    [anon_sym_PLUS_EQ] = ACTIONS(2175),
    [anon_sym_DASH_EQ] = ACTIONS(2175),
    [anon_sym_PIPE_EQ] = ACTIONS(2175),
    [anon_sym_CARET_EQ] = ACTIONS(2175),
    [anon_sym_COLON_EQ] = ACTIONS(2175),
    [anon_sym_lock] = ACTIONS(2175),
    [anon_sym_rlock] = ACTIONS(2175),
    [anon_sym_unsafe] = ACTIONS(2175),
    [anon_sym_sql] = ACTIONS(2175),
    [sym_int_literal] = ACTIONS(2175),
    [sym_float_literal] = ACTIONS(2175),
    [sym_rune_literal] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_c_SQUOTE] = ACTIONS(2175),
    [anon_sym_c_DQUOTE] = ACTIONS(2175),
    [anon_sym_r_SQUOTE] = ACTIONS(2175),
    [anon_sym_r_DQUOTE] = ACTIONS(2175),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2175),
    [anon_sym_shared] = ACTIONS(2175),
    [anon_sym_map_LBRACK] = ACTIONS(2175),
    [anon_sym_chan] = ACTIONS(2175),
    [anon_sym_thread] = ACTIONS(2175),
    [anon_sym_atomic] = ACTIONS(2175),
    [anon_sym_assert] = ACTIONS(2175),
    [anon_sym_defer] = ACTIONS(2175),
    [anon_sym_goto] = ACTIONS(2175),
    [anon_sym_break] = ACTIONS(2175),
    [anon_sym_continue] = ACTIONS(2175),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_DOLLARfor] = ACTIONS(2175),
    [anon_sym_for] = ACTIONS(2175),
    [anon_sym_POUND] = ACTIONS(2175),
    [anon_sym_asm] = ACTIONS(2175),
  },
  [1030] = {
    [sym_line_comment] = STATE(1030),
    [sym_block_comment] = STATE(1030),
    [sym_identifier] = ACTIONS(2429),
    [anon_sym_LF] = ACTIONS(2429),
    [anon_sym_CR] = ACTIONS(2429),
    [anon_sym_CR_LF] = ACTIONS(2429),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2429),
    [anon_sym_DOT] = ACTIONS(2429),
    [anon_sym_as] = ACTIONS(2429),
    [anon_sym_LBRACE] = ACTIONS(2429),
    [anon_sym_COMMA] = ACTIONS(2429),
    [anon_sym_RBRACE] = ACTIONS(2429),
    [anon_sym_LPAREN] = ACTIONS(2429),
    [anon_sym_EQ] = ACTIONS(2429),
    [anon_sym_fn] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(2429),
    [anon_sym_DASH] = ACTIONS(2429),
    [anon_sym_STAR] = ACTIONS(2429),
    [anon_sym_SLASH] = ACTIONS(2429),
    [anon_sym_PERCENT] = ACTIONS(2429),
    [anon_sym_LT] = ACTIONS(2429),
    [anon_sym_GT] = ACTIONS(2429),
    [anon_sym_EQ_EQ] = ACTIONS(2429),
    [anon_sym_BANG_EQ] = ACTIONS(2429),
    [anon_sym_LT_EQ] = ACTIONS(2429),
    [anon_sym_GT_EQ] = ACTIONS(2429),
    [anon_sym_LBRACK] = ACTIONS(2427),
    [anon_sym_struct] = ACTIONS(2429),
    [anon_sym_mut] = ACTIONS(2429),
    [anon_sym_COLON] = ACTIONS(2429),
    [anon_sym_PLUS_PLUS] = ACTIONS(2429),
    [anon_sym_DASH_DASH] = ACTIONS(2429),
    [anon_sym_QMARK] = ACTIONS(2429),
    [anon_sym_BANG] = ACTIONS(2429),
    [anon_sym_go] = ACTIONS(2429),
    [anon_sym_spawn] = ACTIONS(2429),
    [anon_sym_json_DOTdecode] = ACTIONS(2429),
    [anon_sym_PIPE] = ACTIONS(2429),
    [anon_sym_LBRACK2] = ACTIONS(2429),
    [anon_sym_TILDE] = ACTIONS(2429),
    [anon_sym_CARET] = ACTIONS(2429),
    [anon_sym_AMP] = ACTIONS(2429),
    [anon_sym_LT_DASH] = ACTIONS(2429),
    [anon_sym_LT_LT] = ACTIONS(2429),
    [anon_sym_GT_GT] = ACTIONS(2429),
    [anon_sym_GT_GT_GT] = ACTIONS(2429),
    [anon_sym_AMP_CARET] = ACTIONS(2429),
    [anon_sym_AMP_AMP] = ACTIONS(2429),
    [anon_sym_PIPE_PIPE] = ACTIONS(2429),
    [anon_sym_or] = ACTIONS(2429),
    [sym_none] = ACTIONS(2429),
    [sym_true] = ACTIONS(2429),
    [sym_false] = ACTIONS(2429),
    [sym_nil] = ACTIONS(2429),
    [anon_sym_QMARK_DOT] = ACTIONS(2429),
    [anon_sym_POUND_LBRACK] = ACTIONS(2429),
    [anon_sym_if] = ACTIONS(2429),
    [anon_sym_DOLLARif] = ACTIONS(2429),
    [anon_sym_is] = ACTIONS(2429),
    [anon_sym_BANGis] = ACTIONS(2429),
    [anon_sym_in] = ACTIONS(2429),
    [anon_sym_BANGin] = ACTIONS(2429),
    [anon_sym_match] = ACTIONS(2429),
    [anon_sym_select] = ACTIONS(2429),
    [anon_sym_STAR_EQ] = ACTIONS(2429),
    [anon_sym_SLASH_EQ] = ACTIONS(2429),
    [anon_sym_PERCENT_EQ] = ACTIONS(2429),
    [anon_sym_LT_LT_EQ] = ACTIONS(2429),
    [anon_sym_GT_GT_EQ] = ACTIONS(2429),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2429),
    [anon_sym_AMP_EQ] = ACTIONS(2429),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2429),
    [anon_sym_PLUS_EQ] = ACTIONS(2429),
    [anon_sym_DASH_EQ] = ACTIONS(2429),
    [anon_sym_PIPE_EQ] = ACTIONS(2429),
    [anon_sym_CARET_EQ] = ACTIONS(2429),
    [anon_sym_COLON_EQ] = ACTIONS(2429),
    [anon_sym_lock] = ACTIONS(2429),
    [anon_sym_rlock] = ACTIONS(2429),
    [anon_sym_unsafe] = ACTIONS(2429),
    [anon_sym_sql] = ACTIONS(2429),
    [sym_int_literal] = ACTIONS(2429),
    [sym_float_literal] = ACTIONS(2429),
    [sym_rune_literal] = ACTIONS(2429),
    [anon_sym_SQUOTE] = ACTIONS(2429),
    [anon_sym_DQUOTE] = ACTIONS(2429),
    [anon_sym_c_SQUOTE] = ACTIONS(2429),
    [anon_sym_c_DQUOTE] = ACTIONS(2429),
    [anon_sym_r_SQUOTE] = ACTIONS(2429),
    [anon_sym_r_DQUOTE] = ACTIONS(2429),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2429),
    [anon_sym_shared] = ACTIONS(2429),
    [anon_sym_map_LBRACK] = ACTIONS(2429),
    [anon_sym_chan] = ACTIONS(2429),
    [anon_sym_thread] = ACTIONS(2429),
    [anon_sym_atomic] = ACTIONS(2429),
    [anon_sym_assert] = ACTIONS(2429),
    [anon_sym_defer] = ACTIONS(2429),
    [anon_sym_goto] = ACTIONS(2429),
    [anon_sym_break] = ACTIONS(2429),
    [anon_sym_continue] = ACTIONS(2429),
    [anon_sym_return] = ACTIONS(2429),
    [anon_sym_DOLLARfor] = ACTIONS(2429),
    [anon_sym_for] = ACTIONS(2429),
    [anon_sym_POUND] = ACTIONS(2429),
    [anon_sym_asm] = ACTIONS(2429),
  },
  [1031] = {
    [sym_line_comment] = STATE(1031),
    [sym_block_comment] = STATE(1031),
    [sym_identifier] = ACTIONS(2443),
    [anon_sym_LF] = ACTIONS(2443),
    [anon_sym_CR] = ACTIONS(2443),
    [anon_sym_CR_LF] = ACTIONS(2443),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2443),
    [anon_sym_DOT] = ACTIONS(2445),
    [anon_sym_as] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(2443),
    [anon_sym_COMMA] = ACTIONS(2443),
    [anon_sym_RBRACE] = ACTIONS(2443),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym_EQ] = ACTIONS(2443),
    [anon_sym_fn] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2445),
    [anon_sym_STAR] = ACTIONS(2445),
    [anon_sym_SLASH] = ACTIONS(2445),
    [anon_sym_PERCENT] = ACTIONS(2445),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_GT] = ACTIONS(2445),
    [anon_sym_EQ_EQ] = ACTIONS(2445),
    [anon_sym_BANG_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_struct] = ACTIONS(2443),
    [anon_sym_mut] = ACTIONS(2443),
    [anon_sym_COLON] = ACTIONS(2443),
    [anon_sym_PLUS_PLUS] = ACTIONS(2445),
    [anon_sym_DASH_DASH] = ACTIONS(2445),
    [anon_sym_QMARK] = ACTIONS(2445),
    [anon_sym_BANG] = ACTIONS(2445),
    [anon_sym_go] = ACTIONS(2443),
    [anon_sym_spawn] = ACTIONS(2443),
    [anon_sym_json_DOTdecode] = ACTIONS(2443),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_LBRACK2] = ACTIONS(2445),
    [anon_sym_TILDE] = ACTIONS(2443),
    [anon_sym_CARET] = ACTIONS(2445),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_LT_DASH] = ACTIONS(2443),
    [anon_sym_LT_LT] = ACTIONS(2445),
    [anon_sym_GT_GT] = ACTIONS(2445),
    [anon_sym_GT_GT_GT] = ACTIONS(2445),
    [anon_sym_AMP_CARET] = ACTIONS(2445),
    [anon_sym_AMP_AMP] = ACTIONS(2445),
    [anon_sym_PIPE_PIPE] = ACTIONS(2445),
    [anon_sym_or] = ACTIONS(2445),
    [sym_none] = ACTIONS(2443),
    [sym_true] = ACTIONS(2443),
    [sym_false] = ACTIONS(2443),
    [sym_nil] = ACTIONS(2443),
    [anon_sym_QMARK_DOT] = ACTIONS(2445),
    [anon_sym_POUND_LBRACK] = ACTIONS(2445),
    [anon_sym_if] = ACTIONS(2443),
    [anon_sym_DOLLARif] = ACTIONS(2443),
    [anon_sym_is] = ACTIONS(2445),
    [anon_sym_BANGis] = ACTIONS(2445),
    [anon_sym_in] = ACTIONS(2445),
    [anon_sym_BANGin] = ACTIONS(2445),
    [anon_sym_match] = ACTIONS(2443),
    [anon_sym_select] = ACTIONS(2443),
    [anon_sym_STAR_EQ] = ACTIONS(2443),
    [anon_sym_SLASH_EQ] = ACTIONS(2443),
    [anon_sym_PERCENT_EQ] = ACTIONS(2443),
    [anon_sym_LT_LT_EQ] = ACTIONS(2443),
    [anon_sym_GT_GT_EQ] = ACTIONS(2443),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2443),
    [anon_sym_AMP_EQ] = ACTIONS(2443),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2443),
    [anon_sym_PLUS_EQ] = ACTIONS(2443),
    [anon_sym_DASH_EQ] = ACTIONS(2443),
    [anon_sym_PIPE_EQ] = ACTIONS(2443),
    [anon_sym_CARET_EQ] = ACTIONS(2443),
    [anon_sym_COLON_EQ] = ACTIONS(2443),
    [anon_sym_lock] = ACTIONS(2443),
    [anon_sym_rlock] = ACTIONS(2443),
    [anon_sym_unsafe] = ACTIONS(2443),
    [anon_sym_sql] = ACTIONS(2443),
    [sym_int_literal] = ACTIONS(2443),
    [sym_float_literal] = ACTIONS(2443),
    [sym_rune_literal] = ACTIONS(2443),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [anon_sym_DQUOTE] = ACTIONS(2443),
    [anon_sym_c_SQUOTE] = ACTIONS(2443),
    [anon_sym_c_DQUOTE] = ACTIONS(2443),
    [anon_sym_r_SQUOTE] = ACTIONS(2443),
    [anon_sym_r_DQUOTE] = ACTIONS(2443),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2443),
    [anon_sym_shared] = ACTIONS(2443),
    [anon_sym_map_LBRACK] = ACTIONS(2443),
    [anon_sym_chan] = ACTIONS(2443),
    [anon_sym_thread] = ACTIONS(2443),
    [anon_sym_atomic] = ACTIONS(2443),
    [anon_sym_assert] = ACTIONS(2443),
    [anon_sym_defer] = ACTIONS(2443),
    [anon_sym_goto] = ACTIONS(2443),
    [anon_sym_break] = ACTIONS(2443),
    [anon_sym_continue] = ACTIONS(2443),
    [anon_sym_return] = ACTIONS(2443),
    [anon_sym_DOLLARfor] = ACTIONS(2443),
    [anon_sym_for] = ACTIONS(2443),
    [anon_sym_POUND] = ACTIONS(2443),
    [anon_sym_asm] = ACTIONS(2443),
  },
  [1032] = {
    [sym_line_comment] = STATE(1032),
    [sym_block_comment] = STATE(1032),
    [sym_identifier] = ACTIONS(3328),
    [anon_sym_LF] = ACTIONS(3328),
    [anon_sym_CR] = ACTIONS(3328),
    [anon_sym_CR_LF] = ACTIONS(3328),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3328),
    [anon_sym_DOT] = ACTIONS(3328),
    [anon_sym_as] = ACTIONS(3328),
    [anon_sym_LBRACE] = ACTIONS(3328),
    [anon_sym_COMMA] = ACTIONS(3328),
    [anon_sym_RBRACE] = ACTIONS(3328),
    [anon_sym_LPAREN] = ACTIONS(3328),
    [anon_sym_EQ] = ACTIONS(3328),
    [anon_sym_fn] = ACTIONS(3328),
    [anon_sym_PLUS] = ACTIONS(3328),
    [anon_sym_DASH] = ACTIONS(3328),
    [anon_sym_STAR] = ACTIONS(3328),
    [anon_sym_SLASH] = ACTIONS(3328),
    [anon_sym_PERCENT] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(3328),
    [anon_sym_GT] = ACTIONS(3328),
    [anon_sym_EQ_EQ] = ACTIONS(3328),
    [anon_sym_BANG_EQ] = ACTIONS(3328),
    [anon_sym_LT_EQ] = ACTIONS(3328),
    [anon_sym_GT_EQ] = ACTIONS(3328),
    [anon_sym_LBRACK] = ACTIONS(3326),
    [anon_sym_struct] = ACTIONS(3328),
    [anon_sym_mut] = ACTIONS(3328),
    [anon_sym_COLON] = ACTIONS(3328),
    [anon_sym_PLUS_PLUS] = ACTIONS(3328),
    [anon_sym_DASH_DASH] = ACTIONS(3328),
    [anon_sym_QMARK] = ACTIONS(3328),
    [anon_sym_BANG] = ACTIONS(3328),
    [anon_sym_go] = ACTIONS(3328),
    [anon_sym_spawn] = ACTIONS(3328),
    [anon_sym_json_DOTdecode] = ACTIONS(3328),
    [anon_sym_PIPE] = ACTIONS(3328),
    [anon_sym_LBRACK2] = ACTIONS(3328),
    [anon_sym_TILDE] = ACTIONS(3328),
    [anon_sym_CARET] = ACTIONS(3328),
    [anon_sym_AMP] = ACTIONS(3328),
    [anon_sym_LT_DASH] = ACTIONS(3328),
    [anon_sym_LT_LT] = ACTIONS(3328),
    [anon_sym_GT_GT] = ACTIONS(3328),
    [anon_sym_GT_GT_GT] = ACTIONS(3328),
    [anon_sym_AMP_CARET] = ACTIONS(3328),
    [anon_sym_AMP_AMP] = ACTIONS(3328),
    [anon_sym_PIPE_PIPE] = ACTIONS(3328),
    [anon_sym_or] = ACTIONS(3328),
    [sym_none] = ACTIONS(3328),
    [sym_true] = ACTIONS(3328),
    [sym_false] = ACTIONS(3328),
    [sym_nil] = ACTIONS(3328),
    [anon_sym_QMARK_DOT] = ACTIONS(3328),
    [anon_sym_POUND_LBRACK] = ACTIONS(3328),
    [anon_sym_if] = ACTIONS(3328),
    [anon_sym_DOLLARif] = ACTIONS(3328),
    [anon_sym_is] = ACTIONS(3328),
    [anon_sym_BANGis] = ACTIONS(3328),
    [anon_sym_in] = ACTIONS(3328),
    [anon_sym_BANGin] = ACTIONS(3328),
    [anon_sym_match] = ACTIONS(3328),
    [anon_sym_select] = ACTIONS(3328),
    [anon_sym_STAR_EQ] = ACTIONS(3328),
    [anon_sym_SLASH_EQ] = ACTIONS(3328),
    [anon_sym_PERCENT_EQ] = ACTIONS(3328),
    [anon_sym_LT_LT_EQ] = ACTIONS(3328),
    [anon_sym_GT_GT_EQ] = ACTIONS(3328),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3328),
    [anon_sym_AMP_EQ] = ACTIONS(3328),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3328),
    [anon_sym_PLUS_EQ] = ACTIONS(3328),
    [anon_sym_DASH_EQ] = ACTIONS(3328),
    [anon_sym_PIPE_EQ] = ACTIONS(3328),
    [anon_sym_CARET_EQ] = ACTIONS(3328),
    [anon_sym_COLON_EQ] = ACTIONS(3328),
    [anon_sym_lock] = ACTIONS(3328),
    [anon_sym_rlock] = ACTIONS(3328),
    [anon_sym_unsafe] = ACTIONS(3328),
    [anon_sym_sql] = ACTIONS(3328),
    [sym_int_literal] = ACTIONS(3328),
    [sym_float_literal] = ACTIONS(3328),
    [sym_rune_literal] = ACTIONS(3328),
    [anon_sym_SQUOTE] = ACTIONS(3328),
    [anon_sym_DQUOTE] = ACTIONS(3328),
    [anon_sym_c_SQUOTE] = ACTIONS(3328),
    [anon_sym_c_DQUOTE] = ACTIONS(3328),
    [anon_sym_r_SQUOTE] = ACTIONS(3328),
    [anon_sym_r_DQUOTE] = ACTIONS(3328),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3328),
    [anon_sym_shared] = ACTIONS(3328),
    [anon_sym_map_LBRACK] = ACTIONS(3328),
    [anon_sym_chan] = ACTIONS(3328),
    [anon_sym_thread] = ACTIONS(3328),
    [anon_sym_atomic] = ACTIONS(3328),
    [anon_sym_assert] = ACTIONS(3328),
    [anon_sym_defer] = ACTIONS(3328),
    [anon_sym_goto] = ACTIONS(3328),
    [anon_sym_break] = ACTIONS(3328),
    [anon_sym_continue] = ACTIONS(3328),
    [anon_sym_return] = ACTIONS(3328),
    [anon_sym_DOLLARfor] = ACTIONS(3328),
    [anon_sym_for] = ACTIONS(3328),
    [anon_sym_POUND] = ACTIONS(3328),
    [anon_sym_asm] = ACTIONS(3328),
  },
  [1033] = {
    [sym_line_comment] = STATE(1033),
    [sym_block_comment] = STATE(1033),
    [sym_identifier] = ACTIONS(3286),
    [anon_sym_LF] = ACTIONS(3286),
    [anon_sym_CR] = ACTIONS(3286),
    [anon_sym_CR_LF] = ACTIONS(3286),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3286),
    [anon_sym_DOT] = ACTIONS(3286),
    [anon_sym_as] = ACTIONS(3286),
    [anon_sym_LBRACE] = ACTIONS(3286),
    [anon_sym_COMMA] = ACTIONS(3286),
    [anon_sym_RBRACE] = ACTIONS(3286),
    [anon_sym_LPAREN] = ACTIONS(3286),
    [anon_sym_EQ] = ACTIONS(3286),
    [anon_sym_fn] = ACTIONS(3286),
    [anon_sym_PLUS] = ACTIONS(3286),
    [anon_sym_DASH] = ACTIONS(3286),
    [anon_sym_STAR] = ACTIONS(3286),
    [anon_sym_SLASH] = ACTIONS(3286),
    [anon_sym_PERCENT] = ACTIONS(3286),
    [anon_sym_LT] = ACTIONS(3286),
    [anon_sym_GT] = ACTIONS(3286),
    [anon_sym_EQ_EQ] = ACTIONS(3286),
    [anon_sym_BANG_EQ] = ACTIONS(3286),
    [anon_sym_LT_EQ] = ACTIONS(3286),
    [anon_sym_GT_EQ] = ACTIONS(3286),
    [anon_sym_LBRACK] = ACTIONS(3284),
    [anon_sym_struct] = ACTIONS(3286),
    [anon_sym_mut] = ACTIONS(3286),
    [anon_sym_COLON] = ACTIONS(3286),
    [anon_sym_PLUS_PLUS] = ACTIONS(3286),
    [anon_sym_DASH_DASH] = ACTIONS(3286),
    [anon_sym_QMARK] = ACTIONS(3286),
    [anon_sym_BANG] = ACTIONS(3286),
    [anon_sym_go] = ACTIONS(3286),
    [anon_sym_spawn] = ACTIONS(3286),
    [anon_sym_json_DOTdecode] = ACTIONS(3286),
    [anon_sym_PIPE] = ACTIONS(3286),
    [anon_sym_LBRACK2] = ACTIONS(3286),
    [anon_sym_TILDE] = ACTIONS(3286),
    [anon_sym_CARET] = ACTIONS(3286),
    [anon_sym_AMP] = ACTIONS(3286),
    [anon_sym_LT_DASH] = ACTIONS(3286),
    [anon_sym_LT_LT] = ACTIONS(3286),
    [anon_sym_GT_GT] = ACTIONS(3286),
    [anon_sym_GT_GT_GT] = ACTIONS(3286),
    [anon_sym_AMP_CARET] = ACTIONS(3286),
    [anon_sym_AMP_AMP] = ACTIONS(3286),
    [anon_sym_PIPE_PIPE] = ACTIONS(3286),
    [anon_sym_or] = ACTIONS(3286),
    [sym_none] = ACTIONS(3286),
    [sym_true] = ACTIONS(3286),
    [sym_false] = ACTIONS(3286),
    [sym_nil] = ACTIONS(3286),
    [anon_sym_QMARK_DOT] = ACTIONS(3286),
    [anon_sym_POUND_LBRACK] = ACTIONS(3286),
    [anon_sym_if] = ACTIONS(3286),
    [anon_sym_DOLLARif] = ACTIONS(3286),
    [anon_sym_is] = ACTIONS(3286),
    [anon_sym_BANGis] = ACTIONS(3286),
    [anon_sym_in] = ACTIONS(3286),
    [anon_sym_BANGin] = ACTIONS(3286),
    [anon_sym_match] = ACTIONS(3286),
    [anon_sym_select] = ACTIONS(3286),
    [anon_sym_STAR_EQ] = ACTIONS(3286),
    [anon_sym_SLASH_EQ] = ACTIONS(3286),
    [anon_sym_PERCENT_EQ] = ACTIONS(3286),
    [anon_sym_LT_LT_EQ] = ACTIONS(3286),
    [anon_sym_GT_GT_EQ] = ACTIONS(3286),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3286),
    [anon_sym_AMP_EQ] = ACTIONS(3286),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3286),
    [anon_sym_PLUS_EQ] = ACTIONS(3286),
    [anon_sym_DASH_EQ] = ACTIONS(3286),
    [anon_sym_PIPE_EQ] = ACTIONS(3286),
    [anon_sym_CARET_EQ] = ACTIONS(3286),
    [anon_sym_COLON_EQ] = ACTIONS(3286),
    [anon_sym_lock] = ACTIONS(3286),
    [anon_sym_rlock] = ACTIONS(3286),
    [anon_sym_unsafe] = ACTIONS(3286),
    [anon_sym_sql] = ACTIONS(3286),
    [sym_int_literal] = ACTIONS(3286),
    [sym_float_literal] = ACTIONS(3286),
    [sym_rune_literal] = ACTIONS(3286),
    [anon_sym_SQUOTE] = ACTIONS(3286),
    [anon_sym_DQUOTE] = ACTIONS(3286),
    [anon_sym_c_SQUOTE] = ACTIONS(3286),
    [anon_sym_c_DQUOTE] = ACTIONS(3286),
    [anon_sym_r_SQUOTE] = ACTIONS(3286),
    [anon_sym_r_DQUOTE] = ACTIONS(3286),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3286),
    [anon_sym_shared] = ACTIONS(3286),
    [anon_sym_map_LBRACK] = ACTIONS(3286),
    [anon_sym_chan] = ACTIONS(3286),
    [anon_sym_thread] = ACTIONS(3286),
    [anon_sym_atomic] = ACTIONS(3286),
    [anon_sym_assert] = ACTIONS(3286),
    [anon_sym_defer] = ACTIONS(3286),
    [anon_sym_goto] = ACTIONS(3286),
    [anon_sym_break] = ACTIONS(3286),
    [anon_sym_continue] = ACTIONS(3286),
    [anon_sym_return] = ACTIONS(3286),
    [anon_sym_DOLLARfor] = ACTIONS(3286),
    [anon_sym_for] = ACTIONS(3286),
    [anon_sym_POUND] = ACTIONS(3286),
    [anon_sym_asm] = ACTIONS(3286),
  },
  [1034] = {
    [sym_line_comment] = STATE(1034),
    [sym_block_comment] = STATE(1034),
    [sym_identifier] = ACTIONS(2377),
    [anon_sym_LF] = ACTIONS(2377),
    [anon_sym_CR] = ACTIONS(2377),
    [anon_sym_CR_LF] = ACTIONS(2377),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2377),
    [anon_sym_DOT] = ACTIONS(2377),
    [anon_sym_as] = ACTIONS(2377),
    [anon_sym_LBRACE] = ACTIONS(2377),
    [anon_sym_COMMA] = ACTIONS(2377),
    [anon_sym_RBRACE] = ACTIONS(2377),
    [anon_sym_LPAREN] = ACTIONS(2377),
    [anon_sym_EQ] = ACTIONS(2377),
    [anon_sym_fn] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2377),
    [anon_sym_DASH] = ACTIONS(2377),
    [anon_sym_STAR] = ACTIONS(2377),
    [anon_sym_SLASH] = ACTIONS(2377),
    [anon_sym_PERCENT] = ACTIONS(2377),
    [anon_sym_LT] = ACTIONS(2377),
    [anon_sym_GT] = ACTIONS(2377),
    [anon_sym_EQ_EQ] = ACTIONS(2377),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2377),
    [anon_sym_GT_EQ] = ACTIONS(2377),
    [anon_sym_LBRACK] = ACTIONS(2375),
    [anon_sym_struct] = ACTIONS(2377),
    [anon_sym_mut] = ACTIONS(2377),
    [anon_sym_COLON] = ACTIONS(2377),
    [anon_sym_PLUS_PLUS] = ACTIONS(2377),
    [anon_sym_DASH_DASH] = ACTIONS(2377),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2377),
    [anon_sym_go] = ACTIONS(2377),
    [anon_sym_spawn] = ACTIONS(2377),
    [anon_sym_json_DOTdecode] = ACTIONS(2377),
    [anon_sym_PIPE] = ACTIONS(2377),
    [anon_sym_LBRACK2] = ACTIONS(2377),
    [anon_sym_TILDE] = ACTIONS(2377),
    [anon_sym_CARET] = ACTIONS(2377),
    [anon_sym_AMP] = ACTIONS(2377),
    [anon_sym_LT_DASH] = ACTIONS(2377),
    [anon_sym_LT_LT] = ACTIONS(2377),
    [anon_sym_GT_GT] = ACTIONS(2377),
    [anon_sym_GT_GT_GT] = ACTIONS(2377),
    [anon_sym_AMP_CARET] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_or] = ACTIONS(2377),
    [sym_none] = ACTIONS(2377),
    [sym_true] = ACTIONS(2377),
    [sym_false] = ACTIONS(2377),
    [sym_nil] = ACTIONS(2377),
    [anon_sym_QMARK_DOT] = ACTIONS(2377),
    [anon_sym_POUND_LBRACK] = ACTIONS(2377),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_DOLLARif] = ACTIONS(2377),
    [anon_sym_is] = ACTIONS(2377),
    [anon_sym_BANGis] = ACTIONS(2377),
    [anon_sym_in] = ACTIONS(2377),
    [anon_sym_BANGin] = ACTIONS(2377),
    [anon_sym_match] = ACTIONS(2377),
    [anon_sym_select] = ACTIONS(2377),
    [anon_sym_STAR_EQ] = ACTIONS(2377),
    [anon_sym_SLASH_EQ] = ACTIONS(2377),
    [anon_sym_PERCENT_EQ] = ACTIONS(2377),
    [anon_sym_LT_LT_EQ] = ACTIONS(2377),
    [anon_sym_GT_GT_EQ] = ACTIONS(2377),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2377),
    [anon_sym_AMP_EQ] = ACTIONS(2377),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2377),
    [anon_sym_PLUS_EQ] = ACTIONS(2377),
    [anon_sym_DASH_EQ] = ACTIONS(2377),
    [anon_sym_PIPE_EQ] = ACTIONS(2377),
    [anon_sym_CARET_EQ] = ACTIONS(2377),
    [anon_sym_COLON_EQ] = ACTIONS(2377),
    [anon_sym_lock] = ACTIONS(2377),
    [anon_sym_rlock] = ACTIONS(2377),
    [anon_sym_unsafe] = ACTIONS(2377),
    [anon_sym_sql] = ACTIONS(2377),
    [sym_int_literal] = ACTIONS(2377),
    [sym_float_literal] = ACTIONS(2377),
    [sym_rune_literal] = ACTIONS(2377),
    [anon_sym_SQUOTE] = ACTIONS(2377),
    [anon_sym_DQUOTE] = ACTIONS(2377),
    [anon_sym_c_SQUOTE] = ACTIONS(2377),
    [anon_sym_c_DQUOTE] = ACTIONS(2377),
    [anon_sym_r_SQUOTE] = ACTIONS(2377),
    [anon_sym_r_DQUOTE] = ACTIONS(2377),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2377),
    [anon_sym_shared] = ACTIONS(2377),
    [anon_sym_map_LBRACK] = ACTIONS(2377),
    [anon_sym_chan] = ACTIONS(2377),
    [anon_sym_thread] = ACTIONS(2377),
    [anon_sym_atomic] = ACTIONS(2377),
    [anon_sym_assert] = ACTIONS(2377),
    [anon_sym_defer] = ACTIONS(2377),
    [anon_sym_goto] = ACTIONS(2377),
    [anon_sym_break] = ACTIONS(2377),
    [anon_sym_continue] = ACTIONS(2377),
    [anon_sym_return] = ACTIONS(2377),
    [anon_sym_DOLLARfor] = ACTIONS(2377),
    [anon_sym_for] = ACTIONS(2377),
    [anon_sym_POUND] = ACTIONS(2377),
    [anon_sym_asm] = ACTIONS(2377),
  },
  [1035] = {
    [sym_line_comment] = STATE(1035),
    [sym_block_comment] = STATE(1035),
    [sym_identifier] = ACTIONS(3280),
    [anon_sym_LF] = ACTIONS(3280),
    [anon_sym_CR] = ACTIONS(3280),
    [anon_sym_CR_LF] = ACTIONS(3280),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3280),
    [anon_sym_DOT] = ACTIONS(3280),
    [anon_sym_as] = ACTIONS(3280),
    [anon_sym_LBRACE] = ACTIONS(3280),
    [anon_sym_COMMA] = ACTIONS(3280),
    [anon_sym_RBRACE] = ACTIONS(3280),
    [anon_sym_LPAREN] = ACTIONS(3280),
    [anon_sym_EQ] = ACTIONS(3280),
    [anon_sym_fn] = ACTIONS(3280),
    [anon_sym_PLUS] = ACTIONS(3280),
    [anon_sym_DASH] = ACTIONS(3280),
    [anon_sym_STAR] = ACTIONS(3280),
    [anon_sym_SLASH] = ACTIONS(3280),
    [anon_sym_PERCENT] = ACTIONS(3280),
    [anon_sym_LT] = ACTIONS(3280),
    [anon_sym_GT] = ACTIONS(3280),
    [anon_sym_EQ_EQ] = ACTIONS(3280),
    [anon_sym_BANG_EQ] = ACTIONS(3280),
    [anon_sym_LT_EQ] = ACTIONS(3280),
    [anon_sym_GT_EQ] = ACTIONS(3280),
    [anon_sym_LBRACK] = ACTIONS(3278),
    [anon_sym_struct] = ACTIONS(3280),
    [anon_sym_mut] = ACTIONS(3280),
    [anon_sym_COLON] = ACTIONS(3280),
    [anon_sym_PLUS_PLUS] = ACTIONS(3280),
    [anon_sym_DASH_DASH] = ACTIONS(3280),
    [anon_sym_QMARK] = ACTIONS(3280),
    [anon_sym_BANG] = ACTIONS(3280),
    [anon_sym_go] = ACTIONS(3280),
    [anon_sym_spawn] = ACTIONS(3280),
    [anon_sym_json_DOTdecode] = ACTIONS(3280),
    [anon_sym_PIPE] = ACTIONS(3280),
    [anon_sym_LBRACK2] = ACTIONS(3280),
    [anon_sym_TILDE] = ACTIONS(3280),
    [anon_sym_CARET] = ACTIONS(3280),
    [anon_sym_AMP] = ACTIONS(3280),
    [anon_sym_LT_DASH] = ACTIONS(3280),
    [anon_sym_LT_LT] = ACTIONS(3280),
    [anon_sym_GT_GT] = ACTIONS(3280),
    [anon_sym_GT_GT_GT] = ACTIONS(3280),
    [anon_sym_AMP_CARET] = ACTIONS(3280),
    [anon_sym_AMP_AMP] = ACTIONS(3280),
    [anon_sym_PIPE_PIPE] = ACTIONS(3280),
    [anon_sym_or] = ACTIONS(3280),
    [sym_none] = ACTIONS(3280),
    [sym_true] = ACTIONS(3280),
    [sym_false] = ACTIONS(3280),
    [sym_nil] = ACTIONS(3280),
    [anon_sym_QMARK_DOT] = ACTIONS(3280),
    [anon_sym_POUND_LBRACK] = ACTIONS(3280),
    [anon_sym_if] = ACTIONS(3280),
    [anon_sym_DOLLARif] = ACTIONS(3280),
    [anon_sym_is] = ACTIONS(3280),
    [anon_sym_BANGis] = ACTIONS(3280),
    [anon_sym_in] = ACTIONS(3280),
    [anon_sym_BANGin] = ACTIONS(3280),
    [anon_sym_match] = ACTIONS(3280),
    [anon_sym_select] = ACTIONS(3280),
    [anon_sym_STAR_EQ] = ACTIONS(3280),
    [anon_sym_SLASH_EQ] = ACTIONS(3280),
    [anon_sym_PERCENT_EQ] = ACTIONS(3280),
    [anon_sym_LT_LT_EQ] = ACTIONS(3280),
    [anon_sym_GT_GT_EQ] = ACTIONS(3280),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3280),
    [anon_sym_AMP_EQ] = ACTIONS(3280),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3280),
    [anon_sym_PLUS_EQ] = ACTIONS(3280),
    [anon_sym_DASH_EQ] = ACTIONS(3280),
    [anon_sym_PIPE_EQ] = ACTIONS(3280),
    [anon_sym_CARET_EQ] = ACTIONS(3280),
    [anon_sym_COLON_EQ] = ACTIONS(3280),
    [anon_sym_lock] = ACTIONS(3280),
    [anon_sym_rlock] = ACTIONS(3280),
    [anon_sym_unsafe] = ACTIONS(3280),
    [anon_sym_sql] = ACTIONS(3280),
    [sym_int_literal] = ACTIONS(3280),
    [sym_float_literal] = ACTIONS(3280),
    [sym_rune_literal] = ACTIONS(3280),
    [anon_sym_SQUOTE] = ACTIONS(3280),
    [anon_sym_DQUOTE] = ACTIONS(3280),
    [anon_sym_c_SQUOTE] = ACTIONS(3280),
    [anon_sym_c_DQUOTE] = ACTIONS(3280),
    [anon_sym_r_SQUOTE] = ACTIONS(3280),
    [anon_sym_r_DQUOTE] = ACTIONS(3280),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3280),
    [anon_sym_shared] = ACTIONS(3280),
    [anon_sym_map_LBRACK] = ACTIONS(3280),
    [anon_sym_chan] = ACTIONS(3280),
    [anon_sym_thread] = ACTIONS(3280),
    [anon_sym_atomic] = ACTIONS(3280),
    [anon_sym_assert] = ACTIONS(3280),
    [anon_sym_defer] = ACTIONS(3280),
    [anon_sym_goto] = ACTIONS(3280),
    [anon_sym_break] = ACTIONS(3280),
    [anon_sym_continue] = ACTIONS(3280),
    [anon_sym_return] = ACTIONS(3280),
    [anon_sym_DOLLARfor] = ACTIONS(3280),
    [anon_sym_for] = ACTIONS(3280),
    [anon_sym_POUND] = ACTIONS(3280),
    [anon_sym_asm] = ACTIONS(3280),
  },
  [1036] = {
    [sym_line_comment] = STATE(1036),
    [sym_block_comment] = STATE(1036),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_LF] = ACTIONS(2951),
    [anon_sym_CR] = ACTIONS(2951),
    [anon_sym_CR_LF] = ACTIONS(2951),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym_DOT] = ACTIONS(2951),
    [anon_sym_as] = ACTIONS(2951),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_RBRACE] = ACTIONS(2951),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_EQ] = ACTIONS(2951),
    [anon_sym_fn] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_LT] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2949),
    [anon_sym_struct] = ACTIONS(2951),
    [anon_sym_mut] = ACTIONS(2951),
    [anon_sym_COLON] = ACTIONS(2951),
    [anon_sym_PLUS_PLUS] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2951),
    [anon_sym_QMARK] = ACTIONS(2951),
    [anon_sym_BANG] = ACTIONS(2951),
    [anon_sym_go] = ACTIONS(2951),
    [anon_sym_spawn] = ACTIONS(2951),
    [anon_sym_json_DOTdecode] = ACTIONS(2951),
    [anon_sym_PIPE] = ACTIONS(2951),
    [anon_sym_LBRACK2] = ACTIONS(2951),
    [anon_sym_TILDE] = ACTIONS(2951),
    [anon_sym_CARET] = ACTIONS(2951),
    [anon_sym_AMP] = ACTIONS(2951),
    [anon_sym_LT_DASH] = ACTIONS(2951),
    [anon_sym_LT_LT] = ACTIONS(2951),
    [anon_sym_GT_GT] = ACTIONS(2951),
    [anon_sym_GT_GT_GT] = ACTIONS(2951),
    [anon_sym_AMP_CARET] = ACTIONS(2951),
    [anon_sym_AMP_AMP] = ACTIONS(2951),
    [anon_sym_PIPE_PIPE] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [sym_none] = ACTIONS(2951),
    [sym_true] = ACTIONS(2951),
    [sym_false] = ACTIONS(2951),
    [sym_nil] = ACTIONS(2951),
    [anon_sym_QMARK_DOT] = ACTIONS(2951),
    [anon_sym_POUND_LBRACK] = ACTIONS(2951),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_DOLLARif] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_BANGis] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_BANGin] = ACTIONS(2951),
    [anon_sym_match] = ACTIONS(2951),
    [anon_sym_select] = ACTIONS(2951),
    [anon_sym_STAR_EQ] = ACTIONS(2951),
    [anon_sym_SLASH_EQ] = ACTIONS(2951),
    [anon_sym_PERCENT_EQ] = ACTIONS(2951),
    [anon_sym_LT_LT_EQ] = ACTIONS(2951),
    [anon_sym_GT_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2951),
    [anon_sym_AMP_EQ] = ACTIONS(2951),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2951),
    [anon_sym_PLUS_EQ] = ACTIONS(2951),
    [anon_sym_DASH_EQ] = ACTIONS(2951),
    [anon_sym_PIPE_EQ] = ACTIONS(2951),
    [anon_sym_CARET_EQ] = ACTIONS(2951),
    [anon_sym_COLON_EQ] = ACTIONS(2951),
    [anon_sym_lock] = ACTIONS(2951),
    [anon_sym_rlock] = ACTIONS(2951),
    [anon_sym_unsafe] = ACTIONS(2951),
    [anon_sym_sql] = ACTIONS(2951),
    [sym_int_literal] = ACTIONS(2951),
    [sym_float_literal] = ACTIONS(2951),
    [sym_rune_literal] = ACTIONS(2951),
    [anon_sym_SQUOTE] = ACTIONS(2951),
    [anon_sym_DQUOTE] = ACTIONS(2951),
    [anon_sym_c_SQUOTE] = ACTIONS(2951),
    [anon_sym_c_DQUOTE] = ACTIONS(2951),
    [anon_sym_r_SQUOTE] = ACTIONS(2951),
    [anon_sym_r_DQUOTE] = ACTIONS(2951),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2951),
    [anon_sym_shared] = ACTIONS(2951),
    [anon_sym_map_LBRACK] = ACTIONS(2951),
    [anon_sym_chan] = ACTIONS(2951),
    [anon_sym_thread] = ACTIONS(2951),
    [anon_sym_atomic] = ACTIONS(2951),
    [anon_sym_assert] = ACTIONS(2951),
    [anon_sym_defer] = ACTIONS(2951),
    [anon_sym_goto] = ACTIONS(2951),
    [anon_sym_break] = ACTIONS(2951),
    [anon_sym_continue] = ACTIONS(2951),
    [anon_sym_return] = ACTIONS(2951),
    [anon_sym_DOLLARfor] = ACTIONS(2951),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_POUND] = ACTIONS(2951),
    [anon_sym_asm] = ACTIONS(2951),
  },
  [1037] = {
    [sym_line_comment] = STATE(1037),
    [sym_block_comment] = STATE(1037),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_LF] = ACTIONS(2841),
    [anon_sym_CR] = ACTIONS(2841),
    [anon_sym_CR_LF] = ACTIONS(2841),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym_DOT] = ACTIONS(2841),
    [anon_sym_as] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_RBRACE] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2841),
    [anon_sym_EQ] = ACTIONS(2841),
    [anon_sym_fn] = ACTIONS(2841),
    [anon_sym_PLUS] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(2841),
    [anon_sym_SLASH] = ACTIONS(2841),
    [anon_sym_PERCENT] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_GT] = ACTIONS(2841),
    [anon_sym_EQ_EQ] = ACTIONS(2841),
    [anon_sym_BANG_EQ] = ACTIONS(2841),
    [anon_sym_LT_EQ] = ACTIONS(2841),
    [anon_sym_GT_EQ] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_struct] = ACTIONS(2841),
    [anon_sym_mut] = ACTIONS(2841),
    [anon_sym_COLON] = ACTIONS(2841),
    [anon_sym_PLUS_PLUS] = ACTIONS(2841),
    [anon_sym_DASH_DASH] = ACTIONS(2841),
    [anon_sym_QMARK] = ACTIONS(2841),
    [anon_sym_BANG] = ACTIONS(2841),
    [anon_sym_go] = ACTIONS(2841),
    [anon_sym_spawn] = ACTIONS(2841),
    [anon_sym_json_DOTdecode] = ACTIONS(2841),
    [anon_sym_PIPE] = ACTIONS(2841),
    [anon_sym_LBRACK2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2841),
    [anon_sym_LT_DASH] = ACTIONS(2841),
    [anon_sym_LT_LT] = ACTIONS(2841),
    [anon_sym_GT_GT] = ACTIONS(2841),
    [anon_sym_GT_GT_GT] = ACTIONS(2841),
    [anon_sym_AMP_CARET] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_PIPE_PIPE] = ACTIONS(2841),
    [anon_sym_or] = ACTIONS(2841),
    [sym_none] = ACTIONS(2841),
    [sym_true] = ACTIONS(2841),
    [sym_false] = ACTIONS(2841),
    [sym_nil] = ACTIONS(2841),
    [anon_sym_QMARK_DOT] = ACTIONS(2841),
    [anon_sym_POUND_LBRACK] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2841),
    [anon_sym_DOLLARif] = ACTIONS(2841),
    [anon_sym_is] = ACTIONS(2841),
    [anon_sym_BANGis] = ACTIONS(2841),
    [anon_sym_in] = ACTIONS(2841),
    [anon_sym_BANGin] = ACTIONS(2841),
    [anon_sym_match] = ACTIONS(2841),
    [anon_sym_select] = ACTIONS(2841),
    [anon_sym_STAR_EQ] = ACTIONS(2841),
    [anon_sym_SLASH_EQ] = ACTIONS(2841),
    [anon_sym_PERCENT_EQ] = ACTIONS(2841),
    [anon_sym_LT_LT_EQ] = ACTIONS(2841),
    [anon_sym_GT_GT_EQ] = ACTIONS(2841),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2841),
    [anon_sym_AMP_EQ] = ACTIONS(2841),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2841),
    [anon_sym_PLUS_EQ] = ACTIONS(2841),
    [anon_sym_DASH_EQ] = ACTIONS(2841),
    [anon_sym_PIPE_EQ] = ACTIONS(2841),
    [anon_sym_CARET_EQ] = ACTIONS(2841),
    [anon_sym_COLON_EQ] = ACTIONS(2841),
    [anon_sym_lock] = ACTIONS(2841),
    [anon_sym_rlock] = ACTIONS(2841),
    [anon_sym_unsafe] = ACTIONS(2841),
    [anon_sym_sql] = ACTIONS(2841),
    [sym_int_literal] = ACTIONS(2841),
    [sym_float_literal] = ACTIONS(2841),
    [sym_rune_literal] = ACTIONS(2841),
    [anon_sym_SQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE] = ACTIONS(2841),
    [anon_sym_c_SQUOTE] = ACTIONS(2841),
    [anon_sym_c_DQUOTE] = ACTIONS(2841),
    [anon_sym_r_SQUOTE] = ACTIONS(2841),
    [anon_sym_r_DQUOTE] = ACTIONS(2841),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2841),
    [anon_sym_shared] = ACTIONS(2841),
    [anon_sym_map_LBRACK] = ACTIONS(2841),
    [anon_sym_chan] = ACTIONS(2841),
    [anon_sym_thread] = ACTIONS(2841),
    [anon_sym_atomic] = ACTIONS(2841),
    [anon_sym_assert] = ACTIONS(2841),
    [anon_sym_defer] = ACTIONS(2841),
    [anon_sym_goto] = ACTIONS(2841),
    [anon_sym_break] = ACTIONS(2841),
    [anon_sym_continue] = ACTIONS(2841),
    [anon_sym_return] = ACTIONS(2841),
    [anon_sym_DOLLARfor] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2841),
    [anon_sym_POUND] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2841),
  },
  [1038] = {
    [sym_line_comment] = STATE(1038),
    [sym_block_comment] = STATE(1038),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_CR] = ACTIONS(2147),
    [anon_sym_CR_LF] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2335),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_COMMA] = ACTIONS(2335),
    [anon_sym_RBRACE] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym_EQ] = ACTIONS(2335),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2335),
    [anon_sym_PERCENT] = ACTIONS(2335),
    [anon_sym_LT] = ACTIONS(2335),
    [anon_sym_GT] = ACTIONS(2335),
    [anon_sym_EQ_EQ] = ACTIONS(2335),
    [anon_sym_BANG_EQ] = ACTIONS(2335),
    [anon_sym_LT_EQ] = ACTIONS(2335),
    [anon_sym_GT_EQ] = ACTIONS(2335),
    [anon_sym_LBRACK] = ACTIONS(2337),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_COLON] = ACTIONS(2335),
    [anon_sym_PLUS_PLUS] = ACTIONS(2335),
    [anon_sym_DASH_DASH] = ACTIONS(2335),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2147),
    [anon_sym_PIPE] = ACTIONS(2335),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2335),
    [anon_sym_GT_GT] = ACTIONS(2335),
    [anon_sym_GT_GT_GT] = ACTIONS(2335),
    [anon_sym_AMP_CARET] = ACTIONS(2335),
    [anon_sym_AMP_AMP] = ACTIONS(2335),
    [anon_sym_PIPE_PIPE] = ACTIONS(2335),
    [anon_sym_or] = ACTIONS(2335),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2335),
    [anon_sym_POUND_LBRACK] = ACTIONS(2335),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2335),
    [anon_sym_BANGis] = ACTIONS(2335),
    [anon_sym_in] = ACTIONS(2335),
    [anon_sym_BANGin] = ACTIONS(2335),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_STAR_EQ] = ACTIONS(2335),
    [anon_sym_SLASH_EQ] = ACTIONS(2335),
    [anon_sym_PERCENT_EQ] = ACTIONS(2335),
    [anon_sym_LT_LT_EQ] = ACTIONS(2335),
    [anon_sym_GT_GT_EQ] = ACTIONS(2335),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2335),
    [anon_sym_AMP_EQ] = ACTIONS(2335),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2335),
    [anon_sym_PLUS_EQ] = ACTIONS(2335),
    [anon_sym_DASH_EQ] = ACTIONS(2335),
    [anon_sym_PIPE_EQ] = ACTIONS(2335),
    [anon_sym_CARET_EQ] = ACTIONS(2335),
    [anon_sym_COLON_EQ] = ACTIONS(2335),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2147),
    [sym_rune_literal] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_c_SQUOTE] = ACTIONS(2147),
    [anon_sym_c_DQUOTE] = ACTIONS(2147),
    [anon_sym_r_SQUOTE] = ACTIONS(2147),
    [anon_sym_r_DQUOTE] = ACTIONS(2147),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2147),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
    [anon_sym_assert] = ACTIONS(2147),
    [anon_sym_defer] = ACTIONS(2147),
    [anon_sym_goto] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_continue] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2147),
    [anon_sym_DOLLARfor] = ACTIONS(2147),
    [anon_sym_for] = ACTIONS(2147),
    [anon_sym_POUND] = ACTIONS(2147),
    [anon_sym_asm] = ACTIONS(2147),
  },
  [1039] = {
    [sym_line_comment] = STATE(1039),
    [sym_block_comment] = STATE(1039),
    [sym_identifier] = ACTIONS(2929),
    [anon_sym_LF] = ACTIONS(2929),
    [anon_sym_CR] = ACTIONS(2929),
    [anon_sym_CR_LF] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2929),
    [anon_sym_DOT] = ACTIONS(2929),
    [anon_sym_as] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2929),
    [anon_sym_COMMA] = ACTIONS(2929),
    [anon_sym_RBRACE] = ACTIONS(2929),
    [anon_sym_LPAREN] = ACTIONS(2929),
    [anon_sym_EQ] = ACTIONS(2929),
    [anon_sym_fn] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2929),
    [anon_sym_GT] = ACTIONS(2929),
    [anon_sym_EQ_EQ] = ACTIONS(2929),
    [anon_sym_BANG_EQ] = ACTIONS(2929),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2929),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2929),
    [anon_sym_mut] = ACTIONS(2929),
    [anon_sym_COLON] = ACTIONS(2929),
    [anon_sym_PLUS_PLUS] = ACTIONS(2929),
    [anon_sym_DASH_DASH] = ACTIONS(2929),
    [anon_sym_QMARK] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2929),
    [anon_sym_go] = ACTIONS(2929),
    [anon_sym_spawn] = ACTIONS(2929),
    [anon_sym_json_DOTdecode] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(2929),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2929),
    [anon_sym_CARET] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_LT_DASH] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(2929),
    [anon_sym_GT_GT] = ACTIONS(2929),
    [anon_sym_GT_GT_GT] = ACTIONS(2929),
    [anon_sym_AMP_CARET] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_or] = ACTIONS(2929),
    [sym_none] = ACTIONS(2929),
    [sym_true] = ACTIONS(2929),
    [sym_false] = ACTIONS(2929),
    [sym_nil] = ACTIONS(2929),
    [anon_sym_QMARK_DOT] = ACTIONS(2929),
    [anon_sym_POUND_LBRACK] = ACTIONS(2929),
    [anon_sym_if] = ACTIONS(2929),
    [anon_sym_DOLLARif] = ACTIONS(2929),
    [anon_sym_is] = ACTIONS(2929),
    [anon_sym_BANGis] = ACTIONS(2929),
    [anon_sym_in] = ACTIONS(2929),
    [anon_sym_BANGin] = ACTIONS(2929),
    [anon_sym_match] = ACTIONS(2929),
    [anon_sym_select] = ACTIONS(2929),
    [anon_sym_STAR_EQ] = ACTIONS(2929),
    [anon_sym_SLASH_EQ] = ACTIONS(2929),
    [anon_sym_PERCENT_EQ] = ACTIONS(2929),
    [anon_sym_LT_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_GT_EQ] = ACTIONS(2929),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2929),
    [anon_sym_AMP_EQ] = ACTIONS(2929),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2929),
    [anon_sym_PLUS_EQ] = ACTIONS(2929),
    [anon_sym_DASH_EQ] = ACTIONS(2929),
    [anon_sym_PIPE_EQ] = ACTIONS(2929),
    [anon_sym_CARET_EQ] = ACTIONS(2929),
    [anon_sym_COLON_EQ] = ACTIONS(2929),
    [anon_sym_lock] = ACTIONS(2929),
    [anon_sym_rlock] = ACTIONS(2929),
    [anon_sym_unsafe] = ACTIONS(2929),
    [anon_sym_sql] = ACTIONS(2929),
    [sym_int_literal] = ACTIONS(2929),
    [sym_float_literal] = ACTIONS(2929),
    [sym_rune_literal] = ACTIONS(2929),
    [anon_sym_SQUOTE] = ACTIONS(2929),
    [anon_sym_DQUOTE] = ACTIONS(2929),
    [anon_sym_c_SQUOTE] = ACTIONS(2929),
    [anon_sym_c_DQUOTE] = ACTIONS(2929),
    [anon_sym_r_SQUOTE] = ACTIONS(2929),
    [anon_sym_r_DQUOTE] = ACTIONS(2929),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2929),
    [anon_sym_shared] = ACTIONS(2929),
    [anon_sym_map_LBRACK] = ACTIONS(2929),
    [anon_sym_chan] = ACTIONS(2929),
    [anon_sym_thread] = ACTIONS(2929),
    [anon_sym_atomic] = ACTIONS(2929),
    [anon_sym_assert] = ACTIONS(2929),
    [anon_sym_defer] = ACTIONS(2929),
    [anon_sym_goto] = ACTIONS(2929),
    [anon_sym_break] = ACTIONS(2929),
    [anon_sym_continue] = ACTIONS(2929),
    [anon_sym_return] = ACTIONS(2929),
    [anon_sym_DOLLARfor] = ACTIONS(2929),
    [anon_sym_for] = ACTIONS(2929),
    [anon_sym_POUND] = ACTIONS(2929),
    [anon_sym_asm] = ACTIONS(2929),
  },
  [1040] = {
    [sym_line_comment] = STATE(1040),
    [sym_block_comment] = STATE(1040),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_LF] = ACTIONS(2881),
    [anon_sym_CR] = ACTIONS(2881),
    [anon_sym_CR_LF] = ACTIONS(2881),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2881),
    [anon_sym_as] = ACTIONS(2881),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_LPAREN] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2881),
    [anon_sym_fn] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_SLASH] = ACTIONS(2881),
    [anon_sym_PERCENT] = ACTIONS(2881),
    [anon_sym_LT] = ACTIONS(2881),
    [anon_sym_GT] = ACTIONS(2881),
    [anon_sym_EQ_EQ] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_LT_EQ] = ACTIONS(2881),
    [anon_sym_GT_EQ] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_struct] = ACTIONS(2881),
    [anon_sym_mut] = ACTIONS(2881),
    [anon_sym_COLON] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_go] = ACTIONS(2881),
    [anon_sym_spawn] = ACTIONS(2881),
    [anon_sym_json_DOTdecode] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2881),
    [anon_sym_LBRACK2] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_CARET] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2881),
    [anon_sym_LT_DASH] = ACTIONS(2881),
    [anon_sym_LT_LT] = ACTIONS(2881),
    [anon_sym_GT_GT] = ACTIONS(2881),
    [anon_sym_GT_GT_GT] = ACTIONS(2881),
    [anon_sym_AMP_CARET] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2881),
    [sym_none] = ACTIONS(2881),
    [sym_true] = ACTIONS(2881),
    [sym_false] = ACTIONS(2881),
    [sym_nil] = ACTIONS(2881),
    [anon_sym_QMARK_DOT] = ACTIONS(2881),
    [anon_sym_POUND_LBRACK] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_DOLLARif] = ACTIONS(2881),
    [anon_sym_is] = ACTIONS(2881),
    [anon_sym_BANGis] = ACTIONS(2881),
    [anon_sym_in] = ACTIONS(2881),
    [anon_sym_BANGin] = ACTIONS(2881),
    [anon_sym_match] = ACTIONS(2881),
    [anon_sym_select] = ACTIONS(2881),
    [anon_sym_STAR_EQ] = ACTIONS(2881),
    [anon_sym_SLASH_EQ] = ACTIONS(2881),
    [anon_sym_PERCENT_EQ] = ACTIONS(2881),
    [anon_sym_LT_LT_EQ] = ACTIONS(2881),
    [anon_sym_GT_GT_EQ] = ACTIONS(2881),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2881),
    [anon_sym_AMP_EQ] = ACTIONS(2881),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2881),
    [anon_sym_PLUS_EQ] = ACTIONS(2881),
    [anon_sym_DASH_EQ] = ACTIONS(2881),
    [anon_sym_PIPE_EQ] = ACTIONS(2881),
    [anon_sym_CARET_EQ] = ACTIONS(2881),
    [anon_sym_COLON_EQ] = ACTIONS(2881),
    [anon_sym_lock] = ACTIONS(2881),
    [anon_sym_rlock] = ACTIONS(2881),
    [anon_sym_unsafe] = ACTIONS(2881),
    [anon_sym_sql] = ACTIONS(2881),
    [sym_int_literal] = ACTIONS(2881),
    [sym_float_literal] = ACTIONS(2881),
    [sym_rune_literal] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_c_SQUOTE] = ACTIONS(2881),
    [anon_sym_c_DQUOTE] = ACTIONS(2881),
    [anon_sym_r_SQUOTE] = ACTIONS(2881),
    [anon_sym_r_DQUOTE] = ACTIONS(2881),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2881),
    [anon_sym_shared] = ACTIONS(2881),
    [anon_sym_map_LBRACK] = ACTIONS(2881),
    [anon_sym_chan] = ACTIONS(2881),
    [anon_sym_thread] = ACTIONS(2881),
    [anon_sym_atomic] = ACTIONS(2881),
    [anon_sym_assert] = ACTIONS(2881),
    [anon_sym_defer] = ACTIONS(2881),
    [anon_sym_goto] = ACTIONS(2881),
    [anon_sym_break] = ACTIONS(2881),
    [anon_sym_continue] = ACTIONS(2881),
    [anon_sym_return] = ACTIONS(2881),
    [anon_sym_DOLLARfor] = ACTIONS(2881),
    [anon_sym_for] = ACTIONS(2881),
    [anon_sym_POUND] = ACTIONS(2881),
    [anon_sym_asm] = ACTIONS(2881),
  },
  [1041] = {
    [sym_line_comment] = STATE(1041),
    [sym_block_comment] = STATE(1041),
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2373),
    [anon_sym_CR] = ACTIONS(2373),
    [anon_sym_CR_LF] = ACTIONS(2373),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_DOT] = ACTIONS(2177),
    [anon_sym_as] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2373),
    [anon_sym_COMMA] = ACTIONS(2373),
    [anon_sym_RBRACE] = ACTIONS(2373),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym_EQ] = ACTIONS(2373),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_SLASH] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2373),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_mut] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2373),
    [anon_sym_QMARK] = ACTIONS(2373),
    [anon_sym_BANG] = ACTIONS(2373),
    [anon_sym_go] = ACTIONS(2373),
    [anon_sym_spawn] = ACTIONS(2373),
    [anon_sym_json_DOTdecode] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_LBRACK2] = ACTIONS(2373),
    [anon_sym_TILDE] = ACTIONS(2373),
    [anon_sym_CARET] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_LT_DASH] = ACTIONS(2373),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2373),
    [anon_sym_AMP_CARET] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2373),
    [anon_sym_or] = ACTIONS(2373),
    [sym_none] = ACTIONS(2373),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [sym_nil] = ACTIONS(2373),
    [anon_sym_QMARK_DOT] = ACTIONS(2373),
    [anon_sym_POUND_LBRACK] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_DOLLARif] = ACTIONS(2373),
    [anon_sym_is] = ACTIONS(2373),
    [anon_sym_BANGis] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_BANGin] = ACTIONS(2373),
    [anon_sym_match] = ACTIONS(2373),
    [anon_sym_select] = ACTIONS(2373),
    [anon_sym_STAR_EQ] = ACTIONS(2373),
    [anon_sym_SLASH_EQ] = ACTIONS(2373),
    [anon_sym_PERCENT_EQ] = ACTIONS(2373),
    [anon_sym_LT_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT_GT_EQ] = ACTIONS(2373),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2373),
    [anon_sym_AMP_EQ] = ACTIONS(2373),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2373),
    [anon_sym_PLUS_EQ] = ACTIONS(2373),
    [anon_sym_DASH_EQ] = ACTIONS(2373),
    [anon_sym_PIPE_EQ] = ACTIONS(2373),
    [anon_sym_CARET_EQ] = ACTIONS(2373),
    [anon_sym_COLON_EQ] = ACTIONS(2373),
    [anon_sym_lock] = ACTIONS(2373),
    [anon_sym_rlock] = ACTIONS(2373),
    [anon_sym_unsafe] = ACTIONS(2373),
    [anon_sym_sql] = ACTIONS(2373),
    [sym_int_literal] = ACTIONS(2373),
    [sym_float_literal] = ACTIONS(2373),
    [sym_rune_literal] = ACTIONS(2373),
    [anon_sym_SQUOTE] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(2373),
    [anon_sym_c_SQUOTE] = ACTIONS(2373),
    [anon_sym_c_DQUOTE] = ACTIONS(2373),
    [anon_sym_r_SQUOTE] = ACTIONS(2373),
    [anon_sym_r_DQUOTE] = ACTIONS(2373),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_map_LBRACK] = ACTIONS(2373),
    [anon_sym_chan] = ACTIONS(2373),
    [anon_sym_thread] = ACTIONS(2373),
    [anon_sym_atomic] = ACTIONS(2373),
    [anon_sym_assert] = ACTIONS(2373),
    [anon_sym_defer] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_DOLLARfor] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_POUND] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
  },
  [1042] = {
    [sym_line_comment] = STATE(1042),
    [sym_block_comment] = STATE(1042),
    [sym_identifier] = ACTIONS(2383),
    [anon_sym_LF] = ACTIONS(2383),
    [anon_sym_CR] = ACTIONS(2383),
    [anon_sym_CR_LF] = ACTIONS(2383),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2383),
    [anon_sym_DOT] = ACTIONS(2383),
    [anon_sym_as] = ACTIONS(2383),
    [anon_sym_LBRACE] = ACTIONS(2383),
    [anon_sym_COMMA] = ACTIONS(2383),
    [anon_sym_RBRACE] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2383),
    [anon_sym_EQ] = ACTIONS(2383),
    [anon_sym_fn] = ACTIONS(2383),
    [anon_sym_PLUS] = ACTIONS(2383),
    [anon_sym_DASH] = ACTIONS(2383),
    [anon_sym_STAR] = ACTIONS(2383),
    [anon_sym_SLASH] = ACTIONS(2383),
    [anon_sym_PERCENT] = ACTIONS(2383),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_GT] = ACTIONS(2383),
    [anon_sym_EQ_EQ] = ACTIONS(2383),
    [anon_sym_BANG_EQ] = ACTIONS(2383),
    [anon_sym_LT_EQ] = ACTIONS(2383),
    [anon_sym_GT_EQ] = ACTIONS(2383),
    [anon_sym_LBRACK] = ACTIONS(2381),
    [anon_sym_struct] = ACTIONS(2383),
    [anon_sym_mut] = ACTIONS(2383),
    [anon_sym_COLON] = ACTIONS(2383),
    [anon_sym_PLUS_PLUS] = ACTIONS(2383),
    [anon_sym_DASH_DASH] = ACTIONS(2383),
    [anon_sym_QMARK] = ACTIONS(2383),
    [anon_sym_BANG] = ACTIONS(2383),
    [anon_sym_go] = ACTIONS(2383),
    [anon_sym_spawn] = ACTIONS(2383),
    [anon_sym_json_DOTdecode] = ACTIONS(2383),
    [anon_sym_PIPE] = ACTIONS(2383),
    [anon_sym_LBRACK2] = ACTIONS(2383),
    [anon_sym_TILDE] = ACTIONS(2383),
    [anon_sym_CARET] = ACTIONS(2383),
    [anon_sym_AMP] = ACTIONS(2383),
    [anon_sym_LT_DASH] = ACTIONS(2383),
    [anon_sym_LT_LT] = ACTIONS(2383),
    [anon_sym_GT_GT] = ACTIONS(2383),
    [anon_sym_GT_GT_GT] = ACTIONS(2383),
    [anon_sym_AMP_CARET] = ACTIONS(2383),
    [anon_sym_AMP_AMP] = ACTIONS(2383),
    [anon_sym_PIPE_PIPE] = ACTIONS(2383),
    [anon_sym_or] = ACTIONS(2383),
    [sym_none] = ACTIONS(2383),
    [sym_true] = ACTIONS(2383),
    [sym_false] = ACTIONS(2383),
    [sym_nil] = ACTIONS(2383),
    [anon_sym_QMARK_DOT] = ACTIONS(2383),
    [anon_sym_POUND_LBRACK] = ACTIONS(2383),
    [anon_sym_if] = ACTIONS(2383),
    [anon_sym_DOLLARif] = ACTIONS(2383),
    [anon_sym_is] = ACTIONS(2383),
    [anon_sym_BANGis] = ACTIONS(2383),
    [anon_sym_in] = ACTIONS(2383),
    [anon_sym_BANGin] = ACTIONS(2383),
    [anon_sym_match] = ACTIONS(2383),
    [anon_sym_select] = ACTIONS(2383),
    [anon_sym_STAR_EQ] = ACTIONS(2383),
    [anon_sym_SLASH_EQ] = ACTIONS(2383),
    [anon_sym_PERCENT_EQ] = ACTIONS(2383),
    [anon_sym_LT_LT_EQ] = ACTIONS(2383),
    [anon_sym_GT_GT_EQ] = ACTIONS(2383),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2383),
    [anon_sym_AMP_EQ] = ACTIONS(2383),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2383),
    [anon_sym_PLUS_EQ] = ACTIONS(2383),
    [anon_sym_DASH_EQ] = ACTIONS(2383),
    [anon_sym_PIPE_EQ] = ACTIONS(2383),
    [anon_sym_CARET_EQ] = ACTIONS(2383),
    [anon_sym_COLON_EQ] = ACTIONS(2383),
    [anon_sym_lock] = ACTIONS(2383),
    [anon_sym_rlock] = ACTIONS(2383),
    [anon_sym_unsafe] = ACTIONS(2383),
    [anon_sym_sql] = ACTIONS(2383),
    [sym_int_literal] = ACTIONS(2383),
    [sym_float_literal] = ACTIONS(2383),
    [sym_rune_literal] = ACTIONS(2383),
    [anon_sym_SQUOTE] = ACTIONS(2383),
    [anon_sym_DQUOTE] = ACTIONS(2383),
    [anon_sym_c_SQUOTE] = ACTIONS(2383),
    [anon_sym_c_DQUOTE] = ACTIONS(2383),
    [anon_sym_r_SQUOTE] = ACTIONS(2383),
    [anon_sym_r_DQUOTE] = ACTIONS(2383),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2383),
    [anon_sym_shared] = ACTIONS(2383),
    [anon_sym_map_LBRACK] = ACTIONS(2383),
    [anon_sym_chan] = ACTIONS(2383),
    [anon_sym_thread] = ACTIONS(2383),
    [anon_sym_atomic] = ACTIONS(2383),
    [anon_sym_assert] = ACTIONS(2383),
    [anon_sym_defer] = ACTIONS(2383),
    [anon_sym_goto] = ACTIONS(2383),
    [anon_sym_break] = ACTIONS(2383),
    [anon_sym_continue] = ACTIONS(2383),
    [anon_sym_return] = ACTIONS(2383),
    [anon_sym_DOLLARfor] = ACTIONS(2383),
    [anon_sym_for] = ACTIONS(2383),
    [anon_sym_POUND] = ACTIONS(2383),
    [anon_sym_asm] = ACTIONS(2383),
  },
  [1043] = {
    [sym_line_comment] = STATE(1043),
    [sym_block_comment] = STATE(1043),
    [sym_identifier] = ACTIONS(2639),
    [anon_sym_LF] = ACTIONS(2639),
    [anon_sym_CR] = ACTIONS(2639),
    [anon_sym_CR_LF] = ACTIONS(2639),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym_DOT] = ACTIONS(2639),
    [anon_sym_as] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2639),
    [anon_sym_COMMA] = ACTIONS(2639),
    [anon_sym_RBRACE] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(2639),
    [anon_sym_EQ] = ACTIONS(2639),
    [anon_sym_fn] = ACTIONS(2639),
    [anon_sym_PLUS] = ACTIONS(2639),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_SLASH] = ACTIONS(2639),
    [anon_sym_PERCENT] = ACTIONS(2639),
    [anon_sym_LT] = ACTIONS(2639),
    [anon_sym_GT] = ACTIONS(2639),
    [anon_sym_EQ_EQ] = ACTIONS(2639),
    [anon_sym_BANG_EQ] = ACTIONS(2639),
    [anon_sym_LT_EQ] = ACTIONS(2639),
    [anon_sym_GT_EQ] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_mut] = ACTIONS(2639),
    [anon_sym_COLON] = ACTIONS(2639),
    [anon_sym_PLUS_PLUS] = ACTIONS(2639),
    [anon_sym_DASH_DASH] = ACTIONS(2639),
    [anon_sym_QMARK] = ACTIONS(2639),
    [anon_sym_BANG] = ACTIONS(2639),
    [anon_sym_go] = ACTIONS(2639),
    [anon_sym_spawn] = ACTIONS(2639),
    [anon_sym_json_DOTdecode] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_LBRACK2] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_LT_DASH] = ACTIONS(2639),
    [anon_sym_LT_LT] = ACTIONS(2639),
    [anon_sym_GT_GT] = ACTIONS(2639),
    [anon_sym_GT_GT_GT] = ACTIONS(2639),
    [anon_sym_AMP_CARET] = ACTIONS(2639),
    [anon_sym_AMP_AMP] = ACTIONS(2639),
    [anon_sym_PIPE_PIPE] = ACTIONS(2639),
    [anon_sym_or] = ACTIONS(2639),
    [sym_none] = ACTIONS(2639),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [sym_nil] = ACTIONS(2639),
    [anon_sym_QMARK_DOT] = ACTIONS(2639),
    [anon_sym_POUND_LBRACK] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2639),
    [anon_sym_DOLLARif] = ACTIONS(2639),
    [anon_sym_is] = ACTIONS(2639),
    [anon_sym_BANGis] = ACTIONS(2639),
    [anon_sym_in] = ACTIONS(2639),
    [anon_sym_BANGin] = ACTIONS(2639),
    [anon_sym_match] = ACTIONS(2639),
    [anon_sym_select] = ACTIONS(2639),
    [anon_sym_STAR_EQ] = ACTIONS(2639),
    [anon_sym_SLASH_EQ] = ACTIONS(2639),
    [anon_sym_PERCENT_EQ] = ACTIONS(2639),
    [anon_sym_LT_LT_EQ] = ACTIONS(2639),
    [anon_sym_GT_GT_EQ] = ACTIONS(2639),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2639),
    [anon_sym_AMP_EQ] = ACTIONS(2639),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2639),
    [anon_sym_PLUS_EQ] = ACTIONS(2639),
    [anon_sym_DASH_EQ] = ACTIONS(2639),
    [anon_sym_PIPE_EQ] = ACTIONS(2639),
    [anon_sym_CARET_EQ] = ACTIONS(2639),
    [anon_sym_COLON_EQ] = ACTIONS(2639),
    [anon_sym_lock] = ACTIONS(2639),
    [anon_sym_rlock] = ACTIONS(2639),
    [anon_sym_unsafe] = ACTIONS(2639),
    [anon_sym_sql] = ACTIONS(2639),
    [sym_int_literal] = ACTIONS(2639),
    [sym_float_literal] = ACTIONS(2639),
    [sym_rune_literal] = ACTIONS(2639),
    [anon_sym_SQUOTE] = ACTIONS(2639),
    [anon_sym_DQUOTE] = ACTIONS(2639),
    [anon_sym_c_SQUOTE] = ACTIONS(2639),
    [anon_sym_c_DQUOTE] = ACTIONS(2639),
    [anon_sym_r_SQUOTE] = ACTIONS(2639),
    [anon_sym_r_DQUOTE] = ACTIONS(2639),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2639),
    [anon_sym_shared] = ACTIONS(2639),
    [anon_sym_map_LBRACK] = ACTIONS(2639),
    [anon_sym_chan] = ACTIONS(2639),
    [anon_sym_thread] = ACTIONS(2639),
    [anon_sym_atomic] = ACTIONS(2639),
    [anon_sym_assert] = ACTIONS(2639),
    [anon_sym_defer] = ACTIONS(2639),
    [anon_sym_goto] = ACTIONS(2639),
    [anon_sym_break] = ACTIONS(2639),
    [anon_sym_continue] = ACTIONS(2639),
    [anon_sym_return] = ACTIONS(2639),
    [anon_sym_DOLLARfor] = ACTIONS(2639),
    [anon_sym_for] = ACTIONS(2639),
    [anon_sym_POUND] = ACTIONS(2639),
    [anon_sym_asm] = ACTIONS(2639),
  },
  [1044] = {
    [sym_line_comment] = STATE(1044),
    [sym_block_comment] = STATE(1044),
    [sym_identifier] = ACTIONS(2631),
    [anon_sym_LF] = ACTIONS(2631),
    [anon_sym_CR] = ACTIONS(2631),
    [anon_sym_CR_LF] = ACTIONS(2631),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2631),
    [anon_sym_DOT] = ACTIONS(2631),
    [anon_sym_as] = ACTIONS(2631),
    [anon_sym_LBRACE] = ACTIONS(2631),
    [anon_sym_COMMA] = ACTIONS(2631),
    [anon_sym_RBRACE] = ACTIONS(2631),
    [anon_sym_LPAREN] = ACTIONS(2631),
    [anon_sym_EQ] = ACTIONS(2631),
    [anon_sym_fn] = ACTIONS(2631),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_DASH] = ACTIONS(2631),
    [anon_sym_STAR] = ACTIONS(2631),
    [anon_sym_SLASH] = ACTIONS(2631),
    [anon_sym_PERCENT] = ACTIONS(2631),
    [anon_sym_LT] = ACTIONS(2631),
    [anon_sym_GT] = ACTIONS(2631),
    [anon_sym_EQ_EQ] = ACTIONS(2631),
    [anon_sym_BANG_EQ] = ACTIONS(2631),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LBRACK] = ACTIONS(2629),
    [anon_sym_struct] = ACTIONS(2631),
    [anon_sym_mut] = ACTIONS(2631),
    [anon_sym_COLON] = ACTIONS(2631),
    [anon_sym_PLUS_PLUS] = ACTIONS(2631),
    [anon_sym_DASH_DASH] = ACTIONS(2631),
    [anon_sym_QMARK] = ACTIONS(2631),
    [anon_sym_BANG] = ACTIONS(2631),
    [anon_sym_go] = ACTIONS(2631),
    [anon_sym_spawn] = ACTIONS(2631),
    [anon_sym_json_DOTdecode] = ACTIONS(2631),
    [anon_sym_PIPE] = ACTIONS(2631),
    [anon_sym_LBRACK2] = ACTIONS(2631),
    [anon_sym_TILDE] = ACTIONS(2631),
    [anon_sym_CARET] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2631),
    [anon_sym_LT_DASH] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2631),
    [anon_sym_GT_GT] = ACTIONS(2631),
    [anon_sym_GT_GT_GT] = ACTIONS(2631),
    [anon_sym_AMP_CARET] = ACTIONS(2631),
    [anon_sym_AMP_AMP] = ACTIONS(2631),
    [anon_sym_PIPE_PIPE] = ACTIONS(2631),
    [anon_sym_or] = ACTIONS(2631),
    [sym_none] = ACTIONS(2631),
    [sym_true] = ACTIONS(2631),
    [sym_false] = ACTIONS(2631),
    [sym_nil] = ACTIONS(2631),
    [anon_sym_QMARK_DOT] = ACTIONS(2631),
    [anon_sym_POUND_LBRACK] = ACTIONS(2631),
    [anon_sym_if] = ACTIONS(2631),
    [anon_sym_DOLLARif] = ACTIONS(2631),
    [anon_sym_is] = ACTIONS(2631),
    [anon_sym_BANGis] = ACTIONS(2631),
    [anon_sym_in] = ACTIONS(2631),
    [anon_sym_BANGin] = ACTIONS(2631),
    [anon_sym_match] = ACTIONS(2631),
    [anon_sym_select] = ACTIONS(2631),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_COLON_EQ] = ACTIONS(2631),
    [anon_sym_lock] = ACTIONS(2631),
    [anon_sym_rlock] = ACTIONS(2631),
    [anon_sym_unsafe] = ACTIONS(2631),
    [anon_sym_sql] = ACTIONS(2631),
    [sym_int_literal] = ACTIONS(2631),
    [sym_float_literal] = ACTIONS(2631),
    [sym_rune_literal] = ACTIONS(2631),
    [anon_sym_SQUOTE] = ACTIONS(2631),
    [anon_sym_DQUOTE] = ACTIONS(2631),
    [anon_sym_c_SQUOTE] = ACTIONS(2631),
    [anon_sym_c_DQUOTE] = ACTIONS(2631),
    [anon_sym_r_SQUOTE] = ACTIONS(2631),
    [anon_sym_r_DQUOTE] = ACTIONS(2631),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2631),
    [anon_sym_shared] = ACTIONS(2631),
    [anon_sym_map_LBRACK] = ACTIONS(2631),
    [anon_sym_chan] = ACTIONS(2631),
    [anon_sym_thread] = ACTIONS(2631),
    [anon_sym_atomic] = ACTIONS(2631),
    [anon_sym_assert] = ACTIONS(2631),
    [anon_sym_defer] = ACTIONS(2631),
    [anon_sym_goto] = ACTIONS(2631),
    [anon_sym_break] = ACTIONS(2631),
    [anon_sym_continue] = ACTIONS(2631),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_DOLLARfor] = ACTIONS(2631),
    [anon_sym_for] = ACTIONS(2631),
    [anon_sym_POUND] = ACTIONS(2631),
    [anon_sym_asm] = ACTIONS(2631),
  },
  [1045] = {
    [sym_line_comment] = STATE(1045),
    [sym_block_comment] = STATE(1045),
    [sym_identifier] = ACTIONS(2697),
    [anon_sym_LF] = ACTIONS(2697),
    [anon_sym_CR] = ACTIONS(2697),
    [anon_sym_CR_LF] = ACTIONS(2697),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2697),
    [anon_sym_DOT] = ACTIONS(2697),
    [anon_sym_as] = ACTIONS(2697),
    [anon_sym_LBRACE] = ACTIONS(2697),
    [anon_sym_COMMA] = ACTIONS(2697),
    [anon_sym_RBRACE] = ACTIONS(2697),
    [anon_sym_LPAREN] = ACTIONS(2697),
    [anon_sym_EQ] = ACTIONS(2697),
    [anon_sym_fn] = ACTIONS(2697),
    [anon_sym_PLUS] = ACTIONS(2697),
    [anon_sym_DASH] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2697),
    [anon_sym_SLASH] = ACTIONS(2697),
    [anon_sym_PERCENT] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2697),
    [anon_sym_GT] = ACTIONS(2697),
    [anon_sym_EQ_EQ] = ACTIONS(2697),
    [anon_sym_BANG_EQ] = ACTIONS(2697),
    [anon_sym_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT_EQ] = ACTIONS(2697),
    [anon_sym_LBRACK] = ACTIONS(2695),
    [anon_sym_struct] = ACTIONS(2697),
    [anon_sym_mut] = ACTIONS(2697),
    [anon_sym_COLON] = ACTIONS(2697),
    [anon_sym_PLUS_PLUS] = ACTIONS(2697),
    [anon_sym_DASH_DASH] = ACTIONS(2697),
    [anon_sym_QMARK] = ACTIONS(2697),
    [anon_sym_BANG] = ACTIONS(3802),
    [anon_sym_go] = ACTIONS(2697),
    [anon_sym_spawn] = ACTIONS(2697),
    [anon_sym_json_DOTdecode] = ACTIONS(2697),
    [anon_sym_PIPE] = ACTIONS(2697),
    [anon_sym_LBRACK2] = ACTIONS(2697),
    [anon_sym_TILDE] = ACTIONS(2697),
    [anon_sym_CARET] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2697),
    [anon_sym_LT_DASH] = ACTIONS(2697),
    [anon_sym_LT_LT] = ACTIONS(2697),
    [anon_sym_GT_GT] = ACTIONS(2697),
    [anon_sym_GT_GT_GT] = ACTIONS(2697),
    [anon_sym_AMP_CARET] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_PIPE_PIPE] = ACTIONS(2697),
    [anon_sym_or] = ACTIONS(2697),
    [sym_none] = ACTIONS(2697),
    [sym_true] = ACTIONS(2697),
    [sym_false] = ACTIONS(2697),
    [sym_nil] = ACTIONS(2697),
    [anon_sym_QMARK_DOT] = ACTIONS(2697),
    [anon_sym_POUND_LBRACK] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(2697),
    [anon_sym_DOLLARif] = ACTIONS(2697),
    [anon_sym_is] = ACTIONS(2697),
    [anon_sym_BANGis] = ACTIONS(2697),
    [anon_sym_in] = ACTIONS(2697),
    [anon_sym_BANGin] = ACTIONS(2697),
    [anon_sym_match] = ACTIONS(2697),
    [anon_sym_select] = ACTIONS(2697),
    [anon_sym_STAR_EQ] = ACTIONS(2697),
    [anon_sym_SLASH_EQ] = ACTIONS(2697),
    [anon_sym_PERCENT_EQ] = ACTIONS(2697),
    [anon_sym_LT_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT_GT_EQ] = ACTIONS(2697),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2697),
    [anon_sym_AMP_EQ] = ACTIONS(2697),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2697),
    [anon_sym_PLUS_EQ] = ACTIONS(2697),
    [anon_sym_DASH_EQ] = ACTIONS(2697),
    [anon_sym_PIPE_EQ] = ACTIONS(2697),
    [anon_sym_CARET_EQ] = ACTIONS(2697),
    [anon_sym_COLON_EQ] = ACTIONS(2697),
    [anon_sym_lock] = ACTIONS(2697),
    [anon_sym_rlock] = ACTIONS(2697),
    [anon_sym_unsafe] = ACTIONS(2697),
    [anon_sym_sql] = ACTIONS(2697),
    [sym_int_literal] = ACTIONS(2697),
    [sym_float_literal] = ACTIONS(2697),
    [sym_rune_literal] = ACTIONS(2697),
    [anon_sym_SQUOTE] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [anon_sym_c_SQUOTE] = ACTIONS(2697),
    [anon_sym_c_DQUOTE] = ACTIONS(2697),
    [anon_sym_r_SQUOTE] = ACTIONS(2697),
    [anon_sym_r_DQUOTE] = ACTIONS(2697),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2697),
    [anon_sym_shared] = ACTIONS(2697),
    [anon_sym_map_LBRACK] = ACTIONS(2697),
    [anon_sym_chan] = ACTIONS(2697),
    [anon_sym_thread] = ACTIONS(2697),
    [anon_sym_atomic] = ACTIONS(2697),
    [anon_sym_assert] = ACTIONS(2697),
    [anon_sym_defer] = ACTIONS(2697),
    [anon_sym_goto] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2697),
    [anon_sym_continue] = ACTIONS(2697),
    [anon_sym_return] = ACTIONS(2697),
    [anon_sym_DOLLARfor] = ACTIONS(2697),
    [anon_sym_for] = ACTIONS(2697),
    [anon_sym_POUND] = ACTIONS(2697),
    [anon_sym_asm] = ACTIONS(2697),
  },
  [1046] = {
    [sym_line_comment] = STATE(1046),
    [sym_block_comment] = STATE(1046),
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_LF] = ACTIONS(2627),
    [anon_sym_CR] = ACTIONS(2627),
    [anon_sym_CR_LF] = ACTIONS(2627),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2627),
    [anon_sym_DOT] = ACTIONS(2627),
    [anon_sym_as] = ACTIONS(2627),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_COMMA] = ACTIONS(2627),
    [anon_sym_RBRACE] = ACTIONS(2627),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_fn] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_SLASH] = ACTIONS(2627),
    [anon_sym_PERCENT] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2627),
    [anon_sym_GT] = ACTIONS(2627),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT_EQ] = ACTIONS(2627),
    [anon_sym_GT_EQ] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2625),
    [anon_sym_struct] = ACTIONS(2627),
    [anon_sym_mut] = ACTIONS(2627),
    [anon_sym_COLON] = ACTIONS(2627),
    [anon_sym_PLUS_PLUS] = ACTIONS(2627),
    [anon_sym_DASH_DASH] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2627),
    [anon_sym_BANG] = ACTIONS(2627),
    [anon_sym_go] = ACTIONS(2627),
    [anon_sym_spawn] = ACTIONS(2627),
    [anon_sym_json_DOTdecode] = ACTIONS(2627),
    [anon_sym_PIPE] = ACTIONS(2627),
    [anon_sym_LBRACK2] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2627),
    [anon_sym_CARET] = ACTIONS(2627),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_LT_DASH] = ACTIONS(2627),
    [anon_sym_LT_LT] = ACTIONS(2627),
    [anon_sym_GT_GT] = ACTIONS(2627),
    [anon_sym_GT_GT_GT] = ACTIONS(2627),
    [anon_sym_AMP_CARET] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_PIPE_PIPE] = ACTIONS(2627),
    [anon_sym_or] = ACTIONS(2627),
    [sym_none] = ACTIONS(2627),
    [sym_true] = ACTIONS(2627),
    [sym_false] = ACTIONS(2627),
    [sym_nil] = ACTIONS(2627),
    [anon_sym_QMARK_DOT] = ACTIONS(2627),
    [anon_sym_POUND_LBRACK] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_DOLLARif] = ACTIONS(2627),
    [anon_sym_is] = ACTIONS(2627),
    [anon_sym_BANGis] = ACTIONS(2627),
    [anon_sym_in] = ACTIONS(2627),
    [anon_sym_BANGin] = ACTIONS(2627),
    [anon_sym_match] = ACTIONS(2627),
    [anon_sym_select] = ACTIONS(2627),
    [anon_sym_STAR_EQ] = ACTIONS(2627),
    [anon_sym_SLASH_EQ] = ACTIONS(2627),
    [anon_sym_PERCENT_EQ] = ACTIONS(2627),
    [anon_sym_LT_LT_EQ] = ACTIONS(2627),
    [anon_sym_GT_GT_EQ] = ACTIONS(2627),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2627),
    [anon_sym_AMP_EQ] = ACTIONS(2627),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2627),
    [anon_sym_PLUS_EQ] = ACTIONS(2627),
    [anon_sym_DASH_EQ] = ACTIONS(2627),
    [anon_sym_PIPE_EQ] = ACTIONS(2627),
    [anon_sym_CARET_EQ] = ACTIONS(2627),
    [anon_sym_COLON_EQ] = ACTIONS(2627),
    [anon_sym_lock] = ACTIONS(2627),
    [anon_sym_rlock] = ACTIONS(2627),
    [anon_sym_unsafe] = ACTIONS(2627),
    [anon_sym_sql] = ACTIONS(2627),
    [sym_int_literal] = ACTIONS(2627),
    [sym_float_literal] = ACTIONS(2627),
    [sym_rune_literal] = ACTIONS(2627),
    [anon_sym_SQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [anon_sym_c_SQUOTE] = ACTIONS(2627),
    [anon_sym_c_DQUOTE] = ACTIONS(2627),
    [anon_sym_r_SQUOTE] = ACTIONS(2627),
    [anon_sym_r_DQUOTE] = ACTIONS(2627),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2627),
    [anon_sym_shared] = ACTIONS(2627),
    [anon_sym_map_LBRACK] = ACTIONS(2627),
    [anon_sym_chan] = ACTIONS(2627),
    [anon_sym_thread] = ACTIONS(2627),
    [anon_sym_atomic] = ACTIONS(2627),
    [anon_sym_assert] = ACTIONS(2627),
    [anon_sym_defer] = ACTIONS(2627),
    [anon_sym_goto] = ACTIONS(2627),
    [anon_sym_break] = ACTIONS(2627),
    [anon_sym_continue] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_DOLLARfor] = ACTIONS(2627),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_POUND] = ACTIONS(2627),
    [anon_sym_asm] = ACTIONS(2627),
  },
  [1047] = {
    [sym_line_comment] = STATE(1047),
    [sym_block_comment] = STATE(1047),
    [sym_identifier] = ACTIONS(2977),
    [anon_sym_LF] = ACTIONS(2977),
    [anon_sym_CR] = ACTIONS(2977),
    [anon_sym_CR_LF] = ACTIONS(2977),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2977),
    [anon_sym_DOT] = ACTIONS(2977),
    [anon_sym_as] = ACTIONS(2977),
    [anon_sym_LBRACE] = ACTIONS(2977),
    [anon_sym_COMMA] = ACTIONS(2977),
    [anon_sym_RBRACE] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(2977),
    [anon_sym_EQ] = ACTIONS(2977),
    [anon_sym_fn] = ACTIONS(2977),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_PERCENT] = ACTIONS(2977),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_EQ_EQ] = ACTIONS(2977),
    [anon_sym_BANG_EQ] = ACTIONS(2977),
    [anon_sym_LT_EQ] = ACTIONS(2977),
    [anon_sym_GT_EQ] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(2975),
    [anon_sym_struct] = ACTIONS(2977),
    [anon_sym_mut] = ACTIONS(2977),
    [anon_sym_COLON] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2977),
    [anon_sym_DASH_DASH] = ACTIONS(2977),
    [anon_sym_QMARK] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_go] = ACTIONS(2977),
    [anon_sym_spawn] = ACTIONS(2977),
    [anon_sym_json_DOTdecode] = ACTIONS(2977),
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_LBRACK2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2977),
    [anon_sym_CARET] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_LT_DASH] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2977),
    [anon_sym_GT_GT] = ACTIONS(2977),
    [anon_sym_GT_GT_GT] = ACTIONS(2977),
    [anon_sym_AMP_CARET] = ACTIONS(2977),
    [anon_sym_AMP_AMP] = ACTIONS(2977),
    [anon_sym_PIPE_PIPE] = ACTIONS(2977),
    [anon_sym_or] = ACTIONS(2977),
    [sym_none] = ACTIONS(2977),
    [sym_true] = ACTIONS(2977),
    [sym_false] = ACTIONS(2977),
    [sym_nil] = ACTIONS(2977),
    [anon_sym_QMARK_DOT] = ACTIONS(2977),
    [anon_sym_POUND_LBRACK] = ACTIONS(2977),
    [anon_sym_if] = ACTIONS(2977),
    [anon_sym_DOLLARif] = ACTIONS(2977),
    [anon_sym_is] = ACTIONS(2977),
    [anon_sym_BANGis] = ACTIONS(2977),
    [anon_sym_in] = ACTIONS(2977),
    [anon_sym_BANGin] = ACTIONS(2977),
    [anon_sym_match] = ACTIONS(2977),
    [anon_sym_select] = ACTIONS(2977),
    [anon_sym_STAR_EQ] = ACTIONS(2977),
    [anon_sym_SLASH_EQ] = ACTIONS(2977),
    [anon_sym_PERCENT_EQ] = ACTIONS(2977),
    [anon_sym_LT_LT_EQ] = ACTIONS(2977),
    [anon_sym_GT_GT_EQ] = ACTIONS(2977),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2977),
    [anon_sym_AMP_EQ] = ACTIONS(2977),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2977),
    [anon_sym_PLUS_EQ] = ACTIONS(2977),
    [anon_sym_DASH_EQ] = ACTIONS(2977),
    [anon_sym_PIPE_EQ] = ACTIONS(2977),
    [anon_sym_CARET_EQ] = ACTIONS(2977),
    [anon_sym_COLON_EQ] = ACTIONS(2977),
    [anon_sym_lock] = ACTIONS(2977),
    [anon_sym_rlock] = ACTIONS(2977),
    [anon_sym_unsafe] = ACTIONS(2977),
    [anon_sym_sql] = ACTIONS(2977),
    [sym_int_literal] = ACTIONS(2977),
    [sym_float_literal] = ACTIONS(2977),
    [sym_rune_literal] = ACTIONS(2977),
    [anon_sym_SQUOTE] = ACTIONS(2977),
    [anon_sym_DQUOTE] = ACTIONS(2977),
    [anon_sym_c_SQUOTE] = ACTIONS(2977),
    [anon_sym_c_DQUOTE] = ACTIONS(2977),
    [anon_sym_r_SQUOTE] = ACTIONS(2977),
    [anon_sym_r_DQUOTE] = ACTIONS(2977),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2977),
    [anon_sym_shared] = ACTIONS(2977),
    [anon_sym_map_LBRACK] = ACTIONS(2977),
    [anon_sym_chan] = ACTIONS(2977),
    [anon_sym_thread] = ACTIONS(2977),
    [anon_sym_atomic] = ACTIONS(2977),
    [anon_sym_assert] = ACTIONS(2977),
    [anon_sym_defer] = ACTIONS(2977),
    [anon_sym_goto] = ACTIONS(2977),
    [anon_sym_break] = ACTIONS(2977),
    [anon_sym_continue] = ACTIONS(2977),
    [anon_sym_return] = ACTIONS(2977),
    [anon_sym_DOLLARfor] = ACTIONS(2977),
    [anon_sym_for] = ACTIONS(2977),
    [anon_sym_POUND] = ACTIONS(2977),
    [anon_sym_asm] = ACTIONS(2977),
  },
  [1048] = {
    [sym_line_comment] = STATE(1048),
    [sym_block_comment] = STATE(1048),
    [sym_identifier] = ACTIONS(2981),
    [anon_sym_LF] = ACTIONS(2981),
    [anon_sym_CR] = ACTIONS(2981),
    [anon_sym_CR_LF] = ACTIONS(2981),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2981),
    [anon_sym_DOT] = ACTIONS(2981),
    [anon_sym_as] = ACTIONS(2981),
    [anon_sym_LBRACE] = ACTIONS(2981),
    [anon_sym_COMMA] = ACTIONS(2981),
    [anon_sym_RBRACE] = ACTIONS(2981),
    [anon_sym_LPAREN] = ACTIONS(2981),
    [anon_sym_EQ] = ACTIONS(2981),
    [anon_sym_fn] = ACTIONS(2981),
    [anon_sym_PLUS] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_PERCENT] = ACTIONS(2981),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_GT] = ACTIONS(2981),
    [anon_sym_EQ_EQ] = ACTIONS(2981),
    [anon_sym_BANG_EQ] = ACTIONS(2981),
    [anon_sym_LT_EQ] = ACTIONS(2981),
    [anon_sym_GT_EQ] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_struct] = ACTIONS(2981),
    [anon_sym_mut] = ACTIONS(2981),
    [anon_sym_COLON] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2981),
    [anon_sym_DASH_DASH] = ACTIONS(2981),
    [anon_sym_QMARK] = ACTIONS(2981),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_go] = ACTIONS(2981),
    [anon_sym_spawn] = ACTIONS(2981),
    [anon_sym_json_DOTdecode] = ACTIONS(2981),
    [anon_sym_PIPE] = ACTIONS(2981),
    [anon_sym_LBRACK2] = ACTIONS(2981),
    [anon_sym_TILDE] = ACTIONS(2981),
    [anon_sym_CARET] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2981),
    [anon_sym_LT_DASH] = ACTIONS(2981),
    [anon_sym_LT_LT] = ACTIONS(2981),
    [anon_sym_GT_GT] = ACTIONS(2981),
    [anon_sym_GT_GT_GT] = ACTIONS(2981),
    [anon_sym_AMP_CARET] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(2981),
    [anon_sym_PIPE_PIPE] = ACTIONS(2981),
    [anon_sym_or] = ACTIONS(2981),
    [sym_none] = ACTIONS(2981),
    [sym_true] = ACTIONS(2981),
    [sym_false] = ACTIONS(2981),
    [sym_nil] = ACTIONS(2981),
    [anon_sym_QMARK_DOT] = ACTIONS(2981),
    [anon_sym_POUND_LBRACK] = ACTIONS(2981),
    [anon_sym_if] = ACTIONS(2981),
    [anon_sym_DOLLARif] = ACTIONS(2981),
    [anon_sym_is] = ACTIONS(2981),
    [anon_sym_BANGis] = ACTIONS(2981),
    [anon_sym_in] = ACTIONS(2981),
    [anon_sym_BANGin] = ACTIONS(2981),
    [anon_sym_match] = ACTIONS(2981),
    [anon_sym_select] = ACTIONS(2981),
    [anon_sym_STAR_EQ] = ACTIONS(2981),
    [anon_sym_SLASH_EQ] = ACTIONS(2981),
    [anon_sym_PERCENT_EQ] = ACTIONS(2981),
    [anon_sym_LT_LT_EQ] = ACTIONS(2981),
    [anon_sym_GT_GT_EQ] = ACTIONS(2981),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2981),
    [anon_sym_AMP_EQ] = ACTIONS(2981),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2981),
    [anon_sym_PLUS_EQ] = ACTIONS(2981),
    [anon_sym_DASH_EQ] = ACTIONS(2981),
    [anon_sym_PIPE_EQ] = ACTIONS(2981),
    [anon_sym_CARET_EQ] = ACTIONS(2981),
    [anon_sym_COLON_EQ] = ACTIONS(2981),
    [anon_sym_lock] = ACTIONS(2981),
    [anon_sym_rlock] = ACTIONS(2981),
    [anon_sym_unsafe] = ACTIONS(2981),
    [anon_sym_sql] = ACTIONS(2981),
    [sym_int_literal] = ACTIONS(2981),
    [sym_float_literal] = ACTIONS(2981),
    [sym_rune_literal] = ACTIONS(2981),
    [anon_sym_SQUOTE] = ACTIONS(2981),
    [anon_sym_DQUOTE] = ACTIONS(2981),
    [anon_sym_c_SQUOTE] = ACTIONS(2981),
    [anon_sym_c_DQUOTE] = ACTIONS(2981),
    [anon_sym_r_SQUOTE] = ACTIONS(2981),
    [anon_sym_r_DQUOTE] = ACTIONS(2981),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2981),
    [anon_sym_shared] = ACTIONS(2981),
    [anon_sym_map_LBRACK] = ACTIONS(2981),
    [anon_sym_chan] = ACTIONS(2981),
    [anon_sym_thread] = ACTIONS(2981),
    [anon_sym_atomic] = ACTIONS(2981),
    [anon_sym_assert] = ACTIONS(2981),
    [anon_sym_defer] = ACTIONS(2981),
    [anon_sym_goto] = ACTIONS(2981),
    [anon_sym_break] = ACTIONS(2981),
    [anon_sym_continue] = ACTIONS(2981),
    [anon_sym_return] = ACTIONS(2981),
    [anon_sym_DOLLARfor] = ACTIONS(2981),
    [anon_sym_for] = ACTIONS(2981),
    [anon_sym_POUND] = ACTIONS(2981),
    [anon_sym_asm] = ACTIONS(2981),
  },
  [1049] = {
    [sym_line_comment] = STATE(1049),
    [sym_block_comment] = STATE(1049),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_LF] = ACTIONS(2837),
    [anon_sym_CR] = ACTIONS(2837),
    [anon_sym_CR_LF] = ACTIONS(2837),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2837),
    [anon_sym_DOT] = ACTIONS(2837),
    [anon_sym_as] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_RBRACE] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2837),
    [anon_sym_EQ] = ACTIONS(2837),
    [anon_sym_fn] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2837),
    [anon_sym_DASH] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2837),
    [anon_sym_SLASH] = ACTIONS(2837),
    [anon_sym_PERCENT] = ACTIONS(2837),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(2837),
    [anon_sym_BANG_EQ] = ACTIONS(2837),
    [anon_sym_LT_EQ] = ACTIONS(2837),
    [anon_sym_GT_EQ] = ACTIONS(2837),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_struct] = ACTIONS(2837),
    [anon_sym_mut] = ACTIONS(2837),
    [anon_sym_COLON] = ACTIONS(2837),
    [anon_sym_PLUS_PLUS] = ACTIONS(2837),
    [anon_sym_DASH_DASH] = ACTIONS(2837),
    [anon_sym_QMARK] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(2837),
    [anon_sym_go] = ACTIONS(2837),
    [anon_sym_spawn] = ACTIONS(2837),
    [anon_sym_json_DOTdecode] = ACTIONS(2837),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_LBRACK2] = ACTIONS(2837),
    [anon_sym_TILDE] = ACTIONS(2837),
    [anon_sym_CARET] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2837),
    [anon_sym_LT_DASH] = ACTIONS(2837),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_GT_GT_GT] = ACTIONS(2837),
    [anon_sym_AMP_CARET] = ACTIONS(2837),
    [anon_sym_AMP_AMP] = ACTIONS(2837),
    [anon_sym_PIPE_PIPE] = ACTIONS(2837),
    [anon_sym_or] = ACTIONS(2837),
    [sym_none] = ACTIONS(2837),
    [sym_true] = ACTIONS(2837),
    [sym_false] = ACTIONS(2837),
    [sym_nil] = ACTIONS(2837),
    [anon_sym_QMARK_DOT] = ACTIONS(2837),
    [anon_sym_POUND_LBRACK] = ACTIONS(2837),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_DOLLARif] = ACTIONS(2837),
    [anon_sym_is] = ACTIONS(2837),
    [anon_sym_BANGis] = ACTIONS(2837),
    [anon_sym_in] = ACTIONS(2837),
    [anon_sym_BANGin] = ACTIONS(2837),
    [anon_sym_match] = ACTIONS(2837),
    [anon_sym_select] = ACTIONS(2837),
    [anon_sym_STAR_EQ] = ACTIONS(2837),
    [anon_sym_SLASH_EQ] = ACTIONS(2837),
    [anon_sym_PERCENT_EQ] = ACTIONS(2837),
    [anon_sym_LT_LT_EQ] = ACTIONS(2837),
    [anon_sym_GT_GT_EQ] = ACTIONS(2837),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2837),
    [anon_sym_AMP_EQ] = ACTIONS(2837),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2837),
    [anon_sym_PLUS_EQ] = ACTIONS(2837),
    [anon_sym_DASH_EQ] = ACTIONS(2837),
    [anon_sym_PIPE_EQ] = ACTIONS(2837),
    [anon_sym_CARET_EQ] = ACTIONS(2837),
    [anon_sym_COLON_EQ] = ACTIONS(2837),
    [anon_sym_lock] = ACTIONS(2837),
    [anon_sym_rlock] = ACTIONS(2837),
    [anon_sym_unsafe] = ACTIONS(2837),
    [anon_sym_sql] = ACTIONS(2837),
    [sym_int_literal] = ACTIONS(2837),
    [sym_float_literal] = ACTIONS(2837),
    [sym_rune_literal] = ACTIONS(2837),
    [anon_sym_SQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE] = ACTIONS(2837),
    [anon_sym_c_SQUOTE] = ACTIONS(2837),
    [anon_sym_c_DQUOTE] = ACTIONS(2837),
    [anon_sym_r_SQUOTE] = ACTIONS(2837),
    [anon_sym_r_DQUOTE] = ACTIONS(2837),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2837),
    [anon_sym_shared] = ACTIONS(2837),
    [anon_sym_map_LBRACK] = ACTIONS(2837),
    [anon_sym_chan] = ACTIONS(2837),
    [anon_sym_thread] = ACTIONS(2837),
    [anon_sym_atomic] = ACTIONS(2837),
    [anon_sym_assert] = ACTIONS(2837),
    [anon_sym_defer] = ACTIONS(2837),
    [anon_sym_goto] = ACTIONS(2837),
    [anon_sym_break] = ACTIONS(2837),
    [anon_sym_continue] = ACTIONS(2837),
    [anon_sym_return] = ACTIONS(2837),
    [anon_sym_DOLLARfor] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2837),
    [anon_sym_POUND] = ACTIONS(2837),
    [anon_sym_asm] = ACTIONS(2837),
  },
  [1050] = {
    [sym_line_comment] = STATE(1050),
    [sym_block_comment] = STATE(1050),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_LF] = ACTIONS(3007),
    [anon_sym_CR] = ACTIONS(3007),
    [anon_sym_CR_LF] = ACTIONS(3007),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3007),
    [anon_sym_DOT] = ACTIONS(3007),
    [anon_sym_as] = ACTIONS(3007),
    [anon_sym_LBRACE] = ACTIONS(3007),
    [anon_sym_COMMA] = ACTIONS(3007),
    [anon_sym_RBRACE] = ACTIONS(3007),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_EQ] = ACTIONS(3007),
    [anon_sym_fn] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_STAR] = ACTIONS(3007),
    [anon_sym_SLASH] = ACTIONS(3007),
    [anon_sym_PERCENT] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(3007),
    [anon_sym_GT] = ACTIONS(3007),
    [anon_sym_EQ_EQ] = ACTIONS(3007),
    [anon_sym_BANG_EQ] = ACTIONS(3007),
    [anon_sym_LT_EQ] = ACTIONS(3007),
    [anon_sym_GT_EQ] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3005),
    [anon_sym_struct] = ACTIONS(3007),
    [anon_sym_mut] = ACTIONS(3007),
    [anon_sym_COLON] = ACTIONS(3007),
    [anon_sym_PLUS_PLUS] = ACTIONS(3007),
    [anon_sym_DASH_DASH] = ACTIONS(3007),
    [anon_sym_QMARK] = ACTIONS(3007),
    [anon_sym_BANG] = ACTIONS(3007),
    [anon_sym_go] = ACTIONS(3007),
    [anon_sym_spawn] = ACTIONS(3007),
    [anon_sym_json_DOTdecode] = ACTIONS(3007),
    [anon_sym_PIPE] = ACTIONS(3007),
    [anon_sym_LBRACK2] = ACTIONS(3007),
    [anon_sym_TILDE] = ACTIONS(3007),
    [anon_sym_CARET] = ACTIONS(3007),
    [anon_sym_AMP] = ACTIONS(3007),
    [anon_sym_LT_DASH] = ACTIONS(3007),
    [anon_sym_LT_LT] = ACTIONS(3007),
    [anon_sym_GT_GT] = ACTIONS(3007),
    [anon_sym_GT_GT_GT] = ACTIONS(3007),
    [anon_sym_AMP_CARET] = ACTIONS(3007),
    [anon_sym_AMP_AMP] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3007),
    [anon_sym_or] = ACTIONS(3007),
    [sym_none] = ACTIONS(3007),
    [sym_true] = ACTIONS(3007),
    [sym_false] = ACTIONS(3007),
    [sym_nil] = ACTIONS(3007),
    [anon_sym_QMARK_DOT] = ACTIONS(3007),
    [anon_sym_POUND_LBRACK] = ACTIONS(3007),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_DOLLARif] = ACTIONS(3007),
    [anon_sym_is] = ACTIONS(3007),
    [anon_sym_BANGis] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3007),
    [anon_sym_BANGin] = ACTIONS(3007),
    [anon_sym_match] = ACTIONS(3007),
    [anon_sym_select] = ACTIONS(3007),
    [anon_sym_STAR_EQ] = ACTIONS(3007),
    [anon_sym_SLASH_EQ] = ACTIONS(3007),
    [anon_sym_PERCENT_EQ] = ACTIONS(3007),
    [anon_sym_LT_LT_EQ] = ACTIONS(3007),
    [anon_sym_GT_GT_EQ] = ACTIONS(3007),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3007),
    [anon_sym_AMP_EQ] = ACTIONS(3007),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3007),
    [anon_sym_PLUS_EQ] = ACTIONS(3007),
    [anon_sym_DASH_EQ] = ACTIONS(3007),
    [anon_sym_PIPE_EQ] = ACTIONS(3007),
    [anon_sym_CARET_EQ] = ACTIONS(3007),
    [anon_sym_COLON_EQ] = ACTIONS(3007),
    [anon_sym_lock] = ACTIONS(3007),
    [anon_sym_rlock] = ACTIONS(3007),
    [anon_sym_unsafe] = ACTIONS(3007),
    [anon_sym_sql] = ACTIONS(3007),
    [sym_int_literal] = ACTIONS(3007),
    [sym_float_literal] = ACTIONS(3007),
    [sym_rune_literal] = ACTIONS(3007),
    [anon_sym_SQUOTE] = ACTIONS(3007),
    [anon_sym_DQUOTE] = ACTIONS(3007),
    [anon_sym_c_SQUOTE] = ACTIONS(3007),
    [anon_sym_c_DQUOTE] = ACTIONS(3007),
    [anon_sym_r_SQUOTE] = ACTIONS(3007),
    [anon_sym_r_DQUOTE] = ACTIONS(3007),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3007),
    [anon_sym_shared] = ACTIONS(3007),
    [anon_sym_map_LBRACK] = ACTIONS(3007),
    [anon_sym_chan] = ACTIONS(3007),
    [anon_sym_thread] = ACTIONS(3007),
    [anon_sym_atomic] = ACTIONS(3007),
    [anon_sym_assert] = ACTIONS(3007),
    [anon_sym_defer] = ACTIONS(3007),
    [anon_sym_goto] = ACTIONS(3007),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_continue] = ACTIONS(3007),
    [anon_sym_return] = ACTIONS(3007),
    [anon_sym_DOLLARfor] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3007),
    [anon_sym_POUND] = ACTIONS(3007),
    [anon_sym_asm] = ACTIONS(3007),
  },
  [1051] = {
    [sym_line_comment] = STATE(1051),
    [sym_block_comment] = STATE(1051),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_CR] = ACTIONS(2873),
    [anon_sym_CR_LF] = ACTIONS(2873),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2873),
    [anon_sym_as] = ACTIONS(2873),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(2873),
    [anon_sym_LPAREN] = ACTIONS(2873),
    [anon_sym_EQ] = ACTIONS(2873),
    [anon_sym_fn] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2873),
    [anon_sym_STAR] = ACTIONS(2873),
    [anon_sym_SLASH] = ACTIONS(2873),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2873),
    [anon_sym_GT] = ACTIONS(2873),
    [anon_sym_EQ_EQ] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_LT_EQ] = ACTIONS(2873),
    [anon_sym_GT_EQ] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2873),
    [anon_sym_mut] = ACTIONS(2873),
    [anon_sym_COLON] = ACTIONS(2873),
    [anon_sym_PLUS_PLUS] = ACTIONS(2873),
    [anon_sym_DASH_DASH] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_BANG] = ACTIONS(2873),
    [anon_sym_go] = ACTIONS(2873),
    [anon_sym_spawn] = ACTIONS(2873),
    [anon_sym_json_DOTdecode] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2873),
    [anon_sym_LBRACK2] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2873),
    [anon_sym_CARET] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LT_DASH] = ACTIONS(2873),
    [anon_sym_LT_LT] = ACTIONS(2873),
    [anon_sym_GT_GT] = ACTIONS(2873),
    [anon_sym_GT_GT_GT] = ACTIONS(2873),
    [anon_sym_AMP_CARET] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [sym_none] = ACTIONS(2873),
    [sym_true] = ACTIONS(2873),
    [sym_false] = ACTIONS(2873),
    [sym_nil] = ACTIONS(2873),
    [anon_sym_QMARK_DOT] = ACTIONS(2873),
    [anon_sym_POUND_LBRACK] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_DOLLARif] = ACTIONS(2873),
    [anon_sym_is] = ACTIONS(2873),
    [anon_sym_BANGis] = ACTIONS(2873),
    [anon_sym_in] = ACTIONS(2873),
    [anon_sym_BANGin] = ACTIONS(2873),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_select] = ACTIONS(2873),
    [anon_sym_STAR_EQ] = ACTIONS(2873),
    [anon_sym_SLASH_EQ] = ACTIONS(2873),
    [anon_sym_PERCENT_EQ] = ACTIONS(2873),
    [anon_sym_LT_LT_EQ] = ACTIONS(2873),
    [anon_sym_GT_GT_EQ] = ACTIONS(2873),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2873),
    [anon_sym_AMP_EQ] = ACTIONS(2873),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(2873),
    [anon_sym_DASH_EQ] = ACTIONS(2873),
    [anon_sym_PIPE_EQ] = ACTIONS(2873),
    [anon_sym_CARET_EQ] = ACTIONS(2873),
    [anon_sym_COLON_EQ] = ACTIONS(2873),
    [anon_sym_lock] = ACTIONS(2873),
    [anon_sym_rlock] = ACTIONS(2873),
    [anon_sym_unsafe] = ACTIONS(2873),
    [anon_sym_sql] = ACTIONS(2873),
    [sym_int_literal] = ACTIONS(2873),
    [sym_float_literal] = ACTIONS(2873),
    [sym_rune_literal] = ACTIONS(2873),
    [anon_sym_SQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_c_SQUOTE] = ACTIONS(2873),
    [anon_sym_c_DQUOTE] = ACTIONS(2873),
    [anon_sym_r_SQUOTE] = ACTIONS(2873),
    [anon_sym_r_DQUOTE] = ACTIONS(2873),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2873),
    [anon_sym_shared] = ACTIONS(2873),
    [anon_sym_map_LBRACK] = ACTIONS(2873),
    [anon_sym_chan] = ACTIONS(2873),
    [anon_sym_thread] = ACTIONS(2873),
    [anon_sym_atomic] = ACTIONS(2873),
    [anon_sym_assert] = ACTIONS(2873),
    [anon_sym_defer] = ACTIONS(2873),
    [anon_sym_goto] = ACTIONS(2873),
    [anon_sym_break] = ACTIONS(2873),
    [anon_sym_continue] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_DOLLARfor] = ACTIONS(2873),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_POUND] = ACTIONS(2873),
    [anon_sym_asm] = ACTIONS(2873),
  },
  [1052] = {
    [sym_line_comment] = STATE(1052),
    [sym_block_comment] = STATE(1052),
    [sym_identifier] = ACTIONS(2985),
    [anon_sym_LF] = ACTIONS(2985),
    [anon_sym_CR] = ACTIONS(2985),
    [anon_sym_CR_LF] = ACTIONS(2985),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2985),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_as] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2985),
    [anon_sym_RBRACE] = ACTIONS(2985),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2985),
    [anon_sym_fn] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2985),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_PERCENT] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_EQ_EQ] = ACTIONS(2985),
    [anon_sym_BANG_EQ] = ACTIONS(2985),
    [anon_sym_LT_EQ] = ACTIONS(2985),
    [anon_sym_GT_EQ] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_mut] = ACTIONS(2985),
    [anon_sym_COLON] = ACTIONS(2985),
    [anon_sym_PLUS_PLUS] = ACTIONS(2985),
    [anon_sym_DASH_DASH] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_go] = ACTIONS(2985),
    [anon_sym_spawn] = ACTIONS(2985),
    [anon_sym_json_DOTdecode] = ACTIONS(2985),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(2985),
    [anon_sym_CARET] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_DASH] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2985),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_GT_GT_GT] = ACTIONS(2985),
    [anon_sym_AMP_CARET] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_or] = ACTIONS(2985),
    [sym_none] = ACTIONS(2985),
    [sym_true] = ACTIONS(2985),
    [sym_false] = ACTIONS(2985),
    [sym_nil] = ACTIONS(2985),
    [anon_sym_QMARK_DOT] = ACTIONS(2985),
    [anon_sym_POUND_LBRACK] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_DOLLARif] = ACTIONS(2985),
    [anon_sym_is] = ACTIONS(2985),
    [anon_sym_BANGis] = ACTIONS(2985),
    [anon_sym_in] = ACTIONS(2985),
    [anon_sym_BANGin] = ACTIONS(2985),
    [anon_sym_match] = ACTIONS(2985),
    [anon_sym_select] = ACTIONS(2985),
    [anon_sym_STAR_EQ] = ACTIONS(2985),
    [anon_sym_SLASH_EQ] = ACTIONS(2985),
    [anon_sym_PERCENT_EQ] = ACTIONS(2985),
    [anon_sym_LT_LT_EQ] = ACTIONS(2985),
    [anon_sym_GT_GT_EQ] = ACTIONS(2985),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2985),
    [anon_sym_AMP_EQ] = ACTIONS(2985),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2985),
    [anon_sym_PLUS_EQ] = ACTIONS(2985),
    [anon_sym_DASH_EQ] = ACTIONS(2985),
    [anon_sym_PIPE_EQ] = ACTIONS(2985),
    [anon_sym_CARET_EQ] = ACTIONS(2985),
    [anon_sym_COLON_EQ] = ACTIONS(2985),
    [anon_sym_lock] = ACTIONS(2985),
    [anon_sym_rlock] = ACTIONS(2985),
    [anon_sym_unsafe] = ACTIONS(2985),
    [anon_sym_sql] = ACTIONS(2985),
    [sym_int_literal] = ACTIONS(2985),
    [sym_float_literal] = ACTIONS(2985),
    [sym_rune_literal] = ACTIONS(2985),
    [anon_sym_SQUOTE] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_c_SQUOTE] = ACTIONS(2985),
    [anon_sym_c_DQUOTE] = ACTIONS(2985),
    [anon_sym_r_SQUOTE] = ACTIONS(2985),
    [anon_sym_r_DQUOTE] = ACTIONS(2985),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2985),
    [anon_sym_shared] = ACTIONS(2985),
    [anon_sym_map_LBRACK] = ACTIONS(2985),
    [anon_sym_chan] = ACTIONS(2985),
    [anon_sym_thread] = ACTIONS(2985),
    [anon_sym_atomic] = ACTIONS(2985),
    [anon_sym_assert] = ACTIONS(2985),
    [anon_sym_defer] = ACTIONS(2985),
    [anon_sym_goto] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_DOLLARfor] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_POUND] = ACTIONS(2985),
    [anon_sym_asm] = ACTIONS(2985),
  },
  [1053] = {
    [sym_line_comment] = STATE(1053),
    [sym_block_comment] = STATE(1053),
    [sym_identifier] = ACTIONS(2885),
    [anon_sym_LF] = ACTIONS(2885),
    [anon_sym_CR] = ACTIONS(2885),
    [anon_sym_CR_LF] = ACTIONS(2885),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym_DOT] = ACTIONS(2885),
    [anon_sym_as] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2885),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_fn] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2885),
    [anon_sym_SLASH] = ACTIONS(2885),
    [anon_sym_PERCENT] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_GT] = ACTIONS(2885),
    [anon_sym_EQ_EQ] = ACTIONS(2885),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2885),
    [anon_sym_GT_EQ] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_mut] = ACTIONS(2885),
    [anon_sym_COLON] = ACTIONS(2885),
    [anon_sym_PLUS_PLUS] = ACTIONS(2885),
    [anon_sym_DASH_DASH] = ACTIONS(2885),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_BANG] = ACTIONS(2885),
    [anon_sym_go] = ACTIONS(2885),
    [anon_sym_spawn] = ACTIONS(2885),
    [anon_sym_json_DOTdecode] = ACTIONS(2885),
    [anon_sym_PIPE] = ACTIONS(2885),
    [anon_sym_LBRACK2] = ACTIONS(2885),
    [anon_sym_TILDE] = ACTIONS(2885),
    [anon_sym_CARET] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_LT_DASH] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2885),
    [anon_sym_GT_GT] = ACTIONS(2885),
    [anon_sym_GT_GT_GT] = ACTIONS(2885),
    [anon_sym_AMP_CARET] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_or] = ACTIONS(2885),
    [sym_none] = ACTIONS(2885),
    [sym_true] = ACTIONS(2885),
    [sym_false] = ACTIONS(2885),
    [sym_nil] = ACTIONS(2885),
    [anon_sym_QMARK_DOT] = ACTIONS(2885),
    [anon_sym_POUND_LBRACK] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_DOLLARif] = ACTIONS(2885),
    [anon_sym_is] = ACTIONS(2885),
    [anon_sym_BANGis] = ACTIONS(2885),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_BANGin] = ACTIONS(2885),
    [anon_sym_match] = ACTIONS(2885),
    [anon_sym_select] = ACTIONS(2885),
    [anon_sym_STAR_EQ] = ACTIONS(2885),
    [anon_sym_SLASH_EQ] = ACTIONS(2885),
    [anon_sym_PERCENT_EQ] = ACTIONS(2885),
    [anon_sym_LT_LT_EQ] = ACTIONS(2885),
    [anon_sym_GT_GT_EQ] = ACTIONS(2885),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2885),
    [anon_sym_AMP_EQ] = ACTIONS(2885),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2885),
    [anon_sym_PLUS_EQ] = ACTIONS(2885),
    [anon_sym_DASH_EQ] = ACTIONS(2885),
    [anon_sym_PIPE_EQ] = ACTIONS(2885),
    [anon_sym_CARET_EQ] = ACTIONS(2885),
    [anon_sym_COLON_EQ] = ACTIONS(2885),
    [anon_sym_lock] = ACTIONS(2885),
    [anon_sym_rlock] = ACTIONS(2885),
    [anon_sym_unsafe] = ACTIONS(2885),
    [anon_sym_sql] = ACTIONS(2885),
    [sym_int_literal] = ACTIONS(2885),
    [sym_float_literal] = ACTIONS(2885),
    [sym_rune_literal] = ACTIONS(2885),
    [anon_sym_SQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE] = ACTIONS(2885),
    [anon_sym_c_SQUOTE] = ACTIONS(2885),
    [anon_sym_c_DQUOTE] = ACTIONS(2885),
    [anon_sym_r_SQUOTE] = ACTIONS(2885),
    [anon_sym_r_DQUOTE] = ACTIONS(2885),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2885),
    [anon_sym_shared] = ACTIONS(2885),
    [anon_sym_map_LBRACK] = ACTIONS(2885),
    [anon_sym_chan] = ACTIONS(2885),
    [anon_sym_thread] = ACTIONS(2885),
    [anon_sym_atomic] = ACTIONS(2885),
    [anon_sym_assert] = ACTIONS(2885),
    [anon_sym_defer] = ACTIONS(2885),
    [anon_sym_goto] = ACTIONS(2885),
    [anon_sym_break] = ACTIONS(2885),
    [anon_sym_continue] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_DOLLARfor] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_POUND] = ACTIONS(2885),
    [anon_sym_asm] = ACTIONS(2885),
  },
  [1054] = {
    [sym_line_comment] = STATE(1054),
    [sym_block_comment] = STATE(1054),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_LF] = ACTIONS(3015),
    [anon_sym_CR] = ACTIONS(3015),
    [anon_sym_CR_LF] = ACTIONS(3015),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3015),
    [anon_sym_DOT] = ACTIONS(3015),
    [anon_sym_as] = ACTIONS(3015),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_COMMA] = ACTIONS(3015),
    [anon_sym_RBRACE] = ACTIONS(3015),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_EQ] = ACTIONS(3015),
    [anon_sym_fn] = ACTIONS(3015),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(3015),
    [anon_sym_SLASH] = ACTIONS(3015),
    [anon_sym_PERCENT] = ACTIONS(3015),
    [anon_sym_LT] = ACTIONS(3015),
    [anon_sym_GT] = ACTIONS(3015),
    [anon_sym_EQ_EQ] = ACTIONS(3015),
    [anon_sym_BANG_EQ] = ACTIONS(3015),
    [anon_sym_LT_EQ] = ACTIONS(3015),
    [anon_sym_GT_EQ] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3013),
    [anon_sym_struct] = ACTIONS(3015),
    [anon_sym_mut] = ACTIONS(3015),
    [anon_sym_COLON] = ACTIONS(3015),
    [anon_sym_PLUS_PLUS] = ACTIONS(3015),
    [anon_sym_DASH_DASH] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_BANG] = ACTIONS(3015),
    [anon_sym_go] = ACTIONS(3015),
    [anon_sym_spawn] = ACTIONS(3015),
    [anon_sym_json_DOTdecode] = ACTIONS(3015),
    [anon_sym_PIPE] = ACTIONS(3015),
    [anon_sym_LBRACK2] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3015),
    [anon_sym_CARET] = ACTIONS(3015),
    [anon_sym_AMP] = ACTIONS(3015),
    [anon_sym_LT_DASH] = ACTIONS(3015),
    [anon_sym_LT_LT] = ACTIONS(3015),
    [anon_sym_GT_GT] = ACTIONS(3015),
    [anon_sym_GT_GT_GT] = ACTIONS(3015),
    [anon_sym_AMP_CARET] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_or] = ACTIONS(3015),
    [sym_none] = ACTIONS(3015),
    [sym_true] = ACTIONS(3015),
    [sym_false] = ACTIONS(3015),
    [sym_nil] = ACTIONS(3015),
    [anon_sym_QMARK_DOT] = ACTIONS(3015),
    [anon_sym_POUND_LBRACK] = ACTIONS(3015),
    [anon_sym_if] = ACTIONS(3015),
    [anon_sym_DOLLARif] = ACTIONS(3015),
    [anon_sym_is] = ACTIONS(3015),
    [anon_sym_BANGis] = ACTIONS(3015),
    [anon_sym_in] = ACTIONS(3015),
    [anon_sym_BANGin] = ACTIONS(3015),
    [anon_sym_match] = ACTIONS(3015),
    [anon_sym_select] = ACTIONS(3015),
    [anon_sym_STAR_EQ] = ACTIONS(3015),
    [anon_sym_SLASH_EQ] = ACTIONS(3015),
    [anon_sym_PERCENT_EQ] = ACTIONS(3015),
    [anon_sym_LT_LT_EQ] = ACTIONS(3015),
    [anon_sym_GT_GT_EQ] = ACTIONS(3015),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3015),
    [anon_sym_AMP_EQ] = ACTIONS(3015),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3015),
    [anon_sym_PLUS_EQ] = ACTIONS(3015),
    [anon_sym_DASH_EQ] = ACTIONS(3015),
    [anon_sym_PIPE_EQ] = ACTIONS(3015),
    [anon_sym_CARET_EQ] = ACTIONS(3015),
    [anon_sym_COLON_EQ] = ACTIONS(3015),
    [anon_sym_lock] = ACTIONS(3015),
    [anon_sym_rlock] = ACTIONS(3015),
    [anon_sym_unsafe] = ACTIONS(3015),
    [anon_sym_sql] = ACTIONS(3015),
    [sym_int_literal] = ACTIONS(3015),
    [sym_float_literal] = ACTIONS(3015),
    [sym_rune_literal] = ACTIONS(3015),
    [anon_sym_SQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_c_SQUOTE] = ACTIONS(3015),
    [anon_sym_c_DQUOTE] = ACTIONS(3015),
    [anon_sym_r_SQUOTE] = ACTIONS(3015),
    [anon_sym_r_DQUOTE] = ACTIONS(3015),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3015),
    [anon_sym_shared] = ACTIONS(3015),
    [anon_sym_map_LBRACK] = ACTIONS(3015),
    [anon_sym_chan] = ACTIONS(3015),
    [anon_sym_thread] = ACTIONS(3015),
    [anon_sym_atomic] = ACTIONS(3015),
    [anon_sym_assert] = ACTIONS(3015),
    [anon_sym_defer] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3015),
    [anon_sym_break] = ACTIONS(3015),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_return] = ACTIONS(3015),
    [anon_sym_DOLLARfor] = ACTIONS(3015),
    [anon_sym_for] = ACTIONS(3015),
    [anon_sym_POUND] = ACTIONS(3015),
    [anon_sym_asm] = ACTIONS(3015),
  },
  [1055] = {
    [sym_line_comment] = STATE(1055),
    [sym_block_comment] = STATE(1055),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_LF] = ACTIONS(2917),
    [anon_sym_CR] = ACTIONS(2917),
    [anon_sym_CR_LF] = ACTIONS(2917),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym_DOT] = ACTIONS(2917),
    [anon_sym_as] = ACTIONS(2917),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_COMMA] = ACTIONS(2917),
    [anon_sym_RBRACE] = ACTIONS(2917),
    [anon_sym_LPAREN] = ACTIONS(2917),
    [anon_sym_EQ] = ACTIONS(2917),
    [anon_sym_fn] = ACTIONS(2917),
    [anon_sym_PLUS] = ACTIONS(2917),
    [anon_sym_DASH] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2917),
    [anon_sym_SLASH] = ACTIONS(2917),
    [anon_sym_PERCENT] = ACTIONS(2917),
    [anon_sym_LT] = ACTIONS(2917),
    [anon_sym_GT] = ACTIONS(2917),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2917),
    [anon_sym_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT_EQ] = ACTIONS(2917),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2917),
    [anon_sym_mut] = ACTIONS(2917),
    [anon_sym_COLON] = ACTIONS(2917),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_QMARK] = ACTIONS(2917),
    [anon_sym_BANG] = ACTIONS(2917),
    [anon_sym_go] = ACTIONS(2917),
    [anon_sym_spawn] = ACTIONS(2917),
    [anon_sym_json_DOTdecode] = ACTIONS(2917),
    [anon_sym_PIPE] = ACTIONS(2917),
    [anon_sym_LBRACK2] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_CARET] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2917),
    [anon_sym_LT_DASH] = ACTIONS(2917),
    [anon_sym_LT_LT] = ACTIONS(2917),
    [anon_sym_GT_GT] = ACTIONS(2917),
    [anon_sym_GT_GT_GT] = ACTIONS(2917),
    [anon_sym_AMP_CARET] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_PIPE_PIPE] = ACTIONS(2917),
    [anon_sym_or] = ACTIONS(2917),
    [sym_none] = ACTIONS(2917),
    [sym_true] = ACTIONS(2917),
    [sym_false] = ACTIONS(2917),
    [sym_nil] = ACTIONS(2917),
    [anon_sym_QMARK_DOT] = ACTIONS(2917),
    [anon_sym_POUND_LBRACK] = ACTIONS(2917),
    [anon_sym_if] = ACTIONS(2917),
    [anon_sym_DOLLARif] = ACTIONS(2917),
    [anon_sym_is] = ACTIONS(2917),
    [anon_sym_BANGis] = ACTIONS(2917),
    [anon_sym_in] = ACTIONS(2917),
    [anon_sym_BANGin] = ACTIONS(2917),
    [anon_sym_match] = ACTIONS(2917),
    [anon_sym_select] = ACTIONS(2917),
    [anon_sym_STAR_EQ] = ACTIONS(2917),
    [anon_sym_SLASH_EQ] = ACTIONS(2917),
    [anon_sym_PERCENT_EQ] = ACTIONS(2917),
    [anon_sym_LT_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT_GT_EQ] = ACTIONS(2917),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2917),
    [anon_sym_AMP_EQ] = ACTIONS(2917),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2917),
    [anon_sym_PLUS_EQ] = ACTIONS(2917),
    [anon_sym_DASH_EQ] = ACTIONS(2917),
    [anon_sym_PIPE_EQ] = ACTIONS(2917),
    [anon_sym_CARET_EQ] = ACTIONS(2917),
    [anon_sym_COLON_EQ] = ACTIONS(2917),
    [anon_sym_lock] = ACTIONS(2917),
    [anon_sym_rlock] = ACTIONS(2917),
    [anon_sym_unsafe] = ACTIONS(2917),
    [anon_sym_sql] = ACTIONS(2917),
    [sym_int_literal] = ACTIONS(2917),
    [sym_float_literal] = ACTIONS(2917),
    [sym_rune_literal] = ACTIONS(2917),
    [anon_sym_SQUOTE] = ACTIONS(2917),
    [anon_sym_DQUOTE] = ACTIONS(2917),
    [anon_sym_c_SQUOTE] = ACTIONS(2917),
    [anon_sym_c_DQUOTE] = ACTIONS(2917),
    [anon_sym_r_SQUOTE] = ACTIONS(2917),
    [anon_sym_r_DQUOTE] = ACTIONS(2917),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2917),
    [anon_sym_shared] = ACTIONS(2917),
    [anon_sym_map_LBRACK] = ACTIONS(2917),
    [anon_sym_chan] = ACTIONS(2917),
    [anon_sym_thread] = ACTIONS(2917),
    [anon_sym_atomic] = ACTIONS(2917),
    [anon_sym_assert] = ACTIONS(2917),
    [anon_sym_defer] = ACTIONS(2917),
    [anon_sym_goto] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2917),
    [anon_sym_continue] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2917),
    [anon_sym_DOLLARfor] = ACTIONS(2917),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_POUND] = ACTIONS(2917),
    [anon_sym_asm] = ACTIONS(2917),
  },
  [1056] = {
    [sym_line_comment] = STATE(1056),
    [sym_block_comment] = STATE(1056),
    [sym_identifier] = ACTIONS(2921),
    [anon_sym_LF] = ACTIONS(2921),
    [anon_sym_CR] = ACTIONS(2921),
    [anon_sym_CR_LF] = ACTIONS(2921),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_as] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_COMMA] = ACTIONS(2921),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_EQ] = ACTIONS(2921),
    [anon_sym_fn] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2921),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2921),
    [anon_sym_LT] = ACTIONS(2921),
    [anon_sym_GT] = ACTIONS(2921),
    [anon_sym_EQ_EQ] = ACTIONS(2921),
    [anon_sym_BANG_EQ] = ACTIONS(2921),
    [anon_sym_LT_EQ] = ACTIONS(2921),
    [anon_sym_GT_EQ] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2919),
    [anon_sym_struct] = ACTIONS(2921),
    [anon_sym_mut] = ACTIONS(2921),
    [anon_sym_COLON] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2921),
    [anon_sym_DASH_DASH] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_go] = ACTIONS(2921),
    [anon_sym_spawn] = ACTIONS(2921),
    [anon_sym_json_DOTdecode] = ACTIONS(2921),
    [anon_sym_PIPE] = ACTIONS(2921),
    [anon_sym_LBRACK2] = ACTIONS(2921),
    [anon_sym_TILDE] = ACTIONS(2921),
    [anon_sym_CARET] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2921),
    [anon_sym_LT_DASH] = ACTIONS(2921),
    [anon_sym_LT_LT] = ACTIONS(2921),
    [anon_sym_GT_GT] = ACTIONS(2921),
    [anon_sym_GT_GT_GT] = ACTIONS(2921),
    [anon_sym_AMP_CARET] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE] = ACTIONS(2921),
    [anon_sym_or] = ACTIONS(2921),
    [sym_none] = ACTIONS(2921),
    [sym_true] = ACTIONS(2921),
    [sym_false] = ACTIONS(2921),
    [sym_nil] = ACTIONS(2921),
    [anon_sym_QMARK_DOT] = ACTIONS(2921),
    [anon_sym_POUND_LBRACK] = ACTIONS(2921),
    [anon_sym_if] = ACTIONS(2921),
    [anon_sym_DOLLARif] = ACTIONS(2921),
    [anon_sym_is] = ACTIONS(2921),
    [anon_sym_BANGis] = ACTIONS(2921),
    [anon_sym_in] = ACTIONS(2921),
    [anon_sym_BANGin] = ACTIONS(2921),
    [anon_sym_match] = ACTIONS(2921),
    [anon_sym_select] = ACTIONS(2921),
    [anon_sym_STAR_EQ] = ACTIONS(2921),
    [anon_sym_SLASH_EQ] = ACTIONS(2921),
    [anon_sym_PERCENT_EQ] = ACTIONS(2921),
    [anon_sym_LT_LT_EQ] = ACTIONS(2921),
    [anon_sym_GT_GT_EQ] = ACTIONS(2921),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2921),
    [anon_sym_AMP_EQ] = ACTIONS(2921),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2921),
    [anon_sym_PLUS_EQ] = ACTIONS(2921),
    [anon_sym_DASH_EQ] = ACTIONS(2921),
    [anon_sym_PIPE_EQ] = ACTIONS(2921),
    [anon_sym_CARET_EQ] = ACTIONS(2921),
    [anon_sym_COLON_EQ] = ACTIONS(2921),
    [anon_sym_lock] = ACTIONS(2921),
    [anon_sym_rlock] = ACTIONS(2921),
    [anon_sym_unsafe] = ACTIONS(2921),
    [anon_sym_sql] = ACTIONS(2921),
    [sym_int_literal] = ACTIONS(2921),
    [sym_float_literal] = ACTIONS(2921),
    [sym_rune_literal] = ACTIONS(2921),
    [anon_sym_SQUOTE] = ACTIONS(2921),
    [anon_sym_DQUOTE] = ACTIONS(2921),
    [anon_sym_c_SQUOTE] = ACTIONS(2921),
    [anon_sym_c_DQUOTE] = ACTIONS(2921),
    [anon_sym_r_SQUOTE] = ACTIONS(2921),
    [anon_sym_r_DQUOTE] = ACTIONS(2921),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2921),
    [anon_sym_shared] = ACTIONS(2921),
    [anon_sym_map_LBRACK] = ACTIONS(2921),
    [anon_sym_chan] = ACTIONS(2921),
    [anon_sym_thread] = ACTIONS(2921),
    [anon_sym_atomic] = ACTIONS(2921),
    [anon_sym_assert] = ACTIONS(2921),
    [anon_sym_defer] = ACTIONS(2921),
    [anon_sym_goto] = ACTIONS(2921),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2921),
    [anon_sym_return] = ACTIONS(2921),
    [anon_sym_DOLLARfor] = ACTIONS(2921),
    [anon_sym_for] = ACTIONS(2921),
    [anon_sym_POUND] = ACTIONS(2921),
    [anon_sym_asm] = ACTIONS(2921),
  },
  [1057] = {
    [sym_line_comment] = STATE(1057),
    [sym_block_comment] = STATE(1057),
    [sym_identifier] = ACTIONS(2925),
    [anon_sym_LF] = ACTIONS(2925),
    [anon_sym_CR] = ACTIONS(2925),
    [anon_sym_CR_LF] = ACTIONS(2925),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2925),
    [anon_sym_DOT] = ACTIONS(2925),
    [anon_sym_as] = ACTIONS(2925),
    [anon_sym_LBRACE] = ACTIONS(2925),
    [anon_sym_COMMA] = ACTIONS(2925),
    [anon_sym_RBRACE] = ACTIONS(2925),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_EQ] = ACTIONS(2925),
    [anon_sym_fn] = ACTIONS(2925),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_STAR] = ACTIONS(2925),
    [anon_sym_SLASH] = ACTIONS(2925),
    [anon_sym_PERCENT] = ACTIONS(2925),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_GT] = ACTIONS(2925),
    [anon_sym_EQ_EQ] = ACTIONS(2925),
    [anon_sym_BANG_EQ] = ACTIONS(2925),
    [anon_sym_LT_EQ] = ACTIONS(2925),
    [anon_sym_GT_EQ] = ACTIONS(2925),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_struct] = ACTIONS(2925),
    [anon_sym_mut] = ACTIONS(2925),
    [anon_sym_COLON] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2925),
    [anon_sym_DASH_DASH] = ACTIONS(2925),
    [anon_sym_QMARK] = ACTIONS(2925),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_go] = ACTIONS(2925),
    [anon_sym_spawn] = ACTIONS(2925),
    [anon_sym_json_DOTdecode] = ACTIONS(2925),
    [anon_sym_PIPE] = ACTIONS(2925),
    [anon_sym_LBRACK2] = ACTIONS(2925),
    [anon_sym_TILDE] = ACTIONS(2925),
    [anon_sym_CARET] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym_LT_DASH] = ACTIONS(2925),
    [anon_sym_LT_LT] = ACTIONS(2925),
    [anon_sym_GT_GT] = ACTIONS(2925),
    [anon_sym_GT_GT_GT] = ACTIONS(2925),
    [anon_sym_AMP_CARET] = ACTIONS(2925),
    [anon_sym_AMP_AMP] = ACTIONS(2925),
    [anon_sym_PIPE_PIPE] = ACTIONS(2925),
    [anon_sym_or] = ACTIONS(2925),
    [sym_none] = ACTIONS(2925),
    [sym_true] = ACTIONS(2925),
    [sym_false] = ACTIONS(2925),
    [sym_nil] = ACTIONS(2925),
    [anon_sym_QMARK_DOT] = ACTIONS(2925),
    [anon_sym_POUND_LBRACK] = ACTIONS(2925),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_DOLLARif] = ACTIONS(2925),
    [anon_sym_is] = ACTIONS(2925),
    [anon_sym_BANGis] = ACTIONS(2925),
    [anon_sym_in] = ACTIONS(2925),
    [anon_sym_BANGin] = ACTIONS(2925),
    [anon_sym_match] = ACTIONS(2925),
    [anon_sym_select] = ACTIONS(2925),
    [anon_sym_STAR_EQ] = ACTIONS(2925),
    [anon_sym_SLASH_EQ] = ACTIONS(2925),
    [anon_sym_PERCENT_EQ] = ACTIONS(2925),
    [anon_sym_LT_LT_EQ] = ACTIONS(2925),
    [anon_sym_GT_GT_EQ] = ACTIONS(2925),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2925),
    [anon_sym_AMP_EQ] = ACTIONS(2925),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(2925),
    [anon_sym_DASH_EQ] = ACTIONS(2925),
    [anon_sym_PIPE_EQ] = ACTIONS(2925),
    [anon_sym_CARET_EQ] = ACTIONS(2925),
    [anon_sym_COLON_EQ] = ACTIONS(2925),
    [anon_sym_lock] = ACTIONS(2925),
    [anon_sym_rlock] = ACTIONS(2925),
    [anon_sym_unsafe] = ACTIONS(2925),
    [anon_sym_sql] = ACTIONS(2925),
    [sym_int_literal] = ACTIONS(2925),
    [sym_float_literal] = ACTIONS(2925),
    [sym_rune_literal] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2925),
    [anon_sym_DQUOTE] = ACTIONS(2925),
    [anon_sym_c_SQUOTE] = ACTIONS(2925),
    [anon_sym_c_DQUOTE] = ACTIONS(2925),
    [anon_sym_r_SQUOTE] = ACTIONS(2925),
    [anon_sym_r_DQUOTE] = ACTIONS(2925),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2925),
    [anon_sym_shared] = ACTIONS(2925),
    [anon_sym_map_LBRACK] = ACTIONS(2925),
    [anon_sym_chan] = ACTIONS(2925),
    [anon_sym_thread] = ACTIONS(2925),
    [anon_sym_atomic] = ACTIONS(2925),
    [anon_sym_assert] = ACTIONS(2925),
    [anon_sym_defer] = ACTIONS(2925),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2925),
    [anon_sym_continue] = ACTIONS(2925),
    [anon_sym_return] = ACTIONS(2925),
    [anon_sym_DOLLARfor] = ACTIONS(2925),
    [anon_sym_for] = ACTIONS(2925),
    [anon_sym_POUND] = ACTIONS(2925),
    [anon_sym_asm] = ACTIONS(2925),
  },
  [1058] = {
    [sym_line_comment] = STATE(1058),
    [sym_block_comment] = STATE(1058),
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_LF] = ACTIONS(3019),
    [anon_sym_CR] = ACTIONS(3019),
    [anon_sym_CR_LF] = ACTIONS(3019),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(3019),
    [anon_sym_as] = ACTIONS(3019),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_COMMA] = ACTIONS(3019),
    [anon_sym_RBRACE] = ACTIONS(3019),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym_EQ] = ACTIONS(3019),
    [anon_sym_fn] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_STAR] = ACTIONS(3019),
    [anon_sym_SLASH] = ACTIONS(3019),
    [anon_sym_PERCENT] = ACTIONS(3019),
    [anon_sym_LT] = ACTIONS(3019),
    [anon_sym_GT] = ACTIONS(3019),
    [anon_sym_EQ_EQ] = ACTIONS(3019),
    [anon_sym_BANG_EQ] = ACTIONS(3019),
    [anon_sym_LT_EQ] = ACTIONS(3019),
    [anon_sym_GT_EQ] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3017),
    [anon_sym_struct] = ACTIONS(3019),
    [anon_sym_mut] = ACTIONS(3019),
    [anon_sym_COLON] = ACTIONS(3019),
    [anon_sym_PLUS_PLUS] = ACTIONS(3019),
    [anon_sym_DASH_DASH] = ACTIONS(3019),
    [anon_sym_QMARK] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_go] = ACTIONS(3019),
    [anon_sym_spawn] = ACTIONS(3019),
    [anon_sym_json_DOTdecode] = ACTIONS(3019),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_LBRACK2] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_LT_DASH] = ACTIONS(3019),
    [anon_sym_LT_LT] = ACTIONS(3019),
    [anon_sym_GT_GT] = ACTIONS(3019),
    [anon_sym_GT_GT_GT] = ACTIONS(3019),
    [anon_sym_AMP_CARET] = ACTIONS(3019),
    [anon_sym_AMP_AMP] = ACTIONS(3019),
    [anon_sym_PIPE_PIPE] = ACTIONS(3019),
    [anon_sym_or] = ACTIONS(3019),
    [sym_none] = ACTIONS(3019),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_nil] = ACTIONS(3019),
    [anon_sym_QMARK_DOT] = ACTIONS(3019),
    [anon_sym_POUND_LBRACK] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_DOLLARif] = ACTIONS(3019),
    [anon_sym_is] = ACTIONS(3019),
    [anon_sym_BANGis] = ACTIONS(3019),
    [anon_sym_in] = ACTIONS(3019),
    [anon_sym_BANGin] = ACTIONS(3019),
    [anon_sym_match] = ACTIONS(3019),
    [anon_sym_select] = ACTIONS(3019),
    [anon_sym_STAR_EQ] = ACTIONS(3019),
    [anon_sym_SLASH_EQ] = ACTIONS(3019),
    [anon_sym_PERCENT_EQ] = ACTIONS(3019),
    [anon_sym_LT_LT_EQ] = ACTIONS(3019),
    [anon_sym_GT_GT_EQ] = ACTIONS(3019),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3019),
    [anon_sym_AMP_EQ] = ACTIONS(3019),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3019),
    [anon_sym_PLUS_EQ] = ACTIONS(3019),
    [anon_sym_DASH_EQ] = ACTIONS(3019),
    [anon_sym_PIPE_EQ] = ACTIONS(3019),
    [anon_sym_CARET_EQ] = ACTIONS(3019),
    [anon_sym_COLON_EQ] = ACTIONS(3019),
    [anon_sym_lock] = ACTIONS(3019),
    [anon_sym_rlock] = ACTIONS(3019),
    [anon_sym_unsafe] = ACTIONS(3019),
    [anon_sym_sql] = ACTIONS(3019),
    [sym_int_literal] = ACTIONS(3019),
    [sym_float_literal] = ACTIONS(3019),
    [sym_rune_literal] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_c_SQUOTE] = ACTIONS(3019),
    [anon_sym_c_DQUOTE] = ACTIONS(3019),
    [anon_sym_r_SQUOTE] = ACTIONS(3019),
    [anon_sym_r_DQUOTE] = ACTIONS(3019),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3019),
    [anon_sym_shared] = ACTIONS(3019),
    [anon_sym_map_LBRACK] = ACTIONS(3019),
    [anon_sym_chan] = ACTIONS(3019),
    [anon_sym_thread] = ACTIONS(3019),
    [anon_sym_atomic] = ACTIONS(3019),
    [anon_sym_assert] = ACTIONS(3019),
    [anon_sym_defer] = ACTIONS(3019),
    [anon_sym_goto] = ACTIONS(3019),
    [anon_sym_break] = ACTIONS(3019),
    [anon_sym_continue] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_DOLLARfor] = ACTIONS(3019),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_POUND] = ACTIONS(3019),
    [anon_sym_asm] = ACTIONS(3019),
  },
  [1059] = {
    [sym_line_comment] = STATE(1059),
    [sym_block_comment] = STATE(1059),
    [sym_identifier] = ACTIONS(2187),
    [anon_sym_LF] = ACTIONS(2187),
    [anon_sym_CR] = ACTIONS(2187),
    [anon_sym_CR_LF] = ACTIONS(2187),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2187),
    [anon_sym_DOT] = ACTIONS(2187),
    [anon_sym_as] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_RBRACE] = ACTIONS(2187),
    [anon_sym_LPAREN] = ACTIONS(2187),
    [anon_sym_EQ] = ACTIONS(2187),
    [anon_sym_fn] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [anon_sym_LT] = ACTIONS(2187),
    [anon_sym_GT] = ACTIONS(2187),
    [anon_sym_EQ_EQ] = ACTIONS(2187),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2187),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2185),
    [anon_sym_struct] = ACTIONS(2187),
    [anon_sym_mut] = ACTIONS(2187),
    [anon_sym_COLON] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_go] = ACTIONS(2187),
    [anon_sym_spawn] = ACTIONS(2187),
    [anon_sym_json_DOTdecode] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2187),
    [anon_sym_LBRACK2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_LT_DASH] = ACTIONS(2187),
    [anon_sym_LT_LT] = ACTIONS(2187),
    [anon_sym_GT_GT] = ACTIONS(2187),
    [anon_sym_GT_GT_GT] = ACTIONS(2187),
    [anon_sym_AMP_CARET] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2187),
    [sym_none] = ACTIONS(2187),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [sym_nil] = ACTIONS(2187),
    [anon_sym_QMARK_DOT] = ACTIONS(2187),
    [anon_sym_POUND_LBRACK] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_DOLLARif] = ACTIONS(2187),
    [anon_sym_is] = ACTIONS(2187),
    [anon_sym_BANGis] = ACTIONS(2187),
    [anon_sym_in] = ACTIONS(2187),
    [anon_sym_BANGin] = ACTIONS(2187),
    [anon_sym_match] = ACTIONS(2187),
    [anon_sym_select] = ACTIONS(2187),
    [anon_sym_STAR_EQ] = ACTIONS(2187),
    [anon_sym_SLASH_EQ] = ACTIONS(2187),
    [anon_sym_PERCENT_EQ] = ACTIONS(2187),
    [anon_sym_LT_LT_EQ] = ACTIONS(2187),
    [anon_sym_GT_GT_EQ] = ACTIONS(2187),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2187),
    [anon_sym_AMP_EQ] = ACTIONS(2187),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2187),
    [anon_sym_PLUS_EQ] = ACTIONS(2187),
    [anon_sym_DASH_EQ] = ACTIONS(2187),
    [anon_sym_PIPE_EQ] = ACTIONS(2187),
    [anon_sym_CARET_EQ] = ACTIONS(2187),
    [anon_sym_COLON_EQ] = ACTIONS(2187),
    [anon_sym_lock] = ACTIONS(2187),
    [anon_sym_rlock] = ACTIONS(2187),
    [anon_sym_unsafe] = ACTIONS(2187),
    [anon_sym_sql] = ACTIONS(2187),
    [sym_int_literal] = ACTIONS(2187),
    [sym_float_literal] = ACTIONS(2187),
    [sym_rune_literal] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(2187),
    [anon_sym_DQUOTE] = ACTIONS(2187),
    [anon_sym_c_SQUOTE] = ACTIONS(2187),
    [anon_sym_c_DQUOTE] = ACTIONS(2187),
    [anon_sym_r_SQUOTE] = ACTIONS(2187),
    [anon_sym_r_DQUOTE] = ACTIONS(2187),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2187),
    [anon_sym_shared] = ACTIONS(2187),
    [anon_sym_map_LBRACK] = ACTIONS(2187),
    [anon_sym_chan] = ACTIONS(2187),
    [anon_sym_thread] = ACTIONS(2187),
    [anon_sym_atomic] = ACTIONS(2187),
    [anon_sym_assert] = ACTIONS(2187),
    [anon_sym_defer] = ACTIONS(2187),
    [anon_sym_goto] = ACTIONS(2187),
    [anon_sym_break] = ACTIONS(2187),
    [anon_sym_continue] = ACTIONS(2187),
    [anon_sym_return] = ACTIONS(2187),
    [anon_sym_DOLLARfor] = ACTIONS(2187),
    [anon_sym_for] = ACTIONS(2187),
    [anon_sym_POUND] = ACTIONS(2187),
    [anon_sym_asm] = ACTIONS(2187),
  },
  [1060] = {
    [sym_line_comment] = STATE(1060),
    [sym_block_comment] = STATE(1060),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_LF] = ACTIONS(2465),
    [anon_sym_CR] = ACTIONS(2465),
    [anon_sym_CR_LF] = ACTIONS(2465),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2465),
    [anon_sym_DOT] = ACTIONS(2465),
    [anon_sym_as] = ACTIONS(2465),
    [anon_sym_LBRACE] = ACTIONS(2465),
    [anon_sym_COMMA] = ACTIONS(2465),
    [anon_sym_RBRACE] = ACTIONS(2465),
    [anon_sym_LPAREN] = ACTIONS(2465),
    [anon_sym_EQ] = ACTIONS(2465),
    [anon_sym_fn] = ACTIONS(2465),
    [anon_sym_PLUS] = ACTIONS(2465),
    [anon_sym_DASH] = ACTIONS(2465),
    [anon_sym_STAR] = ACTIONS(2465),
    [anon_sym_SLASH] = ACTIONS(2465),
    [anon_sym_PERCENT] = ACTIONS(2465),
    [anon_sym_LT] = ACTIONS(2465),
    [anon_sym_GT] = ACTIONS(2465),
    [anon_sym_EQ_EQ] = ACTIONS(2465),
    [anon_sym_BANG_EQ] = ACTIONS(2465),
    [anon_sym_LT_EQ] = ACTIONS(2465),
    [anon_sym_GT_EQ] = ACTIONS(2465),
    [anon_sym_LBRACK] = ACTIONS(2463),
    [anon_sym_struct] = ACTIONS(2465),
    [anon_sym_mut] = ACTIONS(2465),
    [anon_sym_COLON] = ACTIONS(2465),
    [anon_sym_PLUS_PLUS] = ACTIONS(2465),
    [anon_sym_DASH_DASH] = ACTIONS(2465),
    [anon_sym_QMARK] = ACTIONS(2465),
    [anon_sym_BANG] = ACTIONS(2465),
    [anon_sym_go] = ACTIONS(2465),
    [anon_sym_spawn] = ACTIONS(2465),
    [anon_sym_json_DOTdecode] = ACTIONS(2465),
    [anon_sym_PIPE] = ACTIONS(2465),
    [anon_sym_LBRACK2] = ACTIONS(2465),
    [anon_sym_TILDE] = ACTIONS(2465),
    [anon_sym_CARET] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_LT_DASH] = ACTIONS(2465),
    [anon_sym_LT_LT] = ACTIONS(2465),
    [anon_sym_GT_GT] = ACTIONS(2465),
    [anon_sym_GT_GT_GT] = ACTIONS(2465),
    [anon_sym_AMP_CARET] = ACTIONS(2465),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_PIPE_PIPE] = ACTIONS(2465),
    [anon_sym_or] = ACTIONS(2465),
    [sym_none] = ACTIONS(2465),
    [sym_true] = ACTIONS(2465),
    [sym_false] = ACTIONS(2465),
    [sym_nil] = ACTIONS(2465),
    [anon_sym_QMARK_DOT] = ACTIONS(2465),
    [anon_sym_POUND_LBRACK] = ACTIONS(2465),
    [anon_sym_if] = ACTIONS(2465),
    [anon_sym_DOLLARif] = ACTIONS(2465),
    [anon_sym_is] = ACTIONS(2465),
    [anon_sym_BANGis] = ACTIONS(2465),
    [anon_sym_in] = ACTIONS(2465),
    [anon_sym_BANGin] = ACTIONS(2465),
    [anon_sym_match] = ACTIONS(2465),
    [anon_sym_select] = ACTIONS(2465),
    [anon_sym_STAR_EQ] = ACTIONS(2465),
    [anon_sym_SLASH_EQ] = ACTIONS(2465),
    [anon_sym_PERCENT_EQ] = ACTIONS(2465),
    [anon_sym_LT_LT_EQ] = ACTIONS(2465),
    [anon_sym_GT_GT_EQ] = ACTIONS(2465),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2465),
    [anon_sym_AMP_EQ] = ACTIONS(2465),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2465),
    [anon_sym_PLUS_EQ] = ACTIONS(2465),
    [anon_sym_DASH_EQ] = ACTIONS(2465),
    [anon_sym_PIPE_EQ] = ACTIONS(2465),
    [anon_sym_CARET_EQ] = ACTIONS(2465),
    [anon_sym_COLON_EQ] = ACTIONS(2465),
    [anon_sym_lock] = ACTIONS(2465),
    [anon_sym_rlock] = ACTIONS(2465),
    [anon_sym_unsafe] = ACTIONS(2465),
    [anon_sym_sql] = ACTIONS(2465),
    [sym_int_literal] = ACTIONS(2465),
    [sym_float_literal] = ACTIONS(2465),
    [sym_rune_literal] = ACTIONS(2465),
    [anon_sym_SQUOTE] = ACTIONS(2465),
    [anon_sym_DQUOTE] = ACTIONS(2465),
    [anon_sym_c_SQUOTE] = ACTIONS(2465),
    [anon_sym_c_DQUOTE] = ACTIONS(2465),
    [anon_sym_r_SQUOTE] = ACTIONS(2465),
    [anon_sym_r_DQUOTE] = ACTIONS(2465),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2465),
    [anon_sym_shared] = ACTIONS(2465),
    [anon_sym_map_LBRACK] = ACTIONS(2465),
    [anon_sym_chan] = ACTIONS(2465),
    [anon_sym_thread] = ACTIONS(2465),
    [anon_sym_atomic] = ACTIONS(2465),
    [anon_sym_assert] = ACTIONS(2465),
    [anon_sym_defer] = ACTIONS(2465),
    [anon_sym_goto] = ACTIONS(2465),
    [anon_sym_break] = ACTIONS(2465),
    [anon_sym_continue] = ACTIONS(2465),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_DOLLARfor] = ACTIONS(2465),
    [anon_sym_for] = ACTIONS(2465),
    [anon_sym_POUND] = ACTIONS(2465),
    [anon_sym_asm] = ACTIONS(2465),
  },
  [1061] = {
    [sym_line_comment] = STATE(1061),
    [sym_block_comment] = STATE(1061),
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_LF] = ACTIONS(2669),
    [anon_sym_CR] = ACTIONS(2669),
    [anon_sym_CR_LF] = ACTIONS(2669),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2669),
    [anon_sym_DOT] = ACTIONS(2669),
    [anon_sym_as] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2669),
    [anon_sym_COMMA] = ACTIONS(2669),
    [anon_sym_RBRACE] = ACTIONS(2669),
    [anon_sym_LPAREN] = ACTIONS(2669),
    [anon_sym_EQ] = ACTIONS(2669),
    [anon_sym_fn] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2669),
    [anon_sym_SLASH] = ACTIONS(2669),
    [anon_sym_PERCENT] = ACTIONS(2669),
    [anon_sym_LT] = ACTIONS(2669),
    [anon_sym_GT] = ACTIONS(2669),
    [anon_sym_EQ_EQ] = ACTIONS(2669),
    [anon_sym_BANG_EQ] = ACTIONS(2669),
    [anon_sym_LT_EQ] = ACTIONS(2669),
    [anon_sym_GT_EQ] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2667),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_mut] = ACTIONS(2669),
    [anon_sym_COLON] = ACTIONS(2669),
    [anon_sym_PLUS_PLUS] = ACTIONS(2669),
    [anon_sym_DASH_DASH] = ACTIONS(2669),
    [anon_sym_QMARK] = ACTIONS(2669),
    [anon_sym_BANG] = ACTIONS(2669),
    [anon_sym_go] = ACTIONS(2669),
    [anon_sym_spawn] = ACTIONS(2669),
    [anon_sym_json_DOTdecode] = ACTIONS(2669),
    [anon_sym_PIPE] = ACTIONS(2669),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_TILDE] = ACTIONS(2669),
    [anon_sym_CARET] = ACTIONS(2669),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_LT_DASH] = ACTIONS(2669),
    [anon_sym_LT_LT] = ACTIONS(2669),
    [anon_sym_GT_GT] = ACTIONS(2669),
    [anon_sym_GT_GT_GT] = ACTIONS(2669),
    [anon_sym_AMP_CARET] = ACTIONS(2669),
    [anon_sym_AMP_AMP] = ACTIONS(2669),
    [anon_sym_PIPE_PIPE] = ACTIONS(2669),
    [anon_sym_or] = ACTIONS(2669),
    [sym_none] = ACTIONS(2669),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [sym_nil] = ACTIONS(2669),
    [anon_sym_QMARK_DOT] = ACTIONS(2669),
    [anon_sym_POUND_LBRACK] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_DOLLARif] = ACTIONS(2669),
    [anon_sym_is] = ACTIONS(2669),
    [anon_sym_BANGis] = ACTIONS(2669),
    [anon_sym_in] = ACTIONS(2669),
    [anon_sym_BANGin] = ACTIONS(2669),
    [anon_sym_match] = ACTIONS(2669),
    [anon_sym_select] = ACTIONS(2669),
    [anon_sym_STAR_EQ] = ACTIONS(2669),
    [anon_sym_SLASH_EQ] = ACTIONS(2669),
    [anon_sym_PERCENT_EQ] = ACTIONS(2669),
    [anon_sym_LT_LT_EQ] = ACTIONS(2669),
    [anon_sym_GT_GT_EQ] = ACTIONS(2669),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2669),
    [anon_sym_AMP_EQ] = ACTIONS(2669),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2669),
    [anon_sym_PLUS_EQ] = ACTIONS(2669),
    [anon_sym_DASH_EQ] = ACTIONS(2669),
    [anon_sym_PIPE_EQ] = ACTIONS(2669),
    [anon_sym_CARET_EQ] = ACTIONS(2669),
    [anon_sym_COLON_EQ] = ACTIONS(2669),
    [anon_sym_lock] = ACTIONS(2669),
    [anon_sym_rlock] = ACTIONS(2669),
    [anon_sym_unsafe] = ACTIONS(2669),
    [anon_sym_sql] = ACTIONS(2669),
    [sym_int_literal] = ACTIONS(2669),
    [sym_float_literal] = ACTIONS(2669),
    [sym_rune_literal] = ACTIONS(2669),
    [anon_sym_SQUOTE] = ACTIONS(2669),
    [anon_sym_DQUOTE] = ACTIONS(2669),
    [anon_sym_c_SQUOTE] = ACTIONS(2669),
    [anon_sym_c_DQUOTE] = ACTIONS(2669),
    [anon_sym_r_SQUOTE] = ACTIONS(2669),
    [anon_sym_r_DQUOTE] = ACTIONS(2669),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2669),
    [anon_sym_shared] = ACTIONS(2669),
    [anon_sym_map_LBRACK] = ACTIONS(2669),
    [anon_sym_chan] = ACTIONS(2669),
    [anon_sym_thread] = ACTIONS(2669),
    [anon_sym_atomic] = ACTIONS(2669),
    [anon_sym_assert] = ACTIONS(2669),
    [anon_sym_defer] = ACTIONS(2669),
    [anon_sym_goto] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_DOLLARfor] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_POUND] = ACTIONS(2669),
    [anon_sym_asm] = ACTIONS(2669),
  },
  [1062] = {
    [sym_line_comment] = STATE(1062),
    [sym_block_comment] = STATE(1062),
    [sym_identifier] = ACTIONS(2989),
    [anon_sym_LF] = ACTIONS(2989),
    [anon_sym_CR] = ACTIONS(2989),
    [anon_sym_CR_LF] = ACTIONS(2989),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2989),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_as] = ACTIONS(2989),
    [anon_sym_LBRACE] = ACTIONS(2989),
    [anon_sym_COMMA] = ACTIONS(2989),
    [anon_sym_RBRACE] = ACTIONS(2989),
    [anon_sym_LPAREN] = ACTIONS(2989),
    [anon_sym_EQ] = ACTIONS(2989),
    [anon_sym_fn] = ACTIONS(2989),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2989),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2989),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_EQ_EQ] = ACTIONS(2989),
    [anon_sym_BANG_EQ] = ACTIONS(2989),
    [anon_sym_LT_EQ] = ACTIONS(2989),
    [anon_sym_GT_EQ] = ACTIONS(2989),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_struct] = ACTIONS(2989),
    [anon_sym_mut] = ACTIONS(2989),
    [anon_sym_COLON] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2989),
    [anon_sym_DASH_DASH] = ACTIONS(2989),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_go] = ACTIONS(2989),
    [anon_sym_spawn] = ACTIONS(2989),
    [anon_sym_json_DOTdecode] = ACTIONS(2989),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_LBRACK2] = ACTIONS(2989),
    [anon_sym_TILDE] = ACTIONS(2989),
    [anon_sym_CARET] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_LT_DASH] = ACTIONS(2989),
    [anon_sym_LT_LT] = ACTIONS(2989),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2989),
    [anon_sym_AMP_CARET] = ACTIONS(2989),
    [anon_sym_AMP_AMP] = ACTIONS(2989),
    [anon_sym_PIPE_PIPE] = ACTIONS(2989),
    [anon_sym_or] = ACTIONS(2989),
    [sym_none] = ACTIONS(2989),
    [sym_true] = ACTIONS(2989),
    [sym_false] = ACTIONS(2989),
    [sym_nil] = ACTIONS(2989),
    [anon_sym_QMARK_DOT] = ACTIONS(2989),
    [anon_sym_POUND_LBRACK] = ACTIONS(2989),
    [anon_sym_if] = ACTIONS(2989),
    [anon_sym_DOLLARif] = ACTIONS(2989),
    [anon_sym_is] = ACTIONS(2989),
    [anon_sym_BANGis] = ACTIONS(2989),
    [anon_sym_in] = ACTIONS(2989),
    [anon_sym_BANGin] = ACTIONS(2989),
    [anon_sym_match] = ACTIONS(2989),
    [anon_sym_select] = ACTIONS(2989),
    [anon_sym_STAR_EQ] = ACTIONS(2989),
    [anon_sym_SLASH_EQ] = ACTIONS(2989),
    [anon_sym_PERCENT_EQ] = ACTIONS(2989),
    [anon_sym_LT_LT_EQ] = ACTIONS(2989),
    [anon_sym_GT_GT_EQ] = ACTIONS(2989),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2989),
    [anon_sym_AMP_EQ] = ACTIONS(2989),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2989),
    [anon_sym_PLUS_EQ] = ACTIONS(2989),
    [anon_sym_DASH_EQ] = ACTIONS(2989),
    [anon_sym_PIPE_EQ] = ACTIONS(2989),
    [anon_sym_CARET_EQ] = ACTIONS(2989),
    [anon_sym_COLON_EQ] = ACTIONS(2989),
    [anon_sym_lock] = ACTIONS(2989),
    [anon_sym_rlock] = ACTIONS(2989),
    [anon_sym_unsafe] = ACTIONS(2989),
    [anon_sym_sql] = ACTIONS(2989),
    [sym_int_literal] = ACTIONS(2989),
    [sym_float_literal] = ACTIONS(2989),
    [sym_rune_literal] = ACTIONS(2989),
    [anon_sym_SQUOTE] = ACTIONS(2989),
    [anon_sym_DQUOTE] = ACTIONS(2989),
    [anon_sym_c_SQUOTE] = ACTIONS(2989),
    [anon_sym_c_DQUOTE] = ACTIONS(2989),
    [anon_sym_r_SQUOTE] = ACTIONS(2989),
    [anon_sym_r_DQUOTE] = ACTIONS(2989),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2989),
    [anon_sym_shared] = ACTIONS(2989),
    [anon_sym_map_LBRACK] = ACTIONS(2989),
    [anon_sym_chan] = ACTIONS(2989),
    [anon_sym_thread] = ACTIONS(2989),
    [anon_sym_atomic] = ACTIONS(2989),
    [anon_sym_assert] = ACTIONS(2989),
    [anon_sym_defer] = ACTIONS(2989),
    [anon_sym_goto] = ACTIONS(2989),
    [anon_sym_break] = ACTIONS(2989),
    [anon_sym_continue] = ACTIONS(2989),
    [anon_sym_return] = ACTIONS(2989),
    [anon_sym_DOLLARfor] = ACTIONS(2989),
    [anon_sym_for] = ACTIONS(2989),
    [anon_sym_POUND] = ACTIONS(2989),
    [anon_sym_asm] = ACTIONS(2989),
  },
  [1063] = {
    [sym_line_comment] = STATE(1063),
    [sym_block_comment] = STATE(1063),
    [sym_identifier] = ACTIONS(2993),
    [anon_sym_LF] = ACTIONS(2993),
    [anon_sym_CR] = ACTIONS(2993),
    [anon_sym_CR_LF] = ACTIONS(2993),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2993),
    [anon_sym_DOT] = ACTIONS(2993),
    [anon_sym_as] = ACTIONS(2993),
    [anon_sym_LBRACE] = ACTIONS(2993),
    [anon_sym_COMMA] = ACTIONS(2993),
    [anon_sym_RBRACE] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2993),
    [anon_sym_EQ] = ACTIONS(2993),
    [anon_sym_fn] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2993),
    [anon_sym_DASH] = ACTIONS(2993),
    [anon_sym_STAR] = ACTIONS(2993),
    [anon_sym_SLASH] = ACTIONS(2993),
    [anon_sym_PERCENT] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(2993),
    [anon_sym_EQ_EQ] = ACTIONS(2993),
    [anon_sym_BANG_EQ] = ACTIONS(2993),
    [anon_sym_LT_EQ] = ACTIONS(2993),
    [anon_sym_GT_EQ] = ACTIONS(2993),
    [anon_sym_LBRACK] = ACTIONS(2991),
    [anon_sym_struct] = ACTIONS(2993),
    [anon_sym_mut] = ACTIONS(2993),
    [anon_sym_COLON] = ACTIONS(2993),
    [anon_sym_PLUS_PLUS] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2993),
    [anon_sym_QMARK] = ACTIONS(2993),
    [anon_sym_BANG] = ACTIONS(2993),
    [anon_sym_go] = ACTIONS(2993),
    [anon_sym_spawn] = ACTIONS(2993),
    [anon_sym_json_DOTdecode] = ACTIONS(2993),
    [anon_sym_PIPE] = ACTIONS(2993),
    [anon_sym_LBRACK2] = ACTIONS(2993),
    [anon_sym_TILDE] = ACTIONS(2993),
    [anon_sym_CARET] = ACTIONS(2993),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_LT_DASH] = ACTIONS(2993),
    [anon_sym_LT_LT] = ACTIONS(2993),
    [anon_sym_GT_GT] = ACTIONS(2993),
    [anon_sym_GT_GT_GT] = ACTIONS(2993),
    [anon_sym_AMP_CARET] = ACTIONS(2993),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [anon_sym_or] = ACTIONS(2993),
    [sym_none] = ACTIONS(2993),
    [sym_true] = ACTIONS(2993),
    [sym_false] = ACTIONS(2993),
    [sym_nil] = ACTIONS(2993),
    [anon_sym_QMARK_DOT] = ACTIONS(2993),
    [anon_sym_POUND_LBRACK] = ACTIONS(2993),
    [anon_sym_if] = ACTIONS(2993),
    [anon_sym_DOLLARif] = ACTIONS(2993),
    [anon_sym_is] = ACTIONS(2993),
    [anon_sym_BANGis] = ACTIONS(2993),
    [anon_sym_in] = ACTIONS(2993),
    [anon_sym_BANGin] = ACTIONS(2993),
    [anon_sym_match] = ACTIONS(2993),
    [anon_sym_select] = ACTIONS(2993),
    [anon_sym_STAR_EQ] = ACTIONS(2993),
    [anon_sym_SLASH_EQ] = ACTIONS(2993),
    [anon_sym_PERCENT_EQ] = ACTIONS(2993),
    [anon_sym_LT_LT_EQ] = ACTIONS(2993),
    [anon_sym_GT_GT_EQ] = ACTIONS(2993),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2993),
    [anon_sym_AMP_EQ] = ACTIONS(2993),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2993),
    [anon_sym_PLUS_EQ] = ACTIONS(2993),
    [anon_sym_DASH_EQ] = ACTIONS(2993),
    [anon_sym_PIPE_EQ] = ACTIONS(2993),
    [anon_sym_CARET_EQ] = ACTIONS(2993),
    [anon_sym_COLON_EQ] = ACTIONS(2993),
    [anon_sym_lock] = ACTIONS(2993),
    [anon_sym_rlock] = ACTIONS(2993),
    [anon_sym_unsafe] = ACTIONS(2993),
    [anon_sym_sql] = ACTIONS(2993),
    [sym_int_literal] = ACTIONS(2993),
    [sym_float_literal] = ACTIONS(2993),
    [sym_rune_literal] = ACTIONS(2993),
    [anon_sym_SQUOTE] = ACTIONS(2993),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [anon_sym_c_SQUOTE] = ACTIONS(2993),
    [anon_sym_c_DQUOTE] = ACTIONS(2993),
    [anon_sym_r_SQUOTE] = ACTIONS(2993),
    [anon_sym_r_DQUOTE] = ACTIONS(2993),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2993),
    [anon_sym_shared] = ACTIONS(2993),
    [anon_sym_map_LBRACK] = ACTIONS(2993),
    [anon_sym_chan] = ACTIONS(2993),
    [anon_sym_thread] = ACTIONS(2993),
    [anon_sym_atomic] = ACTIONS(2993),
    [anon_sym_assert] = ACTIONS(2993),
    [anon_sym_defer] = ACTIONS(2993),
    [anon_sym_goto] = ACTIONS(2993),
    [anon_sym_break] = ACTIONS(2993),
    [anon_sym_continue] = ACTIONS(2993),
    [anon_sym_return] = ACTIONS(2993),
    [anon_sym_DOLLARfor] = ACTIONS(2993),
    [anon_sym_for] = ACTIONS(2993),
    [anon_sym_POUND] = ACTIONS(2993),
    [anon_sym_asm] = ACTIONS(2993),
  },
  [1064] = {
    [sym_line_comment] = STATE(1064),
    [sym_block_comment] = STATE(1064),
    [sym_identifier] = ACTIONS(3023),
    [anon_sym_LF] = ACTIONS(3023),
    [anon_sym_CR] = ACTIONS(3023),
    [anon_sym_CR_LF] = ACTIONS(3023),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3023),
    [anon_sym_DOT] = ACTIONS(3023),
    [anon_sym_as] = ACTIONS(3023),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_COMMA] = ACTIONS(3023),
    [anon_sym_RBRACE] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_EQ] = ACTIONS(3023),
    [anon_sym_fn] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_STAR] = ACTIONS(3023),
    [anon_sym_SLASH] = ACTIONS(3023),
    [anon_sym_PERCENT] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3023),
    [anon_sym_GT] = ACTIONS(3023),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT_EQ] = ACTIONS(3023),
    [anon_sym_GT_EQ] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3021),
    [anon_sym_struct] = ACTIONS(3023),
    [anon_sym_mut] = ACTIONS(3023),
    [anon_sym_COLON] = ACTIONS(3023),
    [anon_sym_PLUS_PLUS] = ACTIONS(3023),
    [anon_sym_DASH_DASH] = ACTIONS(3023),
    [anon_sym_QMARK] = ACTIONS(3023),
    [anon_sym_BANG] = ACTIONS(3023),
    [anon_sym_go] = ACTIONS(3023),
    [anon_sym_spawn] = ACTIONS(3023),
    [anon_sym_json_DOTdecode] = ACTIONS(3023),
    [anon_sym_PIPE] = ACTIONS(3023),
    [anon_sym_LBRACK2] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3023),
    [anon_sym_CARET] = ACTIONS(3023),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_LT_DASH] = ACTIONS(3023),
    [anon_sym_LT_LT] = ACTIONS(3023),
    [anon_sym_GT_GT] = ACTIONS(3023),
    [anon_sym_GT_GT_GT] = ACTIONS(3023),
    [anon_sym_AMP_CARET] = ACTIONS(3023),
    [anon_sym_AMP_AMP] = ACTIONS(3023),
    [anon_sym_PIPE_PIPE] = ACTIONS(3023),
    [anon_sym_or] = ACTIONS(3023),
    [sym_none] = ACTIONS(3023),
    [sym_true] = ACTIONS(3023),
    [sym_false] = ACTIONS(3023),
    [sym_nil] = ACTIONS(3023),
    [anon_sym_QMARK_DOT] = ACTIONS(3023),
    [anon_sym_POUND_LBRACK] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_DOLLARif] = ACTIONS(3023),
    [anon_sym_is] = ACTIONS(3023),
    [anon_sym_BANGis] = ACTIONS(3023),
    [anon_sym_in] = ACTIONS(3023),
    [anon_sym_BANGin] = ACTIONS(3023),
    [anon_sym_match] = ACTIONS(3023),
    [anon_sym_select] = ACTIONS(3023),
    [anon_sym_STAR_EQ] = ACTIONS(3023),
    [anon_sym_SLASH_EQ] = ACTIONS(3023),
    [anon_sym_PERCENT_EQ] = ACTIONS(3023),
    [anon_sym_LT_LT_EQ] = ACTIONS(3023),
    [anon_sym_GT_GT_EQ] = ACTIONS(3023),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3023),
    [anon_sym_AMP_EQ] = ACTIONS(3023),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3023),
    [anon_sym_PLUS_EQ] = ACTIONS(3023),
    [anon_sym_DASH_EQ] = ACTIONS(3023),
    [anon_sym_PIPE_EQ] = ACTIONS(3023),
    [anon_sym_CARET_EQ] = ACTIONS(3023),
    [anon_sym_COLON_EQ] = ACTIONS(3023),
    [anon_sym_lock] = ACTIONS(3023),
    [anon_sym_rlock] = ACTIONS(3023),
    [anon_sym_unsafe] = ACTIONS(3023),
    [anon_sym_sql] = ACTIONS(3023),
    [sym_int_literal] = ACTIONS(3023),
    [sym_float_literal] = ACTIONS(3023),
    [sym_rune_literal] = ACTIONS(3023),
    [anon_sym_SQUOTE] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_c_SQUOTE] = ACTIONS(3023),
    [anon_sym_c_DQUOTE] = ACTIONS(3023),
    [anon_sym_r_SQUOTE] = ACTIONS(3023),
    [anon_sym_r_DQUOTE] = ACTIONS(3023),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3023),
    [anon_sym_shared] = ACTIONS(3023),
    [anon_sym_map_LBRACK] = ACTIONS(3023),
    [anon_sym_chan] = ACTIONS(3023),
    [anon_sym_thread] = ACTIONS(3023),
    [anon_sym_atomic] = ACTIONS(3023),
    [anon_sym_assert] = ACTIONS(3023),
    [anon_sym_defer] = ACTIONS(3023),
    [anon_sym_goto] = ACTIONS(3023),
    [anon_sym_break] = ACTIONS(3023),
    [anon_sym_continue] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_DOLLARfor] = ACTIONS(3023),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_POUND] = ACTIONS(3023),
    [anon_sym_asm] = ACTIONS(3023),
  },
  [1065] = {
    [sym_line_comment] = STATE(1065),
    [sym_block_comment] = STATE(1065),
    [sym_identifier] = ACTIONS(3001),
    [anon_sym_LF] = ACTIONS(3001),
    [anon_sym_CR] = ACTIONS(3001),
    [anon_sym_CR_LF] = ACTIONS(3001),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3001),
    [anon_sym_DOT] = ACTIONS(3001),
    [anon_sym_as] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_COMMA] = ACTIONS(3001),
    [anon_sym_RBRACE] = ACTIONS(3001),
    [anon_sym_LPAREN] = ACTIONS(3001),
    [anon_sym_EQ] = ACTIONS(3001),
    [anon_sym_fn] = ACTIONS(3001),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_STAR] = ACTIONS(3001),
    [anon_sym_SLASH] = ACTIONS(3001),
    [anon_sym_PERCENT] = ACTIONS(3001),
    [anon_sym_LT] = ACTIONS(3001),
    [anon_sym_GT] = ACTIONS(3001),
    [anon_sym_EQ_EQ] = ACTIONS(3001),
    [anon_sym_BANG_EQ] = ACTIONS(3001),
    [anon_sym_LT_EQ] = ACTIONS(3001),
    [anon_sym_GT_EQ] = ACTIONS(3001),
    [anon_sym_LBRACK] = ACTIONS(2999),
    [anon_sym_struct] = ACTIONS(3001),
    [anon_sym_mut] = ACTIONS(3001),
    [anon_sym_COLON] = ACTIONS(3001),
    [anon_sym_PLUS_PLUS] = ACTIONS(3001),
    [anon_sym_DASH_DASH] = ACTIONS(3001),
    [anon_sym_QMARK] = ACTIONS(3001),
    [anon_sym_BANG] = ACTIONS(3001),
    [anon_sym_go] = ACTIONS(3001),
    [anon_sym_spawn] = ACTIONS(3001),
    [anon_sym_json_DOTdecode] = ACTIONS(3001),
    [anon_sym_PIPE] = ACTIONS(3001),
    [anon_sym_LBRACK2] = ACTIONS(3001),
    [anon_sym_TILDE] = ACTIONS(3001),
    [anon_sym_CARET] = ACTIONS(3001),
    [anon_sym_AMP] = ACTIONS(3001),
    [anon_sym_LT_DASH] = ACTIONS(3001),
    [anon_sym_LT_LT] = ACTIONS(3001),
    [anon_sym_GT_GT] = ACTIONS(3001),
    [anon_sym_GT_GT_GT] = ACTIONS(3001),
    [anon_sym_AMP_CARET] = ACTIONS(3001),
    [anon_sym_AMP_AMP] = ACTIONS(3001),
    [anon_sym_PIPE_PIPE] = ACTIONS(3001),
    [anon_sym_or] = ACTIONS(3001),
    [sym_none] = ACTIONS(3001),
    [sym_true] = ACTIONS(3001),
    [sym_false] = ACTIONS(3001),
    [sym_nil] = ACTIONS(3001),
    [anon_sym_QMARK_DOT] = ACTIONS(3001),
    [anon_sym_POUND_LBRACK] = ACTIONS(3001),
    [anon_sym_if] = ACTIONS(3001),
    [anon_sym_DOLLARif] = ACTIONS(3001),
    [anon_sym_is] = ACTIONS(3001),
    [anon_sym_BANGis] = ACTIONS(3001),
    [anon_sym_in] = ACTIONS(3001),
    [anon_sym_BANGin] = ACTIONS(3001),
    [anon_sym_match] = ACTIONS(3001),
    [anon_sym_select] = ACTIONS(3001),
    [anon_sym_STAR_EQ] = ACTIONS(3001),
    [anon_sym_SLASH_EQ] = ACTIONS(3001),
    [anon_sym_PERCENT_EQ] = ACTIONS(3001),
    [anon_sym_LT_LT_EQ] = ACTIONS(3001),
    [anon_sym_GT_GT_EQ] = ACTIONS(3001),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3001),
    [anon_sym_AMP_EQ] = ACTIONS(3001),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3001),
    [anon_sym_PLUS_EQ] = ACTIONS(3001),
    [anon_sym_DASH_EQ] = ACTIONS(3001),
    [anon_sym_PIPE_EQ] = ACTIONS(3001),
    [anon_sym_CARET_EQ] = ACTIONS(3001),
    [anon_sym_COLON_EQ] = ACTIONS(3001),
    [anon_sym_lock] = ACTIONS(3001),
    [anon_sym_rlock] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(3001),
    [anon_sym_sql] = ACTIONS(3001),
    [sym_int_literal] = ACTIONS(3001),
    [sym_float_literal] = ACTIONS(3001),
    [sym_rune_literal] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3001),
    [anon_sym_DQUOTE] = ACTIONS(3001),
    [anon_sym_c_SQUOTE] = ACTIONS(3001),
    [anon_sym_c_DQUOTE] = ACTIONS(3001),
    [anon_sym_r_SQUOTE] = ACTIONS(3001),
    [anon_sym_r_DQUOTE] = ACTIONS(3001),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3001),
    [anon_sym_shared] = ACTIONS(3001),
    [anon_sym_map_LBRACK] = ACTIONS(3001),
    [anon_sym_chan] = ACTIONS(3001),
    [anon_sym_thread] = ACTIONS(3001),
    [anon_sym_atomic] = ACTIONS(3001),
    [anon_sym_assert] = ACTIONS(3001),
    [anon_sym_defer] = ACTIONS(3001),
    [anon_sym_goto] = ACTIONS(3001),
    [anon_sym_break] = ACTIONS(3001),
    [anon_sym_continue] = ACTIONS(3001),
    [anon_sym_return] = ACTIONS(3001),
    [anon_sym_DOLLARfor] = ACTIONS(3001),
    [anon_sym_for] = ACTIONS(3001),
    [anon_sym_POUND] = ACTIONS(3001),
    [anon_sym_asm] = ACTIONS(3001),
  },
  [1066] = {
    [sym_line_comment] = STATE(1066),
    [sym_block_comment] = STATE(1066),
    [sym_identifier] = ACTIONS(2997),
    [anon_sym_LF] = ACTIONS(2997),
    [anon_sym_CR] = ACTIONS(2997),
    [anon_sym_CR_LF] = ACTIONS(2997),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2997),
    [anon_sym_DOT] = ACTIONS(2997),
    [anon_sym_as] = ACTIONS(2997),
    [anon_sym_LBRACE] = ACTIONS(2997),
    [anon_sym_COMMA] = ACTIONS(2997),
    [anon_sym_RBRACE] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(2997),
    [anon_sym_EQ] = ACTIONS(2997),
    [anon_sym_fn] = ACTIONS(2997),
    [anon_sym_PLUS] = ACTIONS(2997),
    [anon_sym_DASH] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(2997),
    [anon_sym_SLASH] = ACTIONS(2997),
    [anon_sym_PERCENT] = ACTIONS(2997),
    [anon_sym_LT] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(2997),
    [anon_sym_EQ_EQ] = ACTIONS(2997),
    [anon_sym_BANG_EQ] = ACTIONS(2997),
    [anon_sym_LT_EQ] = ACTIONS(2997),
    [anon_sym_GT_EQ] = ACTIONS(2997),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_struct] = ACTIONS(2997),
    [anon_sym_mut] = ACTIONS(2997),
    [anon_sym_COLON] = ACTIONS(2997),
    [anon_sym_PLUS_PLUS] = ACTIONS(2997),
    [anon_sym_DASH_DASH] = ACTIONS(2997),
    [anon_sym_QMARK] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2997),
    [anon_sym_go] = ACTIONS(2997),
    [anon_sym_spawn] = ACTIONS(2997),
    [anon_sym_json_DOTdecode] = ACTIONS(2997),
    [anon_sym_PIPE] = ACTIONS(2997),
    [anon_sym_LBRACK2] = ACTIONS(2997),
    [anon_sym_TILDE] = ACTIONS(2997),
    [anon_sym_CARET] = ACTIONS(2997),
    [anon_sym_AMP] = ACTIONS(2997),
    [anon_sym_LT_DASH] = ACTIONS(2997),
    [anon_sym_LT_LT] = ACTIONS(2997),
    [anon_sym_GT_GT] = ACTIONS(2997),
    [anon_sym_GT_GT_GT] = ACTIONS(2997),
    [anon_sym_AMP_CARET] = ACTIONS(2997),
    [anon_sym_AMP_AMP] = ACTIONS(2997),
    [anon_sym_PIPE_PIPE] = ACTIONS(2997),
    [anon_sym_or] = ACTIONS(2997),
    [sym_none] = ACTIONS(2997),
    [sym_true] = ACTIONS(2997),
    [sym_false] = ACTIONS(2997),
    [sym_nil] = ACTIONS(2997),
    [anon_sym_QMARK_DOT] = ACTIONS(2997),
    [anon_sym_POUND_LBRACK] = ACTIONS(2997),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_DOLLARif] = ACTIONS(2997),
    [anon_sym_is] = ACTIONS(2997),
    [anon_sym_BANGis] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(2997),
    [anon_sym_BANGin] = ACTIONS(2997),
    [anon_sym_match] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [anon_sym_STAR_EQ] = ACTIONS(2997),
    [anon_sym_SLASH_EQ] = ACTIONS(2997),
    [anon_sym_PERCENT_EQ] = ACTIONS(2997),
    [anon_sym_LT_LT_EQ] = ACTIONS(2997),
    [anon_sym_GT_GT_EQ] = ACTIONS(2997),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2997),
    [anon_sym_AMP_EQ] = ACTIONS(2997),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2997),
    [anon_sym_PLUS_EQ] = ACTIONS(2997),
    [anon_sym_DASH_EQ] = ACTIONS(2997),
    [anon_sym_PIPE_EQ] = ACTIONS(2997),
    [anon_sym_CARET_EQ] = ACTIONS(2997),
    [anon_sym_COLON_EQ] = ACTIONS(2997),
    [anon_sym_lock] = ACTIONS(2997),
    [anon_sym_rlock] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(2997),
    [anon_sym_sql] = ACTIONS(2997),
    [sym_int_literal] = ACTIONS(2997),
    [sym_float_literal] = ACTIONS(2997),
    [sym_rune_literal] = ACTIONS(2997),
    [anon_sym_SQUOTE] = ACTIONS(2997),
    [anon_sym_DQUOTE] = ACTIONS(2997),
    [anon_sym_c_SQUOTE] = ACTIONS(2997),
    [anon_sym_c_DQUOTE] = ACTIONS(2997),
    [anon_sym_r_SQUOTE] = ACTIONS(2997),
    [anon_sym_r_DQUOTE] = ACTIONS(2997),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2997),
    [anon_sym_shared] = ACTIONS(2997),
    [anon_sym_map_LBRACK] = ACTIONS(2997),
    [anon_sym_chan] = ACTIONS(2997),
    [anon_sym_thread] = ACTIONS(2997),
    [anon_sym_atomic] = ACTIONS(2997),
    [anon_sym_assert] = ACTIONS(2997),
    [anon_sym_defer] = ACTIONS(2997),
    [anon_sym_goto] = ACTIONS(2997),
    [anon_sym_break] = ACTIONS(2997),
    [anon_sym_continue] = ACTIONS(2997),
    [anon_sym_return] = ACTIONS(2997),
    [anon_sym_DOLLARfor] = ACTIONS(2997),
    [anon_sym_for] = ACTIONS(2997),
    [anon_sym_POUND] = ACTIONS(2997),
    [anon_sym_asm] = ACTIONS(2997),
  },
  [1067] = {
    [sym_line_comment] = STATE(1067),
    [sym_block_comment] = STATE(1067),
    [sym_identifier] = ACTIONS(2967),
    [anon_sym_LF] = ACTIONS(2967),
    [anon_sym_CR] = ACTIONS(2967),
    [anon_sym_CR_LF] = ACTIONS(2967),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2967),
    [anon_sym_DOT] = ACTIONS(2967),
    [anon_sym_as] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2967),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_RBRACE] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(2967),
    [anon_sym_EQ] = ACTIONS(2967),
    [anon_sym_fn] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2967),
    [anon_sym_SLASH] = ACTIONS(2967),
    [anon_sym_PERCENT] = ACTIONS(2967),
    [anon_sym_LT] = ACTIONS(2967),
    [anon_sym_GT] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2967),
    [anon_sym_BANG_EQ] = ACTIONS(2967),
    [anon_sym_LT_EQ] = ACTIONS(2967),
    [anon_sym_GT_EQ] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2965),
    [anon_sym_struct] = ACTIONS(2967),
    [anon_sym_mut] = ACTIONS(2967),
    [anon_sym_COLON] = ACTIONS(2967),
    [anon_sym_PLUS_PLUS] = ACTIONS(2967),
    [anon_sym_DASH_DASH] = ACTIONS(2967),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_BANG] = ACTIONS(2967),
    [anon_sym_go] = ACTIONS(2967),
    [anon_sym_spawn] = ACTIONS(2967),
    [anon_sym_json_DOTdecode] = ACTIONS(2967),
    [anon_sym_PIPE] = ACTIONS(2967),
    [anon_sym_LBRACK2] = ACTIONS(2967),
    [anon_sym_TILDE] = ACTIONS(2967),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_AMP] = ACTIONS(2967),
    [anon_sym_LT_DASH] = ACTIONS(2967),
    [anon_sym_LT_LT] = ACTIONS(2967),
    [anon_sym_GT_GT] = ACTIONS(2967),
    [anon_sym_GT_GT_GT] = ACTIONS(2967),
    [anon_sym_AMP_CARET] = ACTIONS(2967),
    [anon_sym_AMP_AMP] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE] = ACTIONS(2967),
    [anon_sym_or] = ACTIONS(2967),
    [sym_none] = ACTIONS(2967),
    [sym_true] = ACTIONS(2967),
    [sym_false] = ACTIONS(2967),
    [sym_nil] = ACTIONS(2967),
    [anon_sym_QMARK_DOT] = ACTIONS(2967),
    [anon_sym_POUND_LBRACK] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_DOLLARif] = ACTIONS(2967),
    [anon_sym_is] = ACTIONS(2967),
    [anon_sym_BANGis] = ACTIONS(2967),
    [anon_sym_in] = ACTIONS(2967),
    [anon_sym_BANGin] = ACTIONS(2967),
    [anon_sym_match] = ACTIONS(2967),
    [anon_sym_select] = ACTIONS(2967),
    [anon_sym_STAR_EQ] = ACTIONS(2967),
    [anon_sym_SLASH_EQ] = ACTIONS(2967),
    [anon_sym_PERCENT_EQ] = ACTIONS(2967),
    [anon_sym_LT_LT_EQ] = ACTIONS(2967),
    [anon_sym_GT_GT_EQ] = ACTIONS(2967),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2967),
    [anon_sym_AMP_EQ] = ACTIONS(2967),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2967),
    [anon_sym_PLUS_EQ] = ACTIONS(2967),
    [anon_sym_DASH_EQ] = ACTIONS(2967),
    [anon_sym_PIPE_EQ] = ACTIONS(2967),
    [anon_sym_CARET_EQ] = ACTIONS(2967),
    [anon_sym_COLON_EQ] = ACTIONS(2967),
    [anon_sym_lock] = ACTIONS(2967),
    [anon_sym_rlock] = ACTIONS(2967),
    [anon_sym_unsafe] = ACTIONS(2967),
    [anon_sym_sql] = ACTIONS(2967),
    [sym_int_literal] = ACTIONS(2967),
    [sym_float_literal] = ACTIONS(2967),
    [sym_rune_literal] = ACTIONS(2967),
    [anon_sym_SQUOTE] = ACTIONS(2967),
    [anon_sym_DQUOTE] = ACTIONS(2967),
    [anon_sym_c_SQUOTE] = ACTIONS(2967),
    [anon_sym_c_DQUOTE] = ACTIONS(2967),
    [anon_sym_r_SQUOTE] = ACTIONS(2967),
    [anon_sym_r_DQUOTE] = ACTIONS(2967),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2967),
    [anon_sym_shared] = ACTIONS(2967),
    [anon_sym_map_LBRACK] = ACTIONS(2967),
    [anon_sym_chan] = ACTIONS(2967),
    [anon_sym_thread] = ACTIONS(2967),
    [anon_sym_atomic] = ACTIONS(2967),
    [anon_sym_assert] = ACTIONS(2967),
    [anon_sym_defer] = ACTIONS(2967),
    [anon_sym_goto] = ACTIONS(2967),
    [anon_sym_break] = ACTIONS(2967),
    [anon_sym_continue] = ACTIONS(2967),
    [anon_sym_return] = ACTIONS(2967),
    [anon_sym_DOLLARfor] = ACTIONS(2967),
    [anon_sym_for] = ACTIONS(2967),
    [anon_sym_POUND] = ACTIONS(2967),
    [anon_sym_asm] = ACTIONS(2967),
  },
  [1068] = {
    [sym_line_comment] = STATE(1068),
    [sym_block_comment] = STATE(1068),
    [sym_identifier] = ACTIONS(2647),
    [anon_sym_LF] = ACTIONS(2647),
    [anon_sym_CR] = ACTIONS(2647),
    [anon_sym_CR_LF] = ACTIONS(2647),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2647),
    [anon_sym_DOT] = ACTIONS(2647),
    [anon_sym_as] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_RBRACE] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_EQ] = ACTIONS(2647),
    [anon_sym_fn] = ACTIONS(2647),
    [anon_sym_PLUS] = ACTIONS(2647),
    [anon_sym_DASH] = ACTIONS(2647),
    [anon_sym_STAR] = ACTIONS(2647),
    [anon_sym_SLASH] = ACTIONS(2647),
    [anon_sym_PERCENT] = ACTIONS(2647),
    [anon_sym_LT] = ACTIONS(2647),
    [anon_sym_GT] = ACTIONS(2647),
    [anon_sym_EQ_EQ] = ACTIONS(2647),
    [anon_sym_BANG_EQ] = ACTIONS(2647),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_struct] = ACTIONS(2647),
    [anon_sym_mut] = ACTIONS(2647),
    [anon_sym_COLON] = ACTIONS(2647),
    [anon_sym_PLUS_PLUS] = ACTIONS(2647),
    [anon_sym_DASH_DASH] = ACTIONS(2647),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_go] = ACTIONS(2647),
    [anon_sym_spawn] = ACTIONS(2647),
    [anon_sym_json_DOTdecode] = ACTIONS(2647),
    [anon_sym_PIPE] = ACTIONS(2647),
    [anon_sym_LBRACK2] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [anon_sym_CARET] = ACTIONS(2647),
    [anon_sym_AMP] = ACTIONS(2647),
    [anon_sym_LT_DASH] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2647),
    [anon_sym_GT_GT] = ACTIONS(2647),
    [anon_sym_GT_GT_GT] = ACTIONS(2647),
    [anon_sym_AMP_CARET] = ACTIONS(2647),
    [anon_sym_AMP_AMP] = ACTIONS(2647),
    [anon_sym_PIPE_PIPE] = ACTIONS(2647),
    [anon_sym_or] = ACTIONS(2647),
    [sym_none] = ACTIONS(2647),
    [sym_true] = ACTIONS(2647),
    [sym_false] = ACTIONS(2647),
    [sym_nil] = ACTIONS(2647),
    [anon_sym_QMARK_DOT] = ACTIONS(2647),
    [anon_sym_POUND_LBRACK] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(2647),
    [anon_sym_DOLLARif] = ACTIONS(2647),
    [anon_sym_is] = ACTIONS(2647),
    [anon_sym_BANGis] = ACTIONS(2647),
    [anon_sym_in] = ACTIONS(2647),
    [anon_sym_BANGin] = ACTIONS(2647),
    [anon_sym_match] = ACTIONS(2647),
    [anon_sym_select] = ACTIONS(2647),
    [anon_sym_STAR_EQ] = ACTIONS(2647),
    [anon_sym_SLASH_EQ] = ACTIONS(2647),
    [anon_sym_PERCENT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_GT_EQ] = ACTIONS(2647),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2647),
    [anon_sym_AMP_EQ] = ACTIONS(2647),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2647),
    [anon_sym_PLUS_EQ] = ACTIONS(2647),
    [anon_sym_DASH_EQ] = ACTIONS(2647),
    [anon_sym_PIPE_EQ] = ACTIONS(2647),
    [anon_sym_CARET_EQ] = ACTIONS(2647),
    [anon_sym_COLON_EQ] = ACTIONS(2647),
    [anon_sym_lock] = ACTIONS(2647),
    [anon_sym_rlock] = ACTIONS(2647),
    [anon_sym_unsafe] = ACTIONS(2647),
    [anon_sym_sql] = ACTIONS(2647),
    [sym_int_literal] = ACTIONS(2647),
    [sym_float_literal] = ACTIONS(2647),
    [sym_rune_literal] = ACTIONS(2647),
    [anon_sym_SQUOTE] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(2647),
    [anon_sym_c_SQUOTE] = ACTIONS(2647),
    [anon_sym_c_DQUOTE] = ACTIONS(2647),
    [anon_sym_r_SQUOTE] = ACTIONS(2647),
    [anon_sym_r_DQUOTE] = ACTIONS(2647),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2647),
    [anon_sym_shared] = ACTIONS(2647),
    [anon_sym_map_LBRACK] = ACTIONS(2647),
    [anon_sym_chan] = ACTIONS(2647),
    [anon_sym_thread] = ACTIONS(2647),
    [anon_sym_atomic] = ACTIONS(2647),
    [anon_sym_assert] = ACTIONS(2647),
    [anon_sym_defer] = ACTIONS(2647),
    [anon_sym_goto] = ACTIONS(2647),
    [anon_sym_break] = ACTIONS(2647),
    [anon_sym_continue] = ACTIONS(2647),
    [anon_sym_return] = ACTIONS(2647),
    [anon_sym_DOLLARfor] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2647),
    [anon_sym_POUND] = ACTIONS(2647),
    [anon_sym_asm] = ACTIONS(2647),
  },
  [1069] = {
    [sym_line_comment] = STATE(1069),
    [sym_block_comment] = STATE(1069),
    [sym_identifier] = ACTIONS(3240),
    [anon_sym_LF] = ACTIONS(3240),
    [anon_sym_CR] = ACTIONS(3240),
    [anon_sym_CR_LF] = ACTIONS(3240),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(3240),
    [anon_sym_as] = ACTIONS(3240),
    [anon_sym_LBRACE] = ACTIONS(3240),
    [anon_sym_COMMA] = ACTIONS(3240),
    [anon_sym_RBRACE] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(3240),
    [anon_sym_EQ] = ACTIONS(3240),
    [anon_sym_fn] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3240),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [anon_sym_LT] = ACTIONS(3240),
    [anon_sym_GT] = ACTIONS(3240),
    [anon_sym_EQ_EQ] = ACTIONS(3240),
    [anon_sym_BANG_EQ] = ACTIONS(3240),
    [anon_sym_LT_EQ] = ACTIONS(3240),
    [anon_sym_GT_EQ] = ACTIONS(3240),
    [anon_sym_LBRACK] = ACTIONS(3238),
    [anon_sym_struct] = ACTIONS(3240),
    [anon_sym_mut] = ACTIONS(3240),
    [anon_sym_COLON] = ACTIONS(3240),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_QMARK] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_go] = ACTIONS(3240),
    [anon_sym_spawn] = ACTIONS(3240),
    [anon_sym_json_DOTdecode] = ACTIONS(3240),
    [anon_sym_PIPE] = ACTIONS(3240),
    [anon_sym_LBRACK2] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [anon_sym_CARET] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_LT_DASH] = ACTIONS(3240),
    [anon_sym_LT_LT] = ACTIONS(3240),
    [anon_sym_GT_GT] = ACTIONS(3240),
    [anon_sym_GT_GT_GT] = ACTIONS(3240),
    [anon_sym_AMP_CARET] = ACTIONS(3240),
    [anon_sym_AMP_AMP] = ACTIONS(3240),
    [anon_sym_PIPE_PIPE] = ACTIONS(3240),
    [anon_sym_or] = ACTIONS(3240),
    [sym_none] = ACTIONS(3240),
    [sym_true] = ACTIONS(3240),
    [sym_false] = ACTIONS(3240),
    [sym_nil] = ACTIONS(3240),
    [anon_sym_QMARK_DOT] = ACTIONS(3240),
    [anon_sym_POUND_LBRACK] = ACTIONS(3240),
    [anon_sym_if] = ACTIONS(3240),
    [anon_sym_DOLLARif] = ACTIONS(3240),
    [anon_sym_is] = ACTIONS(3240),
    [anon_sym_BANGis] = ACTIONS(3240),
    [anon_sym_in] = ACTIONS(3240),
    [anon_sym_BANGin] = ACTIONS(3240),
    [anon_sym_match] = ACTIONS(3240),
    [anon_sym_select] = ACTIONS(3240),
    [anon_sym_STAR_EQ] = ACTIONS(3240),
    [anon_sym_SLASH_EQ] = ACTIONS(3240),
    [anon_sym_PERCENT_EQ] = ACTIONS(3240),
    [anon_sym_LT_LT_EQ] = ACTIONS(3240),
    [anon_sym_GT_GT_EQ] = ACTIONS(3240),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3240),
    [anon_sym_AMP_EQ] = ACTIONS(3240),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3240),
    [anon_sym_PLUS_EQ] = ACTIONS(3240),
    [anon_sym_DASH_EQ] = ACTIONS(3240),
    [anon_sym_PIPE_EQ] = ACTIONS(3240),
    [anon_sym_CARET_EQ] = ACTIONS(3240),
    [anon_sym_COLON_EQ] = ACTIONS(3240),
    [anon_sym_lock] = ACTIONS(3240),
    [anon_sym_rlock] = ACTIONS(3240),
    [anon_sym_unsafe] = ACTIONS(3240),
    [anon_sym_sql] = ACTIONS(3240),
    [sym_int_literal] = ACTIONS(3240),
    [sym_float_literal] = ACTIONS(3240),
    [sym_rune_literal] = ACTIONS(3240),
    [anon_sym_SQUOTE] = ACTIONS(3240),
    [anon_sym_DQUOTE] = ACTIONS(3240),
    [anon_sym_c_SQUOTE] = ACTIONS(3240),
    [anon_sym_c_DQUOTE] = ACTIONS(3240),
    [anon_sym_r_SQUOTE] = ACTIONS(3240),
    [anon_sym_r_DQUOTE] = ACTIONS(3240),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3240),
    [anon_sym_shared] = ACTIONS(3240),
    [anon_sym_map_LBRACK] = ACTIONS(3240),
    [anon_sym_chan] = ACTIONS(3240),
    [anon_sym_thread] = ACTIONS(3240),
    [anon_sym_atomic] = ACTIONS(3240),
    [anon_sym_assert] = ACTIONS(3240),
    [anon_sym_defer] = ACTIONS(3240),
    [anon_sym_goto] = ACTIONS(3240),
    [anon_sym_break] = ACTIONS(3240),
    [anon_sym_continue] = ACTIONS(3240),
    [anon_sym_return] = ACTIONS(3240),
    [anon_sym_DOLLARfor] = ACTIONS(3240),
    [anon_sym_for] = ACTIONS(3240),
    [anon_sym_POUND] = ACTIONS(3240),
    [anon_sym_asm] = ACTIONS(3240),
  },
  [1070] = {
    [sym_line_comment] = STATE(1070),
    [sym_block_comment] = STATE(1070),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_LF] = ACTIONS(3027),
    [anon_sym_CR] = ACTIONS(3027),
    [anon_sym_CR_LF] = ACTIONS(3027),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3027),
    [anon_sym_DOT] = ACTIONS(3027),
    [anon_sym_as] = ACTIONS(3027),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_COMMA] = ACTIONS(3027),
    [anon_sym_RBRACE] = ACTIONS(3027),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym_EQ] = ACTIONS(3027),
    [anon_sym_fn] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_STAR] = ACTIONS(3027),
    [anon_sym_SLASH] = ACTIONS(3027),
    [anon_sym_PERCENT] = ACTIONS(3027),
    [anon_sym_LT] = ACTIONS(3027),
    [anon_sym_GT] = ACTIONS(3027),
    [anon_sym_EQ_EQ] = ACTIONS(3027),
    [anon_sym_BANG_EQ] = ACTIONS(3027),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3025),
    [anon_sym_struct] = ACTIONS(3027),
    [anon_sym_mut] = ACTIONS(3027),
    [anon_sym_COLON] = ACTIONS(3027),
    [anon_sym_PLUS_PLUS] = ACTIONS(3027),
    [anon_sym_DASH_DASH] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_BANG] = ACTIONS(3027),
    [anon_sym_go] = ACTIONS(3027),
    [anon_sym_spawn] = ACTIONS(3027),
    [anon_sym_json_DOTdecode] = ACTIONS(3027),
    [anon_sym_PIPE] = ACTIONS(3027),
    [anon_sym_LBRACK2] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3027),
    [anon_sym_CARET] = ACTIONS(3027),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_LT_DASH] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3027),
    [anon_sym_GT_GT] = ACTIONS(3027),
    [anon_sym_GT_GT_GT] = ACTIONS(3027),
    [anon_sym_AMP_CARET] = ACTIONS(3027),
    [anon_sym_AMP_AMP] = ACTIONS(3027),
    [anon_sym_PIPE_PIPE] = ACTIONS(3027),
    [anon_sym_or] = ACTIONS(3027),
    [sym_none] = ACTIONS(3027),
    [sym_true] = ACTIONS(3027),
    [sym_false] = ACTIONS(3027),
    [sym_nil] = ACTIONS(3027),
    [anon_sym_QMARK_DOT] = ACTIONS(3027),
    [anon_sym_POUND_LBRACK] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_DOLLARif] = ACTIONS(3027),
    [anon_sym_is] = ACTIONS(3027),
    [anon_sym_BANGis] = ACTIONS(3027),
    [anon_sym_in] = ACTIONS(3027),
    [anon_sym_BANGin] = ACTIONS(3027),
    [anon_sym_match] = ACTIONS(3027),
    [anon_sym_select] = ACTIONS(3027),
    [anon_sym_STAR_EQ] = ACTIONS(3027),
    [anon_sym_SLASH_EQ] = ACTIONS(3027),
    [anon_sym_PERCENT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_GT_EQ] = ACTIONS(3027),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3027),
    [anon_sym_AMP_EQ] = ACTIONS(3027),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3027),
    [anon_sym_PLUS_EQ] = ACTIONS(3027),
    [anon_sym_DASH_EQ] = ACTIONS(3027),
    [anon_sym_PIPE_EQ] = ACTIONS(3027),
    [anon_sym_CARET_EQ] = ACTIONS(3027),
    [anon_sym_COLON_EQ] = ACTIONS(3027),
    [anon_sym_lock] = ACTIONS(3027),
    [anon_sym_rlock] = ACTIONS(3027),
    [anon_sym_unsafe] = ACTIONS(3027),
    [anon_sym_sql] = ACTIONS(3027),
    [sym_int_literal] = ACTIONS(3027),
    [sym_float_literal] = ACTIONS(3027),
    [sym_rune_literal] = ACTIONS(3027),
    [anon_sym_SQUOTE] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_c_SQUOTE] = ACTIONS(3027),
    [anon_sym_c_DQUOTE] = ACTIONS(3027),
    [anon_sym_r_SQUOTE] = ACTIONS(3027),
    [anon_sym_r_DQUOTE] = ACTIONS(3027),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3027),
    [anon_sym_shared] = ACTIONS(3027),
    [anon_sym_map_LBRACK] = ACTIONS(3027),
    [anon_sym_chan] = ACTIONS(3027),
    [anon_sym_thread] = ACTIONS(3027),
    [anon_sym_atomic] = ACTIONS(3027),
    [anon_sym_assert] = ACTIONS(3027),
    [anon_sym_defer] = ACTIONS(3027),
    [anon_sym_goto] = ACTIONS(3027),
    [anon_sym_break] = ACTIONS(3027),
    [anon_sym_continue] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_DOLLARfor] = ACTIONS(3027),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_POUND] = ACTIONS(3027),
    [anon_sym_asm] = ACTIONS(3027),
  },
  [1071] = {
    [sym_line_comment] = STATE(1071),
    [sym_block_comment] = STATE(1071),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_LF] = ACTIONS(3031),
    [anon_sym_CR] = ACTIONS(3031),
    [anon_sym_CR_LF] = ACTIONS(3031),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3031),
    [anon_sym_DOT] = ACTIONS(3031),
    [anon_sym_as] = ACTIONS(3031),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_COMMA] = ACTIONS(3031),
    [anon_sym_RBRACE] = ACTIONS(3031),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym_EQ] = ACTIONS(3031),
    [anon_sym_fn] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_STAR] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3031),
    [anon_sym_PERCENT] = ACTIONS(3031),
    [anon_sym_LT] = ACTIONS(3031),
    [anon_sym_GT] = ACTIONS(3031),
    [anon_sym_EQ_EQ] = ACTIONS(3031),
    [anon_sym_BANG_EQ] = ACTIONS(3031),
    [anon_sym_LT_EQ] = ACTIONS(3031),
    [anon_sym_GT_EQ] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3029),
    [anon_sym_struct] = ACTIONS(3031),
    [anon_sym_mut] = ACTIONS(3031),
    [anon_sym_COLON] = ACTIONS(3031),
    [anon_sym_PLUS_PLUS] = ACTIONS(3031),
    [anon_sym_DASH_DASH] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_BANG] = ACTIONS(3031),
    [anon_sym_go] = ACTIONS(3031),
    [anon_sym_spawn] = ACTIONS(3031),
    [anon_sym_json_DOTdecode] = ACTIONS(3031),
    [anon_sym_PIPE] = ACTIONS(3031),
    [anon_sym_LBRACK2] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3031),
    [anon_sym_CARET] = ACTIONS(3031),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_LT_DASH] = ACTIONS(3031),
    [anon_sym_LT_LT] = ACTIONS(3031),
    [anon_sym_GT_GT] = ACTIONS(3031),
    [anon_sym_GT_GT_GT] = ACTIONS(3031),
    [anon_sym_AMP_CARET] = ACTIONS(3031),
    [anon_sym_AMP_AMP] = ACTIONS(3031),
    [anon_sym_PIPE_PIPE] = ACTIONS(3031),
    [anon_sym_or] = ACTIONS(3031),
    [sym_none] = ACTIONS(3031),
    [sym_true] = ACTIONS(3031),
    [sym_false] = ACTIONS(3031),
    [sym_nil] = ACTIONS(3031),
    [anon_sym_QMARK_DOT] = ACTIONS(3031),
    [anon_sym_POUND_LBRACK] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_DOLLARif] = ACTIONS(3031),
    [anon_sym_is] = ACTIONS(3031),
    [anon_sym_BANGis] = ACTIONS(3031),
    [anon_sym_in] = ACTIONS(3031),
    [anon_sym_BANGin] = ACTIONS(3031),
    [anon_sym_match] = ACTIONS(3031),
    [anon_sym_select] = ACTIONS(3031),
    [anon_sym_STAR_EQ] = ACTIONS(3031),
    [anon_sym_SLASH_EQ] = ACTIONS(3031),
    [anon_sym_PERCENT_EQ] = ACTIONS(3031),
    [anon_sym_LT_LT_EQ] = ACTIONS(3031),
    [anon_sym_GT_GT_EQ] = ACTIONS(3031),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3031),
    [anon_sym_AMP_EQ] = ACTIONS(3031),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3031),
    [anon_sym_PLUS_EQ] = ACTIONS(3031),
    [anon_sym_DASH_EQ] = ACTIONS(3031),
    [anon_sym_PIPE_EQ] = ACTIONS(3031),
    [anon_sym_CARET_EQ] = ACTIONS(3031),
    [anon_sym_COLON_EQ] = ACTIONS(3031),
    [anon_sym_lock] = ACTIONS(3031),
    [anon_sym_rlock] = ACTIONS(3031),
    [anon_sym_unsafe] = ACTIONS(3031),
    [anon_sym_sql] = ACTIONS(3031),
    [sym_int_literal] = ACTIONS(3031),
    [sym_float_literal] = ACTIONS(3031),
    [sym_rune_literal] = ACTIONS(3031),
    [anon_sym_SQUOTE] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_c_SQUOTE] = ACTIONS(3031),
    [anon_sym_c_DQUOTE] = ACTIONS(3031),
    [anon_sym_r_SQUOTE] = ACTIONS(3031),
    [anon_sym_r_DQUOTE] = ACTIONS(3031),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3031),
    [anon_sym_shared] = ACTIONS(3031),
    [anon_sym_map_LBRACK] = ACTIONS(3031),
    [anon_sym_chan] = ACTIONS(3031),
    [anon_sym_thread] = ACTIONS(3031),
    [anon_sym_atomic] = ACTIONS(3031),
    [anon_sym_assert] = ACTIONS(3031),
    [anon_sym_defer] = ACTIONS(3031),
    [anon_sym_goto] = ACTIONS(3031),
    [anon_sym_break] = ACTIONS(3031),
    [anon_sym_continue] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_DOLLARfor] = ACTIONS(3031),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_POUND] = ACTIONS(3031),
    [anon_sym_asm] = ACTIONS(3031),
  },
  [1072] = {
    [sym_line_comment] = STATE(1072),
    [sym_block_comment] = STATE(1072),
    [sym_identifier] = ACTIONS(3041),
    [anon_sym_LF] = ACTIONS(3041),
    [anon_sym_CR] = ACTIONS(3041),
    [anon_sym_CR_LF] = ACTIONS(3041),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3041),
    [anon_sym_DOT] = ACTIONS(3041),
    [anon_sym_as] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3041),
    [anon_sym_COMMA] = ACTIONS(3041),
    [anon_sym_RBRACE] = ACTIONS(3041),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_EQ] = ACTIONS(3041),
    [anon_sym_fn] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3041),
    [anon_sym_DASH] = ACTIONS(3041),
    [anon_sym_STAR] = ACTIONS(3041),
    [anon_sym_SLASH] = ACTIONS(3041),
    [anon_sym_PERCENT] = ACTIONS(3041),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_GT] = ACTIONS(3041),
    [anon_sym_EQ_EQ] = ACTIONS(3041),
    [anon_sym_BANG_EQ] = ACTIONS(3041),
    [anon_sym_LT_EQ] = ACTIONS(3041),
    [anon_sym_GT_EQ] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_struct] = ACTIONS(3041),
    [anon_sym_mut] = ACTIONS(3041),
    [anon_sym_COLON] = ACTIONS(3041),
    [anon_sym_PLUS_PLUS] = ACTIONS(3041),
    [anon_sym_DASH_DASH] = ACTIONS(3041),
    [anon_sym_QMARK] = ACTIONS(3041),
    [anon_sym_BANG] = ACTIONS(3041),
    [anon_sym_go] = ACTIONS(3041),
    [anon_sym_spawn] = ACTIONS(3041),
    [anon_sym_json_DOTdecode] = ACTIONS(3041),
    [anon_sym_PIPE] = ACTIONS(3041),
    [anon_sym_LBRACK2] = ACTIONS(3041),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_CARET] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3041),
    [anon_sym_LT_DASH] = ACTIONS(3041),
    [anon_sym_LT_LT] = ACTIONS(3041),
    [anon_sym_GT_GT] = ACTIONS(3041),
    [anon_sym_GT_GT_GT] = ACTIONS(3041),
    [anon_sym_AMP_CARET] = ACTIONS(3041),
    [anon_sym_AMP_AMP] = ACTIONS(3041),
    [anon_sym_PIPE_PIPE] = ACTIONS(3041),
    [anon_sym_or] = ACTIONS(3041),
    [sym_none] = ACTIONS(3041),
    [sym_true] = ACTIONS(3041),
    [sym_false] = ACTIONS(3041),
    [sym_nil] = ACTIONS(3041),
    [anon_sym_QMARK_DOT] = ACTIONS(3041),
    [anon_sym_POUND_LBRACK] = ACTIONS(3041),
    [anon_sym_if] = ACTIONS(3041),
    [anon_sym_DOLLARif] = ACTIONS(3041),
    [anon_sym_is] = ACTIONS(3041),
    [anon_sym_BANGis] = ACTIONS(3041),
    [anon_sym_in] = ACTIONS(3041),
    [anon_sym_BANGin] = ACTIONS(3041),
    [anon_sym_match] = ACTIONS(3041),
    [anon_sym_select] = ACTIONS(3041),
    [anon_sym_STAR_EQ] = ACTIONS(3041),
    [anon_sym_SLASH_EQ] = ACTIONS(3041),
    [anon_sym_PERCENT_EQ] = ACTIONS(3041),
    [anon_sym_LT_LT_EQ] = ACTIONS(3041),
    [anon_sym_GT_GT_EQ] = ACTIONS(3041),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3041),
    [anon_sym_AMP_EQ] = ACTIONS(3041),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3041),
    [anon_sym_PLUS_EQ] = ACTIONS(3041),
    [anon_sym_DASH_EQ] = ACTIONS(3041),
    [anon_sym_PIPE_EQ] = ACTIONS(3041),
    [anon_sym_CARET_EQ] = ACTIONS(3041),
    [anon_sym_COLON_EQ] = ACTIONS(3041),
    [anon_sym_lock] = ACTIONS(3041),
    [anon_sym_rlock] = ACTIONS(3041),
    [anon_sym_unsafe] = ACTIONS(3041),
    [anon_sym_sql] = ACTIONS(3041),
    [sym_int_literal] = ACTIONS(3041),
    [sym_float_literal] = ACTIONS(3041),
    [sym_rune_literal] = ACTIONS(3041),
    [anon_sym_SQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE] = ACTIONS(3041),
    [anon_sym_c_SQUOTE] = ACTIONS(3041),
    [anon_sym_c_DQUOTE] = ACTIONS(3041),
    [anon_sym_r_SQUOTE] = ACTIONS(3041),
    [anon_sym_r_DQUOTE] = ACTIONS(3041),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3041),
    [anon_sym_shared] = ACTIONS(3041),
    [anon_sym_map_LBRACK] = ACTIONS(3041),
    [anon_sym_chan] = ACTIONS(3041),
    [anon_sym_thread] = ACTIONS(3041),
    [anon_sym_atomic] = ACTIONS(3041),
    [anon_sym_assert] = ACTIONS(3041),
    [anon_sym_defer] = ACTIONS(3041),
    [anon_sym_goto] = ACTIONS(3041),
    [anon_sym_break] = ACTIONS(3041),
    [anon_sym_continue] = ACTIONS(3041),
    [anon_sym_return] = ACTIONS(3041),
    [anon_sym_DOLLARfor] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3041),
    [anon_sym_POUND] = ACTIONS(3041),
    [anon_sym_asm] = ACTIONS(3041),
  },
  [1073] = {
    [sym_line_comment] = STATE(1073),
    [sym_block_comment] = STATE(1073),
    [sym_identifier] = ACTIONS(3049),
    [anon_sym_LF] = ACTIONS(3049),
    [anon_sym_CR] = ACTIONS(3049),
    [anon_sym_CR_LF] = ACTIONS(3049),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3049),
    [anon_sym_DOT] = ACTIONS(3049),
    [anon_sym_as] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_COMMA] = ACTIONS(3049),
    [anon_sym_RBRACE] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym_fn] = ACTIONS(3049),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_STAR] = ACTIONS(3049),
    [anon_sym_SLASH] = ACTIONS(3049),
    [anon_sym_PERCENT] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_GT] = ACTIONS(3049),
    [anon_sym_EQ_EQ] = ACTIONS(3049),
    [anon_sym_BANG_EQ] = ACTIONS(3049),
    [anon_sym_LT_EQ] = ACTIONS(3049),
    [anon_sym_GT_EQ] = ACTIONS(3049),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_struct] = ACTIONS(3049),
    [anon_sym_mut] = ACTIONS(3049),
    [anon_sym_COLON] = ACTIONS(3049),
    [anon_sym_PLUS_PLUS] = ACTIONS(3049),
    [anon_sym_DASH_DASH] = ACTIONS(3049),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_BANG] = ACTIONS(3049),
    [anon_sym_go] = ACTIONS(3049),
    [anon_sym_spawn] = ACTIONS(3049),
    [anon_sym_json_DOTdecode] = ACTIONS(3049),
    [anon_sym_PIPE] = ACTIONS(3049),
    [anon_sym_LBRACK2] = ACTIONS(3049),
    [anon_sym_TILDE] = ACTIONS(3049),
    [anon_sym_CARET] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_LT_DASH] = ACTIONS(3049),
    [anon_sym_LT_LT] = ACTIONS(3049),
    [anon_sym_GT_GT] = ACTIONS(3049),
    [anon_sym_GT_GT_GT] = ACTIONS(3049),
    [anon_sym_AMP_CARET] = ACTIONS(3049),
    [anon_sym_AMP_AMP] = ACTIONS(3049),
    [anon_sym_PIPE_PIPE] = ACTIONS(3049),
    [anon_sym_or] = ACTIONS(3049),
    [sym_none] = ACTIONS(3049),
    [sym_true] = ACTIONS(3049),
    [sym_false] = ACTIONS(3049),
    [sym_nil] = ACTIONS(3049),
    [anon_sym_QMARK_DOT] = ACTIONS(3049),
    [anon_sym_POUND_LBRACK] = ACTIONS(3049),
    [anon_sym_if] = ACTIONS(3049),
    [anon_sym_DOLLARif] = ACTIONS(3049),
    [anon_sym_is] = ACTIONS(3049),
    [anon_sym_BANGis] = ACTIONS(3049),
    [anon_sym_in] = ACTIONS(3049),
    [anon_sym_BANGin] = ACTIONS(3049),
    [anon_sym_match] = ACTIONS(3049),
    [anon_sym_select] = ACTIONS(3049),
    [anon_sym_STAR_EQ] = ACTIONS(3049),
    [anon_sym_SLASH_EQ] = ACTIONS(3049),
    [anon_sym_PERCENT_EQ] = ACTIONS(3049),
    [anon_sym_LT_LT_EQ] = ACTIONS(3049),
    [anon_sym_GT_GT_EQ] = ACTIONS(3049),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3049),
    [anon_sym_AMP_EQ] = ACTIONS(3049),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3049),
    [anon_sym_PLUS_EQ] = ACTIONS(3049),
    [anon_sym_DASH_EQ] = ACTIONS(3049),
    [anon_sym_PIPE_EQ] = ACTIONS(3049),
    [anon_sym_CARET_EQ] = ACTIONS(3049),
    [anon_sym_COLON_EQ] = ACTIONS(3049),
    [anon_sym_lock] = ACTIONS(3049),
    [anon_sym_rlock] = ACTIONS(3049),
    [anon_sym_unsafe] = ACTIONS(3049),
    [anon_sym_sql] = ACTIONS(3049),
    [sym_int_literal] = ACTIONS(3049),
    [sym_float_literal] = ACTIONS(3049),
    [sym_rune_literal] = ACTIONS(3049),
    [anon_sym_SQUOTE] = ACTIONS(3049),
    [anon_sym_DQUOTE] = ACTIONS(3049),
    [anon_sym_c_SQUOTE] = ACTIONS(3049),
    [anon_sym_c_DQUOTE] = ACTIONS(3049),
    [anon_sym_r_SQUOTE] = ACTIONS(3049),
    [anon_sym_r_DQUOTE] = ACTIONS(3049),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3049),
    [anon_sym_shared] = ACTIONS(3049),
    [anon_sym_map_LBRACK] = ACTIONS(3049),
    [anon_sym_chan] = ACTIONS(3049),
    [anon_sym_thread] = ACTIONS(3049),
    [anon_sym_atomic] = ACTIONS(3049),
    [anon_sym_assert] = ACTIONS(3049),
    [anon_sym_defer] = ACTIONS(3049),
    [anon_sym_goto] = ACTIONS(3049),
    [anon_sym_break] = ACTIONS(3049),
    [anon_sym_continue] = ACTIONS(3049),
    [anon_sym_return] = ACTIONS(3049),
    [anon_sym_DOLLARfor] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3049),
    [anon_sym_POUND] = ACTIONS(3049),
    [anon_sym_asm] = ACTIONS(3049),
  },
  [1074] = {
    [sym_line_comment] = STATE(1074),
    [sym_block_comment] = STATE(1074),
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_LF] = ACTIONS(3061),
    [anon_sym_CR] = ACTIONS(3061),
    [anon_sym_CR_LF] = ACTIONS(3061),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3061),
    [anon_sym_DOT] = ACTIONS(3061),
    [anon_sym_as] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3061),
    [anon_sym_COMMA] = ACTIONS(3061),
    [anon_sym_RBRACE] = ACTIONS(3061),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_EQ] = ACTIONS(3061),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_PLUS] = ACTIONS(3061),
    [anon_sym_DASH] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(3061),
    [anon_sym_SLASH] = ACTIONS(3061),
    [anon_sym_PERCENT] = ACTIONS(3061),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_GT] = ACTIONS(3061),
    [anon_sym_EQ_EQ] = ACTIONS(3061),
    [anon_sym_BANG_EQ] = ACTIONS(3061),
    [anon_sym_LT_EQ] = ACTIONS(3061),
    [anon_sym_GT_EQ] = ACTIONS(3061),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_struct] = ACTIONS(3061),
    [anon_sym_mut] = ACTIONS(3061),
    [anon_sym_COLON] = ACTIONS(3061),
    [anon_sym_PLUS_PLUS] = ACTIONS(3061),
    [anon_sym_DASH_DASH] = ACTIONS(3061),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_BANG] = ACTIONS(3061),
    [anon_sym_go] = ACTIONS(3061),
    [anon_sym_spawn] = ACTIONS(3061),
    [anon_sym_json_DOTdecode] = ACTIONS(3061),
    [anon_sym_PIPE] = ACTIONS(3061),
    [anon_sym_LBRACK2] = ACTIONS(3061),
    [anon_sym_TILDE] = ACTIONS(3061),
    [anon_sym_CARET] = ACTIONS(3061),
    [anon_sym_AMP] = ACTIONS(3061),
    [anon_sym_LT_DASH] = ACTIONS(3061),
    [anon_sym_LT_LT] = ACTIONS(3061),
    [anon_sym_GT_GT] = ACTIONS(3061),
    [anon_sym_GT_GT_GT] = ACTIONS(3061),
    [anon_sym_AMP_CARET] = ACTIONS(3061),
    [anon_sym_AMP_AMP] = ACTIONS(3061),
    [anon_sym_PIPE_PIPE] = ACTIONS(3061),
    [anon_sym_or] = ACTIONS(3061),
    [sym_none] = ACTIONS(3061),
    [sym_true] = ACTIONS(3061),
    [sym_false] = ACTIONS(3061),
    [sym_nil] = ACTIONS(3061),
    [anon_sym_QMARK_DOT] = ACTIONS(3061),
    [anon_sym_POUND_LBRACK] = ACTIONS(3061),
    [anon_sym_if] = ACTIONS(3061),
    [anon_sym_DOLLARif] = ACTIONS(3061),
    [anon_sym_is] = ACTIONS(3061),
    [anon_sym_BANGis] = ACTIONS(3061),
    [anon_sym_in] = ACTIONS(3061),
    [anon_sym_BANGin] = ACTIONS(3061),
    [anon_sym_match] = ACTIONS(3061),
    [anon_sym_select] = ACTIONS(3061),
    [anon_sym_STAR_EQ] = ACTIONS(3061),
    [anon_sym_SLASH_EQ] = ACTIONS(3061),
    [anon_sym_PERCENT_EQ] = ACTIONS(3061),
    [anon_sym_LT_LT_EQ] = ACTIONS(3061),
    [anon_sym_GT_GT_EQ] = ACTIONS(3061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3061),
    [anon_sym_AMP_EQ] = ACTIONS(3061),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3061),
    [anon_sym_PLUS_EQ] = ACTIONS(3061),
    [anon_sym_DASH_EQ] = ACTIONS(3061),
    [anon_sym_PIPE_EQ] = ACTIONS(3061),
    [anon_sym_CARET_EQ] = ACTIONS(3061),
    [anon_sym_COLON_EQ] = ACTIONS(3061),
    [anon_sym_lock] = ACTIONS(3061),
    [anon_sym_rlock] = ACTIONS(3061),
    [anon_sym_unsafe] = ACTIONS(3061),
    [anon_sym_sql] = ACTIONS(3061),
    [sym_int_literal] = ACTIONS(3061),
    [sym_float_literal] = ACTIONS(3061),
    [sym_rune_literal] = ACTIONS(3061),
    [anon_sym_SQUOTE] = ACTIONS(3061),
    [anon_sym_DQUOTE] = ACTIONS(3061),
    [anon_sym_c_SQUOTE] = ACTIONS(3061),
    [anon_sym_c_DQUOTE] = ACTIONS(3061),
    [anon_sym_r_SQUOTE] = ACTIONS(3061),
    [anon_sym_r_DQUOTE] = ACTIONS(3061),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3061),
    [anon_sym_shared] = ACTIONS(3061),
    [anon_sym_map_LBRACK] = ACTIONS(3061),
    [anon_sym_chan] = ACTIONS(3061),
    [anon_sym_thread] = ACTIONS(3061),
    [anon_sym_atomic] = ACTIONS(3061),
    [anon_sym_assert] = ACTIONS(3061),
    [anon_sym_defer] = ACTIONS(3061),
    [anon_sym_goto] = ACTIONS(3061),
    [anon_sym_break] = ACTIONS(3061),
    [anon_sym_continue] = ACTIONS(3061),
    [anon_sym_return] = ACTIONS(3061),
    [anon_sym_DOLLARfor] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(3061),
    [anon_sym_POUND] = ACTIONS(3061),
    [anon_sym_asm] = ACTIONS(3061),
  },
  [1075] = {
    [sym_line_comment] = STATE(1075),
    [sym_block_comment] = STATE(1075),
    [sym_identifier] = ACTIONS(3065),
    [anon_sym_LF] = ACTIONS(3065),
    [anon_sym_CR] = ACTIONS(3065),
    [anon_sym_CR_LF] = ACTIONS(3065),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym_DOT] = ACTIONS(3065),
    [anon_sym_as] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_COMMA] = ACTIONS(3065),
    [anon_sym_RBRACE] = ACTIONS(3065),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_EQ] = ACTIONS(3065),
    [anon_sym_fn] = ACTIONS(3065),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_SLASH] = ACTIONS(3065),
    [anon_sym_PERCENT] = ACTIONS(3065),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_GT] = ACTIONS(3065),
    [anon_sym_EQ_EQ] = ACTIONS(3065),
    [anon_sym_BANG_EQ] = ACTIONS(3065),
    [anon_sym_LT_EQ] = ACTIONS(3065),
    [anon_sym_GT_EQ] = ACTIONS(3065),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3065),
    [anon_sym_mut] = ACTIONS(3065),
    [anon_sym_COLON] = ACTIONS(3065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_QMARK] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_go] = ACTIONS(3065),
    [anon_sym_spawn] = ACTIONS(3065),
    [anon_sym_json_DOTdecode] = ACTIONS(3065),
    [anon_sym_PIPE] = ACTIONS(3065),
    [anon_sym_LBRACK2] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_CARET] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3065),
    [anon_sym_LT_DASH] = ACTIONS(3065),
    [anon_sym_LT_LT] = ACTIONS(3065),
    [anon_sym_GT_GT] = ACTIONS(3065),
    [anon_sym_GT_GT_GT] = ACTIONS(3065),
    [anon_sym_AMP_CARET] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_PIPE_PIPE] = ACTIONS(3065),
    [anon_sym_or] = ACTIONS(3065),
    [sym_none] = ACTIONS(3065),
    [sym_true] = ACTIONS(3065),
    [sym_false] = ACTIONS(3065),
    [sym_nil] = ACTIONS(3065),
    [anon_sym_QMARK_DOT] = ACTIONS(3065),
    [anon_sym_POUND_LBRACK] = ACTIONS(3065),
    [anon_sym_if] = ACTIONS(3065),
    [anon_sym_DOLLARif] = ACTIONS(3065),
    [anon_sym_is] = ACTIONS(3065),
    [anon_sym_BANGis] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3065),
    [anon_sym_BANGin] = ACTIONS(3065),
    [anon_sym_match] = ACTIONS(3065),
    [anon_sym_select] = ACTIONS(3065),
    [anon_sym_STAR_EQ] = ACTIONS(3065),
    [anon_sym_SLASH_EQ] = ACTIONS(3065),
    [anon_sym_PERCENT_EQ] = ACTIONS(3065),
    [anon_sym_LT_LT_EQ] = ACTIONS(3065),
    [anon_sym_GT_GT_EQ] = ACTIONS(3065),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3065),
    [anon_sym_AMP_EQ] = ACTIONS(3065),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3065),
    [anon_sym_PLUS_EQ] = ACTIONS(3065),
    [anon_sym_DASH_EQ] = ACTIONS(3065),
    [anon_sym_PIPE_EQ] = ACTIONS(3065),
    [anon_sym_CARET_EQ] = ACTIONS(3065),
    [anon_sym_COLON_EQ] = ACTIONS(3065),
    [anon_sym_lock] = ACTIONS(3065),
    [anon_sym_rlock] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(3065),
    [anon_sym_sql] = ACTIONS(3065),
    [sym_int_literal] = ACTIONS(3065),
    [sym_float_literal] = ACTIONS(3065),
    [sym_rune_literal] = ACTIONS(3065),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [anon_sym_c_SQUOTE] = ACTIONS(3065),
    [anon_sym_c_DQUOTE] = ACTIONS(3065),
    [anon_sym_r_SQUOTE] = ACTIONS(3065),
    [anon_sym_r_DQUOTE] = ACTIONS(3065),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3065),
    [anon_sym_shared] = ACTIONS(3065),
    [anon_sym_map_LBRACK] = ACTIONS(3065),
    [anon_sym_chan] = ACTIONS(3065),
    [anon_sym_thread] = ACTIONS(3065),
    [anon_sym_atomic] = ACTIONS(3065),
    [anon_sym_assert] = ACTIONS(3065),
    [anon_sym_defer] = ACTIONS(3065),
    [anon_sym_goto] = ACTIONS(3065),
    [anon_sym_break] = ACTIONS(3065),
    [anon_sym_continue] = ACTIONS(3065),
    [anon_sym_return] = ACTIONS(3065),
    [anon_sym_DOLLARfor] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3065),
    [anon_sym_POUND] = ACTIONS(3065),
    [anon_sym_asm] = ACTIONS(3065),
  },
  [1076] = {
    [sym_line_comment] = STATE(1076),
    [sym_block_comment] = STATE(1076),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_LF] = ACTIONS(3055),
    [anon_sym_CR] = ACTIONS(3055),
    [anon_sym_CR_LF] = ACTIONS(3055),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3055),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_as] = ACTIONS(3055),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3055),
    [anon_sym_RBRACE] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_EQ] = ACTIONS(3055),
    [anon_sym_fn] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3055),
    [anon_sym_SLASH] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(3055),
    [anon_sym_GT] = ACTIONS(3055),
    [anon_sym_EQ_EQ] = ACTIONS(3055),
    [anon_sym_BANG_EQ] = ACTIONS(3055),
    [anon_sym_LT_EQ] = ACTIONS(3055),
    [anon_sym_GT_EQ] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_struct] = ACTIONS(3055),
    [anon_sym_mut] = ACTIONS(3055),
    [anon_sym_COLON] = ACTIONS(3055),
    [anon_sym_PLUS_PLUS] = ACTIONS(3055),
    [anon_sym_DASH_DASH] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_BANG] = ACTIONS(3055),
    [anon_sym_go] = ACTIONS(3055),
    [anon_sym_spawn] = ACTIONS(3055),
    [anon_sym_json_DOTdecode] = ACTIONS(3055),
    [anon_sym_PIPE] = ACTIONS(3055),
    [anon_sym_LBRACK2] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3055),
    [anon_sym_CARET] = ACTIONS(3055),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT_DASH] = ACTIONS(3055),
    [anon_sym_LT_LT] = ACTIONS(3055),
    [anon_sym_GT_GT] = ACTIONS(3055),
    [anon_sym_GT_GT_GT] = ACTIONS(3055),
    [anon_sym_AMP_CARET] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3055),
    [anon_sym_or] = ACTIONS(3055),
    [sym_none] = ACTIONS(3055),
    [sym_true] = ACTIONS(3055),
    [sym_false] = ACTIONS(3055),
    [sym_nil] = ACTIONS(3055),
    [anon_sym_QMARK_DOT] = ACTIONS(3055),
    [anon_sym_POUND_LBRACK] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_DOLLARif] = ACTIONS(3055),
    [anon_sym_is] = ACTIONS(3055),
    [anon_sym_BANGis] = ACTIONS(3055),
    [anon_sym_in] = ACTIONS(3055),
    [anon_sym_BANGin] = ACTIONS(3055),
    [anon_sym_match] = ACTIONS(3055),
    [anon_sym_select] = ACTIONS(3055),
    [anon_sym_STAR_EQ] = ACTIONS(3055),
    [anon_sym_SLASH_EQ] = ACTIONS(3055),
    [anon_sym_PERCENT_EQ] = ACTIONS(3055),
    [anon_sym_LT_LT_EQ] = ACTIONS(3055),
    [anon_sym_GT_GT_EQ] = ACTIONS(3055),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3055),
    [anon_sym_AMP_EQ] = ACTIONS(3055),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3055),
    [anon_sym_PLUS_EQ] = ACTIONS(3055),
    [anon_sym_DASH_EQ] = ACTIONS(3055),
    [anon_sym_PIPE_EQ] = ACTIONS(3055),
    [anon_sym_CARET_EQ] = ACTIONS(3055),
    [anon_sym_COLON_EQ] = ACTIONS(3055),
    [anon_sym_lock] = ACTIONS(3055),
    [anon_sym_rlock] = ACTIONS(3055),
    [anon_sym_unsafe] = ACTIONS(3055),
    [anon_sym_sql] = ACTIONS(3055),
    [sym_int_literal] = ACTIONS(3055),
    [sym_float_literal] = ACTIONS(3055),
    [sym_rune_literal] = ACTIONS(3055),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_c_SQUOTE] = ACTIONS(3055),
    [anon_sym_c_DQUOTE] = ACTIONS(3055),
    [anon_sym_r_SQUOTE] = ACTIONS(3055),
    [anon_sym_r_DQUOTE] = ACTIONS(3055),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3055),
    [anon_sym_shared] = ACTIONS(3055),
    [anon_sym_map_LBRACK] = ACTIONS(3055),
    [anon_sym_chan] = ACTIONS(3055),
    [anon_sym_thread] = ACTIONS(3055),
    [anon_sym_atomic] = ACTIONS(3055),
    [anon_sym_assert] = ACTIONS(3055),
    [anon_sym_defer] = ACTIONS(3055),
    [anon_sym_goto] = ACTIONS(3055),
    [anon_sym_break] = ACTIONS(3055),
    [anon_sym_continue] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_DOLLARfor] = ACTIONS(3055),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_POUND] = ACTIONS(3055),
    [anon_sym_asm] = ACTIONS(3055),
  },
  [1077] = {
    [sym_line_comment] = STATE(1077),
    [sym_block_comment] = STATE(1077),
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_LF] = ACTIONS(3073),
    [anon_sym_CR] = ACTIONS(3073),
    [anon_sym_CR_LF] = ACTIONS(3073),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_DOT] = ACTIONS(3073),
    [anon_sym_as] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3073),
    [anon_sym_COMMA] = ACTIONS(3073),
    [anon_sym_RBRACE] = ACTIONS(3073),
    [anon_sym_LPAREN] = ACTIONS(3073),
    [anon_sym_EQ] = ACTIONS(3073),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(3073),
    [anon_sym_DASH] = ACTIONS(3073),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_SLASH] = ACTIONS(3073),
    [anon_sym_PERCENT] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_GT] = ACTIONS(3073),
    [anon_sym_EQ_EQ] = ACTIONS(3073),
    [anon_sym_BANG_EQ] = ACTIONS(3073),
    [anon_sym_LT_EQ] = ACTIONS(3073),
    [anon_sym_GT_EQ] = ACTIONS(3073),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3073),
    [anon_sym_mut] = ACTIONS(3073),
    [anon_sym_COLON] = ACTIONS(3073),
    [anon_sym_PLUS_PLUS] = ACTIONS(3073),
    [anon_sym_DASH_DASH] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3073),
    [anon_sym_BANG] = ACTIONS(3073),
    [anon_sym_go] = ACTIONS(3073),
    [anon_sym_spawn] = ACTIONS(3073),
    [anon_sym_json_DOTdecode] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(3073),
    [anon_sym_LBRACK2] = ACTIONS(3073),
    [anon_sym_TILDE] = ACTIONS(3073),
    [anon_sym_CARET] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3073),
    [anon_sym_LT_DASH] = ACTIONS(3073),
    [anon_sym_LT_LT] = ACTIONS(3073),
    [anon_sym_GT_GT] = ACTIONS(3073),
    [anon_sym_GT_GT_GT] = ACTIONS(3073),
    [anon_sym_AMP_CARET] = ACTIONS(3073),
    [anon_sym_AMP_AMP] = ACTIONS(3073),
    [anon_sym_PIPE_PIPE] = ACTIONS(3073),
    [anon_sym_or] = ACTIONS(3073),
    [sym_none] = ACTIONS(3073),
    [sym_true] = ACTIONS(3073),
    [sym_false] = ACTIONS(3073),
    [sym_nil] = ACTIONS(3073),
    [anon_sym_QMARK_DOT] = ACTIONS(3073),
    [anon_sym_POUND_LBRACK] = ACTIONS(3073),
    [anon_sym_if] = ACTIONS(3073),
    [anon_sym_DOLLARif] = ACTIONS(3073),
    [anon_sym_is] = ACTIONS(3073),
    [anon_sym_BANGis] = ACTIONS(3073),
    [anon_sym_in] = ACTIONS(3073),
    [anon_sym_BANGin] = ACTIONS(3073),
    [anon_sym_match] = ACTIONS(3073),
    [anon_sym_select] = ACTIONS(3073),
    [anon_sym_STAR_EQ] = ACTIONS(3073),
    [anon_sym_SLASH_EQ] = ACTIONS(3073),
    [anon_sym_PERCENT_EQ] = ACTIONS(3073),
    [anon_sym_LT_LT_EQ] = ACTIONS(3073),
    [anon_sym_GT_GT_EQ] = ACTIONS(3073),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3073),
    [anon_sym_AMP_EQ] = ACTIONS(3073),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3073),
    [anon_sym_PLUS_EQ] = ACTIONS(3073),
    [anon_sym_DASH_EQ] = ACTIONS(3073),
    [anon_sym_PIPE_EQ] = ACTIONS(3073),
    [anon_sym_CARET_EQ] = ACTIONS(3073),
    [anon_sym_COLON_EQ] = ACTIONS(3073),
    [anon_sym_lock] = ACTIONS(3073),
    [anon_sym_rlock] = ACTIONS(3073),
    [anon_sym_unsafe] = ACTIONS(3073),
    [anon_sym_sql] = ACTIONS(3073),
    [sym_int_literal] = ACTIONS(3073),
    [sym_float_literal] = ACTIONS(3073),
    [sym_rune_literal] = ACTIONS(3073),
    [anon_sym_SQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE] = ACTIONS(3073),
    [anon_sym_c_SQUOTE] = ACTIONS(3073),
    [anon_sym_c_DQUOTE] = ACTIONS(3073),
    [anon_sym_r_SQUOTE] = ACTIONS(3073),
    [anon_sym_r_DQUOTE] = ACTIONS(3073),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3073),
    [anon_sym_shared] = ACTIONS(3073),
    [anon_sym_map_LBRACK] = ACTIONS(3073),
    [anon_sym_chan] = ACTIONS(3073),
    [anon_sym_thread] = ACTIONS(3073),
    [anon_sym_atomic] = ACTIONS(3073),
    [anon_sym_assert] = ACTIONS(3073),
    [anon_sym_defer] = ACTIONS(3073),
    [anon_sym_goto] = ACTIONS(3073),
    [anon_sym_break] = ACTIONS(3073),
    [anon_sym_continue] = ACTIONS(3073),
    [anon_sym_return] = ACTIONS(3073),
    [anon_sym_DOLLARfor] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(3073),
    [anon_sym_POUND] = ACTIONS(3073),
    [anon_sym_asm] = ACTIONS(3073),
  },
  [1078] = {
    [sym_line_comment] = STATE(1078),
    [sym_block_comment] = STATE(1078),
    [sym_identifier] = ACTIONS(3084),
    [anon_sym_LF] = ACTIONS(3084),
    [anon_sym_CR] = ACTIONS(3084),
    [anon_sym_CR_LF] = ACTIONS(3084),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym_DOT] = ACTIONS(3084),
    [anon_sym_as] = ACTIONS(3084),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_COMMA] = ACTIONS(3084),
    [anon_sym_RBRACE] = ACTIONS(3084),
    [anon_sym_LPAREN] = ACTIONS(3084),
    [anon_sym_EQ] = ACTIONS(3084),
    [anon_sym_fn] = ACTIONS(3084),
    [anon_sym_PLUS] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_SLASH] = ACTIONS(3084),
    [anon_sym_PERCENT] = ACTIONS(3084),
    [anon_sym_LT] = ACTIONS(3084),
    [anon_sym_GT] = ACTIONS(3084),
    [anon_sym_EQ_EQ] = ACTIONS(3084),
    [anon_sym_BANG_EQ] = ACTIONS(3084),
    [anon_sym_LT_EQ] = ACTIONS(3084),
    [anon_sym_GT_EQ] = ACTIONS(3084),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3084),
    [anon_sym_mut] = ACTIONS(3084),
    [anon_sym_COLON] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_QMARK] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_go] = ACTIONS(3084),
    [anon_sym_spawn] = ACTIONS(3084),
    [anon_sym_json_DOTdecode] = ACTIONS(3084),
    [anon_sym_PIPE] = ACTIONS(3084),
    [anon_sym_LBRACK2] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_CARET] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3084),
    [anon_sym_LT_DASH] = ACTIONS(3084),
    [anon_sym_LT_LT] = ACTIONS(3084),
    [anon_sym_GT_GT] = ACTIONS(3084),
    [anon_sym_GT_GT_GT] = ACTIONS(3084),
    [anon_sym_AMP_CARET] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_PIPE_PIPE] = ACTIONS(3084),
    [anon_sym_or] = ACTIONS(3084),
    [sym_none] = ACTIONS(3084),
    [sym_true] = ACTIONS(3084),
    [sym_false] = ACTIONS(3084),
    [sym_nil] = ACTIONS(3084),
    [anon_sym_QMARK_DOT] = ACTIONS(3084),
    [anon_sym_POUND_LBRACK] = ACTIONS(3084),
    [anon_sym_if] = ACTIONS(3084),
    [anon_sym_DOLLARif] = ACTIONS(3084),
    [anon_sym_is] = ACTIONS(3084),
    [anon_sym_BANGis] = ACTIONS(3084),
    [anon_sym_in] = ACTIONS(3084),
    [anon_sym_BANGin] = ACTIONS(3084),
    [anon_sym_match] = ACTIONS(3084),
    [anon_sym_select] = ACTIONS(3084),
    [anon_sym_STAR_EQ] = ACTIONS(3084),
    [anon_sym_SLASH_EQ] = ACTIONS(3084),
    [anon_sym_PERCENT_EQ] = ACTIONS(3084),
    [anon_sym_LT_LT_EQ] = ACTIONS(3084),
    [anon_sym_GT_GT_EQ] = ACTIONS(3084),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3084),
    [anon_sym_AMP_EQ] = ACTIONS(3084),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3084),
    [anon_sym_PLUS_EQ] = ACTIONS(3084),
    [anon_sym_DASH_EQ] = ACTIONS(3084),
    [anon_sym_PIPE_EQ] = ACTIONS(3084),
    [anon_sym_CARET_EQ] = ACTIONS(3084),
    [anon_sym_COLON_EQ] = ACTIONS(3084),
    [anon_sym_lock] = ACTIONS(3084),
    [anon_sym_rlock] = ACTIONS(3084),
    [anon_sym_unsafe] = ACTIONS(3084),
    [anon_sym_sql] = ACTIONS(3084),
    [sym_int_literal] = ACTIONS(3084),
    [sym_float_literal] = ACTIONS(3084),
    [sym_rune_literal] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [anon_sym_c_SQUOTE] = ACTIONS(3084),
    [anon_sym_c_DQUOTE] = ACTIONS(3084),
    [anon_sym_r_SQUOTE] = ACTIONS(3084),
    [anon_sym_r_DQUOTE] = ACTIONS(3084),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3084),
    [anon_sym_shared] = ACTIONS(3084),
    [anon_sym_map_LBRACK] = ACTIONS(3084),
    [anon_sym_chan] = ACTIONS(3084),
    [anon_sym_thread] = ACTIONS(3084),
    [anon_sym_atomic] = ACTIONS(3084),
    [anon_sym_assert] = ACTIONS(3084),
    [anon_sym_defer] = ACTIONS(3084),
    [anon_sym_goto] = ACTIONS(3084),
    [anon_sym_break] = ACTIONS(3084),
    [anon_sym_continue] = ACTIONS(3084),
    [anon_sym_return] = ACTIONS(3084),
    [anon_sym_DOLLARfor] = ACTIONS(3084),
    [anon_sym_for] = ACTIONS(3084),
    [anon_sym_POUND] = ACTIONS(3084),
    [anon_sym_asm] = ACTIONS(3084),
  },
  [1079] = {
    [sym_line_comment] = STATE(1079),
    [sym_block_comment] = STATE(1079),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_LF] = ACTIONS(3300),
    [anon_sym_CR] = ACTIONS(3300),
    [anon_sym_CR_LF] = ACTIONS(3300),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(3300),
    [anon_sym_as] = ACTIONS(3300),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(3300),
    [anon_sym_RBRACE] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_EQ] = ACTIONS(3300),
    [anon_sym_fn] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_SLASH] = ACTIONS(3300),
    [anon_sym_PERCENT] = ACTIONS(3300),
    [anon_sym_LT] = ACTIONS(3300),
    [anon_sym_GT] = ACTIONS(3300),
    [anon_sym_EQ_EQ] = ACTIONS(3300),
    [anon_sym_BANG_EQ] = ACTIONS(3300),
    [anon_sym_LT_EQ] = ACTIONS(3300),
    [anon_sym_GT_EQ] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_struct] = ACTIONS(3300),
    [anon_sym_mut] = ACTIONS(3300),
    [anon_sym_COLON] = ACTIONS(3300),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_go] = ACTIONS(3300),
    [anon_sym_spawn] = ACTIONS(3300),
    [anon_sym_json_DOTdecode] = ACTIONS(3300),
    [anon_sym_PIPE] = ACTIONS(3300),
    [anon_sym_LBRACK2] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [anon_sym_CARET] = ACTIONS(3300),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LT_DASH] = ACTIONS(3300),
    [anon_sym_LT_LT] = ACTIONS(3300),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3300),
    [anon_sym_AMP_CARET] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_PIPE_PIPE] = ACTIONS(3300),
    [anon_sym_or] = ACTIONS(3300),
    [sym_none] = ACTIONS(3300),
    [sym_true] = ACTIONS(3300),
    [sym_false] = ACTIONS(3300),
    [sym_nil] = ACTIONS(3300),
    [anon_sym_QMARK_DOT] = ACTIONS(3300),
    [anon_sym_POUND_LBRACK] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_DOLLARif] = ACTIONS(3300),
    [anon_sym_is] = ACTIONS(3300),
    [anon_sym_BANGis] = ACTIONS(3300),
    [anon_sym_in] = ACTIONS(3300),
    [anon_sym_BANGin] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_select] = ACTIONS(3300),
    [anon_sym_STAR_EQ] = ACTIONS(3300),
    [anon_sym_SLASH_EQ] = ACTIONS(3300),
    [anon_sym_PERCENT_EQ] = ACTIONS(3300),
    [anon_sym_LT_LT_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_AMP_EQ] = ACTIONS(3300),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3300),
    [anon_sym_PLUS_EQ] = ACTIONS(3300),
    [anon_sym_DASH_EQ] = ACTIONS(3300),
    [anon_sym_PIPE_EQ] = ACTIONS(3300),
    [anon_sym_CARET_EQ] = ACTIONS(3300),
    [anon_sym_COLON_EQ] = ACTIONS(3300),
    [anon_sym_lock] = ACTIONS(3300),
    [anon_sym_rlock] = ACTIONS(3300),
    [anon_sym_unsafe] = ACTIONS(3300),
    [anon_sym_sql] = ACTIONS(3300),
    [sym_int_literal] = ACTIONS(3300),
    [sym_float_literal] = ACTIONS(3300),
    [sym_rune_literal] = ACTIONS(3300),
    [anon_sym_SQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_c_SQUOTE] = ACTIONS(3300),
    [anon_sym_c_DQUOTE] = ACTIONS(3300),
    [anon_sym_r_SQUOTE] = ACTIONS(3300),
    [anon_sym_r_DQUOTE] = ACTIONS(3300),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3300),
    [anon_sym_shared] = ACTIONS(3300),
    [anon_sym_map_LBRACK] = ACTIONS(3300),
    [anon_sym_chan] = ACTIONS(3300),
    [anon_sym_thread] = ACTIONS(3300),
    [anon_sym_atomic] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_defer] = ACTIONS(3300),
    [anon_sym_goto] = ACTIONS(3300),
    [anon_sym_break] = ACTIONS(3300),
    [anon_sym_continue] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_DOLLARfor] = ACTIONS(3300),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_POUND] = ACTIONS(3300),
    [anon_sym_asm] = ACTIONS(3300),
  },
  [1080] = {
    [sym_line_comment] = STATE(1080),
    [sym_block_comment] = STATE(1080),
    [sym_identifier] = ACTIONS(2651),
    [anon_sym_LF] = ACTIONS(2651),
    [anon_sym_CR] = ACTIONS(2651),
    [anon_sym_CR_LF] = ACTIONS(2651),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2651),
    [anon_sym_DOT] = ACTIONS(2651),
    [anon_sym_as] = ACTIONS(2651),
    [anon_sym_LBRACE] = ACTIONS(2651),
    [anon_sym_COMMA] = ACTIONS(2651),
    [anon_sym_RBRACE] = ACTIONS(2651),
    [anon_sym_LPAREN] = ACTIONS(2651),
    [anon_sym_EQ] = ACTIONS(2651),
    [anon_sym_fn] = ACTIONS(2651),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_STAR] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2651),
    [anon_sym_PERCENT] = ACTIONS(2651),
    [anon_sym_LT] = ACTIONS(2651),
    [anon_sym_GT] = ACTIONS(2651),
    [anon_sym_EQ_EQ] = ACTIONS(2651),
    [anon_sym_BANG_EQ] = ACTIONS(2651),
    [anon_sym_LT_EQ] = ACTIONS(2651),
    [anon_sym_GT_EQ] = ACTIONS(2651),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_struct] = ACTIONS(2651),
    [anon_sym_mut] = ACTIONS(2651),
    [anon_sym_COLON] = ACTIONS(2651),
    [anon_sym_PLUS_PLUS] = ACTIONS(2651),
    [anon_sym_DASH_DASH] = ACTIONS(2651),
    [anon_sym_QMARK] = ACTIONS(2651),
    [anon_sym_BANG] = ACTIONS(2651),
    [anon_sym_go] = ACTIONS(2651),
    [anon_sym_spawn] = ACTIONS(2651),
    [anon_sym_json_DOTdecode] = ACTIONS(2651),
    [anon_sym_PIPE] = ACTIONS(2651),
    [anon_sym_LBRACK2] = ACTIONS(2651),
    [anon_sym_TILDE] = ACTIONS(2651),
    [anon_sym_CARET] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2651),
    [anon_sym_LT_DASH] = ACTIONS(2651),
    [anon_sym_LT_LT] = ACTIONS(2651),
    [anon_sym_GT_GT] = ACTIONS(2651),
    [anon_sym_GT_GT_GT] = ACTIONS(2651),
    [anon_sym_AMP_CARET] = ACTIONS(2651),
    [anon_sym_AMP_AMP] = ACTIONS(2651),
    [anon_sym_PIPE_PIPE] = ACTIONS(2651),
    [anon_sym_or] = ACTIONS(2651),
    [sym_none] = ACTIONS(2651),
    [sym_true] = ACTIONS(2651),
    [sym_false] = ACTIONS(2651),
    [sym_nil] = ACTIONS(2651),
    [anon_sym_QMARK_DOT] = ACTIONS(2651),
    [anon_sym_POUND_LBRACK] = ACTIONS(2651),
    [anon_sym_if] = ACTIONS(2651),
    [anon_sym_DOLLARif] = ACTIONS(2651),
    [anon_sym_is] = ACTIONS(2651),
    [anon_sym_BANGis] = ACTIONS(2651),
    [anon_sym_in] = ACTIONS(2651),
    [anon_sym_BANGin] = ACTIONS(2651),
    [anon_sym_match] = ACTIONS(2651),
    [anon_sym_select] = ACTIONS(2651),
    [anon_sym_STAR_EQ] = ACTIONS(2651),
    [anon_sym_SLASH_EQ] = ACTIONS(2651),
    [anon_sym_PERCENT_EQ] = ACTIONS(2651),
    [anon_sym_LT_LT_EQ] = ACTIONS(2651),
    [anon_sym_GT_GT_EQ] = ACTIONS(2651),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2651),
    [anon_sym_AMP_EQ] = ACTIONS(2651),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2651),
    [anon_sym_PLUS_EQ] = ACTIONS(2651),
    [anon_sym_DASH_EQ] = ACTIONS(2651),
    [anon_sym_PIPE_EQ] = ACTIONS(2651),
    [anon_sym_CARET_EQ] = ACTIONS(2651),
    [anon_sym_COLON_EQ] = ACTIONS(2651),
    [anon_sym_lock] = ACTIONS(2651),
    [anon_sym_rlock] = ACTIONS(2651),
    [anon_sym_unsafe] = ACTIONS(2651),
    [anon_sym_sql] = ACTIONS(2651),
    [sym_int_literal] = ACTIONS(2651),
    [sym_float_literal] = ACTIONS(2651),
    [sym_rune_literal] = ACTIONS(2651),
    [anon_sym_SQUOTE] = ACTIONS(2651),
    [anon_sym_DQUOTE] = ACTIONS(2651),
    [anon_sym_c_SQUOTE] = ACTIONS(2651),
    [anon_sym_c_DQUOTE] = ACTIONS(2651),
    [anon_sym_r_SQUOTE] = ACTIONS(2651),
    [anon_sym_r_DQUOTE] = ACTIONS(2651),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2651),
    [anon_sym_shared] = ACTIONS(2651),
    [anon_sym_map_LBRACK] = ACTIONS(2651),
    [anon_sym_chan] = ACTIONS(2651),
    [anon_sym_thread] = ACTIONS(2651),
    [anon_sym_atomic] = ACTIONS(2651),
    [anon_sym_assert] = ACTIONS(2651),
    [anon_sym_defer] = ACTIONS(2651),
    [anon_sym_goto] = ACTIONS(2651),
    [anon_sym_break] = ACTIONS(2651),
    [anon_sym_continue] = ACTIONS(2651),
    [anon_sym_return] = ACTIONS(2651),
    [anon_sym_DOLLARfor] = ACTIONS(2651),
    [anon_sym_for] = ACTIONS(2651),
    [anon_sym_POUND] = ACTIONS(2651),
    [anon_sym_asm] = ACTIONS(2651),
  },
  [1081] = {
    [sym_line_comment] = STATE(1081),
    [sym_block_comment] = STATE(1081),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_LF] = ACTIONS(3304),
    [anon_sym_CR] = ACTIONS(3304),
    [anon_sym_CR_LF] = ACTIONS(3304),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3304),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_as] = ACTIONS(3304),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_COMMA] = ACTIONS(3304),
    [anon_sym_RBRACE] = ACTIONS(3304),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_EQ] = ACTIONS(3304),
    [anon_sym_fn] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [anon_sym_LT] = ACTIONS(3304),
    [anon_sym_GT] = ACTIONS(3304),
    [anon_sym_EQ_EQ] = ACTIONS(3304),
    [anon_sym_BANG_EQ] = ACTIONS(3304),
    [anon_sym_LT_EQ] = ACTIONS(3304),
    [anon_sym_GT_EQ] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3302),
    [anon_sym_struct] = ACTIONS(3304),
    [anon_sym_mut] = ACTIONS(3304),
    [anon_sym_COLON] = ACTIONS(3304),
    [anon_sym_PLUS_PLUS] = ACTIONS(3304),
    [anon_sym_DASH_DASH] = ACTIONS(3304),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_go] = ACTIONS(3304),
    [anon_sym_spawn] = ACTIONS(3304),
    [anon_sym_json_DOTdecode] = ACTIONS(3304),
    [anon_sym_PIPE] = ACTIONS(3304),
    [anon_sym_LBRACK2] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LT_DASH] = ACTIONS(3304),
    [anon_sym_LT_LT] = ACTIONS(3304),
    [anon_sym_GT_GT] = ACTIONS(3304),
    [anon_sym_GT_GT_GT] = ACTIONS(3304),
    [anon_sym_AMP_CARET] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_PIPE_PIPE] = ACTIONS(3304),
    [anon_sym_or] = ACTIONS(3304),
    [sym_none] = ACTIONS(3304),
    [sym_true] = ACTIONS(3304),
    [sym_false] = ACTIONS(3304),
    [sym_nil] = ACTIONS(3304),
    [anon_sym_QMARK_DOT] = ACTIONS(3304),
    [anon_sym_POUND_LBRACK] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_DOLLARif] = ACTIONS(3304),
    [anon_sym_is] = ACTIONS(3304),
    [anon_sym_BANGis] = ACTIONS(3304),
    [anon_sym_in] = ACTIONS(3304),
    [anon_sym_BANGin] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_select] = ACTIONS(3304),
    [anon_sym_STAR_EQ] = ACTIONS(3304),
    [anon_sym_SLASH_EQ] = ACTIONS(3304),
    [anon_sym_PERCENT_EQ] = ACTIONS(3304),
    [anon_sym_LT_LT_EQ] = ACTIONS(3304),
    [anon_sym_GT_GT_EQ] = ACTIONS(3304),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3304),
    [anon_sym_AMP_EQ] = ACTIONS(3304),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3304),
    [anon_sym_PLUS_EQ] = ACTIONS(3304),
    [anon_sym_DASH_EQ] = ACTIONS(3304),
    [anon_sym_PIPE_EQ] = ACTIONS(3304),
    [anon_sym_CARET_EQ] = ACTIONS(3304),
    [anon_sym_COLON_EQ] = ACTIONS(3304),
    [anon_sym_lock] = ACTIONS(3304),
    [anon_sym_rlock] = ACTIONS(3304),
    [anon_sym_unsafe] = ACTIONS(3304),
    [anon_sym_sql] = ACTIONS(3304),
    [sym_int_literal] = ACTIONS(3304),
    [sym_float_literal] = ACTIONS(3304),
    [sym_rune_literal] = ACTIONS(3304),
    [anon_sym_SQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_c_SQUOTE] = ACTIONS(3304),
    [anon_sym_c_DQUOTE] = ACTIONS(3304),
    [anon_sym_r_SQUOTE] = ACTIONS(3304),
    [anon_sym_r_DQUOTE] = ACTIONS(3304),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3304),
    [anon_sym_shared] = ACTIONS(3304),
    [anon_sym_map_LBRACK] = ACTIONS(3304),
    [anon_sym_chan] = ACTIONS(3304),
    [anon_sym_thread] = ACTIONS(3304),
    [anon_sym_atomic] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_defer] = ACTIONS(3304),
    [anon_sym_goto] = ACTIONS(3304),
    [anon_sym_break] = ACTIONS(3304),
    [anon_sym_continue] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_DOLLARfor] = ACTIONS(3304),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_POUND] = ACTIONS(3304),
    [anon_sym_asm] = ACTIONS(3304),
  },
  [1082] = {
    [sym_line_comment] = STATE(1082),
    [sym_block_comment] = STATE(1082),
    [sym_identifier] = ACTIONS(2443),
    [anon_sym_LF] = ACTIONS(2443),
    [anon_sym_CR] = ACTIONS(2443),
    [anon_sym_CR_LF] = ACTIONS(2443),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2443),
    [anon_sym_DOT] = ACTIONS(2445),
    [anon_sym_as] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(2443),
    [anon_sym_COMMA] = ACTIONS(2445),
    [anon_sym_RBRACE] = ACTIONS(2443),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym_EQ] = ACTIONS(2445),
    [anon_sym_fn] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2445),
    [anon_sym_STAR] = ACTIONS(2445),
    [anon_sym_SLASH] = ACTIONS(2445),
    [anon_sym_PERCENT] = ACTIONS(2445),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_GT] = ACTIONS(2445),
    [anon_sym_EQ_EQ] = ACTIONS(2445),
    [anon_sym_BANG_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_struct] = ACTIONS(2443),
    [anon_sym_mut] = ACTIONS(2443),
    [anon_sym_COLON] = ACTIONS(2443),
    [anon_sym_PLUS_PLUS] = ACTIONS(2445),
    [anon_sym_DASH_DASH] = ACTIONS(2445),
    [anon_sym_QMARK] = ACTIONS(2445),
    [anon_sym_BANG] = ACTIONS(2445),
    [anon_sym_go] = ACTIONS(2443),
    [anon_sym_spawn] = ACTIONS(2443),
    [anon_sym_json_DOTdecode] = ACTIONS(2443),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_LBRACK2] = ACTIONS(2445),
    [anon_sym_TILDE] = ACTIONS(2443),
    [anon_sym_CARET] = ACTIONS(2445),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_LT_DASH] = ACTIONS(2443),
    [anon_sym_LT_LT] = ACTIONS(2445),
    [anon_sym_GT_GT] = ACTIONS(2445),
    [anon_sym_GT_GT_GT] = ACTIONS(2445),
    [anon_sym_AMP_CARET] = ACTIONS(2445),
    [anon_sym_AMP_AMP] = ACTIONS(2445),
    [anon_sym_PIPE_PIPE] = ACTIONS(2445),
    [anon_sym_or] = ACTIONS(2445),
    [sym_none] = ACTIONS(2443),
    [sym_true] = ACTIONS(2443),
    [sym_false] = ACTIONS(2443),
    [sym_nil] = ACTIONS(2443),
    [anon_sym_QMARK_DOT] = ACTIONS(2445),
    [anon_sym_POUND_LBRACK] = ACTIONS(2445),
    [anon_sym_if] = ACTIONS(2443),
    [anon_sym_DOLLARif] = ACTIONS(2443),
    [anon_sym_is] = ACTIONS(2445),
    [anon_sym_BANGis] = ACTIONS(2445),
    [anon_sym_in] = ACTIONS(2445),
    [anon_sym_BANGin] = ACTIONS(2445),
    [anon_sym_match] = ACTIONS(2443),
    [anon_sym_select] = ACTIONS(2443),
    [anon_sym_STAR_EQ] = ACTIONS(2445),
    [anon_sym_SLASH_EQ] = ACTIONS(2445),
    [anon_sym_PERCENT_EQ] = ACTIONS(2445),
    [anon_sym_LT_LT_EQ] = ACTIONS(2445),
    [anon_sym_GT_GT_EQ] = ACTIONS(2445),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2445),
    [anon_sym_AMP_EQ] = ACTIONS(2445),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2445),
    [anon_sym_PLUS_EQ] = ACTIONS(2445),
    [anon_sym_DASH_EQ] = ACTIONS(2445),
    [anon_sym_PIPE_EQ] = ACTIONS(2445),
    [anon_sym_CARET_EQ] = ACTIONS(2445),
    [anon_sym_COLON_EQ] = ACTIONS(2445),
    [anon_sym_lock] = ACTIONS(2443),
    [anon_sym_rlock] = ACTIONS(2443),
    [anon_sym_unsafe] = ACTIONS(2443),
    [anon_sym_sql] = ACTIONS(2443),
    [sym_int_literal] = ACTIONS(2443),
    [sym_float_literal] = ACTIONS(2443),
    [sym_rune_literal] = ACTIONS(2443),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [anon_sym_DQUOTE] = ACTIONS(2443),
    [anon_sym_c_SQUOTE] = ACTIONS(2443),
    [anon_sym_c_DQUOTE] = ACTIONS(2443),
    [anon_sym_r_SQUOTE] = ACTIONS(2443),
    [anon_sym_r_DQUOTE] = ACTIONS(2443),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2443),
    [anon_sym_shared] = ACTIONS(2443),
    [anon_sym_map_LBRACK] = ACTIONS(2443),
    [anon_sym_chan] = ACTIONS(2443),
    [anon_sym_thread] = ACTIONS(2443),
    [anon_sym_atomic] = ACTIONS(2443),
    [anon_sym_assert] = ACTIONS(2443),
    [anon_sym_defer] = ACTIONS(2443),
    [anon_sym_goto] = ACTIONS(2443),
    [anon_sym_break] = ACTIONS(2443),
    [anon_sym_continue] = ACTIONS(2443),
    [anon_sym_return] = ACTIONS(2443),
    [anon_sym_DOLLARfor] = ACTIONS(2443),
    [anon_sym_for] = ACTIONS(2443),
    [anon_sym_POUND] = ACTIONS(2443),
    [anon_sym_asm] = ACTIONS(2443),
  },
  [1083] = {
    [sym_line_comment] = STATE(1083),
    [sym_block_comment] = STATE(1083),
    [sym_identifier] = ACTIONS(3262),
    [anon_sym_LF] = ACTIONS(3262),
    [anon_sym_CR] = ACTIONS(3262),
    [anon_sym_CR_LF] = ACTIONS(3262),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3262),
    [anon_sym_DOT] = ACTIONS(3262),
    [anon_sym_as] = ACTIONS(3262),
    [anon_sym_LBRACE] = ACTIONS(3262),
    [anon_sym_COMMA] = ACTIONS(3262),
    [anon_sym_RBRACE] = ACTIONS(3262),
    [anon_sym_LPAREN] = ACTIONS(3262),
    [anon_sym_EQ] = ACTIONS(3262),
    [anon_sym_fn] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3262),
    [anon_sym_DASH] = ACTIONS(3262),
    [anon_sym_STAR] = ACTIONS(3262),
    [anon_sym_SLASH] = ACTIONS(3262),
    [anon_sym_PERCENT] = ACTIONS(3262),
    [anon_sym_LT] = ACTIONS(3262),
    [anon_sym_GT] = ACTIONS(3262),
    [anon_sym_EQ_EQ] = ACTIONS(3262),
    [anon_sym_BANG_EQ] = ACTIONS(3262),
    [anon_sym_LT_EQ] = ACTIONS(3262),
    [anon_sym_GT_EQ] = ACTIONS(3262),
    [anon_sym_LBRACK] = ACTIONS(3260),
    [anon_sym_struct] = ACTIONS(3262),
    [anon_sym_mut] = ACTIONS(3262),
    [anon_sym_COLON] = ACTIONS(3262),
    [anon_sym_PLUS_PLUS] = ACTIONS(3262),
    [anon_sym_DASH_DASH] = ACTIONS(3262),
    [anon_sym_QMARK] = ACTIONS(3262),
    [anon_sym_BANG] = ACTIONS(3262),
    [anon_sym_go] = ACTIONS(3262),
    [anon_sym_spawn] = ACTIONS(3262),
    [anon_sym_json_DOTdecode] = ACTIONS(3262),
    [anon_sym_PIPE] = ACTIONS(3262),
    [anon_sym_LBRACK2] = ACTIONS(3262),
    [anon_sym_TILDE] = ACTIONS(3262),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_AMP] = ACTIONS(3262),
    [anon_sym_LT_DASH] = ACTIONS(3262),
    [anon_sym_LT_LT] = ACTIONS(3262),
    [anon_sym_GT_GT] = ACTIONS(3262),
    [anon_sym_GT_GT_GT] = ACTIONS(3262),
    [anon_sym_AMP_CARET] = ACTIONS(3262),
    [anon_sym_AMP_AMP] = ACTIONS(3262),
    [anon_sym_PIPE_PIPE] = ACTIONS(3262),
    [anon_sym_or] = ACTIONS(3262),
    [sym_none] = ACTIONS(3262),
    [sym_true] = ACTIONS(3262),
    [sym_false] = ACTIONS(3262),
    [sym_nil] = ACTIONS(3262),
    [anon_sym_QMARK_DOT] = ACTIONS(3262),
    [anon_sym_POUND_LBRACK] = ACTIONS(3262),
    [anon_sym_if] = ACTIONS(3262),
    [anon_sym_DOLLARif] = ACTIONS(3262),
    [anon_sym_is] = ACTIONS(3262),
    [anon_sym_BANGis] = ACTIONS(3262),
    [anon_sym_in] = ACTIONS(3262),
    [anon_sym_BANGin] = ACTIONS(3262),
    [anon_sym_match] = ACTIONS(3262),
    [anon_sym_select] = ACTIONS(3262),
    [anon_sym_STAR_EQ] = ACTIONS(3262),
    [anon_sym_SLASH_EQ] = ACTIONS(3262),
    [anon_sym_PERCENT_EQ] = ACTIONS(3262),
    [anon_sym_LT_LT_EQ] = ACTIONS(3262),
    [anon_sym_GT_GT_EQ] = ACTIONS(3262),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3262),
    [anon_sym_AMP_EQ] = ACTIONS(3262),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3262),
    [anon_sym_PLUS_EQ] = ACTIONS(3262),
    [anon_sym_DASH_EQ] = ACTIONS(3262),
    [anon_sym_PIPE_EQ] = ACTIONS(3262),
    [anon_sym_CARET_EQ] = ACTIONS(3262),
    [anon_sym_COLON_EQ] = ACTIONS(3262),
    [anon_sym_lock] = ACTIONS(3262),
    [anon_sym_rlock] = ACTIONS(3262),
    [anon_sym_unsafe] = ACTIONS(3262),
    [anon_sym_sql] = ACTIONS(3262),
    [sym_int_literal] = ACTIONS(3262),
    [sym_float_literal] = ACTIONS(3262),
    [sym_rune_literal] = ACTIONS(3262),
    [anon_sym_SQUOTE] = ACTIONS(3262),
    [anon_sym_DQUOTE] = ACTIONS(3262),
    [anon_sym_c_SQUOTE] = ACTIONS(3262),
    [anon_sym_c_DQUOTE] = ACTIONS(3262),
    [anon_sym_r_SQUOTE] = ACTIONS(3262),
    [anon_sym_r_DQUOTE] = ACTIONS(3262),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3262),
    [anon_sym_shared] = ACTIONS(3262),
    [anon_sym_map_LBRACK] = ACTIONS(3262),
    [anon_sym_chan] = ACTIONS(3262),
    [anon_sym_thread] = ACTIONS(3262),
    [anon_sym_atomic] = ACTIONS(3262),
    [anon_sym_assert] = ACTIONS(3262),
    [anon_sym_defer] = ACTIONS(3262),
    [anon_sym_goto] = ACTIONS(3262),
    [anon_sym_break] = ACTIONS(3262),
    [anon_sym_continue] = ACTIONS(3262),
    [anon_sym_return] = ACTIONS(3262),
    [anon_sym_DOLLARfor] = ACTIONS(3262),
    [anon_sym_for] = ACTIONS(3262),
    [anon_sym_POUND] = ACTIONS(3262),
    [anon_sym_asm] = ACTIONS(3262),
  },
  [1084] = {
    [sym_line_comment] = STATE(1084),
    [sym_block_comment] = STATE(1084),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_LF] = ACTIONS(3308),
    [anon_sym_CR] = ACTIONS(3308),
    [anon_sym_CR_LF] = ACTIONS(3308),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3308),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_as] = ACTIONS(3308),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_COMMA] = ACTIONS(3308),
    [anon_sym_RBRACE] = ACTIONS(3308),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_EQ] = ACTIONS(3308),
    [anon_sym_fn] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_SLASH] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_EQ_EQ] = ACTIONS(3308),
    [anon_sym_BANG_EQ] = ACTIONS(3308),
    [anon_sym_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT_EQ] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_struct] = ACTIONS(3308),
    [anon_sym_mut] = ACTIONS(3308),
    [anon_sym_COLON] = ACTIONS(3308),
    [anon_sym_PLUS_PLUS] = ACTIONS(3308),
    [anon_sym_DASH_DASH] = ACTIONS(3308),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_BANG] = ACTIONS(3308),
    [anon_sym_go] = ACTIONS(3308),
    [anon_sym_spawn] = ACTIONS(3308),
    [anon_sym_json_DOTdecode] = ACTIONS(3308),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_LBRACK2] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3308),
    [anon_sym_CARET] = ACTIONS(3308),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LT_DASH] = ACTIONS(3308),
    [anon_sym_LT_LT] = ACTIONS(3308),
    [anon_sym_GT_GT] = ACTIONS(3308),
    [anon_sym_GT_GT_GT] = ACTIONS(3308),
    [anon_sym_AMP_CARET] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(3308),
    [anon_sym_PIPE_PIPE] = ACTIONS(3308),
    [anon_sym_or] = ACTIONS(3308),
    [sym_none] = ACTIONS(3308),
    [sym_true] = ACTIONS(3308),
    [sym_false] = ACTIONS(3308),
    [sym_nil] = ACTIONS(3308),
    [anon_sym_QMARK_DOT] = ACTIONS(3308),
    [anon_sym_POUND_LBRACK] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_DOLLARif] = ACTIONS(3308),
    [anon_sym_is] = ACTIONS(3308),
    [anon_sym_BANGis] = ACTIONS(3308),
    [anon_sym_in] = ACTIONS(3308),
    [anon_sym_BANGin] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_select] = ACTIONS(3308),
    [anon_sym_STAR_EQ] = ACTIONS(3308),
    [anon_sym_SLASH_EQ] = ACTIONS(3308),
    [anon_sym_PERCENT_EQ] = ACTIONS(3308),
    [anon_sym_LT_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT_GT_EQ] = ACTIONS(3308),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3308),
    [anon_sym_AMP_EQ] = ACTIONS(3308),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3308),
    [anon_sym_PLUS_EQ] = ACTIONS(3308),
    [anon_sym_DASH_EQ] = ACTIONS(3308),
    [anon_sym_PIPE_EQ] = ACTIONS(3308),
    [anon_sym_CARET_EQ] = ACTIONS(3308),
    [anon_sym_COLON_EQ] = ACTIONS(3308),
    [anon_sym_lock] = ACTIONS(3308),
    [anon_sym_rlock] = ACTIONS(3308),
    [anon_sym_unsafe] = ACTIONS(3308),
    [anon_sym_sql] = ACTIONS(3308),
    [sym_int_literal] = ACTIONS(3308),
    [sym_float_literal] = ACTIONS(3308),
    [sym_rune_literal] = ACTIONS(3308),
    [anon_sym_SQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_c_SQUOTE] = ACTIONS(3308),
    [anon_sym_c_DQUOTE] = ACTIONS(3308),
    [anon_sym_r_SQUOTE] = ACTIONS(3308),
    [anon_sym_r_DQUOTE] = ACTIONS(3308),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3308),
    [anon_sym_shared] = ACTIONS(3308),
    [anon_sym_map_LBRACK] = ACTIONS(3308),
    [anon_sym_chan] = ACTIONS(3308),
    [anon_sym_thread] = ACTIONS(3308),
    [anon_sym_atomic] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_defer] = ACTIONS(3308),
    [anon_sym_goto] = ACTIONS(3308),
    [anon_sym_break] = ACTIONS(3308),
    [anon_sym_continue] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_DOLLARfor] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_POUND] = ACTIONS(3308),
    [anon_sym_asm] = ACTIONS(3308),
  },
  [1085] = {
    [sym_line_comment] = STATE(1085),
    [sym_block_comment] = STATE(1085),
    [sym_identifier] = ACTIONS(3312),
    [anon_sym_LF] = ACTIONS(3312),
    [anon_sym_CR] = ACTIONS(3312),
    [anon_sym_CR_LF] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3312),
    [anon_sym_DOT] = ACTIONS(3312),
    [anon_sym_as] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_RBRACE] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3312),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_fn] = ACTIONS(3312),
    [anon_sym_PLUS] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_SLASH] = ACTIONS(3312),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_GT] = ACTIONS(3312),
    [anon_sym_EQ_EQ] = ACTIONS(3312),
    [anon_sym_BANG_EQ] = ACTIONS(3312),
    [anon_sym_LT_EQ] = ACTIONS(3312),
    [anon_sym_GT_EQ] = ACTIONS(3312),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_struct] = ACTIONS(3312),
    [anon_sym_mut] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3312),
    [anon_sym_DASH_DASH] = ACTIONS(3312),
    [anon_sym_QMARK] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_go] = ACTIONS(3312),
    [anon_sym_spawn] = ACTIONS(3312),
    [anon_sym_json_DOTdecode] = ACTIONS(3312),
    [anon_sym_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACK2] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_CARET] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3312),
    [anon_sym_LT_DASH] = ACTIONS(3312),
    [anon_sym_LT_LT] = ACTIONS(3312),
    [anon_sym_GT_GT] = ACTIONS(3312),
    [anon_sym_GT_GT_GT] = ACTIONS(3312),
    [anon_sym_AMP_CARET] = ACTIONS(3312),
    [anon_sym_AMP_AMP] = ACTIONS(3312),
    [anon_sym_PIPE_PIPE] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3312),
    [sym_none] = ACTIONS(3312),
    [sym_true] = ACTIONS(3312),
    [sym_false] = ACTIONS(3312),
    [sym_nil] = ACTIONS(3312),
    [anon_sym_QMARK_DOT] = ACTIONS(3312),
    [anon_sym_POUND_LBRACK] = ACTIONS(3312),
    [anon_sym_if] = ACTIONS(3312),
    [anon_sym_DOLLARif] = ACTIONS(3312),
    [anon_sym_is] = ACTIONS(3312),
    [anon_sym_BANGis] = ACTIONS(3312),
    [anon_sym_in] = ACTIONS(3312),
    [anon_sym_BANGin] = ACTIONS(3312),
    [anon_sym_match] = ACTIONS(3312),
    [anon_sym_select] = ACTIONS(3312),
    [anon_sym_STAR_EQ] = ACTIONS(3312),
    [anon_sym_SLASH_EQ] = ACTIONS(3312),
    [anon_sym_PERCENT_EQ] = ACTIONS(3312),
    [anon_sym_LT_LT_EQ] = ACTIONS(3312),
    [anon_sym_GT_GT_EQ] = ACTIONS(3312),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3312),
    [anon_sym_AMP_EQ] = ACTIONS(3312),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3312),
    [anon_sym_PLUS_EQ] = ACTIONS(3312),
    [anon_sym_DASH_EQ] = ACTIONS(3312),
    [anon_sym_PIPE_EQ] = ACTIONS(3312),
    [anon_sym_CARET_EQ] = ACTIONS(3312),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_lock] = ACTIONS(3312),
    [anon_sym_rlock] = ACTIONS(3312),
    [anon_sym_unsafe] = ACTIONS(3312),
    [anon_sym_sql] = ACTIONS(3312),
    [sym_int_literal] = ACTIONS(3312),
    [sym_float_literal] = ACTIONS(3312),
    [sym_rune_literal] = ACTIONS(3312),
    [anon_sym_SQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3312),
    [anon_sym_c_SQUOTE] = ACTIONS(3312),
    [anon_sym_c_DQUOTE] = ACTIONS(3312),
    [anon_sym_r_SQUOTE] = ACTIONS(3312),
    [anon_sym_r_DQUOTE] = ACTIONS(3312),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3312),
    [anon_sym_shared] = ACTIONS(3312),
    [anon_sym_map_LBRACK] = ACTIONS(3312),
    [anon_sym_chan] = ACTIONS(3312),
    [anon_sym_thread] = ACTIONS(3312),
    [anon_sym_atomic] = ACTIONS(3312),
    [anon_sym_assert] = ACTIONS(3312),
    [anon_sym_defer] = ACTIONS(3312),
    [anon_sym_goto] = ACTIONS(3312),
    [anon_sym_break] = ACTIONS(3312),
    [anon_sym_continue] = ACTIONS(3312),
    [anon_sym_return] = ACTIONS(3312),
    [anon_sym_DOLLARfor] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3312),
    [anon_sym_POUND] = ACTIONS(3312),
    [anon_sym_asm] = ACTIONS(3312),
  },
  [1086] = {
    [sym_line_comment] = STATE(1086),
    [sym_block_comment] = STATE(1086),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LF] = ACTIONS(3318),
    [anon_sym_CR] = ACTIONS(3318),
    [anon_sym_CR_LF] = ACTIONS(3318),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3318),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_as] = ACTIONS(3318),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3318),
    [anon_sym_RBRACE] = ACTIONS(3318),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_EQ] = ACTIONS(3318),
    [anon_sym_fn] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_SLASH] = ACTIONS(3318),
    [anon_sym_PERCENT] = ACTIONS(3318),
    [anon_sym_LT] = ACTIONS(3318),
    [anon_sym_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_LT_EQ] = ACTIONS(3318),
    [anon_sym_GT_EQ] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3316),
    [anon_sym_struct] = ACTIONS(3318),
    [anon_sym_mut] = ACTIONS(3318),
    [anon_sym_COLON] = ACTIONS(3318),
    [anon_sym_PLUS_PLUS] = ACTIONS(3318),
    [anon_sym_DASH_DASH] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_BANG] = ACTIONS(3318),
    [anon_sym_go] = ACTIONS(3318),
    [anon_sym_spawn] = ACTIONS(3318),
    [anon_sym_json_DOTdecode] = ACTIONS(3318),
    [anon_sym_PIPE] = ACTIONS(3318),
    [anon_sym_LBRACK2] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3318),
    [anon_sym_CARET] = ACTIONS(3318),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LT_DASH] = ACTIONS(3318),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_GT_GT_GT] = ACTIONS(3318),
    [anon_sym_AMP_CARET] = ACTIONS(3318),
    [anon_sym_AMP_AMP] = ACTIONS(3318),
    [anon_sym_PIPE_PIPE] = ACTIONS(3318),
    [anon_sym_or] = ACTIONS(3318),
    [sym_none] = ACTIONS(3318),
    [sym_true] = ACTIONS(3318),
    [sym_false] = ACTIONS(3318),
    [sym_nil] = ACTIONS(3318),
    [anon_sym_QMARK_DOT] = ACTIONS(3318),
    [anon_sym_POUND_LBRACK] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_DOLLARif] = ACTIONS(3318),
    [anon_sym_is] = ACTIONS(3318),
    [anon_sym_BANGis] = ACTIONS(3318),
    [anon_sym_in] = ACTIONS(3318),
    [anon_sym_BANGin] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_select] = ACTIONS(3318),
    [anon_sym_STAR_EQ] = ACTIONS(3318),
    [anon_sym_SLASH_EQ] = ACTIONS(3318),
    [anon_sym_PERCENT_EQ] = ACTIONS(3318),
    [anon_sym_LT_LT_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_AMP_EQ] = ACTIONS(3318),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3318),
    [anon_sym_PLUS_EQ] = ACTIONS(3318),
    [anon_sym_DASH_EQ] = ACTIONS(3318),
    [anon_sym_PIPE_EQ] = ACTIONS(3318),
    [anon_sym_CARET_EQ] = ACTIONS(3318),
    [anon_sym_COLON_EQ] = ACTIONS(3318),
    [anon_sym_lock] = ACTIONS(3318),
    [anon_sym_rlock] = ACTIONS(3318),
    [anon_sym_unsafe] = ACTIONS(3318),
    [anon_sym_sql] = ACTIONS(3318),
    [sym_int_literal] = ACTIONS(3318),
    [sym_float_literal] = ACTIONS(3318),
    [sym_rune_literal] = ACTIONS(3318),
    [anon_sym_SQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_c_SQUOTE] = ACTIONS(3318),
    [anon_sym_c_DQUOTE] = ACTIONS(3318),
    [anon_sym_r_SQUOTE] = ACTIONS(3318),
    [anon_sym_r_DQUOTE] = ACTIONS(3318),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3318),
    [anon_sym_shared] = ACTIONS(3318),
    [anon_sym_map_LBRACK] = ACTIONS(3318),
    [anon_sym_chan] = ACTIONS(3318),
    [anon_sym_thread] = ACTIONS(3318),
    [anon_sym_atomic] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_defer] = ACTIONS(3318),
    [anon_sym_goto] = ACTIONS(3318),
    [anon_sym_break] = ACTIONS(3318),
    [anon_sym_continue] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_DOLLARfor] = ACTIONS(3318),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_POUND] = ACTIONS(3318),
    [anon_sym_asm] = ACTIONS(3318),
  },
  [1087] = {
    [sym_line_comment] = STATE(1087),
    [sym_block_comment] = STATE(1087),
    [sym_identifier] = ACTIONS(3324),
    [anon_sym_LF] = ACTIONS(3324),
    [anon_sym_CR] = ACTIONS(3324),
    [anon_sym_CR_LF] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3324),
    [anon_sym_DOT] = ACTIONS(3324),
    [anon_sym_as] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3324),
    [anon_sym_COMMA] = ACTIONS(3324),
    [anon_sym_RBRACE] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3324),
    [anon_sym_EQ] = ACTIONS(3324),
    [anon_sym_fn] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3324),
    [anon_sym_DASH] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3324),
    [anon_sym_SLASH] = ACTIONS(3324),
    [anon_sym_PERCENT] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_GT] = ACTIONS(3324),
    [anon_sym_EQ_EQ] = ACTIONS(3324),
    [anon_sym_BANG_EQ] = ACTIONS(3324),
    [anon_sym_LT_EQ] = ACTIONS(3324),
    [anon_sym_GT_EQ] = ACTIONS(3324),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_struct] = ACTIONS(3324),
    [anon_sym_mut] = ACTIONS(3324),
    [anon_sym_COLON] = ACTIONS(3324),
    [anon_sym_PLUS_PLUS] = ACTIONS(3324),
    [anon_sym_DASH_DASH] = ACTIONS(3324),
    [anon_sym_QMARK] = ACTIONS(3324),
    [anon_sym_BANG] = ACTIONS(3324),
    [anon_sym_go] = ACTIONS(3324),
    [anon_sym_spawn] = ACTIONS(3324),
    [anon_sym_json_DOTdecode] = ACTIONS(3324),
    [anon_sym_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACK2] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3324),
    [anon_sym_LT_DASH] = ACTIONS(3324),
    [anon_sym_LT_LT] = ACTIONS(3324),
    [anon_sym_GT_GT] = ACTIONS(3324),
    [anon_sym_GT_GT_GT] = ACTIONS(3324),
    [anon_sym_AMP_CARET] = ACTIONS(3324),
    [anon_sym_AMP_AMP] = ACTIONS(3324),
    [anon_sym_PIPE_PIPE] = ACTIONS(3324),
    [anon_sym_or] = ACTIONS(3324),
    [sym_none] = ACTIONS(3324),
    [sym_true] = ACTIONS(3324),
    [sym_false] = ACTIONS(3324),
    [sym_nil] = ACTIONS(3324),
    [anon_sym_QMARK_DOT] = ACTIONS(3324),
    [anon_sym_POUND_LBRACK] = ACTIONS(3324),
    [anon_sym_if] = ACTIONS(3324),
    [anon_sym_DOLLARif] = ACTIONS(3324),
    [anon_sym_is] = ACTIONS(3324),
    [anon_sym_BANGis] = ACTIONS(3324),
    [anon_sym_in] = ACTIONS(3324),
    [anon_sym_BANGin] = ACTIONS(3324),
    [anon_sym_match] = ACTIONS(3324),
    [anon_sym_select] = ACTIONS(3324),
    [anon_sym_STAR_EQ] = ACTIONS(3324),
    [anon_sym_SLASH_EQ] = ACTIONS(3324),
    [anon_sym_PERCENT_EQ] = ACTIONS(3324),
    [anon_sym_LT_LT_EQ] = ACTIONS(3324),
    [anon_sym_GT_GT_EQ] = ACTIONS(3324),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3324),
    [anon_sym_AMP_EQ] = ACTIONS(3324),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3324),
    [anon_sym_PLUS_EQ] = ACTIONS(3324),
    [anon_sym_DASH_EQ] = ACTIONS(3324),
    [anon_sym_PIPE_EQ] = ACTIONS(3324),
    [anon_sym_CARET_EQ] = ACTIONS(3324),
    [anon_sym_COLON_EQ] = ACTIONS(3324),
    [anon_sym_lock] = ACTIONS(3324),
    [anon_sym_rlock] = ACTIONS(3324),
    [anon_sym_unsafe] = ACTIONS(3324),
    [anon_sym_sql] = ACTIONS(3324),
    [sym_int_literal] = ACTIONS(3324),
    [sym_float_literal] = ACTIONS(3324),
    [sym_rune_literal] = ACTIONS(3324),
    [anon_sym_SQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE] = ACTIONS(3324),
    [anon_sym_c_SQUOTE] = ACTIONS(3324),
    [anon_sym_c_DQUOTE] = ACTIONS(3324),
    [anon_sym_r_SQUOTE] = ACTIONS(3324),
    [anon_sym_r_DQUOTE] = ACTIONS(3324),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3324),
    [anon_sym_shared] = ACTIONS(3324),
    [anon_sym_map_LBRACK] = ACTIONS(3324),
    [anon_sym_chan] = ACTIONS(3324),
    [anon_sym_thread] = ACTIONS(3324),
    [anon_sym_atomic] = ACTIONS(3324),
    [anon_sym_assert] = ACTIONS(3324),
    [anon_sym_defer] = ACTIONS(3324),
    [anon_sym_goto] = ACTIONS(3324),
    [anon_sym_break] = ACTIONS(3324),
    [anon_sym_continue] = ACTIONS(3324),
    [anon_sym_return] = ACTIONS(3324),
    [anon_sym_DOLLARfor] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3324),
    [anon_sym_POUND] = ACTIONS(3324),
    [anon_sym_asm] = ACTIONS(3324),
  },
  [1088] = {
    [sym_line_comment] = STATE(1088),
    [sym_block_comment] = STATE(1088),
    [sym_identifier] = ACTIONS(3346),
    [anon_sym_LF] = ACTIONS(3346),
    [anon_sym_CR] = ACTIONS(3346),
    [anon_sym_CR_LF] = ACTIONS(3346),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_DOT] = ACTIONS(3346),
    [anon_sym_as] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_COMMA] = ACTIONS(3346),
    [anon_sym_RBRACE] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3346),
    [anon_sym_EQ] = ACTIONS(3346),
    [anon_sym_fn] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_SLASH] = ACTIONS(3346),
    [anon_sym_PERCENT] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_GT] = ACTIONS(3346),
    [anon_sym_EQ_EQ] = ACTIONS(3346),
    [anon_sym_BANG_EQ] = ACTIONS(3346),
    [anon_sym_LT_EQ] = ACTIONS(3346),
    [anon_sym_GT_EQ] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3346),
    [anon_sym_mut] = ACTIONS(3346),
    [anon_sym_COLON] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_QMARK] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_go] = ACTIONS(3346),
    [anon_sym_spawn] = ACTIONS(3346),
    [anon_sym_json_DOTdecode] = ACTIONS(3346),
    [anon_sym_PIPE] = ACTIONS(3346),
    [anon_sym_LBRACK2] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_CARET] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym_LT_DASH] = ACTIONS(3346),
    [anon_sym_LT_LT] = ACTIONS(3346),
    [anon_sym_GT_GT] = ACTIONS(3346),
    [anon_sym_GT_GT_GT] = ACTIONS(3346),
    [anon_sym_AMP_CARET] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_PIPE_PIPE] = ACTIONS(3346),
    [anon_sym_or] = ACTIONS(3346),
    [sym_none] = ACTIONS(3346),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [sym_nil] = ACTIONS(3346),
    [anon_sym_QMARK_DOT] = ACTIONS(3346),
    [anon_sym_POUND_LBRACK] = ACTIONS(3346),
    [anon_sym_if] = ACTIONS(3346),
    [anon_sym_DOLLARif] = ACTIONS(3346),
    [anon_sym_is] = ACTIONS(3346),
    [anon_sym_BANGis] = ACTIONS(3346),
    [anon_sym_in] = ACTIONS(3346),
    [anon_sym_BANGin] = ACTIONS(3346),
    [anon_sym_match] = ACTIONS(3346),
    [anon_sym_select] = ACTIONS(3346),
    [anon_sym_STAR_EQ] = ACTIONS(3346),
    [anon_sym_SLASH_EQ] = ACTIONS(3346),
    [anon_sym_PERCENT_EQ] = ACTIONS(3346),
    [anon_sym_LT_LT_EQ] = ACTIONS(3346),
    [anon_sym_GT_GT_EQ] = ACTIONS(3346),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3346),
    [anon_sym_AMP_EQ] = ACTIONS(3346),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3346),
    [anon_sym_PLUS_EQ] = ACTIONS(3346),
    [anon_sym_DASH_EQ] = ACTIONS(3346),
    [anon_sym_PIPE_EQ] = ACTIONS(3346),
    [anon_sym_CARET_EQ] = ACTIONS(3346),
    [anon_sym_COLON_EQ] = ACTIONS(3346),
    [anon_sym_lock] = ACTIONS(3346),
    [anon_sym_rlock] = ACTIONS(3346),
    [anon_sym_unsafe] = ACTIONS(3346),
    [anon_sym_sql] = ACTIONS(3346),
    [sym_int_literal] = ACTIONS(3346),
    [sym_float_literal] = ACTIONS(3346),
    [sym_rune_literal] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [anon_sym_c_SQUOTE] = ACTIONS(3346),
    [anon_sym_c_DQUOTE] = ACTIONS(3346),
    [anon_sym_r_SQUOTE] = ACTIONS(3346),
    [anon_sym_r_DQUOTE] = ACTIONS(3346),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3346),
    [anon_sym_shared] = ACTIONS(3346),
    [anon_sym_map_LBRACK] = ACTIONS(3346),
    [anon_sym_chan] = ACTIONS(3346),
    [anon_sym_thread] = ACTIONS(3346),
    [anon_sym_atomic] = ACTIONS(3346),
    [anon_sym_assert] = ACTIONS(3346),
    [anon_sym_defer] = ACTIONS(3346),
    [anon_sym_goto] = ACTIONS(3346),
    [anon_sym_break] = ACTIONS(3346),
    [anon_sym_continue] = ACTIONS(3346),
    [anon_sym_return] = ACTIONS(3346),
    [anon_sym_DOLLARfor] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3346),
    [anon_sym_POUND] = ACTIONS(3346),
    [anon_sym_asm] = ACTIONS(3346),
  },
  [1089] = {
    [sym_line_comment] = STATE(1089),
    [sym_block_comment] = STATE(1089),
    [sym_identifier] = ACTIONS(2889),
    [anon_sym_LF] = ACTIONS(2889),
    [anon_sym_CR] = ACTIONS(2889),
    [anon_sym_CR_LF] = ACTIONS(2889),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym_DOT] = ACTIONS(2889),
    [anon_sym_as] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2889),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_RBRACE] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2889),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_fn] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2889),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_SLASH] = ACTIONS(2889),
    [anon_sym_PERCENT] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_GT] = ACTIONS(2889),
    [anon_sym_EQ_EQ] = ACTIONS(2889),
    [anon_sym_BANG_EQ] = ACTIONS(2889),
    [anon_sym_LT_EQ] = ACTIONS(2889),
    [anon_sym_GT_EQ] = ACTIONS(2889),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_struct] = ACTIONS(2889),
    [anon_sym_mut] = ACTIONS(2889),
    [anon_sym_COLON] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2889),
    [anon_sym_DASH_DASH] = ACTIONS(2889),
    [anon_sym_QMARK] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2889),
    [anon_sym_go] = ACTIONS(2889),
    [anon_sym_spawn] = ACTIONS(2889),
    [anon_sym_json_DOTdecode] = ACTIONS(2889),
    [anon_sym_PIPE] = ACTIONS(2889),
    [anon_sym_LBRACK2] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_CARET] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2889),
    [anon_sym_LT_DASH] = ACTIONS(2889),
    [anon_sym_LT_LT] = ACTIONS(2889),
    [anon_sym_GT_GT] = ACTIONS(2889),
    [anon_sym_GT_GT_GT] = ACTIONS(2889),
    [anon_sym_AMP_CARET] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2889),
    [anon_sym_or] = ACTIONS(2889),
    [sym_none] = ACTIONS(2889),
    [sym_true] = ACTIONS(2889),
    [sym_false] = ACTIONS(2889),
    [sym_nil] = ACTIONS(2889),
    [anon_sym_QMARK_DOT] = ACTIONS(2889),
    [anon_sym_POUND_LBRACK] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_DOLLARif] = ACTIONS(2889),
    [anon_sym_is] = ACTIONS(2889),
    [anon_sym_BANGis] = ACTIONS(2889),
    [anon_sym_in] = ACTIONS(2889),
    [anon_sym_BANGin] = ACTIONS(2889),
    [anon_sym_match] = ACTIONS(2889),
    [anon_sym_select] = ACTIONS(2889),
    [anon_sym_STAR_EQ] = ACTIONS(2889),
    [anon_sym_SLASH_EQ] = ACTIONS(2889),
    [anon_sym_PERCENT_EQ] = ACTIONS(2889),
    [anon_sym_LT_LT_EQ] = ACTIONS(2889),
    [anon_sym_GT_GT_EQ] = ACTIONS(2889),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2889),
    [anon_sym_AMP_EQ] = ACTIONS(2889),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2889),
    [anon_sym_PLUS_EQ] = ACTIONS(2889),
    [anon_sym_DASH_EQ] = ACTIONS(2889),
    [anon_sym_PIPE_EQ] = ACTIONS(2889),
    [anon_sym_CARET_EQ] = ACTIONS(2889),
    [anon_sym_COLON_EQ] = ACTIONS(2889),
    [anon_sym_lock] = ACTIONS(2889),
    [anon_sym_rlock] = ACTIONS(2889),
    [anon_sym_unsafe] = ACTIONS(2889),
    [anon_sym_sql] = ACTIONS(2889),
    [sym_int_literal] = ACTIONS(2889),
    [sym_float_literal] = ACTIONS(2889),
    [sym_rune_literal] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [anon_sym_c_SQUOTE] = ACTIONS(2889),
    [anon_sym_c_DQUOTE] = ACTIONS(2889),
    [anon_sym_r_SQUOTE] = ACTIONS(2889),
    [anon_sym_r_DQUOTE] = ACTIONS(2889),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2889),
    [anon_sym_shared] = ACTIONS(2889),
    [anon_sym_map_LBRACK] = ACTIONS(2889),
    [anon_sym_chan] = ACTIONS(2889),
    [anon_sym_thread] = ACTIONS(2889),
    [anon_sym_atomic] = ACTIONS(2889),
    [anon_sym_assert] = ACTIONS(2889),
    [anon_sym_defer] = ACTIONS(2889),
    [anon_sym_goto] = ACTIONS(2889),
    [anon_sym_break] = ACTIONS(2889),
    [anon_sym_continue] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_DOLLARfor] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_POUND] = ACTIONS(2889),
    [anon_sym_asm] = ACTIONS(2889),
  },
  [1090] = {
    [sym_line_comment] = STATE(1090),
    [sym_block_comment] = STATE(1090),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_LF] = ACTIONS(2877),
    [anon_sym_CR] = ACTIONS(2877),
    [anon_sym_CR_LF] = ACTIONS(2877),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2877),
    [anon_sym_as] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2877),
    [anon_sym_RBRACE] = ACTIONS(2877),
    [anon_sym_LPAREN] = ACTIONS(2877),
    [anon_sym_EQ] = ACTIONS(2877),
    [anon_sym_fn] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_STAR] = ACTIONS(2877),
    [anon_sym_SLASH] = ACTIONS(2877),
    [anon_sym_PERCENT] = ACTIONS(2877),
    [anon_sym_LT] = ACTIONS(2877),
    [anon_sym_GT] = ACTIONS(2877),
    [anon_sym_EQ_EQ] = ACTIONS(2877),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_LT_EQ] = ACTIONS(2877),
    [anon_sym_GT_EQ] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2875),
    [anon_sym_struct] = ACTIONS(2877),
    [anon_sym_mut] = ACTIONS(2877),
    [anon_sym_COLON] = ACTIONS(2877),
    [anon_sym_PLUS_PLUS] = ACTIONS(2877),
    [anon_sym_DASH_DASH] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2877),
    [anon_sym_go] = ACTIONS(2877),
    [anon_sym_spawn] = ACTIONS(2877),
    [anon_sym_json_DOTdecode] = ACTIONS(2877),
    [anon_sym_PIPE] = ACTIONS(2877),
    [anon_sym_LBRACK2] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2877),
    [anon_sym_CARET] = ACTIONS(2877),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_LT_DASH] = ACTIONS(2877),
    [anon_sym_LT_LT] = ACTIONS(2877),
    [anon_sym_GT_GT] = ACTIONS(2877),
    [anon_sym_GT_GT_GT] = ACTIONS(2877),
    [anon_sym_AMP_CARET] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_PIPE_PIPE] = ACTIONS(2877),
    [anon_sym_or] = ACTIONS(2877),
    [sym_none] = ACTIONS(2877),
    [sym_true] = ACTIONS(2877),
    [sym_false] = ACTIONS(2877),
    [sym_nil] = ACTIONS(2877),
    [anon_sym_QMARK_DOT] = ACTIONS(2877),
    [anon_sym_POUND_LBRACK] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_DOLLARif] = ACTIONS(2877),
    [anon_sym_is] = ACTIONS(2877),
    [anon_sym_BANGis] = ACTIONS(2877),
    [anon_sym_in] = ACTIONS(2877),
    [anon_sym_BANGin] = ACTIONS(2877),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_select] = ACTIONS(2877),
    [anon_sym_STAR_EQ] = ACTIONS(2877),
    [anon_sym_SLASH_EQ] = ACTIONS(2877),
    [anon_sym_PERCENT_EQ] = ACTIONS(2877),
    [anon_sym_LT_LT_EQ] = ACTIONS(2877),
    [anon_sym_GT_GT_EQ] = ACTIONS(2877),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2877),
    [anon_sym_AMP_EQ] = ACTIONS(2877),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2877),
    [anon_sym_PLUS_EQ] = ACTIONS(2877),
    [anon_sym_DASH_EQ] = ACTIONS(2877),
    [anon_sym_PIPE_EQ] = ACTIONS(2877),
    [anon_sym_CARET_EQ] = ACTIONS(2877),
    [anon_sym_COLON_EQ] = ACTIONS(2877),
    [anon_sym_lock] = ACTIONS(2877),
    [anon_sym_rlock] = ACTIONS(2877),
    [anon_sym_unsafe] = ACTIONS(2877),
    [anon_sym_sql] = ACTIONS(2877),
    [sym_int_literal] = ACTIONS(2877),
    [sym_float_literal] = ACTIONS(2877),
    [sym_rune_literal] = ACTIONS(2877),
    [anon_sym_SQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [anon_sym_c_SQUOTE] = ACTIONS(2877),
    [anon_sym_c_DQUOTE] = ACTIONS(2877),
    [anon_sym_r_SQUOTE] = ACTIONS(2877),
    [anon_sym_r_DQUOTE] = ACTIONS(2877),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2877),
    [anon_sym_shared] = ACTIONS(2877),
    [anon_sym_map_LBRACK] = ACTIONS(2877),
    [anon_sym_chan] = ACTIONS(2877),
    [anon_sym_thread] = ACTIONS(2877),
    [anon_sym_atomic] = ACTIONS(2877),
    [anon_sym_assert] = ACTIONS(2877),
    [anon_sym_defer] = ACTIONS(2877),
    [anon_sym_goto] = ACTIONS(2877),
    [anon_sym_break] = ACTIONS(2877),
    [anon_sym_continue] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_DOLLARfor] = ACTIONS(2877),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_POUND] = ACTIONS(2877),
    [anon_sym_asm] = ACTIONS(2877),
  },
  [1091] = {
    [sym_line_comment] = STATE(1091),
    [sym_block_comment] = STATE(1091),
    [sym_identifier] = ACTIONS(3350),
    [anon_sym_LF] = ACTIONS(3350),
    [anon_sym_CR] = ACTIONS(3350),
    [anon_sym_CR_LF] = ACTIONS(3350),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(3350),
    [anon_sym_as] = ACTIONS(3350),
    [anon_sym_LBRACE] = ACTIONS(3350),
    [anon_sym_COMMA] = ACTIONS(3350),
    [anon_sym_RBRACE] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(3350),
    [anon_sym_EQ] = ACTIONS(3350),
    [anon_sym_fn] = ACTIONS(3350),
    [anon_sym_PLUS] = ACTIONS(3350),
    [anon_sym_DASH] = ACTIONS(3350),
    [anon_sym_STAR] = ACTIONS(3350),
    [anon_sym_SLASH] = ACTIONS(3350),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_LT] = ACTIONS(3350),
    [anon_sym_GT] = ACTIONS(3350),
    [anon_sym_EQ_EQ] = ACTIONS(3350),
    [anon_sym_BANG_EQ] = ACTIONS(3350),
    [anon_sym_LT_EQ] = ACTIONS(3350),
    [anon_sym_GT_EQ] = ACTIONS(3350),
    [anon_sym_LBRACK] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3350),
    [anon_sym_mut] = ACTIONS(3350),
    [anon_sym_COLON] = ACTIONS(3350),
    [anon_sym_PLUS_PLUS] = ACTIONS(3350),
    [anon_sym_DASH_DASH] = ACTIONS(3350),
    [anon_sym_QMARK] = ACTIONS(3350),
    [anon_sym_BANG] = ACTIONS(3350),
    [anon_sym_go] = ACTIONS(3350),
    [anon_sym_spawn] = ACTIONS(3350),
    [anon_sym_json_DOTdecode] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3350),
    [anon_sym_LBRACK2] = ACTIONS(3350),
    [anon_sym_TILDE] = ACTIONS(3350),
    [anon_sym_CARET] = ACTIONS(3350),
    [anon_sym_AMP] = ACTIONS(3350),
    [anon_sym_LT_DASH] = ACTIONS(3350),
    [anon_sym_LT_LT] = ACTIONS(3350),
    [anon_sym_GT_GT] = ACTIONS(3350),
    [anon_sym_GT_GT_GT] = ACTIONS(3350),
    [anon_sym_AMP_CARET] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_PIPE_PIPE] = ACTIONS(3350),
    [anon_sym_or] = ACTIONS(3350),
    [sym_none] = ACTIONS(3350),
    [sym_true] = ACTIONS(3350),
    [sym_false] = ACTIONS(3350),
    [sym_nil] = ACTIONS(3350),
    [anon_sym_QMARK_DOT] = ACTIONS(3350),
    [anon_sym_POUND_LBRACK] = ACTIONS(3350),
    [anon_sym_if] = ACTIONS(3350),
    [anon_sym_DOLLARif] = ACTIONS(3350),
    [anon_sym_is] = ACTIONS(3350),
    [anon_sym_BANGis] = ACTIONS(3350),
    [anon_sym_in] = ACTIONS(3350),
    [anon_sym_BANGin] = ACTIONS(3350),
    [anon_sym_match] = ACTIONS(3350),
    [anon_sym_select] = ACTIONS(3350),
    [anon_sym_STAR_EQ] = ACTIONS(3350),
    [anon_sym_SLASH_EQ] = ACTIONS(3350),
    [anon_sym_PERCENT_EQ] = ACTIONS(3350),
    [anon_sym_LT_LT_EQ] = ACTIONS(3350),
    [anon_sym_GT_GT_EQ] = ACTIONS(3350),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3350),
    [anon_sym_AMP_EQ] = ACTIONS(3350),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3350),
    [anon_sym_PLUS_EQ] = ACTIONS(3350),
    [anon_sym_DASH_EQ] = ACTIONS(3350),
    [anon_sym_PIPE_EQ] = ACTIONS(3350),
    [anon_sym_CARET_EQ] = ACTIONS(3350),
    [anon_sym_COLON_EQ] = ACTIONS(3350),
    [anon_sym_lock] = ACTIONS(3350),
    [anon_sym_rlock] = ACTIONS(3350),
    [anon_sym_unsafe] = ACTIONS(3350),
    [anon_sym_sql] = ACTIONS(3350),
    [sym_int_literal] = ACTIONS(3350),
    [sym_float_literal] = ACTIONS(3350),
    [sym_rune_literal] = ACTIONS(3350),
    [anon_sym_SQUOTE] = ACTIONS(3350),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [anon_sym_c_SQUOTE] = ACTIONS(3350),
    [anon_sym_c_DQUOTE] = ACTIONS(3350),
    [anon_sym_r_SQUOTE] = ACTIONS(3350),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3350),
    [anon_sym_shared] = ACTIONS(3350),
    [anon_sym_map_LBRACK] = ACTIONS(3350),
    [anon_sym_chan] = ACTIONS(3350),
    [anon_sym_thread] = ACTIONS(3350),
    [anon_sym_atomic] = ACTIONS(3350),
    [anon_sym_assert] = ACTIONS(3350),
    [anon_sym_defer] = ACTIONS(3350),
    [anon_sym_goto] = ACTIONS(3350),
    [anon_sym_break] = ACTIONS(3350),
    [anon_sym_continue] = ACTIONS(3350),
    [anon_sym_return] = ACTIONS(3350),
    [anon_sym_DOLLARfor] = ACTIONS(3350),
    [anon_sym_for] = ACTIONS(3350),
    [anon_sym_POUND] = ACTIONS(3350),
    [anon_sym_asm] = ACTIONS(3350),
  },
  [1092] = {
    [sym_line_comment] = STATE(1092),
    [sym_block_comment] = STATE(1092),
    [sym_identifier] = ACTIONS(2849),
    [anon_sym_LF] = ACTIONS(2849),
    [anon_sym_CR] = ACTIONS(2849),
    [anon_sym_CR_LF] = ACTIONS(2849),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2849),
    [anon_sym_DOT] = ACTIONS(2849),
    [anon_sym_as] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_COMMA] = ACTIONS(2849),
    [anon_sym_RBRACE] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2849),
    [anon_sym_EQ] = ACTIONS(2849),
    [anon_sym_fn] = ACTIONS(2849),
    [anon_sym_PLUS] = ACTIONS(2849),
    [anon_sym_DASH] = ACTIONS(2849),
    [anon_sym_STAR] = ACTIONS(2849),
    [anon_sym_SLASH] = ACTIONS(2849),
    [anon_sym_PERCENT] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_GT] = ACTIONS(2849),
    [anon_sym_EQ_EQ] = ACTIONS(2849),
    [anon_sym_BANG_EQ] = ACTIONS(2849),
    [anon_sym_LT_EQ] = ACTIONS(2849),
    [anon_sym_GT_EQ] = ACTIONS(2849),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_struct] = ACTIONS(2849),
    [anon_sym_mut] = ACTIONS(2849),
    [anon_sym_COLON] = ACTIONS(2849),
    [anon_sym_PLUS_PLUS] = ACTIONS(2849),
    [anon_sym_DASH_DASH] = ACTIONS(2849),
    [anon_sym_QMARK] = ACTIONS(2849),
    [anon_sym_BANG] = ACTIONS(2849),
    [anon_sym_go] = ACTIONS(2849),
    [anon_sym_spawn] = ACTIONS(2849),
    [anon_sym_json_DOTdecode] = ACTIONS(2849),
    [anon_sym_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACK2] = ACTIONS(2849),
    [anon_sym_TILDE] = ACTIONS(2849),
    [anon_sym_CARET] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2849),
    [anon_sym_LT_DASH] = ACTIONS(2849),
    [anon_sym_LT_LT] = ACTIONS(2849),
    [anon_sym_GT_GT] = ACTIONS(2849),
    [anon_sym_GT_GT_GT] = ACTIONS(2849),
    [anon_sym_AMP_CARET] = ACTIONS(2849),
    [anon_sym_AMP_AMP] = ACTIONS(2849),
    [anon_sym_PIPE_PIPE] = ACTIONS(2849),
    [anon_sym_or] = ACTIONS(2849),
    [sym_none] = ACTIONS(2849),
    [sym_true] = ACTIONS(2849),
    [sym_false] = ACTIONS(2849),
    [sym_nil] = ACTIONS(2849),
    [anon_sym_QMARK_DOT] = ACTIONS(2849),
    [anon_sym_POUND_LBRACK] = ACTIONS(2849),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_DOLLARif] = ACTIONS(2849),
    [anon_sym_is] = ACTIONS(2849),
    [anon_sym_BANGis] = ACTIONS(2849),
    [anon_sym_in] = ACTIONS(2849),
    [anon_sym_BANGin] = ACTIONS(2849),
    [anon_sym_match] = ACTIONS(2849),
    [anon_sym_select] = ACTIONS(2849),
    [anon_sym_STAR_EQ] = ACTIONS(2849),
    [anon_sym_SLASH_EQ] = ACTIONS(2849),
    [anon_sym_PERCENT_EQ] = ACTIONS(2849),
    [anon_sym_LT_LT_EQ] = ACTIONS(2849),
    [anon_sym_GT_GT_EQ] = ACTIONS(2849),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2849),
    [anon_sym_AMP_EQ] = ACTIONS(2849),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2849),
    [anon_sym_PLUS_EQ] = ACTIONS(2849),
    [anon_sym_DASH_EQ] = ACTIONS(2849),
    [anon_sym_PIPE_EQ] = ACTIONS(2849),
    [anon_sym_CARET_EQ] = ACTIONS(2849),
    [anon_sym_COLON_EQ] = ACTIONS(2849),
    [anon_sym_lock] = ACTIONS(2849),
    [anon_sym_rlock] = ACTIONS(2849),
    [anon_sym_unsafe] = ACTIONS(2849),
    [anon_sym_sql] = ACTIONS(2849),
    [sym_int_literal] = ACTIONS(2849),
    [sym_float_literal] = ACTIONS(2849),
    [sym_rune_literal] = ACTIONS(2849),
    [anon_sym_SQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [anon_sym_c_SQUOTE] = ACTIONS(2849),
    [anon_sym_c_DQUOTE] = ACTIONS(2849),
    [anon_sym_r_SQUOTE] = ACTIONS(2849),
    [anon_sym_r_DQUOTE] = ACTIONS(2849),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2849),
    [anon_sym_shared] = ACTIONS(2849),
    [anon_sym_map_LBRACK] = ACTIONS(2849),
    [anon_sym_chan] = ACTIONS(2849),
    [anon_sym_thread] = ACTIONS(2849),
    [anon_sym_atomic] = ACTIONS(2849),
    [anon_sym_assert] = ACTIONS(2849),
    [anon_sym_defer] = ACTIONS(2849),
    [anon_sym_goto] = ACTIONS(2849),
    [anon_sym_break] = ACTIONS(2849),
    [anon_sym_continue] = ACTIONS(2849),
    [anon_sym_return] = ACTIONS(2849),
    [anon_sym_DOLLARfor] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2849),
    [anon_sym_POUND] = ACTIONS(2849),
    [anon_sym_asm] = ACTIONS(2849),
  },
  [1093] = {
    [sym_line_comment] = STATE(1093),
    [sym_block_comment] = STATE(1093),
    [sym_identifier] = ACTIONS(2845),
    [anon_sym_LF] = ACTIONS(2845),
    [anon_sym_CR] = ACTIONS(2845),
    [anon_sym_CR_LF] = ACTIONS(2845),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym_DOT] = ACTIONS(2845),
    [anon_sym_as] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2845),
    [anon_sym_COMMA] = ACTIONS(2845),
    [anon_sym_RBRACE] = ACTIONS(2845),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_EQ] = ACTIONS(2845),
    [anon_sym_fn] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2845),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_SLASH] = ACTIONS(2845),
    [anon_sym_PERCENT] = ACTIONS(2845),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_GT] = ACTIONS(2845),
    [anon_sym_EQ_EQ] = ACTIONS(2845),
    [anon_sym_BANG_EQ] = ACTIONS(2845),
    [anon_sym_LT_EQ] = ACTIONS(2845),
    [anon_sym_GT_EQ] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2845),
    [anon_sym_mut] = ACTIONS(2845),
    [anon_sym_COLON] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2845),
    [anon_sym_DASH_DASH] = ACTIONS(2845),
    [anon_sym_QMARK] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_go] = ACTIONS(2845),
    [anon_sym_spawn] = ACTIONS(2845),
    [anon_sym_json_DOTdecode] = ACTIONS(2845),
    [anon_sym_PIPE] = ACTIONS(2845),
    [anon_sym_LBRACK2] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_CARET] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2845),
    [anon_sym_LT_DASH] = ACTIONS(2845),
    [anon_sym_LT_LT] = ACTIONS(2845),
    [anon_sym_GT_GT] = ACTIONS(2845),
    [anon_sym_GT_GT_GT] = ACTIONS(2845),
    [anon_sym_AMP_CARET] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_PIPE_PIPE] = ACTIONS(2845),
    [anon_sym_or] = ACTIONS(2845),
    [sym_none] = ACTIONS(2845),
    [sym_true] = ACTIONS(2845),
    [sym_false] = ACTIONS(2845),
    [sym_nil] = ACTIONS(2845),
    [anon_sym_QMARK_DOT] = ACTIONS(2845),
    [anon_sym_POUND_LBRACK] = ACTIONS(2845),
    [anon_sym_if] = ACTIONS(2845),
    [anon_sym_DOLLARif] = ACTIONS(2845),
    [anon_sym_is] = ACTIONS(2845),
    [anon_sym_BANGis] = ACTIONS(2845),
    [anon_sym_in] = ACTIONS(2845),
    [anon_sym_BANGin] = ACTIONS(2845),
    [anon_sym_match] = ACTIONS(2845),
    [anon_sym_select] = ACTIONS(2845),
    [anon_sym_STAR_EQ] = ACTIONS(2845),
    [anon_sym_SLASH_EQ] = ACTIONS(2845),
    [anon_sym_PERCENT_EQ] = ACTIONS(2845),
    [anon_sym_LT_LT_EQ] = ACTIONS(2845),
    [anon_sym_GT_GT_EQ] = ACTIONS(2845),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2845),
    [anon_sym_AMP_EQ] = ACTIONS(2845),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2845),
    [anon_sym_PLUS_EQ] = ACTIONS(2845),
    [anon_sym_DASH_EQ] = ACTIONS(2845),
    [anon_sym_PIPE_EQ] = ACTIONS(2845),
    [anon_sym_CARET_EQ] = ACTIONS(2845),
    [anon_sym_COLON_EQ] = ACTIONS(2845),
    [anon_sym_lock] = ACTIONS(2845),
    [anon_sym_rlock] = ACTIONS(2845),
    [anon_sym_unsafe] = ACTIONS(2845),
    [anon_sym_sql] = ACTIONS(2845),
    [sym_int_literal] = ACTIONS(2845),
    [sym_float_literal] = ACTIONS(2845),
    [sym_rune_literal] = ACTIONS(2845),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2845),
    [anon_sym_c_SQUOTE] = ACTIONS(2845),
    [anon_sym_c_DQUOTE] = ACTIONS(2845),
    [anon_sym_r_SQUOTE] = ACTIONS(2845),
    [anon_sym_r_DQUOTE] = ACTIONS(2845),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2845),
    [anon_sym_shared] = ACTIONS(2845),
    [anon_sym_map_LBRACK] = ACTIONS(2845),
    [anon_sym_chan] = ACTIONS(2845),
    [anon_sym_thread] = ACTIONS(2845),
    [anon_sym_atomic] = ACTIONS(2845),
    [anon_sym_assert] = ACTIONS(2845),
    [anon_sym_defer] = ACTIONS(2845),
    [anon_sym_goto] = ACTIONS(2845),
    [anon_sym_break] = ACTIONS(2845),
    [anon_sym_continue] = ACTIONS(2845),
    [anon_sym_return] = ACTIONS(2845),
    [anon_sym_DOLLARfor] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2845),
    [anon_sym_POUND] = ACTIONS(2845),
    [anon_sym_asm] = ACTIONS(2845),
  },
  [1094] = {
    [sym_line_comment] = STATE(1094),
    [sym_block_comment] = STATE(1094),
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_LF] = ACTIONS(3356),
    [anon_sym_CR] = ACTIONS(3356),
    [anon_sym_CR_LF] = ACTIONS(3356),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3356),
    [anon_sym_DOT] = ACTIONS(3356),
    [anon_sym_as] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3356),
    [anon_sym_COMMA] = ACTIONS(3356),
    [anon_sym_RBRACE] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3356),
    [anon_sym_EQ] = ACTIONS(3356),
    [anon_sym_fn] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_STAR] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_PERCENT] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_GT] = ACTIONS(3356),
    [anon_sym_EQ_EQ] = ACTIONS(3356),
    [anon_sym_BANG_EQ] = ACTIONS(3356),
    [anon_sym_LT_EQ] = ACTIONS(3356),
    [anon_sym_GT_EQ] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3354),
    [anon_sym_struct] = ACTIONS(3356),
    [anon_sym_mut] = ACTIONS(3356),
    [anon_sym_COLON] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3356),
    [anon_sym_DASH_DASH] = ACTIONS(3356),
    [anon_sym_QMARK] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3356),
    [anon_sym_go] = ACTIONS(3356),
    [anon_sym_spawn] = ACTIONS(3356),
    [anon_sym_json_DOTdecode] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(3356),
    [anon_sym_LBRACK2] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3356),
    [anon_sym_CARET] = ACTIONS(3356),
    [anon_sym_AMP] = ACTIONS(3356),
    [anon_sym_LT_DASH] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(3356),
    [anon_sym_GT_GT] = ACTIONS(3356),
    [anon_sym_GT_GT_GT] = ACTIONS(3356),
    [anon_sym_AMP_CARET] = ACTIONS(3356),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_PIPE_PIPE] = ACTIONS(3356),
    [anon_sym_or] = ACTIONS(3356),
    [sym_none] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_nil] = ACTIONS(3356),
    [anon_sym_QMARK_DOT] = ACTIONS(3356),
    [anon_sym_POUND_LBRACK] = ACTIONS(3356),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_DOLLARif] = ACTIONS(3356),
    [anon_sym_is] = ACTIONS(3356),
    [anon_sym_BANGis] = ACTIONS(3356),
    [anon_sym_in] = ACTIONS(3356),
    [anon_sym_BANGin] = ACTIONS(3356),
    [anon_sym_match] = ACTIONS(3356),
    [anon_sym_select] = ACTIONS(3356),
    [anon_sym_STAR_EQ] = ACTIONS(3356),
    [anon_sym_SLASH_EQ] = ACTIONS(3356),
    [anon_sym_PERCENT_EQ] = ACTIONS(3356),
    [anon_sym_LT_LT_EQ] = ACTIONS(3356),
    [anon_sym_GT_GT_EQ] = ACTIONS(3356),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3356),
    [anon_sym_AMP_EQ] = ACTIONS(3356),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3356),
    [anon_sym_PLUS_EQ] = ACTIONS(3356),
    [anon_sym_DASH_EQ] = ACTIONS(3356),
    [anon_sym_PIPE_EQ] = ACTIONS(3356),
    [anon_sym_CARET_EQ] = ACTIONS(3356),
    [anon_sym_COLON_EQ] = ACTIONS(3356),
    [anon_sym_lock] = ACTIONS(3356),
    [anon_sym_rlock] = ACTIONS(3356),
    [anon_sym_unsafe] = ACTIONS(3356),
    [anon_sym_sql] = ACTIONS(3356),
    [sym_int_literal] = ACTIONS(3356),
    [sym_float_literal] = ACTIONS(3356),
    [sym_rune_literal] = ACTIONS(3356),
    [anon_sym_SQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [anon_sym_c_SQUOTE] = ACTIONS(3356),
    [anon_sym_c_DQUOTE] = ACTIONS(3356),
    [anon_sym_r_SQUOTE] = ACTIONS(3356),
    [anon_sym_r_DQUOTE] = ACTIONS(3356),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3356),
    [anon_sym_shared] = ACTIONS(3356),
    [anon_sym_map_LBRACK] = ACTIONS(3356),
    [anon_sym_chan] = ACTIONS(3356),
    [anon_sym_thread] = ACTIONS(3356),
    [anon_sym_atomic] = ACTIONS(3356),
    [anon_sym_assert] = ACTIONS(3356),
    [anon_sym_defer] = ACTIONS(3356),
    [anon_sym_goto] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_DOLLARfor] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_POUND] = ACTIONS(3356),
    [anon_sym_asm] = ACTIONS(3356),
  },
  [1095] = {
    [sym_line_comment] = STATE(1095),
    [sym_block_comment] = STATE(1095),
    [sym_identifier] = ACTIONS(2947),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_CR] = ACTIONS(2947),
    [anon_sym_CR_LF] = ACTIONS(2947),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_DOT] = ACTIONS(2947),
    [anon_sym_as] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_COMMA] = ACTIONS(2947),
    [anon_sym_RBRACE] = ACTIONS(2947),
    [anon_sym_LPAREN] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(2947),
    [anon_sym_fn] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_STAR] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(2947),
    [anon_sym_PERCENT] = ACTIONS(2947),
    [anon_sym_LT] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2947),
    [anon_sym_EQ_EQ] = ACTIONS(2947),
    [anon_sym_BANG_EQ] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2947),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2945),
    [anon_sym_struct] = ACTIONS(2947),
    [anon_sym_mut] = ACTIONS(2947),
    [anon_sym_COLON] = ACTIONS(2947),
    [anon_sym_PLUS_PLUS] = ACTIONS(2947),
    [anon_sym_DASH_DASH] = ACTIONS(2947),
    [anon_sym_QMARK] = ACTIONS(2947),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_go] = ACTIONS(2947),
    [anon_sym_spawn] = ACTIONS(2947),
    [anon_sym_json_DOTdecode] = ACTIONS(2947),
    [anon_sym_PIPE] = ACTIONS(2947),
    [anon_sym_LBRACK2] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2947),
    [anon_sym_CARET] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2947),
    [anon_sym_LT_DASH] = ACTIONS(2947),
    [anon_sym_LT_LT] = ACTIONS(2947),
    [anon_sym_GT_GT] = ACTIONS(2947),
    [anon_sym_GT_GT_GT] = ACTIONS(2947),
    [anon_sym_AMP_CARET] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [anon_sym_or] = ACTIONS(2947),
    [sym_none] = ACTIONS(2947),
    [sym_true] = ACTIONS(2947),
    [sym_false] = ACTIONS(2947),
    [sym_nil] = ACTIONS(2947),
    [anon_sym_QMARK_DOT] = ACTIONS(2947),
    [anon_sym_POUND_LBRACK] = ACTIONS(2947),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_DOLLARif] = ACTIONS(2947),
    [anon_sym_is] = ACTIONS(2947),
    [anon_sym_BANGis] = ACTIONS(2947),
    [anon_sym_in] = ACTIONS(2947),
    [anon_sym_BANGin] = ACTIONS(2947),
    [anon_sym_match] = ACTIONS(2947),
    [anon_sym_select] = ACTIONS(2947),
    [anon_sym_STAR_EQ] = ACTIONS(2947),
    [anon_sym_SLASH_EQ] = ACTIONS(2947),
    [anon_sym_PERCENT_EQ] = ACTIONS(2947),
    [anon_sym_LT_LT_EQ] = ACTIONS(2947),
    [anon_sym_GT_GT_EQ] = ACTIONS(2947),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2947),
    [anon_sym_AMP_EQ] = ACTIONS(2947),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2947),
    [anon_sym_PLUS_EQ] = ACTIONS(2947),
    [anon_sym_DASH_EQ] = ACTIONS(2947),
    [anon_sym_PIPE_EQ] = ACTIONS(2947),
    [anon_sym_CARET_EQ] = ACTIONS(2947),
    [anon_sym_COLON_EQ] = ACTIONS(2947),
    [anon_sym_lock] = ACTIONS(2947),
    [anon_sym_rlock] = ACTIONS(2947),
    [anon_sym_unsafe] = ACTIONS(2947),
    [anon_sym_sql] = ACTIONS(2947),
    [sym_int_literal] = ACTIONS(2947),
    [sym_float_literal] = ACTIONS(2947),
    [sym_rune_literal] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(2947),
    [anon_sym_DQUOTE] = ACTIONS(2947),
    [anon_sym_c_SQUOTE] = ACTIONS(2947),
    [anon_sym_c_DQUOTE] = ACTIONS(2947),
    [anon_sym_r_SQUOTE] = ACTIONS(2947),
    [anon_sym_r_DQUOTE] = ACTIONS(2947),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2947),
    [anon_sym_shared] = ACTIONS(2947),
    [anon_sym_map_LBRACK] = ACTIONS(2947),
    [anon_sym_chan] = ACTIONS(2947),
    [anon_sym_thread] = ACTIONS(2947),
    [anon_sym_atomic] = ACTIONS(2947),
    [anon_sym_assert] = ACTIONS(2947),
    [anon_sym_defer] = ACTIONS(2947),
    [anon_sym_goto] = ACTIONS(2947),
    [anon_sym_break] = ACTIONS(2947),
    [anon_sym_continue] = ACTIONS(2947),
    [anon_sym_return] = ACTIONS(2947),
    [anon_sym_DOLLARfor] = ACTIONS(2947),
    [anon_sym_for] = ACTIONS(2947),
    [anon_sym_POUND] = ACTIONS(2947),
    [anon_sym_asm] = ACTIONS(2947),
  },
  [1096] = {
    [sym_line_comment] = STATE(1096),
    [sym_block_comment] = STATE(1096),
    [sym_identifier] = ACTIONS(2935),
    [anon_sym_LF] = ACTIONS(2935),
    [anon_sym_CR] = ACTIONS(2935),
    [anon_sym_CR_LF] = ACTIONS(2935),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2935),
    [anon_sym_DOT] = ACTIONS(2935),
    [anon_sym_as] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(2935),
    [anon_sym_COMMA] = ACTIONS(2935),
    [anon_sym_RBRACE] = ACTIONS(2935),
    [anon_sym_LPAREN] = ACTIONS(2935),
    [anon_sym_EQ] = ACTIONS(2935),
    [anon_sym_fn] = ACTIONS(2935),
    [anon_sym_PLUS] = ACTIONS(2935),
    [anon_sym_DASH] = ACTIONS(2935),
    [anon_sym_STAR] = ACTIONS(2935),
    [anon_sym_SLASH] = ACTIONS(2935),
    [anon_sym_PERCENT] = ACTIONS(2935),
    [anon_sym_LT] = ACTIONS(2935),
    [anon_sym_GT] = ACTIONS(2935),
    [anon_sym_EQ_EQ] = ACTIONS(2935),
    [anon_sym_BANG_EQ] = ACTIONS(2935),
    [anon_sym_LT_EQ] = ACTIONS(2935),
    [anon_sym_GT_EQ] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2933),
    [anon_sym_struct] = ACTIONS(2935),
    [anon_sym_mut] = ACTIONS(2935),
    [anon_sym_COLON] = ACTIONS(2935),
    [anon_sym_PLUS_PLUS] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2935),
    [anon_sym_QMARK] = ACTIONS(2935),
    [anon_sym_BANG] = ACTIONS(2935),
    [anon_sym_go] = ACTIONS(2935),
    [anon_sym_spawn] = ACTIONS(2935),
    [anon_sym_json_DOTdecode] = ACTIONS(2935),
    [anon_sym_PIPE] = ACTIONS(2935),
    [anon_sym_LBRACK2] = ACTIONS(2935),
    [anon_sym_TILDE] = ACTIONS(2935),
    [anon_sym_CARET] = ACTIONS(2935),
    [anon_sym_AMP] = ACTIONS(2935),
    [anon_sym_LT_DASH] = ACTIONS(2935),
    [anon_sym_LT_LT] = ACTIONS(2935),
    [anon_sym_GT_GT] = ACTIONS(2935),
    [anon_sym_GT_GT_GT] = ACTIONS(2935),
    [anon_sym_AMP_CARET] = ACTIONS(2935),
    [anon_sym_AMP_AMP] = ACTIONS(2935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2935),
    [anon_sym_or] = ACTIONS(2935),
    [sym_none] = ACTIONS(2935),
    [sym_true] = ACTIONS(2935),
    [sym_false] = ACTIONS(2935),
    [sym_nil] = ACTIONS(2935),
    [anon_sym_QMARK_DOT] = ACTIONS(2935),
    [anon_sym_POUND_LBRACK] = ACTIONS(2935),
    [anon_sym_if] = ACTIONS(2935),
    [anon_sym_DOLLARif] = ACTIONS(2935),
    [anon_sym_is] = ACTIONS(2935),
    [anon_sym_BANGis] = ACTIONS(2935),
    [anon_sym_in] = ACTIONS(2935),
    [anon_sym_BANGin] = ACTIONS(2935),
    [anon_sym_match] = ACTIONS(2935),
    [anon_sym_select] = ACTIONS(2935),
    [anon_sym_STAR_EQ] = ACTIONS(2935),
    [anon_sym_SLASH_EQ] = ACTIONS(2935),
    [anon_sym_PERCENT_EQ] = ACTIONS(2935),
    [anon_sym_LT_LT_EQ] = ACTIONS(2935),
    [anon_sym_GT_GT_EQ] = ACTIONS(2935),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2935),
    [anon_sym_AMP_EQ] = ACTIONS(2935),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2935),
    [anon_sym_PLUS_EQ] = ACTIONS(2935),
    [anon_sym_DASH_EQ] = ACTIONS(2935),
    [anon_sym_PIPE_EQ] = ACTIONS(2935),
    [anon_sym_CARET_EQ] = ACTIONS(2935),
    [anon_sym_COLON_EQ] = ACTIONS(2935),
    [anon_sym_lock] = ACTIONS(2935),
    [anon_sym_rlock] = ACTIONS(2935),
    [anon_sym_unsafe] = ACTIONS(2935),
    [anon_sym_sql] = ACTIONS(2935),
    [sym_int_literal] = ACTIONS(2935),
    [sym_float_literal] = ACTIONS(2935),
    [sym_rune_literal] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(2935),
    [anon_sym_DQUOTE] = ACTIONS(2935),
    [anon_sym_c_SQUOTE] = ACTIONS(2935),
    [anon_sym_c_DQUOTE] = ACTIONS(2935),
    [anon_sym_r_SQUOTE] = ACTIONS(2935),
    [anon_sym_r_DQUOTE] = ACTIONS(2935),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2935),
    [anon_sym_shared] = ACTIONS(2935),
    [anon_sym_map_LBRACK] = ACTIONS(2935),
    [anon_sym_chan] = ACTIONS(2935),
    [anon_sym_thread] = ACTIONS(2935),
    [anon_sym_atomic] = ACTIONS(2935),
    [anon_sym_assert] = ACTIONS(2935),
    [anon_sym_defer] = ACTIONS(2935),
    [anon_sym_goto] = ACTIONS(2935),
    [anon_sym_break] = ACTIONS(2935),
    [anon_sym_continue] = ACTIONS(2935),
    [anon_sym_return] = ACTIONS(2935),
    [anon_sym_DOLLARfor] = ACTIONS(2935),
    [anon_sym_for] = ACTIONS(2935),
    [anon_sym_POUND] = ACTIONS(2935),
    [anon_sym_asm] = ACTIONS(2935),
  },
  [1097] = {
    [sym_line_comment] = STATE(1097),
    [sym_block_comment] = STATE(1097),
    [sym_identifier] = ACTIONS(3080),
    [anon_sym_LF] = ACTIONS(3080),
    [anon_sym_CR] = ACTIONS(3080),
    [anon_sym_CR_LF] = ACTIONS(3080),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_DOT] = ACTIONS(3080),
    [anon_sym_as] = ACTIONS(3080),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_COMMA] = ACTIONS(3080),
    [anon_sym_RBRACE] = ACTIONS(3080),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_EQ] = ACTIONS(3080),
    [anon_sym_fn] = ACTIONS(3080),
    [anon_sym_PLUS] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3080),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_SLASH] = ACTIONS(3080),
    [anon_sym_PERCENT] = ACTIONS(3080),
    [anon_sym_LT] = ACTIONS(3080),
    [anon_sym_GT] = ACTIONS(3080),
    [anon_sym_EQ_EQ] = ACTIONS(3080),
    [anon_sym_BANG_EQ] = ACTIONS(3080),
    [anon_sym_LT_EQ] = ACTIONS(3080),
    [anon_sym_GT_EQ] = ACTIONS(3080),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_struct] = ACTIONS(3080),
    [anon_sym_mut] = ACTIONS(3080),
    [anon_sym_COLON] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_QMARK] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_go] = ACTIONS(3080),
    [anon_sym_spawn] = ACTIONS(3080),
    [anon_sym_json_DOTdecode] = ACTIONS(3080),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_LBRACK2] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_CARET] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3080),
    [anon_sym_LT_DASH] = ACTIONS(3080),
    [anon_sym_LT_LT] = ACTIONS(3080),
    [anon_sym_GT_GT] = ACTIONS(3080),
    [anon_sym_GT_GT_GT] = ACTIONS(3080),
    [anon_sym_AMP_CARET] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_PIPE_PIPE] = ACTIONS(3080),
    [anon_sym_or] = ACTIONS(3080),
    [sym_none] = ACTIONS(3080),
    [sym_true] = ACTIONS(3080),
    [sym_false] = ACTIONS(3080),
    [sym_nil] = ACTIONS(3080),
    [anon_sym_QMARK_DOT] = ACTIONS(3080),
    [anon_sym_POUND_LBRACK] = ACTIONS(3080),
    [anon_sym_if] = ACTIONS(3080),
    [anon_sym_DOLLARif] = ACTIONS(3080),
    [anon_sym_is] = ACTIONS(3080),
    [anon_sym_BANGis] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3080),
    [anon_sym_BANGin] = ACTIONS(3080),
    [anon_sym_match] = ACTIONS(3080),
    [anon_sym_select] = ACTIONS(3080),
    [anon_sym_STAR_EQ] = ACTIONS(3080),
    [anon_sym_SLASH_EQ] = ACTIONS(3080),
    [anon_sym_PERCENT_EQ] = ACTIONS(3080),
    [anon_sym_LT_LT_EQ] = ACTIONS(3080),
    [anon_sym_GT_GT_EQ] = ACTIONS(3080),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3080),
    [anon_sym_AMP_EQ] = ACTIONS(3080),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3080),
    [anon_sym_PLUS_EQ] = ACTIONS(3080),
    [anon_sym_DASH_EQ] = ACTIONS(3080),
    [anon_sym_PIPE_EQ] = ACTIONS(3080),
    [anon_sym_CARET_EQ] = ACTIONS(3080),
    [anon_sym_COLON_EQ] = ACTIONS(3080),
    [anon_sym_lock] = ACTIONS(3080),
    [anon_sym_rlock] = ACTIONS(3080),
    [anon_sym_unsafe] = ACTIONS(3080),
    [anon_sym_sql] = ACTIONS(3080),
    [sym_int_literal] = ACTIONS(3080),
    [sym_float_literal] = ACTIONS(3080),
    [sym_rune_literal] = ACTIONS(3080),
    [anon_sym_SQUOTE] = ACTIONS(3080),
    [anon_sym_DQUOTE] = ACTIONS(3080),
    [anon_sym_c_SQUOTE] = ACTIONS(3080),
    [anon_sym_c_DQUOTE] = ACTIONS(3080),
    [anon_sym_r_SQUOTE] = ACTIONS(3080),
    [anon_sym_r_DQUOTE] = ACTIONS(3080),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3080),
    [anon_sym_shared] = ACTIONS(3080),
    [anon_sym_map_LBRACK] = ACTIONS(3080),
    [anon_sym_chan] = ACTIONS(3080),
    [anon_sym_thread] = ACTIONS(3080),
    [anon_sym_atomic] = ACTIONS(3080),
    [anon_sym_assert] = ACTIONS(3080),
    [anon_sym_defer] = ACTIONS(3080),
    [anon_sym_goto] = ACTIONS(3080),
    [anon_sym_break] = ACTIONS(3080),
    [anon_sym_continue] = ACTIONS(3080),
    [anon_sym_return] = ACTIONS(3080),
    [anon_sym_DOLLARfor] = ACTIONS(3080),
    [anon_sym_for] = ACTIONS(3080),
    [anon_sym_POUND] = ACTIONS(3080),
    [anon_sym_asm] = ACTIONS(3080),
  },
  [1098] = {
    [sym_line_comment] = STATE(1098),
    [sym_block_comment] = STATE(1098),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LF] = ACTIONS(2175),
    [anon_sym_CR] = ACTIONS(2175),
    [anon_sym_CR_LF] = ACTIONS(2175),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_DOT] = ACTIONS(2175),
    [anon_sym_as] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2177),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_EQ] = ACTIONS(2175),
    [anon_sym_fn] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2175),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_PERCENT] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_GT] = ACTIONS(2175),
    [anon_sym_EQ_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ] = ACTIONS(2175),
    [anon_sym_LT_EQ] = ACTIONS(2175),
    [anon_sym_GT_EQ] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2180),
    [anon_sym_struct] = ACTIONS(2175),
    [anon_sym_mut] = ACTIONS(2175),
    [anon_sym_COLON] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [anon_sym_QMARK] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_go] = ACTIONS(2175),
    [anon_sym_spawn] = ACTIONS(2175),
    [anon_sym_json_DOTdecode] = ACTIONS(2175),
    [anon_sym_PIPE] = ACTIONS(2175),
    [anon_sym_LBRACK2] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_CARET] = ACTIONS(2175),
    [anon_sym_AMP] = ACTIONS(2175),
    [anon_sym_LT_DASH] = ACTIONS(2175),
    [anon_sym_LT_LT] = ACTIONS(2175),
    [anon_sym_GT_GT] = ACTIONS(2175),
    [anon_sym_GT_GT_GT] = ACTIONS(2175),
    [anon_sym_AMP_CARET] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(2175),
    [anon_sym_PIPE_PIPE] = ACTIONS(2175),
    [anon_sym_or] = ACTIONS(2175),
    [sym_none] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_nil] = ACTIONS(2175),
    [anon_sym_QMARK_DOT] = ACTIONS(2175),
    [anon_sym_POUND_LBRACK] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_DOLLARif] = ACTIONS(2175),
    [anon_sym_is] = ACTIONS(2175),
    [anon_sym_BANGis] = ACTIONS(2175),
    [anon_sym_in] = ACTIONS(2175),
    [anon_sym_BANGin] = ACTIONS(2175),
    [anon_sym_match] = ACTIONS(2175),
    [anon_sym_select] = ACTIONS(2175),
    [anon_sym_STAR_EQ] = ACTIONS(2175),
    [anon_sym_SLASH_EQ] = ACTIONS(2175),
    [anon_sym_PERCENT_EQ] = ACTIONS(2175),
    [anon_sym_LT_LT_EQ] = ACTIONS(2175),
    [anon_sym_GT_GT_EQ] = ACTIONS(2175),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2175),
    [anon_sym_AMP_EQ] = ACTIONS(2175),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2175),
    [anon_sym_PLUS_EQ] = ACTIONS(2175),
    [anon_sym_DASH_EQ] = ACTIONS(2175),
    [anon_sym_PIPE_EQ] = ACTIONS(2175),
    [anon_sym_CARET_EQ] = ACTIONS(2175),
    [anon_sym_COLON_EQ] = ACTIONS(2175),
    [anon_sym_lock] = ACTIONS(2175),
    [anon_sym_rlock] = ACTIONS(2175),
    [anon_sym_unsafe] = ACTIONS(2175),
    [anon_sym_sql] = ACTIONS(2175),
    [sym_int_literal] = ACTIONS(2175),
    [sym_float_literal] = ACTIONS(2175),
    [sym_rune_literal] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_c_SQUOTE] = ACTIONS(2175),
    [anon_sym_c_DQUOTE] = ACTIONS(2175),
    [anon_sym_r_SQUOTE] = ACTIONS(2175),
    [anon_sym_r_DQUOTE] = ACTIONS(2175),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2175),
    [anon_sym_shared] = ACTIONS(2175),
    [anon_sym_map_LBRACK] = ACTIONS(2175),
    [anon_sym_chan] = ACTIONS(2175),
    [anon_sym_thread] = ACTIONS(2175),
    [anon_sym_atomic] = ACTIONS(2175),
    [anon_sym_assert] = ACTIONS(2175),
    [anon_sym_defer] = ACTIONS(2175),
    [anon_sym_goto] = ACTIONS(2175),
    [anon_sym_break] = ACTIONS(2175),
    [anon_sym_continue] = ACTIONS(2175),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_DOLLARfor] = ACTIONS(2175),
    [anon_sym_for] = ACTIONS(2175),
    [anon_sym_POUND] = ACTIONS(2175),
    [anon_sym_asm] = ACTIONS(2175),
  },
  [1099] = {
    [sym_line_comment] = STATE(1099),
    [sym_block_comment] = STATE(1099),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_LF] = ACTIONS(3296),
    [anon_sym_CR] = ACTIONS(3296),
    [anon_sym_CR_LF] = ACTIONS(3296),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3296),
    [anon_sym_as] = ACTIONS(3296),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3296),
    [anon_sym_RBRACE] = ACTIONS(3296),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3296),
    [anon_sym_fn] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_SLASH] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_LT] = ACTIONS(3296),
    [anon_sym_GT] = ACTIONS(3296),
    [anon_sym_EQ_EQ] = ACTIONS(3296),
    [anon_sym_BANG_EQ] = ACTIONS(3296),
    [anon_sym_LT_EQ] = ACTIONS(3296),
    [anon_sym_GT_EQ] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3294),
    [anon_sym_struct] = ACTIONS(3296),
    [anon_sym_mut] = ACTIONS(3296),
    [anon_sym_COLON] = ACTIONS(3296),
    [anon_sym_PLUS_PLUS] = ACTIONS(3296),
    [anon_sym_DASH_DASH] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3296),
    [anon_sym_BANG] = ACTIONS(3296),
    [anon_sym_go] = ACTIONS(3296),
    [anon_sym_spawn] = ACTIONS(3296),
    [anon_sym_json_DOTdecode] = ACTIONS(3296),
    [anon_sym_PIPE] = ACTIONS(3296),
    [anon_sym_LBRACK2] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3296),
    [anon_sym_CARET] = ACTIONS(3296),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3296),
    [anon_sym_LT_LT] = ACTIONS(3296),
    [anon_sym_GT_GT] = ACTIONS(3296),
    [anon_sym_GT_GT_GT] = ACTIONS(3296),
    [anon_sym_AMP_CARET] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3296),
    [anon_sym_or] = ACTIONS(3296),
    [sym_none] = ACTIONS(3296),
    [sym_true] = ACTIONS(3296),
    [sym_false] = ACTIONS(3296),
    [sym_nil] = ACTIONS(3296),
    [anon_sym_QMARK_DOT] = ACTIONS(3296),
    [anon_sym_POUND_LBRACK] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_DOLLARif] = ACTIONS(3296),
    [anon_sym_is] = ACTIONS(3296),
    [anon_sym_BANGis] = ACTIONS(3296),
    [anon_sym_in] = ACTIONS(3296),
    [anon_sym_BANGin] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_select] = ACTIONS(3296),
    [anon_sym_STAR_EQ] = ACTIONS(3296),
    [anon_sym_SLASH_EQ] = ACTIONS(3296),
    [anon_sym_PERCENT_EQ] = ACTIONS(3296),
    [anon_sym_LT_LT_EQ] = ACTIONS(3296),
    [anon_sym_GT_GT_EQ] = ACTIONS(3296),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3296),
    [anon_sym_AMP_EQ] = ACTIONS(3296),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3296),
    [anon_sym_PLUS_EQ] = ACTIONS(3296),
    [anon_sym_DASH_EQ] = ACTIONS(3296),
    [anon_sym_PIPE_EQ] = ACTIONS(3296),
    [anon_sym_CARET_EQ] = ACTIONS(3296),
    [anon_sym_COLON_EQ] = ACTIONS(3296),
    [anon_sym_lock] = ACTIONS(3296),
    [anon_sym_rlock] = ACTIONS(3296),
    [anon_sym_unsafe] = ACTIONS(3296),
    [anon_sym_sql] = ACTIONS(3296),
    [sym_int_literal] = ACTIONS(3296),
    [sym_float_literal] = ACTIONS(3296),
    [sym_rune_literal] = ACTIONS(3296),
    [anon_sym_SQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_c_SQUOTE] = ACTIONS(3296),
    [anon_sym_c_DQUOTE] = ACTIONS(3296),
    [anon_sym_r_SQUOTE] = ACTIONS(3296),
    [anon_sym_r_DQUOTE] = ACTIONS(3296),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3296),
    [anon_sym_shared] = ACTIONS(3296),
    [anon_sym_map_LBRACK] = ACTIONS(3296),
    [anon_sym_chan] = ACTIONS(3296),
    [anon_sym_thread] = ACTIONS(3296),
    [anon_sym_atomic] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_defer] = ACTIONS(3296),
    [anon_sym_goto] = ACTIONS(3296),
    [anon_sym_break] = ACTIONS(3296),
    [anon_sym_continue] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_DOLLARfor] = ACTIONS(3296),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_POUND] = ACTIONS(3296),
    [anon_sym_asm] = ACTIONS(3296),
  },
  [1100] = {
    [sym_line_comment] = STATE(1100),
    [sym_block_comment] = STATE(1100),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LF] = ACTIONS(3340),
    [anon_sym_CR] = ACTIONS(3340),
    [anon_sym_CR_LF] = ACTIONS(3340),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3340),
    [anon_sym_DOT] = ACTIONS(3340),
    [anon_sym_as] = ACTIONS(3340),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_COMMA] = ACTIONS(3340),
    [anon_sym_RBRACE] = ACTIONS(3340),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_EQ] = ACTIONS(3340),
    [anon_sym_fn] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_STAR] = ACTIONS(3340),
    [anon_sym_SLASH] = ACTIONS(3340),
    [anon_sym_PERCENT] = ACTIONS(3340),
    [anon_sym_LT] = ACTIONS(3340),
    [anon_sym_GT] = ACTIONS(3340),
    [anon_sym_EQ_EQ] = ACTIONS(3340),
    [anon_sym_BANG_EQ] = ACTIONS(3340),
    [anon_sym_LT_EQ] = ACTIONS(3340),
    [anon_sym_GT_EQ] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3338),
    [anon_sym_struct] = ACTIONS(3340),
    [anon_sym_mut] = ACTIONS(3340),
    [anon_sym_COLON] = ACTIONS(3340),
    [anon_sym_PLUS_PLUS] = ACTIONS(3340),
    [anon_sym_DASH_DASH] = ACTIONS(3340),
    [anon_sym_QMARK] = ACTIONS(3340),
    [anon_sym_BANG] = ACTIONS(3340),
    [anon_sym_go] = ACTIONS(3340),
    [anon_sym_spawn] = ACTIONS(3340),
    [anon_sym_json_DOTdecode] = ACTIONS(3340),
    [anon_sym_PIPE] = ACTIONS(3340),
    [anon_sym_LBRACK2] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3340),
    [anon_sym_CARET] = ACTIONS(3340),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LT_DASH] = ACTIONS(3340),
    [anon_sym_LT_LT] = ACTIONS(3340),
    [anon_sym_GT_GT] = ACTIONS(3340),
    [anon_sym_GT_GT_GT] = ACTIONS(3340),
    [anon_sym_AMP_CARET] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3340),
    [anon_sym_PIPE_PIPE] = ACTIONS(3340),
    [anon_sym_or] = ACTIONS(3340),
    [sym_none] = ACTIONS(3340),
    [sym_true] = ACTIONS(3340),
    [sym_false] = ACTIONS(3340),
    [sym_nil] = ACTIONS(3340),
    [anon_sym_QMARK_DOT] = ACTIONS(3340),
    [anon_sym_POUND_LBRACK] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_DOLLARif] = ACTIONS(3340),
    [anon_sym_is] = ACTIONS(3340),
    [anon_sym_BANGis] = ACTIONS(3340),
    [anon_sym_in] = ACTIONS(3340),
    [anon_sym_BANGin] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_select] = ACTIONS(3340),
    [anon_sym_STAR_EQ] = ACTIONS(3340),
    [anon_sym_SLASH_EQ] = ACTIONS(3340),
    [anon_sym_PERCENT_EQ] = ACTIONS(3340),
    [anon_sym_LT_LT_EQ] = ACTIONS(3340),
    [anon_sym_GT_GT_EQ] = ACTIONS(3340),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3340),
    [anon_sym_AMP_EQ] = ACTIONS(3340),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3340),
    [anon_sym_PLUS_EQ] = ACTIONS(3340),
    [anon_sym_DASH_EQ] = ACTIONS(3340),
    [anon_sym_PIPE_EQ] = ACTIONS(3340),
    [anon_sym_CARET_EQ] = ACTIONS(3340),
    [anon_sym_COLON_EQ] = ACTIONS(3340),
    [anon_sym_lock] = ACTIONS(3340),
    [anon_sym_rlock] = ACTIONS(3340),
    [anon_sym_unsafe] = ACTIONS(3340),
    [anon_sym_sql] = ACTIONS(3340),
    [sym_int_literal] = ACTIONS(3340),
    [sym_float_literal] = ACTIONS(3340),
    [sym_rune_literal] = ACTIONS(3340),
    [anon_sym_SQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_c_SQUOTE] = ACTIONS(3340),
    [anon_sym_c_DQUOTE] = ACTIONS(3340),
    [anon_sym_r_SQUOTE] = ACTIONS(3340),
    [anon_sym_r_DQUOTE] = ACTIONS(3340),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3340),
    [anon_sym_shared] = ACTIONS(3340),
    [anon_sym_map_LBRACK] = ACTIONS(3340),
    [anon_sym_chan] = ACTIONS(3340),
    [anon_sym_thread] = ACTIONS(3340),
    [anon_sym_atomic] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_defer] = ACTIONS(3340),
    [anon_sym_goto] = ACTIONS(3340),
    [anon_sym_break] = ACTIONS(3340),
    [anon_sym_continue] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_DOLLARfor] = ACTIONS(3340),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_POUND] = ACTIONS(3340),
    [anon_sym_asm] = ACTIONS(3340),
  },
  [1101] = {
    [sym_line_comment] = STATE(1101),
    [sym_block_comment] = STATE(1101),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_LF] = ACTIONS(3336),
    [anon_sym_CR] = ACTIONS(3336),
    [anon_sym_CR_LF] = ACTIONS(3336),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym_DOT] = ACTIONS(3336),
    [anon_sym_as] = ACTIONS(3336),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_RBRACE] = ACTIONS(3336),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_EQ] = ACTIONS(3336),
    [anon_sym_fn] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_SLASH] = ACTIONS(3336),
    [anon_sym_PERCENT] = ACTIONS(3336),
    [anon_sym_LT] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3336),
    [anon_sym_EQ_EQ] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_LT_EQ] = ACTIONS(3336),
    [anon_sym_GT_EQ] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_mut] = ACTIONS(3336),
    [anon_sym_COLON] = ACTIONS(3336),
    [anon_sym_PLUS_PLUS] = ACTIONS(3336),
    [anon_sym_DASH_DASH] = ACTIONS(3336),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_BANG] = ACTIONS(3336),
    [anon_sym_go] = ACTIONS(3336),
    [anon_sym_spawn] = ACTIONS(3336),
    [anon_sym_json_DOTdecode] = ACTIONS(3336),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3336),
    [anon_sym_CARET] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LT_DASH] = ACTIONS(3336),
    [anon_sym_LT_LT] = ACTIONS(3336),
    [anon_sym_GT_GT] = ACTIONS(3336),
    [anon_sym_GT_GT_GT] = ACTIONS(3336),
    [anon_sym_AMP_CARET] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_or] = ACTIONS(3336),
    [sym_none] = ACTIONS(3336),
    [sym_true] = ACTIONS(3336),
    [sym_false] = ACTIONS(3336),
    [sym_nil] = ACTIONS(3336),
    [anon_sym_QMARK_DOT] = ACTIONS(3336),
    [anon_sym_POUND_LBRACK] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_DOLLARif] = ACTIONS(3336),
    [anon_sym_is] = ACTIONS(3336),
    [anon_sym_BANGis] = ACTIONS(3336),
    [anon_sym_in] = ACTIONS(3336),
    [anon_sym_BANGin] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_select] = ACTIONS(3336),
    [anon_sym_STAR_EQ] = ACTIONS(3336),
    [anon_sym_SLASH_EQ] = ACTIONS(3336),
    [anon_sym_PERCENT_EQ] = ACTIONS(3336),
    [anon_sym_LT_LT_EQ] = ACTIONS(3336),
    [anon_sym_GT_GT_EQ] = ACTIONS(3336),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3336),
    [anon_sym_AMP_EQ] = ACTIONS(3336),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3336),
    [anon_sym_PLUS_EQ] = ACTIONS(3336),
    [anon_sym_DASH_EQ] = ACTIONS(3336),
    [anon_sym_PIPE_EQ] = ACTIONS(3336),
    [anon_sym_CARET_EQ] = ACTIONS(3336),
    [anon_sym_COLON_EQ] = ACTIONS(3336),
    [anon_sym_lock] = ACTIONS(3336),
    [anon_sym_rlock] = ACTIONS(3336),
    [anon_sym_unsafe] = ACTIONS(3336),
    [anon_sym_sql] = ACTIONS(3336),
    [sym_int_literal] = ACTIONS(3336),
    [sym_float_literal] = ACTIONS(3336),
    [sym_rune_literal] = ACTIONS(3336),
    [anon_sym_SQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_c_SQUOTE] = ACTIONS(3336),
    [anon_sym_c_DQUOTE] = ACTIONS(3336),
    [anon_sym_r_SQUOTE] = ACTIONS(3336),
    [anon_sym_r_DQUOTE] = ACTIONS(3336),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3336),
    [anon_sym_shared] = ACTIONS(3336),
    [anon_sym_map_LBRACK] = ACTIONS(3336),
    [anon_sym_chan] = ACTIONS(3336),
    [anon_sym_thread] = ACTIONS(3336),
    [anon_sym_atomic] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_defer] = ACTIONS(3336),
    [anon_sym_goto] = ACTIONS(3336),
    [anon_sym_break] = ACTIONS(3336),
    [anon_sym_continue] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_DOLLARfor] = ACTIONS(3336),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_POUND] = ACTIONS(3336),
    [anon_sym_asm] = ACTIONS(3336),
  },
  [1102] = {
    [sym_line_comment] = STATE(1102),
    [sym_block_comment] = STATE(1102),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_LF] = ACTIONS(3292),
    [anon_sym_CR] = ACTIONS(3292),
    [anon_sym_CR_LF] = ACTIONS(3292),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(3292),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_COMMA] = ACTIONS(3292),
    [anon_sym_RBRACE] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_EQ] = ACTIONS(3292),
    [anon_sym_fn] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_LT] = ACTIONS(3292),
    [anon_sym_GT] = ACTIONS(3292),
    [anon_sym_EQ_EQ] = ACTIONS(3292),
    [anon_sym_BANG_EQ] = ACTIONS(3292),
    [anon_sym_LT_EQ] = ACTIONS(3292),
    [anon_sym_GT_EQ] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3290),
    [anon_sym_struct] = ACTIONS(3292),
    [anon_sym_mut] = ACTIONS(3292),
    [anon_sym_COLON] = ACTIONS(3292),
    [anon_sym_PLUS_PLUS] = ACTIONS(3292),
    [anon_sym_DASH_DASH] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3292),
    [anon_sym_BANG] = ACTIONS(3292),
    [anon_sym_go] = ACTIONS(3292),
    [anon_sym_spawn] = ACTIONS(3292),
    [anon_sym_json_DOTdecode] = ACTIONS(3292),
    [anon_sym_PIPE] = ACTIONS(3292),
    [anon_sym_LBRACK2] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3292),
    [anon_sym_CARET] = ACTIONS(3292),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LT_DASH] = ACTIONS(3292),
    [anon_sym_LT_LT] = ACTIONS(3292),
    [anon_sym_GT_GT] = ACTIONS(3292),
    [anon_sym_GT_GT_GT] = ACTIONS(3292),
    [anon_sym_AMP_CARET] = ACTIONS(3292),
    [anon_sym_AMP_AMP] = ACTIONS(3292),
    [anon_sym_PIPE_PIPE] = ACTIONS(3292),
    [anon_sym_or] = ACTIONS(3292),
    [sym_none] = ACTIONS(3292),
    [sym_true] = ACTIONS(3292),
    [sym_false] = ACTIONS(3292),
    [sym_nil] = ACTIONS(3292),
    [anon_sym_QMARK_DOT] = ACTIONS(3292),
    [anon_sym_POUND_LBRACK] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_DOLLARif] = ACTIONS(3292),
    [anon_sym_is] = ACTIONS(3292),
    [anon_sym_BANGis] = ACTIONS(3292),
    [anon_sym_in] = ACTIONS(3292),
    [anon_sym_BANGin] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_select] = ACTIONS(3292),
    [anon_sym_STAR_EQ] = ACTIONS(3292),
    [anon_sym_SLASH_EQ] = ACTIONS(3292),
    [anon_sym_PERCENT_EQ] = ACTIONS(3292),
    [anon_sym_LT_LT_EQ] = ACTIONS(3292),
    [anon_sym_GT_GT_EQ] = ACTIONS(3292),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3292),
    [anon_sym_AMP_EQ] = ACTIONS(3292),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3292),
    [anon_sym_PLUS_EQ] = ACTIONS(3292),
    [anon_sym_DASH_EQ] = ACTIONS(3292),
    [anon_sym_PIPE_EQ] = ACTIONS(3292),
    [anon_sym_CARET_EQ] = ACTIONS(3292),
    [anon_sym_COLON_EQ] = ACTIONS(3292),
    [anon_sym_lock] = ACTIONS(3292),
    [anon_sym_rlock] = ACTIONS(3292),
    [anon_sym_unsafe] = ACTIONS(3292),
    [anon_sym_sql] = ACTIONS(3292),
    [sym_int_literal] = ACTIONS(3292),
    [sym_float_literal] = ACTIONS(3292),
    [sym_rune_literal] = ACTIONS(3292),
    [anon_sym_SQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_c_SQUOTE] = ACTIONS(3292),
    [anon_sym_c_DQUOTE] = ACTIONS(3292),
    [anon_sym_r_SQUOTE] = ACTIONS(3292),
    [anon_sym_r_DQUOTE] = ACTIONS(3292),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3292),
    [anon_sym_shared] = ACTIONS(3292),
    [anon_sym_map_LBRACK] = ACTIONS(3292),
    [anon_sym_chan] = ACTIONS(3292),
    [anon_sym_thread] = ACTIONS(3292),
    [anon_sym_atomic] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_defer] = ACTIONS(3292),
    [anon_sym_goto] = ACTIONS(3292),
    [anon_sym_break] = ACTIONS(3292),
    [anon_sym_continue] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_DOLLARfor] = ACTIONS(3292),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_POUND] = ACTIONS(3292),
    [anon_sym_asm] = ACTIONS(3292),
  },
  [1103] = {
    [sym_line_comment] = STATE(1103),
    [sym_block_comment] = STATE(1103),
    [sym_identifier] = ACTIONS(3332),
    [anon_sym_LF] = ACTIONS(3332),
    [anon_sym_CR] = ACTIONS(3332),
    [anon_sym_CR_LF] = ACTIONS(3332),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3332),
    [anon_sym_DOT] = ACTIONS(3332),
    [anon_sym_as] = ACTIONS(3332),
    [anon_sym_LBRACE] = ACTIONS(3332),
    [anon_sym_COMMA] = ACTIONS(3332),
    [anon_sym_RBRACE] = ACTIONS(3332),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_EQ] = ACTIONS(3332),
    [anon_sym_fn] = ACTIONS(3332),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_DASH] = ACTIONS(3332),
    [anon_sym_STAR] = ACTIONS(3332),
    [anon_sym_SLASH] = ACTIONS(3332),
    [anon_sym_PERCENT] = ACTIONS(3332),
    [anon_sym_LT] = ACTIONS(3332),
    [anon_sym_GT] = ACTIONS(3332),
    [anon_sym_EQ_EQ] = ACTIONS(3332),
    [anon_sym_BANG_EQ] = ACTIONS(3332),
    [anon_sym_LT_EQ] = ACTIONS(3332),
    [anon_sym_GT_EQ] = ACTIONS(3332),
    [anon_sym_LBRACK] = ACTIONS(3330),
    [anon_sym_struct] = ACTIONS(3332),
    [anon_sym_mut] = ACTIONS(3332),
    [anon_sym_COLON] = ACTIONS(3332),
    [anon_sym_PLUS_PLUS] = ACTIONS(3332),
    [anon_sym_DASH_DASH] = ACTIONS(3332),
    [anon_sym_QMARK] = ACTIONS(3332),
    [anon_sym_BANG] = ACTIONS(3332),
    [anon_sym_go] = ACTIONS(3332),
    [anon_sym_spawn] = ACTIONS(3332),
    [anon_sym_json_DOTdecode] = ACTIONS(3332),
    [anon_sym_PIPE] = ACTIONS(3332),
    [anon_sym_LBRACK2] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3332),
    [anon_sym_CARET] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3332),
    [anon_sym_LT_DASH] = ACTIONS(3332),
    [anon_sym_LT_LT] = ACTIONS(3332),
    [anon_sym_GT_GT] = ACTIONS(3332),
    [anon_sym_GT_GT_GT] = ACTIONS(3332),
    [anon_sym_AMP_CARET] = ACTIONS(3332),
    [anon_sym_AMP_AMP] = ACTIONS(3332),
    [anon_sym_PIPE_PIPE] = ACTIONS(3332),
    [anon_sym_or] = ACTIONS(3332),
    [sym_none] = ACTIONS(3332),
    [sym_true] = ACTIONS(3332),
    [sym_false] = ACTIONS(3332),
    [sym_nil] = ACTIONS(3332),
    [anon_sym_QMARK_DOT] = ACTIONS(3332),
    [anon_sym_POUND_LBRACK] = ACTIONS(3332),
    [anon_sym_if] = ACTIONS(3332),
    [anon_sym_DOLLARif] = ACTIONS(3332),
    [anon_sym_is] = ACTIONS(3332),
    [anon_sym_BANGis] = ACTIONS(3332),
    [anon_sym_in] = ACTIONS(3332),
    [anon_sym_BANGin] = ACTIONS(3332),
    [anon_sym_match] = ACTIONS(3332),
    [anon_sym_select] = ACTIONS(3332),
    [anon_sym_STAR_EQ] = ACTIONS(3332),
    [anon_sym_SLASH_EQ] = ACTIONS(3332),
    [anon_sym_PERCENT_EQ] = ACTIONS(3332),
    [anon_sym_LT_LT_EQ] = ACTIONS(3332),
    [anon_sym_GT_GT_EQ] = ACTIONS(3332),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3332),
    [anon_sym_AMP_EQ] = ACTIONS(3332),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3332),
    [anon_sym_PLUS_EQ] = ACTIONS(3332),
    [anon_sym_DASH_EQ] = ACTIONS(3332),
    [anon_sym_PIPE_EQ] = ACTIONS(3332),
    [anon_sym_CARET_EQ] = ACTIONS(3332),
    [anon_sym_COLON_EQ] = ACTIONS(3332),
    [anon_sym_lock] = ACTIONS(3332),
    [anon_sym_rlock] = ACTIONS(3332),
    [anon_sym_unsafe] = ACTIONS(3332),
    [anon_sym_sql] = ACTIONS(3332),
    [sym_int_literal] = ACTIONS(3332),
    [sym_float_literal] = ACTIONS(3332),
    [sym_rune_literal] = ACTIONS(3332),
    [anon_sym_SQUOTE] = ACTIONS(3332),
    [anon_sym_DQUOTE] = ACTIONS(3332),
    [anon_sym_c_SQUOTE] = ACTIONS(3332),
    [anon_sym_c_DQUOTE] = ACTIONS(3332),
    [anon_sym_r_SQUOTE] = ACTIONS(3332),
    [anon_sym_r_DQUOTE] = ACTIONS(3332),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3332),
    [anon_sym_shared] = ACTIONS(3332),
    [anon_sym_map_LBRACK] = ACTIONS(3332),
    [anon_sym_chan] = ACTIONS(3332),
    [anon_sym_thread] = ACTIONS(3332),
    [anon_sym_atomic] = ACTIONS(3332),
    [anon_sym_assert] = ACTIONS(3332),
    [anon_sym_defer] = ACTIONS(3332),
    [anon_sym_goto] = ACTIONS(3332),
    [anon_sym_break] = ACTIONS(3332),
    [anon_sym_continue] = ACTIONS(3332),
    [anon_sym_return] = ACTIONS(3332),
    [anon_sym_DOLLARfor] = ACTIONS(3332),
    [anon_sym_for] = ACTIONS(3332),
    [anon_sym_POUND] = ACTIONS(3332),
    [anon_sym_asm] = ACTIONS(3332),
  },
  [1104] = {
    [sym_line_comment] = STATE(1104),
    [sym_block_comment] = STATE(1104),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_LF] = ACTIONS(3274),
    [anon_sym_CR] = ACTIONS(3274),
    [anon_sym_CR_LF] = ACTIONS(3274),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_as] = ACTIONS(3274),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3274),
    [anon_sym_RBRACE] = ACTIONS(3274),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3274),
    [anon_sym_fn] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_SLASH] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_LT] = ACTIONS(3274),
    [anon_sym_GT] = ACTIONS(3274),
    [anon_sym_EQ_EQ] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_LT_EQ] = ACTIONS(3274),
    [anon_sym_GT_EQ] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3272),
    [anon_sym_struct] = ACTIONS(3274),
    [anon_sym_mut] = ACTIONS(3274),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_PLUS_PLUS] = ACTIONS(3274),
    [anon_sym_DASH_DASH] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_BANG] = ACTIONS(3274),
    [anon_sym_go] = ACTIONS(3274),
    [anon_sym_spawn] = ACTIONS(3274),
    [anon_sym_json_DOTdecode] = ACTIONS(3274),
    [anon_sym_PIPE] = ACTIONS(3274),
    [anon_sym_LBRACK2] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3274),
    [anon_sym_CARET] = ACTIONS(3274),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_LT_LT] = ACTIONS(3274),
    [anon_sym_GT_GT] = ACTIONS(3274),
    [anon_sym_GT_GT_GT] = ACTIONS(3274),
    [anon_sym_AMP_CARET] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_or] = ACTIONS(3274),
    [sym_none] = ACTIONS(3274),
    [sym_true] = ACTIONS(3274),
    [sym_false] = ACTIONS(3274),
    [sym_nil] = ACTIONS(3274),
    [anon_sym_QMARK_DOT] = ACTIONS(3274),
    [anon_sym_POUND_LBRACK] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_DOLLARif] = ACTIONS(3274),
    [anon_sym_is] = ACTIONS(3274),
    [anon_sym_BANGis] = ACTIONS(3274),
    [anon_sym_in] = ACTIONS(3274),
    [anon_sym_BANGin] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_select] = ACTIONS(3274),
    [anon_sym_STAR_EQ] = ACTIONS(3274),
    [anon_sym_SLASH_EQ] = ACTIONS(3274),
    [anon_sym_PERCENT_EQ] = ACTIONS(3274),
    [anon_sym_LT_LT_EQ] = ACTIONS(3274),
    [anon_sym_GT_GT_EQ] = ACTIONS(3274),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3274),
    [anon_sym_AMP_EQ] = ACTIONS(3274),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3274),
    [anon_sym_PLUS_EQ] = ACTIONS(3274),
    [anon_sym_DASH_EQ] = ACTIONS(3274),
    [anon_sym_PIPE_EQ] = ACTIONS(3274),
    [anon_sym_CARET_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3274),
    [anon_sym_lock] = ACTIONS(3274),
    [anon_sym_rlock] = ACTIONS(3274),
    [anon_sym_unsafe] = ACTIONS(3274),
    [anon_sym_sql] = ACTIONS(3274),
    [sym_int_literal] = ACTIONS(3274),
    [sym_float_literal] = ACTIONS(3274),
    [sym_rune_literal] = ACTIONS(3274),
    [anon_sym_SQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_c_SQUOTE] = ACTIONS(3274),
    [anon_sym_c_DQUOTE] = ACTIONS(3274),
    [anon_sym_r_SQUOTE] = ACTIONS(3274),
    [anon_sym_r_DQUOTE] = ACTIONS(3274),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3274),
    [anon_sym_shared] = ACTIONS(3274),
    [anon_sym_map_LBRACK] = ACTIONS(3274),
    [anon_sym_chan] = ACTIONS(3274),
    [anon_sym_thread] = ACTIONS(3274),
    [anon_sym_atomic] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_defer] = ACTIONS(3274),
    [anon_sym_goto] = ACTIONS(3274),
    [anon_sym_break] = ACTIONS(3274),
    [anon_sym_continue] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_DOLLARfor] = ACTIONS(3274),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_POUND] = ACTIONS(3274),
    [anon_sym_asm] = ACTIONS(3274),
  },
  [1105] = {
    [sym_line_comment] = STATE(1105),
    [sym_block_comment] = STATE(1105),
    [sym_identifier] = ACTIONS(3256),
    [anon_sym_LF] = ACTIONS(3256),
    [anon_sym_CR] = ACTIONS(3256),
    [anon_sym_CR_LF] = ACTIONS(3256),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3256),
    [anon_sym_DOT] = ACTIONS(3256),
    [anon_sym_as] = ACTIONS(3256),
    [anon_sym_LBRACE] = ACTIONS(3256),
    [anon_sym_COMMA] = ACTIONS(3256),
    [anon_sym_RBRACE] = ACTIONS(3256),
    [anon_sym_LPAREN] = ACTIONS(3256),
    [anon_sym_EQ] = ACTIONS(3256),
    [anon_sym_fn] = ACTIONS(3256),
    [anon_sym_PLUS] = ACTIONS(3256),
    [anon_sym_DASH] = ACTIONS(3256),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_SLASH] = ACTIONS(3256),
    [anon_sym_PERCENT] = ACTIONS(3256),
    [anon_sym_LT] = ACTIONS(3256),
    [anon_sym_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(3256),
    [anon_sym_BANG_EQ] = ACTIONS(3256),
    [anon_sym_LT_EQ] = ACTIONS(3256),
    [anon_sym_GT_EQ] = ACTIONS(3256),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [anon_sym_struct] = ACTIONS(3256),
    [anon_sym_mut] = ACTIONS(3256),
    [anon_sym_COLON] = ACTIONS(3256),
    [anon_sym_PLUS_PLUS] = ACTIONS(3256),
    [anon_sym_DASH_DASH] = ACTIONS(3256),
    [anon_sym_QMARK] = ACTIONS(3256),
    [anon_sym_BANG] = ACTIONS(3256),
    [anon_sym_go] = ACTIONS(3256),
    [anon_sym_spawn] = ACTIONS(3256),
    [anon_sym_json_DOTdecode] = ACTIONS(3256),
    [anon_sym_PIPE] = ACTIONS(3256),
    [anon_sym_LBRACK2] = ACTIONS(3256),
    [anon_sym_TILDE] = ACTIONS(3256),
    [anon_sym_CARET] = ACTIONS(3256),
    [anon_sym_AMP] = ACTIONS(3256),
    [anon_sym_LT_DASH] = ACTIONS(3256),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_GT_GT_GT] = ACTIONS(3256),
    [anon_sym_AMP_CARET] = ACTIONS(3256),
    [anon_sym_AMP_AMP] = ACTIONS(3256),
    [anon_sym_PIPE_PIPE] = ACTIONS(3256),
    [anon_sym_or] = ACTIONS(3256),
    [sym_none] = ACTIONS(3256),
    [sym_true] = ACTIONS(3256),
    [sym_false] = ACTIONS(3256),
    [sym_nil] = ACTIONS(3256),
    [anon_sym_QMARK_DOT] = ACTIONS(3256),
    [anon_sym_POUND_LBRACK] = ACTIONS(3256),
    [anon_sym_if] = ACTIONS(3256),
    [anon_sym_DOLLARif] = ACTIONS(3256),
    [anon_sym_is] = ACTIONS(3256),
    [anon_sym_BANGis] = ACTIONS(3256),
    [anon_sym_in] = ACTIONS(3256),
    [anon_sym_BANGin] = ACTIONS(3256),
    [anon_sym_match] = ACTIONS(3256),
    [anon_sym_select] = ACTIONS(3256),
    [anon_sym_STAR_EQ] = ACTIONS(3256),
    [anon_sym_SLASH_EQ] = ACTIONS(3256),
    [anon_sym_PERCENT_EQ] = ACTIONS(3256),
    [anon_sym_LT_LT_EQ] = ACTIONS(3256),
    [anon_sym_GT_GT_EQ] = ACTIONS(3256),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3256),
    [anon_sym_AMP_EQ] = ACTIONS(3256),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3256),
    [anon_sym_PLUS_EQ] = ACTIONS(3256),
    [anon_sym_DASH_EQ] = ACTIONS(3256),
    [anon_sym_PIPE_EQ] = ACTIONS(3256),
    [anon_sym_CARET_EQ] = ACTIONS(3256),
    [anon_sym_COLON_EQ] = ACTIONS(3256),
    [anon_sym_lock] = ACTIONS(3256),
    [anon_sym_rlock] = ACTIONS(3256),
    [anon_sym_unsafe] = ACTIONS(3256),
    [anon_sym_sql] = ACTIONS(3256),
    [sym_int_literal] = ACTIONS(3256),
    [sym_float_literal] = ACTIONS(3256),
    [sym_rune_literal] = ACTIONS(3256),
    [anon_sym_SQUOTE] = ACTIONS(3256),
    [anon_sym_DQUOTE] = ACTIONS(3256),
    [anon_sym_c_SQUOTE] = ACTIONS(3256),
    [anon_sym_c_DQUOTE] = ACTIONS(3256),
    [anon_sym_r_SQUOTE] = ACTIONS(3256),
    [anon_sym_r_DQUOTE] = ACTIONS(3256),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3256),
    [anon_sym_shared] = ACTIONS(3256),
    [anon_sym_map_LBRACK] = ACTIONS(3256),
    [anon_sym_chan] = ACTIONS(3256),
    [anon_sym_thread] = ACTIONS(3256),
    [anon_sym_atomic] = ACTIONS(3256),
    [anon_sym_assert] = ACTIONS(3256),
    [anon_sym_defer] = ACTIONS(3256),
    [anon_sym_goto] = ACTIONS(3256),
    [anon_sym_break] = ACTIONS(3256),
    [anon_sym_continue] = ACTIONS(3256),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_DOLLARfor] = ACTIONS(3256),
    [anon_sym_for] = ACTIONS(3256),
    [anon_sym_POUND] = ACTIONS(3256),
    [anon_sym_asm] = ACTIONS(3256),
  },
  [1106] = {
    [sym_line_comment] = STATE(1106),
    [sym_block_comment] = STATE(1106),
    [sym_identifier] = ACTIONS(3250),
    [anon_sym_LF] = ACTIONS(3250),
    [anon_sym_CR] = ACTIONS(3250),
    [anon_sym_CR_LF] = ACTIONS(3250),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3250),
    [anon_sym_DOT] = ACTIONS(3250),
    [anon_sym_as] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3250),
    [anon_sym_COMMA] = ACTIONS(3250),
    [anon_sym_RBRACE] = ACTIONS(3250),
    [anon_sym_LPAREN] = ACTIONS(3250),
    [anon_sym_EQ] = ACTIONS(3250),
    [anon_sym_fn] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_STAR] = ACTIONS(3250),
    [anon_sym_SLASH] = ACTIONS(3250),
    [anon_sym_PERCENT] = ACTIONS(3250),
    [anon_sym_LT] = ACTIONS(3250),
    [anon_sym_GT] = ACTIONS(3250),
    [anon_sym_EQ_EQ] = ACTIONS(3250),
    [anon_sym_BANG_EQ] = ACTIONS(3250),
    [anon_sym_LT_EQ] = ACTIONS(3250),
    [anon_sym_GT_EQ] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3248),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_mut] = ACTIONS(3250),
    [anon_sym_COLON] = ACTIONS(3250),
    [anon_sym_PLUS_PLUS] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3250),
    [anon_sym_QMARK] = ACTIONS(3250),
    [anon_sym_BANG] = ACTIONS(3250),
    [anon_sym_go] = ACTIONS(3250),
    [anon_sym_spawn] = ACTIONS(3250),
    [anon_sym_json_DOTdecode] = ACTIONS(3250),
    [anon_sym_PIPE] = ACTIONS(3250),
    [anon_sym_LBRACK2] = ACTIONS(3250),
    [anon_sym_TILDE] = ACTIONS(3250),
    [anon_sym_CARET] = ACTIONS(3250),
    [anon_sym_AMP] = ACTIONS(3250),
    [anon_sym_LT_DASH] = ACTIONS(3250),
    [anon_sym_LT_LT] = ACTIONS(3250),
    [anon_sym_GT_GT] = ACTIONS(3250),
    [anon_sym_GT_GT_GT] = ACTIONS(3250),
    [anon_sym_AMP_CARET] = ACTIONS(3250),
    [anon_sym_AMP_AMP] = ACTIONS(3250),
    [anon_sym_PIPE_PIPE] = ACTIONS(3250),
    [anon_sym_or] = ACTIONS(3250),
    [sym_none] = ACTIONS(3250),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [sym_nil] = ACTIONS(3250),
    [anon_sym_QMARK_DOT] = ACTIONS(3250),
    [anon_sym_POUND_LBRACK] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_DOLLARif] = ACTIONS(3250),
    [anon_sym_is] = ACTIONS(3250),
    [anon_sym_BANGis] = ACTIONS(3250),
    [anon_sym_in] = ACTIONS(3250),
    [anon_sym_BANGin] = ACTIONS(3250),
    [anon_sym_match] = ACTIONS(3250),
    [anon_sym_select] = ACTIONS(3250),
    [anon_sym_STAR_EQ] = ACTIONS(3250),
    [anon_sym_SLASH_EQ] = ACTIONS(3250),
    [anon_sym_PERCENT_EQ] = ACTIONS(3250),
    [anon_sym_LT_LT_EQ] = ACTIONS(3250),
    [anon_sym_GT_GT_EQ] = ACTIONS(3250),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3250),
    [anon_sym_AMP_EQ] = ACTIONS(3250),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3250),
    [anon_sym_PLUS_EQ] = ACTIONS(3250),
    [anon_sym_DASH_EQ] = ACTIONS(3250),
    [anon_sym_PIPE_EQ] = ACTIONS(3250),
    [anon_sym_CARET_EQ] = ACTIONS(3250),
    [anon_sym_COLON_EQ] = ACTIONS(3250),
    [anon_sym_lock] = ACTIONS(3250),
    [anon_sym_rlock] = ACTIONS(3250),
    [anon_sym_unsafe] = ACTIONS(3250),
    [anon_sym_sql] = ACTIONS(3250),
    [sym_int_literal] = ACTIONS(3250),
    [sym_float_literal] = ACTIONS(3250),
    [sym_rune_literal] = ACTIONS(3250),
    [anon_sym_SQUOTE] = ACTIONS(3250),
    [anon_sym_DQUOTE] = ACTIONS(3250),
    [anon_sym_c_SQUOTE] = ACTIONS(3250),
    [anon_sym_c_DQUOTE] = ACTIONS(3250),
    [anon_sym_r_SQUOTE] = ACTIONS(3250),
    [anon_sym_r_DQUOTE] = ACTIONS(3250),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3250),
    [anon_sym_shared] = ACTIONS(3250),
    [anon_sym_map_LBRACK] = ACTIONS(3250),
    [anon_sym_chan] = ACTIONS(3250),
    [anon_sym_thread] = ACTIONS(3250),
    [anon_sym_atomic] = ACTIONS(3250),
    [anon_sym_assert] = ACTIONS(3250),
    [anon_sym_defer] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_DOLLARfor] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_POUND] = ACTIONS(3250),
    [anon_sym_asm] = ACTIONS(3250),
  },
  [1107] = {
    [sym_line_comment] = STATE(1107),
    [sym_block_comment] = STATE(1107),
    [sym_identifier] = ACTIONS(3270),
    [anon_sym_LF] = ACTIONS(3270),
    [anon_sym_CR] = ACTIONS(3270),
    [anon_sym_CR_LF] = ACTIONS(3270),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3270),
    [anon_sym_DOT] = ACTIONS(3270),
    [anon_sym_as] = ACTIONS(3270),
    [anon_sym_LBRACE] = ACTIONS(3270),
    [anon_sym_COMMA] = ACTIONS(3270),
    [anon_sym_RBRACE] = ACTIONS(3270),
    [anon_sym_LPAREN] = ACTIONS(3270),
    [anon_sym_EQ] = ACTIONS(3270),
    [anon_sym_fn] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3270),
    [anon_sym_DASH] = ACTIONS(3270),
    [anon_sym_STAR] = ACTIONS(3270),
    [anon_sym_SLASH] = ACTIONS(3270),
    [anon_sym_PERCENT] = ACTIONS(3270),
    [anon_sym_LT] = ACTIONS(3270),
    [anon_sym_GT] = ACTIONS(3270),
    [anon_sym_EQ_EQ] = ACTIONS(3270),
    [anon_sym_BANG_EQ] = ACTIONS(3270),
    [anon_sym_LT_EQ] = ACTIONS(3270),
    [anon_sym_GT_EQ] = ACTIONS(3270),
    [anon_sym_LBRACK] = ACTIONS(3268),
    [anon_sym_struct] = ACTIONS(3270),
    [anon_sym_mut] = ACTIONS(3270),
    [anon_sym_COLON] = ACTIONS(3270),
    [anon_sym_PLUS_PLUS] = ACTIONS(3270),
    [anon_sym_DASH_DASH] = ACTIONS(3270),
    [anon_sym_QMARK] = ACTIONS(3270),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_go] = ACTIONS(3270),
    [anon_sym_spawn] = ACTIONS(3270),
    [anon_sym_json_DOTdecode] = ACTIONS(3270),
    [anon_sym_PIPE] = ACTIONS(3270),
    [anon_sym_LBRACK2] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3270),
    [anon_sym_CARET] = ACTIONS(3270),
    [anon_sym_AMP] = ACTIONS(3270),
    [anon_sym_LT_DASH] = ACTIONS(3270),
    [anon_sym_LT_LT] = ACTIONS(3270),
    [anon_sym_GT_GT] = ACTIONS(3270),
    [anon_sym_GT_GT_GT] = ACTIONS(3270),
    [anon_sym_AMP_CARET] = ACTIONS(3270),
    [anon_sym_AMP_AMP] = ACTIONS(3270),
    [anon_sym_PIPE_PIPE] = ACTIONS(3270),
    [anon_sym_or] = ACTIONS(3270),
    [sym_none] = ACTIONS(3270),
    [sym_true] = ACTIONS(3270),
    [sym_false] = ACTIONS(3270),
    [sym_nil] = ACTIONS(3270),
    [anon_sym_QMARK_DOT] = ACTIONS(3270),
    [anon_sym_POUND_LBRACK] = ACTIONS(3270),
    [anon_sym_if] = ACTIONS(3270),
    [anon_sym_DOLLARif] = ACTIONS(3270),
    [anon_sym_is] = ACTIONS(3270),
    [anon_sym_BANGis] = ACTIONS(3270),
    [anon_sym_in] = ACTIONS(3270),
    [anon_sym_BANGin] = ACTIONS(3270),
    [anon_sym_match] = ACTIONS(3270),
    [anon_sym_select] = ACTIONS(3270),
    [anon_sym_STAR_EQ] = ACTIONS(3270),
    [anon_sym_SLASH_EQ] = ACTIONS(3270),
    [anon_sym_PERCENT_EQ] = ACTIONS(3270),
    [anon_sym_LT_LT_EQ] = ACTIONS(3270),
    [anon_sym_GT_GT_EQ] = ACTIONS(3270),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3270),
    [anon_sym_AMP_EQ] = ACTIONS(3270),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3270),
    [anon_sym_PLUS_EQ] = ACTIONS(3270),
    [anon_sym_DASH_EQ] = ACTIONS(3270),
    [anon_sym_PIPE_EQ] = ACTIONS(3270),
    [anon_sym_CARET_EQ] = ACTIONS(3270),
    [anon_sym_COLON_EQ] = ACTIONS(3270),
    [anon_sym_lock] = ACTIONS(3270),
    [anon_sym_rlock] = ACTIONS(3270),
    [anon_sym_unsafe] = ACTIONS(3270),
    [anon_sym_sql] = ACTIONS(3270),
    [sym_int_literal] = ACTIONS(3270),
    [sym_float_literal] = ACTIONS(3270),
    [sym_rune_literal] = ACTIONS(3270),
    [anon_sym_SQUOTE] = ACTIONS(3270),
    [anon_sym_DQUOTE] = ACTIONS(3270),
    [anon_sym_c_SQUOTE] = ACTIONS(3270),
    [anon_sym_c_DQUOTE] = ACTIONS(3270),
    [anon_sym_r_SQUOTE] = ACTIONS(3270),
    [anon_sym_r_DQUOTE] = ACTIONS(3270),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3270),
    [anon_sym_shared] = ACTIONS(3270),
    [anon_sym_map_LBRACK] = ACTIONS(3270),
    [anon_sym_chan] = ACTIONS(3270),
    [anon_sym_thread] = ACTIONS(3270),
    [anon_sym_atomic] = ACTIONS(3270),
    [anon_sym_assert] = ACTIONS(3270),
    [anon_sym_defer] = ACTIONS(3270),
    [anon_sym_goto] = ACTIONS(3270),
    [anon_sym_break] = ACTIONS(3270),
    [anon_sym_continue] = ACTIONS(3270),
    [anon_sym_return] = ACTIONS(3270),
    [anon_sym_DOLLARfor] = ACTIONS(3270),
    [anon_sym_for] = ACTIONS(3270),
    [anon_sym_POUND] = ACTIONS(3270),
    [anon_sym_asm] = ACTIONS(3270),
  },
  [1108] = {
    [sym_line_comment] = STATE(1108),
    [sym_block_comment] = STATE(1108),
    [sym_identifier] = ACTIONS(3266),
    [anon_sym_LF] = ACTIONS(3266),
    [anon_sym_CR] = ACTIONS(3266),
    [anon_sym_CR_LF] = ACTIONS(3266),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3266),
    [anon_sym_DOT] = ACTIONS(3266),
    [anon_sym_as] = ACTIONS(3266),
    [anon_sym_LBRACE] = ACTIONS(3266),
    [anon_sym_COMMA] = ACTIONS(3266),
    [anon_sym_RBRACE] = ACTIONS(3266),
    [anon_sym_LPAREN] = ACTIONS(3266),
    [anon_sym_EQ] = ACTIONS(3266),
    [anon_sym_fn] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3266),
    [anon_sym_DASH] = ACTIONS(3266),
    [anon_sym_STAR] = ACTIONS(3266),
    [anon_sym_SLASH] = ACTIONS(3266),
    [anon_sym_PERCENT] = ACTIONS(3266),
    [anon_sym_LT] = ACTIONS(3266),
    [anon_sym_GT] = ACTIONS(3266),
    [anon_sym_EQ_EQ] = ACTIONS(3266),
    [anon_sym_BANG_EQ] = ACTIONS(3266),
    [anon_sym_LT_EQ] = ACTIONS(3266),
    [anon_sym_GT_EQ] = ACTIONS(3266),
    [anon_sym_LBRACK] = ACTIONS(3264),
    [anon_sym_struct] = ACTIONS(3266),
    [anon_sym_mut] = ACTIONS(3266),
    [anon_sym_COLON] = ACTIONS(3266),
    [anon_sym_PLUS_PLUS] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3266),
    [anon_sym_QMARK] = ACTIONS(3266),
    [anon_sym_BANG] = ACTIONS(3266),
    [anon_sym_go] = ACTIONS(3266),
    [anon_sym_spawn] = ACTIONS(3266),
    [anon_sym_json_DOTdecode] = ACTIONS(3266),
    [anon_sym_PIPE] = ACTIONS(3266),
    [anon_sym_LBRACK2] = ACTIONS(3266),
    [anon_sym_TILDE] = ACTIONS(3266),
    [anon_sym_CARET] = ACTIONS(3266),
    [anon_sym_AMP] = ACTIONS(3266),
    [anon_sym_LT_DASH] = ACTIONS(3266),
    [anon_sym_LT_LT] = ACTIONS(3266),
    [anon_sym_GT_GT] = ACTIONS(3266),
    [anon_sym_GT_GT_GT] = ACTIONS(3266),
    [anon_sym_AMP_CARET] = ACTIONS(3266),
    [anon_sym_AMP_AMP] = ACTIONS(3266),
    [anon_sym_PIPE_PIPE] = ACTIONS(3266),
    [anon_sym_or] = ACTIONS(3266),
    [sym_none] = ACTIONS(3266),
    [sym_true] = ACTIONS(3266),
    [sym_false] = ACTIONS(3266),
    [sym_nil] = ACTIONS(3266),
    [anon_sym_QMARK_DOT] = ACTIONS(3266),
    [anon_sym_POUND_LBRACK] = ACTIONS(3266),
    [anon_sym_if] = ACTIONS(3266),
    [anon_sym_DOLLARif] = ACTIONS(3266),
    [anon_sym_is] = ACTIONS(3266),
    [anon_sym_BANGis] = ACTIONS(3266),
    [anon_sym_in] = ACTIONS(3266),
    [anon_sym_BANGin] = ACTIONS(3266),
    [anon_sym_match] = ACTIONS(3266),
    [anon_sym_select] = ACTIONS(3266),
    [anon_sym_STAR_EQ] = ACTIONS(3266),
    [anon_sym_SLASH_EQ] = ACTIONS(3266),
    [anon_sym_PERCENT_EQ] = ACTIONS(3266),
    [anon_sym_LT_LT_EQ] = ACTIONS(3266),
    [anon_sym_GT_GT_EQ] = ACTIONS(3266),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3266),
    [anon_sym_AMP_EQ] = ACTIONS(3266),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3266),
    [anon_sym_PLUS_EQ] = ACTIONS(3266),
    [anon_sym_DASH_EQ] = ACTIONS(3266),
    [anon_sym_PIPE_EQ] = ACTIONS(3266),
    [anon_sym_CARET_EQ] = ACTIONS(3266),
    [anon_sym_COLON_EQ] = ACTIONS(3266),
    [anon_sym_lock] = ACTIONS(3266),
    [anon_sym_rlock] = ACTIONS(3266),
    [anon_sym_unsafe] = ACTIONS(3266),
    [anon_sym_sql] = ACTIONS(3266),
    [sym_int_literal] = ACTIONS(3266),
    [sym_float_literal] = ACTIONS(3266),
    [sym_rune_literal] = ACTIONS(3266),
    [anon_sym_SQUOTE] = ACTIONS(3266),
    [anon_sym_DQUOTE] = ACTIONS(3266),
    [anon_sym_c_SQUOTE] = ACTIONS(3266),
    [anon_sym_c_DQUOTE] = ACTIONS(3266),
    [anon_sym_r_SQUOTE] = ACTIONS(3266),
    [anon_sym_r_DQUOTE] = ACTIONS(3266),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3266),
    [anon_sym_shared] = ACTIONS(3266),
    [anon_sym_map_LBRACK] = ACTIONS(3266),
    [anon_sym_chan] = ACTIONS(3266),
    [anon_sym_thread] = ACTIONS(3266),
    [anon_sym_atomic] = ACTIONS(3266),
    [anon_sym_assert] = ACTIONS(3266),
    [anon_sym_defer] = ACTIONS(3266),
    [anon_sym_goto] = ACTIONS(3266),
    [anon_sym_break] = ACTIONS(3266),
    [anon_sym_continue] = ACTIONS(3266),
    [anon_sym_return] = ACTIONS(3266),
    [anon_sym_DOLLARfor] = ACTIONS(3266),
    [anon_sym_for] = ACTIONS(3266),
    [anon_sym_POUND] = ACTIONS(3266),
    [anon_sym_asm] = ACTIONS(3266),
  },
  [1109] = {
    [sym_line_comment] = STATE(1109),
    [sym_block_comment] = STATE(1109),
    [sym_identifier] = ACTIONS(2961),
    [anon_sym_LF] = ACTIONS(2961),
    [anon_sym_CR] = ACTIONS(2961),
    [anon_sym_CR_LF] = ACTIONS(2961),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2961),
    [anon_sym_DOT] = ACTIONS(2961),
    [anon_sym_as] = ACTIONS(2961),
    [anon_sym_LBRACE] = ACTIONS(2961),
    [anon_sym_COMMA] = ACTIONS(2961),
    [anon_sym_RBRACE] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(2961),
    [anon_sym_EQ] = ACTIONS(2961),
    [anon_sym_fn] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2961),
    [anon_sym_DASH] = ACTIONS(2961),
    [anon_sym_STAR] = ACTIONS(2961),
    [anon_sym_SLASH] = ACTIONS(2961),
    [anon_sym_PERCENT] = ACTIONS(2961),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_GT] = ACTIONS(2961),
    [anon_sym_EQ_EQ] = ACTIONS(2961),
    [anon_sym_BANG_EQ] = ACTIONS(2961),
    [anon_sym_LT_EQ] = ACTIONS(2961),
    [anon_sym_GT_EQ] = ACTIONS(2961),
    [anon_sym_LBRACK] = ACTIONS(2959),
    [anon_sym_struct] = ACTIONS(2961),
    [anon_sym_mut] = ACTIONS(2961),
    [anon_sym_COLON] = ACTIONS(2961),
    [anon_sym_PLUS_PLUS] = ACTIONS(2961),
    [anon_sym_DASH_DASH] = ACTIONS(2961),
    [anon_sym_QMARK] = ACTIONS(2961),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_go] = ACTIONS(2961),
    [anon_sym_spawn] = ACTIONS(2961),
    [anon_sym_json_DOTdecode] = ACTIONS(2961),
    [anon_sym_PIPE] = ACTIONS(2961),
    [anon_sym_LBRACK2] = ACTIONS(2961),
    [anon_sym_TILDE] = ACTIONS(2961),
    [anon_sym_CARET] = ACTIONS(2961),
    [anon_sym_AMP] = ACTIONS(2961),
    [anon_sym_LT_DASH] = ACTIONS(2961),
    [anon_sym_LT_LT] = ACTIONS(2961),
    [anon_sym_GT_GT] = ACTIONS(2961),
    [anon_sym_GT_GT_GT] = ACTIONS(2961),
    [anon_sym_AMP_CARET] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2961),
    [anon_sym_PIPE_PIPE] = ACTIONS(2961),
    [anon_sym_or] = ACTIONS(2961),
    [sym_none] = ACTIONS(2961),
    [sym_true] = ACTIONS(2961),
    [sym_false] = ACTIONS(2961),
    [sym_nil] = ACTIONS(2961),
    [anon_sym_QMARK_DOT] = ACTIONS(2961),
    [anon_sym_POUND_LBRACK] = ACTIONS(2961),
    [anon_sym_if] = ACTIONS(2961),
    [anon_sym_DOLLARif] = ACTIONS(2961),
    [anon_sym_is] = ACTIONS(2961),
    [anon_sym_BANGis] = ACTIONS(2961),
    [anon_sym_in] = ACTIONS(2961),
    [anon_sym_BANGin] = ACTIONS(2961),
    [anon_sym_match] = ACTIONS(2961),
    [anon_sym_select] = ACTIONS(2961),
    [anon_sym_STAR_EQ] = ACTIONS(2961),
    [anon_sym_SLASH_EQ] = ACTIONS(2961),
    [anon_sym_PERCENT_EQ] = ACTIONS(2961),
    [anon_sym_LT_LT_EQ] = ACTIONS(2961),
    [anon_sym_GT_GT_EQ] = ACTIONS(2961),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2961),
    [anon_sym_AMP_EQ] = ACTIONS(2961),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2961),
    [anon_sym_PLUS_EQ] = ACTIONS(2961),
    [anon_sym_DASH_EQ] = ACTIONS(2961),
    [anon_sym_PIPE_EQ] = ACTIONS(2961),
    [anon_sym_CARET_EQ] = ACTIONS(2961),
    [anon_sym_COLON_EQ] = ACTIONS(2961),
    [anon_sym_lock] = ACTIONS(2961),
    [anon_sym_rlock] = ACTIONS(2961),
    [anon_sym_unsafe] = ACTIONS(2961),
    [anon_sym_sql] = ACTIONS(2961),
    [sym_int_literal] = ACTIONS(2961),
    [sym_float_literal] = ACTIONS(2961),
    [sym_rune_literal] = ACTIONS(2961),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_DQUOTE] = ACTIONS(2961),
    [anon_sym_c_SQUOTE] = ACTIONS(2961),
    [anon_sym_c_DQUOTE] = ACTIONS(2961),
    [anon_sym_r_SQUOTE] = ACTIONS(2961),
    [anon_sym_r_DQUOTE] = ACTIONS(2961),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2961),
    [anon_sym_shared] = ACTIONS(2961),
    [anon_sym_map_LBRACK] = ACTIONS(2961),
    [anon_sym_chan] = ACTIONS(2961),
    [anon_sym_thread] = ACTIONS(2961),
    [anon_sym_atomic] = ACTIONS(2961),
    [anon_sym_assert] = ACTIONS(2961),
    [anon_sym_defer] = ACTIONS(2961),
    [anon_sym_goto] = ACTIONS(2961),
    [anon_sym_break] = ACTIONS(2961),
    [anon_sym_continue] = ACTIONS(2961),
    [anon_sym_return] = ACTIONS(2961),
    [anon_sym_DOLLARfor] = ACTIONS(2961),
    [anon_sym_for] = ACTIONS(2961),
    [anon_sym_POUND] = ACTIONS(2961),
    [anon_sym_asm] = ACTIONS(2961),
  },
  [1110] = {
    [sym_line_comment] = STATE(1110),
    [sym_block_comment] = STATE(1110),
    [sym_identifier] = ACTIONS(3246),
    [anon_sym_LF] = ACTIONS(3246),
    [anon_sym_CR] = ACTIONS(3246),
    [anon_sym_CR_LF] = ACTIONS(3246),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3246),
    [anon_sym_DOT] = ACTIONS(3246),
    [anon_sym_as] = ACTIONS(3246),
    [anon_sym_LBRACE] = ACTIONS(3246),
    [anon_sym_COMMA] = ACTIONS(3246),
    [anon_sym_RBRACE] = ACTIONS(3246),
    [anon_sym_LPAREN] = ACTIONS(3246),
    [anon_sym_EQ] = ACTIONS(3246),
    [anon_sym_fn] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3246),
    [anon_sym_DASH] = ACTIONS(3246),
    [anon_sym_STAR] = ACTIONS(3246),
    [anon_sym_SLASH] = ACTIONS(3246),
    [anon_sym_PERCENT] = ACTIONS(3246),
    [anon_sym_LT] = ACTIONS(3246),
    [anon_sym_GT] = ACTIONS(3246),
    [anon_sym_EQ_EQ] = ACTIONS(3246),
    [anon_sym_BANG_EQ] = ACTIONS(3246),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3246),
    [anon_sym_LBRACK] = ACTIONS(3244),
    [anon_sym_struct] = ACTIONS(3246),
    [anon_sym_mut] = ACTIONS(3246),
    [anon_sym_COLON] = ACTIONS(3246),
    [anon_sym_PLUS_PLUS] = ACTIONS(3246),
    [anon_sym_DASH_DASH] = ACTIONS(3246),
    [anon_sym_QMARK] = ACTIONS(3246),
    [anon_sym_BANG] = ACTIONS(3246),
    [anon_sym_go] = ACTIONS(3246),
    [anon_sym_spawn] = ACTIONS(3246),
    [anon_sym_json_DOTdecode] = ACTIONS(3246),
    [anon_sym_PIPE] = ACTIONS(3246),
    [anon_sym_LBRACK2] = ACTIONS(3246),
    [anon_sym_TILDE] = ACTIONS(3246),
    [anon_sym_CARET] = ACTIONS(3246),
    [anon_sym_AMP] = ACTIONS(3246),
    [anon_sym_LT_DASH] = ACTIONS(3246),
    [anon_sym_LT_LT] = ACTIONS(3246),
    [anon_sym_GT_GT] = ACTIONS(3246),
    [anon_sym_GT_GT_GT] = ACTIONS(3246),
    [anon_sym_AMP_CARET] = ACTIONS(3246),
    [anon_sym_AMP_AMP] = ACTIONS(3246),
    [anon_sym_PIPE_PIPE] = ACTIONS(3246),
    [anon_sym_or] = ACTIONS(3246),
    [sym_none] = ACTIONS(3246),
    [sym_true] = ACTIONS(3246),
    [sym_false] = ACTIONS(3246),
    [sym_nil] = ACTIONS(3246),
    [anon_sym_QMARK_DOT] = ACTIONS(3246),
    [anon_sym_POUND_LBRACK] = ACTIONS(3246),
    [anon_sym_if] = ACTIONS(3246),
    [anon_sym_DOLLARif] = ACTIONS(3246),
    [anon_sym_is] = ACTIONS(3246),
    [anon_sym_BANGis] = ACTIONS(3246),
    [anon_sym_in] = ACTIONS(3246),
    [anon_sym_BANGin] = ACTIONS(3246),
    [anon_sym_match] = ACTIONS(3246),
    [anon_sym_select] = ACTIONS(3246),
    [anon_sym_STAR_EQ] = ACTIONS(3246),
    [anon_sym_SLASH_EQ] = ACTIONS(3246),
    [anon_sym_PERCENT_EQ] = ACTIONS(3246),
    [anon_sym_LT_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT_GT_EQ] = ACTIONS(3246),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3246),
    [anon_sym_AMP_EQ] = ACTIONS(3246),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3246),
    [anon_sym_PLUS_EQ] = ACTIONS(3246),
    [anon_sym_DASH_EQ] = ACTIONS(3246),
    [anon_sym_PIPE_EQ] = ACTIONS(3246),
    [anon_sym_CARET_EQ] = ACTIONS(3246),
    [anon_sym_COLON_EQ] = ACTIONS(3246),
    [anon_sym_lock] = ACTIONS(3246),
    [anon_sym_rlock] = ACTIONS(3246),
    [anon_sym_unsafe] = ACTIONS(3246),
    [anon_sym_sql] = ACTIONS(3246),
    [sym_int_literal] = ACTIONS(3246),
    [sym_float_literal] = ACTIONS(3246),
    [sym_rune_literal] = ACTIONS(3246),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_DQUOTE] = ACTIONS(3246),
    [anon_sym_c_SQUOTE] = ACTIONS(3246),
    [anon_sym_c_DQUOTE] = ACTIONS(3246),
    [anon_sym_r_SQUOTE] = ACTIONS(3246),
    [anon_sym_r_DQUOTE] = ACTIONS(3246),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3246),
    [anon_sym_shared] = ACTIONS(3246),
    [anon_sym_map_LBRACK] = ACTIONS(3246),
    [anon_sym_chan] = ACTIONS(3246),
    [anon_sym_thread] = ACTIONS(3246),
    [anon_sym_atomic] = ACTIONS(3246),
    [anon_sym_assert] = ACTIONS(3246),
    [anon_sym_defer] = ACTIONS(3246),
    [anon_sym_goto] = ACTIONS(3246),
    [anon_sym_break] = ACTIONS(3246),
    [anon_sym_continue] = ACTIONS(3246),
    [anon_sym_return] = ACTIONS(3246),
    [anon_sym_DOLLARfor] = ACTIONS(3246),
    [anon_sym_for] = ACTIONS(3246),
    [anon_sym_POUND] = ACTIONS(3246),
    [anon_sym_asm] = ACTIONS(3246),
  },
  [1111] = {
    [sym_line_comment] = STATE(1111),
    [sym_block_comment] = STATE(1111),
    [sym_identifier] = ACTIONS(2973),
    [anon_sym_LF] = ACTIONS(2973),
    [anon_sym_CR] = ACTIONS(2973),
    [anon_sym_CR_LF] = ACTIONS(2973),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym_DOT] = ACTIONS(2973),
    [anon_sym_as] = ACTIONS(2973),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_COMMA] = ACTIONS(2973),
    [anon_sym_RBRACE] = ACTIONS(2973),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_EQ] = ACTIONS(2973),
    [anon_sym_fn] = ACTIONS(2973),
    [anon_sym_PLUS] = ACTIONS(2973),
    [anon_sym_DASH] = ACTIONS(2973),
    [anon_sym_STAR] = ACTIONS(2973),
    [anon_sym_SLASH] = ACTIONS(2973),
    [anon_sym_PERCENT] = ACTIONS(2973),
    [anon_sym_LT] = ACTIONS(2973),
    [anon_sym_GT] = ACTIONS(2973),
    [anon_sym_EQ_EQ] = ACTIONS(2973),
    [anon_sym_BANG_EQ] = ACTIONS(2973),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LBRACK] = ACTIONS(2971),
    [anon_sym_struct] = ACTIONS(2973),
    [anon_sym_mut] = ACTIONS(2973),
    [anon_sym_COLON] = ACTIONS(2973),
    [anon_sym_PLUS_PLUS] = ACTIONS(2973),
    [anon_sym_DASH_DASH] = ACTIONS(2973),
    [anon_sym_QMARK] = ACTIONS(2973),
    [anon_sym_BANG] = ACTIONS(2973),
    [anon_sym_go] = ACTIONS(2973),
    [anon_sym_spawn] = ACTIONS(2973),
    [anon_sym_json_DOTdecode] = ACTIONS(2973),
    [anon_sym_PIPE] = ACTIONS(2973),
    [anon_sym_LBRACK2] = ACTIONS(2973),
    [anon_sym_TILDE] = ACTIONS(2973),
    [anon_sym_CARET] = ACTIONS(2973),
    [anon_sym_AMP] = ACTIONS(2973),
    [anon_sym_LT_DASH] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2973),
    [anon_sym_GT_GT] = ACTIONS(2973),
    [anon_sym_GT_GT_GT] = ACTIONS(2973),
    [anon_sym_AMP_CARET] = ACTIONS(2973),
    [anon_sym_AMP_AMP] = ACTIONS(2973),
    [anon_sym_PIPE_PIPE] = ACTIONS(2973),
    [anon_sym_or] = ACTIONS(2973),
    [sym_none] = ACTIONS(2973),
    [sym_true] = ACTIONS(2973),
    [sym_false] = ACTIONS(2973),
    [sym_nil] = ACTIONS(2973),
    [anon_sym_QMARK_DOT] = ACTIONS(2973),
    [anon_sym_POUND_LBRACK] = ACTIONS(2973),
    [anon_sym_if] = ACTIONS(2973),
    [anon_sym_DOLLARif] = ACTIONS(2973),
    [anon_sym_is] = ACTIONS(2973),
    [anon_sym_BANGis] = ACTIONS(2973),
    [anon_sym_in] = ACTIONS(2973),
    [anon_sym_BANGin] = ACTIONS(2973),
    [anon_sym_match] = ACTIONS(2973),
    [anon_sym_select] = ACTIONS(2973),
    [anon_sym_STAR_EQ] = ACTIONS(2973),
    [anon_sym_SLASH_EQ] = ACTIONS(2973),
    [anon_sym_PERCENT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_GT_EQ] = ACTIONS(2973),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2973),
    [anon_sym_AMP_EQ] = ACTIONS(2973),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2973),
    [anon_sym_PLUS_EQ] = ACTIONS(2973),
    [anon_sym_DASH_EQ] = ACTIONS(2973),
    [anon_sym_PIPE_EQ] = ACTIONS(2973),
    [anon_sym_CARET_EQ] = ACTIONS(2973),
    [anon_sym_COLON_EQ] = ACTIONS(2973),
    [anon_sym_lock] = ACTIONS(2973),
    [anon_sym_rlock] = ACTIONS(2973),
    [anon_sym_unsafe] = ACTIONS(2973),
    [anon_sym_sql] = ACTIONS(2973),
    [sym_int_literal] = ACTIONS(2973),
    [sym_float_literal] = ACTIONS(2973),
    [sym_rune_literal] = ACTIONS(2973),
    [anon_sym_SQUOTE] = ACTIONS(2973),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [anon_sym_c_SQUOTE] = ACTIONS(2973),
    [anon_sym_c_DQUOTE] = ACTIONS(2973),
    [anon_sym_r_SQUOTE] = ACTIONS(2973),
    [anon_sym_r_DQUOTE] = ACTIONS(2973),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2973),
    [anon_sym_shared] = ACTIONS(2973),
    [anon_sym_map_LBRACK] = ACTIONS(2973),
    [anon_sym_chan] = ACTIONS(2973),
    [anon_sym_thread] = ACTIONS(2973),
    [anon_sym_atomic] = ACTIONS(2973),
    [anon_sym_assert] = ACTIONS(2973),
    [anon_sym_defer] = ACTIONS(2973),
    [anon_sym_goto] = ACTIONS(2973),
    [anon_sym_break] = ACTIONS(2973),
    [anon_sym_continue] = ACTIONS(2973),
    [anon_sym_return] = ACTIONS(2973),
    [anon_sym_DOLLARfor] = ACTIONS(2973),
    [anon_sym_for] = ACTIONS(2973),
    [anon_sym_POUND] = ACTIONS(2973),
    [anon_sym_asm] = ACTIONS(2973),
  },
  [1112] = {
    [sym_line_comment] = STATE(1112),
    [sym_block_comment] = STATE(1112),
    [sym_reference_expression] = STATE(4454),
    [sym_type_reference_expression] = STATE(3423),
    [sym_plain_type] = STATE(3452),
    [sym__plain_type_without_special] = STATE(3458),
    [sym_anon_struct_type] = STATE(3459),
    [sym_multi_return_type] = STATE(3458),
    [sym_result_type] = STATE(3458),
    [sym_option_type] = STATE(3458),
    [sym_qualified_type] = STATE(3423),
    [sym_fixed_array_type] = STATE(3459),
    [sym_array_type] = STATE(3459),
    [sym_pointer_type] = STATE(3459),
    [sym_wrong_pointer_type] = STATE(3459),
    [sym_map_type] = STATE(3459),
    [sym_channel_type] = STATE(3459),
    [sym_shared_type] = STATE(3459),
    [sym_thread_type] = STATE(3459),
    [sym_atomic_type] = STATE(3459),
    [sym_generic_type] = STATE(3459),
    [sym_function_type] = STATE(3459),
    [sym_identifier] = ACTIONS(3804),
    [anon_sym_LF] = ACTIONS(2177),
    [anon_sym_CR] = ACTIONS(2177),
    [anon_sym_CR_LF] = ACTIONS(2177),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_DOT] = ACTIONS(2175),
    [anon_sym_as] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2177),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym_RBRACE] = ACTIONS(2177),
    [anon_sym_LPAREN] = ACTIONS(3806),
    [anon_sym___global] = ACTIONS(2373),
    [anon_sym_fn] = ACTIONS(3808),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(3810),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_PERCENT] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_GT] = ACTIONS(2175),
    [anon_sym_EQ_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ] = ACTIONS(2175),
    [anon_sym_LT_EQ] = ACTIONS(2175),
    [anon_sym_GT_EQ] = ACTIONS(2175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2180),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_pub] = ACTIONS(2373),
    [anon_sym_mut] = ACTIONS(2177),
    [anon_sym_COLON] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [anon_sym_QMARK] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(3816),
    [anon_sym_go] = ACTIONS(2175),
    [anon_sym_spawn] = ACTIONS(2175),
    [anon_sym_json_DOTdecode] = ACTIONS(2175),
    [anon_sym_PIPE] = ACTIONS(2175),
    [anon_sym_LBRACK2] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_CARET] = ACTIONS(2175),
    [anon_sym_AMP] = ACTIONS(3820),
    [anon_sym_LT_DASH] = ACTIONS(2175),
    [anon_sym_LT_LT] = ACTIONS(2175),
    [anon_sym_GT_GT] = ACTIONS(2175),
    [anon_sym_GT_GT_GT] = ACTIONS(2175),
    [anon_sym_AMP_CARET] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(2175),
    [anon_sym_PIPE_PIPE] = ACTIONS(2175),
    [anon_sym_or] = ACTIONS(2175),
    [sym_none] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_nil] = ACTIONS(2175),
    [anon_sym_QMARK_DOT] = ACTIONS(2175),
    [anon_sym_POUND_LBRACK] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_DOLLARif] = ACTIONS(2175),
    [anon_sym_is] = ACTIONS(2175),
    [anon_sym_BANGis] = ACTIONS(2175),
    [anon_sym_in] = ACTIONS(2175),
    [anon_sym_BANGin] = ACTIONS(2175),
    [anon_sym_match] = ACTIONS(2175),
    [anon_sym_select] = ACTIONS(2175),
    [anon_sym_lock] = ACTIONS(2175),
    [anon_sym_rlock] = ACTIONS(2175),
    [anon_sym_unsafe] = ACTIONS(2175),
    [anon_sym_sql] = ACTIONS(2175),
    [sym_int_literal] = ACTIONS(2175),
    [sym_float_literal] = ACTIONS(2175),
    [sym_rune_literal] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_c_SQUOTE] = ACTIONS(2175),
    [anon_sym_c_DQUOTE] = ACTIONS(2175),
    [anon_sym_r_SQUOTE] = ACTIONS(2175),
    [anon_sym_r_DQUOTE] = ACTIONS(2175),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2175),
    [anon_sym_shared] = ACTIONS(3822),
    [anon_sym_map_LBRACK] = ACTIONS(3824),
    [anon_sym_chan] = ACTIONS(3826),
    [anon_sym_thread] = ACTIONS(3828),
    [anon_sym_atomic] = ACTIONS(3830),
  },
  [1113] = {
    [sym_line_comment] = STATE(1113),
    [sym_block_comment] = STATE(1113),
    [sym_identifier] = ACTIONS(2445),
    [anon_sym_LF] = ACTIONS(2445),
    [anon_sym_CR] = ACTIONS(2445),
    [anon_sym_CR_LF] = ACTIONS(2445),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2445),
    [anon_sym_DOT] = ACTIONS(2445),
    [anon_sym_as] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(2445),
    [anon_sym_COMMA] = ACTIONS(2445),
    [anon_sym_RBRACE] = ACTIONS(2445),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym_EQ] = ACTIONS(2445),
    [anon_sym_fn] = ACTIONS(2445),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2445),
    [anon_sym_STAR] = ACTIONS(2445),
    [anon_sym_SLASH] = ACTIONS(2445),
    [anon_sym_PERCENT] = ACTIONS(2445),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_GT] = ACTIONS(2445),
    [anon_sym_EQ_EQ] = ACTIONS(2445),
    [anon_sym_BANG_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_struct] = ACTIONS(2445),
    [anon_sym_mut] = ACTIONS(2445),
    [anon_sym_PLUS_PLUS] = ACTIONS(2445),
    [anon_sym_DASH_DASH] = ACTIONS(2445),
    [anon_sym_QMARK] = ACTIONS(2445),
    [anon_sym_BANG] = ACTIONS(2445),
    [anon_sym_go] = ACTIONS(2445),
    [anon_sym_spawn] = ACTIONS(2445),
    [anon_sym_json_DOTdecode] = ACTIONS(2445),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_LBRACK2] = ACTIONS(2445),
    [anon_sym_TILDE] = ACTIONS(2445),
    [anon_sym_CARET] = ACTIONS(2445),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_LT_DASH] = ACTIONS(2445),
    [anon_sym_LT_LT] = ACTIONS(2445),
    [anon_sym_GT_GT] = ACTIONS(2445),
    [anon_sym_GT_GT_GT] = ACTIONS(2445),
    [anon_sym_AMP_CARET] = ACTIONS(2445),
    [anon_sym_AMP_AMP] = ACTIONS(2445),
    [anon_sym_PIPE_PIPE] = ACTIONS(2445),
    [anon_sym_or] = ACTIONS(2445),
    [sym_none] = ACTIONS(2445),
    [sym_true] = ACTIONS(2445),
    [sym_false] = ACTIONS(2445),
    [sym_nil] = ACTIONS(2445),
    [anon_sym_QMARK_DOT] = ACTIONS(2445),
    [anon_sym_POUND_LBRACK] = ACTIONS(2445),
    [anon_sym_if] = ACTIONS(2445),
    [anon_sym_DOLLARif] = ACTIONS(2445),
    [anon_sym_is] = ACTIONS(2445),
    [anon_sym_BANGis] = ACTIONS(2445),
    [anon_sym_in] = ACTIONS(2445),
    [anon_sym_BANGin] = ACTIONS(2445),
    [anon_sym_match] = ACTIONS(2445),
    [anon_sym_select] = ACTIONS(2445),
    [anon_sym_STAR_EQ] = ACTIONS(2445),
    [anon_sym_SLASH_EQ] = ACTIONS(2445),
    [anon_sym_PERCENT_EQ] = ACTIONS(2445),
    [anon_sym_LT_LT_EQ] = ACTIONS(2445),
    [anon_sym_GT_GT_EQ] = ACTIONS(2445),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2445),
    [anon_sym_AMP_EQ] = ACTIONS(2445),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2445),
    [anon_sym_PLUS_EQ] = ACTIONS(2445),
    [anon_sym_DASH_EQ] = ACTIONS(2445),
    [anon_sym_PIPE_EQ] = ACTIONS(2445),
    [anon_sym_CARET_EQ] = ACTIONS(2445),
    [anon_sym_COLON_EQ] = ACTIONS(2445),
    [anon_sym_lock] = ACTIONS(2445),
    [anon_sym_rlock] = ACTIONS(2445),
    [anon_sym_unsafe] = ACTIONS(2445),
    [anon_sym_sql] = ACTIONS(2445),
    [sym_int_literal] = ACTIONS(2445),
    [sym_float_literal] = ACTIONS(2445),
    [sym_rune_literal] = ACTIONS(2445),
    [anon_sym_SQUOTE] = ACTIONS(2445),
    [anon_sym_DQUOTE] = ACTIONS(2445),
    [anon_sym_c_SQUOTE] = ACTIONS(2445),
    [anon_sym_c_DQUOTE] = ACTIONS(2445),
    [anon_sym_r_SQUOTE] = ACTIONS(2445),
    [anon_sym_r_DQUOTE] = ACTIONS(2445),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2445),
    [anon_sym_shared] = ACTIONS(2445),
    [anon_sym_map_LBRACK] = ACTIONS(2445),
    [anon_sym_chan] = ACTIONS(2445),
    [anon_sym_thread] = ACTIONS(2445),
    [anon_sym_atomic] = ACTIONS(2445),
    [anon_sym_assert] = ACTIONS(2445),
    [anon_sym_defer] = ACTIONS(2445),
    [anon_sym_goto] = ACTIONS(2445),
    [anon_sym_break] = ACTIONS(2445),
    [anon_sym_continue] = ACTIONS(2445),
    [anon_sym_return] = ACTIONS(2445),
    [anon_sym_DOLLARfor] = ACTIONS(2445),
    [anon_sym_for] = ACTIONS(2445),
    [anon_sym_POUND] = ACTIONS(2445),
    [anon_sym_asm] = ACTIONS(2445),
  },
  [1114] = {
    [sym_line_comment] = STATE(1114),
    [sym_block_comment] = STATE(1114),
    [sym_reference_expression] = STATE(4507),
    [sym_type_reference_expression] = STATE(1426),
    [sym_plain_type] = STATE(1549),
    [sym__plain_type_without_special] = STATE(1528),
    [sym_anon_struct_type] = STATE(1529),
    [sym_multi_return_type] = STATE(1528),
    [sym_result_type] = STATE(1528),
    [sym_option_type] = STATE(1528),
    [sym_qualified_type] = STATE(1426),
    [sym_fixed_array_type] = STATE(1529),
    [sym_array_type] = STATE(1529),
    [sym_pointer_type] = STATE(1529),
    [sym_wrong_pointer_type] = STATE(1529),
    [sym_map_type] = STATE(1529),
    [sym_channel_type] = STATE(1529),
    [sym_shared_type] = STATE(1529),
    [sym_thread_type] = STATE(1529),
    [sym_atomic_type] = STATE(1529),
    [sym_generic_type] = STATE(1529),
    [sym_function_type] = STATE(1529),
    [sym_identifier] = ACTIONS(3832),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_CR] = ACTIONS(859),
    [anon_sym_CR_LF] = ACTIONS(859),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(859),
    [anon_sym_as] = ACTIONS(859),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(3834),
    [anon_sym_RPAREN] = ACTIONS(859),
    [anon_sym_fn] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(3838),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(859),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_struct] = ACTIONS(3840),
    [anon_sym_mut] = ACTIONS(859),
    [anon_sym_PLUS_PLUS] = ACTIONS(859),
    [anon_sym_DASH_DASH] = ACTIONS(859),
    [anon_sym_QMARK] = ACTIONS(3842),
    [anon_sym_BANG] = ACTIONS(3844),
    [anon_sym_go] = ACTIONS(859),
    [anon_sym_spawn] = ACTIONS(859),
    [anon_sym_json_DOTdecode] = ACTIONS(859),
    [anon_sym_PIPE] = ACTIONS(859),
    [anon_sym_LBRACK2] = ACTIONS(3846),
    [anon_sym_TILDE] = ACTIONS(859),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_LT_DASH] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_GT_GT_GT] = ACTIONS(859),
    [anon_sym_AMP_CARET] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_or] = ACTIONS(859),
    [sym_none] = ACTIONS(859),
    [sym_true] = ACTIONS(859),
    [sym_false] = ACTIONS(859),
    [sym_nil] = ACTIONS(859),
    [anon_sym_QMARK_DOT] = ACTIONS(859),
    [anon_sym_POUND_LBRACK] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_DOLLARif] = ACTIONS(859),
    [anon_sym_is] = ACTIONS(859),
    [anon_sym_BANGis] = ACTIONS(859),
    [anon_sym_in] = ACTIONS(859),
    [anon_sym_BANGin] = ACTIONS(859),
    [anon_sym_match] = ACTIONS(859),
    [anon_sym_select] = ACTIONS(859),
    [anon_sym_lock] = ACTIONS(859),
    [anon_sym_rlock] = ACTIONS(859),
    [anon_sym_unsafe] = ACTIONS(859),
    [anon_sym_sql] = ACTIONS(859),
    [sym_int_literal] = ACTIONS(859),
    [sym_float_literal] = ACTIONS(859),
    [sym_rune_literal] = ACTIONS(859),
    [anon_sym_SQUOTE] = ACTIONS(859),
    [anon_sym_DQUOTE] = ACTIONS(859),
    [anon_sym_c_SQUOTE] = ACTIONS(859),
    [anon_sym_c_DQUOTE] = ACTIONS(859),
    [anon_sym_r_SQUOTE] = ACTIONS(859),
    [anon_sym_r_DQUOTE] = ACTIONS(859),
    [sym_pseudo_compile_time_identifier] = ACTIONS(859),
    [anon_sym_shared] = ACTIONS(3850),
    [anon_sym_map_LBRACK] = ACTIONS(3852),
    [anon_sym_chan] = ACTIONS(3854),
    [anon_sym_thread] = ACTIONS(3856),
    [anon_sym_atomic] = ACTIONS(3858),
  },
  [1115] = {
    [sym_line_comment] = STATE(1115),
    [sym_block_comment] = STATE(1115),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2489),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(851),
    [anon_sym_LF] = ACTIONS(851),
    [anon_sym_CR] = ACTIONS(851),
    [anon_sym_CR_LF] = ACTIONS(851),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(851),
    [anon_sym_DOT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(851),
    [anon_sym_COMMA] = ACTIONS(851),
    [anon_sym_RBRACE] = ACTIONS(851),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_RPAREN] = ACTIONS(851),
    [anon_sym_fn] = ACTIONS(851),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(851),
    [anon_sym_SLASH] = ACTIONS(851),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(851),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_struct] = ACTIONS(851),
    [anon_sym_mut] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(851),
    [anon_sym_DASH_DASH] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_go] = ACTIONS(851),
    [anon_sym_spawn] = ACTIONS(851),
    [anon_sym_json_DOTdecode] = ACTIONS(851),
    [anon_sym_PIPE] = ACTIONS(851),
    [anon_sym_LBRACK2] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(851),
    [anon_sym_CARET] = ACTIONS(851),
    [anon_sym_AMP] = ACTIONS(851),
    [anon_sym_LT_DASH] = ACTIONS(851),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_CARET] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(851),
    [anon_sym_PIPE_PIPE] = ACTIONS(851),
    [anon_sym_or] = ACTIONS(851),
    [sym_none] = ACTIONS(851),
    [sym_true] = ACTIONS(851),
    [sym_false] = ACTIONS(851),
    [sym_nil] = ACTIONS(851),
    [anon_sym_QMARK_DOT] = ACTIONS(851),
    [anon_sym_POUND_LBRACK] = ACTIONS(851),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_DOLLARif] = ACTIONS(851),
    [anon_sym_is] = ACTIONS(851),
    [anon_sym_BANGis] = ACTIONS(851),
    [anon_sym_in] = ACTIONS(851),
    [anon_sym_BANGin] = ACTIONS(851),
    [anon_sym_match] = ACTIONS(851),
    [anon_sym_select] = ACTIONS(851),
    [anon_sym_lock] = ACTIONS(851),
    [anon_sym_rlock] = ACTIONS(851),
    [anon_sym_unsafe] = ACTIONS(851),
    [anon_sym_sql] = ACTIONS(851),
    [sym_int_literal] = ACTIONS(851),
    [sym_float_literal] = ACTIONS(851),
    [sym_rune_literal] = ACTIONS(851),
    [anon_sym_SQUOTE] = ACTIONS(851),
    [anon_sym_DQUOTE] = ACTIONS(851),
    [anon_sym_c_SQUOTE] = ACTIONS(851),
    [anon_sym_c_DQUOTE] = ACTIONS(851),
    [anon_sym_r_SQUOTE] = ACTIONS(851),
    [anon_sym_r_DQUOTE] = ACTIONS(851),
    [sym_pseudo_compile_time_identifier] = ACTIONS(851),
    [anon_sym_shared] = ACTIONS(851),
    [anon_sym_map_LBRACK] = ACTIONS(851),
    [anon_sym_chan] = ACTIONS(851),
    [anon_sym_thread] = ACTIONS(851),
    [anon_sym_atomic] = ACTIONS(851),
  },
  [1116] = {
    [sym_line_comment] = STATE(1116),
    [sym_block_comment] = STATE(1116),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2458),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_LF] = ACTIONS(865),
    [anon_sym_CR] = ACTIONS(865),
    [anon_sym_CR_LF] = ACTIONS(865),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_COMMA] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(865),
    [anon_sym_LPAREN] = ACTIONS(867),
    [anon_sym_RPAREN] = ACTIONS(865),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_STAR] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_PERCENT] = ACTIONS(865),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(865),
    [anon_sym_BANG_EQ] = ACTIONS(865),
    [anon_sym_LT_EQ] = ACTIONS(865),
    [anon_sym_GT_EQ] = ACTIONS(865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_mut] = ACTIONS(865),
    [anon_sym_PLUS_PLUS] = ACTIONS(865),
    [anon_sym_DASH_DASH] = ACTIONS(865),
    [anon_sym_QMARK] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(3860),
    [anon_sym_go] = ACTIONS(865),
    [anon_sym_spawn] = ACTIONS(865),
    [anon_sym_json_DOTdecode] = ACTIONS(865),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_LBRACK2] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(865),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT_DASH] = ACTIONS(865),
    [anon_sym_LT_LT] = ACTIONS(865),
    [anon_sym_GT_GT] = ACTIONS(865),
    [anon_sym_GT_GT_GT] = ACTIONS(865),
    [anon_sym_AMP_CARET] = ACTIONS(865),
    [anon_sym_AMP_AMP] = ACTIONS(865),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_or] = ACTIONS(865),
    [sym_none] = ACTIONS(865),
    [sym_true] = ACTIONS(865),
    [sym_false] = ACTIONS(865),
    [sym_nil] = ACTIONS(865),
    [anon_sym_QMARK_DOT] = ACTIONS(865),
    [anon_sym_POUND_LBRACK] = ACTIONS(865),
    [anon_sym_if] = ACTIONS(865),
    [anon_sym_DOLLARif] = ACTIONS(865),
    [anon_sym_is] = ACTIONS(865),
    [anon_sym_BANGis] = ACTIONS(865),
    [anon_sym_in] = ACTIONS(865),
    [anon_sym_BANGin] = ACTIONS(865),
    [anon_sym_match] = ACTIONS(865),
    [anon_sym_select] = ACTIONS(865),
    [anon_sym_lock] = ACTIONS(865),
    [anon_sym_rlock] = ACTIONS(865),
    [anon_sym_unsafe] = ACTIONS(865),
    [anon_sym_sql] = ACTIONS(865),
    [sym_int_literal] = ACTIONS(865),
    [sym_float_literal] = ACTIONS(865),
    [sym_rune_literal] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(865),
    [anon_sym_DQUOTE] = ACTIONS(865),
    [anon_sym_c_SQUOTE] = ACTIONS(865),
    [anon_sym_c_DQUOTE] = ACTIONS(865),
    [anon_sym_r_SQUOTE] = ACTIONS(865),
    [anon_sym_r_DQUOTE] = ACTIONS(865),
    [sym_pseudo_compile_time_identifier] = ACTIONS(865),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(351),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [1117] = {
    [sym_line_comment] = STATE(1117),
    [sym_block_comment] = STATE(1117),
    [sym_reference_expression] = STATE(4507),
    [sym_type_reference_expression] = STATE(1426),
    [sym_plain_type] = STATE(1518),
    [sym__plain_type_without_special] = STATE(1528),
    [sym_anon_struct_type] = STATE(1529),
    [sym_multi_return_type] = STATE(1528),
    [sym_result_type] = STATE(1528),
    [sym_option_type] = STATE(1528),
    [sym_qualified_type] = STATE(1426),
    [sym_fixed_array_type] = STATE(1529),
    [sym_array_type] = STATE(1529),
    [sym_pointer_type] = STATE(1529),
    [sym_wrong_pointer_type] = STATE(1529),
    [sym_map_type] = STATE(1529),
    [sym_channel_type] = STATE(1529),
    [sym_shared_type] = STATE(1529),
    [sym_thread_type] = STATE(1529),
    [sym_atomic_type] = STATE(1529),
    [sym_generic_type] = STATE(1529),
    [sym_function_type] = STATE(1529),
    [sym_identifier] = ACTIONS(3832),
    [anon_sym_LF] = ACTIONS(855),
    [anon_sym_CR] = ACTIONS(855),
    [anon_sym_CR_LF] = ACTIONS(855),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(855),
    [anon_sym_DOT] = ACTIONS(855),
    [anon_sym_as] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(855),
    [anon_sym_RBRACE] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(3834),
    [anon_sym_RPAREN] = ACTIONS(855),
    [anon_sym_fn] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(3838),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_PERCENT] = ACTIONS(855),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_GT] = ACTIONS(855),
    [anon_sym_EQ_EQ] = ACTIONS(855),
    [anon_sym_BANG_EQ] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(855),
    [anon_sym_GT_EQ] = ACTIONS(855),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_struct] = ACTIONS(3840),
    [anon_sym_mut] = ACTIONS(855),
    [anon_sym_PLUS_PLUS] = ACTIONS(855),
    [anon_sym_DASH_DASH] = ACTIONS(855),
    [anon_sym_QMARK] = ACTIONS(3842),
    [anon_sym_BANG] = ACTIONS(3844),
    [anon_sym_go] = ACTIONS(855),
    [anon_sym_spawn] = ACTIONS(855),
    [anon_sym_json_DOTdecode] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(855),
    [anon_sym_LBRACK2] = ACTIONS(3846),
    [anon_sym_TILDE] = ACTIONS(855),
    [anon_sym_CARET] = ACTIONS(855),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_LT_DASH] = ACTIONS(855),
    [anon_sym_LT_LT] = ACTIONS(855),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_GT_GT_GT] = ACTIONS(855),
    [anon_sym_AMP_CARET] = ACTIONS(855),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_PIPE_PIPE] = ACTIONS(855),
    [anon_sym_or] = ACTIONS(855),
    [sym_none] = ACTIONS(855),
    [sym_true] = ACTIONS(855),
    [sym_false] = ACTIONS(855),
    [sym_nil] = ACTIONS(855),
    [anon_sym_QMARK_DOT] = ACTIONS(855),
    [anon_sym_POUND_LBRACK] = ACTIONS(855),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_DOLLARif] = ACTIONS(855),
    [anon_sym_is] = ACTIONS(855),
    [anon_sym_BANGis] = ACTIONS(855),
    [anon_sym_in] = ACTIONS(855),
    [anon_sym_BANGin] = ACTIONS(855),
    [anon_sym_match] = ACTIONS(855),
    [anon_sym_select] = ACTIONS(855),
    [anon_sym_lock] = ACTIONS(855),
    [anon_sym_rlock] = ACTIONS(855),
    [anon_sym_unsafe] = ACTIONS(855),
    [anon_sym_sql] = ACTIONS(855),
    [sym_int_literal] = ACTIONS(855),
    [sym_float_literal] = ACTIONS(855),
    [sym_rune_literal] = ACTIONS(855),
    [anon_sym_SQUOTE] = ACTIONS(855),
    [anon_sym_DQUOTE] = ACTIONS(855),
    [anon_sym_c_SQUOTE] = ACTIONS(855),
    [anon_sym_c_DQUOTE] = ACTIONS(855),
    [anon_sym_r_SQUOTE] = ACTIONS(855),
    [anon_sym_r_DQUOTE] = ACTIONS(855),
    [sym_pseudo_compile_time_identifier] = ACTIONS(855),
    [anon_sym_shared] = ACTIONS(3850),
    [anon_sym_map_LBRACK] = ACTIONS(3852),
    [anon_sym_chan] = ACTIONS(3854),
    [anon_sym_thread] = ACTIONS(3856),
    [anon_sym_atomic] = ACTIONS(3858),
  },
  [1118] = {
    [sym_line_comment] = STATE(1118),
    [sym_block_comment] = STATE(1118),
    [sym_reference_expression] = STATE(4507),
    [sym_type_reference_expression] = STATE(1426),
    [sym_plain_type] = STATE(1532),
    [sym__plain_type_without_special] = STATE(1528),
    [sym_anon_struct_type] = STATE(1529),
    [sym_multi_return_type] = STATE(1528),
    [sym_result_type] = STATE(1528),
    [sym_option_type] = STATE(1528),
    [sym_qualified_type] = STATE(1426),
    [sym_fixed_array_type] = STATE(1529),
    [sym_array_type] = STATE(1529),
    [sym_pointer_type] = STATE(1529),
    [sym_wrong_pointer_type] = STATE(1529),
    [sym_map_type] = STATE(1529),
    [sym_channel_type] = STATE(1529),
    [sym_shared_type] = STATE(1529),
    [sym_thread_type] = STATE(1529),
    [sym_atomic_type] = STATE(1529),
    [sym_generic_type] = STATE(1529),
    [sym_function_type] = STATE(1529),
    [sym_identifier] = ACTIONS(3832),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_CR] = ACTIONS(821),
    [anon_sym_CR_LF] = ACTIONS(821),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(821),
    [anon_sym_DOT] = ACTIONS(821),
    [anon_sym_as] = ACTIONS(821),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_COMMA] = ACTIONS(821),
    [anon_sym_RBRACE] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(3834),
    [anon_sym_RPAREN] = ACTIONS(821),
    [anon_sym_fn] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(821),
    [anon_sym_DASH] = ACTIONS(821),
    [anon_sym_STAR] = ACTIONS(3838),
    [anon_sym_SLASH] = ACTIONS(821),
    [anon_sym_PERCENT] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(821),
    [anon_sym_GT] = ACTIONS(821),
    [anon_sym_EQ_EQ] = ACTIONS(821),
    [anon_sym_BANG_EQ] = ACTIONS(821),
    [anon_sym_LT_EQ] = ACTIONS(821),
    [anon_sym_GT_EQ] = ACTIONS(821),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(817),
    [anon_sym_struct] = ACTIONS(3840),
    [anon_sym_mut] = ACTIONS(821),
    [anon_sym_PLUS_PLUS] = ACTIONS(821),
    [anon_sym_DASH_DASH] = ACTIONS(821),
    [anon_sym_QMARK] = ACTIONS(3842),
    [anon_sym_BANG] = ACTIONS(3844),
    [anon_sym_go] = ACTIONS(821),
    [anon_sym_spawn] = ACTIONS(821),
    [anon_sym_json_DOTdecode] = ACTIONS(821),
    [anon_sym_PIPE] = ACTIONS(821),
    [anon_sym_LBRACK2] = ACTIONS(3846),
    [anon_sym_TILDE] = ACTIONS(821),
    [anon_sym_CARET] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_LT_DASH] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(821),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_GT_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_CARET] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_or] = ACTIONS(821),
    [sym_none] = ACTIONS(821),
    [sym_true] = ACTIONS(821),
    [sym_false] = ACTIONS(821),
    [sym_nil] = ACTIONS(821),
    [anon_sym_QMARK_DOT] = ACTIONS(821),
    [anon_sym_POUND_LBRACK] = ACTIONS(821),
    [anon_sym_if] = ACTIONS(821),
    [anon_sym_DOLLARif] = ACTIONS(821),
    [anon_sym_is] = ACTIONS(821),
    [anon_sym_BANGis] = ACTIONS(821),
    [anon_sym_in] = ACTIONS(821),
    [anon_sym_BANGin] = ACTIONS(821),
    [anon_sym_match] = ACTIONS(821),
    [anon_sym_select] = ACTIONS(821),
    [anon_sym_lock] = ACTIONS(821),
    [anon_sym_rlock] = ACTIONS(821),
    [anon_sym_unsafe] = ACTIONS(821),
    [anon_sym_sql] = ACTIONS(821),
    [sym_int_literal] = ACTIONS(821),
    [sym_float_literal] = ACTIONS(821),
    [sym_rune_literal] = ACTIONS(821),
    [anon_sym_SQUOTE] = ACTIONS(821),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [anon_sym_c_SQUOTE] = ACTIONS(821),
    [anon_sym_c_DQUOTE] = ACTIONS(821),
    [anon_sym_r_SQUOTE] = ACTIONS(821),
    [anon_sym_r_DQUOTE] = ACTIONS(821),
    [sym_pseudo_compile_time_identifier] = ACTIONS(821),
    [anon_sym_shared] = ACTIONS(3850),
    [anon_sym_map_LBRACK] = ACTIONS(3852),
    [anon_sym_chan] = ACTIONS(3854),
    [anon_sym_thread] = ACTIONS(3856),
    [anon_sym_atomic] = ACTIONS(3858),
  },
  [1119] = {
    [sym_line_comment] = STATE(1119),
    [sym_block_comment] = STATE(1119),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [aux_sym_strictly_expression_list_repeat1] = STATE(1737),
    [ts_builtin_sym_end] = ACTIONS(3862),
    [sym_identifier] = ACTIONS(2041),
    [anon_sym_LF] = ACTIONS(2041),
    [anon_sym_CR] = ACTIONS(2041),
    [anon_sym_CR_LF] = ACTIONS(2041),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(3866),
    [anon_sym_LBRACE] = ACTIONS(2041),
    [anon_sym_COMMA] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(2041),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(2041),
    [anon_sym_type] = ACTIONS(2041),
    [anon_sym_fn] = ACTIONS(2041),
    [anon_sym_PLUS] = ACTIONS(3872),
    [anon_sym_DASH] = ACTIONS(3872),
    [anon_sym_STAR] = ACTIONS(3874),
    [anon_sym_SLASH] = ACTIONS(3874),
    [anon_sym_PERCENT] = ACTIONS(3874),
    [anon_sym_LT] = ACTIONS(3876),
    [anon_sym_GT] = ACTIONS(3876),
    [anon_sym_EQ_EQ] = ACTIONS(3876),
    [anon_sym_BANG_EQ] = ACTIONS(3876),
    [anon_sym_LT_EQ] = ACTIONS(3876),
    [anon_sym_GT_EQ] = ACTIONS(3876),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(2041),
    [anon_sym_union] = ACTIONS(2041),
    [anon_sym_pub] = ACTIONS(2041),
    [anon_sym_mut] = ACTIONS(2041),
    [anon_sym_enum] = ACTIONS(2041),
    [anon_sym_interface] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(3880),
    [anon_sym_DASH_DASH] = ACTIONS(3882),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(2041),
    [anon_sym_spawn] = ACTIONS(2041),
    [anon_sym_json_DOTdecode] = ACTIONS(2041),
    [anon_sym_PIPE] = ACTIONS(3872),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_CARET] = ACTIONS(3872),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym_LT_DASH] = ACTIONS(2041),
    [anon_sym_LT_LT] = ACTIONS(3874),
    [anon_sym_GT_GT] = ACTIONS(3874),
    [anon_sym_GT_GT_GT] = ACTIONS(3874),
    [anon_sym_AMP_CARET] = ACTIONS(3874),
    [anon_sym_AMP_AMP] = ACTIONS(3890),
    [anon_sym_PIPE_PIPE] = ACTIONS(3892),
    [anon_sym_or] = ACTIONS(3894),
    [sym_none] = ACTIONS(2041),
    [sym_true] = ACTIONS(2041),
    [sym_false] = ACTIONS(2041),
    [sym_nil] = ACTIONS(2041),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(2041),
    [anon_sym_DOLLARif] = ACTIONS(2041),
    [anon_sym_is] = ACTIONS(3896),
    [anon_sym_BANGis] = ACTIONS(3896),
    [anon_sym_in] = ACTIONS(3898),
    [anon_sym_BANGin] = ACTIONS(3898),
    [anon_sym_match] = ACTIONS(2041),
    [anon_sym_select] = ACTIONS(2041),
    [anon_sym_lock] = ACTIONS(2041),
    [anon_sym_rlock] = ACTIONS(2041),
    [anon_sym_unsafe] = ACTIONS(2041),
    [anon_sym_sql] = ACTIONS(2041),
    [sym_int_literal] = ACTIONS(2041),
    [sym_float_literal] = ACTIONS(2041),
    [sym_rune_literal] = ACTIONS(2041),
    [anon_sym_SQUOTE] = ACTIONS(2041),
    [anon_sym_DQUOTE] = ACTIONS(2041),
    [anon_sym_c_SQUOTE] = ACTIONS(2041),
    [anon_sym_c_DQUOTE] = ACTIONS(2041),
    [anon_sym_r_SQUOTE] = ACTIONS(2041),
    [anon_sym_r_DQUOTE] = ACTIONS(2041),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2041),
    [anon_sym_shared] = ACTIONS(2041),
    [anon_sym_map_LBRACK] = ACTIONS(2041),
    [anon_sym_chan] = ACTIONS(2041),
    [anon_sym_thread] = ACTIONS(2041),
    [anon_sym_atomic] = ACTIONS(2041),
    [anon_sym_assert] = ACTIONS(2041),
    [anon_sym_defer] = ACTIONS(2041),
    [anon_sym_goto] = ACTIONS(2041),
    [anon_sym_break] = ACTIONS(2041),
    [anon_sym_continue] = ACTIONS(2041),
    [anon_sym_return] = ACTIONS(2041),
    [anon_sym_DOLLARfor] = ACTIONS(2041),
    [anon_sym_for] = ACTIONS(2041),
    [anon_sym_POUND] = ACTIONS(2041),
    [anon_sym_asm] = ACTIONS(2041),
    [anon_sym_AT_LBRACK] = ACTIONS(2041),
  },
  [1120] = {
    [sym_line_comment] = STATE(1120),
    [sym_block_comment] = STATE(1120),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(2055),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_LF] = ACTIONS(2057),
    [anon_sym_CR] = ACTIONS(2057),
    [anon_sym_CR_LF] = ACTIONS(2057),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2057),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_fn] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_PERCENT] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_GT] = ACTIONS(2057),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2057),
    [anon_sym_LT_EQ] = ACTIONS(2057),
    [anon_sym_GT_EQ] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(2057),
    [anon_sym_union] = ACTIONS(2057),
    [anon_sym_pub] = ACTIONS(2057),
    [anon_sym_mut] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(2057),
    [anon_sym_spawn] = ACTIONS(2057),
    [anon_sym_json_DOTdecode] = ACTIONS(2057),
    [anon_sym_PIPE] = ACTIONS(2057),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_CARET] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2057),
    [anon_sym_LT_DASH] = ACTIONS(2057),
    [anon_sym_LT_LT] = ACTIONS(2057),
    [anon_sym_GT_GT] = ACTIONS(2057),
    [anon_sym_GT_GT_GT] = ACTIONS(2057),
    [anon_sym_AMP_CARET] = ACTIONS(2057),
    [anon_sym_AMP_AMP] = ACTIONS(2057),
    [anon_sym_PIPE_PIPE] = ACTIONS(2057),
    [anon_sym_or] = ACTIONS(2057),
    [sym_none] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_nil] = ACTIONS(2057),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_DOLLARif] = ACTIONS(2057),
    [anon_sym_is] = ACTIONS(2057),
    [anon_sym_BANGis] = ACTIONS(2057),
    [anon_sym_in] = ACTIONS(2057),
    [anon_sym_BANGin] = ACTIONS(2057),
    [anon_sym_match] = ACTIONS(2057),
    [anon_sym_select] = ACTIONS(2057),
    [anon_sym_lock] = ACTIONS(2057),
    [anon_sym_rlock] = ACTIONS(2057),
    [anon_sym_unsafe] = ACTIONS(2057),
    [anon_sym_sql] = ACTIONS(2057),
    [sym_int_literal] = ACTIONS(2057),
    [sym_float_literal] = ACTIONS(2057),
    [sym_rune_literal] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_c_SQUOTE] = ACTIONS(2057),
    [anon_sym_c_DQUOTE] = ACTIONS(2057),
    [anon_sym_r_SQUOTE] = ACTIONS(2057),
    [anon_sym_r_DQUOTE] = ACTIONS(2057),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2057),
    [anon_sym_shared] = ACTIONS(2057),
    [anon_sym_map_LBRACK] = ACTIONS(2057),
    [anon_sym_chan] = ACTIONS(2057),
    [anon_sym_thread] = ACTIONS(2057),
    [anon_sym_atomic] = ACTIONS(2057),
    [anon_sym_assert] = ACTIONS(2057),
    [anon_sym_defer] = ACTIONS(2057),
    [anon_sym_goto] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_DOLLARfor] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_POUND] = ACTIONS(2057),
    [anon_sym_asm] = ACTIONS(2057),
    [anon_sym_AT_LBRACK] = ACTIONS(2057),
  },
  [1121] = {
    [sym_line_comment] = STATE(1121),
    [sym_block_comment] = STATE(1121),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(2051),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_const] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(2053),
    [anon_sym_type] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_DASH] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(3874),
    [anon_sym_SLASH] = ACTIONS(3874),
    [anon_sym_PERCENT] = ACTIONS(3874),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_union] = ACTIONS(2053),
    [anon_sym_pub] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_enum] = ACTIONS(2053),
    [anon_sym_interface] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(3874),
    [anon_sym_GT_GT] = ACTIONS(3874),
    [anon_sym_GT_GT_GT] = ACTIONS(3874),
    [anon_sym_AMP_CARET] = ACTIONS(3874),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2053),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
    [anon_sym_AT_LBRACK] = ACTIONS(2053),
  },
  [1122] = {
    [sym_line_comment] = STATE(1122),
    [sym_block_comment] = STATE(1122),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(2067),
    [sym_identifier] = ACTIONS(2069),
    [anon_sym_LF] = ACTIONS(2069),
    [anon_sym_CR] = ACTIONS(2069),
    [anon_sym_CR_LF] = ACTIONS(2069),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(3866),
    [anon_sym_LBRACE] = ACTIONS(2069),
    [anon_sym_COMMA] = ACTIONS(2069),
    [anon_sym_const] = ACTIONS(2069),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(2069),
    [anon_sym_type] = ACTIONS(2069),
    [anon_sym_fn] = ACTIONS(2069),
    [anon_sym_PLUS] = ACTIONS(3872),
    [anon_sym_DASH] = ACTIONS(3872),
    [anon_sym_STAR] = ACTIONS(3874),
    [anon_sym_SLASH] = ACTIONS(3874),
    [anon_sym_PERCENT] = ACTIONS(3874),
    [anon_sym_LT] = ACTIONS(3876),
    [anon_sym_GT] = ACTIONS(3876),
    [anon_sym_EQ_EQ] = ACTIONS(3876),
    [anon_sym_BANG_EQ] = ACTIONS(3876),
    [anon_sym_LT_EQ] = ACTIONS(3876),
    [anon_sym_GT_EQ] = ACTIONS(3876),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(2069),
    [anon_sym_union] = ACTIONS(2069),
    [anon_sym_pub] = ACTIONS(2069),
    [anon_sym_mut] = ACTIONS(2069),
    [anon_sym_enum] = ACTIONS(2069),
    [anon_sym_interface] = ACTIONS(2069),
    [anon_sym_PLUS_PLUS] = ACTIONS(3880),
    [anon_sym_DASH_DASH] = ACTIONS(3882),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(2069),
    [anon_sym_spawn] = ACTIONS(2069),
    [anon_sym_json_DOTdecode] = ACTIONS(2069),
    [anon_sym_PIPE] = ACTIONS(3872),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(2069),
    [anon_sym_CARET] = ACTIONS(3872),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym_LT_DASH] = ACTIONS(2069),
    [anon_sym_LT_LT] = ACTIONS(3874),
    [anon_sym_GT_GT] = ACTIONS(3874),
    [anon_sym_GT_GT_GT] = ACTIONS(3874),
    [anon_sym_AMP_CARET] = ACTIONS(3874),
    [anon_sym_AMP_AMP] = ACTIONS(3890),
    [anon_sym_PIPE_PIPE] = ACTIONS(3892),
    [anon_sym_or] = ACTIONS(3894),
    [sym_none] = ACTIONS(2069),
    [sym_true] = ACTIONS(2069),
    [sym_false] = ACTIONS(2069),
    [sym_nil] = ACTIONS(2069),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(2069),
    [anon_sym_DOLLARif] = ACTIONS(2069),
    [anon_sym_is] = ACTIONS(3900),
    [anon_sym_BANGis] = ACTIONS(3900),
    [anon_sym_in] = ACTIONS(3898),
    [anon_sym_BANGin] = ACTIONS(3898),
    [anon_sym_match] = ACTIONS(2069),
    [anon_sym_select] = ACTIONS(2069),
    [anon_sym_lock] = ACTIONS(2069),
    [anon_sym_rlock] = ACTIONS(2069),
    [anon_sym_unsafe] = ACTIONS(2069),
    [anon_sym_sql] = ACTIONS(2069),
    [sym_int_literal] = ACTIONS(2069),
    [sym_float_literal] = ACTIONS(2069),
    [sym_rune_literal] = ACTIONS(2069),
    [anon_sym_SQUOTE] = ACTIONS(2069),
    [anon_sym_DQUOTE] = ACTIONS(2069),
    [anon_sym_c_SQUOTE] = ACTIONS(2069),
    [anon_sym_c_DQUOTE] = ACTIONS(2069),
    [anon_sym_r_SQUOTE] = ACTIONS(2069),
    [anon_sym_r_DQUOTE] = ACTIONS(2069),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2069),
    [anon_sym_shared] = ACTIONS(2069),
    [anon_sym_map_LBRACK] = ACTIONS(2069),
    [anon_sym_chan] = ACTIONS(2069),
    [anon_sym_thread] = ACTIONS(2069),
    [anon_sym_atomic] = ACTIONS(2069),
    [anon_sym_assert] = ACTIONS(2069),
    [anon_sym_defer] = ACTIONS(2069),
    [anon_sym_goto] = ACTIONS(2069),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_continue] = ACTIONS(2069),
    [anon_sym_return] = ACTIONS(2069),
    [anon_sym_DOLLARfor] = ACTIONS(2069),
    [anon_sym_for] = ACTIONS(2069),
    [anon_sym_POUND] = ACTIONS(2069),
    [anon_sym_asm] = ACTIONS(2069),
    [anon_sym_AT_LBRACK] = ACTIONS(2069),
  },
  [1123] = {
    [sym_line_comment] = STATE(1123),
    [sym_block_comment] = STATE(1123),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(3902),
    [sym_identifier] = ACTIONS(3904),
    [anon_sym_LF] = ACTIONS(3904),
    [anon_sym_CR] = ACTIONS(3904),
    [anon_sym_CR_LF] = ACTIONS(3904),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(3866),
    [anon_sym_LBRACE] = ACTIONS(3904),
    [anon_sym_COMMA] = ACTIONS(3906),
    [anon_sym_const] = ACTIONS(3904),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(3904),
    [anon_sym_type] = ACTIONS(3904),
    [anon_sym_fn] = ACTIONS(3904),
    [anon_sym_PLUS] = ACTIONS(3872),
    [anon_sym_DASH] = ACTIONS(3872),
    [anon_sym_STAR] = ACTIONS(3874),
    [anon_sym_SLASH] = ACTIONS(3874),
    [anon_sym_PERCENT] = ACTIONS(3874),
    [anon_sym_LT] = ACTIONS(3876),
    [anon_sym_GT] = ACTIONS(3876),
    [anon_sym_EQ_EQ] = ACTIONS(3876),
    [anon_sym_BANG_EQ] = ACTIONS(3876),
    [anon_sym_LT_EQ] = ACTIONS(3876),
    [anon_sym_GT_EQ] = ACTIONS(3876),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(3904),
    [anon_sym_union] = ACTIONS(3904),
    [anon_sym_pub] = ACTIONS(3904),
    [anon_sym_mut] = ACTIONS(3904),
    [anon_sym_enum] = ACTIONS(3904),
    [anon_sym_interface] = ACTIONS(3904),
    [anon_sym_PLUS_PLUS] = ACTIONS(3880),
    [anon_sym_DASH_DASH] = ACTIONS(3882),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(3904),
    [anon_sym_spawn] = ACTIONS(3904),
    [anon_sym_json_DOTdecode] = ACTIONS(3904),
    [anon_sym_PIPE] = ACTIONS(3872),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(3904),
    [anon_sym_CARET] = ACTIONS(3872),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym_LT_DASH] = ACTIONS(3904),
    [anon_sym_LT_LT] = ACTIONS(3874),
    [anon_sym_GT_GT] = ACTIONS(3874),
    [anon_sym_GT_GT_GT] = ACTIONS(3874),
    [anon_sym_AMP_CARET] = ACTIONS(3874),
    [anon_sym_AMP_AMP] = ACTIONS(3890),
    [anon_sym_PIPE_PIPE] = ACTIONS(3892),
    [anon_sym_or] = ACTIONS(3894),
    [sym_none] = ACTIONS(3904),
    [sym_true] = ACTIONS(3904),
    [sym_false] = ACTIONS(3904),
    [sym_nil] = ACTIONS(3904),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(3904),
    [anon_sym_DOLLARif] = ACTIONS(3904),
    [anon_sym_is] = ACTIONS(3896),
    [anon_sym_BANGis] = ACTIONS(3896),
    [anon_sym_in] = ACTIONS(3898),
    [anon_sym_BANGin] = ACTIONS(3898),
    [anon_sym_match] = ACTIONS(3904),
    [anon_sym_select] = ACTIONS(3904),
    [anon_sym_lock] = ACTIONS(3904),
    [anon_sym_rlock] = ACTIONS(3904),
    [anon_sym_unsafe] = ACTIONS(3904),
    [anon_sym_sql] = ACTIONS(3904),
    [sym_int_literal] = ACTIONS(3904),
    [sym_float_literal] = ACTIONS(3904),
    [sym_rune_literal] = ACTIONS(3904),
    [anon_sym_SQUOTE] = ACTIONS(3904),
    [anon_sym_DQUOTE] = ACTIONS(3904),
    [anon_sym_c_SQUOTE] = ACTIONS(3904),
    [anon_sym_c_DQUOTE] = ACTIONS(3904),
    [anon_sym_r_SQUOTE] = ACTIONS(3904),
    [anon_sym_r_DQUOTE] = ACTIONS(3904),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3904),
    [anon_sym_shared] = ACTIONS(3904),
    [anon_sym_map_LBRACK] = ACTIONS(3904),
    [anon_sym_chan] = ACTIONS(3904),
    [anon_sym_thread] = ACTIONS(3904),
    [anon_sym_atomic] = ACTIONS(3904),
    [anon_sym_assert] = ACTIONS(3904),
    [anon_sym_defer] = ACTIONS(3904),
    [anon_sym_goto] = ACTIONS(3904),
    [anon_sym_break] = ACTIONS(3904),
    [anon_sym_continue] = ACTIONS(3904),
    [anon_sym_return] = ACTIONS(3904),
    [anon_sym_DOLLARfor] = ACTIONS(3904),
    [anon_sym_for] = ACTIONS(3904),
    [anon_sym_POUND] = ACTIONS(3904),
    [anon_sym_asm] = ACTIONS(3904),
    [anon_sym_AT_LBRACK] = ACTIONS(3904),
  },
  [1124] = {
    [sym_line_comment] = STATE(1124),
    [sym_block_comment] = STATE(1124),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(2047),
    [sym_identifier] = ACTIONS(2049),
    [anon_sym_LF] = ACTIONS(2049),
    [anon_sym_CR] = ACTIONS(2049),
    [anon_sym_CR_LF] = ACTIONS(2049),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(2049),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_const] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(2049),
    [anon_sym_type] = ACTIONS(2049),
    [anon_sym_fn] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(3872),
    [anon_sym_DASH] = ACTIONS(3872),
    [anon_sym_STAR] = ACTIONS(3874),
    [anon_sym_SLASH] = ACTIONS(3874),
    [anon_sym_PERCENT] = ACTIONS(3874),
    [anon_sym_LT] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(2049),
    [anon_sym_union] = ACTIONS(2049),
    [anon_sym_pub] = ACTIONS(2049),
    [anon_sym_mut] = ACTIONS(2049),
    [anon_sym_enum] = ACTIONS(2049),
    [anon_sym_interface] = ACTIONS(2049),
    [anon_sym_PLUS_PLUS] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(2049),
    [anon_sym_spawn] = ACTIONS(2049),
    [anon_sym_json_DOTdecode] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(3872),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(2049),
    [anon_sym_CARET] = ACTIONS(3872),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym_LT_DASH] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(3874),
    [anon_sym_GT_GT] = ACTIONS(3874),
    [anon_sym_GT_GT_GT] = ACTIONS(3874),
    [anon_sym_AMP_CARET] = ACTIONS(3874),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_or] = ACTIONS(2049),
    [sym_none] = ACTIONS(2049),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [sym_nil] = ACTIONS(2049),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(2049),
    [anon_sym_DOLLARif] = ACTIONS(2049),
    [anon_sym_is] = ACTIONS(2049),
    [anon_sym_BANGis] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_BANGin] = ACTIONS(2049),
    [anon_sym_match] = ACTIONS(2049),
    [anon_sym_select] = ACTIONS(2049),
    [anon_sym_lock] = ACTIONS(2049),
    [anon_sym_rlock] = ACTIONS(2049),
    [anon_sym_unsafe] = ACTIONS(2049),
    [anon_sym_sql] = ACTIONS(2049),
    [sym_int_literal] = ACTIONS(2049),
    [sym_float_literal] = ACTIONS(2049),
    [sym_rune_literal] = ACTIONS(2049),
    [anon_sym_SQUOTE] = ACTIONS(2049),
    [anon_sym_DQUOTE] = ACTIONS(2049),
    [anon_sym_c_SQUOTE] = ACTIONS(2049),
    [anon_sym_c_DQUOTE] = ACTIONS(2049),
    [anon_sym_r_SQUOTE] = ACTIONS(2049),
    [anon_sym_r_DQUOTE] = ACTIONS(2049),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2049),
    [anon_sym_shared] = ACTIONS(2049),
    [anon_sym_map_LBRACK] = ACTIONS(2049),
    [anon_sym_chan] = ACTIONS(2049),
    [anon_sym_thread] = ACTIONS(2049),
    [anon_sym_atomic] = ACTIONS(2049),
    [anon_sym_assert] = ACTIONS(2049),
    [anon_sym_defer] = ACTIONS(2049),
    [anon_sym_goto] = ACTIONS(2049),
    [anon_sym_break] = ACTIONS(2049),
    [anon_sym_continue] = ACTIONS(2049),
    [anon_sym_return] = ACTIONS(2049),
    [anon_sym_DOLLARfor] = ACTIONS(2049),
    [anon_sym_for] = ACTIONS(2049),
    [anon_sym_POUND] = ACTIONS(2049),
    [anon_sym_asm] = ACTIONS(2049),
    [anon_sym_AT_LBRACK] = ACTIONS(2049),
  },
  [1125] = {
    [sym_line_comment] = STATE(1125),
    [sym_block_comment] = STATE(1125),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(2051),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_const] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(2053),
    [anon_sym_type] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(3872),
    [anon_sym_DASH] = ACTIONS(3872),
    [anon_sym_STAR] = ACTIONS(3874),
    [anon_sym_SLASH] = ACTIONS(3874),
    [anon_sym_PERCENT] = ACTIONS(3874),
    [anon_sym_LT] = ACTIONS(3876),
    [anon_sym_GT] = ACTIONS(3876),
    [anon_sym_EQ_EQ] = ACTIONS(3876),
    [anon_sym_BANG_EQ] = ACTIONS(3876),
    [anon_sym_LT_EQ] = ACTIONS(3876),
    [anon_sym_GT_EQ] = ACTIONS(3876),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_union] = ACTIONS(2053),
    [anon_sym_pub] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_enum] = ACTIONS(2053),
    [anon_sym_interface] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(3872),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(3872),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(3874),
    [anon_sym_GT_GT] = ACTIONS(3874),
    [anon_sym_GT_GT_GT] = ACTIONS(3874),
    [anon_sym_AMP_CARET] = ACTIONS(3874),
    [anon_sym_AMP_AMP] = ACTIONS(3890),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(3898),
    [anon_sym_BANGin] = ACTIONS(3898),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
    [anon_sym_AT_LBRACK] = ACTIONS(2053),
  },
  [1126] = {
    [sym_line_comment] = STATE(1126),
    [sym_block_comment] = STATE(1126),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(2073),
    [sym_identifier] = ACTIONS(2075),
    [anon_sym_LF] = ACTIONS(2075),
    [anon_sym_CR] = ACTIONS(2075),
    [anon_sym_CR_LF] = ACTIONS(2075),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(3866),
    [anon_sym_LBRACE] = ACTIONS(2075),
    [anon_sym_COMMA] = ACTIONS(2075),
    [anon_sym_const] = ACTIONS(2075),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(2075),
    [anon_sym_type] = ACTIONS(2075),
    [anon_sym_fn] = ACTIONS(2075),
    [anon_sym_PLUS] = ACTIONS(3872),
    [anon_sym_DASH] = ACTIONS(3872),
    [anon_sym_STAR] = ACTIONS(3874),
    [anon_sym_SLASH] = ACTIONS(3874),
    [anon_sym_PERCENT] = ACTIONS(3874),
    [anon_sym_LT] = ACTIONS(3876),
    [anon_sym_GT] = ACTIONS(3876),
    [anon_sym_EQ_EQ] = ACTIONS(3876),
    [anon_sym_BANG_EQ] = ACTIONS(3876),
    [anon_sym_LT_EQ] = ACTIONS(3876),
    [anon_sym_GT_EQ] = ACTIONS(3876),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(2075),
    [anon_sym_union] = ACTIONS(2075),
    [anon_sym_pub] = ACTIONS(2075),
    [anon_sym_mut] = ACTIONS(2075),
    [anon_sym_enum] = ACTIONS(2075),
    [anon_sym_interface] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(3880),
    [anon_sym_DASH_DASH] = ACTIONS(3882),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(2075),
    [anon_sym_spawn] = ACTIONS(2075),
    [anon_sym_json_DOTdecode] = ACTIONS(2075),
    [anon_sym_PIPE] = ACTIONS(3872),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_CARET] = ACTIONS(3872),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym_LT_DASH] = ACTIONS(2075),
    [anon_sym_LT_LT] = ACTIONS(3874),
    [anon_sym_GT_GT] = ACTIONS(3874),
    [anon_sym_GT_GT_GT] = ACTIONS(3874),
    [anon_sym_AMP_CARET] = ACTIONS(3874),
    [anon_sym_AMP_AMP] = ACTIONS(3890),
    [anon_sym_PIPE_PIPE] = ACTIONS(3892),
    [anon_sym_or] = ACTIONS(3894),
    [sym_none] = ACTIONS(2075),
    [sym_true] = ACTIONS(2075),
    [sym_false] = ACTIONS(2075),
    [sym_nil] = ACTIONS(2075),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(2075),
    [anon_sym_DOLLARif] = ACTIONS(2075),
    [anon_sym_is] = ACTIONS(3896),
    [anon_sym_BANGis] = ACTIONS(3896),
    [anon_sym_in] = ACTIONS(3898),
    [anon_sym_BANGin] = ACTIONS(3898),
    [anon_sym_match] = ACTIONS(2075),
    [anon_sym_select] = ACTIONS(2075),
    [anon_sym_lock] = ACTIONS(2075),
    [anon_sym_rlock] = ACTIONS(2075),
    [anon_sym_unsafe] = ACTIONS(2075),
    [anon_sym_sql] = ACTIONS(2075),
    [sym_int_literal] = ACTIONS(2075),
    [sym_float_literal] = ACTIONS(2075),
    [sym_rune_literal] = ACTIONS(2075),
    [anon_sym_SQUOTE] = ACTIONS(2075),
    [anon_sym_DQUOTE] = ACTIONS(2075),
    [anon_sym_c_SQUOTE] = ACTIONS(2075),
    [anon_sym_c_DQUOTE] = ACTIONS(2075),
    [anon_sym_r_SQUOTE] = ACTIONS(2075),
    [anon_sym_r_DQUOTE] = ACTIONS(2075),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2075),
    [anon_sym_shared] = ACTIONS(2075),
    [anon_sym_map_LBRACK] = ACTIONS(2075),
    [anon_sym_chan] = ACTIONS(2075),
    [anon_sym_thread] = ACTIONS(2075),
    [anon_sym_atomic] = ACTIONS(2075),
    [anon_sym_assert] = ACTIONS(2075),
    [anon_sym_defer] = ACTIONS(2075),
    [anon_sym_goto] = ACTIONS(2075),
    [anon_sym_break] = ACTIONS(2075),
    [anon_sym_continue] = ACTIONS(2075),
    [anon_sym_return] = ACTIONS(2075),
    [anon_sym_DOLLARfor] = ACTIONS(2075),
    [anon_sym_for] = ACTIONS(2075),
    [anon_sym_POUND] = ACTIONS(2075),
    [anon_sym_asm] = ACTIONS(2075),
    [anon_sym_AT_LBRACK] = ACTIONS(2075),
  },
  [1127] = {
    [sym_line_comment] = STATE(1127),
    [sym_block_comment] = STATE(1127),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(2051),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_const] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(2053),
    [anon_sym_type] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(3872),
    [anon_sym_DASH] = ACTIONS(3872),
    [anon_sym_STAR] = ACTIONS(3874),
    [anon_sym_SLASH] = ACTIONS(3874),
    [anon_sym_PERCENT] = ACTIONS(3874),
    [anon_sym_LT] = ACTIONS(3876),
    [anon_sym_GT] = ACTIONS(3876),
    [anon_sym_EQ_EQ] = ACTIONS(3876),
    [anon_sym_BANG_EQ] = ACTIONS(3876),
    [anon_sym_LT_EQ] = ACTIONS(3876),
    [anon_sym_GT_EQ] = ACTIONS(3876),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_union] = ACTIONS(2053),
    [anon_sym_pub] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_enum] = ACTIONS(2053),
    [anon_sym_interface] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(3872),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(3872),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(3874),
    [anon_sym_GT_GT] = ACTIONS(3874),
    [anon_sym_GT_GT_GT] = ACTIONS(3874),
    [anon_sym_AMP_CARET] = ACTIONS(3874),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(3898),
    [anon_sym_BANGin] = ACTIONS(3898),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
    [anon_sym_AT_LBRACK] = ACTIONS(2053),
  },
  [1128] = {
    [sym_line_comment] = STATE(1128),
    [sym_block_comment] = STATE(1128),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(2063),
    [sym_identifier] = ACTIONS(2065),
    [anon_sym_LF] = ACTIONS(2065),
    [anon_sym_CR] = ACTIONS(2065),
    [anon_sym_CR_LF] = ACTIONS(2065),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(3866),
    [anon_sym_LBRACE] = ACTIONS(2065),
    [anon_sym_COMMA] = ACTIONS(2065),
    [anon_sym_const] = ACTIONS(2065),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(2065),
    [anon_sym_type] = ACTIONS(2065),
    [anon_sym_fn] = ACTIONS(2065),
    [anon_sym_PLUS] = ACTIONS(3872),
    [anon_sym_DASH] = ACTIONS(3872),
    [anon_sym_STAR] = ACTIONS(3874),
    [anon_sym_SLASH] = ACTIONS(3874),
    [anon_sym_PERCENT] = ACTIONS(3874),
    [anon_sym_LT] = ACTIONS(3876),
    [anon_sym_GT] = ACTIONS(3876),
    [anon_sym_EQ_EQ] = ACTIONS(3876),
    [anon_sym_BANG_EQ] = ACTIONS(3876),
    [anon_sym_LT_EQ] = ACTIONS(3876),
    [anon_sym_GT_EQ] = ACTIONS(3876),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(2065),
    [anon_sym_union] = ACTIONS(2065),
    [anon_sym_pub] = ACTIONS(2065),
    [anon_sym_mut] = ACTIONS(2065),
    [anon_sym_enum] = ACTIONS(2065),
    [anon_sym_interface] = ACTIONS(2065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3880),
    [anon_sym_DASH_DASH] = ACTIONS(3882),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(2065),
    [anon_sym_spawn] = ACTIONS(2065),
    [anon_sym_json_DOTdecode] = ACTIONS(2065),
    [anon_sym_PIPE] = ACTIONS(3872),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(2065),
    [anon_sym_CARET] = ACTIONS(3872),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym_LT_DASH] = ACTIONS(2065),
    [anon_sym_LT_LT] = ACTIONS(3874),
    [anon_sym_GT_GT] = ACTIONS(3874),
    [anon_sym_GT_GT_GT] = ACTIONS(3874),
    [anon_sym_AMP_CARET] = ACTIONS(3874),
    [anon_sym_AMP_AMP] = ACTIONS(3890),
    [anon_sym_PIPE_PIPE] = ACTIONS(3892),
    [anon_sym_or] = ACTIONS(3894),
    [sym_none] = ACTIONS(2065),
    [sym_true] = ACTIONS(2065),
    [sym_false] = ACTIONS(2065),
    [sym_nil] = ACTIONS(2065),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(2065),
    [anon_sym_DOLLARif] = ACTIONS(2065),
    [anon_sym_is] = ACTIONS(3896),
    [anon_sym_BANGis] = ACTIONS(3896),
    [anon_sym_in] = ACTIONS(3898),
    [anon_sym_BANGin] = ACTIONS(3898),
    [anon_sym_match] = ACTIONS(2065),
    [anon_sym_select] = ACTIONS(2065),
    [anon_sym_lock] = ACTIONS(2065),
    [anon_sym_rlock] = ACTIONS(2065),
    [anon_sym_unsafe] = ACTIONS(2065),
    [anon_sym_sql] = ACTIONS(2065),
    [sym_int_literal] = ACTIONS(2065),
    [sym_float_literal] = ACTIONS(2065),
    [sym_rune_literal] = ACTIONS(2065),
    [anon_sym_SQUOTE] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2065),
    [anon_sym_c_SQUOTE] = ACTIONS(2065),
    [anon_sym_c_DQUOTE] = ACTIONS(2065),
    [anon_sym_r_SQUOTE] = ACTIONS(2065),
    [anon_sym_r_DQUOTE] = ACTIONS(2065),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2065),
    [anon_sym_shared] = ACTIONS(2065),
    [anon_sym_map_LBRACK] = ACTIONS(2065),
    [anon_sym_chan] = ACTIONS(2065),
    [anon_sym_thread] = ACTIONS(2065),
    [anon_sym_atomic] = ACTIONS(2065),
    [anon_sym_assert] = ACTIONS(2065),
    [anon_sym_defer] = ACTIONS(2065),
    [anon_sym_goto] = ACTIONS(2065),
    [anon_sym_break] = ACTIONS(2065),
    [anon_sym_continue] = ACTIONS(2065),
    [anon_sym_return] = ACTIONS(2065),
    [anon_sym_DOLLARfor] = ACTIONS(2065),
    [anon_sym_for] = ACTIONS(2065),
    [anon_sym_POUND] = ACTIONS(2065),
    [anon_sym_asm] = ACTIONS(2065),
    [anon_sym_AT_LBRACK] = ACTIONS(2065),
  },
  [1129] = {
    [sym_line_comment] = STATE(1129),
    [sym_block_comment] = STATE(1129),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(2059),
    [sym_identifier] = ACTIONS(2061),
    [anon_sym_LF] = ACTIONS(2061),
    [anon_sym_CR] = ACTIONS(2061),
    [anon_sym_CR_LF] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_LBRACE] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_const] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(2061),
    [anon_sym_type] = ACTIONS(2061),
    [anon_sym_fn] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2061),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(2061),
    [anon_sym_union] = ACTIONS(2061),
    [anon_sym_pub] = ACTIONS(2061),
    [anon_sym_mut] = ACTIONS(2061),
    [anon_sym_enum] = ACTIONS(2061),
    [anon_sym_interface] = ACTIONS(2061),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(2061),
    [anon_sym_spawn] = ACTIONS(2061),
    [anon_sym_json_DOTdecode] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_LT_DASH] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_GT_GT_GT] = ACTIONS(2061),
    [anon_sym_AMP_CARET] = ACTIONS(2061),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [sym_none] = ACTIONS(2061),
    [sym_true] = ACTIONS(2061),
    [sym_false] = ACTIONS(2061),
    [sym_nil] = ACTIONS(2061),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_DOLLARif] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_BANGis] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_BANGin] = ACTIONS(2061),
    [anon_sym_match] = ACTIONS(2061),
    [anon_sym_select] = ACTIONS(2061),
    [anon_sym_lock] = ACTIONS(2061),
    [anon_sym_rlock] = ACTIONS(2061),
    [anon_sym_unsafe] = ACTIONS(2061),
    [anon_sym_sql] = ACTIONS(2061),
    [sym_int_literal] = ACTIONS(2061),
    [sym_float_literal] = ACTIONS(2061),
    [sym_rune_literal] = ACTIONS(2061),
    [anon_sym_SQUOTE] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(2061),
    [anon_sym_c_SQUOTE] = ACTIONS(2061),
    [anon_sym_c_DQUOTE] = ACTIONS(2061),
    [anon_sym_r_SQUOTE] = ACTIONS(2061),
    [anon_sym_r_DQUOTE] = ACTIONS(2061),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2061),
    [anon_sym_shared] = ACTIONS(2061),
    [anon_sym_map_LBRACK] = ACTIONS(2061),
    [anon_sym_chan] = ACTIONS(2061),
    [anon_sym_thread] = ACTIONS(2061),
    [anon_sym_atomic] = ACTIONS(2061),
    [anon_sym_assert] = ACTIONS(2061),
    [anon_sym_defer] = ACTIONS(2061),
    [anon_sym_goto] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2061),
    [anon_sym_continue] = ACTIONS(2061),
    [anon_sym_return] = ACTIONS(2061),
    [anon_sym_DOLLARfor] = ACTIONS(2061),
    [anon_sym_for] = ACTIONS(2061),
    [anon_sym_POUND] = ACTIONS(2061),
    [anon_sym_asm] = ACTIONS(2061),
    [anon_sym_AT_LBRACK] = ACTIONS(2061),
  },
  [1130] = {
    [sym_line_comment] = STATE(1130),
    [sym_block_comment] = STATE(1130),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(2051),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_const] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(2053),
    [anon_sym_type] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(3872),
    [anon_sym_DASH] = ACTIONS(3872),
    [anon_sym_STAR] = ACTIONS(3874),
    [anon_sym_SLASH] = ACTIONS(3874),
    [anon_sym_PERCENT] = ACTIONS(3874),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_union] = ACTIONS(2053),
    [anon_sym_pub] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_enum] = ACTIONS(2053),
    [anon_sym_interface] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(3872),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(3872),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(3874),
    [anon_sym_GT_GT] = ACTIONS(3874),
    [anon_sym_GT_GT_GT] = ACTIONS(3874),
    [anon_sym_AMP_CARET] = ACTIONS(3874),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2053),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
    [anon_sym_AT_LBRACK] = ACTIONS(2053),
  },
  [1131] = {
    [sym_line_comment] = STATE(1131),
    [sym_block_comment] = STATE(1131),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(2051),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_const] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(2053),
    [anon_sym_type] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_DASH] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_SLASH] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_union] = ACTIONS(2053),
    [anon_sym_pub] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_enum] = ACTIONS(2053),
    [anon_sym_interface] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_GT_GT_GT] = ACTIONS(2053),
    [anon_sym_AMP_CARET] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2053),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
    [anon_sym_AT_LBRACK] = ACTIONS(2053),
  },
  [1132] = {
    [sym_line_comment] = STATE(1132),
    [sym_block_comment] = STATE(1132),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(3908),
    [sym_identifier] = ACTIONS(2001),
    [anon_sym_LF] = ACTIONS(2001),
    [anon_sym_CR] = ACTIONS(2001),
    [anon_sym_CR_LF] = ACTIONS(2001),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(3866),
    [anon_sym_LBRACE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(2001),
    [anon_sym_const] = ACTIONS(2001),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(2001),
    [anon_sym_type] = ACTIONS(2001),
    [anon_sym_fn] = ACTIONS(2001),
    [anon_sym_PLUS] = ACTIONS(3872),
    [anon_sym_DASH] = ACTIONS(3872),
    [anon_sym_STAR] = ACTIONS(3874),
    [anon_sym_SLASH] = ACTIONS(3874),
    [anon_sym_PERCENT] = ACTIONS(3874),
    [anon_sym_LT] = ACTIONS(3876),
    [anon_sym_GT] = ACTIONS(3876),
    [anon_sym_EQ_EQ] = ACTIONS(3876),
    [anon_sym_BANG_EQ] = ACTIONS(3876),
    [anon_sym_LT_EQ] = ACTIONS(3876),
    [anon_sym_GT_EQ] = ACTIONS(3876),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(2001),
    [anon_sym_union] = ACTIONS(2001),
    [anon_sym_pub] = ACTIONS(2001),
    [anon_sym_mut] = ACTIONS(2001),
    [anon_sym_enum] = ACTIONS(2001),
    [anon_sym_interface] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(3880),
    [anon_sym_DASH_DASH] = ACTIONS(3882),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(2001),
    [anon_sym_spawn] = ACTIONS(2001),
    [anon_sym_json_DOTdecode] = ACTIONS(2001),
    [anon_sym_PIPE] = ACTIONS(3872),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(2001),
    [anon_sym_CARET] = ACTIONS(3872),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym_LT_DASH] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(3874),
    [anon_sym_GT_GT] = ACTIONS(3874),
    [anon_sym_GT_GT_GT] = ACTIONS(3874),
    [anon_sym_AMP_CARET] = ACTIONS(3874),
    [anon_sym_AMP_AMP] = ACTIONS(3890),
    [anon_sym_PIPE_PIPE] = ACTIONS(3892),
    [anon_sym_or] = ACTIONS(3894),
    [sym_none] = ACTIONS(2001),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_nil] = ACTIONS(2001),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(2001),
    [anon_sym_DOLLARif] = ACTIONS(2001),
    [anon_sym_is] = ACTIONS(3896),
    [anon_sym_BANGis] = ACTIONS(3896),
    [anon_sym_in] = ACTIONS(3898),
    [anon_sym_BANGin] = ACTIONS(3898),
    [anon_sym_match] = ACTIONS(2001),
    [anon_sym_select] = ACTIONS(2001),
    [anon_sym_lock] = ACTIONS(2001),
    [anon_sym_rlock] = ACTIONS(2001),
    [anon_sym_unsafe] = ACTIONS(2001),
    [anon_sym_sql] = ACTIONS(2001),
    [sym_int_literal] = ACTIONS(2001),
    [sym_float_literal] = ACTIONS(2001),
    [sym_rune_literal] = ACTIONS(2001),
    [anon_sym_SQUOTE] = ACTIONS(2001),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_c_SQUOTE] = ACTIONS(2001),
    [anon_sym_c_DQUOTE] = ACTIONS(2001),
    [anon_sym_r_SQUOTE] = ACTIONS(2001),
    [anon_sym_r_DQUOTE] = ACTIONS(2001),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2001),
    [anon_sym_shared] = ACTIONS(2001),
    [anon_sym_map_LBRACK] = ACTIONS(2001),
    [anon_sym_chan] = ACTIONS(2001),
    [anon_sym_thread] = ACTIONS(2001),
    [anon_sym_atomic] = ACTIONS(2001),
    [anon_sym_assert] = ACTIONS(2001),
    [anon_sym_defer] = ACTIONS(2001),
    [anon_sym_goto] = ACTIONS(2001),
    [anon_sym_break] = ACTIONS(2001),
    [anon_sym_continue] = ACTIONS(2001),
    [anon_sym_return] = ACTIONS(2001),
    [anon_sym_DOLLARfor] = ACTIONS(2001),
    [anon_sym_for] = ACTIONS(2001),
    [anon_sym_POUND] = ACTIONS(2001),
    [anon_sym_asm] = ACTIONS(2001),
    [anon_sym_AT_LBRACK] = ACTIONS(2001),
  },
  [1133] = {
    [sym_line_comment] = STATE(1133),
    [sym_block_comment] = STATE(1133),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(3910),
    [sym_identifier] = ACTIONS(3912),
    [anon_sym_LF] = ACTIONS(3912),
    [anon_sym_CR] = ACTIONS(3912),
    [anon_sym_CR_LF] = ACTIONS(3912),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(3866),
    [anon_sym_LBRACE] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(3912),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(3912),
    [anon_sym_type] = ACTIONS(3912),
    [anon_sym_fn] = ACTIONS(3912),
    [anon_sym_PLUS] = ACTIONS(3912),
    [anon_sym_DASH] = ACTIONS(3912),
    [anon_sym_STAR] = ACTIONS(3912),
    [anon_sym_SLASH] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_LT] = ACTIONS(3916),
    [anon_sym_GT] = ACTIONS(3916),
    [anon_sym_EQ_EQ] = ACTIONS(3916),
    [anon_sym_BANG_EQ] = ACTIONS(3916),
    [anon_sym_LT_EQ] = ACTIONS(3916),
    [anon_sym_GT_EQ] = ACTIONS(3916),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(3912),
    [anon_sym_union] = ACTIONS(3912),
    [anon_sym_pub] = ACTIONS(3912),
    [anon_sym_mut] = ACTIONS(3912),
    [anon_sym_enum] = ACTIONS(3912),
    [anon_sym_interface] = ACTIONS(3912),
    [anon_sym_PLUS_PLUS] = ACTIONS(3880),
    [anon_sym_DASH_DASH] = ACTIONS(3882),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(3912),
    [anon_sym_spawn] = ACTIONS(3912),
    [anon_sym_json_DOTdecode] = ACTIONS(3912),
    [anon_sym_PIPE] = ACTIONS(3918),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(3912),
    [anon_sym_CARET] = ACTIONS(3912),
    [anon_sym_AMP] = ACTIONS(3912),
    [anon_sym_LT_DASH] = ACTIONS(3912),
    [anon_sym_LT_LT] = ACTIONS(3914),
    [anon_sym_GT_GT] = ACTIONS(3914),
    [anon_sym_GT_GT_GT] = ACTIONS(3914),
    [anon_sym_AMP_CARET] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(3920),
    [anon_sym_PIPE_PIPE] = ACTIONS(3922),
    [anon_sym_or] = ACTIONS(3894),
    [sym_none] = ACTIONS(3912),
    [sym_true] = ACTIONS(3912),
    [sym_false] = ACTIONS(3912),
    [sym_nil] = ACTIONS(3912),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(3912),
    [anon_sym_DOLLARif] = ACTIONS(3912),
    [anon_sym_is] = ACTIONS(3896),
    [anon_sym_BANGis] = ACTIONS(3896),
    [anon_sym_in] = ACTIONS(3924),
    [anon_sym_BANGin] = ACTIONS(3924),
    [anon_sym_match] = ACTIONS(3912),
    [anon_sym_select] = ACTIONS(3912),
    [anon_sym_lock] = ACTIONS(3912),
    [anon_sym_rlock] = ACTIONS(3912),
    [anon_sym_unsafe] = ACTIONS(3912),
    [anon_sym_sql] = ACTIONS(3912),
    [sym_int_literal] = ACTIONS(3912),
    [sym_float_literal] = ACTIONS(3912),
    [sym_rune_literal] = ACTIONS(3912),
    [anon_sym_SQUOTE] = ACTIONS(3912),
    [anon_sym_DQUOTE] = ACTIONS(3912),
    [anon_sym_c_SQUOTE] = ACTIONS(3912),
    [anon_sym_c_DQUOTE] = ACTIONS(3912),
    [anon_sym_r_SQUOTE] = ACTIONS(3912),
    [anon_sym_r_DQUOTE] = ACTIONS(3912),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3912),
    [anon_sym_shared] = ACTIONS(3912),
    [anon_sym_map_LBRACK] = ACTIONS(3912),
    [anon_sym_chan] = ACTIONS(3912),
    [anon_sym_thread] = ACTIONS(3912),
    [anon_sym_atomic] = ACTIONS(3912),
    [anon_sym_assert] = ACTIONS(3912),
    [anon_sym_defer] = ACTIONS(3912),
    [anon_sym_goto] = ACTIONS(3912),
    [anon_sym_break] = ACTIONS(3912),
    [anon_sym_continue] = ACTIONS(3912),
    [anon_sym_return] = ACTIONS(3912),
    [anon_sym_DOLLARfor] = ACTIONS(3912),
    [anon_sym_for] = ACTIONS(3912),
    [anon_sym_POUND] = ACTIONS(3912),
    [anon_sym_asm] = ACTIONS(3912),
    [anon_sym_AT_LBRACK] = ACTIONS(3912),
  },
  [1134] = {
    [sym_line_comment] = STATE(1134),
    [sym_block_comment] = STATE(1134),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(2073),
    [sym_identifier] = ACTIONS(2075),
    [anon_sym_LF] = ACTIONS(2075),
    [anon_sym_CR] = ACTIONS(2075),
    [anon_sym_CR_LF] = ACTIONS(2075),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(3866),
    [anon_sym_LBRACE] = ACTIONS(2075),
    [anon_sym_const] = ACTIONS(2075),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(2075),
    [anon_sym_type] = ACTIONS(2075),
    [anon_sym_fn] = ACTIONS(2075),
    [anon_sym_PLUS] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3918),
    [anon_sym_STAR] = ACTIONS(3914),
    [anon_sym_SLASH] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_LT] = ACTIONS(3916),
    [anon_sym_GT] = ACTIONS(3916),
    [anon_sym_EQ_EQ] = ACTIONS(3916),
    [anon_sym_BANG_EQ] = ACTIONS(3916),
    [anon_sym_LT_EQ] = ACTIONS(3916),
    [anon_sym_GT_EQ] = ACTIONS(3916),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(2075),
    [anon_sym_union] = ACTIONS(2075),
    [anon_sym_pub] = ACTIONS(2075),
    [anon_sym_mut] = ACTIONS(2075),
    [anon_sym_enum] = ACTIONS(2075),
    [anon_sym_interface] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(3880),
    [anon_sym_DASH_DASH] = ACTIONS(3882),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(2075),
    [anon_sym_spawn] = ACTIONS(2075),
    [anon_sym_json_DOTdecode] = ACTIONS(2075),
    [anon_sym_PIPE] = ACTIONS(3918),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_CARET] = ACTIONS(3918),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(2075),
    [anon_sym_LT_LT] = ACTIONS(3914),
    [anon_sym_GT_GT] = ACTIONS(3914),
    [anon_sym_GT_GT_GT] = ACTIONS(3914),
    [anon_sym_AMP_CARET] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(3920),
    [anon_sym_PIPE_PIPE] = ACTIONS(3922),
    [anon_sym_or] = ACTIONS(3894),
    [sym_none] = ACTIONS(2075),
    [sym_true] = ACTIONS(2075),
    [sym_false] = ACTIONS(2075),
    [sym_nil] = ACTIONS(2075),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(2075),
    [anon_sym_DOLLARif] = ACTIONS(2075),
    [anon_sym_is] = ACTIONS(3896),
    [anon_sym_BANGis] = ACTIONS(3896),
    [anon_sym_in] = ACTIONS(3924),
    [anon_sym_BANGin] = ACTIONS(3924),
    [anon_sym_match] = ACTIONS(2075),
    [anon_sym_select] = ACTIONS(2075),
    [anon_sym_lock] = ACTIONS(2075),
    [anon_sym_rlock] = ACTIONS(2075),
    [anon_sym_unsafe] = ACTIONS(2075),
    [anon_sym_sql] = ACTIONS(2075),
    [sym_int_literal] = ACTIONS(2075),
    [sym_float_literal] = ACTIONS(2075),
    [sym_rune_literal] = ACTIONS(2075),
    [anon_sym_SQUOTE] = ACTIONS(2075),
    [anon_sym_DQUOTE] = ACTIONS(2075),
    [anon_sym_c_SQUOTE] = ACTIONS(2075),
    [anon_sym_c_DQUOTE] = ACTIONS(2075),
    [anon_sym_r_SQUOTE] = ACTIONS(2075),
    [anon_sym_r_DQUOTE] = ACTIONS(2075),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2075),
    [anon_sym_shared] = ACTIONS(2075),
    [anon_sym_map_LBRACK] = ACTIONS(2075),
    [anon_sym_chan] = ACTIONS(2075),
    [anon_sym_thread] = ACTIONS(2075),
    [anon_sym_atomic] = ACTIONS(2075),
    [anon_sym_assert] = ACTIONS(2075),
    [anon_sym_defer] = ACTIONS(2075),
    [anon_sym_goto] = ACTIONS(2075),
    [anon_sym_break] = ACTIONS(2075),
    [anon_sym_continue] = ACTIONS(2075),
    [anon_sym_return] = ACTIONS(2075),
    [anon_sym_DOLLARfor] = ACTIONS(2075),
    [anon_sym_for] = ACTIONS(2075),
    [anon_sym_POUND] = ACTIONS(2075),
    [anon_sym_asm] = ACTIONS(2075),
    [anon_sym_AT_LBRACK] = ACTIONS(2075),
  },
  [1135] = {
    [sym_line_comment] = STATE(1135),
    [sym_block_comment] = STATE(1135),
    [sym_else_branch] = STATE(1187),
    [ts_builtin_sym_end] = ACTIONS(2081),
    [sym_identifier] = ACTIONS(2083),
    [anon_sym_LF] = ACTIONS(2083),
    [anon_sym_CR] = ACTIONS(2083),
    [anon_sym_CR_LF] = ACTIONS(2083),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2083),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(2083),
    [anon_sym_COMMA] = ACTIONS(2083),
    [anon_sym_const] = ACTIONS(2083),
    [anon_sym_LPAREN] = ACTIONS(2083),
    [anon_sym___global] = ACTIONS(2083),
    [anon_sym_type] = ACTIONS(2083),
    [anon_sym_fn] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2083),
    [anon_sym_SLASH] = ACTIONS(2083),
    [anon_sym_PERCENT] = ACTIONS(2083),
    [anon_sym_LT] = ACTIONS(2083),
    [anon_sym_GT] = ACTIONS(2083),
    [anon_sym_EQ_EQ] = ACTIONS(2083),
    [anon_sym_BANG_EQ] = ACTIONS(2083),
    [anon_sym_LT_EQ] = ACTIONS(2083),
    [anon_sym_GT_EQ] = ACTIONS(2083),
    [anon_sym_LBRACK] = ACTIONS(2081),
    [anon_sym_struct] = ACTIONS(2083),
    [anon_sym_union] = ACTIONS(2083),
    [anon_sym_pub] = ACTIONS(2083),
    [anon_sym_mut] = ACTIONS(2083),
    [anon_sym_enum] = ACTIONS(2083),
    [anon_sym_interface] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_QMARK] = ACTIONS(2083),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_go] = ACTIONS(2083),
    [anon_sym_spawn] = ACTIONS(2083),
    [anon_sym_json_DOTdecode] = ACTIONS(2083),
    [anon_sym_PIPE] = ACTIONS(2083),
    [anon_sym_LBRACK2] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_LT_DASH] = ACTIONS(2083),
    [anon_sym_LT_LT] = ACTIONS(2083),
    [anon_sym_GT_GT] = ACTIONS(2083),
    [anon_sym_GT_GT_GT] = ACTIONS(2083),
    [anon_sym_AMP_CARET] = ACTIONS(2083),
    [anon_sym_AMP_AMP] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(2083),
    [anon_sym_or] = ACTIONS(2083),
    [sym_none] = ACTIONS(2083),
    [sym_true] = ACTIONS(2083),
    [sym_false] = ACTIONS(2083),
    [sym_nil] = ACTIONS(2083),
    [anon_sym_QMARK_DOT] = ACTIONS(2083),
    [anon_sym_POUND_LBRACK] = ACTIONS(2083),
    [anon_sym_if] = ACTIONS(2083),
    [anon_sym_else] = ACTIONS(3926),
    [anon_sym_DOLLARif] = ACTIONS(2083),
    [anon_sym_is] = ACTIONS(2083),
    [anon_sym_BANGis] = ACTIONS(2083),
    [anon_sym_in] = ACTIONS(2083),
    [anon_sym_BANGin] = ACTIONS(2083),
    [anon_sym_match] = ACTIONS(2083),
    [anon_sym_select] = ACTIONS(2083),
    [anon_sym_lock] = ACTIONS(2083),
    [anon_sym_rlock] = ACTIONS(2083),
    [anon_sym_unsafe] = ACTIONS(2083),
    [anon_sym_sql] = ACTIONS(2083),
    [sym_int_literal] = ACTIONS(2083),
    [sym_float_literal] = ACTIONS(2083),
    [sym_rune_literal] = ACTIONS(2083),
    [anon_sym_SQUOTE] = ACTIONS(2083),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_c_SQUOTE] = ACTIONS(2083),
    [anon_sym_c_DQUOTE] = ACTIONS(2083),
    [anon_sym_r_SQUOTE] = ACTIONS(2083),
    [anon_sym_r_DQUOTE] = ACTIONS(2083),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2083),
    [anon_sym_shared] = ACTIONS(2083),
    [anon_sym_map_LBRACK] = ACTIONS(2083),
    [anon_sym_chan] = ACTIONS(2083),
    [anon_sym_thread] = ACTIONS(2083),
    [anon_sym_atomic] = ACTIONS(2083),
    [anon_sym_assert] = ACTIONS(2083),
    [anon_sym_defer] = ACTIONS(2083),
    [anon_sym_goto] = ACTIONS(2083),
    [anon_sym_break] = ACTIONS(2083),
    [anon_sym_continue] = ACTIONS(2083),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_DOLLARfor] = ACTIONS(2083),
    [anon_sym_for] = ACTIONS(2083),
    [anon_sym_POUND] = ACTIONS(2083),
    [anon_sym_asm] = ACTIONS(2083),
    [anon_sym_AT_LBRACK] = ACTIONS(2083),
  },
  [1136] = {
    [sym_line_comment] = STATE(1136),
    [sym_block_comment] = STATE(1136),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(3928),
    [sym_identifier] = ACTIONS(3930),
    [anon_sym_LF] = ACTIONS(3930),
    [anon_sym_CR] = ACTIONS(3930),
    [anon_sym_CR_LF] = ACTIONS(3930),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(3866),
    [anon_sym_LBRACE] = ACTIONS(3930),
    [anon_sym_const] = ACTIONS(3930),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(3930),
    [anon_sym_type] = ACTIONS(3930),
    [anon_sym_fn] = ACTIONS(3930),
    [anon_sym_PLUS] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3918),
    [anon_sym_STAR] = ACTIONS(3914),
    [anon_sym_SLASH] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_LT] = ACTIONS(3916),
    [anon_sym_GT] = ACTIONS(3916),
    [anon_sym_EQ_EQ] = ACTIONS(3916),
    [anon_sym_BANG_EQ] = ACTIONS(3916),
    [anon_sym_LT_EQ] = ACTIONS(3916),
    [anon_sym_GT_EQ] = ACTIONS(3916),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(3930),
    [anon_sym_union] = ACTIONS(3930),
    [anon_sym_pub] = ACTIONS(3930),
    [anon_sym_mut] = ACTIONS(3930),
    [anon_sym_enum] = ACTIONS(3930),
    [anon_sym_interface] = ACTIONS(3930),
    [anon_sym_PLUS_PLUS] = ACTIONS(3880),
    [anon_sym_DASH_DASH] = ACTIONS(3882),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(3930),
    [anon_sym_spawn] = ACTIONS(3930),
    [anon_sym_json_DOTdecode] = ACTIONS(3930),
    [anon_sym_PIPE] = ACTIONS(3918),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(3930),
    [anon_sym_CARET] = ACTIONS(3918),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(3930),
    [anon_sym_LT_LT] = ACTIONS(3914),
    [anon_sym_GT_GT] = ACTIONS(3914),
    [anon_sym_GT_GT_GT] = ACTIONS(3914),
    [anon_sym_AMP_CARET] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(3920),
    [anon_sym_PIPE_PIPE] = ACTIONS(3922),
    [anon_sym_or] = ACTIONS(3894),
    [sym_none] = ACTIONS(3930),
    [sym_true] = ACTIONS(3930),
    [sym_false] = ACTIONS(3930),
    [sym_nil] = ACTIONS(3930),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(3930),
    [anon_sym_DOLLARif] = ACTIONS(3930),
    [anon_sym_is] = ACTIONS(3896),
    [anon_sym_BANGis] = ACTIONS(3896),
    [anon_sym_in] = ACTIONS(3924),
    [anon_sym_BANGin] = ACTIONS(3924),
    [anon_sym_match] = ACTIONS(3930),
    [anon_sym_select] = ACTIONS(3930),
    [anon_sym_lock] = ACTIONS(3930),
    [anon_sym_rlock] = ACTIONS(3930),
    [anon_sym_unsafe] = ACTIONS(3930),
    [anon_sym_sql] = ACTIONS(3930),
    [sym_int_literal] = ACTIONS(3930),
    [sym_float_literal] = ACTIONS(3930),
    [sym_rune_literal] = ACTIONS(3930),
    [anon_sym_SQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [anon_sym_c_SQUOTE] = ACTIONS(3930),
    [anon_sym_c_DQUOTE] = ACTIONS(3930),
    [anon_sym_r_SQUOTE] = ACTIONS(3930),
    [anon_sym_r_DQUOTE] = ACTIONS(3930),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3930),
    [anon_sym_shared] = ACTIONS(3930),
    [anon_sym_map_LBRACK] = ACTIONS(3930),
    [anon_sym_chan] = ACTIONS(3930),
    [anon_sym_thread] = ACTIONS(3930),
    [anon_sym_atomic] = ACTIONS(3930),
    [anon_sym_assert] = ACTIONS(3930),
    [anon_sym_defer] = ACTIONS(3930),
    [anon_sym_goto] = ACTIONS(3930),
    [anon_sym_break] = ACTIONS(3930),
    [anon_sym_continue] = ACTIONS(3930),
    [anon_sym_return] = ACTIONS(3930),
    [anon_sym_DOLLARfor] = ACTIONS(3930),
    [anon_sym_for] = ACTIONS(3930),
    [anon_sym_POUND] = ACTIONS(3930),
    [anon_sym_asm] = ACTIONS(3930),
    [anon_sym_AT_LBRACK] = ACTIONS(3930),
  },
  [1137] = {
    [sym_line_comment] = STATE(1137),
    [sym_block_comment] = STATE(1137),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(2063),
    [sym_identifier] = ACTIONS(2065),
    [anon_sym_LF] = ACTIONS(2065),
    [anon_sym_CR] = ACTIONS(2065),
    [anon_sym_CR_LF] = ACTIONS(2065),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(3866),
    [anon_sym_LBRACE] = ACTIONS(2065),
    [anon_sym_const] = ACTIONS(2065),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(2065),
    [anon_sym_type] = ACTIONS(2065),
    [anon_sym_fn] = ACTIONS(2065),
    [anon_sym_PLUS] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3918),
    [anon_sym_STAR] = ACTIONS(3914),
    [anon_sym_SLASH] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_LT] = ACTIONS(3916),
    [anon_sym_GT] = ACTIONS(3916),
    [anon_sym_EQ_EQ] = ACTIONS(3916),
    [anon_sym_BANG_EQ] = ACTIONS(3916),
    [anon_sym_LT_EQ] = ACTIONS(3916),
    [anon_sym_GT_EQ] = ACTIONS(3916),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(2065),
    [anon_sym_union] = ACTIONS(2065),
    [anon_sym_pub] = ACTIONS(2065),
    [anon_sym_mut] = ACTIONS(2065),
    [anon_sym_enum] = ACTIONS(2065),
    [anon_sym_interface] = ACTIONS(2065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3880),
    [anon_sym_DASH_DASH] = ACTIONS(3882),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(2065),
    [anon_sym_spawn] = ACTIONS(2065),
    [anon_sym_json_DOTdecode] = ACTIONS(2065),
    [anon_sym_PIPE] = ACTIONS(3918),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(2065),
    [anon_sym_CARET] = ACTIONS(3918),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(2065),
    [anon_sym_LT_LT] = ACTIONS(3914),
    [anon_sym_GT_GT] = ACTIONS(3914),
    [anon_sym_GT_GT_GT] = ACTIONS(3914),
    [anon_sym_AMP_CARET] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(3920),
    [anon_sym_PIPE_PIPE] = ACTIONS(3922),
    [anon_sym_or] = ACTIONS(3894),
    [sym_none] = ACTIONS(2065),
    [sym_true] = ACTIONS(2065),
    [sym_false] = ACTIONS(2065),
    [sym_nil] = ACTIONS(2065),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(2065),
    [anon_sym_DOLLARif] = ACTIONS(2065),
    [anon_sym_is] = ACTIONS(3896),
    [anon_sym_BANGis] = ACTIONS(3896),
    [anon_sym_in] = ACTIONS(3924),
    [anon_sym_BANGin] = ACTIONS(3924),
    [anon_sym_match] = ACTIONS(2065),
    [anon_sym_select] = ACTIONS(2065),
    [anon_sym_lock] = ACTIONS(2065),
    [anon_sym_rlock] = ACTIONS(2065),
    [anon_sym_unsafe] = ACTIONS(2065),
    [anon_sym_sql] = ACTIONS(2065),
    [sym_int_literal] = ACTIONS(2065),
    [sym_float_literal] = ACTIONS(2065),
    [sym_rune_literal] = ACTIONS(2065),
    [anon_sym_SQUOTE] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2065),
    [anon_sym_c_SQUOTE] = ACTIONS(2065),
    [anon_sym_c_DQUOTE] = ACTIONS(2065),
    [anon_sym_r_SQUOTE] = ACTIONS(2065),
    [anon_sym_r_DQUOTE] = ACTIONS(2065),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2065),
    [anon_sym_shared] = ACTIONS(2065),
    [anon_sym_map_LBRACK] = ACTIONS(2065),
    [anon_sym_chan] = ACTIONS(2065),
    [anon_sym_thread] = ACTIONS(2065),
    [anon_sym_atomic] = ACTIONS(2065),
    [anon_sym_assert] = ACTIONS(2065),
    [anon_sym_defer] = ACTIONS(2065),
    [anon_sym_goto] = ACTIONS(2065),
    [anon_sym_break] = ACTIONS(2065),
    [anon_sym_continue] = ACTIONS(2065),
    [anon_sym_return] = ACTIONS(2065),
    [anon_sym_DOLLARfor] = ACTIONS(2065),
    [anon_sym_for] = ACTIONS(2065),
    [anon_sym_POUND] = ACTIONS(2065),
    [anon_sym_asm] = ACTIONS(2065),
    [anon_sym_AT_LBRACK] = ACTIONS(2065),
  },
  [1138] = {
    [sym_line_comment] = STATE(1138),
    [sym_block_comment] = STATE(1138),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(2047),
    [sym_identifier] = ACTIONS(2049),
    [anon_sym_LF] = ACTIONS(2049),
    [anon_sym_CR] = ACTIONS(2049),
    [anon_sym_CR_LF] = ACTIONS(2049),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(2049),
    [anon_sym_const] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(2049),
    [anon_sym_type] = ACTIONS(2049),
    [anon_sym_fn] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3918),
    [anon_sym_STAR] = ACTIONS(3914),
    [anon_sym_SLASH] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_LT] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(2049),
    [anon_sym_union] = ACTIONS(2049),
    [anon_sym_pub] = ACTIONS(2049),
    [anon_sym_mut] = ACTIONS(2049),
    [anon_sym_enum] = ACTIONS(2049),
    [anon_sym_interface] = ACTIONS(2049),
    [anon_sym_PLUS_PLUS] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(2049),
    [anon_sym_spawn] = ACTIONS(2049),
    [anon_sym_json_DOTdecode] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(3918),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(2049),
    [anon_sym_CARET] = ACTIONS(3918),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(3914),
    [anon_sym_GT_GT] = ACTIONS(3914),
    [anon_sym_GT_GT_GT] = ACTIONS(3914),
    [anon_sym_AMP_CARET] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_or] = ACTIONS(2049),
    [sym_none] = ACTIONS(2049),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [sym_nil] = ACTIONS(2049),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(2049),
    [anon_sym_DOLLARif] = ACTIONS(2049),
    [anon_sym_is] = ACTIONS(2049),
    [anon_sym_BANGis] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_BANGin] = ACTIONS(2049),
    [anon_sym_match] = ACTIONS(2049),
    [anon_sym_select] = ACTIONS(2049),
    [anon_sym_lock] = ACTIONS(2049),
    [anon_sym_rlock] = ACTIONS(2049),
    [anon_sym_unsafe] = ACTIONS(2049),
    [anon_sym_sql] = ACTIONS(2049),
    [sym_int_literal] = ACTIONS(2049),
    [sym_float_literal] = ACTIONS(2049),
    [sym_rune_literal] = ACTIONS(2049),
    [anon_sym_SQUOTE] = ACTIONS(2049),
    [anon_sym_DQUOTE] = ACTIONS(2049),
    [anon_sym_c_SQUOTE] = ACTIONS(2049),
    [anon_sym_c_DQUOTE] = ACTIONS(2049),
    [anon_sym_r_SQUOTE] = ACTIONS(2049),
    [anon_sym_r_DQUOTE] = ACTIONS(2049),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2049),
    [anon_sym_shared] = ACTIONS(2049),
    [anon_sym_map_LBRACK] = ACTIONS(2049),
    [anon_sym_chan] = ACTIONS(2049),
    [anon_sym_thread] = ACTIONS(2049),
    [anon_sym_atomic] = ACTIONS(2049),
    [anon_sym_assert] = ACTIONS(2049),
    [anon_sym_defer] = ACTIONS(2049),
    [anon_sym_goto] = ACTIONS(2049),
    [anon_sym_break] = ACTIONS(2049),
    [anon_sym_continue] = ACTIONS(2049),
    [anon_sym_return] = ACTIONS(2049),
    [anon_sym_DOLLARfor] = ACTIONS(2049),
    [anon_sym_for] = ACTIONS(2049),
    [anon_sym_POUND] = ACTIONS(2049),
    [anon_sym_asm] = ACTIONS(2049),
    [anon_sym_AT_LBRACK] = ACTIONS(2049),
  },
  [1139] = {
    [sym_line_comment] = STATE(1139),
    [sym_block_comment] = STATE(1139),
    [sym_else_branch] = STATE(1188),
    [ts_builtin_sym_end] = ACTIONS(2087),
    [sym_identifier] = ACTIONS(2089),
    [anon_sym_LF] = ACTIONS(2089),
    [anon_sym_CR] = ACTIONS(2089),
    [anon_sym_CR_LF] = ACTIONS(2089),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2089),
    [anon_sym_as] = ACTIONS(2089),
    [anon_sym_LBRACE] = ACTIONS(2089),
    [anon_sym_COMMA] = ACTIONS(2089),
    [anon_sym_const] = ACTIONS(2089),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym___global] = ACTIONS(2089),
    [anon_sym_type] = ACTIONS(2089),
    [anon_sym_fn] = ACTIONS(2089),
    [anon_sym_PLUS] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2089),
    [anon_sym_SLASH] = ACTIONS(2089),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_LT] = ACTIONS(2089),
    [anon_sym_GT] = ACTIONS(2089),
    [anon_sym_EQ_EQ] = ACTIONS(2089),
    [anon_sym_BANG_EQ] = ACTIONS(2089),
    [anon_sym_LT_EQ] = ACTIONS(2089),
    [anon_sym_GT_EQ] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2087),
    [anon_sym_struct] = ACTIONS(2089),
    [anon_sym_union] = ACTIONS(2089),
    [anon_sym_pub] = ACTIONS(2089),
    [anon_sym_mut] = ACTIONS(2089),
    [anon_sym_enum] = ACTIONS(2089),
    [anon_sym_interface] = ACTIONS(2089),
    [anon_sym_PLUS_PLUS] = ACTIONS(2089),
    [anon_sym_DASH_DASH] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2089),
    [anon_sym_BANG] = ACTIONS(2089),
    [anon_sym_go] = ACTIONS(2089),
    [anon_sym_spawn] = ACTIONS(2089),
    [anon_sym_json_DOTdecode] = ACTIONS(2089),
    [anon_sym_PIPE] = ACTIONS(2089),
    [anon_sym_LBRACK2] = ACTIONS(2089),
    [anon_sym_TILDE] = ACTIONS(2089),
    [anon_sym_CARET] = ACTIONS(2089),
    [anon_sym_AMP] = ACTIONS(2089),
    [anon_sym_LT_DASH] = ACTIONS(2089),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_GT_GT] = ACTIONS(2089),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_AMP_CARET] = ACTIONS(2089),
    [anon_sym_AMP_AMP] = ACTIONS(2089),
    [anon_sym_PIPE_PIPE] = ACTIONS(2089),
    [anon_sym_or] = ACTIONS(2089),
    [sym_none] = ACTIONS(2089),
    [sym_true] = ACTIONS(2089),
    [sym_false] = ACTIONS(2089),
    [sym_nil] = ACTIONS(2089),
    [anon_sym_QMARK_DOT] = ACTIONS(2089),
    [anon_sym_POUND_LBRACK] = ACTIONS(2089),
    [anon_sym_if] = ACTIONS(2089),
    [anon_sym_else] = ACTIONS(3926),
    [anon_sym_DOLLARif] = ACTIONS(2089),
    [anon_sym_is] = ACTIONS(2089),
    [anon_sym_BANGis] = ACTIONS(2089),
    [anon_sym_in] = ACTIONS(2089),
    [anon_sym_BANGin] = ACTIONS(2089),
    [anon_sym_match] = ACTIONS(2089),
    [anon_sym_select] = ACTIONS(2089),
    [anon_sym_lock] = ACTIONS(2089),
    [anon_sym_rlock] = ACTIONS(2089),
    [anon_sym_unsafe] = ACTIONS(2089),
    [anon_sym_sql] = ACTIONS(2089),
    [sym_int_literal] = ACTIONS(2089),
    [sym_float_literal] = ACTIONS(2089),
    [sym_rune_literal] = ACTIONS(2089),
    [anon_sym_SQUOTE] = ACTIONS(2089),
    [anon_sym_DQUOTE] = ACTIONS(2089),
    [anon_sym_c_SQUOTE] = ACTIONS(2089),
    [anon_sym_c_DQUOTE] = ACTIONS(2089),
    [anon_sym_r_SQUOTE] = ACTIONS(2089),
    [anon_sym_r_DQUOTE] = ACTIONS(2089),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2089),
    [anon_sym_shared] = ACTIONS(2089),
    [anon_sym_map_LBRACK] = ACTIONS(2089),
    [anon_sym_chan] = ACTIONS(2089),
    [anon_sym_thread] = ACTIONS(2089),
    [anon_sym_atomic] = ACTIONS(2089),
    [anon_sym_assert] = ACTIONS(2089),
    [anon_sym_defer] = ACTIONS(2089),
    [anon_sym_goto] = ACTIONS(2089),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_continue] = ACTIONS(2089),
    [anon_sym_return] = ACTIONS(2089),
    [anon_sym_DOLLARfor] = ACTIONS(2089),
    [anon_sym_for] = ACTIONS(2089),
    [anon_sym_POUND] = ACTIONS(2089),
    [anon_sym_asm] = ACTIONS(2089),
    [anon_sym_AT_LBRACK] = ACTIONS(2089),
  },
  [1140] = {
    [sym_line_comment] = STATE(1140),
    [sym_block_comment] = STATE(1140),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(3932),
    [sym_identifier] = ACTIONS(3934),
    [anon_sym_LF] = ACTIONS(3934),
    [anon_sym_CR] = ACTIONS(3934),
    [anon_sym_CR_LF] = ACTIONS(3934),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(3866),
    [anon_sym_LBRACE] = ACTIONS(3934),
    [anon_sym_const] = ACTIONS(3934),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(3934),
    [anon_sym_type] = ACTIONS(3934),
    [anon_sym_fn] = ACTIONS(3934),
    [anon_sym_PLUS] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3918),
    [anon_sym_STAR] = ACTIONS(3914),
    [anon_sym_SLASH] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_LT] = ACTIONS(3916),
    [anon_sym_GT] = ACTIONS(3916),
    [anon_sym_EQ_EQ] = ACTIONS(3916),
    [anon_sym_BANG_EQ] = ACTIONS(3916),
    [anon_sym_LT_EQ] = ACTIONS(3916),
    [anon_sym_GT_EQ] = ACTIONS(3916),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(3934),
    [anon_sym_union] = ACTIONS(3934),
    [anon_sym_pub] = ACTIONS(3934),
    [anon_sym_mut] = ACTIONS(3934),
    [anon_sym_enum] = ACTIONS(3934),
    [anon_sym_interface] = ACTIONS(3934),
    [anon_sym_PLUS_PLUS] = ACTIONS(3880),
    [anon_sym_DASH_DASH] = ACTIONS(3882),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(3934),
    [anon_sym_spawn] = ACTIONS(3934),
    [anon_sym_json_DOTdecode] = ACTIONS(3934),
    [anon_sym_PIPE] = ACTIONS(3918),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(3934),
    [anon_sym_CARET] = ACTIONS(3918),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(3934),
    [anon_sym_LT_LT] = ACTIONS(3914),
    [anon_sym_GT_GT] = ACTIONS(3914),
    [anon_sym_GT_GT_GT] = ACTIONS(3914),
    [anon_sym_AMP_CARET] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(3920),
    [anon_sym_PIPE_PIPE] = ACTIONS(3922),
    [anon_sym_or] = ACTIONS(3894),
    [sym_none] = ACTIONS(3934),
    [sym_true] = ACTIONS(3934),
    [sym_false] = ACTIONS(3934),
    [sym_nil] = ACTIONS(3934),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(3934),
    [anon_sym_DOLLARif] = ACTIONS(3934),
    [anon_sym_is] = ACTIONS(3896),
    [anon_sym_BANGis] = ACTIONS(3896),
    [anon_sym_in] = ACTIONS(3924),
    [anon_sym_BANGin] = ACTIONS(3924),
    [anon_sym_match] = ACTIONS(3934),
    [anon_sym_select] = ACTIONS(3934),
    [anon_sym_lock] = ACTIONS(3934),
    [anon_sym_rlock] = ACTIONS(3934),
    [anon_sym_unsafe] = ACTIONS(3934),
    [anon_sym_sql] = ACTIONS(3934),
    [sym_int_literal] = ACTIONS(3934),
    [sym_float_literal] = ACTIONS(3934),
    [sym_rune_literal] = ACTIONS(3934),
    [anon_sym_SQUOTE] = ACTIONS(3934),
    [anon_sym_DQUOTE] = ACTIONS(3934),
    [anon_sym_c_SQUOTE] = ACTIONS(3934),
    [anon_sym_c_DQUOTE] = ACTIONS(3934),
    [anon_sym_r_SQUOTE] = ACTIONS(3934),
    [anon_sym_r_DQUOTE] = ACTIONS(3934),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3934),
    [anon_sym_shared] = ACTIONS(3934),
    [anon_sym_map_LBRACK] = ACTIONS(3934),
    [anon_sym_chan] = ACTIONS(3934),
    [anon_sym_thread] = ACTIONS(3934),
    [anon_sym_atomic] = ACTIONS(3934),
    [anon_sym_assert] = ACTIONS(3934),
    [anon_sym_defer] = ACTIONS(3934),
    [anon_sym_goto] = ACTIONS(3934),
    [anon_sym_break] = ACTIONS(3934),
    [anon_sym_continue] = ACTIONS(3934),
    [anon_sym_return] = ACTIONS(3934),
    [anon_sym_DOLLARfor] = ACTIONS(3934),
    [anon_sym_for] = ACTIONS(3934),
    [anon_sym_POUND] = ACTIONS(3934),
    [anon_sym_asm] = ACTIONS(3934),
    [anon_sym_AT_LBRACK] = ACTIONS(3934),
  },
  [1141] = {
    [sym_line_comment] = STATE(1141),
    [sym_block_comment] = STATE(1141),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(3936),
    [sym_identifier] = ACTIONS(3938),
    [anon_sym_LF] = ACTIONS(3938),
    [anon_sym_CR] = ACTIONS(3938),
    [anon_sym_CR_LF] = ACTIONS(3938),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(3866),
    [anon_sym_LBRACE] = ACTIONS(3938),
    [anon_sym_const] = ACTIONS(3938),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(3938),
    [anon_sym_type] = ACTIONS(3938),
    [anon_sym_fn] = ACTIONS(3938),
    [anon_sym_PLUS] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3918),
    [anon_sym_STAR] = ACTIONS(3914),
    [anon_sym_SLASH] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_LT] = ACTIONS(3916),
    [anon_sym_GT] = ACTIONS(3916),
    [anon_sym_EQ_EQ] = ACTIONS(3916),
    [anon_sym_BANG_EQ] = ACTIONS(3916),
    [anon_sym_LT_EQ] = ACTIONS(3916),
    [anon_sym_GT_EQ] = ACTIONS(3916),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(3938),
    [anon_sym_union] = ACTIONS(3938),
    [anon_sym_pub] = ACTIONS(3938),
    [anon_sym_mut] = ACTIONS(3938),
    [anon_sym_enum] = ACTIONS(3938),
    [anon_sym_interface] = ACTIONS(3938),
    [anon_sym_PLUS_PLUS] = ACTIONS(3880),
    [anon_sym_DASH_DASH] = ACTIONS(3882),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(3938),
    [anon_sym_spawn] = ACTIONS(3938),
    [anon_sym_json_DOTdecode] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3918),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(3938),
    [anon_sym_CARET] = ACTIONS(3918),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(3938),
    [anon_sym_LT_LT] = ACTIONS(3914),
    [anon_sym_GT_GT] = ACTIONS(3914),
    [anon_sym_GT_GT_GT] = ACTIONS(3914),
    [anon_sym_AMP_CARET] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(3920),
    [anon_sym_PIPE_PIPE] = ACTIONS(3922),
    [anon_sym_or] = ACTIONS(3894),
    [sym_none] = ACTIONS(3938),
    [sym_true] = ACTIONS(3938),
    [sym_false] = ACTIONS(3938),
    [sym_nil] = ACTIONS(3938),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(3938),
    [anon_sym_DOLLARif] = ACTIONS(3938),
    [anon_sym_is] = ACTIONS(3896),
    [anon_sym_BANGis] = ACTIONS(3896),
    [anon_sym_in] = ACTIONS(3924),
    [anon_sym_BANGin] = ACTIONS(3924),
    [anon_sym_match] = ACTIONS(3938),
    [anon_sym_select] = ACTIONS(3938),
    [anon_sym_lock] = ACTIONS(3938),
    [anon_sym_rlock] = ACTIONS(3938),
    [anon_sym_unsafe] = ACTIONS(3938),
    [anon_sym_sql] = ACTIONS(3938),
    [sym_int_literal] = ACTIONS(3938),
    [sym_float_literal] = ACTIONS(3938),
    [sym_rune_literal] = ACTIONS(3938),
    [anon_sym_SQUOTE] = ACTIONS(3938),
    [anon_sym_DQUOTE] = ACTIONS(3938),
    [anon_sym_c_SQUOTE] = ACTIONS(3938),
    [anon_sym_c_DQUOTE] = ACTIONS(3938),
    [anon_sym_r_SQUOTE] = ACTIONS(3938),
    [anon_sym_r_DQUOTE] = ACTIONS(3938),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3938),
    [anon_sym_shared] = ACTIONS(3938),
    [anon_sym_map_LBRACK] = ACTIONS(3938),
    [anon_sym_chan] = ACTIONS(3938),
    [anon_sym_thread] = ACTIONS(3938),
    [anon_sym_atomic] = ACTIONS(3938),
    [anon_sym_assert] = ACTIONS(3938),
    [anon_sym_defer] = ACTIONS(3938),
    [anon_sym_goto] = ACTIONS(3938),
    [anon_sym_break] = ACTIONS(3938),
    [anon_sym_continue] = ACTIONS(3938),
    [anon_sym_return] = ACTIONS(3938),
    [anon_sym_DOLLARfor] = ACTIONS(3938),
    [anon_sym_for] = ACTIONS(3938),
    [anon_sym_POUND] = ACTIONS(3938),
    [anon_sym_asm] = ACTIONS(3938),
    [anon_sym_AT_LBRACK] = ACTIONS(3938),
  },
  [1142] = {
    [sym_line_comment] = STATE(1142),
    [sym_block_comment] = STATE(1142),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(2051),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_const] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(2053),
    [anon_sym_type] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_DASH] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(3914),
    [anon_sym_SLASH] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_union] = ACTIONS(2053),
    [anon_sym_pub] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_enum] = ACTIONS(2053),
    [anon_sym_interface] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(3914),
    [anon_sym_GT_GT] = ACTIONS(3914),
    [anon_sym_GT_GT_GT] = ACTIONS(3914),
    [anon_sym_AMP_CARET] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2053),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
    [anon_sym_AT_LBRACK] = ACTIONS(2053),
  },
  [1143] = {
    [sym_line_comment] = STATE(1143),
    [sym_block_comment] = STATE(1143),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(2051),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_const] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(2053),
    [anon_sym_type] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3918),
    [anon_sym_STAR] = ACTIONS(3914),
    [anon_sym_SLASH] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_union] = ACTIONS(2053),
    [anon_sym_pub] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_enum] = ACTIONS(2053),
    [anon_sym_interface] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(3918),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(3918),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(3914),
    [anon_sym_GT_GT] = ACTIONS(3914),
    [anon_sym_GT_GT_GT] = ACTIONS(3914),
    [anon_sym_AMP_CARET] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2053),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
    [anon_sym_AT_LBRACK] = ACTIONS(2053),
  },
  [1144] = {
    [sym_line_comment] = STATE(1144),
    [sym_block_comment] = STATE(1144),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(2051),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_const] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(2053),
    [anon_sym_type] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3918),
    [anon_sym_STAR] = ACTIONS(3914),
    [anon_sym_SLASH] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_LT] = ACTIONS(3916),
    [anon_sym_GT] = ACTIONS(3916),
    [anon_sym_EQ_EQ] = ACTIONS(3916),
    [anon_sym_BANG_EQ] = ACTIONS(3916),
    [anon_sym_LT_EQ] = ACTIONS(3916),
    [anon_sym_GT_EQ] = ACTIONS(3916),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_union] = ACTIONS(2053),
    [anon_sym_pub] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_enum] = ACTIONS(2053),
    [anon_sym_interface] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(3918),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(3918),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(3914),
    [anon_sym_GT_GT] = ACTIONS(3914),
    [anon_sym_GT_GT_GT] = ACTIONS(3914),
    [anon_sym_AMP_CARET] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(3920),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(3924),
    [anon_sym_BANGin] = ACTIONS(3924),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
    [anon_sym_AT_LBRACK] = ACTIONS(2053),
  },
  [1145] = {
    [sym_line_comment] = STATE(1145),
    [sym_block_comment] = STATE(1145),
    [sym_type_parameters] = STATE(4311),
    [sym_argument_list] = STATE(1229),
    [sym_or_block] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(2051),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_const] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym___global] = ACTIONS(2053),
    [anon_sym_type] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3918),
    [anon_sym_STAR] = ACTIONS(3914),
    [anon_sym_SLASH] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_LT] = ACTIONS(3916),
    [anon_sym_GT] = ACTIONS(3916),
    [anon_sym_EQ_EQ] = ACTIONS(3916),
    [anon_sym_BANG_EQ] = ACTIONS(3916),
    [anon_sym_LT_EQ] = ACTIONS(3916),
    [anon_sym_GT_EQ] = ACTIONS(3916),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_union] = ACTIONS(2053),
    [anon_sym_pub] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_enum] = ACTIONS(2053),
    [anon_sym_interface] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(3918),
    [anon_sym_LBRACK2] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(3918),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(3914),
    [anon_sym_GT_GT] = ACTIONS(3914),
    [anon_sym_GT_GT_GT] = ACTIONS(3914),
    [anon_sym_AMP_CARET] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3864),
    [anon_sym_POUND_LBRACK] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(3924),
    [anon_sym_BANGin] = ACTIONS(3924),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
    [anon_sym_AT_LBRACK] = ACTIONS(2053),
  },
  [1146] = {
    [sym_line_comment] = STATE(1146),
    [sym_block_comment] = STATE(1146),
    [sym_reference_expression] = STATE(4423),
    [sym_type_reference_expression] = STATE(1563),
    [sym_plain_type] = STATE(1671),
    [sym__plain_type_without_special] = STATE(1655),
    [sym_anon_struct_type] = STATE(1657),
    [sym_multi_return_type] = STATE(1655),
    [sym_result_type] = STATE(1655),
    [sym_option_type] = STATE(1655),
    [sym_qualified_type] = STATE(1563),
    [sym_fixed_array_type] = STATE(1657),
    [sym_array_type] = STATE(1657),
    [sym_pointer_type] = STATE(1657),
    [sym_wrong_pointer_type] = STATE(1657),
    [sym_map_type] = STATE(1657),
    [sym_channel_type] = STATE(1657),
    [sym_shared_type] = STATE(1657),
    [sym_thread_type] = STATE(1657),
    [sym_atomic_type] = STATE(1657),
    [sym_generic_type] = STATE(1657),
    [sym_function_type] = STATE(1657),
    [sym_identifier] = ACTIONS(3940),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(821),
    [anon_sym_as] = ACTIONS(821),
    [anon_sym_LBRACE] = ACTIONS(817),
    [anon_sym_COMMA] = ACTIONS(817),
    [anon_sym_RBRACE] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_fn] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(821),
    [anon_sym_DASH] = ACTIONS(821),
    [anon_sym_STAR] = ACTIONS(3946),
    [anon_sym_SLASH] = ACTIONS(821),
    [anon_sym_PERCENT] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(821),
    [anon_sym_GT] = ACTIONS(821),
    [anon_sym_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(817),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_LBRACK] = ACTIONS(817),
    [anon_sym_RBRACK] = ACTIONS(817),
    [anon_sym_struct] = ACTIONS(3948),
    [anon_sym_mut] = ACTIONS(821),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(817),
    [anon_sym_DASH_DASH] = ACTIONS(817),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3952),
    [anon_sym_go] = ACTIONS(821),
    [anon_sym_spawn] = ACTIONS(821),
    [anon_sym_json_DOTdecode] = ACTIONS(817),
    [anon_sym_PIPE] = ACTIONS(821),
    [anon_sym_LBRACK2] = ACTIONS(3954),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_CARET] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_LT_DASH] = ACTIONS(817),
    [anon_sym_LT_LT] = ACTIONS(817),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_GT_GT_GT] = ACTIONS(817),
    [anon_sym_AMP_CARET] = ACTIONS(817),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_or] = ACTIONS(821),
    [sym_none] = ACTIONS(821),
    [sym_true] = ACTIONS(821),
    [sym_false] = ACTIONS(821),
    [sym_nil] = ACTIONS(821),
    [anon_sym_QMARK_DOT] = ACTIONS(817),
    [anon_sym_POUND_LBRACK] = ACTIONS(817),
    [anon_sym_if] = ACTIONS(821),
    [anon_sym_DOLLARif] = ACTIONS(821),
    [anon_sym_is] = ACTIONS(821),
    [anon_sym_BANGis] = ACTIONS(817),
    [anon_sym_in] = ACTIONS(821),
    [anon_sym_BANGin] = ACTIONS(817),
    [anon_sym_match] = ACTIONS(821),
    [anon_sym_select] = ACTIONS(821),
    [anon_sym_lock] = ACTIONS(821),
    [anon_sym_rlock] = ACTIONS(821),
    [anon_sym_unsafe] = ACTIONS(821),
    [anon_sym_sql] = ACTIONS(821),
    [sym_int_literal] = ACTIONS(821),
    [sym_float_literal] = ACTIONS(817),
    [sym_rune_literal] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_c_SQUOTE] = ACTIONS(817),
    [anon_sym_c_DQUOTE] = ACTIONS(817),
    [anon_sym_r_SQUOTE] = ACTIONS(817),
    [anon_sym_r_DQUOTE] = ACTIONS(817),
    [sym_pseudo_compile_time_identifier] = ACTIONS(821),
    [anon_sym_shared] = ACTIONS(3958),
    [anon_sym_map_LBRACK] = ACTIONS(3960),
    [anon_sym_chan] = ACTIONS(3962),
    [anon_sym_thread] = ACTIONS(3964),
    [anon_sym_atomic] = ACTIONS(3966),
  },
  [1147] = {
    [sym_line_comment] = STATE(1147),
    [sym_block_comment] = STATE(1147),
    [sym_reference_expression] = STATE(4423),
    [sym_type_reference_expression] = STATE(1563),
    [sym_plain_type] = STATE(1647),
    [sym__plain_type_without_special] = STATE(1655),
    [sym_anon_struct_type] = STATE(1657),
    [sym_multi_return_type] = STATE(1655),
    [sym_result_type] = STATE(1655),
    [sym_option_type] = STATE(1655),
    [sym_qualified_type] = STATE(1563),
    [sym_fixed_array_type] = STATE(1657),
    [sym_array_type] = STATE(1657),
    [sym_pointer_type] = STATE(1657),
    [sym_wrong_pointer_type] = STATE(1657),
    [sym_map_type] = STATE(1657),
    [sym_channel_type] = STATE(1657),
    [sym_shared_type] = STATE(1657),
    [sym_thread_type] = STATE(1657),
    [sym_atomic_type] = STATE(1657),
    [sym_generic_type] = STATE(1657),
    [sym_function_type] = STATE(1657),
    [sym_identifier] = ACTIONS(3940),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(855),
    [anon_sym_as] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(853),
    [anon_sym_COMMA] = ACTIONS(853),
    [anon_sym_RBRACE] = ACTIONS(853),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_fn] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(3946),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_PERCENT] = ACTIONS(853),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_GT] = ACTIONS(855),
    [anon_sym_EQ_EQ] = ACTIONS(853),
    [anon_sym_BANG_EQ] = ACTIONS(853),
    [anon_sym_LT_EQ] = ACTIONS(853),
    [anon_sym_GT_EQ] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_RBRACK] = ACTIONS(853),
    [anon_sym_struct] = ACTIONS(3948),
    [anon_sym_mut] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(853),
    [anon_sym_PLUS_PLUS] = ACTIONS(853),
    [anon_sym_DASH_DASH] = ACTIONS(853),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3952),
    [anon_sym_go] = ACTIONS(855),
    [anon_sym_spawn] = ACTIONS(855),
    [anon_sym_json_DOTdecode] = ACTIONS(853),
    [anon_sym_PIPE] = ACTIONS(855),
    [anon_sym_LBRACK2] = ACTIONS(3954),
    [anon_sym_TILDE] = ACTIONS(853),
    [anon_sym_CARET] = ACTIONS(853),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_LT_DASH] = ACTIONS(853),
    [anon_sym_LT_LT] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_GT_GT_GT] = ACTIONS(853),
    [anon_sym_AMP_CARET] = ACTIONS(853),
    [anon_sym_AMP_AMP] = ACTIONS(853),
    [anon_sym_PIPE_PIPE] = ACTIONS(853),
    [anon_sym_or] = ACTIONS(855),
    [sym_none] = ACTIONS(855),
    [sym_true] = ACTIONS(855),
    [sym_false] = ACTIONS(855),
    [sym_nil] = ACTIONS(855),
    [anon_sym_QMARK_DOT] = ACTIONS(853),
    [anon_sym_POUND_LBRACK] = ACTIONS(853),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_DOLLARif] = ACTIONS(855),
    [anon_sym_is] = ACTIONS(855),
    [anon_sym_BANGis] = ACTIONS(853),
    [anon_sym_in] = ACTIONS(855),
    [anon_sym_BANGin] = ACTIONS(853),
    [anon_sym_match] = ACTIONS(855),
    [anon_sym_select] = ACTIONS(855),
    [anon_sym_lock] = ACTIONS(855),
    [anon_sym_rlock] = ACTIONS(855),
    [anon_sym_unsafe] = ACTIONS(855),
    [anon_sym_sql] = ACTIONS(855),
    [sym_int_literal] = ACTIONS(855),
    [sym_float_literal] = ACTIONS(853),
    [sym_rune_literal] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(853),
    [anon_sym_DQUOTE] = ACTIONS(853),
    [anon_sym_c_SQUOTE] = ACTIONS(853),
    [anon_sym_c_DQUOTE] = ACTIONS(853),
    [anon_sym_r_SQUOTE] = ACTIONS(853),
    [anon_sym_r_DQUOTE] = ACTIONS(853),
    [sym_pseudo_compile_time_identifier] = ACTIONS(855),
    [anon_sym_shared] = ACTIONS(3958),
    [anon_sym_map_LBRACK] = ACTIONS(3960),
    [anon_sym_chan] = ACTIONS(3962),
    [anon_sym_thread] = ACTIONS(3964),
    [anon_sym_atomic] = ACTIONS(3966),
  },
  [1148] = {
    [sym_line_comment] = STATE(1148),
    [sym_block_comment] = STATE(1148),
    [sym_type_parameters] = STATE(1246),
    [ts_builtin_sym_end] = ACTIONS(2185),
    [sym_identifier] = ACTIONS(2187),
    [anon_sym_LF] = ACTIONS(2187),
    [anon_sym_CR] = ACTIONS(2187),
    [anon_sym_CR_LF] = ACTIONS(2187),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2187),
    [anon_sym_as] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_const] = ACTIONS(2187),
    [anon_sym_LPAREN] = ACTIONS(2187),
    [anon_sym___global] = ACTIONS(2187),
    [anon_sym_type] = ACTIONS(2187),
    [anon_sym_fn] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [anon_sym_LT] = ACTIONS(2187),
    [anon_sym_GT] = ACTIONS(2187),
    [anon_sym_EQ_EQ] = ACTIONS(2187),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2187),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2185),
    [anon_sym_struct] = ACTIONS(2187),
    [anon_sym_union] = ACTIONS(2187),
    [anon_sym_pub] = ACTIONS(2187),
    [anon_sym_mut] = ACTIONS(2187),
    [anon_sym_enum] = ACTIONS(2187),
    [anon_sym_interface] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_go] = ACTIONS(2187),
    [anon_sym_spawn] = ACTIONS(2187),
    [anon_sym_json_DOTdecode] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2187),
    [anon_sym_LBRACK2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_LT_DASH] = ACTIONS(2187),
    [anon_sym_LT_LT] = ACTIONS(2187),
    [anon_sym_GT_GT] = ACTIONS(2187),
    [anon_sym_GT_GT_GT] = ACTIONS(2187),
    [anon_sym_AMP_CARET] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2187),
    [sym_none] = ACTIONS(2187),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [sym_nil] = ACTIONS(2187),
    [anon_sym_QMARK_DOT] = ACTIONS(2187),
    [anon_sym_POUND_LBRACK] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_DOLLARif] = ACTIONS(2187),
    [anon_sym_is] = ACTIONS(2187),
    [anon_sym_BANGis] = ACTIONS(2187),
    [anon_sym_in] = ACTIONS(2187),
    [anon_sym_BANGin] = ACTIONS(2187),
    [anon_sym_match] = ACTIONS(2187),
    [anon_sym_select] = ACTIONS(2187),
    [anon_sym_lock] = ACTIONS(2187),
    [anon_sym_rlock] = ACTIONS(2187),
    [anon_sym_unsafe] = ACTIONS(2187),
    [anon_sym_sql] = ACTIONS(2187),
    [sym_int_literal] = ACTIONS(2187),
    [sym_float_literal] = ACTIONS(2187),
    [sym_rune_literal] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(2187),
    [anon_sym_DQUOTE] = ACTIONS(2187),
    [anon_sym_c_SQUOTE] = ACTIONS(2187),
    [anon_sym_c_DQUOTE] = ACTIONS(2187),
    [anon_sym_r_SQUOTE] = ACTIONS(2187),
    [anon_sym_r_DQUOTE] = ACTIONS(2187),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2187),
    [anon_sym_shared] = ACTIONS(2187),
    [anon_sym_map_LBRACK] = ACTIONS(2187),
    [anon_sym_chan] = ACTIONS(2187),
    [anon_sym_thread] = ACTIONS(2187),
    [anon_sym_atomic] = ACTIONS(2187),
    [anon_sym_assert] = ACTIONS(2187),
    [anon_sym_defer] = ACTIONS(2187),
    [anon_sym_goto] = ACTIONS(2187),
    [anon_sym_break] = ACTIONS(2187),
    [anon_sym_continue] = ACTIONS(2187),
    [anon_sym_return] = ACTIONS(2187),
    [anon_sym_DOLLARfor] = ACTIONS(2187),
    [anon_sym_for] = ACTIONS(2187),
    [anon_sym_POUND] = ACTIONS(2187),
    [anon_sym_asm] = ACTIONS(2187),
    [anon_sym_AT_LBRACK] = ACTIONS(2187),
  },
  [1149] = {
    [sym_line_comment] = STATE(1149),
    [sym_block_comment] = STATE(1149),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2458),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(861),
    [anon_sym_COMMA] = ACTIONS(861),
    [anon_sym_RBRACE] = ACTIONS(861),
    [anon_sym_LPAREN] = ACTIONS(3968),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_STAR] = ACTIONS(3970),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(861),
    [anon_sym_BANG_EQ] = ACTIONS(861),
    [anon_sym_LT_EQ] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_RBRACK] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_mut] = ACTIONS(865),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_PLUS_PLUS] = ACTIONS(861),
    [anon_sym_DASH_DASH] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(3972),
    [anon_sym_go] = ACTIONS(865),
    [anon_sym_spawn] = ACTIONS(865),
    [anon_sym_json_DOTdecode] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_LBRACK2] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_CARET] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT_DASH] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(865),
    [anon_sym_GT_GT_GT] = ACTIONS(861),
    [anon_sym_AMP_CARET] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [anon_sym_or] = ACTIONS(865),
    [sym_none] = ACTIONS(865),
    [sym_true] = ACTIONS(865),
    [sym_false] = ACTIONS(865),
    [sym_nil] = ACTIONS(865),
    [anon_sym_QMARK_DOT] = ACTIONS(861),
    [anon_sym_POUND_LBRACK] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(865),
    [anon_sym_DOLLARif] = ACTIONS(865),
    [anon_sym_is] = ACTIONS(865),
    [anon_sym_BANGis] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(865),
    [anon_sym_BANGin] = ACTIONS(861),
    [anon_sym_match] = ACTIONS(865),
    [anon_sym_select] = ACTIONS(865),
    [anon_sym_lock] = ACTIONS(865),
    [anon_sym_rlock] = ACTIONS(865),
    [anon_sym_unsafe] = ACTIONS(865),
    [anon_sym_sql] = ACTIONS(865),
    [sym_int_literal] = ACTIONS(865),
    [sym_float_literal] = ACTIONS(861),
    [sym_rune_literal] = ACTIONS(861),
    [anon_sym_SQUOTE] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_c_SQUOTE] = ACTIONS(861),
    [anon_sym_c_DQUOTE] = ACTIONS(861),
    [anon_sym_r_SQUOTE] = ACTIONS(861),
    [anon_sym_r_DQUOTE] = ACTIONS(861),
    [sym_pseudo_compile_time_identifier] = ACTIONS(865),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [1150] = {
    [sym_line_comment] = STATE(1150),
    [sym_block_comment] = STATE(1150),
    [ts_builtin_sym_end] = ACTIONS(2145),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_CR] = ACTIONS(2147),
    [anon_sym_CR_LF] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_COMMA] = ACTIONS(2147),
    [anon_sym_const] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym___global] = ACTIONS(2147),
    [anon_sym_type] = ACTIONS(2147),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2147),
    [anon_sym_BANG_EQ] = ACTIONS(2147),
    [anon_sym_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2147),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_union] = ACTIONS(2147),
    [anon_sym_pub] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_enum] = ACTIONS(2147),
    [anon_sym_interface] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2147),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2147),
    [anon_sym_AMP_CARET] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [anon_sym_or] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2147),
    [anon_sym_POUND_LBRACK] = ACTIONS(2147),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_else] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2147),
    [anon_sym_BANGis] = ACTIONS(2147),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANGin] = ACTIONS(2147),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2147),
    [sym_rune_literal] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_c_SQUOTE] = ACTIONS(2147),
    [anon_sym_c_DQUOTE] = ACTIONS(2147),
    [anon_sym_r_SQUOTE] = ACTIONS(2147),
    [anon_sym_r_DQUOTE] = ACTIONS(2147),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2147),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
    [anon_sym_assert] = ACTIONS(2147),
    [anon_sym_defer] = ACTIONS(2147),
    [anon_sym_goto] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_continue] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2147),
    [anon_sym_DOLLARfor] = ACTIONS(2147),
    [anon_sym_for] = ACTIONS(2147),
    [anon_sym_POUND] = ACTIONS(2147),
    [anon_sym_asm] = ACTIONS(2147),
    [anon_sym_AT_LBRACK] = ACTIONS(2147),
  },
  [1151] = {
    [sym_line_comment] = STATE(1151),
    [sym_block_comment] = STATE(1151),
    [ts_builtin_sym_end] = ACTIONS(2145),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_CR] = ACTIONS(2147),
    [anon_sym_CR_LF] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_COMMA] = ACTIONS(2147),
    [anon_sym_const] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym___global] = ACTIONS(2147),
    [anon_sym_type] = ACTIONS(2147),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2147),
    [anon_sym_BANG_EQ] = ACTIONS(2147),
    [anon_sym_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2147),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_union] = ACTIONS(2147),
    [anon_sym_pub] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_enum] = ACTIONS(2147),
    [anon_sym_interface] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2147),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2147),
    [anon_sym_AMP_CARET] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [anon_sym_or] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2147),
    [anon_sym_POUND_LBRACK] = ACTIONS(2147),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_DOLLARelse] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2147),
    [anon_sym_BANGis] = ACTIONS(2147),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANGin] = ACTIONS(2147),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2147),
    [sym_rune_literal] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_c_SQUOTE] = ACTIONS(2147),
    [anon_sym_c_DQUOTE] = ACTIONS(2147),
    [anon_sym_r_SQUOTE] = ACTIONS(2147),
    [anon_sym_r_DQUOTE] = ACTIONS(2147),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2147),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
    [anon_sym_assert] = ACTIONS(2147),
    [anon_sym_defer] = ACTIONS(2147),
    [anon_sym_goto] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_continue] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2147),
    [anon_sym_DOLLARfor] = ACTIONS(2147),
    [anon_sym_for] = ACTIONS(2147),
    [anon_sym_POUND] = ACTIONS(2147),
    [anon_sym_asm] = ACTIONS(2147),
    [anon_sym_AT_LBRACK] = ACTIONS(2147),
  },
  [1152] = {
    [sym_line_comment] = STATE(1152),
    [sym_block_comment] = STATE(1152),
    [sym_reference_expression] = STATE(4423),
    [sym_type_reference_expression] = STATE(1563),
    [sym_plain_type] = STATE(1653),
    [sym__plain_type_without_special] = STATE(1655),
    [sym_anon_struct_type] = STATE(1657),
    [sym_multi_return_type] = STATE(1655),
    [sym_result_type] = STATE(1655),
    [sym_option_type] = STATE(1655),
    [sym_qualified_type] = STATE(1563),
    [sym_fixed_array_type] = STATE(1657),
    [sym_array_type] = STATE(1657),
    [sym_pointer_type] = STATE(1657),
    [sym_wrong_pointer_type] = STATE(1657),
    [sym_map_type] = STATE(1657),
    [sym_channel_type] = STATE(1657),
    [sym_shared_type] = STATE(1657),
    [sym_thread_type] = STATE(1657),
    [sym_atomic_type] = STATE(1657),
    [sym_generic_type] = STATE(1657),
    [sym_function_type] = STATE(1657),
    [sym_identifier] = ACTIONS(3940),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(859),
    [anon_sym_as] = ACTIONS(859),
    [anon_sym_LBRACE] = ACTIONS(857),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RBRACE] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_fn] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(3946),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_EQ_EQ] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(857),
    [anon_sym_LT_EQ] = ACTIONS(857),
    [anon_sym_GT_EQ] = ACTIONS(857),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(857),
    [anon_sym_struct] = ACTIONS(3948),
    [anon_sym_mut] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3952),
    [anon_sym_go] = ACTIONS(859),
    [anon_sym_spawn] = ACTIONS(859),
    [anon_sym_json_DOTdecode] = ACTIONS(857),
    [anon_sym_PIPE] = ACTIONS(859),
    [anon_sym_LBRACK2] = ACTIONS(3954),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_LT_DASH] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_GT_GT_GT] = ACTIONS(857),
    [anon_sym_AMP_CARET] = ACTIONS(857),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [anon_sym_or] = ACTIONS(859),
    [sym_none] = ACTIONS(859),
    [sym_true] = ACTIONS(859),
    [sym_false] = ACTIONS(859),
    [sym_nil] = ACTIONS(859),
    [anon_sym_QMARK_DOT] = ACTIONS(857),
    [anon_sym_POUND_LBRACK] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_DOLLARif] = ACTIONS(859),
    [anon_sym_is] = ACTIONS(859),
    [anon_sym_BANGis] = ACTIONS(857),
    [anon_sym_in] = ACTIONS(859),
    [anon_sym_BANGin] = ACTIONS(857),
    [anon_sym_match] = ACTIONS(859),
    [anon_sym_select] = ACTIONS(859),
    [anon_sym_lock] = ACTIONS(859),
    [anon_sym_rlock] = ACTIONS(859),
    [anon_sym_unsafe] = ACTIONS(859),
    [anon_sym_sql] = ACTIONS(859),
    [sym_int_literal] = ACTIONS(859),
    [sym_float_literal] = ACTIONS(857),
    [sym_rune_literal] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [anon_sym_c_SQUOTE] = ACTIONS(857),
    [anon_sym_c_DQUOTE] = ACTIONS(857),
    [anon_sym_r_SQUOTE] = ACTIONS(857),
    [anon_sym_r_DQUOTE] = ACTIONS(857),
    [sym_pseudo_compile_time_identifier] = ACTIONS(859),
    [anon_sym_shared] = ACTIONS(3958),
    [anon_sym_map_LBRACK] = ACTIONS(3960),
    [anon_sym_chan] = ACTIONS(3962),
    [anon_sym_thread] = ACTIONS(3964),
    [anon_sym_atomic] = ACTIONS(3966),
  },
  [1153] = {
    [sym_line_comment] = STATE(1153),
    [sym_block_comment] = STATE(1153),
    [ts_builtin_sym_end] = ACTIONS(2167),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_LF] = ACTIONS(2169),
    [anon_sym_CR] = ACTIONS(2169),
    [anon_sym_CR_LF] = ACTIONS(2169),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2169),
    [anon_sym_as] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_COMMA] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_LPAREN] = ACTIONS(2169),
    [anon_sym___global] = ACTIONS(2169),
    [anon_sym_type] = ACTIONS(2169),
    [anon_sym_fn] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_SLASH] = ACTIONS(2169),
    [anon_sym_PERCENT] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2169),
    [anon_sym_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ] = ACTIONS(2169),
    [anon_sym_LT_EQ] = ACTIONS(2169),
    [anon_sym_GT_EQ] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_union] = ACTIONS(2169),
    [anon_sym_pub] = ACTIONS(2169),
    [anon_sym_mut] = ACTIONS(2169),
    [anon_sym_enum] = ACTIONS(2169),
    [anon_sym_interface] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_go] = ACTIONS(2169),
    [anon_sym_spawn] = ACTIONS(2169),
    [anon_sym_json_DOTdecode] = ACTIONS(2169),
    [anon_sym_PIPE] = ACTIONS(2169),
    [anon_sym_LBRACK2] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT_DASH] = ACTIONS(2169),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_GT_GT_GT] = ACTIONS(2169),
    [anon_sym_AMP_CARET] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_PIPE_PIPE] = ACTIONS(2169),
    [anon_sym_or] = ACTIONS(2169),
    [sym_none] = ACTIONS(2169),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [sym_nil] = ACTIONS(2169),
    [anon_sym_QMARK_DOT] = ACTIONS(2169),
    [anon_sym_POUND_LBRACK] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_DOLLARif] = ACTIONS(2169),
    [anon_sym_DOLLARelse] = ACTIONS(2169),
    [anon_sym_is] = ACTIONS(2169),
    [anon_sym_BANGis] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_BANGin] = ACTIONS(2169),
    [anon_sym_match] = ACTIONS(2169),
    [anon_sym_select] = ACTIONS(2169),
    [anon_sym_lock] = ACTIONS(2169),
    [anon_sym_rlock] = ACTIONS(2169),
    [anon_sym_unsafe] = ACTIONS(2169),
    [anon_sym_sql] = ACTIONS(2169),
    [sym_int_literal] = ACTIONS(2169),
    [sym_float_literal] = ACTIONS(2169),
    [sym_rune_literal] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [anon_sym_c_SQUOTE] = ACTIONS(2169),
    [anon_sym_c_DQUOTE] = ACTIONS(2169),
    [anon_sym_r_SQUOTE] = ACTIONS(2169),
    [anon_sym_r_DQUOTE] = ACTIONS(2169),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_map_LBRACK] = ACTIONS(2169),
    [anon_sym_chan] = ACTIONS(2169),
    [anon_sym_thread] = ACTIONS(2169),
    [anon_sym_atomic] = ACTIONS(2169),
    [anon_sym_assert] = ACTIONS(2169),
    [anon_sym_defer] = ACTIONS(2169),
    [anon_sym_goto] = ACTIONS(2169),
    [anon_sym_break] = ACTIONS(2169),
    [anon_sym_continue] = ACTIONS(2169),
    [anon_sym_return] = ACTIONS(2169),
    [anon_sym_DOLLARfor] = ACTIONS(2169),
    [anon_sym_for] = ACTIONS(2169),
    [anon_sym_POUND] = ACTIONS(2169),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym_AT_LBRACK] = ACTIONS(2169),
  },
  [1154] = {
    [sym_line_comment] = STATE(1154),
    [sym_block_comment] = STATE(1154),
    [ts_builtin_sym_end] = ACTIONS(2167),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_LF] = ACTIONS(2169),
    [anon_sym_CR] = ACTIONS(2169),
    [anon_sym_CR_LF] = ACTIONS(2169),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2169),
    [anon_sym_as] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_COMMA] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_LPAREN] = ACTIONS(2169),
    [anon_sym___global] = ACTIONS(2169),
    [anon_sym_type] = ACTIONS(2169),
    [anon_sym_fn] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_SLASH] = ACTIONS(2169),
    [anon_sym_PERCENT] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2169),
    [anon_sym_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ] = ACTIONS(2169),
    [anon_sym_LT_EQ] = ACTIONS(2169),
    [anon_sym_GT_EQ] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_union] = ACTIONS(2169),
    [anon_sym_pub] = ACTIONS(2169),
    [anon_sym_mut] = ACTIONS(2169),
    [anon_sym_enum] = ACTIONS(2169),
    [anon_sym_interface] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_go] = ACTIONS(2169),
    [anon_sym_spawn] = ACTIONS(2169),
    [anon_sym_json_DOTdecode] = ACTIONS(2169),
    [anon_sym_PIPE] = ACTIONS(2169),
    [anon_sym_LBRACK2] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT_DASH] = ACTIONS(2169),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_GT_GT_GT] = ACTIONS(2169),
    [anon_sym_AMP_CARET] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_PIPE_PIPE] = ACTIONS(2169),
    [anon_sym_or] = ACTIONS(2169),
    [sym_none] = ACTIONS(2169),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [sym_nil] = ACTIONS(2169),
    [anon_sym_QMARK_DOT] = ACTIONS(2169),
    [anon_sym_POUND_LBRACK] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(2169),
    [anon_sym_DOLLARif] = ACTIONS(2169),
    [anon_sym_is] = ACTIONS(2169),
    [anon_sym_BANGis] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_BANGin] = ACTIONS(2169),
    [anon_sym_match] = ACTIONS(2169),
    [anon_sym_select] = ACTIONS(2169),
    [anon_sym_lock] = ACTIONS(2169),
    [anon_sym_rlock] = ACTIONS(2169),
    [anon_sym_unsafe] = ACTIONS(2169),
    [anon_sym_sql] = ACTIONS(2169),
    [sym_int_literal] = ACTIONS(2169),
    [sym_float_literal] = ACTIONS(2169),
    [sym_rune_literal] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [anon_sym_c_SQUOTE] = ACTIONS(2169),
    [anon_sym_c_DQUOTE] = ACTIONS(2169),
    [anon_sym_r_SQUOTE] = ACTIONS(2169),
    [anon_sym_r_DQUOTE] = ACTIONS(2169),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_map_LBRACK] = ACTIONS(2169),
    [anon_sym_chan] = ACTIONS(2169),
    [anon_sym_thread] = ACTIONS(2169),
    [anon_sym_atomic] = ACTIONS(2169),
    [anon_sym_assert] = ACTIONS(2169),
    [anon_sym_defer] = ACTIONS(2169),
    [anon_sym_goto] = ACTIONS(2169),
    [anon_sym_break] = ACTIONS(2169),
    [anon_sym_continue] = ACTIONS(2169),
    [anon_sym_return] = ACTIONS(2169),
    [anon_sym_DOLLARfor] = ACTIONS(2169),
    [anon_sym_for] = ACTIONS(2169),
    [anon_sym_POUND] = ACTIONS(2169),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym_AT_LBRACK] = ACTIONS(2169),
  },
  [1155] = {
    [sym_line_comment] = STATE(1155),
    [sym_block_comment] = STATE(1155),
    [ts_builtin_sym_end] = ACTIONS(2091),
    [sym_identifier] = ACTIONS(2093),
    [anon_sym_LF] = ACTIONS(2093),
    [anon_sym_CR] = ACTIONS(2093),
    [anon_sym_CR_LF] = ACTIONS(2093),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2093),
    [anon_sym_as] = ACTIONS(2093),
    [anon_sym_LBRACE] = ACTIONS(2093),
    [anon_sym_COMMA] = ACTIONS(2093),
    [anon_sym_const] = ACTIONS(2093),
    [anon_sym_LPAREN] = ACTIONS(2093),
    [anon_sym___global] = ACTIONS(2093),
    [anon_sym_type] = ACTIONS(2093),
    [anon_sym_fn] = ACTIONS(2093),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(2093),
    [anon_sym_SLASH] = ACTIONS(2093),
    [anon_sym_PERCENT] = ACTIONS(2093),
    [anon_sym_LT] = ACTIONS(2093),
    [anon_sym_GT] = ACTIONS(2093),
    [anon_sym_EQ_EQ] = ACTIONS(2093),
    [anon_sym_BANG_EQ] = ACTIONS(2093),
    [anon_sym_LT_EQ] = ACTIONS(2093),
    [anon_sym_GT_EQ] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2091),
    [anon_sym_struct] = ACTIONS(2093),
    [anon_sym_union] = ACTIONS(2093),
    [anon_sym_pub] = ACTIONS(2093),
    [anon_sym_mut] = ACTIONS(2093),
    [anon_sym_enum] = ACTIONS(2093),
    [anon_sym_interface] = ACTIONS(2093),
    [anon_sym_PLUS_PLUS] = ACTIONS(2093),
    [anon_sym_DASH_DASH] = ACTIONS(2093),
    [anon_sym_QMARK] = ACTIONS(2093),
    [anon_sym_BANG] = ACTIONS(2093),
    [anon_sym_go] = ACTIONS(2093),
    [anon_sym_spawn] = ACTIONS(2093),
    [anon_sym_json_DOTdecode] = ACTIONS(2093),
    [anon_sym_PIPE] = ACTIONS(2093),
    [anon_sym_LBRACK2] = ACTIONS(2093),
    [anon_sym_TILDE] = ACTIONS(2093),
    [anon_sym_CARET] = ACTIONS(2093),
    [anon_sym_AMP] = ACTIONS(2093),
    [anon_sym_LT_DASH] = ACTIONS(2093),
    [anon_sym_LT_LT] = ACTIONS(2093),
    [anon_sym_GT_GT] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2093),
    [anon_sym_AMP_CARET] = ACTIONS(2093),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_PIPE_PIPE] = ACTIONS(2093),
    [anon_sym_or] = ACTIONS(2093),
    [sym_none] = ACTIONS(2093),
    [sym_true] = ACTIONS(2093),
    [sym_false] = ACTIONS(2093),
    [sym_nil] = ACTIONS(2093),
    [anon_sym_QMARK_DOT] = ACTIONS(2093),
    [anon_sym_POUND_LBRACK] = ACTIONS(2093),
    [anon_sym_if] = ACTIONS(2093),
    [anon_sym_DOLLARif] = ACTIONS(2093),
    [anon_sym_DOLLARelse] = ACTIONS(3974),
    [anon_sym_is] = ACTIONS(2093),
    [anon_sym_BANGis] = ACTIONS(2093),
    [anon_sym_in] = ACTIONS(2093),
    [anon_sym_BANGin] = ACTIONS(2093),
    [anon_sym_match] = ACTIONS(2093),
    [anon_sym_select] = ACTIONS(2093),
    [anon_sym_lock] = ACTIONS(2093),
    [anon_sym_rlock] = ACTIONS(2093),
    [anon_sym_unsafe] = ACTIONS(2093),
    [anon_sym_sql] = ACTIONS(2093),
    [sym_int_literal] = ACTIONS(2093),
    [sym_float_literal] = ACTIONS(2093),
    [sym_rune_literal] = ACTIONS(2093),
    [anon_sym_SQUOTE] = ACTIONS(2093),
    [anon_sym_DQUOTE] = ACTIONS(2093),
    [anon_sym_c_SQUOTE] = ACTIONS(2093),
    [anon_sym_c_DQUOTE] = ACTIONS(2093),
    [anon_sym_r_SQUOTE] = ACTIONS(2093),
    [anon_sym_r_DQUOTE] = ACTIONS(2093),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2093),
    [anon_sym_shared] = ACTIONS(2093),
    [anon_sym_map_LBRACK] = ACTIONS(2093),
    [anon_sym_chan] = ACTIONS(2093),
    [anon_sym_thread] = ACTIONS(2093),
    [anon_sym_atomic] = ACTIONS(2093),
    [anon_sym_assert] = ACTIONS(2093),
    [anon_sym_defer] = ACTIONS(2093),
    [anon_sym_goto] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2093),
    [anon_sym_continue] = ACTIONS(2093),
    [anon_sym_return] = ACTIONS(2093),
    [anon_sym_DOLLARfor] = ACTIONS(2093),
    [anon_sym_for] = ACTIONS(2093),
    [anon_sym_POUND] = ACTIONS(2093),
    [anon_sym_asm] = ACTIONS(2093),
    [anon_sym_AT_LBRACK] = ACTIONS(2093),
  },
  [1156] = {
    [sym_line_comment] = STATE(1156),
    [sym_block_comment] = STATE(1156),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2489),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(851),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(849),
    [anon_sym_RBRACE] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(849),
    [anon_sym_fn] = ACTIONS(851),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(849),
    [anon_sym_SLASH] = ACTIONS(851),
    [anon_sym_PERCENT] = ACTIONS(849),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(849),
    [anon_sym_BANG_EQ] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_RBRACK] = ACTIONS(849),
    [anon_sym_struct] = ACTIONS(851),
    [anon_sym_mut] = ACTIONS(851),
    [anon_sym_COLON] = ACTIONS(849),
    [anon_sym_PLUS_PLUS] = ACTIONS(849),
    [anon_sym_DASH_DASH] = ACTIONS(849),
    [anon_sym_QMARK] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_go] = ACTIONS(851),
    [anon_sym_spawn] = ACTIONS(851),
    [anon_sym_json_DOTdecode] = ACTIONS(849),
    [anon_sym_PIPE] = ACTIONS(851),
    [anon_sym_LBRACK2] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(849),
    [anon_sym_CARET] = ACTIONS(849),
    [anon_sym_AMP] = ACTIONS(851),
    [anon_sym_LT_DASH] = ACTIONS(849),
    [anon_sym_LT_LT] = ACTIONS(849),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_GT_GT_GT] = ACTIONS(849),
    [anon_sym_AMP_CARET] = ACTIONS(849),
    [anon_sym_AMP_AMP] = ACTIONS(849),
    [anon_sym_PIPE_PIPE] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(851),
    [sym_none] = ACTIONS(851),
    [sym_true] = ACTIONS(851),
    [sym_false] = ACTIONS(851),
    [sym_nil] = ACTIONS(851),
    [anon_sym_QMARK_DOT] = ACTIONS(849),
    [anon_sym_POUND_LBRACK] = ACTIONS(849),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_DOLLARif] = ACTIONS(851),
    [anon_sym_is] = ACTIONS(851),
    [anon_sym_BANGis] = ACTIONS(849),
    [anon_sym_in] = ACTIONS(851),
    [anon_sym_BANGin] = ACTIONS(849),
    [anon_sym_match] = ACTIONS(851),
    [anon_sym_select] = ACTIONS(851),
    [anon_sym_lock] = ACTIONS(851),
    [anon_sym_rlock] = ACTIONS(851),
    [anon_sym_unsafe] = ACTIONS(851),
    [anon_sym_sql] = ACTIONS(851),
    [sym_int_literal] = ACTIONS(851),
    [sym_float_literal] = ACTIONS(849),
    [sym_rune_literal] = ACTIONS(849),
    [anon_sym_SQUOTE] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(849),
    [anon_sym_c_SQUOTE] = ACTIONS(849),
    [anon_sym_c_DQUOTE] = ACTIONS(849),
    [anon_sym_r_SQUOTE] = ACTIONS(849),
    [anon_sym_r_DQUOTE] = ACTIONS(849),
    [sym_pseudo_compile_time_identifier] = ACTIONS(851),
    [anon_sym_shared] = ACTIONS(851),
    [anon_sym_map_LBRACK] = ACTIONS(849),
    [anon_sym_chan] = ACTIONS(851),
    [anon_sym_thread] = ACTIONS(851),
    [anon_sym_atomic] = ACTIONS(851),
  },
  [1157] = {
    [sym_line_comment] = STATE(1157),
    [sym_block_comment] = STATE(1157),
    [ts_builtin_sym_end] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2105),
    [anon_sym_LF] = ACTIONS(2105),
    [anon_sym_CR] = ACTIONS(2105),
    [anon_sym_CR_LF] = ACTIONS(2105),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2105),
    [anon_sym_as] = ACTIONS(2105),
    [anon_sym_LBRACE] = ACTIONS(2105),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_const] = ACTIONS(2105),
    [anon_sym_LPAREN] = ACTIONS(2105),
    [anon_sym___global] = ACTIONS(2105),
    [anon_sym_type] = ACTIONS(2105),
    [anon_sym_fn] = ACTIONS(2105),
    [anon_sym_PLUS] = ACTIONS(2105),
    [anon_sym_DASH] = ACTIONS(2105),
    [anon_sym_STAR] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2105),
    [anon_sym_PERCENT] = ACTIONS(2105),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_GT] = ACTIONS(2105),
    [anon_sym_EQ_EQ] = ACTIONS(2105),
    [anon_sym_BANG_EQ] = ACTIONS(2105),
    [anon_sym_LT_EQ] = ACTIONS(2105),
    [anon_sym_GT_EQ] = ACTIONS(2105),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_struct] = ACTIONS(2105),
    [anon_sym_union] = ACTIONS(2105),
    [anon_sym_pub] = ACTIONS(2105),
    [anon_sym_mut] = ACTIONS(2105),
    [anon_sym_enum] = ACTIONS(2105),
    [anon_sym_interface] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_QMARK] = ACTIONS(2105),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_go] = ACTIONS(2105),
    [anon_sym_spawn] = ACTIONS(2105),
    [anon_sym_json_DOTdecode] = ACTIONS(2105),
    [anon_sym_PIPE] = ACTIONS(2105),
    [anon_sym_LBRACK2] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_LT_DASH] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(2105),
    [anon_sym_GT_GT] = ACTIONS(2105),
    [anon_sym_GT_GT_GT] = ACTIONS(2105),
    [anon_sym_AMP_CARET] = ACTIONS(2105),
    [anon_sym_AMP_AMP] = ACTIONS(2105),
    [anon_sym_PIPE_PIPE] = ACTIONS(2105),
    [anon_sym_or] = ACTIONS(2105),
    [sym_none] = ACTIONS(2105),
    [sym_true] = ACTIONS(2105),
    [sym_false] = ACTIONS(2105),
    [sym_nil] = ACTIONS(2105),
    [anon_sym_QMARK_DOT] = ACTIONS(2105),
    [anon_sym_POUND_LBRACK] = ACTIONS(2105),
    [anon_sym_if] = ACTIONS(2105),
    [anon_sym_DOLLARif] = ACTIONS(2105),
    [anon_sym_DOLLARelse] = ACTIONS(3976),
    [anon_sym_is] = ACTIONS(2105),
    [anon_sym_BANGis] = ACTIONS(2105),
    [anon_sym_in] = ACTIONS(2105),
    [anon_sym_BANGin] = ACTIONS(2105),
    [anon_sym_match] = ACTIONS(2105),
    [anon_sym_select] = ACTIONS(2105),
    [anon_sym_lock] = ACTIONS(2105),
    [anon_sym_rlock] = ACTIONS(2105),
    [anon_sym_unsafe] = ACTIONS(2105),
    [anon_sym_sql] = ACTIONS(2105),
    [sym_int_literal] = ACTIONS(2105),
    [sym_float_literal] = ACTIONS(2105),
    [sym_rune_literal] = ACTIONS(2105),
    [anon_sym_SQUOTE] = ACTIONS(2105),
    [anon_sym_DQUOTE] = ACTIONS(2105),
    [anon_sym_c_SQUOTE] = ACTIONS(2105),
    [anon_sym_c_DQUOTE] = ACTIONS(2105),
    [anon_sym_r_SQUOTE] = ACTIONS(2105),
    [anon_sym_r_DQUOTE] = ACTIONS(2105),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2105),
    [anon_sym_shared] = ACTIONS(2105),
    [anon_sym_map_LBRACK] = ACTIONS(2105),
    [anon_sym_chan] = ACTIONS(2105),
    [anon_sym_thread] = ACTIONS(2105),
    [anon_sym_atomic] = ACTIONS(2105),
    [anon_sym_assert] = ACTIONS(2105),
    [anon_sym_defer] = ACTIONS(2105),
    [anon_sym_goto] = ACTIONS(2105),
    [anon_sym_break] = ACTIONS(2105),
    [anon_sym_continue] = ACTIONS(2105),
    [anon_sym_return] = ACTIONS(2105),
    [anon_sym_DOLLARfor] = ACTIONS(2105),
    [anon_sym_for] = ACTIONS(2105),
    [anon_sym_POUND] = ACTIONS(2105),
    [anon_sym_asm] = ACTIONS(2105),
    [anon_sym_AT_LBRACK] = ACTIONS(2105),
  },
  [1158] = {
    [sym_line_comment] = STATE(1158),
    [sym_block_comment] = STATE(1158),
    [ts_builtin_sym_end] = ACTIONS(3310),
    [sym_identifier] = ACTIONS(3312),
    [anon_sym_LF] = ACTIONS(3312),
    [anon_sym_CR] = ACTIONS(3312),
    [anon_sym_CR_LF] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3312),
    [anon_sym_as] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_const] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3312),
    [anon_sym___global] = ACTIONS(3312),
    [anon_sym_type] = ACTIONS(3312),
    [anon_sym_fn] = ACTIONS(3312),
    [anon_sym_PLUS] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_SLASH] = ACTIONS(3312),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_GT] = ACTIONS(3312),
    [anon_sym_EQ_EQ] = ACTIONS(3312),
    [anon_sym_BANG_EQ] = ACTIONS(3312),
    [anon_sym_LT_EQ] = ACTIONS(3312),
    [anon_sym_GT_EQ] = ACTIONS(3312),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_struct] = ACTIONS(3312),
    [anon_sym_union] = ACTIONS(3312),
    [anon_sym_pub] = ACTIONS(3312),
    [anon_sym_mut] = ACTIONS(3312),
    [anon_sym_enum] = ACTIONS(3312),
    [anon_sym_interface] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3312),
    [anon_sym_DASH_DASH] = ACTIONS(3312),
    [anon_sym_QMARK] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_go] = ACTIONS(3312),
    [anon_sym_spawn] = ACTIONS(3312),
    [anon_sym_json_DOTdecode] = ACTIONS(3312),
    [anon_sym_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACK2] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_CARET] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3312),
    [anon_sym_LT_DASH] = ACTIONS(3312),
    [anon_sym_LT_LT] = ACTIONS(3312),
    [anon_sym_GT_GT] = ACTIONS(3312),
    [anon_sym_GT_GT_GT] = ACTIONS(3312),
    [anon_sym_AMP_CARET] = ACTIONS(3312),
    [anon_sym_AMP_AMP] = ACTIONS(3312),
    [anon_sym_PIPE_PIPE] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3312),
    [sym_none] = ACTIONS(3312),
    [sym_true] = ACTIONS(3312),
    [sym_false] = ACTIONS(3312),
    [sym_nil] = ACTIONS(3312),
    [anon_sym_QMARK_DOT] = ACTIONS(3312),
    [anon_sym_POUND_LBRACK] = ACTIONS(3312),
    [anon_sym_if] = ACTIONS(3312),
    [anon_sym_DOLLARif] = ACTIONS(3312),
    [anon_sym_is] = ACTIONS(3312),
    [anon_sym_BANGis] = ACTIONS(3312),
    [anon_sym_in] = ACTIONS(3312),
    [anon_sym_BANGin] = ACTIONS(3312),
    [anon_sym_match] = ACTIONS(3312),
    [anon_sym_select] = ACTIONS(3312),
    [anon_sym_lock] = ACTIONS(3312),
    [anon_sym_rlock] = ACTIONS(3312),
    [anon_sym_unsafe] = ACTIONS(3312),
    [anon_sym_sql] = ACTIONS(3312),
    [sym_int_literal] = ACTIONS(3312),
    [sym_float_literal] = ACTIONS(3312),
    [sym_rune_literal] = ACTIONS(3312),
    [anon_sym_SQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3312),
    [anon_sym_c_SQUOTE] = ACTIONS(3312),
    [anon_sym_c_DQUOTE] = ACTIONS(3312),
    [anon_sym_r_SQUOTE] = ACTIONS(3312),
    [anon_sym_r_DQUOTE] = ACTIONS(3312),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3312),
    [anon_sym_shared] = ACTIONS(3312),
    [anon_sym_map_LBRACK] = ACTIONS(3312),
    [anon_sym_chan] = ACTIONS(3312),
    [anon_sym_thread] = ACTIONS(3312),
    [anon_sym_atomic] = ACTIONS(3312),
    [anon_sym_assert] = ACTIONS(3312),
    [anon_sym_defer] = ACTIONS(3312),
    [anon_sym_goto] = ACTIONS(3312),
    [anon_sym_break] = ACTIONS(3312),
    [anon_sym_continue] = ACTIONS(3312),
    [anon_sym_return] = ACTIONS(3312),
    [anon_sym_DOLLARfor] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3312),
    [anon_sym_POUND] = ACTIONS(3312),
    [anon_sym_asm] = ACTIONS(3312),
    [anon_sym_AT_LBRACK] = ACTIONS(3312),
  },
  [1159] = {
    [sym_line_comment] = STATE(1159),
    [sym_block_comment] = STATE(1159),
    [ts_builtin_sym_end] = ACTIONS(3306),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_LF] = ACTIONS(3308),
    [anon_sym_CR] = ACTIONS(3308),
    [anon_sym_CR_LF] = ACTIONS(3308),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_as] = ACTIONS(3308),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_COMMA] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3308),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym___global] = ACTIONS(3308),
    [anon_sym_type] = ACTIONS(3308),
    [anon_sym_fn] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_SLASH] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_EQ_EQ] = ACTIONS(3308),
    [anon_sym_BANG_EQ] = ACTIONS(3308),
    [anon_sym_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT_EQ] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_struct] = ACTIONS(3308),
    [anon_sym_union] = ACTIONS(3308),
    [anon_sym_pub] = ACTIONS(3308),
    [anon_sym_mut] = ACTIONS(3308),
    [anon_sym_enum] = ACTIONS(3308),
    [anon_sym_interface] = ACTIONS(3308),
    [anon_sym_PLUS_PLUS] = ACTIONS(3308),
    [anon_sym_DASH_DASH] = ACTIONS(3308),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_BANG] = ACTIONS(3308),
    [anon_sym_go] = ACTIONS(3308),
    [anon_sym_spawn] = ACTIONS(3308),
    [anon_sym_json_DOTdecode] = ACTIONS(3308),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_LBRACK2] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3308),
    [anon_sym_CARET] = ACTIONS(3308),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LT_DASH] = ACTIONS(3308),
    [anon_sym_LT_LT] = ACTIONS(3308),
    [anon_sym_GT_GT] = ACTIONS(3308),
    [anon_sym_GT_GT_GT] = ACTIONS(3308),
    [anon_sym_AMP_CARET] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(3308),
    [anon_sym_PIPE_PIPE] = ACTIONS(3308),
    [anon_sym_or] = ACTIONS(3308),
    [sym_none] = ACTIONS(3308),
    [sym_true] = ACTIONS(3308),
    [sym_false] = ACTIONS(3308),
    [sym_nil] = ACTIONS(3308),
    [anon_sym_QMARK_DOT] = ACTIONS(3308),
    [anon_sym_POUND_LBRACK] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_DOLLARif] = ACTIONS(3308),
    [anon_sym_is] = ACTIONS(3308),
    [anon_sym_BANGis] = ACTIONS(3308),
    [anon_sym_in] = ACTIONS(3308),
    [anon_sym_BANGin] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_select] = ACTIONS(3308),
    [anon_sym_lock] = ACTIONS(3308),
    [anon_sym_rlock] = ACTIONS(3308),
    [anon_sym_unsafe] = ACTIONS(3308),
    [anon_sym_sql] = ACTIONS(3308),
    [sym_int_literal] = ACTIONS(3308),
    [sym_float_literal] = ACTIONS(3308),
    [sym_rune_literal] = ACTIONS(3308),
    [anon_sym_SQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_c_SQUOTE] = ACTIONS(3308),
    [anon_sym_c_DQUOTE] = ACTIONS(3308),
    [anon_sym_r_SQUOTE] = ACTIONS(3308),
    [anon_sym_r_DQUOTE] = ACTIONS(3308),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3308),
    [anon_sym_shared] = ACTIONS(3308),
    [anon_sym_map_LBRACK] = ACTIONS(3308),
    [anon_sym_chan] = ACTIONS(3308),
    [anon_sym_thread] = ACTIONS(3308),
    [anon_sym_atomic] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_defer] = ACTIONS(3308),
    [anon_sym_goto] = ACTIONS(3308),
    [anon_sym_break] = ACTIONS(3308),
    [anon_sym_continue] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_DOLLARfor] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_POUND] = ACTIONS(3308),
    [anon_sym_asm] = ACTIONS(3308),
    [anon_sym_AT_LBRACK] = ACTIONS(3308),
  },
  [1160] = {
    [sym_line_comment] = STATE(1160),
    [sym_block_comment] = STATE(1160),
    [ts_builtin_sym_end] = ACTIONS(2173),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LF] = ACTIONS(2175),
    [anon_sym_CR] = ACTIONS(2175),
    [anon_sym_CR_LF] = ACTIONS(2175),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2175),
    [anon_sym_as] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2175),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym_const] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym___global] = ACTIONS(2175),
    [anon_sym_type] = ACTIONS(2175),
    [anon_sym_fn] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2175),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_PERCENT] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_GT] = ACTIONS(2175),
    [anon_sym_EQ_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ] = ACTIONS(2175),
    [anon_sym_LT_EQ] = ACTIONS(2175),
    [anon_sym_GT_EQ] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2173),
    [anon_sym_struct] = ACTIONS(2175),
    [anon_sym_union] = ACTIONS(2175),
    [anon_sym_pub] = ACTIONS(2175),
    [anon_sym_mut] = ACTIONS(2175),
    [anon_sym_enum] = ACTIONS(2175),
    [anon_sym_interface] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [anon_sym_QMARK] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_go] = ACTIONS(2175),
    [anon_sym_spawn] = ACTIONS(2175),
    [anon_sym_json_DOTdecode] = ACTIONS(2175),
    [anon_sym_PIPE] = ACTIONS(2175),
    [anon_sym_LBRACK2] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_CARET] = ACTIONS(2175),
    [anon_sym_AMP] = ACTIONS(2175),
    [anon_sym_LT_DASH] = ACTIONS(2175),
    [anon_sym_LT_LT] = ACTIONS(2175),
    [anon_sym_GT_GT] = ACTIONS(2175),
    [anon_sym_GT_GT_GT] = ACTIONS(2175),
    [anon_sym_AMP_CARET] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(2175),
    [anon_sym_PIPE_PIPE] = ACTIONS(2175),
    [anon_sym_or] = ACTIONS(2175),
    [sym_none] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_nil] = ACTIONS(2175),
    [anon_sym_QMARK_DOT] = ACTIONS(2175),
    [anon_sym_POUND_LBRACK] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_DOLLARif] = ACTIONS(2175),
    [anon_sym_is] = ACTIONS(2175),
    [anon_sym_BANGis] = ACTIONS(2175),
    [anon_sym_in] = ACTIONS(2175),
    [anon_sym_BANGin] = ACTIONS(2175),
    [anon_sym_match] = ACTIONS(2175),
    [anon_sym_select] = ACTIONS(2175),
    [anon_sym_lock] = ACTIONS(2175),
    [anon_sym_rlock] = ACTIONS(2175),
    [anon_sym_unsafe] = ACTIONS(2175),
    [anon_sym_sql] = ACTIONS(2175),
    [sym_int_literal] = ACTIONS(2175),
    [sym_float_literal] = ACTIONS(2175),
    [sym_rune_literal] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_c_SQUOTE] = ACTIONS(2175),
    [anon_sym_c_DQUOTE] = ACTIONS(2175),
    [anon_sym_r_SQUOTE] = ACTIONS(2175),
    [anon_sym_r_DQUOTE] = ACTIONS(2175),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2175),
    [anon_sym_shared] = ACTIONS(2175),
    [anon_sym_map_LBRACK] = ACTIONS(2175),
    [anon_sym_chan] = ACTIONS(2175),
    [anon_sym_thread] = ACTIONS(2175),
    [anon_sym_atomic] = ACTIONS(2175),
    [anon_sym_assert] = ACTIONS(2175),
    [anon_sym_defer] = ACTIONS(2175),
    [anon_sym_goto] = ACTIONS(2175),
    [anon_sym_break] = ACTIONS(2175),
    [anon_sym_continue] = ACTIONS(2175),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_DOLLARfor] = ACTIONS(2175),
    [anon_sym_for] = ACTIONS(2175),
    [anon_sym_POUND] = ACTIONS(2175),
    [anon_sym_asm] = ACTIONS(2175),
    [anon_sym_AT_LBRACK] = ACTIONS(2175),
  },
  [1161] = {
    [sym_line_comment] = STATE(1161),
    [sym_block_comment] = STATE(1161),
    [ts_builtin_sym_end] = ACTIONS(3284),
    [sym_identifier] = ACTIONS(3286),
    [anon_sym_LF] = ACTIONS(3286),
    [anon_sym_CR] = ACTIONS(3286),
    [anon_sym_CR_LF] = ACTIONS(3286),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3286),
    [anon_sym_as] = ACTIONS(3286),
    [anon_sym_LBRACE] = ACTIONS(3286),
    [anon_sym_COMMA] = ACTIONS(3286),
    [anon_sym_const] = ACTIONS(3286),
    [anon_sym_LPAREN] = ACTIONS(3286),
    [anon_sym___global] = ACTIONS(3286),
    [anon_sym_type] = ACTIONS(3286),
    [anon_sym_fn] = ACTIONS(3286),
    [anon_sym_PLUS] = ACTIONS(3286),
    [anon_sym_DASH] = ACTIONS(3286),
    [anon_sym_STAR] = ACTIONS(3286),
    [anon_sym_SLASH] = ACTIONS(3286),
    [anon_sym_PERCENT] = ACTIONS(3286),
    [anon_sym_LT] = ACTIONS(3286),
    [anon_sym_GT] = ACTIONS(3286),
    [anon_sym_EQ_EQ] = ACTIONS(3286),
    [anon_sym_BANG_EQ] = ACTIONS(3286),
    [anon_sym_LT_EQ] = ACTIONS(3286),
    [anon_sym_GT_EQ] = ACTIONS(3286),
    [anon_sym_LBRACK] = ACTIONS(3284),
    [anon_sym_struct] = ACTIONS(3286),
    [anon_sym_union] = ACTIONS(3286),
    [anon_sym_pub] = ACTIONS(3286),
    [anon_sym_mut] = ACTIONS(3286),
    [anon_sym_enum] = ACTIONS(3286),
    [anon_sym_interface] = ACTIONS(3286),
    [anon_sym_PLUS_PLUS] = ACTIONS(3286),
    [anon_sym_DASH_DASH] = ACTIONS(3286),
    [anon_sym_QMARK] = ACTIONS(3286),
    [anon_sym_BANG] = ACTIONS(3286),
    [anon_sym_go] = ACTIONS(3286),
    [anon_sym_spawn] = ACTIONS(3286),
    [anon_sym_json_DOTdecode] = ACTIONS(3286),
    [anon_sym_PIPE] = ACTIONS(3286),
    [anon_sym_LBRACK2] = ACTIONS(3286),
    [anon_sym_TILDE] = ACTIONS(3286),
    [anon_sym_CARET] = ACTIONS(3286),
    [anon_sym_AMP] = ACTIONS(3286),
    [anon_sym_LT_DASH] = ACTIONS(3286),
    [anon_sym_LT_LT] = ACTIONS(3286),
    [anon_sym_GT_GT] = ACTIONS(3286),
    [anon_sym_GT_GT_GT] = ACTIONS(3286),
    [anon_sym_AMP_CARET] = ACTIONS(3286),
    [anon_sym_AMP_AMP] = ACTIONS(3286),
    [anon_sym_PIPE_PIPE] = ACTIONS(3286),
    [anon_sym_or] = ACTIONS(3286),
    [sym_none] = ACTIONS(3286),
    [sym_true] = ACTIONS(3286),
    [sym_false] = ACTIONS(3286),
    [sym_nil] = ACTIONS(3286),
    [anon_sym_QMARK_DOT] = ACTIONS(3286),
    [anon_sym_POUND_LBRACK] = ACTIONS(3286),
    [anon_sym_if] = ACTIONS(3286),
    [anon_sym_DOLLARif] = ACTIONS(3286),
    [anon_sym_is] = ACTIONS(3286),
    [anon_sym_BANGis] = ACTIONS(3286),
    [anon_sym_in] = ACTIONS(3286),
    [anon_sym_BANGin] = ACTIONS(3286),
    [anon_sym_match] = ACTIONS(3286),
    [anon_sym_select] = ACTIONS(3286),
    [anon_sym_lock] = ACTIONS(3286),
    [anon_sym_rlock] = ACTIONS(3286),
    [anon_sym_unsafe] = ACTIONS(3286),
    [anon_sym_sql] = ACTIONS(3286),
    [sym_int_literal] = ACTIONS(3286),
    [sym_float_literal] = ACTIONS(3286),
    [sym_rune_literal] = ACTIONS(3286),
    [anon_sym_SQUOTE] = ACTIONS(3286),
    [anon_sym_DQUOTE] = ACTIONS(3286),
    [anon_sym_c_SQUOTE] = ACTIONS(3286),
    [anon_sym_c_DQUOTE] = ACTIONS(3286),
    [anon_sym_r_SQUOTE] = ACTIONS(3286),
    [anon_sym_r_DQUOTE] = ACTIONS(3286),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3286),
    [anon_sym_shared] = ACTIONS(3286),
    [anon_sym_map_LBRACK] = ACTIONS(3286),
    [anon_sym_chan] = ACTIONS(3286),
    [anon_sym_thread] = ACTIONS(3286),
    [anon_sym_atomic] = ACTIONS(3286),
    [anon_sym_assert] = ACTIONS(3286),
    [anon_sym_defer] = ACTIONS(3286),
    [anon_sym_goto] = ACTIONS(3286),
    [anon_sym_break] = ACTIONS(3286),
    [anon_sym_continue] = ACTIONS(3286),
    [anon_sym_return] = ACTIONS(3286),
    [anon_sym_DOLLARfor] = ACTIONS(3286),
    [anon_sym_for] = ACTIONS(3286),
    [anon_sym_POUND] = ACTIONS(3286),
    [anon_sym_asm] = ACTIONS(3286),
    [anon_sym_AT_LBRACK] = ACTIONS(3286),
  },
  [1162] = {
    [sym_line_comment] = STATE(1162),
    [sym_block_comment] = STATE(1162),
    [ts_builtin_sym_end] = ACTIONS(2375),
    [sym_identifier] = ACTIONS(2377),
    [anon_sym_LF] = ACTIONS(2377),
    [anon_sym_CR] = ACTIONS(2377),
    [anon_sym_CR_LF] = ACTIONS(2377),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2377),
    [anon_sym_as] = ACTIONS(2377),
    [anon_sym_LBRACE] = ACTIONS(2377),
    [anon_sym_COMMA] = ACTIONS(2377),
    [anon_sym_const] = ACTIONS(2377),
    [anon_sym_LPAREN] = ACTIONS(2377),
    [anon_sym___global] = ACTIONS(2377),
    [anon_sym_type] = ACTIONS(2377),
    [anon_sym_fn] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2377),
    [anon_sym_DASH] = ACTIONS(2377),
    [anon_sym_STAR] = ACTIONS(2377),
    [anon_sym_SLASH] = ACTIONS(2377),
    [anon_sym_PERCENT] = ACTIONS(2377),
    [anon_sym_LT] = ACTIONS(2377),
    [anon_sym_GT] = ACTIONS(2377),
    [anon_sym_EQ_EQ] = ACTIONS(2377),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2377),
    [anon_sym_GT_EQ] = ACTIONS(2377),
    [anon_sym_LBRACK] = ACTIONS(2375),
    [anon_sym_struct] = ACTIONS(2377),
    [anon_sym_union] = ACTIONS(2377),
    [anon_sym_pub] = ACTIONS(2377),
    [anon_sym_mut] = ACTIONS(2377),
    [anon_sym_enum] = ACTIONS(2377),
    [anon_sym_interface] = ACTIONS(2377),
    [anon_sym_PLUS_PLUS] = ACTIONS(2377),
    [anon_sym_DASH_DASH] = ACTIONS(2377),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2377),
    [anon_sym_go] = ACTIONS(2377),
    [anon_sym_spawn] = ACTIONS(2377),
    [anon_sym_json_DOTdecode] = ACTIONS(2377),
    [anon_sym_PIPE] = ACTIONS(2377),
    [anon_sym_LBRACK2] = ACTIONS(2377),
    [anon_sym_TILDE] = ACTIONS(2377),
    [anon_sym_CARET] = ACTIONS(2377),
    [anon_sym_AMP] = ACTIONS(2377),
    [anon_sym_LT_DASH] = ACTIONS(2377),
    [anon_sym_LT_LT] = ACTIONS(2377),
    [anon_sym_GT_GT] = ACTIONS(2377),
    [anon_sym_GT_GT_GT] = ACTIONS(2377),
    [anon_sym_AMP_CARET] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_or] = ACTIONS(2377),
    [sym_none] = ACTIONS(2377),
    [sym_true] = ACTIONS(2377),
    [sym_false] = ACTIONS(2377),
    [sym_nil] = ACTIONS(2377),
    [anon_sym_QMARK_DOT] = ACTIONS(2377),
    [anon_sym_POUND_LBRACK] = ACTIONS(2377),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_DOLLARif] = ACTIONS(2377),
    [anon_sym_is] = ACTIONS(2377),
    [anon_sym_BANGis] = ACTIONS(2377),
    [anon_sym_in] = ACTIONS(2377),
    [anon_sym_BANGin] = ACTIONS(2377),
    [anon_sym_match] = ACTIONS(2377),
    [anon_sym_select] = ACTIONS(2377),
    [anon_sym_lock] = ACTIONS(2377),
    [anon_sym_rlock] = ACTIONS(2377),
    [anon_sym_unsafe] = ACTIONS(2377),
    [anon_sym_sql] = ACTIONS(2377),
    [sym_int_literal] = ACTIONS(2377),
    [sym_float_literal] = ACTIONS(2377),
    [sym_rune_literal] = ACTIONS(2377),
    [anon_sym_SQUOTE] = ACTIONS(2377),
    [anon_sym_DQUOTE] = ACTIONS(2377),
    [anon_sym_c_SQUOTE] = ACTIONS(2377),
    [anon_sym_c_DQUOTE] = ACTIONS(2377),
    [anon_sym_r_SQUOTE] = ACTIONS(2377),
    [anon_sym_r_DQUOTE] = ACTIONS(2377),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2377),
    [anon_sym_shared] = ACTIONS(2377),
    [anon_sym_map_LBRACK] = ACTIONS(2377),
    [anon_sym_chan] = ACTIONS(2377),
    [anon_sym_thread] = ACTIONS(2377),
    [anon_sym_atomic] = ACTIONS(2377),
    [anon_sym_assert] = ACTIONS(2377),
    [anon_sym_defer] = ACTIONS(2377),
    [anon_sym_goto] = ACTIONS(2377),
    [anon_sym_break] = ACTIONS(2377),
    [anon_sym_continue] = ACTIONS(2377),
    [anon_sym_return] = ACTIONS(2377),
    [anon_sym_DOLLARfor] = ACTIONS(2377),
    [anon_sym_for] = ACTIONS(2377),
    [anon_sym_POUND] = ACTIONS(2377),
    [anon_sym_asm] = ACTIONS(2377),
    [anon_sym_AT_LBRACK] = ACTIONS(2377),
  },
  [1163] = {
    [sym_line_comment] = STATE(1163),
    [sym_block_comment] = STATE(1163),
    [ts_builtin_sym_end] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3280),
    [anon_sym_LF] = ACTIONS(3280),
    [anon_sym_CR] = ACTIONS(3280),
    [anon_sym_CR_LF] = ACTIONS(3280),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3280),
    [anon_sym_as] = ACTIONS(3280),
    [anon_sym_LBRACE] = ACTIONS(3280),
    [anon_sym_COMMA] = ACTIONS(3280),
    [anon_sym_const] = ACTIONS(3280),
    [anon_sym_LPAREN] = ACTIONS(3280),
    [anon_sym___global] = ACTIONS(3280),
    [anon_sym_type] = ACTIONS(3280),
    [anon_sym_fn] = ACTIONS(3280),
    [anon_sym_PLUS] = ACTIONS(3280),
    [anon_sym_DASH] = ACTIONS(3280),
    [anon_sym_STAR] = ACTIONS(3280),
    [anon_sym_SLASH] = ACTIONS(3280),
    [anon_sym_PERCENT] = ACTIONS(3280),
    [anon_sym_LT] = ACTIONS(3280),
    [anon_sym_GT] = ACTIONS(3280),
    [anon_sym_EQ_EQ] = ACTIONS(3280),
    [anon_sym_BANG_EQ] = ACTIONS(3280),
    [anon_sym_LT_EQ] = ACTIONS(3280),
    [anon_sym_GT_EQ] = ACTIONS(3280),
    [anon_sym_LBRACK] = ACTIONS(3278),
    [anon_sym_struct] = ACTIONS(3280),
    [anon_sym_union] = ACTIONS(3280),
    [anon_sym_pub] = ACTIONS(3280),
    [anon_sym_mut] = ACTIONS(3280),
    [anon_sym_enum] = ACTIONS(3280),
    [anon_sym_interface] = ACTIONS(3280),
    [anon_sym_PLUS_PLUS] = ACTIONS(3280),
    [anon_sym_DASH_DASH] = ACTIONS(3280),
    [anon_sym_QMARK] = ACTIONS(3280),
    [anon_sym_BANG] = ACTIONS(3280),
    [anon_sym_go] = ACTIONS(3280),
    [anon_sym_spawn] = ACTIONS(3280),
    [anon_sym_json_DOTdecode] = ACTIONS(3280),
    [anon_sym_PIPE] = ACTIONS(3280),
    [anon_sym_LBRACK2] = ACTIONS(3280),
    [anon_sym_TILDE] = ACTIONS(3280),
    [anon_sym_CARET] = ACTIONS(3280),
    [anon_sym_AMP] = ACTIONS(3280),
    [anon_sym_LT_DASH] = ACTIONS(3280),
    [anon_sym_LT_LT] = ACTIONS(3280),
    [anon_sym_GT_GT] = ACTIONS(3280),
    [anon_sym_GT_GT_GT] = ACTIONS(3280),
    [anon_sym_AMP_CARET] = ACTIONS(3280),
    [anon_sym_AMP_AMP] = ACTIONS(3280),
    [anon_sym_PIPE_PIPE] = ACTIONS(3280),
    [anon_sym_or] = ACTIONS(3280),
    [sym_none] = ACTIONS(3280),
    [sym_true] = ACTIONS(3280),
    [sym_false] = ACTIONS(3280),
    [sym_nil] = ACTIONS(3280),
    [anon_sym_QMARK_DOT] = ACTIONS(3280),
    [anon_sym_POUND_LBRACK] = ACTIONS(3280),
    [anon_sym_if] = ACTIONS(3280),
    [anon_sym_DOLLARif] = ACTIONS(3280),
    [anon_sym_is] = ACTIONS(3280),
    [anon_sym_BANGis] = ACTIONS(3280),
    [anon_sym_in] = ACTIONS(3280),
    [anon_sym_BANGin] = ACTIONS(3280),
    [anon_sym_match] = ACTIONS(3280),
    [anon_sym_select] = ACTIONS(3280),
    [anon_sym_lock] = ACTIONS(3280),
    [anon_sym_rlock] = ACTIONS(3280),
    [anon_sym_unsafe] = ACTIONS(3280),
    [anon_sym_sql] = ACTIONS(3280),
    [sym_int_literal] = ACTIONS(3280),
    [sym_float_literal] = ACTIONS(3280),
    [sym_rune_literal] = ACTIONS(3280),
    [anon_sym_SQUOTE] = ACTIONS(3280),
    [anon_sym_DQUOTE] = ACTIONS(3280),
    [anon_sym_c_SQUOTE] = ACTIONS(3280),
    [anon_sym_c_DQUOTE] = ACTIONS(3280),
    [anon_sym_r_SQUOTE] = ACTIONS(3280),
    [anon_sym_r_DQUOTE] = ACTIONS(3280),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3280),
    [anon_sym_shared] = ACTIONS(3280),
    [anon_sym_map_LBRACK] = ACTIONS(3280),
    [anon_sym_chan] = ACTIONS(3280),
    [anon_sym_thread] = ACTIONS(3280),
    [anon_sym_atomic] = ACTIONS(3280),
    [anon_sym_assert] = ACTIONS(3280),
    [anon_sym_defer] = ACTIONS(3280),
    [anon_sym_goto] = ACTIONS(3280),
    [anon_sym_break] = ACTIONS(3280),
    [anon_sym_continue] = ACTIONS(3280),
    [anon_sym_return] = ACTIONS(3280),
    [anon_sym_DOLLARfor] = ACTIONS(3280),
    [anon_sym_for] = ACTIONS(3280),
    [anon_sym_POUND] = ACTIONS(3280),
    [anon_sym_asm] = ACTIONS(3280),
    [anon_sym_AT_LBRACK] = ACTIONS(3280),
  },
  [1164] = {
    [sym_line_comment] = STATE(1164),
    [sym_block_comment] = STATE(1164),
    [ts_builtin_sym_end] = ACTIONS(2949),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_LF] = ACTIONS(2951),
    [anon_sym_CR] = ACTIONS(2951),
    [anon_sym_CR_LF] = ACTIONS(2951),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2951),
    [anon_sym_as] = ACTIONS(2951),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2951),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym___global] = ACTIONS(2951),
    [anon_sym_type] = ACTIONS(2951),
    [anon_sym_fn] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_LT] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2949),
    [anon_sym_struct] = ACTIONS(2951),
    [anon_sym_union] = ACTIONS(2951),
    [anon_sym_pub] = ACTIONS(2951),
    [anon_sym_mut] = ACTIONS(2951),
    [anon_sym_enum] = ACTIONS(2951),
    [anon_sym_interface] = ACTIONS(2951),
    [anon_sym_PLUS_PLUS] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2951),
    [anon_sym_QMARK] = ACTIONS(2951),
    [anon_sym_BANG] = ACTIONS(2951),
    [anon_sym_go] = ACTIONS(2951),
    [anon_sym_spawn] = ACTIONS(2951),
    [anon_sym_json_DOTdecode] = ACTIONS(2951),
    [anon_sym_PIPE] = ACTIONS(2951),
    [anon_sym_LBRACK2] = ACTIONS(2951),
    [anon_sym_TILDE] = ACTIONS(2951),
    [anon_sym_CARET] = ACTIONS(2951),
    [anon_sym_AMP] = ACTIONS(2951),
    [anon_sym_LT_DASH] = ACTIONS(2951),
    [anon_sym_LT_LT] = ACTIONS(2951),
    [anon_sym_GT_GT] = ACTIONS(2951),
    [anon_sym_GT_GT_GT] = ACTIONS(2951),
    [anon_sym_AMP_CARET] = ACTIONS(2951),
    [anon_sym_AMP_AMP] = ACTIONS(2951),
    [anon_sym_PIPE_PIPE] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [sym_none] = ACTIONS(2951),
    [sym_true] = ACTIONS(2951),
    [sym_false] = ACTIONS(2951),
    [sym_nil] = ACTIONS(2951),
    [anon_sym_QMARK_DOT] = ACTIONS(2951),
    [anon_sym_POUND_LBRACK] = ACTIONS(2951),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_DOLLARif] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_BANGis] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_BANGin] = ACTIONS(2951),
    [anon_sym_match] = ACTIONS(2951),
    [anon_sym_select] = ACTIONS(2951),
    [anon_sym_lock] = ACTIONS(2951),
    [anon_sym_rlock] = ACTIONS(2951),
    [anon_sym_unsafe] = ACTIONS(2951),
    [anon_sym_sql] = ACTIONS(2951),
    [sym_int_literal] = ACTIONS(2951),
    [sym_float_literal] = ACTIONS(2951),
    [sym_rune_literal] = ACTIONS(2951),
    [anon_sym_SQUOTE] = ACTIONS(2951),
    [anon_sym_DQUOTE] = ACTIONS(2951),
    [anon_sym_c_SQUOTE] = ACTIONS(2951),
    [anon_sym_c_DQUOTE] = ACTIONS(2951),
    [anon_sym_r_SQUOTE] = ACTIONS(2951),
    [anon_sym_r_DQUOTE] = ACTIONS(2951),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2951),
    [anon_sym_shared] = ACTIONS(2951),
    [anon_sym_map_LBRACK] = ACTIONS(2951),
    [anon_sym_chan] = ACTIONS(2951),
    [anon_sym_thread] = ACTIONS(2951),
    [anon_sym_atomic] = ACTIONS(2951),
    [anon_sym_assert] = ACTIONS(2951),
    [anon_sym_defer] = ACTIONS(2951),
    [anon_sym_goto] = ACTIONS(2951),
    [anon_sym_break] = ACTIONS(2951),
    [anon_sym_continue] = ACTIONS(2951),
    [anon_sym_return] = ACTIONS(2951),
    [anon_sym_DOLLARfor] = ACTIONS(2951),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_POUND] = ACTIONS(2951),
    [anon_sym_asm] = ACTIONS(2951),
    [anon_sym_AT_LBRACK] = ACTIONS(2951),
  },
  [1165] = {
    [sym_line_comment] = STATE(1165),
    [sym_block_comment] = STATE(1165),
    [ts_builtin_sym_end] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [anon_sym_LF] = ACTIONS(2929),
    [anon_sym_CR] = ACTIONS(2929),
    [anon_sym_CR_LF] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2929),
    [anon_sym_as] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2929),
    [anon_sym_COMMA] = ACTIONS(2929),
    [anon_sym_const] = ACTIONS(2929),
    [anon_sym_LPAREN] = ACTIONS(2929),
    [anon_sym___global] = ACTIONS(2929),
    [anon_sym_type] = ACTIONS(2929),
    [anon_sym_fn] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2929),
    [anon_sym_GT] = ACTIONS(2929),
    [anon_sym_EQ_EQ] = ACTIONS(2929),
    [anon_sym_BANG_EQ] = ACTIONS(2929),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2929),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2929),
    [anon_sym_union] = ACTIONS(2929),
    [anon_sym_pub] = ACTIONS(2929),
    [anon_sym_mut] = ACTIONS(2929),
    [anon_sym_enum] = ACTIONS(2929),
    [anon_sym_interface] = ACTIONS(2929),
    [anon_sym_PLUS_PLUS] = ACTIONS(2929),
    [anon_sym_DASH_DASH] = ACTIONS(2929),
    [anon_sym_QMARK] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2929),
    [anon_sym_go] = ACTIONS(2929),
    [anon_sym_spawn] = ACTIONS(2929),
    [anon_sym_json_DOTdecode] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(2929),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2929),
    [anon_sym_CARET] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_LT_DASH] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(2929),
    [anon_sym_GT_GT] = ACTIONS(2929),
    [anon_sym_GT_GT_GT] = ACTIONS(2929),
    [anon_sym_AMP_CARET] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_or] = ACTIONS(2929),
    [sym_none] = ACTIONS(2929),
    [sym_true] = ACTIONS(2929),
    [sym_false] = ACTIONS(2929),
    [sym_nil] = ACTIONS(2929),
    [anon_sym_QMARK_DOT] = ACTIONS(2929),
    [anon_sym_POUND_LBRACK] = ACTIONS(2929),
    [anon_sym_if] = ACTIONS(2929),
    [anon_sym_DOLLARif] = ACTIONS(2929),
    [anon_sym_is] = ACTIONS(2929),
    [anon_sym_BANGis] = ACTIONS(2929),
    [anon_sym_in] = ACTIONS(2929),
    [anon_sym_BANGin] = ACTIONS(2929),
    [anon_sym_match] = ACTIONS(2929),
    [anon_sym_select] = ACTIONS(2929),
    [anon_sym_lock] = ACTIONS(2929),
    [anon_sym_rlock] = ACTIONS(2929),
    [anon_sym_unsafe] = ACTIONS(2929),
    [anon_sym_sql] = ACTIONS(2929),
    [sym_int_literal] = ACTIONS(2929),
    [sym_float_literal] = ACTIONS(2929),
    [sym_rune_literal] = ACTIONS(2929),
    [anon_sym_SQUOTE] = ACTIONS(2929),
    [anon_sym_DQUOTE] = ACTIONS(2929),
    [anon_sym_c_SQUOTE] = ACTIONS(2929),
    [anon_sym_c_DQUOTE] = ACTIONS(2929),
    [anon_sym_r_SQUOTE] = ACTIONS(2929),
    [anon_sym_r_DQUOTE] = ACTIONS(2929),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2929),
    [anon_sym_shared] = ACTIONS(2929),
    [anon_sym_map_LBRACK] = ACTIONS(2929),
    [anon_sym_chan] = ACTIONS(2929),
    [anon_sym_thread] = ACTIONS(2929),
    [anon_sym_atomic] = ACTIONS(2929),
    [anon_sym_assert] = ACTIONS(2929),
    [anon_sym_defer] = ACTIONS(2929),
    [anon_sym_goto] = ACTIONS(2929),
    [anon_sym_break] = ACTIONS(2929),
    [anon_sym_continue] = ACTIONS(2929),
    [anon_sym_return] = ACTIONS(2929),
    [anon_sym_DOLLARfor] = ACTIONS(2929),
    [anon_sym_for] = ACTIONS(2929),
    [anon_sym_POUND] = ACTIONS(2929),
    [anon_sym_asm] = ACTIONS(2929),
    [anon_sym_AT_LBRACK] = ACTIONS(2929),
  },
  [1166] = {
    [sym_line_comment] = STATE(1166),
    [sym_block_comment] = STATE(1166),
    [ts_builtin_sym_end] = ACTIONS(2879),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_LF] = ACTIONS(2881),
    [anon_sym_CR] = ACTIONS(2881),
    [anon_sym_CR_LF] = ACTIONS(2881),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2881),
    [anon_sym_as] = ACTIONS(2881),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_const] = ACTIONS(2881),
    [anon_sym_LPAREN] = ACTIONS(2881),
    [anon_sym___global] = ACTIONS(2881),
    [anon_sym_type] = ACTIONS(2881),
    [anon_sym_fn] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_SLASH] = ACTIONS(2881),
    [anon_sym_PERCENT] = ACTIONS(2881),
    [anon_sym_LT] = ACTIONS(2881),
    [anon_sym_GT] = ACTIONS(2881),
    [anon_sym_EQ_EQ] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_LT_EQ] = ACTIONS(2881),
    [anon_sym_GT_EQ] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_struct] = ACTIONS(2881),
    [anon_sym_union] = ACTIONS(2881),
    [anon_sym_pub] = ACTIONS(2881),
    [anon_sym_mut] = ACTIONS(2881),
    [anon_sym_enum] = ACTIONS(2881),
    [anon_sym_interface] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_go] = ACTIONS(2881),
    [anon_sym_spawn] = ACTIONS(2881),
    [anon_sym_json_DOTdecode] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2881),
    [anon_sym_LBRACK2] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_CARET] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2881),
    [anon_sym_LT_DASH] = ACTIONS(2881),
    [anon_sym_LT_LT] = ACTIONS(2881),
    [anon_sym_GT_GT] = ACTIONS(2881),
    [anon_sym_GT_GT_GT] = ACTIONS(2881),
    [anon_sym_AMP_CARET] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2881),
    [sym_none] = ACTIONS(2881),
    [sym_true] = ACTIONS(2881),
    [sym_false] = ACTIONS(2881),
    [sym_nil] = ACTIONS(2881),
    [anon_sym_QMARK_DOT] = ACTIONS(2881),
    [anon_sym_POUND_LBRACK] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_DOLLARif] = ACTIONS(2881),
    [anon_sym_is] = ACTIONS(2881),
    [anon_sym_BANGis] = ACTIONS(2881),
    [anon_sym_in] = ACTIONS(2881),
    [anon_sym_BANGin] = ACTIONS(2881),
    [anon_sym_match] = ACTIONS(2881),
    [anon_sym_select] = ACTIONS(2881),
    [anon_sym_lock] = ACTIONS(2881),
    [anon_sym_rlock] = ACTIONS(2881),
    [anon_sym_unsafe] = ACTIONS(2881),
    [anon_sym_sql] = ACTIONS(2881),
    [sym_int_literal] = ACTIONS(2881),
    [sym_float_literal] = ACTIONS(2881),
    [sym_rune_literal] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_c_SQUOTE] = ACTIONS(2881),
    [anon_sym_c_DQUOTE] = ACTIONS(2881),
    [anon_sym_r_SQUOTE] = ACTIONS(2881),
    [anon_sym_r_DQUOTE] = ACTIONS(2881),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2881),
    [anon_sym_shared] = ACTIONS(2881),
    [anon_sym_map_LBRACK] = ACTIONS(2881),
    [anon_sym_chan] = ACTIONS(2881),
    [anon_sym_thread] = ACTIONS(2881),
    [anon_sym_atomic] = ACTIONS(2881),
    [anon_sym_assert] = ACTIONS(2881),
    [anon_sym_defer] = ACTIONS(2881),
    [anon_sym_goto] = ACTIONS(2881),
    [anon_sym_break] = ACTIONS(2881),
    [anon_sym_continue] = ACTIONS(2881),
    [anon_sym_return] = ACTIONS(2881),
    [anon_sym_DOLLARfor] = ACTIONS(2881),
    [anon_sym_for] = ACTIONS(2881),
    [anon_sym_POUND] = ACTIONS(2881),
    [anon_sym_asm] = ACTIONS(2881),
    [anon_sym_AT_LBRACK] = ACTIONS(2881),
  },
  [1167] = {
    [sym_line_comment] = STATE(1167),
    [sym_block_comment] = STATE(1167),
    [ts_builtin_sym_end] = ACTIONS(2381),
    [sym_identifier] = ACTIONS(2383),
    [anon_sym_LF] = ACTIONS(2383),
    [anon_sym_CR] = ACTIONS(2383),
    [anon_sym_CR_LF] = ACTIONS(2383),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2383),
    [anon_sym_as] = ACTIONS(2383),
    [anon_sym_LBRACE] = ACTIONS(2383),
    [anon_sym_COMMA] = ACTIONS(2383),
    [anon_sym_const] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2383),
    [anon_sym___global] = ACTIONS(2383),
    [anon_sym_type] = ACTIONS(2383),
    [anon_sym_fn] = ACTIONS(2383),
    [anon_sym_PLUS] = ACTIONS(2383),
    [anon_sym_DASH] = ACTIONS(2383),
    [anon_sym_STAR] = ACTIONS(2383),
    [anon_sym_SLASH] = ACTIONS(2383),
    [anon_sym_PERCENT] = ACTIONS(2383),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_GT] = ACTIONS(2383),
    [anon_sym_EQ_EQ] = ACTIONS(2383),
    [anon_sym_BANG_EQ] = ACTIONS(2383),
    [anon_sym_LT_EQ] = ACTIONS(2383),
    [anon_sym_GT_EQ] = ACTIONS(2383),
    [anon_sym_LBRACK] = ACTIONS(2381),
    [anon_sym_struct] = ACTIONS(2383),
    [anon_sym_union] = ACTIONS(2383),
    [anon_sym_pub] = ACTIONS(2383),
    [anon_sym_mut] = ACTIONS(2383),
    [anon_sym_enum] = ACTIONS(2383),
    [anon_sym_interface] = ACTIONS(2383),
    [anon_sym_PLUS_PLUS] = ACTIONS(2383),
    [anon_sym_DASH_DASH] = ACTIONS(2383),
    [anon_sym_QMARK] = ACTIONS(2383),
    [anon_sym_BANG] = ACTIONS(2383),
    [anon_sym_go] = ACTIONS(2383),
    [anon_sym_spawn] = ACTIONS(2383),
    [anon_sym_json_DOTdecode] = ACTIONS(2383),
    [anon_sym_PIPE] = ACTIONS(2383),
    [anon_sym_LBRACK2] = ACTIONS(2383),
    [anon_sym_TILDE] = ACTIONS(2383),
    [anon_sym_CARET] = ACTIONS(2383),
    [anon_sym_AMP] = ACTIONS(2383),
    [anon_sym_LT_DASH] = ACTIONS(2383),
    [anon_sym_LT_LT] = ACTIONS(2383),
    [anon_sym_GT_GT] = ACTIONS(2383),
    [anon_sym_GT_GT_GT] = ACTIONS(2383),
    [anon_sym_AMP_CARET] = ACTIONS(2383),
    [anon_sym_AMP_AMP] = ACTIONS(2383),
    [anon_sym_PIPE_PIPE] = ACTIONS(2383),
    [anon_sym_or] = ACTIONS(2383),
    [sym_none] = ACTIONS(2383),
    [sym_true] = ACTIONS(2383),
    [sym_false] = ACTIONS(2383),
    [sym_nil] = ACTIONS(2383),
    [anon_sym_QMARK_DOT] = ACTIONS(2383),
    [anon_sym_POUND_LBRACK] = ACTIONS(2383),
    [anon_sym_if] = ACTIONS(2383),
    [anon_sym_DOLLARif] = ACTIONS(2383),
    [anon_sym_is] = ACTIONS(2383),
    [anon_sym_BANGis] = ACTIONS(2383),
    [anon_sym_in] = ACTIONS(2383),
    [anon_sym_BANGin] = ACTIONS(2383),
    [anon_sym_match] = ACTIONS(2383),
    [anon_sym_select] = ACTIONS(2383),
    [anon_sym_lock] = ACTIONS(2383),
    [anon_sym_rlock] = ACTIONS(2383),
    [anon_sym_unsafe] = ACTIONS(2383),
    [anon_sym_sql] = ACTIONS(2383),
    [sym_int_literal] = ACTIONS(2383),
    [sym_float_literal] = ACTIONS(2383),
    [sym_rune_literal] = ACTIONS(2383),
    [anon_sym_SQUOTE] = ACTIONS(2383),
    [anon_sym_DQUOTE] = ACTIONS(2383),
    [anon_sym_c_SQUOTE] = ACTIONS(2383),
    [anon_sym_c_DQUOTE] = ACTIONS(2383),
    [anon_sym_r_SQUOTE] = ACTIONS(2383),
    [anon_sym_r_DQUOTE] = ACTIONS(2383),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2383),
    [anon_sym_shared] = ACTIONS(2383),
    [anon_sym_map_LBRACK] = ACTIONS(2383),
    [anon_sym_chan] = ACTIONS(2383),
    [anon_sym_thread] = ACTIONS(2383),
    [anon_sym_atomic] = ACTIONS(2383),
    [anon_sym_assert] = ACTIONS(2383),
    [anon_sym_defer] = ACTIONS(2383),
    [anon_sym_goto] = ACTIONS(2383),
    [anon_sym_break] = ACTIONS(2383),
    [anon_sym_continue] = ACTIONS(2383),
    [anon_sym_return] = ACTIONS(2383),
    [anon_sym_DOLLARfor] = ACTIONS(2383),
    [anon_sym_for] = ACTIONS(2383),
    [anon_sym_POUND] = ACTIONS(2383),
    [anon_sym_asm] = ACTIONS(2383),
    [anon_sym_AT_LBRACK] = ACTIONS(2383),
  },
  [1168] = {
    [sym_line_comment] = STATE(1168),
    [sym_block_comment] = STATE(1168),
    [ts_builtin_sym_end] = ACTIONS(2637),
    [sym_identifier] = ACTIONS(2639),
    [anon_sym_LF] = ACTIONS(2639),
    [anon_sym_CR] = ACTIONS(2639),
    [anon_sym_CR_LF] = ACTIONS(2639),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2639),
    [anon_sym_as] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2639),
    [anon_sym_COMMA] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(2639),
    [anon_sym___global] = ACTIONS(2639),
    [anon_sym_type] = ACTIONS(2639),
    [anon_sym_fn] = ACTIONS(2639),
    [anon_sym_PLUS] = ACTIONS(2639),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_SLASH] = ACTIONS(2639),
    [anon_sym_PERCENT] = ACTIONS(2639),
    [anon_sym_LT] = ACTIONS(2639),
    [anon_sym_GT] = ACTIONS(2639),
    [anon_sym_EQ_EQ] = ACTIONS(2639),
    [anon_sym_BANG_EQ] = ACTIONS(2639),
    [anon_sym_LT_EQ] = ACTIONS(2639),
    [anon_sym_GT_EQ] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [anon_sym_pub] = ACTIONS(2639),
    [anon_sym_mut] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_interface] = ACTIONS(2639),
    [anon_sym_PLUS_PLUS] = ACTIONS(2639),
    [anon_sym_DASH_DASH] = ACTIONS(2639),
    [anon_sym_QMARK] = ACTIONS(2639),
    [anon_sym_BANG] = ACTIONS(2639),
    [anon_sym_go] = ACTIONS(2639),
    [anon_sym_spawn] = ACTIONS(2639),
    [anon_sym_json_DOTdecode] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_LBRACK2] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_LT_DASH] = ACTIONS(2639),
    [anon_sym_LT_LT] = ACTIONS(2639),
    [anon_sym_GT_GT] = ACTIONS(2639),
    [anon_sym_GT_GT_GT] = ACTIONS(2639),
    [anon_sym_AMP_CARET] = ACTIONS(2639),
    [anon_sym_AMP_AMP] = ACTIONS(2639),
    [anon_sym_PIPE_PIPE] = ACTIONS(2639),
    [anon_sym_or] = ACTIONS(2639),
    [sym_none] = ACTIONS(2639),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [sym_nil] = ACTIONS(2639),
    [anon_sym_QMARK_DOT] = ACTIONS(2639),
    [anon_sym_POUND_LBRACK] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2639),
    [anon_sym_DOLLARif] = ACTIONS(2639),
    [anon_sym_is] = ACTIONS(2639),
    [anon_sym_BANGis] = ACTIONS(2639),
    [anon_sym_in] = ACTIONS(2639),
    [anon_sym_BANGin] = ACTIONS(2639),
    [anon_sym_match] = ACTIONS(2639),
    [anon_sym_select] = ACTIONS(2639),
    [anon_sym_lock] = ACTIONS(2639),
    [anon_sym_rlock] = ACTIONS(2639),
    [anon_sym_unsafe] = ACTIONS(2639),
    [anon_sym_sql] = ACTIONS(2639),
    [sym_int_literal] = ACTIONS(2639),
    [sym_float_literal] = ACTIONS(2639),
    [sym_rune_literal] = ACTIONS(2639),
    [anon_sym_SQUOTE] = ACTIONS(2639),
    [anon_sym_DQUOTE] = ACTIONS(2639),
    [anon_sym_c_SQUOTE] = ACTIONS(2639),
    [anon_sym_c_DQUOTE] = ACTIONS(2639),
    [anon_sym_r_SQUOTE] = ACTIONS(2639),
    [anon_sym_r_DQUOTE] = ACTIONS(2639),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2639),
    [anon_sym_shared] = ACTIONS(2639),
    [anon_sym_map_LBRACK] = ACTIONS(2639),
    [anon_sym_chan] = ACTIONS(2639),
    [anon_sym_thread] = ACTIONS(2639),
    [anon_sym_atomic] = ACTIONS(2639),
    [anon_sym_assert] = ACTIONS(2639),
    [anon_sym_defer] = ACTIONS(2639),
    [anon_sym_goto] = ACTIONS(2639),
    [anon_sym_break] = ACTIONS(2639),
    [anon_sym_continue] = ACTIONS(2639),
    [anon_sym_return] = ACTIONS(2639),
    [anon_sym_DOLLARfor] = ACTIONS(2639),
    [anon_sym_for] = ACTIONS(2639),
    [anon_sym_POUND] = ACTIONS(2639),
    [anon_sym_asm] = ACTIONS(2639),
    [anon_sym_AT_LBRACK] = ACTIONS(2639),
  },
  [1169] = {
    [sym_line_comment] = STATE(1169),
    [sym_block_comment] = STATE(1169),
    [ts_builtin_sym_end] = ACTIONS(2629),
    [sym_identifier] = ACTIONS(2631),
    [anon_sym_LF] = ACTIONS(2631),
    [anon_sym_CR] = ACTIONS(2631),
    [anon_sym_CR_LF] = ACTIONS(2631),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2631),
    [anon_sym_as] = ACTIONS(2631),
    [anon_sym_LBRACE] = ACTIONS(2631),
    [anon_sym_COMMA] = ACTIONS(2631),
    [anon_sym_const] = ACTIONS(2631),
    [anon_sym_LPAREN] = ACTIONS(2631),
    [anon_sym___global] = ACTIONS(2631),
    [anon_sym_type] = ACTIONS(2631),
    [anon_sym_fn] = ACTIONS(2631),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_DASH] = ACTIONS(2631),
    [anon_sym_STAR] = ACTIONS(2631),
    [anon_sym_SLASH] = ACTIONS(2631),
    [anon_sym_PERCENT] = ACTIONS(2631),
    [anon_sym_LT] = ACTIONS(2631),
    [anon_sym_GT] = ACTIONS(2631),
    [anon_sym_EQ_EQ] = ACTIONS(2631),
    [anon_sym_BANG_EQ] = ACTIONS(2631),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LBRACK] = ACTIONS(2629),
    [anon_sym_struct] = ACTIONS(2631),
    [anon_sym_union] = ACTIONS(2631),
    [anon_sym_pub] = ACTIONS(2631),
    [anon_sym_mut] = ACTIONS(2631),
    [anon_sym_enum] = ACTIONS(2631),
    [anon_sym_interface] = ACTIONS(2631),
    [anon_sym_PLUS_PLUS] = ACTIONS(2631),
    [anon_sym_DASH_DASH] = ACTIONS(2631),
    [anon_sym_QMARK] = ACTIONS(2631),
    [anon_sym_BANG] = ACTIONS(2631),
    [anon_sym_go] = ACTIONS(2631),
    [anon_sym_spawn] = ACTIONS(2631),
    [anon_sym_json_DOTdecode] = ACTIONS(2631),
    [anon_sym_PIPE] = ACTIONS(2631),
    [anon_sym_LBRACK2] = ACTIONS(2631),
    [anon_sym_TILDE] = ACTIONS(2631),
    [anon_sym_CARET] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2631),
    [anon_sym_LT_DASH] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2631),
    [anon_sym_GT_GT] = ACTIONS(2631),
    [anon_sym_GT_GT_GT] = ACTIONS(2631),
    [anon_sym_AMP_CARET] = ACTIONS(2631),
    [anon_sym_AMP_AMP] = ACTIONS(2631),
    [anon_sym_PIPE_PIPE] = ACTIONS(2631),
    [anon_sym_or] = ACTIONS(2631),
    [sym_none] = ACTIONS(2631),
    [sym_true] = ACTIONS(2631),
    [sym_false] = ACTIONS(2631),
    [sym_nil] = ACTIONS(2631),
    [anon_sym_QMARK_DOT] = ACTIONS(2631),
    [anon_sym_POUND_LBRACK] = ACTIONS(2631),
    [anon_sym_if] = ACTIONS(2631),
    [anon_sym_DOLLARif] = ACTIONS(2631),
    [anon_sym_is] = ACTIONS(2631),
    [anon_sym_BANGis] = ACTIONS(2631),
    [anon_sym_in] = ACTIONS(2631),
    [anon_sym_BANGin] = ACTIONS(2631),
    [anon_sym_match] = ACTIONS(2631),
    [anon_sym_select] = ACTIONS(2631),
    [anon_sym_lock] = ACTIONS(2631),
    [anon_sym_rlock] = ACTIONS(2631),
    [anon_sym_unsafe] = ACTIONS(2631),
    [anon_sym_sql] = ACTIONS(2631),
    [sym_int_literal] = ACTIONS(2631),
    [sym_float_literal] = ACTIONS(2631),
    [sym_rune_literal] = ACTIONS(2631),
    [anon_sym_SQUOTE] = ACTIONS(2631),
    [anon_sym_DQUOTE] = ACTIONS(2631),
    [anon_sym_c_SQUOTE] = ACTIONS(2631),
    [anon_sym_c_DQUOTE] = ACTIONS(2631),
    [anon_sym_r_SQUOTE] = ACTIONS(2631),
    [anon_sym_r_DQUOTE] = ACTIONS(2631),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2631),
    [anon_sym_shared] = ACTIONS(2631),
    [anon_sym_map_LBRACK] = ACTIONS(2631),
    [anon_sym_chan] = ACTIONS(2631),
    [anon_sym_thread] = ACTIONS(2631),
    [anon_sym_atomic] = ACTIONS(2631),
    [anon_sym_assert] = ACTIONS(2631),
    [anon_sym_defer] = ACTIONS(2631),
    [anon_sym_goto] = ACTIONS(2631),
    [anon_sym_break] = ACTIONS(2631),
    [anon_sym_continue] = ACTIONS(2631),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_DOLLARfor] = ACTIONS(2631),
    [anon_sym_for] = ACTIONS(2631),
    [anon_sym_POUND] = ACTIONS(2631),
    [anon_sym_asm] = ACTIONS(2631),
    [anon_sym_AT_LBRACK] = ACTIONS(2631),
  },
  [1170] = {
    [sym_line_comment] = STATE(1170),
    [sym_block_comment] = STATE(1170),
    [ts_builtin_sym_end] = ACTIONS(2983),
    [sym_identifier] = ACTIONS(2985),
    [anon_sym_LF] = ACTIONS(2985),
    [anon_sym_CR] = ACTIONS(2985),
    [anon_sym_CR_LF] = ACTIONS(2985),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_as] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym___global] = ACTIONS(2985),
    [anon_sym_type] = ACTIONS(2985),
    [anon_sym_fn] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2985),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_PERCENT] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_EQ_EQ] = ACTIONS(2985),
    [anon_sym_BANG_EQ] = ACTIONS(2985),
    [anon_sym_LT_EQ] = ACTIONS(2985),
    [anon_sym_GT_EQ] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_union] = ACTIONS(2985),
    [anon_sym_pub] = ACTIONS(2985),
    [anon_sym_mut] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [anon_sym_interface] = ACTIONS(2985),
    [anon_sym_PLUS_PLUS] = ACTIONS(2985),
    [anon_sym_DASH_DASH] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_go] = ACTIONS(2985),
    [anon_sym_spawn] = ACTIONS(2985),
    [anon_sym_json_DOTdecode] = ACTIONS(2985),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(2985),
    [anon_sym_CARET] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_DASH] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2985),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_GT_GT_GT] = ACTIONS(2985),
    [anon_sym_AMP_CARET] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_or] = ACTIONS(2985),
    [sym_none] = ACTIONS(2985),
    [sym_true] = ACTIONS(2985),
    [sym_false] = ACTIONS(2985),
    [sym_nil] = ACTIONS(2985),
    [anon_sym_QMARK_DOT] = ACTIONS(2985),
    [anon_sym_POUND_LBRACK] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_DOLLARif] = ACTIONS(2985),
    [anon_sym_is] = ACTIONS(2985),
    [anon_sym_BANGis] = ACTIONS(2985),
    [anon_sym_in] = ACTIONS(2985),
    [anon_sym_BANGin] = ACTIONS(2985),
    [anon_sym_match] = ACTIONS(2985),
    [anon_sym_select] = ACTIONS(2985),
    [anon_sym_lock] = ACTIONS(2985),
    [anon_sym_rlock] = ACTIONS(2985),
    [anon_sym_unsafe] = ACTIONS(2985),
    [anon_sym_sql] = ACTIONS(2985),
    [sym_int_literal] = ACTIONS(2985),
    [sym_float_literal] = ACTIONS(2985),
    [sym_rune_literal] = ACTIONS(2985),
    [anon_sym_SQUOTE] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_c_SQUOTE] = ACTIONS(2985),
    [anon_sym_c_DQUOTE] = ACTIONS(2985),
    [anon_sym_r_SQUOTE] = ACTIONS(2985),
    [anon_sym_r_DQUOTE] = ACTIONS(2985),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2985),
    [anon_sym_shared] = ACTIONS(2985),
    [anon_sym_map_LBRACK] = ACTIONS(2985),
    [anon_sym_chan] = ACTIONS(2985),
    [anon_sym_thread] = ACTIONS(2985),
    [anon_sym_atomic] = ACTIONS(2985),
    [anon_sym_assert] = ACTIONS(2985),
    [anon_sym_defer] = ACTIONS(2985),
    [anon_sym_goto] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_DOLLARfor] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_POUND] = ACTIONS(2985),
    [anon_sym_asm] = ACTIONS(2985),
    [anon_sym_AT_LBRACK] = ACTIONS(2985),
  },
  [1171] = {
    [sym_line_comment] = STATE(1171),
    [sym_block_comment] = STATE(1171),
    [ts_builtin_sym_end] = ACTIONS(2667),
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_LF] = ACTIONS(2669),
    [anon_sym_CR] = ACTIONS(2669),
    [anon_sym_CR_LF] = ACTIONS(2669),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2669),
    [anon_sym_as] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2669),
    [anon_sym_COMMA] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_LPAREN] = ACTIONS(2669),
    [anon_sym___global] = ACTIONS(2669),
    [anon_sym_type] = ACTIONS(2669),
    [anon_sym_fn] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2669),
    [anon_sym_SLASH] = ACTIONS(2669),
    [anon_sym_PERCENT] = ACTIONS(2669),
    [anon_sym_LT] = ACTIONS(2669),
    [anon_sym_GT] = ACTIONS(2669),
    [anon_sym_EQ_EQ] = ACTIONS(2669),
    [anon_sym_BANG_EQ] = ACTIONS(2669),
    [anon_sym_LT_EQ] = ACTIONS(2669),
    [anon_sym_GT_EQ] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2667),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_union] = ACTIONS(2669),
    [anon_sym_pub] = ACTIONS(2669),
    [anon_sym_mut] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [anon_sym_interface] = ACTIONS(2669),
    [anon_sym_PLUS_PLUS] = ACTIONS(2669),
    [anon_sym_DASH_DASH] = ACTIONS(2669),
    [anon_sym_QMARK] = ACTIONS(2669),
    [anon_sym_BANG] = ACTIONS(2669),
    [anon_sym_go] = ACTIONS(2669),
    [anon_sym_spawn] = ACTIONS(2669),
    [anon_sym_json_DOTdecode] = ACTIONS(2669),
    [anon_sym_PIPE] = ACTIONS(2669),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_TILDE] = ACTIONS(2669),
    [anon_sym_CARET] = ACTIONS(2669),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_LT_DASH] = ACTIONS(2669),
    [anon_sym_LT_LT] = ACTIONS(2669),
    [anon_sym_GT_GT] = ACTIONS(2669),
    [anon_sym_GT_GT_GT] = ACTIONS(2669),
    [anon_sym_AMP_CARET] = ACTIONS(2669),
    [anon_sym_AMP_AMP] = ACTIONS(2669),
    [anon_sym_PIPE_PIPE] = ACTIONS(2669),
    [anon_sym_or] = ACTIONS(2669),
    [sym_none] = ACTIONS(2669),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [sym_nil] = ACTIONS(2669),
    [anon_sym_QMARK_DOT] = ACTIONS(2669),
    [anon_sym_POUND_LBRACK] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_DOLLARif] = ACTIONS(2669),
    [anon_sym_is] = ACTIONS(2669),
    [anon_sym_BANGis] = ACTIONS(2669),
    [anon_sym_in] = ACTIONS(2669),
    [anon_sym_BANGin] = ACTIONS(2669),
    [anon_sym_match] = ACTIONS(2669),
    [anon_sym_select] = ACTIONS(2669),
    [anon_sym_lock] = ACTIONS(2669),
    [anon_sym_rlock] = ACTIONS(2669),
    [anon_sym_unsafe] = ACTIONS(2669),
    [anon_sym_sql] = ACTIONS(2669),
    [sym_int_literal] = ACTIONS(2669),
    [sym_float_literal] = ACTIONS(2669),
    [sym_rune_literal] = ACTIONS(2669),
    [anon_sym_SQUOTE] = ACTIONS(2669),
    [anon_sym_DQUOTE] = ACTIONS(2669),
    [anon_sym_c_SQUOTE] = ACTIONS(2669),
    [anon_sym_c_DQUOTE] = ACTIONS(2669),
    [anon_sym_r_SQUOTE] = ACTIONS(2669),
    [anon_sym_r_DQUOTE] = ACTIONS(2669),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2669),
    [anon_sym_shared] = ACTIONS(2669),
    [anon_sym_map_LBRACK] = ACTIONS(2669),
    [anon_sym_chan] = ACTIONS(2669),
    [anon_sym_thread] = ACTIONS(2669),
    [anon_sym_atomic] = ACTIONS(2669),
    [anon_sym_assert] = ACTIONS(2669),
    [anon_sym_defer] = ACTIONS(2669),
    [anon_sym_goto] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_DOLLARfor] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_POUND] = ACTIONS(2669),
    [anon_sym_asm] = ACTIONS(2669),
    [anon_sym_AT_LBRACK] = ACTIONS(2669),
  },
  [1172] = {
    [sym_line_comment] = STATE(1172),
    [sym_block_comment] = STATE(1172),
    [ts_builtin_sym_end] = ACTIONS(2625),
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_LF] = ACTIONS(2627),
    [anon_sym_CR] = ACTIONS(2627),
    [anon_sym_CR_LF] = ACTIONS(2627),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2627),
    [anon_sym_as] = ACTIONS(2627),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_COMMA] = ACTIONS(2627),
    [anon_sym_const] = ACTIONS(2627),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym___global] = ACTIONS(2627),
    [anon_sym_type] = ACTIONS(2627),
    [anon_sym_fn] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_SLASH] = ACTIONS(2627),
    [anon_sym_PERCENT] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2627),
    [anon_sym_GT] = ACTIONS(2627),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT_EQ] = ACTIONS(2627),
    [anon_sym_GT_EQ] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2625),
    [anon_sym_struct] = ACTIONS(2627),
    [anon_sym_union] = ACTIONS(2627),
    [anon_sym_pub] = ACTIONS(2627),
    [anon_sym_mut] = ACTIONS(2627),
    [anon_sym_enum] = ACTIONS(2627),
    [anon_sym_interface] = ACTIONS(2627),
    [anon_sym_PLUS_PLUS] = ACTIONS(2627),
    [anon_sym_DASH_DASH] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2627),
    [anon_sym_BANG] = ACTIONS(2627),
    [anon_sym_go] = ACTIONS(2627),
    [anon_sym_spawn] = ACTIONS(2627),
    [anon_sym_json_DOTdecode] = ACTIONS(2627),
    [anon_sym_PIPE] = ACTIONS(2627),
    [anon_sym_LBRACK2] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2627),
    [anon_sym_CARET] = ACTIONS(2627),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_LT_DASH] = ACTIONS(2627),
    [anon_sym_LT_LT] = ACTIONS(2627),
    [anon_sym_GT_GT] = ACTIONS(2627),
    [anon_sym_GT_GT_GT] = ACTIONS(2627),
    [anon_sym_AMP_CARET] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_PIPE_PIPE] = ACTIONS(2627),
    [anon_sym_or] = ACTIONS(2627),
    [sym_none] = ACTIONS(2627),
    [sym_true] = ACTIONS(2627),
    [sym_false] = ACTIONS(2627),
    [sym_nil] = ACTIONS(2627),
    [anon_sym_QMARK_DOT] = ACTIONS(2627),
    [anon_sym_POUND_LBRACK] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_DOLLARif] = ACTIONS(2627),
    [anon_sym_is] = ACTIONS(2627),
    [anon_sym_BANGis] = ACTIONS(2627),
    [anon_sym_in] = ACTIONS(2627),
    [anon_sym_BANGin] = ACTIONS(2627),
    [anon_sym_match] = ACTIONS(2627),
    [anon_sym_select] = ACTIONS(2627),
    [anon_sym_lock] = ACTIONS(2627),
    [anon_sym_rlock] = ACTIONS(2627),
    [anon_sym_unsafe] = ACTIONS(2627),
    [anon_sym_sql] = ACTIONS(2627),
    [sym_int_literal] = ACTIONS(2627),
    [sym_float_literal] = ACTIONS(2627),
    [sym_rune_literal] = ACTIONS(2627),
    [anon_sym_SQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [anon_sym_c_SQUOTE] = ACTIONS(2627),
    [anon_sym_c_DQUOTE] = ACTIONS(2627),
    [anon_sym_r_SQUOTE] = ACTIONS(2627),
    [anon_sym_r_DQUOTE] = ACTIONS(2627),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2627),
    [anon_sym_shared] = ACTIONS(2627),
    [anon_sym_map_LBRACK] = ACTIONS(2627),
    [anon_sym_chan] = ACTIONS(2627),
    [anon_sym_thread] = ACTIONS(2627),
    [anon_sym_atomic] = ACTIONS(2627),
    [anon_sym_assert] = ACTIONS(2627),
    [anon_sym_defer] = ACTIONS(2627),
    [anon_sym_goto] = ACTIONS(2627),
    [anon_sym_break] = ACTIONS(2627),
    [anon_sym_continue] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_DOLLARfor] = ACTIONS(2627),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_POUND] = ACTIONS(2627),
    [anon_sym_asm] = ACTIONS(2627),
    [anon_sym_AT_LBRACK] = ACTIONS(2627),
  },
  [1173] = {
    [sym_line_comment] = STATE(1173),
    [sym_block_comment] = STATE(1173),
    [ts_builtin_sym_end] = ACTIONS(2463),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_LF] = ACTIONS(2465),
    [anon_sym_CR] = ACTIONS(2465),
    [anon_sym_CR_LF] = ACTIONS(2465),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2465),
    [anon_sym_as] = ACTIONS(2465),
    [anon_sym_LBRACE] = ACTIONS(2465),
    [anon_sym_COMMA] = ACTIONS(2465),
    [anon_sym_const] = ACTIONS(2465),
    [anon_sym_LPAREN] = ACTIONS(2465),
    [anon_sym___global] = ACTIONS(2465),
    [anon_sym_type] = ACTIONS(2465),
    [anon_sym_fn] = ACTIONS(2465),
    [anon_sym_PLUS] = ACTIONS(2465),
    [anon_sym_DASH] = ACTIONS(2465),
    [anon_sym_STAR] = ACTIONS(2465),
    [anon_sym_SLASH] = ACTIONS(2465),
    [anon_sym_PERCENT] = ACTIONS(2465),
    [anon_sym_LT] = ACTIONS(2465),
    [anon_sym_GT] = ACTIONS(2465),
    [anon_sym_EQ_EQ] = ACTIONS(2465),
    [anon_sym_BANG_EQ] = ACTIONS(2465),
    [anon_sym_LT_EQ] = ACTIONS(2465),
    [anon_sym_GT_EQ] = ACTIONS(2465),
    [anon_sym_LBRACK] = ACTIONS(2463),
    [anon_sym_struct] = ACTIONS(2465),
    [anon_sym_union] = ACTIONS(2465),
    [anon_sym_pub] = ACTIONS(2465),
    [anon_sym_mut] = ACTIONS(2465),
    [anon_sym_enum] = ACTIONS(2465),
    [anon_sym_interface] = ACTIONS(2465),
    [anon_sym_PLUS_PLUS] = ACTIONS(2465),
    [anon_sym_DASH_DASH] = ACTIONS(2465),
    [anon_sym_QMARK] = ACTIONS(2465),
    [anon_sym_BANG] = ACTIONS(2465),
    [anon_sym_go] = ACTIONS(2465),
    [anon_sym_spawn] = ACTIONS(2465),
    [anon_sym_json_DOTdecode] = ACTIONS(2465),
    [anon_sym_PIPE] = ACTIONS(2465),
    [anon_sym_LBRACK2] = ACTIONS(2465),
    [anon_sym_TILDE] = ACTIONS(2465),
    [anon_sym_CARET] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_LT_DASH] = ACTIONS(2465),
    [anon_sym_LT_LT] = ACTIONS(2465),
    [anon_sym_GT_GT] = ACTIONS(2465),
    [anon_sym_GT_GT_GT] = ACTIONS(2465),
    [anon_sym_AMP_CARET] = ACTIONS(2465),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_PIPE_PIPE] = ACTIONS(2465),
    [anon_sym_or] = ACTIONS(2465),
    [sym_none] = ACTIONS(2465),
    [sym_true] = ACTIONS(2465),
    [sym_false] = ACTIONS(2465),
    [sym_nil] = ACTIONS(2465),
    [anon_sym_QMARK_DOT] = ACTIONS(2465),
    [anon_sym_POUND_LBRACK] = ACTIONS(2465),
    [anon_sym_if] = ACTIONS(2465),
    [anon_sym_DOLLARif] = ACTIONS(2465),
    [anon_sym_is] = ACTIONS(2465),
    [anon_sym_BANGis] = ACTIONS(2465),
    [anon_sym_in] = ACTIONS(2465),
    [anon_sym_BANGin] = ACTIONS(2465),
    [anon_sym_match] = ACTIONS(2465),
    [anon_sym_select] = ACTIONS(2465),
    [anon_sym_lock] = ACTIONS(2465),
    [anon_sym_rlock] = ACTIONS(2465),
    [anon_sym_unsafe] = ACTIONS(2465),
    [anon_sym_sql] = ACTIONS(2465),
    [sym_int_literal] = ACTIONS(2465),
    [sym_float_literal] = ACTIONS(2465),
    [sym_rune_literal] = ACTIONS(2465),
    [anon_sym_SQUOTE] = ACTIONS(2465),
    [anon_sym_DQUOTE] = ACTIONS(2465),
    [anon_sym_c_SQUOTE] = ACTIONS(2465),
    [anon_sym_c_DQUOTE] = ACTIONS(2465),
    [anon_sym_r_SQUOTE] = ACTIONS(2465),
    [anon_sym_r_DQUOTE] = ACTIONS(2465),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2465),
    [anon_sym_shared] = ACTIONS(2465),
    [anon_sym_map_LBRACK] = ACTIONS(2465),
    [anon_sym_chan] = ACTIONS(2465),
    [anon_sym_thread] = ACTIONS(2465),
    [anon_sym_atomic] = ACTIONS(2465),
    [anon_sym_assert] = ACTIONS(2465),
    [anon_sym_defer] = ACTIONS(2465),
    [anon_sym_goto] = ACTIONS(2465),
    [anon_sym_break] = ACTIONS(2465),
    [anon_sym_continue] = ACTIONS(2465),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_DOLLARfor] = ACTIONS(2465),
    [anon_sym_for] = ACTIONS(2465),
    [anon_sym_POUND] = ACTIONS(2465),
    [anon_sym_asm] = ACTIONS(2465),
    [anon_sym_AT_LBRACK] = ACTIONS(2465),
  },
  [1174] = {
    [sym_line_comment] = STATE(1174),
    [sym_block_comment] = STATE(1174),
    [ts_builtin_sym_end] = ACTIONS(2173),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LF] = ACTIONS(2175),
    [anon_sym_CR] = ACTIONS(2175),
    [anon_sym_CR_LF] = ACTIONS(2175),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2175),
    [anon_sym_as] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2177),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym_const] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym___global] = ACTIONS(2175),
    [anon_sym_type] = ACTIONS(2175),
    [anon_sym_fn] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2175),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_PERCENT] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_GT] = ACTIONS(2175),
    [anon_sym_EQ_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ] = ACTIONS(2175),
    [anon_sym_LT_EQ] = ACTIONS(2175),
    [anon_sym_GT_EQ] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2180),
    [anon_sym_struct] = ACTIONS(2175),
    [anon_sym_union] = ACTIONS(2175),
    [anon_sym_pub] = ACTIONS(2175),
    [anon_sym_mut] = ACTIONS(2175),
    [anon_sym_enum] = ACTIONS(2175),
    [anon_sym_interface] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [anon_sym_QMARK] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_go] = ACTIONS(2175),
    [anon_sym_spawn] = ACTIONS(2175),
    [anon_sym_json_DOTdecode] = ACTIONS(2175),
    [anon_sym_PIPE] = ACTIONS(2175),
    [anon_sym_LBRACK2] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_CARET] = ACTIONS(2175),
    [anon_sym_AMP] = ACTIONS(2175),
    [anon_sym_LT_DASH] = ACTIONS(2175),
    [anon_sym_LT_LT] = ACTIONS(2175),
    [anon_sym_GT_GT] = ACTIONS(2175),
    [anon_sym_GT_GT_GT] = ACTIONS(2175),
    [anon_sym_AMP_CARET] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(2175),
    [anon_sym_PIPE_PIPE] = ACTIONS(2175),
    [anon_sym_or] = ACTIONS(2175),
    [sym_none] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_nil] = ACTIONS(2175),
    [anon_sym_QMARK_DOT] = ACTIONS(2175),
    [anon_sym_POUND_LBRACK] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_DOLLARif] = ACTIONS(2175),
    [anon_sym_is] = ACTIONS(2175),
    [anon_sym_BANGis] = ACTIONS(2175),
    [anon_sym_in] = ACTIONS(2175),
    [anon_sym_BANGin] = ACTIONS(2175),
    [anon_sym_match] = ACTIONS(2175),
    [anon_sym_select] = ACTIONS(2175),
    [anon_sym_lock] = ACTIONS(2175),
    [anon_sym_rlock] = ACTIONS(2175),
    [anon_sym_unsafe] = ACTIONS(2175),
    [anon_sym_sql] = ACTIONS(2175),
    [sym_int_literal] = ACTIONS(2175),
    [sym_float_literal] = ACTIONS(2175),
    [sym_rune_literal] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_c_SQUOTE] = ACTIONS(2175),
    [anon_sym_c_DQUOTE] = ACTIONS(2175),
    [anon_sym_r_SQUOTE] = ACTIONS(2175),
    [anon_sym_r_DQUOTE] = ACTIONS(2175),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2175),
    [anon_sym_shared] = ACTIONS(2175),
    [anon_sym_map_LBRACK] = ACTIONS(2175),
    [anon_sym_chan] = ACTIONS(2175),
    [anon_sym_thread] = ACTIONS(2175),
    [anon_sym_atomic] = ACTIONS(2175),
    [anon_sym_assert] = ACTIONS(2175),
    [anon_sym_defer] = ACTIONS(2175),
    [anon_sym_goto] = ACTIONS(2175),
    [anon_sym_break] = ACTIONS(2175),
    [anon_sym_continue] = ACTIONS(2175),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_DOLLARfor] = ACTIONS(2175),
    [anon_sym_for] = ACTIONS(2175),
    [anon_sym_POUND] = ACTIONS(2175),
    [anon_sym_asm] = ACTIONS(2175),
    [anon_sym_AT_LBRACK] = ACTIONS(2175),
  },
  [1175] = {
    [sym_line_comment] = STATE(1175),
    [sym_block_comment] = STATE(1175),
    [ts_builtin_sym_end] = ACTIONS(3043),
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_LF] = ACTIONS(3045),
    [anon_sym_CR] = ACTIONS(3045),
    [anon_sym_CR_LF] = ACTIONS(3045),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_as] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3045),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_const] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3045),
    [anon_sym___global] = ACTIONS(3045),
    [anon_sym_type] = ACTIONS(3045),
    [anon_sym_fn] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3045),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_PERCENT] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_GT] = ACTIONS(3045),
    [anon_sym_EQ_EQ] = ACTIONS(3045),
    [anon_sym_BANG_EQ] = ACTIONS(3045),
    [anon_sym_LT_EQ] = ACTIONS(3045),
    [anon_sym_GT_EQ] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_struct] = ACTIONS(3045),
    [anon_sym_union] = ACTIONS(3045),
    [anon_sym_pub] = ACTIONS(3045),
    [anon_sym_mut] = ACTIONS(3045),
    [anon_sym_enum] = ACTIONS(3045),
    [anon_sym_interface] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3045),
    [anon_sym_go] = ACTIONS(3045),
    [anon_sym_spawn] = ACTIONS(3045),
    [anon_sym_json_DOTdecode] = ACTIONS(3045),
    [anon_sym_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACK2] = ACTIONS(3045),
    [anon_sym_TILDE] = ACTIONS(3045),
    [anon_sym_CARET] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3045),
    [anon_sym_LT_DASH] = ACTIONS(3045),
    [anon_sym_LT_LT] = ACTIONS(3045),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_GT_GT_GT] = ACTIONS(3045),
    [anon_sym_AMP_CARET] = ACTIONS(3045),
    [anon_sym_AMP_AMP] = ACTIONS(3045),
    [anon_sym_PIPE_PIPE] = ACTIONS(3045),
    [anon_sym_or] = ACTIONS(3045),
    [sym_none] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_nil] = ACTIONS(3045),
    [anon_sym_QMARK_DOT] = ACTIONS(3045),
    [anon_sym_POUND_LBRACK] = ACTIONS(3045),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_DOLLARif] = ACTIONS(3045),
    [anon_sym_is] = ACTIONS(3045),
    [anon_sym_BANGis] = ACTIONS(3045),
    [anon_sym_in] = ACTIONS(3045),
    [anon_sym_BANGin] = ACTIONS(3045),
    [anon_sym_match] = ACTIONS(3045),
    [anon_sym_select] = ACTIONS(3045),
    [anon_sym_lock] = ACTIONS(3045),
    [anon_sym_rlock] = ACTIONS(3045),
    [anon_sym_unsafe] = ACTIONS(3045),
    [anon_sym_sql] = ACTIONS(3045),
    [sym_int_literal] = ACTIONS(3045),
    [sym_float_literal] = ACTIONS(3045),
    [sym_rune_literal] = ACTIONS(3045),
    [anon_sym_SQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE] = ACTIONS(3045),
    [anon_sym_c_SQUOTE] = ACTIONS(3045),
    [anon_sym_c_DQUOTE] = ACTIONS(3045),
    [anon_sym_r_SQUOTE] = ACTIONS(3045),
    [anon_sym_r_DQUOTE] = ACTIONS(3045),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3045),
    [anon_sym_shared] = ACTIONS(3045),
    [anon_sym_map_LBRACK] = ACTIONS(3045),
    [anon_sym_chan] = ACTIONS(3045),
    [anon_sym_thread] = ACTIONS(3045),
    [anon_sym_atomic] = ACTIONS(3045),
    [anon_sym_assert] = ACTIONS(3045),
    [anon_sym_defer] = ACTIONS(3045),
    [anon_sym_goto] = ACTIONS(3045),
    [anon_sym_break] = ACTIONS(3045),
    [anon_sym_continue] = ACTIONS(3045),
    [anon_sym_return] = ACTIONS(3045),
    [anon_sym_DOLLARfor] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3045),
    [anon_sym_POUND] = ACTIONS(3045),
    [anon_sym_asm] = ACTIONS(3045),
    [anon_sym_AT_LBRACK] = ACTIONS(3045),
  },
  [1176] = {
    [sym_line_comment] = STATE(1176),
    [sym_block_comment] = STATE(1176),
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2647),
    [anon_sym_LF] = ACTIONS(2647),
    [anon_sym_CR] = ACTIONS(2647),
    [anon_sym_CR_LF] = ACTIONS(2647),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2647),
    [anon_sym_as] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_const] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym___global] = ACTIONS(2647),
    [anon_sym_type] = ACTIONS(2647),
    [anon_sym_fn] = ACTIONS(2647),
    [anon_sym_PLUS] = ACTIONS(2647),
    [anon_sym_DASH] = ACTIONS(2647),
    [anon_sym_STAR] = ACTIONS(2647),
    [anon_sym_SLASH] = ACTIONS(2647),
    [anon_sym_PERCENT] = ACTIONS(2647),
    [anon_sym_LT] = ACTIONS(2647),
    [anon_sym_GT] = ACTIONS(2647),
    [anon_sym_EQ_EQ] = ACTIONS(2647),
    [anon_sym_BANG_EQ] = ACTIONS(2647),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_struct] = ACTIONS(2647),
    [anon_sym_union] = ACTIONS(2647),
    [anon_sym_pub] = ACTIONS(2647),
    [anon_sym_mut] = ACTIONS(2647),
    [anon_sym_enum] = ACTIONS(2647),
    [anon_sym_interface] = ACTIONS(2647),
    [anon_sym_PLUS_PLUS] = ACTIONS(2647),
    [anon_sym_DASH_DASH] = ACTIONS(2647),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_go] = ACTIONS(2647),
    [anon_sym_spawn] = ACTIONS(2647),
    [anon_sym_json_DOTdecode] = ACTIONS(2647),
    [anon_sym_PIPE] = ACTIONS(2647),
    [anon_sym_LBRACK2] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [anon_sym_CARET] = ACTIONS(2647),
    [anon_sym_AMP] = ACTIONS(2647),
    [anon_sym_LT_DASH] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2647),
    [anon_sym_GT_GT] = ACTIONS(2647),
    [anon_sym_GT_GT_GT] = ACTIONS(2647),
    [anon_sym_AMP_CARET] = ACTIONS(2647),
    [anon_sym_AMP_AMP] = ACTIONS(2647),
    [anon_sym_PIPE_PIPE] = ACTIONS(2647),
    [anon_sym_or] = ACTIONS(2647),
    [sym_none] = ACTIONS(2647),
    [sym_true] = ACTIONS(2647),
    [sym_false] = ACTIONS(2647),
    [sym_nil] = ACTIONS(2647),
    [anon_sym_QMARK_DOT] = ACTIONS(2647),
    [anon_sym_POUND_LBRACK] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(2647),
    [anon_sym_DOLLARif] = ACTIONS(2647),
    [anon_sym_is] = ACTIONS(2647),
    [anon_sym_BANGis] = ACTIONS(2647),
    [anon_sym_in] = ACTIONS(2647),
    [anon_sym_BANGin] = ACTIONS(2647),
    [anon_sym_match] = ACTIONS(2647),
    [anon_sym_select] = ACTIONS(2647),
    [anon_sym_lock] = ACTIONS(2647),
    [anon_sym_rlock] = ACTIONS(2647),
    [anon_sym_unsafe] = ACTIONS(2647),
    [anon_sym_sql] = ACTIONS(2647),
    [sym_int_literal] = ACTIONS(2647),
    [sym_float_literal] = ACTIONS(2647),
    [sym_rune_literal] = ACTIONS(2647),
    [anon_sym_SQUOTE] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(2647),
    [anon_sym_c_SQUOTE] = ACTIONS(2647),
    [anon_sym_c_DQUOTE] = ACTIONS(2647),
    [anon_sym_r_SQUOTE] = ACTIONS(2647),
    [anon_sym_r_DQUOTE] = ACTIONS(2647),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2647),
    [anon_sym_shared] = ACTIONS(2647),
    [anon_sym_map_LBRACK] = ACTIONS(2647),
    [anon_sym_chan] = ACTIONS(2647),
    [anon_sym_thread] = ACTIONS(2647),
    [anon_sym_atomic] = ACTIONS(2647),
    [anon_sym_assert] = ACTIONS(2647),
    [anon_sym_defer] = ACTIONS(2647),
    [anon_sym_goto] = ACTIONS(2647),
    [anon_sym_break] = ACTIONS(2647),
    [anon_sym_continue] = ACTIONS(2647),
    [anon_sym_return] = ACTIONS(2647),
    [anon_sym_DOLLARfor] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2647),
    [anon_sym_POUND] = ACTIONS(2647),
    [anon_sym_asm] = ACTIONS(2647),
    [anon_sym_AT_LBRACK] = ACTIONS(2647),
  },
  [1177] = {
    [sym_line_comment] = STATE(1177),
    [sym_block_comment] = STATE(1177),
    [ts_builtin_sym_end] = ACTIONS(2649),
    [sym_identifier] = ACTIONS(2651),
    [anon_sym_LF] = ACTIONS(2651),
    [anon_sym_CR] = ACTIONS(2651),
    [anon_sym_CR_LF] = ACTIONS(2651),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2651),
    [anon_sym_as] = ACTIONS(2651),
    [anon_sym_LBRACE] = ACTIONS(2651),
    [anon_sym_COMMA] = ACTIONS(2651),
    [anon_sym_const] = ACTIONS(2651),
    [anon_sym_LPAREN] = ACTIONS(2651),
    [anon_sym___global] = ACTIONS(2651),
    [anon_sym_type] = ACTIONS(2651),
    [anon_sym_fn] = ACTIONS(2651),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_STAR] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2651),
    [anon_sym_PERCENT] = ACTIONS(2651),
    [anon_sym_LT] = ACTIONS(2651),
    [anon_sym_GT] = ACTIONS(2651),
    [anon_sym_EQ_EQ] = ACTIONS(2651),
    [anon_sym_BANG_EQ] = ACTIONS(2651),
    [anon_sym_LT_EQ] = ACTIONS(2651),
    [anon_sym_GT_EQ] = ACTIONS(2651),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_struct] = ACTIONS(2651),
    [anon_sym_union] = ACTIONS(2651),
    [anon_sym_pub] = ACTIONS(2651),
    [anon_sym_mut] = ACTIONS(2651),
    [anon_sym_enum] = ACTIONS(2651),
    [anon_sym_interface] = ACTIONS(2651),
    [anon_sym_PLUS_PLUS] = ACTIONS(2651),
    [anon_sym_DASH_DASH] = ACTIONS(2651),
    [anon_sym_QMARK] = ACTIONS(2651),
    [anon_sym_BANG] = ACTIONS(2651),
    [anon_sym_go] = ACTIONS(2651),
    [anon_sym_spawn] = ACTIONS(2651),
    [anon_sym_json_DOTdecode] = ACTIONS(2651),
    [anon_sym_PIPE] = ACTIONS(2651),
    [anon_sym_LBRACK2] = ACTIONS(2651),
    [anon_sym_TILDE] = ACTIONS(2651),
    [anon_sym_CARET] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2651),
    [anon_sym_LT_DASH] = ACTIONS(2651),
    [anon_sym_LT_LT] = ACTIONS(2651),
    [anon_sym_GT_GT] = ACTIONS(2651),
    [anon_sym_GT_GT_GT] = ACTIONS(2651),
    [anon_sym_AMP_CARET] = ACTIONS(2651),
    [anon_sym_AMP_AMP] = ACTIONS(2651),
    [anon_sym_PIPE_PIPE] = ACTIONS(2651),
    [anon_sym_or] = ACTIONS(2651),
    [sym_none] = ACTIONS(2651),
    [sym_true] = ACTIONS(2651),
    [sym_false] = ACTIONS(2651),
    [sym_nil] = ACTIONS(2651),
    [anon_sym_QMARK_DOT] = ACTIONS(2651),
    [anon_sym_POUND_LBRACK] = ACTIONS(2651),
    [anon_sym_if] = ACTIONS(2651),
    [anon_sym_DOLLARif] = ACTIONS(2651),
    [anon_sym_is] = ACTIONS(2651),
    [anon_sym_BANGis] = ACTIONS(2651),
    [anon_sym_in] = ACTIONS(2651),
    [anon_sym_BANGin] = ACTIONS(2651),
    [anon_sym_match] = ACTIONS(2651),
    [anon_sym_select] = ACTIONS(2651),
    [anon_sym_lock] = ACTIONS(2651),
    [anon_sym_rlock] = ACTIONS(2651),
    [anon_sym_unsafe] = ACTIONS(2651),
    [anon_sym_sql] = ACTIONS(2651),
    [sym_int_literal] = ACTIONS(2651),
    [sym_float_literal] = ACTIONS(2651),
    [sym_rune_literal] = ACTIONS(2651),
    [anon_sym_SQUOTE] = ACTIONS(2651),
    [anon_sym_DQUOTE] = ACTIONS(2651),
    [anon_sym_c_SQUOTE] = ACTIONS(2651),
    [anon_sym_c_DQUOTE] = ACTIONS(2651),
    [anon_sym_r_SQUOTE] = ACTIONS(2651),
    [anon_sym_r_DQUOTE] = ACTIONS(2651),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2651),
    [anon_sym_shared] = ACTIONS(2651),
    [anon_sym_map_LBRACK] = ACTIONS(2651),
    [anon_sym_chan] = ACTIONS(2651),
    [anon_sym_thread] = ACTIONS(2651),
    [anon_sym_atomic] = ACTIONS(2651),
    [anon_sym_assert] = ACTIONS(2651),
    [anon_sym_defer] = ACTIONS(2651),
    [anon_sym_goto] = ACTIONS(2651),
    [anon_sym_break] = ACTIONS(2651),
    [anon_sym_continue] = ACTIONS(2651),
    [anon_sym_return] = ACTIONS(2651),
    [anon_sym_DOLLARfor] = ACTIONS(2651),
    [anon_sym_for] = ACTIONS(2651),
    [anon_sym_POUND] = ACTIONS(2651),
    [anon_sym_asm] = ACTIONS(2651),
    [anon_sym_AT_LBRACK] = ACTIONS(2651),
  },
  [1178] = {
    [sym_line_comment] = STATE(1178),
    [sym_block_comment] = STATE(1178),
    [ts_builtin_sym_end] = ACTIONS(3047),
    [sym_identifier] = ACTIONS(3049),
    [anon_sym_LF] = ACTIONS(3049),
    [anon_sym_CR] = ACTIONS(3049),
    [anon_sym_CR_LF] = ACTIONS(3049),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3049),
    [anon_sym_as] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_COMMA] = ACTIONS(3049),
    [anon_sym_const] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [anon_sym___global] = ACTIONS(3049),
    [anon_sym_type] = ACTIONS(3049),
    [anon_sym_fn] = ACTIONS(3049),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_STAR] = ACTIONS(3049),
    [anon_sym_SLASH] = ACTIONS(3049),
    [anon_sym_PERCENT] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_GT] = ACTIONS(3049),
    [anon_sym_EQ_EQ] = ACTIONS(3049),
    [anon_sym_BANG_EQ] = ACTIONS(3049),
    [anon_sym_LT_EQ] = ACTIONS(3049),
    [anon_sym_GT_EQ] = ACTIONS(3049),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_struct] = ACTIONS(3049),
    [anon_sym_union] = ACTIONS(3049),
    [anon_sym_pub] = ACTIONS(3049),
    [anon_sym_mut] = ACTIONS(3049),
    [anon_sym_enum] = ACTIONS(3049),
    [anon_sym_interface] = ACTIONS(3049),
    [anon_sym_PLUS_PLUS] = ACTIONS(3049),
    [anon_sym_DASH_DASH] = ACTIONS(3049),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_BANG] = ACTIONS(3049),
    [anon_sym_go] = ACTIONS(3049),
    [anon_sym_spawn] = ACTIONS(3049),
    [anon_sym_json_DOTdecode] = ACTIONS(3049),
    [anon_sym_PIPE] = ACTIONS(3049),
    [anon_sym_LBRACK2] = ACTIONS(3049),
    [anon_sym_TILDE] = ACTIONS(3049),
    [anon_sym_CARET] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_LT_DASH] = ACTIONS(3049),
    [anon_sym_LT_LT] = ACTIONS(3049),
    [anon_sym_GT_GT] = ACTIONS(3049),
    [anon_sym_GT_GT_GT] = ACTIONS(3049),
    [anon_sym_AMP_CARET] = ACTIONS(3049),
    [anon_sym_AMP_AMP] = ACTIONS(3049),
    [anon_sym_PIPE_PIPE] = ACTIONS(3049),
    [anon_sym_or] = ACTIONS(3049),
    [sym_none] = ACTIONS(3049),
    [sym_true] = ACTIONS(3049),
    [sym_false] = ACTIONS(3049),
    [sym_nil] = ACTIONS(3049),
    [anon_sym_QMARK_DOT] = ACTIONS(3049),
    [anon_sym_POUND_LBRACK] = ACTIONS(3049),
    [anon_sym_if] = ACTIONS(3049),
    [anon_sym_DOLLARif] = ACTIONS(3049),
    [anon_sym_is] = ACTIONS(3049),
    [anon_sym_BANGis] = ACTIONS(3049),
    [anon_sym_in] = ACTIONS(3049),
    [anon_sym_BANGin] = ACTIONS(3049),
    [anon_sym_match] = ACTIONS(3049),
    [anon_sym_select] = ACTIONS(3049),
    [anon_sym_lock] = ACTIONS(3049),
    [anon_sym_rlock] = ACTIONS(3049),
    [anon_sym_unsafe] = ACTIONS(3049),
    [anon_sym_sql] = ACTIONS(3049),
    [sym_int_literal] = ACTIONS(3049),
    [sym_float_literal] = ACTIONS(3049),
    [sym_rune_literal] = ACTIONS(3049),
    [anon_sym_SQUOTE] = ACTIONS(3049),
    [anon_sym_DQUOTE] = ACTIONS(3049),
    [anon_sym_c_SQUOTE] = ACTIONS(3049),
    [anon_sym_c_DQUOTE] = ACTIONS(3049),
    [anon_sym_r_SQUOTE] = ACTIONS(3049),
    [anon_sym_r_DQUOTE] = ACTIONS(3049),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3049),
    [anon_sym_shared] = ACTIONS(3049),
    [anon_sym_map_LBRACK] = ACTIONS(3049),
    [anon_sym_chan] = ACTIONS(3049),
    [anon_sym_thread] = ACTIONS(3049),
    [anon_sym_atomic] = ACTIONS(3049),
    [anon_sym_assert] = ACTIONS(3049),
    [anon_sym_defer] = ACTIONS(3049),
    [anon_sym_goto] = ACTIONS(3049),
    [anon_sym_break] = ACTIONS(3049),
    [anon_sym_continue] = ACTIONS(3049),
    [anon_sym_return] = ACTIONS(3049),
    [anon_sym_DOLLARfor] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3049),
    [anon_sym_POUND] = ACTIONS(3049),
    [anon_sym_asm] = ACTIONS(3049),
    [anon_sym_AT_LBRACK] = ACTIONS(3049),
  },
  [1179] = {
    [sym_line_comment] = STATE(1179),
    [sym_block_comment] = STATE(1179),
    [ts_builtin_sym_end] = ACTIONS(3053),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_LF] = ACTIONS(3055),
    [anon_sym_CR] = ACTIONS(3055),
    [anon_sym_CR_LF] = ACTIONS(3055),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_as] = ACTIONS(3055),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3055),
    [anon_sym_const] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym___global] = ACTIONS(3055),
    [anon_sym_type] = ACTIONS(3055),
    [anon_sym_fn] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3055),
    [anon_sym_SLASH] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(3055),
    [anon_sym_GT] = ACTIONS(3055),
    [anon_sym_EQ_EQ] = ACTIONS(3055),
    [anon_sym_BANG_EQ] = ACTIONS(3055),
    [anon_sym_LT_EQ] = ACTIONS(3055),
    [anon_sym_GT_EQ] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_struct] = ACTIONS(3055),
    [anon_sym_union] = ACTIONS(3055),
    [anon_sym_pub] = ACTIONS(3055),
    [anon_sym_mut] = ACTIONS(3055),
    [anon_sym_enum] = ACTIONS(3055),
    [anon_sym_interface] = ACTIONS(3055),
    [anon_sym_PLUS_PLUS] = ACTIONS(3055),
    [anon_sym_DASH_DASH] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_BANG] = ACTIONS(3055),
    [anon_sym_go] = ACTIONS(3055),
    [anon_sym_spawn] = ACTIONS(3055),
    [anon_sym_json_DOTdecode] = ACTIONS(3055),
    [anon_sym_PIPE] = ACTIONS(3055),
    [anon_sym_LBRACK2] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3055),
    [anon_sym_CARET] = ACTIONS(3055),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT_DASH] = ACTIONS(3055),
    [anon_sym_LT_LT] = ACTIONS(3055),
    [anon_sym_GT_GT] = ACTIONS(3055),
    [anon_sym_GT_GT_GT] = ACTIONS(3055),
    [anon_sym_AMP_CARET] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3055),
    [anon_sym_or] = ACTIONS(3055),
    [sym_none] = ACTIONS(3055),
    [sym_true] = ACTIONS(3055),
    [sym_false] = ACTIONS(3055),
    [sym_nil] = ACTIONS(3055),
    [anon_sym_QMARK_DOT] = ACTIONS(3055),
    [anon_sym_POUND_LBRACK] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_DOLLARif] = ACTIONS(3055),
    [anon_sym_is] = ACTIONS(3055),
    [anon_sym_BANGis] = ACTIONS(3055),
    [anon_sym_in] = ACTIONS(3055),
    [anon_sym_BANGin] = ACTIONS(3055),
    [anon_sym_match] = ACTIONS(3055),
    [anon_sym_select] = ACTIONS(3055),
    [anon_sym_lock] = ACTIONS(3055),
    [anon_sym_rlock] = ACTIONS(3055),
    [anon_sym_unsafe] = ACTIONS(3055),
    [anon_sym_sql] = ACTIONS(3055),
    [sym_int_literal] = ACTIONS(3055),
    [sym_float_literal] = ACTIONS(3055),
    [sym_rune_literal] = ACTIONS(3055),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_c_SQUOTE] = ACTIONS(3055),
    [anon_sym_c_DQUOTE] = ACTIONS(3055),
    [anon_sym_r_SQUOTE] = ACTIONS(3055),
    [anon_sym_r_DQUOTE] = ACTIONS(3055),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3055),
    [anon_sym_shared] = ACTIONS(3055),
    [anon_sym_map_LBRACK] = ACTIONS(3055),
    [anon_sym_chan] = ACTIONS(3055),
    [anon_sym_thread] = ACTIONS(3055),
    [anon_sym_atomic] = ACTIONS(3055),
    [anon_sym_assert] = ACTIONS(3055),
    [anon_sym_defer] = ACTIONS(3055),
    [anon_sym_goto] = ACTIONS(3055),
    [anon_sym_break] = ACTIONS(3055),
    [anon_sym_continue] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_DOLLARfor] = ACTIONS(3055),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_POUND] = ACTIONS(3055),
    [anon_sym_asm] = ACTIONS(3055),
    [anon_sym_AT_LBRACK] = ACTIONS(3055),
  },
  [1180] = {
    [sym_line_comment] = STATE(1180),
    [sym_block_comment] = STATE(1180),
    [ts_builtin_sym_end] = ACTIONS(2933),
    [sym_identifier] = ACTIONS(2935),
    [anon_sym_LF] = ACTIONS(2935),
    [anon_sym_CR] = ACTIONS(2935),
    [anon_sym_CR_LF] = ACTIONS(2935),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2935),
    [anon_sym_as] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(2935),
    [anon_sym_COMMA] = ACTIONS(2935),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_LPAREN] = ACTIONS(2935),
    [anon_sym___global] = ACTIONS(2935),
    [anon_sym_type] = ACTIONS(2935),
    [anon_sym_fn] = ACTIONS(2935),
    [anon_sym_PLUS] = ACTIONS(2935),
    [anon_sym_DASH] = ACTIONS(2935),
    [anon_sym_STAR] = ACTIONS(2935),
    [anon_sym_SLASH] = ACTIONS(2935),
    [anon_sym_PERCENT] = ACTIONS(2935),
    [anon_sym_LT] = ACTIONS(2935),
    [anon_sym_GT] = ACTIONS(2935),
    [anon_sym_EQ_EQ] = ACTIONS(2935),
    [anon_sym_BANG_EQ] = ACTIONS(2935),
    [anon_sym_LT_EQ] = ACTIONS(2935),
    [anon_sym_GT_EQ] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2933),
    [anon_sym_struct] = ACTIONS(2935),
    [anon_sym_union] = ACTIONS(2935),
    [anon_sym_pub] = ACTIONS(2935),
    [anon_sym_mut] = ACTIONS(2935),
    [anon_sym_enum] = ACTIONS(2935),
    [anon_sym_interface] = ACTIONS(2935),
    [anon_sym_PLUS_PLUS] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2935),
    [anon_sym_QMARK] = ACTIONS(2935),
    [anon_sym_BANG] = ACTIONS(2935),
    [anon_sym_go] = ACTIONS(2935),
    [anon_sym_spawn] = ACTIONS(2935),
    [anon_sym_json_DOTdecode] = ACTIONS(2935),
    [anon_sym_PIPE] = ACTIONS(2935),
    [anon_sym_LBRACK2] = ACTIONS(2935),
    [anon_sym_TILDE] = ACTIONS(2935),
    [anon_sym_CARET] = ACTIONS(2935),
    [anon_sym_AMP] = ACTIONS(2935),
    [anon_sym_LT_DASH] = ACTIONS(2935),
    [anon_sym_LT_LT] = ACTIONS(2935),
    [anon_sym_GT_GT] = ACTIONS(2935),
    [anon_sym_GT_GT_GT] = ACTIONS(2935),
    [anon_sym_AMP_CARET] = ACTIONS(2935),
    [anon_sym_AMP_AMP] = ACTIONS(2935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2935),
    [anon_sym_or] = ACTIONS(2935),
    [sym_none] = ACTIONS(2935),
    [sym_true] = ACTIONS(2935),
    [sym_false] = ACTIONS(2935),
    [sym_nil] = ACTIONS(2935),
    [anon_sym_QMARK_DOT] = ACTIONS(2935),
    [anon_sym_POUND_LBRACK] = ACTIONS(2935),
    [anon_sym_if] = ACTIONS(2935),
    [anon_sym_DOLLARif] = ACTIONS(2935),
    [anon_sym_is] = ACTIONS(2935),
    [anon_sym_BANGis] = ACTIONS(2935),
    [anon_sym_in] = ACTIONS(2935),
    [anon_sym_BANGin] = ACTIONS(2935),
    [anon_sym_match] = ACTIONS(2935),
    [anon_sym_select] = ACTIONS(2935),
    [anon_sym_lock] = ACTIONS(2935),
    [anon_sym_rlock] = ACTIONS(2935),
    [anon_sym_unsafe] = ACTIONS(2935),
    [anon_sym_sql] = ACTIONS(2935),
    [sym_int_literal] = ACTIONS(2935),
    [sym_float_literal] = ACTIONS(2935),
    [sym_rune_literal] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(2935),
    [anon_sym_DQUOTE] = ACTIONS(2935),
    [anon_sym_c_SQUOTE] = ACTIONS(2935),
    [anon_sym_c_DQUOTE] = ACTIONS(2935),
    [anon_sym_r_SQUOTE] = ACTIONS(2935),
    [anon_sym_r_DQUOTE] = ACTIONS(2935),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2935),
    [anon_sym_shared] = ACTIONS(2935),
    [anon_sym_map_LBRACK] = ACTIONS(2935),
    [anon_sym_chan] = ACTIONS(2935),
    [anon_sym_thread] = ACTIONS(2935),
    [anon_sym_atomic] = ACTIONS(2935),
    [anon_sym_assert] = ACTIONS(2935),
    [anon_sym_defer] = ACTIONS(2935),
    [anon_sym_goto] = ACTIONS(2935),
    [anon_sym_break] = ACTIONS(2935),
    [anon_sym_continue] = ACTIONS(2935),
    [anon_sym_return] = ACTIONS(2935),
    [anon_sym_DOLLARfor] = ACTIONS(2935),
    [anon_sym_for] = ACTIONS(2935),
    [anon_sym_POUND] = ACTIONS(2935),
    [anon_sym_asm] = ACTIONS(2935),
    [anon_sym_AT_LBRACK] = ACTIONS(2935),
  },
  [1181] = {
    [sym_line_comment] = STATE(1181),
    [sym_block_comment] = STATE(1181),
    [ts_builtin_sym_end] = ACTIONS(2959),
    [sym_identifier] = ACTIONS(2961),
    [anon_sym_LF] = ACTIONS(2961),
    [anon_sym_CR] = ACTIONS(2961),
    [anon_sym_CR_LF] = ACTIONS(2961),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2961),
    [anon_sym_as] = ACTIONS(2961),
    [anon_sym_LBRACE] = ACTIONS(2961),
    [anon_sym_COMMA] = ACTIONS(2961),
    [anon_sym_const] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(2961),
    [anon_sym___global] = ACTIONS(2961),
    [anon_sym_type] = ACTIONS(2961),
    [anon_sym_fn] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2961),
    [anon_sym_DASH] = ACTIONS(2961),
    [anon_sym_STAR] = ACTIONS(2961),
    [anon_sym_SLASH] = ACTIONS(2961),
    [anon_sym_PERCENT] = ACTIONS(2961),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_GT] = ACTIONS(2961),
    [anon_sym_EQ_EQ] = ACTIONS(2961),
    [anon_sym_BANG_EQ] = ACTIONS(2961),
    [anon_sym_LT_EQ] = ACTIONS(2961),
    [anon_sym_GT_EQ] = ACTIONS(2961),
    [anon_sym_LBRACK] = ACTIONS(2959),
    [anon_sym_struct] = ACTIONS(2961),
    [anon_sym_union] = ACTIONS(2961),
    [anon_sym_pub] = ACTIONS(2961),
    [anon_sym_mut] = ACTIONS(2961),
    [anon_sym_enum] = ACTIONS(2961),
    [anon_sym_interface] = ACTIONS(2961),
    [anon_sym_PLUS_PLUS] = ACTIONS(2961),
    [anon_sym_DASH_DASH] = ACTIONS(2961),
    [anon_sym_QMARK] = ACTIONS(2961),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_go] = ACTIONS(2961),
    [anon_sym_spawn] = ACTIONS(2961),
    [anon_sym_json_DOTdecode] = ACTIONS(2961),
    [anon_sym_PIPE] = ACTIONS(2961),
    [anon_sym_LBRACK2] = ACTIONS(2961),
    [anon_sym_TILDE] = ACTIONS(2961),
    [anon_sym_CARET] = ACTIONS(2961),
    [anon_sym_AMP] = ACTIONS(2961),
    [anon_sym_LT_DASH] = ACTIONS(2961),
    [anon_sym_LT_LT] = ACTIONS(2961),
    [anon_sym_GT_GT] = ACTIONS(2961),
    [anon_sym_GT_GT_GT] = ACTIONS(2961),
    [anon_sym_AMP_CARET] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2961),
    [anon_sym_PIPE_PIPE] = ACTIONS(2961),
    [anon_sym_or] = ACTIONS(2961),
    [sym_none] = ACTIONS(2961),
    [sym_true] = ACTIONS(2961),
    [sym_false] = ACTIONS(2961),
    [sym_nil] = ACTIONS(2961),
    [anon_sym_QMARK_DOT] = ACTIONS(2961),
    [anon_sym_POUND_LBRACK] = ACTIONS(2961),
    [anon_sym_if] = ACTIONS(2961),
    [anon_sym_DOLLARif] = ACTIONS(2961),
    [anon_sym_is] = ACTIONS(2961),
    [anon_sym_BANGis] = ACTIONS(2961),
    [anon_sym_in] = ACTIONS(2961),
    [anon_sym_BANGin] = ACTIONS(2961),
    [anon_sym_match] = ACTIONS(2961),
    [anon_sym_select] = ACTIONS(2961),
    [anon_sym_lock] = ACTIONS(2961),
    [anon_sym_rlock] = ACTIONS(2961),
    [anon_sym_unsafe] = ACTIONS(2961),
    [anon_sym_sql] = ACTIONS(2961),
    [sym_int_literal] = ACTIONS(2961),
    [sym_float_literal] = ACTIONS(2961),
    [sym_rune_literal] = ACTIONS(2961),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_DQUOTE] = ACTIONS(2961),
    [anon_sym_c_SQUOTE] = ACTIONS(2961),
    [anon_sym_c_DQUOTE] = ACTIONS(2961),
    [anon_sym_r_SQUOTE] = ACTIONS(2961),
    [anon_sym_r_DQUOTE] = ACTIONS(2961),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2961),
    [anon_sym_shared] = ACTIONS(2961),
    [anon_sym_map_LBRACK] = ACTIONS(2961),
    [anon_sym_chan] = ACTIONS(2961),
    [anon_sym_thread] = ACTIONS(2961),
    [anon_sym_atomic] = ACTIONS(2961),
    [anon_sym_assert] = ACTIONS(2961),
    [anon_sym_defer] = ACTIONS(2961),
    [anon_sym_goto] = ACTIONS(2961),
    [anon_sym_break] = ACTIONS(2961),
    [anon_sym_continue] = ACTIONS(2961),
    [anon_sym_return] = ACTIONS(2961),
    [anon_sym_DOLLARfor] = ACTIONS(2961),
    [anon_sym_for] = ACTIONS(2961),
    [anon_sym_POUND] = ACTIONS(2961),
    [anon_sym_asm] = ACTIONS(2961),
    [anon_sym_AT_LBRACK] = ACTIONS(2961),
  },
  [1182] = {
    [sym_line_comment] = STATE(1182),
    [sym_block_comment] = STATE(1182),
    [ts_builtin_sym_end] = ACTIONS(2971),
    [sym_identifier] = ACTIONS(2973),
    [anon_sym_LF] = ACTIONS(2973),
    [anon_sym_CR] = ACTIONS(2973),
    [anon_sym_CR_LF] = ACTIONS(2973),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2973),
    [anon_sym_as] = ACTIONS(2973),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_COMMA] = ACTIONS(2973),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym___global] = ACTIONS(2973),
    [anon_sym_type] = ACTIONS(2973),
    [anon_sym_fn] = ACTIONS(2973),
    [anon_sym_PLUS] = ACTIONS(2973),
    [anon_sym_DASH] = ACTIONS(2973),
    [anon_sym_STAR] = ACTIONS(2973),
    [anon_sym_SLASH] = ACTIONS(2973),
    [anon_sym_PERCENT] = ACTIONS(2973),
    [anon_sym_LT] = ACTIONS(2973),
    [anon_sym_GT] = ACTIONS(2973),
    [anon_sym_EQ_EQ] = ACTIONS(2973),
    [anon_sym_BANG_EQ] = ACTIONS(2973),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LBRACK] = ACTIONS(2971),
    [anon_sym_struct] = ACTIONS(2973),
    [anon_sym_union] = ACTIONS(2973),
    [anon_sym_pub] = ACTIONS(2973),
    [anon_sym_mut] = ACTIONS(2973),
    [anon_sym_enum] = ACTIONS(2973),
    [anon_sym_interface] = ACTIONS(2973),
    [anon_sym_PLUS_PLUS] = ACTIONS(2973),
    [anon_sym_DASH_DASH] = ACTIONS(2973),
    [anon_sym_QMARK] = ACTIONS(2973),
    [anon_sym_BANG] = ACTIONS(2973),
    [anon_sym_go] = ACTIONS(2973),
    [anon_sym_spawn] = ACTIONS(2973),
    [anon_sym_json_DOTdecode] = ACTIONS(2973),
    [anon_sym_PIPE] = ACTIONS(2973),
    [anon_sym_LBRACK2] = ACTIONS(2973),
    [anon_sym_TILDE] = ACTIONS(2973),
    [anon_sym_CARET] = ACTIONS(2973),
    [anon_sym_AMP] = ACTIONS(2973),
    [anon_sym_LT_DASH] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2973),
    [anon_sym_GT_GT] = ACTIONS(2973),
    [anon_sym_GT_GT_GT] = ACTIONS(2973),
    [anon_sym_AMP_CARET] = ACTIONS(2973),
    [anon_sym_AMP_AMP] = ACTIONS(2973),
    [anon_sym_PIPE_PIPE] = ACTIONS(2973),
    [anon_sym_or] = ACTIONS(2973),
    [sym_none] = ACTIONS(2973),
    [sym_true] = ACTIONS(2973),
    [sym_false] = ACTIONS(2973),
    [sym_nil] = ACTIONS(2973),
    [anon_sym_QMARK_DOT] = ACTIONS(2973),
    [anon_sym_POUND_LBRACK] = ACTIONS(2973),
    [anon_sym_if] = ACTIONS(2973),
    [anon_sym_DOLLARif] = ACTIONS(2973),
    [anon_sym_is] = ACTIONS(2973),
    [anon_sym_BANGis] = ACTIONS(2973),
    [anon_sym_in] = ACTIONS(2973),
    [anon_sym_BANGin] = ACTIONS(2973),
    [anon_sym_match] = ACTIONS(2973),
    [anon_sym_select] = ACTIONS(2973),
    [anon_sym_lock] = ACTIONS(2973),
    [anon_sym_rlock] = ACTIONS(2973),
    [anon_sym_unsafe] = ACTIONS(2973),
    [anon_sym_sql] = ACTIONS(2973),
    [sym_int_literal] = ACTIONS(2973),
    [sym_float_literal] = ACTIONS(2973),
    [sym_rune_literal] = ACTIONS(2973),
    [anon_sym_SQUOTE] = ACTIONS(2973),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [anon_sym_c_SQUOTE] = ACTIONS(2973),
    [anon_sym_c_DQUOTE] = ACTIONS(2973),
    [anon_sym_r_SQUOTE] = ACTIONS(2973),
    [anon_sym_r_DQUOTE] = ACTIONS(2973),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2973),
    [anon_sym_shared] = ACTIONS(2973),
    [anon_sym_map_LBRACK] = ACTIONS(2973),
    [anon_sym_chan] = ACTIONS(2973),
    [anon_sym_thread] = ACTIONS(2973),
    [anon_sym_atomic] = ACTIONS(2973),
    [anon_sym_assert] = ACTIONS(2973),
    [anon_sym_defer] = ACTIONS(2973),
    [anon_sym_goto] = ACTIONS(2973),
    [anon_sym_break] = ACTIONS(2973),
    [anon_sym_continue] = ACTIONS(2973),
    [anon_sym_return] = ACTIONS(2973),
    [anon_sym_DOLLARfor] = ACTIONS(2973),
    [anon_sym_for] = ACTIONS(2973),
    [anon_sym_POUND] = ACTIONS(2973),
    [anon_sym_asm] = ACTIONS(2973),
    [anon_sym_AT_LBRACK] = ACTIONS(2973),
  },
  [1183] = {
    [sym_line_comment] = STATE(1183),
    [sym_block_comment] = STATE(1183),
    [ts_builtin_sym_end] = ACTIONS(3248),
    [sym_identifier] = ACTIONS(3250),
    [anon_sym_LF] = ACTIONS(3250),
    [anon_sym_CR] = ACTIONS(3250),
    [anon_sym_CR_LF] = ACTIONS(3250),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3250),
    [anon_sym_as] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3250),
    [anon_sym_COMMA] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_LPAREN] = ACTIONS(3250),
    [anon_sym___global] = ACTIONS(3250),
    [anon_sym_type] = ACTIONS(3250),
    [anon_sym_fn] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_STAR] = ACTIONS(3250),
    [anon_sym_SLASH] = ACTIONS(3250),
    [anon_sym_PERCENT] = ACTIONS(3250),
    [anon_sym_LT] = ACTIONS(3250),
    [anon_sym_GT] = ACTIONS(3250),
    [anon_sym_EQ_EQ] = ACTIONS(3250),
    [anon_sym_BANG_EQ] = ACTIONS(3250),
    [anon_sym_LT_EQ] = ACTIONS(3250),
    [anon_sym_GT_EQ] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3248),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_union] = ACTIONS(3250),
    [anon_sym_pub] = ACTIONS(3250),
    [anon_sym_mut] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [anon_sym_interface] = ACTIONS(3250),
    [anon_sym_PLUS_PLUS] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3250),
    [anon_sym_QMARK] = ACTIONS(3250),
    [anon_sym_BANG] = ACTIONS(3250),
    [anon_sym_go] = ACTIONS(3250),
    [anon_sym_spawn] = ACTIONS(3250),
    [anon_sym_json_DOTdecode] = ACTIONS(3250),
    [anon_sym_PIPE] = ACTIONS(3250),
    [anon_sym_LBRACK2] = ACTIONS(3250),
    [anon_sym_TILDE] = ACTIONS(3250),
    [anon_sym_CARET] = ACTIONS(3250),
    [anon_sym_AMP] = ACTIONS(3250),
    [anon_sym_LT_DASH] = ACTIONS(3250),
    [anon_sym_LT_LT] = ACTIONS(3250),
    [anon_sym_GT_GT] = ACTIONS(3250),
    [anon_sym_GT_GT_GT] = ACTIONS(3250),
    [anon_sym_AMP_CARET] = ACTIONS(3250),
    [anon_sym_AMP_AMP] = ACTIONS(3250),
    [anon_sym_PIPE_PIPE] = ACTIONS(3250),
    [anon_sym_or] = ACTIONS(3250),
    [sym_none] = ACTIONS(3250),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [sym_nil] = ACTIONS(3250),
    [anon_sym_QMARK_DOT] = ACTIONS(3250),
    [anon_sym_POUND_LBRACK] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_DOLLARif] = ACTIONS(3250),
    [anon_sym_is] = ACTIONS(3250),
    [anon_sym_BANGis] = ACTIONS(3250),
    [anon_sym_in] = ACTIONS(3250),
    [anon_sym_BANGin] = ACTIONS(3250),
    [anon_sym_match] = ACTIONS(3250),
    [anon_sym_select] = ACTIONS(3250),
    [anon_sym_lock] = ACTIONS(3250),
    [anon_sym_rlock] = ACTIONS(3250),
    [anon_sym_unsafe] = ACTIONS(3250),
    [anon_sym_sql] = ACTIONS(3250),
    [sym_int_literal] = ACTIONS(3250),
    [sym_float_literal] = ACTIONS(3250),
    [sym_rune_literal] = ACTIONS(3250),
    [anon_sym_SQUOTE] = ACTIONS(3250),
    [anon_sym_DQUOTE] = ACTIONS(3250),
    [anon_sym_c_SQUOTE] = ACTIONS(3250),
    [anon_sym_c_DQUOTE] = ACTIONS(3250),
    [anon_sym_r_SQUOTE] = ACTIONS(3250),
    [anon_sym_r_DQUOTE] = ACTIONS(3250),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3250),
    [anon_sym_shared] = ACTIONS(3250),
    [anon_sym_map_LBRACK] = ACTIONS(3250),
    [anon_sym_chan] = ACTIONS(3250),
    [anon_sym_thread] = ACTIONS(3250),
    [anon_sym_atomic] = ACTIONS(3250),
    [anon_sym_assert] = ACTIONS(3250),
    [anon_sym_defer] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_DOLLARfor] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_POUND] = ACTIONS(3250),
    [anon_sym_asm] = ACTIONS(3250),
    [anon_sym_AT_LBRACK] = ACTIONS(3250),
  },
  [1184] = {
    [sym_line_comment] = STATE(1184),
    [sym_block_comment] = STATE(1184),
    [ts_builtin_sym_end] = ACTIONS(3254),
    [sym_identifier] = ACTIONS(3256),
    [anon_sym_LF] = ACTIONS(3256),
    [anon_sym_CR] = ACTIONS(3256),
    [anon_sym_CR_LF] = ACTIONS(3256),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3256),
    [anon_sym_as] = ACTIONS(3256),
    [anon_sym_LBRACE] = ACTIONS(3256),
    [anon_sym_COMMA] = ACTIONS(3256),
    [anon_sym_const] = ACTIONS(3256),
    [anon_sym_LPAREN] = ACTIONS(3256),
    [anon_sym___global] = ACTIONS(3256),
    [anon_sym_type] = ACTIONS(3256),
    [anon_sym_fn] = ACTIONS(3256),
    [anon_sym_PLUS] = ACTIONS(3256),
    [anon_sym_DASH] = ACTIONS(3256),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_SLASH] = ACTIONS(3256),
    [anon_sym_PERCENT] = ACTIONS(3256),
    [anon_sym_LT] = ACTIONS(3256),
    [anon_sym_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(3256),
    [anon_sym_BANG_EQ] = ACTIONS(3256),
    [anon_sym_LT_EQ] = ACTIONS(3256),
    [anon_sym_GT_EQ] = ACTIONS(3256),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [anon_sym_struct] = ACTIONS(3256),
    [anon_sym_union] = ACTIONS(3256),
    [anon_sym_pub] = ACTIONS(3256),
    [anon_sym_mut] = ACTIONS(3256),
    [anon_sym_enum] = ACTIONS(3256),
    [anon_sym_interface] = ACTIONS(3256),
    [anon_sym_PLUS_PLUS] = ACTIONS(3256),
    [anon_sym_DASH_DASH] = ACTIONS(3256),
    [anon_sym_QMARK] = ACTIONS(3256),
    [anon_sym_BANG] = ACTIONS(3256),
    [anon_sym_go] = ACTIONS(3256),
    [anon_sym_spawn] = ACTIONS(3256),
    [anon_sym_json_DOTdecode] = ACTIONS(3256),
    [anon_sym_PIPE] = ACTIONS(3256),
    [anon_sym_LBRACK2] = ACTIONS(3256),
    [anon_sym_TILDE] = ACTIONS(3256),
    [anon_sym_CARET] = ACTIONS(3256),
    [anon_sym_AMP] = ACTIONS(3256),
    [anon_sym_LT_DASH] = ACTIONS(3256),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_GT_GT_GT] = ACTIONS(3256),
    [anon_sym_AMP_CARET] = ACTIONS(3256),
    [anon_sym_AMP_AMP] = ACTIONS(3256),
    [anon_sym_PIPE_PIPE] = ACTIONS(3256),
    [anon_sym_or] = ACTIONS(3256),
    [sym_none] = ACTIONS(3256),
    [sym_true] = ACTIONS(3256),
    [sym_false] = ACTIONS(3256),
    [sym_nil] = ACTIONS(3256),
    [anon_sym_QMARK_DOT] = ACTIONS(3256),
    [anon_sym_POUND_LBRACK] = ACTIONS(3256),
    [anon_sym_if] = ACTIONS(3256),
    [anon_sym_DOLLARif] = ACTIONS(3256),
    [anon_sym_is] = ACTIONS(3256),
    [anon_sym_BANGis] = ACTIONS(3256),
    [anon_sym_in] = ACTIONS(3256),
    [anon_sym_BANGin] = ACTIONS(3256),
    [anon_sym_match] = ACTIONS(3256),
    [anon_sym_select] = ACTIONS(3256),
    [anon_sym_lock] = ACTIONS(3256),
    [anon_sym_rlock] = ACTIONS(3256),
    [anon_sym_unsafe] = ACTIONS(3256),
    [anon_sym_sql] = ACTIONS(3256),
    [sym_int_literal] = ACTIONS(3256),
    [sym_float_literal] = ACTIONS(3256),
    [sym_rune_literal] = ACTIONS(3256),
    [anon_sym_SQUOTE] = ACTIONS(3256),
    [anon_sym_DQUOTE] = ACTIONS(3256),
    [anon_sym_c_SQUOTE] = ACTIONS(3256),
    [anon_sym_c_DQUOTE] = ACTIONS(3256),
    [anon_sym_r_SQUOTE] = ACTIONS(3256),
    [anon_sym_r_DQUOTE] = ACTIONS(3256),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3256),
    [anon_sym_shared] = ACTIONS(3256),
    [anon_sym_map_LBRACK] = ACTIONS(3256),
    [anon_sym_chan] = ACTIONS(3256),
    [anon_sym_thread] = ACTIONS(3256),
    [anon_sym_atomic] = ACTIONS(3256),
    [anon_sym_assert] = ACTIONS(3256),
    [anon_sym_defer] = ACTIONS(3256),
    [anon_sym_goto] = ACTIONS(3256),
    [anon_sym_break] = ACTIONS(3256),
    [anon_sym_continue] = ACTIONS(3256),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_DOLLARfor] = ACTIONS(3256),
    [anon_sym_for] = ACTIONS(3256),
    [anon_sym_POUND] = ACTIONS(3256),
    [anon_sym_asm] = ACTIONS(3256),
    [anon_sym_AT_LBRACK] = ACTIONS(3256),
  },
  [1185] = {
    [sym_line_comment] = STATE(1185),
    [sym_block_comment] = STATE(1185),
    [ts_builtin_sym_end] = ACTIONS(3272),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_LF] = ACTIONS(3274),
    [anon_sym_CR] = ACTIONS(3274),
    [anon_sym_CR_LF] = ACTIONS(3274),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_as] = ACTIONS(3274),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3274),
    [anon_sym_const] = ACTIONS(3274),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym___global] = ACTIONS(3274),
    [anon_sym_type] = ACTIONS(3274),
    [anon_sym_fn] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_SLASH] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_LT] = ACTIONS(3274),
    [anon_sym_GT] = ACTIONS(3274),
    [anon_sym_EQ_EQ] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_LT_EQ] = ACTIONS(3274),
    [anon_sym_GT_EQ] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3272),
    [anon_sym_struct] = ACTIONS(3274),
    [anon_sym_union] = ACTIONS(3274),
    [anon_sym_pub] = ACTIONS(3274),
    [anon_sym_mut] = ACTIONS(3274),
    [anon_sym_enum] = ACTIONS(3274),
    [anon_sym_interface] = ACTIONS(3274),
    [anon_sym_PLUS_PLUS] = ACTIONS(3274),
    [anon_sym_DASH_DASH] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_BANG] = ACTIONS(3274),
    [anon_sym_go] = ACTIONS(3274),
    [anon_sym_spawn] = ACTIONS(3274),
    [anon_sym_json_DOTdecode] = ACTIONS(3274),
    [anon_sym_PIPE] = ACTIONS(3274),
    [anon_sym_LBRACK2] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3274),
    [anon_sym_CARET] = ACTIONS(3274),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_LT_LT] = ACTIONS(3274),
    [anon_sym_GT_GT] = ACTIONS(3274),
    [anon_sym_GT_GT_GT] = ACTIONS(3274),
    [anon_sym_AMP_CARET] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_or] = ACTIONS(3274),
    [sym_none] = ACTIONS(3274),
    [sym_true] = ACTIONS(3274),
    [sym_false] = ACTIONS(3274),
    [sym_nil] = ACTIONS(3274),
    [anon_sym_QMARK_DOT] = ACTIONS(3274),
    [anon_sym_POUND_LBRACK] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_DOLLARif] = ACTIONS(3274),
    [anon_sym_is] = ACTIONS(3274),
    [anon_sym_BANGis] = ACTIONS(3274),
    [anon_sym_in] = ACTIONS(3274),
    [anon_sym_BANGin] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_select] = ACTIONS(3274),
    [anon_sym_lock] = ACTIONS(3274),
    [anon_sym_rlock] = ACTIONS(3274),
    [anon_sym_unsafe] = ACTIONS(3274),
    [anon_sym_sql] = ACTIONS(3274),
    [sym_int_literal] = ACTIONS(3274),
    [sym_float_literal] = ACTIONS(3274),
    [sym_rune_literal] = ACTIONS(3274),
    [anon_sym_SQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_c_SQUOTE] = ACTIONS(3274),
    [anon_sym_c_DQUOTE] = ACTIONS(3274),
    [anon_sym_r_SQUOTE] = ACTIONS(3274),
    [anon_sym_r_DQUOTE] = ACTIONS(3274),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3274),
    [anon_sym_shared] = ACTIONS(3274),
    [anon_sym_map_LBRACK] = ACTIONS(3274),
    [anon_sym_chan] = ACTIONS(3274),
    [anon_sym_thread] = ACTIONS(3274),
    [anon_sym_atomic] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_defer] = ACTIONS(3274),
    [anon_sym_goto] = ACTIONS(3274),
    [anon_sym_break] = ACTIONS(3274),
    [anon_sym_continue] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_DOLLARfor] = ACTIONS(3274),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_POUND] = ACTIONS(3274),
    [anon_sym_asm] = ACTIONS(3274),
    [anon_sym_AT_LBRACK] = ACTIONS(3274),
  },
  [1186] = {
    [sym_line_comment] = STATE(1186),
    [sym_block_comment] = STATE(1186),
    [ts_builtin_sym_end] = ACTIONS(3330),
    [sym_identifier] = ACTIONS(3332),
    [anon_sym_LF] = ACTIONS(3332),
    [anon_sym_CR] = ACTIONS(3332),
    [anon_sym_CR_LF] = ACTIONS(3332),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3332),
    [anon_sym_as] = ACTIONS(3332),
    [anon_sym_LBRACE] = ACTIONS(3332),
    [anon_sym_COMMA] = ACTIONS(3332),
    [anon_sym_const] = ACTIONS(3332),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym___global] = ACTIONS(3332),
    [anon_sym_type] = ACTIONS(3332),
    [anon_sym_fn] = ACTIONS(3332),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_DASH] = ACTIONS(3332),
    [anon_sym_STAR] = ACTIONS(3332),
    [anon_sym_SLASH] = ACTIONS(3332),
    [anon_sym_PERCENT] = ACTIONS(3332),
    [anon_sym_LT] = ACTIONS(3332),
    [anon_sym_GT] = ACTIONS(3332),
    [anon_sym_EQ_EQ] = ACTIONS(3332),
    [anon_sym_BANG_EQ] = ACTIONS(3332),
    [anon_sym_LT_EQ] = ACTIONS(3332),
    [anon_sym_GT_EQ] = ACTIONS(3332),
    [anon_sym_LBRACK] = ACTIONS(3330),
    [anon_sym_struct] = ACTIONS(3332),
    [anon_sym_union] = ACTIONS(3332),
    [anon_sym_pub] = ACTIONS(3332),
    [anon_sym_mut] = ACTIONS(3332),
    [anon_sym_enum] = ACTIONS(3332),
    [anon_sym_interface] = ACTIONS(3332),
    [anon_sym_PLUS_PLUS] = ACTIONS(3332),
    [anon_sym_DASH_DASH] = ACTIONS(3332),
    [anon_sym_QMARK] = ACTIONS(3332),
    [anon_sym_BANG] = ACTIONS(3332),
    [anon_sym_go] = ACTIONS(3332),
    [anon_sym_spawn] = ACTIONS(3332),
    [anon_sym_json_DOTdecode] = ACTIONS(3332),
    [anon_sym_PIPE] = ACTIONS(3332),
    [anon_sym_LBRACK2] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3332),
    [anon_sym_CARET] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3332),
    [anon_sym_LT_DASH] = ACTIONS(3332),
    [anon_sym_LT_LT] = ACTIONS(3332),
    [anon_sym_GT_GT] = ACTIONS(3332),
    [anon_sym_GT_GT_GT] = ACTIONS(3332),
    [anon_sym_AMP_CARET] = ACTIONS(3332),
    [anon_sym_AMP_AMP] = ACTIONS(3332),
    [anon_sym_PIPE_PIPE] = ACTIONS(3332),
    [anon_sym_or] = ACTIONS(3332),
    [sym_none] = ACTIONS(3332),
    [sym_true] = ACTIONS(3332),
    [sym_false] = ACTIONS(3332),
    [sym_nil] = ACTIONS(3332),
    [anon_sym_QMARK_DOT] = ACTIONS(3332),
    [anon_sym_POUND_LBRACK] = ACTIONS(3332),
    [anon_sym_if] = ACTIONS(3332),
    [anon_sym_DOLLARif] = ACTIONS(3332),
    [anon_sym_is] = ACTIONS(3332),
    [anon_sym_BANGis] = ACTIONS(3332),
    [anon_sym_in] = ACTIONS(3332),
    [anon_sym_BANGin] = ACTIONS(3332),
    [anon_sym_match] = ACTIONS(3332),
    [anon_sym_select] = ACTIONS(3332),
    [anon_sym_lock] = ACTIONS(3332),
    [anon_sym_rlock] = ACTIONS(3332),
    [anon_sym_unsafe] = ACTIONS(3332),
    [anon_sym_sql] = ACTIONS(3332),
    [sym_int_literal] = ACTIONS(3332),
    [sym_float_literal] = ACTIONS(3332),
    [sym_rune_literal] = ACTIONS(3332),
    [anon_sym_SQUOTE] = ACTIONS(3332),
    [anon_sym_DQUOTE] = ACTIONS(3332),
    [anon_sym_c_SQUOTE] = ACTIONS(3332),
    [anon_sym_c_DQUOTE] = ACTIONS(3332),
    [anon_sym_r_SQUOTE] = ACTIONS(3332),
    [anon_sym_r_DQUOTE] = ACTIONS(3332),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3332),
    [anon_sym_shared] = ACTIONS(3332),
    [anon_sym_map_LBRACK] = ACTIONS(3332),
    [anon_sym_chan] = ACTIONS(3332),
    [anon_sym_thread] = ACTIONS(3332),
    [anon_sym_atomic] = ACTIONS(3332),
    [anon_sym_assert] = ACTIONS(3332),
    [anon_sym_defer] = ACTIONS(3332),
    [anon_sym_goto] = ACTIONS(3332),
    [anon_sym_break] = ACTIONS(3332),
    [anon_sym_continue] = ACTIONS(3332),
    [anon_sym_return] = ACTIONS(3332),
    [anon_sym_DOLLARfor] = ACTIONS(3332),
    [anon_sym_for] = ACTIONS(3332),
    [anon_sym_POUND] = ACTIONS(3332),
    [anon_sym_asm] = ACTIONS(3332),
    [anon_sym_AT_LBRACK] = ACTIONS(3332),
  },
  [1187] = {
    [sym_line_comment] = STATE(1187),
    [sym_block_comment] = STATE(1187),
    [ts_builtin_sym_end] = ACTIONS(3334),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_LF] = ACTIONS(3336),
    [anon_sym_CR] = ACTIONS(3336),
    [anon_sym_CR_LF] = ACTIONS(3336),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3336),
    [anon_sym_as] = ACTIONS(3336),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3336),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym___global] = ACTIONS(3336),
    [anon_sym_type] = ACTIONS(3336),
    [anon_sym_fn] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_SLASH] = ACTIONS(3336),
    [anon_sym_PERCENT] = ACTIONS(3336),
    [anon_sym_LT] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3336),
    [anon_sym_EQ_EQ] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_LT_EQ] = ACTIONS(3336),
    [anon_sym_GT_EQ] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_union] = ACTIONS(3336),
    [anon_sym_pub] = ACTIONS(3336),
    [anon_sym_mut] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(3336),
    [anon_sym_interface] = ACTIONS(3336),
    [anon_sym_PLUS_PLUS] = ACTIONS(3336),
    [anon_sym_DASH_DASH] = ACTIONS(3336),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_BANG] = ACTIONS(3336),
    [anon_sym_go] = ACTIONS(3336),
    [anon_sym_spawn] = ACTIONS(3336),
    [anon_sym_json_DOTdecode] = ACTIONS(3336),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3336),
    [anon_sym_CARET] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LT_DASH] = ACTIONS(3336),
    [anon_sym_LT_LT] = ACTIONS(3336),
    [anon_sym_GT_GT] = ACTIONS(3336),
    [anon_sym_GT_GT_GT] = ACTIONS(3336),
    [anon_sym_AMP_CARET] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_or] = ACTIONS(3336),
    [sym_none] = ACTIONS(3336),
    [sym_true] = ACTIONS(3336),
    [sym_false] = ACTIONS(3336),
    [sym_nil] = ACTIONS(3336),
    [anon_sym_QMARK_DOT] = ACTIONS(3336),
    [anon_sym_POUND_LBRACK] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_DOLLARif] = ACTIONS(3336),
    [anon_sym_is] = ACTIONS(3336),
    [anon_sym_BANGis] = ACTIONS(3336),
    [anon_sym_in] = ACTIONS(3336),
    [anon_sym_BANGin] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_select] = ACTIONS(3336),
    [anon_sym_lock] = ACTIONS(3336),
    [anon_sym_rlock] = ACTIONS(3336),
    [anon_sym_unsafe] = ACTIONS(3336),
    [anon_sym_sql] = ACTIONS(3336),
    [sym_int_literal] = ACTIONS(3336),
    [sym_float_literal] = ACTIONS(3336),
    [sym_rune_literal] = ACTIONS(3336),
    [anon_sym_SQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_c_SQUOTE] = ACTIONS(3336),
    [anon_sym_c_DQUOTE] = ACTIONS(3336),
    [anon_sym_r_SQUOTE] = ACTIONS(3336),
    [anon_sym_r_DQUOTE] = ACTIONS(3336),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3336),
    [anon_sym_shared] = ACTIONS(3336),
    [anon_sym_map_LBRACK] = ACTIONS(3336),
    [anon_sym_chan] = ACTIONS(3336),
    [anon_sym_thread] = ACTIONS(3336),
    [anon_sym_atomic] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_defer] = ACTIONS(3336),
    [anon_sym_goto] = ACTIONS(3336),
    [anon_sym_break] = ACTIONS(3336),
    [anon_sym_continue] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_DOLLARfor] = ACTIONS(3336),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_POUND] = ACTIONS(3336),
    [anon_sym_asm] = ACTIONS(3336),
    [anon_sym_AT_LBRACK] = ACTIONS(3336),
  },
  [1188] = {
    [sym_line_comment] = STATE(1188),
    [sym_block_comment] = STATE(1188),
    [ts_builtin_sym_end] = ACTIONS(3338),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LF] = ACTIONS(3340),
    [anon_sym_CR] = ACTIONS(3340),
    [anon_sym_CR_LF] = ACTIONS(3340),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3340),
    [anon_sym_as] = ACTIONS(3340),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_COMMA] = ACTIONS(3340),
    [anon_sym_const] = ACTIONS(3340),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym___global] = ACTIONS(3340),
    [anon_sym_type] = ACTIONS(3340),
    [anon_sym_fn] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_STAR] = ACTIONS(3340),
    [anon_sym_SLASH] = ACTIONS(3340),
    [anon_sym_PERCENT] = ACTIONS(3340),
    [anon_sym_LT] = ACTIONS(3340),
    [anon_sym_GT] = ACTIONS(3340),
    [anon_sym_EQ_EQ] = ACTIONS(3340),
    [anon_sym_BANG_EQ] = ACTIONS(3340),
    [anon_sym_LT_EQ] = ACTIONS(3340),
    [anon_sym_GT_EQ] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3338),
    [anon_sym_struct] = ACTIONS(3340),
    [anon_sym_union] = ACTIONS(3340),
    [anon_sym_pub] = ACTIONS(3340),
    [anon_sym_mut] = ACTIONS(3340),
    [anon_sym_enum] = ACTIONS(3340),
    [anon_sym_interface] = ACTIONS(3340),
    [anon_sym_PLUS_PLUS] = ACTIONS(3340),
    [anon_sym_DASH_DASH] = ACTIONS(3340),
    [anon_sym_QMARK] = ACTIONS(3340),
    [anon_sym_BANG] = ACTIONS(3340),
    [anon_sym_go] = ACTIONS(3340),
    [anon_sym_spawn] = ACTIONS(3340),
    [anon_sym_json_DOTdecode] = ACTIONS(3340),
    [anon_sym_PIPE] = ACTIONS(3340),
    [anon_sym_LBRACK2] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3340),
    [anon_sym_CARET] = ACTIONS(3340),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LT_DASH] = ACTIONS(3340),
    [anon_sym_LT_LT] = ACTIONS(3340),
    [anon_sym_GT_GT] = ACTIONS(3340),
    [anon_sym_GT_GT_GT] = ACTIONS(3340),
    [anon_sym_AMP_CARET] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3340),
    [anon_sym_PIPE_PIPE] = ACTIONS(3340),
    [anon_sym_or] = ACTIONS(3340),
    [sym_none] = ACTIONS(3340),
    [sym_true] = ACTIONS(3340),
    [sym_false] = ACTIONS(3340),
    [sym_nil] = ACTIONS(3340),
    [anon_sym_QMARK_DOT] = ACTIONS(3340),
    [anon_sym_POUND_LBRACK] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_DOLLARif] = ACTIONS(3340),
    [anon_sym_is] = ACTIONS(3340),
    [anon_sym_BANGis] = ACTIONS(3340),
    [anon_sym_in] = ACTIONS(3340),
    [anon_sym_BANGin] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_select] = ACTIONS(3340),
    [anon_sym_lock] = ACTIONS(3340),
    [anon_sym_rlock] = ACTIONS(3340),
    [anon_sym_unsafe] = ACTIONS(3340),
    [anon_sym_sql] = ACTIONS(3340),
    [sym_int_literal] = ACTIONS(3340),
    [sym_float_literal] = ACTIONS(3340),
    [sym_rune_literal] = ACTIONS(3340),
    [anon_sym_SQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_c_SQUOTE] = ACTIONS(3340),
    [anon_sym_c_DQUOTE] = ACTIONS(3340),
    [anon_sym_r_SQUOTE] = ACTIONS(3340),
    [anon_sym_r_DQUOTE] = ACTIONS(3340),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3340),
    [anon_sym_shared] = ACTIONS(3340),
    [anon_sym_map_LBRACK] = ACTIONS(3340),
    [anon_sym_chan] = ACTIONS(3340),
    [anon_sym_thread] = ACTIONS(3340),
    [anon_sym_atomic] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_defer] = ACTIONS(3340),
    [anon_sym_goto] = ACTIONS(3340),
    [anon_sym_break] = ACTIONS(3340),
    [anon_sym_continue] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_DOLLARfor] = ACTIONS(3340),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_POUND] = ACTIONS(3340),
    [anon_sym_asm] = ACTIONS(3340),
    [anon_sym_AT_LBRACK] = ACTIONS(3340),
  },
  [1189] = {
    [sym_line_comment] = STATE(1189),
    [sym_block_comment] = STATE(1189),
    [ts_builtin_sym_end] = ACTIONS(3078),
    [sym_identifier] = ACTIONS(3080),
    [anon_sym_LF] = ACTIONS(3080),
    [anon_sym_CR] = ACTIONS(3080),
    [anon_sym_CR_LF] = ACTIONS(3080),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3080),
    [anon_sym_as] = ACTIONS(3080),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_COMMA] = ACTIONS(3080),
    [anon_sym_const] = ACTIONS(3080),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym___global] = ACTIONS(3080),
    [anon_sym_type] = ACTIONS(3080),
    [anon_sym_fn] = ACTIONS(3080),
    [anon_sym_PLUS] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3080),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_SLASH] = ACTIONS(3080),
    [anon_sym_PERCENT] = ACTIONS(3080),
    [anon_sym_LT] = ACTIONS(3080),
    [anon_sym_GT] = ACTIONS(3080),
    [anon_sym_EQ_EQ] = ACTIONS(3080),
    [anon_sym_BANG_EQ] = ACTIONS(3080),
    [anon_sym_LT_EQ] = ACTIONS(3080),
    [anon_sym_GT_EQ] = ACTIONS(3080),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_struct] = ACTIONS(3080),
    [anon_sym_union] = ACTIONS(3080),
    [anon_sym_pub] = ACTIONS(3080),
    [anon_sym_mut] = ACTIONS(3080),
    [anon_sym_enum] = ACTIONS(3080),
    [anon_sym_interface] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_QMARK] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_go] = ACTIONS(3080),
    [anon_sym_spawn] = ACTIONS(3080),
    [anon_sym_json_DOTdecode] = ACTIONS(3080),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_LBRACK2] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_CARET] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3080),
    [anon_sym_LT_DASH] = ACTIONS(3080),
    [anon_sym_LT_LT] = ACTIONS(3080),
    [anon_sym_GT_GT] = ACTIONS(3080),
    [anon_sym_GT_GT_GT] = ACTIONS(3080),
    [anon_sym_AMP_CARET] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_PIPE_PIPE] = ACTIONS(3080),
    [anon_sym_or] = ACTIONS(3080),
    [sym_none] = ACTIONS(3080),
    [sym_true] = ACTIONS(3080),
    [sym_false] = ACTIONS(3080),
    [sym_nil] = ACTIONS(3080),
    [anon_sym_QMARK_DOT] = ACTIONS(3080),
    [anon_sym_POUND_LBRACK] = ACTIONS(3080),
    [anon_sym_if] = ACTIONS(3080),
    [anon_sym_DOLLARif] = ACTIONS(3080),
    [anon_sym_is] = ACTIONS(3080),
    [anon_sym_BANGis] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3080),
    [anon_sym_BANGin] = ACTIONS(3080),
    [anon_sym_match] = ACTIONS(3080),
    [anon_sym_select] = ACTIONS(3080),
    [anon_sym_lock] = ACTIONS(3080),
    [anon_sym_rlock] = ACTIONS(3080),
    [anon_sym_unsafe] = ACTIONS(3080),
    [anon_sym_sql] = ACTIONS(3080),
    [sym_int_literal] = ACTIONS(3080),
    [sym_float_literal] = ACTIONS(3080),
    [sym_rune_literal] = ACTIONS(3080),
    [anon_sym_SQUOTE] = ACTIONS(3080),
    [anon_sym_DQUOTE] = ACTIONS(3080),
    [anon_sym_c_SQUOTE] = ACTIONS(3080),
    [anon_sym_c_DQUOTE] = ACTIONS(3080),
    [anon_sym_r_SQUOTE] = ACTIONS(3080),
    [anon_sym_r_DQUOTE] = ACTIONS(3080),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3080),
    [anon_sym_shared] = ACTIONS(3080),
    [anon_sym_map_LBRACK] = ACTIONS(3080),
    [anon_sym_chan] = ACTIONS(3080),
    [anon_sym_thread] = ACTIONS(3080),
    [anon_sym_atomic] = ACTIONS(3080),
    [anon_sym_assert] = ACTIONS(3080),
    [anon_sym_defer] = ACTIONS(3080),
    [anon_sym_goto] = ACTIONS(3080),
    [anon_sym_break] = ACTIONS(3080),
    [anon_sym_continue] = ACTIONS(3080),
    [anon_sym_return] = ACTIONS(3080),
    [anon_sym_DOLLARfor] = ACTIONS(3080),
    [anon_sym_for] = ACTIONS(3080),
    [anon_sym_POUND] = ACTIONS(3080),
    [anon_sym_asm] = ACTIONS(3080),
    [anon_sym_AT_LBRACK] = ACTIONS(3080),
  },
  [1190] = {
    [sym_line_comment] = STATE(1190),
    [sym_block_comment] = STATE(1190),
    [ts_builtin_sym_end] = ACTIONS(2945),
    [sym_identifier] = ACTIONS(2947),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_CR] = ACTIONS(2947),
    [anon_sym_CR_LF] = ACTIONS(2947),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2947),
    [anon_sym_as] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_COMMA] = ACTIONS(2947),
    [anon_sym_const] = ACTIONS(2947),
    [anon_sym_LPAREN] = ACTIONS(2947),
    [anon_sym___global] = ACTIONS(2947),
    [anon_sym_type] = ACTIONS(2947),
    [anon_sym_fn] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_STAR] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(2947),
    [anon_sym_PERCENT] = ACTIONS(2947),
    [anon_sym_LT] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2947),
    [anon_sym_EQ_EQ] = ACTIONS(2947),
    [anon_sym_BANG_EQ] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2947),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2945),
    [anon_sym_struct] = ACTIONS(2947),
    [anon_sym_union] = ACTIONS(2947),
    [anon_sym_pub] = ACTIONS(2947),
    [anon_sym_mut] = ACTIONS(2947),
    [anon_sym_enum] = ACTIONS(2947),
    [anon_sym_interface] = ACTIONS(2947),
    [anon_sym_PLUS_PLUS] = ACTIONS(2947),
    [anon_sym_DASH_DASH] = ACTIONS(2947),
    [anon_sym_QMARK] = ACTIONS(2947),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_go] = ACTIONS(2947),
    [anon_sym_spawn] = ACTIONS(2947),
    [anon_sym_json_DOTdecode] = ACTIONS(2947),
    [anon_sym_PIPE] = ACTIONS(2947),
    [anon_sym_LBRACK2] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2947),
    [anon_sym_CARET] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2947),
    [anon_sym_LT_DASH] = ACTIONS(2947),
    [anon_sym_LT_LT] = ACTIONS(2947),
    [anon_sym_GT_GT] = ACTIONS(2947),
    [anon_sym_GT_GT_GT] = ACTIONS(2947),
    [anon_sym_AMP_CARET] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [anon_sym_or] = ACTIONS(2947),
    [sym_none] = ACTIONS(2947),
    [sym_true] = ACTIONS(2947),
    [sym_false] = ACTIONS(2947),
    [sym_nil] = ACTIONS(2947),
    [anon_sym_QMARK_DOT] = ACTIONS(2947),
    [anon_sym_POUND_LBRACK] = ACTIONS(2947),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_DOLLARif] = ACTIONS(2947),
    [anon_sym_is] = ACTIONS(2947),
    [anon_sym_BANGis] = ACTIONS(2947),
    [anon_sym_in] = ACTIONS(2947),
    [anon_sym_BANGin] = ACTIONS(2947),
    [anon_sym_match] = ACTIONS(2947),
    [anon_sym_select] = ACTIONS(2947),
    [anon_sym_lock] = ACTIONS(2947),
    [anon_sym_rlock] = ACTIONS(2947),
    [anon_sym_unsafe] = ACTIONS(2947),
    [anon_sym_sql] = ACTIONS(2947),
    [sym_int_literal] = ACTIONS(2947),
    [sym_float_literal] = ACTIONS(2947),
    [sym_rune_literal] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(2947),
    [anon_sym_DQUOTE] = ACTIONS(2947),
    [anon_sym_c_SQUOTE] = ACTIONS(2947),
    [anon_sym_c_DQUOTE] = ACTIONS(2947),
    [anon_sym_r_SQUOTE] = ACTIONS(2947),
    [anon_sym_r_DQUOTE] = ACTIONS(2947),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2947),
    [anon_sym_shared] = ACTIONS(2947),
    [anon_sym_map_LBRACK] = ACTIONS(2947),
    [anon_sym_chan] = ACTIONS(2947),
    [anon_sym_thread] = ACTIONS(2947),
    [anon_sym_atomic] = ACTIONS(2947),
    [anon_sym_assert] = ACTIONS(2947),
    [anon_sym_defer] = ACTIONS(2947),
    [anon_sym_goto] = ACTIONS(2947),
    [anon_sym_break] = ACTIONS(2947),
    [anon_sym_continue] = ACTIONS(2947),
    [anon_sym_return] = ACTIONS(2947),
    [anon_sym_DOLLARfor] = ACTIONS(2947),
    [anon_sym_for] = ACTIONS(2947),
    [anon_sym_POUND] = ACTIONS(2947),
    [anon_sym_asm] = ACTIONS(2947),
    [anon_sym_AT_LBRACK] = ACTIONS(2947),
  },
  [1191] = {
    [sym_line_comment] = STATE(1191),
    [sym_block_comment] = STATE(1191),
    [ts_builtin_sym_end] = ACTIONS(2843),
    [sym_identifier] = ACTIONS(2845),
    [anon_sym_LF] = ACTIONS(2845),
    [anon_sym_CR] = ACTIONS(2845),
    [anon_sym_CR_LF] = ACTIONS(2845),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2845),
    [anon_sym_as] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2845),
    [anon_sym_COMMA] = ACTIONS(2845),
    [anon_sym_const] = ACTIONS(2845),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym___global] = ACTIONS(2845),
    [anon_sym_type] = ACTIONS(2845),
    [anon_sym_fn] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2845),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_SLASH] = ACTIONS(2845),
    [anon_sym_PERCENT] = ACTIONS(2845),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_GT] = ACTIONS(2845),
    [anon_sym_EQ_EQ] = ACTIONS(2845),
    [anon_sym_BANG_EQ] = ACTIONS(2845),
    [anon_sym_LT_EQ] = ACTIONS(2845),
    [anon_sym_GT_EQ] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2845),
    [anon_sym_union] = ACTIONS(2845),
    [anon_sym_pub] = ACTIONS(2845),
    [anon_sym_mut] = ACTIONS(2845),
    [anon_sym_enum] = ACTIONS(2845),
    [anon_sym_interface] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2845),
    [anon_sym_DASH_DASH] = ACTIONS(2845),
    [anon_sym_QMARK] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_go] = ACTIONS(2845),
    [anon_sym_spawn] = ACTIONS(2845),
    [anon_sym_json_DOTdecode] = ACTIONS(2845),
    [anon_sym_PIPE] = ACTIONS(2845),
    [anon_sym_LBRACK2] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_CARET] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2845),
    [anon_sym_LT_DASH] = ACTIONS(2845),
    [anon_sym_LT_LT] = ACTIONS(2845),
    [anon_sym_GT_GT] = ACTIONS(2845),
    [anon_sym_GT_GT_GT] = ACTIONS(2845),
    [anon_sym_AMP_CARET] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_PIPE_PIPE] = ACTIONS(2845),
    [anon_sym_or] = ACTIONS(2845),
    [sym_none] = ACTIONS(2845),
    [sym_true] = ACTIONS(2845),
    [sym_false] = ACTIONS(2845),
    [sym_nil] = ACTIONS(2845),
    [anon_sym_QMARK_DOT] = ACTIONS(2845),
    [anon_sym_POUND_LBRACK] = ACTIONS(2845),
    [anon_sym_if] = ACTIONS(2845),
    [anon_sym_DOLLARif] = ACTIONS(2845),
    [anon_sym_is] = ACTIONS(2845),
    [anon_sym_BANGis] = ACTIONS(2845),
    [anon_sym_in] = ACTIONS(2845),
    [anon_sym_BANGin] = ACTIONS(2845),
    [anon_sym_match] = ACTIONS(2845),
    [anon_sym_select] = ACTIONS(2845),
    [anon_sym_lock] = ACTIONS(2845),
    [anon_sym_rlock] = ACTIONS(2845),
    [anon_sym_unsafe] = ACTIONS(2845),
    [anon_sym_sql] = ACTIONS(2845),
    [sym_int_literal] = ACTIONS(2845),
    [sym_float_literal] = ACTIONS(2845),
    [sym_rune_literal] = ACTIONS(2845),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2845),
    [anon_sym_c_SQUOTE] = ACTIONS(2845),
    [anon_sym_c_DQUOTE] = ACTIONS(2845),
    [anon_sym_r_SQUOTE] = ACTIONS(2845),
    [anon_sym_r_DQUOTE] = ACTIONS(2845),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2845),
    [anon_sym_shared] = ACTIONS(2845),
    [anon_sym_map_LBRACK] = ACTIONS(2845),
    [anon_sym_chan] = ACTIONS(2845),
    [anon_sym_thread] = ACTIONS(2845),
    [anon_sym_atomic] = ACTIONS(2845),
    [anon_sym_assert] = ACTIONS(2845),
    [anon_sym_defer] = ACTIONS(2845),
    [anon_sym_goto] = ACTIONS(2845),
    [anon_sym_break] = ACTIONS(2845),
    [anon_sym_continue] = ACTIONS(2845),
    [anon_sym_return] = ACTIONS(2845),
    [anon_sym_DOLLARfor] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2845),
    [anon_sym_POUND] = ACTIONS(2845),
    [anon_sym_asm] = ACTIONS(2845),
    [anon_sym_AT_LBRACK] = ACTIONS(2845),
  },
  [1192] = {
    [sym_line_comment] = STATE(1192),
    [sym_block_comment] = STATE(1192),
    [ts_builtin_sym_end] = ACTIONS(2847),
    [sym_identifier] = ACTIONS(2849),
    [anon_sym_LF] = ACTIONS(2849),
    [anon_sym_CR] = ACTIONS(2849),
    [anon_sym_CR_LF] = ACTIONS(2849),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2849),
    [anon_sym_as] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_COMMA] = ACTIONS(2849),
    [anon_sym_const] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2849),
    [anon_sym___global] = ACTIONS(2849),
    [anon_sym_type] = ACTIONS(2849),
    [anon_sym_fn] = ACTIONS(2849),
    [anon_sym_PLUS] = ACTIONS(2849),
    [anon_sym_DASH] = ACTIONS(2849),
    [anon_sym_STAR] = ACTIONS(2849),
    [anon_sym_SLASH] = ACTIONS(2849),
    [anon_sym_PERCENT] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_GT] = ACTIONS(2849),
    [anon_sym_EQ_EQ] = ACTIONS(2849),
    [anon_sym_BANG_EQ] = ACTIONS(2849),
    [anon_sym_LT_EQ] = ACTIONS(2849),
    [anon_sym_GT_EQ] = ACTIONS(2849),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_struct] = ACTIONS(2849),
    [anon_sym_union] = ACTIONS(2849),
    [anon_sym_pub] = ACTIONS(2849),
    [anon_sym_mut] = ACTIONS(2849),
    [anon_sym_enum] = ACTIONS(2849),
    [anon_sym_interface] = ACTIONS(2849),
    [anon_sym_PLUS_PLUS] = ACTIONS(2849),
    [anon_sym_DASH_DASH] = ACTIONS(2849),
    [anon_sym_QMARK] = ACTIONS(2849),
    [anon_sym_BANG] = ACTIONS(2849),
    [anon_sym_go] = ACTIONS(2849),
    [anon_sym_spawn] = ACTIONS(2849),
    [anon_sym_json_DOTdecode] = ACTIONS(2849),
    [anon_sym_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACK2] = ACTIONS(2849),
    [anon_sym_TILDE] = ACTIONS(2849),
    [anon_sym_CARET] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2849),
    [anon_sym_LT_DASH] = ACTIONS(2849),
    [anon_sym_LT_LT] = ACTIONS(2849),
    [anon_sym_GT_GT] = ACTIONS(2849),
    [anon_sym_GT_GT_GT] = ACTIONS(2849),
    [anon_sym_AMP_CARET] = ACTIONS(2849),
    [anon_sym_AMP_AMP] = ACTIONS(2849),
    [anon_sym_PIPE_PIPE] = ACTIONS(2849),
    [anon_sym_or] = ACTIONS(2849),
    [sym_none] = ACTIONS(2849),
    [sym_true] = ACTIONS(2849),
    [sym_false] = ACTIONS(2849),
    [sym_nil] = ACTIONS(2849),
    [anon_sym_QMARK_DOT] = ACTIONS(2849),
    [anon_sym_POUND_LBRACK] = ACTIONS(2849),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_DOLLARif] = ACTIONS(2849),
    [anon_sym_is] = ACTIONS(2849),
    [anon_sym_BANGis] = ACTIONS(2849),
    [anon_sym_in] = ACTIONS(2849),
    [anon_sym_BANGin] = ACTIONS(2849),
    [anon_sym_match] = ACTIONS(2849),
    [anon_sym_select] = ACTIONS(2849),
    [anon_sym_lock] = ACTIONS(2849),
    [anon_sym_rlock] = ACTIONS(2849),
    [anon_sym_unsafe] = ACTIONS(2849),
    [anon_sym_sql] = ACTIONS(2849),
    [sym_int_literal] = ACTIONS(2849),
    [sym_float_literal] = ACTIONS(2849),
    [sym_rune_literal] = ACTIONS(2849),
    [anon_sym_SQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [anon_sym_c_SQUOTE] = ACTIONS(2849),
    [anon_sym_c_DQUOTE] = ACTIONS(2849),
    [anon_sym_r_SQUOTE] = ACTIONS(2849),
    [anon_sym_r_DQUOTE] = ACTIONS(2849),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2849),
    [anon_sym_shared] = ACTIONS(2849),
    [anon_sym_map_LBRACK] = ACTIONS(2849),
    [anon_sym_chan] = ACTIONS(2849),
    [anon_sym_thread] = ACTIONS(2849),
    [anon_sym_atomic] = ACTIONS(2849),
    [anon_sym_assert] = ACTIONS(2849),
    [anon_sym_defer] = ACTIONS(2849),
    [anon_sym_goto] = ACTIONS(2849),
    [anon_sym_break] = ACTIONS(2849),
    [anon_sym_continue] = ACTIONS(2849),
    [anon_sym_return] = ACTIONS(2849),
    [anon_sym_DOLLARfor] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2849),
    [anon_sym_POUND] = ACTIONS(2849),
    [anon_sym_asm] = ACTIONS(2849),
    [anon_sym_AT_LBRACK] = ACTIONS(2849),
  },
  [1193] = {
    [sym_line_comment] = STATE(1193),
    [sym_block_comment] = STATE(1193),
    [ts_builtin_sym_end] = ACTIONS(2875),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_LF] = ACTIONS(2877),
    [anon_sym_CR] = ACTIONS(2877),
    [anon_sym_CR_LF] = ACTIONS(2877),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2877),
    [anon_sym_as] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2877),
    [anon_sym_const] = ACTIONS(2877),
    [anon_sym_LPAREN] = ACTIONS(2877),
    [anon_sym___global] = ACTIONS(2877),
    [anon_sym_type] = ACTIONS(2877),
    [anon_sym_fn] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_STAR] = ACTIONS(2877),
    [anon_sym_SLASH] = ACTIONS(2877),
    [anon_sym_PERCENT] = ACTIONS(2877),
    [anon_sym_LT] = ACTIONS(2877),
    [anon_sym_GT] = ACTIONS(2877),
    [anon_sym_EQ_EQ] = ACTIONS(2877),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_LT_EQ] = ACTIONS(2877),
    [anon_sym_GT_EQ] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2875),
    [anon_sym_struct] = ACTIONS(2877),
    [anon_sym_union] = ACTIONS(2877),
    [anon_sym_pub] = ACTIONS(2877),
    [anon_sym_mut] = ACTIONS(2877),
    [anon_sym_enum] = ACTIONS(2877),
    [anon_sym_interface] = ACTIONS(2877),
    [anon_sym_PLUS_PLUS] = ACTIONS(2877),
    [anon_sym_DASH_DASH] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2877),
    [anon_sym_go] = ACTIONS(2877),
    [anon_sym_spawn] = ACTIONS(2877),
    [anon_sym_json_DOTdecode] = ACTIONS(2877),
    [anon_sym_PIPE] = ACTIONS(2877),
    [anon_sym_LBRACK2] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2877),
    [anon_sym_CARET] = ACTIONS(2877),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_LT_DASH] = ACTIONS(2877),
    [anon_sym_LT_LT] = ACTIONS(2877),
    [anon_sym_GT_GT] = ACTIONS(2877),
    [anon_sym_GT_GT_GT] = ACTIONS(2877),
    [anon_sym_AMP_CARET] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_PIPE_PIPE] = ACTIONS(2877),
    [anon_sym_or] = ACTIONS(2877),
    [sym_none] = ACTIONS(2877),
    [sym_true] = ACTIONS(2877),
    [sym_false] = ACTIONS(2877),
    [sym_nil] = ACTIONS(2877),
    [anon_sym_QMARK_DOT] = ACTIONS(2877),
    [anon_sym_POUND_LBRACK] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_DOLLARif] = ACTIONS(2877),
    [anon_sym_is] = ACTIONS(2877),
    [anon_sym_BANGis] = ACTIONS(2877),
    [anon_sym_in] = ACTIONS(2877),
    [anon_sym_BANGin] = ACTIONS(2877),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_select] = ACTIONS(2877),
    [anon_sym_lock] = ACTIONS(2877),
    [anon_sym_rlock] = ACTIONS(2877),
    [anon_sym_unsafe] = ACTIONS(2877),
    [anon_sym_sql] = ACTIONS(2877),
    [sym_int_literal] = ACTIONS(2877),
    [sym_float_literal] = ACTIONS(2877),
    [sym_rune_literal] = ACTIONS(2877),
    [anon_sym_SQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [anon_sym_c_SQUOTE] = ACTIONS(2877),
    [anon_sym_c_DQUOTE] = ACTIONS(2877),
    [anon_sym_r_SQUOTE] = ACTIONS(2877),
    [anon_sym_r_DQUOTE] = ACTIONS(2877),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2877),
    [anon_sym_shared] = ACTIONS(2877),
    [anon_sym_map_LBRACK] = ACTIONS(2877),
    [anon_sym_chan] = ACTIONS(2877),
    [anon_sym_thread] = ACTIONS(2877),
    [anon_sym_atomic] = ACTIONS(2877),
    [anon_sym_assert] = ACTIONS(2877),
    [anon_sym_defer] = ACTIONS(2877),
    [anon_sym_goto] = ACTIONS(2877),
    [anon_sym_break] = ACTIONS(2877),
    [anon_sym_continue] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_DOLLARfor] = ACTIONS(2877),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_POUND] = ACTIONS(2877),
    [anon_sym_asm] = ACTIONS(2877),
    [anon_sym_AT_LBRACK] = ACTIONS(2877),
  },
  [1194] = {
    [sym_line_comment] = STATE(1194),
    [sym_block_comment] = STATE(1194),
    [ts_builtin_sym_end] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2889),
    [anon_sym_LF] = ACTIONS(2889),
    [anon_sym_CR] = ACTIONS(2889),
    [anon_sym_CR_LF] = ACTIONS(2889),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2889),
    [anon_sym_as] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2889),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_const] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2889),
    [anon_sym___global] = ACTIONS(2889),
    [anon_sym_type] = ACTIONS(2889),
    [anon_sym_fn] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2889),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_SLASH] = ACTIONS(2889),
    [anon_sym_PERCENT] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_GT] = ACTIONS(2889),
    [anon_sym_EQ_EQ] = ACTIONS(2889),
    [anon_sym_BANG_EQ] = ACTIONS(2889),
    [anon_sym_LT_EQ] = ACTIONS(2889),
    [anon_sym_GT_EQ] = ACTIONS(2889),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_struct] = ACTIONS(2889),
    [anon_sym_union] = ACTIONS(2889),
    [anon_sym_pub] = ACTIONS(2889),
    [anon_sym_mut] = ACTIONS(2889),
    [anon_sym_enum] = ACTIONS(2889),
    [anon_sym_interface] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2889),
    [anon_sym_DASH_DASH] = ACTIONS(2889),
    [anon_sym_QMARK] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2889),
    [anon_sym_go] = ACTIONS(2889),
    [anon_sym_spawn] = ACTIONS(2889),
    [anon_sym_json_DOTdecode] = ACTIONS(2889),
    [anon_sym_PIPE] = ACTIONS(2889),
    [anon_sym_LBRACK2] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_CARET] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2889),
    [anon_sym_LT_DASH] = ACTIONS(2889),
    [anon_sym_LT_LT] = ACTIONS(2889),
    [anon_sym_GT_GT] = ACTIONS(2889),
    [anon_sym_GT_GT_GT] = ACTIONS(2889),
    [anon_sym_AMP_CARET] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2889),
    [anon_sym_or] = ACTIONS(2889),
    [sym_none] = ACTIONS(2889),
    [sym_true] = ACTIONS(2889),
    [sym_false] = ACTIONS(2889),
    [sym_nil] = ACTIONS(2889),
    [anon_sym_QMARK_DOT] = ACTIONS(2889),
    [anon_sym_POUND_LBRACK] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_DOLLARif] = ACTIONS(2889),
    [anon_sym_is] = ACTIONS(2889),
    [anon_sym_BANGis] = ACTIONS(2889),
    [anon_sym_in] = ACTIONS(2889),
    [anon_sym_BANGin] = ACTIONS(2889),
    [anon_sym_match] = ACTIONS(2889),
    [anon_sym_select] = ACTIONS(2889),
    [anon_sym_lock] = ACTIONS(2889),
    [anon_sym_rlock] = ACTIONS(2889),
    [anon_sym_unsafe] = ACTIONS(2889),
    [anon_sym_sql] = ACTIONS(2889),
    [sym_int_literal] = ACTIONS(2889),
    [sym_float_literal] = ACTIONS(2889),
    [sym_rune_literal] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [anon_sym_c_SQUOTE] = ACTIONS(2889),
    [anon_sym_c_DQUOTE] = ACTIONS(2889),
    [anon_sym_r_SQUOTE] = ACTIONS(2889),
    [anon_sym_r_DQUOTE] = ACTIONS(2889),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2889),
    [anon_sym_shared] = ACTIONS(2889),
    [anon_sym_map_LBRACK] = ACTIONS(2889),
    [anon_sym_chan] = ACTIONS(2889),
    [anon_sym_thread] = ACTIONS(2889),
    [anon_sym_atomic] = ACTIONS(2889),
    [anon_sym_assert] = ACTIONS(2889),
    [anon_sym_defer] = ACTIONS(2889),
    [anon_sym_goto] = ACTIONS(2889),
    [anon_sym_break] = ACTIONS(2889),
    [anon_sym_continue] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_DOLLARfor] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_POUND] = ACTIONS(2889),
    [anon_sym_asm] = ACTIONS(2889),
    [anon_sym_AT_LBRACK] = ACTIONS(2889),
  },
  [1195] = {
    [sym_line_comment] = STATE(1195),
    [sym_block_comment] = STATE(1195),
    [ts_builtin_sym_end] = ACTIONS(3260),
    [sym_identifier] = ACTIONS(3262),
    [anon_sym_LF] = ACTIONS(3262),
    [anon_sym_CR] = ACTIONS(3262),
    [anon_sym_CR_LF] = ACTIONS(3262),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3262),
    [anon_sym_as] = ACTIONS(3262),
    [anon_sym_LBRACE] = ACTIONS(3262),
    [anon_sym_COMMA] = ACTIONS(3262),
    [anon_sym_const] = ACTIONS(3262),
    [anon_sym_LPAREN] = ACTIONS(3262),
    [anon_sym___global] = ACTIONS(3262),
    [anon_sym_type] = ACTIONS(3262),
    [anon_sym_fn] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3262),
    [anon_sym_DASH] = ACTIONS(3262),
    [anon_sym_STAR] = ACTIONS(3262),
    [anon_sym_SLASH] = ACTIONS(3262),
    [anon_sym_PERCENT] = ACTIONS(3262),
    [anon_sym_LT] = ACTIONS(3262),
    [anon_sym_GT] = ACTIONS(3262),
    [anon_sym_EQ_EQ] = ACTIONS(3262),
    [anon_sym_BANG_EQ] = ACTIONS(3262),
    [anon_sym_LT_EQ] = ACTIONS(3262),
    [anon_sym_GT_EQ] = ACTIONS(3262),
    [anon_sym_LBRACK] = ACTIONS(3260),
    [anon_sym_struct] = ACTIONS(3262),
    [anon_sym_union] = ACTIONS(3262),
    [anon_sym_pub] = ACTIONS(3262),
    [anon_sym_mut] = ACTIONS(3262),
    [anon_sym_enum] = ACTIONS(3262),
    [anon_sym_interface] = ACTIONS(3262),
    [anon_sym_PLUS_PLUS] = ACTIONS(3262),
    [anon_sym_DASH_DASH] = ACTIONS(3262),
    [anon_sym_QMARK] = ACTIONS(3262),
    [anon_sym_BANG] = ACTIONS(3262),
    [anon_sym_go] = ACTIONS(3262),
    [anon_sym_spawn] = ACTIONS(3262),
    [anon_sym_json_DOTdecode] = ACTIONS(3262),
    [anon_sym_PIPE] = ACTIONS(3262),
    [anon_sym_LBRACK2] = ACTIONS(3262),
    [anon_sym_TILDE] = ACTIONS(3262),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_AMP] = ACTIONS(3262),
    [anon_sym_LT_DASH] = ACTIONS(3262),
    [anon_sym_LT_LT] = ACTIONS(3262),
    [anon_sym_GT_GT] = ACTIONS(3262),
    [anon_sym_GT_GT_GT] = ACTIONS(3262),
    [anon_sym_AMP_CARET] = ACTIONS(3262),
    [anon_sym_AMP_AMP] = ACTIONS(3262),
    [anon_sym_PIPE_PIPE] = ACTIONS(3262),
    [anon_sym_or] = ACTIONS(3262),
    [sym_none] = ACTIONS(3262),
    [sym_true] = ACTIONS(3262),
    [sym_false] = ACTIONS(3262),
    [sym_nil] = ACTIONS(3262),
    [anon_sym_QMARK_DOT] = ACTIONS(3262),
    [anon_sym_POUND_LBRACK] = ACTIONS(3262),
    [anon_sym_if] = ACTIONS(3262),
    [anon_sym_DOLLARif] = ACTIONS(3262),
    [anon_sym_is] = ACTIONS(3262),
    [anon_sym_BANGis] = ACTIONS(3262),
    [anon_sym_in] = ACTIONS(3262),
    [anon_sym_BANGin] = ACTIONS(3262),
    [anon_sym_match] = ACTIONS(3262),
    [anon_sym_select] = ACTIONS(3262),
    [anon_sym_lock] = ACTIONS(3262),
    [anon_sym_rlock] = ACTIONS(3262),
    [anon_sym_unsafe] = ACTIONS(3262),
    [anon_sym_sql] = ACTIONS(3262),
    [sym_int_literal] = ACTIONS(3262),
    [sym_float_literal] = ACTIONS(3262),
    [sym_rune_literal] = ACTIONS(3262),
    [anon_sym_SQUOTE] = ACTIONS(3262),
    [anon_sym_DQUOTE] = ACTIONS(3262),
    [anon_sym_c_SQUOTE] = ACTIONS(3262),
    [anon_sym_c_DQUOTE] = ACTIONS(3262),
    [anon_sym_r_SQUOTE] = ACTIONS(3262),
    [anon_sym_r_DQUOTE] = ACTIONS(3262),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3262),
    [anon_sym_shared] = ACTIONS(3262),
    [anon_sym_map_LBRACK] = ACTIONS(3262),
    [anon_sym_chan] = ACTIONS(3262),
    [anon_sym_thread] = ACTIONS(3262),
    [anon_sym_atomic] = ACTIONS(3262),
    [anon_sym_assert] = ACTIONS(3262),
    [anon_sym_defer] = ACTIONS(3262),
    [anon_sym_goto] = ACTIONS(3262),
    [anon_sym_break] = ACTIONS(3262),
    [anon_sym_continue] = ACTIONS(3262),
    [anon_sym_return] = ACTIONS(3262),
    [anon_sym_DOLLARfor] = ACTIONS(3262),
    [anon_sym_for] = ACTIONS(3262),
    [anon_sym_POUND] = ACTIONS(3262),
    [anon_sym_asm] = ACTIONS(3262),
    [anon_sym_AT_LBRACK] = ACTIONS(3262),
  },
  [1196] = {
    [sym_line_comment] = STATE(1196),
    [sym_block_comment] = STATE(1196),
    [ts_builtin_sym_end] = ACTIONS(3348),
    [sym_identifier] = ACTIONS(3350),
    [anon_sym_LF] = ACTIONS(3350),
    [anon_sym_CR] = ACTIONS(3350),
    [anon_sym_CR_LF] = ACTIONS(3350),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3350),
    [anon_sym_as] = ACTIONS(3350),
    [anon_sym_LBRACE] = ACTIONS(3350),
    [anon_sym_COMMA] = ACTIONS(3350),
    [anon_sym_const] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(3350),
    [anon_sym___global] = ACTIONS(3350),
    [anon_sym_type] = ACTIONS(3350),
    [anon_sym_fn] = ACTIONS(3350),
    [anon_sym_PLUS] = ACTIONS(3350),
    [anon_sym_DASH] = ACTIONS(3350),
    [anon_sym_STAR] = ACTIONS(3350),
    [anon_sym_SLASH] = ACTIONS(3350),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_LT] = ACTIONS(3350),
    [anon_sym_GT] = ACTIONS(3350),
    [anon_sym_EQ_EQ] = ACTIONS(3350),
    [anon_sym_BANG_EQ] = ACTIONS(3350),
    [anon_sym_LT_EQ] = ACTIONS(3350),
    [anon_sym_GT_EQ] = ACTIONS(3350),
    [anon_sym_LBRACK] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3350),
    [anon_sym_union] = ACTIONS(3350),
    [anon_sym_pub] = ACTIONS(3350),
    [anon_sym_mut] = ACTIONS(3350),
    [anon_sym_enum] = ACTIONS(3350),
    [anon_sym_interface] = ACTIONS(3350),
    [anon_sym_PLUS_PLUS] = ACTIONS(3350),
    [anon_sym_DASH_DASH] = ACTIONS(3350),
    [anon_sym_QMARK] = ACTIONS(3350),
    [anon_sym_BANG] = ACTIONS(3350),
    [anon_sym_go] = ACTIONS(3350),
    [anon_sym_spawn] = ACTIONS(3350),
    [anon_sym_json_DOTdecode] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3350),
    [anon_sym_LBRACK2] = ACTIONS(3350),
    [anon_sym_TILDE] = ACTIONS(3350),
    [anon_sym_CARET] = ACTIONS(3350),
    [anon_sym_AMP] = ACTIONS(3350),
    [anon_sym_LT_DASH] = ACTIONS(3350),
    [anon_sym_LT_LT] = ACTIONS(3350),
    [anon_sym_GT_GT] = ACTIONS(3350),
    [anon_sym_GT_GT_GT] = ACTIONS(3350),
    [anon_sym_AMP_CARET] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_PIPE_PIPE] = ACTIONS(3350),
    [anon_sym_or] = ACTIONS(3350),
    [sym_none] = ACTIONS(3350),
    [sym_true] = ACTIONS(3350),
    [sym_false] = ACTIONS(3350),
    [sym_nil] = ACTIONS(3350),
    [anon_sym_QMARK_DOT] = ACTIONS(3350),
    [anon_sym_POUND_LBRACK] = ACTIONS(3350),
    [anon_sym_if] = ACTIONS(3350),
    [anon_sym_DOLLARif] = ACTIONS(3350),
    [anon_sym_is] = ACTIONS(3350),
    [anon_sym_BANGis] = ACTIONS(3350),
    [anon_sym_in] = ACTIONS(3350),
    [anon_sym_BANGin] = ACTIONS(3350),
    [anon_sym_match] = ACTIONS(3350),
    [anon_sym_select] = ACTIONS(3350),
    [anon_sym_lock] = ACTIONS(3350),
    [anon_sym_rlock] = ACTIONS(3350),
    [anon_sym_unsafe] = ACTIONS(3350),
    [anon_sym_sql] = ACTIONS(3350),
    [sym_int_literal] = ACTIONS(3350),
    [sym_float_literal] = ACTIONS(3350),
    [sym_rune_literal] = ACTIONS(3350),
    [anon_sym_SQUOTE] = ACTIONS(3350),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [anon_sym_c_SQUOTE] = ACTIONS(3350),
    [anon_sym_c_DQUOTE] = ACTIONS(3350),
    [anon_sym_r_SQUOTE] = ACTIONS(3350),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3350),
    [anon_sym_shared] = ACTIONS(3350),
    [anon_sym_map_LBRACK] = ACTIONS(3350),
    [anon_sym_chan] = ACTIONS(3350),
    [anon_sym_thread] = ACTIONS(3350),
    [anon_sym_atomic] = ACTIONS(3350),
    [anon_sym_assert] = ACTIONS(3350),
    [anon_sym_defer] = ACTIONS(3350),
    [anon_sym_goto] = ACTIONS(3350),
    [anon_sym_break] = ACTIONS(3350),
    [anon_sym_continue] = ACTIONS(3350),
    [anon_sym_return] = ACTIONS(3350),
    [anon_sym_DOLLARfor] = ACTIONS(3350),
    [anon_sym_for] = ACTIONS(3350),
    [anon_sym_POUND] = ACTIONS(3350),
    [anon_sym_asm] = ACTIONS(3350),
    [anon_sym_AT_LBRACK] = ACTIONS(3350),
  },
  [1197] = {
    [sym_line_comment] = STATE(1197),
    [sym_block_comment] = STATE(1197),
    [ts_builtin_sym_end] = ACTIONS(3071),
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_LF] = ACTIONS(3073),
    [anon_sym_CR] = ACTIONS(3073),
    [anon_sym_CR_LF] = ACTIONS(3073),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3073),
    [anon_sym_as] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3073),
    [anon_sym_COMMA] = ACTIONS(3073),
    [anon_sym_const] = ACTIONS(3073),
    [anon_sym_LPAREN] = ACTIONS(3073),
    [anon_sym___global] = ACTIONS(3073),
    [anon_sym_type] = ACTIONS(3073),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(3073),
    [anon_sym_DASH] = ACTIONS(3073),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_SLASH] = ACTIONS(3073),
    [anon_sym_PERCENT] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_GT] = ACTIONS(3073),
    [anon_sym_EQ_EQ] = ACTIONS(3073),
    [anon_sym_BANG_EQ] = ACTIONS(3073),
    [anon_sym_LT_EQ] = ACTIONS(3073),
    [anon_sym_GT_EQ] = ACTIONS(3073),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3073),
    [anon_sym_union] = ACTIONS(3073),
    [anon_sym_pub] = ACTIONS(3073),
    [anon_sym_mut] = ACTIONS(3073),
    [anon_sym_enum] = ACTIONS(3073),
    [anon_sym_interface] = ACTIONS(3073),
    [anon_sym_PLUS_PLUS] = ACTIONS(3073),
    [anon_sym_DASH_DASH] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3073),
    [anon_sym_BANG] = ACTIONS(3073),
    [anon_sym_go] = ACTIONS(3073),
    [anon_sym_spawn] = ACTIONS(3073),
    [anon_sym_json_DOTdecode] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(3073),
    [anon_sym_LBRACK2] = ACTIONS(3073),
    [anon_sym_TILDE] = ACTIONS(3073),
    [anon_sym_CARET] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3073),
    [anon_sym_LT_DASH] = ACTIONS(3073),
    [anon_sym_LT_LT] = ACTIONS(3073),
    [anon_sym_GT_GT] = ACTIONS(3073),
    [anon_sym_GT_GT_GT] = ACTIONS(3073),
    [anon_sym_AMP_CARET] = ACTIONS(3073),
    [anon_sym_AMP_AMP] = ACTIONS(3073),
    [anon_sym_PIPE_PIPE] = ACTIONS(3073),
    [anon_sym_or] = ACTIONS(3073),
    [sym_none] = ACTIONS(3073),
    [sym_true] = ACTIONS(3073),
    [sym_false] = ACTIONS(3073),
    [sym_nil] = ACTIONS(3073),
    [anon_sym_QMARK_DOT] = ACTIONS(3073),
    [anon_sym_POUND_LBRACK] = ACTIONS(3073),
    [anon_sym_if] = ACTIONS(3073),
    [anon_sym_DOLLARif] = ACTIONS(3073),
    [anon_sym_is] = ACTIONS(3073),
    [anon_sym_BANGis] = ACTIONS(3073),
    [anon_sym_in] = ACTIONS(3073),
    [anon_sym_BANGin] = ACTIONS(3073),
    [anon_sym_match] = ACTIONS(3073),
    [anon_sym_select] = ACTIONS(3073),
    [anon_sym_lock] = ACTIONS(3073),
    [anon_sym_rlock] = ACTIONS(3073),
    [anon_sym_unsafe] = ACTIONS(3073),
    [anon_sym_sql] = ACTIONS(3073),
    [sym_int_literal] = ACTIONS(3073),
    [sym_float_literal] = ACTIONS(3073),
    [sym_rune_literal] = ACTIONS(3073),
    [anon_sym_SQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE] = ACTIONS(3073),
    [anon_sym_c_SQUOTE] = ACTIONS(3073),
    [anon_sym_c_DQUOTE] = ACTIONS(3073),
    [anon_sym_r_SQUOTE] = ACTIONS(3073),
    [anon_sym_r_DQUOTE] = ACTIONS(3073),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3073),
    [anon_sym_shared] = ACTIONS(3073),
    [anon_sym_map_LBRACK] = ACTIONS(3073),
    [anon_sym_chan] = ACTIONS(3073),
    [anon_sym_thread] = ACTIONS(3073),
    [anon_sym_atomic] = ACTIONS(3073),
    [anon_sym_assert] = ACTIONS(3073),
    [anon_sym_defer] = ACTIONS(3073),
    [anon_sym_goto] = ACTIONS(3073),
    [anon_sym_break] = ACTIONS(3073),
    [anon_sym_continue] = ACTIONS(3073),
    [anon_sym_return] = ACTIONS(3073),
    [anon_sym_DOLLARfor] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(3073),
    [anon_sym_POUND] = ACTIONS(3073),
    [anon_sym_asm] = ACTIONS(3073),
    [anon_sym_AT_LBRACK] = ACTIONS(3073),
  },
  [1198] = {
    [sym_line_comment] = STATE(1198),
    [sym_block_comment] = STATE(1198),
    [ts_builtin_sym_end] = ACTIONS(3063),
    [sym_identifier] = ACTIONS(3065),
    [anon_sym_LF] = ACTIONS(3065),
    [anon_sym_CR] = ACTIONS(3065),
    [anon_sym_CR_LF] = ACTIONS(3065),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3065),
    [anon_sym_as] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_COMMA] = ACTIONS(3065),
    [anon_sym_const] = ACTIONS(3065),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym___global] = ACTIONS(3065),
    [anon_sym_type] = ACTIONS(3065),
    [anon_sym_fn] = ACTIONS(3065),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_SLASH] = ACTIONS(3065),
    [anon_sym_PERCENT] = ACTIONS(3065),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_GT] = ACTIONS(3065),
    [anon_sym_EQ_EQ] = ACTIONS(3065),
    [anon_sym_BANG_EQ] = ACTIONS(3065),
    [anon_sym_LT_EQ] = ACTIONS(3065),
    [anon_sym_GT_EQ] = ACTIONS(3065),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3065),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_pub] = ACTIONS(3065),
    [anon_sym_mut] = ACTIONS(3065),
    [anon_sym_enum] = ACTIONS(3065),
    [anon_sym_interface] = ACTIONS(3065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_QMARK] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_go] = ACTIONS(3065),
    [anon_sym_spawn] = ACTIONS(3065),
    [anon_sym_json_DOTdecode] = ACTIONS(3065),
    [anon_sym_PIPE] = ACTIONS(3065),
    [anon_sym_LBRACK2] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_CARET] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3065),
    [anon_sym_LT_DASH] = ACTIONS(3065),
    [anon_sym_LT_LT] = ACTIONS(3065),
    [anon_sym_GT_GT] = ACTIONS(3065),
    [anon_sym_GT_GT_GT] = ACTIONS(3065),
    [anon_sym_AMP_CARET] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_PIPE_PIPE] = ACTIONS(3065),
    [anon_sym_or] = ACTIONS(3065),
    [sym_none] = ACTIONS(3065),
    [sym_true] = ACTIONS(3065),
    [sym_false] = ACTIONS(3065),
    [sym_nil] = ACTIONS(3065),
    [anon_sym_QMARK_DOT] = ACTIONS(3065),
    [anon_sym_POUND_LBRACK] = ACTIONS(3065),
    [anon_sym_if] = ACTIONS(3065),
    [anon_sym_DOLLARif] = ACTIONS(3065),
    [anon_sym_is] = ACTIONS(3065),
    [anon_sym_BANGis] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3065),
    [anon_sym_BANGin] = ACTIONS(3065),
    [anon_sym_match] = ACTIONS(3065),
    [anon_sym_select] = ACTIONS(3065),
    [anon_sym_lock] = ACTIONS(3065),
    [anon_sym_rlock] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(3065),
    [anon_sym_sql] = ACTIONS(3065),
    [sym_int_literal] = ACTIONS(3065),
    [sym_float_literal] = ACTIONS(3065),
    [sym_rune_literal] = ACTIONS(3065),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [anon_sym_c_SQUOTE] = ACTIONS(3065),
    [anon_sym_c_DQUOTE] = ACTIONS(3065),
    [anon_sym_r_SQUOTE] = ACTIONS(3065),
    [anon_sym_r_DQUOTE] = ACTIONS(3065),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3065),
    [anon_sym_shared] = ACTIONS(3065),
    [anon_sym_map_LBRACK] = ACTIONS(3065),
    [anon_sym_chan] = ACTIONS(3065),
    [anon_sym_thread] = ACTIONS(3065),
    [anon_sym_atomic] = ACTIONS(3065),
    [anon_sym_assert] = ACTIONS(3065),
    [anon_sym_defer] = ACTIONS(3065),
    [anon_sym_goto] = ACTIONS(3065),
    [anon_sym_break] = ACTIONS(3065),
    [anon_sym_continue] = ACTIONS(3065),
    [anon_sym_return] = ACTIONS(3065),
    [anon_sym_DOLLARfor] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3065),
    [anon_sym_POUND] = ACTIONS(3065),
    [anon_sym_asm] = ACTIONS(3065),
    [anon_sym_AT_LBRACK] = ACTIONS(3065),
  },
  [1199] = {
    [sym_line_comment] = STATE(1199),
    [sym_block_comment] = STATE(1199),
    [ts_builtin_sym_end] = ACTIONS(3059),
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_LF] = ACTIONS(3061),
    [anon_sym_CR] = ACTIONS(3061),
    [anon_sym_CR_LF] = ACTIONS(3061),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3061),
    [anon_sym_as] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3061),
    [anon_sym_COMMA] = ACTIONS(3061),
    [anon_sym_const] = ACTIONS(3061),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym___global] = ACTIONS(3061),
    [anon_sym_type] = ACTIONS(3061),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_PLUS] = ACTIONS(3061),
    [anon_sym_DASH] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(3061),
    [anon_sym_SLASH] = ACTIONS(3061),
    [anon_sym_PERCENT] = ACTIONS(3061),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_GT] = ACTIONS(3061),
    [anon_sym_EQ_EQ] = ACTIONS(3061),
    [anon_sym_BANG_EQ] = ACTIONS(3061),
    [anon_sym_LT_EQ] = ACTIONS(3061),
    [anon_sym_GT_EQ] = ACTIONS(3061),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_struct] = ACTIONS(3061),
    [anon_sym_union] = ACTIONS(3061),
    [anon_sym_pub] = ACTIONS(3061),
    [anon_sym_mut] = ACTIONS(3061),
    [anon_sym_enum] = ACTIONS(3061),
    [anon_sym_interface] = ACTIONS(3061),
    [anon_sym_PLUS_PLUS] = ACTIONS(3061),
    [anon_sym_DASH_DASH] = ACTIONS(3061),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_BANG] = ACTIONS(3061),
    [anon_sym_go] = ACTIONS(3061),
    [anon_sym_spawn] = ACTIONS(3061),
    [anon_sym_json_DOTdecode] = ACTIONS(3061),
    [anon_sym_PIPE] = ACTIONS(3061),
    [anon_sym_LBRACK2] = ACTIONS(3061),
    [anon_sym_TILDE] = ACTIONS(3061),
    [anon_sym_CARET] = ACTIONS(3061),
    [anon_sym_AMP] = ACTIONS(3061),
    [anon_sym_LT_DASH] = ACTIONS(3061),
    [anon_sym_LT_LT] = ACTIONS(3061),
    [anon_sym_GT_GT] = ACTIONS(3061),
    [anon_sym_GT_GT_GT] = ACTIONS(3061),
    [anon_sym_AMP_CARET] = ACTIONS(3061),
    [anon_sym_AMP_AMP] = ACTIONS(3061),
    [anon_sym_PIPE_PIPE] = ACTIONS(3061),
    [anon_sym_or] = ACTIONS(3061),
    [sym_none] = ACTIONS(3061),
    [sym_true] = ACTIONS(3061),
    [sym_false] = ACTIONS(3061),
    [sym_nil] = ACTIONS(3061),
    [anon_sym_QMARK_DOT] = ACTIONS(3061),
    [anon_sym_POUND_LBRACK] = ACTIONS(3061),
    [anon_sym_if] = ACTIONS(3061),
    [anon_sym_DOLLARif] = ACTIONS(3061),
    [anon_sym_is] = ACTIONS(3061),
    [anon_sym_BANGis] = ACTIONS(3061),
    [anon_sym_in] = ACTIONS(3061),
    [anon_sym_BANGin] = ACTIONS(3061),
    [anon_sym_match] = ACTIONS(3061),
    [anon_sym_select] = ACTIONS(3061),
    [anon_sym_lock] = ACTIONS(3061),
    [anon_sym_rlock] = ACTIONS(3061),
    [anon_sym_unsafe] = ACTIONS(3061),
    [anon_sym_sql] = ACTIONS(3061),
    [sym_int_literal] = ACTIONS(3061),
    [sym_float_literal] = ACTIONS(3061),
    [sym_rune_literal] = ACTIONS(3061),
    [anon_sym_SQUOTE] = ACTIONS(3061),
    [anon_sym_DQUOTE] = ACTIONS(3061),
    [anon_sym_c_SQUOTE] = ACTIONS(3061),
    [anon_sym_c_DQUOTE] = ACTIONS(3061),
    [anon_sym_r_SQUOTE] = ACTIONS(3061),
    [anon_sym_r_DQUOTE] = ACTIONS(3061),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3061),
    [anon_sym_shared] = ACTIONS(3061),
    [anon_sym_map_LBRACK] = ACTIONS(3061),
    [anon_sym_chan] = ACTIONS(3061),
    [anon_sym_thread] = ACTIONS(3061),
    [anon_sym_atomic] = ACTIONS(3061),
    [anon_sym_assert] = ACTIONS(3061),
    [anon_sym_defer] = ACTIONS(3061),
    [anon_sym_goto] = ACTIONS(3061),
    [anon_sym_break] = ACTIONS(3061),
    [anon_sym_continue] = ACTIONS(3061),
    [anon_sym_return] = ACTIONS(3061),
    [anon_sym_DOLLARfor] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(3061),
    [anon_sym_POUND] = ACTIONS(3061),
    [anon_sym_asm] = ACTIONS(3061),
    [anon_sym_AT_LBRACK] = ACTIONS(3061),
  },
  [1200] = {
    [sym_line_comment] = STATE(1200),
    [sym_block_comment] = STATE(1200),
    [ts_builtin_sym_end] = ACTIONS(2995),
    [sym_identifier] = ACTIONS(2997),
    [anon_sym_LF] = ACTIONS(2997),
    [anon_sym_CR] = ACTIONS(2997),
    [anon_sym_CR_LF] = ACTIONS(2997),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2997),
    [anon_sym_as] = ACTIONS(2997),
    [anon_sym_LBRACE] = ACTIONS(2997),
    [anon_sym_COMMA] = ACTIONS(2997),
    [anon_sym_const] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(2997),
    [anon_sym___global] = ACTIONS(2997),
    [anon_sym_type] = ACTIONS(2997),
    [anon_sym_fn] = ACTIONS(2997),
    [anon_sym_PLUS] = ACTIONS(2997),
    [anon_sym_DASH] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(2997),
    [anon_sym_SLASH] = ACTIONS(2997),
    [anon_sym_PERCENT] = ACTIONS(2997),
    [anon_sym_LT] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(2997),
    [anon_sym_EQ_EQ] = ACTIONS(2997),
    [anon_sym_BANG_EQ] = ACTIONS(2997),
    [anon_sym_LT_EQ] = ACTIONS(2997),
    [anon_sym_GT_EQ] = ACTIONS(2997),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_struct] = ACTIONS(2997),
    [anon_sym_union] = ACTIONS(2997),
    [anon_sym_pub] = ACTIONS(2997),
    [anon_sym_mut] = ACTIONS(2997),
    [anon_sym_enum] = ACTIONS(2997),
    [anon_sym_interface] = ACTIONS(2997),
    [anon_sym_PLUS_PLUS] = ACTIONS(2997),
    [anon_sym_DASH_DASH] = ACTIONS(2997),
    [anon_sym_QMARK] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2997),
    [anon_sym_go] = ACTIONS(2997),
    [anon_sym_spawn] = ACTIONS(2997),
    [anon_sym_json_DOTdecode] = ACTIONS(2997),
    [anon_sym_PIPE] = ACTIONS(2997),
    [anon_sym_LBRACK2] = ACTIONS(2997),
    [anon_sym_TILDE] = ACTIONS(2997),
    [anon_sym_CARET] = ACTIONS(2997),
    [anon_sym_AMP] = ACTIONS(2997),
    [anon_sym_LT_DASH] = ACTIONS(2997),
    [anon_sym_LT_LT] = ACTIONS(2997),
    [anon_sym_GT_GT] = ACTIONS(2997),
    [anon_sym_GT_GT_GT] = ACTIONS(2997),
    [anon_sym_AMP_CARET] = ACTIONS(2997),
    [anon_sym_AMP_AMP] = ACTIONS(2997),
    [anon_sym_PIPE_PIPE] = ACTIONS(2997),
    [anon_sym_or] = ACTIONS(2997),
    [sym_none] = ACTIONS(2997),
    [sym_true] = ACTIONS(2997),
    [sym_false] = ACTIONS(2997),
    [sym_nil] = ACTIONS(2997),
    [anon_sym_QMARK_DOT] = ACTIONS(2997),
    [anon_sym_POUND_LBRACK] = ACTIONS(2997),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_DOLLARif] = ACTIONS(2997),
    [anon_sym_is] = ACTIONS(2997),
    [anon_sym_BANGis] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(2997),
    [anon_sym_BANGin] = ACTIONS(2997),
    [anon_sym_match] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [anon_sym_lock] = ACTIONS(2997),
    [anon_sym_rlock] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(2997),
    [anon_sym_sql] = ACTIONS(2997),
    [sym_int_literal] = ACTIONS(2997),
    [sym_float_literal] = ACTIONS(2997),
    [sym_rune_literal] = ACTIONS(2997),
    [anon_sym_SQUOTE] = ACTIONS(2997),
    [anon_sym_DQUOTE] = ACTIONS(2997),
    [anon_sym_c_SQUOTE] = ACTIONS(2997),
    [anon_sym_c_DQUOTE] = ACTIONS(2997),
    [anon_sym_r_SQUOTE] = ACTIONS(2997),
    [anon_sym_r_DQUOTE] = ACTIONS(2997),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2997),
    [anon_sym_shared] = ACTIONS(2997),
    [anon_sym_map_LBRACK] = ACTIONS(2997),
    [anon_sym_chan] = ACTIONS(2997),
    [anon_sym_thread] = ACTIONS(2997),
    [anon_sym_atomic] = ACTIONS(2997),
    [anon_sym_assert] = ACTIONS(2997),
    [anon_sym_defer] = ACTIONS(2997),
    [anon_sym_goto] = ACTIONS(2997),
    [anon_sym_break] = ACTIONS(2997),
    [anon_sym_continue] = ACTIONS(2997),
    [anon_sym_return] = ACTIONS(2997),
    [anon_sym_DOLLARfor] = ACTIONS(2997),
    [anon_sym_for] = ACTIONS(2997),
    [anon_sym_POUND] = ACTIONS(2997),
    [anon_sym_asm] = ACTIONS(2997),
    [anon_sym_AT_LBRACK] = ACTIONS(2997),
  },
  [1201] = {
    [sym_line_comment] = STATE(1201),
    [sym_block_comment] = STATE(1201),
    [ts_builtin_sym_end] = ACTIONS(2991),
    [sym_identifier] = ACTIONS(2993),
    [anon_sym_LF] = ACTIONS(2993),
    [anon_sym_CR] = ACTIONS(2993),
    [anon_sym_CR_LF] = ACTIONS(2993),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2993),
    [anon_sym_as] = ACTIONS(2993),
    [anon_sym_LBRACE] = ACTIONS(2993),
    [anon_sym_COMMA] = ACTIONS(2993),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2993),
    [anon_sym___global] = ACTIONS(2993),
    [anon_sym_type] = ACTIONS(2993),
    [anon_sym_fn] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2993),
    [anon_sym_DASH] = ACTIONS(2993),
    [anon_sym_STAR] = ACTIONS(2993),
    [anon_sym_SLASH] = ACTIONS(2993),
    [anon_sym_PERCENT] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(2993),
    [anon_sym_EQ_EQ] = ACTIONS(2993),
    [anon_sym_BANG_EQ] = ACTIONS(2993),
    [anon_sym_LT_EQ] = ACTIONS(2993),
    [anon_sym_GT_EQ] = ACTIONS(2993),
    [anon_sym_LBRACK] = ACTIONS(2991),
    [anon_sym_struct] = ACTIONS(2993),
    [anon_sym_union] = ACTIONS(2993),
    [anon_sym_pub] = ACTIONS(2993),
    [anon_sym_mut] = ACTIONS(2993),
    [anon_sym_enum] = ACTIONS(2993),
    [anon_sym_interface] = ACTIONS(2993),
    [anon_sym_PLUS_PLUS] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2993),
    [anon_sym_QMARK] = ACTIONS(2993),
    [anon_sym_BANG] = ACTIONS(2993),
    [anon_sym_go] = ACTIONS(2993),
    [anon_sym_spawn] = ACTIONS(2993),
    [anon_sym_json_DOTdecode] = ACTIONS(2993),
    [anon_sym_PIPE] = ACTIONS(2993),
    [anon_sym_LBRACK2] = ACTIONS(2993),
    [anon_sym_TILDE] = ACTIONS(2993),
    [anon_sym_CARET] = ACTIONS(2993),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_LT_DASH] = ACTIONS(2993),
    [anon_sym_LT_LT] = ACTIONS(2993),
    [anon_sym_GT_GT] = ACTIONS(2993),
    [anon_sym_GT_GT_GT] = ACTIONS(2993),
    [anon_sym_AMP_CARET] = ACTIONS(2993),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [anon_sym_or] = ACTIONS(2993),
    [sym_none] = ACTIONS(2993),
    [sym_true] = ACTIONS(2993),
    [sym_false] = ACTIONS(2993),
    [sym_nil] = ACTIONS(2993),
    [anon_sym_QMARK_DOT] = ACTIONS(2993),
    [anon_sym_POUND_LBRACK] = ACTIONS(2993),
    [anon_sym_if] = ACTIONS(2993),
    [anon_sym_DOLLARif] = ACTIONS(2993),
    [anon_sym_is] = ACTIONS(2993),
    [anon_sym_BANGis] = ACTIONS(2993),
    [anon_sym_in] = ACTIONS(2993),
    [anon_sym_BANGin] = ACTIONS(2993),
    [anon_sym_match] = ACTIONS(2993),
    [anon_sym_select] = ACTIONS(2993),
    [anon_sym_lock] = ACTIONS(2993),
    [anon_sym_rlock] = ACTIONS(2993),
    [anon_sym_unsafe] = ACTIONS(2993),
    [anon_sym_sql] = ACTIONS(2993),
    [sym_int_literal] = ACTIONS(2993),
    [sym_float_literal] = ACTIONS(2993),
    [sym_rune_literal] = ACTIONS(2993),
    [anon_sym_SQUOTE] = ACTIONS(2993),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [anon_sym_c_SQUOTE] = ACTIONS(2993),
    [anon_sym_c_DQUOTE] = ACTIONS(2993),
    [anon_sym_r_SQUOTE] = ACTIONS(2993),
    [anon_sym_r_DQUOTE] = ACTIONS(2993),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2993),
    [anon_sym_shared] = ACTIONS(2993),
    [anon_sym_map_LBRACK] = ACTIONS(2993),
    [anon_sym_chan] = ACTIONS(2993),
    [anon_sym_thread] = ACTIONS(2993),
    [anon_sym_atomic] = ACTIONS(2993),
    [anon_sym_assert] = ACTIONS(2993),
    [anon_sym_defer] = ACTIONS(2993),
    [anon_sym_goto] = ACTIONS(2993),
    [anon_sym_break] = ACTIONS(2993),
    [anon_sym_continue] = ACTIONS(2993),
    [anon_sym_return] = ACTIONS(2993),
    [anon_sym_DOLLARfor] = ACTIONS(2993),
    [anon_sym_for] = ACTIONS(2993),
    [anon_sym_POUND] = ACTIONS(2993),
    [anon_sym_asm] = ACTIONS(2993),
    [anon_sym_AT_LBRACK] = ACTIONS(2993),
  },
  [1202] = {
    [sym_line_comment] = STATE(1202),
    [sym_block_comment] = STATE(1202),
    [ts_builtin_sym_end] = ACTIONS(2987),
    [sym_identifier] = ACTIONS(2989),
    [anon_sym_LF] = ACTIONS(2989),
    [anon_sym_CR] = ACTIONS(2989),
    [anon_sym_CR_LF] = ACTIONS(2989),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_as] = ACTIONS(2989),
    [anon_sym_LBRACE] = ACTIONS(2989),
    [anon_sym_COMMA] = ACTIONS(2989),
    [anon_sym_const] = ACTIONS(2989),
    [anon_sym_LPAREN] = ACTIONS(2989),
    [anon_sym___global] = ACTIONS(2989),
    [anon_sym_type] = ACTIONS(2989),
    [anon_sym_fn] = ACTIONS(2989),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2989),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2989),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_EQ_EQ] = ACTIONS(2989),
    [anon_sym_BANG_EQ] = ACTIONS(2989),
    [anon_sym_LT_EQ] = ACTIONS(2989),
    [anon_sym_GT_EQ] = ACTIONS(2989),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_struct] = ACTIONS(2989),
    [anon_sym_union] = ACTIONS(2989),
    [anon_sym_pub] = ACTIONS(2989),
    [anon_sym_mut] = ACTIONS(2989),
    [anon_sym_enum] = ACTIONS(2989),
    [anon_sym_interface] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2989),
    [anon_sym_DASH_DASH] = ACTIONS(2989),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_go] = ACTIONS(2989),
    [anon_sym_spawn] = ACTIONS(2989),
    [anon_sym_json_DOTdecode] = ACTIONS(2989),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_LBRACK2] = ACTIONS(2989),
    [anon_sym_TILDE] = ACTIONS(2989),
    [anon_sym_CARET] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_LT_DASH] = ACTIONS(2989),
    [anon_sym_LT_LT] = ACTIONS(2989),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2989),
    [anon_sym_AMP_CARET] = ACTIONS(2989),
    [anon_sym_AMP_AMP] = ACTIONS(2989),
    [anon_sym_PIPE_PIPE] = ACTIONS(2989),
    [anon_sym_or] = ACTIONS(2989),
    [sym_none] = ACTIONS(2989),
    [sym_true] = ACTIONS(2989),
    [sym_false] = ACTIONS(2989),
    [sym_nil] = ACTIONS(2989),
    [anon_sym_QMARK_DOT] = ACTIONS(2989),
    [anon_sym_POUND_LBRACK] = ACTIONS(2989),
    [anon_sym_if] = ACTIONS(2989),
    [anon_sym_DOLLARif] = ACTIONS(2989),
    [anon_sym_is] = ACTIONS(2989),
    [anon_sym_BANGis] = ACTIONS(2989),
    [anon_sym_in] = ACTIONS(2989),
    [anon_sym_BANGin] = ACTIONS(2989),
    [anon_sym_match] = ACTIONS(2989),
    [anon_sym_select] = ACTIONS(2989),
    [anon_sym_lock] = ACTIONS(2989),
    [anon_sym_rlock] = ACTIONS(2989),
    [anon_sym_unsafe] = ACTIONS(2989),
    [anon_sym_sql] = ACTIONS(2989),
    [sym_int_literal] = ACTIONS(2989),
    [sym_float_literal] = ACTIONS(2989),
    [sym_rune_literal] = ACTIONS(2989),
    [anon_sym_SQUOTE] = ACTIONS(2989),
    [anon_sym_DQUOTE] = ACTIONS(2989),
    [anon_sym_c_SQUOTE] = ACTIONS(2989),
    [anon_sym_c_DQUOTE] = ACTIONS(2989),
    [anon_sym_r_SQUOTE] = ACTIONS(2989),
    [anon_sym_r_DQUOTE] = ACTIONS(2989),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2989),
    [anon_sym_shared] = ACTIONS(2989),
    [anon_sym_map_LBRACK] = ACTIONS(2989),
    [anon_sym_chan] = ACTIONS(2989),
    [anon_sym_thread] = ACTIONS(2989),
    [anon_sym_atomic] = ACTIONS(2989),
    [anon_sym_assert] = ACTIONS(2989),
    [anon_sym_defer] = ACTIONS(2989),
    [anon_sym_goto] = ACTIONS(2989),
    [anon_sym_break] = ACTIONS(2989),
    [anon_sym_continue] = ACTIONS(2989),
    [anon_sym_return] = ACTIONS(2989),
    [anon_sym_DOLLARfor] = ACTIONS(2989),
    [anon_sym_for] = ACTIONS(2989),
    [anon_sym_POUND] = ACTIONS(2989),
    [anon_sym_asm] = ACTIONS(2989),
    [anon_sym_AT_LBRACK] = ACTIONS(2989),
  },
  [1203] = {
    [sym_line_comment] = STATE(1203),
    [sym_block_comment] = STATE(1203),
    [ts_builtin_sym_end] = ACTIONS(2441),
    [sym_identifier] = ACTIONS(2443),
    [anon_sym_LF] = ACTIONS(2443),
    [anon_sym_CR] = ACTIONS(2443),
    [anon_sym_CR_LF] = ACTIONS(2443),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2445),
    [anon_sym_as] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(2443),
    [anon_sym_COMMA] = ACTIONS(2443),
    [anon_sym_const] = ACTIONS(2443),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym___global] = ACTIONS(2443),
    [anon_sym_type] = ACTIONS(2443),
    [anon_sym_fn] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2445),
    [anon_sym_STAR] = ACTIONS(2445),
    [anon_sym_SLASH] = ACTIONS(2445),
    [anon_sym_PERCENT] = ACTIONS(2445),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_GT] = ACTIONS(2445),
    [anon_sym_EQ_EQ] = ACTIONS(2445),
    [anon_sym_BANG_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_struct] = ACTIONS(2443),
    [anon_sym_union] = ACTIONS(2443),
    [anon_sym_pub] = ACTIONS(2443),
    [anon_sym_mut] = ACTIONS(2443),
    [anon_sym_enum] = ACTIONS(2443),
    [anon_sym_interface] = ACTIONS(2443),
    [anon_sym_PLUS_PLUS] = ACTIONS(2445),
    [anon_sym_DASH_DASH] = ACTIONS(2445),
    [anon_sym_QMARK] = ACTIONS(2445),
    [anon_sym_BANG] = ACTIONS(2445),
    [anon_sym_go] = ACTIONS(2443),
    [anon_sym_spawn] = ACTIONS(2443),
    [anon_sym_json_DOTdecode] = ACTIONS(2443),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_LBRACK2] = ACTIONS(2445),
    [anon_sym_TILDE] = ACTIONS(2443),
    [anon_sym_CARET] = ACTIONS(2445),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_LT_DASH] = ACTIONS(2443),
    [anon_sym_LT_LT] = ACTIONS(2445),
    [anon_sym_GT_GT] = ACTIONS(2445),
    [anon_sym_GT_GT_GT] = ACTIONS(2445),
    [anon_sym_AMP_CARET] = ACTIONS(2445),
    [anon_sym_AMP_AMP] = ACTIONS(2445),
    [anon_sym_PIPE_PIPE] = ACTIONS(2445),
    [anon_sym_or] = ACTIONS(2445),
    [sym_none] = ACTIONS(2443),
    [sym_true] = ACTIONS(2443),
    [sym_false] = ACTIONS(2443),
    [sym_nil] = ACTIONS(2443),
    [anon_sym_QMARK_DOT] = ACTIONS(2445),
    [anon_sym_POUND_LBRACK] = ACTIONS(2445),
    [anon_sym_if] = ACTIONS(2443),
    [anon_sym_DOLLARif] = ACTIONS(2443),
    [anon_sym_is] = ACTIONS(2445),
    [anon_sym_BANGis] = ACTIONS(2445),
    [anon_sym_in] = ACTIONS(2445),
    [anon_sym_BANGin] = ACTIONS(2445),
    [anon_sym_match] = ACTIONS(2443),
    [anon_sym_select] = ACTIONS(2443),
    [anon_sym_lock] = ACTIONS(2443),
    [anon_sym_rlock] = ACTIONS(2443),
    [anon_sym_unsafe] = ACTIONS(2443),
    [anon_sym_sql] = ACTIONS(2443),
    [sym_int_literal] = ACTIONS(2443),
    [sym_float_literal] = ACTIONS(2443),
    [sym_rune_literal] = ACTIONS(2443),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [anon_sym_DQUOTE] = ACTIONS(2443),
    [anon_sym_c_SQUOTE] = ACTIONS(2443),
    [anon_sym_c_DQUOTE] = ACTIONS(2443),
    [anon_sym_r_SQUOTE] = ACTIONS(2443),
    [anon_sym_r_DQUOTE] = ACTIONS(2443),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2443),
    [anon_sym_shared] = ACTIONS(2443),
    [anon_sym_map_LBRACK] = ACTIONS(2443),
    [anon_sym_chan] = ACTIONS(2443),
    [anon_sym_thread] = ACTIONS(2443),
    [anon_sym_atomic] = ACTIONS(2443),
    [anon_sym_assert] = ACTIONS(2443),
    [anon_sym_defer] = ACTIONS(2443),
    [anon_sym_goto] = ACTIONS(2443),
    [anon_sym_break] = ACTIONS(2443),
    [anon_sym_continue] = ACTIONS(2443),
    [anon_sym_return] = ACTIONS(2443),
    [anon_sym_DOLLARfor] = ACTIONS(2443),
    [anon_sym_for] = ACTIONS(2443),
    [anon_sym_POUND] = ACTIONS(2443),
    [anon_sym_asm] = ACTIONS(2443),
    [anon_sym_AT_LBRACK] = ACTIONS(2443),
  },
  [1204] = {
    [sym_line_comment] = STATE(1204),
    [sym_block_comment] = STATE(1204),
    [ts_builtin_sym_end] = ACTIONS(2923),
    [sym_identifier] = ACTIONS(2925),
    [anon_sym_LF] = ACTIONS(2925),
    [anon_sym_CR] = ACTIONS(2925),
    [anon_sym_CR_LF] = ACTIONS(2925),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2925),
    [anon_sym_as] = ACTIONS(2925),
    [anon_sym_LBRACE] = ACTIONS(2925),
    [anon_sym_COMMA] = ACTIONS(2925),
    [anon_sym_const] = ACTIONS(2925),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym___global] = ACTIONS(2925),
    [anon_sym_type] = ACTIONS(2925),
    [anon_sym_fn] = ACTIONS(2925),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_STAR] = ACTIONS(2925),
    [anon_sym_SLASH] = ACTIONS(2925),
    [anon_sym_PERCENT] = ACTIONS(2925),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_GT] = ACTIONS(2925),
    [anon_sym_EQ_EQ] = ACTIONS(2925),
    [anon_sym_BANG_EQ] = ACTIONS(2925),
    [anon_sym_LT_EQ] = ACTIONS(2925),
    [anon_sym_GT_EQ] = ACTIONS(2925),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_struct] = ACTIONS(2925),
    [anon_sym_union] = ACTIONS(2925),
    [anon_sym_pub] = ACTIONS(2925),
    [anon_sym_mut] = ACTIONS(2925),
    [anon_sym_enum] = ACTIONS(2925),
    [anon_sym_interface] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2925),
    [anon_sym_DASH_DASH] = ACTIONS(2925),
    [anon_sym_QMARK] = ACTIONS(2925),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_go] = ACTIONS(2925),
    [anon_sym_spawn] = ACTIONS(2925),
    [anon_sym_json_DOTdecode] = ACTIONS(2925),
    [anon_sym_PIPE] = ACTIONS(2925),
    [anon_sym_LBRACK2] = ACTIONS(2925),
    [anon_sym_TILDE] = ACTIONS(2925),
    [anon_sym_CARET] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym_LT_DASH] = ACTIONS(2925),
    [anon_sym_LT_LT] = ACTIONS(2925),
    [anon_sym_GT_GT] = ACTIONS(2925),
    [anon_sym_GT_GT_GT] = ACTIONS(2925),
    [anon_sym_AMP_CARET] = ACTIONS(2925),
    [anon_sym_AMP_AMP] = ACTIONS(2925),
    [anon_sym_PIPE_PIPE] = ACTIONS(2925),
    [anon_sym_or] = ACTIONS(2925),
    [sym_none] = ACTIONS(2925),
    [sym_true] = ACTIONS(2925),
    [sym_false] = ACTIONS(2925),
    [sym_nil] = ACTIONS(2925),
    [anon_sym_QMARK_DOT] = ACTIONS(2925),
    [anon_sym_POUND_LBRACK] = ACTIONS(2925),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_DOLLARif] = ACTIONS(2925),
    [anon_sym_is] = ACTIONS(2925),
    [anon_sym_BANGis] = ACTIONS(2925),
    [anon_sym_in] = ACTIONS(2925),
    [anon_sym_BANGin] = ACTIONS(2925),
    [anon_sym_match] = ACTIONS(2925),
    [anon_sym_select] = ACTIONS(2925),
    [anon_sym_lock] = ACTIONS(2925),
    [anon_sym_rlock] = ACTIONS(2925),
    [anon_sym_unsafe] = ACTIONS(2925),
    [anon_sym_sql] = ACTIONS(2925),
    [sym_int_literal] = ACTIONS(2925),
    [sym_float_literal] = ACTIONS(2925),
    [sym_rune_literal] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2925),
    [anon_sym_DQUOTE] = ACTIONS(2925),
    [anon_sym_c_SQUOTE] = ACTIONS(2925),
    [anon_sym_c_DQUOTE] = ACTIONS(2925),
    [anon_sym_r_SQUOTE] = ACTIONS(2925),
    [anon_sym_r_DQUOTE] = ACTIONS(2925),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2925),
    [anon_sym_shared] = ACTIONS(2925),
    [anon_sym_map_LBRACK] = ACTIONS(2925),
    [anon_sym_chan] = ACTIONS(2925),
    [anon_sym_thread] = ACTIONS(2925),
    [anon_sym_atomic] = ACTIONS(2925),
    [anon_sym_assert] = ACTIONS(2925),
    [anon_sym_defer] = ACTIONS(2925),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2925),
    [anon_sym_continue] = ACTIONS(2925),
    [anon_sym_return] = ACTIONS(2925),
    [anon_sym_DOLLARfor] = ACTIONS(2925),
    [anon_sym_for] = ACTIONS(2925),
    [anon_sym_POUND] = ACTIONS(2925),
    [anon_sym_asm] = ACTIONS(2925),
    [anon_sym_AT_LBRACK] = ACTIONS(2925),
  },
  [1205] = {
    [sym_line_comment] = STATE(1205),
    [sym_block_comment] = STATE(1205),
    [ts_builtin_sym_end] = ACTIONS(2919),
    [sym_identifier] = ACTIONS(2921),
    [anon_sym_LF] = ACTIONS(2921),
    [anon_sym_CR] = ACTIONS(2921),
    [anon_sym_CR_LF] = ACTIONS(2921),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_as] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_COMMA] = ACTIONS(2921),
    [anon_sym_const] = ACTIONS(2921),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym___global] = ACTIONS(2921),
    [anon_sym_type] = ACTIONS(2921),
    [anon_sym_fn] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2921),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2921),
    [anon_sym_LT] = ACTIONS(2921),
    [anon_sym_GT] = ACTIONS(2921),
    [anon_sym_EQ_EQ] = ACTIONS(2921),
    [anon_sym_BANG_EQ] = ACTIONS(2921),
    [anon_sym_LT_EQ] = ACTIONS(2921),
    [anon_sym_GT_EQ] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2919),
    [anon_sym_struct] = ACTIONS(2921),
    [anon_sym_union] = ACTIONS(2921),
    [anon_sym_pub] = ACTIONS(2921),
    [anon_sym_mut] = ACTIONS(2921),
    [anon_sym_enum] = ACTIONS(2921),
    [anon_sym_interface] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2921),
    [anon_sym_DASH_DASH] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_go] = ACTIONS(2921),
    [anon_sym_spawn] = ACTIONS(2921),
    [anon_sym_json_DOTdecode] = ACTIONS(2921),
    [anon_sym_PIPE] = ACTIONS(2921),
    [anon_sym_LBRACK2] = ACTIONS(2921),
    [anon_sym_TILDE] = ACTIONS(2921),
    [anon_sym_CARET] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2921),
    [anon_sym_LT_DASH] = ACTIONS(2921),
    [anon_sym_LT_LT] = ACTIONS(2921),
    [anon_sym_GT_GT] = ACTIONS(2921),
    [anon_sym_GT_GT_GT] = ACTIONS(2921),
    [anon_sym_AMP_CARET] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE] = ACTIONS(2921),
    [anon_sym_or] = ACTIONS(2921),
    [sym_none] = ACTIONS(2921),
    [sym_true] = ACTIONS(2921),
    [sym_false] = ACTIONS(2921),
    [sym_nil] = ACTIONS(2921),
    [anon_sym_QMARK_DOT] = ACTIONS(2921),
    [anon_sym_POUND_LBRACK] = ACTIONS(2921),
    [anon_sym_if] = ACTIONS(2921),
    [anon_sym_DOLLARif] = ACTIONS(2921),
    [anon_sym_is] = ACTIONS(2921),
    [anon_sym_BANGis] = ACTIONS(2921),
    [anon_sym_in] = ACTIONS(2921),
    [anon_sym_BANGin] = ACTIONS(2921),
    [anon_sym_match] = ACTIONS(2921),
    [anon_sym_select] = ACTIONS(2921),
    [anon_sym_lock] = ACTIONS(2921),
    [anon_sym_rlock] = ACTIONS(2921),
    [anon_sym_unsafe] = ACTIONS(2921),
    [anon_sym_sql] = ACTIONS(2921),
    [sym_int_literal] = ACTIONS(2921),
    [sym_float_literal] = ACTIONS(2921),
    [sym_rune_literal] = ACTIONS(2921),
    [anon_sym_SQUOTE] = ACTIONS(2921),
    [anon_sym_DQUOTE] = ACTIONS(2921),
    [anon_sym_c_SQUOTE] = ACTIONS(2921),
    [anon_sym_c_DQUOTE] = ACTIONS(2921),
    [anon_sym_r_SQUOTE] = ACTIONS(2921),
    [anon_sym_r_DQUOTE] = ACTIONS(2921),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2921),
    [anon_sym_shared] = ACTIONS(2921),
    [anon_sym_map_LBRACK] = ACTIONS(2921),
    [anon_sym_chan] = ACTIONS(2921),
    [anon_sym_thread] = ACTIONS(2921),
    [anon_sym_atomic] = ACTIONS(2921),
    [anon_sym_assert] = ACTIONS(2921),
    [anon_sym_defer] = ACTIONS(2921),
    [anon_sym_goto] = ACTIONS(2921),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2921),
    [anon_sym_return] = ACTIONS(2921),
    [anon_sym_DOLLARfor] = ACTIONS(2921),
    [anon_sym_for] = ACTIONS(2921),
    [anon_sym_POUND] = ACTIONS(2921),
    [anon_sym_asm] = ACTIONS(2921),
    [anon_sym_AT_LBRACK] = ACTIONS(2921),
  },
  [1206] = {
    [sym_line_comment] = STATE(1206),
    [sym_block_comment] = STATE(1206),
    [ts_builtin_sym_end] = ACTIONS(2915),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_LF] = ACTIONS(2917),
    [anon_sym_CR] = ACTIONS(2917),
    [anon_sym_CR_LF] = ACTIONS(2917),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2917),
    [anon_sym_as] = ACTIONS(2917),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_COMMA] = ACTIONS(2917),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_LPAREN] = ACTIONS(2917),
    [anon_sym___global] = ACTIONS(2917),
    [anon_sym_type] = ACTIONS(2917),
    [anon_sym_fn] = ACTIONS(2917),
    [anon_sym_PLUS] = ACTIONS(2917),
    [anon_sym_DASH] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2917),
    [anon_sym_SLASH] = ACTIONS(2917),
    [anon_sym_PERCENT] = ACTIONS(2917),
    [anon_sym_LT] = ACTIONS(2917),
    [anon_sym_GT] = ACTIONS(2917),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2917),
    [anon_sym_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT_EQ] = ACTIONS(2917),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2917),
    [anon_sym_union] = ACTIONS(2917),
    [anon_sym_pub] = ACTIONS(2917),
    [anon_sym_mut] = ACTIONS(2917),
    [anon_sym_enum] = ACTIONS(2917),
    [anon_sym_interface] = ACTIONS(2917),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_QMARK] = ACTIONS(2917),
    [anon_sym_BANG] = ACTIONS(2917),
    [anon_sym_go] = ACTIONS(2917),
    [anon_sym_spawn] = ACTIONS(2917),
    [anon_sym_json_DOTdecode] = ACTIONS(2917),
    [anon_sym_PIPE] = ACTIONS(2917),
    [anon_sym_LBRACK2] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_CARET] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2917),
    [anon_sym_LT_DASH] = ACTIONS(2917),
    [anon_sym_LT_LT] = ACTIONS(2917),
    [anon_sym_GT_GT] = ACTIONS(2917),
    [anon_sym_GT_GT_GT] = ACTIONS(2917),
    [anon_sym_AMP_CARET] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_PIPE_PIPE] = ACTIONS(2917),
    [anon_sym_or] = ACTIONS(2917),
    [sym_none] = ACTIONS(2917),
    [sym_true] = ACTIONS(2917),
    [sym_false] = ACTIONS(2917),
    [sym_nil] = ACTIONS(2917),
    [anon_sym_QMARK_DOT] = ACTIONS(2917),
    [anon_sym_POUND_LBRACK] = ACTIONS(2917),
    [anon_sym_if] = ACTIONS(2917),
    [anon_sym_DOLLARif] = ACTIONS(2917),
    [anon_sym_is] = ACTIONS(2917),
    [anon_sym_BANGis] = ACTIONS(2917),
    [anon_sym_in] = ACTIONS(2917),
    [anon_sym_BANGin] = ACTIONS(2917),
    [anon_sym_match] = ACTIONS(2917),
    [anon_sym_select] = ACTIONS(2917),
    [anon_sym_lock] = ACTIONS(2917),
    [anon_sym_rlock] = ACTIONS(2917),
    [anon_sym_unsafe] = ACTIONS(2917),
    [anon_sym_sql] = ACTIONS(2917),
    [sym_int_literal] = ACTIONS(2917),
    [sym_float_literal] = ACTIONS(2917),
    [sym_rune_literal] = ACTIONS(2917),
    [anon_sym_SQUOTE] = ACTIONS(2917),
    [anon_sym_DQUOTE] = ACTIONS(2917),
    [anon_sym_c_SQUOTE] = ACTIONS(2917),
    [anon_sym_c_DQUOTE] = ACTIONS(2917),
    [anon_sym_r_SQUOTE] = ACTIONS(2917),
    [anon_sym_r_DQUOTE] = ACTIONS(2917),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2917),
    [anon_sym_shared] = ACTIONS(2917),
    [anon_sym_map_LBRACK] = ACTIONS(2917),
    [anon_sym_chan] = ACTIONS(2917),
    [anon_sym_thread] = ACTIONS(2917),
    [anon_sym_atomic] = ACTIONS(2917),
    [anon_sym_assert] = ACTIONS(2917),
    [anon_sym_defer] = ACTIONS(2917),
    [anon_sym_goto] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2917),
    [anon_sym_continue] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2917),
    [anon_sym_DOLLARfor] = ACTIONS(2917),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_POUND] = ACTIONS(2917),
    [anon_sym_asm] = ACTIONS(2917),
    [anon_sym_AT_LBRACK] = ACTIONS(2917),
  },
  [1207] = {
    [sym_line_comment] = STATE(1207),
    [sym_block_comment] = STATE(1207),
    [ts_builtin_sym_end] = ACTIONS(2145),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_CR] = ACTIONS(2147),
    [anon_sym_CR_LF] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_COMMA] = ACTIONS(2147),
    [anon_sym_const] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym___global] = ACTIONS(2147),
    [anon_sym_type] = ACTIONS(2147),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2147),
    [anon_sym_BANG_EQ] = ACTIONS(2147),
    [anon_sym_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2147),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_union] = ACTIONS(2147),
    [anon_sym_pub] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_enum] = ACTIONS(2147),
    [anon_sym_interface] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2147),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2147),
    [anon_sym_AMP_CARET] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [anon_sym_or] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2147),
    [anon_sym_POUND_LBRACK] = ACTIONS(2147),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2147),
    [anon_sym_BANGis] = ACTIONS(2147),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANGin] = ACTIONS(2147),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2147),
    [sym_rune_literal] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_c_SQUOTE] = ACTIONS(2147),
    [anon_sym_c_DQUOTE] = ACTIONS(2147),
    [anon_sym_r_SQUOTE] = ACTIONS(2147),
    [anon_sym_r_DQUOTE] = ACTIONS(2147),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2147),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
    [anon_sym_assert] = ACTIONS(2147),
    [anon_sym_defer] = ACTIONS(2147),
    [anon_sym_goto] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_continue] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2147),
    [anon_sym_DOLLARfor] = ACTIONS(2147),
    [anon_sym_for] = ACTIONS(2147),
    [anon_sym_POUND] = ACTIONS(2147),
    [anon_sym_asm] = ACTIONS(2147),
    [anon_sym_AT_LBRACK] = ACTIONS(2147),
  },
  [1208] = {
    [sym_line_comment] = STATE(1208),
    [sym_block_comment] = STATE(1208),
    [ts_builtin_sym_end] = ACTIONS(2883),
    [sym_identifier] = ACTIONS(2885),
    [anon_sym_LF] = ACTIONS(2885),
    [anon_sym_CR] = ACTIONS(2885),
    [anon_sym_CR_LF] = ACTIONS(2885),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2885),
    [anon_sym_as] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2885),
    [anon_sym___global] = ACTIONS(2885),
    [anon_sym_type] = ACTIONS(2885),
    [anon_sym_fn] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2885),
    [anon_sym_SLASH] = ACTIONS(2885),
    [anon_sym_PERCENT] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_GT] = ACTIONS(2885),
    [anon_sym_EQ_EQ] = ACTIONS(2885),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2885),
    [anon_sym_GT_EQ] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_union] = ACTIONS(2885),
    [anon_sym_pub] = ACTIONS(2885),
    [anon_sym_mut] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [anon_sym_interface] = ACTIONS(2885),
    [anon_sym_PLUS_PLUS] = ACTIONS(2885),
    [anon_sym_DASH_DASH] = ACTIONS(2885),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_BANG] = ACTIONS(2885),
    [anon_sym_go] = ACTIONS(2885),
    [anon_sym_spawn] = ACTIONS(2885),
    [anon_sym_json_DOTdecode] = ACTIONS(2885),
    [anon_sym_PIPE] = ACTIONS(2885),
    [anon_sym_LBRACK2] = ACTIONS(2885),
    [anon_sym_TILDE] = ACTIONS(2885),
    [anon_sym_CARET] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_LT_DASH] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2885),
    [anon_sym_GT_GT] = ACTIONS(2885),
    [anon_sym_GT_GT_GT] = ACTIONS(2885),
    [anon_sym_AMP_CARET] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_or] = ACTIONS(2885),
    [sym_none] = ACTIONS(2885),
    [sym_true] = ACTIONS(2885),
    [sym_false] = ACTIONS(2885),
    [sym_nil] = ACTIONS(2885),
    [anon_sym_QMARK_DOT] = ACTIONS(2885),
    [anon_sym_POUND_LBRACK] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_DOLLARif] = ACTIONS(2885),
    [anon_sym_is] = ACTIONS(2885),
    [anon_sym_BANGis] = ACTIONS(2885),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_BANGin] = ACTIONS(2885),
    [anon_sym_match] = ACTIONS(2885),
    [anon_sym_select] = ACTIONS(2885),
    [anon_sym_lock] = ACTIONS(2885),
    [anon_sym_rlock] = ACTIONS(2885),
    [anon_sym_unsafe] = ACTIONS(2885),
    [anon_sym_sql] = ACTIONS(2885),
    [sym_int_literal] = ACTIONS(2885),
    [sym_float_literal] = ACTIONS(2885),
    [sym_rune_literal] = ACTIONS(2885),
    [anon_sym_SQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE] = ACTIONS(2885),
    [anon_sym_c_SQUOTE] = ACTIONS(2885),
    [anon_sym_c_DQUOTE] = ACTIONS(2885),
    [anon_sym_r_SQUOTE] = ACTIONS(2885),
    [anon_sym_r_DQUOTE] = ACTIONS(2885),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2885),
    [anon_sym_shared] = ACTIONS(2885),
    [anon_sym_map_LBRACK] = ACTIONS(2885),
    [anon_sym_chan] = ACTIONS(2885),
    [anon_sym_thread] = ACTIONS(2885),
    [anon_sym_atomic] = ACTIONS(2885),
    [anon_sym_assert] = ACTIONS(2885),
    [anon_sym_defer] = ACTIONS(2885),
    [anon_sym_goto] = ACTIONS(2885),
    [anon_sym_break] = ACTIONS(2885),
    [anon_sym_continue] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_DOLLARfor] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_POUND] = ACTIONS(2885),
    [anon_sym_asm] = ACTIONS(2885),
    [anon_sym_AT_LBRACK] = ACTIONS(2885),
  },
  [1209] = {
    [sym_line_comment] = STATE(1209),
    [sym_block_comment] = STATE(1209),
    [ts_builtin_sym_end] = ACTIONS(2371),
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2373),
    [anon_sym_CR] = ACTIONS(2373),
    [anon_sym_CR_LF] = ACTIONS(2373),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2177),
    [anon_sym_as] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2373),
    [anon_sym_COMMA] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym___global] = ACTIONS(2373),
    [anon_sym_type] = ACTIONS(2373),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_SLASH] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2373),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_pub] = ACTIONS(2373),
    [anon_sym_mut] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2373),
    [anon_sym_QMARK] = ACTIONS(2373),
    [anon_sym_BANG] = ACTIONS(2373),
    [anon_sym_go] = ACTIONS(2373),
    [anon_sym_spawn] = ACTIONS(2373),
    [anon_sym_json_DOTdecode] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_LBRACK2] = ACTIONS(2373),
    [anon_sym_TILDE] = ACTIONS(2373),
    [anon_sym_CARET] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_LT_DASH] = ACTIONS(2373),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2373),
    [anon_sym_AMP_CARET] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2373),
    [anon_sym_or] = ACTIONS(2373),
    [sym_none] = ACTIONS(2373),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [sym_nil] = ACTIONS(2373),
    [anon_sym_QMARK_DOT] = ACTIONS(2373),
    [anon_sym_POUND_LBRACK] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_DOLLARif] = ACTIONS(2373),
    [anon_sym_is] = ACTIONS(2373),
    [anon_sym_BANGis] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_BANGin] = ACTIONS(2373),
    [anon_sym_match] = ACTIONS(2373),
    [anon_sym_select] = ACTIONS(2373),
    [anon_sym_lock] = ACTIONS(2373),
    [anon_sym_rlock] = ACTIONS(2373),
    [anon_sym_unsafe] = ACTIONS(2373),
    [anon_sym_sql] = ACTIONS(2373),
    [sym_int_literal] = ACTIONS(2373),
    [sym_float_literal] = ACTIONS(2373),
    [sym_rune_literal] = ACTIONS(2373),
    [anon_sym_SQUOTE] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(2373),
    [anon_sym_c_SQUOTE] = ACTIONS(2373),
    [anon_sym_c_DQUOTE] = ACTIONS(2373),
    [anon_sym_r_SQUOTE] = ACTIONS(2373),
    [anon_sym_r_DQUOTE] = ACTIONS(2373),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_map_LBRACK] = ACTIONS(2373),
    [anon_sym_chan] = ACTIONS(2373),
    [anon_sym_thread] = ACTIONS(2373),
    [anon_sym_atomic] = ACTIONS(2373),
    [anon_sym_assert] = ACTIONS(2373),
    [anon_sym_defer] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_DOLLARfor] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_POUND] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym_AT_LBRACK] = ACTIONS(2373),
  },
  [1210] = {
    [sym_line_comment] = STATE(1210),
    [sym_block_comment] = STATE(1210),
    [ts_builtin_sym_end] = ACTIONS(2399),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_LF] = ACTIONS(2401),
    [anon_sym_CR] = ACTIONS(2401),
    [anon_sym_CR_LF] = ACTIONS(2401),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2401),
    [anon_sym_as] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(2401),
    [anon_sym_COMMA] = ACTIONS(2401),
    [anon_sym_const] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2401),
    [anon_sym___global] = ACTIONS(2401),
    [anon_sym_type] = ACTIONS(2401),
    [anon_sym_fn] = ACTIONS(2401),
    [anon_sym_PLUS] = ACTIONS(2401),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_STAR] = ACTIONS(2401),
    [anon_sym_SLASH] = ACTIONS(2401),
    [anon_sym_PERCENT] = ACTIONS(2401),
    [anon_sym_LT] = ACTIONS(2401),
    [anon_sym_GT] = ACTIONS(2401),
    [anon_sym_EQ_EQ] = ACTIONS(2401),
    [anon_sym_BANG_EQ] = ACTIONS(2401),
    [anon_sym_LT_EQ] = ACTIONS(2401),
    [anon_sym_GT_EQ] = ACTIONS(2401),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_struct] = ACTIONS(2401),
    [anon_sym_union] = ACTIONS(2401),
    [anon_sym_pub] = ACTIONS(2401),
    [anon_sym_mut] = ACTIONS(2401),
    [anon_sym_enum] = ACTIONS(2401),
    [anon_sym_interface] = ACTIONS(2401),
    [anon_sym_PLUS_PLUS] = ACTIONS(2401),
    [anon_sym_DASH_DASH] = ACTIONS(2401),
    [anon_sym_QMARK] = ACTIONS(2401),
    [anon_sym_BANG] = ACTIONS(2401),
    [anon_sym_go] = ACTIONS(2401),
    [anon_sym_spawn] = ACTIONS(2401),
    [anon_sym_json_DOTdecode] = ACTIONS(2401),
    [anon_sym_PIPE] = ACTIONS(2401),
    [anon_sym_LBRACK2] = ACTIONS(2401),
    [anon_sym_TILDE] = ACTIONS(2401),
    [anon_sym_CARET] = ACTIONS(2401),
    [anon_sym_AMP] = ACTIONS(2401),
    [anon_sym_LT_DASH] = ACTIONS(2401),
    [anon_sym_LT_LT] = ACTIONS(2401),
    [anon_sym_GT_GT] = ACTIONS(2401),
    [anon_sym_GT_GT_GT] = ACTIONS(2401),
    [anon_sym_AMP_CARET] = ACTIONS(2401),
    [anon_sym_AMP_AMP] = ACTIONS(2401),
    [anon_sym_PIPE_PIPE] = ACTIONS(2401),
    [anon_sym_or] = ACTIONS(2401),
    [sym_none] = ACTIONS(2401),
    [sym_true] = ACTIONS(2401),
    [sym_false] = ACTIONS(2401),
    [sym_nil] = ACTIONS(2401),
    [anon_sym_QMARK_DOT] = ACTIONS(2401),
    [anon_sym_POUND_LBRACK] = ACTIONS(2401),
    [anon_sym_if] = ACTIONS(2401),
    [anon_sym_DOLLARif] = ACTIONS(2401),
    [anon_sym_is] = ACTIONS(2401),
    [anon_sym_BANGis] = ACTIONS(2401),
    [anon_sym_in] = ACTIONS(2401),
    [anon_sym_BANGin] = ACTIONS(2401),
    [anon_sym_match] = ACTIONS(2401),
    [anon_sym_select] = ACTIONS(2401),
    [anon_sym_lock] = ACTIONS(2401),
    [anon_sym_rlock] = ACTIONS(2401),
    [anon_sym_unsafe] = ACTIONS(2401),
    [anon_sym_sql] = ACTIONS(2401),
    [sym_int_literal] = ACTIONS(2401),
    [sym_float_literal] = ACTIONS(2401),
    [sym_rune_literal] = ACTIONS(2401),
    [anon_sym_SQUOTE] = ACTIONS(2401),
    [anon_sym_DQUOTE] = ACTIONS(2401),
    [anon_sym_c_SQUOTE] = ACTIONS(2401),
    [anon_sym_c_DQUOTE] = ACTIONS(2401),
    [anon_sym_r_SQUOTE] = ACTIONS(2401),
    [anon_sym_r_DQUOTE] = ACTIONS(2401),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2401),
    [anon_sym_shared] = ACTIONS(2401),
    [anon_sym_map_LBRACK] = ACTIONS(2401),
    [anon_sym_chan] = ACTIONS(2401),
    [anon_sym_thread] = ACTIONS(2401),
    [anon_sym_atomic] = ACTIONS(2401),
    [anon_sym_assert] = ACTIONS(2401),
    [anon_sym_defer] = ACTIONS(2401),
    [anon_sym_goto] = ACTIONS(2401),
    [anon_sym_break] = ACTIONS(2401),
    [anon_sym_continue] = ACTIONS(2401),
    [anon_sym_return] = ACTIONS(2401),
    [anon_sym_DOLLARfor] = ACTIONS(2401),
    [anon_sym_for] = ACTIONS(2401),
    [anon_sym_POUND] = ACTIONS(2401),
    [anon_sym_asm] = ACTIONS(2401),
    [anon_sym_AT_LBRACK] = ACTIONS(2401),
  },
  [1211] = {
    [sym_line_comment] = STATE(1211),
    [sym_block_comment] = STATE(1211),
    [ts_builtin_sym_end] = ACTIONS(2871),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_CR] = ACTIONS(2873),
    [anon_sym_CR_LF] = ACTIONS(2873),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2873),
    [anon_sym_as] = ACTIONS(2873),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2873),
    [anon_sym_const] = ACTIONS(2873),
    [anon_sym_LPAREN] = ACTIONS(2873),
    [anon_sym___global] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_fn] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2873),
    [anon_sym_STAR] = ACTIONS(2873),
    [anon_sym_SLASH] = ACTIONS(2873),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2873),
    [anon_sym_GT] = ACTIONS(2873),
    [anon_sym_EQ_EQ] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_LT_EQ] = ACTIONS(2873),
    [anon_sym_GT_EQ] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2873),
    [anon_sym_union] = ACTIONS(2873),
    [anon_sym_pub] = ACTIONS(2873),
    [anon_sym_mut] = ACTIONS(2873),
    [anon_sym_enum] = ACTIONS(2873),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_PLUS_PLUS] = ACTIONS(2873),
    [anon_sym_DASH_DASH] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_BANG] = ACTIONS(2873),
    [anon_sym_go] = ACTIONS(2873),
    [anon_sym_spawn] = ACTIONS(2873),
    [anon_sym_json_DOTdecode] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2873),
    [anon_sym_LBRACK2] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2873),
    [anon_sym_CARET] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LT_DASH] = ACTIONS(2873),
    [anon_sym_LT_LT] = ACTIONS(2873),
    [anon_sym_GT_GT] = ACTIONS(2873),
    [anon_sym_GT_GT_GT] = ACTIONS(2873),
    [anon_sym_AMP_CARET] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [sym_none] = ACTIONS(2873),
    [sym_true] = ACTIONS(2873),
    [sym_false] = ACTIONS(2873),
    [sym_nil] = ACTIONS(2873),
    [anon_sym_QMARK_DOT] = ACTIONS(2873),
    [anon_sym_POUND_LBRACK] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_DOLLARif] = ACTIONS(2873),
    [anon_sym_is] = ACTIONS(2873),
    [anon_sym_BANGis] = ACTIONS(2873),
    [anon_sym_in] = ACTIONS(2873),
    [anon_sym_BANGin] = ACTIONS(2873),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_select] = ACTIONS(2873),
    [anon_sym_lock] = ACTIONS(2873),
    [anon_sym_rlock] = ACTIONS(2873),
    [anon_sym_unsafe] = ACTIONS(2873),
    [anon_sym_sql] = ACTIONS(2873),
    [sym_int_literal] = ACTIONS(2873),
    [sym_float_literal] = ACTIONS(2873),
    [sym_rune_literal] = ACTIONS(2873),
    [anon_sym_SQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_c_SQUOTE] = ACTIONS(2873),
    [anon_sym_c_DQUOTE] = ACTIONS(2873),
    [anon_sym_r_SQUOTE] = ACTIONS(2873),
    [anon_sym_r_DQUOTE] = ACTIONS(2873),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2873),
    [anon_sym_shared] = ACTIONS(2873),
    [anon_sym_map_LBRACK] = ACTIONS(2873),
    [anon_sym_chan] = ACTIONS(2873),
    [anon_sym_thread] = ACTIONS(2873),
    [anon_sym_atomic] = ACTIONS(2873),
    [anon_sym_assert] = ACTIONS(2873),
    [anon_sym_defer] = ACTIONS(2873),
    [anon_sym_goto] = ACTIONS(2873),
    [anon_sym_break] = ACTIONS(2873),
    [anon_sym_continue] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_DOLLARfor] = ACTIONS(2873),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_POUND] = ACTIONS(2873),
    [anon_sym_asm] = ACTIONS(2873),
    [anon_sym_AT_LBRACK] = ACTIONS(2873),
  },
  [1212] = {
    [sym_line_comment] = STATE(1212),
    [sym_block_comment] = STATE(1212),
    [ts_builtin_sym_end] = ACTIONS(2999),
    [sym_identifier] = ACTIONS(3001),
    [anon_sym_LF] = ACTIONS(3001),
    [anon_sym_CR] = ACTIONS(3001),
    [anon_sym_CR_LF] = ACTIONS(3001),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3001),
    [anon_sym_as] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_COMMA] = ACTIONS(3001),
    [anon_sym_const] = ACTIONS(3001),
    [anon_sym_LPAREN] = ACTIONS(3001),
    [anon_sym___global] = ACTIONS(3001),
    [anon_sym_type] = ACTIONS(3001),
    [anon_sym_fn] = ACTIONS(3001),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_STAR] = ACTIONS(3001),
    [anon_sym_SLASH] = ACTIONS(3001),
    [anon_sym_PERCENT] = ACTIONS(3001),
    [anon_sym_LT] = ACTIONS(3001),
    [anon_sym_GT] = ACTIONS(3001),
    [anon_sym_EQ_EQ] = ACTIONS(3001),
    [anon_sym_BANG_EQ] = ACTIONS(3001),
    [anon_sym_LT_EQ] = ACTIONS(3001),
    [anon_sym_GT_EQ] = ACTIONS(3001),
    [anon_sym_LBRACK] = ACTIONS(2999),
    [anon_sym_struct] = ACTIONS(3001),
    [anon_sym_union] = ACTIONS(3001),
    [anon_sym_pub] = ACTIONS(3001),
    [anon_sym_mut] = ACTIONS(3001),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_interface] = ACTIONS(3001),
    [anon_sym_PLUS_PLUS] = ACTIONS(3001),
    [anon_sym_DASH_DASH] = ACTIONS(3001),
    [anon_sym_QMARK] = ACTIONS(3001),
    [anon_sym_BANG] = ACTIONS(3001),
    [anon_sym_go] = ACTIONS(3001),
    [anon_sym_spawn] = ACTIONS(3001),
    [anon_sym_json_DOTdecode] = ACTIONS(3001),
    [anon_sym_PIPE] = ACTIONS(3001),
    [anon_sym_LBRACK2] = ACTIONS(3001),
    [anon_sym_TILDE] = ACTIONS(3001),
    [anon_sym_CARET] = ACTIONS(3001),
    [anon_sym_AMP] = ACTIONS(3001),
    [anon_sym_LT_DASH] = ACTIONS(3001),
    [anon_sym_LT_LT] = ACTIONS(3001),
    [anon_sym_GT_GT] = ACTIONS(3001),
    [anon_sym_GT_GT_GT] = ACTIONS(3001),
    [anon_sym_AMP_CARET] = ACTIONS(3001),
    [anon_sym_AMP_AMP] = ACTIONS(3001),
    [anon_sym_PIPE_PIPE] = ACTIONS(3001),
    [anon_sym_or] = ACTIONS(3001),
    [sym_none] = ACTIONS(3001),
    [sym_true] = ACTIONS(3001),
    [sym_false] = ACTIONS(3001),
    [sym_nil] = ACTIONS(3001),
    [anon_sym_QMARK_DOT] = ACTIONS(3001),
    [anon_sym_POUND_LBRACK] = ACTIONS(3001),
    [anon_sym_if] = ACTIONS(3001),
    [anon_sym_DOLLARif] = ACTIONS(3001),
    [anon_sym_is] = ACTIONS(3001),
    [anon_sym_BANGis] = ACTIONS(3001),
    [anon_sym_in] = ACTIONS(3001),
    [anon_sym_BANGin] = ACTIONS(3001),
    [anon_sym_match] = ACTIONS(3001),
    [anon_sym_select] = ACTIONS(3001),
    [anon_sym_lock] = ACTIONS(3001),
    [anon_sym_rlock] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(3001),
    [anon_sym_sql] = ACTIONS(3001),
    [sym_int_literal] = ACTIONS(3001),
    [sym_float_literal] = ACTIONS(3001),
    [sym_rune_literal] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3001),
    [anon_sym_DQUOTE] = ACTIONS(3001),
    [anon_sym_c_SQUOTE] = ACTIONS(3001),
    [anon_sym_c_DQUOTE] = ACTIONS(3001),
    [anon_sym_r_SQUOTE] = ACTIONS(3001),
    [anon_sym_r_DQUOTE] = ACTIONS(3001),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3001),
    [anon_sym_shared] = ACTIONS(3001),
    [anon_sym_map_LBRACK] = ACTIONS(3001),
    [anon_sym_chan] = ACTIONS(3001),
    [anon_sym_thread] = ACTIONS(3001),
    [anon_sym_atomic] = ACTIONS(3001),
    [anon_sym_assert] = ACTIONS(3001),
    [anon_sym_defer] = ACTIONS(3001),
    [anon_sym_goto] = ACTIONS(3001),
    [anon_sym_break] = ACTIONS(3001),
    [anon_sym_continue] = ACTIONS(3001),
    [anon_sym_return] = ACTIONS(3001),
    [anon_sym_DOLLARfor] = ACTIONS(3001),
    [anon_sym_for] = ACTIONS(3001),
    [anon_sym_POUND] = ACTIONS(3001),
    [anon_sym_asm] = ACTIONS(3001),
    [anon_sym_AT_LBRACK] = ACTIONS(3001),
  },
  [1213] = {
    [sym_line_comment] = STATE(1213),
    [sym_block_comment] = STATE(1213),
    [ts_builtin_sym_end] = ACTIONS(2695),
    [sym_identifier] = ACTIONS(2697),
    [anon_sym_LF] = ACTIONS(2697),
    [anon_sym_CR] = ACTIONS(2697),
    [anon_sym_CR_LF] = ACTIONS(2697),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2697),
    [anon_sym_as] = ACTIONS(2697),
    [anon_sym_LBRACE] = ACTIONS(2697),
    [anon_sym_COMMA] = ACTIONS(2697),
    [anon_sym_const] = ACTIONS(2697),
    [anon_sym_LPAREN] = ACTIONS(2697),
    [anon_sym___global] = ACTIONS(2697),
    [anon_sym_type] = ACTIONS(2697),
    [anon_sym_fn] = ACTIONS(2697),
    [anon_sym_PLUS] = ACTIONS(2697),
    [anon_sym_DASH] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2697),
    [anon_sym_SLASH] = ACTIONS(2697),
    [anon_sym_PERCENT] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2697),
    [anon_sym_GT] = ACTIONS(2697),
    [anon_sym_EQ_EQ] = ACTIONS(2697),
    [anon_sym_BANG_EQ] = ACTIONS(2697),
    [anon_sym_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT_EQ] = ACTIONS(2697),
    [anon_sym_LBRACK] = ACTIONS(2695),
    [anon_sym_struct] = ACTIONS(2697),
    [anon_sym_union] = ACTIONS(2697),
    [anon_sym_pub] = ACTIONS(2697),
    [anon_sym_mut] = ACTIONS(2697),
    [anon_sym_enum] = ACTIONS(2697),
    [anon_sym_interface] = ACTIONS(2697),
    [anon_sym_PLUS_PLUS] = ACTIONS(2697),
    [anon_sym_DASH_DASH] = ACTIONS(2697),
    [anon_sym_QMARK] = ACTIONS(2697),
    [anon_sym_BANG] = ACTIONS(3978),
    [anon_sym_go] = ACTIONS(2697),
    [anon_sym_spawn] = ACTIONS(2697),
    [anon_sym_json_DOTdecode] = ACTIONS(2697),
    [anon_sym_PIPE] = ACTIONS(2697),
    [anon_sym_LBRACK2] = ACTIONS(2697),
    [anon_sym_TILDE] = ACTIONS(2697),
    [anon_sym_CARET] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2697),
    [anon_sym_LT_DASH] = ACTIONS(2697),
    [anon_sym_LT_LT] = ACTIONS(2697),
    [anon_sym_GT_GT] = ACTIONS(2697),
    [anon_sym_GT_GT_GT] = ACTIONS(2697),
    [anon_sym_AMP_CARET] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_PIPE_PIPE] = ACTIONS(2697),
    [anon_sym_or] = ACTIONS(2697),
    [sym_none] = ACTIONS(2697),
    [sym_true] = ACTIONS(2697),
    [sym_false] = ACTIONS(2697),
    [sym_nil] = ACTIONS(2697),
    [anon_sym_QMARK_DOT] = ACTIONS(2697),
    [anon_sym_POUND_LBRACK] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(2697),
    [anon_sym_DOLLARif] = ACTIONS(2697),
    [anon_sym_is] = ACTIONS(2697),
    [anon_sym_BANGis] = ACTIONS(2697),
    [anon_sym_in] = ACTIONS(2697),
    [anon_sym_BANGin] = ACTIONS(2697),
    [anon_sym_match] = ACTIONS(2697),
    [anon_sym_select] = ACTIONS(2697),
    [anon_sym_lock] = ACTIONS(2697),
    [anon_sym_rlock] = ACTIONS(2697),
    [anon_sym_unsafe] = ACTIONS(2697),
    [anon_sym_sql] = ACTIONS(2697),
    [sym_int_literal] = ACTIONS(2697),
    [sym_float_literal] = ACTIONS(2697),
    [sym_rune_literal] = ACTIONS(2697),
    [anon_sym_SQUOTE] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [anon_sym_c_SQUOTE] = ACTIONS(2697),
    [anon_sym_c_DQUOTE] = ACTIONS(2697),
    [anon_sym_r_SQUOTE] = ACTIONS(2697),
    [anon_sym_r_DQUOTE] = ACTIONS(2697),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2697),
    [anon_sym_shared] = ACTIONS(2697),
    [anon_sym_map_LBRACK] = ACTIONS(2697),
    [anon_sym_chan] = ACTIONS(2697),
    [anon_sym_thread] = ACTIONS(2697),
    [anon_sym_atomic] = ACTIONS(2697),
    [anon_sym_assert] = ACTIONS(2697),
    [anon_sym_defer] = ACTIONS(2697),
    [anon_sym_goto] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2697),
    [anon_sym_continue] = ACTIONS(2697),
    [anon_sym_return] = ACTIONS(2697),
    [anon_sym_DOLLARfor] = ACTIONS(2697),
    [anon_sym_for] = ACTIONS(2697),
    [anon_sym_POUND] = ACTIONS(2697),
    [anon_sym_asm] = ACTIONS(2697),
    [anon_sym_AT_LBRACK] = ACTIONS(2697),
  },
  [1214] = {
    [sym_line_comment] = STATE(1214),
    [sym_block_comment] = STATE(1214),
    [ts_builtin_sym_end] = ACTIONS(2891),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LF] = ACTIONS(2893),
    [anon_sym_CR] = ACTIONS(2893),
    [anon_sym_CR_LF] = ACTIONS(2893),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2893),
    [anon_sym_as] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2893),
    [anon_sym___global] = ACTIONS(2893),
    [anon_sym_type] = ACTIONS(2893),
    [anon_sym_fn] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_PERCENT] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_GT] = ACTIONS(2893),
    [anon_sym_EQ_EQ] = ACTIONS(2893),
    [anon_sym_BANG_EQ] = ACTIONS(2893),
    [anon_sym_LT_EQ] = ACTIONS(2893),
    [anon_sym_GT_EQ] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [anon_sym_pub] = ACTIONS(2893),
    [anon_sym_mut] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_interface] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2893),
    [anon_sym_DASH_DASH] = ACTIONS(2893),
    [anon_sym_QMARK] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_go] = ACTIONS(2893),
    [anon_sym_spawn] = ACTIONS(2893),
    [anon_sym_json_DOTdecode] = ACTIONS(2893),
    [anon_sym_PIPE] = ACTIONS(2893),
    [anon_sym_LBRACK2] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_LT_DASH] = ACTIONS(2893),
    [anon_sym_LT_LT] = ACTIONS(2893),
    [anon_sym_GT_GT] = ACTIONS(2893),
    [anon_sym_GT_GT_GT] = ACTIONS(2893),
    [anon_sym_AMP_CARET] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2893),
    [anon_sym_PIPE_PIPE] = ACTIONS(2893),
    [anon_sym_or] = ACTIONS(2893),
    [sym_none] = ACTIONS(2893),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [sym_nil] = ACTIONS(2893),
    [anon_sym_QMARK_DOT] = ACTIONS(2893),
    [anon_sym_POUND_LBRACK] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_DOLLARif] = ACTIONS(2893),
    [anon_sym_is] = ACTIONS(2893),
    [anon_sym_BANGis] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_BANGin] = ACTIONS(2893),
    [anon_sym_match] = ACTIONS(2893),
    [anon_sym_select] = ACTIONS(2893),
    [anon_sym_lock] = ACTIONS(2893),
    [anon_sym_rlock] = ACTIONS(2893),
    [anon_sym_unsafe] = ACTIONS(2893),
    [anon_sym_sql] = ACTIONS(2893),
    [sym_int_literal] = ACTIONS(2893),
    [sym_float_literal] = ACTIONS(2893),
    [sym_rune_literal] = ACTIONS(2893),
    [anon_sym_SQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(2893),
    [anon_sym_c_SQUOTE] = ACTIONS(2893),
    [anon_sym_c_DQUOTE] = ACTIONS(2893),
    [anon_sym_r_SQUOTE] = ACTIONS(2893),
    [anon_sym_r_DQUOTE] = ACTIONS(2893),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_map_LBRACK] = ACTIONS(2893),
    [anon_sym_chan] = ACTIONS(2893),
    [anon_sym_thread] = ACTIONS(2893),
    [anon_sym_atomic] = ACTIONS(2893),
    [anon_sym_assert] = ACTIONS(2893),
    [anon_sym_defer] = ACTIONS(2893),
    [anon_sym_goto] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_DOLLARfor] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_POUND] = ACTIONS(2893),
    [anon_sym_asm] = ACTIONS(2893),
    [anon_sym_AT_LBRACK] = ACTIONS(2893),
  },
  [1215] = {
    [sym_line_comment] = STATE(1215),
    [sym_block_comment] = STATE(1215),
    [ts_builtin_sym_end] = ACTIONS(2185),
    [sym_identifier] = ACTIONS(2187),
    [anon_sym_LF] = ACTIONS(2187),
    [anon_sym_CR] = ACTIONS(2187),
    [anon_sym_CR_LF] = ACTIONS(2187),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2187),
    [anon_sym_as] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_const] = ACTIONS(2187),
    [anon_sym_LPAREN] = ACTIONS(2187),
    [anon_sym___global] = ACTIONS(2187),
    [anon_sym_type] = ACTIONS(2187),
    [anon_sym_fn] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [anon_sym_LT] = ACTIONS(2187),
    [anon_sym_GT] = ACTIONS(2187),
    [anon_sym_EQ_EQ] = ACTIONS(2187),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2187),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2185),
    [anon_sym_struct] = ACTIONS(2187),
    [anon_sym_union] = ACTIONS(2187),
    [anon_sym_pub] = ACTIONS(2187),
    [anon_sym_mut] = ACTIONS(2187),
    [anon_sym_enum] = ACTIONS(2187),
    [anon_sym_interface] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_go] = ACTIONS(2187),
    [anon_sym_spawn] = ACTIONS(2187),
    [anon_sym_json_DOTdecode] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2187),
    [anon_sym_LBRACK2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_LT_DASH] = ACTIONS(2187),
    [anon_sym_LT_LT] = ACTIONS(2187),
    [anon_sym_GT_GT] = ACTIONS(2187),
    [anon_sym_GT_GT_GT] = ACTIONS(2187),
    [anon_sym_AMP_CARET] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2187),
    [sym_none] = ACTIONS(2187),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [sym_nil] = ACTIONS(2187),
    [anon_sym_QMARK_DOT] = ACTIONS(2187),
    [anon_sym_POUND_LBRACK] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_DOLLARif] = ACTIONS(2187),
    [anon_sym_is] = ACTIONS(2187),
    [anon_sym_BANGis] = ACTIONS(2187),
    [anon_sym_in] = ACTIONS(2187),
    [anon_sym_BANGin] = ACTIONS(2187),
    [anon_sym_match] = ACTIONS(2187),
    [anon_sym_select] = ACTIONS(2187),
    [anon_sym_lock] = ACTIONS(2187),
    [anon_sym_rlock] = ACTIONS(2187),
    [anon_sym_unsafe] = ACTIONS(2187),
    [anon_sym_sql] = ACTIONS(2187),
    [sym_int_literal] = ACTIONS(2187),
    [sym_float_literal] = ACTIONS(2187),
    [sym_rune_literal] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(2187),
    [anon_sym_DQUOTE] = ACTIONS(2187),
    [anon_sym_c_SQUOTE] = ACTIONS(2187),
    [anon_sym_c_DQUOTE] = ACTIONS(2187),
    [anon_sym_r_SQUOTE] = ACTIONS(2187),
    [anon_sym_r_DQUOTE] = ACTIONS(2187),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2187),
    [anon_sym_shared] = ACTIONS(2187),
    [anon_sym_map_LBRACK] = ACTIONS(2187),
    [anon_sym_chan] = ACTIONS(2187),
    [anon_sym_thread] = ACTIONS(2187),
    [anon_sym_atomic] = ACTIONS(2187),
    [anon_sym_assert] = ACTIONS(2187),
    [anon_sym_defer] = ACTIONS(2187),
    [anon_sym_goto] = ACTIONS(2187),
    [anon_sym_break] = ACTIONS(2187),
    [anon_sym_continue] = ACTIONS(2187),
    [anon_sym_return] = ACTIONS(2187),
    [anon_sym_DOLLARfor] = ACTIONS(2187),
    [anon_sym_for] = ACTIONS(2187),
    [anon_sym_POUND] = ACTIONS(2187),
    [anon_sym_asm] = ACTIONS(2187),
    [anon_sym_AT_LBRACK] = ACTIONS(2187),
  },
  [1216] = {
    [sym_line_comment] = STATE(1216),
    [sym_block_comment] = STATE(1216),
    [ts_builtin_sym_end] = ACTIONS(2337),
    [sym_identifier] = ACTIONS(2335),
    [anon_sym_LF] = ACTIONS(2335),
    [anon_sym_CR] = ACTIONS(2335),
    [anon_sym_CR_LF] = ACTIONS(2335),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2335),
    [anon_sym_as] = ACTIONS(2335),
    [anon_sym_LBRACE] = ACTIONS(2335),
    [anon_sym_COMMA] = ACTIONS(2335),
    [anon_sym_const] = ACTIONS(2335),
    [anon_sym_LPAREN] = ACTIONS(2335),
    [anon_sym___global] = ACTIONS(2335),
    [anon_sym_type] = ACTIONS(2335),
    [anon_sym_fn] = ACTIONS(2335),
    [anon_sym_PLUS] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2335),
    [anon_sym_STAR] = ACTIONS(2335),
    [anon_sym_SLASH] = ACTIONS(2335),
    [anon_sym_PERCENT] = ACTIONS(2335),
    [anon_sym_LT] = ACTIONS(2335),
    [anon_sym_GT] = ACTIONS(2335),
    [anon_sym_EQ_EQ] = ACTIONS(2335),
    [anon_sym_BANG_EQ] = ACTIONS(2335),
    [anon_sym_LT_EQ] = ACTIONS(2335),
    [anon_sym_GT_EQ] = ACTIONS(2335),
    [anon_sym_LBRACK] = ACTIONS(2337),
    [anon_sym_struct] = ACTIONS(2335),
    [anon_sym_union] = ACTIONS(2335),
    [anon_sym_pub] = ACTIONS(2335),
    [anon_sym_mut] = ACTIONS(2335),
    [anon_sym_enum] = ACTIONS(2335),
    [anon_sym_interface] = ACTIONS(2335),
    [anon_sym_PLUS_PLUS] = ACTIONS(2335),
    [anon_sym_DASH_DASH] = ACTIONS(2335),
    [anon_sym_QMARK] = ACTIONS(2335),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_go] = ACTIONS(2335),
    [anon_sym_spawn] = ACTIONS(2335),
    [anon_sym_json_DOTdecode] = ACTIONS(2335),
    [anon_sym_PIPE] = ACTIONS(2335),
    [anon_sym_LBRACK2] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [anon_sym_CARET] = ACTIONS(2335),
    [anon_sym_AMP] = ACTIONS(2335),
    [anon_sym_LT_DASH] = ACTIONS(2335),
    [anon_sym_LT_LT] = ACTIONS(2335),
    [anon_sym_GT_GT] = ACTIONS(2335),
    [anon_sym_GT_GT_GT] = ACTIONS(2335),
    [anon_sym_AMP_CARET] = ACTIONS(2335),
    [anon_sym_AMP_AMP] = ACTIONS(2335),
    [anon_sym_PIPE_PIPE] = ACTIONS(2335),
    [anon_sym_or] = ACTIONS(2335),
    [sym_none] = ACTIONS(2335),
    [sym_true] = ACTIONS(2335),
    [sym_false] = ACTIONS(2335),
    [sym_nil] = ACTIONS(2335),
    [anon_sym_QMARK_DOT] = ACTIONS(2335),
    [anon_sym_POUND_LBRACK] = ACTIONS(2335),
    [anon_sym_if] = ACTIONS(2335),
    [anon_sym_DOLLARif] = ACTIONS(2335),
    [anon_sym_is] = ACTIONS(2335),
    [anon_sym_BANGis] = ACTIONS(2335),
    [anon_sym_in] = ACTIONS(2335),
    [anon_sym_BANGin] = ACTIONS(2335),
    [anon_sym_match] = ACTIONS(2335),
    [anon_sym_select] = ACTIONS(2335),
    [anon_sym_lock] = ACTIONS(2335),
    [anon_sym_rlock] = ACTIONS(2335),
    [anon_sym_unsafe] = ACTIONS(2335),
    [anon_sym_sql] = ACTIONS(2335),
    [sym_int_literal] = ACTIONS(2335),
    [sym_float_literal] = ACTIONS(2335),
    [sym_rune_literal] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2335),
    [anon_sym_DQUOTE] = ACTIONS(2335),
    [anon_sym_c_SQUOTE] = ACTIONS(2335),
    [anon_sym_c_DQUOTE] = ACTIONS(2335),
    [anon_sym_r_SQUOTE] = ACTIONS(2335),
    [anon_sym_r_DQUOTE] = ACTIONS(2335),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2335),
    [anon_sym_shared] = ACTIONS(2335),
    [anon_sym_map_LBRACK] = ACTIONS(2335),
    [anon_sym_chan] = ACTIONS(2335),
    [anon_sym_thread] = ACTIONS(2335),
    [anon_sym_atomic] = ACTIONS(2335),
    [anon_sym_assert] = ACTIONS(2335),
    [anon_sym_defer] = ACTIONS(2335),
    [anon_sym_goto] = ACTIONS(2335),
    [anon_sym_break] = ACTIONS(2335),
    [anon_sym_continue] = ACTIONS(2335),
    [anon_sym_return] = ACTIONS(2335),
    [anon_sym_DOLLARfor] = ACTIONS(2335),
    [anon_sym_for] = ACTIONS(2335),
    [anon_sym_POUND] = ACTIONS(2335),
    [anon_sym_asm] = ACTIONS(2335),
    [anon_sym_AT_LBRACK] = ACTIONS(2335),
  },
  [1217] = {
    [sym_line_comment] = STATE(1217),
    [sym_block_comment] = STATE(1217),
    [ts_builtin_sym_end] = ACTIONS(2448),
    [sym_identifier] = ACTIONS(2445),
    [anon_sym_LF] = ACTIONS(2445),
    [anon_sym_CR] = ACTIONS(2445),
    [anon_sym_CR_LF] = ACTIONS(2445),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2445),
    [anon_sym_as] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(2445),
    [anon_sym_COMMA] = ACTIONS(2445),
    [anon_sym_const] = ACTIONS(2445),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym___global] = ACTIONS(2445),
    [anon_sym_type] = ACTIONS(2445),
    [anon_sym_fn] = ACTIONS(2445),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2445),
    [anon_sym_STAR] = ACTIONS(2445),
    [anon_sym_SLASH] = ACTIONS(2445),
    [anon_sym_PERCENT] = ACTIONS(2445),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_GT] = ACTIONS(2445),
    [anon_sym_EQ_EQ] = ACTIONS(2445),
    [anon_sym_BANG_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_struct] = ACTIONS(2445),
    [anon_sym_union] = ACTIONS(2445),
    [anon_sym_pub] = ACTIONS(2445),
    [anon_sym_mut] = ACTIONS(2445),
    [anon_sym_enum] = ACTIONS(2445),
    [anon_sym_interface] = ACTIONS(2445),
    [anon_sym_PLUS_PLUS] = ACTIONS(2445),
    [anon_sym_DASH_DASH] = ACTIONS(2445),
    [anon_sym_QMARK] = ACTIONS(2445),
    [anon_sym_BANG] = ACTIONS(2445),
    [anon_sym_go] = ACTIONS(2445),
    [anon_sym_spawn] = ACTIONS(2445),
    [anon_sym_json_DOTdecode] = ACTIONS(2445),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_LBRACK2] = ACTIONS(2445),
    [anon_sym_TILDE] = ACTIONS(2445),
    [anon_sym_CARET] = ACTIONS(2445),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_LT_DASH] = ACTIONS(2445),
    [anon_sym_LT_LT] = ACTIONS(2445),
    [anon_sym_GT_GT] = ACTIONS(2445),
    [anon_sym_GT_GT_GT] = ACTIONS(2445),
    [anon_sym_AMP_CARET] = ACTIONS(2445),
    [anon_sym_AMP_AMP] = ACTIONS(2445),
    [anon_sym_PIPE_PIPE] = ACTIONS(2445),
    [anon_sym_or] = ACTIONS(2445),
    [sym_none] = ACTIONS(2445),
    [sym_true] = ACTIONS(2445),
    [sym_false] = ACTIONS(2445),
    [sym_nil] = ACTIONS(2445),
    [anon_sym_QMARK_DOT] = ACTIONS(2445),
    [anon_sym_POUND_LBRACK] = ACTIONS(2445),
    [anon_sym_if] = ACTIONS(2445),
    [anon_sym_DOLLARif] = ACTIONS(2445),
    [anon_sym_is] = ACTIONS(2445),
    [anon_sym_BANGis] = ACTIONS(2445),
    [anon_sym_in] = ACTIONS(2445),
    [anon_sym_BANGin] = ACTIONS(2445),
    [anon_sym_match] = ACTIONS(2445),
    [anon_sym_select] = ACTIONS(2445),
    [anon_sym_lock] = ACTIONS(2445),
    [anon_sym_rlock] = ACTIONS(2445),
    [anon_sym_unsafe] = ACTIONS(2445),
    [anon_sym_sql] = ACTIONS(2445),
    [sym_int_literal] = ACTIONS(2445),
    [sym_float_literal] = ACTIONS(2445),
    [sym_rune_literal] = ACTIONS(2445),
    [anon_sym_SQUOTE] = ACTIONS(2445),
    [anon_sym_DQUOTE] = ACTIONS(2445),
    [anon_sym_c_SQUOTE] = ACTIONS(2445),
    [anon_sym_c_DQUOTE] = ACTIONS(2445),
    [anon_sym_r_SQUOTE] = ACTIONS(2445),
    [anon_sym_r_DQUOTE] = ACTIONS(2445),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2445),
    [anon_sym_shared] = ACTIONS(2445),
    [anon_sym_map_LBRACK] = ACTIONS(2445),
    [anon_sym_chan] = ACTIONS(2445),
    [anon_sym_thread] = ACTIONS(2445),
    [anon_sym_atomic] = ACTIONS(2445),
    [anon_sym_assert] = ACTIONS(2445),
    [anon_sym_defer] = ACTIONS(2445),
    [anon_sym_goto] = ACTIONS(2445),
    [anon_sym_break] = ACTIONS(2445),
    [anon_sym_continue] = ACTIONS(2445),
    [anon_sym_return] = ACTIONS(2445),
    [anon_sym_DOLLARfor] = ACTIONS(2445),
    [anon_sym_for] = ACTIONS(2445),
    [anon_sym_POUND] = ACTIONS(2445),
    [anon_sym_asm] = ACTIONS(2445),
    [anon_sym_AT_LBRACK] = ACTIONS(2445),
  },
  [1218] = {
    [sym_line_comment] = STATE(1218),
    [sym_block_comment] = STATE(1218),
    [ts_builtin_sym_end] = ACTIONS(2965),
    [sym_identifier] = ACTIONS(2967),
    [anon_sym_LF] = ACTIONS(2967),
    [anon_sym_CR] = ACTIONS(2967),
    [anon_sym_CR_LF] = ACTIONS(2967),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2967),
    [anon_sym_as] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2967),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(2967),
    [anon_sym___global] = ACTIONS(2967),
    [anon_sym_type] = ACTIONS(2967),
    [anon_sym_fn] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2967),
    [anon_sym_SLASH] = ACTIONS(2967),
    [anon_sym_PERCENT] = ACTIONS(2967),
    [anon_sym_LT] = ACTIONS(2967),
    [anon_sym_GT] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2967),
    [anon_sym_BANG_EQ] = ACTIONS(2967),
    [anon_sym_LT_EQ] = ACTIONS(2967),
    [anon_sym_GT_EQ] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2965),
    [anon_sym_struct] = ACTIONS(2967),
    [anon_sym_union] = ACTIONS(2967),
    [anon_sym_pub] = ACTIONS(2967),
    [anon_sym_mut] = ACTIONS(2967),
    [anon_sym_enum] = ACTIONS(2967),
    [anon_sym_interface] = ACTIONS(2967),
    [anon_sym_PLUS_PLUS] = ACTIONS(2967),
    [anon_sym_DASH_DASH] = ACTIONS(2967),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_BANG] = ACTIONS(2967),
    [anon_sym_go] = ACTIONS(2967),
    [anon_sym_spawn] = ACTIONS(2967),
    [anon_sym_json_DOTdecode] = ACTIONS(2967),
    [anon_sym_PIPE] = ACTIONS(2967),
    [anon_sym_LBRACK2] = ACTIONS(2967),
    [anon_sym_TILDE] = ACTIONS(2967),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_AMP] = ACTIONS(2967),
    [anon_sym_LT_DASH] = ACTIONS(2967),
    [anon_sym_LT_LT] = ACTIONS(2967),
    [anon_sym_GT_GT] = ACTIONS(2967),
    [anon_sym_GT_GT_GT] = ACTIONS(2967),
    [anon_sym_AMP_CARET] = ACTIONS(2967),
    [anon_sym_AMP_AMP] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE] = ACTIONS(2967),
    [anon_sym_or] = ACTIONS(2967),
    [sym_none] = ACTIONS(2967),
    [sym_true] = ACTIONS(2967),
    [sym_false] = ACTIONS(2967),
    [sym_nil] = ACTIONS(2967),
    [anon_sym_QMARK_DOT] = ACTIONS(2967),
    [anon_sym_POUND_LBRACK] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_DOLLARif] = ACTIONS(2967),
    [anon_sym_is] = ACTIONS(2967),
    [anon_sym_BANGis] = ACTIONS(2967),
    [anon_sym_in] = ACTIONS(2967),
    [anon_sym_BANGin] = ACTIONS(2967),
    [anon_sym_match] = ACTIONS(2967),
    [anon_sym_select] = ACTIONS(2967),
    [anon_sym_lock] = ACTIONS(2967),
    [anon_sym_rlock] = ACTIONS(2967),
    [anon_sym_unsafe] = ACTIONS(2967),
    [anon_sym_sql] = ACTIONS(2967),
    [sym_int_literal] = ACTIONS(2967),
    [sym_float_literal] = ACTIONS(2967),
    [sym_rune_literal] = ACTIONS(2967),
    [anon_sym_SQUOTE] = ACTIONS(2967),
    [anon_sym_DQUOTE] = ACTIONS(2967),
    [anon_sym_c_SQUOTE] = ACTIONS(2967),
    [anon_sym_c_DQUOTE] = ACTIONS(2967),
    [anon_sym_r_SQUOTE] = ACTIONS(2967),
    [anon_sym_r_DQUOTE] = ACTIONS(2967),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2967),
    [anon_sym_shared] = ACTIONS(2967),
    [anon_sym_map_LBRACK] = ACTIONS(2967),
    [anon_sym_chan] = ACTIONS(2967),
    [anon_sym_thread] = ACTIONS(2967),
    [anon_sym_atomic] = ACTIONS(2967),
    [anon_sym_assert] = ACTIONS(2967),
    [anon_sym_defer] = ACTIONS(2967),
    [anon_sym_goto] = ACTIONS(2967),
    [anon_sym_break] = ACTIONS(2967),
    [anon_sym_continue] = ACTIONS(2967),
    [anon_sym_return] = ACTIONS(2967),
    [anon_sym_DOLLARfor] = ACTIONS(2967),
    [anon_sym_for] = ACTIONS(2967),
    [anon_sym_POUND] = ACTIONS(2967),
    [anon_sym_asm] = ACTIONS(2967),
    [anon_sym_AT_LBRACK] = ACTIONS(2967),
  },
  [1219] = {
    [sym_line_comment] = STATE(1219),
    [sym_block_comment] = STATE(1219),
    [ts_builtin_sym_end] = ACTIONS(2451),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LF] = ACTIONS(2453),
    [anon_sym_CR] = ACTIONS(2453),
    [anon_sym_CR_LF] = ACTIONS(2453),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2453),
    [anon_sym_as] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [anon_sym_COMMA] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym___global] = ACTIONS(2453),
    [anon_sym_type] = ACTIONS(2453),
    [anon_sym_fn] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2453),
    [anon_sym_SLASH] = ACTIONS(2453),
    [anon_sym_PERCENT] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2453),
    [anon_sym_EQ_EQ] = ACTIONS(2453),
    [anon_sym_BANG_EQ] = ACTIONS(2453),
    [anon_sym_LT_EQ] = ACTIONS(2453),
    [anon_sym_GT_EQ] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2451),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [anon_sym_pub] = ACTIONS(2453),
    [anon_sym_mut] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_interface] = ACTIONS(2453),
    [anon_sym_PLUS_PLUS] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2453),
    [anon_sym_QMARK] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(2453),
    [anon_sym_go] = ACTIONS(2453),
    [anon_sym_spawn] = ACTIONS(2453),
    [anon_sym_json_DOTdecode] = ACTIONS(2453),
    [anon_sym_PIPE] = ACTIONS(2453),
    [anon_sym_LBRACK2] = ACTIONS(2453),
    [anon_sym_TILDE] = ACTIONS(2453),
    [anon_sym_CARET] = ACTIONS(2453),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_LT_DASH] = ACTIONS(2453),
    [anon_sym_LT_LT] = ACTIONS(2453),
    [anon_sym_GT_GT] = ACTIONS(2453),
    [anon_sym_GT_GT_GT] = ACTIONS(2453),
    [anon_sym_AMP_CARET] = ACTIONS(2453),
    [anon_sym_AMP_AMP] = ACTIONS(2453),
    [anon_sym_PIPE_PIPE] = ACTIONS(2453),
    [anon_sym_or] = ACTIONS(2453),
    [sym_none] = ACTIONS(2453),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [sym_nil] = ACTIONS(2453),
    [anon_sym_QMARK_DOT] = ACTIONS(2453),
    [anon_sym_POUND_LBRACK] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_DOLLARif] = ACTIONS(2453),
    [anon_sym_is] = ACTIONS(2453),
    [anon_sym_BANGis] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_BANGin] = ACTIONS(2453),
    [anon_sym_match] = ACTIONS(2453),
    [anon_sym_select] = ACTIONS(2453),
    [anon_sym_lock] = ACTIONS(2453),
    [anon_sym_rlock] = ACTIONS(2453),
    [anon_sym_unsafe] = ACTIONS(2453),
    [anon_sym_sql] = ACTIONS(2453),
    [sym_int_literal] = ACTIONS(2453),
    [sym_float_literal] = ACTIONS(2453),
    [sym_rune_literal] = ACTIONS(2453),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2453),
    [anon_sym_c_SQUOTE] = ACTIONS(2453),
    [anon_sym_c_DQUOTE] = ACTIONS(2453),
    [anon_sym_r_SQUOTE] = ACTIONS(2453),
    [anon_sym_r_DQUOTE] = ACTIONS(2453),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_map_LBRACK] = ACTIONS(2453),
    [anon_sym_chan] = ACTIONS(2453),
    [anon_sym_thread] = ACTIONS(2453),
    [anon_sym_atomic] = ACTIONS(2453),
    [anon_sym_assert] = ACTIONS(2453),
    [anon_sym_defer] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_DOLLARfor] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_POUND] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
    [anon_sym_AT_LBRACK] = ACTIONS(2453),
  },
  [1220] = {
    [sym_line_comment] = STATE(1220),
    [sym_block_comment] = STATE(1220),
    [ts_builtin_sym_end] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2429),
    [anon_sym_LF] = ACTIONS(2429),
    [anon_sym_CR] = ACTIONS(2429),
    [anon_sym_CR_LF] = ACTIONS(2429),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2429),
    [anon_sym_as] = ACTIONS(2429),
    [anon_sym_LBRACE] = ACTIONS(2429),
    [anon_sym_COMMA] = ACTIONS(2429),
    [anon_sym_const] = ACTIONS(2429),
    [anon_sym_LPAREN] = ACTIONS(2429),
    [anon_sym___global] = ACTIONS(2429),
    [anon_sym_type] = ACTIONS(2429),
    [anon_sym_fn] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(2429),
    [anon_sym_DASH] = ACTIONS(2429),
    [anon_sym_STAR] = ACTIONS(2429),
    [anon_sym_SLASH] = ACTIONS(2429),
    [anon_sym_PERCENT] = ACTIONS(2429),
    [anon_sym_LT] = ACTIONS(2429),
    [anon_sym_GT] = ACTIONS(2429),
    [anon_sym_EQ_EQ] = ACTIONS(2429),
    [anon_sym_BANG_EQ] = ACTIONS(2429),
    [anon_sym_LT_EQ] = ACTIONS(2429),
    [anon_sym_GT_EQ] = ACTIONS(2429),
    [anon_sym_LBRACK] = ACTIONS(2427),
    [anon_sym_struct] = ACTIONS(2429),
    [anon_sym_union] = ACTIONS(2429),
    [anon_sym_pub] = ACTIONS(2429),
    [anon_sym_mut] = ACTIONS(2429),
    [anon_sym_enum] = ACTIONS(2429),
    [anon_sym_interface] = ACTIONS(2429),
    [anon_sym_PLUS_PLUS] = ACTIONS(2429),
    [anon_sym_DASH_DASH] = ACTIONS(2429),
    [anon_sym_QMARK] = ACTIONS(2429),
    [anon_sym_BANG] = ACTIONS(2429),
    [anon_sym_go] = ACTIONS(2429),
    [anon_sym_spawn] = ACTIONS(2429),
    [anon_sym_json_DOTdecode] = ACTIONS(2429),
    [anon_sym_PIPE] = ACTIONS(2429),
    [anon_sym_LBRACK2] = ACTIONS(2429),
    [anon_sym_TILDE] = ACTIONS(2429),
    [anon_sym_CARET] = ACTIONS(2429),
    [anon_sym_AMP] = ACTIONS(2429),
    [anon_sym_LT_DASH] = ACTIONS(2429),
    [anon_sym_LT_LT] = ACTIONS(2429),
    [anon_sym_GT_GT] = ACTIONS(2429),
    [anon_sym_GT_GT_GT] = ACTIONS(2429),
    [anon_sym_AMP_CARET] = ACTIONS(2429),
    [anon_sym_AMP_AMP] = ACTIONS(2429),
    [anon_sym_PIPE_PIPE] = ACTIONS(2429),
    [anon_sym_or] = ACTIONS(2429),
    [sym_none] = ACTIONS(2429),
    [sym_true] = ACTIONS(2429),
    [sym_false] = ACTIONS(2429),
    [sym_nil] = ACTIONS(2429),
    [anon_sym_QMARK_DOT] = ACTIONS(2429),
    [anon_sym_POUND_LBRACK] = ACTIONS(2429),
    [anon_sym_if] = ACTIONS(2429),
    [anon_sym_DOLLARif] = ACTIONS(2429),
    [anon_sym_is] = ACTIONS(2429),
    [anon_sym_BANGis] = ACTIONS(2429),
    [anon_sym_in] = ACTIONS(2429),
    [anon_sym_BANGin] = ACTIONS(2429),
    [anon_sym_match] = ACTIONS(2429),
    [anon_sym_select] = ACTIONS(2429),
    [anon_sym_lock] = ACTIONS(2429),
    [anon_sym_rlock] = ACTIONS(2429),
    [anon_sym_unsafe] = ACTIONS(2429),
    [anon_sym_sql] = ACTIONS(2429),
    [sym_int_literal] = ACTIONS(2429),
    [sym_float_literal] = ACTIONS(2429),
    [sym_rune_literal] = ACTIONS(2429),
    [anon_sym_SQUOTE] = ACTIONS(2429),
    [anon_sym_DQUOTE] = ACTIONS(2429),
    [anon_sym_c_SQUOTE] = ACTIONS(2429),
    [anon_sym_c_DQUOTE] = ACTIONS(2429),
    [anon_sym_r_SQUOTE] = ACTIONS(2429),
    [anon_sym_r_DQUOTE] = ACTIONS(2429),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2429),
    [anon_sym_shared] = ACTIONS(2429),
    [anon_sym_map_LBRACK] = ACTIONS(2429),
    [anon_sym_chan] = ACTIONS(2429),
    [anon_sym_thread] = ACTIONS(2429),
    [anon_sym_atomic] = ACTIONS(2429),
    [anon_sym_assert] = ACTIONS(2429),
    [anon_sym_defer] = ACTIONS(2429),
    [anon_sym_goto] = ACTIONS(2429),
    [anon_sym_break] = ACTIONS(2429),
    [anon_sym_continue] = ACTIONS(2429),
    [anon_sym_return] = ACTIONS(2429),
    [anon_sym_DOLLARfor] = ACTIONS(2429),
    [anon_sym_for] = ACTIONS(2429),
    [anon_sym_POUND] = ACTIONS(2429),
    [anon_sym_asm] = ACTIONS(2429),
    [anon_sym_AT_LBRACK] = ACTIONS(2429),
  },
  [1221] = {
    [sym_line_comment] = STATE(1221),
    [sym_block_comment] = STATE(1221),
    [ts_builtin_sym_end] = ACTIONS(3244),
    [sym_identifier] = ACTIONS(3246),
    [anon_sym_LF] = ACTIONS(3246),
    [anon_sym_CR] = ACTIONS(3246),
    [anon_sym_CR_LF] = ACTIONS(3246),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3246),
    [anon_sym_as] = ACTIONS(3246),
    [anon_sym_LBRACE] = ACTIONS(3246),
    [anon_sym_COMMA] = ACTIONS(3246),
    [anon_sym_const] = ACTIONS(3246),
    [anon_sym_LPAREN] = ACTIONS(3246),
    [anon_sym___global] = ACTIONS(3246),
    [anon_sym_type] = ACTIONS(3246),
    [anon_sym_fn] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3246),
    [anon_sym_DASH] = ACTIONS(3246),
    [anon_sym_STAR] = ACTIONS(3246),
    [anon_sym_SLASH] = ACTIONS(3246),
    [anon_sym_PERCENT] = ACTIONS(3246),
    [anon_sym_LT] = ACTIONS(3246),
    [anon_sym_GT] = ACTIONS(3246),
    [anon_sym_EQ_EQ] = ACTIONS(3246),
    [anon_sym_BANG_EQ] = ACTIONS(3246),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3246),
    [anon_sym_LBRACK] = ACTIONS(3244),
    [anon_sym_struct] = ACTIONS(3246),
    [anon_sym_union] = ACTIONS(3246),
    [anon_sym_pub] = ACTIONS(3246),
    [anon_sym_mut] = ACTIONS(3246),
    [anon_sym_enum] = ACTIONS(3246),
    [anon_sym_interface] = ACTIONS(3246),
    [anon_sym_PLUS_PLUS] = ACTIONS(3246),
    [anon_sym_DASH_DASH] = ACTIONS(3246),
    [anon_sym_QMARK] = ACTIONS(3246),
    [anon_sym_BANG] = ACTIONS(3246),
    [anon_sym_go] = ACTIONS(3246),
    [anon_sym_spawn] = ACTIONS(3246),
    [anon_sym_json_DOTdecode] = ACTIONS(3246),
    [anon_sym_PIPE] = ACTIONS(3246),
    [anon_sym_LBRACK2] = ACTIONS(3246),
    [anon_sym_TILDE] = ACTIONS(3246),
    [anon_sym_CARET] = ACTIONS(3246),
    [anon_sym_AMP] = ACTIONS(3246),
    [anon_sym_LT_DASH] = ACTIONS(3246),
    [anon_sym_LT_LT] = ACTIONS(3246),
    [anon_sym_GT_GT] = ACTIONS(3246),
    [anon_sym_GT_GT_GT] = ACTIONS(3246),
    [anon_sym_AMP_CARET] = ACTIONS(3246),
    [anon_sym_AMP_AMP] = ACTIONS(3246),
    [anon_sym_PIPE_PIPE] = ACTIONS(3246),
    [anon_sym_or] = ACTIONS(3246),
    [sym_none] = ACTIONS(3246),
    [sym_true] = ACTIONS(3246),
    [sym_false] = ACTIONS(3246),
    [sym_nil] = ACTIONS(3246),
    [anon_sym_QMARK_DOT] = ACTIONS(3246),
    [anon_sym_POUND_LBRACK] = ACTIONS(3246),
    [anon_sym_if] = ACTIONS(3246),
    [anon_sym_DOLLARif] = ACTIONS(3246),
    [anon_sym_is] = ACTIONS(3246),
    [anon_sym_BANGis] = ACTIONS(3246),
    [anon_sym_in] = ACTIONS(3246),
    [anon_sym_BANGin] = ACTIONS(3246),
    [anon_sym_match] = ACTIONS(3246),
    [anon_sym_select] = ACTIONS(3246),
    [anon_sym_lock] = ACTIONS(3246),
    [anon_sym_rlock] = ACTIONS(3246),
    [anon_sym_unsafe] = ACTIONS(3246),
    [anon_sym_sql] = ACTIONS(3246),
    [sym_int_literal] = ACTIONS(3246),
    [sym_float_literal] = ACTIONS(3246),
    [sym_rune_literal] = ACTIONS(3246),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_DQUOTE] = ACTIONS(3246),
    [anon_sym_c_SQUOTE] = ACTIONS(3246),
    [anon_sym_c_DQUOTE] = ACTIONS(3246),
    [anon_sym_r_SQUOTE] = ACTIONS(3246),
    [anon_sym_r_DQUOTE] = ACTIONS(3246),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3246),
    [anon_sym_shared] = ACTIONS(3246),
    [anon_sym_map_LBRACK] = ACTIONS(3246),
    [anon_sym_chan] = ACTIONS(3246),
    [anon_sym_thread] = ACTIONS(3246),
    [anon_sym_atomic] = ACTIONS(3246),
    [anon_sym_assert] = ACTIONS(3246),
    [anon_sym_defer] = ACTIONS(3246),
    [anon_sym_goto] = ACTIONS(3246),
    [anon_sym_break] = ACTIONS(3246),
    [anon_sym_continue] = ACTIONS(3246),
    [anon_sym_return] = ACTIONS(3246),
    [anon_sym_DOLLARfor] = ACTIONS(3246),
    [anon_sym_for] = ACTIONS(3246),
    [anon_sym_POUND] = ACTIONS(3246),
    [anon_sym_asm] = ACTIONS(3246),
    [anon_sym_AT_LBRACK] = ACTIONS(3246),
  },
  [1222] = {
    [sym_line_comment] = STATE(1222),
    [sym_block_comment] = STATE(1222),
    [ts_builtin_sym_end] = ACTIONS(3025),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_LF] = ACTIONS(3027),
    [anon_sym_CR] = ACTIONS(3027),
    [anon_sym_CR_LF] = ACTIONS(3027),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3027),
    [anon_sym_as] = ACTIONS(3027),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_COMMA] = ACTIONS(3027),
    [anon_sym_const] = ACTIONS(3027),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym___global] = ACTIONS(3027),
    [anon_sym_type] = ACTIONS(3027),
    [anon_sym_fn] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_STAR] = ACTIONS(3027),
    [anon_sym_SLASH] = ACTIONS(3027),
    [anon_sym_PERCENT] = ACTIONS(3027),
    [anon_sym_LT] = ACTIONS(3027),
    [anon_sym_GT] = ACTIONS(3027),
    [anon_sym_EQ_EQ] = ACTIONS(3027),
    [anon_sym_BANG_EQ] = ACTIONS(3027),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3025),
    [anon_sym_struct] = ACTIONS(3027),
    [anon_sym_union] = ACTIONS(3027),
    [anon_sym_pub] = ACTIONS(3027),
    [anon_sym_mut] = ACTIONS(3027),
    [anon_sym_enum] = ACTIONS(3027),
    [anon_sym_interface] = ACTIONS(3027),
    [anon_sym_PLUS_PLUS] = ACTIONS(3027),
    [anon_sym_DASH_DASH] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_BANG] = ACTIONS(3027),
    [anon_sym_go] = ACTIONS(3027),
    [anon_sym_spawn] = ACTIONS(3027),
    [anon_sym_json_DOTdecode] = ACTIONS(3027),
    [anon_sym_PIPE] = ACTIONS(3027),
    [anon_sym_LBRACK2] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3027),
    [anon_sym_CARET] = ACTIONS(3027),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_LT_DASH] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3027),
    [anon_sym_GT_GT] = ACTIONS(3027),
    [anon_sym_GT_GT_GT] = ACTIONS(3027),
    [anon_sym_AMP_CARET] = ACTIONS(3027),
    [anon_sym_AMP_AMP] = ACTIONS(3027),
    [anon_sym_PIPE_PIPE] = ACTIONS(3027),
    [anon_sym_or] = ACTIONS(3027),
    [sym_none] = ACTIONS(3027),
    [sym_true] = ACTIONS(3027),
    [sym_false] = ACTIONS(3027),
    [sym_nil] = ACTIONS(3027),
    [anon_sym_QMARK_DOT] = ACTIONS(3027),
    [anon_sym_POUND_LBRACK] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_DOLLARif] = ACTIONS(3027),
    [anon_sym_is] = ACTIONS(3027),
    [anon_sym_BANGis] = ACTIONS(3027),
    [anon_sym_in] = ACTIONS(3027),
    [anon_sym_BANGin] = ACTIONS(3027),
    [anon_sym_match] = ACTIONS(3027),
    [anon_sym_select] = ACTIONS(3027),
    [anon_sym_lock] = ACTIONS(3027),
    [anon_sym_rlock] = ACTIONS(3027),
    [anon_sym_unsafe] = ACTIONS(3027),
    [anon_sym_sql] = ACTIONS(3027),
    [sym_int_literal] = ACTIONS(3027),
    [sym_float_literal] = ACTIONS(3027),
    [sym_rune_literal] = ACTIONS(3027),
    [anon_sym_SQUOTE] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_c_SQUOTE] = ACTIONS(3027),
    [anon_sym_c_DQUOTE] = ACTIONS(3027),
    [anon_sym_r_SQUOTE] = ACTIONS(3027),
    [anon_sym_r_DQUOTE] = ACTIONS(3027),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3027),
    [anon_sym_shared] = ACTIONS(3027),
    [anon_sym_map_LBRACK] = ACTIONS(3027),
    [anon_sym_chan] = ACTIONS(3027),
    [anon_sym_thread] = ACTIONS(3027),
    [anon_sym_atomic] = ACTIONS(3027),
    [anon_sym_assert] = ACTIONS(3027),
    [anon_sym_defer] = ACTIONS(3027),
    [anon_sym_goto] = ACTIONS(3027),
    [anon_sym_break] = ACTIONS(3027),
    [anon_sym_continue] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_DOLLARfor] = ACTIONS(3027),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_POUND] = ACTIONS(3027),
    [anon_sym_asm] = ACTIONS(3027),
    [anon_sym_AT_LBRACK] = ACTIONS(3027),
  },
  [1223] = {
    [sym_line_comment] = STATE(1223),
    [sym_block_comment] = STATE(1223),
    [ts_builtin_sym_end] = ACTIONS(2395),
    [sym_identifier] = ACTIONS(2397),
    [anon_sym_LF] = ACTIONS(2397),
    [anon_sym_CR] = ACTIONS(2397),
    [anon_sym_CR_LF] = ACTIONS(2397),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2397),
    [anon_sym_as] = ACTIONS(2397),
    [anon_sym_LBRACE] = ACTIONS(2397),
    [anon_sym_COMMA] = ACTIONS(2397),
    [anon_sym_const] = ACTIONS(2397),
    [anon_sym_LPAREN] = ACTIONS(2397),
    [anon_sym___global] = ACTIONS(2397),
    [anon_sym_type] = ACTIONS(2397),
    [anon_sym_fn] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(2397),
    [anon_sym_DASH] = ACTIONS(2397),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_SLASH] = ACTIONS(2397),
    [anon_sym_PERCENT] = ACTIONS(2397),
    [anon_sym_LT] = ACTIONS(2397),
    [anon_sym_GT] = ACTIONS(2397),
    [anon_sym_EQ_EQ] = ACTIONS(2397),
    [anon_sym_BANG_EQ] = ACTIONS(2397),
    [anon_sym_LT_EQ] = ACTIONS(2397),
    [anon_sym_GT_EQ] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(2395),
    [anon_sym_struct] = ACTIONS(2397),
    [anon_sym_union] = ACTIONS(2397),
    [anon_sym_pub] = ACTIONS(2397),
    [anon_sym_mut] = ACTIONS(2397),
    [anon_sym_enum] = ACTIONS(2397),
    [anon_sym_interface] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2397),
    [anon_sym_DASH_DASH] = ACTIONS(2397),
    [anon_sym_QMARK] = ACTIONS(2397),
    [anon_sym_BANG] = ACTIONS(2397),
    [anon_sym_go] = ACTIONS(2397),
    [anon_sym_spawn] = ACTIONS(2397),
    [anon_sym_json_DOTdecode] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(2397),
    [anon_sym_LBRACK2] = ACTIONS(2397),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_CARET] = ACTIONS(2397),
    [anon_sym_AMP] = ACTIONS(2397),
    [anon_sym_LT_DASH] = ACTIONS(2397),
    [anon_sym_LT_LT] = ACTIONS(2397),
    [anon_sym_GT_GT] = ACTIONS(2397),
    [anon_sym_GT_GT_GT] = ACTIONS(2397),
    [anon_sym_AMP_CARET] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(2397),
    [anon_sym_PIPE_PIPE] = ACTIONS(2397),
    [anon_sym_or] = ACTIONS(2397),
    [sym_none] = ACTIONS(2397),
    [sym_true] = ACTIONS(2397),
    [sym_false] = ACTIONS(2397),
    [sym_nil] = ACTIONS(2397),
    [anon_sym_QMARK_DOT] = ACTIONS(2397),
    [anon_sym_POUND_LBRACK] = ACTIONS(2397),
    [anon_sym_if] = ACTIONS(2397),
    [anon_sym_DOLLARif] = ACTIONS(2397),
    [anon_sym_is] = ACTIONS(2397),
    [anon_sym_BANGis] = ACTIONS(2397),
    [anon_sym_in] = ACTIONS(2397),
    [anon_sym_BANGin] = ACTIONS(2397),
    [anon_sym_match] = ACTIONS(2397),
    [anon_sym_select] = ACTIONS(2397),
    [anon_sym_lock] = ACTIONS(2397),
    [anon_sym_rlock] = ACTIONS(2397),
    [anon_sym_unsafe] = ACTIONS(2397),
    [anon_sym_sql] = ACTIONS(2397),
    [sym_int_literal] = ACTIONS(2397),
    [sym_float_literal] = ACTIONS(2397),
    [sym_rune_literal] = ACTIONS(2397),
    [anon_sym_SQUOTE] = ACTIONS(2397),
    [anon_sym_DQUOTE] = ACTIONS(2397),
    [anon_sym_c_SQUOTE] = ACTIONS(2397),
    [anon_sym_c_DQUOTE] = ACTIONS(2397),
    [anon_sym_r_SQUOTE] = ACTIONS(2397),
    [anon_sym_r_DQUOTE] = ACTIONS(2397),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2397),
    [anon_sym_shared] = ACTIONS(2397),
    [anon_sym_map_LBRACK] = ACTIONS(2397),
    [anon_sym_chan] = ACTIONS(2397),
    [anon_sym_thread] = ACTIONS(2397),
    [anon_sym_atomic] = ACTIONS(2397),
    [anon_sym_assert] = ACTIONS(2397),
    [anon_sym_defer] = ACTIONS(2397),
    [anon_sym_goto] = ACTIONS(2397),
    [anon_sym_break] = ACTIONS(2397),
    [anon_sym_continue] = ACTIONS(2397),
    [anon_sym_return] = ACTIONS(2397),
    [anon_sym_DOLLARfor] = ACTIONS(2397),
    [anon_sym_for] = ACTIONS(2397),
    [anon_sym_POUND] = ACTIONS(2397),
    [anon_sym_asm] = ACTIONS(2397),
    [anon_sym_AT_LBRACK] = ACTIONS(2397),
  },
  [1224] = {
    [sym_line_comment] = STATE(1224),
    [sym_block_comment] = STATE(1224),
    [ts_builtin_sym_end] = ACTIONS(3029),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_LF] = ACTIONS(3031),
    [anon_sym_CR] = ACTIONS(3031),
    [anon_sym_CR_LF] = ACTIONS(3031),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3031),
    [anon_sym_as] = ACTIONS(3031),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_COMMA] = ACTIONS(3031),
    [anon_sym_const] = ACTIONS(3031),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym___global] = ACTIONS(3031),
    [anon_sym_type] = ACTIONS(3031),
    [anon_sym_fn] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_STAR] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3031),
    [anon_sym_PERCENT] = ACTIONS(3031),
    [anon_sym_LT] = ACTIONS(3031),
    [anon_sym_GT] = ACTIONS(3031),
    [anon_sym_EQ_EQ] = ACTIONS(3031),
    [anon_sym_BANG_EQ] = ACTIONS(3031),
    [anon_sym_LT_EQ] = ACTIONS(3031),
    [anon_sym_GT_EQ] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3029),
    [anon_sym_struct] = ACTIONS(3031),
    [anon_sym_union] = ACTIONS(3031),
    [anon_sym_pub] = ACTIONS(3031),
    [anon_sym_mut] = ACTIONS(3031),
    [anon_sym_enum] = ACTIONS(3031),
    [anon_sym_interface] = ACTIONS(3031),
    [anon_sym_PLUS_PLUS] = ACTIONS(3031),
    [anon_sym_DASH_DASH] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_BANG] = ACTIONS(3031),
    [anon_sym_go] = ACTIONS(3031),
    [anon_sym_spawn] = ACTIONS(3031),
    [anon_sym_json_DOTdecode] = ACTIONS(3031),
    [anon_sym_PIPE] = ACTIONS(3031),
    [anon_sym_LBRACK2] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3031),
    [anon_sym_CARET] = ACTIONS(3031),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_LT_DASH] = ACTIONS(3031),
    [anon_sym_LT_LT] = ACTIONS(3031),
    [anon_sym_GT_GT] = ACTIONS(3031),
    [anon_sym_GT_GT_GT] = ACTIONS(3031),
    [anon_sym_AMP_CARET] = ACTIONS(3031),
    [anon_sym_AMP_AMP] = ACTIONS(3031),
    [anon_sym_PIPE_PIPE] = ACTIONS(3031),
    [anon_sym_or] = ACTIONS(3031),
    [sym_none] = ACTIONS(3031),
    [sym_true] = ACTIONS(3031),
    [sym_false] = ACTIONS(3031),
    [sym_nil] = ACTIONS(3031),
    [anon_sym_QMARK_DOT] = ACTIONS(3031),
    [anon_sym_POUND_LBRACK] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_DOLLARif] = ACTIONS(3031),
    [anon_sym_is] = ACTIONS(3031),
    [anon_sym_BANGis] = ACTIONS(3031),
    [anon_sym_in] = ACTIONS(3031),
    [anon_sym_BANGin] = ACTIONS(3031),
    [anon_sym_match] = ACTIONS(3031),
    [anon_sym_select] = ACTIONS(3031),
    [anon_sym_lock] = ACTIONS(3031),
    [anon_sym_rlock] = ACTIONS(3031),
    [anon_sym_unsafe] = ACTIONS(3031),
    [anon_sym_sql] = ACTIONS(3031),
    [sym_int_literal] = ACTIONS(3031),
    [sym_float_literal] = ACTIONS(3031),
    [sym_rune_literal] = ACTIONS(3031),
    [anon_sym_SQUOTE] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_c_SQUOTE] = ACTIONS(3031),
    [anon_sym_c_DQUOTE] = ACTIONS(3031),
    [anon_sym_r_SQUOTE] = ACTIONS(3031),
    [anon_sym_r_DQUOTE] = ACTIONS(3031),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3031),
    [anon_sym_shared] = ACTIONS(3031),
    [anon_sym_map_LBRACK] = ACTIONS(3031),
    [anon_sym_chan] = ACTIONS(3031),
    [anon_sym_thread] = ACTIONS(3031),
    [anon_sym_atomic] = ACTIONS(3031),
    [anon_sym_assert] = ACTIONS(3031),
    [anon_sym_defer] = ACTIONS(3031),
    [anon_sym_goto] = ACTIONS(3031),
    [anon_sym_break] = ACTIONS(3031),
    [anon_sym_continue] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_DOLLARfor] = ACTIONS(3031),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_POUND] = ACTIONS(3031),
    [anon_sym_asm] = ACTIONS(3031),
    [anon_sym_AT_LBRACK] = ACTIONS(3031),
  },
  [1225] = {
    [sym_line_comment] = STATE(1225),
    [sym_block_comment] = STATE(1225),
    [ts_builtin_sym_end] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2435),
    [anon_sym_LF] = ACTIONS(2435),
    [anon_sym_CR] = ACTIONS(2435),
    [anon_sym_CR_LF] = ACTIONS(2435),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2435),
    [anon_sym_as] = ACTIONS(2435),
    [anon_sym_LBRACE] = ACTIONS(2435),
    [anon_sym_COMMA] = ACTIONS(2435),
    [anon_sym_const] = ACTIONS(2435),
    [anon_sym_LPAREN] = ACTIONS(2435),
    [anon_sym___global] = ACTIONS(2435),
    [anon_sym_type] = ACTIONS(2435),
    [anon_sym_fn] = ACTIONS(2435),
    [anon_sym_PLUS] = ACTIONS(2435),
    [anon_sym_DASH] = ACTIONS(2435),
    [anon_sym_STAR] = ACTIONS(2435),
    [anon_sym_SLASH] = ACTIONS(2435),
    [anon_sym_PERCENT] = ACTIONS(2435),
    [anon_sym_LT] = ACTIONS(2435),
    [anon_sym_GT] = ACTIONS(2435),
    [anon_sym_EQ_EQ] = ACTIONS(2435),
    [anon_sym_BANG_EQ] = ACTIONS(2435),
    [anon_sym_LT_EQ] = ACTIONS(2435),
    [anon_sym_GT_EQ] = ACTIONS(2435),
    [anon_sym_LBRACK] = ACTIONS(2433),
    [anon_sym_struct] = ACTIONS(2435),
    [anon_sym_union] = ACTIONS(2435),
    [anon_sym_pub] = ACTIONS(2435),
    [anon_sym_mut] = ACTIONS(2435),
    [anon_sym_enum] = ACTIONS(2435),
    [anon_sym_interface] = ACTIONS(2435),
    [anon_sym_PLUS_PLUS] = ACTIONS(2435),
    [anon_sym_DASH_DASH] = ACTIONS(2435),
    [anon_sym_QMARK] = ACTIONS(2435),
    [anon_sym_BANG] = ACTIONS(2435),
    [anon_sym_go] = ACTIONS(2435),
    [anon_sym_spawn] = ACTIONS(2435),
    [anon_sym_json_DOTdecode] = ACTIONS(2435),
    [anon_sym_PIPE] = ACTIONS(2435),
    [anon_sym_LBRACK2] = ACTIONS(2435),
    [anon_sym_TILDE] = ACTIONS(2435),
    [anon_sym_CARET] = ACTIONS(2435),
    [anon_sym_AMP] = ACTIONS(2435),
    [anon_sym_LT_DASH] = ACTIONS(2435),
    [anon_sym_LT_LT] = ACTIONS(2435),
    [anon_sym_GT_GT] = ACTIONS(2435),
    [anon_sym_GT_GT_GT] = ACTIONS(2435),
    [anon_sym_AMP_CARET] = ACTIONS(2435),
    [anon_sym_AMP_AMP] = ACTIONS(2435),
    [anon_sym_PIPE_PIPE] = ACTIONS(2435),
    [anon_sym_or] = ACTIONS(2435),
    [sym_none] = ACTIONS(2435),
    [sym_true] = ACTIONS(2435),
    [sym_false] = ACTIONS(2435),
    [sym_nil] = ACTIONS(2435),
    [anon_sym_QMARK_DOT] = ACTIONS(2435),
    [anon_sym_POUND_LBRACK] = ACTIONS(2435),
    [anon_sym_if] = ACTIONS(2435),
    [anon_sym_DOLLARif] = ACTIONS(2435),
    [anon_sym_is] = ACTIONS(2435),
    [anon_sym_BANGis] = ACTIONS(2435),
    [anon_sym_in] = ACTIONS(2435),
    [anon_sym_BANGin] = ACTIONS(2435),
    [anon_sym_match] = ACTIONS(2435),
    [anon_sym_select] = ACTIONS(2435),
    [anon_sym_lock] = ACTIONS(2435),
    [anon_sym_rlock] = ACTIONS(2435),
    [anon_sym_unsafe] = ACTIONS(2435),
    [anon_sym_sql] = ACTIONS(2435),
    [sym_int_literal] = ACTIONS(2435),
    [sym_float_literal] = ACTIONS(2435),
    [sym_rune_literal] = ACTIONS(2435),
    [anon_sym_SQUOTE] = ACTIONS(2435),
    [anon_sym_DQUOTE] = ACTIONS(2435),
    [anon_sym_c_SQUOTE] = ACTIONS(2435),
    [anon_sym_c_DQUOTE] = ACTIONS(2435),
    [anon_sym_r_SQUOTE] = ACTIONS(2435),
    [anon_sym_r_DQUOTE] = ACTIONS(2435),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2435),
    [anon_sym_shared] = ACTIONS(2435),
    [anon_sym_map_LBRACK] = ACTIONS(2435),
    [anon_sym_chan] = ACTIONS(2435),
    [anon_sym_thread] = ACTIONS(2435),
    [anon_sym_atomic] = ACTIONS(2435),
    [anon_sym_assert] = ACTIONS(2435),
    [anon_sym_defer] = ACTIONS(2435),
    [anon_sym_goto] = ACTIONS(2435),
    [anon_sym_break] = ACTIONS(2435),
    [anon_sym_continue] = ACTIONS(2435),
    [anon_sym_return] = ACTIONS(2435),
    [anon_sym_DOLLARfor] = ACTIONS(2435),
    [anon_sym_for] = ACTIONS(2435),
    [anon_sym_POUND] = ACTIONS(2435),
    [anon_sym_asm] = ACTIONS(2435),
    [anon_sym_AT_LBRACK] = ACTIONS(2435),
  },
  [1226] = {
    [sym_line_comment] = STATE(1226),
    [sym_block_comment] = STATE(1226),
    [ts_builtin_sym_end] = ACTIONS(3039),
    [sym_identifier] = ACTIONS(3041),
    [anon_sym_LF] = ACTIONS(3041),
    [anon_sym_CR] = ACTIONS(3041),
    [anon_sym_CR_LF] = ACTIONS(3041),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3041),
    [anon_sym_as] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3041),
    [anon_sym_COMMA] = ACTIONS(3041),
    [anon_sym_const] = ACTIONS(3041),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym___global] = ACTIONS(3041),
    [anon_sym_type] = ACTIONS(3041),
    [anon_sym_fn] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3041),
    [anon_sym_DASH] = ACTIONS(3041),
    [anon_sym_STAR] = ACTIONS(3041),
    [anon_sym_SLASH] = ACTIONS(3041),
    [anon_sym_PERCENT] = ACTIONS(3041),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_GT] = ACTIONS(3041),
    [anon_sym_EQ_EQ] = ACTIONS(3041),
    [anon_sym_BANG_EQ] = ACTIONS(3041),
    [anon_sym_LT_EQ] = ACTIONS(3041),
    [anon_sym_GT_EQ] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_struct] = ACTIONS(3041),
    [anon_sym_union] = ACTIONS(3041),
    [anon_sym_pub] = ACTIONS(3041),
    [anon_sym_mut] = ACTIONS(3041),
    [anon_sym_enum] = ACTIONS(3041),
    [anon_sym_interface] = ACTIONS(3041),
    [anon_sym_PLUS_PLUS] = ACTIONS(3041),
    [anon_sym_DASH_DASH] = ACTIONS(3041),
    [anon_sym_QMARK] = ACTIONS(3041),
    [anon_sym_BANG] = ACTIONS(3041),
    [anon_sym_go] = ACTIONS(3041),
    [anon_sym_spawn] = ACTIONS(3041),
    [anon_sym_json_DOTdecode] = ACTIONS(3041),
    [anon_sym_PIPE] = ACTIONS(3041),
    [anon_sym_LBRACK2] = ACTIONS(3041),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_CARET] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3041),
    [anon_sym_LT_DASH] = ACTIONS(3041),
    [anon_sym_LT_LT] = ACTIONS(3041),
    [anon_sym_GT_GT] = ACTIONS(3041),
    [anon_sym_GT_GT_GT] = ACTIONS(3041),
    [anon_sym_AMP_CARET] = ACTIONS(3041),
    [anon_sym_AMP_AMP] = ACTIONS(3041),
    [anon_sym_PIPE_PIPE] = ACTIONS(3041),
    [anon_sym_or] = ACTIONS(3041),
    [sym_none] = ACTIONS(3041),
    [sym_true] = ACTIONS(3041),
    [sym_false] = ACTIONS(3041),
    [sym_nil] = ACTIONS(3041),
    [anon_sym_QMARK_DOT] = ACTIONS(3041),
    [anon_sym_POUND_LBRACK] = ACTIONS(3041),
    [anon_sym_if] = ACTIONS(3041),
    [anon_sym_DOLLARif] = ACTIONS(3041),
    [anon_sym_is] = ACTIONS(3041),
    [anon_sym_BANGis] = ACTIONS(3041),
    [anon_sym_in] = ACTIONS(3041),
    [anon_sym_BANGin] = ACTIONS(3041),
    [anon_sym_match] = ACTIONS(3041),
    [anon_sym_select] = ACTIONS(3041),
    [anon_sym_lock] = ACTIONS(3041),
    [anon_sym_rlock] = ACTIONS(3041),
    [anon_sym_unsafe] = ACTIONS(3041),
    [anon_sym_sql] = ACTIONS(3041),
    [sym_int_literal] = ACTIONS(3041),
    [sym_float_literal] = ACTIONS(3041),
    [sym_rune_literal] = ACTIONS(3041),
    [anon_sym_SQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE] = ACTIONS(3041),
    [anon_sym_c_SQUOTE] = ACTIONS(3041),
    [anon_sym_c_DQUOTE] = ACTIONS(3041),
    [anon_sym_r_SQUOTE] = ACTIONS(3041),
    [anon_sym_r_DQUOTE] = ACTIONS(3041),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3041),
    [anon_sym_shared] = ACTIONS(3041),
    [anon_sym_map_LBRACK] = ACTIONS(3041),
    [anon_sym_chan] = ACTIONS(3041),
    [anon_sym_thread] = ACTIONS(3041),
    [anon_sym_atomic] = ACTIONS(3041),
    [anon_sym_assert] = ACTIONS(3041),
    [anon_sym_defer] = ACTIONS(3041),
    [anon_sym_goto] = ACTIONS(3041),
    [anon_sym_break] = ACTIONS(3041),
    [anon_sym_continue] = ACTIONS(3041),
    [anon_sym_return] = ACTIONS(3041),
    [anon_sym_DOLLARfor] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3041),
    [anon_sym_POUND] = ACTIONS(3041),
    [anon_sym_asm] = ACTIONS(3041),
    [anon_sym_AT_LBRACK] = ACTIONS(3041),
  },
  [1227] = {
    [sym_line_comment] = STATE(1227),
    [sym_block_comment] = STATE(1227),
    [ts_builtin_sym_end] = ACTIONS(2469),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LF] = ACTIONS(2471),
    [anon_sym_CR] = ACTIONS(2471),
    [anon_sym_CR_LF] = ACTIONS(2471),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2471),
    [anon_sym_as] = ACTIONS(2471),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_COMMA] = ACTIONS(2471),
    [anon_sym_const] = ACTIONS(2471),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym___global] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2471),
    [anon_sym_fn] = ACTIONS(2471),
    [anon_sym_PLUS] = ACTIONS(2471),
    [anon_sym_DASH] = ACTIONS(2471),
    [anon_sym_STAR] = ACTIONS(2471),
    [anon_sym_SLASH] = ACTIONS(2471),
    [anon_sym_PERCENT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2471),
    [anon_sym_GT] = ACTIONS(2471),
    [anon_sym_EQ_EQ] = ACTIONS(2471),
    [anon_sym_BANG_EQ] = ACTIONS(2471),
    [anon_sym_LT_EQ] = ACTIONS(2471),
    [anon_sym_GT_EQ] = ACTIONS(2471),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_struct] = ACTIONS(2471),
    [anon_sym_union] = ACTIONS(2471),
    [anon_sym_pub] = ACTIONS(2471),
    [anon_sym_mut] = ACTIONS(2471),
    [anon_sym_enum] = ACTIONS(2471),
    [anon_sym_interface] = ACTIONS(2471),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_go] = ACTIONS(2471),
    [anon_sym_spawn] = ACTIONS(2471),
    [anon_sym_json_DOTdecode] = ACTIONS(2471),
    [anon_sym_PIPE] = ACTIONS(2471),
    [anon_sym_LBRACK2] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_CARET] = ACTIONS(2471),
    [anon_sym_AMP] = ACTIONS(2471),
    [anon_sym_LT_DASH] = ACTIONS(2471),
    [anon_sym_LT_LT] = ACTIONS(2471),
    [anon_sym_GT_GT] = ACTIONS(2471),
    [anon_sym_GT_GT_GT] = ACTIONS(2471),
    [anon_sym_AMP_CARET] = ACTIONS(2471),
    [anon_sym_AMP_AMP] = ACTIONS(2471),
    [anon_sym_PIPE_PIPE] = ACTIONS(2471),
    [anon_sym_or] = ACTIONS(2471),
    [sym_none] = ACTIONS(2471),
    [sym_true] = ACTIONS(2471),
    [sym_false] = ACTIONS(2471),
    [sym_nil] = ACTIONS(2471),
    [anon_sym_QMARK_DOT] = ACTIONS(2471),
    [anon_sym_POUND_LBRACK] = ACTIONS(2471),
    [anon_sym_if] = ACTIONS(2471),
    [anon_sym_DOLLARif] = ACTIONS(2471),
    [anon_sym_is] = ACTIONS(2471),
    [anon_sym_BANGis] = ACTIONS(2471),
    [anon_sym_in] = ACTIONS(2471),
    [anon_sym_BANGin] = ACTIONS(2471),
    [anon_sym_match] = ACTIONS(2471),
    [anon_sym_select] = ACTIONS(2471),
    [anon_sym_lock] = ACTIONS(2471),
    [anon_sym_rlock] = ACTIONS(2471),
    [anon_sym_unsafe] = ACTIONS(2471),
    [anon_sym_sql] = ACTIONS(2471),
    [sym_int_literal] = ACTIONS(2471),
    [sym_float_literal] = ACTIONS(2471),
    [sym_rune_literal] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_c_SQUOTE] = ACTIONS(2471),
    [anon_sym_c_DQUOTE] = ACTIONS(2471),
    [anon_sym_r_SQUOTE] = ACTIONS(2471),
    [anon_sym_r_DQUOTE] = ACTIONS(2471),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2471),
    [anon_sym_shared] = ACTIONS(2471),
    [anon_sym_map_LBRACK] = ACTIONS(2471),
    [anon_sym_chan] = ACTIONS(2471),
    [anon_sym_thread] = ACTIONS(2471),
    [anon_sym_atomic] = ACTIONS(2471),
    [anon_sym_assert] = ACTIONS(2471),
    [anon_sym_defer] = ACTIONS(2471),
    [anon_sym_goto] = ACTIONS(2471),
    [anon_sym_break] = ACTIONS(2471),
    [anon_sym_continue] = ACTIONS(2471),
    [anon_sym_return] = ACTIONS(2471),
    [anon_sym_DOLLARfor] = ACTIONS(2471),
    [anon_sym_for] = ACTIONS(2471),
    [anon_sym_POUND] = ACTIONS(2471),
    [anon_sym_asm] = ACTIONS(2471),
    [anon_sym_AT_LBRACK] = ACTIONS(2471),
  },
  [1228] = {
    [sym_line_comment] = STATE(1228),
    [sym_block_comment] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2655),
    [anon_sym_LF] = ACTIONS(2655),
    [anon_sym_CR] = ACTIONS(2655),
    [anon_sym_CR_LF] = ACTIONS(2655),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2655),
    [anon_sym_as] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2655),
    [anon_sym_COMMA] = ACTIONS(2655),
    [anon_sym_const] = ACTIONS(2655),
    [anon_sym_LPAREN] = ACTIONS(2655),
    [anon_sym___global] = ACTIONS(2655),
    [anon_sym_type] = ACTIONS(2655),
    [anon_sym_fn] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_DASH] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_SLASH] = ACTIONS(2655),
    [anon_sym_PERCENT] = ACTIONS(2655),
    [anon_sym_LT] = ACTIONS(2655),
    [anon_sym_GT] = ACTIONS(2655),
    [anon_sym_EQ_EQ] = ACTIONS(2655),
    [anon_sym_BANG_EQ] = ACTIONS(2655),
    [anon_sym_LT_EQ] = ACTIONS(2655),
    [anon_sym_GT_EQ] = ACTIONS(2655),
    [anon_sym_LBRACK] = ACTIONS(2653),
    [anon_sym_struct] = ACTIONS(2655),
    [anon_sym_union] = ACTIONS(2655),
    [anon_sym_pub] = ACTIONS(2655),
    [anon_sym_mut] = ACTIONS(2655),
    [anon_sym_enum] = ACTIONS(2655),
    [anon_sym_interface] = ACTIONS(2655),
    [anon_sym_PLUS_PLUS] = ACTIONS(2655),
    [anon_sym_DASH_DASH] = ACTIONS(2655),
    [anon_sym_QMARK] = ACTIONS(2655),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_go] = ACTIONS(2655),
    [anon_sym_spawn] = ACTIONS(2655),
    [anon_sym_json_DOTdecode] = ACTIONS(2655),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_LBRACK2] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [anon_sym_CARET] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2655),
    [anon_sym_LT_DASH] = ACTIONS(2655),
    [anon_sym_LT_LT] = ACTIONS(2655),
    [anon_sym_GT_GT] = ACTIONS(2655),
    [anon_sym_GT_GT_GT] = ACTIONS(2655),
    [anon_sym_AMP_CARET] = ACTIONS(2655),
    [anon_sym_AMP_AMP] = ACTIONS(2655),
    [anon_sym_PIPE_PIPE] = ACTIONS(2655),
    [anon_sym_or] = ACTIONS(2655),
    [sym_none] = ACTIONS(2655),
    [sym_true] = ACTIONS(2655),
    [sym_false] = ACTIONS(2655),
    [sym_nil] = ACTIONS(2655),
    [anon_sym_QMARK_DOT] = ACTIONS(2655),
    [anon_sym_POUND_LBRACK] = ACTIONS(2655),
    [anon_sym_if] = ACTIONS(2655),
    [anon_sym_DOLLARif] = ACTIONS(2655),
    [anon_sym_is] = ACTIONS(2655),
    [anon_sym_BANGis] = ACTIONS(2655),
    [anon_sym_in] = ACTIONS(2655),
    [anon_sym_BANGin] = ACTIONS(2655),
    [anon_sym_match] = ACTIONS(2655),
    [anon_sym_select] = ACTIONS(2655),
    [anon_sym_lock] = ACTIONS(2655),
    [anon_sym_rlock] = ACTIONS(2655),
    [anon_sym_unsafe] = ACTIONS(2655),
    [anon_sym_sql] = ACTIONS(2655),
    [sym_int_literal] = ACTIONS(2655),
    [sym_float_literal] = ACTIONS(2655),
    [sym_rune_literal] = ACTIONS(2655),
    [anon_sym_SQUOTE] = ACTIONS(2655),
    [anon_sym_DQUOTE] = ACTIONS(2655),
    [anon_sym_c_SQUOTE] = ACTIONS(2655),
    [anon_sym_c_DQUOTE] = ACTIONS(2655),
    [anon_sym_r_SQUOTE] = ACTIONS(2655),
    [anon_sym_r_DQUOTE] = ACTIONS(2655),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2655),
    [anon_sym_shared] = ACTIONS(2655),
    [anon_sym_map_LBRACK] = ACTIONS(2655),
    [anon_sym_chan] = ACTIONS(2655),
    [anon_sym_thread] = ACTIONS(2655),
    [anon_sym_atomic] = ACTIONS(2655),
    [anon_sym_assert] = ACTIONS(2655),
    [anon_sym_defer] = ACTIONS(2655),
    [anon_sym_goto] = ACTIONS(2655),
    [anon_sym_break] = ACTIONS(2655),
    [anon_sym_continue] = ACTIONS(2655),
    [anon_sym_return] = ACTIONS(2655),
    [anon_sym_DOLLARfor] = ACTIONS(2655),
    [anon_sym_for] = ACTIONS(2655),
    [anon_sym_POUND] = ACTIONS(2655),
    [anon_sym_asm] = ACTIONS(2655),
    [anon_sym_AT_LBRACK] = ACTIONS(2655),
  },
  [1229] = {
    [sym_line_comment] = STATE(1229),
    [sym_block_comment] = STATE(1229),
    [ts_builtin_sym_end] = ACTIONS(2657),
    [sym_identifier] = ACTIONS(2659),
    [anon_sym_LF] = ACTIONS(2659),
    [anon_sym_CR] = ACTIONS(2659),
    [anon_sym_CR_LF] = ACTIONS(2659),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2659),
    [anon_sym_as] = ACTIONS(2659),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_COMMA] = ACTIONS(2659),
    [anon_sym_const] = ACTIONS(2659),
    [anon_sym_LPAREN] = ACTIONS(2659),
    [anon_sym___global] = ACTIONS(2659),
    [anon_sym_type] = ACTIONS(2659),
    [anon_sym_fn] = ACTIONS(2659),
    [anon_sym_PLUS] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_SLASH] = ACTIONS(2659),
    [anon_sym_PERCENT] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(2659),
    [anon_sym_GT] = ACTIONS(2659),
    [anon_sym_EQ_EQ] = ACTIONS(2659),
    [anon_sym_BANG_EQ] = ACTIONS(2659),
    [anon_sym_LT_EQ] = ACTIONS(2659),
    [anon_sym_GT_EQ] = ACTIONS(2659),
    [anon_sym_LBRACK] = ACTIONS(2657),
    [anon_sym_struct] = ACTIONS(2659),
    [anon_sym_union] = ACTIONS(2659),
    [anon_sym_pub] = ACTIONS(2659),
    [anon_sym_mut] = ACTIONS(2659),
    [anon_sym_enum] = ACTIONS(2659),
    [anon_sym_interface] = ACTIONS(2659),
    [anon_sym_PLUS_PLUS] = ACTIONS(2659),
    [anon_sym_DASH_DASH] = ACTIONS(2659),
    [anon_sym_QMARK] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_go] = ACTIONS(2659),
    [anon_sym_spawn] = ACTIONS(2659),
    [anon_sym_json_DOTdecode] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(2659),
    [anon_sym_LBRACK2] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_CARET] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2659),
    [anon_sym_LT_DASH] = ACTIONS(2659),
    [anon_sym_LT_LT] = ACTIONS(2659),
    [anon_sym_GT_GT] = ACTIONS(2659),
    [anon_sym_GT_GT_GT] = ACTIONS(2659),
    [anon_sym_AMP_CARET] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_PIPE_PIPE] = ACTIONS(2659),
    [anon_sym_or] = ACTIONS(2659),
    [sym_none] = ACTIONS(2659),
    [sym_true] = ACTIONS(2659),
    [sym_false] = ACTIONS(2659),
    [sym_nil] = ACTIONS(2659),
    [anon_sym_QMARK_DOT] = ACTIONS(2659),
    [anon_sym_POUND_LBRACK] = ACTIONS(2659),
    [anon_sym_if] = ACTIONS(2659),
    [anon_sym_DOLLARif] = ACTIONS(2659),
    [anon_sym_is] = ACTIONS(2659),
    [anon_sym_BANGis] = ACTIONS(2659),
    [anon_sym_in] = ACTIONS(2659),
    [anon_sym_BANGin] = ACTIONS(2659),
    [anon_sym_match] = ACTIONS(2659),
    [anon_sym_select] = ACTIONS(2659),
    [anon_sym_lock] = ACTIONS(2659),
    [anon_sym_rlock] = ACTIONS(2659),
    [anon_sym_unsafe] = ACTIONS(2659),
    [anon_sym_sql] = ACTIONS(2659),
    [sym_int_literal] = ACTIONS(2659),
    [sym_float_literal] = ACTIONS(2659),
    [sym_rune_literal] = ACTIONS(2659),
    [anon_sym_SQUOTE] = ACTIONS(2659),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [anon_sym_c_SQUOTE] = ACTIONS(2659),
    [anon_sym_c_DQUOTE] = ACTIONS(2659),
    [anon_sym_r_SQUOTE] = ACTIONS(2659),
    [anon_sym_r_DQUOTE] = ACTIONS(2659),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2659),
    [anon_sym_shared] = ACTIONS(2659),
    [anon_sym_map_LBRACK] = ACTIONS(2659),
    [anon_sym_chan] = ACTIONS(2659),
    [anon_sym_thread] = ACTIONS(2659),
    [anon_sym_atomic] = ACTIONS(2659),
    [anon_sym_assert] = ACTIONS(2659),
    [anon_sym_defer] = ACTIONS(2659),
    [anon_sym_goto] = ACTIONS(2659),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_continue] = ACTIONS(2659),
    [anon_sym_return] = ACTIONS(2659),
    [anon_sym_DOLLARfor] = ACTIONS(2659),
    [anon_sym_for] = ACTIONS(2659),
    [anon_sym_POUND] = ACTIONS(2659),
    [anon_sym_asm] = ACTIONS(2659),
    [anon_sym_AT_LBRACK] = ACTIONS(2659),
  },
  [1230] = {
    [sym_line_comment] = STATE(1230),
    [sym_block_comment] = STATE(1230),
    [ts_builtin_sym_end] = ACTIONS(2817),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_LF] = ACTIONS(2819),
    [anon_sym_CR] = ACTIONS(2819),
    [anon_sym_CR_LF] = ACTIONS(2819),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2819),
    [anon_sym_as] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2819),
    [anon_sym_const] = ACTIONS(2819),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym___global] = ACTIONS(2819),
    [anon_sym_type] = ACTIONS(2819),
    [anon_sym_fn] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_LT] = ACTIONS(2819),
    [anon_sym_GT] = ACTIONS(2819),
    [anon_sym_EQ_EQ] = ACTIONS(2819),
    [anon_sym_BANG_EQ] = ACTIONS(2819),
    [anon_sym_LT_EQ] = ACTIONS(2819),
    [anon_sym_GT_EQ] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2817),
    [anon_sym_struct] = ACTIONS(2819),
    [anon_sym_union] = ACTIONS(2819),
    [anon_sym_pub] = ACTIONS(2819),
    [anon_sym_mut] = ACTIONS(2819),
    [anon_sym_enum] = ACTIONS(2819),
    [anon_sym_interface] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2819),
    [anon_sym_DASH_DASH] = ACTIONS(2819),
    [anon_sym_QMARK] = ACTIONS(2819),
    [anon_sym_BANG] = ACTIONS(2819),
    [anon_sym_go] = ACTIONS(2819),
    [anon_sym_spawn] = ACTIONS(2819),
    [anon_sym_json_DOTdecode] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(2819),
    [anon_sym_LBRACK2] = ACTIONS(2819),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_CARET] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_LT_DASH] = ACTIONS(2819),
    [anon_sym_LT_LT] = ACTIONS(2819),
    [anon_sym_GT_GT] = ACTIONS(2819),
    [anon_sym_GT_GT_GT] = ACTIONS(2819),
    [anon_sym_AMP_CARET] = ACTIONS(2819),
    [anon_sym_AMP_AMP] = ACTIONS(2819),
    [anon_sym_PIPE_PIPE] = ACTIONS(2819),
    [anon_sym_or] = ACTIONS(2819),
    [sym_none] = ACTIONS(2819),
    [sym_true] = ACTIONS(2819),
    [sym_false] = ACTIONS(2819),
    [sym_nil] = ACTIONS(2819),
    [anon_sym_QMARK_DOT] = ACTIONS(2819),
    [anon_sym_POUND_LBRACK] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_DOLLARif] = ACTIONS(2819),
    [anon_sym_is] = ACTIONS(2819),
    [anon_sym_BANGis] = ACTIONS(2819),
    [anon_sym_in] = ACTIONS(2819),
    [anon_sym_BANGin] = ACTIONS(2819),
    [anon_sym_match] = ACTIONS(2819),
    [anon_sym_select] = ACTIONS(2819),
    [anon_sym_lock] = ACTIONS(2819),
    [anon_sym_rlock] = ACTIONS(2819),
    [anon_sym_unsafe] = ACTIONS(2819),
    [anon_sym_sql] = ACTIONS(2819),
    [sym_int_literal] = ACTIONS(2819),
    [sym_float_literal] = ACTIONS(2819),
    [sym_rune_literal] = ACTIONS(2819),
    [anon_sym_SQUOTE] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2819),
    [anon_sym_c_SQUOTE] = ACTIONS(2819),
    [anon_sym_c_DQUOTE] = ACTIONS(2819),
    [anon_sym_r_SQUOTE] = ACTIONS(2819),
    [anon_sym_r_DQUOTE] = ACTIONS(2819),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2819),
    [anon_sym_shared] = ACTIONS(2819),
    [anon_sym_map_LBRACK] = ACTIONS(2819),
    [anon_sym_chan] = ACTIONS(2819),
    [anon_sym_thread] = ACTIONS(2819),
    [anon_sym_atomic] = ACTIONS(2819),
    [anon_sym_assert] = ACTIONS(2819),
    [anon_sym_defer] = ACTIONS(2819),
    [anon_sym_goto] = ACTIONS(2819),
    [anon_sym_break] = ACTIONS(2819),
    [anon_sym_continue] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_DOLLARfor] = ACTIONS(2819),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_POUND] = ACTIONS(2819),
    [anon_sym_asm] = ACTIONS(2819),
    [anon_sym_AT_LBRACK] = ACTIONS(2819),
  },
  [1231] = {
    [sym_line_comment] = STATE(1231),
    [sym_block_comment] = STATE(1231),
    [ts_builtin_sym_end] = ACTIONS(2821),
    [sym_identifier] = ACTIONS(2823),
    [anon_sym_LF] = ACTIONS(2823),
    [anon_sym_CR] = ACTIONS(2823),
    [anon_sym_CR_LF] = ACTIONS(2823),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2823),
    [anon_sym_as] = ACTIONS(2823),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_COMMA] = ACTIONS(2823),
    [anon_sym_const] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym___global] = ACTIONS(2823),
    [anon_sym_type] = ACTIONS(2823),
    [anon_sym_fn] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2823),
    [anon_sym_DASH] = ACTIONS(2823),
    [anon_sym_STAR] = ACTIONS(2823),
    [anon_sym_SLASH] = ACTIONS(2823),
    [anon_sym_PERCENT] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2823),
    [anon_sym_GT] = ACTIONS(2823),
    [anon_sym_EQ_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_EQ] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(2821),
    [anon_sym_struct] = ACTIONS(2823),
    [anon_sym_union] = ACTIONS(2823),
    [anon_sym_pub] = ACTIONS(2823),
    [anon_sym_mut] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2823),
    [anon_sym_interface] = ACTIONS(2823),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_QMARK] = ACTIONS(2823),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_go] = ACTIONS(2823),
    [anon_sym_spawn] = ACTIONS(2823),
    [anon_sym_json_DOTdecode] = ACTIONS(2823),
    [anon_sym_PIPE] = ACTIONS(2823),
    [anon_sym_LBRACK2] = ACTIONS(2823),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_CARET] = ACTIONS(2823),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_LT_DASH] = ACTIONS(2823),
    [anon_sym_LT_LT] = ACTIONS(2823),
    [anon_sym_GT_GT] = ACTIONS(2823),
    [anon_sym_GT_GT_GT] = ACTIONS(2823),
    [anon_sym_AMP_CARET] = ACTIONS(2823),
    [anon_sym_AMP_AMP] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2823),
    [anon_sym_or] = ACTIONS(2823),
    [sym_none] = ACTIONS(2823),
    [sym_true] = ACTIONS(2823),
    [sym_false] = ACTIONS(2823),
    [sym_nil] = ACTIONS(2823),
    [anon_sym_QMARK_DOT] = ACTIONS(2823),
    [anon_sym_POUND_LBRACK] = ACTIONS(2823),
    [anon_sym_if] = ACTIONS(2823),
    [anon_sym_DOLLARif] = ACTIONS(2823),
    [anon_sym_is] = ACTIONS(2823),
    [anon_sym_BANGis] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(2823),
    [anon_sym_BANGin] = ACTIONS(2823),
    [anon_sym_match] = ACTIONS(2823),
    [anon_sym_select] = ACTIONS(2823),
    [anon_sym_lock] = ACTIONS(2823),
    [anon_sym_rlock] = ACTIONS(2823),
    [anon_sym_unsafe] = ACTIONS(2823),
    [anon_sym_sql] = ACTIONS(2823),
    [sym_int_literal] = ACTIONS(2823),
    [sym_float_literal] = ACTIONS(2823),
    [sym_rune_literal] = ACTIONS(2823),
    [anon_sym_SQUOTE] = ACTIONS(2823),
    [anon_sym_DQUOTE] = ACTIONS(2823),
    [anon_sym_c_SQUOTE] = ACTIONS(2823),
    [anon_sym_c_DQUOTE] = ACTIONS(2823),
    [anon_sym_r_SQUOTE] = ACTIONS(2823),
    [anon_sym_r_DQUOTE] = ACTIONS(2823),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2823),
    [anon_sym_shared] = ACTIONS(2823),
    [anon_sym_map_LBRACK] = ACTIONS(2823),
    [anon_sym_chan] = ACTIONS(2823),
    [anon_sym_thread] = ACTIONS(2823),
    [anon_sym_atomic] = ACTIONS(2823),
    [anon_sym_assert] = ACTIONS(2823),
    [anon_sym_defer] = ACTIONS(2823),
    [anon_sym_goto] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2823),
    [anon_sym_continue] = ACTIONS(2823),
    [anon_sym_return] = ACTIONS(2823),
    [anon_sym_DOLLARfor] = ACTIONS(2823),
    [anon_sym_for] = ACTIONS(2823),
    [anon_sym_POUND] = ACTIONS(2823),
    [anon_sym_asm] = ACTIONS(2823),
    [anon_sym_AT_LBRACK] = ACTIONS(2823),
  },
  [1232] = {
    [sym_line_comment] = STATE(1232),
    [sym_block_comment] = STATE(1232),
    [ts_builtin_sym_end] = ACTIONS(2827),
    [sym_identifier] = ACTIONS(2829),
    [anon_sym_LF] = ACTIONS(2829),
    [anon_sym_CR] = ACTIONS(2829),
    [anon_sym_CR_LF] = ACTIONS(2829),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2829),
    [anon_sym_as] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_const] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym___global] = ACTIONS(2829),
    [anon_sym_type] = ACTIONS(2829),
    [anon_sym_fn] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(2829),
    [anon_sym_SLASH] = ACTIONS(2829),
    [anon_sym_PERCENT] = ACTIONS(2829),
    [anon_sym_LT] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2829),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LBRACK] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2829),
    [anon_sym_pub] = ACTIONS(2829),
    [anon_sym_mut] = ACTIONS(2829),
    [anon_sym_enum] = ACTIONS(2829),
    [anon_sym_interface] = ACTIONS(2829),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_QMARK] = ACTIONS(2829),
    [anon_sym_BANG] = ACTIONS(2829),
    [anon_sym_go] = ACTIONS(2829),
    [anon_sym_spawn] = ACTIONS(2829),
    [anon_sym_json_DOTdecode] = ACTIONS(2829),
    [anon_sym_PIPE] = ACTIONS(2829),
    [anon_sym_LBRACK2] = ACTIONS(2829),
    [anon_sym_TILDE] = ACTIONS(2829),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_AMP] = ACTIONS(2829),
    [anon_sym_LT_DASH] = ACTIONS(2829),
    [anon_sym_LT_LT] = ACTIONS(2829),
    [anon_sym_GT_GT] = ACTIONS(2829),
    [anon_sym_GT_GT_GT] = ACTIONS(2829),
    [anon_sym_AMP_CARET] = ACTIONS(2829),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_or] = ACTIONS(2829),
    [sym_none] = ACTIONS(2829),
    [sym_true] = ACTIONS(2829),
    [sym_false] = ACTIONS(2829),
    [sym_nil] = ACTIONS(2829),
    [anon_sym_QMARK_DOT] = ACTIONS(2829),
    [anon_sym_POUND_LBRACK] = ACTIONS(2829),
    [anon_sym_if] = ACTIONS(2829),
    [anon_sym_DOLLARif] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2829),
    [anon_sym_BANGis] = ACTIONS(2829),
    [anon_sym_in] = ACTIONS(2829),
    [anon_sym_BANGin] = ACTIONS(2829),
    [anon_sym_match] = ACTIONS(2829),
    [anon_sym_select] = ACTIONS(2829),
    [anon_sym_lock] = ACTIONS(2829),
    [anon_sym_rlock] = ACTIONS(2829),
    [anon_sym_unsafe] = ACTIONS(2829),
    [anon_sym_sql] = ACTIONS(2829),
    [sym_int_literal] = ACTIONS(2829),
    [sym_float_literal] = ACTIONS(2829),
    [sym_rune_literal] = ACTIONS(2829),
    [anon_sym_SQUOTE] = ACTIONS(2829),
    [anon_sym_DQUOTE] = ACTIONS(2829),
    [anon_sym_c_SQUOTE] = ACTIONS(2829),
    [anon_sym_c_DQUOTE] = ACTIONS(2829),
    [anon_sym_r_SQUOTE] = ACTIONS(2829),
    [anon_sym_r_DQUOTE] = ACTIONS(2829),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2829),
    [anon_sym_shared] = ACTIONS(2829),
    [anon_sym_map_LBRACK] = ACTIONS(2829),
    [anon_sym_chan] = ACTIONS(2829),
    [anon_sym_thread] = ACTIONS(2829),
    [anon_sym_atomic] = ACTIONS(2829),
    [anon_sym_assert] = ACTIONS(2829),
    [anon_sym_defer] = ACTIONS(2829),
    [anon_sym_goto] = ACTIONS(2829),
    [anon_sym_break] = ACTIONS(2829),
    [anon_sym_continue] = ACTIONS(2829),
    [anon_sym_return] = ACTIONS(2829),
    [anon_sym_DOLLARfor] = ACTIONS(2829),
    [anon_sym_for] = ACTIONS(2829),
    [anon_sym_POUND] = ACTIONS(2829),
    [anon_sym_asm] = ACTIONS(2829),
    [anon_sym_AT_LBRACK] = ACTIONS(2829),
  },
  [1233] = {
    [sym_line_comment] = STATE(1233),
    [sym_block_comment] = STATE(1233),
    [ts_builtin_sym_end] = ACTIONS(2831),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_LF] = ACTIONS(2833),
    [anon_sym_CR] = ACTIONS(2833),
    [anon_sym_CR_LF] = ACTIONS(2833),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2833),
    [anon_sym_as] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_const] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2833),
    [anon_sym___global] = ACTIONS(2833),
    [anon_sym_type] = ACTIONS(2833),
    [anon_sym_fn] = ACTIONS(2833),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(2833),
    [anon_sym_SLASH] = ACTIONS(2833),
    [anon_sym_PERCENT] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(2833),
    [anon_sym_EQ_EQ] = ACTIONS(2833),
    [anon_sym_BANG_EQ] = ACTIONS(2833),
    [anon_sym_LT_EQ] = ACTIONS(2833),
    [anon_sym_GT_EQ] = ACTIONS(2833),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_struct] = ACTIONS(2833),
    [anon_sym_union] = ACTIONS(2833),
    [anon_sym_pub] = ACTIONS(2833),
    [anon_sym_mut] = ACTIONS(2833),
    [anon_sym_enum] = ACTIONS(2833),
    [anon_sym_interface] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_QMARK] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_go] = ACTIONS(2833),
    [anon_sym_spawn] = ACTIONS(2833),
    [anon_sym_json_DOTdecode] = ACTIONS(2833),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_LBRACK2] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2833),
    [anon_sym_CARET] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2833),
    [anon_sym_LT_DASH] = ACTIONS(2833),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_GT] = ACTIONS(2833),
    [anon_sym_AMP_CARET] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2833),
    [anon_sym_or] = ACTIONS(2833),
    [sym_none] = ACTIONS(2833),
    [sym_true] = ACTIONS(2833),
    [sym_false] = ACTIONS(2833),
    [sym_nil] = ACTIONS(2833),
    [anon_sym_QMARK_DOT] = ACTIONS(2833),
    [anon_sym_POUND_LBRACK] = ACTIONS(2833),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_DOLLARif] = ACTIONS(2833),
    [anon_sym_is] = ACTIONS(2833),
    [anon_sym_BANGis] = ACTIONS(2833),
    [anon_sym_in] = ACTIONS(2833),
    [anon_sym_BANGin] = ACTIONS(2833),
    [anon_sym_match] = ACTIONS(2833),
    [anon_sym_select] = ACTIONS(2833),
    [anon_sym_lock] = ACTIONS(2833),
    [anon_sym_rlock] = ACTIONS(2833),
    [anon_sym_unsafe] = ACTIONS(2833),
    [anon_sym_sql] = ACTIONS(2833),
    [sym_int_literal] = ACTIONS(2833),
    [sym_float_literal] = ACTIONS(2833),
    [sym_rune_literal] = ACTIONS(2833),
    [anon_sym_SQUOTE] = ACTIONS(2833),
    [anon_sym_DQUOTE] = ACTIONS(2833),
    [anon_sym_c_SQUOTE] = ACTIONS(2833),
    [anon_sym_c_DQUOTE] = ACTIONS(2833),
    [anon_sym_r_SQUOTE] = ACTIONS(2833),
    [anon_sym_r_DQUOTE] = ACTIONS(2833),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2833),
    [anon_sym_shared] = ACTIONS(2833),
    [anon_sym_map_LBRACK] = ACTIONS(2833),
    [anon_sym_chan] = ACTIONS(2833),
    [anon_sym_thread] = ACTIONS(2833),
    [anon_sym_atomic] = ACTIONS(2833),
    [anon_sym_assert] = ACTIONS(2833),
    [anon_sym_defer] = ACTIONS(2833),
    [anon_sym_goto] = ACTIONS(2833),
    [anon_sym_break] = ACTIONS(2833),
    [anon_sym_continue] = ACTIONS(2833),
    [anon_sym_return] = ACTIONS(2833),
    [anon_sym_DOLLARfor] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2833),
    [anon_sym_POUND] = ACTIONS(2833),
    [anon_sym_asm] = ACTIONS(2833),
    [anon_sym_AT_LBRACK] = ACTIONS(2833),
  },
  [1234] = {
    [sym_line_comment] = STATE(1234),
    [sym_block_comment] = STATE(1234),
    [ts_builtin_sym_end] = ACTIONS(3264),
    [sym_identifier] = ACTIONS(3266),
    [anon_sym_LF] = ACTIONS(3266),
    [anon_sym_CR] = ACTIONS(3266),
    [anon_sym_CR_LF] = ACTIONS(3266),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3266),
    [anon_sym_as] = ACTIONS(3266),
    [anon_sym_LBRACE] = ACTIONS(3266),
    [anon_sym_COMMA] = ACTIONS(3266),
    [anon_sym_const] = ACTIONS(3266),
    [anon_sym_LPAREN] = ACTIONS(3266),
    [anon_sym___global] = ACTIONS(3266),
    [anon_sym_type] = ACTIONS(3266),
    [anon_sym_fn] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3266),
    [anon_sym_DASH] = ACTIONS(3266),
    [anon_sym_STAR] = ACTIONS(3266),
    [anon_sym_SLASH] = ACTIONS(3266),
    [anon_sym_PERCENT] = ACTIONS(3266),
    [anon_sym_LT] = ACTIONS(3266),
    [anon_sym_GT] = ACTIONS(3266),
    [anon_sym_EQ_EQ] = ACTIONS(3266),
    [anon_sym_BANG_EQ] = ACTIONS(3266),
    [anon_sym_LT_EQ] = ACTIONS(3266),
    [anon_sym_GT_EQ] = ACTIONS(3266),
    [anon_sym_LBRACK] = ACTIONS(3264),
    [anon_sym_struct] = ACTIONS(3266),
    [anon_sym_union] = ACTIONS(3266),
    [anon_sym_pub] = ACTIONS(3266),
    [anon_sym_mut] = ACTIONS(3266),
    [anon_sym_enum] = ACTIONS(3266),
    [anon_sym_interface] = ACTIONS(3266),
    [anon_sym_PLUS_PLUS] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3266),
    [anon_sym_QMARK] = ACTIONS(3266),
    [anon_sym_BANG] = ACTIONS(3266),
    [anon_sym_go] = ACTIONS(3266),
    [anon_sym_spawn] = ACTIONS(3266),
    [anon_sym_json_DOTdecode] = ACTIONS(3266),
    [anon_sym_PIPE] = ACTIONS(3266),
    [anon_sym_LBRACK2] = ACTIONS(3266),
    [anon_sym_TILDE] = ACTIONS(3266),
    [anon_sym_CARET] = ACTIONS(3266),
    [anon_sym_AMP] = ACTIONS(3266),
    [anon_sym_LT_DASH] = ACTIONS(3266),
    [anon_sym_LT_LT] = ACTIONS(3266),
    [anon_sym_GT_GT] = ACTIONS(3266),
    [anon_sym_GT_GT_GT] = ACTIONS(3266),
    [anon_sym_AMP_CARET] = ACTIONS(3266),
    [anon_sym_AMP_AMP] = ACTIONS(3266),
    [anon_sym_PIPE_PIPE] = ACTIONS(3266),
    [anon_sym_or] = ACTIONS(3266),
    [sym_none] = ACTIONS(3266),
    [sym_true] = ACTIONS(3266),
    [sym_false] = ACTIONS(3266),
    [sym_nil] = ACTIONS(3266),
    [anon_sym_QMARK_DOT] = ACTIONS(3266),
    [anon_sym_POUND_LBRACK] = ACTIONS(3266),
    [anon_sym_if] = ACTIONS(3266),
    [anon_sym_DOLLARif] = ACTIONS(3266),
    [anon_sym_is] = ACTIONS(3266),
    [anon_sym_BANGis] = ACTIONS(3266),
    [anon_sym_in] = ACTIONS(3266),
    [anon_sym_BANGin] = ACTIONS(3266),
    [anon_sym_match] = ACTIONS(3266),
    [anon_sym_select] = ACTIONS(3266),
    [anon_sym_lock] = ACTIONS(3266),
    [anon_sym_rlock] = ACTIONS(3266),
    [anon_sym_unsafe] = ACTIONS(3266),
    [anon_sym_sql] = ACTIONS(3266),
    [sym_int_literal] = ACTIONS(3266),
    [sym_float_literal] = ACTIONS(3266),
    [sym_rune_literal] = ACTIONS(3266),
    [anon_sym_SQUOTE] = ACTIONS(3266),
    [anon_sym_DQUOTE] = ACTIONS(3266),
    [anon_sym_c_SQUOTE] = ACTIONS(3266),
    [anon_sym_c_DQUOTE] = ACTIONS(3266),
    [anon_sym_r_SQUOTE] = ACTIONS(3266),
    [anon_sym_r_DQUOTE] = ACTIONS(3266),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3266),
    [anon_sym_shared] = ACTIONS(3266),
    [anon_sym_map_LBRACK] = ACTIONS(3266),
    [anon_sym_chan] = ACTIONS(3266),
    [anon_sym_thread] = ACTIONS(3266),
    [anon_sym_atomic] = ACTIONS(3266),
    [anon_sym_assert] = ACTIONS(3266),
    [anon_sym_defer] = ACTIONS(3266),
    [anon_sym_goto] = ACTIONS(3266),
    [anon_sym_break] = ACTIONS(3266),
    [anon_sym_continue] = ACTIONS(3266),
    [anon_sym_return] = ACTIONS(3266),
    [anon_sym_DOLLARfor] = ACTIONS(3266),
    [anon_sym_for] = ACTIONS(3266),
    [anon_sym_POUND] = ACTIONS(3266),
    [anon_sym_asm] = ACTIONS(3266),
    [anon_sym_AT_LBRACK] = ACTIONS(3266),
  },
  [1235] = {
    [sym_line_comment] = STATE(1235),
    [sym_block_comment] = STATE(1235),
    [ts_builtin_sym_end] = ACTIONS(3268),
    [sym_identifier] = ACTIONS(3270),
    [anon_sym_LF] = ACTIONS(3270),
    [anon_sym_CR] = ACTIONS(3270),
    [anon_sym_CR_LF] = ACTIONS(3270),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3270),
    [anon_sym_as] = ACTIONS(3270),
    [anon_sym_LBRACE] = ACTIONS(3270),
    [anon_sym_COMMA] = ACTIONS(3270),
    [anon_sym_const] = ACTIONS(3270),
    [anon_sym_LPAREN] = ACTIONS(3270),
    [anon_sym___global] = ACTIONS(3270),
    [anon_sym_type] = ACTIONS(3270),
    [anon_sym_fn] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3270),
    [anon_sym_DASH] = ACTIONS(3270),
    [anon_sym_STAR] = ACTIONS(3270),
    [anon_sym_SLASH] = ACTIONS(3270),
    [anon_sym_PERCENT] = ACTIONS(3270),
    [anon_sym_LT] = ACTIONS(3270),
    [anon_sym_GT] = ACTIONS(3270),
    [anon_sym_EQ_EQ] = ACTIONS(3270),
    [anon_sym_BANG_EQ] = ACTIONS(3270),
    [anon_sym_LT_EQ] = ACTIONS(3270),
    [anon_sym_GT_EQ] = ACTIONS(3270),
    [anon_sym_LBRACK] = ACTIONS(3268),
    [anon_sym_struct] = ACTIONS(3270),
    [anon_sym_union] = ACTIONS(3270),
    [anon_sym_pub] = ACTIONS(3270),
    [anon_sym_mut] = ACTIONS(3270),
    [anon_sym_enum] = ACTIONS(3270),
    [anon_sym_interface] = ACTIONS(3270),
    [anon_sym_PLUS_PLUS] = ACTIONS(3270),
    [anon_sym_DASH_DASH] = ACTIONS(3270),
    [anon_sym_QMARK] = ACTIONS(3270),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_go] = ACTIONS(3270),
    [anon_sym_spawn] = ACTIONS(3270),
    [anon_sym_json_DOTdecode] = ACTIONS(3270),
    [anon_sym_PIPE] = ACTIONS(3270),
    [anon_sym_LBRACK2] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3270),
    [anon_sym_CARET] = ACTIONS(3270),
    [anon_sym_AMP] = ACTIONS(3270),
    [anon_sym_LT_DASH] = ACTIONS(3270),
    [anon_sym_LT_LT] = ACTIONS(3270),
    [anon_sym_GT_GT] = ACTIONS(3270),
    [anon_sym_GT_GT_GT] = ACTIONS(3270),
    [anon_sym_AMP_CARET] = ACTIONS(3270),
    [anon_sym_AMP_AMP] = ACTIONS(3270),
    [anon_sym_PIPE_PIPE] = ACTIONS(3270),
    [anon_sym_or] = ACTIONS(3270),
    [sym_none] = ACTIONS(3270),
    [sym_true] = ACTIONS(3270),
    [sym_false] = ACTIONS(3270),
    [sym_nil] = ACTIONS(3270),
    [anon_sym_QMARK_DOT] = ACTIONS(3270),
    [anon_sym_POUND_LBRACK] = ACTIONS(3270),
    [anon_sym_if] = ACTIONS(3270),
    [anon_sym_DOLLARif] = ACTIONS(3270),
    [anon_sym_is] = ACTIONS(3270),
    [anon_sym_BANGis] = ACTIONS(3270),
    [anon_sym_in] = ACTIONS(3270),
    [anon_sym_BANGin] = ACTIONS(3270),
    [anon_sym_match] = ACTIONS(3270),
    [anon_sym_select] = ACTIONS(3270),
    [anon_sym_lock] = ACTIONS(3270),
    [anon_sym_rlock] = ACTIONS(3270),
    [anon_sym_unsafe] = ACTIONS(3270),
    [anon_sym_sql] = ACTIONS(3270),
    [sym_int_literal] = ACTIONS(3270),
    [sym_float_literal] = ACTIONS(3270),
    [sym_rune_literal] = ACTIONS(3270),
    [anon_sym_SQUOTE] = ACTIONS(3270),
    [anon_sym_DQUOTE] = ACTIONS(3270),
    [anon_sym_c_SQUOTE] = ACTIONS(3270),
    [anon_sym_c_DQUOTE] = ACTIONS(3270),
    [anon_sym_r_SQUOTE] = ACTIONS(3270),
    [anon_sym_r_DQUOTE] = ACTIONS(3270),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3270),
    [anon_sym_shared] = ACTIONS(3270),
    [anon_sym_map_LBRACK] = ACTIONS(3270),
    [anon_sym_chan] = ACTIONS(3270),
    [anon_sym_thread] = ACTIONS(3270),
    [anon_sym_atomic] = ACTIONS(3270),
    [anon_sym_assert] = ACTIONS(3270),
    [anon_sym_defer] = ACTIONS(3270),
    [anon_sym_goto] = ACTIONS(3270),
    [anon_sym_break] = ACTIONS(3270),
    [anon_sym_continue] = ACTIONS(3270),
    [anon_sym_return] = ACTIONS(3270),
    [anon_sym_DOLLARfor] = ACTIONS(3270),
    [anon_sym_for] = ACTIONS(3270),
    [anon_sym_POUND] = ACTIONS(3270),
    [anon_sym_asm] = ACTIONS(3270),
    [anon_sym_AT_LBRACK] = ACTIONS(3270),
  },
  [1236] = {
    [sym_line_comment] = STATE(1236),
    [sym_block_comment] = STATE(1236),
    [ts_builtin_sym_end] = ACTIONS(3290),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_LF] = ACTIONS(3292),
    [anon_sym_CR] = ACTIONS(3292),
    [anon_sym_CR_LF] = ACTIONS(3292),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(3292),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_COMMA] = ACTIONS(3292),
    [anon_sym_const] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym___global] = ACTIONS(3292),
    [anon_sym_type] = ACTIONS(3292),
    [anon_sym_fn] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_LT] = ACTIONS(3292),
    [anon_sym_GT] = ACTIONS(3292),
    [anon_sym_EQ_EQ] = ACTIONS(3292),
    [anon_sym_BANG_EQ] = ACTIONS(3292),
    [anon_sym_LT_EQ] = ACTIONS(3292),
    [anon_sym_GT_EQ] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3290),
    [anon_sym_struct] = ACTIONS(3292),
    [anon_sym_union] = ACTIONS(3292),
    [anon_sym_pub] = ACTIONS(3292),
    [anon_sym_mut] = ACTIONS(3292),
    [anon_sym_enum] = ACTIONS(3292),
    [anon_sym_interface] = ACTIONS(3292),
    [anon_sym_PLUS_PLUS] = ACTIONS(3292),
    [anon_sym_DASH_DASH] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3292),
    [anon_sym_BANG] = ACTIONS(3292),
    [anon_sym_go] = ACTIONS(3292),
    [anon_sym_spawn] = ACTIONS(3292),
    [anon_sym_json_DOTdecode] = ACTIONS(3292),
    [anon_sym_PIPE] = ACTIONS(3292),
    [anon_sym_LBRACK2] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3292),
    [anon_sym_CARET] = ACTIONS(3292),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LT_DASH] = ACTIONS(3292),
    [anon_sym_LT_LT] = ACTIONS(3292),
    [anon_sym_GT_GT] = ACTIONS(3292),
    [anon_sym_GT_GT_GT] = ACTIONS(3292),
    [anon_sym_AMP_CARET] = ACTIONS(3292),
    [anon_sym_AMP_AMP] = ACTIONS(3292),
    [anon_sym_PIPE_PIPE] = ACTIONS(3292),
    [anon_sym_or] = ACTIONS(3292),
    [sym_none] = ACTIONS(3292),
    [sym_true] = ACTIONS(3292),
    [sym_false] = ACTIONS(3292),
    [sym_nil] = ACTIONS(3292),
    [anon_sym_QMARK_DOT] = ACTIONS(3292),
    [anon_sym_POUND_LBRACK] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_DOLLARif] = ACTIONS(3292),
    [anon_sym_is] = ACTIONS(3292),
    [anon_sym_BANGis] = ACTIONS(3292),
    [anon_sym_in] = ACTIONS(3292),
    [anon_sym_BANGin] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_select] = ACTIONS(3292),
    [anon_sym_lock] = ACTIONS(3292),
    [anon_sym_rlock] = ACTIONS(3292),
    [anon_sym_unsafe] = ACTIONS(3292),
    [anon_sym_sql] = ACTIONS(3292),
    [sym_int_literal] = ACTIONS(3292),
    [sym_float_literal] = ACTIONS(3292),
    [sym_rune_literal] = ACTIONS(3292),
    [anon_sym_SQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_c_SQUOTE] = ACTIONS(3292),
    [anon_sym_c_DQUOTE] = ACTIONS(3292),
    [anon_sym_r_SQUOTE] = ACTIONS(3292),
    [anon_sym_r_DQUOTE] = ACTIONS(3292),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3292),
    [anon_sym_shared] = ACTIONS(3292),
    [anon_sym_map_LBRACK] = ACTIONS(3292),
    [anon_sym_chan] = ACTIONS(3292),
    [anon_sym_thread] = ACTIONS(3292),
    [anon_sym_atomic] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_defer] = ACTIONS(3292),
    [anon_sym_goto] = ACTIONS(3292),
    [anon_sym_break] = ACTIONS(3292),
    [anon_sym_continue] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_DOLLARfor] = ACTIONS(3292),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_POUND] = ACTIONS(3292),
    [anon_sym_asm] = ACTIONS(3292),
    [anon_sym_AT_LBRACK] = ACTIONS(3292),
  },
  [1237] = {
    [sym_line_comment] = STATE(1237),
    [sym_block_comment] = STATE(1237),
    [ts_builtin_sym_end] = ACTIONS(3294),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_LF] = ACTIONS(3296),
    [anon_sym_CR] = ACTIONS(3296),
    [anon_sym_CR_LF] = ACTIONS(3296),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3296),
    [anon_sym_as] = ACTIONS(3296),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3296),
    [anon_sym_const] = ACTIONS(3296),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym___global] = ACTIONS(3296),
    [anon_sym_type] = ACTIONS(3296),
    [anon_sym_fn] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_SLASH] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_LT] = ACTIONS(3296),
    [anon_sym_GT] = ACTIONS(3296),
    [anon_sym_EQ_EQ] = ACTIONS(3296),
    [anon_sym_BANG_EQ] = ACTIONS(3296),
    [anon_sym_LT_EQ] = ACTIONS(3296),
    [anon_sym_GT_EQ] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3294),
    [anon_sym_struct] = ACTIONS(3296),
    [anon_sym_union] = ACTIONS(3296),
    [anon_sym_pub] = ACTIONS(3296),
    [anon_sym_mut] = ACTIONS(3296),
    [anon_sym_enum] = ACTIONS(3296),
    [anon_sym_interface] = ACTIONS(3296),
    [anon_sym_PLUS_PLUS] = ACTIONS(3296),
    [anon_sym_DASH_DASH] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3296),
    [anon_sym_BANG] = ACTIONS(3296),
    [anon_sym_go] = ACTIONS(3296),
    [anon_sym_spawn] = ACTIONS(3296),
    [anon_sym_json_DOTdecode] = ACTIONS(3296),
    [anon_sym_PIPE] = ACTIONS(3296),
    [anon_sym_LBRACK2] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3296),
    [anon_sym_CARET] = ACTIONS(3296),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3296),
    [anon_sym_LT_LT] = ACTIONS(3296),
    [anon_sym_GT_GT] = ACTIONS(3296),
    [anon_sym_GT_GT_GT] = ACTIONS(3296),
    [anon_sym_AMP_CARET] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3296),
    [anon_sym_or] = ACTIONS(3296),
    [sym_none] = ACTIONS(3296),
    [sym_true] = ACTIONS(3296),
    [sym_false] = ACTIONS(3296),
    [sym_nil] = ACTIONS(3296),
    [anon_sym_QMARK_DOT] = ACTIONS(3296),
    [anon_sym_POUND_LBRACK] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_DOLLARif] = ACTIONS(3296),
    [anon_sym_is] = ACTIONS(3296),
    [anon_sym_BANGis] = ACTIONS(3296),
    [anon_sym_in] = ACTIONS(3296),
    [anon_sym_BANGin] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_select] = ACTIONS(3296),
    [anon_sym_lock] = ACTIONS(3296),
    [anon_sym_rlock] = ACTIONS(3296),
    [anon_sym_unsafe] = ACTIONS(3296),
    [anon_sym_sql] = ACTIONS(3296),
    [sym_int_literal] = ACTIONS(3296),
    [sym_float_literal] = ACTIONS(3296),
    [sym_rune_literal] = ACTIONS(3296),
    [anon_sym_SQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_c_SQUOTE] = ACTIONS(3296),
    [anon_sym_c_DQUOTE] = ACTIONS(3296),
    [anon_sym_r_SQUOTE] = ACTIONS(3296),
    [anon_sym_r_DQUOTE] = ACTIONS(3296),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3296),
    [anon_sym_shared] = ACTIONS(3296),
    [anon_sym_map_LBRACK] = ACTIONS(3296),
    [anon_sym_chan] = ACTIONS(3296),
    [anon_sym_thread] = ACTIONS(3296),
    [anon_sym_atomic] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_defer] = ACTIONS(3296),
    [anon_sym_goto] = ACTIONS(3296),
    [anon_sym_break] = ACTIONS(3296),
    [anon_sym_continue] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_DOLLARfor] = ACTIONS(3296),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_POUND] = ACTIONS(3296),
    [anon_sym_asm] = ACTIONS(3296),
    [anon_sym_AT_LBRACK] = ACTIONS(3296),
  },
  [1238] = {
    [sym_line_comment] = STATE(1238),
    [sym_block_comment] = STATE(1238),
    [ts_builtin_sym_end] = ACTIONS(2975),
    [sym_identifier] = ACTIONS(2977),
    [anon_sym_LF] = ACTIONS(2977),
    [anon_sym_CR] = ACTIONS(2977),
    [anon_sym_CR_LF] = ACTIONS(2977),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2977),
    [anon_sym_as] = ACTIONS(2977),
    [anon_sym_LBRACE] = ACTIONS(2977),
    [anon_sym_COMMA] = ACTIONS(2977),
    [anon_sym_const] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(2977),
    [anon_sym___global] = ACTIONS(2977),
    [anon_sym_type] = ACTIONS(2977),
    [anon_sym_fn] = ACTIONS(2977),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_PERCENT] = ACTIONS(2977),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_EQ_EQ] = ACTIONS(2977),
    [anon_sym_BANG_EQ] = ACTIONS(2977),
    [anon_sym_LT_EQ] = ACTIONS(2977),
    [anon_sym_GT_EQ] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(2975),
    [anon_sym_struct] = ACTIONS(2977),
    [anon_sym_union] = ACTIONS(2977),
    [anon_sym_pub] = ACTIONS(2977),
    [anon_sym_mut] = ACTIONS(2977),
    [anon_sym_enum] = ACTIONS(2977),
    [anon_sym_interface] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2977),
    [anon_sym_DASH_DASH] = ACTIONS(2977),
    [anon_sym_QMARK] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_go] = ACTIONS(2977),
    [anon_sym_spawn] = ACTIONS(2977),
    [anon_sym_json_DOTdecode] = ACTIONS(2977),
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_LBRACK2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2977),
    [anon_sym_CARET] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_LT_DASH] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2977),
    [anon_sym_GT_GT] = ACTIONS(2977),
    [anon_sym_GT_GT_GT] = ACTIONS(2977),
    [anon_sym_AMP_CARET] = ACTIONS(2977),
    [anon_sym_AMP_AMP] = ACTIONS(2977),
    [anon_sym_PIPE_PIPE] = ACTIONS(2977),
    [anon_sym_or] = ACTIONS(2977),
    [sym_none] = ACTIONS(2977),
    [sym_true] = ACTIONS(2977),
    [sym_false] = ACTIONS(2977),
    [sym_nil] = ACTIONS(2977),
    [anon_sym_QMARK_DOT] = ACTIONS(2977),
    [anon_sym_POUND_LBRACK] = ACTIONS(2977),
    [anon_sym_if] = ACTIONS(2977),
    [anon_sym_DOLLARif] = ACTIONS(2977),
    [anon_sym_is] = ACTIONS(2977),
    [anon_sym_BANGis] = ACTIONS(2977),
    [anon_sym_in] = ACTIONS(2977),
    [anon_sym_BANGin] = ACTIONS(2977),
    [anon_sym_match] = ACTIONS(2977),
    [anon_sym_select] = ACTIONS(2977),
    [anon_sym_lock] = ACTIONS(2977),
    [anon_sym_rlock] = ACTIONS(2977),
    [anon_sym_unsafe] = ACTIONS(2977),
    [anon_sym_sql] = ACTIONS(2977),
    [sym_int_literal] = ACTIONS(2977),
    [sym_float_literal] = ACTIONS(2977),
    [sym_rune_literal] = ACTIONS(2977),
    [anon_sym_SQUOTE] = ACTIONS(2977),
    [anon_sym_DQUOTE] = ACTIONS(2977),
    [anon_sym_c_SQUOTE] = ACTIONS(2977),
    [anon_sym_c_DQUOTE] = ACTIONS(2977),
    [anon_sym_r_SQUOTE] = ACTIONS(2977),
    [anon_sym_r_DQUOTE] = ACTIONS(2977),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2977),
    [anon_sym_shared] = ACTIONS(2977),
    [anon_sym_map_LBRACK] = ACTIONS(2977),
    [anon_sym_chan] = ACTIONS(2977),
    [anon_sym_thread] = ACTIONS(2977),
    [anon_sym_atomic] = ACTIONS(2977),
    [anon_sym_assert] = ACTIONS(2977),
    [anon_sym_defer] = ACTIONS(2977),
    [anon_sym_goto] = ACTIONS(2977),
    [anon_sym_break] = ACTIONS(2977),
    [anon_sym_continue] = ACTIONS(2977),
    [anon_sym_return] = ACTIONS(2977),
    [anon_sym_DOLLARfor] = ACTIONS(2977),
    [anon_sym_for] = ACTIONS(2977),
    [anon_sym_POUND] = ACTIONS(2977),
    [anon_sym_asm] = ACTIONS(2977),
    [anon_sym_AT_LBRACK] = ACTIONS(2977),
  },
  [1239] = {
    [sym_line_comment] = STATE(1239),
    [sym_block_comment] = STATE(1239),
    [ts_builtin_sym_end] = ACTIONS(2979),
    [sym_identifier] = ACTIONS(2981),
    [anon_sym_LF] = ACTIONS(2981),
    [anon_sym_CR] = ACTIONS(2981),
    [anon_sym_CR_LF] = ACTIONS(2981),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2981),
    [anon_sym_as] = ACTIONS(2981),
    [anon_sym_LBRACE] = ACTIONS(2981),
    [anon_sym_COMMA] = ACTIONS(2981),
    [anon_sym_const] = ACTIONS(2981),
    [anon_sym_LPAREN] = ACTIONS(2981),
    [anon_sym___global] = ACTIONS(2981),
    [anon_sym_type] = ACTIONS(2981),
    [anon_sym_fn] = ACTIONS(2981),
    [anon_sym_PLUS] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_PERCENT] = ACTIONS(2981),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_GT] = ACTIONS(2981),
    [anon_sym_EQ_EQ] = ACTIONS(2981),
    [anon_sym_BANG_EQ] = ACTIONS(2981),
    [anon_sym_LT_EQ] = ACTIONS(2981),
    [anon_sym_GT_EQ] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_struct] = ACTIONS(2981),
    [anon_sym_union] = ACTIONS(2981),
    [anon_sym_pub] = ACTIONS(2981),
    [anon_sym_mut] = ACTIONS(2981),
    [anon_sym_enum] = ACTIONS(2981),
    [anon_sym_interface] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2981),
    [anon_sym_DASH_DASH] = ACTIONS(2981),
    [anon_sym_QMARK] = ACTIONS(2981),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_go] = ACTIONS(2981),
    [anon_sym_spawn] = ACTIONS(2981),
    [anon_sym_json_DOTdecode] = ACTIONS(2981),
    [anon_sym_PIPE] = ACTIONS(2981),
    [anon_sym_LBRACK2] = ACTIONS(2981),
    [anon_sym_TILDE] = ACTIONS(2981),
    [anon_sym_CARET] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2981),
    [anon_sym_LT_DASH] = ACTIONS(2981),
    [anon_sym_LT_LT] = ACTIONS(2981),
    [anon_sym_GT_GT] = ACTIONS(2981),
    [anon_sym_GT_GT_GT] = ACTIONS(2981),
    [anon_sym_AMP_CARET] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(2981),
    [anon_sym_PIPE_PIPE] = ACTIONS(2981),
    [anon_sym_or] = ACTIONS(2981),
    [sym_none] = ACTIONS(2981),
    [sym_true] = ACTIONS(2981),
    [sym_false] = ACTIONS(2981),
    [sym_nil] = ACTIONS(2981),
    [anon_sym_QMARK_DOT] = ACTIONS(2981),
    [anon_sym_POUND_LBRACK] = ACTIONS(2981),
    [anon_sym_if] = ACTIONS(2981),
    [anon_sym_DOLLARif] = ACTIONS(2981),
    [anon_sym_is] = ACTIONS(2981),
    [anon_sym_BANGis] = ACTIONS(2981),
    [anon_sym_in] = ACTIONS(2981),
    [anon_sym_BANGin] = ACTIONS(2981),
    [anon_sym_match] = ACTIONS(2981),
    [anon_sym_select] = ACTIONS(2981),
    [anon_sym_lock] = ACTIONS(2981),
    [anon_sym_rlock] = ACTIONS(2981),
    [anon_sym_unsafe] = ACTIONS(2981),
    [anon_sym_sql] = ACTIONS(2981),
    [sym_int_literal] = ACTIONS(2981),
    [sym_float_literal] = ACTIONS(2981),
    [sym_rune_literal] = ACTIONS(2981),
    [anon_sym_SQUOTE] = ACTIONS(2981),
    [anon_sym_DQUOTE] = ACTIONS(2981),
    [anon_sym_c_SQUOTE] = ACTIONS(2981),
    [anon_sym_c_DQUOTE] = ACTIONS(2981),
    [anon_sym_r_SQUOTE] = ACTIONS(2981),
    [anon_sym_r_DQUOTE] = ACTIONS(2981),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2981),
    [anon_sym_shared] = ACTIONS(2981),
    [anon_sym_map_LBRACK] = ACTIONS(2981),
    [anon_sym_chan] = ACTIONS(2981),
    [anon_sym_thread] = ACTIONS(2981),
    [anon_sym_atomic] = ACTIONS(2981),
    [anon_sym_assert] = ACTIONS(2981),
    [anon_sym_defer] = ACTIONS(2981),
    [anon_sym_goto] = ACTIONS(2981),
    [anon_sym_break] = ACTIONS(2981),
    [anon_sym_continue] = ACTIONS(2981),
    [anon_sym_return] = ACTIONS(2981),
    [anon_sym_DOLLARfor] = ACTIONS(2981),
    [anon_sym_for] = ACTIONS(2981),
    [anon_sym_POUND] = ACTIONS(2981),
    [anon_sym_asm] = ACTIONS(2981),
    [anon_sym_AT_LBRACK] = ACTIONS(2981),
  },
  [1240] = {
    [sym_line_comment] = STATE(1240),
    [sym_block_comment] = STATE(1240),
    [ts_builtin_sym_end] = ACTIONS(3005),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_LF] = ACTIONS(3007),
    [anon_sym_CR] = ACTIONS(3007),
    [anon_sym_CR_LF] = ACTIONS(3007),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3007),
    [anon_sym_as] = ACTIONS(3007),
    [anon_sym_LBRACE] = ACTIONS(3007),
    [anon_sym_COMMA] = ACTIONS(3007),
    [anon_sym_const] = ACTIONS(3007),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym___global] = ACTIONS(3007),
    [anon_sym_type] = ACTIONS(3007),
    [anon_sym_fn] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_STAR] = ACTIONS(3007),
    [anon_sym_SLASH] = ACTIONS(3007),
    [anon_sym_PERCENT] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(3007),
    [anon_sym_GT] = ACTIONS(3007),
    [anon_sym_EQ_EQ] = ACTIONS(3007),
    [anon_sym_BANG_EQ] = ACTIONS(3007),
    [anon_sym_LT_EQ] = ACTIONS(3007),
    [anon_sym_GT_EQ] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3005),
    [anon_sym_struct] = ACTIONS(3007),
    [anon_sym_union] = ACTIONS(3007),
    [anon_sym_pub] = ACTIONS(3007),
    [anon_sym_mut] = ACTIONS(3007),
    [anon_sym_enum] = ACTIONS(3007),
    [anon_sym_interface] = ACTIONS(3007),
    [anon_sym_PLUS_PLUS] = ACTIONS(3007),
    [anon_sym_DASH_DASH] = ACTIONS(3007),
    [anon_sym_QMARK] = ACTIONS(3007),
    [anon_sym_BANG] = ACTIONS(3007),
    [anon_sym_go] = ACTIONS(3007),
    [anon_sym_spawn] = ACTIONS(3007),
    [anon_sym_json_DOTdecode] = ACTIONS(3007),
    [anon_sym_PIPE] = ACTIONS(3007),
    [anon_sym_LBRACK2] = ACTIONS(3007),
    [anon_sym_TILDE] = ACTIONS(3007),
    [anon_sym_CARET] = ACTIONS(3007),
    [anon_sym_AMP] = ACTIONS(3007),
    [anon_sym_LT_DASH] = ACTIONS(3007),
    [anon_sym_LT_LT] = ACTIONS(3007),
    [anon_sym_GT_GT] = ACTIONS(3007),
    [anon_sym_GT_GT_GT] = ACTIONS(3007),
    [anon_sym_AMP_CARET] = ACTIONS(3007),
    [anon_sym_AMP_AMP] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3007),
    [anon_sym_or] = ACTIONS(3007),
    [sym_none] = ACTIONS(3007),
    [sym_true] = ACTIONS(3007),
    [sym_false] = ACTIONS(3007),
    [sym_nil] = ACTIONS(3007),
    [anon_sym_QMARK_DOT] = ACTIONS(3007),
    [anon_sym_POUND_LBRACK] = ACTIONS(3007),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_DOLLARif] = ACTIONS(3007),
    [anon_sym_is] = ACTIONS(3007),
    [anon_sym_BANGis] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3007),
    [anon_sym_BANGin] = ACTIONS(3007),
    [anon_sym_match] = ACTIONS(3007),
    [anon_sym_select] = ACTIONS(3007),
    [anon_sym_lock] = ACTIONS(3007),
    [anon_sym_rlock] = ACTIONS(3007),
    [anon_sym_unsafe] = ACTIONS(3007),
    [anon_sym_sql] = ACTIONS(3007),
    [sym_int_literal] = ACTIONS(3007),
    [sym_float_literal] = ACTIONS(3007),
    [sym_rune_literal] = ACTIONS(3007),
    [anon_sym_SQUOTE] = ACTIONS(3007),
    [anon_sym_DQUOTE] = ACTIONS(3007),
    [anon_sym_c_SQUOTE] = ACTIONS(3007),
    [anon_sym_c_DQUOTE] = ACTIONS(3007),
    [anon_sym_r_SQUOTE] = ACTIONS(3007),
    [anon_sym_r_DQUOTE] = ACTIONS(3007),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3007),
    [anon_sym_shared] = ACTIONS(3007),
    [anon_sym_map_LBRACK] = ACTIONS(3007),
    [anon_sym_chan] = ACTIONS(3007),
    [anon_sym_thread] = ACTIONS(3007),
    [anon_sym_atomic] = ACTIONS(3007),
    [anon_sym_assert] = ACTIONS(3007),
    [anon_sym_defer] = ACTIONS(3007),
    [anon_sym_goto] = ACTIONS(3007),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_continue] = ACTIONS(3007),
    [anon_sym_return] = ACTIONS(3007),
    [anon_sym_DOLLARfor] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3007),
    [anon_sym_POUND] = ACTIONS(3007),
    [anon_sym_asm] = ACTIONS(3007),
    [anon_sym_AT_LBRACK] = ACTIONS(3007),
  },
  [1241] = {
    [sym_line_comment] = STATE(1241),
    [sym_block_comment] = STATE(1241),
    [ts_builtin_sym_end] = ACTIONS(3013),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_LF] = ACTIONS(3015),
    [anon_sym_CR] = ACTIONS(3015),
    [anon_sym_CR_LF] = ACTIONS(3015),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3015),
    [anon_sym_as] = ACTIONS(3015),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_COMMA] = ACTIONS(3015),
    [anon_sym_const] = ACTIONS(3015),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym___global] = ACTIONS(3015),
    [anon_sym_type] = ACTIONS(3015),
    [anon_sym_fn] = ACTIONS(3015),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(3015),
    [anon_sym_SLASH] = ACTIONS(3015),
    [anon_sym_PERCENT] = ACTIONS(3015),
    [anon_sym_LT] = ACTIONS(3015),
    [anon_sym_GT] = ACTIONS(3015),
    [anon_sym_EQ_EQ] = ACTIONS(3015),
    [anon_sym_BANG_EQ] = ACTIONS(3015),
    [anon_sym_LT_EQ] = ACTIONS(3015),
    [anon_sym_GT_EQ] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3013),
    [anon_sym_struct] = ACTIONS(3015),
    [anon_sym_union] = ACTIONS(3015),
    [anon_sym_pub] = ACTIONS(3015),
    [anon_sym_mut] = ACTIONS(3015),
    [anon_sym_enum] = ACTIONS(3015),
    [anon_sym_interface] = ACTIONS(3015),
    [anon_sym_PLUS_PLUS] = ACTIONS(3015),
    [anon_sym_DASH_DASH] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_BANG] = ACTIONS(3015),
    [anon_sym_go] = ACTIONS(3015),
    [anon_sym_spawn] = ACTIONS(3015),
    [anon_sym_json_DOTdecode] = ACTIONS(3015),
    [anon_sym_PIPE] = ACTIONS(3015),
    [anon_sym_LBRACK2] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3015),
    [anon_sym_CARET] = ACTIONS(3015),
    [anon_sym_AMP] = ACTIONS(3015),
    [anon_sym_LT_DASH] = ACTIONS(3015),
    [anon_sym_LT_LT] = ACTIONS(3015),
    [anon_sym_GT_GT] = ACTIONS(3015),
    [anon_sym_GT_GT_GT] = ACTIONS(3015),
    [anon_sym_AMP_CARET] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_or] = ACTIONS(3015),
    [sym_none] = ACTIONS(3015),
    [sym_true] = ACTIONS(3015),
    [sym_false] = ACTIONS(3015),
    [sym_nil] = ACTIONS(3015),
    [anon_sym_QMARK_DOT] = ACTIONS(3015),
    [anon_sym_POUND_LBRACK] = ACTIONS(3015),
    [anon_sym_if] = ACTIONS(3015),
    [anon_sym_DOLLARif] = ACTIONS(3015),
    [anon_sym_is] = ACTIONS(3015),
    [anon_sym_BANGis] = ACTIONS(3015),
    [anon_sym_in] = ACTIONS(3015),
    [anon_sym_BANGin] = ACTIONS(3015),
    [anon_sym_match] = ACTIONS(3015),
    [anon_sym_select] = ACTIONS(3015),
    [anon_sym_lock] = ACTIONS(3015),
    [anon_sym_rlock] = ACTIONS(3015),
    [anon_sym_unsafe] = ACTIONS(3015),
    [anon_sym_sql] = ACTIONS(3015),
    [sym_int_literal] = ACTIONS(3015),
    [sym_float_literal] = ACTIONS(3015),
    [sym_rune_literal] = ACTIONS(3015),
    [anon_sym_SQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_c_SQUOTE] = ACTIONS(3015),
    [anon_sym_c_DQUOTE] = ACTIONS(3015),
    [anon_sym_r_SQUOTE] = ACTIONS(3015),
    [anon_sym_r_DQUOTE] = ACTIONS(3015),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3015),
    [anon_sym_shared] = ACTIONS(3015),
    [anon_sym_map_LBRACK] = ACTIONS(3015),
    [anon_sym_chan] = ACTIONS(3015),
    [anon_sym_thread] = ACTIONS(3015),
    [anon_sym_atomic] = ACTIONS(3015),
    [anon_sym_assert] = ACTIONS(3015),
    [anon_sym_defer] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3015),
    [anon_sym_break] = ACTIONS(3015),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_return] = ACTIONS(3015),
    [anon_sym_DOLLARfor] = ACTIONS(3015),
    [anon_sym_for] = ACTIONS(3015),
    [anon_sym_POUND] = ACTIONS(3015),
    [anon_sym_asm] = ACTIONS(3015),
    [anon_sym_AT_LBRACK] = ACTIONS(3015),
  },
  [1242] = {
    [sym_line_comment] = STATE(1242),
    [sym_block_comment] = STATE(1242),
    [ts_builtin_sym_end] = ACTIONS(3017),
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_LF] = ACTIONS(3019),
    [anon_sym_CR] = ACTIONS(3019),
    [anon_sym_CR_LF] = ACTIONS(3019),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3019),
    [anon_sym_as] = ACTIONS(3019),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_COMMA] = ACTIONS(3019),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym___global] = ACTIONS(3019),
    [anon_sym_type] = ACTIONS(3019),
    [anon_sym_fn] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_STAR] = ACTIONS(3019),
    [anon_sym_SLASH] = ACTIONS(3019),
    [anon_sym_PERCENT] = ACTIONS(3019),
    [anon_sym_LT] = ACTIONS(3019),
    [anon_sym_GT] = ACTIONS(3019),
    [anon_sym_EQ_EQ] = ACTIONS(3019),
    [anon_sym_BANG_EQ] = ACTIONS(3019),
    [anon_sym_LT_EQ] = ACTIONS(3019),
    [anon_sym_GT_EQ] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3017),
    [anon_sym_struct] = ACTIONS(3019),
    [anon_sym_union] = ACTIONS(3019),
    [anon_sym_pub] = ACTIONS(3019),
    [anon_sym_mut] = ACTIONS(3019),
    [anon_sym_enum] = ACTIONS(3019),
    [anon_sym_interface] = ACTIONS(3019),
    [anon_sym_PLUS_PLUS] = ACTIONS(3019),
    [anon_sym_DASH_DASH] = ACTIONS(3019),
    [anon_sym_QMARK] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_go] = ACTIONS(3019),
    [anon_sym_spawn] = ACTIONS(3019),
    [anon_sym_json_DOTdecode] = ACTIONS(3019),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_LBRACK2] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_LT_DASH] = ACTIONS(3019),
    [anon_sym_LT_LT] = ACTIONS(3019),
    [anon_sym_GT_GT] = ACTIONS(3019),
    [anon_sym_GT_GT_GT] = ACTIONS(3019),
    [anon_sym_AMP_CARET] = ACTIONS(3019),
    [anon_sym_AMP_AMP] = ACTIONS(3019),
    [anon_sym_PIPE_PIPE] = ACTIONS(3019),
    [anon_sym_or] = ACTIONS(3019),
    [sym_none] = ACTIONS(3019),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_nil] = ACTIONS(3019),
    [anon_sym_QMARK_DOT] = ACTIONS(3019),
    [anon_sym_POUND_LBRACK] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_DOLLARif] = ACTIONS(3019),
    [anon_sym_is] = ACTIONS(3019),
    [anon_sym_BANGis] = ACTIONS(3019),
    [anon_sym_in] = ACTIONS(3019),
    [anon_sym_BANGin] = ACTIONS(3019),
    [anon_sym_match] = ACTIONS(3019),
    [anon_sym_select] = ACTIONS(3019),
    [anon_sym_lock] = ACTIONS(3019),
    [anon_sym_rlock] = ACTIONS(3019),
    [anon_sym_unsafe] = ACTIONS(3019),
    [anon_sym_sql] = ACTIONS(3019),
    [sym_int_literal] = ACTIONS(3019),
    [sym_float_literal] = ACTIONS(3019),
    [sym_rune_literal] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_c_SQUOTE] = ACTIONS(3019),
    [anon_sym_c_DQUOTE] = ACTIONS(3019),
    [anon_sym_r_SQUOTE] = ACTIONS(3019),
    [anon_sym_r_DQUOTE] = ACTIONS(3019),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3019),
    [anon_sym_shared] = ACTIONS(3019),
    [anon_sym_map_LBRACK] = ACTIONS(3019),
    [anon_sym_chan] = ACTIONS(3019),
    [anon_sym_thread] = ACTIONS(3019),
    [anon_sym_atomic] = ACTIONS(3019),
    [anon_sym_assert] = ACTIONS(3019),
    [anon_sym_defer] = ACTIONS(3019),
    [anon_sym_goto] = ACTIONS(3019),
    [anon_sym_break] = ACTIONS(3019),
    [anon_sym_continue] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_DOLLARfor] = ACTIONS(3019),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_POUND] = ACTIONS(3019),
    [anon_sym_asm] = ACTIONS(3019),
    [anon_sym_AT_LBRACK] = ACTIONS(3019),
  },
  [1243] = {
    [sym_line_comment] = STATE(1243),
    [sym_block_comment] = STATE(1243),
    [ts_builtin_sym_end] = ACTIONS(3021),
    [sym_identifier] = ACTIONS(3023),
    [anon_sym_LF] = ACTIONS(3023),
    [anon_sym_CR] = ACTIONS(3023),
    [anon_sym_CR_LF] = ACTIONS(3023),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3023),
    [anon_sym_as] = ACTIONS(3023),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_COMMA] = ACTIONS(3023),
    [anon_sym_const] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym___global] = ACTIONS(3023),
    [anon_sym_type] = ACTIONS(3023),
    [anon_sym_fn] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_STAR] = ACTIONS(3023),
    [anon_sym_SLASH] = ACTIONS(3023),
    [anon_sym_PERCENT] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3023),
    [anon_sym_GT] = ACTIONS(3023),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT_EQ] = ACTIONS(3023),
    [anon_sym_GT_EQ] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3021),
    [anon_sym_struct] = ACTIONS(3023),
    [anon_sym_union] = ACTIONS(3023),
    [anon_sym_pub] = ACTIONS(3023),
    [anon_sym_mut] = ACTIONS(3023),
    [anon_sym_enum] = ACTIONS(3023),
    [anon_sym_interface] = ACTIONS(3023),
    [anon_sym_PLUS_PLUS] = ACTIONS(3023),
    [anon_sym_DASH_DASH] = ACTIONS(3023),
    [anon_sym_QMARK] = ACTIONS(3023),
    [anon_sym_BANG] = ACTIONS(3023),
    [anon_sym_go] = ACTIONS(3023),
    [anon_sym_spawn] = ACTIONS(3023),
    [anon_sym_json_DOTdecode] = ACTIONS(3023),
    [anon_sym_PIPE] = ACTIONS(3023),
    [anon_sym_LBRACK2] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3023),
    [anon_sym_CARET] = ACTIONS(3023),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_LT_DASH] = ACTIONS(3023),
    [anon_sym_LT_LT] = ACTIONS(3023),
    [anon_sym_GT_GT] = ACTIONS(3023),
    [anon_sym_GT_GT_GT] = ACTIONS(3023),
    [anon_sym_AMP_CARET] = ACTIONS(3023),
    [anon_sym_AMP_AMP] = ACTIONS(3023),
    [anon_sym_PIPE_PIPE] = ACTIONS(3023),
    [anon_sym_or] = ACTIONS(3023),
    [sym_none] = ACTIONS(3023),
    [sym_true] = ACTIONS(3023),
    [sym_false] = ACTIONS(3023),
    [sym_nil] = ACTIONS(3023),
    [anon_sym_QMARK_DOT] = ACTIONS(3023),
    [anon_sym_POUND_LBRACK] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_DOLLARif] = ACTIONS(3023),
    [anon_sym_is] = ACTIONS(3023),
    [anon_sym_BANGis] = ACTIONS(3023),
    [anon_sym_in] = ACTIONS(3023),
    [anon_sym_BANGin] = ACTIONS(3023),
    [anon_sym_match] = ACTIONS(3023),
    [anon_sym_select] = ACTIONS(3023),
    [anon_sym_lock] = ACTIONS(3023),
    [anon_sym_rlock] = ACTIONS(3023),
    [anon_sym_unsafe] = ACTIONS(3023),
    [anon_sym_sql] = ACTIONS(3023),
    [sym_int_literal] = ACTIONS(3023),
    [sym_float_literal] = ACTIONS(3023),
    [sym_rune_literal] = ACTIONS(3023),
    [anon_sym_SQUOTE] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_c_SQUOTE] = ACTIONS(3023),
    [anon_sym_c_DQUOTE] = ACTIONS(3023),
    [anon_sym_r_SQUOTE] = ACTIONS(3023),
    [anon_sym_r_DQUOTE] = ACTIONS(3023),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3023),
    [anon_sym_shared] = ACTIONS(3023),
    [anon_sym_map_LBRACK] = ACTIONS(3023),
    [anon_sym_chan] = ACTIONS(3023),
    [anon_sym_thread] = ACTIONS(3023),
    [anon_sym_atomic] = ACTIONS(3023),
    [anon_sym_assert] = ACTIONS(3023),
    [anon_sym_defer] = ACTIONS(3023),
    [anon_sym_goto] = ACTIONS(3023),
    [anon_sym_break] = ACTIONS(3023),
    [anon_sym_continue] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_DOLLARfor] = ACTIONS(3023),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_POUND] = ACTIONS(3023),
    [anon_sym_asm] = ACTIONS(3023),
    [anon_sym_AT_LBRACK] = ACTIONS(3023),
  },
  [1244] = {
    [sym_line_comment] = STATE(1244),
    [sym_block_comment] = STATE(1244),
    [ts_builtin_sym_end] = ACTIONS(3238),
    [sym_identifier] = ACTIONS(3240),
    [anon_sym_LF] = ACTIONS(3240),
    [anon_sym_CR] = ACTIONS(3240),
    [anon_sym_CR_LF] = ACTIONS(3240),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3240),
    [anon_sym_as] = ACTIONS(3240),
    [anon_sym_LBRACE] = ACTIONS(3240),
    [anon_sym_COMMA] = ACTIONS(3240),
    [anon_sym_const] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(3240),
    [anon_sym___global] = ACTIONS(3240),
    [anon_sym_type] = ACTIONS(3240),
    [anon_sym_fn] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3240),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [anon_sym_LT] = ACTIONS(3240),
    [anon_sym_GT] = ACTIONS(3240),
    [anon_sym_EQ_EQ] = ACTIONS(3240),
    [anon_sym_BANG_EQ] = ACTIONS(3240),
    [anon_sym_LT_EQ] = ACTIONS(3240),
    [anon_sym_GT_EQ] = ACTIONS(3240),
    [anon_sym_LBRACK] = ACTIONS(3238),
    [anon_sym_struct] = ACTIONS(3240),
    [anon_sym_union] = ACTIONS(3240),
    [anon_sym_pub] = ACTIONS(3240),
    [anon_sym_mut] = ACTIONS(3240),
    [anon_sym_enum] = ACTIONS(3240),
    [anon_sym_interface] = ACTIONS(3240),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_QMARK] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_go] = ACTIONS(3240),
    [anon_sym_spawn] = ACTIONS(3240),
    [anon_sym_json_DOTdecode] = ACTIONS(3240),
    [anon_sym_PIPE] = ACTIONS(3240),
    [anon_sym_LBRACK2] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [anon_sym_CARET] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_LT_DASH] = ACTIONS(3240),
    [anon_sym_LT_LT] = ACTIONS(3240),
    [anon_sym_GT_GT] = ACTIONS(3240),
    [anon_sym_GT_GT_GT] = ACTIONS(3240),
    [anon_sym_AMP_CARET] = ACTIONS(3240),
    [anon_sym_AMP_AMP] = ACTIONS(3240),
    [anon_sym_PIPE_PIPE] = ACTIONS(3240),
    [anon_sym_or] = ACTIONS(3240),
    [sym_none] = ACTIONS(3240),
    [sym_true] = ACTIONS(3240),
    [sym_false] = ACTIONS(3240),
    [sym_nil] = ACTIONS(3240),
    [anon_sym_QMARK_DOT] = ACTIONS(3240),
    [anon_sym_POUND_LBRACK] = ACTIONS(3240),
    [anon_sym_if] = ACTIONS(3240),
    [anon_sym_DOLLARif] = ACTIONS(3240),
    [anon_sym_is] = ACTIONS(3240),
    [anon_sym_BANGis] = ACTIONS(3240),
    [anon_sym_in] = ACTIONS(3240),
    [anon_sym_BANGin] = ACTIONS(3240),
    [anon_sym_match] = ACTIONS(3240),
    [anon_sym_select] = ACTIONS(3240),
    [anon_sym_lock] = ACTIONS(3240),
    [anon_sym_rlock] = ACTIONS(3240),
    [anon_sym_unsafe] = ACTIONS(3240),
    [anon_sym_sql] = ACTIONS(3240),
    [sym_int_literal] = ACTIONS(3240),
    [sym_float_literal] = ACTIONS(3240),
    [sym_rune_literal] = ACTIONS(3240),
    [anon_sym_SQUOTE] = ACTIONS(3240),
    [anon_sym_DQUOTE] = ACTIONS(3240),
    [anon_sym_c_SQUOTE] = ACTIONS(3240),
    [anon_sym_c_DQUOTE] = ACTIONS(3240),
    [anon_sym_r_SQUOTE] = ACTIONS(3240),
    [anon_sym_r_DQUOTE] = ACTIONS(3240),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3240),
    [anon_sym_shared] = ACTIONS(3240),
    [anon_sym_map_LBRACK] = ACTIONS(3240),
    [anon_sym_chan] = ACTIONS(3240),
    [anon_sym_thread] = ACTIONS(3240),
    [anon_sym_atomic] = ACTIONS(3240),
    [anon_sym_assert] = ACTIONS(3240),
    [anon_sym_defer] = ACTIONS(3240),
    [anon_sym_goto] = ACTIONS(3240),
    [anon_sym_break] = ACTIONS(3240),
    [anon_sym_continue] = ACTIONS(3240),
    [anon_sym_return] = ACTIONS(3240),
    [anon_sym_DOLLARfor] = ACTIONS(3240),
    [anon_sym_for] = ACTIONS(3240),
    [anon_sym_POUND] = ACTIONS(3240),
    [anon_sym_asm] = ACTIONS(3240),
    [anon_sym_AT_LBRACK] = ACTIONS(3240),
  },
  [1245] = {
    [sym_line_comment] = STATE(1245),
    [sym_block_comment] = STATE(1245),
    [ts_builtin_sym_end] = ACTIONS(2835),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_LF] = ACTIONS(2837),
    [anon_sym_CR] = ACTIONS(2837),
    [anon_sym_CR_LF] = ACTIONS(2837),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2837),
    [anon_sym_as] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(2335),
    [anon_sym_const] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2837),
    [anon_sym___global] = ACTIONS(2837),
    [anon_sym_type] = ACTIONS(2837),
    [anon_sym_fn] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2837),
    [anon_sym_DASH] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2837),
    [anon_sym_SLASH] = ACTIONS(2837),
    [anon_sym_PERCENT] = ACTIONS(2837),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(2837),
    [anon_sym_BANG_EQ] = ACTIONS(2837),
    [anon_sym_LT_EQ] = ACTIONS(2837),
    [anon_sym_GT_EQ] = ACTIONS(2837),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_struct] = ACTIONS(2837),
    [anon_sym_union] = ACTIONS(2837),
    [anon_sym_pub] = ACTIONS(2837),
    [anon_sym_mut] = ACTIONS(2837),
    [anon_sym_enum] = ACTIONS(2837),
    [anon_sym_interface] = ACTIONS(2837),
    [anon_sym_PLUS_PLUS] = ACTIONS(2837),
    [anon_sym_DASH_DASH] = ACTIONS(2837),
    [anon_sym_QMARK] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(2837),
    [anon_sym_go] = ACTIONS(2837),
    [anon_sym_spawn] = ACTIONS(2837),
    [anon_sym_json_DOTdecode] = ACTIONS(2837),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_LBRACK2] = ACTIONS(2837),
    [anon_sym_TILDE] = ACTIONS(2837),
    [anon_sym_CARET] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2837),
    [anon_sym_LT_DASH] = ACTIONS(2837),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_GT_GT_GT] = ACTIONS(2837),
    [anon_sym_AMP_CARET] = ACTIONS(2837),
    [anon_sym_AMP_AMP] = ACTIONS(2837),
    [anon_sym_PIPE_PIPE] = ACTIONS(2837),
    [anon_sym_or] = ACTIONS(2837),
    [sym_none] = ACTIONS(2837),
    [sym_true] = ACTIONS(2837),
    [sym_false] = ACTIONS(2837),
    [sym_nil] = ACTIONS(2837),
    [anon_sym_QMARK_DOT] = ACTIONS(2837),
    [anon_sym_POUND_LBRACK] = ACTIONS(2837),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_DOLLARif] = ACTIONS(2837),
    [anon_sym_is] = ACTIONS(2837),
    [anon_sym_BANGis] = ACTIONS(2837),
    [anon_sym_in] = ACTIONS(2837),
    [anon_sym_BANGin] = ACTIONS(2837),
    [anon_sym_match] = ACTIONS(2837),
    [anon_sym_select] = ACTIONS(2837),
    [anon_sym_lock] = ACTIONS(2837),
    [anon_sym_rlock] = ACTIONS(2837),
    [anon_sym_unsafe] = ACTIONS(2837),
    [anon_sym_sql] = ACTIONS(2837),
    [sym_int_literal] = ACTIONS(2837),
    [sym_float_literal] = ACTIONS(2837),
    [sym_rune_literal] = ACTIONS(2837),
    [anon_sym_SQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE] = ACTIONS(2837),
    [anon_sym_c_SQUOTE] = ACTIONS(2837),
    [anon_sym_c_DQUOTE] = ACTIONS(2837),
    [anon_sym_r_SQUOTE] = ACTIONS(2837),
    [anon_sym_r_DQUOTE] = ACTIONS(2837),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2837),
    [anon_sym_shared] = ACTIONS(2837),
    [anon_sym_map_LBRACK] = ACTIONS(2837),
    [anon_sym_chan] = ACTIONS(2837),
    [anon_sym_thread] = ACTIONS(2837),
    [anon_sym_atomic] = ACTIONS(2837),
    [anon_sym_assert] = ACTIONS(2837),
    [anon_sym_defer] = ACTIONS(2837),
    [anon_sym_goto] = ACTIONS(2837),
    [anon_sym_break] = ACTIONS(2837),
    [anon_sym_continue] = ACTIONS(2837),
    [anon_sym_return] = ACTIONS(2837),
    [anon_sym_DOLLARfor] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2837),
    [anon_sym_POUND] = ACTIONS(2837),
    [anon_sym_asm] = ACTIONS(2837),
    [anon_sym_AT_LBRACK] = ACTIONS(2837),
  },
  [1246] = {
    [sym_line_comment] = STATE(1246),
    [sym_block_comment] = STATE(1246),
    [ts_builtin_sym_end] = ACTIONS(2839),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_LF] = ACTIONS(2841),
    [anon_sym_CR] = ACTIONS(2841),
    [anon_sym_CR_LF] = ACTIONS(2841),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2841),
    [anon_sym_as] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_const] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2841),
    [anon_sym___global] = ACTIONS(2841),
    [anon_sym_type] = ACTIONS(2841),
    [anon_sym_fn] = ACTIONS(2841),
    [anon_sym_PLUS] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(2841),
    [anon_sym_SLASH] = ACTIONS(2841),
    [anon_sym_PERCENT] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_GT] = ACTIONS(2841),
    [anon_sym_EQ_EQ] = ACTIONS(2841),
    [anon_sym_BANG_EQ] = ACTIONS(2841),
    [anon_sym_LT_EQ] = ACTIONS(2841),
    [anon_sym_GT_EQ] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_struct] = ACTIONS(2841),
    [anon_sym_union] = ACTIONS(2841),
    [anon_sym_pub] = ACTIONS(2841),
    [anon_sym_mut] = ACTIONS(2841),
    [anon_sym_enum] = ACTIONS(2841),
    [anon_sym_interface] = ACTIONS(2841),
    [anon_sym_PLUS_PLUS] = ACTIONS(2841),
    [anon_sym_DASH_DASH] = ACTIONS(2841),
    [anon_sym_QMARK] = ACTIONS(2841),
    [anon_sym_BANG] = ACTIONS(2841),
    [anon_sym_go] = ACTIONS(2841),
    [anon_sym_spawn] = ACTIONS(2841),
    [anon_sym_json_DOTdecode] = ACTIONS(2841),
    [anon_sym_PIPE] = ACTIONS(2841),
    [anon_sym_LBRACK2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2841),
    [anon_sym_LT_DASH] = ACTIONS(2841),
    [anon_sym_LT_LT] = ACTIONS(2841),
    [anon_sym_GT_GT] = ACTIONS(2841),
    [anon_sym_GT_GT_GT] = ACTIONS(2841),
    [anon_sym_AMP_CARET] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_PIPE_PIPE] = ACTIONS(2841),
    [anon_sym_or] = ACTIONS(2841),
    [sym_none] = ACTIONS(2841),
    [sym_true] = ACTIONS(2841),
    [sym_false] = ACTIONS(2841),
    [sym_nil] = ACTIONS(2841),
    [anon_sym_QMARK_DOT] = ACTIONS(2841),
    [anon_sym_POUND_LBRACK] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2841),
    [anon_sym_DOLLARif] = ACTIONS(2841),
    [anon_sym_is] = ACTIONS(2841),
    [anon_sym_BANGis] = ACTIONS(2841),
    [anon_sym_in] = ACTIONS(2841),
    [anon_sym_BANGin] = ACTIONS(2841),
    [anon_sym_match] = ACTIONS(2841),
    [anon_sym_select] = ACTIONS(2841),
    [anon_sym_lock] = ACTIONS(2841),
    [anon_sym_rlock] = ACTIONS(2841),
    [anon_sym_unsafe] = ACTIONS(2841),
    [anon_sym_sql] = ACTIONS(2841),
    [sym_int_literal] = ACTIONS(2841),
    [sym_float_literal] = ACTIONS(2841),
    [sym_rune_literal] = ACTIONS(2841),
    [anon_sym_SQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE] = ACTIONS(2841),
    [anon_sym_c_SQUOTE] = ACTIONS(2841),
    [anon_sym_c_DQUOTE] = ACTIONS(2841),
    [anon_sym_r_SQUOTE] = ACTIONS(2841),
    [anon_sym_r_DQUOTE] = ACTIONS(2841),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2841),
    [anon_sym_shared] = ACTIONS(2841),
    [anon_sym_map_LBRACK] = ACTIONS(2841),
    [anon_sym_chan] = ACTIONS(2841),
    [anon_sym_thread] = ACTIONS(2841),
    [anon_sym_atomic] = ACTIONS(2841),
    [anon_sym_assert] = ACTIONS(2841),
    [anon_sym_defer] = ACTIONS(2841),
    [anon_sym_goto] = ACTIONS(2841),
    [anon_sym_break] = ACTIONS(2841),
    [anon_sym_continue] = ACTIONS(2841),
    [anon_sym_return] = ACTIONS(2841),
    [anon_sym_DOLLARfor] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2841),
    [anon_sym_POUND] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2841),
    [anon_sym_AT_LBRACK] = ACTIONS(2841),
  },
  [1247] = {
    [sym_line_comment] = STATE(1247),
    [sym_block_comment] = STATE(1247),
    [ts_builtin_sym_end] = ACTIONS(2145),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_CR] = ACTIONS(2147),
    [anon_sym_CR_LF] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_COMMA] = ACTIONS(2335),
    [anon_sym_const] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym___global] = ACTIONS(2147),
    [anon_sym_type] = ACTIONS(2147),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2147),
    [anon_sym_BANG_EQ] = ACTIONS(2147),
    [anon_sym_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2147),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_union] = ACTIONS(2147),
    [anon_sym_pub] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_enum] = ACTIONS(2147),
    [anon_sym_interface] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2147),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2147),
    [anon_sym_AMP_CARET] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [anon_sym_or] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2147),
    [anon_sym_POUND_LBRACK] = ACTIONS(2147),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2147),
    [anon_sym_BANGis] = ACTIONS(2147),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANGin] = ACTIONS(2147),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2147),
    [sym_rune_literal] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_c_SQUOTE] = ACTIONS(2147),
    [anon_sym_c_DQUOTE] = ACTIONS(2147),
    [anon_sym_r_SQUOTE] = ACTIONS(2147),
    [anon_sym_r_DQUOTE] = ACTIONS(2147),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2147),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
    [anon_sym_assert] = ACTIONS(2147),
    [anon_sym_defer] = ACTIONS(2147),
    [anon_sym_goto] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_continue] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2147),
    [anon_sym_DOLLARfor] = ACTIONS(2147),
    [anon_sym_for] = ACTIONS(2147),
    [anon_sym_POUND] = ACTIONS(2147),
    [anon_sym_asm] = ACTIONS(2147),
    [anon_sym_AT_LBRACK] = ACTIONS(2147),
  },
  [1248] = {
    [sym_line_comment] = STATE(1248),
    [sym_block_comment] = STATE(1248),
    [ts_builtin_sym_end] = ACTIONS(3326),
    [sym_identifier] = ACTIONS(3328),
    [anon_sym_LF] = ACTIONS(3328),
    [anon_sym_CR] = ACTIONS(3328),
    [anon_sym_CR_LF] = ACTIONS(3328),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3328),
    [anon_sym_as] = ACTIONS(3328),
    [anon_sym_LBRACE] = ACTIONS(3328),
    [anon_sym_COMMA] = ACTIONS(3328),
    [anon_sym_const] = ACTIONS(3328),
    [anon_sym_LPAREN] = ACTIONS(3328),
    [anon_sym___global] = ACTIONS(3328),
    [anon_sym_type] = ACTIONS(3328),
    [anon_sym_fn] = ACTIONS(3328),
    [anon_sym_PLUS] = ACTIONS(3328),
    [anon_sym_DASH] = ACTIONS(3328),
    [anon_sym_STAR] = ACTIONS(3328),
    [anon_sym_SLASH] = ACTIONS(3328),
    [anon_sym_PERCENT] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(3328),
    [anon_sym_GT] = ACTIONS(3328),
    [anon_sym_EQ_EQ] = ACTIONS(3328),
    [anon_sym_BANG_EQ] = ACTIONS(3328),
    [anon_sym_LT_EQ] = ACTIONS(3328),
    [anon_sym_GT_EQ] = ACTIONS(3328),
    [anon_sym_LBRACK] = ACTIONS(3326),
    [anon_sym_struct] = ACTIONS(3328),
    [anon_sym_union] = ACTIONS(3328),
    [anon_sym_pub] = ACTIONS(3328),
    [anon_sym_mut] = ACTIONS(3328),
    [anon_sym_enum] = ACTIONS(3328),
    [anon_sym_interface] = ACTIONS(3328),
    [anon_sym_PLUS_PLUS] = ACTIONS(3328),
    [anon_sym_DASH_DASH] = ACTIONS(3328),
    [anon_sym_QMARK] = ACTIONS(3328),
    [anon_sym_BANG] = ACTIONS(3328),
    [anon_sym_go] = ACTIONS(3328),
    [anon_sym_spawn] = ACTIONS(3328),
    [anon_sym_json_DOTdecode] = ACTIONS(3328),
    [anon_sym_PIPE] = ACTIONS(3328),
    [anon_sym_LBRACK2] = ACTIONS(3328),
    [anon_sym_TILDE] = ACTIONS(3328),
    [anon_sym_CARET] = ACTIONS(3328),
    [anon_sym_AMP] = ACTIONS(3328),
    [anon_sym_LT_DASH] = ACTIONS(3328),
    [anon_sym_LT_LT] = ACTIONS(3328),
    [anon_sym_GT_GT] = ACTIONS(3328),
    [anon_sym_GT_GT_GT] = ACTIONS(3328),
    [anon_sym_AMP_CARET] = ACTIONS(3328),
    [anon_sym_AMP_AMP] = ACTIONS(3328),
    [anon_sym_PIPE_PIPE] = ACTIONS(3328),
    [anon_sym_or] = ACTIONS(3328),
    [sym_none] = ACTIONS(3328),
    [sym_true] = ACTIONS(3328),
    [sym_false] = ACTIONS(3328),
    [sym_nil] = ACTIONS(3328),
    [anon_sym_QMARK_DOT] = ACTIONS(3328),
    [anon_sym_POUND_LBRACK] = ACTIONS(3328),
    [anon_sym_if] = ACTIONS(3328),
    [anon_sym_DOLLARif] = ACTIONS(3328),
    [anon_sym_is] = ACTIONS(3328),
    [anon_sym_BANGis] = ACTIONS(3328),
    [anon_sym_in] = ACTIONS(3328),
    [anon_sym_BANGin] = ACTIONS(3328),
    [anon_sym_match] = ACTIONS(3328),
    [anon_sym_select] = ACTIONS(3328),
    [anon_sym_lock] = ACTIONS(3328),
    [anon_sym_rlock] = ACTIONS(3328),
    [anon_sym_unsafe] = ACTIONS(3328),
    [anon_sym_sql] = ACTIONS(3328),
    [sym_int_literal] = ACTIONS(3328),
    [sym_float_literal] = ACTIONS(3328),
    [sym_rune_literal] = ACTIONS(3328),
    [anon_sym_SQUOTE] = ACTIONS(3328),
    [anon_sym_DQUOTE] = ACTIONS(3328),
    [anon_sym_c_SQUOTE] = ACTIONS(3328),
    [anon_sym_c_DQUOTE] = ACTIONS(3328),
    [anon_sym_r_SQUOTE] = ACTIONS(3328),
    [anon_sym_r_DQUOTE] = ACTIONS(3328),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3328),
    [anon_sym_shared] = ACTIONS(3328),
    [anon_sym_map_LBRACK] = ACTIONS(3328),
    [anon_sym_chan] = ACTIONS(3328),
    [anon_sym_thread] = ACTIONS(3328),
    [anon_sym_atomic] = ACTIONS(3328),
    [anon_sym_assert] = ACTIONS(3328),
    [anon_sym_defer] = ACTIONS(3328),
    [anon_sym_goto] = ACTIONS(3328),
    [anon_sym_break] = ACTIONS(3328),
    [anon_sym_continue] = ACTIONS(3328),
    [anon_sym_return] = ACTIONS(3328),
    [anon_sym_DOLLARfor] = ACTIONS(3328),
    [anon_sym_for] = ACTIONS(3328),
    [anon_sym_POUND] = ACTIONS(3328),
    [anon_sym_asm] = ACTIONS(3328),
    [anon_sym_AT_LBRACK] = ACTIONS(3328),
  },
  [1249] = {
    [sym_line_comment] = STATE(1249),
    [sym_block_comment] = STATE(1249),
    [ts_builtin_sym_end] = ACTIONS(3354),
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_LF] = ACTIONS(3356),
    [anon_sym_CR] = ACTIONS(3356),
    [anon_sym_CR_LF] = ACTIONS(3356),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3356),
    [anon_sym_as] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3356),
    [anon_sym_COMMA] = ACTIONS(3356),
    [anon_sym_const] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3356),
    [anon_sym___global] = ACTIONS(3356),
    [anon_sym_type] = ACTIONS(3356),
    [anon_sym_fn] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_STAR] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_PERCENT] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_GT] = ACTIONS(3356),
    [anon_sym_EQ_EQ] = ACTIONS(3356),
    [anon_sym_BANG_EQ] = ACTIONS(3356),
    [anon_sym_LT_EQ] = ACTIONS(3356),
    [anon_sym_GT_EQ] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3354),
    [anon_sym_struct] = ACTIONS(3356),
    [anon_sym_union] = ACTIONS(3356),
    [anon_sym_pub] = ACTIONS(3356),
    [anon_sym_mut] = ACTIONS(3356),
    [anon_sym_enum] = ACTIONS(3356),
    [anon_sym_interface] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3356),
    [anon_sym_DASH_DASH] = ACTIONS(3356),
    [anon_sym_QMARK] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3356),
    [anon_sym_go] = ACTIONS(3356),
    [anon_sym_spawn] = ACTIONS(3356),
    [anon_sym_json_DOTdecode] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(3356),
    [anon_sym_LBRACK2] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3356),
    [anon_sym_CARET] = ACTIONS(3356),
    [anon_sym_AMP] = ACTIONS(3356),
    [anon_sym_LT_DASH] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(3356),
    [anon_sym_GT_GT] = ACTIONS(3356),
    [anon_sym_GT_GT_GT] = ACTIONS(3356),
    [anon_sym_AMP_CARET] = ACTIONS(3356),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_PIPE_PIPE] = ACTIONS(3356),
    [anon_sym_or] = ACTIONS(3356),
    [sym_none] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_nil] = ACTIONS(3356),
    [anon_sym_QMARK_DOT] = ACTIONS(3356),
    [anon_sym_POUND_LBRACK] = ACTIONS(3356),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_DOLLARif] = ACTIONS(3356),
    [anon_sym_is] = ACTIONS(3356),
    [anon_sym_BANGis] = ACTIONS(3356),
    [anon_sym_in] = ACTIONS(3356),
    [anon_sym_BANGin] = ACTIONS(3356),
    [anon_sym_match] = ACTIONS(3356),
    [anon_sym_select] = ACTIONS(3356),
    [anon_sym_lock] = ACTIONS(3356),
    [anon_sym_rlock] = ACTIONS(3356),
    [anon_sym_unsafe] = ACTIONS(3356),
    [anon_sym_sql] = ACTIONS(3356),
    [sym_int_literal] = ACTIONS(3356),
    [sym_float_literal] = ACTIONS(3356),
    [sym_rune_literal] = ACTIONS(3356),
    [anon_sym_SQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [anon_sym_c_SQUOTE] = ACTIONS(3356),
    [anon_sym_c_DQUOTE] = ACTIONS(3356),
    [anon_sym_r_SQUOTE] = ACTIONS(3356),
    [anon_sym_r_DQUOTE] = ACTIONS(3356),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3356),
    [anon_sym_shared] = ACTIONS(3356),
    [anon_sym_map_LBRACK] = ACTIONS(3356),
    [anon_sym_chan] = ACTIONS(3356),
    [anon_sym_thread] = ACTIONS(3356),
    [anon_sym_atomic] = ACTIONS(3356),
    [anon_sym_assert] = ACTIONS(3356),
    [anon_sym_defer] = ACTIONS(3356),
    [anon_sym_goto] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_DOLLARfor] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_POUND] = ACTIONS(3356),
    [anon_sym_asm] = ACTIONS(3356),
    [anon_sym_AT_LBRACK] = ACTIONS(3356),
  },
  [1250] = {
    [sym_line_comment] = STATE(1250),
    [sym_block_comment] = STATE(1250),
    [ts_builtin_sym_end] = ACTIONS(3067),
    [sym_identifier] = ACTIONS(3069),
    [anon_sym_LF] = ACTIONS(3069),
    [anon_sym_CR] = ACTIONS(3069),
    [anon_sym_CR_LF] = ACTIONS(3069),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3069),
    [anon_sym_as] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3069),
    [anon_sym_COMMA] = ACTIONS(3069),
    [anon_sym_const] = ACTIONS(3069),
    [anon_sym_LPAREN] = ACTIONS(3069),
    [anon_sym___global] = ACTIONS(3069),
    [anon_sym_type] = ACTIONS(3069),
    [anon_sym_fn] = ACTIONS(3069),
    [anon_sym_PLUS] = ACTIONS(3069),
    [anon_sym_DASH] = ACTIONS(3069),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_SLASH] = ACTIONS(3069),
    [anon_sym_PERCENT] = ACTIONS(3069),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_GT] = ACTIONS(3069),
    [anon_sym_EQ_EQ] = ACTIONS(3069),
    [anon_sym_BANG_EQ] = ACTIONS(3069),
    [anon_sym_LT_EQ] = ACTIONS(3069),
    [anon_sym_GT_EQ] = ACTIONS(3069),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_struct] = ACTIONS(3069),
    [anon_sym_union] = ACTIONS(3069),
    [anon_sym_pub] = ACTIONS(3069),
    [anon_sym_mut] = ACTIONS(3069),
    [anon_sym_enum] = ACTIONS(3069),
    [anon_sym_interface] = ACTIONS(3069),
    [anon_sym_PLUS_PLUS] = ACTIONS(3069),
    [anon_sym_DASH_DASH] = ACTIONS(3069),
    [anon_sym_QMARK] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(3069),
    [anon_sym_go] = ACTIONS(3069),
    [anon_sym_spawn] = ACTIONS(3069),
    [anon_sym_json_DOTdecode] = ACTIONS(3069),
    [anon_sym_PIPE] = ACTIONS(3069),
    [anon_sym_LBRACK2] = ACTIONS(3069),
    [anon_sym_TILDE] = ACTIONS(3069),
    [anon_sym_CARET] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3069),
    [anon_sym_LT_DASH] = ACTIONS(3069),
    [anon_sym_LT_LT] = ACTIONS(3069),
    [anon_sym_GT_GT] = ACTIONS(3069),
    [anon_sym_GT_GT_GT] = ACTIONS(3069),
    [anon_sym_AMP_CARET] = ACTIONS(3069),
    [anon_sym_AMP_AMP] = ACTIONS(3069),
    [anon_sym_PIPE_PIPE] = ACTIONS(3069),
    [anon_sym_or] = ACTIONS(3069),
    [sym_none] = ACTIONS(3069),
    [sym_true] = ACTIONS(3069),
    [sym_false] = ACTIONS(3069),
    [sym_nil] = ACTIONS(3069),
    [anon_sym_QMARK_DOT] = ACTIONS(3069),
    [anon_sym_POUND_LBRACK] = ACTIONS(3069),
    [anon_sym_if] = ACTIONS(3069),
    [anon_sym_DOLLARif] = ACTIONS(3069),
    [anon_sym_is] = ACTIONS(3069),
    [anon_sym_BANGis] = ACTIONS(3069),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_BANGin] = ACTIONS(3069),
    [anon_sym_match] = ACTIONS(3069),
    [anon_sym_select] = ACTIONS(3069),
    [anon_sym_lock] = ACTIONS(3069),
    [anon_sym_rlock] = ACTIONS(3069),
    [anon_sym_unsafe] = ACTIONS(3069),
    [anon_sym_sql] = ACTIONS(3069),
    [sym_int_literal] = ACTIONS(3069),
    [sym_float_literal] = ACTIONS(3069),
    [sym_rune_literal] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE] = ACTIONS(3069),
    [anon_sym_c_SQUOTE] = ACTIONS(3069),
    [anon_sym_c_DQUOTE] = ACTIONS(3069),
    [anon_sym_r_SQUOTE] = ACTIONS(3069),
    [anon_sym_r_DQUOTE] = ACTIONS(3069),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3069),
    [anon_sym_shared] = ACTIONS(3069),
    [anon_sym_map_LBRACK] = ACTIONS(3069),
    [anon_sym_chan] = ACTIONS(3069),
    [anon_sym_thread] = ACTIONS(3069),
    [anon_sym_atomic] = ACTIONS(3069),
    [anon_sym_assert] = ACTIONS(3069),
    [anon_sym_defer] = ACTIONS(3069),
    [anon_sym_goto] = ACTIONS(3069),
    [anon_sym_break] = ACTIONS(3069),
    [anon_sym_continue] = ACTIONS(3069),
    [anon_sym_return] = ACTIONS(3069),
    [anon_sym_DOLLARfor] = ACTIONS(3069),
    [anon_sym_for] = ACTIONS(3069),
    [anon_sym_POUND] = ACTIONS(3069),
    [anon_sym_asm] = ACTIONS(3069),
    [anon_sym_AT_LBRACK] = ACTIONS(3069),
  },
  [1251] = {
    [sym_line_comment] = STATE(1251),
    [sym_block_comment] = STATE(1251),
    [ts_builtin_sym_end] = ACTIONS(3043),
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_LF] = ACTIONS(3045),
    [anon_sym_CR] = ACTIONS(3045),
    [anon_sym_CR_LF] = ACTIONS(3045),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3045),
    [anon_sym_as] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3045),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_const] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3045),
    [anon_sym___global] = ACTIONS(3045),
    [anon_sym_type] = ACTIONS(3045),
    [anon_sym_fn] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3045),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_PERCENT] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_GT] = ACTIONS(3045),
    [anon_sym_EQ_EQ] = ACTIONS(3045),
    [anon_sym_BANG_EQ] = ACTIONS(3045),
    [anon_sym_LT_EQ] = ACTIONS(3045),
    [anon_sym_GT_EQ] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_struct] = ACTIONS(3045),
    [anon_sym_union] = ACTIONS(3045),
    [anon_sym_pub] = ACTIONS(3045),
    [anon_sym_mut] = ACTIONS(3045),
    [anon_sym_enum] = ACTIONS(3045),
    [anon_sym_interface] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3045),
    [anon_sym_go] = ACTIONS(3045),
    [anon_sym_spawn] = ACTIONS(3045),
    [anon_sym_json_DOTdecode] = ACTIONS(3045),
    [anon_sym_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACK2] = ACTIONS(3045),
    [anon_sym_TILDE] = ACTIONS(3045),
    [anon_sym_CARET] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3045),
    [anon_sym_LT_DASH] = ACTIONS(3045),
    [anon_sym_LT_LT] = ACTIONS(3045),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_GT_GT_GT] = ACTIONS(3045),
    [anon_sym_AMP_CARET] = ACTIONS(3045),
    [anon_sym_AMP_AMP] = ACTIONS(3045),
    [anon_sym_PIPE_PIPE] = ACTIONS(3045),
    [anon_sym_or] = ACTIONS(3045),
    [sym_none] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_nil] = ACTIONS(3045),
    [anon_sym_QMARK_DOT] = ACTIONS(3045),
    [anon_sym_POUND_LBRACK] = ACTIONS(3045),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_DOLLARif] = ACTIONS(3045),
    [anon_sym_is] = ACTIONS(3045),
    [anon_sym_BANGis] = ACTIONS(3045),
    [anon_sym_in] = ACTIONS(3045),
    [anon_sym_BANGin] = ACTIONS(3045),
    [anon_sym_match] = ACTIONS(3045),
    [anon_sym_select] = ACTIONS(3045),
    [anon_sym_lock] = ACTIONS(3045),
    [anon_sym_rlock] = ACTIONS(3045),
    [anon_sym_unsafe] = ACTIONS(3045),
    [anon_sym_sql] = ACTIONS(3045),
    [sym_int_literal] = ACTIONS(3045),
    [sym_float_literal] = ACTIONS(3045),
    [sym_rune_literal] = ACTIONS(3045),
    [anon_sym_SQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE] = ACTIONS(3045),
    [anon_sym_c_SQUOTE] = ACTIONS(3045),
    [anon_sym_c_DQUOTE] = ACTIONS(3045),
    [anon_sym_r_SQUOTE] = ACTIONS(3045),
    [anon_sym_r_DQUOTE] = ACTIONS(3045),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3045),
    [anon_sym_shared] = ACTIONS(3045),
    [anon_sym_map_LBRACK] = ACTIONS(3045),
    [anon_sym_chan] = ACTIONS(3045),
    [anon_sym_thread] = ACTIONS(3045),
    [anon_sym_atomic] = ACTIONS(3045),
    [anon_sym_assert] = ACTIONS(3045),
    [anon_sym_defer] = ACTIONS(3045),
    [anon_sym_goto] = ACTIONS(3045),
    [anon_sym_break] = ACTIONS(3045),
    [anon_sym_continue] = ACTIONS(3045),
    [anon_sym_return] = ACTIONS(3045),
    [anon_sym_DOLLARfor] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3045),
    [anon_sym_POUND] = ACTIONS(3045),
    [anon_sym_asm] = ACTIONS(3045),
    [anon_sym_AT_LBRACK] = ACTIONS(3045),
  },
  [1252] = {
    [sym_line_comment] = STATE(1252),
    [sym_block_comment] = STATE(1252),
    [ts_builtin_sym_end] = ACTIONS(3033),
    [sym_identifier] = ACTIONS(3035),
    [anon_sym_LF] = ACTIONS(3035),
    [anon_sym_CR] = ACTIONS(3035),
    [anon_sym_CR_LF] = ACTIONS(3035),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3035),
    [anon_sym_as] = ACTIONS(3035),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_COMMA] = ACTIONS(3035),
    [anon_sym_const] = ACTIONS(3035),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym___global] = ACTIONS(3035),
    [anon_sym_type] = ACTIONS(3035),
    [anon_sym_fn] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3035),
    [anon_sym_SLASH] = ACTIONS(3035),
    [anon_sym_PERCENT] = ACTIONS(3035),
    [anon_sym_LT] = ACTIONS(3035),
    [anon_sym_GT] = ACTIONS(3035),
    [anon_sym_EQ_EQ] = ACTIONS(3035),
    [anon_sym_BANG_EQ] = ACTIONS(3035),
    [anon_sym_LT_EQ] = ACTIONS(3035),
    [anon_sym_GT_EQ] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3033),
    [anon_sym_struct] = ACTIONS(3035),
    [anon_sym_union] = ACTIONS(3035),
    [anon_sym_pub] = ACTIONS(3035),
    [anon_sym_mut] = ACTIONS(3035),
    [anon_sym_enum] = ACTIONS(3035),
    [anon_sym_interface] = ACTIONS(3035),
    [anon_sym_PLUS_PLUS] = ACTIONS(3035),
    [anon_sym_DASH_DASH] = ACTIONS(3035),
    [anon_sym_QMARK] = ACTIONS(3035),
    [anon_sym_BANG] = ACTIONS(3035),
    [anon_sym_go] = ACTIONS(3035),
    [anon_sym_spawn] = ACTIONS(3035),
    [anon_sym_json_DOTdecode] = ACTIONS(3035),
    [anon_sym_PIPE] = ACTIONS(3035),
    [anon_sym_LBRACK2] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3035),
    [anon_sym_CARET] = ACTIONS(3035),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_LT_DASH] = ACTIONS(3035),
    [anon_sym_LT_LT] = ACTIONS(3035),
    [anon_sym_GT_GT] = ACTIONS(3035),
    [anon_sym_GT_GT_GT] = ACTIONS(3035),
    [anon_sym_AMP_CARET] = ACTIONS(3035),
    [anon_sym_AMP_AMP] = ACTIONS(3035),
    [anon_sym_PIPE_PIPE] = ACTIONS(3035),
    [anon_sym_or] = ACTIONS(3035),
    [sym_none] = ACTIONS(3035),
    [sym_true] = ACTIONS(3035),
    [sym_false] = ACTIONS(3035),
    [sym_nil] = ACTIONS(3035),
    [anon_sym_QMARK_DOT] = ACTIONS(3035),
    [anon_sym_POUND_LBRACK] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_DOLLARif] = ACTIONS(3035),
    [anon_sym_is] = ACTIONS(3035),
    [anon_sym_BANGis] = ACTIONS(3035),
    [anon_sym_in] = ACTIONS(3035),
    [anon_sym_BANGin] = ACTIONS(3035),
    [anon_sym_match] = ACTIONS(3035),
    [anon_sym_select] = ACTIONS(3035),
    [anon_sym_lock] = ACTIONS(3035),
    [anon_sym_rlock] = ACTIONS(3035),
    [anon_sym_unsafe] = ACTIONS(3035),
    [anon_sym_sql] = ACTIONS(3035),
    [sym_int_literal] = ACTIONS(3035),
    [sym_float_literal] = ACTIONS(3035),
    [sym_rune_literal] = ACTIONS(3035),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_c_SQUOTE] = ACTIONS(3035),
    [anon_sym_c_DQUOTE] = ACTIONS(3035),
    [anon_sym_r_SQUOTE] = ACTIONS(3035),
    [anon_sym_r_DQUOTE] = ACTIONS(3035),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3035),
    [anon_sym_shared] = ACTIONS(3035),
    [anon_sym_map_LBRACK] = ACTIONS(3035),
    [anon_sym_chan] = ACTIONS(3035),
    [anon_sym_thread] = ACTIONS(3035),
    [anon_sym_atomic] = ACTIONS(3035),
    [anon_sym_assert] = ACTIONS(3035),
    [anon_sym_defer] = ACTIONS(3035),
    [anon_sym_goto] = ACTIONS(3035),
    [anon_sym_break] = ACTIONS(3035),
    [anon_sym_continue] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_DOLLARfor] = ACTIONS(3035),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_POUND] = ACTIONS(3035),
    [anon_sym_asm] = ACTIONS(3035),
    [anon_sym_AT_LBRACK] = ACTIONS(3035),
  },
  [1253] = {
    [sym_line_comment] = STATE(1253),
    [sym_block_comment] = STATE(1253),
    [ts_builtin_sym_end] = ACTIONS(3344),
    [sym_identifier] = ACTIONS(3346),
    [anon_sym_LF] = ACTIONS(3346),
    [anon_sym_CR] = ACTIONS(3346),
    [anon_sym_CR_LF] = ACTIONS(3346),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3346),
    [anon_sym_as] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_COMMA] = ACTIONS(3346),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3346),
    [anon_sym___global] = ACTIONS(3346),
    [anon_sym_type] = ACTIONS(3346),
    [anon_sym_fn] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_SLASH] = ACTIONS(3346),
    [anon_sym_PERCENT] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_GT] = ACTIONS(3346),
    [anon_sym_EQ_EQ] = ACTIONS(3346),
    [anon_sym_BANG_EQ] = ACTIONS(3346),
    [anon_sym_LT_EQ] = ACTIONS(3346),
    [anon_sym_GT_EQ] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3346),
    [anon_sym_union] = ACTIONS(3346),
    [anon_sym_pub] = ACTIONS(3346),
    [anon_sym_mut] = ACTIONS(3346),
    [anon_sym_enum] = ACTIONS(3346),
    [anon_sym_interface] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_QMARK] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_go] = ACTIONS(3346),
    [anon_sym_spawn] = ACTIONS(3346),
    [anon_sym_json_DOTdecode] = ACTIONS(3346),
    [anon_sym_PIPE] = ACTIONS(3346),
    [anon_sym_LBRACK2] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_CARET] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym_LT_DASH] = ACTIONS(3346),
    [anon_sym_LT_LT] = ACTIONS(3346),
    [anon_sym_GT_GT] = ACTIONS(3346),
    [anon_sym_GT_GT_GT] = ACTIONS(3346),
    [anon_sym_AMP_CARET] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_PIPE_PIPE] = ACTIONS(3346),
    [anon_sym_or] = ACTIONS(3346),
    [sym_none] = ACTIONS(3346),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [sym_nil] = ACTIONS(3346),
    [anon_sym_QMARK_DOT] = ACTIONS(3346),
    [anon_sym_POUND_LBRACK] = ACTIONS(3346),
    [anon_sym_if] = ACTIONS(3346),
    [anon_sym_DOLLARif] = ACTIONS(3346),
    [anon_sym_is] = ACTIONS(3346),
    [anon_sym_BANGis] = ACTIONS(3346),
    [anon_sym_in] = ACTIONS(3346),
    [anon_sym_BANGin] = ACTIONS(3346),
    [anon_sym_match] = ACTIONS(3346),
    [anon_sym_select] = ACTIONS(3346),
    [anon_sym_lock] = ACTIONS(3346),
    [anon_sym_rlock] = ACTIONS(3346),
    [anon_sym_unsafe] = ACTIONS(3346),
    [anon_sym_sql] = ACTIONS(3346),
    [sym_int_literal] = ACTIONS(3346),
    [sym_float_literal] = ACTIONS(3346),
    [sym_rune_literal] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [anon_sym_c_SQUOTE] = ACTIONS(3346),
    [anon_sym_c_DQUOTE] = ACTIONS(3346),
    [anon_sym_r_SQUOTE] = ACTIONS(3346),
    [anon_sym_r_DQUOTE] = ACTIONS(3346),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3346),
    [anon_sym_shared] = ACTIONS(3346),
    [anon_sym_map_LBRACK] = ACTIONS(3346),
    [anon_sym_chan] = ACTIONS(3346),
    [anon_sym_thread] = ACTIONS(3346),
    [anon_sym_atomic] = ACTIONS(3346),
    [anon_sym_assert] = ACTIONS(3346),
    [anon_sym_defer] = ACTIONS(3346),
    [anon_sym_goto] = ACTIONS(3346),
    [anon_sym_break] = ACTIONS(3346),
    [anon_sym_continue] = ACTIONS(3346),
    [anon_sym_return] = ACTIONS(3346),
    [anon_sym_DOLLARfor] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3346),
    [anon_sym_POUND] = ACTIONS(3346),
    [anon_sym_asm] = ACTIONS(3346),
    [anon_sym_AT_LBRACK] = ACTIONS(3346),
  },
  [1254] = {
    [sym_line_comment] = STATE(1254),
    [sym_block_comment] = STATE(1254),
    [ts_builtin_sym_end] = ACTIONS(3322),
    [sym_identifier] = ACTIONS(3324),
    [anon_sym_LF] = ACTIONS(3324),
    [anon_sym_CR] = ACTIONS(3324),
    [anon_sym_CR_LF] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3324),
    [anon_sym_as] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3324),
    [anon_sym_COMMA] = ACTIONS(3324),
    [anon_sym_const] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3324),
    [anon_sym___global] = ACTIONS(3324),
    [anon_sym_type] = ACTIONS(3324),
    [anon_sym_fn] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3324),
    [anon_sym_DASH] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3324),
    [anon_sym_SLASH] = ACTIONS(3324),
    [anon_sym_PERCENT] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_GT] = ACTIONS(3324),
    [anon_sym_EQ_EQ] = ACTIONS(3324),
    [anon_sym_BANG_EQ] = ACTIONS(3324),
    [anon_sym_LT_EQ] = ACTIONS(3324),
    [anon_sym_GT_EQ] = ACTIONS(3324),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_struct] = ACTIONS(3324),
    [anon_sym_union] = ACTIONS(3324),
    [anon_sym_pub] = ACTIONS(3324),
    [anon_sym_mut] = ACTIONS(3324),
    [anon_sym_enum] = ACTIONS(3324),
    [anon_sym_interface] = ACTIONS(3324),
    [anon_sym_PLUS_PLUS] = ACTIONS(3324),
    [anon_sym_DASH_DASH] = ACTIONS(3324),
    [anon_sym_QMARK] = ACTIONS(3324),
    [anon_sym_BANG] = ACTIONS(3324),
    [anon_sym_go] = ACTIONS(3324),
    [anon_sym_spawn] = ACTIONS(3324),
    [anon_sym_json_DOTdecode] = ACTIONS(3324),
    [anon_sym_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACK2] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3324),
    [anon_sym_LT_DASH] = ACTIONS(3324),
    [anon_sym_LT_LT] = ACTIONS(3324),
    [anon_sym_GT_GT] = ACTIONS(3324),
    [anon_sym_GT_GT_GT] = ACTIONS(3324),
    [anon_sym_AMP_CARET] = ACTIONS(3324),
    [anon_sym_AMP_AMP] = ACTIONS(3324),
    [anon_sym_PIPE_PIPE] = ACTIONS(3324),
    [anon_sym_or] = ACTIONS(3324),
    [sym_none] = ACTIONS(3324),
    [sym_true] = ACTIONS(3324),
    [sym_false] = ACTIONS(3324),
    [sym_nil] = ACTIONS(3324),
    [anon_sym_QMARK_DOT] = ACTIONS(3324),
    [anon_sym_POUND_LBRACK] = ACTIONS(3324),
    [anon_sym_if] = ACTIONS(3324),
    [anon_sym_DOLLARif] = ACTIONS(3324),
    [anon_sym_is] = ACTIONS(3324),
    [anon_sym_BANGis] = ACTIONS(3324),
    [anon_sym_in] = ACTIONS(3324),
    [anon_sym_BANGin] = ACTIONS(3324),
    [anon_sym_match] = ACTIONS(3324),
    [anon_sym_select] = ACTIONS(3324),
    [anon_sym_lock] = ACTIONS(3324),
    [anon_sym_rlock] = ACTIONS(3324),
    [anon_sym_unsafe] = ACTIONS(3324),
    [anon_sym_sql] = ACTIONS(3324),
    [sym_int_literal] = ACTIONS(3324),
    [sym_float_literal] = ACTIONS(3324),
    [sym_rune_literal] = ACTIONS(3324),
    [anon_sym_SQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE] = ACTIONS(3324),
    [anon_sym_c_SQUOTE] = ACTIONS(3324),
    [anon_sym_c_DQUOTE] = ACTIONS(3324),
    [anon_sym_r_SQUOTE] = ACTIONS(3324),
    [anon_sym_r_DQUOTE] = ACTIONS(3324),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3324),
    [anon_sym_shared] = ACTIONS(3324),
    [anon_sym_map_LBRACK] = ACTIONS(3324),
    [anon_sym_chan] = ACTIONS(3324),
    [anon_sym_thread] = ACTIONS(3324),
    [anon_sym_atomic] = ACTIONS(3324),
    [anon_sym_assert] = ACTIONS(3324),
    [anon_sym_defer] = ACTIONS(3324),
    [anon_sym_goto] = ACTIONS(3324),
    [anon_sym_break] = ACTIONS(3324),
    [anon_sym_continue] = ACTIONS(3324),
    [anon_sym_return] = ACTIONS(3324),
    [anon_sym_DOLLARfor] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3324),
    [anon_sym_POUND] = ACTIONS(3324),
    [anon_sym_asm] = ACTIONS(3324),
    [anon_sym_AT_LBRACK] = ACTIONS(3324),
  },
  [1255] = {
    [sym_line_comment] = STATE(1255),
    [sym_block_comment] = STATE(1255),
    [ts_builtin_sym_end] = ACTIONS(3316),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LF] = ACTIONS(3318),
    [anon_sym_CR] = ACTIONS(3318),
    [anon_sym_CR_LF] = ACTIONS(3318),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_as] = ACTIONS(3318),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3318),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym___global] = ACTIONS(3318),
    [anon_sym_type] = ACTIONS(3318),
    [anon_sym_fn] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_SLASH] = ACTIONS(3318),
    [anon_sym_PERCENT] = ACTIONS(3318),
    [anon_sym_LT] = ACTIONS(3318),
    [anon_sym_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_LT_EQ] = ACTIONS(3318),
    [anon_sym_GT_EQ] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3316),
    [anon_sym_struct] = ACTIONS(3318),
    [anon_sym_union] = ACTIONS(3318),
    [anon_sym_pub] = ACTIONS(3318),
    [anon_sym_mut] = ACTIONS(3318),
    [anon_sym_enum] = ACTIONS(3318),
    [anon_sym_interface] = ACTIONS(3318),
    [anon_sym_PLUS_PLUS] = ACTIONS(3318),
    [anon_sym_DASH_DASH] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_BANG] = ACTIONS(3318),
    [anon_sym_go] = ACTIONS(3318),
    [anon_sym_spawn] = ACTIONS(3318),
    [anon_sym_json_DOTdecode] = ACTIONS(3318),
    [anon_sym_PIPE] = ACTIONS(3318),
    [anon_sym_LBRACK2] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3318),
    [anon_sym_CARET] = ACTIONS(3318),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LT_DASH] = ACTIONS(3318),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_GT_GT_GT] = ACTIONS(3318),
    [anon_sym_AMP_CARET] = ACTIONS(3318),
    [anon_sym_AMP_AMP] = ACTIONS(3318),
    [anon_sym_PIPE_PIPE] = ACTIONS(3318),
    [anon_sym_or] = ACTIONS(3318),
    [sym_none] = ACTIONS(3318),
    [sym_true] = ACTIONS(3318),
    [sym_false] = ACTIONS(3318),
    [sym_nil] = ACTIONS(3318),
    [anon_sym_QMARK_DOT] = ACTIONS(3318),
    [anon_sym_POUND_LBRACK] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_DOLLARif] = ACTIONS(3318),
    [anon_sym_is] = ACTIONS(3318),
    [anon_sym_BANGis] = ACTIONS(3318),
    [anon_sym_in] = ACTIONS(3318),
    [anon_sym_BANGin] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_select] = ACTIONS(3318),
    [anon_sym_lock] = ACTIONS(3318),
    [anon_sym_rlock] = ACTIONS(3318),
    [anon_sym_unsafe] = ACTIONS(3318),
    [anon_sym_sql] = ACTIONS(3318),
    [sym_int_literal] = ACTIONS(3318),
    [sym_float_literal] = ACTIONS(3318),
    [sym_rune_literal] = ACTIONS(3318),
    [anon_sym_SQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_c_SQUOTE] = ACTIONS(3318),
    [anon_sym_c_DQUOTE] = ACTIONS(3318),
    [anon_sym_r_SQUOTE] = ACTIONS(3318),
    [anon_sym_r_DQUOTE] = ACTIONS(3318),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3318),
    [anon_sym_shared] = ACTIONS(3318),
    [anon_sym_map_LBRACK] = ACTIONS(3318),
    [anon_sym_chan] = ACTIONS(3318),
    [anon_sym_thread] = ACTIONS(3318),
    [anon_sym_atomic] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_defer] = ACTIONS(3318),
    [anon_sym_goto] = ACTIONS(3318),
    [anon_sym_break] = ACTIONS(3318),
    [anon_sym_continue] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_DOLLARfor] = ACTIONS(3318),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_POUND] = ACTIONS(3318),
    [anon_sym_asm] = ACTIONS(3318),
    [anon_sym_AT_LBRACK] = ACTIONS(3318),
  },
  [1256] = {
    [sym_line_comment] = STATE(1256),
    [sym_block_comment] = STATE(1256),
    [ts_builtin_sym_end] = ACTIONS(2955),
    [sym_identifier] = ACTIONS(2957),
    [anon_sym_LF] = ACTIONS(2957),
    [anon_sym_CR] = ACTIONS(2957),
    [anon_sym_CR_LF] = ACTIONS(2957),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2957),
    [anon_sym_as] = ACTIONS(2957),
    [anon_sym_LBRACE] = ACTIONS(2957),
    [anon_sym_COMMA] = ACTIONS(2957),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_LPAREN] = ACTIONS(2957),
    [anon_sym___global] = ACTIONS(2957),
    [anon_sym_type] = ACTIONS(2957),
    [anon_sym_fn] = ACTIONS(2957),
    [anon_sym_PLUS] = ACTIONS(2957),
    [anon_sym_DASH] = ACTIONS(2957),
    [anon_sym_STAR] = ACTIONS(2957),
    [anon_sym_SLASH] = ACTIONS(2957),
    [anon_sym_PERCENT] = ACTIONS(2957),
    [anon_sym_LT] = ACTIONS(2957),
    [anon_sym_GT] = ACTIONS(2957),
    [anon_sym_EQ_EQ] = ACTIONS(2957),
    [anon_sym_BANG_EQ] = ACTIONS(2957),
    [anon_sym_LT_EQ] = ACTIONS(2957),
    [anon_sym_GT_EQ] = ACTIONS(2957),
    [anon_sym_LBRACK] = ACTIONS(2955),
    [anon_sym_struct] = ACTIONS(2957),
    [anon_sym_union] = ACTIONS(2957),
    [anon_sym_pub] = ACTIONS(2957),
    [anon_sym_mut] = ACTIONS(2957),
    [anon_sym_enum] = ACTIONS(2957),
    [anon_sym_interface] = ACTIONS(2957),
    [anon_sym_PLUS_PLUS] = ACTIONS(2957),
    [anon_sym_DASH_DASH] = ACTIONS(2957),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_BANG] = ACTIONS(2957),
    [anon_sym_go] = ACTIONS(2957),
    [anon_sym_spawn] = ACTIONS(2957),
    [anon_sym_json_DOTdecode] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2957),
    [anon_sym_LBRACK2] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2957),
    [anon_sym_CARET] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2957),
    [anon_sym_LT_DASH] = ACTIONS(2957),
    [anon_sym_LT_LT] = ACTIONS(2957),
    [anon_sym_GT_GT] = ACTIONS(2957),
    [anon_sym_GT_GT_GT] = ACTIONS(2957),
    [anon_sym_AMP_CARET] = ACTIONS(2957),
    [anon_sym_AMP_AMP] = ACTIONS(2957),
    [anon_sym_PIPE_PIPE] = ACTIONS(2957),
    [anon_sym_or] = ACTIONS(2957),
    [sym_none] = ACTIONS(2957),
    [sym_true] = ACTIONS(2957),
    [sym_false] = ACTIONS(2957),
    [sym_nil] = ACTIONS(2957),
    [anon_sym_QMARK_DOT] = ACTIONS(2957),
    [anon_sym_POUND_LBRACK] = ACTIONS(2957),
    [anon_sym_if] = ACTIONS(2957),
    [anon_sym_DOLLARif] = ACTIONS(2957),
    [anon_sym_is] = ACTIONS(2957),
    [anon_sym_BANGis] = ACTIONS(2957),
    [anon_sym_in] = ACTIONS(2957),
    [anon_sym_BANGin] = ACTIONS(2957),
    [anon_sym_match] = ACTIONS(2957),
    [anon_sym_select] = ACTIONS(2957),
    [anon_sym_lock] = ACTIONS(2957),
    [anon_sym_rlock] = ACTIONS(2957),
    [anon_sym_unsafe] = ACTIONS(2957),
    [anon_sym_sql] = ACTIONS(2957),
    [sym_int_literal] = ACTIONS(2957),
    [sym_float_literal] = ACTIONS(2957),
    [sym_rune_literal] = ACTIONS(2957),
    [anon_sym_SQUOTE] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(2957),
    [anon_sym_c_SQUOTE] = ACTIONS(2957),
    [anon_sym_c_DQUOTE] = ACTIONS(2957),
    [anon_sym_r_SQUOTE] = ACTIONS(2957),
    [anon_sym_r_DQUOTE] = ACTIONS(2957),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2957),
    [anon_sym_shared] = ACTIONS(2957),
    [anon_sym_map_LBRACK] = ACTIONS(2957),
    [anon_sym_chan] = ACTIONS(2957),
    [anon_sym_thread] = ACTIONS(2957),
    [anon_sym_atomic] = ACTIONS(2957),
    [anon_sym_assert] = ACTIONS(2957),
    [anon_sym_defer] = ACTIONS(2957),
    [anon_sym_goto] = ACTIONS(2957),
    [anon_sym_break] = ACTIONS(2957),
    [anon_sym_continue] = ACTIONS(2957),
    [anon_sym_return] = ACTIONS(2957),
    [anon_sym_DOLLARfor] = ACTIONS(2957),
    [anon_sym_for] = ACTIONS(2957),
    [anon_sym_POUND] = ACTIONS(2957),
    [anon_sym_asm] = ACTIONS(2957),
    [anon_sym_AT_LBRACK] = ACTIONS(2957),
  },
  [1257] = {
    [sym_line_comment] = STATE(1257),
    [sym_block_comment] = STATE(1257),
    [ts_builtin_sym_end] = ACTIONS(2863),
    [sym_identifier] = ACTIONS(2865),
    [anon_sym_LF] = ACTIONS(2865),
    [anon_sym_CR] = ACTIONS(2865),
    [anon_sym_CR_LF] = ACTIONS(2865),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2865),
    [anon_sym_as] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2865),
    [anon_sym_COMMA] = ACTIONS(2865),
    [anon_sym_const] = ACTIONS(2865),
    [anon_sym_LPAREN] = ACTIONS(2865),
    [anon_sym___global] = ACTIONS(2865),
    [anon_sym_type] = ACTIONS(2865),
    [anon_sym_fn] = ACTIONS(2865),
    [anon_sym_PLUS] = ACTIONS(2865),
    [anon_sym_DASH] = ACTIONS(2865),
    [anon_sym_STAR] = ACTIONS(2865),
    [anon_sym_SLASH] = ACTIONS(2865),
    [anon_sym_PERCENT] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_GT] = ACTIONS(2865),
    [anon_sym_EQ_EQ] = ACTIONS(2865),
    [anon_sym_BANG_EQ] = ACTIONS(2865),
    [anon_sym_LT_EQ] = ACTIONS(2865),
    [anon_sym_GT_EQ] = ACTIONS(2865),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_struct] = ACTIONS(2865),
    [anon_sym_union] = ACTIONS(2865),
    [anon_sym_pub] = ACTIONS(2865),
    [anon_sym_mut] = ACTIONS(2865),
    [anon_sym_enum] = ACTIONS(2865),
    [anon_sym_interface] = ACTIONS(2865),
    [anon_sym_PLUS_PLUS] = ACTIONS(2865),
    [anon_sym_DASH_DASH] = ACTIONS(2865),
    [anon_sym_QMARK] = ACTIONS(2865),
    [anon_sym_BANG] = ACTIONS(2865),
    [anon_sym_go] = ACTIONS(2865),
    [anon_sym_spawn] = ACTIONS(2865),
    [anon_sym_json_DOTdecode] = ACTIONS(2865),
    [anon_sym_PIPE] = ACTIONS(2865),
    [anon_sym_LBRACK2] = ACTIONS(2865),
    [anon_sym_TILDE] = ACTIONS(2865),
    [anon_sym_CARET] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2865),
    [anon_sym_LT_DASH] = ACTIONS(2865),
    [anon_sym_LT_LT] = ACTIONS(2865),
    [anon_sym_GT_GT] = ACTIONS(2865),
    [anon_sym_GT_GT_GT] = ACTIONS(2865),
    [anon_sym_AMP_CARET] = ACTIONS(2865),
    [anon_sym_AMP_AMP] = ACTIONS(2865),
    [anon_sym_PIPE_PIPE] = ACTIONS(2865),
    [anon_sym_or] = ACTIONS(2865),
    [sym_none] = ACTIONS(2865),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_nil] = ACTIONS(2865),
    [anon_sym_QMARK_DOT] = ACTIONS(2865),
    [anon_sym_POUND_LBRACK] = ACTIONS(2865),
    [anon_sym_if] = ACTIONS(2865),
    [anon_sym_DOLLARif] = ACTIONS(2865),
    [anon_sym_is] = ACTIONS(2865),
    [anon_sym_BANGis] = ACTIONS(2865),
    [anon_sym_in] = ACTIONS(2865),
    [anon_sym_BANGin] = ACTIONS(2865),
    [anon_sym_match] = ACTIONS(2865),
    [anon_sym_select] = ACTIONS(2865),
    [anon_sym_lock] = ACTIONS(2865),
    [anon_sym_rlock] = ACTIONS(2865),
    [anon_sym_unsafe] = ACTIONS(2865),
    [anon_sym_sql] = ACTIONS(2865),
    [sym_int_literal] = ACTIONS(2865),
    [sym_float_literal] = ACTIONS(2865),
    [sym_rune_literal] = ACTIONS(2865),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_DQUOTE] = ACTIONS(2865),
    [anon_sym_c_SQUOTE] = ACTIONS(2865),
    [anon_sym_c_DQUOTE] = ACTIONS(2865),
    [anon_sym_r_SQUOTE] = ACTIONS(2865),
    [anon_sym_r_DQUOTE] = ACTIONS(2865),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2865),
    [anon_sym_shared] = ACTIONS(2865),
    [anon_sym_map_LBRACK] = ACTIONS(2865),
    [anon_sym_chan] = ACTIONS(2865),
    [anon_sym_thread] = ACTIONS(2865),
    [anon_sym_atomic] = ACTIONS(2865),
    [anon_sym_assert] = ACTIONS(2865),
    [anon_sym_defer] = ACTIONS(2865),
    [anon_sym_goto] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2865),
    [anon_sym_continue] = ACTIONS(2865),
    [anon_sym_return] = ACTIONS(2865),
    [anon_sym_DOLLARfor] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2865),
    [anon_sym_POUND] = ACTIONS(2865),
    [anon_sym_asm] = ACTIONS(2865),
    [anon_sym_AT_LBRACK] = ACTIONS(2865),
  },
  [1258] = {
    [sym_line_comment] = STATE(1258),
    [sym_block_comment] = STATE(1258),
    [ts_builtin_sym_end] = ACTIONS(3082),
    [sym_identifier] = ACTIONS(3084),
    [anon_sym_LF] = ACTIONS(3084),
    [anon_sym_CR] = ACTIONS(3084),
    [anon_sym_CR_LF] = ACTIONS(3084),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3084),
    [anon_sym_as] = ACTIONS(3084),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_COMMA] = ACTIONS(3084),
    [anon_sym_const] = ACTIONS(3084),
    [anon_sym_LPAREN] = ACTIONS(3084),
    [anon_sym___global] = ACTIONS(3084),
    [anon_sym_type] = ACTIONS(3084),
    [anon_sym_fn] = ACTIONS(3084),
    [anon_sym_PLUS] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_SLASH] = ACTIONS(3084),
    [anon_sym_PERCENT] = ACTIONS(3084),
    [anon_sym_LT] = ACTIONS(3084),
    [anon_sym_GT] = ACTIONS(3084),
    [anon_sym_EQ_EQ] = ACTIONS(3084),
    [anon_sym_BANG_EQ] = ACTIONS(3084),
    [anon_sym_LT_EQ] = ACTIONS(3084),
    [anon_sym_GT_EQ] = ACTIONS(3084),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3084),
    [anon_sym_union] = ACTIONS(3084),
    [anon_sym_pub] = ACTIONS(3084),
    [anon_sym_mut] = ACTIONS(3084),
    [anon_sym_enum] = ACTIONS(3084),
    [anon_sym_interface] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_QMARK] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_go] = ACTIONS(3084),
    [anon_sym_spawn] = ACTIONS(3084),
    [anon_sym_json_DOTdecode] = ACTIONS(3084),
    [anon_sym_PIPE] = ACTIONS(3084),
    [anon_sym_LBRACK2] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_CARET] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3084),
    [anon_sym_LT_DASH] = ACTIONS(3084),
    [anon_sym_LT_LT] = ACTIONS(3084),
    [anon_sym_GT_GT] = ACTIONS(3084),
    [anon_sym_GT_GT_GT] = ACTIONS(3084),
    [anon_sym_AMP_CARET] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_PIPE_PIPE] = ACTIONS(3084),
    [anon_sym_or] = ACTIONS(3084),
    [sym_none] = ACTIONS(3084),
    [sym_true] = ACTIONS(3084),
    [sym_false] = ACTIONS(3084),
    [sym_nil] = ACTIONS(3084),
    [anon_sym_QMARK_DOT] = ACTIONS(3084),
    [anon_sym_POUND_LBRACK] = ACTIONS(3084),
    [anon_sym_if] = ACTIONS(3084),
    [anon_sym_DOLLARif] = ACTIONS(3084),
    [anon_sym_is] = ACTIONS(3084),
    [anon_sym_BANGis] = ACTIONS(3084),
    [anon_sym_in] = ACTIONS(3084),
    [anon_sym_BANGin] = ACTIONS(3084),
    [anon_sym_match] = ACTIONS(3084),
    [anon_sym_select] = ACTIONS(3084),
    [anon_sym_lock] = ACTIONS(3084),
    [anon_sym_rlock] = ACTIONS(3084),
    [anon_sym_unsafe] = ACTIONS(3084),
    [anon_sym_sql] = ACTIONS(3084),
    [sym_int_literal] = ACTIONS(3084),
    [sym_float_literal] = ACTIONS(3084),
    [sym_rune_literal] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [anon_sym_c_SQUOTE] = ACTIONS(3084),
    [anon_sym_c_DQUOTE] = ACTIONS(3084),
    [anon_sym_r_SQUOTE] = ACTIONS(3084),
    [anon_sym_r_DQUOTE] = ACTIONS(3084),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3084),
    [anon_sym_shared] = ACTIONS(3084),
    [anon_sym_map_LBRACK] = ACTIONS(3084),
    [anon_sym_chan] = ACTIONS(3084),
    [anon_sym_thread] = ACTIONS(3084),
    [anon_sym_atomic] = ACTIONS(3084),
    [anon_sym_assert] = ACTIONS(3084),
    [anon_sym_defer] = ACTIONS(3084),
    [anon_sym_goto] = ACTIONS(3084),
    [anon_sym_break] = ACTIONS(3084),
    [anon_sym_continue] = ACTIONS(3084),
    [anon_sym_return] = ACTIONS(3084),
    [anon_sym_DOLLARfor] = ACTIONS(3084),
    [anon_sym_for] = ACTIONS(3084),
    [anon_sym_POUND] = ACTIONS(3084),
    [anon_sym_asm] = ACTIONS(3084),
    [anon_sym_AT_LBRACK] = ACTIONS(3084),
  },
  [1259] = {
    [sym_line_comment] = STATE(1259),
    [sym_block_comment] = STATE(1259),
    [ts_builtin_sym_end] = ACTIONS(3302),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_LF] = ACTIONS(3304),
    [anon_sym_CR] = ACTIONS(3304),
    [anon_sym_CR_LF] = ACTIONS(3304),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_as] = ACTIONS(3304),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_COMMA] = ACTIONS(3304),
    [anon_sym_const] = ACTIONS(3304),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym___global] = ACTIONS(3304),
    [anon_sym_type] = ACTIONS(3304),
    [anon_sym_fn] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [anon_sym_LT] = ACTIONS(3304),
    [anon_sym_GT] = ACTIONS(3304),
    [anon_sym_EQ_EQ] = ACTIONS(3304),
    [anon_sym_BANG_EQ] = ACTIONS(3304),
    [anon_sym_LT_EQ] = ACTIONS(3304),
    [anon_sym_GT_EQ] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3302),
    [anon_sym_struct] = ACTIONS(3304),
    [anon_sym_union] = ACTIONS(3304),
    [anon_sym_pub] = ACTIONS(3304),
    [anon_sym_mut] = ACTIONS(3304),
    [anon_sym_enum] = ACTIONS(3304),
    [anon_sym_interface] = ACTIONS(3304),
    [anon_sym_PLUS_PLUS] = ACTIONS(3304),
    [anon_sym_DASH_DASH] = ACTIONS(3304),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_go] = ACTIONS(3304),
    [anon_sym_spawn] = ACTIONS(3304),
    [anon_sym_json_DOTdecode] = ACTIONS(3304),
    [anon_sym_PIPE] = ACTIONS(3304),
    [anon_sym_LBRACK2] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LT_DASH] = ACTIONS(3304),
    [anon_sym_LT_LT] = ACTIONS(3304),
    [anon_sym_GT_GT] = ACTIONS(3304),
    [anon_sym_GT_GT_GT] = ACTIONS(3304),
    [anon_sym_AMP_CARET] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_PIPE_PIPE] = ACTIONS(3304),
    [anon_sym_or] = ACTIONS(3304),
    [sym_none] = ACTIONS(3304),
    [sym_true] = ACTIONS(3304),
    [sym_false] = ACTIONS(3304),
    [sym_nil] = ACTIONS(3304),
    [anon_sym_QMARK_DOT] = ACTIONS(3304),
    [anon_sym_POUND_LBRACK] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_DOLLARif] = ACTIONS(3304),
    [anon_sym_is] = ACTIONS(3304),
    [anon_sym_BANGis] = ACTIONS(3304),
    [anon_sym_in] = ACTIONS(3304),
    [anon_sym_BANGin] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_select] = ACTIONS(3304),
    [anon_sym_lock] = ACTIONS(3304),
    [anon_sym_rlock] = ACTIONS(3304),
    [anon_sym_unsafe] = ACTIONS(3304),
    [anon_sym_sql] = ACTIONS(3304),
    [sym_int_literal] = ACTIONS(3304),
    [sym_float_literal] = ACTIONS(3304),
    [sym_rune_literal] = ACTIONS(3304),
    [anon_sym_SQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_c_SQUOTE] = ACTIONS(3304),
    [anon_sym_c_DQUOTE] = ACTIONS(3304),
    [anon_sym_r_SQUOTE] = ACTIONS(3304),
    [anon_sym_r_DQUOTE] = ACTIONS(3304),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3304),
    [anon_sym_shared] = ACTIONS(3304),
    [anon_sym_map_LBRACK] = ACTIONS(3304),
    [anon_sym_chan] = ACTIONS(3304),
    [anon_sym_thread] = ACTIONS(3304),
    [anon_sym_atomic] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_defer] = ACTIONS(3304),
    [anon_sym_goto] = ACTIONS(3304),
    [anon_sym_break] = ACTIONS(3304),
    [anon_sym_continue] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_DOLLARfor] = ACTIONS(3304),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_POUND] = ACTIONS(3304),
    [anon_sym_asm] = ACTIONS(3304),
    [anon_sym_AT_LBRACK] = ACTIONS(3304),
  },
  [1260] = {
    [sym_line_comment] = STATE(1260),
    [sym_block_comment] = STATE(1260),
    [ts_builtin_sym_end] = ACTIONS(3298),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_LF] = ACTIONS(3300),
    [anon_sym_CR] = ACTIONS(3300),
    [anon_sym_CR_LF] = ACTIONS(3300),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3300),
    [anon_sym_as] = ACTIONS(3300),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(3300),
    [anon_sym_const] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym___global] = ACTIONS(3300),
    [anon_sym_type] = ACTIONS(3300),
    [anon_sym_fn] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_SLASH] = ACTIONS(3300),
    [anon_sym_PERCENT] = ACTIONS(3300),
    [anon_sym_LT] = ACTIONS(3300),
    [anon_sym_GT] = ACTIONS(3300),
    [anon_sym_EQ_EQ] = ACTIONS(3300),
    [anon_sym_BANG_EQ] = ACTIONS(3300),
    [anon_sym_LT_EQ] = ACTIONS(3300),
    [anon_sym_GT_EQ] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_struct] = ACTIONS(3300),
    [anon_sym_union] = ACTIONS(3300),
    [anon_sym_pub] = ACTIONS(3300),
    [anon_sym_mut] = ACTIONS(3300),
    [anon_sym_enum] = ACTIONS(3300),
    [anon_sym_interface] = ACTIONS(3300),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_go] = ACTIONS(3300),
    [anon_sym_spawn] = ACTIONS(3300),
    [anon_sym_json_DOTdecode] = ACTIONS(3300),
    [anon_sym_PIPE] = ACTIONS(3300),
    [anon_sym_LBRACK2] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [anon_sym_CARET] = ACTIONS(3300),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LT_DASH] = ACTIONS(3300),
    [anon_sym_LT_LT] = ACTIONS(3300),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3300),
    [anon_sym_AMP_CARET] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_PIPE_PIPE] = ACTIONS(3300),
    [anon_sym_or] = ACTIONS(3300),
    [sym_none] = ACTIONS(3300),
    [sym_true] = ACTIONS(3300),
    [sym_false] = ACTIONS(3300),
    [sym_nil] = ACTIONS(3300),
    [anon_sym_QMARK_DOT] = ACTIONS(3300),
    [anon_sym_POUND_LBRACK] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_DOLLARif] = ACTIONS(3300),
    [anon_sym_is] = ACTIONS(3300),
    [anon_sym_BANGis] = ACTIONS(3300),
    [anon_sym_in] = ACTIONS(3300),
    [anon_sym_BANGin] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_select] = ACTIONS(3300),
    [anon_sym_lock] = ACTIONS(3300),
    [anon_sym_rlock] = ACTIONS(3300),
    [anon_sym_unsafe] = ACTIONS(3300),
    [anon_sym_sql] = ACTIONS(3300),
    [sym_int_literal] = ACTIONS(3300),
    [sym_float_literal] = ACTIONS(3300),
    [sym_rune_literal] = ACTIONS(3300),
    [anon_sym_SQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_c_SQUOTE] = ACTIONS(3300),
    [anon_sym_c_DQUOTE] = ACTIONS(3300),
    [anon_sym_r_SQUOTE] = ACTIONS(3300),
    [anon_sym_r_DQUOTE] = ACTIONS(3300),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3300),
    [anon_sym_shared] = ACTIONS(3300),
    [anon_sym_map_LBRACK] = ACTIONS(3300),
    [anon_sym_chan] = ACTIONS(3300),
    [anon_sym_thread] = ACTIONS(3300),
    [anon_sym_atomic] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_defer] = ACTIONS(3300),
    [anon_sym_goto] = ACTIONS(3300),
    [anon_sym_break] = ACTIONS(3300),
    [anon_sym_continue] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_DOLLARfor] = ACTIONS(3300),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_POUND] = ACTIONS(3300),
    [anon_sym_asm] = ACTIONS(3300),
    [anon_sym_AT_LBRACK] = ACTIONS(3300),
  },
  [1261] = {
    [sym_line_comment] = STATE(1261),
    [sym_block_comment] = STATE(1261),
    [ts_builtin_sym_end] = ACTIONS(2455),
    [sym_identifier] = ACTIONS(2457),
    [anon_sym_LF] = ACTIONS(2457),
    [anon_sym_CR] = ACTIONS(2457),
    [anon_sym_CR_LF] = ACTIONS(2457),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2457),
    [anon_sym_as] = ACTIONS(2457),
    [anon_sym_LBRACE] = ACTIONS(2457),
    [anon_sym_COMMA] = ACTIONS(2457),
    [anon_sym_const] = ACTIONS(2457),
    [anon_sym_LPAREN] = ACTIONS(2457),
    [anon_sym___global] = ACTIONS(2457),
    [anon_sym_type] = ACTIONS(2457),
    [anon_sym_fn] = ACTIONS(2457),
    [anon_sym_PLUS] = ACTIONS(2457),
    [anon_sym_DASH] = ACTIONS(2457),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_PERCENT] = ACTIONS(2457),
    [anon_sym_LT] = ACTIONS(2457),
    [anon_sym_GT] = ACTIONS(2457),
    [anon_sym_EQ_EQ] = ACTIONS(2457),
    [anon_sym_BANG_EQ] = ACTIONS(2457),
    [anon_sym_LT_EQ] = ACTIONS(2457),
    [anon_sym_GT_EQ] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_struct] = ACTIONS(2457),
    [anon_sym_union] = ACTIONS(2457),
    [anon_sym_pub] = ACTIONS(2457),
    [anon_sym_mut] = ACTIONS(2457),
    [anon_sym_enum] = ACTIONS(2457),
    [anon_sym_interface] = ACTIONS(2457),
    [anon_sym_PLUS_PLUS] = ACTIONS(2457),
    [anon_sym_DASH_DASH] = ACTIONS(2457),
    [anon_sym_QMARK] = ACTIONS(2457),
    [anon_sym_BANG] = ACTIONS(2457),
    [anon_sym_go] = ACTIONS(2457),
    [anon_sym_spawn] = ACTIONS(2457),
    [anon_sym_json_DOTdecode] = ACTIONS(2457),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_LBRACK2] = ACTIONS(2457),
    [anon_sym_TILDE] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2457),
    [anon_sym_AMP] = ACTIONS(2457),
    [anon_sym_LT_DASH] = ACTIONS(2457),
    [anon_sym_LT_LT] = ACTIONS(2457),
    [anon_sym_GT_GT] = ACTIONS(2457),
    [anon_sym_GT_GT_GT] = ACTIONS(2457),
    [anon_sym_AMP_CARET] = ACTIONS(2457),
    [anon_sym_AMP_AMP] = ACTIONS(2457),
    [anon_sym_PIPE_PIPE] = ACTIONS(2457),
    [anon_sym_or] = ACTIONS(2457),
    [sym_none] = ACTIONS(2457),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [sym_nil] = ACTIONS(2457),
    [anon_sym_QMARK_DOT] = ACTIONS(2457),
    [anon_sym_POUND_LBRACK] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2457),
    [anon_sym_DOLLARif] = ACTIONS(2457),
    [anon_sym_is] = ACTIONS(2457),
    [anon_sym_BANGis] = ACTIONS(2457),
    [anon_sym_in] = ACTIONS(2457),
    [anon_sym_BANGin] = ACTIONS(2457),
    [anon_sym_match] = ACTIONS(2457),
    [anon_sym_select] = ACTIONS(2457),
    [anon_sym_lock] = ACTIONS(2457),
    [anon_sym_rlock] = ACTIONS(2457),
    [anon_sym_unsafe] = ACTIONS(2457),
    [anon_sym_sql] = ACTIONS(2457),
    [sym_int_literal] = ACTIONS(2457),
    [sym_float_literal] = ACTIONS(2457),
    [sym_rune_literal] = ACTIONS(2457),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_DQUOTE] = ACTIONS(2457),
    [anon_sym_c_SQUOTE] = ACTIONS(2457),
    [anon_sym_c_DQUOTE] = ACTIONS(2457),
    [anon_sym_r_SQUOTE] = ACTIONS(2457),
    [anon_sym_r_DQUOTE] = ACTIONS(2457),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2457),
    [anon_sym_shared] = ACTIONS(2457),
    [anon_sym_map_LBRACK] = ACTIONS(2457),
    [anon_sym_chan] = ACTIONS(2457),
    [anon_sym_thread] = ACTIONS(2457),
    [anon_sym_atomic] = ACTIONS(2457),
    [anon_sym_assert] = ACTIONS(2457),
    [anon_sym_defer] = ACTIONS(2457),
    [anon_sym_goto] = ACTIONS(2457),
    [anon_sym_break] = ACTIONS(2457),
    [anon_sym_continue] = ACTIONS(2457),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_DOLLARfor] = ACTIONS(2457),
    [anon_sym_for] = ACTIONS(2457),
    [anon_sym_POUND] = ACTIONS(2457),
    [anon_sym_asm] = ACTIONS(2457),
    [anon_sym_AT_LBRACK] = ACTIONS(2457),
  },
  [1262] = {
    [sym_line_comment] = STATE(1262),
    [sym_block_comment] = STATE(1262),
    [ts_builtin_sym_end] = ACTIONS(2371),
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2373),
    [anon_sym_CR] = ACTIONS(2373),
    [anon_sym_CR_LF] = ACTIONS(2373),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2373),
    [anon_sym_as] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2373),
    [anon_sym_COMMA] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym___global] = ACTIONS(2373),
    [anon_sym_type] = ACTIONS(2373),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_SLASH] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2373),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_pub] = ACTIONS(2373),
    [anon_sym_mut] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2373),
    [anon_sym_QMARK] = ACTIONS(2373),
    [anon_sym_BANG] = ACTIONS(2373),
    [anon_sym_go] = ACTIONS(2373),
    [anon_sym_spawn] = ACTIONS(2373),
    [anon_sym_json_DOTdecode] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_LBRACK2] = ACTIONS(2373),
    [anon_sym_TILDE] = ACTIONS(2373),
    [anon_sym_CARET] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_LT_DASH] = ACTIONS(2373),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2373),
    [anon_sym_AMP_CARET] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2373),
    [anon_sym_or] = ACTIONS(2373),
    [sym_none] = ACTIONS(2373),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [sym_nil] = ACTIONS(2373),
    [anon_sym_QMARK_DOT] = ACTIONS(2373),
    [anon_sym_POUND_LBRACK] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_DOLLARif] = ACTIONS(2373),
    [anon_sym_is] = ACTIONS(2373),
    [anon_sym_BANGis] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_BANGin] = ACTIONS(2373),
    [anon_sym_match] = ACTIONS(2373),
    [anon_sym_select] = ACTIONS(2373),
    [anon_sym_lock] = ACTIONS(2373),
    [anon_sym_rlock] = ACTIONS(2373),
    [anon_sym_unsafe] = ACTIONS(2373),
    [anon_sym_sql] = ACTIONS(2373),
    [sym_int_literal] = ACTIONS(2373),
    [sym_float_literal] = ACTIONS(2373),
    [sym_rune_literal] = ACTIONS(2373),
    [anon_sym_SQUOTE] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(2373),
    [anon_sym_c_SQUOTE] = ACTIONS(2373),
    [anon_sym_c_DQUOTE] = ACTIONS(2373),
    [anon_sym_r_SQUOTE] = ACTIONS(2373),
    [anon_sym_r_DQUOTE] = ACTIONS(2373),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_map_LBRACK] = ACTIONS(2373),
    [anon_sym_chan] = ACTIONS(2373),
    [anon_sym_thread] = ACTIONS(2373),
    [anon_sym_atomic] = ACTIONS(2373),
    [anon_sym_assert] = ACTIONS(2373),
    [anon_sym_defer] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_DOLLARfor] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_POUND] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym_AT_LBRACK] = ACTIONS(2373),
  },
  [1263] = {
    [sym_line_comment] = STATE(1263),
    [sym_block_comment] = STATE(1263),
    [ts_builtin_sym_end] = ACTIONS(2835),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_LF] = ACTIONS(2837),
    [anon_sym_CR] = ACTIONS(2837),
    [anon_sym_CR_LF] = ACTIONS(2837),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2837),
    [anon_sym_as] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2837),
    [anon_sym___global] = ACTIONS(2837),
    [anon_sym_type] = ACTIONS(2837),
    [anon_sym_fn] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2837),
    [anon_sym_DASH] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2837),
    [anon_sym_SLASH] = ACTIONS(2837),
    [anon_sym_PERCENT] = ACTIONS(2837),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(2837),
    [anon_sym_BANG_EQ] = ACTIONS(2837),
    [anon_sym_LT_EQ] = ACTIONS(2837),
    [anon_sym_GT_EQ] = ACTIONS(2837),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_struct] = ACTIONS(2837),
    [anon_sym_union] = ACTIONS(2837),
    [anon_sym_pub] = ACTIONS(2837),
    [anon_sym_mut] = ACTIONS(2837),
    [anon_sym_enum] = ACTIONS(2837),
    [anon_sym_interface] = ACTIONS(2837),
    [anon_sym_PLUS_PLUS] = ACTIONS(2837),
    [anon_sym_DASH_DASH] = ACTIONS(2837),
    [anon_sym_QMARK] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(2837),
    [anon_sym_go] = ACTIONS(2837),
    [anon_sym_spawn] = ACTIONS(2837),
    [anon_sym_json_DOTdecode] = ACTIONS(2837),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_LBRACK2] = ACTIONS(2837),
    [anon_sym_TILDE] = ACTIONS(2837),
    [anon_sym_CARET] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2837),
    [anon_sym_LT_DASH] = ACTIONS(2837),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_GT_GT_GT] = ACTIONS(2837),
    [anon_sym_AMP_CARET] = ACTIONS(2837),
    [anon_sym_AMP_AMP] = ACTIONS(2837),
    [anon_sym_PIPE_PIPE] = ACTIONS(2837),
    [anon_sym_or] = ACTIONS(2837),
    [sym_none] = ACTIONS(2837),
    [sym_true] = ACTIONS(2837),
    [sym_false] = ACTIONS(2837),
    [sym_nil] = ACTIONS(2837),
    [anon_sym_QMARK_DOT] = ACTIONS(2837),
    [anon_sym_POUND_LBRACK] = ACTIONS(2837),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_DOLLARif] = ACTIONS(2837),
    [anon_sym_is] = ACTIONS(2837),
    [anon_sym_BANGis] = ACTIONS(2837),
    [anon_sym_in] = ACTIONS(2837),
    [anon_sym_BANGin] = ACTIONS(2837),
    [anon_sym_match] = ACTIONS(2837),
    [anon_sym_select] = ACTIONS(2837),
    [anon_sym_lock] = ACTIONS(2837),
    [anon_sym_rlock] = ACTIONS(2837),
    [anon_sym_unsafe] = ACTIONS(2837),
    [anon_sym_sql] = ACTIONS(2837),
    [sym_int_literal] = ACTIONS(2837),
    [sym_float_literal] = ACTIONS(2837),
    [sym_rune_literal] = ACTIONS(2837),
    [anon_sym_SQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE] = ACTIONS(2837),
    [anon_sym_c_SQUOTE] = ACTIONS(2837),
    [anon_sym_c_DQUOTE] = ACTIONS(2837),
    [anon_sym_r_SQUOTE] = ACTIONS(2837),
    [anon_sym_r_DQUOTE] = ACTIONS(2837),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2837),
    [anon_sym_shared] = ACTIONS(2837),
    [anon_sym_map_LBRACK] = ACTIONS(2837),
    [anon_sym_chan] = ACTIONS(2837),
    [anon_sym_thread] = ACTIONS(2837),
    [anon_sym_atomic] = ACTIONS(2837),
    [anon_sym_assert] = ACTIONS(2837),
    [anon_sym_defer] = ACTIONS(2837),
    [anon_sym_goto] = ACTIONS(2837),
    [anon_sym_break] = ACTIONS(2837),
    [anon_sym_continue] = ACTIONS(2837),
    [anon_sym_return] = ACTIONS(2837),
    [anon_sym_DOLLARfor] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2837),
    [anon_sym_POUND] = ACTIONS(2837),
    [anon_sym_asm] = ACTIONS(2837),
    [anon_sym_AT_LBRACK] = ACTIONS(2837),
  },
  [1264] = {
    [sym_line_comment] = STATE(1264),
    [sym_block_comment] = STATE(1264),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [aux_sym_strictly_expression_list_repeat1] = STATE(1927),
    [sym_identifier] = ACTIONS(2041),
    [anon_sym_LF] = ACTIONS(2041),
    [anon_sym_CR] = ACTIONS(2041),
    [anon_sym_CR_LF] = ACTIONS(2041),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2041),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(2041),
    [anon_sym_COMMA] = ACTIONS(3984),
    [anon_sym_RBRACE] = ACTIONS(2041),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(2041),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_STAR] = ACTIONS(3990),
    [anon_sym_SLASH] = ACTIONS(3990),
    [anon_sym_PERCENT] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3992),
    [anon_sym_GT] = ACTIONS(3992),
    [anon_sym_EQ_EQ] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_LT_EQ] = ACTIONS(3992),
    [anon_sym_GT_EQ] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(2041),
    [anon_sym_mut] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(3996),
    [anon_sym_DASH_DASH] = ACTIONS(3998),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(2041),
    [anon_sym_spawn] = ACTIONS(2041),
    [anon_sym_json_DOTdecode] = ACTIONS(2041),
    [anon_sym_PIPE] = ACTIONS(3988),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_CARET] = ACTIONS(3988),
    [anon_sym_AMP] = ACTIONS(3990),
    [anon_sym_LT_DASH] = ACTIONS(2041),
    [anon_sym_LT_LT] = ACTIONS(3990),
    [anon_sym_GT_GT] = ACTIONS(3990),
    [anon_sym_GT_GT_GT] = ACTIONS(3990),
    [anon_sym_AMP_CARET] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(4006),
    [anon_sym_PIPE_PIPE] = ACTIONS(4008),
    [anon_sym_or] = ACTIONS(4010),
    [sym_none] = ACTIONS(2041),
    [sym_true] = ACTIONS(2041),
    [sym_false] = ACTIONS(2041),
    [sym_nil] = ACTIONS(2041),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(2041),
    [anon_sym_DOLLARif] = ACTIONS(2041),
    [anon_sym_is] = ACTIONS(4012),
    [anon_sym_BANGis] = ACTIONS(4012),
    [anon_sym_in] = ACTIONS(4014),
    [anon_sym_BANGin] = ACTIONS(4014),
    [anon_sym_match] = ACTIONS(2041),
    [anon_sym_select] = ACTIONS(2041),
    [anon_sym_lock] = ACTIONS(2041),
    [anon_sym_rlock] = ACTIONS(2041),
    [anon_sym_unsafe] = ACTIONS(2041),
    [anon_sym_sql] = ACTIONS(2041),
    [sym_int_literal] = ACTIONS(2041),
    [sym_float_literal] = ACTIONS(2041),
    [sym_rune_literal] = ACTIONS(2041),
    [anon_sym_SQUOTE] = ACTIONS(2041),
    [anon_sym_DQUOTE] = ACTIONS(2041),
    [anon_sym_c_SQUOTE] = ACTIONS(2041),
    [anon_sym_c_DQUOTE] = ACTIONS(2041),
    [anon_sym_r_SQUOTE] = ACTIONS(2041),
    [anon_sym_r_DQUOTE] = ACTIONS(2041),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2041),
    [anon_sym_shared] = ACTIONS(2041),
    [anon_sym_map_LBRACK] = ACTIONS(2041),
    [anon_sym_chan] = ACTIONS(2041),
    [anon_sym_thread] = ACTIONS(2041),
    [anon_sym_atomic] = ACTIONS(2041),
    [anon_sym_assert] = ACTIONS(2041),
    [anon_sym_defer] = ACTIONS(2041),
    [anon_sym_goto] = ACTIONS(2041),
    [anon_sym_break] = ACTIONS(2041),
    [anon_sym_continue] = ACTIONS(2041),
    [anon_sym_return] = ACTIONS(2041),
    [anon_sym_DOLLARfor] = ACTIONS(2041),
    [anon_sym_for] = ACTIONS(2041),
    [anon_sym_POUND] = ACTIONS(2041),
    [anon_sym_asm] = ACTIONS(2041),
  },
  [1265] = {
    [sym_line_comment] = STATE(1265),
    [sym_block_comment] = STATE(1265),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(2075),
    [anon_sym_LF] = ACTIONS(2075),
    [anon_sym_CR] = ACTIONS(2075),
    [anon_sym_CR_LF] = ACTIONS(2075),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2075),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(2075),
    [anon_sym_COMMA] = ACTIONS(2075),
    [anon_sym_RBRACE] = ACTIONS(2075),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(2075),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_STAR] = ACTIONS(3990),
    [anon_sym_SLASH] = ACTIONS(3990),
    [anon_sym_PERCENT] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3992),
    [anon_sym_GT] = ACTIONS(3992),
    [anon_sym_EQ_EQ] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_LT_EQ] = ACTIONS(3992),
    [anon_sym_GT_EQ] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(2075),
    [anon_sym_mut] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(3996),
    [anon_sym_DASH_DASH] = ACTIONS(3998),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(2075),
    [anon_sym_spawn] = ACTIONS(2075),
    [anon_sym_json_DOTdecode] = ACTIONS(2075),
    [anon_sym_PIPE] = ACTIONS(3988),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_CARET] = ACTIONS(3988),
    [anon_sym_AMP] = ACTIONS(3990),
    [anon_sym_LT_DASH] = ACTIONS(2075),
    [anon_sym_LT_LT] = ACTIONS(3990),
    [anon_sym_GT_GT] = ACTIONS(3990),
    [anon_sym_GT_GT_GT] = ACTIONS(3990),
    [anon_sym_AMP_CARET] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(4006),
    [anon_sym_PIPE_PIPE] = ACTIONS(4008),
    [anon_sym_or] = ACTIONS(4010),
    [sym_none] = ACTIONS(2075),
    [sym_true] = ACTIONS(2075),
    [sym_false] = ACTIONS(2075),
    [sym_nil] = ACTIONS(2075),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(2075),
    [anon_sym_DOLLARif] = ACTIONS(2075),
    [anon_sym_is] = ACTIONS(4012),
    [anon_sym_BANGis] = ACTIONS(4012),
    [anon_sym_in] = ACTIONS(4014),
    [anon_sym_BANGin] = ACTIONS(4014),
    [anon_sym_match] = ACTIONS(2075),
    [anon_sym_select] = ACTIONS(2075),
    [anon_sym_lock] = ACTIONS(2075),
    [anon_sym_rlock] = ACTIONS(2075),
    [anon_sym_unsafe] = ACTIONS(2075),
    [anon_sym_sql] = ACTIONS(2075),
    [sym_int_literal] = ACTIONS(2075),
    [sym_float_literal] = ACTIONS(2075),
    [sym_rune_literal] = ACTIONS(2075),
    [anon_sym_SQUOTE] = ACTIONS(2075),
    [anon_sym_DQUOTE] = ACTIONS(2075),
    [anon_sym_c_SQUOTE] = ACTIONS(2075),
    [anon_sym_c_DQUOTE] = ACTIONS(2075),
    [anon_sym_r_SQUOTE] = ACTIONS(2075),
    [anon_sym_r_DQUOTE] = ACTIONS(2075),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2075),
    [anon_sym_shared] = ACTIONS(2075),
    [anon_sym_map_LBRACK] = ACTIONS(2075),
    [anon_sym_chan] = ACTIONS(2075),
    [anon_sym_thread] = ACTIONS(2075),
    [anon_sym_atomic] = ACTIONS(2075),
    [anon_sym_assert] = ACTIONS(2075),
    [anon_sym_defer] = ACTIONS(2075),
    [anon_sym_goto] = ACTIONS(2075),
    [anon_sym_break] = ACTIONS(2075),
    [anon_sym_continue] = ACTIONS(2075),
    [anon_sym_return] = ACTIONS(2075),
    [anon_sym_DOLLARfor] = ACTIONS(2075),
    [anon_sym_for] = ACTIONS(2075),
    [anon_sym_POUND] = ACTIONS(2075),
    [anon_sym_asm] = ACTIONS(2075),
  },
  [1266] = {
    [sym_line_comment] = STATE(1266),
    [sym_block_comment] = STATE(1266),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_DASH] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(3990),
    [anon_sym_SLASH] = ACTIONS(3990),
    [anon_sym_PERCENT] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(3990),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(3990),
    [anon_sym_GT_GT] = ACTIONS(3990),
    [anon_sym_GT_GT_GT] = ACTIONS(3990),
    [anon_sym_AMP_CARET] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2053),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
  },
  [1267] = {
    [sym_line_comment] = STATE(1267),
    [sym_block_comment] = STATE(1267),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_STAR] = ACTIONS(3990),
    [anon_sym_SLASH] = ACTIONS(3990),
    [anon_sym_PERCENT] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(3988),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(3988),
    [anon_sym_AMP] = ACTIONS(3990),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(3990),
    [anon_sym_GT_GT] = ACTIONS(3990),
    [anon_sym_GT_GT_GT] = ACTIONS(3990),
    [anon_sym_AMP_CARET] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2053),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
  },
  [1268] = {
    [sym_line_comment] = STATE(1268),
    [sym_block_comment] = STATE(1268),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_STAR] = ACTIONS(3990),
    [anon_sym_SLASH] = ACTIONS(3990),
    [anon_sym_PERCENT] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3992),
    [anon_sym_GT] = ACTIONS(3992),
    [anon_sym_EQ_EQ] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_LT_EQ] = ACTIONS(3992),
    [anon_sym_GT_EQ] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(3988),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(3988),
    [anon_sym_AMP] = ACTIONS(3990),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(3990),
    [anon_sym_GT_GT] = ACTIONS(3990),
    [anon_sym_GT_GT_GT] = ACTIONS(3990),
    [anon_sym_AMP_CARET] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(4014),
    [anon_sym_BANGin] = ACTIONS(4014),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
  },
  [1269] = {
    [sym_line_comment] = STATE(1269),
    [sym_block_comment] = STATE(1269),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_STAR] = ACTIONS(3990),
    [anon_sym_SLASH] = ACTIONS(3990),
    [anon_sym_PERCENT] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3992),
    [anon_sym_GT] = ACTIONS(3992),
    [anon_sym_EQ_EQ] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_LT_EQ] = ACTIONS(3992),
    [anon_sym_GT_EQ] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(3988),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(3988),
    [anon_sym_AMP] = ACTIONS(3990),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(3990),
    [anon_sym_GT_GT] = ACTIONS(3990),
    [anon_sym_GT_GT_GT] = ACTIONS(3990),
    [anon_sym_AMP_CARET] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(4006),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(4014),
    [anon_sym_BANGin] = ACTIONS(4014),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
  },
  [1270] = {
    [sym_line_comment] = STATE(1270),
    [sym_block_comment] = STATE(1270),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(2001),
    [anon_sym_LF] = ACTIONS(2001),
    [anon_sym_CR] = ACTIONS(2001),
    [anon_sym_CR_LF] = ACTIONS(2001),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2001),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(2001),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(2001),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_STAR] = ACTIONS(3990),
    [anon_sym_SLASH] = ACTIONS(3990),
    [anon_sym_PERCENT] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3992),
    [anon_sym_GT] = ACTIONS(3992),
    [anon_sym_EQ_EQ] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_LT_EQ] = ACTIONS(3992),
    [anon_sym_GT_EQ] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(2001),
    [anon_sym_mut] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(3996),
    [anon_sym_DASH_DASH] = ACTIONS(3998),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(2001),
    [anon_sym_spawn] = ACTIONS(2001),
    [anon_sym_json_DOTdecode] = ACTIONS(2001),
    [anon_sym_PIPE] = ACTIONS(3988),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(2001),
    [anon_sym_CARET] = ACTIONS(3988),
    [anon_sym_AMP] = ACTIONS(3990),
    [anon_sym_LT_DASH] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(3990),
    [anon_sym_GT_GT] = ACTIONS(3990),
    [anon_sym_GT_GT_GT] = ACTIONS(3990),
    [anon_sym_AMP_CARET] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(4006),
    [anon_sym_PIPE_PIPE] = ACTIONS(4008),
    [anon_sym_or] = ACTIONS(4010),
    [sym_none] = ACTIONS(2001),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_nil] = ACTIONS(2001),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(2001),
    [anon_sym_DOLLARif] = ACTIONS(2001),
    [anon_sym_is] = ACTIONS(4012),
    [anon_sym_BANGis] = ACTIONS(4012),
    [anon_sym_in] = ACTIONS(4014),
    [anon_sym_BANGin] = ACTIONS(4014),
    [anon_sym_match] = ACTIONS(2001),
    [anon_sym_select] = ACTIONS(2001),
    [anon_sym_lock] = ACTIONS(2001),
    [anon_sym_rlock] = ACTIONS(2001),
    [anon_sym_unsafe] = ACTIONS(2001),
    [anon_sym_sql] = ACTIONS(2001),
    [sym_int_literal] = ACTIONS(2001),
    [sym_float_literal] = ACTIONS(2001),
    [sym_rune_literal] = ACTIONS(2001),
    [anon_sym_SQUOTE] = ACTIONS(2001),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_c_SQUOTE] = ACTIONS(2001),
    [anon_sym_c_DQUOTE] = ACTIONS(2001),
    [anon_sym_r_SQUOTE] = ACTIONS(2001),
    [anon_sym_r_DQUOTE] = ACTIONS(2001),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2001),
    [anon_sym_shared] = ACTIONS(2001),
    [anon_sym_map_LBRACK] = ACTIONS(2001),
    [anon_sym_chan] = ACTIONS(2001),
    [anon_sym_thread] = ACTIONS(2001),
    [anon_sym_atomic] = ACTIONS(2001),
    [anon_sym_assert] = ACTIONS(2001),
    [anon_sym_defer] = ACTIONS(2001),
    [anon_sym_goto] = ACTIONS(2001),
    [anon_sym_break] = ACTIONS(2001),
    [anon_sym_continue] = ACTIONS(2001),
    [anon_sym_return] = ACTIONS(2001),
    [anon_sym_DOLLARfor] = ACTIONS(2001),
    [anon_sym_for] = ACTIONS(2001),
    [anon_sym_POUND] = ACTIONS(2001),
    [anon_sym_asm] = ACTIONS(2001),
  },
  [1271] = {
    [sym_line_comment] = STATE(1271),
    [sym_block_comment] = STATE(1271),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(2049),
    [anon_sym_LF] = ACTIONS(2049),
    [anon_sym_CR] = ACTIONS(2049),
    [anon_sym_CR_LF] = ACTIONS(2049),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(2049),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_STAR] = ACTIONS(3990),
    [anon_sym_SLASH] = ACTIONS(3990),
    [anon_sym_PERCENT] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(2049),
    [anon_sym_mut] = ACTIONS(2049),
    [anon_sym_PLUS_PLUS] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(2049),
    [anon_sym_spawn] = ACTIONS(2049),
    [anon_sym_json_DOTdecode] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(3988),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(2049),
    [anon_sym_CARET] = ACTIONS(3988),
    [anon_sym_AMP] = ACTIONS(3990),
    [anon_sym_LT_DASH] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(3990),
    [anon_sym_GT_GT] = ACTIONS(3990),
    [anon_sym_GT_GT_GT] = ACTIONS(3990),
    [anon_sym_AMP_CARET] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_or] = ACTIONS(2049),
    [sym_none] = ACTIONS(2049),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [sym_nil] = ACTIONS(2049),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(2049),
    [anon_sym_DOLLARif] = ACTIONS(2049),
    [anon_sym_is] = ACTIONS(2049),
    [anon_sym_BANGis] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_BANGin] = ACTIONS(2049),
    [anon_sym_match] = ACTIONS(2049),
    [anon_sym_select] = ACTIONS(2049),
    [anon_sym_lock] = ACTIONS(2049),
    [anon_sym_rlock] = ACTIONS(2049),
    [anon_sym_unsafe] = ACTIONS(2049),
    [anon_sym_sql] = ACTIONS(2049),
    [sym_int_literal] = ACTIONS(2049),
    [sym_float_literal] = ACTIONS(2049),
    [sym_rune_literal] = ACTIONS(2049),
    [anon_sym_SQUOTE] = ACTIONS(2049),
    [anon_sym_DQUOTE] = ACTIONS(2049),
    [anon_sym_c_SQUOTE] = ACTIONS(2049),
    [anon_sym_c_DQUOTE] = ACTIONS(2049),
    [anon_sym_r_SQUOTE] = ACTIONS(2049),
    [anon_sym_r_DQUOTE] = ACTIONS(2049),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2049),
    [anon_sym_shared] = ACTIONS(2049),
    [anon_sym_map_LBRACK] = ACTIONS(2049),
    [anon_sym_chan] = ACTIONS(2049),
    [anon_sym_thread] = ACTIONS(2049),
    [anon_sym_atomic] = ACTIONS(2049),
    [anon_sym_assert] = ACTIONS(2049),
    [anon_sym_defer] = ACTIONS(2049),
    [anon_sym_goto] = ACTIONS(2049),
    [anon_sym_break] = ACTIONS(2049),
    [anon_sym_continue] = ACTIONS(2049),
    [anon_sym_return] = ACTIONS(2049),
    [anon_sym_DOLLARfor] = ACTIONS(2049),
    [anon_sym_for] = ACTIONS(2049),
    [anon_sym_POUND] = ACTIONS(2049),
    [anon_sym_asm] = ACTIONS(2049),
  },
  [1272] = {
    [sym_line_comment] = STATE(1272),
    [sym_block_comment] = STATE(1272),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(2065),
    [anon_sym_LF] = ACTIONS(2065),
    [anon_sym_CR] = ACTIONS(2065),
    [anon_sym_CR_LF] = ACTIONS(2065),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(2065),
    [anon_sym_COMMA] = ACTIONS(2065),
    [anon_sym_RBRACE] = ACTIONS(2065),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(2065),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_STAR] = ACTIONS(3990),
    [anon_sym_SLASH] = ACTIONS(3990),
    [anon_sym_PERCENT] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3992),
    [anon_sym_GT] = ACTIONS(3992),
    [anon_sym_EQ_EQ] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_LT_EQ] = ACTIONS(3992),
    [anon_sym_GT_EQ] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(2065),
    [anon_sym_mut] = ACTIONS(2065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3996),
    [anon_sym_DASH_DASH] = ACTIONS(3998),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(2065),
    [anon_sym_spawn] = ACTIONS(2065),
    [anon_sym_json_DOTdecode] = ACTIONS(2065),
    [anon_sym_PIPE] = ACTIONS(3988),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(2065),
    [anon_sym_CARET] = ACTIONS(3988),
    [anon_sym_AMP] = ACTIONS(3990),
    [anon_sym_LT_DASH] = ACTIONS(2065),
    [anon_sym_LT_LT] = ACTIONS(3990),
    [anon_sym_GT_GT] = ACTIONS(3990),
    [anon_sym_GT_GT_GT] = ACTIONS(3990),
    [anon_sym_AMP_CARET] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(4006),
    [anon_sym_PIPE_PIPE] = ACTIONS(4008),
    [anon_sym_or] = ACTIONS(4010),
    [sym_none] = ACTIONS(2065),
    [sym_true] = ACTIONS(2065),
    [sym_false] = ACTIONS(2065),
    [sym_nil] = ACTIONS(2065),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(2065),
    [anon_sym_DOLLARif] = ACTIONS(2065),
    [anon_sym_is] = ACTIONS(4012),
    [anon_sym_BANGis] = ACTIONS(4012),
    [anon_sym_in] = ACTIONS(4014),
    [anon_sym_BANGin] = ACTIONS(4014),
    [anon_sym_match] = ACTIONS(2065),
    [anon_sym_select] = ACTIONS(2065),
    [anon_sym_lock] = ACTIONS(2065),
    [anon_sym_rlock] = ACTIONS(2065),
    [anon_sym_unsafe] = ACTIONS(2065),
    [anon_sym_sql] = ACTIONS(2065),
    [sym_int_literal] = ACTIONS(2065),
    [sym_float_literal] = ACTIONS(2065),
    [sym_rune_literal] = ACTIONS(2065),
    [anon_sym_SQUOTE] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2065),
    [anon_sym_c_SQUOTE] = ACTIONS(2065),
    [anon_sym_c_DQUOTE] = ACTIONS(2065),
    [anon_sym_r_SQUOTE] = ACTIONS(2065),
    [anon_sym_r_DQUOTE] = ACTIONS(2065),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2065),
    [anon_sym_shared] = ACTIONS(2065),
    [anon_sym_map_LBRACK] = ACTIONS(2065),
    [anon_sym_chan] = ACTIONS(2065),
    [anon_sym_thread] = ACTIONS(2065),
    [anon_sym_atomic] = ACTIONS(2065),
    [anon_sym_assert] = ACTIONS(2065),
    [anon_sym_defer] = ACTIONS(2065),
    [anon_sym_goto] = ACTIONS(2065),
    [anon_sym_break] = ACTIONS(2065),
    [anon_sym_continue] = ACTIONS(2065),
    [anon_sym_return] = ACTIONS(2065),
    [anon_sym_DOLLARfor] = ACTIONS(2065),
    [anon_sym_for] = ACTIONS(2065),
    [anon_sym_POUND] = ACTIONS(2065),
    [anon_sym_asm] = ACTIONS(2065),
  },
  [1273] = {
    [sym_line_comment] = STATE(1273),
    [sym_block_comment] = STATE(1273),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(2069),
    [anon_sym_LF] = ACTIONS(2069),
    [anon_sym_CR] = ACTIONS(2069),
    [anon_sym_CR_LF] = ACTIONS(2069),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2069),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(2069),
    [anon_sym_COMMA] = ACTIONS(2069),
    [anon_sym_RBRACE] = ACTIONS(2069),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(2069),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_STAR] = ACTIONS(3990),
    [anon_sym_SLASH] = ACTIONS(3990),
    [anon_sym_PERCENT] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3992),
    [anon_sym_GT] = ACTIONS(3992),
    [anon_sym_EQ_EQ] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_LT_EQ] = ACTIONS(3992),
    [anon_sym_GT_EQ] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(2069),
    [anon_sym_mut] = ACTIONS(2069),
    [anon_sym_PLUS_PLUS] = ACTIONS(3996),
    [anon_sym_DASH_DASH] = ACTIONS(3998),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(2069),
    [anon_sym_spawn] = ACTIONS(2069),
    [anon_sym_json_DOTdecode] = ACTIONS(2069),
    [anon_sym_PIPE] = ACTIONS(3988),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(2069),
    [anon_sym_CARET] = ACTIONS(3988),
    [anon_sym_AMP] = ACTIONS(3990),
    [anon_sym_LT_DASH] = ACTIONS(2069),
    [anon_sym_LT_LT] = ACTIONS(3990),
    [anon_sym_GT_GT] = ACTIONS(3990),
    [anon_sym_GT_GT_GT] = ACTIONS(3990),
    [anon_sym_AMP_CARET] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(4006),
    [anon_sym_PIPE_PIPE] = ACTIONS(4008),
    [anon_sym_or] = ACTIONS(4010),
    [sym_none] = ACTIONS(2069),
    [sym_true] = ACTIONS(2069),
    [sym_false] = ACTIONS(2069),
    [sym_nil] = ACTIONS(2069),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(2069),
    [anon_sym_DOLLARif] = ACTIONS(2069),
    [anon_sym_is] = ACTIONS(4016),
    [anon_sym_BANGis] = ACTIONS(4016),
    [anon_sym_in] = ACTIONS(4014),
    [anon_sym_BANGin] = ACTIONS(4014),
    [anon_sym_match] = ACTIONS(2069),
    [anon_sym_select] = ACTIONS(2069),
    [anon_sym_lock] = ACTIONS(2069),
    [anon_sym_rlock] = ACTIONS(2069),
    [anon_sym_unsafe] = ACTIONS(2069),
    [anon_sym_sql] = ACTIONS(2069),
    [sym_int_literal] = ACTIONS(2069),
    [sym_float_literal] = ACTIONS(2069),
    [sym_rune_literal] = ACTIONS(2069),
    [anon_sym_SQUOTE] = ACTIONS(2069),
    [anon_sym_DQUOTE] = ACTIONS(2069),
    [anon_sym_c_SQUOTE] = ACTIONS(2069),
    [anon_sym_c_DQUOTE] = ACTIONS(2069),
    [anon_sym_r_SQUOTE] = ACTIONS(2069),
    [anon_sym_r_DQUOTE] = ACTIONS(2069),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2069),
    [anon_sym_shared] = ACTIONS(2069),
    [anon_sym_map_LBRACK] = ACTIONS(2069),
    [anon_sym_chan] = ACTIONS(2069),
    [anon_sym_thread] = ACTIONS(2069),
    [anon_sym_atomic] = ACTIONS(2069),
    [anon_sym_assert] = ACTIONS(2069),
    [anon_sym_defer] = ACTIONS(2069),
    [anon_sym_goto] = ACTIONS(2069),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_continue] = ACTIONS(2069),
    [anon_sym_return] = ACTIONS(2069),
    [anon_sym_DOLLARfor] = ACTIONS(2069),
    [anon_sym_for] = ACTIONS(2069),
    [anon_sym_POUND] = ACTIONS(2069),
    [anon_sym_asm] = ACTIONS(2069),
  },
  [1274] = {
    [sym_line_comment] = STATE(1274),
    [sym_block_comment] = STATE(1274),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(3904),
    [anon_sym_LF] = ACTIONS(3904),
    [anon_sym_CR] = ACTIONS(3904),
    [anon_sym_CR_LF] = ACTIONS(3904),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3904),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3904),
    [anon_sym_COMMA] = ACTIONS(4018),
    [anon_sym_RBRACE] = ACTIONS(3904),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(3904),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_STAR] = ACTIONS(3990),
    [anon_sym_SLASH] = ACTIONS(3990),
    [anon_sym_PERCENT] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3992),
    [anon_sym_GT] = ACTIONS(3992),
    [anon_sym_EQ_EQ] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_LT_EQ] = ACTIONS(3992),
    [anon_sym_GT_EQ] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(3904),
    [anon_sym_mut] = ACTIONS(3904),
    [anon_sym_PLUS_PLUS] = ACTIONS(3996),
    [anon_sym_DASH_DASH] = ACTIONS(3998),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(3904),
    [anon_sym_spawn] = ACTIONS(3904),
    [anon_sym_json_DOTdecode] = ACTIONS(3904),
    [anon_sym_PIPE] = ACTIONS(3988),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(3904),
    [anon_sym_CARET] = ACTIONS(3988),
    [anon_sym_AMP] = ACTIONS(3990),
    [anon_sym_LT_DASH] = ACTIONS(3904),
    [anon_sym_LT_LT] = ACTIONS(3990),
    [anon_sym_GT_GT] = ACTIONS(3990),
    [anon_sym_GT_GT_GT] = ACTIONS(3990),
    [anon_sym_AMP_CARET] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(4006),
    [anon_sym_PIPE_PIPE] = ACTIONS(4008),
    [anon_sym_or] = ACTIONS(4010),
    [sym_none] = ACTIONS(3904),
    [sym_true] = ACTIONS(3904),
    [sym_false] = ACTIONS(3904),
    [sym_nil] = ACTIONS(3904),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(3904),
    [anon_sym_DOLLARif] = ACTIONS(3904),
    [anon_sym_is] = ACTIONS(4012),
    [anon_sym_BANGis] = ACTIONS(4012),
    [anon_sym_in] = ACTIONS(4014),
    [anon_sym_BANGin] = ACTIONS(4014),
    [anon_sym_match] = ACTIONS(3904),
    [anon_sym_select] = ACTIONS(3904),
    [anon_sym_lock] = ACTIONS(3904),
    [anon_sym_rlock] = ACTIONS(3904),
    [anon_sym_unsafe] = ACTIONS(3904),
    [anon_sym_sql] = ACTIONS(3904),
    [sym_int_literal] = ACTIONS(3904),
    [sym_float_literal] = ACTIONS(3904),
    [sym_rune_literal] = ACTIONS(3904),
    [anon_sym_SQUOTE] = ACTIONS(3904),
    [anon_sym_DQUOTE] = ACTIONS(3904),
    [anon_sym_c_SQUOTE] = ACTIONS(3904),
    [anon_sym_c_DQUOTE] = ACTIONS(3904),
    [anon_sym_r_SQUOTE] = ACTIONS(3904),
    [anon_sym_r_DQUOTE] = ACTIONS(3904),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3904),
    [anon_sym_shared] = ACTIONS(3904),
    [anon_sym_map_LBRACK] = ACTIONS(3904),
    [anon_sym_chan] = ACTIONS(3904),
    [anon_sym_thread] = ACTIONS(3904),
    [anon_sym_atomic] = ACTIONS(3904),
    [anon_sym_assert] = ACTIONS(3904),
    [anon_sym_defer] = ACTIONS(3904),
    [anon_sym_goto] = ACTIONS(3904),
    [anon_sym_break] = ACTIONS(3904),
    [anon_sym_continue] = ACTIONS(3904),
    [anon_sym_return] = ACTIONS(3904),
    [anon_sym_DOLLARfor] = ACTIONS(3904),
    [anon_sym_for] = ACTIONS(3904),
    [anon_sym_POUND] = ACTIONS(3904),
    [anon_sym_asm] = ACTIONS(3904),
  },
  [1275] = {
    [sym_line_comment] = STATE(1275),
    [sym_block_comment] = STATE(1275),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_LF] = ACTIONS(2057),
    [anon_sym_CR] = ACTIONS(2057),
    [anon_sym_CR_LF] = ACTIONS(2057),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2057),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_PERCENT] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_GT] = ACTIONS(2057),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2057),
    [anon_sym_LT_EQ] = ACTIONS(2057),
    [anon_sym_GT_EQ] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(2057),
    [anon_sym_mut] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(2057),
    [anon_sym_spawn] = ACTIONS(2057),
    [anon_sym_json_DOTdecode] = ACTIONS(2057),
    [anon_sym_PIPE] = ACTIONS(2057),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_CARET] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2057),
    [anon_sym_LT_DASH] = ACTIONS(2057),
    [anon_sym_LT_LT] = ACTIONS(2057),
    [anon_sym_GT_GT] = ACTIONS(2057),
    [anon_sym_GT_GT_GT] = ACTIONS(2057),
    [anon_sym_AMP_CARET] = ACTIONS(2057),
    [anon_sym_AMP_AMP] = ACTIONS(2057),
    [anon_sym_PIPE_PIPE] = ACTIONS(2057),
    [anon_sym_or] = ACTIONS(2057),
    [sym_none] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_nil] = ACTIONS(2057),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_DOLLARif] = ACTIONS(2057),
    [anon_sym_is] = ACTIONS(2057),
    [anon_sym_BANGis] = ACTIONS(2057),
    [anon_sym_in] = ACTIONS(2057),
    [anon_sym_BANGin] = ACTIONS(2057),
    [anon_sym_match] = ACTIONS(2057),
    [anon_sym_select] = ACTIONS(2057),
    [anon_sym_lock] = ACTIONS(2057),
    [anon_sym_rlock] = ACTIONS(2057),
    [anon_sym_unsafe] = ACTIONS(2057),
    [anon_sym_sql] = ACTIONS(2057),
    [sym_int_literal] = ACTIONS(2057),
    [sym_float_literal] = ACTIONS(2057),
    [sym_rune_literal] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_c_SQUOTE] = ACTIONS(2057),
    [anon_sym_c_DQUOTE] = ACTIONS(2057),
    [anon_sym_r_SQUOTE] = ACTIONS(2057),
    [anon_sym_r_DQUOTE] = ACTIONS(2057),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2057),
    [anon_sym_shared] = ACTIONS(2057),
    [anon_sym_map_LBRACK] = ACTIONS(2057),
    [anon_sym_chan] = ACTIONS(2057),
    [anon_sym_thread] = ACTIONS(2057),
    [anon_sym_atomic] = ACTIONS(2057),
    [anon_sym_assert] = ACTIONS(2057),
    [anon_sym_defer] = ACTIONS(2057),
    [anon_sym_goto] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_DOLLARfor] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_POUND] = ACTIONS(2057),
    [anon_sym_asm] = ACTIONS(2057),
  },
  [1276] = {
    [sym_line_comment] = STATE(1276),
    [sym_block_comment] = STATE(1276),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(2061),
    [anon_sym_LF] = ACTIONS(2061),
    [anon_sym_CR] = ACTIONS(2061),
    [anon_sym_CR_LF] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_LBRACE] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2061),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(2061),
    [anon_sym_mut] = ACTIONS(2061),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(2061),
    [anon_sym_spawn] = ACTIONS(2061),
    [anon_sym_json_DOTdecode] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_LT_DASH] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_GT_GT_GT] = ACTIONS(2061),
    [anon_sym_AMP_CARET] = ACTIONS(2061),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [sym_none] = ACTIONS(2061),
    [sym_true] = ACTIONS(2061),
    [sym_false] = ACTIONS(2061),
    [sym_nil] = ACTIONS(2061),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_DOLLARif] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_BANGis] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_BANGin] = ACTIONS(2061),
    [anon_sym_match] = ACTIONS(2061),
    [anon_sym_select] = ACTIONS(2061),
    [anon_sym_lock] = ACTIONS(2061),
    [anon_sym_rlock] = ACTIONS(2061),
    [anon_sym_unsafe] = ACTIONS(2061),
    [anon_sym_sql] = ACTIONS(2061),
    [sym_int_literal] = ACTIONS(2061),
    [sym_float_literal] = ACTIONS(2061),
    [sym_rune_literal] = ACTIONS(2061),
    [anon_sym_SQUOTE] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(2061),
    [anon_sym_c_SQUOTE] = ACTIONS(2061),
    [anon_sym_c_DQUOTE] = ACTIONS(2061),
    [anon_sym_r_SQUOTE] = ACTIONS(2061),
    [anon_sym_r_DQUOTE] = ACTIONS(2061),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2061),
    [anon_sym_shared] = ACTIONS(2061),
    [anon_sym_map_LBRACK] = ACTIONS(2061),
    [anon_sym_chan] = ACTIONS(2061),
    [anon_sym_thread] = ACTIONS(2061),
    [anon_sym_atomic] = ACTIONS(2061),
    [anon_sym_assert] = ACTIONS(2061),
    [anon_sym_defer] = ACTIONS(2061),
    [anon_sym_goto] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2061),
    [anon_sym_continue] = ACTIONS(2061),
    [anon_sym_return] = ACTIONS(2061),
    [anon_sym_DOLLARfor] = ACTIONS(2061),
    [anon_sym_for] = ACTIONS(2061),
    [anon_sym_POUND] = ACTIONS(2061),
    [anon_sym_asm] = ACTIONS(2061),
  },
  [1277] = {
    [sym_line_comment] = STATE(1277),
    [sym_block_comment] = STATE(1277),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_DASH] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_SLASH] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_GT_GT_GT] = ACTIONS(2053),
    [anon_sym_AMP_CARET] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2053),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
  },
  [1278] = {
    [sym_line_comment] = STATE(1278),
    [sym_block_comment] = STATE(1278),
    [sym_else_branch] = STATE(1387),
    [sym_identifier] = ACTIONS(2083),
    [anon_sym_LF] = ACTIONS(2083),
    [anon_sym_CR] = ACTIONS(2083),
    [anon_sym_CR_LF] = ACTIONS(2083),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2083),
    [anon_sym_DOT] = ACTIONS(2083),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(2083),
    [anon_sym_COMMA] = ACTIONS(2083),
    [anon_sym_RBRACE] = ACTIONS(2083),
    [anon_sym_LPAREN] = ACTIONS(2083),
    [anon_sym_fn] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2083),
    [anon_sym_SLASH] = ACTIONS(2083),
    [anon_sym_PERCENT] = ACTIONS(2083),
    [anon_sym_LT] = ACTIONS(2083),
    [anon_sym_GT] = ACTIONS(2083),
    [anon_sym_EQ_EQ] = ACTIONS(2083),
    [anon_sym_BANG_EQ] = ACTIONS(2083),
    [anon_sym_LT_EQ] = ACTIONS(2083),
    [anon_sym_GT_EQ] = ACTIONS(2083),
    [anon_sym_LBRACK] = ACTIONS(2081),
    [anon_sym_struct] = ACTIONS(2083),
    [anon_sym_mut] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_QMARK] = ACTIONS(2083),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_go] = ACTIONS(2083),
    [anon_sym_spawn] = ACTIONS(2083),
    [anon_sym_json_DOTdecode] = ACTIONS(2083),
    [anon_sym_PIPE] = ACTIONS(2083),
    [anon_sym_LBRACK2] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_LT_DASH] = ACTIONS(2083),
    [anon_sym_LT_LT] = ACTIONS(2083),
    [anon_sym_GT_GT] = ACTIONS(2083),
    [anon_sym_GT_GT_GT] = ACTIONS(2083),
    [anon_sym_AMP_CARET] = ACTIONS(2083),
    [anon_sym_AMP_AMP] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(2083),
    [anon_sym_or] = ACTIONS(2083),
    [sym_none] = ACTIONS(2083),
    [sym_true] = ACTIONS(2083),
    [sym_false] = ACTIONS(2083),
    [sym_nil] = ACTIONS(2083),
    [anon_sym_QMARK_DOT] = ACTIONS(2083),
    [anon_sym_POUND_LBRACK] = ACTIONS(2083),
    [anon_sym_if] = ACTIONS(2083),
    [anon_sym_else] = ACTIONS(4020),
    [anon_sym_DOLLARif] = ACTIONS(2083),
    [anon_sym_is] = ACTIONS(2083),
    [anon_sym_BANGis] = ACTIONS(2083),
    [anon_sym_in] = ACTIONS(2083),
    [anon_sym_BANGin] = ACTIONS(2083),
    [anon_sym_match] = ACTIONS(2083),
    [anon_sym_select] = ACTIONS(2083),
    [anon_sym_lock] = ACTIONS(2083),
    [anon_sym_rlock] = ACTIONS(2083),
    [anon_sym_unsafe] = ACTIONS(2083),
    [anon_sym_sql] = ACTIONS(2083),
    [sym_int_literal] = ACTIONS(2083),
    [sym_float_literal] = ACTIONS(2083),
    [sym_rune_literal] = ACTIONS(2083),
    [anon_sym_SQUOTE] = ACTIONS(2083),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_c_SQUOTE] = ACTIONS(2083),
    [anon_sym_c_DQUOTE] = ACTIONS(2083),
    [anon_sym_r_SQUOTE] = ACTIONS(2083),
    [anon_sym_r_DQUOTE] = ACTIONS(2083),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2083),
    [anon_sym_shared] = ACTIONS(2083),
    [anon_sym_map_LBRACK] = ACTIONS(2083),
    [anon_sym_chan] = ACTIONS(2083),
    [anon_sym_thread] = ACTIONS(2083),
    [anon_sym_atomic] = ACTIONS(2083),
    [anon_sym_assert] = ACTIONS(2083),
    [anon_sym_defer] = ACTIONS(2083),
    [anon_sym_goto] = ACTIONS(2083),
    [anon_sym_break] = ACTIONS(2083),
    [anon_sym_continue] = ACTIONS(2083),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_DOLLARfor] = ACTIONS(2083),
    [anon_sym_for] = ACTIONS(2083),
    [anon_sym_POUND] = ACTIONS(2083),
    [anon_sym_asm] = ACTIONS(2083),
  },
  [1279] = {
    [sym_line_comment] = STATE(1279),
    [sym_block_comment] = STATE(1279),
    [sym_else_branch] = STATE(1388),
    [sym_identifier] = ACTIONS(2089),
    [anon_sym_LF] = ACTIONS(2089),
    [anon_sym_CR] = ACTIONS(2089),
    [anon_sym_CR_LF] = ACTIONS(2089),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2089),
    [anon_sym_DOT] = ACTIONS(2089),
    [anon_sym_as] = ACTIONS(2089),
    [anon_sym_LBRACE] = ACTIONS(2089),
    [anon_sym_COMMA] = ACTIONS(2089),
    [anon_sym_RBRACE] = ACTIONS(2089),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_fn] = ACTIONS(2089),
    [anon_sym_PLUS] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2089),
    [anon_sym_SLASH] = ACTIONS(2089),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_LT] = ACTIONS(2089),
    [anon_sym_GT] = ACTIONS(2089),
    [anon_sym_EQ_EQ] = ACTIONS(2089),
    [anon_sym_BANG_EQ] = ACTIONS(2089),
    [anon_sym_LT_EQ] = ACTIONS(2089),
    [anon_sym_GT_EQ] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2087),
    [anon_sym_struct] = ACTIONS(2089),
    [anon_sym_mut] = ACTIONS(2089),
    [anon_sym_PLUS_PLUS] = ACTIONS(2089),
    [anon_sym_DASH_DASH] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2089),
    [anon_sym_BANG] = ACTIONS(2089),
    [anon_sym_go] = ACTIONS(2089),
    [anon_sym_spawn] = ACTIONS(2089),
    [anon_sym_json_DOTdecode] = ACTIONS(2089),
    [anon_sym_PIPE] = ACTIONS(2089),
    [anon_sym_LBRACK2] = ACTIONS(2089),
    [anon_sym_TILDE] = ACTIONS(2089),
    [anon_sym_CARET] = ACTIONS(2089),
    [anon_sym_AMP] = ACTIONS(2089),
    [anon_sym_LT_DASH] = ACTIONS(2089),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_GT_GT] = ACTIONS(2089),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_AMP_CARET] = ACTIONS(2089),
    [anon_sym_AMP_AMP] = ACTIONS(2089),
    [anon_sym_PIPE_PIPE] = ACTIONS(2089),
    [anon_sym_or] = ACTIONS(2089),
    [sym_none] = ACTIONS(2089),
    [sym_true] = ACTIONS(2089),
    [sym_false] = ACTIONS(2089),
    [sym_nil] = ACTIONS(2089),
    [anon_sym_QMARK_DOT] = ACTIONS(2089),
    [anon_sym_POUND_LBRACK] = ACTIONS(2089),
    [anon_sym_if] = ACTIONS(2089),
    [anon_sym_else] = ACTIONS(4020),
    [anon_sym_DOLLARif] = ACTIONS(2089),
    [anon_sym_is] = ACTIONS(2089),
    [anon_sym_BANGis] = ACTIONS(2089),
    [anon_sym_in] = ACTIONS(2089),
    [anon_sym_BANGin] = ACTIONS(2089),
    [anon_sym_match] = ACTIONS(2089),
    [anon_sym_select] = ACTIONS(2089),
    [anon_sym_lock] = ACTIONS(2089),
    [anon_sym_rlock] = ACTIONS(2089),
    [anon_sym_unsafe] = ACTIONS(2089),
    [anon_sym_sql] = ACTIONS(2089),
    [sym_int_literal] = ACTIONS(2089),
    [sym_float_literal] = ACTIONS(2089),
    [sym_rune_literal] = ACTIONS(2089),
    [anon_sym_SQUOTE] = ACTIONS(2089),
    [anon_sym_DQUOTE] = ACTIONS(2089),
    [anon_sym_c_SQUOTE] = ACTIONS(2089),
    [anon_sym_c_DQUOTE] = ACTIONS(2089),
    [anon_sym_r_SQUOTE] = ACTIONS(2089),
    [anon_sym_r_DQUOTE] = ACTIONS(2089),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2089),
    [anon_sym_shared] = ACTIONS(2089),
    [anon_sym_map_LBRACK] = ACTIONS(2089),
    [anon_sym_chan] = ACTIONS(2089),
    [anon_sym_thread] = ACTIONS(2089),
    [anon_sym_atomic] = ACTIONS(2089),
    [anon_sym_assert] = ACTIONS(2089),
    [anon_sym_defer] = ACTIONS(2089),
    [anon_sym_goto] = ACTIONS(2089),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_continue] = ACTIONS(2089),
    [anon_sym_return] = ACTIONS(2089),
    [anon_sym_DOLLARfor] = ACTIONS(2089),
    [anon_sym_for] = ACTIONS(2089),
    [anon_sym_POUND] = ACTIONS(2089),
    [anon_sym_asm] = ACTIONS(2089),
  },
  [1280] = {
    [sym_line_comment] = STATE(1280),
    [sym_block_comment] = STATE(1280),
    [sym_reference_expression] = STATE(4425),
    [sym_type_reference_expression] = STATE(1699),
    [sym_plain_type] = STATE(1747),
    [sym__plain_type_without_special] = STATE(1719),
    [sym_anon_struct_type] = STATE(1721),
    [sym_multi_return_type] = STATE(1719),
    [sym_result_type] = STATE(1719),
    [sym_option_type] = STATE(1719),
    [sym_qualified_type] = STATE(1699),
    [sym_fixed_array_type] = STATE(1721),
    [sym_array_type] = STATE(1721),
    [sym_pointer_type] = STATE(1721),
    [sym_wrong_pointer_type] = STATE(1721),
    [sym_map_type] = STATE(1721),
    [sym_channel_type] = STATE(1721),
    [sym_shared_type] = STATE(1721),
    [sym_thread_type] = STATE(1721),
    [sym_atomic_type] = STATE(1721),
    [sym_generic_type] = STATE(1721),
    [sym_function_type] = STATE(1721),
    [ts_builtin_sym_end] = ACTIONS(853),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_LF] = ACTIONS(855),
    [anon_sym_CR] = ACTIONS(855),
    [anon_sym_CR_LF] = ACTIONS(855),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_const] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym___global] = ACTIONS(855),
    [anon_sym_type] = ACTIONS(855),
    [anon_sym_fn] = ACTIONS(4026),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(4028),
    [anon_sym_struct] = ACTIONS(4030),
    [anon_sym_union] = ACTIONS(855),
    [anon_sym_pub] = ACTIONS(855),
    [anon_sym_mut] = ACTIONS(855),
    [anon_sym_enum] = ACTIONS(855),
    [anon_sym_interface] = ACTIONS(855),
    [anon_sym_QMARK] = ACTIONS(4032),
    [anon_sym_BANG] = ACTIONS(4034),
    [anon_sym_go] = ACTIONS(855),
    [anon_sym_spawn] = ACTIONS(855),
    [anon_sym_json_DOTdecode] = ACTIONS(855),
    [anon_sym_LBRACK2] = ACTIONS(4036),
    [anon_sym_TILDE] = ACTIONS(855),
    [anon_sym_CARET] = ACTIONS(855),
    [anon_sym_AMP] = ACTIONS(4038),
    [anon_sym_LT_DASH] = ACTIONS(855),
    [sym_none] = ACTIONS(855),
    [sym_true] = ACTIONS(855),
    [sym_false] = ACTIONS(855),
    [sym_nil] = ACTIONS(855),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_DOLLARif] = ACTIONS(855),
    [anon_sym_match] = ACTIONS(855),
    [anon_sym_select] = ACTIONS(855),
    [anon_sym_lock] = ACTIONS(855),
    [anon_sym_rlock] = ACTIONS(855),
    [anon_sym_unsafe] = ACTIONS(855),
    [anon_sym_sql] = ACTIONS(855),
    [sym_int_literal] = ACTIONS(855),
    [sym_float_literal] = ACTIONS(855),
    [sym_rune_literal] = ACTIONS(855),
    [anon_sym_SQUOTE] = ACTIONS(855),
    [anon_sym_DQUOTE] = ACTIONS(855),
    [anon_sym_c_SQUOTE] = ACTIONS(855),
    [anon_sym_c_DQUOTE] = ACTIONS(855),
    [anon_sym_r_SQUOTE] = ACTIONS(855),
    [anon_sym_r_DQUOTE] = ACTIONS(855),
    [sym_pseudo_compile_time_identifier] = ACTIONS(855),
    [anon_sym_shared] = ACTIONS(4040),
    [aux_sym_sum_type_token1] = ACTIONS(855),
    [anon_sym_PIPE2] = ACTIONS(853),
    [anon_sym_map_LBRACK] = ACTIONS(4042),
    [anon_sym_chan] = ACTIONS(4044),
    [anon_sym_thread] = ACTIONS(4046),
    [anon_sym_atomic] = ACTIONS(4048),
    [anon_sym_assert] = ACTIONS(855),
    [anon_sym_defer] = ACTIONS(855),
    [anon_sym_goto] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(855),
    [anon_sym_continue] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(855),
    [anon_sym_DOLLARfor] = ACTIONS(855),
    [anon_sym_for] = ACTIONS(855),
    [anon_sym_POUND] = ACTIONS(855),
    [anon_sym_asm] = ACTIONS(855),
    [anon_sym_AT_LBRACK] = ACTIONS(855),
  },
  [1281] = {
    [sym_line_comment] = STATE(1281),
    [sym_block_comment] = STATE(1281),
    [sym_reference_expression] = STATE(4425),
    [sym_type_reference_expression] = STATE(1699),
    [sym_plain_type] = STATE(1739),
    [sym__plain_type_without_special] = STATE(1719),
    [sym_anon_struct_type] = STATE(1721),
    [sym_multi_return_type] = STATE(1719),
    [sym_result_type] = STATE(1719),
    [sym_option_type] = STATE(1719),
    [sym_qualified_type] = STATE(1699),
    [sym_fixed_array_type] = STATE(1721),
    [sym_array_type] = STATE(1721),
    [sym_pointer_type] = STATE(1721),
    [sym_wrong_pointer_type] = STATE(1721),
    [sym_map_type] = STATE(1721),
    [sym_channel_type] = STATE(1721),
    [sym_shared_type] = STATE(1721),
    [sym_thread_type] = STATE(1721),
    [sym_atomic_type] = STATE(1721),
    [sym_generic_type] = STATE(1721),
    [sym_function_type] = STATE(1721),
    [ts_builtin_sym_end] = ACTIONS(857),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_CR] = ACTIONS(859),
    [anon_sym_CR_LF] = ACTIONS(859),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(859),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_const] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym___global] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(859),
    [anon_sym_fn] = ACTIONS(4026),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(4028),
    [anon_sym_struct] = ACTIONS(4030),
    [anon_sym_union] = ACTIONS(859),
    [anon_sym_pub] = ACTIONS(859),
    [anon_sym_mut] = ACTIONS(859),
    [anon_sym_enum] = ACTIONS(859),
    [anon_sym_interface] = ACTIONS(859),
    [anon_sym_QMARK] = ACTIONS(4032),
    [anon_sym_BANG] = ACTIONS(4034),
    [anon_sym_go] = ACTIONS(859),
    [anon_sym_spawn] = ACTIONS(859),
    [anon_sym_json_DOTdecode] = ACTIONS(859),
    [anon_sym_LBRACK2] = ACTIONS(4036),
    [anon_sym_TILDE] = ACTIONS(859),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(4038),
    [anon_sym_LT_DASH] = ACTIONS(859),
    [sym_none] = ACTIONS(859),
    [sym_true] = ACTIONS(859),
    [sym_false] = ACTIONS(859),
    [sym_nil] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_DOLLARif] = ACTIONS(859),
    [anon_sym_match] = ACTIONS(859),
    [anon_sym_select] = ACTIONS(859),
    [anon_sym_lock] = ACTIONS(859),
    [anon_sym_rlock] = ACTIONS(859),
    [anon_sym_unsafe] = ACTIONS(859),
    [anon_sym_sql] = ACTIONS(859),
    [sym_int_literal] = ACTIONS(859),
    [sym_float_literal] = ACTIONS(859),
    [sym_rune_literal] = ACTIONS(859),
    [anon_sym_SQUOTE] = ACTIONS(859),
    [anon_sym_DQUOTE] = ACTIONS(859),
    [anon_sym_c_SQUOTE] = ACTIONS(859),
    [anon_sym_c_DQUOTE] = ACTIONS(859),
    [anon_sym_r_SQUOTE] = ACTIONS(859),
    [anon_sym_r_DQUOTE] = ACTIONS(859),
    [sym_pseudo_compile_time_identifier] = ACTIONS(859),
    [anon_sym_shared] = ACTIONS(4040),
    [aux_sym_sum_type_token1] = ACTIONS(859),
    [anon_sym_PIPE2] = ACTIONS(857),
    [anon_sym_map_LBRACK] = ACTIONS(4042),
    [anon_sym_chan] = ACTIONS(4044),
    [anon_sym_thread] = ACTIONS(4046),
    [anon_sym_atomic] = ACTIONS(4048),
    [anon_sym_assert] = ACTIONS(859),
    [anon_sym_defer] = ACTIONS(859),
    [anon_sym_goto] = ACTIONS(859),
    [anon_sym_break] = ACTIONS(859),
    [anon_sym_continue] = ACTIONS(859),
    [anon_sym_return] = ACTIONS(859),
    [anon_sym_DOLLARfor] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(859),
    [anon_sym_POUND] = ACTIONS(859),
    [anon_sym_asm] = ACTIONS(859),
    [anon_sym_AT_LBRACK] = ACTIONS(859),
  },
  [1282] = {
    [sym_line_comment] = STATE(1282),
    [sym_block_comment] = STATE(1282),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(2065),
    [anon_sym_LF] = ACTIONS(2065),
    [anon_sym_CR] = ACTIONS(2065),
    [anon_sym_CR_LF] = ACTIONS(2065),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(2065),
    [anon_sym_RBRACE] = ACTIONS(2065),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(2065),
    [anon_sym_PLUS] = ACTIONS(4050),
    [anon_sym_DASH] = ACTIONS(4050),
    [anon_sym_STAR] = ACTIONS(4052),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(2065),
    [anon_sym_mut] = ACTIONS(2065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3996),
    [anon_sym_DASH_DASH] = ACTIONS(3998),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(2065),
    [anon_sym_spawn] = ACTIONS(2065),
    [anon_sym_json_DOTdecode] = ACTIONS(2065),
    [anon_sym_PIPE] = ACTIONS(4050),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(2065),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_LT_DASH] = ACTIONS(2065),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_GT_GT_GT] = ACTIONS(4052),
    [anon_sym_AMP_CARET] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4056),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_or] = ACTIONS(4010),
    [sym_none] = ACTIONS(2065),
    [sym_true] = ACTIONS(2065),
    [sym_false] = ACTIONS(2065),
    [sym_nil] = ACTIONS(2065),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(2065),
    [anon_sym_DOLLARif] = ACTIONS(2065),
    [anon_sym_is] = ACTIONS(4012),
    [anon_sym_BANGis] = ACTIONS(4012),
    [anon_sym_in] = ACTIONS(4060),
    [anon_sym_BANGin] = ACTIONS(4060),
    [anon_sym_match] = ACTIONS(2065),
    [anon_sym_select] = ACTIONS(2065),
    [anon_sym_lock] = ACTIONS(2065),
    [anon_sym_rlock] = ACTIONS(2065),
    [anon_sym_unsafe] = ACTIONS(2065),
    [anon_sym_sql] = ACTIONS(2065),
    [sym_int_literal] = ACTIONS(2065),
    [sym_float_literal] = ACTIONS(2065),
    [sym_rune_literal] = ACTIONS(2065),
    [anon_sym_SQUOTE] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2065),
    [anon_sym_c_SQUOTE] = ACTIONS(2065),
    [anon_sym_c_DQUOTE] = ACTIONS(2065),
    [anon_sym_r_SQUOTE] = ACTIONS(2065),
    [anon_sym_r_DQUOTE] = ACTIONS(2065),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2065),
    [anon_sym_shared] = ACTIONS(2065),
    [anon_sym_map_LBRACK] = ACTIONS(2065),
    [anon_sym_chan] = ACTIONS(2065),
    [anon_sym_thread] = ACTIONS(2065),
    [anon_sym_atomic] = ACTIONS(2065),
    [anon_sym_assert] = ACTIONS(2065),
    [anon_sym_defer] = ACTIONS(2065),
    [anon_sym_goto] = ACTIONS(2065),
    [anon_sym_break] = ACTIONS(2065),
    [anon_sym_continue] = ACTIONS(2065),
    [anon_sym_return] = ACTIONS(2065),
    [anon_sym_DOLLARfor] = ACTIONS(2065),
    [anon_sym_for] = ACTIONS(2065),
    [anon_sym_POUND] = ACTIONS(2065),
    [anon_sym_asm] = ACTIONS(2065),
  },
  [1283] = {
    [sym_line_comment] = STATE(1283),
    [sym_block_comment] = STATE(1283),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(4050),
    [anon_sym_DASH] = ACTIONS(4050),
    [anon_sym_STAR] = ACTIONS(4052),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(4050),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_GT_GT_GT] = ACTIONS(4052),
    [anon_sym_AMP_CARET] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(4060),
    [anon_sym_BANGin] = ACTIONS(4060),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
  },
  [1284] = {
    [sym_line_comment] = STATE(1284),
    [sym_block_comment] = STATE(1284),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_DASH] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(4052),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_GT_GT_GT] = ACTIONS(4052),
    [anon_sym_AMP_CARET] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2053),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
  },
  [1285] = {
    [sym_line_comment] = STATE(1285),
    [sym_block_comment] = STATE(1285),
    [sym_reference_expression] = STATE(4425),
    [sym_type_reference_expression] = STATE(1699),
    [sym_plain_type] = STATE(1726),
    [sym__plain_type_without_special] = STATE(1719),
    [sym_anon_struct_type] = STATE(1721),
    [sym_multi_return_type] = STATE(1719),
    [sym_result_type] = STATE(1719),
    [sym_option_type] = STATE(1719),
    [sym_qualified_type] = STATE(1699),
    [sym_fixed_array_type] = STATE(1721),
    [sym_array_type] = STATE(1721),
    [sym_pointer_type] = STATE(1721),
    [sym_wrong_pointer_type] = STATE(1721),
    [sym_map_type] = STATE(1721),
    [sym_channel_type] = STATE(1721),
    [sym_shared_type] = STATE(1721),
    [sym_thread_type] = STATE(1721),
    [sym_atomic_type] = STATE(1721),
    [sym_generic_type] = STATE(1721),
    [sym_function_type] = STATE(1721),
    [ts_builtin_sym_end] = ACTIONS(817),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_CR] = ACTIONS(821),
    [anon_sym_CR_LF] = ACTIONS(821),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(821),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_const] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym___global] = ACTIONS(821),
    [anon_sym_type] = ACTIONS(821),
    [anon_sym_fn] = ACTIONS(4026),
    [anon_sym_PLUS] = ACTIONS(821),
    [anon_sym_DASH] = ACTIONS(821),
    [anon_sym_STAR] = ACTIONS(4028),
    [anon_sym_struct] = ACTIONS(4030),
    [anon_sym_union] = ACTIONS(821),
    [anon_sym_pub] = ACTIONS(821),
    [anon_sym_mut] = ACTIONS(821),
    [anon_sym_enum] = ACTIONS(821),
    [anon_sym_interface] = ACTIONS(821),
    [anon_sym_QMARK] = ACTIONS(4032),
    [anon_sym_BANG] = ACTIONS(4034),
    [anon_sym_go] = ACTIONS(821),
    [anon_sym_spawn] = ACTIONS(821),
    [anon_sym_json_DOTdecode] = ACTIONS(821),
    [anon_sym_LBRACK2] = ACTIONS(4036),
    [anon_sym_TILDE] = ACTIONS(821),
    [anon_sym_CARET] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(4038),
    [anon_sym_LT_DASH] = ACTIONS(821),
    [sym_none] = ACTIONS(821),
    [sym_true] = ACTIONS(821),
    [sym_false] = ACTIONS(821),
    [sym_nil] = ACTIONS(821),
    [anon_sym_if] = ACTIONS(821),
    [anon_sym_DOLLARif] = ACTIONS(821),
    [anon_sym_match] = ACTIONS(821),
    [anon_sym_select] = ACTIONS(821),
    [anon_sym_lock] = ACTIONS(821),
    [anon_sym_rlock] = ACTIONS(821),
    [anon_sym_unsafe] = ACTIONS(821),
    [anon_sym_sql] = ACTIONS(821),
    [sym_int_literal] = ACTIONS(821),
    [sym_float_literal] = ACTIONS(821),
    [sym_rune_literal] = ACTIONS(821),
    [anon_sym_SQUOTE] = ACTIONS(821),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [anon_sym_c_SQUOTE] = ACTIONS(821),
    [anon_sym_c_DQUOTE] = ACTIONS(821),
    [anon_sym_r_SQUOTE] = ACTIONS(821),
    [anon_sym_r_DQUOTE] = ACTIONS(821),
    [sym_pseudo_compile_time_identifier] = ACTIONS(821),
    [anon_sym_shared] = ACTIONS(4040),
    [aux_sym_sum_type_token1] = ACTIONS(821),
    [anon_sym_PIPE2] = ACTIONS(817),
    [anon_sym_map_LBRACK] = ACTIONS(4042),
    [anon_sym_chan] = ACTIONS(4044),
    [anon_sym_thread] = ACTIONS(4046),
    [anon_sym_atomic] = ACTIONS(4048),
    [anon_sym_assert] = ACTIONS(821),
    [anon_sym_defer] = ACTIONS(821),
    [anon_sym_goto] = ACTIONS(821),
    [anon_sym_break] = ACTIONS(821),
    [anon_sym_continue] = ACTIONS(821),
    [anon_sym_return] = ACTIONS(821),
    [anon_sym_DOLLARfor] = ACTIONS(821),
    [anon_sym_for] = ACTIONS(821),
    [anon_sym_POUND] = ACTIONS(821),
    [anon_sym_asm] = ACTIONS(821),
    [anon_sym_AT_LBRACK] = ACTIONS(821),
  },
  [1286] = {
    [sym_line_comment] = STATE(1286),
    [sym_block_comment] = STATE(1286),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(2049),
    [anon_sym_LF] = ACTIONS(2049),
    [anon_sym_CR] = ACTIONS(2049),
    [anon_sym_CR_LF] = ACTIONS(2049),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(2049),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(4050),
    [anon_sym_DASH] = ACTIONS(4050),
    [anon_sym_STAR] = ACTIONS(4052),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(2049),
    [anon_sym_mut] = ACTIONS(2049),
    [anon_sym_PLUS_PLUS] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(2049),
    [anon_sym_spawn] = ACTIONS(2049),
    [anon_sym_json_DOTdecode] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(4050),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(2049),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_LT_DASH] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_GT_GT_GT] = ACTIONS(4052),
    [anon_sym_AMP_CARET] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_or] = ACTIONS(2049),
    [sym_none] = ACTIONS(2049),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [sym_nil] = ACTIONS(2049),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(2049),
    [anon_sym_DOLLARif] = ACTIONS(2049),
    [anon_sym_is] = ACTIONS(2049),
    [anon_sym_BANGis] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_BANGin] = ACTIONS(2049),
    [anon_sym_match] = ACTIONS(2049),
    [anon_sym_select] = ACTIONS(2049),
    [anon_sym_lock] = ACTIONS(2049),
    [anon_sym_rlock] = ACTIONS(2049),
    [anon_sym_unsafe] = ACTIONS(2049),
    [anon_sym_sql] = ACTIONS(2049),
    [sym_int_literal] = ACTIONS(2049),
    [sym_float_literal] = ACTIONS(2049),
    [sym_rune_literal] = ACTIONS(2049),
    [anon_sym_SQUOTE] = ACTIONS(2049),
    [anon_sym_DQUOTE] = ACTIONS(2049),
    [anon_sym_c_SQUOTE] = ACTIONS(2049),
    [anon_sym_c_DQUOTE] = ACTIONS(2049),
    [anon_sym_r_SQUOTE] = ACTIONS(2049),
    [anon_sym_r_DQUOTE] = ACTIONS(2049),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2049),
    [anon_sym_shared] = ACTIONS(2049),
    [anon_sym_map_LBRACK] = ACTIONS(2049),
    [anon_sym_chan] = ACTIONS(2049),
    [anon_sym_thread] = ACTIONS(2049),
    [anon_sym_atomic] = ACTIONS(2049),
    [anon_sym_assert] = ACTIONS(2049),
    [anon_sym_defer] = ACTIONS(2049),
    [anon_sym_goto] = ACTIONS(2049),
    [anon_sym_break] = ACTIONS(2049),
    [anon_sym_continue] = ACTIONS(2049),
    [anon_sym_return] = ACTIONS(2049),
    [anon_sym_DOLLARfor] = ACTIONS(2049),
    [anon_sym_for] = ACTIONS(2049),
    [anon_sym_POUND] = ACTIONS(2049),
    [anon_sym_asm] = ACTIONS(2049),
  },
  [1287] = {
    [sym_line_comment] = STATE(1287),
    [sym_block_comment] = STATE(1287),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(4050),
    [anon_sym_DASH] = ACTIONS(4050),
    [anon_sym_STAR] = ACTIONS(4052),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(4050),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_GT_GT_GT] = ACTIONS(4052),
    [anon_sym_AMP_CARET] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4056),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(4060),
    [anon_sym_BANGin] = ACTIONS(4060),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
  },
  [1288] = {
    [sym_line_comment] = STATE(1288),
    [sym_block_comment] = STATE(1288),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(3930),
    [anon_sym_LF] = ACTIONS(3930),
    [anon_sym_CR] = ACTIONS(3930),
    [anon_sym_CR_LF] = ACTIONS(3930),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3930),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3930),
    [anon_sym_RBRACE] = ACTIONS(3930),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(3930),
    [anon_sym_PLUS] = ACTIONS(4050),
    [anon_sym_DASH] = ACTIONS(4050),
    [anon_sym_STAR] = ACTIONS(4052),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(3930),
    [anon_sym_mut] = ACTIONS(3930),
    [anon_sym_PLUS_PLUS] = ACTIONS(3996),
    [anon_sym_DASH_DASH] = ACTIONS(3998),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(3930),
    [anon_sym_spawn] = ACTIONS(3930),
    [anon_sym_json_DOTdecode] = ACTIONS(3930),
    [anon_sym_PIPE] = ACTIONS(4050),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(3930),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_LT_DASH] = ACTIONS(3930),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_GT_GT_GT] = ACTIONS(4052),
    [anon_sym_AMP_CARET] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4056),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_or] = ACTIONS(4010),
    [sym_none] = ACTIONS(3930),
    [sym_true] = ACTIONS(3930),
    [sym_false] = ACTIONS(3930),
    [sym_nil] = ACTIONS(3930),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(3930),
    [anon_sym_DOLLARif] = ACTIONS(3930),
    [anon_sym_is] = ACTIONS(4012),
    [anon_sym_BANGis] = ACTIONS(4012),
    [anon_sym_in] = ACTIONS(4060),
    [anon_sym_BANGin] = ACTIONS(4060),
    [anon_sym_match] = ACTIONS(3930),
    [anon_sym_select] = ACTIONS(3930),
    [anon_sym_lock] = ACTIONS(3930),
    [anon_sym_rlock] = ACTIONS(3930),
    [anon_sym_unsafe] = ACTIONS(3930),
    [anon_sym_sql] = ACTIONS(3930),
    [sym_int_literal] = ACTIONS(3930),
    [sym_float_literal] = ACTIONS(3930),
    [sym_rune_literal] = ACTIONS(3930),
    [anon_sym_SQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [anon_sym_c_SQUOTE] = ACTIONS(3930),
    [anon_sym_c_DQUOTE] = ACTIONS(3930),
    [anon_sym_r_SQUOTE] = ACTIONS(3930),
    [anon_sym_r_DQUOTE] = ACTIONS(3930),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3930),
    [anon_sym_shared] = ACTIONS(3930),
    [anon_sym_map_LBRACK] = ACTIONS(3930),
    [anon_sym_chan] = ACTIONS(3930),
    [anon_sym_thread] = ACTIONS(3930),
    [anon_sym_atomic] = ACTIONS(3930),
    [anon_sym_assert] = ACTIONS(3930),
    [anon_sym_defer] = ACTIONS(3930),
    [anon_sym_goto] = ACTIONS(3930),
    [anon_sym_break] = ACTIONS(3930),
    [anon_sym_continue] = ACTIONS(3930),
    [anon_sym_return] = ACTIONS(3930),
    [anon_sym_DOLLARfor] = ACTIONS(3930),
    [anon_sym_for] = ACTIONS(3930),
    [anon_sym_POUND] = ACTIONS(3930),
    [anon_sym_asm] = ACTIONS(3930),
  },
  [1289] = {
    [sym_line_comment] = STATE(1289),
    [sym_block_comment] = STATE(1289),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(3912),
    [anon_sym_LF] = ACTIONS(3912),
    [anon_sym_CR] = ACTIONS(3912),
    [anon_sym_CR_LF] = ACTIONS(3912),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3912),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3912),
    [anon_sym_RBRACE] = ACTIONS(3912),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(3912),
    [anon_sym_PLUS] = ACTIONS(3912),
    [anon_sym_DASH] = ACTIONS(3912),
    [anon_sym_STAR] = ACTIONS(3912),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(3912),
    [anon_sym_mut] = ACTIONS(3912),
    [anon_sym_PLUS_PLUS] = ACTIONS(3996),
    [anon_sym_DASH_DASH] = ACTIONS(3998),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(3912),
    [anon_sym_spawn] = ACTIONS(3912),
    [anon_sym_json_DOTdecode] = ACTIONS(3912),
    [anon_sym_PIPE] = ACTIONS(4050),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(3912),
    [anon_sym_CARET] = ACTIONS(3912),
    [anon_sym_AMP] = ACTIONS(3912),
    [anon_sym_LT_DASH] = ACTIONS(3912),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_GT_GT_GT] = ACTIONS(4052),
    [anon_sym_AMP_CARET] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4056),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_or] = ACTIONS(4010),
    [sym_none] = ACTIONS(3912),
    [sym_true] = ACTIONS(3912),
    [sym_false] = ACTIONS(3912),
    [sym_nil] = ACTIONS(3912),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(3912),
    [anon_sym_DOLLARif] = ACTIONS(3912),
    [anon_sym_is] = ACTIONS(4012),
    [anon_sym_BANGis] = ACTIONS(4012),
    [anon_sym_in] = ACTIONS(4060),
    [anon_sym_BANGin] = ACTIONS(4060),
    [anon_sym_match] = ACTIONS(3912),
    [anon_sym_select] = ACTIONS(3912),
    [anon_sym_lock] = ACTIONS(3912),
    [anon_sym_rlock] = ACTIONS(3912),
    [anon_sym_unsafe] = ACTIONS(3912),
    [anon_sym_sql] = ACTIONS(3912),
    [sym_int_literal] = ACTIONS(3912),
    [sym_float_literal] = ACTIONS(3912),
    [sym_rune_literal] = ACTIONS(3912),
    [anon_sym_SQUOTE] = ACTIONS(3912),
    [anon_sym_DQUOTE] = ACTIONS(3912),
    [anon_sym_c_SQUOTE] = ACTIONS(3912),
    [anon_sym_c_DQUOTE] = ACTIONS(3912),
    [anon_sym_r_SQUOTE] = ACTIONS(3912),
    [anon_sym_r_DQUOTE] = ACTIONS(3912),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3912),
    [anon_sym_shared] = ACTIONS(3912),
    [anon_sym_map_LBRACK] = ACTIONS(3912),
    [anon_sym_chan] = ACTIONS(3912),
    [anon_sym_thread] = ACTIONS(3912),
    [anon_sym_atomic] = ACTIONS(3912),
    [anon_sym_assert] = ACTIONS(3912),
    [anon_sym_defer] = ACTIONS(3912),
    [anon_sym_goto] = ACTIONS(3912),
    [anon_sym_break] = ACTIONS(3912),
    [anon_sym_continue] = ACTIONS(3912),
    [anon_sym_return] = ACTIONS(3912),
    [anon_sym_DOLLARfor] = ACTIONS(3912),
    [anon_sym_for] = ACTIONS(3912),
    [anon_sym_POUND] = ACTIONS(3912),
    [anon_sym_asm] = ACTIONS(3912),
  },
  [1290] = {
    [sym_line_comment] = STATE(1290),
    [sym_block_comment] = STATE(1290),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(4050),
    [anon_sym_DASH] = ACTIONS(4050),
    [anon_sym_STAR] = ACTIONS(4052),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(4050),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_GT_GT_GT] = ACTIONS(4052),
    [anon_sym_AMP_CARET] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2053),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
    [anon_sym_assert] = ACTIONS(2053),
    [anon_sym_defer] = ACTIONS(2053),
    [anon_sym_goto] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_DOLLARfor] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_asm] = ACTIONS(2053),
  },
  [1291] = {
    [sym_line_comment] = STATE(1291),
    [sym_block_comment] = STATE(1291),
    [sym_type_parameters] = STATE(4159),
    [sym_argument_list] = STATE(1360),
    [sym_or_block] = STATE(1361),
    [sym_identifier] = ACTIONS(2075),
    [anon_sym_LF] = ACTIONS(2075),
    [anon_sym_CR] = ACTIONS(2075),
    [anon_sym_CR_LF] = ACTIONS(2075),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2075),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_as] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(2075),
    [anon_sym_RBRACE] = ACTIONS(2075),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_fn] = ACTIONS(2075),
    [anon_sym_PLUS] = ACTIONS(4050),
    [anon_sym_DASH] = ACTIONS(4050),
    [anon_sym_STAR] = ACTIONS(4052),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_struct] = ACTIONS(2075),
    [anon_sym_mut] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(3996),
    [anon_sym_DASH_DASH] = ACTIONS(3998),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_go] = ACTIONS(2075),
    [anon_sym_spawn] = ACTIONS(2075),
    [anon_sym_json_DOTdecode] = ACTIONS(2075),
    [anon_sym_PIPE] = ACTIONS(4050),
    [anon_sym_LBRACK2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_LT_DASH] = ACTIONS(2075),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_GT_GT_GT] = ACTIONS(4052),
    [anon_sym_AMP_CARET] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4056),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_or] = ACTIONS(4010),
    [sym_none] = ACTIONS(2075),
    [sym_true] = ACTIONS(2075),
    [sym_false] = ACTIONS(2075),
    [sym_nil] = ACTIONS(2075),
    [anon_sym_QMARK_DOT] = ACTIONS(3980),
    [anon_sym_POUND_LBRACK] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(2075),
    [anon_sym_DOLLARif] = ACTIONS(2075),
    [anon_sym_is] = ACTIONS(4012),
    [anon_sym_BANGis] = ACTIONS(4012),
    [anon_sym_in] = ACTIONS(4060),
    [anon_sym_BANGin] = ACTIONS(4060),
    [anon_sym_match] = ACTIONS(2075),
    [anon_sym_select] = ACTIONS(2075),
    [anon_sym_lock] = ACTIONS(2075),
    [anon_sym_rlock] = ACTIONS(2075),
    [anon_sym_unsafe] = ACTIONS(2075),
    [anon_sym_sql] = ACTIONS(2075),
    [sym_int_literal] = ACTIONS(2075),
    [sym_float_literal] = ACTIONS(2075),
    [sym_rune_literal] = ACTIONS(2075),
    [anon_sym_SQUOTE] = ACTIONS(2075),
    [anon_sym_DQUOTE] = ACTIONS(2075),
    [anon_sym_c_SQUOTE] = ACTIONS(2075),
    [anon_sym_c_DQUOTE] = ACTIONS(2075),
    [anon_sym_r_SQUOTE] = ACTIONS(2075),
    [anon_sym_r_DQUOTE] = ACTIONS(2075),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2075),
    [anon_sym_shared] = ACTIONS(2075),
    [anon_sym_map_LBRACK] = ACTIONS(2075),
    [anon_sym_chan] = ACTIONS(2075),
    [anon_sym_thread] = ACTIONS(2075),
    [anon_sym_atomic] = ACTIONS(2075),
    [anon_sym_assert] = ACTIONS(2075),
    [anon_sym_defer] = ACTIONS(2075),
    [anon_sym_goto] = ACTIONS(2075),
    [anon_sym_break] = ACTIONS(2075),
    [anon_sym_continue] = ACTIONS(2075),
    [anon_sym_return] = ACTIONS(2075),
    [anon_sym_DOLLARfor] = ACTIONS(2075),
    [anon_sym_for] = ACTIONS(2075),
    [anon_sym_POUND] = ACTIONS(2075),
    [anon_sym_asm] = ACTIONS(2075),
  },
  [1292] = {
    [sym_line_comment] = STATE(1292),
    [sym_block_comment] = STATE(1292),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_LF] = ACTIONS(2169),
    [anon_sym_CR] = ACTIONS(2169),
    [anon_sym_CR_LF] = ACTIONS(2169),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2169),
    [anon_sym_as] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_COMMA] = ACTIONS(2169),
    [anon_sym_RBRACE] = ACTIONS(2169),
    [anon_sym_LPAREN] = ACTIONS(2169),
    [anon_sym_fn] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_SLASH] = ACTIONS(2169),
    [anon_sym_PERCENT] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2169),
    [anon_sym_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ] = ACTIONS(2169),
    [anon_sym_LT_EQ] = ACTIONS(2169),
    [anon_sym_GT_EQ] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_mut] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_go] = ACTIONS(2169),
    [anon_sym_spawn] = ACTIONS(2169),
    [anon_sym_json_DOTdecode] = ACTIONS(2169),
    [anon_sym_PIPE] = ACTIONS(2169),
    [anon_sym_LBRACK2] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT_DASH] = ACTIONS(2169),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_GT_GT_GT] = ACTIONS(2169),
    [anon_sym_AMP_CARET] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_PIPE_PIPE] = ACTIONS(2169),
    [anon_sym_or] = ACTIONS(2169),
    [sym_none] = ACTIONS(2169),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [sym_nil] = ACTIONS(2169),
    [anon_sym_QMARK_DOT] = ACTIONS(2169),
    [anon_sym_POUND_LBRACK] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_DOLLARif] = ACTIONS(2169),
    [anon_sym_DOLLARelse] = ACTIONS(2169),
    [anon_sym_is] = ACTIONS(2169),
    [anon_sym_BANGis] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_BANGin] = ACTIONS(2169),
    [anon_sym_match] = ACTIONS(2169),
    [anon_sym_select] = ACTIONS(2169),
    [anon_sym_lock] = ACTIONS(2169),
    [anon_sym_rlock] = ACTIONS(2169),
    [anon_sym_unsafe] = ACTIONS(2169),
    [anon_sym_sql] = ACTIONS(2169),
    [sym_int_literal] = ACTIONS(2169),
    [sym_float_literal] = ACTIONS(2169),
    [sym_rune_literal] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [anon_sym_c_SQUOTE] = ACTIONS(2169),
    [anon_sym_c_DQUOTE] = ACTIONS(2169),
    [anon_sym_r_SQUOTE] = ACTIONS(2169),
    [anon_sym_r_DQUOTE] = ACTIONS(2169),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_map_LBRACK] = ACTIONS(2169),
    [anon_sym_chan] = ACTIONS(2169),
    [anon_sym_thread] = ACTIONS(2169),
    [anon_sym_atomic] = ACTIONS(2169),
    [anon_sym_assert] = ACTIONS(2169),
    [anon_sym_defer] = ACTIONS(2169),
    [anon_sym_goto] = ACTIONS(2169),
    [anon_sym_break] = ACTIONS(2169),
    [anon_sym_continue] = ACTIONS(2169),
    [anon_sym_return] = ACTIONS(2169),
    [anon_sym_DOLLARfor] = ACTIONS(2169),
    [anon_sym_for] = ACTIONS(2169),
    [anon_sym_POUND] = ACTIONS(2169),
    [anon_sym_asm] = ACTIONS(2169),
  },
  [1293] = {
    [sym_line_comment] = STATE(1293),
    [sym_block_comment] = STATE(1293),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_LF] = ACTIONS(2169),
    [anon_sym_CR] = ACTIONS(2169),
    [anon_sym_CR_LF] = ACTIONS(2169),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2169),
    [anon_sym_as] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_COMMA] = ACTIONS(2169),
    [anon_sym_RBRACE] = ACTIONS(2169),
    [anon_sym_LPAREN] = ACTIONS(2169),
    [anon_sym_fn] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_SLASH] = ACTIONS(2169),
    [anon_sym_PERCENT] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2169),
    [anon_sym_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ] = ACTIONS(2169),
    [anon_sym_LT_EQ] = ACTIONS(2169),
    [anon_sym_GT_EQ] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_mut] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_go] = ACTIONS(2169),
    [anon_sym_spawn] = ACTIONS(2169),
    [anon_sym_json_DOTdecode] = ACTIONS(2169),
    [anon_sym_PIPE] = ACTIONS(2169),
    [anon_sym_LBRACK2] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT_DASH] = ACTIONS(2169),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_GT_GT_GT] = ACTIONS(2169),
    [anon_sym_AMP_CARET] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_PIPE_PIPE] = ACTIONS(2169),
    [anon_sym_or] = ACTIONS(2169),
    [sym_none] = ACTIONS(2169),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [sym_nil] = ACTIONS(2169),
    [anon_sym_QMARK_DOT] = ACTIONS(2169),
    [anon_sym_POUND_LBRACK] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(2169),
    [anon_sym_DOLLARif] = ACTIONS(2169),
    [anon_sym_is] = ACTIONS(2169),
    [anon_sym_BANGis] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_BANGin] = ACTIONS(2169),
    [anon_sym_match] = ACTIONS(2169),
    [anon_sym_select] = ACTIONS(2169),
    [anon_sym_lock] = ACTIONS(2169),
    [anon_sym_rlock] = ACTIONS(2169),
    [anon_sym_unsafe] = ACTIONS(2169),
    [anon_sym_sql] = ACTIONS(2169),
    [sym_int_literal] = ACTIONS(2169),
    [sym_float_literal] = ACTIONS(2169),
    [sym_rune_literal] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [anon_sym_c_SQUOTE] = ACTIONS(2169),
    [anon_sym_c_DQUOTE] = ACTIONS(2169),
    [anon_sym_r_SQUOTE] = ACTIONS(2169),
    [anon_sym_r_DQUOTE] = ACTIONS(2169),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_map_LBRACK] = ACTIONS(2169),
    [anon_sym_chan] = ACTIONS(2169),
    [anon_sym_thread] = ACTIONS(2169),
    [anon_sym_atomic] = ACTIONS(2169),
    [anon_sym_assert] = ACTIONS(2169),
    [anon_sym_defer] = ACTIONS(2169),
    [anon_sym_goto] = ACTIONS(2169),
    [anon_sym_break] = ACTIONS(2169),
    [anon_sym_continue] = ACTIONS(2169),
    [anon_sym_return] = ACTIONS(2169),
    [anon_sym_DOLLARfor] = ACTIONS(2169),
    [anon_sym_for] = ACTIONS(2169),
    [anon_sym_POUND] = ACTIONS(2169),
    [anon_sym_asm] = ACTIONS(2169),
  },
  [1294] = {
    [sym_line_comment] = STATE(1294),
    [sym_block_comment] = STATE(1294),
    [sym_identifier] = ACTIONS(2105),
    [anon_sym_LF] = ACTIONS(2105),
    [anon_sym_CR] = ACTIONS(2105),
    [anon_sym_CR_LF] = ACTIONS(2105),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2105),
    [anon_sym_DOT] = ACTIONS(2105),
    [anon_sym_as] = ACTIONS(2105),
    [anon_sym_LBRACE] = ACTIONS(2105),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_RBRACE] = ACTIONS(2105),
    [anon_sym_LPAREN] = ACTIONS(2105),
    [anon_sym_fn] = ACTIONS(2105),
    [anon_sym_PLUS] = ACTIONS(2105),
    [anon_sym_DASH] = ACTIONS(2105),
    [anon_sym_STAR] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2105),
    [anon_sym_PERCENT] = ACTIONS(2105),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_GT] = ACTIONS(2105),
    [anon_sym_EQ_EQ] = ACTIONS(2105),
    [anon_sym_BANG_EQ] = ACTIONS(2105),
    [anon_sym_LT_EQ] = ACTIONS(2105),
    [anon_sym_GT_EQ] = ACTIONS(2105),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_struct] = ACTIONS(2105),
    [anon_sym_mut] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_QMARK] = ACTIONS(2105),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_go] = ACTIONS(2105),
    [anon_sym_spawn] = ACTIONS(2105),
    [anon_sym_json_DOTdecode] = ACTIONS(2105),
    [anon_sym_PIPE] = ACTIONS(2105),
    [anon_sym_LBRACK2] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_LT_DASH] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(2105),
    [anon_sym_GT_GT] = ACTIONS(2105),
    [anon_sym_GT_GT_GT] = ACTIONS(2105),
    [anon_sym_AMP_CARET] = ACTIONS(2105),
    [anon_sym_AMP_AMP] = ACTIONS(2105),
    [anon_sym_PIPE_PIPE] = ACTIONS(2105),
    [anon_sym_or] = ACTIONS(2105),
    [sym_none] = ACTIONS(2105),
    [sym_true] = ACTIONS(2105),
    [sym_false] = ACTIONS(2105),
    [sym_nil] = ACTIONS(2105),
    [anon_sym_QMARK_DOT] = ACTIONS(2105),
    [anon_sym_POUND_LBRACK] = ACTIONS(2105),
    [anon_sym_if] = ACTIONS(2105),
    [anon_sym_DOLLARif] = ACTIONS(2105),
    [anon_sym_DOLLARelse] = ACTIONS(4062),
    [anon_sym_is] = ACTIONS(2105),
    [anon_sym_BANGis] = ACTIONS(2105),
    [anon_sym_in] = ACTIONS(2105),
    [anon_sym_BANGin] = ACTIONS(2105),
    [anon_sym_match] = ACTIONS(2105),
    [anon_sym_select] = ACTIONS(2105),
    [anon_sym_lock] = ACTIONS(2105),
    [anon_sym_rlock] = ACTIONS(2105),
    [anon_sym_unsafe] = ACTIONS(2105),
    [anon_sym_sql] = ACTIONS(2105),
    [sym_int_literal] = ACTIONS(2105),
    [sym_float_literal] = ACTIONS(2105),
    [sym_rune_literal] = ACTIONS(2105),
    [anon_sym_SQUOTE] = ACTIONS(2105),
    [anon_sym_DQUOTE] = ACTIONS(2105),
    [anon_sym_c_SQUOTE] = ACTIONS(2105),
    [anon_sym_c_DQUOTE] = ACTIONS(2105),
    [anon_sym_r_SQUOTE] = ACTIONS(2105),
    [anon_sym_r_DQUOTE] = ACTIONS(2105),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2105),
    [anon_sym_shared] = ACTIONS(2105),
    [anon_sym_map_LBRACK] = ACTIONS(2105),
    [anon_sym_chan] = ACTIONS(2105),
    [anon_sym_thread] = ACTIONS(2105),
    [anon_sym_atomic] = ACTIONS(2105),
    [anon_sym_assert] = ACTIONS(2105),
    [anon_sym_defer] = ACTIONS(2105),
    [anon_sym_goto] = ACTIONS(2105),
    [anon_sym_break] = ACTIONS(2105),
    [anon_sym_continue] = ACTIONS(2105),
    [anon_sym_return] = ACTIONS(2105),
    [anon_sym_DOLLARfor] = ACTIONS(2105),
    [anon_sym_for] = ACTIONS(2105),
    [anon_sym_POUND] = ACTIONS(2105),
    [anon_sym_asm] = ACTIONS(2105),
  },
  [1295] = {
    [sym_line_comment] = STATE(1295),
    [sym_block_comment] = STATE(1295),
    [sym_identifier] = ACTIONS(2093),
    [anon_sym_LF] = ACTIONS(2093),
    [anon_sym_CR] = ACTIONS(2093),
    [anon_sym_CR_LF] = ACTIONS(2093),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2093),
    [anon_sym_DOT] = ACTIONS(2093),
    [anon_sym_as] = ACTIONS(2093),
    [anon_sym_LBRACE] = ACTIONS(2093),
    [anon_sym_COMMA] = ACTIONS(2093),
    [anon_sym_RBRACE] = ACTIONS(2093),
    [anon_sym_LPAREN] = ACTIONS(2093),
    [anon_sym_fn] = ACTIONS(2093),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(2093),
    [anon_sym_SLASH] = ACTIONS(2093),
    [anon_sym_PERCENT] = ACTIONS(2093),
    [anon_sym_LT] = ACTIONS(2093),
    [anon_sym_GT] = ACTIONS(2093),
    [anon_sym_EQ_EQ] = ACTIONS(2093),
    [anon_sym_BANG_EQ] = ACTIONS(2093),
    [anon_sym_LT_EQ] = ACTIONS(2093),
    [anon_sym_GT_EQ] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2091),
    [anon_sym_struct] = ACTIONS(2093),
    [anon_sym_mut] = ACTIONS(2093),
    [anon_sym_PLUS_PLUS] = ACTIONS(2093),
    [anon_sym_DASH_DASH] = ACTIONS(2093),
    [anon_sym_QMARK] = ACTIONS(2093),
    [anon_sym_BANG] = ACTIONS(2093),
    [anon_sym_go] = ACTIONS(2093),
    [anon_sym_spawn] = ACTIONS(2093),
    [anon_sym_json_DOTdecode] = ACTIONS(2093),
    [anon_sym_PIPE] = ACTIONS(2093),
    [anon_sym_LBRACK2] = ACTIONS(2093),
    [anon_sym_TILDE] = ACTIONS(2093),
    [anon_sym_CARET] = ACTIONS(2093),
    [anon_sym_AMP] = ACTIONS(2093),
    [anon_sym_LT_DASH] = ACTIONS(2093),
    [anon_sym_LT_LT] = ACTIONS(2093),
    [anon_sym_GT_GT] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2093),
    [anon_sym_AMP_CARET] = ACTIONS(2093),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_PIPE_PIPE] = ACTIONS(2093),
    [anon_sym_or] = ACTIONS(2093),
    [sym_none] = ACTIONS(2093),
    [sym_true] = ACTIONS(2093),
    [sym_false] = ACTIONS(2093),
    [sym_nil] = ACTIONS(2093),
    [anon_sym_QMARK_DOT] = ACTIONS(2093),
    [anon_sym_POUND_LBRACK] = ACTIONS(2093),
    [anon_sym_if] = ACTIONS(2093),
    [anon_sym_DOLLARif] = ACTIONS(2093),
    [anon_sym_DOLLARelse] = ACTIONS(4064),
    [anon_sym_is] = ACTIONS(2093),
    [anon_sym_BANGis] = ACTIONS(2093),
    [anon_sym_in] = ACTIONS(2093),
    [anon_sym_BANGin] = ACTIONS(2093),
    [anon_sym_match] = ACTIONS(2093),
    [anon_sym_select] = ACTIONS(2093),
    [anon_sym_lock] = ACTIONS(2093),
    [anon_sym_rlock] = ACTIONS(2093),
    [anon_sym_unsafe] = ACTIONS(2093),
    [anon_sym_sql] = ACTIONS(2093),
    [sym_int_literal] = ACTIONS(2093),
    [sym_float_literal] = ACTIONS(2093),
    [sym_rune_literal] = ACTIONS(2093),
    [anon_sym_SQUOTE] = ACTIONS(2093),
    [anon_sym_DQUOTE] = ACTIONS(2093),
    [anon_sym_c_SQUOTE] = ACTIONS(2093),
    [anon_sym_c_DQUOTE] = ACTIONS(2093),
    [anon_sym_r_SQUOTE] = ACTIONS(2093),
    [anon_sym_r_DQUOTE] = ACTIONS(2093),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2093),
    [anon_sym_shared] = ACTIONS(2093),
    [anon_sym_map_LBRACK] = ACTIONS(2093),
    [anon_sym_chan] = ACTIONS(2093),
    [anon_sym_thread] = ACTIONS(2093),
    [anon_sym_atomic] = ACTIONS(2093),
    [anon_sym_assert] = ACTIONS(2093),
    [anon_sym_defer] = ACTIONS(2093),
    [anon_sym_goto] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2093),
    [anon_sym_continue] = ACTIONS(2093),
    [anon_sym_return] = ACTIONS(2093),
    [anon_sym_DOLLARfor] = ACTIONS(2093),
    [anon_sym_for] = ACTIONS(2093),
    [anon_sym_POUND] = ACTIONS(2093),
    [anon_sym_asm] = ACTIONS(2093),
  },
  [1296] = {
    [sym_line_comment] = STATE(1296),
    [sym_block_comment] = STATE(1296),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_CR] = ACTIONS(2147),
    [anon_sym_CR_LF] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_COMMA] = ACTIONS(2147),
    [anon_sym_RBRACE] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2147),
    [anon_sym_BANG_EQ] = ACTIONS(2147),
    [anon_sym_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2147),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2147),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2147),
    [anon_sym_AMP_CARET] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [anon_sym_or] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2147),
    [anon_sym_POUND_LBRACK] = ACTIONS(2147),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_DOLLARelse] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2147),
    [anon_sym_BANGis] = ACTIONS(2147),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANGin] = ACTIONS(2147),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2147),
    [sym_rune_literal] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_c_SQUOTE] = ACTIONS(2147),
    [anon_sym_c_DQUOTE] = ACTIONS(2147),
    [anon_sym_r_SQUOTE] = ACTIONS(2147),
    [anon_sym_r_DQUOTE] = ACTIONS(2147),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2147),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
    [anon_sym_assert] = ACTIONS(2147),
    [anon_sym_defer] = ACTIONS(2147),
    [anon_sym_goto] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_continue] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2147),
    [anon_sym_DOLLARfor] = ACTIONS(2147),
    [anon_sym_for] = ACTIONS(2147),
    [anon_sym_POUND] = ACTIONS(2147),
    [anon_sym_asm] = ACTIONS(2147),
  },
  [1297] = {
    [sym_line_comment] = STATE(1297),
    [sym_block_comment] = STATE(1297),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_CR] = ACTIONS(2147),
    [anon_sym_CR_LF] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_COMMA] = ACTIONS(2147),
    [anon_sym_RBRACE] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2147),
    [anon_sym_BANG_EQ] = ACTIONS(2147),
    [anon_sym_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2147),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2147),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2147),
    [anon_sym_AMP_CARET] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [anon_sym_or] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2147),
    [anon_sym_POUND_LBRACK] = ACTIONS(2147),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_else] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2147),
    [anon_sym_BANGis] = ACTIONS(2147),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANGin] = ACTIONS(2147),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2147),
    [sym_rune_literal] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_c_SQUOTE] = ACTIONS(2147),
    [anon_sym_c_DQUOTE] = ACTIONS(2147),
    [anon_sym_r_SQUOTE] = ACTIONS(2147),
    [anon_sym_r_DQUOTE] = ACTIONS(2147),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2147),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
    [anon_sym_assert] = ACTIONS(2147),
    [anon_sym_defer] = ACTIONS(2147),
    [anon_sym_goto] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_continue] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2147),
    [anon_sym_DOLLARfor] = ACTIONS(2147),
    [anon_sym_for] = ACTIONS(2147),
    [anon_sym_POUND] = ACTIONS(2147),
    [anon_sym_asm] = ACTIONS(2147),
  },
  [1298] = {
    [sym_line_comment] = STATE(1298),
    [sym_block_comment] = STATE(1298),
    [sym_type_parameters] = STATE(1347),
    [sym_identifier] = ACTIONS(2187),
    [anon_sym_LF] = ACTIONS(2187),
    [anon_sym_CR] = ACTIONS(2187),
    [anon_sym_CR_LF] = ACTIONS(2187),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2187),
    [anon_sym_DOT] = ACTIONS(2187),
    [anon_sym_as] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_RBRACE] = ACTIONS(2187),
    [anon_sym_LPAREN] = ACTIONS(2187),
    [anon_sym_fn] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [anon_sym_LT] = ACTIONS(2187),
    [anon_sym_GT] = ACTIONS(2187),
    [anon_sym_EQ_EQ] = ACTIONS(2187),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2187),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2185),
    [anon_sym_struct] = ACTIONS(2187),
    [anon_sym_mut] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_go] = ACTIONS(2187),
    [anon_sym_spawn] = ACTIONS(2187),
    [anon_sym_json_DOTdecode] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2187),
    [anon_sym_LBRACK2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_LT_DASH] = ACTIONS(2187),
    [anon_sym_LT_LT] = ACTIONS(2187),
    [anon_sym_GT_GT] = ACTIONS(2187),
    [anon_sym_GT_GT_GT] = ACTIONS(2187),
    [anon_sym_AMP_CARET] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2187),
    [sym_none] = ACTIONS(2187),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [sym_nil] = ACTIONS(2187),
    [anon_sym_QMARK_DOT] = ACTIONS(2187),
    [anon_sym_POUND_LBRACK] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_DOLLARif] = ACTIONS(2187),
    [anon_sym_is] = ACTIONS(2187),
    [anon_sym_BANGis] = ACTIONS(2187),
    [anon_sym_in] = ACTIONS(2187),
    [anon_sym_BANGin] = ACTIONS(2187),
    [anon_sym_match] = ACTIONS(2187),
    [anon_sym_select] = ACTIONS(2187),
    [anon_sym_lock] = ACTIONS(2187),
    [anon_sym_rlock] = ACTIONS(2187),
    [anon_sym_unsafe] = ACTIONS(2187),
    [anon_sym_sql] = ACTIONS(2187),
    [sym_int_literal] = ACTIONS(2187),
    [sym_float_literal] = ACTIONS(2187),
    [sym_rune_literal] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(2187),
    [anon_sym_DQUOTE] = ACTIONS(2187),
    [anon_sym_c_SQUOTE] = ACTIONS(2187),
    [anon_sym_c_DQUOTE] = ACTIONS(2187),
    [anon_sym_r_SQUOTE] = ACTIONS(2187),
    [anon_sym_r_DQUOTE] = ACTIONS(2187),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2187),
    [anon_sym_shared] = ACTIONS(2187),
    [anon_sym_map_LBRACK] = ACTIONS(2187),
    [anon_sym_chan] = ACTIONS(2187),
    [anon_sym_thread] = ACTIONS(2187),
    [anon_sym_atomic] = ACTIONS(2187),
    [anon_sym_assert] = ACTIONS(2187),
    [anon_sym_defer] = ACTIONS(2187),
    [anon_sym_goto] = ACTIONS(2187),
    [anon_sym_break] = ACTIONS(2187),
    [anon_sym_continue] = ACTIONS(2187),
    [anon_sym_return] = ACTIONS(2187),
    [anon_sym_DOLLARfor] = ACTIONS(2187),
    [anon_sym_for] = ACTIONS(2187),
    [anon_sym_POUND] = ACTIONS(2187),
    [anon_sym_asm] = ACTIONS(2187),
  },
  [1299] = {
    [sym_line_comment] = STATE(1299),
    [sym_block_comment] = STATE(1299),
    [sym_identifier] = ACTIONS(2651),
    [anon_sym_LF] = ACTIONS(2651),
    [anon_sym_CR] = ACTIONS(2651),
    [anon_sym_CR_LF] = ACTIONS(2651),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2651),
    [anon_sym_DOT] = ACTIONS(2651),
    [anon_sym_as] = ACTIONS(2651),
    [anon_sym_LBRACE] = ACTIONS(2651),
    [anon_sym_COMMA] = ACTIONS(2651),
    [anon_sym_RBRACE] = ACTIONS(2651),
    [anon_sym_LPAREN] = ACTIONS(2651),
    [anon_sym_fn] = ACTIONS(2651),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_STAR] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2651),
    [anon_sym_PERCENT] = ACTIONS(2651),
    [anon_sym_LT] = ACTIONS(2651),
    [anon_sym_GT] = ACTIONS(2651),
    [anon_sym_EQ_EQ] = ACTIONS(2651),
    [anon_sym_BANG_EQ] = ACTIONS(2651),
    [anon_sym_LT_EQ] = ACTIONS(2651),
    [anon_sym_GT_EQ] = ACTIONS(2651),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_struct] = ACTIONS(2651),
    [anon_sym_mut] = ACTIONS(2651),
    [anon_sym_PLUS_PLUS] = ACTIONS(2651),
    [anon_sym_DASH_DASH] = ACTIONS(2651),
    [anon_sym_QMARK] = ACTIONS(2651),
    [anon_sym_BANG] = ACTIONS(2651),
    [anon_sym_go] = ACTIONS(2651),
    [anon_sym_spawn] = ACTIONS(2651),
    [anon_sym_json_DOTdecode] = ACTIONS(2651),
    [anon_sym_PIPE] = ACTIONS(2651),
    [anon_sym_LBRACK2] = ACTIONS(2651),
    [anon_sym_TILDE] = ACTIONS(2651),
    [anon_sym_CARET] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2651),
    [anon_sym_LT_DASH] = ACTIONS(2651),
    [anon_sym_LT_LT] = ACTIONS(2651),
    [anon_sym_GT_GT] = ACTIONS(2651),
    [anon_sym_GT_GT_GT] = ACTIONS(2651),
    [anon_sym_AMP_CARET] = ACTIONS(2651),
    [anon_sym_AMP_AMP] = ACTIONS(2651),
    [anon_sym_PIPE_PIPE] = ACTIONS(2651),
    [anon_sym_or] = ACTIONS(2651),
    [sym_none] = ACTIONS(2651),
    [sym_true] = ACTIONS(2651),
    [sym_false] = ACTIONS(2651),
    [sym_nil] = ACTIONS(2651),
    [anon_sym_QMARK_DOT] = ACTIONS(2651),
    [anon_sym_POUND_LBRACK] = ACTIONS(2651),
    [anon_sym_if] = ACTIONS(2651),
    [anon_sym_DOLLARif] = ACTIONS(2651),
    [anon_sym_is] = ACTIONS(2651),
    [anon_sym_BANGis] = ACTIONS(2651),
    [anon_sym_in] = ACTIONS(2651),
    [anon_sym_BANGin] = ACTIONS(2651),
    [anon_sym_match] = ACTIONS(2651),
    [anon_sym_select] = ACTIONS(2651),
    [anon_sym_lock] = ACTIONS(2651),
    [anon_sym_rlock] = ACTIONS(2651),
    [anon_sym_unsafe] = ACTIONS(2651),
    [anon_sym_sql] = ACTIONS(2651),
    [sym_int_literal] = ACTIONS(2651),
    [sym_float_literal] = ACTIONS(2651),
    [sym_rune_literal] = ACTIONS(2651),
    [anon_sym_SQUOTE] = ACTIONS(2651),
    [anon_sym_DQUOTE] = ACTIONS(2651),
    [anon_sym_c_SQUOTE] = ACTIONS(2651),
    [anon_sym_c_DQUOTE] = ACTIONS(2651),
    [anon_sym_r_SQUOTE] = ACTIONS(2651),
    [anon_sym_r_DQUOTE] = ACTIONS(2651),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2651),
    [anon_sym_shared] = ACTIONS(2651),
    [anon_sym_map_LBRACK] = ACTIONS(2651),
    [anon_sym_chan] = ACTIONS(2651),
    [anon_sym_thread] = ACTIONS(2651),
    [anon_sym_atomic] = ACTIONS(2651),
    [anon_sym_assert] = ACTIONS(2651),
    [anon_sym_defer] = ACTIONS(2651),
    [anon_sym_goto] = ACTIONS(2651),
    [anon_sym_break] = ACTIONS(2651),
    [anon_sym_continue] = ACTIONS(2651),
    [anon_sym_return] = ACTIONS(2651),
    [anon_sym_DOLLARfor] = ACTIONS(2651),
    [anon_sym_for] = ACTIONS(2651),
    [anon_sym_POUND] = ACTIONS(2651),
    [anon_sym_asm] = ACTIONS(2651),
  },
  [1300] = {
    [sym_line_comment] = STATE(1300),
    [sym_block_comment] = STATE(1300),
    [sym_identifier] = ACTIONS(2631),
    [anon_sym_LF] = ACTIONS(2631),
    [anon_sym_CR] = ACTIONS(2631),
    [anon_sym_CR_LF] = ACTIONS(2631),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2631),
    [anon_sym_DOT] = ACTIONS(2631),
    [anon_sym_as] = ACTIONS(2631),
    [anon_sym_LBRACE] = ACTIONS(2631),
    [anon_sym_COMMA] = ACTIONS(2631),
    [anon_sym_RBRACE] = ACTIONS(2631),
    [anon_sym_LPAREN] = ACTIONS(2631),
    [anon_sym_fn] = ACTIONS(2631),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_DASH] = ACTIONS(2631),
    [anon_sym_STAR] = ACTIONS(2631),
    [anon_sym_SLASH] = ACTIONS(2631),
    [anon_sym_PERCENT] = ACTIONS(2631),
    [anon_sym_LT] = ACTIONS(2631),
    [anon_sym_GT] = ACTIONS(2631),
    [anon_sym_EQ_EQ] = ACTIONS(2631),
    [anon_sym_BANG_EQ] = ACTIONS(2631),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LBRACK] = ACTIONS(2629),
    [anon_sym_struct] = ACTIONS(2631),
    [anon_sym_mut] = ACTIONS(2631),
    [anon_sym_PLUS_PLUS] = ACTIONS(2631),
    [anon_sym_DASH_DASH] = ACTIONS(2631),
    [anon_sym_QMARK] = ACTIONS(2631),
    [anon_sym_BANG] = ACTIONS(2631),
    [anon_sym_go] = ACTIONS(2631),
    [anon_sym_spawn] = ACTIONS(2631),
    [anon_sym_json_DOTdecode] = ACTIONS(2631),
    [anon_sym_PIPE] = ACTIONS(2631),
    [anon_sym_LBRACK2] = ACTIONS(2631),
    [anon_sym_TILDE] = ACTIONS(2631),
    [anon_sym_CARET] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2631),
    [anon_sym_LT_DASH] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2631),
    [anon_sym_GT_GT] = ACTIONS(2631),
    [anon_sym_GT_GT_GT] = ACTIONS(2631),
    [anon_sym_AMP_CARET] = ACTIONS(2631),
    [anon_sym_AMP_AMP] = ACTIONS(2631),
    [anon_sym_PIPE_PIPE] = ACTIONS(2631),
    [anon_sym_or] = ACTIONS(2631),
    [sym_none] = ACTIONS(2631),
    [sym_true] = ACTIONS(2631),
    [sym_false] = ACTIONS(2631),
    [sym_nil] = ACTIONS(2631),
    [anon_sym_QMARK_DOT] = ACTIONS(2631),
    [anon_sym_POUND_LBRACK] = ACTIONS(2631),
    [anon_sym_if] = ACTIONS(2631),
    [anon_sym_DOLLARif] = ACTIONS(2631),
    [anon_sym_is] = ACTIONS(2631),
    [anon_sym_BANGis] = ACTIONS(2631),
    [anon_sym_in] = ACTIONS(2631),
    [anon_sym_BANGin] = ACTIONS(2631),
    [anon_sym_match] = ACTIONS(2631),
    [anon_sym_select] = ACTIONS(2631),
    [anon_sym_lock] = ACTIONS(2631),
    [anon_sym_rlock] = ACTIONS(2631),
    [anon_sym_unsafe] = ACTIONS(2631),
    [anon_sym_sql] = ACTIONS(2631),
    [sym_int_literal] = ACTIONS(2631),
    [sym_float_literal] = ACTIONS(2631),
    [sym_rune_literal] = ACTIONS(2631),
    [anon_sym_SQUOTE] = ACTIONS(2631),
    [anon_sym_DQUOTE] = ACTIONS(2631),
    [anon_sym_c_SQUOTE] = ACTIONS(2631),
    [anon_sym_c_DQUOTE] = ACTIONS(2631),
    [anon_sym_r_SQUOTE] = ACTIONS(2631),
    [anon_sym_r_DQUOTE] = ACTIONS(2631),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2631),
    [anon_sym_shared] = ACTIONS(2631),
    [anon_sym_map_LBRACK] = ACTIONS(2631),
    [anon_sym_chan] = ACTIONS(2631),
    [anon_sym_thread] = ACTIONS(2631),
    [anon_sym_atomic] = ACTIONS(2631),
    [anon_sym_assert] = ACTIONS(2631),
    [anon_sym_defer] = ACTIONS(2631),
    [anon_sym_goto] = ACTIONS(2631),
    [anon_sym_break] = ACTIONS(2631),
    [anon_sym_continue] = ACTIONS(2631),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_DOLLARfor] = ACTIONS(2631),
    [anon_sym_for] = ACTIONS(2631),
    [anon_sym_POUND] = ACTIONS(2631),
    [anon_sym_asm] = ACTIONS(2631),
  },
  [1301] = {
    [sym_line_comment] = STATE(1301),
    [sym_block_comment] = STATE(1301),
    [sym_identifier] = ACTIONS(2997),
    [anon_sym_LF] = ACTIONS(2997),
    [anon_sym_CR] = ACTIONS(2997),
    [anon_sym_CR_LF] = ACTIONS(2997),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2997),
    [anon_sym_DOT] = ACTIONS(2997),
    [anon_sym_as] = ACTIONS(2997),
    [anon_sym_LBRACE] = ACTIONS(2997),
    [anon_sym_COMMA] = ACTIONS(2997),
    [anon_sym_RBRACE] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(2997),
    [anon_sym_fn] = ACTIONS(2997),
    [anon_sym_PLUS] = ACTIONS(2997),
    [anon_sym_DASH] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(2997),
    [anon_sym_SLASH] = ACTIONS(2997),
    [anon_sym_PERCENT] = ACTIONS(2997),
    [anon_sym_LT] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(2997),
    [anon_sym_EQ_EQ] = ACTIONS(2997),
    [anon_sym_BANG_EQ] = ACTIONS(2997),
    [anon_sym_LT_EQ] = ACTIONS(2997),
    [anon_sym_GT_EQ] = ACTIONS(2997),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_struct] = ACTIONS(2997),
    [anon_sym_mut] = ACTIONS(2997),
    [anon_sym_PLUS_PLUS] = ACTIONS(2997),
    [anon_sym_DASH_DASH] = ACTIONS(2997),
    [anon_sym_QMARK] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2997),
    [anon_sym_go] = ACTIONS(2997),
    [anon_sym_spawn] = ACTIONS(2997),
    [anon_sym_json_DOTdecode] = ACTIONS(2997),
    [anon_sym_PIPE] = ACTIONS(2997),
    [anon_sym_LBRACK2] = ACTIONS(2997),
    [anon_sym_TILDE] = ACTIONS(2997),
    [anon_sym_CARET] = ACTIONS(2997),
    [anon_sym_AMP] = ACTIONS(2997),
    [anon_sym_LT_DASH] = ACTIONS(2997),
    [anon_sym_LT_LT] = ACTIONS(2997),
    [anon_sym_GT_GT] = ACTIONS(2997),
    [anon_sym_GT_GT_GT] = ACTIONS(2997),
    [anon_sym_AMP_CARET] = ACTIONS(2997),
    [anon_sym_AMP_AMP] = ACTIONS(2997),
    [anon_sym_PIPE_PIPE] = ACTIONS(2997),
    [anon_sym_or] = ACTIONS(2997),
    [sym_none] = ACTIONS(2997),
    [sym_true] = ACTIONS(2997),
    [sym_false] = ACTIONS(2997),
    [sym_nil] = ACTIONS(2997),
    [anon_sym_QMARK_DOT] = ACTIONS(2997),
    [anon_sym_POUND_LBRACK] = ACTIONS(2997),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_DOLLARif] = ACTIONS(2997),
    [anon_sym_is] = ACTIONS(2997),
    [anon_sym_BANGis] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(2997),
    [anon_sym_BANGin] = ACTIONS(2997),
    [anon_sym_match] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [anon_sym_lock] = ACTIONS(2997),
    [anon_sym_rlock] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(2997),
    [anon_sym_sql] = ACTIONS(2997),
    [sym_int_literal] = ACTIONS(2997),
    [sym_float_literal] = ACTIONS(2997),
    [sym_rune_literal] = ACTIONS(2997),
    [anon_sym_SQUOTE] = ACTIONS(2997),
    [anon_sym_DQUOTE] = ACTIONS(2997),
    [anon_sym_c_SQUOTE] = ACTIONS(2997),
    [anon_sym_c_DQUOTE] = ACTIONS(2997),
    [anon_sym_r_SQUOTE] = ACTIONS(2997),
    [anon_sym_r_DQUOTE] = ACTIONS(2997),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2997),
    [anon_sym_shared] = ACTIONS(2997),
    [anon_sym_map_LBRACK] = ACTIONS(2997),
    [anon_sym_chan] = ACTIONS(2997),
    [anon_sym_thread] = ACTIONS(2997),
    [anon_sym_atomic] = ACTIONS(2997),
    [anon_sym_assert] = ACTIONS(2997),
    [anon_sym_defer] = ACTIONS(2997),
    [anon_sym_goto] = ACTIONS(2997),
    [anon_sym_break] = ACTIONS(2997),
    [anon_sym_continue] = ACTIONS(2997),
    [anon_sym_return] = ACTIONS(2997),
    [anon_sym_DOLLARfor] = ACTIONS(2997),
    [anon_sym_for] = ACTIONS(2997),
    [anon_sym_POUND] = ACTIONS(2997),
    [anon_sym_asm] = ACTIONS(2997),
  },
  [1302] = {
    [sym_line_comment] = STATE(1302),
    [sym_block_comment] = STATE(1302),
    [sym_identifier] = ACTIONS(2989),
    [anon_sym_LF] = ACTIONS(2989),
    [anon_sym_CR] = ACTIONS(2989),
    [anon_sym_CR_LF] = ACTIONS(2989),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2989),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_as] = ACTIONS(2989),
    [anon_sym_LBRACE] = ACTIONS(2989),
    [anon_sym_COMMA] = ACTIONS(2989),
    [anon_sym_RBRACE] = ACTIONS(2989),
    [anon_sym_LPAREN] = ACTIONS(2989),
    [anon_sym_fn] = ACTIONS(2989),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2989),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2989),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_EQ_EQ] = ACTIONS(2989),
    [anon_sym_BANG_EQ] = ACTIONS(2989),
    [anon_sym_LT_EQ] = ACTIONS(2989),
    [anon_sym_GT_EQ] = ACTIONS(2989),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_struct] = ACTIONS(2989),
    [anon_sym_mut] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2989),
    [anon_sym_DASH_DASH] = ACTIONS(2989),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_go] = ACTIONS(2989),
    [anon_sym_spawn] = ACTIONS(2989),
    [anon_sym_json_DOTdecode] = ACTIONS(2989),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_LBRACK2] = ACTIONS(2989),
    [anon_sym_TILDE] = ACTIONS(2989),
    [anon_sym_CARET] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_LT_DASH] = ACTIONS(2989),
    [anon_sym_LT_LT] = ACTIONS(2989),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2989),
    [anon_sym_AMP_CARET] = ACTIONS(2989),
    [anon_sym_AMP_AMP] = ACTIONS(2989),
    [anon_sym_PIPE_PIPE] = ACTIONS(2989),
    [anon_sym_or] = ACTIONS(2989),
    [sym_none] = ACTIONS(2989),
    [sym_true] = ACTIONS(2989),
    [sym_false] = ACTIONS(2989),
    [sym_nil] = ACTIONS(2989),
    [anon_sym_QMARK_DOT] = ACTIONS(2989),
    [anon_sym_POUND_LBRACK] = ACTIONS(2989),
    [anon_sym_if] = ACTIONS(2989),
    [anon_sym_DOLLARif] = ACTIONS(2989),
    [anon_sym_is] = ACTIONS(2989),
    [anon_sym_BANGis] = ACTIONS(2989),
    [anon_sym_in] = ACTIONS(2989),
    [anon_sym_BANGin] = ACTIONS(2989),
    [anon_sym_match] = ACTIONS(2989),
    [anon_sym_select] = ACTIONS(2989),
    [anon_sym_lock] = ACTIONS(2989),
    [anon_sym_rlock] = ACTIONS(2989),
    [anon_sym_unsafe] = ACTIONS(2989),
    [anon_sym_sql] = ACTIONS(2989),
    [sym_int_literal] = ACTIONS(2989),
    [sym_float_literal] = ACTIONS(2989),
    [sym_rune_literal] = ACTIONS(2989),
    [anon_sym_SQUOTE] = ACTIONS(2989),
    [anon_sym_DQUOTE] = ACTIONS(2989),
    [anon_sym_c_SQUOTE] = ACTIONS(2989),
    [anon_sym_c_DQUOTE] = ACTIONS(2989),
    [anon_sym_r_SQUOTE] = ACTIONS(2989),
    [anon_sym_r_DQUOTE] = ACTIONS(2989),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2989),
    [anon_sym_shared] = ACTIONS(2989),
    [anon_sym_map_LBRACK] = ACTIONS(2989),
    [anon_sym_chan] = ACTIONS(2989),
    [anon_sym_thread] = ACTIONS(2989),
    [anon_sym_atomic] = ACTIONS(2989),
    [anon_sym_assert] = ACTIONS(2989),
    [anon_sym_defer] = ACTIONS(2989),
    [anon_sym_goto] = ACTIONS(2989),
    [anon_sym_break] = ACTIONS(2989),
    [anon_sym_continue] = ACTIONS(2989),
    [anon_sym_return] = ACTIONS(2989),
    [anon_sym_DOLLARfor] = ACTIONS(2989),
    [anon_sym_for] = ACTIONS(2989),
    [anon_sym_POUND] = ACTIONS(2989),
    [anon_sym_asm] = ACTIONS(2989),
  },
  [1303] = {
    [sym_line_comment] = STATE(1303),
    [sym_block_comment] = STATE(1303),
    [sym_identifier] = ACTIONS(3084),
    [anon_sym_LF] = ACTIONS(3084),
    [anon_sym_CR] = ACTIONS(3084),
    [anon_sym_CR_LF] = ACTIONS(3084),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym_DOT] = ACTIONS(3084),
    [anon_sym_as] = ACTIONS(3084),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_COMMA] = ACTIONS(3084),
    [anon_sym_RBRACE] = ACTIONS(3084),
    [anon_sym_LPAREN] = ACTIONS(3084),
    [anon_sym_fn] = ACTIONS(3084),
    [anon_sym_PLUS] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_SLASH] = ACTIONS(3084),
    [anon_sym_PERCENT] = ACTIONS(3084),
    [anon_sym_LT] = ACTIONS(3084),
    [anon_sym_GT] = ACTIONS(3084),
    [anon_sym_EQ_EQ] = ACTIONS(3084),
    [anon_sym_BANG_EQ] = ACTIONS(3084),
    [anon_sym_LT_EQ] = ACTIONS(3084),
    [anon_sym_GT_EQ] = ACTIONS(3084),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3084),
    [anon_sym_mut] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_QMARK] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_go] = ACTIONS(3084),
    [anon_sym_spawn] = ACTIONS(3084),
    [anon_sym_json_DOTdecode] = ACTIONS(3084),
    [anon_sym_PIPE] = ACTIONS(3084),
    [anon_sym_LBRACK2] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_CARET] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3084),
    [anon_sym_LT_DASH] = ACTIONS(3084),
    [anon_sym_LT_LT] = ACTIONS(3084),
    [anon_sym_GT_GT] = ACTIONS(3084),
    [anon_sym_GT_GT_GT] = ACTIONS(3084),
    [anon_sym_AMP_CARET] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_PIPE_PIPE] = ACTIONS(3084),
    [anon_sym_or] = ACTIONS(3084),
    [sym_none] = ACTIONS(3084),
    [sym_true] = ACTIONS(3084),
    [sym_false] = ACTIONS(3084),
    [sym_nil] = ACTIONS(3084),
    [anon_sym_QMARK_DOT] = ACTIONS(3084),
    [anon_sym_POUND_LBRACK] = ACTIONS(3084),
    [anon_sym_if] = ACTIONS(3084),
    [anon_sym_DOLLARif] = ACTIONS(3084),
    [anon_sym_is] = ACTIONS(3084),
    [anon_sym_BANGis] = ACTIONS(3084),
    [anon_sym_in] = ACTIONS(3084),
    [anon_sym_BANGin] = ACTIONS(3084),
    [anon_sym_match] = ACTIONS(3084),
    [anon_sym_select] = ACTIONS(3084),
    [anon_sym_lock] = ACTIONS(3084),
    [anon_sym_rlock] = ACTIONS(3084),
    [anon_sym_unsafe] = ACTIONS(3084),
    [anon_sym_sql] = ACTIONS(3084),
    [sym_int_literal] = ACTIONS(3084),
    [sym_float_literal] = ACTIONS(3084),
    [sym_rune_literal] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [anon_sym_c_SQUOTE] = ACTIONS(3084),
    [anon_sym_c_DQUOTE] = ACTIONS(3084),
    [anon_sym_r_SQUOTE] = ACTIONS(3084),
    [anon_sym_r_DQUOTE] = ACTIONS(3084),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3084),
    [anon_sym_shared] = ACTIONS(3084),
    [anon_sym_map_LBRACK] = ACTIONS(3084),
    [anon_sym_chan] = ACTIONS(3084),
    [anon_sym_thread] = ACTIONS(3084),
    [anon_sym_atomic] = ACTIONS(3084),
    [anon_sym_assert] = ACTIONS(3084),
    [anon_sym_defer] = ACTIONS(3084),
    [anon_sym_goto] = ACTIONS(3084),
    [anon_sym_break] = ACTIONS(3084),
    [anon_sym_continue] = ACTIONS(3084),
    [anon_sym_return] = ACTIONS(3084),
    [anon_sym_DOLLARfor] = ACTIONS(3084),
    [anon_sym_for] = ACTIONS(3084),
    [anon_sym_POUND] = ACTIONS(3084),
    [anon_sym_asm] = ACTIONS(3084),
  },
  [1304] = {
    [sym_line_comment] = STATE(1304),
    [sym_block_comment] = STATE(1304),
    [sym_identifier] = ACTIONS(2925),
    [anon_sym_LF] = ACTIONS(2925),
    [anon_sym_CR] = ACTIONS(2925),
    [anon_sym_CR_LF] = ACTIONS(2925),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2925),
    [anon_sym_DOT] = ACTIONS(2925),
    [anon_sym_as] = ACTIONS(2925),
    [anon_sym_LBRACE] = ACTIONS(2925),
    [anon_sym_COMMA] = ACTIONS(2925),
    [anon_sym_RBRACE] = ACTIONS(2925),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_fn] = ACTIONS(2925),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_STAR] = ACTIONS(2925),
    [anon_sym_SLASH] = ACTIONS(2925),
    [anon_sym_PERCENT] = ACTIONS(2925),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_GT] = ACTIONS(2925),
    [anon_sym_EQ_EQ] = ACTIONS(2925),
    [anon_sym_BANG_EQ] = ACTIONS(2925),
    [anon_sym_LT_EQ] = ACTIONS(2925),
    [anon_sym_GT_EQ] = ACTIONS(2925),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_struct] = ACTIONS(2925),
    [anon_sym_mut] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2925),
    [anon_sym_DASH_DASH] = ACTIONS(2925),
    [anon_sym_QMARK] = ACTIONS(2925),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_go] = ACTIONS(2925),
    [anon_sym_spawn] = ACTIONS(2925),
    [anon_sym_json_DOTdecode] = ACTIONS(2925),
    [anon_sym_PIPE] = ACTIONS(2925),
    [anon_sym_LBRACK2] = ACTIONS(2925),
    [anon_sym_TILDE] = ACTIONS(2925),
    [anon_sym_CARET] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym_LT_DASH] = ACTIONS(2925),
    [anon_sym_LT_LT] = ACTIONS(2925),
    [anon_sym_GT_GT] = ACTIONS(2925),
    [anon_sym_GT_GT_GT] = ACTIONS(2925),
    [anon_sym_AMP_CARET] = ACTIONS(2925),
    [anon_sym_AMP_AMP] = ACTIONS(2925),
    [anon_sym_PIPE_PIPE] = ACTIONS(2925),
    [anon_sym_or] = ACTIONS(2925),
    [sym_none] = ACTIONS(2925),
    [sym_true] = ACTIONS(2925),
    [sym_false] = ACTIONS(2925),
    [sym_nil] = ACTIONS(2925),
    [anon_sym_QMARK_DOT] = ACTIONS(2925),
    [anon_sym_POUND_LBRACK] = ACTIONS(2925),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_DOLLARif] = ACTIONS(2925),
    [anon_sym_is] = ACTIONS(2925),
    [anon_sym_BANGis] = ACTIONS(2925),
    [anon_sym_in] = ACTIONS(2925),
    [anon_sym_BANGin] = ACTIONS(2925),
    [anon_sym_match] = ACTIONS(2925),
    [anon_sym_select] = ACTIONS(2925),
    [anon_sym_lock] = ACTIONS(2925),
    [anon_sym_rlock] = ACTIONS(2925),
    [anon_sym_unsafe] = ACTIONS(2925),
    [anon_sym_sql] = ACTIONS(2925),
    [sym_int_literal] = ACTIONS(2925),
    [sym_float_literal] = ACTIONS(2925),
    [sym_rune_literal] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2925),
    [anon_sym_DQUOTE] = ACTIONS(2925),
    [anon_sym_c_SQUOTE] = ACTIONS(2925),
    [anon_sym_c_DQUOTE] = ACTIONS(2925),
    [anon_sym_r_SQUOTE] = ACTIONS(2925),
    [anon_sym_r_DQUOTE] = ACTIONS(2925),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2925),
    [anon_sym_shared] = ACTIONS(2925),
    [anon_sym_map_LBRACK] = ACTIONS(2925),
    [anon_sym_chan] = ACTIONS(2925),
    [anon_sym_thread] = ACTIONS(2925),
    [anon_sym_atomic] = ACTIONS(2925),
    [anon_sym_assert] = ACTIONS(2925),
    [anon_sym_defer] = ACTIONS(2925),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2925),
    [anon_sym_continue] = ACTIONS(2925),
    [anon_sym_return] = ACTIONS(2925),
    [anon_sym_DOLLARfor] = ACTIONS(2925),
    [anon_sym_for] = ACTIONS(2925),
    [anon_sym_POUND] = ACTIONS(2925),
    [anon_sym_asm] = ACTIONS(2925),
  },
  [1305] = {
    [sym_line_comment] = STATE(1305),
    [sym_block_comment] = STATE(1305),
    [sym_identifier] = ACTIONS(2921),
    [anon_sym_LF] = ACTIONS(2921),
    [anon_sym_CR] = ACTIONS(2921),
    [anon_sym_CR_LF] = ACTIONS(2921),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_as] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_COMMA] = ACTIONS(2921),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_fn] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2921),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2921),
    [anon_sym_LT] = ACTIONS(2921),
    [anon_sym_GT] = ACTIONS(2921),
    [anon_sym_EQ_EQ] = ACTIONS(2921),
    [anon_sym_BANG_EQ] = ACTIONS(2921),
    [anon_sym_LT_EQ] = ACTIONS(2921),
    [anon_sym_GT_EQ] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2919),
    [anon_sym_struct] = ACTIONS(2921),
    [anon_sym_mut] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2921),
    [anon_sym_DASH_DASH] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_go] = ACTIONS(2921),
    [anon_sym_spawn] = ACTIONS(2921),
    [anon_sym_json_DOTdecode] = ACTIONS(2921),
    [anon_sym_PIPE] = ACTIONS(2921),
    [anon_sym_LBRACK2] = ACTIONS(2921),
    [anon_sym_TILDE] = ACTIONS(2921),
    [anon_sym_CARET] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2921),
    [anon_sym_LT_DASH] = ACTIONS(2921),
    [anon_sym_LT_LT] = ACTIONS(2921),
    [anon_sym_GT_GT] = ACTIONS(2921),
    [anon_sym_GT_GT_GT] = ACTIONS(2921),
    [anon_sym_AMP_CARET] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE] = ACTIONS(2921),
    [anon_sym_or] = ACTIONS(2921),
    [sym_none] = ACTIONS(2921),
    [sym_true] = ACTIONS(2921),
    [sym_false] = ACTIONS(2921),
    [sym_nil] = ACTIONS(2921),
    [anon_sym_QMARK_DOT] = ACTIONS(2921),
    [anon_sym_POUND_LBRACK] = ACTIONS(2921),
    [anon_sym_if] = ACTIONS(2921),
    [anon_sym_DOLLARif] = ACTIONS(2921),
    [anon_sym_is] = ACTIONS(2921),
    [anon_sym_BANGis] = ACTIONS(2921),
    [anon_sym_in] = ACTIONS(2921),
    [anon_sym_BANGin] = ACTIONS(2921),
    [anon_sym_match] = ACTIONS(2921),
    [anon_sym_select] = ACTIONS(2921),
    [anon_sym_lock] = ACTIONS(2921),
    [anon_sym_rlock] = ACTIONS(2921),
    [anon_sym_unsafe] = ACTIONS(2921),
    [anon_sym_sql] = ACTIONS(2921),
    [sym_int_literal] = ACTIONS(2921),
    [sym_float_literal] = ACTIONS(2921),
    [sym_rune_literal] = ACTIONS(2921),
    [anon_sym_SQUOTE] = ACTIONS(2921),
    [anon_sym_DQUOTE] = ACTIONS(2921),
    [anon_sym_c_SQUOTE] = ACTIONS(2921),
    [anon_sym_c_DQUOTE] = ACTIONS(2921),
    [anon_sym_r_SQUOTE] = ACTIONS(2921),
    [anon_sym_r_DQUOTE] = ACTIONS(2921),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2921),
    [anon_sym_shared] = ACTIONS(2921),
    [anon_sym_map_LBRACK] = ACTIONS(2921),
    [anon_sym_chan] = ACTIONS(2921),
    [anon_sym_thread] = ACTIONS(2921),
    [anon_sym_atomic] = ACTIONS(2921),
    [anon_sym_assert] = ACTIONS(2921),
    [anon_sym_defer] = ACTIONS(2921),
    [anon_sym_goto] = ACTIONS(2921),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2921),
    [anon_sym_return] = ACTIONS(2921),
    [anon_sym_DOLLARfor] = ACTIONS(2921),
    [anon_sym_for] = ACTIONS(2921),
    [anon_sym_POUND] = ACTIONS(2921),
    [anon_sym_asm] = ACTIONS(2921),
  },
  [1306] = {
    [sym_line_comment] = STATE(1306),
    [sym_block_comment] = STATE(1306),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_LF] = ACTIONS(3300),
    [anon_sym_CR] = ACTIONS(3300),
    [anon_sym_CR_LF] = ACTIONS(3300),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(3300),
    [anon_sym_as] = ACTIONS(3300),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(3300),
    [anon_sym_RBRACE] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_fn] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_SLASH] = ACTIONS(3300),
    [anon_sym_PERCENT] = ACTIONS(3300),
    [anon_sym_LT] = ACTIONS(3300),
    [anon_sym_GT] = ACTIONS(3300),
    [anon_sym_EQ_EQ] = ACTIONS(3300),
    [anon_sym_BANG_EQ] = ACTIONS(3300),
    [anon_sym_LT_EQ] = ACTIONS(3300),
    [anon_sym_GT_EQ] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_struct] = ACTIONS(3300),
    [anon_sym_mut] = ACTIONS(3300),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_go] = ACTIONS(3300),
    [anon_sym_spawn] = ACTIONS(3300),
    [anon_sym_json_DOTdecode] = ACTIONS(3300),
    [anon_sym_PIPE] = ACTIONS(3300),
    [anon_sym_LBRACK2] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [anon_sym_CARET] = ACTIONS(3300),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LT_DASH] = ACTIONS(3300),
    [anon_sym_LT_LT] = ACTIONS(3300),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3300),
    [anon_sym_AMP_CARET] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_PIPE_PIPE] = ACTIONS(3300),
    [anon_sym_or] = ACTIONS(3300),
    [sym_none] = ACTIONS(3300),
    [sym_true] = ACTIONS(3300),
    [sym_false] = ACTIONS(3300),
    [sym_nil] = ACTIONS(3300),
    [anon_sym_QMARK_DOT] = ACTIONS(3300),
    [anon_sym_POUND_LBRACK] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_DOLLARif] = ACTIONS(3300),
    [anon_sym_is] = ACTIONS(3300),
    [anon_sym_BANGis] = ACTIONS(3300),
    [anon_sym_in] = ACTIONS(3300),
    [anon_sym_BANGin] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_select] = ACTIONS(3300),
    [anon_sym_lock] = ACTIONS(3300),
    [anon_sym_rlock] = ACTIONS(3300),
    [anon_sym_unsafe] = ACTIONS(3300),
    [anon_sym_sql] = ACTIONS(3300),
    [sym_int_literal] = ACTIONS(3300),
    [sym_float_literal] = ACTIONS(3300),
    [sym_rune_literal] = ACTIONS(3300),
    [anon_sym_SQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_c_SQUOTE] = ACTIONS(3300),
    [anon_sym_c_DQUOTE] = ACTIONS(3300),
    [anon_sym_r_SQUOTE] = ACTIONS(3300),
    [anon_sym_r_DQUOTE] = ACTIONS(3300),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3300),
    [anon_sym_shared] = ACTIONS(3300),
    [anon_sym_map_LBRACK] = ACTIONS(3300),
    [anon_sym_chan] = ACTIONS(3300),
    [anon_sym_thread] = ACTIONS(3300),
    [anon_sym_atomic] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_defer] = ACTIONS(3300),
    [anon_sym_goto] = ACTIONS(3300),
    [anon_sym_break] = ACTIONS(3300),
    [anon_sym_continue] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_DOLLARfor] = ACTIONS(3300),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_POUND] = ACTIONS(3300),
    [anon_sym_asm] = ACTIONS(3300),
  },
  [1307] = {
    [sym_line_comment] = STATE(1307),
    [sym_block_comment] = STATE(1307),
    [sym_identifier] = ACTIONS(2445),
    [anon_sym_LF] = ACTIONS(2445),
    [anon_sym_CR] = ACTIONS(2445),
    [anon_sym_CR_LF] = ACTIONS(2445),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2445),
    [anon_sym_DOT] = ACTIONS(2445),
    [anon_sym_as] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(2445),
    [anon_sym_COMMA] = ACTIONS(2445),
    [anon_sym_RBRACE] = ACTIONS(2445),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym_fn] = ACTIONS(2445),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2445),
    [anon_sym_STAR] = ACTIONS(2445),
    [anon_sym_SLASH] = ACTIONS(2445),
    [anon_sym_PERCENT] = ACTIONS(2445),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_GT] = ACTIONS(2445),
    [anon_sym_EQ_EQ] = ACTIONS(2445),
    [anon_sym_BANG_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_struct] = ACTIONS(2445),
    [anon_sym_mut] = ACTIONS(2445),
    [anon_sym_PLUS_PLUS] = ACTIONS(2445),
    [anon_sym_DASH_DASH] = ACTIONS(2445),
    [anon_sym_QMARK] = ACTIONS(2445),
    [anon_sym_BANG] = ACTIONS(2445),
    [anon_sym_go] = ACTIONS(2445),
    [anon_sym_spawn] = ACTIONS(2445),
    [anon_sym_json_DOTdecode] = ACTIONS(2445),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_LBRACK2] = ACTIONS(2445),
    [anon_sym_TILDE] = ACTIONS(2445),
    [anon_sym_CARET] = ACTIONS(2445),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_LT_DASH] = ACTIONS(2445),
    [anon_sym_LT_LT] = ACTIONS(2445),
    [anon_sym_GT_GT] = ACTIONS(2445),
    [anon_sym_GT_GT_GT] = ACTIONS(2445),
    [anon_sym_AMP_CARET] = ACTIONS(2445),
    [anon_sym_AMP_AMP] = ACTIONS(2445),
    [anon_sym_PIPE_PIPE] = ACTIONS(2445),
    [anon_sym_or] = ACTIONS(2445),
    [sym_none] = ACTIONS(2445),
    [sym_true] = ACTIONS(2445),
    [sym_false] = ACTIONS(2445),
    [sym_nil] = ACTIONS(2445),
    [anon_sym_QMARK_DOT] = ACTIONS(2445),
    [anon_sym_POUND_LBRACK] = ACTIONS(2445),
    [anon_sym_if] = ACTIONS(2445),
    [anon_sym_DOLLARif] = ACTIONS(2445),
    [anon_sym_is] = ACTIONS(2445),
    [anon_sym_BANGis] = ACTIONS(2445),
    [anon_sym_in] = ACTIONS(2445),
    [anon_sym_BANGin] = ACTIONS(2445),
    [anon_sym_match] = ACTIONS(2445),
    [anon_sym_select] = ACTIONS(2445),
    [anon_sym_lock] = ACTIONS(2445),
    [anon_sym_rlock] = ACTIONS(2445),
    [anon_sym_unsafe] = ACTIONS(2445),
    [anon_sym_sql] = ACTIONS(2445),
    [sym_int_literal] = ACTIONS(2445),
    [sym_float_literal] = ACTIONS(2445),
    [sym_rune_literal] = ACTIONS(2445),
    [anon_sym_SQUOTE] = ACTIONS(2445),
    [anon_sym_DQUOTE] = ACTIONS(2445),
    [anon_sym_c_SQUOTE] = ACTIONS(2445),
    [anon_sym_c_DQUOTE] = ACTIONS(2445),
    [anon_sym_r_SQUOTE] = ACTIONS(2445),
    [anon_sym_r_DQUOTE] = ACTIONS(2445),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2445),
    [anon_sym_shared] = ACTIONS(2445),
    [anon_sym_map_LBRACK] = ACTIONS(2445),
    [anon_sym_chan] = ACTIONS(2445),
    [anon_sym_thread] = ACTIONS(2445),
    [anon_sym_atomic] = ACTIONS(2445),
    [anon_sym_assert] = ACTIONS(2445),
    [anon_sym_defer] = ACTIONS(2445),
    [anon_sym_goto] = ACTIONS(2445),
    [anon_sym_break] = ACTIONS(2445),
    [anon_sym_continue] = ACTIONS(2445),
    [anon_sym_return] = ACTIONS(2445),
    [anon_sym_DOLLARfor] = ACTIONS(2445),
    [anon_sym_for] = ACTIONS(2445),
    [anon_sym_POUND] = ACTIONS(2445),
    [anon_sym_asm] = ACTIONS(2445),
  },
  [1308] = {
    [sym_line_comment] = STATE(1308),
    [sym_block_comment] = STATE(1308),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LF] = ACTIONS(2175),
    [anon_sym_CR] = ACTIONS(2175),
    [anon_sym_CR_LF] = ACTIONS(2175),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_DOT] = ACTIONS(2175),
    [anon_sym_as] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2177),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_fn] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2175),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_PERCENT] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_GT] = ACTIONS(2175),
    [anon_sym_EQ_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ] = ACTIONS(2175),
    [anon_sym_LT_EQ] = ACTIONS(2175),
    [anon_sym_GT_EQ] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2180),
    [anon_sym_struct] = ACTIONS(2175),
    [anon_sym_mut] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [anon_sym_QMARK] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_go] = ACTIONS(2175),
    [anon_sym_spawn] = ACTIONS(2175),
    [anon_sym_json_DOTdecode] = ACTIONS(2175),
    [anon_sym_PIPE] = ACTIONS(2175),
    [anon_sym_LBRACK2] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_CARET] = ACTIONS(2175),
    [anon_sym_AMP] = ACTIONS(2175),
    [anon_sym_LT_DASH] = ACTIONS(2175),
    [anon_sym_LT_LT] = ACTIONS(2175),
    [anon_sym_GT_GT] = ACTIONS(2175),
    [anon_sym_GT_GT_GT] = ACTIONS(2175),
    [anon_sym_AMP_CARET] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(2175),
    [anon_sym_PIPE_PIPE] = ACTIONS(2175),
    [anon_sym_or] = ACTIONS(2175),
    [sym_none] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_nil] = ACTIONS(2175),
    [anon_sym_QMARK_DOT] = ACTIONS(2175),
    [anon_sym_POUND_LBRACK] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_DOLLARif] = ACTIONS(2175),
    [anon_sym_is] = ACTIONS(2175),
    [anon_sym_BANGis] = ACTIONS(2175),
    [anon_sym_in] = ACTIONS(2175),
    [anon_sym_BANGin] = ACTIONS(2175),
    [anon_sym_match] = ACTIONS(2175),
    [anon_sym_select] = ACTIONS(2175),
    [anon_sym_lock] = ACTIONS(2175),
    [anon_sym_rlock] = ACTIONS(2175),
    [anon_sym_unsafe] = ACTIONS(2175),
    [anon_sym_sql] = ACTIONS(2175),
    [sym_int_literal] = ACTIONS(2175),
    [sym_float_literal] = ACTIONS(2175),
    [sym_rune_literal] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_c_SQUOTE] = ACTIONS(2175),
    [anon_sym_c_DQUOTE] = ACTIONS(2175),
    [anon_sym_r_SQUOTE] = ACTIONS(2175),
    [anon_sym_r_DQUOTE] = ACTIONS(2175),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2175),
    [anon_sym_shared] = ACTIONS(2175),
    [anon_sym_map_LBRACK] = ACTIONS(2175),
    [anon_sym_chan] = ACTIONS(2175),
    [anon_sym_thread] = ACTIONS(2175),
    [anon_sym_atomic] = ACTIONS(2175),
    [anon_sym_assert] = ACTIONS(2175),
    [anon_sym_defer] = ACTIONS(2175),
    [anon_sym_goto] = ACTIONS(2175),
    [anon_sym_break] = ACTIONS(2175),
    [anon_sym_continue] = ACTIONS(2175),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_DOLLARfor] = ACTIONS(2175),
    [anon_sym_for] = ACTIONS(2175),
    [anon_sym_POUND] = ACTIONS(2175),
    [anon_sym_asm] = ACTIONS(2175),
  },
  [1309] = {
    [sym_line_comment] = STATE(1309),
    [sym_block_comment] = STATE(1309),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_LF] = ACTIONS(2917),
    [anon_sym_CR] = ACTIONS(2917),
    [anon_sym_CR_LF] = ACTIONS(2917),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym_DOT] = ACTIONS(2917),
    [anon_sym_as] = ACTIONS(2917),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_COMMA] = ACTIONS(2917),
    [anon_sym_RBRACE] = ACTIONS(2917),
    [anon_sym_LPAREN] = ACTIONS(2917),
    [anon_sym_fn] = ACTIONS(2917),
    [anon_sym_PLUS] = ACTIONS(2917),
    [anon_sym_DASH] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2917),
    [anon_sym_SLASH] = ACTIONS(2917),
    [anon_sym_PERCENT] = ACTIONS(2917),
    [anon_sym_LT] = ACTIONS(2917),
    [anon_sym_GT] = ACTIONS(2917),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2917),
    [anon_sym_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT_EQ] = ACTIONS(2917),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2917),
    [anon_sym_mut] = ACTIONS(2917),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_QMARK] = ACTIONS(2917),
    [anon_sym_BANG] = ACTIONS(2917),
    [anon_sym_go] = ACTIONS(2917),
    [anon_sym_spawn] = ACTIONS(2917),
    [anon_sym_json_DOTdecode] = ACTIONS(2917),
    [anon_sym_PIPE] = ACTIONS(2917),
    [anon_sym_LBRACK2] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_CARET] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2917),
    [anon_sym_LT_DASH] = ACTIONS(2917),
    [anon_sym_LT_LT] = ACTIONS(2917),
    [anon_sym_GT_GT] = ACTIONS(2917),
    [anon_sym_GT_GT_GT] = ACTIONS(2917),
    [anon_sym_AMP_CARET] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_PIPE_PIPE] = ACTIONS(2917),
    [anon_sym_or] = ACTIONS(2917),
    [sym_none] = ACTIONS(2917),
    [sym_true] = ACTIONS(2917),
    [sym_false] = ACTIONS(2917),
    [sym_nil] = ACTIONS(2917),
    [anon_sym_QMARK_DOT] = ACTIONS(2917),
    [anon_sym_POUND_LBRACK] = ACTIONS(2917),
    [anon_sym_if] = ACTIONS(2917),
    [anon_sym_DOLLARif] = ACTIONS(2917),
    [anon_sym_is] = ACTIONS(2917),
    [anon_sym_BANGis] = ACTIONS(2917),
    [anon_sym_in] = ACTIONS(2917),
    [anon_sym_BANGin] = ACTIONS(2917),
    [anon_sym_match] = ACTIONS(2917),
    [anon_sym_select] = ACTIONS(2917),
    [anon_sym_lock] = ACTIONS(2917),
    [anon_sym_rlock] = ACTIONS(2917),
    [anon_sym_unsafe] = ACTIONS(2917),
    [anon_sym_sql] = ACTIONS(2917),
    [sym_int_literal] = ACTIONS(2917),
    [sym_float_literal] = ACTIONS(2917),
    [sym_rune_literal] = ACTIONS(2917),
    [anon_sym_SQUOTE] = ACTIONS(2917),
    [anon_sym_DQUOTE] = ACTIONS(2917),
    [anon_sym_c_SQUOTE] = ACTIONS(2917),
    [anon_sym_c_DQUOTE] = ACTIONS(2917),
    [anon_sym_r_SQUOTE] = ACTIONS(2917),
    [anon_sym_r_DQUOTE] = ACTIONS(2917),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2917),
    [anon_sym_shared] = ACTIONS(2917),
    [anon_sym_map_LBRACK] = ACTIONS(2917),
    [anon_sym_chan] = ACTIONS(2917),
    [anon_sym_thread] = ACTIONS(2917),
    [anon_sym_atomic] = ACTIONS(2917),
    [anon_sym_assert] = ACTIONS(2917),
    [anon_sym_defer] = ACTIONS(2917),
    [anon_sym_goto] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2917),
    [anon_sym_continue] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2917),
    [anon_sym_DOLLARfor] = ACTIONS(2917),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_POUND] = ACTIONS(2917),
    [anon_sym_asm] = ACTIONS(2917),
  },
  [1310] = {
    [sym_line_comment] = STATE(1310),
    [sym_block_comment] = STATE(1310),
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_LF] = ACTIONS(3061),
    [anon_sym_CR] = ACTIONS(3061),
    [anon_sym_CR_LF] = ACTIONS(3061),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3061),
    [anon_sym_DOT] = ACTIONS(3061),
    [anon_sym_as] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3061),
    [anon_sym_COMMA] = ACTIONS(3061),
    [anon_sym_RBRACE] = ACTIONS(3061),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_PLUS] = ACTIONS(3061),
    [anon_sym_DASH] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(3061),
    [anon_sym_SLASH] = ACTIONS(3061),
    [anon_sym_PERCENT] = ACTIONS(3061),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_GT] = ACTIONS(3061),
    [anon_sym_EQ_EQ] = ACTIONS(3061),
    [anon_sym_BANG_EQ] = ACTIONS(3061),
    [anon_sym_LT_EQ] = ACTIONS(3061),
    [anon_sym_GT_EQ] = ACTIONS(3061),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_struct] = ACTIONS(3061),
    [anon_sym_mut] = ACTIONS(3061),
    [anon_sym_PLUS_PLUS] = ACTIONS(3061),
    [anon_sym_DASH_DASH] = ACTIONS(3061),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_BANG] = ACTIONS(3061),
    [anon_sym_go] = ACTIONS(3061),
    [anon_sym_spawn] = ACTIONS(3061),
    [anon_sym_json_DOTdecode] = ACTIONS(3061),
    [anon_sym_PIPE] = ACTIONS(3061),
    [anon_sym_LBRACK2] = ACTIONS(3061),
    [anon_sym_TILDE] = ACTIONS(3061),
    [anon_sym_CARET] = ACTIONS(3061),
    [anon_sym_AMP] = ACTIONS(3061),
    [anon_sym_LT_DASH] = ACTIONS(3061),
    [anon_sym_LT_LT] = ACTIONS(3061),
    [anon_sym_GT_GT] = ACTIONS(3061),
    [anon_sym_GT_GT_GT] = ACTIONS(3061),
    [anon_sym_AMP_CARET] = ACTIONS(3061),
    [anon_sym_AMP_AMP] = ACTIONS(3061),
    [anon_sym_PIPE_PIPE] = ACTIONS(3061),
    [anon_sym_or] = ACTIONS(3061),
    [sym_none] = ACTIONS(3061),
    [sym_true] = ACTIONS(3061),
    [sym_false] = ACTIONS(3061),
    [sym_nil] = ACTIONS(3061),
    [anon_sym_QMARK_DOT] = ACTIONS(3061),
    [anon_sym_POUND_LBRACK] = ACTIONS(3061),
    [anon_sym_if] = ACTIONS(3061),
    [anon_sym_DOLLARif] = ACTIONS(3061),
    [anon_sym_is] = ACTIONS(3061),
    [anon_sym_BANGis] = ACTIONS(3061),
    [anon_sym_in] = ACTIONS(3061),
    [anon_sym_BANGin] = ACTIONS(3061),
    [anon_sym_match] = ACTIONS(3061),
    [anon_sym_select] = ACTIONS(3061),
    [anon_sym_lock] = ACTIONS(3061),
    [anon_sym_rlock] = ACTIONS(3061),
    [anon_sym_unsafe] = ACTIONS(3061),
    [anon_sym_sql] = ACTIONS(3061),
    [sym_int_literal] = ACTIONS(3061),
    [sym_float_literal] = ACTIONS(3061),
    [sym_rune_literal] = ACTIONS(3061),
    [anon_sym_SQUOTE] = ACTIONS(3061),
    [anon_sym_DQUOTE] = ACTIONS(3061),
    [anon_sym_c_SQUOTE] = ACTIONS(3061),
    [anon_sym_c_DQUOTE] = ACTIONS(3061),
    [anon_sym_r_SQUOTE] = ACTIONS(3061),
    [anon_sym_r_DQUOTE] = ACTIONS(3061),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3061),
    [anon_sym_shared] = ACTIONS(3061),
    [anon_sym_map_LBRACK] = ACTIONS(3061),
    [anon_sym_chan] = ACTIONS(3061),
    [anon_sym_thread] = ACTIONS(3061),
    [anon_sym_atomic] = ACTIONS(3061),
    [anon_sym_assert] = ACTIONS(3061),
    [anon_sym_defer] = ACTIONS(3061),
    [anon_sym_goto] = ACTIONS(3061),
    [anon_sym_break] = ACTIONS(3061),
    [anon_sym_continue] = ACTIONS(3061),
    [anon_sym_return] = ACTIONS(3061),
    [anon_sym_DOLLARfor] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(3061),
    [anon_sym_POUND] = ACTIONS(3061),
    [anon_sym_asm] = ACTIONS(3061),
  },
  [1311] = {
    [sym_line_comment] = STATE(1311),
    [sym_block_comment] = STATE(1311),
    [sym_identifier] = ACTIONS(2865),
    [anon_sym_LF] = ACTIONS(2865),
    [anon_sym_CR] = ACTIONS(2865),
    [anon_sym_CR_LF] = ACTIONS(2865),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2865),
    [anon_sym_DOT] = ACTIONS(2865),
    [anon_sym_as] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2865),
    [anon_sym_COMMA] = ACTIONS(2865),
    [anon_sym_RBRACE] = ACTIONS(2865),
    [anon_sym_LPAREN] = ACTIONS(2865),
    [anon_sym_fn] = ACTIONS(2865),
    [anon_sym_PLUS] = ACTIONS(2865),
    [anon_sym_DASH] = ACTIONS(2865),
    [anon_sym_STAR] = ACTIONS(2865),
    [anon_sym_SLASH] = ACTIONS(2865),
    [anon_sym_PERCENT] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_GT] = ACTIONS(2865),
    [anon_sym_EQ_EQ] = ACTIONS(2865),
    [anon_sym_BANG_EQ] = ACTIONS(2865),
    [anon_sym_LT_EQ] = ACTIONS(2865),
    [anon_sym_GT_EQ] = ACTIONS(2865),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_struct] = ACTIONS(2865),
    [anon_sym_mut] = ACTIONS(2865),
    [anon_sym_PLUS_PLUS] = ACTIONS(2865),
    [anon_sym_DASH_DASH] = ACTIONS(2865),
    [anon_sym_QMARK] = ACTIONS(2865),
    [anon_sym_BANG] = ACTIONS(2865),
    [anon_sym_go] = ACTIONS(2865),
    [anon_sym_spawn] = ACTIONS(2865),
    [anon_sym_json_DOTdecode] = ACTIONS(2865),
    [anon_sym_PIPE] = ACTIONS(2865),
    [anon_sym_LBRACK2] = ACTIONS(2865),
    [anon_sym_TILDE] = ACTIONS(2865),
    [anon_sym_CARET] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2865),
    [anon_sym_LT_DASH] = ACTIONS(2865),
    [anon_sym_LT_LT] = ACTIONS(2865),
    [anon_sym_GT_GT] = ACTIONS(2865),
    [anon_sym_GT_GT_GT] = ACTIONS(2865),
    [anon_sym_AMP_CARET] = ACTIONS(2865),
    [anon_sym_AMP_AMP] = ACTIONS(2865),
    [anon_sym_PIPE_PIPE] = ACTIONS(2865),
    [anon_sym_or] = ACTIONS(2865),
    [sym_none] = ACTIONS(2865),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_nil] = ACTIONS(2865),
    [anon_sym_QMARK_DOT] = ACTIONS(2865),
    [anon_sym_POUND_LBRACK] = ACTIONS(2865),
    [anon_sym_if] = ACTIONS(2865),
    [anon_sym_DOLLARif] = ACTIONS(2865),
    [anon_sym_is] = ACTIONS(2865),
    [anon_sym_BANGis] = ACTIONS(2865),
    [anon_sym_in] = ACTIONS(2865),
    [anon_sym_BANGin] = ACTIONS(2865),
    [anon_sym_match] = ACTIONS(2865),
    [anon_sym_select] = ACTIONS(2865),
    [anon_sym_lock] = ACTIONS(2865),
    [anon_sym_rlock] = ACTIONS(2865),
    [anon_sym_unsafe] = ACTIONS(2865),
    [anon_sym_sql] = ACTIONS(2865),
    [sym_int_literal] = ACTIONS(2865),
    [sym_float_literal] = ACTIONS(2865),
    [sym_rune_literal] = ACTIONS(2865),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_DQUOTE] = ACTIONS(2865),
    [anon_sym_c_SQUOTE] = ACTIONS(2865),
    [anon_sym_c_DQUOTE] = ACTIONS(2865),
    [anon_sym_r_SQUOTE] = ACTIONS(2865),
    [anon_sym_r_DQUOTE] = ACTIONS(2865),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2865),
    [anon_sym_shared] = ACTIONS(2865),
    [anon_sym_map_LBRACK] = ACTIONS(2865),
    [anon_sym_chan] = ACTIONS(2865),
    [anon_sym_thread] = ACTIONS(2865),
    [anon_sym_atomic] = ACTIONS(2865),
    [anon_sym_assert] = ACTIONS(2865),
    [anon_sym_defer] = ACTIONS(2865),
    [anon_sym_goto] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2865),
    [anon_sym_continue] = ACTIONS(2865),
    [anon_sym_return] = ACTIONS(2865),
    [anon_sym_DOLLARfor] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2865),
    [anon_sym_POUND] = ACTIONS(2865),
    [anon_sym_asm] = ACTIONS(2865),
  },
  [1312] = {
    [sym_line_comment] = STATE(1312),
    [sym_block_comment] = STATE(1312),
    [sym_identifier] = ACTIONS(3246),
    [anon_sym_LF] = ACTIONS(3246),
    [anon_sym_CR] = ACTIONS(3246),
    [anon_sym_CR_LF] = ACTIONS(3246),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3246),
    [anon_sym_DOT] = ACTIONS(3246),
    [anon_sym_as] = ACTIONS(3246),
    [anon_sym_LBRACE] = ACTIONS(3246),
    [anon_sym_COMMA] = ACTIONS(3246),
    [anon_sym_RBRACE] = ACTIONS(3246),
    [anon_sym_LPAREN] = ACTIONS(3246),
    [anon_sym_fn] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3246),
    [anon_sym_DASH] = ACTIONS(3246),
    [anon_sym_STAR] = ACTIONS(3246),
    [anon_sym_SLASH] = ACTIONS(3246),
    [anon_sym_PERCENT] = ACTIONS(3246),
    [anon_sym_LT] = ACTIONS(3246),
    [anon_sym_GT] = ACTIONS(3246),
    [anon_sym_EQ_EQ] = ACTIONS(3246),
    [anon_sym_BANG_EQ] = ACTIONS(3246),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3246),
    [anon_sym_LBRACK] = ACTIONS(3244),
    [anon_sym_struct] = ACTIONS(3246),
    [anon_sym_mut] = ACTIONS(3246),
    [anon_sym_PLUS_PLUS] = ACTIONS(3246),
    [anon_sym_DASH_DASH] = ACTIONS(3246),
    [anon_sym_QMARK] = ACTIONS(3246),
    [anon_sym_BANG] = ACTIONS(3246),
    [anon_sym_go] = ACTIONS(3246),
    [anon_sym_spawn] = ACTIONS(3246),
    [anon_sym_json_DOTdecode] = ACTIONS(3246),
    [anon_sym_PIPE] = ACTIONS(3246),
    [anon_sym_LBRACK2] = ACTIONS(3246),
    [anon_sym_TILDE] = ACTIONS(3246),
    [anon_sym_CARET] = ACTIONS(3246),
    [anon_sym_AMP] = ACTIONS(3246),
    [anon_sym_LT_DASH] = ACTIONS(3246),
    [anon_sym_LT_LT] = ACTIONS(3246),
    [anon_sym_GT_GT] = ACTIONS(3246),
    [anon_sym_GT_GT_GT] = ACTIONS(3246),
    [anon_sym_AMP_CARET] = ACTIONS(3246),
    [anon_sym_AMP_AMP] = ACTIONS(3246),
    [anon_sym_PIPE_PIPE] = ACTIONS(3246),
    [anon_sym_or] = ACTIONS(3246),
    [sym_none] = ACTIONS(3246),
    [sym_true] = ACTIONS(3246),
    [sym_false] = ACTIONS(3246),
    [sym_nil] = ACTIONS(3246),
    [anon_sym_QMARK_DOT] = ACTIONS(3246),
    [anon_sym_POUND_LBRACK] = ACTIONS(3246),
    [anon_sym_if] = ACTIONS(3246),
    [anon_sym_DOLLARif] = ACTIONS(3246),
    [anon_sym_is] = ACTIONS(3246),
    [anon_sym_BANGis] = ACTIONS(3246),
    [anon_sym_in] = ACTIONS(3246),
    [anon_sym_BANGin] = ACTIONS(3246),
    [anon_sym_match] = ACTIONS(3246),
    [anon_sym_select] = ACTIONS(3246),
    [anon_sym_lock] = ACTIONS(3246),
    [anon_sym_rlock] = ACTIONS(3246),
    [anon_sym_unsafe] = ACTIONS(3246),
    [anon_sym_sql] = ACTIONS(3246),
    [sym_int_literal] = ACTIONS(3246),
    [sym_float_literal] = ACTIONS(3246),
    [sym_rune_literal] = ACTIONS(3246),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_DQUOTE] = ACTIONS(3246),
    [anon_sym_c_SQUOTE] = ACTIONS(3246),
    [anon_sym_c_DQUOTE] = ACTIONS(3246),
    [anon_sym_r_SQUOTE] = ACTIONS(3246),
    [anon_sym_r_DQUOTE] = ACTIONS(3246),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3246),
    [anon_sym_shared] = ACTIONS(3246),
    [anon_sym_map_LBRACK] = ACTIONS(3246),
    [anon_sym_chan] = ACTIONS(3246),
    [anon_sym_thread] = ACTIONS(3246),
    [anon_sym_atomic] = ACTIONS(3246),
    [anon_sym_assert] = ACTIONS(3246),
    [anon_sym_defer] = ACTIONS(3246),
    [anon_sym_goto] = ACTIONS(3246),
    [anon_sym_break] = ACTIONS(3246),
    [anon_sym_continue] = ACTIONS(3246),
    [anon_sym_return] = ACTIONS(3246),
    [anon_sym_DOLLARfor] = ACTIONS(3246),
    [anon_sym_for] = ACTIONS(3246),
    [anon_sym_POUND] = ACTIONS(3246),
    [anon_sym_asm] = ACTIONS(3246),
  },
  [1313] = {
    [sym_line_comment] = STATE(1313),
    [sym_block_comment] = STATE(1313),
    [sym_identifier] = ACTIONS(2957),
    [anon_sym_LF] = ACTIONS(2957),
    [anon_sym_CR] = ACTIONS(2957),
    [anon_sym_CR_LF] = ACTIONS(2957),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2957),
    [anon_sym_DOT] = ACTIONS(2957),
    [anon_sym_as] = ACTIONS(2957),
    [anon_sym_LBRACE] = ACTIONS(2957),
    [anon_sym_COMMA] = ACTIONS(2957),
    [anon_sym_RBRACE] = ACTIONS(2957),
    [anon_sym_LPAREN] = ACTIONS(2957),
    [anon_sym_fn] = ACTIONS(2957),
    [anon_sym_PLUS] = ACTIONS(2957),
    [anon_sym_DASH] = ACTIONS(2957),
    [anon_sym_STAR] = ACTIONS(2957),
    [anon_sym_SLASH] = ACTIONS(2957),
    [anon_sym_PERCENT] = ACTIONS(2957),
    [anon_sym_LT] = ACTIONS(2957),
    [anon_sym_GT] = ACTIONS(2957),
    [anon_sym_EQ_EQ] = ACTIONS(2957),
    [anon_sym_BANG_EQ] = ACTIONS(2957),
    [anon_sym_LT_EQ] = ACTIONS(2957),
    [anon_sym_GT_EQ] = ACTIONS(2957),
    [anon_sym_LBRACK] = ACTIONS(2955),
    [anon_sym_struct] = ACTIONS(2957),
    [anon_sym_mut] = ACTIONS(2957),
    [anon_sym_PLUS_PLUS] = ACTIONS(2957),
    [anon_sym_DASH_DASH] = ACTIONS(2957),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_BANG] = ACTIONS(2957),
    [anon_sym_go] = ACTIONS(2957),
    [anon_sym_spawn] = ACTIONS(2957),
    [anon_sym_json_DOTdecode] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2957),
    [anon_sym_LBRACK2] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2957),
    [anon_sym_CARET] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2957),
    [anon_sym_LT_DASH] = ACTIONS(2957),
    [anon_sym_LT_LT] = ACTIONS(2957),
    [anon_sym_GT_GT] = ACTIONS(2957),
    [anon_sym_GT_GT_GT] = ACTIONS(2957),
    [anon_sym_AMP_CARET] = ACTIONS(2957),
    [anon_sym_AMP_AMP] = ACTIONS(2957),
    [anon_sym_PIPE_PIPE] = ACTIONS(2957),
    [anon_sym_or] = ACTIONS(2957),
    [sym_none] = ACTIONS(2957),
    [sym_true] = ACTIONS(2957),
    [sym_false] = ACTIONS(2957),
    [sym_nil] = ACTIONS(2957),
    [anon_sym_QMARK_DOT] = ACTIONS(2957),
    [anon_sym_POUND_LBRACK] = ACTIONS(2957),
    [anon_sym_if] = ACTIONS(2957),
    [anon_sym_DOLLARif] = ACTIONS(2957),
    [anon_sym_is] = ACTIONS(2957),
    [anon_sym_BANGis] = ACTIONS(2957),
    [anon_sym_in] = ACTIONS(2957),
    [anon_sym_BANGin] = ACTIONS(2957),
    [anon_sym_match] = ACTIONS(2957),
    [anon_sym_select] = ACTIONS(2957),
    [anon_sym_lock] = ACTIONS(2957),
    [anon_sym_rlock] = ACTIONS(2957),
    [anon_sym_unsafe] = ACTIONS(2957),
    [anon_sym_sql] = ACTIONS(2957),
    [sym_int_literal] = ACTIONS(2957),
    [sym_float_literal] = ACTIONS(2957),
    [sym_rune_literal] = ACTIONS(2957),
    [anon_sym_SQUOTE] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(2957),
    [anon_sym_c_SQUOTE] = ACTIONS(2957),
    [anon_sym_c_DQUOTE] = ACTIONS(2957),
    [anon_sym_r_SQUOTE] = ACTIONS(2957),
    [anon_sym_r_DQUOTE] = ACTIONS(2957),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2957),
    [anon_sym_shared] = ACTIONS(2957),
    [anon_sym_map_LBRACK] = ACTIONS(2957),
    [anon_sym_chan] = ACTIONS(2957),
    [anon_sym_thread] = ACTIONS(2957),
    [anon_sym_atomic] = ACTIONS(2957),
    [anon_sym_assert] = ACTIONS(2957),
    [anon_sym_defer] = ACTIONS(2957),
    [anon_sym_goto] = ACTIONS(2957),
    [anon_sym_break] = ACTIONS(2957),
    [anon_sym_continue] = ACTIONS(2957),
    [anon_sym_return] = ACTIONS(2957),
    [anon_sym_DOLLARfor] = ACTIONS(2957),
    [anon_sym_for] = ACTIONS(2957),
    [anon_sym_POUND] = ACTIONS(2957),
    [anon_sym_asm] = ACTIONS(2957),
  },
  [1314] = {
    [sym_line_comment] = STATE(1314),
    [sym_block_comment] = STATE(1314),
    [sym_identifier] = ACTIONS(3035),
    [anon_sym_LF] = ACTIONS(3035),
    [anon_sym_CR] = ACTIONS(3035),
    [anon_sym_CR_LF] = ACTIONS(3035),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym_DOT] = ACTIONS(3035),
    [anon_sym_as] = ACTIONS(3035),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_COMMA] = ACTIONS(3035),
    [anon_sym_RBRACE] = ACTIONS(3035),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_fn] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3035),
    [anon_sym_SLASH] = ACTIONS(3035),
    [anon_sym_PERCENT] = ACTIONS(3035),
    [anon_sym_LT] = ACTIONS(3035),
    [anon_sym_GT] = ACTIONS(3035),
    [anon_sym_EQ_EQ] = ACTIONS(3035),
    [anon_sym_BANG_EQ] = ACTIONS(3035),
    [anon_sym_LT_EQ] = ACTIONS(3035),
    [anon_sym_GT_EQ] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3033),
    [anon_sym_struct] = ACTIONS(3035),
    [anon_sym_mut] = ACTIONS(3035),
    [anon_sym_PLUS_PLUS] = ACTIONS(3035),
    [anon_sym_DASH_DASH] = ACTIONS(3035),
    [anon_sym_QMARK] = ACTIONS(3035),
    [anon_sym_BANG] = ACTIONS(3035),
    [anon_sym_go] = ACTIONS(3035),
    [anon_sym_spawn] = ACTIONS(3035),
    [anon_sym_json_DOTdecode] = ACTIONS(3035),
    [anon_sym_PIPE] = ACTIONS(3035),
    [anon_sym_LBRACK2] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3035),
    [anon_sym_CARET] = ACTIONS(3035),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_LT_DASH] = ACTIONS(3035),
    [anon_sym_LT_LT] = ACTIONS(3035),
    [anon_sym_GT_GT] = ACTIONS(3035),
    [anon_sym_GT_GT_GT] = ACTIONS(3035),
    [anon_sym_AMP_CARET] = ACTIONS(3035),
    [anon_sym_AMP_AMP] = ACTIONS(3035),
    [anon_sym_PIPE_PIPE] = ACTIONS(3035),
    [anon_sym_or] = ACTIONS(3035),
    [sym_none] = ACTIONS(3035),
    [sym_true] = ACTIONS(3035),
    [sym_false] = ACTIONS(3035),
    [sym_nil] = ACTIONS(3035),
    [anon_sym_QMARK_DOT] = ACTIONS(3035),
    [anon_sym_POUND_LBRACK] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_DOLLARif] = ACTIONS(3035),
    [anon_sym_is] = ACTIONS(3035),
    [anon_sym_BANGis] = ACTIONS(3035),
    [anon_sym_in] = ACTIONS(3035),
    [anon_sym_BANGin] = ACTIONS(3035),
    [anon_sym_match] = ACTIONS(3035),
    [anon_sym_select] = ACTIONS(3035),
    [anon_sym_lock] = ACTIONS(3035),
    [anon_sym_rlock] = ACTIONS(3035),
    [anon_sym_unsafe] = ACTIONS(3035),
    [anon_sym_sql] = ACTIONS(3035),
    [sym_int_literal] = ACTIONS(3035),
    [sym_float_literal] = ACTIONS(3035),
    [sym_rune_literal] = ACTIONS(3035),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_c_SQUOTE] = ACTIONS(3035),
    [anon_sym_c_DQUOTE] = ACTIONS(3035),
    [anon_sym_r_SQUOTE] = ACTIONS(3035),
    [anon_sym_r_DQUOTE] = ACTIONS(3035),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3035),
    [anon_sym_shared] = ACTIONS(3035),
    [anon_sym_map_LBRACK] = ACTIONS(3035),
    [anon_sym_chan] = ACTIONS(3035),
    [anon_sym_thread] = ACTIONS(3035),
    [anon_sym_atomic] = ACTIONS(3035),
    [anon_sym_assert] = ACTIONS(3035),
    [anon_sym_defer] = ACTIONS(3035),
    [anon_sym_goto] = ACTIONS(3035),
    [anon_sym_break] = ACTIONS(3035),
    [anon_sym_continue] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_DOLLARfor] = ACTIONS(3035),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_POUND] = ACTIONS(3035),
    [anon_sym_asm] = ACTIONS(3035),
  },
  [1315] = {
    [sym_line_comment] = STATE(1315),
    [sym_block_comment] = STATE(1315),
    [sym_identifier] = ACTIONS(2967),
    [anon_sym_LF] = ACTIONS(2967),
    [anon_sym_CR] = ACTIONS(2967),
    [anon_sym_CR_LF] = ACTIONS(2967),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2967),
    [anon_sym_DOT] = ACTIONS(2967),
    [anon_sym_as] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2967),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_RBRACE] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(2967),
    [anon_sym_fn] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2967),
    [anon_sym_SLASH] = ACTIONS(2967),
    [anon_sym_PERCENT] = ACTIONS(2967),
    [anon_sym_LT] = ACTIONS(2967),
    [anon_sym_GT] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2967),
    [anon_sym_BANG_EQ] = ACTIONS(2967),
    [anon_sym_LT_EQ] = ACTIONS(2967),
    [anon_sym_GT_EQ] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2965),
    [anon_sym_struct] = ACTIONS(2967),
    [anon_sym_mut] = ACTIONS(2967),
    [anon_sym_PLUS_PLUS] = ACTIONS(2967),
    [anon_sym_DASH_DASH] = ACTIONS(2967),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_BANG] = ACTIONS(2967),
    [anon_sym_go] = ACTIONS(2967),
    [anon_sym_spawn] = ACTIONS(2967),
    [anon_sym_json_DOTdecode] = ACTIONS(2967),
    [anon_sym_PIPE] = ACTIONS(2967),
    [anon_sym_LBRACK2] = ACTIONS(2967),
    [anon_sym_TILDE] = ACTIONS(2967),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_AMP] = ACTIONS(2967),
    [anon_sym_LT_DASH] = ACTIONS(2967),
    [anon_sym_LT_LT] = ACTIONS(2967),
    [anon_sym_GT_GT] = ACTIONS(2967),
    [anon_sym_GT_GT_GT] = ACTIONS(2967),
    [anon_sym_AMP_CARET] = ACTIONS(2967),
    [anon_sym_AMP_AMP] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE] = ACTIONS(2967),
    [anon_sym_or] = ACTIONS(2967),
    [sym_none] = ACTIONS(2967),
    [sym_true] = ACTIONS(2967),
    [sym_false] = ACTIONS(2967),
    [sym_nil] = ACTIONS(2967),
    [anon_sym_QMARK_DOT] = ACTIONS(2967),
    [anon_sym_POUND_LBRACK] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_DOLLARif] = ACTIONS(2967),
    [anon_sym_is] = ACTIONS(2967),
    [anon_sym_BANGis] = ACTIONS(2967),
    [anon_sym_in] = ACTIONS(2967),
    [anon_sym_BANGin] = ACTIONS(2967),
    [anon_sym_match] = ACTIONS(2967),
    [anon_sym_select] = ACTIONS(2967),
    [anon_sym_lock] = ACTIONS(2967),
    [anon_sym_rlock] = ACTIONS(2967),
    [anon_sym_unsafe] = ACTIONS(2967),
    [anon_sym_sql] = ACTIONS(2967),
    [sym_int_literal] = ACTIONS(2967),
    [sym_float_literal] = ACTIONS(2967),
    [sym_rune_literal] = ACTIONS(2967),
    [anon_sym_SQUOTE] = ACTIONS(2967),
    [anon_sym_DQUOTE] = ACTIONS(2967),
    [anon_sym_c_SQUOTE] = ACTIONS(2967),
    [anon_sym_c_DQUOTE] = ACTIONS(2967),
    [anon_sym_r_SQUOTE] = ACTIONS(2967),
    [anon_sym_r_DQUOTE] = ACTIONS(2967),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2967),
    [anon_sym_shared] = ACTIONS(2967),
    [anon_sym_map_LBRACK] = ACTIONS(2967),
    [anon_sym_chan] = ACTIONS(2967),
    [anon_sym_thread] = ACTIONS(2967),
    [anon_sym_atomic] = ACTIONS(2967),
    [anon_sym_assert] = ACTIONS(2967),
    [anon_sym_defer] = ACTIONS(2967),
    [anon_sym_goto] = ACTIONS(2967),
    [anon_sym_break] = ACTIONS(2967),
    [anon_sym_continue] = ACTIONS(2967),
    [anon_sym_return] = ACTIONS(2967),
    [anon_sym_DOLLARfor] = ACTIONS(2967),
    [anon_sym_for] = ACTIONS(2967),
    [anon_sym_POUND] = ACTIONS(2967),
    [anon_sym_asm] = ACTIONS(2967),
  },
  [1316] = {
    [sym_line_comment] = STATE(1316),
    [sym_block_comment] = STATE(1316),
    [sym_identifier] = ACTIONS(3065),
    [anon_sym_LF] = ACTIONS(3065),
    [anon_sym_CR] = ACTIONS(3065),
    [anon_sym_CR_LF] = ACTIONS(3065),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym_DOT] = ACTIONS(3065),
    [anon_sym_as] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_COMMA] = ACTIONS(3065),
    [anon_sym_RBRACE] = ACTIONS(3065),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_fn] = ACTIONS(3065),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_SLASH] = ACTIONS(3065),
    [anon_sym_PERCENT] = ACTIONS(3065),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_GT] = ACTIONS(3065),
    [anon_sym_EQ_EQ] = ACTIONS(3065),
    [anon_sym_BANG_EQ] = ACTIONS(3065),
    [anon_sym_LT_EQ] = ACTIONS(3065),
    [anon_sym_GT_EQ] = ACTIONS(3065),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3065),
    [anon_sym_mut] = ACTIONS(3065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_QMARK] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_go] = ACTIONS(3065),
    [anon_sym_spawn] = ACTIONS(3065),
    [anon_sym_json_DOTdecode] = ACTIONS(3065),
    [anon_sym_PIPE] = ACTIONS(3065),
    [anon_sym_LBRACK2] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_CARET] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3065),
    [anon_sym_LT_DASH] = ACTIONS(3065),
    [anon_sym_LT_LT] = ACTIONS(3065),
    [anon_sym_GT_GT] = ACTIONS(3065),
    [anon_sym_GT_GT_GT] = ACTIONS(3065),
    [anon_sym_AMP_CARET] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_PIPE_PIPE] = ACTIONS(3065),
    [anon_sym_or] = ACTIONS(3065),
    [sym_none] = ACTIONS(3065),
    [sym_true] = ACTIONS(3065),
    [sym_false] = ACTIONS(3065),
    [sym_nil] = ACTIONS(3065),
    [anon_sym_QMARK_DOT] = ACTIONS(3065),
    [anon_sym_POUND_LBRACK] = ACTIONS(3065),
    [anon_sym_if] = ACTIONS(3065),
    [anon_sym_DOLLARif] = ACTIONS(3065),
    [anon_sym_is] = ACTIONS(3065),
    [anon_sym_BANGis] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3065),
    [anon_sym_BANGin] = ACTIONS(3065),
    [anon_sym_match] = ACTIONS(3065),
    [anon_sym_select] = ACTIONS(3065),
    [anon_sym_lock] = ACTIONS(3065),
    [anon_sym_rlock] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(3065),
    [anon_sym_sql] = ACTIONS(3065),
    [sym_int_literal] = ACTIONS(3065),
    [sym_float_literal] = ACTIONS(3065),
    [sym_rune_literal] = ACTIONS(3065),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [anon_sym_c_SQUOTE] = ACTIONS(3065),
    [anon_sym_c_DQUOTE] = ACTIONS(3065),
    [anon_sym_r_SQUOTE] = ACTIONS(3065),
    [anon_sym_r_DQUOTE] = ACTIONS(3065),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3065),
    [anon_sym_shared] = ACTIONS(3065),
    [anon_sym_map_LBRACK] = ACTIONS(3065),
    [anon_sym_chan] = ACTIONS(3065),
    [anon_sym_thread] = ACTIONS(3065),
    [anon_sym_atomic] = ACTIONS(3065),
    [anon_sym_assert] = ACTIONS(3065),
    [anon_sym_defer] = ACTIONS(3065),
    [anon_sym_goto] = ACTIONS(3065),
    [anon_sym_break] = ACTIONS(3065),
    [anon_sym_continue] = ACTIONS(3065),
    [anon_sym_return] = ACTIONS(3065),
    [anon_sym_DOLLARfor] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3065),
    [anon_sym_POUND] = ACTIONS(3065),
    [anon_sym_asm] = ACTIONS(3065),
  },
  [1317] = {
    [sym_line_comment] = STATE(1317),
    [sym_block_comment] = STATE(1317),
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_LF] = ACTIONS(3045),
    [anon_sym_CR] = ACTIONS(3045),
    [anon_sym_CR_LF] = ACTIONS(3045),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3045),
    [anon_sym_DOT] = ACTIONS(3045),
    [anon_sym_as] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3045),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_RBRACE] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3045),
    [anon_sym_fn] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3045),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_PERCENT] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_GT] = ACTIONS(3045),
    [anon_sym_EQ_EQ] = ACTIONS(3045),
    [anon_sym_BANG_EQ] = ACTIONS(3045),
    [anon_sym_LT_EQ] = ACTIONS(3045),
    [anon_sym_GT_EQ] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_struct] = ACTIONS(3045),
    [anon_sym_mut] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3045),
    [anon_sym_go] = ACTIONS(3045),
    [anon_sym_spawn] = ACTIONS(3045),
    [anon_sym_json_DOTdecode] = ACTIONS(3045),
    [anon_sym_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACK2] = ACTIONS(3045),
    [anon_sym_TILDE] = ACTIONS(3045),
    [anon_sym_CARET] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3045),
    [anon_sym_LT_DASH] = ACTIONS(3045),
    [anon_sym_LT_LT] = ACTIONS(3045),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_GT_GT_GT] = ACTIONS(3045),
    [anon_sym_AMP_CARET] = ACTIONS(3045),
    [anon_sym_AMP_AMP] = ACTIONS(3045),
    [anon_sym_PIPE_PIPE] = ACTIONS(3045),
    [anon_sym_or] = ACTIONS(3045),
    [sym_none] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_nil] = ACTIONS(3045),
    [anon_sym_QMARK_DOT] = ACTIONS(3045),
    [anon_sym_POUND_LBRACK] = ACTIONS(3045),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_DOLLARif] = ACTIONS(3045),
    [anon_sym_is] = ACTIONS(3045),
    [anon_sym_BANGis] = ACTIONS(3045),
    [anon_sym_in] = ACTIONS(3045),
    [anon_sym_BANGin] = ACTIONS(3045),
    [anon_sym_match] = ACTIONS(3045),
    [anon_sym_select] = ACTIONS(3045),
    [anon_sym_lock] = ACTIONS(3045),
    [anon_sym_rlock] = ACTIONS(3045),
    [anon_sym_unsafe] = ACTIONS(3045),
    [anon_sym_sql] = ACTIONS(3045),
    [sym_int_literal] = ACTIONS(3045),
    [sym_float_literal] = ACTIONS(3045),
    [sym_rune_literal] = ACTIONS(3045),
    [anon_sym_SQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE] = ACTIONS(3045),
    [anon_sym_c_SQUOTE] = ACTIONS(3045),
    [anon_sym_c_DQUOTE] = ACTIONS(3045),
    [anon_sym_r_SQUOTE] = ACTIONS(3045),
    [anon_sym_r_DQUOTE] = ACTIONS(3045),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3045),
    [anon_sym_shared] = ACTIONS(3045),
    [anon_sym_map_LBRACK] = ACTIONS(3045),
    [anon_sym_chan] = ACTIONS(3045),
    [anon_sym_thread] = ACTIONS(3045),
    [anon_sym_atomic] = ACTIONS(3045),
    [anon_sym_assert] = ACTIONS(3045),
    [anon_sym_defer] = ACTIONS(3045),
    [anon_sym_goto] = ACTIONS(3045),
    [anon_sym_break] = ACTIONS(3045),
    [anon_sym_continue] = ACTIONS(3045),
    [anon_sym_return] = ACTIONS(3045),
    [anon_sym_DOLLARfor] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3045),
    [anon_sym_POUND] = ACTIONS(3045),
    [anon_sym_asm] = ACTIONS(3045),
  },
  [1318] = {
    [sym_line_comment] = STATE(1318),
    [sym_block_comment] = STATE(1318),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_LF] = ACTIONS(2837),
    [anon_sym_CR] = ACTIONS(2837),
    [anon_sym_CR_LF] = ACTIONS(2837),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2837),
    [anon_sym_DOT] = ACTIONS(2837),
    [anon_sym_as] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(2335),
    [anon_sym_RBRACE] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2837),
    [anon_sym_fn] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2837),
    [anon_sym_DASH] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2837),
    [anon_sym_SLASH] = ACTIONS(2837),
    [anon_sym_PERCENT] = ACTIONS(2837),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(2837),
    [anon_sym_BANG_EQ] = ACTIONS(2837),
    [anon_sym_LT_EQ] = ACTIONS(2837),
    [anon_sym_GT_EQ] = ACTIONS(2837),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_struct] = ACTIONS(2837),
    [anon_sym_mut] = ACTIONS(2837),
    [anon_sym_PLUS_PLUS] = ACTIONS(2837),
    [anon_sym_DASH_DASH] = ACTIONS(2837),
    [anon_sym_QMARK] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(2837),
    [anon_sym_go] = ACTIONS(2837),
    [anon_sym_spawn] = ACTIONS(2837),
    [anon_sym_json_DOTdecode] = ACTIONS(2837),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_LBRACK2] = ACTIONS(2837),
    [anon_sym_TILDE] = ACTIONS(2837),
    [anon_sym_CARET] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2837),
    [anon_sym_LT_DASH] = ACTIONS(2837),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_GT_GT_GT] = ACTIONS(2837),
    [anon_sym_AMP_CARET] = ACTIONS(2837),
    [anon_sym_AMP_AMP] = ACTIONS(2837),
    [anon_sym_PIPE_PIPE] = ACTIONS(2837),
    [anon_sym_or] = ACTIONS(2837),
    [sym_none] = ACTIONS(2837),
    [sym_true] = ACTIONS(2837),
    [sym_false] = ACTIONS(2837),
    [sym_nil] = ACTIONS(2837),
    [anon_sym_QMARK_DOT] = ACTIONS(2837),
    [anon_sym_POUND_LBRACK] = ACTIONS(2837),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_DOLLARif] = ACTIONS(2837),
    [anon_sym_is] = ACTIONS(2837),
    [anon_sym_BANGis] = ACTIONS(2837),
    [anon_sym_in] = ACTIONS(2837),
    [anon_sym_BANGin] = ACTIONS(2837),
    [anon_sym_match] = ACTIONS(2837),
    [anon_sym_select] = ACTIONS(2837),
    [anon_sym_lock] = ACTIONS(2837),
    [anon_sym_rlock] = ACTIONS(2837),
    [anon_sym_unsafe] = ACTIONS(2837),
    [anon_sym_sql] = ACTIONS(2837),
    [sym_int_literal] = ACTIONS(2837),
    [sym_float_literal] = ACTIONS(2837),
    [sym_rune_literal] = ACTIONS(2837),
    [anon_sym_SQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE] = ACTIONS(2837),
    [anon_sym_c_SQUOTE] = ACTIONS(2837),
    [anon_sym_c_DQUOTE] = ACTIONS(2837),
    [anon_sym_r_SQUOTE] = ACTIONS(2837),
    [anon_sym_r_DQUOTE] = ACTIONS(2837),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2837),
    [anon_sym_shared] = ACTIONS(2837),
    [anon_sym_map_LBRACK] = ACTIONS(2837),
    [anon_sym_chan] = ACTIONS(2837),
    [anon_sym_thread] = ACTIONS(2837),
    [anon_sym_atomic] = ACTIONS(2837),
    [anon_sym_assert] = ACTIONS(2837),
    [anon_sym_defer] = ACTIONS(2837),
    [anon_sym_goto] = ACTIONS(2837),
    [anon_sym_break] = ACTIONS(2837),
    [anon_sym_continue] = ACTIONS(2837),
    [anon_sym_return] = ACTIONS(2837),
    [anon_sym_DOLLARfor] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2837),
    [anon_sym_POUND] = ACTIONS(2837),
    [anon_sym_asm] = ACTIONS(2837),
  },
  [1319] = {
    [sym_line_comment] = STATE(1319),
    [sym_block_comment] = STATE(1319),
    [sym_identifier] = ACTIONS(3069),
    [anon_sym_LF] = ACTIONS(3069),
    [anon_sym_CR] = ACTIONS(3069),
    [anon_sym_CR_LF] = ACTIONS(3069),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3069),
    [anon_sym_DOT] = ACTIONS(3069),
    [anon_sym_as] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3069),
    [anon_sym_COMMA] = ACTIONS(3069),
    [anon_sym_RBRACE] = ACTIONS(3069),
    [anon_sym_LPAREN] = ACTIONS(3069),
    [anon_sym_fn] = ACTIONS(3069),
    [anon_sym_PLUS] = ACTIONS(3069),
    [anon_sym_DASH] = ACTIONS(3069),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_SLASH] = ACTIONS(3069),
    [anon_sym_PERCENT] = ACTIONS(3069),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_GT] = ACTIONS(3069),
    [anon_sym_EQ_EQ] = ACTIONS(3069),
    [anon_sym_BANG_EQ] = ACTIONS(3069),
    [anon_sym_LT_EQ] = ACTIONS(3069),
    [anon_sym_GT_EQ] = ACTIONS(3069),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_struct] = ACTIONS(3069),
    [anon_sym_mut] = ACTIONS(3069),
    [anon_sym_PLUS_PLUS] = ACTIONS(3069),
    [anon_sym_DASH_DASH] = ACTIONS(3069),
    [anon_sym_QMARK] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(3069),
    [anon_sym_go] = ACTIONS(3069),
    [anon_sym_spawn] = ACTIONS(3069),
    [anon_sym_json_DOTdecode] = ACTIONS(3069),
    [anon_sym_PIPE] = ACTIONS(3069),
    [anon_sym_LBRACK2] = ACTIONS(3069),
    [anon_sym_TILDE] = ACTIONS(3069),
    [anon_sym_CARET] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3069),
    [anon_sym_LT_DASH] = ACTIONS(3069),
    [anon_sym_LT_LT] = ACTIONS(3069),
    [anon_sym_GT_GT] = ACTIONS(3069),
    [anon_sym_GT_GT_GT] = ACTIONS(3069),
    [anon_sym_AMP_CARET] = ACTIONS(3069),
    [anon_sym_AMP_AMP] = ACTIONS(3069),
    [anon_sym_PIPE_PIPE] = ACTIONS(3069),
    [anon_sym_or] = ACTIONS(3069),
    [sym_none] = ACTIONS(3069),
    [sym_true] = ACTIONS(3069),
    [sym_false] = ACTIONS(3069),
    [sym_nil] = ACTIONS(3069),
    [anon_sym_QMARK_DOT] = ACTIONS(3069),
    [anon_sym_POUND_LBRACK] = ACTIONS(3069),
    [anon_sym_if] = ACTIONS(3069),
    [anon_sym_DOLLARif] = ACTIONS(3069),
    [anon_sym_is] = ACTIONS(3069),
    [anon_sym_BANGis] = ACTIONS(3069),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_BANGin] = ACTIONS(3069),
    [anon_sym_match] = ACTIONS(3069),
    [anon_sym_select] = ACTIONS(3069),
    [anon_sym_lock] = ACTIONS(3069),
    [anon_sym_rlock] = ACTIONS(3069),
    [anon_sym_unsafe] = ACTIONS(3069),
    [anon_sym_sql] = ACTIONS(3069),
    [sym_int_literal] = ACTIONS(3069),
    [sym_float_literal] = ACTIONS(3069),
    [sym_rune_literal] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE] = ACTIONS(3069),
    [anon_sym_c_SQUOTE] = ACTIONS(3069),
    [anon_sym_c_DQUOTE] = ACTIONS(3069),
    [anon_sym_r_SQUOTE] = ACTIONS(3069),
    [anon_sym_r_DQUOTE] = ACTIONS(3069),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3069),
    [anon_sym_shared] = ACTIONS(3069),
    [anon_sym_map_LBRACK] = ACTIONS(3069),
    [anon_sym_chan] = ACTIONS(3069),
    [anon_sym_thread] = ACTIONS(3069),
    [anon_sym_atomic] = ACTIONS(3069),
    [anon_sym_assert] = ACTIONS(3069),
    [anon_sym_defer] = ACTIONS(3069),
    [anon_sym_goto] = ACTIONS(3069),
    [anon_sym_break] = ACTIONS(3069),
    [anon_sym_continue] = ACTIONS(3069),
    [anon_sym_return] = ACTIONS(3069),
    [anon_sym_DOLLARfor] = ACTIONS(3069),
    [anon_sym_for] = ACTIONS(3069),
    [anon_sym_POUND] = ACTIONS(3069),
    [anon_sym_asm] = ACTIONS(3069),
  },
  [1320] = {
    [sym_line_comment] = STATE(1320),
    [sym_block_comment] = STATE(1320),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_LF] = ACTIONS(2401),
    [anon_sym_CR] = ACTIONS(2401),
    [anon_sym_CR_LF] = ACTIONS(2401),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2401),
    [anon_sym_DOT] = ACTIONS(2401),
    [anon_sym_as] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(2401),
    [anon_sym_COMMA] = ACTIONS(2401),
    [anon_sym_RBRACE] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2401),
    [anon_sym_fn] = ACTIONS(2401),
    [anon_sym_PLUS] = ACTIONS(2401),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_STAR] = ACTIONS(2401),
    [anon_sym_SLASH] = ACTIONS(2401),
    [anon_sym_PERCENT] = ACTIONS(2401),
    [anon_sym_LT] = ACTIONS(2401),
    [anon_sym_GT] = ACTIONS(2401),
    [anon_sym_EQ_EQ] = ACTIONS(2401),
    [anon_sym_BANG_EQ] = ACTIONS(2401),
    [anon_sym_LT_EQ] = ACTIONS(2401),
    [anon_sym_GT_EQ] = ACTIONS(2401),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_struct] = ACTIONS(2401),
    [anon_sym_mut] = ACTIONS(2401),
    [anon_sym_PLUS_PLUS] = ACTIONS(2401),
    [anon_sym_DASH_DASH] = ACTIONS(2401),
    [anon_sym_QMARK] = ACTIONS(2401),
    [anon_sym_BANG] = ACTIONS(2401),
    [anon_sym_go] = ACTIONS(2401),
    [anon_sym_spawn] = ACTIONS(2401),
    [anon_sym_json_DOTdecode] = ACTIONS(2401),
    [anon_sym_PIPE] = ACTIONS(2401),
    [anon_sym_LBRACK2] = ACTIONS(2401),
    [anon_sym_TILDE] = ACTIONS(2401),
    [anon_sym_CARET] = ACTIONS(2401),
    [anon_sym_AMP] = ACTIONS(2401),
    [anon_sym_LT_DASH] = ACTIONS(2401),
    [anon_sym_LT_LT] = ACTIONS(2401),
    [anon_sym_GT_GT] = ACTIONS(2401),
    [anon_sym_GT_GT_GT] = ACTIONS(2401),
    [anon_sym_AMP_CARET] = ACTIONS(2401),
    [anon_sym_AMP_AMP] = ACTIONS(2401),
    [anon_sym_PIPE_PIPE] = ACTIONS(2401),
    [anon_sym_or] = ACTIONS(2401),
    [sym_none] = ACTIONS(2401),
    [sym_true] = ACTIONS(2401),
    [sym_false] = ACTIONS(2401),
    [sym_nil] = ACTIONS(2401),
    [anon_sym_QMARK_DOT] = ACTIONS(2401),
    [anon_sym_POUND_LBRACK] = ACTIONS(2401),
    [anon_sym_if] = ACTIONS(2401),
    [anon_sym_DOLLARif] = ACTIONS(2401),
    [anon_sym_is] = ACTIONS(2401),
    [anon_sym_BANGis] = ACTIONS(2401),
    [anon_sym_in] = ACTIONS(2401),
    [anon_sym_BANGin] = ACTIONS(2401),
    [anon_sym_match] = ACTIONS(2401),
    [anon_sym_select] = ACTIONS(2401),
    [anon_sym_lock] = ACTIONS(2401),
    [anon_sym_rlock] = ACTIONS(2401),
    [anon_sym_unsafe] = ACTIONS(2401),
    [anon_sym_sql] = ACTIONS(2401),
    [sym_int_literal] = ACTIONS(2401),
    [sym_float_literal] = ACTIONS(2401),
    [sym_rune_literal] = ACTIONS(2401),
    [anon_sym_SQUOTE] = ACTIONS(2401),
    [anon_sym_DQUOTE] = ACTIONS(2401),
    [anon_sym_c_SQUOTE] = ACTIONS(2401),
    [anon_sym_c_DQUOTE] = ACTIONS(2401),
    [anon_sym_r_SQUOTE] = ACTIONS(2401),
    [anon_sym_r_DQUOTE] = ACTIONS(2401),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2401),
    [anon_sym_shared] = ACTIONS(2401),
    [anon_sym_map_LBRACK] = ACTIONS(2401),
    [anon_sym_chan] = ACTIONS(2401),
    [anon_sym_thread] = ACTIONS(2401),
    [anon_sym_atomic] = ACTIONS(2401),
    [anon_sym_assert] = ACTIONS(2401),
    [anon_sym_defer] = ACTIONS(2401),
    [anon_sym_goto] = ACTIONS(2401),
    [anon_sym_break] = ACTIONS(2401),
    [anon_sym_continue] = ACTIONS(2401),
    [anon_sym_return] = ACTIONS(2401),
    [anon_sym_DOLLARfor] = ACTIONS(2401),
    [anon_sym_for] = ACTIONS(2401),
    [anon_sym_POUND] = ACTIONS(2401),
    [anon_sym_asm] = ACTIONS(2401),
  },
  [1321] = {
    [sym_line_comment] = STATE(1321),
    [sym_block_comment] = STATE(1321),
    [sym_identifier] = ACTIONS(3328),
    [anon_sym_LF] = ACTIONS(3328),
    [anon_sym_CR] = ACTIONS(3328),
    [anon_sym_CR_LF] = ACTIONS(3328),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3328),
    [anon_sym_DOT] = ACTIONS(3328),
    [anon_sym_as] = ACTIONS(3328),
    [anon_sym_LBRACE] = ACTIONS(3328),
    [anon_sym_COMMA] = ACTIONS(3328),
    [anon_sym_RBRACE] = ACTIONS(3328),
    [anon_sym_LPAREN] = ACTIONS(3328),
    [anon_sym_fn] = ACTIONS(3328),
    [anon_sym_PLUS] = ACTIONS(3328),
    [anon_sym_DASH] = ACTIONS(3328),
    [anon_sym_STAR] = ACTIONS(3328),
    [anon_sym_SLASH] = ACTIONS(3328),
    [anon_sym_PERCENT] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(3328),
    [anon_sym_GT] = ACTIONS(3328),
    [anon_sym_EQ_EQ] = ACTIONS(3328),
    [anon_sym_BANG_EQ] = ACTIONS(3328),
    [anon_sym_LT_EQ] = ACTIONS(3328),
    [anon_sym_GT_EQ] = ACTIONS(3328),
    [anon_sym_LBRACK] = ACTIONS(3326),
    [anon_sym_struct] = ACTIONS(3328),
    [anon_sym_mut] = ACTIONS(3328),
    [anon_sym_PLUS_PLUS] = ACTIONS(3328),
    [anon_sym_DASH_DASH] = ACTIONS(3328),
    [anon_sym_QMARK] = ACTIONS(3328),
    [anon_sym_BANG] = ACTIONS(3328),
    [anon_sym_go] = ACTIONS(3328),
    [anon_sym_spawn] = ACTIONS(3328),
    [anon_sym_json_DOTdecode] = ACTIONS(3328),
    [anon_sym_PIPE] = ACTIONS(3328),
    [anon_sym_LBRACK2] = ACTIONS(3328),
    [anon_sym_TILDE] = ACTIONS(3328),
    [anon_sym_CARET] = ACTIONS(3328),
    [anon_sym_AMP] = ACTIONS(3328),
    [anon_sym_LT_DASH] = ACTIONS(3328),
    [anon_sym_LT_LT] = ACTIONS(3328),
    [anon_sym_GT_GT] = ACTIONS(3328),
    [anon_sym_GT_GT_GT] = ACTIONS(3328),
    [anon_sym_AMP_CARET] = ACTIONS(3328),
    [anon_sym_AMP_AMP] = ACTIONS(3328),
    [anon_sym_PIPE_PIPE] = ACTIONS(3328),
    [anon_sym_or] = ACTIONS(3328),
    [sym_none] = ACTIONS(3328),
    [sym_true] = ACTIONS(3328),
    [sym_false] = ACTIONS(3328),
    [sym_nil] = ACTIONS(3328),
    [anon_sym_QMARK_DOT] = ACTIONS(3328),
    [anon_sym_POUND_LBRACK] = ACTIONS(3328),
    [anon_sym_if] = ACTIONS(3328),
    [anon_sym_DOLLARif] = ACTIONS(3328),
    [anon_sym_is] = ACTIONS(3328),
    [anon_sym_BANGis] = ACTIONS(3328),
    [anon_sym_in] = ACTIONS(3328),
    [anon_sym_BANGin] = ACTIONS(3328),
    [anon_sym_match] = ACTIONS(3328),
    [anon_sym_select] = ACTIONS(3328),
    [anon_sym_lock] = ACTIONS(3328),
    [anon_sym_rlock] = ACTIONS(3328),
    [anon_sym_unsafe] = ACTIONS(3328),
    [anon_sym_sql] = ACTIONS(3328),
    [sym_int_literal] = ACTIONS(3328),
    [sym_float_literal] = ACTIONS(3328),
    [sym_rune_literal] = ACTIONS(3328),
    [anon_sym_SQUOTE] = ACTIONS(3328),
    [anon_sym_DQUOTE] = ACTIONS(3328),
    [anon_sym_c_SQUOTE] = ACTIONS(3328),
    [anon_sym_c_DQUOTE] = ACTIONS(3328),
    [anon_sym_r_SQUOTE] = ACTIONS(3328),
    [anon_sym_r_DQUOTE] = ACTIONS(3328),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3328),
    [anon_sym_shared] = ACTIONS(3328),
    [anon_sym_map_LBRACK] = ACTIONS(3328),
    [anon_sym_chan] = ACTIONS(3328),
    [anon_sym_thread] = ACTIONS(3328),
    [anon_sym_atomic] = ACTIONS(3328),
    [anon_sym_assert] = ACTIONS(3328),
    [anon_sym_defer] = ACTIONS(3328),
    [anon_sym_goto] = ACTIONS(3328),
    [anon_sym_break] = ACTIONS(3328),
    [anon_sym_continue] = ACTIONS(3328),
    [anon_sym_return] = ACTIONS(3328),
    [anon_sym_DOLLARfor] = ACTIONS(3328),
    [anon_sym_for] = ACTIONS(3328),
    [anon_sym_POUND] = ACTIONS(3328),
    [anon_sym_asm] = ACTIONS(3328),
  },
  [1322] = {
    [sym_line_comment] = STATE(1322),
    [sym_block_comment] = STATE(1322),
    [sym_identifier] = ACTIONS(3001),
    [anon_sym_LF] = ACTIONS(3001),
    [anon_sym_CR] = ACTIONS(3001),
    [anon_sym_CR_LF] = ACTIONS(3001),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3001),
    [anon_sym_DOT] = ACTIONS(3001),
    [anon_sym_as] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_COMMA] = ACTIONS(3001),
    [anon_sym_RBRACE] = ACTIONS(3001),
    [anon_sym_LPAREN] = ACTIONS(3001),
    [anon_sym_fn] = ACTIONS(3001),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_STAR] = ACTIONS(3001),
    [anon_sym_SLASH] = ACTIONS(3001),
    [anon_sym_PERCENT] = ACTIONS(3001),
    [anon_sym_LT] = ACTIONS(3001),
    [anon_sym_GT] = ACTIONS(3001),
    [anon_sym_EQ_EQ] = ACTIONS(3001),
    [anon_sym_BANG_EQ] = ACTIONS(3001),
    [anon_sym_LT_EQ] = ACTIONS(3001),
    [anon_sym_GT_EQ] = ACTIONS(3001),
    [anon_sym_LBRACK] = ACTIONS(2999),
    [anon_sym_struct] = ACTIONS(3001),
    [anon_sym_mut] = ACTIONS(3001),
    [anon_sym_PLUS_PLUS] = ACTIONS(3001),
    [anon_sym_DASH_DASH] = ACTIONS(3001),
    [anon_sym_QMARK] = ACTIONS(3001),
    [anon_sym_BANG] = ACTIONS(3001),
    [anon_sym_go] = ACTIONS(3001),
    [anon_sym_spawn] = ACTIONS(3001),
    [anon_sym_json_DOTdecode] = ACTIONS(3001),
    [anon_sym_PIPE] = ACTIONS(3001),
    [anon_sym_LBRACK2] = ACTIONS(3001),
    [anon_sym_TILDE] = ACTIONS(3001),
    [anon_sym_CARET] = ACTIONS(3001),
    [anon_sym_AMP] = ACTIONS(3001),
    [anon_sym_LT_DASH] = ACTIONS(3001),
    [anon_sym_LT_LT] = ACTIONS(3001),
    [anon_sym_GT_GT] = ACTIONS(3001),
    [anon_sym_GT_GT_GT] = ACTIONS(3001),
    [anon_sym_AMP_CARET] = ACTIONS(3001),
    [anon_sym_AMP_AMP] = ACTIONS(3001),
    [anon_sym_PIPE_PIPE] = ACTIONS(3001),
    [anon_sym_or] = ACTIONS(3001),
    [sym_none] = ACTIONS(3001),
    [sym_true] = ACTIONS(3001),
    [sym_false] = ACTIONS(3001),
    [sym_nil] = ACTIONS(3001),
    [anon_sym_QMARK_DOT] = ACTIONS(3001),
    [anon_sym_POUND_LBRACK] = ACTIONS(3001),
    [anon_sym_if] = ACTIONS(3001),
    [anon_sym_DOLLARif] = ACTIONS(3001),
    [anon_sym_is] = ACTIONS(3001),
    [anon_sym_BANGis] = ACTIONS(3001),
    [anon_sym_in] = ACTIONS(3001),
    [anon_sym_BANGin] = ACTIONS(3001),
    [anon_sym_match] = ACTIONS(3001),
    [anon_sym_select] = ACTIONS(3001),
    [anon_sym_lock] = ACTIONS(3001),
    [anon_sym_rlock] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(3001),
    [anon_sym_sql] = ACTIONS(3001),
    [sym_int_literal] = ACTIONS(3001),
    [sym_float_literal] = ACTIONS(3001),
    [sym_rune_literal] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3001),
    [anon_sym_DQUOTE] = ACTIONS(3001),
    [anon_sym_c_SQUOTE] = ACTIONS(3001),
    [anon_sym_c_DQUOTE] = ACTIONS(3001),
    [anon_sym_r_SQUOTE] = ACTIONS(3001),
    [anon_sym_r_DQUOTE] = ACTIONS(3001),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3001),
    [anon_sym_shared] = ACTIONS(3001),
    [anon_sym_map_LBRACK] = ACTIONS(3001),
    [anon_sym_chan] = ACTIONS(3001),
    [anon_sym_thread] = ACTIONS(3001),
    [anon_sym_atomic] = ACTIONS(3001),
    [anon_sym_assert] = ACTIONS(3001),
    [anon_sym_defer] = ACTIONS(3001),
    [anon_sym_goto] = ACTIONS(3001),
    [anon_sym_break] = ACTIONS(3001),
    [anon_sym_continue] = ACTIONS(3001),
    [anon_sym_return] = ACTIONS(3001),
    [anon_sym_DOLLARfor] = ACTIONS(3001),
    [anon_sym_for] = ACTIONS(3001),
    [anon_sym_POUND] = ACTIONS(3001),
    [anon_sym_asm] = ACTIONS(3001),
  },
  [1323] = {
    [sym_line_comment] = STATE(1323),
    [sym_block_comment] = STATE(1323),
    [sym_identifier] = ACTIONS(3240),
    [anon_sym_LF] = ACTIONS(3240),
    [anon_sym_CR] = ACTIONS(3240),
    [anon_sym_CR_LF] = ACTIONS(3240),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(3240),
    [anon_sym_as] = ACTIONS(3240),
    [anon_sym_LBRACE] = ACTIONS(3240),
    [anon_sym_COMMA] = ACTIONS(3240),
    [anon_sym_RBRACE] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(3240),
    [anon_sym_fn] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3240),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [anon_sym_LT] = ACTIONS(3240),
    [anon_sym_GT] = ACTIONS(3240),
    [anon_sym_EQ_EQ] = ACTIONS(3240),
    [anon_sym_BANG_EQ] = ACTIONS(3240),
    [anon_sym_LT_EQ] = ACTIONS(3240),
    [anon_sym_GT_EQ] = ACTIONS(3240),
    [anon_sym_LBRACK] = ACTIONS(3238),
    [anon_sym_struct] = ACTIONS(3240),
    [anon_sym_mut] = ACTIONS(3240),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_QMARK] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_go] = ACTIONS(3240),
    [anon_sym_spawn] = ACTIONS(3240),
    [anon_sym_json_DOTdecode] = ACTIONS(3240),
    [anon_sym_PIPE] = ACTIONS(3240),
    [anon_sym_LBRACK2] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [anon_sym_CARET] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_LT_DASH] = ACTIONS(3240),
    [anon_sym_LT_LT] = ACTIONS(3240),
    [anon_sym_GT_GT] = ACTIONS(3240),
    [anon_sym_GT_GT_GT] = ACTIONS(3240),
    [anon_sym_AMP_CARET] = ACTIONS(3240),
    [anon_sym_AMP_AMP] = ACTIONS(3240),
    [anon_sym_PIPE_PIPE] = ACTIONS(3240),
    [anon_sym_or] = ACTIONS(3240),
    [sym_none] = ACTIONS(3240),
    [sym_true] = ACTIONS(3240),
    [sym_false] = ACTIONS(3240),
    [sym_nil] = ACTIONS(3240),
    [anon_sym_QMARK_DOT] = ACTIONS(3240),
    [anon_sym_POUND_LBRACK] = ACTIONS(3240),
    [anon_sym_if] = ACTIONS(3240),
    [anon_sym_DOLLARif] = ACTIONS(3240),
    [anon_sym_is] = ACTIONS(3240),
    [anon_sym_BANGis] = ACTIONS(3240),
    [anon_sym_in] = ACTIONS(3240),
    [anon_sym_BANGin] = ACTIONS(3240),
    [anon_sym_match] = ACTIONS(3240),
    [anon_sym_select] = ACTIONS(3240),
    [anon_sym_lock] = ACTIONS(3240),
    [anon_sym_rlock] = ACTIONS(3240),
    [anon_sym_unsafe] = ACTIONS(3240),
    [anon_sym_sql] = ACTIONS(3240),
    [sym_int_literal] = ACTIONS(3240),
    [sym_float_literal] = ACTIONS(3240),
    [sym_rune_literal] = ACTIONS(3240),
    [anon_sym_SQUOTE] = ACTIONS(3240),
    [anon_sym_DQUOTE] = ACTIONS(3240),
    [anon_sym_c_SQUOTE] = ACTIONS(3240),
    [anon_sym_c_DQUOTE] = ACTIONS(3240),
    [anon_sym_r_SQUOTE] = ACTIONS(3240),
    [anon_sym_r_DQUOTE] = ACTIONS(3240),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3240),
    [anon_sym_shared] = ACTIONS(3240),
    [anon_sym_map_LBRACK] = ACTIONS(3240),
    [anon_sym_chan] = ACTIONS(3240),
    [anon_sym_thread] = ACTIONS(3240),
    [anon_sym_atomic] = ACTIONS(3240),
    [anon_sym_assert] = ACTIONS(3240),
    [anon_sym_defer] = ACTIONS(3240),
    [anon_sym_goto] = ACTIONS(3240),
    [anon_sym_break] = ACTIONS(3240),
    [anon_sym_continue] = ACTIONS(3240),
    [anon_sym_return] = ACTIONS(3240),
    [anon_sym_DOLLARfor] = ACTIONS(3240),
    [anon_sym_for] = ACTIONS(3240),
    [anon_sym_POUND] = ACTIONS(3240),
    [anon_sym_asm] = ACTIONS(3240),
  },
  [1324] = {
    [sym_line_comment] = STATE(1324),
    [sym_block_comment] = STATE(1324),
    [sym_identifier] = ACTIONS(2187),
    [anon_sym_LF] = ACTIONS(2187),
    [anon_sym_CR] = ACTIONS(2187),
    [anon_sym_CR_LF] = ACTIONS(2187),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2187),
    [anon_sym_DOT] = ACTIONS(2187),
    [anon_sym_as] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_RBRACE] = ACTIONS(2187),
    [anon_sym_LPAREN] = ACTIONS(2187),
    [anon_sym_fn] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [anon_sym_LT] = ACTIONS(2187),
    [anon_sym_GT] = ACTIONS(2187),
    [anon_sym_EQ_EQ] = ACTIONS(2187),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2187),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2185),
    [anon_sym_struct] = ACTIONS(2187),
    [anon_sym_mut] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_go] = ACTIONS(2187),
    [anon_sym_spawn] = ACTIONS(2187),
    [anon_sym_json_DOTdecode] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2187),
    [anon_sym_LBRACK2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_LT_DASH] = ACTIONS(2187),
    [anon_sym_LT_LT] = ACTIONS(2187),
    [anon_sym_GT_GT] = ACTIONS(2187),
    [anon_sym_GT_GT_GT] = ACTIONS(2187),
    [anon_sym_AMP_CARET] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2187),
    [sym_none] = ACTIONS(2187),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [sym_nil] = ACTIONS(2187),
    [anon_sym_QMARK_DOT] = ACTIONS(2187),
    [anon_sym_POUND_LBRACK] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_DOLLARif] = ACTIONS(2187),
    [anon_sym_is] = ACTIONS(2187),
    [anon_sym_BANGis] = ACTIONS(2187),
    [anon_sym_in] = ACTIONS(2187),
    [anon_sym_BANGin] = ACTIONS(2187),
    [anon_sym_match] = ACTIONS(2187),
    [anon_sym_select] = ACTIONS(2187),
    [anon_sym_lock] = ACTIONS(2187),
    [anon_sym_rlock] = ACTIONS(2187),
    [anon_sym_unsafe] = ACTIONS(2187),
    [anon_sym_sql] = ACTIONS(2187),
    [sym_int_literal] = ACTIONS(2187),
    [sym_float_literal] = ACTIONS(2187),
    [sym_rune_literal] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(2187),
    [anon_sym_DQUOTE] = ACTIONS(2187),
    [anon_sym_c_SQUOTE] = ACTIONS(2187),
    [anon_sym_c_DQUOTE] = ACTIONS(2187),
    [anon_sym_r_SQUOTE] = ACTIONS(2187),
    [anon_sym_r_DQUOTE] = ACTIONS(2187),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2187),
    [anon_sym_shared] = ACTIONS(2187),
    [anon_sym_map_LBRACK] = ACTIONS(2187),
    [anon_sym_chan] = ACTIONS(2187),
    [anon_sym_thread] = ACTIONS(2187),
    [anon_sym_atomic] = ACTIONS(2187),
    [anon_sym_assert] = ACTIONS(2187),
    [anon_sym_defer] = ACTIONS(2187),
    [anon_sym_goto] = ACTIONS(2187),
    [anon_sym_break] = ACTIONS(2187),
    [anon_sym_continue] = ACTIONS(2187),
    [anon_sym_return] = ACTIONS(2187),
    [anon_sym_DOLLARfor] = ACTIONS(2187),
    [anon_sym_for] = ACTIONS(2187),
    [anon_sym_POUND] = ACTIONS(2187),
    [anon_sym_asm] = ACTIONS(2187),
  },
  [1325] = {
    [sym_line_comment] = STATE(1325),
    [sym_block_comment] = STATE(1325),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LF] = ACTIONS(2453),
    [anon_sym_CR] = ACTIONS(2453),
    [anon_sym_CR_LF] = ACTIONS(2453),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2453),
    [anon_sym_DOT] = ACTIONS(2453),
    [anon_sym_as] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [anon_sym_COMMA] = ACTIONS(2453),
    [anon_sym_RBRACE] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_fn] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2453),
    [anon_sym_SLASH] = ACTIONS(2453),
    [anon_sym_PERCENT] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2453),
    [anon_sym_EQ_EQ] = ACTIONS(2453),
    [anon_sym_BANG_EQ] = ACTIONS(2453),
    [anon_sym_LT_EQ] = ACTIONS(2453),
    [anon_sym_GT_EQ] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2451),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_mut] = ACTIONS(2453),
    [anon_sym_PLUS_PLUS] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2453),
    [anon_sym_QMARK] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(2453),
    [anon_sym_go] = ACTIONS(2453),
    [anon_sym_spawn] = ACTIONS(2453),
    [anon_sym_json_DOTdecode] = ACTIONS(2453),
    [anon_sym_PIPE] = ACTIONS(2453),
    [anon_sym_LBRACK2] = ACTIONS(2453),
    [anon_sym_TILDE] = ACTIONS(2453),
    [anon_sym_CARET] = ACTIONS(2453),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_LT_DASH] = ACTIONS(2453),
    [anon_sym_LT_LT] = ACTIONS(2453),
    [anon_sym_GT_GT] = ACTIONS(2453),
    [anon_sym_GT_GT_GT] = ACTIONS(2453),
    [anon_sym_AMP_CARET] = ACTIONS(2453),
    [anon_sym_AMP_AMP] = ACTIONS(2453),
    [anon_sym_PIPE_PIPE] = ACTIONS(2453),
    [anon_sym_or] = ACTIONS(2453),
    [sym_none] = ACTIONS(2453),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [sym_nil] = ACTIONS(2453),
    [anon_sym_QMARK_DOT] = ACTIONS(2453),
    [anon_sym_POUND_LBRACK] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_DOLLARif] = ACTIONS(2453),
    [anon_sym_is] = ACTIONS(2453),
    [anon_sym_BANGis] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_BANGin] = ACTIONS(2453),
    [anon_sym_match] = ACTIONS(2453),
    [anon_sym_select] = ACTIONS(2453),
    [anon_sym_lock] = ACTIONS(2453),
    [anon_sym_rlock] = ACTIONS(2453),
    [anon_sym_unsafe] = ACTIONS(2453),
    [anon_sym_sql] = ACTIONS(2453),
    [sym_int_literal] = ACTIONS(2453),
    [sym_float_literal] = ACTIONS(2453),
    [sym_rune_literal] = ACTIONS(2453),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2453),
    [anon_sym_c_SQUOTE] = ACTIONS(2453),
    [anon_sym_c_DQUOTE] = ACTIONS(2453),
    [anon_sym_r_SQUOTE] = ACTIONS(2453),
    [anon_sym_r_DQUOTE] = ACTIONS(2453),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_map_LBRACK] = ACTIONS(2453),
    [anon_sym_chan] = ACTIONS(2453),
    [anon_sym_thread] = ACTIONS(2453),
    [anon_sym_atomic] = ACTIONS(2453),
    [anon_sym_assert] = ACTIONS(2453),
    [anon_sym_defer] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_DOLLARfor] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_POUND] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
  },
  [1326] = {
    [sym_line_comment] = STATE(1326),
    [sym_block_comment] = STATE(1326),
    [sym_identifier] = ACTIONS(3023),
    [anon_sym_LF] = ACTIONS(3023),
    [anon_sym_CR] = ACTIONS(3023),
    [anon_sym_CR_LF] = ACTIONS(3023),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3023),
    [anon_sym_DOT] = ACTIONS(3023),
    [anon_sym_as] = ACTIONS(3023),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_COMMA] = ACTIONS(3023),
    [anon_sym_RBRACE] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_fn] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_STAR] = ACTIONS(3023),
    [anon_sym_SLASH] = ACTIONS(3023),
    [anon_sym_PERCENT] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3023),
    [anon_sym_GT] = ACTIONS(3023),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT_EQ] = ACTIONS(3023),
    [anon_sym_GT_EQ] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3021),
    [anon_sym_struct] = ACTIONS(3023),
    [anon_sym_mut] = ACTIONS(3023),
    [anon_sym_PLUS_PLUS] = ACTIONS(3023),
    [anon_sym_DASH_DASH] = ACTIONS(3023),
    [anon_sym_QMARK] = ACTIONS(3023),
    [anon_sym_BANG] = ACTIONS(3023),
    [anon_sym_go] = ACTIONS(3023),
    [anon_sym_spawn] = ACTIONS(3023),
    [anon_sym_json_DOTdecode] = ACTIONS(3023),
    [anon_sym_PIPE] = ACTIONS(3023),
    [anon_sym_LBRACK2] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3023),
    [anon_sym_CARET] = ACTIONS(3023),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_LT_DASH] = ACTIONS(3023),
    [anon_sym_LT_LT] = ACTIONS(3023),
    [anon_sym_GT_GT] = ACTIONS(3023),
    [anon_sym_GT_GT_GT] = ACTIONS(3023),
    [anon_sym_AMP_CARET] = ACTIONS(3023),
    [anon_sym_AMP_AMP] = ACTIONS(3023),
    [anon_sym_PIPE_PIPE] = ACTIONS(3023),
    [anon_sym_or] = ACTIONS(3023),
    [sym_none] = ACTIONS(3023),
    [sym_true] = ACTIONS(3023),
    [sym_false] = ACTIONS(3023),
    [sym_nil] = ACTIONS(3023),
    [anon_sym_QMARK_DOT] = ACTIONS(3023),
    [anon_sym_POUND_LBRACK] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_DOLLARif] = ACTIONS(3023),
    [anon_sym_is] = ACTIONS(3023),
    [anon_sym_BANGis] = ACTIONS(3023),
    [anon_sym_in] = ACTIONS(3023),
    [anon_sym_BANGin] = ACTIONS(3023),
    [anon_sym_match] = ACTIONS(3023),
    [anon_sym_select] = ACTIONS(3023),
    [anon_sym_lock] = ACTIONS(3023),
    [anon_sym_rlock] = ACTIONS(3023),
    [anon_sym_unsafe] = ACTIONS(3023),
    [anon_sym_sql] = ACTIONS(3023),
    [sym_int_literal] = ACTIONS(3023),
    [sym_float_literal] = ACTIONS(3023),
    [sym_rune_literal] = ACTIONS(3023),
    [anon_sym_SQUOTE] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_c_SQUOTE] = ACTIONS(3023),
    [anon_sym_c_DQUOTE] = ACTIONS(3023),
    [anon_sym_r_SQUOTE] = ACTIONS(3023),
    [anon_sym_r_DQUOTE] = ACTIONS(3023),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3023),
    [anon_sym_shared] = ACTIONS(3023),
    [anon_sym_map_LBRACK] = ACTIONS(3023),
    [anon_sym_chan] = ACTIONS(3023),
    [anon_sym_thread] = ACTIONS(3023),
    [anon_sym_atomic] = ACTIONS(3023),
    [anon_sym_assert] = ACTIONS(3023),
    [anon_sym_defer] = ACTIONS(3023),
    [anon_sym_goto] = ACTIONS(3023),
    [anon_sym_break] = ACTIONS(3023),
    [anon_sym_continue] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_DOLLARfor] = ACTIONS(3023),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_POUND] = ACTIONS(3023),
    [anon_sym_asm] = ACTIONS(3023),
  },
  [1327] = {
    [sym_line_comment] = STATE(1327),
    [sym_block_comment] = STATE(1327),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LF] = ACTIONS(2893),
    [anon_sym_CR] = ACTIONS(2893),
    [anon_sym_CR_LF] = ACTIONS(2893),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2893),
    [anon_sym_as] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_RBRACE] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2893),
    [anon_sym_fn] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_PERCENT] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_GT] = ACTIONS(2893),
    [anon_sym_EQ_EQ] = ACTIONS(2893),
    [anon_sym_BANG_EQ] = ACTIONS(2893),
    [anon_sym_LT_EQ] = ACTIONS(2893),
    [anon_sym_GT_EQ] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_mut] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2893),
    [anon_sym_DASH_DASH] = ACTIONS(2893),
    [anon_sym_QMARK] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_go] = ACTIONS(2893),
    [anon_sym_spawn] = ACTIONS(2893),
    [anon_sym_json_DOTdecode] = ACTIONS(2893),
    [anon_sym_PIPE] = ACTIONS(2893),
    [anon_sym_LBRACK2] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_LT_DASH] = ACTIONS(2893),
    [anon_sym_LT_LT] = ACTIONS(2893),
    [anon_sym_GT_GT] = ACTIONS(2893),
    [anon_sym_GT_GT_GT] = ACTIONS(2893),
    [anon_sym_AMP_CARET] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2893),
    [anon_sym_PIPE_PIPE] = ACTIONS(2893),
    [anon_sym_or] = ACTIONS(2893),
    [sym_none] = ACTIONS(2893),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [sym_nil] = ACTIONS(2893),
    [anon_sym_QMARK_DOT] = ACTIONS(2893),
    [anon_sym_POUND_LBRACK] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_DOLLARif] = ACTIONS(2893),
    [anon_sym_is] = ACTIONS(2893),
    [anon_sym_BANGis] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_BANGin] = ACTIONS(2893),
    [anon_sym_match] = ACTIONS(2893),
    [anon_sym_select] = ACTIONS(2893),
    [anon_sym_lock] = ACTIONS(2893),
    [anon_sym_rlock] = ACTIONS(2893),
    [anon_sym_unsafe] = ACTIONS(2893),
    [anon_sym_sql] = ACTIONS(2893),
    [sym_int_literal] = ACTIONS(2893),
    [sym_float_literal] = ACTIONS(2893),
    [sym_rune_literal] = ACTIONS(2893),
    [anon_sym_SQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(2893),
    [anon_sym_c_SQUOTE] = ACTIONS(2893),
    [anon_sym_c_DQUOTE] = ACTIONS(2893),
    [anon_sym_r_SQUOTE] = ACTIONS(2893),
    [anon_sym_r_DQUOTE] = ACTIONS(2893),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_map_LBRACK] = ACTIONS(2893),
    [anon_sym_chan] = ACTIONS(2893),
    [anon_sym_thread] = ACTIONS(2893),
    [anon_sym_atomic] = ACTIONS(2893),
    [anon_sym_assert] = ACTIONS(2893),
    [anon_sym_defer] = ACTIONS(2893),
    [anon_sym_goto] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_DOLLARfor] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_POUND] = ACTIONS(2893),
    [anon_sym_asm] = ACTIONS(2893),
  },
  [1328] = {
    [sym_line_comment] = STATE(1328),
    [sym_block_comment] = STATE(1328),
    [sym_identifier] = ACTIONS(3350),
    [anon_sym_LF] = ACTIONS(3350),
    [anon_sym_CR] = ACTIONS(3350),
    [anon_sym_CR_LF] = ACTIONS(3350),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(3350),
    [anon_sym_as] = ACTIONS(3350),
    [anon_sym_LBRACE] = ACTIONS(3350),
    [anon_sym_COMMA] = ACTIONS(3350),
    [anon_sym_RBRACE] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(3350),
    [anon_sym_fn] = ACTIONS(3350),
    [anon_sym_PLUS] = ACTIONS(3350),
    [anon_sym_DASH] = ACTIONS(3350),
    [anon_sym_STAR] = ACTIONS(3350),
    [anon_sym_SLASH] = ACTIONS(3350),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_LT] = ACTIONS(3350),
    [anon_sym_GT] = ACTIONS(3350),
    [anon_sym_EQ_EQ] = ACTIONS(3350),
    [anon_sym_BANG_EQ] = ACTIONS(3350),
    [anon_sym_LT_EQ] = ACTIONS(3350),
    [anon_sym_GT_EQ] = ACTIONS(3350),
    [anon_sym_LBRACK] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3350),
    [anon_sym_mut] = ACTIONS(3350),
    [anon_sym_PLUS_PLUS] = ACTIONS(3350),
    [anon_sym_DASH_DASH] = ACTIONS(3350),
    [anon_sym_QMARK] = ACTIONS(3350),
    [anon_sym_BANG] = ACTIONS(3350),
    [anon_sym_go] = ACTIONS(3350),
    [anon_sym_spawn] = ACTIONS(3350),
    [anon_sym_json_DOTdecode] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3350),
    [anon_sym_LBRACK2] = ACTIONS(3350),
    [anon_sym_TILDE] = ACTIONS(3350),
    [anon_sym_CARET] = ACTIONS(3350),
    [anon_sym_AMP] = ACTIONS(3350),
    [anon_sym_LT_DASH] = ACTIONS(3350),
    [anon_sym_LT_LT] = ACTIONS(3350),
    [anon_sym_GT_GT] = ACTIONS(3350),
    [anon_sym_GT_GT_GT] = ACTIONS(3350),
    [anon_sym_AMP_CARET] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_PIPE_PIPE] = ACTIONS(3350),
    [anon_sym_or] = ACTIONS(3350),
    [sym_none] = ACTIONS(3350),
    [sym_true] = ACTIONS(3350),
    [sym_false] = ACTIONS(3350),
    [sym_nil] = ACTIONS(3350),
    [anon_sym_QMARK_DOT] = ACTIONS(3350),
    [anon_sym_POUND_LBRACK] = ACTIONS(3350),
    [anon_sym_if] = ACTIONS(3350),
    [anon_sym_DOLLARif] = ACTIONS(3350),
    [anon_sym_is] = ACTIONS(3350),
    [anon_sym_BANGis] = ACTIONS(3350),
    [anon_sym_in] = ACTIONS(3350),
    [anon_sym_BANGin] = ACTIONS(3350),
    [anon_sym_match] = ACTIONS(3350),
    [anon_sym_select] = ACTIONS(3350),
    [anon_sym_lock] = ACTIONS(3350),
    [anon_sym_rlock] = ACTIONS(3350),
    [anon_sym_unsafe] = ACTIONS(3350),
    [anon_sym_sql] = ACTIONS(3350),
    [sym_int_literal] = ACTIONS(3350),
    [sym_float_literal] = ACTIONS(3350),
    [sym_rune_literal] = ACTIONS(3350),
    [anon_sym_SQUOTE] = ACTIONS(3350),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [anon_sym_c_SQUOTE] = ACTIONS(3350),
    [anon_sym_c_DQUOTE] = ACTIONS(3350),
    [anon_sym_r_SQUOTE] = ACTIONS(3350),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3350),
    [anon_sym_shared] = ACTIONS(3350),
    [anon_sym_map_LBRACK] = ACTIONS(3350),
    [anon_sym_chan] = ACTIONS(3350),
    [anon_sym_thread] = ACTIONS(3350),
    [anon_sym_atomic] = ACTIONS(3350),
    [anon_sym_assert] = ACTIONS(3350),
    [anon_sym_defer] = ACTIONS(3350),
    [anon_sym_goto] = ACTIONS(3350),
    [anon_sym_break] = ACTIONS(3350),
    [anon_sym_continue] = ACTIONS(3350),
    [anon_sym_return] = ACTIONS(3350),
    [anon_sym_DOLLARfor] = ACTIONS(3350),
    [anon_sym_for] = ACTIONS(3350),
    [anon_sym_POUND] = ACTIONS(3350),
    [anon_sym_asm] = ACTIONS(3350),
  },
  [1329] = {
    [sym_line_comment] = STATE(1329),
    [sym_block_comment] = STATE(1329),
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_LF] = ACTIONS(3019),
    [anon_sym_CR] = ACTIONS(3019),
    [anon_sym_CR_LF] = ACTIONS(3019),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(3019),
    [anon_sym_as] = ACTIONS(3019),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_COMMA] = ACTIONS(3019),
    [anon_sym_RBRACE] = ACTIONS(3019),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym_fn] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_STAR] = ACTIONS(3019),
    [anon_sym_SLASH] = ACTIONS(3019),
    [anon_sym_PERCENT] = ACTIONS(3019),
    [anon_sym_LT] = ACTIONS(3019),
    [anon_sym_GT] = ACTIONS(3019),
    [anon_sym_EQ_EQ] = ACTIONS(3019),
    [anon_sym_BANG_EQ] = ACTIONS(3019),
    [anon_sym_LT_EQ] = ACTIONS(3019),
    [anon_sym_GT_EQ] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3017),
    [anon_sym_struct] = ACTIONS(3019),
    [anon_sym_mut] = ACTIONS(3019),
    [anon_sym_PLUS_PLUS] = ACTIONS(3019),
    [anon_sym_DASH_DASH] = ACTIONS(3019),
    [anon_sym_QMARK] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_go] = ACTIONS(3019),
    [anon_sym_spawn] = ACTIONS(3019),
    [anon_sym_json_DOTdecode] = ACTIONS(3019),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_LBRACK2] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_LT_DASH] = ACTIONS(3019),
    [anon_sym_LT_LT] = ACTIONS(3019),
    [anon_sym_GT_GT] = ACTIONS(3019),
    [anon_sym_GT_GT_GT] = ACTIONS(3019),
    [anon_sym_AMP_CARET] = ACTIONS(3019),
    [anon_sym_AMP_AMP] = ACTIONS(3019),
    [anon_sym_PIPE_PIPE] = ACTIONS(3019),
    [anon_sym_or] = ACTIONS(3019),
    [sym_none] = ACTIONS(3019),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_nil] = ACTIONS(3019),
    [anon_sym_QMARK_DOT] = ACTIONS(3019),
    [anon_sym_POUND_LBRACK] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_DOLLARif] = ACTIONS(3019),
    [anon_sym_is] = ACTIONS(3019),
    [anon_sym_BANGis] = ACTIONS(3019),
    [anon_sym_in] = ACTIONS(3019),
    [anon_sym_BANGin] = ACTIONS(3019),
    [anon_sym_match] = ACTIONS(3019),
    [anon_sym_select] = ACTIONS(3019),
    [anon_sym_lock] = ACTIONS(3019),
    [anon_sym_rlock] = ACTIONS(3019),
    [anon_sym_unsafe] = ACTIONS(3019),
    [anon_sym_sql] = ACTIONS(3019),
    [sym_int_literal] = ACTIONS(3019),
    [sym_float_literal] = ACTIONS(3019),
    [sym_rune_literal] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_c_SQUOTE] = ACTIONS(3019),
    [anon_sym_c_DQUOTE] = ACTIONS(3019),
    [anon_sym_r_SQUOTE] = ACTIONS(3019),
    [anon_sym_r_DQUOTE] = ACTIONS(3019),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3019),
    [anon_sym_shared] = ACTIONS(3019),
    [anon_sym_map_LBRACK] = ACTIONS(3019),
    [anon_sym_chan] = ACTIONS(3019),
    [anon_sym_thread] = ACTIONS(3019),
    [anon_sym_atomic] = ACTIONS(3019),
    [anon_sym_assert] = ACTIONS(3019),
    [anon_sym_defer] = ACTIONS(3019),
    [anon_sym_goto] = ACTIONS(3019),
    [anon_sym_break] = ACTIONS(3019),
    [anon_sym_continue] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_DOLLARfor] = ACTIONS(3019),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_POUND] = ACTIONS(3019),
    [anon_sym_asm] = ACTIONS(3019),
  },
  [1330] = {
    [sym_line_comment] = STATE(1330),
    [sym_block_comment] = STATE(1330),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_LF] = ACTIONS(3015),
    [anon_sym_CR] = ACTIONS(3015),
    [anon_sym_CR_LF] = ACTIONS(3015),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3015),
    [anon_sym_DOT] = ACTIONS(3015),
    [anon_sym_as] = ACTIONS(3015),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_COMMA] = ACTIONS(3015),
    [anon_sym_RBRACE] = ACTIONS(3015),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_fn] = ACTIONS(3015),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(3015),
    [anon_sym_SLASH] = ACTIONS(3015),
    [anon_sym_PERCENT] = ACTIONS(3015),
    [anon_sym_LT] = ACTIONS(3015),
    [anon_sym_GT] = ACTIONS(3015),
    [anon_sym_EQ_EQ] = ACTIONS(3015),
    [anon_sym_BANG_EQ] = ACTIONS(3015),
    [anon_sym_LT_EQ] = ACTIONS(3015),
    [anon_sym_GT_EQ] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3013),
    [anon_sym_struct] = ACTIONS(3015),
    [anon_sym_mut] = ACTIONS(3015),
    [anon_sym_PLUS_PLUS] = ACTIONS(3015),
    [anon_sym_DASH_DASH] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_BANG] = ACTIONS(3015),
    [anon_sym_go] = ACTIONS(3015),
    [anon_sym_spawn] = ACTIONS(3015),
    [anon_sym_json_DOTdecode] = ACTIONS(3015),
    [anon_sym_PIPE] = ACTIONS(3015),
    [anon_sym_LBRACK2] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3015),
    [anon_sym_CARET] = ACTIONS(3015),
    [anon_sym_AMP] = ACTIONS(3015),
    [anon_sym_LT_DASH] = ACTIONS(3015),
    [anon_sym_LT_LT] = ACTIONS(3015),
    [anon_sym_GT_GT] = ACTIONS(3015),
    [anon_sym_GT_GT_GT] = ACTIONS(3015),
    [anon_sym_AMP_CARET] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_or] = ACTIONS(3015),
    [sym_none] = ACTIONS(3015),
    [sym_true] = ACTIONS(3015),
    [sym_false] = ACTIONS(3015),
    [sym_nil] = ACTIONS(3015),
    [anon_sym_QMARK_DOT] = ACTIONS(3015),
    [anon_sym_POUND_LBRACK] = ACTIONS(3015),
    [anon_sym_if] = ACTIONS(3015),
    [anon_sym_DOLLARif] = ACTIONS(3015),
    [anon_sym_is] = ACTIONS(3015),
    [anon_sym_BANGis] = ACTIONS(3015),
    [anon_sym_in] = ACTIONS(3015),
    [anon_sym_BANGin] = ACTIONS(3015),
    [anon_sym_match] = ACTIONS(3015),
    [anon_sym_select] = ACTIONS(3015),
    [anon_sym_lock] = ACTIONS(3015),
    [anon_sym_rlock] = ACTIONS(3015),
    [anon_sym_unsafe] = ACTIONS(3015),
    [anon_sym_sql] = ACTIONS(3015),
    [sym_int_literal] = ACTIONS(3015),
    [sym_float_literal] = ACTIONS(3015),
    [sym_rune_literal] = ACTIONS(3015),
    [anon_sym_SQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_c_SQUOTE] = ACTIONS(3015),
    [anon_sym_c_DQUOTE] = ACTIONS(3015),
    [anon_sym_r_SQUOTE] = ACTIONS(3015),
    [anon_sym_r_DQUOTE] = ACTIONS(3015),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3015),
    [anon_sym_shared] = ACTIONS(3015),
    [anon_sym_map_LBRACK] = ACTIONS(3015),
    [anon_sym_chan] = ACTIONS(3015),
    [anon_sym_thread] = ACTIONS(3015),
    [anon_sym_atomic] = ACTIONS(3015),
    [anon_sym_assert] = ACTIONS(3015),
    [anon_sym_defer] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3015),
    [anon_sym_break] = ACTIONS(3015),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_return] = ACTIONS(3015),
    [anon_sym_DOLLARfor] = ACTIONS(3015),
    [anon_sym_for] = ACTIONS(3015),
    [anon_sym_POUND] = ACTIONS(3015),
    [anon_sym_asm] = ACTIONS(3015),
  },
  [1331] = {
    [sym_line_comment] = STATE(1331),
    [sym_block_comment] = STATE(1331),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_LF] = ACTIONS(3007),
    [anon_sym_CR] = ACTIONS(3007),
    [anon_sym_CR_LF] = ACTIONS(3007),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3007),
    [anon_sym_DOT] = ACTIONS(3007),
    [anon_sym_as] = ACTIONS(3007),
    [anon_sym_LBRACE] = ACTIONS(3007),
    [anon_sym_COMMA] = ACTIONS(3007),
    [anon_sym_RBRACE] = ACTIONS(3007),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_fn] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_STAR] = ACTIONS(3007),
    [anon_sym_SLASH] = ACTIONS(3007),
    [anon_sym_PERCENT] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(3007),
    [anon_sym_GT] = ACTIONS(3007),
    [anon_sym_EQ_EQ] = ACTIONS(3007),
    [anon_sym_BANG_EQ] = ACTIONS(3007),
    [anon_sym_LT_EQ] = ACTIONS(3007),
    [anon_sym_GT_EQ] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3005),
    [anon_sym_struct] = ACTIONS(3007),
    [anon_sym_mut] = ACTIONS(3007),
    [anon_sym_PLUS_PLUS] = ACTIONS(3007),
    [anon_sym_DASH_DASH] = ACTIONS(3007),
    [anon_sym_QMARK] = ACTIONS(3007),
    [anon_sym_BANG] = ACTIONS(3007),
    [anon_sym_go] = ACTIONS(3007),
    [anon_sym_spawn] = ACTIONS(3007),
    [anon_sym_json_DOTdecode] = ACTIONS(3007),
    [anon_sym_PIPE] = ACTIONS(3007),
    [anon_sym_LBRACK2] = ACTIONS(3007),
    [anon_sym_TILDE] = ACTIONS(3007),
    [anon_sym_CARET] = ACTIONS(3007),
    [anon_sym_AMP] = ACTIONS(3007),
    [anon_sym_LT_DASH] = ACTIONS(3007),
    [anon_sym_LT_LT] = ACTIONS(3007),
    [anon_sym_GT_GT] = ACTIONS(3007),
    [anon_sym_GT_GT_GT] = ACTIONS(3007),
    [anon_sym_AMP_CARET] = ACTIONS(3007),
    [anon_sym_AMP_AMP] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3007),
    [anon_sym_or] = ACTIONS(3007),
    [sym_none] = ACTIONS(3007),
    [sym_true] = ACTIONS(3007),
    [sym_false] = ACTIONS(3007),
    [sym_nil] = ACTIONS(3007),
    [anon_sym_QMARK_DOT] = ACTIONS(3007),
    [anon_sym_POUND_LBRACK] = ACTIONS(3007),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_DOLLARif] = ACTIONS(3007),
    [anon_sym_is] = ACTIONS(3007),
    [anon_sym_BANGis] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3007),
    [anon_sym_BANGin] = ACTIONS(3007),
    [anon_sym_match] = ACTIONS(3007),
    [anon_sym_select] = ACTIONS(3007),
    [anon_sym_lock] = ACTIONS(3007),
    [anon_sym_rlock] = ACTIONS(3007),
    [anon_sym_unsafe] = ACTIONS(3007),
    [anon_sym_sql] = ACTIONS(3007),
    [sym_int_literal] = ACTIONS(3007),
    [sym_float_literal] = ACTIONS(3007),
    [sym_rune_literal] = ACTIONS(3007),
    [anon_sym_SQUOTE] = ACTIONS(3007),
    [anon_sym_DQUOTE] = ACTIONS(3007),
    [anon_sym_c_SQUOTE] = ACTIONS(3007),
    [anon_sym_c_DQUOTE] = ACTIONS(3007),
    [anon_sym_r_SQUOTE] = ACTIONS(3007),
    [anon_sym_r_DQUOTE] = ACTIONS(3007),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3007),
    [anon_sym_shared] = ACTIONS(3007),
    [anon_sym_map_LBRACK] = ACTIONS(3007),
    [anon_sym_chan] = ACTIONS(3007),
    [anon_sym_thread] = ACTIONS(3007),
    [anon_sym_atomic] = ACTIONS(3007),
    [anon_sym_assert] = ACTIONS(3007),
    [anon_sym_defer] = ACTIONS(3007),
    [anon_sym_goto] = ACTIONS(3007),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_continue] = ACTIONS(3007),
    [anon_sym_return] = ACTIONS(3007),
    [anon_sym_DOLLARfor] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3007),
    [anon_sym_POUND] = ACTIONS(3007),
    [anon_sym_asm] = ACTIONS(3007),
  },
  [1332] = {
    [sym_line_comment] = STATE(1332),
    [sym_block_comment] = STATE(1332),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_LF] = ACTIONS(3027),
    [anon_sym_CR] = ACTIONS(3027),
    [anon_sym_CR_LF] = ACTIONS(3027),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3027),
    [anon_sym_DOT] = ACTIONS(3027),
    [anon_sym_as] = ACTIONS(3027),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_COMMA] = ACTIONS(3027),
    [anon_sym_RBRACE] = ACTIONS(3027),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym_fn] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_STAR] = ACTIONS(3027),
    [anon_sym_SLASH] = ACTIONS(3027),
    [anon_sym_PERCENT] = ACTIONS(3027),
    [anon_sym_LT] = ACTIONS(3027),
    [anon_sym_GT] = ACTIONS(3027),
    [anon_sym_EQ_EQ] = ACTIONS(3027),
    [anon_sym_BANG_EQ] = ACTIONS(3027),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3025),
    [anon_sym_struct] = ACTIONS(3027),
    [anon_sym_mut] = ACTIONS(3027),
    [anon_sym_PLUS_PLUS] = ACTIONS(3027),
    [anon_sym_DASH_DASH] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_BANG] = ACTIONS(3027),
    [anon_sym_go] = ACTIONS(3027),
    [anon_sym_spawn] = ACTIONS(3027),
    [anon_sym_json_DOTdecode] = ACTIONS(3027),
    [anon_sym_PIPE] = ACTIONS(3027),
    [anon_sym_LBRACK2] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3027),
    [anon_sym_CARET] = ACTIONS(3027),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_LT_DASH] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3027),
    [anon_sym_GT_GT] = ACTIONS(3027),
    [anon_sym_GT_GT_GT] = ACTIONS(3027),
    [anon_sym_AMP_CARET] = ACTIONS(3027),
    [anon_sym_AMP_AMP] = ACTIONS(3027),
    [anon_sym_PIPE_PIPE] = ACTIONS(3027),
    [anon_sym_or] = ACTIONS(3027),
    [sym_none] = ACTIONS(3027),
    [sym_true] = ACTIONS(3027),
    [sym_false] = ACTIONS(3027),
    [sym_nil] = ACTIONS(3027),
    [anon_sym_QMARK_DOT] = ACTIONS(3027),
    [anon_sym_POUND_LBRACK] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_DOLLARif] = ACTIONS(3027),
    [anon_sym_is] = ACTIONS(3027),
    [anon_sym_BANGis] = ACTIONS(3027),
    [anon_sym_in] = ACTIONS(3027),
    [anon_sym_BANGin] = ACTIONS(3027),
    [anon_sym_match] = ACTIONS(3027),
    [anon_sym_select] = ACTIONS(3027),
    [anon_sym_lock] = ACTIONS(3027),
    [anon_sym_rlock] = ACTIONS(3027),
    [anon_sym_unsafe] = ACTIONS(3027),
    [anon_sym_sql] = ACTIONS(3027),
    [sym_int_literal] = ACTIONS(3027),
    [sym_float_literal] = ACTIONS(3027),
    [sym_rune_literal] = ACTIONS(3027),
    [anon_sym_SQUOTE] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_c_SQUOTE] = ACTIONS(3027),
    [anon_sym_c_DQUOTE] = ACTIONS(3027),
    [anon_sym_r_SQUOTE] = ACTIONS(3027),
    [anon_sym_r_DQUOTE] = ACTIONS(3027),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3027),
    [anon_sym_shared] = ACTIONS(3027),
    [anon_sym_map_LBRACK] = ACTIONS(3027),
    [anon_sym_chan] = ACTIONS(3027),
    [anon_sym_thread] = ACTIONS(3027),
    [anon_sym_atomic] = ACTIONS(3027),
    [anon_sym_assert] = ACTIONS(3027),
    [anon_sym_defer] = ACTIONS(3027),
    [anon_sym_goto] = ACTIONS(3027),
    [anon_sym_break] = ACTIONS(3027),
    [anon_sym_continue] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_DOLLARfor] = ACTIONS(3027),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_POUND] = ACTIONS(3027),
    [anon_sym_asm] = ACTIONS(3027),
  },
  [1333] = {
    [sym_line_comment] = STATE(1333),
    [sym_block_comment] = STATE(1333),
    [sym_identifier] = ACTIONS(3250),
    [anon_sym_LF] = ACTIONS(3250),
    [anon_sym_CR] = ACTIONS(3250),
    [anon_sym_CR_LF] = ACTIONS(3250),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3250),
    [anon_sym_DOT] = ACTIONS(3250),
    [anon_sym_as] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3250),
    [anon_sym_COMMA] = ACTIONS(3250),
    [anon_sym_RBRACE] = ACTIONS(3250),
    [anon_sym_LPAREN] = ACTIONS(3250),
    [anon_sym_fn] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_STAR] = ACTIONS(3250),
    [anon_sym_SLASH] = ACTIONS(3250),
    [anon_sym_PERCENT] = ACTIONS(3250),
    [anon_sym_LT] = ACTIONS(3250),
    [anon_sym_GT] = ACTIONS(3250),
    [anon_sym_EQ_EQ] = ACTIONS(3250),
    [anon_sym_BANG_EQ] = ACTIONS(3250),
    [anon_sym_LT_EQ] = ACTIONS(3250),
    [anon_sym_GT_EQ] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3248),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_mut] = ACTIONS(3250),
    [anon_sym_PLUS_PLUS] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3250),
    [anon_sym_QMARK] = ACTIONS(3250),
    [anon_sym_BANG] = ACTIONS(3250),
    [anon_sym_go] = ACTIONS(3250),
    [anon_sym_spawn] = ACTIONS(3250),
    [anon_sym_json_DOTdecode] = ACTIONS(3250),
    [anon_sym_PIPE] = ACTIONS(3250),
    [anon_sym_LBRACK2] = ACTIONS(3250),
    [anon_sym_TILDE] = ACTIONS(3250),
    [anon_sym_CARET] = ACTIONS(3250),
    [anon_sym_AMP] = ACTIONS(3250),
    [anon_sym_LT_DASH] = ACTIONS(3250),
    [anon_sym_LT_LT] = ACTIONS(3250),
    [anon_sym_GT_GT] = ACTIONS(3250),
    [anon_sym_GT_GT_GT] = ACTIONS(3250),
    [anon_sym_AMP_CARET] = ACTIONS(3250),
    [anon_sym_AMP_AMP] = ACTIONS(3250),
    [anon_sym_PIPE_PIPE] = ACTIONS(3250),
    [anon_sym_or] = ACTIONS(3250),
    [sym_none] = ACTIONS(3250),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [sym_nil] = ACTIONS(3250),
    [anon_sym_QMARK_DOT] = ACTIONS(3250),
    [anon_sym_POUND_LBRACK] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_DOLLARif] = ACTIONS(3250),
    [anon_sym_is] = ACTIONS(3250),
    [anon_sym_BANGis] = ACTIONS(3250),
    [anon_sym_in] = ACTIONS(3250),
    [anon_sym_BANGin] = ACTIONS(3250),
    [anon_sym_match] = ACTIONS(3250),
    [anon_sym_select] = ACTIONS(3250),
    [anon_sym_lock] = ACTIONS(3250),
    [anon_sym_rlock] = ACTIONS(3250),
    [anon_sym_unsafe] = ACTIONS(3250),
    [anon_sym_sql] = ACTIONS(3250),
    [sym_int_literal] = ACTIONS(3250),
    [sym_float_literal] = ACTIONS(3250),
    [sym_rune_literal] = ACTIONS(3250),
    [anon_sym_SQUOTE] = ACTIONS(3250),
    [anon_sym_DQUOTE] = ACTIONS(3250),
    [anon_sym_c_SQUOTE] = ACTIONS(3250),
    [anon_sym_c_DQUOTE] = ACTIONS(3250),
    [anon_sym_r_SQUOTE] = ACTIONS(3250),
    [anon_sym_r_DQUOTE] = ACTIONS(3250),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3250),
    [anon_sym_shared] = ACTIONS(3250),
    [anon_sym_map_LBRACK] = ACTIONS(3250),
    [anon_sym_chan] = ACTIONS(3250),
    [anon_sym_thread] = ACTIONS(3250),
    [anon_sym_atomic] = ACTIONS(3250),
    [anon_sym_assert] = ACTIONS(3250),
    [anon_sym_defer] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_DOLLARfor] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_POUND] = ACTIONS(3250),
    [anon_sym_asm] = ACTIONS(3250),
  },
  [1334] = {
    [sym_line_comment] = STATE(1334),
    [sym_block_comment] = STATE(1334),
    [sym_identifier] = ACTIONS(2981),
    [anon_sym_LF] = ACTIONS(2981),
    [anon_sym_CR] = ACTIONS(2981),
    [anon_sym_CR_LF] = ACTIONS(2981),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2981),
    [anon_sym_DOT] = ACTIONS(2981),
    [anon_sym_as] = ACTIONS(2981),
    [anon_sym_LBRACE] = ACTIONS(2981),
    [anon_sym_COMMA] = ACTIONS(2981),
    [anon_sym_RBRACE] = ACTIONS(2981),
    [anon_sym_LPAREN] = ACTIONS(2981),
    [anon_sym_fn] = ACTIONS(2981),
    [anon_sym_PLUS] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_PERCENT] = ACTIONS(2981),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_GT] = ACTIONS(2981),
    [anon_sym_EQ_EQ] = ACTIONS(2981),
    [anon_sym_BANG_EQ] = ACTIONS(2981),
    [anon_sym_LT_EQ] = ACTIONS(2981),
    [anon_sym_GT_EQ] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_struct] = ACTIONS(2981),
    [anon_sym_mut] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2981),
    [anon_sym_DASH_DASH] = ACTIONS(2981),
    [anon_sym_QMARK] = ACTIONS(2981),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_go] = ACTIONS(2981),
    [anon_sym_spawn] = ACTIONS(2981),
    [anon_sym_json_DOTdecode] = ACTIONS(2981),
    [anon_sym_PIPE] = ACTIONS(2981),
    [anon_sym_LBRACK2] = ACTIONS(2981),
    [anon_sym_TILDE] = ACTIONS(2981),
    [anon_sym_CARET] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2981),
    [anon_sym_LT_DASH] = ACTIONS(2981),
    [anon_sym_LT_LT] = ACTIONS(2981),
    [anon_sym_GT_GT] = ACTIONS(2981),
    [anon_sym_GT_GT_GT] = ACTIONS(2981),
    [anon_sym_AMP_CARET] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(2981),
    [anon_sym_PIPE_PIPE] = ACTIONS(2981),
    [anon_sym_or] = ACTIONS(2981),
    [sym_none] = ACTIONS(2981),
    [sym_true] = ACTIONS(2981),
    [sym_false] = ACTIONS(2981),
    [sym_nil] = ACTIONS(2981),
    [anon_sym_QMARK_DOT] = ACTIONS(2981),
    [anon_sym_POUND_LBRACK] = ACTIONS(2981),
    [anon_sym_if] = ACTIONS(2981),
    [anon_sym_DOLLARif] = ACTIONS(2981),
    [anon_sym_is] = ACTIONS(2981),
    [anon_sym_BANGis] = ACTIONS(2981),
    [anon_sym_in] = ACTIONS(2981),
    [anon_sym_BANGin] = ACTIONS(2981),
    [anon_sym_match] = ACTIONS(2981),
    [anon_sym_select] = ACTIONS(2981),
    [anon_sym_lock] = ACTIONS(2981),
    [anon_sym_rlock] = ACTIONS(2981),
    [anon_sym_unsafe] = ACTIONS(2981),
    [anon_sym_sql] = ACTIONS(2981),
    [sym_int_literal] = ACTIONS(2981),
    [sym_float_literal] = ACTIONS(2981),
    [sym_rune_literal] = ACTIONS(2981),
    [anon_sym_SQUOTE] = ACTIONS(2981),
    [anon_sym_DQUOTE] = ACTIONS(2981),
    [anon_sym_c_SQUOTE] = ACTIONS(2981),
    [anon_sym_c_DQUOTE] = ACTIONS(2981),
    [anon_sym_r_SQUOTE] = ACTIONS(2981),
    [anon_sym_r_DQUOTE] = ACTIONS(2981),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2981),
    [anon_sym_shared] = ACTIONS(2981),
    [anon_sym_map_LBRACK] = ACTIONS(2981),
    [anon_sym_chan] = ACTIONS(2981),
    [anon_sym_thread] = ACTIONS(2981),
    [anon_sym_atomic] = ACTIONS(2981),
    [anon_sym_assert] = ACTIONS(2981),
    [anon_sym_defer] = ACTIONS(2981),
    [anon_sym_goto] = ACTIONS(2981),
    [anon_sym_break] = ACTIONS(2981),
    [anon_sym_continue] = ACTIONS(2981),
    [anon_sym_return] = ACTIONS(2981),
    [anon_sym_DOLLARfor] = ACTIONS(2981),
    [anon_sym_for] = ACTIONS(2981),
    [anon_sym_POUND] = ACTIONS(2981),
    [anon_sym_asm] = ACTIONS(2981),
  },
  [1335] = {
    [sym_line_comment] = STATE(1335),
    [sym_block_comment] = STATE(1335),
    [sym_identifier] = ACTIONS(2977),
    [anon_sym_LF] = ACTIONS(2977),
    [anon_sym_CR] = ACTIONS(2977),
    [anon_sym_CR_LF] = ACTIONS(2977),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2977),
    [anon_sym_DOT] = ACTIONS(2977),
    [anon_sym_as] = ACTIONS(2977),
    [anon_sym_LBRACE] = ACTIONS(2977),
    [anon_sym_COMMA] = ACTIONS(2977),
    [anon_sym_RBRACE] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(2977),
    [anon_sym_fn] = ACTIONS(2977),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_PERCENT] = ACTIONS(2977),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_EQ_EQ] = ACTIONS(2977),
    [anon_sym_BANG_EQ] = ACTIONS(2977),
    [anon_sym_LT_EQ] = ACTIONS(2977),
    [anon_sym_GT_EQ] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(2975),
    [anon_sym_struct] = ACTIONS(2977),
    [anon_sym_mut] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2977),
    [anon_sym_DASH_DASH] = ACTIONS(2977),
    [anon_sym_QMARK] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_go] = ACTIONS(2977),
    [anon_sym_spawn] = ACTIONS(2977),
    [anon_sym_json_DOTdecode] = ACTIONS(2977),
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_LBRACK2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2977),
    [anon_sym_CARET] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_LT_DASH] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2977),
    [anon_sym_GT_GT] = ACTIONS(2977),
    [anon_sym_GT_GT_GT] = ACTIONS(2977),
    [anon_sym_AMP_CARET] = ACTIONS(2977),
    [anon_sym_AMP_AMP] = ACTIONS(2977),
    [anon_sym_PIPE_PIPE] = ACTIONS(2977),
    [anon_sym_or] = ACTIONS(2977),
    [sym_none] = ACTIONS(2977),
    [sym_true] = ACTIONS(2977),
    [sym_false] = ACTIONS(2977),
    [sym_nil] = ACTIONS(2977),
    [anon_sym_QMARK_DOT] = ACTIONS(2977),
    [anon_sym_POUND_LBRACK] = ACTIONS(2977),
    [anon_sym_if] = ACTIONS(2977),
    [anon_sym_DOLLARif] = ACTIONS(2977),
    [anon_sym_is] = ACTIONS(2977),
    [anon_sym_BANGis] = ACTIONS(2977),
    [anon_sym_in] = ACTIONS(2977),
    [anon_sym_BANGin] = ACTIONS(2977),
    [anon_sym_match] = ACTIONS(2977),
    [anon_sym_select] = ACTIONS(2977),
    [anon_sym_lock] = ACTIONS(2977),
    [anon_sym_rlock] = ACTIONS(2977),
    [anon_sym_unsafe] = ACTIONS(2977),
    [anon_sym_sql] = ACTIONS(2977),
    [sym_int_literal] = ACTIONS(2977),
    [sym_float_literal] = ACTIONS(2977),
    [sym_rune_literal] = ACTIONS(2977),
    [anon_sym_SQUOTE] = ACTIONS(2977),
    [anon_sym_DQUOTE] = ACTIONS(2977),
    [anon_sym_c_SQUOTE] = ACTIONS(2977),
    [anon_sym_c_DQUOTE] = ACTIONS(2977),
    [anon_sym_r_SQUOTE] = ACTIONS(2977),
    [anon_sym_r_DQUOTE] = ACTIONS(2977),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2977),
    [anon_sym_shared] = ACTIONS(2977),
    [anon_sym_map_LBRACK] = ACTIONS(2977),
    [anon_sym_chan] = ACTIONS(2977),
    [anon_sym_thread] = ACTIONS(2977),
    [anon_sym_atomic] = ACTIONS(2977),
    [anon_sym_assert] = ACTIONS(2977),
    [anon_sym_defer] = ACTIONS(2977),
    [anon_sym_goto] = ACTIONS(2977),
    [anon_sym_break] = ACTIONS(2977),
    [anon_sym_continue] = ACTIONS(2977),
    [anon_sym_return] = ACTIONS(2977),
    [anon_sym_DOLLARfor] = ACTIONS(2977),
    [anon_sym_for] = ACTIONS(2977),
    [anon_sym_POUND] = ACTIONS(2977),
    [anon_sym_asm] = ACTIONS(2977),
  },
  [1336] = {
    [sym_line_comment] = STATE(1336),
    [sym_block_comment] = STATE(1336),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_LF] = ACTIONS(3031),
    [anon_sym_CR] = ACTIONS(3031),
    [anon_sym_CR_LF] = ACTIONS(3031),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3031),
    [anon_sym_DOT] = ACTIONS(3031),
    [anon_sym_as] = ACTIONS(3031),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_COMMA] = ACTIONS(3031),
    [anon_sym_RBRACE] = ACTIONS(3031),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym_fn] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_STAR] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3031),
    [anon_sym_PERCENT] = ACTIONS(3031),
    [anon_sym_LT] = ACTIONS(3031),
    [anon_sym_GT] = ACTIONS(3031),
    [anon_sym_EQ_EQ] = ACTIONS(3031),
    [anon_sym_BANG_EQ] = ACTIONS(3031),
    [anon_sym_LT_EQ] = ACTIONS(3031),
    [anon_sym_GT_EQ] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3029),
    [anon_sym_struct] = ACTIONS(3031),
    [anon_sym_mut] = ACTIONS(3031),
    [anon_sym_PLUS_PLUS] = ACTIONS(3031),
    [anon_sym_DASH_DASH] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_BANG] = ACTIONS(3031),
    [anon_sym_go] = ACTIONS(3031),
    [anon_sym_spawn] = ACTIONS(3031),
    [anon_sym_json_DOTdecode] = ACTIONS(3031),
    [anon_sym_PIPE] = ACTIONS(3031),
    [anon_sym_LBRACK2] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3031),
    [anon_sym_CARET] = ACTIONS(3031),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_LT_DASH] = ACTIONS(3031),
    [anon_sym_LT_LT] = ACTIONS(3031),
    [anon_sym_GT_GT] = ACTIONS(3031),
    [anon_sym_GT_GT_GT] = ACTIONS(3031),
    [anon_sym_AMP_CARET] = ACTIONS(3031),
    [anon_sym_AMP_AMP] = ACTIONS(3031),
    [anon_sym_PIPE_PIPE] = ACTIONS(3031),
    [anon_sym_or] = ACTIONS(3031),
    [sym_none] = ACTIONS(3031),
    [sym_true] = ACTIONS(3031),
    [sym_false] = ACTIONS(3031),
    [sym_nil] = ACTIONS(3031),
    [anon_sym_QMARK_DOT] = ACTIONS(3031),
    [anon_sym_POUND_LBRACK] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_DOLLARif] = ACTIONS(3031),
    [anon_sym_is] = ACTIONS(3031),
    [anon_sym_BANGis] = ACTIONS(3031),
    [anon_sym_in] = ACTIONS(3031),
    [anon_sym_BANGin] = ACTIONS(3031),
    [anon_sym_match] = ACTIONS(3031),
    [anon_sym_select] = ACTIONS(3031),
    [anon_sym_lock] = ACTIONS(3031),
    [anon_sym_rlock] = ACTIONS(3031),
    [anon_sym_unsafe] = ACTIONS(3031),
    [anon_sym_sql] = ACTIONS(3031),
    [sym_int_literal] = ACTIONS(3031),
    [sym_float_literal] = ACTIONS(3031),
    [sym_rune_literal] = ACTIONS(3031),
    [anon_sym_SQUOTE] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_c_SQUOTE] = ACTIONS(3031),
    [anon_sym_c_DQUOTE] = ACTIONS(3031),
    [anon_sym_r_SQUOTE] = ACTIONS(3031),
    [anon_sym_r_DQUOTE] = ACTIONS(3031),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3031),
    [anon_sym_shared] = ACTIONS(3031),
    [anon_sym_map_LBRACK] = ACTIONS(3031),
    [anon_sym_chan] = ACTIONS(3031),
    [anon_sym_thread] = ACTIONS(3031),
    [anon_sym_atomic] = ACTIONS(3031),
    [anon_sym_assert] = ACTIONS(3031),
    [anon_sym_defer] = ACTIONS(3031),
    [anon_sym_goto] = ACTIONS(3031),
    [anon_sym_break] = ACTIONS(3031),
    [anon_sym_continue] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_DOLLARfor] = ACTIONS(3031),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_POUND] = ACTIONS(3031),
    [anon_sym_asm] = ACTIONS(3031),
  },
  [1337] = {
    [sym_line_comment] = STATE(1337),
    [sym_block_comment] = STATE(1337),
    [sym_identifier] = ACTIONS(3041),
    [anon_sym_LF] = ACTIONS(3041),
    [anon_sym_CR] = ACTIONS(3041),
    [anon_sym_CR_LF] = ACTIONS(3041),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3041),
    [anon_sym_DOT] = ACTIONS(3041),
    [anon_sym_as] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3041),
    [anon_sym_COMMA] = ACTIONS(3041),
    [anon_sym_RBRACE] = ACTIONS(3041),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_fn] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3041),
    [anon_sym_DASH] = ACTIONS(3041),
    [anon_sym_STAR] = ACTIONS(3041),
    [anon_sym_SLASH] = ACTIONS(3041),
    [anon_sym_PERCENT] = ACTIONS(3041),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_GT] = ACTIONS(3041),
    [anon_sym_EQ_EQ] = ACTIONS(3041),
    [anon_sym_BANG_EQ] = ACTIONS(3041),
    [anon_sym_LT_EQ] = ACTIONS(3041),
    [anon_sym_GT_EQ] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_struct] = ACTIONS(3041),
    [anon_sym_mut] = ACTIONS(3041),
    [anon_sym_PLUS_PLUS] = ACTIONS(3041),
    [anon_sym_DASH_DASH] = ACTIONS(3041),
    [anon_sym_QMARK] = ACTIONS(3041),
    [anon_sym_BANG] = ACTIONS(3041),
    [anon_sym_go] = ACTIONS(3041),
    [anon_sym_spawn] = ACTIONS(3041),
    [anon_sym_json_DOTdecode] = ACTIONS(3041),
    [anon_sym_PIPE] = ACTIONS(3041),
    [anon_sym_LBRACK2] = ACTIONS(3041),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_CARET] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3041),
    [anon_sym_LT_DASH] = ACTIONS(3041),
    [anon_sym_LT_LT] = ACTIONS(3041),
    [anon_sym_GT_GT] = ACTIONS(3041),
    [anon_sym_GT_GT_GT] = ACTIONS(3041),
    [anon_sym_AMP_CARET] = ACTIONS(3041),
    [anon_sym_AMP_AMP] = ACTIONS(3041),
    [anon_sym_PIPE_PIPE] = ACTIONS(3041),
    [anon_sym_or] = ACTIONS(3041),
    [sym_none] = ACTIONS(3041),
    [sym_true] = ACTIONS(3041),
    [sym_false] = ACTIONS(3041),
    [sym_nil] = ACTIONS(3041),
    [anon_sym_QMARK_DOT] = ACTIONS(3041),
    [anon_sym_POUND_LBRACK] = ACTIONS(3041),
    [anon_sym_if] = ACTIONS(3041),
    [anon_sym_DOLLARif] = ACTIONS(3041),
    [anon_sym_is] = ACTIONS(3041),
    [anon_sym_BANGis] = ACTIONS(3041),
    [anon_sym_in] = ACTIONS(3041),
    [anon_sym_BANGin] = ACTIONS(3041),
    [anon_sym_match] = ACTIONS(3041),
    [anon_sym_select] = ACTIONS(3041),
    [anon_sym_lock] = ACTIONS(3041),
    [anon_sym_rlock] = ACTIONS(3041),
    [anon_sym_unsafe] = ACTIONS(3041),
    [anon_sym_sql] = ACTIONS(3041),
    [sym_int_literal] = ACTIONS(3041),
    [sym_float_literal] = ACTIONS(3041),
    [sym_rune_literal] = ACTIONS(3041),
    [anon_sym_SQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE] = ACTIONS(3041),
    [anon_sym_c_SQUOTE] = ACTIONS(3041),
    [anon_sym_c_DQUOTE] = ACTIONS(3041),
    [anon_sym_r_SQUOTE] = ACTIONS(3041),
    [anon_sym_r_DQUOTE] = ACTIONS(3041),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3041),
    [anon_sym_shared] = ACTIONS(3041),
    [anon_sym_map_LBRACK] = ACTIONS(3041),
    [anon_sym_chan] = ACTIONS(3041),
    [anon_sym_thread] = ACTIONS(3041),
    [anon_sym_atomic] = ACTIONS(3041),
    [anon_sym_assert] = ACTIONS(3041),
    [anon_sym_defer] = ACTIONS(3041),
    [anon_sym_goto] = ACTIONS(3041),
    [anon_sym_break] = ACTIONS(3041),
    [anon_sym_continue] = ACTIONS(3041),
    [anon_sym_return] = ACTIONS(3041),
    [anon_sym_DOLLARfor] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3041),
    [anon_sym_POUND] = ACTIONS(3041),
    [anon_sym_asm] = ACTIONS(3041),
  },
  [1338] = {
    [sym_line_comment] = STATE(1338),
    [sym_block_comment] = STATE(1338),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_LF] = ACTIONS(2833),
    [anon_sym_CR] = ACTIONS(2833),
    [anon_sym_CR_LF] = ACTIONS(2833),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2833),
    [anon_sym_DOT] = ACTIONS(2833),
    [anon_sym_as] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_RBRACE] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2833),
    [anon_sym_fn] = ACTIONS(2833),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(2833),
    [anon_sym_SLASH] = ACTIONS(2833),
    [anon_sym_PERCENT] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(2833),
    [anon_sym_EQ_EQ] = ACTIONS(2833),
    [anon_sym_BANG_EQ] = ACTIONS(2833),
    [anon_sym_LT_EQ] = ACTIONS(2833),
    [anon_sym_GT_EQ] = ACTIONS(2833),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_struct] = ACTIONS(2833),
    [anon_sym_mut] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_QMARK] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_go] = ACTIONS(2833),
    [anon_sym_spawn] = ACTIONS(2833),
    [anon_sym_json_DOTdecode] = ACTIONS(2833),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_LBRACK2] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2833),
    [anon_sym_CARET] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2833),
    [anon_sym_LT_DASH] = ACTIONS(2833),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_GT] = ACTIONS(2833),
    [anon_sym_AMP_CARET] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2833),
    [anon_sym_or] = ACTIONS(2833),
    [sym_none] = ACTIONS(2833),
    [sym_true] = ACTIONS(2833),
    [sym_false] = ACTIONS(2833),
    [sym_nil] = ACTIONS(2833),
    [anon_sym_QMARK_DOT] = ACTIONS(2833),
    [anon_sym_POUND_LBRACK] = ACTIONS(2833),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_DOLLARif] = ACTIONS(2833),
    [anon_sym_is] = ACTIONS(2833),
    [anon_sym_BANGis] = ACTIONS(2833),
    [anon_sym_in] = ACTIONS(2833),
    [anon_sym_BANGin] = ACTIONS(2833),
    [anon_sym_match] = ACTIONS(2833),
    [anon_sym_select] = ACTIONS(2833),
    [anon_sym_lock] = ACTIONS(2833),
    [anon_sym_rlock] = ACTIONS(2833),
    [anon_sym_unsafe] = ACTIONS(2833),
    [anon_sym_sql] = ACTIONS(2833),
    [sym_int_literal] = ACTIONS(2833),
    [sym_float_literal] = ACTIONS(2833),
    [sym_rune_literal] = ACTIONS(2833),
    [anon_sym_SQUOTE] = ACTIONS(2833),
    [anon_sym_DQUOTE] = ACTIONS(2833),
    [anon_sym_c_SQUOTE] = ACTIONS(2833),
    [anon_sym_c_DQUOTE] = ACTIONS(2833),
    [anon_sym_r_SQUOTE] = ACTIONS(2833),
    [anon_sym_r_DQUOTE] = ACTIONS(2833),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2833),
    [anon_sym_shared] = ACTIONS(2833),
    [anon_sym_map_LBRACK] = ACTIONS(2833),
    [anon_sym_chan] = ACTIONS(2833),
    [anon_sym_thread] = ACTIONS(2833),
    [anon_sym_atomic] = ACTIONS(2833),
    [anon_sym_assert] = ACTIONS(2833),
    [anon_sym_defer] = ACTIONS(2833),
    [anon_sym_goto] = ACTIONS(2833),
    [anon_sym_break] = ACTIONS(2833),
    [anon_sym_continue] = ACTIONS(2833),
    [anon_sym_return] = ACTIONS(2833),
    [anon_sym_DOLLARfor] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2833),
    [anon_sym_POUND] = ACTIONS(2833),
    [anon_sym_asm] = ACTIONS(2833),
  },
  [1339] = {
    [sym_line_comment] = STATE(1339),
    [sym_block_comment] = STATE(1339),
    [sym_identifier] = ACTIONS(2829),
    [anon_sym_LF] = ACTIONS(2829),
    [anon_sym_CR] = ACTIONS(2829),
    [anon_sym_CR_LF] = ACTIONS(2829),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_DOT] = ACTIONS(2829),
    [anon_sym_as] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_fn] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(2829),
    [anon_sym_SLASH] = ACTIONS(2829),
    [anon_sym_PERCENT] = ACTIONS(2829),
    [anon_sym_LT] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2829),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LBRACK] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_mut] = ACTIONS(2829),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_QMARK] = ACTIONS(2829),
    [anon_sym_BANG] = ACTIONS(2829),
    [anon_sym_go] = ACTIONS(2829),
    [anon_sym_spawn] = ACTIONS(2829),
    [anon_sym_json_DOTdecode] = ACTIONS(2829),
    [anon_sym_PIPE] = ACTIONS(2829),
    [anon_sym_LBRACK2] = ACTIONS(2829),
    [anon_sym_TILDE] = ACTIONS(2829),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_AMP] = ACTIONS(2829),
    [anon_sym_LT_DASH] = ACTIONS(2829),
    [anon_sym_LT_LT] = ACTIONS(2829),
    [anon_sym_GT_GT] = ACTIONS(2829),
    [anon_sym_GT_GT_GT] = ACTIONS(2829),
    [anon_sym_AMP_CARET] = ACTIONS(2829),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_or] = ACTIONS(2829),
    [sym_none] = ACTIONS(2829),
    [sym_true] = ACTIONS(2829),
    [sym_false] = ACTIONS(2829),
    [sym_nil] = ACTIONS(2829),
    [anon_sym_QMARK_DOT] = ACTIONS(2829),
    [anon_sym_POUND_LBRACK] = ACTIONS(2829),
    [anon_sym_if] = ACTIONS(2829),
    [anon_sym_DOLLARif] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2829),
    [anon_sym_BANGis] = ACTIONS(2829),
    [anon_sym_in] = ACTIONS(2829),
    [anon_sym_BANGin] = ACTIONS(2829),
    [anon_sym_match] = ACTIONS(2829),
    [anon_sym_select] = ACTIONS(2829),
    [anon_sym_lock] = ACTIONS(2829),
    [anon_sym_rlock] = ACTIONS(2829),
    [anon_sym_unsafe] = ACTIONS(2829),
    [anon_sym_sql] = ACTIONS(2829),
    [sym_int_literal] = ACTIONS(2829),
    [sym_float_literal] = ACTIONS(2829),
    [sym_rune_literal] = ACTIONS(2829),
    [anon_sym_SQUOTE] = ACTIONS(2829),
    [anon_sym_DQUOTE] = ACTIONS(2829),
    [anon_sym_c_SQUOTE] = ACTIONS(2829),
    [anon_sym_c_DQUOTE] = ACTIONS(2829),
    [anon_sym_r_SQUOTE] = ACTIONS(2829),
    [anon_sym_r_DQUOTE] = ACTIONS(2829),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2829),
    [anon_sym_shared] = ACTIONS(2829),
    [anon_sym_map_LBRACK] = ACTIONS(2829),
    [anon_sym_chan] = ACTIONS(2829),
    [anon_sym_thread] = ACTIONS(2829),
    [anon_sym_atomic] = ACTIONS(2829),
    [anon_sym_assert] = ACTIONS(2829),
    [anon_sym_defer] = ACTIONS(2829),
    [anon_sym_goto] = ACTIONS(2829),
    [anon_sym_break] = ACTIONS(2829),
    [anon_sym_continue] = ACTIONS(2829),
    [anon_sym_return] = ACTIONS(2829),
    [anon_sym_DOLLARfor] = ACTIONS(2829),
    [anon_sym_for] = ACTIONS(2829),
    [anon_sym_POUND] = ACTIONS(2829),
    [anon_sym_asm] = ACTIONS(2829),
  },
  [1340] = {
    [sym_line_comment] = STATE(1340),
    [sym_block_comment] = STATE(1340),
    [sym_reference_expression] = STATE(4601),
    [sym_type_reference_expression] = STATE(1730),
    [sym_plain_type] = STATE(1870),
    [sym__plain_type_without_special] = STATE(1875),
    [sym_anon_struct_type] = STATE(1881),
    [sym_multi_return_type] = STATE(1875),
    [sym_result_type] = STATE(1875),
    [sym_option_type] = STATE(1875),
    [sym_qualified_type] = STATE(1730),
    [sym_fixed_array_type] = STATE(1881),
    [sym_array_type] = STATE(1881),
    [sym_pointer_type] = STATE(1881),
    [sym_wrong_pointer_type] = STATE(1881),
    [sym_map_type] = STATE(1881),
    [sym_channel_type] = STATE(1881),
    [sym_shared_type] = STATE(1881),
    [sym_thread_type] = STATE(1881),
    [sym_atomic_type] = STATE(1881),
    [sym_generic_type] = STATE(1881),
    [sym_function_type] = STATE(1881),
    [ts_builtin_sym_end] = ACTIONS(857),
    [sym_identifier] = ACTIONS(4066),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_CR] = ACTIONS(859),
    [anon_sym_CR_LF] = ACTIONS(859),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(859),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_const] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(4068),
    [anon_sym___global] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(859),
    [anon_sym_fn] = ACTIONS(4070),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(4072),
    [anon_sym_struct] = ACTIONS(4074),
    [anon_sym_union] = ACTIONS(859),
    [anon_sym_pub] = ACTIONS(859),
    [anon_sym_mut] = ACTIONS(859),
    [anon_sym_enum] = ACTIONS(859),
    [anon_sym_interface] = ACTIONS(859),
    [anon_sym_QMARK] = ACTIONS(4076),
    [anon_sym_BANG] = ACTIONS(4078),
    [anon_sym_go] = ACTIONS(859),
    [anon_sym_spawn] = ACTIONS(859),
    [anon_sym_json_DOTdecode] = ACTIONS(859),
    [anon_sym_LBRACK2] = ACTIONS(4080),
    [anon_sym_TILDE] = ACTIONS(859),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_LT_DASH] = ACTIONS(859),
    [sym_none] = ACTIONS(859),
    [sym_true] = ACTIONS(859),
    [sym_false] = ACTIONS(859),
    [sym_nil] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_DOLLARif] = ACTIONS(859),
    [anon_sym_match] = ACTIONS(859),
    [anon_sym_select] = ACTIONS(859),
    [anon_sym_lock] = ACTIONS(859),
    [anon_sym_rlock] = ACTIONS(859),
    [anon_sym_unsafe] = ACTIONS(859),
    [anon_sym_sql] = ACTIONS(859),
    [sym_int_literal] = ACTIONS(859),
    [sym_float_literal] = ACTIONS(859),
    [sym_rune_literal] = ACTIONS(859),
    [anon_sym_SQUOTE] = ACTIONS(859),
    [anon_sym_DQUOTE] = ACTIONS(859),
    [anon_sym_c_SQUOTE] = ACTIONS(859),
    [anon_sym_c_DQUOTE] = ACTIONS(859),
    [anon_sym_r_SQUOTE] = ACTIONS(859),
    [anon_sym_r_DQUOTE] = ACTIONS(859),
    [sym_pseudo_compile_time_identifier] = ACTIONS(859),
    [anon_sym_shared] = ACTIONS(4084),
    [anon_sym_map_LBRACK] = ACTIONS(4086),
    [anon_sym_chan] = ACTIONS(4088),
    [anon_sym_thread] = ACTIONS(4090),
    [anon_sym_atomic] = ACTIONS(4092),
    [anon_sym_assert] = ACTIONS(859),
    [anon_sym_defer] = ACTIONS(859),
    [anon_sym_goto] = ACTIONS(859),
    [anon_sym_break] = ACTIONS(859),
    [anon_sym_continue] = ACTIONS(859),
    [anon_sym_return] = ACTIONS(859),
    [anon_sym_DOLLARfor] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(859),
    [anon_sym_POUND] = ACTIONS(859),
    [anon_sym_asm] = ACTIONS(859),
    [anon_sym_AT_LBRACK] = ACTIONS(859),
  },
  [1341] = {
    [sym_line_comment] = STATE(1341),
    [sym_block_comment] = STATE(1341),
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2373),
    [anon_sym_CR] = ACTIONS(2373),
    [anon_sym_CR_LF] = ACTIONS(2373),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_DOT] = ACTIONS(2177),
    [anon_sym_as] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2373),
    [anon_sym_COMMA] = ACTIONS(2373),
    [anon_sym_RBRACE] = ACTIONS(2373),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_SLASH] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2373),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_mut] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2373),
    [anon_sym_QMARK] = ACTIONS(2373),
    [anon_sym_BANG] = ACTIONS(2373),
    [anon_sym_go] = ACTIONS(2373),
    [anon_sym_spawn] = ACTIONS(2373),
    [anon_sym_json_DOTdecode] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_LBRACK2] = ACTIONS(2373),
    [anon_sym_TILDE] = ACTIONS(2373),
    [anon_sym_CARET] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_LT_DASH] = ACTIONS(2373),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2373),
    [anon_sym_AMP_CARET] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2373),
    [anon_sym_or] = ACTIONS(2373),
    [sym_none] = ACTIONS(2373),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [sym_nil] = ACTIONS(2373),
    [anon_sym_QMARK_DOT] = ACTIONS(2373),
    [anon_sym_POUND_LBRACK] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_DOLLARif] = ACTIONS(2373),
    [anon_sym_is] = ACTIONS(2373),
    [anon_sym_BANGis] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_BANGin] = ACTIONS(2373),
    [anon_sym_match] = ACTIONS(2373),
    [anon_sym_select] = ACTIONS(2373),
    [anon_sym_lock] = ACTIONS(2373),
    [anon_sym_rlock] = ACTIONS(2373),
    [anon_sym_unsafe] = ACTIONS(2373),
    [anon_sym_sql] = ACTIONS(2373),
    [sym_int_literal] = ACTIONS(2373),
    [sym_float_literal] = ACTIONS(2373),
    [sym_rune_literal] = ACTIONS(2373),
    [anon_sym_SQUOTE] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(2373),
    [anon_sym_c_SQUOTE] = ACTIONS(2373),
    [anon_sym_c_DQUOTE] = ACTIONS(2373),
    [anon_sym_r_SQUOTE] = ACTIONS(2373),
    [anon_sym_r_DQUOTE] = ACTIONS(2373),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_map_LBRACK] = ACTIONS(2373),
    [anon_sym_chan] = ACTIONS(2373),
    [anon_sym_thread] = ACTIONS(2373),
    [anon_sym_atomic] = ACTIONS(2373),
    [anon_sym_assert] = ACTIONS(2373),
    [anon_sym_defer] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_DOLLARfor] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_POUND] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
  },
  [1342] = {
    [sym_line_comment] = STATE(1342),
    [sym_block_comment] = STATE(1342),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_CR] = ACTIONS(2147),
    [anon_sym_CR_LF] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_COMMA] = ACTIONS(2147),
    [anon_sym_RBRACE] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2147),
    [anon_sym_BANG_EQ] = ACTIONS(2147),
    [anon_sym_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2147),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2147),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2147),
    [anon_sym_AMP_CARET] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [anon_sym_or] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2147),
    [anon_sym_POUND_LBRACK] = ACTIONS(2147),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2147),
    [anon_sym_BANGis] = ACTIONS(2147),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANGin] = ACTIONS(2147),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2147),
    [sym_rune_literal] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_c_SQUOTE] = ACTIONS(2147),
    [anon_sym_c_DQUOTE] = ACTIONS(2147),
    [anon_sym_r_SQUOTE] = ACTIONS(2147),
    [anon_sym_r_DQUOTE] = ACTIONS(2147),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2147),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
    [anon_sym_assert] = ACTIONS(2147),
    [anon_sym_defer] = ACTIONS(2147),
    [anon_sym_goto] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_continue] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2147),
    [anon_sym_DOLLARfor] = ACTIONS(2147),
    [anon_sym_for] = ACTIONS(2147),
    [anon_sym_POUND] = ACTIONS(2147),
    [anon_sym_asm] = ACTIONS(2147),
  },
  [1343] = {
    [sym_line_comment] = STATE(1343),
    [sym_block_comment] = STATE(1343),
    [sym_identifier] = ACTIONS(2823),
    [anon_sym_LF] = ACTIONS(2823),
    [anon_sym_CR] = ACTIONS(2823),
    [anon_sym_CR_LF] = ACTIONS(2823),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2823),
    [anon_sym_DOT] = ACTIONS(2823),
    [anon_sym_as] = ACTIONS(2823),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_COMMA] = ACTIONS(2823),
    [anon_sym_RBRACE] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_fn] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2823),
    [anon_sym_DASH] = ACTIONS(2823),
    [anon_sym_STAR] = ACTIONS(2823),
    [anon_sym_SLASH] = ACTIONS(2823),
    [anon_sym_PERCENT] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2823),
    [anon_sym_GT] = ACTIONS(2823),
    [anon_sym_EQ_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_EQ] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(2821),
    [anon_sym_struct] = ACTIONS(2823),
    [anon_sym_mut] = ACTIONS(2823),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_QMARK] = ACTIONS(2823),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_go] = ACTIONS(2823),
    [anon_sym_spawn] = ACTIONS(2823),
    [anon_sym_json_DOTdecode] = ACTIONS(2823),
    [anon_sym_PIPE] = ACTIONS(2823),
    [anon_sym_LBRACK2] = ACTIONS(2823),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_CARET] = ACTIONS(2823),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_LT_DASH] = ACTIONS(2823),
    [anon_sym_LT_LT] = ACTIONS(2823),
    [anon_sym_GT_GT] = ACTIONS(2823),
    [anon_sym_GT_GT_GT] = ACTIONS(2823),
    [anon_sym_AMP_CARET] = ACTIONS(2823),
    [anon_sym_AMP_AMP] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2823),
    [anon_sym_or] = ACTIONS(2823),
    [sym_none] = ACTIONS(2823),
    [sym_true] = ACTIONS(2823),
    [sym_false] = ACTIONS(2823),
    [sym_nil] = ACTIONS(2823),
    [anon_sym_QMARK_DOT] = ACTIONS(2823),
    [anon_sym_POUND_LBRACK] = ACTIONS(2823),
    [anon_sym_if] = ACTIONS(2823),
    [anon_sym_DOLLARif] = ACTIONS(2823),
    [anon_sym_is] = ACTIONS(2823),
    [anon_sym_BANGis] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(2823),
    [anon_sym_BANGin] = ACTIONS(2823),
    [anon_sym_match] = ACTIONS(2823),
    [anon_sym_select] = ACTIONS(2823),
    [anon_sym_lock] = ACTIONS(2823),
    [anon_sym_rlock] = ACTIONS(2823),
    [anon_sym_unsafe] = ACTIONS(2823),
    [anon_sym_sql] = ACTIONS(2823),
    [sym_int_literal] = ACTIONS(2823),
    [sym_float_literal] = ACTIONS(2823),
    [sym_rune_literal] = ACTIONS(2823),
    [anon_sym_SQUOTE] = ACTIONS(2823),
    [anon_sym_DQUOTE] = ACTIONS(2823),
    [anon_sym_c_SQUOTE] = ACTIONS(2823),
    [anon_sym_c_DQUOTE] = ACTIONS(2823),
    [anon_sym_r_SQUOTE] = ACTIONS(2823),
    [anon_sym_r_DQUOTE] = ACTIONS(2823),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2823),
    [anon_sym_shared] = ACTIONS(2823),
    [anon_sym_map_LBRACK] = ACTIONS(2823),
    [anon_sym_chan] = ACTIONS(2823),
    [anon_sym_thread] = ACTIONS(2823),
    [anon_sym_atomic] = ACTIONS(2823),
    [anon_sym_assert] = ACTIONS(2823),
    [anon_sym_defer] = ACTIONS(2823),
    [anon_sym_goto] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2823),
    [anon_sym_continue] = ACTIONS(2823),
    [anon_sym_return] = ACTIONS(2823),
    [anon_sym_DOLLARfor] = ACTIONS(2823),
    [anon_sym_for] = ACTIONS(2823),
    [anon_sym_POUND] = ACTIONS(2823),
    [anon_sym_asm] = ACTIONS(2823),
  },
  [1344] = {
    [sym_line_comment] = STATE(1344),
    [sym_block_comment] = STATE(1344),
    [sym_identifier] = ACTIONS(3286),
    [anon_sym_LF] = ACTIONS(3286),
    [anon_sym_CR] = ACTIONS(3286),
    [anon_sym_CR_LF] = ACTIONS(3286),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3286),
    [anon_sym_DOT] = ACTIONS(3286),
    [anon_sym_as] = ACTIONS(3286),
    [anon_sym_LBRACE] = ACTIONS(3286),
    [anon_sym_COMMA] = ACTIONS(3286),
    [anon_sym_RBRACE] = ACTIONS(3286),
    [anon_sym_LPAREN] = ACTIONS(3286),
    [anon_sym_fn] = ACTIONS(3286),
    [anon_sym_PLUS] = ACTIONS(3286),
    [anon_sym_DASH] = ACTIONS(3286),
    [anon_sym_STAR] = ACTIONS(3286),
    [anon_sym_SLASH] = ACTIONS(3286),
    [anon_sym_PERCENT] = ACTIONS(3286),
    [anon_sym_LT] = ACTIONS(3286),
    [anon_sym_GT] = ACTIONS(3286),
    [anon_sym_EQ_EQ] = ACTIONS(3286),
    [anon_sym_BANG_EQ] = ACTIONS(3286),
    [anon_sym_LT_EQ] = ACTIONS(3286),
    [anon_sym_GT_EQ] = ACTIONS(3286),
    [anon_sym_LBRACK] = ACTIONS(3284),
    [anon_sym_struct] = ACTIONS(3286),
    [anon_sym_mut] = ACTIONS(3286),
    [anon_sym_PLUS_PLUS] = ACTIONS(3286),
    [anon_sym_DASH_DASH] = ACTIONS(3286),
    [anon_sym_QMARK] = ACTIONS(3286),
    [anon_sym_BANG] = ACTIONS(3286),
    [anon_sym_go] = ACTIONS(3286),
    [anon_sym_spawn] = ACTIONS(3286),
    [anon_sym_json_DOTdecode] = ACTIONS(3286),
    [anon_sym_PIPE] = ACTIONS(3286),
    [anon_sym_LBRACK2] = ACTIONS(3286),
    [anon_sym_TILDE] = ACTIONS(3286),
    [anon_sym_CARET] = ACTIONS(3286),
    [anon_sym_AMP] = ACTIONS(3286),
    [anon_sym_LT_DASH] = ACTIONS(3286),
    [anon_sym_LT_LT] = ACTIONS(3286),
    [anon_sym_GT_GT] = ACTIONS(3286),
    [anon_sym_GT_GT_GT] = ACTIONS(3286),
    [anon_sym_AMP_CARET] = ACTIONS(3286),
    [anon_sym_AMP_AMP] = ACTIONS(3286),
    [anon_sym_PIPE_PIPE] = ACTIONS(3286),
    [anon_sym_or] = ACTIONS(3286),
    [sym_none] = ACTIONS(3286),
    [sym_true] = ACTIONS(3286),
    [sym_false] = ACTIONS(3286),
    [sym_nil] = ACTIONS(3286),
    [anon_sym_QMARK_DOT] = ACTIONS(3286),
    [anon_sym_POUND_LBRACK] = ACTIONS(3286),
    [anon_sym_if] = ACTIONS(3286),
    [anon_sym_DOLLARif] = ACTIONS(3286),
    [anon_sym_is] = ACTIONS(3286),
    [anon_sym_BANGis] = ACTIONS(3286),
    [anon_sym_in] = ACTIONS(3286),
    [anon_sym_BANGin] = ACTIONS(3286),
    [anon_sym_match] = ACTIONS(3286),
    [anon_sym_select] = ACTIONS(3286),
    [anon_sym_lock] = ACTIONS(3286),
    [anon_sym_rlock] = ACTIONS(3286),
    [anon_sym_unsafe] = ACTIONS(3286),
    [anon_sym_sql] = ACTIONS(3286),
    [sym_int_literal] = ACTIONS(3286),
    [sym_float_literal] = ACTIONS(3286),
    [sym_rune_literal] = ACTIONS(3286),
    [anon_sym_SQUOTE] = ACTIONS(3286),
    [anon_sym_DQUOTE] = ACTIONS(3286),
    [anon_sym_c_SQUOTE] = ACTIONS(3286),
    [anon_sym_c_DQUOTE] = ACTIONS(3286),
    [anon_sym_r_SQUOTE] = ACTIONS(3286),
    [anon_sym_r_DQUOTE] = ACTIONS(3286),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3286),
    [anon_sym_shared] = ACTIONS(3286),
    [anon_sym_map_LBRACK] = ACTIONS(3286),
    [anon_sym_chan] = ACTIONS(3286),
    [anon_sym_thread] = ACTIONS(3286),
    [anon_sym_atomic] = ACTIONS(3286),
    [anon_sym_assert] = ACTIONS(3286),
    [anon_sym_defer] = ACTIONS(3286),
    [anon_sym_goto] = ACTIONS(3286),
    [anon_sym_break] = ACTIONS(3286),
    [anon_sym_continue] = ACTIONS(3286),
    [anon_sym_return] = ACTIONS(3286),
    [anon_sym_DOLLARfor] = ACTIONS(3286),
    [anon_sym_for] = ACTIONS(3286),
    [anon_sym_POUND] = ACTIONS(3286),
    [anon_sym_asm] = ACTIONS(3286),
  },
  [1345] = {
    [sym_line_comment] = STATE(1345),
    [sym_block_comment] = STATE(1345),
    [sym_identifier] = ACTIONS(2377),
    [anon_sym_LF] = ACTIONS(2377),
    [anon_sym_CR] = ACTIONS(2377),
    [anon_sym_CR_LF] = ACTIONS(2377),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2377),
    [anon_sym_DOT] = ACTIONS(2377),
    [anon_sym_as] = ACTIONS(2377),
    [anon_sym_LBRACE] = ACTIONS(2377),
    [anon_sym_COMMA] = ACTIONS(2377),
    [anon_sym_RBRACE] = ACTIONS(2377),
    [anon_sym_LPAREN] = ACTIONS(2377),
    [anon_sym_fn] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2377),
    [anon_sym_DASH] = ACTIONS(2377),
    [anon_sym_STAR] = ACTIONS(2377),
    [anon_sym_SLASH] = ACTIONS(2377),
    [anon_sym_PERCENT] = ACTIONS(2377),
    [anon_sym_LT] = ACTIONS(2377),
    [anon_sym_GT] = ACTIONS(2377),
    [anon_sym_EQ_EQ] = ACTIONS(2377),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2377),
    [anon_sym_GT_EQ] = ACTIONS(2377),
    [anon_sym_LBRACK] = ACTIONS(2375),
    [anon_sym_struct] = ACTIONS(2377),
    [anon_sym_mut] = ACTIONS(2377),
    [anon_sym_PLUS_PLUS] = ACTIONS(2377),
    [anon_sym_DASH_DASH] = ACTIONS(2377),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2377),
    [anon_sym_go] = ACTIONS(2377),
    [anon_sym_spawn] = ACTIONS(2377),
    [anon_sym_json_DOTdecode] = ACTIONS(2377),
    [anon_sym_PIPE] = ACTIONS(2377),
    [anon_sym_LBRACK2] = ACTIONS(2377),
    [anon_sym_TILDE] = ACTIONS(2377),
    [anon_sym_CARET] = ACTIONS(2377),
    [anon_sym_AMP] = ACTIONS(2377),
    [anon_sym_LT_DASH] = ACTIONS(2377),
    [anon_sym_LT_LT] = ACTIONS(2377),
    [anon_sym_GT_GT] = ACTIONS(2377),
    [anon_sym_GT_GT_GT] = ACTIONS(2377),
    [anon_sym_AMP_CARET] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_or] = ACTIONS(2377),
    [sym_none] = ACTIONS(2377),
    [sym_true] = ACTIONS(2377),
    [sym_false] = ACTIONS(2377),
    [sym_nil] = ACTIONS(2377),
    [anon_sym_QMARK_DOT] = ACTIONS(2377),
    [anon_sym_POUND_LBRACK] = ACTIONS(2377),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_DOLLARif] = ACTIONS(2377),
    [anon_sym_is] = ACTIONS(2377),
    [anon_sym_BANGis] = ACTIONS(2377),
    [anon_sym_in] = ACTIONS(2377),
    [anon_sym_BANGin] = ACTIONS(2377),
    [anon_sym_match] = ACTIONS(2377),
    [anon_sym_select] = ACTIONS(2377),
    [anon_sym_lock] = ACTIONS(2377),
    [anon_sym_rlock] = ACTIONS(2377),
    [anon_sym_unsafe] = ACTIONS(2377),
    [anon_sym_sql] = ACTIONS(2377),
    [sym_int_literal] = ACTIONS(2377),
    [sym_float_literal] = ACTIONS(2377),
    [sym_rune_literal] = ACTIONS(2377),
    [anon_sym_SQUOTE] = ACTIONS(2377),
    [anon_sym_DQUOTE] = ACTIONS(2377),
    [anon_sym_c_SQUOTE] = ACTIONS(2377),
    [anon_sym_c_DQUOTE] = ACTIONS(2377),
    [anon_sym_r_SQUOTE] = ACTIONS(2377),
    [anon_sym_r_DQUOTE] = ACTIONS(2377),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2377),
    [anon_sym_shared] = ACTIONS(2377),
    [anon_sym_map_LBRACK] = ACTIONS(2377),
    [anon_sym_chan] = ACTIONS(2377),
    [anon_sym_thread] = ACTIONS(2377),
    [anon_sym_atomic] = ACTIONS(2377),
    [anon_sym_assert] = ACTIONS(2377),
    [anon_sym_defer] = ACTIONS(2377),
    [anon_sym_goto] = ACTIONS(2377),
    [anon_sym_break] = ACTIONS(2377),
    [anon_sym_continue] = ACTIONS(2377),
    [anon_sym_return] = ACTIONS(2377),
    [anon_sym_DOLLARfor] = ACTIONS(2377),
    [anon_sym_for] = ACTIONS(2377),
    [anon_sym_POUND] = ACTIONS(2377),
    [anon_sym_asm] = ACTIONS(2377),
  },
  [1346] = {
    [sym_line_comment] = STATE(1346),
    [sym_block_comment] = STATE(1346),
    [sym_identifier] = ACTIONS(3280),
    [anon_sym_LF] = ACTIONS(3280),
    [anon_sym_CR] = ACTIONS(3280),
    [anon_sym_CR_LF] = ACTIONS(3280),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3280),
    [anon_sym_DOT] = ACTIONS(3280),
    [anon_sym_as] = ACTIONS(3280),
    [anon_sym_LBRACE] = ACTIONS(3280),
    [anon_sym_COMMA] = ACTIONS(3280),
    [anon_sym_RBRACE] = ACTIONS(3280),
    [anon_sym_LPAREN] = ACTIONS(3280),
    [anon_sym_fn] = ACTIONS(3280),
    [anon_sym_PLUS] = ACTIONS(3280),
    [anon_sym_DASH] = ACTIONS(3280),
    [anon_sym_STAR] = ACTIONS(3280),
    [anon_sym_SLASH] = ACTIONS(3280),
    [anon_sym_PERCENT] = ACTIONS(3280),
    [anon_sym_LT] = ACTIONS(3280),
    [anon_sym_GT] = ACTIONS(3280),
    [anon_sym_EQ_EQ] = ACTIONS(3280),
    [anon_sym_BANG_EQ] = ACTIONS(3280),
    [anon_sym_LT_EQ] = ACTIONS(3280),
    [anon_sym_GT_EQ] = ACTIONS(3280),
    [anon_sym_LBRACK] = ACTIONS(3278),
    [anon_sym_struct] = ACTIONS(3280),
    [anon_sym_mut] = ACTIONS(3280),
    [anon_sym_PLUS_PLUS] = ACTIONS(3280),
    [anon_sym_DASH_DASH] = ACTIONS(3280),
    [anon_sym_QMARK] = ACTIONS(3280),
    [anon_sym_BANG] = ACTIONS(3280),
    [anon_sym_go] = ACTIONS(3280),
    [anon_sym_spawn] = ACTIONS(3280),
    [anon_sym_json_DOTdecode] = ACTIONS(3280),
    [anon_sym_PIPE] = ACTIONS(3280),
    [anon_sym_LBRACK2] = ACTIONS(3280),
    [anon_sym_TILDE] = ACTIONS(3280),
    [anon_sym_CARET] = ACTIONS(3280),
    [anon_sym_AMP] = ACTIONS(3280),
    [anon_sym_LT_DASH] = ACTIONS(3280),
    [anon_sym_LT_LT] = ACTIONS(3280),
    [anon_sym_GT_GT] = ACTIONS(3280),
    [anon_sym_GT_GT_GT] = ACTIONS(3280),
    [anon_sym_AMP_CARET] = ACTIONS(3280),
    [anon_sym_AMP_AMP] = ACTIONS(3280),
    [anon_sym_PIPE_PIPE] = ACTIONS(3280),
    [anon_sym_or] = ACTIONS(3280),
    [sym_none] = ACTIONS(3280),
    [sym_true] = ACTIONS(3280),
    [sym_false] = ACTIONS(3280),
    [sym_nil] = ACTIONS(3280),
    [anon_sym_QMARK_DOT] = ACTIONS(3280),
    [anon_sym_POUND_LBRACK] = ACTIONS(3280),
    [anon_sym_if] = ACTIONS(3280),
    [anon_sym_DOLLARif] = ACTIONS(3280),
    [anon_sym_is] = ACTIONS(3280),
    [anon_sym_BANGis] = ACTIONS(3280),
    [anon_sym_in] = ACTIONS(3280),
    [anon_sym_BANGin] = ACTIONS(3280),
    [anon_sym_match] = ACTIONS(3280),
    [anon_sym_select] = ACTIONS(3280),
    [anon_sym_lock] = ACTIONS(3280),
    [anon_sym_rlock] = ACTIONS(3280),
    [anon_sym_unsafe] = ACTIONS(3280),
    [anon_sym_sql] = ACTIONS(3280),
    [sym_int_literal] = ACTIONS(3280),
    [sym_float_literal] = ACTIONS(3280),
    [sym_rune_literal] = ACTIONS(3280),
    [anon_sym_SQUOTE] = ACTIONS(3280),
    [anon_sym_DQUOTE] = ACTIONS(3280),
    [anon_sym_c_SQUOTE] = ACTIONS(3280),
    [anon_sym_c_DQUOTE] = ACTIONS(3280),
    [anon_sym_r_SQUOTE] = ACTIONS(3280),
    [anon_sym_r_DQUOTE] = ACTIONS(3280),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3280),
    [anon_sym_shared] = ACTIONS(3280),
    [anon_sym_map_LBRACK] = ACTIONS(3280),
    [anon_sym_chan] = ACTIONS(3280),
    [anon_sym_thread] = ACTIONS(3280),
    [anon_sym_atomic] = ACTIONS(3280),
    [anon_sym_assert] = ACTIONS(3280),
    [anon_sym_defer] = ACTIONS(3280),
    [anon_sym_goto] = ACTIONS(3280),
    [anon_sym_break] = ACTIONS(3280),
    [anon_sym_continue] = ACTIONS(3280),
    [anon_sym_return] = ACTIONS(3280),
    [anon_sym_DOLLARfor] = ACTIONS(3280),
    [anon_sym_for] = ACTIONS(3280),
    [anon_sym_POUND] = ACTIONS(3280),
    [anon_sym_asm] = ACTIONS(3280),
  },
  [1347] = {
    [sym_line_comment] = STATE(1347),
    [sym_block_comment] = STATE(1347),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_LF] = ACTIONS(2841),
    [anon_sym_CR] = ACTIONS(2841),
    [anon_sym_CR_LF] = ACTIONS(2841),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym_DOT] = ACTIONS(2841),
    [anon_sym_as] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_RBRACE] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2841),
    [anon_sym_fn] = ACTIONS(2841),
    [anon_sym_PLUS] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(2841),
    [anon_sym_SLASH] = ACTIONS(2841),
    [anon_sym_PERCENT] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_GT] = ACTIONS(2841),
    [anon_sym_EQ_EQ] = ACTIONS(2841),
    [anon_sym_BANG_EQ] = ACTIONS(2841),
    [anon_sym_LT_EQ] = ACTIONS(2841),
    [anon_sym_GT_EQ] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_struct] = ACTIONS(2841),
    [anon_sym_mut] = ACTIONS(2841),
    [anon_sym_PLUS_PLUS] = ACTIONS(2841),
    [anon_sym_DASH_DASH] = ACTIONS(2841),
    [anon_sym_QMARK] = ACTIONS(2841),
    [anon_sym_BANG] = ACTIONS(2841),
    [anon_sym_go] = ACTIONS(2841),
    [anon_sym_spawn] = ACTIONS(2841),
    [anon_sym_json_DOTdecode] = ACTIONS(2841),
    [anon_sym_PIPE] = ACTIONS(2841),
    [anon_sym_LBRACK2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2841),
    [anon_sym_LT_DASH] = ACTIONS(2841),
    [anon_sym_LT_LT] = ACTIONS(2841),
    [anon_sym_GT_GT] = ACTIONS(2841),
    [anon_sym_GT_GT_GT] = ACTIONS(2841),
    [anon_sym_AMP_CARET] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_PIPE_PIPE] = ACTIONS(2841),
    [anon_sym_or] = ACTIONS(2841),
    [sym_none] = ACTIONS(2841),
    [sym_true] = ACTIONS(2841),
    [sym_false] = ACTIONS(2841),
    [sym_nil] = ACTIONS(2841),
    [anon_sym_QMARK_DOT] = ACTIONS(2841),
    [anon_sym_POUND_LBRACK] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2841),
    [anon_sym_DOLLARif] = ACTIONS(2841),
    [anon_sym_is] = ACTIONS(2841),
    [anon_sym_BANGis] = ACTIONS(2841),
    [anon_sym_in] = ACTIONS(2841),
    [anon_sym_BANGin] = ACTIONS(2841),
    [anon_sym_match] = ACTIONS(2841),
    [anon_sym_select] = ACTIONS(2841),
    [anon_sym_lock] = ACTIONS(2841),
    [anon_sym_rlock] = ACTIONS(2841),
    [anon_sym_unsafe] = ACTIONS(2841),
    [anon_sym_sql] = ACTIONS(2841),
    [sym_int_literal] = ACTIONS(2841),
    [sym_float_literal] = ACTIONS(2841),
    [sym_rune_literal] = ACTIONS(2841),
    [anon_sym_SQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE] = ACTIONS(2841),
    [anon_sym_c_SQUOTE] = ACTIONS(2841),
    [anon_sym_c_DQUOTE] = ACTIONS(2841),
    [anon_sym_r_SQUOTE] = ACTIONS(2841),
    [anon_sym_r_DQUOTE] = ACTIONS(2841),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2841),
    [anon_sym_shared] = ACTIONS(2841),
    [anon_sym_map_LBRACK] = ACTIONS(2841),
    [anon_sym_chan] = ACTIONS(2841),
    [anon_sym_thread] = ACTIONS(2841),
    [anon_sym_atomic] = ACTIONS(2841),
    [anon_sym_assert] = ACTIONS(2841),
    [anon_sym_defer] = ACTIONS(2841),
    [anon_sym_goto] = ACTIONS(2841),
    [anon_sym_break] = ACTIONS(2841),
    [anon_sym_continue] = ACTIONS(2841),
    [anon_sym_return] = ACTIONS(2841),
    [anon_sym_DOLLARfor] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2841),
    [anon_sym_POUND] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2841),
  },
  [1348] = {
    [sym_line_comment] = STATE(1348),
    [sym_block_comment] = STATE(1348),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_LF] = ACTIONS(2951),
    [anon_sym_CR] = ACTIONS(2951),
    [anon_sym_CR_LF] = ACTIONS(2951),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym_DOT] = ACTIONS(2951),
    [anon_sym_as] = ACTIONS(2951),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_RBRACE] = ACTIONS(2951),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_fn] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_LT] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2949),
    [anon_sym_struct] = ACTIONS(2951),
    [anon_sym_mut] = ACTIONS(2951),
    [anon_sym_PLUS_PLUS] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2951),
    [anon_sym_QMARK] = ACTIONS(2951),
    [anon_sym_BANG] = ACTIONS(2951),
    [anon_sym_go] = ACTIONS(2951),
    [anon_sym_spawn] = ACTIONS(2951),
    [anon_sym_json_DOTdecode] = ACTIONS(2951),
    [anon_sym_PIPE] = ACTIONS(2951),
    [anon_sym_LBRACK2] = ACTIONS(2951),
    [anon_sym_TILDE] = ACTIONS(2951),
    [anon_sym_CARET] = ACTIONS(2951),
    [anon_sym_AMP] = ACTIONS(2951),
    [anon_sym_LT_DASH] = ACTIONS(2951),
    [anon_sym_LT_LT] = ACTIONS(2951),
    [anon_sym_GT_GT] = ACTIONS(2951),
    [anon_sym_GT_GT_GT] = ACTIONS(2951),
    [anon_sym_AMP_CARET] = ACTIONS(2951),
    [anon_sym_AMP_AMP] = ACTIONS(2951),
    [anon_sym_PIPE_PIPE] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [sym_none] = ACTIONS(2951),
    [sym_true] = ACTIONS(2951),
    [sym_false] = ACTIONS(2951),
    [sym_nil] = ACTIONS(2951),
    [anon_sym_QMARK_DOT] = ACTIONS(2951),
    [anon_sym_POUND_LBRACK] = ACTIONS(2951),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_DOLLARif] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_BANGis] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_BANGin] = ACTIONS(2951),
    [anon_sym_match] = ACTIONS(2951),
    [anon_sym_select] = ACTIONS(2951),
    [anon_sym_lock] = ACTIONS(2951),
    [anon_sym_rlock] = ACTIONS(2951),
    [anon_sym_unsafe] = ACTIONS(2951),
    [anon_sym_sql] = ACTIONS(2951),
    [sym_int_literal] = ACTIONS(2951),
    [sym_float_literal] = ACTIONS(2951),
    [sym_rune_literal] = ACTIONS(2951),
    [anon_sym_SQUOTE] = ACTIONS(2951),
    [anon_sym_DQUOTE] = ACTIONS(2951),
    [anon_sym_c_SQUOTE] = ACTIONS(2951),
    [anon_sym_c_DQUOTE] = ACTIONS(2951),
    [anon_sym_r_SQUOTE] = ACTIONS(2951),
    [anon_sym_r_DQUOTE] = ACTIONS(2951),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2951),
    [anon_sym_shared] = ACTIONS(2951),
    [anon_sym_map_LBRACK] = ACTIONS(2951),
    [anon_sym_chan] = ACTIONS(2951),
    [anon_sym_thread] = ACTIONS(2951),
    [anon_sym_atomic] = ACTIONS(2951),
    [anon_sym_assert] = ACTIONS(2951),
    [anon_sym_defer] = ACTIONS(2951),
    [anon_sym_goto] = ACTIONS(2951),
    [anon_sym_break] = ACTIONS(2951),
    [anon_sym_continue] = ACTIONS(2951),
    [anon_sym_return] = ACTIONS(2951),
    [anon_sym_DOLLARfor] = ACTIONS(2951),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_POUND] = ACTIONS(2951),
    [anon_sym_asm] = ACTIONS(2951),
  },
  [1349] = {
    [sym_line_comment] = STATE(1349),
    [sym_block_comment] = STATE(1349),
    [sym_identifier] = ACTIONS(2929),
    [anon_sym_LF] = ACTIONS(2929),
    [anon_sym_CR] = ACTIONS(2929),
    [anon_sym_CR_LF] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2929),
    [anon_sym_DOT] = ACTIONS(2929),
    [anon_sym_as] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2929),
    [anon_sym_COMMA] = ACTIONS(2929),
    [anon_sym_RBRACE] = ACTIONS(2929),
    [anon_sym_LPAREN] = ACTIONS(2929),
    [anon_sym_fn] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2929),
    [anon_sym_GT] = ACTIONS(2929),
    [anon_sym_EQ_EQ] = ACTIONS(2929),
    [anon_sym_BANG_EQ] = ACTIONS(2929),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2929),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2929),
    [anon_sym_mut] = ACTIONS(2929),
    [anon_sym_PLUS_PLUS] = ACTIONS(2929),
    [anon_sym_DASH_DASH] = ACTIONS(2929),
    [anon_sym_QMARK] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2929),
    [anon_sym_go] = ACTIONS(2929),
    [anon_sym_spawn] = ACTIONS(2929),
    [anon_sym_json_DOTdecode] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(2929),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2929),
    [anon_sym_CARET] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_LT_DASH] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(2929),
    [anon_sym_GT_GT] = ACTIONS(2929),
    [anon_sym_GT_GT_GT] = ACTIONS(2929),
    [anon_sym_AMP_CARET] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_or] = ACTIONS(2929),
    [sym_none] = ACTIONS(2929),
    [sym_true] = ACTIONS(2929),
    [sym_false] = ACTIONS(2929),
    [sym_nil] = ACTIONS(2929),
    [anon_sym_QMARK_DOT] = ACTIONS(2929),
    [anon_sym_POUND_LBRACK] = ACTIONS(2929),
    [anon_sym_if] = ACTIONS(2929),
    [anon_sym_DOLLARif] = ACTIONS(2929),
    [anon_sym_is] = ACTIONS(2929),
    [anon_sym_BANGis] = ACTIONS(2929),
    [anon_sym_in] = ACTIONS(2929),
    [anon_sym_BANGin] = ACTIONS(2929),
    [anon_sym_match] = ACTIONS(2929),
    [anon_sym_select] = ACTIONS(2929),
    [anon_sym_lock] = ACTIONS(2929),
    [anon_sym_rlock] = ACTIONS(2929),
    [anon_sym_unsafe] = ACTIONS(2929),
    [anon_sym_sql] = ACTIONS(2929),
    [sym_int_literal] = ACTIONS(2929),
    [sym_float_literal] = ACTIONS(2929),
    [sym_rune_literal] = ACTIONS(2929),
    [anon_sym_SQUOTE] = ACTIONS(2929),
    [anon_sym_DQUOTE] = ACTIONS(2929),
    [anon_sym_c_SQUOTE] = ACTIONS(2929),
    [anon_sym_c_DQUOTE] = ACTIONS(2929),
    [anon_sym_r_SQUOTE] = ACTIONS(2929),
    [anon_sym_r_DQUOTE] = ACTIONS(2929),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2929),
    [anon_sym_shared] = ACTIONS(2929),
    [anon_sym_map_LBRACK] = ACTIONS(2929),
    [anon_sym_chan] = ACTIONS(2929),
    [anon_sym_thread] = ACTIONS(2929),
    [anon_sym_atomic] = ACTIONS(2929),
    [anon_sym_assert] = ACTIONS(2929),
    [anon_sym_defer] = ACTIONS(2929),
    [anon_sym_goto] = ACTIONS(2929),
    [anon_sym_break] = ACTIONS(2929),
    [anon_sym_continue] = ACTIONS(2929),
    [anon_sym_return] = ACTIONS(2929),
    [anon_sym_DOLLARfor] = ACTIONS(2929),
    [anon_sym_for] = ACTIONS(2929),
    [anon_sym_POUND] = ACTIONS(2929),
    [anon_sym_asm] = ACTIONS(2929),
  },
  [1350] = {
    [sym_line_comment] = STATE(1350),
    [sym_block_comment] = STATE(1350),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_LF] = ACTIONS(2881),
    [anon_sym_CR] = ACTIONS(2881),
    [anon_sym_CR_LF] = ACTIONS(2881),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2881),
    [anon_sym_as] = ACTIONS(2881),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_LPAREN] = ACTIONS(2881),
    [anon_sym_fn] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_SLASH] = ACTIONS(2881),
    [anon_sym_PERCENT] = ACTIONS(2881),
    [anon_sym_LT] = ACTIONS(2881),
    [anon_sym_GT] = ACTIONS(2881),
    [anon_sym_EQ_EQ] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_LT_EQ] = ACTIONS(2881),
    [anon_sym_GT_EQ] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_struct] = ACTIONS(2881),
    [anon_sym_mut] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_go] = ACTIONS(2881),
    [anon_sym_spawn] = ACTIONS(2881),
    [anon_sym_json_DOTdecode] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2881),
    [anon_sym_LBRACK2] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_CARET] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2881),
    [anon_sym_LT_DASH] = ACTIONS(2881),
    [anon_sym_LT_LT] = ACTIONS(2881),
    [anon_sym_GT_GT] = ACTIONS(2881),
    [anon_sym_GT_GT_GT] = ACTIONS(2881),
    [anon_sym_AMP_CARET] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2881),
    [sym_none] = ACTIONS(2881),
    [sym_true] = ACTIONS(2881),
    [sym_false] = ACTIONS(2881),
    [sym_nil] = ACTIONS(2881),
    [anon_sym_QMARK_DOT] = ACTIONS(2881),
    [anon_sym_POUND_LBRACK] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_DOLLARif] = ACTIONS(2881),
    [anon_sym_is] = ACTIONS(2881),
    [anon_sym_BANGis] = ACTIONS(2881),
    [anon_sym_in] = ACTIONS(2881),
    [anon_sym_BANGin] = ACTIONS(2881),
    [anon_sym_match] = ACTIONS(2881),
    [anon_sym_select] = ACTIONS(2881),
    [anon_sym_lock] = ACTIONS(2881),
    [anon_sym_rlock] = ACTIONS(2881),
    [anon_sym_unsafe] = ACTIONS(2881),
    [anon_sym_sql] = ACTIONS(2881),
    [sym_int_literal] = ACTIONS(2881),
    [sym_float_literal] = ACTIONS(2881),
    [sym_rune_literal] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_c_SQUOTE] = ACTIONS(2881),
    [anon_sym_c_DQUOTE] = ACTIONS(2881),
    [anon_sym_r_SQUOTE] = ACTIONS(2881),
    [anon_sym_r_DQUOTE] = ACTIONS(2881),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2881),
    [anon_sym_shared] = ACTIONS(2881),
    [anon_sym_map_LBRACK] = ACTIONS(2881),
    [anon_sym_chan] = ACTIONS(2881),
    [anon_sym_thread] = ACTIONS(2881),
    [anon_sym_atomic] = ACTIONS(2881),
    [anon_sym_assert] = ACTIONS(2881),
    [anon_sym_defer] = ACTIONS(2881),
    [anon_sym_goto] = ACTIONS(2881),
    [anon_sym_break] = ACTIONS(2881),
    [anon_sym_continue] = ACTIONS(2881),
    [anon_sym_return] = ACTIONS(2881),
    [anon_sym_DOLLARfor] = ACTIONS(2881),
    [anon_sym_for] = ACTIONS(2881),
    [anon_sym_POUND] = ACTIONS(2881),
    [anon_sym_asm] = ACTIONS(2881),
  },
  [1351] = {
    [sym_line_comment] = STATE(1351),
    [sym_block_comment] = STATE(1351),
    [sym_identifier] = ACTIONS(2383),
    [anon_sym_LF] = ACTIONS(2383),
    [anon_sym_CR] = ACTIONS(2383),
    [anon_sym_CR_LF] = ACTIONS(2383),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2383),
    [anon_sym_DOT] = ACTIONS(2383),
    [anon_sym_as] = ACTIONS(2383),
    [anon_sym_LBRACE] = ACTIONS(2383),
    [anon_sym_COMMA] = ACTIONS(2383),
    [anon_sym_RBRACE] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2383),
    [anon_sym_fn] = ACTIONS(2383),
    [anon_sym_PLUS] = ACTIONS(2383),
    [anon_sym_DASH] = ACTIONS(2383),
    [anon_sym_STAR] = ACTIONS(2383),
    [anon_sym_SLASH] = ACTIONS(2383),
    [anon_sym_PERCENT] = ACTIONS(2383),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_GT] = ACTIONS(2383),
    [anon_sym_EQ_EQ] = ACTIONS(2383),
    [anon_sym_BANG_EQ] = ACTIONS(2383),
    [anon_sym_LT_EQ] = ACTIONS(2383),
    [anon_sym_GT_EQ] = ACTIONS(2383),
    [anon_sym_LBRACK] = ACTIONS(2381),
    [anon_sym_struct] = ACTIONS(2383),
    [anon_sym_mut] = ACTIONS(2383),
    [anon_sym_PLUS_PLUS] = ACTIONS(2383),
    [anon_sym_DASH_DASH] = ACTIONS(2383),
    [anon_sym_QMARK] = ACTIONS(2383),
    [anon_sym_BANG] = ACTIONS(2383),
    [anon_sym_go] = ACTIONS(2383),
    [anon_sym_spawn] = ACTIONS(2383),
    [anon_sym_json_DOTdecode] = ACTIONS(2383),
    [anon_sym_PIPE] = ACTIONS(2383),
    [anon_sym_LBRACK2] = ACTIONS(2383),
    [anon_sym_TILDE] = ACTIONS(2383),
    [anon_sym_CARET] = ACTIONS(2383),
    [anon_sym_AMP] = ACTIONS(2383),
    [anon_sym_LT_DASH] = ACTIONS(2383),
    [anon_sym_LT_LT] = ACTIONS(2383),
    [anon_sym_GT_GT] = ACTIONS(2383),
    [anon_sym_GT_GT_GT] = ACTIONS(2383),
    [anon_sym_AMP_CARET] = ACTIONS(2383),
    [anon_sym_AMP_AMP] = ACTIONS(2383),
    [anon_sym_PIPE_PIPE] = ACTIONS(2383),
    [anon_sym_or] = ACTIONS(2383),
    [sym_none] = ACTIONS(2383),
    [sym_true] = ACTIONS(2383),
    [sym_false] = ACTIONS(2383),
    [sym_nil] = ACTIONS(2383),
    [anon_sym_QMARK_DOT] = ACTIONS(2383),
    [anon_sym_POUND_LBRACK] = ACTIONS(2383),
    [anon_sym_if] = ACTIONS(2383),
    [anon_sym_DOLLARif] = ACTIONS(2383),
    [anon_sym_is] = ACTIONS(2383),
    [anon_sym_BANGis] = ACTIONS(2383),
    [anon_sym_in] = ACTIONS(2383),
    [anon_sym_BANGin] = ACTIONS(2383),
    [anon_sym_match] = ACTIONS(2383),
    [anon_sym_select] = ACTIONS(2383),
    [anon_sym_lock] = ACTIONS(2383),
    [anon_sym_rlock] = ACTIONS(2383),
    [anon_sym_unsafe] = ACTIONS(2383),
    [anon_sym_sql] = ACTIONS(2383),
    [sym_int_literal] = ACTIONS(2383),
    [sym_float_literal] = ACTIONS(2383),
    [sym_rune_literal] = ACTIONS(2383),
    [anon_sym_SQUOTE] = ACTIONS(2383),
    [anon_sym_DQUOTE] = ACTIONS(2383),
    [anon_sym_c_SQUOTE] = ACTIONS(2383),
    [anon_sym_c_DQUOTE] = ACTIONS(2383),
    [anon_sym_r_SQUOTE] = ACTIONS(2383),
    [anon_sym_r_DQUOTE] = ACTIONS(2383),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2383),
    [anon_sym_shared] = ACTIONS(2383),
    [anon_sym_map_LBRACK] = ACTIONS(2383),
    [anon_sym_chan] = ACTIONS(2383),
    [anon_sym_thread] = ACTIONS(2383),
    [anon_sym_atomic] = ACTIONS(2383),
    [anon_sym_assert] = ACTIONS(2383),
    [anon_sym_defer] = ACTIONS(2383),
    [anon_sym_goto] = ACTIONS(2383),
    [anon_sym_break] = ACTIONS(2383),
    [anon_sym_continue] = ACTIONS(2383),
    [anon_sym_return] = ACTIONS(2383),
    [anon_sym_DOLLARfor] = ACTIONS(2383),
    [anon_sym_for] = ACTIONS(2383),
    [anon_sym_POUND] = ACTIONS(2383),
    [anon_sym_asm] = ACTIONS(2383),
  },
  [1352] = {
    [sym_line_comment] = STATE(1352),
    [sym_block_comment] = STATE(1352),
    [sym_identifier] = ACTIONS(2639),
    [anon_sym_LF] = ACTIONS(2639),
    [anon_sym_CR] = ACTIONS(2639),
    [anon_sym_CR_LF] = ACTIONS(2639),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym_DOT] = ACTIONS(2639),
    [anon_sym_as] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2639),
    [anon_sym_COMMA] = ACTIONS(2639),
    [anon_sym_RBRACE] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(2639),
    [anon_sym_fn] = ACTIONS(2639),
    [anon_sym_PLUS] = ACTIONS(2639),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_SLASH] = ACTIONS(2639),
    [anon_sym_PERCENT] = ACTIONS(2639),
    [anon_sym_LT] = ACTIONS(2639),
    [anon_sym_GT] = ACTIONS(2639),
    [anon_sym_EQ_EQ] = ACTIONS(2639),
    [anon_sym_BANG_EQ] = ACTIONS(2639),
    [anon_sym_LT_EQ] = ACTIONS(2639),
    [anon_sym_GT_EQ] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_mut] = ACTIONS(2639),
    [anon_sym_PLUS_PLUS] = ACTIONS(2639),
    [anon_sym_DASH_DASH] = ACTIONS(2639),
    [anon_sym_QMARK] = ACTIONS(2639),
    [anon_sym_BANG] = ACTIONS(2639),
    [anon_sym_go] = ACTIONS(2639),
    [anon_sym_spawn] = ACTIONS(2639),
    [anon_sym_json_DOTdecode] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_LBRACK2] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_LT_DASH] = ACTIONS(2639),
    [anon_sym_LT_LT] = ACTIONS(2639),
    [anon_sym_GT_GT] = ACTIONS(2639),
    [anon_sym_GT_GT_GT] = ACTIONS(2639),
    [anon_sym_AMP_CARET] = ACTIONS(2639),
    [anon_sym_AMP_AMP] = ACTIONS(2639),
    [anon_sym_PIPE_PIPE] = ACTIONS(2639),
    [anon_sym_or] = ACTIONS(2639),
    [sym_none] = ACTIONS(2639),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [sym_nil] = ACTIONS(2639),
    [anon_sym_QMARK_DOT] = ACTIONS(2639),
    [anon_sym_POUND_LBRACK] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2639),
    [anon_sym_DOLLARif] = ACTIONS(2639),
    [anon_sym_is] = ACTIONS(2639),
    [anon_sym_BANGis] = ACTIONS(2639),
    [anon_sym_in] = ACTIONS(2639),
    [anon_sym_BANGin] = ACTIONS(2639),
    [anon_sym_match] = ACTIONS(2639),
    [anon_sym_select] = ACTIONS(2639),
    [anon_sym_lock] = ACTIONS(2639),
    [anon_sym_rlock] = ACTIONS(2639),
    [anon_sym_unsafe] = ACTIONS(2639),
    [anon_sym_sql] = ACTIONS(2639),
    [sym_int_literal] = ACTIONS(2639),
    [sym_float_literal] = ACTIONS(2639),
    [sym_rune_literal] = ACTIONS(2639),
    [anon_sym_SQUOTE] = ACTIONS(2639),
    [anon_sym_DQUOTE] = ACTIONS(2639),
    [anon_sym_c_SQUOTE] = ACTIONS(2639),
    [anon_sym_c_DQUOTE] = ACTIONS(2639),
    [anon_sym_r_SQUOTE] = ACTIONS(2639),
    [anon_sym_r_DQUOTE] = ACTIONS(2639),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2639),
    [anon_sym_shared] = ACTIONS(2639),
    [anon_sym_map_LBRACK] = ACTIONS(2639),
    [anon_sym_chan] = ACTIONS(2639),
    [anon_sym_thread] = ACTIONS(2639),
    [anon_sym_atomic] = ACTIONS(2639),
    [anon_sym_assert] = ACTIONS(2639),
    [anon_sym_defer] = ACTIONS(2639),
    [anon_sym_goto] = ACTIONS(2639),
    [anon_sym_break] = ACTIONS(2639),
    [anon_sym_continue] = ACTIONS(2639),
    [anon_sym_return] = ACTIONS(2639),
    [anon_sym_DOLLARfor] = ACTIONS(2639),
    [anon_sym_for] = ACTIONS(2639),
    [anon_sym_POUND] = ACTIONS(2639),
    [anon_sym_asm] = ACTIONS(2639),
  },
  [1353] = {
    [sym_line_comment] = STATE(1353),
    [sym_block_comment] = STATE(1353),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_LF] = ACTIONS(3292),
    [anon_sym_CR] = ACTIONS(3292),
    [anon_sym_CR_LF] = ACTIONS(3292),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(3292),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_COMMA] = ACTIONS(3292),
    [anon_sym_RBRACE] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_fn] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_LT] = ACTIONS(3292),
    [anon_sym_GT] = ACTIONS(3292),
    [anon_sym_EQ_EQ] = ACTIONS(3292),
    [anon_sym_BANG_EQ] = ACTIONS(3292),
    [anon_sym_LT_EQ] = ACTIONS(3292),
    [anon_sym_GT_EQ] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3290),
    [anon_sym_struct] = ACTIONS(3292),
    [anon_sym_mut] = ACTIONS(3292),
    [anon_sym_PLUS_PLUS] = ACTIONS(3292),
    [anon_sym_DASH_DASH] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3292),
    [anon_sym_BANG] = ACTIONS(3292),
    [anon_sym_go] = ACTIONS(3292),
    [anon_sym_spawn] = ACTIONS(3292),
    [anon_sym_json_DOTdecode] = ACTIONS(3292),
    [anon_sym_PIPE] = ACTIONS(3292),
    [anon_sym_LBRACK2] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3292),
    [anon_sym_CARET] = ACTIONS(3292),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LT_DASH] = ACTIONS(3292),
    [anon_sym_LT_LT] = ACTIONS(3292),
    [anon_sym_GT_GT] = ACTIONS(3292),
    [anon_sym_GT_GT_GT] = ACTIONS(3292),
    [anon_sym_AMP_CARET] = ACTIONS(3292),
    [anon_sym_AMP_AMP] = ACTIONS(3292),
    [anon_sym_PIPE_PIPE] = ACTIONS(3292),
    [anon_sym_or] = ACTIONS(3292),
    [sym_none] = ACTIONS(3292),
    [sym_true] = ACTIONS(3292),
    [sym_false] = ACTIONS(3292),
    [sym_nil] = ACTIONS(3292),
    [anon_sym_QMARK_DOT] = ACTIONS(3292),
    [anon_sym_POUND_LBRACK] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_DOLLARif] = ACTIONS(3292),
    [anon_sym_is] = ACTIONS(3292),
    [anon_sym_BANGis] = ACTIONS(3292),
    [anon_sym_in] = ACTIONS(3292),
    [anon_sym_BANGin] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_select] = ACTIONS(3292),
    [anon_sym_lock] = ACTIONS(3292),
    [anon_sym_rlock] = ACTIONS(3292),
    [anon_sym_unsafe] = ACTIONS(3292),
    [anon_sym_sql] = ACTIONS(3292),
    [sym_int_literal] = ACTIONS(3292),
    [sym_float_literal] = ACTIONS(3292),
    [sym_rune_literal] = ACTIONS(3292),
    [anon_sym_SQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_c_SQUOTE] = ACTIONS(3292),
    [anon_sym_c_DQUOTE] = ACTIONS(3292),
    [anon_sym_r_SQUOTE] = ACTIONS(3292),
    [anon_sym_r_DQUOTE] = ACTIONS(3292),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3292),
    [anon_sym_shared] = ACTIONS(3292),
    [anon_sym_map_LBRACK] = ACTIONS(3292),
    [anon_sym_chan] = ACTIONS(3292),
    [anon_sym_thread] = ACTIONS(3292),
    [anon_sym_atomic] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_defer] = ACTIONS(3292),
    [anon_sym_goto] = ACTIONS(3292),
    [anon_sym_break] = ACTIONS(3292),
    [anon_sym_continue] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_DOLLARfor] = ACTIONS(3292),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_POUND] = ACTIONS(3292),
    [anon_sym_asm] = ACTIONS(3292),
  },
  [1354] = {
    [sym_line_comment] = STATE(1354),
    [sym_block_comment] = STATE(1354),
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_LF] = ACTIONS(2627),
    [anon_sym_CR] = ACTIONS(2627),
    [anon_sym_CR_LF] = ACTIONS(2627),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2627),
    [anon_sym_DOT] = ACTIONS(2627),
    [anon_sym_as] = ACTIONS(2627),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_COMMA] = ACTIONS(2627),
    [anon_sym_RBRACE] = ACTIONS(2627),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_fn] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_SLASH] = ACTIONS(2627),
    [anon_sym_PERCENT] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2627),
    [anon_sym_GT] = ACTIONS(2627),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT_EQ] = ACTIONS(2627),
    [anon_sym_GT_EQ] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2625),
    [anon_sym_struct] = ACTIONS(2627),
    [anon_sym_mut] = ACTIONS(2627),
    [anon_sym_PLUS_PLUS] = ACTIONS(2627),
    [anon_sym_DASH_DASH] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2627),
    [anon_sym_BANG] = ACTIONS(2627),
    [anon_sym_go] = ACTIONS(2627),
    [anon_sym_spawn] = ACTIONS(2627),
    [anon_sym_json_DOTdecode] = ACTIONS(2627),
    [anon_sym_PIPE] = ACTIONS(2627),
    [anon_sym_LBRACK2] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2627),
    [anon_sym_CARET] = ACTIONS(2627),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_LT_DASH] = ACTIONS(2627),
    [anon_sym_LT_LT] = ACTIONS(2627),
    [anon_sym_GT_GT] = ACTIONS(2627),
    [anon_sym_GT_GT_GT] = ACTIONS(2627),
    [anon_sym_AMP_CARET] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_PIPE_PIPE] = ACTIONS(2627),
    [anon_sym_or] = ACTIONS(2627),
    [sym_none] = ACTIONS(2627),
    [sym_true] = ACTIONS(2627),
    [sym_false] = ACTIONS(2627),
    [sym_nil] = ACTIONS(2627),
    [anon_sym_QMARK_DOT] = ACTIONS(2627),
    [anon_sym_POUND_LBRACK] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_DOLLARif] = ACTIONS(2627),
    [anon_sym_is] = ACTIONS(2627),
    [anon_sym_BANGis] = ACTIONS(2627),
    [anon_sym_in] = ACTIONS(2627),
    [anon_sym_BANGin] = ACTIONS(2627),
    [anon_sym_match] = ACTIONS(2627),
    [anon_sym_select] = ACTIONS(2627),
    [anon_sym_lock] = ACTIONS(2627),
    [anon_sym_rlock] = ACTIONS(2627),
    [anon_sym_unsafe] = ACTIONS(2627),
    [anon_sym_sql] = ACTIONS(2627),
    [sym_int_literal] = ACTIONS(2627),
    [sym_float_literal] = ACTIONS(2627),
    [sym_rune_literal] = ACTIONS(2627),
    [anon_sym_SQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [anon_sym_c_SQUOTE] = ACTIONS(2627),
    [anon_sym_c_DQUOTE] = ACTIONS(2627),
    [anon_sym_r_SQUOTE] = ACTIONS(2627),
    [anon_sym_r_DQUOTE] = ACTIONS(2627),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2627),
    [anon_sym_shared] = ACTIONS(2627),
    [anon_sym_map_LBRACK] = ACTIONS(2627),
    [anon_sym_chan] = ACTIONS(2627),
    [anon_sym_thread] = ACTIONS(2627),
    [anon_sym_atomic] = ACTIONS(2627),
    [anon_sym_assert] = ACTIONS(2627),
    [anon_sym_defer] = ACTIONS(2627),
    [anon_sym_goto] = ACTIONS(2627),
    [anon_sym_break] = ACTIONS(2627),
    [anon_sym_continue] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_DOLLARfor] = ACTIONS(2627),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_POUND] = ACTIONS(2627),
    [anon_sym_asm] = ACTIONS(2627),
  },
  [1355] = {
    [sym_line_comment] = STATE(1355),
    [sym_block_comment] = STATE(1355),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_LF] = ACTIONS(2819),
    [anon_sym_CR] = ACTIONS(2819),
    [anon_sym_CR_LF] = ACTIONS(2819),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2819),
    [anon_sym_DOT] = ACTIONS(2819),
    [anon_sym_as] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(2819),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_fn] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_LT] = ACTIONS(2819),
    [anon_sym_GT] = ACTIONS(2819),
    [anon_sym_EQ_EQ] = ACTIONS(2819),
    [anon_sym_BANG_EQ] = ACTIONS(2819),
    [anon_sym_LT_EQ] = ACTIONS(2819),
    [anon_sym_GT_EQ] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2817),
    [anon_sym_struct] = ACTIONS(2819),
    [anon_sym_mut] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2819),
    [anon_sym_DASH_DASH] = ACTIONS(2819),
    [anon_sym_QMARK] = ACTIONS(2819),
    [anon_sym_BANG] = ACTIONS(2819),
    [anon_sym_go] = ACTIONS(2819),
    [anon_sym_spawn] = ACTIONS(2819),
    [anon_sym_json_DOTdecode] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(2819),
    [anon_sym_LBRACK2] = ACTIONS(2819),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_CARET] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_LT_DASH] = ACTIONS(2819),
    [anon_sym_LT_LT] = ACTIONS(2819),
    [anon_sym_GT_GT] = ACTIONS(2819),
    [anon_sym_GT_GT_GT] = ACTIONS(2819),
    [anon_sym_AMP_CARET] = ACTIONS(2819),
    [anon_sym_AMP_AMP] = ACTIONS(2819),
    [anon_sym_PIPE_PIPE] = ACTIONS(2819),
    [anon_sym_or] = ACTIONS(2819),
    [sym_none] = ACTIONS(2819),
    [sym_true] = ACTIONS(2819),
    [sym_false] = ACTIONS(2819),
    [sym_nil] = ACTIONS(2819),
    [anon_sym_QMARK_DOT] = ACTIONS(2819),
    [anon_sym_POUND_LBRACK] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_DOLLARif] = ACTIONS(2819),
    [anon_sym_is] = ACTIONS(2819),
    [anon_sym_BANGis] = ACTIONS(2819),
    [anon_sym_in] = ACTIONS(2819),
    [anon_sym_BANGin] = ACTIONS(2819),
    [anon_sym_match] = ACTIONS(2819),
    [anon_sym_select] = ACTIONS(2819),
    [anon_sym_lock] = ACTIONS(2819),
    [anon_sym_rlock] = ACTIONS(2819),
    [anon_sym_unsafe] = ACTIONS(2819),
    [anon_sym_sql] = ACTIONS(2819),
    [sym_int_literal] = ACTIONS(2819),
    [sym_float_literal] = ACTIONS(2819),
    [sym_rune_literal] = ACTIONS(2819),
    [anon_sym_SQUOTE] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2819),
    [anon_sym_c_SQUOTE] = ACTIONS(2819),
    [anon_sym_c_DQUOTE] = ACTIONS(2819),
    [anon_sym_r_SQUOTE] = ACTIONS(2819),
    [anon_sym_r_DQUOTE] = ACTIONS(2819),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2819),
    [anon_sym_shared] = ACTIONS(2819),
    [anon_sym_map_LBRACK] = ACTIONS(2819),
    [anon_sym_chan] = ACTIONS(2819),
    [anon_sym_thread] = ACTIONS(2819),
    [anon_sym_atomic] = ACTIONS(2819),
    [anon_sym_assert] = ACTIONS(2819),
    [anon_sym_defer] = ACTIONS(2819),
    [anon_sym_goto] = ACTIONS(2819),
    [anon_sym_break] = ACTIONS(2819),
    [anon_sym_continue] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_DOLLARfor] = ACTIONS(2819),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_POUND] = ACTIONS(2819),
    [anon_sym_asm] = ACTIONS(2819),
  },
  [1356] = {
    [sym_line_comment] = STATE(1356),
    [sym_block_comment] = STATE(1356),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_LF] = ACTIONS(2465),
    [anon_sym_CR] = ACTIONS(2465),
    [anon_sym_CR_LF] = ACTIONS(2465),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2465),
    [anon_sym_DOT] = ACTIONS(2465),
    [anon_sym_as] = ACTIONS(2465),
    [anon_sym_LBRACE] = ACTIONS(2465),
    [anon_sym_COMMA] = ACTIONS(2465),
    [anon_sym_RBRACE] = ACTIONS(2465),
    [anon_sym_LPAREN] = ACTIONS(2465),
    [anon_sym_fn] = ACTIONS(2465),
    [anon_sym_PLUS] = ACTIONS(2465),
    [anon_sym_DASH] = ACTIONS(2465),
    [anon_sym_STAR] = ACTIONS(2465),
    [anon_sym_SLASH] = ACTIONS(2465),
    [anon_sym_PERCENT] = ACTIONS(2465),
    [anon_sym_LT] = ACTIONS(2465),
    [anon_sym_GT] = ACTIONS(2465),
    [anon_sym_EQ_EQ] = ACTIONS(2465),
    [anon_sym_BANG_EQ] = ACTIONS(2465),
    [anon_sym_LT_EQ] = ACTIONS(2465),
    [anon_sym_GT_EQ] = ACTIONS(2465),
    [anon_sym_LBRACK] = ACTIONS(2463),
    [anon_sym_struct] = ACTIONS(2465),
    [anon_sym_mut] = ACTIONS(2465),
    [anon_sym_PLUS_PLUS] = ACTIONS(2465),
    [anon_sym_DASH_DASH] = ACTIONS(2465),
    [anon_sym_QMARK] = ACTIONS(2465),
    [anon_sym_BANG] = ACTIONS(2465),
    [anon_sym_go] = ACTIONS(2465),
    [anon_sym_spawn] = ACTIONS(2465),
    [anon_sym_json_DOTdecode] = ACTIONS(2465),
    [anon_sym_PIPE] = ACTIONS(2465),
    [anon_sym_LBRACK2] = ACTIONS(2465),
    [anon_sym_TILDE] = ACTIONS(2465),
    [anon_sym_CARET] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_LT_DASH] = ACTIONS(2465),
    [anon_sym_LT_LT] = ACTIONS(2465),
    [anon_sym_GT_GT] = ACTIONS(2465),
    [anon_sym_GT_GT_GT] = ACTIONS(2465),
    [anon_sym_AMP_CARET] = ACTIONS(2465),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_PIPE_PIPE] = ACTIONS(2465),
    [anon_sym_or] = ACTIONS(2465),
    [sym_none] = ACTIONS(2465),
    [sym_true] = ACTIONS(2465),
    [sym_false] = ACTIONS(2465),
    [sym_nil] = ACTIONS(2465),
    [anon_sym_QMARK_DOT] = ACTIONS(2465),
    [anon_sym_POUND_LBRACK] = ACTIONS(2465),
    [anon_sym_if] = ACTIONS(2465),
    [anon_sym_DOLLARif] = ACTIONS(2465),
    [anon_sym_is] = ACTIONS(2465),
    [anon_sym_BANGis] = ACTIONS(2465),
    [anon_sym_in] = ACTIONS(2465),
    [anon_sym_BANGin] = ACTIONS(2465),
    [anon_sym_match] = ACTIONS(2465),
    [anon_sym_select] = ACTIONS(2465),
    [anon_sym_lock] = ACTIONS(2465),
    [anon_sym_rlock] = ACTIONS(2465),
    [anon_sym_unsafe] = ACTIONS(2465),
    [anon_sym_sql] = ACTIONS(2465),
    [sym_int_literal] = ACTIONS(2465),
    [sym_float_literal] = ACTIONS(2465),
    [sym_rune_literal] = ACTIONS(2465),
    [anon_sym_SQUOTE] = ACTIONS(2465),
    [anon_sym_DQUOTE] = ACTIONS(2465),
    [anon_sym_c_SQUOTE] = ACTIONS(2465),
    [anon_sym_c_DQUOTE] = ACTIONS(2465),
    [anon_sym_r_SQUOTE] = ACTIONS(2465),
    [anon_sym_r_DQUOTE] = ACTIONS(2465),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2465),
    [anon_sym_shared] = ACTIONS(2465),
    [anon_sym_map_LBRACK] = ACTIONS(2465),
    [anon_sym_chan] = ACTIONS(2465),
    [anon_sym_thread] = ACTIONS(2465),
    [anon_sym_atomic] = ACTIONS(2465),
    [anon_sym_assert] = ACTIONS(2465),
    [anon_sym_defer] = ACTIONS(2465),
    [anon_sym_goto] = ACTIONS(2465),
    [anon_sym_break] = ACTIONS(2465),
    [anon_sym_continue] = ACTIONS(2465),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_DOLLARfor] = ACTIONS(2465),
    [anon_sym_for] = ACTIONS(2465),
    [anon_sym_POUND] = ACTIONS(2465),
    [anon_sym_asm] = ACTIONS(2465),
  },
  [1357] = {
    [sym_line_comment] = STATE(1357),
    [sym_block_comment] = STATE(1357),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_LF] = ACTIONS(3304),
    [anon_sym_CR] = ACTIONS(3304),
    [anon_sym_CR_LF] = ACTIONS(3304),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3304),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_as] = ACTIONS(3304),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_COMMA] = ACTIONS(3304),
    [anon_sym_RBRACE] = ACTIONS(3304),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_fn] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [anon_sym_LT] = ACTIONS(3304),
    [anon_sym_GT] = ACTIONS(3304),
    [anon_sym_EQ_EQ] = ACTIONS(3304),
    [anon_sym_BANG_EQ] = ACTIONS(3304),
    [anon_sym_LT_EQ] = ACTIONS(3304),
    [anon_sym_GT_EQ] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3302),
    [anon_sym_struct] = ACTIONS(3304),
    [anon_sym_mut] = ACTIONS(3304),
    [anon_sym_PLUS_PLUS] = ACTIONS(3304),
    [anon_sym_DASH_DASH] = ACTIONS(3304),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_go] = ACTIONS(3304),
    [anon_sym_spawn] = ACTIONS(3304),
    [anon_sym_json_DOTdecode] = ACTIONS(3304),
    [anon_sym_PIPE] = ACTIONS(3304),
    [anon_sym_LBRACK2] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LT_DASH] = ACTIONS(3304),
    [anon_sym_LT_LT] = ACTIONS(3304),
    [anon_sym_GT_GT] = ACTIONS(3304),
    [anon_sym_GT_GT_GT] = ACTIONS(3304),
    [anon_sym_AMP_CARET] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_PIPE_PIPE] = ACTIONS(3304),
    [anon_sym_or] = ACTIONS(3304),
    [sym_none] = ACTIONS(3304),
    [sym_true] = ACTIONS(3304),
    [sym_false] = ACTIONS(3304),
    [sym_nil] = ACTIONS(3304),
    [anon_sym_QMARK_DOT] = ACTIONS(3304),
    [anon_sym_POUND_LBRACK] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_DOLLARif] = ACTIONS(3304),
    [anon_sym_is] = ACTIONS(3304),
    [anon_sym_BANGis] = ACTIONS(3304),
    [anon_sym_in] = ACTIONS(3304),
    [anon_sym_BANGin] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_select] = ACTIONS(3304),
    [anon_sym_lock] = ACTIONS(3304),
    [anon_sym_rlock] = ACTIONS(3304),
    [anon_sym_unsafe] = ACTIONS(3304),
    [anon_sym_sql] = ACTIONS(3304),
    [sym_int_literal] = ACTIONS(3304),
    [sym_float_literal] = ACTIONS(3304),
    [sym_rune_literal] = ACTIONS(3304),
    [anon_sym_SQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_c_SQUOTE] = ACTIONS(3304),
    [anon_sym_c_DQUOTE] = ACTIONS(3304),
    [anon_sym_r_SQUOTE] = ACTIONS(3304),
    [anon_sym_r_DQUOTE] = ACTIONS(3304),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3304),
    [anon_sym_shared] = ACTIONS(3304),
    [anon_sym_map_LBRACK] = ACTIONS(3304),
    [anon_sym_chan] = ACTIONS(3304),
    [anon_sym_thread] = ACTIONS(3304),
    [anon_sym_atomic] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_defer] = ACTIONS(3304),
    [anon_sym_goto] = ACTIONS(3304),
    [anon_sym_break] = ACTIONS(3304),
    [anon_sym_continue] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_DOLLARfor] = ACTIONS(3304),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_POUND] = ACTIONS(3304),
    [anon_sym_asm] = ACTIONS(3304),
  },
  [1358] = {
    [sym_line_comment] = STATE(1358),
    [sym_block_comment] = STATE(1358),
    [sym_identifier] = ACTIONS(2647),
    [anon_sym_LF] = ACTIONS(2647),
    [anon_sym_CR] = ACTIONS(2647),
    [anon_sym_CR_LF] = ACTIONS(2647),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2647),
    [anon_sym_DOT] = ACTIONS(2647),
    [anon_sym_as] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_RBRACE] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_fn] = ACTIONS(2647),
    [anon_sym_PLUS] = ACTIONS(2647),
    [anon_sym_DASH] = ACTIONS(2647),
    [anon_sym_STAR] = ACTIONS(2647),
    [anon_sym_SLASH] = ACTIONS(2647),
    [anon_sym_PERCENT] = ACTIONS(2647),
    [anon_sym_LT] = ACTIONS(2647),
    [anon_sym_GT] = ACTIONS(2647),
    [anon_sym_EQ_EQ] = ACTIONS(2647),
    [anon_sym_BANG_EQ] = ACTIONS(2647),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_struct] = ACTIONS(2647),
    [anon_sym_mut] = ACTIONS(2647),
    [anon_sym_PLUS_PLUS] = ACTIONS(2647),
    [anon_sym_DASH_DASH] = ACTIONS(2647),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_go] = ACTIONS(2647),
    [anon_sym_spawn] = ACTIONS(2647),
    [anon_sym_json_DOTdecode] = ACTIONS(2647),
    [anon_sym_PIPE] = ACTIONS(2647),
    [anon_sym_LBRACK2] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [anon_sym_CARET] = ACTIONS(2647),
    [anon_sym_AMP] = ACTIONS(2647),
    [anon_sym_LT_DASH] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2647),
    [anon_sym_GT_GT] = ACTIONS(2647),
    [anon_sym_GT_GT_GT] = ACTIONS(2647),
    [anon_sym_AMP_CARET] = ACTIONS(2647),
    [anon_sym_AMP_AMP] = ACTIONS(2647),
    [anon_sym_PIPE_PIPE] = ACTIONS(2647),
    [anon_sym_or] = ACTIONS(2647),
    [sym_none] = ACTIONS(2647),
    [sym_true] = ACTIONS(2647),
    [sym_false] = ACTIONS(2647),
    [sym_nil] = ACTIONS(2647),
    [anon_sym_QMARK_DOT] = ACTIONS(2647),
    [anon_sym_POUND_LBRACK] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(2647),
    [anon_sym_DOLLARif] = ACTIONS(2647),
    [anon_sym_is] = ACTIONS(2647),
    [anon_sym_BANGis] = ACTIONS(2647),
    [anon_sym_in] = ACTIONS(2647),
    [anon_sym_BANGin] = ACTIONS(2647),
    [anon_sym_match] = ACTIONS(2647),
    [anon_sym_select] = ACTIONS(2647),
    [anon_sym_lock] = ACTIONS(2647),
    [anon_sym_rlock] = ACTIONS(2647),
    [anon_sym_unsafe] = ACTIONS(2647),
    [anon_sym_sql] = ACTIONS(2647),
    [sym_int_literal] = ACTIONS(2647),
    [sym_float_literal] = ACTIONS(2647),
    [sym_rune_literal] = ACTIONS(2647),
    [anon_sym_SQUOTE] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(2647),
    [anon_sym_c_SQUOTE] = ACTIONS(2647),
    [anon_sym_c_DQUOTE] = ACTIONS(2647),
    [anon_sym_r_SQUOTE] = ACTIONS(2647),
    [anon_sym_r_DQUOTE] = ACTIONS(2647),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2647),
    [anon_sym_shared] = ACTIONS(2647),
    [anon_sym_map_LBRACK] = ACTIONS(2647),
    [anon_sym_chan] = ACTIONS(2647),
    [anon_sym_thread] = ACTIONS(2647),
    [anon_sym_atomic] = ACTIONS(2647),
    [anon_sym_assert] = ACTIONS(2647),
    [anon_sym_defer] = ACTIONS(2647),
    [anon_sym_goto] = ACTIONS(2647),
    [anon_sym_break] = ACTIONS(2647),
    [anon_sym_continue] = ACTIONS(2647),
    [anon_sym_return] = ACTIONS(2647),
    [anon_sym_DOLLARfor] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2647),
    [anon_sym_POUND] = ACTIONS(2647),
    [anon_sym_asm] = ACTIONS(2647),
  },
  [1359] = {
    [sym_line_comment] = STATE(1359),
    [sym_block_comment] = STATE(1359),
    [sym_identifier] = ACTIONS(2993),
    [anon_sym_LF] = ACTIONS(2993),
    [anon_sym_CR] = ACTIONS(2993),
    [anon_sym_CR_LF] = ACTIONS(2993),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2993),
    [anon_sym_DOT] = ACTIONS(2993),
    [anon_sym_as] = ACTIONS(2993),
    [anon_sym_LBRACE] = ACTIONS(2993),
    [anon_sym_COMMA] = ACTIONS(2993),
    [anon_sym_RBRACE] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2993),
    [anon_sym_fn] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2993),
    [anon_sym_DASH] = ACTIONS(2993),
    [anon_sym_STAR] = ACTIONS(2993),
    [anon_sym_SLASH] = ACTIONS(2993),
    [anon_sym_PERCENT] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(2993),
    [anon_sym_EQ_EQ] = ACTIONS(2993),
    [anon_sym_BANG_EQ] = ACTIONS(2993),
    [anon_sym_LT_EQ] = ACTIONS(2993),
    [anon_sym_GT_EQ] = ACTIONS(2993),
    [anon_sym_LBRACK] = ACTIONS(2991),
    [anon_sym_struct] = ACTIONS(2993),
    [anon_sym_mut] = ACTIONS(2993),
    [anon_sym_PLUS_PLUS] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2993),
    [anon_sym_QMARK] = ACTIONS(2993),
    [anon_sym_BANG] = ACTIONS(2993),
    [anon_sym_go] = ACTIONS(2993),
    [anon_sym_spawn] = ACTIONS(2993),
    [anon_sym_json_DOTdecode] = ACTIONS(2993),
    [anon_sym_PIPE] = ACTIONS(2993),
    [anon_sym_LBRACK2] = ACTIONS(2993),
    [anon_sym_TILDE] = ACTIONS(2993),
    [anon_sym_CARET] = ACTIONS(2993),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_LT_DASH] = ACTIONS(2993),
    [anon_sym_LT_LT] = ACTIONS(2993),
    [anon_sym_GT_GT] = ACTIONS(2993),
    [anon_sym_GT_GT_GT] = ACTIONS(2993),
    [anon_sym_AMP_CARET] = ACTIONS(2993),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [anon_sym_or] = ACTIONS(2993),
    [sym_none] = ACTIONS(2993),
    [sym_true] = ACTIONS(2993),
    [sym_false] = ACTIONS(2993),
    [sym_nil] = ACTIONS(2993),
    [anon_sym_QMARK_DOT] = ACTIONS(2993),
    [anon_sym_POUND_LBRACK] = ACTIONS(2993),
    [anon_sym_if] = ACTIONS(2993),
    [anon_sym_DOLLARif] = ACTIONS(2993),
    [anon_sym_is] = ACTIONS(2993),
    [anon_sym_BANGis] = ACTIONS(2993),
    [anon_sym_in] = ACTIONS(2993),
    [anon_sym_BANGin] = ACTIONS(2993),
    [anon_sym_match] = ACTIONS(2993),
    [anon_sym_select] = ACTIONS(2993),
    [anon_sym_lock] = ACTIONS(2993),
    [anon_sym_rlock] = ACTIONS(2993),
    [anon_sym_unsafe] = ACTIONS(2993),
    [anon_sym_sql] = ACTIONS(2993),
    [sym_int_literal] = ACTIONS(2993),
    [sym_float_literal] = ACTIONS(2993),
    [sym_rune_literal] = ACTIONS(2993),
    [anon_sym_SQUOTE] = ACTIONS(2993),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [anon_sym_c_SQUOTE] = ACTIONS(2993),
    [anon_sym_c_DQUOTE] = ACTIONS(2993),
    [anon_sym_r_SQUOTE] = ACTIONS(2993),
    [anon_sym_r_DQUOTE] = ACTIONS(2993),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2993),
    [anon_sym_shared] = ACTIONS(2993),
    [anon_sym_map_LBRACK] = ACTIONS(2993),
    [anon_sym_chan] = ACTIONS(2993),
    [anon_sym_thread] = ACTIONS(2993),
    [anon_sym_atomic] = ACTIONS(2993),
    [anon_sym_assert] = ACTIONS(2993),
    [anon_sym_defer] = ACTIONS(2993),
    [anon_sym_goto] = ACTIONS(2993),
    [anon_sym_break] = ACTIONS(2993),
    [anon_sym_continue] = ACTIONS(2993),
    [anon_sym_return] = ACTIONS(2993),
    [anon_sym_DOLLARfor] = ACTIONS(2993),
    [anon_sym_for] = ACTIONS(2993),
    [anon_sym_POUND] = ACTIONS(2993),
    [anon_sym_asm] = ACTIONS(2993),
  },
  [1360] = {
    [sym_line_comment] = STATE(1360),
    [sym_block_comment] = STATE(1360),
    [sym_identifier] = ACTIONS(2659),
    [anon_sym_LF] = ACTIONS(2659),
    [anon_sym_CR] = ACTIONS(2659),
    [anon_sym_CR_LF] = ACTIONS(2659),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2659),
    [anon_sym_DOT] = ACTIONS(2659),
    [anon_sym_as] = ACTIONS(2659),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_COMMA] = ACTIONS(2659),
    [anon_sym_RBRACE] = ACTIONS(2659),
    [anon_sym_LPAREN] = ACTIONS(2659),
    [anon_sym_fn] = ACTIONS(2659),
    [anon_sym_PLUS] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_SLASH] = ACTIONS(2659),
    [anon_sym_PERCENT] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(2659),
    [anon_sym_GT] = ACTIONS(2659),
    [anon_sym_EQ_EQ] = ACTIONS(2659),
    [anon_sym_BANG_EQ] = ACTIONS(2659),
    [anon_sym_LT_EQ] = ACTIONS(2659),
    [anon_sym_GT_EQ] = ACTIONS(2659),
    [anon_sym_LBRACK] = ACTIONS(2657),
    [anon_sym_struct] = ACTIONS(2659),
    [anon_sym_mut] = ACTIONS(2659),
    [anon_sym_PLUS_PLUS] = ACTIONS(2659),
    [anon_sym_DASH_DASH] = ACTIONS(2659),
    [anon_sym_QMARK] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_go] = ACTIONS(2659),
    [anon_sym_spawn] = ACTIONS(2659),
    [anon_sym_json_DOTdecode] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(2659),
    [anon_sym_LBRACK2] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_CARET] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2659),
    [anon_sym_LT_DASH] = ACTIONS(2659),
    [anon_sym_LT_LT] = ACTIONS(2659),
    [anon_sym_GT_GT] = ACTIONS(2659),
    [anon_sym_GT_GT_GT] = ACTIONS(2659),
    [anon_sym_AMP_CARET] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_PIPE_PIPE] = ACTIONS(2659),
    [anon_sym_or] = ACTIONS(2659),
    [sym_none] = ACTIONS(2659),
    [sym_true] = ACTIONS(2659),
    [sym_false] = ACTIONS(2659),
    [sym_nil] = ACTIONS(2659),
    [anon_sym_QMARK_DOT] = ACTIONS(2659),
    [anon_sym_POUND_LBRACK] = ACTIONS(2659),
    [anon_sym_if] = ACTIONS(2659),
    [anon_sym_DOLLARif] = ACTIONS(2659),
    [anon_sym_is] = ACTIONS(2659),
    [anon_sym_BANGis] = ACTIONS(2659),
    [anon_sym_in] = ACTIONS(2659),
    [anon_sym_BANGin] = ACTIONS(2659),
    [anon_sym_match] = ACTIONS(2659),
    [anon_sym_select] = ACTIONS(2659),
    [anon_sym_lock] = ACTIONS(2659),
    [anon_sym_rlock] = ACTIONS(2659),
    [anon_sym_unsafe] = ACTIONS(2659),
    [anon_sym_sql] = ACTIONS(2659),
    [sym_int_literal] = ACTIONS(2659),
    [sym_float_literal] = ACTIONS(2659),
    [sym_rune_literal] = ACTIONS(2659),
    [anon_sym_SQUOTE] = ACTIONS(2659),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [anon_sym_c_SQUOTE] = ACTIONS(2659),
    [anon_sym_c_DQUOTE] = ACTIONS(2659),
    [anon_sym_r_SQUOTE] = ACTIONS(2659),
    [anon_sym_r_DQUOTE] = ACTIONS(2659),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2659),
    [anon_sym_shared] = ACTIONS(2659),
    [anon_sym_map_LBRACK] = ACTIONS(2659),
    [anon_sym_chan] = ACTIONS(2659),
    [anon_sym_thread] = ACTIONS(2659),
    [anon_sym_atomic] = ACTIONS(2659),
    [anon_sym_assert] = ACTIONS(2659),
    [anon_sym_defer] = ACTIONS(2659),
    [anon_sym_goto] = ACTIONS(2659),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_continue] = ACTIONS(2659),
    [anon_sym_return] = ACTIONS(2659),
    [anon_sym_DOLLARfor] = ACTIONS(2659),
    [anon_sym_for] = ACTIONS(2659),
    [anon_sym_POUND] = ACTIONS(2659),
    [anon_sym_asm] = ACTIONS(2659),
  },
  [1361] = {
    [sym_line_comment] = STATE(1361),
    [sym_block_comment] = STATE(1361),
    [sym_identifier] = ACTIONS(2655),
    [anon_sym_LF] = ACTIONS(2655),
    [anon_sym_CR] = ACTIONS(2655),
    [anon_sym_CR_LF] = ACTIONS(2655),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym_DOT] = ACTIONS(2655),
    [anon_sym_as] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2655),
    [anon_sym_COMMA] = ACTIONS(2655),
    [anon_sym_RBRACE] = ACTIONS(2655),
    [anon_sym_LPAREN] = ACTIONS(2655),
    [anon_sym_fn] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_DASH] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_SLASH] = ACTIONS(2655),
    [anon_sym_PERCENT] = ACTIONS(2655),
    [anon_sym_LT] = ACTIONS(2655),
    [anon_sym_GT] = ACTIONS(2655),
    [anon_sym_EQ_EQ] = ACTIONS(2655),
    [anon_sym_BANG_EQ] = ACTIONS(2655),
    [anon_sym_LT_EQ] = ACTIONS(2655),
    [anon_sym_GT_EQ] = ACTIONS(2655),
    [anon_sym_LBRACK] = ACTIONS(2653),
    [anon_sym_struct] = ACTIONS(2655),
    [anon_sym_mut] = ACTIONS(2655),
    [anon_sym_PLUS_PLUS] = ACTIONS(2655),
    [anon_sym_DASH_DASH] = ACTIONS(2655),
    [anon_sym_QMARK] = ACTIONS(2655),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_go] = ACTIONS(2655),
    [anon_sym_spawn] = ACTIONS(2655),
    [anon_sym_json_DOTdecode] = ACTIONS(2655),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_LBRACK2] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [anon_sym_CARET] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2655),
    [anon_sym_LT_DASH] = ACTIONS(2655),
    [anon_sym_LT_LT] = ACTIONS(2655),
    [anon_sym_GT_GT] = ACTIONS(2655),
    [anon_sym_GT_GT_GT] = ACTIONS(2655),
    [anon_sym_AMP_CARET] = ACTIONS(2655),
    [anon_sym_AMP_AMP] = ACTIONS(2655),
    [anon_sym_PIPE_PIPE] = ACTIONS(2655),
    [anon_sym_or] = ACTIONS(2655),
    [sym_none] = ACTIONS(2655),
    [sym_true] = ACTIONS(2655),
    [sym_false] = ACTIONS(2655),
    [sym_nil] = ACTIONS(2655),
    [anon_sym_QMARK_DOT] = ACTIONS(2655),
    [anon_sym_POUND_LBRACK] = ACTIONS(2655),
    [anon_sym_if] = ACTIONS(2655),
    [anon_sym_DOLLARif] = ACTIONS(2655),
    [anon_sym_is] = ACTIONS(2655),
    [anon_sym_BANGis] = ACTIONS(2655),
    [anon_sym_in] = ACTIONS(2655),
    [anon_sym_BANGin] = ACTIONS(2655),
    [anon_sym_match] = ACTIONS(2655),
    [anon_sym_select] = ACTIONS(2655),
    [anon_sym_lock] = ACTIONS(2655),
    [anon_sym_rlock] = ACTIONS(2655),
    [anon_sym_unsafe] = ACTIONS(2655),
    [anon_sym_sql] = ACTIONS(2655),
    [sym_int_literal] = ACTIONS(2655),
    [sym_float_literal] = ACTIONS(2655),
    [sym_rune_literal] = ACTIONS(2655),
    [anon_sym_SQUOTE] = ACTIONS(2655),
    [anon_sym_DQUOTE] = ACTIONS(2655),
    [anon_sym_c_SQUOTE] = ACTIONS(2655),
    [anon_sym_c_DQUOTE] = ACTIONS(2655),
    [anon_sym_r_SQUOTE] = ACTIONS(2655),
    [anon_sym_r_DQUOTE] = ACTIONS(2655),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2655),
    [anon_sym_shared] = ACTIONS(2655),
    [anon_sym_map_LBRACK] = ACTIONS(2655),
    [anon_sym_chan] = ACTIONS(2655),
    [anon_sym_thread] = ACTIONS(2655),
    [anon_sym_atomic] = ACTIONS(2655),
    [anon_sym_assert] = ACTIONS(2655),
    [anon_sym_defer] = ACTIONS(2655),
    [anon_sym_goto] = ACTIONS(2655),
    [anon_sym_break] = ACTIONS(2655),
    [anon_sym_continue] = ACTIONS(2655),
    [anon_sym_return] = ACTIONS(2655),
    [anon_sym_DOLLARfor] = ACTIONS(2655),
    [anon_sym_for] = ACTIONS(2655),
    [anon_sym_POUND] = ACTIONS(2655),
    [anon_sym_asm] = ACTIONS(2655),
  },
  [1362] = {
    [sym_line_comment] = STATE(1362),
    [sym_block_comment] = STATE(1362),
    [sym_identifier] = ACTIONS(2985),
    [anon_sym_LF] = ACTIONS(2985),
    [anon_sym_CR] = ACTIONS(2985),
    [anon_sym_CR_LF] = ACTIONS(2985),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2985),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_as] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2985),
    [anon_sym_RBRACE] = ACTIONS(2985),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_fn] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2985),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_PERCENT] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_EQ_EQ] = ACTIONS(2985),
    [anon_sym_BANG_EQ] = ACTIONS(2985),
    [anon_sym_LT_EQ] = ACTIONS(2985),
    [anon_sym_GT_EQ] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_mut] = ACTIONS(2985),
    [anon_sym_PLUS_PLUS] = ACTIONS(2985),
    [anon_sym_DASH_DASH] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_go] = ACTIONS(2985),
    [anon_sym_spawn] = ACTIONS(2985),
    [anon_sym_json_DOTdecode] = ACTIONS(2985),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(2985),
    [anon_sym_CARET] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_DASH] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2985),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_GT_GT_GT] = ACTIONS(2985),
    [anon_sym_AMP_CARET] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_or] = ACTIONS(2985),
    [sym_none] = ACTIONS(2985),
    [sym_true] = ACTIONS(2985),
    [sym_false] = ACTIONS(2985),
    [sym_nil] = ACTIONS(2985),
    [anon_sym_QMARK_DOT] = ACTIONS(2985),
    [anon_sym_POUND_LBRACK] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_DOLLARif] = ACTIONS(2985),
    [anon_sym_is] = ACTIONS(2985),
    [anon_sym_BANGis] = ACTIONS(2985),
    [anon_sym_in] = ACTIONS(2985),
    [anon_sym_BANGin] = ACTIONS(2985),
    [anon_sym_match] = ACTIONS(2985),
    [anon_sym_select] = ACTIONS(2985),
    [anon_sym_lock] = ACTIONS(2985),
    [anon_sym_rlock] = ACTIONS(2985),
    [anon_sym_unsafe] = ACTIONS(2985),
    [anon_sym_sql] = ACTIONS(2985),
    [sym_int_literal] = ACTIONS(2985),
    [sym_float_literal] = ACTIONS(2985),
    [sym_rune_literal] = ACTIONS(2985),
    [anon_sym_SQUOTE] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_c_SQUOTE] = ACTIONS(2985),
    [anon_sym_c_DQUOTE] = ACTIONS(2985),
    [anon_sym_r_SQUOTE] = ACTIONS(2985),
    [anon_sym_r_DQUOTE] = ACTIONS(2985),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2985),
    [anon_sym_shared] = ACTIONS(2985),
    [anon_sym_map_LBRACK] = ACTIONS(2985),
    [anon_sym_chan] = ACTIONS(2985),
    [anon_sym_thread] = ACTIONS(2985),
    [anon_sym_atomic] = ACTIONS(2985),
    [anon_sym_assert] = ACTIONS(2985),
    [anon_sym_defer] = ACTIONS(2985),
    [anon_sym_goto] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_DOLLARfor] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_POUND] = ACTIONS(2985),
    [anon_sym_asm] = ACTIONS(2985),
  },
  [1363] = {
    [sym_line_comment] = STATE(1363),
    [sym_block_comment] = STATE(1363),
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_LF] = ACTIONS(3045),
    [anon_sym_CR] = ACTIONS(3045),
    [anon_sym_CR_LF] = ACTIONS(3045),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3045),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_as] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3045),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_RBRACE] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3045),
    [anon_sym_fn] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3045),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_PERCENT] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_GT] = ACTIONS(3045),
    [anon_sym_EQ_EQ] = ACTIONS(3045),
    [anon_sym_BANG_EQ] = ACTIONS(3045),
    [anon_sym_LT_EQ] = ACTIONS(3045),
    [anon_sym_GT_EQ] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_struct] = ACTIONS(3045),
    [anon_sym_mut] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3045),
    [anon_sym_go] = ACTIONS(3045),
    [anon_sym_spawn] = ACTIONS(3045),
    [anon_sym_json_DOTdecode] = ACTIONS(3045),
    [anon_sym_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACK2] = ACTIONS(3045),
    [anon_sym_TILDE] = ACTIONS(3045),
    [anon_sym_CARET] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3045),
    [anon_sym_LT_DASH] = ACTIONS(3045),
    [anon_sym_LT_LT] = ACTIONS(3045),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_GT_GT_GT] = ACTIONS(3045),
    [anon_sym_AMP_CARET] = ACTIONS(3045),
    [anon_sym_AMP_AMP] = ACTIONS(3045),
    [anon_sym_PIPE_PIPE] = ACTIONS(3045),
    [anon_sym_or] = ACTIONS(3045),
    [sym_none] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_nil] = ACTIONS(3045),
    [anon_sym_QMARK_DOT] = ACTIONS(3045),
    [anon_sym_POUND_LBRACK] = ACTIONS(3045),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_DOLLARif] = ACTIONS(3045),
    [anon_sym_is] = ACTIONS(3045),
    [anon_sym_BANGis] = ACTIONS(3045),
    [anon_sym_in] = ACTIONS(3045),
    [anon_sym_BANGin] = ACTIONS(3045),
    [anon_sym_match] = ACTIONS(3045),
    [anon_sym_select] = ACTIONS(3045),
    [anon_sym_lock] = ACTIONS(3045),
    [anon_sym_rlock] = ACTIONS(3045),
    [anon_sym_unsafe] = ACTIONS(3045),
    [anon_sym_sql] = ACTIONS(3045),
    [sym_int_literal] = ACTIONS(3045),
    [sym_float_literal] = ACTIONS(3045),
    [sym_rune_literal] = ACTIONS(3045),
    [anon_sym_SQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE] = ACTIONS(3045),
    [anon_sym_c_SQUOTE] = ACTIONS(3045),
    [anon_sym_c_DQUOTE] = ACTIONS(3045),
    [anon_sym_r_SQUOTE] = ACTIONS(3045),
    [anon_sym_r_DQUOTE] = ACTIONS(3045),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3045),
    [anon_sym_shared] = ACTIONS(3045),
    [anon_sym_map_LBRACK] = ACTIONS(3045),
    [anon_sym_chan] = ACTIONS(3045),
    [anon_sym_thread] = ACTIONS(3045),
    [anon_sym_atomic] = ACTIONS(3045),
    [anon_sym_assert] = ACTIONS(3045),
    [anon_sym_defer] = ACTIONS(3045),
    [anon_sym_goto] = ACTIONS(3045),
    [anon_sym_break] = ACTIONS(3045),
    [anon_sym_continue] = ACTIONS(3045),
    [anon_sym_return] = ACTIONS(3045),
    [anon_sym_DOLLARfor] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3045),
    [anon_sym_POUND] = ACTIONS(3045),
    [anon_sym_asm] = ACTIONS(3045),
  },
  [1364] = {
    [sym_line_comment] = STATE(1364),
    [sym_block_comment] = STATE(1364),
    [sym_identifier] = ACTIONS(2935),
    [anon_sym_LF] = ACTIONS(2935),
    [anon_sym_CR] = ACTIONS(2935),
    [anon_sym_CR_LF] = ACTIONS(2935),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2935),
    [anon_sym_DOT] = ACTIONS(2935),
    [anon_sym_as] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(2935),
    [anon_sym_COMMA] = ACTIONS(2935),
    [anon_sym_RBRACE] = ACTIONS(2935),
    [anon_sym_LPAREN] = ACTIONS(2935),
    [anon_sym_fn] = ACTIONS(2935),
    [anon_sym_PLUS] = ACTIONS(2935),
    [anon_sym_DASH] = ACTIONS(2935),
    [anon_sym_STAR] = ACTIONS(2935),
    [anon_sym_SLASH] = ACTIONS(2935),
    [anon_sym_PERCENT] = ACTIONS(2935),
    [anon_sym_LT] = ACTIONS(2935),
    [anon_sym_GT] = ACTIONS(2935),
    [anon_sym_EQ_EQ] = ACTIONS(2935),
    [anon_sym_BANG_EQ] = ACTIONS(2935),
    [anon_sym_LT_EQ] = ACTIONS(2935),
    [anon_sym_GT_EQ] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2933),
    [anon_sym_struct] = ACTIONS(2935),
    [anon_sym_mut] = ACTIONS(2935),
    [anon_sym_PLUS_PLUS] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2935),
    [anon_sym_QMARK] = ACTIONS(2935),
    [anon_sym_BANG] = ACTIONS(2935),
    [anon_sym_go] = ACTIONS(2935),
    [anon_sym_spawn] = ACTIONS(2935),
    [anon_sym_json_DOTdecode] = ACTIONS(2935),
    [anon_sym_PIPE] = ACTIONS(2935),
    [anon_sym_LBRACK2] = ACTIONS(2935),
    [anon_sym_TILDE] = ACTIONS(2935),
    [anon_sym_CARET] = ACTIONS(2935),
    [anon_sym_AMP] = ACTIONS(2935),
    [anon_sym_LT_DASH] = ACTIONS(2935),
    [anon_sym_LT_LT] = ACTIONS(2935),
    [anon_sym_GT_GT] = ACTIONS(2935),
    [anon_sym_GT_GT_GT] = ACTIONS(2935),
    [anon_sym_AMP_CARET] = ACTIONS(2935),
    [anon_sym_AMP_AMP] = ACTIONS(2935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2935),
    [anon_sym_or] = ACTIONS(2935),
    [sym_none] = ACTIONS(2935),
    [sym_true] = ACTIONS(2935),
    [sym_false] = ACTIONS(2935),
    [sym_nil] = ACTIONS(2935),
    [anon_sym_QMARK_DOT] = ACTIONS(2935),
    [anon_sym_POUND_LBRACK] = ACTIONS(2935),
    [anon_sym_if] = ACTIONS(2935),
    [anon_sym_DOLLARif] = ACTIONS(2935),
    [anon_sym_is] = ACTIONS(2935),
    [anon_sym_BANGis] = ACTIONS(2935),
    [anon_sym_in] = ACTIONS(2935),
    [anon_sym_BANGin] = ACTIONS(2935),
    [anon_sym_match] = ACTIONS(2935),
    [anon_sym_select] = ACTIONS(2935),
    [anon_sym_lock] = ACTIONS(2935),
    [anon_sym_rlock] = ACTIONS(2935),
    [anon_sym_unsafe] = ACTIONS(2935),
    [anon_sym_sql] = ACTIONS(2935),
    [sym_int_literal] = ACTIONS(2935),
    [sym_float_literal] = ACTIONS(2935),
    [sym_rune_literal] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(2935),
    [anon_sym_DQUOTE] = ACTIONS(2935),
    [anon_sym_c_SQUOTE] = ACTIONS(2935),
    [anon_sym_c_DQUOTE] = ACTIONS(2935),
    [anon_sym_r_SQUOTE] = ACTIONS(2935),
    [anon_sym_r_DQUOTE] = ACTIONS(2935),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2935),
    [anon_sym_shared] = ACTIONS(2935),
    [anon_sym_map_LBRACK] = ACTIONS(2935),
    [anon_sym_chan] = ACTIONS(2935),
    [anon_sym_thread] = ACTIONS(2935),
    [anon_sym_atomic] = ACTIONS(2935),
    [anon_sym_assert] = ACTIONS(2935),
    [anon_sym_defer] = ACTIONS(2935),
    [anon_sym_goto] = ACTIONS(2935),
    [anon_sym_break] = ACTIONS(2935),
    [anon_sym_continue] = ACTIONS(2935),
    [anon_sym_return] = ACTIONS(2935),
    [anon_sym_DOLLARfor] = ACTIONS(2935),
    [anon_sym_for] = ACTIONS(2935),
    [anon_sym_POUND] = ACTIONS(2935),
    [anon_sym_asm] = ACTIONS(2935),
  },
  [1365] = {
    [sym_line_comment] = STATE(1365),
    [sym_block_comment] = STATE(1365),
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_LF] = ACTIONS(3073),
    [anon_sym_CR] = ACTIONS(3073),
    [anon_sym_CR_LF] = ACTIONS(3073),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_DOT] = ACTIONS(3073),
    [anon_sym_as] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3073),
    [anon_sym_COMMA] = ACTIONS(3073),
    [anon_sym_RBRACE] = ACTIONS(3073),
    [anon_sym_LPAREN] = ACTIONS(3073),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(3073),
    [anon_sym_DASH] = ACTIONS(3073),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_SLASH] = ACTIONS(3073),
    [anon_sym_PERCENT] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_GT] = ACTIONS(3073),
    [anon_sym_EQ_EQ] = ACTIONS(3073),
    [anon_sym_BANG_EQ] = ACTIONS(3073),
    [anon_sym_LT_EQ] = ACTIONS(3073),
    [anon_sym_GT_EQ] = ACTIONS(3073),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3073),
    [anon_sym_mut] = ACTIONS(3073),
    [anon_sym_PLUS_PLUS] = ACTIONS(3073),
    [anon_sym_DASH_DASH] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3073),
    [anon_sym_BANG] = ACTIONS(3073),
    [anon_sym_go] = ACTIONS(3073),
    [anon_sym_spawn] = ACTIONS(3073),
    [anon_sym_json_DOTdecode] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(3073),
    [anon_sym_LBRACK2] = ACTIONS(3073),
    [anon_sym_TILDE] = ACTIONS(3073),
    [anon_sym_CARET] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3073),
    [anon_sym_LT_DASH] = ACTIONS(3073),
    [anon_sym_LT_LT] = ACTIONS(3073),
    [anon_sym_GT_GT] = ACTIONS(3073),
    [anon_sym_GT_GT_GT] = ACTIONS(3073),
    [anon_sym_AMP_CARET] = ACTIONS(3073),
    [anon_sym_AMP_AMP] = ACTIONS(3073),
    [anon_sym_PIPE_PIPE] = ACTIONS(3073),
    [anon_sym_or] = ACTIONS(3073),
    [sym_none] = ACTIONS(3073),
    [sym_true] = ACTIONS(3073),
    [sym_false] = ACTIONS(3073),
    [sym_nil] = ACTIONS(3073),
    [anon_sym_QMARK_DOT] = ACTIONS(3073),
    [anon_sym_POUND_LBRACK] = ACTIONS(3073),
    [anon_sym_if] = ACTIONS(3073),
    [anon_sym_DOLLARif] = ACTIONS(3073),
    [anon_sym_is] = ACTIONS(3073),
    [anon_sym_BANGis] = ACTIONS(3073),
    [anon_sym_in] = ACTIONS(3073),
    [anon_sym_BANGin] = ACTIONS(3073),
    [anon_sym_match] = ACTIONS(3073),
    [anon_sym_select] = ACTIONS(3073),
    [anon_sym_lock] = ACTIONS(3073),
    [anon_sym_rlock] = ACTIONS(3073),
    [anon_sym_unsafe] = ACTIONS(3073),
    [anon_sym_sql] = ACTIONS(3073),
    [sym_int_literal] = ACTIONS(3073),
    [sym_float_literal] = ACTIONS(3073),
    [sym_rune_literal] = ACTIONS(3073),
    [anon_sym_SQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE] = ACTIONS(3073),
    [anon_sym_c_SQUOTE] = ACTIONS(3073),
    [anon_sym_c_DQUOTE] = ACTIONS(3073),
    [anon_sym_r_SQUOTE] = ACTIONS(3073),
    [anon_sym_r_DQUOTE] = ACTIONS(3073),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3073),
    [anon_sym_shared] = ACTIONS(3073),
    [anon_sym_map_LBRACK] = ACTIONS(3073),
    [anon_sym_chan] = ACTIONS(3073),
    [anon_sym_thread] = ACTIONS(3073),
    [anon_sym_atomic] = ACTIONS(3073),
    [anon_sym_assert] = ACTIONS(3073),
    [anon_sym_defer] = ACTIONS(3073),
    [anon_sym_goto] = ACTIONS(3073),
    [anon_sym_break] = ACTIONS(3073),
    [anon_sym_continue] = ACTIONS(3073),
    [anon_sym_return] = ACTIONS(3073),
    [anon_sym_DOLLARfor] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(3073),
    [anon_sym_POUND] = ACTIONS(3073),
    [anon_sym_asm] = ACTIONS(3073),
  },
  [1366] = {
    [sym_line_comment] = STATE(1366),
    [sym_block_comment] = STATE(1366),
    [sym_reference_expression] = STATE(4601),
    [sym_type_reference_expression] = STATE(1730),
    [sym_plain_type] = STATE(1891),
    [sym__plain_type_without_special] = STATE(1875),
    [sym_anon_struct_type] = STATE(1881),
    [sym_multi_return_type] = STATE(1875),
    [sym_result_type] = STATE(1875),
    [sym_option_type] = STATE(1875),
    [sym_qualified_type] = STATE(1730),
    [sym_fixed_array_type] = STATE(1881),
    [sym_array_type] = STATE(1881),
    [sym_pointer_type] = STATE(1881),
    [sym_wrong_pointer_type] = STATE(1881),
    [sym_map_type] = STATE(1881),
    [sym_channel_type] = STATE(1881),
    [sym_shared_type] = STATE(1881),
    [sym_thread_type] = STATE(1881),
    [sym_atomic_type] = STATE(1881),
    [sym_generic_type] = STATE(1881),
    [sym_function_type] = STATE(1881),
    [ts_builtin_sym_end] = ACTIONS(853),
    [sym_identifier] = ACTIONS(4066),
    [anon_sym_LF] = ACTIONS(855),
    [anon_sym_CR] = ACTIONS(855),
    [anon_sym_CR_LF] = ACTIONS(855),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_const] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(4068),
    [anon_sym___global] = ACTIONS(855),
    [anon_sym_type] = ACTIONS(855),
    [anon_sym_fn] = ACTIONS(4070),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(4072),
    [anon_sym_struct] = ACTIONS(4074),
    [anon_sym_union] = ACTIONS(855),
    [anon_sym_pub] = ACTIONS(855),
    [anon_sym_mut] = ACTIONS(855),
    [anon_sym_enum] = ACTIONS(855),
    [anon_sym_interface] = ACTIONS(855),
    [anon_sym_QMARK] = ACTIONS(4076),
    [anon_sym_BANG] = ACTIONS(4078),
    [anon_sym_go] = ACTIONS(855),
    [anon_sym_spawn] = ACTIONS(855),
    [anon_sym_json_DOTdecode] = ACTIONS(855),
    [anon_sym_LBRACK2] = ACTIONS(4080),
    [anon_sym_TILDE] = ACTIONS(855),
    [anon_sym_CARET] = ACTIONS(855),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_LT_DASH] = ACTIONS(855),
    [sym_none] = ACTIONS(855),
    [sym_true] = ACTIONS(855),
    [sym_false] = ACTIONS(855),
    [sym_nil] = ACTIONS(855),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_DOLLARif] = ACTIONS(855),
    [anon_sym_match] = ACTIONS(855),
    [anon_sym_select] = ACTIONS(855),
    [anon_sym_lock] = ACTIONS(855),
    [anon_sym_rlock] = ACTIONS(855),
    [anon_sym_unsafe] = ACTIONS(855),
    [anon_sym_sql] = ACTIONS(855),
    [sym_int_literal] = ACTIONS(855),
    [sym_float_literal] = ACTIONS(855),
    [sym_rune_literal] = ACTIONS(855),
    [anon_sym_SQUOTE] = ACTIONS(855),
    [anon_sym_DQUOTE] = ACTIONS(855),
    [anon_sym_c_SQUOTE] = ACTIONS(855),
    [anon_sym_c_DQUOTE] = ACTIONS(855),
    [anon_sym_r_SQUOTE] = ACTIONS(855),
    [anon_sym_r_DQUOTE] = ACTIONS(855),
    [sym_pseudo_compile_time_identifier] = ACTIONS(855),
    [anon_sym_shared] = ACTIONS(4084),
    [anon_sym_map_LBRACK] = ACTIONS(4086),
    [anon_sym_chan] = ACTIONS(4088),
    [anon_sym_thread] = ACTIONS(4090),
    [anon_sym_atomic] = ACTIONS(4092),
    [anon_sym_assert] = ACTIONS(855),
    [anon_sym_defer] = ACTIONS(855),
    [anon_sym_goto] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(855),
    [anon_sym_continue] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(855),
    [anon_sym_DOLLARfor] = ACTIONS(855),
    [anon_sym_for] = ACTIONS(855),
    [anon_sym_POUND] = ACTIONS(855),
    [anon_sym_asm] = ACTIONS(855),
    [anon_sym_AT_LBRACK] = ACTIONS(855),
  },
  [1367] = {
    [sym_line_comment] = STATE(1367),
    [sym_block_comment] = STATE(1367),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LF] = ACTIONS(2471),
    [anon_sym_CR] = ACTIONS(2471),
    [anon_sym_CR_LF] = ACTIONS(2471),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_DOT] = ACTIONS(2471),
    [anon_sym_as] = ACTIONS(2471),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_COMMA] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_fn] = ACTIONS(2471),
    [anon_sym_PLUS] = ACTIONS(2471),
    [anon_sym_DASH] = ACTIONS(2471),
    [anon_sym_STAR] = ACTIONS(2471),
    [anon_sym_SLASH] = ACTIONS(2471),
    [anon_sym_PERCENT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2471),
    [anon_sym_GT] = ACTIONS(2471),
    [anon_sym_EQ_EQ] = ACTIONS(2471),
    [anon_sym_BANG_EQ] = ACTIONS(2471),
    [anon_sym_LT_EQ] = ACTIONS(2471),
    [anon_sym_GT_EQ] = ACTIONS(2471),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_struct] = ACTIONS(2471),
    [anon_sym_mut] = ACTIONS(2471),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_go] = ACTIONS(2471),
    [anon_sym_spawn] = ACTIONS(2471),
    [anon_sym_json_DOTdecode] = ACTIONS(2471),
    [anon_sym_PIPE] = ACTIONS(2471),
    [anon_sym_LBRACK2] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_CARET] = ACTIONS(2471),
    [anon_sym_AMP] = ACTIONS(2471),
    [anon_sym_LT_DASH] = ACTIONS(2471),
    [anon_sym_LT_LT] = ACTIONS(2471),
    [anon_sym_GT_GT] = ACTIONS(2471),
    [anon_sym_GT_GT_GT] = ACTIONS(2471),
    [anon_sym_AMP_CARET] = ACTIONS(2471),
    [anon_sym_AMP_AMP] = ACTIONS(2471),
    [anon_sym_PIPE_PIPE] = ACTIONS(2471),
    [anon_sym_or] = ACTIONS(2471),
    [sym_none] = ACTIONS(2471),
    [sym_true] = ACTIONS(2471),
    [sym_false] = ACTIONS(2471),
    [sym_nil] = ACTIONS(2471),
    [anon_sym_QMARK_DOT] = ACTIONS(2471),
    [anon_sym_POUND_LBRACK] = ACTIONS(2471),
    [anon_sym_if] = ACTIONS(2471),
    [anon_sym_DOLLARif] = ACTIONS(2471),
    [anon_sym_is] = ACTIONS(2471),
    [anon_sym_BANGis] = ACTIONS(2471),
    [anon_sym_in] = ACTIONS(2471),
    [anon_sym_BANGin] = ACTIONS(2471),
    [anon_sym_match] = ACTIONS(2471),
    [anon_sym_select] = ACTIONS(2471),
    [anon_sym_lock] = ACTIONS(2471),
    [anon_sym_rlock] = ACTIONS(2471),
    [anon_sym_unsafe] = ACTIONS(2471),
    [anon_sym_sql] = ACTIONS(2471),
    [sym_int_literal] = ACTIONS(2471),
    [sym_float_literal] = ACTIONS(2471),
    [sym_rune_literal] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_c_SQUOTE] = ACTIONS(2471),
    [anon_sym_c_DQUOTE] = ACTIONS(2471),
    [anon_sym_r_SQUOTE] = ACTIONS(2471),
    [anon_sym_r_DQUOTE] = ACTIONS(2471),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2471),
    [anon_sym_shared] = ACTIONS(2471),
    [anon_sym_map_LBRACK] = ACTIONS(2471),
    [anon_sym_chan] = ACTIONS(2471),
    [anon_sym_thread] = ACTIONS(2471),
    [anon_sym_atomic] = ACTIONS(2471),
    [anon_sym_assert] = ACTIONS(2471),
    [anon_sym_defer] = ACTIONS(2471),
    [anon_sym_goto] = ACTIONS(2471),
    [anon_sym_break] = ACTIONS(2471),
    [anon_sym_continue] = ACTIONS(2471),
    [anon_sym_return] = ACTIONS(2471),
    [anon_sym_DOLLARfor] = ACTIONS(2471),
    [anon_sym_for] = ACTIONS(2471),
    [anon_sym_POUND] = ACTIONS(2471),
    [anon_sym_asm] = ACTIONS(2471),
  },
  [1368] = {
    [sym_line_comment] = STATE(1368),
    [sym_block_comment] = STATE(1368),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_LF] = ACTIONS(3296),
    [anon_sym_CR] = ACTIONS(3296),
    [anon_sym_CR_LF] = ACTIONS(3296),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3296),
    [anon_sym_as] = ACTIONS(3296),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3296),
    [anon_sym_RBRACE] = ACTIONS(3296),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_fn] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_SLASH] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_LT] = ACTIONS(3296),
    [anon_sym_GT] = ACTIONS(3296),
    [anon_sym_EQ_EQ] = ACTIONS(3296),
    [anon_sym_BANG_EQ] = ACTIONS(3296),
    [anon_sym_LT_EQ] = ACTIONS(3296),
    [anon_sym_GT_EQ] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3294),
    [anon_sym_struct] = ACTIONS(3296),
    [anon_sym_mut] = ACTIONS(3296),
    [anon_sym_PLUS_PLUS] = ACTIONS(3296),
    [anon_sym_DASH_DASH] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3296),
    [anon_sym_BANG] = ACTIONS(3296),
    [anon_sym_go] = ACTIONS(3296),
    [anon_sym_spawn] = ACTIONS(3296),
    [anon_sym_json_DOTdecode] = ACTIONS(3296),
    [anon_sym_PIPE] = ACTIONS(3296),
    [anon_sym_LBRACK2] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3296),
    [anon_sym_CARET] = ACTIONS(3296),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3296),
    [anon_sym_LT_LT] = ACTIONS(3296),
    [anon_sym_GT_GT] = ACTIONS(3296),
    [anon_sym_GT_GT_GT] = ACTIONS(3296),
    [anon_sym_AMP_CARET] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3296),
    [anon_sym_or] = ACTIONS(3296),
    [sym_none] = ACTIONS(3296),
    [sym_true] = ACTIONS(3296),
    [sym_false] = ACTIONS(3296),
    [sym_nil] = ACTIONS(3296),
    [anon_sym_QMARK_DOT] = ACTIONS(3296),
    [anon_sym_POUND_LBRACK] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_DOLLARif] = ACTIONS(3296),
    [anon_sym_is] = ACTIONS(3296),
    [anon_sym_BANGis] = ACTIONS(3296),
    [anon_sym_in] = ACTIONS(3296),
    [anon_sym_BANGin] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_select] = ACTIONS(3296),
    [anon_sym_lock] = ACTIONS(3296),
    [anon_sym_rlock] = ACTIONS(3296),
    [anon_sym_unsafe] = ACTIONS(3296),
    [anon_sym_sql] = ACTIONS(3296),
    [sym_int_literal] = ACTIONS(3296),
    [sym_float_literal] = ACTIONS(3296),
    [sym_rune_literal] = ACTIONS(3296),
    [anon_sym_SQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_c_SQUOTE] = ACTIONS(3296),
    [anon_sym_c_DQUOTE] = ACTIONS(3296),
    [anon_sym_r_SQUOTE] = ACTIONS(3296),
    [anon_sym_r_DQUOTE] = ACTIONS(3296),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3296),
    [anon_sym_shared] = ACTIONS(3296),
    [anon_sym_map_LBRACK] = ACTIONS(3296),
    [anon_sym_chan] = ACTIONS(3296),
    [anon_sym_thread] = ACTIONS(3296),
    [anon_sym_atomic] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_defer] = ACTIONS(3296),
    [anon_sym_goto] = ACTIONS(3296),
    [anon_sym_break] = ACTIONS(3296),
    [anon_sym_continue] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_DOLLARfor] = ACTIONS(3296),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_POUND] = ACTIONS(3296),
    [anon_sym_asm] = ACTIONS(3296),
  },
  [1369] = {
    [sym_line_comment] = STATE(1369),
    [sym_block_comment] = STATE(1369),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_LF] = ACTIONS(3055),
    [anon_sym_CR] = ACTIONS(3055),
    [anon_sym_CR_LF] = ACTIONS(3055),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3055),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_as] = ACTIONS(3055),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3055),
    [anon_sym_RBRACE] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_fn] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3055),
    [anon_sym_SLASH] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(3055),
    [anon_sym_GT] = ACTIONS(3055),
    [anon_sym_EQ_EQ] = ACTIONS(3055),
    [anon_sym_BANG_EQ] = ACTIONS(3055),
    [anon_sym_LT_EQ] = ACTIONS(3055),
    [anon_sym_GT_EQ] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_struct] = ACTIONS(3055),
    [anon_sym_mut] = ACTIONS(3055),
    [anon_sym_PLUS_PLUS] = ACTIONS(3055),
    [anon_sym_DASH_DASH] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_BANG] = ACTIONS(3055),
    [anon_sym_go] = ACTIONS(3055),
    [anon_sym_spawn] = ACTIONS(3055),
    [anon_sym_json_DOTdecode] = ACTIONS(3055),
    [anon_sym_PIPE] = ACTIONS(3055),
    [anon_sym_LBRACK2] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3055),
    [anon_sym_CARET] = ACTIONS(3055),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT_DASH] = ACTIONS(3055),
    [anon_sym_LT_LT] = ACTIONS(3055),
    [anon_sym_GT_GT] = ACTIONS(3055),
    [anon_sym_GT_GT_GT] = ACTIONS(3055),
    [anon_sym_AMP_CARET] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3055),
    [anon_sym_or] = ACTIONS(3055),
    [sym_none] = ACTIONS(3055),
    [sym_true] = ACTIONS(3055),
    [sym_false] = ACTIONS(3055),
    [sym_nil] = ACTIONS(3055),
    [anon_sym_QMARK_DOT] = ACTIONS(3055),
    [anon_sym_POUND_LBRACK] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_DOLLARif] = ACTIONS(3055),
    [anon_sym_is] = ACTIONS(3055),
    [anon_sym_BANGis] = ACTIONS(3055),
    [anon_sym_in] = ACTIONS(3055),
    [anon_sym_BANGin] = ACTIONS(3055),
    [anon_sym_match] = ACTIONS(3055),
    [anon_sym_select] = ACTIONS(3055),
    [anon_sym_lock] = ACTIONS(3055),
    [anon_sym_rlock] = ACTIONS(3055),
    [anon_sym_unsafe] = ACTIONS(3055),
    [anon_sym_sql] = ACTIONS(3055),
    [sym_int_literal] = ACTIONS(3055),
    [sym_float_literal] = ACTIONS(3055),
    [sym_rune_literal] = ACTIONS(3055),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_c_SQUOTE] = ACTIONS(3055),
    [anon_sym_c_DQUOTE] = ACTIONS(3055),
    [anon_sym_r_SQUOTE] = ACTIONS(3055),
    [anon_sym_r_DQUOTE] = ACTIONS(3055),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3055),
    [anon_sym_shared] = ACTIONS(3055),
    [anon_sym_map_LBRACK] = ACTIONS(3055),
    [anon_sym_chan] = ACTIONS(3055),
    [anon_sym_thread] = ACTIONS(3055),
    [anon_sym_atomic] = ACTIONS(3055),
    [anon_sym_assert] = ACTIONS(3055),
    [anon_sym_defer] = ACTIONS(3055),
    [anon_sym_goto] = ACTIONS(3055),
    [anon_sym_break] = ACTIONS(3055),
    [anon_sym_continue] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_DOLLARfor] = ACTIONS(3055),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_POUND] = ACTIONS(3055),
    [anon_sym_asm] = ACTIONS(3055),
  },
  [1370] = {
    [sym_line_comment] = STATE(1370),
    [sym_block_comment] = STATE(1370),
    [sym_identifier] = ACTIONS(3049),
    [anon_sym_LF] = ACTIONS(3049),
    [anon_sym_CR] = ACTIONS(3049),
    [anon_sym_CR_LF] = ACTIONS(3049),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3049),
    [anon_sym_DOT] = ACTIONS(3049),
    [anon_sym_as] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_COMMA] = ACTIONS(3049),
    [anon_sym_RBRACE] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [anon_sym_fn] = ACTIONS(3049),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_STAR] = ACTIONS(3049),
    [anon_sym_SLASH] = ACTIONS(3049),
    [anon_sym_PERCENT] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_GT] = ACTIONS(3049),
    [anon_sym_EQ_EQ] = ACTIONS(3049),
    [anon_sym_BANG_EQ] = ACTIONS(3049),
    [anon_sym_LT_EQ] = ACTIONS(3049),
    [anon_sym_GT_EQ] = ACTIONS(3049),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_struct] = ACTIONS(3049),
    [anon_sym_mut] = ACTIONS(3049),
    [anon_sym_PLUS_PLUS] = ACTIONS(3049),
    [anon_sym_DASH_DASH] = ACTIONS(3049),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_BANG] = ACTIONS(3049),
    [anon_sym_go] = ACTIONS(3049),
    [anon_sym_spawn] = ACTIONS(3049),
    [anon_sym_json_DOTdecode] = ACTIONS(3049),
    [anon_sym_PIPE] = ACTIONS(3049),
    [anon_sym_LBRACK2] = ACTIONS(3049),
    [anon_sym_TILDE] = ACTIONS(3049),
    [anon_sym_CARET] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_LT_DASH] = ACTIONS(3049),
    [anon_sym_LT_LT] = ACTIONS(3049),
    [anon_sym_GT_GT] = ACTIONS(3049),
    [anon_sym_GT_GT_GT] = ACTIONS(3049),
    [anon_sym_AMP_CARET] = ACTIONS(3049),
    [anon_sym_AMP_AMP] = ACTIONS(3049),
    [anon_sym_PIPE_PIPE] = ACTIONS(3049),
    [anon_sym_or] = ACTIONS(3049),
    [sym_none] = ACTIONS(3049),
    [sym_true] = ACTIONS(3049),
    [sym_false] = ACTIONS(3049),
    [sym_nil] = ACTIONS(3049),
    [anon_sym_QMARK_DOT] = ACTIONS(3049),
    [anon_sym_POUND_LBRACK] = ACTIONS(3049),
    [anon_sym_if] = ACTIONS(3049),
    [anon_sym_DOLLARif] = ACTIONS(3049),
    [anon_sym_is] = ACTIONS(3049),
    [anon_sym_BANGis] = ACTIONS(3049),
    [anon_sym_in] = ACTIONS(3049),
    [anon_sym_BANGin] = ACTIONS(3049),
    [anon_sym_match] = ACTIONS(3049),
    [anon_sym_select] = ACTIONS(3049),
    [anon_sym_lock] = ACTIONS(3049),
    [anon_sym_rlock] = ACTIONS(3049),
    [anon_sym_unsafe] = ACTIONS(3049),
    [anon_sym_sql] = ACTIONS(3049),
    [sym_int_literal] = ACTIONS(3049),
    [sym_float_literal] = ACTIONS(3049),
    [sym_rune_literal] = ACTIONS(3049),
    [anon_sym_SQUOTE] = ACTIONS(3049),
    [anon_sym_DQUOTE] = ACTIONS(3049),
    [anon_sym_c_SQUOTE] = ACTIONS(3049),
    [anon_sym_c_DQUOTE] = ACTIONS(3049),
    [anon_sym_r_SQUOTE] = ACTIONS(3049),
    [anon_sym_r_DQUOTE] = ACTIONS(3049),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3049),
    [anon_sym_shared] = ACTIONS(3049),
    [anon_sym_map_LBRACK] = ACTIONS(3049),
    [anon_sym_chan] = ACTIONS(3049),
    [anon_sym_thread] = ACTIONS(3049),
    [anon_sym_atomic] = ACTIONS(3049),
    [anon_sym_assert] = ACTIONS(3049),
    [anon_sym_defer] = ACTIONS(3049),
    [anon_sym_goto] = ACTIONS(3049),
    [anon_sym_break] = ACTIONS(3049),
    [anon_sym_continue] = ACTIONS(3049),
    [anon_sym_return] = ACTIONS(3049),
    [anon_sym_DOLLARfor] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3049),
    [anon_sym_POUND] = ACTIONS(3049),
    [anon_sym_asm] = ACTIONS(3049),
  },
  [1371] = {
    [sym_line_comment] = STATE(1371),
    [sym_block_comment] = STATE(1371),
    [sym_identifier] = ACTIONS(2961),
    [anon_sym_LF] = ACTIONS(2961),
    [anon_sym_CR] = ACTIONS(2961),
    [anon_sym_CR_LF] = ACTIONS(2961),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2961),
    [anon_sym_DOT] = ACTIONS(2961),
    [anon_sym_as] = ACTIONS(2961),
    [anon_sym_LBRACE] = ACTIONS(2961),
    [anon_sym_COMMA] = ACTIONS(2961),
    [anon_sym_RBRACE] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(2961),
    [anon_sym_fn] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2961),
    [anon_sym_DASH] = ACTIONS(2961),
    [anon_sym_STAR] = ACTIONS(2961),
    [anon_sym_SLASH] = ACTIONS(2961),
    [anon_sym_PERCENT] = ACTIONS(2961),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_GT] = ACTIONS(2961),
    [anon_sym_EQ_EQ] = ACTIONS(2961),
    [anon_sym_BANG_EQ] = ACTIONS(2961),
    [anon_sym_LT_EQ] = ACTIONS(2961),
    [anon_sym_GT_EQ] = ACTIONS(2961),
    [anon_sym_LBRACK] = ACTIONS(2959),
    [anon_sym_struct] = ACTIONS(2961),
    [anon_sym_mut] = ACTIONS(2961),
    [anon_sym_PLUS_PLUS] = ACTIONS(2961),
    [anon_sym_DASH_DASH] = ACTIONS(2961),
    [anon_sym_QMARK] = ACTIONS(2961),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_go] = ACTIONS(2961),
    [anon_sym_spawn] = ACTIONS(2961),
    [anon_sym_json_DOTdecode] = ACTIONS(2961),
    [anon_sym_PIPE] = ACTIONS(2961),
    [anon_sym_LBRACK2] = ACTIONS(2961),
    [anon_sym_TILDE] = ACTIONS(2961),
    [anon_sym_CARET] = ACTIONS(2961),
    [anon_sym_AMP] = ACTIONS(2961),
    [anon_sym_LT_DASH] = ACTIONS(2961),
    [anon_sym_LT_LT] = ACTIONS(2961),
    [anon_sym_GT_GT] = ACTIONS(2961),
    [anon_sym_GT_GT_GT] = ACTIONS(2961),
    [anon_sym_AMP_CARET] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2961),
    [anon_sym_PIPE_PIPE] = ACTIONS(2961),
    [anon_sym_or] = ACTIONS(2961),
    [sym_none] = ACTIONS(2961),
    [sym_true] = ACTIONS(2961),
    [sym_false] = ACTIONS(2961),
    [sym_nil] = ACTIONS(2961),
    [anon_sym_QMARK_DOT] = ACTIONS(2961),
    [anon_sym_POUND_LBRACK] = ACTIONS(2961),
    [anon_sym_if] = ACTIONS(2961),
    [anon_sym_DOLLARif] = ACTIONS(2961),
    [anon_sym_is] = ACTIONS(2961),
    [anon_sym_BANGis] = ACTIONS(2961),
    [anon_sym_in] = ACTIONS(2961),
    [anon_sym_BANGin] = ACTIONS(2961),
    [anon_sym_match] = ACTIONS(2961),
    [anon_sym_select] = ACTIONS(2961),
    [anon_sym_lock] = ACTIONS(2961),
    [anon_sym_rlock] = ACTIONS(2961),
    [anon_sym_unsafe] = ACTIONS(2961),
    [anon_sym_sql] = ACTIONS(2961),
    [sym_int_literal] = ACTIONS(2961),
    [sym_float_literal] = ACTIONS(2961),
    [sym_rune_literal] = ACTIONS(2961),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_DQUOTE] = ACTIONS(2961),
    [anon_sym_c_SQUOTE] = ACTIONS(2961),
    [anon_sym_c_DQUOTE] = ACTIONS(2961),
    [anon_sym_r_SQUOTE] = ACTIONS(2961),
    [anon_sym_r_DQUOTE] = ACTIONS(2961),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2961),
    [anon_sym_shared] = ACTIONS(2961),
    [anon_sym_map_LBRACK] = ACTIONS(2961),
    [anon_sym_chan] = ACTIONS(2961),
    [anon_sym_thread] = ACTIONS(2961),
    [anon_sym_atomic] = ACTIONS(2961),
    [anon_sym_assert] = ACTIONS(2961),
    [anon_sym_defer] = ACTIONS(2961),
    [anon_sym_goto] = ACTIONS(2961),
    [anon_sym_break] = ACTIONS(2961),
    [anon_sym_continue] = ACTIONS(2961),
    [anon_sym_return] = ACTIONS(2961),
    [anon_sym_DOLLARfor] = ACTIONS(2961),
    [anon_sym_for] = ACTIONS(2961),
    [anon_sym_POUND] = ACTIONS(2961),
    [anon_sym_asm] = ACTIONS(2961),
  },
  [1372] = {
    [sym_line_comment] = STATE(1372),
    [sym_block_comment] = STATE(1372),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_CR] = ACTIONS(2147),
    [anon_sym_CR_LF] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_COMMA] = ACTIONS(2335),
    [anon_sym_RBRACE] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2147),
    [anon_sym_BANG_EQ] = ACTIONS(2147),
    [anon_sym_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2147),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2147),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2147),
    [anon_sym_AMP_CARET] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [anon_sym_or] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2147),
    [anon_sym_POUND_LBRACK] = ACTIONS(2147),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2147),
    [anon_sym_BANGis] = ACTIONS(2147),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANGin] = ACTIONS(2147),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2147),
    [sym_rune_literal] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_c_SQUOTE] = ACTIONS(2147),
    [anon_sym_c_DQUOTE] = ACTIONS(2147),
    [anon_sym_r_SQUOTE] = ACTIONS(2147),
    [anon_sym_r_DQUOTE] = ACTIONS(2147),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2147),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
    [anon_sym_assert] = ACTIONS(2147),
    [anon_sym_defer] = ACTIONS(2147),
    [anon_sym_goto] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_continue] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2147),
    [anon_sym_DOLLARfor] = ACTIONS(2147),
    [anon_sym_for] = ACTIONS(2147),
    [anon_sym_POUND] = ACTIONS(2147),
    [anon_sym_asm] = ACTIONS(2147),
  },
  [1373] = {
    [sym_line_comment] = STATE(1373),
    [sym_block_comment] = STATE(1373),
    [sym_reference_expression] = STATE(4601),
    [sym_type_reference_expression] = STATE(1730),
    [sym_plain_type] = STATE(1844),
    [sym__plain_type_without_special] = STATE(1875),
    [sym_anon_struct_type] = STATE(1881),
    [sym_multi_return_type] = STATE(1875),
    [sym_result_type] = STATE(1875),
    [sym_option_type] = STATE(1875),
    [sym_qualified_type] = STATE(1730),
    [sym_fixed_array_type] = STATE(1881),
    [sym_array_type] = STATE(1881),
    [sym_pointer_type] = STATE(1881),
    [sym_wrong_pointer_type] = STATE(1881),
    [sym_map_type] = STATE(1881),
    [sym_channel_type] = STATE(1881),
    [sym_shared_type] = STATE(1881),
    [sym_thread_type] = STATE(1881),
    [sym_atomic_type] = STATE(1881),
    [sym_generic_type] = STATE(1881),
    [sym_function_type] = STATE(1881),
    [ts_builtin_sym_end] = ACTIONS(817),
    [sym_identifier] = ACTIONS(4066),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_CR] = ACTIONS(821),
    [anon_sym_CR_LF] = ACTIONS(821),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(821),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_const] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(4068),
    [anon_sym___global] = ACTIONS(821),
    [anon_sym_type] = ACTIONS(821),
    [anon_sym_fn] = ACTIONS(4070),
    [anon_sym_PLUS] = ACTIONS(821),
    [anon_sym_DASH] = ACTIONS(821),
    [anon_sym_STAR] = ACTIONS(4072),
    [anon_sym_struct] = ACTIONS(4074),
    [anon_sym_union] = ACTIONS(821),
    [anon_sym_pub] = ACTIONS(821),
    [anon_sym_mut] = ACTIONS(821),
    [anon_sym_enum] = ACTIONS(821),
    [anon_sym_interface] = ACTIONS(821),
    [anon_sym_QMARK] = ACTIONS(4076),
    [anon_sym_BANG] = ACTIONS(4078),
    [anon_sym_go] = ACTIONS(821),
    [anon_sym_spawn] = ACTIONS(821),
    [anon_sym_json_DOTdecode] = ACTIONS(821),
    [anon_sym_LBRACK2] = ACTIONS(4080),
    [anon_sym_TILDE] = ACTIONS(821),
    [anon_sym_CARET] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_LT_DASH] = ACTIONS(821),
    [sym_none] = ACTIONS(821),
    [sym_true] = ACTIONS(821),
    [sym_false] = ACTIONS(821),
    [sym_nil] = ACTIONS(821),
    [anon_sym_if] = ACTIONS(821),
    [anon_sym_DOLLARif] = ACTIONS(821),
    [anon_sym_match] = ACTIONS(821),
    [anon_sym_select] = ACTIONS(821),
    [anon_sym_lock] = ACTIONS(821),
    [anon_sym_rlock] = ACTIONS(821),
    [anon_sym_unsafe] = ACTIONS(821),
    [anon_sym_sql] = ACTIONS(821),
    [sym_int_literal] = ACTIONS(821),
    [sym_float_literal] = ACTIONS(821),
    [sym_rune_literal] = ACTIONS(821),
    [anon_sym_SQUOTE] = ACTIONS(821),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [anon_sym_c_SQUOTE] = ACTIONS(821),
    [anon_sym_c_DQUOTE] = ACTIONS(821),
    [anon_sym_r_SQUOTE] = ACTIONS(821),
    [anon_sym_r_DQUOTE] = ACTIONS(821),
    [sym_pseudo_compile_time_identifier] = ACTIONS(821),
    [anon_sym_shared] = ACTIONS(4084),
    [anon_sym_map_LBRACK] = ACTIONS(4086),
    [anon_sym_chan] = ACTIONS(4088),
    [anon_sym_thread] = ACTIONS(4090),
    [anon_sym_atomic] = ACTIONS(4092),
    [anon_sym_assert] = ACTIONS(821),
    [anon_sym_defer] = ACTIONS(821),
    [anon_sym_goto] = ACTIONS(821),
    [anon_sym_break] = ACTIONS(821),
    [anon_sym_continue] = ACTIONS(821),
    [anon_sym_return] = ACTIONS(821),
    [anon_sym_DOLLARfor] = ACTIONS(821),
    [anon_sym_for] = ACTIONS(821),
    [anon_sym_POUND] = ACTIONS(821),
    [anon_sym_asm] = ACTIONS(821),
    [anon_sym_AT_LBRACK] = ACTIONS(821),
  },
  [1374] = {
    [sym_line_comment] = STATE(1374),
    [sym_block_comment] = STATE(1374),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_LF] = ACTIONS(2837),
    [anon_sym_CR] = ACTIONS(2837),
    [anon_sym_CR_LF] = ACTIONS(2837),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2837),
    [anon_sym_DOT] = ACTIONS(2837),
    [anon_sym_as] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_RBRACE] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2837),
    [anon_sym_fn] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2837),
    [anon_sym_DASH] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2837),
    [anon_sym_SLASH] = ACTIONS(2837),
    [anon_sym_PERCENT] = ACTIONS(2837),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(2837),
    [anon_sym_BANG_EQ] = ACTIONS(2837),
    [anon_sym_LT_EQ] = ACTIONS(2837),
    [anon_sym_GT_EQ] = ACTIONS(2837),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_struct] = ACTIONS(2837),
    [anon_sym_mut] = ACTIONS(2837),
    [anon_sym_PLUS_PLUS] = ACTIONS(2837),
    [anon_sym_DASH_DASH] = ACTIONS(2837),
    [anon_sym_QMARK] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(2837),
    [anon_sym_go] = ACTIONS(2837),
    [anon_sym_spawn] = ACTIONS(2837),
    [anon_sym_json_DOTdecode] = ACTIONS(2837),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_LBRACK2] = ACTIONS(2837),
    [anon_sym_TILDE] = ACTIONS(2837),
    [anon_sym_CARET] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2837),
    [anon_sym_LT_DASH] = ACTIONS(2837),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_GT_GT_GT] = ACTIONS(2837),
    [anon_sym_AMP_CARET] = ACTIONS(2837),
    [anon_sym_AMP_AMP] = ACTIONS(2837),
    [anon_sym_PIPE_PIPE] = ACTIONS(2837),
    [anon_sym_or] = ACTIONS(2837),
    [sym_none] = ACTIONS(2837),
    [sym_true] = ACTIONS(2837),
    [sym_false] = ACTIONS(2837),
    [sym_nil] = ACTIONS(2837),
    [anon_sym_QMARK_DOT] = ACTIONS(2837),
    [anon_sym_POUND_LBRACK] = ACTIONS(2837),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_DOLLARif] = ACTIONS(2837),
    [anon_sym_is] = ACTIONS(2837),
    [anon_sym_BANGis] = ACTIONS(2837),
    [anon_sym_in] = ACTIONS(2837),
    [anon_sym_BANGin] = ACTIONS(2837),
    [anon_sym_match] = ACTIONS(2837),
    [anon_sym_select] = ACTIONS(2837),
    [anon_sym_lock] = ACTIONS(2837),
    [anon_sym_rlock] = ACTIONS(2837),
    [anon_sym_unsafe] = ACTIONS(2837),
    [anon_sym_sql] = ACTIONS(2837),
    [sym_int_literal] = ACTIONS(2837),
    [sym_float_literal] = ACTIONS(2837),
    [sym_rune_literal] = ACTIONS(2837),
    [anon_sym_SQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE] = ACTIONS(2837),
    [anon_sym_c_SQUOTE] = ACTIONS(2837),
    [anon_sym_c_DQUOTE] = ACTIONS(2837),
    [anon_sym_r_SQUOTE] = ACTIONS(2837),
    [anon_sym_r_DQUOTE] = ACTIONS(2837),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2837),
    [anon_sym_shared] = ACTIONS(2837),
    [anon_sym_map_LBRACK] = ACTIONS(2837),
    [anon_sym_chan] = ACTIONS(2837),
    [anon_sym_thread] = ACTIONS(2837),
    [anon_sym_atomic] = ACTIONS(2837),
    [anon_sym_assert] = ACTIONS(2837),
    [anon_sym_defer] = ACTIONS(2837),
    [anon_sym_goto] = ACTIONS(2837),
    [anon_sym_break] = ACTIONS(2837),
    [anon_sym_continue] = ACTIONS(2837),
    [anon_sym_return] = ACTIONS(2837),
    [anon_sym_DOLLARfor] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2837),
    [anon_sym_POUND] = ACTIONS(2837),
    [anon_sym_asm] = ACTIONS(2837),
  },
  [1375] = {
    [sym_line_comment] = STATE(1375),
    [sym_block_comment] = STATE(1375),
    [sym_identifier] = ACTIONS(2973),
    [anon_sym_LF] = ACTIONS(2973),
    [anon_sym_CR] = ACTIONS(2973),
    [anon_sym_CR_LF] = ACTIONS(2973),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym_DOT] = ACTIONS(2973),
    [anon_sym_as] = ACTIONS(2973),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_COMMA] = ACTIONS(2973),
    [anon_sym_RBRACE] = ACTIONS(2973),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_fn] = ACTIONS(2973),
    [anon_sym_PLUS] = ACTIONS(2973),
    [anon_sym_DASH] = ACTIONS(2973),
    [anon_sym_STAR] = ACTIONS(2973),
    [anon_sym_SLASH] = ACTIONS(2973),
    [anon_sym_PERCENT] = ACTIONS(2973),
    [anon_sym_LT] = ACTIONS(2973),
    [anon_sym_GT] = ACTIONS(2973),
    [anon_sym_EQ_EQ] = ACTIONS(2973),
    [anon_sym_BANG_EQ] = ACTIONS(2973),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LBRACK] = ACTIONS(2971),
    [anon_sym_struct] = ACTIONS(2973),
    [anon_sym_mut] = ACTIONS(2973),
    [anon_sym_PLUS_PLUS] = ACTIONS(2973),
    [anon_sym_DASH_DASH] = ACTIONS(2973),
    [anon_sym_QMARK] = ACTIONS(2973),
    [anon_sym_BANG] = ACTIONS(2973),
    [anon_sym_go] = ACTIONS(2973),
    [anon_sym_spawn] = ACTIONS(2973),
    [anon_sym_json_DOTdecode] = ACTIONS(2973),
    [anon_sym_PIPE] = ACTIONS(2973),
    [anon_sym_LBRACK2] = ACTIONS(2973),
    [anon_sym_TILDE] = ACTIONS(2973),
    [anon_sym_CARET] = ACTIONS(2973),
    [anon_sym_AMP] = ACTIONS(2973),
    [anon_sym_LT_DASH] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2973),
    [anon_sym_GT_GT] = ACTIONS(2973),
    [anon_sym_GT_GT_GT] = ACTIONS(2973),
    [anon_sym_AMP_CARET] = ACTIONS(2973),
    [anon_sym_AMP_AMP] = ACTIONS(2973),
    [anon_sym_PIPE_PIPE] = ACTIONS(2973),
    [anon_sym_or] = ACTIONS(2973),
    [sym_none] = ACTIONS(2973),
    [sym_true] = ACTIONS(2973),
    [sym_false] = ACTIONS(2973),
    [sym_nil] = ACTIONS(2973),
    [anon_sym_QMARK_DOT] = ACTIONS(2973),
    [anon_sym_POUND_LBRACK] = ACTIONS(2973),
    [anon_sym_if] = ACTIONS(2973),
    [anon_sym_DOLLARif] = ACTIONS(2973),
    [anon_sym_is] = ACTIONS(2973),
    [anon_sym_BANGis] = ACTIONS(2973),
    [anon_sym_in] = ACTIONS(2973),
    [anon_sym_BANGin] = ACTIONS(2973),
    [anon_sym_match] = ACTIONS(2973),
    [anon_sym_select] = ACTIONS(2973),
    [anon_sym_lock] = ACTIONS(2973),
    [anon_sym_rlock] = ACTIONS(2973),
    [anon_sym_unsafe] = ACTIONS(2973),
    [anon_sym_sql] = ACTIONS(2973),
    [sym_int_literal] = ACTIONS(2973),
    [sym_float_literal] = ACTIONS(2973),
    [sym_rune_literal] = ACTIONS(2973),
    [anon_sym_SQUOTE] = ACTIONS(2973),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [anon_sym_c_SQUOTE] = ACTIONS(2973),
    [anon_sym_c_DQUOTE] = ACTIONS(2973),
    [anon_sym_r_SQUOTE] = ACTIONS(2973),
    [anon_sym_r_DQUOTE] = ACTIONS(2973),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2973),
    [anon_sym_shared] = ACTIONS(2973),
    [anon_sym_map_LBRACK] = ACTIONS(2973),
    [anon_sym_chan] = ACTIONS(2973),
    [anon_sym_thread] = ACTIONS(2973),
    [anon_sym_atomic] = ACTIONS(2973),
    [anon_sym_assert] = ACTIONS(2973),
    [anon_sym_defer] = ACTIONS(2973),
    [anon_sym_goto] = ACTIONS(2973),
    [anon_sym_break] = ACTIONS(2973),
    [anon_sym_continue] = ACTIONS(2973),
    [anon_sym_return] = ACTIONS(2973),
    [anon_sym_DOLLARfor] = ACTIONS(2973),
    [anon_sym_for] = ACTIONS(2973),
    [anon_sym_POUND] = ACTIONS(2973),
    [anon_sym_asm] = ACTIONS(2973),
  },
  [1376] = {
    [sym_line_comment] = STATE(1376),
    [sym_block_comment] = STATE(1376),
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_LF] = ACTIONS(3356),
    [anon_sym_CR] = ACTIONS(3356),
    [anon_sym_CR_LF] = ACTIONS(3356),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3356),
    [anon_sym_DOT] = ACTIONS(3356),
    [anon_sym_as] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3356),
    [anon_sym_COMMA] = ACTIONS(3356),
    [anon_sym_RBRACE] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3356),
    [anon_sym_fn] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_STAR] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_PERCENT] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_GT] = ACTIONS(3356),
    [anon_sym_EQ_EQ] = ACTIONS(3356),
    [anon_sym_BANG_EQ] = ACTIONS(3356),
    [anon_sym_LT_EQ] = ACTIONS(3356),
    [anon_sym_GT_EQ] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3354),
    [anon_sym_struct] = ACTIONS(3356),
    [anon_sym_mut] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3356),
    [anon_sym_DASH_DASH] = ACTIONS(3356),
    [anon_sym_QMARK] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3356),
    [anon_sym_go] = ACTIONS(3356),
    [anon_sym_spawn] = ACTIONS(3356),
    [anon_sym_json_DOTdecode] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(3356),
    [anon_sym_LBRACK2] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3356),
    [anon_sym_CARET] = ACTIONS(3356),
    [anon_sym_AMP] = ACTIONS(3356),
    [anon_sym_LT_DASH] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(3356),
    [anon_sym_GT_GT] = ACTIONS(3356),
    [anon_sym_GT_GT_GT] = ACTIONS(3356),
    [anon_sym_AMP_CARET] = ACTIONS(3356),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_PIPE_PIPE] = ACTIONS(3356),
    [anon_sym_or] = ACTIONS(3356),
    [sym_none] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_nil] = ACTIONS(3356),
    [anon_sym_QMARK_DOT] = ACTIONS(3356),
    [anon_sym_POUND_LBRACK] = ACTIONS(3356),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_DOLLARif] = ACTIONS(3356),
    [anon_sym_is] = ACTIONS(3356),
    [anon_sym_BANGis] = ACTIONS(3356),
    [anon_sym_in] = ACTIONS(3356),
    [anon_sym_BANGin] = ACTIONS(3356),
    [anon_sym_match] = ACTIONS(3356),
    [anon_sym_select] = ACTIONS(3356),
    [anon_sym_lock] = ACTIONS(3356),
    [anon_sym_rlock] = ACTIONS(3356),
    [anon_sym_unsafe] = ACTIONS(3356),
    [anon_sym_sql] = ACTIONS(3356),
    [sym_int_literal] = ACTIONS(3356),
    [sym_float_literal] = ACTIONS(3356),
    [sym_rune_literal] = ACTIONS(3356),
    [anon_sym_SQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [anon_sym_c_SQUOTE] = ACTIONS(3356),
    [anon_sym_c_DQUOTE] = ACTIONS(3356),
    [anon_sym_r_SQUOTE] = ACTIONS(3356),
    [anon_sym_r_DQUOTE] = ACTIONS(3356),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3356),
    [anon_sym_shared] = ACTIONS(3356),
    [anon_sym_map_LBRACK] = ACTIONS(3356),
    [anon_sym_chan] = ACTIONS(3356),
    [anon_sym_thread] = ACTIONS(3356),
    [anon_sym_atomic] = ACTIONS(3356),
    [anon_sym_assert] = ACTIONS(3356),
    [anon_sym_defer] = ACTIONS(3356),
    [anon_sym_goto] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_DOLLARfor] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_POUND] = ACTIONS(3356),
    [anon_sym_asm] = ACTIONS(3356),
  },
  [1377] = {
    [sym_line_comment] = STATE(1377),
    [sym_block_comment] = STATE(1377),
    [sym_identifier] = ACTIONS(2435),
    [anon_sym_LF] = ACTIONS(2435),
    [anon_sym_CR] = ACTIONS(2435),
    [anon_sym_CR_LF] = ACTIONS(2435),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2435),
    [anon_sym_DOT] = ACTIONS(2435),
    [anon_sym_as] = ACTIONS(2435),
    [anon_sym_LBRACE] = ACTIONS(2435),
    [anon_sym_COMMA] = ACTIONS(2435),
    [anon_sym_RBRACE] = ACTIONS(2435),
    [anon_sym_LPAREN] = ACTIONS(2435),
    [anon_sym_fn] = ACTIONS(2435),
    [anon_sym_PLUS] = ACTIONS(2435),
    [anon_sym_DASH] = ACTIONS(2435),
    [anon_sym_STAR] = ACTIONS(2435),
    [anon_sym_SLASH] = ACTIONS(2435),
    [anon_sym_PERCENT] = ACTIONS(2435),
    [anon_sym_LT] = ACTIONS(2435),
    [anon_sym_GT] = ACTIONS(2435),
    [anon_sym_EQ_EQ] = ACTIONS(2435),
    [anon_sym_BANG_EQ] = ACTIONS(2435),
    [anon_sym_LT_EQ] = ACTIONS(2435),
    [anon_sym_GT_EQ] = ACTIONS(2435),
    [anon_sym_LBRACK] = ACTIONS(2433),
    [anon_sym_struct] = ACTIONS(2435),
    [anon_sym_mut] = ACTIONS(2435),
    [anon_sym_PLUS_PLUS] = ACTIONS(2435),
    [anon_sym_DASH_DASH] = ACTIONS(2435),
    [anon_sym_QMARK] = ACTIONS(2435),
    [anon_sym_BANG] = ACTIONS(2435),
    [anon_sym_go] = ACTIONS(2435),
    [anon_sym_spawn] = ACTIONS(2435),
    [anon_sym_json_DOTdecode] = ACTIONS(2435),
    [anon_sym_PIPE] = ACTIONS(2435),
    [anon_sym_LBRACK2] = ACTIONS(2435),
    [anon_sym_TILDE] = ACTIONS(2435),
    [anon_sym_CARET] = ACTIONS(2435),
    [anon_sym_AMP] = ACTIONS(2435),
    [anon_sym_LT_DASH] = ACTIONS(2435),
    [anon_sym_LT_LT] = ACTIONS(2435),
    [anon_sym_GT_GT] = ACTIONS(2435),
    [anon_sym_GT_GT_GT] = ACTIONS(2435),
    [anon_sym_AMP_CARET] = ACTIONS(2435),
    [anon_sym_AMP_AMP] = ACTIONS(2435),
    [anon_sym_PIPE_PIPE] = ACTIONS(2435),
    [anon_sym_or] = ACTIONS(2435),
    [sym_none] = ACTIONS(2435),
    [sym_true] = ACTIONS(2435),
    [sym_false] = ACTIONS(2435),
    [sym_nil] = ACTIONS(2435),
    [anon_sym_QMARK_DOT] = ACTIONS(2435),
    [anon_sym_POUND_LBRACK] = ACTIONS(2435),
    [anon_sym_if] = ACTIONS(2435),
    [anon_sym_DOLLARif] = ACTIONS(2435),
    [anon_sym_is] = ACTIONS(2435),
    [anon_sym_BANGis] = ACTIONS(2435),
    [anon_sym_in] = ACTIONS(2435),
    [anon_sym_BANGin] = ACTIONS(2435),
    [anon_sym_match] = ACTIONS(2435),
    [anon_sym_select] = ACTIONS(2435),
    [anon_sym_lock] = ACTIONS(2435),
    [anon_sym_rlock] = ACTIONS(2435),
    [anon_sym_unsafe] = ACTIONS(2435),
    [anon_sym_sql] = ACTIONS(2435),
    [sym_int_literal] = ACTIONS(2435),
    [sym_float_literal] = ACTIONS(2435),
    [sym_rune_literal] = ACTIONS(2435),
    [anon_sym_SQUOTE] = ACTIONS(2435),
    [anon_sym_DQUOTE] = ACTIONS(2435),
    [anon_sym_c_SQUOTE] = ACTIONS(2435),
    [anon_sym_c_DQUOTE] = ACTIONS(2435),
    [anon_sym_r_SQUOTE] = ACTIONS(2435),
    [anon_sym_r_DQUOTE] = ACTIONS(2435),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2435),
    [anon_sym_shared] = ACTIONS(2435),
    [anon_sym_map_LBRACK] = ACTIONS(2435),
    [anon_sym_chan] = ACTIONS(2435),
    [anon_sym_thread] = ACTIONS(2435),
    [anon_sym_atomic] = ACTIONS(2435),
    [anon_sym_assert] = ACTIONS(2435),
    [anon_sym_defer] = ACTIONS(2435),
    [anon_sym_goto] = ACTIONS(2435),
    [anon_sym_break] = ACTIONS(2435),
    [anon_sym_continue] = ACTIONS(2435),
    [anon_sym_return] = ACTIONS(2435),
    [anon_sym_DOLLARfor] = ACTIONS(2435),
    [anon_sym_for] = ACTIONS(2435),
    [anon_sym_POUND] = ACTIONS(2435),
    [anon_sym_asm] = ACTIONS(2435),
  },
  [1378] = {
    [sym_line_comment] = STATE(1378),
    [sym_block_comment] = STATE(1378),
    [sym_identifier] = ACTIONS(2457),
    [anon_sym_LF] = ACTIONS(2457),
    [anon_sym_CR] = ACTIONS(2457),
    [anon_sym_CR_LF] = ACTIONS(2457),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2457),
    [anon_sym_DOT] = ACTIONS(2457),
    [anon_sym_as] = ACTIONS(2457),
    [anon_sym_LBRACE] = ACTIONS(2457),
    [anon_sym_COMMA] = ACTIONS(2457),
    [anon_sym_RBRACE] = ACTIONS(2457),
    [anon_sym_LPAREN] = ACTIONS(2457),
    [anon_sym_fn] = ACTIONS(2457),
    [anon_sym_PLUS] = ACTIONS(2457),
    [anon_sym_DASH] = ACTIONS(2457),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_PERCENT] = ACTIONS(2457),
    [anon_sym_LT] = ACTIONS(2457),
    [anon_sym_GT] = ACTIONS(2457),
    [anon_sym_EQ_EQ] = ACTIONS(2457),
    [anon_sym_BANG_EQ] = ACTIONS(2457),
    [anon_sym_LT_EQ] = ACTIONS(2457),
    [anon_sym_GT_EQ] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_struct] = ACTIONS(2457),
    [anon_sym_mut] = ACTIONS(2457),
    [anon_sym_PLUS_PLUS] = ACTIONS(2457),
    [anon_sym_DASH_DASH] = ACTIONS(2457),
    [anon_sym_QMARK] = ACTIONS(2457),
    [anon_sym_BANG] = ACTIONS(2457),
    [anon_sym_go] = ACTIONS(2457),
    [anon_sym_spawn] = ACTIONS(2457),
    [anon_sym_json_DOTdecode] = ACTIONS(2457),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_LBRACK2] = ACTIONS(2457),
    [anon_sym_TILDE] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2457),
    [anon_sym_AMP] = ACTIONS(2457),
    [anon_sym_LT_DASH] = ACTIONS(2457),
    [anon_sym_LT_LT] = ACTIONS(2457),
    [anon_sym_GT_GT] = ACTIONS(2457),
    [anon_sym_GT_GT_GT] = ACTIONS(2457),
    [anon_sym_AMP_CARET] = ACTIONS(2457),
    [anon_sym_AMP_AMP] = ACTIONS(2457),
    [anon_sym_PIPE_PIPE] = ACTIONS(2457),
    [anon_sym_or] = ACTIONS(2457),
    [sym_none] = ACTIONS(2457),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [sym_nil] = ACTIONS(2457),
    [anon_sym_QMARK_DOT] = ACTIONS(2457),
    [anon_sym_POUND_LBRACK] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2457),
    [anon_sym_DOLLARif] = ACTIONS(2457),
    [anon_sym_is] = ACTIONS(2457),
    [anon_sym_BANGis] = ACTIONS(2457),
    [anon_sym_in] = ACTIONS(2457),
    [anon_sym_BANGin] = ACTIONS(2457),
    [anon_sym_match] = ACTIONS(2457),
    [anon_sym_select] = ACTIONS(2457),
    [anon_sym_lock] = ACTIONS(2457),
    [anon_sym_rlock] = ACTIONS(2457),
    [anon_sym_unsafe] = ACTIONS(2457),
    [anon_sym_sql] = ACTIONS(2457),
    [sym_int_literal] = ACTIONS(2457),
    [sym_float_literal] = ACTIONS(2457),
    [sym_rune_literal] = ACTIONS(2457),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_DQUOTE] = ACTIONS(2457),
    [anon_sym_c_SQUOTE] = ACTIONS(2457),
    [anon_sym_c_DQUOTE] = ACTIONS(2457),
    [anon_sym_r_SQUOTE] = ACTIONS(2457),
    [anon_sym_r_DQUOTE] = ACTIONS(2457),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2457),
    [anon_sym_shared] = ACTIONS(2457),
    [anon_sym_map_LBRACK] = ACTIONS(2457),
    [anon_sym_chan] = ACTIONS(2457),
    [anon_sym_thread] = ACTIONS(2457),
    [anon_sym_atomic] = ACTIONS(2457),
    [anon_sym_assert] = ACTIONS(2457),
    [anon_sym_defer] = ACTIONS(2457),
    [anon_sym_goto] = ACTIONS(2457),
    [anon_sym_break] = ACTIONS(2457),
    [anon_sym_continue] = ACTIONS(2457),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_DOLLARfor] = ACTIONS(2457),
    [anon_sym_for] = ACTIONS(2457),
    [anon_sym_POUND] = ACTIONS(2457),
    [anon_sym_asm] = ACTIONS(2457),
  },
  [1379] = {
    [sym_line_comment] = STATE(1379),
    [sym_block_comment] = STATE(1379),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LF] = ACTIONS(2175),
    [anon_sym_CR] = ACTIONS(2175),
    [anon_sym_CR_LF] = ACTIONS(2175),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_DOT] = ACTIONS(2175),
    [anon_sym_as] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2175),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_fn] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2175),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_PERCENT] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_GT] = ACTIONS(2175),
    [anon_sym_EQ_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ] = ACTIONS(2175),
    [anon_sym_LT_EQ] = ACTIONS(2175),
    [anon_sym_GT_EQ] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2173),
    [anon_sym_struct] = ACTIONS(2175),
    [anon_sym_mut] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [anon_sym_QMARK] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_go] = ACTIONS(2175),
    [anon_sym_spawn] = ACTIONS(2175),
    [anon_sym_json_DOTdecode] = ACTIONS(2175),
    [anon_sym_PIPE] = ACTIONS(2175),
    [anon_sym_LBRACK2] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_CARET] = ACTIONS(2175),
    [anon_sym_AMP] = ACTIONS(2175),
    [anon_sym_LT_DASH] = ACTIONS(2175),
    [anon_sym_LT_LT] = ACTIONS(2175),
    [anon_sym_GT_GT] = ACTIONS(2175),
    [anon_sym_GT_GT_GT] = ACTIONS(2175),
    [anon_sym_AMP_CARET] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(2175),
    [anon_sym_PIPE_PIPE] = ACTIONS(2175),
    [anon_sym_or] = ACTIONS(2175),
    [sym_none] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_nil] = ACTIONS(2175),
    [anon_sym_QMARK_DOT] = ACTIONS(2175),
    [anon_sym_POUND_LBRACK] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_DOLLARif] = ACTIONS(2175),
    [anon_sym_is] = ACTIONS(2175),
    [anon_sym_BANGis] = ACTIONS(2175),
    [anon_sym_in] = ACTIONS(2175),
    [anon_sym_BANGin] = ACTIONS(2175),
    [anon_sym_match] = ACTIONS(2175),
    [anon_sym_select] = ACTIONS(2175),
    [anon_sym_lock] = ACTIONS(2175),
    [anon_sym_rlock] = ACTIONS(2175),
    [anon_sym_unsafe] = ACTIONS(2175),
    [anon_sym_sql] = ACTIONS(2175),
    [sym_int_literal] = ACTIONS(2175),
    [sym_float_literal] = ACTIONS(2175),
    [sym_rune_literal] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_c_SQUOTE] = ACTIONS(2175),
    [anon_sym_c_DQUOTE] = ACTIONS(2175),
    [anon_sym_r_SQUOTE] = ACTIONS(2175),
    [anon_sym_r_DQUOTE] = ACTIONS(2175),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2175),
    [anon_sym_shared] = ACTIONS(2175),
    [anon_sym_map_LBRACK] = ACTIONS(2175),
    [anon_sym_chan] = ACTIONS(2175),
    [anon_sym_thread] = ACTIONS(2175),
    [anon_sym_atomic] = ACTIONS(2175),
    [anon_sym_assert] = ACTIONS(2175),
    [anon_sym_defer] = ACTIONS(2175),
    [anon_sym_goto] = ACTIONS(2175),
    [anon_sym_break] = ACTIONS(2175),
    [anon_sym_continue] = ACTIONS(2175),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_DOLLARfor] = ACTIONS(2175),
    [anon_sym_for] = ACTIONS(2175),
    [anon_sym_POUND] = ACTIONS(2175),
    [anon_sym_asm] = ACTIONS(2175),
  },
  [1380] = {
    [sym_line_comment] = STATE(1380),
    [sym_block_comment] = STATE(1380),
    [sym_identifier] = ACTIONS(3256),
    [anon_sym_LF] = ACTIONS(3256),
    [anon_sym_CR] = ACTIONS(3256),
    [anon_sym_CR_LF] = ACTIONS(3256),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3256),
    [anon_sym_DOT] = ACTIONS(3256),
    [anon_sym_as] = ACTIONS(3256),
    [anon_sym_LBRACE] = ACTIONS(3256),
    [anon_sym_COMMA] = ACTIONS(3256),
    [anon_sym_RBRACE] = ACTIONS(3256),
    [anon_sym_LPAREN] = ACTIONS(3256),
    [anon_sym_fn] = ACTIONS(3256),
    [anon_sym_PLUS] = ACTIONS(3256),
    [anon_sym_DASH] = ACTIONS(3256),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_SLASH] = ACTIONS(3256),
    [anon_sym_PERCENT] = ACTIONS(3256),
    [anon_sym_LT] = ACTIONS(3256),
    [anon_sym_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(3256),
    [anon_sym_BANG_EQ] = ACTIONS(3256),
    [anon_sym_LT_EQ] = ACTIONS(3256),
    [anon_sym_GT_EQ] = ACTIONS(3256),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [anon_sym_struct] = ACTIONS(3256),
    [anon_sym_mut] = ACTIONS(3256),
    [anon_sym_PLUS_PLUS] = ACTIONS(3256),
    [anon_sym_DASH_DASH] = ACTIONS(3256),
    [anon_sym_QMARK] = ACTIONS(3256),
    [anon_sym_BANG] = ACTIONS(3256),
    [anon_sym_go] = ACTIONS(3256),
    [anon_sym_spawn] = ACTIONS(3256),
    [anon_sym_json_DOTdecode] = ACTIONS(3256),
    [anon_sym_PIPE] = ACTIONS(3256),
    [anon_sym_LBRACK2] = ACTIONS(3256),
    [anon_sym_TILDE] = ACTIONS(3256),
    [anon_sym_CARET] = ACTIONS(3256),
    [anon_sym_AMP] = ACTIONS(3256),
    [anon_sym_LT_DASH] = ACTIONS(3256),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_GT_GT_GT] = ACTIONS(3256),
    [anon_sym_AMP_CARET] = ACTIONS(3256),
    [anon_sym_AMP_AMP] = ACTIONS(3256),
    [anon_sym_PIPE_PIPE] = ACTIONS(3256),
    [anon_sym_or] = ACTIONS(3256),
    [sym_none] = ACTIONS(3256),
    [sym_true] = ACTIONS(3256),
    [sym_false] = ACTIONS(3256),
    [sym_nil] = ACTIONS(3256),
    [anon_sym_QMARK_DOT] = ACTIONS(3256),
    [anon_sym_POUND_LBRACK] = ACTIONS(3256),
    [anon_sym_if] = ACTIONS(3256),
    [anon_sym_DOLLARif] = ACTIONS(3256),
    [anon_sym_is] = ACTIONS(3256),
    [anon_sym_BANGis] = ACTIONS(3256),
    [anon_sym_in] = ACTIONS(3256),
    [anon_sym_BANGin] = ACTIONS(3256),
    [anon_sym_match] = ACTIONS(3256),
    [anon_sym_select] = ACTIONS(3256),
    [anon_sym_lock] = ACTIONS(3256),
    [anon_sym_rlock] = ACTIONS(3256),
    [anon_sym_unsafe] = ACTIONS(3256),
    [anon_sym_sql] = ACTIONS(3256),
    [sym_int_literal] = ACTIONS(3256),
    [sym_float_literal] = ACTIONS(3256),
    [sym_rune_literal] = ACTIONS(3256),
    [anon_sym_SQUOTE] = ACTIONS(3256),
    [anon_sym_DQUOTE] = ACTIONS(3256),
    [anon_sym_c_SQUOTE] = ACTIONS(3256),
    [anon_sym_c_DQUOTE] = ACTIONS(3256),
    [anon_sym_r_SQUOTE] = ACTIONS(3256),
    [anon_sym_r_DQUOTE] = ACTIONS(3256),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3256),
    [anon_sym_shared] = ACTIONS(3256),
    [anon_sym_map_LBRACK] = ACTIONS(3256),
    [anon_sym_chan] = ACTIONS(3256),
    [anon_sym_thread] = ACTIONS(3256),
    [anon_sym_atomic] = ACTIONS(3256),
    [anon_sym_assert] = ACTIONS(3256),
    [anon_sym_defer] = ACTIONS(3256),
    [anon_sym_goto] = ACTIONS(3256),
    [anon_sym_break] = ACTIONS(3256),
    [anon_sym_continue] = ACTIONS(3256),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_DOLLARfor] = ACTIONS(3256),
    [anon_sym_for] = ACTIONS(3256),
    [anon_sym_POUND] = ACTIONS(3256),
    [anon_sym_asm] = ACTIONS(3256),
  },
  [1381] = {
    [sym_line_comment] = STATE(1381),
    [sym_block_comment] = STATE(1381),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_LF] = ACTIONS(3274),
    [anon_sym_CR] = ACTIONS(3274),
    [anon_sym_CR_LF] = ACTIONS(3274),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_as] = ACTIONS(3274),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3274),
    [anon_sym_RBRACE] = ACTIONS(3274),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_fn] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_SLASH] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_LT] = ACTIONS(3274),
    [anon_sym_GT] = ACTIONS(3274),
    [anon_sym_EQ_EQ] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_LT_EQ] = ACTIONS(3274),
    [anon_sym_GT_EQ] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3272),
    [anon_sym_struct] = ACTIONS(3274),
    [anon_sym_mut] = ACTIONS(3274),
    [anon_sym_PLUS_PLUS] = ACTIONS(3274),
    [anon_sym_DASH_DASH] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_BANG] = ACTIONS(3274),
    [anon_sym_go] = ACTIONS(3274),
    [anon_sym_spawn] = ACTIONS(3274),
    [anon_sym_json_DOTdecode] = ACTIONS(3274),
    [anon_sym_PIPE] = ACTIONS(3274),
    [anon_sym_LBRACK2] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3274),
    [anon_sym_CARET] = ACTIONS(3274),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_LT_LT] = ACTIONS(3274),
    [anon_sym_GT_GT] = ACTIONS(3274),
    [anon_sym_GT_GT_GT] = ACTIONS(3274),
    [anon_sym_AMP_CARET] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_or] = ACTIONS(3274),
    [sym_none] = ACTIONS(3274),
    [sym_true] = ACTIONS(3274),
    [sym_false] = ACTIONS(3274),
    [sym_nil] = ACTIONS(3274),
    [anon_sym_QMARK_DOT] = ACTIONS(3274),
    [anon_sym_POUND_LBRACK] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_DOLLARif] = ACTIONS(3274),
    [anon_sym_is] = ACTIONS(3274),
    [anon_sym_BANGis] = ACTIONS(3274),
    [anon_sym_in] = ACTIONS(3274),
    [anon_sym_BANGin] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_select] = ACTIONS(3274),
    [anon_sym_lock] = ACTIONS(3274),
    [anon_sym_rlock] = ACTIONS(3274),
    [anon_sym_unsafe] = ACTIONS(3274),
    [anon_sym_sql] = ACTIONS(3274),
    [sym_int_literal] = ACTIONS(3274),
    [sym_float_literal] = ACTIONS(3274),
    [sym_rune_literal] = ACTIONS(3274),
    [anon_sym_SQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_c_SQUOTE] = ACTIONS(3274),
    [anon_sym_c_DQUOTE] = ACTIONS(3274),
    [anon_sym_r_SQUOTE] = ACTIONS(3274),
    [anon_sym_r_DQUOTE] = ACTIONS(3274),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3274),
    [anon_sym_shared] = ACTIONS(3274),
    [anon_sym_map_LBRACK] = ACTIONS(3274),
    [anon_sym_chan] = ACTIONS(3274),
    [anon_sym_thread] = ACTIONS(3274),
    [anon_sym_atomic] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_defer] = ACTIONS(3274),
    [anon_sym_goto] = ACTIONS(3274),
    [anon_sym_break] = ACTIONS(3274),
    [anon_sym_continue] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_DOLLARfor] = ACTIONS(3274),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_POUND] = ACTIONS(3274),
    [anon_sym_asm] = ACTIONS(3274),
  },
  [1382] = {
    [sym_line_comment] = STATE(1382),
    [sym_block_comment] = STATE(1382),
    [sym_identifier] = ACTIONS(3332),
    [anon_sym_LF] = ACTIONS(3332),
    [anon_sym_CR] = ACTIONS(3332),
    [anon_sym_CR_LF] = ACTIONS(3332),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3332),
    [anon_sym_DOT] = ACTIONS(3332),
    [anon_sym_as] = ACTIONS(3332),
    [anon_sym_LBRACE] = ACTIONS(3332),
    [anon_sym_COMMA] = ACTIONS(3332),
    [anon_sym_RBRACE] = ACTIONS(3332),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_fn] = ACTIONS(3332),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_DASH] = ACTIONS(3332),
    [anon_sym_STAR] = ACTIONS(3332),
    [anon_sym_SLASH] = ACTIONS(3332),
    [anon_sym_PERCENT] = ACTIONS(3332),
    [anon_sym_LT] = ACTIONS(3332),
    [anon_sym_GT] = ACTIONS(3332),
    [anon_sym_EQ_EQ] = ACTIONS(3332),
    [anon_sym_BANG_EQ] = ACTIONS(3332),
    [anon_sym_LT_EQ] = ACTIONS(3332),
    [anon_sym_GT_EQ] = ACTIONS(3332),
    [anon_sym_LBRACK] = ACTIONS(3330),
    [anon_sym_struct] = ACTIONS(3332),
    [anon_sym_mut] = ACTIONS(3332),
    [anon_sym_PLUS_PLUS] = ACTIONS(3332),
    [anon_sym_DASH_DASH] = ACTIONS(3332),
    [anon_sym_QMARK] = ACTIONS(3332),
    [anon_sym_BANG] = ACTIONS(3332),
    [anon_sym_go] = ACTIONS(3332),
    [anon_sym_spawn] = ACTIONS(3332),
    [anon_sym_json_DOTdecode] = ACTIONS(3332),
    [anon_sym_PIPE] = ACTIONS(3332),
    [anon_sym_LBRACK2] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3332),
    [anon_sym_CARET] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3332),
    [anon_sym_LT_DASH] = ACTIONS(3332),
    [anon_sym_LT_LT] = ACTIONS(3332),
    [anon_sym_GT_GT] = ACTIONS(3332),
    [anon_sym_GT_GT_GT] = ACTIONS(3332),
    [anon_sym_AMP_CARET] = ACTIONS(3332),
    [anon_sym_AMP_AMP] = ACTIONS(3332),
    [anon_sym_PIPE_PIPE] = ACTIONS(3332),
    [anon_sym_or] = ACTIONS(3332),
    [sym_none] = ACTIONS(3332),
    [sym_true] = ACTIONS(3332),
    [sym_false] = ACTIONS(3332),
    [sym_nil] = ACTIONS(3332),
    [anon_sym_QMARK_DOT] = ACTIONS(3332),
    [anon_sym_POUND_LBRACK] = ACTIONS(3332),
    [anon_sym_if] = ACTIONS(3332),
    [anon_sym_DOLLARif] = ACTIONS(3332),
    [anon_sym_is] = ACTIONS(3332),
    [anon_sym_BANGis] = ACTIONS(3332),
    [anon_sym_in] = ACTIONS(3332),
    [anon_sym_BANGin] = ACTIONS(3332),
    [anon_sym_match] = ACTIONS(3332),
    [anon_sym_select] = ACTIONS(3332),
    [anon_sym_lock] = ACTIONS(3332),
    [anon_sym_rlock] = ACTIONS(3332),
    [anon_sym_unsafe] = ACTIONS(3332),
    [anon_sym_sql] = ACTIONS(3332),
    [sym_int_literal] = ACTIONS(3332),
    [sym_float_literal] = ACTIONS(3332),
    [sym_rune_literal] = ACTIONS(3332),
    [anon_sym_SQUOTE] = ACTIONS(3332),
    [anon_sym_DQUOTE] = ACTIONS(3332),
    [anon_sym_c_SQUOTE] = ACTIONS(3332),
    [anon_sym_c_DQUOTE] = ACTIONS(3332),
    [anon_sym_r_SQUOTE] = ACTIONS(3332),
    [anon_sym_r_DQUOTE] = ACTIONS(3332),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3332),
    [anon_sym_shared] = ACTIONS(3332),
    [anon_sym_map_LBRACK] = ACTIONS(3332),
    [anon_sym_chan] = ACTIONS(3332),
    [anon_sym_thread] = ACTIONS(3332),
    [anon_sym_atomic] = ACTIONS(3332),
    [anon_sym_assert] = ACTIONS(3332),
    [anon_sym_defer] = ACTIONS(3332),
    [anon_sym_goto] = ACTIONS(3332),
    [anon_sym_break] = ACTIONS(3332),
    [anon_sym_continue] = ACTIONS(3332),
    [anon_sym_return] = ACTIONS(3332),
    [anon_sym_DOLLARfor] = ACTIONS(3332),
    [anon_sym_for] = ACTIONS(3332),
    [anon_sym_POUND] = ACTIONS(3332),
    [anon_sym_asm] = ACTIONS(3332),
  },
  [1383] = {
    [sym_line_comment] = STATE(1383),
    [sym_block_comment] = STATE(1383),
    [sym_identifier] = ACTIONS(3266),
    [anon_sym_LF] = ACTIONS(3266),
    [anon_sym_CR] = ACTIONS(3266),
    [anon_sym_CR_LF] = ACTIONS(3266),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3266),
    [anon_sym_DOT] = ACTIONS(3266),
    [anon_sym_as] = ACTIONS(3266),
    [anon_sym_LBRACE] = ACTIONS(3266),
    [anon_sym_COMMA] = ACTIONS(3266),
    [anon_sym_RBRACE] = ACTIONS(3266),
    [anon_sym_LPAREN] = ACTIONS(3266),
    [anon_sym_fn] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3266),
    [anon_sym_DASH] = ACTIONS(3266),
    [anon_sym_STAR] = ACTIONS(3266),
    [anon_sym_SLASH] = ACTIONS(3266),
    [anon_sym_PERCENT] = ACTIONS(3266),
    [anon_sym_LT] = ACTIONS(3266),
    [anon_sym_GT] = ACTIONS(3266),
    [anon_sym_EQ_EQ] = ACTIONS(3266),
    [anon_sym_BANG_EQ] = ACTIONS(3266),
    [anon_sym_LT_EQ] = ACTIONS(3266),
    [anon_sym_GT_EQ] = ACTIONS(3266),
    [anon_sym_LBRACK] = ACTIONS(3264),
    [anon_sym_struct] = ACTIONS(3266),
    [anon_sym_mut] = ACTIONS(3266),
    [anon_sym_PLUS_PLUS] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3266),
    [anon_sym_QMARK] = ACTIONS(3266),
    [anon_sym_BANG] = ACTIONS(3266),
    [anon_sym_go] = ACTIONS(3266),
    [anon_sym_spawn] = ACTIONS(3266),
    [anon_sym_json_DOTdecode] = ACTIONS(3266),
    [anon_sym_PIPE] = ACTIONS(3266),
    [anon_sym_LBRACK2] = ACTIONS(3266),
    [anon_sym_TILDE] = ACTIONS(3266),
    [anon_sym_CARET] = ACTIONS(3266),
    [anon_sym_AMP] = ACTIONS(3266),
    [anon_sym_LT_DASH] = ACTIONS(3266),
    [anon_sym_LT_LT] = ACTIONS(3266),
    [anon_sym_GT_GT] = ACTIONS(3266),
    [anon_sym_GT_GT_GT] = ACTIONS(3266),
    [anon_sym_AMP_CARET] = ACTIONS(3266),
    [anon_sym_AMP_AMP] = ACTIONS(3266),
    [anon_sym_PIPE_PIPE] = ACTIONS(3266),
    [anon_sym_or] = ACTIONS(3266),
    [sym_none] = ACTIONS(3266),
    [sym_true] = ACTIONS(3266),
    [sym_false] = ACTIONS(3266),
    [sym_nil] = ACTIONS(3266),
    [anon_sym_QMARK_DOT] = ACTIONS(3266),
    [anon_sym_POUND_LBRACK] = ACTIONS(3266),
    [anon_sym_if] = ACTIONS(3266),
    [anon_sym_DOLLARif] = ACTIONS(3266),
    [anon_sym_is] = ACTIONS(3266),
    [anon_sym_BANGis] = ACTIONS(3266),
    [anon_sym_in] = ACTIONS(3266),
    [anon_sym_BANGin] = ACTIONS(3266),
    [anon_sym_match] = ACTIONS(3266),
    [anon_sym_select] = ACTIONS(3266),
    [anon_sym_lock] = ACTIONS(3266),
    [anon_sym_rlock] = ACTIONS(3266),
    [anon_sym_unsafe] = ACTIONS(3266),
    [anon_sym_sql] = ACTIONS(3266),
    [sym_int_literal] = ACTIONS(3266),
    [sym_float_literal] = ACTIONS(3266),
    [sym_rune_literal] = ACTIONS(3266),
    [anon_sym_SQUOTE] = ACTIONS(3266),
    [anon_sym_DQUOTE] = ACTIONS(3266),
    [anon_sym_c_SQUOTE] = ACTIONS(3266),
    [anon_sym_c_DQUOTE] = ACTIONS(3266),
    [anon_sym_r_SQUOTE] = ACTIONS(3266),
    [anon_sym_r_DQUOTE] = ACTIONS(3266),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3266),
    [anon_sym_shared] = ACTIONS(3266),
    [anon_sym_map_LBRACK] = ACTIONS(3266),
    [anon_sym_chan] = ACTIONS(3266),
    [anon_sym_thread] = ACTIONS(3266),
    [anon_sym_atomic] = ACTIONS(3266),
    [anon_sym_assert] = ACTIONS(3266),
    [anon_sym_defer] = ACTIONS(3266),
    [anon_sym_goto] = ACTIONS(3266),
    [anon_sym_break] = ACTIONS(3266),
    [anon_sym_continue] = ACTIONS(3266),
    [anon_sym_return] = ACTIONS(3266),
    [anon_sym_DOLLARfor] = ACTIONS(3266),
    [anon_sym_for] = ACTIONS(3266),
    [anon_sym_POUND] = ACTIONS(3266),
    [anon_sym_asm] = ACTIONS(3266),
  },
  [1384] = {
    [sym_line_comment] = STATE(1384),
    [sym_block_comment] = STATE(1384),
    [sym_identifier] = ACTIONS(2335),
    [anon_sym_LF] = ACTIONS(2335),
    [anon_sym_CR] = ACTIONS(2335),
    [anon_sym_CR_LF] = ACTIONS(2335),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2335),
    [anon_sym_DOT] = ACTIONS(2335),
    [anon_sym_as] = ACTIONS(2335),
    [anon_sym_LBRACE] = ACTIONS(2335),
    [anon_sym_COMMA] = ACTIONS(2335),
    [anon_sym_RBRACE] = ACTIONS(2335),
    [anon_sym_LPAREN] = ACTIONS(2335),
    [anon_sym_fn] = ACTIONS(2335),
    [anon_sym_PLUS] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2335),
    [anon_sym_STAR] = ACTIONS(2335),
    [anon_sym_SLASH] = ACTIONS(2335),
    [anon_sym_PERCENT] = ACTIONS(2335),
    [anon_sym_LT] = ACTIONS(2335),
    [anon_sym_GT] = ACTIONS(2335),
    [anon_sym_EQ_EQ] = ACTIONS(2335),
    [anon_sym_BANG_EQ] = ACTIONS(2335),
    [anon_sym_LT_EQ] = ACTIONS(2335),
    [anon_sym_GT_EQ] = ACTIONS(2335),
    [anon_sym_LBRACK] = ACTIONS(2337),
    [anon_sym_struct] = ACTIONS(2335),
    [anon_sym_mut] = ACTIONS(2335),
    [anon_sym_PLUS_PLUS] = ACTIONS(2335),
    [anon_sym_DASH_DASH] = ACTIONS(2335),
    [anon_sym_QMARK] = ACTIONS(2335),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_go] = ACTIONS(2335),
    [anon_sym_spawn] = ACTIONS(2335),
    [anon_sym_json_DOTdecode] = ACTIONS(2335),
    [anon_sym_PIPE] = ACTIONS(2335),
    [anon_sym_LBRACK2] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [anon_sym_CARET] = ACTIONS(2335),
    [anon_sym_AMP] = ACTIONS(2335),
    [anon_sym_LT_DASH] = ACTIONS(2335),
    [anon_sym_LT_LT] = ACTIONS(2335),
    [anon_sym_GT_GT] = ACTIONS(2335),
    [anon_sym_GT_GT_GT] = ACTIONS(2335),
    [anon_sym_AMP_CARET] = ACTIONS(2335),
    [anon_sym_AMP_AMP] = ACTIONS(2335),
    [anon_sym_PIPE_PIPE] = ACTIONS(2335),
    [anon_sym_or] = ACTIONS(2335),
    [sym_none] = ACTIONS(2335),
    [sym_true] = ACTIONS(2335),
    [sym_false] = ACTIONS(2335),
    [sym_nil] = ACTIONS(2335),
    [anon_sym_QMARK_DOT] = ACTIONS(2335),
    [anon_sym_POUND_LBRACK] = ACTIONS(2335),
    [anon_sym_if] = ACTIONS(2335),
    [anon_sym_DOLLARif] = ACTIONS(2335),
    [anon_sym_is] = ACTIONS(2335),
    [anon_sym_BANGis] = ACTIONS(2335),
    [anon_sym_in] = ACTIONS(2335),
    [anon_sym_BANGin] = ACTIONS(2335),
    [anon_sym_match] = ACTIONS(2335),
    [anon_sym_select] = ACTIONS(2335),
    [anon_sym_lock] = ACTIONS(2335),
    [anon_sym_rlock] = ACTIONS(2335),
    [anon_sym_unsafe] = ACTIONS(2335),
    [anon_sym_sql] = ACTIONS(2335),
    [sym_int_literal] = ACTIONS(2335),
    [sym_float_literal] = ACTIONS(2335),
    [sym_rune_literal] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2335),
    [anon_sym_DQUOTE] = ACTIONS(2335),
    [anon_sym_c_SQUOTE] = ACTIONS(2335),
    [anon_sym_c_DQUOTE] = ACTIONS(2335),
    [anon_sym_r_SQUOTE] = ACTIONS(2335),
    [anon_sym_r_DQUOTE] = ACTIONS(2335),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2335),
    [anon_sym_shared] = ACTIONS(2335),
    [anon_sym_map_LBRACK] = ACTIONS(2335),
    [anon_sym_chan] = ACTIONS(2335),
    [anon_sym_thread] = ACTIONS(2335),
    [anon_sym_atomic] = ACTIONS(2335),
    [anon_sym_assert] = ACTIONS(2335),
    [anon_sym_defer] = ACTIONS(2335),
    [anon_sym_goto] = ACTIONS(2335),
    [anon_sym_break] = ACTIONS(2335),
    [anon_sym_continue] = ACTIONS(2335),
    [anon_sym_return] = ACTIONS(2335),
    [anon_sym_DOLLARfor] = ACTIONS(2335),
    [anon_sym_for] = ACTIONS(2335),
    [anon_sym_POUND] = ACTIONS(2335),
    [anon_sym_asm] = ACTIONS(2335),
  },
  [1385] = {
    [sym_line_comment] = STATE(1385),
    [sym_block_comment] = STATE(1385),
    [sym_identifier] = ACTIONS(2397),
    [anon_sym_LF] = ACTIONS(2397),
    [anon_sym_CR] = ACTIONS(2397),
    [anon_sym_CR_LF] = ACTIONS(2397),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2397),
    [anon_sym_DOT] = ACTIONS(2397),
    [anon_sym_as] = ACTIONS(2397),
    [anon_sym_LBRACE] = ACTIONS(2397),
    [anon_sym_COMMA] = ACTIONS(2397),
    [anon_sym_RBRACE] = ACTIONS(2397),
    [anon_sym_LPAREN] = ACTIONS(2397),
    [anon_sym_fn] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(2397),
    [anon_sym_DASH] = ACTIONS(2397),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_SLASH] = ACTIONS(2397),
    [anon_sym_PERCENT] = ACTIONS(2397),
    [anon_sym_LT] = ACTIONS(2397),
    [anon_sym_GT] = ACTIONS(2397),
    [anon_sym_EQ_EQ] = ACTIONS(2397),
    [anon_sym_BANG_EQ] = ACTIONS(2397),
    [anon_sym_LT_EQ] = ACTIONS(2397),
    [anon_sym_GT_EQ] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(2395),
    [anon_sym_struct] = ACTIONS(2397),
    [anon_sym_mut] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2397),
    [anon_sym_DASH_DASH] = ACTIONS(2397),
    [anon_sym_QMARK] = ACTIONS(2397),
    [anon_sym_BANG] = ACTIONS(2397),
    [anon_sym_go] = ACTIONS(2397),
    [anon_sym_spawn] = ACTIONS(2397),
    [anon_sym_json_DOTdecode] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(2397),
    [anon_sym_LBRACK2] = ACTIONS(2397),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_CARET] = ACTIONS(2397),
    [anon_sym_AMP] = ACTIONS(2397),
    [anon_sym_LT_DASH] = ACTIONS(2397),
    [anon_sym_LT_LT] = ACTIONS(2397),
    [anon_sym_GT_GT] = ACTIONS(2397),
    [anon_sym_GT_GT_GT] = ACTIONS(2397),
    [anon_sym_AMP_CARET] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(2397),
    [anon_sym_PIPE_PIPE] = ACTIONS(2397),
    [anon_sym_or] = ACTIONS(2397),
    [sym_none] = ACTIONS(2397),
    [sym_true] = ACTIONS(2397),
    [sym_false] = ACTIONS(2397),
    [sym_nil] = ACTIONS(2397),
    [anon_sym_QMARK_DOT] = ACTIONS(2397),
    [anon_sym_POUND_LBRACK] = ACTIONS(2397),
    [anon_sym_if] = ACTIONS(2397),
    [anon_sym_DOLLARif] = ACTIONS(2397),
    [anon_sym_is] = ACTIONS(2397),
    [anon_sym_BANGis] = ACTIONS(2397),
    [anon_sym_in] = ACTIONS(2397),
    [anon_sym_BANGin] = ACTIONS(2397),
    [anon_sym_match] = ACTIONS(2397),
    [anon_sym_select] = ACTIONS(2397),
    [anon_sym_lock] = ACTIONS(2397),
    [anon_sym_rlock] = ACTIONS(2397),
    [anon_sym_unsafe] = ACTIONS(2397),
    [anon_sym_sql] = ACTIONS(2397),
    [sym_int_literal] = ACTIONS(2397),
    [sym_float_literal] = ACTIONS(2397),
    [sym_rune_literal] = ACTIONS(2397),
    [anon_sym_SQUOTE] = ACTIONS(2397),
    [anon_sym_DQUOTE] = ACTIONS(2397),
    [anon_sym_c_SQUOTE] = ACTIONS(2397),
    [anon_sym_c_DQUOTE] = ACTIONS(2397),
    [anon_sym_r_SQUOTE] = ACTIONS(2397),
    [anon_sym_r_DQUOTE] = ACTIONS(2397),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2397),
    [anon_sym_shared] = ACTIONS(2397),
    [anon_sym_map_LBRACK] = ACTIONS(2397),
    [anon_sym_chan] = ACTIONS(2397),
    [anon_sym_thread] = ACTIONS(2397),
    [anon_sym_atomic] = ACTIONS(2397),
    [anon_sym_assert] = ACTIONS(2397),
    [anon_sym_defer] = ACTIONS(2397),
    [anon_sym_goto] = ACTIONS(2397),
    [anon_sym_break] = ACTIONS(2397),
    [anon_sym_continue] = ACTIONS(2397),
    [anon_sym_return] = ACTIONS(2397),
    [anon_sym_DOLLARfor] = ACTIONS(2397),
    [anon_sym_for] = ACTIONS(2397),
    [anon_sym_POUND] = ACTIONS(2397),
    [anon_sym_asm] = ACTIONS(2397),
  },
  [1386] = {
    [sym_line_comment] = STATE(1386),
    [sym_block_comment] = STATE(1386),
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2373),
    [anon_sym_CR] = ACTIONS(2373),
    [anon_sym_CR_LF] = ACTIONS(2373),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_DOT] = ACTIONS(2373),
    [anon_sym_as] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2373),
    [anon_sym_COMMA] = ACTIONS(2373),
    [anon_sym_RBRACE] = ACTIONS(2373),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_SLASH] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2373),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_mut] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2373),
    [anon_sym_QMARK] = ACTIONS(2373),
    [anon_sym_BANG] = ACTIONS(2373),
    [anon_sym_go] = ACTIONS(2373),
    [anon_sym_spawn] = ACTIONS(2373),
    [anon_sym_json_DOTdecode] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_LBRACK2] = ACTIONS(2373),
    [anon_sym_TILDE] = ACTIONS(2373),
    [anon_sym_CARET] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_LT_DASH] = ACTIONS(2373),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2373),
    [anon_sym_AMP_CARET] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2373),
    [anon_sym_or] = ACTIONS(2373),
    [sym_none] = ACTIONS(2373),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [sym_nil] = ACTIONS(2373),
    [anon_sym_QMARK_DOT] = ACTIONS(2373),
    [anon_sym_POUND_LBRACK] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_DOLLARif] = ACTIONS(2373),
    [anon_sym_is] = ACTIONS(2373),
    [anon_sym_BANGis] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_BANGin] = ACTIONS(2373),
    [anon_sym_match] = ACTIONS(2373),
    [anon_sym_select] = ACTIONS(2373),
    [anon_sym_lock] = ACTIONS(2373),
    [anon_sym_rlock] = ACTIONS(2373),
    [anon_sym_unsafe] = ACTIONS(2373),
    [anon_sym_sql] = ACTIONS(2373),
    [sym_int_literal] = ACTIONS(2373),
    [sym_float_literal] = ACTIONS(2373),
    [sym_rune_literal] = ACTIONS(2373),
    [anon_sym_SQUOTE] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(2373),
    [anon_sym_c_SQUOTE] = ACTIONS(2373),
    [anon_sym_c_DQUOTE] = ACTIONS(2373),
    [anon_sym_r_SQUOTE] = ACTIONS(2373),
    [anon_sym_r_DQUOTE] = ACTIONS(2373),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_map_LBRACK] = ACTIONS(2373),
    [anon_sym_chan] = ACTIONS(2373),
    [anon_sym_thread] = ACTIONS(2373),
    [anon_sym_atomic] = ACTIONS(2373),
    [anon_sym_assert] = ACTIONS(2373),
    [anon_sym_defer] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_DOLLARfor] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_POUND] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
  },
  [1387] = {
    [sym_line_comment] = STATE(1387),
    [sym_block_comment] = STATE(1387),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_LF] = ACTIONS(3336),
    [anon_sym_CR] = ACTIONS(3336),
    [anon_sym_CR_LF] = ACTIONS(3336),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym_DOT] = ACTIONS(3336),
    [anon_sym_as] = ACTIONS(3336),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_RBRACE] = ACTIONS(3336),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_fn] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_SLASH] = ACTIONS(3336),
    [anon_sym_PERCENT] = ACTIONS(3336),
    [anon_sym_LT] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3336),
    [anon_sym_EQ_EQ] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_LT_EQ] = ACTIONS(3336),
    [anon_sym_GT_EQ] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_mut] = ACTIONS(3336),
    [anon_sym_PLUS_PLUS] = ACTIONS(3336),
    [anon_sym_DASH_DASH] = ACTIONS(3336),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_BANG] = ACTIONS(3336),
    [anon_sym_go] = ACTIONS(3336),
    [anon_sym_spawn] = ACTIONS(3336),
    [anon_sym_json_DOTdecode] = ACTIONS(3336),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3336),
    [anon_sym_CARET] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LT_DASH] = ACTIONS(3336),
    [anon_sym_LT_LT] = ACTIONS(3336),
    [anon_sym_GT_GT] = ACTIONS(3336),
    [anon_sym_GT_GT_GT] = ACTIONS(3336),
    [anon_sym_AMP_CARET] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_or] = ACTIONS(3336),
    [sym_none] = ACTIONS(3336),
    [sym_true] = ACTIONS(3336),
    [sym_false] = ACTIONS(3336),
    [sym_nil] = ACTIONS(3336),
    [anon_sym_QMARK_DOT] = ACTIONS(3336),
    [anon_sym_POUND_LBRACK] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_DOLLARif] = ACTIONS(3336),
    [anon_sym_is] = ACTIONS(3336),
    [anon_sym_BANGis] = ACTIONS(3336),
    [anon_sym_in] = ACTIONS(3336),
    [anon_sym_BANGin] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_select] = ACTIONS(3336),
    [anon_sym_lock] = ACTIONS(3336),
    [anon_sym_rlock] = ACTIONS(3336),
    [anon_sym_unsafe] = ACTIONS(3336),
    [anon_sym_sql] = ACTIONS(3336),
    [sym_int_literal] = ACTIONS(3336),
    [sym_float_literal] = ACTIONS(3336),
    [sym_rune_literal] = ACTIONS(3336),
    [anon_sym_SQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_c_SQUOTE] = ACTIONS(3336),
    [anon_sym_c_DQUOTE] = ACTIONS(3336),
    [anon_sym_r_SQUOTE] = ACTIONS(3336),
    [anon_sym_r_DQUOTE] = ACTIONS(3336),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3336),
    [anon_sym_shared] = ACTIONS(3336),
    [anon_sym_map_LBRACK] = ACTIONS(3336),
    [anon_sym_chan] = ACTIONS(3336),
    [anon_sym_thread] = ACTIONS(3336),
    [anon_sym_atomic] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_defer] = ACTIONS(3336),
    [anon_sym_goto] = ACTIONS(3336),
    [anon_sym_break] = ACTIONS(3336),
    [anon_sym_continue] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_DOLLARfor] = ACTIONS(3336),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_POUND] = ACTIONS(3336),
    [anon_sym_asm] = ACTIONS(3336),
  },
  [1388] = {
    [sym_line_comment] = STATE(1388),
    [sym_block_comment] = STATE(1388),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LF] = ACTIONS(3340),
    [anon_sym_CR] = ACTIONS(3340),
    [anon_sym_CR_LF] = ACTIONS(3340),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3340),
    [anon_sym_DOT] = ACTIONS(3340),
    [anon_sym_as] = ACTIONS(3340),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_COMMA] = ACTIONS(3340),
    [anon_sym_RBRACE] = ACTIONS(3340),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_fn] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_STAR] = ACTIONS(3340),
    [anon_sym_SLASH] = ACTIONS(3340),
    [anon_sym_PERCENT] = ACTIONS(3340),
    [anon_sym_LT] = ACTIONS(3340),
    [anon_sym_GT] = ACTIONS(3340),
    [anon_sym_EQ_EQ] = ACTIONS(3340),
    [anon_sym_BANG_EQ] = ACTIONS(3340),
    [anon_sym_LT_EQ] = ACTIONS(3340),
    [anon_sym_GT_EQ] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3338),
    [anon_sym_struct] = ACTIONS(3340),
    [anon_sym_mut] = ACTIONS(3340),
    [anon_sym_PLUS_PLUS] = ACTIONS(3340),
    [anon_sym_DASH_DASH] = ACTIONS(3340),
    [anon_sym_QMARK] = ACTIONS(3340),
    [anon_sym_BANG] = ACTIONS(3340),
    [anon_sym_go] = ACTIONS(3340),
    [anon_sym_spawn] = ACTIONS(3340),
    [anon_sym_json_DOTdecode] = ACTIONS(3340),
    [anon_sym_PIPE] = ACTIONS(3340),
    [anon_sym_LBRACK2] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3340),
    [anon_sym_CARET] = ACTIONS(3340),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LT_DASH] = ACTIONS(3340),
    [anon_sym_LT_LT] = ACTIONS(3340),
    [anon_sym_GT_GT] = ACTIONS(3340),
    [anon_sym_GT_GT_GT] = ACTIONS(3340),
    [anon_sym_AMP_CARET] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3340),
    [anon_sym_PIPE_PIPE] = ACTIONS(3340),
    [anon_sym_or] = ACTIONS(3340),
    [sym_none] = ACTIONS(3340),
    [sym_true] = ACTIONS(3340),
    [sym_false] = ACTIONS(3340),
    [sym_nil] = ACTIONS(3340),
    [anon_sym_QMARK_DOT] = ACTIONS(3340),
    [anon_sym_POUND_LBRACK] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_DOLLARif] = ACTIONS(3340),
    [anon_sym_is] = ACTIONS(3340),
    [anon_sym_BANGis] = ACTIONS(3340),
    [anon_sym_in] = ACTIONS(3340),
    [anon_sym_BANGin] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_select] = ACTIONS(3340),
    [anon_sym_lock] = ACTIONS(3340),
    [anon_sym_rlock] = ACTIONS(3340),
    [anon_sym_unsafe] = ACTIONS(3340),
    [anon_sym_sql] = ACTIONS(3340),
    [sym_int_literal] = ACTIONS(3340),
    [sym_float_literal] = ACTIONS(3340),
    [sym_rune_literal] = ACTIONS(3340),
    [anon_sym_SQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_c_SQUOTE] = ACTIONS(3340),
    [anon_sym_c_DQUOTE] = ACTIONS(3340),
    [anon_sym_r_SQUOTE] = ACTIONS(3340),
    [anon_sym_r_DQUOTE] = ACTIONS(3340),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3340),
    [anon_sym_shared] = ACTIONS(3340),
    [anon_sym_map_LBRACK] = ACTIONS(3340),
    [anon_sym_chan] = ACTIONS(3340),
    [anon_sym_thread] = ACTIONS(3340),
    [anon_sym_atomic] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_defer] = ACTIONS(3340),
    [anon_sym_goto] = ACTIONS(3340),
    [anon_sym_break] = ACTIONS(3340),
    [anon_sym_continue] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_DOLLARfor] = ACTIONS(3340),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_POUND] = ACTIONS(3340),
    [anon_sym_asm] = ACTIONS(3340),
  },
  [1389] = {
    [sym_line_comment] = STATE(1389),
    [sym_block_comment] = STATE(1389),
    [sym_identifier] = ACTIONS(3080),
    [anon_sym_LF] = ACTIONS(3080),
    [anon_sym_CR] = ACTIONS(3080),
    [anon_sym_CR_LF] = ACTIONS(3080),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_DOT] = ACTIONS(3080),
    [anon_sym_as] = ACTIONS(3080),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_COMMA] = ACTIONS(3080),
    [anon_sym_RBRACE] = ACTIONS(3080),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_fn] = ACTIONS(3080),
    [anon_sym_PLUS] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3080),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_SLASH] = ACTIONS(3080),
    [anon_sym_PERCENT] = ACTIONS(3080),
    [anon_sym_LT] = ACTIONS(3080),
    [anon_sym_GT] = ACTIONS(3080),
    [anon_sym_EQ_EQ] = ACTIONS(3080),
    [anon_sym_BANG_EQ] = ACTIONS(3080),
    [anon_sym_LT_EQ] = ACTIONS(3080),
    [anon_sym_GT_EQ] = ACTIONS(3080),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_struct] = ACTIONS(3080),
    [anon_sym_mut] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_QMARK] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_go] = ACTIONS(3080),
    [anon_sym_spawn] = ACTIONS(3080),
    [anon_sym_json_DOTdecode] = ACTIONS(3080),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_LBRACK2] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_CARET] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3080),
    [anon_sym_LT_DASH] = ACTIONS(3080),
    [anon_sym_LT_LT] = ACTIONS(3080),
    [anon_sym_GT_GT] = ACTIONS(3080),
    [anon_sym_GT_GT_GT] = ACTIONS(3080),
    [anon_sym_AMP_CARET] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_PIPE_PIPE] = ACTIONS(3080),
    [anon_sym_or] = ACTIONS(3080),
    [sym_none] = ACTIONS(3080),
    [sym_true] = ACTIONS(3080),
    [sym_false] = ACTIONS(3080),
    [sym_nil] = ACTIONS(3080),
    [anon_sym_QMARK_DOT] = ACTIONS(3080),
    [anon_sym_POUND_LBRACK] = ACTIONS(3080),
    [anon_sym_if] = ACTIONS(3080),
    [anon_sym_DOLLARif] = ACTIONS(3080),
    [anon_sym_is] = ACTIONS(3080),
    [anon_sym_BANGis] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3080),
    [anon_sym_BANGin] = ACTIONS(3080),
    [anon_sym_match] = ACTIONS(3080),
    [anon_sym_select] = ACTIONS(3080),
    [anon_sym_lock] = ACTIONS(3080),
    [anon_sym_rlock] = ACTIONS(3080),
    [anon_sym_unsafe] = ACTIONS(3080),
    [anon_sym_sql] = ACTIONS(3080),
    [sym_int_literal] = ACTIONS(3080),
    [sym_float_literal] = ACTIONS(3080),
    [sym_rune_literal] = ACTIONS(3080),
    [anon_sym_SQUOTE] = ACTIONS(3080),
    [anon_sym_DQUOTE] = ACTIONS(3080),
    [anon_sym_c_SQUOTE] = ACTIONS(3080),
    [anon_sym_c_DQUOTE] = ACTIONS(3080),
    [anon_sym_r_SQUOTE] = ACTIONS(3080),
    [anon_sym_r_DQUOTE] = ACTIONS(3080),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3080),
    [anon_sym_shared] = ACTIONS(3080),
    [anon_sym_map_LBRACK] = ACTIONS(3080),
    [anon_sym_chan] = ACTIONS(3080),
    [anon_sym_thread] = ACTIONS(3080),
    [anon_sym_atomic] = ACTIONS(3080),
    [anon_sym_assert] = ACTIONS(3080),
    [anon_sym_defer] = ACTIONS(3080),
    [anon_sym_goto] = ACTIONS(3080),
    [anon_sym_break] = ACTIONS(3080),
    [anon_sym_continue] = ACTIONS(3080),
    [anon_sym_return] = ACTIONS(3080),
    [anon_sym_DOLLARfor] = ACTIONS(3080),
    [anon_sym_for] = ACTIONS(3080),
    [anon_sym_POUND] = ACTIONS(3080),
    [anon_sym_asm] = ACTIONS(3080),
  },
  [1390] = {
    [sym_line_comment] = STATE(1390),
    [sym_block_comment] = STATE(1390),
    [sym_identifier] = ACTIONS(2429),
    [anon_sym_LF] = ACTIONS(2429),
    [anon_sym_CR] = ACTIONS(2429),
    [anon_sym_CR_LF] = ACTIONS(2429),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2429),
    [anon_sym_DOT] = ACTIONS(2429),
    [anon_sym_as] = ACTIONS(2429),
    [anon_sym_LBRACE] = ACTIONS(2429),
    [anon_sym_COMMA] = ACTIONS(2429),
    [anon_sym_RBRACE] = ACTIONS(2429),
    [anon_sym_LPAREN] = ACTIONS(2429),
    [anon_sym_fn] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(2429),
    [anon_sym_DASH] = ACTIONS(2429),
    [anon_sym_STAR] = ACTIONS(2429),
    [anon_sym_SLASH] = ACTIONS(2429),
    [anon_sym_PERCENT] = ACTIONS(2429),
    [anon_sym_LT] = ACTIONS(2429),
    [anon_sym_GT] = ACTIONS(2429),
    [anon_sym_EQ_EQ] = ACTIONS(2429),
    [anon_sym_BANG_EQ] = ACTIONS(2429),
    [anon_sym_LT_EQ] = ACTIONS(2429),
    [anon_sym_GT_EQ] = ACTIONS(2429),
    [anon_sym_LBRACK] = ACTIONS(2427),
    [anon_sym_struct] = ACTIONS(2429),
    [anon_sym_mut] = ACTIONS(2429),
    [anon_sym_PLUS_PLUS] = ACTIONS(2429),
    [anon_sym_DASH_DASH] = ACTIONS(2429),
    [anon_sym_QMARK] = ACTIONS(2429),
    [anon_sym_BANG] = ACTIONS(2429),
    [anon_sym_go] = ACTIONS(2429),
    [anon_sym_spawn] = ACTIONS(2429),
    [anon_sym_json_DOTdecode] = ACTIONS(2429),
    [anon_sym_PIPE] = ACTIONS(2429),
    [anon_sym_LBRACK2] = ACTIONS(2429),
    [anon_sym_TILDE] = ACTIONS(2429),
    [anon_sym_CARET] = ACTIONS(2429),
    [anon_sym_AMP] = ACTIONS(2429),
    [anon_sym_LT_DASH] = ACTIONS(2429),
    [anon_sym_LT_LT] = ACTIONS(2429),
    [anon_sym_GT_GT] = ACTIONS(2429),
    [anon_sym_GT_GT_GT] = ACTIONS(2429),
    [anon_sym_AMP_CARET] = ACTIONS(2429),
    [anon_sym_AMP_AMP] = ACTIONS(2429),
    [anon_sym_PIPE_PIPE] = ACTIONS(2429),
    [anon_sym_or] = ACTIONS(2429),
    [sym_none] = ACTIONS(2429),
    [sym_true] = ACTIONS(2429),
    [sym_false] = ACTIONS(2429),
    [sym_nil] = ACTIONS(2429),
    [anon_sym_QMARK_DOT] = ACTIONS(2429),
    [anon_sym_POUND_LBRACK] = ACTIONS(2429),
    [anon_sym_if] = ACTIONS(2429),
    [anon_sym_DOLLARif] = ACTIONS(2429),
    [anon_sym_is] = ACTIONS(2429),
    [anon_sym_BANGis] = ACTIONS(2429),
    [anon_sym_in] = ACTIONS(2429),
    [anon_sym_BANGin] = ACTIONS(2429),
    [anon_sym_match] = ACTIONS(2429),
    [anon_sym_select] = ACTIONS(2429),
    [anon_sym_lock] = ACTIONS(2429),
    [anon_sym_rlock] = ACTIONS(2429),
    [anon_sym_unsafe] = ACTIONS(2429),
    [anon_sym_sql] = ACTIONS(2429),
    [sym_int_literal] = ACTIONS(2429),
    [sym_float_literal] = ACTIONS(2429),
    [sym_rune_literal] = ACTIONS(2429),
    [anon_sym_SQUOTE] = ACTIONS(2429),
    [anon_sym_DQUOTE] = ACTIONS(2429),
    [anon_sym_c_SQUOTE] = ACTIONS(2429),
    [anon_sym_c_DQUOTE] = ACTIONS(2429),
    [anon_sym_r_SQUOTE] = ACTIONS(2429),
    [anon_sym_r_DQUOTE] = ACTIONS(2429),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2429),
    [anon_sym_shared] = ACTIONS(2429),
    [anon_sym_map_LBRACK] = ACTIONS(2429),
    [anon_sym_chan] = ACTIONS(2429),
    [anon_sym_thread] = ACTIONS(2429),
    [anon_sym_atomic] = ACTIONS(2429),
    [anon_sym_assert] = ACTIONS(2429),
    [anon_sym_defer] = ACTIONS(2429),
    [anon_sym_goto] = ACTIONS(2429),
    [anon_sym_break] = ACTIONS(2429),
    [anon_sym_continue] = ACTIONS(2429),
    [anon_sym_return] = ACTIONS(2429),
    [anon_sym_DOLLARfor] = ACTIONS(2429),
    [anon_sym_for] = ACTIONS(2429),
    [anon_sym_POUND] = ACTIONS(2429),
    [anon_sym_asm] = ACTIONS(2429),
  },
  [1391] = {
    [sym_line_comment] = STATE(1391),
    [sym_block_comment] = STATE(1391),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_LF] = ACTIONS(3308),
    [anon_sym_CR] = ACTIONS(3308),
    [anon_sym_CR_LF] = ACTIONS(3308),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3308),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_as] = ACTIONS(3308),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_COMMA] = ACTIONS(3308),
    [anon_sym_RBRACE] = ACTIONS(3308),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_fn] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_SLASH] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_EQ_EQ] = ACTIONS(3308),
    [anon_sym_BANG_EQ] = ACTIONS(3308),
    [anon_sym_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT_EQ] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_struct] = ACTIONS(3308),
    [anon_sym_mut] = ACTIONS(3308),
    [anon_sym_PLUS_PLUS] = ACTIONS(3308),
    [anon_sym_DASH_DASH] = ACTIONS(3308),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_BANG] = ACTIONS(3308),
    [anon_sym_go] = ACTIONS(3308),
    [anon_sym_spawn] = ACTIONS(3308),
    [anon_sym_json_DOTdecode] = ACTIONS(3308),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_LBRACK2] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3308),
    [anon_sym_CARET] = ACTIONS(3308),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LT_DASH] = ACTIONS(3308),
    [anon_sym_LT_LT] = ACTIONS(3308),
    [anon_sym_GT_GT] = ACTIONS(3308),
    [anon_sym_GT_GT_GT] = ACTIONS(3308),
    [anon_sym_AMP_CARET] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(3308),
    [anon_sym_PIPE_PIPE] = ACTIONS(3308),
    [anon_sym_or] = ACTIONS(3308),
    [sym_none] = ACTIONS(3308),
    [sym_true] = ACTIONS(3308),
    [sym_false] = ACTIONS(3308),
    [sym_nil] = ACTIONS(3308),
    [anon_sym_QMARK_DOT] = ACTIONS(3308),
    [anon_sym_POUND_LBRACK] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_DOLLARif] = ACTIONS(3308),
    [anon_sym_is] = ACTIONS(3308),
    [anon_sym_BANGis] = ACTIONS(3308),
    [anon_sym_in] = ACTIONS(3308),
    [anon_sym_BANGin] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_select] = ACTIONS(3308),
    [anon_sym_lock] = ACTIONS(3308),
    [anon_sym_rlock] = ACTIONS(3308),
    [anon_sym_unsafe] = ACTIONS(3308),
    [anon_sym_sql] = ACTIONS(3308),
    [sym_int_literal] = ACTIONS(3308),
    [sym_float_literal] = ACTIONS(3308),
    [sym_rune_literal] = ACTIONS(3308),
    [anon_sym_SQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_c_SQUOTE] = ACTIONS(3308),
    [anon_sym_c_DQUOTE] = ACTIONS(3308),
    [anon_sym_r_SQUOTE] = ACTIONS(3308),
    [anon_sym_r_DQUOTE] = ACTIONS(3308),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3308),
    [anon_sym_shared] = ACTIONS(3308),
    [anon_sym_map_LBRACK] = ACTIONS(3308),
    [anon_sym_chan] = ACTIONS(3308),
    [anon_sym_thread] = ACTIONS(3308),
    [anon_sym_atomic] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_defer] = ACTIONS(3308),
    [anon_sym_goto] = ACTIONS(3308),
    [anon_sym_break] = ACTIONS(3308),
    [anon_sym_continue] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_DOLLARfor] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_POUND] = ACTIONS(3308),
    [anon_sym_asm] = ACTIONS(3308),
  },
  [1392] = {
    [sym_line_comment] = STATE(1392),
    [sym_block_comment] = STATE(1392),
    [sym_identifier] = ACTIONS(3312),
    [anon_sym_LF] = ACTIONS(3312),
    [anon_sym_CR] = ACTIONS(3312),
    [anon_sym_CR_LF] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3312),
    [anon_sym_DOT] = ACTIONS(3312),
    [anon_sym_as] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_RBRACE] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3312),
    [anon_sym_fn] = ACTIONS(3312),
    [anon_sym_PLUS] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_SLASH] = ACTIONS(3312),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_GT] = ACTIONS(3312),
    [anon_sym_EQ_EQ] = ACTIONS(3312),
    [anon_sym_BANG_EQ] = ACTIONS(3312),
    [anon_sym_LT_EQ] = ACTIONS(3312),
    [anon_sym_GT_EQ] = ACTIONS(3312),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_struct] = ACTIONS(3312),
    [anon_sym_mut] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3312),
    [anon_sym_DASH_DASH] = ACTIONS(3312),
    [anon_sym_QMARK] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_go] = ACTIONS(3312),
    [anon_sym_spawn] = ACTIONS(3312),
    [anon_sym_json_DOTdecode] = ACTIONS(3312),
    [anon_sym_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACK2] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_CARET] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3312),
    [anon_sym_LT_DASH] = ACTIONS(3312),
    [anon_sym_LT_LT] = ACTIONS(3312),
    [anon_sym_GT_GT] = ACTIONS(3312),
    [anon_sym_GT_GT_GT] = ACTIONS(3312),
    [anon_sym_AMP_CARET] = ACTIONS(3312),
    [anon_sym_AMP_AMP] = ACTIONS(3312),
    [anon_sym_PIPE_PIPE] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3312),
    [sym_none] = ACTIONS(3312),
    [sym_true] = ACTIONS(3312),
    [sym_false] = ACTIONS(3312),
    [sym_nil] = ACTIONS(3312),
    [anon_sym_QMARK_DOT] = ACTIONS(3312),
    [anon_sym_POUND_LBRACK] = ACTIONS(3312),
    [anon_sym_if] = ACTIONS(3312),
    [anon_sym_DOLLARif] = ACTIONS(3312),
    [anon_sym_is] = ACTIONS(3312),
    [anon_sym_BANGis] = ACTIONS(3312),
    [anon_sym_in] = ACTIONS(3312),
    [anon_sym_BANGin] = ACTIONS(3312),
    [anon_sym_match] = ACTIONS(3312),
    [anon_sym_select] = ACTIONS(3312),
    [anon_sym_lock] = ACTIONS(3312),
    [anon_sym_rlock] = ACTIONS(3312),
    [anon_sym_unsafe] = ACTIONS(3312),
    [anon_sym_sql] = ACTIONS(3312),
    [sym_int_literal] = ACTIONS(3312),
    [sym_float_literal] = ACTIONS(3312),
    [sym_rune_literal] = ACTIONS(3312),
    [anon_sym_SQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3312),
    [anon_sym_c_SQUOTE] = ACTIONS(3312),
    [anon_sym_c_DQUOTE] = ACTIONS(3312),
    [anon_sym_r_SQUOTE] = ACTIONS(3312),
    [anon_sym_r_DQUOTE] = ACTIONS(3312),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3312),
    [anon_sym_shared] = ACTIONS(3312),
    [anon_sym_map_LBRACK] = ACTIONS(3312),
    [anon_sym_chan] = ACTIONS(3312),
    [anon_sym_thread] = ACTIONS(3312),
    [anon_sym_atomic] = ACTIONS(3312),
    [anon_sym_assert] = ACTIONS(3312),
    [anon_sym_defer] = ACTIONS(3312),
    [anon_sym_goto] = ACTIONS(3312),
    [anon_sym_break] = ACTIONS(3312),
    [anon_sym_continue] = ACTIONS(3312),
    [anon_sym_return] = ACTIONS(3312),
    [anon_sym_DOLLARfor] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3312),
    [anon_sym_POUND] = ACTIONS(3312),
    [anon_sym_asm] = ACTIONS(3312),
  },
  [1393] = {
    [sym_line_comment] = STATE(1393),
    [sym_block_comment] = STATE(1393),
    [sym_identifier] = ACTIONS(2697),
    [anon_sym_LF] = ACTIONS(2697),
    [anon_sym_CR] = ACTIONS(2697),
    [anon_sym_CR_LF] = ACTIONS(2697),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2697),
    [anon_sym_DOT] = ACTIONS(2697),
    [anon_sym_as] = ACTIONS(2697),
    [anon_sym_LBRACE] = ACTIONS(2697),
    [anon_sym_COMMA] = ACTIONS(2697),
    [anon_sym_RBRACE] = ACTIONS(2697),
    [anon_sym_LPAREN] = ACTIONS(2697),
    [anon_sym_fn] = ACTIONS(2697),
    [anon_sym_PLUS] = ACTIONS(2697),
    [anon_sym_DASH] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2697),
    [anon_sym_SLASH] = ACTIONS(2697),
    [anon_sym_PERCENT] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2697),
    [anon_sym_GT] = ACTIONS(2697),
    [anon_sym_EQ_EQ] = ACTIONS(2697),
    [anon_sym_BANG_EQ] = ACTIONS(2697),
    [anon_sym_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT_EQ] = ACTIONS(2697),
    [anon_sym_LBRACK] = ACTIONS(2695),
    [anon_sym_struct] = ACTIONS(2697),
    [anon_sym_mut] = ACTIONS(2697),
    [anon_sym_PLUS_PLUS] = ACTIONS(2697),
    [anon_sym_DASH_DASH] = ACTIONS(2697),
    [anon_sym_QMARK] = ACTIONS(2697),
    [anon_sym_BANG] = ACTIONS(4094),
    [anon_sym_go] = ACTIONS(2697),
    [anon_sym_spawn] = ACTIONS(2697),
    [anon_sym_json_DOTdecode] = ACTIONS(2697),
    [anon_sym_PIPE] = ACTIONS(2697),
    [anon_sym_LBRACK2] = ACTIONS(2697),
    [anon_sym_TILDE] = ACTIONS(2697),
    [anon_sym_CARET] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2697),
    [anon_sym_LT_DASH] = ACTIONS(2697),
    [anon_sym_LT_LT] = ACTIONS(2697),
    [anon_sym_GT_GT] = ACTIONS(2697),
    [anon_sym_GT_GT_GT] = ACTIONS(2697),
    [anon_sym_AMP_CARET] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_PIPE_PIPE] = ACTIONS(2697),
    [anon_sym_or] = ACTIONS(2697),
    [sym_none] = ACTIONS(2697),
    [sym_true] = ACTIONS(2697),
    [sym_false] = ACTIONS(2697),
    [sym_nil] = ACTIONS(2697),
    [anon_sym_QMARK_DOT] = ACTIONS(2697),
    [anon_sym_POUND_LBRACK] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(2697),
    [anon_sym_DOLLARif] = ACTIONS(2697),
    [anon_sym_is] = ACTIONS(2697),
    [anon_sym_BANGis] = ACTIONS(2697),
    [anon_sym_in] = ACTIONS(2697),
    [anon_sym_BANGin] = ACTIONS(2697),
    [anon_sym_match] = ACTIONS(2697),
    [anon_sym_select] = ACTIONS(2697),
    [anon_sym_lock] = ACTIONS(2697),
    [anon_sym_rlock] = ACTIONS(2697),
    [anon_sym_unsafe] = ACTIONS(2697),
    [anon_sym_sql] = ACTIONS(2697),
    [sym_int_literal] = ACTIONS(2697),
    [sym_float_literal] = ACTIONS(2697),
    [sym_rune_literal] = ACTIONS(2697),
    [anon_sym_SQUOTE] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [anon_sym_c_SQUOTE] = ACTIONS(2697),
    [anon_sym_c_DQUOTE] = ACTIONS(2697),
    [anon_sym_r_SQUOTE] = ACTIONS(2697),
    [anon_sym_r_DQUOTE] = ACTIONS(2697),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2697),
    [anon_sym_shared] = ACTIONS(2697),
    [anon_sym_map_LBRACK] = ACTIONS(2697),
    [anon_sym_chan] = ACTIONS(2697),
    [anon_sym_thread] = ACTIONS(2697),
    [anon_sym_atomic] = ACTIONS(2697),
    [anon_sym_assert] = ACTIONS(2697),
    [anon_sym_defer] = ACTIONS(2697),
    [anon_sym_goto] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2697),
    [anon_sym_continue] = ACTIONS(2697),
    [anon_sym_return] = ACTIONS(2697),
    [anon_sym_DOLLARfor] = ACTIONS(2697),
    [anon_sym_for] = ACTIONS(2697),
    [anon_sym_POUND] = ACTIONS(2697),
    [anon_sym_asm] = ACTIONS(2697),
  },
  [1394] = {
    [sym_line_comment] = STATE(1394),
    [sym_block_comment] = STATE(1394),
    [sym_identifier] = ACTIONS(3270),
    [anon_sym_LF] = ACTIONS(3270),
    [anon_sym_CR] = ACTIONS(3270),
    [anon_sym_CR_LF] = ACTIONS(3270),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3270),
    [anon_sym_DOT] = ACTIONS(3270),
    [anon_sym_as] = ACTIONS(3270),
    [anon_sym_LBRACE] = ACTIONS(3270),
    [anon_sym_COMMA] = ACTIONS(3270),
    [anon_sym_RBRACE] = ACTIONS(3270),
    [anon_sym_LPAREN] = ACTIONS(3270),
    [anon_sym_fn] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3270),
    [anon_sym_DASH] = ACTIONS(3270),
    [anon_sym_STAR] = ACTIONS(3270),
    [anon_sym_SLASH] = ACTIONS(3270),
    [anon_sym_PERCENT] = ACTIONS(3270),
    [anon_sym_LT] = ACTIONS(3270),
    [anon_sym_GT] = ACTIONS(3270),
    [anon_sym_EQ_EQ] = ACTIONS(3270),
    [anon_sym_BANG_EQ] = ACTIONS(3270),
    [anon_sym_LT_EQ] = ACTIONS(3270),
    [anon_sym_GT_EQ] = ACTIONS(3270),
    [anon_sym_LBRACK] = ACTIONS(3268),
    [anon_sym_struct] = ACTIONS(3270),
    [anon_sym_mut] = ACTIONS(3270),
    [anon_sym_PLUS_PLUS] = ACTIONS(3270),
    [anon_sym_DASH_DASH] = ACTIONS(3270),
    [anon_sym_QMARK] = ACTIONS(3270),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_go] = ACTIONS(3270),
    [anon_sym_spawn] = ACTIONS(3270),
    [anon_sym_json_DOTdecode] = ACTIONS(3270),
    [anon_sym_PIPE] = ACTIONS(3270),
    [anon_sym_LBRACK2] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3270),
    [anon_sym_CARET] = ACTIONS(3270),
    [anon_sym_AMP] = ACTIONS(3270),
    [anon_sym_LT_DASH] = ACTIONS(3270),
    [anon_sym_LT_LT] = ACTIONS(3270),
    [anon_sym_GT_GT] = ACTIONS(3270),
    [anon_sym_GT_GT_GT] = ACTIONS(3270),
    [anon_sym_AMP_CARET] = ACTIONS(3270),
    [anon_sym_AMP_AMP] = ACTIONS(3270),
    [anon_sym_PIPE_PIPE] = ACTIONS(3270),
    [anon_sym_or] = ACTIONS(3270),
    [sym_none] = ACTIONS(3270),
    [sym_true] = ACTIONS(3270),
    [sym_false] = ACTIONS(3270),
    [sym_nil] = ACTIONS(3270),
    [anon_sym_QMARK_DOT] = ACTIONS(3270),
    [anon_sym_POUND_LBRACK] = ACTIONS(3270),
    [anon_sym_if] = ACTIONS(3270),
    [anon_sym_DOLLARif] = ACTIONS(3270),
    [anon_sym_is] = ACTIONS(3270),
    [anon_sym_BANGis] = ACTIONS(3270),
    [anon_sym_in] = ACTIONS(3270),
    [anon_sym_BANGin] = ACTIONS(3270),
    [anon_sym_match] = ACTIONS(3270),
    [anon_sym_select] = ACTIONS(3270),
    [anon_sym_lock] = ACTIONS(3270),
    [anon_sym_rlock] = ACTIONS(3270),
    [anon_sym_unsafe] = ACTIONS(3270),
    [anon_sym_sql] = ACTIONS(3270),
    [sym_int_literal] = ACTIONS(3270),
    [sym_float_literal] = ACTIONS(3270),
    [sym_rune_literal] = ACTIONS(3270),
    [anon_sym_SQUOTE] = ACTIONS(3270),
    [anon_sym_DQUOTE] = ACTIONS(3270),
    [anon_sym_c_SQUOTE] = ACTIONS(3270),
    [anon_sym_c_DQUOTE] = ACTIONS(3270),
    [anon_sym_r_SQUOTE] = ACTIONS(3270),
    [anon_sym_r_DQUOTE] = ACTIONS(3270),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3270),
    [anon_sym_shared] = ACTIONS(3270),
    [anon_sym_map_LBRACK] = ACTIONS(3270),
    [anon_sym_chan] = ACTIONS(3270),
    [anon_sym_thread] = ACTIONS(3270),
    [anon_sym_atomic] = ACTIONS(3270),
    [anon_sym_assert] = ACTIONS(3270),
    [anon_sym_defer] = ACTIONS(3270),
    [anon_sym_goto] = ACTIONS(3270),
    [anon_sym_break] = ACTIONS(3270),
    [anon_sym_continue] = ACTIONS(3270),
    [anon_sym_return] = ACTIONS(3270),
    [anon_sym_DOLLARfor] = ACTIONS(3270),
    [anon_sym_for] = ACTIONS(3270),
    [anon_sym_POUND] = ACTIONS(3270),
    [anon_sym_asm] = ACTIONS(3270),
  },
  [1395] = {
    [sym_line_comment] = STATE(1395),
    [sym_block_comment] = STATE(1395),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_CR] = ACTIONS(2873),
    [anon_sym_CR_LF] = ACTIONS(2873),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2873),
    [anon_sym_as] = ACTIONS(2873),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(2873),
    [anon_sym_LPAREN] = ACTIONS(2873),
    [anon_sym_fn] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2873),
    [anon_sym_STAR] = ACTIONS(2873),
    [anon_sym_SLASH] = ACTIONS(2873),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2873),
    [anon_sym_GT] = ACTIONS(2873),
    [anon_sym_EQ_EQ] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_LT_EQ] = ACTIONS(2873),
    [anon_sym_GT_EQ] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2873),
    [anon_sym_mut] = ACTIONS(2873),
    [anon_sym_PLUS_PLUS] = ACTIONS(2873),
    [anon_sym_DASH_DASH] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_BANG] = ACTIONS(2873),
    [anon_sym_go] = ACTIONS(2873),
    [anon_sym_spawn] = ACTIONS(2873),
    [anon_sym_json_DOTdecode] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2873),
    [anon_sym_LBRACK2] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2873),
    [anon_sym_CARET] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LT_DASH] = ACTIONS(2873),
    [anon_sym_LT_LT] = ACTIONS(2873),
    [anon_sym_GT_GT] = ACTIONS(2873),
    [anon_sym_GT_GT_GT] = ACTIONS(2873),
    [anon_sym_AMP_CARET] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [sym_none] = ACTIONS(2873),
    [sym_true] = ACTIONS(2873),
    [sym_false] = ACTIONS(2873),
    [sym_nil] = ACTIONS(2873),
    [anon_sym_QMARK_DOT] = ACTIONS(2873),
    [anon_sym_POUND_LBRACK] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_DOLLARif] = ACTIONS(2873),
    [anon_sym_is] = ACTIONS(2873),
    [anon_sym_BANGis] = ACTIONS(2873),
    [anon_sym_in] = ACTIONS(2873),
    [anon_sym_BANGin] = ACTIONS(2873),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_select] = ACTIONS(2873),
    [anon_sym_lock] = ACTIONS(2873),
    [anon_sym_rlock] = ACTIONS(2873),
    [anon_sym_unsafe] = ACTIONS(2873),
    [anon_sym_sql] = ACTIONS(2873),
    [sym_int_literal] = ACTIONS(2873),
    [sym_float_literal] = ACTIONS(2873),
    [sym_rune_literal] = ACTIONS(2873),
    [anon_sym_SQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_c_SQUOTE] = ACTIONS(2873),
    [anon_sym_c_DQUOTE] = ACTIONS(2873),
    [anon_sym_r_SQUOTE] = ACTIONS(2873),
    [anon_sym_r_DQUOTE] = ACTIONS(2873),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2873),
    [anon_sym_shared] = ACTIONS(2873),
    [anon_sym_map_LBRACK] = ACTIONS(2873),
    [anon_sym_chan] = ACTIONS(2873),
    [anon_sym_thread] = ACTIONS(2873),
    [anon_sym_atomic] = ACTIONS(2873),
    [anon_sym_assert] = ACTIONS(2873),
    [anon_sym_defer] = ACTIONS(2873),
    [anon_sym_goto] = ACTIONS(2873),
    [anon_sym_break] = ACTIONS(2873),
    [anon_sym_continue] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_DOLLARfor] = ACTIONS(2873),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_POUND] = ACTIONS(2873),
    [anon_sym_asm] = ACTIONS(2873),
  },
  [1396] = {
    [sym_line_comment] = STATE(1396),
    [sym_block_comment] = STATE(1396),
    [sym_identifier] = ACTIONS(2947),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_CR] = ACTIONS(2947),
    [anon_sym_CR_LF] = ACTIONS(2947),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_DOT] = ACTIONS(2947),
    [anon_sym_as] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_COMMA] = ACTIONS(2947),
    [anon_sym_RBRACE] = ACTIONS(2947),
    [anon_sym_LPAREN] = ACTIONS(2947),
    [anon_sym_fn] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_STAR] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(2947),
    [anon_sym_PERCENT] = ACTIONS(2947),
    [anon_sym_LT] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2947),
    [anon_sym_EQ_EQ] = ACTIONS(2947),
    [anon_sym_BANG_EQ] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2947),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2945),
    [anon_sym_struct] = ACTIONS(2947),
    [anon_sym_mut] = ACTIONS(2947),
    [anon_sym_PLUS_PLUS] = ACTIONS(2947),
    [anon_sym_DASH_DASH] = ACTIONS(2947),
    [anon_sym_QMARK] = ACTIONS(2947),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_go] = ACTIONS(2947),
    [anon_sym_spawn] = ACTIONS(2947),
    [anon_sym_json_DOTdecode] = ACTIONS(2947),
    [anon_sym_PIPE] = ACTIONS(2947),
    [anon_sym_LBRACK2] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2947),
    [anon_sym_CARET] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2947),
    [anon_sym_LT_DASH] = ACTIONS(2947),
    [anon_sym_LT_LT] = ACTIONS(2947),
    [anon_sym_GT_GT] = ACTIONS(2947),
    [anon_sym_GT_GT_GT] = ACTIONS(2947),
    [anon_sym_AMP_CARET] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [anon_sym_or] = ACTIONS(2947),
    [sym_none] = ACTIONS(2947),
    [sym_true] = ACTIONS(2947),
    [sym_false] = ACTIONS(2947),
    [sym_nil] = ACTIONS(2947),
    [anon_sym_QMARK_DOT] = ACTIONS(2947),
    [anon_sym_POUND_LBRACK] = ACTIONS(2947),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_DOLLARif] = ACTIONS(2947),
    [anon_sym_is] = ACTIONS(2947),
    [anon_sym_BANGis] = ACTIONS(2947),
    [anon_sym_in] = ACTIONS(2947),
    [anon_sym_BANGin] = ACTIONS(2947),
    [anon_sym_match] = ACTIONS(2947),
    [anon_sym_select] = ACTIONS(2947),
    [anon_sym_lock] = ACTIONS(2947),
    [anon_sym_rlock] = ACTIONS(2947),
    [anon_sym_unsafe] = ACTIONS(2947),
    [anon_sym_sql] = ACTIONS(2947),
    [sym_int_literal] = ACTIONS(2947),
    [sym_float_literal] = ACTIONS(2947),
    [sym_rune_literal] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(2947),
    [anon_sym_DQUOTE] = ACTIONS(2947),
    [anon_sym_c_SQUOTE] = ACTIONS(2947),
    [anon_sym_c_DQUOTE] = ACTIONS(2947),
    [anon_sym_r_SQUOTE] = ACTIONS(2947),
    [anon_sym_r_DQUOTE] = ACTIONS(2947),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2947),
    [anon_sym_shared] = ACTIONS(2947),
    [anon_sym_map_LBRACK] = ACTIONS(2947),
    [anon_sym_chan] = ACTIONS(2947),
    [anon_sym_thread] = ACTIONS(2947),
    [anon_sym_atomic] = ACTIONS(2947),
    [anon_sym_assert] = ACTIONS(2947),
    [anon_sym_defer] = ACTIONS(2947),
    [anon_sym_goto] = ACTIONS(2947),
    [anon_sym_break] = ACTIONS(2947),
    [anon_sym_continue] = ACTIONS(2947),
    [anon_sym_return] = ACTIONS(2947),
    [anon_sym_DOLLARfor] = ACTIONS(2947),
    [anon_sym_for] = ACTIONS(2947),
    [anon_sym_POUND] = ACTIONS(2947),
    [anon_sym_asm] = ACTIONS(2947),
  },
  [1397] = {
    [sym_line_comment] = STATE(1397),
    [sym_block_comment] = STATE(1397),
    [sym_identifier] = ACTIONS(3346),
    [anon_sym_LF] = ACTIONS(3346),
    [anon_sym_CR] = ACTIONS(3346),
    [anon_sym_CR_LF] = ACTIONS(3346),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_DOT] = ACTIONS(3346),
    [anon_sym_as] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_COMMA] = ACTIONS(3346),
    [anon_sym_RBRACE] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3346),
    [anon_sym_fn] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_SLASH] = ACTIONS(3346),
    [anon_sym_PERCENT] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_GT] = ACTIONS(3346),
    [anon_sym_EQ_EQ] = ACTIONS(3346),
    [anon_sym_BANG_EQ] = ACTIONS(3346),
    [anon_sym_LT_EQ] = ACTIONS(3346),
    [anon_sym_GT_EQ] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3346),
    [anon_sym_mut] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_QMARK] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_go] = ACTIONS(3346),
    [anon_sym_spawn] = ACTIONS(3346),
    [anon_sym_json_DOTdecode] = ACTIONS(3346),
    [anon_sym_PIPE] = ACTIONS(3346),
    [anon_sym_LBRACK2] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_CARET] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym_LT_DASH] = ACTIONS(3346),
    [anon_sym_LT_LT] = ACTIONS(3346),
    [anon_sym_GT_GT] = ACTIONS(3346),
    [anon_sym_GT_GT_GT] = ACTIONS(3346),
    [anon_sym_AMP_CARET] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_PIPE_PIPE] = ACTIONS(3346),
    [anon_sym_or] = ACTIONS(3346),
    [sym_none] = ACTIONS(3346),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [sym_nil] = ACTIONS(3346),
    [anon_sym_QMARK_DOT] = ACTIONS(3346),
    [anon_sym_POUND_LBRACK] = ACTIONS(3346),
    [anon_sym_if] = ACTIONS(3346),
    [anon_sym_DOLLARif] = ACTIONS(3346),
    [anon_sym_is] = ACTIONS(3346),
    [anon_sym_BANGis] = ACTIONS(3346),
    [anon_sym_in] = ACTIONS(3346),
    [anon_sym_BANGin] = ACTIONS(3346),
    [anon_sym_match] = ACTIONS(3346),
    [anon_sym_select] = ACTIONS(3346),
    [anon_sym_lock] = ACTIONS(3346),
    [anon_sym_rlock] = ACTIONS(3346),
    [anon_sym_unsafe] = ACTIONS(3346),
    [anon_sym_sql] = ACTIONS(3346),
    [sym_int_literal] = ACTIONS(3346),
    [sym_float_literal] = ACTIONS(3346),
    [sym_rune_literal] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [anon_sym_c_SQUOTE] = ACTIONS(3346),
    [anon_sym_c_DQUOTE] = ACTIONS(3346),
    [anon_sym_r_SQUOTE] = ACTIONS(3346),
    [anon_sym_r_DQUOTE] = ACTIONS(3346),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3346),
    [anon_sym_shared] = ACTIONS(3346),
    [anon_sym_map_LBRACK] = ACTIONS(3346),
    [anon_sym_chan] = ACTIONS(3346),
    [anon_sym_thread] = ACTIONS(3346),
    [anon_sym_atomic] = ACTIONS(3346),
    [anon_sym_assert] = ACTIONS(3346),
    [anon_sym_defer] = ACTIONS(3346),
    [anon_sym_goto] = ACTIONS(3346),
    [anon_sym_break] = ACTIONS(3346),
    [anon_sym_continue] = ACTIONS(3346),
    [anon_sym_return] = ACTIONS(3346),
    [anon_sym_DOLLARfor] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3346),
    [anon_sym_POUND] = ACTIONS(3346),
    [anon_sym_asm] = ACTIONS(3346),
  },
  [1398] = {
    [sym_line_comment] = STATE(1398),
    [sym_block_comment] = STATE(1398),
    [sym_identifier] = ACTIONS(2885),
    [anon_sym_LF] = ACTIONS(2885),
    [anon_sym_CR] = ACTIONS(2885),
    [anon_sym_CR_LF] = ACTIONS(2885),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym_DOT] = ACTIONS(2885),
    [anon_sym_as] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2885),
    [anon_sym_fn] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2885),
    [anon_sym_SLASH] = ACTIONS(2885),
    [anon_sym_PERCENT] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_GT] = ACTIONS(2885),
    [anon_sym_EQ_EQ] = ACTIONS(2885),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2885),
    [anon_sym_GT_EQ] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_mut] = ACTIONS(2885),
    [anon_sym_PLUS_PLUS] = ACTIONS(2885),
    [anon_sym_DASH_DASH] = ACTIONS(2885),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_BANG] = ACTIONS(2885),
    [anon_sym_go] = ACTIONS(2885),
    [anon_sym_spawn] = ACTIONS(2885),
    [anon_sym_json_DOTdecode] = ACTIONS(2885),
    [anon_sym_PIPE] = ACTIONS(2885),
    [anon_sym_LBRACK2] = ACTIONS(2885),
    [anon_sym_TILDE] = ACTIONS(2885),
    [anon_sym_CARET] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_LT_DASH] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2885),
    [anon_sym_GT_GT] = ACTIONS(2885),
    [anon_sym_GT_GT_GT] = ACTIONS(2885),
    [anon_sym_AMP_CARET] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_or] = ACTIONS(2885),
    [sym_none] = ACTIONS(2885),
    [sym_true] = ACTIONS(2885),
    [sym_false] = ACTIONS(2885),
    [sym_nil] = ACTIONS(2885),
    [anon_sym_QMARK_DOT] = ACTIONS(2885),
    [anon_sym_POUND_LBRACK] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_DOLLARif] = ACTIONS(2885),
    [anon_sym_is] = ACTIONS(2885),
    [anon_sym_BANGis] = ACTIONS(2885),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_BANGin] = ACTIONS(2885),
    [anon_sym_match] = ACTIONS(2885),
    [anon_sym_select] = ACTIONS(2885),
    [anon_sym_lock] = ACTIONS(2885),
    [anon_sym_rlock] = ACTIONS(2885),
    [anon_sym_unsafe] = ACTIONS(2885),
    [anon_sym_sql] = ACTIONS(2885),
    [sym_int_literal] = ACTIONS(2885),
    [sym_float_literal] = ACTIONS(2885),
    [sym_rune_literal] = ACTIONS(2885),
    [anon_sym_SQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE] = ACTIONS(2885),
    [anon_sym_c_SQUOTE] = ACTIONS(2885),
    [anon_sym_c_DQUOTE] = ACTIONS(2885),
    [anon_sym_r_SQUOTE] = ACTIONS(2885),
    [anon_sym_r_DQUOTE] = ACTIONS(2885),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2885),
    [anon_sym_shared] = ACTIONS(2885),
    [anon_sym_map_LBRACK] = ACTIONS(2885),
    [anon_sym_chan] = ACTIONS(2885),
    [anon_sym_thread] = ACTIONS(2885),
    [anon_sym_atomic] = ACTIONS(2885),
    [anon_sym_assert] = ACTIONS(2885),
    [anon_sym_defer] = ACTIONS(2885),
    [anon_sym_goto] = ACTIONS(2885),
    [anon_sym_break] = ACTIONS(2885),
    [anon_sym_continue] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_DOLLARfor] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_POUND] = ACTIONS(2885),
    [anon_sym_asm] = ACTIONS(2885),
  },
  [1399] = {
    [sym_line_comment] = STATE(1399),
    [sym_block_comment] = STATE(1399),
    [sym_identifier] = ACTIONS(2845),
    [anon_sym_LF] = ACTIONS(2845),
    [anon_sym_CR] = ACTIONS(2845),
    [anon_sym_CR_LF] = ACTIONS(2845),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym_DOT] = ACTIONS(2845),
    [anon_sym_as] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2845),
    [anon_sym_COMMA] = ACTIONS(2845),
    [anon_sym_RBRACE] = ACTIONS(2845),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_fn] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2845),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_SLASH] = ACTIONS(2845),
    [anon_sym_PERCENT] = ACTIONS(2845),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_GT] = ACTIONS(2845),
    [anon_sym_EQ_EQ] = ACTIONS(2845),
    [anon_sym_BANG_EQ] = ACTIONS(2845),
    [anon_sym_LT_EQ] = ACTIONS(2845),
    [anon_sym_GT_EQ] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2845),
    [anon_sym_mut] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2845),
    [anon_sym_DASH_DASH] = ACTIONS(2845),
    [anon_sym_QMARK] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_go] = ACTIONS(2845),
    [anon_sym_spawn] = ACTIONS(2845),
    [anon_sym_json_DOTdecode] = ACTIONS(2845),
    [anon_sym_PIPE] = ACTIONS(2845),
    [anon_sym_LBRACK2] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_CARET] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2845),
    [anon_sym_LT_DASH] = ACTIONS(2845),
    [anon_sym_LT_LT] = ACTIONS(2845),
    [anon_sym_GT_GT] = ACTIONS(2845),
    [anon_sym_GT_GT_GT] = ACTIONS(2845),
    [anon_sym_AMP_CARET] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_PIPE_PIPE] = ACTIONS(2845),
    [anon_sym_or] = ACTIONS(2845),
    [sym_none] = ACTIONS(2845),
    [sym_true] = ACTIONS(2845),
    [sym_false] = ACTIONS(2845),
    [sym_nil] = ACTIONS(2845),
    [anon_sym_QMARK_DOT] = ACTIONS(2845),
    [anon_sym_POUND_LBRACK] = ACTIONS(2845),
    [anon_sym_if] = ACTIONS(2845),
    [anon_sym_DOLLARif] = ACTIONS(2845),
    [anon_sym_is] = ACTIONS(2845),
    [anon_sym_BANGis] = ACTIONS(2845),
    [anon_sym_in] = ACTIONS(2845),
    [anon_sym_BANGin] = ACTIONS(2845),
    [anon_sym_match] = ACTIONS(2845),
    [anon_sym_select] = ACTIONS(2845),
    [anon_sym_lock] = ACTIONS(2845),
    [anon_sym_rlock] = ACTIONS(2845),
    [anon_sym_unsafe] = ACTIONS(2845),
    [anon_sym_sql] = ACTIONS(2845),
    [sym_int_literal] = ACTIONS(2845),
    [sym_float_literal] = ACTIONS(2845),
    [sym_rune_literal] = ACTIONS(2845),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2845),
    [anon_sym_c_SQUOTE] = ACTIONS(2845),
    [anon_sym_c_DQUOTE] = ACTIONS(2845),
    [anon_sym_r_SQUOTE] = ACTIONS(2845),
    [anon_sym_r_DQUOTE] = ACTIONS(2845),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2845),
    [anon_sym_shared] = ACTIONS(2845),
    [anon_sym_map_LBRACK] = ACTIONS(2845),
    [anon_sym_chan] = ACTIONS(2845),
    [anon_sym_thread] = ACTIONS(2845),
    [anon_sym_atomic] = ACTIONS(2845),
    [anon_sym_assert] = ACTIONS(2845),
    [anon_sym_defer] = ACTIONS(2845),
    [anon_sym_goto] = ACTIONS(2845),
    [anon_sym_break] = ACTIONS(2845),
    [anon_sym_continue] = ACTIONS(2845),
    [anon_sym_return] = ACTIONS(2845),
    [anon_sym_DOLLARfor] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2845),
    [anon_sym_POUND] = ACTIONS(2845),
    [anon_sym_asm] = ACTIONS(2845),
  },
  [1400] = {
    [sym_line_comment] = STATE(1400),
    [sym_block_comment] = STATE(1400),
    [sym_identifier] = ACTIONS(2849),
    [anon_sym_LF] = ACTIONS(2849),
    [anon_sym_CR] = ACTIONS(2849),
    [anon_sym_CR_LF] = ACTIONS(2849),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2849),
    [anon_sym_DOT] = ACTIONS(2849),
    [anon_sym_as] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_COMMA] = ACTIONS(2849),
    [anon_sym_RBRACE] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2849),
    [anon_sym_fn] = ACTIONS(2849),
    [anon_sym_PLUS] = ACTIONS(2849),
    [anon_sym_DASH] = ACTIONS(2849),
    [anon_sym_STAR] = ACTIONS(2849),
    [anon_sym_SLASH] = ACTIONS(2849),
    [anon_sym_PERCENT] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_GT] = ACTIONS(2849),
    [anon_sym_EQ_EQ] = ACTIONS(2849),
    [anon_sym_BANG_EQ] = ACTIONS(2849),
    [anon_sym_LT_EQ] = ACTIONS(2849),
    [anon_sym_GT_EQ] = ACTIONS(2849),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_struct] = ACTIONS(2849),
    [anon_sym_mut] = ACTIONS(2849),
    [anon_sym_PLUS_PLUS] = ACTIONS(2849),
    [anon_sym_DASH_DASH] = ACTIONS(2849),
    [anon_sym_QMARK] = ACTIONS(2849),
    [anon_sym_BANG] = ACTIONS(2849),
    [anon_sym_go] = ACTIONS(2849),
    [anon_sym_spawn] = ACTIONS(2849),
    [anon_sym_json_DOTdecode] = ACTIONS(2849),
    [anon_sym_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACK2] = ACTIONS(2849),
    [anon_sym_TILDE] = ACTIONS(2849),
    [anon_sym_CARET] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2849),
    [anon_sym_LT_DASH] = ACTIONS(2849),
    [anon_sym_LT_LT] = ACTIONS(2849),
    [anon_sym_GT_GT] = ACTIONS(2849),
    [anon_sym_GT_GT_GT] = ACTIONS(2849),
    [anon_sym_AMP_CARET] = ACTIONS(2849),
    [anon_sym_AMP_AMP] = ACTIONS(2849),
    [anon_sym_PIPE_PIPE] = ACTIONS(2849),
    [anon_sym_or] = ACTIONS(2849),
    [sym_none] = ACTIONS(2849),
    [sym_true] = ACTIONS(2849),
    [sym_false] = ACTIONS(2849),
    [sym_nil] = ACTIONS(2849),
    [anon_sym_QMARK_DOT] = ACTIONS(2849),
    [anon_sym_POUND_LBRACK] = ACTIONS(2849),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_DOLLARif] = ACTIONS(2849),
    [anon_sym_is] = ACTIONS(2849),
    [anon_sym_BANGis] = ACTIONS(2849),
    [anon_sym_in] = ACTIONS(2849),
    [anon_sym_BANGin] = ACTIONS(2849),
    [anon_sym_match] = ACTIONS(2849),
    [anon_sym_select] = ACTIONS(2849),
    [anon_sym_lock] = ACTIONS(2849),
    [anon_sym_rlock] = ACTIONS(2849),
    [anon_sym_unsafe] = ACTIONS(2849),
    [anon_sym_sql] = ACTIONS(2849),
    [sym_int_literal] = ACTIONS(2849),
    [sym_float_literal] = ACTIONS(2849),
    [sym_rune_literal] = ACTIONS(2849),
    [anon_sym_SQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [anon_sym_c_SQUOTE] = ACTIONS(2849),
    [anon_sym_c_DQUOTE] = ACTIONS(2849),
    [anon_sym_r_SQUOTE] = ACTIONS(2849),
    [anon_sym_r_DQUOTE] = ACTIONS(2849),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2849),
    [anon_sym_shared] = ACTIONS(2849),
    [anon_sym_map_LBRACK] = ACTIONS(2849),
    [anon_sym_chan] = ACTIONS(2849),
    [anon_sym_thread] = ACTIONS(2849),
    [anon_sym_atomic] = ACTIONS(2849),
    [anon_sym_assert] = ACTIONS(2849),
    [anon_sym_defer] = ACTIONS(2849),
    [anon_sym_goto] = ACTIONS(2849),
    [anon_sym_break] = ACTIONS(2849),
    [anon_sym_continue] = ACTIONS(2849),
    [anon_sym_return] = ACTIONS(2849),
    [anon_sym_DOLLARfor] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2849),
    [anon_sym_POUND] = ACTIONS(2849),
    [anon_sym_asm] = ACTIONS(2849),
  },
  [1401] = {
    [sym_line_comment] = STATE(1401),
    [sym_block_comment] = STATE(1401),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_LF] = ACTIONS(2877),
    [anon_sym_CR] = ACTIONS(2877),
    [anon_sym_CR_LF] = ACTIONS(2877),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2877),
    [anon_sym_as] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2877),
    [anon_sym_RBRACE] = ACTIONS(2877),
    [anon_sym_LPAREN] = ACTIONS(2877),
    [anon_sym_fn] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_STAR] = ACTIONS(2877),
    [anon_sym_SLASH] = ACTIONS(2877),
    [anon_sym_PERCENT] = ACTIONS(2877),
    [anon_sym_LT] = ACTIONS(2877),
    [anon_sym_GT] = ACTIONS(2877),
    [anon_sym_EQ_EQ] = ACTIONS(2877),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_LT_EQ] = ACTIONS(2877),
    [anon_sym_GT_EQ] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2875),
    [anon_sym_struct] = ACTIONS(2877),
    [anon_sym_mut] = ACTIONS(2877),
    [anon_sym_PLUS_PLUS] = ACTIONS(2877),
    [anon_sym_DASH_DASH] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2877),
    [anon_sym_go] = ACTIONS(2877),
    [anon_sym_spawn] = ACTIONS(2877),
    [anon_sym_json_DOTdecode] = ACTIONS(2877),
    [anon_sym_PIPE] = ACTIONS(2877),
    [anon_sym_LBRACK2] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2877),
    [anon_sym_CARET] = ACTIONS(2877),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_LT_DASH] = ACTIONS(2877),
    [anon_sym_LT_LT] = ACTIONS(2877),
    [anon_sym_GT_GT] = ACTIONS(2877),
    [anon_sym_GT_GT_GT] = ACTIONS(2877),
    [anon_sym_AMP_CARET] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_PIPE_PIPE] = ACTIONS(2877),
    [anon_sym_or] = ACTIONS(2877),
    [sym_none] = ACTIONS(2877),
    [sym_true] = ACTIONS(2877),
    [sym_false] = ACTIONS(2877),
    [sym_nil] = ACTIONS(2877),
    [anon_sym_QMARK_DOT] = ACTIONS(2877),
    [anon_sym_POUND_LBRACK] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_DOLLARif] = ACTIONS(2877),
    [anon_sym_is] = ACTIONS(2877),
    [anon_sym_BANGis] = ACTIONS(2877),
    [anon_sym_in] = ACTIONS(2877),
    [anon_sym_BANGin] = ACTIONS(2877),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_select] = ACTIONS(2877),
    [anon_sym_lock] = ACTIONS(2877),
    [anon_sym_rlock] = ACTIONS(2877),
    [anon_sym_unsafe] = ACTIONS(2877),
    [anon_sym_sql] = ACTIONS(2877),
    [sym_int_literal] = ACTIONS(2877),
    [sym_float_literal] = ACTIONS(2877),
    [sym_rune_literal] = ACTIONS(2877),
    [anon_sym_SQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [anon_sym_c_SQUOTE] = ACTIONS(2877),
    [anon_sym_c_DQUOTE] = ACTIONS(2877),
    [anon_sym_r_SQUOTE] = ACTIONS(2877),
    [anon_sym_r_DQUOTE] = ACTIONS(2877),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2877),
    [anon_sym_shared] = ACTIONS(2877),
    [anon_sym_map_LBRACK] = ACTIONS(2877),
    [anon_sym_chan] = ACTIONS(2877),
    [anon_sym_thread] = ACTIONS(2877),
    [anon_sym_atomic] = ACTIONS(2877),
    [anon_sym_assert] = ACTIONS(2877),
    [anon_sym_defer] = ACTIONS(2877),
    [anon_sym_goto] = ACTIONS(2877),
    [anon_sym_break] = ACTIONS(2877),
    [anon_sym_continue] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_DOLLARfor] = ACTIONS(2877),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_POUND] = ACTIONS(2877),
    [anon_sym_asm] = ACTIONS(2877),
  },
  [1402] = {
    [sym_line_comment] = STATE(1402),
    [sym_block_comment] = STATE(1402),
    [sym_identifier] = ACTIONS(2889),
    [anon_sym_LF] = ACTIONS(2889),
    [anon_sym_CR] = ACTIONS(2889),
    [anon_sym_CR_LF] = ACTIONS(2889),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym_DOT] = ACTIONS(2889),
    [anon_sym_as] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2889),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_RBRACE] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2889),
    [anon_sym_fn] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2889),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_SLASH] = ACTIONS(2889),
    [anon_sym_PERCENT] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_GT] = ACTIONS(2889),
    [anon_sym_EQ_EQ] = ACTIONS(2889),
    [anon_sym_BANG_EQ] = ACTIONS(2889),
    [anon_sym_LT_EQ] = ACTIONS(2889),
    [anon_sym_GT_EQ] = ACTIONS(2889),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_struct] = ACTIONS(2889),
    [anon_sym_mut] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2889),
    [anon_sym_DASH_DASH] = ACTIONS(2889),
    [anon_sym_QMARK] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2889),
    [anon_sym_go] = ACTIONS(2889),
    [anon_sym_spawn] = ACTIONS(2889),
    [anon_sym_json_DOTdecode] = ACTIONS(2889),
    [anon_sym_PIPE] = ACTIONS(2889),
    [anon_sym_LBRACK2] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_CARET] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2889),
    [anon_sym_LT_DASH] = ACTIONS(2889),
    [anon_sym_LT_LT] = ACTIONS(2889),
    [anon_sym_GT_GT] = ACTIONS(2889),
    [anon_sym_GT_GT_GT] = ACTIONS(2889),
    [anon_sym_AMP_CARET] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2889),
    [anon_sym_or] = ACTIONS(2889),
    [sym_none] = ACTIONS(2889),
    [sym_true] = ACTIONS(2889),
    [sym_false] = ACTIONS(2889),
    [sym_nil] = ACTIONS(2889),
    [anon_sym_QMARK_DOT] = ACTIONS(2889),
    [anon_sym_POUND_LBRACK] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_DOLLARif] = ACTIONS(2889),
    [anon_sym_is] = ACTIONS(2889),
    [anon_sym_BANGis] = ACTIONS(2889),
    [anon_sym_in] = ACTIONS(2889),
    [anon_sym_BANGin] = ACTIONS(2889),
    [anon_sym_match] = ACTIONS(2889),
    [anon_sym_select] = ACTIONS(2889),
    [anon_sym_lock] = ACTIONS(2889),
    [anon_sym_rlock] = ACTIONS(2889),
    [anon_sym_unsafe] = ACTIONS(2889),
    [anon_sym_sql] = ACTIONS(2889),
    [sym_int_literal] = ACTIONS(2889),
    [sym_float_literal] = ACTIONS(2889),
    [sym_rune_literal] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [anon_sym_c_SQUOTE] = ACTIONS(2889),
    [anon_sym_c_DQUOTE] = ACTIONS(2889),
    [anon_sym_r_SQUOTE] = ACTIONS(2889),
    [anon_sym_r_DQUOTE] = ACTIONS(2889),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2889),
    [anon_sym_shared] = ACTIONS(2889),
    [anon_sym_map_LBRACK] = ACTIONS(2889),
    [anon_sym_chan] = ACTIONS(2889),
    [anon_sym_thread] = ACTIONS(2889),
    [anon_sym_atomic] = ACTIONS(2889),
    [anon_sym_assert] = ACTIONS(2889),
    [anon_sym_defer] = ACTIONS(2889),
    [anon_sym_goto] = ACTIONS(2889),
    [anon_sym_break] = ACTIONS(2889),
    [anon_sym_continue] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_DOLLARfor] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_POUND] = ACTIONS(2889),
    [anon_sym_asm] = ACTIONS(2889),
  },
  [1403] = {
    [sym_line_comment] = STATE(1403),
    [sym_block_comment] = STATE(1403),
    [sym_identifier] = ACTIONS(2443),
    [anon_sym_LF] = ACTIONS(2443),
    [anon_sym_CR] = ACTIONS(2443),
    [anon_sym_CR_LF] = ACTIONS(2443),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2443),
    [anon_sym_DOT] = ACTIONS(2445),
    [anon_sym_as] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(2443),
    [anon_sym_COMMA] = ACTIONS(2443),
    [anon_sym_RBRACE] = ACTIONS(2443),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym_fn] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2445),
    [anon_sym_STAR] = ACTIONS(2445),
    [anon_sym_SLASH] = ACTIONS(2445),
    [anon_sym_PERCENT] = ACTIONS(2445),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_GT] = ACTIONS(2445),
    [anon_sym_EQ_EQ] = ACTIONS(2445),
    [anon_sym_BANG_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_struct] = ACTIONS(2443),
    [anon_sym_mut] = ACTIONS(2443),
    [anon_sym_PLUS_PLUS] = ACTIONS(2445),
    [anon_sym_DASH_DASH] = ACTIONS(2445),
    [anon_sym_QMARK] = ACTIONS(2445),
    [anon_sym_BANG] = ACTIONS(2445),
    [anon_sym_go] = ACTIONS(2443),
    [anon_sym_spawn] = ACTIONS(2443),
    [anon_sym_json_DOTdecode] = ACTIONS(2443),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_LBRACK2] = ACTIONS(2445),
    [anon_sym_TILDE] = ACTIONS(2443),
    [anon_sym_CARET] = ACTIONS(2445),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_LT_DASH] = ACTIONS(2443),
    [anon_sym_LT_LT] = ACTIONS(2445),
    [anon_sym_GT_GT] = ACTIONS(2445),
    [anon_sym_GT_GT_GT] = ACTIONS(2445),
    [anon_sym_AMP_CARET] = ACTIONS(2445),
    [anon_sym_AMP_AMP] = ACTIONS(2445),
    [anon_sym_PIPE_PIPE] = ACTIONS(2445),
    [anon_sym_or] = ACTIONS(2445),
    [sym_none] = ACTIONS(2443),
    [sym_true] = ACTIONS(2443),
    [sym_false] = ACTIONS(2443),
    [sym_nil] = ACTIONS(2443),
    [anon_sym_QMARK_DOT] = ACTIONS(2445),
    [anon_sym_POUND_LBRACK] = ACTIONS(2445),
    [anon_sym_if] = ACTIONS(2443),
    [anon_sym_DOLLARif] = ACTIONS(2443),
    [anon_sym_is] = ACTIONS(2445),
    [anon_sym_BANGis] = ACTIONS(2445),
    [anon_sym_in] = ACTIONS(2445),
    [anon_sym_BANGin] = ACTIONS(2445),
    [anon_sym_match] = ACTIONS(2443),
    [anon_sym_select] = ACTIONS(2443),
    [anon_sym_lock] = ACTIONS(2443),
    [anon_sym_rlock] = ACTIONS(2443),
    [anon_sym_unsafe] = ACTIONS(2443),
    [anon_sym_sql] = ACTIONS(2443),
    [sym_int_literal] = ACTIONS(2443),
    [sym_float_literal] = ACTIONS(2443),
    [sym_rune_literal] = ACTIONS(2443),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [anon_sym_DQUOTE] = ACTIONS(2443),
    [anon_sym_c_SQUOTE] = ACTIONS(2443),
    [anon_sym_c_DQUOTE] = ACTIONS(2443),
    [anon_sym_r_SQUOTE] = ACTIONS(2443),
    [anon_sym_r_DQUOTE] = ACTIONS(2443),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2443),
    [anon_sym_shared] = ACTIONS(2443),
    [anon_sym_map_LBRACK] = ACTIONS(2443),
    [anon_sym_chan] = ACTIONS(2443),
    [anon_sym_thread] = ACTIONS(2443),
    [anon_sym_atomic] = ACTIONS(2443),
    [anon_sym_assert] = ACTIONS(2443),
    [anon_sym_defer] = ACTIONS(2443),
    [anon_sym_goto] = ACTIONS(2443),
    [anon_sym_break] = ACTIONS(2443),
    [anon_sym_continue] = ACTIONS(2443),
    [anon_sym_return] = ACTIONS(2443),
    [anon_sym_DOLLARfor] = ACTIONS(2443),
    [anon_sym_for] = ACTIONS(2443),
    [anon_sym_POUND] = ACTIONS(2443),
    [anon_sym_asm] = ACTIONS(2443),
  },
  [1404] = {
    [sym_line_comment] = STATE(1404),
    [sym_block_comment] = STATE(1404),
    [sym_identifier] = ACTIONS(3324),
    [anon_sym_LF] = ACTIONS(3324),
    [anon_sym_CR] = ACTIONS(3324),
    [anon_sym_CR_LF] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3324),
    [anon_sym_DOT] = ACTIONS(3324),
    [anon_sym_as] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3324),
    [anon_sym_COMMA] = ACTIONS(3324),
    [anon_sym_RBRACE] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3324),
    [anon_sym_fn] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3324),
    [anon_sym_DASH] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3324),
    [anon_sym_SLASH] = ACTIONS(3324),
    [anon_sym_PERCENT] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_GT] = ACTIONS(3324),
    [anon_sym_EQ_EQ] = ACTIONS(3324),
    [anon_sym_BANG_EQ] = ACTIONS(3324),
    [anon_sym_LT_EQ] = ACTIONS(3324),
    [anon_sym_GT_EQ] = ACTIONS(3324),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_struct] = ACTIONS(3324),
    [anon_sym_mut] = ACTIONS(3324),
    [anon_sym_PLUS_PLUS] = ACTIONS(3324),
    [anon_sym_DASH_DASH] = ACTIONS(3324),
    [anon_sym_QMARK] = ACTIONS(3324),
    [anon_sym_BANG] = ACTIONS(3324),
    [anon_sym_go] = ACTIONS(3324),
    [anon_sym_spawn] = ACTIONS(3324),
    [anon_sym_json_DOTdecode] = ACTIONS(3324),
    [anon_sym_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACK2] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3324),
    [anon_sym_LT_DASH] = ACTIONS(3324),
    [anon_sym_LT_LT] = ACTIONS(3324),
    [anon_sym_GT_GT] = ACTIONS(3324),
    [anon_sym_GT_GT_GT] = ACTIONS(3324),
    [anon_sym_AMP_CARET] = ACTIONS(3324),
    [anon_sym_AMP_AMP] = ACTIONS(3324),
    [anon_sym_PIPE_PIPE] = ACTIONS(3324),
    [anon_sym_or] = ACTIONS(3324),
    [sym_none] = ACTIONS(3324),
    [sym_true] = ACTIONS(3324),
    [sym_false] = ACTIONS(3324),
    [sym_nil] = ACTIONS(3324),
    [anon_sym_QMARK_DOT] = ACTIONS(3324),
    [anon_sym_POUND_LBRACK] = ACTIONS(3324),
    [anon_sym_if] = ACTIONS(3324),
    [anon_sym_DOLLARif] = ACTIONS(3324),
    [anon_sym_is] = ACTIONS(3324),
    [anon_sym_BANGis] = ACTIONS(3324),
    [anon_sym_in] = ACTIONS(3324),
    [anon_sym_BANGin] = ACTIONS(3324),
    [anon_sym_match] = ACTIONS(3324),
    [anon_sym_select] = ACTIONS(3324),
    [anon_sym_lock] = ACTIONS(3324),
    [anon_sym_rlock] = ACTIONS(3324),
    [anon_sym_unsafe] = ACTIONS(3324),
    [anon_sym_sql] = ACTIONS(3324),
    [sym_int_literal] = ACTIONS(3324),
    [sym_float_literal] = ACTIONS(3324),
    [sym_rune_literal] = ACTIONS(3324),
    [anon_sym_SQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE] = ACTIONS(3324),
    [anon_sym_c_SQUOTE] = ACTIONS(3324),
    [anon_sym_c_DQUOTE] = ACTIONS(3324),
    [anon_sym_r_SQUOTE] = ACTIONS(3324),
    [anon_sym_r_DQUOTE] = ACTIONS(3324),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3324),
    [anon_sym_shared] = ACTIONS(3324),
    [anon_sym_map_LBRACK] = ACTIONS(3324),
    [anon_sym_chan] = ACTIONS(3324),
    [anon_sym_thread] = ACTIONS(3324),
    [anon_sym_atomic] = ACTIONS(3324),
    [anon_sym_assert] = ACTIONS(3324),
    [anon_sym_defer] = ACTIONS(3324),
    [anon_sym_goto] = ACTIONS(3324),
    [anon_sym_break] = ACTIONS(3324),
    [anon_sym_continue] = ACTIONS(3324),
    [anon_sym_return] = ACTIONS(3324),
    [anon_sym_DOLLARfor] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3324),
    [anon_sym_POUND] = ACTIONS(3324),
    [anon_sym_asm] = ACTIONS(3324),
  },
  [1405] = {
    [sym_line_comment] = STATE(1405),
    [sym_block_comment] = STATE(1405),
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_LF] = ACTIONS(2669),
    [anon_sym_CR] = ACTIONS(2669),
    [anon_sym_CR_LF] = ACTIONS(2669),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2669),
    [anon_sym_DOT] = ACTIONS(2669),
    [anon_sym_as] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2669),
    [anon_sym_COMMA] = ACTIONS(2669),
    [anon_sym_RBRACE] = ACTIONS(2669),
    [anon_sym_LPAREN] = ACTIONS(2669),
    [anon_sym_fn] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2669),
    [anon_sym_SLASH] = ACTIONS(2669),
    [anon_sym_PERCENT] = ACTIONS(2669),
    [anon_sym_LT] = ACTIONS(2669),
    [anon_sym_GT] = ACTIONS(2669),
    [anon_sym_EQ_EQ] = ACTIONS(2669),
    [anon_sym_BANG_EQ] = ACTIONS(2669),
    [anon_sym_LT_EQ] = ACTIONS(2669),
    [anon_sym_GT_EQ] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2667),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_mut] = ACTIONS(2669),
    [anon_sym_PLUS_PLUS] = ACTIONS(2669),
    [anon_sym_DASH_DASH] = ACTIONS(2669),
    [anon_sym_QMARK] = ACTIONS(2669),
    [anon_sym_BANG] = ACTIONS(2669),
    [anon_sym_go] = ACTIONS(2669),
    [anon_sym_spawn] = ACTIONS(2669),
    [anon_sym_json_DOTdecode] = ACTIONS(2669),
    [anon_sym_PIPE] = ACTIONS(2669),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_TILDE] = ACTIONS(2669),
    [anon_sym_CARET] = ACTIONS(2669),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_LT_DASH] = ACTIONS(2669),
    [anon_sym_LT_LT] = ACTIONS(2669),
    [anon_sym_GT_GT] = ACTIONS(2669),
    [anon_sym_GT_GT_GT] = ACTIONS(2669),
    [anon_sym_AMP_CARET] = ACTIONS(2669),
    [anon_sym_AMP_AMP] = ACTIONS(2669),
    [anon_sym_PIPE_PIPE] = ACTIONS(2669),
    [anon_sym_or] = ACTIONS(2669),
    [sym_none] = ACTIONS(2669),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [sym_nil] = ACTIONS(2669),
    [anon_sym_QMARK_DOT] = ACTIONS(2669),
    [anon_sym_POUND_LBRACK] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_DOLLARif] = ACTIONS(2669),
    [anon_sym_is] = ACTIONS(2669),
    [anon_sym_BANGis] = ACTIONS(2669),
    [anon_sym_in] = ACTIONS(2669),
    [anon_sym_BANGin] = ACTIONS(2669),
    [anon_sym_match] = ACTIONS(2669),
    [anon_sym_select] = ACTIONS(2669),
    [anon_sym_lock] = ACTIONS(2669),
    [anon_sym_rlock] = ACTIONS(2669),
    [anon_sym_unsafe] = ACTIONS(2669),
    [anon_sym_sql] = ACTIONS(2669),
    [sym_int_literal] = ACTIONS(2669),
    [sym_float_literal] = ACTIONS(2669),
    [sym_rune_literal] = ACTIONS(2669),
    [anon_sym_SQUOTE] = ACTIONS(2669),
    [anon_sym_DQUOTE] = ACTIONS(2669),
    [anon_sym_c_SQUOTE] = ACTIONS(2669),
    [anon_sym_c_DQUOTE] = ACTIONS(2669),
    [anon_sym_r_SQUOTE] = ACTIONS(2669),
    [anon_sym_r_DQUOTE] = ACTIONS(2669),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2669),
    [anon_sym_shared] = ACTIONS(2669),
    [anon_sym_map_LBRACK] = ACTIONS(2669),
    [anon_sym_chan] = ACTIONS(2669),
    [anon_sym_thread] = ACTIONS(2669),
    [anon_sym_atomic] = ACTIONS(2669),
    [anon_sym_assert] = ACTIONS(2669),
    [anon_sym_defer] = ACTIONS(2669),
    [anon_sym_goto] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_DOLLARfor] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_POUND] = ACTIONS(2669),
    [anon_sym_asm] = ACTIONS(2669),
  },
  [1406] = {
    [sym_line_comment] = STATE(1406),
    [sym_block_comment] = STATE(1406),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LF] = ACTIONS(3318),
    [anon_sym_CR] = ACTIONS(3318),
    [anon_sym_CR_LF] = ACTIONS(3318),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3318),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_as] = ACTIONS(3318),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3318),
    [anon_sym_RBRACE] = ACTIONS(3318),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_fn] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_SLASH] = ACTIONS(3318),
    [anon_sym_PERCENT] = ACTIONS(3318),
    [anon_sym_LT] = ACTIONS(3318),
    [anon_sym_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_LT_EQ] = ACTIONS(3318),
    [anon_sym_GT_EQ] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3316),
    [anon_sym_struct] = ACTIONS(3318),
    [anon_sym_mut] = ACTIONS(3318),
    [anon_sym_PLUS_PLUS] = ACTIONS(3318),
    [anon_sym_DASH_DASH] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_BANG] = ACTIONS(3318),
    [anon_sym_go] = ACTIONS(3318),
    [anon_sym_spawn] = ACTIONS(3318),
    [anon_sym_json_DOTdecode] = ACTIONS(3318),
    [anon_sym_PIPE] = ACTIONS(3318),
    [anon_sym_LBRACK2] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3318),
    [anon_sym_CARET] = ACTIONS(3318),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LT_DASH] = ACTIONS(3318),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_GT_GT_GT] = ACTIONS(3318),
    [anon_sym_AMP_CARET] = ACTIONS(3318),
    [anon_sym_AMP_AMP] = ACTIONS(3318),
    [anon_sym_PIPE_PIPE] = ACTIONS(3318),
    [anon_sym_or] = ACTIONS(3318),
    [sym_none] = ACTIONS(3318),
    [sym_true] = ACTIONS(3318),
    [sym_false] = ACTIONS(3318),
    [sym_nil] = ACTIONS(3318),
    [anon_sym_QMARK_DOT] = ACTIONS(3318),
    [anon_sym_POUND_LBRACK] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_DOLLARif] = ACTIONS(3318),
    [anon_sym_is] = ACTIONS(3318),
    [anon_sym_BANGis] = ACTIONS(3318),
    [anon_sym_in] = ACTIONS(3318),
    [anon_sym_BANGin] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_select] = ACTIONS(3318),
    [anon_sym_lock] = ACTIONS(3318),
    [anon_sym_rlock] = ACTIONS(3318),
    [anon_sym_unsafe] = ACTIONS(3318),
    [anon_sym_sql] = ACTIONS(3318),
    [sym_int_literal] = ACTIONS(3318),
    [sym_float_literal] = ACTIONS(3318),
    [sym_rune_literal] = ACTIONS(3318),
    [anon_sym_SQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_c_SQUOTE] = ACTIONS(3318),
    [anon_sym_c_DQUOTE] = ACTIONS(3318),
    [anon_sym_r_SQUOTE] = ACTIONS(3318),
    [anon_sym_r_DQUOTE] = ACTIONS(3318),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3318),
    [anon_sym_shared] = ACTIONS(3318),
    [anon_sym_map_LBRACK] = ACTIONS(3318),
    [anon_sym_chan] = ACTIONS(3318),
    [anon_sym_thread] = ACTIONS(3318),
    [anon_sym_atomic] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_defer] = ACTIONS(3318),
    [anon_sym_goto] = ACTIONS(3318),
    [anon_sym_break] = ACTIONS(3318),
    [anon_sym_continue] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_DOLLARfor] = ACTIONS(3318),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_POUND] = ACTIONS(3318),
    [anon_sym_asm] = ACTIONS(3318),
  },
  [1407] = {
    [sym_line_comment] = STATE(1407),
    [sym_block_comment] = STATE(1407),
    [sym_identifier] = ACTIONS(3262),
    [anon_sym_LF] = ACTIONS(3262),
    [anon_sym_CR] = ACTIONS(3262),
    [anon_sym_CR_LF] = ACTIONS(3262),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3262),
    [anon_sym_DOT] = ACTIONS(3262),
    [anon_sym_as] = ACTIONS(3262),
    [anon_sym_LBRACE] = ACTIONS(3262),
    [anon_sym_COMMA] = ACTIONS(3262),
    [anon_sym_RBRACE] = ACTIONS(3262),
    [anon_sym_LPAREN] = ACTIONS(3262),
    [anon_sym_fn] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3262),
    [anon_sym_DASH] = ACTIONS(3262),
    [anon_sym_STAR] = ACTIONS(3262),
    [anon_sym_SLASH] = ACTIONS(3262),
    [anon_sym_PERCENT] = ACTIONS(3262),
    [anon_sym_LT] = ACTIONS(3262),
    [anon_sym_GT] = ACTIONS(3262),
    [anon_sym_EQ_EQ] = ACTIONS(3262),
    [anon_sym_BANG_EQ] = ACTIONS(3262),
    [anon_sym_LT_EQ] = ACTIONS(3262),
    [anon_sym_GT_EQ] = ACTIONS(3262),
    [anon_sym_LBRACK] = ACTIONS(3260),
    [anon_sym_struct] = ACTIONS(3262),
    [anon_sym_mut] = ACTIONS(3262),
    [anon_sym_PLUS_PLUS] = ACTIONS(3262),
    [anon_sym_DASH_DASH] = ACTIONS(3262),
    [anon_sym_QMARK] = ACTIONS(3262),
    [anon_sym_BANG] = ACTIONS(3262),
    [anon_sym_go] = ACTIONS(3262),
    [anon_sym_spawn] = ACTIONS(3262),
    [anon_sym_json_DOTdecode] = ACTIONS(3262),
    [anon_sym_PIPE] = ACTIONS(3262),
    [anon_sym_LBRACK2] = ACTIONS(3262),
    [anon_sym_TILDE] = ACTIONS(3262),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_AMP] = ACTIONS(3262),
    [anon_sym_LT_DASH] = ACTIONS(3262),
    [anon_sym_LT_LT] = ACTIONS(3262),
    [anon_sym_GT_GT] = ACTIONS(3262),
    [anon_sym_GT_GT_GT] = ACTIONS(3262),
    [anon_sym_AMP_CARET] = ACTIONS(3262),
    [anon_sym_AMP_AMP] = ACTIONS(3262),
    [anon_sym_PIPE_PIPE] = ACTIONS(3262),
    [anon_sym_or] = ACTIONS(3262),
    [sym_none] = ACTIONS(3262),
    [sym_true] = ACTIONS(3262),
    [sym_false] = ACTIONS(3262),
    [sym_nil] = ACTIONS(3262),
    [anon_sym_QMARK_DOT] = ACTIONS(3262),
    [anon_sym_POUND_LBRACK] = ACTIONS(3262),
    [anon_sym_if] = ACTIONS(3262),
    [anon_sym_DOLLARif] = ACTIONS(3262),
    [anon_sym_is] = ACTIONS(3262),
    [anon_sym_BANGis] = ACTIONS(3262),
    [anon_sym_in] = ACTIONS(3262),
    [anon_sym_BANGin] = ACTIONS(3262),
    [anon_sym_match] = ACTIONS(3262),
    [anon_sym_select] = ACTIONS(3262),
    [anon_sym_lock] = ACTIONS(3262),
    [anon_sym_rlock] = ACTIONS(3262),
    [anon_sym_unsafe] = ACTIONS(3262),
    [anon_sym_sql] = ACTIONS(3262),
    [sym_int_literal] = ACTIONS(3262),
    [sym_float_literal] = ACTIONS(3262),
    [sym_rune_literal] = ACTIONS(3262),
    [anon_sym_SQUOTE] = ACTIONS(3262),
    [anon_sym_DQUOTE] = ACTIONS(3262),
    [anon_sym_c_SQUOTE] = ACTIONS(3262),
    [anon_sym_c_DQUOTE] = ACTIONS(3262),
    [anon_sym_r_SQUOTE] = ACTIONS(3262),
    [anon_sym_r_DQUOTE] = ACTIONS(3262),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3262),
    [anon_sym_shared] = ACTIONS(3262),
    [anon_sym_map_LBRACK] = ACTIONS(3262),
    [anon_sym_chan] = ACTIONS(3262),
    [anon_sym_thread] = ACTIONS(3262),
    [anon_sym_atomic] = ACTIONS(3262),
    [anon_sym_assert] = ACTIONS(3262),
    [anon_sym_defer] = ACTIONS(3262),
    [anon_sym_goto] = ACTIONS(3262),
    [anon_sym_break] = ACTIONS(3262),
    [anon_sym_continue] = ACTIONS(3262),
    [anon_sym_return] = ACTIONS(3262),
    [anon_sym_DOLLARfor] = ACTIONS(3262),
    [anon_sym_for] = ACTIONS(3262),
    [anon_sym_POUND] = ACTIONS(3262),
    [anon_sym_asm] = ACTIONS(3262),
  },
  [1408] = {
    [sym_line_comment] = STATE(1408),
    [sym_block_comment] = STATE(1408),
    [aux_sym_strictly_expression_list_repeat1] = STATE(1740),
    [ts_builtin_sym_end] = ACTIONS(1993),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_LF] = ACTIONS(1995),
    [anon_sym_CR] = ACTIONS(1995),
    [anon_sym_CR_LF] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(2001),
    [anon_sym_const] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(2001),
    [anon_sym___global] = ACTIONS(1995),
    [anon_sym_type] = ACTIONS(1995),
    [anon_sym_fn] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1995),
    [anon_sym_struct] = ACTIONS(1995),
    [anon_sym_union] = ACTIONS(1995),
    [anon_sym_pub] = ACTIONS(1995),
    [anon_sym_mut] = ACTIONS(1995),
    [anon_sym_enum] = ACTIONS(1995),
    [anon_sym_interface] = ACTIONS(1995),
    [anon_sym_QMARK] = ACTIONS(1995),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_go] = ACTIONS(1995),
    [anon_sym_spawn] = ACTIONS(1995),
    [anon_sym_json_DOTdecode] = ACTIONS(1995),
    [anon_sym_LBRACK2] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_LT_DASH] = ACTIONS(1995),
    [sym_none] = ACTIONS(1995),
    [sym_true] = ACTIONS(1995),
    [sym_false] = ACTIONS(1995),
    [sym_nil] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_DOLLARif] = ACTIONS(1995),
    [anon_sym_match] = ACTIONS(1995),
    [anon_sym_select] = ACTIONS(1995),
    [anon_sym_STAR_EQ] = ACTIONS(2001),
    [anon_sym_SLASH_EQ] = ACTIONS(2001),
    [anon_sym_PERCENT_EQ] = ACTIONS(2001),
    [anon_sym_LT_LT_EQ] = ACTIONS(2001),
    [anon_sym_GT_GT_EQ] = ACTIONS(2001),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2001),
    [anon_sym_AMP_EQ] = ACTIONS(2001),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2001),
    [anon_sym_PLUS_EQ] = ACTIONS(2001),
    [anon_sym_DASH_EQ] = ACTIONS(2001),
    [anon_sym_PIPE_EQ] = ACTIONS(2001),
    [anon_sym_CARET_EQ] = ACTIONS(2001),
    [anon_sym_COLON_EQ] = ACTIONS(2001),
    [anon_sym_lock] = ACTIONS(1995),
    [anon_sym_rlock] = ACTIONS(1995),
    [anon_sym_unsafe] = ACTIONS(1995),
    [anon_sym_sql] = ACTIONS(1995),
    [sym_int_literal] = ACTIONS(1995),
    [sym_float_literal] = ACTIONS(1995),
    [sym_rune_literal] = ACTIONS(1995),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_DQUOTE] = ACTIONS(1995),
    [anon_sym_c_SQUOTE] = ACTIONS(1995),
    [anon_sym_c_DQUOTE] = ACTIONS(1995),
    [anon_sym_r_SQUOTE] = ACTIONS(1995),
    [anon_sym_r_DQUOTE] = ACTIONS(1995),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1995),
    [anon_sym_shared] = ACTIONS(1995),
    [anon_sym_map_LBRACK] = ACTIONS(1995),
    [anon_sym_chan] = ACTIONS(1995),
    [anon_sym_thread] = ACTIONS(1995),
    [anon_sym_atomic] = ACTIONS(1995),
    [anon_sym_assert] = ACTIONS(1995),
    [anon_sym_defer] = ACTIONS(1995),
    [anon_sym_goto] = ACTIONS(1995),
    [anon_sym_break] = ACTIONS(1995),
    [anon_sym_continue] = ACTIONS(1995),
    [anon_sym_return] = ACTIONS(1995),
    [anon_sym_DOLLARfor] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_POUND] = ACTIONS(1995),
    [anon_sym_asm] = ACTIONS(1995),
    [anon_sym_AT_LBRACK] = ACTIONS(1995),
  },
  [1409] = {
    [sym_line_comment] = STATE(1409),
    [sym_block_comment] = STATE(1409),
    [sym_type_parameters] = STATE(4411),
    [sym_argument_list] = STATE(1514),
    [sym_or_block] = STATE(1516),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(4096),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(4098),
    [anon_sym_RPAREN] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_DASH] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_SLASH] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(4102),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_LBRACK2] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_GT_GT_GT] = ACTIONS(2053),
    [anon_sym_AMP_CARET] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(4096),
    [anon_sym_POUND_LBRACK] = ACTIONS(4106),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2053),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
  },
  [1410] = {
    [sym_line_comment] = STATE(1410),
    [sym_block_comment] = STATE(1410),
    [sym_type_parameters] = STATE(4411),
    [sym_argument_list] = STATE(1514),
    [sym_or_block] = STATE(1516),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(4096),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(4098),
    [anon_sym_RPAREN] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4110),
    [anon_sym_SLASH] = ACTIONS(4110),
    [anon_sym_PERCENT] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4112),
    [anon_sym_GT] = ACTIONS(4112),
    [anon_sym_EQ_EQ] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_LT_EQ] = ACTIONS(4112),
    [anon_sym_GT_EQ] = ACTIONS(4112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(4102),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_LBRACK2] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4110),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(4110),
    [anon_sym_GT_GT] = ACTIONS(4110),
    [anon_sym_GT_GT_GT] = ACTIONS(4110),
    [anon_sym_AMP_CARET] = ACTIONS(4110),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(4096),
    [anon_sym_POUND_LBRACK] = ACTIONS(4106),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(4114),
    [anon_sym_BANGin] = ACTIONS(4114),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
  },
  [1411] = {
    [sym_line_comment] = STATE(1411),
    [sym_block_comment] = STATE(1411),
    [sym_type_parameters] = STATE(4411),
    [sym_argument_list] = STATE(1514),
    [sym_or_block] = STATE(1516),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_LF] = ACTIONS(2057),
    [anon_sym_CR] = ACTIONS(2057),
    [anon_sym_CR_LF] = ACTIONS(2057),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(4096),
    [anon_sym_as] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2057),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(4098),
    [anon_sym_RPAREN] = ACTIONS(2057),
    [anon_sym_fn] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_PERCENT] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_GT] = ACTIONS(2057),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2057),
    [anon_sym_LT_EQ] = ACTIONS(2057),
    [anon_sym_GT_EQ] = ACTIONS(2057),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_struct] = ACTIONS(2057),
    [anon_sym_mut] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [anon_sym_QMARK] = ACTIONS(4102),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_go] = ACTIONS(2057),
    [anon_sym_spawn] = ACTIONS(2057),
    [anon_sym_json_DOTdecode] = ACTIONS(2057),
    [anon_sym_PIPE] = ACTIONS(2057),
    [anon_sym_LBRACK2] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_CARET] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2057),
    [anon_sym_LT_DASH] = ACTIONS(2057),
    [anon_sym_LT_LT] = ACTIONS(2057),
    [anon_sym_GT_GT] = ACTIONS(2057),
    [anon_sym_GT_GT_GT] = ACTIONS(2057),
    [anon_sym_AMP_CARET] = ACTIONS(2057),
    [anon_sym_AMP_AMP] = ACTIONS(2057),
    [anon_sym_PIPE_PIPE] = ACTIONS(2057),
    [anon_sym_or] = ACTIONS(2057),
    [sym_none] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_nil] = ACTIONS(2057),
    [anon_sym_QMARK_DOT] = ACTIONS(4096),
    [anon_sym_POUND_LBRACK] = ACTIONS(4106),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_DOLLARif] = ACTIONS(2057),
    [anon_sym_is] = ACTIONS(2057),
    [anon_sym_BANGis] = ACTIONS(2057),
    [anon_sym_in] = ACTIONS(2057),
    [anon_sym_BANGin] = ACTIONS(2057),
    [anon_sym_match] = ACTIONS(2057),
    [anon_sym_select] = ACTIONS(2057),
    [anon_sym_lock] = ACTIONS(2057),
    [anon_sym_rlock] = ACTIONS(2057),
    [anon_sym_unsafe] = ACTIONS(2057),
    [anon_sym_sql] = ACTIONS(2057),
    [sym_int_literal] = ACTIONS(2057),
    [sym_float_literal] = ACTIONS(2057),
    [sym_rune_literal] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_c_SQUOTE] = ACTIONS(2057),
    [anon_sym_c_DQUOTE] = ACTIONS(2057),
    [anon_sym_r_SQUOTE] = ACTIONS(2057),
    [anon_sym_r_DQUOTE] = ACTIONS(2057),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2057),
    [anon_sym_shared] = ACTIONS(2057),
    [anon_sym_map_LBRACK] = ACTIONS(2057),
    [anon_sym_chan] = ACTIONS(2057),
    [anon_sym_thread] = ACTIONS(2057),
    [anon_sym_atomic] = ACTIONS(2057),
  },
  [1412] = {
    [sym_line_comment] = STATE(1412),
    [sym_block_comment] = STATE(1412),
    [sym_type_parameters] = STATE(4411),
    [sym_argument_list] = STATE(1514),
    [sym_or_block] = STATE(1516),
    [sym_identifier] = ACTIONS(2075),
    [anon_sym_LF] = ACTIONS(2075),
    [anon_sym_CR] = ACTIONS(2075),
    [anon_sym_CR_LF] = ACTIONS(2075),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2075),
    [anon_sym_DOT] = ACTIONS(4096),
    [anon_sym_as] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(2075),
    [anon_sym_COMMA] = ACTIONS(2075),
    [anon_sym_RBRACE] = ACTIONS(2075),
    [anon_sym_LPAREN] = ACTIONS(4098),
    [anon_sym_RPAREN] = ACTIONS(2075),
    [anon_sym_fn] = ACTIONS(2075),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4110),
    [anon_sym_SLASH] = ACTIONS(4110),
    [anon_sym_PERCENT] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4112),
    [anon_sym_GT] = ACTIONS(4112),
    [anon_sym_EQ_EQ] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_LT_EQ] = ACTIONS(4112),
    [anon_sym_GT_EQ] = ACTIONS(4112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2075),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_struct] = ACTIONS(2075),
    [anon_sym_mut] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(4118),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4102),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_go] = ACTIONS(2075),
    [anon_sym_spawn] = ACTIONS(2075),
    [anon_sym_json_DOTdecode] = ACTIONS(2075),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_LBRACK2] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4110),
    [anon_sym_LT_DASH] = ACTIONS(2075),
    [anon_sym_LT_LT] = ACTIONS(4110),
    [anon_sym_GT_GT] = ACTIONS(4110),
    [anon_sym_GT_GT_GT] = ACTIONS(4110),
    [anon_sym_AMP_CARET] = ACTIONS(4110),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4124),
    [anon_sym_or] = ACTIONS(4126),
    [sym_none] = ACTIONS(2075),
    [sym_true] = ACTIONS(2075),
    [sym_false] = ACTIONS(2075),
    [sym_nil] = ACTIONS(2075),
    [anon_sym_QMARK_DOT] = ACTIONS(4096),
    [anon_sym_POUND_LBRACK] = ACTIONS(4106),
    [anon_sym_if] = ACTIONS(2075),
    [anon_sym_DOLLARif] = ACTIONS(2075),
    [anon_sym_is] = ACTIONS(4128),
    [anon_sym_BANGis] = ACTIONS(4128),
    [anon_sym_in] = ACTIONS(4114),
    [anon_sym_BANGin] = ACTIONS(4114),
    [anon_sym_match] = ACTIONS(2075),
    [anon_sym_select] = ACTIONS(2075),
    [anon_sym_lock] = ACTIONS(2075),
    [anon_sym_rlock] = ACTIONS(2075),
    [anon_sym_unsafe] = ACTIONS(2075),
    [anon_sym_sql] = ACTIONS(2075),
    [sym_int_literal] = ACTIONS(2075),
    [sym_float_literal] = ACTIONS(2075),
    [sym_rune_literal] = ACTIONS(2075),
    [anon_sym_SQUOTE] = ACTIONS(2075),
    [anon_sym_DQUOTE] = ACTIONS(2075),
    [anon_sym_c_SQUOTE] = ACTIONS(2075),
    [anon_sym_c_DQUOTE] = ACTIONS(2075),
    [anon_sym_r_SQUOTE] = ACTIONS(2075),
    [anon_sym_r_DQUOTE] = ACTIONS(2075),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2075),
    [anon_sym_shared] = ACTIONS(2075),
    [anon_sym_map_LBRACK] = ACTIONS(2075),
    [anon_sym_chan] = ACTIONS(2075),
    [anon_sym_thread] = ACTIONS(2075),
    [anon_sym_atomic] = ACTIONS(2075),
  },
  [1413] = {
    [sym_line_comment] = STATE(1413),
    [sym_block_comment] = STATE(1413),
    [sym_type_parameters] = STATE(4411),
    [sym_argument_list] = STATE(1514),
    [sym_or_block] = STATE(1516),
    [sym_identifier] = ACTIONS(2065),
    [anon_sym_LF] = ACTIONS(2065),
    [anon_sym_CR] = ACTIONS(2065),
    [anon_sym_CR_LF] = ACTIONS(2065),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_DOT] = ACTIONS(4096),
    [anon_sym_as] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(2065),
    [anon_sym_COMMA] = ACTIONS(2065),
    [anon_sym_RBRACE] = ACTIONS(2065),
    [anon_sym_LPAREN] = ACTIONS(4098),
    [anon_sym_RPAREN] = ACTIONS(2065),
    [anon_sym_fn] = ACTIONS(2065),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4110),
    [anon_sym_SLASH] = ACTIONS(4110),
    [anon_sym_PERCENT] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4112),
    [anon_sym_GT] = ACTIONS(4112),
    [anon_sym_EQ_EQ] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_LT_EQ] = ACTIONS(4112),
    [anon_sym_GT_EQ] = ACTIONS(4112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2065),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_struct] = ACTIONS(2065),
    [anon_sym_mut] = ACTIONS(2065),
    [anon_sym_PLUS_PLUS] = ACTIONS(4118),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4102),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_go] = ACTIONS(2065),
    [anon_sym_spawn] = ACTIONS(2065),
    [anon_sym_json_DOTdecode] = ACTIONS(2065),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_LBRACK2] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(2065),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4110),
    [anon_sym_LT_DASH] = ACTIONS(2065),
    [anon_sym_LT_LT] = ACTIONS(4110),
    [anon_sym_GT_GT] = ACTIONS(4110),
    [anon_sym_GT_GT_GT] = ACTIONS(4110),
    [anon_sym_AMP_CARET] = ACTIONS(4110),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4124),
    [anon_sym_or] = ACTIONS(4126),
    [sym_none] = ACTIONS(2065),
    [sym_true] = ACTIONS(2065),
    [sym_false] = ACTIONS(2065),
    [sym_nil] = ACTIONS(2065),
    [anon_sym_QMARK_DOT] = ACTIONS(4096),
    [anon_sym_POUND_LBRACK] = ACTIONS(4106),
    [anon_sym_if] = ACTIONS(2065),
    [anon_sym_DOLLARif] = ACTIONS(2065),
    [anon_sym_is] = ACTIONS(4128),
    [anon_sym_BANGis] = ACTIONS(4128),
    [anon_sym_in] = ACTIONS(4114),
    [anon_sym_BANGin] = ACTIONS(4114),
    [anon_sym_match] = ACTIONS(2065),
    [anon_sym_select] = ACTIONS(2065),
    [anon_sym_lock] = ACTIONS(2065),
    [anon_sym_rlock] = ACTIONS(2065),
    [anon_sym_unsafe] = ACTIONS(2065),
    [anon_sym_sql] = ACTIONS(2065),
    [sym_int_literal] = ACTIONS(2065),
    [sym_float_literal] = ACTIONS(2065),
    [sym_rune_literal] = ACTIONS(2065),
    [anon_sym_SQUOTE] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2065),
    [anon_sym_c_SQUOTE] = ACTIONS(2065),
    [anon_sym_c_DQUOTE] = ACTIONS(2065),
    [anon_sym_r_SQUOTE] = ACTIONS(2065),
    [anon_sym_r_DQUOTE] = ACTIONS(2065),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2065),
    [anon_sym_shared] = ACTIONS(2065),
    [anon_sym_map_LBRACK] = ACTIONS(2065),
    [anon_sym_chan] = ACTIONS(2065),
    [anon_sym_thread] = ACTIONS(2065),
    [anon_sym_atomic] = ACTIONS(2065),
  },
  [1414] = {
    [sym_line_comment] = STATE(1414),
    [sym_block_comment] = STATE(1414),
    [sym_type_parameters] = STATE(4411),
    [sym_argument_list] = STATE(1514),
    [sym_or_block] = STATE(1516),
    [sym_identifier] = ACTIONS(2061),
    [anon_sym_LF] = ACTIONS(2061),
    [anon_sym_CR] = ACTIONS(2061),
    [anon_sym_CR_LF] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(4096),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_LBRACE] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(4098),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_fn] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2061),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_struct] = ACTIONS(2061),
    [anon_sym_mut] = ACTIONS(2061),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_QMARK] = ACTIONS(4102),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_go] = ACTIONS(2061),
    [anon_sym_spawn] = ACTIONS(2061),
    [anon_sym_json_DOTdecode] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_LBRACK2] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_LT_DASH] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_GT_GT_GT] = ACTIONS(2061),
    [anon_sym_AMP_CARET] = ACTIONS(2061),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [sym_none] = ACTIONS(2061),
    [sym_true] = ACTIONS(2061),
    [sym_false] = ACTIONS(2061),
    [sym_nil] = ACTIONS(2061),
    [anon_sym_QMARK_DOT] = ACTIONS(4096),
    [anon_sym_POUND_LBRACK] = ACTIONS(4106),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_DOLLARif] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_BANGis] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_BANGin] = ACTIONS(2061),
    [anon_sym_match] = ACTIONS(2061),
    [anon_sym_select] = ACTIONS(2061),
    [anon_sym_lock] = ACTIONS(2061),
    [anon_sym_rlock] = ACTIONS(2061),
    [anon_sym_unsafe] = ACTIONS(2061),
    [anon_sym_sql] = ACTIONS(2061),
    [sym_int_literal] = ACTIONS(2061),
    [sym_float_literal] = ACTIONS(2061),
    [sym_rune_literal] = ACTIONS(2061),
    [anon_sym_SQUOTE] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(2061),
    [anon_sym_c_SQUOTE] = ACTIONS(2061),
    [anon_sym_c_DQUOTE] = ACTIONS(2061),
    [anon_sym_r_SQUOTE] = ACTIONS(2061),
    [anon_sym_r_DQUOTE] = ACTIONS(2061),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2061),
    [anon_sym_shared] = ACTIONS(2061),
    [anon_sym_map_LBRACK] = ACTIONS(2061),
    [anon_sym_chan] = ACTIONS(2061),
    [anon_sym_thread] = ACTIONS(2061),
    [anon_sym_atomic] = ACTIONS(2061),
  },
  [1415] = {
    [sym_line_comment] = STATE(1415),
    [sym_block_comment] = STATE(1415),
    [sym_type_parameters] = STATE(4411),
    [sym_argument_list] = STATE(1514),
    [sym_or_block] = STATE(1516),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(4096),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(4098),
    [anon_sym_RPAREN] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_DASH] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(4110),
    [anon_sym_SLASH] = ACTIONS(4110),
    [anon_sym_PERCENT] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(4102),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_LBRACK2] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(4110),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(4110),
    [anon_sym_GT_GT] = ACTIONS(4110),
    [anon_sym_GT_GT_GT] = ACTIONS(4110),
    [anon_sym_AMP_CARET] = ACTIONS(4110),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(4096),
    [anon_sym_POUND_LBRACK] = ACTIONS(4106),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2053),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
  },
  [1416] = {
    [sym_line_comment] = STATE(1416),
    [sym_block_comment] = STATE(1416),
    [sym_type_parameters] = STATE(4411),
    [sym_argument_list] = STATE(1514),
    [sym_or_block] = STATE(1516),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(4096),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(4098),
    [anon_sym_RPAREN] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4110),
    [anon_sym_SLASH] = ACTIONS(4110),
    [anon_sym_PERCENT] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(4102),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_LBRACK2] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4110),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(4110),
    [anon_sym_GT_GT] = ACTIONS(4110),
    [anon_sym_GT_GT_GT] = ACTIONS(4110),
    [anon_sym_AMP_CARET] = ACTIONS(4110),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(4096),
    [anon_sym_POUND_LBRACK] = ACTIONS(4106),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2053),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
  },
  [1417] = {
    [sym_line_comment] = STATE(1417),
    [sym_block_comment] = STATE(1417),
    [sym_type_parameters] = STATE(4411),
    [sym_argument_list] = STATE(1514),
    [sym_or_block] = STATE(1516),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LF] = ACTIONS(2053),
    [anon_sym_CR] = ACTIONS(2053),
    [anon_sym_CR_LF] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(4096),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(4098),
    [anon_sym_RPAREN] = ACTIONS(2053),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4110),
    [anon_sym_SLASH] = ACTIONS(4110),
    [anon_sym_PERCENT] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4112),
    [anon_sym_GT] = ACTIONS(4112),
    [anon_sym_EQ_EQ] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_LT_EQ] = ACTIONS(4112),
    [anon_sym_GT_EQ] = ACTIONS(4112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(4102),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_LBRACK2] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4110),
    [anon_sym_LT_DASH] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(4110),
    [anon_sym_GT_GT] = ACTIONS(4110),
    [anon_sym_GT_GT_GT] = ACTIONS(4110),
    [anon_sym_AMP_CARET] = ACTIONS(4110),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(4096),
    [anon_sym_POUND_LBRACK] = ACTIONS(4106),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(4114),
    [anon_sym_BANGin] = ACTIONS(4114),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_rune_literal] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_c_SQUOTE] = ACTIONS(2053),
    [anon_sym_c_DQUOTE] = ACTIONS(2053),
    [anon_sym_r_SQUOTE] = ACTIONS(2053),
    [anon_sym_r_DQUOTE] = ACTIONS(2053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2053),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
  },
  [1418] = {
    [sym_line_comment] = STATE(1418),
    [sym_block_comment] = STATE(1418),
    [sym_type_parameters] = STATE(4411),
    [sym_argument_list] = STATE(1514),
    [sym_or_block] = STATE(1516),
    [sym_identifier] = ACTIONS(2049),
    [anon_sym_LF] = ACTIONS(2049),
    [anon_sym_CR] = ACTIONS(2049),
    [anon_sym_CR_LF] = ACTIONS(2049),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(4096),
    [anon_sym_as] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(2049),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(4098),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_fn] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4110),
    [anon_sym_SLASH] = ACTIONS(4110),
    [anon_sym_PERCENT] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_struct] = ACTIONS(2049),
    [anon_sym_mut] = ACTIONS(2049),
    [anon_sym_PLUS_PLUS] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(4102),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_go] = ACTIONS(2049),
    [anon_sym_spawn] = ACTIONS(2049),
    [anon_sym_json_DOTdecode] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_LBRACK2] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(2049),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4110),
    [anon_sym_LT_DASH] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(4110),
    [anon_sym_GT_GT] = ACTIONS(4110),
    [anon_sym_GT_GT_GT] = ACTIONS(4110),
    [anon_sym_AMP_CARET] = ACTIONS(4110),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_or] = ACTIONS(2049),
    [sym_none] = ACTIONS(2049),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [sym_nil] = ACTIONS(2049),
    [anon_sym_QMARK_DOT] = ACTIONS(4096),
    [anon_sym_POUND_LBRACK] = ACTIONS(4106),
    [anon_sym_if] = ACTIONS(2049),
    [anon_sym_DOLLARif] = ACTIONS(2049),
    [anon_sym_is] = ACTIONS(2049),
    [anon_sym_BANGis] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_BANGin] = ACTIONS(2049),
    [anon_sym_match] = ACTIONS(2049),
    [anon_sym_select] = ACTIONS(2049),
    [anon_sym_lock] = ACTIONS(2049),
    [anon_sym_rlock] = ACTIONS(2049),
    [anon_sym_unsafe] = ACTIONS(2049),
    [anon_sym_sql] = ACTIONS(2049),
    [sym_int_literal] = ACTIONS(2049),
    [sym_float_literal] = ACTIONS(2049),
    [sym_rune_literal] = ACTIONS(2049),
    [anon_sym_SQUOTE] = ACTIONS(2049),
    [anon_sym_DQUOTE] = ACTIONS(2049),
    [anon_sym_c_SQUOTE] = ACTIONS(2049),
    [anon_sym_c_DQUOTE] = ACTIONS(2049),
    [anon_sym_r_SQUOTE] = ACTIONS(2049),
    [anon_sym_r_DQUOTE] = ACTIONS(2049),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2049),
    [anon_sym_shared] = ACTIONS(2049),
    [anon_sym_map_LBRACK] = ACTIONS(2049),
    [anon_sym_chan] = ACTIONS(2049),
    [anon_sym_thread] = ACTIONS(2049),
    [anon_sym_atomic] = ACTIONS(2049),
  },
  [1419] = {
    [sym_line_comment] = STATE(1419),
    [sym_block_comment] = STATE(1419),
    [sym_type_parameters] = STATE(4411),
    [sym_argument_list] = STATE(1514),
    [sym_or_block] = STATE(1516),
    [sym_identifier] = ACTIONS(2069),
    [anon_sym_LF] = ACTIONS(2069),
    [anon_sym_CR] = ACTIONS(2069),
    [anon_sym_CR_LF] = ACTIONS(2069),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2069),
    [anon_sym_DOT] = ACTIONS(4096),
    [anon_sym_as] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(2069),
    [anon_sym_COMMA] = ACTIONS(2069),
    [anon_sym_LPAREN] = ACTIONS(4098),
    [anon_sym_RPAREN] = ACTIONS(2069),
    [anon_sym_fn] = ACTIONS(2069),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4110),
    [anon_sym_SLASH] = ACTIONS(4110),
    [anon_sym_PERCENT] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4112),
    [anon_sym_GT] = ACTIONS(4112),
    [anon_sym_EQ_EQ] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_LT_EQ] = ACTIONS(4112),
    [anon_sym_GT_EQ] = ACTIONS(4112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2069),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_struct] = ACTIONS(2069),
    [anon_sym_mut] = ACTIONS(2069),
    [anon_sym_PLUS_PLUS] = ACTIONS(4118),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4102),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_go] = ACTIONS(2069),
    [anon_sym_spawn] = ACTIONS(2069),
    [anon_sym_json_DOTdecode] = ACTIONS(2069),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_LBRACK2] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(2069),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4110),
    [anon_sym_LT_DASH] = ACTIONS(2069),
    [anon_sym_LT_LT] = ACTIONS(4110),
    [anon_sym_GT_GT] = ACTIONS(4110),
    [anon_sym_GT_GT_GT] = ACTIONS(4110),
    [anon_sym_AMP_CARET] = ACTIONS(4110),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4124),
    [anon_sym_or] = ACTIONS(4126),
    [sym_none] = ACTIONS(2069),
    [sym_true] = ACTIONS(2069),
    [sym_false] = ACTIONS(2069),
    [sym_nil] = ACTIONS(2069),
    [anon_sym_QMARK_DOT] = ACTIONS(4096),
    [anon_sym_POUND_LBRACK] = ACTIONS(4106),
    [anon_sym_if] = ACTIONS(2069),
    [anon_sym_DOLLARif] = ACTIONS(2069),
    [anon_sym_is] = ACTIONS(4130),
    [anon_sym_BANGis] = ACTIONS(4130),
    [anon_sym_in] = ACTIONS(4114),
    [anon_sym_BANGin] = ACTIONS(4114),
    [anon_sym_match] = ACTIONS(2069),
    [anon_sym_select] = ACTIONS(2069),
    [anon_sym_lock] = ACTIONS(2069),
    [anon_sym_rlock] = ACTIONS(2069),
    [anon_sym_unsafe] = ACTIONS(2069),
    [anon_sym_sql] = ACTIONS(2069),
    [sym_int_literal] = ACTIONS(2069),
    [sym_float_literal] = ACTIONS(2069),
    [sym_rune_literal] = ACTIONS(2069),
    [anon_sym_SQUOTE] = ACTIONS(2069),
    [anon_sym_DQUOTE] = ACTIONS(2069),
    [anon_sym_c_SQUOTE] = ACTIONS(2069),
    [anon_sym_c_DQUOTE] = ACTIONS(2069),
    [anon_sym_r_SQUOTE] = ACTIONS(2069),
    [anon_sym_r_DQUOTE] = ACTIONS(2069),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2069),
    [anon_sym_shared] = ACTIONS(2069),
    [anon_sym_map_LBRACK] = ACTIONS(2069),
    [anon_sym_chan] = ACTIONS(2069),
    [anon_sym_thread] = ACTIONS(2069),
    [anon_sym_atomic] = ACTIONS(2069),
  },
  [1420] = {
    [sym_line_comment] = STATE(1420),
    [sym_block_comment] = STATE(1420),
    [sym_type_parameters] = STATE(4411),
    [sym_argument_list] = STATE(1514),
    [sym_or_block] = STATE(1516),
    [sym_identifier] = ACTIONS(4132),
    [anon_sym_LF] = ACTIONS(4132),
    [anon_sym_CR] = ACTIONS(4132),
    [anon_sym_CR_LF] = ACTIONS(4132),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4132),
    [anon_sym_DOT] = ACTIONS(4096),
    [anon_sym_as] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4132),
    [anon_sym_COMMA] = ACTIONS(4132),
    [anon_sym_LPAREN] = ACTIONS(4098),
    [anon_sym_RPAREN] = ACTIONS(4132),
    [anon_sym_fn] = ACTIONS(4132),
    [anon_sym_PLUS] = ACTIONS(4132),
    [anon_sym_DASH] = ACTIONS(4132),
    [anon_sym_STAR] = ACTIONS(4132),
    [anon_sym_SLASH] = ACTIONS(4110),
    [anon_sym_PERCENT] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4112),
    [anon_sym_GT] = ACTIONS(4112),
    [anon_sym_EQ_EQ] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_LT_EQ] = ACTIONS(4112),
    [anon_sym_GT_EQ] = ACTIONS(4112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_struct] = ACTIONS(4132),
    [anon_sym_mut] = ACTIONS(4132),
    [anon_sym_PLUS_PLUS] = ACTIONS(4118),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4102),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_go] = ACTIONS(4132),
    [anon_sym_spawn] = ACTIONS(4132),
    [anon_sym_json_DOTdecode] = ACTIONS(4132),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_LBRACK2] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(4132),
    [anon_sym_CARET] = ACTIONS(4132),
    [anon_sym_AMP] = ACTIONS(4132),
    [anon_sym_LT_DASH] = ACTIONS(4132),
    [anon_sym_LT_LT] = ACTIONS(4110),
    [anon_sym_GT_GT] = ACTIONS(4110),
    [anon_sym_GT_GT_GT] = ACTIONS(4110),
    [anon_sym_AMP_CARET] = ACTIONS(4110),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4124),
    [anon_sym_or] = ACTIONS(4126),
    [sym_none] = ACTIONS(4132),
    [sym_true] = ACTIONS(4132),
    [sym_false] = ACTIONS(4132),
    [sym_nil] = ACTIONS(4132),
    [anon_sym_QMARK_DOT] = ACTIONS(4096),
    [anon_sym_POUND_LBRACK] = ACTIONS(4106),
    [anon_sym_if] = ACTIONS(4132),
    [anon_sym_DOLLARif] = ACTIONS(4132),
    [anon_sym_is] = ACTIONS(4128),
    [anon_sym_BANGis] = ACTIONS(4128),
    [anon_sym_in] = ACTIONS(4114),
    [anon_sym_BANGin] = ACTIONS(4114),
    [anon_sym_match] = ACTIONS(4132),
    [anon_sym_select] = ACTIONS(4132),
    [anon_sym_lock] = ACTIONS(4132),
    [anon_sym_rlock] = ACTIONS(4132),
    [anon_sym_unsafe] = ACTIONS(4132),
    [anon_sym_sql] = ACTIONS(4132),
    [sym_int_literal] = ACTIONS(4132),
    [sym_float_literal] = ACTIONS(4132),
    [sym_rune_literal] = ACTIONS(4132),
    [anon_sym_SQUOTE] = ACTIONS(4132),
    [anon_sym_DQUOTE] = ACTIONS(4132),
    [anon_sym_c_SQUOTE] = ACTIONS(4132),
    [anon_sym_c_DQUOTE] = ACTIONS(4132),
    [anon_sym_r_SQUOTE] = ACTIONS(4132),
    [anon_sym_r_DQUOTE] = ACTIONS(4132),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4132),
    [anon_sym_shared] = ACTIONS(4132),
    [anon_sym_map_LBRACK] = ACTIONS(4132),
    [anon_sym_chan] = ACTIONS(4132),
    [anon_sym_thread] = ACTIONS(4132),
    [anon_sym_atomic] = ACTIONS(4132),
  },
  [1421] = {
    [sym_line_comment] = STATE(1421),
    [sym_block_comment] = STATE(1421),
    [sym_type_parameters] = STATE(4411),
    [sym_argument_list] = STATE(1514),
    [sym_or_block] = STATE(1516),
    [sym_identifier] = ACTIONS(4134),
    [anon_sym_LF] = ACTIONS(4134),
    [anon_sym_CR] = ACTIONS(4134),
    [anon_sym_CR_LF] = ACTIONS(4134),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4134),
    [anon_sym_DOT] = ACTIONS(4096),
    [anon_sym_as] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4134),
    [anon_sym_COMMA] = ACTIONS(4134),
    [anon_sym_LPAREN] = ACTIONS(4098),
    [anon_sym_RPAREN] = ACTIONS(4134),
    [anon_sym_fn] = ACTIONS(4134),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4110),
    [anon_sym_SLASH] = ACTIONS(4110),
    [anon_sym_PERCENT] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4112),
    [anon_sym_GT] = ACTIONS(4112),
    [anon_sym_EQ_EQ] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_LT_EQ] = ACTIONS(4112),
    [anon_sym_GT_EQ] = ACTIONS(4112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4134),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_struct] = ACTIONS(4134),
    [anon_sym_mut] = ACTIONS(4134),
    [anon_sym_PLUS_PLUS] = ACTIONS(4118),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4102),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_go] = ACTIONS(4134),
    [anon_sym_spawn] = ACTIONS(4134),
    [anon_sym_json_DOTdecode] = ACTIONS(4134),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_LBRACK2] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4110),
    [anon_sym_LT_DASH] = ACTIONS(4134),
    [anon_sym_LT_LT] = ACTIONS(4110),
    [anon_sym_GT_GT] = ACTIONS(4110),
    [anon_sym_GT_GT_GT] = ACTIONS(4110),
    [anon_sym_AMP_CARET] = ACTIONS(4110),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4124),
    [anon_sym_or] = ACTIONS(4126),
    [sym_none] = ACTIONS(4134),
    [sym_true] = ACTIONS(4134),
    [sym_false] = ACTIONS(4134),
    [sym_nil] = ACTIONS(4134),
    [anon_sym_QMARK_DOT] = ACTIONS(4096),
    [anon_sym_POUND_LBRACK] = ACTIONS(4106),
    [anon_sym_if] = ACTIONS(4134),
    [anon_sym_DOLLARif] = ACTIONS(4134),
    [anon_sym_is] = ACTIONS(4128),
    [anon_sym_BANGis] = ACTIONS(4128),
    [anon_sym_in] = ACTIONS(4114),
    [anon_sym_BANGin] = ACTIONS(4114),
    [anon_sym_match] = ACTIONS(4134),
    [anon_sym_select] = ACTIONS(4134),
    [anon_sym_lock] = ACTIONS(4134),
    [anon_sym_rlock] = ACTIONS(4134),
    [anon_sym_unsafe] = ACTIONS(4134),
    [anon_sym_sql] = ACTIONS(4134),
    [sym_int_literal] = ACTIONS(4134),
    [sym_float_literal] = ACTIONS(4134),
    [sym_rune_literal] = ACTIONS(4134),
    [anon_sym_SQUOTE] = ACTIONS(4134),
    [anon_sym_DQUOTE] = ACTIONS(4134),
    [anon_sym_c_SQUOTE] = ACTIONS(4134),
    [anon_sym_c_DQUOTE] = ACTIONS(4134),
    [anon_sym_r_SQUOTE] = ACTIONS(4134),
    [anon_sym_r_DQUOTE] = ACTIONS(4134),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4134),
    [anon_sym_shared] = ACTIONS(4134),
    [anon_sym_map_LBRACK] = ACTIONS(4134),
    [anon_sym_chan] = ACTIONS(4134),
    [anon_sym_thread] = ACTIONS(4134),
    [anon_sym_atomic] = ACTIONS(4134),
  },
  [1422] = {
    [sym_line_comment] = STATE(1422),
    [sym_block_comment] = STATE(1422),
    [sym_type_parameters] = STATE(4411),
    [sym_argument_list] = STATE(1514),
    [sym_or_block] = STATE(1516),
    [sym_identifier] = ACTIONS(4136),
    [anon_sym_LF] = ACTIONS(4136),
    [anon_sym_CR] = ACTIONS(4136),
    [anon_sym_CR_LF] = ACTIONS(4136),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4136),
    [anon_sym_DOT] = ACTIONS(4096),
    [anon_sym_as] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4136),
    [anon_sym_COMMA] = ACTIONS(4136),
    [anon_sym_LPAREN] = ACTIONS(4098),
    [anon_sym_RPAREN] = ACTIONS(4136),
    [anon_sym_fn] = ACTIONS(4136),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4110),
    [anon_sym_SLASH] = ACTIONS(4110),
    [anon_sym_PERCENT] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4112),
    [anon_sym_GT] = ACTIONS(4112),
    [anon_sym_EQ_EQ] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_LT_EQ] = ACTIONS(4112),
    [anon_sym_GT_EQ] = ACTIONS(4112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4136),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_struct] = ACTIONS(4136),
    [anon_sym_mut] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4118),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4102),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_go] = ACTIONS(4136),
    [anon_sym_spawn] = ACTIONS(4136),
    [anon_sym_json_DOTdecode] = ACTIONS(4136),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_LBRACK2] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(4136),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4110),
    [anon_sym_LT_DASH] = ACTIONS(4136),
    [anon_sym_LT_LT] = ACTIONS(4110),
    [anon_sym_GT_GT] = ACTIONS(4110),
    [anon_sym_GT_GT_GT] = ACTIONS(4110),
    [anon_sym_AMP_CARET] = ACTIONS(4110),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4124),
    [anon_sym_or] = ACTIONS(4126),
    [sym_none] = ACTIONS(4136),
    [sym_true] = ACTIONS(4136),
    [sym_false] = ACTIONS(4136),
    [sym_nil] = ACTIONS(4136),
    [anon_sym_QMARK_DOT] = ACTIONS(4096),
    [anon_sym_POUND_LBRACK] = ACTIONS(4106),
    [anon_sym_if] = ACTIONS(4136),
    [anon_sym_DOLLARif] = ACTIONS(4136),
    [anon_sym_is] = ACTIONS(4128),
    [anon_sym_BANGis] = ACTIONS(4128),
    [anon_sym_in] = ACTIONS(4114),
    [anon_sym_BANGin] = ACTIONS(4114),
    [anon_sym_match] = ACTIONS(4136),
    [anon_sym_select] = ACTIONS(4136),
    [anon_sym_lock] = ACTIONS(4136),
    [anon_sym_rlock] = ACTIONS(4136),
    [anon_sym_unsafe] = ACTIONS(4136),
    [anon_sym_sql] = ACTIONS(4136),
    [sym_int_literal] = ACTIONS(4136),
    [sym_float_literal] = ACTIONS(4136),
    [sym_rune_literal] = ACTIONS(4136),
    [anon_sym_SQUOTE] = ACTIONS(4136),
    [anon_sym_DQUOTE] = ACTIONS(4136),
    [anon_sym_c_SQUOTE] = ACTIONS(4136),
    [anon_sym_c_DQUOTE] = ACTIONS(4136),
    [anon_sym_r_SQUOTE] = ACTIONS(4136),
    [anon_sym_r_DQUOTE] = ACTIONS(4136),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4136),
    [anon_sym_shared] = ACTIONS(4136),
    [anon_sym_map_LBRACK] = ACTIONS(4136),
    [anon_sym_chan] = ACTIONS(4136),
    [anon_sym_thread] = ACTIONS(4136),
    [anon_sym_atomic] = ACTIONS(4136),
  },
  [1423] = {
    [sym_line_comment] = STATE(1423),
    [sym_block_comment] = STATE(1423),
    [sym_else_branch] = STATE(1485),
    [sym_identifier] = ACTIONS(2089),
    [anon_sym_LF] = ACTIONS(2089),
    [anon_sym_CR] = ACTIONS(2089),
    [anon_sym_CR_LF] = ACTIONS(2089),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2089),
    [anon_sym_DOT] = ACTIONS(2089),
    [anon_sym_as] = ACTIONS(2089),
    [anon_sym_LBRACE] = ACTIONS(2089),
    [anon_sym_COMMA] = ACTIONS(2089),
    [anon_sym_RBRACE] = ACTIONS(2089),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_RPAREN] = ACTIONS(2089),
    [anon_sym_fn] = ACTIONS(2089),
    [anon_sym_PLUS] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2089),
    [anon_sym_SLASH] = ACTIONS(2089),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_LT] = ACTIONS(2089),
    [anon_sym_GT] = ACTIONS(2089),
    [anon_sym_EQ_EQ] = ACTIONS(2089),
    [anon_sym_BANG_EQ] = ACTIONS(2089),
    [anon_sym_LT_EQ] = ACTIONS(2089),
    [anon_sym_GT_EQ] = ACTIONS(2089),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2087),
    [anon_sym_struct] = ACTIONS(2089),
    [anon_sym_mut] = ACTIONS(2089),
    [anon_sym_PLUS_PLUS] = ACTIONS(2089),
    [anon_sym_DASH_DASH] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2089),
    [anon_sym_BANG] = ACTIONS(2089),
    [anon_sym_go] = ACTIONS(2089),
    [anon_sym_spawn] = ACTIONS(2089),
    [anon_sym_json_DOTdecode] = ACTIONS(2089),
    [anon_sym_PIPE] = ACTIONS(2089),
    [anon_sym_LBRACK2] = ACTIONS(2089),
    [anon_sym_TILDE] = ACTIONS(2089),
    [anon_sym_CARET] = ACTIONS(2089),
    [anon_sym_AMP] = ACTIONS(2089),
    [anon_sym_LT_DASH] = ACTIONS(2089),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_GT_GT] = ACTIONS(2089),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_AMP_CARET] = ACTIONS(2089),
    [anon_sym_AMP_AMP] = ACTIONS(2089),
    [anon_sym_PIPE_PIPE] = ACTIONS(2089),
    [anon_sym_or] = ACTIONS(2089),
    [sym_none] = ACTIONS(2089),
    [sym_true] = ACTIONS(2089),
    [sym_false] = ACTIONS(2089),
    [sym_nil] = ACTIONS(2089),
    [anon_sym_QMARK_DOT] = ACTIONS(2089),
    [anon_sym_POUND_LBRACK] = ACTIONS(2089),
    [anon_sym_if] = ACTIONS(2089),
    [anon_sym_else] = ACTIONS(4138),
    [anon_sym_DOLLARif] = ACTIONS(2089),
    [anon_sym_is] = ACTIONS(2089),
    [anon_sym_BANGis] = ACTIONS(2089),
    [anon_sym_in] = ACTIONS(2089),
    [anon_sym_BANGin] = ACTIONS(2089),
    [anon_sym_match] = ACTIONS(2089),
    [anon_sym_select] = ACTIONS(2089),
    [anon_sym_lock] = ACTIONS(2089),
    [anon_sym_rlock] = ACTIONS(2089),
    [anon_sym_unsafe] = ACTIONS(2089),
    [anon_sym_sql] = ACTIONS(2089),
    [sym_int_literal] = ACTIONS(2089),
    [sym_float_literal] = ACTIONS(2089),
    [sym_rune_literal] = ACTIONS(2089),
    [anon_sym_SQUOTE] = ACTIONS(2089),
    [anon_sym_DQUOTE] = ACTIONS(2089),
    [anon_sym_c_SQUOTE] = ACTIONS(2089),
    [anon_sym_c_DQUOTE] = ACTIONS(2089),
    [anon_sym_r_SQUOTE] = ACTIONS(2089),
    [anon_sym_r_DQUOTE] = ACTIONS(2089),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2089),
    [anon_sym_shared] = ACTIONS(2089),
    [anon_sym_map_LBRACK] = ACTIONS(2089),
    [anon_sym_chan] = ACTIONS(2089),
    [anon_sym_thread] = ACTIONS(2089),
    [anon_sym_atomic] = ACTIONS(2089),
  },
  [1424] = {
    [sym_line_comment] = STATE(1424),
    [sym_block_comment] = STATE(1424),
    [sym_else_branch] = STATE(1486),
    [sym_identifier] = ACTIONS(2083),
    [anon_sym_LF] = ACTIONS(2083),
    [anon_sym_CR] = ACTIONS(2083),
    [anon_sym_CR_LF] = ACTIONS(2083),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2083),
    [anon_sym_DOT] = ACTIONS(2083),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(2083),
    [anon_sym_COMMA] = ACTIONS(2083),
    [anon_sym_RBRACE] = ACTIONS(2083),
    [anon_sym_LPAREN] = ACTIONS(2083),
    [anon_sym_RPAREN] = ACTIONS(2083),
    [anon_sym_fn] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2083),
    [anon_sym_SLASH] = ACTIONS(2083),
    [anon_sym_PERCENT] = ACTIONS(2083),
    [anon_sym_LT] = ACTIONS(2083),
    [anon_sym_GT] = ACTIONS(2083),
    [anon_sym_EQ_EQ] = ACTIONS(2083),
    [anon_sym_BANG_EQ] = ACTIONS(2083),
    [anon_sym_LT_EQ] = ACTIONS(2083),
    [anon_sym_GT_EQ] = ACTIONS(2083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2083),
    [anon_sym_LBRACK] = ACTIONS(2081),
    [anon_sym_struct] = ACTIONS(2083),
    [anon_sym_mut] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_QMARK] = ACTIONS(2083),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_go] = ACTIONS(2083),
    [anon_sym_spawn] = ACTIONS(2083),
    [anon_sym_json_DOTdecode] = ACTIONS(2083),
    [anon_sym_PIPE] = ACTIONS(2083),
    [anon_sym_LBRACK2] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_LT_DASH] = ACTIONS(2083),
    [anon_sym_LT_LT] = ACTIONS(2083),
    [anon_sym_GT_GT] = ACTIONS(2083),
    [anon_sym_GT_GT_GT] = ACTIONS(2083),
    [anon_sym_AMP_CARET] = ACTIONS(2083),
    [anon_sym_AMP_AMP] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(2083),
    [anon_sym_or] = ACTIONS(2083),
    [sym_none] = ACTIONS(2083),
    [sym_true] = ACTIONS(2083),
    [sym_false] = ACTIONS(2083),
    [sym_nil] = ACTIONS(2083),
    [anon_sym_QMARK_DOT] = ACTIONS(2083),
    [anon_sym_POUND_LBRACK] = ACTIONS(2083),
    [anon_sym_if] = ACTIONS(2083),
    [anon_sym_else] = ACTIONS(4138),
    [anon_sym_DOLLARif] = ACTIONS(2083),
    [anon_sym_is] = ACTIONS(2083),
    [anon_sym_BANGis] = ACTIONS(2083),
    [anon_sym_in] = ACTIONS(2083),
    [anon_sym_BANGin] = ACTIONS(2083),
    [anon_sym_match] = ACTIONS(2083),
    [anon_sym_select] = ACTIONS(2083),
    [anon_sym_lock] = ACTIONS(2083),
    [anon_sym_rlock] = ACTIONS(2083),
    [anon_sym_unsafe] = ACTIONS(2083),
    [anon_sym_sql] = ACTIONS(2083),
    [sym_int_literal] = ACTIONS(2083),
    [sym_float_literal] = ACTIONS(2083),
    [sym_rune_literal] = ACTIONS(2083),
    [anon_sym_SQUOTE] = ACTIONS(2083),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_c_SQUOTE] = ACTIONS(2083),
    [anon_sym_c_DQUOTE] = ACTIONS(2083),
    [anon_sym_r_SQUOTE] = ACTIONS(2083),
    [anon_sym_r_DQUOTE] = ACTIONS(2083),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2083),
    [anon_sym_shared] = ACTIONS(2083),
    [anon_sym_map_LBRACK] = ACTIONS(2083),
    [anon_sym_chan] = ACTIONS(2083),
    [anon_sym_thread] = ACTIONS(2083),
    [anon_sym_atomic] = ACTIONS(2083),
  },
  [1425] = {
    [sym_line_comment] = STATE(1425),
    [sym_block_comment] = STATE(1425),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_LF] = ACTIONS(2169),
    [anon_sym_CR] = ACTIONS(2169),
    [anon_sym_CR_LF] = ACTIONS(2169),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2169),
    [anon_sym_as] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_COMMA] = ACTIONS(2169),
    [anon_sym_RBRACE] = ACTIONS(2169),
    [anon_sym_LPAREN] = ACTIONS(2169),
    [anon_sym_RPAREN] = ACTIONS(2169),
    [anon_sym_fn] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_SLASH] = ACTIONS(2169),
    [anon_sym_PERCENT] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2169),
    [anon_sym_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ] = ACTIONS(2169),
    [anon_sym_LT_EQ] = ACTIONS(2169),
    [anon_sym_GT_EQ] = ACTIONS(2169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_mut] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_go] = ACTIONS(2169),
    [anon_sym_spawn] = ACTIONS(2169),
    [anon_sym_json_DOTdecode] = ACTIONS(2169),
    [anon_sym_PIPE] = ACTIONS(2169),
    [anon_sym_LBRACK2] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT_DASH] = ACTIONS(2169),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_GT_GT_GT] = ACTIONS(2169),
    [anon_sym_AMP_CARET] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_PIPE_PIPE] = ACTIONS(2169),
    [anon_sym_or] = ACTIONS(2169),
    [sym_none] = ACTIONS(2169),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [sym_nil] = ACTIONS(2169),
    [anon_sym_QMARK_DOT] = ACTIONS(2169),
    [anon_sym_POUND_LBRACK] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_DOLLARif] = ACTIONS(2169),
    [anon_sym_DOLLARelse] = ACTIONS(2169),
    [anon_sym_is] = ACTIONS(2169),
    [anon_sym_BANGis] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_BANGin] = ACTIONS(2169),
    [anon_sym_match] = ACTIONS(2169),
    [anon_sym_select] = ACTIONS(2169),
    [anon_sym_lock] = ACTIONS(2169),
    [anon_sym_rlock] = ACTIONS(2169),
    [anon_sym_unsafe] = ACTIONS(2169),
    [anon_sym_sql] = ACTIONS(2169),
    [sym_int_literal] = ACTIONS(2169),
    [sym_float_literal] = ACTIONS(2169),
    [sym_rune_literal] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [anon_sym_c_SQUOTE] = ACTIONS(2169),
    [anon_sym_c_DQUOTE] = ACTIONS(2169),
    [anon_sym_r_SQUOTE] = ACTIONS(2169),
    [anon_sym_r_DQUOTE] = ACTIONS(2169),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_map_LBRACK] = ACTIONS(2169),
    [anon_sym_chan] = ACTIONS(2169),
    [anon_sym_thread] = ACTIONS(2169),
    [anon_sym_atomic] = ACTIONS(2169),
  },
  [1426] = {
    [sym_line_comment] = STATE(1426),
    [sym_block_comment] = STATE(1426),
    [sym_type_parameters] = STATE(1544),
    [sym_identifier] = ACTIONS(2187),
    [anon_sym_LF] = ACTIONS(2187),
    [anon_sym_CR] = ACTIONS(2187),
    [anon_sym_CR_LF] = ACTIONS(2187),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2187),
    [anon_sym_DOT] = ACTIONS(2187),
    [anon_sym_as] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_RBRACE] = ACTIONS(2187),
    [anon_sym_LPAREN] = ACTIONS(2187),
    [anon_sym_RPAREN] = ACTIONS(2187),
    [anon_sym_fn] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [anon_sym_LT] = ACTIONS(2187),
    [anon_sym_GT] = ACTIONS(2187),
    [anon_sym_EQ_EQ] = ACTIONS(2187),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2187),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2185),
    [anon_sym_struct] = ACTIONS(2187),
    [anon_sym_mut] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_go] = ACTIONS(2187),
    [anon_sym_spawn] = ACTIONS(2187),
    [anon_sym_json_DOTdecode] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2187),
    [anon_sym_LBRACK2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_LT_DASH] = ACTIONS(2187),
    [anon_sym_LT_LT] = ACTIONS(2187),
    [anon_sym_GT_GT] = ACTIONS(2187),
    [anon_sym_GT_GT_GT] = ACTIONS(2187),
    [anon_sym_AMP_CARET] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2187),
    [sym_none] = ACTIONS(2187),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [sym_nil] = ACTIONS(2187),
    [anon_sym_QMARK_DOT] = ACTIONS(2187),
    [anon_sym_POUND_LBRACK] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_DOLLARif] = ACTIONS(2187),
    [anon_sym_is] = ACTIONS(2187),
    [anon_sym_BANGis] = ACTIONS(2187),
    [anon_sym_in] = ACTIONS(2187),
    [anon_sym_BANGin] = ACTIONS(2187),
    [anon_sym_match] = ACTIONS(2187),
    [anon_sym_select] = ACTIONS(2187),
    [anon_sym_lock] = ACTIONS(2187),
    [anon_sym_rlock] = ACTIONS(2187),
    [anon_sym_unsafe] = ACTIONS(2187),
    [anon_sym_sql] = ACTIONS(2187),
    [sym_int_literal] = ACTIONS(2187),
    [sym_float_literal] = ACTIONS(2187),
    [sym_rune_literal] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(2187),
    [anon_sym_DQUOTE] = ACTIONS(2187),
    [anon_sym_c_SQUOTE] = ACTIONS(2187),
    [anon_sym_c_DQUOTE] = ACTIONS(2187),
    [anon_sym_r_SQUOTE] = ACTIONS(2187),
    [anon_sym_r_DQUOTE] = ACTIONS(2187),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2187),
    [anon_sym_shared] = ACTIONS(2187),
    [anon_sym_map_LBRACK] = ACTIONS(2187),
    [anon_sym_chan] = ACTIONS(2187),
    [anon_sym_thread] = ACTIONS(2187),
    [anon_sym_atomic] = ACTIONS(2187),
  },
  [1427] = {
    [sym_line_comment] = STATE(1427),
    [sym_block_comment] = STATE(1427),
    [sym_type_parameters] = STATE(4411),
    [sym_argument_list] = STATE(1514),
    [sym_or_block] = STATE(1516),
    [sym_identifier] = ACTIONS(4140),
    [anon_sym_LF] = ACTIONS(4140),
    [anon_sym_CR] = ACTIONS(4140),
    [anon_sym_CR_LF] = ACTIONS(4140),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4096),
    [anon_sym_as] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4098),
    [anon_sym_fn] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4110),
    [anon_sym_SLASH] = ACTIONS(4110),
    [anon_sym_PERCENT] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4112),
    [anon_sym_GT] = ACTIONS(4112),
    [anon_sym_EQ_EQ] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_LT_EQ] = ACTIONS(4112),
    [anon_sym_GT_EQ] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_struct] = ACTIONS(4140),
    [anon_sym_mut] = ACTIONS(4140),
    [anon_sym_PLUS_PLUS] = ACTIONS(4118),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4102),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_go] = ACTIONS(4140),
    [anon_sym_spawn] = ACTIONS(4140),
    [anon_sym_json_DOTdecode] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_LBRACK2] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(4140),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4110),
    [anon_sym_LT_DASH] = ACTIONS(4140),
    [anon_sym_LT_LT] = ACTIONS(4110),
    [anon_sym_GT_GT] = ACTIONS(4110),
    [anon_sym_GT_GT_GT] = ACTIONS(4110),
    [anon_sym_AMP_CARET] = ACTIONS(4110),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4124),
    [anon_sym_or] = ACTIONS(4126),
    [sym_none] = ACTIONS(4140),
    [sym_true] = ACTIONS(4140),
    [sym_false] = ACTIONS(4140),
    [sym_nil] = ACTIONS(4140),
    [anon_sym_QMARK_DOT] = ACTIONS(4096),
    [anon_sym_POUND_LBRACK] = ACTIONS(4106),
    [anon_sym_if] = ACTIONS(4140),
    [anon_sym_DOLLARif] = ACTIONS(4140),
    [anon_sym_is] = ACTIONS(4128),
    [anon_sym_BANGis] = ACTIONS(4128),
    [anon_sym_in] = ACTIONS(4114),
    [anon_sym_BANGin] = ACTIONS(4114),
    [anon_sym_match] = ACTIONS(4140),
    [anon_sym_select] = ACTIONS(4140),
    [anon_sym_lock] = ACTIONS(4140),
    [anon_sym_rlock] = ACTIONS(4140),
    [anon_sym_unsafe] = ACTIONS(4140),
    [anon_sym_sql] = ACTIONS(4140),
    [sym_int_literal] = ACTIONS(4140),
    [sym_float_literal] = ACTIONS(4140),
    [sym_rune_literal] = ACTIONS(4140),
    [anon_sym_SQUOTE] = ACTIONS(4140),
    [anon_sym_DQUOTE] = ACTIONS(4140),
    [anon_sym_c_SQUOTE] = ACTIONS(4140),
    [anon_sym_c_DQUOTE] = ACTIONS(4140),
    [anon_sym_r_SQUOTE] = ACTIONS(4140),
    [anon_sym_r_DQUOTE] = ACTIONS(4140),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4140),
    [anon_sym_shared] = ACTIONS(4140),
    [anon_sym_map_LBRACK] = ACTIONS(4140),
    [anon_sym_chan] = ACTIONS(4140),
    [anon_sym_thread] = ACTIONS(4140),
    [anon_sym_atomic] = ACTIONS(4140),
  },
  [1428] = {
    [sym_line_comment] = STATE(1428),
    [sym_block_comment] = STATE(1428),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LF] = ACTIONS(2175),
    [anon_sym_CR] = ACTIONS(2175),
    [anon_sym_CR_LF] = ACTIONS(2175),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_DOT] = ACTIONS(2175),
    [anon_sym_as] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2177),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_RPAREN] = ACTIONS(2175),
    [anon_sym_fn] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2175),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_PERCENT] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_GT] = ACTIONS(2175),
    [anon_sym_EQ_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ] = ACTIONS(2175),
    [anon_sym_LT_EQ] = ACTIONS(2175),
    [anon_sym_GT_EQ] = ACTIONS(2175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2180),
    [anon_sym_struct] = ACTIONS(2175),
    [anon_sym_mut] = ACTIONS(2175),
    [anon_sym_COLON] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [anon_sym_QMARK] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_go] = ACTIONS(2175),
    [anon_sym_spawn] = ACTIONS(2175),
    [anon_sym_json_DOTdecode] = ACTIONS(2175),
    [anon_sym_PIPE] = ACTIONS(2175),
    [anon_sym_LBRACK2] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_CARET] = ACTIONS(2175),
    [anon_sym_AMP] = ACTIONS(2175),
    [anon_sym_LT_DASH] = ACTIONS(2175),
    [anon_sym_LT_LT] = ACTIONS(2175),
    [anon_sym_GT_GT] = ACTIONS(2175),
    [anon_sym_GT_GT_GT] = ACTIONS(2175),
    [anon_sym_AMP_CARET] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(2175),
    [anon_sym_PIPE_PIPE] = ACTIONS(2175),
    [anon_sym_or] = ACTIONS(2175),
    [sym_none] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_nil] = ACTIONS(2175),
    [anon_sym_QMARK_DOT] = ACTIONS(2175),
    [anon_sym_POUND_LBRACK] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_DOLLARif] = ACTIONS(2175),
    [anon_sym_is] = ACTIONS(2175),
    [anon_sym_BANGis] = ACTIONS(2175),
    [anon_sym_in] = ACTIONS(2175),
    [anon_sym_BANGin] = ACTIONS(2175),
    [anon_sym_match] = ACTIONS(2175),
    [anon_sym_select] = ACTIONS(2175),
    [anon_sym_lock] = ACTIONS(2175),
    [anon_sym_rlock] = ACTIONS(2175),
    [anon_sym_unsafe] = ACTIONS(2175),
    [anon_sym_sql] = ACTIONS(2175),
    [sym_int_literal] = ACTIONS(2175),
    [sym_float_literal] = ACTIONS(2175),
    [sym_rune_literal] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_c_SQUOTE] = ACTIONS(2175),
    [anon_sym_c_DQUOTE] = ACTIONS(2175),
    [anon_sym_r_SQUOTE] = ACTIONS(2175),
    [anon_sym_r_DQUOTE] = ACTIONS(2175),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2175),
    [anon_sym_shared] = ACTIONS(2175),
    [anon_sym_map_LBRACK] = ACTIONS(2175),
    [anon_sym_chan] = ACTIONS(2175),
    [anon_sym_thread] = ACTIONS(2175),
    [anon_sym_atomic] = ACTIONS(2175),
  },
  [1429] = {
    [sym_line_comment] = STATE(1429),
    [sym_block_comment] = STATE(1429),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_CR] = ACTIONS(2147),
    [anon_sym_CR_LF] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_COMMA] = ACTIONS(2147),
    [anon_sym_RBRACE] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym_RPAREN] = ACTIONS(2147),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2147),
    [anon_sym_BANG_EQ] = ACTIONS(2147),
    [anon_sym_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2147),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2147),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2147),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2147),
    [anon_sym_AMP_CARET] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [anon_sym_or] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2147),
    [anon_sym_POUND_LBRACK] = ACTIONS(2147),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_else] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2147),
    [anon_sym_BANGis] = ACTIONS(2147),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANGin] = ACTIONS(2147),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2147),
    [sym_rune_literal] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_c_SQUOTE] = ACTIONS(2147),
    [anon_sym_c_DQUOTE] = ACTIONS(2147),
    [anon_sym_r_SQUOTE] = ACTIONS(2147),
    [anon_sym_r_DQUOTE] = ACTIONS(2147),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2147),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
  },
  [1430] = {
    [sym_line_comment] = STATE(1430),
    [sym_block_comment] = STATE(1430),
    [sym_identifier] = ACTIONS(2105),
    [anon_sym_LF] = ACTIONS(2105),
    [anon_sym_CR] = ACTIONS(2105),
    [anon_sym_CR_LF] = ACTIONS(2105),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2105),
    [anon_sym_DOT] = ACTIONS(2105),
    [anon_sym_as] = ACTIONS(2105),
    [anon_sym_LBRACE] = ACTIONS(2105),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_RBRACE] = ACTIONS(2105),
    [anon_sym_LPAREN] = ACTIONS(2105),
    [anon_sym_RPAREN] = ACTIONS(2105),
    [anon_sym_fn] = ACTIONS(2105),
    [anon_sym_PLUS] = ACTIONS(2105),
    [anon_sym_DASH] = ACTIONS(2105),
    [anon_sym_STAR] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2105),
    [anon_sym_PERCENT] = ACTIONS(2105),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_GT] = ACTIONS(2105),
    [anon_sym_EQ_EQ] = ACTIONS(2105),
    [anon_sym_BANG_EQ] = ACTIONS(2105),
    [anon_sym_LT_EQ] = ACTIONS(2105),
    [anon_sym_GT_EQ] = ACTIONS(2105),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2105),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_struct] = ACTIONS(2105),
    [anon_sym_mut] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_QMARK] = ACTIONS(2105),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_go] = ACTIONS(2105),
    [anon_sym_spawn] = ACTIONS(2105),
    [anon_sym_json_DOTdecode] = ACTIONS(2105),
    [anon_sym_PIPE] = ACTIONS(2105),
    [anon_sym_LBRACK2] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_LT_DASH] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(2105),
    [anon_sym_GT_GT] = ACTIONS(2105),
    [anon_sym_GT_GT_GT] = ACTIONS(2105),
    [anon_sym_AMP_CARET] = ACTIONS(2105),
    [anon_sym_AMP_AMP] = ACTIONS(2105),
    [anon_sym_PIPE_PIPE] = ACTIONS(2105),
    [anon_sym_or] = ACTIONS(2105),
    [sym_none] = ACTIONS(2105),
    [sym_true] = ACTIONS(2105),
    [sym_false] = ACTIONS(2105),
    [sym_nil] = ACTIONS(2105),
    [anon_sym_QMARK_DOT] = ACTIONS(2105),
    [anon_sym_POUND_LBRACK] = ACTIONS(2105),
    [anon_sym_if] = ACTIONS(2105),
    [anon_sym_DOLLARif] = ACTIONS(2105),
    [anon_sym_DOLLARelse] = ACTIONS(4142),
    [anon_sym_is] = ACTIONS(2105),
    [anon_sym_BANGis] = ACTIONS(2105),
    [anon_sym_in] = ACTIONS(2105),
    [anon_sym_BANGin] = ACTIONS(2105),
    [anon_sym_match] = ACTIONS(2105),
    [anon_sym_select] = ACTIONS(2105),
    [anon_sym_lock] = ACTIONS(2105),
    [anon_sym_rlock] = ACTIONS(2105),
    [anon_sym_unsafe] = ACTIONS(2105),
    [anon_sym_sql] = ACTIONS(2105),
    [sym_int_literal] = ACTIONS(2105),
    [sym_float_literal] = ACTIONS(2105),
    [sym_rune_literal] = ACTIONS(2105),
    [anon_sym_SQUOTE] = ACTIONS(2105),
    [anon_sym_DQUOTE] = ACTIONS(2105),
    [anon_sym_c_SQUOTE] = ACTIONS(2105),
    [anon_sym_c_DQUOTE] = ACTIONS(2105),
    [anon_sym_r_SQUOTE] = ACTIONS(2105),
    [anon_sym_r_DQUOTE] = ACTIONS(2105),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2105),
    [anon_sym_shared] = ACTIONS(2105),
    [anon_sym_map_LBRACK] = ACTIONS(2105),
    [anon_sym_chan] = ACTIONS(2105),
    [anon_sym_thread] = ACTIONS(2105),
    [anon_sym_atomic] = ACTIONS(2105),
  },
  [1431] = {
    [sym_line_comment] = STATE(1431),
    [sym_block_comment] = STATE(1431),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_LF] = ACTIONS(2169),
    [anon_sym_CR] = ACTIONS(2169),
    [anon_sym_CR_LF] = ACTIONS(2169),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2169),
    [anon_sym_as] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_COMMA] = ACTIONS(2169),
    [anon_sym_RBRACE] = ACTIONS(2169),
    [anon_sym_LPAREN] = ACTIONS(2169),
    [anon_sym_RPAREN] = ACTIONS(2169),
    [anon_sym_fn] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_SLASH] = ACTIONS(2169),
    [anon_sym_PERCENT] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2169),
    [anon_sym_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ] = ACTIONS(2169),
    [anon_sym_LT_EQ] = ACTIONS(2169),
    [anon_sym_GT_EQ] = ACTIONS(2169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_mut] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_go] = ACTIONS(2169),
    [anon_sym_spawn] = ACTIONS(2169),
    [anon_sym_json_DOTdecode] = ACTIONS(2169),
    [anon_sym_PIPE] = ACTIONS(2169),
    [anon_sym_LBRACK2] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT_DASH] = ACTIONS(2169),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_GT_GT_GT] = ACTIONS(2169),
    [anon_sym_AMP_CARET] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_PIPE_PIPE] = ACTIONS(2169),
    [anon_sym_or] = ACTIONS(2169),
    [sym_none] = ACTIONS(2169),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [sym_nil] = ACTIONS(2169),
    [anon_sym_QMARK_DOT] = ACTIONS(2169),
    [anon_sym_POUND_LBRACK] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(2169),
    [anon_sym_DOLLARif] = ACTIONS(2169),
    [anon_sym_is] = ACTIONS(2169),
    [anon_sym_BANGis] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_BANGin] = ACTIONS(2169),
    [anon_sym_match] = ACTIONS(2169),
    [anon_sym_select] = ACTIONS(2169),
    [anon_sym_lock] = ACTIONS(2169),
    [anon_sym_rlock] = ACTIONS(2169),
    [anon_sym_unsafe] = ACTIONS(2169),
    [anon_sym_sql] = ACTIONS(2169),
    [sym_int_literal] = ACTIONS(2169),
    [sym_float_literal] = ACTIONS(2169),
    [sym_rune_literal] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [anon_sym_c_SQUOTE] = ACTIONS(2169),
    [anon_sym_c_DQUOTE] = ACTIONS(2169),
    [anon_sym_r_SQUOTE] = ACTIONS(2169),
    [anon_sym_r_DQUOTE] = ACTIONS(2169),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_map_LBRACK] = ACTIONS(2169),
    [anon_sym_chan] = ACTIONS(2169),
    [anon_sym_thread] = ACTIONS(2169),
    [anon_sym_atomic] = ACTIONS(2169),
  },
  [1432] = {
    [sym_line_comment] = STATE(1432),
    [sym_block_comment] = STATE(1432),
    [sym_identifier] = ACTIONS(2093),
    [anon_sym_LF] = ACTIONS(2093),
    [anon_sym_CR] = ACTIONS(2093),
    [anon_sym_CR_LF] = ACTIONS(2093),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2093),
    [anon_sym_DOT] = ACTIONS(2093),
    [anon_sym_as] = ACTIONS(2093),
    [anon_sym_LBRACE] = ACTIONS(2093),
    [anon_sym_COMMA] = ACTIONS(2093),
    [anon_sym_RBRACE] = ACTIONS(2093),
    [anon_sym_LPAREN] = ACTIONS(2093),
    [anon_sym_RPAREN] = ACTIONS(2093),
    [anon_sym_fn] = ACTIONS(2093),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(2093),
    [anon_sym_SLASH] = ACTIONS(2093),
    [anon_sym_PERCENT] = ACTIONS(2093),
    [anon_sym_LT] = ACTIONS(2093),
    [anon_sym_GT] = ACTIONS(2093),
    [anon_sym_EQ_EQ] = ACTIONS(2093),
    [anon_sym_BANG_EQ] = ACTIONS(2093),
    [anon_sym_LT_EQ] = ACTIONS(2093),
    [anon_sym_GT_EQ] = ACTIONS(2093),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2091),
    [anon_sym_struct] = ACTIONS(2093),
    [anon_sym_mut] = ACTIONS(2093),
    [anon_sym_PLUS_PLUS] = ACTIONS(2093),
    [anon_sym_DASH_DASH] = ACTIONS(2093),
    [anon_sym_QMARK] = ACTIONS(2093),
    [anon_sym_BANG] = ACTIONS(2093),
    [anon_sym_go] = ACTIONS(2093),
    [anon_sym_spawn] = ACTIONS(2093),
    [anon_sym_json_DOTdecode] = ACTIONS(2093),
    [anon_sym_PIPE] = ACTIONS(2093),
    [anon_sym_LBRACK2] = ACTIONS(2093),
    [anon_sym_TILDE] = ACTIONS(2093),
    [anon_sym_CARET] = ACTIONS(2093),
    [anon_sym_AMP] = ACTIONS(2093),
    [anon_sym_LT_DASH] = ACTIONS(2093),
    [anon_sym_LT_LT] = ACTIONS(2093),
    [anon_sym_GT_GT] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2093),
    [anon_sym_AMP_CARET] = ACTIONS(2093),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_PIPE_PIPE] = ACTIONS(2093),
    [anon_sym_or] = ACTIONS(2093),
    [sym_none] = ACTIONS(2093),
    [sym_true] = ACTIONS(2093),
    [sym_false] = ACTIONS(2093),
    [sym_nil] = ACTIONS(2093),
    [anon_sym_QMARK_DOT] = ACTIONS(2093),
    [anon_sym_POUND_LBRACK] = ACTIONS(2093),
    [anon_sym_if] = ACTIONS(2093),
    [anon_sym_DOLLARif] = ACTIONS(2093),
    [anon_sym_DOLLARelse] = ACTIONS(4144),
    [anon_sym_is] = ACTIONS(2093),
    [anon_sym_BANGis] = ACTIONS(2093),
    [anon_sym_in] = ACTIONS(2093),
    [anon_sym_BANGin] = ACTIONS(2093),
    [anon_sym_match] = ACTIONS(2093),
    [anon_sym_select] = ACTIONS(2093),
    [anon_sym_lock] = ACTIONS(2093),
    [anon_sym_rlock] = ACTIONS(2093),
    [anon_sym_unsafe] = ACTIONS(2093),
    [anon_sym_sql] = ACTIONS(2093),
    [sym_int_literal] = ACTIONS(2093),
    [sym_float_literal] = ACTIONS(2093),
    [sym_rune_literal] = ACTIONS(2093),
    [anon_sym_SQUOTE] = ACTIONS(2093),
    [anon_sym_DQUOTE] = ACTIONS(2093),
    [anon_sym_c_SQUOTE] = ACTIONS(2093),
    [anon_sym_c_DQUOTE] = ACTIONS(2093),
    [anon_sym_r_SQUOTE] = ACTIONS(2093),
    [anon_sym_r_DQUOTE] = ACTIONS(2093),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2093),
    [anon_sym_shared] = ACTIONS(2093),
    [anon_sym_map_LBRACK] = ACTIONS(2093),
    [anon_sym_chan] = ACTIONS(2093),
    [anon_sym_thread] = ACTIONS(2093),
    [anon_sym_atomic] = ACTIONS(2093),
  },
  [1433] = {
    [sym_line_comment] = STATE(1433),
    [sym_block_comment] = STATE(1433),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_CR] = ACTIONS(2147),
    [anon_sym_CR_LF] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_COMMA] = ACTIONS(2147),
    [anon_sym_RBRACE] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym_RPAREN] = ACTIONS(2147),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2147),
    [anon_sym_BANG_EQ] = ACTIONS(2147),
    [anon_sym_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2147),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2147),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2147),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2147),
    [anon_sym_AMP_CARET] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [anon_sym_or] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2147),
    [anon_sym_POUND_LBRACK] = ACTIONS(2147),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_DOLLARelse] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2147),
    [anon_sym_BANGis] = ACTIONS(2147),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANGin] = ACTIONS(2147),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2147),
    [sym_rune_literal] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_c_SQUOTE] = ACTIONS(2147),
    [anon_sym_c_DQUOTE] = ACTIONS(2147),
    [anon_sym_r_SQUOTE] = ACTIONS(2147),
    [anon_sym_r_DQUOTE] = ACTIONS(2147),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2147),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
  },
  [1434] = {
    [sym_line_comment] = STATE(1434),
    [sym_block_comment] = STATE(1434),
    [sym_type_parameters] = STATE(4411),
    [sym_argument_list] = STATE(1514),
    [sym_or_block] = STATE(1516),
    [sym_identifier] = ACTIONS(4146),
    [anon_sym_LF] = ACTIONS(4148),
    [anon_sym_CR] = ACTIONS(4148),
    [anon_sym_CR_LF] = ACTIONS(4148),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4096),
    [anon_sym_as] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_RBRACE] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(4098),
    [anon_sym_fn] = ACTIONS(4146),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4110),
    [anon_sym_SLASH] = ACTIONS(4110),
    [anon_sym_PERCENT] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4112),
    [anon_sym_GT] = ACTIONS(4112),
    [anon_sym_EQ_EQ] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_LT_EQ] = ACTIONS(4112),
    [anon_sym_GT_EQ] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_struct] = ACTIONS(4146),
    [anon_sym_mut] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4118),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4102),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_go] = ACTIONS(4146),
    [anon_sym_spawn] = ACTIONS(4146),
    [anon_sym_json_DOTdecode] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_LBRACK2] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(4146),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4110),
    [anon_sym_LT_DASH] = ACTIONS(4146),
    [anon_sym_LT_LT] = ACTIONS(4110),
    [anon_sym_GT_GT] = ACTIONS(4110),
    [anon_sym_GT_GT_GT] = ACTIONS(4110),
    [anon_sym_AMP_CARET] = ACTIONS(4110),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4124),
    [anon_sym_or] = ACTIONS(4126),
    [sym_none] = ACTIONS(4146),
    [sym_true] = ACTIONS(4146),
    [sym_false] = ACTIONS(4146),
    [sym_nil] = ACTIONS(4146),
    [anon_sym_QMARK_DOT] = ACTIONS(4096),
    [anon_sym_POUND_LBRACK] = ACTIONS(4106),
    [anon_sym_if] = ACTIONS(4146),
    [anon_sym_DOLLARif] = ACTIONS(4146),
    [anon_sym_is] = ACTIONS(4128),
    [anon_sym_BANGis] = ACTIONS(4128),
    [anon_sym_in] = ACTIONS(4114),
    [anon_sym_BANGin] = ACTIONS(4114),
    [anon_sym_match] = ACTIONS(4146),
    [anon_sym_select] = ACTIONS(4146),
    [anon_sym_lock] = ACTIONS(4146),
    [anon_sym_rlock] = ACTIONS(4146),
    [anon_sym_unsafe] = ACTIONS(4146),
    [anon_sym_sql] = ACTIONS(4146),
    [sym_int_literal] = ACTIONS(4146),
    [sym_float_literal] = ACTIONS(4146),
    [sym_rune_literal] = ACTIONS(4146),
    [anon_sym_SQUOTE] = ACTIONS(4146),
    [anon_sym_DQUOTE] = ACTIONS(4146),
    [anon_sym_c_SQUOTE] = ACTIONS(4146),
    [anon_sym_c_DQUOTE] = ACTIONS(4146),
    [anon_sym_r_SQUOTE] = ACTIONS(4146),
    [anon_sym_r_DQUOTE] = ACTIONS(4146),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4146),
    [anon_sym_shared] = ACTIONS(4146),
    [anon_sym_map_LBRACK] = ACTIONS(4146),
    [anon_sym_chan] = ACTIONS(4146),
    [anon_sym_thread] = ACTIONS(4146),
    [anon_sym_atomic] = ACTIONS(4146),
  },
  [1435] = {
    [sym_line_comment] = STATE(1435),
    [sym_block_comment] = STATE(1435),
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_LF] = ACTIONS(2627),
    [anon_sym_CR] = ACTIONS(2627),
    [anon_sym_CR_LF] = ACTIONS(2627),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2627),
    [anon_sym_DOT] = ACTIONS(2627),
    [anon_sym_as] = ACTIONS(2627),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_COMMA] = ACTIONS(2627),
    [anon_sym_RBRACE] = ACTIONS(2627),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_RPAREN] = ACTIONS(2627),
    [anon_sym_fn] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_SLASH] = ACTIONS(2627),
    [anon_sym_PERCENT] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2627),
    [anon_sym_GT] = ACTIONS(2627),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT_EQ] = ACTIONS(2627),
    [anon_sym_GT_EQ] = ACTIONS(2627),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2625),
    [anon_sym_struct] = ACTIONS(2627),
    [anon_sym_mut] = ACTIONS(2627),
    [anon_sym_PLUS_PLUS] = ACTIONS(2627),
    [anon_sym_DASH_DASH] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2627),
    [anon_sym_BANG] = ACTIONS(2627),
    [anon_sym_go] = ACTIONS(2627),
    [anon_sym_spawn] = ACTIONS(2627),
    [anon_sym_json_DOTdecode] = ACTIONS(2627),
    [anon_sym_PIPE] = ACTIONS(2627),
    [anon_sym_LBRACK2] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2627),
    [anon_sym_CARET] = ACTIONS(2627),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_LT_DASH] = ACTIONS(2627),
    [anon_sym_LT_LT] = ACTIONS(2627),
    [anon_sym_GT_GT] = ACTIONS(2627),
    [anon_sym_GT_GT_GT] = ACTIONS(2627),
    [anon_sym_AMP_CARET] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_PIPE_PIPE] = ACTIONS(2627),
    [anon_sym_or] = ACTIONS(2627),
    [sym_none] = ACTIONS(2627),
    [sym_true] = ACTIONS(2627),
    [sym_false] = ACTIONS(2627),
    [sym_nil] = ACTIONS(2627),
    [anon_sym_QMARK_DOT] = ACTIONS(2627),
    [anon_sym_POUND_LBRACK] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_DOLLARif] = ACTIONS(2627),
    [anon_sym_is] = ACTIONS(2627),
    [anon_sym_BANGis] = ACTIONS(2627),
    [anon_sym_in] = ACTIONS(2627),
    [anon_sym_BANGin] = ACTIONS(2627),
    [anon_sym_match] = ACTIONS(2627),
    [anon_sym_select] = ACTIONS(2627),
    [anon_sym_lock] = ACTIONS(2627),
    [anon_sym_rlock] = ACTIONS(2627),
    [anon_sym_unsafe] = ACTIONS(2627),
    [anon_sym_sql] = ACTIONS(2627),
    [sym_int_literal] = ACTIONS(2627),
    [sym_float_literal] = ACTIONS(2627),
    [sym_rune_literal] = ACTIONS(2627),
    [anon_sym_SQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [anon_sym_c_SQUOTE] = ACTIONS(2627),
    [anon_sym_c_DQUOTE] = ACTIONS(2627),
    [anon_sym_r_SQUOTE] = ACTIONS(2627),
    [anon_sym_r_DQUOTE] = ACTIONS(2627),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2627),
    [anon_sym_shared] = ACTIONS(2627),
    [anon_sym_map_LBRACK] = ACTIONS(2627),
    [anon_sym_chan] = ACTIONS(2627),
    [anon_sym_thread] = ACTIONS(2627),
    [anon_sym_atomic] = ACTIONS(2627),
  },
  [1436] = {
    [sym_line_comment] = STATE(1436),
    [sym_block_comment] = STATE(1436),
    [sym_identifier] = ACTIONS(3350),
    [anon_sym_LF] = ACTIONS(3350),
    [anon_sym_CR] = ACTIONS(3350),
    [anon_sym_CR_LF] = ACTIONS(3350),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(3350),
    [anon_sym_as] = ACTIONS(3350),
    [anon_sym_LBRACE] = ACTIONS(3350),
    [anon_sym_COMMA] = ACTIONS(3350),
    [anon_sym_RBRACE] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(3350),
    [anon_sym_RPAREN] = ACTIONS(3350),
    [anon_sym_fn] = ACTIONS(3350),
    [anon_sym_PLUS] = ACTIONS(3350),
    [anon_sym_DASH] = ACTIONS(3350),
    [anon_sym_STAR] = ACTIONS(3350),
    [anon_sym_SLASH] = ACTIONS(3350),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_LT] = ACTIONS(3350),
    [anon_sym_GT] = ACTIONS(3350),
    [anon_sym_EQ_EQ] = ACTIONS(3350),
    [anon_sym_BANG_EQ] = ACTIONS(3350),
    [anon_sym_LT_EQ] = ACTIONS(3350),
    [anon_sym_GT_EQ] = ACTIONS(3350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3350),
    [anon_sym_LBRACK] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3350),
    [anon_sym_mut] = ACTIONS(3350),
    [anon_sym_PLUS_PLUS] = ACTIONS(3350),
    [anon_sym_DASH_DASH] = ACTIONS(3350),
    [anon_sym_QMARK] = ACTIONS(3350),
    [anon_sym_BANG] = ACTIONS(3350),
    [anon_sym_go] = ACTIONS(3350),
    [anon_sym_spawn] = ACTIONS(3350),
    [anon_sym_json_DOTdecode] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3350),
    [anon_sym_LBRACK2] = ACTIONS(3350),
    [anon_sym_TILDE] = ACTIONS(3350),
    [anon_sym_CARET] = ACTIONS(3350),
    [anon_sym_AMP] = ACTIONS(3350),
    [anon_sym_LT_DASH] = ACTIONS(3350),
    [anon_sym_LT_LT] = ACTIONS(3350),
    [anon_sym_GT_GT] = ACTIONS(3350),
    [anon_sym_GT_GT_GT] = ACTIONS(3350),
    [anon_sym_AMP_CARET] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_PIPE_PIPE] = ACTIONS(3350),
    [anon_sym_or] = ACTIONS(3350),
    [sym_none] = ACTIONS(3350),
    [sym_true] = ACTIONS(3350),
    [sym_false] = ACTIONS(3350),
    [sym_nil] = ACTIONS(3350),
    [anon_sym_QMARK_DOT] = ACTIONS(3350),
    [anon_sym_POUND_LBRACK] = ACTIONS(3350),
    [anon_sym_if] = ACTIONS(3350),
    [anon_sym_DOLLARif] = ACTIONS(3350),
    [anon_sym_is] = ACTIONS(3350),
    [anon_sym_BANGis] = ACTIONS(3350),
    [anon_sym_in] = ACTIONS(3350),
    [anon_sym_BANGin] = ACTIONS(3350),
    [anon_sym_match] = ACTIONS(3350),
    [anon_sym_select] = ACTIONS(3350),
    [anon_sym_lock] = ACTIONS(3350),
    [anon_sym_rlock] = ACTIONS(3350),
    [anon_sym_unsafe] = ACTIONS(3350),
    [anon_sym_sql] = ACTIONS(3350),
    [sym_int_literal] = ACTIONS(3350),
    [sym_float_literal] = ACTIONS(3350),
    [sym_rune_literal] = ACTIONS(3350),
    [anon_sym_SQUOTE] = ACTIONS(3350),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [anon_sym_c_SQUOTE] = ACTIONS(3350),
    [anon_sym_c_DQUOTE] = ACTIONS(3350),
    [anon_sym_r_SQUOTE] = ACTIONS(3350),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3350),
    [anon_sym_shared] = ACTIONS(3350),
    [anon_sym_map_LBRACK] = ACTIONS(3350),
    [anon_sym_chan] = ACTIONS(3350),
    [anon_sym_thread] = ACTIONS(3350),
    [anon_sym_atomic] = ACTIONS(3350),
  },
  [1437] = {
    [sym_line_comment] = STATE(1437),
    [sym_block_comment] = STATE(1437),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2489),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(849),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_as] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(853),
    [anon_sym_COMMA] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(849),
    [anon_sym_EQ] = ACTIONS(851),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(851),
    [anon_sym_SLASH] = ACTIONS(851),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(849),
    [anon_sym_BANG_EQ] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_PLUS_PLUS] = ACTIONS(849),
    [anon_sym_DASH_DASH] = ACTIONS(849),
    [anon_sym_QMARK] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PIPE] = ACTIONS(851),
    [anon_sym_LBRACK2] = ACTIONS(851),
    [anon_sym_CARET] = ACTIONS(851),
    [anon_sym_AMP] = ACTIONS(851),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_CARET] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(849),
    [anon_sym_PIPE_PIPE] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(851),
    [anon_sym_QMARK_DOT] = ACTIONS(849),
    [anon_sym_POUND_LBRACK] = ACTIONS(849),
    [anon_sym_is] = ACTIONS(851),
    [anon_sym_BANGis] = ACTIONS(849),
    [anon_sym_in] = ACTIONS(851),
    [anon_sym_BANGin] = ACTIONS(849),
    [anon_sym_STAR_EQ] = ACTIONS(849),
    [anon_sym_SLASH_EQ] = ACTIONS(849),
    [anon_sym_PERCENT_EQ] = ACTIONS(849),
    [anon_sym_LT_LT_EQ] = ACTIONS(849),
    [anon_sym_GT_GT_EQ] = ACTIONS(849),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(849),
    [anon_sym_AMP_EQ] = ACTIONS(849),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(849),
    [anon_sym_PLUS_EQ] = ACTIONS(849),
    [anon_sym_DASH_EQ] = ACTIONS(849),
    [anon_sym_PIPE_EQ] = ACTIONS(849),
    [anon_sym_CARET_EQ] = ACTIONS(849),
    [anon_sym_COLON_EQ] = ACTIONS(849),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [1438] = {
    [sym_line_comment] = STATE(1438),
    [sym_block_comment] = STATE(1438),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LF] = ACTIONS(2175),
    [anon_sym_CR] = ACTIONS(2175),
    [anon_sym_CR_LF] = ACTIONS(2175),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_DOT] = ACTIONS(2175),
    [anon_sym_as] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2175),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_RPAREN] = ACTIONS(2175),
    [anon_sym_fn] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2175),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_PERCENT] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_GT] = ACTIONS(2175),
    [anon_sym_EQ_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ] = ACTIONS(2175),
    [anon_sym_LT_EQ] = ACTIONS(2175),
    [anon_sym_GT_EQ] = ACTIONS(2175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2173),
    [anon_sym_struct] = ACTIONS(2175),
    [anon_sym_mut] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [anon_sym_QMARK] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_go] = ACTIONS(2175),
    [anon_sym_spawn] = ACTIONS(2175),
    [anon_sym_json_DOTdecode] = ACTIONS(2175),
    [anon_sym_PIPE] = ACTIONS(2175),
    [anon_sym_LBRACK2] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_CARET] = ACTIONS(2175),
    [anon_sym_AMP] = ACTIONS(2175),
    [anon_sym_LT_DASH] = ACTIONS(2175),
    [anon_sym_LT_LT] = ACTIONS(2175),
    [anon_sym_GT_GT] = ACTIONS(2175),
    [anon_sym_GT_GT_GT] = ACTIONS(2175),
    [anon_sym_AMP_CARET] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(2175),
    [anon_sym_PIPE_PIPE] = ACTIONS(2175),
    [anon_sym_or] = ACTIONS(2175),
    [sym_none] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_nil] = ACTIONS(2175),
    [anon_sym_QMARK_DOT] = ACTIONS(2175),
    [anon_sym_POUND_LBRACK] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_DOLLARif] = ACTIONS(2175),
    [anon_sym_is] = ACTIONS(2175),
    [anon_sym_BANGis] = ACTIONS(2175),
    [anon_sym_in] = ACTIONS(2175),
    [anon_sym_BANGin] = ACTIONS(2175),
    [anon_sym_match] = ACTIONS(2175),
    [anon_sym_select] = ACTIONS(2175),
    [anon_sym_lock] = ACTIONS(2175),
    [anon_sym_rlock] = ACTIONS(2175),
    [anon_sym_unsafe] = ACTIONS(2175),
    [anon_sym_sql] = ACTIONS(2175),
    [sym_int_literal] = ACTIONS(2175),
    [sym_float_literal] = ACTIONS(2175),
    [sym_rune_literal] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_c_SQUOTE] = ACTIONS(2175),
    [anon_sym_c_DQUOTE] = ACTIONS(2175),
    [anon_sym_r_SQUOTE] = ACTIONS(2175),
    [anon_sym_r_DQUOTE] = ACTIONS(2175),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2175),
    [anon_sym_shared] = ACTIONS(2175),
    [anon_sym_map_LBRACK] = ACTIONS(2175),
    [anon_sym_chan] = ACTIONS(2175),
    [anon_sym_thread] = ACTIONS(2175),
    [anon_sym_atomic] = ACTIONS(2175),
  },
  [1439] = {
    [sym_line_comment] = STATE(1439),
    [sym_block_comment] = STATE(1439),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_CR] = ACTIONS(2873),
    [anon_sym_CR_LF] = ACTIONS(2873),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2873),
    [anon_sym_as] = ACTIONS(2873),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(2873),
    [anon_sym_LPAREN] = ACTIONS(2873),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_fn] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2873),
    [anon_sym_STAR] = ACTIONS(2873),
    [anon_sym_SLASH] = ACTIONS(2873),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2873),
    [anon_sym_GT] = ACTIONS(2873),
    [anon_sym_EQ_EQ] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_LT_EQ] = ACTIONS(2873),
    [anon_sym_GT_EQ] = ACTIONS(2873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2873),
    [anon_sym_mut] = ACTIONS(2873),
    [anon_sym_PLUS_PLUS] = ACTIONS(2873),
    [anon_sym_DASH_DASH] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_BANG] = ACTIONS(2873),
    [anon_sym_go] = ACTIONS(2873),
    [anon_sym_spawn] = ACTIONS(2873),
    [anon_sym_json_DOTdecode] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2873),
    [anon_sym_LBRACK2] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2873),
    [anon_sym_CARET] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LT_DASH] = ACTIONS(2873),
    [anon_sym_LT_LT] = ACTIONS(2873),
    [anon_sym_GT_GT] = ACTIONS(2873),
    [anon_sym_GT_GT_GT] = ACTIONS(2873),
    [anon_sym_AMP_CARET] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [sym_none] = ACTIONS(2873),
    [sym_true] = ACTIONS(2873),
    [sym_false] = ACTIONS(2873),
    [sym_nil] = ACTIONS(2873),
    [anon_sym_QMARK_DOT] = ACTIONS(2873),
    [anon_sym_POUND_LBRACK] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_DOLLARif] = ACTIONS(2873),
    [anon_sym_is] = ACTIONS(2873),
    [anon_sym_BANGis] = ACTIONS(2873),
    [anon_sym_in] = ACTIONS(2873),
    [anon_sym_BANGin] = ACTIONS(2873),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_select] = ACTIONS(2873),
    [anon_sym_lock] = ACTIONS(2873),
    [anon_sym_rlock] = ACTIONS(2873),
    [anon_sym_unsafe] = ACTIONS(2873),
    [anon_sym_sql] = ACTIONS(2873),
    [sym_int_literal] = ACTIONS(2873),
    [sym_float_literal] = ACTIONS(2873),
    [sym_rune_literal] = ACTIONS(2873),
    [anon_sym_SQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_c_SQUOTE] = ACTIONS(2873),
    [anon_sym_c_DQUOTE] = ACTIONS(2873),
    [anon_sym_r_SQUOTE] = ACTIONS(2873),
    [anon_sym_r_DQUOTE] = ACTIONS(2873),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2873),
    [anon_sym_shared] = ACTIONS(2873),
    [anon_sym_map_LBRACK] = ACTIONS(2873),
    [anon_sym_chan] = ACTIONS(2873),
    [anon_sym_thread] = ACTIONS(2873),
    [anon_sym_atomic] = ACTIONS(2873),
  },
  [1440] = {
    [sym_line_comment] = STATE(1440),
    [sym_block_comment] = STATE(1440),
    [sym_reference_expression] = STATE(4465),
    [sym_type_reference_expression] = STATE(2019),
    [sym_plain_type] = STATE(2063),
    [sym__plain_type_without_special] = STATE(2052),
    [sym_anon_struct_type] = STATE(2051),
    [sym_multi_return_type] = STATE(2052),
    [sym_result_type] = STATE(2052),
    [sym_option_type] = STATE(2052),
    [sym_qualified_type] = STATE(2019),
    [sym_fixed_array_type] = STATE(2051),
    [sym_array_type] = STATE(2051),
    [sym_pointer_type] = STATE(2051),
    [sym_wrong_pointer_type] = STATE(2051),
    [sym_map_type] = STATE(2051),
    [sym_channel_type] = STATE(2051),
    [sym_shared_type] = STATE(2051),
    [sym_thread_type] = STATE(2051),
    [sym_atomic_type] = STATE(2051),
    [sym_generic_type] = STATE(2051),
    [sym_function_type] = STATE(2051),
    [sym_identifier] = ACTIONS(4150),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(853),
    [anon_sym_DOT] = ACTIONS(853),
    [anon_sym_as] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(853),
    [anon_sym_COMMA] = ACTIONS(853),
    [anon_sym_LPAREN] = ACTIONS(4152),
    [anon_sym_EQ] = ACTIONS(855),
    [anon_sym_fn] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_PERCENT] = ACTIONS(855),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_GT] = ACTIONS(855),
    [anon_sym_EQ_EQ] = ACTIONS(853),
    [anon_sym_BANG_EQ] = ACTIONS(853),
    [anon_sym_LT_EQ] = ACTIONS(853),
    [anon_sym_GT_EQ] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_struct] = ACTIONS(4158),
    [anon_sym_PLUS_PLUS] = ACTIONS(853),
    [anon_sym_DASH_DASH] = ACTIONS(853),
    [anon_sym_QMARK] = ACTIONS(4160),
    [anon_sym_BANG] = ACTIONS(4162),
    [anon_sym_PIPE] = ACTIONS(855),
    [anon_sym_LBRACK2] = ACTIONS(4164),
    [anon_sym_CARET] = ACTIONS(855),
    [anon_sym_AMP] = ACTIONS(4166),
    [anon_sym_LT_LT] = ACTIONS(855),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_GT_GT_GT] = ACTIONS(855),
    [anon_sym_AMP_CARET] = ACTIONS(855),
    [anon_sym_AMP_AMP] = ACTIONS(853),
    [anon_sym_PIPE_PIPE] = ACTIONS(853),
    [anon_sym_or] = ACTIONS(855),
    [anon_sym_QMARK_DOT] = ACTIONS(853),
    [anon_sym_POUND_LBRACK] = ACTIONS(853),
    [anon_sym_is] = ACTIONS(855),
    [anon_sym_BANGis] = ACTIONS(853),
    [anon_sym_in] = ACTIONS(855),
    [anon_sym_BANGin] = ACTIONS(853),
    [anon_sym_STAR_EQ] = ACTIONS(853),
    [anon_sym_SLASH_EQ] = ACTIONS(853),
    [anon_sym_PERCENT_EQ] = ACTIONS(853),
    [anon_sym_LT_LT_EQ] = ACTIONS(853),
    [anon_sym_GT_GT_EQ] = ACTIONS(853),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(853),
    [anon_sym_AMP_EQ] = ACTIONS(853),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(853),
    [anon_sym_PLUS_EQ] = ACTIONS(853),
    [anon_sym_DASH_EQ] = ACTIONS(853),
    [anon_sym_PIPE_EQ] = ACTIONS(853),
    [anon_sym_CARET_EQ] = ACTIONS(853),
    [anon_sym_COLON_EQ] = ACTIONS(853),
    [anon_sym_shared] = ACTIONS(4168),
    [anon_sym_map_LBRACK] = ACTIONS(4170),
    [anon_sym_chan] = ACTIONS(4172),
    [anon_sym_thread] = ACTIONS(4174),
    [anon_sym_atomic] = ACTIONS(4176),
  },
  [1441] = {
    [sym_line_comment] = STATE(1441),
    [sym_block_comment] = STATE(1441),
    [sym_identifier] = ACTIONS(4178),
    [anon_sym_LF] = ACTIONS(4181),
    [anon_sym_CR] = ACTIONS(4181),
    [anon_sym_CR_LF] = ACTIONS(4181),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4181),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_as] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3045),
    [anon_sym_COMMA] = ACTIONS(4181),
    [anon_sym_RBRACE] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(3045),
    [anon_sym_fn] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3045),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_PERCENT] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_GT] = ACTIONS(3045),
    [anon_sym_EQ_EQ] = ACTIONS(3045),
    [anon_sym_BANG_EQ] = ACTIONS(3045),
    [anon_sym_LT_EQ] = ACTIONS(3045),
    [anon_sym_GT_EQ] = ACTIONS(3045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4184),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_struct] = ACTIONS(3045),
    [anon_sym_mut] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3045),
    [anon_sym_go] = ACTIONS(3045),
    [anon_sym_spawn] = ACTIONS(3045),
    [anon_sym_json_DOTdecode] = ACTIONS(3045),
    [anon_sym_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACK2] = ACTIONS(3045),
    [anon_sym_TILDE] = ACTIONS(3045),
    [anon_sym_CARET] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3045),
    [anon_sym_LT_DASH] = ACTIONS(3045),
    [anon_sym_LT_LT] = ACTIONS(3045),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_GT_GT_GT] = ACTIONS(3045),
    [anon_sym_AMP_CARET] = ACTIONS(3045),
    [anon_sym_AMP_AMP] = ACTIONS(3045),
    [anon_sym_PIPE_PIPE] = ACTIONS(3045),
    [anon_sym_or] = ACTIONS(3045),
    [sym_none] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_nil] = ACTIONS(3045),
    [anon_sym_QMARK_DOT] = ACTIONS(3045),
    [anon_sym_POUND_LBRACK] = ACTIONS(3045),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_DOLLARif] = ACTIONS(3045),
    [anon_sym_is] = ACTIONS(3045),
    [anon_sym_BANGis] = ACTIONS(3045),
    [anon_sym_in] = ACTIONS(3045),
    [anon_sym_BANGin] = ACTIONS(3045),
    [anon_sym_match] = ACTIONS(3045),
    [anon_sym_select] = ACTIONS(3045),
    [anon_sym_lock] = ACTIONS(3045),
    [anon_sym_rlock] = ACTIONS(3045),
    [anon_sym_unsafe] = ACTIONS(3045),
    [anon_sym_sql] = ACTIONS(3045),
    [sym_int_literal] = ACTIONS(3045),
    [sym_float_literal] = ACTIONS(3045),
    [sym_rune_literal] = ACTIONS(3045),
    [anon_sym_SQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE] = ACTIONS(3045),
    [anon_sym_c_SQUOTE] = ACTIONS(3045),
    [anon_sym_c_DQUOTE] = ACTIONS(3045),
    [anon_sym_r_SQUOTE] = ACTIONS(3045),
    [anon_sym_r_DQUOTE] = ACTIONS(3045),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3045),
    [anon_sym_shared] = ACTIONS(3045),
    [anon_sym_map_LBRACK] = ACTIONS(3045),
    [anon_sym_chan] = ACTIONS(3045),
    [anon_sym_thread] = ACTIONS(3045),
    [anon_sym_atomic] = ACTIONS(3045),
  },
  [1442] = {
    [sym_line_comment] = STATE(1442),
    [sym_block_comment] = STATE(1442),
    [sym_identifier] = ACTIONS(2885),
    [anon_sym_LF] = ACTIONS(2885),
    [anon_sym_CR] = ACTIONS(2885),
    [anon_sym_CR_LF] = ACTIONS(2885),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym_DOT] = ACTIONS(2885),
    [anon_sym_as] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2885),
    [anon_sym_RPAREN] = ACTIONS(2885),
    [anon_sym_fn] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2885),
    [anon_sym_SLASH] = ACTIONS(2885),
    [anon_sym_PERCENT] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_GT] = ACTIONS(2885),
    [anon_sym_EQ_EQ] = ACTIONS(2885),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2885),
    [anon_sym_GT_EQ] = ACTIONS(2885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_mut] = ACTIONS(2885),
    [anon_sym_PLUS_PLUS] = ACTIONS(2885),
    [anon_sym_DASH_DASH] = ACTIONS(2885),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_BANG] = ACTIONS(2885),
    [anon_sym_go] = ACTIONS(2885),
    [anon_sym_spawn] = ACTIONS(2885),
    [anon_sym_json_DOTdecode] = ACTIONS(2885),
    [anon_sym_PIPE] = ACTIONS(2885),
    [anon_sym_LBRACK2] = ACTIONS(2885),
    [anon_sym_TILDE] = ACTIONS(2885),
    [anon_sym_CARET] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_LT_DASH] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2885),
    [anon_sym_GT_GT] = ACTIONS(2885),
    [anon_sym_GT_GT_GT] = ACTIONS(2885),
    [anon_sym_AMP_CARET] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_or] = ACTIONS(2885),
    [sym_none] = ACTIONS(2885),
    [sym_true] = ACTIONS(2885),
    [sym_false] = ACTIONS(2885),
    [sym_nil] = ACTIONS(2885),
    [anon_sym_QMARK_DOT] = ACTIONS(2885),
    [anon_sym_POUND_LBRACK] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_DOLLARif] = ACTIONS(2885),
    [anon_sym_is] = ACTIONS(2885),
    [anon_sym_BANGis] = ACTIONS(2885),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_BANGin] = ACTIONS(2885),
    [anon_sym_match] = ACTIONS(2885),
    [anon_sym_select] = ACTIONS(2885),
    [anon_sym_lock] = ACTIONS(2885),
    [anon_sym_rlock] = ACTIONS(2885),
    [anon_sym_unsafe] = ACTIONS(2885),
    [anon_sym_sql] = ACTIONS(2885),
    [sym_int_literal] = ACTIONS(2885),
    [sym_float_literal] = ACTIONS(2885),
    [sym_rune_literal] = ACTIONS(2885),
    [anon_sym_SQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE] = ACTIONS(2885),
    [anon_sym_c_SQUOTE] = ACTIONS(2885),
    [anon_sym_c_DQUOTE] = ACTIONS(2885),
    [anon_sym_r_SQUOTE] = ACTIONS(2885),
    [anon_sym_r_DQUOTE] = ACTIONS(2885),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2885),
    [anon_sym_shared] = ACTIONS(2885),
    [anon_sym_map_LBRACK] = ACTIONS(2885),
    [anon_sym_chan] = ACTIONS(2885),
    [anon_sym_thread] = ACTIONS(2885),
    [anon_sym_atomic] = ACTIONS(2885),
  },
  [1443] = {
    [sym_line_comment] = STATE(1443),
    [sym_block_comment] = STATE(1443),
    [sym_reference_expression] = STATE(4465),
    [sym_type_reference_expression] = STATE(2019),
    [sym_plain_type] = STATE(2078),
    [sym__plain_type_without_special] = STATE(2052),
    [sym_anon_struct_type] = STATE(2051),
    [sym_multi_return_type] = STATE(2052),
    [sym_result_type] = STATE(2052),
    [sym_option_type] = STATE(2052),
    [sym_qualified_type] = STATE(2019),
    [sym_fixed_array_type] = STATE(2051),
    [sym_array_type] = STATE(2051),
    [sym_pointer_type] = STATE(2051),
    [sym_wrong_pointer_type] = STATE(2051),
    [sym_map_type] = STATE(2051),
    [sym_channel_type] = STATE(2051),
    [sym_shared_type] = STATE(2051),
    [sym_thread_type] = STATE(2051),
    [sym_atomic_type] = STATE(2051),
    [sym_generic_type] = STATE(2051),
    [sym_function_type] = STATE(2051),
    [sym_identifier] = ACTIONS(4150),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_DOT] = ACTIONS(857),
    [anon_sym_as] = ACTIONS(859),
    [anon_sym_LBRACE] = ACTIONS(857),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(4152),
    [anon_sym_EQ] = ACTIONS(859),
    [anon_sym_fn] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_EQ_EQ] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(857),
    [anon_sym_LT_EQ] = ACTIONS(857),
    [anon_sym_GT_EQ] = ACTIONS(857),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_struct] = ACTIONS(4158),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_QMARK] = ACTIONS(4160),
    [anon_sym_BANG] = ACTIONS(4162),
    [anon_sym_PIPE] = ACTIONS(859),
    [anon_sym_LBRACK2] = ACTIONS(4164),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(4166),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_GT_GT_GT] = ACTIONS(859),
    [anon_sym_AMP_CARET] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [anon_sym_or] = ACTIONS(859),
    [anon_sym_QMARK_DOT] = ACTIONS(857),
    [anon_sym_POUND_LBRACK] = ACTIONS(857),
    [anon_sym_is] = ACTIONS(859),
    [anon_sym_BANGis] = ACTIONS(857),
    [anon_sym_in] = ACTIONS(859),
    [anon_sym_BANGin] = ACTIONS(857),
    [anon_sym_STAR_EQ] = ACTIONS(857),
    [anon_sym_SLASH_EQ] = ACTIONS(857),
    [anon_sym_PERCENT_EQ] = ACTIONS(857),
    [anon_sym_LT_LT_EQ] = ACTIONS(857),
    [anon_sym_GT_GT_EQ] = ACTIONS(857),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(857),
    [anon_sym_AMP_EQ] = ACTIONS(857),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(857),
    [anon_sym_PLUS_EQ] = ACTIONS(857),
    [anon_sym_DASH_EQ] = ACTIONS(857),
    [anon_sym_PIPE_EQ] = ACTIONS(857),
    [anon_sym_CARET_EQ] = ACTIONS(857),
    [anon_sym_COLON_EQ] = ACTIONS(857),
    [anon_sym_shared] = ACTIONS(4168),
    [anon_sym_map_LBRACK] = ACTIONS(4170),
    [anon_sym_chan] = ACTIONS(4172),
    [anon_sym_thread] = ACTIONS(4174),
    [anon_sym_atomic] = ACTIONS(4176),
  },
  [1444] = {
    [sym_line_comment] = STATE(1444),
    [sym_block_comment] = STATE(1444),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_LF] = ACTIONS(2917),
    [anon_sym_CR] = ACTIONS(2917),
    [anon_sym_CR_LF] = ACTIONS(2917),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym_DOT] = ACTIONS(2917),
    [anon_sym_as] = ACTIONS(2917),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_COMMA] = ACTIONS(2917),
    [anon_sym_RBRACE] = ACTIONS(2917),
    [anon_sym_LPAREN] = ACTIONS(2917),
    [anon_sym_RPAREN] = ACTIONS(2917),
    [anon_sym_fn] = ACTIONS(2917),
    [anon_sym_PLUS] = ACTIONS(2917),
    [anon_sym_DASH] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2917),
    [anon_sym_SLASH] = ACTIONS(2917),
    [anon_sym_PERCENT] = ACTIONS(2917),
    [anon_sym_LT] = ACTIONS(2917),
    [anon_sym_GT] = ACTIONS(2917),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2917),
    [anon_sym_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT_EQ] = ACTIONS(2917),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2917),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2917),
    [anon_sym_mut] = ACTIONS(2917),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_QMARK] = ACTIONS(2917),
    [anon_sym_BANG] = ACTIONS(2917),
    [anon_sym_go] = ACTIONS(2917),
    [anon_sym_spawn] = ACTIONS(2917),
    [anon_sym_json_DOTdecode] = ACTIONS(2917),
    [anon_sym_PIPE] = ACTIONS(2917),
    [anon_sym_LBRACK2] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_CARET] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2917),
    [anon_sym_LT_DASH] = ACTIONS(2917),
    [anon_sym_LT_LT] = ACTIONS(2917),
    [anon_sym_GT_GT] = ACTIONS(2917),
    [anon_sym_GT_GT_GT] = ACTIONS(2917),
    [anon_sym_AMP_CARET] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_PIPE_PIPE] = ACTIONS(2917),
    [anon_sym_or] = ACTIONS(2917),
    [sym_none] = ACTIONS(2917),
    [sym_true] = ACTIONS(2917),
    [sym_false] = ACTIONS(2917),
    [sym_nil] = ACTIONS(2917),
    [anon_sym_QMARK_DOT] = ACTIONS(2917),
    [anon_sym_POUND_LBRACK] = ACTIONS(2917),
    [anon_sym_if] = ACTIONS(2917),
    [anon_sym_DOLLARif] = ACTIONS(2917),
    [anon_sym_is] = ACTIONS(2917),
    [anon_sym_BANGis] = ACTIONS(2917),
    [anon_sym_in] = ACTIONS(2917),
    [anon_sym_BANGin] = ACTIONS(2917),
    [anon_sym_match] = ACTIONS(2917),
    [anon_sym_select] = ACTIONS(2917),
    [anon_sym_lock] = ACTIONS(2917),
    [anon_sym_rlock] = ACTIONS(2917),
    [anon_sym_unsafe] = ACTIONS(2917),
    [anon_sym_sql] = ACTIONS(2917),
    [sym_int_literal] = ACTIONS(2917),
    [sym_float_literal] = ACTIONS(2917),
    [sym_rune_literal] = ACTIONS(2917),
    [anon_sym_SQUOTE] = ACTIONS(2917),
    [anon_sym_DQUOTE] = ACTIONS(2917),
    [anon_sym_c_SQUOTE] = ACTIONS(2917),
    [anon_sym_c_DQUOTE] = ACTIONS(2917),
    [anon_sym_r_SQUOTE] = ACTIONS(2917),
    [anon_sym_r_DQUOTE] = ACTIONS(2917),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2917),
    [anon_sym_shared] = ACTIONS(2917),
    [anon_sym_map_LBRACK] = ACTIONS(2917),
    [anon_sym_chan] = ACTIONS(2917),
    [anon_sym_thread] = ACTIONS(2917),
    [anon_sym_atomic] = ACTIONS(2917),
  },
  [1445] = {
    [sym_line_comment] = STATE(1445),
    [sym_block_comment] = STATE(1445),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2489),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(849),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_as] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(849),
    [anon_sym_EQ] = ACTIONS(851),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(851),
    [anon_sym_SLASH] = ACTIONS(851),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(849),
    [anon_sym_BANG_EQ] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_PLUS_PLUS] = ACTIONS(849),
    [anon_sym_DASH_DASH] = ACTIONS(849),
    [anon_sym_QMARK] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PIPE] = ACTIONS(851),
    [anon_sym_LBRACK2] = ACTIONS(851),
    [anon_sym_CARET] = ACTIONS(851),
    [anon_sym_AMP] = ACTIONS(851),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_CARET] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(849),
    [anon_sym_PIPE_PIPE] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(851),
    [anon_sym_QMARK_DOT] = ACTIONS(849),
    [anon_sym_POUND_LBRACK] = ACTIONS(849),
    [anon_sym_is] = ACTIONS(851),
    [anon_sym_BANGis] = ACTIONS(849),
    [anon_sym_in] = ACTIONS(851),
    [anon_sym_BANGin] = ACTIONS(849),
    [anon_sym_STAR_EQ] = ACTIONS(849),
    [anon_sym_SLASH_EQ] = ACTIONS(849),
    [anon_sym_PERCENT_EQ] = ACTIONS(849),
    [anon_sym_LT_LT_EQ] = ACTIONS(849),
    [anon_sym_GT_GT_EQ] = ACTIONS(849),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(849),
    [anon_sym_AMP_EQ] = ACTIONS(849),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(849),
    [anon_sym_PLUS_EQ] = ACTIONS(849),
    [anon_sym_DASH_EQ] = ACTIONS(849),
    [anon_sym_PIPE_EQ] = ACTIONS(849),
    [anon_sym_CARET_EQ] = ACTIONS(849),
    [anon_sym_COLON_EQ] = ACTIONS(849),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [1446] = {
    [sym_line_comment] = STATE(1446),
    [sym_block_comment] = STATE(1446),
    [sym_identifier] = ACTIONS(2921),
    [anon_sym_LF] = ACTIONS(2921),
    [anon_sym_CR] = ACTIONS(2921),
    [anon_sym_CR_LF] = ACTIONS(2921),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_as] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_COMMA] = ACTIONS(2921),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2921),
    [anon_sym_fn] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2921),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2921),
    [anon_sym_LT] = ACTIONS(2921),
    [anon_sym_GT] = ACTIONS(2921),
    [anon_sym_EQ_EQ] = ACTIONS(2921),
    [anon_sym_BANG_EQ] = ACTIONS(2921),
    [anon_sym_LT_EQ] = ACTIONS(2921),
    [anon_sym_GT_EQ] = ACTIONS(2921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2919),
    [anon_sym_struct] = ACTIONS(2921),
    [anon_sym_mut] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2921),
    [anon_sym_DASH_DASH] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_go] = ACTIONS(2921),
    [anon_sym_spawn] = ACTIONS(2921),
    [anon_sym_json_DOTdecode] = ACTIONS(2921),
    [anon_sym_PIPE] = ACTIONS(2921),
    [anon_sym_LBRACK2] = ACTIONS(2921),
    [anon_sym_TILDE] = ACTIONS(2921),
    [anon_sym_CARET] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2921),
    [anon_sym_LT_DASH] = ACTIONS(2921),
    [anon_sym_LT_LT] = ACTIONS(2921),
    [anon_sym_GT_GT] = ACTIONS(2921),
    [anon_sym_GT_GT_GT] = ACTIONS(2921),
    [anon_sym_AMP_CARET] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE] = ACTIONS(2921),
    [anon_sym_or] = ACTIONS(2921),
    [sym_none] = ACTIONS(2921),
    [sym_true] = ACTIONS(2921),
    [sym_false] = ACTIONS(2921),
    [sym_nil] = ACTIONS(2921),
    [anon_sym_QMARK_DOT] = ACTIONS(2921),
    [anon_sym_POUND_LBRACK] = ACTIONS(2921),
    [anon_sym_if] = ACTIONS(2921),
    [anon_sym_DOLLARif] = ACTIONS(2921),
    [anon_sym_is] = ACTIONS(2921),
    [anon_sym_BANGis] = ACTIONS(2921),
    [anon_sym_in] = ACTIONS(2921),
    [anon_sym_BANGin] = ACTIONS(2921),
    [anon_sym_match] = ACTIONS(2921),
    [anon_sym_select] = ACTIONS(2921),
    [anon_sym_lock] = ACTIONS(2921),
    [anon_sym_rlock] = ACTIONS(2921),
    [anon_sym_unsafe] = ACTIONS(2921),
    [anon_sym_sql] = ACTIONS(2921),
    [sym_int_literal] = ACTIONS(2921),
    [sym_float_literal] = ACTIONS(2921),
    [sym_rune_literal] = ACTIONS(2921),
    [anon_sym_SQUOTE] = ACTIONS(2921),
    [anon_sym_DQUOTE] = ACTIONS(2921),
    [anon_sym_c_SQUOTE] = ACTIONS(2921),
    [anon_sym_c_DQUOTE] = ACTIONS(2921),
    [anon_sym_r_SQUOTE] = ACTIONS(2921),
    [anon_sym_r_DQUOTE] = ACTIONS(2921),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2921),
    [anon_sym_shared] = ACTIONS(2921),
    [anon_sym_map_LBRACK] = ACTIONS(2921),
    [anon_sym_chan] = ACTIONS(2921),
    [anon_sym_thread] = ACTIONS(2921),
    [anon_sym_atomic] = ACTIONS(2921),
  },
  [1447] = {
    [sym_line_comment] = STATE(1447),
    [sym_block_comment] = STATE(1447),
    [sym_identifier] = ACTIONS(2981),
    [anon_sym_LF] = ACTIONS(2981),
    [anon_sym_CR] = ACTIONS(2981),
    [anon_sym_CR_LF] = ACTIONS(2981),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2981),
    [anon_sym_DOT] = ACTIONS(2981),
    [anon_sym_as] = ACTIONS(2981),
    [anon_sym_LBRACE] = ACTIONS(2981),
    [anon_sym_COMMA] = ACTIONS(2981),
    [anon_sym_RBRACE] = ACTIONS(2981),
    [anon_sym_LPAREN] = ACTIONS(2981),
    [anon_sym_RPAREN] = ACTIONS(2981),
    [anon_sym_fn] = ACTIONS(2981),
    [anon_sym_PLUS] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_PERCENT] = ACTIONS(2981),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_GT] = ACTIONS(2981),
    [anon_sym_EQ_EQ] = ACTIONS(2981),
    [anon_sym_BANG_EQ] = ACTIONS(2981),
    [anon_sym_LT_EQ] = ACTIONS(2981),
    [anon_sym_GT_EQ] = ACTIONS(2981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_struct] = ACTIONS(2981),
    [anon_sym_mut] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2981),
    [anon_sym_DASH_DASH] = ACTIONS(2981),
    [anon_sym_QMARK] = ACTIONS(2981),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_go] = ACTIONS(2981),
    [anon_sym_spawn] = ACTIONS(2981),
    [anon_sym_json_DOTdecode] = ACTIONS(2981),
    [anon_sym_PIPE] = ACTIONS(2981),
    [anon_sym_LBRACK2] = ACTIONS(2981),
    [anon_sym_TILDE] = ACTIONS(2981),
    [anon_sym_CARET] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2981),
    [anon_sym_LT_DASH] = ACTIONS(2981),
    [anon_sym_LT_LT] = ACTIONS(2981),
    [anon_sym_GT_GT] = ACTIONS(2981),
    [anon_sym_GT_GT_GT] = ACTIONS(2981),
    [anon_sym_AMP_CARET] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(2981),
    [anon_sym_PIPE_PIPE] = ACTIONS(2981),
    [anon_sym_or] = ACTIONS(2981),
    [sym_none] = ACTIONS(2981),
    [sym_true] = ACTIONS(2981),
    [sym_false] = ACTIONS(2981),
    [sym_nil] = ACTIONS(2981),
    [anon_sym_QMARK_DOT] = ACTIONS(2981),
    [anon_sym_POUND_LBRACK] = ACTIONS(2981),
    [anon_sym_if] = ACTIONS(2981),
    [anon_sym_DOLLARif] = ACTIONS(2981),
    [anon_sym_is] = ACTIONS(2981),
    [anon_sym_BANGis] = ACTIONS(2981),
    [anon_sym_in] = ACTIONS(2981),
    [anon_sym_BANGin] = ACTIONS(2981),
    [anon_sym_match] = ACTIONS(2981),
    [anon_sym_select] = ACTIONS(2981),
    [anon_sym_lock] = ACTIONS(2981),
    [anon_sym_rlock] = ACTIONS(2981),
    [anon_sym_unsafe] = ACTIONS(2981),
    [anon_sym_sql] = ACTIONS(2981),
    [sym_int_literal] = ACTIONS(2981),
    [sym_float_literal] = ACTIONS(2981),
    [sym_rune_literal] = ACTIONS(2981),
    [anon_sym_SQUOTE] = ACTIONS(2981),
    [anon_sym_DQUOTE] = ACTIONS(2981),
    [anon_sym_c_SQUOTE] = ACTIONS(2981),
    [anon_sym_c_DQUOTE] = ACTIONS(2981),
    [anon_sym_r_SQUOTE] = ACTIONS(2981),
    [anon_sym_r_DQUOTE] = ACTIONS(2981),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2981),
    [anon_sym_shared] = ACTIONS(2981),
    [anon_sym_map_LBRACK] = ACTIONS(2981),
    [anon_sym_chan] = ACTIONS(2981),
    [anon_sym_thread] = ACTIONS(2981),
    [anon_sym_atomic] = ACTIONS(2981),
  },
  [1448] = {
    [sym_line_comment] = STATE(1448),
    [sym_block_comment] = STATE(1448),
    [sym_identifier] = ACTIONS(2925),
    [anon_sym_LF] = ACTIONS(2925),
    [anon_sym_CR] = ACTIONS(2925),
    [anon_sym_CR_LF] = ACTIONS(2925),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2925),
    [anon_sym_DOT] = ACTIONS(2925),
    [anon_sym_as] = ACTIONS(2925),
    [anon_sym_LBRACE] = ACTIONS(2925),
    [anon_sym_COMMA] = ACTIONS(2925),
    [anon_sym_RBRACE] = ACTIONS(2925),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_RPAREN] = ACTIONS(2925),
    [anon_sym_fn] = ACTIONS(2925),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_STAR] = ACTIONS(2925),
    [anon_sym_SLASH] = ACTIONS(2925),
    [anon_sym_PERCENT] = ACTIONS(2925),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_GT] = ACTIONS(2925),
    [anon_sym_EQ_EQ] = ACTIONS(2925),
    [anon_sym_BANG_EQ] = ACTIONS(2925),
    [anon_sym_LT_EQ] = ACTIONS(2925),
    [anon_sym_GT_EQ] = ACTIONS(2925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2925),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_struct] = ACTIONS(2925),
    [anon_sym_mut] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2925),
    [anon_sym_DASH_DASH] = ACTIONS(2925),
    [anon_sym_QMARK] = ACTIONS(2925),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_go] = ACTIONS(2925),
    [anon_sym_spawn] = ACTIONS(2925),
    [anon_sym_json_DOTdecode] = ACTIONS(2925),
    [anon_sym_PIPE] = ACTIONS(2925),
    [anon_sym_LBRACK2] = ACTIONS(2925),
    [anon_sym_TILDE] = ACTIONS(2925),
    [anon_sym_CARET] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym_LT_DASH] = ACTIONS(2925),
    [anon_sym_LT_LT] = ACTIONS(2925),
    [anon_sym_GT_GT] = ACTIONS(2925),
    [anon_sym_GT_GT_GT] = ACTIONS(2925),
    [anon_sym_AMP_CARET] = ACTIONS(2925),
    [anon_sym_AMP_AMP] = ACTIONS(2925),
    [anon_sym_PIPE_PIPE] = ACTIONS(2925),
    [anon_sym_or] = ACTIONS(2925),
    [sym_none] = ACTIONS(2925),
    [sym_true] = ACTIONS(2925),
    [sym_false] = ACTIONS(2925),
    [sym_nil] = ACTIONS(2925),
    [anon_sym_QMARK_DOT] = ACTIONS(2925),
    [anon_sym_POUND_LBRACK] = ACTIONS(2925),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_DOLLARif] = ACTIONS(2925),
    [anon_sym_is] = ACTIONS(2925),
    [anon_sym_BANGis] = ACTIONS(2925),
    [anon_sym_in] = ACTIONS(2925),
    [anon_sym_BANGin] = ACTIONS(2925),
    [anon_sym_match] = ACTIONS(2925),
    [anon_sym_select] = ACTIONS(2925),
    [anon_sym_lock] = ACTIONS(2925),
    [anon_sym_rlock] = ACTIONS(2925),
    [anon_sym_unsafe] = ACTIONS(2925),
    [anon_sym_sql] = ACTIONS(2925),
    [sym_int_literal] = ACTIONS(2925),
    [sym_float_literal] = ACTIONS(2925),
    [sym_rune_literal] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2925),
    [anon_sym_DQUOTE] = ACTIONS(2925),
    [anon_sym_c_SQUOTE] = ACTIONS(2925),
    [anon_sym_c_DQUOTE] = ACTIONS(2925),
    [anon_sym_r_SQUOTE] = ACTIONS(2925),
    [anon_sym_r_DQUOTE] = ACTIONS(2925),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2925),
    [anon_sym_shared] = ACTIONS(2925),
    [anon_sym_map_LBRACK] = ACTIONS(2925),
    [anon_sym_chan] = ACTIONS(2925),
    [anon_sym_thread] = ACTIONS(2925),
    [anon_sym_atomic] = ACTIONS(2925),
  },
  [1449] = {
    [sym_line_comment] = STATE(1449),
    [sym_block_comment] = STATE(1449),
    [sym_reference_expression] = STATE(4465),
    [sym_type_reference_expression] = STATE(2019),
    [sym_plain_type] = STATE(2041),
    [sym__plain_type_without_special] = STATE(2052),
    [sym_anon_struct_type] = STATE(2051),
    [sym_multi_return_type] = STATE(2052),
    [sym_result_type] = STATE(2052),
    [sym_option_type] = STATE(2052),
    [sym_qualified_type] = STATE(2019),
    [sym_fixed_array_type] = STATE(2051),
    [sym_array_type] = STATE(2051),
    [sym_pointer_type] = STATE(2051),
    [sym_wrong_pointer_type] = STATE(2051),
    [sym_map_type] = STATE(2051),
    [sym_channel_type] = STATE(2051),
    [sym_shared_type] = STATE(2051),
    [sym_thread_type] = STATE(2051),
    [sym_atomic_type] = STATE(2051),
    [sym_generic_type] = STATE(2051),
    [sym_function_type] = STATE(2051),
    [sym_identifier] = ACTIONS(4150),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(817),
    [anon_sym_DOT] = ACTIONS(817),
    [anon_sym_as] = ACTIONS(821),
    [anon_sym_LBRACE] = ACTIONS(817),
    [anon_sym_COMMA] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(4152),
    [anon_sym_EQ] = ACTIONS(821),
    [anon_sym_fn] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(821),
    [anon_sym_DASH] = ACTIONS(821),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(821),
    [anon_sym_PERCENT] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(821),
    [anon_sym_GT] = ACTIONS(821),
    [anon_sym_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(817),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_LBRACK] = ACTIONS(817),
    [anon_sym_struct] = ACTIONS(4158),
    [anon_sym_PLUS_PLUS] = ACTIONS(817),
    [anon_sym_DASH_DASH] = ACTIONS(817),
    [anon_sym_QMARK] = ACTIONS(4160),
    [anon_sym_BANG] = ACTIONS(4162),
    [anon_sym_PIPE] = ACTIONS(821),
    [anon_sym_LBRACK2] = ACTIONS(4164),
    [anon_sym_CARET] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(4166),
    [anon_sym_LT_LT] = ACTIONS(821),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_GT_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_CARET] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_or] = ACTIONS(821),
    [anon_sym_QMARK_DOT] = ACTIONS(817),
    [anon_sym_POUND_LBRACK] = ACTIONS(817),
    [anon_sym_is] = ACTIONS(821),
    [anon_sym_BANGis] = ACTIONS(817),
    [anon_sym_in] = ACTIONS(821),
    [anon_sym_BANGin] = ACTIONS(817),
    [anon_sym_STAR_EQ] = ACTIONS(817),
    [anon_sym_SLASH_EQ] = ACTIONS(817),
    [anon_sym_PERCENT_EQ] = ACTIONS(817),
    [anon_sym_LT_LT_EQ] = ACTIONS(817),
    [anon_sym_GT_GT_EQ] = ACTIONS(817),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(817),
    [anon_sym_AMP_EQ] = ACTIONS(817),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(817),
    [anon_sym_PLUS_EQ] = ACTIONS(817),
    [anon_sym_DASH_EQ] = ACTIONS(817),
    [anon_sym_PIPE_EQ] = ACTIONS(817),
    [anon_sym_CARET_EQ] = ACTIONS(817),
    [anon_sym_COLON_EQ] = ACTIONS(817),
    [anon_sym_shared] = ACTIONS(4168),
    [anon_sym_map_LBRACK] = ACTIONS(4170),
    [anon_sym_chan] = ACTIONS(4172),
    [anon_sym_thread] = ACTIONS(4174),
    [anon_sym_atomic] = ACTIONS(4176),
  },
  [1450] = {
    [sym_line_comment] = STATE(1450),
    [sym_block_comment] = STATE(1450),
    [sym_identifier] = ACTIONS(2989),
    [anon_sym_LF] = ACTIONS(2989),
    [anon_sym_CR] = ACTIONS(2989),
    [anon_sym_CR_LF] = ACTIONS(2989),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2989),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_as] = ACTIONS(2989),
    [anon_sym_LBRACE] = ACTIONS(2989),
    [anon_sym_COMMA] = ACTIONS(2989),
    [anon_sym_RBRACE] = ACTIONS(2989),
    [anon_sym_LPAREN] = ACTIONS(2989),
    [anon_sym_RPAREN] = ACTIONS(2989),
    [anon_sym_fn] = ACTIONS(2989),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2989),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2989),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_EQ_EQ] = ACTIONS(2989),
    [anon_sym_BANG_EQ] = ACTIONS(2989),
    [anon_sym_LT_EQ] = ACTIONS(2989),
    [anon_sym_GT_EQ] = ACTIONS(2989),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2989),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_struct] = ACTIONS(2989),
    [anon_sym_mut] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2989),
    [anon_sym_DASH_DASH] = ACTIONS(2989),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_go] = ACTIONS(2989),
    [anon_sym_spawn] = ACTIONS(2989),
    [anon_sym_json_DOTdecode] = ACTIONS(2989),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_LBRACK2] = ACTIONS(2989),
    [anon_sym_TILDE] = ACTIONS(2989),
    [anon_sym_CARET] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_LT_DASH] = ACTIONS(2989),
    [anon_sym_LT_LT] = ACTIONS(2989),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2989),
    [anon_sym_AMP_CARET] = ACTIONS(2989),
    [anon_sym_AMP_AMP] = ACTIONS(2989),
    [anon_sym_PIPE_PIPE] = ACTIONS(2989),
    [anon_sym_or] = ACTIONS(2989),
    [sym_none] = ACTIONS(2989),
    [sym_true] = ACTIONS(2989),
    [sym_false] = ACTIONS(2989),
    [sym_nil] = ACTIONS(2989),
    [anon_sym_QMARK_DOT] = ACTIONS(2989),
    [anon_sym_POUND_LBRACK] = ACTIONS(2989),
    [anon_sym_if] = ACTIONS(2989),
    [anon_sym_DOLLARif] = ACTIONS(2989),
    [anon_sym_is] = ACTIONS(2989),
    [anon_sym_BANGis] = ACTIONS(2989),
    [anon_sym_in] = ACTIONS(2989),
    [anon_sym_BANGin] = ACTIONS(2989),
    [anon_sym_match] = ACTIONS(2989),
    [anon_sym_select] = ACTIONS(2989),
    [anon_sym_lock] = ACTIONS(2989),
    [anon_sym_rlock] = ACTIONS(2989),
    [anon_sym_unsafe] = ACTIONS(2989),
    [anon_sym_sql] = ACTIONS(2989),
    [sym_int_literal] = ACTIONS(2989),
    [sym_float_literal] = ACTIONS(2989),
    [sym_rune_literal] = ACTIONS(2989),
    [anon_sym_SQUOTE] = ACTIONS(2989),
    [anon_sym_DQUOTE] = ACTIONS(2989),
    [anon_sym_c_SQUOTE] = ACTIONS(2989),
    [anon_sym_c_DQUOTE] = ACTIONS(2989),
    [anon_sym_r_SQUOTE] = ACTIONS(2989),
    [anon_sym_r_DQUOTE] = ACTIONS(2989),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2989),
    [anon_sym_shared] = ACTIONS(2989),
    [anon_sym_map_LBRACK] = ACTIONS(2989),
    [anon_sym_chan] = ACTIONS(2989),
    [anon_sym_thread] = ACTIONS(2989),
    [anon_sym_atomic] = ACTIONS(2989),
  },
  [1451] = {
    [sym_line_comment] = STATE(1451),
    [sym_block_comment] = STATE(1451),
    [sym_identifier] = ACTIONS(2993),
    [anon_sym_LF] = ACTIONS(2993),
    [anon_sym_CR] = ACTIONS(2993),
    [anon_sym_CR_LF] = ACTIONS(2993),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2993),
    [anon_sym_DOT] = ACTIONS(2993),
    [anon_sym_as] = ACTIONS(2993),
    [anon_sym_LBRACE] = ACTIONS(2993),
    [anon_sym_COMMA] = ACTIONS(2993),
    [anon_sym_RBRACE] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2993),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_fn] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2993),
    [anon_sym_DASH] = ACTIONS(2993),
    [anon_sym_STAR] = ACTIONS(2993),
    [anon_sym_SLASH] = ACTIONS(2993),
    [anon_sym_PERCENT] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(2993),
    [anon_sym_EQ_EQ] = ACTIONS(2993),
    [anon_sym_BANG_EQ] = ACTIONS(2993),
    [anon_sym_LT_EQ] = ACTIONS(2993),
    [anon_sym_GT_EQ] = ACTIONS(2993),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2993),
    [anon_sym_LBRACK] = ACTIONS(2991),
    [anon_sym_struct] = ACTIONS(2993),
    [anon_sym_mut] = ACTIONS(2993),
    [anon_sym_PLUS_PLUS] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2993),
    [anon_sym_QMARK] = ACTIONS(2993),
    [anon_sym_BANG] = ACTIONS(2993),
    [anon_sym_go] = ACTIONS(2993),
    [anon_sym_spawn] = ACTIONS(2993),
    [anon_sym_json_DOTdecode] = ACTIONS(2993),
    [anon_sym_PIPE] = ACTIONS(2993),
    [anon_sym_LBRACK2] = ACTIONS(2993),
    [anon_sym_TILDE] = ACTIONS(2993),
    [anon_sym_CARET] = ACTIONS(2993),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_LT_DASH] = ACTIONS(2993),
    [anon_sym_LT_LT] = ACTIONS(2993),
    [anon_sym_GT_GT] = ACTIONS(2993),
    [anon_sym_GT_GT_GT] = ACTIONS(2993),
    [anon_sym_AMP_CARET] = ACTIONS(2993),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [anon_sym_or] = ACTIONS(2993),
    [sym_none] = ACTIONS(2993),
    [sym_true] = ACTIONS(2993),
    [sym_false] = ACTIONS(2993),
    [sym_nil] = ACTIONS(2993),
    [anon_sym_QMARK_DOT] = ACTIONS(2993),
    [anon_sym_POUND_LBRACK] = ACTIONS(2993),
    [anon_sym_if] = ACTIONS(2993),
    [anon_sym_DOLLARif] = ACTIONS(2993),
    [anon_sym_is] = ACTIONS(2993),
    [anon_sym_BANGis] = ACTIONS(2993),
    [anon_sym_in] = ACTIONS(2993),
    [anon_sym_BANGin] = ACTIONS(2993),
    [anon_sym_match] = ACTIONS(2993),
    [anon_sym_select] = ACTIONS(2993),
    [anon_sym_lock] = ACTIONS(2993),
    [anon_sym_rlock] = ACTIONS(2993),
    [anon_sym_unsafe] = ACTIONS(2993),
    [anon_sym_sql] = ACTIONS(2993),
    [sym_int_literal] = ACTIONS(2993),
    [sym_float_literal] = ACTIONS(2993),
    [sym_rune_literal] = ACTIONS(2993),
    [anon_sym_SQUOTE] = ACTIONS(2993),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [anon_sym_c_SQUOTE] = ACTIONS(2993),
    [anon_sym_c_DQUOTE] = ACTIONS(2993),
    [anon_sym_r_SQUOTE] = ACTIONS(2993),
    [anon_sym_r_DQUOTE] = ACTIONS(2993),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2993),
    [anon_sym_shared] = ACTIONS(2993),
    [anon_sym_map_LBRACK] = ACTIONS(2993),
    [anon_sym_chan] = ACTIONS(2993),
    [anon_sym_thread] = ACTIONS(2993),
    [anon_sym_atomic] = ACTIONS(2993),
  },
  [1452] = {
    [sym_line_comment] = STATE(1452),
    [sym_block_comment] = STATE(1452),
    [sym_identifier] = ACTIONS(2997),
    [anon_sym_LF] = ACTIONS(2997),
    [anon_sym_CR] = ACTIONS(2997),
    [anon_sym_CR_LF] = ACTIONS(2997),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2997),
    [anon_sym_DOT] = ACTIONS(2997),
    [anon_sym_as] = ACTIONS(2997),
    [anon_sym_LBRACE] = ACTIONS(2997),
    [anon_sym_COMMA] = ACTIONS(2997),
    [anon_sym_RBRACE] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(2997),
    [anon_sym_RPAREN] = ACTIONS(2997),
    [anon_sym_fn] = ACTIONS(2997),
    [anon_sym_PLUS] = ACTIONS(2997),
    [anon_sym_DASH] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(2997),
    [anon_sym_SLASH] = ACTIONS(2997),
    [anon_sym_PERCENT] = ACTIONS(2997),
    [anon_sym_LT] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(2997),
    [anon_sym_EQ_EQ] = ACTIONS(2997),
    [anon_sym_BANG_EQ] = ACTIONS(2997),
    [anon_sym_LT_EQ] = ACTIONS(2997),
    [anon_sym_GT_EQ] = ACTIONS(2997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2997),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_struct] = ACTIONS(2997),
    [anon_sym_mut] = ACTIONS(2997),
    [anon_sym_PLUS_PLUS] = ACTIONS(2997),
    [anon_sym_DASH_DASH] = ACTIONS(2997),
    [anon_sym_QMARK] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2997),
    [anon_sym_go] = ACTIONS(2997),
    [anon_sym_spawn] = ACTIONS(2997),
    [anon_sym_json_DOTdecode] = ACTIONS(2997),
    [anon_sym_PIPE] = ACTIONS(2997),
    [anon_sym_LBRACK2] = ACTIONS(2997),
    [anon_sym_TILDE] = ACTIONS(2997),
    [anon_sym_CARET] = ACTIONS(2997),
    [anon_sym_AMP] = ACTIONS(2997),
    [anon_sym_LT_DASH] = ACTIONS(2997),
    [anon_sym_LT_LT] = ACTIONS(2997),
    [anon_sym_GT_GT] = ACTIONS(2997),
    [anon_sym_GT_GT_GT] = ACTIONS(2997),
    [anon_sym_AMP_CARET] = ACTIONS(2997),
    [anon_sym_AMP_AMP] = ACTIONS(2997),
    [anon_sym_PIPE_PIPE] = ACTIONS(2997),
    [anon_sym_or] = ACTIONS(2997),
    [sym_none] = ACTIONS(2997),
    [sym_true] = ACTIONS(2997),
    [sym_false] = ACTIONS(2997),
    [sym_nil] = ACTIONS(2997),
    [anon_sym_QMARK_DOT] = ACTIONS(2997),
    [anon_sym_POUND_LBRACK] = ACTIONS(2997),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_DOLLARif] = ACTIONS(2997),
    [anon_sym_is] = ACTIONS(2997),
    [anon_sym_BANGis] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(2997),
    [anon_sym_BANGin] = ACTIONS(2997),
    [anon_sym_match] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [anon_sym_lock] = ACTIONS(2997),
    [anon_sym_rlock] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(2997),
    [anon_sym_sql] = ACTIONS(2997),
    [sym_int_literal] = ACTIONS(2997),
    [sym_float_literal] = ACTIONS(2997),
    [sym_rune_literal] = ACTIONS(2997),
    [anon_sym_SQUOTE] = ACTIONS(2997),
    [anon_sym_DQUOTE] = ACTIONS(2997),
    [anon_sym_c_SQUOTE] = ACTIONS(2997),
    [anon_sym_c_DQUOTE] = ACTIONS(2997),
    [anon_sym_r_SQUOTE] = ACTIONS(2997),
    [anon_sym_r_DQUOTE] = ACTIONS(2997),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2997),
    [anon_sym_shared] = ACTIONS(2997),
    [anon_sym_map_LBRACK] = ACTIONS(2997),
    [anon_sym_chan] = ACTIONS(2997),
    [anon_sym_thread] = ACTIONS(2997),
    [anon_sym_atomic] = ACTIONS(2997),
  },
  [1453] = {
    [sym_line_comment] = STATE(1453),
    [sym_block_comment] = STATE(1453),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_LF] = ACTIONS(2401),
    [anon_sym_CR] = ACTIONS(2401),
    [anon_sym_CR_LF] = ACTIONS(2401),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2401),
    [anon_sym_DOT] = ACTIONS(2401),
    [anon_sym_as] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(2401),
    [anon_sym_COMMA] = ACTIONS(2401),
    [anon_sym_RBRACE] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2401),
    [anon_sym_RPAREN] = ACTIONS(2401),
    [anon_sym_fn] = ACTIONS(2401),
    [anon_sym_PLUS] = ACTIONS(2401),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_STAR] = ACTIONS(2401),
    [anon_sym_SLASH] = ACTIONS(2401),
    [anon_sym_PERCENT] = ACTIONS(2401),
    [anon_sym_LT] = ACTIONS(2401),
    [anon_sym_GT] = ACTIONS(2401),
    [anon_sym_EQ_EQ] = ACTIONS(2401),
    [anon_sym_BANG_EQ] = ACTIONS(2401),
    [anon_sym_LT_EQ] = ACTIONS(2401),
    [anon_sym_GT_EQ] = ACTIONS(2401),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2401),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_struct] = ACTIONS(2401),
    [anon_sym_mut] = ACTIONS(2401),
    [anon_sym_PLUS_PLUS] = ACTIONS(2401),
    [anon_sym_DASH_DASH] = ACTIONS(2401),
    [anon_sym_QMARK] = ACTIONS(2401),
    [anon_sym_BANG] = ACTIONS(2401),
    [anon_sym_go] = ACTIONS(2401),
    [anon_sym_spawn] = ACTIONS(2401),
    [anon_sym_json_DOTdecode] = ACTIONS(2401),
    [anon_sym_PIPE] = ACTIONS(2401),
    [anon_sym_LBRACK2] = ACTIONS(2401),
    [anon_sym_TILDE] = ACTIONS(2401),
    [anon_sym_CARET] = ACTIONS(2401),
    [anon_sym_AMP] = ACTIONS(2401),
    [anon_sym_LT_DASH] = ACTIONS(2401),
    [anon_sym_LT_LT] = ACTIONS(2401),
    [anon_sym_GT_GT] = ACTIONS(2401),
    [anon_sym_GT_GT_GT] = ACTIONS(2401),
    [anon_sym_AMP_CARET] = ACTIONS(2401),
    [anon_sym_AMP_AMP] = ACTIONS(2401),
    [anon_sym_PIPE_PIPE] = ACTIONS(2401),
    [anon_sym_or] = ACTIONS(2401),
    [sym_none] = ACTIONS(2401),
    [sym_true] = ACTIONS(2401),
    [sym_false] = ACTIONS(2401),
    [sym_nil] = ACTIONS(2401),
    [anon_sym_QMARK_DOT] = ACTIONS(2401),
    [anon_sym_POUND_LBRACK] = ACTIONS(2401),
    [anon_sym_if] = ACTIONS(2401),
    [anon_sym_DOLLARif] = ACTIONS(2401),
    [anon_sym_is] = ACTIONS(2401),
    [anon_sym_BANGis] = ACTIONS(2401),
    [anon_sym_in] = ACTIONS(2401),
    [anon_sym_BANGin] = ACTIONS(2401),
    [anon_sym_match] = ACTIONS(2401),
    [anon_sym_select] = ACTIONS(2401),
    [anon_sym_lock] = ACTIONS(2401),
    [anon_sym_rlock] = ACTIONS(2401),
    [anon_sym_unsafe] = ACTIONS(2401),
    [anon_sym_sql] = ACTIONS(2401),
    [sym_int_literal] = ACTIONS(2401),
    [sym_float_literal] = ACTIONS(2401),
    [sym_rune_literal] = ACTIONS(2401),
    [anon_sym_SQUOTE] = ACTIONS(2401),
    [anon_sym_DQUOTE] = ACTIONS(2401),
    [anon_sym_c_SQUOTE] = ACTIONS(2401),
    [anon_sym_c_DQUOTE] = ACTIONS(2401),
    [anon_sym_r_SQUOTE] = ACTIONS(2401),
    [anon_sym_r_DQUOTE] = ACTIONS(2401),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2401),
    [anon_sym_shared] = ACTIONS(2401),
    [anon_sym_map_LBRACK] = ACTIONS(2401),
    [anon_sym_chan] = ACTIONS(2401),
    [anon_sym_thread] = ACTIONS(2401),
    [anon_sym_atomic] = ACTIONS(2401),
  },
  [1454] = {
    [sym_line_comment] = STATE(1454),
    [sym_block_comment] = STATE(1454),
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_LF] = ACTIONS(3061),
    [anon_sym_CR] = ACTIONS(3061),
    [anon_sym_CR_LF] = ACTIONS(3061),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3061),
    [anon_sym_DOT] = ACTIONS(3061),
    [anon_sym_as] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3061),
    [anon_sym_COMMA] = ACTIONS(3061),
    [anon_sym_RBRACE] = ACTIONS(3061),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_RPAREN] = ACTIONS(3061),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_PLUS] = ACTIONS(3061),
    [anon_sym_DASH] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(3061),
    [anon_sym_SLASH] = ACTIONS(3061),
    [anon_sym_PERCENT] = ACTIONS(3061),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_GT] = ACTIONS(3061),
    [anon_sym_EQ_EQ] = ACTIONS(3061),
    [anon_sym_BANG_EQ] = ACTIONS(3061),
    [anon_sym_LT_EQ] = ACTIONS(3061),
    [anon_sym_GT_EQ] = ACTIONS(3061),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3061),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_struct] = ACTIONS(3061),
    [anon_sym_mut] = ACTIONS(3061),
    [anon_sym_PLUS_PLUS] = ACTIONS(3061),
    [anon_sym_DASH_DASH] = ACTIONS(3061),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_BANG] = ACTIONS(3061),
    [anon_sym_go] = ACTIONS(3061),
    [anon_sym_spawn] = ACTIONS(3061),
    [anon_sym_json_DOTdecode] = ACTIONS(3061),
    [anon_sym_PIPE] = ACTIONS(3061),
    [anon_sym_LBRACK2] = ACTIONS(3061),
    [anon_sym_TILDE] = ACTIONS(3061),
    [anon_sym_CARET] = ACTIONS(3061),
    [anon_sym_AMP] = ACTIONS(3061),
    [anon_sym_LT_DASH] = ACTIONS(3061),
    [anon_sym_LT_LT] = ACTIONS(3061),
    [anon_sym_GT_GT] = ACTIONS(3061),
    [anon_sym_GT_GT_GT] = ACTIONS(3061),
    [anon_sym_AMP_CARET] = ACTIONS(3061),
    [anon_sym_AMP_AMP] = ACTIONS(3061),
    [anon_sym_PIPE_PIPE] = ACTIONS(3061),
    [anon_sym_or] = ACTIONS(3061),
    [sym_none] = ACTIONS(3061),
    [sym_true] = ACTIONS(3061),
    [sym_false] = ACTIONS(3061),
    [sym_nil] = ACTIONS(3061),
    [anon_sym_QMARK_DOT] = ACTIONS(3061),
    [anon_sym_POUND_LBRACK] = ACTIONS(3061),
    [anon_sym_if] = ACTIONS(3061),
    [anon_sym_DOLLARif] = ACTIONS(3061),
    [anon_sym_is] = ACTIONS(3061),
    [anon_sym_BANGis] = ACTIONS(3061),
    [anon_sym_in] = ACTIONS(3061),
    [anon_sym_BANGin] = ACTIONS(3061),
    [anon_sym_match] = ACTIONS(3061),
    [anon_sym_select] = ACTIONS(3061),
    [anon_sym_lock] = ACTIONS(3061),
    [anon_sym_rlock] = ACTIONS(3061),
    [anon_sym_unsafe] = ACTIONS(3061),
    [anon_sym_sql] = ACTIONS(3061),
    [sym_int_literal] = ACTIONS(3061),
    [sym_float_literal] = ACTIONS(3061),
    [sym_rune_literal] = ACTIONS(3061),
    [anon_sym_SQUOTE] = ACTIONS(3061),
    [anon_sym_DQUOTE] = ACTIONS(3061),
    [anon_sym_c_SQUOTE] = ACTIONS(3061),
    [anon_sym_c_DQUOTE] = ACTIONS(3061),
    [anon_sym_r_SQUOTE] = ACTIONS(3061),
    [anon_sym_r_DQUOTE] = ACTIONS(3061),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3061),
    [anon_sym_shared] = ACTIONS(3061),
    [anon_sym_map_LBRACK] = ACTIONS(3061),
    [anon_sym_chan] = ACTIONS(3061),
    [anon_sym_thread] = ACTIONS(3061),
    [anon_sym_atomic] = ACTIONS(3061),
  },
  [1455] = {
    [sym_line_comment] = STATE(1455),
    [sym_block_comment] = STATE(1455),
    [sym_identifier] = ACTIONS(3065),
    [anon_sym_LF] = ACTIONS(3065),
    [anon_sym_CR] = ACTIONS(3065),
    [anon_sym_CR_LF] = ACTIONS(3065),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym_DOT] = ACTIONS(3065),
    [anon_sym_as] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_COMMA] = ACTIONS(3065),
    [anon_sym_RBRACE] = ACTIONS(3065),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_RPAREN] = ACTIONS(3065),
    [anon_sym_fn] = ACTIONS(3065),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_SLASH] = ACTIONS(3065),
    [anon_sym_PERCENT] = ACTIONS(3065),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_GT] = ACTIONS(3065),
    [anon_sym_EQ_EQ] = ACTIONS(3065),
    [anon_sym_BANG_EQ] = ACTIONS(3065),
    [anon_sym_LT_EQ] = ACTIONS(3065),
    [anon_sym_GT_EQ] = ACTIONS(3065),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3065),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3065),
    [anon_sym_mut] = ACTIONS(3065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_QMARK] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_go] = ACTIONS(3065),
    [anon_sym_spawn] = ACTIONS(3065),
    [anon_sym_json_DOTdecode] = ACTIONS(3065),
    [anon_sym_PIPE] = ACTIONS(3065),
    [anon_sym_LBRACK2] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_CARET] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3065),
    [anon_sym_LT_DASH] = ACTIONS(3065),
    [anon_sym_LT_LT] = ACTIONS(3065),
    [anon_sym_GT_GT] = ACTIONS(3065),
    [anon_sym_GT_GT_GT] = ACTIONS(3065),
    [anon_sym_AMP_CARET] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_PIPE_PIPE] = ACTIONS(3065),
    [anon_sym_or] = ACTIONS(3065),
    [sym_none] = ACTIONS(3065),
    [sym_true] = ACTIONS(3065),
    [sym_false] = ACTIONS(3065),
    [sym_nil] = ACTIONS(3065),
    [anon_sym_QMARK_DOT] = ACTIONS(3065),
    [anon_sym_POUND_LBRACK] = ACTIONS(3065),
    [anon_sym_if] = ACTIONS(3065),
    [anon_sym_DOLLARif] = ACTIONS(3065),
    [anon_sym_is] = ACTIONS(3065),
    [anon_sym_BANGis] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3065),
    [anon_sym_BANGin] = ACTIONS(3065),
    [anon_sym_match] = ACTIONS(3065),
    [anon_sym_select] = ACTIONS(3065),
    [anon_sym_lock] = ACTIONS(3065),
    [anon_sym_rlock] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(3065),
    [anon_sym_sql] = ACTIONS(3065),
    [sym_int_literal] = ACTIONS(3065),
    [sym_float_literal] = ACTIONS(3065),
    [sym_rune_literal] = ACTIONS(3065),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [anon_sym_c_SQUOTE] = ACTIONS(3065),
    [anon_sym_c_DQUOTE] = ACTIONS(3065),
    [anon_sym_r_SQUOTE] = ACTIONS(3065),
    [anon_sym_r_DQUOTE] = ACTIONS(3065),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3065),
    [anon_sym_shared] = ACTIONS(3065),
    [anon_sym_map_LBRACK] = ACTIONS(3065),
    [anon_sym_chan] = ACTIONS(3065),
    [anon_sym_thread] = ACTIONS(3065),
    [anon_sym_atomic] = ACTIONS(3065),
  },
  [1456] = {
    [sym_line_comment] = STATE(1456),
    [sym_block_comment] = STATE(1456),
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_LF] = ACTIONS(3073),
    [anon_sym_CR] = ACTIONS(3073),
    [anon_sym_CR_LF] = ACTIONS(3073),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_DOT] = ACTIONS(3073),
    [anon_sym_as] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3073),
    [anon_sym_COMMA] = ACTIONS(3073),
    [anon_sym_RBRACE] = ACTIONS(3073),
    [anon_sym_LPAREN] = ACTIONS(3073),
    [anon_sym_RPAREN] = ACTIONS(3073),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(3073),
    [anon_sym_DASH] = ACTIONS(3073),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_SLASH] = ACTIONS(3073),
    [anon_sym_PERCENT] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_GT] = ACTIONS(3073),
    [anon_sym_EQ_EQ] = ACTIONS(3073),
    [anon_sym_BANG_EQ] = ACTIONS(3073),
    [anon_sym_LT_EQ] = ACTIONS(3073),
    [anon_sym_GT_EQ] = ACTIONS(3073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3073),
    [anon_sym_mut] = ACTIONS(3073),
    [anon_sym_PLUS_PLUS] = ACTIONS(3073),
    [anon_sym_DASH_DASH] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3073),
    [anon_sym_BANG] = ACTIONS(3073),
    [anon_sym_go] = ACTIONS(3073),
    [anon_sym_spawn] = ACTIONS(3073),
    [anon_sym_json_DOTdecode] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(3073),
    [anon_sym_LBRACK2] = ACTIONS(3073),
    [anon_sym_TILDE] = ACTIONS(3073),
    [anon_sym_CARET] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3073),
    [anon_sym_LT_DASH] = ACTIONS(3073),
    [anon_sym_LT_LT] = ACTIONS(3073),
    [anon_sym_GT_GT] = ACTIONS(3073),
    [anon_sym_GT_GT_GT] = ACTIONS(3073),
    [anon_sym_AMP_CARET] = ACTIONS(3073),
    [anon_sym_AMP_AMP] = ACTIONS(3073),
    [anon_sym_PIPE_PIPE] = ACTIONS(3073),
    [anon_sym_or] = ACTIONS(3073),
    [sym_none] = ACTIONS(3073),
    [sym_true] = ACTIONS(3073),
    [sym_false] = ACTIONS(3073),
    [sym_nil] = ACTIONS(3073),
    [anon_sym_QMARK_DOT] = ACTIONS(3073),
    [anon_sym_POUND_LBRACK] = ACTIONS(3073),
    [anon_sym_if] = ACTIONS(3073),
    [anon_sym_DOLLARif] = ACTIONS(3073),
    [anon_sym_is] = ACTIONS(3073),
    [anon_sym_BANGis] = ACTIONS(3073),
    [anon_sym_in] = ACTIONS(3073),
    [anon_sym_BANGin] = ACTIONS(3073),
    [anon_sym_match] = ACTIONS(3073),
    [anon_sym_select] = ACTIONS(3073),
    [anon_sym_lock] = ACTIONS(3073),
    [anon_sym_rlock] = ACTIONS(3073),
    [anon_sym_unsafe] = ACTIONS(3073),
    [anon_sym_sql] = ACTIONS(3073),
    [sym_int_literal] = ACTIONS(3073),
    [sym_float_literal] = ACTIONS(3073),
    [sym_rune_literal] = ACTIONS(3073),
    [anon_sym_SQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE] = ACTIONS(3073),
    [anon_sym_c_SQUOTE] = ACTIONS(3073),
    [anon_sym_c_DQUOTE] = ACTIONS(3073),
    [anon_sym_r_SQUOTE] = ACTIONS(3073),
    [anon_sym_r_DQUOTE] = ACTIONS(3073),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3073),
    [anon_sym_shared] = ACTIONS(3073),
    [anon_sym_map_LBRACK] = ACTIONS(3073),
    [anon_sym_chan] = ACTIONS(3073),
    [anon_sym_thread] = ACTIONS(3073),
    [anon_sym_atomic] = ACTIONS(3073),
  },
  [1457] = {
    [sym_line_comment] = STATE(1457),
    [sym_block_comment] = STATE(1457),
    [sym_identifier] = ACTIONS(3001),
    [anon_sym_LF] = ACTIONS(3001),
    [anon_sym_CR] = ACTIONS(3001),
    [anon_sym_CR_LF] = ACTIONS(3001),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3001),
    [anon_sym_DOT] = ACTIONS(3001),
    [anon_sym_as] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_COMMA] = ACTIONS(3001),
    [anon_sym_RBRACE] = ACTIONS(3001),
    [anon_sym_LPAREN] = ACTIONS(3001),
    [anon_sym_RPAREN] = ACTIONS(3001),
    [anon_sym_fn] = ACTIONS(3001),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_STAR] = ACTIONS(3001),
    [anon_sym_SLASH] = ACTIONS(3001),
    [anon_sym_PERCENT] = ACTIONS(3001),
    [anon_sym_LT] = ACTIONS(3001),
    [anon_sym_GT] = ACTIONS(3001),
    [anon_sym_EQ_EQ] = ACTIONS(3001),
    [anon_sym_BANG_EQ] = ACTIONS(3001),
    [anon_sym_LT_EQ] = ACTIONS(3001),
    [anon_sym_GT_EQ] = ACTIONS(3001),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3001),
    [anon_sym_LBRACK] = ACTIONS(2999),
    [anon_sym_struct] = ACTIONS(3001),
    [anon_sym_mut] = ACTIONS(3001),
    [anon_sym_PLUS_PLUS] = ACTIONS(3001),
    [anon_sym_DASH_DASH] = ACTIONS(3001),
    [anon_sym_QMARK] = ACTIONS(3001),
    [anon_sym_BANG] = ACTIONS(3001),
    [anon_sym_go] = ACTIONS(3001),
    [anon_sym_spawn] = ACTIONS(3001),
    [anon_sym_json_DOTdecode] = ACTIONS(3001),
    [anon_sym_PIPE] = ACTIONS(3001),
    [anon_sym_LBRACK2] = ACTIONS(3001),
    [anon_sym_TILDE] = ACTIONS(3001),
    [anon_sym_CARET] = ACTIONS(3001),
    [anon_sym_AMP] = ACTIONS(3001),
    [anon_sym_LT_DASH] = ACTIONS(3001),
    [anon_sym_LT_LT] = ACTIONS(3001),
    [anon_sym_GT_GT] = ACTIONS(3001),
    [anon_sym_GT_GT_GT] = ACTIONS(3001),
    [anon_sym_AMP_CARET] = ACTIONS(3001),
    [anon_sym_AMP_AMP] = ACTIONS(3001),
    [anon_sym_PIPE_PIPE] = ACTIONS(3001),
    [anon_sym_or] = ACTIONS(3001),
    [sym_none] = ACTIONS(3001),
    [sym_true] = ACTIONS(3001),
    [sym_false] = ACTIONS(3001),
    [sym_nil] = ACTIONS(3001),
    [anon_sym_QMARK_DOT] = ACTIONS(3001),
    [anon_sym_POUND_LBRACK] = ACTIONS(3001),
    [anon_sym_if] = ACTIONS(3001),
    [anon_sym_DOLLARif] = ACTIONS(3001),
    [anon_sym_is] = ACTIONS(3001),
    [anon_sym_BANGis] = ACTIONS(3001),
    [anon_sym_in] = ACTIONS(3001),
    [anon_sym_BANGin] = ACTIONS(3001),
    [anon_sym_match] = ACTIONS(3001),
    [anon_sym_select] = ACTIONS(3001),
    [anon_sym_lock] = ACTIONS(3001),
    [anon_sym_rlock] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(3001),
    [anon_sym_sql] = ACTIONS(3001),
    [sym_int_literal] = ACTIONS(3001),
    [sym_float_literal] = ACTIONS(3001),
    [sym_rune_literal] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3001),
    [anon_sym_DQUOTE] = ACTIONS(3001),
    [anon_sym_c_SQUOTE] = ACTIONS(3001),
    [anon_sym_c_DQUOTE] = ACTIONS(3001),
    [anon_sym_r_SQUOTE] = ACTIONS(3001),
    [anon_sym_r_DQUOTE] = ACTIONS(3001),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3001),
    [anon_sym_shared] = ACTIONS(3001),
    [anon_sym_map_LBRACK] = ACTIONS(3001),
    [anon_sym_chan] = ACTIONS(3001),
    [anon_sym_thread] = ACTIONS(3001),
    [anon_sym_atomic] = ACTIONS(3001),
  },
  [1458] = {
    [sym_line_comment] = STATE(1458),
    [sym_block_comment] = STATE(1458),
    [sym_identifier] = ACTIONS(2977),
    [anon_sym_LF] = ACTIONS(2977),
    [anon_sym_CR] = ACTIONS(2977),
    [anon_sym_CR_LF] = ACTIONS(2977),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2977),
    [anon_sym_DOT] = ACTIONS(2977),
    [anon_sym_as] = ACTIONS(2977),
    [anon_sym_LBRACE] = ACTIONS(2977),
    [anon_sym_COMMA] = ACTIONS(2977),
    [anon_sym_RBRACE] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(2977),
    [anon_sym_RPAREN] = ACTIONS(2977),
    [anon_sym_fn] = ACTIONS(2977),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_PERCENT] = ACTIONS(2977),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_EQ_EQ] = ACTIONS(2977),
    [anon_sym_BANG_EQ] = ACTIONS(2977),
    [anon_sym_LT_EQ] = ACTIONS(2977),
    [anon_sym_GT_EQ] = ACTIONS(2977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(2975),
    [anon_sym_struct] = ACTIONS(2977),
    [anon_sym_mut] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2977),
    [anon_sym_DASH_DASH] = ACTIONS(2977),
    [anon_sym_QMARK] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_go] = ACTIONS(2977),
    [anon_sym_spawn] = ACTIONS(2977),
    [anon_sym_json_DOTdecode] = ACTIONS(2977),
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_LBRACK2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2977),
    [anon_sym_CARET] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_LT_DASH] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2977),
    [anon_sym_GT_GT] = ACTIONS(2977),
    [anon_sym_GT_GT_GT] = ACTIONS(2977),
    [anon_sym_AMP_CARET] = ACTIONS(2977),
    [anon_sym_AMP_AMP] = ACTIONS(2977),
    [anon_sym_PIPE_PIPE] = ACTIONS(2977),
    [anon_sym_or] = ACTIONS(2977),
    [sym_none] = ACTIONS(2977),
    [sym_true] = ACTIONS(2977),
    [sym_false] = ACTIONS(2977),
    [sym_nil] = ACTIONS(2977),
    [anon_sym_QMARK_DOT] = ACTIONS(2977),
    [anon_sym_POUND_LBRACK] = ACTIONS(2977),
    [anon_sym_if] = ACTIONS(2977),
    [anon_sym_DOLLARif] = ACTIONS(2977),
    [anon_sym_is] = ACTIONS(2977),
    [anon_sym_BANGis] = ACTIONS(2977),
    [anon_sym_in] = ACTIONS(2977),
    [anon_sym_BANGin] = ACTIONS(2977),
    [anon_sym_match] = ACTIONS(2977),
    [anon_sym_select] = ACTIONS(2977),
    [anon_sym_lock] = ACTIONS(2977),
    [anon_sym_rlock] = ACTIONS(2977),
    [anon_sym_unsafe] = ACTIONS(2977),
    [anon_sym_sql] = ACTIONS(2977),
    [sym_int_literal] = ACTIONS(2977),
    [sym_float_literal] = ACTIONS(2977),
    [sym_rune_literal] = ACTIONS(2977),
    [anon_sym_SQUOTE] = ACTIONS(2977),
    [anon_sym_DQUOTE] = ACTIONS(2977),
    [anon_sym_c_SQUOTE] = ACTIONS(2977),
    [anon_sym_c_DQUOTE] = ACTIONS(2977),
    [anon_sym_r_SQUOTE] = ACTIONS(2977),
    [anon_sym_r_DQUOTE] = ACTIONS(2977),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2977),
    [anon_sym_shared] = ACTIONS(2977),
    [anon_sym_map_LBRACK] = ACTIONS(2977),
    [anon_sym_chan] = ACTIONS(2977),
    [anon_sym_thread] = ACTIONS(2977),
    [anon_sym_atomic] = ACTIONS(2977),
  },
  [1459] = {
    [sym_line_comment] = STATE(1459),
    [sym_block_comment] = STATE(1459),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LF] = ACTIONS(2453),
    [anon_sym_CR] = ACTIONS(2453),
    [anon_sym_CR_LF] = ACTIONS(2453),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2453),
    [anon_sym_DOT] = ACTIONS(2453),
    [anon_sym_as] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [anon_sym_COMMA] = ACTIONS(2453),
    [anon_sym_RBRACE] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_RPAREN] = ACTIONS(2453),
    [anon_sym_fn] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2453),
    [anon_sym_SLASH] = ACTIONS(2453),
    [anon_sym_PERCENT] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2453),
    [anon_sym_EQ_EQ] = ACTIONS(2453),
    [anon_sym_BANG_EQ] = ACTIONS(2453),
    [anon_sym_LT_EQ] = ACTIONS(2453),
    [anon_sym_GT_EQ] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2451),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_mut] = ACTIONS(2453),
    [anon_sym_PLUS_PLUS] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2453),
    [anon_sym_QMARK] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(2453),
    [anon_sym_go] = ACTIONS(2453),
    [anon_sym_spawn] = ACTIONS(2453),
    [anon_sym_json_DOTdecode] = ACTIONS(2453),
    [anon_sym_PIPE] = ACTIONS(2453),
    [anon_sym_LBRACK2] = ACTIONS(2453),
    [anon_sym_TILDE] = ACTIONS(2453),
    [anon_sym_CARET] = ACTIONS(2453),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_LT_DASH] = ACTIONS(2453),
    [anon_sym_LT_LT] = ACTIONS(2453),
    [anon_sym_GT_GT] = ACTIONS(2453),
    [anon_sym_GT_GT_GT] = ACTIONS(2453),
    [anon_sym_AMP_CARET] = ACTIONS(2453),
    [anon_sym_AMP_AMP] = ACTIONS(2453),
    [anon_sym_PIPE_PIPE] = ACTIONS(2453),
    [anon_sym_or] = ACTIONS(2453),
    [sym_none] = ACTIONS(2453),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [sym_nil] = ACTIONS(2453),
    [anon_sym_QMARK_DOT] = ACTIONS(2453),
    [anon_sym_POUND_LBRACK] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_DOLLARif] = ACTIONS(2453),
    [anon_sym_is] = ACTIONS(2453),
    [anon_sym_BANGis] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_BANGin] = ACTIONS(2453),
    [anon_sym_match] = ACTIONS(2453),
    [anon_sym_select] = ACTIONS(2453),
    [anon_sym_lock] = ACTIONS(2453),
    [anon_sym_rlock] = ACTIONS(2453),
    [anon_sym_unsafe] = ACTIONS(2453),
    [anon_sym_sql] = ACTIONS(2453),
    [sym_int_literal] = ACTIONS(2453),
    [sym_float_literal] = ACTIONS(2453),
    [sym_rune_literal] = ACTIONS(2453),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2453),
    [anon_sym_c_SQUOTE] = ACTIONS(2453),
    [anon_sym_c_DQUOTE] = ACTIONS(2453),
    [anon_sym_r_SQUOTE] = ACTIONS(2453),
    [anon_sym_r_DQUOTE] = ACTIONS(2453),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_map_LBRACK] = ACTIONS(2453),
    [anon_sym_chan] = ACTIONS(2453),
    [anon_sym_thread] = ACTIONS(2453),
    [anon_sym_atomic] = ACTIONS(2453),
  },
  [1460] = {
    [sym_line_comment] = STATE(1460),
    [sym_block_comment] = STATE(1460),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_LF] = ACTIONS(3027),
    [anon_sym_CR] = ACTIONS(3027),
    [anon_sym_CR_LF] = ACTIONS(3027),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3027),
    [anon_sym_DOT] = ACTIONS(3027),
    [anon_sym_as] = ACTIONS(3027),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_COMMA] = ACTIONS(3027),
    [anon_sym_RBRACE] = ACTIONS(3027),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym_RPAREN] = ACTIONS(3027),
    [anon_sym_fn] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_STAR] = ACTIONS(3027),
    [anon_sym_SLASH] = ACTIONS(3027),
    [anon_sym_PERCENT] = ACTIONS(3027),
    [anon_sym_LT] = ACTIONS(3027),
    [anon_sym_GT] = ACTIONS(3027),
    [anon_sym_EQ_EQ] = ACTIONS(3027),
    [anon_sym_BANG_EQ] = ACTIONS(3027),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3025),
    [anon_sym_struct] = ACTIONS(3027),
    [anon_sym_mut] = ACTIONS(3027),
    [anon_sym_PLUS_PLUS] = ACTIONS(3027),
    [anon_sym_DASH_DASH] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_BANG] = ACTIONS(3027),
    [anon_sym_go] = ACTIONS(3027),
    [anon_sym_spawn] = ACTIONS(3027),
    [anon_sym_json_DOTdecode] = ACTIONS(3027),
    [anon_sym_PIPE] = ACTIONS(3027),
    [anon_sym_LBRACK2] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3027),
    [anon_sym_CARET] = ACTIONS(3027),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_LT_DASH] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3027),
    [anon_sym_GT_GT] = ACTIONS(3027),
    [anon_sym_GT_GT_GT] = ACTIONS(3027),
    [anon_sym_AMP_CARET] = ACTIONS(3027),
    [anon_sym_AMP_AMP] = ACTIONS(3027),
    [anon_sym_PIPE_PIPE] = ACTIONS(3027),
    [anon_sym_or] = ACTIONS(3027),
    [sym_none] = ACTIONS(3027),
    [sym_true] = ACTIONS(3027),
    [sym_false] = ACTIONS(3027),
    [sym_nil] = ACTIONS(3027),
    [anon_sym_QMARK_DOT] = ACTIONS(3027),
    [anon_sym_POUND_LBRACK] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_DOLLARif] = ACTIONS(3027),
    [anon_sym_is] = ACTIONS(3027),
    [anon_sym_BANGis] = ACTIONS(3027),
    [anon_sym_in] = ACTIONS(3027),
    [anon_sym_BANGin] = ACTIONS(3027),
    [anon_sym_match] = ACTIONS(3027),
    [anon_sym_select] = ACTIONS(3027),
    [anon_sym_lock] = ACTIONS(3027),
    [anon_sym_rlock] = ACTIONS(3027),
    [anon_sym_unsafe] = ACTIONS(3027),
    [anon_sym_sql] = ACTIONS(3027),
    [sym_int_literal] = ACTIONS(3027),
    [sym_float_literal] = ACTIONS(3027),
    [sym_rune_literal] = ACTIONS(3027),
    [anon_sym_SQUOTE] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_c_SQUOTE] = ACTIONS(3027),
    [anon_sym_c_DQUOTE] = ACTIONS(3027),
    [anon_sym_r_SQUOTE] = ACTIONS(3027),
    [anon_sym_r_DQUOTE] = ACTIONS(3027),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3027),
    [anon_sym_shared] = ACTIONS(3027),
    [anon_sym_map_LBRACK] = ACTIONS(3027),
    [anon_sym_chan] = ACTIONS(3027),
    [anon_sym_thread] = ACTIONS(3027),
    [anon_sym_atomic] = ACTIONS(3027),
  },
  [1461] = {
    [sym_line_comment] = STATE(1461),
    [sym_block_comment] = STATE(1461),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_LF] = ACTIONS(3031),
    [anon_sym_CR] = ACTIONS(3031),
    [anon_sym_CR_LF] = ACTIONS(3031),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3031),
    [anon_sym_DOT] = ACTIONS(3031),
    [anon_sym_as] = ACTIONS(3031),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_COMMA] = ACTIONS(3031),
    [anon_sym_RBRACE] = ACTIONS(3031),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym_RPAREN] = ACTIONS(3031),
    [anon_sym_fn] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_STAR] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3031),
    [anon_sym_PERCENT] = ACTIONS(3031),
    [anon_sym_LT] = ACTIONS(3031),
    [anon_sym_GT] = ACTIONS(3031),
    [anon_sym_EQ_EQ] = ACTIONS(3031),
    [anon_sym_BANG_EQ] = ACTIONS(3031),
    [anon_sym_LT_EQ] = ACTIONS(3031),
    [anon_sym_GT_EQ] = ACTIONS(3031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3029),
    [anon_sym_struct] = ACTIONS(3031),
    [anon_sym_mut] = ACTIONS(3031),
    [anon_sym_PLUS_PLUS] = ACTIONS(3031),
    [anon_sym_DASH_DASH] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_BANG] = ACTIONS(3031),
    [anon_sym_go] = ACTIONS(3031),
    [anon_sym_spawn] = ACTIONS(3031),
    [anon_sym_json_DOTdecode] = ACTIONS(3031),
    [anon_sym_PIPE] = ACTIONS(3031),
    [anon_sym_LBRACK2] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3031),
    [anon_sym_CARET] = ACTIONS(3031),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_LT_DASH] = ACTIONS(3031),
    [anon_sym_LT_LT] = ACTIONS(3031),
    [anon_sym_GT_GT] = ACTIONS(3031),
    [anon_sym_GT_GT_GT] = ACTIONS(3031),
    [anon_sym_AMP_CARET] = ACTIONS(3031),
    [anon_sym_AMP_AMP] = ACTIONS(3031),
    [anon_sym_PIPE_PIPE] = ACTIONS(3031),
    [anon_sym_or] = ACTIONS(3031),
    [sym_none] = ACTIONS(3031),
    [sym_true] = ACTIONS(3031),
    [sym_false] = ACTIONS(3031),
    [sym_nil] = ACTIONS(3031),
    [anon_sym_QMARK_DOT] = ACTIONS(3031),
    [anon_sym_POUND_LBRACK] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_DOLLARif] = ACTIONS(3031),
    [anon_sym_is] = ACTIONS(3031),
    [anon_sym_BANGis] = ACTIONS(3031),
    [anon_sym_in] = ACTIONS(3031),
    [anon_sym_BANGin] = ACTIONS(3031),
    [anon_sym_match] = ACTIONS(3031),
    [anon_sym_select] = ACTIONS(3031),
    [anon_sym_lock] = ACTIONS(3031),
    [anon_sym_rlock] = ACTIONS(3031),
    [anon_sym_unsafe] = ACTIONS(3031),
    [anon_sym_sql] = ACTIONS(3031),
    [sym_int_literal] = ACTIONS(3031),
    [sym_float_literal] = ACTIONS(3031),
    [sym_rune_literal] = ACTIONS(3031),
    [anon_sym_SQUOTE] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_c_SQUOTE] = ACTIONS(3031),
    [anon_sym_c_DQUOTE] = ACTIONS(3031),
    [anon_sym_r_SQUOTE] = ACTIONS(3031),
    [anon_sym_r_DQUOTE] = ACTIONS(3031),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3031),
    [anon_sym_shared] = ACTIONS(3031),
    [anon_sym_map_LBRACK] = ACTIONS(3031),
    [anon_sym_chan] = ACTIONS(3031),
    [anon_sym_thread] = ACTIONS(3031),
    [anon_sym_atomic] = ACTIONS(3031),
  },
  [1462] = {
    [sym_line_comment] = STATE(1462),
    [sym_block_comment] = STATE(1462),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2458),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(861),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_as] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(861),
    [anon_sym_COMMA] = ACTIONS(861),
    [anon_sym_LPAREN] = ACTIONS(3968),
    [anon_sym_EQ] = ACTIONS(865),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_STAR] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_PERCENT] = ACTIONS(865),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(861),
    [anon_sym_BANG_EQ] = ACTIONS(861),
    [anon_sym_LT_EQ] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_PLUS_PLUS] = ACTIONS(861),
    [anon_sym_DASH_DASH] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(4188),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_LBRACK2] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(865),
    [anon_sym_GT_GT] = ACTIONS(865),
    [anon_sym_GT_GT_GT] = ACTIONS(865),
    [anon_sym_AMP_CARET] = ACTIONS(865),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_QMARK_DOT] = ACTIONS(861),
    [anon_sym_POUND_LBRACK] = ACTIONS(861),
    [anon_sym_is] = ACTIONS(865),
    [anon_sym_BANGis] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(865),
    [anon_sym_BANGin] = ACTIONS(861),
    [anon_sym_STAR_EQ] = ACTIONS(861),
    [anon_sym_SLASH_EQ] = ACTIONS(861),
    [anon_sym_PERCENT_EQ] = ACTIONS(861),
    [anon_sym_LT_LT_EQ] = ACTIONS(861),
    [anon_sym_GT_GT_EQ] = ACTIONS(861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(861),
    [anon_sym_AMP_EQ] = ACTIONS(861),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(861),
    [anon_sym_PLUS_EQ] = ACTIONS(861),
    [anon_sym_DASH_EQ] = ACTIONS(861),
    [anon_sym_PIPE_EQ] = ACTIONS(861),
    [anon_sym_CARET_EQ] = ACTIONS(861),
    [anon_sym_COLON_EQ] = ACTIONS(861),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [1463] = {
    [sym_line_comment] = STATE(1463),
    [sym_block_comment] = STATE(1463),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_LF] = ACTIONS(3007),
    [anon_sym_CR] = ACTIONS(3007),
    [anon_sym_CR_LF] = ACTIONS(3007),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3007),
    [anon_sym_DOT] = ACTIONS(3007),
    [anon_sym_as] = ACTIONS(3007),
    [anon_sym_LBRACE] = ACTIONS(3007),
    [anon_sym_COMMA] = ACTIONS(3007),
    [anon_sym_RBRACE] = ACTIONS(3007),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3007),
    [anon_sym_fn] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_STAR] = ACTIONS(3007),
    [anon_sym_SLASH] = ACTIONS(3007),
    [anon_sym_PERCENT] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(3007),
    [anon_sym_GT] = ACTIONS(3007),
    [anon_sym_EQ_EQ] = ACTIONS(3007),
    [anon_sym_BANG_EQ] = ACTIONS(3007),
    [anon_sym_LT_EQ] = ACTIONS(3007),
    [anon_sym_GT_EQ] = ACTIONS(3007),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3005),
    [anon_sym_struct] = ACTIONS(3007),
    [anon_sym_mut] = ACTIONS(3007),
    [anon_sym_PLUS_PLUS] = ACTIONS(3007),
    [anon_sym_DASH_DASH] = ACTIONS(3007),
    [anon_sym_QMARK] = ACTIONS(3007),
    [anon_sym_BANG] = ACTIONS(3007),
    [anon_sym_go] = ACTIONS(3007),
    [anon_sym_spawn] = ACTIONS(3007),
    [anon_sym_json_DOTdecode] = ACTIONS(3007),
    [anon_sym_PIPE] = ACTIONS(3007),
    [anon_sym_LBRACK2] = ACTIONS(3007),
    [anon_sym_TILDE] = ACTIONS(3007),
    [anon_sym_CARET] = ACTIONS(3007),
    [anon_sym_AMP] = ACTIONS(3007),
    [anon_sym_LT_DASH] = ACTIONS(3007),
    [anon_sym_LT_LT] = ACTIONS(3007),
    [anon_sym_GT_GT] = ACTIONS(3007),
    [anon_sym_GT_GT_GT] = ACTIONS(3007),
    [anon_sym_AMP_CARET] = ACTIONS(3007),
    [anon_sym_AMP_AMP] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3007),
    [anon_sym_or] = ACTIONS(3007),
    [sym_none] = ACTIONS(3007),
    [sym_true] = ACTIONS(3007),
    [sym_false] = ACTIONS(3007),
    [sym_nil] = ACTIONS(3007),
    [anon_sym_QMARK_DOT] = ACTIONS(3007),
    [anon_sym_POUND_LBRACK] = ACTIONS(3007),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_DOLLARif] = ACTIONS(3007),
    [anon_sym_is] = ACTIONS(3007),
    [anon_sym_BANGis] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3007),
    [anon_sym_BANGin] = ACTIONS(3007),
    [anon_sym_match] = ACTIONS(3007),
    [anon_sym_select] = ACTIONS(3007),
    [anon_sym_lock] = ACTIONS(3007),
    [anon_sym_rlock] = ACTIONS(3007),
    [anon_sym_unsafe] = ACTIONS(3007),
    [anon_sym_sql] = ACTIONS(3007),
    [sym_int_literal] = ACTIONS(3007),
    [sym_float_literal] = ACTIONS(3007),
    [sym_rune_literal] = ACTIONS(3007),
    [anon_sym_SQUOTE] = ACTIONS(3007),
    [anon_sym_DQUOTE] = ACTIONS(3007),
    [anon_sym_c_SQUOTE] = ACTIONS(3007),
    [anon_sym_c_DQUOTE] = ACTIONS(3007),
    [anon_sym_r_SQUOTE] = ACTIONS(3007),
    [anon_sym_r_DQUOTE] = ACTIONS(3007),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3007),
    [anon_sym_shared] = ACTIONS(3007),
    [anon_sym_map_LBRACK] = ACTIONS(3007),
    [anon_sym_chan] = ACTIONS(3007),
    [anon_sym_thread] = ACTIONS(3007),
    [anon_sym_atomic] = ACTIONS(3007),
  },
  [1464] = {
    [sym_line_comment] = STATE(1464),
    [sym_block_comment] = STATE(1464),
    [sym_identifier] = ACTIONS(3041),
    [anon_sym_LF] = ACTIONS(3041),
    [anon_sym_CR] = ACTIONS(3041),
    [anon_sym_CR_LF] = ACTIONS(3041),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3041),
    [anon_sym_DOT] = ACTIONS(3041),
    [anon_sym_as] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3041),
    [anon_sym_COMMA] = ACTIONS(3041),
    [anon_sym_RBRACE] = ACTIONS(3041),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_RPAREN] = ACTIONS(3041),
    [anon_sym_fn] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3041),
    [anon_sym_DASH] = ACTIONS(3041),
    [anon_sym_STAR] = ACTIONS(3041),
    [anon_sym_SLASH] = ACTIONS(3041),
    [anon_sym_PERCENT] = ACTIONS(3041),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_GT] = ACTIONS(3041),
    [anon_sym_EQ_EQ] = ACTIONS(3041),
    [anon_sym_BANG_EQ] = ACTIONS(3041),
    [anon_sym_LT_EQ] = ACTIONS(3041),
    [anon_sym_GT_EQ] = ACTIONS(3041),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_struct] = ACTIONS(3041),
    [anon_sym_mut] = ACTIONS(3041),
    [anon_sym_PLUS_PLUS] = ACTIONS(3041),
    [anon_sym_DASH_DASH] = ACTIONS(3041),
    [anon_sym_QMARK] = ACTIONS(3041),
    [anon_sym_BANG] = ACTIONS(3041),
    [anon_sym_go] = ACTIONS(3041),
    [anon_sym_spawn] = ACTIONS(3041),
    [anon_sym_json_DOTdecode] = ACTIONS(3041),
    [anon_sym_PIPE] = ACTIONS(3041),
    [anon_sym_LBRACK2] = ACTIONS(3041),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_CARET] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3041),
    [anon_sym_LT_DASH] = ACTIONS(3041),
    [anon_sym_LT_LT] = ACTIONS(3041),
    [anon_sym_GT_GT] = ACTIONS(3041),
    [anon_sym_GT_GT_GT] = ACTIONS(3041),
    [anon_sym_AMP_CARET] = ACTIONS(3041),
    [anon_sym_AMP_AMP] = ACTIONS(3041),
    [anon_sym_PIPE_PIPE] = ACTIONS(3041),
    [anon_sym_or] = ACTIONS(3041),
    [sym_none] = ACTIONS(3041),
    [sym_true] = ACTIONS(3041),
    [sym_false] = ACTIONS(3041),
    [sym_nil] = ACTIONS(3041),
    [anon_sym_QMARK_DOT] = ACTIONS(3041),
    [anon_sym_POUND_LBRACK] = ACTIONS(3041),
    [anon_sym_if] = ACTIONS(3041),
    [anon_sym_DOLLARif] = ACTIONS(3041),
    [anon_sym_is] = ACTIONS(3041),
    [anon_sym_BANGis] = ACTIONS(3041),
    [anon_sym_in] = ACTIONS(3041),
    [anon_sym_BANGin] = ACTIONS(3041),
    [anon_sym_match] = ACTIONS(3041),
    [anon_sym_select] = ACTIONS(3041),
    [anon_sym_lock] = ACTIONS(3041),
    [anon_sym_rlock] = ACTIONS(3041),
    [anon_sym_unsafe] = ACTIONS(3041),
    [anon_sym_sql] = ACTIONS(3041),
    [sym_int_literal] = ACTIONS(3041),
    [sym_float_literal] = ACTIONS(3041),
    [sym_rune_literal] = ACTIONS(3041),
    [anon_sym_SQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE] = ACTIONS(3041),
    [anon_sym_c_SQUOTE] = ACTIONS(3041),
    [anon_sym_c_DQUOTE] = ACTIONS(3041),
    [anon_sym_r_SQUOTE] = ACTIONS(3041),
    [anon_sym_r_DQUOTE] = ACTIONS(3041),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3041),
    [anon_sym_shared] = ACTIONS(3041),
    [anon_sym_map_LBRACK] = ACTIONS(3041),
    [anon_sym_chan] = ACTIONS(3041),
    [anon_sym_thread] = ACTIONS(3041),
    [anon_sym_atomic] = ACTIONS(3041),
  },
  [1465] = {
    [sym_line_comment] = STATE(1465),
    [sym_block_comment] = STATE(1465),
    [sym_identifier] = ACTIONS(2397),
    [anon_sym_LF] = ACTIONS(2397),
    [anon_sym_CR] = ACTIONS(2397),
    [anon_sym_CR_LF] = ACTIONS(2397),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2397),
    [anon_sym_DOT] = ACTIONS(2397),
    [anon_sym_as] = ACTIONS(2397),
    [anon_sym_LBRACE] = ACTIONS(2397),
    [anon_sym_COMMA] = ACTIONS(2397),
    [anon_sym_RBRACE] = ACTIONS(2397),
    [anon_sym_LPAREN] = ACTIONS(2397),
    [anon_sym_RPAREN] = ACTIONS(2397),
    [anon_sym_fn] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(2397),
    [anon_sym_DASH] = ACTIONS(2397),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_SLASH] = ACTIONS(2397),
    [anon_sym_PERCENT] = ACTIONS(2397),
    [anon_sym_LT] = ACTIONS(2397),
    [anon_sym_GT] = ACTIONS(2397),
    [anon_sym_EQ_EQ] = ACTIONS(2397),
    [anon_sym_BANG_EQ] = ACTIONS(2397),
    [anon_sym_LT_EQ] = ACTIONS(2397),
    [anon_sym_GT_EQ] = ACTIONS(2397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(2395),
    [anon_sym_struct] = ACTIONS(2397),
    [anon_sym_mut] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2397),
    [anon_sym_DASH_DASH] = ACTIONS(2397),
    [anon_sym_QMARK] = ACTIONS(2397),
    [anon_sym_BANG] = ACTIONS(2397),
    [anon_sym_go] = ACTIONS(2397),
    [anon_sym_spawn] = ACTIONS(2397),
    [anon_sym_json_DOTdecode] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(2397),
    [anon_sym_LBRACK2] = ACTIONS(2397),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_CARET] = ACTIONS(2397),
    [anon_sym_AMP] = ACTIONS(2397),
    [anon_sym_LT_DASH] = ACTIONS(2397),
    [anon_sym_LT_LT] = ACTIONS(2397),
    [anon_sym_GT_GT] = ACTIONS(2397),
    [anon_sym_GT_GT_GT] = ACTIONS(2397),
    [anon_sym_AMP_CARET] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(2397),
    [anon_sym_PIPE_PIPE] = ACTIONS(2397),
    [anon_sym_or] = ACTIONS(2397),
    [sym_none] = ACTIONS(2397),
    [sym_true] = ACTIONS(2397),
    [sym_false] = ACTIONS(2397),
    [sym_nil] = ACTIONS(2397),
    [anon_sym_QMARK_DOT] = ACTIONS(2397),
    [anon_sym_POUND_LBRACK] = ACTIONS(2397),
    [anon_sym_if] = ACTIONS(2397),
    [anon_sym_DOLLARif] = ACTIONS(2397),
    [anon_sym_is] = ACTIONS(2397),
    [anon_sym_BANGis] = ACTIONS(2397),
    [anon_sym_in] = ACTIONS(2397),
    [anon_sym_BANGin] = ACTIONS(2397),
    [anon_sym_match] = ACTIONS(2397),
    [anon_sym_select] = ACTIONS(2397),
    [anon_sym_lock] = ACTIONS(2397),
    [anon_sym_rlock] = ACTIONS(2397),
    [anon_sym_unsafe] = ACTIONS(2397),
    [anon_sym_sql] = ACTIONS(2397),
    [sym_int_literal] = ACTIONS(2397),
    [sym_float_literal] = ACTIONS(2397),
    [sym_rune_literal] = ACTIONS(2397),
    [anon_sym_SQUOTE] = ACTIONS(2397),
    [anon_sym_DQUOTE] = ACTIONS(2397),
    [anon_sym_c_SQUOTE] = ACTIONS(2397),
    [anon_sym_c_DQUOTE] = ACTIONS(2397),
    [anon_sym_r_SQUOTE] = ACTIONS(2397),
    [anon_sym_r_DQUOTE] = ACTIONS(2397),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2397),
    [anon_sym_shared] = ACTIONS(2397),
    [anon_sym_map_LBRACK] = ACTIONS(2397),
    [anon_sym_chan] = ACTIONS(2397),
    [anon_sym_thread] = ACTIONS(2397),
    [anon_sym_atomic] = ACTIONS(2397),
  },
  [1466] = {
    [sym_line_comment] = STATE(1466),
    [sym_block_comment] = STATE(1466),
    [sym_identifier] = ACTIONS(3084),
    [anon_sym_LF] = ACTIONS(3084),
    [anon_sym_CR] = ACTIONS(3084),
    [anon_sym_CR_LF] = ACTIONS(3084),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym_DOT] = ACTIONS(3084),
    [anon_sym_as] = ACTIONS(3084),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_COMMA] = ACTIONS(3084),
    [anon_sym_RBRACE] = ACTIONS(3084),
    [anon_sym_LPAREN] = ACTIONS(3084),
    [anon_sym_RPAREN] = ACTIONS(3084),
    [anon_sym_fn] = ACTIONS(3084),
    [anon_sym_PLUS] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_SLASH] = ACTIONS(3084),
    [anon_sym_PERCENT] = ACTIONS(3084),
    [anon_sym_LT] = ACTIONS(3084),
    [anon_sym_GT] = ACTIONS(3084),
    [anon_sym_EQ_EQ] = ACTIONS(3084),
    [anon_sym_BANG_EQ] = ACTIONS(3084),
    [anon_sym_LT_EQ] = ACTIONS(3084),
    [anon_sym_GT_EQ] = ACTIONS(3084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3084),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3084),
    [anon_sym_mut] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_QMARK] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_go] = ACTIONS(3084),
    [anon_sym_spawn] = ACTIONS(3084),
    [anon_sym_json_DOTdecode] = ACTIONS(3084),
    [anon_sym_PIPE] = ACTIONS(3084),
    [anon_sym_LBRACK2] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_CARET] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3084),
    [anon_sym_LT_DASH] = ACTIONS(3084),
    [anon_sym_LT_LT] = ACTIONS(3084),
    [anon_sym_GT_GT] = ACTIONS(3084),
    [anon_sym_GT_GT_GT] = ACTIONS(3084),
    [anon_sym_AMP_CARET] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_PIPE_PIPE] = ACTIONS(3084),
    [anon_sym_or] = ACTIONS(3084),
    [sym_none] = ACTIONS(3084),
    [sym_true] = ACTIONS(3084),
    [sym_false] = ACTIONS(3084),
    [sym_nil] = ACTIONS(3084),
    [anon_sym_QMARK_DOT] = ACTIONS(3084),
    [anon_sym_POUND_LBRACK] = ACTIONS(3084),
    [anon_sym_if] = ACTIONS(3084),
    [anon_sym_DOLLARif] = ACTIONS(3084),
    [anon_sym_is] = ACTIONS(3084),
    [anon_sym_BANGis] = ACTIONS(3084),
    [anon_sym_in] = ACTIONS(3084),
    [anon_sym_BANGin] = ACTIONS(3084),
    [anon_sym_match] = ACTIONS(3084),
    [anon_sym_select] = ACTIONS(3084),
    [anon_sym_lock] = ACTIONS(3084),
    [anon_sym_rlock] = ACTIONS(3084),
    [anon_sym_unsafe] = ACTIONS(3084),
    [anon_sym_sql] = ACTIONS(3084),
    [sym_int_literal] = ACTIONS(3084),
    [sym_float_literal] = ACTIONS(3084),
    [sym_rune_literal] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [anon_sym_c_SQUOTE] = ACTIONS(3084),
    [anon_sym_c_DQUOTE] = ACTIONS(3084),
    [anon_sym_r_SQUOTE] = ACTIONS(3084),
    [anon_sym_r_DQUOTE] = ACTIONS(3084),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3084),
    [anon_sym_shared] = ACTIONS(3084),
    [anon_sym_map_LBRACK] = ACTIONS(3084),
    [anon_sym_chan] = ACTIONS(3084),
    [anon_sym_thread] = ACTIONS(3084),
    [anon_sym_atomic] = ACTIONS(3084),
  },
  [1467] = {
    [sym_line_comment] = STATE(1467),
    [sym_block_comment] = STATE(1467),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_LF] = ACTIONS(2837),
    [anon_sym_CR] = ACTIONS(2837),
    [anon_sym_CR_LF] = ACTIONS(2837),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2837),
    [anon_sym_DOT] = ACTIONS(2837),
    [anon_sym_as] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_RBRACE] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2837),
    [anon_sym_RPAREN] = ACTIONS(2837),
    [anon_sym_fn] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2837),
    [anon_sym_DASH] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2837),
    [anon_sym_SLASH] = ACTIONS(2837),
    [anon_sym_PERCENT] = ACTIONS(2837),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(2837),
    [anon_sym_BANG_EQ] = ACTIONS(2837),
    [anon_sym_LT_EQ] = ACTIONS(2837),
    [anon_sym_GT_EQ] = ACTIONS(2837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2837),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_struct] = ACTIONS(2837),
    [anon_sym_mut] = ACTIONS(2837),
    [anon_sym_PLUS_PLUS] = ACTIONS(2837),
    [anon_sym_DASH_DASH] = ACTIONS(2837),
    [anon_sym_QMARK] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(2837),
    [anon_sym_go] = ACTIONS(2837),
    [anon_sym_spawn] = ACTIONS(2837),
    [anon_sym_json_DOTdecode] = ACTIONS(2837),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_LBRACK2] = ACTIONS(2837),
    [anon_sym_TILDE] = ACTIONS(2837),
    [anon_sym_CARET] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2837),
    [anon_sym_LT_DASH] = ACTIONS(2837),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_GT_GT_GT] = ACTIONS(2837),
    [anon_sym_AMP_CARET] = ACTIONS(2837),
    [anon_sym_AMP_AMP] = ACTIONS(2837),
    [anon_sym_PIPE_PIPE] = ACTIONS(2837),
    [anon_sym_or] = ACTIONS(2837),
    [sym_none] = ACTIONS(2837),
    [sym_true] = ACTIONS(2837),
    [sym_false] = ACTIONS(2837),
    [sym_nil] = ACTIONS(2837),
    [anon_sym_QMARK_DOT] = ACTIONS(2837),
    [anon_sym_POUND_LBRACK] = ACTIONS(2837),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_DOLLARif] = ACTIONS(2837),
    [anon_sym_is] = ACTIONS(2837),
    [anon_sym_BANGis] = ACTIONS(2837),
    [anon_sym_in] = ACTIONS(2837),
    [anon_sym_BANGin] = ACTIONS(2837),
    [anon_sym_match] = ACTIONS(2837),
    [anon_sym_select] = ACTIONS(2837),
    [anon_sym_lock] = ACTIONS(2837),
    [anon_sym_rlock] = ACTIONS(2837),
    [anon_sym_unsafe] = ACTIONS(2837),
    [anon_sym_sql] = ACTIONS(2837),
    [sym_int_literal] = ACTIONS(2837),
    [sym_float_literal] = ACTIONS(2837),
    [sym_rune_literal] = ACTIONS(2837),
    [anon_sym_SQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE] = ACTIONS(2837),
    [anon_sym_c_SQUOTE] = ACTIONS(2837),
    [anon_sym_c_DQUOTE] = ACTIONS(2837),
    [anon_sym_r_SQUOTE] = ACTIONS(2837),
    [anon_sym_r_DQUOTE] = ACTIONS(2837),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2837),
    [anon_sym_shared] = ACTIONS(2837),
    [anon_sym_map_LBRACK] = ACTIONS(2837),
    [anon_sym_chan] = ACTIONS(2837),
    [anon_sym_thread] = ACTIONS(2837),
    [anon_sym_atomic] = ACTIONS(2837),
  },
  [1468] = {
    [sym_line_comment] = STATE(1468),
    [sym_block_comment] = STATE(1468),
    [sym_identifier] = ACTIONS(2335),
    [anon_sym_LF] = ACTIONS(2335),
    [anon_sym_CR] = ACTIONS(2335),
    [anon_sym_CR_LF] = ACTIONS(2335),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2335),
    [anon_sym_DOT] = ACTIONS(2335),
    [anon_sym_as] = ACTIONS(2335),
    [anon_sym_LBRACE] = ACTIONS(2335),
    [anon_sym_COMMA] = ACTIONS(2335),
    [anon_sym_RBRACE] = ACTIONS(2335),
    [anon_sym_LPAREN] = ACTIONS(2335),
    [anon_sym_RPAREN] = ACTIONS(2335),
    [anon_sym_fn] = ACTIONS(2335),
    [anon_sym_PLUS] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2335),
    [anon_sym_STAR] = ACTIONS(2335),
    [anon_sym_SLASH] = ACTIONS(2335),
    [anon_sym_PERCENT] = ACTIONS(2335),
    [anon_sym_LT] = ACTIONS(2335),
    [anon_sym_GT] = ACTIONS(2335),
    [anon_sym_EQ_EQ] = ACTIONS(2335),
    [anon_sym_BANG_EQ] = ACTIONS(2335),
    [anon_sym_LT_EQ] = ACTIONS(2335),
    [anon_sym_GT_EQ] = ACTIONS(2335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2335),
    [anon_sym_LBRACK] = ACTIONS(2337),
    [anon_sym_struct] = ACTIONS(2335),
    [anon_sym_mut] = ACTIONS(2335),
    [anon_sym_PLUS_PLUS] = ACTIONS(2335),
    [anon_sym_DASH_DASH] = ACTIONS(2335),
    [anon_sym_QMARK] = ACTIONS(2335),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_go] = ACTIONS(2335),
    [anon_sym_spawn] = ACTIONS(2335),
    [anon_sym_json_DOTdecode] = ACTIONS(2335),
    [anon_sym_PIPE] = ACTIONS(2335),
    [anon_sym_LBRACK2] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2335),
    [anon_sym_CARET] = ACTIONS(2335),
    [anon_sym_AMP] = ACTIONS(2335),
    [anon_sym_LT_DASH] = ACTIONS(2335),
    [anon_sym_LT_LT] = ACTIONS(2335),
    [anon_sym_GT_GT] = ACTIONS(2335),
    [anon_sym_GT_GT_GT] = ACTIONS(2335),
    [anon_sym_AMP_CARET] = ACTIONS(2335),
    [anon_sym_AMP_AMP] = ACTIONS(2335),
    [anon_sym_PIPE_PIPE] = ACTIONS(2335),
    [anon_sym_or] = ACTIONS(2335),
    [sym_none] = ACTIONS(2335),
    [sym_true] = ACTIONS(2335),
    [sym_false] = ACTIONS(2335),
    [sym_nil] = ACTIONS(2335),
    [anon_sym_QMARK_DOT] = ACTIONS(2335),
    [anon_sym_POUND_LBRACK] = ACTIONS(2335),
    [anon_sym_if] = ACTIONS(2335),
    [anon_sym_DOLLARif] = ACTIONS(2335),
    [anon_sym_is] = ACTIONS(2335),
    [anon_sym_BANGis] = ACTIONS(2335),
    [anon_sym_in] = ACTIONS(2335),
    [anon_sym_BANGin] = ACTIONS(2335),
    [anon_sym_match] = ACTIONS(2335),
    [anon_sym_select] = ACTIONS(2335),
    [anon_sym_lock] = ACTIONS(2335),
    [anon_sym_rlock] = ACTIONS(2335),
    [anon_sym_unsafe] = ACTIONS(2335),
    [anon_sym_sql] = ACTIONS(2335),
    [sym_int_literal] = ACTIONS(2335),
    [sym_float_literal] = ACTIONS(2335),
    [sym_rune_literal] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2335),
    [anon_sym_DQUOTE] = ACTIONS(2335),
    [anon_sym_c_SQUOTE] = ACTIONS(2335),
    [anon_sym_c_DQUOTE] = ACTIONS(2335),
    [anon_sym_r_SQUOTE] = ACTIONS(2335),
    [anon_sym_r_DQUOTE] = ACTIONS(2335),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2335),
    [anon_sym_shared] = ACTIONS(2335),
    [anon_sym_map_LBRACK] = ACTIONS(2335),
    [anon_sym_chan] = ACTIONS(2335),
    [anon_sym_thread] = ACTIONS(2335),
    [anon_sym_atomic] = ACTIONS(2335),
  },
  [1469] = {
    [sym_line_comment] = STATE(1469),
    [sym_block_comment] = STATE(1469),
    [sym_identifier] = ACTIONS(3250),
    [anon_sym_LF] = ACTIONS(3250),
    [anon_sym_CR] = ACTIONS(3250),
    [anon_sym_CR_LF] = ACTIONS(3250),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3250),
    [anon_sym_DOT] = ACTIONS(3250),
    [anon_sym_as] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3250),
    [anon_sym_COMMA] = ACTIONS(3250),
    [anon_sym_RBRACE] = ACTIONS(3250),
    [anon_sym_LPAREN] = ACTIONS(3250),
    [anon_sym_RPAREN] = ACTIONS(3250),
    [anon_sym_fn] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_STAR] = ACTIONS(3250),
    [anon_sym_SLASH] = ACTIONS(3250),
    [anon_sym_PERCENT] = ACTIONS(3250),
    [anon_sym_LT] = ACTIONS(3250),
    [anon_sym_GT] = ACTIONS(3250),
    [anon_sym_EQ_EQ] = ACTIONS(3250),
    [anon_sym_BANG_EQ] = ACTIONS(3250),
    [anon_sym_LT_EQ] = ACTIONS(3250),
    [anon_sym_GT_EQ] = ACTIONS(3250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3248),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_mut] = ACTIONS(3250),
    [anon_sym_PLUS_PLUS] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3250),
    [anon_sym_QMARK] = ACTIONS(3250),
    [anon_sym_BANG] = ACTIONS(3250),
    [anon_sym_go] = ACTIONS(3250),
    [anon_sym_spawn] = ACTIONS(3250),
    [anon_sym_json_DOTdecode] = ACTIONS(3250),
    [anon_sym_PIPE] = ACTIONS(3250),
    [anon_sym_LBRACK2] = ACTIONS(3250),
    [anon_sym_TILDE] = ACTIONS(3250),
    [anon_sym_CARET] = ACTIONS(3250),
    [anon_sym_AMP] = ACTIONS(3250),
    [anon_sym_LT_DASH] = ACTIONS(3250),
    [anon_sym_LT_LT] = ACTIONS(3250),
    [anon_sym_GT_GT] = ACTIONS(3250),
    [anon_sym_GT_GT_GT] = ACTIONS(3250),
    [anon_sym_AMP_CARET] = ACTIONS(3250),
    [anon_sym_AMP_AMP] = ACTIONS(3250),
    [anon_sym_PIPE_PIPE] = ACTIONS(3250),
    [anon_sym_or] = ACTIONS(3250),
    [sym_none] = ACTIONS(3250),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [sym_nil] = ACTIONS(3250),
    [anon_sym_QMARK_DOT] = ACTIONS(3250),
    [anon_sym_POUND_LBRACK] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_DOLLARif] = ACTIONS(3250),
    [anon_sym_is] = ACTIONS(3250),
    [anon_sym_BANGis] = ACTIONS(3250),
    [anon_sym_in] = ACTIONS(3250),
    [anon_sym_BANGin] = ACTIONS(3250),
    [anon_sym_match] = ACTIONS(3250),
    [anon_sym_select] = ACTIONS(3250),
    [anon_sym_lock] = ACTIONS(3250),
    [anon_sym_rlock] = ACTIONS(3250),
    [anon_sym_unsafe] = ACTIONS(3250),
    [anon_sym_sql] = ACTIONS(3250),
    [sym_int_literal] = ACTIONS(3250),
    [sym_float_literal] = ACTIONS(3250),
    [sym_rune_literal] = ACTIONS(3250),
    [anon_sym_SQUOTE] = ACTIONS(3250),
    [anon_sym_DQUOTE] = ACTIONS(3250),
    [anon_sym_c_SQUOTE] = ACTIONS(3250),
    [anon_sym_c_DQUOTE] = ACTIONS(3250),
    [anon_sym_r_SQUOTE] = ACTIONS(3250),
    [anon_sym_r_DQUOTE] = ACTIONS(3250),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3250),
    [anon_sym_shared] = ACTIONS(3250),
    [anon_sym_map_LBRACK] = ACTIONS(3250),
    [anon_sym_chan] = ACTIONS(3250),
    [anon_sym_thread] = ACTIONS(3250),
    [anon_sym_atomic] = ACTIONS(3250),
  },
  [1470] = {
    [sym_line_comment] = STATE(1470),
    [sym_block_comment] = STATE(1470),
    [sym_identifier] = ACTIONS(2435),
    [anon_sym_LF] = ACTIONS(2435),
    [anon_sym_CR] = ACTIONS(2435),
    [anon_sym_CR_LF] = ACTIONS(2435),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2435),
    [anon_sym_DOT] = ACTIONS(2435),
    [anon_sym_as] = ACTIONS(2435),
    [anon_sym_LBRACE] = ACTIONS(2435),
    [anon_sym_COMMA] = ACTIONS(2435),
    [anon_sym_RBRACE] = ACTIONS(2435),
    [anon_sym_LPAREN] = ACTIONS(2435),
    [anon_sym_RPAREN] = ACTIONS(2435),
    [anon_sym_fn] = ACTIONS(2435),
    [anon_sym_PLUS] = ACTIONS(2435),
    [anon_sym_DASH] = ACTIONS(2435),
    [anon_sym_STAR] = ACTIONS(2435),
    [anon_sym_SLASH] = ACTIONS(2435),
    [anon_sym_PERCENT] = ACTIONS(2435),
    [anon_sym_LT] = ACTIONS(2435),
    [anon_sym_GT] = ACTIONS(2435),
    [anon_sym_EQ_EQ] = ACTIONS(2435),
    [anon_sym_BANG_EQ] = ACTIONS(2435),
    [anon_sym_LT_EQ] = ACTIONS(2435),
    [anon_sym_GT_EQ] = ACTIONS(2435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2435),
    [anon_sym_LBRACK] = ACTIONS(2433),
    [anon_sym_struct] = ACTIONS(2435),
    [anon_sym_mut] = ACTIONS(2435),
    [anon_sym_PLUS_PLUS] = ACTIONS(2435),
    [anon_sym_DASH_DASH] = ACTIONS(2435),
    [anon_sym_QMARK] = ACTIONS(2435),
    [anon_sym_BANG] = ACTIONS(2435),
    [anon_sym_go] = ACTIONS(2435),
    [anon_sym_spawn] = ACTIONS(2435),
    [anon_sym_json_DOTdecode] = ACTIONS(2435),
    [anon_sym_PIPE] = ACTIONS(2435),
    [anon_sym_LBRACK2] = ACTIONS(2435),
    [anon_sym_TILDE] = ACTIONS(2435),
    [anon_sym_CARET] = ACTIONS(2435),
    [anon_sym_AMP] = ACTIONS(2435),
    [anon_sym_LT_DASH] = ACTIONS(2435),
    [anon_sym_LT_LT] = ACTIONS(2435),
    [anon_sym_GT_GT] = ACTIONS(2435),
    [anon_sym_GT_GT_GT] = ACTIONS(2435),
    [anon_sym_AMP_CARET] = ACTIONS(2435),
    [anon_sym_AMP_AMP] = ACTIONS(2435),
    [anon_sym_PIPE_PIPE] = ACTIONS(2435),
    [anon_sym_or] = ACTIONS(2435),
    [sym_none] = ACTIONS(2435),
    [sym_true] = ACTIONS(2435),
    [sym_false] = ACTIONS(2435),
    [sym_nil] = ACTIONS(2435),
    [anon_sym_QMARK_DOT] = ACTIONS(2435),
    [anon_sym_POUND_LBRACK] = ACTIONS(2435),
    [anon_sym_if] = ACTIONS(2435),
    [anon_sym_DOLLARif] = ACTIONS(2435),
    [anon_sym_is] = ACTIONS(2435),
    [anon_sym_BANGis] = ACTIONS(2435),
    [anon_sym_in] = ACTIONS(2435),
    [anon_sym_BANGin] = ACTIONS(2435),
    [anon_sym_match] = ACTIONS(2435),
    [anon_sym_select] = ACTIONS(2435),
    [anon_sym_lock] = ACTIONS(2435),
    [anon_sym_rlock] = ACTIONS(2435),
    [anon_sym_unsafe] = ACTIONS(2435),
    [anon_sym_sql] = ACTIONS(2435),
    [sym_int_literal] = ACTIONS(2435),
    [sym_float_literal] = ACTIONS(2435),
    [sym_rune_literal] = ACTIONS(2435),
    [anon_sym_SQUOTE] = ACTIONS(2435),
    [anon_sym_DQUOTE] = ACTIONS(2435),
    [anon_sym_c_SQUOTE] = ACTIONS(2435),
    [anon_sym_c_DQUOTE] = ACTIONS(2435),
    [anon_sym_r_SQUOTE] = ACTIONS(2435),
    [anon_sym_r_DQUOTE] = ACTIONS(2435),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2435),
    [anon_sym_shared] = ACTIONS(2435),
    [anon_sym_map_LBRACK] = ACTIONS(2435),
    [anon_sym_chan] = ACTIONS(2435),
    [anon_sym_thread] = ACTIONS(2435),
    [anon_sym_atomic] = ACTIONS(2435),
  },
  [1471] = {
    [sym_line_comment] = STATE(1471),
    [sym_block_comment] = STATE(1471),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LF] = ACTIONS(2471),
    [anon_sym_CR] = ACTIONS(2471),
    [anon_sym_CR_LF] = ACTIONS(2471),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_DOT] = ACTIONS(2471),
    [anon_sym_as] = ACTIONS(2471),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_COMMA] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_RPAREN] = ACTIONS(2471),
    [anon_sym_fn] = ACTIONS(2471),
    [anon_sym_PLUS] = ACTIONS(2471),
    [anon_sym_DASH] = ACTIONS(2471),
    [anon_sym_STAR] = ACTIONS(2471),
    [anon_sym_SLASH] = ACTIONS(2471),
    [anon_sym_PERCENT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2471),
    [anon_sym_GT] = ACTIONS(2471),
    [anon_sym_EQ_EQ] = ACTIONS(2471),
    [anon_sym_BANG_EQ] = ACTIONS(2471),
    [anon_sym_LT_EQ] = ACTIONS(2471),
    [anon_sym_GT_EQ] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2471),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_struct] = ACTIONS(2471),
    [anon_sym_mut] = ACTIONS(2471),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_go] = ACTIONS(2471),
    [anon_sym_spawn] = ACTIONS(2471),
    [anon_sym_json_DOTdecode] = ACTIONS(2471),
    [anon_sym_PIPE] = ACTIONS(2471),
    [anon_sym_LBRACK2] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_CARET] = ACTIONS(2471),
    [anon_sym_AMP] = ACTIONS(2471),
    [anon_sym_LT_DASH] = ACTIONS(2471),
    [anon_sym_LT_LT] = ACTIONS(2471),
    [anon_sym_GT_GT] = ACTIONS(2471),
    [anon_sym_GT_GT_GT] = ACTIONS(2471),
    [anon_sym_AMP_CARET] = ACTIONS(2471),
    [anon_sym_AMP_AMP] = ACTIONS(2471),
    [anon_sym_PIPE_PIPE] = ACTIONS(2471),
    [anon_sym_or] = ACTIONS(2471),
    [sym_none] = ACTIONS(2471),
    [sym_true] = ACTIONS(2471),
    [sym_false] = ACTIONS(2471),
    [sym_nil] = ACTIONS(2471),
    [anon_sym_QMARK_DOT] = ACTIONS(2471),
    [anon_sym_POUND_LBRACK] = ACTIONS(2471),
    [anon_sym_if] = ACTIONS(2471),
    [anon_sym_DOLLARif] = ACTIONS(2471),
    [anon_sym_is] = ACTIONS(2471),
    [anon_sym_BANGis] = ACTIONS(2471),
    [anon_sym_in] = ACTIONS(2471),
    [anon_sym_BANGin] = ACTIONS(2471),
    [anon_sym_match] = ACTIONS(2471),
    [anon_sym_select] = ACTIONS(2471),
    [anon_sym_lock] = ACTIONS(2471),
    [anon_sym_rlock] = ACTIONS(2471),
    [anon_sym_unsafe] = ACTIONS(2471),
    [anon_sym_sql] = ACTIONS(2471),
    [sym_int_literal] = ACTIONS(2471),
    [sym_float_literal] = ACTIONS(2471),
    [sym_rune_literal] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_c_SQUOTE] = ACTIONS(2471),
    [anon_sym_c_DQUOTE] = ACTIONS(2471),
    [anon_sym_r_SQUOTE] = ACTIONS(2471),
    [anon_sym_r_DQUOTE] = ACTIONS(2471),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2471),
    [anon_sym_shared] = ACTIONS(2471),
    [anon_sym_map_LBRACK] = ACTIONS(2471),
    [anon_sym_chan] = ACTIONS(2471),
    [anon_sym_thread] = ACTIONS(2471),
    [anon_sym_atomic] = ACTIONS(2471),
  },
  [1472] = {
    [sym_line_comment] = STATE(1472),
    [sym_block_comment] = STATE(1472),
    [sym_identifier] = ACTIONS(2889),
    [anon_sym_LF] = ACTIONS(2889),
    [anon_sym_CR] = ACTIONS(2889),
    [anon_sym_CR_LF] = ACTIONS(2889),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym_DOT] = ACTIONS(2889),
    [anon_sym_as] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2889),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_RBRACE] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2889),
    [anon_sym_RPAREN] = ACTIONS(2889),
    [anon_sym_fn] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2889),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_SLASH] = ACTIONS(2889),
    [anon_sym_PERCENT] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_GT] = ACTIONS(2889),
    [anon_sym_EQ_EQ] = ACTIONS(2889),
    [anon_sym_BANG_EQ] = ACTIONS(2889),
    [anon_sym_LT_EQ] = ACTIONS(2889),
    [anon_sym_GT_EQ] = ACTIONS(2889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2889),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_struct] = ACTIONS(2889),
    [anon_sym_mut] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2889),
    [anon_sym_DASH_DASH] = ACTIONS(2889),
    [anon_sym_QMARK] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2889),
    [anon_sym_go] = ACTIONS(2889),
    [anon_sym_spawn] = ACTIONS(2889),
    [anon_sym_json_DOTdecode] = ACTIONS(2889),
    [anon_sym_PIPE] = ACTIONS(2889),
    [anon_sym_LBRACK2] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_CARET] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2889),
    [anon_sym_LT_DASH] = ACTIONS(2889),
    [anon_sym_LT_LT] = ACTIONS(2889),
    [anon_sym_GT_GT] = ACTIONS(2889),
    [anon_sym_GT_GT_GT] = ACTIONS(2889),
    [anon_sym_AMP_CARET] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2889),
    [anon_sym_or] = ACTIONS(2889),
    [sym_none] = ACTIONS(2889),
    [sym_true] = ACTIONS(2889),
    [sym_false] = ACTIONS(2889),
    [sym_nil] = ACTIONS(2889),
    [anon_sym_QMARK_DOT] = ACTIONS(2889),
    [anon_sym_POUND_LBRACK] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_DOLLARif] = ACTIONS(2889),
    [anon_sym_is] = ACTIONS(2889),
    [anon_sym_BANGis] = ACTIONS(2889),
    [anon_sym_in] = ACTIONS(2889),
    [anon_sym_BANGin] = ACTIONS(2889),
    [anon_sym_match] = ACTIONS(2889),
    [anon_sym_select] = ACTIONS(2889),
    [anon_sym_lock] = ACTIONS(2889),
    [anon_sym_rlock] = ACTIONS(2889),
    [anon_sym_unsafe] = ACTIONS(2889),
    [anon_sym_sql] = ACTIONS(2889),
    [sym_int_literal] = ACTIONS(2889),
    [sym_float_literal] = ACTIONS(2889),
    [sym_rune_literal] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [anon_sym_c_SQUOTE] = ACTIONS(2889),
    [anon_sym_c_DQUOTE] = ACTIONS(2889),
    [anon_sym_r_SQUOTE] = ACTIONS(2889),
    [anon_sym_r_DQUOTE] = ACTIONS(2889),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2889),
    [anon_sym_shared] = ACTIONS(2889),
    [anon_sym_map_LBRACK] = ACTIONS(2889),
    [anon_sym_chan] = ACTIONS(2889),
    [anon_sym_thread] = ACTIONS(2889),
    [anon_sym_atomic] = ACTIONS(2889),
  },
  [1473] = {
    [sym_line_comment] = STATE(1473),
    [sym_block_comment] = STATE(1473),
    [sym_identifier] = ACTIONS(3262),
    [anon_sym_LF] = ACTIONS(3262),
    [anon_sym_CR] = ACTIONS(3262),
    [anon_sym_CR_LF] = ACTIONS(3262),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3262),
    [anon_sym_DOT] = ACTIONS(3262),
    [anon_sym_as] = ACTIONS(3262),
    [anon_sym_LBRACE] = ACTIONS(3262),
    [anon_sym_COMMA] = ACTIONS(3262),
    [anon_sym_RBRACE] = ACTIONS(3262),
    [anon_sym_LPAREN] = ACTIONS(3262),
    [anon_sym_RPAREN] = ACTIONS(3262),
    [anon_sym_fn] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3262),
    [anon_sym_DASH] = ACTIONS(3262),
    [anon_sym_STAR] = ACTIONS(3262),
    [anon_sym_SLASH] = ACTIONS(3262),
    [anon_sym_PERCENT] = ACTIONS(3262),
    [anon_sym_LT] = ACTIONS(3262),
    [anon_sym_GT] = ACTIONS(3262),
    [anon_sym_EQ_EQ] = ACTIONS(3262),
    [anon_sym_BANG_EQ] = ACTIONS(3262),
    [anon_sym_LT_EQ] = ACTIONS(3262),
    [anon_sym_GT_EQ] = ACTIONS(3262),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3262),
    [anon_sym_LBRACK] = ACTIONS(3260),
    [anon_sym_struct] = ACTIONS(3262),
    [anon_sym_mut] = ACTIONS(3262),
    [anon_sym_PLUS_PLUS] = ACTIONS(3262),
    [anon_sym_DASH_DASH] = ACTIONS(3262),
    [anon_sym_QMARK] = ACTIONS(3262),
    [anon_sym_BANG] = ACTIONS(3262),
    [anon_sym_go] = ACTIONS(3262),
    [anon_sym_spawn] = ACTIONS(3262),
    [anon_sym_json_DOTdecode] = ACTIONS(3262),
    [anon_sym_PIPE] = ACTIONS(3262),
    [anon_sym_LBRACK2] = ACTIONS(3262),
    [anon_sym_TILDE] = ACTIONS(3262),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_AMP] = ACTIONS(3262),
    [anon_sym_LT_DASH] = ACTIONS(3262),
    [anon_sym_LT_LT] = ACTIONS(3262),
    [anon_sym_GT_GT] = ACTIONS(3262),
    [anon_sym_GT_GT_GT] = ACTIONS(3262),
    [anon_sym_AMP_CARET] = ACTIONS(3262),
    [anon_sym_AMP_AMP] = ACTIONS(3262),
    [anon_sym_PIPE_PIPE] = ACTIONS(3262),
    [anon_sym_or] = ACTIONS(3262),
    [sym_none] = ACTIONS(3262),
    [sym_true] = ACTIONS(3262),
    [sym_false] = ACTIONS(3262),
    [sym_nil] = ACTIONS(3262),
    [anon_sym_QMARK_DOT] = ACTIONS(3262),
    [anon_sym_POUND_LBRACK] = ACTIONS(3262),
    [anon_sym_if] = ACTIONS(3262),
    [anon_sym_DOLLARif] = ACTIONS(3262),
    [anon_sym_is] = ACTIONS(3262),
    [anon_sym_BANGis] = ACTIONS(3262),
    [anon_sym_in] = ACTIONS(3262),
    [anon_sym_BANGin] = ACTIONS(3262),
    [anon_sym_match] = ACTIONS(3262),
    [anon_sym_select] = ACTIONS(3262),
    [anon_sym_lock] = ACTIONS(3262),
    [anon_sym_rlock] = ACTIONS(3262),
    [anon_sym_unsafe] = ACTIONS(3262),
    [anon_sym_sql] = ACTIONS(3262),
    [sym_int_literal] = ACTIONS(3262),
    [sym_float_literal] = ACTIONS(3262),
    [sym_rune_literal] = ACTIONS(3262),
    [anon_sym_SQUOTE] = ACTIONS(3262),
    [anon_sym_DQUOTE] = ACTIONS(3262),
    [anon_sym_c_SQUOTE] = ACTIONS(3262),
    [anon_sym_c_DQUOTE] = ACTIONS(3262),
    [anon_sym_r_SQUOTE] = ACTIONS(3262),
    [anon_sym_r_DQUOTE] = ACTIONS(3262),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3262),
    [anon_sym_shared] = ACTIONS(3262),
    [anon_sym_map_LBRACK] = ACTIONS(3262),
    [anon_sym_chan] = ACTIONS(3262),
    [anon_sym_thread] = ACTIONS(3262),
    [anon_sym_atomic] = ACTIONS(3262),
  },
  [1474] = {
    [sym_line_comment] = STATE(1474),
    [sym_block_comment] = STATE(1474),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_LF] = ACTIONS(2877),
    [anon_sym_CR] = ACTIONS(2877),
    [anon_sym_CR_LF] = ACTIONS(2877),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2877),
    [anon_sym_as] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2877),
    [anon_sym_RBRACE] = ACTIONS(2877),
    [anon_sym_LPAREN] = ACTIONS(2877),
    [anon_sym_RPAREN] = ACTIONS(2877),
    [anon_sym_fn] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_STAR] = ACTIONS(2877),
    [anon_sym_SLASH] = ACTIONS(2877),
    [anon_sym_PERCENT] = ACTIONS(2877),
    [anon_sym_LT] = ACTIONS(2877),
    [anon_sym_GT] = ACTIONS(2877),
    [anon_sym_EQ_EQ] = ACTIONS(2877),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_LT_EQ] = ACTIONS(2877),
    [anon_sym_GT_EQ] = ACTIONS(2877),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2875),
    [anon_sym_struct] = ACTIONS(2877),
    [anon_sym_mut] = ACTIONS(2877),
    [anon_sym_PLUS_PLUS] = ACTIONS(2877),
    [anon_sym_DASH_DASH] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2877),
    [anon_sym_go] = ACTIONS(2877),
    [anon_sym_spawn] = ACTIONS(2877),
    [anon_sym_json_DOTdecode] = ACTIONS(2877),
    [anon_sym_PIPE] = ACTIONS(2877),
    [anon_sym_LBRACK2] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2877),
    [anon_sym_CARET] = ACTIONS(2877),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_LT_DASH] = ACTIONS(2877),
    [anon_sym_LT_LT] = ACTIONS(2877),
    [anon_sym_GT_GT] = ACTIONS(2877),
    [anon_sym_GT_GT_GT] = ACTIONS(2877),
    [anon_sym_AMP_CARET] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_PIPE_PIPE] = ACTIONS(2877),
    [anon_sym_or] = ACTIONS(2877),
    [sym_none] = ACTIONS(2877),
    [sym_true] = ACTIONS(2877),
    [sym_false] = ACTIONS(2877),
    [sym_nil] = ACTIONS(2877),
    [anon_sym_QMARK_DOT] = ACTIONS(2877),
    [anon_sym_POUND_LBRACK] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_DOLLARif] = ACTIONS(2877),
    [anon_sym_is] = ACTIONS(2877),
    [anon_sym_BANGis] = ACTIONS(2877),
    [anon_sym_in] = ACTIONS(2877),
    [anon_sym_BANGin] = ACTIONS(2877),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_select] = ACTIONS(2877),
    [anon_sym_lock] = ACTIONS(2877),
    [anon_sym_rlock] = ACTIONS(2877),
    [anon_sym_unsafe] = ACTIONS(2877),
    [anon_sym_sql] = ACTIONS(2877),
    [sym_int_literal] = ACTIONS(2877),
    [sym_float_literal] = ACTIONS(2877),
    [sym_rune_literal] = ACTIONS(2877),
    [anon_sym_SQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [anon_sym_c_SQUOTE] = ACTIONS(2877),
    [anon_sym_c_DQUOTE] = ACTIONS(2877),
    [anon_sym_r_SQUOTE] = ACTIONS(2877),
    [anon_sym_r_DQUOTE] = ACTIONS(2877),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2877),
    [anon_sym_shared] = ACTIONS(2877),
    [anon_sym_map_LBRACK] = ACTIONS(2877),
    [anon_sym_chan] = ACTIONS(2877),
    [anon_sym_thread] = ACTIONS(2877),
    [anon_sym_atomic] = ACTIONS(2877),
  },
  [1475] = {
    [sym_line_comment] = STATE(1475),
    [sym_block_comment] = STATE(1475),
    [sym_identifier] = ACTIONS(2865),
    [anon_sym_LF] = ACTIONS(2865),
    [anon_sym_CR] = ACTIONS(2865),
    [anon_sym_CR_LF] = ACTIONS(2865),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2865),
    [anon_sym_DOT] = ACTIONS(2865),
    [anon_sym_as] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2865),
    [anon_sym_COMMA] = ACTIONS(2865),
    [anon_sym_RBRACE] = ACTIONS(2865),
    [anon_sym_LPAREN] = ACTIONS(2865),
    [anon_sym_RPAREN] = ACTIONS(2865),
    [anon_sym_fn] = ACTIONS(2865),
    [anon_sym_PLUS] = ACTIONS(2865),
    [anon_sym_DASH] = ACTIONS(2865),
    [anon_sym_STAR] = ACTIONS(2865),
    [anon_sym_SLASH] = ACTIONS(2865),
    [anon_sym_PERCENT] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_GT] = ACTIONS(2865),
    [anon_sym_EQ_EQ] = ACTIONS(2865),
    [anon_sym_BANG_EQ] = ACTIONS(2865),
    [anon_sym_LT_EQ] = ACTIONS(2865),
    [anon_sym_GT_EQ] = ACTIONS(2865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2865),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_struct] = ACTIONS(2865),
    [anon_sym_mut] = ACTIONS(2865),
    [anon_sym_PLUS_PLUS] = ACTIONS(2865),
    [anon_sym_DASH_DASH] = ACTIONS(2865),
    [anon_sym_QMARK] = ACTIONS(2865),
    [anon_sym_BANG] = ACTIONS(2865),
    [anon_sym_go] = ACTIONS(2865),
    [anon_sym_spawn] = ACTIONS(2865),
    [anon_sym_json_DOTdecode] = ACTIONS(2865),
    [anon_sym_PIPE] = ACTIONS(2865),
    [anon_sym_LBRACK2] = ACTIONS(2865),
    [anon_sym_TILDE] = ACTIONS(2865),
    [anon_sym_CARET] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2865),
    [anon_sym_LT_DASH] = ACTIONS(2865),
    [anon_sym_LT_LT] = ACTIONS(2865),
    [anon_sym_GT_GT] = ACTIONS(2865),
    [anon_sym_GT_GT_GT] = ACTIONS(2865),
    [anon_sym_AMP_CARET] = ACTIONS(2865),
    [anon_sym_AMP_AMP] = ACTIONS(2865),
    [anon_sym_PIPE_PIPE] = ACTIONS(2865),
    [anon_sym_or] = ACTIONS(2865),
    [sym_none] = ACTIONS(2865),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_nil] = ACTIONS(2865),
    [anon_sym_QMARK_DOT] = ACTIONS(2865),
    [anon_sym_POUND_LBRACK] = ACTIONS(2865),
    [anon_sym_if] = ACTIONS(2865),
    [anon_sym_DOLLARif] = ACTIONS(2865),
    [anon_sym_is] = ACTIONS(2865),
    [anon_sym_BANGis] = ACTIONS(2865),
    [anon_sym_in] = ACTIONS(2865),
    [anon_sym_BANGin] = ACTIONS(2865),
    [anon_sym_match] = ACTIONS(2865),
    [anon_sym_select] = ACTIONS(2865),
    [anon_sym_lock] = ACTIONS(2865),
    [anon_sym_rlock] = ACTIONS(2865),
    [anon_sym_unsafe] = ACTIONS(2865),
    [anon_sym_sql] = ACTIONS(2865),
    [sym_int_literal] = ACTIONS(2865),
    [sym_float_literal] = ACTIONS(2865),
    [sym_rune_literal] = ACTIONS(2865),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_DQUOTE] = ACTIONS(2865),
    [anon_sym_c_SQUOTE] = ACTIONS(2865),
    [anon_sym_c_DQUOTE] = ACTIONS(2865),
    [anon_sym_r_SQUOTE] = ACTIONS(2865),
    [anon_sym_r_DQUOTE] = ACTIONS(2865),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2865),
    [anon_sym_shared] = ACTIONS(2865),
    [anon_sym_map_LBRACK] = ACTIONS(2865),
    [anon_sym_chan] = ACTIONS(2865),
    [anon_sym_thread] = ACTIONS(2865),
    [anon_sym_atomic] = ACTIONS(2865),
  },
  [1476] = {
    [sym_line_comment] = STATE(1476),
    [sym_block_comment] = STATE(1476),
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2373),
    [anon_sym_CR] = ACTIONS(2373),
    [anon_sym_CR_LF] = ACTIONS(2373),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_DOT] = ACTIONS(2177),
    [anon_sym_as] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2373),
    [anon_sym_COMMA] = ACTIONS(2373),
    [anon_sym_RBRACE] = ACTIONS(2373),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym_RPAREN] = ACTIONS(2373),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_SLASH] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2373),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_mut] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2373),
    [anon_sym_QMARK] = ACTIONS(2373),
    [anon_sym_BANG] = ACTIONS(2373),
    [anon_sym_go] = ACTIONS(2373),
    [anon_sym_spawn] = ACTIONS(2373),
    [anon_sym_json_DOTdecode] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_LBRACK2] = ACTIONS(2373),
    [anon_sym_TILDE] = ACTIONS(2373),
    [anon_sym_CARET] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_LT_DASH] = ACTIONS(2373),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2373),
    [anon_sym_AMP_CARET] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2373),
    [anon_sym_or] = ACTIONS(2373),
    [sym_none] = ACTIONS(2373),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [sym_nil] = ACTIONS(2373),
    [anon_sym_QMARK_DOT] = ACTIONS(2373),
    [anon_sym_POUND_LBRACK] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_DOLLARif] = ACTIONS(2373),
    [anon_sym_is] = ACTIONS(2373),
    [anon_sym_BANGis] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_BANGin] = ACTIONS(2373),
    [anon_sym_match] = ACTIONS(2373),
    [anon_sym_select] = ACTIONS(2373),
    [anon_sym_lock] = ACTIONS(2373),
    [anon_sym_rlock] = ACTIONS(2373),
    [anon_sym_unsafe] = ACTIONS(2373),
    [anon_sym_sql] = ACTIONS(2373),
    [sym_int_literal] = ACTIONS(2373),
    [sym_float_literal] = ACTIONS(2373),
    [sym_rune_literal] = ACTIONS(2373),
    [anon_sym_SQUOTE] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(2373),
    [anon_sym_c_SQUOTE] = ACTIONS(2373),
    [anon_sym_c_DQUOTE] = ACTIONS(2373),
    [anon_sym_r_SQUOTE] = ACTIONS(2373),
    [anon_sym_r_DQUOTE] = ACTIONS(2373),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_map_LBRACK] = ACTIONS(2373),
    [anon_sym_chan] = ACTIONS(2373),
    [anon_sym_thread] = ACTIONS(2373),
    [anon_sym_atomic] = ACTIONS(2373),
  },
  [1477] = {
    [sym_line_comment] = STATE(1477),
    [sym_block_comment] = STATE(1477),
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_LF] = ACTIONS(3045),
    [anon_sym_CR] = ACTIONS(3045),
    [anon_sym_CR_LF] = ACTIONS(3045),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3045),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_as] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3045),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3045),
    [anon_sym_RPAREN] = ACTIONS(3045),
    [anon_sym_fn] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3045),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_PERCENT] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_GT] = ACTIONS(3045),
    [anon_sym_EQ_EQ] = ACTIONS(3045),
    [anon_sym_BANG_EQ] = ACTIONS(3045),
    [anon_sym_LT_EQ] = ACTIONS(3045),
    [anon_sym_GT_EQ] = ACTIONS(3045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_struct] = ACTIONS(3045),
    [anon_sym_mut] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3045),
    [anon_sym_go] = ACTIONS(3045),
    [anon_sym_spawn] = ACTIONS(3045),
    [anon_sym_json_DOTdecode] = ACTIONS(3045),
    [anon_sym_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACK2] = ACTIONS(3045),
    [anon_sym_TILDE] = ACTIONS(3045),
    [anon_sym_CARET] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3045),
    [anon_sym_LT_DASH] = ACTIONS(3045),
    [anon_sym_LT_LT] = ACTIONS(3045),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_GT_GT_GT] = ACTIONS(3045),
    [anon_sym_AMP_CARET] = ACTIONS(3045),
    [anon_sym_AMP_AMP] = ACTIONS(3045),
    [anon_sym_PIPE_PIPE] = ACTIONS(3045),
    [anon_sym_or] = ACTIONS(3045),
    [sym_none] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_nil] = ACTIONS(3045),
    [anon_sym_QMARK_DOT] = ACTIONS(3045),
    [anon_sym_POUND_LBRACK] = ACTIONS(3045),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_DOLLARif] = ACTIONS(3045),
    [anon_sym_is] = ACTIONS(3045),
    [anon_sym_BANGis] = ACTIONS(3045),
    [anon_sym_in] = ACTIONS(3045),
    [anon_sym_BANGin] = ACTIONS(3045),
    [anon_sym_match] = ACTIONS(3045),
    [anon_sym_select] = ACTIONS(3045),
    [anon_sym_lock] = ACTIONS(3045),
    [anon_sym_rlock] = ACTIONS(3045),
    [anon_sym_unsafe] = ACTIONS(3045),
    [anon_sym_sql] = ACTIONS(3045),
    [sym_int_literal] = ACTIONS(3045),
    [sym_float_literal] = ACTIONS(3045),
    [sym_rune_literal] = ACTIONS(3045),
    [anon_sym_SQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE] = ACTIONS(3045),
    [anon_sym_c_SQUOTE] = ACTIONS(3045),
    [anon_sym_c_DQUOTE] = ACTIONS(3045),
    [anon_sym_r_SQUOTE] = ACTIONS(3045),
    [anon_sym_r_DQUOTE] = ACTIONS(3045),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3045),
    [anon_sym_shared] = ACTIONS(3045),
    [anon_sym_map_LBRACK] = ACTIONS(3045),
    [anon_sym_chan] = ACTIONS(3045),
    [anon_sym_thread] = ACTIONS(3045),
    [anon_sym_atomic] = ACTIONS(3045),
  },
  [1478] = {
    [sym_line_comment] = STATE(1478),
    [sym_block_comment] = STATE(1478),
    [sym_reference_expression] = STATE(4528),
    [sym_type_reference_expression] = STATE(2017),
    [sym_plain_type] = STATE(2147),
    [sym__plain_type_without_special] = STATE(2110),
    [sym_anon_struct_type] = STATE(2111),
    [sym_multi_return_type] = STATE(2110),
    [sym_result_type] = STATE(2110),
    [sym_option_type] = STATE(2110),
    [sym_qualified_type] = STATE(2017),
    [sym_fixed_array_type] = STATE(2111),
    [sym_array_type] = STATE(2111),
    [sym_pointer_type] = STATE(2111),
    [sym_wrong_pointer_type] = STATE(2111),
    [sym_map_type] = STATE(2111),
    [sym_channel_type] = STATE(2111),
    [sym_shared_type] = STATE(2111),
    [sym_thread_type] = STATE(2111),
    [sym_atomic_type] = STATE(2111),
    [sym_generic_type] = STATE(2111),
    [sym_function_type] = STATE(2111),
    [sym_identifier] = ACTIONS(4190),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(853),
    [anon_sym_as] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(853),
    [anon_sym_COMMA] = ACTIONS(853),
    [anon_sym_LPAREN] = ACTIONS(4192),
    [anon_sym_EQ] = ACTIONS(855),
    [anon_sym_fn] = ACTIONS(4194),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_PERCENT] = ACTIONS(855),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_GT] = ACTIONS(855),
    [anon_sym_EQ_EQ] = ACTIONS(853),
    [anon_sym_BANG_EQ] = ACTIONS(853),
    [anon_sym_LT_EQ] = ACTIONS(853),
    [anon_sym_GT_EQ] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_struct] = ACTIONS(4198),
    [anon_sym_COLON] = ACTIONS(853),
    [anon_sym_PLUS_PLUS] = ACTIONS(853),
    [anon_sym_DASH_DASH] = ACTIONS(853),
    [anon_sym_QMARK] = ACTIONS(4200),
    [anon_sym_BANG] = ACTIONS(4202),
    [anon_sym_PIPE] = ACTIONS(855),
    [anon_sym_LBRACK2] = ACTIONS(4204),
    [anon_sym_CARET] = ACTIONS(855),
    [anon_sym_AMP] = ACTIONS(4206),
    [anon_sym_LT_DASH] = ACTIONS(853),
    [anon_sym_LT_LT] = ACTIONS(855),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_GT_GT_GT] = ACTIONS(855),
    [anon_sym_AMP_CARET] = ACTIONS(855),
    [anon_sym_AMP_AMP] = ACTIONS(853),
    [anon_sym_PIPE_PIPE] = ACTIONS(853),
    [anon_sym_or] = ACTIONS(855),
    [anon_sym_QMARK_DOT] = ACTIONS(853),
    [anon_sym_POUND_LBRACK] = ACTIONS(853),
    [anon_sym_is] = ACTIONS(855),
    [anon_sym_BANGis] = ACTIONS(853),
    [anon_sym_in] = ACTIONS(855),
    [anon_sym_BANGin] = ACTIONS(853),
    [anon_sym_STAR_EQ] = ACTIONS(853),
    [anon_sym_SLASH_EQ] = ACTIONS(853),
    [anon_sym_PERCENT_EQ] = ACTIONS(853),
    [anon_sym_LT_LT_EQ] = ACTIONS(853),
    [anon_sym_GT_GT_EQ] = ACTIONS(853),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(853),
    [anon_sym_AMP_EQ] = ACTIONS(853),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(853),
    [anon_sym_PLUS_EQ] = ACTIONS(853),
    [anon_sym_DASH_EQ] = ACTIONS(853),
    [anon_sym_PIPE_EQ] = ACTIONS(853),
    [anon_sym_CARET_EQ] = ACTIONS(853),
    [anon_sym_shared] = ACTIONS(4208),
    [anon_sym_map_LBRACK] = ACTIONS(4210),
    [anon_sym_chan] = ACTIONS(4212),
    [anon_sym_thread] = ACTIONS(4214),
    [anon_sym_atomic] = ACTIONS(4216),
  },
  [1479] = {
    [sym_line_comment] = STATE(1479),
    [sym_block_comment] = STATE(1479),
    [sym_identifier] = ACTIONS(2849),
    [anon_sym_LF] = ACTIONS(2849),
    [anon_sym_CR] = ACTIONS(2849),
    [anon_sym_CR_LF] = ACTIONS(2849),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2849),
    [anon_sym_DOT] = ACTIONS(2849),
    [anon_sym_as] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_COMMA] = ACTIONS(2849),
    [anon_sym_RBRACE] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2849),
    [anon_sym_RPAREN] = ACTIONS(2849),
    [anon_sym_fn] = ACTIONS(2849),
    [anon_sym_PLUS] = ACTIONS(2849),
    [anon_sym_DASH] = ACTIONS(2849),
    [anon_sym_STAR] = ACTIONS(2849),
    [anon_sym_SLASH] = ACTIONS(2849),
    [anon_sym_PERCENT] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_GT] = ACTIONS(2849),
    [anon_sym_EQ_EQ] = ACTIONS(2849),
    [anon_sym_BANG_EQ] = ACTIONS(2849),
    [anon_sym_LT_EQ] = ACTIONS(2849),
    [anon_sym_GT_EQ] = ACTIONS(2849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2849),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_struct] = ACTIONS(2849),
    [anon_sym_mut] = ACTIONS(2849),
    [anon_sym_PLUS_PLUS] = ACTIONS(2849),
    [anon_sym_DASH_DASH] = ACTIONS(2849),
    [anon_sym_QMARK] = ACTIONS(2849),
    [anon_sym_BANG] = ACTIONS(2849),
    [anon_sym_go] = ACTIONS(2849),
    [anon_sym_spawn] = ACTIONS(2849),
    [anon_sym_json_DOTdecode] = ACTIONS(2849),
    [anon_sym_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACK2] = ACTIONS(2849),
    [anon_sym_TILDE] = ACTIONS(2849),
    [anon_sym_CARET] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2849),
    [anon_sym_LT_DASH] = ACTIONS(2849),
    [anon_sym_LT_LT] = ACTIONS(2849),
    [anon_sym_GT_GT] = ACTIONS(2849),
    [anon_sym_GT_GT_GT] = ACTIONS(2849),
    [anon_sym_AMP_CARET] = ACTIONS(2849),
    [anon_sym_AMP_AMP] = ACTIONS(2849),
    [anon_sym_PIPE_PIPE] = ACTIONS(2849),
    [anon_sym_or] = ACTIONS(2849),
    [sym_none] = ACTIONS(2849),
    [sym_true] = ACTIONS(2849),
    [sym_false] = ACTIONS(2849),
    [sym_nil] = ACTIONS(2849),
    [anon_sym_QMARK_DOT] = ACTIONS(2849),
    [anon_sym_POUND_LBRACK] = ACTIONS(2849),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_DOLLARif] = ACTIONS(2849),
    [anon_sym_is] = ACTIONS(2849),
    [anon_sym_BANGis] = ACTIONS(2849),
    [anon_sym_in] = ACTIONS(2849),
    [anon_sym_BANGin] = ACTIONS(2849),
    [anon_sym_match] = ACTIONS(2849),
    [anon_sym_select] = ACTIONS(2849),
    [anon_sym_lock] = ACTIONS(2849),
    [anon_sym_rlock] = ACTIONS(2849),
    [anon_sym_unsafe] = ACTIONS(2849),
    [anon_sym_sql] = ACTIONS(2849),
    [sym_int_literal] = ACTIONS(2849),
    [sym_float_literal] = ACTIONS(2849),
    [sym_rune_literal] = ACTIONS(2849),
    [anon_sym_SQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [anon_sym_c_SQUOTE] = ACTIONS(2849),
    [anon_sym_c_DQUOTE] = ACTIONS(2849),
    [anon_sym_r_SQUOTE] = ACTIONS(2849),
    [anon_sym_r_DQUOTE] = ACTIONS(2849),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2849),
    [anon_sym_shared] = ACTIONS(2849),
    [anon_sym_map_LBRACK] = ACTIONS(2849),
    [anon_sym_chan] = ACTIONS(2849),
    [anon_sym_thread] = ACTIONS(2849),
    [anon_sym_atomic] = ACTIONS(2849),
  },
  [1480] = {
    [sym_line_comment] = STATE(1480),
    [sym_block_comment] = STATE(1480),
    [sym_identifier] = ACTIONS(2845),
    [anon_sym_LF] = ACTIONS(2845),
    [anon_sym_CR] = ACTIONS(2845),
    [anon_sym_CR_LF] = ACTIONS(2845),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym_DOT] = ACTIONS(2845),
    [anon_sym_as] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2845),
    [anon_sym_COMMA] = ACTIONS(2845),
    [anon_sym_RBRACE] = ACTIONS(2845),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_RPAREN] = ACTIONS(2845),
    [anon_sym_fn] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2845),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_SLASH] = ACTIONS(2845),
    [anon_sym_PERCENT] = ACTIONS(2845),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_GT] = ACTIONS(2845),
    [anon_sym_EQ_EQ] = ACTIONS(2845),
    [anon_sym_BANG_EQ] = ACTIONS(2845),
    [anon_sym_LT_EQ] = ACTIONS(2845),
    [anon_sym_GT_EQ] = ACTIONS(2845),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2845),
    [anon_sym_mut] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2845),
    [anon_sym_DASH_DASH] = ACTIONS(2845),
    [anon_sym_QMARK] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_go] = ACTIONS(2845),
    [anon_sym_spawn] = ACTIONS(2845),
    [anon_sym_json_DOTdecode] = ACTIONS(2845),
    [anon_sym_PIPE] = ACTIONS(2845),
    [anon_sym_LBRACK2] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_CARET] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2845),
    [anon_sym_LT_DASH] = ACTIONS(2845),
    [anon_sym_LT_LT] = ACTIONS(2845),
    [anon_sym_GT_GT] = ACTIONS(2845),
    [anon_sym_GT_GT_GT] = ACTIONS(2845),
    [anon_sym_AMP_CARET] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_PIPE_PIPE] = ACTIONS(2845),
    [anon_sym_or] = ACTIONS(2845),
    [sym_none] = ACTIONS(2845),
    [sym_true] = ACTIONS(2845),
    [sym_false] = ACTIONS(2845),
    [sym_nil] = ACTIONS(2845),
    [anon_sym_QMARK_DOT] = ACTIONS(2845),
    [anon_sym_POUND_LBRACK] = ACTIONS(2845),
    [anon_sym_if] = ACTIONS(2845),
    [anon_sym_DOLLARif] = ACTIONS(2845),
    [anon_sym_is] = ACTIONS(2845),
    [anon_sym_BANGis] = ACTIONS(2845),
    [anon_sym_in] = ACTIONS(2845),
    [anon_sym_BANGin] = ACTIONS(2845),
    [anon_sym_match] = ACTIONS(2845),
    [anon_sym_select] = ACTIONS(2845),
    [anon_sym_lock] = ACTIONS(2845),
    [anon_sym_rlock] = ACTIONS(2845),
    [anon_sym_unsafe] = ACTIONS(2845),
    [anon_sym_sql] = ACTIONS(2845),
    [sym_int_literal] = ACTIONS(2845),
    [sym_float_literal] = ACTIONS(2845),
    [sym_rune_literal] = ACTIONS(2845),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2845),
    [anon_sym_c_SQUOTE] = ACTIONS(2845),
    [anon_sym_c_DQUOTE] = ACTIONS(2845),
    [anon_sym_r_SQUOTE] = ACTIONS(2845),
    [anon_sym_r_DQUOTE] = ACTIONS(2845),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2845),
    [anon_sym_shared] = ACTIONS(2845),
    [anon_sym_map_LBRACK] = ACTIONS(2845),
    [anon_sym_chan] = ACTIONS(2845),
    [anon_sym_thread] = ACTIONS(2845),
    [anon_sym_atomic] = ACTIONS(2845),
  },
  [1481] = {
    [sym_line_comment] = STATE(1481),
    [sym_block_comment] = STATE(1481),
    [sym_identifier] = ACTIONS(2947),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_CR] = ACTIONS(2947),
    [anon_sym_CR_LF] = ACTIONS(2947),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_DOT] = ACTIONS(2947),
    [anon_sym_as] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_COMMA] = ACTIONS(2947),
    [anon_sym_RBRACE] = ACTIONS(2947),
    [anon_sym_LPAREN] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_fn] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_STAR] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(2947),
    [anon_sym_PERCENT] = ACTIONS(2947),
    [anon_sym_LT] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2947),
    [anon_sym_EQ_EQ] = ACTIONS(2947),
    [anon_sym_BANG_EQ] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2947),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2945),
    [anon_sym_struct] = ACTIONS(2947),
    [anon_sym_mut] = ACTIONS(2947),
    [anon_sym_PLUS_PLUS] = ACTIONS(2947),
    [anon_sym_DASH_DASH] = ACTIONS(2947),
    [anon_sym_QMARK] = ACTIONS(2947),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_go] = ACTIONS(2947),
    [anon_sym_spawn] = ACTIONS(2947),
    [anon_sym_json_DOTdecode] = ACTIONS(2947),
    [anon_sym_PIPE] = ACTIONS(2947),
    [anon_sym_LBRACK2] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2947),
    [anon_sym_CARET] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2947),
    [anon_sym_LT_DASH] = ACTIONS(2947),
    [anon_sym_LT_LT] = ACTIONS(2947),
    [anon_sym_GT_GT] = ACTIONS(2947),
    [anon_sym_GT_GT_GT] = ACTIONS(2947),
    [anon_sym_AMP_CARET] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [anon_sym_or] = ACTIONS(2947),
    [sym_none] = ACTIONS(2947),
    [sym_true] = ACTIONS(2947),
    [sym_false] = ACTIONS(2947),
    [sym_nil] = ACTIONS(2947),
    [anon_sym_QMARK_DOT] = ACTIONS(2947),
    [anon_sym_POUND_LBRACK] = ACTIONS(2947),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_DOLLARif] = ACTIONS(2947),
    [anon_sym_is] = ACTIONS(2947),
    [anon_sym_BANGis] = ACTIONS(2947),
    [anon_sym_in] = ACTIONS(2947),
    [anon_sym_BANGin] = ACTIONS(2947),
    [anon_sym_match] = ACTIONS(2947),
    [anon_sym_select] = ACTIONS(2947),
    [anon_sym_lock] = ACTIONS(2947),
    [anon_sym_rlock] = ACTIONS(2947),
    [anon_sym_unsafe] = ACTIONS(2947),
    [anon_sym_sql] = ACTIONS(2947),
    [sym_int_literal] = ACTIONS(2947),
    [sym_float_literal] = ACTIONS(2947),
    [sym_rune_literal] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(2947),
    [anon_sym_DQUOTE] = ACTIONS(2947),
    [anon_sym_c_SQUOTE] = ACTIONS(2947),
    [anon_sym_c_DQUOTE] = ACTIONS(2947),
    [anon_sym_r_SQUOTE] = ACTIONS(2947),
    [anon_sym_r_DQUOTE] = ACTIONS(2947),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2947),
    [anon_sym_shared] = ACTIONS(2947),
    [anon_sym_map_LBRACK] = ACTIONS(2947),
    [anon_sym_chan] = ACTIONS(2947),
    [anon_sym_thread] = ACTIONS(2947),
    [anon_sym_atomic] = ACTIONS(2947),
  },
  [1482] = {
    [sym_line_comment] = STATE(1482),
    [sym_block_comment] = STATE(1482),
    [sym_identifier] = ACTIONS(2457),
    [anon_sym_LF] = ACTIONS(2457),
    [anon_sym_CR] = ACTIONS(2457),
    [anon_sym_CR_LF] = ACTIONS(2457),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2457),
    [anon_sym_DOT] = ACTIONS(2457),
    [anon_sym_as] = ACTIONS(2457),
    [anon_sym_LBRACE] = ACTIONS(2457),
    [anon_sym_COMMA] = ACTIONS(2457),
    [anon_sym_RBRACE] = ACTIONS(2457),
    [anon_sym_LPAREN] = ACTIONS(2457),
    [anon_sym_RPAREN] = ACTIONS(2457),
    [anon_sym_fn] = ACTIONS(2457),
    [anon_sym_PLUS] = ACTIONS(2457),
    [anon_sym_DASH] = ACTIONS(2457),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_PERCENT] = ACTIONS(2457),
    [anon_sym_LT] = ACTIONS(2457),
    [anon_sym_GT] = ACTIONS(2457),
    [anon_sym_EQ_EQ] = ACTIONS(2457),
    [anon_sym_BANG_EQ] = ACTIONS(2457),
    [anon_sym_LT_EQ] = ACTIONS(2457),
    [anon_sym_GT_EQ] = ACTIONS(2457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_struct] = ACTIONS(2457),
    [anon_sym_mut] = ACTIONS(2457),
    [anon_sym_PLUS_PLUS] = ACTIONS(2457),
    [anon_sym_DASH_DASH] = ACTIONS(2457),
    [anon_sym_QMARK] = ACTIONS(2457),
    [anon_sym_BANG] = ACTIONS(2457),
    [anon_sym_go] = ACTIONS(2457),
    [anon_sym_spawn] = ACTIONS(2457),
    [anon_sym_json_DOTdecode] = ACTIONS(2457),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_LBRACK2] = ACTIONS(2457),
    [anon_sym_TILDE] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2457),
    [anon_sym_AMP] = ACTIONS(2457),
    [anon_sym_LT_DASH] = ACTIONS(2457),
    [anon_sym_LT_LT] = ACTIONS(2457),
    [anon_sym_GT_GT] = ACTIONS(2457),
    [anon_sym_GT_GT_GT] = ACTIONS(2457),
    [anon_sym_AMP_CARET] = ACTIONS(2457),
    [anon_sym_AMP_AMP] = ACTIONS(2457),
    [anon_sym_PIPE_PIPE] = ACTIONS(2457),
    [anon_sym_or] = ACTIONS(2457),
    [sym_none] = ACTIONS(2457),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [sym_nil] = ACTIONS(2457),
    [anon_sym_QMARK_DOT] = ACTIONS(2457),
    [anon_sym_POUND_LBRACK] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2457),
    [anon_sym_DOLLARif] = ACTIONS(2457),
    [anon_sym_is] = ACTIONS(2457),
    [anon_sym_BANGis] = ACTIONS(2457),
    [anon_sym_in] = ACTIONS(2457),
    [anon_sym_BANGin] = ACTIONS(2457),
    [anon_sym_match] = ACTIONS(2457),
    [anon_sym_select] = ACTIONS(2457),
    [anon_sym_lock] = ACTIONS(2457),
    [anon_sym_rlock] = ACTIONS(2457),
    [anon_sym_unsafe] = ACTIONS(2457),
    [anon_sym_sql] = ACTIONS(2457),
    [sym_int_literal] = ACTIONS(2457),
    [sym_float_literal] = ACTIONS(2457),
    [sym_rune_literal] = ACTIONS(2457),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_DQUOTE] = ACTIONS(2457),
    [anon_sym_c_SQUOTE] = ACTIONS(2457),
    [anon_sym_c_DQUOTE] = ACTIONS(2457),
    [anon_sym_r_SQUOTE] = ACTIONS(2457),
    [anon_sym_r_DQUOTE] = ACTIONS(2457),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2457),
    [anon_sym_shared] = ACTIONS(2457),
    [anon_sym_map_LBRACK] = ACTIONS(2457),
    [anon_sym_chan] = ACTIONS(2457),
    [anon_sym_thread] = ACTIONS(2457),
    [anon_sym_atomic] = ACTIONS(2457),
  },
  [1483] = {
    [sym_line_comment] = STATE(1483),
    [sym_block_comment] = STATE(1483),
    [sym_identifier] = ACTIONS(3080),
    [anon_sym_LF] = ACTIONS(3080),
    [anon_sym_CR] = ACTIONS(3080),
    [anon_sym_CR_LF] = ACTIONS(3080),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_DOT] = ACTIONS(3080),
    [anon_sym_as] = ACTIONS(3080),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_COMMA] = ACTIONS(3080),
    [anon_sym_RBRACE] = ACTIONS(3080),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_RPAREN] = ACTIONS(3080),
    [anon_sym_fn] = ACTIONS(3080),
    [anon_sym_PLUS] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3080),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_SLASH] = ACTIONS(3080),
    [anon_sym_PERCENT] = ACTIONS(3080),
    [anon_sym_LT] = ACTIONS(3080),
    [anon_sym_GT] = ACTIONS(3080),
    [anon_sym_EQ_EQ] = ACTIONS(3080),
    [anon_sym_BANG_EQ] = ACTIONS(3080),
    [anon_sym_LT_EQ] = ACTIONS(3080),
    [anon_sym_GT_EQ] = ACTIONS(3080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3080),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_struct] = ACTIONS(3080),
    [anon_sym_mut] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_QMARK] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_go] = ACTIONS(3080),
    [anon_sym_spawn] = ACTIONS(3080),
    [anon_sym_json_DOTdecode] = ACTIONS(3080),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_LBRACK2] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_CARET] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3080),
    [anon_sym_LT_DASH] = ACTIONS(3080),
    [anon_sym_LT_LT] = ACTIONS(3080),
    [anon_sym_GT_GT] = ACTIONS(3080),
    [anon_sym_GT_GT_GT] = ACTIONS(3080),
    [anon_sym_AMP_CARET] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_PIPE_PIPE] = ACTIONS(3080),
    [anon_sym_or] = ACTIONS(3080),
    [sym_none] = ACTIONS(3080),
    [sym_true] = ACTIONS(3080),
    [sym_false] = ACTIONS(3080),
    [sym_nil] = ACTIONS(3080),
    [anon_sym_QMARK_DOT] = ACTIONS(3080),
    [anon_sym_POUND_LBRACK] = ACTIONS(3080),
    [anon_sym_if] = ACTIONS(3080),
    [anon_sym_DOLLARif] = ACTIONS(3080),
    [anon_sym_is] = ACTIONS(3080),
    [anon_sym_BANGis] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3080),
    [anon_sym_BANGin] = ACTIONS(3080),
    [anon_sym_match] = ACTIONS(3080),
    [anon_sym_select] = ACTIONS(3080),
    [anon_sym_lock] = ACTIONS(3080),
    [anon_sym_rlock] = ACTIONS(3080),
    [anon_sym_unsafe] = ACTIONS(3080),
    [anon_sym_sql] = ACTIONS(3080),
    [sym_int_literal] = ACTIONS(3080),
    [sym_float_literal] = ACTIONS(3080),
    [sym_rune_literal] = ACTIONS(3080),
    [anon_sym_SQUOTE] = ACTIONS(3080),
    [anon_sym_DQUOTE] = ACTIONS(3080),
    [anon_sym_c_SQUOTE] = ACTIONS(3080),
    [anon_sym_c_DQUOTE] = ACTIONS(3080),
    [anon_sym_r_SQUOTE] = ACTIONS(3080),
    [anon_sym_r_DQUOTE] = ACTIONS(3080),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3080),
    [anon_sym_shared] = ACTIONS(3080),
    [anon_sym_map_LBRACK] = ACTIONS(3080),
    [anon_sym_chan] = ACTIONS(3080),
    [anon_sym_thread] = ACTIONS(3080),
    [anon_sym_atomic] = ACTIONS(3080),
  },
  [1484] = {
    [sym_line_comment] = STATE(1484),
    [sym_block_comment] = STATE(1484),
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2373),
    [anon_sym_CR] = ACTIONS(2373),
    [anon_sym_CR_LF] = ACTIONS(2373),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_DOT] = ACTIONS(2373),
    [anon_sym_as] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2373),
    [anon_sym_COMMA] = ACTIONS(2373),
    [anon_sym_RBRACE] = ACTIONS(2373),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym_RPAREN] = ACTIONS(2373),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_SLASH] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2373),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_mut] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2373),
    [anon_sym_QMARK] = ACTIONS(2373),
    [anon_sym_BANG] = ACTIONS(2373),
    [anon_sym_go] = ACTIONS(2373),
    [anon_sym_spawn] = ACTIONS(2373),
    [anon_sym_json_DOTdecode] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_LBRACK2] = ACTIONS(2373),
    [anon_sym_TILDE] = ACTIONS(2373),
    [anon_sym_CARET] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_LT_DASH] = ACTIONS(2373),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2373),
    [anon_sym_AMP_CARET] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2373),
    [anon_sym_or] = ACTIONS(2373),
    [sym_none] = ACTIONS(2373),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [sym_nil] = ACTIONS(2373),
    [anon_sym_QMARK_DOT] = ACTIONS(2373),
    [anon_sym_POUND_LBRACK] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_DOLLARif] = ACTIONS(2373),
    [anon_sym_is] = ACTIONS(2373),
    [anon_sym_BANGis] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_BANGin] = ACTIONS(2373),
    [anon_sym_match] = ACTIONS(2373),
    [anon_sym_select] = ACTIONS(2373),
    [anon_sym_lock] = ACTIONS(2373),
    [anon_sym_rlock] = ACTIONS(2373),
    [anon_sym_unsafe] = ACTIONS(2373),
    [anon_sym_sql] = ACTIONS(2373),
    [sym_int_literal] = ACTIONS(2373),
    [sym_float_literal] = ACTIONS(2373),
    [sym_rune_literal] = ACTIONS(2373),
    [anon_sym_SQUOTE] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(2373),
    [anon_sym_c_SQUOTE] = ACTIONS(2373),
    [anon_sym_c_DQUOTE] = ACTIONS(2373),
    [anon_sym_r_SQUOTE] = ACTIONS(2373),
    [anon_sym_r_DQUOTE] = ACTIONS(2373),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_map_LBRACK] = ACTIONS(2373),
    [anon_sym_chan] = ACTIONS(2373),
    [anon_sym_thread] = ACTIONS(2373),
    [anon_sym_atomic] = ACTIONS(2373),
  },
  [1485] = {
    [sym_line_comment] = STATE(1485),
    [sym_block_comment] = STATE(1485),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LF] = ACTIONS(3340),
    [anon_sym_CR] = ACTIONS(3340),
    [anon_sym_CR_LF] = ACTIONS(3340),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3340),
    [anon_sym_DOT] = ACTIONS(3340),
    [anon_sym_as] = ACTIONS(3340),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_COMMA] = ACTIONS(3340),
    [anon_sym_RBRACE] = ACTIONS(3340),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_RPAREN] = ACTIONS(3340),
    [anon_sym_fn] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_STAR] = ACTIONS(3340),
    [anon_sym_SLASH] = ACTIONS(3340),
    [anon_sym_PERCENT] = ACTIONS(3340),
    [anon_sym_LT] = ACTIONS(3340),
    [anon_sym_GT] = ACTIONS(3340),
    [anon_sym_EQ_EQ] = ACTIONS(3340),
    [anon_sym_BANG_EQ] = ACTIONS(3340),
    [anon_sym_LT_EQ] = ACTIONS(3340),
    [anon_sym_GT_EQ] = ACTIONS(3340),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3338),
    [anon_sym_struct] = ACTIONS(3340),
    [anon_sym_mut] = ACTIONS(3340),
    [anon_sym_PLUS_PLUS] = ACTIONS(3340),
    [anon_sym_DASH_DASH] = ACTIONS(3340),
    [anon_sym_QMARK] = ACTIONS(3340),
    [anon_sym_BANG] = ACTIONS(3340),
    [anon_sym_go] = ACTIONS(3340),
    [anon_sym_spawn] = ACTIONS(3340),
    [anon_sym_json_DOTdecode] = ACTIONS(3340),
    [anon_sym_PIPE] = ACTIONS(3340),
    [anon_sym_LBRACK2] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3340),
    [anon_sym_CARET] = ACTIONS(3340),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LT_DASH] = ACTIONS(3340),
    [anon_sym_LT_LT] = ACTIONS(3340),
    [anon_sym_GT_GT] = ACTIONS(3340),
    [anon_sym_GT_GT_GT] = ACTIONS(3340),
    [anon_sym_AMP_CARET] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3340),
    [anon_sym_PIPE_PIPE] = ACTIONS(3340),
    [anon_sym_or] = ACTIONS(3340),
    [sym_none] = ACTIONS(3340),
    [sym_true] = ACTIONS(3340),
    [sym_false] = ACTIONS(3340),
    [sym_nil] = ACTIONS(3340),
    [anon_sym_QMARK_DOT] = ACTIONS(3340),
    [anon_sym_POUND_LBRACK] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_DOLLARif] = ACTIONS(3340),
    [anon_sym_is] = ACTIONS(3340),
    [anon_sym_BANGis] = ACTIONS(3340),
    [anon_sym_in] = ACTIONS(3340),
    [anon_sym_BANGin] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_select] = ACTIONS(3340),
    [anon_sym_lock] = ACTIONS(3340),
    [anon_sym_rlock] = ACTIONS(3340),
    [anon_sym_unsafe] = ACTIONS(3340),
    [anon_sym_sql] = ACTIONS(3340),
    [sym_int_literal] = ACTIONS(3340),
    [sym_float_literal] = ACTIONS(3340),
    [sym_rune_literal] = ACTIONS(3340),
    [anon_sym_SQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_c_SQUOTE] = ACTIONS(3340),
    [anon_sym_c_DQUOTE] = ACTIONS(3340),
    [anon_sym_r_SQUOTE] = ACTIONS(3340),
    [anon_sym_r_DQUOTE] = ACTIONS(3340),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3340),
    [anon_sym_shared] = ACTIONS(3340),
    [anon_sym_map_LBRACK] = ACTIONS(3340),
    [anon_sym_chan] = ACTIONS(3340),
    [anon_sym_thread] = ACTIONS(3340),
    [anon_sym_atomic] = ACTIONS(3340),
  },
  [1486] = {
    [sym_line_comment] = STATE(1486),
    [sym_block_comment] = STATE(1486),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_LF] = ACTIONS(3336),
    [anon_sym_CR] = ACTIONS(3336),
    [anon_sym_CR_LF] = ACTIONS(3336),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym_DOT] = ACTIONS(3336),
    [anon_sym_as] = ACTIONS(3336),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_RBRACE] = ACTIONS(3336),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_RPAREN] = ACTIONS(3336),
    [anon_sym_fn] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_SLASH] = ACTIONS(3336),
    [anon_sym_PERCENT] = ACTIONS(3336),
    [anon_sym_LT] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3336),
    [anon_sym_EQ_EQ] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_LT_EQ] = ACTIONS(3336),
    [anon_sym_GT_EQ] = ACTIONS(3336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_mut] = ACTIONS(3336),
    [anon_sym_PLUS_PLUS] = ACTIONS(3336),
    [anon_sym_DASH_DASH] = ACTIONS(3336),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_BANG] = ACTIONS(3336),
    [anon_sym_go] = ACTIONS(3336),
    [anon_sym_spawn] = ACTIONS(3336),
    [anon_sym_json_DOTdecode] = ACTIONS(3336),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3336),
    [anon_sym_CARET] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LT_DASH] = ACTIONS(3336),
    [anon_sym_LT_LT] = ACTIONS(3336),
    [anon_sym_GT_GT] = ACTIONS(3336),
    [anon_sym_GT_GT_GT] = ACTIONS(3336),
    [anon_sym_AMP_CARET] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_or] = ACTIONS(3336),
    [sym_none] = ACTIONS(3336),
    [sym_true] = ACTIONS(3336),
    [sym_false] = ACTIONS(3336),
    [sym_nil] = ACTIONS(3336),
    [anon_sym_QMARK_DOT] = ACTIONS(3336),
    [anon_sym_POUND_LBRACK] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_DOLLARif] = ACTIONS(3336),
    [anon_sym_is] = ACTIONS(3336),
    [anon_sym_BANGis] = ACTIONS(3336),
    [anon_sym_in] = ACTIONS(3336),
    [anon_sym_BANGin] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_select] = ACTIONS(3336),
    [anon_sym_lock] = ACTIONS(3336),
    [anon_sym_rlock] = ACTIONS(3336),
    [anon_sym_unsafe] = ACTIONS(3336),
    [anon_sym_sql] = ACTIONS(3336),
    [sym_int_literal] = ACTIONS(3336),
    [sym_float_literal] = ACTIONS(3336),
    [sym_rune_literal] = ACTIONS(3336),
    [anon_sym_SQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_c_SQUOTE] = ACTIONS(3336),
    [anon_sym_c_DQUOTE] = ACTIONS(3336),
    [anon_sym_r_SQUOTE] = ACTIONS(3336),
    [anon_sym_r_DQUOTE] = ACTIONS(3336),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3336),
    [anon_sym_shared] = ACTIONS(3336),
    [anon_sym_map_LBRACK] = ACTIONS(3336),
    [anon_sym_chan] = ACTIONS(3336),
    [anon_sym_thread] = ACTIONS(3336),
    [anon_sym_atomic] = ACTIONS(3336),
  },
  [1487] = {
    [sym_line_comment] = STATE(1487),
    [sym_block_comment] = STATE(1487),
    [sym_identifier] = ACTIONS(3332),
    [anon_sym_LF] = ACTIONS(3332),
    [anon_sym_CR] = ACTIONS(3332),
    [anon_sym_CR_LF] = ACTIONS(3332),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3332),
    [anon_sym_DOT] = ACTIONS(3332),
    [anon_sym_as] = ACTIONS(3332),
    [anon_sym_LBRACE] = ACTIONS(3332),
    [anon_sym_COMMA] = ACTIONS(3332),
    [anon_sym_RBRACE] = ACTIONS(3332),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_RPAREN] = ACTIONS(3332),
    [anon_sym_fn] = ACTIONS(3332),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_DASH] = ACTIONS(3332),
    [anon_sym_STAR] = ACTIONS(3332),
    [anon_sym_SLASH] = ACTIONS(3332),
    [anon_sym_PERCENT] = ACTIONS(3332),
    [anon_sym_LT] = ACTIONS(3332),
    [anon_sym_GT] = ACTIONS(3332),
    [anon_sym_EQ_EQ] = ACTIONS(3332),
    [anon_sym_BANG_EQ] = ACTIONS(3332),
    [anon_sym_LT_EQ] = ACTIONS(3332),
    [anon_sym_GT_EQ] = ACTIONS(3332),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3332),
    [anon_sym_LBRACK] = ACTIONS(3330),
    [anon_sym_struct] = ACTIONS(3332),
    [anon_sym_mut] = ACTIONS(3332),
    [anon_sym_PLUS_PLUS] = ACTIONS(3332),
    [anon_sym_DASH_DASH] = ACTIONS(3332),
    [anon_sym_QMARK] = ACTIONS(3332),
    [anon_sym_BANG] = ACTIONS(3332),
    [anon_sym_go] = ACTIONS(3332),
    [anon_sym_spawn] = ACTIONS(3332),
    [anon_sym_json_DOTdecode] = ACTIONS(3332),
    [anon_sym_PIPE] = ACTIONS(3332),
    [anon_sym_LBRACK2] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3332),
    [anon_sym_CARET] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3332),
    [anon_sym_LT_DASH] = ACTIONS(3332),
    [anon_sym_LT_LT] = ACTIONS(3332),
    [anon_sym_GT_GT] = ACTIONS(3332),
    [anon_sym_GT_GT_GT] = ACTIONS(3332),
    [anon_sym_AMP_CARET] = ACTIONS(3332),
    [anon_sym_AMP_AMP] = ACTIONS(3332),
    [anon_sym_PIPE_PIPE] = ACTIONS(3332),
    [anon_sym_or] = ACTIONS(3332),
    [sym_none] = ACTIONS(3332),
    [sym_true] = ACTIONS(3332),
    [sym_false] = ACTIONS(3332),
    [sym_nil] = ACTIONS(3332),
    [anon_sym_QMARK_DOT] = ACTIONS(3332),
    [anon_sym_POUND_LBRACK] = ACTIONS(3332),
    [anon_sym_if] = ACTIONS(3332),
    [anon_sym_DOLLARif] = ACTIONS(3332),
    [anon_sym_is] = ACTIONS(3332),
    [anon_sym_BANGis] = ACTIONS(3332),
    [anon_sym_in] = ACTIONS(3332),
    [anon_sym_BANGin] = ACTIONS(3332),
    [anon_sym_match] = ACTIONS(3332),
    [anon_sym_select] = ACTIONS(3332),
    [anon_sym_lock] = ACTIONS(3332),
    [anon_sym_rlock] = ACTIONS(3332),
    [anon_sym_unsafe] = ACTIONS(3332),
    [anon_sym_sql] = ACTIONS(3332),
    [sym_int_literal] = ACTIONS(3332),
    [sym_float_literal] = ACTIONS(3332),
    [sym_rune_literal] = ACTIONS(3332),
    [anon_sym_SQUOTE] = ACTIONS(3332),
    [anon_sym_DQUOTE] = ACTIONS(3332),
    [anon_sym_c_SQUOTE] = ACTIONS(3332),
    [anon_sym_c_DQUOTE] = ACTIONS(3332),
    [anon_sym_r_SQUOTE] = ACTIONS(3332),
    [anon_sym_r_DQUOTE] = ACTIONS(3332),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3332),
    [anon_sym_shared] = ACTIONS(3332),
    [anon_sym_map_LBRACK] = ACTIONS(3332),
    [anon_sym_chan] = ACTIONS(3332),
    [anon_sym_thread] = ACTIONS(3332),
    [anon_sym_atomic] = ACTIONS(3332),
  },
  [1488] = {
    [sym_line_comment] = STATE(1488),
    [sym_block_comment] = STATE(1488),
    [sym_reference_expression] = STATE(4528),
    [sym_type_reference_expression] = STATE(2017),
    [sym_plain_type] = STATE(2136),
    [sym__plain_type_without_special] = STATE(2110),
    [sym_anon_struct_type] = STATE(2111),
    [sym_multi_return_type] = STATE(2110),
    [sym_result_type] = STATE(2110),
    [sym_option_type] = STATE(2110),
    [sym_qualified_type] = STATE(2017),
    [sym_fixed_array_type] = STATE(2111),
    [sym_array_type] = STATE(2111),
    [sym_pointer_type] = STATE(2111),
    [sym_wrong_pointer_type] = STATE(2111),
    [sym_map_type] = STATE(2111),
    [sym_channel_type] = STATE(2111),
    [sym_shared_type] = STATE(2111),
    [sym_thread_type] = STATE(2111),
    [sym_atomic_type] = STATE(2111),
    [sym_generic_type] = STATE(2111),
    [sym_function_type] = STATE(2111),
    [sym_identifier] = ACTIONS(4190),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(857),
    [anon_sym_as] = ACTIONS(859),
    [anon_sym_LBRACE] = ACTIONS(857),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(4192),
    [anon_sym_EQ] = ACTIONS(859),
    [anon_sym_fn] = ACTIONS(4194),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_EQ_EQ] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(857),
    [anon_sym_LT_EQ] = ACTIONS(857),
    [anon_sym_GT_EQ] = ACTIONS(857),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_struct] = ACTIONS(4198),
    [anon_sym_COLON] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_QMARK] = ACTIONS(4200),
    [anon_sym_BANG] = ACTIONS(4202),
    [anon_sym_PIPE] = ACTIONS(859),
    [anon_sym_LBRACK2] = ACTIONS(4204),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(4206),
    [anon_sym_LT_DASH] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_GT_GT_GT] = ACTIONS(859),
    [anon_sym_AMP_CARET] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [anon_sym_or] = ACTIONS(859),
    [anon_sym_QMARK_DOT] = ACTIONS(857),
    [anon_sym_POUND_LBRACK] = ACTIONS(857),
    [anon_sym_is] = ACTIONS(859),
    [anon_sym_BANGis] = ACTIONS(857),
    [anon_sym_in] = ACTIONS(859),
    [anon_sym_BANGin] = ACTIONS(857),
    [anon_sym_STAR_EQ] = ACTIONS(857),
    [anon_sym_SLASH_EQ] = ACTIONS(857),
    [anon_sym_PERCENT_EQ] = ACTIONS(857),
    [anon_sym_LT_LT_EQ] = ACTIONS(857),
    [anon_sym_GT_GT_EQ] = ACTIONS(857),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(857),
    [anon_sym_AMP_EQ] = ACTIONS(857),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(857),
    [anon_sym_PLUS_EQ] = ACTIONS(857),
    [anon_sym_DASH_EQ] = ACTIONS(857),
    [anon_sym_PIPE_EQ] = ACTIONS(857),
    [anon_sym_CARET_EQ] = ACTIONS(857),
    [anon_sym_shared] = ACTIONS(4208),
    [anon_sym_map_LBRACK] = ACTIONS(4210),
    [anon_sym_chan] = ACTIONS(4212),
    [anon_sym_thread] = ACTIONS(4214),
    [anon_sym_atomic] = ACTIONS(4216),
  },
  [1489] = {
    [sym_line_comment] = STATE(1489),
    [sym_block_comment] = STATE(1489),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_LF] = ACTIONS(3015),
    [anon_sym_CR] = ACTIONS(3015),
    [anon_sym_CR_LF] = ACTIONS(3015),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3015),
    [anon_sym_DOT] = ACTIONS(3015),
    [anon_sym_as] = ACTIONS(3015),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_COMMA] = ACTIONS(3015),
    [anon_sym_RBRACE] = ACTIONS(3015),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_RPAREN] = ACTIONS(3015),
    [anon_sym_fn] = ACTIONS(3015),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(3015),
    [anon_sym_SLASH] = ACTIONS(3015),
    [anon_sym_PERCENT] = ACTIONS(3015),
    [anon_sym_LT] = ACTIONS(3015),
    [anon_sym_GT] = ACTIONS(3015),
    [anon_sym_EQ_EQ] = ACTIONS(3015),
    [anon_sym_BANG_EQ] = ACTIONS(3015),
    [anon_sym_LT_EQ] = ACTIONS(3015),
    [anon_sym_GT_EQ] = ACTIONS(3015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3013),
    [anon_sym_struct] = ACTIONS(3015),
    [anon_sym_mut] = ACTIONS(3015),
    [anon_sym_PLUS_PLUS] = ACTIONS(3015),
    [anon_sym_DASH_DASH] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_BANG] = ACTIONS(3015),
    [anon_sym_go] = ACTIONS(3015),
    [anon_sym_spawn] = ACTIONS(3015),
    [anon_sym_json_DOTdecode] = ACTIONS(3015),
    [anon_sym_PIPE] = ACTIONS(3015),
    [anon_sym_LBRACK2] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3015),
    [anon_sym_CARET] = ACTIONS(3015),
    [anon_sym_AMP] = ACTIONS(3015),
    [anon_sym_LT_DASH] = ACTIONS(3015),
    [anon_sym_LT_LT] = ACTIONS(3015),
    [anon_sym_GT_GT] = ACTIONS(3015),
    [anon_sym_GT_GT_GT] = ACTIONS(3015),
    [anon_sym_AMP_CARET] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_or] = ACTIONS(3015),
    [sym_none] = ACTIONS(3015),
    [sym_true] = ACTIONS(3015),
    [sym_false] = ACTIONS(3015),
    [sym_nil] = ACTIONS(3015),
    [anon_sym_QMARK_DOT] = ACTIONS(3015),
    [anon_sym_POUND_LBRACK] = ACTIONS(3015),
    [anon_sym_if] = ACTIONS(3015),
    [anon_sym_DOLLARif] = ACTIONS(3015),
    [anon_sym_is] = ACTIONS(3015),
    [anon_sym_BANGis] = ACTIONS(3015),
    [anon_sym_in] = ACTIONS(3015),
    [anon_sym_BANGin] = ACTIONS(3015),
    [anon_sym_match] = ACTIONS(3015),
    [anon_sym_select] = ACTIONS(3015),
    [anon_sym_lock] = ACTIONS(3015),
    [anon_sym_rlock] = ACTIONS(3015),
    [anon_sym_unsafe] = ACTIONS(3015),
    [anon_sym_sql] = ACTIONS(3015),
    [sym_int_literal] = ACTIONS(3015),
    [sym_float_literal] = ACTIONS(3015),
    [sym_rune_literal] = ACTIONS(3015),
    [anon_sym_SQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_c_SQUOTE] = ACTIONS(3015),
    [anon_sym_c_DQUOTE] = ACTIONS(3015),
    [anon_sym_r_SQUOTE] = ACTIONS(3015),
    [anon_sym_r_DQUOTE] = ACTIONS(3015),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3015),
    [anon_sym_shared] = ACTIONS(3015),
    [anon_sym_map_LBRACK] = ACTIONS(3015),
    [anon_sym_chan] = ACTIONS(3015),
    [anon_sym_thread] = ACTIONS(3015),
    [anon_sym_atomic] = ACTIONS(3015),
  },
  [1490] = {
    [sym_line_comment] = STATE(1490),
    [sym_block_comment] = STATE(1490),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_LF] = ACTIONS(3274),
    [anon_sym_CR] = ACTIONS(3274),
    [anon_sym_CR_LF] = ACTIONS(3274),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_as] = ACTIONS(3274),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3274),
    [anon_sym_RBRACE] = ACTIONS(3274),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_RPAREN] = ACTIONS(3274),
    [anon_sym_fn] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_SLASH] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_LT] = ACTIONS(3274),
    [anon_sym_GT] = ACTIONS(3274),
    [anon_sym_EQ_EQ] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_LT_EQ] = ACTIONS(3274),
    [anon_sym_GT_EQ] = ACTIONS(3274),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3272),
    [anon_sym_struct] = ACTIONS(3274),
    [anon_sym_mut] = ACTIONS(3274),
    [anon_sym_PLUS_PLUS] = ACTIONS(3274),
    [anon_sym_DASH_DASH] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_BANG] = ACTIONS(3274),
    [anon_sym_go] = ACTIONS(3274),
    [anon_sym_spawn] = ACTIONS(3274),
    [anon_sym_json_DOTdecode] = ACTIONS(3274),
    [anon_sym_PIPE] = ACTIONS(3274),
    [anon_sym_LBRACK2] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3274),
    [anon_sym_CARET] = ACTIONS(3274),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_LT_LT] = ACTIONS(3274),
    [anon_sym_GT_GT] = ACTIONS(3274),
    [anon_sym_GT_GT_GT] = ACTIONS(3274),
    [anon_sym_AMP_CARET] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_or] = ACTIONS(3274),
    [sym_none] = ACTIONS(3274),
    [sym_true] = ACTIONS(3274),
    [sym_false] = ACTIONS(3274),
    [sym_nil] = ACTIONS(3274),
    [anon_sym_QMARK_DOT] = ACTIONS(3274),
    [anon_sym_POUND_LBRACK] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_DOLLARif] = ACTIONS(3274),
    [anon_sym_is] = ACTIONS(3274),
    [anon_sym_BANGis] = ACTIONS(3274),
    [anon_sym_in] = ACTIONS(3274),
    [anon_sym_BANGin] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_select] = ACTIONS(3274),
    [anon_sym_lock] = ACTIONS(3274),
    [anon_sym_rlock] = ACTIONS(3274),
    [anon_sym_unsafe] = ACTIONS(3274),
    [anon_sym_sql] = ACTIONS(3274),
    [sym_int_literal] = ACTIONS(3274),
    [sym_float_literal] = ACTIONS(3274),
    [sym_rune_literal] = ACTIONS(3274),
    [anon_sym_SQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_c_SQUOTE] = ACTIONS(3274),
    [anon_sym_c_DQUOTE] = ACTIONS(3274),
    [anon_sym_r_SQUOTE] = ACTIONS(3274),
    [anon_sym_r_DQUOTE] = ACTIONS(3274),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3274),
    [anon_sym_shared] = ACTIONS(3274),
    [anon_sym_map_LBRACK] = ACTIONS(3274),
    [anon_sym_chan] = ACTIONS(3274),
    [anon_sym_thread] = ACTIONS(3274),
    [anon_sym_atomic] = ACTIONS(3274),
  },
  [1491] = {
    [sym_line_comment] = STATE(1491),
    [sym_block_comment] = STATE(1491),
    [sym_identifier] = ACTIONS(3256),
    [anon_sym_LF] = ACTIONS(3256),
    [anon_sym_CR] = ACTIONS(3256),
    [anon_sym_CR_LF] = ACTIONS(3256),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3256),
    [anon_sym_DOT] = ACTIONS(3256),
    [anon_sym_as] = ACTIONS(3256),
    [anon_sym_LBRACE] = ACTIONS(3256),
    [anon_sym_COMMA] = ACTIONS(3256),
    [anon_sym_RBRACE] = ACTIONS(3256),
    [anon_sym_LPAREN] = ACTIONS(3256),
    [anon_sym_RPAREN] = ACTIONS(3256),
    [anon_sym_fn] = ACTIONS(3256),
    [anon_sym_PLUS] = ACTIONS(3256),
    [anon_sym_DASH] = ACTIONS(3256),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_SLASH] = ACTIONS(3256),
    [anon_sym_PERCENT] = ACTIONS(3256),
    [anon_sym_LT] = ACTIONS(3256),
    [anon_sym_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(3256),
    [anon_sym_BANG_EQ] = ACTIONS(3256),
    [anon_sym_LT_EQ] = ACTIONS(3256),
    [anon_sym_GT_EQ] = ACTIONS(3256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3256),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [anon_sym_struct] = ACTIONS(3256),
    [anon_sym_mut] = ACTIONS(3256),
    [anon_sym_PLUS_PLUS] = ACTIONS(3256),
    [anon_sym_DASH_DASH] = ACTIONS(3256),
    [anon_sym_QMARK] = ACTIONS(3256),
    [anon_sym_BANG] = ACTIONS(3256),
    [anon_sym_go] = ACTIONS(3256),
    [anon_sym_spawn] = ACTIONS(3256),
    [anon_sym_json_DOTdecode] = ACTIONS(3256),
    [anon_sym_PIPE] = ACTIONS(3256),
    [anon_sym_LBRACK2] = ACTIONS(3256),
    [anon_sym_TILDE] = ACTIONS(3256),
    [anon_sym_CARET] = ACTIONS(3256),
    [anon_sym_AMP] = ACTIONS(3256),
    [anon_sym_LT_DASH] = ACTIONS(3256),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_GT_GT_GT] = ACTIONS(3256),
    [anon_sym_AMP_CARET] = ACTIONS(3256),
    [anon_sym_AMP_AMP] = ACTIONS(3256),
    [anon_sym_PIPE_PIPE] = ACTIONS(3256),
    [anon_sym_or] = ACTIONS(3256),
    [sym_none] = ACTIONS(3256),
    [sym_true] = ACTIONS(3256),
    [sym_false] = ACTIONS(3256),
    [sym_nil] = ACTIONS(3256),
    [anon_sym_QMARK_DOT] = ACTIONS(3256),
    [anon_sym_POUND_LBRACK] = ACTIONS(3256),
    [anon_sym_if] = ACTIONS(3256),
    [anon_sym_DOLLARif] = ACTIONS(3256),
    [anon_sym_is] = ACTIONS(3256),
    [anon_sym_BANGis] = ACTIONS(3256),
    [anon_sym_in] = ACTIONS(3256),
    [anon_sym_BANGin] = ACTIONS(3256),
    [anon_sym_match] = ACTIONS(3256),
    [anon_sym_select] = ACTIONS(3256),
    [anon_sym_lock] = ACTIONS(3256),
    [anon_sym_rlock] = ACTIONS(3256),
    [anon_sym_unsafe] = ACTIONS(3256),
    [anon_sym_sql] = ACTIONS(3256),
    [sym_int_literal] = ACTIONS(3256),
    [sym_float_literal] = ACTIONS(3256),
    [sym_rune_literal] = ACTIONS(3256),
    [anon_sym_SQUOTE] = ACTIONS(3256),
    [anon_sym_DQUOTE] = ACTIONS(3256),
    [anon_sym_c_SQUOTE] = ACTIONS(3256),
    [anon_sym_c_DQUOTE] = ACTIONS(3256),
    [anon_sym_r_SQUOTE] = ACTIONS(3256),
    [anon_sym_r_DQUOTE] = ACTIONS(3256),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3256),
    [anon_sym_shared] = ACTIONS(3256),
    [anon_sym_map_LBRACK] = ACTIONS(3256),
    [anon_sym_chan] = ACTIONS(3256),
    [anon_sym_thread] = ACTIONS(3256),
    [anon_sym_atomic] = ACTIONS(3256),
  },
  [1492] = {
    [sym_line_comment] = STATE(1492),
    [sym_block_comment] = STATE(1492),
    [sym_identifier] = ACTIONS(2957),
    [anon_sym_LF] = ACTIONS(2957),
    [anon_sym_CR] = ACTIONS(2957),
    [anon_sym_CR_LF] = ACTIONS(2957),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2957),
    [anon_sym_DOT] = ACTIONS(2957),
    [anon_sym_as] = ACTIONS(2957),
    [anon_sym_LBRACE] = ACTIONS(2957),
    [anon_sym_COMMA] = ACTIONS(2957),
    [anon_sym_RBRACE] = ACTIONS(2957),
    [anon_sym_LPAREN] = ACTIONS(2957),
    [anon_sym_RPAREN] = ACTIONS(2957),
    [anon_sym_fn] = ACTIONS(2957),
    [anon_sym_PLUS] = ACTIONS(2957),
    [anon_sym_DASH] = ACTIONS(2957),
    [anon_sym_STAR] = ACTIONS(2957),
    [anon_sym_SLASH] = ACTIONS(2957),
    [anon_sym_PERCENT] = ACTIONS(2957),
    [anon_sym_LT] = ACTIONS(2957),
    [anon_sym_GT] = ACTIONS(2957),
    [anon_sym_EQ_EQ] = ACTIONS(2957),
    [anon_sym_BANG_EQ] = ACTIONS(2957),
    [anon_sym_LT_EQ] = ACTIONS(2957),
    [anon_sym_GT_EQ] = ACTIONS(2957),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2957),
    [anon_sym_LBRACK] = ACTIONS(2955),
    [anon_sym_struct] = ACTIONS(2957),
    [anon_sym_mut] = ACTIONS(2957),
    [anon_sym_PLUS_PLUS] = ACTIONS(2957),
    [anon_sym_DASH_DASH] = ACTIONS(2957),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_BANG] = ACTIONS(2957),
    [anon_sym_go] = ACTIONS(2957),
    [anon_sym_spawn] = ACTIONS(2957),
    [anon_sym_json_DOTdecode] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2957),
    [anon_sym_LBRACK2] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2957),
    [anon_sym_CARET] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2957),
    [anon_sym_LT_DASH] = ACTIONS(2957),
    [anon_sym_LT_LT] = ACTIONS(2957),
    [anon_sym_GT_GT] = ACTIONS(2957),
    [anon_sym_GT_GT_GT] = ACTIONS(2957),
    [anon_sym_AMP_CARET] = ACTIONS(2957),
    [anon_sym_AMP_AMP] = ACTIONS(2957),
    [anon_sym_PIPE_PIPE] = ACTIONS(2957),
    [anon_sym_or] = ACTIONS(2957),
    [sym_none] = ACTIONS(2957),
    [sym_true] = ACTIONS(2957),
    [sym_false] = ACTIONS(2957),
    [sym_nil] = ACTIONS(2957),
    [anon_sym_QMARK_DOT] = ACTIONS(2957),
    [anon_sym_POUND_LBRACK] = ACTIONS(2957),
    [anon_sym_if] = ACTIONS(2957),
    [anon_sym_DOLLARif] = ACTIONS(2957),
    [anon_sym_is] = ACTIONS(2957),
    [anon_sym_BANGis] = ACTIONS(2957),
    [anon_sym_in] = ACTIONS(2957),
    [anon_sym_BANGin] = ACTIONS(2957),
    [anon_sym_match] = ACTIONS(2957),
    [anon_sym_select] = ACTIONS(2957),
    [anon_sym_lock] = ACTIONS(2957),
    [anon_sym_rlock] = ACTIONS(2957),
    [anon_sym_unsafe] = ACTIONS(2957),
    [anon_sym_sql] = ACTIONS(2957),
    [sym_int_literal] = ACTIONS(2957),
    [sym_float_literal] = ACTIONS(2957),
    [sym_rune_literal] = ACTIONS(2957),
    [anon_sym_SQUOTE] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(2957),
    [anon_sym_c_SQUOTE] = ACTIONS(2957),
    [anon_sym_c_DQUOTE] = ACTIONS(2957),
    [anon_sym_r_SQUOTE] = ACTIONS(2957),
    [anon_sym_r_DQUOTE] = ACTIONS(2957),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2957),
    [anon_sym_shared] = ACTIONS(2957),
    [anon_sym_map_LBRACK] = ACTIONS(2957),
    [anon_sym_chan] = ACTIONS(2957),
    [anon_sym_thread] = ACTIONS(2957),
    [anon_sym_atomic] = ACTIONS(2957),
  },
  [1493] = {
    [sym_line_comment] = STATE(1493),
    [sym_block_comment] = STATE(1493),
    [sym_identifier] = ACTIONS(3035),
    [anon_sym_LF] = ACTIONS(3035),
    [anon_sym_CR] = ACTIONS(3035),
    [anon_sym_CR_LF] = ACTIONS(3035),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym_DOT] = ACTIONS(3035),
    [anon_sym_as] = ACTIONS(3035),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_COMMA] = ACTIONS(3035),
    [anon_sym_RBRACE] = ACTIONS(3035),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(3035),
    [anon_sym_fn] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3035),
    [anon_sym_SLASH] = ACTIONS(3035),
    [anon_sym_PERCENT] = ACTIONS(3035),
    [anon_sym_LT] = ACTIONS(3035),
    [anon_sym_GT] = ACTIONS(3035),
    [anon_sym_EQ_EQ] = ACTIONS(3035),
    [anon_sym_BANG_EQ] = ACTIONS(3035),
    [anon_sym_LT_EQ] = ACTIONS(3035),
    [anon_sym_GT_EQ] = ACTIONS(3035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3033),
    [anon_sym_struct] = ACTIONS(3035),
    [anon_sym_mut] = ACTIONS(3035),
    [anon_sym_PLUS_PLUS] = ACTIONS(3035),
    [anon_sym_DASH_DASH] = ACTIONS(3035),
    [anon_sym_QMARK] = ACTIONS(3035),
    [anon_sym_BANG] = ACTIONS(3035),
    [anon_sym_go] = ACTIONS(3035),
    [anon_sym_spawn] = ACTIONS(3035),
    [anon_sym_json_DOTdecode] = ACTIONS(3035),
    [anon_sym_PIPE] = ACTIONS(3035),
    [anon_sym_LBRACK2] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3035),
    [anon_sym_CARET] = ACTIONS(3035),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_LT_DASH] = ACTIONS(3035),
    [anon_sym_LT_LT] = ACTIONS(3035),
    [anon_sym_GT_GT] = ACTIONS(3035),
    [anon_sym_GT_GT_GT] = ACTIONS(3035),
    [anon_sym_AMP_CARET] = ACTIONS(3035),
    [anon_sym_AMP_AMP] = ACTIONS(3035),
    [anon_sym_PIPE_PIPE] = ACTIONS(3035),
    [anon_sym_or] = ACTIONS(3035),
    [sym_none] = ACTIONS(3035),
    [sym_true] = ACTIONS(3035),
    [sym_false] = ACTIONS(3035),
    [sym_nil] = ACTIONS(3035),
    [anon_sym_QMARK_DOT] = ACTIONS(3035),
    [anon_sym_POUND_LBRACK] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_DOLLARif] = ACTIONS(3035),
    [anon_sym_is] = ACTIONS(3035),
    [anon_sym_BANGis] = ACTIONS(3035),
    [anon_sym_in] = ACTIONS(3035),
    [anon_sym_BANGin] = ACTIONS(3035),
    [anon_sym_match] = ACTIONS(3035),
    [anon_sym_select] = ACTIONS(3035),
    [anon_sym_lock] = ACTIONS(3035),
    [anon_sym_rlock] = ACTIONS(3035),
    [anon_sym_unsafe] = ACTIONS(3035),
    [anon_sym_sql] = ACTIONS(3035),
    [sym_int_literal] = ACTIONS(3035),
    [sym_float_literal] = ACTIONS(3035),
    [sym_rune_literal] = ACTIONS(3035),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_c_SQUOTE] = ACTIONS(3035),
    [anon_sym_c_DQUOTE] = ACTIONS(3035),
    [anon_sym_r_SQUOTE] = ACTIONS(3035),
    [anon_sym_r_DQUOTE] = ACTIONS(3035),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3035),
    [anon_sym_shared] = ACTIONS(3035),
    [anon_sym_map_LBRACK] = ACTIONS(3035),
    [anon_sym_chan] = ACTIONS(3035),
    [anon_sym_thread] = ACTIONS(3035),
    [anon_sym_atomic] = ACTIONS(3035),
  },
  [1494] = {
    [sym_line_comment] = STATE(1494),
    [sym_block_comment] = STATE(1494),
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_LF] = ACTIONS(3045),
    [anon_sym_CR] = ACTIONS(3045),
    [anon_sym_CR_LF] = ACTIONS(3045),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3045),
    [anon_sym_DOT] = ACTIONS(3045),
    [anon_sym_as] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3045),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_RBRACE] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3045),
    [anon_sym_RPAREN] = ACTIONS(3045),
    [anon_sym_fn] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3045),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_PERCENT] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_GT] = ACTIONS(3045),
    [anon_sym_EQ_EQ] = ACTIONS(3045),
    [anon_sym_BANG_EQ] = ACTIONS(3045),
    [anon_sym_LT_EQ] = ACTIONS(3045),
    [anon_sym_GT_EQ] = ACTIONS(3045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_struct] = ACTIONS(3045),
    [anon_sym_mut] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3045),
    [anon_sym_go] = ACTIONS(3045),
    [anon_sym_spawn] = ACTIONS(3045),
    [anon_sym_json_DOTdecode] = ACTIONS(3045),
    [anon_sym_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACK2] = ACTIONS(3045),
    [anon_sym_TILDE] = ACTIONS(3045),
    [anon_sym_CARET] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3045),
    [anon_sym_LT_DASH] = ACTIONS(3045),
    [anon_sym_LT_LT] = ACTIONS(3045),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_GT_GT_GT] = ACTIONS(3045),
    [anon_sym_AMP_CARET] = ACTIONS(3045),
    [anon_sym_AMP_AMP] = ACTIONS(3045),
    [anon_sym_PIPE_PIPE] = ACTIONS(3045),
    [anon_sym_or] = ACTIONS(3045),
    [sym_none] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_nil] = ACTIONS(3045),
    [anon_sym_QMARK_DOT] = ACTIONS(3045),
    [anon_sym_POUND_LBRACK] = ACTIONS(3045),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_DOLLARif] = ACTIONS(3045),
    [anon_sym_is] = ACTIONS(3045),
    [anon_sym_BANGis] = ACTIONS(3045),
    [anon_sym_in] = ACTIONS(3045),
    [anon_sym_BANGin] = ACTIONS(3045),
    [anon_sym_match] = ACTIONS(3045),
    [anon_sym_select] = ACTIONS(3045),
    [anon_sym_lock] = ACTIONS(3045),
    [anon_sym_rlock] = ACTIONS(3045),
    [anon_sym_unsafe] = ACTIONS(3045),
    [anon_sym_sql] = ACTIONS(3045),
    [sym_int_literal] = ACTIONS(3045),
    [sym_float_literal] = ACTIONS(3045),
    [sym_rune_literal] = ACTIONS(3045),
    [anon_sym_SQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE] = ACTIONS(3045),
    [anon_sym_c_SQUOTE] = ACTIONS(3045),
    [anon_sym_c_DQUOTE] = ACTIONS(3045),
    [anon_sym_r_SQUOTE] = ACTIONS(3045),
    [anon_sym_r_DQUOTE] = ACTIONS(3045),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3045),
    [anon_sym_shared] = ACTIONS(3045),
    [anon_sym_map_LBRACK] = ACTIONS(3045),
    [anon_sym_chan] = ACTIONS(3045),
    [anon_sym_thread] = ACTIONS(3045),
    [anon_sym_atomic] = ACTIONS(3045),
  },
  [1495] = {
    [sym_line_comment] = STATE(1495),
    [sym_block_comment] = STATE(1495),
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_LF] = ACTIONS(3019),
    [anon_sym_CR] = ACTIONS(3019),
    [anon_sym_CR_LF] = ACTIONS(3019),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(3019),
    [anon_sym_as] = ACTIONS(3019),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_COMMA] = ACTIONS(3019),
    [anon_sym_RBRACE] = ACTIONS(3019),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym_RPAREN] = ACTIONS(3019),
    [anon_sym_fn] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_STAR] = ACTIONS(3019),
    [anon_sym_SLASH] = ACTIONS(3019),
    [anon_sym_PERCENT] = ACTIONS(3019),
    [anon_sym_LT] = ACTIONS(3019),
    [anon_sym_GT] = ACTIONS(3019),
    [anon_sym_EQ_EQ] = ACTIONS(3019),
    [anon_sym_BANG_EQ] = ACTIONS(3019),
    [anon_sym_LT_EQ] = ACTIONS(3019),
    [anon_sym_GT_EQ] = ACTIONS(3019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3017),
    [anon_sym_struct] = ACTIONS(3019),
    [anon_sym_mut] = ACTIONS(3019),
    [anon_sym_PLUS_PLUS] = ACTIONS(3019),
    [anon_sym_DASH_DASH] = ACTIONS(3019),
    [anon_sym_QMARK] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_go] = ACTIONS(3019),
    [anon_sym_spawn] = ACTIONS(3019),
    [anon_sym_json_DOTdecode] = ACTIONS(3019),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_LBRACK2] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_LT_DASH] = ACTIONS(3019),
    [anon_sym_LT_LT] = ACTIONS(3019),
    [anon_sym_GT_GT] = ACTIONS(3019),
    [anon_sym_GT_GT_GT] = ACTIONS(3019),
    [anon_sym_AMP_CARET] = ACTIONS(3019),
    [anon_sym_AMP_AMP] = ACTIONS(3019),
    [anon_sym_PIPE_PIPE] = ACTIONS(3019),
    [anon_sym_or] = ACTIONS(3019),
    [sym_none] = ACTIONS(3019),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_nil] = ACTIONS(3019),
    [anon_sym_QMARK_DOT] = ACTIONS(3019),
    [anon_sym_POUND_LBRACK] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_DOLLARif] = ACTIONS(3019),
    [anon_sym_is] = ACTIONS(3019),
    [anon_sym_BANGis] = ACTIONS(3019),
    [anon_sym_in] = ACTIONS(3019),
    [anon_sym_BANGin] = ACTIONS(3019),
    [anon_sym_match] = ACTIONS(3019),
    [anon_sym_select] = ACTIONS(3019),
    [anon_sym_lock] = ACTIONS(3019),
    [anon_sym_rlock] = ACTIONS(3019),
    [anon_sym_unsafe] = ACTIONS(3019),
    [anon_sym_sql] = ACTIONS(3019),
    [sym_int_literal] = ACTIONS(3019),
    [sym_float_literal] = ACTIONS(3019),
    [sym_rune_literal] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_c_SQUOTE] = ACTIONS(3019),
    [anon_sym_c_DQUOTE] = ACTIONS(3019),
    [anon_sym_r_SQUOTE] = ACTIONS(3019),
    [anon_sym_r_DQUOTE] = ACTIONS(3019),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3019),
    [anon_sym_shared] = ACTIONS(3019),
    [anon_sym_map_LBRACK] = ACTIONS(3019),
    [anon_sym_chan] = ACTIONS(3019),
    [anon_sym_thread] = ACTIONS(3019),
    [anon_sym_atomic] = ACTIONS(3019),
  },
  [1496] = {
    [sym_line_comment] = STATE(1496),
    [sym_block_comment] = STATE(1496),
    [sym_identifier] = ACTIONS(3069),
    [anon_sym_LF] = ACTIONS(3069),
    [anon_sym_CR] = ACTIONS(3069),
    [anon_sym_CR_LF] = ACTIONS(3069),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3069),
    [anon_sym_DOT] = ACTIONS(3069),
    [anon_sym_as] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3069),
    [anon_sym_COMMA] = ACTIONS(3069),
    [anon_sym_RBRACE] = ACTIONS(3069),
    [anon_sym_LPAREN] = ACTIONS(3069),
    [anon_sym_RPAREN] = ACTIONS(3069),
    [anon_sym_fn] = ACTIONS(3069),
    [anon_sym_PLUS] = ACTIONS(3069),
    [anon_sym_DASH] = ACTIONS(3069),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_SLASH] = ACTIONS(3069),
    [anon_sym_PERCENT] = ACTIONS(3069),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_GT] = ACTIONS(3069),
    [anon_sym_EQ_EQ] = ACTIONS(3069),
    [anon_sym_BANG_EQ] = ACTIONS(3069),
    [anon_sym_LT_EQ] = ACTIONS(3069),
    [anon_sym_GT_EQ] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3069),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_struct] = ACTIONS(3069),
    [anon_sym_mut] = ACTIONS(3069),
    [anon_sym_PLUS_PLUS] = ACTIONS(3069),
    [anon_sym_DASH_DASH] = ACTIONS(3069),
    [anon_sym_QMARK] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(3069),
    [anon_sym_go] = ACTIONS(3069),
    [anon_sym_spawn] = ACTIONS(3069),
    [anon_sym_json_DOTdecode] = ACTIONS(3069),
    [anon_sym_PIPE] = ACTIONS(3069),
    [anon_sym_LBRACK2] = ACTIONS(3069),
    [anon_sym_TILDE] = ACTIONS(3069),
    [anon_sym_CARET] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3069),
    [anon_sym_LT_DASH] = ACTIONS(3069),
    [anon_sym_LT_LT] = ACTIONS(3069),
    [anon_sym_GT_GT] = ACTIONS(3069),
    [anon_sym_GT_GT_GT] = ACTIONS(3069),
    [anon_sym_AMP_CARET] = ACTIONS(3069),
    [anon_sym_AMP_AMP] = ACTIONS(3069),
    [anon_sym_PIPE_PIPE] = ACTIONS(3069),
    [anon_sym_or] = ACTIONS(3069),
    [sym_none] = ACTIONS(3069),
    [sym_true] = ACTIONS(3069),
    [sym_false] = ACTIONS(3069),
    [sym_nil] = ACTIONS(3069),
    [anon_sym_QMARK_DOT] = ACTIONS(3069),
    [anon_sym_POUND_LBRACK] = ACTIONS(3069),
    [anon_sym_if] = ACTIONS(3069),
    [anon_sym_DOLLARif] = ACTIONS(3069),
    [anon_sym_is] = ACTIONS(3069),
    [anon_sym_BANGis] = ACTIONS(3069),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_BANGin] = ACTIONS(3069),
    [anon_sym_match] = ACTIONS(3069),
    [anon_sym_select] = ACTIONS(3069),
    [anon_sym_lock] = ACTIONS(3069),
    [anon_sym_rlock] = ACTIONS(3069),
    [anon_sym_unsafe] = ACTIONS(3069),
    [anon_sym_sql] = ACTIONS(3069),
    [sym_int_literal] = ACTIONS(3069),
    [sym_float_literal] = ACTIONS(3069),
    [sym_rune_literal] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE] = ACTIONS(3069),
    [anon_sym_c_SQUOTE] = ACTIONS(3069),
    [anon_sym_c_DQUOTE] = ACTIONS(3069),
    [anon_sym_r_SQUOTE] = ACTIONS(3069),
    [anon_sym_r_DQUOTE] = ACTIONS(3069),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3069),
    [anon_sym_shared] = ACTIONS(3069),
    [anon_sym_map_LBRACK] = ACTIONS(3069),
    [anon_sym_chan] = ACTIONS(3069),
    [anon_sym_thread] = ACTIONS(3069),
    [anon_sym_atomic] = ACTIONS(3069),
  },
  [1497] = {
    [sym_line_comment] = STATE(1497),
    [sym_block_comment] = STATE(1497),
    [sym_identifier] = ACTIONS(2973),
    [anon_sym_LF] = ACTIONS(2973),
    [anon_sym_CR] = ACTIONS(2973),
    [anon_sym_CR_LF] = ACTIONS(2973),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym_DOT] = ACTIONS(2973),
    [anon_sym_as] = ACTIONS(2973),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_COMMA] = ACTIONS(2973),
    [anon_sym_RBRACE] = ACTIONS(2973),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_RPAREN] = ACTIONS(2973),
    [anon_sym_fn] = ACTIONS(2973),
    [anon_sym_PLUS] = ACTIONS(2973),
    [anon_sym_DASH] = ACTIONS(2973),
    [anon_sym_STAR] = ACTIONS(2973),
    [anon_sym_SLASH] = ACTIONS(2973),
    [anon_sym_PERCENT] = ACTIONS(2973),
    [anon_sym_LT] = ACTIONS(2973),
    [anon_sym_GT] = ACTIONS(2973),
    [anon_sym_EQ_EQ] = ACTIONS(2973),
    [anon_sym_BANG_EQ] = ACTIONS(2973),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2973),
    [anon_sym_LBRACK] = ACTIONS(2971),
    [anon_sym_struct] = ACTIONS(2973),
    [anon_sym_mut] = ACTIONS(2973),
    [anon_sym_PLUS_PLUS] = ACTIONS(2973),
    [anon_sym_DASH_DASH] = ACTIONS(2973),
    [anon_sym_QMARK] = ACTIONS(2973),
    [anon_sym_BANG] = ACTIONS(2973),
    [anon_sym_go] = ACTIONS(2973),
    [anon_sym_spawn] = ACTIONS(2973),
    [anon_sym_json_DOTdecode] = ACTIONS(2973),
    [anon_sym_PIPE] = ACTIONS(2973),
    [anon_sym_LBRACK2] = ACTIONS(2973),
    [anon_sym_TILDE] = ACTIONS(2973),
    [anon_sym_CARET] = ACTIONS(2973),
    [anon_sym_AMP] = ACTIONS(2973),
    [anon_sym_LT_DASH] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2973),
    [anon_sym_GT_GT] = ACTIONS(2973),
    [anon_sym_GT_GT_GT] = ACTIONS(2973),
    [anon_sym_AMP_CARET] = ACTIONS(2973),
    [anon_sym_AMP_AMP] = ACTIONS(2973),
    [anon_sym_PIPE_PIPE] = ACTIONS(2973),
    [anon_sym_or] = ACTIONS(2973),
    [sym_none] = ACTIONS(2973),
    [sym_true] = ACTIONS(2973),
    [sym_false] = ACTIONS(2973),
    [sym_nil] = ACTIONS(2973),
    [anon_sym_QMARK_DOT] = ACTIONS(2973),
    [anon_sym_POUND_LBRACK] = ACTIONS(2973),
    [anon_sym_if] = ACTIONS(2973),
    [anon_sym_DOLLARif] = ACTIONS(2973),
    [anon_sym_is] = ACTIONS(2973),
    [anon_sym_BANGis] = ACTIONS(2973),
    [anon_sym_in] = ACTIONS(2973),
    [anon_sym_BANGin] = ACTIONS(2973),
    [anon_sym_match] = ACTIONS(2973),
    [anon_sym_select] = ACTIONS(2973),
    [anon_sym_lock] = ACTIONS(2973),
    [anon_sym_rlock] = ACTIONS(2973),
    [anon_sym_unsafe] = ACTIONS(2973),
    [anon_sym_sql] = ACTIONS(2973),
    [sym_int_literal] = ACTIONS(2973),
    [sym_float_literal] = ACTIONS(2973),
    [sym_rune_literal] = ACTIONS(2973),
    [anon_sym_SQUOTE] = ACTIONS(2973),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [anon_sym_c_SQUOTE] = ACTIONS(2973),
    [anon_sym_c_DQUOTE] = ACTIONS(2973),
    [anon_sym_r_SQUOTE] = ACTIONS(2973),
    [anon_sym_r_DQUOTE] = ACTIONS(2973),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2973),
    [anon_sym_shared] = ACTIONS(2973),
    [anon_sym_map_LBRACK] = ACTIONS(2973),
    [anon_sym_chan] = ACTIONS(2973),
    [anon_sym_thread] = ACTIONS(2973),
    [anon_sym_atomic] = ACTIONS(2973),
  },
  [1498] = {
    [sym_line_comment] = STATE(1498),
    [sym_block_comment] = STATE(1498),
    [sym_identifier] = ACTIONS(2961),
    [anon_sym_LF] = ACTIONS(2961),
    [anon_sym_CR] = ACTIONS(2961),
    [anon_sym_CR_LF] = ACTIONS(2961),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2961),
    [anon_sym_DOT] = ACTIONS(2961),
    [anon_sym_as] = ACTIONS(2961),
    [anon_sym_LBRACE] = ACTIONS(2961),
    [anon_sym_COMMA] = ACTIONS(2961),
    [anon_sym_RBRACE] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(2961),
    [anon_sym_RPAREN] = ACTIONS(2961),
    [anon_sym_fn] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2961),
    [anon_sym_DASH] = ACTIONS(2961),
    [anon_sym_STAR] = ACTIONS(2961),
    [anon_sym_SLASH] = ACTIONS(2961),
    [anon_sym_PERCENT] = ACTIONS(2961),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_GT] = ACTIONS(2961),
    [anon_sym_EQ_EQ] = ACTIONS(2961),
    [anon_sym_BANG_EQ] = ACTIONS(2961),
    [anon_sym_LT_EQ] = ACTIONS(2961),
    [anon_sym_GT_EQ] = ACTIONS(2961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2961),
    [anon_sym_LBRACK] = ACTIONS(2959),
    [anon_sym_struct] = ACTIONS(2961),
    [anon_sym_mut] = ACTIONS(2961),
    [anon_sym_PLUS_PLUS] = ACTIONS(2961),
    [anon_sym_DASH_DASH] = ACTIONS(2961),
    [anon_sym_QMARK] = ACTIONS(2961),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_go] = ACTIONS(2961),
    [anon_sym_spawn] = ACTIONS(2961),
    [anon_sym_json_DOTdecode] = ACTIONS(2961),
    [anon_sym_PIPE] = ACTIONS(2961),
    [anon_sym_LBRACK2] = ACTIONS(2961),
    [anon_sym_TILDE] = ACTIONS(2961),
    [anon_sym_CARET] = ACTIONS(2961),
    [anon_sym_AMP] = ACTIONS(2961),
    [anon_sym_LT_DASH] = ACTIONS(2961),
    [anon_sym_LT_LT] = ACTIONS(2961),
    [anon_sym_GT_GT] = ACTIONS(2961),
    [anon_sym_GT_GT_GT] = ACTIONS(2961),
    [anon_sym_AMP_CARET] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2961),
    [anon_sym_PIPE_PIPE] = ACTIONS(2961),
    [anon_sym_or] = ACTIONS(2961),
    [sym_none] = ACTIONS(2961),
    [sym_true] = ACTIONS(2961),
    [sym_false] = ACTIONS(2961),
    [sym_nil] = ACTIONS(2961),
    [anon_sym_QMARK_DOT] = ACTIONS(2961),
    [anon_sym_POUND_LBRACK] = ACTIONS(2961),
    [anon_sym_if] = ACTIONS(2961),
    [anon_sym_DOLLARif] = ACTIONS(2961),
    [anon_sym_is] = ACTIONS(2961),
    [anon_sym_BANGis] = ACTIONS(2961),
    [anon_sym_in] = ACTIONS(2961),
    [anon_sym_BANGin] = ACTIONS(2961),
    [anon_sym_match] = ACTIONS(2961),
    [anon_sym_select] = ACTIONS(2961),
    [anon_sym_lock] = ACTIONS(2961),
    [anon_sym_rlock] = ACTIONS(2961),
    [anon_sym_unsafe] = ACTIONS(2961),
    [anon_sym_sql] = ACTIONS(2961),
    [sym_int_literal] = ACTIONS(2961),
    [sym_float_literal] = ACTIONS(2961),
    [sym_rune_literal] = ACTIONS(2961),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_DQUOTE] = ACTIONS(2961),
    [anon_sym_c_SQUOTE] = ACTIONS(2961),
    [anon_sym_c_DQUOTE] = ACTIONS(2961),
    [anon_sym_r_SQUOTE] = ACTIONS(2961),
    [anon_sym_r_DQUOTE] = ACTIONS(2961),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2961),
    [anon_sym_shared] = ACTIONS(2961),
    [anon_sym_map_LBRACK] = ACTIONS(2961),
    [anon_sym_chan] = ACTIONS(2961),
    [anon_sym_thread] = ACTIONS(2961),
    [anon_sym_atomic] = ACTIONS(2961),
  },
  [1499] = {
    [sym_line_comment] = STATE(1499),
    [sym_block_comment] = STATE(1499),
    [sym_identifier] = ACTIONS(3023),
    [anon_sym_LF] = ACTIONS(3023),
    [anon_sym_CR] = ACTIONS(3023),
    [anon_sym_CR_LF] = ACTIONS(3023),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3023),
    [anon_sym_DOT] = ACTIONS(3023),
    [anon_sym_as] = ACTIONS(3023),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_COMMA] = ACTIONS(3023),
    [anon_sym_RBRACE] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_RPAREN] = ACTIONS(3023),
    [anon_sym_fn] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_STAR] = ACTIONS(3023),
    [anon_sym_SLASH] = ACTIONS(3023),
    [anon_sym_PERCENT] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3023),
    [anon_sym_GT] = ACTIONS(3023),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT_EQ] = ACTIONS(3023),
    [anon_sym_GT_EQ] = ACTIONS(3023),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3021),
    [anon_sym_struct] = ACTIONS(3023),
    [anon_sym_mut] = ACTIONS(3023),
    [anon_sym_PLUS_PLUS] = ACTIONS(3023),
    [anon_sym_DASH_DASH] = ACTIONS(3023),
    [anon_sym_QMARK] = ACTIONS(3023),
    [anon_sym_BANG] = ACTIONS(3023),
    [anon_sym_go] = ACTIONS(3023),
    [anon_sym_spawn] = ACTIONS(3023),
    [anon_sym_json_DOTdecode] = ACTIONS(3023),
    [anon_sym_PIPE] = ACTIONS(3023),
    [anon_sym_LBRACK2] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3023),
    [anon_sym_CARET] = ACTIONS(3023),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_LT_DASH] = ACTIONS(3023),
    [anon_sym_LT_LT] = ACTIONS(3023),
    [anon_sym_GT_GT] = ACTIONS(3023),
    [anon_sym_GT_GT_GT] = ACTIONS(3023),
    [anon_sym_AMP_CARET] = ACTIONS(3023),
    [anon_sym_AMP_AMP] = ACTIONS(3023),
    [anon_sym_PIPE_PIPE] = ACTIONS(3023),
    [anon_sym_or] = ACTIONS(3023),
    [sym_none] = ACTIONS(3023),
    [sym_true] = ACTIONS(3023),
    [sym_false] = ACTIONS(3023),
    [sym_nil] = ACTIONS(3023),
    [anon_sym_QMARK_DOT] = ACTIONS(3023),
    [anon_sym_POUND_LBRACK] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_DOLLARif] = ACTIONS(3023),
    [anon_sym_is] = ACTIONS(3023),
    [anon_sym_BANGis] = ACTIONS(3023),
    [anon_sym_in] = ACTIONS(3023),
    [anon_sym_BANGin] = ACTIONS(3023),
    [anon_sym_match] = ACTIONS(3023),
    [anon_sym_select] = ACTIONS(3023),
    [anon_sym_lock] = ACTIONS(3023),
    [anon_sym_rlock] = ACTIONS(3023),
    [anon_sym_unsafe] = ACTIONS(3023),
    [anon_sym_sql] = ACTIONS(3023),
    [sym_int_literal] = ACTIONS(3023),
    [sym_float_literal] = ACTIONS(3023),
    [sym_rune_literal] = ACTIONS(3023),
    [anon_sym_SQUOTE] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_c_SQUOTE] = ACTIONS(3023),
    [anon_sym_c_DQUOTE] = ACTIONS(3023),
    [anon_sym_r_SQUOTE] = ACTIONS(3023),
    [anon_sym_r_DQUOTE] = ACTIONS(3023),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3023),
    [anon_sym_shared] = ACTIONS(3023),
    [anon_sym_map_LBRACK] = ACTIONS(3023),
    [anon_sym_chan] = ACTIONS(3023),
    [anon_sym_thread] = ACTIONS(3023),
    [anon_sym_atomic] = ACTIONS(3023),
  },
  [1500] = {
    [sym_line_comment] = STATE(1500),
    [sym_block_comment] = STATE(1500),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_CR] = ACTIONS(2147),
    [anon_sym_CR_LF] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_COMMA] = ACTIONS(2147),
    [anon_sym_RBRACE] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym_RPAREN] = ACTIONS(2147),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2147),
    [anon_sym_BANG_EQ] = ACTIONS(2147),
    [anon_sym_LT_EQ] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2147),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2147),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2147),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2147),
    [anon_sym_AMP_CARET] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [anon_sym_or] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2147),
    [anon_sym_POUND_LBRACK] = ACTIONS(2147),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2147),
    [anon_sym_BANGis] = ACTIONS(2147),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANGin] = ACTIONS(2147),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2147),
    [sym_rune_literal] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_c_SQUOTE] = ACTIONS(2147),
    [anon_sym_c_DQUOTE] = ACTIONS(2147),
    [anon_sym_r_SQUOTE] = ACTIONS(2147),
    [anon_sym_r_DQUOTE] = ACTIONS(2147),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2147),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
  },
  [1501] = {
    [sym_line_comment] = STATE(1501),
    [sym_block_comment] = STATE(1501),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_LF] = ACTIONS(2819),
    [anon_sym_CR] = ACTIONS(2819),
    [anon_sym_CR_LF] = ACTIONS(2819),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2819),
    [anon_sym_DOT] = ACTIONS(2819),
    [anon_sym_as] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(2819),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_RPAREN] = ACTIONS(2819),
    [anon_sym_fn] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_LT] = ACTIONS(2819),
    [anon_sym_GT] = ACTIONS(2819),
    [anon_sym_EQ_EQ] = ACTIONS(2819),
    [anon_sym_BANG_EQ] = ACTIONS(2819),
    [anon_sym_LT_EQ] = ACTIONS(2819),
    [anon_sym_GT_EQ] = ACTIONS(2819),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2817),
    [anon_sym_struct] = ACTIONS(2819),
    [anon_sym_mut] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2819),
    [anon_sym_DASH_DASH] = ACTIONS(2819),
    [anon_sym_QMARK] = ACTIONS(2819),
    [anon_sym_BANG] = ACTIONS(2819),
    [anon_sym_go] = ACTIONS(2819),
    [anon_sym_spawn] = ACTIONS(2819),
    [anon_sym_json_DOTdecode] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(2819),
    [anon_sym_LBRACK2] = ACTIONS(2819),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_CARET] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_LT_DASH] = ACTIONS(2819),
    [anon_sym_LT_LT] = ACTIONS(2819),
    [anon_sym_GT_GT] = ACTIONS(2819),
    [anon_sym_GT_GT_GT] = ACTIONS(2819),
    [anon_sym_AMP_CARET] = ACTIONS(2819),
    [anon_sym_AMP_AMP] = ACTIONS(2819),
    [anon_sym_PIPE_PIPE] = ACTIONS(2819),
    [anon_sym_or] = ACTIONS(2819),
    [sym_none] = ACTIONS(2819),
    [sym_true] = ACTIONS(2819),
    [sym_false] = ACTIONS(2819),
    [sym_nil] = ACTIONS(2819),
    [anon_sym_QMARK_DOT] = ACTIONS(2819),
    [anon_sym_POUND_LBRACK] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_DOLLARif] = ACTIONS(2819),
    [anon_sym_is] = ACTIONS(2819),
    [anon_sym_BANGis] = ACTIONS(2819),
    [anon_sym_in] = ACTIONS(2819),
    [anon_sym_BANGin] = ACTIONS(2819),
    [anon_sym_match] = ACTIONS(2819),
    [anon_sym_select] = ACTIONS(2819),
    [anon_sym_lock] = ACTIONS(2819),
    [anon_sym_rlock] = ACTIONS(2819),
    [anon_sym_unsafe] = ACTIONS(2819),
    [anon_sym_sql] = ACTIONS(2819),
    [sym_int_literal] = ACTIONS(2819),
    [sym_float_literal] = ACTIONS(2819),
    [sym_rune_literal] = ACTIONS(2819),
    [anon_sym_SQUOTE] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2819),
    [anon_sym_c_SQUOTE] = ACTIONS(2819),
    [anon_sym_c_DQUOTE] = ACTIONS(2819),
    [anon_sym_r_SQUOTE] = ACTIONS(2819),
    [anon_sym_r_DQUOTE] = ACTIONS(2819),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2819),
    [anon_sym_shared] = ACTIONS(2819),
    [anon_sym_map_LBRACK] = ACTIONS(2819),
    [anon_sym_chan] = ACTIONS(2819),
    [anon_sym_thread] = ACTIONS(2819),
    [anon_sym_atomic] = ACTIONS(2819),
  },
  [1502] = {
    [sym_line_comment] = STATE(1502),
    [sym_block_comment] = STATE(1502),
    [sym_identifier] = ACTIONS(2935),
    [anon_sym_LF] = ACTIONS(2935),
    [anon_sym_CR] = ACTIONS(2935),
    [anon_sym_CR_LF] = ACTIONS(2935),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2935),
    [anon_sym_DOT] = ACTIONS(2935),
    [anon_sym_as] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(2935),
    [anon_sym_COMMA] = ACTIONS(2935),
    [anon_sym_RBRACE] = ACTIONS(2935),
    [anon_sym_LPAREN] = ACTIONS(2935),
    [anon_sym_RPAREN] = ACTIONS(2935),
    [anon_sym_fn] = ACTIONS(2935),
    [anon_sym_PLUS] = ACTIONS(2935),
    [anon_sym_DASH] = ACTIONS(2935),
    [anon_sym_STAR] = ACTIONS(2935),
    [anon_sym_SLASH] = ACTIONS(2935),
    [anon_sym_PERCENT] = ACTIONS(2935),
    [anon_sym_LT] = ACTIONS(2935),
    [anon_sym_GT] = ACTIONS(2935),
    [anon_sym_EQ_EQ] = ACTIONS(2935),
    [anon_sym_BANG_EQ] = ACTIONS(2935),
    [anon_sym_LT_EQ] = ACTIONS(2935),
    [anon_sym_GT_EQ] = ACTIONS(2935),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2933),
    [anon_sym_struct] = ACTIONS(2935),
    [anon_sym_mut] = ACTIONS(2935),
    [anon_sym_PLUS_PLUS] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2935),
    [anon_sym_QMARK] = ACTIONS(2935),
    [anon_sym_BANG] = ACTIONS(2935),
    [anon_sym_go] = ACTIONS(2935),
    [anon_sym_spawn] = ACTIONS(2935),
    [anon_sym_json_DOTdecode] = ACTIONS(2935),
    [anon_sym_PIPE] = ACTIONS(2935),
    [anon_sym_LBRACK2] = ACTIONS(2935),
    [anon_sym_TILDE] = ACTIONS(2935),
    [anon_sym_CARET] = ACTIONS(2935),
    [anon_sym_AMP] = ACTIONS(2935),
    [anon_sym_LT_DASH] = ACTIONS(2935),
    [anon_sym_LT_LT] = ACTIONS(2935),
    [anon_sym_GT_GT] = ACTIONS(2935),
    [anon_sym_GT_GT_GT] = ACTIONS(2935),
    [anon_sym_AMP_CARET] = ACTIONS(2935),
    [anon_sym_AMP_AMP] = ACTIONS(2935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2935),
    [anon_sym_or] = ACTIONS(2935),
    [sym_none] = ACTIONS(2935),
    [sym_true] = ACTIONS(2935),
    [sym_false] = ACTIONS(2935),
    [sym_nil] = ACTIONS(2935),
    [anon_sym_QMARK_DOT] = ACTIONS(2935),
    [anon_sym_POUND_LBRACK] = ACTIONS(2935),
    [anon_sym_if] = ACTIONS(2935),
    [anon_sym_DOLLARif] = ACTIONS(2935),
    [anon_sym_is] = ACTIONS(2935),
    [anon_sym_BANGis] = ACTIONS(2935),
    [anon_sym_in] = ACTIONS(2935),
    [anon_sym_BANGin] = ACTIONS(2935),
    [anon_sym_match] = ACTIONS(2935),
    [anon_sym_select] = ACTIONS(2935),
    [anon_sym_lock] = ACTIONS(2935),
    [anon_sym_rlock] = ACTIONS(2935),
    [anon_sym_unsafe] = ACTIONS(2935),
    [anon_sym_sql] = ACTIONS(2935),
    [sym_int_literal] = ACTIONS(2935),
    [sym_float_literal] = ACTIONS(2935),
    [sym_rune_literal] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(2935),
    [anon_sym_DQUOTE] = ACTIONS(2935),
    [anon_sym_c_SQUOTE] = ACTIONS(2935),
    [anon_sym_c_DQUOTE] = ACTIONS(2935),
    [anon_sym_r_SQUOTE] = ACTIONS(2935),
    [anon_sym_r_DQUOTE] = ACTIONS(2935),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2935),
    [anon_sym_shared] = ACTIONS(2935),
    [anon_sym_map_LBRACK] = ACTIONS(2935),
    [anon_sym_chan] = ACTIONS(2935),
    [anon_sym_thread] = ACTIONS(2935),
    [anon_sym_atomic] = ACTIONS(2935),
  },
  [1503] = {
    [sym_line_comment] = STATE(1503),
    [sym_block_comment] = STATE(1503),
    [sym_identifier] = ACTIONS(2651),
    [anon_sym_LF] = ACTIONS(2651),
    [anon_sym_CR] = ACTIONS(2651),
    [anon_sym_CR_LF] = ACTIONS(2651),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2651),
    [anon_sym_DOT] = ACTIONS(2651),
    [anon_sym_as] = ACTIONS(2651),
    [anon_sym_LBRACE] = ACTIONS(2651),
    [anon_sym_COMMA] = ACTIONS(2651),
    [anon_sym_RBRACE] = ACTIONS(2651),
    [anon_sym_LPAREN] = ACTIONS(2651),
    [anon_sym_RPAREN] = ACTIONS(2651),
    [anon_sym_fn] = ACTIONS(2651),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_STAR] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2651),
    [anon_sym_PERCENT] = ACTIONS(2651),
    [anon_sym_LT] = ACTIONS(2651),
    [anon_sym_GT] = ACTIONS(2651),
    [anon_sym_EQ_EQ] = ACTIONS(2651),
    [anon_sym_BANG_EQ] = ACTIONS(2651),
    [anon_sym_LT_EQ] = ACTIONS(2651),
    [anon_sym_GT_EQ] = ACTIONS(2651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2651),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_struct] = ACTIONS(2651),
    [anon_sym_mut] = ACTIONS(2651),
    [anon_sym_PLUS_PLUS] = ACTIONS(2651),
    [anon_sym_DASH_DASH] = ACTIONS(2651),
    [anon_sym_QMARK] = ACTIONS(2651),
    [anon_sym_BANG] = ACTIONS(2651),
    [anon_sym_go] = ACTIONS(2651),
    [anon_sym_spawn] = ACTIONS(2651),
    [anon_sym_json_DOTdecode] = ACTIONS(2651),
    [anon_sym_PIPE] = ACTIONS(2651),
    [anon_sym_LBRACK2] = ACTIONS(2651),
    [anon_sym_TILDE] = ACTIONS(2651),
    [anon_sym_CARET] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2651),
    [anon_sym_LT_DASH] = ACTIONS(2651),
    [anon_sym_LT_LT] = ACTIONS(2651),
    [anon_sym_GT_GT] = ACTIONS(2651),
    [anon_sym_GT_GT_GT] = ACTIONS(2651),
    [anon_sym_AMP_CARET] = ACTIONS(2651),
    [anon_sym_AMP_AMP] = ACTIONS(2651),
    [anon_sym_PIPE_PIPE] = ACTIONS(2651),
    [anon_sym_or] = ACTIONS(2651),
    [sym_none] = ACTIONS(2651),
    [sym_true] = ACTIONS(2651),
    [sym_false] = ACTIONS(2651),
    [sym_nil] = ACTIONS(2651),
    [anon_sym_QMARK_DOT] = ACTIONS(2651),
    [anon_sym_POUND_LBRACK] = ACTIONS(2651),
    [anon_sym_if] = ACTIONS(2651),
    [anon_sym_DOLLARif] = ACTIONS(2651),
    [anon_sym_is] = ACTIONS(2651),
    [anon_sym_BANGis] = ACTIONS(2651),
    [anon_sym_in] = ACTIONS(2651),
    [anon_sym_BANGin] = ACTIONS(2651),
    [anon_sym_match] = ACTIONS(2651),
    [anon_sym_select] = ACTIONS(2651),
    [anon_sym_lock] = ACTIONS(2651),
    [anon_sym_rlock] = ACTIONS(2651),
    [anon_sym_unsafe] = ACTIONS(2651),
    [anon_sym_sql] = ACTIONS(2651),
    [sym_int_literal] = ACTIONS(2651),
    [sym_float_literal] = ACTIONS(2651),
    [sym_rune_literal] = ACTIONS(2651),
    [anon_sym_SQUOTE] = ACTIONS(2651),
    [anon_sym_DQUOTE] = ACTIONS(2651),
    [anon_sym_c_SQUOTE] = ACTIONS(2651),
    [anon_sym_c_DQUOTE] = ACTIONS(2651),
    [anon_sym_r_SQUOTE] = ACTIONS(2651),
    [anon_sym_r_DQUOTE] = ACTIONS(2651),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2651),
    [anon_sym_shared] = ACTIONS(2651),
    [anon_sym_map_LBRACK] = ACTIONS(2651),
    [anon_sym_chan] = ACTIONS(2651),
    [anon_sym_thread] = ACTIONS(2651),
    [anon_sym_atomic] = ACTIONS(2651),
  },
  [1504] = {
    [sym_line_comment] = STATE(1504),
    [sym_block_comment] = STATE(1504),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_LF] = ACTIONS(3300),
    [anon_sym_CR] = ACTIONS(3300),
    [anon_sym_CR_LF] = ACTIONS(3300),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(3300),
    [anon_sym_as] = ACTIONS(3300),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(3300),
    [anon_sym_RBRACE] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_RPAREN] = ACTIONS(3300),
    [anon_sym_fn] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_SLASH] = ACTIONS(3300),
    [anon_sym_PERCENT] = ACTIONS(3300),
    [anon_sym_LT] = ACTIONS(3300),
    [anon_sym_GT] = ACTIONS(3300),
    [anon_sym_EQ_EQ] = ACTIONS(3300),
    [anon_sym_BANG_EQ] = ACTIONS(3300),
    [anon_sym_LT_EQ] = ACTIONS(3300),
    [anon_sym_GT_EQ] = ACTIONS(3300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_struct] = ACTIONS(3300),
    [anon_sym_mut] = ACTIONS(3300),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_go] = ACTIONS(3300),
    [anon_sym_spawn] = ACTIONS(3300),
    [anon_sym_json_DOTdecode] = ACTIONS(3300),
    [anon_sym_PIPE] = ACTIONS(3300),
    [anon_sym_LBRACK2] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [anon_sym_CARET] = ACTIONS(3300),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LT_DASH] = ACTIONS(3300),
    [anon_sym_LT_LT] = ACTIONS(3300),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3300),
    [anon_sym_AMP_CARET] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_PIPE_PIPE] = ACTIONS(3300),
    [anon_sym_or] = ACTIONS(3300),
    [sym_none] = ACTIONS(3300),
    [sym_true] = ACTIONS(3300),
    [sym_false] = ACTIONS(3300),
    [sym_nil] = ACTIONS(3300),
    [anon_sym_QMARK_DOT] = ACTIONS(3300),
    [anon_sym_POUND_LBRACK] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_DOLLARif] = ACTIONS(3300),
    [anon_sym_is] = ACTIONS(3300),
    [anon_sym_BANGis] = ACTIONS(3300),
    [anon_sym_in] = ACTIONS(3300),
    [anon_sym_BANGin] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_select] = ACTIONS(3300),
    [anon_sym_lock] = ACTIONS(3300),
    [anon_sym_rlock] = ACTIONS(3300),
    [anon_sym_unsafe] = ACTIONS(3300),
    [anon_sym_sql] = ACTIONS(3300),
    [sym_int_literal] = ACTIONS(3300),
    [sym_float_literal] = ACTIONS(3300),
    [sym_rune_literal] = ACTIONS(3300),
    [anon_sym_SQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_c_SQUOTE] = ACTIONS(3300),
    [anon_sym_c_DQUOTE] = ACTIONS(3300),
    [anon_sym_r_SQUOTE] = ACTIONS(3300),
    [anon_sym_r_DQUOTE] = ACTIONS(3300),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3300),
    [anon_sym_shared] = ACTIONS(3300),
    [anon_sym_map_LBRACK] = ACTIONS(3300),
    [anon_sym_chan] = ACTIONS(3300),
    [anon_sym_thread] = ACTIONS(3300),
    [anon_sym_atomic] = ACTIONS(3300),
  },
  [1505] = {
    [sym_line_comment] = STATE(1505),
    [sym_block_comment] = STATE(1505),
    [sym_identifier] = ACTIONS(2647),
    [anon_sym_LF] = ACTIONS(2647),
    [anon_sym_CR] = ACTIONS(2647),
    [anon_sym_CR_LF] = ACTIONS(2647),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2647),
    [anon_sym_DOT] = ACTIONS(2647),
    [anon_sym_as] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_RBRACE] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_RPAREN] = ACTIONS(2647),
    [anon_sym_fn] = ACTIONS(2647),
    [anon_sym_PLUS] = ACTIONS(2647),
    [anon_sym_DASH] = ACTIONS(2647),
    [anon_sym_STAR] = ACTIONS(2647),
    [anon_sym_SLASH] = ACTIONS(2647),
    [anon_sym_PERCENT] = ACTIONS(2647),
    [anon_sym_LT] = ACTIONS(2647),
    [anon_sym_GT] = ACTIONS(2647),
    [anon_sym_EQ_EQ] = ACTIONS(2647),
    [anon_sym_BANG_EQ] = ACTIONS(2647),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_struct] = ACTIONS(2647),
    [anon_sym_mut] = ACTIONS(2647),
    [anon_sym_PLUS_PLUS] = ACTIONS(2647),
    [anon_sym_DASH_DASH] = ACTIONS(2647),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_go] = ACTIONS(2647),
    [anon_sym_spawn] = ACTIONS(2647),
    [anon_sym_json_DOTdecode] = ACTIONS(2647),
    [anon_sym_PIPE] = ACTIONS(2647),
    [anon_sym_LBRACK2] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [anon_sym_CARET] = ACTIONS(2647),
    [anon_sym_AMP] = ACTIONS(2647),
    [anon_sym_LT_DASH] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2647),
    [anon_sym_GT_GT] = ACTIONS(2647),
    [anon_sym_GT_GT_GT] = ACTIONS(2647),
    [anon_sym_AMP_CARET] = ACTIONS(2647),
    [anon_sym_AMP_AMP] = ACTIONS(2647),
    [anon_sym_PIPE_PIPE] = ACTIONS(2647),
    [anon_sym_or] = ACTIONS(2647),
    [sym_none] = ACTIONS(2647),
    [sym_true] = ACTIONS(2647),
    [sym_false] = ACTIONS(2647),
    [sym_nil] = ACTIONS(2647),
    [anon_sym_QMARK_DOT] = ACTIONS(2647),
    [anon_sym_POUND_LBRACK] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(2647),
    [anon_sym_DOLLARif] = ACTIONS(2647),
    [anon_sym_is] = ACTIONS(2647),
    [anon_sym_BANGis] = ACTIONS(2647),
    [anon_sym_in] = ACTIONS(2647),
    [anon_sym_BANGin] = ACTIONS(2647),
    [anon_sym_match] = ACTIONS(2647),
    [anon_sym_select] = ACTIONS(2647),
    [anon_sym_lock] = ACTIONS(2647),
    [anon_sym_rlock] = ACTIONS(2647),
    [anon_sym_unsafe] = ACTIONS(2647),
    [anon_sym_sql] = ACTIONS(2647),
    [sym_int_literal] = ACTIONS(2647),
    [sym_float_literal] = ACTIONS(2647),
    [sym_rune_literal] = ACTIONS(2647),
    [anon_sym_SQUOTE] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(2647),
    [anon_sym_c_SQUOTE] = ACTIONS(2647),
    [anon_sym_c_DQUOTE] = ACTIONS(2647),
    [anon_sym_r_SQUOTE] = ACTIONS(2647),
    [anon_sym_r_DQUOTE] = ACTIONS(2647),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2647),
    [anon_sym_shared] = ACTIONS(2647),
    [anon_sym_map_LBRACK] = ACTIONS(2647),
    [anon_sym_chan] = ACTIONS(2647),
    [anon_sym_thread] = ACTIONS(2647),
    [anon_sym_atomic] = ACTIONS(2647),
  },
  [1506] = {
    [sym_line_comment] = STATE(1506),
    [sym_block_comment] = STATE(1506),
    [sym_identifier] = ACTIONS(3328),
    [anon_sym_LF] = ACTIONS(3328),
    [anon_sym_CR] = ACTIONS(3328),
    [anon_sym_CR_LF] = ACTIONS(3328),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3328),
    [anon_sym_DOT] = ACTIONS(3328),
    [anon_sym_as] = ACTIONS(3328),
    [anon_sym_LBRACE] = ACTIONS(3328),
    [anon_sym_COMMA] = ACTIONS(3328),
    [anon_sym_RBRACE] = ACTIONS(3328),
    [anon_sym_LPAREN] = ACTIONS(3328),
    [anon_sym_RPAREN] = ACTIONS(3328),
    [anon_sym_fn] = ACTIONS(3328),
    [anon_sym_PLUS] = ACTIONS(3328),
    [anon_sym_DASH] = ACTIONS(3328),
    [anon_sym_STAR] = ACTIONS(3328),
    [anon_sym_SLASH] = ACTIONS(3328),
    [anon_sym_PERCENT] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(3328),
    [anon_sym_GT] = ACTIONS(3328),
    [anon_sym_EQ_EQ] = ACTIONS(3328),
    [anon_sym_BANG_EQ] = ACTIONS(3328),
    [anon_sym_LT_EQ] = ACTIONS(3328),
    [anon_sym_GT_EQ] = ACTIONS(3328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3328),
    [anon_sym_LBRACK] = ACTIONS(3326),
    [anon_sym_struct] = ACTIONS(3328),
    [anon_sym_mut] = ACTIONS(3328),
    [anon_sym_PLUS_PLUS] = ACTIONS(3328),
    [anon_sym_DASH_DASH] = ACTIONS(3328),
    [anon_sym_QMARK] = ACTIONS(3328),
    [anon_sym_BANG] = ACTIONS(3328),
    [anon_sym_go] = ACTIONS(3328),
    [anon_sym_spawn] = ACTIONS(3328),
    [anon_sym_json_DOTdecode] = ACTIONS(3328),
    [anon_sym_PIPE] = ACTIONS(3328),
    [anon_sym_LBRACK2] = ACTIONS(3328),
    [anon_sym_TILDE] = ACTIONS(3328),
    [anon_sym_CARET] = ACTIONS(3328),
    [anon_sym_AMP] = ACTIONS(3328),
    [anon_sym_LT_DASH] = ACTIONS(3328),
    [anon_sym_LT_LT] = ACTIONS(3328),
    [anon_sym_GT_GT] = ACTIONS(3328),
    [anon_sym_GT_GT_GT] = ACTIONS(3328),
    [anon_sym_AMP_CARET] = ACTIONS(3328),
    [anon_sym_AMP_AMP] = ACTIONS(3328),
    [anon_sym_PIPE_PIPE] = ACTIONS(3328),
    [anon_sym_or] = ACTIONS(3328),
    [sym_none] = ACTIONS(3328),
    [sym_true] = ACTIONS(3328),
    [sym_false] = ACTIONS(3328),
    [sym_nil] = ACTIONS(3328),
    [anon_sym_QMARK_DOT] = ACTIONS(3328),
    [anon_sym_POUND_LBRACK] = ACTIONS(3328),
    [anon_sym_if] = ACTIONS(3328),
    [anon_sym_DOLLARif] = ACTIONS(3328),
    [anon_sym_is] = ACTIONS(3328),
    [anon_sym_BANGis] = ACTIONS(3328),
    [anon_sym_in] = ACTIONS(3328),
    [anon_sym_BANGin] = ACTIONS(3328),
    [anon_sym_match] = ACTIONS(3328),
    [anon_sym_select] = ACTIONS(3328),
    [anon_sym_lock] = ACTIONS(3328),
    [anon_sym_rlock] = ACTIONS(3328),
    [anon_sym_unsafe] = ACTIONS(3328),
    [anon_sym_sql] = ACTIONS(3328),
    [sym_int_literal] = ACTIONS(3328),
    [sym_float_literal] = ACTIONS(3328),
    [sym_rune_literal] = ACTIONS(3328),
    [anon_sym_SQUOTE] = ACTIONS(3328),
    [anon_sym_DQUOTE] = ACTIONS(3328),
    [anon_sym_c_SQUOTE] = ACTIONS(3328),
    [anon_sym_c_DQUOTE] = ACTIONS(3328),
    [anon_sym_r_SQUOTE] = ACTIONS(3328),
    [anon_sym_r_DQUOTE] = ACTIONS(3328),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3328),
    [anon_sym_shared] = ACTIONS(3328),
    [anon_sym_map_LBRACK] = ACTIONS(3328),
    [anon_sym_chan] = ACTIONS(3328),
    [anon_sym_thread] = ACTIONS(3328),
    [anon_sym_atomic] = ACTIONS(3328),
  },
  [1507] = {
    [sym_line_comment] = STATE(1507),
    [sym_block_comment] = STATE(1507),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_LF] = ACTIONS(2465),
    [anon_sym_CR] = ACTIONS(2465),
    [anon_sym_CR_LF] = ACTIONS(2465),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2465),
    [anon_sym_DOT] = ACTIONS(2465),
    [anon_sym_as] = ACTIONS(2465),
    [anon_sym_LBRACE] = ACTIONS(2465),
    [anon_sym_COMMA] = ACTIONS(2465),
    [anon_sym_RBRACE] = ACTIONS(2465),
    [anon_sym_LPAREN] = ACTIONS(2465),
    [anon_sym_RPAREN] = ACTIONS(2465),
    [anon_sym_fn] = ACTIONS(2465),
    [anon_sym_PLUS] = ACTIONS(2465),
    [anon_sym_DASH] = ACTIONS(2465),
    [anon_sym_STAR] = ACTIONS(2465),
    [anon_sym_SLASH] = ACTIONS(2465),
    [anon_sym_PERCENT] = ACTIONS(2465),
    [anon_sym_LT] = ACTIONS(2465),
    [anon_sym_GT] = ACTIONS(2465),
    [anon_sym_EQ_EQ] = ACTIONS(2465),
    [anon_sym_BANG_EQ] = ACTIONS(2465),
    [anon_sym_LT_EQ] = ACTIONS(2465),
    [anon_sym_GT_EQ] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2465),
    [anon_sym_LBRACK] = ACTIONS(2463),
    [anon_sym_struct] = ACTIONS(2465),
    [anon_sym_mut] = ACTIONS(2465),
    [anon_sym_PLUS_PLUS] = ACTIONS(2465),
    [anon_sym_DASH_DASH] = ACTIONS(2465),
    [anon_sym_QMARK] = ACTIONS(2465),
    [anon_sym_BANG] = ACTIONS(2465),
    [anon_sym_go] = ACTIONS(2465),
    [anon_sym_spawn] = ACTIONS(2465),
    [anon_sym_json_DOTdecode] = ACTIONS(2465),
    [anon_sym_PIPE] = ACTIONS(2465),
    [anon_sym_LBRACK2] = ACTIONS(2465),
    [anon_sym_TILDE] = ACTIONS(2465),
    [anon_sym_CARET] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_LT_DASH] = ACTIONS(2465),
    [anon_sym_LT_LT] = ACTIONS(2465),
    [anon_sym_GT_GT] = ACTIONS(2465),
    [anon_sym_GT_GT_GT] = ACTIONS(2465),
    [anon_sym_AMP_CARET] = ACTIONS(2465),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_PIPE_PIPE] = ACTIONS(2465),
    [anon_sym_or] = ACTIONS(2465),
    [sym_none] = ACTIONS(2465),
    [sym_true] = ACTIONS(2465),
    [sym_false] = ACTIONS(2465),
    [sym_nil] = ACTIONS(2465),
    [anon_sym_QMARK_DOT] = ACTIONS(2465),
    [anon_sym_POUND_LBRACK] = ACTIONS(2465),
    [anon_sym_if] = ACTIONS(2465),
    [anon_sym_DOLLARif] = ACTIONS(2465),
    [anon_sym_is] = ACTIONS(2465),
    [anon_sym_BANGis] = ACTIONS(2465),
    [anon_sym_in] = ACTIONS(2465),
    [anon_sym_BANGin] = ACTIONS(2465),
    [anon_sym_match] = ACTIONS(2465),
    [anon_sym_select] = ACTIONS(2465),
    [anon_sym_lock] = ACTIONS(2465),
    [anon_sym_rlock] = ACTIONS(2465),
    [anon_sym_unsafe] = ACTIONS(2465),
    [anon_sym_sql] = ACTIONS(2465),
    [sym_int_literal] = ACTIONS(2465),
    [sym_float_literal] = ACTIONS(2465),
    [sym_rune_literal] = ACTIONS(2465),
    [anon_sym_SQUOTE] = ACTIONS(2465),
    [anon_sym_DQUOTE] = ACTIONS(2465),
    [anon_sym_c_SQUOTE] = ACTIONS(2465),
    [anon_sym_c_DQUOTE] = ACTIONS(2465),
    [anon_sym_r_SQUOTE] = ACTIONS(2465),
    [anon_sym_r_DQUOTE] = ACTIONS(2465),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2465),
    [anon_sym_shared] = ACTIONS(2465),
    [anon_sym_map_LBRACK] = ACTIONS(2465),
    [anon_sym_chan] = ACTIONS(2465),
    [anon_sym_thread] = ACTIONS(2465),
    [anon_sym_atomic] = ACTIONS(2465),
  },
  [1508] = {
    [sym_line_comment] = STATE(1508),
    [sym_block_comment] = STATE(1508),
    [sym_identifier] = ACTIONS(2429),
    [anon_sym_LF] = ACTIONS(2429),
    [anon_sym_CR] = ACTIONS(2429),
    [anon_sym_CR_LF] = ACTIONS(2429),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2429),
    [anon_sym_DOT] = ACTIONS(2429),
    [anon_sym_as] = ACTIONS(2429),
    [anon_sym_LBRACE] = ACTIONS(2429),
    [anon_sym_COMMA] = ACTIONS(2429),
    [anon_sym_RBRACE] = ACTIONS(2429),
    [anon_sym_LPAREN] = ACTIONS(2429),
    [anon_sym_RPAREN] = ACTIONS(2429),
    [anon_sym_fn] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(2429),
    [anon_sym_DASH] = ACTIONS(2429),
    [anon_sym_STAR] = ACTIONS(2429),
    [anon_sym_SLASH] = ACTIONS(2429),
    [anon_sym_PERCENT] = ACTIONS(2429),
    [anon_sym_LT] = ACTIONS(2429),
    [anon_sym_GT] = ACTIONS(2429),
    [anon_sym_EQ_EQ] = ACTIONS(2429),
    [anon_sym_BANG_EQ] = ACTIONS(2429),
    [anon_sym_LT_EQ] = ACTIONS(2429),
    [anon_sym_GT_EQ] = ACTIONS(2429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2429),
    [anon_sym_LBRACK] = ACTIONS(2427),
    [anon_sym_struct] = ACTIONS(2429),
    [anon_sym_mut] = ACTIONS(2429),
    [anon_sym_PLUS_PLUS] = ACTIONS(2429),
    [anon_sym_DASH_DASH] = ACTIONS(2429),
    [anon_sym_QMARK] = ACTIONS(2429),
    [anon_sym_BANG] = ACTIONS(2429),
    [anon_sym_go] = ACTIONS(2429),
    [anon_sym_spawn] = ACTIONS(2429),
    [anon_sym_json_DOTdecode] = ACTIONS(2429),
    [anon_sym_PIPE] = ACTIONS(2429),
    [anon_sym_LBRACK2] = ACTIONS(2429),
    [anon_sym_TILDE] = ACTIONS(2429),
    [anon_sym_CARET] = ACTIONS(2429),
    [anon_sym_AMP] = ACTIONS(2429),
    [anon_sym_LT_DASH] = ACTIONS(2429),
    [anon_sym_LT_LT] = ACTIONS(2429),
    [anon_sym_GT_GT] = ACTIONS(2429),
    [anon_sym_GT_GT_GT] = ACTIONS(2429),
    [anon_sym_AMP_CARET] = ACTIONS(2429),
    [anon_sym_AMP_AMP] = ACTIONS(2429),
    [anon_sym_PIPE_PIPE] = ACTIONS(2429),
    [anon_sym_or] = ACTIONS(2429),
    [sym_none] = ACTIONS(2429),
    [sym_true] = ACTIONS(2429),
    [sym_false] = ACTIONS(2429),
    [sym_nil] = ACTIONS(2429),
    [anon_sym_QMARK_DOT] = ACTIONS(2429),
    [anon_sym_POUND_LBRACK] = ACTIONS(2429),
    [anon_sym_if] = ACTIONS(2429),
    [anon_sym_DOLLARif] = ACTIONS(2429),
    [anon_sym_is] = ACTIONS(2429),
    [anon_sym_BANGis] = ACTIONS(2429),
    [anon_sym_in] = ACTIONS(2429),
    [anon_sym_BANGin] = ACTIONS(2429),
    [anon_sym_match] = ACTIONS(2429),
    [anon_sym_select] = ACTIONS(2429),
    [anon_sym_lock] = ACTIONS(2429),
    [anon_sym_rlock] = ACTIONS(2429),
    [anon_sym_unsafe] = ACTIONS(2429),
    [anon_sym_sql] = ACTIONS(2429),
    [sym_int_literal] = ACTIONS(2429),
    [sym_float_literal] = ACTIONS(2429),
    [sym_rune_literal] = ACTIONS(2429),
    [anon_sym_SQUOTE] = ACTIONS(2429),
    [anon_sym_DQUOTE] = ACTIONS(2429),
    [anon_sym_c_SQUOTE] = ACTIONS(2429),
    [anon_sym_c_DQUOTE] = ACTIONS(2429),
    [anon_sym_r_SQUOTE] = ACTIONS(2429),
    [anon_sym_r_DQUOTE] = ACTIONS(2429),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2429),
    [anon_sym_shared] = ACTIONS(2429),
    [anon_sym_map_LBRACK] = ACTIONS(2429),
    [anon_sym_chan] = ACTIONS(2429),
    [anon_sym_thread] = ACTIONS(2429),
    [anon_sym_atomic] = ACTIONS(2429),
  },
  [1509] = {
    [sym_line_comment] = STATE(1509),
    [sym_block_comment] = STATE(1509),
    [sym_identifier] = ACTIONS(2631),
    [anon_sym_LF] = ACTIONS(2631),
    [anon_sym_CR] = ACTIONS(2631),
    [anon_sym_CR_LF] = ACTIONS(2631),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2631),
    [anon_sym_DOT] = ACTIONS(2631),
    [anon_sym_as] = ACTIONS(2631),
    [anon_sym_LBRACE] = ACTIONS(2631),
    [anon_sym_COMMA] = ACTIONS(2631),
    [anon_sym_RBRACE] = ACTIONS(2631),
    [anon_sym_LPAREN] = ACTIONS(2631),
    [anon_sym_RPAREN] = ACTIONS(2631),
    [anon_sym_fn] = ACTIONS(2631),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_DASH] = ACTIONS(2631),
    [anon_sym_STAR] = ACTIONS(2631),
    [anon_sym_SLASH] = ACTIONS(2631),
    [anon_sym_PERCENT] = ACTIONS(2631),
    [anon_sym_LT] = ACTIONS(2631),
    [anon_sym_GT] = ACTIONS(2631),
    [anon_sym_EQ_EQ] = ACTIONS(2631),
    [anon_sym_BANG_EQ] = ACTIONS(2631),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2631),
    [anon_sym_LBRACK] = ACTIONS(2629),
    [anon_sym_struct] = ACTIONS(2631),
    [anon_sym_mut] = ACTIONS(2631),
    [anon_sym_PLUS_PLUS] = ACTIONS(2631),
    [anon_sym_DASH_DASH] = ACTIONS(2631),
    [anon_sym_QMARK] = ACTIONS(2631),
    [anon_sym_BANG] = ACTIONS(2631),
    [anon_sym_go] = ACTIONS(2631),
    [anon_sym_spawn] = ACTIONS(2631),
    [anon_sym_json_DOTdecode] = ACTIONS(2631),
    [anon_sym_PIPE] = ACTIONS(2631),
    [anon_sym_LBRACK2] = ACTIONS(2631),
    [anon_sym_TILDE] = ACTIONS(2631),
    [anon_sym_CARET] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2631),
    [anon_sym_LT_DASH] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2631),
    [anon_sym_GT_GT] = ACTIONS(2631),
    [anon_sym_GT_GT_GT] = ACTIONS(2631),
    [anon_sym_AMP_CARET] = ACTIONS(2631),
    [anon_sym_AMP_AMP] = ACTIONS(2631),
    [anon_sym_PIPE_PIPE] = ACTIONS(2631),
    [anon_sym_or] = ACTIONS(2631),
    [sym_none] = ACTIONS(2631),
    [sym_true] = ACTIONS(2631),
    [sym_false] = ACTIONS(2631),
    [sym_nil] = ACTIONS(2631),
    [anon_sym_QMARK_DOT] = ACTIONS(2631),
    [anon_sym_POUND_LBRACK] = ACTIONS(2631),
    [anon_sym_if] = ACTIONS(2631),
    [anon_sym_DOLLARif] = ACTIONS(2631),
    [anon_sym_is] = ACTIONS(2631),
    [anon_sym_BANGis] = ACTIONS(2631),
    [anon_sym_in] = ACTIONS(2631),
    [anon_sym_BANGin] = ACTIONS(2631),
    [anon_sym_match] = ACTIONS(2631),
    [anon_sym_select] = ACTIONS(2631),
    [anon_sym_lock] = ACTIONS(2631),
    [anon_sym_rlock] = ACTIONS(2631),
    [anon_sym_unsafe] = ACTIONS(2631),
    [anon_sym_sql] = ACTIONS(2631),
    [sym_int_literal] = ACTIONS(2631),
    [sym_float_literal] = ACTIONS(2631),
    [sym_rune_literal] = ACTIONS(2631),
    [anon_sym_SQUOTE] = ACTIONS(2631),
    [anon_sym_DQUOTE] = ACTIONS(2631),
    [anon_sym_c_SQUOTE] = ACTIONS(2631),
    [anon_sym_c_DQUOTE] = ACTIONS(2631),
    [anon_sym_r_SQUOTE] = ACTIONS(2631),
    [anon_sym_r_DQUOTE] = ACTIONS(2631),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2631),
    [anon_sym_shared] = ACTIONS(2631),
    [anon_sym_map_LBRACK] = ACTIONS(2631),
    [anon_sym_chan] = ACTIONS(2631),
    [anon_sym_thread] = ACTIONS(2631),
    [anon_sym_atomic] = ACTIONS(2631),
  },
  [1510] = {
    [sym_line_comment] = STATE(1510),
    [sym_block_comment] = STATE(1510),
    [sym_identifier] = ACTIONS(2639),
    [anon_sym_LF] = ACTIONS(2639),
    [anon_sym_CR] = ACTIONS(2639),
    [anon_sym_CR_LF] = ACTIONS(2639),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym_DOT] = ACTIONS(2639),
    [anon_sym_as] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2639),
    [anon_sym_COMMA] = ACTIONS(2639),
    [anon_sym_RBRACE] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(2639),
    [anon_sym_RPAREN] = ACTIONS(2639),
    [anon_sym_fn] = ACTIONS(2639),
    [anon_sym_PLUS] = ACTIONS(2639),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_SLASH] = ACTIONS(2639),
    [anon_sym_PERCENT] = ACTIONS(2639),
    [anon_sym_LT] = ACTIONS(2639),
    [anon_sym_GT] = ACTIONS(2639),
    [anon_sym_EQ_EQ] = ACTIONS(2639),
    [anon_sym_BANG_EQ] = ACTIONS(2639),
    [anon_sym_LT_EQ] = ACTIONS(2639),
    [anon_sym_GT_EQ] = ACTIONS(2639),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_mut] = ACTIONS(2639),
    [anon_sym_PLUS_PLUS] = ACTIONS(2639),
    [anon_sym_DASH_DASH] = ACTIONS(2639),
    [anon_sym_QMARK] = ACTIONS(2639),
    [anon_sym_BANG] = ACTIONS(2639),
    [anon_sym_go] = ACTIONS(2639),
    [anon_sym_spawn] = ACTIONS(2639),
    [anon_sym_json_DOTdecode] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_LBRACK2] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_LT_DASH] = ACTIONS(2639),
    [anon_sym_LT_LT] = ACTIONS(2639),
    [anon_sym_GT_GT] = ACTIONS(2639),
    [anon_sym_GT_GT_GT] = ACTIONS(2639),
    [anon_sym_AMP_CARET] = ACTIONS(2639),
    [anon_sym_AMP_AMP] = ACTIONS(2639),
    [anon_sym_PIPE_PIPE] = ACTIONS(2639),
    [anon_sym_or] = ACTIONS(2639),
    [sym_none] = ACTIONS(2639),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [sym_nil] = ACTIONS(2639),
    [anon_sym_QMARK_DOT] = ACTIONS(2639),
    [anon_sym_POUND_LBRACK] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2639),
    [anon_sym_DOLLARif] = ACTIONS(2639),
    [anon_sym_is] = ACTIONS(2639),
    [anon_sym_BANGis] = ACTIONS(2639),
    [anon_sym_in] = ACTIONS(2639),
    [anon_sym_BANGin] = ACTIONS(2639),
    [anon_sym_match] = ACTIONS(2639),
    [anon_sym_select] = ACTIONS(2639),
    [anon_sym_lock] = ACTIONS(2639),
    [anon_sym_rlock] = ACTIONS(2639),
    [anon_sym_unsafe] = ACTIONS(2639),
    [anon_sym_sql] = ACTIONS(2639),
    [sym_int_literal] = ACTIONS(2639),
    [sym_float_literal] = ACTIONS(2639),
    [sym_rune_literal] = ACTIONS(2639),
    [anon_sym_SQUOTE] = ACTIONS(2639),
    [anon_sym_DQUOTE] = ACTIONS(2639),
    [anon_sym_c_SQUOTE] = ACTIONS(2639),
    [anon_sym_c_DQUOTE] = ACTIONS(2639),
    [anon_sym_r_SQUOTE] = ACTIONS(2639),
    [anon_sym_r_DQUOTE] = ACTIONS(2639),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2639),
    [anon_sym_shared] = ACTIONS(2639),
    [anon_sym_map_LBRACK] = ACTIONS(2639),
    [anon_sym_chan] = ACTIONS(2639),
    [anon_sym_thread] = ACTIONS(2639),
    [anon_sym_atomic] = ACTIONS(2639),
  },
  [1511] = {
    [sym_line_comment] = STATE(1511),
    [sym_block_comment] = STATE(1511),
    [sym_identifier] = ACTIONS(3286),
    [anon_sym_LF] = ACTIONS(3286),
    [anon_sym_CR] = ACTIONS(3286),
    [anon_sym_CR_LF] = ACTIONS(3286),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3286),
    [anon_sym_DOT] = ACTIONS(3286),
    [anon_sym_as] = ACTIONS(3286),
    [anon_sym_LBRACE] = ACTIONS(3286),
    [anon_sym_COMMA] = ACTIONS(3286),
    [anon_sym_RBRACE] = ACTIONS(3286),
    [anon_sym_LPAREN] = ACTIONS(3286),
    [anon_sym_RPAREN] = ACTIONS(3286),
    [anon_sym_fn] = ACTIONS(3286),
    [anon_sym_PLUS] = ACTIONS(3286),
    [anon_sym_DASH] = ACTIONS(3286),
    [anon_sym_STAR] = ACTIONS(3286),
    [anon_sym_SLASH] = ACTIONS(3286),
    [anon_sym_PERCENT] = ACTIONS(3286),
    [anon_sym_LT] = ACTIONS(3286),
    [anon_sym_GT] = ACTIONS(3286),
    [anon_sym_EQ_EQ] = ACTIONS(3286),
    [anon_sym_BANG_EQ] = ACTIONS(3286),
    [anon_sym_LT_EQ] = ACTIONS(3286),
    [anon_sym_GT_EQ] = ACTIONS(3286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3286),
    [anon_sym_LBRACK] = ACTIONS(3284),
    [anon_sym_struct] = ACTIONS(3286),
    [anon_sym_mut] = ACTIONS(3286),
    [anon_sym_PLUS_PLUS] = ACTIONS(3286),
    [anon_sym_DASH_DASH] = ACTIONS(3286),
    [anon_sym_QMARK] = ACTIONS(3286),
    [anon_sym_BANG] = ACTIONS(3286),
    [anon_sym_go] = ACTIONS(3286),
    [anon_sym_spawn] = ACTIONS(3286),
    [anon_sym_json_DOTdecode] = ACTIONS(3286),
    [anon_sym_PIPE] = ACTIONS(3286),
    [anon_sym_LBRACK2] = ACTIONS(3286),
    [anon_sym_TILDE] = ACTIONS(3286),
    [anon_sym_CARET] = ACTIONS(3286),
    [anon_sym_AMP] = ACTIONS(3286),
    [anon_sym_LT_DASH] = ACTIONS(3286),
    [anon_sym_LT_LT] = ACTIONS(3286),
    [anon_sym_GT_GT] = ACTIONS(3286),
    [anon_sym_GT_GT_GT] = ACTIONS(3286),
    [anon_sym_AMP_CARET] = ACTIONS(3286),
    [anon_sym_AMP_AMP] = ACTIONS(3286),
    [anon_sym_PIPE_PIPE] = ACTIONS(3286),
    [anon_sym_or] = ACTIONS(3286),
    [sym_none] = ACTIONS(3286),
    [sym_true] = ACTIONS(3286),
    [sym_false] = ACTIONS(3286),
    [sym_nil] = ACTIONS(3286),
    [anon_sym_QMARK_DOT] = ACTIONS(3286),
    [anon_sym_POUND_LBRACK] = ACTIONS(3286),
    [anon_sym_if] = ACTIONS(3286),
    [anon_sym_DOLLARif] = ACTIONS(3286),
    [anon_sym_is] = ACTIONS(3286),
    [anon_sym_BANGis] = ACTIONS(3286),
    [anon_sym_in] = ACTIONS(3286),
    [anon_sym_BANGin] = ACTIONS(3286),
    [anon_sym_match] = ACTIONS(3286),
    [anon_sym_select] = ACTIONS(3286),
    [anon_sym_lock] = ACTIONS(3286),
    [anon_sym_rlock] = ACTIONS(3286),
    [anon_sym_unsafe] = ACTIONS(3286),
    [anon_sym_sql] = ACTIONS(3286),
    [sym_int_literal] = ACTIONS(3286),
    [sym_float_literal] = ACTIONS(3286),
    [sym_rune_literal] = ACTIONS(3286),
    [anon_sym_SQUOTE] = ACTIONS(3286),
    [anon_sym_DQUOTE] = ACTIONS(3286),
    [anon_sym_c_SQUOTE] = ACTIONS(3286),
    [anon_sym_c_DQUOTE] = ACTIONS(3286),
    [anon_sym_r_SQUOTE] = ACTIONS(3286),
    [anon_sym_r_DQUOTE] = ACTIONS(3286),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3286),
    [anon_sym_shared] = ACTIONS(3286),
    [anon_sym_map_LBRACK] = ACTIONS(3286),
    [anon_sym_chan] = ACTIONS(3286),
    [anon_sym_thread] = ACTIONS(3286),
    [anon_sym_atomic] = ACTIONS(3286),
  },
  [1512] = {
    [sym_line_comment] = STATE(1512),
    [sym_block_comment] = STATE(1512),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_LF] = ACTIONS(3304),
    [anon_sym_CR] = ACTIONS(3304),
    [anon_sym_CR_LF] = ACTIONS(3304),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3304),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_as] = ACTIONS(3304),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_COMMA] = ACTIONS(3304),
    [anon_sym_RBRACE] = ACTIONS(3304),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_RPAREN] = ACTIONS(3304),
    [anon_sym_fn] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [anon_sym_LT] = ACTIONS(3304),
    [anon_sym_GT] = ACTIONS(3304),
    [anon_sym_EQ_EQ] = ACTIONS(3304),
    [anon_sym_BANG_EQ] = ACTIONS(3304),
    [anon_sym_LT_EQ] = ACTIONS(3304),
    [anon_sym_GT_EQ] = ACTIONS(3304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3302),
    [anon_sym_struct] = ACTIONS(3304),
    [anon_sym_mut] = ACTIONS(3304),
    [anon_sym_PLUS_PLUS] = ACTIONS(3304),
    [anon_sym_DASH_DASH] = ACTIONS(3304),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_go] = ACTIONS(3304),
    [anon_sym_spawn] = ACTIONS(3304),
    [anon_sym_json_DOTdecode] = ACTIONS(3304),
    [anon_sym_PIPE] = ACTIONS(3304),
    [anon_sym_LBRACK2] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LT_DASH] = ACTIONS(3304),
    [anon_sym_LT_LT] = ACTIONS(3304),
    [anon_sym_GT_GT] = ACTIONS(3304),
    [anon_sym_GT_GT_GT] = ACTIONS(3304),
    [anon_sym_AMP_CARET] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_PIPE_PIPE] = ACTIONS(3304),
    [anon_sym_or] = ACTIONS(3304),
    [sym_none] = ACTIONS(3304),
    [sym_true] = ACTIONS(3304),
    [sym_false] = ACTIONS(3304),
    [sym_nil] = ACTIONS(3304),
    [anon_sym_QMARK_DOT] = ACTIONS(3304),
    [anon_sym_POUND_LBRACK] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_DOLLARif] = ACTIONS(3304),
    [anon_sym_is] = ACTIONS(3304),
    [anon_sym_BANGis] = ACTIONS(3304),
    [anon_sym_in] = ACTIONS(3304),
    [anon_sym_BANGin] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_select] = ACTIONS(3304),
    [anon_sym_lock] = ACTIONS(3304),
    [anon_sym_rlock] = ACTIONS(3304),
    [anon_sym_unsafe] = ACTIONS(3304),
    [anon_sym_sql] = ACTIONS(3304),
    [sym_int_literal] = ACTIONS(3304),
    [sym_float_literal] = ACTIONS(3304),
    [sym_rune_literal] = ACTIONS(3304),
    [anon_sym_SQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_c_SQUOTE] = ACTIONS(3304),
    [anon_sym_c_DQUOTE] = ACTIONS(3304),
    [anon_sym_r_SQUOTE] = ACTIONS(3304),
    [anon_sym_r_DQUOTE] = ACTIONS(3304),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3304),
    [anon_sym_shared] = ACTIONS(3304),
    [anon_sym_map_LBRACK] = ACTIONS(3304),
    [anon_sym_chan] = ACTIONS(3304),
    [anon_sym_thread] = ACTIONS(3304),
    [anon_sym_atomic] = ACTIONS(3304),
  },
  [1513] = {
    [sym_line_comment] = STATE(1513),
    [sym_block_comment] = STATE(1513),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_LF] = ACTIONS(3296),
    [anon_sym_CR] = ACTIONS(3296),
    [anon_sym_CR_LF] = ACTIONS(3296),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3296),
    [anon_sym_as] = ACTIONS(3296),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3296),
    [anon_sym_RBRACE] = ACTIONS(3296),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_RPAREN] = ACTIONS(3296),
    [anon_sym_fn] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_SLASH] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_LT] = ACTIONS(3296),
    [anon_sym_GT] = ACTIONS(3296),
    [anon_sym_EQ_EQ] = ACTIONS(3296),
    [anon_sym_BANG_EQ] = ACTIONS(3296),
    [anon_sym_LT_EQ] = ACTIONS(3296),
    [anon_sym_GT_EQ] = ACTIONS(3296),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3294),
    [anon_sym_struct] = ACTIONS(3296),
    [anon_sym_mut] = ACTIONS(3296),
    [anon_sym_PLUS_PLUS] = ACTIONS(3296),
    [anon_sym_DASH_DASH] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3296),
    [anon_sym_BANG] = ACTIONS(3296),
    [anon_sym_go] = ACTIONS(3296),
    [anon_sym_spawn] = ACTIONS(3296),
    [anon_sym_json_DOTdecode] = ACTIONS(3296),
    [anon_sym_PIPE] = ACTIONS(3296),
    [anon_sym_LBRACK2] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3296),
    [anon_sym_CARET] = ACTIONS(3296),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3296),
    [anon_sym_LT_LT] = ACTIONS(3296),
    [anon_sym_GT_GT] = ACTIONS(3296),
    [anon_sym_GT_GT_GT] = ACTIONS(3296),
    [anon_sym_AMP_CARET] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3296),
    [anon_sym_or] = ACTIONS(3296),
    [sym_none] = ACTIONS(3296),
    [sym_true] = ACTIONS(3296),
    [sym_false] = ACTIONS(3296),
    [sym_nil] = ACTIONS(3296),
    [anon_sym_QMARK_DOT] = ACTIONS(3296),
    [anon_sym_POUND_LBRACK] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_DOLLARif] = ACTIONS(3296),
    [anon_sym_is] = ACTIONS(3296),
    [anon_sym_BANGis] = ACTIONS(3296),
    [anon_sym_in] = ACTIONS(3296),
    [anon_sym_BANGin] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_select] = ACTIONS(3296),
    [anon_sym_lock] = ACTIONS(3296),
    [anon_sym_rlock] = ACTIONS(3296),
    [anon_sym_unsafe] = ACTIONS(3296),
    [anon_sym_sql] = ACTIONS(3296),
    [sym_int_literal] = ACTIONS(3296),
    [sym_float_literal] = ACTIONS(3296),
    [sym_rune_literal] = ACTIONS(3296),
    [anon_sym_SQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_c_SQUOTE] = ACTIONS(3296),
    [anon_sym_c_DQUOTE] = ACTIONS(3296),
    [anon_sym_r_SQUOTE] = ACTIONS(3296),
    [anon_sym_r_DQUOTE] = ACTIONS(3296),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3296),
    [anon_sym_shared] = ACTIONS(3296),
    [anon_sym_map_LBRACK] = ACTIONS(3296),
    [anon_sym_chan] = ACTIONS(3296),
    [anon_sym_thread] = ACTIONS(3296),
    [anon_sym_atomic] = ACTIONS(3296),
  },
  [1514] = {
    [sym_line_comment] = STATE(1514),
    [sym_block_comment] = STATE(1514),
    [sym_identifier] = ACTIONS(2659),
    [anon_sym_LF] = ACTIONS(2659),
    [anon_sym_CR] = ACTIONS(2659),
    [anon_sym_CR_LF] = ACTIONS(2659),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2659),
    [anon_sym_DOT] = ACTIONS(2659),
    [anon_sym_as] = ACTIONS(2659),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_COMMA] = ACTIONS(2659),
    [anon_sym_RBRACE] = ACTIONS(2659),
    [anon_sym_LPAREN] = ACTIONS(2659),
    [anon_sym_RPAREN] = ACTIONS(2659),
    [anon_sym_fn] = ACTIONS(2659),
    [anon_sym_PLUS] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_SLASH] = ACTIONS(2659),
    [anon_sym_PERCENT] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(2659),
    [anon_sym_GT] = ACTIONS(2659),
    [anon_sym_EQ_EQ] = ACTIONS(2659),
    [anon_sym_BANG_EQ] = ACTIONS(2659),
    [anon_sym_LT_EQ] = ACTIONS(2659),
    [anon_sym_GT_EQ] = ACTIONS(2659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2659),
    [anon_sym_LBRACK] = ACTIONS(2657),
    [anon_sym_struct] = ACTIONS(2659),
    [anon_sym_mut] = ACTIONS(2659),
    [anon_sym_PLUS_PLUS] = ACTIONS(2659),
    [anon_sym_DASH_DASH] = ACTIONS(2659),
    [anon_sym_QMARK] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_go] = ACTIONS(2659),
    [anon_sym_spawn] = ACTIONS(2659),
    [anon_sym_json_DOTdecode] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(2659),
    [anon_sym_LBRACK2] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_CARET] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2659),
    [anon_sym_LT_DASH] = ACTIONS(2659),
    [anon_sym_LT_LT] = ACTIONS(2659),
    [anon_sym_GT_GT] = ACTIONS(2659),
    [anon_sym_GT_GT_GT] = ACTIONS(2659),
    [anon_sym_AMP_CARET] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_PIPE_PIPE] = ACTIONS(2659),
    [anon_sym_or] = ACTIONS(2659),
    [sym_none] = ACTIONS(2659),
    [sym_true] = ACTIONS(2659),
    [sym_false] = ACTIONS(2659),
    [sym_nil] = ACTIONS(2659),
    [anon_sym_QMARK_DOT] = ACTIONS(2659),
    [anon_sym_POUND_LBRACK] = ACTIONS(2659),
    [anon_sym_if] = ACTIONS(2659),
    [anon_sym_DOLLARif] = ACTIONS(2659),
    [anon_sym_is] = ACTIONS(2659),
    [anon_sym_BANGis] = ACTIONS(2659),
    [anon_sym_in] = ACTIONS(2659),
    [anon_sym_BANGin] = ACTIONS(2659),
    [anon_sym_match] = ACTIONS(2659),
    [anon_sym_select] = ACTIONS(2659),
    [anon_sym_lock] = ACTIONS(2659),
    [anon_sym_rlock] = ACTIONS(2659),
    [anon_sym_unsafe] = ACTIONS(2659),
    [anon_sym_sql] = ACTIONS(2659),
    [sym_int_literal] = ACTIONS(2659),
    [sym_float_literal] = ACTIONS(2659),
    [sym_rune_literal] = ACTIONS(2659),
    [anon_sym_SQUOTE] = ACTIONS(2659),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [anon_sym_c_SQUOTE] = ACTIONS(2659),
    [anon_sym_c_DQUOTE] = ACTIONS(2659),
    [anon_sym_r_SQUOTE] = ACTIONS(2659),
    [anon_sym_r_DQUOTE] = ACTIONS(2659),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2659),
    [anon_sym_shared] = ACTIONS(2659),
    [anon_sym_map_LBRACK] = ACTIONS(2659),
    [anon_sym_chan] = ACTIONS(2659),
    [anon_sym_thread] = ACTIONS(2659),
    [anon_sym_atomic] = ACTIONS(2659),
  },
  [1515] = {
    [sym_line_comment] = STATE(1515),
    [sym_block_comment] = STATE(1515),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_LF] = ACTIONS(2951),
    [anon_sym_CR] = ACTIONS(2951),
    [anon_sym_CR_LF] = ACTIONS(2951),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym_DOT] = ACTIONS(2951),
    [anon_sym_as] = ACTIONS(2951),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_RBRACE] = ACTIONS(2951),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_RPAREN] = ACTIONS(2951),
    [anon_sym_fn] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_LT] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2949),
    [anon_sym_struct] = ACTIONS(2951),
    [anon_sym_mut] = ACTIONS(2951),
    [anon_sym_PLUS_PLUS] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2951),
    [anon_sym_QMARK] = ACTIONS(2951),
    [anon_sym_BANG] = ACTIONS(2951),
    [anon_sym_go] = ACTIONS(2951),
    [anon_sym_spawn] = ACTIONS(2951),
    [anon_sym_json_DOTdecode] = ACTIONS(2951),
    [anon_sym_PIPE] = ACTIONS(2951),
    [anon_sym_LBRACK2] = ACTIONS(2951),
    [anon_sym_TILDE] = ACTIONS(2951),
    [anon_sym_CARET] = ACTIONS(2951),
    [anon_sym_AMP] = ACTIONS(2951),
    [anon_sym_LT_DASH] = ACTIONS(2951),
    [anon_sym_LT_LT] = ACTIONS(2951),
    [anon_sym_GT_GT] = ACTIONS(2951),
    [anon_sym_GT_GT_GT] = ACTIONS(2951),
    [anon_sym_AMP_CARET] = ACTIONS(2951),
    [anon_sym_AMP_AMP] = ACTIONS(2951),
    [anon_sym_PIPE_PIPE] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [sym_none] = ACTIONS(2951),
    [sym_true] = ACTIONS(2951),
    [sym_false] = ACTIONS(2951),
    [sym_nil] = ACTIONS(2951),
    [anon_sym_QMARK_DOT] = ACTIONS(2951),
    [anon_sym_POUND_LBRACK] = ACTIONS(2951),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_DOLLARif] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_BANGis] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_BANGin] = ACTIONS(2951),
    [anon_sym_match] = ACTIONS(2951),
    [anon_sym_select] = ACTIONS(2951),
    [anon_sym_lock] = ACTIONS(2951),
    [anon_sym_rlock] = ACTIONS(2951),
    [anon_sym_unsafe] = ACTIONS(2951),
    [anon_sym_sql] = ACTIONS(2951),
    [sym_int_literal] = ACTIONS(2951),
    [sym_float_literal] = ACTIONS(2951),
    [sym_rune_literal] = ACTIONS(2951),
    [anon_sym_SQUOTE] = ACTIONS(2951),
    [anon_sym_DQUOTE] = ACTIONS(2951),
    [anon_sym_c_SQUOTE] = ACTIONS(2951),
    [anon_sym_c_DQUOTE] = ACTIONS(2951),
    [anon_sym_r_SQUOTE] = ACTIONS(2951),
    [anon_sym_r_DQUOTE] = ACTIONS(2951),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2951),
    [anon_sym_shared] = ACTIONS(2951),
    [anon_sym_map_LBRACK] = ACTIONS(2951),
    [anon_sym_chan] = ACTIONS(2951),
    [anon_sym_thread] = ACTIONS(2951),
    [anon_sym_atomic] = ACTIONS(2951),
  },
  [1516] = {
    [sym_line_comment] = STATE(1516),
    [sym_block_comment] = STATE(1516),
    [sym_identifier] = ACTIONS(2655),
    [anon_sym_LF] = ACTIONS(2655),
    [anon_sym_CR] = ACTIONS(2655),
    [anon_sym_CR_LF] = ACTIONS(2655),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym_DOT] = ACTIONS(2655),
    [anon_sym_as] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2655),
    [anon_sym_COMMA] = ACTIONS(2655),
    [anon_sym_RBRACE] = ACTIONS(2655),
    [anon_sym_LPAREN] = ACTIONS(2655),
    [anon_sym_RPAREN] = ACTIONS(2655),
    [anon_sym_fn] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_DASH] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_SLASH] = ACTIONS(2655),
    [anon_sym_PERCENT] = ACTIONS(2655),
    [anon_sym_LT] = ACTIONS(2655),
    [anon_sym_GT] = ACTIONS(2655),
    [anon_sym_EQ_EQ] = ACTIONS(2655),
    [anon_sym_BANG_EQ] = ACTIONS(2655),
    [anon_sym_LT_EQ] = ACTIONS(2655),
    [anon_sym_GT_EQ] = ACTIONS(2655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2655),
    [anon_sym_LBRACK] = ACTIONS(2653),
    [anon_sym_struct] = ACTIONS(2655),
    [anon_sym_mut] = ACTIONS(2655),
    [anon_sym_PLUS_PLUS] = ACTIONS(2655),
    [anon_sym_DASH_DASH] = ACTIONS(2655),
    [anon_sym_QMARK] = ACTIONS(2655),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_go] = ACTIONS(2655),
    [anon_sym_spawn] = ACTIONS(2655),
    [anon_sym_json_DOTdecode] = ACTIONS(2655),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_LBRACK2] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [anon_sym_CARET] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2655),
    [anon_sym_LT_DASH] = ACTIONS(2655),
    [anon_sym_LT_LT] = ACTIONS(2655),
    [anon_sym_GT_GT] = ACTIONS(2655),
    [anon_sym_GT_GT_GT] = ACTIONS(2655),
    [anon_sym_AMP_CARET] = ACTIONS(2655),
    [anon_sym_AMP_AMP] = ACTIONS(2655),
    [anon_sym_PIPE_PIPE] = ACTIONS(2655),
    [anon_sym_or] = ACTIONS(2655),
    [sym_none] = ACTIONS(2655),
    [sym_true] = ACTIONS(2655),
    [sym_false] = ACTIONS(2655),
    [sym_nil] = ACTIONS(2655),
    [anon_sym_QMARK_DOT] = ACTIONS(2655),
    [anon_sym_POUND_LBRACK] = ACTIONS(2655),
    [anon_sym_if] = ACTIONS(2655),
    [anon_sym_DOLLARif] = ACTIONS(2655),
    [anon_sym_is] = ACTIONS(2655),
    [anon_sym_BANGis] = ACTIONS(2655),
    [anon_sym_in] = ACTIONS(2655),
    [anon_sym_BANGin] = ACTIONS(2655),
    [anon_sym_match] = ACTIONS(2655),
    [anon_sym_select] = ACTIONS(2655),
    [anon_sym_lock] = ACTIONS(2655),
    [anon_sym_rlock] = ACTIONS(2655),
    [anon_sym_unsafe] = ACTIONS(2655),
    [anon_sym_sql] = ACTIONS(2655),
    [sym_int_literal] = ACTIONS(2655),
    [sym_float_literal] = ACTIONS(2655),
    [sym_rune_literal] = ACTIONS(2655),
    [anon_sym_SQUOTE] = ACTIONS(2655),
    [anon_sym_DQUOTE] = ACTIONS(2655),
    [anon_sym_c_SQUOTE] = ACTIONS(2655),
    [anon_sym_c_DQUOTE] = ACTIONS(2655),
    [anon_sym_r_SQUOTE] = ACTIONS(2655),
    [anon_sym_r_DQUOTE] = ACTIONS(2655),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2655),
    [anon_sym_shared] = ACTIONS(2655),
    [anon_sym_map_LBRACK] = ACTIONS(2655),
    [anon_sym_chan] = ACTIONS(2655),
    [anon_sym_thread] = ACTIONS(2655),
    [anon_sym_atomic] = ACTIONS(2655),
  },
  [1517] = {
    [sym_line_comment] = STATE(1517),
    [sym_block_comment] = STATE(1517),
    [sym_reference_expression] = STATE(4528),
    [sym_type_reference_expression] = STATE(2017),
    [sym_plain_type] = STATE(2123),
    [sym__plain_type_without_special] = STATE(2110),
    [sym_anon_struct_type] = STATE(2111),
    [sym_multi_return_type] = STATE(2110),
    [sym_result_type] = STATE(2110),
    [sym_option_type] = STATE(2110),
    [sym_qualified_type] = STATE(2017),
    [sym_fixed_array_type] = STATE(2111),
    [sym_array_type] = STATE(2111),
    [sym_pointer_type] = STATE(2111),
    [sym_wrong_pointer_type] = STATE(2111),
    [sym_map_type] = STATE(2111),
    [sym_channel_type] = STATE(2111),
    [sym_shared_type] = STATE(2111),
    [sym_thread_type] = STATE(2111),
    [sym_atomic_type] = STATE(2111),
    [sym_generic_type] = STATE(2111),
    [sym_function_type] = STATE(2111),
    [sym_identifier] = ACTIONS(4190),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(817),
    [anon_sym_as] = ACTIONS(821),
    [anon_sym_LBRACE] = ACTIONS(817),
    [anon_sym_COMMA] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(4192),
    [anon_sym_EQ] = ACTIONS(821),
    [anon_sym_fn] = ACTIONS(4194),
    [anon_sym_PLUS] = ACTIONS(821),
    [anon_sym_DASH] = ACTIONS(821),
    [anon_sym_STAR] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(821),
    [anon_sym_PERCENT] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(821),
    [anon_sym_GT] = ACTIONS(821),
    [anon_sym_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(817),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_LBRACK] = ACTIONS(817),
    [anon_sym_struct] = ACTIONS(4198),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(817),
    [anon_sym_DASH_DASH] = ACTIONS(817),
    [anon_sym_QMARK] = ACTIONS(4200),
    [anon_sym_BANG] = ACTIONS(4202),
    [anon_sym_PIPE] = ACTIONS(821),
    [anon_sym_LBRACK2] = ACTIONS(4204),
    [anon_sym_CARET] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(4206),
    [anon_sym_LT_DASH] = ACTIONS(817),
    [anon_sym_LT_LT] = ACTIONS(821),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_GT_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_CARET] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_or] = ACTIONS(821),
    [anon_sym_QMARK_DOT] = ACTIONS(817),
    [anon_sym_POUND_LBRACK] = ACTIONS(817),
    [anon_sym_is] = ACTIONS(821),
    [anon_sym_BANGis] = ACTIONS(817),
    [anon_sym_in] = ACTIONS(821),
    [anon_sym_BANGin] = ACTIONS(817),
    [anon_sym_STAR_EQ] = ACTIONS(817),
    [anon_sym_SLASH_EQ] = ACTIONS(817),
    [anon_sym_PERCENT_EQ] = ACTIONS(817),
    [anon_sym_LT_LT_EQ] = ACTIONS(817),
    [anon_sym_GT_GT_EQ] = ACTIONS(817),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(817),
    [anon_sym_AMP_EQ] = ACTIONS(817),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(817),
    [anon_sym_PLUS_EQ] = ACTIONS(817),
    [anon_sym_DASH_EQ] = ACTIONS(817),
    [anon_sym_PIPE_EQ] = ACTIONS(817),
    [anon_sym_CARET_EQ] = ACTIONS(817),
    [anon_sym_shared] = ACTIONS(4208),
    [anon_sym_map_LBRACK] = ACTIONS(4210),
    [anon_sym_chan] = ACTIONS(4212),
    [anon_sym_thread] = ACTIONS(4214),
    [anon_sym_atomic] = ACTIONS(4216),
  },
  [1518] = {
    [sym_line_comment] = STATE(1518),
    [sym_block_comment] = STATE(1518),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_LF] = ACTIONS(3308),
    [anon_sym_CR] = ACTIONS(3308),
    [anon_sym_CR_LF] = ACTIONS(3308),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3308),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_as] = ACTIONS(3308),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_COMMA] = ACTIONS(3308),
    [anon_sym_RBRACE] = ACTIONS(3308),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_RPAREN] = ACTIONS(3308),
    [anon_sym_fn] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_SLASH] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_EQ_EQ] = ACTIONS(3308),
    [anon_sym_BANG_EQ] = ACTIONS(3308),
    [anon_sym_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT_EQ] = ACTIONS(3308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_struct] = ACTIONS(3308),
    [anon_sym_mut] = ACTIONS(3308),
    [anon_sym_PLUS_PLUS] = ACTIONS(3308),
    [anon_sym_DASH_DASH] = ACTIONS(3308),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_BANG] = ACTIONS(3308),
    [anon_sym_go] = ACTIONS(3308),
    [anon_sym_spawn] = ACTIONS(3308),
    [anon_sym_json_DOTdecode] = ACTIONS(3308),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_LBRACK2] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3308),
    [anon_sym_CARET] = ACTIONS(3308),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LT_DASH] = ACTIONS(3308),
    [anon_sym_LT_LT] = ACTIONS(3308),
    [anon_sym_GT_GT] = ACTIONS(3308),
    [anon_sym_GT_GT_GT] = ACTIONS(3308),
    [anon_sym_AMP_CARET] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(3308),
    [anon_sym_PIPE_PIPE] = ACTIONS(3308),
    [anon_sym_or] = ACTIONS(3308),
    [sym_none] = ACTIONS(3308),
    [sym_true] = ACTIONS(3308),
    [sym_false] = ACTIONS(3308),
    [sym_nil] = ACTIONS(3308),
    [anon_sym_QMARK_DOT] = ACTIONS(3308),
    [anon_sym_POUND_LBRACK] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_DOLLARif] = ACTIONS(3308),
    [anon_sym_is] = ACTIONS(3308),
    [anon_sym_BANGis] = ACTIONS(3308),
    [anon_sym_in] = ACTIONS(3308),
    [anon_sym_BANGin] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_select] = ACTIONS(3308),
    [anon_sym_lock] = ACTIONS(3308),
    [anon_sym_rlock] = ACTIONS(3308),
    [anon_sym_unsafe] = ACTIONS(3308),
    [anon_sym_sql] = ACTIONS(3308),
    [sym_int_literal] = ACTIONS(3308),
    [sym_float_literal] = ACTIONS(3308),
    [sym_rune_literal] = ACTIONS(3308),
    [anon_sym_SQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_c_SQUOTE] = ACTIONS(3308),
    [anon_sym_c_DQUOTE] = ACTIONS(3308),
    [anon_sym_r_SQUOTE] = ACTIONS(3308),
    [anon_sym_r_DQUOTE] = ACTIONS(3308),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3308),
    [anon_sym_shared] = ACTIONS(3308),
    [anon_sym_map_LBRACK] = ACTIONS(3308),
    [anon_sym_chan] = ACTIONS(3308),
    [anon_sym_thread] = ACTIONS(3308),
    [anon_sym_atomic] = ACTIONS(3308),
  },
  [1519] = {
    [sym_line_comment] = STATE(1519),
    [sym_block_comment] = STATE(1519),
    [sym_identifier] = ACTIONS(3312),
    [anon_sym_LF] = ACTIONS(3312),
    [anon_sym_CR] = ACTIONS(3312),
    [anon_sym_CR_LF] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3312),
    [anon_sym_DOT] = ACTIONS(3312),
    [anon_sym_as] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_RBRACE] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3312),
    [anon_sym_RPAREN] = ACTIONS(3312),
    [anon_sym_fn] = ACTIONS(3312),
    [anon_sym_PLUS] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_SLASH] = ACTIONS(3312),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_GT] = ACTIONS(3312),
    [anon_sym_EQ_EQ] = ACTIONS(3312),
    [anon_sym_BANG_EQ] = ACTIONS(3312),
    [anon_sym_LT_EQ] = ACTIONS(3312),
    [anon_sym_GT_EQ] = ACTIONS(3312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3312),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_struct] = ACTIONS(3312),
    [anon_sym_mut] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3312),
    [anon_sym_DASH_DASH] = ACTIONS(3312),
    [anon_sym_QMARK] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_go] = ACTIONS(3312),
    [anon_sym_spawn] = ACTIONS(3312),
    [anon_sym_json_DOTdecode] = ACTIONS(3312),
    [anon_sym_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACK2] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_CARET] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3312),
    [anon_sym_LT_DASH] = ACTIONS(3312),
    [anon_sym_LT_LT] = ACTIONS(3312),
    [anon_sym_GT_GT] = ACTIONS(3312),
    [anon_sym_GT_GT_GT] = ACTIONS(3312),
    [anon_sym_AMP_CARET] = ACTIONS(3312),
    [anon_sym_AMP_AMP] = ACTIONS(3312),
    [anon_sym_PIPE_PIPE] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3312),
    [sym_none] = ACTIONS(3312),
    [sym_true] = ACTIONS(3312),
    [sym_false] = ACTIONS(3312),
    [sym_nil] = ACTIONS(3312),
    [anon_sym_QMARK_DOT] = ACTIONS(3312),
    [anon_sym_POUND_LBRACK] = ACTIONS(3312),
    [anon_sym_if] = ACTIONS(3312),
    [anon_sym_DOLLARif] = ACTIONS(3312),
    [anon_sym_is] = ACTIONS(3312),
    [anon_sym_BANGis] = ACTIONS(3312),
    [anon_sym_in] = ACTIONS(3312),
    [anon_sym_BANGin] = ACTIONS(3312),
    [anon_sym_match] = ACTIONS(3312),
    [anon_sym_select] = ACTIONS(3312),
    [anon_sym_lock] = ACTIONS(3312),
    [anon_sym_rlock] = ACTIONS(3312),
    [anon_sym_unsafe] = ACTIONS(3312),
    [anon_sym_sql] = ACTIONS(3312),
    [sym_int_literal] = ACTIONS(3312),
    [sym_float_literal] = ACTIONS(3312),
    [sym_rune_literal] = ACTIONS(3312),
    [anon_sym_SQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3312),
    [anon_sym_c_SQUOTE] = ACTIONS(3312),
    [anon_sym_c_DQUOTE] = ACTIONS(3312),
    [anon_sym_r_SQUOTE] = ACTIONS(3312),
    [anon_sym_r_DQUOTE] = ACTIONS(3312),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3312),
    [anon_sym_shared] = ACTIONS(3312),
    [anon_sym_map_LBRACK] = ACTIONS(3312),
    [anon_sym_chan] = ACTIONS(3312),
    [anon_sym_thread] = ACTIONS(3312),
    [anon_sym_atomic] = ACTIONS(3312),
  },
  [1520] = {
    [sym_line_comment] = STATE(1520),
    [sym_block_comment] = STATE(1520),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_LF] = ACTIONS(2833),
    [anon_sym_CR] = ACTIONS(2833),
    [anon_sym_CR_LF] = ACTIONS(2833),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2833),
    [anon_sym_DOT] = ACTIONS(2833),
    [anon_sym_as] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_RBRACE] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2833),
    [anon_sym_RPAREN] = ACTIONS(2833),
    [anon_sym_fn] = ACTIONS(2833),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(2833),
    [anon_sym_SLASH] = ACTIONS(2833),
    [anon_sym_PERCENT] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(2833),
    [anon_sym_EQ_EQ] = ACTIONS(2833),
    [anon_sym_BANG_EQ] = ACTIONS(2833),
    [anon_sym_LT_EQ] = ACTIONS(2833),
    [anon_sym_GT_EQ] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2833),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_struct] = ACTIONS(2833),
    [anon_sym_mut] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_QMARK] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_go] = ACTIONS(2833),
    [anon_sym_spawn] = ACTIONS(2833),
    [anon_sym_json_DOTdecode] = ACTIONS(2833),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_LBRACK2] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2833),
    [anon_sym_CARET] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2833),
    [anon_sym_LT_DASH] = ACTIONS(2833),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_GT] = ACTIONS(2833),
    [anon_sym_AMP_CARET] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2833),
    [anon_sym_or] = ACTIONS(2833),
    [sym_none] = ACTIONS(2833),
    [sym_true] = ACTIONS(2833),
    [sym_false] = ACTIONS(2833),
    [sym_nil] = ACTIONS(2833),
    [anon_sym_QMARK_DOT] = ACTIONS(2833),
    [anon_sym_POUND_LBRACK] = ACTIONS(2833),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_DOLLARif] = ACTIONS(2833),
    [anon_sym_is] = ACTIONS(2833),
    [anon_sym_BANGis] = ACTIONS(2833),
    [anon_sym_in] = ACTIONS(2833),
    [anon_sym_BANGin] = ACTIONS(2833),
    [anon_sym_match] = ACTIONS(2833),
    [anon_sym_select] = ACTIONS(2833),
    [anon_sym_lock] = ACTIONS(2833),
    [anon_sym_rlock] = ACTIONS(2833),
    [anon_sym_unsafe] = ACTIONS(2833),
    [anon_sym_sql] = ACTIONS(2833),
    [sym_int_literal] = ACTIONS(2833),
    [sym_float_literal] = ACTIONS(2833),
    [sym_rune_literal] = ACTIONS(2833),
    [anon_sym_SQUOTE] = ACTIONS(2833),
    [anon_sym_DQUOTE] = ACTIONS(2833),
    [anon_sym_c_SQUOTE] = ACTIONS(2833),
    [anon_sym_c_DQUOTE] = ACTIONS(2833),
    [anon_sym_r_SQUOTE] = ACTIONS(2833),
    [anon_sym_r_DQUOTE] = ACTIONS(2833),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2833),
    [anon_sym_shared] = ACTIONS(2833),
    [anon_sym_map_LBRACK] = ACTIONS(2833),
    [anon_sym_chan] = ACTIONS(2833),
    [anon_sym_thread] = ACTIONS(2833),
    [anon_sym_atomic] = ACTIONS(2833),
  },
  [1521] = {
    [sym_line_comment] = STATE(1521),
    [sym_block_comment] = STATE(1521),
    [sym_identifier] = ACTIONS(3280),
    [anon_sym_LF] = ACTIONS(3280),
    [anon_sym_CR] = ACTIONS(3280),
    [anon_sym_CR_LF] = ACTIONS(3280),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3280),
    [anon_sym_DOT] = ACTIONS(3280),
    [anon_sym_as] = ACTIONS(3280),
    [anon_sym_LBRACE] = ACTIONS(3280),
    [anon_sym_COMMA] = ACTIONS(3280),
    [anon_sym_RBRACE] = ACTIONS(3280),
    [anon_sym_LPAREN] = ACTIONS(3280),
    [anon_sym_RPAREN] = ACTIONS(3280),
    [anon_sym_fn] = ACTIONS(3280),
    [anon_sym_PLUS] = ACTIONS(3280),
    [anon_sym_DASH] = ACTIONS(3280),
    [anon_sym_STAR] = ACTIONS(3280),
    [anon_sym_SLASH] = ACTIONS(3280),
    [anon_sym_PERCENT] = ACTIONS(3280),
    [anon_sym_LT] = ACTIONS(3280),
    [anon_sym_GT] = ACTIONS(3280),
    [anon_sym_EQ_EQ] = ACTIONS(3280),
    [anon_sym_BANG_EQ] = ACTIONS(3280),
    [anon_sym_LT_EQ] = ACTIONS(3280),
    [anon_sym_GT_EQ] = ACTIONS(3280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3280),
    [anon_sym_LBRACK] = ACTIONS(3278),
    [anon_sym_struct] = ACTIONS(3280),
    [anon_sym_mut] = ACTIONS(3280),
    [anon_sym_PLUS_PLUS] = ACTIONS(3280),
    [anon_sym_DASH_DASH] = ACTIONS(3280),
    [anon_sym_QMARK] = ACTIONS(3280),
    [anon_sym_BANG] = ACTIONS(3280),
    [anon_sym_go] = ACTIONS(3280),
    [anon_sym_spawn] = ACTIONS(3280),
    [anon_sym_json_DOTdecode] = ACTIONS(3280),
    [anon_sym_PIPE] = ACTIONS(3280),
    [anon_sym_LBRACK2] = ACTIONS(3280),
    [anon_sym_TILDE] = ACTIONS(3280),
    [anon_sym_CARET] = ACTIONS(3280),
    [anon_sym_AMP] = ACTIONS(3280),
    [anon_sym_LT_DASH] = ACTIONS(3280),
    [anon_sym_LT_LT] = ACTIONS(3280),
    [anon_sym_GT_GT] = ACTIONS(3280),
    [anon_sym_GT_GT_GT] = ACTIONS(3280),
    [anon_sym_AMP_CARET] = ACTIONS(3280),
    [anon_sym_AMP_AMP] = ACTIONS(3280),
    [anon_sym_PIPE_PIPE] = ACTIONS(3280),
    [anon_sym_or] = ACTIONS(3280),
    [sym_none] = ACTIONS(3280),
    [sym_true] = ACTIONS(3280),
    [sym_false] = ACTIONS(3280),
    [sym_nil] = ACTIONS(3280),
    [anon_sym_QMARK_DOT] = ACTIONS(3280),
    [anon_sym_POUND_LBRACK] = ACTIONS(3280),
    [anon_sym_if] = ACTIONS(3280),
    [anon_sym_DOLLARif] = ACTIONS(3280),
    [anon_sym_is] = ACTIONS(3280),
    [anon_sym_BANGis] = ACTIONS(3280),
    [anon_sym_in] = ACTIONS(3280),
    [anon_sym_BANGin] = ACTIONS(3280),
    [anon_sym_match] = ACTIONS(3280),
    [anon_sym_select] = ACTIONS(3280),
    [anon_sym_lock] = ACTIONS(3280),
    [anon_sym_rlock] = ACTIONS(3280),
    [anon_sym_unsafe] = ACTIONS(3280),
    [anon_sym_sql] = ACTIONS(3280),
    [sym_int_literal] = ACTIONS(3280),
    [sym_float_literal] = ACTIONS(3280),
    [sym_rune_literal] = ACTIONS(3280),
    [anon_sym_SQUOTE] = ACTIONS(3280),
    [anon_sym_DQUOTE] = ACTIONS(3280),
    [anon_sym_c_SQUOTE] = ACTIONS(3280),
    [anon_sym_c_DQUOTE] = ACTIONS(3280),
    [anon_sym_r_SQUOTE] = ACTIONS(3280),
    [anon_sym_r_DQUOTE] = ACTIONS(3280),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3280),
    [anon_sym_shared] = ACTIONS(3280),
    [anon_sym_map_LBRACK] = ACTIONS(3280),
    [anon_sym_chan] = ACTIONS(3280),
    [anon_sym_thread] = ACTIONS(3280),
    [anon_sym_atomic] = ACTIONS(3280),
  },
  [1522] = {
    [sym_line_comment] = STATE(1522),
    [sym_block_comment] = STATE(1522),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_LF] = ACTIONS(2881),
    [anon_sym_CR] = ACTIONS(2881),
    [anon_sym_CR_LF] = ACTIONS(2881),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2881),
    [anon_sym_as] = ACTIONS(2881),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_LPAREN] = ACTIONS(2881),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [anon_sym_fn] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_SLASH] = ACTIONS(2881),
    [anon_sym_PERCENT] = ACTIONS(2881),
    [anon_sym_LT] = ACTIONS(2881),
    [anon_sym_GT] = ACTIONS(2881),
    [anon_sym_EQ_EQ] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_LT_EQ] = ACTIONS(2881),
    [anon_sym_GT_EQ] = ACTIONS(2881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_struct] = ACTIONS(2881),
    [anon_sym_mut] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_go] = ACTIONS(2881),
    [anon_sym_spawn] = ACTIONS(2881),
    [anon_sym_json_DOTdecode] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2881),
    [anon_sym_LBRACK2] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_CARET] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2881),
    [anon_sym_LT_DASH] = ACTIONS(2881),
    [anon_sym_LT_LT] = ACTIONS(2881),
    [anon_sym_GT_GT] = ACTIONS(2881),
    [anon_sym_GT_GT_GT] = ACTIONS(2881),
    [anon_sym_AMP_CARET] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2881),
    [sym_none] = ACTIONS(2881),
    [sym_true] = ACTIONS(2881),
    [sym_false] = ACTIONS(2881),
    [sym_nil] = ACTIONS(2881),
    [anon_sym_QMARK_DOT] = ACTIONS(2881),
    [anon_sym_POUND_LBRACK] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_DOLLARif] = ACTIONS(2881),
    [anon_sym_is] = ACTIONS(2881),
    [anon_sym_BANGis] = ACTIONS(2881),
    [anon_sym_in] = ACTIONS(2881),
    [anon_sym_BANGin] = ACTIONS(2881),
    [anon_sym_match] = ACTIONS(2881),
    [anon_sym_select] = ACTIONS(2881),
    [anon_sym_lock] = ACTIONS(2881),
    [anon_sym_rlock] = ACTIONS(2881),
    [anon_sym_unsafe] = ACTIONS(2881),
    [anon_sym_sql] = ACTIONS(2881),
    [sym_int_literal] = ACTIONS(2881),
    [sym_float_literal] = ACTIONS(2881),
    [sym_rune_literal] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_c_SQUOTE] = ACTIONS(2881),
    [anon_sym_c_DQUOTE] = ACTIONS(2881),
    [anon_sym_r_SQUOTE] = ACTIONS(2881),
    [anon_sym_r_DQUOTE] = ACTIONS(2881),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2881),
    [anon_sym_shared] = ACTIONS(2881),
    [anon_sym_map_LBRACK] = ACTIONS(2881),
    [anon_sym_chan] = ACTIONS(2881),
    [anon_sym_thread] = ACTIONS(2881),
    [anon_sym_atomic] = ACTIONS(2881),
  },
  [1523] = {
    [sym_line_comment] = STATE(1523),
    [sym_block_comment] = STATE(1523),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2489),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_as] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(849),
    [anon_sym_EQ] = ACTIONS(851),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(851),
    [anon_sym_SLASH] = ACTIONS(851),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(849),
    [anon_sym_BANG_EQ] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_COLON] = ACTIONS(849),
    [anon_sym_PLUS_PLUS] = ACTIONS(849),
    [anon_sym_DASH_DASH] = ACTIONS(849),
    [anon_sym_QMARK] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PIPE] = ACTIONS(851),
    [anon_sym_LBRACK2] = ACTIONS(851),
    [anon_sym_CARET] = ACTIONS(851),
    [anon_sym_AMP] = ACTIONS(851),
    [anon_sym_LT_DASH] = ACTIONS(849),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_CARET] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(849),
    [anon_sym_PIPE_PIPE] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(851),
    [anon_sym_QMARK_DOT] = ACTIONS(849),
    [anon_sym_POUND_LBRACK] = ACTIONS(849),
    [anon_sym_is] = ACTIONS(851),
    [anon_sym_BANGis] = ACTIONS(849),
    [anon_sym_in] = ACTIONS(851),
    [anon_sym_BANGin] = ACTIONS(849),
    [anon_sym_STAR_EQ] = ACTIONS(849),
    [anon_sym_SLASH_EQ] = ACTIONS(849),
    [anon_sym_PERCENT_EQ] = ACTIONS(849),
    [anon_sym_LT_LT_EQ] = ACTIONS(849),
    [anon_sym_GT_GT_EQ] = ACTIONS(849),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(849),
    [anon_sym_AMP_EQ] = ACTIONS(849),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(849),
    [anon_sym_PLUS_EQ] = ACTIONS(849),
    [anon_sym_DASH_EQ] = ACTIONS(849),
    [anon_sym_PIPE_EQ] = ACTIONS(849),
    [anon_sym_CARET_EQ] = ACTIONS(849),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [1524] = {
    [sym_line_comment] = STATE(1524),
    [sym_block_comment] = STATE(1524),
    [sym_identifier] = ACTIONS(2377),
    [anon_sym_LF] = ACTIONS(2377),
    [anon_sym_CR] = ACTIONS(2377),
    [anon_sym_CR_LF] = ACTIONS(2377),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2377),
    [anon_sym_DOT] = ACTIONS(2377),
    [anon_sym_as] = ACTIONS(2377),
    [anon_sym_LBRACE] = ACTIONS(2377),
    [anon_sym_COMMA] = ACTIONS(2377),
    [anon_sym_RBRACE] = ACTIONS(2377),
    [anon_sym_LPAREN] = ACTIONS(2377),
    [anon_sym_RPAREN] = ACTIONS(2377),
    [anon_sym_fn] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2377),
    [anon_sym_DASH] = ACTIONS(2377),
    [anon_sym_STAR] = ACTIONS(2377),
    [anon_sym_SLASH] = ACTIONS(2377),
    [anon_sym_PERCENT] = ACTIONS(2377),
    [anon_sym_LT] = ACTIONS(2377),
    [anon_sym_GT] = ACTIONS(2377),
    [anon_sym_EQ_EQ] = ACTIONS(2377),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2377),
    [anon_sym_GT_EQ] = ACTIONS(2377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2377),
    [anon_sym_LBRACK] = ACTIONS(2375),
    [anon_sym_struct] = ACTIONS(2377),
    [anon_sym_mut] = ACTIONS(2377),
    [anon_sym_PLUS_PLUS] = ACTIONS(2377),
    [anon_sym_DASH_DASH] = ACTIONS(2377),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2377),
    [anon_sym_go] = ACTIONS(2377),
    [anon_sym_spawn] = ACTIONS(2377),
    [anon_sym_json_DOTdecode] = ACTIONS(2377),
    [anon_sym_PIPE] = ACTIONS(2377),
    [anon_sym_LBRACK2] = ACTIONS(2377),
    [anon_sym_TILDE] = ACTIONS(2377),
    [anon_sym_CARET] = ACTIONS(2377),
    [anon_sym_AMP] = ACTIONS(2377),
    [anon_sym_LT_DASH] = ACTIONS(2377),
    [anon_sym_LT_LT] = ACTIONS(2377),
    [anon_sym_GT_GT] = ACTIONS(2377),
    [anon_sym_GT_GT_GT] = ACTIONS(2377),
    [anon_sym_AMP_CARET] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_or] = ACTIONS(2377),
    [sym_none] = ACTIONS(2377),
    [sym_true] = ACTIONS(2377),
    [sym_false] = ACTIONS(2377),
    [sym_nil] = ACTIONS(2377),
    [anon_sym_QMARK_DOT] = ACTIONS(2377),
    [anon_sym_POUND_LBRACK] = ACTIONS(2377),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_DOLLARif] = ACTIONS(2377),
    [anon_sym_is] = ACTIONS(2377),
    [anon_sym_BANGis] = ACTIONS(2377),
    [anon_sym_in] = ACTIONS(2377),
    [anon_sym_BANGin] = ACTIONS(2377),
    [anon_sym_match] = ACTIONS(2377),
    [anon_sym_select] = ACTIONS(2377),
    [anon_sym_lock] = ACTIONS(2377),
    [anon_sym_rlock] = ACTIONS(2377),
    [anon_sym_unsafe] = ACTIONS(2377),
    [anon_sym_sql] = ACTIONS(2377),
    [sym_int_literal] = ACTIONS(2377),
    [sym_float_literal] = ACTIONS(2377),
    [sym_rune_literal] = ACTIONS(2377),
    [anon_sym_SQUOTE] = ACTIONS(2377),
    [anon_sym_DQUOTE] = ACTIONS(2377),
    [anon_sym_c_SQUOTE] = ACTIONS(2377),
    [anon_sym_c_DQUOTE] = ACTIONS(2377),
    [anon_sym_r_SQUOTE] = ACTIONS(2377),
    [anon_sym_r_DQUOTE] = ACTIONS(2377),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2377),
    [anon_sym_shared] = ACTIONS(2377),
    [anon_sym_map_LBRACK] = ACTIONS(2377),
    [anon_sym_chan] = ACTIONS(2377),
    [anon_sym_thread] = ACTIONS(2377),
    [anon_sym_atomic] = ACTIONS(2377),
  },
  [1525] = {
    [sym_line_comment] = STATE(1525),
    [sym_block_comment] = STATE(1525),
    [sym_identifier] = ACTIONS(2829),
    [anon_sym_LF] = ACTIONS(2829),
    [anon_sym_CR] = ACTIONS(2829),
    [anon_sym_CR_LF] = ACTIONS(2829),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_DOT] = ACTIONS(2829),
    [anon_sym_as] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2829),
    [anon_sym_fn] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(2829),
    [anon_sym_SLASH] = ACTIONS(2829),
    [anon_sym_PERCENT] = ACTIONS(2829),
    [anon_sym_LT] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2829),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2829),
    [anon_sym_LBRACK] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_mut] = ACTIONS(2829),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_QMARK] = ACTIONS(2829),
    [anon_sym_BANG] = ACTIONS(2829),
    [anon_sym_go] = ACTIONS(2829),
    [anon_sym_spawn] = ACTIONS(2829),
    [anon_sym_json_DOTdecode] = ACTIONS(2829),
    [anon_sym_PIPE] = ACTIONS(2829),
    [anon_sym_LBRACK2] = ACTIONS(2829),
    [anon_sym_TILDE] = ACTIONS(2829),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_AMP] = ACTIONS(2829),
    [anon_sym_LT_DASH] = ACTIONS(2829),
    [anon_sym_LT_LT] = ACTIONS(2829),
    [anon_sym_GT_GT] = ACTIONS(2829),
    [anon_sym_GT_GT_GT] = ACTIONS(2829),
    [anon_sym_AMP_CARET] = ACTIONS(2829),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_or] = ACTIONS(2829),
    [sym_none] = ACTIONS(2829),
    [sym_true] = ACTIONS(2829),
    [sym_false] = ACTIONS(2829),
    [sym_nil] = ACTIONS(2829),
    [anon_sym_QMARK_DOT] = ACTIONS(2829),
    [anon_sym_POUND_LBRACK] = ACTIONS(2829),
    [anon_sym_if] = ACTIONS(2829),
    [anon_sym_DOLLARif] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2829),
    [anon_sym_BANGis] = ACTIONS(2829),
    [anon_sym_in] = ACTIONS(2829),
    [anon_sym_BANGin] = ACTIONS(2829),
    [anon_sym_match] = ACTIONS(2829),
    [anon_sym_select] = ACTIONS(2829),
    [anon_sym_lock] = ACTIONS(2829),
    [anon_sym_rlock] = ACTIONS(2829),
    [anon_sym_unsafe] = ACTIONS(2829),
    [anon_sym_sql] = ACTIONS(2829),
    [sym_int_literal] = ACTIONS(2829),
    [sym_float_literal] = ACTIONS(2829),
    [sym_rune_literal] = ACTIONS(2829),
    [anon_sym_SQUOTE] = ACTIONS(2829),
    [anon_sym_DQUOTE] = ACTIONS(2829),
    [anon_sym_c_SQUOTE] = ACTIONS(2829),
    [anon_sym_c_DQUOTE] = ACTIONS(2829),
    [anon_sym_r_SQUOTE] = ACTIONS(2829),
    [anon_sym_r_DQUOTE] = ACTIONS(2829),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2829),
    [anon_sym_shared] = ACTIONS(2829),
    [anon_sym_map_LBRACK] = ACTIONS(2829),
    [anon_sym_chan] = ACTIONS(2829),
    [anon_sym_thread] = ACTIONS(2829),
    [anon_sym_atomic] = ACTIONS(2829),
  },
  [1526] = {
    [sym_line_comment] = STATE(1526),
    [sym_block_comment] = STATE(1526),
    [sym_identifier] = ACTIONS(2383),
    [anon_sym_LF] = ACTIONS(2383),
    [anon_sym_CR] = ACTIONS(2383),
    [anon_sym_CR_LF] = ACTIONS(2383),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2383),
    [anon_sym_DOT] = ACTIONS(2383),
    [anon_sym_as] = ACTIONS(2383),
    [anon_sym_LBRACE] = ACTIONS(2383),
    [anon_sym_COMMA] = ACTIONS(2383),
    [anon_sym_RBRACE] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(2383),
    [anon_sym_fn] = ACTIONS(2383),
    [anon_sym_PLUS] = ACTIONS(2383),
    [anon_sym_DASH] = ACTIONS(2383),
    [anon_sym_STAR] = ACTIONS(2383),
    [anon_sym_SLASH] = ACTIONS(2383),
    [anon_sym_PERCENT] = ACTIONS(2383),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_GT] = ACTIONS(2383),
    [anon_sym_EQ_EQ] = ACTIONS(2383),
    [anon_sym_BANG_EQ] = ACTIONS(2383),
    [anon_sym_LT_EQ] = ACTIONS(2383),
    [anon_sym_GT_EQ] = ACTIONS(2383),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2383),
    [anon_sym_LBRACK] = ACTIONS(2381),
    [anon_sym_struct] = ACTIONS(2383),
    [anon_sym_mut] = ACTIONS(2383),
    [anon_sym_PLUS_PLUS] = ACTIONS(2383),
    [anon_sym_DASH_DASH] = ACTIONS(2383),
    [anon_sym_QMARK] = ACTIONS(2383),
    [anon_sym_BANG] = ACTIONS(2383),
    [anon_sym_go] = ACTIONS(2383),
    [anon_sym_spawn] = ACTIONS(2383),
    [anon_sym_json_DOTdecode] = ACTIONS(2383),
    [anon_sym_PIPE] = ACTIONS(2383),
    [anon_sym_LBRACK2] = ACTIONS(2383),
    [anon_sym_TILDE] = ACTIONS(2383),
    [anon_sym_CARET] = ACTIONS(2383),
    [anon_sym_AMP] = ACTIONS(2383),
    [anon_sym_LT_DASH] = ACTIONS(2383),
    [anon_sym_LT_LT] = ACTIONS(2383),
    [anon_sym_GT_GT] = ACTIONS(2383),
    [anon_sym_GT_GT_GT] = ACTIONS(2383),
    [anon_sym_AMP_CARET] = ACTIONS(2383),
    [anon_sym_AMP_AMP] = ACTIONS(2383),
    [anon_sym_PIPE_PIPE] = ACTIONS(2383),
    [anon_sym_or] = ACTIONS(2383),
    [sym_none] = ACTIONS(2383),
    [sym_true] = ACTIONS(2383),
    [sym_false] = ACTIONS(2383),
    [sym_nil] = ACTIONS(2383),
    [anon_sym_QMARK_DOT] = ACTIONS(2383),
    [anon_sym_POUND_LBRACK] = ACTIONS(2383),
    [anon_sym_if] = ACTIONS(2383),
    [anon_sym_DOLLARif] = ACTIONS(2383),
    [anon_sym_is] = ACTIONS(2383),
    [anon_sym_BANGis] = ACTIONS(2383),
    [anon_sym_in] = ACTIONS(2383),
    [anon_sym_BANGin] = ACTIONS(2383),
    [anon_sym_match] = ACTIONS(2383),
    [anon_sym_select] = ACTIONS(2383),
    [anon_sym_lock] = ACTIONS(2383),
    [anon_sym_rlock] = ACTIONS(2383),
    [anon_sym_unsafe] = ACTIONS(2383),
    [anon_sym_sql] = ACTIONS(2383),
    [sym_int_literal] = ACTIONS(2383),
    [sym_float_literal] = ACTIONS(2383),
    [sym_rune_literal] = ACTIONS(2383),
    [anon_sym_SQUOTE] = ACTIONS(2383),
    [anon_sym_DQUOTE] = ACTIONS(2383),
    [anon_sym_c_SQUOTE] = ACTIONS(2383),
    [anon_sym_c_DQUOTE] = ACTIONS(2383),
    [anon_sym_r_SQUOTE] = ACTIONS(2383),
    [anon_sym_r_DQUOTE] = ACTIONS(2383),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2383),
    [anon_sym_shared] = ACTIONS(2383),
    [anon_sym_map_LBRACK] = ACTIONS(2383),
    [anon_sym_chan] = ACTIONS(2383),
    [anon_sym_thread] = ACTIONS(2383),
    [anon_sym_atomic] = ACTIONS(2383),
  },
  [1527] = {
    [sym_line_comment] = STATE(1527),
    [sym_block_comment] = STATE(1527),
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_LF] = ACTIONS(3045),
    [anon_sym_CR] = ACTIONS(3045),
    [anon_sym_CR_LF] = ACTIONS(3045),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3045),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_as] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3045),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_RBRACE] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3045),
    [anon_sym_RPAREN] = ACTIONS(3045),
    [anon_sym_fn] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3045),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_PERCENT] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_GT] = ACTIONS(3045),
    [anon_sym_EQ_EQ] = ACTIONS(3045),
    [anon_sym_BANG_EQ] = ACTIONS(3045),
    [anon_sym_LT_EQ] = ACTIONS(3045),
    [anon_sym_GT_EQ] = ACTIONS(3045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_struct] = ACTIONS(3045),
    [anon_sym_mut] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3045),
    [anon_sym_go] = ACTIONS(3045),
    [anon_sym_spawn] = ACTIONS(3045),
    [anon_sym_json_DOTdecode] = ACTIONS(3045),
    [anon_sym_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACK2] = ACTIONS(3045),
    [anon_sym_TILDE] = ACTIONS(3045),
    [anon_sym_CARET] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3045),
    [anon_sym_LT_DASH] = ACTIONS(3045),
    [anon_sym_LT_LT] = ACTIONS(3045),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_GT_GT_GT] = ACTIONS(3045),
    [anon_sym_AMP_CARET] = ACTIONS(3045),
    [anon_sym_AMP_AMP] = ACTIONS(3045),
    [anon_sym_PIPE_PIPE] = ACTIONS(3045),
    [anon_sym_or] = ACTIONS(3045),
    [sym_none] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_nil] = ACTIONS(3045),
    [anon_sym_QMARK_DOT] = ACTIONS(3045),
    [anon_sym_POUND_LBRACK] = ACTIONS(3045),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_DOLLARif] = ACTIONS(3045),
    [anon_sym_is] = ACTIONS(3045),
    [anon_sym_BANGis] = ACTIONS(3045),
    [anon_sym_in] = ACTIONS(3045),
    [anon_sym_BANGin] = ACTIONS(3045),
    [anon_sym_match] = ACTIONS(3045),
    [anon_sym_select] = ACTIONS(3045),
    [anon_sym_lock] = ACTIONS(3045),
    [anon_sym_rlock] = ACTIONS(3045),
    [anon_sym_unsafe] = ACTIONS(3045),
    [anon_sym_sql] = ACTIONS(3045),
    [sym_int_literal] = ACTIONS(3045),
    [sym_float_literal] = ACTIONS(3045),
    [sym_rune_literal] = ACTIONS(3045),
    [anon_sym_SQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE] = ACTIONS(3045),
    [anon_sym_c_SQUOTE] = ACTIONS(3045),
    [anon_sym_c_DQUOTE] = ACTIONS(3045),
    [anon_sym_r_SQUOTE] = ACTIONS(3045),
    [anon_sym_r_DQUOTE] = ACTIONS(3045),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3045),
    [anon_sym_shared] = ACTIONS(3045),
    [anon_sym_map_LBRACK] = ACTIONS(3045),
    [anon_sym_chan] = ACTIONS(3045),
    [anon_sym_thread] = ACTIONS(3045),
    [anon_sym_atomic] = ACTIONS(3045),
  },
  [1528] = {
    [sym_line_comment] = STATE(1528),
    [sym_block_comment] = STATE(1528),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LF] = ACTIONS(2893),
    [anon_sym_CR] = ACTIONS(2893),
    [anon_sym_CR_LF] = ACTIONS(2893),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2893),
    [anon_sym_as] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_RBRACE] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2893),
    [anon_sym_RPAREN] = ACTIONS(2893),
    [anon_sym_fn] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_PERCENT] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_GT] = ACTIONS(2893),
    [anon_sym_EQ_EQ] = ACTIONS(2893),
    [anon_sym_BANG_EQ] = ACTIONS(2893),
    [anon_sym_LT_EQ] = ACTIONS(2893),
    [anon_sym_GT_EQ] = ACTIONS(2893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_mut] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2893),
    [anon_sym_DASH_DASH] = ACTIONS(2893),
    [anon_sym_QMARK] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_go] = ACTIONS(2893),
    [anon_sym_spawn] = ACTIONS(2893),
    [anon_sym_json_DOTdecode] = ACTIONS(2893),
    [anon_sym_PIPE] = ACTIONS(2893),
    [anon_sym_LBRACK2] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_LT_DASH] = ACTIONS(2893),
    [anon_sym_LT_LT] = ACTIONS(2893),
    [anon_sym_GT_GT] = ACTIONS(2893),
    [anon_sym_GT_GT_GT] = ACTIONS(2893),
    [anon_sym_AMP_CARET] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2893),
    [anon_sym_PIPE_PIPE] = ACTIONS(2893),
    [anon_sym_or] = ACTIONS(2893),
    [sym_none] = ACTIONS(2893),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [sym_nil] = ACTIONS(2893),
    [anon_sym_QMARK_DOT] = ACTIONS(2893),
    [anon_sym_POUND_LBRACK] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_DOLLARif] = ACTIONS(2893),
    [anon_sym_is] = ACTIONS(2893),
    [anon_sym_BANGis] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_BANGin] = ACTIONS(2893),
    [anon_sym_match] = ACTIONS(2893),
    [anon_sym_select] = ACTIONS(2893),
    [anon_sym_lock] = ACTIONS(2893),
    [anon_sym_rlock] = ACTIONS(2893),
    [anon_sym_unsafe] = ACTIONS(2893),
    [anon_sym_sql] = ACTIONS(2893),
    [sym_int_literal] = ACTIONS(2893),
    [sym_float_literal] = ACTIONS(2893),
    [sym_rune_literal] = ACTIONS(2893),
    [anon_sym_SQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(2893),
    [anon_sym_c_SQUOTE] = ACTIONS(2893),
    [anon_sym_c_DQUOTE] = ACTIONS(2893),
    [anon_sym_r_SQUOTE] = ACTIONS(2893),
    [anon_sym_r_DQUOTE] = ACTIONS(2893),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_map_LBRACK] = ACTIONS(2893),
    [anon_sym_chan] = ACTIONS(2893),
    [anon_sym_thread] = ACTIONS(2893),
    [anon_sym_atomic] = ACTIONS(2893),
  },
  [1529] = {
    [sym_line_comment] = STATE(1529),
    [sym_block_comment] = STATE(1529),
    [sym_identifier] = ACTIONS(2187),
    [anon_sym_LF] = ACTIONS(2187),
    [anon_sym_CR] = ACTIONS(2187),
    [anon_sym_CR_LF] = ACTIONS(2187),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2187),
    [anon_sym_DOT] = ACTIONS(2187),
    [anon_sym_as] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_RBRACE] = ACTIONS(2187),
    [anon_sym_LPAREN] = ACTIONS(2187),
    [anon_sym_RPAREN] = ACTIONS(2187),
    [anon_sym_fn] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [anon_sym_LT] = ACTIONS(2187),
    [anon_sym_GT] = ACTIONS(2187),
    [anon_sym_EQ_EQ] = ACTIONS(2187),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2187),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2185),
    [anon_sym_struct] = ACTIONS(2187),
    [anon_sym_mut] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_go] = ACTIONS(2187),
    [anon_sym_spawn] = ACTIONS(2187),
    [anon_sym_json_DOTdecode] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2187),
    [anon_sym_LBRACK2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_LT_DASH] = ACTIONS(2187),
    [anon_sym_LT_LT] = ACTIONS(2187),
    [anon_sym_GT_GT] = ACTIONS(2187),
    [anon_sym_GT_GT_GT] = ACTIONS(2187),
    [anon_sym_AMP_CARET] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2187),
    [sym_none] = ACTIONS(2187),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [sym_nil] = ACTIONS(2187),
    [anon_sym_QMARK_DOT] = ACTIONS(2187),
    [anon_sym_POUND_LBRACK] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_DOLLARif] = ACTIONS(2187),
    [anon_sym_is] = ACTIONS(2187),
    [anon_sym_BANGis] = ACTIONS(2187),
    [anon_sym_in] = ACTIONS(2187),
    [anon_sym_BANGin] = ACTIONS(2187),
    [anon_sym_match] = ACTIONS(2187),
    [anon_sym_select] = ACTIONS(2187),
    [anon_sym_lock] = ACTIONS(2187),
    [anon_sym_rlock] = ACTIONS(2187),
    [anon_sym_unsafe] = ACTIONS(2187),
    [anon_sym_sql] = ACTIONS(2187),
    [sym_int_literal] = ACTIONS(2187),
    [sym_float_literal] = ACTIONS(2187),
    [sym_rune_literal] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(2187),
    [anon_sym_DQUOTE] = ACTIONS(2187),
    [anon_sym_c_SQUOTE] = ACTIONS(2187),
    [anon_sym_c_DQUOTE] = ACTIONS(2187),
    [anon_sym_r_SQUOTE] = ACTIONS(2187),
    [anon_sym_r_DQUOTE] = ACTIONS(2187),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2187),
    [anon_sym_shared] = ACTIONS(2187),
    [anon_sym_map_LBRACK] = ACTIONS(2187),
    [anon_sym_chan] = ACTIONS(2187),
    [anon_sym_thread] = ACTIONS(2187),
    [anon_sym_atomic] = ACTIONS(2187),
  },
  [1530] = {
    [sym_line_comment] = STATE(1530),
    [sym_block_comment] = STATE(1530),
    [sym_identifier] = ACTIONS(2823),
    [anon_sym_LF] = ACTIONS(2823),
    [anon_sym_CR] = ACTIONS(2823),
    [anon_sym_CR_LF] = ACTIONS(2823),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2823),
    [anon_sym_DOT] = ACTIONS(2823),
    [anon_sym_as] = ACTIONS(2823),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_COMMA] = ACTIONS(2823),
    [anon_sym_RBRACE] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_RPAREN] = ACTIONS(2823),
    [anon_sym_fn] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2823),
    [anon_sym_DASH] = ACTIONS(2823),
    [anon_sym_STAR] = ACTIONS(2823),
    [anon_sym_SLASH] = ACTIONS(2823),
    [anon_sym_PERCENT] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2823),
    [anon_sym_GT] = ACTIONS(2823),
    [anon_sym_EQ_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_EQ] = ACTIONS(2823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(2821),
    [anon_sym_struct] = ACTIONS(2823),
    [anon_sym_mut] = ACTIONS(2823),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_QMARK] = ACTIONS(2823),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_go] = ACTIONS(2823),
    [anon_sym_spawn] = ACTIONS(2823),
    [anon_sym_json_DOTdecode] = ACTIONS(2823),
    [anon_sym_PIPE] = ACTIONS(2823),
    [anon_sym_LBRACK2] = ACTIONS(2823),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_CARET] = ACTIONS(2823),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_LT_DASH] = ACTIONS(2823),
    [anon_sym_LT_LT] = ACTIONS(2823),
    [anon_sym_GT_GT] = ACTIONS(2823),
    [anon_sym_GT_GT_GT] = ACTIONS(2823),
    [anon_sym_AMP_CARET] = ACTIONS(2823),
    [anon_sym_AMP_AMP] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2823),
    [anon_sym_or] = ACTIONS(2823),
    [sym_none] = ACTIONS(2823),
    [sym_true] = ACTIONS(2823),
    [sym_false] = ACTIONS(2823),
    [sym_nil] = ACTIONS(2823),
    [anon_sym_QMARK_DOT] = ACTIONS(2823),
    [anon_sym_POUND_LBRACK] = ACTIONS(2823),
    [anon_sym_if] = ACTIONS(2823),
    [anon_sym_DOLLARif] = ACTIONS(2823),
    [anon_sym_is] = ACTIONS(2823),
    [anon_sym_BANGis] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(2823),
    [anon_sym_BANGin] = ACTIONS(2823),
    [anon_sym_match] = ACTIONS(2823),
    [anon_sym_select] = ACTIONS(2823),
    [anon_sym_lock] = ACTIONS(2823),
    [anon_sym_rlock] = ACTIONS(2823),
    [anon_sym_unsafe] = ACTIONS(2823),
    [anon_sym_sql] = ACTIONS(2823),
    [sym_int_literal] = ACTIONS(2823),
    [sym_float_literal] = ACTIONS(2823),
    [sym_rune_literal] = ACTIONS(2823),
    [anon_sym_SQUOTE] = ACTIONS(2823),
    [anon_sym_DQUOTE] = ACTIONS(2823),
    [anon_sym_c_SQUOTE] = ACTIONS(2823),
    [anon_sym_c_DQUOTE] = ACTIONS(2823),
    [anon_sym_r_SQUOTE] = ACTIONS(2823),
    [anon_sym_r_DQUOTE] = ACTIONS(2823),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2823),
    [anon_sym_shared] = ACTIONS(2823),
    [anon_sym_map_LBRACK] = ACTIONS(2823),
    [anon_sym_chan] = ACTIONS(2823),
    [anon_sym_thread] = ACTIONS(2823),
    [anon_sym_atomic] = ACTIONS(2823),
  },
  [1531] = {
    [sym_line_comment] = STATE(1531),
    [sym_block_comment] = STATE(1531),
    [sym_identifier] = ACTIONS(2967),
    [anon_sym_LF] = ACTIONS(2967),
    [anon_sym_CR] = ACTIONS(2967),
    [anon_sym_CR_LF] = ACTIONS(2967),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2967),
    [anon_sym_DOT] = ACTIONS(2967),
    [anon_sym_as] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2967),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_RBRACE] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(2967),
    [anon_sym_RPAREN] = ACTIONS(2967),
    [anon_sym_fn] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2967),
    [anon_sym_SLASH] = ACTIONS(2967),
    [anon_sym_PERCENT] = ACTIONS(2967),
    [anon_sym_LT] = ACTIONS(2967),
    [anon_sym_GT] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2967),
    [anon_sym_BANG_EQ] = ACTIONS(2967),
    [anon_sym_LT_EQ] = ACTIONS(2967),
    [anon_sym_GT_EQ] = ACTIONS(2967),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2965),
    [anon_sym_struct] = ACTIONS(2967),
    [anon_sym_mut] = ACTIONS(2967),
    [anon_sym_PLUS_PLUS] = ACTIONS(2967),
    [anon_sym_DASH_DASH] = ACTIONS(2967),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_BANG] = ACTIONS(2967),
    [anon_sym_go] = ACTIONS(2967),
    [anon_sym_spawn] = ACTIONS(2967),
    [anon_sym_json_DOTdecode] = ACTIONS(2967),
    [anon_sym_PIPE] = ACTIONS(2967),
    [anon_sym_LBRACK2] = ACTIONS(2967),
    [anon_sym_TILDE] = ACTIONS(2967),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_AMP] = ACTIONS(2967),
    [anon_sym_LT_DASH] = ACTIONS(2967),
    [anon_sym_LT_LT] = ACTIONS(2967),
    [anon_sym_GT_GT] = ACTIONS(2967),
    [anon_sym_GT_GT_GT] = ACTIONS(2967),
    [anon_sym_AMP_CARET] = ACTIONS(2967),
    [anon_sym_AMP_AMP] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE] = ACTIONS(2967),
    [anon_sym_or] = ACTIONS(2967),
    [sym_none] = ACTIONS(2967),
    [sym_true] = ACTIONS(2967),
    [sym_false] = ACTIONS(2967),
    [sym_nil] = ACTIONS(2967),
    [anon_sym_QMARK_DOT] = ACTIONS(2967),
    [anon_sym_POUND_LBRACK] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_DOLLARif] = ACTIONS(2967),
    [anon_sym_is] = ACTIONS(2967),
    [anon_sym_BANGis] = ACTIONS(2967),
    [anon_sym_in] = ACTIONS(2967),
    [anon_sym_BANGin] = ACTIONS(2967),
    [anon_sym_match] = ACTIONS(2967),
    [anon_sym_select] = ACTIONS(2967),
    [anon_sym_lock] = ACTIONS(2967),
    [anon_sym_rlock] = ACTIONS(2967),
    [anon_sym_unsafe] = ACTIONS(2967),
    [anon_sym_sql] = ACTIONS(2967),
    [sym_int_literal] = ACTIONS(2967),
    [sym_float_literal] = ACTIONS(2967),
    [sym_rune_literal] = ACTIONS(2967),
    [anon_sym_SQUOTE] = ACTIONS(2967),
    [anon_sym_DQUOTE] = ACTIONS(2967),
    [anon_sym_c_SQUOTE] = ACTIONS(2967),
    [anon_sym_c_DQUOTE] = ACTIONS(2967),
    [anon_sym_r_SQUOTE] = ACTIONS(2967),
    [anon_sym_r_DQUOTE] = ACTIONS(2967),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2967),
    [anon_sym_shared] = ACTIONS(2967),
    [anon_sym_map_LBRACK] = ACTIONS(2967),
    [anon_sym_chan] = ACTIONS(2967),
    [anon_sym_thread] = ACTIONS(2967),
    [anon_sym_atomic] = ACTIONS(2967),
  },
  [1532] = {
    [sym_line_comment] = STATE(1532),
    [sym_block_comment] = STATE(1532),
    [sym_identifier] = ACTIONS(3246),
    [anon_sym_LF] = ACTIONS(3246),
    [anon_sym_CR] = ACTIONS(3246),
    [anon_sym_CR_LF] = ACTIONS(3246),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3246),
    [anon_sym_DOT] = ACTIONS(3246),
    [anon_sym_as] = ACTIONS(3246),
    [anon_sym_LBRACE] = ACTIONS(3246),
    [anon_sym_COMMA] = ACTIONS(3246),
    [anon_sym_RBRACE] = ACTIONS(3246),
    [anon_sym_LPAREN] = ACTIONS(3246),
    [anon_sym_RPAREN] = ACTIONS(3246),
    [anon_sym_fn] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3246),
    [anon_sym_DASH] = ACTIONS(3246),
    [anon_sym_STAR] = ACTIONS(3246),
    [anon_sym_SLASH] = ACTIONS(3246),
    [anon_sym_PERCENT] = ACTIONS(3246),
    [anon_sym_LT] = ACTIONS(3246),
    [anon_sym_GT] = ACTIONS(3246),
    [anon_sym_EQ_EQ] = ACTIONS(3246),
    [anon_sym_BANG_EQ] = ACTIONS(3246),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3246),
    [anon_sym_LBRACK] = ACTIONS(3244),
    [anon_sym_struct] = ACTIONS(3246),
    [anon_sym_mut] = ACTIONS(3246),
    [anon_sym_PLUS_PLUS] = ACTIONS(3246),
    [anon_sym_DASH_DASH] = ACTIONS(3246),
    [anon_sym_QMARK] = ACTIONS(3246),
    [anon_sym_BANG] = ACTIONS(3246),
    [anon_sym_go] = ACTIONS(3246),
    [anon_sym_spawn] = ACTIONS(3246),
    [anon_sym_json_DOTdecode] = ACTIONS(3246),
    [anon_sym_PIPE] = ACTIONS(3246),
    [anon_sym_LBRACK2] = ACTIONS(3246),
    [anon_sym_TILDE] = ACTIONS(3246),
    [anon_sym_CARET] = ACTIONS(3246),
    [anon_sym_AMP] = ACTIONS(3246),
    [anon_sym_LT_DASH] = ACTIONS(3246),
    [anon_sym_LT_LT] = ACTIONS(3246),
    [anon_sym_GT_GT] = ACTIONS(3246),
    [anon_sym_GT_GT_GT] = ACTIONS(3246),
    [anon_sym_AMP_CARET] = ACTIONS(3246),
    [anon_sym_AMP_AMP] = ACTIONS(3246),
    [anon_sym_PIPE_PIPE] = ACTIONS(3246),
    [anon_sym_or] = ACTIONS(3246),
    [sym_none] = ACTIONS(3246),
    [sym_true] = ACTIONS(3246),
    [sym_false] = ACTIONS(3246),
    [sym_nil] = ACTIONS(3246),
    [anon_sym_QMARK_DOT] = ACTIONS(3246),
    [anon_sym_POUND_LBRACK] = ACTIONS(3246),
    [anon_sym_if] = ACTIONS(3246),
    [anon_sym_DOLLARif] = ACTIONS(3246),
    [anon_sym_is] = ACTIONS(3246),
    [anon_sym_BANGis] = ACTIONS(3246),
    [anon_sym_in] = ACTIONS(3246),
    [anon_sym_BANGin] = ACTIONS(3246),
    [anon_sym_match] = ACTIONS(3246),
    [anon_sym_select] = ACTIONS(3246),
    [anon_sym_lock] = ACTIONS(3246),
    [anon_sym_rlock] = ACTIONS(3246),
    [anon_sym_unsafe] = ACTIONS(3246),
    [anon_sym_sql] = ACTIONS(3246),
    [sym_int_literal] = ACTIONS(3246),
    [sym_float_literal] = ACTIONS(3246),
    [sym_rune_literal] = ACTIONS(3246),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_DQUOTE] = ACTIONS(3246),
    [anon_sym_c_SQUOTE] = ACTIONS(3246),
    [anon_sym_c_DQUOTE] = ACTIONS(3246),
    [anon_sym_r_SQUOTE] = ACTIONS(3246),
    [anon_sym_r_DQUOTE] = ACTIONS(3246),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3246),
    [anon_sym_shared] = ACTIONS(3246),
    [anon_sym_map_LBRACK] = ACTIONS(3246),
    [anon_sym_chan] = ACTIONS(3246),
    [anon_sym_thread] = ACTIONS(3246),
    [anon_sym_atomic] = ACTIONS(3246),
  },
  [1533] = {
    [sym_line_comment] = STATE(1533),
    [sym_block_comment] = STATE(1533),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2458),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_as] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(861),
    [anon_sym_COMMA] = ACTIONS(861),
    [anon_sym_LPAREN] = ACTIONS(3968),
    [anon_sym_EQ] = ACTIONS(865),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_STAR] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_PERCENT] = ACTIONS(865),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(861),
    [anon_sym_BANG_EQ] = ACTIONS(861),
    [anon_sym_LT_EQ] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_PLUS_PLUS] = ACTIONS(861),
    [anon_sym_DASH_DASH] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(4218),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_LBRACK2] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT_DASH] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(865),
    [anon_sym_GT_GT] = ACTIONS(865),
    [anon_sym_GT_GT_GT] = ACTIONS(865),
    [anon_sym_AMP_CARET] = ACTIONS(865),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_QMARK_DOT] = ACTIONS(861),
    [anon_sym_POUND_LBRACK] = ACTIONS(861),
    [anon_sym_is] = ACTIONS(865),
    [anon_sym_BANGis] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(865),
    [anon_sym_BANGin] = ACTIONS(861),
    [anon_sym_STAR_EQ] = ACTIONS(861),
    [anon_sym_SLASH_EQ] = ACTIONS(861),
    [anon_sym_PERCENT_EQ] = ACTIONS(861),
    [anon_sym_LT_LT_EQ] = ACTIONS(861),
    [anon_sym_GT_GT_EQ] = ACTIONS(861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(861),
    [anon_sym_AMP_EQ] = ACTIONS(861),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(861),
    [anon_sym_PLUS_EQ] = ACTIONS(861),
    [anon_sym_DASH_EQ] = ACTIONS(861),
    [anon_sym_PIPE_EQ] = ACTIONS(861),
    [anon_sym_CARET_EQ] = ACTIONS(861),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [1534] = {
    [sym_line_comment] = STATE(1534),
    [sym_block_comment] = STATE(1534),
    [sym_identifier] = ACTIONS(3266),
    [anon_sym_LF] = ACTIONS(3266),
    [anon_sym_CR] = ACTIONS(3266),
    [anon_sym_CR_LF] = ACTIONS(3266),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3266),
    [anon_sym_DOT] = ACTIONS(3266),
    [anon_sym_as] = ACTIONS(3266),
    [anon_sym_LBRACE] = ACTIONS(3266),
    [anon_sym_COMMA] = ACTIONS(3266),
    [anon_sym_RBRACE] = ACTIONS(3266),
    [anon_sym_LPAREN] = ACTIONS(3266),
    [anon_sym_RPAREN] = ACTIONS(3266),
    [anon_sym_fn] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3266),
    [anon_sym_DASH] = ACTIONS(3266),
    [anon_sym_STAR] = ACTIONS(3266),
    [anon_sym_SLASH] = ACTIONS(3266),
    [anon_sym_PERCENT] = ACTIONS(3266),
    [anon_sym_LT] = ACTIONS(3266),
    [anon_sym_GT] = ACTIONS(3266),
    [anon_sym_EQ_EQ] = ACTIONS(3266),
    [anon_sym_BANG_EQ] = ACTIONS(3266),
    [anon_sym_LT_EQ] = ACTIONS(3266),
    [anon_sym_GT_EQ] = ACTIONS(3266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3266),
    [anon_sym_LBRACK] = ACTIONS(3264),
    [anon_sym_struct] = ACTIONS(3266),
    [anon_sym_mut] = ACTIONS(3266),
    [anon_sym_PLUS_PLUS] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3266),
    [anon_sym_QMARK] = ACTIONS(3266),
    [anon_sym_BANG] = ACTIONS(3266),
    [anon_sym_go] = ACTIONS(3266),
    [anon_sym_spawn] = ACTIONS(3266),
    [anon_sym_json_DOTdecode] = ACTIONS(3266),
    [anon_sym_PIPE] = ACTIONS(3266),
    [anon_sym_LBRACK2] = ACTIONS(3266),
    [anon_sym_TILDE] = ACTIONS(3266),
    [anon_sym_CARET] = ACTIONS(3266),
    [anon_sym_AMP] = ACTIONS(3266),
    [anon_sym_LT_DASH] = ACTIONS(3266),
    [anon_sym_LT_LT] = ACTIONS(3266),
    [anon_sym_GT_GT] = ACTIONS(3266),
    [anon_sym_GT_GT_GT] = ACTIONS(3266),
    [anon_sym_AMP_CARET] = ACTIONS(3266),
    [anon_sym_AMP_AMP] = ACTIONS(3266),
    [anon_sym_PIPE_PIPE] = ACTIONS(3266),
    [anon_sym_or] = ACTIONS(3266),
    [sym_none] = ACTIONS(3266),
    [sym_true] = ACTIONS(3266),
    [sym_false] = ACTIONS(3266),
    [sym_nil] = ACTIONS(3266),
    [anon_sym_QMARK_DOT] = ACTIONS(3266),
    [anon_sym_POUND_LBRACK] = ACTIONS(3266),
    [anon_sym_if] = ACTIONS(3266),
    [anon_sym_DOLLARif] = ACTIONS(3266),
    [anon_sym_is] = ACTIONS(3266),
    [anon_sym_BANGis] = ACTIONS(3266),
    [anon_sym_in] = ACTIONS(3266),
    [anon_sym_BANGin] = ACTIONS(3266),
    [anon_sym_match] = ACTIONS(3266),
    [anon_sym_select] = ACTIONS(3266),
    [anon_sym_lock] = ACTIONS(3266),
    [anon_sym_rlock] = ACTIONS(3266),
    [anon_sym_unsafe] = ACTIONS(3266),
    [anon_sym_sql] = ACTIONS(3266),
    [sym_int_literal] = ACTIONS(3266),
    [sym_float_literal] = ACTIONS(3266),
    [sym_rune_literal] = ACTIONS(3266),
    [anon_sym_SQUOTE] = ACTIONS(3266),
    [anon_sym_DQUOTE] = ACTIONS(3266),
    [anon_sym_c_SQUOTE] = ACTIONS(3266),
    [anon_sym_c_DQUOTE] = ACTIONS(3266),
    [anon_sym_r_SQUOTE] = ACTIONS(3266),
    [anon_sym_r_DQUOTE] = ACTIONS(3266),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3266),
    [anon_sym_shared] = ACTIONS(3266),
    [anon_sym_map_LBRACK] = ACTIONS(3266),
    [anon_sym_chan] = ACTIONS(3266),
    [anon_sym_thread] = ACTIONS(3266),
    [anon_sym_atomic] = ACTIONS(3266),
  },
  [1535] = {
    [sym_line_comment] = STATE(1535),
    [sym_block_comment] = STATE(1535),
    [sym_identifier] = ACTIONS(3270),
    [anon_sym_LF] = ACTIONS(3270),
    [anon_sym_CR] = ACTIONS(3270),
    [anon_sym_CR_LF] = ACTIONS(3270),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3270),
    [anon_sym_DOT] = ACTIONS(3270),
    [anon_sym_as] = ACTIONS(3270),
    [anon_sym_LBRACE] = ACTIONS(3270),
    [anon_sym_COMMA] = ACTIONS(3270),
    [anon_sym_RBRACE] = ACTIONS(3270),
    [anon_sym_LPAREN] = ACTIONS(3270),
    [anon_sym_RPAREN] = ACTIONS(3270),
    [anon_sym_fn] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3270),
    [anon_sym_DASH] = ACTIONS(3270),
    [anon_sym_STAR] = ACTIONS(3270),
    [anon_sym_SLASH] = ACTIONS(3270),
    [anon_sym_PERCENT] = ACTIONS(3270),
    [anon_sym_LT] = ACTIONS(3270),
    [anon_sym_GT] = ACTIONS(3270),
    [anon_sym_EQ_EQ] = ACTIONS(3270),
    [anon_sym_BANG_EQ] = ACTIONS(3270),
    [anon_sym_LT_EQ] = ACTIONS(3270),
    [anon_sym_GT_EQ] = ACTIONS(3270),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3270),
    [anon_sym_LBRACK] = ACTIONS(3268),
    [anon_sym_struct] = ACTIONS(3270),
    [anon_sym_mut] = ACTIONS(3270),
    [anon_sym_PLUS_PLUS] = ACTIONS(3270),
    [anon_sym_DASH_DASH] = ACTIONS(3270),
    [anon_sym_QMARK] = ACTIONS(3270),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_go] = ACTIONS(3270),
    [anon_sym_spawn] = ACTIONS(3270),
    [anon_sym_json_DOTdecode] = ACTIONS(3270),
    [anon_sym_PIPE] = ACTIONS(3270),
    [anon_sym_LBRACK2] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3270),
    [anon_sym_CARET] = ACTIONS(3270),
    [anon_sym_AMP] = ACTIONS(3270),
    [anon_sym_LT_DASH] = ACTIONS(3270),
    [anon_sym_LT_LT] = ACTIONS(3270),
    [anon_sym_GT_GT] = ACTIONS(3270),
    [anon_sym_GT_GT_GT] = ACTIONS(3270),
    [anon_sym_AMP_CARET] = ACTIONS(3270),
    [anon_sym_AMP_AMP] = ACTIONS(3270),
    [anon_sym_PIPE_PIPE] = ACTIONS(3270),
    [anon_sym_or] = ACTIONS(3270),
    [sym_none] = ACTIONS(3270),
    [sym_true] = ACTIONS(3270),
    [sym_false] = ACTIONS(3270),
    [sym_nil] = ACTIONS(3270),
    [anon_sym_QMARK_DOT] = ACTIONS(3270),
    [anon_sym_POUND_LBRACK] = ACTIONS(3270),
    [anon_sym_if] = ACTIONS(3270),
    [anon_sym_DOLLARif] = ACTIONS(3270),
    [anon_sym_is] = ACTIONS(3270),
    [anon_sym_BANGis] = ACTIONS(3270),
    [anon_sym_in] = ACTIONS(3270),
    [anon_sym_BANGin] = ACTIONS(3270),
    [anon_sym_match] = ACTIONS(3270),
    [anon_sym_select] = ACTIONS(3270),
    [anon_sym_lock] = ACTIONS(3270),
    [anon_sym_rlock] = ACTIONS(3270),
    [anon_sym_unsafe] = ACTIONS(3270),
    [anon_sym_sql] = ACTIONS(3270),
    [sym_int_literal] = ACTIONS(3270),
    [sym_float_literal] = ACTIONS(3270),
    [sym_rune_literal] = ACTIONS(3270),
    [anon_sym_SQUOTE] = ACTIONS(3270),
    [anon_sym_DQUOTE] = ACTIONS(3270),
    [anon_sym_c_SQUOTE] = ACTIONS(3270),
    [anon_sym_c_DQUOTE] = ACTIONS(3270),
    [anon_sym_r_SQUOTE] = ACTIONS(3270),
    [anon_sym_r_DQUOTE] = ACTIONS(3270),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3270),
    [anon_sym_shared] = ACTIONS(3270),
    [anon_sym_map_LBRACK] = ACTIONS(3270),
    [anon_sym_chan] = ACTIONS(3270),
    [anon_sym_thread] = ACTIONS(3270),
    [anon_sym_atomic] = ACTIONS(3270),
  },
  [1536] = {
    [sym_line_comment] = STATE(1536),
    [sym_block_comment] = STATE(1536),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LF] = ACTIONS(3318),
    [anon_sym_CR] = ACTIONS(3318),
    [anon_sym_CR_LF] = ACTIONS(3318),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3318),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_as] = ACTIONS(3318),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3318),
    [anon_sym_RBRACE] = ACTIONS(3318),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_RPAREN] = ACTIONS(3318),
    [anon_sym_fn] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_SLASH] = ACTIONS(3318),
    [anon_sym_PERCENT] = ACTIONS(3318),
    [anon_sym_LT] = ACTIONS(3318),
    [anon_sym_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_LT_EQ] = ACTIONS(3318),
    [anon_sym_GT_EQ] = ACTIONS(3318),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3316),
    [anon_sym_struct] = ACTIONS(3318),
    [anon_sym_mut] = ACTIONS(3318),
    [anon_sym_PLUS_PLUS] = ACTIONS(3318),
    [anon_sym_DASH_DASH] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_BANG] = ACTIONS(3318),
    [anon_sym_go] = ACTIONS(3318),
    [anon_sym_spawn] = ACTIONS(3318),
    [anon_sym_json_DOTdecode] = ACTIONS(3318),
    [anon_sym_PIPE] = ACTIONS(3318),
    [anon_sym_LBRACK2] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3318),
    [anon_sym_CARET] = ACTIONS(3318),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LT_DASH] = ACTIONS(3318),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_GT_GT_GT] = ACTIONS(3318),
    [anon_sym_AMP_CARET] = ACTIONS(3318),
    [anon_sym_AMP_AMP] = ACTIONS(3318),
    [anon_sym_PIPE_PIPE] = ACTIONS(3318),
    [anon_sym_or] = ACTIONS(3318),
    [sym_none] = ACTIONS(3318),
    [sym_true] = ACTIONS(3318),
    [sym_false] = ACTIONS(3318),
    [sym_nil] = ACTIONS(3318),
    [anon_sym_QMARK_DOT] = ACTIONS(3318),
    [anon_sym_POUND_LBRACK] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_DOLLARif] = ACTIONS(3318),
    [anon_sym_is] = ACTIONS(3318),
    [anon_sym_BANGis] = ACTIONS(3318),
    [anon_sym_in] = ACTIONS(3318),
    [anon_sym_BANGin] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_select] = ACTIONS(3318),
    [anon_sym_lock] = ACTIONS(3318),
    [anon_sym_rlock] = ACTIONS(3318),
    [anon_sym_unsafe] = ACTIONS(3318),
    [anon_sym_sql] = ACTIONS(3318),
    [sym_int_literal] = ACTIONS(3318),
    [sym_float_literal] = ACTIONS(3318),
    [sym_rune_literal] = ACTIONS(3318),
    [anon_sym_SQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_c_SQUOTE] = ACTIONS(3318),
    [anon_sym_c_DQUOTE] = ACTIONS(3318),
    [anon_sym_r_SQUOTE] = ACTIONS(3318),
    [anon_sym_r_DQUOTE] = ACTIONS(3318),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3318),
    [anon_sym_shared] = ACTIONS(3318),
    [anon_sym_map_LBRACK] = ACTIONS(3318),
    [anon_sym_chan] = ACTIONS(3318),
    [anon_sym_thread] = ACTIONS(3318),
    [anon_sym_atomic] = ACTIONS(3318),
  },
  [1537] = {
    [sym_line_comment] = STATE(1537),
    [sym_block_comment] = STATE(1537),
    [sym_identifier] = ACTIONS(4178),
    [anon_sym_LF] = ACTIONS(4181),
    [anon_sym_CR] = ACTIONS(4181),
    [anon_sym_CR_LF] = ACTIONS(4181),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4181),
    [anon_sym_DOT] = ACTIONS(4220),
    [anon_sym_as] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3045),
    [anon_sym_COMMA] = ACTIONS(4181),
    [anon_sym_RBRACE] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(3045),
    [anon_sym_fn] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3045),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_PERCENT] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_GT] = ACTIONS(3045),
    [anon_sym_EQ_EQ] = ACTIONS(3045),
    [anon_sym_BANG_EQ] = ACTIONS(3045),
    [anon_sym_LT_EQ] = ACTIONS(3045),
    [anon_sym_GT_EQ] = ACTIONS(3045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4184),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_struct] = ACTIONS(3045),
    [anon_sym_mut] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3045),
    [anon_sym_go] = ACTIONS(3045),
    [anon_sym_spawn] = ACTIONS(3045),
    [anon_sym_json_DOTdecode] = ACTIONS(3045),
    [anon_sym_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACK2] = ACTIONS(3045),
    [anon_sym_TILDE] = ACTIONS(3045),
    [anon_sym_CARET] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3045),
    [anon_sym_LT_DASH] = ACTIONS(3045),
    [anon_sym_LT_LT] = ACTIONS(3045),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_GT_GT_GT] = ACTIONS(3045),
    [anon_sym_AMP_CARET] = ACTIONS(3045),
    [anon_sym_AMP_AMP] = ACTIONS(3045),
    [anon_sym_PIPE_PIPE] = ACTIONS(3045),
    [anon_sym_or] = ACTIONS(3045),
    [sym_none] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_nil] = ACTIONS(3045),
    [anon_sym_QMARK_DOT] = ACTIONS(3045),
    [anon_sym_POUND_LBRACK] = ACTIONS(3045),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_DOLLARif] = ACTIONS(3045),
    [anon_sym_is] = ACTIONS(3045),
    [anon_sym_BANGis] = ACTIONS(3045),
    [anon_sym_in] = ACTIONS(3045),
    [anon_sym_BANGin] = ACTIONS(3045),
    [anon_sym_match] = ACTIONS(3045),
    [anon_sym_select] = ACTIONS(3045),
    [anon_sym_lock] = ACTIONS(3045),
    [anon_sym_rlock] = ACTIONS(3045),
    [anon_sym_unsafe] = ACTIONS(3045),
    [anon_sym_sql] = ACTIONS(3045),
    [sym_int_literal] = ACTIONS(3045),
    [sym_float_literal] = ACTIONS(3045),
    [sym_rune_literal] = ACTIONS(3045),
    [anon_sym_SQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE] = ACTIONS(3045),
    [anon_sym_c_SQUOTE] = ACTIONS(3045),
    [anon_sym_c_DQUOTE] = ACTIONS(3045),
    [anon_sym_r_SQUOTE] = ACTIONS(3045),
    [anon_sym_r_DQUOTE] = ACTIONS(3045),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3045),
    [anon_sym_shared] = ACTIONS(3045),
    [anon_sym_map_LBRACK] = ACTIONS(3045),
    [anon_sym_chan] = ACTIONS(3045),
    [anon_sym_thread] = ACTIONS(3045),
    [anon_sym_atomic] = ACTIONS(3045),
  },
  [1538] = {
    [sym_line_comment] = STATE(1538),
    [sym_block_comment] = STATE(1538),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_LF] = ACTIONS(3055),
    [anon_sym_CR] = ACTIONS(3055),
    [anon_sym_CR_LF] = ACTIONS(3055),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3055),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_as] = ACTIONS(3055),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3055),
    [anon_sym_RBRACE] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_RPAREN] = ACTIONS(3055),
    [anon_sym_fn] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3055),
    [anon_sym_SLASH] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(3055),
    [anon_sym_GT] = ACTIONS(3055),
    [anon_sym_EQ_EQ] = ACTIONS(3055),
    [anon_sym_BANG_EQ] = ACTIONS(3055),
    [anon_sym_LT_EQ] = ACTIONS(3055),
    [anon_sym_GT_EQ] = ACTIONS(3055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_struct] = ACTIONS(3055),
    [anon_sym_mut] = ACTIONS(3055),
    [anon_sym_PLUS_PLUS] = ACTIONS(3055),
    [anon_sym_DASH_DASH] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_BANG] = ACTIONS(3055),
    [anon_sym_go] = ACTIONS(3055),
    [anon_sym_spawn] = ACTIONS(3055),
    [anon_sym_json_DOTdecode] = ACTIONS(3055),
    [anon_sym_PIPE] = ACTIONS(3055),
    [anon_sym_LBRACK2] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3055),
    [anon_sym_CARET] = ACTIONS(3055),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT_DASH] = ACTIONS(3055),
    [anon_sym_LT_LT] = ACTIONS(3055),
    [anon_sym_GT_GT] = ACTIONS(3055),
    [anon_sym_GT_GT_GT] = ACTIONS(3055),
    [anon_sym_AMP_CARET] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3055),
    [anon_sym_or] = ACTIONS(3055),
    [sym_none] = ACTIONS(3055),
    [sym_true] = ACTIONS(3055),
    [sym_false] = ACTIONS(3055),
    [sym_nil] = ACTIONS(3055),
    [anon_sym_QMARK_DOT] = ACTIONS(3055),
    [anon_sym_POUND_LBRACK] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_DOLLARif] = ACTIONS(3055),
    [anon_sym_is] = ACTIONS(3055),
    [anon_sym_BANGis] = ACTIONS(3055),
    [anon_sym_in] = ACTIONS(3055),
    [anon_sym_BANGin] = ACTIONS(3055),
    [anon_sym_match] = ACTIONS(3055),
    [anon_sym_select] = ACTIONS(3055),
    [anon_sym_lock] = ACTIONS(3055),
    [anon_sym_rlock] = ACTIONS(3055),
    [anon_sym_unsafe] = ACTIONS(3055),
    [anon_sym_sql] = ACTIONS(3055),
    [sym_int_literal] = ACTIONS(3055),
    [sym_float_literal] = ACTIONS(3055),
    [sym_rune_literal] = ACTIONS(3055),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_c_SQUOTE] = ACTIONS(3055),
    [anon_sym_c_DQUOTE] = ACTIONS(3055),
    [anon_sym_r_SQUOTE] = ACTIONS(3055),
    [anon_sym_r_DQUOTE] = ACTIONS(3055),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3055),
    [anon_sym_shared] = ACTIONS(3055),
    [anon_sym_map_LBRACK] = ACTIONS(3055),
    [anon_sym_chan] = ACTIONS(3055),
    [anon_sym_thread] = ACTIONS(3055),
    [anon_sym_atomic] = ACTIONS(3055),
  },
  [1539] = {
    [sym_line_comment] = STATE(1539),
    [sym_block_comment] = STATE(1539),
    [sym_identifier] = ACTIONS(3049),
    [anon_sym_LF] = ACTIONS(3049),
    [anon_sym_CR] = ACTIONS(3049),
    [anon_sym_CR_LF] = ACTIONS(3049),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3049),
    [anon_sym_DOT] = ACTIONS(3049),
    [anon_sym_as] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_COMMA] = ACTIONS(3049),
    [anon_sym_RBRACE] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [anon_sym_RPAREN] = ACTIONS(3049),
    [anon_sym_fn] = ACTIONS(3049),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_STAR] = ACTIONS(3049),
    [anon_sym_SLASH] = ACTIONS(3049),
    [anon_sym_PERCENT] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_GT] = ACTIONS(3049),
    [anon_sym_EQ_EQ] = ACTIONS(3049),
    [anon_sym_BANG_EQ] = ACTIONS(3049),
    [anon_sym_LT_EQ] = ACTIONS(3049),
    [anon_sym_GT_EQ] = ACTIONS(3049),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3049),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_struct] = ACTIONS(3049),
    [anon_sym_mut] = ACTIONS(3049),
    [anon_sym_PLUS_PLUS] = ACTIONS(3049),
    [anon_sym_DASH_DASH] = ACTIONS(3049),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_BANG] = ACTIONS(3049),
    [anon_sym_go] = ACTIONS(3049),
    [anon_sym_spawn] = ACTIONS(3049),
    [anon_sym_json_DOTdecode] = ACTIONS(3049),
    [anon_sym_PIPE] = ACTIONS(3049),
    [anon_sym_LBRACK2] = ACTIONS(3049),
    [anon_sym_TILDE] = ACTIONS(3049),
    [anon_sym_CARET] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_LT_DASH] = ACTIONS(3049),
    [anon_sym_LT_LT] = ACTIONS(3049),
    [anon_sym_GT_GT] = ACTIONS(3049),
    [anon_sym_GT_GT_GT] = ACTIONS(3049),
    [anon_sym_AMP_CARET] = ACTIONS(3049),
    [anon_sym_AMP_AMP] = ACTIONS(3049),
    [anon_sym_PIPE_PIPE] = ACTIONS(3049),
    [anon_sym_or] = ACTIONS(3049),
    [sym_none] = ACTIONS(3049),
    [sym_true] = ACTIONS(3049),
    [sym_false] = ACTIONS(3049),
    [sym_nil] = ACTIONS(3049),
    [anon_sym_QMARK_DOT] = ACTIONS(3049),
    [anon_sym_POUND_LBRACK] = ACTIONS(3049),
    [anon_sym_if] = ACTIONS(3049),
    [anon_sym_DOLLARif] = ACTIONS(3049),
    [anon_sym_is] = ACTIONS(3049),
    [anon_sym_BANGis] = ACTIONS(3049),
    [anon_sym_in] = ACTIONS(3049),
    [anon_sym_BANGin] = ACTIONS(3049),
    [anon_sym_match] = ACTIONS(3049),
    [anon_sym_select] = ACTIONS(3049),
    [anon_sym_lock] = ACTIONS(3049),
    [anon_sym_rlock] = ACTIONS(3049),
    [anon_sym_unsafe] = ACTIONS(3049),
    [anon_sym_sql] = ACTIONS(3049),
    [sym_int_literal] = ACTIONS(3049),
    [sym_float_literal] = ACTIONS(3049),
    [sym_rune_literal] = ACTIONS(3049),
    [anon_sym_SQUOTE] = ACTIONS(3049),
    [anon_sym_DQUOTE] = ACTIONS(3049),
    [anon_sym_c_SQUOTE] = ACTIONS(3049),
    [anon_sym_c_DQUOTE] = ACTIONS(3049),
    [anon_sym_r_SQUOTE] = ACTIONS(3049),
    [anon_sym_r_DQUOTE] = ACTIONS(3049),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3049),
    [anon_sym_shared] = ACTIONS(3049),
    [anon_sym_map_LBRACK] = ACTIONS(3049),
    [anon_sym_chan] = ACTIONS(3049),
    [anon_sym_thread] = ACTIONS(3049),
    [anon_sym_atomic] = ACTIONS(3049),
  },
  [1540] = {
    [sym_line_comment] = STATE(1540),
    [sym_block_comment] = STATE(1540),
    [sym_identifier] = ACTIONS(2443),
    [anon_sym_LF] = ACTIONS(2443),
    [anon_sym_CR] = ACTIONS(2443),
    [anon_sym_CR_LF] = ACTIONS(2443),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2443),
    [anon_sym_DOT] = ACTIONS(2445),
    [anon_sym_as] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(2443),
    [anon_sym_COMMA] = ACTIONS(2443),
    [anon_sym_RBRACE] = ACTIONS(2443),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym_RPAREN] = ACTIONS(2443),
    [anon_sym_fn] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2445),
    [anon_sym_STAR] = ACTIONS(2445),
    [anon_sym_SLASH] = ACTIONS(2445),
    [anon_sym_PERCENT] = ACTIONS(2445),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_GT] = ACTIONS(2445),
    [anon_sym_EQ_EQ] = ACTIONS(2445),
    [anon_sym_BANG_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2443),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_struct] = ACTIONS(2443),
    [anon_sym_mut] = ACTIONS(2443),
    [anon_sym_PLUS_PLUS] = ACTIONS(2445),
    [anon_sym_DASH_DASH] = ACTIONS(2445),
    [anon_sym_QMARK] = ACTIONS(2445),
    [anon_sym_BANG] = ACTIONS(2445),
    [anon_sym_go] = ACTIONS(2443),
    [anon_sym_spawn] = ACTIONS(2443),
    [anon_sym_json_DOTdecode] = ACTIONS(2443),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_LBRACK2] = ACTIONS(2445),
    [anon_sym_TILDE] = ACTIONS(2443),
    [anon_sym_CARET] = ACTIONS(2445),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_LT_DASH] = ACTIONS(2443),
    [anon_sym_LT_LT] = ACTIONS(2445),
    [anon_sym_GT_GT] = ACTIONS(2445),
    [anon_sym_GT_GT_GT] = ACTIONS(2445),
    [anon_sym_AMP_CARET] = ACTIONS(2445),
    [anon_sym_AMP_AMP] = ACTIONS(2445),
    [anon_sym_PIPE_PIPE] = ACTIONS(2445),
    [anon_sym_or] = ACTIONS(2445),
    [sym_none] = ACTIONS(2443),
    [sym_true] = ACTIONS(2443),
    [sym_false] = ACTIONS(2443),
    [sym_nil] = ACTIONS(2443),
    [anon_sym_QMARK_DOT] = ACTIONS(2445),
    [anon_sym_POUND_LBRACK] = ACTIONS(2445),
    [anon_sym_if] = ACTIONS(2443),
    [anon_sym_DOLLARif] = ACTIONS(2443),
    [anon_sym_is] = ACTIONS(2445),
    [anon_sym_BANGis] = ACTIONS(2445),
    [anon_sym_in] = ACTIONS(2445),
    [anon_sym_BANGin] = ACTIONS(2445),
    [anon_sym_match] = ACTIONS(2443),
    [anon_sym_select] = ACTIONS(2443),
    [anon_sym_lock] = ACTIONS(2443),
    [anon_sym_rlock] = ACTIONS(2443),
    [anon_sym_unsafe] = ACTIONS(2443),
    [anon_sym_sql] = ACTIONS(2443),
    [sym_int_literal] = ACTIONS(2443),
    [sym_float_literal] = ACTIONS(2443),
    [sym_rune_literal] = ACTIONS(2443),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [anon_sym_DQUOTE] = ACTIONS(2443),
    [anon_sym_c_SQUOTE] = ACTIONS(2443),
    [anon_sym_c_DQUOTE] = ACTIONS(2443),
    [anon_sym_r_SQUOTE] = ACTIONS(2443),
    [anon_sym_r_DQUOTE] = ACTIONS(2443),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2443),
    [anon_sym_shared] = ACTIONS(2443),
    [anon_sym_map_LBRACK] = ACTIONS(2443),
    [anon_sym_chan] = ACTIONS(2443),
    [anon_sym_thread] = ACTIONS(2443),
    [anon_sym_atomic] = ACTIONS(2443),
  },
  [1541] = {
    [sym_line_comment] = STATE(1541),
    [sym_block_comment] = STATE(1541),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_LF] = ACTIONS(3292),
    [anon_sym_CR] = ACTIONS(3292),
    [anon_sym_CR_LF] = ACTIONS(3292),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(3292),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_COMMA] = ACTIONS(3292),
    [anon_sym_RBRACE] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_RPAREN] = ACTIONS(3292),
    [anon_sym_fn] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_LT] = ACTIONS(3292),
    [anon_sym_GT] = ACTIONS(3292),
    [anon_sym_EQ_EQ] = ACTIONS(3292),
    [anon_sym_BANG_EQ] = ACTIONS(3292),
    [anon_sym_LT_EQ] = ACTIONS(3292),
    [anon_sym_GT_EQ] = ACTIONS(3292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3290),
    [anon_sym_struct] = ACTIONS(3292),
    [anon_sym_mut] = ACTIONS(3292),
    [anon_sym_PLUS_PLUS] = ACTIONS(3292),
    [anon_sym_DASH_DASH] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3292),
    [anon_sym_BANG] = ACTIONS(3292),
    [anon_sym_go] = ACTIONS(3292),
    [anon_sym_spawn] = ACTIONS(3292),
    [anon_sym_json_DOTdecode] = ACTIONS(3292),
    [anon_sym_PIPE] = ACTIONS(3292),
    [anon_sym_LBRACK2] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3292),
    [anon_sym_CARET] = ACTIONS(3292),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LT_DASH] = ACTIONS(3292),
    [anon_sym_LT_LT] = ACTIONS(3292),
    [anon_sym_GT_GT] = ACTIONS(3292),
    [anon_sym_GT_GT_GT] = ACTIONS(3292),
    [anon_sym_AMP_CARET] = ACTIONS(3292),
    [anon_sym_AMP_AMP] = ACTIONS(3292),
    [anon_sym_PIPE_PIPE] = ACTIONS(3292),
    [anon_sym_or] = ACTIONS(3292),
    [sym_none] = ACTIONS(3292),
    [sym_true] = ACTIONS(3292),
    [sym_false] = ACTIONS(3292),
    [sym_nil] = ACTIONS(3292),
    [anon_sym_QMARK_DOT] = ACTIONS(3292),
    [anon_sym_POUND_LBRACK] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_DOLLARif] = ACTIONS(3292),
    [anon_sym_is] = ACTIONS(3292),
    [anon_sym_BANGis] = ACTIONS(3292),
    [anon_sym_in] = ACTIONS(3292),
    [anon_sym_BANGin] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_select] = ACTIONS(3292),
    [anon_sym_lock] = ACTIONS(3292),
    [anon_sym_rlock] = ACTIONS(3292),
    [anon_sym_unsafe] = ACTIONS(3292),
    [anon_sym_sql] = ACTIONS(3292),
    [sym_int_literal] = ACTIONS(3292),
    [sym_float_literal] = ACTIONS(3292),
    [sym_rune_literal] = ACTIONS(3292),
    [anon_sym_SQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_c_SQUOTE] = ACTIONS(3292),
    [anon_sym_c_DQUOTE] = ACTIONS(3292),
    [anon_sym_r_SQUOTE] = ACTIONS(3292),
    [anon_sym_r_DQUOTE] = ACTIONS(3292),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3292),
    [anon_sym_shared] = ACTIONS(3292),
    [anon_sym_map_LBRACK] = ACTIONS(3292),
    [anon_sym_chan] = ACTIONS(3292),
    [anon_sym_thread] = ACTIONS(3292),
    [anon_sym_atomic] = ACTIONS(3292),
  },
  [1542] = {
    [sym_line_comment] = STATE(1542),
    [sym_block_comment] = STATE(1542),
    [sym_identifier] = ACTIONS(2929),
    [anon_sym_LF] = ACTIONS(2929),
    [anon_sym_CR] = ACTIONS(2929),
    [anon_sym_CR_LF] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2929),
    [anon_sym_DOT] = ACTIONS(2929),
    [anon_sym_as] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2929),
    [anon_sym_COMMA] = ACTIONS(2929),
    [anon_sym_RBRACE] = ACTIONS(2929),
    [anon_sym_LPAREN] = ACTIONS(2929),
    [anon_sym_RPAREN] = ACTIONS(2929),
    [anon_sym_fn] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2929),
    [anon_sym_GT] = ACTIONS(2929),
    [anon_sym_EQ_EQ] = ACTIONS(2929),
    [anon_sym_BANG_EQ] = ACTIONS(2929),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2929),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2929),
    [anon_sym_mut] = ACTIONS(2929),
    [anon_sym_PLUS_PLUS] = ACTIONS(2929),
    [anon_sym_DASH_DASH] = ACTIONS(2929),
    [anon_sym_QMARK] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2929),
    [anon_sym_go] = ACTIONS(2929),
    [anon_sym_spawn] = ACTIONS(2929),
    [anon_sym_json_DOTdecode] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(2929),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2929),
    [anon_sym_CARET] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_LT_DASH] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(2929),
    [anon_sym_GT_GT] = ACTIONS(2929),
    [anon_sym_GT_GT_GT] = ACTIONS(2929),
    [anon_sym_AMP_CARET] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_or] = ACTIONS(2929),
    [sym_none] = ACTIONS(2929),
    [sym_true] = ACTIONS(2929),
    [sym_false] = ACTIONS(2929),
    [sym_nil] = ACTIONS(2929),
    [anon_sym_QMARK_DOT] = ACTIONS(2929),
    [anon_sym_POUND_LBRACK] = ACTIONS(2929),
    [anon_sym_if] = ACTIONS(2929),
    [anon_sym_DOLLARif] = ACTIONS(2929),
    [anon_sym_is] = ACTIONS(2929),
    [anon_sym_BANGis] = ACTIONS(2929),
    [anon_sym_in] = ACTIONS(2929),
    [anon_sym_BANGin] = ACTIONS(2929),
    [anon_sym_match] = ACTIONS(2929),
    [anon_sym_select] = ACTIONS(2929),
    [anon_sym_lock] = ACTIONS(2929),
    [anon_sym_rlock] = ACTIONS(2929),
    [anon_sym_unsafe] = ACTIONS(2929),
    [anon_sym_sql] = ACTIONS(2929),
    [sym_int_literal] = ACTIONS(2929),
    [sym_float_literal] = ACTIONS(2929),
    [sym_rune_literal] = ACTIONS(2929),
    [anon_sym_SQUOTE] = ACTIONS(2929),
    [anon_sym_DQUOTE] = ACTIONS(2929),
    [anon_sym_c_SQUOTE] = ACTIONS(2929),
    [anon_sym_c_DQUOTE] = ACTIONS(2929),
    [anon_sym_r_SQUOTE] = ACTIONS(2929),
    [anon_sym_r_DQUOTE] = ACTIONS(2929),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2929),
    [anon_sym_shared] = ACTIONS(2929),
    [anon_sym_map_LBRACK] = ACTIONS(2929),
    [anon_sym_chan] = ACTIONS(2929),
    [anon_sym_thread] = ACTIONS(2929),
    [anon_sym_atomic] = ACTIONS(2929),
  },
  [1543] = {
    [sym_line_comment] = STATE(1543),
    [sym_block_comment] = STATE(1543),
    [sym_identifier] = ACTIONS(3240),
    [anon_sym_LF] = ACTIONS(3240),
    [anon_sym_CR] = ACTIONS(3240),
    [anon_sym_CR_LF] = ACTIONS(3240),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(3240),
    [anon_sym_as] = ACTIONS(3240),
    [anon_sym_LBRACE] = ACTIONS(3240),
    [anon_sym_COMMA] = ACTIONS(3240),
    [anon_sym_RBRACE] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(3240),
    [anon_sym_RPAREN] = ACTIONS(3240),
    [anon_sym_fn] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3240),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [anon_sym_LT] = ACTIONS(3240),
    [anon_sym_GT] = ACTIONS(3240),
    [anon_sym_EQ_EQ] = ACTIONS(3240),
    [anon_sym_BANG_EQ] = ACTIONS(3240),
    [anon_sym_LT_EQ] = ACTIONS(3240),
    [anon_sym_GT_EQ] = ACTIONS(3240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_LBRACK] = ACTIONS(3238),
    [anon_sym_struct] = ACTIONS(3240),
    [anon_sym_mut] = ACTIONS(3240),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_QMARK] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_go] = ACTIONS(3240),
    [anon_sym_spawn] = ACTIONS(3240),
    [anon_sym_json_DOTdecode] = ACTIONS(3240),
    [anon_sym_PIPE] = ACTIONS(3240),
    [anon_sym_LBRACK2] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [anon_sym_CARET] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_LT_DASH] = ACTIONS(3240),
    [anon_sym_LT_LT] = ACTIONS(3240),
    [anon_sym_GT_GT] = ACTIONS(3240),
    [anon_sym_GT_GT_GT] = ACTIONS(3240),
    [anon_sym_AMP_CARET] = ACTIONS(3240),
    [anon_sym_AMP_AMP] = ACTIONS(3240),
    [anon_sym_PIPE_PIPE] = ACTIONS(3240),
    [anon_sym_or] = ACTIONS(3240),
    [sym_none] = ACTIONS(3240),
    [sym_true] = ACTIONS(3240),
    [sym_false] = ACTIONS(3240),
    [sym_nil] = ACTIONS(3240),
    [anon_sym_QMARK_DOT] = ACTIONS(3240),
    [anon_sym_POUND_LBRACK] = ACTIONS(3240),
    [anon_sym_if] = ACTIONS(3240),
    [anon_sym_DOLLARif] = ACTIONS(3240),
    [anon_sym_is] = ACTIONS(3240),
    [anon_sym_BANGis] = ACTIONS(3240),
    [anon_sym_in] = ACTIONS(3240),
    [anon_sym_BANGin] = ACTIONS(3240),
    [anon_sym_match] = ACTIONS(3240),
    [anon_sym_select] = ACTIONS(3240),
    [anon_sym_lock] = ACTIONS(3240),
    [anon_sym_rlock] = ACTIONS(3240),
    [anon_sym_unsafe] = ACTIONS(3240),
    [anon_sym_sql] = ACTIONS(3240),
    [sym_int_literal] = ACTIONS(3240),
    [sym_float_literal] = ACTIONS(3240),
    [sym_rune_literal] = ACTIONS(3240),
    [anon_sym_SQUOTE] = ACTIONS(3240),
    [anon_sym_DQUOTE] = ACTIONS(3240),
    [anon_sym_c_SQUOTE] = ACTIONS(3240),
    [anon_sym_c_DQUOTE] = ACTIONS(3240),
    [anon_sym_r_SQUOTE] = ACTIONS(3240),
    [anon_sym_r_DQUOTE] = ACTIONS(3240),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3240),
    [anon_sym_shared] = ACTIONS(3240),
    [anon_sym_map_LBRACK] = ACTIONS(3240),
    [anon_sym_chan] = ACTIONS(3240),
    [anon_sym_thread] = ACTIONS(3240),
    [anon_sym_atomic] = ACTIONS(3240),
  },
  [1544] = {
    [sym_line_comment] = STATE(1544),
    [sym_block_comment] = STATE(1544),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_LF] = ACTIONS(2841),
    [anon_sym_CR] = ACTIONS(2841),
    [anon_sym_CR_LF] = ACTIONS(2841),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym_DOT] = ACTIONS(2841),
    [anon_sym_as] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_RBRACE] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2841),
    [anon_sym_RPAREN] = ACTIONS(2841),
    [anon_sym_fn] = ACTIONS(2841),
    [anon_sym_PLUS] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(2841),
    [anon_sym_SLASH] = ACTIONS(2841),
    [anon_sym_PERCENT] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_GT] = ACTIONS(2841),
    [anon_sym_EQ_EQ] = ACTIONS(2841),
    [anon_sym_BANG_EQ] = ACTIONS(2841),
    [anon_sym_LT_EQ] = ACTIONS(2841),
    [anon_sym_GT_EQ] = ACTIONS(2841),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_struct] = ACTIONS(2841),
    [anon_sym_mut] = ACTIONS(2841),
    [anon_sym_PLUS_PLUS] = ACTIONS(2841),
    [anon_sym_DASH_DASH] = ACTIONS(2841),
    [anon_sym_QMARK] = ACTIONS(2841),
    [anon_sym_BANG] = ACTIONS(2841),
    [anon_sym_go] = ACTIONS(2841),
    [anon_sym_spawn] = ACTIONS(2841),
    [anon_sym_json_DOTdecode] = ACTIONS(2841),
    [anon_sym_PIPE] = ACTIONS(2841),
    [anon_sym_LBRACK2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2841),
    [anon_sym_LT_DASH] = ACTIONS(2841),
    [anon_sym_LT_LT] = ACTIONS(2841),
    [anon_sym_GT_GT] = ACTIONS(2841),
    [anon_sym_GT_GT_GT] = ACTIONS(2841),
    [anon_sym_AMP_CARET] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_PIPE_PIPE] = ACTIONS(2841),
    [anon_sym_or] = ACTIONS(2841),
    [sym_none] = ACTIONS(2841),
    [sym_true] = ACTIONS(2841),
    [sym_false] = ACTIONS(2841),
    [sym_nil] = ACTIONS(2841),
    [anon_sym_QMARK_DOT] = ACTIONS(2841),
    [anon_sym_POUND_LBRACK] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2841),
    [anon_sym_DOLLARif] = ACTIONS(2841),
    [anon_sym_is] = ACTIONS(2841),
    [anon_sym_BANGis] = ACTIONS(2841),
    [anon_sym_in] = ACTIONS(2841),
    [anon_sym_BANGin] = ACTIONS(2841),
    [anon_sym_match] = ACTIONS(2841),
    [anon_sym_select] = ACTIONS(2841),
    [anon_sym_lock] = ACTIONS(2841),
    [anon_sym_rlock] = ACTIONS(2841),
    [anon_sym_unsafe] = ACTIONS(2841),
    [anon_sym_sql] = ACTIONS(2841),
    [sym_int_literal] = ACTIONS(2841),
    [sym_float_literal] = ACTIONS(2841),
    [sym_rune_literal] = ACTIONS(2841),
    [anon_sym_SQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE] = ACTIONS(2841),
    [anon_sym_c_SQUOTE] = ACTIONS(2841),
    [anon_sym_c_DQUOTE] = ACTIONS(2841),
    [anon_sym_r_SQUOTE] = ACTIONS(2841),
    [anon_sym_r_DQUOTE] = ACTIONS(2841),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2841),
    [anon_sym_shared] = ACTIONS(2841),
    [anon_sym_map_LBRACK] = ACTIONS(2841),
    [anon_sym_chan] = ACTIONS(2841),
    [anon_sym_thread] = ACTIONS(2841),
    [anon_sym_atomic] = ACTIONS(2841),
  },
  [1545] = {
    [sym_line_comment] = STATE(1545),
    [sym_block_comment] = STATE(1545),
    [sym_identifier] = ACTIONS(3324),
    [anon_sym_LF] = ACTIONS(3324),
    [anon_sym_CR] = ACTIONS(3324),
    [anon_sym_CR_LF] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3324),
    [anon_sym_DOT] = ACTIONS(3324),
    [anon_sym_as] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3324),
    [anon_sym_COMMA] = ACTIONS(3324),
    [anon_sym_RBRACE] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3324),
    [anon_sym_RPAREN] = ACTIONS(3324),
    [anon_sym_fn] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3324),
    [anon_sym_DASH] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3324),
    [anon_sym_SLASH] = ACTIONS(3324),
    [anon_sym_PERCENT] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_GT] = ACTIONS(3324),
    [anon_sym_EQ_EQ] = ACTIONS(3324),
    [anon_sym_BANG_EQ] = ACTIONS(3324),
    [anon_sym_LT_EQ] = ACTIONS(3324),
    [anon_sym_GT_EQ] = ACTIONS(3324),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3324),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_struct] = ACTIONS(3324),
    [anon_sym_mut] = ACTIONS(3324),
    [anon_sym_PLUS_PLUS] = ACTIONS(3324),
    [anon_sym_DASH_DASH] = ACTIONS(3324),
    [anon_sym_QMARK] = ACTIONS(3324),
    [anon_sym_BANG] = ACTIONS(3324),
    [anon_sym_go] = ACTIONS(3324),
    [anon_sym_spawn] = ACTIONS(3324),
    [anon_sym_json_DOTdecode] = ACTIONS(3324),
    [anon_sym_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACK2] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3324),
    [anon_sym_LT_DASH] = ACTIONS(3324),
    [anon_sym_LT_LT] = ACTIONS(3324),
    [anon_sym_GT_GT] = ACTIONS(3324),
    [anon_sym_GT_GT_GT] = ACTIONS(3324),
    [anon_sym_AMP_CARET] = ACTIONS(3324),
    [anon_sym_AMP_AMP] = ACTIONS(3324),
    [anon_sym_PIPE_PIPE] = ACTIONS(3324),
    [anon_sym_or] = ACTIONS(3324),
    [sym_none] = ACTIONS(3324),
    [sym_true] = ACTIONS(3324),
    [sym_false] = ACTIONS(3324),
    [sym_nil] = ACTIONS(3324),
    [anon_sym_QMARK_DOT] = ACTIONS(3324),
    [anon_sym_POUND_LBRACK] = ACTIONS(3324),
    [anon_sym_if] = ACTIONS(3324),
    [anon_sym_DOLLARif] = ACTIONS(3324),
    [anon_sym_is] = ACTIONS(3324),
    [anon_sym_BANGis] = ACTIONS(3324),
    [anon_sym_in] = ACTIONS(3324),
    [anon_sym_BANGin] = ACTIONS(3324),
    [anon_sym_match] = ACTIONS(3324),
    [anon_sym_select] = ACTIONS(3324),
    [anon_sym_lock] = ACTIONS(3324),
    [anon_sym_rlock] = ACTIONS(3324),
    [anon_sym_unsafe] = ACTIONS(3324),
    [anon_sym_sql] = ACTIONS(3324),
    [sym_int_literal] = ACTIONS(3324),
    [sym_float_literal] = ACTIONS(3324),
    [sym_rune_literal] = ACTIONS(3324),
    [anon_sym_SQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE] = ACTIONS(3324),
    [anon_sym_c_SQUOTE] = ACTIONS(3324),
    [anon_sym_c_DQUOTE] = ACTIONS(3324),
    [anon_sym_r_SQUOTE] = ACTIONS(3324),
    [anon_sym_r_DQUOTE] = ACTIONS(3324),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3324),
    [anon_sym_shared] = ACTIONS(3324),
    [anon_sym_map_LBRACK] = ACTIONS(3324),
    [anon_sym_chan] = ACTIONS(3324),
    [anon_sym_thread] = ACTIONS(3324),
    [anon_sym_atomic] = ACTIONS(3324),
  },
  [1546] = {
    [sym_line_comment] = STATE(1546),
    [sym_block_comment] = STATE(1546),
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_LF] = ACTIONS(2669),
    [anon_sym_CR] = ACTIONS(2669),
    [anon_sym_CR_LF] = ACTIONS(2669),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2669),
    [anon_sym_DOT] = ACTIONS(2669),
    [anon_sym_as] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2669),
    [anon_sym_COMMA] = ACTIONS(2669),
    [anon_sym_RBRACE] = ACTIONS(2669),
    [anon_sym_LPAREN] = ACTIONS(2669),
    [anon_sym_RPAREN] = ACTIONS(2669),
    [anon_sym_fn] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2669),
    [anon_sym_SLASH] = ACTIONS(2669),
    [anon_sym_PERCENT] = ACTIONS(2669),
    [anon_sym_LT] = ACTIONS(2669),
    [anon_sym_GT] = ACTIONS(2669),
    [anon_sym_EQ_EQ] = ACTIONS(2669),
    [anon_sym_BANG_EQ] = ACTIONS(2669),
    [anon_sym_LT_EQ] = ACTIONS(2669),
    [anon_sym_GT_EQ] = ACTIONS(2669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2667),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_mut] = ACTIONS(2669),
    [anon_sym_PLUS_PLUS] = ACTIONS(2669),
    [anon_sym_DASH_DASH] = ACTIONS(2669),
    [anon_sym_QMARK] = ACTIONS(2669),
    [anon_sym_BANG] = ACTIONS(2669),
    [anon_sym_go] = ACTIONS(2669),
    [anon_sym_spawn] = ACTIONS(2669),
    [anon_sym_json_DOTdecode] = ACTIONS(2669),
    [anon_sym_PIPE] = ACTIONS(2669),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_TILDE] = ACTIONS(2669),
    [anon_sym_CARET] = ACTIONS(2669),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_LT_DASH] = ACTIONS(2669),
    [anon_sym_LT_LT] = ACTIONS(2669),
    [anon_sym_GT_GT] = ACTIONS(2669),
    [anon_sym_GT_GT_GT] = ACTIONS(2669),
    [anon_sym_AMP_CARET] = ACTIONS(2669),
    [anon_sym_AMP_AMP] = ACTIONS(2669),
    [anon_sym_PIPE_PIPE] = ACTIONS(2669),
    [anon_sym_or] = ACTIONS(2669),
    [sym_none] = ACTIONS(2669),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [sym_nil] = ACTIONS(2669),
    [anon_sym_QMARK_DOT] = ACTIONS(2669),
    [anon_sym_POUND_LBRACK] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_DOLLARif] = ACTIONS(2669),
    [anon_sym_is] = ACTIONS(2669),
    [anon_sym_BANGis] = ACTIONS(2669),
    [anon_sym_in] = ACTIONS(2669),
    [anon_sym_BANGin] = ACTIONS(2669),
    [anon_sym_match] = ACTIONS(2669),
    [anon_sym_select] = ACTIONS(2669),
    [anon_sym_lock] = ACTIONS(2669),
    [anon_sym_rlock] = ACTIONS(2669),
    [anon_sym_unsafe] = ACTIONS(2669),
    [anon_sym_sql] = ACTIONS(2669),
    [sym_int_literal] = ACTIONS(2669),
    [sym_float_literal] = ACTIONS(2669),
    [sym_rune_literal] = ACTIONS(2669),
    [anon_sym_SQUOTE] = ACTIONS(2669),
    [anon_sym_DQUOTE] = ACTIONS(2669),
    [anon_sym_c_SQUOTE] = ACTIONS(2669),
    [anon_sym_c_DQUOTE] = ACTIONS(2669),
    [anon_sym_r_SQUOTE] = ACTIONS(2669),
    [anon_sym_r_DQUOTE] = ACTIONS(2669),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2669),
    [anon_sym_shared] = ACTIONS(2669),
    [anon_sym_map_LBRACK] = ACTIONS(2669),
    [anon_sym_chan] = ACTIONS(2669),
    [anon_sym_thread] = ACTIONS(2669),
    [anon_sym_atomic] = ACTIONS(2669),
  },
  [1547] = {
    [sym_line_comment] = STATE(1547),
    [sym_block_comment] = STATE(1547),
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_LF] = ACTIONS(3356),
    [anon_sym_CR] = ACTIONS(3356),
    [anon_sym_CR_LF] = ACTIONS(3356),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3356),
    [anon_sym_DOT] = ACTIONS(3356),
    [anon_sym_as] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3356),
    [anon_sym_COMMA] = ACTIONS(3356),
    [anon_sym_RBRACE] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(3356),
    [anon_sym_fn] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_STAR] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_PERCENT] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_GT] = ACTIONS(3356),
    [anon_sym_EQ_EQ] = ACTIONS(3356),
    [anon_sym_BANG_EQ] = ACTIONS(3356),
    [anon_sym_LT_EQ] = ACTIONS(3356),
    [anon_sym_GT_EQ] = ACTIONS(3356),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3354),
    [anon_sym_struct] = ACTIONS(3356),
    [anon_sym_mut] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3356),
    [anon_sym_DASH_DASH] = ACTIONS(3356),
    [anon_sym_QMARK] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3356),
    [anon_sym_go] = ACTIONS(3356),
    [anon_sym_spawn] = ACTIONS(3356),
    [anon_sym_json_DOTdecode] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(3356),
    [anon_sym_LBRACK2] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3356),
    [anon_sym_CARET] = ACTIONS(3356),
    [anon_sym_AMP] = ACTIONS(3356),
    [anon_sym_LT_DASH] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(3356),
    [anon_sym_GT_GT] = ACTIONS(3356),
    [anon_sym_GT_GT_GT] = ACTIONS(3356),
    [anon_sym_AMP_CARET] = ACTIONS(3356),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_PIPE_PIPE] = ACTIONS(3356),
    [anon_sym_or] = ACTIONS(3356),
    [sym_none] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_nil] = ACTIONS(3356),
    [anon_sym_QMARK_DOT] = ACTIONS(3356),
    [anon_sym_POUND_LBRACK] = ACTIONS(3356),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_DOLLARif] = ACTIONS(3356),
    [anon_sym_is] = ACTIONS(3356),
    [anon_sym_BANGis] = ACTIONS(3356),
    [anon_sym_in] = ACTIONS(3356),
    [anon_sym_BANGin] = ACTIONS(3356),
    [anon_sym_match] = ACTIONS(3356),
    [anon_sym_select] = ACTIONS(3356),
    [anon_sym_lock] = ACTIONS(3356),
    [anon_sym_rlock] = ACTIONS(3356),
    [anon_sym_unsafe] = ACTIONS(3356),
    [anon_sym_sql] = ACTIONS(3356),
    [sym_int_literal] = ACTIONS(3356),
    [sym_float_literal] = ACTIONS(3356),
    [sym_rune_literal] = ACTIONS(3356),
    [anon_sym_SQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [anon_sym_c_SQUOTE] = ACTIONS(3356),
    [anon_sym_c_DQUOTE] = ACTIONS(3356),
    [anon_sym_r_SQUOTE] = ACTIONS(3356),
    [anon_sym_r_DQUOTE] = ACTIONS(3356),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3356),
    [anon_sym_shared] = ACTIONS(3356),
    [anon_sym_map_LBRACK] = ACTIONS(3356),
    [anon_sym_chan] = ACTIONS(3356),
    [anon_sym_thread] = ACTIONS(3356),
    [anon_sym_atomic] = ACTIONS(3356),
  },
  [1548] = {
    [sym_line_comment] = STATE(1548),
    [sym_block_comment] = STATE(1548),
    [sym_identifier] = ACTIONS(2697),
    [anon_sym_LF] = ACTIONS(2697),
    [anon_sym_CR] = ACTIONS(2697),
    [anon_sym_CR_LF] = ACTIONS(2697),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2697),
    [anon_sym_DOT] = ACTIONS(2697),
    [anon_sym_as] = ACTIONS(2697),
    [anon_sym_LBRACE] = ACTIONS(2697),
    [anon_sym_COMMA] = ACTIONS(2697),
    [anon_sym_RBRACE] = ACTIONS(2697),
    [anon_sym_LPAREN] = ACTIONS(2697),
    [anon_sym_RPAREN] = ACTIONS(2697),
    [anon_sym_fn] = ACTIONS(2697),
    [anon_sym_PLUS] = ACTIONS(2697),
    [anon_sym_DASH] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2697),
    [anon_sym_SLASH] = ACTIONS(2697),
    [anon_sym_PERCENT] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2697),
    [anon_sym_GT] = ACTIONS(2697),
    [anon_sym_EQ_EQ] = ACTIONS(2697),
    [anon_sym_BANG_EQ] = ACTIONS(2697),
    [anon_sym_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT_EQ] = ACTIONS(2697),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2697),
    [anon_sym_LBRACK] = ACTIONS(2695),
    [anon_sym_struct] = ACTIONS(2697),
    [anon_sym_mut] = ACTIONS(2697),
    [anon_sym_PLUS_PLUS] = ACTIONS(2697),
    [anon_sym_DASH_DASH] = ACTIONS(2697),
    [anon_sym_QMARK] = ACTIONS(2697),
    [anon_sym_BANG] = ACTIONS(4223),
    [anon_sym_go] = ACTIONS(2697),
    [anon_sym_spawn] = ACTIONS(2697),
    [anon_sym_json_DOTdecode] = ACTIONS(2697),
    [anon_sym_PIPE] = ACTIONS(2697),
    [anon_sym_LBRACK2] = ACTIONS(2697),
    [anon_sym_TILDE] = ACTIONS(2697),
    [anon_sym_CARET] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2697),
    [anon_sym_LT_DASH] = ACTIONS(2697),
    [anon_sym_LT_LT] = ACTIONS(2697),
    [anon_sym_GT_GT] = ACTIONS(2697),
    [anon_sym_GT_GT_GT] = ACTIONS(2697),
    [anon_sym_AMP_CARET] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_PIPE_PIPE] = ACTIONS(2697),
    [anon_sym_or] = ACTIONS(2697),
    [sym_none] = ACTIONS(2697),
    [sym_true] = ACTIONS(2697),
    [sym_false] = ACTIONS(2697),
    [sym_nil] = ACTIONS(2697),
    [anon_sym_QMARK_DOT] = ACTIONS(2697),
    [anon_sym_POUND_LBRACK] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(2697),
    [anon_sym_DOLLARif] = ACTIONS(2697),
    [anon_sym_is] = ACTIONS(2697),
    [anon_sym_BANGis] = ACTIONS(2697),
    [anon_sym_in] = ACTIONS(2697),
    [anon_sym_BANGin] = ACTIONS(2697),
    [anon_sym_match] = ACTIONS(2697),
    [anon_sym_select] = ACTIONS(2697),
    [anon_sym_lock] = ACTIONS(2697),
    [anon_sym_rlock] = ACTIONS(2697),
    [anon_sym_unsafe] = ACTIONS(2697),
    [anon_sym_sql] = ACTIONS(2697),
    [sym_int_literal] = ACTIONS(2697),
    [sym_float_literal] = ACTIONS(2697),
    [sym_rune_literal] = ACTIONS(2697),
    [anon_sym_SQUOTE] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [anon_sym_c_SQUOTE] = ACTIONS(2697),
    [anon_sym_c_DQUOTE] = ACTIONS(2697),
    [anon_sym_r_SQUOTE] = ACTIONS(2697),
    [anon_sym_r_DQUOTE] = ACTIONS(2697),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2697),
    [anon_sym_shared] = ACTIONS(2697),
    [anon_sym_map_LBRACK] = ACTIONS(2697),
    [anon_sym_chan] = ACTIONS(2697),
    [anon_sym_thread] = ACTIONS(2697),
    [anon_sym_atomic] = ACTIONS(2697),
  },
  [1549] = {
    [sym_line_comment] = STATE(1549),
    [sym_block_comment] = STATE(1549),
    [sym_identifier] = ACTIONS(3346),
    [anon_sym_LF] = ACTIONS(3346),
    [anon_sym_CR] = ACTIONS(3346),
    [anon_sym_CR_LF] = ACTIONS(3346),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_DOT] = ACTIONS(3346),
    [anon_sym_as] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_COMMA] = ACTIONS(3346),
    [anon_sym_RBRACE] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3346),
    [anon_sym_RPAREN] = ACTIONS(3346),
    [anon_sym_fn] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_SLASH] = ACTIONS(3346),
    [anon_sym_PERCENT] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_GT] = ACTIONS(3346),
    [anon_sym_EQ_EQ] = ACTIONS(3346),
    [anon_sym_BANG_EQ] = ACTIONS(3346),
    [anon_sym_LT_EQ] = ACTIONS(3346),
    [anon_sym_GT_EQ] = ACTIONS(3346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3346),
    [anon_sym_mut] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_QMARK] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_go] = ACTIONS(3346),
    [anon_sym_spawn] = ACTIONS(3346),
    [anon_sym_json_DOTdecode] = ACTIONS(3346),
    [anon_sym_PIPE] = ACTIONS(3346),
    [anon_sym_LBRACK2] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_CARET] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym_LT_DASH] = ACTIONS(3346),
    [anon_sym_LT_LT] = ACTIONS(3346),
    [anon_sym_GT_GT] = ACTIONS(3346),
    [anon_sym_GT_GT_GT] = ACTIONS(3346),
    [anon_sym_AMP_CARET] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_PIPE_PIPE] = ACTIONS(3346),
    [anon_sym_or] = ACTIONS(3346),
    [sym_none] = ACTIONS(3346),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [sym_nil] = ACTIONS(3346),
    [anon_sym_QMARK_DOT] = ACTIONS(3346),
    [anon_sym_POUND_LBRACK] = ACTIONS(3346),
    [anon_sym_if] = ACTIONS(3346),
    [anon_sym_DOLLARif] = ACTIONS(3346),
    [anon_sym_is] = ACTIONS(3346),
    [anon_sym_BANGis] = ACTIONS(3346),
    [anon_sym_in] = ACTIONS(3346),
    [anon_sym_BANGin] = ACTIONS(3346),
    [anon_sym_match] = ACTIONS(3346),
    [anon_sym_select] = ACTIONS(3346),
    [anon_sym_lock] = ACTIONS(3346),
    [anon_sym_rlock] = ACTIONS(3346),
    [anon_sym_unsafe] = ACTIONS(3346),
    [anon_sym_sql] = ACTIONS(3346),
    [sym_int_literal] = ACTIONS(3346),
    [sym_float_literal] = ACTIONS(3346),
    [sym_rune_literal] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [anon_sym_c_SQUOTE] = ACTIONS(3346),
    [anon_sym_c_DQUOTE] = ACTIONS(3346),
    [anon_sym_r_SQUOTE] = ACTIONS(3346),
    [anon_sym_r_DQUOTE] = ACTIONS(3346),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3346),
    [anon_sym_shared] = ACTIONS(3346),
    [anon_sym_map_LBRACK] = ACTIONS(3346),
    [anon_sym_chan] = ACTIONS(3346),
    [anon_sym_thread] = ACTIONS(3346),
    [anon_sym_atomic] = ACTIONS(3346),
  },
  [1550] = {
    [sym_line_comment] = STATE(1550),
    [sym_block_comment] = STATE(1550),
    [sym_identifier] = ACTIONS(2985),
    [anon_sym_LF] = ACTIONS(2985),
    [anon_sym_CR] = ACTIONS(2985),
    [anon_sym_CR_LF] = ACTIONS(2985),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2985),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_as] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2985),
    [anon_sym_RBRACE] = ACTIONS(2985),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [anon_sym_fn] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2985),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_PERCENT] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_EQ_EQ] = ACTIONS(2985),
    [anon_sym_BANG_EQ] = ACTIONS(2985),
    [anon_sym_LT_EQ] = ACTIONS(2985),
    [anon_sym_GT_EQ] = ACTIONS(2985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_mut] = ACTIONS(2985),
    [anon_sym_PLUS_PLUS] = ACTIONS(2985),
    [anon_sym_DASH_DASH] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_go] = ACTIONS(2985),
    [anon_sym_spawn] = ACTIONS(2985),
    [anon_sym_json_DOTdecode] = ACTIONS(2985),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(2985),
    [anon_sym_CARET] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_DASH] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2985),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_GT_GT_GT] = ACTIONS(2985),
    [anon_sym_AMP_CARET] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_or] = ACTIONS(2985),
    [sym_none] = ACTIONS(2985),
    [sym_true] = ACTIONS(2985),
    [sym_false] = ACTIONS(2985),
    [sym_nil] = ACTIONS(2985),
    [anon_sym_QMARK_DOT] = ACTIONS(2985),
    [anon_sym_POUND_LBRACK] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_DOLLARif] = ACTIONS(2985),
    [anon_sym_is] = ACTIONS(2985),
    [anon_sym_BANGis] = ACTIONS(2985),
    [anon_sym_in] = ACTIONS(2985),
    [anon_sym_BANGin] = ACTIONS(2985),
    [anon_sym_match] = ACTIONS(2985),
    [anon_sym_select] = ACTIONS(2985),
    [anon_sym_lock] = ACTIONS(2985),
    [anon_sym_rlock] = ACTIONS(2985),
    [anon_sym_unsafe] = ACTIONS(2985),
    [anon_sym_sql] = ACTIONS(2985),
    [sym_int_literal] = ACTIONS(2985),
    [sym_float_literal] = ACTIONS(2985),
    [sym_rune_literal] = ACTIONS(2985),
    [anon_sym_SQUOTE] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_c_SQUOTE] = ACTIONS(2985),
    [anon_sym_c_DQUOTE] = ACTIONS(2985),
    [anon_sym_r_SQUOTE] = ACTIONS(2985),
    [anon_sym_r_DQUOTE] = ACTIONS(2985),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2985),
    [anon_sym_shared] = ACTIONS(2985),
    [anon_sym_map_LBRACK] = ACTIONS(2985),
    [anon_sym_chan] = ACTIONS(2985),
    [anon_sym_thread] = ACTIONS(2985),
    [anon_sym_atomic] = ACTIONS(2985),
  },
  [1551] = {
    [sym_line_comment] = STATE(1551),
    [sym_block_comment] = STATE(1551),
    [sym_identifier] = ACTIONS(2445),
    [anon_sym_LF] = ACTIONS(2445),
    [anon_sym_CR] = ACTIONS(2445),
    [anon_sym_CR_LF] = ACTIONS(2445),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2445),
    [anon_sym_DOT] = ACTIONS(2445),
    [anon_sym_as] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(2445),
    [anon_sym_COMMA] = ACTIONS(2445),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym_RPAREN] = ACTIONS(2445),
    [anon_sym_fn] = ACTIONS(2445),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2445),
    [anon_sym_STAR] = ACTIONS(2445),
    [anon_sym_SLASH] = ACTIONS(2445),
    [anon_sym_PERCENT] = ACTIONS(2445),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_GT] = ACTIONS(2445),
    [anon_sym_EQ_EQ] = ACTIONS(2445),
    [anon_sym_BANG_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2445),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_struct] = ACTIONS(2445),
    [anon_sym_mut] = ACTIONS(2445),
    [anon_sym_PLUS_PLUS] = ACTIONS(2445),
    [anon_sym_DASH_DASH] = ACTIONS(2445),
    [anon_sym_QMARK] = ACTIONS(2445),
    [anon_sym_BANG] = ACTIONS(2445),
    [anon_sym_go] = ACTIONS(2445),
    [anon_sym_spawn] = ACTIONS(2445),
    [anon_sym_json_DOTdecode] = ACTIONS(2445),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_LBRACK2] = ACTIONS(2445),
    [anon_sym_TILDE] = ACTIONS(2445),
    [anon_sym_CARET] = ACTIONS(2445),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_LT_DASH] = ACTIONS(2445),
    [anon_sym_LT_LT] = ACTIONS(2445),
    [anon_sym_GT_GT] = ACTIONS(2445),
    [anon_sym_GT_GT_GT] = ACTIONS(2445),
    [anon_sym_AMP_CARET] = ACTIONS(2445),
    [anon_sym_AMP_AMP] = ACTIONS(2445),
    [anon_sym_PIPE_PIPE] = ACTIONS(2445),
    [anon_sym_or] = ACTIONS(2445),
    [sym_none] = ACTIONS(2445),
    [sym_true] = ACTIONS(2445),
    [sym_false] = ACTIONS(2445),
    [sym_nil] = ACTIONS(2445),
    [anon_sym_QMARK_DOT] = ACTIONS(2445),
    [anon_sym_POUND_LBRACK] = ACTIONS(2445),
    [anon_sym_if] = ACTIONS(2445),
    [anon_sym_DOLLARif] = ACTIONS(2445),
    [anon_sym_is] = ACTIONS(2445),
    [anon_sym_BANGis] = ACTIONS(2445),
    [anon_sym_in] = ACTIONS(2445),
    [anon_sym_BANGin] = ACTIONS(2445),
    [anon_sym_match] = ACTIONS(2445),
    [anon_sym_select] = ACTIONS(2445),
    [anon_sym_lock] = ACTIONS(2445),
    [anon_sym_rlock] = ACTIONS(2445),
    [anon_sym_unsafe] = ACTIONS(2445),
    [anon_sym_sql] = ACTIONS(2445),
    [sym_int_literal] = ACTIONS(2445),
    [sym_float_literal] = ACTIONS(2445),
    [sym_rune_literal] = ACTIONS(2445),
    [anon_sym_SQUOTE] = ACTIONS(2445),
    [anon_sym_DQUOTE] = ACTIONS(2445),
    [anon_sym_c_SQUOTE] = ACTIONS(2445),
    [anon_sym_c_DQUOTE] = ACTIONS(2445),
    [anon_sym_r_SQUOTE] = ACTIONS(2445),
    [anon_sym_r_DQUOTE] = ACTIONS(2445),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2445),
    [anon_sym_shared] = ACTIONS(2445),
    [anon_sym_map_LBRACK] = ACTIONS(2445),
    [anon_sym_chan] = ACTIONS(2445),
    [anon_sym_thread] = ACTIONS(2445),
    [anon_sym_atomic] = ACTIONS(2445),
  },
  [1552] = {
    [sym_line_comment] = STATE(1552),
    [sym_block_comment] = STATE(1552),
    [sym_type_parameters] = STATE(4409),
    [sym_argument_list] = STATE(1682),
    [sym_or_block] = STATE(1683),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2051),
    [anon_sym_RBRACE] = ACTIONS(2051),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_DASH] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_SLASH] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2051),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2051),
    [anon_sym_GT_EQ] = ACTIONS(2051),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_RBRACK] = ACTIONS(2051),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_COLON] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(2051),
    [anon_sym_DASH_DASH] = ACTIONS(2051),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4233),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2051),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_LBRACK2] = ACTIONS(4235),
    [anon_sym_TILDE] = ACTIONS(2051),
    [anon_sym_CARET] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_LT_DASH] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_GT_GT_GT] = ACTIONS(2051),
    [anon_sym_AMP_CARET] = ACTIONS(2051),
    [anon_sym_AMP_AMP] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(4237),
    [anon_sym_POUND_LBRACK] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2051),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2051),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2051),
    [sym_rune_literal] = ACTIONS(2051),
    [anon_sym_SQUOTE] = ACTIONS(2051),
    [anon_sym_DQUOTE] = ACTIONS(2051),
    [anon_sym_c_SQUOTE] = ACTIONS(2051),
    [anon_sym_c_DQUOTE] = ACTIONS(2051),
    [anon_sym_r_SQUOTE] = ACTIONS(2051),
    [anon_sym_r_DQUOTE] = ACTIONS(2051),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2051),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
  },
  [1553] = {
    [sym_line_comment] = STATE(1553),
    [sym_block_comment] = STATE(1553),
    [sym_type_parameters] = STATE(4409),
    [sym_argument_list] = STATE(1682),
    [sym_or_block] = STATE(1683),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_RBRACE] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_fn] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_PERCENT] = ACTIONS(2055),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_GT] = ACTIONS(2057),
    [anon_sym_EQ_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2055),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_RBRACK] = ACTIONS(2055),
    [anon_sym_struct] = ACTIONS(2057),
    [anon_sym_mut] = ACTIONS(2057),
    [anon_sym_COLON] = ACTIONS(2055),
    [anon_sym_PLUS_PLUS] = ACTIONS(2055),
    [anon_sym_DASH_DASH] = ACTIONS(2055),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4233),
    [anon_sym_go] = ACTIONS(2057),
    [anon_sym_spawn] = ACTIONS(2057),
    [anon_sym_json_DOTdecode] = ACTIONS(2055),
    [anon_sym_PIPE] = ACTIONS(2057),
    [anon_sym_LBRACK2] = ACTIONS(4235),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_CARET] = ACTIONS(2055),
    [anon_sym_AMP] = ACTIONS(2057),
    [anon_sym_LT_DASH] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2057),
    [anon_sym_GT_GT_GT] = ACTIONS(2055),
    [anon_sym_AMP_CARET] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2055),
    [anon_sym_PIPE_PIPE] = ACTIONS(2055),
    [anon_sym_or] = ACTIONS(2057),
    [sym_none] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_nil] = ACTIONS(2057),
    [anon_sym_QMARK_DOT] = ACTIONS(4237),
    [anon_sym_POUND_LBRACK] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_DOLLARif] = ACTIONS(2057),
    [anon_sym_is] = ACTIONS(2057),
    [anon_sym_BANGis] = ACTIONS(2055),
    [anon_sym_in] = ACTIONS(2057),
    [anon_sym_BANGin] = ACTIONS(2055),
    [anon_sym_match] = ACTIONS(2057),
    [anon_sym_select] = ACTIONS(2057),
    [anon_sym_lock] = ACTIONS(2057),
    [anon_sym_rlock] = ACTIONS(2057),
    [anon_sym_unsafe] = ACTIONS(2057),
    [anon_sym_sql] = ACTIONS(2057),
    [sym_int_literal] = ACTIONS(2057),
    [sym_float_literal] = ACTIONS(2055),
    [sym_rune_literal] = ACTIONS(2055),
    [anon_sym_SQUOTE] = ACTIONS(2055),
    [anon_sym_DQUOTE] = ACTIONS(2055),
    [anon_sym_c_SQUOTE] = ACTIONS(2055),
    [anon_sym_c_DQUOTE] = ACTIONS(2055),
    [anon_sym_r_SQUOTE] = ACTIONS(2055),
    [anon_sym_r_DQUOTE] = ACTIONS(2055),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2057),
    [anon_sym_shared] = ACTIONS(2057),
    [anon_sym_map_LBRACK] = ACTIONS(2055),
    [anon_sym_chan] = ACTIONS(2057),
    [anon_sym_thread] = ACTIONS(2057),
    [anon_sym_atomic] = ACTIONS(2057),
  },
  [1554] = {
    [sym_line_comment] = STATE(1554),
    [sym_block_comment] = STATE(1554),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2458),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(861),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_as] = ACTIONS(865),
    [anon_sym_COMMA] = ACTIONS(861),
    [anon_sym_LPAREN] = ACTIONS(3968),
    [anon_sym_EQ] = ACTIONS(865),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_STAR] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_PERCENT] = ACTIONS(865),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(861),
    [anon_sym_BANG_EQ] = ACTIONS(861),
    [anon_sym_LT_EQ] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_PLUS_PLUS] = ACTIONS(861),
    [anon_sym_DASH_DASH] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(4241),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_LBRACK2] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(865),
    [anon_sym_GT_GT] = ACTIONS(865),
    [anon_sym_GT_GT_GT] = ACTIONS(865),
    [anon_sym_AMP_CARET] = ACTIONS(865),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_QMARK_DOT] = ACTIONS(861),
    [anon_sym_POUND_LBRACK] = ACTIONS(861),
    [anon_sym_is] = ACTIONS(865),
    [anon_sym_BANGis] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(865),
    [anon_sym_BANGin] = ACTIONS(861),
    [anon_sym_STAR_EQ] = ACTIONS(861),
    [anon_sym_SLASH_EQ] = ACTIONS(861),
    [anon_sym_PERCENT_EQ] = ACTIONS(861),
    [anon_sym_LT_LT_EQ] = ACTIONS(861),
    [anon_sym_GT_GT_EQ] = ACTIONS(861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(861),
    [anon_sym_AMP_EQ] = ACTIONS(861),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(861),
    [anon_sym_PLUS_EQ] = ACTIONS(861),
    [anon_sym_DASH_EQ] = ACTIONS(861),
    [anon_sym_PIPE_EQ] = ACTIONS(861),
    [anon_sym_CARET_EQ] = ACTIONS(861),
    [anon_sym_COLON_EQ] = ACTIONS(861),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [1555] = {
    [sym_line_comment] = STATE(1555),
    [sym_block_comment] = STATE(1555),
    [sym_type_parameters] = STATE(4409),
    [sym_argument_list] = STATE(1682),
    [sym_or_block] = STATE(1683),
    [sym_identifier] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_LBRACE] = ACTIONS(2059),
    [anon_sym_COMMA] = ACTIONS(2059),
    [anon_sym_RBRACE] = ACTIONS(2059),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_fn] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2059),
    [anon_sym_SLASH] = ACTIONS(2061),
    [anon_sym_PERCENT] = ACTIONS(2059),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2059),
    [anon_sym_BANG_EQ] = ACTIONS(2059),
    [anon_sym_LT_EQ] = ACTIONS(2059),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_RBRACK] = ACTIONS(2059),
    [anon_sym_struct] = ACTIONS(2061),
    [anon_sym_mut] = ACTIONS(2061),
    [anon_sym_COLON] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4233),
    [anon_sym_go] = ACTIONS(2061),
    [anon_sym_spawn] = ACTIONS(2061),
    [anon_sym_json_DOTdecode] = ACTIONS(2059),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_LBRACK2] = ACTIONS(4235),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_LT_DASH] = ACTIONS(2059),
    [anon_sym_LT_LT] = ACTIONS(2059),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_GT_GT_GT] = ACTIONS(2059),
    [anon_sym_AMP_CARET] = ACTIONS(2059),
    [anon_sym_AMP_AMP] = ACTIONS(2059),
    [anon_sym_PIPE_PIPE] = ACTIONS(2059),
    [anon_sym_or] = ACTIONS(2061),
    [sym_none] = ACTIONS(2061),
    [sym_true] = ACTIONS(2061),
    [sym_false] = ACTIONS(2061),
    [sym_nil] = ACTIONS(2061),
    [anon_sym_QMARK_DOT] = ACTIONS(4237),
    [anon_sym_POUND_LBRACK] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_DOLLARif] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_BANGis] = ACTIONS(2059),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_BANGin] = ACTIONS(2059),
    [anon_sym_match] = ACTIONS(2061),
    [anon_sym_select] = ACTIONS(2061),
    [anon_sym_lock] = ACTIONS(2061),
    [anon_sym_rlock] = ACTIONS(2061),
    [anon_sym_unsafe] = ACTIONS(2061),
    [anon_sym_sql] = ACTIONS(2061),
    [sym_int_literal] = ACTIONS(2061),
    [sym_float_literal] = ACTIONS(2059),
    [sym_rune_literal] = ACTIONS(2059),
    [anon_sym_SQUOTE] = ACTIONS(2059),
    [anon_sym_DQUOTE] = ACTIONS(2059),
    [anon_sym_c_SQUOTE] = ACTIONS(2059),
    [anon_sym_c_DQUOTE] = ACTIONS(2059),
    [anon_sym_r_SQUOTE] = ACTIONS(2059),
    [anon_sym_r_DQUOTE] = ACTIONS(2059),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2061),
    [anon_sym_shared] = ACTIONS(2061),
    [anon_sym_map_LBRACK] = ACTIONS(2059),
    [anon_sym_chan] = ACTIONS(2061),
    [anon_sym_thread] = ACTIONS(2061),
    [anon_sym_atomic] = ACTIONS(2061),
  },
  [1556] = {
    [sym_line_comment] = STATE(1556),
    [sym_block_comment] = STATE(1556),
    [sym_type_parameters] = STATE(4409),
    [sym_argument_list] = STATE(1682),
    [sym_or_block] = STATE(1683),
    [sym_format_specifier] = STATE(4682),
    [sym_identifier] = ACTIONS(4243),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(4245),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_fn] = ACTIONS(4243),
    [anon_sym_PLUS] = ACTIONS(4249),
    [anon_sym_DASH] = ACTIONS(4249),
    [anon_sym_STAR] = ACTIONS(4251),
    [anon_sym_SLASH] = ACTIONS(4253),
    [anon_sym_PERCENT] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(4255),
    [anon_sym_GT] = ACTIONS(4255),
    [anon_sym_EQ_EQ] = ACTIONS(4257),
    [anon_sym_BANG_EQ] = ACTIONS(4257),
    [anon_sym_LT_EQ] = ACTIONS(4257),
    [anon_sym_GT_EQ] = ACTIONS(4257),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_struct] = ACTIONS(4243),
    [anon_sym_mut] = ACTIONS(4243),
    [anon_sym_COLON] = ACTIONS(4259),
    [anon_sym_PLUS_PLUS] = ACTIONS(4261),
    [anon_sym_DASH_DASH] = ACTIONS(4263),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4233),
    [anon_sym_go] = ACTIONS(4243),
    [anon_sym_spawn] = ACTIONS(4243),
    [anon_sym_json_DOTdecode] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(4249),
    [anon_sym_LBRACK2] = ACTIONS(4235),
    [anon_sym_TILDE] = ACTIONS(4247),
    [anon_sym_CARET] = ACTIONS(4265),
    [anon_sym_AMP] = ACTIONS(4253),
    [anon_sym_LT_DASH] = ACTIONS(4247),
    [anon_sym_LT_LT] = ACTIONS(4251),
    [anon_sym_GT_GT] = ACTIONS(4253),
    [anon_sym_GT_GT_GT] = ACTIONS(4251),
    [anon_sym_AMP_CARET] = ACTIONS(4251),
    [anon_sym_AMP_AMP] = ACTIONS(4267),
    [anon_sym_PIPE_PIPE] = ACTIONS(4269),
    [anon_sym_or] = ACTIONS(4271),
    [sym_none] = ACTIONS(4243),
    [sym_true] = ACTIONS(4243),
    [sym_false] = ACTIONS(4243),
    [sym_nil] = ACTIONS(4243),
    [anon_sym_QMARK_DOT] = ACTIONS(4237),
    [anon_sym_POUND_LBRACK] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(4243),
    [anon_sym_DOLLARif] = ACTIONS(4243),
    [anon_sym_is] = ACTIONS(4273),
    [anon_sym_BANGis] = ACTIONS(4275),
    [anon_sym_in] = ACTIONS(4277),
    [anon_sym_BANGin] = ACTIONS(4279),
    [anon_sym_match] = ACTIONS(4243),
    [anon_sym_select] = ACTIONS(4243),
    [anon_sym_lock] = ACTIONS(4243),
    [anon_sym_rlock] = ACTIONS(4243),
    [anon_sym_unsafe] = ACTIONS(4243),
    [anon_sym_sql] = ACTIONS(4243),
    [sym_int_literal] = ACTIONS(4243),
    [sym_float_literal] = ACTIONS(4247),
    [sym_rune_literal] = ACTIONS(4247),
    [anon_sym_SQUOTE] = ACTIONS(4247),
    [anon_sym_DQUOTE] = ACTIONS(4247),
    [anon_sym_c_SQUOTE] = ACTIONS(4247),
    [anon_sym_c_DQUOTE] = ACTIONS(4247),
    [anon_sym_r_SQUOTE] = ACTIONS(4247),
    [anon_sym_r_DQUOTE] = ACTIONS(4247),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4243),
    [anon_sym_shared] = ACTIONS(4243),
    [anon_sym_map_LBRACK] = ACTIONS(4247),
    [anon_sym_chan] = ACTIONS(4243),
    [anon_sym_thread] = ACTIONS(4243),
    [anon_sym_atomic] = ACTIONS(4243),
  },
  [1557] = {
    [sym_line_comment] = STATE(1557),
    [sym_block_comment] = STATE(1557),
    [sym_else_branch] = STATE(1624),
    [sym_identifier] = ACTIONS(2083),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2083),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(2081),
    [anon_sym_COMMA] = ACTIONS(2081),
    [anon_sym_RBRACE] = ACTIONS(2081),
    [anon_sym_LPAREN] = ACTIONS(2081),
    [anon_sym_fn] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2081),
    [anon_sym_SLASH] = ACTIONS(2083),
    [anon_sym_PERCENT] = ACTIONS(2081),
    [anon_sym_LT] = ACTIONS(2083),
    [anon_sym_GT] = ACTIONS(2083),
    [anon_sym_EQ_EQ] = ACTIONS(2081),
    [anon_sym_BANG_EQ] = ACTIONS(2081),
    [anon_sym_LT_EQ] = ACTIONS(2081),
    [anon_sym_GT_EQ] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(2081),
    [anon_sym_RBRACK] = ACTIONS(2081),
    [anon_sym_struct] = ACTIONS(2083),
    [anon_sym_mut] = ACTIONS(2083),
    [anon_sym_COLON] = ACTIONS(2081),
    [anon_sym_PLUS_PLUS] = ACTIONS(2081),
    [anon_sym_DASH_DASH] = ACTIONS(2081),
    [anon_sym_QMARK] = ACTIONS(2083),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_go] = ACTIONS(2083),
    [anon_sym_spawn] = ACTIONS(2083),
    [anon_sym_json_DOTdecode] = ACTIONS(2081),
    [anon_sym_PIPE] = ACTIONS(2083),
    [anon_sym_LBRACK2] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2081),
    [anon_sym_CARET] = ACTIONS(2081),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_LT_DASH] = ACTIONS(2081),
    [anon_sym_LT_LT] = ACTIONS(2081),
    [anon_sym_GT_GT] = ACTIONS(2083),
    [anon_sym_GT_GT_GT] = ACTIONS(2081),
    [anon_sym_AMP_CARET] = ACTIONS(2081),
    [anon_sym_AMP_AMP] = ACTIONS(2081),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_or] = ACTIONS(2083),
    [sym_none] = ACTIONS(2083),
    [sym_true] = ACTIONS(2083),
    [sym_false] = ACTIONS(2083),
    [sym_nil] = ACTIONS(2083),
    [anon_sym_QMARK_DOT] = ACTIONS(2081),
    [anon_sym_POUND_LBRACK] = ACTIONS(2081),
    [anon_sym_if] = ACTIONS(2083),
    [anon_sym_else] = ACTIONS(4281),
    [anon_sym_DOLLARif] = ACTIONS(2083),
    [anon_sym_is] = ACTIONS(2083),
    [anon_sym_BANGis] = ACTIONS(2081),
    [anon_sym_in] = ACTIONS(2083),
    [anon_sym_BANGin] = ACTIONS(2081),
    [anon_sym_match] = ACTIONS(2083),
    [anon_sym_select] = ACTIONS(2083),
    [anon_sym_lock] = ACTIONS(2083),
    [anon_sym_rlock] = ACTIONS(2083),
    [anon_sym_unsafe] = ACTIONS(2083),
    [anon_sym_sql] = ACTIONS(2083),
    [sym_int_literal] = ACTIONS(2083),
    [sym_float_literal] = ACTIONS(2081),
    [sym_rune_literal] = ACTIONS(2081),
    [anon_sym_SQUOTE] = ACTIONS(2081),
    [anon_sym_DQUOTE] = ACTIONS(2081),
    [anon_sym_c_SQUOTE] = ACTIONS(2081),
    [anon_sym_c_DQUOTE] = ACTIONS(2081),
    [anon_sym_r_SQUOTE] = ACTIONS(2081),
    [anon_sym_r_DQUOTE] = ACTIONS(2081),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2083),
    [anon_sym_shared] = ACTIONS(2083),
    [anon_sym_map_LBRACK] = ACTIONS(2081),
    [anon_sym_chan] = ACTIONS(2083),
    [anon_sym_thread] = ACTIONS(2083),
    [anon_sym_atomic] = ACTIONS(2083),
  },
  [1558] = {
    [sym_line_comment] = STATE(1558),
    [sym_block_comment] = STATE(1558),
    [sym_type_parameters] = STATE(4409),
    [sym_argument_list] = STATE(1682),
    [sym_or_block] = STATE(1683),
    [sym_format_specifier] = STATE(4590),
    [sym_identifier] = ACTIONS(4243),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(4245),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_fn] = ACTIONS(4243),
    [anon_sym_PLUS] = ACTIONS(4249),
    [anon_sym_DASH] = ACTIONS(4249),
    [anon_sym_STAR] = ACTIONS(4251),
    [anon_sym_SLASH] = ACTIONS(4253),
    [anon_sym_PERCENT] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(4255),
    [anon_sym_GT] = ACTIONS(4255),
    [anon_sym_EQ_EQ] = ACTIONS(4257),
    [anon_sym_BANG_EQ] = ACTIONS(4257),
    [anon_sym_LT_EQ] = ACTIONS(4257),
    [anon_sym_GT_EQ] = ACTIONS(4257),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_struct] = ACTIONS(4243),
    [anon_sym_mut] = ACTIONS(4243),
    [anon_sym_COLON] = ACTIONS(4259),
    [anon_sym_PLUS_PLUS] = ACTIONS(4261),
    [anon_sym_DASH_DASH] = ACTIONS(4263),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4233),
    [anon_sym_go] = ACTIONS(4243),
    [anon_sym_spawn] = ACTIONS(4243),
    [anon_sym_json_DOTdecode] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(4249),
    [anon_sym_LBRACK2] = ACTIONS(4235),
    [anon_sym_TILDE] = ACTIONS(4247),
    [anon_sym_CARET] = ACTIONS(4265),
    [anon_sym_AMP] = ACTIONS(4253),
    [anon_sym_LT_DASH] = ACTIONS(4247),
    [anon_sym_LT_LT] = ACTIONS(4251),
    [anon_sym_GT_GT] = ACTIONS(4253),
    [anon_sym_GT_GT_GT] = ACTIONS(4251),
    [anon_sym_AMP_CARET] = ACTIONS(4251),
    [anon_sym_AMP_AMP] = ACTIONS(4267),
    [anon_sym_PIPE_PIPE] = ACTIONS(4269),
    [anon_sym_or] = ACTIONS(4271),
    [sym_none] = ACTIONS(4243),
    [sym_true] = ACTIONS(4243),
    [sym_false] = ACTIONS(4243),
    [sym_nil] = ACTIONS(4243),
    [anon_sym_QMARK_DOT] = ACTIONS(4237),
    [anon_sym_POUND_LBRACK] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(4243),
    [anon_sym_DOLLARif] = ACTIONS(4243),
    [anon_sym_is] = ACTIONS(4273),
    [anon_sym_BANGis] = ACTIONS(4275),
    [anon_sym_in] = ACTIONS(4277),
    [anon_sym_BANGin] = ACTIONS(4279),
    [anon_sym_match] = ACTIONS(4243),
    [anon_sym_select] = ACTIONS(4243),
    [anon_sym_lock] = ACTIONS(4243),
    [anon_sym_rlock] = ACTIONS(4243),
    [anon_sym_unsafe] = ACTIONS(4243),
    [anon_sym_sql] = ACTIONS(4243),
    [sym_int_literal] = ACTIONS(4243),
    [sym_float_literal] = ACTIONS(4247),
    [sym_rune_literal] = ACTIONS(4247),
    [anon_sym_SQUOTE] = ACTIONS(4247),
    [anon_sym_DQUOTE] = ACTIONS(4247),
    [anon_sym_c_SQUOTE] = ACTIONS(4247),
    [anon_sym_c_DQUOTE] = ACTIONS(4247),
    [anon_sym_r_SQUOTE] = ACTIONS(4247),
    [anon_sym_r_DQUOTE] = ACTIONS(4247),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4243),
    [anon_sym_shared] = ACTIONS(4243),
    [anon_sym_map_LBRACK] = ACTIONS(4247),
    [anon_sym_chan] = ACTIONS(4243),
    [anon_sym_thread] = ACTIONS(4243),
    [anon_sym_atomic] = ACTIONS(4243),
  },
  [1559] = {
    [sym_line_comment] = STATE(1559),
    [sym_block_comment] = STATE(1559),
    [sym_else_branch] = STATE(1627),
    [sym_identifier] = ACTIONS(2089),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2089),
    [anon_sym_as] = ACTIONS(2089),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_COMMA] = ACTIONS(2087),
    [anon_sym_RBRACE] = ACTIONS(2087),
    [anon_sym_LPAREN] = ACTIONS(2087),
    [anon_sym_fn] = ACTIONS(2089),
    [anon_sym_PLUS] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2087),
    [anon_sym_SLASH] = ACTIONS(2089),
    [anon_sym_PERCENT] = ACTIONS(2087),
    [anon_sym_LT] = ACTIONS(2089),
    [anon_sym_GT] = ACTIONS(2089),
    [anon_sym_EQ_EQ] = ACTIONS(2087),
    [anon_sym_BANG_EQ] = ACTIONS(2087),
    [anon_sym_LT_EQ] = ACTIONS(2087),
    [anon_sym_GT_EQ] = ACTIONS(2087),
    [anon_sym_LBRACK] = ACTIONS(2087),
    [anon_sym_RBRACK] = ACTIONS(2087),
    [anon_sym_struct] = ACTIONS(2089),
    [anon_sym_mut] = ACTIONS(2089),
    [anon_sym_COLON] = ACTIONS(2087),
    [anon_sym_PLUS_PLUS] = ACTIONS(2087),
    [anon_sym_DASH_DASH] = ACTIONS(2087),
    [anon_sym_QMARK] = ACTIONS(2089),
    [anon_sym_BANG] = ACTIONS(2089),
    [anon_sym_go] = ACTIONS(2089),
    [anon_sym_spawn] = ACTIONS(2089),
    [anon_sym_json_DOTdecode] = ACTIONS(2087),
    [anon_sym_PIPE] = ACTIONS(2089),
    [anon_sym_LBRACK2] = ACTIONS(2089),
    [anon_sym_TILDE] = ACTIONS(2087),
    [anon_sym_CARET] = ACTIONS(2087),
    [anon_sym_AMP] = ACTIONS(2089),
    [anon_sym_LT_DASH] = ACTIONS(2087),
    [anon_sym_LT_LT] = ACTIONS(2087),
    [anon_sym_GT_GT] = ACTIONS(2089),
    [anon_sym_GT_GT_GT] = ACTIONS(2087),
    [anon_sym_AMP_CARET] = ACTIONS(2087),
    [anon_sym_AMP_AMP] = ACTIONS(2087),
    [anon_sym_PIPE_PIPE] = ACTIONS(2087),
    [anon_sym_or] = ACTIONS(2089),
    [sym_none] = ACTIONS(2089),
    [sym_true] = ACTIONS(2089),
    [sym_false] = ACTIONS(2089),
    [sym_nil] = ACTIONS(2089),
    [anon_sym_QMARK_DOT] = ACTIONS(2087),
    [anon_sym_POUND_LBRACK] = ACTIONS(2087),
    [anon_sym_if] = ACTIONS(2089),
    [anon_sym_else] = ACTIONS(4281),
    [anon_sym_DOLLARif] = ACTIONS(2089),
    [anon_sym_is] = ACTIONS(2089),
    [anon_sym_BANGis] = ACTIONS(2087),
    [anon_sym_in] = ACTIONS(2089),
    [anon_sym_BANGin] = ACTIONS(2087),
    [anon_sym_match] = ACTIONS(2089),
    [anon_sym_select] = ACTIONS(2089),
    [anon_sym_lock] = ACTIONS(2089),
    [anon_sym_rlock] = ACTIONS(2089),
    [anon_sym_unsafe] = ACTIONS(2089),
    [anon_sym_sql] = ACTIONS(2089),
    [sym_int_literal] = ACTIONS(2089),
    [sym_float_literal] = ACTIONS(2087),
    [sym_rune_literal] = ACTIONS(2087),
    [anon_sym_SQUOTE] = ACTIONS(2087),
    [anon_sym_DQUOTE] = ACTIONS(2087),
    [anon_sym_c_SQUOTE] = ACTIONS(2087),
    [anon_sym_c_DQUOTE] = ACTIONS(2087),
    [anon_sym_r_SQUOTE] = ACTIONS(2087),
    [anon_sym_r_DQUOTE] = ACTIONS(2087),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2089),
    [anon_sym_shared] = ACTIONS(2089),
    [anon_sym_map_LBRACK] = ACTIONS(2087),
    [anon_sym_chan] = ACTIONS(2089),
    [anon_sym_thread] = ACTIONS(2089),
    [anon_sym_atomic] = ACTIONS(2089),
  },
  [1560] = {
    [sym_line_comment] = STATE(1560),
    [sym_block_comment] = STATE(1560),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2169),
    [anon_sym_as] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2167),
    [anon_sym_COMMA] = ACTIONS(2167),
    [anon_sym_RBRACE] = ACTIONS(2167),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_fn] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2167),
    [anon_sym_SLASH] = ACTIONS(2169),
    [anon_sym_PERCENT] = ACTIONS(2167),
    [anon_sym_LT] = ACTIONS(2169),
    [anon_sym_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2167),
    [anon_sym_BANG_EQ] = ACTIONS(2167),
    [anon_sym_LT_EQ] = ACTIONS(2167),
    [anon_sym_GT_EQ] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_RBRACK] = ACTIONS(2167),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_mut] = ACTIONS(2169),
    [anon_sym_COLON] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_QMARK] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_go] = ACTIONS(2169),
    [anon_sym_spawn] = ACTIONS(2169),
    [anon_sym_json_DOTdecode] = ACTIONS(2167),
    [anon_sym_PIPE] = ACTIONS(2169),
    [anon_sym_LBRACK2] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT_DASH] = ACTIONS(2167),
    [anon_sym_LT_LT] = ACTIONS(2167),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_GT_GT_GT] = ACTIONS(2167),
    [anon_sym_AMP_CARET] = ACTIONS(2167),
    [anon_sym_AMP_AMP] = ACTIONS(2167),
    [anon_sym_PIPE_PIPE] = ACTIONS(2167),
    [anon_sym_or] = ACTIONS(2169),
    [sym_none] = ACTIONS(2169),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [sym_nil] = ACTIONS(2169),
    [anon_sym_QMARK_DOT] = ACTIONS(2167),
    [anon_sym_POUND_LBRACK] = ACTIONS(2167),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(2169),
    [anon_sym_DOLLARif] = ACTIONS(2169),
    [anon_sym_is] = ACTIONS(2169),
    [anon_sym_BANGis] = ACTIONS(2167),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_BANGin] = ACTIONS(2167),
    [anon_sym_match] = ACTIONS(2169),
    [anon_sym_select] = ACTIONS(2169),
    [anon_sym_lock] = ACTIONS(2169),
    [anon_sym_rlock] = ACTIONS(2169),
    [anon_sym_unsafe] = ACTIONS(2169),
    [anon_sym_sql] = ACTIONS(2169),
    [sym_int_literal] = ACTIONS(2169),
    [sym_float_literal] = ACTIONS(2167),
    [sym_rune_literal] = ACTIONS(2167),
    [anon_sym_SQUOTE] = ACTIONS(2167),
    [anon_sym_DQUOTE] = ACTIONS(2167),
    [anon_sym_c_SQUOTE] = ACTIONS(2167),
    [anon_sym_c_DQUOTE] = ACTIONS(2167),
    [anon_sym_r_SQUOTE] = ACTIONS(2167),
    [anon_sym_r_DQUOTE] = ACTIONS(2167),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_map_LBRACK] = ACTIONS(2167),
    [anon_sym_chan] = ACTIONS(2169),
    [anon_sym_thread] = ACTIONS(2169),
    [anon_sym_atomic] = ACTIONS(2169),
  },
  [1561] = {
    [sym_line_comment] = STATE(1561),
    [sym_block_comment] = STATE(1561),
    [sym_identifier] = ACTIONS(2105),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2105),
    [anon_sym_as] = ACTIONS(2105),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [anon_sym_COMMA] = ACTIONS(2103),
    [anon_sym_RBRACE] = ACTIONS(2103),
    [anon_sym_LPAREN] = ACTIONS(2103),
    [anon_sym_fn] = ACTIONS(2105),
    [anon_sym_PLUS] = ACTIONS(2105),
    [anon_sym_DASH] = ACTIONS(2105),
    [anon_sym_STAR] = ACTIONS(2103),
    [anon_sym_SLASH] = ACTIONS(2105),
    [anon_sym_PERCENT] = ACTIONS(2103),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_GT] = ACTIONS(2105),
    [anon_sym_EQ_EQ] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2103),
    [anon_sym_LT_EQ] = ACTIONS(2103),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_RBRACK] = ACTIONS(2103),
    [anon_sym_struct] = ACTIONS(2105),
    [anon_sym_mut] = ACTIONS(2105),
    [anon_sym_COLON] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(2103),
    [anon_sym_QMARK] = ACTIONS(2105),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_go] = ACTIONS(2105),
    [anon_sym_spawn] = ACTIONS(2105),
    [anon_sym_json_DOTdecode] = ACTIONS(2103),
    [anon_sym_PIPE] = ACTIONS(2105),
    [anon_sym_LBRACK2] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2103),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_LT_DASH] = ACTIONS(2103),
    [anon_sym_LT_LT] = ACTIONS(2103),
    [anon_sym_GT_GT] = ACTIONS(2105),
    [anon_sym_GT_GT_GT] = ACTIONS(2103),
    [anon_sym_AMP_CARET] = ACTIONS(2103),
    [anon_sym_AMP_AMP] = ACTIONS(2103),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_or] = ACTIONS(2105),
    [sym_none] = ACTIONS(2105),
    [sym_true] = ACTIONS(2105),
    [sym_false] = ACTIONS(2105),
    [sym_nil] = ACTIONS(2105),
    [anon_sym_QMARK_DOT] = ACTIONS(2103),
    [anon_sym_POUND_LBRACK] = ACTIONS(2103),
    [anon_sym_if] = ACTIONS(2105),
    [anon_sym_DOLLARif] = ACTIONS(2105),
    [anon_sym_DOLLARelse] = ACTIONS(4283),
    [anon_sym_is] = ACTIONS(2105),
    [anon_sym_BANGis] = ACTIONS(2103),
    [anon_sym_in] = ACTIONS(2105),
    [anon_sym_BANGin] = ACTIONS(2103),
    [anon_sym_match] = ACTIONS(2105),
    [anon_sym_select] = ACTIONS(2105),
    [anon_sym_lock] = ACTIONS(2105),
    [anon_sym_rlock] = ACTIONS(2105),
    [anon_sym_unsafe] = ACTIONS(2105),
    [anon_sym_sql] = ACTIONS(2105),
    [sym_int_literal] = ACTIONS(2105),
    [sym_float_literal] = ACTIONS(2103),
    [sym_rune_literal] = ACTIONS(2103),
    [anon_sym_SQUOTE] = ACTIONS(2103),
    [anon_sym_DQUOTE] = ACTIONS(2103),
    [anon_sym_c_SQUOTE] = ACTIONS(2103),
    [anon_sym_c_DQUOTE] = ACTIONS(2103),
    [anon_sym_r_SQUOTE] = ACTIONS(2103),
    [anon_sym_r_DQUOTE] = ACTIONS(2103),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2105),
    [anon_sym_shared] = ACTIONS(2105),
    [anon_sym_map_LBRACK] = ACTIONS(2103),
    [anon_sym_chan] = ACTIONS(2105),
    [anon_sym_thread] = ACTIONS(2105),
    [anon_sym_atomic] = ACTIONS(2105),
  },
  [1562] = {
    [sym_line_comment] = STATE(1562),
    [sym_block_comment] = STATE(1562),
    [sym_type_parameters] = STATE(4409),
    [sym_argument_list] = STATE(1682),
    [sym_or_block] = STATE(1683),
    [sym_identifier] = ACTIONS(2065),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(4245),
    [anon_sym_LBRACE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(2063),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_fn] = ACTIONS(2065),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4287),
    [anon_sym_SLASH] = ACTIONS(4289),
    [anon_sym_PERCENT] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(4291),
    [anon_sym_GT] = ACTIONS(4291),
    [anon_sym_EQ_EQ] = ACTIONS(4293),
    [anon_sym_BANG_EQ] = ACTIONS(4293),
    [anon_sym_LT_EQ] = ACTIONS(4293),
    [anon_sym_GT_EQ] = ACTIONS(4293),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_RBRACK] = ACTIONS(2063),
    [anon_sym_struct] = ACTIONS(2065),
    [anon_sym_mut] = ACTIONS(2065),
    [anon_sym_PLUS_PLUS] = ACTIONS(4261),
    [anon_sym_DASH_DASH] = ACTIONS(4263),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4233),
    [anon_sym_go] = ACTIONS(2065),
    [anon_sym_spawn] = ACTIONS(2065),
    [anon_sym_json_DOTdecode] = ACTIONS(2063),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_LBRACK2] = ACTIONS(4235),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_CARET] = ACTIONS(4295),
    [anon_sym_AMP] = ACTIONS(4289),
    [anon_sym_LT_DASH] = ACTIONS(2063),
    [anon_sym_LT_LT] = ACTIONS(4287),
    [anon_sym_GT_GT] = ACTIONS(4289),
    [anon_sym_GT_GT_GT] = ACTIONS(4287),
    [anon_sym_AMP_CARET] = ACTIONS(4287),
    [anon_sym_AMP_AMP] = ACTIONS(4297),
    [anon_sym_PIPE_PIPE] = ACTIONS(4299),
    [anon_sym_or] = ACTIONS(4271),
    [sym_none] = ACTIONS(2065),
    [sym_true] = ACTIONS(2065),
    [sym_false] = ACTIONS(2065),
    [sym_nil] = ACTIONS(2065),
    [anon_sym_QMARK_DOT] = ACTIONS(4237),
    [anon_sym_POUND_LBRACK] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(2065),
    [anon_sym_DOLLARif] = ACTIONS(2065),
    [anon_sym_is] = ACTIONS(4273),
    [anon_sym_BANGis] = ACTIONS(4275),
    [anon_sym_in] = ACTIONS(4301),
    [anon_sym_BANGin] = ACTIONS(4303),
    [anon_sym_match] = ACTIONS(2065),
    [anon_sym_select] = ACTIONS(2065),
    [anon_sym_lock] = ACTIONS(2065),
    [anon_sym_rlock] = ACTIONS(2065),
    [anon_sym_unsafe] = ACTIONS(2065),
    [anon_sym_sql] = ACTIONS(2065),
    [sym_int_literal] = ACTIONS(2065),
    [sym_float_literal] = ACTIONS(2063),
    [sym_rune_literal] = ACTIONS(2063),
    [anon_sym_SQUOTE] = ACTIONS(2063),
    [anon_sym_DQUOTE] = ACTIONS(2063),
    [anon_sym_c_SQUOTE] = ACTIONS(2063),
    [anon_sym_c_DQUOTE] = ACTIONS(2063),
    [anon_sym_r_SQUOTE] = ACTIONS(2063),
    [anon_sym_r_DQUOTE] = ACTIONS(2063),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2065),
    [anon_sym_shared] = ACTIONS(2065),
    [anon_sym_map_LBRACK] = ACTIONS(2063),
    [anon_sym_chan] = ACTIONS(2065),
    [anon_sym_thread] = ACTIONS(2065),
    [anon_sym_atomic] = ACTIONS(2065),
  },
  [1563] = {
    [sym_line_comment] = STATE(1563),
    [sym_block_comment] = STATE(1563),
    [sym_type_parameters] = STATE(1669),
    [sym_identifier] = ACTIONS(2187),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2187),
    [anon_sym_as] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2185),
    [anon_sym_COMMA] = ACTIONS(2185),
    [anon_sym_RBRACE] = ACTIONS(2185),
    [anon_sym_LPAREN] = ACTIONS(2185),
    [anon_sym_fn] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2185),
    [anon_sym_LT] = ACTIONS(2187),
    [anon_sym_GT] = ACTIONS(2187),
    [anon_sym_EQ_EQ] = ACTIONS(2185),
    [anon_sym_BANG_EQ] = ACTIONS(2185),
    [anon_sym_LT_EQ] = ACTIONS(2185),
    [anon_sym_GT_EQ] = ACTIONS(2185),
    [anon_sym_LBRACK] = ACTIONS(2185),
    [anon_sym_RBRACK] = ACTIONS(2185),
    [anon_sym_struct] = ACTIONS(2187),
    [anon_sym_mut] = ACTIONS(2187),
    [anon_sym_COLON] = ACTIONS(2185),
    [anon_sym_PLUS_PLUS] = ACTIONS(2185),
    [anon_sym_DASH_DASH] = ACTIONS(2185),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_go] = ACTIONS(2187),
    [anon_sym_spawn] = ACTIONS(2187),
    [anon_sym_json_DOTdecode] = ACTIONS(2185),
    [anon_sym_PIPE] = ACTIONS(2187),
    [anon_sym_LBRACK2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2185),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_LT_DASH] = ACTIONS(2185),
    [anon_sym_LT_LT] = ACTIONS(2185),
    [anon_sym_GT_GT] = ACTIONS(2187),
    [anon_sym_GT_GT_GT] = ACTIONS(2185),
    [anon_sym_AMP_CARET] = ACTIONS(2185),
    [anon_sym_AMP_AMP] = ACTIONS(2185),
    [anon_sym_PIPE_PIPE] = ACTIONS(2185),
    [anon_sym_or] = ACTIONS(2187),
    [sym_none] = ACTIONS(2187),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [sym_nil] = ACTIONS(2187),
    [anon_sym_QMARK_DOT] = ACTIONS(2185),
    [anon_sym_POUND_LBRACK] = ACTIONS(2185),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_DOLLARif] = ACTIONS(2187),
    [anon_sym_is] = ACTIONS(2187),
    [anon_sym_BANGis] = ACTIONS(2185),
    [anon_sym_in] = ACTIONS(2187),
    [anon_sym_BANGin] = ACTIONS(2185),
    [anon_sym_match] = ACTIONS(2187),
    [anon_sym_select] = ACTIONS(2187),
    [anon_sym_lock] = ACTIONS(2187),
    [anon_sym_rlock] = ACTIONS(2187),
    [anon_sym_unsafe] = ACTIONS(2187),
    [anon_sym_sql] = ACTIONS(2187),
    [sym_int_literal] = ACTIONS(2187),
    [sym_float_literal] = ACTIONS(2185),
    [sym_rune_literal] = ACTIONS(2185),
    [anon_sym_SQUOTE] = ACTIONS(2185),
    [anon_sym_DQUOTE] = ACTIONS(2185),
    [anon_sym_c_SQUOTE] = ACTIONS(2185),
    [anon_sym_c_DQUOTE] = ACTIONS(2185),
    [anon_sym_r_SQUOTE] = ACTIONS(2185),
    [anon_sym_r_DQUOTE] = ACTIONS(2185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2187),
    [anon_sym_shared] = ACTIONS(2187),
    [anon_sym_map_LBRACK] = ACTIONS(2185),
    [anon_sym_chan] = ACTIONS(2187),
    [anon_sym_thread] = ACTIONS(2187),
    [anon_sym_atomic] = ACTIONS(2187),
  },
  [1564] = {
    [sym_line_comment] = STATE(1564),
    [sym_block_comment] = STATE(1564),
    [sym_identifier] = ACTIONS(2865),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2865),
    [anon_sym_as] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2863),
    [anon_sym_RBRACE] = ACTIONS(2863),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_fn] = ACTIONS(2865),
    [anon_sym_PLUS] = ACTIONS(2865),
    [anon_sym_DASH] = ACTIONS(2865),
    [anon_sym_STAR] = ACTIONS(2863),
    [anon_sym_SLASH] = ACTIONS(2865),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_GT] = ACTIONS(2865),
    [anon_sym_EQ_EQ] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_LT_EQ] = ACTIONS(2863),
    [anon_sym_GT_EQ] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_RBRACK] = ACTIONS(2863),
    [anon_sym_struct] = ACTIONS(2865),
    [anon_sym_mut] = ACTIONS(2865),
    [anon_sym_COLON] = ACTIONS(2863),
    [anon_sym_PLUS_PLUS] = ACTIONS(2863),
    [anon_sym_DASH_DASH] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2865),
    [anon_sym_BANG] = ACTIONS(2865),
    [anon_sym_go] = ACTIONS(2865),
    [anon_sym_spawn] = ACTIONS(2865),
    [anon_sym_json_DOTdecode] = ACTIONS(2863),
    [anon_sym_PIPE] = ACTIONS(2865),
    [anon_sym_LBRACK2] = ACTIONS(2865),
    [anon_sym_TILDE] = ACTIONS(2863),
    [anon_sym_CARET] = ACTIONS(2863),
    [anon_sym_AMP] = ACTIONS(2865),
    [anon_sym_LT_DASH] = ACTIONS(2863),
    [anon_sym_LT_LT] = ACTIONS(2863),
    [anon_sym_GT_GT] = ACTIONS(2865),
    [anon_sym_GT_GT_GT] = ACTIONS(2863),
    [anon_sym_AMP_CARET] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2865),
    [sym_none] = ACTIONS(2865),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_nil] = ACTIONS(2865),
    [anon_sym_QMARK_DOT] = ACTIONS(2863),
    [anon_sym_POUND_LBRACK] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2865),
    [anon_sym_DOLLARif] = ACTIONS(2865),
    [anon_sym_is] = ACTIONS(2865),
    [anon_sym_BANGis] = ACTIONS(2863),
    [anon_sym_in] = ACTIONS(2865),
    [anon_sym_BANGin] = ACTIONS(2863),
    [anon_sym_match] = ACTIONS(2865),
    [anon_sym_select] = ACTIONS(2865),
    [anon_sym_lock] = ACTIONS(2865),
    [anon_sym_rlock] = ACTIONS(2865),
    [anon_sym_unsafe] = ACTIONS(2865),
    [anon_sym_sql] = ACTIONS(2865),
    [sym_int_literal] = ACTIONS(2865),
    [sym_float_literal] = ACTIONS(2863),
    [sym_rune_literal] = ACTIONS(2863),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_DQUOTE] = ACTIONS(2863),
    [anon_sym_c_SQUOTE] = ACTIONS(2863),
    [anon_sym_c_DQUOTE] = ACTIONS(2863),
    [anon_sym_r_SQUOTE] = ACTIONS(2863),
    [anon_sym_r_DQUOTE] = ACTIONS(2863),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2865),
    [anon_sym_shared] = ACTIONS(2865),
    [anon_sym_map_LBRACK] = ACTIONS(2863),
    [anon_sym_chan] = ACTIONS(2865),
    [anon_sym_thread] = ACTIONS(2865),
    [anon_sym_atomic] = ACTIONS(2865),
  },
  [1565] = {
    [sym_line_comment] = STATE(1565),
    [sym_block_comment] = STATE(1565),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(3005),
    [anon_sym_DOT] = ACTIONS(3007),
    [anon_sym_as] = ACTIONS(3007),
    [anon_sym_LBRACE] = ACTIONS(3005),
    [anon_sym_COMMA] = ACTIONS(3005),
    [anon_sym_RBRACE] = ACTIONS(3005),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_fn] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_STAR] = ACTIONS(3005),
    [anon_sym_SLASH] = ACTIONS(3007),
    [anon_sym_PERCENT] = ACTIONS(3005),
    [anon_sym_LT] = ACTIONS(3007),
    [anon_sym_GT] = ACTIONS(3007),
    [anon_sym_EQ_EQ] = ACTIONS(3005),
    [anon_sym_BANG_EQ] = ACTIONS(3005),
    [anon_sym_LT_EQ] = ACTIONS(3005),
    [anon_sym_GT_EQ] = ACTIONS(3005),
    [anon_sym_LBRACK] = ACTIONS(3005),
    [anon_sym_RBRACK] = ACTIONS(3005),
    [anon_sym_struct] = ACTIONS(3007),
    [anon_sym_mut] = ACTIONS(3007),
    [anon_sym_COLON] = ACTIONS(3005),
    [anon_sym_PLUS_PLUS] = ACTIONS(3005),
    [anon_sym_DASH_DASH] = ACTIONS(3005),
    [anon_sym_QMARK] = ACTIONS(3007),
    [anon_sym_BANG] = ACTIONS(3007),
    [anon_sym_go] = ACTIONS(3007),
    [anon_sym_spawn] = ACTIONS(3007),
    [anon_sym_json_DOTdecode] = ACTIONS(3005),
    [anon_sym_PIPE] = ACTIONS(3007),
    [anon_sym_LBRACK2] = ACTIONS(3007),
    [anon_sym_TILDE] = ACTIONS(3005),
    [anon_sym_CARET] = ACTIONS(3005),
    [anon_sym_AMP] = ACTIONS(3007),
    [anon_sym_LT_DASH] = ACTIONS(3005),
    [anon_sym_LT_LT] = ACTIONS(3005),
    [anon_sym_GT_GT] = ACTIONS(3007),
    [anon_sym_GT_GT_GT] = ACTIONS(3005),
    [anon_sym_AMP_CARET] = ACTIONS(3005),
    [anon_sym_AMP_AMP] = ACTIONS(3005),
    [anon_sym_PIPE_PIPE] = ACTIONS(3005),
    [anon_sym_or] = ACTIONS(3007),
    [sym_none] = ACTIONS(3007),
    [sym_true] = ACTIONS(3007),
    [sym_false] = ACTIONS(3007),
    [sym_nil] = ACTIONS(3007),
    [anon_sym_QMARK_DOT] = ACTIONS(3005),
    [anon_sym_POUND_LBRACK] = ACTIONS(3005),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_DOLLARif] = ACTIONS(3007),
    [anon_sym_is] = ACTIONS(3007),
    [anon_sym_BANGis] = ACTIONS(3005),
    [anon_sym_in] = ACTIONS(3007),
    [anon_sym_BANGin] = ACTIONS(3005),
    [anon_sym_match] = ACTIONS(3007),
    [anon_sym_select] = ACTIONS(3007),
    [anon_sym_lock] = ACTIONS(3007),
    [anon_sym_rlock] = ACTIONS(3007),
    [anon_sym_unsafe] = ACTIONS(3007),
    [anon_sym_sql] = ACTIONS(3007),
    [sym_int_literal] = ACTIONS(3007),
    [sym_float_literal] = ACTIONS(3005),
    [sym_rune_literal] = ACTIONS(3005),
    [anon_sym_SQUOTE] = ACTIONS(3005),
    [anon_sym_DQUOTE] = ACTIONS(3005),
    [anon_sym_c_SQUOTE] = ACTIONS(3005),
    [anon_sym_c_DQUOTE] = ACTIONS(3005),
    [anon_sym_r_SQUOTE] = ACTIONS(3005),
    [anon_sym_r_DQUOTE] = ACTIONS(3005),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3007),
    [anon_sym_shared] = ACTIONS(3007),
    [anon_sym_map_LBRACK] = ACTIONS(3005),
    [anon_sym_chan] = ACTIONS(3007),
    [anon_sym_thread] = ACTIONS(3007),
    [anon_sym_atomic] = ACTIONS(3007),
  },
  [1566] = {
    [sym_line_comment] = STATE(1566),
    [sym_block_comment] = STATE(1566),
    [sym_identifier] = ACTIONS(2981),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_DOT] = ACTIONS(2981),
    [anon_sym_as] = ACTIONS(2981),
    [anon_sym_LBRACE] = ACTIONS(2979),
    [anon_sym_COMMA] = ACTIONS(2979),
    [anon_sym_RBRACE] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_fn] = ACTIONS(2981),
    [anon_sym_PLUS] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_STAR] = ACTIONS(2979),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_PERCENT] = ACTIONS(2979),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_GT] = ACTIONS(2981),
    [anon_sym_EQ_EQ] = ACTIONS(2979),
    [anon_sym_BANG_EQ] = ACTIONS(2979),
    [anon_sym_LT_EQ] = ACTIONS(2979),
    [anon_sym_GT_EQ] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_RBRACK] = ACTIONS(2979),
    [anon_sym_struct] = ACTIONS(2981),
    [anon_sym_mut] = ACTIONS(2981),
    [anon_sym_COLON] = ACTIONS(2979),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [anon_sym_QMARK] = ACTIONS(2981),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_go] = ACTIONS(2981),
    [anon_sym_spawn] = ACTIONS(2981),
    [anon_sym_json_DOTdecode] = ACTIONS(2979),
    [anon_sym_PIPE] = ACTIONS(2981),
    [anon_sym_LBRACK2] = ACTIONS(2981),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_CARET] = ACTIONS(2979),
    [anon_sym_AMP] = ACTIONS(2981),
    [anon_sym_LT_DASH] = ACTIONS(2979),
    [anon_sym_LT_LT] = ACTIONS(2979),
    [anon_sym_GT_GT] = ACTIONS(2981),
    [anon_sym_GT_GT_GT] = ACTIONS(2979),
    [anon_sym_AMP_CARET] = ACTIONS(2979),
    [anon_sym_AMP_AMP] = ACTIONS(2979),
    [anon_sym_PIPE_PIPE] = ACTIONS(2979),
    [anon_sym_or] = ACTIONS(2981),
    [sym_none] = ACTIONS(2981),
    [sym_true] = ACTIONS(2981),
    [sym_false] = ACTIONS(2981),
    [sym_nil] = ACTIONS(2981),
    [anon_sym_QMARK_DOT] = ACTIONS(2979),
    [anon_sym_POUND_LBRACK] = ACTIONS(2979),
    [anon_sym_if] = ACTIONS(2981),
    [anon_sym_DOLLARif] = ACTIONS(2981),
    [anon_sym_is] = ACTIONS(2981),
    [anon_sym_BANGis] = ACTIONS(2979),
    [anon_sym_in] = ACTIONS(2981),
    [anon_sym_BANGin] = ACTIONS(2979),
    [anon_sym_match] = ACTIONS(2981),
    [anon_sym_select] = ACTIONS(2981),
    [anon_sym_lock] = ACTIONS(2981),
    [anon_sym_rlock] = ACTIONS(2981),
    [anon_sym_unsafe] = ACTIONS(2981),
    [anon_sym_sql] = ACTIONS(2981),
    [sym_int_literal] = ACTIONS(2981),
    [sym_float_literal] = ACTIONS(2979),
    [sym_rune_literal] = ACTIONS(2979),
    [anon_sym_SQUOTE] = ACTIONS(2979),
    [anon_sym_DQUOTE] = ACTIONS(2979),
    [anon_sym_c_SQUOTE] = ACTIONS(2979),
    [anon_sym_c_DQUOTE] = ACTIONS(2979),
    [anon_sym_r_SQUOTE] = ACTIONS(2979),
    [anon_sym_r_DQUOTE] = ACTIONS(2979),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2981),
    [anon_sym_shared] = ACTIONS(2981),
    [anon_sym_map_LBRACK] = ACTIONS(2979),
    [anon_sym_chan] = ACTIONS(2981),
    [anon_sym_thread] = ACTIONS(2981),
    [anon_sym_atomic] = ACTIONS(2981),
  },
  [1567] = {
    [sym_line_comment] = STATE(1567),
    [sym_block_comment] = STATE(1567),
    [sym_type_parameters] = STATE(4409),
    [sym_argument_list] = STATE(1682),
    [sym_or_block] = STATE(1683),
    [sym_identifier] = ACTIONS(2065),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(4245),
    [anon_sym_LBRACE] = ACTIONS(2063),
    [anon_sym_RBRACE] = ACTIONS(2063),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_fn] = ACTIONS(2065),
    [anon_sym_PLUS] = ACTIONS(4249),
    [anon_sym_DASH] = ACTIONS(4249),
    [anon_sym_STAR] = ACTIONS(4251),
    [anon_sym_SLASH] = ACTIONS(4253),
    [anon_sym_PERCENT] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(4255),
    [anon_sym_GT] = ACTIONS(4255),
    [anon_sym_EQ_EQ] = ACTIONS(4257),
    [anon_sym_BANG_EQ] = ACTIONS(4257),
    [anon_sym_LT_EQ] = ACTIONS(4257),
    [anon_sym_GT_EQ] = ACTIONS(4257),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_struct] = ACTIONS(2065),
    [anon_sym_mut] = ACTIONS(2065),
    [anon_sym_COLON] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(4261),
    [anon_sym_DASH_DASH] = ACTIONS(4263),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4233),
    [anon_sym_go] = ACTIONS(2065),
    [anon_sym_spawn] = ACTIONS(2065),
    [anon_sym_json_DOTdecode] = ACTIONS(2063),
    [anon_sym_PIPE] = ACTIONS(4249),
    [anon_sym_LBRACK2] = ACTIONS(4235),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_CARET] = ACTIONS(4265),
    [anon_sym_AMP] = ACTIONS(4253),
    [anon_sym_LT_DASH] = ACTIONS(2063),
    [anon_sym_LT_LT] = ACTIONS(4251),
    [anon_sym_GT_GT] = ACTIONS(4253),
    [anon_sym_GT_GT_GT] = ACTIONS(4251),
    [anon_sym_AMP_CARET] = ACTIONS(4251),
    [anon_sym_AMP_AMP] = ACTIONS(4267),
    [anon_sym_PIPE_PIPE] = ACTIONS(4269),
    [anon_sym_or] = ACTIONS(4271),
    [sym_none] = ACTIONS(2065),
    [sym_true] = ACTIONS(2065),
    [sym_false] = ACTIONS(2065),
    [sym_nil] = ACTIONS(2065),
    [anon_sym_QMARK_DOT] = ACTIONS(4237),
    [anon_sym_POUND_LBRACK] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(2065),
    [anon_sym_DOLLARif] = ACTIONS(2065),
    [anon_sym_is] = ACTIONS(4273),
    [anon_sym_BANGis] = ACTIONS(4275),
    [anon_sym_in] = ACTIONS(4277),
    [anon_sym_BANGin] = ACTIONS(4279),
    [anon_sym_match] = ACTIONS(2065),
    [anon_sym_select] = ACTIONS(2065),
    [anon_sym_lock] = ACTIONS(2065),
    [anon_sym_rlock] = ACTIONS(2065),
    [anon_sym_unsafe] = ACTIONS(2065),
    [anon_sym_sql] = ACTIONS(2065),
    [sym_int_literal] = ACTIONS(2065),
    [sym_float_literal] = ACTIONS(2063),
    [sym_rune_literal] = ACTIONS(2063),
    [anon_sym_SQUOTE] = ACTIONS(2063),
    [anon_sym_DQUOTE] = ACTIONS(2063),
    [anon_sym_c_SQUOTE] = ACTIONS(2063),
    [anon_sym_c_DQUOTE] = ACTIONS(2063),
    [anon_sym_r_SQUOTE] = ACTIONS(2063),
    [anon_sym_r_DQUOTE] = ACTIONS(2063),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2065),
    [anon_sym_shared] = ACTIONS(2065),
    [anon_sym_map_LBRACK] = ACTIONS(2063),
    [anon_sym_chan] = ACTIONS(2065),
    [anon_sym_thread] = ACTIONS(2065),
    [anon_sym_atomic] = ACTIONS(2065),
  },
  [1568] = {
    [sym_line_comment] = STATE(1568),
    [sym_block_comment] = STATE(1568),
    [sym_identifier] = ACTIONS(2977),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(2975),
    [anon_sym_DOT] = ACTIONS(2977),
    [anon_sym_as] = ACTIONS(2977),
    [anon_sym_LBRACE] = ACTIONS(2975),
    [anon_sym_COMMA] = ACTIONS(2975),
    [anon_sym_RBRACE] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_fn] = ACTIONS(2977),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2975),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_PERCENT] = ACTIONS(2975),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_EQ_EQ] = ACTIONS(2975),
    [anon_sym_BANG_EQ] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(2975),
    [anon_sym_GT_EQ] = ACTIONS(2975),
    [anon_sym_LBRACK] = ACTIONS(2975),
    [anon_sym_RBRACK] = ACTIONS(2975),
    [anon_sym_struct] = ACTIONS(2977),
    [anon_sym_mut] = ACTIONS(2977),
    [anon_sym_COLON] = ACTIONS(2975),
    [anon_sym_PLUS_PLUS] = ACTIONS(2975),
    [anon_sym_DASH_DASH] = ACTIONS(2975),
    [anon_sym_QMARK] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_go] = ACTIONS(2977),
    [anon_sym_spawn] = ACTIONS(2977),
    [anon_sym_json_DOTdecode] = ACTIONS(2975),
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_LBRACK2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2975),
    [anon_sym_CARET] = ACTIONS(2975),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_LT_DASH] = ACTIONS(2975),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2977),
    [anon_sym_GT_GT_GT] = ACTIONS(2975),
    [anon_sym_AMP_CARET] = ACTIONS(2975),
    [anon_sym_AMP_AMP] = ACTIONS(2975),
    [anon_sym_PIPE_PIPE] = ACTIONS(2975),
    [anon_sym_or] = ACTIONS(2977),
    [sym_none] = ACTIONS(2977),
    [sym_true] = ACTIONS(2977),
    [sym_false] = ACTIONS(2977),
    [sym_nil] = ACTIONS(2977),
    [anon_sym_QMARK_DOT] = ACTIONS(2975),
    [anon_sym_POUND_LBRACK] = ACTIONS(2975),
    [anon_sym_if] = ACTIONS(2977),
    [anon_sym_DOLLARif] = ACTIONS(2977),
    [anon_sym_is] = ACTIONS(2977),
    [anon_sym_BANGis] = ACTIONS(2975),
    [anon_sym_in] = ACTIONS(2977),
    [anon_sym_BANGin] = ACTIONS(2975),
    [anon_sym_match] = ACTIONS(2977),
    [anon_sym_select] = ACTIONS(2977),
    [anon_sym_lock] = ACTIONS(2977),
    [anon_sym_rlock] = ACTIONS(2977),
    [anon_sym_unsafe] = ACTIONS(2977),
    [anon_sym_sql] = ACTIONS(2977),
    [sym_int_literal] = ACTIONS(2977),
    [sym_float_literal] = ACTIONS(2975),
    [sym_rune_literal] = ACTIONS(2975),
    [anon_sym_SQUOTE] = ACTIONS(2975),
    [anon_sym_DQUOTE] = ACTIONS(2975),
    [anon_sym_c_SQUOTE] = ACTIONS(2975),
    [anon_sym_c_DQUOTE] = ACTIONS(2975),
    [anon_sym_r_SQUOTE] = ACTIONS(2975),
    [anon_sym_r_DQUOTE] = ACTIONS(2975),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2977),
    [anon_sym_shared] = ACTIONS(2977),
    [anon_sym_map_LBRACK] = ACTIONS(2975),
    [anon_sym_chan] = ACTIONS(2977),
    [anon_sym_thread] = ACTIONS(2977),
    [anon_sym_atomic] = ACTIONS(2977),
  },
  [1569] = {
    [sym_line_comment] = STATE(1569),
    [sym_block_comment] = STATE(1569),
    [sym_type_parameters] = STATE(4409),
    [sym_argument_list] = STATE(1682),
    [sym_or_block] = STATE(1683),
    [sym_identifier] = ACTIONS(2075),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(4245),
    [anon_sym_LBRACE] = ACTIONS(2073),
    [anon_sym_RBRACE] = ACTIONS(2073),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_fn] = ACTIONS(2075),
    [anon_sym_PLUS] = ACTIONS(4249),
    [anon_sym_DASH] = ACTIONS(4249),
    [anon_sym_STAR] = ACTIONS(4251),
    [anon_sym_SLASH] = ACTIONS(4253),
    [anon_sym_PERCENT] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(4255),
    [anon_sym_GT] = ACTIONS(4255),
    [anon_sym_EQ_EQ] = ACTIONS(4257),
    [anon_sym_BANG_EQ] = ACTIONS(4257),
    [anon_sym_LT_EQ] = ACTIONS(4257),
    [anon_sym_GT_EQ] = ACTIONS(4257),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_struct] = ACTIONS(2075),
    [anon_sym_mut] = ACTIONS(2075),
    [anon_sym_COLON] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(4261),
    [anon_sym_DASH_DASH] = ACTIONS(4263),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4233),
    [anon_sym_go] = ACTIONS(2075),
    [anon_sym_spawn] = ACTIONS(2075),
    [anon_sym_json_DOTdecode] = ACTIONS(2073),
    [anon_sym_PIPE] = ACTIONS(4249),
    [anon_sym_LBRACK2] = ACTIONS(4235),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_CARET] = ACTIONS(4265),
    [anon_sym_AMP] = ACTIONS(4253),
    [anon_sym_LT_DASH] = ACTIONS(2073),
    [anon_sym_LT_LT] = ACTIONS(4251),
    [anon_sym_GT_GT] = ACTIONS(4253),
    [anon_sym_GT_GT_GT] = ACTIONS(4251),
    [anon_sym_AMP_CARET] = ACTIONS(4251),
    [anon_sym_AMP_AMP] = ACTIONS(4267),
    [anon_sym_PIPE_PIPE] = ACTIONS(4269),
    [anon_sym_or] = ACTIONS(4271),
    [sym_none] = ACTIONS(2075),
    [sym_true] = ACTIONS(2075),
    [sym_false] = ACTIONS(2075),
    [sym_nil] = ACTIONS(2075),
    [anon_sym_QMARK_DOT] = ACTIONS(4237),
    [anon_sym_POUND_LBRACK] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(2075),
    [anon_sym_DOLLARif] = ACTIONS(2075),
    [anon_sym_is] = ACTIONS(4273),
    [anon_sym_BANGis] = ACTIONS(4275),
    [anon_sym_in] = ACTIONS(4277),
    [anon_sym_BANGin] = ACTIONS(4279),
    [anon_sym_match] = ACTIONS(2075),
    [anon_sym_select] = ACTIONS(2075),
    [anon_sym_lock] = ACTIONS(2075),
    [anon_sym_rlock] = ACTIONS(2075),
    [anon_sym_unsafe] = ACTIONS(2075),
    [anon_sym_sql] = ACTIONS(2075),
    [sym_int_literal] = ACTIONS(2075),
    [sym_float_literal] = ACTIONS(2073),
    [sym_rune_literal] = ACTIONS(2073),
    [anon_sym_SQUOTE] = ACTIONS(2073),
    [anon_sym_DQUOTE] = ACTIONS(2073),
    [anon_sym_c_SQUOTE] = ACTIONS(2073),
    [anon_sym_c_DQUOTE] = ACTIONS(2073),
    [anon_sym_r_SQUOTE] = ACTIONS(2073),
    [anon_sym_r_DQUOTE] = ACTIONS(2073),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2075),
    [anon_sym_shared] = ACTIONS(2075),
    [anon_sym_map_LBRACK] = ACTIONS(2073),
    [anon_sym_chan] = ACTIONS(2075),
    [anon_sym_thread] = ACTIONS(2075),
    [anon_sym_atomic] = ACTIONS(2075),
  },
  [1570] = {
    [sym_line_comment] = STATE(1570),
    [sym_block_comment] = STATE(1570),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2145),
    [anon_sym_BANG_EQ] = ACTIONS(2145),
    [anon_sym_LT_EQ] = ACTIONS(2145),
    [anon_sym_GT_EQ] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_RBRACK] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_COLON] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2145),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2145),
    [anon_sym_LT_LT] = ACTIONS(2145),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2145),
    [anon_sym_AMP_CARET] = ACTIONS(2145),
    [anon_sym_AMP_AMP] = ACTIONS(2145),
    [anon_sym_PIPE_PIPE] = ACTIONS(2145),
    [anon_sym_or] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2145),
    [anon_sym_POUND_LBRACK] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_else] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2147),
    [anon_sym_BANGis] = ACTIONS(2145),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANGin] = ACTIONS(2145),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2145),
    [sym_rune_literal] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_c_SQUOTE] = ACTIONS(2145),
    [anon_sym_c_DQUOTE] = ACTIONS(2145),
    [anon_sym_r_SQUOTE] = ACTIONS(2145),
    [anon_sym_r_DQUOTE] = ACTIONS(2145),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2145),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
  },
  [1571] = {
    [sym_line_comment] = STATE(1571),
    [sym_block_comment] = STATE(1571),
    [sym_type_parameters] = STATE(4409),
    [sym_argument_list] = STATE(1682),
    [sym_or_block] = STATE(1683),
    [sym_identifier] = ACTIONS(2049),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_RBRACE] = ACTIONS(2047),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_fn] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(4249),
    [anon_sym_DASH] = ACTIONS(4249),
    [anon_sym_STAR] = ACTIONS(4251),
    [anon_sym_SLASH] = ACTIONS(4253),
    [anon_sym_PERCENT] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_EQ_EQ] = ACTIONS(2047),
    [anon_sym_BANG_EQ] = ACTIONS(2047),
    [anon_sym_LT_EQ] = ACTIONS(2047),
    [anon_sym_GT_EQ] = ACTIONS(2047),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_struct] = ACTIONS(2049),
    [anon_sym_mut] = ACTIONS(2049),
    [anon_sym_COLON] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(2047),
    [anon_sym_DASH_DASH] = ACTIONS(2047),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4233),
    [anon_sym_go] = ACTIONS(2049),
    [anon_sym_spawn] = ACTIONS(2049),
    [anon_sym_json_DOTdecode] = ACTIONS(2047),
    [anon_sym_PIPE] = ACTIONS(4249),
    [anon_sym_LBRACK2] = ACTIONS(4235),
    [anon_sym_TILDE] = ACTIONS(2047),
    [anon_sym_CARET] = ACTIONS(4265),
    [anon_sym_AMP] = ACTIONS(4253),
    [anon_sym_LT_DASH] = ACTIONS(2047),
    [anon_sym_LT_LT] = ACTIONS(4251),
    [anon_sym_GT_GT] = ACTIONS(4253),
    [anon_sym_GT_GT_GT] = ACTIONS(4251),
    [anon_sym_AMP_CARET] = ACTIONS(4251),
    [anon_sym_AMP_AMP] = ACTIONS(2047),
    [anon_sym_PIPE_PIPE] = ACTIONS(2047),
    [anon_sym_or] = ACTIONS(2049),
    [sym_none] = ACTIONS(2049),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [sym_nil] = ACTIONS(2049),
    [anon_sym_QMARK_DOT] = ACTIONS(4237),
    [anon_sym_POUND_LBRACK] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(2049),
    [anon_sym_DOLLARif] = ACTIONS(2049),
    [anon_sym_is] = ACTIONS(2049),
    [anon_sym_BANGis] = ACTIONS(2047),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_BANGin] = ACTIONS(2047),
    [anon_sym_match] = ACTIONS(2049),
    [anon_sym_select] = ACTIONS(2049),
    [anon_sym_lock] = ACTIONS(2049),
    [anon_sym_rlock] = ACTIONS(2049),
    [anon_sym_unsafe] = ACTIONS(2049),
    [anon_sym_sql] = ACTIONS(2049),
    [sym_int_literal] = ACTIONS(2049),
    [sym_float_literal] = ACTIONS(2047),
    [sym_rune_literal] = ACTIONS(2047),
    [anon_sym_SQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [anon_sym_c_SQUOTE] = ACTIONS(2047),
    [anon_sym_c_DQUOTE] = ACTIONS(2047),
    [anon_sym_r_SQUOTE] = ACTIONS(2047),
    [anon_sym_r_DQUOTE] = ACTIONS(2047),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2049),
    [anon_sym_shared] = ACTIONS(2049),
    [anon_sym_map_LBRACK] = ACTIONS(2047),
    [anon_sym_chan] = ACTIONS(2049),
    [anon_sym_thread] = ACTIONS(2049),
    [anon_sym_atomic] = ACTIONS(2049),
  },
  [1572] = {
    [sym_line_comment] = STATE(1572),
    [sym_block_comment] = STATE(1572),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2169),
    [anon_sym_as] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2167),
    [anon_sym_COMMA] = ACTIONS(2167),
    [anon_sym_RBRACE] = ACTIONS(2167),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_fn] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2167),
    [anon_sym_SLASH] = ACTIONS(2169),
    [anon_sym_PERCENT] = ACTIONS(2167),
    [anon_sym_LT] = ACTIONS(2169),
    [anon_sym_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2167),
    [anon_sym_BANG_EQ] = ACTIONS(2167),
    [anon_sym_LT_EQ] = ACTIONS(2167),
    [anon_sym_GT_EQ] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_RBRACK] = ACTIONS(2167),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_mut] = ACTIONS(2169),
    [anon_sym_COLON] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_QMARK] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_go] = ACTIONS(2169),
    [anon_sym_spawn] = ACTIONS(2169),
    [anon_sym_json_DOTdecode] = ACTIONS(2167),
    [anon_sym_PIPE] = ACTIONS(2169),
    [anon_sym_LBRACK2] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT_DASH] = ACTIONS(2167),
    [anon_sym_LT_LT] = ACTIONS(2167),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_GT_GT_GT] = ACTIONS(2167),
    [anon_sym_AMP_CARET] = ACTIONS(2167),
    [anon_sym_AMP_AMP] = ACTIONS(2167),
    [anon_sym_PIPE_PIPE] = ACTIONS(2167),
    [anon_sym_or] = ACTIONS(2169),
    [sym_none] = ACTIONS(2169),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [sym_nil] = ACTIONS(2169),
    [anon_sym_QMARK_DOT] = ACTIONS(2167),
    [anon_sym_POUND_LBRACK] = ACTIONS(2167),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_DOLLARif] = ACTIONS(2169),
    [anon_sym_DOLLARelse] = ACTIONS(2169),
    [anon_sym_is] = ACTIONS(2169),
    [anon_sym_BANGis] = ACTIONS(2167),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_BANGin] = ACTIONS(2167),
    [anon_sym_match] = ACTIONS(2169),
    [anon_sym_select] = ACTIONS(2169),
    [anon_sym_lock] = ACTIONS(2169),
    [anon_sym_rlock] = ACTIONS(2169),
    [anon_sym_unsafe] = ACTIONS(2169),
    [anon_sym_sql] = ACTIONS(2169),
    [sym_int_literal] = ACTIONS(2169),
    [sym_float_literal] = ACTIONS(2167),
    [sym_rune_literal] = ACTIONS(2167),
    [anon_sym_SQUOTE] = ACTIONS(2167),
    [anon_sym_DQUOTE] = ACTIONS(2167),
    [anon_sym_c_SQUOTE] = ACTIONS(2167),
    [anon_sym_c_DQUOTE] = ACTIONS(2167),
    [anon_sym_r_SQUOTE] = ACTIONS(2167),
    [anon_sym_r_DQUOTE] = ACTIONS(2167),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_map_LBRACK] = ACTIONS(2167),
    [anon_sym_chan] = ACTIONS(2169),
    [anon_sym_thread] = ACTIONS(2169),
    [anon_sym_atomic] = ACTIONS(2169),
  },
  [1573] = {
    [sym_line_comment] = STATE(1573),
    [sym_block_comment] = STATE(1573),
    [sym_identifier] = ACTIONS(2093),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2093),
    [anon_sym_as] = ACTIONS(2093),
    [anon_sym_LBRACE] = ACTIONS(2091),
    [anon_sym_COMMA] = ACTIONS(2091),
    [anon_sym_RBRACE] = ACTIONS(2091),
    [anon_sym_LPAREN] = ACTIONS(2091),
    [anon_sym_fn] = ACTIONS(2093),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(2091),
    [anon_sym_SLASH] = ACTIONS(2093),
    [anon_sym_PERCENT] = ACTIONS(2091),
    [anon_sym_LT] = ACTIONS(2093),
    [anon_sym_GT] = ACTIONS(2093),
    [anon_sym_EQ_EQ] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2091),
    [anon_sym_LT_EQ] = ACTIONS(2091),
    [anon_sym_GT_EQ] = ACTIONS(2091),
    [anon_sym_LBRACK] = ACTIONS(2091),
    [anon_sym_RBRACK] = ACTIONS(2091),
    [anon_sym_struct] = ACTIONS(2093),
    [anon_sym_mut] = ACTIONS(2093),
    [anon_sym_COLON] = ACTIONS(2091),
    [anon_sym_PLUS_PLUS] = ACTIONS(2091),
    [anon_sym_DASH_DASH] = ACTIONS(2091),
    [anon_sym_QMARK] = ACTIONS(2093),
    [anon_sym_BANG] = ACTIONS(2093),
    [anon_sym_go] = ACTIONS(2093),
    [anon_sym_spawn] = ACTIONS(2093),
    [anon_sym_json_DOTdecode] = ACTIONS(2091),
    [anon_sym_PIPE] = ACTIONS(2093),
    [anon_sym_LBRACK2] = ACTIONS(2093),
    [anon_sym_TILDE] = ACTIONS(2091),
    [anon_sym_CARET] = ACTIONS(2091),
    [anon_sym_AMP] = ACTIONS(2093),
    [anon_sym_LT_DASH] = ACTIONS(2091),
    [anon_sym_LT_LT] = ACTIONS(2091),
    [anon_sym_GT_GT] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2091),
    [anon_sym_AMP_CARET] = ACTIONS(2091),
    [anon_sym_AMP_AMP] = ACTIONS(2091),
    [anon_sym_PIPE_PIPE] = ACTIONS(2091),
    [anon_sym_or] = ACTIONS(2093),
    [sym_none] = ACTIONS(2093),
    [sym_true] = ACTIONS(2093),
    [sym_false] = ACTIONS(2093),
    [sym_nil] = ACTIONS(2093),
    [anon_sym_QMARK_DOT] = ACTIONS(2091),
    [anon_sym_POUND_LBRACK] = ACTIONS(2091),
    [anon_sym_if] = ACTIONS(2093),
    [anon_sym_DOLLARif] = ACTIONS(2093),
    [anon_sym_DOLLARelse] = ACTIONS(4305),
    [anon_sym_is] = ACTIONS(2093),
    [anon_sym_BANGis] = ACTIONS(2091),
    [anon_sym_in] = ACTIONS(2093),
    [anon_sym_BANGin] = ACTIONS(2091),
    [anon_sym_match] = ACTIONS(2093),
    [anon_sym_select] = ACTIONS(2093),
    [anon_sym_lock] = ACTIONS(2093),
    [anon_sym_rlock] = ACTIONS(2093),
    [anon_sym_unsafe] = ACTIONS(2093),
    [anon_sym_sql] = ACTIONS(2093),
    [sym_int_literal] = ACTIONS(2093),
    [sym_float_literal] = ACTIONS(2091),
    [sym_rune_literal] = ACTIONS(2091),
    [anon_sym_SQUOTE] = ACTIONS(2091),
    [anon_sym_DQUOTE] = ACTIONS(2091),
    [anon_sym_c_SQUOTE] = ACTIONS(2091),
    [anon_sym_c_DQUOTE] = ACTIONS(2091),
    [anon_sym_r_SQUOTE] = ACTIONS(2091),
    [anon_sym_r_DQUOTE] = ACTIONS(2091),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2093),
    [anon_sym_shared] = ACTIONS(2093),
    [anon_sym_map_LBRACK] = ACTIONS(2091),
    [anon_sym_chan] = ACTIONS(2093),
    [anon_sym_thread] = ACTIONS(2093),
    [anon_sym_atomic] = ACTIONS(2093),
  },
  [1574] = {
    [sym_line_comment] = STATE(1574),
    [sym_block_comment] = STATE(1574),
    [sym_type_parameters] = STATE(4409),
    [sym_argument_list] = STATE(1682),
    [sym_or_block] = STATE(1683),
    [sym_identifier] = ACTIONS(4307),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(4245),
    [anon_sym_LBRACE] = ACTIONS(4309),
    [anon_sym_COMMA] = ACTIONS(4311),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_fn] = ACTIONS(4307),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4287),
    [anon_sym_SLASH] = ACTIONS(4289),
    [anon_sym_PERCENT] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(4291),
    [anon_sym_GT] = ACTIONS(4291),
    [anon_sym_EQ_EQ] = ACTIONS(4293),
    [anon_sym_BANG_EQ] = ACTIONS(4293),
    [anon_sym_LT_EQ] = ACTIONS(4293),
    [anon_sym_GT_EQ] = ACTIONS(4293),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_RBRACK] = ACTIONS(4309),
    [anon_sym_struct] = ACTIONS(4307),
    [anon_sym_mut] = ACTIONS(4307),
    [anon_sym_PLUS_PLUS] = ACTIONS(4261),
    [anon_sym_DASH_DASH] = ACTIONS(4263),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4233),
    [anon_sym_go] = ACTIONS(4307),
    [anon_sym_spawn] = ACTIONS(4307),
    [anon_sym_json_DOTdecode] = ACTIONS(4309),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_LBRACK2] = ACTIONS(4235),
    [anon_sym_TILDE] = ACTIONS(4309),
    [anon_sym_CARET] = ACTIONS(4295),
    [anon_sym_AMP] = ACTIONS(4289),
    [anon_sym_LT_DASH] = ACTIONS(4309),
    [anon_sym_LT_LT] = ACTIONS(4287),
    [anon_sym_GT_GT] = ACTIONS(4289),
    [anon_sym_GT_GT_GT] = ACTIONS(4287),
    [anon_sym_AMP_CARET] = ACTIONS(4287),
    [anon_sym_AMP_AMP] = ACTIONS(4297),
    [anon_sym_PIPE_PIPE] = ACTIONS(4299),
    [anon_sym_or] = ACTIONS(4271),
    [sym_none] = ACTIONS(4307),
    [sym_true] = ACTIONS(4307),
    [sym_false] = ACTIONS(4307),
    [sym_nil] = ACTIONS(4307),
    [anon_sym_QMARK_DOT] = ACTIONS(4237),
    [anon_sym_POUND_LBRACK] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(4307),
    [anon_sym_DOLLARif] = ACTIONS(4307),
    [anon_sym_is] = ACTIONS(4273),
    [anon_sym_BANGis] = ACTIONS(4275),
    [anon_sym_in] = ACTIONS(4301),
    [anon_sym_BANGin] = ACTIONS(4303),
    [anon_sym_match] = ACTIONS(4307),
    [anon_sym_select] = ACTIONS(4307),
    [anon_sym_lock] = ACTIONS(4307),
    [anon_sym_rlock] = ACTIONS(4307),
    [anon_sym_unsafe] = ACTIONS(4307),
    [anon_sym_sql] = ACTIONS(4307),
    [sym_int_literal] = ACTIONS(4307),
    [sym_float_literal] = ACTIONS(4309),
    [sym_rune_literal] = ACTIONS(4309),
    [anon_sym_SQUOTE] = ACTIONS(4309),
    [anon_sym_DQUOTE] = ACTIONS(4309),
    [anon_sym_c_SQUOTE] = ACTIONS(4309),
    [anon_sym_c_DQUOTE] = ACTIONS(4309),
    [anon_sym_r_SQUOTE] = ACTIONS(4309),
    [anon_sym_r_DQUOTE] = ACTIONS(4309),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4307),
    [anon_sym_shared] = ACTIONS(4307),
    [anon_sym_map_LBRACK] = ACTIONS(4309),
    [anon_sym_chan] = ACTIONS(4307),
    [anon_sym_thread] = ACTIONS(4307),
    [anon_sym_atomic] = ACTIONS(4307),
  },
  [1575] = {
    [sym_line_comment] = STATE(1575),
    [sym_block_comment] = STATE(1575),
    [sym_type_parameters] = STATE(4409),
    [sym_argument_list] = STATE(1682),
    [sym_or_block] = STATE(1683),
    [sym_identifier] = ACTIONS(2075),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(4245),
    [anon_sym_LBRACE] = ACTIONS(2073),
    [anon_sym_COMMA] = ACTIONS(2073),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_fn] = ACTIONS(2075),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4287),
    [anon_sym_SLASH] = ACTIONS(4289),
    [anon_sym_PERCENT] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(4291),
    [anon_sym_GT] = ACTIONS(4291),
    [anon_sym_EQ_EQ] = ACTIONS(4293),
    [anon_sym_BANG_EQ] = ACTIONS(4293),
    [anon_sym_LT_EQ] = ACTIONS(4293),
    [anon_sym_GT_EQ] = ACTIONS(4293),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_RBRACK] = ACTIONS(2073),
    [anon_sym_struct] = ACTIONS(2075),
    [anon_sym_mut] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(4261),
    [anon_sym_DASH_DASH] = ACTIONS(4263),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4233),
    [anon_sym_go] = ACTIONS(2075),
    [anon_sym_spawn] = ACTIONS(2075),
    [anon_sym_json_DOTdecode] = ACTIONS(2073),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_LBRACK2] = ACTIONS(4235),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_CARET] = ACTIONS(4295),
    [anon_sym_AMP] = ACTIONS(4289),
    [anon_sym_LT_DASH] = ACTIONS(2073),
    [anon_sym_LT_LT] = ACTIONS(4287),
    [anon_sym_GT_GT] = ACTIONS(4289),
    [anon_sym_GT_GT_GT] = ACTIONS(4287),
    [anon_sym_AMP_CARET] = ACTIONS(4287),
    [anon_sym_AMP_AMP] = ACTIONS(4297),
    [anon_sym_PIPE_PIPE] = ACTIONS(4299),
    [anon_sym_or] = ACTIONS(4271),
    [sym_none] = ACTIONS(2075),
    [sym_true] = ACTIONS(2075),
    [sym_false] = ACTIONS(2075),
    [sym_nil] = ACTIONS(2075),
    [anon_sym_QMARK_DOT] = ACTIONS(4237),
    [anon_sym_POUND_LBRACK] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(2075),
    [anon_sym_DOLLARif] = ACTIONS(2075),
    [anon_sym_is] = ACTIONS(4273),
    [anon_sym_BANGis] = ACTIONS(4275),
    [anon_sym_in] = ACTIONS(4301),
    [anon_sym_BANGin] = ACTIONS(4303),
    [anon_sym_match] = ACTIONS(2075),
    [anon_sym_select] = ACTIONS(2075),
    [anon_sym_lock] = ACTIONS(2075),
    [anon_sym_rlock] = ACTIONS(2075),
    [anon_sym_unsafe] = ACTIONS(2075),
    [anon_sym_sql] = ACTIONS(2075),
    [sym_int_literal] = ACTIONS(2075),
    [sym_float_literal] = ACTIONS(2073),
    [sym_rune_literal] = ACTIONS(2073),
    [anon_sym_SQUOTE] = ACTIONS(2073),
    [anon_sym_DQUOTE] = ACTIONS(2073),
    [anon_sym_c_SQUOTE] = ACTIONS(2073),
    [anon_sym_c_DQUOTE] = ACTIONS(2073),
    [anon_sym_r_SQUOTE] = ACTIONS(2073),
    [anon_sym_r_DQUOTE] = ACTIONS(2073),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2075),
    [anon_sym_shared] = ACTIONS(2075),
    [anon_sym_map_LBRACK] = ACTIONS(2073),
    [anon_sym_chan] = ACTIONS(2075),
    [anon_sym_thread] = ACTIONS(2075),
    [anon_sym_atomic] = ACTIONS(2075),
  },
  [1576] = {
    [sym_line_comment] = STATE(1576),
    [sym_block_comment] = STATE(1576),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_DOT] = ACTIONS(2917),
    [anon_sym_as] = ACTIONS(2917),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_COMMA] = ACTIONS(2915),
    [anon_sym_RBRACE] = ACTIONS(2915),
    [anon_sym_LPAREN] = ACTIONS(2915),
    [anon_sym_fn] = ACTIONS(2917),
    [anon_sym_PLUS] = ACTIONS(2917),
    [anon_sym_DASH] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2915),
    [anon_sym_SLASH] = ACTIONS(2917),
    [anon_sym_PERCENT] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2917),
    [anon_sym_GT] = ACTIONS(2917),
    [anon_sym_EQ_EQ] = ACTIONS(2915),
    [anon_sym_BANG_EQ] = ACTIONS(2915),
    [anon_sym_LT_EQ] = ACTIONS(2915),
    [anon_sym_GT_EQ] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_RBRACK] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2917),
    [anon_sym_mut] = ACTIONS(2917),
    [anon_sym_COLON] = ACTIONS(2915),
    [anon_sym_PLUS_PLUS] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(2917),
    [anon_sym_BANG] = ACTIONS(2917),
    [anon_sym_go] = ACTIONS(2917),
    [anon_sym_spawn] = ACTIONS(2917),
    [anon_sym_json_DOTdecode] = ACTIONS(2915),
    [anon_sym_PIPE] = ACTIONS(2917),
    [anon_sym_LBRACK2] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2915),
    [anon_sym_CARET] = ACTIONS(2915),
    [anon_sym_AMP] = ACTIONS(2917),
    [anon_sym_LT_DASH] = ACTIONS(2915),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2917),
    [anon_sym_GT_GT_GT] = ACTIONS(2915),
    [anon_sym_AMP_CARET] = ACTIONS(2915),
    [anon_sym_AMP_AMP] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE] = ACTIONS(2915),
    [anon_sym_or] = ACTIONS(2917),
    [sym_none] = ACTIONS(2917),
    [sym_true] = ACTIONS(2917),
    [sym_false] = ACTIONS(2917),
    [sym_nil] = ACTIONS(2917),
    [anon_sym_QMARK_DOT] = ACTIONS(2915),
    [anon_sym_POUND_LBRACK] = ACTIONS(2915),
    [anon_sym_if] = ACTIONS(2917),
    [anon_sym_DOLLARif] = ACTIONS(2917),
    [anon_sym_is] = ACTIONS(2917),
    [anon_sym_BANGis] = ACTIONS(2915),
    [anon_sym_in] = ACTIONS(2917),
    [anon_sym_BANGin] = ACTIONS(2915),
    [anon_sym_match] = ACTIONS(2917),
    [anon_sym_select] = ACTIONS(2917),
    [anon_sym_lock] = ACTIONS(2917),
    [anon_sym_rlock] = ACTIONS(2917),
    [anon_sym_unsafe] = ACTIONS(2917),
    [anon_sym_sql] = ACTIONS(2917),
    [sym_int_literal] = ACTIONS(2917),
    [sym_float_literal] = ACTIONS(2915),
    [sym_rune_literal] = ACTIONS(2915),
    [anon_sym_SQUOTE] = ACTIONS(2915),
    [anon_sym_DQUOTE] = ACTIONS(2915),
    [anon_sym_c_SQUOTE] = ACTIONS(2915),
    [anon_sym_c_DQUOTE] = ACTIONS(2915),
    [anon_sym_r_SQUOTE] = ACTIONS(2915),
    [anon_sym_r_DQUOTE] = ACTIONS(2915),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2917),
    [anon_sym_shared] = ACTIONS(2917),
    [anon_sym_map_LBRACK] = ACTIONS(2915),
    [anon_sym_chan] = ACTIONS(2917),
    [anon_sym_thread] = ACTIONS(2917),
    [anon_sym_atomic] = ACTIONS(2917),
  },
  [1577] = {
    [sym_line_comment] = STATE(1577),
    [sym_block_comment] = STATE(1577),
    [sym_identifier] = ACTIONS(2921),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(2919),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_as] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2919),
    [anon_sym_COMMA] = ACTIONS(2919),
    [anon_sym_RBRACE] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2919),
    [anon_sym_fn] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2919),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2919),
    [anon_sym_LT] = ACTIONS(2921),
    [anon_sym_GT] = ACTIONS(2921),
    [anon_sym_EQ_EQ] = ACTIONS(2919),
    [anon_sym_BANG_EQ] = ACTIONS(2919),
    [anon_sym_LT_EQ] = ACTIONS(2919),
    [anon_sym_GT_EQ] = ACTIONS(2919),
    [anon_sym_LBRACK] = ACTIONS(2919),
    [anon_sym_RBRACK] = ACTIONS(2919),
    [anon_sym_struct] = ACTIONS(2921),
    [anon_sym_mut] = ACTIONS(2921),
    [anon_sym_COLON] = ACTIONS(2919),
    [anon_sym_PLUS_PLUS] = ACTIONS(2919),
    [anon_sym_DASH_DASH] = ACTIONS(2919),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_go] = ACTIONS(2921),
    [anon_sym_spawn] = ACTIONS(2921),
    [anon_sym_json_DOTdecode] = ACTIONS(2919),
    [anon_sym_PIPE] = ACTIONS(2921),
    [anon_sym_LBRACK2] = ACTIONS(2921),
    [anon_sym_TILDE] = ACTIONS(2919),
    [anon_sym_CARET] = ACTIONS(2919),
    [anon_sym_AMP] = ACTIONS(2921),
    [anon_sym_LT_DASH] = ACTIONS(2919),
    [anon_sym_LT_LT] = ACTIONS(2919),
    [anon_sym_GT_GT] = ACTIONS(2921),
    [anon_sym_GT_GT_GT] = ACTIONS(2919),
    [anon_sym_AMP_CARET] = ACTIONS(2919),
    [anon_sym_AMP_AMP] = ACTIONS(2919),
    [anon_sym_PIPE_PIPE] = ACTIONS(2919),
    [anon_sym_or] = ACTIONS(2921),
    [sym_none] = ACTIONS(2921),
    [sym_true] = ACTIONS(2921),
    [sym_false] = ACTIONS(2921),
    [sym_nil] = ACTIONS(2921),
    [anon_sym_QMARK_DOT] = ACTIONS(2919),
    [anon_sym_POUND_LBRACK] = ACTIONS(2919),
    [anon_sym_if] = ACTIONS(2921),
    [anon_sym_DOLLARif] = ACTIONS(2921),
    [anon_sym_is] = ACTIONS(2921),
    [anon_sym_BANGis] = ACTIONS(2919),
    [anon_sym_in] = ACTIONS(2921),
    [anon_sym_BANGin] = ACTIONS(2919),
    [anon_sym_match] = ACTIONS(2921),
    [anon_sym_select] = ACTIONS(2921),
    [anon_sym_lock] = ACTIONS(2921),
    [anon_sym_rlock] = ACTIONS(2921),
    [anon_sym_unsafe] = ACTIONS(2921),
    [anon_sym_sql] = ACTIONS(2921),
    [sym_int_literal] = ACTIONS(2921),
    [sym_float_literal] = ACTIONS(2919),
    [sym_rune_literal] = ACTIONS(2919),
    [anon_sym_SQUOTE] = ACTIONS(2919),
    [anon_sym_DQUOTE] = ACTIONS(2919),
    [anon_sym_c_SQUOTE] = ACTIONS(2919),
    [anon_sym_c_DQUOTE] = ACTIONS(2919),
    [anon_sym_r_SQUOTE] = ACTIONS(2919),
    [anon_sym_r_DQUOTE] = ACTIONS(2919),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2921),
    [anon_sym_shared] = ACTIONS(2921),
    [anon_sym_map_LBRACK] = ACTIONS(2919),
    [anon_sym_chan] = ACTIONS(2921),
    [anon_sym_thread] = ACTIONS(2921),
    [anon_sym_atomic] = ACTIONS(2921),
  },
  [1578] = {
    [sym_line_comment] = STATE(1578),
    [sym_block_comment] = STATE(1578),
    [sym_identifier] = ACTIONS(2925),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_DOT] = ACTIONS(2925),
    [anon_sym_as] = ACTIONS(2925),
    [anon_sym_LBRACE] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2923),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_fn] = ACTIONS(2925),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_STAR] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2925),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_GT] = ACTIONS(2925),
    [anon_sym_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2923),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_RBRACK] = ACTIONS(2923),
    [anon_sym_struct] = ACTIONS(2925),
    [anon_sym_mut] = ACTIONS(2925),
    [anon_sym_COLON] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_QMARK] = ACTIONS(2925),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_go] = ACTIONS(2925),
    [anon_sym_spawn] = ACTIONS(2925),
    [anon_sym_json_DOTdecode] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2925),
    [anon_sym_LBRACK2] = ACTIONS(2925),
    [anon_sym_TILDE] = ACTIONS(2923),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym_LT_DASH] = ACTIONS(2923),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_GT_GT] = ACTIONS(2925),
    [anon_sym_GT_GT_GT] = ACTIONS(2923),
    [anon_sym_AMP_CARET] = ACTIONS(2923),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_or] = ACTIONS(2925),
    [sym_none] = ACTIONS(2925),
    [sym_true] = ACTIONS(2925),
    [sym_false] = ACTIONS(2925),
    [sym_nil] = ACTIONS(2925),
    [anon_sym_QMARK_DOT] = ACTIONS(2923),
    [anon_sym_POUND_LBRACK] = ACTIONS(2923),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_DOLLARif] = ACTIONS(2925),
    [anon_sym_is] = ACTIONS(2925),
    [anon_sym_BANGis] = ACTIONS(2923),
    [anon_sym_in] = ACTIONS(2925),
    [anon_sym_BANGin] = ACTIONS(2923),
    [anon_sym_match] = ACTIONS(2925),
    [anon_sym_select] = ACTIONS(2925),
    [anon_sym_lock] = ACTIONS(2925),
    [anon_sym_rlock] = ACTIONS(2925),
    [anon_sym_unsafe] = ACTIONS(2925),
    [anon_sym_sql] = ACTIONS(2925),
    [sym_int_literal] = ACTIONS(2925),
    [sym_float_literal] = ACTIONS(2923),
    [sym_rune_literal] = ACTIONS(2923),
    [anon_sym_SQUOTE] = ACTIONS(2923),
    [anon_sym_DQUOTE] = ACTIONS(2923),
    [anon_sym_c_SQUOTE] = ACTIONS(2923),
    [anon_sym_c_DQUOTE] = ACTIONS(2923),
    [anon_sym_r_SQUOTE] = ACTIONS(2923),
    [anon_sym_r_DQUOTE] = ACTIONS(2923),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2925),
    [anon_sym_shared] = ACTIONS(2925),
    [anon_sym_map_LBRACK] = ACTIONS(2923),
    [anon_sym_chan] = ACTIONS(2925),
    [anon_sym_thread] = ACTIONS(2925),
    [anon_sym_atomic] = ACTIONS(2925),
  },
  [1579] = {
    [sym_line_comment] = STATE(1579),
    [sym_block_comment] = STATE(1579),
    [sym_type_parameters] = STATE(4409),
    [sym_argument_list] = STATE(1682),
    [sym_or_block] = STATE(1683),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2051),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_DASH] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(4287),
    [anon_sym_SLASH] = ACTIONS(4289),
    [anon_sym_PERCENT] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2051),
    [anon_sym_GT_EQ] = ACTIONS(2051),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_RBRACK] = ACTIONS(2051),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2051),
    [anon_sym_DASH_DASH] = ACTIONS(2051),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4233),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2051),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_LBRACK2] = ACTIONS(4235),
    [anon_sym_TILDE] = ACTIONS(2051),
    [anon_sym_CARET] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(4289),
    [anon_sym_LT_DASH] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(4287),
    [anon_sym_GT_GT] = ACTIONS(4289),
    [anon_sym_GT_GT_GT] = ACTIONS(4287),
    [anon_sym_AMP_CARET] = ACTIONS(4287),
    [anon_sym_AMP_AMP] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(4237),
    [anon_sym_POUND_LBRACK] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2051),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2051),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2051),
    [sym_rune_literal] = ACTIONS(2051),
    [anon_sym_SQUOTE] = ACTIONS(2051),
    [anon_sym_DQUOTE] = ACTIONS(2051),
    [anon_sym_c_SQUOTE] = ACTIONS(2051),
    [anon_sym_c_DQUOTE] = ACTIONS(2051),
    [anon_sym_r_SQUOTE] = ACTIONS(2051),
    [anon_sym_r_DQUOTE] = ACTIONS(2051),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2051),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
  },
  [1580] = {
    [sym_line_comment] = STATE(1580),
    [sym_block_comment] = STATE(1580),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(2173),
    [anon_sym_DOT] = ACTIONS(2175),
    [anon_sym_as] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2180),
    [anon_sym_COMMA] = ACTIONS(2173),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(2173),
    [anon_sym_fn] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2173),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_PERCENT] = ACTIONS(2173),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_GT] = ACTIONS(2175),
    [anon_sym_EQ_EQ] = ACTIONS(2173),
    [anon_sym_BANG_EQ] = ACTIONS(2173),
    [anon_sym_LT_EQ] = ACTIONS(2173),
    [anon_sym_GT_EQ] = ACTIONS(2173),
    [anon_sym_LBRACK] = ACTIONS(2180),
    [anon_sym_RBRACK] = ACTIONS(2173),
    [anon_sym_struct] = ACTIONS(2175),
    [anon_sym_mut] = ACTIONS(2175),
    [anon_sym_COLON] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_QMARK] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_go] = ACTIONS(2175),
    [anon_sym_spawn] = ACTIONS(2175),
    [anon_sym_json_DOTdecode] = ACTIONS(2173),
    [anon_sym_PIPE] = ACTIONS(2175),
    [anon_sym_LBRACK2] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2175),
    [anon_sym_LT_DASH] = ACTIONS(2173),
    [anon_sym_LT_LT] = ACTIONS(2173),
    [anon_sym_GT_GT] = ACTIONS(2175),
    [anon_sym_GT_GT_GT] = ACTIONS(2173),
    [anon_sym_AMP_CARET] = ACTIONS(2173),
    [anon_sym_AMP_AMP] = ACTIONS(2173),
    [anon_sym_PIPE_PIPE] = ACTIONS(2173),
    [anon_sym_or] = ACTIONS(2175),
    [sym_none] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_nil] = ACTIONS(2175),
    [anon_sym_QMARK_DOT] = ACTIONS(2173),
    [anon_sym_POUND_LBRACK] = ACTIONS(2173),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_DOLLARif] = ACTIONS(2175),
    [anon_sym_is] = ACTIONS(2175),
    [anon_sym_BANGis] = ACTIONS(2173),
    [anon_sym_in] = ACTIONS(2175),
    [anon_sym_BANGin] = ACTIONS(2173),
    [anon_sym_match] = ACTIONS(2175),
    [anon_sym_select] = ACTIONS(2175),
    [anon_sym_lock] = ACTIONS(2175),
    [anon_sym_rlock] = ACTIONS(2175),
    [anon_sym_unsafe] = ACTIONS(2175),
    [anon_sym_sql] = ACTIONS(2175),
    [sym_int_literal] = ACTIONS(2175),
    [sym_float_literal] = ACTIONS(2173),
    [sym_rune_literal] = ACTIONS(2173),
    [anon_sym_SQUOTE] = ACTIONS(2173),
    [anon_sym_DQUOTE] = ACTIONS(2173),
    [anon_sym_c_SQUOTE] = ACTIONS(2173),
    [anon_sym_c_DQUOTE] = ACTIONS(2173),
    [anon_sym_r_SQUOTE] = ACTIONS(2173),
    [anon_sym_r_DQUOTE] = ACTIONS(2173),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2175),
    [anon_sym_shared] = ACTIONS(2175),
    [anon_sym_map_LBRACK] = ACTIONS(2173),
    [anon_sym_chan] = ACTIONS(2175),
    [anon_sym_thread] = ACTIONS(2175),
    [anon_sym_atomic] = ACTIONS(2175),
  },
  [1581] = {
    [sym_line_comment] = STATE(1581),
    [sym_block_comment] = STATE(1581),
    [sym_type_parameters] = STATE(4409),
    [sym_argument_list] = STATE(1682),
    [sym_or_block] = STATE(1683),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2051),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4287),
    [anon_sym_SLASH] = ACTIONS(4289),
    [anon_sym_PERCENT] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2051),
    [anon_sym_GT_EQ] = ACTIONS(2051),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_RBRACK] = ACTIONS(2051),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2051),
    [anon_sym_DASH_DASH] = ACTIONS(2051),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4233),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2051),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_LBRACK2] = ACTIONS(4235),
    [anon_sym_TILDE] = ACTIONS(2051),
    [anon_sym_CARET] = ACTIONS(4295),
    [anon_sym_AMP] = ACTIONS(4289),
    [anon_sym_LT_DASH] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(4287),
    [anon_sym_GT_GT] = ACTIONS(4289),
    [anon_sym_GT_GT_GT] = ACTIONS(4287),
    [anon_sym_AMP_CARET] = ACTIONS(4287),
    [anon_sym_AMP_AMP] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(4237),
    [anon_sym_POUND_LBRACK] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2051),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2051),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2051),
    [sym_rune_literal] = ACTIONS(2051),
    [anon_sym_SQUOTE] = ACTIONS(2051),
    [anon_sym_DQUOTE] = ACTIONS(2051),
    [anon_sym_c_SQUOTE] = ACTIONS(2051),
    [anon_sym_c_DQUOTE] = ACTIONS(2051),
    [anon_sym_r_SQUOTE] = ACTIONS(2051),
    [anon_sym_r_DQUOTE] = ACTIONS(2051),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2051),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
  },
  [1582] = {
    [sym_line_comment] = STATE(1582),
    [sym_block_comment] = STATE(1582),
    [aux_sym_strictly_expression_list_repeat1] = STATE(1924),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_LF] = ACTIONS(1995),
    [anon_sym_CR] = ACTIONS(1995),
    [anon_sym_CR_LF] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(2001),
    [anon_sym_fn] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1995),
    [anon_sym_struct] = ACTIONS(1995),
    [anon_sym_mut] = ACTIONS(1995),
    [anon_sym_QMARK] = ACTIONS(1995),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_go] = ACTIONS(1995),
    [anon_sym_spawn] = ACTIONS(1995),
    [anon_sym_json_DOTdecode] = ACTIONS(1995),
    [anon_sym_LBRACK2] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_LT_DASH] = ACTIONS(1995),
    [sym_none] = ACTIONS(1995),
    [sym_true] = ACTIONS(1995),
    [sym_false] = ACTIONS(1995),
    [sym_nil] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_DOLLARif] = ACTIONS(1995),
    [anon_sym_match] = ACTIONS(1995),
    [anon_sym_select] = ACTIONS(1995),
    [anon_sym_STAR_EQ] = ACTIONS(2001),
    [anon_sym_SLASH_EQ] = ACTIONS(2001),
    [anon_sym_PERCENT_EQ] = ACTIONS(2001),
    [anon_sym_LT_LT_EQ] = ACTIONS(2001),
    [anon_sym_GT_GT_EQ] = ACTIONS(2001),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2001),
    [anon_sym_AMP_EQ] = ACTIONS(2001),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2001),
    [anon_sym_PLUS_EQ] = ACTIONS(2001),
    [anon_sym_DASH_EQ] = ACTIONS(2001),
    [anon_sym_PIPE_EQ] = ACTIONS(2001),
    [anon_sym_CARET_EQ] = ACTIONS(2001),
    [anon_sym_COLON_EQ] = ACTIONS(2001),
    [anon_sym_lock] = ACTIONS(1995),
    [anon_sym_rlock] = ACTIONS(1995),
    [anon_sym_unsafe] = ACTIONS(1995),
    [anon_sym_sql] = ACTIONS(1995),
    [sym_int_literal] = ACTIONS(1995),
    [sym_float_literal] = ACTIONS(1995),
    [sym_rune_literal] = ACTIONS(1995),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_DQUOTE] = ACTIONS(1995),
    [anon_sym_c_SQUOTE] = ACTIONS(1995),
    [anon_sym_c_DQUOTE] = ACTIONS(1995),
    [anon_sym_r_SQUOTE] = ACTIONS(1995),
    [anon_sym_r_DQUOTE] = ACTIONS(1995),
    [sym_pseudo_compile_time_identifier] = ACTIONS(1995),
    [anon_sym_shared] = ACTIONS(1995),
    [anon_sym_map_LBRACK] = ACTIONS(1995),
    [anon_sym_chan] = ACTIONS(1995),
    [anon_sym_thread] = ACTIONS(1995),
    [anon_sym_atomic] = ACTIONS(1995),
    [anon_sym_assert] = ACTIONS(1995),
    [anon_sym_defer] = ACTIONS(1995),
    [anon_sym_goto] = ACTIONS(1995),
    [anon_sym_break] = ACTIONS(1995),
    [anon_sym_continue] = ACTIONS(1995),
    [anon_sym_return] = ACTIONS(1995),
    [anon_sym_DOLLARfor] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_POUND] = ACTIONS(1995),
    [anon_sym_asm] = ACTIONS(1995),
  },
  [1583] = {
    [sym_line_comment] = STATE(1583),
    [sym_block_comment] = STATE(1583),
    [sym_type_parameters] = STATE(4409),
    [sym_argument_list] = STATE(1682),
    [sym_or_block] = STATE(1683),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2051),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4287),
    [anon_sym_SLASH] = ACTIONS(4289),
    [anon_sym_PERCENT] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(4291),
    [anon_sym_GT] = ACTIONS(4291),
    [anon_sym_EQ_EQ] = ACTIONS(4293),
    [anon_sym_BANG_EQ] = ACTIONS(4293),
    [anon_sym_LT_EQ] = ACTIONS(4293),
    [anon_sym_GT_EQ] = ACTIONS(4293),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_RBRACK] = ACTIONS(2051),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2051),
    [anon_sym_DASH_DASH] = ACTIONS(2051),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4233),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2051),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_LBRACK2] = ACTIONS(4235),
    [anon_sym_TILDE] = ACTIONS(2051),
    [anon_sym_CARET] = ACTIONS(4295),
    [anon_sym_AMP] = ACTIONS(4289),
    [anon_sym_LT_DASH] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(4287),
    [anon_sym_GT_GT] = ACTIONS(4289),
    [anon_sym_GT_GT_GT] = ACTIONS(4287),
    [anon_sym_AMP_CARET] = ACTIONS(4287),
    [anon_sym_AMP_AMP] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(4237),
    [anon_sym_POUND_LBRACK] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2051),
    [anon_sym_in] = ACTIONS(4301),
    [anon_sym_BANGin] = ACTIONS(4303),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2051),
    [sym_rune_literal] = ACTIONS(2051),
    [anon_sym_SQUOTE] = ACTIONS(2051),
    [anon_sym_DQUOTE] = ACTIONS(2051),
    [anon_sym_c_SQUOTE] = ACTIONS(2051),
    [anon_sym_c_DQUOTE] = ACTIONS(2051),
    [anon_sym_r_SQUOTE] = ACTIONS(2051),
    [anon_sym_r_DQUOTE] = ACTIONS(2051),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2051),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
  },
  [1584] = {
    [sym_line_comment] = STATE(1584),
    [sym_block_comment] = STATE(1584),
    [sym_type_parameters] = STATE(4409),
    [sym_argument_list] = STATE(1682),
    [sym_or_block] = STATE(1683),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2051),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4287),
    [anon_sym_SLASH] = ACTIONS(4289),
    [anon_sym_PERCENT] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(4291),
    [anon_sym_GT] = ACTIONS(4291),
    [anon_sym_EQ_EQ] = ACTIONS(4293),
    [anon_sym_BANG_EQ] = ACTIONS(4293),
    [anon_sym_LT_EQ] = ACTIONS(4293),
    [anon_sym_GT_EQ] = ACTIONS(4293),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_RBRACK] = ACTIONS(2051),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2051),
    [anon_sym_DASH_DASH] = ACTIONS(2051),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4233),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2051),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_LBRACK2] = ACTIONS(4235),
    [anon_sym_TILDE] = ACTIONS(2051),
    [anon_sym_CARET] = ACTIONS(4295),
    [anon_sym_AMP] = ACTIONS(4289),
    [anon_sym_LT_DASH] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(4287),
    [anon_sym_GT_GT] = ACTIONS(4289),
    [anon_sym_GT_GT_GT] = ACTIONS(4287),
    [anon_sym_AMP_CARET] = ACTIONS(4287),
    [anon_sym_AMP_AMP] = ACTIONS(4297),
    [anon_sym_PIPE_PIPE] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(4237),
    [anon_sym_POUND_LBRACK] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2051),
    [anon_sym_in] = ACTIONS(4301),
    [anon_sym_BANGin] = ACTIONS(4303),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2051),
    [sym_rune_literal] = ACTIONS(2051),
    [anon_sym_SQUOTE] = ACTIONS(2051),
    [anon_sym_DQUOTE] = ACTIONS(2051),
    [anon_sym_c_SQUOTE] = ACTIONS(2051),
    [anon_sym_c_DQUOTE] = ACTIONS(2051),
    [anon_sym_r_SQUOTE] = ACTIONS(2051),
    [anon_sym_r_DQUOTE] = ACTIONS(2051),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2051),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
  },
  [1585] = {
    [sym_line_comment] = STATE(1585),
    [sym_block_comment] = STATE(1585),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2145),
    [anon_sym_BANG_EQ] = ACTIONS(2145),
    [anon_sym_LT_EQ] = ACTIONS(2145),
    [anon_sym_GT_EQ] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_RBRACK] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_COLON] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2145),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2145),
    [anon_sym_LT_LT] = ACTIONS(2145),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2145),
    [anon_sym_AMP_CARET] = ACTIONS(2145),
    [anon_sym_AMP_AMP] = ACTIONS(2145),
    [anon_sym_PIPE_PIPE] = ACTIONS(2145),
    [anon_sym_or] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2145),
    [anon_sym_POUND_LBRACK] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_DOLLARelse] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2147),
    [anon_sym_BANGis] = ACTIONS(2145),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANGin] = ACTIONS(2145),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2145),
    [sym_rune_literal] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_c_SQUOTE] = ACTIONS(2145),
    [anon_sym_c_DQUOTE] = ACTIONS(2145),
    [anon_sym_r_SQUOTE] = ACTIONS(2145),
    [anon_sym_r_DQUOTE] = ACTIONS(2145),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2145),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
  },
  [1586] = {
    [sym_line_comment] = STATE(1586),
    [sym_block_comment] = STATE(1586),
    [sym_type_parameters] = STATE(4409),
    [sym_argument_list] = STATE(1682),
    [sym_or_block] = STATE(1683),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2051),
    [anon_sym_RBRACE] = ACTIONS(2051),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_DASH] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(4251),
    [anon_sym_SLASH] = ACTIONS(4253),
    [anon_sym_PERCENT] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2051),
    [anon_sym_GT_EQ] = ACTIONS(2051),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_COLON] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(2051),
    [anon_sym_DASH_DASH] = ACTIONS(2051),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4233),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2051),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_LBRACK2] = ACTIONS(4235),
    [anon_sym_TILDE] = ACTIONS(2051),
    [anon_sym_CARET] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(4253),
    [anon_sym_LT_DASH] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(4251),
    [anon_sym_GT_GT] = ACTIONS(4253),
    [anon_sym_GT_GT_GT] = ACTIONS(4251),
    [anon_sym_AMP_CARET] = ACTIONS(4251),
    [anon_sym_AMP_AMP] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(4237),
    [anon_sym_POUND_LBRACK] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2051),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2051),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2051),
    [sym_rune_literal] = ACTIONS(2051),
    [anon_sym_SQUOTE] = ACTIONS(2051),
    [anon_sym_DQUOTE] = ACTIONS(2051),
    [anon_sym_c_SQUOTE] = ACTIONS(2051),
    [anon_sym_c_DQUOTE] = ACTIONS(2051),
    [anon_sym_r_SQUOTE] = ACTIONS(2051),
    [anon_sym_r_DQUOTE] = ACTIONS(2051),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2051),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
  },
  [1587] = {
    [sym_line_comment] = STATE(1587),
    [sym_block_comment] = STATE(1587),
    [sym_type_parameters] = STATE(4409),
    [sym_argument_list] = STATE(1682),
    [sym_or_block] = STATE(1683),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2051),
    [anon_sym_RBRACE] = ACTIONS(2051),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(4249),
    [anon_sym_DASH] = ACTIONS(4249),
    [anon_sym_STAR] = ACTIONS(4251),
    [anon_sym_SLASH] = ACTIONS(4253),
    [anon_sym_PERCENT] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2051),
    [anon_sym_GT_EQ] = ACTIONS(2051),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_COLON] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(2051),
    [anon_sym_DASH_DASH] = ACTIONS(2051),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4233),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2051),
    [anon_sym_PIPE] = ACTIONS(4249),
    [anon_sym_LBRACK2] = ACTIONS(4235),
    [anon_sym_TILDE] = ACTIONS(2051),
    [anon_sym_CARET] = ACTIONS(4265),
    [anon_sym_AMP] = ACTIONS(4253),
    [anon_sym_LT_DASH] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(4251),
    [anon_sym_GT_GT] = ACTIONS(4253),
    [anon_sym_GT_GT_GT] = ACTIONS(4251),
    [anon_sym_AMP_CARET] = ACTIONS(4251),
    [anon_sym_AMP_AMP] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(4237),
    [anon_sym_POUND_LBRACK] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2051),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_BANGin] = ACTIONS(2051),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2051),
    [sym_rune_literal] = ACTIONS(2051),
    [anon_sym_SQUOTE] = ACTIONS(2051),
    [anon_sym_DQUOTE] = ACTIONS(2051),
    [anon_sym_c_SQUOTE] = ACTIONS(2051),
    [anon_sym_c_DQUOTE] = ACTIONS(2051),
    [anon_sym_r_SQUOTE] = ACTIONS(2051),
    [anon_sym_r_DQUOTE] = ACTIONS(2051),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2051),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
  },
  [1588] = {
    [sym_line_comment] = STATE(1588),
    [sym_block_comment] = STATE(1588),
    [sym_type_parameters] = STATE(4409),
    [sym_argument_list] = STATE(1682),
    [sym_or_block] = STATE(1683),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2051),
    [anon_sym_RBRACE] = ACTIONS(2051),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(4249),
    [anon_sym_DASH] = ACTIONS(4249),
    [anon_sym_STAR] = ACTIONS(4251),
    [anon_sym_SLASH] = ACTIONS(4253),
    [anon_sym_PERCENT] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(4255),
    [anon_sym_GT] = ACTIONS(4255),
    [anon_sym_EQ_EQ] = ACTIONS(4257),
    [anon_sym_BANG_EQ] = ACTIONS(4257),
    [anon_sym_LT_EQ] = ACTIONS(4257),
    [anon_sym_GT_EQ] = ACTIONS(4257),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_COLON] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(2051),
    [anon_sym_DASH_DASH] = ACTIONS(2051),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4233),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2051),
    [anon_sym_PIPE] = ACTIONS(4249),
    [anon_sym_LBRACK2] = ACTIONS(4235),
    [anon_sym_TILDE] = ACTIONS(2051),
    [anon_sym_CARET] = ACTIONS(4265),
    [anon_sym_AMP] = ACTIONS(4253),
    [anon_sym_LT_DASH] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(4251),
    [anon_sym_GT_GT] = ACTIONS(4253),
    [anon_sym_GT_GT_GT] = ACTIONS(4251),
    [anon_sym_AMP_CARET] = ACTIONS(4251),
    [anon_sym_AMP_AMP] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(4237),
    [anon_sym_POUND_LBRACK] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2051),
    [anon_sym_in] = ACTIONS(4277),
    [anon_sym_BANGin] = ACTIONS(4279),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2051),
    [sym_rune_literal] = ACTIONS(2051),
    [anon_sym_SQUOTE] = ACTIONS(2051),
    [anon_sym_DQUOTE] = ACTIONS(2051),
    [anon_sym_c_SQUOTE] = ACTIONS(2051),
    [anon_sym_c_DQUOTE] = ACTIONS(2051),
    [anon_sym_r_SQUOTE] = ACTIONS(2051),
    [anon_sym_r_DQUOTE] = ACTIONS(2051),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2051),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
  },
  [1589] = {
    [sym_line_comment] = STATE(1589),
    [sym_block_comment] = STATE(1589),
    [sym_type_parameters] = STATE(4409),
    [sym_argument_list] = STATE(1682),
    [sym_or_block] = STATE(1683),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2051),
    [anon_sym_RBRACE] = ACTIONS(2051),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_fn] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(4249),
    [anon_sym_DASH] = ACTIONS(4249),
    [anon_sym_STAR] = ACTIONS(4251),
    [anon_sym_SLASH] = ACTIONS(4253),
    [anon_sym_PERCENT] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(4255),
    [anon_sym_GT] = ACTIONS(4255),
    [anon_sym_EQ_EQ] = ACTIONS(4257),
    [anon_sym_BANG_EQ] = ACTIONS(4257),
    [anon_sym_LT_EQ] = ACTIONS(4257),
    [anon_sym_GT_EQ] = ACTIONS(4257),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_struct] = ACTIONS(2053),
    [anon_sym_mut] = ACTIONS(2053),
    [anon_sym_COLON] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(2051),
    [anon_sym_DASH_DASH] = ACTIONS(2051),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4233),
    [anon_sym_go] = ACTIONS(2053),
    [anon_sym_spawn] = ACTIONS(2053),
    [anon_sym_json_DOTdecode] = ACTIONS(2051),
    [anon_sym_PIPE] = ACTIONS(4249),
    [anon_sym_LBRACK2] = ACTIONS(4235),
    [anon_sym_TILDE] = ACTIONS(2051),
    [anon_sym_CARET] = ACTIONS(4265),
    [anon_sym_AMP] = ACTIONS(4253),
    [anon_sym_LT_DASH] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(4251),
    [anon_sym_GT_GT] = ACTIONS(4253),
    [anon_sym_GT_GT_GT] = ACTIONS(4251),
    [anon_sym_AMP_CARET] = ACTIONS(4251),
    [anon_sym_AMP_AMP] = ACTIONS(4267),
    [anon_sym_PIPE_PIPE] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2053),
    [sym_none] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_nil] = ACTIONS(2053),
    [anon_sym_QMARK_DOT] = ACTIONS(4237),
    [anon_sym_POUND_LBRACK] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_DOLLARif] = ACTIONS(2053),
    [anon_sym_is] = ACTIONS(2053),
    [anon_sym_BANGis] = ACTIONS(2051),
    [anon_sym_in] = ACTIONS(4277),
    [anon_sym_BANGin] = ACTIONS(4279),
    [anon_sym_match] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_lock] = ACTIONS(2053),
    [anon_sym_rlock] = ACTIONS(2053),
    [anon_sym_unsafe] = ACTIONS(2053),
    [anon_sym_sql] = ACTIONS(2053),
    [sym_int_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2051),
    [sym_rune_literal] = ACTIONS(2051),
    [anon_sym_SQUOTE] = ACTIONS(2051),
    [anon_sym_DQUOTE] = ACTIONS(2051),
    [anon_sym_c_SQUOTE] = ACTIONS(2051),
    [anon_sym_c_DQUOTE] = ACTIONS(2051),
    [anon_sym_r_SQUOTE] = ACTIONS(2051),
    [anon_sym_r_DQUOTE] = ACTIONS(2051),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2053),
    [anon_sym_shared] = ACTIONS(2053),
    [anon_sym_map_LBRACK] = ACTIONS(2051),
    [anon_sym_chan] = ACTIONS(2053),
    [anon_sym_thread] = ACTIONS(2053),
    [anon_sym_atomic] = ACTIONS(2053),
  },
  [1590] = {
    [sym_line_comment] = STATE(1590),
    [sym_block_comment] = STATE(1590),
    [sym_type_parameters] = STATE(4409),
    [sym_argument_list] = STATE(1682),
    [sym_or_block] = STATE(1683),
    [sym_identifier] = ACTIONS(2049),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_COMMA] = ACTIONS(2047),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_fn] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4287),
    [anon_sym_SLASH] = ACTIONS(4289),
    [anon_sym_PERCENT] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_EQ_EQ] = ACTIONS(2047),
    [anon_sym_BANG_EQ] = ACTIONS(2047),
    [anon_sym_LT_EQ] = ACTIONS(2047),
    [anon_sym_GT_EQ] = ACTIONS(2047),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_RBRACK] = ACTIONS(2047),
    [anon_sym_struct] = ACTIONS(2049),
    [anon_sym_mut] = ACTIONS(2049),
    [anon_sym_PLUS_PLUS] = ACTIONS(2047),
    [anon_sym_DASH_DASH] = ACTIONS(2047),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4233),
    [anon_sym_go] = ACTIONS(2049),
    [anon_sym_spawn] = ACTIONS(2049),
    [anon_sym_json_DOTdecode] = ACTIONS(2047),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_LBRACK2] = ACTIONS(4235),
    [anon_sym_TILDE] = ACTIONS(2047),
    [anon_sym_CARET] = ACTIONS(4295),
    [anon_sym_AMP] = ACTIONS(4289),
    [anon_sym_LT_DASH] = ACTIONS(2047),
    [anon_sym_LT_LT] = ACTIONS(4287),
    [anon_sym_GT_GT] = ACTIONS(4289),
    [anon_sym_GT_GT_GT] = ACTIONS(4287),
    [anon_sym_AMP_CARET] = ACTIONS(4287),
    [anon_sym_AMP_AMP] = ACTIONS(2047),
    [anon_sym_PIPE_PIPE] = ACTIONS(2047),
    [anon_sym_or] = ACTIONS(2049),
    [sym_none] = ACTIONS(2049),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [sym_nil] = ACTIONS(2049),
    [anon_sym_QMARK_DOT] = ACTIONS(4237),
    [anon_sym_POUND_LBRACK] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(2049),
    [anon_sym_DOLLARif] = ACTIONS(2049),
    [anon_sym_is] = ACTIONS(2049),
    [anon_sym_BANGis] = ACTIONS(2047),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_BANGin] = ACTIONS(2047),
    [anon_sym_match] = ACTIONS(2049),
    [anon_sym_select] = ACTIONS(2049),
    [anon_sym_lock] = ACTIONS(2049),
    [anon_sym_rlock] = ACTIONS(2049),
    [anon_sym_unsafe] = ACTIONS(2049),
    [anon_sym_sql] = ACTIONS(2049),
    [sym_int_literal] = ACTIONS(2049),
    [sym_float_literal] = ACTIONS(2047),
    [sym_rune_literal] = ACTIONS(2047),
    [anon_sym_SQUOTE] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [anon_sym_c_SQUOTE] = ACTIONS(2047),
    [anon_sym_c_DQUOTE] = ACTIONS(2047),
    [anon_sym_r_SQUOTE] = ACTIONS(2047),
    [anon_sym_r_DQUOTE] = ACTIONS(2047),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2049),
    [anon_sym_shared] = ACTIONS(2049),
    [anon_sym_map_LBRACK] = ACTIONS(2047),
    [anon_sym_chan] = ACTIONS(2049),
    [anon_sym_thread] = ACTIONS(2049),
    [anon_sym_atomic] = ACTIONS(2049),
  },
  [1591] = {
    [sym_line_comment] = STATE(1591),
    [sym_block_comment] = STATE(1591),
    [sym_identifier] = ACTIONS(2849),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2849),
    [anon_sym_as] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_COMMA] = ACTIONS(2847),
    [anon_sym_RBRACE] = ACTIONS(2847),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_fn] = ACTIONS(2849),
    [anon_sym_PLUS] = ACTIONS(2849),
    [anon_sym_DASH] = ACTIONS(2849),
    [anon_sym_STAR] = ACTIONS(2847),
    [anon_sym_SLASH] = ACTIONS(2849),
    [anon_sym_PERCENT] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_GT] = ACTIONS(2849),
    [anon_sym_EQ_EQ] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_LT_EQ] = ACTIONS(2847),
    [anon_sym_GT_EQ] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_RBRACK] = ACTIONS(2847),
    [anon_sym_struct] = ACTIONS(2849),
    [anon_sym_mut] = ACTIONS(2849),
    [anon_sym_COLON] = ACTIONS(2847),
    [anon_sym_PLUS_PLUS] = ACTIONS(2847),
    [anon_sym_DASH_DASH] = ACTIONS(2847),
    [anon_sym_QMARK] = ACTIONS(2849),
    [anon_sym_BANG] = ACTIONS(2849),
    [anon_sym_go] = ACTIONS(2849),
    [anon_sym_spawn] = ACTIONS(2849),
    [anon_sym_json_DOTdecode] = ACTIONS(2847),
    [anon_sym_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACK2] = ACTIONS(2849),
    [anon_sym_TILDE] = ACTIONS(2847),
    [anon_sym_CARET] = ACTIONS(2847),
    [anon_sym_AMP] = ACTIONS(2849),
    [anon_sym_LT_DASH] = ACTIONS(2847),
    [anon_sym_LT_LT] = ACTIONS(2847),
    [anon_sym_GT_GT] = ACTIONS(2849),
    [anon_sym_GT_GT_GT] = ACTIONS(2847),
    [anon_sym_AMP_CARET] = ACTIONS(2847),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_or] = ACTIONS(2849),
    [sym_none] = ACTIONS(2849),
    [sym_true] = ACTIONS(2849),
    [sym_false] = ACTIONS(2849),
    [sym_nil] = ACTIONS(2849),
    [anon_sym_QMARK_DOT] = ACTIONS(2847),
    [anon_sym_POUND_LBRACK] = ACTIONS(2847),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_DOLLARif] = ACTIONS(2849),
    [anon_sym_is] = ACTIONS(2849),
    [anon_sym_BANGis] = ACTIONS(2847),
    [anon_sym_in] = ACTIONS(2849),
    [anon_sym_BANGin] = ACTIONS(2847),
    [anon_sym_match] = ACTIONS(2849),
    [anon_sym_select] = ACTIONS(2849),
    [anon_sym_lock] = ACTIONS(2849),
    [anon_sym_rlock] = ACTIONS(2849),
    [anon_sym_unsafe] = ACTIONS(2849),
    [anon_sym_sql] = ACTIONS(2849),
    [sym_int_literal] = ACTIONS(2849),
    [sym_float_literal] = ACTIONS(2847),
    [sym_rune_literal] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [anon_sym_c_SQUOTE] = ACTIONS(2847),
    [anon_sym_c_DQUOTE] = ACTIONS(2847),
    [anon_sym_r_SQUOTE] = ACTIONS(2847),
    [anon_sym_r_DQUOTE] = ACTIONS(2847),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2849),
    [anon_sym_shared] = ACTIONS(2849),
    [anon_sym_map_LBRACK] = ACTIONS(2847),
    [anon_sym_chan] = ACTIONS(2849),
    [anon_sym_thread] = ACTIONS(2849),
    [anon_sym_atomic] = ACTIONS(2849),
  },
  [1592] = {
    [sym_line_comment] = STATE(1592),
    [sym_block_comment] = STATE(1592),
    [sym_identifier] = ACTIONS(3332),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3332),
    [anon_sym_as] = ACTIONS(3332),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_COMMA] = ACTIONS(3330),
    [anon_sym_RBRACE] = ACTIONS(3330),
    [anon_sym_LPAREN] = ACTIONS(3330),
    [anon_sym_fn] = ACTIONS(3332),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_DASH] = ACTIONS(3332),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_SLASH] = ACTIONS(3332),
    [anon_sym_PERCENT] = ACTIONS(3330),
    [anon_sym_LT] = ACTIONS(3332),
    [anon_sym_GT] = ACTIONS(3332),
    [anon_sym_EQ_EQ] = ACTIONS(3330),
    [anon_sym_BANG_EQ] = ACTIONS(3330),
    [anon_sym_LT_EQ] = ACTIONS(3330),
    [anon_sym_GT_EQ] = ACTIONS(3330),
    [anon_sym_LBRACK] = ACTIONS(3330),
    [anon_sym_RBRACK] = ACTIONS(3330),
    [anon_sym_struct] = ACTIONS(3332),
    [anon_sym_mut] = ACTIONS(3332),
    [anon_sym_COLON] = ACTIONS(3330),
    [anon_sym_PLUS_PLUS] = ACTIONS(3330),
    [anon_sym_DASH_DASH] = ACTIONS(3330),
    [anon_sym_QMARK] = ACTIONS(3332),
    [anon_sym_BANG] = ACTIONS(3332),
    [anon_sym_go] = ACTIONS(3332),
    [anon_sym_spawn] = ACTIONS(3332),
    [anon_sym_json_DOTdecode] = ACTIONS(3330),
    [anon_sym_PIPE] = ACTIONS(3332),
    [anon_sym_LBRACK2] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3330),
    [anon_sym_CARET] = ACTIONS(3330),
    [anon_sym_AMP] = ACTIONS(3332),
    [anon_sym_LT_DASH] = ACTIONS(3330),
    [anon_sym_LT_LT] = ACTIONS(3330),
    [anon_sym_GT_GT] = ACTIONS(3332),
    [anon_sym_GT_GT_GT] = ACTIONS(3330),
    [anon_sym_AMP_CARET] = ACTIONS(3330),
    [anon_sym_AMP_AMP] = ACTIONS(3330),
    [anon_sym_PIPE_PIPE] = ACTIONS(3330),
    [anon_sym_or] = ACTIONS(3332),
    [sym_none] = ACTIONS(3332),
    [sym_true] = ACTIONS(3332),
    [sym_false] = ACTIONS(3332),
    [sym_nil] = ACTIONS(3332),
    [anon_sym_QMARK_DOT] = ACTIONS(3330),
    [anon_sym_POUND_LBRACK] = ACTIONS(3330),
    [anon_sym_if] = ACTIONS(3332),
    [anon_sym_DOLLARif] = ACTIONS(3332),
    [anon_sym_is] = ACTIONS(3332),
    [anon_sym_BANGis] = ACTIONS(3330),
    [anon_sym_in] = ACTIONS(3332),
    [anon_sym_BANGin] = ACTIONS(3330),
    [anon_sym_match] = ACTIONS(3332),
    [anon_sym_select] = ACTIONS(3332),
    [anon_sym_lock] = ACTIONS(3332),
    [anon_sym_rlock] = ACTIONS(3332),
    [anon_sym_unsafe] = ACTIONS(3332),
    [anon_sym_sql] = ACTIONS(3332),
    [sym_int_literal] = ACTIONS(3332),
    [sym_float_literal] = ACTIONS(3330),
    [sym_rune_literal] = ACTIONS(3330),
    [anon_sym_SQUOTE] = ACTIONS(3330),
    [anon_sym_DQUOTE] = ACTIONS(3330),
    [anon_sym_c_SQUOTE] = ACTIONS(3330),
    [anon_sym_c_DQUOTE] = ACTIONS(3330),
    [anon_sym_r_SQUOTE] = ACTIONS(3330),
    [anon_sym_r_DQUOTE] = ACTIONS(3330),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3332),
    [anon_sym_shared] = ACTIONS(3332),
    [anon_sym_map_LBRACK] = ACTIONS(3330),
    [anon_sym_chan] = ACTIONS(3332),
    [anon_sym_thread] = ACTIONS(3332),
    [anon_sym_atomic] = ACTIONS(3332),
  },
  [1593] = {
    [sym_line_comment] = STATE(1593),
    [sym_block_comment] = STATE(1593),
    [sym_identifier] = ACTIONS(3286),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3286),
    [anon_sym_as] = ACTIONS(3286),
    [anon_sym_LBRACE] = ACTIONS(3284),
    [anon_sym_COMMA] = ACTIONS(3284),
    [anon_sym_RBRACE] = ACTIONS(3284),
    [anon_sym_LPAREN] = ACTIONS(3284),
    [anon_sym_fn] = ACTIONS(3286),
    [anon_sym_PLUS] = ACTIONS(3286),
    [anon_sym_DASH] = ACTIONS(3286),
    [anon_sym_STAR] = ACTIONS(3284),
    [anon_sym_SLASH] = ACTIONS(3286),
    [anon_sym_PERCENT] = ACTIONS(3284),
    [anon_sym_LT] = ACTIONS(3286),
    [anon_sym_GT] = ACTIONS(3286),
    [anon_sym_EQ_EQ] = ACTIONS(3284),
    [anon_sym_BANG_EQ] = ACTIONS(3284),
    [anon_sym_LT_EQ] = ACTIONS(3284),
    [anon_sym_GT_EQ] = ACTIONS(3284),
    [anon_sym_LBRACK] = ACTIONS(3284),
    [anon_sym_RBRACK] = ACTIONS(3284),
    [anon_sym_struct] = ACTIONS(3286),
    [anon_sym_mut] = ACTIONS(3286),
    [anon_sym_COLON] = ACTIONS(3284),
    [anon_sym_PLUS_PLUS] = ACTIONS(3284),
    [anon_sym_DASH_DASH] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3286),
    [anon_sym_BANG] = ACTIONS(3286),
    [anon_sym_go] = ACTIONS(3286),
    [anon_sym_spawn] = ACTIONS(3286),
    [anon_sym_json_DOTdecode] = ACTIONS(3284),
    [anon_sym_PIPE] = ACTIONS(3286),
    [anon_sym_LBRACK2] = ACTIONS(3286),
    [anon_sym_TILDE] = ACTIONS(3284),
    [anon_sym_CARET] = ACTIONS(3284),
    [anon_sym_AMP] = ACTIONS(3286),
    [anon_sym_LT_DASH] = ACTIONS(3284),
    [anon_sym_LT_LT] = ACTIONS(3284),
    [anon_sym_GT_GT] = ACTIONS(3286),
    [anon_sym_GT_GT_GT] = ACTIONS(3284),
    [anon_sym_AMP_CARET] = ACTIONS(3284),
    [anon_sym_AMP_AMP] = ACTIONS(3284),
    [anon_sym_PIPE_PIPE] = ACTIONS(3284),
    [anon_sym_or] = ACTIONS(3286),
    [sym_none] = ACTIONS(3286),
    [sym_true] = ACTIONS(3286),
    [sym_false] = ACTIONS(3286),
    [sym_nil] = ACTIONS(3286),
    [anon_sym_QMARK_DOT] = ACTIONS(3284),
    [anon_sym_POUND_LBRACK] = ACTIONS(3284),
    [anon_sym_if] = ACTIONS(3286),
    [anon_sym_DOLLARif] = ACTIONS(3286),
    [anon_sym_is] = ACTIONS(3286),
    [anon_sym_BANGis] = ACTIONS(3284),
    [anon_sym_in] = ACTIONS(3286),
    [anon_sym_BANGin] = ACTIONS(3284),
    [anon_sym_match] = ACTIONS(3286),
    [anon_sym_select] = ACTIONS(3286),
    [anon_sym_lock] = ACTIONS(3286),
    [anon_sym_rlock] = ACTIONS(3286),
    [anon_sym_unsafe] = ACTIONS(3286),
    [anon_sym_sql] = ACTIONS(3286),
    [sym_int_literal] = ACTIONS(3286),
    [sym_float_literal] = ACTIONS(3284),
    [sym_rune_literal] = ACTIONS(3284),
    [anon_sym_SQUOTE] = ACTIONS(3284),
    [anon_sym_DQUOTE] = ACTIONS(3284),
    [anon_sym_c_SQUOTE] = ACTIONS(3284),
    [anon_sym_c_DQUOTE] = ACTIONS(3284),
    [anon_sym_r_SQUOTE] = ACTIONS(3284),
    [anon_sym_r_DQUOTE] = ACTIONS(3284),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3286),
    [anon_sym_shared] = ACTIONS(3286),
    [anon_sym_map_LBRACK] = ACTIONS(3284),
    [anon_sym_chan] = ACTIONS(3286),
    [anon_sym_thread] = ACTIONS(3286),
    [anon_sym_atomic] = ACTIONS(3286),
  },
  [1594] = {
    [sym_line_comment] = STATE(1594),
    [sym_block_comment] = STATE(1594),
    [sym_identifier] = ACTIONS(3280),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3280),
    [anon_sym_as] = ACTIONS(3280),
    [anon_sym_LBRACE] = ACTIONS(3278),
    [anon_sym_COMMA] = ACTIONS(3278),
    [anon_sym_RBRACE] = ACTIONS(3278),
    [anon_sym_LPAREN] = ACTIONS(3278),
    [anon_sym_fn] = ACTIONS(3280),
    [anon_sym_PLUS] = ACTIONS(3280),
    [anon_sym_DASH] = ACTIONS(3280),
    [anon_sym_STAR] = ACTIONS(3278),
    [anon_sym_SLASH] = ACTIONS(3280),
    [anon_sym_PERCENT] = ACTIONS(3278),
    [anon_sym_LT] = ACTIONS(3280),
    [anon_sym_GT] = ACTIONS(3280),
    [anon_sym_EQ_EQ] = ACTIONS(3278),
    [anon_sym_BANG_EQ] = ACTIONS(3278),
    [anon_sym_LT_EQ] = ACTIONS(3278),
    [anon_sym_GT_EQ] = ACTIONS(3278),
    [anon_sym_LBRACK] = ACTIONS(3278),
    [anon_sym_RBRACK] = ACTIONS(3278),
    [anon_sym_struct] = ACTIONS(3280),
    [anon_sym_mut] = ACTIONS(3280),
    [anon_sym_COLON] = ACTIONS(3278),
    [anon_sym_PLUS_PLUS] = ACTIONS(3278),
    [anon_sym_DASH_DASH] = ACTIONS(3278),
    [anon_sym_QMARK] = ACTIONS(3280),
    [anon_sym_BANG] = ACTIONS(3280),
    [anon_sym_go] = ACTIONS(3280),
    [anon_sym_spawn] = ACTIONS(3280),
    [anon_sym_json_DOTdecode] = ACTIONS(3278),
    [anon_sym_PIPE] = ACTIONS(3280),
    [anon_sym_LBRACK2] = ACTIONS(3280),
    [anon_sym_TILDE] = ACTIONS(3278),
    [anon_sym_CARET] = ACTIONS(3278),
    [anon_sym_AMP] = ACTIONS(3280),
    [anon_sym_LT_DASH] = ACTIONS(3278),
    [anon_sym_LT_LT] = ACTIONS(3278),
    [anon_sym_GT_GT] = ACTIONS(3280),
    [anon_sym_GT_GT_GT] = ACTIONS(3278),
    [anon_sym_AMP_CARET] = ACTIONS(3278),
    [anon_sym_AMP_AMP] = ACTIONS(3278),
    [anon_sym_PIPE_PIPE] = ACTIONS(3278),
    [anon_sym_or] = ACTIONS(3280),
    [sym_none] = ACTIONS(3280),
    [sym_true] = ACTIONS(3280),
    [sym_false] = ACTIONS(3280),
    [sym_nil] = ACTIONS(3280),
    [anon_sym_QMARK_DOT] = ACTIONS(3278),
    [anon_sym_POUND_LBRACK] = ACTIONS(3278),
    [anon_sym_if] = ACTIONS(3280),
    [anon_sym_DOLLARif] = ACTIONS(3280),
    [anon_sym_is] = ACTIONS(3280),
    [anon_sym_BANGis] = ACTIONS(3278),
    [anon_sym_in] = ACTIONS(3280),
    [anon_sym_BANGin] = ACTIONS(3278),
    [anon_sym_match] = ACTIONS(3280),
    [anon_sym_select] = ACTIONS(3280),
    [anon_sym_lock] = ACTIONS(3280),
    [anon_sym_rlock] = ACTIONS(3280),
    [anon_sym_unsafe] = ACTIONS(3280),
    [anon_sym_sql] = ACTIONS(3280),
    [sym_int_literal] = ACTIONS(3280),
    [sym_float_literal] = ACTIONS(3278),
    [sym_rune_literal] = ACTIONS(3278),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [anon_sym_DQUOTE] = ACTIONS(3278),
    [anon_sym_c_SQUOTE] = ACTIONS(3278),
    [anon_sym_c_DQUOTE] = ACTIONS(3278),
    [anon_sym_r_SQUOTE] = ACTIONS(3278),
    [anon_sym_r_DQUOTE] = ACTIONS(3278),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3280),
    [anon_sym_shared] = ACTIONS(3280),
    [anon_sym_map_LBRACK] = ACTIONS(3278),
    [anon_sym_chan] = ACTIONS(3280),
    [anon_sym_thread] = ACTIONS(3280),
    [anon_sym_atomic] = ACTIONS(3280),
  },
  [1595] = {
    [sym_line_comment] = STATE(1595),
    [sym_block_comment] = STATE(1595),
    [sym_identifier] = ACTIONS(2335),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2335),
    [anon_sym_as] = ACTIONS(2335),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_COMMA] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2335),
    [anon_sym_PLUS] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2335),
    [anon_sym_STAR] = ACTIONS(2337),
    [anon_sym_SLASH] = ACTIONS(2335),
    [anon_sym_PERCENT] = ACTIONS(2337),
    [anon_sym_LT] = ACTIONS(2335),
    [anon_sym_GT] = ACTIONS(2335),
    [anon_sym_EQ_EQ] = ACTIONS(2337),
    [anon_sym_BANG_EQ] = ACTIONS(2337),
    [anon_sym_LT_EQ] = ACTIONS(2337),
    [anon_sym_GT_EQ] = ACTIONS(2337),
    [anon_sym_LBRACK] = ACTIONS(2337),
    [anon_sym_RBRACK] = ACTIONS(2337),
    [anon_sym_struct] = ACTIONS(2335),
    [anon_sym_mut] = ACTIONS(2335),
    [anon_sym_COLON] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2337),
    [anon_sym_DASH_DASH] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2335),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_go] = ACTIONS(2335),
    [anon_sym_spawn] = ACTIONS(2335),
    [anon_sym_json_DOTdecode] = ACTIONS(2337),
    [anon_sym_PIPE] = ACTIONS(2335),
    [anon_sym_LBRACK2] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(2337),
    [anon_sym_AMP] = ACTIONS(2335),
    [anon_sym_LT_DASH] = ACTIONS(2337),
    [anon_sym_LT_LT] = ACTIONS(2337),
    [anon_sym_GT_GT] = ACTIONS(2335),
    [anon_sym_GT_GT_GT] = ACTIONS(2337),
    [anon_sym_AMP_CARET] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2337),
    [anon_sym_PIPE_PIPE] = ACTIONS(2337),
    [anon_sym_or] = ACTIONS(2335),
    [sym_none] = ACTIONS(2335),
    [sym_true] = ACTIONS(2335),
    [sym_false] = ACTIONS(2335),
    [sym_nil] = ACTIONS(2335),
    [anon_sym_QMARK_DOT] = ACTIONS(2337),
    [anon_sym_POUND_LBRACK] = ACTIONS(2337),
    [anon_sym_if] = ACTIONS(2335),
    [anon_sym_DOLLARif] = ACTIONS(2335),
    [anon_sym_is] = ACTIONS(2335),
    [anon_sym_BANGis] = ACTIONS(2337),
    [anon_sym_in] = ACTIONS(2335),
    [anon_sym_BANGin] = ACTIONS(2337),
    [anon_sym_match] = ACTIONS(2335),
    [anon_sym_select] = ACTIONS(2335),
    [anon_sym_lock] = ACTIONS(2335),
    [anon_sym_rlock] = ACTIONS(2335),
    [anon_sym_unsafe] = ACTIONS(2335),
    [anon_sym_sql] = ACTIONS(2335),
    [sym_int_literal] = ACTIONS(2335),
    [sym_float_literal] = ACTIONS(2337),
    [sym_rune_literal] = ACTIONS(2337),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym_DQUOTE] = ACTIONS(2337),
    [anon_sym_c_SQUOTE] = ACTIONS(2337),
    [anon_sym_c_DQUOTE] = ACTIONS(2337),
    [anon_sym_r_SQUOTE] = ACTIONS(2337),
    [anon_sym_r_DQUOTE] = ACTIONS(2337),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2335),
    [anon_sym_shared] = ACTIONS(2335),
    [anon_sym_map_LBRACK] = ACTIONS(2337),
    [anon_sym_chan] = ACTIONS(2335),
    [anon_sym_thread] = ACTIONS(2335),
    [anon_sym_atomic] = ACTIONS(2335),
  },
  [1596] = {
    [sym_line_comment] = STATE(1596),
    [sym_block_comment] = STATE(1596),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2951),
    [anon_sym_as] = ACTIONS(2951),
    [anon_sym_LBRACE] = ACTIONS(2949),
    [anon_sym_COMMA] = ACTIONS(2949),
    [anon_sym_RBRACE] = ACTIONS(2949),
    [anon_sym_LPAREN] = ACTIONS(2949),
    [anon_sym_fn] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(2949),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2949),
    [anon_sym_LT] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2949),
    [anon_sym_BANG_EQ] = ACTIONS(2949),
    [anon_sym_LT_EQ] = ACTIONS(2949),
    [anon_sym_GT_EQ] = ACTIONS(2949),
    [anon_sym_LBRACK] = ACTIONS(2949),
    [anon_sym_RBRACK] = ACTIONS(2949),
    [anon_sym_struct] = ACTIONS(2951),
    [anon_sym_mut] = ACTIONS(2951),
    [anon_sym_COLON] = ACTIONS(2949),
    [anon_sym_PLUS_PLUS] = ACTIONS(2949),
    [anon_sym_DASH_DASH] = ACTIONS(2949),
    [anon_sym_QMARK] = ACTIONS(2951),
    [anon_sym_BANG] = ACTIONS(2951),
    [anon_sym_go] = ACTIONS(2951),
    [anon_sym_spawn] = ACTIONS(2951),
    [anon_sym_json_DOTdecode] = ACTIONS(2949),
    [anon_sym_PIPE] = ACTIONS(2951),
    [anon_sym_LBRACK2] = ACTIONS(2951),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_CARET] = ACTIONS(2949),
    [anon_sym_AMP] = ACTIONS(2951),
    [anon_sym_LT_DASH] = ACTIONS(2949),
    [anon_sym_LT_LT] = ACTIONS(2949),
    [anon_sym_GT_GT] = ACTIONS(2951),
    [anon_sym_GT_GT_GT] = ACTIONS(2949),
    [anon_sym_AMP_CARET] = ACTIONS(2949),
    [anon_sym_AMP_AMP] = ACTIONS(2949),
    [anon_sym_PIPE_PIPE] = ACTIONS(2949),
    [anon_sym_or] = ACTIONS(2951),
    [sym_none] = ACTIONS(2951),
    [sym_true] = ACTIONS(2951),
    [sym_false] = ACTIONS(2951),
    [sym_nil] = ACTIONS(2951),
    [anon_sym_QMARK_DOT] = ACTIONS(2949),
    [anon_sym_POUND_LBRACK] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_DOLLARif] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_BANGis] = ACTIONS(2949),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_BANGin] = ACTIONS(2949),
    [anon_sym_match] = ACTIONS(2951),
    [anon_sym_select] = ACTIONS(2951),
    [anon_sym_lock] = ACTIONS(2951),
    [anon_sym_rlock] = ACTIONS(2951),
    [anon_sym_unsafe] = ACTIONS(2951),
    [anon_sym_sql] = ACTIONS(2951),
    [sym_int_literal] = ACTIONS(2951),
    [sym_float_literal] = ACTIONS(2949),
    [sym_rune_literal] = ACTIONS(2949),
    [anon_sym_SQUOTE] = ACTIONS(2949),
    [anon_sym_DQUOTE] = ACTIONS(2949),
    [anon_sym_c_SQUOTE] = ACTIONS(2949),
    [anon_sym_c_DQUOTE] = ACTIONS(2949),
    [anon_sym_r_SQUOTE] = ACTIONS(2949),
    [anon_sym_r_DQUOTE] = ACTIONS(2949),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2951),
    [anon_sym_shared] = ACTIONS(2951),
    [anon_sym_map_LBRACK] = ACTIONS(2949),
    [anon_sym_chan] = ACTIONS(2951),
    [anon_sym_thread] = ACTIONS(2951),
    [anon_sym_atomic] = ACTIONS(2951),
  },
  [1597] = {
    [sym_line_comment] = STATE(1597),
    [sym_block_comment] = STATE(1597),
    [sym_identifier] = ACTIONS(2929),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2929),
    [anon_sym_as] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2927),
    [anon_sym_COMMA] = ACTIONS(2927),
    [anon_sym_RBRACE] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2927),
    [anon_sym_fn] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2927),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_PERCENT] = ACTIONS(2927),
    [anon_sym_LT] = ACTIONS(2929),
    [anon_sym_GT] = ACTIONS(2929),
    [anon_sym_EQ_EQ] = ACTIONS(2927),
    [anon_sym_BANG_EQ] = ACTIONS(2927),
    [anon_sym_LT_EQ] = ACTIONS(2927),
    [anon_sym_GT_EQ] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_RBRACK] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2929),
    [anon_sym_mut] = ACTIONS(2929),
    [anon_sym_COLON] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2927),
    [anon_sym_QMARK] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2929),
    [anon_sym_go] = ACTIONS(2929),
    [anon_sym_spawn] = ACTIONS(2929),
    [anon_sym_json_DOTdecode] = ACTIONS(2927),
    [anon_sym_PIPE] = ACTIONS(2929),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_CARET] = ACTIONS(2927),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_LT_DASH] = ACTIONS(2927),
    [anon_sym_LT_LT] = ACTIONS(2927),
    [anon_sym_GT_GT] = ACTIONS(2929),
    [anon_sym_GT_GT_GT] = ACTIONS(2927),
    [anon_sym_AMP_CARET] = ACTIONS(2927),
    [anon_sym_AMP_AMP] = ACTIONS(2927),
    [anon_sym_PIPE_PIPE] = ACTIONS(2927),
    [anon_sym_or] = ACTIONS(2929),
    [sym_none] = ACTIONS(2929),
    [sym_true] = ACTIONS(2929),
    [sym_false] = ACTIONS(2929),
    [sym_nil] = ACTIONS(2929),
    [anon_sym_QMARK_DOT] = ACTIONS(2927),
    [anon_sym_POUND_LBRACK] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2929),
    [anon_sym_DOLLARif] = ACTIONS(2929),
    [anon_sym_is] = ACTIONS(2929),
    [anon_sym_BANGis] = ACTIONS(2927),
    [anon_sym_in] = ACTIONS(2929),
    [anon_sym_BANGin] = ACTIONS(2927),
    [anon_sym_match] = ACTIONS(2929),
    [anon_sym_select] = ACTIONS(2929),
    [anon_sym_lock] = ACTIONS(2929),
    [anon_sym_rlock] = ACTIONS(2929),
    [anon_sym_unsafe] = ACTIONS(2929),
    [anon_sym_sql] = ACTIONS(2929),
    [sym_int_literal] = ACTIONS(2929),
    [sym_float_literal] = ACTIONS(2927),
    [sym_rune_literal] = ACTIONS(2927),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_DQUOTE] = ACTIONS(2927),
    [anon_sym_c_SQUOTE] = ACTIONS(2927),
    [anon_sym_c_DQUOTE] = ACTIONS(2927),
    [anon_sym_r_SQUOTE] = ACTIONS(2927),
    [anon_sym_r_DQUOTE] = ACTIONS(2927),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2929),
    [anon_sym_shared] = ACTIONS(2929),
    [anon_sym_map_LBRACK] = ACTIONS(2927),
    [anon_sym_chan] = ACTIONS(2929),
    [anon_sym_thread] = ACTIONS(2929),
    [anon_sym_atomic] = ACTIONS(2929),
  },
  [1598] = {
    [sym_line_comment] = STATE(1598),
    [sym_block_comment] = STATE(1598),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2881),
    [anon_sym_as] = ACTIONS(2881),
    [anon_sym_LBRACE] = ACTIONS(2879),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_RBRACE] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2879),
    [anon_sym_fn] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [anon_sym_STAR] = ACTIONS(2879),
    [anon_sym_SLASH] = ACTIONS(2881),
    [anon_sym_PERCENT] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2881),
    [anon_sym_GT] = ACTIONS(2881),
    [anon_sym_EQ_EQ] = ACTIONS(2879),
    [anon_sym_BANG_EQ] = ACTIONS(2879),
    [anon_sym_LT_EQ] = ACTIONS(2879),
    [anon_sym_GT_EQ] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_RBRACK] = ACTIONS(2879),
    [anon_sym_struct] = ACTIONS(2881),
    [anon_sym_mut] = ACTIONS(2881),
    [anon_sym_COLON] = ACTIONS(2879),
    [anon_sym_PLUS_PLUS] = ACTIONS(2879),
    [anon_sym_DASH_DASH] = ACTIONS(2879),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_go] = ACTIONS(2881),
    [anon_sym_spawn] = ACTIONS(2881),
    [anon_sym_json_DOTdecode] = ACTIONS(2879),
    [anon_sym_PIPE] = ACTIONS(2881),
    [anon_sym_LBRACK2] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2879),
    [anon_sym_CARET] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2881),
    [anon_sym_LT_DASH] = ACTIONS(2879),
    [anon_sym_LT_LT] = ACTIONS(2879),
    [anon_sym_GT_GT] = ACTIONS(2881),
    [anon_sym_GT_GT_GT] = ACTIONS(2879),
    [anon_sym_AMP_CARET] = ACTIONS(2879),
    [anon_sym_AMP_AMP] = ACTIONS(2879),
    [anon_sym_PIPE_PIPE] = ACTIONS(2879),
    [anon_sym_or] = ACTIONS(2881),
    [sym_none] = ACTIONS(2881),
    [sym_true] = ACTIONS(2881),
    [sym_false] = ACTIONS(2881),
    [sym_nil] = ACTIONS(2881),
    [anon_sym_QMARK_DOT] = ACTIONS(2879),
    [anon_sym_POUND_LBRACK] = ACTIONS(2879),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_DOLLARif] = ACTIONS(2881),
    [anon_sym_is] = ACTIONS(2881),
    [anon_sym_BANGis] = ACTIONS(2879),
    [anon_sym_in] = ACTIONS(2881),
    [anon_sym_BANGin] = ACTIONS(2879),
    [anon_sym_match] = ACTIONS(2881),
    [anon_sym_select] = ACTIONS(2881),
    [anon_sym_lock] = ACTIONS(2881),
    [anon_sym_rlock] = ACTIONS(2881),
    [anon_sym_unsafe] = ACTIONS(2881),
    [anon_sym_sql] = ACTIONS(2881),
    [sym_int_literal] = ACTIONS(2881),
    [sym_float_literal] = ACTIONS(2879),
    [sym_rune_literal] = ACTIONS(2879),
    [anon_sym_SQUOTE] = ACTIONS(2879),
    [anon_sym_DQUOTE] = ACTIONS(2879),
    [anon_sym_c_SQUOTE] = ACTIONS(2879),
    [anon_sym_c_DQUOTE] = ACTIONS(2879),
    [anon_sym_r_SQUOTE] = ACTIONS(2879),
    [anon_sym_r_DQUOTE] = ACTIONS(2879),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2881),
    [anon_sym_shared] = ACTIONS(2881),
    [anon_sym_map_LBRACK] = ACTIONS(2879),
    [anon_sym_chan] = ACTIONS(2881),
    [anon_sym_thread] = ACTIONS(2881),
    [anon_sym_atomic] = ACTIONS(2881),
  },
  [1599] = {
    [sym_line_comment] = STATE(1599),
    [sym_block_comment] = STATE(1599),
    [sym_identifier] = ACTIONS(2383),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2383),
    [anon_sym_as] = ACTIONS(2383),
    [anon_sym_LBRACE] = ACTIONS(2381),
    [anon_sym_COMMA] = ACTIONS(2381),
    [anon_sym_RBRACE] = ACTIONS(2381),
    [anon_sym_LPAREN] = ACTIONS(2381),
    [anon_sym_fn] = ACTIONS(2383),
    [anon_sym_PLUS] = ACTIONS(2383),
    [anon_sym_DASH] = ACTIONS(2383),
    [anon_sym_STAR] = ACTIONS(2381),
    [anon_sym_SLASH] = ACTIONS(2383),
    [anon_sym_PERCENT] = ACTIONS(2381),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_GT] = ACTIONS(2383),
    [anon_sym_EQ_EQ] = ACTIONS(2381),
    [anon_sym_BANG_EQ] = ACTIONS(2381),
    [anon_sym_LT_EQ] = ACTIONS(2381),
    [anon_sym_GT_EQ] = ACTIONS(2381),
    [anon_sym_LBRACK] = ACTIONS(2381),
    [anon_sym_RBRACK] = ACTIONS(2381),
    [anon_sym_struct] = ACTIONS(2383),
    [anon_sym_mut] = ACTIONS(2383),
    [anon_sym_COLON] = ACTIONS(2381),
    [anon_sym_PLUS_PLUS] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(2381),
    [anon_sym_QMARK] = ACTIONS(2383),
    [anon_sym_BANG] = ACTIONS(2383),
    [anon_sym_go] = ACTIONS(2383),
    [anon_sym_spawn] = ACTIONS(2383),
    [anon_sym_json_DOTdecode] = ACTIONS(2381),
    [anon_sym_PIPE] = ACTIONS(2383),
    [anon_sym_LBRACK2] = ACTIONS(2383),
    [anon_sym_TILDE] = ACTIONS(2381),
    [anon_sym_CARET] = ACTIONS(2381),
    [anon_sym_AMP] = ACTIONS(2383),
    [anon_sym_LT_DASH] = ACTIONS(2381),
    [anon_sym_LT_LT] = ACTIONS(2381),
    [anon_sym_GT_GT] = ACTIONS(2383),
    [anon_sym_GT_GT_GT] = ACTIONS(2381),
    [anon_sym_AMP_CARET] = ACTIONS(2381),
    [anon_sym_AMP_AMP] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(2381),
    [anon_sym_or] = ACTIONS(2383),
    [sym_none] = ACTIONS(2383),
    [sym_true] = ACTIONS(2383),
    [sym_false] = ACTIONS(2383),
    [sym_nil] = ACTIONS(2383),
    [anon_sym_QMARK_DOT] = ACTIONS(2381),
    [anon_sym_POUND_LBRACK] = ACTIONS(2381),
    [anon_sym_if] = ACTIONS(2383),
    [anon_sym_DOLLARif] = ACTIONS(2383),
    [anon_sym_is] = ACTIONS(2383),
    [anon_sym_BANGis] = ACTIONS(2381),
    [anon_sym_in] = ACTIONS(2383),
    [anon_sym_BANGin] = ACTIONS(2381),
    [anon_sym_match] = ACTIONS(2383),
    [anon_sym_select] = ACTIONS(2383),
    [anon_sym_lock] = ACTIONS(2383),
    [anon_sym_rlock] = ACTIONS(2383),
    [anon_sym_unsafe] = ACTIONS(2383),
    [anon_sym_sql] = ACTIONS(2383),
    [sym_int_literal] = ACTIONS(2383),
    [sym_float_literal] = ACTIONS(2381),
    [sym_rune_literal] = ACTIONS(2381),
    [anon_sym_SQUOTE] = ACTIONS(2381),
    [anon_sym_DQUOTE] = ACTIONS(2381),
    [anon_sym_c_SQUOTE] = ACTIONS(2381),
    [anon_sym_c_DQUOTE] = ACTIONS(2381),
    [anon_sym_r_SQUOTE] = ACTIONS(2381),
    [anon_sym_r_DQUOTE] = ACTIONS(2381),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2383),
    [anon_sym_shared] = ACTIONS(2383),
    [anon_sym_map_LBRACK] = ACTIONS(2381),
    [anon_sym_chan] = ACTIONS(2383),
    [anon_sym_thread] = ACTIONS(2383),
    [anon_sym_atomic] = ACTIONS(2383),
  },
  [1600] = {
    [sym_line_comment] = STATE(1600),
    [sym_block_comment] = STATE(1600),
    [sym_identifier] = ACTIONS(2639),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2639),
    [anon_sym_as] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2637),
    [anon_sym_COMMA] = ACTIONS(2637),
    [anon_sym_RBRACE] = ACTIONS(2637),
    [anon_sym_LPAREN] = ACTIONS(2637),
    [anon_sym_fn] = ACTIONS(2639),
    [anon_sym_PLUS] = ACTIONS(2639),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2637),
    [anon_sym_SLASH] = ACTIONS(2639),
    [anon_sym_PERCENT] = ACTIONS(2637),
    [anon_sym_LT] = ACTIONS(2639),
    [anon_sym_GT] = ACTIONS(2639),
    [anon_sym_EQ_EQ] = ACTIONS(2637),
    [anon_sym_BANG_EQ] = ACTIONS(2637),
    [anon_sym_LT_EQ] = ACTIONS(2637),
    [anon_sym_GT_EQ] = ACTIONS(2637),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_RBRACK] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_mut] = ACTIONS(2639),
    [anon_sym_COLON] = ACTIONS(2637),
    [anon_sym_PLUS_PLUS] = ACTIONS(2637),
    [anon_sym_DASH_DASH] = ACTIONS(2637),
    [anon_sym_QMARK] = ACTIONS(2639),
    [anon_sym_BANG] = ACTIONS(2639),
    [anon_sym_go] = ACTIONS(2639),
    [anon_sym_spawn] = ACTIONS(2639),
    [anon_sym_json_DOTdecode] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_LBRACK2] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2637),
    [anon_sym_CARET] = ACTIONS(2637),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_LT_DASH] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(2637),
    [anon_sym_GT_GT] = ACTIONS(2639),
    [anon_sym_GT_GT_GT] = ACTIONS(2637),
    [anon_sym_AMP_CARET] = ACTIONS(2637),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE_PIPE] = ACTIONS(2637),
    [anon_sym_or] = ACTIONS(2639),
    [sym_none] = ACTIONS(2639),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [sym_nil] = ACTIONS(2639),
    [anon_sym_QMARK_DOT] = ACTIONS(2637),
    [anon_sym_POUND_LBRACK] = ACTIONS(2637),
    [anon_sym_if] = ACTIONS(2639),
    [anon_sym_DOLLARif] = ACTIONS(2639),
    [anon_sym_is] = ACTIONS(2639),
    [anon_sym_BANGis] = ACTIONS(2637),
    [anon_sym_in] = ACTIONS(2639),
    [anon_sym_BANGin] = ACTIONS(2637),
    [anon_sym_match] = ACTIONS(2639),
    [anon_sym_select] = ACTIONS(2639),
    [anon_sym_lock] = ACTIONS(2639),
    [anon_sym_rlock] = ACTIONS(2639),
    [anon_sym_unsafe] = ACTIONS(2639),
    [anon_sym_sql] = ACTIONS(2639),
    [sym_int_literal] = ACTIONS(2639),
    [sym_float_literal] = ACTIONS(2637),
    [sym_rune_literal] = ACTIONS(2637),
    [anon_sym_SQUOTE] = ACTIONS(2637),
    [anon_sym_DQUOTE] = ACTIONS(2637),
    [anon_sym_c_SQUOTE] = ACTIONS(2637),
    [anon_sym_c_DQUOTE] = ACTIONS(2637),
    [anon_sym_r_SQUOTE] = ACTIONS(2637),
    [anon_sym_r_DQUOTE] = ACTIONS(2637),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2639),
    [anon_sym_shared] = ACTIONS(2639),
    [anon_sym_map_LBRACK] = ACTIONS(2637),
    [anon_sym_chan] = ACTIONS(2639),
    [anon_sym_thread] = ACTIONS(2639),
    [anon_sym_atomic] = ACTIONS(2639),
  },
  [1601] = {
    [sym_line_comment] = STATE(1601),
    [sym_block_comment] = STATE(1601),
    [sym_identifier] = ACTIONS(2631),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2631),
    [anon_sym_as] = ACTIONS(2631),
    [anon_sym_LBRACE] = ACTIONS(2629),
    [anon_sym_COMMA] = ACTIONS(2629),
    [anon_sym_RBRACE] = ACTIONS(2629),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_fn] = ACTIONS(2631),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_DASH] = ACTIONS(2631),
    [anon_sym_STAR] = ACTIONS(2629),
    [anon_sym_SLASH] = ACTIONS(2631),
    [anon_sym_PERCENT] = ACTIONS(2629),
    [anon_sym_LT] = ACTIONS(2631),
    [anon_sym_GT] = ACTIONS(2631),
    [anon_sym_EQ_EQ] = ACTIONS(2629),
    [anon_sym_BANG_EQ] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2629),
    [anon_sym_GT_EQ] = ACTIONS(2629),
    [anon_sym_LBRACK] = ACTIONS(2629),
    [anon_sym_RBRACK] = ACTIONS(2629),
    [anon_sym_struct] = ACTIONS(2631),
    [anon_sym_mut] = ACTIONS(2631),
    [anon_sym_COLON] = ACTIONS(2629),
    [anon_sym_PLUS_PLUS] = ACTIONS(2629),
    [anon_sym_DASH_DASH] = ACTIONS(2629),
    [anon_sym_QMARK] = ACTIONS(2631),
    [anon_sym_BANG] = ACTIONS(2631),
    [anon_sym_go] = ACTIONS(2631),
    [anon_sym_spawn] = ACTIONS(2631),
    [anon_sym_json_DOTdecode] = ACTIONS(2629),
    [anon_sym_PIPE] = ACTIONS(2631),
    [anon_sym_LBRACK2] = ACTIONS(2631),
    [anon_sym_TILDE] = ACTIONS(2629),
    [anon_sym_CARET] = ACTIONS(2629),
    [anon_sym_AMP] = ACTIONS(2631),
    [anon_sym_LT_DASH] = ACTIONS(2629),
    [anon_sym_LT_LT] = ACTIONS(2629),
    [anon_sym_GT_GT] = ACTIONS(2631),
    [anon_sym_GT_GT_GT] = ACTIONS(2629),
    [anon_sym_AMP_CARET] = ACTIONS(2629),
    [anon_sym_AMP_AMP] = ACTIONS(2629),
    [anon_sym_PIPE_PIPE] = ACTIONS(2629),
    [anon_sym_or] = ACTIONS(2631),
    [sym_none] = ACTIONS(2631),
    [sym_true] = ACTIONS(2631),
    [sym_false] = ACTIONS(2631),
    [sym_nil] = ACTIONS(2631),
    [anon_sym_QMARK_DOT] = ACTIONS(2629),
    [anon_sym_POUND_LBRACK] = ACTIONS(2629),
    [anon_sym_if] = ACTIONS(2631),
    [anon_sym_DOLLARif] = ACTIONS(2631),
    [anon_sym_is] = ACTIONS(2631),
    [anon_sym_BANGis] = ACTIONS(2629),
    [anon_sym_in] = ACTIONS(2631),
    [anon_sym_BANGin] = ACTIONS(2629),
    [anon_sym_match] = ACTIONS(2631),
    [anon_sym_select] = ACTIONS(2631),
    [anon_sym_lock] = ACTIONS(2631),
    [anon_sym_rlock] = ACTIONS(2631),
    [anon_sym_unsafe] = ACTIONS(2631),
    [anon_sym_sql] = ACTIONS(2631),
    [sym_int_literal] = ACTIONS(2631),
    [sym_float_literal] = ACTIONS(2629),
    [sym_rune_literal] = ACTIONS(2629),
    [anon_sym_SQUOTE] = ACTIONS(2629),
    [anon_sym_DQUOTE] = ACTIONS(2629),
    [anon_sym_c_SQUOTE] = ACTIONS(2629),
    [anon_sym_c_DQUOTE] = ACTIONS(2629),
    [anon_sym_r_SQUOTE] = ACTIONS(2629),
    [anon_sym_r_DQUOTE] = ACTIONS(2629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2631),
    [anon_sym_shared] = ACTIONS(2631),
    [anon_sym_map_LBRACK] = ACTIONS(2629),
    [anon_sym_chan] = ACTIONS(2631),
    [anon_sym_thread] = ACTIONS(2631),
    [anon_sym_atomic] = ACTIONS(2631),
  },
  [1602] = {
    [sym_line_comment] = STATE(1602),
    [sym_block_comment] = STATE(1602),
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2627),
    [anon_sym_as] = ACTIONS(2627),
    [anon_sym_LBRACE] = ACTIONS(2625),
    [anon_sym_COMMA] = ACTIONS(2625),
    [anon_sym_RBRACE] = ACTIONS(2625),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_fn] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_SLASH] = ACTIONS(2627),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_LT] = ACTIONS(2627),
    [anon_sym_GT] = ACTIONS(2627),
    [anon_sym_EQ_EQ] = ACTIONS(2625),
    [anon_sym_BANG_EQ] = ACTIONS(2625),
    [anon_sym_LT_EQ] = ACTIONS(2625),
    [anon_sym_GT_EQ] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(2625),
    [anon_sym_RBRACK] = ACTIONS(2625),
    [anon_sym_struct] = ACTIONS(2627),
    [anon_sym_mut] = ACTIONS(2627),
    [anon_sym_COLON] = ACTIONS(2625),
    [anon_sym_PLUS_PLUS] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(2625),
    [anon_sym_QMARK] = ACTIONS(2627),
    [anon_sym_BANG] = ACTIONS(2627),
    [anon_sym_go] = ACTIONS(2627),
    [anon_sym_spawn] = ACTIONS(2627),
    [anon_sym_json_DOTdecode] = ACTIONS(2625),
    [anon_sym_PIPE] = ACTIONS(2627),
    [anon_sym_LBRACK2] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2625),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_LT_DASH] = ACTIONS(2625),
    [anon_sym_LT_LT] = ACTIONS(2625),
    [anon_sym_GT_GT] = ACTIONS(2627),
    [anon_sym_GT_GT_GT] = ACTIONS(2625),
    [anon_sym_AMP_CARET] = ACTIONS(2625),
    [anon_sym_AMP_AMP] = ACTIONS(2625),
    [anon_sym_PIPE_PIPE] = ACTIONS(2625),
    [anon_sym_or] = ACTIONS(2627),
    [sym_none] = ACTIONS(2627),
    [sym_true] = ACTIONS(2627),
    [sym_false] = ACTIONS(2627),
    [sym_nil] = ACTIONS(2627),
    [anon_sym_QMARK_DOT] = ACTIONS(2625),
    [anon_sym_POUND_LBRACK] = ACTIONS(2625),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_DOLLARif] = ACTIONS(2627),
    [anon_sym_is] = ACTIONS(2627),
    [anon_sym_BANGis] = ACTIONS(2625),
    [anon_sym_in] = ACTIONS(2627),
    [anon_sym_BANGin] = ACTIONS(2625),
    [anon_sym_match] = ACTIONS(2627),
    [anon_sym_select] = ACTIONS(2627),
    [anon_sym_lock] = ACTIONS(2627),
    [anon_sym_rlock] = ACTIONS(2627),
    [anon_sym_unsafe] = ACTIONS(2627),
    [anon_sym_sql] = ACTIONS(2627),
    [sym_int_literal] = ACTIONS(2627),
    [sym_float_literal] = ACTIONS(2625),
    [sym_rune_literal] = ACTIONS(2625),
    [anon_sym_SQUOTE] = ACTIONS(2625),
    [anon_sym_DQUOTE] = ACTIONS(2625),
    [anon_sym_c_SQUOTE] = ACTIONS(2625),
    [anon_sym_c_DQUOTE] = ACTIONS(2625),
    [anon_sym_r_SQUOTE] = ACTIONS(2625),
    [anon_sym_r_DQUOTE] = ACTIONS(2625),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2627),
    [anon_sym_shared] = ACTIONS(2627),
    [anon_sym_map_LBRACK] = ACTIONS(2625),
    [anon_sym_chan] = ACTIONS(2627),
    [anon_sym_thread] = ACTIONS(2627),
    [anon_sym_atomic] = ACTIONS(2627),
  },
  [1603] = {
    [sym_line_comment] = STATE(1603),
    [sym_block_comment] = STATE(1603),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2465),
    [anon_sym_as] = ACTIONS(2465),
    [anon_sym_LBRACE] = ACTIONS(2463),
    [anon_sym_COMMA] = ACTIONS(2463),
    [anon_sym_RBRACE] = ACTIONS(2463),
    [anon_sym_LPAREN] = ACTIONS(2463),
    [anon_sym_fn] = ACTIONS(2465),
    [anon_sym_PLUS] = ACTIONS(2465),
    [anon_sym_DASH] = ACTIONS(2465),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_SLASH] = ACTIONS(2465),
    [anon_sym_PERCENT] = ACTIONS(2463),
    [anon_sym_LT] = ACTIONS(2465),
    [anon_sym_GT] = ACTIONS(2465),
    [anon_sym_EQ_EQ] = ACTIONS(2463),
    [anon_sym_BANG_EQ] = ACTIONS(2463),
    [anon_sym_LT_EQ] = ACTIONS(2463),
    [anon_sym_GT_EQ] = ACTIONS(2463),
    [anon_sym_LBRACK] = ACTIONS(2463),
    [anon_sym_RBRACK] = ACTIONS(2463),
    [anon_sym_struct] = ACTIONS(2465),
    [anon_sym_mut] = ACTIONS(2465),
    [anon_sym_COLON] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(2463),
    [anon_sym_DASH_DASH] = ACTIONS(2463),
    [anon_sym_QMARK] = ACTIONS(2465),
    [anon_sym_BANG] = ACTIONS(2465),
    [anon_sym_go] = ACTIONS(2465),
    [anon_sym_spawn] = ACTIONS(2465),
    [anon_sym_json_DOTdecode] = ACTIONS(2463),
    [anon_sym_PIPE] = ACTIONS(2465),
    [anon_sym_LBRACK2] = ACTIONS(2465),
    [anon_sym_TILDE] = ACTIONS(2463),
    [anon_sym_CARET] = ACTIONS(2463),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_LT_DASH] = ACTIONS(2463),
    [anon_sym_LT_LT] = ACTIONS(2463),
    [anon_sym_GT_GT] = ACTIONS(2465),
    [anon_sym_GT_GT_GT] = ACTIONS(2463),
    [anon_sym_AMP_CARET] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2463),
    [anon_sym_PIPE_PIPE] = ACTIONS(2463),
    [anon_sym_or] = ACTIONS(2465),
    [sym_none] = ACTIONS(2465),
    [sym_true] = ACTIONS(2465),
    [sym_false] = ACTIONS(2465),
    [sym_nil] = ACTIONS(2465),
    [anon_sym_QMARK_DOT] = ACTIONS(2463),
    [anon_sym_POUND_LBRACK] = ACTIONS(2463),
    [anon_sym_if] = ACTIONS(2465),
    [anon_sym_DOLLARif] = ACTIONS(2465),
    [anon_sym_is] = ACTIONS(2465),
    [anon_sym_BANGis] = ACTIONS(2463),
    [anon_sym_in] = ACTIONS(2465),
    [anon_sym_BANGin] = ACTIONS(2463),
    [anon_sym_match] = ACTIONS(2465),
    [anon_sym_select] = ACTIONS(2465),
    [anon_sym_lock] = ACTIONS(2465),
    [anon_sym_rlock] = ACTIONS(2465),
    [anon_sym_unsafe] = ACTIONS(2465),
    [anon_sym_sql] = ACTIONS(2465),
    [sym_int_literal] = ACTIONS(2465),
    [sym_float_literal] = ACTIONS(2463),
    [sym_rune_literal] = ACTIONS(2463),
    [anon_sym_SQUOTE] = ACTIONS(2463),
    [anon_sym_DQUOTE] = ACTIONS(2463),
    [anon_sym_c_SQUOTE] = ACTIONS(2463),
    [anon_sym_c_DQUOTE] = ACTIONS(2463),
    [anon_sym_r_SQUOTE] = ACTIONS(2463),
    [anon_sym_r_DQUOTE] = ACTIONS(2463),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2465),
    [anon_sym_shared] = ACTIONS(2465),
    [anon_sym_map_LBRACK] = ACTIONS(2463),
    [anon_sym_chan] = ACTIONS(2465),
    [anon_sym_thread] = ACTIONS(2465),
    [anon_sym_atomic] = ACTIONS(2465),
  },
  [1604] = {
    [sym_line_comment] = STATE(1604),
    [sym_block_comment] = STATE(1604),
    [sym_type_parameters] = STATE(4409),
    [sym_argument_list] = STATE(1682),
    [sym_or_block] = STATE(1683),
    [sym_identifier] = ACTIONS(4243),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(4245),
    [anon_sym_LBRACE] = ACTIONS(4247),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_fn] = ACTIONS(4243),
    [anon_sym_PLUS] = ACTIONS(4249),
    [anon_sym_DASH] = ACTIONS(4249),
    [anon_sym_STAR] = ACTIONS(4251),
    [anon_sym_SLASH] = ACTIONS(4253),
    [anon_sym_PERCENT] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(4255),
    [anon_sym_GT] = ACTIONS(4255),
    [anon_sym_EQ_EQ] = ACTIONS(4257),
    [anon_sym_BANG_EQ] = ACTIONS(4257),
    [anon_sym_LT_EQ] = ACTIONS(4257),
    [anon_sym_GT_EQ] = ACTIONS(4257),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_struct] = ACTIONS(4243),
    [anon_sym_mut] = ACTIONS(4243),
    [anon_sym_PLUS_PLUS] = ACTIONS(4261),
    [anon_sym_DASH_DASH] = ACTIONS(4263),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4233),
    [anon_sym_go] = ACTIONS(4243),
    [anon_sym_spawn] = ACTIONS(4243),
    [anon_sym_json_DOTdecode] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(4249),
    [anon_sym_LBRACK2] = ACTIONS(4235),
    [anon_sym_TILDE] = ACTIONS(4247),
    [anon_sym_CARET] = ACTIONS(4265),
    [anon_sym_AMP] = ACTIONS(4253),
    [anon_sym_LT_DASH] = ACTIONS(4247),
    [anon_sym_LT_LT] = ACTIONS(4251),
    [anon_sym_GT_GT] = ACTIONS(4253),
    [anon_sym_GT_GT_GT] = ACTIONS(4251),
    [anon_sym_AMP_CARET] = ACTIONS(4251),
    [anon_sym_AMP_AMP] = ACTIONS(4267),
    [anon_sym_PIPE_PIPE] = ACTIONS(4269),
    [anon_sym_or] = ACTIONS(4271),
    [sym_none] = ACTIONS(4243),
    [sym_true] = ACTIONS(4243),
    [sym_false] = ACTIONS(4243),
    [sym_nil] = ACTIONS(4243),
    [anon_sym_QMARK_DOT] = ACTIONS(4237),
    [anon_sym_POUND_LBRACK] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(4243),
    [anon_sym_DOLLARif] = ACTIONS(4243),
    [anon_sym_is] = ACTIONS(4273),
    [anon_sym_BANGis] = ACTIONS(4275),
    [anon_sym_in] = ACTIONS(4277),
    [anon_sym_BANGin] = ACTIONS(4279),
    [anon_sym_match] = ACTIONS(4243),
    [anon_sym_select] = ACTIONS(4243),
    [anon_sym_lock] = ACTIONS(4243),
    [anon_sym_rlock] = ACTIONS(4243),
    [anon_sym_unsafe] = ACTIONS(4243),
    [anon_sym_sql] = ACTIONS(4243),
    [sym_int_literal] = ACTIONS(4243),
    [sym_float_literal] = ACTIONS(4247),
    [sym_rune_literal] = ACTIONS(4247),
    [anon_sym_SQUOTE] = ACTIONS(4247),
    [anon_sym_DQUOTE] = ACTIONS(4247),
    [anon_sym_c_SQUOTE] = ACTIONS(4247),
    [anon_sym_c_DQUOTE] = ACTIONS(4247),
    [anon_sym_r_SQUOTE] = ACTIONS(4247),
    [anon_sym_r_DQUOTE] = ACTIONS(4247),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4243),
    [anon_sym_shared] = ACTIONS(4243),
    [anon_sym_map_LBRACK] = ACTIONS(4247),
    [anon_sym_chan] = ACTIONS(4243),
    [anon_sym_thread] = ACTIONS(4243),
    [anon_sym_atomic] = ACTIONS(4243),
  },
  [1605] = {
    [sym_line_comment] = STATE(1605),
    [sym_block_comment] = STATE(1605),
    [sym_identifier] = ACTIONS(2647),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2647),
    [anon_sym_as] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_COMMA] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2645),
    [anon_sym_fn] = ACTIONS(2647),
    [anon_sym_PLUS] = ACTIONS(2647),
    [anon_sym_DASH] = ACTIONS(2647),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_SLASH] = ACTIONS(2647),
    [anon_sym_PERCENT] = ACTIONS(2645),
    [anon_sym_LT] = ACTIONS(2647),
    [anon_sym_GT] = ACTIONS(2647),
    [anon_sym_EQ_EQ] = ACTIONS(2645),
    [anon_sym_BANG_EQ] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2645),
    [anon_sym_GT_EQ] = ACTIONS(2645),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_RBRACK] = ACTIONS(2645),
    [anon_sym_struct] = ACTIONS(2647),
    [anon_sym_mut] = ACTIONS(2647),
    [anon_sym_COLON] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_go] = ACTIONS(2647),
    [anon_sym_spawn] = ACTIONS(2647),
    [anon_sym_json_DOTdecode] = ACTIONS(2645),
    [anon_sym_PIPE] = ACTIONS(2647),
    [anon_sym_LBRACK2] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_CARET] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2647),
    [anon_sym_LT_DASH] = ACTIONS(2645),
    [anon_sym_LT_LT] = ACTIONS(2645),
    [anon_sym_GT_GT] = ACTIONS(2647),
    [anon_sym_GT_GT_GT] = ACTIONS(2645),
    [anon_sym_AMP_CARET] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_PIPE_PIPE] = ACTIONS(2645),
    [anon_sym_or] = ACTIONS(2647),
    [sym_none] = ACTIONS(2647),
    [sym_true] = ACTIONS(2647),
    [sym_false] = ACTIONS(2647),
    [sym_nil] = ACTIONS(2647),
    [anon_sym_QMARK_DOT] = ACTIONS(2645),
    [anon_sym_POUND_LBRACK] = ACTIONS(2645),
    [anon_sym_if] = ACTIONS(2647),
    [anon_sym_DOLLARif] = ACTIONS(2647),
    [anon_sym_is] = ACTIONS(2647),
    [anon_sym_BANGis] = ACTIONS(2645),
    [anon_sym_in] = ACTIONS(2647),
    [anon_sym_BANGin] = ACTIONS(2645),
    [anon_sym_match] = ACTIONS(2647),
    [anon_sym_select] = ACTIONS(2647),
    [anon_sym_lock] = ACTIONS(2647),
    [anon_sym_rlock] = ACTIONS(2647),
    [anon_sym_unsafe] = ACTIONS(2647),
    [anon_sym_sql] = ACTIONS(2647),
    [sym_int_literal] = ACTIONS(2647),
    [sym_float_literal] = ACTIONS(2645),
    [sym_rune_literal] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [anon_sym_c_SQUOTE] = ACTIONS(2645),
    [anon_sym_c_DQUOTE] = ACTIONS(2645),
    [anon_sym_r_SQUOTE] = ACTIONS(2645),
    [anon_sym_r_DQUOTE] = ACTIONS(2645),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2647),
    [anon_sym_shared] = ACTIONS(2647),
    [anon_sym_map_LBRACK] = ACTIONS(2645),
    [anon_sym_chan] = ACTIONS(2647),
    [anon_sym_thread] = ACTIONS(2647),
    [anon_sym_atomic] = ACTIONS(2647),
  },
  [1606] = {
    [sym_line_comment] = STATE(1606),
    [sym_block_comment] = STATE(1606),
    [sym_identifier] = ACTIONS(2651),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2651),
    [anon_sym_as] = ACTIONS(2651),
    [anon_sym_LBRACE] = ACTIONS(2649),
    [anon_sym_COMMA] = ACTIONS(2649),
    [anon_sym_RBRACE] = ACTIONS(2649),
    [anon_sym_LPAREN] = ACTIONS(2649),
    [anon_sym_fn] = ACTIONS(2651),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_STAR] = ACTIONS(2649),
    [anon_sym_SLASH] = ACTIONS(2651),
    [anon_sym_PERCENT] = ACTIONS(2649),
    [anon_sym_LT] = ACTIONS(2651),
    [anon_sym_GT] = ACTIONS(2651),
    [anon_sym_EQ_EQ] = ACTIONS(2649),
    [anon_sym_BANG_EQ] = ACTIONS(2649),
    [anon_sym_LT_EQ] = ACTIONS(2649),
    [anon_sym_GT_EQ] = ACTIONS(2649),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_RBRACK] = ACTIONS(2649),
    [anon_sym_struct] = ACTIONS(2651),
    [anon_sym_mut] = ACTIONS(2651),
    [anon_sym_COLON] = ACTIONS(2649),
    [anon_sym_PLUS_PLUS] = ACTIONS(2649),
    [anon_sym_DASH_DASH] = ACTIONS(2649),
    [anon_sym_QMARK] = ACTIONS(2651),
    [anon_sym_BANG] = ACTIONS(2651),
    [anon_sym_go] = ACTIONS(2651),
    [anon_sym_spawn] = ACTIONS(2651),
    [anon_sym_json_DOTdecode] = ACTIONS(2649),
    [anon_sym_PIPE] = ACTIONS(2651),
    [anon_sym_LBRACK2] = ACTIONS(2651),
    [anon_sym_TILDE] = ACTIONS(2649),
    [anon_sym_CARET] = ACTIONS(2649),
    [anon_sym_AMP] = ACTIONS(2651),
    [anon_sym_LT_DASH] = ACTIONS(2649),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2651),
    [anon_sym_GT_GT_GT] = ACTIONS(2649),
    [anon_sym_AMP_CARET] = ACTIONS(2649),
    [anon_sym_AMP_AMP] = ACTIONS(2649),
    [anon_sym_PIPE_PIPE] = ACTIONS(2649),
    [anon_sym_or] = ACTIONS(2651),
    [sym_none] = ACTIONS(2651),
    [sym_true] = ACTIONS(2651),
    [sym_false] = ACTIONS(2651),
    [sym_nil] = ACTIONS(2651),
    [anon_sym_QMARK_DOT] = ACTIONS(2649),
    [anon_sym_POUND_LBRACK] = ACTIONS(2649),
    [anon_sym_if] = ACTIONS(2651),
    [anon_sym_DOLLARif] = ACTIONS(2651),
    [anon_sym_is] = ACTIONS(2651),
    [anon_sym_BANGis] = ACTIONS(2649),
    [anon_sym_in] = ACTIONS(2651),
    [anon_sym_BANGin] = ACTIONS(2649),
    [anon_sym_match] = ACTIONS(2651),
    [anon_sym_select] = ACTIONS(2651),
    [anon_sym_lock] = ACTIONS(2651),
    [anon_sym_rlock] = ACTIONS(2651),
    [anon_sym_unsafe] = ACTIONS(2651),
    [anon_sym_sql] = ACTIONS(2651),
    [sym_int_literal] = ACTIONS(2651),
    [sym_float_literal] = ACTIONS(2649),
    [sym_rune_literal] = ACTIONS(2649),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_DQUOTE] = ACTIONS(2649),
    [anon_sym_c_SQUOTE] = ACTIONS(2649),
    [anon_sym_c_DQUOTE] = ACTIONS(2649),
    [anon_sym_r_SQUOTE] = ACTIONS(2649),
    [anon_sym_r_DQUOTE] = ACTIONS(2649),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2651),
    [anon_sym_shared] = ACTIONS(2651),
    [anon_sym_map_LBRACK] = ACTIONS(2649),
    [anon_sym_chan] = ACTIONS(2651),
    [anon_sym_thread] = ACTIONS(2651),
    [anon_sym_atomic] = ACTIONS(2651),
  },
  [1607] = {
    [sym_line_comment] = STATE(1607),
    [sym_block_comment] = STATE(1607),
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_as] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3043),
    [anon_sym_RBRACE] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_fn] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3043),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_PERCENT] = ACTIONS(3043),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_GT] = ACTIONS(3045),
    [anon_sym_EQ_EQ] = ACTIONS(3043),
    [anon_sym_BANG_EQ] = ACTIONS(3043),
    [anon_sym_LT_EQ] = ACTIONS(3043),
    [anon_sym_GT_EQ] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_RBRACK] = ACTIONS(3043),
    [anon_sym_struct] = ACTIONS(3045),
    [anon_sym_mut] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(3043),
    [anon_sym_PLUS_PLUS] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3045),
    [anon_sym_go] = ACTIONS(3045),
    [anon_sym_spawn] = ACTIONS(3045),
    [anon_sym_json_DOTdecode] = ACTIONS(3043),
    [anon_sym_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACK2] = ACTIONS(3045),
    [anon_sym_TILDE] = ACTIONS(3043),
    [anon_sym_CARET] = ACTIONS(3043),
    [anon_sym_AMP] = ACTIONS(3045),
    [anon_sym_LT_DASH] = ACTIONS(3043),
    [anon_sym_LT_LT] = ACTIONS(3043),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_GT_GT_GT] = ACTIONS(3043),
    [anon_sym_AMP_CARET] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [anon_sym_or] = ACTIONS(3045),
    [sym_none] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_nil] = ACTIONS(3045),
    [anon_sym_QMARK_DOT] = ACTIONS(3043),
    [anon_sym_POUND_LBRACK] = ACTIONS(3043),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_DOLLARif] = ACTIONS(3045),
    [anon_sym_is] = ACTIONS(3045),
    [anon_sym_BANGis] = ACTIONS(3043),
    [anon_sym_in] = ACTIONS(3045),
    [anon_sym_BANGin] = ACTIONS(3043),
    [anon_sym_match] = ACTIONS(3045),
    [anon_sym_select] = ACTIONS(3045),
    [anon_sym_lock] = ACTIONS(3045),
    [anon_sym_rlock] = ACTIONS(3045),
    [anon_sym_unsafe] = ACTIONS(3045),
    [anon_sym_sql] = ACTIONS(3045),
    [sym_int_literal] = ACTIONS(3045),
    [sym_float_literal] = ACTIONS(3043),
    [sym_rune_literal] = ACTIONS(3043),
    [anon_sym_SQUOTE] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [anon_sym_c_SQUOTE] = ACTIONS(3043),
    [anon_sym_c_DQUOTE] = ACTIONS(3043),
    [anon_sym_r_SQUOTE] = ACTIONS(3043),
    [anon_sym_r_DQUOTE] = ACTIONS(3043),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3045),
    [anon_sym_shared] = ACTIONS(3045),
    [anon_sym_map_LBRACK] = ACTIONS(3043),
    [anon_sym_chan] = ACTIONS(3045),
    [anon_sym_thread] = ACTIONS(3045),
    [anon_sym_atomic] = ACTIONS(3045),
  },
  [1608] = {
    [sym_line_comment] = STATE(1608),
    [sym_block_comment] = STATE(1608),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2401),
    [anon_sym_as] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(2399),
    [anon_sym_COMMA] = ACTIONS(2399),
    [anon_sym_RBRACE] = ACTIONS(2399),
    [anon_sym_LPAREN] = ACTIONS(2399),
    [anon_sym_fn] = ACTIONS(2401),
    [anon_sym_PLUS] = ACTIONS(2401),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_STAR] = ACTIONS(2399),
    [anon_sym_SLASH] = ACTIONS(2401),
    [anon_sym_PERCENT] = ACTIONS(2399),
    [anon_sym_LT] = ACTIONS(2401),
    [anon_sym_GT] = ACTIONS(2401),
    [anon_sym_EQ_EQ] = ACTIONS(2399),
    [anon_sym_BANG_EQ] = ACTIONS(2399),
    [anon_sym_LT_EQ] = ACTIONS(2399),
    [anon_sym_GT_EQ] = ACTIONS(2399),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_RBRACK] = ACTIONS(2399),
    [anon_sym_struct] = ACTIONS(2401),
    [anon_sym_mut] = ACTIONS(2401),
    [anon_sym_COLON] = ACTIONS(2399),
    [anon_sym_PLUS_PLUS] = ACTIONS(2399),
    [anon_sym_DASH_DASH] = ACTIONS(2399),
    [anon_sym_QMARK] = ACTIONS(2401),
    [anon_sym_BANG] = ACTIONS(2401),
    [anon_sym_go] = ACTIONS(2401),
    [anon_sym_spawn] = ACTIONS(2401),
    [anon_sym_json_DOTdecode] = ACTIONS(2399),
    [anon_sym_PIPE] = ACTIONS(2401),
    [anon_sym_LBRACK2] = ACTIONS(2401),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_CARET] = ACTIONS(2399),
    [anon_sym_AMP] = ACTIONS(2401),
    [anon_sym_LT_DASH] = ACTIONS(2399),
    [anon_sym_LT_LT] = ACTIONS(2399),
    [anon_sym_GT_GT] = ACTIONS(2401),
    [anon_sym_GT_GT_GT] = ACTIONS(2399),
    [anon_sym_AMP_CARET] = ACTIONS(2399),
    [anon_sym_AMP_AMP] = ACTIONS(2399),
    [anon_sym_PIPE_PIPE] = ACTIONS(2399),
    [anon_sym_or] = ACTIONS(2401),
    [sym_none] = ACTIONS(2401),
    [sym_true] = ACTIONS(2401),
    [sym_false] = ACTIONS(2401),
    [sym_nil] = ACTIONS(2401),
    [anon_sym_QMARK_DOT] = ACTIONS(2399),
    [anon_sym_POUND_LBRACK] = ACTIONS(2399),
    [anon_sym_if] = ACTIONS(2401),
    [anon_sym_DOLLARif] = ACTIONS(2401),
    [anon_sym_is] = ACTIONS(2401),
    [anon_sym_BANGis] = ACTIONS(2399),
    [anon_sym_in] = ACTIONS(2401),
    [anon_sym_BANGin] = ACTIONS(2399),
    [anon_sym_match] = ACTIONS(2401),
    [anon_sym_select] = ACTIONS(2401),
    [anon_sym_lock] = ACTIONS(2401),
    [anon_sym_rlock] = ACTIONS(2401),
    [anon_sym_unsafe] = ACTIONS(2401),
    [anon_sym_sql] = ACTIONS(2401),
    [sym_int_literal] = ACTIONS(2401),
    [sym_float_literal] = ACTIONS(2399),
    [sym_rune_literal] = ACTIONS(2399),
    [anon_sym_SQUOTE] = ACTIONS(2399),
    [anon_sym_DQUOTE] = ACTIONS(2399),
    [anon_sym_c_SQUOTE] = ACTIONS(2399),
    [anon_sym_c_DQUOTE] = ACTIONS(2399),
    [anon_sym_r_SQUOTE] = ACTIONS(2399),
    [anon_sym_r_DQUOTE] = ACTIONS(2399),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2401),
    [anon_sym_shared] = ACTIONS(2401),
    [anon_sym_map_LBRACK] = ACTIONS(2399),
    [anon_sym_chan] = ACTIONS(2401),
    [anon_sym_thread] = ACTIONS(2401),
    [anon_sym_atomic] = ACTIONS(2401),
  },
  [1609] = {
    [sym_line_comment] = STATE(1609),
    [sym_block_comment] = STATE(1609),
    [sym_identifier] = ACTIONS(2985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_as] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_RBRACE] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_fn] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2983),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_PERCENT] = ACTIONS(2983),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_EQ_EQ] = ACTIONS(2983),
    [anon_sym_BANG_EQ] = ACTIONS(2983),
    [anon_sym_LT_EQ] = ACTIONS(2983),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_RBRACK] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_mut] = ACTIONS(2985),
    [anon_sym_COLON] = ACTIONS(2983),
    [anon_sym_PLUS_PLUS] = ACTIONS(2983),
    [anon_sym_DASH_DASH] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_go] = ACTIONS(2985),
    [anon_sym_spawn] = ACTIONS(2985),
    [anon_sym_json_DOTdecode] = ACTIONS(2983),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(2983),
    [anon_sym_CARET] = ACTIONS(2983),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_DASH] = ACTIONS(2983),
    [anon_sym_LT_LT] = ACTIONS(2983),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_GT_GT_GT] = ACTIONS(2983),
    [anon_sym_AMP_CARET] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_or] = ACTIONS(2985),
    [sym_none] = ACTIONS(2985),
    [sym_true] = ACTIONS(2985),
    [sym_false] = ACTIONS(2985),
    [sym_nil] = ACTIONS(2985),
    [anon_sym_QMARK_DOT] = ACTIONS(2983),
    [anon_sym_POUND_LBRACK] = ACTIONS(2983),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_DOLLARif] = ACTIONS(2985),
    [anon_sym_is] = ACTIONS(2985),
    [anon_sym_BANGis] = ACTIONS(2983),
    [anon_sym_in] = ACTIONS(2985),
    [anon_sym_BANGin] = ACTIONS(2983),
    [anon_sym_match] = ACTIONS(2985),
    [anon_sym_select] = ACTIONS(2985),
    [anon_sym_lock] = ACTIONS(2985),
    [anon_sym_rlock] = ACTIONS(2985),
    [anon_sym_unsafe] = ACTIONS(2985),
    [anon_sym_sql] = ACTIONS(2985),
    [sym_int_literal] = ACTIONS(2985),
    [sym_float_literal] = ACTIONS(2983),
    [sym_rune_literal] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(2983),
    [anon_sym_DQUOTE] = ACTIONS(2983),
    [anon_sym_c_SQUOTE] = ACTIONS(2983),
    [anon_sym_c_DQUOTE] = ACTIONS(2983),
    [anon_sym_r_SQUOTE] = ACTIONS(2983),
    [anon_sym_r_DQUOTE] = ACTIONS(2983),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2985),
    [anon_sym_shared] = ACTIONS(2985),
    [anon_sym_map_LBRACK] = ACTIONS(2983),
    [anon_sym_chan] = ACTIONS(2985),
    [anon_sym_thread] = ACTIONS(2985),
    [anon_sym_atomic] = ACTIONS(2985),
  },
  [1610] = {
    [sym_line_comment] = STATE(1610),
    [sym_block_comment] = STATE(1610),
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2669),
    [anon_sym_as] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_COMMA] = ACTIONS(2667),
    [anon_sym_RBRACE] = ACTIONS(2667),
    [anon_sym_LPAREN] = ACTIONS(2667),
    [anon_sym_fn] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2667),
    [anon_sym_SLASH] = ACTIONS(2669),
    [anon_sym_PERCENT] = ACTIONS(2667),
    [anon_sym_LT] = ACTIONS(2669),
    [anon_sym_GT] = ACTIONS(2669),
    [anon_sym_EQ_EQ] = ACTIONS(2667),
    [anon_sym_BANG_EQ] = ACTIONS(2667),
    [anon_sym_LT_EQ] = ACTIONS(2667),
    [anon_sym_GT_EQ] = ACTIONS(2667),
    [anon_sym_LBRACK] = ACTIONS(2667),
    [anon_sym_RBRACK] = ACTIONS(2667),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_mut] = ACTIONS(2669),
    [anon_sym_COLON] = ACTIONS(2667),
    [anon_sym_PLUS_PLUS] = ACTIONS(2667),
    [anon_sym_DASH_DASH] = ACTIONS(2667),
    [anon_sym_QMARK] = ACTIONS(2669),
    [anon_sym_BANG] = ACTIONS(2669),
    [anon_sym_go] = ACTIONS(2669),
    [anon_sym_spawn] = ACTIONS(2669),
    [anon_sym_json_DOTdecode] = ACTIONS(2667),
    [anon_sym_PIPE] = ACTIONS(2669),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_TILDE] = ACTIONS(2667),
    [anon_sym_CARET] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_LT_DASH] = ACTIONS(2667),
    [anon_sym_LT_LT] = ACTIONS(2667),
    [anon_sym_GT_GT] = ACTIONS(2669),
    [anon_sym_GT_GT_GT] = ACTIONS(2667),
    [anon_sym_AMP_CARET] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_PIPE_PIPE] = ACTIONS(2667),
    [anon_sym_or] = ACTIONS(2669),
    [sym_none] = ACTIONS(2669),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [sym_nil] = ACTIONS(2669),
    [anon_sym_QMARK_DOT] = ACTIONS(2667),
    [anon_sym_POUND_LBRACK] = ACTIONS(2667),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_DOLLARif] = ACTIONS(2669),
    [anon_sym_is] = ACTIONS(2669),
    [anon_sym_BANGis] = ACTIONS(2667),
    [anon_sym_in] = ACTIONS(2669),
    [anon_sym_BANGin] = ACTIONS(2667),
    [anon_sym_match] = ACTIONS(2669),
    [anon_sym_select] = ACTIONS(2669),
    [anon_sym_lock] = ACTIONS(2669),
    [anon_sym_rlock] = ACTIONS(2669),
    [anon_sym_unsafe] = ACTIONS(2669),
    [anon_sym_sql] = ACTIONS(2669),
    [sym_int_literal] = ACTIONS(2669),
    [sym_float_literal] = ACTIONS(2667),
    [sym_rune_literal] = ACTIONS(2667),
    [anon_sym_SQUOTE] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [anon_sym_c_SQUOTE] = ACTIONS(2667),
    [anon_sym_c_DQUOTE] = ACTIONS(2667),
    [anon_sym_r_SQUOTE] = ACTIONS(2667),
    [anon_sym_r_DQUOTE] = ACTIONS(2667),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2669),
    [anon_sym_shared] = ACTIONS(2669),
    [anon_sym_map_LBRACK] = ACTIONS(2667),
    [anon_sym_chan] = ACTIONS(2669),
    [anon_sym_thread] = ACTIONS(2669),
    [anon_sym_atomic] = ACTIONS(2669),
  },
  [1611] = {
    [sym_line_comment] = STATE(1611),
    [sym_block_comment] = STATE(1611),
    [sym_identifier] = ACTIONS(2935),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2935),
    [anon_sym_as] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(2933),
    [anon_sym_COMMA] = ACTIONS(2933),
    [anon_sym_RBRACE] = ACTIONS(2933),
    [anon_sym_LPAREN] = ACTIONS(2933),
    [anon_sym_fn] = ACTIONS(2935),
    [anon_sym_PLUS] = ACTIONS(2935),
    [anon_sym_DASH] = ACTIONS(2935),
    [anon_sym_STAR] = ACTIONS(2933),
    [anon_sym_SLASH] = ACTIONS(2935),
    [anon_sym_PERCENT] = ACTIONS(2933),
    [anon_sym_LT] = ACTIONS(2935),
    [anon_sym_GT] = ACTIONS(2935),
    [anon_sym_EQ_EQ] = ACTIONS(2933),
    [anon_sym_BANG_EQ] = ACTIONS(2933),
    [anon_sym_LT_EQ] = ACTIONS(2933),
    [anon_sym_GT_EQ] = ACTIONS(2933),
    [anon_sym_LBRACK] = ACTIONS(2933),
    [anon_sym_RBRACK] = ACTIONS(2933),
    [anon_sym_struct] = ACTIONS(2935),
    [anon_sym_mut] = ACTIONS(2935),
    [anon_sym_COLON] = ACTIONS(2933),
    [anon_sym_PLUS_PLUS] = ACTIONS(2933),
    [anon_sym_DASH_DASH] = ACTIONS(2933),
    [anon_sym_QMARK] = ACTIONS(2935),
    [anon_sym_BANG] = ACTIONS(2935),
    [anon_sym_go] = ACTIONS(2935),
    [anon_sym_spawn] = ACTIONS(2935),
    [anon_sym_json_DOTdecode] = ACTIONS(2933),
    [anon_sym_PIPE] = ACTIONS(2935),
    [anon_sym_LBRACK2] = ACTIONS(2935),
    [anon_sym_TILDE] = ACTIONS(2933),
    [anon_sym_CARET] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2935),
    [anon_sym_LT_DASH] = ACTIONS(2933),
    [anon_sym_LT_LT] = ACTIONS(2933),
    [anon_sym_GT_GT] = ACTIONS(2935),
    [anon_sym_GT_GT_GT] = ACTIONS(2933),
    [anon_sym_AMP_CARET] = ACTIONS(2933),
    [anon_sym_AMP_AMP] = ACTIONS(2933),
    [anon_sym_PIPE_PIPE] = ACTIONS(2933),
    [anon_sym_or] = ACTIONS(2935),
    [sym_none] = ACTIONS(2935),
    [sym_true] = ACTIONS(2935),
    [sym_false] = ACTIONS(2935),
    [sym_nil] = ACTIONS(2935),
    [anon_sym_QMARK_DOT] = ACTIONS(2933),
    [anon_sym_POUND_LBRACK] = ACTIONS(2933),
    [anon_sym_if] = ACTIONS(2935),
    [anon_sym_DOLLARif] = ACTIONS(2935),
    [anon_sym_is] = ACTIONS(2935),
    [anon_sym_BANGis] = ACTIONS(2933),
    [anon_sym_in] = ACTIONS(2935),
    [anon_sym_BANGin] = ACTIONS(2933),
    [anon_sym_match] = ACTIONS(2935),
    [anon_sym_select] = ACTIONS(2935),
    [anon_sym_lock] = ACTIONS(2935),
    [anon_sym_rlock] = ACTIONS(2935),
    [anon_sym_unsafe] = ACTIONS(2935),
    [anon_sym_sql] = ACTIONS(2935),
    [sym_int_literal] = ACTIONS(2935),
    [sym_float_literal] = ACTIONS(2933),
    [sym_rune_literal] = ACTIONS(2933),
    [anon_sym_SQUOTE] = ACTIONS(2933),
    [anon_sym_DQUOTE] = ACTIONS(2933),
    [anon_sym_c_SQUOTE] = ACTIONS(2933),
    [anon_sym_c_DQUOTE] = ACTIONS(2933),
    [anon_sym_r_SQUOTE] = ACTIONS(2933),
    [anon_sym_r_DQUOTE] = ACTIONS(2933),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2935),
    [anon_sym_shared] = ACTIONS(2935),
    [anon_sym_map_LBRACK] = ACTIONS(2933),
    [anon_sym_chan] = ACTIONS(2935),
    [anon_sym_thread] = ACTIONS(2935),
    [anon_sym_atomic] = ACTIONS(2935),
  },
  [1612] = {
    [sym_line_comment] = STATE(1612),
    [sym_block_comment] = STATE(1612),
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3061),
    [anon_sym_as] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_COMMA] = ACTIONS(3059),
    [anon_sym_RBRACE] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_PLUS] = ACTIONS(3061),
    [anon_sym_DASH] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_SLASH] = ACTIONS(3061),
    [anon_sym_PERCENT] = ACTIONS(3059),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_GT] = ACTIONS(3061),
    [anon_sym_EQ_EQ] = ACTIONS(3059),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_LT_EQ] = ACTIONS(3059),
    [anon_sym_GT_EQ] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_RBRACK] = ACTIONS(3059),
    [anon_sym_struct] = ACTIONS(3061),
    [anon_sym_mut] = ACTIONS(3061),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_PLUS_PLUS] = ACTIONS(3059),
    [anon_sym_DASH_DASH] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_BANG] = ACTIONS(3061),
    [anon_sym_go] = ACTIONS(3061),
    [anon_sym_spawn] = ACTIONS(3061),
    [anon_sym_json_DOTdecode] = ACTIONS(3059),
    [anon_sym_PIPE] = ACTIONS(3061),
    [anon_sym_LBRACK2] = ACTIONS(3061),
    [anon_sym_TILDE] = ACTIONS(3059),
    [anon_sym_CARET] = ACTIONS(3059),
    [anon_sym_AMP] = ACTIONS(3061),
    [anon_sym_LT_DASH] = ACTIONS(3059),
    [anon_sym_LT_LT] = ACTIONS(3059),
    [anon_sym_GT_GT] = ACTIONS(3061),
    [anon_sym_GT_GT_GT] = ACTIONS(3059),
    [anon_sym_AMP_CARET] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_or] = ACTIONS(3061),
    [sym_none] = ACTIONS(3061),
    [sym_true] = ACTIONS(3061),
    [sym_false] = ACTIONS(3061),
    [sym_nil] = ACTIONS(3061),
    [anon_sym_QMARK_DOT] = ACTIONS(3059),
    [anon_sym_POUND_LBRACK] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(3061),
    [anon_sym_DOLLARif] = ACTIONS(3061),
    [anon_sym_is] = ACTIONS(3061),
    [anon_sym_BANGis] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(3061),
    [anon_sym_BANGin] = ACTIONS(3059),
    [anon_sym_match] = ACTIONS(3061),
    [anon_sym_select] = ACTIONS(3061),
    [anon_sym_lock] = ACTIONS(3061),
    [anon_sym_rlock] = ACTIONS(3061),
    [anon_sym_unsafe] = ACTIONS(3061),
    [anon_sym_sql] = ACTIONS(3061),
    [sym_int_literal] = ACTIONS(3061),
    [sym_float_literal] = ACTIONS(3059),
    [sym_rune_literal] = ACTIONS(3059),
    [anon_sym_SQUOTE] = ACTIONS(3059),
    [anon_sym_DQUOTE] = ACTIONS(3059),
    [anon_sym_c_SQUOTE] = ACTIONS(3059),
    [anon_sym_c_DQUOTE] = ACTIONS(3059),
    [anon_sym_r_SQUOTE] = ACTIONS(3059),
    [anon_sym_r_DQUOTE] = ACTIONS(3059),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3061),
    [anon_sym_shared] = ACTIONS(3061),
    [anon_sym_map_LBRACK] = ACTIONS(3059),
    [anon_sym_chan] = ACTIONS(3061),
    [anon_sym_thread] = ACTIONS(3061),
    [anon_sym_atomic] = ACTIONS(3061),
  },
  [1613] = {
    [sym_line_comment] = STATE(1613),
    [sym_block_comment] = STATE(1613),
    [sym_identifier] = ACTIONS(3001),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3001),
    [anon_sym_as] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(2999),
    [anon_sym_COMMA] = ACTIONS(2999),
    [anon_sym_RBRACE] = ACTIONS(2999),
    [anon_sym_LPAREN] = ACTIONS(2999),
    [anon_sym_fn] = ACTIONS(3001),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_SLASH] = ACTIONS(3001),
    [anon_sym_PERCENT] = ACTIONS(2999),
    [anon_sym_LT] = ACTIONS(3001),
    [anon_sym_GT] = ACTIONS(3001),
    [anon_sym_EQ_EQ] = ACTIONS(2999),
    [anon_sym_BANG_EQ] = ACTIONS(2999),
    [anon_sym_LT_EQ] = ACTIONS(2999),
    [anon_sym_GT_EQ] = ACTIONS(2999),
    [anon_sym_LBRACK] = ACTIONS(2999),
    [anon_sym_RBRACK] = ACTIONS(2999),
    [anon_sym_struct] = ACTIONS(3001),
    [anon_sym_mut] = ACTIONS(3001),
    [anon_sym_COLON] = ACTIONS(2999),
    [anon_sym_PLUS_PLUS] = ACTIONS(2999),
    [anon_sym_DASH_DASH] = ACTIONS(2999),
    [anon_sym_QMARK] = ACTIONS(3001),
    [anon_sym_BANG] = ACTIONS(3001),
    [anon_sym_go] = ACTIONS(3001),
    [anon_sym_spawn] = ACTIONS(3001),
    [anon_sym_json_DOTdecode] = ACTIONS(2999),
    [anon_sym_PIPE] = ACTIONS(3001),
    [anon_sym_LBRACK2] = ACTIONS(3001),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_CARET] = ACTIONS(2999),
    [anon_sym_AMP] = ACTIONS(3001),
    [anon_sym_LT_DASH] = ACTIONS(2999),
    [anon_sym_LT_LT] = ACTIONS(2999),
    [anon_sym_GT_GT] = ACTIONS(3001),
    [anon_sym_GT_GT_GT] = ACTIONS(2999),
    [anon_sym_AMP_CARET] = ACTIONS(2999),
    [anon_sym_AMP_AMP] = ACTIONS(2999),
    [anon_sym_PIPE_PIPE] = ACTIONS(2999),
    [anon_sym_or] = ACTIONS(3001),
    [sym_none] = ACTIONS(3001),
    [sym_true] = ACTIONS(3001),
    [sym_false] = ACTIONS(3001),
    [sym_nil] = ACTIONS(3001),
    [anon_sym_QMARK_DOT] = ACTIONS(2999),
    [anon_sym_POUND_LBRACK] = ACTIONS(2999),
    [anon_sym_if] = ACTIONS(3001),
    [anon_sym_DOLLARif] = ACTIONS(3001),
    [anon_sym_is] = ACTIONS(3001),
    [anon_sym_BANGis] = ACTIONS(2999),
    [anon_sym_in] = ACTIONS(3001),
    [anon_sym_BANGin] = ACTIONS(2999),
    [anon_sym_match] = ACTIONS(3001),
    [anon_sym_select] = ACTIONS(3001),
    [anon_sym_lock] = ACTIONS(3001),
    [anon_sym_rlock] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(3001),
    [anon_sym_sql] = ACTIONS(3001),
    [sym_int_literal] = ACTIONS(3001),
    [sym_float_literal] = ACTIONS(2999),
    [sym_rune_literal] = ACTIONS(2999),
    [anon_sym_SQUOTE] = ACTIONS(2999),
    [anon_sym_DQUOTE] = ACTIONS(2999),
    [anon_sym_c_SQUOTE] = ACTIONS(2999),
    [anon_sym_c_DQUOTE] = ACTIONS(2999),
    [anon_sym_r_SQUOTE] = ACTIONS(2999),
    [anon_sym_r_DQUOTE] = ACTIONS(2999),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3001),
    [anon_sym_shared] = ACTIONS(3001),
    [anon_sym_map_LBRACK] = ACTIONS(2999),
    [anon_sym_chan] = ACTIONS(3001),
    [anon_sym_thread] = ACTIONS(3001),
    [anon_sym_atomic] = ACTIONS(3001),
  },
  [1614] = {
    [sym_line_comment] = STATE(1614),
    [sym_block_comment] = STATE(1614),
    [sym_identifier] = ACTIONS(3049),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3049),
    [anon_sym_as] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_COMMA] = ACTIONS(3047),
    [anon_sym_RBRACE] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_fn] = ACTIONS(3049),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_SLASH] = ACTIONS(3049),
    [anon_sym_PERCENT] = ACTIONS(3047),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_GT] = ACTIONS(3049),
    [anon_sym_EQ_EQ] = ACTIONS(3047),
    [anon_sym_BANG_EQ] = ACTIONS(3047),
    [anon_sym_LT_EQ] = ACTIONS(3047),
    [anon_sym_GT_EQ] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_RBRACK] = ACTIONS(3047),
    [anon_sym_struct] = ACTIONS(3049),
    [anon_sym_mut] = ACTIONS(3049),
    [anon_sym_COLON] = ACTIONS(3047),
    [anon_sym_PLUS_PLUS] = ACTIONS(3047),
    [anon_sym_DASH_DASH] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_BANG] = ACTIONS(3049),
    [anon_sym_go] = ACTIONS(3049),
    [anon_sym_spawn] = ACTIONS(3049),
    [anon_sym_json_DOTdecode] = ACTIONS(3047),
    [anon_sym_PIPE] = ACTIONS(3049),
    [anon_sym_LBRACK2] = ACTIONS(3049),
    [anon_sym_TILDE] = ACTIONS(3047),
    [anon_sym_CARET] = ACTIONS(3047),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_LT_DASH] = ACTIONS(3047),
    [anon_sym_LT_LT] = ACTIONS(3047),
    [anon_sym_GT_GT] = ACTIONS(3049),
    [anon_sym_GT_GT_GT] = ACTIONS(3047),
    [anon_sym_AMP_CARET] = ACTIONS(3047),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3047),
    [anon_sym_or] = ACTIONS(3049),
    [sym_none] = ACTIONS(3049),
    [sym_true] = ACTIONS(3049),
    [sym_false] = ACTIONS(3049),
    [sym_nil] = ACTIONS(3049),
    [anon_sym_QMARK_DOT] = ACTIONS(3047),
    [anon_sym_POUND_LBRACK] = ACTIONS(3047),
    [anon_sym_if] = ACTIONS(3049),
    [anon_sym_DOLLARif] = ACTIONS(3049),
    [anon_sym_is] = ACTIONS(3049),
    [anon_sym_BANGis] = ACTIONS(3047),
    [anon_sym_in] = ACTIONS(3049),
    [anon_sym_BANGin] = ACTIONS(3047),
    [anon_sym_match] = ACTIONS(3049),
    [anon_sym_select] = ACTIONS(3049),
    [anon_sym_lock] = ACTIONS(3049),
    [anon_sym_rlock] = ACTIONS(3049),
    [anon_sym_unsafe] = ACTIONS(3049),
    [anon_sym_sql] = ACTIONS(3049),
    [sym_int_literal] = ACTIONS(3049),
    [sym_float_literal] = ACTIONS(3047),
    [sym_rune_literal] = ACTIONS(3047),
    [anon_sym_SQUOTE] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [anon_sym_c_SQUOTE] = ACTIONS(3047),
    [anon_sym_c_DQUOTE] = ACTIONS(3047),
    [anon_sym_r_SQUOTE] = ACTIONS(3047),
    [anon_sym_r_DQUOTE] = ACTIONS(3047),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3049),
    [anon_sym_shared] = ACTIONS(3049),
    [anon_sym_map_LBRACK] = ACTIONS(3047),
    [anon_sym_chan] = ACTIONS(3049),
    [anon_sym_thread] = ACTIONS(3049),
    [anon_sym_atomic] = ACTIONS(3049),
  },
  [1615] = {
    [sym_line_comment] = STATE(1615),
    [sym_block_comment] = STATE(1615),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_as] = ACTIONS(3055),
    [anon_sym_LBRACE] = ACTIONS(3053),
    [anon_sym_COMMA] = ACTIONS(3053),
    [anon_sym_RBRACE] = ACTIONS(3053),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_fn] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_SLASH] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3053),
    [anon_sym_LT] = ACTIONS(3055),
    [anon_sym_GT] = ACTIONS(3055),
    [anon_sym_EQ_EQ] = ACTIONS(3053),
    [anon_sym_BANG_EQ] = ACTIONS(3053),
    [anon_sym_LT_EQ] = ACTIONS(3053),
    [anon_sym_GT_EQ] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_RBRACK] = ACTIONS(3053),
    [anon_sym_struct] = ACTIONS(3055),
    [anon_sym_mut] = ACTIONS(3055),
    [anon_sym_COLON] = ACTIONS(3053),
    [anon_sym_PLUS_PLUS] = ACTIONS(3053),
    [anon_sym_DASH_DASH] = ACTIONS(3053),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_BANG] = ACTIONS(3055),
    [anon_sym_go] = ACTIONS(3055),
    [anon_sym_spawn] = ACTIONS(3055),
    [anon_sym_json_DOTdecode] = ACTIONS(3053),
    [anon_sym_PIPE] = ACTIONS(3055),
    [anon_sym_LBRACK2] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3053),
    [anon_sym_CARET] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT_DASH] = ACTIONS(3053),
    [anon_sym_LT_LT] = ACTIONS(3053),
    [anon_sym_GT_GT] = ACTIONS(3055),
    [anon_sym_GT_GT_GT] = ACTIONS(3053),
    [anon_sym_AMP_CARET] = ACTIONS(3053),
    [anon_sym_AMP_AMP] = ACTIONS(3053),
    [anon_sym_PIPE_PIPE] = ACTIONS(3053),
    [anon_sym_or] = ACTIONS(3055),
    [sym_none] = ACTIONS(3055),
    [sym_true] = ACTIONS(3055),
    [sym_false] = ACTIONS(3055),
    [sym_nil] = ACTIONS(3055),
    [anon_sym_QMARK_DOT] = ACTIONS(3053),
    [anon_sym_POUND_LBRACK] = ACTIONS(3053),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_DOLLARif] = ACTIONS(3055),
    [anon_sym_is] = ACTIONS(3055),
    [anon_sym_BANGis] = ACTIONS(3053),
    [anon_sym_in] = ACTIONS(3055),
    [anon_sym_BANGin] = ACTIONS(3053),
    [anon_sym_match] = ACTIONS(3055),
    [anon_sym_select] = ACTIONS(3055),
    [anon_sym_lock] = ACTIONS(3055),
    [anon_sym_rlock] = ACTIONS(3055),
    [anon_sym_unsafe] = ACTIONS(3055),
    [anon_sym_sql] = ACTIONS(3055),
    [sym_int_literal] = ACTIONS(3055),
    [sym_float_literal] = ACTIONS(3053),
    [sym_rune_literal] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(3053),
    [anon_sym_DQUOTE] = ACTIONS(3053),
    [anon_sym_c_SQUOTE] = ACTIONS(3053),
    [anon_sym_c_DQUOTE] = ACTIONS(3053),
    [anon_sym_r_SQUOTE] = ACTIONS(3053),
    [anon_sym_r_DQUOTE] = ACTIONS(3053),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3055),
    [anon_sym_shared] = ACTIONS(3055),
    [anon_sym_map_LBRACK] = ACTIONS(3053),
    [anon_sym_chan] = ACTIONS(3055),
    [anon_sym_thread] = ACTIONS(3055),
    [anon_sym_atomic] = ACTIONS(3055),
  },
  [1616] = {
    [sym_line_comment] = STATE(1616),
    [sym_block_comment] = STATE(1616),
    [sym_identifier] = ACTIONS(2961),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2961),
    [anon_sym_as] = ACTIONS(2961),
    [anon_sym_LBRACE] = ACTIONS(2959),
    [anon_sym_COMMA] = ACTIONS(2959),
    [anon_sym_RBRACE] = ACTIONS(2959),
    [anon_sym_LPAREN] = ACTIONS(2959),
    [anon_sym_fn] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2961),
    [anon_sym_DASH] = ACTIONS(2961),
    [anon_sym_STAR] = ACTIONS(2959),
    [anon_sym_SLASH] = ACTIONS(2961),
    [anon_sym_PERCENT] = ACTIONS(2959),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_GT] = ACTIONS(2961),
    [anon_sym_EQ_EQ] = ACTIONS(2959),
    [anon_sym_BANG_EQ] = ACTIONS(2959),
    [anon_sym_LT_EQ] = ACTIONS(2959),
    [anon_sym_GT_EQ] = ACTIONS(2959),
    [anon_sym_LBRACK] = ACTIONS(2959),
    [anon_sym_RBRACK] = ACTIONS(2959),
    [anon_sym_struct] = ACTIONS(2961),
    [anon_sym_mut] = ACTIONS(2961),
    [anon_sym_COLON] = ACTIONS(2959),
    [anon_sym_PLUS_PLUS] = ACTIONS(2959),
    [anon_sym_DASH_DASH] = ACTIONS(2959),
    [anon_sym_QMARK] = ACTIONS(2961),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_go] = ACTIONS(2961),
    [anon_sym_spawn] = ACTIONS(2961),
    [anon_sym_json_DOTdecode] = ACTIONS(2959),
    [anon_sym_PIPE] = ACTIONS(2961),
    [anon_sym_LBRACK2] = ACTIONS(2961),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_CARET] = ACTIONS(2959),
    [anon_sym_AMP] = ACTIONS(2961),
    [anon_sym_LT_DASH] = ACTIONS(2959),
    [anon_sym_LT_LT] = ACTIONS(2959),
    [anon_sym_GT_GT] = ACTIONS(2961),
    [anon_sym_GT_GT_GT] = ACTIONS(2959),
    [anon_sym_AMP_CARET] = ACTIONS(2959),
    [anon_sym_AMP_AMP] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2959),
    [anon_sym_or] = ACTIONS(2961),
    [sym_none] = ACTIONS(2961),
    [sym_true] = ACTIONS(2961),
    [sym_false] = ACTIONS(2961),
    [sym_nil] = ACTIONS(2961),
    [anon_sym_QMARK_DOT] = ACTIONS(2959),
    [anon_sym_POUND_LBRACK] = ACTIONS(2959),
    [anon_sym_if] = ACTIONS(2961),
    [anon_sym_DOLLARif] = ACTIONS(2961),
    [anon_sym_is] = ACTIONS(2961),
    [anon_sym_BANGis] = ACTIONS(2959),
    [anon_sym_in] = ACTIONS(2961),
    [anon_sym_BANGin] = ACTIONS(2959),
    [anon_sym_match] = ACTIONS(2961),
    [anon_sym_select] = ACTIONS(2961),
    [anon_sym_lock] = ACTIONS(2961),
    [anon_sym_rlock] = ACTIONS(2961),
    [anon_sym_unsafe] = ACTIONS(2961),
    [anon_sym_sql] = ACTIONS(2961),
    [sym_int_literal] = ACTIONS(2961),
    [sym_float_literal] = ACTIONS(2959),
    [sym_rune_literal] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2959),
    [anon_sym_DQUOTE] = ACTIONS(2959),
    [anon_sym_c_SQUOTE] = ACTIONS(2959),
    [anon_sym_c_DQUOTE] = ACTIONS(2959),
    [anon_sym_r_SQUOTE] = ACTIONS(2959),
    [anon_sym_r_DQUOTE] = ACTIONS(2959),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2961),
    [anon_sym_shared] = ACTIONS(2961),
    [anon_sym_map_LBRACK] = ACTIONS(2959),
    [anon_sym_chan] = ACTIONS(2961),
    [anon_sym_thread] = ACTIONS(2961),
    [anon_sym_atomic] = ACTIONS(2961),
  },
  [1617] = {
    [sym_line_comment] = STATE(1617),
    [sym_block_comment] = STATE(1617),
    [sym_identifier] = ACTIONS(2973),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2973),
    [anon_sym_as] = ACTIONS(2973),
    [anon_sym_LBRACE] = ACTIONS(2971),
    [anon_sym_COMMA] = ACTIONS(2971),
    [anon_sym_RBRACE] = ACTIONS(2971),
    [anon_sym_LPAREN] = ACTIONS(2971),
    [anon_sym_fn] = ACTIONS(2973),
    [anon_sym_PLUS] = ACTIONS(2973),
    [anon_sym_DASH] = ACTIONS(2973),
    [anon_sym_STAR] = ACTIONS(2971),
    [anon_sym_SLASH] = ACTIONS(2973),
    [anon_sym_PERCENT] = ACTIONS(2971),
    [anon_sym_LT] = ACTIONS(2973),
    [anon_sym_GT] = ACTIONS(2973),
    [anon_sym_EQ_EQ] = ACTIONS(2971),
    [anon_sym_BANG_EQ] = ACTIONS(2971),
    [anon_sym_LT_EQ] = ACTIONS(2971),
    [anon_sym_GT_EQ] = ACTIONS(2971),
    [anon_sym_LBRACK] = ACTIONS(2971),
    [anon_sym_RBRACK] = ACTIONS(2971),
    [anon_sym_struct] = ACTIONS(2973),
    [anon_sym_mut] = ACTIONS(2973),
    [anon_sym_COLON] = ACTIONS(2971),
    [anon_sym_PLUS_PLUS] = ACTIONS(2971),
    [anon_sym_DASH_DASH] = ACTIONS(2971),
    [anon_sym_QMARK] = ACTIONS(2973),
    [anon_sym_BANG] = ACTIONS(2973),
    [anon_sym_go] = ACTIONS(2973),
    [anon_sym_spawn] = ACTIONS(2973),
    [anon_sym_json_DOTdecode] = ACTIONS(2971),
    [anon_sym_PIPE] = ACTIONS(2973),
    [anon_sym_LBRACK2] = ACTIONS(2973),
    [anon_sym_TILDE] = ACTIONS(2971),
    [anon_sym_CARET] = ACTIONS(2971),
    [anon_sym_AMP] = ACTIONS(2973),
    [anon_sym_LT_DASH] = ACTIONS(2971),
    [anon_sym_LT_LT] = ACTIONS(2971),
    [anon_sym_GT_GT] = ACTIONS(2973),
    [anon_sym_GT_GT_GT] = ACTIONS(2971),
    [anon_sym_AMP_CARET] = ACTIONS(2971),
    [anon_sym_AMP_AMP] = ACTIONS(2971),
    [anon_sym_PIPE_PIPE] = ACTIONS(2971),
    [anon_sym_or] = ACTIONS(2973),
    [sym_none] = ACTIONS(2973),
    [sym_true] = ACTIONS(2973),
    [sym_false] = ACTIONS(2973),
    [sym_nil] = ACTIONS(2973),
    [anon_sym_QMARK_DOT] = ACTIONS(2971),
    [anon_sym_POUND_LBRACK] = ACTIONS(2971),
    [anon_sym_if] = ACTIONS(2973),
    [anon_sym_DOLLARif] = ACTIONS(2973),
    [anon_sym_is] = ACTIONS(2973),
    [anon_sym_BANGis] = ACTIONS(2971),
    [anon_sym_in] = ACTIONS(2973),
    [anon_sym_BANGin] = ACTIONS(2971),
    [anon_sym_match] = ACTIONS(2973),
    [anon_sym_select] = ACTIONS(2973),
    [anon_sym_lock] = ACTIONS(2973),
    [anon_sym_rlock] = ACTIONS(2973),
    [anon_sym_unsafe] = ACTIONS(2973),
    [anon_sym_sql] = ACTIONS(2973),
    [sym_int_literal] = ACTIONS(2973),
    [sym_float_literal] = ACTIONS(2971),
    [sym_rune_literal] = ACTIONS(2971),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2971),
    [anon_sym_c_SQUOTE] = ACTIONS(2971),
    [anon_sym_c_DQUOTE] = ACTIONS(2971),
    [anon_sym_r_SQUOTE] = ACTIONS(2971),
    [anon_sym_r_DQUOTE] = ACTIONS(2971),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2973),
    [anon_sym_shared] = ACTIONS(2973),
    [anon_sym_map_LBRACK] = ACTIONS(2971),
    [anon_sym_chan] = ACTIONS(2973),
    [anon_sym_thread] = ACTIONS(2973),
    [anon_sym_atomic] = ACTIONS(2973),
  },
  [1618] = {
    [sym_line_comment] = STATE(1618),
    [sym_block_comment] = STATE(1618),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2453),
    [anon_sym_as] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2451),
    [anon_sym_COMMA] = ACTIONS(2451),
    [anon_sym_RBRACE] = ACTIONS(2451),
    [anon_sym_LPAREN] = ACTIONS(2451),
    [anon_sym_fn] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2451),
    [anon_sym_SLASH] = ACTIONS(2453),
    [anon_sym_PERCENT] = ACTIONS(2451),
    [anon_sym_LT] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2453),
    [anon_sym_EQ_EQ] = ACTIONS(2451),
    [anon_sym_BANG_EQ] = ACTIONS(2451),
    [anon_sym_LT_EQ] = ACTIONS(2451),
    [anon_sym_GT_EQ] = ACTIONS(2451),
    [anon_sym_LBRACK] = ACTIONS(2451),
    [anon_sym_RBRACK] = ACTIONS(2451),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_mut] = ACTIONS(2453),
    [anon_sym_COLON] = ACTIONS(2451),
    [anon_sym_PLUS_PLUS] = ACTIONS(2451),
    [anon_sym_DASH_DASH] = ACTIONS(2451),
    [anon_sym_QMARK] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(2453),
    [anon_sym_go] = ACTIONS(2453),
    [anon_sym_spawn] = ACTIONS(2453),
    [anon_sym_json_DOTdecode] = ACTIONS(2451),
    [anon_sym_PIPE] = ACTIONS(2453),
    [anon_sym_LBRACK2] = ACTIONS(2453),
    [anon_sym_TILDE] = ACTIONS(2451),
    [anon_sym_CARET] = ACTIONS(2451),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_LT_DASH] = ACTIONS(2451),
    [anon_sym_LT_LT] = ACTIONS(2451),
    [anon_sym_GT_GT] = ACTIONS(2453),
    [anon_sym_GT_GT_GT] = ACTIONS(2451),
    [anon_sym_AMP_CARET] = ACTIONS(2451),
    [anon_sym_AMP_AMP] = ACTIONS(2451),
    [anon_sym_PIPE_PIPE] = ACTIONS(2451),
    [anon_sym_or] = ACTIONS(2453),
    [sym_none] = ACTIONS(2453),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [sym_nil] = ACTIONS(2453),
    [anon_sym_QMARK_DOT] = ACTIONS(2451),
    [anon_sym_POUND_LBRACK] = ACTIONS(2451),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_DOLLARif] = ACTIONS(2453),
    [anon_sym_is] = ACTIONS(2453),
    [anon_sym_BANGis] = ACTIONS(2451),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_BANGin] = ACTIONS(2451),
    [anon_sym_match] = ACTIONS(2453),
    [anon_sym_select] = ACTIONS(2453),
    [anon_sym_lock] = ACTIONS(2453),
    [anon_sym_rlock] = ACTIONS(2453),
    [anon_sym_unsafe] = ACTIONS(2453),
    [anon_sym_sql] = ACTIONS(2453),
    [sym_int_literal] = ACTIONS(2453),
    [sym_float_literal] = ACTIONS(2451),
    [sym_rune_literal] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2451),
    [anon_sym_DQUOTE] = ACTIONS(2451),
    [anon_sym_c_SQUOTE] = ACTIONS(2451),
    [anon_sym_c_DQUOTE] = ACTIONS(2451),
    [anon_sym_r_SQUOTE] = ACTIONS(2451),
    [anon_sym_r_DQUOTE] = ACTIONS(2451),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_map_LBRACK] = ACTIONS(2451),
    [anon_sym_chan] = ACTIONS(2453),
    [anon_sym_thread] = ACTIONS(2453),
    [anon_sym_atomic] = ACTIONS(2453),
  },
  [1619] = {
    [sym_line_comment] = STATE(1619),
    [sym_block_comment] = STATE(1619),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3027),
    [anon_sym_as] = ACTIONS(3027),
    [anon_sym_LBRACE] = ACTIONS(3025),
    [anon_sym_COMMA] = ACTIONS(3025),
    [anon_sym_RBRACE] = ACTIONS(3025),
    [anon_sym_LPAREN] = ACTIONS(3025),
    [anon_sym_fn] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_STAR] = ACTIONS(3025),
    [anon_sym_SLASH] = ACTIONS(3027),
    [anon_sym_PERCENT] = ACTIONS(3025),
    [anon_sym_LT] = ACTIONS(3027),
    [anon_sym_GT] = ACTIONS(3027),
    [anon_sym_EQ_EQ] = ACTIONS(3025),
    [anon_sym_BANG_EQ] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3025),
    [anon_sym_GT_EQ] = ACTIONS(3025),
    [anon_sym_LBRACK] = ACTIONS(3025),
    [anon_sym_RBRACK] = ACTIONS(3025),
    [anon_sym_struct] = ACTIONS(3027),
    [anon_sym_mut] = ACTIONS(3027),
    [anon_sym_COLON] = ACTIONS(3025),
    [anon_sym_PLUS_PLUS] = ACTIONS(3025),
    [anon_sym_DASH_DASH] = ACTIONS(3025),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_BANG] = ACTIONS(3027),
    [anon_sym_go] = ACTIONS(3027),
    [anon_sym_spawn] = ACTIONS(3027),
    [anon_sym_json_DOTdecode] = ACTIONS(3025),
    [anon_sym_PIPE] = ACTIONS(3027),
    [anon_sym_LBRACK2] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3025),
    [anon_sym_CARET] = ACTIONS(3025),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_LT_DASH] = ACTIONS(3025),
    [anon_sym_LT_LT] = ACTIONS(3025),
    [anon_sym_GT_GT] = ACTIONS(3027),
    [anon_sym_GT_GT_GT] = ACTIONS(3025),
    [anon_sym_AMP_CARET] = ACTIONS(3025),
    [anon_sym_AMP_AMP] = ACTIONS(3025),
    [anon_sym_PIPE_PIPE] = ACTIONS(3025),
    [anon_sym_or] = ACTIONS(3027),
    [sym_none] = ACTIONS(3027),
    [sym_true] = ACTIONS(3027),
    [sym_false] = ACTIONS(3027),
    [sym_nil] = ACTIONS(3027),
    [anon_sym_QMARK_DOT] = ACTIONS(3025),
    [anon_sym_POUND_LBRACK] = ACTIONS(3025),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_DOLLARif] = ACTIONS(3027),
    [anon_sym_is] = ACTIONS(3027),
    [anon_sym_BANGis] = ACTIONS(3025),
    [anon_sym_in] = ACTIONS(3027),
    [anon_sym_BANGin] = ACTIONS(3025),
    [anon_sym_match] = ACTIONS(3027),
    [anon_sym_select] = ACTIONS(3027),
    [anon_sym_lock] = ACTIONS(3027),
    [anon_sym_rlock] = ACTIONS(3027),
    [anon_sym_unsafe] = ACTIONS(3027),
    [anon_sym_sql] = ACTIONS(3027),
    [sym_int_literal] = ACTIONS(3027),
    [sym_float_literal] = ACTIONS(3025),
    [sym_rune_literal] = ACTIONS(3025),
    [anon_sym_SQUOTE] = ACTIONS(3025),
    [anon_sym_DQUOTE] = ACTIONS(3025),
    [anon_sym_c_SQUOTE] = ACTIONS(3025),
    [anon_sym_c_DQUOTE] = ACTIONS(3025),
    [anon_sym_r_SQUOTE] = ACTIONS(3025),
    [anon_sym_r_DQUOTE] = ACTIONS(3025),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3027),
    [anon_sym_shared] = ACTIONS(3027),
    [anon_sym_map_LBRACK] = ACTIONS(3025),
    [anon_sym_chan] = ACTIONS(3027),
    [anon_sym_thread] = ACTIONS(3027),
    [anon_sym_atomic] = ACTIONS(3027),
  },
  [1620] = {
    [sym_line_comment] = STATE(1620),
    [sym_block_comment] = STATE(1620),
    [sym_identifier] = ACTIONS(3250),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3250),
    [anon_sym_as] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3248),
    [anon_sym_COMMA] = ACTIONS(3248),
    [anon_sym_RBRACE] = ACTIONS(3248),
    [anon_sym_LPAREN] = ACTIONS(3248),
    [anon_sym_fn] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_STAR] = ACTIONS(3248),
    [anon_sym_SLASH] = ACTIONS(3250),
    [anon_sym_PERCENT] = ACTIONS(3248),
    [anon_sym_LT] = ACTIONS(3250),
    [anon_sym_GT] = ACTIONS(3250),
    [anon_sym_EQ_EQ] = ACTIONS(3248),
    [anon_sym_BANG_EQ] = ACTIONS(3248),
    [anon_sym_LT_EQ] = ACTIONS(3248),
    [anon_sym_GT_EQ] = ACTIONS(3248),
    [anon_sym_LBRACK] = ACTIONS(3248),
    [anon_sym_RBRACK] = ACTIONS(3248),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_mut] = ACTIONS(3250),
    [anon_sym_COLON] = ACTIONS(3248),
    [anon_sym_PLUS_PLUS] = ACTIONS(3248),
    [anon_sym_DASH_DASH] = ACTIONS(3248),
    [anon_sym_QMARK] = ACTIONS(3250),
    [anon_sym_BANG] = ACTIONS(3250),
    [anon_sym_go] = ACTIONS(3250),
    [anon_sym_spawn] = ACTIONS(3250),
    [anon_sym_json_DOTdecode] = ACTIONS(3248),
    [anon_sym_PIPE] = ACTIONS(3250),
    [anon_sym_LBRACK2] = ACTIONS(3250),
    [anon_sym_TILDE] = ACTIONS(3248),
    [anon_sym_CARET] = ACTIONS(3248),
    [anon_sym_AMP] = ACTIONS(3250),
    [anon_sym_LT_DASH] = ACTIONS(3248),
    [anon_sym_LT_LT] = ACTIONS(3248),
    [anon_sym_GT_GT] = ACTIONS(3250),
    [anon_sym_GT_GT_GT] = ACTIONS(3248),
    [anon_sym_AMP_CARET] = ACTIONS(3248),
    [anon_sym_AMP_AMP] = ACTIONS(3248),
    [anon_sym_PIPE_PIPE] = ACTIONS(3248),
    [anon_sym_or] = ACTIONS(3250),
    [sym_none] = ACTIONS(3250),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [sym_nil] = ACTIONS(3250),
    [anon_sym_QMARK_DOT] = ACTIONS(3248),
    [anon_sym_POUND_LBRACK] = ACTIONS(3248),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_DOLLARif] = ACTIONS(3250),
    [anon_sym_is] = ACTIONS(3250),
    [anon_sym_BANGis] = ACTIONS(3248),
    [anon_sym_in] = ACTIONS(3250),
    [anon_sym_BANGin] = ACTIONS(3248),
    [anon_sym_match] = ACTIONS(3250),
    [anon_sym_select] = ACTIONS(3250),
    [anon_sym_lock] = ACTIONS(3250),
    [anon_sym_rlock] = ACTIONS(3250),
    [anon_sym_unsafe] = ACTIONS(3250),
    [anon_sym_sql] = ACTIONS(3250),
    [sym_int_literal] = ACTIONS(3250),
    [sym_float_literal] = ACTIONS(3248),
    [sym_rune_literal] = ACTIONS(3248),
    [anon_sym_SQUOTE] = ACTIONS(3248),
    [anon_sym_DQUOTE] = ACTIONS(3248),
    [anon_sym_c_SQUOTE] = ACTIONS(3248),
    [anon_sym_c_DQUOTE] = ACTIONS(3248),
    [anon_sym_r_SQUOTE] = ACTIONS(3248),
    [anon_sym_r_DQUOTE] = ACTIONS(3248),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3250),
    [anon_sym_shared] = ACTIONS(3250),
    [anon_sym_map_LBRACK] = ACTIONS(3248),
    [anon_sym_chan] = ACTIONS(3250),
    [anon_sym_thread] = ACTIONS(3250),
    [anon_sym_atomic] = ACTIONS(3250),
  },
  [1621] = {
    [sym_line_comment] = STATE(1621),
    [sym_block_comment] = STATE(1621),
    [sym_identifier] = ACTIONS(3256),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3256),
    [anon_sym_as] = ACTIONS(3256),
    [anon_sym_LBRACE] = ACTIONS(3254),
    [anon_sym_COMMA] = ACTIONS(3254),
    [anon_sym_RBRACE] = ACTIONS(3254),
    [anon_sym_LPAREN] = ACTIONS(3254),
    [anon_sym_fn] = ACTIONS(3256),
    [anon_sym_PLUS] = ACTIONS(3256),
    [anon_sym_DASH] = ACTIONS(3256),
    [anon_sym_STAR] = ACTIONS(3254),
    [anon_sym_SLASH] = ACTIONS(3256),
    [anon_sym_PERCENT] = ACTIONS(3254),
    [anon_sym_LT] = ACTIONS(3256),
    [anon_sym_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(3254),
    [anon_sym_BANG_EQ] = ACTIONS(3254),
    [anon_sym_LT_EQ] = ACTIONS(3254),
    [anon_sym_GT_EQ] = ACTIONS(3254),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [anon_sym_RBRACK] = ACTIONS(3254),
    [anon_sym_struct] = ACTIONS(3256),
    [anon_sym_mut] = ACTIONS(3256),
    [anon_sym_COLON] = ACTIONS(3254),
    [anon_sym_PLUS_PLUS] = ACTIONS(3254),
    [anon_sym_DASH_DASH] = ACTIONS(3254),
    [anon_sym_QMARK] = ACTIONS(3256),
    [anon_sym_BANG] = ACTIONS(3256),
    [anon_sym_go] = ACTIONS(3256),
    [anon_sym_spawn] = ACTIONS(3256),
    [anon_sym_json_DOTdecode] = ACTIONS(3254),
    [anon_sym_PIPE] = ACTIONS(3256),
    [anon_sym_LBRACK2] = ACTIONS(3256),
    [anon_sym_TILDE] = ACTIONS(3254),
    [anon_sym_CARET] = ACTIONS(3254),
    [anon_sym_AMP] = ACTIONS(3256),
    [anon_sym_LT_DASH] = ACTIONS(3254),
    [anon_sym_LT_LT] = ACTIONS(3254),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_GT_GT_GT] = ACTIONS(3254),
    [anon_sym_AMP_CARET] = ACTIONS(3254),
    [anon_sym_AMP_AMP] = ACTIONS(3254),
    [anon_sym_PIPE_PIPE] = ACTIONS(3254),
    [anon_sym_or] = ACTIONS(3256),
    [sym_none] = ACTIONS(3256),
    [sym_true] = ACTIONS(3256),
    [sym_false] = ACTIONS(3256),
    [sym_nil] = ACTIONS(3256),
    [anon_sym_QMARK_DOT] = ACTIONS(3254),
    [anon_sym_POUND_LBRACK] = ACTIONS(3254),
    [anon_sym_if] = ACTIONS(3256),
    [anon_sym_DOLLARif] = ACTIONS(3256),
    [anon_sym_is] = ACTIONS(3256),
    [anon_sym_BANGis] = ACTIONS(3254),
    [anon_sym_in] = ACTIONS(3256),
    [anon_sym_BANGin] = ACTIONS(3254),
    [anon_sym_match] = ACTIONS(3256),
    [anon_sym_select] = ACTIONS(3256),
    [anon_sym_lock] = ACTIONS(3256),
    [anon_sym_rlock] = ACTIONS(3256),
    [anon_sym_unsafe] = ACTIONS(3256),
    [anon_sym_sql] = ACTIONS(3256),
    [sym_int_literal] = ACTIONS(3256),
    [sym_float_literal] = ACTIONS(3254),
    [sym_rune_literal] = ACTIONS(3254),
    [anon_sym_SQUOTE] = ACTIONS(3254),
    [anon_sym_DQUOTE] = ACTIONS(3254),
    [anon_sym_c_SQUOTE] = ACTIONS(3254),
    [anon_sym_c_DQUOTE] = ACTIONS(3254),
    [anon_sym_r_SQUOTE] = ACTIONS(3254),
    [anon_sym_r_DQUOTE] = ACTIONS(3254),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3256),
    [anon_sym_shared] = ACTIONS(3256),
    [anon_sym_map_LBRACK] = ACTIONS(3254),
    [anon_sym_chan] = ACTIONS(3256),
    [anon_sym_thread] = ACTIONS(3256),
    [anon_sym_atomic] = ACTIONS(3256),
  },
  [1622] = {
    [sym_line_comment] = STATE(1622),
    [sym_block_comment] = STATE(1622),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_as] = ACTIONS(3274),
    [anon_sym_LBRACE] = ACTIONS(3272),
    [anon_sym_COMMA] = ACTIONS(3272),
    [anon_sym_RBRACE] = ACTIONS(3272),
    [anon_sym_LPAREN] = ACTIONS(3272),
    [anon_sym_fn] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3272),
    [anon_sym_SLASH] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3272),
    [anon_sym_LT] = ACTIONS(3274),
    [anon_sym_GT] = ACTIONS(3274),
    [anon_sym_EQ_EQ] = ACTIONS(3272),
    [anon_sym_BANG_EQ] = ACTIONS(3272),
    [anon_sym_LT_EQ] = ACTIONS(3272),
    [anon_sym_GT_EQ] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(3272),
    [anon_sym_RBRACK] = ACTIONS(3272),
    [anon_sym_struct] = ACTIONS(3274),
    [anon_sym_mut] = ACTIONS(3274),
    [anon_sym_COLON] = ACTIONS(3272),
    [anon_sym_PLUS_PLUS] = ACTIONS(3272),
    [anon_sym_DASH_DASH] = ACTIONS(3272),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_BANG] = ACTIONS(3274),
    [anon_sym_go] = ACTIONS(3274),
    [anon_sym_spawn] = ACTIONS(3274),
    [anon_sym_json_DOTdecode] = ACTIONS(3272),
    [anon_sym_PIPE] = ACTIONS(3274),
    [anon_sym_LBRACK2] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_CARET] = ACTIONS(3272),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3272),
    [anon_sym_LT_LT] = ACTIONS(3272),
    [anon_sym_GT_GT] = ACTIONS(3274),
    [anon_sym_GT_GT_GT] = ACTIONS(3272),
    [anon_sym_AMP_CARET] = ACTIONS(3272),
    [anon_sym_AMP_AMP] = ACTIONS(3272),
    [anon_sym_PIPE_PIPE] = ACTIONS(3272),
    [anon_sym_or] = ACTIONS(3274),
    [sym_none] = ACTIONS(3274),
    [sym_true] = ACTIONS(3274),
    [sym_false] = ACTIONS(3274),
    [sym_nil] = ACTIONS(3274),
    [anon_sym_QMARK_DOT] = ACTIONS(3272),
    [anon_sym_POUND_LBRACK] = ACTIONS(3272),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_DOLLARif] = ACTIONS(3274),
    [anon_sym_is] = ACTIONS(3274),
    [anon_sym_BANGis] = ACTIONS(3272),
    [anon_sym_in] = ACTIONS(3274),
    [anon_sym_BANGin] = ACTIONS(3272),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_select] = ACTIONS(3274),
    [anon_sym_lock] = ACTIONS(3274),
    [anon_sym_rlock] = ACTIONS(3274),
    [anon_sym_unsafe] = ACTIONS(3274),
    [anon_sym_sql] = ACTIONS(3274),
    [sym_int_literal] = ACTIONS(3274),
    [sym_float_literal] = ACTIONS(3272),
    [sym_rune_literal] = ACTIONS(3272),
    [anon_sym_SQUOTE] = ACTIONS(3272),
    [anon_sym_DQUOTE] = ACTIONS(3272),
    [anon_sym_c_SQUOTE] = ACTIONS(3272),
    [anon_sym_c_DQUOTE] = ACTIONS(3272),
    [anon_sym_r_SQUOTE] = ACTIONS(3272),
    [anon_sym_r_DQUOTE] = ACTIONS(3272),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3274),
    [anon_sym_shared] = ACTIONS(3274),
    [anon_sym_map_LBRACK] = ACTIONS(3272),
    [anon_sym_chan] = ACTIONS(3274),
    [anon_sym_thread] = ACTIONS(3274),
    [anon_sym_atomic] = ACTIONS(3274),
  },
  [1623] = {
    [sym_line_comment] = STATE(1623),
    [sym_block_comment] = STATE(1623),
    [sym_identifier] = ACTIONS(2377),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2377),
    [anon_sym_as] = ACTIONS(2377),
    [anon_sym_LBRACE] = ACTIONS(2375),
    [anon_sym_COMMA] = ACTIONS(2375),
    [anon_sym_RBRACE] = ACTIONS(2375),
    [anon_sym_LPAREN] = ACTIONS(2375),
    [anon_sym_fn] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2377),
    [anon_sym_DASH] = ACTIONS(2377),
    [anon_sym_STAR] = ACTIONS(2375),
    [anon_sym_SLASH] = ACTIONS(2377),
    [anon_sym_PERCENT] = ACTIONS(2375),
    [anon_sym_LT] = ACTIONS(2377),
    [anon_sym_GT] = ACTIONS(2377),
    [anon_sym_EQ_EQ] = ACTIONS(2375),
    [anon_sym_BANG_EQ] = ACTIONS(2375),
    [anon_sym_LT_EQ] = ACTIONS(2375),
    [anon_sym_GT_EQ] = ACTIONS(2375),
    [anon_sym_LBRACK] = ACTIONS(2375),
    [anon_sym_RBRACK] = ACTIONS(2375),
    [anon_sym_struct] = ACTIONS(2377),
    [anon_sym_mut] = ACTIONS(2377),
    [anon_sym_COLON] = ACTIONS(2375),
    [anon_sym_PLUS_PLUS] = ACTIONS(2375),
    [anon_sym_DASH_DASH] = ACTIONS(2375),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2377),
    [anon_sym_go] = ACTIONS(2377),
    [anon_sym_spawn] = ACTIONS(2377),
    [anon_sym_json_DOTdecode] = ACTIONS(2375),
    [anon_sym_PIPE] = ACTIONS(2377),
    [anon_sym_LBRACK2] = ACTIONS(2377),
    [anon_sym_TILDE] = ACTIONS(2375),
    [anon_sym_CARET] = ACTIONS(2375),
    [anon_sym_AMP] = ACTIONS(2377),
    [anon_sym_LT_DASH] = ACTIONS(2375),
    [anon_sym_LT_LT] = ACTIONS(2375),
    [anon_sym_GT_GT] = ACTIONS(2377),
    [anon_sym_GT_GT_GT] = ACTIONS(2375),
    [anon_sym_AMP_CARET] = ACTIONS(2375),
    [anon_sym_AMP_AMP] = ACTIONS(2375),
    [anon_sym_PIPE_PIPE] = ACTIONS(2375),
    [anon_sym_or] = ACTIONS(2377),
    [sym_none] = ACTIONS(2377),
    [sym_true] = ACTIONS(2377),
    [sym_false] = ACTIONS(2377),
    [sym_nil] = ACTIONS(2377),
    [anon_sym_QMARK_DOT] = ACTIONS(2375),
    [anon_sym_POUND_LBRACK] = ACTIONS(2375),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_DOLLARif] = ACTIONS(2377),
    [anon_sym_is] = ACTIONS(2377),
    [anon_sym_BANGis] = ACTIONS(2375),
    [anon_sym_in] = ACTIONS(2377),
    [anon_sym_BANGin] = ACTIONS(2375),
    [anon_sym_match] = ACTIONS(2377),
    [anon_sym_select] = ACTIONS(2377),
    [anon_sym_lock] = ACTIONS(2377),
    [anon_sym_rlock] = ACTIONS(2377),
    [anon_sym_unsafe] = ACTIONS(2377),
    [anon_sym_sql] = ACTIONS(2377),
    [sym_int_literal] = ACTIONS(2377),
    [sym_float_literal] = ACTIONS(2375),
    [sym_rune_literal] = ACTIONS(2375),
    [anon_sym_SQUOTE] = ACTIONS(2375),
    [anon_sym_DQUOTE] = ACTIONS(2375),
    [anon_sym_c_SQUOTE] = ACTIONS(2375),
    [anon_sym_c_DQUOTE] = ACTIONS(2375),
    [anon_sym_r_SQUOTE] = ACTIONS(2375),
    [anon_sym_r_DQUOTE] = ACTIONS(2375),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2377),
    [anon_sym_shared] = ACTIONS(2377),
    [anon_sym_map_LBRACK] = ACTIONS(2375),
    [anon_sym_chan] = ACTIONS(2377),
    [anon_sym_thread] = ACTIONS(2377),
    [anon_sym_atomic] = ACTIONS(2377),
  },
  [1624] = {
    [sym_line_comment] = STATE(1624),
    [sym_block_comment] = STATE(1624),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3336),
    [anon_sym_as] = ACTIONS(3336),
    [anon_sym_LBRACE] = ACTIONS(3334),
    [anon_sym_COMMA] = ACTIONS(3334),
    [anon_sym_RBRACE] = ACTIONS(3334),
    [anon_sym_LPAREN] = ACTIONS(3334),
    [anon_sym_fn] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3334),
    [anon_sym_SLASH] = ACTIONS(3336),
    [anon_sym_PERCENT] = ACTIONS(3334),
    [anon_sym_LT] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3336),
    [anon_sym_EQ_EQ] = ACTIONS(3334),
    [anon_sym_BANG_EQ] = ACTIONS(3334),
    [anon_sym_LT_EQ] = ACTIONS(3334),
    [anon_sym_GT_EQ] = ACTIONS(3334),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_RBRACK] = ACTIONS(3334),
    [anon_sym_struct] = ACTIONS(3336),
    [anon_sym_mut] = ACTIONS(3336),
    [anon_sym_COLON] = ACTIONS(3334),
    [anon_sym_PLUS_PLUS] = ACTIONS(3334),
    [anon_sym_DASH_DASH] = ACTIONS(3334),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_BANG] = ACTIONS(3336),
    [anon_sym_go] = ACTIONS(3336),
    [anon_sym_spawn] = ACTIONS(3336),
    [anon_sym_json_DOTdecode] = ACTIONS(3334),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3334),
    [anon_sym_CARET] = ACTIONS(3334),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LT_DASH] = ACTIONS(3334),
    [anon_sym_LT_LT] = ACTIONS(3334),
    [anon_sym_GT_GT] = ACTIONS(3336),
    [anon_sym_GT_GT_GT] = ACTIONS(3334),
    [anon_sym_AMP_CARET] = ACTIONS(3334),
    [anon_sym_AMP_AMP] = ACTIONS(3334),
    [anon_sym_PIPE_PIPE] = ACTIONS(3334),
    [anon_sym_or] = ACTIONS(3336),
    [sym_none] = ACTIONS(3336),
    [sym_true] = ACTIONS(3336),
    [sym_false] = ACTIONS(3336),
    [sym_nil] = ACTIONS(3336),
    [anon_sym_QMARK_DOT] = ACTIONS(3334),
    [anon_sym_POUND_LBRACK] = ACTIONS(3334),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_DOLLARif] = ACTIONS(3336),
    [anon_sym_is] = ACTIONS(3336),
    [anon_sym_BANGis] = ACTIONS(3334),
    [anon_sym_in] = ACTIONS(3336),
    [anon_sym_BANGin] = ACTIONS(3334),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_select] = ACTIONS(3336),
    [anon_sym_lock] = ACTIONS(3336),
    [anon_sym_rlock] = ACTIONS(3336),
    [anon_sym_unsafe] = ACTIONS(3336),
    [anon_sym_sql] = ACTIONS(3336),
    [sym_int_literal] = ACTIONS(3336),
    [sym_float_literal] = ACTIONS(3334),
    [sym_rune_literal] = ACTIONS(3334),
    [anon_sym_SQUOTE] = ACTIONS(3334),
    [anon_sym_DQUOTE] = ACTIONS(3334),
    [anon_sym_c_SQUOTE] = ACTIONS(3334),
    [anon_sym_c_DQUOTE] = ACTIONS(3334),
    [anon_sym_r_SQUOTE] = ACTIONS(3334),
    [anon_sym_r_DQUOTE] = ACTIONS(3334),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3336),
    [anon_sym_shared] = ACTIONS(3336),
    [anon_sym_map_LBRACK] = ACTIONS(3334),
    [anon_sym_chan] = ACTIONS(3336),
    [anon_sym_thread] = ACTIONS(3336),
    [anon_sym_atomic] = ACTIONS(3336),
  },
  [1625] = {
    [sym_line_comment] = STATE(1625),
    [sym_block_comment] = STATE(1625),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3031),
    [anon_sym_as] = ACTIONS(3031),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_COMMA] = ACTIONS(3029),
    [anon_sym_RBRACE] = ACTIONS(3029),
    [anon_sym_LPAREN] = ACTIONS(3029),
    [anon_sym_fn] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_STAR] = ACTIONS(3029),
    [anon_sym_SLASH] = ACTIONS(3031),
    [anon_sym_PERCENT] = ACTIONS(3029),
    [anon_sym_LT] = ACTIONS(3031),
    [anon_sym_GT] = ACTIONS(3031),
    [anon_sym_EQ_EQ] = ACTIONS(3029),
    [anon_sym_BANG_EQ] = ACTIONS(3029),
    [anon_sym_LT_EQ] = ACTIONS(3029),
    [anon_sym_GT_EQ] = ACTIONS(3029),
    [anon_sym_LBRACK] = ACTIONS(3029),
    [anon_sym_RBRACK] = ACTIONS(3029),
    [anon_sym_struct] = ACTIONS(3031),
    [anon_sym_mut] = ACTIONS(3031),
    [anon_sym_COLON] = ACTIONS(3029),
    [anon_sym_PLUS_PLUS] = ACTIONS(3029),
    [anon_sym_DASH_DASH] = ACTIONS(3029),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_BANG] = ACTIONS(3031),
    [anon_sym_go] = ACTIONS(3031),
    [anon_sym_spawn] = ACTIONS(3031),
    [anon_sym_json_DOTdecode] = ACTIONS(3029),
    [anon_sym_PIPE] = ACTIONS(3031),
    [anon_sym_LBRACK2] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3029),
    [anon_sym_CARET] = ACTIONS(3029),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_LT_DASH] = ACTIONS(3029),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3031),
    [anon_sym_GT_GT_GT] = ACTIONS(3029),
    [anon_sym_AMP_CARET] = ACTIONS(3029),
    [anon_sym_AMP_AMP] = ACTIONS(3029),
    [anon_sym_PIPE_PIPE] = ACTIONS(3029),
    [anon_sym_or] = ACTIONS(3031),
    [sym_none] = ACTIONS(3031),
    [sym_true] = ACTIONS(3031),
    [sym_false] = ACTIONS(3031),
    [sym_nil] = ACTIONS(3031),
    [anon_sym_QMARK_DOT] = ACTIONS(3029),
    [anon_sym_POUND_LBRACK] = ACTIONS(3029),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_DOLLARif] = ACTIONS(3031),
    [anon_sym_is] = ACTIONS(3031),
    [anon_sym_BANGis] = ACTIONS(3029),
    [anon_sym_in] = ACTIONS(3031),
    [anon_sym_BANGin] = ACTIONS(3029),
    [anon_sym_match] = ACTIONS(3031),
    [anon_sym_select] = ACTIONS(3031),
    [anon_sym_lock] = ACTIONS(3031),
    [anon_sym_rlock] = ACTIONS(3031),
    [anon_sym_unsafe] = ACTIONS(3031),
    [anon_sym_sql] = ACTIONS(3031),
    [sym_int_literal] = ACTIONS(3031),
    [sym_float_literal] = ACTIONS(3029),
    [sym_rune_literal] = ACTIONS(3029),
    [anon_sym_SQUOTE] = ACTIONS(3029),
    [anon_sym_DQUOTE] = ACTIONS(3029),
    [anon_sym_c_SQUOTE] = ACTIONS(3029),
    [anon_sym_c_DQUOTE] = ACTIONS(3029),
    [anon_sym_r_SQUOTE] = ACTIONS(3029),
    [anon_sym_r_DQUOTE] = ACTIONS(3029),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3031),
    [anon_sym_shared] = ACTIONS(3031),
    [anon_sym_map_LBRACK] = ACTIONS(3029),
    [anon_sym_chan] = ACTIONS(3031),
    [anon_sym_thread] = ACTIONS(3031),
    [anon_sym_atomic] = ACTIONS(3031),
  },
  [1626] = {
    [sym_line_comment] = STATE(1626),
    [sym_block_comment] = STATE(1626),
    [sym_identifier] = ACTIONS(3041),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3041),
    [anon_sym_as] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3039),
    [anon_sym_RBRACE] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_fn] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3041),
    [anon_sym_DASH] = ACTIONS(3041),
    [anon_sym_STAR] = ACTIONS(3039),
    [anon_sym_SLASH] = ACTIONS(3041),
    [anon_sym_PERCENT] = ACTIONS(3039),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_GT] = ACTIONS(3041),
    [anon_sym_EQ_EQ] = ACTIONS(3039),
    [anon_sym_BANG_EQ] = ACTIONS(3039),
    [anon_sym_LT_EQ] = ACTIONS(3039),
    [anon_sym_GT_EQ] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_RBRACK] = ACTIONS(3039),
    [anon_sym_struct] = ACTIONS(3041),
    [anon_sym_mut] = ACTIONS(3041),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_PLUS_PLUS] = ACTIONS(3039),
    [anon_sym_DASH_DASH] = ACTIONS(3039),
    [anon_sym_QMARK] = ACTIONS(3041),
    [anon_sym_BANG] = ACTIONS(3041),
    [anon_sym_go] = ACTIONS(3041),
    [anon_sym_spawn] = ACTIONS(3041),
    [anon_sym_json_DOTdecode] = ACTIONS(3039),
    [anon_sym_PIPE] = ACTIONS(3041),
    [anon_sym_LBRACK2] = ACTIONS(3041),
    [anon_sym_TILDE] = ACTIONS(3039),
    [anon_sym_CARET] = ACTIONS(3039),
    [anon_sym_AMP] = ACTIONS(3041),
    [anon_sym_LT_DASH] = ACTIONS(3039),
    [anon_sym_LT_LT] = ACTIONS(3039),
    [anon_sym_GT_GT] = ACTIONS(3041),
    [anon_sym_GT_GT_GT] = ACTIONS(3039),
    [anon_sym_AMP_CARET] = ACTIONS(3039),
    [anon_sym_AMP_AMP] = ACTIONS(3039),
    [anon_sym_PIPE_PIPE] = ACTIONS(3039),
    [anon_sym_or] = ACTIONS(3041),
    [sym_none] = ACTIONS(3041),
    [sym_true] = ACTIONS(3041),
    [sym_false] = ACTIONS(3041),
    [sym_nil] = ACTIONS(3041),
    [anon_sym_QMARK_DOT] = ACTIONS(3039),
    [anon_sym_POUND_LBRACK] = ACTIONS(3039),
    [anon_sym_if] = ACTIONS(3041),
    [anon_sym_DOLLARif] = ACTIONS(3041),
    [anon_sym_is] = ACTIONS(3041),
    [anon_sym_BANGis] = ACTIONS(3039),
    [anon_sym_in] = ACTIONS(3041),
    [anon_sym_BANGin] = ACTIONS(3039),
    [anon_sym_match] = ACTIONS(3041),
    [anon_sym_select] = ACTIONS(3041),
    [anon_sym_lock] = ACTIONS(3041),
    [anon_sym_rlock] = ACTIONS(3041),
    [anon_sym_unsafe] = ACTIONS(3041),
    [anon_sym_sql] = ACTIONS(3041),
    [sym_int_literal] = ACTIONS(3041),
    [sym_float_literal] = ACTIONS(3039),
    [sym_rune_literal] = ACTIONS(3039),
    [anon_sym_SQUOTE] = ACTIONS(3039),
    [anon_sym_DQUOTE] = ACTIONS(3039),
    [anon_sym_c_SQUOTE] = ACTIONS(3039),
    [anon_sym_c_DQUOTE] = ACTIONS(3039),
    [anon_sym_r_SQUOTE] = ACTIONS(3039),
    [anon_sym_r_DQUOTE] = ACTIONS(3039),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3041),
    [anon_sym_shared] = ACTIONS(3041),
    [anon_sym_map_LBRACK] = ACTIONS(3039),
    [anon_sym_chan] = ACTIONS(3041),
    [anon_sym_thread] = ACTIONS(3041),
    [anon_sym_atomic] = ACTIONS(3041),
  },
  [1627] = {
    [sym_line_comment] = STATE(1627),
    [sym_block_comment] = STATE(1627),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3340),
    [anon_sym_as] = ACTIONS(3340),
    [anon_sym_LBRACE] = ACTIONS(3338),
    [anon_sym_COMMA] = ACTIONS(3338),
    [anon_sym_RBRACE] = ACTIONS(3338),
    [anon_sym_LPAREN] = ACTIONS(3338),
    [anon_sym_fn] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_SLASH] = ACTIONS(3340),
    [anon_sym_PERCENT] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3340),
    [anon_sym_GT] = ACTIONS(3340),
    [anon_sym_EQ_EQ] = ACTIONS(3338),
    [anon_sym_BANG_EQ] = ACTIONS(3338),
    [anon_sym_LT_EQ] = ACTIONS(3338),
    [anon_sym_GT_EQ] = ACTIONS(3338),
    [anon_sym_LBRACK] = ACTIONS(3338),
    [anon_sym_RBRACK] = ACTIONS(3338),
    [anon_sym_struct] = ACTIONS(3340),
    [anon_sym_mut] = ACTIONS(3340),
    [anon_sym_COLON] = ACTIONS(3338),
    [anon_sym_PLUS_PLUS] = ACTIONS(3338),
    [anon_sym_DASH_DASH] = ACTIONS(3338),
    [anon_sym_QMARK] = ACTIONS(3340),
    [anon_sym_BANG] = ACTIONS(3340),
    [anon_sym_go] = ACTIONS(3340),
    [anon_sym_spawn] = ACTIONS(3340),
    [anon_sym_json_DOTdecode] = ACTIONS(3338),
    [anon_sym_PIPE] = ACTIONS(3340),
    [anon_sym_LBRACK2] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_CARET] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LT_DASH] = ACTIONS(3338),
    [anon_sym_LT_LT] = ACTIONS(3338),
    [anon_sym_GT_GT] = ACTIONS(3340),
    [anon_sym_GT_GT_GT] = ACTIONS(3338),
    [anon_sym_AMP_CARET] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_PIPE_PIPE] = ACTIONS(3338),
    [anon_sym_or] = ACTIONS(3340),
    [sym_none] = ACTIONS(3340),
    [sym_true] = ACTIONS(3340),
    [sym_false] = ACTIONS(3340),
    [sym_nil] = ACTIONS(3340),
    [anon_sym_QMARK_DOT] = ACTIONS(3338),
    [anon_sym_POUND_LBRACK] = ACTIONS(3338),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_DOLLARif] = ACTIONS(3340),
    [anon_sym_is] = ACTIONS(3340),
    [anon_sym_BANGis] = ACTIONS(3338),
    [anon_sym_in] = ACTIONS(3340),
    [anon_sym_BANGin] = ACTIONS(3338),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_select] = ACTIONS(3340),
    [anon_sym_lock] = ACTIONS(3340),
    [anon_sym_rlock] = ACTIONS(3340),
    [anon_sym_unsafe] = ACTIONS(3340),
    [anon_sym_sql] = ACTIONS(3340),
    [sym_int_literal] = ACTIONS(3340),
    [sym_float_literal] = ACTIONS(3338),
    [sym_rune_literal] = ACTIONS(3338),
    [anon_sym_SQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE] = ACTIONS(3338),
    [anon_sym_c_SQUOTE] = ACTIONS(3338),
    [anon_sym_c_DQUOTE] = ACTIONS(3338),
    [anon_sym_r_SQUOTE] = ACTIONS(3338),
    [anon_sym_r_DQUOTE] = ACTIONS(3338),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3340),
    [anon_sym_shared] = ACTIONS(3340),
    [anon_sym_map_LBRACK] = ACTIONS(3338),
    [anon_sym_chan] = ACTIONS(3340),
    [anon_sym_thread] = ACTIONS(3340),
    [anon_sym_atomic] = ACTIONS(3340),
  },
  [1628] = {
    [sym_line_comment] = STATE(1628),
    [sym_block_comment] = STATE(1628),
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2177),
    [anon_sym_as] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_COMMA] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_LPAREN] = ACTIONS(2371),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_SLASH] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2371),
    [anon_sym_BANG_EQ] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2371),
    [anon_sym_GT_EQ] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_RBRACK] = ACTIONS(2371),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_mut] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_QMARK] = ACTIONS(2373),
    [anon_sym_BANG] = ACTIONS(2373),
    [anon_sym_go] = ACTIONS(2373),
    [anon_sym_spawn] = ACTIONS(2373),
    [anon_sym_json_DOTdecode] = ACTIONS(2371),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_LBRACK2] = ACTIONS(2373),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_CARET] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2371),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_CARET] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_or] = ACTIONS(2373),
    [sym_none] = ACTIONS(2373),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [sym_nil] = ACTIONS(2373),
    [anon_sym_QMARK_DOT] = ACTIONS(2371),
    [anon_sym_POUND_LBRACK] = ACTIONS(2371),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_DOLLARif] = ACTIONS(2373),
    [anon_sym_is] = ACTIONS(2373),
    [anon_sym_BANGis] = ACTIONS(2371),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_BANGin] = ACTIONS(2371),
    [anon_sym_match] = ACTIONS(2373),
    [anon_sym_select] = ACTIONS(2373),
    [anon_sym_lock] = ACTIONS(2373),
    [anon_sym_rlock] = ACTIONS(2373),
    [anon_sym_unsafe] = ACTIONS(2373),
    [anon_sym_sql] = ACTIONS(2373),
    [sym_int_literal] = ACTIONS(2373),
    [sym_float_literal] = ACTIONS(2371),
    [sym_rune_literal] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [anon_sym_c_SQUOTE] = ACTIONS(2371),
    [anon_sym_c_DQUOTE] = ACTIONS(2371),
    [anon_sym_r_SQUOTE] = ACTIONS(2371),
    [anon_sym_r_DQUOTE] = ACTIONS(2371),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_map_LBRACK] = ACTIONS(2371),
    [anon_sym_chan] = ACTIONS(2373),
    [anon_sym_thread] = ACTIONS(2373),
    [anon_sym_atomic] = ACTIONS(2373),
  },
  [1629] = {
    [sym_line_comment] = STATE(1629),
    [sym_block_comment] = STATE(1629),
    [sym_identifier] = ACTIONS(3080),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3080),
    [anon_sym_as] = ACTIONS(3080),
    [anon_sym_LBRACE] = ACTIONS(3078),
    [anon_sym_COMMA] = ACTIONS(3078),
    [anon_sym_RBRACE] = ACTIONS(3078),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_fn] = ACTIONS(3080),
    [anon_sym_PLUS] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3080),
    [anon_sym_STAR] = ACTIONS(3078),
    [anon_sym_SLASH] = ACTIONS(3080),
    [anon_sym_PERCENT] = ACTIONS(3078),
    [anon_sym_LT] = ACTIONS(3080),
    [anon_sym_GT] = ACTIONS(3080),
    [anon_sym_EQ_EQ] = ACTIONS(3078),
    [anon_sym_BANG_EQ] = ACTIONS(3078),
    [anon_sym_LT_EQ] = ACTIONS(3078),
    [anon_sym_GT_EQ] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_RBRACK] = ACTIONS(3078),
    [anon_sym_struct] = ACTIONS(3080),
    [anon_sym_mut] = ACTIONS(3080),
    [anon_sym_COLON] = ACTIONS(3078),
    [anon_sym_PLUS_PLUS] = ACTIONS(3078),
    [anon_sym_DASH_DASH] = ACTIONS(3078),
    [anon_sym_QMARK] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_go] = ACTIONS(3080),
    [anon_sym_spawn] = ACTIONS(3080),
    [anon_sym_json_DOTdecode] = ACTIONS(3078),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_LBRACK2] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3078),
    [anon_sym_CARET] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3080),
    [anon_sym_LT_DASH] = ACTIONS(3078),
    [anon_sym_LT_LT] = ACTIONS(3078),
    [anon_sym_GT_GT] = ACTIONS(3080),
    [anon_sym_GT_GT_GT] = ACTIONS(3078),
    [anon_sym_AMP_CARET] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_PIPE_PIPE] = ACTIONS(3078),
    [anon_sym_or] = ACTIONS(3080),
    [sym_none] = ACTIONS(3080),
    [sym_true] = ACTIONS(3080),
    [sym_false] = ACTIONS(3080),
    [sym_nil] = ACTIONS(3080),
    [anon_sym_QMARK_DOT] = ACTIONS(3078),
    [anon_sym_POUND_LBRACK] = ACTIONS(3078),
    [anon_sym_if] = ACTIONS(3080),
    [anon_sym_DOLLARif] = ACTIONS(3080),
    [anon_sym_is] = ACTIONS(3080),
    [anon_sym_BANGis] = ACTIONS(3078),
    [anon_sym_in] = ACTIONS(3080),
    [anon_sym_BANGin] = ACTIONS(3078),
    [anon_sym_match] = ACTIONS(3080),
    [anon_sym_select] = ACTIONS(3080),
    [anon_sym_lock] = ACTIONS(3080),
    [anon_sym_rlock] = ACTIONS(3080),
    [anon_sym_unsafe] = ACTIONS(3080),
    [anon_sym_sql] = ACTIONS(3080),
    [sym_int_literal] = ACTIONS(3080),
    [sym_float_literal] = ACTIONS(3078),
    [sym_rune_literal] = ACTIONS(3078),
    [anon_sym_SQUOTE] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [anon_sym_c_SQUOTE] = ACTIONS(3078),
    [anon_sym_c_DQUOTE] = ACTIONS(3078),
    [anon_sym_r_SQUOTE] = ACTIONS(3078),
    [anon_sym_r_DQUOTE] = ACTIONS(3078),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3080),
    [anon_sym_shared] = ACTIONS(3080),
    [anon_sym_map_LBRACK] = ACTIONS(3078),
    [anon_sym_chan] = ACTIONS(3080),
    [anon_sym_thread] = ACTIONS(3080),
    [anon_sym_atomic] = ACTIONS(3080),
  },
  [1630] = {
    [sym_line_comment] = STATE(1630),
    [sym_block_comment] = STATE(1630),
    [sym_identifier] = ACTIONS(3350),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3350),
    [anon_sym_as] = ACTIONS(3350),
    [anon_sym_LBRACE] = ACTIONS(3348),
    [anon_sym_COMMA] = ACTIONS(3348),
    [anon_sym_RBRACE] = ACTIONS(3348),
    [anon_sym_LPAREN] = ACTIONS(3348),
    [anon_sym_fn] = ACTIONS(3350),
    [anon_sym_PLUS] = ACTIONS(3350),
    [anon_sym_DASH] = ACTIONS(3350),
    [anon_sym_STAR] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3350),
    [anon_sym_PERCENT] = ACTIONS(3348),
    [anon_sym_LT] = ACTIONS(3350),
    [anon_sym_GT] = ACTIONS(3350),
    [anon_sym_EQ_EQ] = ACTIONS(3348),
    [anon_sym_BANG_EQ] = ACTIONS(3348),
    [anon_sym_LT_EQ] = ACTIONS(3348),
    [anon_sym_GT_EQ] = ACTIONS(3348),
    [anon_sym_LBRACK] = ACTIONS(3348),
    [anon_sym_RBRACK] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3350),
    [anon_sym_mut] = ACTIONS(3350),
    [anon_sym_COLON] = ACTIONS(3348),
    [anon_sym_PLUS_PLUS] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3348),
    [anon_sym_QMARK] = ACTIONS(3350),
    [anon_sym_BANG] = ACTIONS(3350),
    [anon_sym_go] = ACTIONS(3350),
    [anon_sym_spawn] = ACTIONS(3350),
    [anon_sym_json_DOTdecode] = ACTIONS(3348),
    [anon_sym_PIPE] = ACTIONS(3350),
    [anon_sym_LBRACK2] = ACTIONS(3350),
    [anon_sym_TILDE] = ACTIONS(3348),
    [anon_sym_CARET] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3350),
    [anon_sym_LT_DASH] = ACTIONS(3348),
    [anon_sym_LT_LT] = ACTIONS(3348),
    [anon_sym_GT_GT] = ACTIONS(3350),
    [anon_sym_GT_GT_GT] = ACTIONS(3348),
    [anon_sym_AMP_CARET] = ACTIONS(3348),
    [anon_sym_AMP_AMP] = ACTIONS(3348),
    [anon_sym_PIPE_PIPE] = ACTIONS(3348),
    [anon_sym_or] = ACTIONS(3350),
    [sym_none] = ACTIONS(3350),
    [sym_true] = ACTIONS(3350),
    [sym_false] = ACTIONS(3350),
    [sym_nil] = ACTIONS(3350),
    [anon_sym_QMARK_DOT] = ACTIONS(3348),
    [anon_sym_POUND_LBRACK] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3350),
    [anon_sym_DOLLARif] = ACTIONS(3350),
    [anon_sym_is] = ACTIONS(3350),
    [anon_sym_BANGis] = ACTIONS(3348),
    [anon_sym_in] = ACTIONS(3350),
    [anon_sym_BANGin] = ACTIONS(3348),
    [anon_sym_match] = ACTIONS(3350),
    [anon_sym_select] = ACTIONS(3350),
    [anon_sym_lock] = ACTIONS(3350),
    [anon_sym_rlock] = ACTIONS(3350),
    [anon_sym_unsafe] = ACTIONS(3350),
    [anon_sym_sql] = ACTIONS(3350),
    [sym_int_literal] = ACTIONS(3350),
    [sym_float_literal] = ACTIONS(3348),
    [sym_rune_literal] = ACTIONS(3348),
    [anon_sym_SQUOTE] = ACTIONS(3348),
    [anon_sym_DQUOTE] = ACTIONS(3348),
    [anon_sym_c_SQUOTE] = ACTIONS(3348),
    [anon_sym_c_DQUOTE] = ACTIONS(3348),
    [anon_sym_r_SQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3348),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3350),
    [anon_sym_shared] = ACTIONS(3350),
    [anon_sym_map_LBRACK] = ACTIONS(3348),
    [anon_sym_chan] = ACTIONS(3350),
    [anon_sym_thread] = ACTIONS(3350),
    [anon_sym_atomic] = ACTIONS(3350),
  },
  [1631] = {
    [sym_line_comment] = STATE(1631),
    [sym_block_comment] = STATE(1631),
    [sym_identifier] = ACTIONS(2947),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2947),
    [anon_sym_as] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2945),
    [anon_sym_COMMA] = ACTIONS(2945),
    [anon_sym_RBRACE] = ACTIONS(2945),
    [anon_sym_LPAREN] = ACTIONS(2945),
    [anon_sym_fn] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_SLASH] = ACTIONS(2947),
    [anon_sym_PERCENT] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2947),
    [anon_sym_EQ_EQ] = ACTIONS(2945),
    [anon_sym_BANG_EQ] = ACTIONS(2945),
    [anon_sym_LT_EQ] = ACTIONS(2945),
    [anon_sym_GT_EQ] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(2945),
    [anon_sym_RBRACK] = ACTIONS(2945),
    [anon_sym_struct] = ACTIONS(2947),
    [anon_sym_mut] = ACTIONS(2947),
    [anon_sym_COLON] = ACTIONS(2945),
    [anon_sym_PLUS_PLUS] = ACTIONS(2945),
    [anon_sym_DASH_DASH] = ACTIONS(2945),
    [anon_sym_QMARK] = ACTIONS(2947),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_go] = ACTIONS(2947),
    [anon_sym_spawn] = ACTIONS(2947),
    [anon_sym_json_DOTdecode] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2947),
    [anon_sym_LBRACK2] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2945),
    [anon_sym_CARET] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2947),
    [anon_sym_LT_DASH] = ACTIONS(2945),
    [anon_sym_LT_LT] = ACTIONS(2945),
    [anon_sym_GT_GT] = ACTIONS(2947),
    [anon_sym_GT_GT_GT] = ACTIONS(2945),
    [anon_sym_AMP_CARET] = ACTIONS(2945),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [anon_sym_or] = ACTIONS(2947),
    [sym_none] = ACTIONS(2947),
    [sym_true] = ACTIONS(2947),
    [sym_false] = ACTIONS(2947),
    [sym_nil] = ACTIONS(2947),
    [anon_sym_QMARK_DOT] = ACTIONS(2945),
    [anon_sym_POUND_LBRACK] = ACTIONS(2945),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_DOLLARif] = ACTIONS(2947),
    [anon_sym_is] = ACTIONS(2947),
    [anon_sym_BANGis] = ACTIONS(2945),
    [anon_sym_in] = ACTIONS(2947),
    [anon_sym_BANGin] = ACTIONS(2945),
    [anon_sym_match] = ACTIONS(2947),
    [anon_sym_select] = ACTIONS(2947),
    [anon_sym_lock] = ACTIONS(2947),
    [anon_sym_rlock] = ACTIONS(2947),
    [anon_sym_unsafe] = ACTIONS(2947),
    [anon_sym_sql] = ACTIONS(2947),
    [sym_int_literal] = ACTIONS(2947),
    [sym_float_literal] = ACTIONS(2945),
    [sym_rune_literal] = ACTIONS(2945),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [anon_sym_c_SQUOTE] = ACTIONS(2945),
    [anon_sym_c_DQUOTE] = ACTIONS(2945),
    [anon_sym_r_SQUOTE] = ACTIONS(2945),
    [anon_sym_r_DQUOTE] = ACTIONS(2945),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2947),
    [anon_sym_shared] = ACTIONS(2947),
    [anon_sym_map_LBRACK] = ACTIONS(2945),
    [anon_sym_chan] = ACTIONS(2947),
    [anon_sym_thread] = ACTIONS(2947),
    [anon_sym_atomic] = ACTIONS(2947),
  },
  [1632] = {
    [sym_line_comment] = STATE(1632),
    [sym_block_comment] = STATE(1632),
    [sym_identifier] = ACTIONS(2845),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2845),
    [anon_sym_as] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_COMMA] = ACTIONS(2843),
    [anon_sym_RBRACE] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_fn] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2845),
    [anon_sym_STAR] = ACTIONS(2843),
    [anon_sym_SLASH] = ACTIONS(2845),
    [anon_sym_PERCENT] = ACTIONS(2843),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_GT] = ACTIONS(2845),
    [anon_sym_EQ_EQ] = ACTIONS(2843),
    [anon_sym_BANG_EQ] = ACTIONS(2843),
    [anon_sym_LT_EQ] = ACTIONS(2843),
    [anon_sym_GT_EQ] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_RBRACK] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2845),
    [anon_sym_mut] = ACTIONS(2845),
    [anon_sym_COLON] = ACTIONS(2843),
    [anon_sym_PLUS_PLUS] = ACTIONS(2843),
    [anon_sym_DASH_DASH] = ACTIONS(2843),
    [anon_sym_QMARK] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_go] = ACTIONS(2845),
    [anon_sym_spawn] = ACTIONS(2845),
    [anon_sym_json_DOTdecode] = ACTIONS(2843),
    [anon_sym_PIPE] = ACTIONS(2845),
    [anon_sym_LBRACK2] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_CARET] = ACTIONS(2843),
    [anon_sym_AMP] = ACTIONS(2845),
    [anon_sym_LT_DASH] = ACTIONS(2843),
    [anon_sym_LT_LT] = ACTIONS(2843),
    [anon_sym_GT_GT] = ACTIONS(2845),
    [anon_sym_GT_GT_GT] = ACTIONS(2843),
    [anon_sym_AMP_CARET] = ACTIONS(2843),
    [anon_sym_AMP_AMP] = ACTIONS(2843),
    [anon_sym_PIPE_PIPE] = ACTIONS(2843),
    [anon_sym_or] = ACTIONS(2845),
    [sym_none] = ACTIONS(2845),
    [sym_true] = ACTIONS(2845),
    [sym_false] = ACTIONS(2845),
    [sym_nil] = ACTIONS(2845),
    [anon_sym_QMARK_DOT] = ACTIONS(2843),
    [anon_sym_POUND_LBRACK] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2845),
    [anon_sym_DOLLARif] = ACTIONS(2845),
    [anon_sym_is] = ACTIONS(2845),
    [anon_sym_BANGis] = ACTIONS(2843),
    [anon_sym_in] = ACTIONS(2845),
    [anon_sym_BANGin] = ACTIONS(2843),
    [anon_sym_match] = ACTIONS(2845),
    [anon_sym_select] = ACTIONS(2845),
    [anon_sym_lock] = ACTIONS(2845),
    [anon_sym_rlock] = ACTIONS(2845),
    [anon_sym_unsafe] = ACTIONS(2845),
    [anon_sym_sql] = ACTIONS(2845),
    [sym_int_literal] = ACTIONS(2845),
    [sym_float_literal] = ACTIONS(2843),
    [sym_rune_literal] = ACTIONS(2843),
    [anon_sym_SQUOTE] = ACTIONS(2843),
    [anon_sym_DQUOTE] = ACTIONS(2843),
    [anon_sym_c_SQUOTE] = ACTIONS(2843),
    [anon_sym_c_DQUOTE] = ACTIONS(2843),
    [anon_sym_r_SQUOTE] = ACTIONS(2843),
    [anon_sym_r_DQUOTE] = ACTIONS(2843),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2845),
    [anon_sym_shared] = ACTIONS(2845),
    [anon_sym_map_LBRACK] = ACTIONS(2843),
    [anon_sym_chan] = ACTIONS(2845),
    [anon_sym_thread] = ACTIONS(2845),
    [anon_sym_atomic] = ACTIONS(2845),
  },
  [1633] = {
    [sym_line_comment] = STATE(1633),
    [sym_block_comment] = STATE(1633),
    [sym_identifier] = ACTIONS(3084),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3084),
    [anon_sym_as] = ACTIONS(3084),
    [anon_sym_LBRACE] = ACTIONS(3082),
    [anon_sym_COMMA] = ACTIONS(3082),
    [anon_sym_RBRACE] = ACTIONS(3082),
    [anon_sym_LPAREN] = ACTIONS(3082),
    [anon_sym_fn] = ACTIONS(3084),
    [anon_sym_PLUS] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3082),
    [anon_sym_SLASH] = ACTIONS(3084),
    [anon_sym_PERCENT] = ACTIONS(3082),
    [anon_sym_LT] = ACTIONS(3084),
    [anon_sym_GT] = ACTIONS(3084),
    [anon_sym_EQ_EQ] = ACTIONS(3082),
    [anon_sym_BANG_EQ] = ACTIONS(3082),
    [anon_sym_LT_EQ] = ACTIONS(3082),
    [anon_sym_GT_EQ] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_RBRACK] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3084),
    [anon_sym_mut] = ACTIONS(3084),
    [anon_sym_COLON] = ACTIONS(3082),
    [anon_sym_PLUS_PLUS] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3082),
    [anon_sym_QMARK] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_go] = ACTIONS(3084),
    [anon_sym_spawn] = ACTIONS(3084),
    [anon_sym_json_DOTdecode] = ACTIONS(3082),
    [anon_sym_PIPE] = ACTIONS(3084),
    [anon_sym_LBRACK2] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3082),
    [anon_sym_CARET] = ACTIONS(3082),
    [anon_sym_AMP] = ACTIONS(3084),
    [anon_sym_LT_DASH] = ACTIONS(3082),
    [anon_sym_LT_LT] = ACTIONS(3082),
    [anon_sym_GT_GT] = ACTIONS(3084),
    [anon_sym_GT_GT_GT] = ACTIONS(3082),
    [anon_sym_AMP_CARET] = ACTIONS(3082),
    [anon_sym_AMP_AMP] = ACTIONS(3082),
    [anon_sym_PIPE_PIPE] = ACTIONS(3082),
    [anon_sym_or] = ACTIONS(3084),
    [sym_none] = ACTIONS(3084),
    [sym_true] = ACTIONS(3084),
    [sym_false] = ACTIONS(3084),
    [sym_nil] = ACTIONS(3084),
    [anon_sym_QMARK_DOT] = ACTIONS(3082),
    [anon_sym_POUND_LBRACK] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3084),
    [anon_sym_DOLLARif] = ACTIONS(3084),
    [anon_sym_is] = ACTIONS(3084),
    [anon_sym_BANGis] = ACTIONS(3082),
    [anon_sym_in] = ACTIONS(3084),
    [anon_sym_BANGin] = ACTIONS(3082),
    [anon_sym_match] = ACTIONS(3084),
    [anon_sym_select] = ACTIONS(3084),
    [anon_sym_lock] = ACTIONS(3084),
    [anon_sym_rlock] = ACTIONS(3084),
    [anon_sym_unsafe] = ACTIONS(3084),
    [anon_sym_sql] = ACTIONS(3084),
    [sym_int_literal] = ACTIONS(3084),
    [sym_float_literal] = ACTIONS(3082),
    [sym_rune_literal] = ACTIONS(3082),
    [anon_sym_SQUOTE] = ACTIONS(3082),
    [anon_sym_DQUOTE] = ACTIONS(3082),
    [anon_sym_c_SQUOTE] = ACTIONS(3082),
    [anon_sym_c_DQUOTE] = ACTIONS(3082),
    [anon_sym_r_SQUOTE] = ACTIONS(3082),
    [anon_sym_r_DQUOTE] = ACTIONS(3082),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3084),
    [anon_sym_shared] = ACTIONS(3084),
    [anon_sym_map_LBRACK] = ACTIONS(3082),
    [anon_sym_chan] = ACTIONS(3084),
    [anon_sym_thread] = ACTIONS(3084),
    [anon_sym_atomic] = ACTIONS(3084),
  },
  [1634] = {
    [sym_line_comment] = STATE(1634),
    [sym_block_comment] = STATE(1634),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2175),
    [anon_sym_as] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2173),
    [anon_sym_COMMA] = ACTIONS(2173),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(2173),
    [anon_sym_fn] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2173),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_PERCENT] = ACTIONS(2173),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_GT] = ACTIONS(2175),
    [anon_sym_EQ_EQ] = ACTIONS(2173),
    [anon_sym_BANG_EQ] = ACTIONS(2173),
    [anon_sym_LT_EQ] = ACTIONS(2173),
    [anon_sym_GT_EQ] = ACTIONS(2173),
    [anon_sym_LBRACK] = ACTIONS(2173),
    [anon_sym_RBRACK] = ACTIONS(2173),
    [anon_sym_struct] = ACTIONS(2175),
    [anon_sym_mut] = ACTIONS(2175),
    [anon_sym_COLON] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_QMARK] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_go] = ACTIONS(2175),
    [anon_sym_spawn] = ACTIONS(2175),
    [anon_sym_json_DOTdecode] = ACTIONS(2173),
    [anon_sym_PIPE] = ACTIONS(2175),
    [anon_sym_LBRACK2] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2175),
    [anon_sym_LT_DASH] = ACTIONS(2173),
    [anon_sym_LT_LT] = ACTIONS(2173),
    [anon_sym_GT_GT] = ACTIONS(2175),
    [anon_sym_GT_GT_GT] = ACTIONS(2173),
    [anon_sym_AMP_CARET] = ACTIONS(2173),
    [anon_sym_AMP_AMP] = ACTIONS(2173),
    [anon_sym_PIPE_PIPE] = ACTIONS(2173),
    [anon_sym_or] = ACTIONS(2175),
    [sym_none] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_nil] = ACTIONS(2175),
    [anon_sym_QMARK_DOT] = ACTIONS(2173),
    [anon_sym_POUND_LBRACK] = ACTIONS(2173),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_DOLLARif] = ACTIONS(2175),
    [anon_sym_is] = ACTIONS(2175),
    [anon_sym_BANGis] = ACTIONS(2173),
    [anon_sym_in] = ACTIONS(2175),
    [anon_sym_BANGin] = ACTIONS(2173),
    [anon_sym_match] = ACTIONS(2175),
    [anon_sym_select] = ACTIONS(2175),
    [anon_sym_lock] = ACTIONS(2175),
    [anon_sym_rlock] = ACTIONS(2175),
    [anon_sym_unsafe] = ACTIONS(2175),
    [anon_sym_sql] = ACTIONS(2175),
    [sym_int_literal] = ACTIONS(2175),
    [sym_float_literal] = ACTIONS(2173),
    [sym_rune_literal] = ACTIONS(2173),
    [anon_sym_SQUOTE] = ACTIONS(2173),
    [anon_sym_DQUOTE] = ACTIONS(2173),
    [anon_sym_c_SQUOTE] = ACTIONS(2173),
    [anon_sym_c_DQUOTE] = ACTIONS(2173),
    [anon_sym_r_SQUOTE] = ACTIONS(2173),
    [anon_sym_r_DQUOTE] = ACTIONS(2173),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2175),
    [anon_sym_shared] = ACTIONS(2175),
    [anon_sym_map_LBRACK] = ACTIONS(2173),
    [anon_sym_chan] = ACTIONS(2175),
    [anon_sym_thread] = ACTIONS(2175),
    [anon_sym_atomic] = ACTIONS(2175),
  },
  [1635] = {
    [sym_line_comment] = STATE(1635),
    [sym_block_comment] = STATE(1635),
    [sym_identifier] = ACTIONS(2457),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2457),
    [anon_sym_as] = ACTIONS(2457),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_COMMA] = ACTIONS(2455),
    [anon_sym_RBRACE] = ACTIONS(2455),
    [anon_sym_LPAREN] = ACTIONS(2455),
    [anon_sym_fn] = ACTIONS(2457),
    [anon_sym_PLUS] = ACTIONS(2457),
    [anon_sym_DASH] = ACTIONS(2457),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_PERCENT] = ACTIONS(2455),
    [anon_sym_LT] = ACTIONS(2457),
    [anon_sym_GT] = ACTIONS(2457),
    [anon_sym_EQ_EQ] = ACTIONS(2455),
    [anon_sym_BANG_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2455),
    [anon_sym_GT_EQ] = ACTIONS(2455),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_RBRACK] = ACTIONS(2455),
    [anon_sym_struct] = ACTIONS(2457),
    [anon_sym_mut] = ACTIONS(2457),
    [anon_sym_COLON] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2455),
    [anon_sym_DASH_DASH] = ACTIONS(2455),
    [anon_sym_QMARK] = ACTIONS(2457),
    [anon_sym_BANG] = ACTIONS(2457),
    [anon_sym_go] = ACTIONS(2457),
    [anon_sym_spawn] = ACTIONS(2457),
    [anon_sym_json_DOTdecode] = ACTIONS(2455),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_LBRACK2] = ACTIONS(2457),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_CARET] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2457),
    [anon_sym_LT_DASH] = ACTIONS(2455),
    [anon_sym_LT_LT] = ACTIONS(2455),
    [anon_sym_GT_GT] = ACTIONS(2457),
    [anon_sym_GT_GT_GT] = ACTIONS(2455),
    [anon_sym_AMP_CARET] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_PIPE_PIPE] = ACTIONS(2455),
    [anon_sym_or] = ACTIONS(2457),
    [sym_none] = ACTIONS(2457),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [sym_nil] = ACTIONS(2457),
    [anon_sym_QMARK_DOT] = ACTIONS(2455),
    [anon_sym_POUND_LBRACK] = ACTIONS(2455),
    [anon_sym_if] = ACTIONS(2457),
    [anon_sym_DOLLARif] = ACTIONS(2457),
    [anon_sym_is] = ACTIONS(2457),
    [anon_sym_BANGis] = ACTIONS(2455),
    [anon_sym_in] = ACTIONS(2457),
    [anon_sym_BANGin] = ACTIONS(2455),
    [anon_sym_match] = ACTIONS(2457),
    [anon_sym_select] = ACTIONS(2457),
    [anon_sym_lock] = ACTIONS(2457),
    [anon_sym_rlock] = ACTIONS(2457),
    [anon_sym_unsafe] = ACTIONS(2457),
    [anon_sym_sql] = ACTIONS(2457),
    [sym_int_literal] = ACTIONS(2457),
    [sym_float_literal] = ACTIONS(2455),
    [sym_rune_literal] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [anon_sym_c_SQUOTE] = ACTIONS(2455),
    [anon_sym_c_DQUOTE] = ACTIONS(2455),
    [anon_sym_r_SQUOTE] = ACTIONS(2455),
    [anon_sym_r_DQUOTE] = ACTIONS(2455),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2457),
    [anon_sym_shared] = ACTIONS(2457),
    [anon_sym_map_LBRACK] = ACTIONS(2455),
    [anon_sym_chan] = ACTIONS(2457),
    [anon_sym_thread] = ACTIONS(2457),
    [anon_sym_atomic] = ACTIONS(2457),
  },
  [1636] = {
    [sym_line_comment] = STATE(1636),
    [sym_block_comment] = STATE(1636),
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2373),
    [anon_sym_as] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_COMMA] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_LPAREN] = ACTIONS(2371),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_SLASH] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2371),
    [anon_sym_BANG_EQ] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2371),
    [anon_sym_GT_EQ] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_RBRACK] = ACTIONS(2371),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_mut] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_QMARK] = ACTIONS(2373),
    [anon_sym_BANG] = ACTIONS(2373),
    [anon_sym_go] = ACTIONS(2373),
    [anon_sym_spawn] = ACTIONS(2373),
    [anon_sym_json_DOTdecode] = ACTIONS(2371),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_LBRACK2] = ACTIONS(2373),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_CARET] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2371),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_CARET] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_or] = ACTIONS(2373),
    [sym_none] = ACTIONS(2373),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [sym_nil] = ACTIONS(2373),
    [anon_sym_QMARK_DOT] = ACTIONS(2371),
    [anon_sym_POUND_LBRACK] = ACTIONS(2371),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_DOLLARif] = ACTIONS(2373),
    [anon_sym_is] = ACTIONS(2373),
    [anon_sym_BANGis] = ACTIONS(2371),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_BANGin] = ACTIONS(2371),
    [anon_sym_match] = ACTIONS(2373),
    [anon_sym_select] = ACTIONS(2373),
    [anon_sym_lock] = ACTIONS(2373),
    [anon_sym_rlock] = ACTIONS(2373),
    [anon_sym_unsafe] = ACTIONS(2373),
    [anon_sym_sql] = ACTIONS(2373),
    [sym_int_literal] = ACTIONS(2373),
    [sym_float_literal] = ACTIONS(2371),
    [sym_rune_literal] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [anon_sym_c_SQUOTE] = ACTIONS(2371),
    [anon_sym_c_DQUOTE] = ACTIONS(2371),
    [anon_sym_r_SQUOTE] = ACTIONS(2371),
    [anon_sym_r_DQUOTE] = ACTIONS(2371),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_map_LBRACK] = ACTIONS(2371),
    [anon_sym_chan] = ACTIONS(2373),
    [anon_sym_thread] = ACTIONS(2373),
    [anon_sym_atomic] = ACTIONS(2373),
  },
  [1637] = {
    [sym_line_comment] = STATE(1637),
    [sym_block_comment] = STATE(1637),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2877),
    [anon_sym_as] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(2875),
    [anon_sym_COMMA] = ACTIONS(2875),
    [anon_sym_RBRACE] = ACTIONS(2875),
    [anon_sym_LPAREN] = ACTIONS(2875),
    [anon_sym_fn] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_STAR] = ACTIONS(2875),
    [anon_sym_SLASH] = ACTIONS(2877),
    [anon_sym_PERCENT] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2877),
    [anon_sym_GT] = ACTIONS(2877),
    [anon_sym_EQ_EQ] = ACTIONS(2875),
    [anon_sym_BANG_EQ] = ACTIONS(2875),
    [anon_sym_LT_EQ] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2875),
    [anon_sym_LBRACK] = ACTIONS(2875),
    [anon_sym_RBRACK] = ACTIONS(2875),
    [anon_sym_struct] = ACTIONS(2877),
    [anon_sym_mut] = ACTIONS(2877),
    [anon_sym_COLON] = ACTIONS(2875),
    [anon_sym_PLUS_PLUS] = ACTIONS(2875),
    [anon_sym_DASH_DASH] = ACTIONS(2875),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2877),
    [anon_sym_go] = ACTIONS(2877),
    [anon_sym_spawn] = ACTIONS(2877),
    [anon_sym_json_DOTdecode] = ACTIONS(2875),
    [anon_sym_PIPE] = ACTIONS(2877),
    [anon_sym_LBRACK2] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2875),
    [anon_sym_CARET] = ACTIONS(2875),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_LT_DASH] = ACTIONS(2875),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(2877),
    [anon_sym_GT_GT_GT] = ACTIONS(2875),
    [anon_sym_AMP_CARET] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_or] = ACTIONS(2877),
    [sym_none] = ACTIONS(2877),
    [sym_true] = ACTIONS(2877),
    [sym_false] = ACTIONS(2877),
    [sym_nil] = ACTIONS(2877),
    [anon_sym_QMARK_DOT] = ACTIONS(2875),
    [anon_sym_POUND_LBRACK] = ACTIONS(2875),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_DOLLARif] = ACTIONS(2877),
    [anon_sym_is] = ACTIONS(2877),
    [anon_sym_BANGis] = ACTIONS(2875),
    [anon_sym_in] = ACTIONS(2877),
    [anon_sym_BANGin] = ACTIONS(2875),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_select] = ACTIONS(2877),
    [anon_sym_lock] = ACTIONS(2877),
    [anon_sym_rlock] = ACTIONS(2877),
    [anon_sym_unsafe] = ACTIONS(2877),
    [anon_sym_sql] = ACTIONS(2877),
    [sym_int_literal] = ACTIONS(2877),
    [sym_float_literal] = ACTIONS(2875),
    [sym_rune_literal] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_c_SQUOTE] = ACTIONS(2875),
    [anon_sym_c_DQUOTE] = ACTIONS(2875),
    [anon_sym_r_SQUOTE] = ACTIONS(2875),
    [anon_sym_r_DQUOTE] = ACTIONS(2875),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2877),
    [anon_sym_shared] = ACTIONS(2877),
    [anon_sym_map_LBRACK] = ACTIONS(2875),
    [anon_sym_chan] = ACTIONS(2877),
    [anon_sym_thread] = ACTIONS(2877),
    [anon_sym_atomic] = ACTIONS(2877),
  },
  [1638] = {
    [sym_line_comment] = STATE(1638),
    [sym_block_comment] = STATE(1638),
    [sym_identifier] = ACTIONS(2889),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2889),
    [anon_sym_as] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_COMMA] = ACTIONS(2887),
    [anon_sym_RBRACE] = ACTIONS(2887),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_fn] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2889),
    [anon_sym_STAR] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(2889),
    [anon_sym_PERCENT] = ACTIONS(2887),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_GT] = ACTIONS(2889),
    [anon_sym_EQ_EQ] = ACTIONS(2887),
    [anon_sym_BANG_EQ] = ACTIONS(2887),
    [anon_sym_LT_EQ] = ACTIONS(2887),
    [anon_sym_GT_EQ] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_RBRACK] = ACTIONS(2887),
    [anon_sym_struct] = ACTIONS(2889),
    [anon_sym_mut] = ACTIONS(2889),
    [anon_sym_COLON] = ACTIONS(2887),
    [anon_sym_PLUS_PLUS] = ACTIONS(2887),
    [anon_sym_DASH_DASH] = ACTIONS(2887),
    [anon_sym_QMARK] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2889),
    [anon_sym_go] = ACTIONS(2889),
    [anon_sym_spawn] = ACTIONS(2889),
    [anon_sym_json_DOTdecode] = ACTIONS(2887),
    [anon_sym_PIPE] = ACTIONS(2889),
    [anon_sym_LBRACK2] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2887),
    [anon_sym_CARET] = ACTIONS(2887),
    [anon_sym_AMP] = ACTIONS(2889),
    [anon_sym_LT_DASH] = ACTIONS(2887),
    [anon_sym_LT_LT] = ACTIONS(2887),
    [anon_sym_GT_GT] = ACTIONS(2889),
    [anon_sym_GT_GT_GT] = ACTIONS(2887),
    [anon_sym_AMP_CARET] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_PIPE_PIPE] = ACTIONS(2887),
    [anon_sym_or] = ACTIONS(2889),
    [sym_none] = ACTIONS(2889),
    [sym_true] = ACTIONS(2889),
    [sym_false] = ACTIONS(2889),
    [sym_nil] = ACTIONS(2889),
    [anon_sym_QMARK_DOT] = ACTIONS(2887),
    [anon_sym_POUND_LBRACK] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_DOLLARif] = ACTIONS(2889),
    [anon_sym_is] = ACTIONS(2889),
    [anon_sym_BANGis] = ACTIONS(2887),
    [anon_sym_in] = ACTIONS(2889),
    [anon_sym_BANGin] = ACTIONS(2887),
    [anon_sym_match] = ACTIONS(2889),
    [anon_sym_select] = ACTIONS(2889),
    [anon_sym_lock] = ACTIONS(2889),
    [anon_sym_rlock] = ACTIONS(2889),
    [anon_sym_unsafe] = ACTIONS(2889),
    [anon_sym_sql] = ACTIONS(2889),
    [sym_int_literal] = ACTIONS(2889),
    [sym_float_literal] = ACTIONS(2887),
    [sym_rune_literal] = ACTIONS(2887),
    [anon_sym_SQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [anon_sym_c_SQUOTE] = ACTIONS(2887),
    [anon_sym_c_DQUOTE] = ACTIONS(2887),
    [anon_sym_r_SQUOTE] = ACTIONS(2887),
    [anon_sym_r_DQUOTE] = ACTIONS(2887),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2889),
    [anon_sym_shared] = ACTIONS(2889),
    [anon_sym_map_LBRACK] = ACTIONS(2887),
    [anon_sym_chan] = ACTIONS(2889),
    [anon_sym_thread] = ACTIONS(2889),
    [anon_sym_atomic] = ACTIONS(2889),
  },
  [1639] = {
    [sym_line_comment] = STATE(1639),
    [sym_block_comment] = STATE(1639),
    [sym_identifier] = ACTIONS(3262),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3262),
    [anon_sym_as] = ACTIONS(3262),
    [anon_sym_LBRACE] = ACTIONS(3260),
    [anon_sym_COMMA] = ACTIONS(3260),
    [anon_sym_RBRACE] = ACTIONS(3260),
    [anon_sym_LPAREN] = ACTIONS(3260),
    [anon_sym_fn] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3262),
    [anon_sym_DASH] = ACTIONS(3262),
    [anon_sym_STAR] = ACTIONS(3260),
    [anon_sym_SLASH] = ACTIONS(3262),
    [anon_sym_PERCENT] = ACTIONS(3260),
    [anon_sym_LT] = ACTIONS(3262),
    [anon_sym_GT] = ACTIONS(3262),
    [anon_sym_EQ_EQ] = ACTIONS(3260),
    [anon_sym_BANG_EQ] = ACTIONS(3260),
    [anon_sym_LT_EQ] = ACTIONS(3260),
    [anon_sym_GT_EQ] = ACTIONS(3260),
    [anon_sym_LBRACK] = ACTIONS(3260),
    [anon_sym_RBRACK] = ACTIONS(3260),
    [anon_sym_struct] = ACTIONS(3262),
    [anon_sym_mut] = ACTIONS(3262),
    [anon_sym_COLON] = ACTIONS(3260),
    [anon_sym_PLUS_PLUS] = ACTIONS(3260),
    [anon_sym_DASH_DASH] = ACTIONS(3260),
    [anon_sym_QMARK] = ACTIONS(3262),
    [anon_sym_BANG] = ACTIONS(3262),
    [anon_sym_go] = ACTIONS(3262),
    [anon_sym_spawn] = ACTIONS(3262),
    [anon_sym_json_DOTdecode] = ACTIONS(3260),
    [anon_sym_PIPE] = ACTIONS(3262),
    [anon_sym_LBRACK2] = ACTIONS(3262),
    [anon_sym_TILDE] = ACTIONS(3260),
    [anon_sym_CARET] = ACTIONS(3260),
    [anon_sym_AMP] = ACTIONS(3262),
    [anon_sym_LT_DASH] = ACTIONS(3260),
    [anon_sym_LT_LT] = ACTIONS(3260),
    [anon_sym_GT_GT] = ACTIONS(3262),
    [anon_sym_GT_GT_GT] = ACTIONS(3260),
    [anon_sym_AMP_CARET] = ACTIONS(3260),
    [anon_sym_AMP_AMP] = ACTIONS(3260),
    [anon_sym_PIPE_PIPE] = ACTIONS(3260),
    [anon_sym_or] = ACTIONS(3262),
    [sym_none] = ACTIONS(3262),
    [sym_true] = ACTIONS(3262),
    [sym_false] = ACTIONS(3262),
    [sym_nil] = ACTIONS(3262),
    [anon_sym_QMARK_DOT] = ACTIONS(3260),
    [anon_sym_POUND_LBRACK] = ACTIONS(3260),
    [anon_sym_if] = ACTIONS(3262),
    [anon_sym_DOLLARif] = ACTIONS(3262),
    [anon_sym_is] = ACTIONS(3262),
    [anon_sym_BANGis] = ACTIONS(3260),
    [anon_sym_in] = ACTIONS(3262),
    [anon_sym_BANGin] = ACTIONS(3260),
    [anon_sym_match] = ACTIONS(3262),
    [anon_sym_select] = ACTIONS(3262),
    [anon_sym_lock] = ACTIONS(3262),
    [anon_sym_rlock] = ACTIONS(3262),
    [anon_sym_unsafe] = ACTIONS(3262),
    [anon_sym_sql] = ACTIONS(3262),
    [sym_int_literal] = ACTIONS(3262),
    [sym_float_literal] = ACTIONS(3260),
    [sym_rune_literal] = ACTIONS(3260),
    [anon_sym_SQUOTE] = ACTIONS(3260),
    [anon_sym_DQUOTE] = ACTIONS(3260),
    [anon_sym_c_SQUOTE] = ACTIONS(3260),
    [anon_sym_c_DQUOTE] = ACTIONS(3260),
    [anon_sym_r_SQUOTE] = ACTIONS(3260),
    [anon_sym_r_DQUOTE] = ACTIONS(3260),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3262),
    [anon_sym_shared] = ACTIONS(3262),
    [anon_sym_map_LBRACK] = ACTIONS(3260),
    [anon_sym_chan] = ACTIONS(3262),
    [anon_sym_thread] = ACTIONS(3262),
    [anon_sym_atomic] = ACTIONS(3262),
  },
  [1640] = {
    [sym_line_comment] = STATE(1640),
    [sym_block_comment] = STATE(1640),
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3073),
    [anon_sym_as] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_RBRACE] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(3073),
    [anon_sym_DASH] = ACTIONS(3073),
    [anon_sym_STAR] = ACTIONS(3071),
    [anon_sym_SLASH] = ACTIONS(3073),
    [anon_sym_PERCENT] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_GT] = ACTIONS(3073),
    [anon_sym_EQ_EQ] = ACTIONS(3071),
    [anon_sym_BANG_EQ] = ACTIONS(3071),
    [anon_sym_LT_EQ] = ACTIONS(3071),
    [anon_sym_GT_EQ] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_RBRACK] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3073),
    [anon_sym_mut] = ACTIONS(3073),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_PLUS_PLUS] = ACTIONS(3071),
    [anon_sym_DASH_DASH] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3073),
    [anon_sym_BANG] = ACTIONS(3073),
    [anon_sym_go] = ACTIONS(3073),
    [anon_sym_spawn] = ACTIONS(3073),
    [anon_sym_json_DOTdecode] = ACTIONS(3071),
    [anon_sym_PIPE] = ACTIONS(3073),
    [anon_sym_LBRACK2] = ACTIONS(3073),
    [anon_sym_TILDE] = ACTIONS(3071),
    [anon_sym_CARET] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3073),
    [anon_sym_LT_DASH] = ACTIONS(3071),
    [anon_sym_LT_LT] = ACTIONS(3071),
    [anon_sym_GT_GT] = ACTIONS(3073),
    [anon_sym_GT_GT_GT] = ACTIONS(3071),
    [anon_sym_AMP_CARET] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_or] = ACTIONS(3073),
    [sym_none] = ACTIONS(3073),
    [sym_true] = ACTIONS(3073),
    [sym_false] = ACTIONS(3073),
    [sym_nil] = ACTIONS(3073),
    [anon_sym_QMARK_DOT] = ACTIONS(3071),
    [anon_sym_POUND_LBRACK] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3073),
    [anon_sym_DOLLARif] = ACTIONS(3073),
    [anon_sym_is] = ACTIONS(3073),
    [anon_sym_BANGis] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3073),
    [anon_sym_BANGin] = ACTIONS(3071),
    [anon_sym_match] = ACTIONS(3073),
    [anon_sym_select] = ACTIONS(3073),
    [anon_sym_lock] = ACTIONS(3073),
    [anon_sym_rlock] = ACTIONS(3073),
    [anon_sym_unsafe] = ACTIONS(3073),
    [anon_sym_sql] = ACTIONS(3073),
    [sym_int_literal] = ACTIONS(3073),
    [sym_float_literal] = ACTIONS(3071),
    [sym_rune_literal] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_c_SQUOTE] = ACTIONS(3071),
    [anon_sym_c_DQUOTE] = ACTIONS(3071),
    [anon_sym_r_SQUOTE] = ACTIONS(3071),
    [anon_sym_r_DQUOTE] = ACTIONS(3071),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3073),
    [anon_sym_shared] = ACTIONS(3073),
    [anon_sym_map_LBRACK] = ACTIONS(3071),
    [anon_sym_chan] = ACTIONS(3073),
    [anon_sym_thread] = ACTIONS(3073),
    [anon_sym_atomic] = ACTIONS(3073),
  },
  [1641] = {
    [sym_line_comment] = STATE(1641),
    [sym_block_comment] = STATE(1641),
    [sym_identifier] = ACTIONS(3065),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3065),
    [anon_sym_as] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_COMMA] = ACTIONS(3063),
    [anon_sym_RBRACE] = ACTIONS(3063),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_fn] = ACTIONS(3065),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_STAR] = ACTIONS(3063),
    [anon_sym_SLASH] = ACTIONS(3065),
    [anon_sym_PERCENT] = ACTIONS(3063),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_GT] = ACTIONS(3065),
    [anon_sym_EQ_EQ] = ACTIONS(3063),
    [anon_sym_BANG_EQ] = ACTIONS(3063),
    [anon_sym_LT_EQ] = ACTIONS(3063),
    [anon_sym_GT_EQ] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_RBRACK] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3065),
    [anon_sym_mut] = ACTIONS(3065),
    [anon_sym_COLON] = ACTIONS(3063),
    [anon_sym_PLUS_PLUS] = ACTIONS(3063),
    [anon_sym_DASH_DASH] = ACTIONS(3063),
    [anon_sym_QMARK] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_go] = ACTIONS(3065),
    [anon_sym_spawn] = ACTIONS(3065),
    [anon_sym_json_DOTdecode] = ACTIONS(3063),
    [anon_sym_PIPE] = ACTIONS(3065),
    [anon_sym_LBRACK2] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3063),
    [anon_sym_CARET] = ACTIONS(3063),
    [anon_sym_AMP] = ACTIONS(3065),
    [anon_sym_LT_DASH] = ACTIONS(3063),
    [anon_sym_LT_LT] = ACTIONS(3063),
    [anon_sym_GT_GT] = ACTIONS(3065),
    [anon_sym_GT_GT_GT] = ACTIONS(3063),
    [anon_sym_AMP_CARET] = ACTIONS(3063),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_PIPE_PIPE] = ACTIONS(3063),
    [anon_sym_or] = ACTIONS(3065),
    [sym_none] = ACTIONS(3065),
    [sym_true] = ACTIONS(3065),
    [sym_false] = ACTIONS(3065),
    [sym_nil] = ACTIONS(3065),
    [anon_sym_QMARK_DOT] = ACTIONS(3063),
    [anon_sym_POUND_LBRACK] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3065),
    [anon_sym_DOLLARif] = ACTIONS(3065),
    [anon_sym_is] = ACTIONS(3065),
    [anon_sym_BANGis] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3065),
    [anon_sym_BANGin] = ACTIONS(3063),
    [anon_sym_match] = ACTIONS(3065),
    [anon_sym_select] = ACTIONS(3065),
    [anon_sym_lock] = ACTIONS(3065),
    [anon_sym_rlock] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(3065),
    [anon_sym_sql] = ACTIONS(3065),
    [sym_int_literal] = ACTIONS(3065),
    [sym_float_literal] = ACTIONS(3063),
    [sym_rune_literal] = ACTIONS(3063),
    [anon_sym_SQUOTE] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [anon_sym_c_SQUOTE] = ACTIONS(3063),
    [anon_sym_c_DQUOTE] = ACTIONS(3063),
    [anon_sym_r_SQUOTE] = ACTIONS(3063),
    [anon_sym_r_DQUOTE] = ACTIONS(3063),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3065),
    [anon_sym_shared] = ACTIONS(3065),
    [anon_sym_map_LBRACK] = ACTIONS(3063),
    [anon_sym_chan] = ACTIONS(3065),
    [anon_sym_thread] = ACTIONS(3065),
    [anon_sym_atomic] = ACTIONS(3065),
  },
  [1642] = {
    [sym_line_comment] = STATE(1642),
    [sym_block_comment] = STATE(1642),
    [sym_identifier] = ACTIONS(2957),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2957),
    [anon_sym_as] = ACTIONS(2957),
    [anon_sym_LBRACE] = ACTIONS(2955),
    [anon_sym_COMMA] = ACTIONS(2955),
    [anon_sym_RBRACE] = ACTIONS(2955),
    [anon_sym_LPAREN] = ACTIONS(2955),
    [anon_sym_fn] = ACTIONS(2957),
    [anon_sym_PLUS] = ACTIONS(2957),
    [anon_sym_DASH] = ACTIONS(2957),
    [anon_sym_STAR] = ACTIONS(2955),
    [anon_sym_SLASH] = ACTIONS(2957),
    [anon_sym_PERCENT] = ACTIONS(2955),
    [anon_sym_LT] = ACTIONS(2957),
    [anon_sym_GT] = ACTIONS(2957),
    [anon_sym_EQ_EQ] = ACTIONS(2955),
    [anon_sym_BANG_EQ] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2955),
    [anon_sym_GT_EQ] = ACTIONS(2955),
    [anon_sym_LBRACK] = ACTIONS(2955),
    [anon_sym_RBRACK] = ACTIONS(2955),
    [anon_sym_struct] = ACTIONS(2957),
    [anon_sym_mut] = ACTIONS(2957),
    [anon_sym_COLON] = ACTIONS(2955),
    [anon_sym_PLUS_PLUS] = ACTIONS(2955),
    [anon_sym_DASH_DASH] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_BANG] = ACTIONS(2957),
    [anon_sym_go] = ACTIONS(2957),
    [anon_sym_spawn] = ACTIONS(2957),
    [anon_sym_json_DOTdecode] = ACTIONS(2955),
    [anon_sym_PIPE] = ACTIONS(2957),
    [anon_sym_LBRACK2] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2955),
    [anon_sym_CARET] = ACTIONS(2955),
    [anon_sym_AMP] = ACTIONS(2957),
    [anon_sym_LT_DASH] = ACTIONS(2955),
    [anon_sym_LT_LT] = ACTIONS(2955),
    [anon_sym_GT_GT] = ACTIONS(2957),
    [anon_sym_GT_GT_GT] = ACTIONS(2955),
    [anon_sym_AMP_CARET] = ACTIONS(2955),
    [anon_sym_AMP_AMP] = ACTIONS(2955),
    [anon_sym_PIPE_PIPE] = ACTIONS(2955),
    [anon_sym_or] = ACTIONS(2957),
    [sym_none] = ACTIONS(2957),
    [sym_true] = ACTIONS(2957),
    [sym_false] = ACTIONS(2957),
    [sym_nil] = ACTIONS(2957),
    [anon_sym_QMARK_DOT] = ACTIONS(2955),
    [anon_sym_POUND_LBRACK] = ACTIONS(2955),
    [anon_sym_if] = ACTIONS(2957),
    [anon_sym_DOLLARif] = ACTIONS(2957),
    [anon_sym_is] = ACTIONS(2957),
    [anon_sym_BANGis] = ACTIONS(2955),
    [anon_sym_in] = ACTIONS(2957),
    [anon_sym_BANGin] = ACTIONS(2955),
    [anon_sym_match] = ACTIONS(2957),
    [anon_sym_select] = ACTIONS(2957),
    [anon_sym_lock] = ACTIONS(2957),
    [anon_sym_rlock] = ACTIONS(2957),
    [anon_sym_unsafe] = ACTIONS(2957),
    [anon_sym_sql] = ACTIONS(2957),
    [sym_int_literal] = ACTIONS(2957),
    [sym_float_literal] = ACTIONS(2955),
    [sym_rune_literal] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2955),
    [anon_sym_DQUOTE] = ACTIONS(2955),
    [anon_sym_c_SQUOTE] = ACTIONS(2955),
    [anon_sym_c_DQUOTE] = ACTIONS(2955),
    [anon_sym_r_SQUOTE] = ACTIONS(2955),
    [anon_sym_r_DQUOTE] = ACTIONS(2955),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2957),
    [anon_sym_shared] = ACTIONS(2957),
    [anon_sym_map_LBRACK] = ACTIONS(2955),
    [anon_sym_chan] = ACTIONS(2957),
    [anon_sym_thread] = ACTIONS(2957),
    [anon_sym_atomic] = ACTIONS(2957),
  },
  [1643] = {
    [sym_line_comment] = STATE(1643),
    [sym_block_comment] = STATE(1643),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3300),
    [anon_sym_as] = ACTIONS(3300),
    [anon_sym_LBRACE] = ACTIONS(3298),
    [anon_sym_COMMA] = ACTIONS(3298),
    [anon_sym_RBRACE] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3298),
    [anon_sym_fn] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_STAR] = ACTIONS(3298),
    [anon_sym_SLASH] = ACTIONS(3300),
    [anon_sym_PERCENT] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(3300),
    [anon_sym_GT] = ACTIONS(3300),
    [anon_sym_EQ_EQ] = ACTIONS(3298),
    [anon_sym_BANG_EQ] = ACTIONS(3298),
    [anon_sym_LT_EQ] = ACTIONS(3298),
    [anon_sym_GT_EQ] = ACTIONS(3298),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_RBRACK] = ACTIONS(3298),
    [anon_sym_struct] = ACTIONS(3300),
    [anon_sym_mut] = ACTIONS(3300),
    [anon_sym_COLON] = ACTIONS(3298),
    [anon_sym_PLUS_PLUS] = ACTIONS(3298),
    [anon_sym_DASH_DASH] = ACTIONS(3298),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_go] = ACTIONS(3300),
    [anon_sym_spawn] = ACTIONS(3300),
    [anon_sym_json_DOTdecode] = ACTIONS(3298),
    [anon_sym_PIPE] = ACTIONS(3300),
    [anon_sym_LBRACK2] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3298),
    [anon_sym_CARET] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LT_DASH] = ACTIONS(3298),
    [anon_sym_LT_LT] = ACTIONS(3298),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3298),
    [anon_sym_AMP_CARET] = ACTIONS(3298),
    [anon_sym_AMP_AMP] = ACTIONS(3298),
    [anon_sym_PIPE_PIPE] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3300),
    [sym_none] = ACTIONS(3300),
    [sym_true] = ACTIONS(3300),
    [sym_false] = ACTIONS(3300),
    [sym_nil] = ACTIONS(3300),
    [anon_sym_QMARK_DOT] = ACTIONS(3298),
    [anon_sym_POUND_LBRACK] = ACTIONS(3298),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_DOLLARif] = ACTIONS(3300),
    [anon_sym_is] = ACTIONS(3300),
    [anon_sym_BANGis] = ACTIONS(3298),
    [anon_sym_in] = ACTIONS(3300),
    [anon_sym_BANGin] = ACTIONS(3298),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_select] = ACTIONS(3300),
    [anon_sym_lock] = ACTIONS(3300),
    [anon_sym_rlock] = ACTIONS(3300),
    [anon_sym_unsafe] = ACTIONS(3300),
    [anon_sym_sql] = ACTIONS(3300),
    [sym_int_literal] = ACTIONS(3300),
    [sym_float_literal] = ACTIONS(3298),
    [sym_rune_literal] = ACTIONS(3298),
    [anon_sym_SQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE] = ACTIONS(3298),
    [anon_sym_c_SQUOTE] = ACTIONS(3298),
    [anon_sym_c_DQUOTE] = ACTIONS(3298),
    [anon_sym_r_SQUOTE] = ACTIONS(3298),
    [anon_sym_r_DQUOTE] = ACTIONS(3298),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3300),
    [anon_sym_shared] = ACTIONS(3300),
    [anon_sym_map_LBRACK] = ACTIONS(3298),
    [anon_sym_chan] = ACTIONS(3300),
    [anon_sym_thread] = ACTIONS(3300),
    [anon_sym_atomic] = ACTIONS(3300),
  },
  [1644] = {
    [sym_line_comment] = STATE(1644),
    [sym_block_comment] = STATE(1644),
    [sym_identifier] = ACTIONS(2885),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2885),
    [anon_sym_as] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2883),
    [anon_sym_RBRACE] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_fn] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2883),
    [anon_sym_SLASH] = ACTIONS(2885),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_GT] = ACTIONS(2885),
    [anon_sym_EQ_EQ] = ACTIONS(2883),
    [anon_sym_BANG_EQ] = ACTIONS(2883),
    [anon_sym_LT_EQ] = ACTIONS(2883),
    [anon_sym_GT_EQ] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_RBRACK] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_mut] = ACTIONS(2885),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_BANG] = ACTIONS(2885),
    [anon_sym_go] = ACTIONS(2885),
    [anon_sym_spawn] = ACTIONS(2885),
    [anon_sym_json_DOTdecode] = ACTIONS(2883),
    [anon_sym_PIPE] = ACTIONS(2885),
    [anon_sym_LBRACK2] = ACTIONS(2885),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_CARET] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_LT_DASH] = ACTIONS(2883),
    [anon_sym_LT_LT] = ACTIONS(2883),
    [anon_sym_GT_GT] = ACTIONS(2885),
    [anon_sym_GT_GT_GT] = ACTIONS(2883),
    [anon_sym_AMP_CARET] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_or] = ACTIONS(2885),
    [sym_none] = ACTIONS(2885),
    [sym_true] = ACTIONS(2885),
    [sym_false] = ACTIONS(2885),
    [sym_nil] = ACTIONS(2885),
    [anon_sym_QMARK_DOT] = ACTIONS(2883),
    [anon_sym_POUND_LBRACK] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_DOLLARif] = ACTIONS(2885),
    [anon_sym_is] = ACTIONS(2885),
    [anon_sym_BANGis] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_BANGin] = ACTIONS(2883),
    [anon_sym_match] = ACTIONS(2885),
    [anon_sym_select] = ACTIONS(2885),
    [anon_sym_lock] = ACTIONS(2885),
    [anon_sym_rlock] = ACTIONS(2885),
    [anon_sym_unsafe] = ACTIONS(2885),
    [anon_sym_sql] = ACTIONS(2885),
    [sym_int_literal] = ACTIONS(2885),
    [sym_float_literal] = ACTIONS(2883),
    [sym_rune_literal] = ACTIONS(2883),
    [anon_sym_SQUOTE] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_c_SQUOTE] = ACTIONS(2883),
    [anon_sym_c_DQUOTE] = ACTIONS(2883),
    [anon_sym_r_SQUOTE] = ACTIONS(2883),
    [anon_sym_r_DQUOTE] = ACTIONS(2883),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2885),
    [anon_sym_shared] = ACTIONS(2885),
    [anon_sym_map_LBRACK] = ACTIONS(2883),
    [anon_sym_chan] = ACTIONS(2885),
    [anon_sym_thread] = ACTIONS(2885),
    [anon_sym_atomic] = ACTIONS(2885),
  },
  [1645] = {
    [sym_line_comment] = STATE(1645),
    [sym_block_comment] = STATE(1645),
    [sym_identifier] = ACTIONS(2997),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2997),
    [anon_sym_as] = ACTIONS(2997),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_COMMA] = ACTIONS(2995),
    [anon_sym_RBRACE] = ACTIONS(2995),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_fn] = ACTIONS(2997),
    [anon_sym_PLUS] = ACTIONS(2997),
    [anon_sym_DASH] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(2995),
    [anon_sym_SLASH] = ACTIONS(2997),
    [anon_sym_PERCENT] = ACTIONS(2995),
    [anon_sym_LT] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(2997),
    [anon_sym_EQ_EQ] = ACTIONS(2995),
    [anon_sym_BANG_EQ] = ACTIONS(2995),
    [anon_sym_LT_EQ] = ACTIONS(2995),
    [anon_sym_GT_EQ] = ACTIONS(2995),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_RBRACK] = ACTIONS(2995),
    [anon_sym_struct] = ACTIONS(2997),
    [anon_sym_mut] = ACTIONS(2997),
    [anon_sym_COLON] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2995),
    [anon_sym_DASH_DASH] = ACTIONS(2995),
    [anon_sym_QMARK] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2997),
    [anon_sym_go] = ACTIONS(2997),
    [anon_sym_spawn] = ACTIONS(2997),
    [anon_sym_json_DOTdecode] = ACTIONS(2995),
    [anon_sym_PIPE] = ACTIONS(2997),
    [anon_sym_LBRACK2] = ACTIONS(2997),
    [anon_sym_TILDE] = ACTIONS(2995),
    [anon_sym_CARET] = ACTIONS(2995),
    [anon_sym_AMP] = ACTIONS(2997),
    [anon_sym_LT_DASH] = ACTIONS(2995),
    [anon_sym_LT_LT] = ACTIONS(2995),
    [anon_sym_GT_GT] = ACTIONS(2997),
    [anon_sym_GT_GT_GT] = ACTIONS(2995),
    [anon_sym_AMP_CARET] = ACTIONS(2995),
    [anon_sym_AMP_AMP] = ACTIONS(2995),
    [anon_sym_PIPE_PIPE] = ACTIONS(2995),
    [anon_sym_or] = ACTIONS(2997),
    [sym_none] = ACTIONS(2997),
    [sym_true] = ACTIONS(2997),
    [sym_false] = ACTIONS(2997),
    [sym_nil] = ACTIONS(2997),
    [anon_sym_QMARK_DOT] = ACTIONS(2995),
    [anon_sym_POUND_LBRACK] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_DOLLARif] = ACTIONS(2997),
    [anon_sym_is] = ACTIONS(2997),
    [anon_sym_BANGis] = ACTIONS(2995),
    [anon_sym_in] = ACTIONS(2997),
    [anon_sym_BANGin] = ACTIONS(2995),
    [anon_sym_match] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [anon_sym_lock] = ACTIONS(2997),
    [anon_sym_rlock] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(2997),
    [anon_sym_sql] = ACTIONS(2997),
    [sym_int_literal] = ACTIONS(2997),
    [sym_float_literal] = ACTIONS(2995),
    [sym_rune_literal] = ACTIONS(2995),
    [anon_sym_SQUOTE] = ACTIONS(2995),
    [anon_sym_DQUOTE] = ACTIONS(2995),
    [anon_sym_c_SQUOTE] = ACTIONS(2995),
    [anon_sym_c_DQUOTE] = ACTIONS(2995),
    [anon_sym_r_SQUOTE] = ACTIONS(2995),
    [anon_sym_r_DQUOTE] = ACTIONS(2995),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2997),
    [anon_sym_shared] = ACTIONS(2997),
    [anon_sym_map_LBRACK] = ACTIONS(2995),
    [anon_sym_chan] = ACTIONS(2997),
    [anon_sym_thread] = ACTIONS(2997),
    [anon_sym_atomic] = ACTIONS(2997),
  },
  [1646] = {
    [sym_line_comment] = STATE(1646),
    [sym_block_comment] = STATE(1646),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_as] = ACTIONS(3304),
    [anon_sym_LBRACE] = ACTIONS(3302),
    [anon_sym_COMMA] = ACTIONS(3302),
    [anon_sym_RBRACE] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3302),
    [anon_sym_fn] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_STAR] = ACTIONS(3302),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3302),
    [anon_sym_LT] = ACTIONS(3304),
    [anon_sym_GT] = ACTIONS(3304),
    [anon_sym_EQ_EQ] = ACTIONS(3302),
    [anon_sym_BANG_EQ] = ACTIONS(3302),
    [anon_sym_LT_EQ] = ACTIONS(3302),
    [anon_sym_GT_EQ] = ACTIONS(3302),
    [anon_sym_LBRACK] = ACTIONS(3302),
    [anon_sym_RBRACK] = ACTIONS(3302),
    [anon_sym_struct] = ACTIONS(3304),
    [anon_sym_mut] = ACTIONS(3304),
    [anon_sym_COLON] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_go] = ACTIONS(3304),
    [anon_sym_spawn] = ACTIONS(3304),
    [anon_sym_json_DOTdecode] = ACTIONS(3302),
    [anon_sym_PIPE] = ACTIONS(3304),
    [anon_sym_LBRACK2] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3302),
    [anon_sym_CARET] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LT_DASH] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_GT_GT] = ACTIONS(3304),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_AMP_CARET] = ACTIONS(3302),
    [anon_sym_AMP_AMP] = ACTIONS(3302),
    [anon_sym_PIPE_PIPE] = ACTIONS(3302),
    [anon_sym_or] = ACTIONS(3304),
    [sym_none] = ACTIONS(3304),
    [sym_true] = ACTIONS(3304),
    [sym_false] = ACTIONS(3304),
    [sym_nil] = ACTIONS(3304),
    [anon_sym_QMARK_DOT] = ACTIONS(3302),
    [anon_sym_POUND_LBRACK] = ACTIONS(3302),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_DOLLARif] = ACTIONS(3304),
    [anon_sym_is] = ACTIONS(3304),
    [anon_sym_BANGis] = ACTIONS(3302),
    [anon_sym_in] = ACTIONS(3304),
    [anon_sym_BANGin] = ACTIONS(3302),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_select] = ACTIONS(3304),
    [anon_sym_lock] = ACTIONS(3304),
    [anon_sym_rlock] = ACTIONS(3304),
    [anon_sym_unsafe] = ACTIONS(3304),
    [anon_sym_sql] = ACTIONS(3304),
    [sym_int_literal] = ACTIONS(3304),
    [sym_float_literal] = ACTIONS(3302),
    [sym_rune_literal] = ACTIONS(3302),
    [anon_sym_SQUOTE] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(3302),
    [anon_sym_c_SQUOTE] = ACTIONS(3302),
    [anon_sym_c_DQUOTE] = ACTIONS(3302),
    [anon_sym_r_SQUOTE] = ACTIONS(3302),
    [anon_sym_r_DQUOTE] = ACTIONS(3302),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3304),
    [anon_sym_shared] = ACTIONS(3304),
    [anon_sym_map_LBRACK] = ACTIONS(3302),
    [anon_sym_chan] = ACTIONS(3304),
    [anon_sym_thread] = ACTIONS(3304),
    [anon_sym_atomic] = ACTIONS(3304),
  },
  [1647] = {
    [sym_line_comment] = STATE(1647),
    [sym_block_comment] = STATE(1647),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_as] = ACTIONS(3308),
    [anon_sym_LBRACE] = ACTIONS(3306),
    [anon_sym_COMMA] = ACTIONS(3306),
    [anon_sym_RBRACE] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3306),
    [anon_sym_fn] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_STAR] = ACTIONS(3306),
    [anon_sym_SLASH] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_EQ_EQ] = ACTIONS(3306),
    [anon_sym_BANG_EQ] = ACTIONS(3306),
    [anon_sym_LT_EQ] = ACTIONS(3306),
    [anon_sym_GT_EQ] = ACTIONS(3306),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3306),
    [anon_sym_struct] = ACTIONS(3308),
    [anon_sym_mut] = ACTIONS(3308),
    [anon_sym_COLON] = ACTIONS(3306),
    [anon_sym_PLUS_PLUS] = ACTIONS(3306),
    [anon_sym_DASH_DASH] = ACTIONS(3306),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_BANG] = ACTIONS(3308),
    [anon_sym_go] = ACTIONS(3308),
    [anon_sym_spawn] = ACTIONS(3308),
    [anon_sym_json_DOTdecode] = ACTIONS(3306),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_LBRACK2] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3306),
    [anon_sym_CARET] = ACTIONS(3306),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LT_DASH] = ACTIONS(3306),
    [anon_sym_LT_LT] = ACTIONS(3306),
    [anon_sym_GT_GT] = ACTIONS(3308),
    [anon_sym_GT_GT_GT] = ACTIONS(3306),
    [anon_sym_AMP_CARET] = ACTIONS(3306),
    [anon_sym_AMP_AMP] = ACTIONS(3306),
    [anon_sym_PIPE_PIPE] = ACTIONS(3306),
    [anon_sym_or] = ACTIONS(3308),
    [sym_none] = ACTIONS(3308),
    [sym_true] = ACTIONS(3308),
    [sym_false] = ACTIONS(3308),
    [sym_nil] = ACTIONS(3308),
    [anon_sym_QMARK_DOT] = ACTIONS(3306),
    [anon_sym_POUND_LBRACK] = ACTIONS(3306),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_DOLLARif] = ACTIONS(3308),
    [anon_sym_is] = ACTIONS(3308),
    [anon_sym_BANGis] = ACTIONS(3306),
    [anon_sym_in] = ACTIONS(3308),
    [anon_sym_BANGin] = ACTIONS(3306),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_select] = ACTIONS(3308),
    [anon_sym_lock] = ACTIONS(3308),
    [anon_sym_rlock] = ACTIONS(3308),
    [anon_sym_unsafe] = ACTIONS(3308),
    [anon_sym_sql] = ACTIONS(3308),
    [sym_int_literal] = ACTIONS(3308),
    [sym_float_literal] = ACTIONS(3306),
    [sym_rune_literal] = ACTIONS(3306),
    [anon_sym_SQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE] = ACTIONS(3306),
    [anon_sym_c_SQUOTE] = ACTIONS(3306),
    [anon_sym_c_DQUOTE] = ACTIONS(3306),
    [anon_sym_r_SQUOTE] = ACTIONS(3306),
    [anon_sym_r_DQUOTE] = ACTIONS(3306),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3308),
    [anon_sym_shared] = ACTIONS(3308),
    [anon_sym_map_LBRACK] = ACTIONS(3306),
    [anon_sym_chan] = ACTIONS(3308),
    [anon_sym_thread] = ACTIONS(3308),
    [anon_sym_atomic] = ACTIONS(3308),
  },
  [1648] = {
    [sym_line_comment] = STATE(1648),
    [sym_block_comment] = STATE(1648),
    [sym_identifier] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3312),
    [anon_sym_as] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3310),
    [anon_sym_COMMA] = ACTIONS(3310),
    [anon_sym_RBRACE] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3310),
    [anon_sym_fn] = ACTIONS(3312),
    [anon_sym_PLUS] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3310),
    [anon_sym_SLASH] = ACTIONS(3312),
    [anon_sym_PERCENT] = ACTIONS(3310),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_GT] = ACTIONS(3312),
    [anon_sym_EQ_EQ] = ACTIONS(3310),
    [anon_sym_BANG_EQ] = ACTIONS(3310),
    [anon_sym_LT_EQ] = ACTIONS(3310),
    [anon_sym_GT_EQ] = ACTIONS(3310),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_RBRACK] = ACTIONS(3310),
    [anon_sym_struct] = ACTIONS(3312),
    [anon_sym_mut] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3310),
    [anon_sym_PLUS_PLUS] = ACTIONS(3310),
    [anon_sym_DASH_DASH] = ACTIONS(3310),
    [anon_sym_QMARK] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_go] = ACTIONS(3312),
    [anon_sym_spawn] = ACTIONS(3312),
    [anon_sym_json_DOTdecode] = ACTIONS(3310),
    [anon_sym_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACK2] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3310),
    [anon_sym_CARET] = ACTIONS(3310),
    [anon_sym_AMP] = ACTIONS(3312),
    [anon_sym_LT_DASH] = ACTIONS(3310),
    [anon_sym_LT_LT] = ACTIONS(3310),
    [anon_sym_GT_GT] = ACTIONS(3312),
    [anon_sym_GT_GT_GT] = ACTIONS(3310),
    [anon_sym_AMP_CARET] = ACTIONS(3310),
    [anon_sym_AMP_AMP] = ACTIONS(3310),
    [anon_sym_PIPE_PIPE] = ACTIONS(3310),
    [anon_sym_or] = ACTIONS(3312),
    [sym_none] = ACTIONS(3312),
    [sym_true] = ACTIONS(3312),
    [sym_false] = ACTIONS(3312),
    [sym_nil] = ACTIONS(3312),
    [anon_sym_QMARK_DOT] = ACTIONS(3310),
    [anon_sym_POUND_LBRACK] = ACTIONS(3310),
    [anon_sym_if] = ACTIONS(3312),
    [anon_sym_DOLLARif] = ACTIONS(3312),
    [anon_sym_is] = ACTIONS(3312),
    [anon_sym_BANGis] = ACTIONS(3310),
    [anon_sym_in] = ACTIONS(3312),
    [anon_sym_BANGin] = ACTIONS(3310),
    [anon_sym_match] = ACTIONS(3312),
    [anon_sym_select] = ACTIONS(3312),
    [anon_sym_lock] = ACTIONS(3312),
    [anon_sym_rlock] = ACTIONS(3312),
    [anon_sym_unsafe] = ACTIONS(3312),
    [anon_sym_sql] = ACTIONS(3312),
    [sym_int_literal] = ACTIONS(3312),
    [sym_float_literal] = ACTIONS(3310),
    [sym_rune_literal] = ACTIONS(3310),
    [anon_sym_SQUOTE] = ACTIONS(3310),
    [anon_sym_DQUOTE] = ACTIONS(3310),
    [anon_sym_c_SQUOTE] = ACTIONS(3310),
    [anon_sym_c_DQUOTE] = ACTIONS(3310),
    [anon_sym_r_SQUOTE] = ACTIONS(3310),
    [anon_sym_r_DQUOTE] = ACTIONS(3310),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3312),
    [anon_sym_shared] = ACTIONS(3312),
    [anon_sym_map_LBRACK] = ACTIONS(3310),
    [anon_sym_chan] = ACTIONS(3312),
    [anon_sym_thread] = ACTIONS(3312),
    [anon_sym_atomic] = ACTIONS(3312),
  },
  [1649] = {
    [sym_line_comment] = STATE(1649),
    [sym_block_comment] = STATE(1649),
    [sym_identifier] = ACTIONS(2443),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2445),
    [anon_sym_as] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(2441),
    [anon_sym_COMMA] = ACTIONS(2441),
    [anon_sym_RBRACE] = ACTIONS(2441),
    [anon_sym_LPAREN] = ACTIONS(2448),
    [anon_sym_fn] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2445),
    [anon_sym_STAR] = ACTIONS(2448),
    [anon_sym_SLASH] = ACTIONS(2445),
    [anon_sym_PERCENT] = ACTIONS(2448),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_GT] = ACTIONS(2445),
    [anon_sym_EQ_EQ] = ACTIONS(2448),
    [anon_sym_BANG_EQ] = ACTIONS(2448),
    [anon_sym_LT_EQ] = ACTIONS(2448),
    [anon_sym_GT_EQ] = ACTIONS(2448),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_RBRACK] = ACTIONS(2441),
    [anon_sym_struct] = ACTIONS(2443),
    [anon_sym_mut] = ACTIONS(2443),
    [anon_sym_COLON] = ACTIONS(2441),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_QMARK] = ACTIONS(2445),
    [anon_sym_BANG] = ACTIONS(2445),
    [anon_sym_go] = ACTIONS(2443),
    [anon_sym_spawn] = ACTIONS(2443),
    [anon_sym_json_DOTdecode] = ACTIONS(2441),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_LBRACK2] = ACTIONS(2445),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_CARET] = ACTIONS(2448),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_LT_DASH] = ACTIONS(2441),
    [anon_sym_LT_LT] = ACTIONS(2448),
    [anon_sym_GT_GT] = ACTIONS(2445),
    [anon_sym_GT_GT_GT] = ACTIONS(2448),
    [anon_sym_AMP_CARET] = ACTIONS(2448),
    [anon_sym_AMP_AMP] = ACTIONS(2448),
    [anon_sym_PIPE_PIPE] = ACTIONS(2448),
    [anon_sym_or] = ACTIONS(2445),
    [sym_none] = ACTIONS(2443),
    [sym_true] = ACTIONS(2443),
    [sym_false] = ACTIONS(2443),
    [sym_nil] = ACTIONS(2443),
    [anon_sym_QMARK_DOT] = ACTIONS(2448),
    [anon_sym_POUND_LBRACK] = ACTIONS(2448),
    [anon_sym_if] = ACTIONS(2443),
    [anon_sym_DOLLARif] = ACTIONS(2443),
    [anon_sym_is] = ACTIONS(2445),
    [anon_sym_BANGis] = ACTIONS(2448),
    [anon_sym_in] = ACTIONS(2445),
    [anon_sym_BANGin] = ACTIONS(2448),
    [anon_sym_match] = ACTIONS(2443),
    [anon_sym_select] = ACTIONS(2443),
    [anon_sym_lock] = ACTIONS(2443),
    [anon_sym_rlock] = ACTIONS(2443),
    [anon_sym_unsafe] = ACTIONS(2443),
    [anon_sym_sql] = ACTIONS(2443),
    [sym_int_literal] = ACTIONS(2443),
    [sym_float_literal] = ACTIONS(2441),
    [sym_rune_literal] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2441),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [anon_sym_c_SQUOTE] = ACTIONS(2441),
    [anon_sym_c_DQUOTE] = ACTIONS(2441),
    [anon_sym_r_SQUOTE] = ACTIONS(2441),
    [anon_sym_r_DQUOTE] = ACTIONS(2441),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2443),
    [anon_sym_shared] = ACTIONS(2443),
    [anon_sym_map_LBRACK] = ACTIONS(2441),
    [anon_sym_chan] = ACTIONS(2443),
    [anon_sym_thread] = ACTIONS(2443),
    [anon_sym_atomic] = ACTIONS(2443),
  },
  [1650] = {
    [sym_line_comment] = STATE(1650),
    [sym_block_comment] = STATE(1650),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_as] = ACTIONS(3318),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_COMMA] = ACTIONS(3316),
    [anon_sym_RBRACE] = ACTIONS(3316),
    [anon_sym_LPAREN] = ACTIONS(3316),
    [anon_sym_fn] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_SLASH] = ACTIONS(3318),
    [anon_sym_PERCENT] = ACTIONS(3316),
    [anon_sym_LT] = ACTIONS(3318),
    [anon_sym_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3316),
    [anon_sym_BANG_EQ] = ACTIONS(3316),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_LBRACK] = ACTIONS(3316),
    [anon_sym_RBRACK] = ACTIONS(3316),
    [anon_sym_struct] = ACTIONS(3318),
    [anon_sym_mut] = ACTIONS(3318),
    [anon_sym_COLON] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_BANG] = ACTIONS(3318),
    [anon_sym_go] = ACTIONS(3318),
    [anon_sym_spawn] = ACTIONS(3318),
    [anon_sym_json_DOTdecode] = ACTIONS(3316),
    [anon_sym_PIPE] = ACTIONS(3318),
    [anon_sym_LBRACK2] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_CARET] = ACTIONS(3316),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LT_DASH] = ACTIONS(3316),
    [anon_sym_LT_LT] = ACTIONS(3316),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_GT_GT_GT] = ACTIONS(3316),
    [anon_sym_AMP_CARET] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_PIPE_PIPE] = ACTIONS(3316),
    [anon_sym_or] = ACTIONS(3318),
    [sym_none] = ACTIONS(3318),
    [sym_true] = ACTIONS(3318),
    [sym_false] = ACTIONS(3318),
    [sym_nil] = ACTIONS(3318),
    [anon_sym_QMARK_DOT] = ACTIONS(3316),
    [anon_sym_POUND_LBRACK] = ACTIONS(3316),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_DOLLARif] = ACTIONS(3318),
    [anon_sym_is] = ACTIONS(3318),
    [anon_sym_BANGis] = ACTIONS(3316),
    [anon_sym_in] = ACTIONS(3318),
    [anon_sym_BANGin] = ACTIONS(3316),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_select] = ACTIONS(3318),
    [anon_sym_lock] = ACTIONS(3318),
    [anon_sym_rlock] = ACTIONS(3318),
    [anon_sym_unsafe] = ACTIONS(3318),
    [anon_sym_sql] = ACTIONS(3318),
    [sym_int_literal] = ACTIONS(3318),
    [sym_float_literal] = ACTIONS(3316),
    [sym_rune_literal] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3316),
    [anon_sym_DQUOTE] = ACTIONS(3316),
    [anon_sym_c_SQUOTE] = ACTIONS(3316),
    [anon_sym_c_DQUOTE] = ACTIONS(3316),
    [anon_sym_r_SQUOTE] = ACTIONS(3316),
    [anon_sym_r_DQUOTE] = ACTIONS(3316),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3318),
    [anon_sym_shared] = ACTIONS(3318),
    [anon_sym_map_LBRACK] = ACTIONS(3316),
    [anon_sym_chan] = ACTIONS(3318),
    [anon_sym_thread] = ACTIONS(3318),
    [anon_sym_atomic] = ACTIONS(3318),
  },
  [1651] = {
    [sym_line_comment] = STATE(1651),
    [sym_block_comment] = STATE(1651),
    [sym_identifier] = ACTIONS(2993),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2993),
    [anon_sym_as] = ACTIONS(2993),
    [anon_sym_LBRACE] = ACTIONS(2991),
    [anon_sym_COMMA] = ACTIONS(2991),
    [anon_sym_RBRACE] = ACTIONS(2991),
    [anon_sym_LPAREN] = ACTIONS(2991),
    [anon_sym_fn] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2993),
    [anon_sym_DASH] = ACTIONS(2993),
    [anon_sym_STAR] = ACTIONS(2991),
    [anon_sym_SLASH] = ACTIONS(2993),
    [anon_sym_PERCENT] = ACTIONS(2991),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(2993),
    [anon_sym_EQ_EQ] = ACTIONS(2991),
    [anon_sym_BANG_EQ] = ACTIONS(2991),
    [anon_sym_LT_EQ] = ACTIONS(2991),
    [anon_sym_GT_EQ] = ACTIONS(2991),
    [anon_sym_LBRACK] = ACTIONS(2991),
    [anon_sym_RBRACK] = ACTIONS(2991),
    [anon_sym_struct] = ACTIONS(2993),
    [anon_sym_mut] = ACTIONS(2993),
    [anon_sym_COLON] = ACTIONS(2991),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [anon_sym_QMARK] = ACTIONS(2993),
    [anon_sym_BANG] = ACTIONS(2993),
    [anon_sym_go] = ACTIONS(2993),
    [anon_sym_spawn] = ACTIONS(2993),
    [anon_sym_json_DOTdecode] = ACTIONS(2991),
    [anon_sym_PIPE] = ACTIONS(2993),
    [anon_sym_LBRACK2] = ACTIONS(2993),
    [anon_sym_TILDE] = ACTIONS(2991),
    [anon_sym_CARET] = ACTIONS(2991),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_LT_DASH] = ACTIONS(2991),
    [anon_sym_LT_LT] = ACTIONS(2991),
    [anon_sym_GT_GT] = ACTIONS(2993),
    [anon_sym_GT_GT_GT] = ACTIONS(2991),
    [anon_sym_AMP_CARET] = ACTIONS(2991),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_or] = ACTIONS(2993),
    [sym_none] = ACTIONS(2993),
    [sym_true] = ACTIONS(2993),
    [sym_false] = ACTIONS(2993),
    [sym_nil] = ACTIONS(2993),
    [anon_sym_QMARK_DOT] = ACTIONS(2991),
    [anon_sym_POUND_LBRACK] = ACTIONS(2991),
    [anon_sym_if] = ACTIONS(2993),
    [anon_sym_DOLLARif] = ACTIONS(2993),
    [anon_sym_is] = ACTIONS(2993),
    [anon_sym_BANGis] = ACTIONS(2991),
    [anon_sym_in] = ACTIONS(2993),
    [anon_sym_BANGin] = ACTIONS(2991),
    [anon_sym_match] = ACTIONS(2993),
    [anon_sym_select] = ACTIONS(2993),
    [anon_sym_lock] = ACTIONS(2993),
    [anon_sym_rlock] = ACTIONS(2993),
    [anon_sym_unsafe] = ACTIONS(2993),
    [anon_sym_sql] = ACTIONS(2993),
    [sym_int_literal] = ACTIONS(2993),
    [sym_float_literal] = ACTIONS(2991),
    [sym_rune_literal] = ACTIONS(2991),
    [anon_sym_SQUOTE] = ACTIONS(2991),
    [anon_sym_DQUOTE] = ACTIONS(2991),
    [anon_sym_c_SQUOTE] = ACTIONS(2991),
    [anon_sym_c_DQUOTE] = ACTIONS(2991),
    [anon_sym_r_SQUOTE] = ACTIONS(2991),
    [anon_sym_r_DQUOTE] = ACTIONS(2991),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2993),
    [anon_sym_shared] = ACTIONS(2993),
    [anon_sym_map_LBRACK] = ACTIONS(2991),
    [anon_sym_chan] = ACTIONS(2993),
    [anon_sym_thread] = ACTIONS(2993),
    [anon_sym_atomic] = ACTIONS(2993),
  },
  [1652] = {
    [sym_line_comment] = STATE(1652),
    [sym_block_comment] = STATE(1652),
    [sym_identifier] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3324),
    [anon_sym_as] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_COMMA] = ACTIONS(3322),
    [anon_sym_RBRACE] = ACTIONS(3322),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_fn] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3324),
    [anon_sym_DASH] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3322),
    [anon_sym_SLASH] = ACTIONS(3324),
    [anon_sym_PERCENT] = ACTIONS(3322),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_GT] = ACTIONS(3324),
    [anon_sym_EQ_EQ] = ACTIONS(3322),
    [anon_sym_BANG_EQ] = ACTIONS(3322),
    [anon_sym_LT_EQ] = ACTIONS(3322),
    [anon_sym_GT_EQ] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_RBRACK] = ACTIONS(3322),
    [anon_sym_struct] = ACTIONS(3324),
    [anon_sym_mut] = ACTIONS(3324),
    [anon_sym_COLON] = ACTIONS(3322),
    [anon_sym_PLUS_PLUS] = ACTIONS(3322),
    [anon_sym_DASH_DASH] = ACTIONS(3322),
    [anon_sym_QMARK] = ACTIONS(3324),
    [anon_sym_BANG] = ACTIONS(3324),
    [anon_sym_go] = ACTIONS(3324),
    [anon_sym_spawn] = ACTIONS(3324),
    [anon_sym_json_DOTdecode] = ACTIONS(3322),
    [anon_sym_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACK2] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3322),
    [anon_sym_CARET] = ACTIONS(3322),
    [anon_sym_AMP] = ACTIONS(3324),
    [anon_sym_LT_DASH] = ACTIONS(3322),
    [anon_sym_LT_LT] = ACTIONS(3322),
    [anon_sym_GT_GT] = ACTIONS(3324),
    [anon_sym_GT_GT_GT] = ACTIONS(3322),
    [anon_sym_AMP_CARET] = ACTIONS(3322),
    [anon_sym_AMP_AMP] = ACTIONS(3322),
    [anon_sym_PIPE_PIPE] = ACTIONS(3322),
    [anon_sym_or] = ACTIONS(3324),
    [sym_none] = ACTIONS(3324),
    [sym_true] = ACTIONS(3324),
    [sym_false] = ACTIONS(3324),
    [sym_nil] = ACTIONS(3324),
    [anon_sym_QMARK_DOT] = ACTIONS(3322),
    [anon_sym_POUND_LBRACK] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3324),
    [anon_sym_DOLLARif] = ACTIONS(3324),
    [anon_sym_is] = ACTIONS(3324),
    [anon_sym_BANGis] = ACTIONS(3322),
    [anon_sym_in] = ACTIONS(3324),
    [anon_sym_BANGin] = ACTIONS(3322),
    [anon_sym_match] = ACTIONS(3324),
    [anon_sym_select] = ACTIONS(3324),
    [anon_sym_lock] = ACTIONS(3324),
    [anon_sym_rlock] = ACTIONS(3324),
    [anon_sym_unsafe] = ACTIONS(3324),
    [anon_sym_sql] = ACTIONS(3324),
    [sym_int_literal] = ACTIONS(3324),
    [sym_float_literal] = ACTIONS(3322),
    [sym_rune_literal] = ACTIONS(3322),
    [anon_sym_SQUOTE] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_c_SQUOTE] = ACTIONS(3322),
    [anon_sym_c_DQUOTE] = ACTIONS(3322),
    [anon_sym_r_SQUOTE] = ACTIONS(3322),
    [anon_sym_r_DQUOTE] = ACTIONS(3322),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3324),
    [anon_sym_shared] = ACTIONS(3324),
    [anon_sym_map_LBRACK] = ACTIONS(3322),
    [anon_sym_chan] = ACTIONS(3324),
    [anon_sym_thread] = ACTIONS(3324),
    [anon_sym_atomic] = ACTIONS(3324),
  },
  [1653] = {
    [sym_line_comment] = STATE(1653),
    [sym_block_comment] = STATE(1653),
    [sym_identifier] = ACTIONS(3346),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3346),
    [anon_sym_as] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3344),
    [anon_sym_COMMA] = ACTIONS(3344),
    [anon_sym_RBRACE] = ACTIONS(3344),
    [anon_sym_LPAREN] = ACTIONS(3344),
    [anon_sym_fn] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3344),
    [anon_sym_SLASH] = ACTIONS(3346),
    [anon_sym_PERCENT] = ACTIONS(3344),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_GT] = ACTIONS(3346),
    [anon_sym_EQ_EQ] = ACTIONS(3344),
    [anon_sym_BANG_EQ] = ACTIONS(3344),
    [anon_sym_LT_EQ] = ACTIONS(3344),
    [anon_sym_GT_EQ] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_RBRACK] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3346),
    [anon_sym_mut] = ACTIONS(3346),
    [anon_sym_COLON] = ACTIONS(3344),
    [anon_sym_PLUS_PLUS] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3344),
    [anon_sym_QMARK] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_go] = ACTIONS(3346),
    [anon_sym_spawn] = ACTIONS(3346),
    [anon_sym_json_DOTdecode] = ACTIONS(3344),
    [anon_sym_PIPE] = ACTIONS(3346),
    [anon_sym_LBRACK2] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_CARET] = ACTIONS(3344),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym_LT_DASH] = ACTIONS(3344),
    [anon_sym_LT_LT] = ACTIONS(3344),
    [anon_sym_GT_GT] = ACTIONS(3346),
    [anon_sym_GT_GT_GT] = ACTIONS(3344),
    [anon_sym_AMP_CARET] = ACTIONS(3344),
    [anon_sym_AMP_AMP] = ACTIONS(3344),
    [anon_sym_PIPE_PIPE] = ACTIONS(3344),
    [anon_sym_or] = ACTIONS(3346),
    [sym_none] = ACTIONS(3346),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [sym_nil] = ACTIONS(3346),
    [anon_sym_QMARK_DOT] = ACTIONS(3344),
    [anon_sym_POUND_LBRACK] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3346),
    [anon_sym_DOLLARif] = ACTIONS(3346),
    [anon_sym_is] = ACTIONS(3346),
    [anon_sym_BANGis] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3346),
    [anon_sym_BANGin] = ACTIONS(3344),
    [anon_sym_match] = ACTIONS(3346),
    [anon_sym_select] = ACTIONS(3346),
    [anon_sym_lock] = ACTIONS(3346),
    [anon_sym_rlock] = ACTIONS(3346),
    [anon_sym_unsafe] = ACTIONS(3346),
    [anon_sym_sql] = ACTIONS(3346),
    [sym_int_literal] = ACTIONS(3346),
    [sym_float_literal] = ACTIONS(3344),
    [sym_rune_literal] = ACTIONS(3344),
    [anon_sym_SQUOTE] = ACTIONS(3344),
    [anon_sym_DQUOTE] = ACTIONS(3344),
    [anon_sym_c_SQUOTE] = ACTIONS(3344),
    [anon_sym_c_DQUOTE] = ACTIONS(3344),
    [anon_sym_r_SQUOTE] = ACTIONS(3344),
    [anon_sym_r_DQUOTE] = ACTIONS(3344),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3346),
    [anon_sym_shared] = ACTIONS(3346),
    [anon_sym_map_LBRACK] = ACTIONS(3344),
    [anon_sym_chan] = ACTIONS(3346),
    [anon_sym_thread] = ACTIONS(3346),
    [anon_sym_atomic] = ACTIONS(3346),
  },
  [1654] = {
    [sym_line_comment] = STATE(1654),
    [sym_block_comment] = STATE(1654),
    [sym_identifier] = ACTIONS(3035),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3035),
    [anon_sym_as] = ACTIONS(3035),
    [anon_sym_LBRACE] = ACTIONS(3033),
    [anon_sym_COMMA] = ACTIONS(3033),
    [anon_sym_RBRACE] = ACTIONS(3033),
    [anon_sym_LPAREN] = ACTIONS(3033),
    [anon_sym_fn] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3033),
    [anon_sym_SLASH] = ACTIONS(3035),
    [anon_sym_PERCENT] = ACTIONS(3033),
    [anon_sym_LT] = ACTIONS(3035),
    [anon_sym_GT] = ACTIONS(3035),
    [anon_sym_EQ_EQ] = ACTIONS(3033),
    [anon_sym_BANG_EQ] = ACTIONS(3033),
    [anon_sym_LT_EQ] = ACTIONS(3033),
    [anon_sym_GT_EQ] = ACTIONS(3033),
    [anon_sym_LBRACK] = ACTIONS(3033),
    [anon_sym_RBRACK] = ACTIONS(3033),
    [anon_sym_struct] = ACTIONS(3035),
    [anon_sym_mut] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3033),
    [anon_sym_PLUS_PLUS] = ACTIONS(3033),
    [anon_sym_DASH_DASH] = ACTIONS(3033),
    [anon_sym_QMARK] = ACTIONS(3035),
    [anon_sym_BANG] = ACTIONS(3035),
    [anon_sym_go] = ACTIONS(3035),
    [anon_sym_spawn] = ACTIONS(3035),
    [anon_sym_json_DOTdecode] = ACTIONS(3033),
    [anon_sym_PIPE] = ACTIONS(3035),
    [anon_sym_LBRACK2] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3033),
    [anon_sym_CARET] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_LT_DASH] = ACTIONS(3033),
    [anon_sym_LT_LT] = ACTIONS(3033),
    [anon_sym_GT_GT] = ACTIONS(3035),
    [anon_sym_GT_GT_GT] = ACTIONS(3033),
    [anon_sym_AMP_CARET] = ACTIONS(3033),
    [anon_sym_AMP_AMP] = ACTIONS(3033),
    [anon_sym_PIPE_PIPE] = ACTIONS(3033),
    [anon_sym_or] = ACTIONS(3035),
    [sym_none] = ACTIONS(3035),
    [sym_true] = ACTIONS(3035),
    [sym_false] = ACTIONS(3035),
    [sym_nil] = ACTIONS(3035),
    [anon_sym_QMARK_DOT] = ACTIONS(3033),
    [anon_sym_POUND_LBRACK] = ACTIONS(3033),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_DOLLARif] = ACTIONS(3035),
    [anon_sym_is] = ACTIONS(3035),
    [anon_sym_BANGis] = ACTIONS(3033),
    [anon_sym_in] = ACTIONS(3035),
    [anon_sym_BANGin] = ACTIONS(3033),
    [anon_sym_match] = ACTIONS(3035),
    [anon_sym_select] = ACTIONS(3035),
    [anon_sym_lock] = ACTIONS(3035),
    [anon_sym_rlock] = ACTIONS(3035),
    [anon_sym_unsafe] = ACTIONS(3035),
    [anon_sym_sql] = ACTIONS(3035),
    [sym_int_literal] = ACTIONS(3035),
    [sym_float_literal] = ACTIONS(3033),
    [sym_rune_literal] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3033),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_c_SQUOTE] = ACTIONS(3033),
    [anon_sym_c_DQUOTE] = ACTIONS(3033),
    [anon_sym_r_SQUOTE] = ACTIONS(3033),
    [anon_sym_r_DQUOTE] = ACTIONS(3033),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3035),
    [anon_sym_shared] = ACTIONS(3035),
    [anon_sym_map_LBRACK] = ACTIONS(3033),
    [anon_sym_chan] = ACTIONS(3035),
    [anon_sym_thread] = ACTIONS(3035),
    [anon_sym_atomic] = ACTIONS(3035),
  },
  [1655] = {
    [sym_line_comment] = STATE(1655),
    [sym_block_comment] = STATE(1655),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2893),
    [anon_sym_as] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_COMMA] = ACTIONS(2891),
    [anon_sym_RBRACE] = ACTIONS(2891),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_fn] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2891),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_PERCENT] = ACTIONS(2891),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_GT] = ACTIONS(2893),
    [anon_sym_EQ_EQ] = ACTIONS(2891),
    [anon_sym_BANG_EQ] = ACTIONS(2891),
    [anon_sym_LT_EQ] = ACTIONS(2891),
    [anon_sym_GT_EQ] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_RBRACK] = ACTIONS(2891),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_mut] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2891),
    [anon_sym_PLUS_PLUS] = ACTIONS(2891),
    [anon_sym_DASH_DASH] = ACTIONS(2891),
    [anon_sym_QMARK] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_go] = ACTIONS(2893),
    [anon_sym_spawn] = ACTIONS(2893),
    [anon_sym_json_DOTdecode] = ACTIONS(2891),
    [anon_sym_PIPE] = ACTIONS(2893),
    [anon_sym_LBRACK2] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2891),
    [anon_sym_CARET] = ACTIONS(2891),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_LT_DASH] = ACTIONS(2891),
    [anon_sym_LT_LT] = ACTIONS(2891),
    [anon_sym_GT_GT] = ACTIONS(2893),
    [anon_sym_GT_GT_GT] = ACTIONS(2891),
    [anon_sym_AMP_CARET] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [anon_sym_or] = ACTIONS(2893),
    [sym_none] = ACTIONS(2893),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [sym_nil] = ACTIONS(2893),
    [anon_sym_QMARK_DOT] = ACTIONS(2891),
    [anon_sym_POUND_LBRACK] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_DOLLARif] = ACTIONS(2893),
    [anon_sym_is] = ACTIONS(2893),
    [anon_sym_BANGis] = ACTIONS(2891),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_BANGin] = ACTIONS(2891),
    [anon_sym_match] = ACTIONS(2893),
    [anon_sym_select] = ACTIONS(2893),
    [anon_sym_lock] = ACTIONS(2893),
    [anon_sym_rlock] = ACTIONS(2893),
    [anon_sym_unsafe] = ACTIONS(2893),
    [anon_sym_sql] = ACTIONS(2893),
    [sym_int_literal] = ACTIONS(2893),
    [sym_float_literal] = ACTIONS(2891),
    [sym_rune_literal] = ACTIONS(2891),
    [anon_sym_SQUOTE] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_c_SQUOTE] = ACTIONS(2891),
    [anon_sym_c_DQUOTE] = ACTIONS(2891),
    [anon_sym_r_SQUOTE] = ACTIONS(2891),
    [anon_sym_r_DQUOTE] = ACTIONS(2891),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_map_LBRACK] = ACTIONS(2891),
    [anon_sym_chan] = ACTIONS(2893),
    [anon_sym_thread] = ACTIONS(2893),
    [anon_sym_atomic] = ACTIONS(2893),
  },
  [1656] = {
    [sym_line_comment] = STATE(1656),
    [sym_block_comment] = STATE(1656),
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3045),
    [anon_sym_as] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3043),
    [anon_sym_RBRACE] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_fn] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3043),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_PERCENT] = ACTIONS(3043),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_GT] = ACTIONS(3045),
    [anon_sym_EQ_EQ] = ACTIONS(3043),
    [anon_sym_BANG_EQ] = ACTIONS(3043),
    [anon_sym_LT_EQ] = ACTIONS(3043),
    [anon_sym_GT_EQ] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_RBRACK] = ACTIONS(3043),
    [anon_sym_struct] = ACTIONS(3045),
    [anon_sym_mut] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(3043),
    [anon_sym_PLUS_PLUS] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3045),
    [anon_sym_go] = ACTIONS(3045),
    [anon_sym_spawn] = ACTIONS(3045),
    [anon_sym_json_DOTdecode] = ACTIONS(3043),
    [anon_sym_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACK2] = ACTIONS(3045),
    [anon_sym_TILDE] = ACTIONS(3043),
    [anon_sym_CARET] = ACTIONS(3043),
    [anon_sym_AMP] = ACTIONS(3045),
    [anon_sym_LT_DASH] = ACTIONS(3043),
    [anon_sym_LT_LT] = ACTIONS(3043),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_GT_GT_GT] = ACTIONS(3043),
    [anon_sym_AMP_CARET] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [anon_sym_or] = ACTIONS(3045),
    [sym_none] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_nil] = ACTIONS(3045),
    [anon_sym_QMARK_DOT] = ACTIONS(3043),
    [anon_sym_POUND_LBRACK] = ACTIONS(3043),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_DOLLARif] = ACTIONS(3045),
    [anon_sym_is] = ACTIONS(3045),
    [anon_sym_BANGis] = ACTIONS(3043),
    [anon_sym_in] = ACTIONS(3045),
    [anon_sym_BANGin] = ACTIONS(3043),
    [anon_sym_match] = ACTIONS(3045),
    [anon_sym_select] = ACTIONS(3045),
    [anon_sym_lock] = ACTIONS(3045),
    [anon_sym_rlock] = ACTIONS(3045),
    [anon_sym_unsafe] = ACTIONS(3045),
    [anon_sym_sql] = ACTIONS(3045),
    [sym_int_literal] = ACTIONS(3045),
    [sym_float_literal] = ACTIONS(3043),
    [sym_rune_literal] = ACTIONS(3043),
    [anon_sym_SQUOTE] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [anon_sym_c_SQUOTE] = ACTIONS(3043),
    [anon_sym_c_DQUOTE] = ACTIONS(3043),
    [anon_sym_r_SQUOTE] = ACTIONS(3043),
    [anon_sym_r_DQUOTE] = ACTIONS(3043),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3045),
    [anon_sym_shared] = ACTIONS(3045),
    [anon_sym_map_LBRACK] = ACTIONS(3043),
    [anon_sym_chan] = ACTIONS(3045),
    [anon_sym_thread] = ACTIONS(3045),
    [anon_sym_atomic] = ACTIONS(3045),
  },
  [1657] = {
    [sym_line_comment] = STATE(1657),
    [sym_block_comment] = STATE(1657),
    [sym_identifier] = ACTIONS(2187),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2187),
    [anon_sym_as] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2185),
    [anon_sym_COMMA] = ACTIONS(2185),
    [anon_sym_RBRACE] = ACTIONS(2185),
    [anon_sym_LPAREN] = ACTIONS(2185),
    [anon_sym_fn] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2185),
    [anon_sym_LT] = ACTIONS(2187),
    [anon_sym_GT] = ACTIONS(2187),
    [anon_sym_EQ_EQ] = ACTIONS(2185),
    [anon_sym_BANG_EQ] = ACTIONS(2185),
    [anon_sym_LT_EQ] = ACTIONS(2185),
    [anon_sym_GT_EQ] = ACTIONS(2185),
    [anon_sym_LBRACK] = ACTIONS(2185),
    [anon_sym_RBRACK] = ACTIONS(2185),
    [anon_sym_struct] = ACTIONS(2187),
    [anon_sym_mut] = ACTIONS(2187),
    [anon_sym_COLON] = ACTIONS(2185),
    [anon_sym_PLUS_PLUS] = ACTIONS(2185),
    [anon_sym_DASH_DASH] = ACTIONS(2185),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_go] = ACTIONS(2187),
    [anon_sym_spawn] = ACTIONS(2187),
    [anon_sym_json_DOTdecode] = ACTIONS(2185),
    [anon_sym_PIPE] = ACTIONS(2187),
    [anon_sym_LBRACK2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2185),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_LT_DASH] = ACTIONS(2185),
    [anon_sym_LT_LT] = ACTIONS(2185),
    [anon_sym_GT_GT] = ACTIONS(2187),
    [anon_sym_GT_GT_GT] = ACTIONS(2185),
    [anon_sym_AMP_CARET] = ACTIONS(2185),
    [anon_sym_AMP_AMP] = ACTIONS(2185),
    [anon_sym_PIPE_PIPE] = ACTIONS(2185),
    [anon_sym_or] = ACTIONS(2187),
    [sym_none] = ACTIONS(2187),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [sym_nil] = ACTIONS(2187),
    [anon_sym_QMARK_DOT] = ACTIONS(2185),
    [anon_sym_POUND_LBRACK] = ACTIONS(2185),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_DOLLARif] = ACTIONS(2187),
    [anon_sym_is] = ACTIONS(2187),
    [anon_sym_BANGis] = ACTIONS(2185),
    [anon_sym_in] = ACTIONS(2187),
    [anon_sym_BANGin] = ACTIONS(2185),
    [anon_sym_match] = ACTIONS(2187),
    [anon_sym_select] = ACTIONS(2187),
    [anon_sym_lock] = ACTIONS(2187),
    [anon_sym_rlock] = ACTIONS(2187),
    [anon_sym_unsafe] = ACTIONS(2187),
    [anon_sym_sql] = ACTIONS(2187),
    [sym_int_literal] = ACTIONS(2187),
    [sym_float_literal] = ACTIONS(2185),
    [sym_rune_literal] = ACTIONS(2185),
    [anon_sym_SQUOTE] = ACTIONS(2185),
    [anon_sym_DQUOTE] = ACTIONS(2185),
    [anon_sym_c_SQUOTE] = ACTIONS(2185),
    [anon_sym_c_DQUOTE] = ACTIONS(2185),
    [anon_sym_r_SQUOTE] = ACTIONS(2185),
    [anon_sym_r_DQUOTE] = ACTIONS(2185),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2187),
    [anon_sym_shared] = ACTIONS(2187),
    [anon_sym_map_LBRACK] = ACTIONS(2185),
    [anon_sym_chan] = ACTIONS(2187),
    [anon_sym_thread] = ACTIONS(2187),
    [anon_sym_atomic] = ACTIONS(2187),
  },
  [1658] = {
    [sym_line_comment] = STATE(1658),
    [sym_block_comment] = STATE(1658),
    [sym_identifier] = ACTIONS(2989),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_as] = ACTIONS(2989),
    [anon_sym_LBRACE] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(2987),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_fn] = ACTIONS(2989),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2987),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_EQ_EQ] = ACTIONS(2987),
    [anon_sym_BANG_EQ] = ACTIONS(2987),
    [anon_sym_LT_EQ] = ACTIONS(2987),
    [anon_sym_GT_EQ] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_RBRACK] = ACTIONS(2987),
    [anon_sym_struct] = ACTIONS(2989),
    [anon_sym_mut] = ACTIONS(2989),
    [anon_sym_COLON] = ACTIONS(2987),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_go] = ACTIONS(2989),
    [anon_sym_spawn] = ACTIONS(2989),
    [anon_sym_json_DOTdecode] = ACTIONS(2987),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_LBRACK2] = ACTIONS(2989),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_CARET] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_LT_DASH] = ACTIONS(2987),
    [anon_sym_LT_LT] = ACTIONS(2987),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2987),
    [anon_sym_AMP_CARET] = ACTIONS(2987),
    [anon_sym_AMP_AMP] = ACTIONS(2987),
    [anon_sym_PIPE_PIPE] = ACTIONS(2987),
    [anon_sym_or] = ACTIONS(2989),
    [sym_none] = ACTIONS(2989),
    [sym_true] = ACTIONS(2989),
    [sym_false] = ACTIONS(2989),
    [sym_nil] = ACTIONS(2989),
    [anon_sym_QMARK_DOT] = ACTIONS(2987),
    [anon_sym_POUND_LBRACK] = ACTIONS(2987),
    [anon_sym_if] = ACTIONS(2989),
    [anon_sym_DOLLARif] = ACTIONS(2989),
    [anon_sym_is] = ACTIONS(2989),
    [anon_sym_BANGis] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(2989),
    [anon_sym_BANGin] = ACTIONS(2987),
    [anon_sym_match] = ACTIONS(2989),
    [anon_sym_select] = ACTIONS(2989),
    [anon_sym_lock] = ACTIONS(2989),
    [anon_sym_rlock] = ACTIONS(2989),
    [anon_sym_unsafe] = ACTIONS(2989),
    [anon_sym_sql] = ACTIONS(2989),
    [sym_int_literal] = ACTIONS(2989),
    [sym_float_literal] = ACTIONS(2987),
    [sym_rune_literal] = ACTIONS(2987),
    [anon_sym_SQUOTE] = ACTIONS(2987),
    [anon_sym_DQUOTE] = ACTIONS(2987),
    [anon_sym_c_SQUOTE] = ACTIONS(2987),
    [anon_sym_c_DQUOTE] = ACTIONS(2987),
    [anon_sym_r_SQUOTE] = ACTIONS(2987),
    [anon_sym_r_DQUOTE] = ACTIONS(2987),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2989),
    [anon_sym_shared] = ACTIONS(2989),
    [anon_sym_map_LBRACK] = ACTIONS(2987),
    [anon_sym_chan] = ACTIONS(2989),
    [anon_sym_thread] = ACTIONS(2989),
    [anon_sym_atomic] = ACTIONS(2989),
  },
  [1659] = {
    [sym_line_comment] = STATE(1659),
    [sym_block_comment] = STATE(1659),
    [sym_identifier] = ACTIONS(3069),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3069),
    [anon_sym_as] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3067),
    [anon_sym_RBRACE] = ACTIONS(3067),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_fn] = ACTIONS(3069),
    [anon_sym_PLUS] = ACTIONS(3069),
    [anon_sym_DASH] = ACTIONS(3069),
    [anon_sym_STAR] = ACTIONS(3067),
    [anon_sym_SLASH] = ACTIONS(3069),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_GT] = ACTIONS(3069),
    [anon_sym_EQ_EQ] = ACTIONS(3067),
    [anon_sym_BANG_EQ] = ACTIONS(3067),
    [anon_sym_LT_EQ] = ACTIONS(3067),
    [anon_sym_GT_EQ] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_RBRACK] = ACTIONS(3067),
    [anon_sym_struct] = ACTIONS(3069),
    [anon_sym_mut] = ACTIONS(3069),
    [anon_sym_COLON] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3067),
    [anon_sym_DASH_DASH] = ACTIONS(3067),
    [anon_sym_QMARK] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(3069),
    [anon_sym_go] = ACTIONS(3069),
    [anon_sym_spawn] = ACTIONS(3069),
    [anon_sym_json_DOTdecode] = ACTIONS(3067),
    [anon_sym_PIPE] = ACTIONS(3069),
    [anon_sym_LBRACK2] = ACTIONS(3069),
    [anon_sym_TILDE] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3069),
    [anon_sym_LT_DASH] = ACTIONS(3067),
    [anon_sym_LT_LT] = ACTIONS(3067),
    [anon_sym_GT_GT] = ACTIONS(3069),
    [anon_sym_GT_GT_GT] = ACTIONS(3067),
    [anon_sym_AMP_CARET] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3067),
    [anon_sym_PIPE_PIPE] = ACTIONS(3067),
    [anon_sym_or] = ACTIONS(3069),
    [sym_none] = ACTIONS(3069),
    [sym_true] = ACTIONS(3069),
    [sym_false] = ACTIONS(3069),
    [sym_nil] = ACTIONS(3069),
    [anon_sym_QMARK_DOT] = ACTIONS(3067),
    [anon_sym_POUND_LBRACK] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3069),
    [anon_sym_DOLLARif] = ACTIONS(3069),
    [anon_sym_is] = ACTIONS(3069),
    [anon_sym_BANGis] = ACTIONS(3067),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_BANGin] = ACTIONS(3067),
    [anon_sym_match] = ACTIONS(3069),
    [anon_sym_select] = ACTIONS(3069),
    [anon_sym_lock] = ACTIONS(3069),
    [anon_sym_rlock] = ACTIONS(3069),
    [anon_sym_unsafe] = ACTIONS(3069),
    [anon_sym_sql] = ACTIONS(3069),
    [sym_int_literal] = ACTIONS(3069),
    [sym_float_literal] = ACTIONS(3067),
    [sym_rune_literal] = ACTIONS(3067),
    [anon_sym_SQUOTE] = ACTIONS(3067),
    [anon_sym_DQUOTE] = ACTIONS(3067),
    [anon_sym_c_SQUOTE] = ACTIONS(3067),
    [anon_sym_c_DQUOTE] = ACTIONS(3067),
    [anon_sym_r_SQUOTE] = ACTIONS(3067),
    [anon_sym_r_DQUOTE] = ACTIONS(3067),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3069),
    [anon_sym_shared] = ACTIONS(3069),
    [anon_sym_map_LBRACK] = ACTIONS(3067),
    [anon_sym_chan] = ACTIONS(3069),
    [anon_sym_thread] = ACTIONS(3069),
    [anon_sym_atomic] = ACTIONS(3069),
  },
  [1660] = {
    [sym_line_comment] = STATE(1660),
    [sym_block_comment] = STATE(1660),
    [sym_identifier] = ACTIONS(3328),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3328),
    [anon_sym_as] = ACTIONS(3328),
    [anon_sym_LBRACE] = ACTIONS(3326),
    [anon_sym_COMMA] = ACTIONS(3326),
    [anon_sym_RBRACE] = ACTIONS(3326),
    [anon_sym_LPAREN] = ACTIONS(3326),
    [anon_sym_fn] = ACTIONS(3328),
    [anon_sym_PLUS] = ACTIONS(3328),
    [anon_sym_DASH] = ACTIONS(3328),
    [anon_sym_STAR] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3328),
    [anon_sym_PERCENT] = ACTIONS(3326),
    [anon_sym_LT] = ACTIONS(3328),
    [anon_sym_GT] = ACTIONS(3328),
    [anon_sym_EQ_EQ] = ACTIONS(3326),
    [anon_sym_BANG_EQ] = ACTIONS(3326),
    [anon_sym_LT_EQ] = ACTIONS(3326),
    [anon_sym_GT_EQ] = ACTIONS(3326),
    [anon_sym_LBRACK] = ACTIONS(3326),
    [anon_sym_RBRACK] = ACTIONS(3326),
    [anon_sym_struct] = ACTIONS(3328),
    [anon_sym_mut] = ACTIONS(3328),
    [anon_sym_COLON] = ACTIONS(3326),
    [anon_sym_PLUS_PLUS] = ACTIONS(3326),
    [anon_sym_DASH_DASH] = ACTIONS(3326),
    [anon_sym_QMARK] = ACTIONS(3328),
    [anon_sym_BANG] = ACTIONS(3328),
    [anon_sym_go] = ACTIONS(3328),
    [anon_sym_spawn] = ACTIONS(3328),
    [anon_sym_json_DOTdecode] = ACTIONS(3326),
    [anon_sym_PIPE] = ACTIONS(3328),
    [anon_sym_LBRACK2] = ACTIONS(3328),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_CARET] = ACTIONS(3326),
    [anon_sym_AMP] = ACTIONS(3328),
    [anon_sym_LT_DASH] = ACTIONS(3326),
    [anon_sym_LT_LT] = ACTIONS(3326),
    [anon_sym_GT_GT] = ACTIONS(3328),
    [anon_sym_GT_GT_GT] = ACTIONS(3326),
    [anon_sym_AMP_CARET] = ACTIONS(3326),
    [anon_sym_AMP_AMP] = ACTIONS(3326),
    [anon_sym_PIPE_PIPE] = ACTIONS(3326),
    [anon_sym_or] = ACTIONS(3328),
    [sym_none] = ACTIONS(3328),
    [sym_true] = ACTIONS(3328),
    [sym_false] = ACTIONS(3328),
    [sym_nil] = ACTIONS(3328),
    [anon_sym_QMARK_DOT] = ACTIONS(3326),
    [anon_sym_POUND_LBRACK] = ACTIONS(3326),
    [anon_sym_if] = ACTIONS(3328),
    [anon_sym_DOLLARif] = ACTIONS(3328),
    [anon_sym_is] = ACTIONS(3328),
    [anon_sym_BANGis] = ACTIONS(3326),
    [anon_sym_in] = ACTIONS(3328),
    [anon_sym_BANGin] = ACTIONS(3326),
    [anon_sym_match] = ACTIONS(3328),
    [anon_sym_select] = ACTIONS(3328),
    [anon_sym_lock] = ACTIONS(3328),
    [anon_sym_rlock] = ACTIONS(3328),
    [anon_sym_unsafe] = ACTIONS(3328),
    [anon_sym_sql] = ACTIONS(3328),
    [sym_int_literal] = ACTIONS(3328),
    [sym_float_literal] = ACTIONS(3326),
    [sym_rune_literal] = ACTIONS(3326),
    [anon_sym_SQUOTE] = ACTIONS(3326),
    [anon_sym_DQUOTE] = ACTIONS(3326),
    [anon_sym_c_SQUOTE] = ACTIONS(3326),
    [anon_sym_c_DQUOTE] = ACTIONS(3326),
    [anon_sym_r_SQUOTE] = ACTIONS(3326),
    [anon_sym_r_DQUOTE] = ACTIONS(3326),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3328),
    [anon_sym_shared] = ACTIONS(3328),
    [anon_sym_map_LBRACK] = ACTIONS(3326),
    [anon_sym_chan] = ACTIONS(3328),
    [anon_sym_thread] = ACTIONS(3328),
    [anon_sym_atomic] = ACTIONS(3328),
  },
  [1661] = {
    [sym_line_comment] = STATE(1661),
    [sym_block_comment] = STATE(1661),
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3356),
    [anon_sym_as] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_COMMA] = ACTIONS(3354),
    [anon_sym_RBRACE] = ACTIONS(3354),
    [anon_sym_LPAREN] = ACTIONS(3354),
    [anon_sym_fn] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_STAR] = ACTIONS(3354),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_PERCENT] = ACTIONS(3354),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_GT] = ACTIONS(3356),
    [anon_sym_EQ_EQ] = ACTIONS(3354),
    [anon_sym_BANG_EQ] = ACTIONS(3354),
    [anon_sym_LT_EQ] = ACTIONS(3354),
    [anon_sym_GT_EQ] = ACTIONS(3354),
    [anon_sym_LBRACK] = ACTIONS(3354),
    [anon_sym_RBRACK] = ACTIONS(3354),
    [anon_sym_struct] = ACTIONS(3356),
    [anon_sym_mut] = ACTIONS(3356),
    [anon_sym_COLON] = ACTIONS(3354),
    [anon_sym_PLUS_PLUS] = ACTIONS(3354),
    [anon_sym_DASH_DASH] = ACTIONS(3354),
    [anon_sym_QMARK] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3356),
    [anon_sym_go] = ACTIONS(3356),
    [anon_sym_spawn] = ACTIONS(3356),
    [anon_sym_json_DOTdecode] = ACTIONS(3354),
    [anon_sym_PIPE] = ACTIONS(3356),
    [anon_sym_LBRACK2] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3354),
    [anon_sym_CARET] = ACTIONS(3354),
    [anon_sym_AMP] = ACTIONS(3356),
    [anon_sym_LT_DASH] = ACTIONS(3354),
    [anon_sym_LT_LT] = ACTIONS(3354),
    [anon_sym_GT_GT] = ACTIONS(3356),
    [anon_sym_GT_GT_GT] = ACTIONS(3354),
    [anon_sym_AMP_CARET] = ACTIONS(3354),
    [anon_sym_AMP_AMP] = ACTIONS(3354),
    [anon_sym_PIPE_PIPE] = ACTIONS(3354),
    [anon_sym_or] = ACTIONS(3356),
    [sym_none] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_nil] = ACTIONS(3356),
    [anon_sym_QMARK_DOT] = ACTIONS(3354),
    [anon_sym_POUND_LBRACK] = ACTIONS(3354),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_DOLLARif] = ACTIONS(3356),
    [anon_sym_is] = ACTIONS(3356),
    [anon_sym_BANGis] = ACTIONS(3354),
    [anon_sym_in] = ACTIONS(3356),
    [anon_sym_BANGin] = ACTIONS(3354),
    [anon_sym_match] = ACTIONS(3356),
    [anon_sym_select] = ACTIONS(3356),
    [anon_sym_lock] = ACTIONS(3356),
    [anon_sym_rlock] = ACTIONS(3356),
    [anon_sym_unsafe] = ACTIONS(3356),
    [anon_sym_sql] = ACTIONS(3356),
    [sym_int_literal] = ACTIONS(3356),
    [sym_float_literal] = ACTIONS(3354),
    [sym_rune_literal] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_c_SQUOTE] = ACTIONS(3354),
    [anon_sym_c_DQUOTE] = ACTIONS(3354),
    [anon_sym_r_SQUOTE] = ACTIONS(3354),
    [anon_sym_r_DQUOTE] = ACTIONS(3354),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3356),
    [anon_sym_shared] = ACTIONS(3356),
    [anon_sym_map_LBRACK] = ACTIONS(3354),
    [anon_sym_chan] = ACTIONS(3356),
    [anon_sym_thread] = ACTIONS(3356),
    [anon_sym_atomic] = ACTIONS(3356),
  },
  [1662] = {
    [sym_line_comment] = STATE(1662),
    [sym_block_comment] = STATE(1662),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2873),
    [anon_sym_as] = ACTIONS(2873),
    [anon_sym_LBRACE] = ACTIONS(2871),
    [anon_sym_COMMA] = ACTIONS(2871),
    [anon_sym_RBRACE] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2871),
    [anon_sym_fn] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2873),
    [anon_sym_STAR] = ACTIONS(2871),
    [anon_sym_SLASH] = ACTIONS(2873),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [anon_sym_LT] = ACTIONS(2873),
    [anon_sym_GT] = ACTIONS(2873),
    [anon_sym_EQ_EQ] = ACTIONS(2871),
    [anon_sym_BANG_EQ] = ACTIONS(2871),
    [anon_sym_LT_EQ] = ACTIONS(2871),
    [anon_sym_GT_EQ] = ACTIONS(2871),
    [anon_sym_LBRACK] = ACTIONS(2871),
    [anon_sym_RBRACK] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2873),
    [anon_sym_mut] = ACTIONS(2873),
    [anon_sym_COLON] = ACTIONS(2871),
    [anon_sym_PLUS_PLUS] = ACTIONS(2871),
    [anon_sym_DASH_DASH] = ACTIONS(2871),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_BANG] = ACTIONS(2873),
    [anon_sym_go] = ACTIONS(2873),
    [anon_sym_spawn] = ACTIONS(2873),
    [anon_sym_json_DOTdecode] = ACTIONS(2871),
    [anon_sym_PIPE] = ACTIONS(2873),
    [anon_sym_LBRACK2] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2871),
    [anon_sym_CARET] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LT_DASH] = ACTIONS(2871),
    [anon_sym_LT_LT] = ACTIONS(2871),
    [anon_sym_GT_GT] = ACTIONS(2873),
    [anon_sym_GT_GT_GT] = ACTIONS(2871),
    [anon_sym_AMP_CARET] = ACTIONS(2871),
    [anon_sym_AMP_AMP] = ACTIONS(2871),
    [anon_sym_PIPE_PIPE] = ACTIONS(2871),
    [anon_sym_or] = ACTIONS(2873),
    [sym_none] = ACTIONS(2873),
    [sym_true] = ACTIONS(2873),
    [sym_false] = ACTIONS(2873),
    [sym_nil] = ACTIONS(2873),
    [anon_sym_QMARK_DOT] = ACTIONS(2871),
    [anon_sym_POUND_LBRACK] = ACTIONS(2871),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_DOLLARif] = ACTIONS(2873),
    [anon_sym_is] = ACTIONS(2873),
    [anon_sym_BANGis] = ACTIONS(2871),
    [anon_sym_in] = ACTIONS(2873),
    [anon_sym_BANGin] = ACTIONS(2871),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_select] = ACTIONS(2873),
    [anon_sym_lock] = ACTIONS(2873),
    [anon_sym_rlock] = ACTIONS(2873),
    [anon_sym_unsafe] = ACTIONS(2873),
    [anon_sym_sql] = ACTIONS(2873),
    [sym_int_literal] = ACTIONS(2873),
    [sym_float_literal] = ACTIONS(2871),
    [sym_rune_literal] = ACTIONS(2871),
    [anon_sym_SQUOTE] = ACTIONS(2871),
    [anon_sym_DQUOTE] = ACTIONS(2871),
    [anon_sym_c_SQUOTE] = ACTIONS(2871),
    [anon_sym_c_DQUOTE] = ACTIONS(2871),
    [anon_sym_r_SQUOTE] = ACTIONS(2871),
    [anon_sym_r_DQUOTE] = ACTIONS(2871),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2873),
    [anon_sym_shared] = ACTIONS(2873),
    [anon_sym_map_LBRACK] = ACTIONS(2871),
    [anon_sym_chan] = ACTIONS(2873),
    [anon_sym_thread] = ACTIONS(2873),
    [anon_sym_atomic] = ACTIONS(2873),
  },
  [1663] = {
    [sym_line_comment] = STATE(1663),
    [sym_block_comment] = STATE(1663),
    [sym_identifier] = ACTIONS(2967),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2967),
    [anon_sym_as] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2965),
    [anon_sym_COMMA] = ACTIONS(2965),
    [anon_sym_RBRACE] = ACTIONS(2965),
    [anon_sym_LPAREN] = ACTIONS(2965),
    [anon_sym_fn] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2965),
    [anon_sym_SLASH] = ACTIONS(2967),
    [anon_sym_PERCENT] = ACTIONS(2965),
    [anon_sym_LT] = ACTIONS(2967),
    [anon_sym_GT] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2965),
    [anon_sym_BANG_EQ] = ACTIONS(2965),
    [anon_sym_LT_EQ] = ACTIONS(2965),
    [anon_sym_GT_EQ] = ACTIONS(2965),
    [anon_sym_LBRACK] = ACTIONS(2965),
    [anon_sym_RBRACK] = ACTIONS(2965),
    [anon_sym_struct] = ACTIONS(2967),
    [anon_sym_mut] = ACTIONS(2967),
    [anon_sym_COLON] = ACTIONS(2965),
    [anon_sym_PLUS_PLUS] = ACTIONS(2965),
    [anon_sym_DASH_DASH] = ACTIONS(2965),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_BANG] = ACTIONS(2967),
    [anon_sym_go] = ACTIONS(2967),
    [anon_sym_spawn] = ACTIONS(2967),
    [anon_sym_json_DOTdecode] = ACTIONS(2965),
    [anon_sym_PIPE] = ACTIONS(2967),
    [anon_sym_LBRACK2] = ACTIONS(2967),
    [anon_sym_TILDE] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2965),
    [anon_sym_AMP] = ACTIONS(2967),
    [anon_sym_LT_DASH] = ACTIONS(2965),
    [anon_sym_LT_LT] = ACTIONS(2965),
    [anon_sym_GT_GT] = ACTIONS(2967),
    [anon_sym_GT_GT_GT] = ACTIONS(2965),
    [anon_sym_AMP_CARET] = ACTIONS(2965),
    [anon_sym_AMP_AMP] = ACTIONS(2965),
    [anon_sym_PIPE_PIPE] = ACTIONS(2965),
    [anon_sym_or] = ACTIONS(2967),
    [sym_none] = ACTIONS(2967),
    [sym_true] = ACTIONS(2967),
    [sym_false] = ACTIONS(2967),
    [sym_nil] = ACTIONS(2967),
    [anon_sym_QMARK_DOT] = ACTIONS(2965),
    [anon_sym_POUND_LBRACK] = ACTIONS(2965),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_DOLLARif] = ACTIONS(2967),
    [anon_sym_is] = ACTIONS(2967),
    [anon_sym_BANGis] = ACTIONS(2965),
    [anon_sym_in] = ACTIONS(2967),
    [anon_sym_BANGin] = ACTIONS(2965),
    [anon_sym_match] = ACTIONS(2967),
    [anon_sym_select] = ACTIONS(2967),
    [anon_sym_lock] = ACTIONS(2967),
    [anon_sym_rlock] = ACTIONS(2967),
    [anon_sym_unsafe] = ACTIONS(2967),
    [anon_sym_sql] = ACTIONS(2967),
    [sym_int_literal] = ACTIONS(2967),
    [sym_float_literal] = ACTIONS(2965),
    [sym_rune_literal] = ACTIONS(2965),
    [anon_sym_SQUOTE] = ACTIONS(2965),
    [anon_sym_DQUOTE] = ACTIONS(2965),
    [anon_sym_c_SQUOTE] = ACTIONS(2965),
    [anon_sym_c_DQUOTE] = ACTIONS(2965),
    [anon_sym_r_SQUOTE] = ACTIONS(2965),
    [anon_sym_r_DQUOTE] = ACTIONS(2965),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2967),
    [anon_sym_shared] = ACTIONS(2967),
    [anon_sym_map_LBRACK] = ACTIONS(2965),
    [anon_sym_chan] = ACTIONS(2967),
    [anon_sym_thread] = ACTIONS(2967),
    [anon_sym_atomic] = ACTIONS(2967),
  },
  [1664] = {
    [sym_line_comment] = STATE(1664),
    [sym_block_comment] = STATE(1664),
    [sym_identifier] = ACTIONS(3240),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3240),
    [anon_sym_as] = ACTIONS(3240),
    [anon_sym_LBRACE] = ACTIONS(3238),
    [anon_sym_COMMA] = ACTIONS(3238),
    [anon_sym_RBRACE] = ACTIONS(3238),
    [anon_sym_LPAREN] = ACTIONS(3238),
    [anon_sym_fn] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3240),
    [anon_sym_STAR] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3238),
    [anon_sym_LT] = ACTIONS(3240),
    [anon_sym_GT] = ACTIONS(3240),
    [anon_sym_EQ_EQ] = ACTIONS(3238),
    [anon_sym_BANG_EQ] = ACTIONS(3238),
    [anon_sym_LT_EQ] = ACTIONS(3238),
    [anon_sym_GT_EQ] = ACTIONS(3238),
    [anon_sym_LBRACK] = ACTIONS(3238),
    [anon_sym_RBRACK] = ACTIONS(3238),
    [anon_sym_struct] = ACTIONS(3240),
    [anon_sym_mut] = ACTIONS(3240),
    [anon_sym_COLON] = ACTIONS(3238),
    [anon_sym_PLUS_PLUS] = ACTIONS(3238),
    [anon_sym_DASH_DASH] = ACTIONS(3238),
    [anon_sym_QMARK] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_go] = ACTIONS(3240),
    [anon_sym_spawn] = ACTIONS(3240),
    [anon_sym_json_DOTdecode] = ACTIONS(3238),
    [anon_sym_PIPE] = ACTIONS(3240),
    [anon_sym_LBRACK2] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3238),
    [anon_sym_CARET] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_LT_DASH] = ACTIONS(3238),
    [anon_sym_LT_LT] = ACTIONS(3238),
    [anon_sym_GT_GT] = ACTIONS(3240),
    [anon_sym_GT_GT_GT] = ACTIONS(3238),
    [anon_sym_AMP_CARET] = ACTIONS(3238),
    [anon_sym_AMP_AMP] = ACTIONS(3238),
    [anon_sym_PIPE_PIPE] = ACTIONS(3238),
    [anon_sym_or] = ACTIONS(3240),
    [sym_none] = ACTIONS(3240),
    [sym_true] = ACTIONS(3240),
    [sym_false] = ACTIONS(3240),
    [sym_nil] = ACTIONS(3240),
    [anon_sym_QMARK_DOT] = ACTIONS(3238),
    [anon_sym_POUND_LBRACK] = ACTIONS(3238),
    [anon_sym_if] = ACTIONS(3240),
    [anon_sym_DOLLARif] = ACTIONS(3240),
    [anon_sym_is] = ACTIONS(3240),
    [anon_sym_BANGis] = ACTIONS(3238),
    [anon_sym_in] = ACTIONS(3240),
    [anon_sym_BANGin] = ACTIONS(3238),
    [anon_sym_match] = ACTIONS(3240),
    [anon_sym_select] = ACTIONS(3240),
    [anon_sym_lock] = ACTIONS(3240),
    [anon_sym_rlock] = ACTIONS(3240),
    [anon_sym_unsafe] = ACTIONS(3240),
    [anon_sym_sql] = ACTIONS(3240),
    [sym_int_literal] = ACTIONS(3240),
    [sym_float_literal] = ACTIONS(3238),
    [sym_rune_literal] = ACTIONS(3238),
    [anon_sym_SQUOTE] = ACTIONS(3238),
    [anon_sym_DQUOTE] = ACTIONS(3238),
    [anon_sym_c_SQUOTE] = ACTIONS(3238),
    [anon_sym_c_DQUOTE] = ACTIONS(3238),
    [anon_sym_r_SQUOTE] = ACTIONS(3238),
    [anon_sym_r_DQUOTE] = ACTIONS(3238),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3240),
    [anon_sym_shared] = ACTIONS(3240),
    [anon_sym_map_LBRACK] = ACTIONS(3238),
    [anon_sym_chan] = ACTIONS(3240),
    [anon_sym_thread] = ACTIONS(3240),
    [anon_sym_atomic] = ACTIONS(3240),
  },
  [1665] = {
    [sym_line_comment] = STATE(1665),
    [sym_block_comment] = STATE(1665),
    [sym_identifier] = ACTIONS(2697),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2697),
    [anon_sym_as] = ACTIONS(2697),
    [anon_sym_LBRACE] = ACTIONS(2695),
    [anon_sym_COMMA] = ACTIONS(2695),
    [anon_sym_RBRACE] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(2695),
    [anon_sym_fn] = ACTIONS(2697),
    [anon_sym_PLUS] = ACTIONS(2697),
    [anon_sym_DASH] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2695),
    [anon_sym_SLASH] = ACTIONS(2697),
    [anon_sym_PERCENT] = ACTIONS(2695),
    [anon_sym_LT] = ACTIONS(2697),
    [anon_sym_GT] = ACTIONS(2697),
    [anon_sym_EQ_EQ] = ACTIONS(2695),
    [anon_sym_BANG_EQ] = ACTIONS(2695),
    [anon_sym_LT_EQ] = ACTIONS(2695),
    [anon_sym_GT_EQ] = ACTIONS(2695),
    [anon_sym_LBRACK] = ACTIONS(2695),
    [anon_sym_RBRACK] = ACTIONS(2695),
    [anon_sym_struct] = ACTIONS(2697),
    [anon_sym_mut] = ACTIONS(2697),
    [anon_sym_COLON] = ACTIONS(2695),
    [anon_sym_PLUS_PLUS] = ACTIONS(2695),
    [anon_sym_DASH_DASH] = ACTIONS(2695),
    [anon_sym_QMARK] = ACTIONS(2697),
    [anon_sym_BANG] = ACTIONS(4313),
    [anon_sym_go] = ACTIONS(2697),
    [anon_sym_spawn] = ACTIONS(2697),
    [anon_sym_json_DOTdecode] = ACTIONS(2695),
    [anon_sym_PIPE] = ACTIONS(2697),
    [anon_sym_LBRACK2] = ACTIONS(2697),
    [anon_sym_TILDE] = ACTIONS(2695),
    [anon_sym_CARET] = ACTIONS(2695),
    [anon_sym_AMP] = ACTIONS(2697),
    [anon_sym_LT_DASH] = ACTIONS(2695),
    [anon_sym_LT_LT] = ACTIONS(2695),
    [anon_sym_GT_GT] = ACTIONS(2697),
    [anon_sym_GT_GT_GT] = ACTIONS(2695),
    [anon_sym_AMP_CARET] = ACTIONS(2695),
    [anon_sym_AMP_AMP] = ACTIONS(2695),
    [anon_sym_PIPE_PIPE] = ACTIONS(2695),
    [anon_sym_or] = ACTIONS(2697),
    [sym_none] = ACTIONS(2697),
    [sym_true] = ACTIONS(2697),
    [sym_false] = ACTIONS(2697),
    [sym_nil] = ACTIONS(2697),
    [anon_sym_QMARK_DOT] = ACTIONS(2695),
    [anon_sym_POUND_LBRACK] = ACTIONS(2695),
    [anon_sym_if] = ACTIONS(2697),
    [anon_sym_DOLLARif] = ACTIONS(2697),
    [anon_sym_is] = ACTIONS(2697),
    [anon_sym_BANGis] = ACTIONS(2695),
    [anon_sym_in] = ACTIONS(2697),
    [anon_sym_BANGin] = ACTIONS(2695),
    [anon_sym_match] = ACTIONS(2697),
    [anon_sym_select] = ACTIONS(2697),
    [anon_sym_lock] = ACTIONS(2697),
    [anon_sym_rlock] = ACTIONS(2697),
    [anon_sym_unsafe] = ACTIONS(2697),
    [anon_sym_sql] = ACTIONS(2697),
    [sym_int_literal] = ACTIONS(2697),
    [sym_float_literal] = ACTIONS(2695),
    [sym_rune_literal] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(2695),
    [anon_sym_DQUOTE] = ACTIONS(2695),
    [anon_sym_c_SQUOTE] = ACTIONS(2695),
    [anon_sym_c_DQUOTE] = ACTIONS(2695),
    [anon_sym_r_SQUOTE] = ACTIONS(2695),
    [anon_sym_r_DQUOTE] = ACTIONS(2695),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2697),
    [anon_sym_shared] = ACTIONS(2697),
    [anon_sym_map_LBRACK] = ACTIONS(2695),
    [anon_sym_chan] = ACTIONS(2697),
    [anon_sym_thread] = ACTIONS(2697),
    [anon_sym_atomic] = ACTIONS(2697),
  },
  [1666] = {
    [sym_line_comment] = STATE(1666),
    [sym_block_comment] = STATE(1666),
    [sym_identifier] = ACTIONS(2429),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2429),
    [anon_sym_as] = ACTIONS(2429),
    [anon_sym_LBRACE] = ACTIONS(2427),
    [anon_sym_COMMA] = ACTIONS(2427),
    [anon_sym_RBRACE] = ACTIONS(2427),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_fn] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(2429),
    [anon_sym_DASH] = ACTIONS(2429),
    [anon_sym_STAR] = ACTIONS(2427),
    [anon_sym_SLASH] = ACTIONS(2429),
    [anon_sym_PERCENT] = ACTIONS(2427),
    [anon_sym_LT] = ACTIONS(2429),
    [anon_sym_GT] = ACTIONS(2429),
    [anon_sym_EQ_EQ] = ACTIONS(2427),
    [anon_sym_BANG_EQ] = ACTIONS(2427),
    [anon_sym_LT_EQ] = ACTIONS(2427),
    [anon_sym_GT_EQ] = ACTIONS(2427),
    [anon_sym_LBRACK] = ACTIONS(2427),
    [anon_sym_RBRACK] = ACTIONS(2427),
    [anon_sym_struct] = ACTIONS(2429),
    [anon_sym_mut] = ACTIONS(2429),
    [anon_sym_COLON] = ACTIONS(2427),
    [anon_sym_PLUS_PLUS] = ACTIONS(2427),
    [anon_sym_DASH_DASH] = ACTIONS(2427),
    [anon_sym_QMARK] = ACTIONS(2429),
    [anon_sym_BANG] = ACTIONS(2429),
    [anon_sym_go] = ACTIONS(2429),
    [anon_sym_spawn] = ACTIONS(2429),
    [anon_sym_json_DOTdecode] = ACTIONS(2427),
    [anon_sym_PIPE] = ACTIONS(2429),
    [anon_sym_LBRACK2] = ACTIONS(2429),
    [anon_sym_TILDE] = ACTIONS(2427),
    [anon_sym_CARET] = ACTIONS(2427),
    [anon_sym_AMP] = ACTIONS(2429),
    [anon_sym_LT_DASH] = ACTIONS(2427),
    [anon_sym_LT_LT] = ACTIONS(2427),
    [anon_sym_GT_GT] = ACTIONS(2429),
    [anon_sym_GT_GT_GT] = ACTIONS(2427),
    [anon_sym_AMP_CARET] = ACTIONS(2427),
    [anon_sym_AMP_AMP] = ACTIONS(2427),
    [anon_sym_PIPE_PIPE] = ACTIONS(2427),
    [anon_sym_or] = ACTIONS(2429),
    [sym_none] = ACTIONS(2429),
    [sym_true] = ACTIONS(2429),
    [sym_false] = ACTIONS(2429),
    [sym_nil] = ACTIONS(2429),
    [anon_sym_QMARK_DOT] = ACTIONS(2427),
    [anon_sym_POUND_LBRACK] = ACTIONS(2427),
    [anon_sym_if] = ACTIONS(2429),
    [anon_sym_DOLLARif] = ACTIONS(2429),
    [anon_sym_is] = ACTIONS(2429),
    [anon_sym_BANGis] = ACTIONS(2427),
    [anon_sym_in] = ACTIONS(2429),
    [anon_sym_BANGin] = ACTIONS(2427),
    [anon_sym_match] = ACTIONS(2429),
    [anon_sym_select] = ACTIONS(2429),
    [anon_sym_lock] = ACTIONS(2429),
    [anon_sym_rlock] = ACTIONS(2429),
    [anon_sym_unsafe] = ACTIONS(2429),
    [anon_sym_sql] = ACTIONS(2429),
    [sym_int_literal] = ACTIONS(2429),
    [sym_float_literal] = ACTIONS(2427),
    [sym_rune_literal] = ACTIONS(2427),
    [anon_sym_SQUOTE] = ACTIONS(2427),
    [anon_sym_DQUOTE] = ACTIONS(2427),
    [anon_sym_c_SQUOTE] = ACTIONS(2427),
    [anon_sym_c_DQUOTE] = ACTIONS(2427),
    [anon_sym_r_SQUOTE] = ACTIONS(2427),
    [anon_sym_r_DQUOTE] = ACTIONS(2427),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2429),
    [anon_sym_shared] = ACTIONS(2429),
    [anon_sym_map_LBRACK] = ACTIONS(2427),
    [anon_sym_chan] = ACTIONS(2429),
    [anon_sym_thread] = ACTIONS(2429),
    [anon_sym_atomic] = ACTIONS(2429),
  },
  [1667] = {
    [sym_line_comment] = STATE(1667),
    [sym_block_comment] = STATE(1667),
    [sym_identifier] = ACTIONS(3023),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3023),
    [anon_sym_as] = ACTIONS(3023),
    [anon_sym_LBRACE] = ACTIONS(3021),
    [anon_sym_COMMA] = ACTIONS(3021),
    [anon_sym_RBRACE] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3021),
    [anon_sym_fn] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_STAR] = ACTIONS(3021),
    [anon_sym_SLASH] = ACTIONS(3023),
    [anon_sym_PERCENT] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3023),
    [anon_sym_GT] = ACTIONS(3023),
    [anon_sym_EQ_EQ] = ACTIONS(3021),
    [anon_sym_BANG_EQ] = ACTIONS(3021),
    [anon_sym_LT_EQ] = ACTIONS(3021),
    [anon_sym_GT_EQ] = ACTIONS(3021),
    [anon_sym_LBRACK] = ACTIONS(3021),
    [anon_sym_RBRACK] = ACTIONS(3021),
    [anon_sym_struct] = ACTIONS(3023),
    [anon_sym_mut] = ACTIONS(3023),
    [anon_sym_COLON] = ACTIONS(3021),
    [anon_sym_PLUS_PLUS] = ACTIONS(3021),
    [anon_sym_DASH_DASH] = ACTIONS(3021),
    [anon_sym_QMARK] = ACTIONS(3023),
    [anon_sym_BANG] = ACTIONS(3023),
    [anon_sym_go] = ACTIONS(3023),
    [anon_sym_spawn] = ACTIONS(3023),
    [anon_sym_json_DOTdecode] = ACTIONS(3021),
    [anon_sym_PIPE] = ACTIONS(3023),
    [anon_sym_LBRACK2] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3021),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_LT_DASH] = ACTIONS(3021),
    [anon_sym_LT_LT] = ACTIONS(3021),
    [anon_sym_GT_GT] = ACTIONS(3023),
    [anon_sym_GT_GT_GT] = ACTIONS(3021),
    [anon_sym_AMP_CARET] = ACTIONS(3021),
    [anon_sym_AMP_AMP] = ACTIONS(3021),
    [anon_sym_PIPE_PIPE] = ACTIONS(3021),
    [anon_sym_or] = ACTIONS(3023),
    [sym_none] = ACTIONS(3023),
    [sym_true] = ACTIONS(3023),
    [sym_false] = ACTIONS(3023),
    [sym_nil] = ACTIONS(3023),
    [anon_sym_QMARK_DOT] = ACTIONS(3021),
    [anon_sym_POUND_LBRACK] = ACTIONS(3021),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_DOLLARif] = ACTIONS(3023),
    [anon_sym_is] = ACTIONS(3023),
    [anon_sym_BANGis] = ACTIONS(3021),
    [anon_sym_in] = ACTIONS(3023),
    [anon_sym_BANGin] = ACTIONS(3021),
    [anon_sym_match] = ACTIONS(3023),
    [anon_sym_select] = ACTIONS(3023),
    [anon_sym_lock] = ACTIONS(3023),
    [anon_sym_rlock] = ACTIONS(3023),
    [anon_sym_unsafe] = ACTIONS(3023),
    [anon_sym_sql] = ACTIONS(3023),
    [sym_int_literal] = ACTIONS(3023),
    [sym_float_literal] = ACTIONS(3021),
    [sym_rune_literal] = ACTIONS(3021),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [anon_sym_DQUOTE] = ACTIONS(3021),
    [anon_sym_c_SQUOTE] = ACTIONS(3021),
    [anon_sym_c_DQUOTE] = ACTIONS(3021),
    [anon_sym_r_SQUOTE] = ACTIONS(3021),
    [anon_sym_r_DQUOTE] = ACTIONS(3021),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3023),
    [anon_sym_shared] = ACTIONS(3023),
    [anon_sym_map_LBRACK] = ACTIONS(3021),
    [anon_sym_chan] = ACTIONS(3023),
    [anon_sym_thread] = ACTIONS(3023),
    [anon_sym_atomic] = ACTIONS(3023),
  },
  [1668] = {
    [sym_line_comment] = STATE(1668),
    [sym_block_comment] = STATE(1668),
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3019),
    [anon_sym_as] = ACTIONS(3019),
    [anon_sym_LBRACE] = ACTIONS(3017),
    [anon_sym_COMMA] = ACTIONS(3017),
    [anon_sym_RBRACE] = ACTIONS(3017),
    [anon_sym_LPAREN] = ACTIONS(3017),
    [anon_sym_fn] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_STAR] = ACTIONS(3017),
    [anon_sym_SLASH] = ACTIONS(3019),
    [anon_sym_PERCENT] = ACTIONS(3017),
    [anon_sym_LT] = ACTIONS(3019),
    [anon_sym_GT] = ACTIONS(3019),
    [anon_sym_EQ_EQ] = ACTIONS(3017),
    [anon_sym_BANG_EQ] = ACTIONS(3017),
    [anon_sym_LT_EQ] = ACTIONS(3017),
    [anon_sym_GT_EQ] = ACTIONS(3017),
    [anon_sym_LBRACK] = ACTIONS(3017),
    [anon_sym_RBRACK] = ACTIONS(3017),
    [anon_sym_struct] = ACTIONS(3019),
    [anon_sym_mut] = ACTIONS(3019),
    [anon_sym_COLON] = ACTIONS(3017),
    [anon_sym_PLUS_PLUS] = ACTIONS(3017),
    [anon_sym_DASH_DASH] = ACTIONS(3017),
    [anon_sym_QMARK] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_go] = ACTIONS(3019),
    [anon_sym_spawn] = ACTIONS(3019),
    [anon_sym_json_DOTdecode] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_LBRACK2] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_CARET] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_LT_DASH] = ACTIONS(3017),
    [anon_sym_LT_LT] = ACTIONS(3017),
    [anon_sym_GT_GT] = ACTIONS(3019),
    [anon_sym_GT_GT_GT] = ACTIONS(3017),
    [anon_sym_AMP_CARET] = ACTIONS(3017),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE_PIPE] = ACTIONS(3017),
    [anon_sym_or] = ACTIONS(3019),
    [sym_none] = ACTIONS(3019),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_nil] = ACTIONS(3019),
    [anon_sym_QMARK_DOT] = ACTIONS(3017),
    [anon_sym_POUND_LBRACK] = ACTIONS(3017),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_DOLLARif] = ACTIONS(3019),
    [anon_sym_is] = ACTIONS(3019),
    [anon_sym_BANGis] = ACTIONS(3017),
    [anon_sym_in] = ACTIONS(3019),
    [anon_sym_BANGin] = ACTIONS(3017),
    [anon_sym_match] = ACTIONS(3019),
    [anon_sym_select] = ACTIONS(3019),
    [anon_sym_lock] = ACTIONS(3019),
    [anon_sym_rlock] = ACTIONS(3019),
    [anon_sym_unsafe] = ACTIONS(3019),
    [anon_sym_sql] = ACTIONS(3019),
    [sym_int_literal] = ACTIONS(3019),
    [sym_float_literal] = ACTIONS(3017),
    [sym_rune_literal] = ACTIONS(3017),
    [anon_sym_SQUOTE] = ACTIONS(3017),
    [anon_sym_DQUOTE] = ACTIONS(3017),
    [anon_sym_c_SQUOTE] = ACTIONS(3017),
    [anon_sym_c_DQUOTE] = ACTIONS(3017),
    [anon_sym_r_SQUOTE] = ACTIONS(3017),
    [anon_sym_r_DQUOTE] = ACTIONS(3017),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3019),
    [anon_sym_shared] = ACTIONS(3019),
    [anon_sym_map_LBRACK] = ACTIONS(3017),
    [anon_sym_chan] = ACTIONS(3019),
    [anon_sym_thread] = ACTIONS(3019),
    [anon_sym_atomic] = ACTIONS(3019),
  },
  [1669] = {
    [sym_line_comment] = STATE(1669),
    [sym_block_comment] = STATE(1669),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2841),
    [anon_sym_as] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2839),
    [anon_sym_COMMA] = ACTIONS(2839),
    [anon_sym_RBRACE] = ACTIONS(2839),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_fn] = ACTIONS(2841),
    [anon_sym_PLUS] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(2841),
    [anon_sym_PERCENT] = ACTIONS(2839),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_GT] = ACTIONS(2841),
    [anon_sym_EQ_EQ] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2839),
    [anon_sym_LT_EQ] = ACTIONS(2839),
    [anon_sym_GT_EQ] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_RBRACK] = ACTIONS(2839),
    [anon_sym_struct] = ACTIONS(2841),
    [anon_sym_mut] = ACTIONS(2841),
    [anon_sym_COLON] = ACTIONS(2839),
    [anon_sym_PLUS_PLUS] = ACTIONS(2839),
    [anon_sym_DASH_DASH] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(2841),
    [anon_sym_BANG] = ACTIONS(2841),
    [anon_sym_go] = ACTIONS(2841),
    [anon_sym_spawn] = ACTIONS(2841),
    [anon_sym_json_DOTdecode] = ACTIONS(2839),
    [anon_sym_PIPE] = ACTIONS(2841),
    [anon_sym_LBRACK2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_CARET] = ACTIONS(2839),
    [anon_sym_AMP] = ACTIONS(2841),
    [anon_sym_LT_DASH] = ACTIONS(2839),
    [anon_sym_LT_LT] = ACTIONS(2839),
    [anon_sym_GT_GT] = ACTIONS(2841),
    [anon_sym_GT_GT_GT] = ACTIONS(2839),
    [anon_sym_AMP_CARET] = ACTIONS(2839),
    [anon_sym_AMP_AMP] = ACTIONS(2839),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_or] = ACTIONS(2841),
    [sym_none] = ACTIONS(2841),
    [sym_true] = ACTIONS(2841),
    [sym_false] = ACTIONS(2841),
    [sym_nil] = ACTIONS(2841),
    [anon_sym_QMARK_DOT] = ACTIONS(2839),
    [anon_sym_POUND_LBRACK] = ACTIONS(2839),
    [anon_sym_if] = ACTIONS(2841),
    [anon_sym_DOLLARif] = ACTIONS(2841),
    [anon_sym_is] = ACTIONS(2841),
    [anon_sym_BANGis] = ACTIONS(2839),
    [anon_sym_in] = ACTIONS(2841),
    [anon_sym_BANGin] = ACTIONS(2839),
    [anon_sym_match] = ACTIONS(2841),
    [anon_sym_select] = ACTIONS(2841),
    [anon_sym_lock] = ACTIONS(2841),
    [anon_sym_rlock] = ACTIONS(2841),
    [anon_sym_unsafe] = ACTIONS(2841),
    [anon_sym_sql] = ACTIONS(2841),
    [sym_int_literal] = ACTIONS(2841),
    [sym_float_literal] = ACTIONS(2839),
    [sym_rune_literal] = ACTIONS(2839),
    [anon_sym_SQUOTE] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_c_SQUOTE] = ACTIONS(2839),
    [anon_sym_c_DQUOTE] = ACTIONS(2839),
    [anon_sym_r_SQUOTE] = ACTIONS(2839),
    [anon_sym_r_DQUOTE] = ACTIONS(2839),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2841),
    [anon_sym_shared] = ACTIONS(2841),
    [anon_sym_map_LBRACK] = ACTIONS(2839),
    [anon_sym_chan] = ACTIONS(2841),
    [anon_sym_thread] = ACTIONS(2841),
    [anon_sym_atomic] = ACTIONS(2841),
  },
  [1670] = {
    [sym_line_comment] = STATE(1670),
    [sym_block_comment] = STATE(1670),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3015),
    [anon_sym_as] = ACTIONS(3015),
    [anon_sym_LBRACE] = ACTIONS(3013),
    [anon_sym_COMMA] = ACTIONS(3013),
    [anon_sym_RBRACE] = ACTIONS(3013),
    [anon_sym_LPAREN] = ACTIONS(3013),
    [anon_sym_fn] = ACTIONS(3015),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(3013),
    [anon_sym_SLASH] = ACTIONS(3015),
    [anon_sym_PERCENT] = ACTIONS(3013),
    [anon_sym_LT] = ACTIONS(3015),
    [anon_sym_GT] = ACTIONS(3015),
    [anon_sym_EQ_EQ] = ACTIONS(3013),
    [anon_sym_BANG_EQ] = ACTIONS(3013),
    [anon_sym_LT_EQ] = ACTIONS(3013),
    [anon_sym_GT_EQ] = ACTIONS(3013),
    [anon_sym_LBRACK] = ACTIONS(3013),
    [anon_sym_RBRACK] = ACTIONS(3013),
    [anon_sym_struct] = ACTIONS(3015),
    [anon_sym_mut] = ACTIONS(3015),
    [anon_sym_COLON] = ACTIONS(3013),
    [anon_sym_PLUS_PLUS] = ACTIONS(3013),
    [anon_sym_DASH_DASH] = ACTIONS(3013),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_BANG] = ACTIONS(3015),
    [anon_sym_go] = ACTIONS(3015),
    [anon_sym_spawn] = ACTIONS(3015),
    [anon_sym_json_DOTdecode] = ACTIONS(3013),
    [anon_sym_PIPE] = ACTIONS(3015),
    [anon_sym_LBRACK2] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3013),
    [anon_sym_CARET] = ACTIONS(3013),
    [anon_sym_AMP] = ACTIONS(3015),
    [anon_sym_LT_DASH] = ACTIONS(3013),
    [anon_sym_LT_LT] = ACTIONS(3013),
    [anon_sym_GT_GT] = ACTIONS(3015),
    [anon_sym_GT_GT_GT] = ACTIONS(3013),
    [anon_sym_AMP_CARET] = ACTIONS(3013),
    [anon_sym_AMP_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3013),
    [anon_sym_or] = ACTIONS(3015),
    [sym_none] = ACTIONS(3015),
    [sym_true] = ACTIONS(3015),
    [sym_false] = ACTIONS(3015),
    [sym_nil] = ACTIONS(3015),
    [anon_sym_QMARK_DOT] = ACTIONS(3013),
    [anon_sym_POUND_LBRACK] = ACTIONS(3013),
    [anon_sym_if] = ACTIONS(3015),
    [anon_sym_DOLLARif] = ACTIONS(3015),
    [anon_sym_is] = ACTIONS(3015),
    [anon_sym_BANGis] = ACTIONS(3013),
    [anon_sym_in] = ACTIONS(3015),
    [anon_sym_BANGin] = ACTIONS(3013),
    [anon_sym_match] = ACTIONS(3015),
    [anon_sym_select] = ACTIONS(3015),
    [anon_sym_lock] = ACTIONS(3015),
    [anon_sym_rlock] = ACTIONS(3015),
    [anon_sym_unsafe] = ACTIONS(3015),
    [anon_sym_sql] = ACTIONS(3015),
    [sym_int_literal] = ACTIONS(3015),
    [sym_float_literal] = ACTIONS(3013),
    [sym_rune_literal] = ACTIONS(3013),
    [anon_sym_SQUOTE] = ACTIONS(3013),
    [anon_sym_DQUOTE] = ACTIONS(3013),
    [anon_sym_c_SQUOTE] = ACTIONS(3013),
    [anon_sym_c_DQUOTE] = ACTIONS(3013),
    [anon_sym_r_SQUOTE] = ACTIONS(3013),
    [anon_sym_r_DQUOTE] = ACTIONS(3013),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3015),
    [anon_sym_shared] = ACTIONS(3015),
    [anon_sym_map_LBRACK] = ACTIONS(3013),
    [anon_sym_chan] = ACTIONS(3015),
    [anon_sym_thread] = ACTIONS(3015),
    [anon_sym_atomic] = ACTIONS(3015),
  },
  [1671] = {
    [sym_line_comment] = STATE(1671),
    [sym_block_comment] = STATE(1671),
    [sym_identifier] = ACTIONS(3246),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3246),
    [anon_sym_as] = ACTIONS(3246),
    [anon_sym_LBRACE] = ACTIONS(3244),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_RBRACE] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3244),
    [anon_sym_fn] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3246),
    [anon_sym_DASH] = ACTIONS(3246),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_SLASH] = ACTIONS(3246),
    [anon_sym_PERCENT] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3246),
    [anon_sym_GT] = ACTIONS(3246),
    [anon_sym_EQ_EQ] = ACTIONS(3244),
    [anon_sym_BANG_EQ] = ACTIONS(3244),
    [anon_sym_LT_EQ] = ACTIONS(3244),
    [anon_sym_GT_EQ] = ACTIONS(3244),
    [anon_sym_LBRACK] = ACTIONS(3244),
    [anon_sym_RBRACK] = ACTIONS(3244),
    [anon_sym_struct] = ACTIONS(3246),
    [anon_sym_mut] = ACTIONS(3246),
    [anon_sym_COLON] = ACTIONS(3244),
    [anon_sym_PLUS_PLUS] = ACTIONS(3244),
    [anon_sym_DASH_DASH] = ACTIONS(3244),
    [anon_sym_QMARK] = ACTIONS(3246),
    [anon_sym_BANG] = ACTIONS(3246),
    [anon_sym_go] = ACTIONS(3246),
    [anon_sym_spawn] = ACTIONS(3246),
    [anon_sym_json_DOTdecode] = ACTIONS(3244),
    [anon_sym_PIPE] = ACTIONS(3246),
    [anon_sym_LBRACK2] = ACTIONS(3246),
    [anon_sym_TILDE] = ACTIONS(3244),
    [anon_sym_CARET] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3246),
    [anon_sym_LT_DASH] = ACTIONS(3244),
    [anon_sym_LT_LT] = ACTIONS(3244),
    [anon_sym_GT_GT] = ACTIONS(3246),
    [anon_sym_GT_GT_GT] = ACTIONS(3244),
    [anon_sym_AMP_CARET] = ACTIONS(3244),
    [anon_sym_AMP_AMP] = ACTIONS(3244),
    [anon_sym_PIPE_PIPE] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(3246),
    [sym_none] = ACTIONS(3246),
    [sym_true] = ACTIONS(3246),
    [sym_false] = ACTIONS(3246),
    [sym_nil] = ACTIONS(3246),
    [anon_sym_QMARK_DOT] = ACTIONS(3244),
    [anon_sym_POUND_LBRACK] = ACTIONS(3244),
    [anon_sym_if] = ACTIONS(3246),
    [anon_sym_DOLLARif] = ACTIONS(3246),
    [anon_sym_is] = ACTIONS(3246),
    [anon_sym_BANGis] = ACTIONS(3244),
    [anon_sym_in] = ACTIONS(3246),
    [anon_sym_BANGin] = ACTIONS(3244),
    [anon_sym_match] = ACTIONS(3246),
    [anon_sym_select] = ACTIONS(3246),
    [anon_sym_lock] = ACTIONS(3246),
    [anon_sym_rlock] = ACTIONS(3246),
    [anon_sym_unsafe] = ACTIONS(3246),
    [anon_sym_sql] = ACTIONS(3246),
    [sym_int_literal] = ACTIONS(3246),
    [sym_float_literal] = ACTIONS(3244),
    [sym_rune_literal] = ACTIONS(3244),
    [anon_sym_SQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE] = ACTIONS(3244),
    [anon_sym_c_SQUOTE] = ACTIONS(3244),
    [anon_sym_c_DQUOTE] = ACTIONS(3244),
    [anon_sym_r_SQUOTE] = ACTIONS(3244),
    [anon_sym_r_DQUOTE] = ACTIONS(3244),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3246),
    [anon_sym_shared] = ACTIONS(3246),
    [anon_sym_map_LBRACK] = ACTIONS(3244),
    [anon_sym_chan] = ACTIONS(3246),
    [anon_sym_thread] = ACTIONS(3246),
    [anon_sym_atomic] = ACTIONS(3246),
  },
  [1672] = {
    [sym_line_comment] = STATE(1672),
    [sym_block_comment] = STATE(1672),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2833),
    [anon_sym_as] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2831),
    [anon_sym_COMMA] = ACTIONS(2831),
    [anon_sym_RBRACE] = ACTIONS(2831),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_fn] = ACTIONS(2833),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(2831),
    [anon_sym_SLASH] = ACTIONS(2833),
    [anon_sym_PERCENT] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(2833),
    [anon_sym_EQ_EQ] = ACTIONS(2831),
    [anon_sym_BANG_EQ] = ACTIONS(2831),
    [anon_sym_LT_EQ] = ACTIONS(2831),
    [anon_sym_GT_EQ] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_RBRACK] = ACTIONS(2831),
    [anon_sym_struct] = ACTIONS(2833),
    [anon_sym_mut] = ACTIONS(2833),
    [anon_sym_COLON] = ACTIONS(2831),
    [anon_sym_PLUS_PLUS] = ACTIONS(2831),
    [anon_sym_DASH_DASH] = ACTIONS(2831),
    [anon_sym_QMARK] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_go] = ACTIONS(2833),
    [anon_sym_spawn] = ACTIONS(2833),
    [anon_sym_json_DOTdecode] = ACTIONS(2831),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_LBRACK2] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2831),
    [anon_sym_CARET] = ACTIONS(2831),
    [anon_sym_AMP] = ACTIONS(2833),
    [anon_sym_LT_DASH] = ACTIONS(2831),
    [anon_sym_LT_LT] = ACTIONS(2831),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_GT] = ACTIONS(2831),
    [anon_sym_AMP_CARET] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_or] = ACTIONS(2833),
    [sym_none] = ACTIONS(2833),
    [sym_true] = ACTIONS(2833),
    [sym_false] = ACTIONS(2833),
    [sym_nil] = ACTIONS(2833),
    [anon_sym_QMARK_DOT] = ACTIONS(2831),
    [anon_sym_POUND_LBRACK] = ACTIONS(2831),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_DOLLARif] = ACTIONS(2833),
    [anon_sym_is] = ACTIONS(2833),
    [anon_sym_BANGis] = ACTIONS(2831),
    [anon_sym_in] = ACTIONS(2833),
    [anon_sym_BANGin] = ACTIONS(2831),
    [anon_sym_match] = ACTIONS(2833),
    [anon_sym_select] = ACTIONS(2833),
    [anon_sym_lock] = ACTIONS(2833),
    [anon_sym_rlock] = ACTIONS(2833),
    [anon_sym_unsafe] = ACTIONS(2833),
    [anon_sym_sql] = ACTIONS(2833),
    [sym_int_literal] = ACTIONS(2833),
    [sym_float_literal] = ACTIONS(2831),
    [sym_rune_literal] = ACTIONS(2831),
    [anon_sym_SQUOTE] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2831),
    [anon_sym_c_SQUOTE] = ACTIONS(2831),
    [anon_sym_c_DQUOTE] = ACTIONS(2831),
    [anon_sym_r_SQUOTE] = ACTIONS(2831),
    [anon_sym_r_DQUOTE] = ACTIONS(2831),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2833),
    [anon_sym_shared] = ACTIONS(2833),
    [anon_sym_map_LBRACK] = ACTIONS(2831),
    [anon_sym_chan] = ACTIONS(2833),
    [anon_sym_thread] = ACTIONS(2833),
    [anon_sym_atomic] = ACTIONS(2833),
  },
  [1673] = {
    [sym_line_comment] = STATE(1673),
    [sym_block_comment] = STATE(1673),
    [sym_identifier] = ACTIONS(2829),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2829),
    [anon_sym_as] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_COMMA] = ACTIONS(2827),
    [anon_sym_RBRACE] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2827),
    [anon_sym_fn] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2829),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_LT] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2829),
    [anon_sym_EQ_EQ] = ACTIONS(2827),
    [anon_sym_BANG_EQ] = ACTIONS(2827),
    [anon_sym_LT_EQ] = ACTIONS(2827),
    [anon_sym_GT_EQ] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2827),
    [anon_sym_RBRACK] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_mut] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2827),
    [anon_sym_DASH_DASH] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2829),
    [anon_sym_BANG] = ACTIONS(2829),
    [anon_sym_go] = ACTIONS(2829),
    [anon_sym_spawn] = ACTIONS(2829),
    [anon_sym_json_DOTdecode] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2829),
    [anon_sym_LBRACK2] = ACTIONS(2829),
    [anon_sym_TILDE] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2829),
    [anon_sym_LT_DASH] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2829),
    [anon_sym_GT_GT_GT] = ACTIONS(2827),
    [anon_sym_AMP_CARET] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2827),
    [anon_sym_PIPE_PIPE] = ACTIONS(2827),
    [anon_sym_or] = ACTIONS(2829),
    [sym_none] = ACTIONS(2829),
    [sym_true] = ACTIONS(2829),
    [sym_false] = ACTIONS(2829),
    [sym_nil] = ACTIONS(2829),
    [anon_sym_QMARK_DOT] = ACTIONS(2827),
    [anon_sym_POUND_LBRACK] = ACTIONS(2827),
    [anon_sym_if] = ACTIONS(2829),
    [anon_sym_DOLLARif] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2829),
    [anon_sym_BANGis] = ACTIONS(2827),
    [anon_sym_in] = ACTIONS(2829),
    [anon_sym_BANGin] = ACTIONS(2827),
    [anon_sym_match] = ACTIONS(2829),
    [anon_sym_select] = ACTIONS(2829),
    [anon_sym_lock] = ACTIONS(2829),
    [anon_sym_rlock] = ACTIONS(2829),
    [anon_sym_unsafe] = ACTIONS(2829),
    [anon_sym_sql] = ACTIONS(2829),
    [sym_int_literal] = ACTIONS(2829),
    [sym_float_literal] = ACTIONS(2827),
    [sym_rune_literal] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(2827),
    [anon_sym_DQUOTE] = ACTIONS(2827),
    [anon_sym_c_SQUOTE] = ACTIONS(2827),
    [anon_sym_c_DQUOTE] = ACTIONS(2827),
    [anon_sym_r_SQUOTE] = ACTIONS(2827),
    [anon_sym_r_DQUOTE] = ACTIONS(2827),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2829),
    [anon_sym_shared] = ACTIONS(2829),
    [anon_sym_map_LBRACK] = ACTIONS(2827),
    [anon_sym_chan] = ACTIONS(2829),
    [anon_sym_thread] = ACTIONS(2829),
    [anon_sym_atomic] = ACTIONS(2829),
  },
  [1674] = {
    [sym_line_comment] = STATE(1674),
    [sym_block_comment] = STATE(1674),
    [sym_identifier] = ACTIONS(2823),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2823),
    [anon_sym_as] = ACTIONS(2823),
    [anon_sym_LBRACE] = ACTIONS(2821),
    [anon_sym_COMMA] = ACTIONS(2821),
    [anon_sym_RBRACE] = ACTIONS(2821),
    [anon_sym_LPAREN] = ACTIONS(2821),
    [anon_sym_fn] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2823),
    [anon_sym_DASH] = ACTIONS(2823),
    [anon_sym_STAR] = ACTIONS(2821),
    [anon_sym_SLASH] = ACTIONS(2823),
    [anon_sym_PERCENT] = ACTIONS(2821),
    [anon_sym_LT] = ACTIONS(2823),
    [anon_sym_GT] = ACTIONS(2823),
    [anon_sym_EQ_EQ] = ACTIONS(2821),
    [anon_sym_BANG_EQ] = ACTIONS(2821),
    [anon_sym_LT_EQ] = ACTIONS(2821),
    [anon_sym_GT_EQ] = ACTIONS(2821),
    [anon_sym_LBRACK] = ACTIONS(2821),
    [anon_sym_RBRACK] = ACTIONS(2821),
    [anon_sym_struct] = ACTIONS(2823),
    [anon_sym_mut] = ACTIONS(2823),
    [anon_sym_COLON] = ACTIONS(2821),
    [anon_sym_PLUS_PLUS] = ACTIONS(2821),
    [anon_sym_DASH_DASH] = ACTIONS(2821),
    [anon_sym_QMARK] = ACTIONS(2823),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_go] = ACTIONS(2823),
    [anon_sym_spawn] = ACTIONS(2823),
    [anon_sym_json_DOTdecode] = ACTIONS(2821),
    [anon_sym_PIPE] = ACTIONS(2823),
    [anon_sym_LBRACK2] = ACTIONS(2823),
    [anon_sym_TILDE] = ACTIONS(2821),
    [anon_sym_CARET] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_LT_DASH] = ACTIONS(2821),
    [anon_sym_LT_LT] = ACTIONS(2821),
    [anon_sym_GT_GT] = ACTIONS(2823),
    [anon_sym_GT_GT_GT] = ACTIONS(2821),
    [anon_sym_AMP_CARET] = ACTIONS(2821),
    [anon_sym_AMP_AMP] = ACTIONS(2821),
    [anon_sym_PIPE_PIPE] = ACTIONS(2821),
    [anon_sym_or] = ACTIONS(2823),
    [sym_none] = ACTIONS(2823),
    [sym_true] = ACTIONS(2823),
    [sym_false] = ACTIONS(2823),
    [sym_nil] = ACTIONS(2823),
    [anon_sym_QMARK_DOT] = ACTIONS(2821),
    [anon_sym_POUND_LBRACK] = ACTIONS(2821),
    [anon_sym_if] = ACTIONS(2823),
    [anon_sym_DOLLARif] = ACTIONS(2823),
    [anon_sym_is] = ACTIONS(2823),
    [anon_sym_BANGis] = ACTIONS(2821),
    [anon_sym_in] = ACTIONS(2823),
    [anon_sym_BANGin] = ACTIONS(2821),
    [anon_sym_match] = ACTIONS(2823),
    [anon_sym_select] = ACTIONS(2823),
    [anon_sym_lock] = ACTIONS(2823),
    [anon_sym_rlock] = ACTIONS(2823),
    [anon_sym_unsafe] = ACTIONS(2823),
    [anon_sym_sql] = ACTIONS(2823),
    [sym_int_literal] = ACTIONS(2823),
    [sym_float_literal] = ACTIONS(2821),
    [sym_rune_literal] = ACTIONS(2821),
    [anon_sym_SQUOTE] = ACTIONS(2821),
    [anon_sym_DQUOTE] = ACTIONS(2821),
    [anon_sym_c_SQUOTE] = ACTIONS(2821),
    [anon_sym_c_DQUOTE] = ACTIONS(2821),
    [anon_sym_r_SQUOTE] = ACTIONS(2821),
    [anon_sym_r_DQUOTE] = ACTIONS(2821),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2823),
    [anon_sym_shared] = ACTIONS(2823),
    [anon_sym_map_LBRACK] = ACTIONS(2821),
    [anon_sym_chan] = ACTIONS(2823),
    [anon_sym_thread] = ACTIONS(2823),
    [anon_sym_atomic] = ACTIONS(2823),
  },
  [1675] = {
    [sym_line_comment] = STATE(1675),
    [sym_block_comment] = STATE(1675),
    [sym_identifier] = ACTIONS(2397),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2397),
    [anon_sym_as] = ACTIONS(2397),
    [anon_sym_LBRACE] = ACTIONS(2395),
    [anon_sym_COMMA] = ACTIONS(2395),
    [anon_sym_RBRACE] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2395),
    [anon_sym_fn] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(2397),
    [anon_sym_DASH] = ACTIONS(2397),
    [anon_sym_STAR] = ACTIONS(2395),
    [anon_sym_SLASH] = ACTIONS(2397),
    [anon_sym_PERCENT] = ACTIONS(2395),
    [anon_sym_LT] = ACTIONS(2397),
    [anon_sym_GT] = ACTIONS(2397),
    [anon_sym_EQ_EQ] = ACTIONS(2395),
    [anon_sym_BANG_EQ] = ACTIONS(2395),
    [anon_sym_LT_EQ] = ACTIONS(2395),
    [anon_sym_GT_EQ] = ACTIONS(2395),
    [anon_sym_LBRACK] = ACTIONS(2395),
    [anon_sym_RBRACK] = ACTIONS(2395),
    [anon_sym_struct] = ACTIONS(2397),
    [anon_sym_mut] = ACTIONS(2397),
    [anon_sym_COLON] = ACTIONS(2395),
    [anon_sym_PLUS_PLUS] = ACTIONS(2395),
    [anon_sym_DASH_DASH] = ACTIONS(2395),
    [anon_sym_QMARK] = ACTIONS(2397),
    [anon_sym_BANG] = ACTIONS(2397),
    [anon_sym_go] = ACTIONS(2397),
    [anon_sym_spawn] = ACTIONS(2397),
    [anon_sym_json_DOTdecode] = ACTIONS(2395),
    [anon_sym_PIPE] = ACTIONS(2397),
    [anon_sym_LBRACK2] = ACTIONS(2397),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_CARET] = ACTIONS(2395),
    [anon_sym_AMP] = ACTIONS(2397),
    [anon_sym_LT_DASH] = ACTIONS(2395),
    [anon_sym_LT_LT] = ACTIONS(2395),
    [anon_sym_GT_GT] = ACTIONS(2397),
    [anon_sym_GT_GT_GT] = ACTIONS(2395),
    [anon_sym_AMP_CARET] = ACTIONS(2395),
    [anon_sym_AMP_AMP] = ACTIONS(2395),
    [anon_sym_PIPE_PIPE] = ACTIONS(2395),
    [anon_sym_or] = ACTIONS(2397),
    [sym_none] = ACTIONS(2397),
    [sym_true] = ACTIONS(2397),
    [sym_false] = ACTIONS(2397),
    [sym_nil] = ACTIONS(2397),
    [anon_sym_QMARK_DOT] = ACTIONS(2395),
    [anon_sym_POUND_LBRACK] = ACTIONS(2395),
    [anon_sym_if] = ACTIONS(2397),
    [anon_sym_DOLLARif] = ACTIONS(2397),
    [anon_sym_is] = ACTIONS(2397),
    [anon_sym_BANGis] = ACTIONS(2395),
    [anon_sym_in] = ACTIONS(2397),
    [anon_sym_BANGin] = ACTIONS(2395),
    [anon_sym_match] = ACTIONS(2397),
    [anon_sym_select] = ACTIONS(2397),
    [anon_sym_lock] = ACTIONS(2397),
    [anon_sym_rlock] = ACTIONS(2397),
    [anon_sym_unsafe] = ACTIONS(2397),
    [anon_sym_sql] = ACTIONS(2397),
    [sym_int_literal] = ACTIONS(2397),
    [sym_float_literal] = ACTIONS(2395),
    [sym_rune_literal] = ACTIONS(2395),
    [anon_sym_SQUOTE] = ACTIONS(2395),
    [anon_sym_DQUOTE] = ACTIONS(2395),
    [anon_sym_c_SQUOTE] = ACTIONS(2395),
    [anon_sym_c_DQUOTE] = ACTIONS(2395),
    [anon_sym_r_SQUOTE] = ACTIONS(2395),
    [anon_sym_r_DQUOTE] = ACTIONS(2395),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2397),
    [anon_sym_shared] = ACTIONS(2397),
    [anon_sym_map_LBRACK] = ACTIONS(2395),
    [anon_sym_chan] = ACTIONS(2397),
    [anon_sym_thread] = ACTIONS(2397),
    [anon_sym_atomic] = ACTIONS(2397),
  },
  [1676] = {
    [sym_line_comment] = STATE(1676),
    [sym_block_comment] = STATE(1676),
    [sym_identifier] = ACTIONS(2435),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2435),
    [anon_sym_as] = ACTIONS(2435),
    [anon_sym_LBRACE] = ACTIONS(2433),
    [anon_sym_COMMA] = ACTIONS(2433),
    [anon_sym_RBRACE] = ACTIONS(2433),
    [anon_sym_LPAREN] = ACTIONS(2433),
    [anon_sym_fn] = ACTIONS(2435),
    [anon_sym_PLUS] = ACTIONS(2435),
    [anon_sym_DASH] = ACTIONS(2435),
    [anon_sym_STAR] = ACTIONS(2433),
    [anon_sym_SLASH] = ACTIONS(2435),
    [anon_sym_PERCENT] = ACTIONS(2433),
    [anon_sym_LT] = ACTIONS(2435),
    [anon_sym_GT] = ACTIONS(2435),
    [anon_sym_EQ_EQ] = ACTIONS(2433),
    [anon_sym_BANG_EQ] = ACTIONS(2433),
    [anon_sym_LT_EQ] = ACTIONS(2433),
    [anon_sym_GT_EQ] = ACTIONS(2433),
    [anon_sym_LBRACK] = ACTIONS(2433),
    [anon_sym_RBRACK] = ACTIONS(2433),
    [anon_sym_struct] = ACTIONS(2435),
    [anon_sym_mut] = ACTIONS(2435),
    [anon_sym_COLON] = ACTIONS(2433),
    [anon_sym_PLUS_PLUS] = ACTIONS(2433),
    [anon_sym_DASH_DASH] = ACTIONS(2433),
    [anon_sym_QMARK] = ACTIONS(2435),
    [anon_sym_BANG] = ACTIONS(2435),
    [anon_sym_go] = ACTIONS(2435),
    [anon_sym_spawn] = ACTIONS(2435),
    [anon_sym_json_DOTdecode] = ACTIONS(2433),
    [anon_sym_PIPE] = ACTIONS(2435),
    [anon_sym_LBRACK2] = ACTIONS(2435),
    [anon_sym_TILDE] = ACTIONS(2433),
    [anon_sym_CARET] = ACTIONS(2433),
    [anon_sym_AMP] = ACTIONS(2435),
    [anon_sym_LT_DASH] = ACTIONS(2433),
    [anon_sym_LT_LT] = ACTIONS(2433),
    [anon_sym_GT_GT] = ACTIONS(2435),
    [anon_sym_GT_GT_GT] = ACTIONS(2433),
    [anon_sym_AMP_CARET] = ACTIONS(2433),
    [anon_sym_AMP_AMP] = ACTIONS(2433),
    [anon_sym_PIPE_PIPE] = ACTIONS(2433),
    [anon_sym_or] = ACTIONS(2435),
    [sym_none] = ACTIONS(2435),
    [sym_true] = ACTIONS(2435),
    [sym_false] = ACTIONS(2435),
    [sym_nil] = ACTIONS(2435),
    [anon_sym_QMARK_DOT] = ACTIONS(2433),
    [anon_sym_POUND_LBRACK] = ACTIONS(2433),
    [anon_sym_if] = ACTIONS(2435),
    [anon_sym_DOLLARif] = ACTIONS(2435),
    [anon_sym_is] = ACTIONS(2435),
    [anon_sym_BANGis] = ACTIONS(2433),
    [anon_sym_in] = ACTIONS(2435),
    [anon_sym_BANGin] = ACTIONS(2433),
    [anon_sym_match] = ACTIONS(2435),
    [anon_sym_select] = ACTIONS(2435),
    [anon_sym_lock] = ACTIONS(2435),
    [anon_sym_rlock] = ACTIONS(2435),
    [anon_sym_unsafe] = ACTIONS(2435),
    [anon_sym_sql] = ACTIONS(2435),
    [sym_int_literal] = ACTIONS(2435),
    [sym_float_literal] = ACTIONS(2433),
    [sym_rune_literal] = ACTIONS(2433),
    [anon_sym_SQUOTE] = ACTIONS(2433),
    [anon_sym_DQUOTE] = ACTIONS(2433),
    [anon_sym_c_SQUOTE] = ACTIONS(2433),
    [anon_sym_c_DQUOTE] = ACTIONS(2433),
    [anon_sym_r_SQUOTE] = ACTIONS(2433),
    [anon_sym_r_DQUOTE] = ACTIONS(2433),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2435),
    [anon_sym_shared] = ACTIONS(2435),
    [anon_sym_map_LBRACK] = ACTIONS(2433),
    [anon_sym_chan] = ACTIONS(2435),
    [anon_sym_thread] = ACTIONS(2435),
    [anon_sym_atomic] = ACTIONS(2435),
  },
  [1677] = {
    [sym_line_comment] = STATE(1677),
    [sym_block_comment] = STATE(1677),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3296),
    [anon_sym_as] = ACTIONS(3296),
    [anon_sym_LBRACE] = ACTIONS(3294),
    [anon_sym_COMMA] = ACTIONS(3294),
    [anon_sym_RBRACE] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3294),
    [anon_sym_fn] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_STAR] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3294),
    [anon_sym_LT] = ACTIONS(3296),
    [anon_sym_GT] = ACTIONS(3296),
    [anon_sym_EQ_EQ] = ACTIONS(3294),
    [anon_sym_BANG_EQ] = ACTIONS(3294),
    [anon_sym_LT_EQ] = ACTIONS(3294),
    [anon_sym_GT_EQ] = ACTIONS(3294),
    [anon_sym_LBRACK] = ACTIONS(3294),
    [anon_sym_RBRACK] = ACTIONS(3294),
    [anon_sym_struct] = ACTIONS(3296),
    [anon_sym_mut] = ACTIONS(3296),
    [anon_sym_COLON] = ACTIONS(3294),
    [anon_sym_PLUS_PLUS] = ACTIONS(3294),
    [anon_sym_DASH_DASH] = ACTIONS(3294),
    [anon_sym_QMARK] = ACTIONS(3296),
    [anon_sym_BANG] = ACTIONS(3296),
    [anon_sym_go] = ACTIONS(3296),
    [anon_sym_spawn] = ACTIONS(3296),
    [anon_sym_json_DOTdecode] = ACTIONS(3294),
    [anon_sym_PIPE] = ACTIONS(3296),
    [anon_sym_LBRACK2] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3294),
    [anon_sym_CARET] = ACTIONS(3294),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3294),
    [anon_sym_LT_LT] = ACTIONS(3294),
    [anon_sym_GT_GT] = ACTIONS(3296),
    [anon_sym_GT_GT_GT] = ACTIONS(3294),
    [anon_sym_AMP_CARET] = ACTIONS(3294),
    [anon_sym_AMP_AMP] = ACTIONS(3294),
    [anon_sym_PIPE_PIPE] = ACTIONS(3294),
    [anon_sym_or] = ACTIONS(3296),
    [sym_none] = ACTIONS(3296),
    [sym_true] = ACTIONS(3296),
    [sym_false] = ACTIONS(3296),
    [sym_nil] = ACTIONS(3296),
    [anon_sym_QMARK_DOT] = ACTIONS(3294),
    [anon_sym_POUND_LBRACK] = ACTIONS(3294),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_DOLLARif] = ACTIONS(3296),
    [anon_sym_is] = ACTIONS(3296),
    [anon_sym_BANGis] = ACTIONS(3294),
    [anon_sym_in] = ACTIONS(3296),
    [anon_sym_BANGin] = ACTIONS(3294),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_select] = ACTIONS(3296),
    [anon_sym_lock] = ACTIONS(3296),
    [anon_sym_rlock] = ACTIONS(3296),
    [anon_sym_unsafe] = ACTIONS(3296),
    [anon_sym_sql] = ACTIONS(3296),
    [sym_int_literal] = ACTIONS(3296),
    [sym_float_literal] = ACTIONS(3294),
    [sym_rune_literal] = ACTIONS(3294),
    [anon_sym_SQUOTE] = ACTIONS(3294),
    [anon_sym_DQUOTE] = ACTIONS(3294),
    [anon_sym_c_SQUOTE] = ACTIONS(3294),
    [anon_sym_c_DQUOTE] = ACTIONS(3294),
    [anon_sym_r_SQUOTE] = ACTIONS(3294),
    [anon_sym_r_DQUOTE] = ACTIONS(3294),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3296),
    [anon_sym_shared] = ACTIONS(3296),
    [anon_sym_map_LBRACK] = ACTIONS(3294),
    [anon_sym_chan] = ACTIONS(3296),
    [anon_sym_thread] = ACTIONS(3296),
    [anon_sym_atomic] = ACTIONS(3296),
  },
  [1678] = {
    [sym_line_comment] = STATE(1678),
    [sym_block_comment] = STATE(1678),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(3292),
    [anon_sym_LBRACE] = ACTIONS(3290),
    [anon_sym_COMMA] = ACTIONS(3290),
    [anon_sym_RBRACE] = ACTIONS(3290),
    [anon_sym_LPAREN] = ACTIONS(3290),
    [anon_sym_fn] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_STAR] = ACTIONS(3290),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3290),
    [anon_sym_LT] = ACTIONS(3292),
    [anon_sym_GT] = ACTIONS(3292),
    [anon_sym_EQ_EQ] = ACTIONS(3290),
    [anon_sym_BANG_EQ] = ACTIONS(3290),
    [anon_sym_LT_EQ] = ACTIONS(3290),
    [anon_sym_GT_EQ] = ACTIONS(3290),
    [anon_sym_LBRACK] = ACTIONS(3290),
    [anon_sym_RBRACK] = ACTIONS(3290),
    [anon_sym_struct] = ACTIONS(3292),
    [anon_sym_mut] = ACTIONS(3292),
    [anon_sym_COLON] = ACTIONS(3290),
    [anon_sym_PLUS_PLUS] = ACTIONS(3290),
    [anon_sym_DASH_DASH] = ACTIONS(3290),
    [anon_sym_QMARK] = ACTIONS(3292),
    [anon_sym_BANG] = ACTIONS(3292),
    [anon_sym_go] = ACTIONS(3292),
    [anon_sym_spawn] = ACTIONS(3292),
    [anon_sym_json_DOTdecode] = ACTIONS(3290),
    [anon_sym_PIPE] = ACTIONS(3292),
    [anon_sym_LBRACK2] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3290),
    [anon_sym_CARET] = ACTIONS(3290),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LT_DASH] = ACTIONS(3290),
    [anon_sym_LT_LT] = ACTIONS(3290),
    [anon_sym_GT_GT] = ACTIONS(3292),
    [anon_sym_GT_GT_GT] = ACTIONS(3290),
    [anon_sym_AMP_CARET] = ACTIONS(3290),
    [anon_sym_AMP_AMP] = ACTIONS(3290),
    [anon_sym_PIPE_PIPE] = ACTIONS(3290),
    [anon_sym_or] = ACTIONS(3292),
    [sym_none] = ACTIONS(3292),
    [sym_true] = ACTIONS(3292),
    [sym_false] = ACTIONS(3292),
    [sym_nil] = ACTIONS(3292),
    [anon_sym_QMARK_DOT] = ACTIONS(3290),
    [anon_sym_POUND_LBRACK] = ACTIONS(3290),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_DOLLARif] = ACTIONS(3292),
    [anon_sym_is] = ACTIONS(3292),
    [anon_sym_BANGis] = ACTIONS(3290),
    [anon_sym_in] = ACTIONS(3292),
    [anon_sym_BANGin] = ACTIONS(3290),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_select] = ACTIONS(3292),
    [anon_sym_lock] = ACTIONS(3292),
    [anon_sym_rlock] = ACTIONS(3292),
    [anon_sym_unsafe] = ACTIONS(3292),
    [anon_sym_sql] = ACTIONS(3292),
    [sym_int_literal] = ACTIONS(3292),
    [sym_float_literal] = ACTIONS(3290),
    [sym_rune_literal] = ACTIONS(3290),
    [anon_sym_SQUOTE] = ACTIONS(3290),
    [anon_sym_DQUOTE] = ACTIONS(3290),
    [anon_sym_c_SQUOTE] = ACTIONS(3290),
    [anon_sym_c_DQUOTE] = ACTIONS(3290),
    [anon_sym_r_SQUOTE] = ACTIONS(3290),
    [anon_sym_r_DQUOTE] = ACTIONS(3290),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3292),
    [anon_sym_shared] = ACTIONS(3292),
    [anon_sym_map_LBRACK] = ACTIONS(3290),
    [anon_sym_chan] = ACTIONS(3292),
    [anon_sym_thread] = ACTIONS(3292),
    [anon_sym_atomic] = ACTIONS(3292),
  },
  [1679] = {
    [sym_line_comment] = STATE(1679),
    [sym_block_comment] = STATE(1679),
    [sym_identifier] = ACTIONS(3270),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3270),
    [anon_sym_as] = ACTIONS(3270),
    [anon_sym_LBRACE] = ACTIONS(3268),
    [anon_sym_COMMA] = ACTIONS(3268),
    [anon_sym_RBRACE] = ACTIONS(3268),
    [anon_sym_LPAREN] = ACTIONS(3268),
    [anon_sym_fn] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3270),
    [anon_sym_DASH] = ACTIONS(3270),
    [anon_sym_STAR] = ACTIONS(3268),
    [anon_sym_SLASH] = ACTIONS(3270),
    [anon_sym_PERCENT] = ACTIONS(3268),
    [anon_sym_LT] = ACTIONS(3270),
    [anon_sym_GT] = ACTIONS(3270),
    [anon_sym_EQ_EQ] = ACTIONS(3268),
    [anon_sym_BANG_EQ] = ACTIONS(3268),
    [anon_sym_LT_EQ] = ACTIONS(3268),
    [anon_sym_GT_EQ] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(3268),
    [anon_sym_RBRACK] = ACTIONS(3268),
    [anon_sym_struct] = ACTIONS(3270),
    [anon_sym_mut] = ACTIONS(3270),
    [anon_sym_COLON] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3268),
    [anon_sym_DASH_DASH] = ACTIONS(3268),
    [anon_sym_QMARK] = ACTIONS(3270),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_go] = ACTIONS(3270),
    [anon_sym_spawn] = ACTIONS(3270),
    [anon_sym_json_DOTdecode] = ACTIONS(3268),
    [anon_sym_PIPE] = ACTIONS(3270),
    [anon_sym_LBRACK2] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3268),
    [anon_sym_CARET] = ACTIONS(3268),
    [anon_sym_AMP] = ACTIONS(3270),
    [anon_sym_LT_DASH] = ACTIONS(3268),
    [anon_sym_LT_LT] = ACTIONS(3268),
    [anon_sym_GT_GT] = ACTIONS(3270),
    [anon_sym_GT_GT_GT] = ACTIONS(3268),
    [anon_sym_AMP_CARET] = ACTIONS(3268),
    [anon_sym_AMP_AMP] = ACTIONS(3268),
    [anon_sym_PIPE_PIPE] = ACTIONS(3268),
    [anon_sym_or] = ACTIONS(3270),
    [sym_none] = ACTIONS(3270),
    [sym_true] = ACTIONS(3270),
    [sym_false] = ACTIONS(3270),
    [sym_nil] = ACTIONS(3270),
    [anon_sym_QMARK_DOT] = ACTIONS(3268),
    [anon_sym_POUND_LBRACK] = ACTIONS(3268),
    [anon_sym_if] = ACTIONS(3270),
    [anon_sym_DOLLARif] = ACTIONS(3270),
    [anon_sym_is] = ACTIONS(3270),
    [anon_sym_BANGis] = ACTIONS(3268),
    [anon_sym_in] = ACTIONS(3270),
    [anon_sym_BANGin] = ACTIONS(3268),
    [anon_sym_match] = ACTIONS(3270),
    [anon_sym_select] = ACTIONS(3270),
    [anon_sym_lock] = ACTIONS(3270),
    [anon_sym_rlock] = ACTIONS(3270),
    [anon_sym_unsafe] = ACTIONS(3270),
    [anon_sym_sql] = ACTIONS(3270),
    [sym_int_literal] = ACTIONS(3270),
    [sym_float_literal] = ACTIONS(3268),
    [sym_rune_literal] = ACTIONS(3268),
    [anon_sym_SQUOTE] = ACTIONS(3268),
    [anon_sym_DQUOTE] = ACTIONS(3268),
    [anon_sym_c_SQUOTE] = ACTIONS(3268),
    [anon_sym_c_DQUOTE] = ACTIONS(3268),
    [anon_sym_r_SQUOTE] = ACTIONS(3268),
    [anon_sym_r_DQUOTE] = ACTIONS(3268),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3270),
    [anon_sym_shared] = ACTIONS(3270),
    [anon_sym_map_LBRACK] = ACTIONS(3268),
    [anon_sym_chan] = ACTIONS(3270),
    [anon_sym_thread] = ACTIONS(3270),
    [anon_sym_atomic] = ACTIONS(3270),
  },
  [1680] = {
    [sym_line_comment] = STATE(1680),
    [sym_block_comment] = STATE(1680),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2819),
    [anon_sym_as] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(2817),
    [anon_sym_COMMA] = ACTIONS(2817),
    [anon_sym_RBRACE] = ACTIONS(2817),
    [anon_sym_LPAREN] = ACTIONS(2817),
    [anon_sym_fn] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_STAR] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(2819),
    [anon_sym_GT] = ACTIONS(2819),
    [anon_sym_EQ_EQ] = ACTIONS(2817),
    [anon_sym_BANG_EQ] = ACTIONS(2817),
    [anon_sym_LT_EQ] = ACTIONS(2817),
    [anon_sym_GT_EQ] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(2817),
    [anon_sym_RBRACK] = ACTIONS(2817),
    [anon_sym_struct] = ACTIONS(2819),
    [anon_sym_mut] = ACTIONS(2819),
    [anon_sym_COLON] = ACTIONS(2817),
    [anon_sym_PLUS_PLUS] = ACTIONS(2817),
    [anon_sym_DASH_DASH] = ACTIONS(2817),
    [anon_sym_QMARK] = ACTIONS(2819),
    [anon_sym_BANG] = ACTIONS(2819),
    [anon_sym_go] = ACTIONS(2819),
    [anon_sym_spawn] = ACTIONS(2819),
    [anon_sym_json_DOTdecode] = ACTIONS(2817),
    [anon_sym_PIPE] = ACTIONS(2819),
    [anon_sym_LBRACK2] = ACTIONS(2819),
    [anon_sym_TILDE] = ACTIONS(2817),
    [anon_sym_CARET] = ACTIONS(2817),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_LT_DASH] = ACTIONS(2817),
    [anon_sym_LT_LT] = ACTIONS(2817),
    [anon_sym_GT_GT] = ACTIONS(2819),
    [anon_sym_GT_GT_GT] = ACTIONS(2817),
    [anon_sym_AMP_CARET] = ACTIONS(2817),
    [anon_sym_AMP_AMP] = ACTIONS(2817),
    [anon_sym_PIPE_PIPE] = ACTIONS(2817),
    [anon_sym_or] = ACTIONS(2819),
    [sym_none] = ACTIONS(2819),
    [sym_true] = ACTIONS(2819),
    [sym_false] = ACTIONS(2819),
    [sym_nil] = ACTIONS(2819),
    [anon_sym_QMARK_DOT] = ACTIONS(2817),
    [anon_sym_POUND_LBRACK] = ACTIONS(2817),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_DOLLARif] = ACTIONS(2819),
    [anon_sym_is] = ACTIONS(2819),
    [anon_sym_BANGis] = ACTIONS(2817),
    [anon_sym_in] = ACTIONS(2819),
    [anon_sym_BANGin] = ACTIONS(2817),
    [anon_sym_match] = ACTIONS(2819),
    [anon_sym_select] = ACTIONS(2819),
    [anon_sym_lock] = ACTIONS(2819),
    [anon_sym_rlock] = ACTIONS(2819),
    [anon_sym_unsafe] = ACTIONS(2819),
    [anon_sym_sql] = ACTIONS(2819),
    [sym_int_literal] = ACTIONS(2819),
    [sym_float_literal] = ACTIONS(2817),
    [sym_rune_literal] = ACTIONS(2817),
    [anon_sym_SQUOTE] = ACTIONS(2817),
    [anon_sym_DQUOTE] = ACTIONS(2817),
    [anon_sym_c_SQUOTE] = ACTIONS(2817),
    [anon_sym_c_DQUOTE] = ACTIONS(2817),
    [anon_sym_r_SQUOTE] = ACTIONS(2817),
    [anon_sym_r_DQUOTE] = ACTIONS(2817),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2819),
    [anon_sym_shared] = ACTIONS(2819),
    [anon_sym_map_LBRACK] = ACTIONS(2817),
    [anon_sym_chan] = ACTIONS(2819),
    [anon_sym_thread] = ACTIONS(2819),
    [anon_sym_atomic] = ACTIONS(2819),
  },
  [1681] = {
    [sym_line_comment] = STATE(1681),
    [sym_block_comment] = STATE(1681),
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(4315),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_as] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_fn] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3043),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_PERCENT] = ACTIONS(3043),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_GT] = ACTIONS(3045),
    [anon_sym_EQ_EQ] = ACTIONS(3043),
    [anon_sym_BANG_EQ] = ACTIONS(3043),
    [anon_sym_LT_EQ] = ACTIONS(3043),
    [anon_sym_GT_EQ] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_RBRACK] = ACTIONS(4315),
    [anon_sym_struct] = ACTIONS(3045),
    [anon_sym_mut] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(4315),
    [anon_sym_PLUS_PLUS] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3045),
    [anon_sym_go] = ACTIONS(3045),
    [anon_sym_spawn] = ACTIONS(3045),
    [anon_sym_json_DOTdecode] = ACTIONS(3043),
    [anon_sym_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACK2] = ACTIONS(3045),
    [anon_sym_TILDE] = ACTIONS(3043),
    [anon_sym_CARET] = ACTIONS(3043),
    [anon_sym_AMP] = ACTIONS(3045),
    [anon_sym_LT_DASH] = ACTIONS(3043),
    [anon_sym_LT_LT] = ACTIONS(3043),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_GT_GT_GT] = ACTIONS(3043),
    [anon_sym_AMP_CARET] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [anon_sym_or] = ACTIONS(3045),
    [sym_none] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_nil] = ACTIONS(3045),
    [anon_sym_QMARK_DOT] = ACTIONS(3043),
    [anon_sym_POUND_LBRACK] = ACTIONS(3043),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_DOLLARif] = ACTIONS(3045),
    [anon_sym_is] = ACTIONS(3045),
    [anon_sym_BANGis] = ACTIONS(3043),
    [anon_sym_in] = ACTIONS(3045),
    [anon_sym_BANGin] = ACTIONS(3043),
    [anon_sym_match] = ACTIONS(3045),
    [anon_sym_select] = ACTIONS(3045),
    [anon_sym_lock] = ACTIONS(3045),
    [anon_sym_rlock] = ACTIONS(3045),
    [anon_sym_unsafe] = ACTIONS(3045),
    [anon_sym_sql] = ACTIONS(3045),
    [sym_int_literal] = ACTIONS(3045),
    [sym_float_literal] = ACTIONS(3043),
    [sym_rune_literal] = ACTIONS(3043),
    [anon_sym_SQUOTE] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [anon_sym_c_SQUOTE] = ACTIONS(3043),
    [anon_sym_c_DQUOTE] = ACTIONS(3043),
    [anon_sym_r_SQUOTE] = ACTIONS(3043),
    [anon_sym_r_DQUOTE] = ACTIONS(3043),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3045),
    [anon_sym_shared] = ACTIONS(3045),
    [anon_sym_map_LBRACK] = ACTIONS(3043),
    [anon_sym_chan] = ACTIONS(3045),
    [anon_sym_thread] = ACTIONS(3045),
    [anon_sym_atomic] = ACTIONS(3045),
  },
  [1682] = {
    [sym_line_comment] = STATE(1682),
    [sym_block_comment] = STATE(1682),
    [sym_identifier] = ACTIONS(2659),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2659),
    [anon_sym_as] = ACTIONS(2659),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_COMMA] = ACTIONS(2657),
    [anon_sym_RBRACE] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(2657),
    [anon_sym_fn] = ACTIONS(2659),
    [anon_sym_PLUS] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_STAR] = ACTIONS(2657),
    [anon_sym_SLASH] = ACTIONS(2659),
    [anon_sym_PERCENT] = ACTIONS(2657),
    [anon_sym_LT] = ACTIONS(2659),
    [anon_sym_GT] = ACTIONS(2659),
    [anon_sym_EQ_EQ] = ACTIONS(2657),
    [anon_sym_BANG_EQ] = ACTIONS(2657),
    [anon_sym_LT_EQ] = ACTIONS(2657),
    [anon_sym_GT_EQ] = ACTIONS(2657),
    [anon_sym_LBRACK] = ACTIONS(2657),
    [anon_sym_RBRACK] = ACTIONS(2657),
    [anon_sym_struct] = ACTIONS(2659),
    [anon_sym_mut] = ACTIONS(2659),
    [anon_sym_COLON] = ACTIONS(2657),
    [anon_sym_PLUS_PLUS] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(2657),
    [anon_sym_QMARK] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_go] = ACTIONS(2659),
    [anon_sym_spawn] = ACTIONS(2659),
    [anon_sym_json_DOTdecode] = ACTIONS(2657),
    [anon_sym_PIPE] = ACTIONS(2659),
    [anon_sym_LBRACK2] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2657),
    [anon_sym_CARET] = ACTIONS(2657),
    [anon_sym_AMP] = ACTIONS(2659),
    [anon_sym_LT_DASH] = ACTIONS(2657),
    [anon_sym_LT_LT] = ACTIONS(2657),
    [anon_sym_GT_GT] = ACTIONS(2659),
    [anon_sym_GT_GT_GT] = ACTIONS(2657),
    [anon_sym_AMP_CARET] = ACTIONS(2657),
    [anon_sym_AMP_AMP] = ACTIONS(2657),
    [anon_sym_PIPE_PIPE] = ACTIONS(2657),
    [anon_sym_or] = ACTIONS(2659),
    [sym_none] = ACTIONS(2659),
    [sym_true] = ACTIONS(2659),
    [sym_false] = ACTIONS(2659),
    [sym_nil] = ACTIONS(2659),
    [anon_sym_QMARK_DOT] = ACTIONS(2657),
    [anon_sym_POUND_LBRACK] = ACTIONS(2657),
    [anon_sym_if] = ACTIONS(2659),
    [anon_sym_DOLLARif] = ACTIONS(2659),
    [anon_sym_is] = ACTIONS(2659),
    [anon_sym_BANGis] = ACTIONS(2657),
    [anon_sym_in] = ACTIONS(2659),
    [anon_sym_BANGin] = ACTIONS(2657),
    [anon_sym_match] = ACTIONS(2659),
    [anon_sym_select] = ACTIONS(2659),
    [anon_sym_lock] = ACTIONS(2659),
    [anon_sym_rlock] = ACTIONS(2659),
    [anon_sym_unsafe] = ACTIONS(2659),
    [anon_sym_sql] = ACTIONS(2659),
    [sym_int_literal] = ACTIONS(2659),
    [sym_float_literal] = ACTIONS(2657),
    [sym_rune_literal] = ACTIONS(2657),
    [anon_sym_SQUOTE] = ACTIONS(2657),
    [anon_sym_DQUOTE] = ACTIONS(2657),
    [anon_sym_c_SQUOTE] = ACTIONS(2657),
    [anon_sym_c_DQUOTE] = ACTIONS(2657),
    [anon_sym_r_SQUOTE] = ACTIONS(2657),
    [anon_sym_r_DQUOTE] = ACTIONS(2657),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2659),
    [anon_sym_shared] = ACTIONS(2659),
    [anon_sym_map_LBRACK] = ACTIONS(2657),
    [anon_sym_chan] = ACTIONS(2659),
    [anon_sym_thread] = ACTIONS(2659),
    [anon_sym_atomic] = ACTIONS(2659),
  },
  [1683] = {
    [sym_line_comment] = STATE(1683),
    [sym_block_comment] = STATE(1683),
    [sym_identifier] = ACTIONS(2655),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2655),
    [anon_sym_as] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2653),
    [anon_sym_COMMA] = ACTIONS(2653),
    [anon_sym_RBRACE] = ACTIONS(2653),
    [anon_sym_LPAREN] = ACTIONS(2653),
    [anon_sym_fn] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_DASH] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(2653),
    [anon_sym_SLASH] = ACTIONS(2655),
    [anon_sym_PERCENT] = ACTIONS(2653),
    [anon_sym_LT] = ACTIONS(2655),
    [anon_sym_GT] = ACTIONS(2655),
    [anon_sym_EQ_EQ] = ACTIONS(2653),
    [anon_sym_BANG_EQ] = ACTIONS(2653),
    [anon_sym_LT_EQ] = ACTIONS(2653),
    [anon_sym_GT_EQ] = ACTIONS(2653),
    [anon_sym_LBRACK] = ACTIONS(2653),
    [anon_sym_RBRACK] = ACTIONS(2653),
    [anon_sym_struct] = ACTIONS(2655),
    [anon_sym_mut] = ACTIONS(2655),
    [anon_sym_COLON] = ACTIONS(2653),
    [anon_sym_PLUS_PLUS] = ACTIONS(2653),
    [anon_sym_DASH_DASH] = ACTIONS(2653),
    [anon_sym_QMARK] = ACTIONS(2655),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_go] = ACTIONS(2655),
    [anon_sym_spawn] = ACTIONS(2655),
    [anon_sym_json_DOTdecode] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_LBRACK2] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2653),
    [anon_sym_CARET] = ACTIONS(2653),
    [anon_sym_AMP] = ACTIONS(2655),
    [anon_sym_LT_DASH] = ACTIONS(2653),
    [anon_sym_LT_LT] = ACTIONS(2653),
    [anon_sym_GT_GT] = ACTIONS(2655),
    [anon_sym_GT_GT_GT] = ACTIONS(2653),
    [anon_sym_AMP_CARET] = ACTIONS(2653),
    [anon_sym_AMP_AMP] = ACTIONS(2653),
    [anon_sym_PIPE_PIPE] = ACTIONS(2653),
    [anon_sym_or] = ACTIONS(2655),
    [sym_none] = ACTIONS(2655),
    [sym_true] = ACTIONS(2655),
    [sym_false] = ACTIONS(2655),
    [sym_nil] = ACTIONS(2655),
    [anon_sym_QMARK_DOT] = ACTIONS(2653),
    [anon_sym_POUND_LBRACK] = ACTIONS(2653),
    [anon_sym_if] = ACTIONS(2655),
    [anon_sym_DOLLARif] = ACTIONS(2655),
    [anon_sym_is] = ACTIONS(2655),
    [anon_sym_BANGis] = ACTIONS(2653),
    [anon_sym_in] = ACTIONS(2655),
    [anon_sym_BANGin] = ACTIONS(2653),
    [anon_sym_match] = ACTIONS(2655),
    [anon_sym_select] = ACTIONS(2655),
    [anon_sym_lock] = ACTIONS(2655),
    [anon_sym_rlock] = ACTIONS(2655),
    [anon_sym_unsafe] = ACTIONS(2655),
    [anon_sym_sql] = ACTIONS(2655),
    [sym_int_literal] = ACTIONS(2655),
    [sym_float_literal] = ACTIONS(2653),
    [sym_rune_literal] = ACTIONS(2653),
    [anon_sym_SQUOTE] = ACTIONS(2653),
    [anon_sym_DQUOTE] = ACTIONS(2653),
    [anon_sym_c_SQUOTE] = ACTIONS(2653),
    [anon_sym_c_DQUOTE] = ACTIONS(2653),
    [anon_sym_r_SQUOTE] = ACTIONS(2653),
    [anon_sym_r_DQUOTE] = ACTIONS(2653),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2655),
    [anon_sym_shared] = ACTIONS(2655),
    [anon_sym_map_LBRACK] = ACTIONS(2653),
    [anon_sym_chan] = ACTIONS(2655),
    [anon_sym_thread] = ACTIONS(2655),
    [anon_sym_atomic] = ACTIONS(2655),
  },
  [1684] = {
    [sym_line_comment] = STATE(1684),
    [sym_block_comment] = STATE(1684),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2471),
    [anon_sym_as] = ACTIONS(2471),
    [anon_sym_LBRACE] = ACTIONS(2469),
    [anon_sym_COMMA] = ACTIONS(2469),
    [anon_sym_RBRACE] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2469),
    [anon_sym_fn] = ACTIONS(2471),
    [anon_sym_PLUS] = ACTIONS(2471),
    [anon_sym_DASH] = ACTIONS(2471),
    [anon_sym_STAR] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2471),
    [anon_sym_PERCENT] = ACTIONS(2469),
    [anon_sym_LT] = ACTIONS(2471),
    [anon_sym_GT] = ACTIONS(2471),
    [anon_sym_EQ_EQ] = ACTIONS(2469),
    [anon_sym_BANG_EQ] = ACTIONS(2469),
    [anon_sym_LT_EQ] = ACTIONS(2469),
    [anon_sym_GT_EQ] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(2469),
    [anon_sym_struct] = ACTIONS(2471),
    [anon_sym_mut] = ACTIONS(2471),
    [anon_sym_COLON] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2469),
    [anon_sym_DASH_DASH] = ACTIONS(2469),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_go] = ACTIONS(2471),
    [anon_sym_spawn] = ACTIONS(2471),
    [anon_sym_json_DOTdecode] = ACTIONS(2469),
    [anon_sym_PIPE] = ACTIONS(2471),
    [anon_sym_LBRACK2] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2469),
    [anon_sym_CARET] = ACTIONS(2469),
    [anon_sym_AMP] = ACTIONS(2471),
    [anon_sym_LT_DASH] = ACTIONS(2469),
    [anon_sym_LT_LT] = ACTIONS(2469),
    [anon_sym_GT_GT] = ACTIONS(2471),
    [anon_sym_GT_GT_GT] = ACTIONS(2469),
    [anon_sym_AMP_CARET] = ACTIONS(2469),
    [anon_sym_AMP_AMP] = ACTIONS(2469),
    [anon_sym_PIPE_PIPE] = ACTIONS(2469),
    [anon_sym_or] = ACTIONS(2471),
    [sym_none] = ACTIONS(2471),
    [sym_true] = ACTIONS(2471),
    [sym_false] = ACTIONS(2471),
    [sym_nil] = ACTIONS(2471),
    [anon_sym_QMARK_DOT] = ACTIONS(2469),
    [anon_sym_POUND_LBRACK] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2471),
    [anon_sym_DOLLARif] = ACTIONS(2471),
    [anon_sym_is] = ACTIONS(2471),
    [anon_sym_BANGis] = ACTIONS(2469),
    [anon_sym_in] = ACTIONS(2471),
    [anon_sym_BANGin] = ACTIONS(2469),
    [anon_sym_match] = ACTIONS(2471),
    [anon_sym_select] = ACTIONS(2471),
    [anon_sym_lock] = ACTIONS(2471),
    [anon_sym_rlock] = ACTIONS(2471),
    [anon_sym_unsafe] = ACTIONS(2471),
    [anon_sym_sql] = ACTIONS(2471),
    [sym_int_literal] = ACTIONS(2471),
    [sym_float_literal] = ACTIONS(2469),
    [sym_rune_literal] = ACTIONS(2469),
    [anon_sym_SQUOTE] = ACTIONS(2469),
    [anon_sym_DQUOTE] = ACTIONS(2469),
    [anon_sym_c_SQUOTE] = ACTIONS(2469),
    [anon_sym_c_DQUOTE] = ACTIONS(2469),
    [anon_sym_r_SQUOTE] = ACTIONS(2469),
    [anon_sym_r_DQUOTE] = ACTIONS(2469),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2471),
    [anon_sym_shared] = ACTIONS(2471),
    [anon_sym_map_LBRACK] = ACTIONS(2469),
    [anon_sym_chan] = ACTIONS(2471),
    [anon_sym_thread] = ACTIONS(2471),
    [anon_sym_atomic] = ACTIONS(2471),
  },
  [1685] = {
    [sym_line_comment] = STATE(1685),
    [sym_block_comment] = STATE(1685),
    [sym_identifier] = ACTIONS(3266),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3266),
    [anon_sym_as] = ACTIONS(3266),
    [anon_sym_LBRACE] = ACTIONS(3264),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_RBRACE] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3264),
    [anon_sym_fn] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3266),
    [anon_sym_DASH] = ACTIONS(3266),
    [anon_sym_STAR] = ACTIONS(3264),
    [anon_sym_SLASH] = ACTIONS(3266),
    [anon_sym_PERCENT] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3266),
    [anon_sym_GT] = ACTIONS(3266),
    [anon_sym_EQ_EQ] = ACTIONS(3264),
    [anon_sym_BANG_EQ] = ACTIONS(3264),
    [anon_sym_LT_EQ] = ACTIONS(3264),
    [anon_sym_GT_EQ] = ACTIONS(3264),
    [anon_sym_LBRACK] = ACTIONS(3264),
    [anon_sym_RBRACK] = ACTIONS(3264),
    [anon_sym_struct] = ACTIONS(3266),
    [anon_sym_mut] = ACTIONS(3266),
    [anon_sym_COLON] = ACTIONS(3264),
    [anon_sym_PLUS_PLUS] = ACTIONS(3264),
    [anon_sym_DASH_DASH] = ACTIONS(3264),
    [anon_sym_QMARK] = ACTIONS(3266),
    [anon_sym_BANG] = ACTIONS(3266),
    [anon_sym_go] = ACTIONS(3266),
    [anon_sym_spawn] = ACTIONS(3266),
    [anon_sym_json_DOTdecode] = ACTIONS(3264),
    [anon_sym_PIPE] = ACTIONS(3266),
    [anon_sym_LBRACK2] = ACTIONS(3266),
    [anon_sym_TILDE] = ACTIONS(3264),
    [anon_sym_CARET] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3266),
    [anon_sym_LT_DASH] = ACTIONS(3264),
    [anon_sym_LT_LT] = ACTIONS(3264),
    [anon_sym_GT_GT] = ACTIONS(3266),
    [anon_sym_GT_GT_GT] = ACTIONS(3264),
    [anon_sym_AMP_CARET] = ACTIONS(3264),
    [anon_sym_AMP_AMP] = ACTIONS(3264),
    [anon_sym_PIPE_PIPE] = ACTIONS(3264),
    [anon_sym_or] = ACTIONS(3266),
    [sym_none] = ACTIONS(3266),
    [sym_true] = ACTIONS(3266),
    [sym_false] = ACTIONS(3266),
    [sym_nil] = ACTIONS(3266),
    [anon_sym_QMARK_DOT] = ACTIONS(3264),
    [anon_sym_POUND_LBRACK] = ACTIONS(3264),
    [anon_sym_if] = ACTIONS(3266),
    [anon_sym_DOLLARif] = ACTIONS(3266),
    [anon_sym_is] = ACTIONS(3266),
    [anon_sym_BANGis] = ACTIONS(3264),
    [anon_sym_in] = ACTIONS(3266),
    [anon_sym_BANGin] = ACTIONS(3264),
    [anon_sym_match] = ACTIONS(3266),
    [anon_sym_select] = ACTIONS(3266),
    [anon_sym_lock] = ACTIONS(3266),
    [anon_sym_rlock] = ACTIONS(3266),
    [anon_sym_unsafe] = ACTIONS(3266),
    [anon_sym_sql] = ACTIONS(3266),
    [sym_int_literal] = ACTIONS(3266),
    [sym_float_literal] = ACTIONS(3264),
    [sym_rune_literal] = ACTIONS(3264),
    [anon_sym_SQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE] = ACTIONS(3264),
    [anon_sym_c_SQUOTE] = ACTIONS(3264),
    [anon_sym_c_DQUOTE] = ACTIONS(3264),
    [anon_sym_r_SQUOTE] = ACTIONS(3264),
    [anon_sym_r_DQUOTE] = ACTIONS(3264),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3266),
    [anon_sym_shared] = ACTIONS(3266),
    [anon_sym_map_LBRACK] = ACTIONS(3264),
    [anon_sym_chan] = ACTIONS(3266),
    [anon_sym_thread] = ACTIONS(3266),
    [anon_sym_atomic] = ACTIONS(3266),
  },
  [1686] = {
    [sym_line_comment] = STATE(1686),
    [sym_block_comment] = STATE(1686),
    [sym_identifier] = ACTIONS(2865),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2865),
    [anon_sym_as] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2863),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_fn] = ACTIONS(2865),
    [anon_sym_PLUS] = ACTIONS(2865),
    [anon_sym_DASH] = ACTIONS(2865),
    [anon_sym_STAR] = ACTIONS(2863),
    [anon_sym_SLASH] = ACTIONS(2865),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_GT] = ACTIONS(2865),
    [anon_sym_EQ_EQ] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_LT_EQ] = ACTIONS(2863),
    [anon_sym_GT_EQ] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_RBRACK] = ACTIONS(4317),
    [anon_sym_struct] = ACTIONS(2865),
    [anon_sym_mut] = ACTIONS(2865),
    [anon_sym_PLUS_PLUS] = ACTIONS(2863),
    [anon_sym_DASH_DASH] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2865),
    [anon_sym_BANG] = ACTIONS(2865),
    [anon_sym_go] = ACTIONS(2865),
    [anon_sym_spawn] = ACTIONS(2865),
    [anon_sym_json_DOTdecode] = ACTIONS(2863),
    [anon_sym_PIPE] = ACTIONS(2865),
    [anon_sym_LBRACK2] = ACTIONS(2865),
    [anon_sym_TILDE] = ACTIONS(2863),
    [anon_sym_CARET] = ACTIONS(2863),
    [anon_sym_AMP] = ACTIONS(2865),
    [anon_sym_LT_DASH] = ACTIONS(2863),
    [anon_sym_LT_LT] = ACTIONS(2863),
    [anon_sym_GT_GT] = ACTIONS(2865),
    [anon_sym_GT_GT_GT] = ACTIONS(2863),
    [anon_sym_AMP_CARET] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2865),
    [sym_none] = ACTIONS(2865),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_nil] = ACTIONS(2865),
    [anon_sym_QMARK_DOT] = ACTIONS(2863),
    [anon_sym_POUND_LBRACK] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2865),
    [anon_sym_DOLLARif] = ACTIONS(2865),
    [anon_sym_is] = ACTIONS(2865),
    [anon_sym_BANGis] = ACTIONS(2863),
    [anon_sym_in] = ACTIONS(2865),
    [anon_sym_BANGin] = ACTIONS(2863),
    [anon_sym_match] = ACTIONS(2865),
    [anon_sym_select] = ACTIONS(2865),
    [anon_sym_lock] = ACTIONS(2865),
    [anon_sym_rlock] = ACTIONS(2865),
    [anon_sym_unsafe] = ACTIONS(2865),
    [anon_sym_sql] = ACTIONS(2865),
    [sym_int_literal] = ACTIONS(2865),
    [sym_float_literal] = ACTIONS(2863),
    [sym_rune_literal] = ACTIONS(2863),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_DQUOTE] = ACTIONS(2863),
    [anon_sym_c_SQUOTE] = ACTIONS(2863),
    [anon_sym_c_DQUOTE] = ACTIONS(2863),
    [anon_sym_r_SQUOTE] = ACTIONS(2863),
    [anon_sym_r_DQUOTE] = ACTIONS(2863),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2865),
    [anon_sym_shared] = ACTIONS(2865),
    [anon_sym_map_LBRACK] = ACTIONS(2863),
    [anon_sym_chan] = ACTIONS(2865),
    [anon_sym_thread] = ACTIONS(2865),
    [anon_sym_atomic] = ACTIONS(2865),
  },
  [1687] = {
    [sym_line_comment] = STATE(1687),
    [sym_block_comment] = STATE(1687),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2145),
    [anon_sym_BANG_EQ] = ACTIONS(2145),
    [anon_sym_LT_EQ] = ACTIONS(2145),
    [anon_sym_GT_EQ] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_COLON] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2145),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2145),
    [anon_sym_LT_LT] = ACTIONS(2145),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2145),
    [anon_sym_AMP_CARET] = ACTIONS(2145),
    [anon_sym_AMP_AMP] = ACTIONS(2145),
    [anon_sym_PIPE_PIPE] = ACTIONS(2145),
    [anon_sym_or] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2145),
    [anon_sym_POUND_LBRACK] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2147),
    [anon_sym_BANGis] = ACTIONS(2145),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANGin] = ACTIONS(2145),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2145),
    [sym_rune_literal] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_c_SQUOTE] = ACTIONS(2145),
    [anon_sym_c_DQUOTE] = ACTIONS(2145),
    [anon_sym_r_SQUOTE] = ACTIONS(2145),
    [anon_sym_r_DQUOTE] = ACTIONS(2145),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2145),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
  },
  [1688] = {
    [sym_line_comment] = STATE(1688),
    [sym_block_comment] = STATE(1688),
    [sym_identifier] = ACTIONS(2957),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_DOT] = ACTIONS(2957),
    [anon_sym_as] = ACTIONS(2957),
    [anon_sym_LBRACE] = ACTIONS(2955),
    [anon_sym_COMMA] = ACTIONS(2955),
    [anon_sym_LPAREN] = ACTIONS(2955),
    [anon_sym_fn] = ACTIONS(2957),
    [anon_sym_PLUS] = ACTIONS(2957),
    [anon_sym_DASH] = ACTIONS(2957),
    [anon_sym_STAR] = ACTIONS(2955),
    [anon_sym_SLASH] = ACTIONS(2957),
    [anon_sym_PERCENT] = ACTIONS(2955),
    [anon_sym_LT] = ACTIONS(2957),
    [anon_sym_GT] = ACTIONS(2957),
    [anon_sym_EQ_EQ] = ACTIONS(2955),
    [anon_sym_BANG_EQ] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2955),
    [anon_sym_GT_EQ] = ACTIONS(2955),
    [anon_sym_LBRACK] = ACTIONS(2955),
    [anon_sym_RBRACK] = ACTIONS(4320),
    [anon_sym_struct] = ACTIONS(2957),
    [anon_sym_mut] = ACTIONS(2957),
    [anon_sym_PLUS_PLUS] = ACTIONS(2955),
    [anon_sym_DASH_DASH] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_BANG] = ACTIONS(2957),
    [anon_sym_go] = ACTIONS(2957),
    [anon_sym_spawn] = ACTIONS(2957),
    [anon_sym_json_DOTdecode] = ACTIONS(2955),
    [anon_sym_PIPE] = ACTIONS(2957),
    [anon_sym_LBRACK2] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2955),
    [anon_sym_CARET] = ACTIONS(2955),
    [anon_sym_AMP] = ACTIONS(2957),
    [anon_sym_LT_DASH] = ACTIONS(2955),
    [anon_sym_LT_LT] = ACTIONS(2955),
    [anon_sym_GT_GT] = ACTIONS(2957),
    [anon_sym_GT_GT_GT] = ACTIONS(2955),
    [anon_sym_AMP_CARET] = ACTIONS(2955),
    [anon_sym_AMP_AMP] = ACTIONS(2955),
    [anon_sym_PIPE_PIPE] = ACTIONS(2955),
    [anon_sym_or] = ACTIONS(2957),
    [sym_none] = ACTIONS(2957),
    [sym_true] = ACTIONS(2957),
    [sym_false] = ACTIONS(2957),
    [sym_nil] = ACTIONS(2957),
    [anon_sym_QMARK_DOT] = ACTIONS(2955),
    [anon_sym_POUND_LBRACK] = ACTIONS(2955),
    [anon_sym_if] = ACTIONS(2957),
    [anon_sym_DOLLARif] = ACTIONS(2957),
    [anon_sym_is] = ACTIONS(2957),
    [anon_sym_BANGis] = ACTIONS(2955),
    [anon_sym_in] = ACTIONS(2957),
    [anon_sym_BANGin] = ACTIONS(2955),
    [anon_sym_match] = ACTIONS(2957),
    [anon_sym_select] = ACTIONS(2957),
    [anon_sym_lock] = ACTIONS(2957),
    [anon_sym_rlock] = ACTIONS(2957),
    [anon_sym_unsafe] = ACTIONS(2957),
    [anon_sym_sql] = ACTIONS(2957),
    [sym_int_literal] = ACTIONS(2957),
    [sym_float_literal] = ACTIONS(2955),
    [sym_rune_literal] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2955),
    [anon_sym_DQUOTE] = ACTIONS(2955),
    [anon_sym_c_SQUOTE] = ACTIONS(2955),
    [anon_sym_c_DQUOTE] = ACTIONS(2955),
    [anon_sym_r_SQUOTE] = ACTIONS(2955),
    [anon_sym_r_DQUOTE] = ACTIONS(2955),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2957),
    [anon_sym_shared] = ACTIONS(2957),
    [anon_sym_map_LBRACK] = ACTIONS(2955),
    [anon_sym_chan] = ACTIONS(2957),
    [anon_sym_thread] = ACTIONS(2957),
    [anon_sym_atomic] = ACTIONS(2957),
  },
  [1689] = {
    [sym_line_comment] = STATE(1689),
    [sym_block_comment] = STATE(1689),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2837),
    [anon_sym_as] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_COMMA] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_fn] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2837),
    [anon_sym_DASH] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2835),
    [anon_sym_SLASH] = ACTIONS(2837),
    [anon_sym_PERCENT] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(2835),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2835),
    [anon_sym_GT_EQ] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_struct] = ACTIONS(2837),
    [anon_sym_mut] = ACTIONS(2837),
    [anon_sym_COLON] = ACTIONS(2835),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_QMARK] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(2837),
    [anon_sym_go] = ACTIONS(2837),
    [anon_sym_spawn] = ACTIONS(2837),
    [anon_sym_json_DOTdecode] = ACTIONS(2835),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_LBRACK2] = ACTIONS(2837),
    [anon_sym_TILDE] = ACTIONS(2835),
    [anon_sym_CARET] = ACTIONS(2835),
    [anon_sym_AMP] = ACTIONS(2837),
    [anon_sym_LT_DASH] = ACTIONS(2835),
    [anon_sym_LT_LT] = ACTIONS(2835),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_GT_GT_GT] = ACTIONS(2835),
    [anon_sym_AMP_CARET] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_or] = ACTIONS(2837),
    [sym_none] = ACTIONS(2837),
    [sym_true] = ACTIONS(2837),
    [sym_false] = ACTIONS(2837),
    [sym_nil] = ACTIONS(2837),
    [anon_sym_QMARK_DOT] = ACTIONS(2835),
    [anon_sym_POUND_LBRACK] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_DOLLARif] = ACTIONS(2837),
    [anon_sym_is] = ACTIONS(2837),
    [anon_sym_BANGis] = ACTIONS(2835),
    [anon_sym_in] = ACTIONS(2837),
    [anon_sym_BANGin] = ACTIONS(2835),
    [anon_sym_match] = ACTIONS(2837),
    [anon_sym_select] = ACTIONS(2837),
    [anon_sym_lock] = ACTIONS(2837),
    [anon_sym_rlock] = ACTIONS(2837),
    [anon_sym_unsafe] = ACTIONS(2837),
    [anon_sym_sql] = ACTIONS(2837),
    [sym_int_literal] = ACTIONS(2837),
    [sym_float_literal] = ACTIONS(2835),
    [sym_rune_literal] = ACTIONS(2835),
    [anon_sym_SQUOTE] = ACTIONS(2835),
    [anon_sym_DQUOTE] = ACTIONS(2835),
    [anon_sym_c_SQUOTE] = ACTIONS(2835),
    [anon_sym_c_DQUOTE] = ACTIONS(2835),
    [anon_sym_r_SQUOTE] = ACTIONS(2835),
    [anon_sym_r_DQUOTE] = ACTIONS(2835),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2837),
    [anon_sym_shared] = ACTIONS(2837),
    [anon_sym_map_LBRACK] = ACTIONS(2835),
    [anon_sym_chan] = ACTIONS(2837),
    [anon_sym_thread] = ACTIONS(2837),
    [anon_sym_atomic] = ACTIONS(2837),
  },
  [1690] = {
    [sym_line_comment] = STATE(1690),
    [sym_block_comment] = STATE(1690),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2489),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(851),
    [anon_sym_LF] = ACTIONS(851),
    [anon_sym_CR] = ACTIONS(851),
    [anon_sym_CR_LF] = ACTIONS(851),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(851),
    [anon_sym_DOT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(851),
    [anon_sym_RBRACE] = ACTIONS(851),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym___global] = ACTIONS(851),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(851),
    [anon_sym_SLASH] = ACTIONS(851),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(851),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_pub] = ACTIONS(851),
    [anon_sym_mut] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(851),
    [anon_sym_DASH_DASH] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PIPE] = ACTIONS(851),
    [anon_sym_LBRACK2] = ACTIONS(851),
    [anon_sym_CARET] = ACTIONS(851),
    [anon_sym_AMP] = ACTIONS(851),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_CARET] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(851),
    [anon_sym_PIPE_PIPE] = ACTIONS(851),
    [anon_sym_or] = ACTIONS(851),
    [anon_sym_QMARK_DOT] = ACTIONS(851),
    [anon_sym_POUND_LBRACK] = ACTIONS(851),
    [anon_sym_is] = ACTIONS(851),
    [anon_sym_BANGis] = ACTIONS(851),
    [anon_sym_in] = ACTIONS(851),
    [anon_sym_BANGin] = ACTIONS(851),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(351),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_AT_LBRACK] = ACTIONS(851),
  },
  [1691] = {
    [sym_line_comment] = STATE(1691),
    [sym_block_comment] = STATE(1691),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2837),
    [anon_sym_as] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_COMMA] = ACTIONS(2835),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_fn] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2837),
    [anon_sym_DASH] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2835),
    [anon_sym_SLASH] = ACTIONS(2837),
    [anon_sym_PERCENT] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(2835),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2835),
    [anon_sym_GT_EQ] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_RBRACK] = ACTIONS(2835),
    [anon_sym_struct] = ACTIONS(2837),
    [anon_sym_mut] = ACTIONS(2837),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_QMARK] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(2837),
    [anon_sym_go] = ACTIONS(2837),
    [anon_sym_spawn] = ACTIONS(2837),
    [anon_sym_json_DOTdecode] = ACTIONS(2835),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_LBRACK2] = ACTIONS(2837),
    [anon_sym_TILDE] = ACTIONS(2835),
    [anon_sym_CARET] = ACTIONS(2835),
    [anon_sym_AMP] = ACTIONS(2837),
    [anon_sym_LT_DASH] = ACTIONS(2835),
    [anon_sym_LT_LT] = ACTIONS(2835),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_GT_GT_GT] = ACTIONS(2835),
    [anon_sym_AMP_CARET] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_or] = ACTIONS(2837),
    [sym_none] = ACTIONS(2837),
    [sym_true] = ACTIONS(2837),
    [sym_false] = ACTIONS(2837),
    [sym_nil] = ACTIONS(2837),
    [anon_sym_QMARK_DOT] = ACTIONS(2835),
    [anon_sym_POUND_LBRACK] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_DOLLARif] = ACTIONS(2837),
    [anon_sym_is] = ACTIONS(2837),
    [anon_sym_BANGis] = ACTIONS(2835),
    [anon_sym_in] = ACTIONS(2837),
    [anon_sym_BANGin] = ACTIONS(2835),
    [anon_sym_match] = ACTIONS(2837),
    [anon_sym_select] = ACTIONS(2837),
    [anon_sym_lock] = ACTIONS(2837),
    [anon_sym_rlock] = ACTIONS(2837),
    [anon_sym_unsafe] = ACTIONS(2837),
    [anon_sym_sql] = ACTIONS(2837),
    [sym_int_literal] = ACTIONS(2837),
    [sym_float_literal] = ACTIONS(2835),
    [sym_rune_literal] = ACTIONS(2835),
    [anon_sym_SQUOTE] = ACTIONS(2835),
    [anon_sym_DQUOTE] = ACTIONS(2835),
    [anon_sym_c_SQUOTE] = ACTIONS(2835),
    [anon_sym_c_DQUOTE] = ACTIONS(2835),
    [anon_sym_r_SQUOTE] = ACTIONS(2835),
    [anon_sym_r_DQUOTE] = ACTIONS(2835),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2837),
    [anon_sym_shared] = ACTIONS(2837),
    [anon_sym_map_LBRACK] = ACTIONS(2835),
    [anon_sym_chan] = ACTIONS(2837),
    [anon_sym_thread] = ACTIONS(2837),
    [anon_sym_atomic] = ACTIONS(2837),
  },
  [1692] = {
    [sym_line_comment] = STATE(1692),
    [sym_block_comment] = STATE(1692),
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3045),
    [anon_sym_as] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_fn] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3043),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_PERCENT] = ACTIONS(3043),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_GT] = ACTIONS(3045),
    [anon_sym_EQ_EQ] = ACTIONS(3043),
    [anon_sym_BANG_EQ] = ACTIONS(3043),
    [anon_sym_LT_EQ] = ACTIONS(3043),
    [anon_sym_GT_EQ] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_RBRACK] = ACTIONS(4322),
    [anon_sym_struct] = ACTIONS(3045),
    [anon_sym_mut] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3045),
    [anon_sym_go] = ACTIONS(3045),
    [anon_sym_spawn] = ACTIONS(3045),
    [anon_sym_json_DOTdecode] = ACTIONS(3043),
    [anon_sym_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACK2] = ACTIONS(3045),
    [anon_sym_TILDE] = ACTIONS(3043),
    [anon_sym_CARET] = ACTIONS(3043),
    [anon_sym_AMP] = ACTIONS(3045),
    [anon_sym_LT_DASH] = ACTIONS(3043),
    [anon_sym_LT_LT] = ACTIONS(3043),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_GT_GT_GT] = ACTIONS(3043),
    [anon_sym_AMP_CARET] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [anon_sym_or] = ACTIONS(3045),
    [sym_none] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_nil] = ACTIONS(3045),
    [anon_sym_QMARK_DOT] = ACTIONS(3043),
    [anon_sym_POUND_LBRACK] = ACTIONS(3043),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_DOLLARif] = ACTIONS(3045),
    [anon_sym_is] = ACTIONS(3045),
    [anon_sym_BANGis] = ACTIONS(3043),
    [anon_sym_in] = ACTIONS(3045),
    [anon_sym_BANGin] = ACTIONS(3043),
    [anon_sym_match] = ACTIONS(3045),
    [anon_sym_select] = ACTIONS(3045),
    [anon_sym_lock] = ACTIONS(3045),
    [anon_sym_rlock] = ACTIONS(3045),
    [anon_sym_unsafe] = ACTIONS(3045),
    [anon_sym_sql] = ACTIONS(3045),
    [sym_int_literal] = ACTIONS(3045),
    [sym_float_literal] = ACTIONS(3043),
    [sym_rune_literal] = ACTIONS(3043),
    [anon_sym_SQUOTE] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [anon_sym_c_SQUOTE] = ACTIONS(3043),
    [anon_sym_c_DQUOTE] = ACTIONS(3043),
    [anon_sym_r_SQUOTE] = ACTIONS(3043),
    [anon_sym_r_DQUOTE] = ACTIONS(3043),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3045),
    [anon_sym_shared] = ACTIONS(3045),
    [anon_sym_map_LBRACK] = ACTIONS(3043),
    [anon_sym_chan] = ACTIONS(3045),
    [anon_sym_thread] = ACTIONS(3045),
    [anon_sym_atomic] = ACTIONS(3045),
  },
  [1693] = {
    [sym_line_comment] = STATE(1693),
    [sym_block_comment] = STATE(1693),
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_as] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_fn] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3043),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_PERCENT] = ACTIONS(3043),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_GT] = ACTIONS(3045),
    [anon_sym_EQ_EQ] = ACTIONS(3043),
    [anon_sym_BANG_EQ] = ACTIONS(3043),
    [anon_sym_LT_EQ] = ACTIONS(3043),
    [anon_sym_GT_EQ] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_RBRACK] = ACTIONS(4322),
    [anon_sym_struct] = ACTIONS(3045),
    [anon_sym_mut] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3045),
    [anon_sym_go] = ACTIONS(3045),
    [anon_sym_spawn] = ACTIONS(3045),
    [anon_sym_json_DOTdecode] = ACTIONS(3043),
    [anon_sym_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACK2] = ACTIONS(3045),
    [anon_sym_TILDE] = ACTIONS(3043),
    [anon_sym_CARET] = ACTIONS(3043),
    [anon_sym_AMP] = ACTIONS(3045),
    [anon_sym_LT_DASH] = ACTIONS(3043),
    [anon_sym_LT_LT] = ACTIONS(3043),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_GT_GT_GT] = ACTIONS(3043),
    [anon_sym_AMP_CARET] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [anon_sym_or] = ACTIONS(3045),
    [sym_none] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_nil] = ACTIONS(3045),
    [anon_sym_QMARK_DOT] = ACTIONS(3043),
    [anon_sym_POUND_LBRACK] = ACTIONS(3043),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_DOLLARif] = ACTIONS(3045),
    [anon_sym_is] = ACTIONS(3045),
    [anon_sym_BANGis] = ACTIONS(3043),
    [anon_sym_in] = ACTIONS(3045),
    [anon_sym_BANGin] = ACTIONS(3043),
    [anon_sym_match] = ACTIONS(3045),
    [anon_sym_select] = ACTIONS(3045),
    [anon_sym_lock] = ACTIONS(3045),
    [anon_sym_rlock] = ACTIONS(3045),
    [anon_sym_unsafe] = ACTIONS(3045),
    [anon_sym_sql] = ACTIONS(3045),
    [sym_int_literal] = ACTIONS(3045),
    [sym_float_literal] = ACTIONS(3043),
    [sym_rune_literal] = ACTIONS(3043),
    [anon_sym_SQUOTE] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [anon_sym_c_SQUOTE] = ACTIONS(3043),
    [anon_sym_c_DQUOTE] = ACTIONS(3043),
    [anon_sym_r_SQUOTE] = ACTIONS(3043),
    [anon_sym_r_DQUOTE] = ACTIONS(3043),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3045),
    [anon_sym_shared] = ACTIONS(3045),
    [anon_sym_map_LBRACK] = ACTIONS(3043),
    [anon_sym_chan] = ACTIONS(3045),
    [anon_sym_thread] = ACTIONS(3045),
    [anon_sym_atomic] = ACTIONS(3045),
  },
  [1694] = {
    [sym_line_comment] = STATE(1694),
    [sym_block_comment] = STATE(1694),
    [sym_reference_expression] = STATE(4545),
    [sym_type_reference_expression] = STATE(2244),
    [sym_plain_type] = STATE(2361),
    [sym__plain_type_without_special] = STATE(2366),
    [sym_anon_struct_type] = STATE(2365),
    [sym_multi_return_type] = STATE(2366),
    [sym_result_type] = STATE(2366),
    [sym_option_type] = STATE(2366),
    [sym_qualified_type] = STATE(2244),
    [sym_fixed_array_type] = STATE(2365),
    [sym_array_type] = STATE(2365),
    [sym_pointer_type] = STATE(2365),
    [sym_wrong_pointer_type] = STATE(2365),
    [sym_map_type] = STATE(2365),
    [sym_channel_type] = STATE(2365),
    [sym_shared_type] = STATE(2365),
    [sym_thread_type] = STATE(2365),
    [sym_atomic_type] = STATE(2365),
    [sym_generic_type] = STATE(2365),
    [sym_function_type] = STATE(2365),
    [sym_identifier] = ACTIONS(4325),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_CR] = ACTIONS(821),
    [anon_sym_CR_LF] = ACTIONS(821),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(821),
    [anon_sym_DOT] = ACTIONS(821),
    [anon_sym_as] = ACTIONS(821),
    [anon_sym_COMMA] = ACTIONS(821),
    [anon_sym_RBRACE] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(4327),
    [anon_sym___global] = ACTIONS(821),
    [anon_sym_fn] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(821),
    [anon_sym_DASH] = ACTIONS(821),
    [anon_sym_STAR] = ACTIONS(4331),
    [anon_sym_SLASH] = ACTIONS(821),
    [anon_sym_PERCENT] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(821),
    [anon_sym_GT] = ACTIONS(821),
    [anon_sym_EQ_EQ] = ACTIONS(821),
    [anon_sym_BANG_EQ] = ACTIONS(821),
    [anon_sym_LT_EQ] = ACTIONS(821),
    [anon_sym_GT_EQ] = ACTIONS(821),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(817),
    [anon_sym_struct] = ACTIONS(4333),
    [anon_sym_pub] = ACTIONS(821),
    [anon_sym_mut] = ACTIONS(821),
    [anon_sym_PLUS_PLUS] = ACTIONS(821),
    [anon_sym_DASH_DASH] = ACTIONS(821),
    [anon_sym_QMARK] = ACTIONS(4335),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PIPE] = ACTIONS(821),
    [anon_sym_LBRACK2] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_LT_LT] = ACTIONS(821),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_GT_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_CARET] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_or] = ACTIONS(821),
    [anon_sym_QMARK_DOT] = ACTIONS(821),
    [anon_sym_POUND_LBRACK] = ACTIONS(821),
    [anon_sym_is] = ACTIONS(821),
    [anon_sym_BANGis] = ACTIONS(821),
    [anon_sym_in] = ACTIONS(821),
    [anon_sym_BANGin] = ACTIONS(821),
    [anon_sym_shared] = ACTIONS(4343),
    [anon_sym_map_LBRACK] = ACTIONS(4345),
    [anon_sym_chan] = ACTIONS(4347),
    [anon_sym_thread] = ACTIONS(4349),
    [anon_sym_atomic] = ACTIONS(4351),
    [anon_sym_AT_LBRACK] = ACTIONS(821),
  },
  [1695] = {
    [sym_line_comment] = STATE(1695),
    [sym_block_comment] = STATE(1695),
    [sym_reference_expression] = STATE(4545),
    [sym_type_reference_expression] = STATE(2244),
    [sym_plain_type] = STATE(2259),
    [sym__plain_type_without_special] = STATE(2366),
    [sym_anon_struct_type] = STATE(2365),
    [sym_multi_return_type] = STATE(2366),
    [sym_result_type] = STATE(2366),
    [sym_option_type] = STATE(2366),
    [sym_qualified_type] = STATE(2244),
    [sym_fixed_array_type] = STATE(2365),
    [sym_array_type] = STATE(2365),
    [sym_pointer_type] = STATE(2365),
    [sym_wrong_pointer_type] = STATE(2365),
    [sym_map_type] = STATE(2365),
    [sym_channel_type] = STATE(2365),
    [sym_shared_type] = STATE(2365),
    [sym_thread_type] = STATE(2365),
    [sym_atomic_type] = STATE(2365),
    [sym_generic_type] = STATE(2365),
    [sym_function_type] = STATE(2365),
    [sym_identifier] = ACTIONS(4325),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_CR] = ACTIONS(859),
    [anon_sym_CR_LF] = ACTIONS(859),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(859),
    [anon_sym_as] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(4327),
    [anon_sym___global] = ACTIONS(859),
    [anon_sym_fn] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(4331),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(859),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_struct] = ACTIONS(4333),
    [anon_sym_pub] = ACTIONS(859),
    [anon_sym_mut] = ACTIONS(859),
    [anon_sym_PLUS_PLUS] = ACTIONS(859),
    [anon_sym_DASH_DASH] = ACTIONS(859),
    [anon_sym_QMARK] = ACTIONS(4335),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PIPE] = ACTIONS(859),
    [anon_sym_LBRACK2] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_GT_GT_GT] = ACTIONS(859),
    [anon_sym_AMP_CARET] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_or] = ACTIONS(859),
    [anon_sym_QMARK_DOT] = ACTIONS(859),
    [anon_sym_POUND_LBRACK] = ACTIONS(859),
    [anon_sym_is] = ACTIONS(859),
    [anon_sym_BANGis] = ACTIONS(859),
    [anon_sym_in] = ACTIONS(859),
    [anon_sym_BANGin] = ACTIONS(859),
    [anon_sym_shared] = ACTIONS(4343),
    [anon_sym_map_LBRACK] = ACTIONS(4345),
    [anon_sym_chan] = ACTIONS(4347),
    [anon_sym_thread] = ACTIONS(4349),
    [anon_sym_atomic] = ACTIONS(4351),
    [anon_sym_AT_LBRACK] = ACTIONS(859),
  },
  [1696] = {
    [sym_line_comment] = STATE(1696),
    [sym_block_comment] = STATE(1696),
    [sym_reference_expression] = STATE(4545),
    [sym_type_reference_expression] = STATE(2244),
    [sym_plain_type] = STATE(2321),
    [sym__plain_type_without_special] = STATE(2366),
    [sym_anon_struct_type] = STATE(2365),
    [sym_multi_return_type] = STATE(2366),
    [sym_result_type] = STATE(2366),
    [sym_option_type] = STATE(2366),
    [sym_qualified_type] = STATE(2244),
    [sym_fixed_array_type] = STATE(2365),
    [sym_array_type] = STATE(2365),
    [sym_pointer_type] = STATE(2365),
    [sym_wrong_pointer_type] = STATE(2365),
    [sym_map_type] = STATE(2365),
    [sym_channel_type] = STATE(2365),
    [sym_shared_type] = STATE(2365),
    [sym_thread_type] = STATE(2365),
    [sym_atomic_type] = STATE(2365),
    [sym_generic_type] = STATE(2365),
    [sym_function_type] = STATE(2365),
    [sym_identifier] = ACTIONS(4325),
    [anon_sym_LF] = ACTIONS(855),
    [anon_sym_CR] = ACTIONS(855),
    [anon_sym_CR_LF] = ACTIONS(855),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(855),
    [anon_sym_DOT] = ACTIONS(855),
    [anon_sym_as] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(855),
    [anon_sym_RBRACE] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(4327),
    [anon_sym___global] = ACTIONS(855),
    [anon_sym_fn] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(4331),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_PERCENT] = ACTIONS(855),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_GT] = ACTIONS(855),
    [anon_sym_EQ_EQ] = ACTIONS(855),
    [anon_sym_BANG_EQ] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(855),
    [anon_sym_GT_EQ] = ACTIONS(855),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_struct] = ACTIONS(4333),
    [anon_sym_pub] = ACTIONS(855),
    [anon_sym_mut] = ACTIONS(855),
    [anon_sym_PLUS_PLUS] = ACTIONS(855),
    [anon_sym_DASH_DASH] = ACTIONS(855),
    [anon_sym_QMARK] = ACTIONS(4335),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PIPE] = ACTIONS(855),
    [anon_sym_LBRACK2] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(855),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_LT_LT] = ACTIONS(855),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_GT_GT_GT] = ACTIONS(855),
    [anon_sym_AMP_CARET] = ACTIONS(855),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_PIPE_PIPE] = ACTIONS(855),
    [anon_sym_or] = ACTIONS(855),
    [anon_sym_QMARK_DOT] = ACTIONS(855),
    [anon_sym_POUND_LBRACK] = ACTIONS(855),
    [anon_sym_is] = ACTIONS(855),
    [anon_sym_BANGis] = ACTIONS(855),
    [anon_sym_in] = ACTIONS(855),
    [anon_sym_BANGin] = ACTIONS(855),
    [anon_sym_shared] = ACTIONS(4343),
    [anon_sym_map_LBRACK] = ACTIONS(4345),
    [anon_sym_chan] = ACTIONS(4347),
    [anon_sym_thread] = ACTIONS(4349),
    [anon_sym_atomic] = ACTIONS(4351),
    [anon_sym_AT_LBRACK] = ACTIONS(855),
  },
  [1697] = {
    [sym_line_comment] = STATE(1697),
    [sym_block_comment] = STATE(1697),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2458),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_LF] = ACTIONS(865),
    [anon_sym_CR] = ACTIONS(865),
    [anon_sym_CR_LF] = ACTIONS(865),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(865),
    [anon_sym_COMMA] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(865),
    [anon_sym_LPAREN] = ACTIONS(867),
    [anon_sym___global] = ACTIONS(865),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_STAR] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_PERCENT] = ACTIONS(865),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(865),
    [anon_sym_BANG_EQ] = ACTIONS(865),
    [anon_sym_LT_EQ] = ACTIONS(865),
    [anon_sym_GT_EQ] = ACTIONS(865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_pub] = ACTIONS(865),
    [anon_sym_mut] = ACTIONS(865),
    [anon_sym_PLUS_PLUS] = ACTIONS(865),
    [anon_sym_DASH_DASH] = ACTIONS(865),
    [anon_sym_QMARK] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(4353),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_LBRACK2] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(865),
    [anon_sym_GT_GT] = ACTIONS(865),
    [anon_sym_GT_GT_GT] = ACTIONS(865),
    [anon_sym_AMP_CARET] = ACTIONS(865),
    [anon_sym_AMP_AMP] = ACTIONS(865),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_QMARK_DOT] = ACTIONS(865),
    [anon_sym_POUND_LBRACK] = ACTIONS(865),
    [anon_sym_is] = ACTIONS(865),
    [anon_sym_BANGis] = ACTIONS(865),
    [anon_sym_in] = ACTIONS(865),
    [anon_sym_BANGin] = ACTIONS(865),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(351),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_AT_LBRACK] = ACTIONS(865),
  },
  [1698] = {
    [sym_line_comment] = STATE(1698),
    [sym_block_comment] = STATE(1698),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_as] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2145),
    [anon_sym_BANG_EQ] = ACTIONS(2145),
    [anon_sym_LT_EQ] = ACTIONS(2145),
    [anon_sym_GT_EQ] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_RBRACK] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2145),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2145),
    [anon_sym_LT_LT] = ACTIONS(2145),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2145),
    [anon_sym_AMP_CARET] = ACTIONS(2145),
    [anon_sym_AMP_AMP] = ACTIONS(2145),
    [anon_sym_PIPE_PIPE] = ACTIONS(2145),
    [anon_sym_or] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_QMARK_DOT] = ACTIONS(2145),
    [anon_sym_POUND_LBRACK] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_is] = ACTIONS(2147),
    [anon_sym_BANGis] = ACTIONS(2145),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANGin] = ACTIONS(2145),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2145),
    [sym_rune_literal] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_c_SQUOTE] = ACTIONS(2145),
    [anon_sym_c_DQUOTE] = ACTIONS(2145),
    [anon_sym_r_SQUOTE] = ACTIONS(2145),
    [anon_sym_r_DQUOTE] = ACTIONS(2145),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2145),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
  },
  [1699] = {
    [sym_line_comment] = STATE(1699),
    [sym_block_comment] = STATE(1699),
    [sym_type_parameters] = STATE(1746),
    [ts_builtin_sym_end] = ACTIONS(2185),
    [sym_identifier] = ACTIONS(2187),
    [anon_sym_LF] = ACTIONS(2187),
    [anon_sym_CR] = ACTIONS(2187),
    [anon_sym_CR_LF] = ACTIONS(2187),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_const] = ACTIONS(2187),
    [anon_sym_LPAREN] = ACTIONS(2187),
    [anon_sym___global] = ACTIONS(2187),
    [anon_sym_type] = ACTIONS(2187),
    [anon_sym_fn] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(4355),
    [anon_sym_struct] = ACTIONS(2187),
    [anon_sym_union] = ACTIONS(2187),
    [anon_sym_pub] = ACTIONS(2187),
    [anon_sym_mut] = ACTIONS(2187),
    [anon_sym_enum] = ACTIONS(2187),
    [anon_sym_interface] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_go] = ACTIONS(2187),
    [anon_sym_spawn] = ACTIONS(2187),
    [anon_sym_json_DOTdecode] = ACTIONS(2187),
    [anon_sym_LBRACK2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_LT_DASH] = ACTIONS(2187),
    [sym_none] = ACTIONS(2187),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [sym_nil] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_DOLLARif] = ACTIONS(2187),
    [anon_sym_match] = ACTIONS(2187),
    [anon_sym_select] = ACTIONS(2187),
    [anon_sym_lock] = ACTIONS(2187),
    [anon_sym_rlock] = ACTIONS(2187),
    [anon_sym_unsafe] = ACTIONS(2187),
    [anon_sym_sql] = ACTIONS(2187),
    [sym_int_literal] = ACTIONS(2187),
    [sym_float_literal] = ACTIONS(2187),
    [sym_rune_literal] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(2187),
    [anon_sym_DQUOTE] = ACTIONS(2187),
    [anon_sym_c_SQUOTE] = ACTIONS(2187),
    [anon_sym_c_DQUOTE] = ACTIONS(2187),
    [anon_sym_r_SQUOTE] = ACTIONS(2187),
    [anon_sym_r_DQUOTE] = ACTIONS(2187),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2187),
    [anon_sym_shared] = ACTIONS(2187),
    [aux_sym_sum_type_token1] = ACTIONS(2187),
    [anon_sym_PIPE2] = ACTIONS(2185),
    [anon_sym_map_LBRACK] = ACTIONS(2187),
    [anon_sym_chan] = ACTIONS(2187),
    [anon_sym_thread] = ACTIONS(2187),
    [anon_sym_atomic] = ACTIONS(2187),
    [anon_sym_assert] = ACTIONS(2187),
    [anon_sym_defer] = ACTIONS(2187),
    [anon_sym_goto] = ACTIONS(2187),
    [anon_sym_break] = ACTIONS(2187),
    [anon_sym_continue] = ACTIONS(2187),
    [anon_sym_return] = ACTIONS(2187),
    [anon_sym_DOLLARfor] = ACTIONS(2187),
    [anon_sym_for] = ACTIONS(2187),
    [anon_sym_POUND] = ACTIONS(2187),
    [anon_sym_asm] = ACTIONS(2187),
    [anon_sym_AT_LBRACK] = ACTIONS(2187),
  },
  [1700] = {
    [sym_line_comment] = STATE(1700),
    [sym_block_comment] = STATE(1700),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(2395),
    [sym_plain_type] = STATE(2441),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(2395),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(4357),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_DOT] = ACTIONS(859),
    [anon_sym_as] = ACTIONS(859),
    [anon_sym_LBRACE] = ACTIONS(857),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(3968),
    [anon_sym_RPAREN] = ACTIONS(857),
    [anon_sym_fn] = ACTIONS(4359),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(4361),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_EQ_EQ] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(857),
    [anon_sym_LT_EQ] = ACTIONS(857),
    [anon_sym_GT_EQ] = ACTIONS(857),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(857),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_COLON] = ACTIONS(859),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_QMARK] = ACTIONS(4363),
    [anon_sym_BANG] = ACTIONS(4365),
    [anon_sym_PIPE] = ACTIONS(859),
    [anon_sym_LBRACK2] = ACTIONS(4367),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(4369),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_GT_GT_GT] = ACTIONS(857),
    [anon_sym_AMP_CARET] = ACTIONS(857),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [anon_sym_or] = ACTIONS(859),
    [anon_sym_QMARK_DOT] = ACTIONS(857),
    [anon_sym_POUND_LBRACK] = ACTIONS(857),
    [anon_sym_is] = ACTIONS(859),
    [anon_sym_BANGis] = ACTIONS(857),
    [anon_sym_in] = ACTIONS(859),
    [anon_sym_BANGin] = ACTIONS(857),
    [anon_sym_COLON_EQ] = ACTIONS(857),
    [anon_sym_shared] = ACTIONS(4371),
    [anon_sym_map_LBRACK] = ACTIONS(4373),
    [anon_sym_chan] = ACTIONS(4375),
    [anon_sym_thread] = ACTIONS(4377),
    [anon_sym_atomic] = ACTIONS(4379),
    [anon_sym_DOT_DOT] = ACTIONS(857),
  },
  [1701] = {
    [sym_line_comment] = STATE(1701),
    [sym_block_comment] = STATE(1701),
    [ts_builtin_sym_end] = ACTIONS(2371),
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2373),
    [anon_sym_CR] = ACTIONS(2373),
    [anon_sym_CR_LF] = ACTIONS(2373),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym___global] = ACTIONS(2373),
    [anon_sym_type] = ACTIONS(2373),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_pub] = ACTIONS(2373),
    [anon_sym_mut] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_QMARK] = ACTIONS(2373),
    [anon_sym_BANG] = ACTIONS(2373),
    [anon_sym_go] = ACTIONS(2373),
    [anon_sym_spawn] = ACTIONS(2373),
    [anon_sym_json_DOTdecode] = ACTIONS(2373),
    [anon_sym_LBRACK2] = ACTIONS(2373),
    [anon_sym_TILDE] = ACTIONS(2373),
    [anon_sym_CARET] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_LT_DASH] = ACTIONS(2373),
    [sym_none] = ACTIONS(2373),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [sym_nil] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_DOLLARif] = ACTIONS(2373),
    [anon_sym_match] = ACTIONS(2373),
    [anon_sym_select] = ACTIONS(2373),
    [anon_sym_lock] = ACTIONS(2373),
    [anon_sym_rlock] = ACTIONS(2373),
    [anon_sym_unsafe] = ACTIONS(2373),
    [anon_sym_sql] = ACTIONS(2373),
    [sym_int_literal] = ACTIONS(2373),
    [sym_float_literal] = ACTIONS(2373),
    [sym_rune_literal] = ACTIONS(2373),
    [anon_sym_SQUOTE] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(2373),
    [anon_sym_c_SQUOTE] = ACTIONS(2373),
    [anon_sym_c_DQUOTE] = ACTIONS(2373),
    [anon_sym_r_SQUOTE] = ACTIONS(2373),
    [anon_sym_r_DQUOTE] = ACTIONS(2373),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [aux_sym_sum_type_token1] = ACTIONS(2373),
    [anon_sym_PIPE2] = ACTIONS(2371),
    [anon_sym_map_LBRACK] = ACTIONS(2373),
    [anon_sym_chan] = ACTIONS(2373),
    [anon_sym_thread] = ACTIONS(2373),
    [anon_sym_atomic] = ACTIONS(2373),
    [anon_sym_assert] = ACTIONS(2373),
    [anon_sym_defer] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_DOLLARfor] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_POUND] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym_AT_LBRACK] = ACTIONS(2373),
  },
  [1702] = {
    [sym_line_comment] = STATE(1702),
    [sym_block_comment] = STATE(1702),
    [aux_sym_sum_type_repeat1] = STATE(1705),
    [ts_builtin_sym_end] = ACTIONS(4381),
    [sym_identifier] = ACTIONS(4383),
    [anon_sym_LF] = ACTIONS(4383),
    [anon_sym_CR] = ACTIONS(4383),
    [anon_sym_CR_LF] = ACTIONS(4383),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4383),
    [anon_sym_const] = ACTIONS(4383),
    [anon_sym_LPAREN] = ACTIONS(4383),
    [anon_sym___global] = ACTIONS(4383),
    [anon_sym_type] = ACTIONS(4383),
    [anon_sym_fn] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_DASH] = ACTIONS(4383),
    [anon_sym_STAR] = ACTIONS(4383),
    [anon_sym_struct] = ACTIONS(4383),
    [anon_sym_union] = ACTIONS(4383),
    [anon_sym_pub] = ACTIONS(4383),
    [anon_sym_mut] = ACTIONS(4383),
    [anon_sym_enum] = ACTIONS(4383),
    [anon_sym_interface] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4383),
    [anon_sym_BANG] = ACTIONS(4383),
    [anon_sym_go] = ACTIONS(4383),
    [anon_sym_spawn] = ACTIONS(4383),
    [anon_sym_json_DOTdecode] = ACTIONS(4383),
    [anon_sym_LBRACK2] = ACTIONS(4383),
    [anon_sym_TILDE] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4383),
    [anon_sym_LT_DASH] = ACTIONS(4383),
    [sym_none] = ACTIONS(4383),
    [sym_true] = ACTIONS(4383),
    [sym_false] = ACTIONS(4383),
    [sym_nil] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_DOLLARif] = ACTIONS(4383),
    [anon_sym_match] = ACTIONS(4383),
    [anon_sym_select] = ACTIONS(4383),
    [anon_sym_lock] = ACTIONS(4383),
    [anon_sym_rlock] = ACTIONS(4383),
    [anon_sym_unsafe] = ACTIONS(4383),
    [anon_sym_sql] = ACTIONS(4383),
    [sym_int_literal] = ACTIONS(4383),
    [sym_float_literal] = ACTIONS(4383),
    [sym_rune_literal] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(4383),
    [anon_sym_DQUOTE] = ACTIONS(4383),
    [anon_sym_c_SQUOTE] = ACTIONS(4383),
    [anon_sym_c_DQUOTE] = ACTIONS(4383),
    [anon_sym_r_SQUOTE] = ACTIONS(4383),
    [anon_sym_r_DQUOTE] = ACTIONS(4383),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4383),
    [anon_sym_shared] = ACTIONS(4383),
    [aux_sym_sum_type_token1] = ACTIONS(4385),
    [anon_sym_PIPE2] = ACTIONS(4387),
    [anon_sym_map_LBRACK] = ACTIONS(4383),
    [anon_sym_chan] = ACTIONS(4383),
    [anon_sym_thread] = ACTIONS(4383),
    [anon_sym_atomic] = ACTIONS(4383),
    [anon_sym_assert] = ACTIONS(4383),
    [anon_sym_defer] = ACTIONS(4383),
    [anon_sym_goto] = ACTIONS(4383),
    [anon_sym_break] = ACTIONS(4383),
    [anon_sym_continue] = ACTIONS(4383),
    [anon_sym_return] = ACTIONS(4383),
    [anon_sym_DOLLARfor] = ACTIONS(4383),
    [anon_sym_for] = ACTIONS(4383),
    [anon_sym_POUND] = ACTIONS(4383),
    [anon_sym_asm] = ACTIONS(4383),
    [anon_sym_AT_LBRACK] = ACTIONS(4383),
  },
  [1703] = {
    [sym_line_comment] = STATE(1703),
    [sym_block_comment] = STATE(1703),
    [aux_sym_sum_type_repeat1] = STATE(1702),
    [ts_builtin_sym_end] = ACTIONS(4389),
    [sym_identifier] = ACTIONS(4391),
    [anon_sym_LF] = ACTIONS(4391),
    [anon_sym_CR] = ACTIONS(4391),
    [anon_sym_CR_LF] = ACTIONS(4391),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(4391),
    [anon_sym_const] = ACTIONS(4391),
    [anon_sym_LPAREN] = ACTIONS(4391),
    [anon_sym___global] = ACTIONS(4391),
    [anon_sym_type] = ACTIONS(4391),
    [anon_sym_fn] = ACTIONS(4391),
    [anon_sym_PLUS] = ACTIONS(4391),
    [anon_sym_DASH] = ACTIONS(4391),
    [anon_sym_STAR] = ACTIONS(4391),
    [anon_sym_struct] = ACTIONS(4391),
    [anon_sym_union] = ACTIONS(4391),
    [anon_sym_pub] = ACTIONS(4391),
    [anon_sym_mut] = ACTIONS(4391),
    [anon_sym_enum] = ACTIONS(4391),
    [anon_sym_interface] = ACTIONS(4391),
    [anon_sym_QMARK] = ACTIONS(4391),
    [anon_sym_BANG] = ACTIONS(4391),
    [anon_sym_go] = ACTIONS(4391),
    [anon_sym_spawn] = ACTIONS(4391),
    [anon_sym_json_DOTdecode] = ACTIONS(4391),
    [anon_sym_LBRACK2] = ACTIONS(4391),
    [anon_sym_TILDE] = ACTIONS(4391),
    [anon_sym_CARET] = ACTIONS(4391),
    [anon_sym_AMP] = ACTIONS(4391),
    [anon_sym_LT_DASH] = ACTIONS(4391),
    [sym_none] = ACTIONS(4391),
    [sym_true] = ACTIONS(4391),
    [sym_false] = ACTIONS(4391),
    [sym_nil] = ACTIONS(4391),
    [anon_sym_if] = ACTIONS(4391),
    [anon_sym_DOLLARif] = ACTIONS(4391),
    [anon_sym_match] = ACTIONS(4391),
    [anon_sym_select] = ACTIONS(4391),
    [anon_sym_lock] = ACTIONS(4391),
    [anon_sym_rlock] = ACTIONS(4391),
    [anon_sym_unsafe] = ACTIONS(4391),
    [anon_sym_sql] = ACTIONS(4391),
    [sym_int_literal] = ACTIONS(4391),
    [sym_float_literal] = ACTIONS(4391),
    [sym_rune_literal] = ACTIONS(4391),
    [anon_sym_SQUOTE] = ACTIONS(4391),
    [anon_sym_DQUOTE] = ACTIONS(4391),
    [anon_sym_c_SQUOTE] = ACTIONS(4391),
    [anon_sym_c_DQUOTE] = ACTIONS(4391),
    [anon_sym_r_SQUOTE] = ACTIONS(4391),
    [anon_sym_r_DQUOTE] = ACTIONS(4391),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4391),
    [anon_sym_shared] = ACTIONS(4391),
    [aux_sym_sum_type_token1] = ACTIONS(4385),
    [anon_sym_PIPE2] = ACTIONS(4387),
    [anon_sym_map_LBRACK] = ACTIONS(4391),
    [anon_sym_chan] = ACTIONS(4391),
    [anon_sym_thread] = ACTIONS(4391),
    [anon_sym_atomic] = ACTIONS(4391),
    [anon_sym_assert] = ACTIONS(4391),
    [anon_sym_defer] = ACTIONS(4391),
    [anon_sym_goto] = ACTIONS(4391),
    [anon_sym_break] = ACTIONS(4391),
    [anon_sym_continue] = ACTIONS(4391),
    [anon_sym_return] = ACTIONS(4391),
    [anon_sym_DOLLARfor] = ACTIONS(4391),
    [anon_sym_for] = ACTIONS(4391),
    [anon_sym_POUND] = ACTIONS(4391),
    [anon_sym_asm] = ACTIONS(4391),
    [anon_sym_AT_LBRACK] = ACTIONS(4391),
  },
  [1704] = {
    [sym_line_comment] = STATE(1704),
    [sym_block_comment] = STATE(1704),
    [aux_sym_sum_type_repeat1] = STATE(1702),
    [ts_builtin_sym_end] = ACTIONS(4393),
    [sym_identifier] = ACTIONS(4395),
    [anon_sym_LF] = ACTIONS(4395),
    [anon_sym_CR] = ACTIONS(4395),
    [anon_sym_CR_LF] = ACTIONS(4395),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(4395),
    [anon_sym_const] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym___global] = ACTIONS(4395),
    [anon_sym_type] = ACTIONS(4395),
    [anon_sym_fn] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4395),
    [anon_sym_DASH] = ACTIONS(4395),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_struct] = ACTIONS(4395),
    [anon_sym_union] = ACTIONS(4395),
    [anon_sym_pub] = ACTIONS(4395),
    [anon_sym_mut] = ACTIONS(4395),
    [anon_sym_enum] = ACTIONS(4395),
    [anon_sym_interface] = ACTIONS(4395),
    [anon_sym_QMARK] = ACTIONS(4395),
    [anon_sym_BANG] = ACTIONS(4395),
    [anon_sym_go] = ACTIONS(4395),
    [anon_sym_spawn] = ACTIONS(4395),
    [anon_sym_json_DOTdecode] = ACTIONS(4395),
    [anon_sym_LBRACK2] = ACTIONS(4395),
    [anon_sym_TILDE] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_AMP] = ACTIONS(4395),
    [anon_sym_LT_DASH] = ACTIONS(4395),
    [sym_none] = ACTIONS(4395),
    [sym_true] = ACTIONS(4395),
    [sym_false] = ACTIONS(4395),
    [sym_nil] = ACTIONS(4395),
    [anon_sym_if] = ACTIONS(4395),
    [anon_sym_DOLLARif] = ACTIONS(4395),
    [anon_sym_match] = ACTIONS(4395),
    [anon_sym_select] = ACTIONS(4395),
    [anon_sym_lock] = ACTIONS(4395),
    [anon_sym_rlock] = ACTIONS(4395),
    [anon_sym_unsafe] = ACTIONS(4395),
    [anon_sym_sql] = ACTIONS(4395),
    [sym_int_literal] = ACTIONS(4395),
    [sym_float_literal] = ACTIONS(4395),
    [sym_rune_literal] = ACTIONS(4395),
    [anon_sym_SQUOTE] = ACTIONS(4395),
    [anon_sym_DQUOTE] = ACTIONS(4395),
    [anon_sym_c_SQUOTE] = ACTIONS(4395),
    [anon_sym_c_DQUOTE] = ACTIONS(4395),
    [anon_sym_r_SQUOTE] = ACTIONS(4395),
    [anon_sym_r_DQUOTE] = ACTIONS(4395),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4395),
    [anon_sym_shared] = ACTIONS(4395),
    [aux_sym_sum_type_token1] = ACTIONS(4385),
    [anon_sym_PIPE2] = ACTIONS(4387),
    [anon_sym_map_LBRACK] = ACTIONS(4395),
    [anon_sym_chan] = ACTIONS(4395),
    [anon_sym_thread] = ACTIONS(4395),
    [anon_sym_atomic] = ACTIONS(4395),
    [anon_sym_assert] = ACTIONS(4395),
    [anon_sym_defer] = ACTIONS(4395),
    [anon_sym_goto] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4395),
    [anon_sym_continue] = ACTIONS(4395),
    [anon_sym_return] = ACTIONS(4395),
    [anon_sym_DOLLARfor] = ACTIONS(4395),
    [anon_sym_for] = ACTIONS(4395),
    [anon_sym_POUND] = ACTIONS(4395),
    [anon_sym_asm] = ACTIONS(4395),
    [anon_sym_AT_LBRACK] = ACTIONS(4395),
  },
  [1705] = {
    [sym_line_comment] = STATE(1705),
    [sym_block_comment] = STATE(1705),
    [aux_sym_sum_type_repeat1] = STATE(1705),
    [ts_builtin_sym_end] = ACTIONS(4397),
    [sym_identifier] = ACTIONS(4399),
    [anon_sym_LF] = ACTIONS(4399),
    [anon_sym_CR] = ACTIONS(4399),
    [anon_sym_CR_LF] = ACTIONS(4399),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4399),
    [anon_sym_LBRACE] = ACTIONS(4399),
    [anon_sym_const] = ACTIONS(4399),
    [anon_sym_LPAREN] = ACTIONS(4399),
    [anon_sym___global] = ACTIONS(4399),
    [anon_sym_type] = ACTIONS(4399),
    [anon_sym_fn] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4399),
    [anon_sym_DASH] = ACTIONS(4399),
    [anon_sym_STAR] = ACTIONS(4399),
    [anon_sym_struct] = ACTIONS(4399),
    [anon_sym_union] = ACTIONS(4399),
    [anon_sym_pub] = ACTIONS(4399),
    [anon_sym_mut] = ACTIONS(4399),
    [anon_sym_enum] = ACTIONS(4399),
    [anon_sym_interface] = ACTIONS(4399),
    [anon_sym_QMARK] = ACTIONS(4399),
    [anon_sym_BANG] = ACTIONS(4399),
    [anon_sym_go] = ACTIONS(4399),
    [anon_sym_spawn] = ACTIONS(4399),
    [anon_sym_json_DOTdecode] = ACTIONS(4399),
    [anon_sym_LBRACK2] = ACTIONS(4399),
    [anon_sym_TILDE] = ACTIONS(4399),
    [anon_sym_CARET] = ACTIONS(4399),
    [anon_sym_AMP] = ACTIONS(4399),
    [anon_sym_LT_DASH] = ACTIONS(4399),
    [sym_none] = ACTIONS(4399),
    [sym_true] = ACTIONS(4399),
    [sym_false] = ACTIONS(4399),
    [sym_nil] = ACTIONS(4399),
    [anon_sym_if] = ACTIONS(4399),
    [anon_sym_DOLLARif] = ACTIONS(4399),
    [anon_sym_match] = ACTIONS(4399),
    [anon_sym_select] = ACTIONS(4399),
    [anon_sym_lock] = ACTIONS(4399),
    [anon_sym_rlock] = ACTIONS(4399),
    [anon_sym_unsafe] = ACTIONS(4399),
    [anon_sym_sql] = ACTIONS(4399),
    [sym_int_literal] = ACTIONS(4399),
    [sym_float_literal] = ACTIONS(4399),
    [sym_rune_literal] = ACTIONS(4399),
    [anon_sym_SQUOTE] = ACTIONS(4399),
    [anon_sym_DQUOTE] = ACTIONS(4399),
    [anon_sym_c_SQUOTE] = ACTIONS(4399),
    [anon_sym_c_DQUOTE] = ACTIONS(4399),
    [anon_sym_r_SQUOTE] = ACTIONS(4399),
    [anon_sym_r_DQUOTE] = ACTIONS(4399),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4399),
    [anon_sym_shared] = ACTIONS(4399),
    [aux_sym_sum_type_token1] = ACTIONS(4401),
    [anon_sym_PIPE2] = ACTIONS(4404),
    [anon_sym_map_LBRACK] = ACTIONS(4399),
    [anon_sym_chan] = ACTIONS(4399),
    [anon_sym_thread] = ACTIONS(4399),
    [anon_sym_atomic] = ACTIONS(4399),
    [anon_sym_assert] = ACTIONS(4399),
    [anon_sym_defer] = ACTIONS(4399),
    [anon_sym_goto] = ACTIONS(4399),
    [anon_sym_break] = ACTIONS(4399),
    [anon_sym_continue] = ACTIONS(4399),
    [anon_sym_return] = ACTIONS(4399),
    [anon_sym_DOLLARfor] = ACTIONS(4399),
    [anon_sym_for] = ACTIONS(4399),
    [anon_sym_POUND] = ACTIONS(4399),
    [anon_sym_asm] = ACTIONS(4399),
    [anon_sym_AT_LBRACK] = ACTIONS(4399),
  },
  [1706] = {
    [sym_line_comment] = STATE(1706),
    [sym_block_comment] = STATE(1706),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(2395),
    [sym_plain_type] = STATE(2489),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(2395),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(4357),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(853),
    [anon_sym_DOT] = ACTIONS(855),
    [anon_sym_as] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(853),
    [anon_sym_COMMA] = ACTIONS(853),
    [anon_sym_LPAREN] = ACTIONS(3968),
    [anon_sym_RPAREN] = ACTIONS(853),
    [anon_sym_fn] = ACTIONS(4359),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(4361),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_PERCENT] = ACTIONS(853),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_GT] = ACTIONS(855),
    [anon_sym_EQ_EQ] = ACTIONS(853),
    [anon_sym_BANG_EQ] = ACTIONS(853),
    [anon_sym_LT_EQ] = ACTIONS(853),
    [anon_sym_GT_EQ] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_RBRACK] = ACTIONS(853),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_COLON] = ACTIONS(855),
    [anon_sym_PLUS_PLUS] = ACTIONS(853),
    [anon_sym_DASH_DASH] = ACTIONS(853),
    [anon_sym_QMARK] = ACTIONS(4363),
    [anon_sym_BANG] = ACTIONS(4365),
    [anon_sym_PIPE] = ACTIONS(855),
    [anon_sym_LBRACK2] = ACTIONS(4367),
    [anon_sym_CARET] = ACTIONS(853),
    [anon_sym_AMP] = ACTIONS(4369),
    [anon_sym_LT_LT] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_GT_GT_GT] = ACTIONS(853),
    [anon_sym_AMP_CARET] = ACTIONS(853),
    [anon_sym_AMP_AMP] = ACTIONS(853),
    [anon_sym_PIPE_PIPE] = ACTIONS(853),
    [anon_sym_or] = ACTIONS(855),
    [anon_sym_QMARK_DOT] = ACTIONS(853),
    [anon_sym_POUND_LBRACK] = ACTIONS(853),
    [anon_sym_is] = ACTIONS(855),
    [anon_sym_BANGis] = ACTIONS(853),
    [anon_sym_in] = ACTIONS(855),
    [anon_sym_BANGin] = ACTIONS(853),
    [anon_sym_COLON_EQ] = ACTIONS(853),
    [anon_sym_shared] = ACTIONS(4371),
    [anon_sym_map_LBRACK] = ACTIONS(4373),
    [anon_sym_chan] = ACTIONS(4375),
    [anon_sym_thread] = ACTIONS(4377),
    [anon_sym_atomic] = ACTIONS(4379),
    [anon_sym_DOT_DOT] = ACTIONS(853),
  },
  [1707] = {
    [sym_line_comment] = STATE(1707),
    [sym_block_comment] = STATE(1707),
    [aux_sym_sum_type_repeat1] = STATE(1702),
    [ts_builtin_sym_end] = ACTIONS(4407),
    [sym_identifier] = ACTIONS(4409),
    [anon_sym_LF] = ACTIONS(4409),
    [anon_sym_CR] = ACTIONS(4409),
    [anon_sym_CR_LF] = ACTIONS(4409),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4409),
    [anon_sym_LBRACE] = ACTIONS(4409),
    [anon_sym_const] = ACTIONS(4409),
    [anon_sym_LPAREN] = ACTIONS(4409),
    [anon_sym___global] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_fn] = ACTIONS(4409),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_DASH] = ACTIONS(4409),
    [anon_sym_STAR] = ACTIONS(4409),
    [anon_sym_struct] = ACTIONS(4409),
    [anon_sym_union] = ACTIONS(4409),
    [anon_sym_pub] = ACTIONS(4409),
    [anon_sym_mut] = ACTIONS(4409),
    [anon_sym_enum] = ACTIONS(4409),
    [anon_sym_interface] = ACTIONS(4409),
    [anon_sym_QMARK] = ACTIONS(4409),
    [anon_sym_BANG] = ACTIONS(4409),
    [anon_sym_go] = ACTIONS(4409),
    [anon_sym_spawn] = ACTIONS(4409),
    [anon_sym_json_DOTdecode] = ACTIONS(4409),
    [anon_sym_LBRACK2] = ACTIONS(4409),
    [anon_sym_TILDE] = ACTIONS(4409),
    [anon_sym_CARET] = ACTIONS(4409),
    [anon_sym_AMP] = ACTIONS(4409),
    [anon_sym_LT_DASH] = ACTIONS(4409),
    [sym_none] = ACTIONS(4409),
    [sym_true] = ACTIONS(4409),
    [sym_false] = ACTIONS(4409),
    [sym_nil] = ACTIONS(4409),
    [anon_sym_if] = ACTIONS(4409),
    [anon_sym_DOLLARif] = ACTIONS(4409),
    [anon_sym_match] = ACTIONS(4409),
    [anon_sym_select] = ACTIONS(4409),
    [anon_sym_lock] = ACTIONS(4409),
    [anon_sym_rlock] = ACTIONS(4409),
    [anon_sym_unsafe] = ACTIONS(4409),
    [anon_sym_sql] = ACTIONS(4409),
    [sym_int_literal] = ACTIONS(4409),
    [sym_float_literal] = ACTIONS(4409),
    [sym_rune_literal] = ACTIONS(4409),
    [anon_sym_SQUOTE] = ACTIONS(4409),
    [anon_sym_DQUOTE] = ACTIONS(4409),
    [anon_sym_c_SQUOTE] = ACTIONS(4409),
    [anon_sym_c_DQUOTE] = ACTIONS(4409),
    [anon_sym_r_SQUOTE] = ACTIONS(4409),
    [anon_sym_r_DQUOTE] = ACTIONS(4409),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4409),
    [anon_sym_shared] = ACTIONS(4409),
    [aux_sym_sum_type_token1] = ACTIONS(4385),
    [anon_sym_PIPE2] = ACTIONS(4387),
    [anon_sym_map_LBRACK] = ACTIONS(4409),
    [anon_sym_chan] = ACTIONS(4409),
    [anon_sym_thread] = ACTIONS(4409),
    [anon_sym_atomic] = ACTIONS(4409),
    [anon_sym_assert] = ACTIONS(4409),
    [anon_sym_defer] = ACTIONS(4409),
    [anon_sym_goto] = ACTIONS(4409),
    [anon_sym_break] = ACTIONS(4409),
    [anon_sym_continue] = ACTIONS(4409),
    [anon_sym_return] = ACTIONS(4409),
    [anon_sym_DOLLARfor] = ACTIONS(4409),
    [anon_sym_for] = ACTIONS(4409),
    [anon_sym_POUND] = ACTIONS(4409),
    [anon_sym_asm] = ACTIONS(4409),
    [anon_sym_AT_LBRACK] = ACTIONS(4409),
  },
  [1708] = {
    [sym_line_comment] = STATE(1708),
    [sym_block_comment] = STATE(1708),
    [aux_sym_sum_type_repeat1] = STATE(1702),
    [ts_builtin_sym_end] = ACTIONS(4411),
    [sym_identifier] = ACTIONS(4413),
    [anon_sym_LF] = ACTIONS(4413),
    [anon_sym_CR] = ACTIONS(4413),
    [anon_sym_CR_LF] = ACTIONS(4413),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(4413),
    [anon_sym_const] = ACTIONS(4413),
    [anon_sym_LPAREN] = ACTIONS(4413),
    [anon_sym___global] = ACTIONS(4413),
    [anon_sym_type] = ACTIONS(4413),
    [anon_sym_fn] = ACTIONS(4413),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_STAR] = ACTIONS(4413),
    [anon_sym_struct] = ACTIONS(4413),
    [anon_sym_union] = ACTIONS(4413),
    [anon_sym_pub] = ACTIONS(4413),
    [anon_sym_mut] = ACTIONS(4413),
    [anon_sym_enum] = ACTIONS(4413),
    [anon_sym_interface] = ACTIONS(4413),
    [anon_sym_QMARK] = ACTIONS(4413),
    [anon_sym_BANG] = ACTIONS(4413),
    [anon_sym_go] = ACTIONS(4413),
    [anon_sym_spawn] = ACTIONS(4413),
    [anon_sym_json_DOTdecode] = ACTIONS(4413),
    [anon_sym_LBRACK2] = ACTIONS(4413),
    [anon_sym_TILDE] = ACTIONS(4413),
    [anon_sym_CARET] = ACTIONS(4413),
    [anon_sym_AMP] = ACTIONS(4413),
    [anon_sym_LT_DASH] = ACTIONS(4413),
    [sym_none] = ACTIONS(4413),
    [sym_true] = ACTIONS(4413),
    [sym_false] = ACTIONS(4413),
    [sym_nil] = ACTIONS(4413),
    [anon_sym_if] = ACTIONS(4413),
    [anon_sym_DOLLARif] = ACTIONS(4413),
    [anon_sym_match] = ACTIONS(4413),
    [anon_sym_select] = ACTIONS(4413),
    [anon_sym_lock] = ACTIONS(4413),
    [anon_sym_rlock] = ACTIONS(4413),
    [anon_sym_unsafe] = ACTIONS(4413),
    [anon_sym_sql] = ACTIONS(4413),
    [sym_int_literal] = ACTIONS(4413),
    [sym_float_literal] = ACTIONS(4413),
    [sym_rune_literal] = ACTIONS(4413),
    [anon_sym_SQUOTE] = ACTIONS(4413),
    [anon_sym_DQUOTE] = ACTIONS(4413),
    [anon_sym_c_SQUOTE] = ACTIONS(4413),
    [anon_sym_c_DQUOTE] = ACTIONS(4413),
    [anon_sym_r_SQUOTE] = ACTIONS(4413),
    [anon_sym_r_DQUOTE] = ACTIONS(4413),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4413),
    [anon_sym_shared] = ACTIONS(4413),
    [aux_sym_sum_type_token1] = ACTIONS(4385),
    [anon_sym_PIPE2] = ACTIONS(4387),
    [anon_sym_map_LBRACK] = ACTIONS(4413),
    [anon_sym_chan] = ACTIONS(4413),
    [anon_sym_thread] = ACTIONS(4413),
    [anon_sym_atomic] = ACTIONS(4413),
    [anon_sym_assert] = ACTIONS(4413),
    [anon_sym_defer] = ACTIONS(4413),
    [anon_sym_goto] = ACTIONS(4413),
    [anon_sym_break] = ACTIONS(4413),
    [anon_sym_continue] = ACTIONS(4413),
    [anon_sym_return] = ACTIONS(4413),
    [anon_sym_DOLLARfor] = ACTIONS(4413),
    [anon_sym_for] = ACTIONS(4413),
    [anon_sym_POUND] = ACTIONS(4413),
    [anon_sym_asm] = ACTIONS(4413),
    [anon_sym_AT_LBRACK] = ACTIONS(4413),
  },
  [1709] = {
    [sym_line_comment] = STATE(1709),
    [sym_block_comment] = STATE(1709),
    [ts_builtin_sym_end] = ACTIONS(2371),
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2373),
    [anon_sym_CR] = ACTIONS(2373),
    [anon_sym_CR_LF] = ACTIONS(2373),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym___global] = ACTIONS(2373),
    [anon_sym_type] = ACTIONS(2373),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_pub] = ACTIONS(2373),
    [anon_sym_mut] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_QMARK] = ACTIONS(2373),
    [anon_sym_BANG] = ACTIONS(2373),
    [anon_sym_go] = ACTIONS(2373),
    [anon_sym_spawn] = ACTIONS(2373),
    [anon_sym_json_DOTdecode] = ACTIONS(2373),
    [anon_sym_LBRACK2] = ACTIONS(2373),
    [anon_sym_TILDE] = ACTIONS(2373),
    [anon_sym_CARET] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_LT_DASH] = ACTIONS(2373),
    [sym_none] = ACTIONS(2373),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [sym_nil] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_DOLLARif] = ACTIONS(2373),
    [anon_sym_match] = ACTIONS(2373),
    [anon_sym_select] = ACTIONS(2373),
    [anon_sym_lock] = ACTIONS(2373),
    [anon_sym_rlock] = ACTIONS(2373),
    [anon_sym_unsafe] = ACTIONS(2373),
    [anon_sym_sql] = ACTIONS(2373),
    [sym_int_literal] = ACTIONS(2373),
    [sym_float_literal] = ACTIONS(2373),
    [sym_rune_literal] = ACTIONS(2373),
    [anon_sym_SQUOTE] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(2373),
    [anon_sym_c_SQUOTE] = ACTIONS(2373),
    [anon_sym_c_DQUOTE] = ACTIONS(2373),
    [anon_sym_r_SQUOTE] = ACTIONS(2373),
    [anon_sym_r_DQUOTE] = ACTIONS(2373),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [aux_sym_sum_type_token1] = ACTIONS(2373),
    [anon_sym_PIPE2] = ACTIONS(2371),
    [anon_sym_map_LBRACK] = ACTIONS(2373),
    [anon_sym_chan] = ACTIONS(2373),
    [anon_sym_thread] = ACTIONS(2373),
    [anon_sym_atomic] = ACTIONS(2373),
    [anon_sym_assert] = ACTIONS(2373),
    [anon_sym_defer] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_DOLLARfor] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_POUND] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym_AT_LBRACK] = ACTIONS(2373),
  },
  [1710] = {
    [sym_line_comment] = STATE(1710),
    [sym_block_comment] = STATE(1710),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(2395),
    [sym_plain_type] = STATE(2445),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(2395),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(4357),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(817),
    [anon_sym_DOT] = ACTIONS(821),
    [anon_sym_as] = ACTIONS(821),
    [anon_sym_LBRACE] = ACTIONS(817),
    [anon_sym_COMMA] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(3968),
    [anon_sym_RPAREN] = ACTIONS(817),
    [anon_sym_fn] = ACTIONS(4359),
    [anon_sym_PLUS] = ACTIONS(821),
    [anon_sym_DASH] = ACTIONS(821),
    [anon_sym_STAR] = ACTIONS(4361),
    [anon_sym_SLASH] = ACTIONS(821),
    [anon_sym_PERCENT] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(821),
    [anon_sym_GT] = ACTIONS(821),
    [anon_sym_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(817),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_LBRACK] = ACTIONS(817),
    [anon_sym_RBRACK] = ACTIONS(817),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_COLON] = ACTIONS(821),
    [anon_sym_PLUS_PLUS] = ACTIONS(817),
    [anon_sym_DASH_DASH] = ACTIONS(817),
    [anon_sym_QMARK] = ACTIONS(4363),
    [anon_sym_BANG] = ACTIONS(4365),
    [anon_sym_PIPE] = ACTIONS(821),
    [anon_sym_LBRACK2] = ACTIONS(4367),
    [anon_sym_CARET] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(4369),
    [anon_sym_LT_LT] = ACTIONS(817),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_GT_GT_GT] = ACTIONS(817),
    [anon_sym_AMP_CARET] = ACTIONS(817),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_or] = ACTIONS(821),
    [anon_sym_QMARK_DOT] = ACTIONS(817),
    [anon_sym_POUND_LBRACK] = ACTIONS(817),
    [anon_sym_is] = ACTIONS(821),
    [anon_sym_BANGis] = ACTIONS(817),
    [anon_sym_in] = ACTIONS(821),
    [anon_sym_BANGin] = ACTIONS(817),
    [anon_sym_COLON_EQ] = ACTIONS(817),
    [anon_sym_shared] = ACTIONS(4371),
    [anon_sym_map_LBRACK] = ACTIONS(4373),
    [anon_sym_chan] = ACTIONS(4375),
    [anon_sym_thread] = ACTIONS(4377),
    [anon_sym_atomic] = ACTIONS(4379),
    [anon_sym_DOT_DOT] = ACTIONS(817),
  },
  [1711] = {
    [sym_line_comment] = STATE(1711),
    [sym_block_comment] = STATE(1711),
    [ts_builtin_sym_end] = ACTIONS(2455),
    [sym_identifier] = ACTIONS(2457),
    [anon_sym_LF] = ACTIONS(2457),
    [anon_sym_CR] = ACTIONS(2457),
    [anon_sym_CR_LF] = ACTIONS(2457),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2457),
    [anon_sym_LBRACE] = ACTIONS(2457),
    [anon_sym_const] = ACTIONS(2457),
    [anon_sym_LPAREN] = ACTIONS(2457),
    [anon_sym___global] = ACTIONS(2457),
    [anon_sym_type] = ACTIONS(2457),
    [anon_sym_fn] = ACTIONS(2457),
    [anon_sym_PLUS] = ACTIONS(2457),
    [anon_sym_DASH] = ACTIONS(2457),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_struct] = ACTIONS(2457),
    [anon_sym_union] = ACTIONS(2457),
    [anon_sym_pub] = ACTIONS(2457),
    [anon_sym_mut] = ACTIONS(2457),
    [anon_sym_enum] = ACTIONS(2457),
    [anon_sym_interface] = ACTIONS(2457),
    [anon_sym_QMARK] = ACTIONS(2457),
    [anon_sym_BANG] = ACTIONS(2457),
    [anon_sym_go] = ACTIONS(2457),
    [anon_sym_spawn] = ACTIONS(2457),
    [anon_sym_json_DOTdecode] = ACTIONS(2457),
    [anon_sym_LBRACK2] = ACTIONS(2457),
    [anon_sym_TILDE] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2457),
    [anon_sym_AMP] = ACTIONS(2457),
    [anon_sym_LT_DASH] = ACTIONS(2457),
    [sym_none] = ACTIONS(2457),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [sym_nil] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2457),
    [anon_sym_DOLLARif] = ACTIONS(2457),
    [anon_sym_match] = ACTIONS(2457),
    [anon_sym_select] = ACTIONS(2457),
    [anon_sym_lock] = ACTIONS(2457),
    [anon_sym_rlock] = ACTIONS(2457),
    [anon_sym_unsafe] = ACTIONS(2457),
    [anon_sym_sql] = ACTIONS(2457),
    [sym_int_literal] = ACTIONS(2457),
    [sym_float_literal] = ACTIONS(2457),
    [sym_rune_literal] = ACTIONS(2457),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_DQUOTE] = ACTIONS(2457),
    [anon_sym_c_SQUOTE] = ACTIONS(2457),
    [anon_sym_c_DQUOTE] = ACTIONS(2457),
    [anon_sym_r_SQUOTE] = ACTIONS(2457),
    [anon_sym_r_DQUOTE] = ACTIONS(2457),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2457),
    [anon_sym_shared] = ACTIONS(2457),
    [aux_sym_sum_type_token1] = ACTIONS(2457),
    [anon_sym_PIPE2] = ACTIONS(2455),
    [anon_sym_map_LBRACK] = ACTIONS(2457),
    [anon_sym_chan] = ACTIONS(2457),
    [anon_sym_thread] = ACTIONS(2457),
    [anon_sym_atomic] = ACTIONS(2457),
    [anon_sym_assert] = ACTIONS(2457),
    [anon_sym_defer] = ACTIONS(2457),
    [anon_sym_goto] = ACTIONS(2457),
    [anon_sym_break] = ACTIONS(2457),
    [anon_sym_continue] = ACTIONS(2457),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_DOLLARfor] = ACTIONS(2457),
    [anon_sym_for] = ACTIONS(2457),
    [anon_sym_POUND] = ACTIONS(2457),
    [anon_sym_asm] = ACTIONS(2457),
    [anon_sym_AT_LBRACK] = ACTIONS(2457),
  },
  [1712] = {
    [sym_line_comment] = STATE(1712),
    [sym_block_comment] = STATE(1712),
    [ts_builtin_sym_end] = ACTIONS(3298),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_LF] = ACTIONS(3300),
    [anon_sym_CR] = ACTIONS(3300),
    [anon_sym_CR_LF] = ACTIONS(3300),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3300),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_const] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym___global] = ACTIONS(3300),
    [anon_sym_type] = ACTIONS(3300),
    [anon_sym_fn] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_struct] = ACTIONS(3300),
    [anon_sym_union] = ACTIONS(3300),
    [anon_sym_pub] = ACTIONS(3300),
    [anon_sym_mut] = ACTIONS(3300),
    [anon_sym_enum] = ACTIONS(3300),
    [anon_sym_interface] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_go] = ACTIONS(3300),
    [anon_sym_spawn] = ACTIONS(3300),
    [anon_sym_json_DOTdecode] = ACTIONS(3300),
    [anon_sym_LBRACK2] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [anon_sym_CARET] = ACTIONS(3300),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LT_DASH] = ACTIONS(3300),
    [sym_none] = ACTIONS(3300),
    [sym_true] = ACTIONS(3300),
    [sym_false] = ACTIONS(3300),
    [sym_nil] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_DOLLARif] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_select] = ACTIONS(3300),
    [anon_sym_lock] = ACTIONS(3300),
    [anon_sym_rlock] = ACTIONS(3300),
    [anon_sym_unsafe] = ACTIONS(3300),
    [anon_sym_sql] = ACTIONS(3300),
    [sym_int_literal] = ACTIONS(3300),
    [sym_float_literal] = ACTIONS(3300),
    [sym_rune_literal] = ACTIONS(3300),
    [anon_sym_SQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_c_SQUOTE] = ACTIONS(3300),
    [anon_sym_c_DQUOTE] = ACTIONS(3300),
    [anon_sym_r_SQUOTE] = ACTIONS(3300),
    [anon_sym_r_DQUOTE] = ACTIONS(3300),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3300),
    [anon_sym_shared] = ACTIONS(3300),
    [aux_sym_sum_type_token1] = ACTIONS(3300),
    [anon_sym_PIPE2] = ACTIONS(3298),
    [anon_sym_map_LBRACK] = ACTIONS(3300),
    [anon_sym_chan] = ACTIONS(3300),
    [anon_sym_thread] = ACTIONS(3300),
    [anon_sym_atomic] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_defer] = ACTIONS(3300),
    [anon_sym_goto] = ACTIONS(3300),
    [anon_sym_break] = ACTIONS(3300),
    [anon_sym_continue] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_DOLLARfor] = ACTIONS(3300),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_POUND] = ACTIONS(3300),
    [anon_sym_asm] = ACTIONS(3300),
    [anon_sym_AT_LBRACK] = ACTIONS(3300),
  },
  [1713] = {
    [sym_line_comment] = STATE(1713),
    [sym_block_comment] = STATE(1713),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2489),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(849),
    [anon_sym_DOT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(853),
    [anon_sym_COMMA] = ACTIONS(853),
    [anon_sym_LPAREN] = ACTIONS(849),
    [anon_sym_RPAREN] = ACTIONS(849),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(849),
    [anon_sym_SLASH] = ACTIONS(851),
    [anon_sym_PERCENT] = ACTIONS(849),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(849),
    [anon_sym_BANG_EQ] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_RBRACK] = ACTIONS(849),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_COLON] = ACTIONS(849),
    [anon_sym_PLUS_PLUS] = ACTIONS(849),
    [anon_sym_DASH_DASH] = ACTIONS(849),
    [anon_sym_QMARK] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PIPE] = ACTIONS(851),
    [anon_sym_LBRACK2] = ACTIONS(851),
    [anon_sym_CARET] = ACTIONS(849),
    [anon_sym_AMP] = ACTIONS(851),
    [anon_sym_LT_LT] = ACTIONS(849),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_GT_GT_GT] = ACTIONS(849),
    [anon_sym_AMP_CARET] = ACTIONS(849),
    [anon_sym_AMP_AMP] = ACTIONS(849),
    [anon_sym_PIPE_PIPE] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(851),
    [anon_sym_QMARK_DOT] = ACTIONS(849),
    [anon_sym_POUND_LBRACK] = ACTIONS(849),
    [anon_sym_is] = ACTIONS(851),
    [anon_sym_BANGis] = ACTIONS(849),
    [anon_sym_in] = ACTIONS(851),
    [anon_sym_BANGin] = ACTIONS(849),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(849),
  },
  [1714] = {
    [sym_line_comment] = STATE(1714),
    [sym_block_comment] = STATE(1714),
    [ts_builtin_sym_end] = ACTIONS(2667),
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_LF] = ACTIONS(2669),
    [anon_sym_CR] = ACTIONS(2669),
    [anon_sym_CR_LF] = ACTIONS(2669),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_LPAREN] = ACTIONS(2669),
    [anon_sym___global] = ACTIONS(2669),
    [anon_sym_type] = ACTIONS(2669),
    [anon_sym_fn] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_union] = ACTIONS(2669),
    [anon_sym_pub] = ACTIONS(2669),
    [anon_sym_mut] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [anon_sym_interface] = ACTIONS(2669),
    [anon_sym_QMARK] = ACTIONS(2669),
    [anon_sym_BANG] = ACTIONS(2669),
    [anon_sym_go] = ACTIONS(2669),
    [anon_sym_spawn] = ACTIONS(2669),
    [anon_sym_json_DOTdecode] = ACTIONS(2669),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_TILDE] = ACTIONS(2669),
    [anon_sym_CARET] = ACTIONS(2669),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_LT_DASH] = ACTIONS(2669),
    [sym_none] = ACTIONS(2669),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [sym_nil] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_DOLLARif] = ACTIONS(2669),
    [anon_sym_match] = ACTIONS(2669),
    [anon_sym_select] = ACTIONS(2669),
    [anon_sym_lock] = ACTIONS(2669),
    [anon_sym_rlock] = ACTIONS(2669),
    [anon_sym_unsafe] = ACTIONS(2669),
    [anon_sym_sql] = ACTIONS(2669),
    [sym_int_literal] = ACTIONS(2669),
    [sym_float_literal] = ACTIONS(2669),
    [sym_rune_literal] = ACTIONS(2669),
    [anon_sym_SQUOTE] = ACTIONS(2669),
    [anon_sym_DQUOTE] = ACTIONS(2669),
    [anon_sym_c_SQUOTE] = ACTIONS(2669),
    [anon_sym_c_DQUOTE] = ACTIONS(2669),
    [anon_sym_r_SQUOTE] = ACTIONS(2669),
    [anon_sym_r_DQUOTE] = ACTIONS(2669),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2669),
    [anon_sym_shared] = ACTIONS(2669),
    [aux_sym_sum_type_token1] = ACTIONS(2669),
    [anon_sym_PIPE2] = ACTIONS(2667),
    [anon_sym_map_LBRACK] = ACTIONS(2669),
    [anon_sym_chan] = ACTIONS(2669),
    [anon_sym_thread] = ACTIONS(2669),
    [anon_sym_atomic] = ACTIONS(2669),
    [anon_sym_assert] = ACTIONS(2669),
    [anon_sym_defer] = ACTIONS(2669),
    [anon_sym_goto] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_DOLLARfor] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_POUND] = ACTIONS(2669),
    [anon_sym_asm] = ACTIONS(2669),
    [anon_sym_AT_LBRACK] = ACTIONS(2669),
  },
  [1715] = {
    [sym_line_comment] = STATE(1715),
    [sym_block_comment] = STATE(1715),
    [aux_sym_strictly_expression_list_repeat1] = STATE(1737),
    [ts_builtin_sym_end] = ACTIONS(3862),
    [sym_identifier] = ACTIONS(2041),
    [anon_sym_LF] = ACTIONS(2041),
    [anon_sym_CR] = ACTIONS(2041),
    [anon_sym_CR_LF] = ACTIONS(2041),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2041),
    [anon_sym_COMMA] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(2041),
    [anon_sym_LPAREN] = ACTIONS(2041),
    [anon_sym___global] = ACTIONS(2041),
    [anon_sym_type] = ACTIONS(2041),
    [anon_sym_fn] = ACTIONS(2041),
    [anon_sym_PLUS] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_struct] = ACTIONS(2041),
    [anon_sym_union] = ACTIONS(2041),
    [anon_sym_pub] = ACTIONS(2041),
    [anon_sym_mut] = ACTIONS(2041),
    [anon_sym_enum] = ACTIONS(2041),
    [anon_sym_interface] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2041),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_go] = ACTIONS(2041),
    [anon_sym_spawn] = ACTIONS(2041),
    [anon_sym_json_DOTdecode] = ACTIONS(2041),
    [anon_sym_LBRACK2] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT_DASH] = ACTIONS(2041),
    [sym_none] = ACTIONS(2041),
    [sym_true] = ACTIONS(2041),
    [sym_false] = ACTIONS(2041),
    [sym_nil] = ACTIONS(2041),
    [anon_sym_if] = ACTIONS(2041),
    [anon_sym_DOLLARif] = ACTIONS(2041),
    [anon_sym_match] = ACTIONS(2041),
    [anon_sym_select] = ACTIONS(2041),
    [anon_sym_lock] = ACTIONS(2041),
    [anon_sym_rlock] = ACTIONS(2041),
    [anon_sym_unsafe] = ACTIONS(2041),
    [anon_sym_sql] = ACTIONS(2041),
    [sym_int_literal] = ACTIONS(2041),
    [sym_float_literal] = ACTIONS(2041),
    [sym_rune_literal] = ACTIONS(2041),
    [anon_sym_SQUOTE] = ACTIONS(2041),
    [anon_sym_DQUOTE] = ACTIONS(2041),
    [anon_sym_c_SQUOTE] = ACTIONS(2041),
    [anon_sym_c_DQUOTE] = ACTIONS(2041),
    [anon_sym_r_SQUOTE] = ACTIONS(2041),
    [anon_sym_r_DQUOTE] = ACTIONS(2041),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2041),
    [anon_sym_shared] = ACTIONS(2041),
    [anon_sym_map_LBRACK] = ACTIONS(2041),
    [anon_sym_chan] = ACTIONS(2041),
    [anon_sym_thread] = ACTIONS(2041),
    [anon_sym_atomic] = ACTIONS(2041),
    [anon_sym_assert] = ACTIONS(2041),
    [anon_sym_defer] = ACTIONS(2041),
    [anon_sym_goto] = ACTIONS(2041),
    [anon_sym_break] = ACTIONS(2041),
    [anon_sym_continue] = ACTIONS(2041),
    [anon_sym_return] = ACTIONS(2041),
    [anon_sym_DOLLARfor] = ACTIONS(2041),
    [anon_sym_for] = ACTIONS(2041),
    [anon_sym_POUND] = ACTIONS(2041),
    [anon_sym_asm] = ACTIONS(2041),
    [anon_sym_AT_LBRACK] = ACTIONS(2041),
  },
  [1716] = {
    [sym_line_comment] = STATE(1716),
    [sym_block_comment] = STATE(1716),
    [ts_builtin_sym_end] = ACTIONS(3348),
    [sym_identifier] = ACTIONS(3350),
    [anon_sym_LF] = ACTIONS(3350),
    [anon_sym_CR] = ACTIONS(3350),
    [anon_sym_CR_LF] = ACTIONS(3350),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3350),
    [anon_sym_LBRACE] = ACTIONS(3350),
    [anon_sym_const] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(3350),
    [anon_sym___global] = ACTIONS(3350),
    [anon_sym_type] = ACTIONS(3350),
    [anon_sym_fn] = ACTIONS(3350),
    [anon_sym_PLUS] = ACTIONS(3350),
    [anon_sym_DASH] = ACTIONS(3350),
    [anon_sym_STAR] = ACTIONS(3350),
    [anon_sym_struct] = ACTIONS(3350),
    [anon_sym_union] = ACTIONS(3350),
    [anon_sym_pub] = ACTIONS(3350),
    [anon_sym_mut] = ACTIONS(3350),
    [anon_sym_enum] = ACTIONS(3350),
    [anon_sym_interface] = ACTIONS(3350),
    [anon_sym_QMARK] = ACTIONS(3350),
    [anon_sym_BANG] = ACTIONS(3350),
    [anon_sym_go] = ACTIONS(3350),
    [anon_sym_spawn] = ACTIONS(3350),
    [anon_sym_json_DOTdecode] = ACTIONS(3350),
    [anon_sym_LBRACK2] = ACTIONS(3350),
    [anon_sym_TILDE] = ACTIONS(3350),
    [anon_sym_CARET] = ACTIONS(3350),
    [anon_sym_AMP] = ACTIONS(3350),
    [anon_sym_LT_DASH] = ACTIONS(3350),
    [sym_none] = ACTIONS(3350),
    [sym_true] = ACTIONS(3350),
    [sym_false] = ACTIONS(3350),
    [sym_nil] = ACTIONS(3350),
    [anon_sym_if] = ACTIONS(3350),
    [anon_sym_DOLLARif] = ACTIONS(3350),
    [anon_sym_match] = ACTIONS(3350),
    [anon_sym_select] = ACTIONS(3350),
    [anon_sym_lock] = ACTIONS(3350),
    [anon_sym_rlock] = ACTIONS(3350),
    [anon_sym_unsafe] = ACTIONS(3350),
    [anon_sym_sql] = ACTIONS(3350),
    [sym_int_literal] = ACTIONS(3350),
    [sym_float_literal] = ACTIONS(3350),
    [sym_rune_literal] = ACTIONS(3350),
    [anon_sym_SQUOTE] = ACTIONS(3350),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [anon_sym_c_SQUOTE] = ACTIONS(3350),
    [anon_sym_c_DQUOTE] = ACTIONS(3350),
    [anon_sym_r_SQUOTE] = ACTIONS(3350),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3350),
    [anon_sym_shared] = ACTIONS(3350),
    [aux_sym_sum_type_token1] = ACTIONS(3350),
    [anon_sym_PIPE2] = ACTIONS(3348),
    [anon_sym_map_LBRACK] = ACTIONS(3350),
    [anon_sym_chan] = ACTIONS(3350),
    [anon_sym_thread] = ACTIONS(3350),
    [anon_sym_atomic] = ACTIONS(3350),
    [anon_sym_assert] = ACTIONS(3350),
    [anon_sym_defer] = ACTIONS(3350),
    [anon_sym_goto] = ACTIONS(3350),
    [anon_sym_break] = ACTIONS(3350),
    [anon_sym_continue] = ACTIONS(3350),
    [anon_sym_return] = ACTIONS(3350),
    [anon_sym_DOLLARfor] = ACTIONS(3350),
    [anon_sym_for] = ACTIONS(3350),
    [anon_sym_POUND] = ACTIONS(3350),
    [anon_sym_asm] = ACTIONS(3350),
    [anon_sym_AT_LBRACK] = ACTIONS(3350),
  },
  [1717] = {
    [sym_line_comment] = STATE(1717),
    [sym_block_comment] = STATE(1717),
    [aux_sym_strictly_expression_list_repeat1] = STATE(1717),
    [ts_builtin_sym_end] = ACTIONS(3908),
    [sym_identifier] = ACTIONS(2001),
    [anon_sym_LF] = ACTIONS(2001),
    [anon_sym_CR] = ACTIONS(2001),
    [anon_sym_CR_LF] = ACTIONS(2001),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(4415),
    [anon_sym_const] = ACTIONS(2001),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [anon_sym___global] = ACTIONS(2001),
    [anon_sym_type] = ACTIONS(2001),
    [anon_sym_fn] = ACTIONS(2001),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_struct] = ACTIONS(2001),
    [anon_sym_union] = ACTIONS(2001),
    [anon_sym_pub] = ACTIONS(2001),
    [anon_sym_mut] = ACTIONS(2001),
    [anon_sym_enum] = ACTIONS(2001),
    [anon_sym_interface] = ACTIONS(2001),
    [anon_sym_QMARK] = ACTIONS(2001),
    [anon_sym_BANG] = ACTIONS(2001),
    [anon_sym_go] = ACTIONS(2001),
    [anon_sym_spawn] = ACTIONS(2001),
    [anon_sym_json_DOTdecode] = ACTIONS(2001),
    [anon_sym_LBRACK2] = ACTIONS(2001),
    [anon_sym_TILDE] = ACTIONS(2001),
    [anon_sym_CARET] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_LT_DASH] = ACTIONS(2001),
    [sym_none] = ACTIONS(2001),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_nil] = ACTIONS(2001),
    [anon_sym_if] = ACTIONS(2001),
    [anon_sym_DOLLARif] = ACTIONS(2001),
    [anon_sym_match] = ACTIONS(2001),
    [anon_sym_select] = ACTIONS(2001),
    [anon_sym_lock] = ACTIONS(2001),
    [anon_sym_rlock] = ACTIONS(2001),
    [anon_sym_unsafe] = ACTIONS(2001),
    [anon_sym_sql] = ACTIONS(2001),
    [sym_int_literal] = ACTIONS(2001),
    [sym_float_literal] = ACTIONS(2001),
    [sym_rune_literal] = ACTIONS(2001),
    [anon_sym_SQUOTE] = ACTIONS(2001),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_c_SQUOTE] = ACTIONS(2001),
    [anon_sym_c_DQUOTE] = ACTIONS(2001),
    [anon_sym_r_SQUOTE] = ACTIONS(2001),
    [anon_sym_r_DQUOTE] = ACTIONS(2001),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2001),
    [anon_sym_shared] = ACTIONS(2001),
    [anon_sym_map_LBRACK] = ACTIONS(2001),
    [anon_sym_chan] = ACTIONS(2001),
    [anon_sym_thread] = ACTIONS(2001),
    [anon_sym_atomic] = ACTIONS(2001),
    [anon_sym_assert] = ACTIONS(2001),
    [anon_sym_defer] = ACTIONS(2001),
    [anon_sym_goto] = ACTIONS(2001),
    [anon_sym_break] = ACTIONS(2001),
    [anon_sym_continue] = ACTIONS(2001),
    [anon_sym_return] = ACTIONS(2001),
    [anon_sym_DOLLARfor] = ACTIONS(2001),
    [anon_sym_for] = ACTIONS(2001),
    [anon_sym_POUND] = ACTIONS(2001),
    [anon_sym_asm] = ACTIONS(2001),
    [anon_sym_AT_LBRACK] = ACTIONS(2001),
  },
  [1718] = {
    [sym_line_comment] = STATE(1718),
    [sym_block_comment] = STATE(1718),
    [ts_builtin_sym_end] = ACTIONS(2451),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LF] = ACTIONS(2453),
    [anon_sym_CR] = ACTIONS(2453),
    [anon_sym_CR_LF] = ACTIONS(2453),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym___global] = ACTIONS(2453),
    [anon_sym_type] = ACTIONS(2453),
    [anon_sym_fn] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [anon_sym_pub] = ACTIONS(2453),
    [anon_sym_mut] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_interface] = ACTIONS(2453),
    [anon_sym_QMARK] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(2453),
    [anon_sym_go] = ACTIONS(2453),
    [anon_sym_spawn] = ACTIONS(2453),
    [anon_sym_json_DOTdecode] = ACTIONS(2453),
    [anon_sym_LBRACK2] = ACTIONS(2453),
    [anon_sym_TILDE] = ACTIONS(2453),
    [anon_sym_CARET] = ACTIONS(2453),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_LT_DASH] = ACTIONS(2453),
    [sym_none] = ACTIONS(2453),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [sym_nil] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_DOLLARif] = ACTIONS(2453),
    [anon_sym_match] = ACTIONS(2453),
    [anon_sym_select] = ACTIONS(2453),
    [anon_sym_lock] = ACTIONS(2453),
    [anon_sym_rlock] = ACTIONS(2453),
    [anon_sym_unsafe] = ACTIONS(2453),
    [anon_sym_sql] = ACTIONS(2453),
    [sym_int_literal] = ACTIONS(2453),
    [sym_float_literal] = ACTIONS(2453),
    [sym_rune_literal] = ACTIONS(2453),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2453),
    [anon_sym_c_SQUOTE] = ACTIONS(2453),
    [anon_sym_c_DQUOTE] = ACTIONS(2453),
    [anon_sym_r_SQUOTE] = ACTIONS(2453),
    [anon_sym_r_DQUOTE] = ACTIONS(2453),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [aux_sym_sum_type_token1] = ACTIONS(2453),
    [anon_sym_PIPE2] = ACTIONS(2451),
    [anon_sym_map_LBRACK] = ACTIONS(2453),
    [anon_sym_chan] = ACTIONS(2453),
    [anon_sym_thread] = ACTIONS(2453),
    [anon_sym_atomic] = ACTIONS(2453),
    [anon_sym_assert] = ACTIONS(2453),
    [anon_sym_defer] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_DOLLARfor] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_POUND] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
    [anon_sym_AT_LBRACK] = ACTIONS(2453),
  },
  [1719] = {
    [sym_line_comment] = STATE(1719),
    [sym_block_comment] = STATE(1719),
    [ts_builtin_sym_end] = ACTIONS(2891),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LF] = ACTIONS(2893),
    [anon_sym_CR] = ACTIONS(2893),
    [anon_sym_CR_LF] = ACTIONS(2893),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2893),
    [anon_sym___global] = ACTIONS(2893),
    [anon_sym_type] = ACTIONS(2893),
    [anon_sym_fn] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [anon_sym_pub] = ACTIONS(2893),
    [anon_sym_mut] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_interface] = ACTIONS(2893),
    [anon_sym_QMARK] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_go] = ACTIONS(2893),
    [anon_sym_spawn] = ACTIONS(2893),
    [anon_sym_json_DOTdecode] = ACTIONS(2893),
    [anon_sym_LBRACK2] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_LT_DASH] = ACTIONS(2893),
    [sym_none] = ACTIONS(2893),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [sym_nil] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_DOLLARif] = ACTIONS(2893),
    [anon_sym_match] = ACTIONS(2893),
    [anon_sym_select] = ACTIONS(2893),
    [anon_sym_lock] = ACTIONS(2893),
    [anon_sym_rlock] = ACTIONS(2893),
    [anon_sym_unsafe] = ACTIONS(2893),
    [anon_sym_sql] = ACTIONS(2893),
    [sym_int_literal] = ACTIONS(2893),
    [sym_float_literal] = ACTIONS(2893),
    [sym_rune_literal] = ACTIONS(2893),
    [anon_sym_SQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(2893),
    [anon_sym_c_SQUOTE] = ACTIONS(2893),
    [anon_sym_c_DQUOTE] = ACTIONS(2893),
    [anon_sym_r_SQUOTE] = ACTIONS(2893),
    [anon_sym_r_DQUOTE] = ACTIONS(2893),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [aux_sym_sum_type_token1] = ACTIONS(2893),
    [anon_sym_PIPE2] = ACTIONS(2891),
    [anon_sym_map_LBRACK] = ACTIONS(2893),
    [anon_sym_chan] = ACTIONS(2893),
    [anon_sym_thread] = ACTIONS(2893),
    [anon_sym_atomic] = ACTIONS(2893),
    [anon_sym_assert] = ACTIONS(2893),
    [anon_sym_defer] = ACTIONS(2893),
    [anon_sym_goto] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_DOLLARfor] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_POUND] = ACTIONS(2893),
    [anon_sym_asm] = ACTIONS(2893),
    [anon_sym_AT_LBRACK] = ACTIONS(2893),
  },
  [1720] = {
    [sym_line_comment] = STATE(1720),
    [sym_block_comment] = STATE(1720),
    [ts_builtin_sym_end] = ACTIONS(3082),
    [sym_identifier] = ACTIONS(3084),
    [anon_sym_LF] = ACTIONS(3084),
    [anon_sym_CR] = ACTIONS(3084),
    [anon_sym_CR_LF] = ACTIONS(3084),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3084),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_const] = ACTIONS(3084),
    [anon_sym_LPAREN] = ACTIONS(3084),
    [anon_sym___global] = ACTIONS(3084),
    [anon_sym_type] = ACTIONS(3084),
    [anon_sym_fn] = ACTIONS(3084),
    [anon_sym_PLUS] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_struct] = ACTIONS(3084),
    [anon_sym_union] = ACTIONS(3084),
    [anon_sym_pub] = ACTIONS(3084),
    [anon_sym_mut] = ACTIONS(3084),
    [anon_sym_enum] = ACTIONS(3084),
    [anon_sym_interface] = ACTIONS(3084),
    [anon_sym_QMARK] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_go] = ACTIONS(3084),
    [anon_sym_spawn] = ACTIONS(3084),
    [anon_sym_json_DOTdecode] = ACTIONS(3084),
    [anon_sym_LBRACK2] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_CARET] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3084),
    [anon_sym_LT_DASH] = ACTIONS(3084),
    [sym_none] = ACTIONS(3084),
    [sym_true] = ACTIONS(3084),
    [sym_false] = ACTIONS(3084),
    [sym_nil] = ACTIONS(3084),
    [anon_sym_if] = ACTIONS(3084),
    [anon_sym_DOLLARif] = ACTIONS(3084),
    [anon_sym_match] = ACTIONS(3084),
    [anon_sym_select] = ACTIONS(3084),
    [anon_sym_lock] = ACTIONS(3084),
    [anon_sym_rlock] = ACTIONS(3084),
    [anon_sym_unsafe] = ACTIONS(3084),
    [anon_sym_sql] = ACTIONS(3084),
    [sym_int_literal] = ACTIONS(3084),
    [sym_float_literal] = ACTIONS(3084),
    [sym_rune_literal] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [anon_sym_c_SQUOTE] = ACTIONS(3084),
    [anon_sym_c_DQUOTE] = ACTIONS(3084),
    [anon_sym_r_SQUOTE] = ACTIONS(3084),
    [anon_sym_r_DQUOTE] = ACTIONS(3084),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3084),
    [anon_sym_shared] = ACTIONS(3084),
    [aux_sym_sum_type_token1] = ACTIONS(3084),
    [anon_sym_PIPE2] = ACTIONS(3082),
    [anon_sym_map_LBRACK] = ACTIONS(3084),
    [anon_sym_chan] = ACTIONS(3084),
    [anon_sym_thread] = ACTIONS(3084),
    [anon_sym_atomic] = ACTIONS(3084),
    [anon_sym_assert] = ACTIONS(3084),
    [anon_sym_defer] = ACTIONS(3084),
    [anon_sym_goto] = ACTIONS(3084),
    [anon_sym_break] = ACTIONS(3084),
    [anon_sym_continue] = ACTIONS(3084),
    [anon_sym_return] = ACTIONS(3084),
    [anon_sym_DOLLARfor] = ACTIONS(3084),
    [anon_sym_for] = ACTIONS(3084),
    [anon_sym_POUND] = ACTIONS(3084),
    [anon_sym_asm] = ACTIONS(3084),
    [anon_sym_AT_LBRACK] = ACTIONS(3084),
  },
  [1721] = {
    [sym_line_comment] = STATE(1721),
    [sym_block_comment] = STATE(1721),
    [ts_builtin_sym_end] = ACTIONS(2185),
    [sym_identifier] = ACTIONS(2187),
    [anon_sym_LF] = ACTIONS(2187),
    [anon_sym_CR] = ACTIONS(2187),
    [anon_sym_CR_LF] = ACTIONS(2187),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_const] = ACTIONS(2187),
    [anon_sym_LPAREN] = ACTIONS(2187),
    [anon_sym___global] = ACTIONS(2187),
    [anon_sym_type] = ACTIONS(2187),
    [anon_sym_fn] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_struct] = ACTIONS(2187),
    [anon_sym_union] = ACTIONS(2187),
    [anon_sym_pub] = ACTIONS(2187),
    [anon_sym_mut] = ACTIONS(2187),
    [anon_sym_enum] = ACTIONS(2187),
    [anon_sym_interface] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_go] = ACTIONS(2187),
    [anon_sym_spawn] = ACTIONS(2187),
    [anon_sym_json_DOTdecode] = ACTIONS(2187),
    [anon_sym_LBRACK2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_LT_DASH] = ACTIONS(2187),
    [sym_none] = ACTIONS(2187),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [sym_nil] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_DOLLARif] = ACTIONS(2187),
    [anon_sym_match] = ACTIONS(2187),
    [anon_sym_select] = ACTIONS(2187),
    [anon_sym_lock] = ACTIONS(2187),
    [anon_sym_rlock] = ACTIONS(2187),
    [anon_sym_unsafe] = ACTIONS(2187),
    [anon_sym_sql] = ACTIONS(2187),
    [sym_int_literal] = ACTIONS(2187),
    [sym_float_literal] = ACTIONS(2187),
    [sym_rune_literal] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(2187),
    [anon_sym_DQUOTE] = ACTIONS(2187),
    [anon_sym_c_SQUOTE] = ACTIONS(2187),
    [anon_sym_c_DQUOTE] = ACTIONS(2187),
    [anon_sym_r_SQUOTE] = ACTIONS(2187),
    [anon_sym_r_DQUOTE] = ACTIONS(2187),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2187),
    [anon_sym_shared] = ACTIONS(2187),
    [aux_sym_sum_type_token1] = ACTIONS(2187),
    [anon_sym_PIPE2] = ACTIONS(2185),
    [anon_sym_map_LBRACK] = ACTIONS(2187),
    [anon_sym_chan] = ACTIONS(2187),
    [anon_sym_thread] = ACTIONS(2187),
    [anon_sym_atomic] = ACTIONS(2187),
    [anon_sym_assert] = ACTIONS(2187),
    [anon_sym_defer] = ACTIONS(2187),
    [anon_sym_goto] = ACTIONS(2187),
    [anon_sym_break] = ACTIONS(2187),
    [anon_sym_continue] = ACTIONS(2187),
    [anon_sym_return] = ACTIONS(2187),
    [anon_sym_DOLLARfor] = ACTIONS(2187),
    [anon_sym_for] = ACTIONS(2187),
    [anon_sym_POUND] = ACTIONS(2187),
    [anon_sym_asm] = ACTIONS(2187),
    [anon_sym_AT_LBRACK] = ACTIONS(2187),
  },
  [1722] = {
    [sym_line_comment] = STATE(1722),
    [sym_block_comment] = STATE(1722),
    [ts_builtin_sym_end] = ACTIONS(2965),
    [sym_identifier] = ACTIONS(2967),
    [anon_sym_LF] = ACTIONS(2967),
    [anon_sym_CR] = ACTIONS(2967),
    [anon_sym_CR_LF] = ACTIONS(2967),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(2967),
    [anon_sym___global] = ACTIONS(2967),
    [anon_sym_type] = ACTIONS(2967),
    [anon_sym_fn] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2967),
    [anon_sym_struct] = ACTIONS(2967),
    [anon_sym_union] = ACTIONS(2967),
    [anon_sym_pub] = ACTIONS(2967),
    [anon_sym_mut] = ACTIONS(2967),
    [anon_sym_enum] = ACTIONS(2967),
    [anon_sym_interface] = ACTIONS(2967),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_BANG] = ACTIONS(2967),
    [anon_sym_go] = ACTIONS(2967),
    [anon_sym_spawn] = ACTIONS(2967),
    [anon_sym_json_DOTdecode] = ACTIONS(2967),
    [anon_sym_LBRACK2] = ACTIONS(2967),
    [anon_sym_TILDE] = ACTIONS(2967),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_AMP] = ACTIONS(2967),
    [anon_sym_LT_DASH] = ACTIONS(2967),
    [sym_none] = ACTIONS(2967),
    [sym_true] = ACTIONS(2967),
    [sym_false] = ACTIONS(2967),
    [sym_nil] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_DOLLARif] = ACTIONS(2967),
    [anon_sym_match] = ACTIONS(2967),
    [anon_sym_select] = ACTIONS(2967),
    [anon_sym_lock] = ACTIONS(2967),
    [anon_sym_rlock] = ACTIONS(2967),
    [anon_sym_unsafe] = ACTIONS(2967),
    [anon_sym_sql] = ACTIONS(2967),
    [sym_int_literal] = ACTIONS(2967),
    [sym_float_literal] = ACTIONS(2967),
    [sym_rune_literal] = ACTIONS(2967),
    [anon_sym_SQUOTE] = ACTIONS(2967),
    [anon_sym_DQUOTE] = ACTIONS(2967),
    [anon_sym_c_SQUOTE] = ACTIONS(2967),
    [anon_sym_c_DQUOTE] = ACTIONS(2967),
    [anon_sym_r_SQUOTE] = ACTIONS(2967),
    [anon_sym_r_DQUOTE] = ACTIONS(2967),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2967),
    [anon_sym_shared] = ACTIONS(2967),
    [aux_sym_sum_type_token1] = ACTIONS(2967),
    [anon_sym_PIPE2] = ACTIONS(2965),
    [anon_sym_map_LBRACK] = ACTIONS(2967),
    [anon_sym_chan] = ACTIONS(2967),
    [anon_sym_thread] = ACTIONS(2967),
    [anon_sym_atomic] = ACTIONS(2967),
    [anon_sym_assert] = ACTIONS(2967),
    [anon_sym_defer] = ACTIONS(2967),
    [anon_sym_goto] = ACTIONS(2967),
    [anon_sym_break] = ACTIONS(2967),
    [anon_sym_continue] = ACTIONS(2967),
    [anon_sym_return] = ACTIONS(2967),
    [anon_sym_DOLLARfor] = ACTIONS(2967),
    [anon_sym_for] = ACTIONS(2967),
    [anon_sym_POUND] = ACTIONS(2967),
    [anon_sym_asm] = ACTIONS(2967),
    [anon_sym_AT_LBRACK] = ACTIONS(2967),
  },
  [1723] = {
    [sym_line_comment] = STATE(1723),
    [sym_block_comment] = STATE(1723),
    [ts_builtin_sym_end] = ACTIONS(3047),
    [sym_identifier] = ACTIONS(3049),
    [anon_sym_LF] = ACTIONS(3049),
    [anon_sym_CR] = ACTIONS(3049),
    [anon_sym_CR_LF] = ACTIONS(3049),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_const] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [anon_sym___global] = ACTIONS(3049),
    [anon_sym_type] = ACTIONS(3049),
    [anon_sym_fn] = ACTIONS(3049),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_STAR] = ACTIONS(3049),
    [anon_sym_struct] = ACTIONS(3049),
    [anon_sym_union] = ACTIONS(3049),
    [anon_sym_pub] = ACTIONS(3049),
    [anon_sym_mut] = ACTIONS(3049),
    [anon_sym_enum] = ACTIONS(3049),
    [anon_sym_interface] = ACTIONS(3049),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_BANG] = ACTIONS(3049),
    [anon_sym_go] = ACTIONS(3049),
    [anon_sym_spawn] = ACTIONS(3049),
    [anon_sym_json_DOTdecode] = ACTIONS(3049),
    [anon_sym_LBRACK2] = ACTIONS(3049),
    [anon_sym_TILDE] = ACTIONS(3049),
    [anon_sym_CARET] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_LT_DASH] = ACTIONS(3049),
    [sym_none] = ACTIONS(3049),
    [sym_true] = ACTIONS(3049),
    [sym_false] = ACTIONS(3049),
    [sym_nil] = ACTIONS(3049),
    [anon_sym_if] = ACTIONS(3049),
    [anon_sym_DOLLARif] = ACTIONS(3049),
    [anon_sym_match] = ACTIONS(3049),
    [anon_sym_select] = ACTIONS(3049),
    [anon_sym_lock] = ACTIONS(3049),
    [anon_sym_rlock] = ACTIONS(3049),
    [anon_sym_unsafe] = ACTIONS(3049),
    [anon_sym_sql] = ACTIONS(3049),
    [sym_int_literal] = ACTIONS(3049),
    [sym_float_literal] = ACTIONS(3049),
    [sym_rune_literal] = ACTIONS(3049),
    [anon_sym_SQUOTE] = ACTIONS(3049),
    [anon_sym_DQUOTE] = ACTIONS(3049),
    [anon_sym_c_SQUOTE] = ACTIONS(3049),
    [anon_sym_c_DQUOTE] = ACTIONS(3049),
    [anon_sym_r_SQUOTE] = ACTIONS(3049),
    [anon_sym_r_DQUOTE] = ACTIONS(3049),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3049),
    [anon_sym_shared] = ACTIONS(3049),
    [aux_sym_sum_type_token1] = ACTIONS(3049),
    [anon_sym_PIPE2] = ACTIONS(3047),
    [anon_sym_map_LBRACK] = ACTIONS(3049),
    [anon_sym_chan] = ACTIONS(3049),
    [anon_sym_thread] = ACTIONS(3049),
    [anon_sym_atomic] = ACTIONS(3049),
    [anon_sym_assert] = ACTIONS(3049),
    [anon_sym_defer] = ACTIONS(3049),
    [anon_sym_goto] = ACTIONS(3049),
    [anon_sym_break] = ACTIONS(3049),
    [anon_sym_continue] = ACTIONS(3049),
    [anon_sym_return] = ACTIONS(3049),
    [anon_sym_DOLLARfor] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3049),
    [anon_sym_POUND] = ACTIONS(3049),
    [anon_sym_asm] = ACTIONS(3049),
    [anon_sym_AT_LBRACK] = ACTIONS(3049),
  },
  [1724] = {
    [sym_line_comment] = STATE(1724),
    [sym_block_comment] = STATE(1724),
    [ts_builtin_sym_end] = ACTIONS(3053),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_LF] = ACTIONS(3055),
    [anon_sym_CR] = ACTIONS(3055),
    [anon_sym_CR_LF] = ACTIONS(3055),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_const] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym___global] = ACTIONS(3055),
    [anon_sym_type] = ACTIONS(3055),
    [anon_sym_fn] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3055),
    [anon_sym_struct] = ACTIONS(3055),
    [anon_sym_union] = ACTIONS(3055),
    [anon_sym_pub] = ACTIONS(3055),
    [anon_sym_mut] = ACTIONS(3055),
    [anon_sym_enum] = ACTIONS(3055),
    [anon_sym_interface] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_BANG] = ACTIONS(3055),
    [anon_sym_go] = ACTIONS(3055),
    [anon_sym_spawn] = ACTIONS(3055),
    [anon_sym_json_DOTdecode] = ACTIONS(3055),
    [anon_sym_LBRACK2] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3055),
    [anon_sym_CARET] = ACTIONS(3055),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT_DASH] = ACTIONS(3055),
    [sym_none] = ACTIONS(3055),
    [sym_true] = ACTIONS(3055),
    [sym_false] = ACTIONS(3055),
    [sym_nil] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_DOLLARif] = ACTIONS(3055),
    [anon_sym_match] = ACTIONS(3055),
    [anon_sym_select] = ACTIONS(3055),
    [anon_sym_lock] = ACTIONS(3055),
    [anon_sym_rlock] = ACTIONS(3055),
    [anon_sym_unsafe] = ACTIONS(3055),
    [anon_sym_sql] = ACTIONS(3055),
    [sym_int_literal] = ACTIONS(3055),
    [sym_float_literal] = ACTIONS(3055),
    [sym_rune_literal] = ACTIONS(3055),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_c_SQUOTE] = ACTIONS(3055),
    [anon_sym_c_DQUOTE] = ACTIONS(3055),
    [anon_sym_r_SQUOTE] = ACTIONS(3055),
    [anon_sym_r_DQUOTE] = ACTIONS(3055),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3055),
    [anon_sym_shared] = ACTIONS(3055),
    [aux_sym_sum_type_token1] = ACTIONS(3055),
    [anon_sym_PIPE2] = ACTIONS(3053),
    [anon_sym_map_LBRACK] = ACTIONS(3055),
    [anon_sym_chan] = ACTIONS(3055),
    [anon_sym_thread] = ACTIONS(3055),
    [anon_sym_atomic] = ACTIONS(3055),
    [anon_sym_assert] = ACTIONS(3055),
    [anon_sym_defer] = ACTIONS(3055),
    [anon_sym_goto] = ACTIONS(3055),
    [anon_sym_break] = ACTIONS(3055),
    [anon_sym_continue] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_DOLLARfor] = ACTIONS(3055),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_POUND] = ACTIONS(3055),
    [anon_sym_asm] = ACTIONS(3055),
    [anon_sym_AT_LBRACK] = ACTIONS(3055),
  },
  [1725] = {
    [sym_line_comment] = STATE(1725),
    [sym_block_comment] = STATE(1725),
    [ts_builtin_sym_end] = ACTIONS(3039),
    [sym_identifier] = ACTIONS(3041),
    [anon_sym_LF] = ACTIONS(3041),
    [anon_sym_CR] = ACTIONS(3041),
    [anon_sym_CR_LF] = ACTIONS(3041),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3041),
    [anon_sym_const] = ACTIONS(3041),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym___global] = ACTIONS(3041),
    [anon_sym_type] = ACTIONS(3041),
    [anon_sym_fn] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3041),
    [anon_sym_DASH] = ACTIONS(3041),
    [anon_sym_STAR] = ACTIONS(3041),
    [anon_sym_struct] = ACTIONS(3041),
    [anon_sym_union] = ACTIONS(3041),
    [anon_sym_pub] = ACTIONS(3041),
    [anon_sym_mut] = ACTIONS(3041),
    [anon_sym_enum] = ACTIONS(3041),
    [anon_sym_interface] = ACTIONS(3041),
    [anon_sym_QMARK] = ACTIONS(3041),
    [anon_sym_BANG] = ACTIONS(3041),
    [anon_sym_go] = ACTIONS(3041),
    [anon_sym_spawn] = ACTIONS(3041),
    [anon_sym_json_DOTdecode] = ACTIONS(3041),
    [anon_sym_LBRACK2] = ACTIONS(3041),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_CARET] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3041),
    [anon_sym_LT_DASH] = ACTIONS(3041),
    [sym_none] = ACTIONS(3041),
    [sym_true] = ACTIONS(3041),
    [sym_false] = ACTIONS(3041),
    [sym_nil] = ACTIONS(3041),
    [anon_sym_if] = ACTIONS(3041),
    [anon_sym_DOLLARif] = ACTIONS(3041),
    [anon_sym_match] = ACTIONS(3041),
    [anon_sym_select] = ACTIONS(3041),
    [anon_sym_lock] = ACTIONS(3041),
    [anon_sym_rlock] = ACTIONS(3041),
    [anon_sym_unsafe] = ACTIONS(3041),
    [anon_sym_sql] = ACTIONS(3041),
    [sym_int_literal] = ACTIONS(3041),
    [sym_float_literal] = ACTIONS(3041),
    [sym_rune_literal] = ACTIONS(3041),
    [anon_sym_SQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE] = ACTIONS(3041),
    [anon_sym_c_SQUOTE] = ACTIONS(3041),
    [anon_sym_c_DQUOTE] = ACTIONS(3041),
    [anon_sym_r_SQUOTE] = ACTIONS(3041),
    [anon_sym_r_DQUOTE] = ACTIONS(3041),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3041),
    [anon_sym_shared] = ACTIONS(3041),
    [aux_sym_sum_type_token1] = ACTIONS(3041),
    [anon_sym_PIPE2] = ACTIONS(3039),
    [anon_sym_map_LBRACK] = ACTIONS(3041),
    [anon_sym_chan] = ACTIONS(3041),
    [anon_sym_thread] = ACTIONS(3041),
    [anon_sym_atomic] = ACTIONS(3041),
    [anon_sym_assert] = ACTIONS(3041),
    [anon_sym_defer] = ACTIONS(3041),
    [anon_sym_goto] = ACTIONS(3041),
    [anon_sym_break] = ACTIONS(3041),
    [anon_sym_continue] = ACTIONS(3041),
    [anon_sym_return] = ACTIONS(3041),
    [anon_sym_DOLLARfor] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3041),
    [anon_sym_POUND] = ACTIONS(3041),
    [anon_sym_asm] = ACTIONS(3041),
    [anon_sym_AT_LBRACK] = ACTIONS(3041),
  },
  [1726] = {
    [sym_line_comment] = STATE(1726),
    [sym_block_comment] = STATE(1726),
    [ts_builtin_sym_end] = ACTIONS(3244),
    [sym_identifier] = ACTIONS(3246),
    [anon_sym_LF] = ACTIONS(3246),
    [anon_sym_CR] = ACTIONS(3246),
    [anon_sym_CR_LF] = ACTIONS(3246),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3246),
    [anon_sym_LBRACE] = ACTIONS(3246),
    [anon_sym_const] = ACTIONS(3246),
    [anon_sym_LPAREN] = ACTIONS(3246),
    [anon_sym___global] = ACTIONS(3246),
    [anon_sym_type] = ACTIONS(3246),
    [anon_sym_fn] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3246),
    [anon_sym_DASH] = ACTIONS(3246),
    [anon_sym_STAR] = ACTIONS(3246),
    [anon_sym_struct] = ACTIONS(3246),
    [anon_sym_union] = ACTIONS(3246),
    [anon_sym_pub] = ACTIONS(3246),
    [anon_sym_mut] = ACTIONS(3246),
    [anon_sym_enum] = ACTIONS(3246),
    [anon_sym_interface] = ACTIONS(3246),
    [anon_sym_QMARK] = ACTIONS(3246),
    [anon_sym_BANG] = ACTIONS(3246),
    [anon_sym_go] = ACTIONS(3246),
    [anon_sym_spawn] = ACTIONS(3246),
    [anon_sym_json_DOTdecode] = ACTIONS(3246),
    [anon_sym_LBRACK2] = ACTIONS(3246),
    [anon_sym_TILDE] = ACTIONS(3246),
    [anon_sym_CARET] = ACTIONS(3246),
    [anon_sym_AMP] = ACTIONS(3246),
    [anon_sym_LT_DASH] = ACTIONS(3246),
    [sym_none] = ACTIONS(3246),
    [sym_true] = ACTIONS(3246),
    [sym_false] = ACTIONS(3246),
    [sym_nil] = ACTIONS(3246),
    [anon_sym_if] = ACTIONS(3246),
    [anon_sym_DOLLARif] = ACTIONS(3246),
    [anon_sym_match] = ACTIONS(3246),
    [anon_sym_select] = ACTIONS(3246),
    [anon_sym_lock] = ACTIONS(3246),
    [anon_sym_rlock] = ACTIONS(3246),
    [anon_sym_unsafe] = ACTIONS(3246),
    [anon_sym_sql] = ACTIONS(3246),
    [sym_int_literal] = ACTIONS(3246),
    [sym_float_literal] = ACTIONS(3246),
    [sym_rune_literal] = ACTIONS(3246),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_DQUOTE] = ACTIONS(3246),
    [anon_sym_c_SQUOTE] = ACTIONS(3246),
    [anon_sym_c_DQUOTE] = ACTIONS(3246),
    [anon_sym_r_SQUOTE] = ACTIONS(3246),
    [anon_sym_r_DQUOTE] = ACTIONS(3246),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3246),
    [anon_sym_shared] = ACTIONS(3246),
    [aux_sym_sum_type_token1] = ACTIONS(3246),
    [anon_sym_PIPE2] = ACTIONS(3244),
    [anon_sym_map_LBRACK] = ACTIONS(3246),
    [anon_sym_chan] = ACTIONS(3246),
    [anon_sym_thread] = ACTIONS(3246),
    [anon_sym_atomic] = ACTIONS(3246),
    [anon_sym_assert] = ACTIONS(3246),
    [anon_sym_defer] = ACTIONS(3246),
    [anon_sym_goto] = ACTIONS(3246),
    [anon_sym_break] = ACTIONS(3246),
    [anon_sym_continue] = ACTIONS(3246),
    [anon_sym_return] = ACTIONS(3246),
    [anon_sym_DOLLARfor] = ACTIONS(3246),
    [anon_sym_for] = ACTIONS(3246),
    [anon_sym_POUND] = ACTIONS(3246),
    [anon_sym_asm] = ACTIONS(3246),
    [anon_sym_AT_LBRACK] = ACTIONS(3246),
  },
  [1727] = {
    [sym_line_comment] = STATE(1727),
    [sym_block_comment] = STATE(1727),
    [ts_builtin_sym_end] = ACTIONS(3264),
    [sym_identifier] = ACTIONS(3266),
    [anon_sym_LF] = ACTIONS(3266),
    [anon_sym_CR] = ACTIONS(3266),
    [anon_sym_CR_LF] = ACTIONS(3266),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3266),
    [anon_sym_LBRACE] = ACTIONS(3266),
    [anon_sym_const] = ACTIONS(3266),
    [anon_sym_LPAREN] = ACTIONS(3266),
    [anon_sym___global] = ACTIONS(3266),
    [anon_sym_type] = ACTIONS(3266),
    [anon_sym_fn] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3266),
    [anon_sym_DASH] = ACTIONS(3266),
    [anon_sym_STAR] = ACTIONS(3266),
    [anon_sym_struct] = ACTIONS(3266),
    [anon_sym_union] = ACTIONS(3266),
    [anon_sym_pub] = ACTIONS(3266),
    [anon_sym_mut] = ACTIONS(3266),
    [anon_sym_enum] = ACTIONS(3266),
    [anon_sym_interface] = ACTIONS(3266),
    [anon_sym_QMARK] = ACTIONS(3266),
    [anon_sym_BANG] = ACTIONS(3266),
    [anon_sym_go] = ACTIONS(3266),
    [anon_sym_spawn] = ACTIONS(3266),
    [anon_sym_json_DOTdecode] = ACTIONS(3266),
    [anon_sym_LBRACK2] = ACTIONS(3266),
    [anon_sym_TILDE] = ACTIONS(3266),
    [anon_sym_CARET] = ACTIONS(3266),
    [anon_sym_AMP] = ACTIONS(3266),
    [anon_sym_LT_DASH] = ACTIONS(3266),
    [sym_none] = ACTIONS(3266),
    [sym_true] = ACTIONS(3266),
    [sym_false] = ACTIONS(3266),
    [sym_nil] = ACTIONS(3266),
    [anon_sym_if] = ACTIONS(3266),
    [anon_sym_DOLLARif] = ACTIONS(3266),
    [anon_sym_match] = ACTIONS(3266),
    [anon_sym_select] = ACTIONS(3266),
    [anon_sym_lock] = ACTIONS(3266),
    [anon_sym_rlock] = ACTIONS(3266),
    [anon_sym_unsafe] = ACTIONS(3266),
    [anon_sym_sql] = ACTIONS(3266),
    [sym_int_literal] = ACTIONS(3266),
    [sym_float_literal] = ACTIONS(3266),
    [sym_rune_literal] = ACTIONS(3266),
    [anon_sym_SQUOTE] = ACTIONS(3266),
    [anon_sym_DQUOTE] = ACTIONS(3266),
    [anon_sym_c_SQUOTE] = ACTIONS(3266),
    [anon_sym_c_DQUOTE] = ACTIONS(3266),
    [anon_sym_r_SQUOTE] = ACTIONS(3266),
    [anon_sym_r_DQUOTE] = ACTIONS(3266),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3266),
    [anon_sym_shared] = ACTIONS(3266),
    [aux_sym_sum_type_token1] = ACTIONS(3266),
    [anon_sym_PIPE2] = ACTIONS(3264),
    [anon_sym_map_LBRACK] = ACTIONS(3266),
    [anon_sym_chan] = ACTIONS(3266),
    [anon_sym_thread] = ACTIONS(3266),
    [anon_sym_atomic] = ACTIONS(3266),
    [anon_sym_assert] = ACTIONS(3266),
    [anon_sym_defer] = ACTIONS(3266),
    [anon_sym_goto] = ACTIONS(3266),
    [anon_sym_break] = ACTIONS(3266),
    [anon_sym_continue] = ACTIONS(3266),
    [anon_sym_return] = ACTIONS(3266),
    [anon_sym_DOLLARfor] = ACTIONS(3266),
    [anon_sym_for] = ACTIONS(3266),
    [anon_sym_POUND] = ACTIONS(3266),
    [anon_sym_asm] = ACTIONS(3266),
    [anon_sym_AT_LBRACK] = ACTIONS(3266),
  },
  [1728] = {
    [sym_line_comment] = STATE(1728),
    [sym_block_comment] = STATE(1728),
    [ts_builtin_sym_end] = ACTIONS(3268),
    [sym_identifier] = ACTIONS(3270),
    [anon_sym_LF] = ACTIONS(3270),
    [anon_sym_CR] = ACTIONS(3270),
    [anon_sym_CR_LF] = ACTIONS(3270),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3270),
    [anon_sym_LBRACE] = ACTIONS(3270),
    [anon_sym_const] = ACTIONS(3270),
    [anon_sym_LPAREN] = ACTIONS(3270),
    [anon_sym___global] = ACTIONS(3270),
    [anon_sym_type] = ACTIONS(3270),
    [anon_sym_fn] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3270),
    [anon_sym_DASH] = ACTIONS(3270),
    [anon_sym_STAR] = ACTIONS(3270),
    [anon_sym_struct] = ACTIONS(3270),
    [anon_sym_union] = ACTIONS(3270),
    [anon_sym_pub] = ACTIONS(3270),
    [anon_sym_mut] = ACTIONS(3270),
    [anon_sym_enum] = ACTIONS(3270),
    [anon_sym_interface] = ACTIONS(3270),
    [anon_sym_QMARK] = ACTIONS(3270),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_go] = ACTIONS(3270),
    [anon_sym_spawn] = ACTIONS(3270),
    [anon_sym_json_DOTdecode] = ACTIONS(3270),
    [anon_sym_LBRACK2] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3270),
    [anon_sym_CARET] = ACTIONS(3270),
    [anon_sym_AMP] = ACTIONS(3270),
    [anon_sym_LT_DASH] = ACTIONS(3270),
    [sym_none] = ACTIONS(3270),
    [sym_true] = ACTIONS(3270),
    [sym_false] = ACTIONS(3270),
    [sym_nil] = ACTIONS(3270),
    [anon_sym_if] = ACTIONS(3270),
    [anon_sym_DOLLARif] = ACTIONS(3270),
    [anon_sym_match] = ACTIONS(3270),
    [anon_sym_select] = ACTIONS(3270),
    [anon_sym_lock] = ACTIONS(3270),
    [anon_sym_rlock] = ACTIONS(3270),
    [anon_sym_unsafe] = ACTIONS(3270),
    [anon_sym_sql] = ACTIONS(3270),
    [sym_int_literal] = ACTIONS(3270),
    [sym_float_literal] = ACTIONS(3270),
    [sym_rune_literal] = ACTIONS(3270),
    [anon_sym_SQUOTE] = ACTIONS(3270),
    [anon_sym_DQUOTE] = ACTIONS(3270),
    [anon_sym_c_SQUOTE] = ACTIONS(3270),
    [anon_sym_c_DQUOTE] = ACTIONS(3270),
    [anon_sym_r_SQUOTE] = ACTIONS(3270),
    [anon_sym_r_DQUOTE] = ACTIONS(3270),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3270),
    [anon_sym_shared] = ACTIONS(3270),
    [aux_sym_sum_type_token1] = ACTIONS(3270),
    [anon_sym_PIPE2] = ACTIONS(3268),
    [anon_sym_map_LBRACK] = ACTIONS(3270),
    [anon_sym_chan] = ACTIONS(3270),
    [anon_sym_thread] = ACTIONS(3270),
    [anon_sym_atomic] = ACTIONS(3270),
    [anon_sym_assert] = ACTIONS(3270),
    [anon_sym_defer] = ACTIONS(3270),
    [anon_sym_goto] = ACTIONS(3270),
    [anon_sym_break] = ACTIONS(3270),
    [anon_sym_continue] = ACTIONS(3270),
    [anon_sym_return] = ACTIONS(3270),
    [anon_sym_DOLLARfor] = ACTIONS(3270),
    [anon_sym_for] = ACTIONS(3270),
    [anon_sym_POUND] = ACTIONS(3270),
    [anon_sym_asm] = ACTIONS(3270),
    [anon_sym_AT_LBRACK] = ACTIONS(3270),
  },
  [1729] = {
    [sym_line_comment] = STATE(1729),
    [sym_block_comment] = STATE(1729),
    [ts_builtin_sym_end] = ACTIONS(2399),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_LF] = ACTIONS(2401),
    [anon_sym_CR] = ACTIONS(2401),
    [anon_sym_CR_LF] = ACTIONS(2401),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(2401),
    [anon_sym_const] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2401),
    [anon_sym___global] = ACTIONS(2401),
    [anon_sym_type] = ACTIONS(2401),
    [anon_sym_fn] = ACTIONS(2401),
    [anon_sym_PLUS] = ACTIONS(2401),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_STAR] = ACTIONS(2401),
    [anon_sym_struct] = ACTIONS(2401),
    [anon_sym_union] = ACTIONS(2401),
    [anon_sym_pub] = ACTIONS(2401),
    [anon_sym_mut] = ACTIONS(2401),
    [anon_sym_enum] = ACTIONS(2401),
    [anon_sym_interface] = ACTIONS(2401),
    [anon_sym_QMARK] = ACTIONS(2401),
    [anon_sym_BANG] = ACTIONS(2401),
    [anon_sym_go] = ACTIONS(2401),
    [anon_sym_spawn] = ACTIONS(2401),
    [anon_sym_json_DOTdecode] = ACTIONS(2401),
    [anon_sym_LBRACK2] = ACTIONS(2401),
    [anon_sym_TILDE] = ACTIONS(2401),
    [anon_sym_CARET] = ACTIONS(2401),
    [anon_sym_AMP] = ACTIONS(2401),
    [anon_sym_LT_DASH] = ACTIONS(2401),
    [sym_none] = ACTIONS(2401),
    [sym_true] = ACTIONS(2401),
    [sym_false] = ACTIONS(2401),
    [sym_nil] = ACTIONS(2401),
    [anon_sym_if] = ACTIONS(2401),
    [anon_sym_DOLLARif] = ACTIONS(2401),
    [anon_sym_match] = ACTIONS(2401),
    [anon_sym_select] = ACTIONS(2401),
    [anon_sym_lock] = ACTIONS(2401),
    [anon_sym_rlock] = ACTIONS(2401),
    [anon_sym_unsafe] = ACTIONS(2401),
    [anon_sym_sql] = ACTIONS(2401),
    [sym_int_literal] = ACTIONS(2401),
    [sym_float_literal] = ACTIONS(2401),
    [sym_rune_literal] = ACTIONS(2401),
    [anon_sym_SQUOTE] = ACTIONS(2401),
    [anon_sym_DQUOTE] = ACTIONS(2401),
    [anon_sym_c_SQUOTE] = ACTIONS(2401),
    [anon_sym_c_DQUOTE] = ACTIONS(2401),
    [anon_sym_r_SQUOTE] = ACTIONS(2401),
    [anon_sym_r_DQUOTE] = ACTIONS(2401),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2401),
    [anon_sym_shared] = ACTIONS(2401),
    [aux_sym_sum_type_token1] = ACTIONS(2401),
    [anon_sym_PIPE2] = ACTIONS(2399),
    [anon_sym_map_LBRACK] = ACTIONS(2401),
    [anon_sym_chan] = ACTIONS(2401),
    [anon_sym_thread] = ACTIONS(2401),
    [anon_sym_atomic] = ACTIONS(2401),
    [anon_sym_assert] = ACTIONS(2401),
    [anon_sym_defer] = ACTIONS(2401),
    [anon_sym_goto] = ACTIONS(2401),
    [anon_sym_break] = ACTIONS(2401),
    [anon_sym_continue] = ACTIONS(2401),
    [anon_sym_return] = ACTIONS(2401),
    [anon_sym_DOLLARfor] = ACTIONS(2401),
    [anon_sym_for] = ACTIONS(2401),
    [anon_sym_POUND] = ACTIONS(2401),
    [anon_sym_asm] = ACTIONS(2401),
    [anon_sym_AT_LBRACK] = ACTIONS(2401),
  },
  [1730] = {
    [sym_line_comment] = STATE(1730),
    [sym_block_comment] = STATE(1730),
    [sym_type_parameters] = STATE(1839),
    [ts_builtin_sym_end] = ACTIONS(2185),
    [sym_identifier] = ACTIONS(2187),
    [anon_sym_LF] = ACTIONS(2187),
    [anon_sym_CR] = ACTIONS(2187),
    [anon_sym_CR_LF] = ACTIONS(2187),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_const] = ACTIONS(2187),
    [anon_sym_LPAREN] = ACTIONS(2187),
    [anon_sym___global] = ACTIONS(2187),
    [anon_sym_type] = ACTIONS(2187),
    [anon_sym_fn] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(4418),
    [anon_sym_struct] = ACTIONS(2187),
    [anon_sym_union] = ACTIONS(2187),
    [anon_sym_pub] = ACTIONS(2187),
    [anon_sym_mut] = ACTIONS(2187),
    [anon_sym_enum] = ACTIONS(2187),
    [anon_sym_interface] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_go] = ACTIONS(2187),
    [anon_sym_spawn] = ACTIONS(2187),
    [anon_sym_json_DOTdecode] = ACTIONS(2187),
    [anon_sym_LBRACK2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_LT_DASH] = ACTIONS(2187),
    [sym_none] = ACTIONS(2187),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [sym_nil] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_DOLLARif] = ACTIONS(2187),
    [anon_sym_match] = ACTIONS(2187),
    [anon_sym_select] = ACTIONS(2187),
    [anon_sym_lock] = ACTIONS(2187),
    [anon_sym_rlock] = ACTIONS(2187),
    [anon_sym_unsafe] = ACTIONS(2187),
    [anon_sym_sql] = ACTIONS(2187),
    [sym_int_literal] = ACTIONS(2187),
    [sym_float_literal] = ACTIONS(2187),
    [sym_rune_literal] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(2187),
    [anon_sym_DQUOTE] = ACTIONS(2187),
    [anon_sym_c_SQUOTE] = ACTIONS(2187),
    [anon_sym_c_DQUOTE] = ACTIONS(2187),
    [anon_sym_r_SQUOTE] = ACTIONS(2187),
    [anon_sym_r_DQUOTE] = ACTIONS(2187),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2187),
    [anon_sym_shared] = ACTIONS(2187),
    [anon_sym_map_LBRACK] = ACTIONS(2187),
    [anon_sym_chan] = ACTIONS(2187),
    [anon_sym_thread] = ACTIONS(2187),
    [anon_sym_atomic] = ACTIONS(2187),
    [anon_sym_assert] = ACTIONS(2187),
    [anon_sym_defer] = ACTIONS(2187),
    [anon_sym_goto] = ACTIONS(2187),
    [anon_sym_break] = ACTIONS(2187),
    [anon_sym_continue] = ACTIONS(2187),
    [anon_sym_return] = ACTIONS(2187),
    [anon_sym_DOLLARfor] = ACTIONS(2187),
    [anon_sym_for] = ACTIONS(2187),
    [anon_sym_POUND] = ACTIONS(2187),
    [anon_sym_asm] = ACTIONS(2187),
    [anon_sym_AT_LBRACK] = ACTIONS(2187),
  },
  [1731] = {
    [sym_line_comment] = STATE(1731),
    [sym_block_comment] = STATE(1731),
    [ts_builtin_sym_end] = ACTIONS(2999),
    [sym_identifier] = ACTIONS(3001),
    [anon_sym_LF] = ACTIONS(3001),
    [anon_sym_CR] = ACTIONS(3001),
    [anon_sym_CR_LF] = ACTIONS(3001),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_const] = ACTIONS(3001),
    [anon_sym_LPAREN] = ACTIONS(3001),
    [anon_sym___global] = ACTIONS(3001),
    [anon_sym_type] = ACTIONS(3001),
    [anon_sym_fn] = ACTIONS(3001),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_STAR] = ACTIONS(3001),
    [anon_sym_struct] = ACTIONS(3001),
    [anon_sym_union] = ACTIONS(3001),
    [anon_sym_pub] = ACTIONS(3001),
    [anon_sym_mut] = ACTIONS(3001),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_interface] = ACTIONS(3001),
    [anon_sym_QMARK] = ACTIONS(3001),
    [anon_sym_BANG] = ACTIONS(3001),
    [anon_sym_go] = ACTIONS(3001),
    [anon_sym_spawn] = ACTIONS(3001),
    [anon_sym_json_DOTdecode] = ACTIONS(3001),
    [anon_sym_LBRACK2] = ACTIONS(3001),
    [anon_sym_TILDE] = ACTIONS(3001),
    [anon_sym_CARET] = ACTIONS(3001),
    [anon_sym_AMP] = ACTIONS(3001),
    [anon_sym_LT_DASH] = ACTIONS(3001),
    [sym_none] = ACTIONS(3001),
    [sym_true] = ACTIONS(3001),
    [sym_false] = ACTIONS(3001),
    [sym_nil] = ACTIONS(3001),
    [anon_sym_if] = ACTIONS(3001),
    [anon_sym_DOLLARif] = ACTIONS(3001),
    [anon_sym_match] = ACTIONS(3001),
    [anon_sym_select] = ACTIONS(3001),
    [anon_sym_lock] = ACTIONS(3001),
    [anon_sym_rlock] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(3001),
    [anon_sym_sql] = ACTIONS(3001),
    [sym_int_literal] = ACTIONS(3001),
    [sym_float_literal] = ACTIONS(3001),
    [sym_rune_literal] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3001),
    [anon_sym_DQUOTE] = ACTIONS(3001),
    [anon_sym_c_SQUOTE] = ACTIONS(3001),
    [anon_sym_c_DQUOTE] = ACTIONS(3001),
    [anon_sym_r_SQUOTE] = ACTIONS(3001),
    [anon_sym_r_DQUOTE] = ACTIONS(3001),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3001),
    [anon_sym_shared] = ACTIONS(3001),
    [aux_sym_sum_type_token1] = ACTIONS(3001),
    [anon_sym_PIPE2] = ACTIONS(2999),
    [anon_sym_map_LBRACK] = ACTIONS(3001),
    [anon_sym_chan] = ACTIONS(3001),
    [anon_sym_thread] = ACTIONS(3001),
    [anon_sym_atomic] = ACTIONS(3001),
    [anon_sym_assert] = ACTIONS(3001),
    [anon_sym_defer] = ACTIONS(3001),
    [anon_sym_goto] = ACTIONS(3001),
    [anon_sym_break] = ACTIONS(3001),
    [anon_sym_continue] = ACTIONS(3001),
    [anon_sym_return] = ACTIONS(3001),
    [anon_sym_DOLLARfor] = ACTIONS(3001),
    [anon_sym_for] = ACTIONS(3001),
    [anon_sym_POUND] = ACTIONS(3001),
    [anon_sym_asm] = ACTIONS(3001),
    [anon_sym_AT_LBRACK] = ACTIONS(3001),
  },
  [1732] = {
    [sym_line_comment] = STATE(1732),
    [sym_block_comment] = STATE(1732),
    [ts_builtin_sym_end] = ACTIONS(3290),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_LF] = ACTIONS(3292),
    [anon_sym_CR] = ACTIONS(3292),
    [anon_sym_CR_LF] = ACTIONS(3292),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3292),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_const] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym___global] = ACTIONS(3292),
    [anon_sym_type] = ACTIONS(3292),
    [anon_sym_fn] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_struct] = ACTIONS(3292),
    [anon_sym_union] = ACTIONS(3292),
    [anon_sym_pub] = ACTIONS(3292),
    [anon_sym_mut] = ACTIONS(3292),
    [anon_sym_enum] = ACTIONS(3292),
    [anon_sym_interface] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3292),
    [anon_sym_BANG] = ACTIONS(3292),
    [anon_sym_go] = ACTIONS(3292),
    [anon_sym_spawn] = ACTIONS(3292),
    [anon_sym_json_DOTdecode] = ACTIONS(3292),
    [anon_sym_LBRACK2] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3292),
    [anon_sym_CARET] = ACTIONS(3292),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LT_DASH] = ACTIONS(3292),
    [sym_none] = ACTIONS(3292),
    [sym_true] = ACTIONS(3292),
    [sym_false] = ACTIONS(3292),
    [sym_nil] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_DOLLARif] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_select] = ACTIONS(3292),
    [anon_sym_lock] = ACTIONS(3292),
    [anon_sym_rlock] = ACTIONS(3292),
    [anon_sym_unsafe] = ACTIONS(3292),
    [anon_sym_sql] = ACTIONS(3292),
    [sym_int_literal] = ACTIONS(3292),
    [sym_float_literal] = ACTIONS(3292),
    [sym_rune_literal] = ACTIONS(3292),
    [anon_sym_SQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_c_SQUOTE] = ACTIONS(3292),
    [anon_sym_c_DQUOTE] = ACTIONS(3292),
    [anon_sym_r_SQUOTE] = ACTIONS(3292),
    [anon_sym_r_DQUOTE] = ACTIONS(3292),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3292),
    [anon_sym_shared] = ACTIONS(3292),
    [aux_sym_sum_type_token1] = ACTIONS(3292),
    [anon_sym_PIPE2] = ACTIONS(3290),
    [anon_sym_map_LBRACK] = ACTIONS(3292),
    [anon_sym_chan] = ACTIONS(3292),
    [anon_sym_thread] = ACTIONS(3292),
    [anon_sym_atomic] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_defer] = ACTIONS(3292),
    [anon_sym_goto] = ACTIONS(3292),
    [anon_sym_break] = ACTIONS(3292),
    [anon_sym_continue] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_DOLLARfor] = ACTIONS(3292),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_POUND] = ACTIONS(3292),
    [anon_sym_asm] = ACTIONS(3292),
    [anon_sym_AT_LBRACK] = ACTIONS(3292),
  },
  [1733] = {
    [sym_line_comment] = STATE(1733),
    [sym_block_comment] = STATE(1733),
    [ts_builtin_sym_end] = ACTIONS(2983),
    [sym_identifier] = ACTIONS(2985),
    [anon_sym_LF] = ACTIONS(2985),
    [anon_sym_CR] = ACTIONS(2985),
    [anon_sym_CR_LF] = ACTIONS(2985),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym___global] = ACTIONS(2985),
    [anon_sym_type] = ACTIONS(2985),
    [anon_sym_fn] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2985),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_union] = ACTIONS(2985),
    [anon_sym_pub] = ACTIONS(2985),
    [anon_sym_mut] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [anon_sym_interface] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_go] = ACTIONS(2985),
    [anon_sym_spawn] = ACTIONS(2985),
    [anon_sym_json_DOTdecode] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(2985),
    [anon_sym_CARET] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_DASH] = ACTIONS(2985),
    [sym_none] = ACTIONS(2985),
    [sym_true] = ACTIONS(2985),
    [sym_false] = ACTIONS(2985),
    [sym_nil] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_DOLLARif] = ACTIONS(2985),
    [anon_sym_match] = ACTIONS(2985),
    [anon_sym_select] = ACTIONS(2985),
    [anon_sym_lock] = ACTIONS(2985),
    [anon_sym_rlock] = ACTIONS(2985),
    [anon_sym_unsafe] = ACTIONS(2985),
    [anon_sym_sql] = ACTIONS(2985),
    [sym_int_literal] = ACTIONS(2985),
    [sym_float_literal] = ACTIONS(2985),
    [sym_rune_literal] = ACTIONS(2985),
    [anon_sym_SQUOTE] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_c_SQUOTE] = ACTIONS(2985),
    [anon_sym_c_DQUOTE] = ACTIONS(2985),
    [anon_sym_r_SQUOTE] = ACTIONS(2985),
    [anon_sym_r_DQUOTE] = ACTIONS(2985),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2985),
    [anon_sym_shared] = ACTIONS(2985),
    [aux_sym_sum_type_token1] = ACTIONS(2985),
    [anon_sym_PIPE2] = ACTIONS(2983),
    [anon_sym_map_LBRACK] = ACTIONS(2985),
    [anon_sym_chan] = ACTIONS(2985),
    [anon_sym_thread] = ACTIONS(2985),
    [anon_sym_atomic] = ACTIONS(2985),
    [anon_sym_assert] = ACTIONS(2985),
    [anon_sym_defer] = ACTIONS(2985),
    [anon_sym_goto] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_DOLLARfor] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_POUND] = ACTIONS(2985),
    [anon_sym_asm] = ACTIONS(2985),
    [anon_sym_AT_LBRACK] = ACTIONS(2985),
  },
  [1734] = {
    [sym_line_comment] = STATE(1734),
    [sym_block_comment] = STATE(1734),
    [ts_builtin_sym_end] = ACTIONS(4397),
    [sym_identifier] = ACTIONS(4399),
    [anon_sym_LF] = ACTIONS(4399),
    [anon_sym_CR] = ACTIONS(4399),
    [anon_sym_CR_LF] = ACTIONS(4399),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4399),
    [anon_sym_LBRACE] = ACTIONS(4399),
    [anon_sym_const] = ACTIONS(4399),
    [anon_sym_LPAREN] = ACTIONS(4399),
    [anon_sym___global] = ACTIONS(4399),
    [anon_sym_type] = ACTIONS(4399),
    [anon_sym_fn] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4399),
    [anon_sym_DASH] = ACTIONS(4399),
    [anon_sym_STAR] = ACTIONS(4399),
    [anon_sym_struct] = ACTIONS(4399),
    [anon_sym_union] = ACTIONS(4399),
    [anon_sym_pub] = ACTIONS(4399),
    [anon_sym_mut] = ACTIONS(4399),
    [anon_sym_enum] = ACTIONS(4399),
    [anon_sym_interface] = ACTIONS(4399),
    [anon_sym_QMARK] = ACTIONS(4399),
    [anon_sym_BANG] = ACTIONS(4399),
    [anon_sym_go] = ACTIONS(4399),
    [anon_sym_spawn] = ACTIONS(4399),
    [anon_sym_json_DOTdecode] = ACTIONS(4399),
    [anon_sym_LBRACK2] = ACTIONS(4399),
    [anon_sym_TILDE] = ACTIONS(4399),
    [anon_sym_CARET] = ACTIONS(4399),
    [anon_sym_AMP] = ACTIONS(4399),
    [anon_sym_LT_DASH] = ACTIONS(4399),
    [sym_none] = ACTIONS(4399),
    [sym_true] = ACTIONS(4399),
    [sym_false] = ACTIONS(4399),
    [sym_nil] = ACTIONS(4399),
    [anon_sym_if] = ACTIONS(4399),
    [anon_sym_DOLLARif] = ACTIONS(4399),
    [anon_sym_match] = ACTIONS(4399),
    [anon_sym_select] = ACTIONS(4399),
    [anon_sym_lock] = ACTIONS(4399),
    [anon_sym_rlock] = ACTIONS(4399),
    [anon_sym_unsafe] = ACTIONS(4399),
    [anon_sym_sql] = ACTIONS(4399),
    [sym_int_literal] = ACTIONS(4399),
    [sym_float_literal] = ACTIONS(4399),
    [sym_rune_literal] = ACTIONS(4399),
    [anon_sym_SQUOTE] = ACTIONS(4399),
    [anon_sym_DQUOTE] = ACTIONS(4399),
    [anon_sym_c_SQUOTE] = ACTIONS(4399),
    [anon_sym_c_DQUOTE] = ACTIONS(4399),
    [anon_sym_r_SQUOTE] = ACTIONS(4399),
    [anon_sym_r_DQUOTE] = ACTIONS(4399),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4399),
    [anon_sym_shared] = ACTIONS(4399),
    [aux_sym_sum_type_token1] = ACTIONS(4399),
    [anon_sym_PIPE2] = ACTIONS(4397),
    [anon_sym_map_LBRACK] = ACTIONS(4399),
    [anon_sym_chan] = ACTIONS(4399),
    [anon_sym_thread] = ACTIONS(4399),
    [anon_sym_atomic] = ACTIONS(4399),
    [anon_sym_assert] = ACTIONS(4399),
    [anon_sym_defer] = ACTIONS(4399),
    [anon_sym_goto] = ACTIONS(4399),
    [anon_sym_break] = ACTIONS(4399),
    [anon_sym_continue] = ACTIONS(4399),
    [anon_sym_return] = ACTIONS(4399),
    [anon_sym_DOLLARfor] = ACTIONS(4399),
    [anon_sym_for] = ACTIONS(4399),
    [anon_sym_POUND] = ACTIONS(4399),
    [anon_sym_asm] = ACTIONS(4399),
    [anon_sym_AT_LBRACK] = ACTIONS(4399),
  },
  [1735] = {
    [sym_line_comment] = STATE(1735),
    [sym_block_comment] = STATE(1735),
    [ts_builtin_sym_end] = ACTIONS(3294),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_LF] = ACTIONS(3296),
    [anon_sym_CR] = ACTIONS(3296),
    [anon_sym_CR_LF] = ACTIONS(3296),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3296),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_const] = ACTIONS(3296),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym___global] = ACTIONS(3296),
    [anon_sym_type] = ACTIONS(3296),
    [anon_sym_fn] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_struct] = ACTIONS(3296),
    [anon_sym_union] = ACTIONS(3296),
    [anon_sym_pub] = ACTIONS(3296),
    [anon_sym_mut] = ACTIONS(3296),
    [anon_sym_enum] = ACTIONS(3296),
    [anon_sym_interface] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3296),
    [anon_sym_BANG] = ACTIONS(3296),
    [anon_sym_go] = ACTIONS(3296),
    [anon_sym_spawn] = ACTIONS(3296),
    [anon_sym_json_DOTdecode] = ACTIONS(3296),
    [anon_sym_LBRACK2] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3296),
    [anon_sym_CARET] = ACTIONS(3296),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3296),
    [sym_none] = ACTIONS(3296),
    [sym_true] = ACTIONS(3296),
    [sym_false] = ACTIONS(3296),
    [sym_nil] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_DOLLARif] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_select] = ACTIONS(3296),
    [anon_sym_lock] = ACTIONS(3296),
    [anon_sym_rlock] = ACTIONS(3296),
    [anon_sym_unsafe] = ACTIONS(3296),
    [anon_sym_sql] = ACTIONS(3296),
    [sym_int_literal] = ACTIONS(3296),
    [sym_float_literal] = ACTIONS(3296),
    [sym_rune_literal] = ACTIONS(3296),
    [anon_sym_SQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_c_SQUOTE] = ACTIONS(3296),
    [anon_sym_c_DQUOTE] = ACTIONS(3296),
    [anon_sym_r_SQUOTE] = ACTIONS(3296),
    [anon_sym_r_DQUOTE] = ACTIONS(3296),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3296),
    [anon_sym_shared] = ACTIONS(3296),
    [aux_sym_sum_type_token1] = ACTIONS(3296),
    [anon_sym_PIPE2] = ACTIONS(3294),
    [anon_sym_map_LBRACK] = ACTIONS(3296),
    [anon_sym_chan] = ACTIONS(3296),
    [anon_sym_thread] = ACTIONS(3296),
    [anon_sym_atomic] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_defer] = ACTIONS(3296),
    [anon_sym_goto] = ACTIONS(3296),
    [anon_sym_break] = ACTIONS(3296),
    [anon_sym_continue] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_DOLLARfor] = ACTIONS(3296),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_POUND] = ACTIONS(3296),
    [anon_sym_asm] = ACTIONS(3296),
    [anon_sym_AT_LBRACK] = ACTIONS(3296),
  },
  [1736] = {
    [sym_line_comment] = STATE(1736),
    [sym_block_comment] = STATE(1736),
    [ts_builtin_sym_end] = ACTIONS(4420),
    [sym_identifier] = ACTIONS(4422),
    [anon_sym_LF] = ACTIONS(4422),
    [anon_sym_CR] = ACTIONS(4422),
    [anon_sym_CR_LF] = ACTIONS(4422),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_LBRACE] = ACTIONS(4422),
    [anon_sym_const] = ACTIONS(4422),
    [anon_sym_LPAREN] = ACTIONS(4422),
    [anon_sym___global] = ACTIONS(4422),
    [anon_sym_type] = ACTIONS(4422),
    [anon_sym_fn] = ACTIONS(4422),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4422),
    [anon_sym_struct] = ACTIONS(4422),
    [anon_sym_union] = ACTIONS(4422),
    [anon_sym_pub] = ACTIONS(4422),
    [anon_sym_mut] = ACTIONS(4422),
    [anon_sym_enum] = ACTIONS(4422),
    [anon_sym_interface] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_go] = ACTIONS(4422),
    [anon_sym_spawn] = ACTIONS(4422),
    [anon_sym_json_DOTdecode] = ACTIONS(4422),
    [anon_sym_LBRACK2] = ACTIONS(4422),
    [anon_sym_TILDE] = ACTIONS(4422),
    [anon_sym_CARET] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_DASH] = ACTIONS(4422),
    [sym_none] = ACTIONS(4422),
    [sym_true] = ACTIONS(4422),
    [sym_false] = ACTIONS(4422),
    [sym_nil] = ACTIONS(4422),
    [anon_sym_if] = ACTIONS(4422),
    [anon_sym_DOLLARif] = ACTIONS(4422),
    [anon_sym_match] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_lock] = ACTIONS(4422),
    [anon_sym_rlock] = ACTIONS(4422),
    [anon_sym_unsafe] = ACTIONS(4422),
    [anon_sym_sql] = ACTIONS(4422),
    [sym_int_literal] = ACTIONS(4422),
    [sym_float_literal] = ACTIONS(4422),
    [sym_rune_literal] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym_DQUOTE] = ACTIONS(4422),
    [anon_sym_c_SQUOTE] = ACTIONS(4422),
    [anon_sym_c_DQUOTE] = ACTIONS(4422),
    [anon_sym_r_SQUOTE] = ACTIONS(4422),
    [anon_sym_r_DQUOTE] = ACTIONS(4422),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4422),
    [anon_sym_shared] = ACTIONS(4422),
    [aux_sym_sum_type_token1] = ACTIONS(4422),
    [anon_sym_PIPE2] = ACTIONS(4420),
    [anon_sym_map_LBRACK] = ACTIONS(4422),
    [anon_sym_chan] = ACTIONS(4422),
    [anon_sym_thread] = ACTIONS(4422),
    [anon_sym_atomic] = ACTIONS(4422),
    [anon_sym_assert] = ACTIONS(4422),
    [anon_sym_defer] = ACTIONS(4422),
    [anon_sym_goto] = ACTIONS(4422),
    [anon_sym_break] = ACTIONS(4422),
    [anon_sym_continue] = ACTIONS(4422),
    [anon_sym_return] = ACTIONS(4422),
    [anon_sym_DOLLARfor] = ACTIONS(4422),
    [anon_sym_for] = ACTIONS(4422),
    [anon_sym_POUND] = ACTIONS(4422),
    [anon_sym_asm] = ACTIONS(4422),
    [anon_sym_AT_LBRACK] = ACTIONS(4422),
  },
  [1737] = {
    [sym_line_comment] = STATE(1737),
    [sym_block_comment] = STATE(1737),
    [aux_sym_strictly_expression_list_repeat1] = STATE(1717),
    [ts_builtin_sym_end] = ACTIONS(4424),
    [sym_identifier] = ACTIONS(4426),
    [anon_sym_LF] = ACTIONS(4426),
    [anon_sym_CR] = ACTIONS(4426),
    [anon_sym_CR_LF] = ACTIONS(4426),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4426),
    [anon_sym_LBRACE] = ACTIONS(4426),
    [anon_sym_COMMA] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(4426),
    [anon_sym_LPAREN] = ACTIONS(4426),
    [anon_sym___global] = ACTIONS(4426),
    [anon_sym_type] = ACTIONS(4426),
    [anon_sym_fn] = ACTIONS(4426),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_DASH] = ACTIONS(4426),
    [anon_sym_STAR] = ACTIONS(4426),
    [anon_sym_struct] = ACTIONS(4426),
    [anon_sym_union] = ACTIONS(4426),
    [anon_sym_pub] = ACTIONS(4426),
    [anon_sym_mut] = ACTIONS(4426),
    [anon_sym_enum] = ACTIONS(4426),
    [anon_sym_interface] = ACTIONS(4426),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_BANG] = ACTIONS(4426),
    [anon_sym_go] = ACTIONS(4426),
    [anon_sym_spawn] = ACTIONS(4426),
    [anon_sym_json_DOTdecode] = ACTIONS(4426),
    [anon_sym_LBRACK2] = ACTIONS(4426),
    [anon_sym_TILDE] = ACTIONS(4426),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4426),
    [anon_sym_LT_DASH] = ACTIONS(4426),
    [sym_none] = ACTIONS(4426),
    [sym_true] = ACTIONS(4426),
    [sym_false] = ACTIONS(4426),
    [sym_nil] = ACTIONS(4426),
    [anon_sym_if] = ACTIONS(4426),
    [anon_sym_DOLLARif] = ACTIONS(4426),
    [anon_sym_match] = ACTIONS(4426),
    [anon_sym_select] = ACTIONS(4426),
    [anon_sym_lock] = ACTIONS(4426),
    [anon_sym_rlock] = ACTIONS(4426),
    [anon_sym_unsafe] = ACTIONS(4426),
    [anon_sym_sql] = ACTIONS(4426),
    [sym_int_literal] = ACTIONS(4426),
    [sym_float_literal] = ACTIONS(4426),
    [sym_rune_literal] = ACTIONS(4426),
    [anon_sym_SQUOTE] = ACTIONS(4426),
    [anon_sym_DQUOTE] = ACTIONS(4426),
    [anon_sym_c_SQUOTE] = ACTIONS(4426),
    [anon_sym_c_DQUOTE] = ACTIONS(4426),
    [anon_sym_r_SQUOTE] = ACTIONS(4426),
    [anon_sym_r_DQUOTE] = ACTIONS(4426),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4426),
    [anon_sym_shared] = ACTIONS(4426),
    [anon_sym_map_LBRACK] = ACTIONS(4426),
    [anon_sym_chan] = ACTIONS(4426),
    [anon_sym_thread] = ACTIONS(4426),
    [anon_sym_atomic] = ACTIONS(4426),
    [anon_sym_assert] = ACTIONS(4426),
    [anon_sym_defer] = ACTIONS(4426),
    [anon_sym_goto] = ACTIONS(4426),
    [anon_sym_break] = ACTIONS(4426),
    [anon_sym_continue] = ACTIONS(4426),
    [anon_sym_return] = ACTIONS(4426),
    [anon_sym_DOLLARfor] = ACTIONS(4426),
    [anon_sym_for] = ACTIONS(4426),
    [anon_sym_POUND] = ACTIONS(4426),
    [anon_sym_asm] = ACTIONS(4426),
    [anon_sym_AT_LBRACK] = ACTIONS(4426),
  },
  [1738] = {
    [sym_line_comment] = STATE(1738),
    [sym_block_comment] = STATE(1738),
    [ts_builtin_sym_end] = ACTIONS(3354),
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_LF] = ACTIONS(3356),
    [anon_sym_CR] = ACTIONS(3356),
    [anon_sym_CR_LF] = ACTIONS(3356),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3356),
    [anon_sym_const] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3356),
    [anon_sym___global] = ACTIONS(3356),
    [anon_sym_type] = ACTIONS(3356),
    [anon_sym_fn] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_STAR] = ACTIONS(3356),
    [anon_sym_struct] = ACTIONS(3356),
    [anon_sym_union] = ACTIONS(3356),
    [anon_sym_pub] = ACTIONS(3356),
    [anon_sym_mut] = ACTIONS(3356),
    [anon_sym_enum] = ACTIONS(3356),
    [anon_sym_interface] = ACTIONS(3356),
    [anon_sym_QMARK] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3356),
    [anon_sym_go] = ACTIONS(3356),
    [anon_sym_spawn] = ACTIONS(3356),
    [anon_sym_json_DOTdecode] = ACTIONS(3356),
    [anon_sym_LBRACK2] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3356),
    [anon_sym_CARET] = ACTIONS(3356),
    [anon_sym_AMP] = ACTIONS(3356),
    [anon_sym_LT_DASH] = ACTIONS(3356),
    [sym_none] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_nil] = ACTIONS(3356),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_DOLLARif] = ACTIONS(3356),
    [anon_sym_match] = ACTIONS(3356),
    [anon_sym_select] = ACTIONS(3356),
    [anon_sym_lock] = ACTIONS(3356),
    [anon_sym_rlock] = ACTIONS(3356),
    [anon_sym_unsafe] = ACTIONS(3356),
    [anon_sym_sql] = ACTIONS(3356),
    [sym_int_literal] = ACTIONS(3356),
    [sym_float_literal] = ACTIONS(3356),
    [sym_rune_literal] = ACTIONS(3356),
    [anon_sym_SQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [anon_sym_c_SQUOTE] = ACTIONS(3356),
    [anon_sym_c_DQUOTE] = ACTIONS(3356),
    [anon_sym_r_SQUOTE] = ACTIONS(3356),
    [anon_sym_r_DQUOTE] = ACTIONS(3356),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3356),
    [anon_sym_shared] = ACTIONS(3356),
    [aux_sym_sum_type_token1] = ACTIONS(3356),
    [anon_sym_PIPE2] = ACTIONS(3354),
    [anon_sym_map_LBRACK] = ACTIONS(3356),
    [anon_sym_chan] = ACTIONS(3356),
    [anon_sym_thread] = ACTIONS(3356),
    [anon_sym_atomic] = ACTIONS(3356),
    [anon_sym_assert] = ACTIONS(3356),
    [anon_sym_defer] = ACTIONS(3356),
    [anon_sym_goto] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_DOLLARfor] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_POUND] = ACTIONS(3356),
    [anon_sym_asm] = ACTIONS(3356),
    [anon_sym_AT_LBRACK] = ACTIONS(3356),
  },
  [1739] = {
    [sym_line_comment] = STATE(1739),
    [sym_block_comment] = STATE(1739),
    [ts_builtin_sym_end] = ACTIONS(3344),
    [sym_identifier] = ACTIONS(3346),
    [anon_sym_LF] = ACTIONS(3346),
    [anon_sym_CR] = ACTIONS(3346),
    [anon_sym_CR_LF] = ACTIONS(3346),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3346),
    [anon_sym___global] = ACTIONS(3346),
    [anon_sym_type] = ACTIONS(3346),
    [anon_sym_fn] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_struct] = ACTIONS(3346),
    [anon_sym_union] = ACTIONS(3346),
    [anon_sym_pub] = ACTIONS(3346),
    [anon_sym_mut] = ACTIONS(3346),
    [anon_sym_enum] = ACTIONS(3346),
    [anon_sym_interface] = ACTIONS(3346),
    [anon_sym_QMARK] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_go] = ACTIONS(3346),
    [anon_sym_spawn] = ACTIONS(3346),
    [anon_sym_json_DOTdecode] = ACTIONS(3346),
    [anon_sym_LBRACK2] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_CARET] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym_LT_DASH] = ACTIONS(3346),
    [sym_none] = ACTIONS(3346),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [sym_nil] = ACTIONS(3346),
    [anon_sym_if] = ACTIONS(3346),
    [anon_sym_DOLLARif] = ACTIONS(3346),
    [anon_sym_match] = ACTIONS(3346),
    [anon_sym_select] = ACTIONS(3346),
    [anon_sym_lock] = ACTIONS(3346),
    [anon_sym_rlock] = ACTIONS(3346),
    [anon_sym_unsafe] = ACTIONS(3346),
    [anon_sym_sql] = ACTIONS(3346),
    [sym_int_literal] = ACTIONS(3346),
    [sym_float_literal] = ACTIONS(3346),
    [sym_rune_literal] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [anon_sym_c_SQUOTE] = ACTIONS(3346),
    [anon_sym_c_DQUOTE] = ACTIONS(3346),
    [anon_sym_r_SQUOTE] = ACTIONS(3346),
    [anon_sym_r_DQUOTE] = ACTIONS(3346),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3346),
    [anon_sym_shared] = ACTIONS(3346),
    [aux_sym_sum_type_token1] = ACTIONS(3346),
    [anon_sym_PIPE2] = ACTIONS(3344),
    [anon_sym_map_LBRACK] = ACTIONS(3346),
    [anon_sym_chan] = ACTIONS(3346),
    [anon_sym_thread] = ACTIONS(3346),
    [anon_sym_atomic] = ACTIONS(3346),
    [anon_sym_assert] = ACTIONS(3346),
    [anon_sym_defer] = ACTIONS(3346),
    [anon_sym_goto] = ACTIONS(3346),
    [anon_sym_break] = ACTIONS(3346),
    [anon_sym_continue] = ACTIONS(3346),
    [anon_sym_return] = ACTIONS(3346),
    [anon_sym_DOLLARfor] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3346),
    [anon_sym_POUND] = ACTIONS(3346),
    [anon_sym_asm] = ACTIONS(3346),
    [anon_sym_AT_LBRACK] = ACTIONS(3346),
  },
  [1740] = {
    [sym_line_comment] = STATE(1740),
    [sym_block_comment] = STATE(1740),
    [aux_sym_strictly_expression_list_repeat1] = STATE(1717),
    [ts_builtin_sym_end] = ACTIONS(4428),
    [sym_identifier] = ACTIONS(4430),
    [anon_sym_LF] = ACTIONS(4430),
    [anon_sym_CR] = ACTIONS(4430),
    [anon_sym_CR_LF] = ACTIONS(4430),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4430),
    [anon_sym_LBRACE] = ACTIONS(4430),
    [anon_sym_COMMA] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(4430),
    [anon_sym_LPAREN] = ACTIONS(4430),
    [anon_sym___global] = ACTIONS(4430),
    [anon_sym_type] = ACTIONS(4430),
    [anon_sym_fn] = ACTIONS(4430),
    [anon_sym_PLUS] = ACTIONS(4430),
    [anon_sym_DASH] = ACTIONS(4430),
    [anon_sym_STAR] = ACTIONS(4430),
    [anon_sym_struct] = ACTIONS(4430),
    [anon_sym_union] = ACTIONS(4430),
    [anon_sym_pub] = ACTIONS(4430),
    [anon_sym_mut] = ACTIONS(4430),
    [anon_sym_enum] = ACTIONS(4430),
    [anon_sym_interface] = ACTIONS(4430),
    [anon_sym_QMARK] = ACTIONS(4430),
    [anon_sym_BANG] = ACTIONS(4430),
    [anon_sym_go] = ACTIONS(4430),
    [anon_sym_spawn] = ACTIONS(4430),
    [anon_sym_json_DOTdecode] = ACTIONS(4430),
    [anon_sym_LBRACK2] = ACTIONS(4430),
    [anon_sym_TILDE] = ACTIONS(4430),
    [anon_sym_CARET] = ACTIONS(4430),
    [anon_sym_AMP] = ACTIONS(4430),
    [anon_sym_LT_DASH] = ACTIONS(4430),
    [sym_none] = ACTIONS(4430),
    [sym_true] = ACTIONS(4430),
    [sym_false] = ACTIONS(4430),
    [sym_nil] = ACTIONS(4430),
    [anon_sym_if] = ACTIONS(4430),
    [anon_sym_DOLLARif] = ACTIONS(4430),
    [anon_sym_match] = ACTIONS(4430),
    [anon_sym_select] = ACTIONS(4430),
    [anon_sym_lock] = ACTIONS(4430),
    [anon_sym_rlock] = ACTIONS(4430),
    [anon_sym_unsafe] = ACTIONS(4430),
    [anon_sym_sql] = ACTIONS(4430),
    [sym_int_literal] = ACTIONS(4430),
    [sym_float_literal] = ACTIONS(4430),
    [sym_rune_literal] = ACTIONS(4430),
    [anon_sym_SQUOTE] = ACTIONS(4430),
    [anon_sym_DQUOTE] = ACTIONS(4430),
    [anon_sym_c_SQUOTE] = ACTIONS(4430),
    [anon_sym_c_DQUOTE] = ACTIONS(4430),
    [anon_sym_r_SQUOTE] = ACTIONS(4430),
    [anon_sym_r_DQUOTE] = ACTIONS(4430),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4430),
    [anon_sym_shared] = ACTIONS(4430),
    [anon_sym_map_LBRACK] = ACTIONS(4430),
    [anon_sym_chan] = ACTIONS(4430),
    [anon_sym_thread] = ACTIONS(4430),
    [anon_sym_atomic] = ACTIONS(4430),
    [anon_sym_assert] = ACTIONS(4430),
    [anon_sym_defer] = ACTIONS(4430),
    [anon_sym_goto] = ACTIONS(4430),
    [anon_sym_break] = ACTIONS(4430),
    [anon_sym_continue] = ACTIONS(4430),
    [anon_sym_return] = ACTIONS(4430),
    [anon_sym_DOLLARfor] = ACTIONS(4430),
    [anon_sym_for] = ACTIONS(4430),
    [anon_sym_POUND] = ACTIONS(4430),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym_AT_LBRACK] = ACTIONS(4430),
  },
  [1741] = {
    [sym_line_comment] = STATE(1741),
    [sym_block_comment] = STATE(1741),
    [ts_builtin_sym_end] = ACTIONS(3322),
    [sym_identifier] = ACTIONS(3324),
    [anon_sym_LF] = ACTIONS(3324),
    [anon_sym_CR] = ACTIONS(3324),
    [anon_sym_CR_LF] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3324),
    [anon_sym_const] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3324),
    [anon_sym___global] = ACTIONS(3324),
    [anon_sym_type] = ACTIONS(3324),
    [anon_sym_fn] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3324),
    [anon_sym_DASH] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3324),
    [anon_sym_struct] = ACTIONS(3324),
    [anon_sym_union] = ACTIONS(3324),
    [anon_sym_pub] = ACTIONS(3324),
    [anon_sym_mut] = ACTIONS(3324),
    [anon_sym_enum] = ACTIONS(3324),
    [anon_sym_interface] = ACTIONS(3324),
    [anon_sym_QMARK] = ACTIONS(3324),
    [anon_sym_BANG] = ACTIONS(3324),
    [anon_sym_go] = ACTIONS(3324),
    [anon_sym_spawn] = ACTIONS(3324),
    [anon_sym_json_DOTdecode] = ACTIONS(3324),
    [anon_sym_LBRACK2] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3324),
    [anon_sym_LT_DASH] = ACTIONS(3324),
    [sym_none] = ACTIONS(3324),
    [sym_true] = ACTIONS(3324),
    [sym_false] = ACTIONS(3324),
    [sym_nil] = ACTIONS(3324),
    [anon_sym_if] = ACTIONS(3324),
    [anon_sym_DOLLARif] = ACTIONS(3324),
    [anon_sym_match] = ACTIONS(3324),
    [anon_sym_select] = ACTIONS(3324),
    [anon_sym_lock] = ACTIONS(3324),
    [anon_sym_rlock] = ACTIONS(3324),
    [anon_sym_unsafe] = ACTIONS(3324),
    [anon_sym_sql] = ACTIONS(3324),
    [sym_int_literal] = ACTIONS(3324),
    [sym_float_literal] = ACTIONS(3324),
    [sym_rune_literal] = ACTIONS(3324),
    [anon_sym_SQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE] = ACTIONS(3324),
    [anon_sym_c_SQUOTE] = ACTIONS(3324),
    [anon_sym_c_DQUOTE] = ACTIONS(3324),
    [anon_sym_r_SQUOTE] = ACTIONS(3324),
    [anon_sym_r_DQUOTE] = ACTIONS(3324),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3324),
    [anon_sym_shared] = ACTIONS(3324),
    [aux_sym_sum_type_token1] = ACTIONS(3324),
    [anon_sym_PIPE2] = ACTIONS(3322),
    [anon_sym_map_LBRACK] = ACTIONS(3324),
    [anon_sym_chan] = ACTIONS(3324),
    [anon_sym_thread] = ACTIONS(3324),
    [anon_sym_atomic] = ACTIONS(3324),
    [anon_sym_assert] = ACTIONS(3324),
    [anon_sym_defer] = ACTIONS(3324),
    [anon_sym_goto] = ACTIONS(3324),
    [anon_sym_break] = ACTIONS(3324),
    [anon_sym_continue] = ACTIONS(3324),
    [anon_sym_return] = ACTIONS(3324),
    [anon_sym_DOLLARfor] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3324),
    [anon_sym_POUND] = ACTIONS(3324),
    [anon_sym_asm] = ACTIONS(3324),
    [anon_sym_AT_LBRACK] = ACTIONS(3324),
  },
  [1742] = {
    [sym_line_comment] = STATE(1742),
    [sym_block_comment] = STATE(1742),
    [ts_builtin_sym_end] = ACTIONS(3025),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_LF] = ACTIONS(3027),
    [anon_sym_CR] = ACTIONS(3027),
    [anon_sym_CR_LF] = ACTIONS(3027),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3027),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_const] = ACTIONS(3027),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym___global] = ACTIONS(3027),
    [anon_sym_type] = ACTIONS(3027),
    [anon_sym_fn] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_STAR] = ACTIONS(3027),
    [anon_sym_struct] = ACTIONS(3027),
    [anon_sym_union] = ACTIONS(3027),
    [anon_sym_pub] = ACTIONS(3027),
    [anon_sym_mut] = ACTIONS(3027),
    [anon_sym_enum] = ACTIONS(3027),
    [anon_sym_interface] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_BANG] = ACTIONS(3027),
    [anon_sym_go] = ACTIONS(3027),
    [anon_sym_spawn] = ACTIONS(3027),
    [anon_sym_json_DOTdecode] = ACTIONS(3027),
    [anon_sym_LBRACK2] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3027),
    [anon_sym_CARET] = ACTIONS(3027),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_LT_DASH] = ACTIONS(3027),
    [sym_none] = ACTIONS(3027),
    [sym_true] = ACTIONS(3027),
    [sym_false] = ACTIONS(3027),
    [sym_nil] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_DOLLARif] = ACTIONS(3027),
    [anon_sym_match] = ACTIONS(3027),
    [anon_sym_select] = ACTIONS(3027),
    [anon_sym_lock] = ACTIONS(3027),
    [anon_sym_rlock] = ACTIONS(3027),
    [anon_sym_unsafe] = ACTIONS(3027),
    [anon_sym_sql] = ACTIONS(3027),
    [sym_int_literal] = ACTIONS(3027),
    [sym_float_literal] = ACTIONS(3027),
    [sym_rune_literal] = ACTIONS(3027),
    [anon_sym_SQUOTE] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_c_SQUOTE] = ACTIONS(3027),
    [anon_sym_c_DQUOTE] = ACTIONS(3027),
    [anon_sym_r_SQUOTE] = ACTIONS(3027),
    [anon_sym_r_DQUOTE] = ACTIONS(3027),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3027),
    [anon_sym_shared] = ACTIONS(3027),
    [aux_sym_sum_type_token1] = ACTIONS(3027),
    [anon_sym_PIPE2] = ACTIONS(3025),
    [anon_sym_map_LBRACK] = ACTIONS(3027),
    [anon_sym_chan] = ACTIONS(3027),
    [anon_sym_thread] = ACTIONS(3027),
    [anon_sym_atomic] = ACTIONS(3027),
    [anon_sym_assert] = ACTIONS(3027),
    [anon_sym_defer] = ACTIONS(3027),
    [anon_sym_goto] = ACTIONS(3027),
    [anon_sym_break] = ACTIONS(3027),
    [anon_sym_continue] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_DOLLARfor] = ACTIONS(3027),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_POUND] = ACTIONS(3027),
    [anon_sym_asm] = ACTIONS(3027),
    [anon_sym_AT_LBRACK] = ACTIONS(3027),
  },
  [1743] = {
    [sym_line_comment] = STATE(1743),
    [sym_block_comment] = STATE(1743),
    [ts_builtin_sym_end] = ACTIONS(3029),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_LF] = ACTIONS(3031),
    [anon_sym_CR] = ACTIONS(3031),
    [anon_sym_CR_LF] = ACTIONS(3031),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3031),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_const] = ACTIONS(3031),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym___global] = ACTIONS(3031),
    [anon_sym_type] = ACTIONS(3031),
    [anon_sym_fn] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_STAR] = ACTIONS(3031),
    [anon_sym_struct] = ACTIONS(3031),
    [anon_sym_union] = ACTIONS(3031),
    [anon_sym_pub] = ACTIONS(3031),
    [anon_sym_mut] = ACTIONS(3031),
    [anon_sym_enum] = ACTIONS(3031),
    [anon_sym_interface] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_BANG] = ACTIONS(3031),
    [anon_sym_go] = ACTIONS(3031),
    [anon_sym_spawn] = ACTIONS(3031),
    [anon_sym_json_DOTdecode] = ACTIONS(3031),
    [anon_sym_LBRACK2] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3031),
    [anon_sym_CARET] = ACTIONS(3031),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_LT_DASH] = ACTIONS(3031),
    [sym_none] = ACTIONS(3031),
    [sym_true] = ACTIONS(3031),
    [sym_false] = ACTIONS(3031),
    [sym_nil] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_DOLLARif] = ACTIONS(3031),
    [anon_sym_match] = ACTIONS(3031),
    [anon_sym_select] = ACTIONS(3031),
    [anon_sym_lock] = ACTIONS(3031),
    [anon_sym_rlock] = ACTIONS(3031),
    [anon_sym_unsafe] = ACTIONS(3031),
    [anon_sym_sql] = ACTIONS(3031),
    [sym_int_literal] = ACTIONS(3031),
    [sym_float_literal] = ACTIONS(3031),
    [sym_rune_literal] = ACTIONS(3031),
    [anon_sym_SQUOTE] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_c_SQUOTE] = ACTIONS(3031),
    [anon_sym_c_DQUOTE] = ACTIONS(3031),
    [anon_sym_r_SQUOTE] = ACTIONS(3031),
    [anon_sym_r_DQUOTE] = ACTIONS(3031),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3031),
    [anon_sym_shared] = ACTIONS(3031),
    [aux_sym_sum_type_token1] = ACTIONS(3031),
    [anon_sym_PIPE2] = ACTIONS(3029),
    [anon_sym_map_LBRACK] = ACTIONS(3031),
    [anon_sym_chan] = ACTIONS(3031),
    [anon_sym_thread] = ACTIONS(3031),
    [anon_sym_atomic] = ACTIONS(3031),
    [anon_sym_assert] = ACTIONS(3031),
    [anon_sym_defer] = ACTIONS(3031),
    [anon_sym_goto] = ACTIONS(3031),
    [anon_sym_break] = ACTIONS(3031),
    [anon_sym_continue] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_DOLLARfor] = ACTIONS(3031),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_POUND] = ACTIONS(3031),
    [anon_sym_asm] = ACTIONS(3031),
    [anon_sym_AT_LBRACK] = ACTIONS(3031),
  },
  [1744] = {
    [sym_line_comment] = STATE(1744),
    [sym_block_comment] = STATE(1744),
    [ts_builtin_sym_end] = ACTIONS(3302),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_LF] = ACTIONS(3304),
    [anon_sym_CR] = ACTIONS(3304),
    [anon_sym_CR_LF] = ACTIONS(3304),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_const] = ACTIONS(3304),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym___global] = ACTIONS(3304),
    [anon_sym_type] = ACTIONS(3304),
    [anon_sym_fn] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_struct] = ACTIONS(3304),
    [anon_sym_union] = ACTIONS(3304),
    [anon_sym_pub] = ACTIONS(3304),
    [anon_sym_mut] = ACTIONS(3304),
    [anon_sym_enum] = ACTIONS(3304),
    [anon_sym_interface] = ACTIONS(3304),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_go] = ACTIONS(3304),
    [anon_sym_spawn] = ACTIONS(3304),
    [anon_sym_json_DOTdecode] = ACTIONS(3304),
    [anon_sym_LBRACK2] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LT_DASH] = ACTIONS(3304),
    [sym_none] = ACTIONS(3304),
    [sym_true] = ACTIONS(3304),
    [sym_false] = ACTIONS(3304),
    [sym_nil] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_DOLLARif] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_select] = ACTIONS(3304),
    [anon_sym_lock] = ACTIONS(3304),
    [anon_sym_rlock] = ACTIONS(3304),
    [anon_sym_unsafe] = ACTIONS(3304),
    [anon_sym_sql] = ACTIONS(3304),
    [sym_int_literal] = ACTIONS(3304),
    [sym_float_literal] = ACTIONS(3304),
    [sym_rune_literal] = ACTIONS(3304),
    [anon_sym_SQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_c_SQUOTE] = ACTIONS(3304),
    [anon_sym_c_DQUOTE] = ACTIONS(3304),
    [anon_sym_r_SQUOTE] = ACTIONS(3304),
    [anon_sym_r_DQUOTE] = ACTIONS(3304),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3304),
    [anon_sym_shared] = ACTIONS(3304),
    [aux_sym_sum_type_token1] = ACTIONS(3304),
    [anon_sym_PIPE2] = ACTIONS(3302),
    [anon_sym_map_LBRACK] = ACTIONS(3304),
    [anon_sym_chan] = ACTIONS(3304),
    [anon_sym_thread] = ACTIONS(3304),
    [anon_sym_atomic] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_defer] = ACTIONS(3304),
    [anon_sym_goto] = ACTIONS(3304),
    [anon_sym_break] = ACTIONS(3304),
    [anon_sym_continue] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_DOLLARfor] = ACTIONS(3304),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_POUND] = ACTIONS(3304),
    [anon_sym_asm] = ACTIONS(3304),
    [anon_sym_AT_LBRACK] = ACTIONS(3304),
  },
  [1745] = {
    [sym_line_comment] = STATE(1745),
    [sym_block_comment] = STATE(1745),
    [ts_builtin_sym_end] = ACTIONS(3316),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LF] = ACTIONS(3318),
    [anon_sym_CR] = ACTIONS(3318),
    [anon_sym_CR_LF] = ACTIONS(3318),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3318),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym___global] = ACTIONS(3318),
    [anon_sym_type] = ACTIONS(3318),
    [anon_sym_fn] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_struct] = ACTIONS(3318),
    [anon_sym_union] = ACTIONS(3318),
    [anon_sym_pub] = ACTIONS(3318),
    [anon_sym_mut] = ACTIONS(3318),
    [anon_sym_enum] = ACTIONS(3318),
    [anon_sym_interface] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_BANG] = ACTIONS(3318),
    [anon_sym_go] = ACTIONS(3318),
    [anon_sym_spawn] = ACTIONS(3318),
    [anon_sym_json_DOTdecode] = ACTIONS(3318),
    [anon_sym_LBRACK2] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3318),
    [anon_sym_CARET] = ACTIONS(3318),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LT_DASH] = ACTIONS(3318),
    [sym_none] = ACTIONS(3318),
    [sym_true] = ACTIONS(3318),
    [sym_false] = ACTIONS(3318),
    [sym_nil] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_DOLLARif] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_select] = ACTIONS(3318),
    [anon_sym_lock] = ACTIONS(3318),
    [anon_sym_rlock] = ACTIONS(3318),
    [anon_sym_unsafe] = ACTIONS(3318),
    [anon_sym_sql] = ACTIONS(3318),
    [sym_int_literal] = ACTIONS(3318),
    [sym_float_literal] = ACTIONS(3318),
    [sym_rune_literal] = ACTIONS(3318),
    [anon_sym_SQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_c_SQUOTE] = ACTIONS(3318),
    [anon_sym_c_DQUOTE] = ACTIONS(3318),
    [anon_sym_r_SQUOTE] = ACTIONS(3318),
    [anon_sym_r_DQUOTE] = ACTIONS(3318),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3318),
    [anon_sym_shared] = ACTIONS(3318),
    [aux_sym_sum_type_token1] = ACTIONS(3318),
    [anon_sym_PIPE2] = ACTIONS(3316),
    [anon_sym_map_LBRACK] = ACTIONS(3318),
    [anon_sym_chan] = ACTIONS(3318),
    [anon_sym_thread] = ACTIONS(3318),
    [anon_sym_atomic] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_defer] = ACTIONS(3318),
    [anon_sym_goto] = ACTIONS(3318),
    [anon_sym_break] = ACTIONS(3318),
    [anon_sym_continue] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_DOLLARfor] = ACTIONS(3318),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_POUND] = ACTIONS(3318),
    [anon_sym_asm] = ACTIONS(3318),
    [anon_sym_AT_LBRACK] = ACTIONS(3318),
  },
  [1746] = {
    [sym_line_comment] = STATE(1746),
    [sym_block_comment] = STATE(1746),
    [ts_builtin_sym_end] = ACTIONS(2839),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_LF] = ACTIONS(2841),
    [anon_sym_CR] = ACTIONS(2841),
    [anon_sym_CR_LF] = ACTIONS(2841),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_const] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2841),
    [anon_sym___global] = ACTIONS(2841),
    [anon_sym_type] = ACTIONS(2841),
    [anon_sym_fn] = ACTIONS(2841),
    [anon_sym_PLUS] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(2841),
    [anon_sym_struct] = ACTIONS(2841),
    [anon_sym_union] = ACTIONS(2841),
    [anon_sym_pub] = ACTIONS(2841),
    [anon_sym_mut] = ACTIONS(2841),
    [anon_sym_enum] = ACTIONS(2841),
    [anon_sym_interface] = ACTIONS(2841),
    [anon_sym_QMARK] = ACTIONS(2841),
    [anon_sym_BANG] = ACTIONS(2841),
    [anon_sym_go] = ACTIONS(2841),
    [anon_sym_spawn] = ACTIONS(2841),
    [anon_sym_json_DOTdecode] = ACTIONS(2841),
    [anon_sym_LBRACK2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2841),
    [anon_sym_LT_DASH] = ACTIONS(2841),
    [sym_none] = ACTIONS(2841),
    [sym_true] = ACTIONS(2841),
    [sym_false] = ACTIONS(2841),
    [sym_nil] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2841),
    [anon_sym_DOLLARif] = ACTIONS(2841),
    [anon_sym_match] = ACTIONS(2841),
    [anon_sym_select] = ACTIONS(2841),
    [anon_sym_lock] = ACTIONS(2841),
    [anon_sym_rlock] = ACTIONS(2841),
    [anon_sym_unsafe] = ACTIONS(2841),
    [anon_sym_sql] = ACTIONS(2841),
    [sym_int_literal] = ACTIONS(2841),
    [sym_float_literal] = ACTIONS(2841),
    [sym_rune_literal] = ACTIONS(2841),
    [anon_sym_SQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE] = ACTIONS(2841),
    [anon_sym_c_SQUOTE] = ACTIONS(2841),
    [anon_sym_c_DQUOTE] = ACTIONS(2841),
    [anon_sym_r_SQUOTE] = ACTIONS(2841),
    [anon_sym_r_DQUOTE] = ACTIONS(2841),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2841),
    [anon_sym_shared] = ACTIONS(2841),
    [aux_sym_sum_type_token1] = ACTIONS(2841),
    [anon_sym_PIPE2] = ACTIONS(2839),
    [anon_sym_map_LBRACK] = ACTIONS(2841),
    [anon_sym_chan] = ACTIONS(2841),
    [anon_sym_thread] = ACTIONS(2841),
    [anon_sym_atomic] = ACTIONS(2841),
    [anon_sym_assert] = ACTIONS(2841),
    [anon_sym_defer] = ACTIONS(2841),
    [anon_sym_goto] = ACTIONS(2841),
    [anon_sym_break] = ACTIONS(2841),
    [anon_sym_continue] = ACTIONS(2841),
    [anon_sym_return] = ACTIONS(2841),
    [anon_sym_DOLLARfor] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2841),
    [anon_sym_POUND] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2841),
    [anon_sym_AT_LBRACK] = ACTIONS(2841),
  },
  [1747] = {
    [sym_line_comment] = STATE(1747),
    [sym_block_comment] = STATE(1747),
    [ts_builtin_sym_end] = ACTIONS(3306),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_LF] = ACTIONS(3308),
    [anon_sym_CR] = ACTIONS(3308),
    [anon_sym_CR_LF] = ACTIONS(3308),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3308),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym___global] = ACTIONS(3308),
    [anon_sym_type] = ACTIONS(3308),
    [anon_sym_fn] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_struct] = ACTIONS(3308),
    [anon_sym_union] = ACTIONS(3308),
    [anon_sym_pub] = ACTIONS(3308),
    [anon_sym_mut] = ACTIONS(3308),
    [anon_sym_enum] = ACTIONS(3308),
    [anon_sym_interface] = ACTIONS(3308),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_BANG] = ACTIONS(3308),
    [anon_sym_go] = ACTIONS(3308),
    [anon_sym_spawn] = ACTIONS(3308),
    [anon_sym_json_DOTdecode] = ACTIONS(3308),
    [anon_sym_LBRACK2] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3308),
    [anon_sym_CARET] = ACTIONS(3308),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LT_DASH] = ACTIONS(3308),
    [sym_none] = ACTIONS(3308),
    [sym_true] = ACTIONS(3308),
    [sym_false] = ACTIONS(3308),
    [sym_nil] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_DOLLARif] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_select] = ACTIONS(3308),
    [anon_sym_lock] = ACTIONS(3308),
    [anon_sym_rlock] = ACTIONS(3308),
    [anon_sym_unsafe] = ACTIONS(3308),
    [anon_sym_sql] = ACTIONS(3308),
    [sym_int_literal] = ACTIONS(3308),
    [sym_float_literal] = ACTIONS(3308),
    [sym_rune_literal] = ACTIONS(3308),
    [anon_sym_SQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_c_SQUOTE] = ACTIONS(3308),
    [anon_sym_c_DQUOTE] = ACTIONS(3308),
    [anon_sym_r_SQUOTE] = ACTIONS(3308),
    [anon_sym_r_DQUOTE] = ACTIONS(3308),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3308),
    [anon_sym_shared] = ACTIONS(3308),
    [aux_sym_sum_type_token1] = ACTIONS(3308),
    [anon_sym_PIPE2] = ACTIONS(3306),
    [anon_sym_map_LBRACK] = ACTIONS(3308),
    [anon_sym_chan] = ACTIONS(3308),
    [anon_sym_thread] = ACTIONS(3308),
    [anon_sym_atomic] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_defer] = ACTIONS(3308),
    [anon_sym_goto] = ACTIONS(3308),
    [anon_sym_break] = ACTIONS(3308),
    [anon_sym_continue] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_DOLLARfor] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_POUND] = ACTIONS(3308),
    [anon_sym_asm] = ACTIONS(3308),
    [anon_sym_AT_LBRACK] = ACTIONS(3308),
  },
  [1748] = {
    [sym_line_comment] = STATE(1748),
    [sym_block_comment] = STATE(1748),
    [ts_builtin_sym_end] = ACTIONS(3310),
    [sym_identifier] = ACTIONS(3312),
    [anon_sym_LF] = ACTIONS(3312),
    [anon_sym_CR] = ACTIONS(3312),
    [anon_sym_CR_LF] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_const] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3312),
    [anon_sym___global] = ACTIONS(3312),
    [anon_sym_type] = ACTIONS(3312),
    [anon_sym_fn] = ACTIONS(3312),
    [anon_sym_PLUS] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_struct] = ACTIONS(3312),
    [anon_sym_union] = ACTIONS(3312),
    [anon_sym_pub] = ACTIONS(3312),
    [anon_sym_mut] = ACTIONS(3312),
    [anon_sym_enum] = ACTIONS(3312),
    [anon_sym_interface] = ACTIONS(3312),
    [anon_sym_QMARK] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_go] = ACTIONS(3312),
    [anon_sym_spawn] = ACTIONS(3312),
    [anon_sym_json_DOTdecode] = ACTIONS(3312),
    [anon_sym_LBRACK2] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_CARET] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3312),
    [anon_sym_LT_DASH] = ACTIONS(3312),
    [sym_none] = ACTIONS(3312),
    [sym_true] = ACTIONS(3312),
    [sym_false] = ACTIONS(3312),
    [sym_nil] = ACTIONS(3312),
    [anon_sym_if] = ACTIONS(3312),
    [anon_sym_DOLLARif] = ACTIONS(3312),
    [anon_sym_match] = ACTIONS(3312),
    [anon_sym_select] = ACTIONS(3312),
    [anon_sym_lock] = ACTIONS(3312),
    [anon_sym_rlock] = ACTIONS(3312),
    [anon_sym_unsafe] = ACTIONS(3312),
    [anon_sym_sql] = ACTIONS(3312),
    [sym_int_literal] = ACTIONS(3312),
    [sym_float_literal] = ACTIONS(3312),
    [sym_rune_literal] = ACTIONS(3312),
    [anon_sym_SQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3312),
    [anon_sym_c_SQUOTE] = ACTIONS(3312),
    [anon_sym_c_DQUOTE] = ACTIONS(3312),
    [anon_sym_r_SQUOTE] = ACTIONS(3312),
    [anon_sym_r_DQUOTE] = ACTIONS(3312),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3312),
    [anon_sym_shared] = ACTIONS(3312),
    [aux_sym_sum_type_token1] = ACTIONS(3312),
    [anon_sym_PIPE2] = ACTIONS(3310),
    [anon_sym_map_LBRACK] = ACTIONS(3312),
    [anon_sym_chan] = ACTIONS(3312),
    [anon_sym_thread] = ACTIONS(3312),
    [anon_sym_atomic] = ACTIONS(3312),
    [anon_sym_assert] = ACTIONS(3312),
    [anon_sym_defer] = ACTIONS(3312),
    [anon_sym_goto] = ACTIONS(3312),
    [anon_sym_break] = ACTIONS(3312),
    [anon_sym_continue] = ACTIONS(3312),
    [anon_sym_return] = ACTIONS(3312),
    [anon_sym_DOLLARfor] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3312),
    [anon_sym_POUND] = ACTIONS(3312),
    [anon_sym_asm] = ACTIONS(3312),
    [anon_sym_AT_LBRACK] = ACTIONS(3312),
  },
  [1749] = {
    [sym_line_comment] = STATE(1749),
    [sym_block_comment] = STATE(1749),
    [sym_block] = STATE(1889),
    [ts_builtin_sym_end] = ACTIONS(4432),
    [sym_identifier] = ACTIONS(4434),
    [anon_sym_LF] = ACTIONS(4434),
    [anon_sym_CR] = ACTIONS(4434),
    [anon_sym_CR_LF] = ACTIONS(4434),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4434),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4434),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [anon_sym___global] = ACTIONS(4434),
    [anon_sym_type] = ACTIONS(4434),
    [anon_sym_fn] = ACTIONS(4434),
    [anon_sym_PLUS] = ACTIONS(4434),
    [anon_sym_DASH] = ACTIONS(4434),
    [anon_sym_STAR] = ACTIONS(4434),
    [anon_sym_struct] = ACTIONS(4434),
    [anon_sym_union] = ACTIONS(4434),
    [anon_sym_pub] = ACTIONS(4434),
    [anon_sym_mut] = ACTIONS(4434),
    [anon_sym_enum] = ACTIONS(4434),
    [anon_sym_interface] = ACTIONS(4434),
    [anon_sym_QMARK] = ACTIONS(4434),
    [anon_sym_BANG] = ACTIONS(4434),
    [anon_sym_go] = ACTIONS(4434),
    [anon_sym_spawn] = ACTIONS(4434),
    [anon_sym_json_DOTdecode] = ACTIONS(4434),
    [anon_sym_LBRACK2] = ACTIONS(4434),
    [anon_sym_TILDE] = ACTIONS(4434),
    [anon_sym_CARET] = ACTIONS(4434),
    [anon_sym_AMP] = ACTIONS(4434),
    [anon_sym_LT_DASH] = ACTIONS(4434),
    [sym_none] = ACTIONS(4434),
    [sym_true] = ACTIONS(4434),
    [sym_false] = ACTIONS(4434),
    [sym_nil] = ACTIONS(4434),
    [anon_sym_if] = ACTIONS(4434),
    [anon_sym_DOLLARif] = ACTIONS(4434),
    [anon_sym_match] = ACTIONS(4434),
    [anon_sym_select] = ACTIONS(4434),
    [anon_sym_lock] = ACTIONS(4434),
    [anon_sym_rlock] = ACTIONS(4434),
    [anon_sym_unsafe] = ACTIONS(4434),
    [anon_sym_sql] = ACTIONS(4434),
    [sym_int_literal] = ACTIONS(4434),
    [sym_float_literal] = ACTIONS(4434),
    [sym_rune_literal] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_DQUOTE] = ACTIONS(4434),
    [anon_sym_c_SQUOTE] = ACTIONS(4434),
    [anon_sym_c_DQUOTE] = ACTIONS(4434),
    [anon_sym_r_SQUOTE] = ACTIONS(4434),
    [anon_sym_r_DQUOTE] = ACTIONS(4434),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4434),
    [anon_sym_shared] = ACTIONS(4434),
    [anon_sym_map_LBRACK] = ACTIONS(4434),
    [anon_sym_chan] = ACTIONS(4434),
    [anon_sym_thread] = ACTIONS(4434),
    [anon_sym_atomic] = ACTIONS(4434),
    [anon_sym_assert] = ACTIONS(4434),
    [anon_sym_defer] = ACTIONS(4434),
    [anon_sym_goto] = ACTIONS(4434),
    [anon_sym_break] = ACTIONS(4434),
    [anon_sym_continue] = ACTIONS(4434),
    [anon_sym_return] = ACTIONS(4434),
    [anon_sym_DOLLARfor] = ACTIONS(4434),
    [anon_sym_for] = ACTIONS(4434),
    [anon_sym_POUND] = ACTIONS(4434),
    [anon_sym_asm] = ACTIONS(4434),
    [anon_sym_AT_LBRACK] = ACTIONS(4434),
  },
  [1750] = {
    [sym_line_comment] = STATE(1750),
    [sym_block_comment] = STATE(1750),
    [sym_block] = STATE(1837),
    [ts_builtin_sym_end] = ACTIONS(4438),
    [sym_identifier] = ACTIONS(4440),
    [anon_sym_LF] = ACTIONS(4440),
    [anon_sym_CR] = ACTIONS(4440),
    [anon_sym_CR_LF] = ACTIONS(4440),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4440),
    [anon_sym_LPAREN] = ACTIONS(4440),
    [anon_sym___global] = ACTIONS(4440),
    [anon_sym_type] = ACTIONS(4440),
    [anon_sym_fn] = ACTIONS(4440),
    [anon_sym_PLUS] = ACTIONS(4440),
    [anon_sym_DASH] = ACTIONS(4440),
    [anon_sym_STAR] = ACTIONS(4440),
    [anon_sym_struct] = ACTIONS(4440),
    [anon_sym_union] = ACTIONS(4440),
    [anon_sym_pub] = ACTIONS(4440),
    [anon_sym_mut] = ACTIONS(4440),
    [anon_sym_enum] = ACTIONS(4440),
    [anon_sym_interface] = ACTIONS(4440),
    [anon_sym_QMARK] = ACTIONS(4440),
    [anon_sym_BANG] = ACTIONS(4440),
    [anon_sym_go] = ACTIONS(4440),
    [anon_sym_spawn] = ACTIONS(4440),
    [anon_sym_json_DOTdecode] = ACTIONS(4440),
    [anon_sym_LBRACK2] = ACTIONS(4440),
    [anon_sym_TILDE] = ACTIONS(4440),
    [anon_sym_CARET] = ACTIONS(4440),
    [anon_sym_AMP] = ACTIONS(4440),
    [anon_sym_LT_DASH] = ACTIONS(4440),
    [sym_none] = ACTIONS(4440),
    [sym_true] = ACTIONS(4440),
    [sym_false] = ACTIONS(4440),
    [sym_nil] = ACTIONS(4440),
    [anon_sym_if] = ACTIONS(4440),
    [anon_sym_DOLLARif] = ACTIONS(4440),
    [anon_sym_match] = ACTIONS(4440),
    [anon_sym_select] = ACTIONS(4440),
    [anon_sym_lock] = ACTIONS(4440),
    [anon_sym_rlock] = ACTIONS(4440),
    [anon_sym_unsafe] = ACTIONS(4440),
    [anon_sym_sql] = ACTIONS(4440),
    [sym_int_literal] = ACTIONS(4440),
    [sym_float_literal] = ACTIONS(4440),
    [sym_rune_literal] = ACTIONS(4440),
    [anon_sym_SQUOTE] = ACTIONS(4440),
    [anon_sym_DQUOTE] = ACTIONS(4440),
    [anon_sym_c_SQUOTE] = ACTIONS(4440),
    [anon_sym_c_DQUOTE] = ACTIONS(4440),
    [anon_sym_r_SQUOTE] = ACTIONS(4440),
    [anon_sym_r_DQUOTE] = ACTIONS(4440),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4440),
    [anon_sym_shared] = ACTIONS(4440),
    [anon_sym_map_LBRACK] = ACTIONS(4440),
    [anon_sym_chan] = ACTIONS(4440),
    [anon_sym_thread] = ACTIONS(4440),
    [anon_sym_atomic] = ACTIONS(4440),
    [anon_sym_assert] = ACTIONS(4440),
    [anon_sym_defer] = ACTIONS(4440),
    [anon_sym_goto] = ACTIONS(4440),
    [anon_sym_break] = ACTIONS(4440),
    [anon_sym_continue] = ACTIONS(4440),
    [anon_sym_return] = ACTIONS(4440),
    [anon_sym_DOLLARfor] = ACTIONS(4440),
    [anon_sym_for] = ACTIONS(4440),
    [anon_sym_POUND] = ACTIONS(4440),
    [anon_sym_asm] = ACTIONS(4440),
    [anon_sym_AT_LBRACK] = ACTIONS(4440),
  },
  [1751] = {
    [sym_line_comment] = STATE(1751),
    [sym_block_comment] = STATE(1751),
    [sym_block] = STATE(1846),
    [ts_builtin_sym_end] = ACTIONS(4442),
    [sym_identifier] = ACTIONS(4444),
    [anon_sym_LF] = ACTIONS(4444),
    [anon_sym_CR] = ACTIONS(4444),
    [anon_sym_CR_LF] = ACTIONS(4444),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4444),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4444),
    [anon_sym_LPAREN] = ACTIONS(4444),
    [anon_sym___global] = ACTIONS(4444),
    [anon_sym_type] = ACTIONS(4444),
    [anon_sym_fn] = ACTIONS(4444),
    [anon_sym_PLUS] = ACTIONS(4444),
    [anon_sym_DASH] = ACTIONS(4444),
    [anon_sym_STAR] = ACTIONS(4444),
    [anon_sym_struct] = ACTIONS(4444),
    [anon_sym_union] = ACTIONS(4444),
    [anon_sym_pub] = ACTIONS(4444),
    [anon_sym_mut] = ACTIONS(4444),
    [anon_sym_enum] = ACTIONS(4444),
    [anon_sym_interface] = ACTIONS(4444),
    [anon_sym_QMARK] = ACTIONS(4444),
    [anon_sym_BANG] = ACTIONS(4444),
    [anon_sym_go] = ACTIONS(4444),
    [anon_sym_spawn] = ACTIONS(4444),
    [anon_sym_json_DOTdecode] = ACTIONS(4444),
    [anon_sym_LBRACK2] = ACTIONS(4444),
    [anon_sym_TILDE] = ACTIONS(4444),
    [anon_sym_CARET] = ACTIONS(4444),
    [anon_sym_AMP] = ACTIONS(4444),
    [anon_sym_LT_DASH] = ACTIONS(4444),
    [sym_none] = ACTIONS(4444),
    [sym_true] = ACTIONS(4444),
    [sym_false] = ACTIONS(4444),
    [sym_nil] = ACTIONS(4444),
    [anon_sym_if] = ACTIONS(4444),
    [anon_sym_DOLLARif] = ACTIONS(4444),
    [anon_sym_match] = ACTIONS(4444),
    [anon_sym_select] = ACTIONS(4444),
    [anon_sym_lock] = ACTIONS(4444),
    [anon_sym_rlock] = ACTIONS(4444),
    [anon_sym_unsafe] = ACTIONS(4444),
    [anon_sym_sql] = ACTIONS(4444),
    [sym_int_literal] = ACTIONS(4444),
    [sym_float_literal] = ACTIONS(4444),
    [sym_rune_literal] = ACTIONS(4444),
    [anon_sym_SQUOTE] = ACTIONS(4444),
    [anon_sym_DQUOTE] = ACTIONS(4444),
    [anon_sym_c_SQUOTE] = ACTIONS(4444),
    [anon_sym_c_DQUOTE] = ACTIONS(4444),
    [anon_sym_r_SQUOTE] = ACTIONS(4444),
    [anon_sym_r_DQUOTE] = ACTIONS(4444),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4444),
    [anon_sym_shared] = ACTIONS(4444),
    [anon_sym_map_LBRACK] = ACTIONS(4444),
    [anon_sym_chan] = ACTIONS(4444),
    [anon_sym_thread] = ACTIONS(4444),
    [anon_sym_atomic] = ACTIONS(4444),
    [anon_sym_assert] = ACTIONS(4444),
    [anon_sym_defer] = ACTIONS(4444),
    [anon_sym_goto] = ACTIONS(4444),
    [anon_sym_break] = ACTIONS(4444),
    [anon_sym_continue] = ACTIONS(4444),
    [anon_sym_return] = ACTIONS(4444),
    [anon_sym_DOLLARfor] = ACTIONS(4444),
    [anon_sym_for] = ACTIONS(4444),
    [anon_sym_POUND] = ACTIONS(4444),
    [anon_sym_asm] = ACTIONS(4444),
    [anon_sym_AT_LBRACK] = ACTIONS(4444),
  },
  [1752] = {
    [sym_line_comment] = STATE(1752),
    [sym_block_comment] = STATE(1752),
    [ts_builtin_sym_end] = ACTIONS(2371),
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2373),
    [anon_sym_CR] = ACTIONS(2373),
    [anon_sym_CR_LF] = ACTIONS(2373),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym___global] = ACTIONS(2373),
    [anon_sym_type] = ACTIONS(2373),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_pub] = ACTIONS(2373),
    [anon_sym_mut] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_QMARK] = ACTIONS(2373),
    [anon_sym_BANG] = ACTIONS(2373),
    [anon_sym_go] = ACTIONS(2373),
    [anon_sym_spawn] = ACTIONS(2373),
    [anon_sym_json_DOTdecode] = ACTIONS(2373),
    [anon_sym_LBRACK2] = ACTIONS(2373),
    [anon_sym_TILDE] = ACTIONS(2373),
    [anon_sym_CARET] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_LT_DASH] = ACTIONS(2373),
    [sym_none] = ACTIONS(2373),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [sym_nil] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_DOLLARif] = ACTIONS(2373),
    [anon_sym_match] = ACTIONS(2373),
    [anon_sym_select] = ACTIONS(2373),
    [anon_sym_lock] = ACTIONS(2373),
    [anon_sym_rlock] = ACTIONS(2373),
    [anon_sym_unsafe] = ACTIONS(2373),
    [anon_sym_sql] = ACTIONS(2373),
    [sym_int_literal] = ACTIONS(2373),
    [sym_float_literal] = ACTIONS(2373),
    [sym_rune_literal] = ACTIONS(2373),
    [anon_sym_SQUOTE] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(2373),
    [anon_sym_c_SQUOTE] = ACTIONS(2373),
    [anon_sym_c_DQUOTE] = ACTIONS(2373),
    [anon_sym_r_SQUOTE] = ACTIONS(2373),
    [anon_sym_r_DQUOTE] = ACTIONS(2373),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_map_LBRACK] = ACTIONS(2373),
    [anon_sym_chan] = ACTIONS(2373),
    [anon_sym_thread] = ACTIONS(2373),
    [anon_sym_atomic] = ACTIONS(2373),
    [anon_sym_assert] = ACTIONS(2373),
    [anon_sym_defer] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_DOLLARfor] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_POUND] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym_AT_LBRACK] = ACTIONS(2373),
  },
  [1753] = {
    [sym_line_comment] = STATE(1753),
    [sym_block_comment] = STATE(1753),
    [sym_block] = STATE(1879),
    [ts_builtin_sym_end] = ACTIONS(4446),
    [sym_identifier] = ACTIONS(4448),
    [anon_sym_LF] = ACTIONS(4448),
    [anon_sym_CR] = ACTIONS(4448),
    [anon_sym_CR_LF] = ACTIONS(4448),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4448),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4448),
    [anon_sym_LPAREN] = ACTIONS(4448),
    [anon_sym___global] = ACTIONS(4448),
    [anon_sym_type] = ACTIONS(4448),
    [anon_sym_fn] = ACTIONS(4448),
    [anon_sym_PLUS] = ACTIONS(4448),
    [anon_sym_DASH] = ACTIONS(4448),
    [anon_sym_STAR] = ACTIONS(4448),
    [anon_sym_struct] = ACTIONS(4448),
    [anon_sym_union] = ACTIONS(4448),
    [anon_sym_pub] = ACTIONS(4448),
    [anon_sym_mut] = ACTIONS(4448),
    [anon_sym_enum] = ACTIONS(4448),
    [anon_sym_interface] = ACTIONS(4448),
    [anon_sym_QMARK] = ACTIONS(4448),
    [anon_sym_BANG] = ACTIONS(4448),
    [anon_sym_go] = ACTIONS(4448),
    [anon_sym_spawn] = ACTIONS(4448),
    [anon_sym_json_DOTdecode] = ACTIONS(4448),
    [anon_sym_LBRACK2] = ACTIONS(4448),
    [anon_sym_TILDE] = ACTIONS(4448),
    [anon_sym_CARET] = ACTIONS(4448),
    [anon_sym_AMP] = ACTIONS(4448),
    [anon_sym_LT_DASH] = ACTIONS(4448),
    [sym_none] = ACTIONS(4448),
    [sym_true] = ACTIONS(4448),
    [sym_false] = ACTIONS(4448),
    [sym_nil] = ACTIONS(4448),
    [anon_sym_if] = ACTIONS(4448),
    [anon_sym_DOLLARif] = ACTIONS(4448),
    [anon_sym_match] = ACTIONS(4448),
    [anon_sym_select] = ACTIONS(4448),
    [anon_sym_lock] = ACTIONS(4448),
    [anon_sym_rlock] = ACTIONS(4448),
    [anon_sym_unsafe] = ACTIONS(4448),
    [anon_sym_sql] = ACTIONS(4448),
    [sym_int_literal] = ACTIONS(4448),
    [sym_float_literal] = ACTIONS(4448),
    [sym_rune_literal] = ACTIONS(4448),
    [anon_sym_SQUOTE] = ACTIONS(4448),
    [anon_sym_DQUOTE] = ACTIONS(4448),
    [anon_sym_c_SQUOTE] = ACTIONS(4448),
    [anon_sym_c_DQUOTE] = ACTIONS(4448),
    [anon_sym_r_SQUOTE] = ACTIONS(4448),
    [anon_sym_r_DQUOTE] = ACTIONS(4448),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4448),
    [anon_sym_shared] = ACTIONS(4448),
    [anon_sym_map_LBRACK] = ACTIONS(4448),
    [anon_sym_chan] = ACTIONS(4448),
    [anon_sym_thread] = ACTIONS(4448),
    [anon_sym_atomic] = ACTIONS(4448),
    [anon_sym_assert] = ACTIONS(4448),
    [anon_sym_defer] = ACTIONS(4448),
    [anon_sym_goto] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4448),
    [anon_sym_continue] = ACTIONS(4448),
    [anon_sym_return] = ACTIONS(4448),
    [anon_sym_DOLLARfor] = ACTIONS(4448),
    [anon_sym_for] = ACTIONS(4448),
    [anon_sym_POUND] = ACTIONS(4448),
    [anon_sym_asm] = ACTIONS(4448),
    [anon_sym_AT_LBRACK] = ACTIONS(4448),
  },
  [1754] = {
    [sym_line_comment] = STATE(1754),
    [sym_block_comment] = STATE(1754),
    [sym_block] = STATE(1868),
    [ts_builtin_sym_end] = ACTIONS(4450),
    [sym_identifier] = ACTIONS(4452),
    [anon_sym_LF] = ACTIONS(4452),
    [anon_sym_CR] = ACTIONS(4452),
    [anon_sym_CR_LF] = ACTIONS(4452),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4452),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4452),
    [anon_sym_LPAREN] = ACTIONS(4452),
    [anon_sym___global] = ACTIONS(4452),
    [anon_sym_type] = ACTIONS(4452),
    [anon_sym_fn] = ACTIONS(4452),
    [anon_sym_PLUS] = ACTIONS(4452),
    [anon_sym_DASH] = ACTIONS(4452),
    [anon_sym_STAR] = ACTIONS(4452),
    [anon_sym_struct] = ACTIONS(4452),
    [anon_sym_union] = ACTIONS(4452),
    [anon_sym_pub] = ACTIONS(4452),
    [anon_sym_mut] = ACTIONS(4452),
    [anon_sym_enum] = ACTIONS(4452),
    [anon_sym_interface] = ACTIONS(4452),
    [anon_sym_QMARK] = ACTIONS(4452),
    [anon_sym_BANG] = ACTIONS(4452),
    [anon_sym_go] = ACTIONS(4452),
    [anon_sym_spawn] = ACTIONS(4452),
    [anon_sym_json_DOTdecode] = ACTIONS(4452),
    [anon_sym_LBRACK2] = ACTIONS(4452),
    [anon_sym_TILDE] = ACTIONS(4452),
    [anon_sym_CARET] = ACTIONS(4452),
    [anon_sym_AMP] = ACTIONS(4452),
    [anon_sym_LT_DASH] = ACTIONS(4452),
    [sym_none] = ACTIONS(4452),
    [sym_true] = ACTIONS(4452),
    [sym_false] = ACTIONS(4452),
    [sym_nil] = ACTIONS(4452),
    [anon_sym_if] = ACTIONS(4452),
    [anon_sym_DOLLARif] = ACTIONS(4452),
    [anon_sym_match] = ACTIONS(4452),
    [anon_sym_select] = ACTIONS(4452),
    [anon_sym_lock] = ACTIONS(4452),
    [anon_sym_rlock] = ACTIONS(4452),
    [anon_sym_unsafe] = ACTIONS(4452),
    [anon_sym_sql] = ACTIONS(4452),
    [sym_int_literal] = ACTIONS(4452),
    [sym_float_literal] = ACTIONS(4452),
    [sym_rune_literal] = ACTIONS(4452),
    [anon_sym_SQUOTE] = ACTIONS(4452),
    [anon_sym_DQUOTE] = ACTIONS(4452),
    [anon_sym_c_SQUOTE] = ACTIONS(4452),
    [anon_sym_c_DQUOTE] = ACTIONS(4452),
    [anon_sym_r_SQUOTE] = ACTIONS(4452),
    [anon_sym_r_DQUOTE] = ACTIONS(4452),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4452),
    [anon_sym_shared] = ACTIONS(4452),
    [anon_sym_map_LBRACK] = ACTIONS(4452),
    [anon_sym_chan] = ACTIONS(4452),
    [anon_sym_thread] = ACTIONS(4452),
    [anon_sym_atomic] = ACTIONS(4452),
    [anon_sym_assert] = ACTIONS(4452),
    [anon_sym_defer] = ACTIONS(4452),
    [anon_sym_goto] = ACTIONS(4452),
    [anon_sym_break] = ACTIONS(4452),
    [anon_sym_continue] = ACTIONS(4452),
    [anon_sym_return] = ACTIONS(4452),
    [anon_sym_DOLLARfor] = ACTIONS(4452),
    [anon_sym_for] = ACTIONS(4452),
    [anon_sym_POUND] = ACTIONS(4452),
    [anon_sym_asm] = ACTIONS(4452),
    [anon_sym_AT_LBRACK] = ACTIONS(4452),
  },
  [1755] = {
    [sym_line_comment] = STATE(1755),
    [sym_block_comment] = STATE(1755),
    [sym_block] = STATE(1845),
    [ts_builtin_sym_end] = ACTIONS(4454),
    [sym_identifier] = ACTIONS(4456),
    [anon_sym_LF] = ACTIONS(4456),
    [anon_sym_CR] = ACTIONS(4456),
    [anon_sym_CR_LF] = ACTIONS(4456),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4456),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4456),
    [anon_sym_LPAREN] = ACTIONS(4456),
    [anon_sym___global] = ACTIONS(4456),
    [anon_sym_type] = ACTIONS(4456),
    [anon_sym_fn] = ACTIONS(4456),
    [anon_sym_PLUS] = ACTIONS(4456),
    [anon_sym_DASH] = ACTIONS(4456),
    [anon_sym_STAR] = ACTIONS(4456),
    [anon_sym_struct] = ACTIONS(4456),
    [anon_sym_union] = ACTIONS(4456),
    [anon_sym_pub] = ACTIONS(4456),
    [anon_sym_mut] = ACTIONS(4456),
    [anon_sym_enum] = ACTIONS(4456),
    [anon_sym_interface] = ACTIONS(4456),
    [anon_sym_QMARK] = ACTIONS(4456),
    [anon_sym_BANG] = ACTIONS(4456),
    [anon_sym_go] = ACTIONS(4456),
    [anon_sym_spawn] = ACTIONS(4456),
    [anon_sym_json_DOTdecode] = ACTIONS(4456),
    [anon_sym_LBRACK2] = ACTIONS(4456),
    [anon_sym_TILDE] = ACTIONS(4456),
    [anon_sym_CARET] = ACTIONS(4456),
    [anon_sym_AMP] = ACTIONS(4456),
    [anon_sym_LT_DASH] = ACTIONS(4456),
    [sym_none] = ACTIONS(4456),
    [sym_true] = ACTIONS(4456),
    [sym_false] = ACTIONS(4456),
    [sym_nil] = ACTIONS(4456),
    [anon_sym_if] = ACTIONS(4456),
    [anon_sym_DOLLARif] = ACTIONS(4456),
    [anon_sym_match] = ACTIONS(4456),
    [anon_sym_select] = ACTIONS(4456),
    [anon_sym_lock] = ACTIONS(4456),
    [anon_sym_rlock] = ACTIONS(4456),
    [anon_sym_unsafe] = ACTIONS(4456),
    [anon_sym_sql] = ACTIONS(4456),
    [sym_int_literal] = ACTIONS(4456),
    [sym_float_literal] = ACTIONS(4456),
    [sym_rune_literal] = ACTIONS(4456),
    [anon_sym_SQUOTE] = ACTIONS(4456),
    [anon_sym_DQUOTE] = ACTIONS(4456),
    [anon_sym_c_SQUOTE] = ACTIONS(4456),
    [anon_sym_c_DQUOTE] = ACTIONS(4456),
    [anon_sym_r_SQUOTE] = ACTIONS(4456),
    [anon_sym_r_DQUOTE] = ACTIONS(4456),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4456),
    [anon_sym_shared] = ACTIONS(4456),
    [anon_sym_map_LBRACK] = ACTIONS(4456),
    [anon_sym_chan] = ACTIONS(4456),
    [anon_sym_thread] = ACTIONS(4456),
    [anon_sym_atomic] = ACTIONS(4456),
    [anon_sym_assert] = ACTIONS(4456),
    [anon_sym_defer] = ACTIONS(4456),
    [anon_sym_goto] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4456),
    [anon_sym_continue] = ACTIONS(4456),
    [anon_sym_return] = ACTIONS(4456),
    [anon_sym_DOLLARfor] = ACTIONS(4456),
    [anon_sym_for] = ACTIONS(4456),
    [anon_sym_POUND] = ACTIONS(4456),
    [anon_sym_asm] = ACTIONS(4456),
    [anon_sym_AT_LBRACK] = ACTIONS(4456),
  },
  [1756] = {
    [sym_line_comment] = STATE(1756),
    [sym_block_comment] = STATE(1756),
    [sym_block] = STATE(1860),
    [ts_builtin_sym_end] = ACTIONS(4458),
    [sym_identifier] = ACTIONS(4460),
    [anon_sym_LF] = ACTIONS(4460),
    [anon_sym_CR] = ACTIONS(4460),
    [anon_sym_CR_LF] = ACTIONS(4460),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4460),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4460),
    [anon_sym_LPAREN] = ACTIONS(4460),
    [anon_sym___global] = ACTIONS(4460),
    [anon_sym_type] = ACTIONS(4460),
    [anon_sym_fn] = ACTIONS(4460),
    [anon_sym_PLUS] = ACTIONS(4460),
    [anon_sym_DASH] = ACTIONS(4460),
    [anon_sym_STAR] = ACTIONS(4460),
    [anon_sym_struct] = ACTIONS(4460),
    [anon_sym_union] = ACTIONS(4460),
    [anon_sym_pub] = ACTIONS(4460),
    [anon_sym_mut] = ACTIONS(4460),
    [anon_sym_enum] = ACTIONS(4460),
    [anon_sym_interface] = ACTIONS(4460),
    [anon_sym_QMARK] = ACTIONS(4460),
    [anon_sym_BANG] = ACTIONS(4460),
    [anon_sym_go] = ACTIONS(4460),
    [anon_sym_spawn] = ACTIONS(4460),
    [anon_sym_json_DOTdecode] = ACTIONS(4460),
    [anon_sym_LBRACK2] = ACTIONS(4460),
    [anon_sym_TILDE] = ACTIONS(4460),
    [anon_sym_CARET] = ACTIONS(4460),
    [anon_sym_AMP] = ACTIONS(4460),
    [anon_sym_LT_DASH] = ACTIONS(4460),
    [sym_none] = ACTIONS(4460),
    [sym_true] = ACTIONS(4460),
    [sym_false] = ACTIONS(4460),
    [sym_nil] = ACTIONS(4460),
    [anon_sym_if] = ACTIONS(4460),
    [anon_sym_DOLLARif] = ACTIONS(4460),
    [anon_sym_match] = ACTIONS(4460),
    [anon_sym_select] = ACTIONS(4460),
    [anon_sym_lock] = ACTIONS(4460),
    [anon_sym_rlock] = ACTIONS(4460),
    [anon_sym_unsafe] = ACTIONS(4460),
    [anon_sym_sql] = ACTIONS(4460),
    [sym_int_literal] = ACTIONS(4460),
    [sym_float_literal] = ACTIONS(4460),
    [sym_rune_literal] = ACTIONS(4460),
    [anon_sym_SQUOTE] = ACTIONS(4460),
    [anon_sym_DQUOTE] = ACTIONS(4460),
    [anon_sym_c_SQUOTE] = ACTIONS(4460),
    [anon_sym_c_DQUOTE] = ACTIONS(4460),
    [anon_sym_r_SQUOTE] = ACTIONS(4460),
    [anon_sym_r_DQUOTE] = ACTIONS(4460),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4460),
    [anon_sym_shared] = ACTIONS(4460),
    [anon_sym_map_LBRACK] = ACTIONS(4460),
    [anon_sym_chan] = ACTIONS(4460),
    [anon_sym_thread] = ACTIONS(4460),
    [anon_sym_atomic] = ACTIONS(4460),
    [anon_sym_assert] = ACTIONS(4460),
    [anon_sym_defer] = ACTIONS(4460),
    [anon_sym_goto] = ACTIONS(4460),
    [anon_sym_break] = ACTIONS(4460),
    [anon_sym_continue] = ACTIONS(4460),
    [anon_sym_return] = ACTIONS(4460),
    [anon_sym_DOLLARfor] = ACTIONS(4460),
    [anon_sym_for] = ACTIONS(4460),
    [anon_sym_POUND] = ACTIONS(4460),
    [anon_sym_asm] = ACTIONS(4460),
    [anon_sym_AT_LBRACK] = ACTIONS(4460),
  },
  [1757] = {
    [sym_line_comment] = STATE(1757),
    [sym_block_comment] = STATE(1757),
    [sym_block] = STATE(1887),
    [ts_builtin_sym_end] = ACTIONS(4462),
    [sym_identifier] = ACTIONS(4464),
    [anon_sym_LF] = ACTIONS(4464),
    [anon_sym_CR] = ACTIONS(4464),
    [anon_sym_CR_LF] = ACTIONS(4464),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4464),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4464),
    [anon_sym_LPAREN] = ACTIONS(4464),
    [anon_sym___global] = ACTIONS(4464),
    [anon_sym_type] = ACTIONS(4464),
    [anon_sym_fn] = ACTIONS(4464),
    [anon_sym_PLUS] = ACTIONS(4464),
    [anon_sym_DASH] = ACTIONS(4464),
    [anon_sym_STAR] = ACTIONS(4464),
    [anon_sym_struct] = ACTIONS(4464),
    [anon_sym_union] = ACTIONS(4464),
    [anon_sym_pub] = ACTIONS(4464),
    [anon_sym_mut] = ACTIONS(4464),
    [anon_sym_enum] = ACTIONS(4464),
    [anon_sym_interface] = ACTIONS(4464),
    [anon_sym_QMARK] = ACTIONS(4464),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_go] = ACTIONS(4464),
    [anon_sym_spawn] = ACTIONS(4464),
    [anon_sym_json_DOTdecode] = ACTIONS(4464),
    [anon_sym_LBRACK2] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [anon_sym_CARET] = ACTIONS(4464),
    [anon_sym_AMP] = ACTIONS(4464),
    [anon_sym_LT_DASH] = ACTIONS(4464),
    [sym_none] = ACTIONS(4464),
    [sym_true] = ACTIONS(4464),
    [sym_false] = ACTIONS(4464),
    [sym_nil] = ACTIONS(4464),
    [anon_sym_if] = ACTIONS(4464),
    [anon_sym_DOLLARif] = ACTIONS(4464),
    [anon_sym_match] = ACTIONS(4464),
    [anon_sym_select] = ACTIONS(4464),
    [anon_sym_lock] = ACTIONS(4464),
    [anon_sym_rlock] = ACTIONS(4464),
    [anon_sym_unsafe] = ACTIONS(4464),
    [anon_sym_sql] = ACTIONS(4464),
    [sym_int_literal] = ACTIONS(4464),
    [sym_float_literal] = ACTIONS(4464),
    [sym_rune_literal] = ACTIONS(4464),
    [anon_sym_SQUOTE] = ACTIONS(4464),
    [anon_sym_DQUOTE] = ACTIONS(4464),
    [anon_sym_c_SQUOTE] = ACTIONS(4464),
    [anon_sym_c_DQUOTE] = ACTIONS(4464),
    [anon_sym_r_SQUOTE] = ACTIONS(4464),
    [anon_sym_r_DQUOTE] = ACTIONS(4464),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4464),
    [anon_sym_shared] = ACTIONS(4464),
    [anon_sym_map_LBRACK] = ACTIONS(4464),
    [anon_sym_chan] = ACTIONS(4464),
    [anon_sym_thread] = ACTIONS(4464),
    [anon_sym_atomic] = ACTIONS(4464),
    [anon_sym_assert] = ACTIONS(4464),
    [anon_sym_defer] = ACTIONS(4464),
    [anon_sym_goto] = ACTIONS(4464),
    [anon_sym_break] = ACTIONS(4464),
    [anon_sym_continue] = ACTIONS(4464),
    [anon_sym_return] = ACTIONS(4464),
    [anon_sym_DOLLARfor] = ACTIONS(4464),
    [anon_sym_for] = ACTIONS(4464),
    [anon_sym_POUND] = ACTIONS(4464),
    [anon_sym_asm] = ACTIONS(4464),
    [anon_sym_AT_LBRACK] = ACTIONS(4464),
  },
  [1758] = {
    [sym_line_comment] = STATE(1758),
    [sym_block_comment] = STATE(1758),
    [sym_block] = STATE(1882),
    [ts_builtin_sym_end] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4468),
    [anon_sym_LF] = ACTIONS(4468),
    [anon_sym_CR] = ACTIONS(4468),
    [anon_sym_CR_LF] = ACTIONS(4468),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4468),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4468),
    [anon_sym_LPAREN] = ACTIONS(4468),
    [anon_sym___global] = ACTIONS(4468),
    [anon_sym_type] = ACTIONS(4468),
    [anon_sym_fn] = ACTIONS(4468),
    [anon_sym_PLUS] = ACTIONS(4468),
    [anon_sym_DASH] = ACTIONS(4468),
    [anon_sym_STAR] = ACTIONS(4468),
    [anon_sym_struct] = ACTIONS(4468),
    [anon_sym_union] = ACTIONS(4468),
    [anon_sym_pub] = ACTIONS(4468),
    [anon_sym_mut] = ACTIONS(4468),
    [anon_sym_enum] = ACTIONS(4468),
    [anon_sym_interface] = ACTIONS(4468),
    [anon_sym_QMARK] = ACTIONS(4468),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_go] = ACTIONS(4468),
    [anon_sym_spawn] = ACTIONS(4468),
    [anon_sym_json_DOTdecode] = ACTIONS(4468),
    [anon_sym_LBRACK2] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [anon_sym_CARET] = ACTIONS(4468),
    [anon_sym_AMP] = ACTIONS(4468),
    [anon_sym_LT_DASH] = ACTIONS(4468),
    [sym_none] = ACTIONS(4468),
    [sym_true] = ACTIONS(4468),
    [sym_false] = ACTIONS(4468),
    [sym_nil] = ACTIONS(4468),
    [anon_sym_if] = ACTIONS(4468),
    [anon_sym_DOLLARif] = ACTIONS(4468),
    [anon_sym_match] = ACTIONS(4468),
    [anon_sym_select] = ACTIONS(4468),
    [anon_sym_lock] = ACTIONS(4468),
    [anon_sym_rlock] = ACTIONS(4468),
    [anon_sym_unsafe] = ACTIONS(4468),
    [anon_sym_sql] = ACTIONS(4468),
    [sym_int_literal] = ACTIONS(4468),
    [sym_float_literal] = ACTIONS(4468),
    [sym_rune_literal] = ACTIONS(4468),
    [anon_sym_SQUOTE] = ACTIONS(4468),
    [anon_sym_DQUOTE] = ACTIONS(4468),
    [anon_sym_c_SQUOTE] = ACTIONS(4468),
    [anon_sym_c_DQUOTE] = ACTIONS(4468),
    [anon_sym_r_SQUOTE] = ACTIONS(4468),
    [anon_sym_r_DQUOTE] = ACTIONS(4468),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4468),
    [anon_sym_shared] = ACTIONS(4468),
    [anon_sym_map_LBRACK] = ACTIONS(4468),
    [anon_sym_chan] = ACTIONS(4468),
    [anon_sym_thread] = ACTIONS(4468),
    [anon_sym_atomic] = ACTIONS(4468),
    [anon_sym_assert] = ACTIONS(4468),
    [anon_sym_defer] = ACTIONS(4468),
    [anon_sym_goto] = ACTIONS(4468),
    [anon_sym_break] = ACTIONS(4468),
    [anon_sym_continue] = ACTIONS(4468),
    [anon_sym_return] = ACTIONS(4468),
    [anon_sym_DOLLARfor] = ACTIONS(4468),
    [anon_sym_for] = ACTIONS(4468),
    [anon_sym_POUND] = ACTIONS(4468),
    [anon_sym_asm] = ACTIONS(4468),
    [anon_sym_AT_LBRACK] = ACTIONS(4468),
  },
  [1759] = {
    [sym_line_comment] = STATE(1759),
    [sym_block_comment] = STATE(1759),
    [sym_block] = STATE(1897),
    [ts_builtin_sym_end] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4472),
    [anon_sym_LF] = ACTIONS(4472),
    [anon_sym_CR] = ACTIONS(4472),
    [anon_sym_CR_LF] = ACTIONS(4472),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4472),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4472),
    [anon_sym_LPAREN] = ACTIONS(4472),
    [anon_sym___global] = ACTIONS(4472),
    [anon_sym_type] = ACTIONS(4472),
    [anon_sym_fn] = ACTIONS(4472),
    [anon_sym_PLUS] = ACTIONS(4472),
    [anon_sym_DASH] = ACTIONS(4472),
    [anon_sym_STAR] = ACTIONS(4472),
    [anon_sym_struct] = ACTIONS(4472),
    [anon_sym_union] = ACTIONS(4472),
    [anon_sym_pub] = ACTIONS(4472),
    [anon_sym_mut] = ACTIONS(4472),
    [anon_sym_enum] = ACTIONS(4472),
    [anon_sym_interface] = ACTIONS(4472),
    [anon_sym_QMARK] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(4472),
    [anon_sym_go] = ACTIONS(4472),
    [anon_sym_spawn] = ACTIONS(4472),
    [anon_sym_json_DOTdecode] = ACTIONS(4472),
    [anon_sym_LBRACK2] = ACTIONS(4472),
    [anon_sym_TILDE] = ACTIONS(4472),
    [anon_sym_CARET] = ACTIONS(4472),
    [anon_sym_AMP] = ACTIONS(4472),
    [anon_sym_LT_DASH] = ACTIONS(4472),
    [sym_none] = ACTIONS(4472),
    [sym_true] = ACTIONS(4472),
    [sym_false] = ACTIONS(4472),
    [sym_nil] = ACTIONS(4472),
    [anon_sym_if] = ACTIONS(4472),
    [anon_sym_DOLLARif] = ACTIONS(4472),
    [anon_sym_match] = ACTIONS(4472),
    [anon_sym_select] = ACTIONS(4472),
    [anon_sym_lock] = ACTIONS(4472),
    [anon_sym_rlock] = ACTIONS(4472),
    [anon_sym_unsafe] = ACTIONS(4472),
    [anon_sym_sql] = ACTIONS(4472),
    [sym_int_literal] = ACTIONS(4472),
    [sym_float_literal] = ACTIONS(4472),
    [sym_rune_literal] = ACTIONS(4472),
    [anon_sym_SQUOTE] = ACTIONS(4472),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_c_SQUOTE] = ACTIONS(4472),
    [anon_sym_c_DQUOTE] = ACTIONS(4472),
    [anon_sym_r_SQUOTE] = ACTIONS(4472),
    [anon_sym_r_DQUOTE] = ACTIONS(4472),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4472),
    [anon_sym_shared] = ACTIONS(4472),
    [anon_sym_map_LBRACK] = ACTIONS(4472),
    [anon_sym_chan] = ACTIONS(4472),
    [anon_sym_thread] = ACTIONS(4472),
    [anon_sym_atomic] = ACTIONS(4472),
    [anon_sym_assert] = ACTIONS(4472),
    [anon_sym_defer] = ACTIONS(4472),
    [anon_sym_goto] = ACTIONS(4472),
    [anon_sym_break] = ACTIONS(4472),
    [anon_sym_continue] = ACTIONS(4472),
    [anon_sym_return] = ACTIONS(4472),
    [anon_sym_DOLLARfor] = ACTIONS(4472),
    [anon_sym_for] = ACTIONS(4472),
    [anon_sym_POUND] = ACTIONS(4472),
    [anon_sym_asm] = ACTIONS(4472),
    [anon_sym_AT_LBRACK] = ACTIONS(4472),
  },
  [1760] = {
    [sym_line_comment] = STATE(1760),
    [sym_block_comment] = STATE(1760),
    [sym_block] = STATE(1808),
    [ts_builtin_sym_end] = ACTIONS(4474),
    [sym_identifier] = ACTIONS(4476),
    [anon_sym_LF] = ACTIONS(4476),
    [anon_sym_CR] = ACTIONS(4476),
    [anon_sym_CR_LF] = ACTIONS(4476),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4476),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4476),
    [anon_sym_LPAREN] = ACTIONS(4476),
    [anon_sym___global] = ACTIONS(4476),
    [anon_sym_type] = ACTIONS(4476),
    [anon_sym_fn] = ACTIONS(4476),
    [anon_sym_PLUS] = ACTIONS(4476),
    [anon_sym_DASH] = ACTIONS(4476),
    [anon_sym_STAR] = ACTIONS(4476),
    [anon_sym_struct] = ACTIONS(4476),
    [anon_sym_union] = ACTIONS(4476),
    [anon_sym_pub] = ACTIONS(4476),
    [anon_sym_mut] = ACTIONS(4476),
    [anon_sym_enum] = ACTIONS(4476),
    [anon_sym_interface] = ACTIONS(4476),
    [anon_sym_QMARK] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(4476),
    [anon_sym_go] = ACTIONS(4476),
    [anon_sym_spawn] = ACTIONS(4476),
    [anon_sym_json_DOTdecode] = ACTIONS(4476),
    [anon_sym_LBRACK2] = ACTIONS(4476),
    [anon_sym_TILDE] = ACTIONS(4476),
    [anon_sym_CARET] = ACTIONS(4476),
    [anon_sym_AMP] = ACTIONS(4476),
    [anon_sym_LT_DASH] = ACTIONS(4476),
    [sym_none] = ACTIONS(4476),
    [sym_true] = ACTIONS(4476),
    [sym_false] = ACTIONS(4476),
    [sym_nil] = ACTIONS(4476),
    [anon_sym_if] = ACTIONS(4476),
    [anon_sym_DOLLARif] = ACTIONS(4476),
    [anon_sym_match] = ACTIONS(4476),
    [anon_sym_select] = ACTIONS(4476),
    [anon_sym_lock] = ACTIONS(4476),
    [anon_sym_rlock] = ACTIONS(4476),
    [anon_sym_unsafe] = ACTIONS(4476),
    [anon_sym_sql] = ACTIONS(4476),
    [sym_int_literal] = ACTIONS(4476),
    [sym_float_literal] = ACTIONS(4476),
    [sym_rune_literal] = ACTIONS(4476),
    [anon_sym_SQUOTE] = ACTIONS(4476),
    [anon_sym_DQUOTE] = ACTIONS(4476),
    [anon_sym_c_SQUOTE] = ACTIONS(4476),
    [anon_sym_c_DQUOTE] = ACTIONS(4476),
    [anon_sym_r_SQUOTE] = ACTIONS(4476),
    [anon_sym_r_DQUOTE] = ACTIONS(4476),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4476),
    [anon_sym_shared] = ACTIONS(4476),
    [anon_sym_map_LBRACK] = ACTIONS(4476),
    [anon_sym_chan] = ACTIONS(4476),
    [anon_sym_thread] = ACTIONS(4476),
    [anon_sym_atomic] = ACTIONS(4476),
    [anon_sym_assert] = ACTIONS(4476),
    [anon_sym_defer] = ACTIONS(4476),
    [anon_sym_goto] = ACTIONS(4476),
    [anon_sym_break] = ACTIONS(4476),
    [anon_sym_continue] = ACTIONS(4476),
    [anon_sym_return] = ACTIONS(4476),
    [anon_sym_DOLLARfor] = ACTIONS(4476),
    [anon_sym_for] = ACTIONS(4476),
    [anon_sym_POUND] = ACTIONS(4476),
    [anon_sym_asm] = ACTIONS(4476),
    [anon_sym_AT_LBRACK] = ACTIONS(4476),
  },
  [1761] = {
    [sym_line_comment] = STATE(1761),
    [sym_block_comment] = STATE(1761),
    [sym_block] = STATE(1884),
    [ts_builtin_sym_end] = ACTIONS(4478),
    [sym_identifier] = ACTIONS(4480),
    [anon_sym_LF] = ACTIONS(4480),
    [anon_sym_CR] = ACTIONS(4480),
    [anon_sym_CR_LF] = ACTIONS(4480),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4480),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4480),
    [anon_sym_LPAREN] = ACTIONS(4480),
    [anon_sym___global] = ACTIONS(4480),
    [anon_sym_type] = ACTIONS(4480),
    [anon_sym_fn] = ACTIONS(4480),
    [anon_sym_PLUS] = ACTIONS(4480),
    [anon_sym_DASH] = ACTIONS(4480),
    [anon_sym_STAR] = ACTIONS(4480),
    [anon_sym_struct] = ACTIONS(4480),
    [anon_sym_union] = ACTIONS(4480),
    [anon_sym_pub] = ACTIONS(4480),
    [anon_sym_mut] = ACTIONS(4480),
    [anon_sym_enum] = ACTIONS(4480),
    [anon_sym_interface] = ACTIONS(4480),
    [anon_sym_QMARK] = ACTIONS(4480),
    [anon_sym_BANG] = ACTIONS(4480),
    [anon_sym_go] = ACTIONS(4480),
    [anon_sym_spawn] = ACTIONS(4480),
    [anon_sym_json_DOTdecode] = ACTIONS(4480),
    [anon_sym_LBRACK2] = ACTIONS(4480),
    [anon_sym_TILDE] = ACTIONS(4480),
    [anon_sym_CARET] = ACTIONS(4480),
    [anon_sym_AMP] = ACTIONS(4480),
    [anon_sym_LT_DASH] = ACTIONS(4480),
    [sym_none] = ACTIONS(4480),
    [sym_true] = ACTIONS(4480),
    [sym_false] = ACTIONS(4480),
    [sym_nil] = ACTIONS(4480),
    [anon_sym_if] = ACTIONS(4480),
    [anon_sym_DOLLARif] = ACTIONS(4480),
    [anon_sym_match] = ACTIONS(4480),
    [anon_sym_select] = ACTIONS(4480),
    [anon_sym_lock] = ACTIONS(4480),
    [anon_sym_rlock] = ACTIONS(4480),
    [anon_sym_unsafe] = ACTIONS(4480),
    [anon_sym_sql] = ACTIONS(4480),
    [sym_int_literal] = ACTIONS(4480),
    [sym_float_literal] = ACTIONS(4480),
    [sym_rune_literal] = ACTIONS(4480),
    [anon_sym_SQUOTE] = ACTIONS(4480),
    [anon_sym_DQUOTE] = ACTIONS(4480),
    [anon_sym_c_SQUOTE] = ACTIONS(4480),
    [anon_sym_c_DQUOTE] = ACTIONS(4480),
    [anon_sym_r_SQUOTE] = ACTIONS(4480),
    [anon_sym_r_DQUOTE] = ACTIONS(4480),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4480),
    [anon_sym_shared] = ACTIONS(4480),
    [anon_sym_map_LBRACK] = ACTIONS(4480),
    [anon_sym_chan] = ACTIONS(4480),
    [anon_sym_thread] = ACTIONS(4480),
    [anon_sym_atomic] = ACTIONS(4480),
    [anon_sym_assert] = ACTIONS(4480),
    [anon_sym_defer] = ACTIONS(4480),
    [anon_sym_goto] = ACTIONS(4480),
    [anon_sym_break] = ACTIONS(4480),
    [anon_sym_continue] = ACTIONS(4480),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_DOLLARfor] = ACTIONS(4480),
    [anon_sym_for] = ACTIONS(4480),
    [anon_sym_POUND] = ACTIONS(4480),
    [anon_sym_asm] = ACTIONS(4480),
    [anon_sym_AT_LBRACK] = ACTIONS(4480),
  },
  [1762] = {
    [sym_line_comment] = STATE(1762),
    [sym_block_comment] = STATE(1762),
    [sym_block] = STATE(1867),
    [ts_builtin_sym_end] = ACTIONS(4482),
    [sym_identifier] = ACTIONS(4484),
    [anon_sym_LF] = ACTIONS(4484),
    [anon_sym_CR] = ACTIONS(4484),
    [anon_sym_CR_LF] = ACTIONS(4484),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4484),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4484),
    [anon_sym_LPAREN] = ACTIONS(4484),
    [anon_sym___global] = ACTIONS(4484),
    [anon_sym_type] = ACTIONS(4484),
    [anon_sym_fn] = ACTIONS(4484),
    [anon_sym_PLUS] = ACTIONS(4484),
    [anon_sym_DASH] = ACTIONS(4484),
    [anon_sym_STAR] = ACTIONS(4484),
    [anon_sym_struct] = ACTIONS(4484),
    [anon_sym_union] = ACTIONS(4484),
    [anon_sym_pub] = ACTIONS(4484),
    [anon_sym_mut] = ACTIONS(4484),
    [anon_sym_enum] = ACTIONS(4484),
    [anon_sym_interface] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4484),
    [anon_sym_go] = ACTIONS(4484),
    [anon_sym_spawn] = ACTIONS(4484),
    [anon_sym_json_DOTdecode] = ACTIONS(4484),
    [anon_sym_LBRACK2] = ACTIONS(4484),
    [anon_sym_TILDE] = ACTIONS(4484),
    [anon_sym_CARET] = ACTIONS(4484),
    [anon_sym_AMP] = ACTIONS(4484),
    [anon_sym_LT_DASH] = ACTIONS(4484),
    [sym_none] = ACTIONS(4484),
    [sym_true] = ACTIONS(4484),
    [sym_false] = ACTIONS(4484),
    [sym_nil] = ACTIONS(4484),
    [anon_sym_if] = ACTIONS(4484),
    [anon_sym_DOLLARif] = ACTIONS(4484),
    [anon_sym_match] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [anon_sym_lock] = ACTIONS(4484),
    [anon_sym_rlock] = ACTIONS(4484),
    [anon_sym_unsafe] = ACTIONS(4484),
    [anon_sym_sql] = ACTIONS(4484),
    [sym_int_literal] = ACTIONS(4484),
    [sym_float_literal] = ACTIONS(4484),
    [sym_rune_literal] = ACTIONS(4484),
    [anon_sym_SQUOTE] = ACTIONS(4484),
    [anon_sym_DQUOTE] = ACTIONS(4484),
    [anon_sym_c_SQUOTE] = ACTIONS(4484),
    [anon_sym_c_DQUOTE] = ACTIONS(4484),
    [anon_sym_r_SQUOTE] = ACTIONS(4484),
    [anon_sym_r_DQUOTE] = ACTIONS(4484),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4484),
    [anon_sym_shared] = ACTIONS(4484),
    [anon_sym_map_LBRACK] = ACTIONS(4484),
    [anon_sym_chan] = ACTIONS(4484),
    [anon_sym_thread] = ACTIONS(4484),
    [anon_sym_atomic] = ACTIONS(4484),
    [anon_sym_assert] = ACTIONS(4484),
    [anon_sym_defer] = ACTIONS(4484),
    [anon_sym_goto] = ACTIONS(4484),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_continue] = ACTIONS(4484),
    [anon_sym_return] = ACTIONS(4484),
    [anon_sym_DOLLARfor] = ACTIONS(4484),
    [anon_sym_for] = ACTIONS(4484),
    [anon_sym_POUND] = ACTIONS(4484),
    [anon_sym_asm] = ACTIONS(4484),
    [anon_sym_AT_LBRACK] = ACTIONS(4484),
  },
  [1763] = {
    [sym_line_comment] = STATE(1763),
    [sym_block_comment] = STATE(1763),
    [sym_block] = STATE(1869),
    [ts_builtin_sym_end] = ACTIONS(4486),
    [sym_identifier] = ACTIONS(4488),
    [anon_sym_LF] = ACTIONS(4488),
    [anon_sym_CR] = ACTIONS(4488),
    [anon_sym_CR_LF] = ACTIONS(4488),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4488),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4488),
    [anon_sym_LPAREN] = ACTIONS(4488),
    [anon_sym___global] = ACTIONS(4488),
    [anon_sym_type] = ACTIONS(4488),
    [anon_sym_fn] = ACTIONS(4488),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_DASH] = ACTIONS(4488),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_struct] = ACTIONS(4488),
    [anon_sym_union] = ACTIONS(4488),
    [anon_sym_pub] = ACTIONS(4488),
    [anon_sym_mut] = ACTIONS(4488),
    [anon_sym_enum] = ACTIONS(4488),
    [anon_sym_interface] = ACTIONS(4488),
    [anon_sym_QMARK] = ACTIONS(4488),
    [anon_sym_BANG] = ACTIONS(4488),
    [anon_sym_go] = ACTIONS(4488),
    [anon_sym_spawn] = ACTIONS(4488),
    [anon_sym_json_DOTdecode] = ACTIONS(4488),
    [anon_sym_LBRACK2] = ACTIONS(4488),
    [anon_sym_TILDE] = ACTIONS(4488),
    [anon_sym_CARET] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_LT_DASH] = ACTIONS(4488),
    [sym_none] = ACTIONS(4488),
    [sym_true] = ACTIONS(4488),
    [sym_false] = ACTIONS(4488),
    [sym_nil] = ACTIONS(4488),
    [anon_sym_if] = ACTIONS(4488),
    [anon_sym_DOLLARif] = ACTIONS(4488),
    [anon_sym_match] = ACTIONS(4488),
    [anon_sym_select] = ACTIONS(4488),
    [anon_sym_lock] = ACTIONS(4488),
    [anon_sym_rlock] = ACTIONS(4488),
    [anon_sym_unsafe] = ACTIONS(4488),
    [anon_sym_sql] = ACTIONS(4488),
    [sym_int_literal] = ACTIONS(4488),
    [sym_float_literal] = ACTIONS(4488),
    [sym_rune_literal] = ACTIONS(4488),
    [anon_sym_SQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE] = ACTIONS(4488),
    [anon_sym_c_SQUOTE] = ACTIONS(4488),
    [anon_sym_c_DQUOTE] = ACTIONS(4488),
    [anon_sym_r_SQUOTE] = ACTIONS(4488),
    [anon_sym_r_DQUOTE] = ACTIONS(4488),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4488),
    [anon_sym_shared] = ACTIONS(4488),
    [anon_sym_map_LBRACK] = ACTIONS(4488),
    [anon_sym_chan] = ACTIONS(4488),
    [anon_sym_thread] = ACTIONS(4488),
    [anon_sym_atomic] = ACTIONS(4488),
    [anon_sym_assert] = ACTIONS(4488),
    [anon_sym_defer] = ACTIONS(4488),
    [anon_sym_goto] = ACTIONS(4488),
    [anon_sym_break] = ACTIONS(4488),
    [anon_sym_continue] = ACTIONS(4488),
    [anon_sym_return] = ACTIONS(4488),
    [anon_sym_DOLLARfor] = ACTIONS(4488),
    [anon_sym_for] = ACTIONS(4488),
    [anon_sym_POUND] = ACTIONS(4488),
    [anon_sym_asm] = ACTIONS(4488),
    [anon_sym_AT_LBRACK] = ACTIONS(4488),
  },
  [1764] = {
    [sym_line_comment] = STATE(1764),
    [sym_block_comment] = STATE(1764),
    [sym_block] = STATE(1873),
    [ts_builtin_sym_end] = ACTIONS(4490),
    [sym_identifier] = ACTIONS(4492),
    [anon_sym_LF] = ACTIONS(4492),
    [anon_sym_CR] = ACTIONS(4492),
    [anon_sym_CR_LF] = ACTIONS(4492),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4492),
    [anon_sym_LPAREN] = ACTIONS(4492),
    [anon_sym___global] = ACTIONS(4492),
    [anon_sym_type] = ACTIONS(4492),
    [anon_sym_fn] = ACTIONS(4492),
    [anon_sym_PLUS] = ACTIONS(4492),
    [anon_sym_DASH] = ACTIONS(4492),
    [anon_sym_STAR] = ACTIONS(4492),
    [anon_sym_struct] = ACTIONS(4492),
    [anon_sym_union] = ACTIONS(4492),
    [anon_sym_pub] = ACTIONS(4492),
    [anon_sym_mut] = ACTIONS(4492),
    [anon_sym_enum] = ACTIONS(4492),
    [anon_sym_interface] = ACTIONS(4492),
    [anon_sym_QMARK] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4492),
    [anon_sym_go] = ACTIONS(4492),
    [anon_sym_spawn] = ACTIONS(4492),
    [anon_sym_json_DOTdecode] = ACTIONS(4492),
    [anon_sym_LBRACK2] = ACTIONS(4492),
    [anon_sym_TILDE] = ACTIONS(4492),
    [anon_sym_CARET] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(4492),
    [anon_sym_LT_DASH] = ACTIONS(4492),
    [sym_none] = ACTIONS(4492),
    [sym_true] = ACTIONS(4492),
    [sym_false] = ACTIONS(4492),
    [sym_nil] = ACTIONS(4492),
    [anon_sym_if] = ACTIONS(4492),
    [anon_sym_DOLLARif] = ACTIONS(4492),
    [anon_sym_match] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4492),
    [anon_sym_lock] = ACTIONS(4492),
    [anon_sym_rlock] = ACTIONS(4492),
    [anon_sym_unsafe] = ACTIONS(4492),
    [anon_sym_sql] = ACTIONS(4492),
    [sym_int_literal] = ACTIONS(4492),
    [sym_float_literal] = ACTIONS(4492),
    [sym_rune_literal] = ACTIONS(4492),
    [anon_sym_SQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE] = ACTIONS(4492),
    [anon_sym_c_SQUOTE] = ACTIONS(4492),
    [anon_sym_c_DQUOTE] = ACTIONS(4492),
    [anon_sym_r_SQUOTE] = ACTIONS(4492),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4492),
    [anon_sym_shared] = ACTIONS(4492),
    [anon_sym_map_LBRACK] = ACTIONS(4492),
    [anon_sym_chan] = ACTIONS(4492),
    [anon_sym_thread] = ACTIONS(4492),
    [anon_sym_atomic] = ACTIONS(4492),
    [anon_sym_assert] = ACTIONS(4492),
    [anon_sym_defer] = ACTIONS(4492),
    [anon_sym_goto] = ACTIONS(4492),
    [anon_sym_break] = ACTIONS(4492),
    [anon_sym_continue] = ACTIONS(4492),
    [anon_sym_return] = ACTIONS(4492),
    [anon_sym_DOLLARfor] = ACTIONS(4492),
    [anon_sym_for] = ACTIONS(4492),
    [anon_sym_POUND] = ACTIONS(4492),
    [anon_sym_asm] = ACTIONS(4492),
    [anon_sym_AT_LBRACK] = ACTIONS(4492),
  },
  [1765] = {
    [sym_line_comment] = STATE(1765),
    [sym_block_comment] = STATE(1765),
    [sym_block] = STATE(1847),
    [ts_builtin_sym_end] = ACTIONS(4494),
    [sym_identifier] = ACTIONS(4496),
    [anon_sym_LF] = ACTIONS(4496),
    [anon_sym_CR] = ACTIONS(4496),
    [anon_sym_CR_LF] = ACTIONS(4496),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4496),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4496),
    [anon_sym_LPAREN] = ACTIONS(4496),
    [anon_sym___global] = ACTIONS(4496),
    [anon_sym_type] = ACTIONS(4496),
    [anon_sym_fn] = ACTIONS(4496),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_DASH] = ACTIONS(4496),
    [anon_sym_STAR] = ACTIONS(4496),
    [anon_sym_struct] = ACTIONS(4496),
    [anon_sym_union] = ACTIONS(4496),
    [anon_sym_pub] = ACTIONS(4496),
    [anon_sym_mut] = ACTIONS(4496),
    [anon_sym_enum] = ACTIONS(4496),
    [anon_sym_interface] = ACTIONS(4496),
    [anon_sym_QMARK] = ACTIONS(4496),
    [anon_sym_BANG] = ACTIONS(4496),
    [anon_sym_go] = ACTIONS(4496),
    [anon_sym_spawn] = ACTIONS(4496),
    [anon_sym_json_DOTdecode] = ACTIONS(4496),
    [anon_sym_LBRACK2] = ACTIONS(4496),
    [anon_sym_TILDE] = ACTIONS(4496),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_AMP] = ACTIONS(4496),
    [anon_sym_LT_DASH] = ACTIONS(4496),
    [sym_none] = ACTIONS(4496),
    [sym_true] = ACTIONS(4496),
    [sym_false] = ACTIONS(4496),
    [sym_nil] = ACTIONS(4496),
    [anon_sym_if] = ACTIONS(4496),
    [anon_sym_DOLLARif] = ACTIONS(4496),
    [anon_sym_match] = ACTIONS(4496),
    [anon_sym_select] = ACTIONS(4496),
    [anon_sym_lock] = ACTIONS(4496),
    [anon_sym_rlock] = ACTIONS(4496),
    [anon_sym_unsafe] = ACTIONS(4496),
    [anon_sym_sql] = ACTIONS(4496),
    [sym_int_literal] = ACTIONS(4496),
    [sym_float_literal] = ACTIONS(4496),
    [sym_rune_literal] = ACTIONS(4496),
    [anon_sym_SQUOTE] = ACTIONS(4496),
    [anon_sym_DQUOTE] = ACTIONS(4496),
    [anon_sym_c_SQUOTE] = ACTIONS(4496),
    [anon_sym_c_DQUOTE] = ACTIONS(4496),
    [anon_sym_r_SQUOTE] = ACTIONS(4496),
    [anon_sym_r_DQUOTE] = ACTIONS(4496),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4496),
    [anon_sym_shared] = ACTIONS(4496),
    [anon_sym_map_LBRACK] = ACTIONS(4496),
    [anon_sym_chan] = ACTIONS(4496),
    [anon_sym_thread] = ACTIONS(4496),
    [anon_sym_atomic] = ACTIONS(4496),
    [anon_sym_assert] = ACTIONS(4496),
    [anon_sym_defer] = ACTIONS(4496),
    [anon_sym_goto] = ACTIONS(4496),
    [anon_sym_break] = ACTIONS(4496),
    [anon_sym_continue] = ACTIONS(4496),
    [anon_sym_return] = ACTIONS(4496),
    [anon_sym_DOLLARfor] = ACTIONS(4496),
    [anon_sym_for] = ACTIONS(4496),
    [anon_sym_POUND] = ACTIONS(4496),
    [anon_sym_asm] = ACTIONS(4496),
    [anon_sym_AT_LBRACK] = ACTIONS(4496),
  },
  [1766] = {
    [sym_line_comment] = STATE(1766),
    [sym_block_comment] = STATE(1766),
    [ts_builtin_sym_end] = ACTIONS(3908),
    [sym_identifier] = ACTIONS(2001),
    [anon_sym_LF] = ACTIONS(2001),
    [anon_sym_CR] = ACTIONS(2001),
    [anon_sym_CR_LF] = ACTIONS(2001),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(2001),
    [anon_sym_const] = ACTIONS(2001),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [anon_sym___global] = ACTIONS(2001),
    [anon_sym_type] = ACTIONS(2001),
    [anon_sym_fn] = ACTIONS(2001),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_struct] = ACTIONS(2001),
    [anon_sym_union] = ACTIONS(2001),
    [anon_sym_pub] = ACTIONS(2001),
    [anon_sym_mut] = ACTIONS(2001),
    [anon_sym_enum] = ACTIONS(2001),
    [anon_sym_interface] = ACTIONS(2001),
    [anon_sym_QMARK] = ACTIONS(2001),
    [anon_sym_BANG] = ACTIONS(2001),
    [anon_sym_go] = ACTIONS(2001),
    [anon_sym_spawn] = ACTIONS(2001),
    [anon_sym_json_DOTdecode] = ACTIONS(2001),
    [anon_sym_LBRACK2] = ACTIONS(2001),
    [anon_sym_TILDE] = ACTIONS(2001),
    [anon_sym_CARET] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_LT_DASH] = ACTIONS(2001),
    [sym_none] = ACTIONS(2001),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_nil] = ACTIONS(2001),
    [anon_sym_if] = ACTIONS(2001),
    [anon_sym_DOLLARif] = ACTIONS(2001),
    [anon_sym_match] = ACTIONS(2001),
    [anon_sym_select] = ACTIONS(2001),
    [anon_sym_lock] = ACTIONS(2001),
    [anon_sym_rlock] = ACTIONS(2001),
    [anon_sym_unsafe] = ACTIONS(2001),
    [anon_sym_sql] = ACTIONS(2001),
    [sym_int_literal] = ACTIONS(2001),
    [sym_float_literal] = ACTIONS(2001),
    [sym_rune_literal] = ACTIONS(2001),
    [anon_sym_SQUOTE] = ACTIONS(2001),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_c_SQUOTE] = ACTIONS(2001),
    [anon_sym_c_DQUOTE] = ACTIONS(2001),
    [anon_sym_r_SQUOTE] = ACTIONS(2001),
    [anon_sym_r_DQUOTE] = ACTIONS(2001),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2001),
    [anon_sym_shared] = ACTIONS(2001),
    [anon_sym_map_LBRACK] = ACTIONS(2001),
    [anon_sym_chan] = ACTIONS(2001),
    [anon_sym_thread] = ACTIONS(2001),
    [anon_sym_atomic] = ACTIONS(2001),
    [anon_sym_assert] = ACTIONS(2001),
    [anon_sym_defer] = ACTIONS(2001),
    [anon_sym_goto] = ACTIONS(2001),
    [anon_sym_break] = ACTIONS(2001),
    [anon_sym_continue] = ACTIONS(2001),
    [anon_sym_return] = ACTIONS(2001),
    [anon_sym_DOLLARfor] = ACTIONS(2001),
    [anon_sym_for] = ACTIONS(2001),
    [anon_sym_POUND] = ACTIONS(2001),
    [anon_sym_asm] = ACTIONS(2001),
    [anon_sym_AT_LBRACK] = ACTIONS(2001),
  },
  [1767] = {
    [sym_line_comment] = STATE(1767),
    [sym_block_comment] = STATE(1767),
    [sym_block] = STATE(1898),
    [ts_builtin_sym_end] = ACTIONS(4498),
    [sym_identifier] = ACTIONS(4500),
    [anon_sym_LF] = ACTIONS(4500),
    [anon_sym_CR] = ACTIONS(4500),
    [anon_sym_CR_LF] = ACTIONS(4500),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4500),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4500),
    [anon_sym_LPAREN] = ACTIONS(4500),
    [anon_sym___global] = ACTIONS(4500),
    [anon_sym_type] = ACTIONS(4500),
    [anon_sym_fn] = ACTIONS(4500),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_DASH] = ACTIONS(4500),
    [anon_sym_STAR] = ACTIONS(4500),
    [anon_sym_struct] = ACTIONS(4500),
    [anon_sym_union] = ACTIONS(4500),
    [anon_sym_pub] = ACTIONS(4500),
    [anon_sym_mut] = ACTIONS(4500),
    [anon_sym_enum] = ACTIONS(4500),
    [anon_sym_interface] = ACTIONS(4500),
    [anon_sym_QMARK] = ACTIONS(4500),
    [anon_sym_BANG] = ACTIONS(4500),
    [anon_sym_go] = ACTIONS(4500),
    [anon_sym_spawn] = ACTIONS(4500),
    [anon_sym_json_DOTdecode] = ACTIONS(4500),
    [anon_sym_LBRACK2] = ACTIONS(4500),
    [anon_sym_TILDE] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4500),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_LT_DASH] = ACTIONS(4500),
    [sym_none] = ACTIONS(4500),
    [sym_true] = ACTIONS(4500),
    [sym_false] = ACTIONS(4500),
    [sym_nil] = ACTIONS(4500),
    [anon_sym_if] = ACTIONS(4500),
    [anon_sym_DOLLARif] = ACTIONS(4500),
    [anon_sym_match] = ACTIONS(4500),
    [anon_sym_select] = ACTIONS(4500),
    [anon_sym_lock] = ACTIONS(4500),
    [anon_sym_rlock] = ACTIONS(4500),
    [anon_sym_unsafe] = ACTIONS(4500),
    [anon_sym_sql] = ACTIONS(4500),
    [sym_int_literal] = ACTIONS(4500),
    [sym_float_literal] = ACTIONS(4500),
    [sym_rune_literal] = ACTIONS(4500),
    [anon_sym_SQUOTE] = ACTIONS(4500),
    [anon_sym_DQUOTE] = ACTIONS(4500),
    [anon_sym_c_SQUOTE] = ACTIONS(4500),
    [anon_sym_c_DQUOTE] = ACTIONS(4500),
    [anon_sym_r_SQUOTE] = ACTIONS(4500),
    [anon_sym_r_DQUOTE] = ACTIONS(4500),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4500),
    [anon_sym_shared] = ACTIONS(4500),
    [anon_sym_map_LBRACK] = ACTIONS(4500),
    [anon_sym_chan] = ACTIONS(4500),
    [anon_sym_thread] = ACTIONS(4500),
    [anon_sym_atomic] = ACTIONS(4500),
    [anon_sym_assert] = ACTIONS(4500),
    [anon_sym_defer] = ACTIONS(4500),
    [anon_sym_goto] = ACTIONS(4500),
    [anon_sym_break] = ACTIONS(4500),
    [anon_sym_continue] = ACTIONS(4500),
    [anon_sym_return] = ACTIONS(4500),
    [anon_sym_DOLLARfor] = ACTIONS(4500),
    [anon_sym_for] = ACTIONS(4500),
    [anon_sym_POUND] = ACTIONS(4500),
    [anon_sym_asm] = ACTIONS(4500),
    [anon_sym_AT_LBRACK] = ACTIONS(4500),
  },
  [1768] = {
    [sym_line_comment] = STATE(1768),
    [sym_block_comment] = STATE(1768),
    [sym_block] = STATE(1817),
    [ts_builtin_sym_end] = ACTIONS(4502),
    [sym_identifier] = ACTIONS(4504),
    [anon_sym_LF] = ACTIONS(4504),
    [anon_sym_CR] = ACTIONS(4504),
    [anon_sym_CR_LF] = ACTIONS(4504),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4504),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4504),
    [anon_sym_LPAREN] = ACTIONS(4504),
    [anon_sym___global] = ACTIONS(4504),
    [anon_sym_type] = ACTIONS(4504),
    [anon_sym_fn] = ACTIONS(4504),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_STAR] = ACTIONS(4504),
    [anon_sym_struct] = ACTIONS(4504),
    [anon_sym_union] = ACTIONS(4504),
    [anon_sym_pub] = ACTIONS(4504),
    [anon_sym_mut] = ACTIONS(4504),
    [anon_sym_enum] = ACTIONS(4504),
    [anon_sym_interface] = ACTIONS(4504),
    [anon_sym_QMARK] = ACTIONS(4504),
    [anon_sym_BANG] = ACTIONS(4504),
    [anon_sym_go] = ACTIONS(4504),
    [anon_sym_spawn] = ACTIONS(4504),
    [anon_sym_json_DOTdecode] = ACTIONS(4504),
    [anon_sym_LBRACK2] = ACTIONS(4504),
    [anon_sym_TILDE] = ACTIONS(4504),
    [anon_sym_CARET] = ACTIONS(4504),
    [anon_sym_AMP] = ACTIONS(4504),
    [anon_sym_LT_DASH] = ACTIONS(4504),
    [sym_none] = ACTIONS(4504),
    [sym_true] = ACTIONS(4504),
    [sym_false] = ACTIONS(4504),
    [sym_nil] = ACTIONS(4504),
    [anon_sym_if] = ACTIONS(4504),
    [anon_sym_DOLLARif] = ACTIONS(4504),
    [anon_sym_match] = ACTIONS(4504),
    [anon_sym_select] = ACTIONS(4504),
    [anon_sym_lock] = ACTIONS(4504),
    [anon_sym_rlock] = ACTIONS(4504),
    [anon_sym_unsafe] = ACTIONS(4504),
    [anon_sym_sql] = ACTIONS(4504),
    [sym_int_literal] = ACTIONS(4504),
    [sym_float_literal] = ACTIONS(4504),
    [sym_rune_literal] = ACTIONS(4504),
    [anon_sym_SQUOTE] = ACTIONS(4504),
    [anon_sym_DQUOTE] = ACTIONS(4504),
    [anon_sym_c_SQUOTE] = ACTIONS(4504),
    [anon_sym_c_DQUOTE] = ACTIONS(4504),
    [anon_sym_r_SQUOTE] = ACTIONS(4504),
    [anon_sym_r_DQUOTE] = ACTIONS(4504),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4504),
    [anon_sym_shared] = ACTIONS(4504),
    [anon_sym_map_LBRACK] = ACTIONS(4504),
    [anon_sym_chan] = ACTIONS(4504),
    [anon_sym_thread] = ACTIONS(4504),
    [anon_sym_atomic] = ACTIONS(4504),
    [anon_sym_assert] = ACTIONS(4504),
    [anon_sym_defer] = ACTIONS(4504),
    [anon_sym_goto] = ACTIONS(4504),
    [anon_sym_break] = ACTIONS(4504),
    [anon_sym_continue] = ACTIONS(4504),
    [anon_sym_return] = ACTIONS(4504),
    [anon_sym_DOLLARfor] = ACTIONS(4504),
    [anon_sym_for] = ACTIONS(4504),
    [anon_sym_POUND] = ACTIONS(4504),
    [anon_sym_asm] = ACTIONS(4504),
    [anon_sym_AT_LBRACK] = ACTIONS(4504),
  },
  [1769] = {
    [sym_line_comment] = STATE(1769),
    [sym_block_comment] = STATE(1769),
    [sym_block] = STATE(1864),
    [ts_builtin_sym_end] = ACTIONS(4506),
    [sym_identifier] = ACTIONS(4508),
    [anon_sym_LF] = ACTIONS(4508),
    [anon_sym_CR] = ACTIONS(4508),
    [anon_sym_CR_LF] = ACTIONS(4508),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4508),
    [anon_sym_LPAREN] = ACTIONS(4508),
    [anon_sym___global] = ACTIONS(4508),
    [anon_sym_type] = ACTIONS(4508),
    [anon_sym_fn] = ACTIONS(4508),
    [anon_sym_PLUS] = ACTIONS(4508),
    [anon_sym_DASH] = ACTIONS(4508),
    [anon_sym_STAR] = ACTIONS(4508),
    [anon_sym_struct] = ACTIONS(4508),
    [anon_sym_union] = ACTIONS(4508),
    [anon_sym_pub] = ACTIONS(4508),
    [anon_sym_mut] = ACTIONS(4508),
    [anon_sym_enum] = ACTIONS(4508),
    [anon_sym_interface] = ACTIONS(4508),
    [anon_sym_QMARK] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(4508),
    [anon_sym_go] = ACTIONS(4508),
    [anon_sym_spawn] = ACTIONS(4508),
    [anon_sym_json_DOTdecode] = ACTIONS(4508),
    [anon_sym_LBRACK2] = ACTIONS(4508),
    [anon_sym_TILDE] = ACTIONS(4508),
    [anon_sym_CARET] = ACTIONS(4508),
    [anon_sym_AMP] = ACTIONS(4508),
    [anon_sym_LT_DASH] = ACTIONS(4508),
    [sym_none] = ACTIONS(4508),
    [sym_true] = ACTIONS(4508),
    [sym_false] = ACTIONS(4508),
    [sym_nil] = ACTIONS(4508),
    [anon_sym_if] = ACTIONS(4508),
    [anon_sym_DOLLARif] = ACTIONS(4508),
    [anon_sym_match] = ACTIONS(4508),
    [anon_sym_select] = ACTIONS(4508),
    [anon_sym_lock] = ACTIONS(4508),
    [anon_sym_rlock] = ACTIONS(4508),
    [anon_sym_unsafe] = ACTIONS(4508),
    [anon_sym_sql] = ACTIONS(4508),
    [sym_int_literal] = ACTIONS(4508),
    [sym_float_literal] = ACTIONS(4508),
    [sym_rune_literal] = ACTIONS(4508),
    [anon_sym_SQUOTE] = ACTIONS(4508),
    [anon_sym_DQUOTE] = ACTIONS(4508),
    [anon_sym_c_SQUOTE] = ACTIONS(4508),
    [anon_sym_c_DQUOTE] = ACTIONS(4508),
    [anon_sym_r_SQUOTE] = ACTIONS(4508),
    [anon_sym_r_DQUOTE] = ACTIONS(4508),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4508),
    [anon_sym_shared] = ACTIONS(4508),
    [anon_sym_map_LBRACK] = ACTIONS(4508),
    [anon_sym_chan] = ACTIONS(4508),
    [anon_sym_thread] = ACTIONS(4508),
    [anon_sym_atomic] = ACTIONS(4508),
    [anon_sym_assert] = ACTIONS(4508),
    [anon_sym_defer] = ACTIONS(4508),
    [anon_sym_goto] = ACTIONS(4508),
    [anon_sym_break] = ACTIONS(4508),
    [anon_sym_continue] = ACTIONS(4508),
    [anon_sym_return] = ACTIONS(4508),
    [anon_sym_DOLLARfor] = ACTIONS(4508),
    [anon_sym_for] = ACTIONS(4508),
    [anon_sym_POUND] = ACTIONS(4508),
    [anon_sym_asm] = ACTIONS(4508),
    [anon_sym_AT_LBRACK] = ACTIONS(4508),
  },
  [1770] = {
    [sym_line_comment] = STATE(1770),
    [sym_block_comment] = STATE(1770),
    [sym_block] = STATE(1818),
    [ts_builtin_sym_end] = ACTIONS(4510),
    [sym_identifier] = ACTIONS(4512),
    [anon_sym_LF] = ACTIONS(4512),
    [anon_sym_CR] = ACTIONS(4512),
    [anon_sym_CR_LF] = ACTIONS(4512),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4512),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4512),
    [anon_sym_LPAREN] = ACTIONS(4512),
    [anon_sym___global] = ACTIONS(4512),
    [anon_sym_type] = ACTIONS(4512),
    [anon_sym_fn] = ACTIONS(4512),
    [anon_sym_PLUS] = ACTIONS(4512),
    [anon_sym_DASH] = ACTIONS(4512),
    [anon_sym_STAR] = ACTIONS(4512),
    [anon_sym_struct] = ACTIONS(4512),
    [anon_sym_union] = ACTIONS(4512),
    [anon_sym_pub] = ACTIONS(4512),
    [anon_sym_mut] = ACTIONS(4512),
    [anon_sym_enum] = ACTIONS(4512),
    [anon_sym_interface] = ACTIONS(4512),
    [anon_sym_QMARK] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(4512),
    [anon_sym_go] = ACTIONS(4512),
    [anon_sym_spawn] = ACTIONS(4512),
    [anon_sym_json_DOTdecode] = ACTIONS(4512),
    [anon_sym_LBRACK2] = ACTIONS(4512),
    [anon_sym_TILDE] = ACTIONS(4512),
    [anon_sym_CARET] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4512),
    [anon_sym_LT_DASH] = ACTIONS(4512),
    [sym_none] = ACTIONS(4512),
    [sym_true] = ACTIONS(4512),
    [sym_false] = ACTIONS(4512),
    [sym_nil] = ACTIONS(4512),
    [anon_sym_if] = ACTIONS(4512),
    [anon_sym_DOLLARif] = ACTIONS(4512),
    [anon_sym_match] = ACTIONS(4512),
    [anon_sym_select] = ACTIONS(4512),
    [anon_sym_lock] = ACTIONS(4512),
    [anon_sym_rlock] = ACTIONS(4512),
    [anon_sym_unsafe] = ACTIONS(4512),
    [anon_sym_sql] = ACTIONS(4512),
    [sym_int_literal] = ACTIONS(4512),
    [sym_float_literal] = ACTIONS(4512),
    [sym_rune_literal] = ACTIONS(4512),
    [anon_sym_SQUOTE] = ACTIONS(4512),
    [anon_sym_DQUOTE] = ACTIONS(4512),
    [anon_sym_c_SQUOTE] = ACTIONS(4512),
    [anon_sym_c_DQUOTE] = ACTIONS(4512),
    [anon_sym_r_SQUOTE] = ACTIONS(4512),
    [anon_sym_r_DQUOTE] = ACTIONS(4512),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4512),
    [anon_sym_shared] = ACTIONS(4512),
    [anon_sym_map_LBRACK] = ACTIONS(4512),
    [anon_sym_chan] = ACTIONS(4512),
    [anon_sym_thread] = ACTIONS(4512),
    [anon_sym_atomic] = ACTIONS(4512),
    [anon_sym_assert] = ACTIONS(4512),
    [anon_sym_defer] = ACTIONS(4512),
    [anon_sym_goto] = ACTIONS(4512),
    [anon_sym_break] = ACTIONS(4512),
    [anon_sym_continue] = ACTIONS(4512),
    [anon_sym_return] = ACTIONS(4512),
    [anon_sym_DOLLARfor] = ACTIONS(4512),
    [anon_sym_for] = ACTIONS(4512),
    [anon_sym_POUND] = ACTIONS(4512),
    [anon_sym_asm] = ACTIONS(4512),
    [anon_sym_AT_LBRACK] = ACTIONS(4512),
  },
  [1771] = {
    [sym_line_comment] = STATE(1771),
    [sym_block_comment] = STATE(1771),
    [sym_block] = STATE(1843),
    [ts_builtin_sym_end] = ACTIONS(4514),
    [sym_identifier] = ACTIONS(4516),
    [anon_sym_LF] = ACTIONS(4516),
    [anon_sym_CR] = ACTIONS(4516),
    [anon_sym_CR_LF] = ACTIONS(4516),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4516),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4516),
    [anon_sym_LPAREN] = ACTIONS(4516),
    [anon_sym___global] = ACTIONS(4516),
    [anon_sym_type] = ACTIONS(4516),
    [anon_sym_fn] = ACTIONS(4516),
    [anon_sym_PLUS] = ACTIONS(4516),
    [anon_sym_DASH] = ACTIONS(4516),
    [anon_sym_STAR] = ACTIONS(4516),
    [anon_sym_struct] = ACTIONS(4516),
    [anon_sym_union] = ACTIONS(4516),
    [anon_sym_pub] = ACTIONS(4516),
    [anon_sym_mut] = ACTIONS(4516),
    [anon_sym_enum] = ACTIONS(4516),
    [anon_sym_interface] = ACTIONS(4516),
    [anon_sym_QMARK] = ACTIONS(4516),
    [anon_sym_BANG] = ACTIONS(4516),
    [anon_sym_go] = ACTIONS(4516),
    [anon_sym_spawn] = ACTIONS(4516),
    [anon_sym_json_DOTdecode] = ACTIONS(4516),
    [anon_sym_LBRACK2] = ACTIONS(4516),
    [anon_sym_TILDE] = ACTIONS(4516),
    [anon_sym_CARET] = ACTIONS(4516),
    [anon_sym_AMP] = ACTIONS(4516),
    [anon_sym_LT_DASH] = ACTIONS(4516),
    [sym_none] = ACTIONS(4516),
    [sym_true] = ACTIONS(4516),
    [sym_false] = ACTIONS(4516),
    [sym_nil] = ACTIONS(4516),
    [anon_sym_if] = ACTIONS(4516),
    [anon_sym_DOLLARif] = ACTIONS(4516),
    [anon_sym_match] = ACTIONS(4516),
    [anon_sym_select] = ACTIONS(4516),
    [anon_sym_lock] = ACTIONS(4516),
    [anon_sym_rlock] = ACTIONS(4516),
    [anon_sym_unsafe] = ACTIONS(4516),
    [anon_sym_sql] = ACTIONS(4516),
    [sym_int_literal] = ACTIONS(4516),
    [sym_float_literal] = ACTIONS(4516),
    [sym_rune_literal] = ACTIONS(4516),
    [anon_sym_SQUOTE] = ACTIONS(4516),
    [anon_sym_DQUOTE] = ACTIONS(4516),
    [anon_sym_c_SQUOTE] = ACTIONS(4516),
    [anon_sym_c_DQUOTE] = ACTIONS(4516),
    [anon_sym_r_SQUOTE] = ACTIONS(4516),
    [anon_sym_r_DQUOTE] = ACTIONS(4516),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4516),
    [anon_sym_shared] = ACTIONS(4516),
    [anon_sym_map_LBRACK] = ACTIONS(4516),
    [anon_sym_chan] = ACTIONS(4516),
    [anon_sym_thread] = ACTIONS(4516),
    [anon_sym_atomic] = ACTIONS(4516),
    [anon_sym_assert] = ACTIONS(4516),
    [anon_sym_defer] = ACTIONS(4516),
    [anon_sym_goto] = ACTIONS(4516),
    [anon_sym_break] = ACTIONS(4516),
    [anon_sym_continue] = ACTIONS(4516),
    [anon_sym_return] = ACTIONS(4516),
    [anon_sym_DOLLARfor] = ACTIONS(4516),
    [anon_sym_for] = ACTIONS(4516),
    [anon_sym_POUND] = ACTIONS(4516),
    [anon_sym_asm] = ACTIONS(4516),
    [anon_sym_AT_LBRACK] = ACTIONS(4516),
  },
  [1772] = {
    [sym_line_comment] = STATE(1772),
    [sym_block_comment] = STATE(1772),
    [sym_block] = STATE(1865),
    [ts_builtin_sym_end] = ACTIONS(4518),
    [sym_identifier] = ACTIONS(4520),
    [anon_sym_LF] = ACTIONS(4520),
    [anon_sym_CR] = ACTIONS(4520),
    [anon_sym_CR_LF] = ACTIONS(4520),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4520),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4520),
    [anon_sym_LPAREN] = ACTIONS(4520),
    [anon_sym___global] = ACTIONS(4520),
    [anon_sym_type] = ACTIONS(4520),
    [anon_sym_fn] = ACTIONS(4520),
    [anon_sym_PLUS] = ACTIONS(4520),
    [anon_sym_DASH] = ACTIONS(4520),
    [anon_sym_STAR] = ACTIONS(4520),
    [anon_sym_struct] = ACTIONS(4520),
    [anon_sym_union] = ACTIONS(4520),
    [anon_sym_pub] = ACTIONS(4520),
    [anon_sym_mut] = ACTIONS(4520),
    [anon_sym_enum] = ACTIONS(4520),
    [anon_sym_interface] = ACTIONS(4520),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_BANG] = ACTIONS(4520),
    [anon_sym_go] = ACTIONS(4520),
    [anon_sym_spawn] = ACTIONS(4520),
    [anon_sym_json_DOTdecode] = ACTIONS(4520),
    [anon_sym_LBRACK2] = ACTIONS(4520),
    [anon_sym_TILDE] = ACTIONS(4520),
    [anon_sym_CARET] = ACTIONS(4520),
    [anon_sym_AMP] = ACTIONS(4520),
    [anon_sym_LT_DASH] = ACTIONS(4520),
    [sym_none] = ACTIONS(4520),
    [sym_true] = ACTIONS(4520),
    [sym_false] = ACTIONS(4520),
    [sym_nil] = ACTIONS(4520),
    [anon_sym_if] = ACTIONS(4520),
    [anon_sym_DOLLARif] = ACTIONS(4520),
    [anon_sym_match] = ACTIONS(4520),
    [anon_sym_select] = ACTIONS(4520),
    [anon_sym_lock] = ACTIONS(4520),
    [anon_sym_rlock] = ACTIONS(4520),
    [anon_sym_unsafe] = ACTIONS(4520),
    [anon_sym_sql] = ACTIONS(4520),
    [sym_int_literal] = ACTIONS(4520),
    [sym_float_literal] = ACTIONS(4520),
    [sym_rune_literal] = ACTIONS(4520),
    [anon_sym_SQUOTE] = ACTIONS(4520),
    [anon_sym_DQUOTE] = ACTIONS(4520),
    [anon_sym_c_SQUOTE] = ACTIONS(4520),
    [anon_sym_c_DQUOTE] = ACTIONS(4520),
    [anon_sym_r_SQUOTE] = ACTIONS(4520),
    [anon_sym_r_DQUOTE] = ACTIONS(4520),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4520),
    [anon_sym_shared] = ACTIONS(4520),
    [anon_sym_map_LBRACK] = ACTIONS(4520),
    [anon_sym_chan] = ACTIONS(4520),
    [anon_sym_thread] = ACTIONS(4520),
    [anon_sym_atomic] = ACTIONS(4520),
    [anon_sym_assert] = ACTIONS(4520),
    [anon_sym_defer] = ACTIONS(4520),
    [anon_sym_goto] = ACTIONS(4520),
    [anon_sym_break] = ACTIONS(4520),
    [anon_sym_continue] = ACTIONS(4520),
    [anon_sym_return] = ACTIONS(4520),
    [anon_sym_DOLLARfor] = ACTIONS(4520),
    [anon_sym_for] = ACTIONS(4520),
    [anon_sym_POUND] = ACTIONS(4520),
    [anon_sym_asm] = ACTIONS(4520),
    [anon_sym_AT_LBRACK] = ACTIONS(4520),
  },
  [1773] = {
    [sym_line_comment] = STATE(1773),
    [sym_block_comment] = STATE(1773),
    [sym_label_reference] = STATE(1901),
    [ts_builtin_sym_end] = ACTIONS(4522),
    [sym_identifier] = ACTIONS(4524),
    [anon_sym_LF] = ACTIONS(4526),
    [anon_sym_CR] = ACTIONS(4526),
    [anon_sym_CR_LF] = ACTIONS(4526),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4526),
    [anon_sym_LBRACE] = ACTIONS(4526),
    [anon_sym_const] = ACTIONS(4526),
    [anon_sym_LPAREN] = ACTIONS(4526),
    [anon_sym___global] = ACTIONS(4526),
    [anon_sym_type] = ACTIONS(4526),
    [anon_sym_fn] = ACTIONS(4526),
    [anon_sym_PLUS] = ACTIONS(4526),
    [anon_sym_DASH] = ACTIONS(4526),
    [anon_sym_STAR] = ACTIONS(4526),
    [anon_sym_struct] = ACTIONS(4526),
    [anon_sym_union] = ACTIONS(4526),
    [anon_sym_pub] = ACTIONS(4526),
    [anon_sym_mut] = ACTIONS(4526),
    [anon_sym_enum] = ACTIONS(4526),
    [anon_sym_interface] = ACTIONS(4526),
    [anon_sym_QMARK] = ACTIONS(4526),
    [anon_sym_BANG] = ACTIONS(4526),
    [anon_sym_go] = ACTIONS(4526),
    [anon_sym_spawn] = ACTIONS(4526),
    [anon_sym_json_DOTdecode] = ACTIONS(4526),
    [anon_sym_LBRACK2] = ACTIONS(4526),
    [anon_sym_TILDE] = ACTIONS(4526),
    [anon_sym_CARET] = ACTIONS(4526),
    [anon_sym_AMP] = ACTIONS(4526),
    [anon_sym_LT_DASH] = ACTIONS(4526),
    [sym_none] = ACTIONS(4526),
    [sym_true] = ACTIONS(4526),
    [sym_false] = ACTIONS(4526),
    [sym_nil] = ACTIONS(4526),
    [anon_sym_if] = ACTIONS(4526),
    [anon_sym_DOLLARif] = ACTIONS(4526),
    [anon_sym_match] = ACTIONS(4526),
    [anon_sym_select] = ACTIONS(4526),
    [anon_sym_lock] = ACTIONS(4526),
    [anon_sym_rlock] = ACTIONS(4526),
    [anon_sym_unsafe] = ACTIONS(4526),
    [anon_sym_sql] = ACTIONS(4526),
    [sym_int_literal] = ACTIONS(4526),
    [sym_float_literal] = ACTIONS(4526),
    [sym_rune_literal] = ACTIONS(4526),
    [anon_sym_SQUOTE] = ACTIONS(4526),
    [anon_sym_DQUOTE] = ACTIONS(4526),
    [anon_sym_c_SQUOTE] = ACTIONS(4526),
    [anon_sym_c_DQUOTE] = ACTIONS(4526),
    [anon_sym_r_SQUOTE] = ACTIONS(4526),
    [anon_sym_r_DQUOTE] = ACTIONS(4526),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4526),
    [anon_sym_shared] = ACTIONS(4526),
    [anon_sym_map_LBRACK] = ACTIONS(4526),
    [anon_sym_chan] = ACTIONS(4526),
    [anon_sym_thread] = ACTIONS(4526),
    [anon_sym_atomic] = ACTIONS(4526),
    [anon_sym_assert] = ACTIONS(4526),
    [anon_sym_defer] = ACTIONS(4526),
    [anon_sym_goto] = ACTIONS(4526),
    [anon_sym_break] = ACTIONS(4526),
    [anon_sym_continue] = ACTIONS(4526),
    [anon_sym_return] = ACTIONS(4526),
    [anon_sym_DOLLARfor] = ACTIONS(4526),
    [anon_sym_for] = ACTIONS(4526),
    [anon_sym_POUND] = ACTIONS(4526),
    [anon_sym_asm] = ACTIONS(4526),
    [anon_sym_AT_LBRACK] = ACTIONS(4526),
  },
  [1774] = {
    [sym_line_comment] = STATE(1774),
    [sym_block_comment] = STATE(1774),
    [ts_builtin_sym_end] = ACTIONS(2455),
    [sym_identifier] = ACTIONS(2457),
    [anon_sym_LF] = ACTIONS(2457),
    [anon_sym_CR] = ACTIONS(2457),
    [anon_sym_CR_LF] = ACTIONS(2457),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2457),
    [anon_sym_LBRACE] = ACTIONS(2457),
    [anon_sym_const] = ACTIONS(2457),
    [anon_sym_LPAREN] = ACTIONS(2457),
    [anon_sym___global] = ACTIONS(2457),
    [anon_sym_type] = ACTIONS(2457),
    [anon_sym_fn] = ACTIONS(2457),
    [anon_sym_PLUS] = ACTIONS(2457),
    [anon_sym_DASH] = ACTIONS(2457),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_struct] = ACTIONS(2457),
    [anon_sym_union] = ACTIONS(2457),
    [anon_sym_pub] = ACTIONS(2457),
    [anon_sym_mut] = ACTIONS(2457),
    [anon_sym_enum] = ACTIONS(2457),
    [anon_sym_interface] = ACTIONS(2457),
    [anon_sym_QMARK] = ACTIONS(2457),
    [anon_sym_BANG] = ACTIONS(2457),
    [anon_sym_go] = ACTIONS(2457),
    [anon_sym_spawn] = ACTIONS(2457),
    [anon_sym_json_DOTdecode] = ACTIONS(2457),
    [anon_sym_LBRACK2] = ACTIONS(2457),
    [anon_sym_TILDE] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2457),
    [anon_sym_AMP] = ACTIONS(2457),
    [anon_sym_LT_DASH] = ACTIONS(2457),
    [sym_none] = ACTIONS(2457),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [sym_nil] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2457),
    [anon_sym_DOLLARif] = ACTIONS(2457),
    [anon_sym_match] = ACTIONS(2457),
    [anon_sym_select] = ACTIONS(2457),
    [anon_sym_lock] = ACTIONS(2457),
    [anon_sym_rlock] = ACTIONS(2457),
    [anon_sym_unsafe] = ACTIONS(2457),
    [anon_sym_sql] = ACTIONS(2457),
    [sym_int_literal] = ACTIONS(2457),
    [sym_float_literal] = ACTIONS(2457),
    [sym_rune_literal] = ACTIONS(2457),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_DQUOTE] = ACTIONS(2457),
    [anon_sym_c_SQUOTE] = ACTIONS(2457),
    [anon_sym_c_DQUOTE] = ACTIONS(2457),
    [anon_sym_r_SQUOTE] = ACTIONS(2457),
    [anon_sym_r_DQUOTE] = ACTIONS(2457),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2457),
    [anon_sym_shared] = ACTIONS(2457),
    [anon_sym_map_LBRACK] = ACTIONS(2457),
    [anon_sym_chan] = ACTIONS(2457),
    [anon_sym_thread] = ACTIONS(2457),
    [anon_sym_atomic] = ACTIONS(2457),
    [anon_sym_assert] = ACTIONS(2457),
    [anon_sym_defer] = ACTIONS(2457),
    [anon_sym_goto] = ACTIONS(2457),
    [anon_sym_break] = ACTIONS(2457),
    [anon_sym_continue] = ACTIONS(2457),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_DOLLARfor] = ACTIONS(2457),
    [anon_sym_for] = ACTIONS(2457),
    [anon_sym_POUND] = ACTIONS(2457),
    [anon_sym_asm] = ACTIONS(2457),
    [anon_sym_AT_LBRACK] = ACTIONS(2457),
  },
  [1775] = {
    [sym_line_comment] = STATE(1775),
    [sym_block_comment] = STATE(1775),
    [ts_builtin_sym_end] = ACTIONS(2371),
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2373),
    [anon_sym_CR] = ACTIONS(2373),
    [anon_sym_CR_LF] = ACTIONS(2373),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym___global] = ACTIONS(2373),
    [anon_sym_type] = ACTIONS(2373),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_pub] = ACTIONS(2373),
    [anon_sym_mut] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_QMARK] = ACTIONS(2373),
    [anon_sym_BANG] = ACTIONS(2373),
    [anon_sym_go] = ACTIONS(2373),
    [anon_sym_spawn] = ACTIONS(2373),
    [anon_sym_json_DOTdecode] = ACTIONS(2373),
    [anon_sym_LBRACK2] = ACTIONS(2373),
    [anon_sym_TILDE] = ACTIONS(2373),
    [anon_sym_CARET] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_LT_DASH] = ACTIONS(2373),
    [sym_none] = ACTIONS(2373),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [sym_nil] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_DOLLARif] = ACTIONS(2373),
    [anon_sym_match] = ACTIONS(2373),
    [anon_sym_select] = ACTIONS(2373),
    [anon_sym_lock] = ACTIONS(2373),
    [anon_sym_rlock] = ACTIONS(2373),
    [anon_sym_unsafe] = ACTIONS(2373),
    [anon_sym_sql] = ACTIONS(2373),
    [sym_int_literal] = ACTIONS(2373),
    [sym_float_literal] = ACTIONS(2373),
    [sym_rune_literal] = ACTIONS(2373),
    [anon_sym_SQUOTE] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(2373),
    [anon_sym_c_SQUOTE] = ACTIONS(2373),
    [anon_sym_c_DQUOTE] = ACTIONS(2373),
    [anon_sym_r_SQUOTE] = ACTIONS(2373),
    [anon_sym_r_DQUOTE] = ACTIONS(2373),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_map_LBRACK] = ACTIONS(2373),
    [anon_sym_chan] = ACTIONS(2373),
    [anon_sym_thread] = ACTIONS(2373),
    [anon_sym_atomic] = ACTIONS(2373),
    [anon_sym_assert] = ACTIONS(2373),
    [anon_sym_defer] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_DOLLARfor] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_POUND] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym_AT_LBRACK] = ACTIONS(2373),
  },
  [1776] = {
    [sym_line_comment] = STATE(1776),
    [sym_block_comment] = STATE(1776),
    [sym_block] = STATE(1823),
    [ts_builtin_sym_end] = ACTIONS(4528),
    [sym_identifier] = ACTIONS(4530),
    [anon_sym_LF] = ACTIONS(4530),
    [anon_sym_CR] = ACTIONS(4530),
    [anon_sym_CR_LF] = ACTIONS(4530),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4530),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4530),
    [anon_sym_LPAREN] = ACTIONS(4530),
    [anon_sym___global] = ACTIONS(4530),
    [anon_sym_type] = ACTIONS(4530),
    [anon_sym_fn] = ACTIONS(4530),
    [anon_sym_PLUS] = ACTIONS(4530),
    [anon_sym_DASH] = ACTIONS(4530),
    [anon_sym_STAR] = ACTIONS(4530),
    [anon_sym_struct] = ACTIONS(4530),
    [anon_sym_union] = ACTIONS(4530),
    [anon_sym_pub] = ACTIONS(4530),
    [anon_sym_mut] = ACTIONS(4530),
    [anon_sym_enum] = ACTIONS(4530),
    [anon_sym_interface] = ACTIONS(4530),
    [anon_sym_QMARK] = ACTIONS(4530),
    [anon_sym_BANG] = ACTIONS(4530),
    [anon_sym_go] = ACTIONS(4530),
    [anon_sym_spawn] = ACTIONS(4530),
    [anon_sym_json_DOTdecode] = ACTIONS(4530),
    [anon_sym_LBRACK2] = ACTIONS(4530),
    [anon_sym_TILDE] = ACTIONS(4530),
    [anon_sym_CARET] = ACTIONS(4530),
    [anon_sym_AMP] = ACTIONS(4530),
    [anon_sym_LT_DASH] = ACTIONS(4530),
    [sym_none] = ACTIONS(4530),
    [sym_true] = ACTIONS(4530),
    [sym_false] = ACTIONS(4530),
    [sym_nil] = ACTIONS(4530),
    [anon_sym_if] = ACTIONS(4530),
    [anon_sym_DOLLARif] = ACTIONS(4530),
    [anon_sym_match] = ACTIONS(4530),
    [anon_sym_select] = ACTIONS(4530),
    [anon_sym_lock] = ACTIONS(4530),
    [anon_sym_rlock] = ACTIONS(4530),
    [anon_sym_unsafe] = ACTIONS(4530),
    [anon_sym_sql] = ACTIONS(4530),
    [sym_int_literal] = ACTIONS(4530),
    [sym_float_literal] = ACTIONS(4530),
    [sym_rune_literal] = ACTIONS(4530),
    [anon_sym_SQUOTE] = ACTIONS(4530),
    [anon_sym_DQUOTE] = ACTIONS(4530),
    [anon_sym_c_SQUOTE] = ACTIONS(4530),
    [anon_sym_c_DQUOTE] = ACTIONS(4530),
    [anon_sym_r_SQUOTE] = ACTIONS(4530),
    [anon_sym_r_DQUOTE] = ACTIONS(4530),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4530),
    [anon_sym_shared] = ACTIONS(4530),
    [anon_sym_map_LBRACK] = ACTIONS(4530),
    [anon_sym_chan] = ACTIONS(4530),
    [anon_sym_thread] = ACTIONS(4530),
    [anon_sym_atomic] = ACTIONS(4530),
    [anon_sym_assert] = ACTIONS(4530),
    [anon_sym_defer] = ACTIONS(4530),
    [anon_sym_goto] = ACTIONS(4530),
    [anon_sym_break] = ACTIONS(4530),
    [anon_sym_continue] = ACTIONS(4530),
    [anon_sym_return] = ACTIONS(4530),
    [anon_sym_DOLLARfor] = ACTIONS(4530),
    [anon_sym_for] = ACTIONS(4530),
    [anon_sym_POUND] = ACTIONS(4530),
    [anon_sym_asm] = ACTIONS(4530),
    [anon_sym_AT_LBRACK] = ACTIONS(4530),
  },
  [1777] = {
    [sym_line_comment] = STATE(1777),
    [sym_block_comment] = STATE(1777),
    [sym_label_reference] = STATE(1900),
    [ts_builtin_sym_end] = ACTIONS(4532),
    [sym_identifier] = ACTIONS(4524),
    [anon_sym_LF] = ACTIONS(4534),
    [anon_sym_CR] = ACTIONS(4534),
    [anon_sym_CR_LF] = ACTIONS(4534),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4534),
    [anon_sym_LBRACE] = ACTIONS(4534),
    [anon_sym_const] = ACTIONS(4534),
    [anon_sym_LPAREN] = ACTIONS(4534),
    [anon_sym___global] = ACTIONS(4534),
    [anon_sym_type] = ACTIONS(4534),
    [anon_sym_fn] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_DASH] = ACTIONS(4534),
    [anon_sym_STAR] = ACTIONS(4534),
    [anon_sym_struct] = ACTIONS(4534),
    [anon_sym_union] = ACTIONS(4534),
    [anon_sym_pub] = ACTIONS(4534),
    [anon_sym_mut] = ACTIONS(4534),
    [anon_sym_enum] = ACTIONS(4534),
    [anon_sym_interface] = ACTIONS(4534),
    [anon_sym_QMARK] = ACTIONS(4534),
    [anon_sym_BANG] = ACTIONS(4534),
    [anon_sym_go] = ACTIONS(4534),
    [anon_sym_spawn] = ACTIONS(4534),
    [anon_sym_json_DOTdecode] = ACTIONS(4534),
    [anon_sym_LBRACK2] = ACTIONS(4534),
    [anon_sym_TILDE] = ACTIONS(4534),
    [anon_sym_CARET] = ACTIONS(4534),
    [anon_sym_AMP] = ACTIONS(4534),
    [anon_sym_LT_DASH] = ACTIONS(4534),
    [sym_none] = ACTIONS(4534),
    [sym_true] = ACTIONS(4534),
    [sym_false] = ACTIONS(4534),
    [sym_nil] = ACTIONS(4534),
    [anon_sym_if] = ACTIONS(4534),
    [anon_sym_DOLLARif] = ACTIONS(4534),
    [anon_sym_match] = ACTIONS(4534),
    [anon_sym_select] = ACTIONS(4534),
    [anon_sym_lock] = ACTIONS(4534),
    [anon_sym_rlock] = ACTIONS(4534),
    [anon_sym_unsafe] = ACTIONS(4534),
    [anon_sym_sql] = ACTIONS(4534),
    [sym_int_literal] = ACTIONS(4534),
    [sym_float_literal] = ACTIONS(4534),
    [sym_rune_literal] = ACTIONS(4534),
    [anon_sym_SQUOTE] = ACTIONS(4534),
    [anon_sym_DQUOTE] = ACTIONS(4534),
    [anon_sym_c_SQUOTE] = ACTIONS(4534),
    [anon_sym_c_DQUOTE] = ACTIONS(4534),
    [anon_sym_r_SQUOTE] = ACTIONS(4534),
    [anon_sym_r_DQUOTE] = ACTIONS(4534),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4534),
    [anon_sym_shared] = ACTIONS(4534),
    [anon_sym_map_LBRACK] = ACTIONS(4534),
    [anon_sym_chan] = ACTIONS(4534),
    [anon_sym_thread] = ACTIONS(4534),
    [anon_sym_atomic] = ACTIONS(4534),
    [anon_sym_assert] = ACTIONS(4534),
    [anon_sym_defer] = ACTIONS(4534),
    [anon_sym_goto] = ACTIONS(4534),
    [anon_sym_break] = ACTIONS(4534),
    [anon_sym_continue] = ACTIONS(4534),
    [anon_sym_return] = ACTIONS(4534),
    [anon_sym_DOLLARfor] = ACTIONS(4534),
    [anon_sym_for] = ACTIONS(4534),
    [anon_sym_POUND] = ACTIONS(4534),
    [anon_sym_asm] = ACTIONS(4534),
    [anon_sym_AT_LBRACK] = ACTIONS(4534),
  },
  [1778] = {
    [sym_line_comment] = STATE(1778),
    [sym_block_comment] = STATE(1778),
    [sym_block] = STATE(1821),
    [ts_builtin_sym_end] = ACTIONS(4536),
    [sym_identifier] = ACTIONS(4538),
    [anon_sym_LF] = ACTIONS(4538),
    [anon_sym_CR] = ACTIONS(4538),
    [anon_sym_CR_LF] = ACTIONS(4538),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4538),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4538),
    [anon_sym_LPAREN] = ACTIONS(4538),
    [anon_sym___global] = ACTIONS(4538),
    [anon_sym_type] = ACTIONS(4538),
    [anon_sym_fn] = ACTIONS(4538),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_struct] = ACTIONS(4538),
    [anon_sym_union] = ACTIONS(4538),
    [anon_sym_pub] = ACTIONS(4538),
    [anon_sym_mut] = ACTIONS(4538),
    [anon_sym_enum] = ACTIONS(4538),
    [anon_sym_interface] = ACTIONS(4538),
    [anon_sym_QMARK] = ACTIONS(4538),
    [anon_sym_BANG] = ACTIONS(4538),
    [anon_sym_go] = ACTIONS(4538),
    [anon_sym_spawn] = ACTIONS(4538),
    [anon_sym_json_DOTdecode] = ACTIONS(4538),
    [anon_sym_LBRACK2] = ACTIONS(4538),
    [anon_sym_TILDE] = ACTIONS(4538),
    [anon_sym_CARET] = ACTIONS(4538),
    [anon_sym_AMP] = ACTIONS(4538),
    [anon_sym_LT_DASH] = ACTIONS(4538),
    [sym_none] = ACTIONS(4538),
    [sym_true] = ACTIONS(4538),
    [sym_false] = ACTIONS(4538),
    [sym_nil] = ACTIONS(4538),
    [anon_sym_if] = ACTIONS(4538),
    [anon_sym_DOLLARif] = ACTIONS(4538),
    [anon_sym_match] = ACTIONS(4538),
    [anon_sym_select] = ACTIONS(4538),
    [anon_sym_lock] = ACTIONS(4538),
    [anon_sym_rlock] = ACTIONS(4538),
    [anon_sym_unsafe] = ACTIONS(4538),
    [anon_sym_sql] = ACTIONS(4538),
    [sym_int_literal] = ACTIONS(4538),
    [sym_float_literal] = ACTIONS(4538),
    [sym_rune_literal] = ACTIONS(4538),
    [anon_sym_SQUOTE] = ACTIONS(4538),
    [anon_sym_DQUOTE] = ACTIONS(4538),
    [anon_sym_c_SQUOTE] = ACTIONS(4538),
    [anon_sym_c_DQUOTE] = ACTIONS(4538),
    [anon_sym_r_SQUOTE] = ACTIONS(4538),
    [anon_sym_r_DQUOTE] = ACTIONS(4538),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4538),
    [anon_sym_shared] = ACTIONS(4538),
    [anon_sym_map_LBRACK] = ACTIONS(4538),
    [anon_sym_chan] = ACTIONS(4538),
    [anon_sym_thread] = ACTIONS(4538),
    [anon_sym_atomic] = ACTIONS(4538),
    [anon_sym_assert] = ACTIONS(4538),
    [anon_sym_defer] = ACTIONS(4538),
    [anon_sym_goto] = ACTIONS(4538),
    [anon_sym_break] = ACTIONS(4538),
    [anon_sym_continue] = ACTIONS(4538),
    [anon_sym_return] = ACTIONS(4538),
    [anon_sym_DOLLARfor] = ACTIONS(4538),
    [anon_sym_for] = ACTIONS(4538),
    [anon_sym_POUND] = ACTIONS(4538),
    [anon_sym_asm] = ACTIONS(4538),
    [anon_sym_AT_LBRACK] = ACTIONS(4538),
  },
  [1779] = {
    [sym_line_comment] = STATE(1779),
    [sym_block_comment] = STATE(1779),
    [ts_builtin_sym_end] = ACTIONS(3264),
    [sym_identifier] = ACTIONS(3266),
    [anon_sym_LF] = ACTIONS(3266),
    [anon_sym_CR] = ACTIONS(3266),
    [anon_sym_CR_LF] = ACTIONS(3266),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3266),
    [anon_sym_LBRACE] = ACTIONS(3266),
    [anon_sym_const] = ACTIONS(3266),
    [anon_sym_LPAREN] = ACTIONS(3266),
    [anon_sym___global] = ACTIONS(3266),
    [anon_sym_type] = ACTIONS(3266),
    [anon_sym_fn] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3266),
    [anon_sym_DASH] = ACTIONS(3266),
    [anon_sym_STAR] = ACTIONS(3266),
    [anon_sym_struct] = ACTIONS(3266),
    [anon_sym_union] = ACTIONS(3266),
    [anon_sym_pub] = ACTIONS(3266),
    [anon_sym_mut] = ACTIONS(3266),
    [anon_sym_enum] = ACTIONS(3266),
    [anon_sym_interface] = ACTIONS(3266),
    [anon_sym_QMARK] = ACTIONS(3266),
    [anon_sym_BANG] = ACTIONS(3266),
    [anon_sym_go] = ACTIONS(3266),
    [anon_sym_spawn] = ACTIONS(3266),
    [anon_sym_json_DOTdecode] = ACTIONS(3266),
    [anon_sym_LBRACK2] = ACTIONS(3266),
    [anon_sym_TILDE] = ACTIONS(3266),
    [anon_sym_CARET] = ACTIONS(3266),
    [anon_sym_AMP] = ACTIONS(3266),
    [anon_sym_LT_DASH] = ACTIONS(3266),
    [sym_none] = ACTIONS(3266),
    [sym_true] = ACTIONS(3266),
    [sym_false] = ACTIONS(3266),
    [sym_nil] = ACTIONS(3266),
    [anon_sym_if] = ACTIONS(3266),
    [anon_sym_DOLLARif] = ACTIONS(3266),
    [anon_sym_match] = ACTIONS(3266),
    [anon_sym_select] = ACTIONS(3266),
    [anon_sym_lock] = ACTIONS(3266),
    [anon_sym_rlock] = ACTIONS(3266),
    [anon_sym_unsafe] = ACTIONS(3266),
    [anon_sym_sql] = ACTIONS(3266),
    [sym_int_literal] = ACTIONS(3266),
    [sym_float_literal] = ACTIONS(3266),
    [sym_rune_literal] = ACTIONS(3266),
    [anon_sym_SQUOTE] = ACTIONS(3266),
    [anon_sym_DQUOTE] = ACTIONS(3266),
    [anon_sym_c_SQUOTE] = ACTIONS(3266),
    [anon_sym_c_DQUOTE] = ACTIONS(3266),
    [anon_sym_r_SQUOTE] = ACTIONS(3266),
    [anon_sym_r_DQUOTE] = ACTIONS(3266),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3266),
    [anon_sym_shared] = ACTIONS(3266),
    [anon_sym_map_LBRACK] = ACTIONS(3266),
    [anon_sym_chan] = ACTIONS(3266),
    [anon_sym_thread] = ACTIONS(3266),
    [anon_sym_atomic] = ACTIONS(3266),
    [anon_sym_assert] = ACTIONS(3266),
    [anon_sym_defer] = ACTIONS(3266),
    [anon_sym_goto] = ACTIONS(3266),
    [anon_sym_break] = ACTIONS(3266),
    [anon_sym_continue] = ACTIONS(3266),
    [anon_sym_return] = ACTIONS(3266),
    [anon_sym_DOLLARfor] = ACTIONS(3266),
    [anon_sym_for] = ACTIONS(3266),
    [anon_sym_POUND] = ACTIONS(3266),
    [anon_sym_asm] = ACTIONS(3266),
    [anon_sym_AT_LBRACK] = ACTIONS(3266),
  },
  [1780] = {
    [sym_line_comment] = STATE(1780),
    [sym_block_comment] = STATE(1780),
    [ts_builtin_sym_end] = ACTIONS(4540),
    [sym_identifier] = ACTIONS(4542),
    [anon_sym_LF] = ACTIONS(4542),
    [anon_sym_CR] = ACTIONS(4542),
    [anon_sym_CR_LF] = ACTIONS(4542),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4542),
    [anon_sym_LBRACE] = ACTIONS(4542),
    [anon_sym_const] = ACTIONS(4542),
    [anon_sym_LPAREN] = ACTIONS(4542),
    [anon_sym___global] = ACTIONS(4542),
    [anon_sym_type] = ACTIONS(4542),
    [anon_sym_fn] = ACTIONS(4542),
    [anon_sym_PLUS] = ACTIONS(4542),
    [anon_sym_DASH] = ACTIONS(4542),
    [anon_sym_STAR] = ACTIONS(4542),
    [anon_sym_struct] = ACTIONS(4542),
    [anon_sym_union] = ACTIONS(4542),
    [anon_sym_pub] = ACTIONS(4542),
    [anon_sym_mut] = ACTIONS(4542),
    [anon_sym_enum] = ACTIONS(4542),
    [anon_sym_interface] = ACTIONS(4542),
    [anon_sym_QMARK] = ACTIONS(4542),
    [anon_sym_BANG] = ACTIONS(4542),
    [anon_sym_go] = ACTIONS(4542),
    [anon_sym_spawn] = ACTIONS(4542),
    [anon_sym_json_DOTdecode] = ACTIONS(4542),
    [anon_sym_LBRACK2] = ACTIONS(4542),
    [anon_sym_TILDE] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4542),
    [anon_sym_AMP] = ACTIONS(4542),
    [anon_sym_LT_DASH] = ACTIONS(4542),
    [sym_none] = ACTIONS(4542),
    [sym_true] = ACTIONS(4542),
    [sym_false] = ACTIONS(4542),
    [sym_nil] = ACTIONS(4542),
    [anon_sym_if] = ACTIONS(4542),
    [anon_sym_DOLLARif] = ACTIONS(4542),
    [anon_sym_match] = ACTIONS(4542),
    [anon_sym_select] = ACTIONS(4542),
    [anon_sym_lock] = ACTIONS(4542),
    [anon_sym_rlock] = ACTIONS(4542),
    [anon_sym_unsafe] = ACTIONS(4542),
    [anon_sym_sql] = ACTIONS(4542),
    [sym_int_literal] = ACTIONS(4542),
    [sym_float_literal] = ACTIONS(4542),
    [sym_rune_literal] = ACTIONS(4542),
    [anon_sym_SQUOTE] = ACTIONS(4542),
    [anon_sym_DQUOTE] = ACTIONS(4542),
    [anon_sym_c_SQUOTE] = ACTIONS(4542),
    [anon_sym_c_DQUOTE] = ACTIONS(4542),
    [anon_sym_r_SQUOTE] = ACTIONS(4542),
    [anon_sym_r_DQUOTE] = ACTIONS(4542),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4542),
    [anon_sym_shared] = ACTIONS(4542),
    [anon_sym_map_LBRACK] = ACTIONS(4542),
    [anon_sym_chan] = ACTIONS(4542),
    [anon_sym_thread] = ACTIONS(4542),
    [anon_sym_atomic] = ACTIONS(4542),
    [anon_sym_assert] = ACTIONS(4542),
    [anon_sym_defer] = ACTIONS(4542),
    [anon_sym_goto] = ACTIONS(4542),
    [anon_sym_break] = ACTIONS(4542),
    [anon_sym_continue] = ACTIONS(4542),
    [anon_sym_return] = ACTIONS(4542),
    [anon_sym_DOLLARfor] = ACTIONS(4542),
    [anon_sym_for] = ACTIONS(4542),
    [anon_sym_POUND] = ACTIONS(4542),
    [anon_sym_asm] = ACTIONS(4542),
    [anon_sym_AT_LBRACK] = ACTIONS(4542),
  },
  [1781] = {
    [sym_line_comment] = STATE(1781),
    [sym_block_comment] = STATE(1781),
    [ts_builtin_sym_end] = ACTIONS(4544),
    [sym_identifier] = ACTIONS(4546),
    [anon_sym_LF] = ACTIONS(4546),
    [anon_sym_CR] = ACTIONS(4546),
    [anon_sym_CR_LF] = ACTIONS(4546),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4546),
    [anon_sym_LBRACE] = ACTIONS(4546),
    [anon_sym_const] = ACTIONS(4546),
    [anon_sym_LPAREN] = ACTIONS(4546),
    [anon_sym___global] = ACTIONS(4546),
    [anon_sym_type] = ACTIONS(4546),
    [anon_sym_fn] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(4546),
    [anon_sym_DASH] = ACTIONS(4546),
    [anon_sym_STAR] = ACTIONS(4546),
    [anon_sym_struct] = ACTIONS(4546),
    [anon_sym_union] = ACTIONS(4546),
    [anon_sym_pub] = ACTIONS(4546),
    [anon_sym_mut] = ACTIONS(4546),
    [anon_sym_enum] = ACTIONS(4546),
    [anon_sym_interface] = ACTIONS(4546),
    [anon_sym_QMARK] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(4546),
    [anon_sym_go] = ACTIONS(4546),
    [anon_sym_spawn] = ACTIONS(4546),
    [anon_sym_json_DOTdecode] = ACTIONS(4546),
    [anon_sym_LBRACK2] = ACTIONS(4546),
    [anon_sym_TILDE] = ACTIONS(4546),
    [anon_sym_CARET] = ACTIONS(4546),
    [anon_sym_AMP] = ACTIONS(4546),
    [anon_sym_LT_DASH] = ACTIONS(4546),
    [sym_none] = ACTIONS(4546),
    [sym_true] = ACTIONS(4546),
    [sym_false] = ACTIONS(4546),
    [sym_nil] = ACTIONS(4546),
    [anon_sym_if] = ACTIONS(4546),
    [anon_sym_DOLLARif] = ACTIONS(4546),
    [anon_sym_match] = ACTIONS(4546),
    [anon_sym_select] = ACTIONS(4546),
    [anon_sym_lock] = ACTIONS(4546),
    [anon_sym_rlock] = ACTIONS(4546),
    [anon_sym_unsafe] = ACTIONS(4546),
    [anon_sym_sql] = ACTIONS(4546),
    [sym_int_literal] = ACTIONS(4546),
    [sym_float_literal] = ACTIONS(4546),
    [sym_rune_literal] = ACTIONS(4546),
    [anon_sym_SQUOTE] = ACTIONS(4546),
    [anon_sym_DQUOTE] = ACTIONS(4546),
    [anon_sym_c_SQUOTE] = ACTIONS(4546),
    [anon_sym_c_DQUOTE] = ACTIONS(4546),
    [anon_sym_r_SQUOTE] = ACTIONS(4546),
    [anon_sym_r_DQUOTE] = ACTIONS(4546),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4546),
    [anon_sym_shared] = ACTIONS(4546),
    [anon_sym_map_LBRACK] = ACTIONS(4546),
    [anon_sym_chan] = ACTIONS(4546),
    [anon_sym_thread] = ACTIONS(4546),
    [anon_sym_atomic] = ACTIONS(4546),
    [anon_sym_assert] = ACTIONS(4546),
    [anon_sym_defer] = ACTIONS(4546),
    [anon_sym_goto] = ACTIONS(4546),
    [anon_sym_break] = ACTIONS(4546),
    [anon_sym_continue] = ACTIONS(4546),
    [anon_sym_return] = ACTIONS(4546),
    [anon_sym_DOLLARfor] = ACTIONS(4546),
    [anon_sym_for] = ACTIONS(4546),
    [anon_sym_POUND] = ACTIONS(4546),
    [anon_sym_asm] = ACTIONS(4546),
    [anon_sym_AT_LBRACK] = ACTIONS(4546),
  },
  [1782] = {
    [sym_line_comment] = STATE(1782),
    [sym_block_comment] = STATE(1782),
    [ts_builtin_sym_end] = ACTIONS(4548),
    [sym_identifier] = ACTIONS(4550),
    [anon_sym_LF] = ACTIONS(4550),
    [anon_sym_CR] = ACTIONS(4550),
    [anon_sym_CR_LF] = ACTIONS(4550),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4550),
    [anon_sym_LBRACE] = ACTIONS(4550),
    [anon_sym_const] = ACTIONS(4550),
    [anon_sym_LPAREN] = ACTIONS(4550),
    [anon_sym___global] = ACTIONS(4550),
    [anon_sym_type] = ACTIONS(4550),
    [anon_sym_fn] = ACTIONS(4550),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_DASH] = ACTIONS(4550),
    [anon_sym_STAR] = ACTIONS(4550),
    [anon_sym_struct] = ACTIONS(4550),
    [anon_sym_union] = ACTIONS(4550),
    [anon_sym_pub] = ACTIONS(4550),
    [anon_sym_mut] = ACTIONS(4550),
    [anon_sym_enum] = ACTIONS(4550),
    [anon_sym_interface] = ACTIONS(4550),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_BANG] = ACTIONS(4550),
    [anon_sym_go] = ACTIONS(4550),
    [anon_sym_spawn] = ACTIONS(4550),
    [anon_sym_json_DOTdecode] = ACTIONS(4550),
    [anon_sym_LBRACK2] = ACTIONS(4550),
    [anon_sym_TILDE] = ACTIONS(4550),
    [anon_sym_CARET] = ACTIONS(4550),
    [anon_sym_AMP] = ACTIONS(4550),
    [anon_sym_LT_DASH] = ACTIONS(4550),
    [sym_none] = ACTIONS(4550),
    [sym_true] = ACTIONS(4550),
    [sym_false] = ACTIONS(4550),
    [sym_nil] = ACTIONS(4550),
    [anon_sym_if] = ACTIONS(4550),
    [anon_sym_DOLLARif] = ACTIONS(4550),
    [anon_sym_match] = ACTIONS(4550),
    [anon_sym_select] = ACTIONS(4550),
    [anon_sym_lock] = ACTIONS(4550),
    [anon_sym_rlock] = ACTIONS(4550),
    [anon_sym_unsafe] = ACTIONS(4550),
    [anon_sym_sql] = ACTIONS(4550),
    [sym_int_literal] = ACTIONS(4550),
    [sym_float_literal] = ACTIONS(4550),
    [sym_rune_literal] = ACTIONS(4550),
    [anon_sym_SQUOTE] = ACTIONS(4550),
    [anon_sym_DQUOTE] = ACTIONS(4550),
    [anon_sym_c_SQUOTE] = ACTIONS(4550),
    [anon_sym_c_DQUOTE] = ACTIONS(4550),
    [anon_sym_r_SQUOTE] = ACTIONS(4550),
    [anon_sym_r_DQUOTE] = ACTIONS(4550),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4550),
    [anon_sym_shared] = ACTIONS(4550),
    [anon_sym_map_LBRACK] = ACTIONS(4550),
    [anon_sym_chan] = ACTIONS(4550),
    [anon_sym_thread] = ACTIONS(4550),
    [anon_sym_atomic] = ACTIONS(4550),
    [anon_sym_assert] = ACTIONS(4550),
    [anon_sym_defer] = ACTIONS(4550),
    [anon_sym_goto] = ACTIONS(4550),
    [anon_sym_break] = ACTIONS(4550),
    [anon_sym_continue] = ACTIONS(4550),
    [anon_sym_return] = ACTIONS(4550),
    [anon_sym_DOLLARfor] = ACTIONS(4550),
    [anon_sym_for] = ACTIONS(4550),
    [anon_sym_POUND] = ACTIONS(4550),
    [anon_sym_asm] = ACTIONS(4550),
    [anon_sym_AT_LBRACK] = ACTIONS(4550),
  },
  [1783] = {
    [sym_line_comment] = STATE(1783),
    [sym_block_comment] = STATE(1783),
    [sym_import_declaration] = STATE(1920),
    [aux_sym_import_list_repeat1] = STATE(1783),
    [ts_builtin_sym_end] = ACTIONS(4552),
    [sym_identifier] = ACTIONS(4554),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(4556),
    [anon_sym_DOT] = ACTIONS(4554),
    [anon_sym_LBRACE] = ACTIONS(4552),
    [anon_sym_const] = ACTIONS(4554),
    [anon_sym_LPAREN] = ACTIONS(4552),
    [anon_sym___global] = ACTIONS(4554),
    [anon_sym_type] = ACTIONS(4554),
    [anon_sym_fn] = ACTIONS(4554),
    [anon_sym_PLUS] = ACTIONS(4552),
    [anon_sym_DASH] = ACTIONS(4552),
    [anon_sym_STAR] = ACTIONS(4552),
    [anon_sym_struct] = ACTIONS(4554),
    [anon_sym_union] = ACTIONS(4554),
    [anon_sym_pub] = ACTIONS(4554),
    [anon_sym_mut] = ACTIONS(4554),
    [anon_sym_enum] = ACTIONS(4554),
    [anon_sym_interface] = ACTIONS(4554),
    [anon_sym_QMARK] = ACTIONS(4552),
    [anon_sym_BANG] = ACTIONS(4552),
    [anon_sym_go] = ACTIONS(4554),
    [anon_sym_spawn] = ACTIONS(4554),
    [anon_sym_json_DOTdecode] = ACTIONS(4552),
    [anon_sym_LBRACK2] = ACTIONS(4552),
    [anon_sym_TILDE] = ACTIONS(4552),
    [anon_sym_CARET] = ACTIONS(4552),
    [anon_sym_AMP] = ACTIONS(4552),
    [anon_sym_LT_DASH] = ACTIONS(4552),
    [sym_none] = ACTIONS(4554),
    [sym_true] = ACTIONS(4554),
    [sym_false] = ACTIONS(4554),
    [sym_nil] = ACTIONS(4554),
    [anon_sym_if] = ACTIONS(4554),
    [anon_sym_DOLLARif] = ACTIONS(4554),
    [anon_sym_match] = ACTIONS(4554),
    [anon_sym_select] = ACTIONS(4554),
    [anon_sym_lock] = ACTIONS(4554),
    [anon_sym_rlock] = ACTIONS(4554),
    [anon_sym_unsafe] = ACTIONS(4554),
    [anon_sym_sql] = ACTIONS(4554),
    [sym_int_literal] = ACTIONS(4554),
    [sym_float_literal] = ACTIONS(4552),
    [sym_rune_literal] = ACTIONS(4552),
    [anon_sym_SQUOTE] = ACTIONS(4552),
    [anon_sym_DQUOTE] = ACTIONS(4552),
    [anon_sym_c_SQUOTE] = ACTIONS(4552),
    [anon_sym_c_DQUOTE] = ACTIONS(4552),
    [anon_sym_r_SQUOTE] = ACTIONS(4552),
    [anon_sym_r_DQUOTE] = ACTIONS(4552),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4554),
    [anon_sym_shared] = ACTIONS(4554),
    [anon_sym_map_LBRACK] = ACTIONS(4552),
    [anon_sym_chan] = ACTIONS(4554),
    [anon_sym_thread] = ACTIONS(4554),
    [anon_sym_atomic] = ACTIONS(4554),
    [anon_sym_assert] = ACTIONS(4554),
    [anon_sym_defer] = ACTIONS(4554),
    [anon_sym_goto] = ACTIONS(4554),
    [anon_sym_break] = ACTIONS(4554),
    [anon_sym_continue] = ACTIONS(4554),
    [anon_sym_return] = ACTIONS(4554),
    [anon_sym_DOLLARfor] = ACTIONS(4554),
    [anon_sym_for] = ACTIONS(4554),
    [anon_sym_POUND] = ACTIONS(4552),
    [anon_sym_asm] = ACTIONS(4554),
    [anon_sym_AT_LBRACK] = ACTIONS(4552),
  },
  [1784] = {
    [sym_line_comment] = STATE(1784),
    [sym_block_comment] = STATE(1784),
    [ts_builtin_sym_end] = ACTIONS(4411),
    [sym_identifier] = ACTIONS(4413),
    [anon_sym_LF] = ACTIONS(4413),
    [anon_sym_CR] = ACTIONS(4413),
    [anon_sym_CR_LF] = ACTIONS(4413),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(4413),
    [anon_sym_const] = ACTIONS(4413),
    [anon_sym_LPAREN] = ACTIONS(4413),
    [anon_sym___global] = ACTIONS(4413),
    [anon_sym_type] = ACTIONS(4413),
    [anon_sym_fn] = ACTIONS(4413),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_STAR] = ACTIONS(4413),
    [anon_sym_struct] = ACTIONS(4413),
    [anon_sym_union] = ACTIONS(4413),
    [anon_sym_pub] = ACTIONS(4413),
    [anon_sym_mut] = ACTIONS(4413),
    [anon_sym_enum] = ACTIONS(4413),
    [anon_sym_interface] = ACTIONS(4413),
    [anon_sym_QMARK] = ACTIONS(4413),
    [anon_sym_BANG] = ACTIONS(4413),
    [anon_sym_go] = ACTIONS(4413),
    [anon_sym_spawn] = ACTIONS(4413),
    [anon_sym_json_DOTdecode] = ACTIONS(4413),
    [anon_sym_LBRACK2] = ACTIONS(4413),
    [anon_sym_TILDE] = ACTIONS(4413),
    [anon_sym_CARET] = ACTIONS(4413),
    [anon_sym_AMP] = ACTIONS(4413),
    [anon_sym_LT_DASH] = ACTIONS(4413),
    [sym_none] = ACTIONS(4413),
    [sym_true] = ACTIONS(4413),
    [sym_false] = ACTIONS(4413),
    [sym_nil] = ACTIONS(4413),
    [anon_sym_if] = ACTIONS(4413),
    [anon_sym_DOLLARif] = ACTIONS(4413),
    [anon_sym_match] = ACTIONS(4413),
    [anon_sym_select] = ACTIONS(4413),
    [anon_sym_lock] = ACTIONS(4413),
    [anon_sym_rlock] = ACTIONS(4413),
    [anon_sym_unsafe] = ACTIONS(4413),
    [anon_sym_sql] = ACTIONS(4413),
    [sym_int_literal] = ACTIONS(4413),
    [sym_float_literal] = ACTIONS(4413),
    [sym_rune_literal] = ACTIONS(4413),
    [anon_sym_SQUOTE] = ACTIONS(4413),
    [anon_sym_DQUOTE] = ACTIONS(4413),
    [anon_sym_c_SQUOTE] = ACTIONS(4413),
    [anon_sym_c_DQUOTE] = ACTIONS(4413),
    [anon_sym_r_SQUOTE] = ACTIONS(4413),
    [anon_sym_r_DQUOTE] = ACTIONS(4413),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4413),
    [anon_sym_shared] = ACTIONS(4413),
    [anon_sym_map_LBRACK] = ACTIONS(4413),
    [anon_sym_chan] = ACTIONS(4413),
    [anon_sym_thread] = ACTIONS(4413),
    [anon_sym_atomic] = ACTIONS(4413),
    [anon_sym_assert] = ACTIONS(4413),
    [anon_sym_defer] = ACTIONS(4413),
    [anon_sym_goto] = ACTIONS(4413),
    [anon_sym_break] = ACTIONS(4413),
    [anon_sym_continue] = ACTIONS(4413),
    [anon_sym_return] = ACTIONS(4413),
    [anon_sym_DOLLARfor] = ACTIONS(4413),
    [anon_sym_for] = ACTIONS(4413),
    [anon_sym_POUND] = ACTIONS(4413),
    [anon_sym_asm] = ACTIONS(4413),
    [anon_sym_AT_LBRACK] = ACTIONS(4413),
  },
  [1785] = {
    [sym_line_comment] = STATE(1785),
    [sym_block_comment] = STATE(1785),
    [ts_builtin_sym_end] = ACTIONS(4559),
    [sym_identifier] = ACTIONS(4561),
    [anon_sym_LF] = ACTIONS(4561),
    [anon_sym_CR] = ACTIONS(4561),
    [anon_sym_CR_LF] = ACTIONS(4561),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4561),
    [anon_sym_LBRACE] = ACTIONS(4561),
    [anon_sym_const] = ACTIONS(4561),
    [anon_sym_LPAREN] = ACTIONS(4561),
    [anon_sym___global] = ACTIONS(4561),
    [anon_sym_type] = ACTIONS(4561),
    [anon_sym_fn] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4561),
    [anon_sym_DASH] = ACTIONS(4561),
    [anon_sym_STAR] = ACTIONS(4561),
    [anon_sym_struct] = ACTIONS(4561),
    [anon_sym_union] = ACTIONS(4561),
    [anon_sym_pub] = ACTIONS(4561),
    [anon_sym_mut] = ACTIONS(4561),
    [anon_sym_enum] = ACTIONS(4561),
    [anon_sym_interface] = ACTIONS(4561),
    [anon_sym_QMARK] = ACTIONS(4561),
    [anon_sym_BANG] = ACTIONS(4561),
    [anon_sym_go] = ACTIONS(4561),
    [anon_sym_spawn] = ACTIONS(4561),
    [anon_sym_json_DOTdecode] = ACTIONS(4561),
    [anon_sym_LBRACK2] = ACTIONS(4561),
    [anon_sym_TILDE] = ACTIONS(4561),
    [anon_sym_CARET] = ACTIONS(4561),
    [anon_sym_AMP] = ACTIONS(4561),
    [anon_sym_LT_DASH] = ACTIONS(4561),
    [sym_none] = ACTIONS(4561),
    [sym_true] = ACTIONS(4561),
    [sym_false] = ACTIONS(4561),
    [sym_nil] = ACTIONS(4561),
    [anon_sym_if] = ACTIONS(4561),
    [anon_sym_DOLLARif] = ACTIONS(4561),
    [anon_sym_match] = ACTIONS(4561),
    [anon_sym_select] = ACTIONS(4561),
    [anon_sym_lock] = ACTIONS(4561),
    [anon_sym_rlock] = ACTIONS(4561),
    [anon_sym_unsafe] = ACTIONS(4561),
    [anon_sym_sql] = ACTIONS(4561),
    [sym_int_literal] = ACTIONS(4561),
    [sym_float_literal] = ACTIONS(4561),
    [sym_rune_literal] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_DQUOTE] = ACTIONS(4561),
    [anon_sym_c_SQUOTE] = ACTIONS(4561),
    [anon_sym_c_DQUOTE] = ACTIONS(4561),
    [anon_sym_r_SQUOTE] = ACTIONS(4561),
    [anon_sym_r_DQUOTE] = ACTIONS(4561),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4561),
    [anon_sym_shared] = ACTIONS(4561),
    [anon_sym_map_LBRACK] = ACTIONS(4561),
    [anon_sym_chan] = ACTIONS(4561),
    [anon_sym_thread] = ACTIONS(4561),
    [anon_sym_atomic] = ACTIONS(4561),
    [anon_sym_assert] = ACTIONS(4561),
    [anon_sym_defer] = ACTIONS(4561),
    [anon_sym_goto] = ACTIONS(4561),
    [anon_sym_break] = ACTIONS(4561),
    [anon_sym_continue] = ACTIONS(4561),
    [anon_sym_return] = ACTIONS(4561),
    [anon_sym_DOLLARfor] = ACTIONS(4561),
    [anon_sym_for] = ACTIONS(4561),
    [anon_sym_POUND] = ACTIONS(4561),
    [anon_sym_asm] = ACTIONS(4561),
    [anon_sym_AT_LBRACK] = ACTIONS(4561),
  },
  [1786] = {
    [sym_line_comment] = STATE(1786),
    [sym_block_comment] = STATE(1786),
    [ts_builtin_sym_end] = ACTIONS(4563),
    [sym_identifier] = ACTIONS(4565),
    [anon_sym_LF] = ACTIONS(4565),
    [anon_sym_CR] = ACTIONS(4565),
    [anon_sym_CR_LF] = ACTIONS(4565),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4565),
    [anon_sym_LBRACE] = ACTIONS(4565),
    [anon_sym_const] = ACTIONS(4565),
    [anon_sym_LPAREN] = ACTIONS(4565),
    [anon_sym___global] = ACTIONS(4565),
    [anon_sym_type] = ACTIONS(4565),
    [anon_sym_fn] = ACTIONS(4565),
    [anon_sym_PLUS] = ACTIONS(4565),
    [anon_sym_DASH] = ACTIONS(4565),
    [anon_sym_STAR] = ACTIONS(4565),
    [anon_sym_struct] = ACTIONS(4565),
    [anon_sym_union] = ACTIONS(4565),
    [anon_sym_pub] = ACTIONS(4565),
    [anon_sym_mut] = ACTIONS(4565),
    [anon_sym_enum] = ACTIONS(4565),
    [anon_sym_interface] = ACTIONS(4565),
    [anon_sym_QMARK] = ACTIONS(4565),
    [anon_sym_BANG] = ACTIONS(4565),
    [anon_sym_go] = ACTIONS(4565),
    [anon_sym_spawn] = ACTIONS(4565),
    [anon_sym_json_DOTdecode] = ACTIONS(4565),
    [anon_sym_LBRACK2] = ACTIONS(4565),
    [anon_sym_TILDE] = ACTIONS(4565),
    [anon_sym_CARET] = ACTIONS(4565),
    [anon_sym_AMP] = ACTIONS(4565),
    [anon_sym_LT_DASH] = ACTIONS(4565),
    [sym_none] = ACTIONS(4565),
    [sym_true] = ACTIONS(4565),
    [sym_false] = ACTIONS(4565),
    [sym_nil] = ACTIONS(4565),
    [anon_sym_if] = ACTIONS(4565),
    [anon_sym_DOLLARif] = ACTIONS(4565),
    [anon_sym_match] = ACTIONS(4565),
    [anon_sym_select] = ACTIONS(4565),
    [anon_sym_lock] = ACTIONS(4565),
    [anon_sym_rlock] = ACTIONS(4565),
    [anon_sym_unsafe] = ACTIONS(4565),
    [anon_sym_sql] = ACTIONS(4565),
    [sym_int_literal] = ACTIONS(4565),
    [sym_float_literal] = ACTIONS(4565),
    [sym_rune_literal] = ACTIONS(4565),
    [anon_sym_SQUOTE] = ACTIONS(4565),
    [anon_sym_DQUOTE] = ACTIONS(4565),
    [anon_sym_c_SQUOTE] = ACTIONS(4565),
    [anon_sym_c_DQUOTE] = ACTIONS(4565),
    [anon_sym_r_SQUOTE] = ACTIONS(4565),
    [anon_sym_r_DQUOTE] = ACTIONS(4565),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4565),
    [anon_sym_shared] = ACTIONS(4565),
    [anon_sym_map_LBRACK] = ACTIONS(4565),
    [anon_sym_chan] = ACTIONS(4565),
    [anon_sym_thread] = ACTIONS(4565),
    [anon_sym_atomic] = ACTIONS(4565),
    [anon_sym_assert] = ACTIONS(4565),
    [anon_sym_defer] = ACTIONS(4565),
    [anon_sym_goto] = ACTIONS(4565),
    [anon_sym_break] = ACTIONS(4565),
    [anon_sym_continue] = ACTIONS(4565),
    [anon_sym_return] = ACTIONS(4565),
    [anon_sym_DOLLARfor] = ACTIONS(4565),
    [anon_sym_for] = ACTIONS(4565),
    [anon_sym_POUND] = ACTIONS(4565),
    [anon_sym_asm] = ACTIONS(4565),
    [anon_sym_AT_LBRACK] = ACTIONS(4565),
  },
  [1787] = {
    [sym_line_comment] = STATE(1787),
    [sym_block_comment] = STATE(1787),
    [ts_builtin_sym_end] = ACTIONS(4567),
    [sym_identifier] = ACTIONS(4569),
    [anon_sym_LF] = ACTIONS(4569),
    [anon_sym_CR] = ACTIONS(4569),
    [anon_sym_CR_LF] = ACTIONS(4569),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4569),
    [anon_sym_LBRACE] = ACTIONS(4569),
    [anon_sym_const] = ACTIONS(4569),
    [anon_sym_LPAREN] = ACTIONS(4569),
    [anon_sym___global] = ACTIONS(4569),
    [anon_sym_type] = ACTIONS(4569),
    [anon_sym_fn] = ACTIONS(4569),
    [anon_sym_PLUS] = ACTIONS(4569),
    [anon_sym_DASH] = ACTIONS(4569),
    [anon_sym_STAR] = ACTIONS(4569),
    [anon_sym_struct] = ACTIONS(4569),
    [anon_sym_union] = ACTIONS(4569),
    [anon_sym_pub] = ACTIONS(4569),
    [anon_sym_mut] = ACTIONS(4569),
    [anon_sym_enum] = ACTIONS(4569),
    [anon_sym_interface] = ACTIONS(4569),
    [anon_sym_QMARK] = ACTIONS(4569),
    [anon_sym_BANG] = ACTIONS(4569),
    [anon_sym_go] = ACTIONS(4569),
    [anon_sym_spawn] = ACTIONS(4569),
    [anon_sym_json_DOTdecode] = ACTIONS(4569),
    [anon_sym_LBRACK2] = ACTIONS(4569),
    [anon_sym_TILDE] = ACTIONS(4569),
    [anon_sym_CARET] = ACTIONS(4569),
    [anon_sym_AMP] = ACTIONS(4569),
    [anon_sym_LT_DASH] = ACTIONS(4569),
    [sym_none] = ACTIONS(4569),
    [sym_true] = ACTIONS(4569),
    [sym_false] = ACTIONS(4569),
    [sym_nil] = ACTIONS(4569),
    [anon_sym_if] = ACTIONS(4569),
    [anon_sym_DOLLARif] = ACTIONS(4569),
    [anon_sym_match] = ACTIONS(4569),
    [anon_sym_select] = ACTIONS(4569),
    [anon_sym_lock] = ACTIONS(4569),
    [anon_sym_rlock] = ACTIONS(4569),
    [anon_sym_unsafe] = ACTIONS(4569),
    [anon_sym_sql] = ACTIONS(4569),
    [sym_int_literal] = ACTIONS(4569),
    [sym_float_literal] = ACTIONS(4569),
    [sym_rune_literal] = ACTIONS(4569),
    [anon_sym_SQUOTE] = ACTIONS(4569),
    [anon_sym_DQUOTE] = ACTIONS(4569),
    [anon_sym_c_SQUOTE] = ACTIONS(4569),
    [anon_sym_c_DQUOTE] = ACTIONS(4569),
    [anon_sym_r_SQUOTE] = ACTIONS(4569),
    [anon_sym_r_DQUOTE] = ACTIONS(4569),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4569),
    [anon_sym_shared] = ACTIONS(4569),
    [anon_sym_map_LBRACK] = ACTIONS(4569),
    [anon_sym_chan] = ACTIONS(4569),
    [anon_sym_thread] = ACTIONS(4569),
    [anon_sym_atomic] = ACTIONS(4569),
    [anon_sym_assert] = ACTIONS(4569),
    [anon_sym_defer] = ACTIONS(4569),
    [anon_sym_goto] = ACTIONS(4569),
    [anon_sym_break] = ACTIONS(4569),
    [anon_sym_continue] = ACTIONS(4569),
    [anon_sym_return] = ACTIONS(4569),
    [anon_sym_DOLLARfor] = ACTIONS(4569),
    [anon_sym_for] = ACTIONS(4569),
    [anon_sym_POUND] = ACTIONS(4569),
    [anon_sym_asm] = ACTIONS(4569),
    [anon_sym_AT_LBRACK] = ACTIONS(4569),
  },
  [1788] = {
    [sym_line_comment] = STATE(1788),
    [sym_block_comment] = STATE(1788),
    [ts_builtin_sym_end] = ACTIONS(4571),
    [sym_identifier] = ACTIONS(4573),
    [anon_sym_LF] = ACTIONS(4575),
    [anon_sym_CR] = ACTIONS(4575),
    [anon_sym_CR_LF] = ACTIONS(4575),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(4573),
    [anon_sym_const] = ACTIONS(4573),
    [anon_sym_LPAREN] = ACTIONS(4573),
    [anon_sym___global] = ACTIONS(4573),
    [anon_sym_type] = ACTIONS(4573),
    [anon_sym_fn] = ACTIONS(4573),
    [anon_sym_PLUS] = ACTIONS(4573),
    [anon_sym_DASH] = ACTIONS(4573),
    [anon_sym_STAR] = ACTIONS(4573),
    [anon_sym_struct] = ACTIONS(4573),
    [anon_sym_union] = ACTIONS(4573),
    [anon_sym_pub] = ACTIONS(4573),
    [anon_sym_mut] = ACTIONS(4573),
    [anon_sym_enum] = ACTIONS(4573),
    [anon_sym_interface] = ACTIONS(4573),
    [anon_sym_QMARK] = ACTIONS(4573),
    [anon_sym_BANG] = ACTIONS(4573),
    [anon_sym_go] = ACTIONS(4573),
    [anon_sym_spawn] = ACTIONS(4573),
    [anon_sym_json_DOTdecode] = ACTIONS(4573),
    [anon_sym_LBRACK2] = ACTIONS(4573),
    [anon_sym_TILDE] = ACTIONS(4573),
    [anon_sym_CARET] = ACTIONS(4573),
    [anon_sym_AMP] = ACTIONS(4573),
    [anon_sym_LT_DASH] = ACTIONS(4573),
    [sym_none] = ACTIONS(4573),
    [sym_true] = ACTIONS(4573),
    [sym_false] = ACTIONS(4573),
    [sym_nil] = ACTIONS(4573),
    [anon_sym_if] = ACTIONS(4573),
    [anon_sym_DOLLARif] = ACTIONS(4573),
    [anon_sym_match] = ACTIONS(4573),
    [anon_sym_select] = ACTIONS(4573),
    [anon_sym_lock] = ACTIONS(4573),
    [anon_sym_rlock] = ACTIONS(4573),
    [anon_sym_unsafe] = ACTIONS(4573),
    [anon_sym_sql] = ACTIONS(4573),
    [sym_int_literal] = ACTIONS(4573),
    [sym_float_literal] = ACTIONS(4573),
    [sym_rune_literal] = ACTIONS(4573),
    [anon_sym_SQUOTE] = ACTIONS(4573),
    [anon_sym_DQUOTE] = ACTIONS(4573),
    [anon_sym_c_SQUOTE] = ACTIONS(4573),
    [anon_sym_c_DQUOTE] = ACTIONS(4573),
    [anon_sym_r_SQUOTE] = ACTIONS(4573),
    [anon_sym_r_DQUOTE] = ACTIONS(4573),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4573),
    [anon_sym_shared] = ACTIONS(4573),
    [anon_sym_map_LBRACK] = ACTIONS(4573),
    [anon_sym_chan] = ACTIONS(4573),
    [anon_sym_thread] = ACTIONS(4573),
    [anon_sym_atomic] = ACTIONS(4573),
    [anon_sym_assert] = ACTIONS(4573),
    [anon_sym_defer] = ACTIONS(4573),
    [anon_sym_goto] = ACTIONS(4573),
    [anon_sym_break] = ACTIONS(4573),
    [anon_sym_continue] = ACTIONS(4573),
    [anon_sym_return] = ACTIONS(4573),
    [anon_sym_DOLLARfor] = ACTIONS(4573),
    [anon_sym_for] = ACTIONS(4573),
    [anon_sym_POUND] = ACTIONS(4573),
    [anon_sym_asm] = ACTIONS(4573),
    [anon_sym_AT_LBRACK] = ACTIONS(4573),
  },
  [1789] = {
    [sym_line_comment] = STATE(1789),
    [sym_block_comment] = STATE(1789),
    [ts_builtin_sym_end] = ACTIONS(4577),
    [sym_identifier] = ACTIONS(4579),
    [anon_sym_LF] = ACTIONS(4579),
    [anon_sym_CR] = ACTIONS(4579),
    [anon_sym_CR_LF] = ACTIONS(4579),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4579),
    [anon_sym_LBRACE] = ACTIONS(4579),
    [anon_sym_const] = ACTIONS(4579),
    [anon_sym_LPAREN] = ACTIONS(4579),
    [anon_sym___global] = ACTIONS(4579),
    [anon_sym_type] = ACTIONS(4579),
    [anon_sym_fn] = ACTIONS(4579),
    [anon_sym_PLUS] = ACTIONS(4579),
    [anon_sym_DASH] = ACTIONS(4579),
    [anon_sym_STAR] = ACTIONS(4579),
    [anon_sym_struct] = ACTIONS(4579),
    [anon_sym_union] = ACTIONS(4579),
    [anon_sym_pub] = ACTIONS(4579),
    [anon_sym_mut] = ACTIONS(4579),
    [anon_sym_enum] = ACTIONS(4579),
    [anon_sym_interface] = ACTIONS(4579),
    [anon_sym_QMARK] = ACTIONS(4579),
    [anon_sym_BANG] = ACTIONS(4579),
    [anon_sym_go] = ACTIONS(4579),
    [anon_sym_spawn] = ACTIONS(4579),
    [anon_sym_json_DOTdecode] = ACTIONS(4579),
    [anon_sym_LBRACK2] = ACTIONS(4579),
    [anon_sym_TILDE] = ACTIONS(4579),
    [anon_sym_CARET] = ACTIONS(4579),
    [anon_sym_AMP] = ACTIONS(4579),
    [anon_sym_LT_DASH] = ACTIONS(4579),
    [sym_none] = ACTIONS(4579),
    [sym_true] = ACTIONS(4579),
    [sym_false] = ACTIONS(4579),
    [sym_nil] = ACTIONS(4579),
    [anon_sym_if] = ACTIONS(4579),
    [anon_sym_DOLLARif] = ACTIONS(4579),
    [anon_sym_match] = ACTIONS(4579),
    [anon_sym_select] = ACTIONS(4579),
    [anon_sym_lock] = ACTIONS(4579),
    [anon_sym_rlock] = ACTIONS(4579),
    [anon_sym_unsafe] = ACTIONS(4579),
    [anon_sym_sql] = ACTIONS(4579),
    [sym_int_literal] = ACTIONS(4579),
    [sym_float_literal] = ACTIONS(4579),
    [sym_rune_literal] = ACTIONS(4579),
    [anon_sym_SQUOTE] = ACTIONS(4579),
    [anon_sym_DQUOTE] = ACTIONS(4579),
    [anon_sym_c_SQUOTE] = ACTIONS(4579),
    [anon_sym_c_DQUOTE] = ACTIONS(4579),
    [anon_sym_r_SQUOTE] = ACTIONS(4579),
    [anon_sym_r_DQUOTE] = ACTIONS(4579),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4579),
    [anon_sym_shared] = ACTIONS(4579),
    [anon_sym_map_LBRACK] = ACTIONS(4579),
    [anon_sym_chan] = ACTIONS(4579),
    [anon_sym_thread] = ACTIONS(4579),
    [anon_sym_atomic] = ACTIONS(4579),
    [anon_sym_assert] = ACTIONS(4579),
    [anon_sym_defer] = ACTIONS(4579),
    [anon_sym_goto] = ACTIONS(4579),
    [anon_sym_break] = ACTIONS(4579),
    [anon_sym_continue] = ACTIONS(4579),
    [anon_sym_return] = ACTIONS(4579),
    [anon_sym_DOLLARfor] = ACTIONS(4579),
    [anon_sym_for] = ACTIONS(4579),
    [anon_sym_POUND] = ACTIONS(4579),
    [anon_sym_asm] = ACTIONS(4579),
    [anon_sym_AT_LBRACK] = ACTIONS(4579),
  },
  [1790] = {
    [sym_line_comment] = STATE(1790),
    [sym_block_comment] = STATE(1790),
    [ts_builtin_sym_end] = ACTIONS(4581),
    [sym_identifier] = ACTIONS(4583),
    [anon_sym_LF] = ACTIONS(4583),
    [anon_sym_CR] = ACTIONS(4583),
    [anon_sym_CR_LF] = ACTIONS(4583),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4583),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_const] = ACTIONS(4583),
    [anon_sym_LPAREN] = ACTIONS(4583),
    [anon_sym___global] = ACTIONS(4583),
    [anon_sym_type] = ACTIONS(4583),
    [anon_sym_fn] = ACTIONS(4583),
    [anon_sym_PLUS] = ACTIONS(4583),
    [anon_sym_DASH] = ACTIONS(4583),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_struct] = ACTIONS(4583),
    [anon_sym_union] = ACTIONS(4583),
    [anon_sym_pub] = ACTIONS(4583),
    [anon_sym_mut] = ACTIONS(4583),
    [anon_sym_enum] = ACTIONS(4583),
    [anon_sym_interface] = ACTIONS(4583),
    [anon_sym_QMARK] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(4583),
    [anon_sym_go] = ACTIONS(4583),
    [anon_sym_spawn] = ACTIONS(4583),
    [anon_sym_json_DOTdecode] = ACTIONS(4583),
    [anon_sym_LBRACK2] = ACTIONS(4583),
    [anon_sym_TILDE] = ACTIONS(4583),
    [anon_sym_CARET] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4583),
    [anon_sym_LT_DASH] = ACTIONS(4583),
    [sym_none] = ACTIONS(4583),
    [sym_true] = ACTIONS(4583),
    [sym_false] = ACTIONS(4583),
    [sym_nil] = ACTIONS(4583),
    [anon_sym_if] = ACTIONS(4583),
    [anon_sym_DOLLARif] = ACTIONS(4583),
    [anon_sym_match] = ACTIONS(4583),
    [anon_sym_select] = ACTIONS(4583),
    [anon_sym_lock] = ACTIONS(4583),
    [anon_sym_rlock] = ACTIONS(4583),
    [anon_sym_unsafe] = ACTIONS(4583),
    [anon_sym_sql] = ACTIONS(4583),
    [sym_int_literal] = ACTIONS(4583),
    [sym_float_literal] = ACTIONS(4583),
    [sym_rune_literal] = ACTIONS(4583),
    [anon_sym_SQUOTE] = ACTIONS(4583),
    [anon_sym_DQUOTE] = ACTIONS(4583),
    [anon_sym_c_SQUOTE] = ACTIONS(4583),
    [anon_sym_c_DQUOTE] = ACTIONS(4583),
    [anon_sym_r_SQUOTE] = ACTIONS(4583),
    [anon_sym_r_DQUOTE] = ACTIONS(4583),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4583),
    [anon_sym_shared] = ACTIONS(4583),
    [anon_sym_map_LBRACK] = ACTIONS(4583),
    [anon_sym_chan] = ACTIONS(4583),
    [anon_sym_thread] = ACTIONS(4583),
    [anon_sym_atomic] = ACTIONS(4583),
    [anon_sym_assert] = ACTIONS(4583),
    [anon_sym_defer] = ACTIONS(4583),
    [anon_sym_goto] = ACTIONS(4583),
    [anon_sym_break] = ACTIONS(4583),
    [anon_sym_continue] = ACTIONS(4583),
    [anon_sym_return] = ACTIONS(4583),
    [anon_sym_DOLLARfor] = ACTIONS(4583),
    [anon_sym_for] = ACTIONS(4583),
    [anon_sym_POUND] = ACTIONS(4583),
    [anon_sym_asm] = ACTIONS(4583),
    [anon_sym_AT_LBRACK] = ACTIONS(4583),
  },
  [1791] = {
    [sym_line_comment] = STATE(1791),
    [sym_block_comment] = STATE(1791),
    [ts_builtin_sym_end] = ACTIONS(4585),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LF] = ACTIONS(4587),
    [anon_sym_CR] = ACTIONS(4587),
    [anon_sym_CR_LF] = ACTIONS(4587),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4587),
    [anon_sym_LBRACE] = ACTIONS(4587),
    [anon_sym_const] = ACTIONS(4587),
    [anon_sym_LPAREN] = ACTIONS(4587),
    [anon_sym___global] = ACTIONS(4587),
    [anon_sym_type] = ACTIONS(4587),
    [anon_sym_fn] = ACTIONS(4587),
    [anon_sym_PLUS] = ACTIONS(4587),
    [anon_sym_DASH] = ACTIONS(4587),
    [anon_sym_STAR] = ACTIONS(4587),
    [anon_sym_struct] = ACTIONS(4587),
    [anon_sym_union] = ACTIONS(4587),
    [anon_sym_pub] = ACTIONS(4587),
    [anon_sym_mut] = ACTIONS(4587),
    [anon_sym_enum] = ACTIONS(4587),
    [anon_sym_interface] = ACTIONS(4587),
    [anon_sym_QMARK] = ACTIONS(4587),
    [anon_sym_BANG] = ACTIONS(4587),
    [anon_sym_go] = ACTIONS(4587),
    [anon_sym_spawn] = ACTIONS(4587),
    [anon_sym_json_DOTdecode] = ACTIONS(4587),
    [anon_sym_LBRACK2] = ACTIONS(4587),
    [anon_sym_TILDE] = ACTIONS(4587),
    [anon_sym_CARET] = ACTIONS(4587),
    [anon_sym_AMP] = ACTIONS(4587),
    [anon_sym_LT_DASH] = ACTIONS(4587),
    [sym_none] = ACTIONS(4587),
    [sym_true] = ACTIONS(4587),
    [sym_false] = ACTIONS(4587),
    [sym_nil] = ACTIONS(4587),
    [anon_sym_if] = ACTIONS(4587),
    [anon_sym_DOLLARif] = ACTIONS(4587),
    [anon_sym_match] = ACTIONS(4587),
    [anon_sym_select] = ACTIONS(4587),
    [anon_sym_lock] = ACTIONS(4587),
    [anon_sym_rlock] = ACTIONS(4587),
    [anon_sym_unsafe] = ACTIONS(4587),
    [anon_sym_sql] = ACTIONS(4587),
    [sym_int_literal] = ACTIONS(4587),
    [sym_float_literal] = ACTIONS(4587),
    [sym_rune_literal] = ACTIONS(4587),
    [anon_sym_SQUOTE] = ACTIONS(4587),
    [anon_sym_DQUOTE] = ACTIONS(4587),
    [anon_sym_c_SQUOTE] = ACTIONS(4587),
    [anon_sym_c_DQUOTE] = ACTIONS(4587),
    [anon_sym_r_SQUOTE] = ACTIONS(4587),
    [anon_sym_r_DQUOTE] = ACTIONS(4587),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4587),
    [anon_sym_shared] = ACTIONS(4587),
    [anon_sym_map_LBRACK] = ACTIONS(4587),
    [anon_sym_chan] = ACTIONS(4587),
    [anon_sym_thread] = ACTIONS(4587),
    [anon_sym_atomic] = ACTIONS(4587),
    [anon_sym_assert] = ACTIONS(4587),
    [anon_sym_defer] = ACTIONS(4587),
    [anon_sym_goto] = ACTIONS(4587),
    [anon_sym_break] = ACTIONS(4587),
    [anon_sym_continue] = ACTIONS(4587),
    [anon_sym_return] = ACTIONS(4587),
    [anon_sym_DOLLARfor] = ACTIONS(4587),
    [anon_sym_for] = ACTIONS(4587),
    [anon_sym_POUND] = ACTIONS(4587),
    [anon_sym_asm] = ACTIONS(4587),
    [anon_sym_AT_LBRACK] = ACTIONS(4587),
  },
  [1792] = {
    [sym_line_comment] = STATE(1792),
    [sym_block_comment] = STATE(1792),
    [ts_builtin_sym_end] = ACTIONS(4589),
    [sym_identifier] = ACTIONS(4591),
    [anon_sym_LF] = ACTIONS(4591),
    [anon_sym_CR] = ACTIONS(4591),
    [anon_sym_CR_LF] = ACTIONS(4591),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4591),
    [anon_sym_LBRACE] = ACTIONS(4591),
    [anon_sym_const] = ACTIONS(4591),
    [anon_sym_LPAREN] = ACTIONS(4591),
    [anon_sym___global] = ACTIONS(4591),
    [anon_sym_type] = ACTIONS(4591),
    [anon_sym_fn] = ACTIONS(4591),
    [anon_sym_PLUS] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4591),
    [anon_sym_STAR] = ACTIONS(4591),
    [anon_sym_struct] = ACTIONS(4591),
    [anon_sym_union] = ACTIONS(4591),
    [anon_sym_pub] = ACTIONS(4591),
    [anon_sym_mut] = ACTIONS(4591),
    [anon_sym_enum] = ACTIONS(4591),
    [anon_sym_interface] = ACTIONS(4591),
    [anon_sym_QMARK] = ACTIONS(4591),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_go] = ACTIONS(4591),
    [anon_sym_spawn] = ACTIONS(4591),
    [anon_sym_json_DOTdecode] = ACTIONS(4591),
    [anon_sym_LBRACK2] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_CARET] = ACTIONS(4591),
    [anon_sym_AMP] = ACTIONS(4591),
    [anon_sym_LT_DASH] = ACTIONS(4591),
    [sym_none] = ACTIONS(4591),
    [sym_true] = ACTIONS(4591),
    [sym_false] = ACTIONS(4591),
    [sym_nil] = ACTIONS(4591),
    [anon_sym_if] = ACTIONS(4591),
    [anon_sym_DOLLARif] = ACTIONS(4591),
    [anon_sym_match] = ACTIONS(4591),
    [anon_sym_select] = ACTIONS(4591),
    [anon_sym_lock] = ACTIONS(4591),
    [anon_sym_rlock] = ACTIONS(4591),
    [anon_sym_unsafe] = ACTIONS(4591),
    [anon_sym_sql] = ACTIONS(4591),
    [sym_int_literal] = ACTIONS(4591),
    [sym_float_literal] = ACTIONS(4591),
    [sym_rune_literal] = ACTIONS(4591),
    [anon_sym_SQUOTE] = ACTIONS(4591),
    [anon_sym_DQUOTE] = ACTIONS(4591),
    [anon_sym_c_SQUOTE] = ACTIONS(4591),
    [anon_sym_c_DQUOTE] = ACTIONS(4591),
    [anon_sym_r_SQUOTE] = ACTIONS(4591),
    [anon_sym_r_DQUOTE] = ACTIONS(4591),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4591),
    [anon_sym_shared] = ACTIONS(4591),
    [anon_sym_map_LBRACK] = ACTIONS(4591),
    [anon_sym_chan] = ACTIONS(4591),
    [anon_sym_thread] = ACTIONS(4591),
    [anon_sym_atomic] = ACTIONS(4591),
    [anon_sym_assert] = ACTIONS(4591),
    [anon_sym_defer] = ACTIONS(4591),
    [anon_sym_goto] = ACTIONS(4591),
    [anon_sym_break] = ACTIONS(4591),
    [anon_sym_continue] = ACTIONS(4591),
    [anon_sym_return] = ACTIONS(4591),
    [anon_sym_DOLLARfor] = ACTIONS(4591),
    [anon_sym_for] = ACTIONS(4591),
    [anon_sym_POUND] = ACTIONS(4591),
    [anon_sym_asm] = ACTIONS(4591),
    [anon_sym_AT_LBRACK] = ACTIONS(4591),
  },
  [1793] = {
    [sym_line_comment] = STATE(1793),
    [sym_block_comment] = STATE(1793),
    [ts_builtin_sym_end] = ACTIONS(4593),
    [sym_identifier] = ACTIONS(4595),
    [anon_sym_LF] = ACTIONS(4595),
    [anon_sym_CR] = ACTIONS(4595),
    [anon_sym_CR_LF] = ACTIONS(4595),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4595),
    [anon_sym_LBRACE] = ACTIONS(4595),
    [anon_sym_const] = ACTIONS(4595),
    [anon_sym_LPAREN] = ACTIONS(4595),
    [anon_sym___global] = ACTIONS(4595),
    [anon_sym_type] = ACTIONS(4595),
    [anon_sym_fn] = ACTIONS(4595),
    [anon_sym_PLUS] = ACTIONS(4595),
    [anon_sym_DASH] = ACTIONS(4595),
    [anon_sym_STAR] = ACTIONS(4595),
    [anon_sym_struct] = ACTIONS(4595),
    [anon_sym_union] = ACTIONS(4595),
    [anon_sym_pub] = ACTIONS(4595),
    [anon_sym_mut] = ACTIONS(4595),
    [anon_sym_enum] = ACTIONS(4595),
    [anon_sym_interface] = ACTIONS(4595),
    [anon_sym_QMARK] = ACTIONS(4595),
    [anon_sym_BANG] = ACTIONS(4595),
    [anon_sym_go] = ACTIONS(4595),
    [anon_sym_spawn] = ACTIONS(4595),
    [anon_sym_json_DOTdecode] = ACTIONS(4595),
    [anon_sym_LBRACK2] = ACTIONS(4595),
    [anon_sym_TILDE] = ACTIONS(4595),
    [anon_sym_CARET] = ACTIONS(4595),
    [anon_sym_AMP] = ACTIONS(4595),
    [anon_sym_LT_DASH] = ACTIONS(4595),
    [sym_none] = ACTIONS(4595),
    [sym_true] = ACTIONS(4595),
    [sym_false] = ACTIONS(4595),
    [sym_nil] = ACTIONS(4595),
    [anon_sym_if] = ACTIONS(4595),
    [anon_sym_DOLLARif] = ACTIONS(4595),
    [anon_sym_match] = ACTIONS(4595),
    [anon_sym_select] = ACTIONS(4595),
    [anon_sym_lock] = ACTIONS(4595),
    [anon_sym_rlock] = ACTIONS(4595),
    [anon_sym_unsafe] = ACTIONS(4595),
    [anon_sym_sql] = ACTIONS(4595),
    [sym_int_literal] = ACTIONS(4595),
    [sym_float_literal] = ACTIONS(4595),
    [sym_rune_literal] = ACTIONS(4595),
    [anon_sym_SQUOTE] = ACTIONS(4595),
    [anon_sym_DQUOTE] = ACTIONS(4595),
    [anon_sym_c_SQUOTE] = ACTIONS(4595),
    [anon_sym_c_DQUOTE] = ACTIONS(4595),
    [anon_sym_r_SQUOTE] = ACTIONS(4595),
    [anon_sym_r_DQUOTE] = ACTIONS(4595),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4595),
    [anon_sym_shared] = ACTIONS(4595),
    [anon_sym_map_LBRACK] = ACTIONS(4595),
    [anon_sym_chan] = ACTIONS(4595),
    [anon_sym_thread] = ACTIONS(4595),
    [anon_sym_atomic] = ACTIONS(4595),
    [anon_sym_assert] = ACTIONS(4595),
    [anon_sym_defer] = ACTIONS(4595),
    [anon_sym_goto] = ACTIONS(4595),
    [anon_sym_break] = ACTIONS(4595),
    [anon_sym_continue] = ACTIONS(4595),
    [anon_sym_return] = ACTIONS(4595),
    [anon_sym_DOLLARfor] = ACTIONS(4595),
    [anon_sym_for] = ACTIONS(4595),
    [anon_sym_POUND] = ACTIONS(4595),
    [anon_sym_asm] = ACTIONS(4595),
    [anon_sym_AT_LBRACK] = ACTIONS(4595),
  },
  [1794] = {
    [sym_line_comment] = STATE(1794),
    [sym_block_comment] = STATE(1794),
    [ts_builtin_sym_end] = ACTIONS(4597),
    [sym_identifier] = ACTIONS(4599),
    [anon_sym_LF] = ACTIONS(4599),
    [anon_sym_CR] = ACTIONS(4599),
    [anon_sym_CR_LF] = ACTIONS(4599),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4599),
    [anon_sym_LBRACE] = ACTIONS(4599),
    [anon_sym_const] = ACTIONS(4599),
    [anon_sym_LPAREN] = ACTIONS(4599),
    [anon_sym___global] = ACTIONS(4599),
    [anon_sym_type] = ACTIONS(4599),
    [anon_sym_fn] = ACTIONS(4599),
    [anon_sym_PLUS] = ACTIONS(4599),
    [anon_sym_DASH] = ACTIONS(4599),
    [anon_sym_STAR] = ACTIONS(4599),
    [anon_sym_struct] = ACTIONS(4599),
    [anon_sym_union] = ACTIONS(4599),
    [anon_sym_pub] = ACTIONS(4599),
    [anon_sym_mut] = ACTIONS(4599),
    [anon_sym_enum] = ACTIONS(4599),
    [anon_sym_interface] = ACTIONS(4599),
    [anon_sym_QMARK] = ACTIONS(4599),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_go] = ACTIONS(4599),
    [anon_sym_spawn] = ACTIONS(4599),
    [anon_sym_json_DOTdecode] = ACTIONS(4599),
    [anon_sym_LBRACK2] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [anon_sym_CARET] = ACTIONS(4599),
    [anon_sym_AMP] = ACTIONS(4599),
    [anon_sym_LT_DASH] = ACTIONS(4599),
    [sym_none] = ACTIONS(4599),
    [sym_true] = ACTIONS(4599),
    [sym_false] = ACTIONS(4599),
    [sym_nil] = ACTIONS(4599),
    [anon_sym_if] = ACTIONS(4599),
    [anon_sym_DOLLARif] = ACTIONS(4599),
    [anon_sym_match] = ACTIONS(4599),
    [anon_sym_select] = ACTIONS(4599),
    [anon_sym_lock] = ACTIONS(4599),
    [anon_sym_rlock] = ACTIONS(4599),
    [anon_sym_unsafe] = ACTIONS(4599),
    [anon_sym_sql] = ACTIONS(4599),
    [sym_int_literal] = ACTIONS(4599),
    [sym_float_literal] = ACTIONS(4599),
    [sym_rune_literal] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_DQUOTE] = ACTIONS(4599),
    [anon_sym_c_SQUOTE] = ACTIONS(4599),
    [anon_sym_c_DQUOTE] = ACTIONS(4599),
    [anon_sym_r_SQUOTE] = ACTIONS(4599),
    [anon_sym_r_DQUOTE] = ACTIONS(4599),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4599),
    [anon_sym_shared] = ACTIONS(4599),
    [anon_sym_map_LBRACK] = ACTIONS(4599),
    [anon_sym_chan] = ACTIONS(4599),
    [anon_sym_thread] = ACTIONS(4599),
    [anon_sym_atomic] = ACTIONS(4599),
    [anon_sym_assert] = ACTIONS(4599),
    [anon_sym_defer] = ACTIONS(4599),
    [anon_sym_goto] = ACTIONS(4599),
    [anon_sym_break] = ACTIONS(4599),
    [anon_sym_continue] = ACTIONS(4599),
    [anon_sym_return] = ACTIONS(4599),
    [anon_sym_DOLLARfor] = ACTIONS(4599),
    [anon_sym_for] = ACTIONS(4599),
    [anon_sym_POUND] = ACTIONS(4599),
    [anon_sym_asm] = ACTIONS(4599),
    [anon_sym_AT_LBRACK] = ACTIONS(4599),
  },
  [1795] = {
    [sym_line_comment] = STATE(1795),
    [sym_block_comment] = STATE(1795),
    [ts_builtin_sym_end] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(4603),
    [anon_sym_LF] = ACTIONS(4603),
    [anon_sym_CR] = ACTIONS(4603),
    [anon_sym_CR_LF] = ACTIONS(4603),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4603),
    [anon_sym_LBRACE] = ACTIONS(4603),
    [anon_sym_const] = ACTIONS(4603),
    [anon_sym_LPAREN] = ACTIONS(4603),
    [anon_sym___global] = ACTIONS(4603),
    [anon_sym_type] = ACTIONS(4603),
    [anon_sym_fn] = ACTIONS(4603),
    [anon_sym_PLUS] = ACTIONS(4603),
    [anon_sym_DASH] = ACTIONS(4603),
    [anon_sym_STAR] = ACTIONS(4603),
    [anon_sym_struct] = ACTIONS(4603),
    [anon_sym_union] = ACTIONS(4603),
    [anon_sym_pub] = ACTIONS(4603),
    [anon_sym_mut] = ACTIONS(4603),
    [anon_sym_enum] = ACTIONS(4603),
    [anon_sym_interface] = ACTIONS(4603),
    [anon_sym_QMARK] = ACTIONS(4603),
    [anon_sym_BANG] = ACTIONS(4603),
    [anon_sym_go] = ACTIONS(4603),
    [anon_sym_spawn] = ACTIONS(4603),
    [anon_sym_json_DOTdecode] = ACTIONS(4603),
    [anon_sym_LBRACK2] = ACTIONS(4603),
    [anon_sym_TILDE] = ACTIONS(4603),
    [anon_sym_CARET] = ACTIONS(4603),
    [anon_sym_AMP] = ACTIONS(4603),
    [anon_sym_LT_DASH] = ACTIONS(4603),
    [sym_none] = ACTIONS(4603),
    [sym_true] = ACTIONS(4603),
    [sym_false] = ACTIONS(4603),
    [sym_nil] = ACTIONS(4603),
    [anon_sym_if] = ACTIONS(4603),
    [anon_sym_DOLLARif] = ACTIONS(4603),
    [anon_sym_match] = ACTIONS(4603),
    [anon_sym_select] = ACTIONS(4603),
    [anon_sym_lock] = ACTIONS(4603),
    [anon_sym_rlock] = ACTIONS(4603),
    [anon_sym_unsafe] = ACTIONS(4603),
    [anon_sym_sql] = ACTIONS(4603),
    [sym_int_literal] = ACTIONS(4603),
    [sym_float_literal] = ACTIONS(4603),
    [sym_rune_literal] = ACTIONS(4603),
    [anon_sym_SQUOTE] = ACTIONS(4603),
    [anon_sym_DQUOTE] = ACTIONS(4603),
    [anon_sym_c_SQUOTE] = ACTIONS(4603),
    [anon_sym_c_DQUOTE] = ACTIONS(4603),
    [anon_sym_r_SQUOTE] = ACTIONS(4603),
    [anon_sym_r_DQUOTE] = ACTIONS(4603),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4603),
    [anon_sym_shared] = ACTIONS(4603),
    [anon_sym_map_LBRACK] = ACTIONS(4603),
    [anon_sym_chan] = ACTIONS(4603),
    [anon_sym_thread] = ACTIONS(4603),
    [anon_sym_atomic] = ACTIONS(4603),
    [anon_sym_assert] = ACTIONS(4603),
    [anon_sym_defer] = ACTIONS(4603),
    [anon_sym_goto] = ACTIONS(4603),
    [anon_sym_break] = ACTIONS(4603),
    [anon_sym_continue] = ACTIONS(4603),
    [anon_sym_return] = ACTIONS(4603),
    [anon_sym_DOLLARfor] = ACTIONS(4603),
    [anon_sym_for] = ACTIONS(4603),
    [anon_sym_POUND] = ACTIONS(4603),
    [anon_sym_asm] = ACTIONS(4603),
    [anon_sym_AT_LBRACK] = ACTIONS(4603),
  },
  [1796] = {
    [sym_line_comment] = STATE(1796),
    [sym_block_comment] = STATE(1796),
    [ts_builtin_sym_end] = ACTIONS(2035),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_LF] = ACTIONS(2037),
    [anon_sym_CR] = ACTIONS(2037),
    [anon_sym_CR_LF] = ACTIONS(2037),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(2037),
    [anon_sym_const] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(2037),
    [anon_sym___global] = ACTIONS(2037),
    [anon_sym_type] = ACTIONS(2037),
    [anon_sym_fn] = ACTIONS(2037),
    [anon_sym_PLUS] = ACTIONS(2037),
    [anon_sym_DASH] = ACTIONS(2037),
    [anon_sym_STAR] = ACTIONS(2037),
    [anon_sym_struct] = ACTIONS(2037),
    [anon_sym_union] = ACTIONS(2037),
    [anon_sym_pub] = ACTIONS(2037),
    [anon_sym_mut] = ACTIONS(2037),
    [anon_sym_enum] = ACTIONS(2037),
    [anon_sym_interface] = ACTIONS(2037),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_go] = ACTIONS(2037),
    [anon_sym_spawn] = ACTIONS(2037),
    [anon_sym_json_DOTdecode] = ACTIONS(2037),
    [anon_sym_LBRACK2] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_LT_DASH] = ACTIONS(2037),
    [sym_none] = ACTIONS(2037),
    [sym_true] = ACTIONS(2037),
    [sym_false] = ACTIONS(2037),
    [sym_nil] = ACTIONS(2037),
    [anon_sym_if] = ACTIONS(2037),
    [anon_sym_DOLLARif] = ACTIONS(2037),
    [anon_sym_match] = ACTIONS(2037),
    [anon_sym_select] = ACTIONS(2037),
    [anon_sym_lock] = ACTIONS(2037),
    [anon_sym_rlock] = ACTIONS(2037),
    [anon_sym_unsafe] = ACTIONS(2037),
    [anon_sym_sql] = ACTIONS(2037),
    [sym_int_literal] = ACTIONS(2037),
    [sym_float_literal] = ACTIONS(2037),
    [sym_rune_literal] = ACTIONS(2037),
    [anon_sym_SQUOTE] = ACTIONS(2037),
    [anon_sym_DQUOTE] = ACTIONS(2037),
    [anon_sym_c_SQUOTE] = ACTIONS(2037),
    [anon_sym_c_DQUOTE] = ACTIONS(2037),
    [anon_sym_r_SQUOTE] = ACTIONS(2037),
    [anon_sym_r_DQUOTE] = ACTIONS(2037),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2037),
    [anon_sym_shared] = ACTIONS(2037),
    [anon_sym_map_LBRACK] = ACTIONS(2037),
    [anon_sym_chan] = ACTIONS(2037),
    [anon_sym_thread] = ACTIONS(2037),
    [anon_sym_atomic] = ACTIONS(2037),
    [anon_sym_assert] = ACTIONS(2037),
    [anon_sym_defer] = ACTIONS(2037),
    [anon_sym_goto] = ACTIONS(2037),
    [anon_sym_break] = ACTIONS(2037),
    [anon_sym_continue] = ACTIONS(2037),
    [anon_sym_return] = ACTIONS(2037),
    [anon_sym_DOLLARfor] = ACTIONS(2037),
    [anon_sym_for] = ACTIONS(2037),
    [anon_sym_POUND] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2037),
    [anon_sym_AT_LBRACK] = ACTIONS(2037),
  },
  [1797] = {
    [sym_line_comment] = STATE(1797),
    [sym_block_comment] = STATE(1797),
    [ts_builtin_sym_end] = ACTIONS(4605),
    [sym_identifier] = ACTIONS(4607),
    [anon_sym_LF] = ACTIONS(4607),
    [anon_sym_CR] = ACTIONS(4607),
    [anon_sym_CR_LF] = ACTIONS(4607),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4607),
    [anon_sym_LBRACE] = ACTIONS(4607),
    [anon_sym_const] = ACTIONS(4607),
    [anon_sym_LPAREN] = ACTIONS(4607),
    [anon_sym___global] = ACTIONS(4607),
    [anon_sym_type] = ACTIONS(4607),
    [anon_sym_fn] = ACTIONS(4607),
    [anon_sym_PLUS] = ACTIONS(4607),
    [anon_sym_DASH] = ACTIONS(4607),
    [anon_sym_STAR] = ACTIONS(4607),
    [anon_sym_struct] = ACTIONS(4607),
    [anon_sym_union] = ACTIONS(4607),
    [anon_sym_pub] = ACTIONS(4607),
    [anon_sym_mut] = ACTIONS(4607),
    [anon_sym_enum] = ACTIONS(4607),
    [anon_sym_interface] = ACTIONS(4607),
    [anon_sym_QMARK] = ACTIONS(4607),
    [anon_sym_BANG] = ACTIONS(4607),
    [anon_sym_go] = ACTIONS(4607),
    [anon_sym_spawn] = ACTIONS(4607),
    [anon_sym_json_DOTdecode] = ACTIONS(4607),
    [anon_sym_LBRACK2] = ACTIONS(4607),
    [anon_sym_TILDE] = ACTIONS(4607),
    [anon_sym_CARET] = ACTIONS(4607),
    [anon_sym_AMP] = ACTIONS(4607),
    [anon_sym_LT_DASH] = ACTIONS(4607),
    [sym_none] = ACTIONS(4607),
    [sym_true] = ACTIONS(4607),
    [sym_false] = ACTIONS(4607),
    [sym_nil] = ACTIONS(4607),
    [anon_sym_if] = ACTIONS(4607),
    [anon_sym_DOLLARif] = ACTIONS(4607),
    [anon_sym_match] = ACTIONS(4607),
    [anon_sym_select] = ACTIONS(4607),
    [anon_sym_lock] = ACTIONS(4607),
    [anon_sym_rlock] = ACTIONS(4607),
    [anon_sym_unsafe] = ACTIONS(4607),
    [anon_sym_sql] = ACTIONS(4607),
    [sym_int_literal] = ACTIONS(4607),
    [sym_float_literal] = ACTIONS(4607),
    [sym_rune_literal] = ACTIONS(4607),
    [anon_sym_SQUOTE] = ACTIONS(4607),
    [anon_sym_DQUOTE] = ACTIONS(4607),
    [anon_sym_c_SQUOTE] = ACTIONS(4607),
    [anon_sym_c_DQUOTE] = ACTIONS(4607),
    [anon_sym_r_SQUOTE] = ACTIONS(4607),
    [anon_sym_r_DQUOTE] = ACTIONS(4607),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4607),
    [anon_sym_shared] = ACTIONS(4607),
    [anon_sym_map_LBRACK] = ACTIONS(4607),
    [anon_sym_chan] = ACTIONS(4607),
    [anon_sym_thread] = ACTIONS(4607),
    [anon_sym_atomic] = ACTIONS(4607),
    [anon_sym_assert] = ACTIONS(4607),
    [anon_sym_defer] = ACTIONS(4607),
    [anon_sym_goto] = ACTIONS(4607),
    [anon_sym_break] = ACTIONS(4607),
    [anon_sym_continue] = ACTIONS(4607),
    [anon_sym_return] = ACTIONS(4607),
    [anon_sym_DOLLARfor] = ACTIONS(4607),
    [anon_sym_for] = ACTIONS(4607),
    [anon_sym_POUND] = ACTIONS(4607),
    [anon_sym_asm] = ACTIONS(4607),
    [anon_sym_AT_LBRACK] = ACTIONS(4607),
  },
  [1798] = {
    [sym_line_comment] = STATE(1798),
    [sym_block_comment] = STATE(1798),
    [ts_builtin_sym_end] = ACTIONS(4609),
    [sym_identifier] = ACTIONS(4611),
    [anon_sym_LF] = ACTIONS(4611),
    [anon_sym_CR] = ACTIONS(4611),
    [anon_sym_CR_LF] = ACTIONS(4611),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4611),
    [anon_sym_LBRACE] = ACTIONS(4611),
    [anon_sym_const] = ACTIONS(4611),
    [anon_sym_LPAREN] = ACTIONS(4611),
    [anon_sym___global] = ACTIONS(4611),
    [anon_sym_type] = ACTIONS(4611),
    [anon_sym_fn] = ACTIONS(4611),
    [anon_sym_PLUS] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4611),
    [anon_sym_STAR] = ACTIONS(4611),
    [anon_sym_struct] = ACTIONS(4611),
    [anon_sym_union] = ACTIONS(4611),
    [anon_sym_pub] = ACTIONS(4611),
    [anon_sym_mut] = ACTIONS(4611),
    [anon_sym_enum] = ACTIONS(4611),
    [anon_sym_interface] = ACTIONS(4611),
    [anon_sym_QMARK] = ACTIONS(4611),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_go] = ACTIONS(4611),
    [anon_sym_spawn] = ACTIONS(4611),
    [anon_sym_json_DOTdecode] = ACTIONS(4611),
    [anon_sym_LBRACK2] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_CARET] = ACTIONS(4611),
    [anon_sym_AMP] = ACTIONS(4611),
    [anon_sym_LT_DASH] = ACTIONS(4611),
    [sym_none] = ACTIONS(4611),
    [sym_true] = ACTIONS(4611),
    [sym_false] = ACTIONS(4611),
    [sym_nil] = ACTIONS(4611),
    [anon_sym_if] = ACTIONS(4611),
    [anon_sym_DOLLARif] = ACTIONS(4611),
    [anon_sym_match] = ACTIONS(4611),
    [anon_sym_select] = ACTIONS(4611),
    [anon_sym_lock] = ACTIONS(4611),
    [anon_sym_rlock] = ACTIONS(4611),
    [anon_sym_unsafe] = ACTIONS(4611),
    [anon_sym_sql] = ACTIONS(4611),
    [sym_int_literal] = ACTIONS(4611),
    [sym_float_literal] = ACTIONS(4611),
    [sym_rune_literal] = ACTIONS(4611),
    [anon_sym_SQUOTE] = ACTIONS(4611),
    [anon_sym_DQUOTE] = ACTIONS(4611),
    [anon_sym_c_SQUOTE] = ACTIONS(4611),
    [anon_sym_c_DQUOTE] = ACTIONS(4611),
    [anon_sym_r_SQUOTE] = ACTIONS(4611),
    [anon_sym_r_DQUOTE] = ACTIONS(4611),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4611),
    [anon_sym_shared] = ACTIONS(4611),
    [anon_sym_map_LBRACK] = ACTIONS(4611),
    [anon_sym_chan] = ACTIONS(4611),
    [anon_sym_thread] = ACTIONS(4611),
    [anon_sym_atomic] = ACTIONS(4611),
    [anon_sym_assert] = ACTIONS(4611),
    [anon_sym_defer] = ACTIONS(4611),
    [anon_sym_goto] = ACTIONS(4611),
    [anon_sym_break] = ACTIONS(4611),
    [anon_sym_continue] = ACTIONS(4611),
    [anon_sym_return] = ACTIONS(4611),
    [anon_sym_DOLLARfor] = ACTIONS(4611),
    [anon_sym_for] = ACTIONS(4611),
    [anon_sym_POUND] = ACTIONS(4611),
    [anon_sym_asm] = ACTIONS(4611),
    [anon_sym_AT_LBRACK] = ACTIONS(4611),
  },
  [1799] = {
    [sym_line_comment] = STATE(1799),
    [sym_block_comment] = STATE(1799),
    [ts_builtin_sym_end] = ACTIONS(4613),
    [sym_identifier] = ACTIONS(4615),
    [anon_sym_LF] = ACTIONS(4615),
    [anon_sym_CR] = ACTIONS(4615),
    [anon_sym_CR_LF] = ACTIONS(4615),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4615),
    [anon_sym_LBRACE] = ACTIONS(4615),
    [anon_sym_const] = ACTIONS(4615),
    [anon_sym_LPAREN] = ACTIONS(4615),
    [anon_sym___global] = ACTIONS(4615),
    [anon_sym_type] = ACTIONS(4615),
    [anon_sym_fn] = ACTIONS(4615),
    [anon_sym_PLUS] = ACTIONS(4615),
    [anon_sym_DASH] = ACTIONS(4615),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_struct] = ACTIONS(4615),
    [anon_sym_union] = ACTIONS(4615),
    [anon_sym_pub] = ACTIONS(4615),
    [anon_sym_mut] = ACTIONS(4615),
    [anon_sym_enum] = ACTIONS(4615),
    [anon_sym_interface] = ACTIONS(4615),
    [anon_sym_QMARK] = ACTIONS(4615),
    [anon_sym_BANG] = ACTIONS(4615),
    [anon_sym_go] = ACTIONS(4615),
    [anon_sym_spawn] = ACTIONS(4615),
    [anon_sym_json_DOTdecode] = ACTIONS(4615),
    [anon_sym_LBRACK2] = ACTIONS(4615),
    [anon_sym_TILDE] = ACTIONS(4615),
    [anon_sym_CARET] = ACTIONS(4615),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_LT_DASH] = ACTIONS(4615),
    [sym_none] = ACTIONS(4615),
    [sym_true] = ACTIONS(4615),
    [sym_false] = ACTIONS(4615),
    [sym_nil] = ACTIONS(4615),
    [anon_sym_if] = ACTIONS(4615),
    [anon_sym_DOLLARif] = ACTIONS(4615),
    [anon_sym_match] = ACTIONS(4615),
    [anon_sym_select] = ACTIONS(4615),
    [anon_sym_lock] = ACTIONS(4615),
    [anon_sym_rlock] = ACTIONS(4615),
    [anon_sym_unsafe] = ACTIONS(4615),
    [anon_sym_sql] = ACTIONS(4615),
    [sym_int_literal] = ACTIONS(4615),
    [sym_float_literal] = ACTIONS(4615),
    [sym_rune_literal] = ACTIONS(4615),
    [anon_sym_SQUOTE] = ACTIONS(4615),
    [anon_sym_DQUOTE] = ACTIONS(4615),
    [anon_sym_c_SQUOTE] = ACTIONS(4615),
    [anon_sym_c_DQUOTE] = ACTIONS(4615),
    [anon_sym_r_SQUOTE] = ACTIONS(4615),
    [anon_sym_r_DQUOTE] = ACTIONS(4615),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4615),
    [anon_sym_shared] = ACTIONS(4615),
    [anon_sym_map_LBRACK] = ACTIONS(4615),
    [anon_sym_chan] = ACTIONS(4615),
    [anon_sym_thread] = ACTIONS(4615),
    [anon_sym_atomic] = ACTIONS(4615),
    [anon_sym_assert] = ACTIONS(4615),
    [anon_sym_defer] = ACTIONS(4615),
    [anon_sym_goto] = ACTIONS(4615),
    [anon_sym_break] = ACTIONS(4615),
    [anon_sym_continue] = ACTIONS(4615),
    [anon_sym_return] = ACTIONS(4615),
    [anon_sym_DOLLARfor] = ACTIONS(4615),
    [anon_sym_for] = ACTIONS(4615),
    [anon_sym_POUND] = ACTIONS(4615),
    [anon_sym_asm] = ACTIONS(4615),
    [anon_sym_AT_LBRACK] = ACTIONS(4615),
  },
  [1800] = {
    [sym_line_comment] = STATE(1800),
    [sym_block_comment] = STATE(1800),
    [ts_builtin_sym_end] = ACTIONS(4617),
    [sym_identifier] = ACTIONS(4619),
    [anon_sym_LF] = ACTIONS(4619),
    [anon_sym_CR] = ACTIONS(4619),
    [anon_sym_CR_LF] = ACTIONS(4619),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4619),
    [anon_sym_LBRACE] = ACTIONS(4619),
    [anon_sym_const] = ACTIONS(4619),
    [anon_sym_LPAREN] = ACTIONS(4619),
    [anon_sym___global] = ACTIONS(4619),
    [anon_sym_type] = ACTIONS(4619),
    [anon_sym_fn] = ACTIONS(4619),
    [anon_sym_PLUS] = ACTIONS(4619),
    [anon_sym_DASH] = ACTIONS(4619),
    [anon_sym_STAR] = ACTIONS(4619),
    [anon_sym_struct] = ACTIONS(4619),
    [anon_sym_union] = ACTIONS(4619),
    [anon_sym_pub] = ACTIONS(4619),
    [anon_sym_mut] = ACTIONS(4619),
    [anon_sym_enum] = ACTIONS(4619),
    [anon_sym_interface] = ACTIONS(4619),
    [anon_sym_QMARK] = ACTIONS(4619),
    [anon_sym_BANG] = ACTIONS(4619),
    [anon_sym_go] = ACTIONS(4619),
    [anon_sym_spawn] = ACTIONS(4619),
    [anon_sym_json_DOTdecode] = ACTIONS(4619),
    [anon_sym_LBRACK2] = ACTIONS(4619),
    [anon_sym_TILDE] = ACTIONS(4619),
    [anon_sym_CARET] = ACTIONS(4619),
    [anon_sym_AMP] = ACTIONS(4619),
    [anon_sym_LT_DASH] = ACTIONS(4619),
    [sym_none] = ACTIONS(4619),
    [sym_true] = ACTIONS(4619),
    [sym_false] = ACTIONS(4619),
    [sym_nil] = ACTIONS(4619),
    [anon_sym_if] = ACTIONS(4619),
    [anon_sym_DOLLARif] = ACTIONS(4619),
    [anon_sym_match] = ACTIONS(4619),
    [anon_sym_select] = ACTIONS(4619),
    [anon_sym_lock] = ACTIONS(4619),
    [anon_sym_rlock] = ACTIONS(4619),
    [anon_sym_unsafe] = ACTIONS(4619),
    [anon_sym_sql] = ACTIONS(4619),
    [sym_int_literal] = ACTIONS(4619),
    [sym_float_literal] = ACTIONS(4619),
    [sym_rune_literal] = ACTIONS(4619),
    [anon_sym_SQUOTE] = ACTIONS(4619),
    [anon_sym_DQUOTE] = ACTIONS(4619),
    [anon_sym_c_SQUOTE] = ACTIONS(4619),
    [anon_sym_c_DQUOTE] = ACTIONS(4619),
    [anon_sym_r_SQUOTE] = ACTIONS(4619),
    [anon_sym_r_DQUOTE] = ACTIONS(4619),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4619),
    [anon_sym_shared] = ACTIONS(4619),
    [anon_sym_map_LBRACK] = ACTIONS(4619),
    [anon_sym_chan] = ACTIONS(4619),
    [anon_sym_thread] = ACTIONS(4619),
    [anon_sym_atomic] = ACTIONS(4619),
    [anon_sym_assert] = ACTIONS(4619),
    [anon_sym_defer] = ACTIONS(4619),
    [anon_sym_goto] = ACTIONS(4619),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_continue] = ACTIONS(4619),
    [anon_sym_return] = ACTIONS(4619),
    [anon_sym_DOLLARfor] = ACTIONS(4619),
    [anon_sym_for] = ACTIONS(4619),
    [anon_sym_POUND] = ACTIONS(4619),
    [anon_sym_asm] = ACTIONS(4619),
    [anon_sym_AT_LBRACK] = ACTIONS(4619),
  },
  [1801] = {
    [sym_line_comment] = STATE(1801),
    [sym_block_comment] = STATE(1801),
    [ts_builtin_sym_end] = ACTIONS(2667),
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_LF] = ACTIONS(2669),
    [anon_sym_CR] = ACTIONS(2669),
    [anon_sym_CR_LF] = ACTIONS(2669),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_LPAREN] = ACTIONS(2669),
    [anon_sym___global] = ACTIONS(2669),
    [anon_sym_type] = ACTIONS(2669),
    [anon_sym_fn] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_union] = ACTIONS(2669),
    [anon_sym_pub] = ACTIONS(2669),
    [anon_sym_mut] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [anon_sym_interface] = ACTIONS(2669),
    [anon_sym_QMARK] = ACTIONS(2669),
    [anon_sym_BANG] = ACTIONS(2669),
    [anon_sym_go] = ACTIONS(2669),
    [anon_sym_spawn] = ACTIONS(2669),
    [anon_sym_json_DOTdecode] = ACTIONS(2669),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_TILDE] = ACTIONS(2669),
    [anon_sym_CARET] = ACTIONS(2669),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_LT_DASH] = ACTIONS(2669),
    [sym_none] = ACTIONS(2669),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [sym_nil] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_DOLLARif] = ACTIONS(2669),
    [anon_sym_match] = ACTIONS(2669),
    [anon_sym_select] = ACTIONS(2669),
    [anon_sym_lock] = ACTIONS(2669),
    [anon_sym_rlock] = ACTIONS(2669),
    [anon_sym_unsafe] = ACTIONS(2669),
    [anon_sym_sql] = ACTIONS(2669),
    [sym_int_literal] = ACTIONS(2669),
    [sym_float_literal] = ACTIONS(2669),
    [sym_rune_literal] = ACTIONS(2669),
    [anon_sym_SQUOTE] = ACTIONS(2669),
    [anon_sym_DQUOTE] = ACTIONS(2669),
    [anon_sym_c_SQUOTE] = ACTIONS(2669),
    [anon_sym_c_DQUOTE] = ACTIONS(2669),
    [anon_sym_r_SQUOTE] = ACTIONS(2669),
    [anon_sym_r_DQUOTE] = ACTIONS(2669),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2669),
    [anon_sym_shared] = ACTIONS(2669),
    [anon_sym_map_LBRACK] = ACTIONS(2669),
    [anon_sym_chan] = ACTIONS(2669),
    [anon_sym_thread] = ACTIONS(2669),
    [anon_sym_atomic] = ACTIONS(2669),
    [anon_sym_assert] = ACTIONS(2669),
    [anon_sym_defer] = ACTIONS(2669),
    [anon_sym_goto] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_DOLLARfor] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_POUND] = ACTIONS(2669),
    [anon_sym_asm] = ACTIONS(2669),
    [anon_sym_AT_LBRACK] = ACTIONS(2669),
  },
  [1802] = {
    [sym_line_comment] = STATE(1802),
    [sym_block_comment] = STATE(1802),
    [ts_builtin_sym_end] = ACTIONS(2983),
    [sym_identifier] = ACTIONS(2985),
    [anon_sym_LF] = ACTIONS(2985),
    [anon_sym_CR] = ACTIONS(2985),
    [anon_sym_CR_LF] = ACTIONS(2985),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym___global] = ACTIONS(2985),
    [anon_sym_type] = ACTIONS(2985),
    [anon_sym_fn] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2985),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_union] = ACTIONS(2985),
    [anon_sym_pub] = ACTIONS(2985),
    [anon_sym_mut] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [anon_sym_interface] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_go] = ACTIONS(2985),
    [anon_sym_spawn] = ACTIONS(2985),
    [anon_sym_json_DOTdecode] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(2985),
    [anon_sym_CARET] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_DASH] = ACTIONS(2985),
    [sym_none] = ACTIONS(2985),
    [sym_true] = ACTIONS(2985),
    [sym_false] = ACTIONS(2985),
    [sym_nil] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_DOLLARif] = ACTIONS(2985),
    [anon_sym_match] = ACTIONS(2985),
    [anon_sym_select] = ACTIONS(2985),
    [anon_sym_lock] = ACTIONS(2985),
    [anon_sym_rlock] = ACTIONS(2985),
    [anon_sym_unsafe] = ACTIONS(2985),
    [anon_sym_sql] = ACTIONS(2985),
    [sym_int_literal] = ACTIONS(2985),
    [sym_float_literal] = ACTIONS(2985),
    [sym_rune_literal] = ACTIONS(2985),
    [anon_sym_SQUOTE] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_c_SQUOTE] = ACTIONS(2985),
    [anon_sym_c_DQUOTE] = ACTIONS(2985),
    [anon_sym_r_SQUOTE] = ACTIONS(2985),
    [anon_sym_r_DQUOTE] = ACTIONS(2985),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2985),
    [anon_sym_shared] = ACTIONS(2985),
    [anon_sym_map_LBRACK] = ACTIONS(2985),
    [anon_sym_chan] = ACTIONS(2985),
    [anon_sym_thread] = ACTIONS(2985),
    [anon_sym_atomic] = ACTIONS(2985),
    [anon_sym_assert] = ACTIONS(2985),
    [anon_sym_defer] = ACTIONS(2985),
    [anon_sym_goto] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_DOLLARfor] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_POUND] = ACTIONS(2985),
    [anon_sym_asm] = ACTIONS(2985),
    [anon_sym_AT_LBRACK] = ACTIONS(2985),
  },
  [1803] = {
    [sym_line_comment] = STATE(1803),
    [sym_block_comment] = STATE(1803),
    [ts_builtin_sym_end] = ACTIONS(4621),
    [sym_identifier] = ACTIONS(4623),
    [anon_sym_LF] = ACTIONS(4623),
    [anon_sym_CR] = ACTIONS(4623),
    [anon_sym_CR_LF] = ACTIONS(4623),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4623),
    [anon_sym_LBRACE] = ACTIONS(4623),
    [anon_sym_const] = ACTIONS(4623),
    [anon_sym_LPAREN] = ACTIONS(4623),
    [anon_sym___global] = ACTIONS(4623),
    [anon_sym_type] = ACTIONS(4623),
    [anon_sym_fn] = ACTIONS(4623),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_DASH] = ACTIONS(4623),
    [anon_sym_STAR] = ACTIONS(4623),
    [anon_sym_struct] = ACTIONS(4623),
    [anon_sym_union] = ACTIONS(4623),
    [anon_sym_pub] = ACTIONS(4623),
    [anon_sym_mut] = ACTIONS(4623),
    [anon_sym_enum] = ACTIONS(4623),
    [anon_sym_interface] = ACTIONS(4623),
    [anon_sym_QMARK] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4623),
    [anon_sym_go] = ACTIONS(4623),
    [anon_sym_spawn] = ACTIONS(4623),
    [anon_sym_json_DOTdecode] = ACTIONS(4623),
    [anon_sym_LBRACK2] = ACTIONS(4623),
    [anon_sym_TILDE] = ACTIONS(4623),
    [anon_sym_CARET] = ACTIONS(4623),
    [anon_sym_AMP] = ACTIONS(4623),
    [anon_sym_LT_DASH] = ACTIONS(4623),
    [sym_none] = ACTIONS(4623),
    [sym_true] = ACTIONS(4623),
    [sym_false] = ACTIONS(4623),
    [sym_nil] = ACTIONS(4623),
    [anon_sym_if] = ACTIONS(4623),
    [anon_sym_DOLLARif] = ACTIONS(4623),
    [anon_sym_match] = ACTIONS(4623),
    [anon_sym_select] = ACTIONS(4623),
    [anon_sym_lock] = ACTIONS(4623),
    [anon_sym_rlock] = ACTIONS(4623),
    [anon_sym_unsafe] = ACTIONS(4623),
    [anon_sym_sql] = ACTIONS(4623),
    [sym_int_literal] = ACTIONS(4623),
    [sym_float_literal] = ACTIONS(4623),
    [sym_rune_literal] = ACTIONS(4623),
    [anon_sym_SQUOTE] = ACTIONS(4623),
    [anon_sym_DQUOTE] = ACTIONS(4623),
    [anon_sym_c_SQUOTE] = ACTIONS(4623),
    [anon_sym_c_DQUOTE] = ACTIONS(4623),
    [anon_sym_r_SQUOTE] = ACTIONS(4623),
    [anon_sym_r_DQUOTE] = ACTIONS(4623),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4623),
    [anon_sym_shared] = ACTIONS(4623),
    [anon_sym_map_LBRACK] = ACTIONS(4623),
    [anon_sym_chan] = ACTIONS(4623),
    [anon_sym_thread] = ACTIONS(4623),
    [anon_sym_atomic] = ACTIONS(4623),
    [anon_sym_assert] = ACTIONS(4623),
    [anon_sym_defer] = ACTIONS(4623),
    [anon_sym_goto] = ACTIONS(4623),
    [anon_sym_break] = ACTIONS(4623),
    [anon_sym_continue] = ACTIONS(4623),
    [anon_sym_return] = ACTIONS(4623),
    [anon_sym_DOLLARfor] = ACTIONS(4623),
    [anon_sym_for] = ACTIONS(4623),
    [anon_sym_POUND] = ACTIONS(4623),
    [anon_sym_asm] = ACTIONS(4623),
    [anon_sym_AT_LBRACK] = ACTIONS(4623),
  },
  [1804] = {
    [sym_line_comment] = STATE(1804),
    [sym_block_comment] = STATE(1804),
    [ts_builtin_sym_end] = ACTIONS(4625),
    [sym_identifier] = ACTIONS(4627),
    [anon_sym_LF] = ACTIONS(4627),
    [anon_sym_CR] = ACTIONS(4627),
    [anon_sym_CR_LF] = ACTIONS(4627),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4627),
    [anon_sym_LBRACE] = ACTIONS(4627),
    [anon_sym_const] = ACTIONS(4627),
    [anon_sym_LPAREN] = ACTIONS(4627),
    [anon_sym___global] = ACTIONS(4627),
    [anon_sym_type] = ACTIONS(4627),
    [anon_sym_fn] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4627),
    [anon_sym_struct] = ACTIONS(4627),
    [anon_sym_union] = ACTIONS(4627),
    [anon_sym_pub] = ACTIONS(4627),
    [anon_sym_mut] = ACTIONS(4627),
    [anon_sym_enum] = ACTIONS(4627),
    [anon_sym_interface] = ACTIONS(4627),
    [anon_sym_QMARK] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4627),
    [anon_sym_go] = ACTIONS(4627),
    [anon_sym_spawn] = ACTIONS(4627),
    [anon_sym_json_DOTdecode] = ACTIONS(4627),
    [anon_sym_LBRACK2] = ACTIONS(4627),
    [anon_sym_TILDE] = ACTIONS(4627),
    [anon_sym_CARET] = ACTIONS(4627),
    [anon_sym_AMP] = ACTIONS(4627),
    [anon_sym_LT_DASH] = ACTIONS(4627),
    [sym_none] = ACTIONS(4627),
    [sym_true] = ACTIONS(4627),
    [sym_false] = ACTIONS(4627),
    [sym_nil] = ACTIONS(4627),
    [anon_sym_if] = ACTIONS(4627),
    [anon_sym_DOLLARif] = ACTIONS(4627),
    [anon_sym_match] = ACTIONS(4627),
    [anon_sym_select] = ACTIONS(4627),
    [anon_sym_lock] = ACTIONS(4627),
    [anon_sym_rlock] = ACTIONS(4627),
    [anon_sym_unsafe] = ACTIONS(4627),
    [anon_sym_sql] = ACTIONS(4627),
    [sym_int_literal] = ACTIONS(4627),
    [sym_float_literal] = ACTIONS(4627),
    [sym_rune_literal] = ACTIONS(4627),
    [anon_sym_SQUOTE] = ACTIONS(4627),
    [anon_sym_DQUOTE] = ACTIONS(4627),
    [anon_sym_c_SQUOTE] = ACTIONS(4627),
    [anon_sym_c_DQUOTE] = ACTIONS(4627),
    [anon_sym_r_SQUOTE] = ACTIONS(4627),
    [anon_sym_r_DQUOTE] = ACTIONS(4627),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4627),
    [anon_sym_shared] = ACTIONS(4627),
    [anon_sym_map_LBRACK] = ACTIONS(4627),
    [anon_sym_chan] = ACTIONS(4627),
    [anon_sym_thread] = ACTIONS(4627),
    [anon_sym_atomic] = ACTIONS(4627),
    [anon_sym_assert] = ACTIONS(4627),
    [anon_sym_defer] = ACTIONS(4627),
    [anon_sym_goto] = ACTIONS(4627),
    [anon_sym_break] = ACTIONS(4627),
    [anon_sym_continue] = ACTIONS(4627),
    [anon_sym_return] = ACTIONS(4627),
    [anon_sym_DOLLARfor] = ACTIONS(4627),
    [anon_sym_for] = ACTIONS(4627),
    [anon_sym_POUND] = ACTIONS(4627),
    [anon_sym_asm] = ACTIONS(4627),
    [anon_sym_AT_LBRACK] = ACTIONS(4627),
  },
  [1805] = {
    [sym_line_comment] = STATE(1805),
    [sym_block_comment] = STATE(1805),
    [sym_import_declaration] = STATE(1920),
    [aux_sym_import_list_repeat1] = STATE(1783),
    [ts_builtin_sym_end] = ACTIONS(4629),
    [sym_identifier] = ACTIONS(4631),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(4631),
    [anon_sym_LBRACE] = ACTIONS(4629),
    [anon_sym_const] = ACTIONS(4631),
    [anon_sym_LPAREN] = ACTIONS(4629),
    [anon_sym___global] = ACTIONS(4631),
    [anon_sym_type] = ACTIONS(4631),
    [anon_sym_fn] = ACTIONS(4631),
    [anon_sym_PLUS] = ACTIONS(4629),
    [anon_sym_DASH] = ACTIONS(4629),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_struct] = ACTIONS(4631),
    [anon_sym_union] = ACTIONS(4631),
    [anon_sym_pub] = ACTIONS(4631),
    [anon_sym_mut] = ACTIONS(4631),
    [anon_sym_enum] = ACTIONS(4631),
    [anon_sym_interface] = ACTIONS(4631),
    [anon_sym_QMARK] = ACTIONS(4629),
    [anon_sym_BANG] = ACTIONS(4629),
    [anon_sym_go] = ACTIONS(4631),
    [anon_sym_spawn] = ACTIONS(4631),
    [anon_sym_json_DOTdecode] = ACTIONS(4629),
    [anon_sym_LBRACK2] = ACTIONS(4629),
    [anon_sym_TILDE] = ACTIONS(4629),
    [anon_sym_CARET] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_LT_DASH] = ACTIONS(4629),
    [sym_none] = ACTIONS(4631),
    [sym_true] = ACTIONS(4631),
    [sym_false] = ACTIONS(4631),
    [sym_nil] = ACTIONS(4631),
    [anon_sym_if] = ACTIONS(4631),
    [anon_sym_DOLLARif] = ACTIONS(4631),
    [anon_sym_match] = ACTIONS(4631),
    [anon_sym_select] = ACTIONS(4631),
    [anon_sym_lock] = ACTIONS(4631),
    [anon_sym_rlock] = ACTIONS(4631),
    [anon_sym_unsafe] = ACTIONS(4631),
    [anon_sym_sql] = ACTIONS(4631),
    [sym_int_literal] = ACTIONS(4631),
    [sym_float_literal] = ACTIONS(4629),
    [sym_rune_literal] = ACTIONS(4629),
    [anon_sym_SQUOTE] = ACTIONS(4629),
    [anon_sym_DQUOTE] = ACTIONS(4629),
    [anon_sym_c_SQUOTE] = ACTIONS(4629),
    [anon_sym_c_DQUOTE] = ACTIONS(4629),
    [anon_sym_r_SQUOTE] = ACTIONS(4629),
    [anon_sym_r_DQUOTE] = ACTIONS(4629),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4631),
    [anon_sym_shared] = ACTIONS(4631),
    [anon_sym_map_LBRACK] = ACTIONS(4629),
    [anon_sym_chan] = ACTIONS(4631),
    [anon_sym_thread] = ACTIONS(4631),
    [anon_sym_atomic] = ACTIONS(4631),
    [anon_sym_assert] = ACTIONS(4631),
    [anon_sym_defer] = ACTIONS(4631),
    [anon_sym_goto] = ACTIONS(4631),
    [anon_sym_break] = ACTIONS(4631),
    [anon_sym_continue] = ACTIONS(4631),
    [anon_sym_return] = ACTIONS(4631),
    [anon_sym_DOLLARfor] = ACTIONS(4631),
    [anon_sym_for] = ACTIONS(4631),
    [anon_sym_POUND] = ACTIONS(4629),
    [anon_sym_asm] = ACTIONS(4631),
    [anon_sym_AT_LBRACK] = ACTIONS(4629),
  },
  [1806] = {
    [sym_line_comment] = STATE(1806),
    [sym_block_comment] = STATE(1806),
    [ts_builtin_sym_end] = ACTIONS(3082),
    [sym_identifier] = ACTIONS(3084),
    [anon_sym_LF] = ACTIONS(3084),
    [anon_sym_CR] = ACTIONS(3084),
    [anon_sym_CR_LF] = ACTIONS(3084),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3084),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_const] = ACTIONS(3084),
    [anon_sym_LPAREN] = ACTIONS(3084),
    [anon_sym___global] = ACTIONS(3084),
    [anon_sym_type] = ACTIONS(3084),
    [anon_sym_fn] = ACTIONS(3084),
    [anon_sym_PLUS] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_struct] = ACTIONS(3084),
    [anon_sym_union] = ACTIONS(3084),
    [anon_sym_pub] = ACTIONS(3084),
    [anon_sym_mut] = ACTIONS(3084),
    [anon_sym_enum] = ACTIONS(3084),
    [anon_sym_interface] = ACTIONS(3084),
    [anon_sym_QMARK] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_go] = ACTIONS(3084),
    [anon_sym_spawn] = ACTIONS(3084),
    [anon_sym_json_DOTdecode] = ACTIONS(3084),
    [anon_sym_LBRACK2] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_CARET] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3084),
    [anon_sym_LT_DASH] = ACTIONS(3084),
    [sym_none] = ACTIONS(3084),
    [sym_true] = ACTIONS(3084),
    [sym_false] = ACTIONS(3084),
    [sym_nil] = ACTIONS(3084),
    [anon_sym_if] = ACTIONS(3084),
    [anon_sym_DOLLARif] = ACTIONS(3084),
    [anon_sym_match] = ACTIONS(3084),
    [anon_sym_select] = ACTIONS(3084),
    [anon_sym_lock] = ACTIONS(3084),
    [anon_sym_rlock] = ACTIONS(3084),
    [anon_sym_unsafe] = ACTIONS(3084),
    [anon_sym_sql] = ACTIONS(3084),
    [sym_int_literal] = ACTIONS(3084),
    [sym_float_literal] = ACTIONS(3084),
    [sym_rune_literal] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [anon_sym_c_SQUOTE] = ACTIONS(3084),
    [anon_sym_c_DQUOTE] = ACTIONS(3084),
    [anon_sym_r_SQUOTE] = ACTIONS(3084),
    [anon_sym_r_DQUOTE] = ACTIONS(3084),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3084),
    [anon_sym_shared] = ACTIONS(3084),
    [anon_sym_map_LBRACK] = ACTIONS(3084),
    [anon_sym_chan] = ACTIONS(3084),
    [anon_sym_thread] = ACTIONS(3084),
    [anon_sym_atomic] = ACTIONS(3084),
    [anon_sym_assert] = ACTIONS(3084),
    [anon_sym_defer] = ACTIONS(3084),
    [anon_sym_goto] = ACTIONS(3084),
    [anon_sym_break] = ACTIONS(3084),
    [anon_sym_continue] = ACTIONS(3084),
    [anon_sym_return] = ACTIONS(3084),
    [anon_sym_DOLLARfor] = ACTIONS(3084),
    [anon_sym_for] = ACTIONS(3084),
    [anon_sym_POUND] = ACTIONS(3084),
    [anon_sym_asm] = ACTIONS(3084),
    [anon_sym_AT_LBRACK] = ACTIONS(3084),
  },
  [1807] = {
    [sym_line_comment] = STATE(1807),
    [sym_block_comment] = STATE(1807),
    [ts_builtin_sym_end] = ACTIONS(3302),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_LF] = ACTIONS(3304),
    [anon_sym_CR] = ACTIONS(3304),
    [anon_sym_CR_LF] = ACTIONS(3304),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_const] = ACTIONS(3304),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym___global] = ACTIONS(3304),
    [anon_sym_type] = ACTIONS(3304),
    [anon_sym_fn] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_struct] = ACTIONS(3304),
    [anon_sym_union] = ACTIONS(3304),
    [anon_sym_pub] = ACTIONS(3304),
    [anon_sym_mut] = ACTIONS(3304),
    [anon_sym_enum] = ACTIONS(3304),
    [anon_sym_interface] = ACTIONS(3304),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_go] = ACTIONS(3304),
    [anon_sym_spawn] = ACTIONS(3304),
    [anon_sym_json_DOTdecode] = ACTIONS(3304),
    [anon_sym_LBRACK2] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LT_DASH] = ACTIONS(3304),
    [sym_none] = ACTIONS(3304),
    [sym_true] = ACTIONS(3304),
    [sym_false] = ACTIONS(3304),
    [sym_nil] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_DOLLARif] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_select] = ACTIONS(3304),
    [anon_sym_lock] = ACTIONS(3304),
    [anon_sym_rlock] = ACTIONS(3304),
    [anon_sym_unsafe] = ACTIONS(3304),
    [anon_sym_sql] = ACTIONS(3304),
    [sym_int_literal] = ACTIONS(3304),
    [sym_float_literal] = ACTIONS(3304),
    [sym_rune_literal] = ACTIONS(3304),
    [anon_sym_SQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_c_SQUOTE] = ACTIONS(3304),
    [anon_sym_c_DQUOTE] = ACTIONS(3304),
    [anon_sym_r_SQUOTE] = ACTIONS(3304),
    [anon_sym_r_DQUOTE] = ACTIONS(3304),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3304),
    [anon_sym_shared] = ACTIONS(3304),
    [anon_sym_map_LBRACK] = ACTIONS(3304),
    [anon_sym_chan] = ACTIONS(3304),
    [anon_sym_thread] = ACTIONS(3304),
    [anon_sym_atomic] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_defer] = ACTIONS(3304),
    [anon_sym_goto] = ACTIONS(3304),
    [anon_sym_break] = ACTIONS(3304),
    [anon_sym_continue] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_DOLLARfor] = ACTIONS(3304),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_POUND] = ACTIONS(3304),
    [anon_sym_asm] = ACTIONS(3304),
    [anon_sym_AT_LBRACK] = ACTIONS(3304),
  },
  [1808] = {
    [sym_line_comment] = STATE(1808),
    [sym_block_comment] = STATE(1808),
    [ts_builtin_sym_end] = ACTIONS(4633),
    [sym_identifier] = ACTIONS(4635),
    [anon_sym_LF] = ACTIONS(4635),
    [anon_sym_CR] = ACTIONS(4635),
    [anon_sym_CR_LF] = ACTIONS(4635),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4635),
    [anon_sym_LBRACE] = ACTIONS(4635),
    [anon_sym_const] = ACTIONS(4635),
    [anon_sym_LPAREN] = ACTIONS(4635),
    [anon_sym___global] = ACTIONS(4635),
    [anon_sym_type] = ACTIONS(4635),
    [anon_sym_fn] = ACTIONS(4635),
    [anon_sym_PLUS] = ACTIONS(4635),
    [anon_sym_DASH] = ACTIONS(4635),
    [anon_sym_STAR] = ACTIONS(4635),
    [anon_sym_struct] = ACTIONS(4635),
    [anon_sym_union] = ACTIONS(4635),
    [anon_sym_pub] = ACTIONS(4635),
    [anon_sym_mut] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4635),
    [anon_sym_interface] = ACTIONS(4635),
    [anon_sym_QMARK] = ACTIONS(4635),
    [anon_sym_BANG] = ACTIONS(4635),
    [anon_sym_go] = ACTIONS(4635),
    [anon_sym_spawn] = ACTIONS(4635),
    [anon_sym_json_DOTdecode] = ACTIONS(4635),
    [anon_sym_LBRACK2] = ACTIONS(4635),
    [anon_sym_TILDE] = ACTIONS(4635),
    [anon_sym_CARET] = ACTIONS(4635),
    [anon_sym_AMP] = ACTIONS(4635),
    [anon_sym_LT_DASH] = ACTIONS(4635),
    [sym_none] = ACTIONS(4635),
    [sym_true] = ACTIONS(4635),
    [sym_false] = ACTIONS(4635),
    [sym_nil] = ACTIONS(4635),
    [anon_sym_if] = ACTIONS(4635),
    [anon_sym_DOLLARif] = ACTIONS(4635),
    [anon_sym_match] = ACTIONS(4635),
    [anon_sym_select] = ACTIONS(4635),
    [anon_sym_lock] = ACTIONS(4635),
    [anon_sym_rlock] = ACTIONS(4635),
    [anon_sym_unsafe] = ACTIONS(4635),
    [anon_sym_sql] = ACTIONS(4635),
    [sym_int_literal] = ACTIONS(4635),
    [sym_float_literal] = ACTIONS(4635),
    [sym_rune_literal] = ACTIONS(4635),
    [anon_sym_SQUOTE] = ACTIONS(4635),
    [anon_sym_DQUOTE] = ACTIONS(4635),
    [anon_sym_c_SQUOTE] = ACTIONS(4635),
    [anon_sym_c_DQUOTE] = ACTIONS(4635),
    [anon_sym_r_SQUOTE] = ACTIONS(4635),
    [anon_sym_r_DQUOTE] = ACTIONS(4635),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4635),
    [anon_sym_shared] = ACTIONS(4635),
    [anon_sym_map_LBRACK] = ACTIONS(4635),
    [anon_sym_chan] = ACTIONS(4635),
    [anon_sym_thread] = ACTIONS(4635),
    [anon_sym_atomic] = ACTIONS(4635),
    [anon_sym_assert] = ACTIONS(4635),
    [anon_sym_defer] = ACTIONS(4635),
    [anon_sym_goto] = ACTIONS(4635),
    [anon_sym_break] = ACTIONS(4635),
    [anon_sym_continue] = ACTIONS(4635),
    [anon_sym_return] = ACTIONS(4635),
    [anon_sym_DOLLARfor] = ACTIONS(4635),
    [anon_sym_for] = ACTIONS(4635),
    [anon_sym_POUND] = ACTIONS(4635),
    [anon_sym_asm] = ACTIONS(4635),
    [anon_sym_AT_LBRACK] = ACTIONS(4635),
  },
  [1809] = {
    [sym_line_comment] = STATE(1809),
    [sym_block_comment] = STATE(1809),
    [ts_builtin_sym_end] = ACTIONS(2451),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LF] = ACTIONS(2453),
    [anon_sym_CR] = ACTIONS(2453),
    [anon_sym_CR_LF] = ACTIONS(2453),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym___global] = ACTIONS(2453),
    [anon_sym_type] = ACTIONS(2453),
    [anon_sym_fn] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [anon_sym_pub] = ACTIONS(2453),
    [anon_sym_mut] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_interface] = ACTIONS(2453),
    [anon_sym_QMARK] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(2453),
    [anon_sym_go] = ACTIONS(2453),
    [anon_sym_spawn] = ACTIONS(2453),
    [anon_sym_json_DOTdecode] = ACTIONS(2453),
    [anon_sym_LBRACK2] = ACTIONS(2453),
    [anon_sym_TILDE] = ACTIONS(2453),
    [anon_sym_CARET] = ACTIONS(2453),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_LT_DASH] = ACTIONS(2453),
    [sym_none] = ACTIONS(2453),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [sym_nil] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_DOLLARif] = ACTIONS(2453),
    [anon_sym_match] = ACTIONS(2453),
    [anon_sym_select] = ACTIONS(2453),
    [anon_sym_lock] = ACTIONS(2453),
    [anon_sym_rlock] = ACTIONS(2453),
    [anon_sym_unsafe] = ACTIONS(2453),
    [anon_sym_sql] = ACTIONS(2453),
    [sym_int_literal] = ACTIONS(2453),
    [sym_float_literal] = ACTIONS(2453),
    [sym_rune_literal] = ACTIONS(2453),
    [anon_sym_SQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2453),
    [anon_sym_c_SQUOTE] = ACTIONS(2453),
    [anon_sym_c_DQUOTE] = ACTIONS(2453),
    [anon_sym_r_SQUOTE] = ACTIONS(2453),
    [anon_sym_r_DQUOTE] = ACTIONS(2453),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_map_LBRACK] = ACTIONS(2453),
    [anon_sym_chan] = ACTIONS(2453),
    [anon_sym_thread] = ACTIONS(2453),
    [anon_sym_atomic] = ACTIONS(2453),
    [anon_sym_assert] = ACTIONS(2453),
    [anon_sym_defer] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_DOLLARfor] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_POUND] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
    [anon_sym_AT_LBRACK] = ACTIONS(2453),
  },
  [1810] = {
    [sym_line_comment] = STATE(1810),
    [sym_block_comment] = STATE(1810),
    [ts_builtin_sym_end] = ACTIONS(4637),
    [sym_identifier] = ACTIONS(4639),
    [anon_sym_LF] = ACTIONS(4639),
    [anon_sym_CR] = ACTIONS(4639),
    [anon_sym_CR_LF] = ACTIONS(4639),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4639),
    [anon_sym_LBRACE] = ACTIONS(4639),
    [anon_sym_const] = ACTIONS(4639),
    [anon_sym_LPAREN] = ACTIONS(4639),
    [anon_sym___global] = ACTIONS(4639),
    [anon_sym_type] = ACTIONS(4639),
    [anon_sym_fn] = ACTIONS(4639),
    [anon_sym_PLUS] = ACTIONS(4639),
    [anon_sym_DASH] = ACTIONS(4639),
    [anon_sym_STAR] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4639),
    [anon_sym_union] = ACTIONS(4639),
    [anon_sym_pub] = ACTIONS(4639),
    [anon_sym_mut] = ACTIONS(4639),
    [anon_sym_enum] = ACTIONS(4639),
    [anon_sym_interface] = ACTIONS(4639),
    [anon_sym_QMARK] = ACTIONS(4639),
    [anon_sym_BANG] = ACTIONS(4639),
    [anon_sym_go] = ACTIONS(4639),
    [anon_sym_spawn] = ACTIONS(4639),
    [anon_sym_json_DOTdecode] = ACTIONS(4639),
    [anon_sym_LBRACK2] = ACTIONS(4639),
    [anon_sym_TILDE] = ACTIONS(4639),
    [anon_sym_CARET] = ACTIONS(4639),
    [anon_sym_AMP] = ACTIONS(4639),
    [anon_sym_LT_DASH] = ACTIONS(4639),
    [sym_none] = ACTIONS(4639),
    [sym_true] = ACTIONS(4639),
    [sym_false] = ACTIONS(4639),
    [sym_nil] = ACTIONS(4639),
    [anon_sym_if] = ACTIONS(4639),
    [anon_sym_DOLLARif] = ACTIONS(4639),
    [anon_sym_match] = ACTIONS(4639),
    [anon_sym_select] = ACTIONS(4639),
    [anon_sym_lock] = ACTIONS(4639),
    [anon_sym_rlock] = ACTIONS(4639),
    [anon_sym_unsafe] = ACTIONS(4639),
    [anon_sym_sql] = ACTIONS(4639),
    [sym_int_literal] = ACTIONS(4639),
    [sym_float_literal] = ACTIONS(4639),
    [sym_rune_literal] = ACTIONS(4639),
    [anon_sym_SQUOTE] = ACTIONS(4639),
    [anon_sym_DQUOTE] = ACTIONS(4639),
    [anon_sym_c_SQUOTE] = ACTIONS(4639),
    [anon_sym_c_DQUOTE] = ACTIONS(4639),
    [anon_sym_r_SQUOTE] = ACTIONS(4639),
    [anon_sym_r_DQUOTE] = ACTIONS(4639),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4639),
    [anon_sym_shared] = ACTIONS(4639),
    [anon_sym_map_LBRACK] = ACTIONS(4639),
    [anon_sym_chan] = ACTIONS(4639),
    [anon_sym_thread] = ACTIONS(4639),
    [anon_sym_atomic] = ACTIONS(4639),
    [anon_sym_assert] = ACTIONS(4639),
    [anon_sym_defer] = ACTIONS(4639),
    [anon_sym_goto] = ACTIONS(4639),
    [anon_sym_break] = ACTIONS(4639),
    [anon_sym_continue] = ACTIONS(4639),
    [anon_sym_return] = ACTIONS(4639),
    [anon_sym_DOLLARfor] = ACTIONS(4639),
    [anon_sym_for] = ACTIONS(4639),
    [anon_sym_POUND] = ACTIONS(4639),
    [anon_sym_asm] = ACTIONS(4639),
    [anon_sym_AT_LBRACK] = ACTIONS(4639),
  },
  [1811] = {
    [sym_line_comment] = STATE(1811),
    [sym_block_comment] = STATE(1811),
    [ts_builtin_sym_end] = ACTIONS(3025),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_LF] = ACTIONS(3027),
    [anon_sym_CR] = ACTIONS(3027),
    [anon_sym_CR_LF] = ACTIONS(3027),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3027),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_const] = ACTIONS(3027),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym___global] = ACTIONS(3027),
    [anon_sym_type] = ACTIONS(3027),
    [anon_sym_fn] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_STAR] = ACTIONS(3027),
    [anon_sym_struct] = ACTIONS(3027),
    [anon_sym_union] = ACTIONS(3027),
    [anon_sym_pub] = ACTIONS(3027),
    [anon_sym_mut] = ACTIONS(3027),
    [anon_sym_enum] = ACTIONS(3027),
    [anon_sym_interface] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_BANG] = ACTIONS(3027),
    [anon_sym_go] = ACTIONS(3027),
    [anon_sym_spawn] = ACTIONS(3027),
    [anon_sym_json_DOTdecode] = ACTIONS(3027),
    [anon_sym_LBRACK2] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3027),
    [anon_sym_CARET] = ACTIONS(3027),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_LT_DASH] = ACTIONS(3027),
    [sym_none] = ACTIONS(3027),
    [sym_true] = ACTIONS(3027),
    [sym_false] = ACTIONS(3027),
    [sym_nil] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_DOLLARif] = ACTIONS(3027),
    [anon_sym_match] = ACTIONS(3027),
    [anon_sym_select] = ACTIONS(3027),
    [anon_sym_lock] = ACTIONS(3027),
    [anon_sym_rlock] = ACTIONS(3027),
    [anon_sym_unsafe] = ACTIONS(3027),
    [anon_sym_sql] = ACTIONS(3027),
    [sym_int_literal] = ACTIONS(3027),
    [sym_float_literal] = ACTIONS(3027),
    [sym_rune_literal] = ACTIONS(3027),
    [anon_sym_SQUOTE] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_c_SQUOTE] = ACTIONS(3027),
    [anon_sym_c_DQUOTE] = ACTIONS(3027),
    [anon_sym_r_SQUOTE] = ACTIONS(3027),
    [anon_sym_r_DQUOTE] = ACTIONS(3027),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3027),
    [anon_sym_shared] = ACTIONS(3027),
    [anon_sym_map_LBRACK] = ACTIONS(3027),
    [anon_sym_chan] = ACTIONS(3027),
    [anon_sym_thread] = ACTIONS(3027),
    [anon_sym_atomic] = ACTIONS(3027),
    [anon_sym_assert] = ACTIONS(3027),
    [anon_sym_defer] = ACTIONS(3027),
    [anon_sym_goto] = ACTIONS(3027),
    [anon_sym_break] = ACTIONS(3027),
    [anon_sym_continue] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_DOLLARfor] = ACTIONS(3027),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_POUND] = ACTIONS(3027),
    [anon_sym_asm] = ACTIONS(3027),
    [anon_sym_AT_LBRACK] = ACTIONS(3027),
  },
  [1812] = {
    [sym_line_comment] = STATE(1812),
    [sym_block_comment] = STATE(1812),
    [ts_builtin_sym_end] = ACTIONS(4641),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LF] = ACTIONS(4643),
    [anon_sym_CR] = ACTIONS(4643),
    [anon_sym_CR_LF] = ACTIONS(4643),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4643),
    [anon_sym_LBRACE] = ACTIONS(4643),
    [anon_sym_const] = ACTIONS(4643),
    [anon_sym_LPAREN] = ACTIONS(4643),
    [anon_sym___global] = ACTIONS(4643),
    [anon_sym_type] = ACTIONS(4643),
    [anon_sym_fn] = ACTIONS(4643),
    [anon_sym_PLUS] = ACTIONS(4643),
    [anon_sym_DASH] = ACTIONS(4643),
    [anon_sym_STAR] = ACTIONS(4643),
    [anon_sym_struct] = ACTIONS(4643),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_pub] = ACTIONS(4643),
    [anon_sym_mut] = ACTIONS(4643),
    [anon_sym_enum] = ACTIONS(4643),
    [anon_sym_interface] = ACTIONS(4643),
    [anon_sym_QMARK] = ACTIONS(4643),
    [anon_sym_BANG] = ACTIONS(4643),
    [anon_sym_go] = ACTIONS(4643),
    [anon_sym_spawn] = ACTIONS(4643),
    [anon_sym_json_DOTdecode] = ACTIONS(4643),
    [anon_sym_LBRACK2] = ACTIONS(4643),
    [anon_sym_TILDE] = ACTIONS(4643),
    [anon_sym_CARET] = ACTIONS(4643),
    [anon_sym_AMP] = ACTIONS(4643),
    [anon_sym_LT_DASH] = ACTIONS(4643),
    [sym_none] = ACTIONS(4643),
    [sym_true] = ACTIONS(4643),
    [sym_false] = ACTIONS(4643),
    [sym_nil] = ACTIONS(4643),
    [anon_sym_if] = ACTIONS(4643),
    [anon_sym_DOLLARif] = ACTIONS(4643),
    [anon_sym_match] = ACTIONS(4643),
    [anon_sym_select] = ACTIONS(4643),
    [anon_sym_lock] = ACTIONS(4643),
    [anon_sym_rlock] = ACTIONS(4643),
    [anon_sym_unsafe] = ACTIONS(4643),
    [anon_sym_sql] = ACTIONS(4643),
    [sym_int_literal] = ACTIONS(4643),
    [sym_float_literal] = ACTIONS(4643),
    [sym_rune_literal] = ACTIONS(4643),
    [anon_sym_SQUOTE] = ACTIONS(4643),
    [anon_sym_DQUOTE] = ACTIONS(4643),
    [anon_sym_c_SQUOTE] = ACTIONS(4643),
    [anon_sym_c_DQUOTE] = ACTIONS(4643),
    [anon_sym_r_SQUOTE] = ACTIONS(4643),
    [anon_sym_r_DQUOTE] = ACTIONS(4643),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4643),
    [anon_sym_shared] = ACTIONS(4643),
    [anon_sym_map_LBRACK] = ACTIONS(4643),
    [anon_sym_chan] = ACTIONS(4643),
    [anon_sym_thread] = ACTIONS(4643),
    [anon_sym_atomic] = ACTIONS(4643),
    [anon_sym_assert] = ACTIONS(4643),
    [anon_sym_defer] = ACTIONS(4643),
    [anon_sym_goto] = ACTIONS(4643),
    [anon_sym_break] = ACTIONS(4643),
    [anon_sym_continue] = ACTIONS(4643),
    [anon_sym_return] = ACTIONS(4643),
    [anon_sym_DOLLARfor] = ACTIONS(4643),
    [anon_sym_for] = ACTIONS(4643),
    [anon_sym_POUND] = ACTIONS(4643),
    [anon_sym_asm] = ACTIONS(4643),
    [anon_sym_AT_LBRACK] = ACTIONS(4643),
  },
  [1813] = {
    [sym_line_comment] = STATE(1813),
    [sym_block_comment] = STATE(1813),
    [ts_builtin_sym_end] = ACTIONS(4645),
    [sym_identifier] = ACTIONS(4647),
    [anon_sym_LF] = ACTIONS(4647),
    [anon_sym_CR] = ACTIONS(4647),
    [anon_sym_CR_LF] = ACTIONS(4647),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4647),
    [anon_sym_LBRACE] = ACTIONS(4647),
    [anon_sym_const] = ACTIONS(4647),
    [anon_sym_LPAREN] = ACTIONS(4647),
    [anon_sym___global] = ACTIONS(4647),
    [anon_sym_type] = ACTIONS(4647),
    [anon_sym_fn] = ACTIONS(4647),
    [anon_sym_PLUS] = ACTIONS(4647),
    [anon_sym_DASH] = ACTIONS(4647),
    [anon_sym_STAR] = ACTIONS(4647),
    [anon_sym_struct] = ACTIONS(4647),
    [anon_sym_union] = ACTIONS(4647),
    [anon_sym_pub] = ACTIONS(4647),
    [anon_sym_mut] = ACTIONS(4647),
    [anon_sym_enum] = ACTIONS(4647),
    [anon_sym_interface] = ACTIONS(4647),
    [anon_sym_QMARK] = ACTIONS(4647),
    [anon_sym_BANG] = ACTIONS(4647),
    [anon_sym_go] = ACTIONS(4647),
    [anon_sym_spawn] = ACTIONS(4647),
    [anon_sym_json_DOTdecode] = ACTIONS(4647),
    [anon_sym_LBRACK2] = ACTIONS(4647),
    [anon_sym_TILDE] = ACTIONS(4647),
    [anon_sym_CARET] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(4647),
    [anon_sym_LT_DASH] = ACTIONS(4647),
    [sym_none] = ACTIONS(4647),
    [sym_true] = ACTIONS(4647),
    [sym_false] = ACTIONS(4647),
    [sym_nil] = ACTIONS(4647),
    [anon_sym_if] = ACTIONS(4647),
    [anon_sym_DOLLARif] = ACTIONS(4647),
    [anon_sym_match] = ACTIONS(4647),
    [anon_sym_select] = ACTIONS(4647),
    [anon_sym_lock] = ACTIONS(4647),
    [anon_sym_rlock] = ACTIONS(4647),
    [anon_sym_unsafe] = ACTIONS(4647),
    [anon_sym_sql] = ACTIONS(4647),
    [sym_int_literal] = ACTIONS(4647),
    [sym_float_literal] = ACTIONS(4647),
    [sym_rune_literal] = ACTIONS(4647),
    [anon_sym_SQUOTE] = ACTIONS(4647),
    [anon_sym_DQUOTE] = ACTIONS(4647),
    [anon_sym_c_SQUOTE] = ACTIONS(4647),
    [anon_sym_c_DQUOTE] = ACTIONS(4647),
    [anon_sym_r_SQUOTE] = ACTIONS(4647),
    [anon_sym_r_DQUOTE] = ACTIONS(4647),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4647),
    [anon_sym_shared] = ACTIONS(4647),
    [anon_sym_map_LBRACK] = ACTIONS(4647),
    [anon_sym_chan] = ACTIONS(4647),
    [anon_sym_thread] = ACTIONS(4647),
    [anon_sym_atomic] = ACTIONS(4647),
    [anon_sym_assert] = ACTIONS(4647),
    [anon_sym_defer] = ACTIONS(4647),
    [anon_sym_goto] = ACTIONS(4647),
    [anon_sym_break] = ACTIONS(4647),
    [anon_sym_continue] = ACTIONS(4647),
    [anon_sym_return] = ACTIONS(4647),
    [anon_sym_DOLLARfor] = ACTIONS(4647),
    [anon_sym_for] = ACTIONS(4647),
    [anon_sym_POUND] = ACTIONS(4647),
    [anon_sym_asm] = ACTIONS(4647),
    [anon_sym_AT_LBRACK] = ACTIONS(4647),
  },
  [1814] = {
    [sym_line_comment] = STATE(1814),
    [sym_block_comment] = STATE(1814),
    [ts_builtin_sym_end] = ACTIONS(4649),
    [sym_identifier] = ACTIONS(4651),
    [anon_sym_LF] = ACTIONS(4651),
    [anon_sym_CR] = ACTIONS(4651),
    [anon_sym_CR_LF] = ACTIONS(4651),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4651),
    [anon_sym_LBRACE] = ACTIONS(4651),
    [anon_sym_const] = ACTIONS(4651),
    [anon_sym_LPAREN] = ACTIONS(4651),
    [anon_sym___global] = ACTIONS(4651),
    [anon_sym_type] = ACTIONS(4651),
    [anon_sym_fn] = ACTIONS(4651),
    [anon_sym_PLUS] = ACTIONS(4651),
    [anon_sym_DASH] = ACTIONS(4651),
    [anon_sym_STAR] = ACTIONS(4651),
    [anon_sym_struct] = ACTIONS(4651),
    [anon_sym_union] = ACTIONS(4651),
    [anon_sym_pub] = ACTIONS(4651),
    [anon_sym_mut] = ACTIONS(4651),
    [anon_sym_enum] = ACTIONS(4651),
    [anon_sym_interface] = ACTIONS(4651),
    [anon_sym_QMARK] = ACTIONS(4651),
    [anon_sym_BANG] = ACTIONS(4651),
    [anon_sym_go] = ACTIONS(4651),
    [anon_sym_spawn] = ACTIONS(4651),
    [anon_sym_json_DOTdecode] = ACTIONS(4651),
    [anon_sym_LBRACK2] = ACTIONS(4651),
    [anon_sym_TILDE] = ACTIONS(4651),
    [anon_sym_CARET] = ACTIONS(4651),
    [anon_sym_AMP] = ACTIONS(4651),
    [anon_sym_LT_DASH] = ACTIONS(4651),
    [sym_none] = ACTIONS(4651),
    [sym_true] = ACTIONS(4651),
    [sym_false] = ACTIONS(4651),
    [sym_nil] = ACTIONS(4651),
    [anon_sym_if] = ACTIONS(4651),
    [anon_sym_DOLLARif] = ACTIONS(4651),
    [anon_sym_match] = ACTIONS(4651),
    [anon_sym_select] = ACTIONS(4651),
    [anon_sym_lock] = ACTIONS(4651),
    [anon_sym_rlock] = ACTIONS(4651),
    [anon_sym_unsafe] = ACTIONS(4651),
    [anon_sym_sql] = ACTIONS(4651),
    [sym_int_literal] = ACTIONS(4651),
    [sym_float_literal] = ACTIONS(4651),
    [sym_rune_literal] = ACTIONS(4651),
    [anon_sym_SQUOTE] = ACTIONS(4651),
    [anon_sym_DQUOTE] = ACTIONS(4651),
    [anon_sym_c_SQUOTE] = ACTIONS(4651),
    [anon_sym_c_DQUOTE] = ACTIONS(4651),
    [anon_sym_r_SQUOTE] = ACTIONS(4651),
    [anon_sym_r_DQUOTE] = ACTIONS(4651),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4651),
    [anon_sym_shared] = ACTIONS(4651),
    [anon_sym_map_LBRACK] = ACTIONS(4651),
    [anon_sym_chan] = ACTIONS(4651),
    [anon_sym_thread] = ACTIONS(4651),
    [anon_sym_atomic] = ACTIONS(4651),
    [anon_sym_assert] = ACTIONS(4651),
    [anon_sym_defer] = ACTIONS(4651),
    [anon_sym_goto] = ACTIONS(4651),
    [anon_sym_break] = ACTIONS(4651),
    [anon_sym_continue] = ACTIONS(4651),
    [anon_sym_return] = ACTIONS(4651),
    [anon_sym_DOLLARfor] = ACTIONS(4651),
    [anon_sym_for] = ACTIONS(4651),
    [anon_sym_POUND] = ACTIONS(4651),
    [anon_sym_asm] = ACTIONS(4651),
    [anon_sym_AT_LBRACK] = ACTIONS(4651),
  },
  [1815] = {
    [sym_line_comment] = STATE(1815),
    [sym_block_comment] = STATE(1815),
    [ts_builtin_sym_end] = ACTIONS(4653),
    [sym_identifier] = ACTIONS(4655),
    [anon_sym_LF] = ACTIONS(4655),
    [anon_sym_CR] = ACTIONS(4655),
    [anon_sym_CR_LF] = ACTIONS(4655),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4655),
    [anon_sym_LBRACE] = ACTIONS(4655),
    [anon_sym_const] = ACTIONS(4655),
    [anon_sym_LPAREN] = ACTIONS(4655),
    [anon_sym___global] = ACTIONS(4655),
    [anon_sym_type] = ACTIONS(4655),
    [anon_sym_fn] = ACTIONS(4655),
    [anon_sym_PLUS] = ACTIONS(4655),
    [anon_sym_DASH] = ACTIONS(4655),
    [anon_sym_STAR] = ACTIONS(4655),
    [anon_sym_struct] = ACTIONS(4655),
    [anon_sym_union] = ACTIONS(4655),
    [anon_sym_pub] = ACTIONS(4655),
    [anon_sym_mut] = ACTIONS(4655),
    [anon_sym_enum] = ACTIONS(4655),
    [anon_sym_interface] = ACTIONS(4655),
    [anon_sym_QMARK] = ACTIONS(4655),
    [anon_sym_BANG] = ACTIONS(4655),
    [anon_sym_go] = ACTIONS(4655),
    [anon_sym_spawn] = ACTIONS(4655),
    [anon_sym_json_DOTdecode] = ACTIONS(4655),
    [anon_sym_LBRACK2] = ACTIONS(4655),
    [anon_sym_TILDE] = ACTIONS(4655),
    [anon_sym_CARET] = ACTIONS(4655),
    [anon_sym_AMP] = ACTIONS(4655),
    [anon_sym_LT_DASH] = ACTIONS(4655),
    [sym_none] = ACTIONS(4655),
    [sym_true] = ACTIONS(4655),
    [sym_false] = ACTIONS(4655),
    [sym_nil] = ACTIONS(4655),
    [anon_sym_if] = ACTIONS(4655),
    [anon_sym_DOLLARif] = ACTIONS(4655),
    [anon_sym_match] = ACTIONS(4655),
    [anon_sym_select] = ACTIONS(4655),
    [anon_sym_lock] = ACTIONS(4655),
    [anon_sym_rlock] = ACTIONS(4655),
    [anon_sym_unsafe] = ACTIONS(4655),
    [anon_sym_sql] = ACTIONS(4655),
    [sym_int_literal] = ACTIONS(4655),
    [sym_float_literal] = ACTIONS(4655),
    [sym_rune_literal] = ACTIONS(4655),
    [anon_sym_SQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4655),
    [anon_sym_c_SQUOTE] = ACTIONS(4655),
    [anon_sym_c_DQUOTE] = ACTIONS(4655),
    [anon_sym_r_SQUOTE] = ACTIONS(4655),
    [anon_sym_r_DQUOTE] = ACTIONS(4655),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4655),
    [anon_sym_shared] = ACTIONS(4655),
    [anon_sym_map_LBRACK] = ACTIONS(4655),
    [anon_sym_chan] = ACTIONS(4655),
    [anon_sym_thread] = ACTIONS(4655),
    [anon_sym_atomic] = ACTIONS(4655),
    [anon_sym_assert] = ACTIONS(4655),
    [anon_sym_defer] = ACTIONS(4655),
    [anon_sym_goto] = ACTIONS(4655),
    [anon_sym_break] = ACTIONS(4655),
    [anon_sym_continue] = ACTIONS(4655),
    [anon_sym_return] = ACTIONS(4655),
    [anon_sym_DOLLARfor] = ACTIONS(4655),
    [anon_sym_for] = ACTIONS(4655),
    [anon_sym_POUND] = ACTIONS(4655),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym_AT_LBRACK] = ACTIONS(4655),
  },
  [1816] = {
    [sym_line_comment] = STATE(1816),
    [sym_block_comment] = STATE(1816),
    [ts_builtin_sym_end] = ACTIONS(4657),
    [sym_identifier] = ACTIONS(4659),
    [anon_sym_LF] = ACTIONS(4659),
    [anon_sym_CR] = ACTIONS(4659),
    [anon_sym_CR_LF] = ACTIONS(4659),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4659),
    [anon_sym_LBRACE] = ACTIONS(4659),
    [anon_sym_const] = ACTIONS(4659),
    [anon_sym_LPAREN] = ACTIONS(4659),
    [anon_sym___global] = ACTIONS(4659),
    [anon_sym_type] = ACTIONS(4659),
    [anon_sym_fn] = ACTIONS(4659),
    [anon_sym_PLUS] = ACTIONS(4659),
    [anon_sym_DASH] = ACTIONS(4659),
    [anon_sym_STAR] = ACTIONS(4659),
    [anon_sym_struct] = ACTIONS(4659),
    [anon_sym_union] = ACTIONS(4659),
    [anon_sym_pub] = ACTIONS(4659),
    [anon_sym_mut] = ACTIONS(4659),
    [anon_sym_enum] = ACTIONS(4659),
    [anon_sym_interface] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4659),
    [anon_sym_BANG] = ACTIONS(4659),
    [anon_sym_go] = ACTIONS(4659),
    [anon_sym_spawn] = ACTIONS(4659),
    [anon_sym_json_DOTdecode] = ACTIONS(4659),
    [anon_sym_LBRACK2] = ACTIONS(4659),
    [anon_sym_TILDE] = ACTIONS(4659),
    [anon_sym_CARET] = ACTIONS(4659),
    [anon_sym_AMP] = ACTIONS(4659),
    [anon_sym_LT_DASH] = ACTIONS(4659),
    [sym_none] = ACTIONS(4659),
    [sym_true] = ACTIONS(4659),
    [sym_false] = ACTIONS(4659),
    [sym_nil] = ACTIONS(4659),
    [anon_sym_if] = ACTIONS(4659),
    [anon_sym_DOLLARif] = ACTIONS(4659),
    [anon_sym_match] = ACTIONS(4659),
    [anon_sym_select] = ACTIONS(4659),
    [anon_sym_lock] = ACTIONS(4659),
    [anon_sym_rlock] = ACTIONS(4659),
    [anon_sym_unsafe] = ACTIONS(4659),
    [anon_sym_sql] = ACTIONS(4659),
    [sym_int_literal] = ACTIONS(4659),
    [sym_float_literal] = ACTIONS(4659),
    [sym_rune_literal] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_DQUOTE] = ACTIONS(4659),
    [anon_sym_c_SQUOTE] = ACTIONS(4659),
    [anon_sym_c_DQUOTE] = ACTIONS(4659),
    [anon_sym_r_SQUOTE] = ACTIONS(4659),
    [anon_sym_r_DQUOTE] = ACTIONS(4659),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4659),
    [anon_sym_shared] = ACTIONS(4659),
    [anon_sym_map_LBRACK] = ACTIONS(4659),
    [anon_sym_chan] = ACTIONS(4659),
    [anon_sym_thread] = ACTIONS(4659),
    [anon_sym_atomic] = ACTIONS(4659),
    [anon_sym_assert] = ACTIONS(4659),
    [anon_sym_defer] = ACTIONS(4659),
    [anon_sym_goto] = ACTIONS(4659),
    [anon_sym_break] = ACTIONS(4659),
    [anon_sym_continue] = ACTIONS(4659),
    [anon_sym_return] = ACTIONS(4659),
    [anon_sym_DOLLARfor] = ACTIONS(4659),
    [anon_sym_for] = ACTIONS(4659),
    [anon_sym_POUND] = ACTIONS(4659),
    [anon_sym_asm] = ACTIONS(4659),
    [anon_sym_AT_LBRACK] = ACTIONS(4659),
  },
  [1817] = {
    [sym_line_comment] = STATE(1817),
    [sym_block_comment] = STATE(1817),
    [ts_builtin_sym_end] = ACTIONS(4661),
    [sym_identifier] = ACTIONS(4663),
    [anon_sym_LF] = ACTIONS(4663),
    [anon_sym_CR] = ACTIONS(4663),
    [anon_sym_CR_LF] = ACTIONS(4663),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4663),
    [anon_sym_LBRACE] = ACTIONS(4663),
    [anon_sym_const] = ACTIONS(4663),
    [anon_sym_LPAREN] = ACTIONS(4663),
    [anon_sym___global] = ACTIONS(4663),
    [anon_sym_type] = ACTIONS(4663),
    [anon_sym_fn] = ACTIONS(4663),
    [anon_sym_PLUS] = ACTIONS(4663),
    [anon_sym_DASH] = ACTIONS(4663),
    [anon_sym_STAR] = ACTIONS(4663),
    [anon_sym_struct] = ACTIONS(4663),
    [anon_sym_union] = ACTIONS(4663),
    [anon_sym_pub] = ACTIONS(4663),
    [anon_sym_mut] = ACTIONS(4663),
    [anon_sym_enum] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4663),
    [anon_sym_QMARK] = ACTIONS(4663),
    [anon_sym_BANG] = ACTIONS(4663),
    [anon_sym_go] = ACTIONS(4663),
    [anon_sym_spawn] = ACTIONS(4663),
    [anon_sym_json_DOTdecode] = ACTIONS(4663),
    [anon_sym_LBRACK2] = ACTIONS(4663),
    [anon_sym_TILDE] = ACTIONS(4663),
    [anon_sym_CARET] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4663),
    [anon_sym_LT_DASH] = ACTIONS(4663),
    [sym_none] = ACTIONS(4663),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [sym_nil] = ACTIONS(4663),
    [anon_sym_if] = ACTIONS(4663),
    [anon_sym_DOLLARif] = ACTIONS(4663),
    [anon_sym_match] = ACTIONS(4663),
    [anon_sym_select] = ACTIONS(4663),
    [anon_sym_lock] = ACTIONS(4663),
    [anon_sym_rlock] = ACTIONS(4663),
    [anon_sym_unsafe] = ACTIONS(4663),
    [anon_sym_sql] = ACTIONS(4663),
    [sym_int_literal] = ACTIONS(4663),
    [sym_float_literal] = ACTIONS(4663),
    [sym_rune_literal] = ACTIONS(4663),
    [anon_sym_SQUOTE] = ACTIONS(4663),
    [anon_sym_DQUOTE] = ACTIONS(4663),
    [anon_sym_c_SQUOTE] = ACTIONS(4663),
    [anon_sym_c_DQUOTE] = ACTIONS(4663),
    [anon_sym_r_SQUOTE] = ACTIONS(4663),
    [anon_sym_r_DQUOTE] = ACTIONS(4663),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4663),
    [anon_sym_shared] = ACTIONS(4663),
    [anon_sym_map_LBRACK] = ACTIONS(4663),
    [anon_sym_chan] = ACTIONS(4663),
    [anon_sym_thread] = ACTIONS(4663),
    [anon_sym_atomic] = ACTIONS(4663),
    [anon_sym_assert] = ACTIONS(4663),
    [anon_sym_defer] = ACTIONS(4663),
    [anon_sym_goto] = ACTIONS(4663),
    [anon_sym_break] = ACTIONS(4663),
    [anon_sym_continue] = ACTIONS(4663),
    [anon_sym_return] = ACTIONS(4663),
    [anon_sym_DOLLARfor] = ACTIONS(4663),
    [anon_sym_for] = ACTIONS(4663),
    [anon_sym_POUND] = ACTIONS(4663),
    [anon_sym_asm] = ACTIONS(4663),
    [anon_sym_AT_LBRACK] = ACTIONS(4663),
  },
  [1818] = {
    [sym_line_comment] = STATE(1818),
    [sym_block_comment] = STATE(1818),
    [ts_builtin_sym_end] = ACTIONS(4665),
    [sym_identifier] = ACTIONS(4667),
    [anon_sym_LF] = ACTIONS(4667),
    [anon_sym_CR] = ACTIONS(4667),
    [anon_sym_CR_LF] = ACTIONS(4667),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4667),
    [anon_sym_LBRACE] = ACTIONS(4667),
    [anon_sym_const] = ACTIONS(4667),
    [anon_sym_LPAREN] = ACTIONS(4667),
    [anon_sym___global] = ACTIONS(4667),
    [anon_sym_type] = ACTIONS(4667),
    [anon_sym_fn] = ACTIONS(4667),
    [anon_sym_PLUS] = ACTIONS(4667),
    [anon_sym_DASH] = ACTIONS(4667),
    [anon_sym_STAR] = ACTIONS(4667),
    [anon_sym_struct] = ACTIONS(4667),
    [anon_sym_union] = ACTIONS(4667),
    [anon_sym_pub] = ACTIONS(4667),
    [anon_sym_mut] = ACTIONS(4667),
    [anon_sym_enum] = ACTIONS(4667),
    [anon_sym_interface] = ACTIONS(4667),
    [anon_sym_QMARK] = ACTIONS(4667),
    [anon_sym_BANG] = ACTIONS(4667),
    [anon_sym_go] = ACTIONS(4667),
    [anon_sym_spawn] = ACTIONS(4667),
    [anon_sym_json_DOTdecode] = ACTIONS(4667),
    [anon_sym_LBRACK2] = ACTIONS(4667),
    [anon_sym_TILDE] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4667),
    [anon_sym_AMP] = ACTIONS(4667),
    [anon_sym_LT_DASH] = ACTIONS(4667),
    [sym_none] = ACTIONS(4667),
    [sym_true] = ACTIONS(4667),
    [sym_false] = ACTIONS(4667),
    [sym_nil] = ACTIONS(4667),
    [anon_sym_if] = ACTIONS(4667),
    [anon_sym_DOLLARif] = ACTIONS(4667),
    [anon_sym_match] = ACTIONS(4667),
    [anon_sym_select] = ACTIONS(4667),
    [anon_sym_lock] = ACTIONS(4667),
    [anon_sym_rlock] = ACTIONS(4667),
    [anon_sym_unsafe] = ACTIONS(4667),
    [anon_sym_sql] = ACTIONS(4667),
    [sym_int_literal] = ACTIONS(4667),
    [sym_float_literal] = ACTIONS(4667),
    [sym_rune_literal] = ACTIONS(4667),
    [anon_sym_SQUOTE] = ACTIONS(4667),
    [anon_sym_DQUOTE] = ACTIONS(4667),
    [anon_sym_c_SQUOTE] = ACTIONS(4667),
    [anon_sym_c_DQUOTE] = ACTIONS(4667),
    [anon_sym_r_SQUOTE] = ACTIONS(4667),
    [anon_sym_r_DQUOTE] = ACTIONS(4667),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4667),
    [anon_sym_shared] = ACTIONS(4667),
    [anon_sym_map_LBRACK] = ACTIONS(4667),
    [anon_sym_chan] = ACTIONS(4667),
    [anon_sym_thread] = ACTIONS(4667),
    [anon_sym_atomic] = ACTIONS(4667),
    [anon_sym_assert] = ACTIONS(4667),
    [anon_sym_defer] = ACTIONS(4667),
    [anon_sym_goto] = ACTIONS(4667),
    [anon_sym_break] = ACTIONS(4667),
    [anon_sym_continue] = ACTIONS(4667),
    [anon_sym_return] = ACTIONS(4667),
    [anon_sym_DOLLARfor] = ACTIONS(4667),
    [anon_sym_for] = ACTIONS(4667),
    [anon_sym_POUND] = ACTIONS(4667),
    [anon_sym_asm] = ACTIONS(4667),
    [anon_sym_AT_LBRACK] = ACTIONS(4667),
  },
  [1819] = {
    [sym_line_comment] = STATE(1819),
    [sym_block_comment] = STATE(1819),
    [ts_builtin_sym_end] = ACTIONS(3294),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_LF] = ACTIONS(3296),
    [anon_sym_CR] = ACTIONS(3296),
    [anon_sym_CR_LF] = ACTIONS(3296),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3296),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_const] = ACTIONS(3296),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym___global] = ACTIONS(3296),
    [anon_sym_type] = ACTIONS(3296),
    [anon_sym_fn] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_struct] = ACTIONS(3296),
    [anon_sym_union] = ACTIONS(3296),
    [anon_sym_pub] = ACTIONS(3296),
    [anon_sym_mut] = ACTIONS(3296),
    [anon_sym_enum] = ACTIONS(3296),
    [anon_sym_interface] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3296),
    [anon_sym_BANG] = ACTIONS(3296),
    [anon_sym_go] = ACTIONS(3296),
    [anon_sym_spawn] = ACTIONS(3296),
    [anon_sym_json_DOTdecode] = ACTIONS(3296),
    [anon_sym_LBRACK2] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3296),
    [anon_sym_CARET] = ACTIONS(3296),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3296),
    [sym_none] = ACTIONS(3296),
    [sym_true] = ACTIONS(3296),
    [sym_false] = ACTIONS(3296),
    [sym_nil] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_DOLLARif] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_select] = ACTIONS(3296),
    [anon_sym_lock] = ACTIONS(3296),
    [anon_sym_rlock] = ACTIONS(3296),
    [anon_sym_unsafe] = ACTIONS(3296),
    [anon_sym_sql] = ACTIONS(3296),
    [sym_int_literal] = ACTIONS(3296),
    [sym_float_literal] = ACTIONS(3296),
    [sym_rune_literal] = ACTIONS(3296),
    [anon_sym_SQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_c_SQUOTE] = ACTIONS(3296),
    [anon_sym_c_DQUOTE] = ACTIONS(3296),
    [anon_sym_r_SQUOTE] = ACTIONS(3296),
    [anon_sym_r_DQUOTE] = ACTIONS(3296),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3296),
    [anon_sym_shared] = ACTIONS(3296),
    [anon_sym_map_LBRACK] = ACTIONS(3296),
    [anon_sym_chan] = ACTIONS(3296),
    [anon_sym_thread] = ACTIONS(3296),
    [anon_sym_atomic] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_defer] = ACTIONS(3296),
    [anon_sym_goto] = ACTIONS(3296),
    [anon_sym_break] = ACTIONS(3296),
    [anon_sym_continue] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_DOLLARfor] = ACTIONS(3296),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_POUND] = ACTIONS(3296),
    [anon_sym_asm] = ACTIONS(3296),
    [anon_sym_AT_LBRACK] = ACTIONS(3296),
  },
  [1820] = {
    [sym_line_comment] = STATE(1820),
    [sym_block_comment] = STATE(1820),
    [ts_builtin_sym_end] = ACTIONS(4669),
    [sym_identifier] = ACTIONS(4671),
    [anon_sym_LF] = ACTIONS(4671),
    [anon_sym_CR] = ACTIONS(4671),
    [anon_sym_CR_LF] = ACTIONS(4671),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4671),
    [anon_sym_LBRACE] = ACTIONS(4671),
    [anon_sym_const] = ACTIONS(4671),
    [anon_sym_LPAREN] = ACTIONS(4671),
    [anon_sym___global] = ACTIONS(4671),
    [anon_sym_type] = ACTIONS(4671),
    [anon_sym_fn] = ACTIONS(4671),
    [anon_sym_PLUS] = ACTIONS(4671),
    [anon_sym_DASH] = ACTIONS(4671),
    [anon_sym_STAR] = ACTIONS(4671),
    [anon_sym_struct] = ACTIONS(4671),
    [anon_sym_union] = ACTIONS(4671),
    [anon_sym_pub] = ACTIONS(4671),
    [anon_sym_mut] = ACTIONS(4671),
    [anon_sym_enum] = ACTIONS(4671),
    [anon_sym_interface] = ACTIONS(4671),
    [anon_sym_QMARK] = ACTIONS(4671),
    [anon_sym_BANG] = ACTIONS(4671),
    [anon_sym_go] = ACTIONS(4671),
    [anon_sym_spawn] = ACTIONS(4671),
    [anon_sym_json_DOTdecode] = ACTIONS(4671),
    [anon_sym_LBRACK2] = ACTIONS(4671),
    [anon_sym_TILDE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4671),
    [anon_sym_AMP] = ACTIONS(4671),
    [anon_sym_LT_DASH] = ACTIONS(4671),
    [sym_none] = ACTIONS(4671),
    [sym_true] = ACTIONS(4671),
    [sym_false] = ACTIONS(4671),
    [sym_nil] = ACTIONS(4671),
    [anon_sym_if] = ACTIONS(4671),
    [anon_sym_DOLLARif] = ACTIONS(4671),
    [anon_sym_match] = ACTIONS(4671),
    [anon_sym_select] = ACTIONS(4671),
    [anon_sym_lock] = ACTIONS(4671),
    [anon_sym_rlock] = ACTIONS(4671),
    [anon_sym_unsafe] = ACTIONS(4671),
    [anon_sym_sql] = ACTIONS(4671),
    [sym_int_literal] = ACTIONS(4671),
    [sym_float_literal] = ACTIONS(4671),
    [sym_rune_literal] = ACTIONS(4671),
    [anon_sym_SQUOTE] = ACTIONS(4671),
    [anon_sym_DQUOTE] = ACTIONS(4671),
    [anon_sym_c_SQUOTE] = ACTIONS(4671),
    [anon_sym_c_DQUOTE] = ACTIONS(4671),
    [anon_sym_r_SQUOTE] = ACTIONS(4671),
    [anon_sym_r_DQUOTE] = ACTIONS(4671),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4671),
    [anon_sym_shared] = ACTIONS(4671),
    [anon_sym_map_LBRACK] = ACTIONS(4671),
    [anon_sym_chan] = ACTIONS(4671),
    [anon_sym_thread] = ACTIONS(4671),
    [anon_sym_atomic] = ACTIONS(4671),
    [anon_sym_assert] = ACTIONS(4671),
    [anon_sym_defer] = ACTIONS(4671),
    [anon_sym_goto] = ACTIONS(4671),
    [anon_sym_break] = ACTIONS(4671),
    [anon_sym_continue] = ACTIONS(4671),
    [anon_sym_return] = ACTIONS(4671),
    [anon_sym_DOLLARfor] = ACTIONS(4671),
    [anon_sym_for] = ACTIONS(4671),
    [anon_sym_POUND] = ACTIONS(4671),
    [anon_sym_asm] = ACTIONS(4671),
    [anon_sym_AT_LBRACK] = ACTIONS(4671),
  },
  [1821] = {
    [sym_line_comment] = STATE(1821),
    [sym_block_comment] = STATE(1821),
    [ts_builtin_sym_end] = ACTIONS(4673),
    [sym_identifier] = ACTIONS(4675),
    [anon_sym_LF] = ACTIONS(4675),
    [anon_sym_CR] = ACTIONS(4675),
    [anon_sym_CR_LF] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4675),
    [anon_sym_LBRACE] = ACTIONS(4675),
    [anon_sym_const] = ACTIONS(4675),
    [anon_sym_LPAREN] = ACTIONS(4675),
    [anon_sym___global] = ACTIONS(4675),
    [anon_sym_type] = ACTIONS(4675),
    [anon_sym_fn] = ACTIONS(4675),
    [anon_sym_PLUS] = ACTIONS(4675),
    [anon_sym_DASH] = ACTIONS(4675),
    [anon_sym_STAR] = ACTIONS(4675),
    [anon_sym_struct] = ACTIONS(4675),
    [anon_sym_union] = ACTIONS(4675),
    [anon_sym_pub] = ACTIONS(4675),
    [anon_sym_mut] = ACTIONS(4675),
    [anon_sym_enum] = ACTIONS(4675),
    [anon_sym_interface] = ACTIONS(4675),
    [anon_sym_QMARK] = ACTIONS(4675),
    [anon_sym_BANG] = ACTIONS(4675),
    [anon_sym_go] = ACTIONS(4675),
    [anon_sym_spawn] = ACTIONS(4675),
    [anon_sym_json_DOTdecode] = ACTIONS(4675),
    [anon_sym_LBRACK2] = ACTIONS(4675),
    [anon_sym_TILDE] = ACTIONS(4675),
    [anon_sym_CARET] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(4675),
    [anon_sym_LT_DASH] = ACTIONS(4675),
    [sym_none] = ACTIONS(4675),
    [sym_true] = ACTIONS(4675),
    [sym_false] = ACTIONS(4675),
    [sym_nil] = ACTIONS(4675),
    [anon_sym_if] = ACTIONS(4675),
    [anon_sym_DOLLARif] = ACTIONS(4675),
    [anon_sym_match] = ACTIONS(4675),
    [anon_sym_select] = ACTIONS(4675),
    [anon_sym_lock] = ACTIONS(4675),
    [anon_sym_rlock] = ACTIONS(4675),
    [anon_sym_unsafe] = ACTIONS(4675),
    [anon_sym_sql] = ACTIONS(4675),
    [sym_int_literal] = ACTIONS(4675),
    [sym_float_literal] = ACTIONS(4675),
    [sym_rune_literal] = ACTIONS(4675),
    [anon_sym_SQUOTE] = ACTIONS(4675),
    [anon_sym_DQUOTE] = ACTIONS(4675),
    [anon_sym_c_SQUOTE] = ACTIONS(4675),
    [anon_sym_c_DQUOTE] = ACTIONS(4675),
    [anon_sym_r_SQUOTE] = ACTIONS(4675),
    [anon_sym_r_DQUOTE] = ACTIONS(4675),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4675),
    [anon_sym_shared] = ACTIONS(4675),
    [anon_sym_map_LBRACK] = ACTIONS(4675),
    [anon_sym_chan] = ACTIONS(4675),
    [anon_sym_thread] = ACTIONS(4675),
    [anon_sym_atomic] = ACTIONS(4675),
    [anon_sym_assert] = ACTIONS(4675),
    [anon_sym_defer] = ACTIONS(4675),
    [anon_sym_goto] = ACTIONS(4675),
    [anon_sym_break] = ACTIONS(4675),
    [anon_sym_continue] = ACTIONS(4675),
    [anon_sym_return] = ACTIONS(4675),
    [anon_sym_DOLLARfor] = ACTIONS(4675),
    [anon_sym_for] = ACTIONS(4675),
    [anon_sym_POUND] = ACTIONS(4675),
    [anon_sym_asm] = ACTIONS(4675),
    [anon_sym_AT_LBRACK] = ACTIONS(4675),
  },
  [1822] = {
    [sym_line_comment] = STATE(1822),
    [sym_block_comment] = STATE(1822),
    [ts_builtin_sym_end] = ACTIONS(4677),
    [sym_identifier] = ACTIONS(4679),
    [anon_sym_LF] = ACTIONS(4679),
    [anon_sym_CR] = ACTIONS(4679),
    [anon_sym_CR_LF] = ACTIONS(4679),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4679),
    [anon_sym_LBRACE] = ACTIONS(4679),
    [anon_sym_const] = ACTIONS(4679),
    [anon_sym_LPAREN] = ACTIONS(4679),
    [anon_sym___global] = ACTIONS(4679),
    [anon_sym_type] = ACTIONS(4679),
    [anon_sym_fn] = ACTIONS(4679),
    [anon_sym_PLUS] = ACTIONS(4679),
    [anon_sym_DASH] = ACTIONS(4679),
    [anon_sym_STAR] = ACTIONS(4679),
    [anon_sym_struct] = ACTIONS(4679),
    [anon_sym_union] = ACTIONS(4679),
    [anon_sym_pub] = ACTIONS(4679),
    [anon_sym_mut] = ACTIONS(4679),
    [anon_sym_enum] = ACTIONS(4679),
    [anon_sym_interface] = ACTIONS(4679),
    [anon_sym_QMARK] = ACTIONS(4679),
    [anon_sym_BANG] = ACTIONS(4679),
    [anon_sym_go] = ACTIONS(4679),
    [anon_sym_spawn] = ACTIONS(4679),
    [anon_sym_json_DOTdecode] = ACTIONS(4679),
    [anon_sym_LBRACK2] = ACTIONS(4679),
    [anon_sym_TILDE] = ACTIONS(4679),
    [anon_sym_CARET] = ACTIONS(4679),
    [anon_sym_AMP] = ACTIONS(4679),
    [anon_sym_LT_DASH] = ACTIONS(4679),
    [sym_none] = ACTIONS(4679),
    [sym_true] = ACTIONS(4679),
    [sym_false] = ACTIONS(4679),
    [sym_nil] = ACTIONS(4679),
    [anon_sym_if] = ACTIONS(4679),
    [anon_sym_DOLLARif] = ACTIONS(4679),
    [anon_sym_match] = ACTIONS(4679),
    [anon_sym_select] = ACTIONS(4679),
    [anon_sym_lock] = ACTIONS(4679),
    [anon_sym_rlock] = ACTIONS(4679),
    [anon_sym_unsafe] = ACTIONS(4679),
    [anon_sym_sql] = ACTIONS(4679),
    [sym_int_literal] = ACTIONS(4679),
    [sym_float_literal] = ACTIONS(4679),
    [sym_rune_literal] = ACTIONS(4679),
    [anon_sym_SQUOTE] = ACTIONS(4679),
    [anon_sym_DQUOTE] = ACTIONS(4679),
    [anon_sym_c_SQUOTE] = ACTIONS(4679),
    [anon_sym_c_DQUOTE] = ACTIONS(4679),
    [anon_sym_r_SQUOTE] = ACTIONS(4679),
    [anon_sym_r_DQUOTE] = ACTIONS(4679),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4679),
    [anon_sym_shared] = ACTIONS(4679),
    [anon_sym_map_LBRACK] = ACTIONS(4679),
    [anon_sym_chan] = ACTIONS(4679),
    [anon_sym_thread] = ACTIONS(4679),
    [anon_sym_atomic] = ACTIONS(4679),
    [anon_sym_assert] = ACTIONS(4679),
    [anon_sym_defer] = ACTIONS(4679),
    [anon_sym_goto] = ACTIONS(4679),
    [anon_sym_break] = ACTIONS(4679),
    [anon_sym_continue] = ACTIONS(4679),
    [anon_sym_return] = ACTIONS(4679),
    [anon_sym_DOLLARfor] = ACTIONS(4679),
    [anon_sym_for] = ACTIONS(4679),
    [anon_sym_POUND] = ACTIONS(4679),
    [anon_sym_asm] = ACTIONS(4679),
    [anon_sym_AT_LBRACK] = ACTIONS(4679),
  },
  [1823] = {
    [sym_line_comment] = STATE(1823),
    [sym_block_comment] = STATE(1823),
    [ts_builtin_sym_end] = ACTIONS(4681),
    [sym_identifier] = ACTIONS(4683),
    [anon_sym_LF] = ACTIONS(4683),
    [anon_sym_CR] = ACTIONS(4683),
    [anon_sym_CR_LF] = ACTIONS(4683),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4683),
    [anon_sym_LBRACE] = ACTIONS(4683),
    [anon_sym_const] = ACTIONS(4683),
    [anon_sym_LPAREN] = ACTIONS(4683),
    [anon_sym___global] = ACTIONS(4683),
    [anon_sym_type] = ACTIONS(4683),
    [anon_sym_fn] = ACTIONS(4683),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_STAR] = ACTIONS(4683),
    [anon_sym_struct] = ACTIONS(4683),
    [anon_sym_union] = ACTIONS(4683),
    [anon_sym_pub] = ACTIONS(4683),
    [anon_sym_mut] = ACTIONS(4683),
    [anon_sym_enum] = ACTIONS(4683),
    [anon_sym_interface] = ACTIONS(4683),
    [anon_sym_QMARK] = ACTIONS(4683),
    [anon_sym_BANG] = ACTIONS(4683),
    [anon_sym_go] = ACTIONS(4683),
    [anon_sym_spawn] = ACTIONS(4683),
    [anon_sym_json_DOTdecode] = ACTIONS(4683),
    [anon_sym_LBRACK2] = ACTIONS(4683),
    [anon_sym_TILDE] = ACTIONS(4683),
    [anon_sym_CARET] = ACTIONS(4683),
    [anon_sym_AMP] = ACTIONS(4683),
    [anon_sym_LT_DASH] = ACTIONS(4683),
    [sym_none] = ACTIONS(4683),
    [sym_true] = ACTIONS(4683),
    [sym_false] = ACTIONS(4683),
    [sym_nil] = ACTIONS(4683),
    [anon_sym_if] = ACTIONS(4683),
    [anon_sym_DOLLARif] = ACTIONS(4683),
    [anon_sym_match] = ACTIONS(4683),
    [anon_sym_select] = ACTIONS(4683),
    [anon_sym_lock] = ACTIONS(4683),
    [anon_sym_rlock] = ACTIONS(4683),
    [anon_sym_unsafe] = ACTIONS(4683),
    [anon_sym_sql] = ACTIONS(4683),
    [sym_int_literal] = ACTIONS(4683),
    [sym_float_literal] = ACTIONS(4683),
    [sym_rune_literal] = ACTIONS(4683),
    [anon_sym_SQUOTE] = ACTIONS(4683),
    [anon_sym_DQUOTE] = ACTIONS(4683),
    [anon_sym_c_SQUOTE] = ACTIONS(4683),
    [anon_sym_c_DQUOTE] = ACTIONS(4683),
    [anon_sym_r_SQUOTE] = ACTIONS(4683),
    [anon_sym_r_DQUOTE] = ACTIONS(4683),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4683),
    [anon_sym_shared] = ACTIONS(4683),
    [anon_sym_map_LBRACK] = ACTIONS(4683),
    [anon_sym_chan] = ACTIONS(4683),
    [anon_sym_thread] = ACTIONS(4683),
    [anon_sym_atomic] = ACTIONS(4683),
    [anon_sym_assert] = ACTIONS(4683),
    [anon_sym_defer] = ACTIONS(4683),
    [anon_sym_goto] = ACTIONS(4683),
    [anon_sym_break] = ACTIONS(4683),
    [anon_sym_continue] = ACTIONS(4683),
    [anon_sym_return] = ACTIONS(4683),
    [anon_sym_DOLLARfor] = ACTIONS(4683),
    [anon_sym_for] = ACTIONS(4683),
    [anon_sym_POUND] = ACTIONS(4683),
    [anon_sym_asm] = ACTIONS(4683),
    [anon_sym_AT_LBRACK] = ACTIONS(4683),
  },
  [1824] = {
    [sym_line_comment] = STATE(1824),
    [sym_block_comment] = STATE(1824),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2489),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(849),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(849),
    [anon_sym_SLASH] = ACTIONS(851),
    [anon_sym_PERCENT] = ACTIONS(849),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(849),
    [anon_sym_BANG_EQ] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_PLUS_PLUS] = ACTIONS(849),
    [anon_sym_DASH_DASH] = ACTIONS(849),
    [anon_sym_QMARK] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PIPE] = ACTIONS(851),
    [anon_sym_LBRACK2] = ACTIONS(851),
    [anon_sym_CARET] = ACTIONS(849),
    [anon_sym_AMP] = ACTIONS(851),
    [anon_sym_LT_LT] = ACTIONS(849),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_GT_GT_GT] = ACTIONS(849),
    [anon_sym_AMP_CARET] = ACTIONS(849),
    [anon_sym_AMP_AMP] = ACTIONS(849),
    [anon_sym_PIPE_PIPE] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(851),
    [anon_sym_QMARK_DOT] = ACTIONS(849),
    [anon_sym_POUND_LBRACK] = ACTIONS(849),
    [anon_sym_is] = ACTIONS(851),
    [anon_sym_BANGis] = ACTIONS(849),
    [anon_sym_in] = ACTIONS(851),
    [anon_sym_BANGin] = ACTIONS(849),
    [anon_sym_COLON_EQ] = ACTIONS(849),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(851),
  },
  [1825] = {
    [sym_line_comment] = STATE(1825),
    [sym_block_comment] = STATE(1825),
    [ts_builtin_sym_end] = ACTIONS(4685),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_LF] = ACTIONS(4687),
    [anon_sym_CR] = ACTIONS(4687),
    [anon_sym_CR_LF] = ACTIONS(4687),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4687),
    [anon_sym_LBRACE] = ACTIONS(4687),
    [anon_sym_const] = ACTIONS(4687),
    [anon_sym_LPAREN] = ACTIONS(4687),
    [anon_sym___global] = ACTIONS(4687),
    [anon_sym_type] = ACTIONS(4687),
    [anon_sym_fn] = ACTIONS(4687),
    [anon_sym_PLUS] = ACTIONS(4687),
    [anon_sym_DASH] = ACTIONS(4687),
    [anon_sym_STAR] = ACTIONS(4687),
    [anon_sym_struct] = ACTIONS(4687),
    [anon_sym_union] = ACTIONS(4687),
    [anon_sym_pub] = ACTIONS(4687),
    [anon_sym_mut] = ACTIONS(4687),
    [anon_sym_enum] = ACTIONS(4687),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_QMARK] = ACTIONS(4687),
    [anon_sym_BANG] = ACTIONS(4687),
    [anon_sym_go] = ACTIONS(4687),
    [anon_sym_spawn] = ACTIONS(4687),
    [anon_sym_json_DOTdecode] = ACTIONS(4687),
    [anon_sym_LBRACK2] = ACTIONS(4687),
    [anon_sym_TILDE] = ACTIONS(4687),
    [anon_sym_CARET] = ACTIONS(4687),
    [anon_sym_AMP] = ACTIONS(4687),
    [anon_sym_LT_DASH] = ACTIONS(4687),
    [sym_none] = ACTIONS(4687),
    [sym_true] = ACTIONS(4687),
    [sym_false] = ACTIONS(4687),
    [sym_nil] = ACTIONS(4687),
    [anon_sym_if] = ACTIONS(4687),
    [anon_sym_DOLLARif] = ACTIONS(4687),
    [anon_sym_match] = ACTIONS(4687),
    [anon_sym_select] = ACTIONS(4687),
    [anon_sym_lock] = ACTIONS(4687),
    [anon_sym_rlock] = ACTIONS(4687),
    [anon_sym_unsafe] = ACTIONS(4687),
    [anon_sym_sql] = ACTIONS(4687),
    [sym_int_literal] = ACTIONS(4687),
    [sym_float_literal] = ACTIONS(4687),
    [sym_rune_literal] = ACTIONS(4687),
    [anon_sym_SQUOTE] = ACTIONS(4687),
    [anon_sym_DQUOTE] = ACTIONS(4687),
    [anon_sym_c_SQUOTE] = ACTIONS(4687),
    [anon_sym_c_DQUOTE] = ACTIONS(4687),
    [anon_sym_r_SQUOTE] = ACTIONS(4687),
    [anon_sym_r_DQUOTE] = ACTIONS(4687),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4687),
    [anon_sym_shared] = ACTIONS(4687),
    [anon_sym_map_LBRACK] = ACTIONS(4687),
    [anon_sym_chan] = ACTIONS(4687),
    [anon_sym_thread] = ACTIONS(4687),
    [anon_sym_atomic] = ACTIONS(4687),
    [anon_sym_assert] = ACTIONS(4687),
    [anon_sym_defer] = ACTIONS(4687),
    [anon_sym_goto] = ACTIONS(4687),
    [anon_sym_break] = ACTIONS(4687),
    [anon_sym_continue] = ACTIONS(4687),
    [anon_sym_return] = ACTIONS(4687),
    [anon_sym_DOLLARfor] = ACTIONS(4687),
    [anon_sym_for] = ACTIONS(4687),
    [anon_sym_POUND] = ACTIONS(4687),
    [anon_sym_asm] = ACTIONS(4687),
    [anon_sym_AT_LBRACK] = ACTIONS(4687),
  },
  [1826] = {
    [sym_line_comment] = STATE(1826),
    [sym_block_comment] = STATE(1826),
    [ts_builtin_sym_end] = ACTIONS(4689),
    [sym_identifier] = ACTIONS(4691),
    [anon_sym_LF] = ACTIONS(4691),
    [anon_sym_CR] = ACTIONS(4691),
    [anon_sym_CR_LF] = ACTIONS(4691),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4691),
    [anon_sym_LBRACE] = ACTIONS(4691),
    [anon_sym_const] = ACTIONS(4691),
    [anon_sym_LPAREN] = ACTIONS(4691),
    [anon_sym___global] = ACTIONS(4691),
    [anon_sym_type] = ACTIONS(4691),
    [anon_sym_fn] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4691),
    [anon_sym_DASH] = ACTIONS(4691),
    [anon_sym_STAR] = ACTIONS(4691),
    [anon_sym_struct] = ACTIONS(4691),
    [anon_sym_union] = ACTIONS(4691),
    [anon_sym_pub] = ACTIONS(4691),
    [anon_sym_mut] = ACTIONS(4691),
    [anon_sym_enum] = ACTIONS(4691),
    [anon_sym_interface] = ACTIONS(4691),
    [anon_sym_QMARK] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(4691),
    [anon_sym_go] = ACTIONS(4691),
    [anon_sym_spawn] = ACTIONS(4691),
    [anon_sym_json_DOTdecode] = ACTIONS(4691),
    [anon_sym_LBRACK2] = ACTIONS(4691),
    [anon_sym_TILDE] = ACTIONS(4691),
    [anon_sym_CARET] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(4691),
    [anon_sym_LT_DASH] = ACTIONS(4691),
    [sym_none] = ACTIONS(4691),
    [sym_true] = ACTIONS(4691),
    [sym_false] = ACTIONS(4691),
    [sym_nil] = ACTIONS(4691),
    [anon_sym_if] = ACTIONS(4691),
    [anon_sym_DOLLARif] = ACTIONS(4691),
    [anon_sym_match] = ACTIONS(4691),
    [anon_sym_select] = ACTIONS(4691),
    [anon_sym_lock] = ACTIONS(4691),
    [anon_sym_rlock] = ACTIONS(4691),
    [anon_sym_unsafe] = ACTIONS(4691),
    [anon_sym_sql] = ACTIONS(4691),
    [sym_int_literal] = ACTIONS(4691),
    [sym_float_literal] = ACTIONS(4691),
    [sym_rune_literal] = ACTIONS(4691),
    [anon_sym_SQUOTE] = ACTIONS(4691),
    [anon_sym_DQUOTE] = ACTIONS(4691),
    [anon_sym_c_SQUOTE] = ACTIONS(4691),
    [anon_sym_c_DQUOTE] = ACTIONS(4691),
    [anon_sym_r_SQUOTE] = ACTIONS(4691),
    [anon_sym_r_DQUOTE] = ACTIONS(4691),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4691),
    [anon_sym_shared] = ACTIONS(4691),
    [anon_sym_map_LBRACK] = ACTIONS(4691),
    [anon_sym_chan] = ACTIONS(4691),
    [anon_sym_thread] = ACTIONS(4691),
    [anon_sym_atomic] = ACTIONS(4691),
    [anon_sym_assert] = ACTIONS(4691),
    [anon_sym_defer] = ACTIONS(4691),
    [anon_sym_goto] = ACTIONS(4691),
    [anon_sym_break] = ACTIONS(4691),
    [anon_sym_continue] = ACTIONS(4691),
    [anon_sym_return] = ACTIONS(4691),
    [anon_sym_DOLLARfor] = ACTIONS(4691),
    [anon_sym_for] = ACTIONS(4691),
    [anon_sym_POUND] = ACTIONS(4691),
    [anon_sym_asm] = ACTIONS(4691),
    [anon_sym_AT_LBRACK] = ACTIONS(4691),
  },
  [1827] = {
    [sym_line_comment] = STATE(1827),
    [sym_block_comment] = STATE(1827),
    [ts_builtin_sym_end] = ACTIONS(4693),
    [sym_identifier] = ACTIONS(4695),
    [anon_sym_LF] = ACTIONS(4695),
    [anon_sym_CR] = ACTIONS(4695),
    [anon_sym_CR_LF] = ACTIONS(4695),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4695),
    [anon_sym_LBRACE] = ACTIONS(4695),
    [anon_sym_const] = ACTIONS(4695),
    [anon_sym_LPAREN] = ACTIONS(4695),
    [anon_sym___global] = ACTIONS(4695),
    [anon_sym_type] = ACTIONS(4695),
    [anon_sym_fn] = ACTIONS(4695),
    [anon_sym_PLUS] = ACTIONS(4695),
    [anon_sym_DASH] = ACTIONS(4695),
    [anon_sym_STAR] = ACTIONS(4695),
    [anon_sym_struct] = ACTIONS(4695),
    [anon_sym_union] = ACTIONS(4695),
    [anon_sym_pub] = ACTIONS(4695),
    [anon_sym_mut] = ACTIONS(4695),
    [anon_sym_enum] = ACTIONS(4695),
    [anon_sym_interface] = ACTIONS(4695),
    [anon_sym_QMARK] = ACTIONS(4695),
    [anon_sym_BANG] = ACTIONS(4695),
    [anon_sym_go] = ACTIONS(4695),
    [anon_sym_spawn] = ACTIONS(4695),
    [anon_sym_json_DOTdecode] = ACTIONS(4695),
    [anon_sym_LBRACK2] = ACTIONS(4695),
    [anon_sym_TILDE] = ACTIONS(4695),
    [anon_sym_CARET] = ACTIONS(4695),
    [anon_sym_AMP] = ACTIONS(4695),
    [anon_sym_LT_DASH] = ACTIONS(4695),
    [sym_none] = ACTIONS(4695),
    [sym_true] = ACTIONS(4695),
    [sym_false] = ACTIONS(4695),
    [sym_nil] = ACTIONS(4695),
    [anon_sym_if] = ACTIONS(4695),
    [anon_sym_DOLLARif] = ACTIONS(4695),
    [anon_sym_match] = ACTIONS(4695),
    [anon_sym_select] = ACTIONS(4695),
    [anon_sym_lock] = ACTIONS(4695),
    [anon_sym_rlock] = ACTIONS(4695),
    [anon_sym_unsafe] = ACTIONS(4695),
    [anon_sym_sql] = ACTIONS(4695),
    [sym_int_literal] = ACTIONS(4695),
    [sym_float_literal] = ACTIONS(4695),
    [sym_rune_literal] = ACTIONS(4695),
    [anon_sym_SQUOTE] = ACTIONS(4695),
    [anon_sym_DQUOTE] = ACTIONS(4695),
    [anon_sym_c_SQUOTE] = ACTIONS(4695),
    [anon_sym_c_DQUOTE] = ACTIONS(4695),
    [anon_sym_r_SQUOTE] = ACTIONS(4695),
    [anon_sym_r_DQUOTE] = ACTIONS(4695),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4695),
    [anon_sym_shared] = ACTIONS(4695),
    [anon_sym_map_LBRACK] = ACTIONS(4695),
    [anon_sym_chan] = ACTIONS(4695),
    [anon_sym_thread] = ACTIONS(4695),
    [anon_sym_atomic] = ACTIONS(4695),
    [anon_sym_assert] = ACTIONS(4695),
    [anon_sym_defer] = ACTIONS(4695),
    [anon_sym_goto] = ACTIONS(4695),
    [anon_sym_break] = ACTIONS(4695),
    [anon_sym_continue] = ACTIONS(4695),
    [anon_sym_return] = ACTIONS(4695),
    [anon_sym_DOLLARfor] = ACTIONS(4695),
    [anon_sym_for] = ACTIONS(4695),
    [anon_sym_POUND] = ACTIONS(4695),
    [anon_sym_asm] = ACTIONS(4695),
    [anon_sym_AT_LBRACK] = ACTIONS(4695),
  },
  [1828] = {
    [sym_line_comment] = STATE(1828),
    [sym_block_comment] = STATE(1828),
    [ts_builtin_sym_end] = ACTIONS(2167),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_LF] = ACTIONS(2169),
    [anon_sym_CR] = ACTIONS(2169),
    [anon_sym_CR_LF] = ACTIONS(2169),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_LPAREN] = ACTIONS(2169),
    [anon_sym___global] = ACTIONS(2169),
    [anon_sym_type] = ACTIONS(2169),
    [anon_sym_fn] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_union] = ACTIONS(2169),
    [anon_sym_pub] = ACTIONS(2169),
    [anon_sym_mut] = ACTIONS(2169),
    [anon_sym_enum] = ACTIONS(2169),
    [anon_sym_interface] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_go] = ACTIONS(2169),
    [anon_sym_spawn] = ACTIONS(2169),
    [anon_sym_json_DOTdecode] = ACTIONS(2169),
    [anon_sym_LBRACK2] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT_DASH] = ACTIONS(2169),
    [sym_none] = ACTIONS(2169),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [sym_nil] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_DOLLARif] = ACTIONS(2169),
    [anon_sym_match] = ACTIONS(2169),
    [anon_sym_select] = ACTIONS(2169),
    [anon_sym_lock] = ACTIONS(2169),
    [anon_sym_rlock] = ACTIONS(2169),
    [anon_sym_unsafe] = ACTIONS(2169),
    [anon_sym_sql] = ACTIONS(2169),
    [sym_int_literal] = ACTIONS(2169),
    [sym_float_literal] = ACTIONS(2169),
    [sym_rune_literal] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [anon_sym_c_SQUOTE] = ACTIONS(2169),
    [anon_sym_c_DQUOTE] = ACTIONS(2169),
    [anon_sym_r_SQUOTE] = ACTIONS(2169),
    [anon_sym_r_DQUOTE] = ACTIONS(2169),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_map_LBRACK] = ACTIONS(2169),
    [anon_sym_chan] = ACTIONS(2169),
    [anon_sym_thread] = ACTIONS(2169),
    [anon_sym_atomic] = ACTIONS(2169),
    [anon_sym_assert] = ACTIONS(2169),
    [anon_sym_defer] = ACTIONS(2169),
    [anon_sym_goto] = ACTIONS(2169),
    [anon_sym_break] = ACTIONS(2169),
    [anon_sym_continue] = ACTIONS(2169),
    [anon_sym_return] = ACTIONS(2169),
    [anon_sym_DOLLARfor] = ACTIONS(2169),
    [anon_sym_for] = ACTIONS(2169),
    [anon_sym_POUND] = ACTIONS(2169),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym_AT_LBRACK] = ACTIONS(2169),
  },
  [1829] = {
    [sym_line_comment] = STATE(1829),
    [sym_block_comment] = STATE(1829),
    [ts_builtin_sym_end] = ACTIONS(4697),
    [sym_identifier] = ACTIONS(4699),
    [anon_sym_LF] = ACTIONS(4699),
    [anon_sym_CR] = ACTIONS(4699),
    [anon_sym_CR_LF] = ACTIONS(4699),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4699),
    [anon_sym_LBRACE] = ACTIONS(4699),
    [anon_sym_const] = ACTIONS(4699),
    [anon_sym_LPAREN] = ACTIONS(4699),
    [anon_sym___global] = ACTIONS(4699),
    [anon_sym_type] = ACTIONS(4699),
    [anon_sym_fn] = ACTIONS(4699),
    [anon_sym_PLUS] = ACTIONS(4699),
    [anon_sym_DASH] = ACTIONS(4699),
    [anon_sym_STAR] = ACTIONS(4699),
    [anon_sym_struct] = ACTIONS(4699),
    [anon_sym_union] = ACTIONS(4699),
    [anon_sym_pub] = ACTIONS(4699),
    [anon_sym_mut] = ACTIONS(4699),
    [anon_sym_enum] = ACTIONS(4699),
    [anon_sym_interface] = ACTIONS(4699),
    [anon_sym_QMARK] = ACTIONS(4699),
    [anon_sym_BANG] = ACTIONS(4699),
    [anon_sym_go] = ACTIONS(4699),
    [anon_sym_spawn] = ACTIONS(4699),
    [anon_sym_json_DOTdecode] = ACTIONS(4699),
    [anon_sym_LBRACK2] = ACTIONS(4699),
    [anon_sym_TILDE] = ACTIONS(4699),
    [anon_sym_CARET] = ACTIONS(4699),
    [anon_sym_AMP] = ACTIONS(4699),
    [anon_sym_LT_DASH] = ACTIONS(4699),
    [sym_none] = ACTIONS(4699),
    [sym_true] = ACTIONS(4699),
    [sym_false] = ACTIONS(4699),
    [sym_nil] = ACTIONS(4699),
    [anon_sym_if] = ACTIONS(4699),
    [anon_sym_DOLLARif] = ACTIONS(4699),
    [anon_sym_match] = ACTIONS(4699),
    [anon_sym_select] = ACTIONS(4699),
    [anon_sym_lock] = ACTIONS(4699),
    [anon_sym_rlock] = ACTIONS(4699),
    [anon_sym_unsafe] = ACTIONS(4699),
    [anon_sym_sql] = ACTIONS(4699),
    [sym_int_literal] = ACTIONS(4699),
    [sym_float_literal] = ACTIONS(4699),
    [sym_rune_literal] = ACTIONS(4699),
    [anon_sym_SQUOTE] = ACTIONS(4699),
    [anon_sym_DQUOTE] = ACTIONS(4699),
    [anon_sym_c_SQUOTE] = ACTIONS(4699),
    [anon_sym_c_DQUOTE] = ACTIONS(4699),
    [anon_sym_r_SQUOTE] = ACTIONS(4699),
    [anon_sym_r_DQUOTE] = ACTIONS(4699),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4699),
    [anon_sym_shared] = ACTIONS(4699),
    [anon_sym_map_LBRACK] = ACTIONS(4699),
    [anon_sym_chan] = ACTIONS(4699),
    [anon_sym_thread] = ACTIONS(4699),
    [anon_sym_atomic] = ACTIONS(4699),
    [anon_sym_assert] = ACTIONS(4699),
    [anon_sym_defer] = ACTIONS(4699),
    [anon_sym_goto] = ACTIONS(4699),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_continue] = ACTIONS(4699),
    [anon_sym_return] = ACTIONS(4699),
    [anon_sym_DOLLARfor] = ACTIONS(4699),
    [anon_sym_for] = ACTIONS(4699),
    [anon_sym_POUND] = ACTIONS(4699),
    [anon_sym_asm] = ACTIONS(4699),
    [anon_sym_AT_LBRACK] = ACTIONS(4699),
  },
  [1830] = {
    [sym_line_comment] = STATE(1830),
    [sym_block_comment] = STATE(1830),
    [ts_builtin_sym_end] = ACTIONS(3029),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_LF] = ACTIONS(3031),
    [anon_sym_CR] = ACTIONS(3031),
    [anon_sym_CR_LF] = ACTIONS(3031),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3031),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_const] = ACTIONS(3031),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym___global] = ACTIONS(3031),
    [anon_sym_type] = ACTIONS(3031),
    [anon_sym_fn] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_STAR] = ACTIONS(3031),
    [anon_sym_struct] = ACTIONS(3031),
    [anon_sym_union] = ACTIONS(3031),
    [anon_sym_pub] = ACTIONS(3031),
    [anon_sym_mut] = ACTIONS(3031),
    [anon_sym_enum] = ACTIONS(3031),
    [anon_sym_interface] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_BANG] = ACTIONS(3031),
    [anon_sym_go] = ACTIONS(3031),
    [anon_sym_spawn] = ACTIONS(3031),
    [anon_sym_json_DOTdecode] = ACTIONS(3031),
    [anon_sym_LBRACK2] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3031),
    [anon_sym_CARET] = ACTIONS(3031),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_LT_DASH] = ACTIONS(3031),
    [sym_none] = ACTIONS(3031),
    [sym_true] = ACTIONS(3031),
    [sym_false] = ACTIONS(3031),
    [sym_nil] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_DOLLARif] = ACTIONS(3031),
    [anon_sym_match] = ACTIONS(3031),
    [anon_sym_select] = ACTIONS(3031),
    [anon_sym_lock] = ACTIONS(3031),
    [anon_sym_rlock] = ACTIONS(3031),
    [anon_sym_unsafe] = ACTIONS(3031),
    [anon_sym_sql] = ACTIONS(3031),
    [sym_int_literal] = ACTIONS(3031),
    [sym_float_literal] = ACTIONS(3031),
    [sym_rune_literal] = ACTIONS(3031),
    [anon_sym_SQUOTE] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_c_SQUOTE] = ACTIONS(3031),
    [anon_sym_c_DQUOTE] = ACTIONS(3031),
    [anon_sym_r_SQUOTE] = ACTIONS(3031),
    [anon_sym_r_DQUOTE] = ACTIONS(3031),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3031),
    [anon_sym_shared] = ACTIONS(3031),
    [anon_sym_map_LBRACK] = ACTIONS(3031),
    [anon_sym_chan] = ACTIONS(3031),
    [anon_sym_thread] = ACTIONS(3031),
    [anon_sym_atomic] = ACTIONS(3031),
    [anon_sym_assert] = ACTIONS(3031),
    [anon_sym_defer] = ACTIONS(3031),
    [anon_sym_goto] = ACTIONS(3031),
    [anon_sym_break] = ACTIONS(3031),
    [anon_sym_continue] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_DOLLARfor] = ACTIONS(3031),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_POUND] = ACTIONS(3031),
    [anon_sym_asm] = ACTIONS(3031),
    [anon_sym_AT_LBRACK] = ACTIONS(3031),
  },
  [1831] = {
    [sym_line_comment] = STATE(1831),
    [sym_block_comment] = STATE(1831),
    [ts_builtin_sym_end] = ACTIONS(4701),
    [sym_identifier] = ACTIONS(4703),
    [anon_sym_LF] = ACTIONS(4703),
    [anon_sym_CR] = ACTIONS(4703),
    [anon_sym_CR_LF] = ACTIONS(4703),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4703),
    [anon_sym_LBRACE] = ACTIONS(4703),
    [anon_sym_const] = ACTIONS(4703),
    [anon_sym_LPAREN] = ACTIONS(4703),
    [anon_sym___global] = ACTIONS(4703),
    [anon_sym_type] = ACTIONS(4703),
    [anon_sym_fn] = ACTIONS(4703),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_DASH] = ACTIONS(4703),
    [anon_sym_STAR] = ACTIONS(4703),
    [anon_sym_struct] = ACTIONS(4703),
    [anon_sym_union] = ACTIONS(4703),
    [anon_sym_pub] = ACTIONS(4703),
    [anon_sym_mut] = ACTIONS(4703),
    [anon_sym_enum] = ACTIONS(4703),
    [anon_sym_interface] = ACTIONS(4703),
    [anon_sym_QMARK] = ACTIONS(4703),
    [anon_sym_BANG] = ACTIONS(4703),
    [anon_sym_go] = ACTIONS(4703),
    [anon_sym_spawn] = ACTIONS(4703),
    [anon_sym_json_DOTdecode] = ACTIONS(4703),
    [anon_sym_LBRACK2] = ACTIONS(4703),
    [anon_sym_TILDE] = ACTIONS(4703),
    [anon_sym_CARET] = ACTIONS(4703),
    [anon_sym_AMP] = ACTIONS(4703),
    [anon_sym_LT_DASH] = ACTIONS(4703),
    [sym_none] = ACTIONS(4703),
    [sym_true] = ACTIONS(4703),
    [sym_false] = ACTIONS(4703),
    [sym_nil] = ACTIONS(4703),
    [anon_sym_if] = ACTIONS(4703),
    [anon_sym_DOLLARif] = ACTIONS(4703),
    [anon_sym_match] = ACTIONS(4703),
    [anon_sym_select] = ACTIONS(4703),
    [anon_sym_lock] = ACTIONS(4703),
    [anon_sym_rlock] = ACTIONS(4703),
    [anon_sym_unsafe] = ACTIONS(4703),
    [anon_sym_sql] = ACTIONS(4703),
    [sym_int_literal] = ACTIONS(4703),
    [sym_float_literal] = ACTIONS(4703),
    [sym_rune_literal] = ACTIONS(4703),
    [anon_sym_SQUOTE] = ACTIONS(4703),
    [anon_sym_DQUOTE] = ACTIONS(4703),
    [anon_sym_c_SQUOTE] = ACTIONS(4703),
    [anon_sym_c_DQUOTE] = ACTIONS(4703),
    [anon_sym_r_SQUOTE] = ACTIONS(4703),
    [anon_sym_r_DQUOTE] = ACTIONS(4703),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4703),
    [anon_sym_shared] = ACTIONS(4703),
    [anon_sym_map_LBRACK] = ACTIONS(4703),
    [anon_sym_chan] = ACTIONS(4703),
    [anon_sym_thread] = ACTIONS(4703),
    [anon_sym_atomic] = ACTIONS(4703),
    [anon_sym_assert] = ACTIONS(4703),
    [anon_sym_defer] = ACTIONS(4703),
    [anon_sym_goto] = ACTIONS(4703),
    [anon_sym_break] = ACTIONS(4703),
    [anon_sym_continue] = ACTIONS(4703),
    [anon_sym_return] = ACTIONS(4703),
    [anon_sym_DOLLARfor] = ACTIONS(4703),
    [anon_sym_for] = ACTIONS(4703),
    [anon_sym_POUND] = ACTIONS(4703),
    [anon_sym_asm] = ACTIONS(4703),
    [anon_sym_AT_LBRACK] = ACTIONS(4703),
  },
  [1832] = {
    [sym_line_comment] = STATE(1832),
    [sym_block_comment] = STATE(1832),
    [ts_builtin_sym_end] = ACTIONS(4705),
    [sym_identifier] = ACTIONS(4707),
    [anon_sym_LF] = ACTIONS(4707),
    [anon_sym_CR] = ACTIONS(4707),
    [anon_sym_CR_LF] = ACTIONS(4707),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4707),
    [anon_sym_LBRACE] = ACTIONS(4707),
    [anon_sym_const] = ACTIONS(4707),
    [anon_sym_LPAREN] = ACTIONS(4707),
    [anon_sym___global] = ACTIONS(4707),
    [anon_sym_type] = ACTIONS(4707),
    [anon_sym_fn] = ACTIONS(4707),
    [anon_sym_PLUS] = ACTIONS(4707),
    [anon_sym_DASH] = ACTIONS(4707),
    [anon_sym_STAR] = ACTIONS(4707),
    [anon_sym_struct] = ACTIONS(4707),
    [anon_sym_union] = ACTIONS(4707),
    [anon_sym_pub] = ACTIONS(4707),
    [anon_sym_mut] = ACTIONS(4707),
    [anon_sym_enum] = ACTIONS(4707),
    [anon_sym_interface] = ACTIONS(4707),
    [anon_sym_QMARK] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4707),
    [anon_sym_go] = ACTIONS(4707),
    [anon_sym_spawn] = ACTIONS(4707),
    [anon_sym_json_DOTdecode] = ACTIONS(4707),
    [anon_sym_LBRACK2] = ACTIONS(4707),
    [anon_sym_TILDE] = ACTIONS(4707),
    [anon_sym_CARET] = ACTIONS(4707),
    [anon_sym_AMP] = ACTIONS(4707),
    [anon_sym_LT_DASH] = ACTIONS(4707),
    [sym_none] = ACTIONS(4707),
    [sym_true] = ACTIONS(4707),
    [sym_false] = ACTIONS(4707),
    [sym_nil] = ACTIONS(4707),
    [anon_sym_if] = ACTIONS(4707),
    [anon_sym_DOLLARif] = ACTIONS(4707),
    [anon_sym_match] = ACTIONS(4707),
    [anon_sym_select] = ACTIONS(4707),
    [anon_sym_lock] = ACTIONS(4707),
    [anon_sym_rlock] = ACTIONS(4707),
    [anon_sym_unsafe] = ACTIONS(4707),
    [anon_sym_sql] = ACTIONS(4707),
    [sym_int_literal] = ACTIONS(4707),
    [sym_float_literal] = ACTIONS(4707),
    [sym_rune_literal] = ACTIONS(4707),
    [anon_sym_SQUOTE] = ACTIONS(4707),
    [anon_sym_DQUOTE] = ACTIONS(4707),
    [anon_sym_c_SQUOTE] = ACTIONS(4707),
    [anon_sym_c_DQUOTE] = ACTIONS(4707),
    [anon_sym_r_SQUOTE] = ACTIONS(4707),
    [anon_sym_r_DQUOTE] = ACTIONS(4707),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4707),
    [anon_sym_shared] = ACTIONS(4707),
    [anon_sym_map_LBRACK] = ACTIONS(4707),
    [anon_sym_chan] = ACTIONS(4707),
    [anon_sym_thread] = ACTIONS(4707),
    [anon_sym_atomic] = ACTIONS(4707),
    [anon_sym_assert] = ACTIONS(4707),
    [anon_sym_defer] = ACTIONS(4707),
    [anon_sym_goto] = ACTIONS(4707),
    [anon_sym_break] = ACTIONS(4707),
    [anon_sym_continue] = ACTIONS(4707),
    [anon_sym_return] = ACTIONS(4707),
    [anon_sym_DOLLARfor] = ACTIONS(4707),
    [anon_sym_for] = ACTIONS(4707),
    [anon_sym_POUND] = ACTIONS(4707),
    [anon_sym_asm] = ACTIONS(4707),
    [anon_sym_AT_LBRACK] = ACTIONS(4707),
  },
  [1833] = {
    [sym_line_comment] = STATE(1833),
    [sym_block_comment] = STATE(1833),
    [ts_builtin_sym_end] = ACTIONS(3039),
    [sym_identifier] = ACTIONS(3041),
    [anon_sym_LF] = ACTIONS(3041),
    [anon_sym_CR] = ACTIONS(3041),
    [anon_sym_CR_LF] = ACTIONS(3041),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3041),
    [anon_sym_const] = ACTIONS(3041),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym___global] = ACTIONS(3041),
    [anon_sym_type] = ACTIONS(3041),
    [anon_sym_fn] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3041),
    [anon_sym_DASH] = ACTIONS(3041),
    [anon_sym_STAR] = ACTIONS(3041),
    [anon_sym_struct] = ACTIONS(3041),
    [anon_sym_union] = ACTIONS(3041),
    [anon_sym_pub] = ACTIONS(3041),
    [anon_sym_mut] = ACTIONS(3041),
    [anon_sym_enum] = ACTIONS(3041),
    [anon_sym_interface] = ACTIONS(3041),
    [anon_sym_QMARK] = ACTIONS(3041),
    [anon_sym_BANG] = ACTIONS(3041),
    [anon_sym_go] = ACTIONS(3041),
    [anon_sym_spawn] = ACTIONS(3041),
    [anon_sym_json_DOTdecode] = ACTIONS(3041),
    [anon_sym_LBRACK2] = ACTIONS(3041),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_CARET] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3041),
    [anon_sym_LT_DASH] = ACTIONS(3041),
    [sym_none] = ACTIONS(3041),
    [sym_true] = ACTIONS(3041),
    [sym_false] = ACTIONS(3041),
    [sym_nil] = ACTIONS(3041),
    [anon_sym_if] = ACTIONS(3041),
    [anon_sym_DOLLARif] = ACTIONS(3041),
    [anon_sym_match] = ACTIONS(3041),
    [anon_sym_select] = ACTIONS(3041),
    [anon_sym_lock] = ACTIONS(3041),
    [anon_sym_rlock] = ACTIONS(3041),
    [anon_sym_unsafe] = ACTIONS(3041),
    [anon_sym_sql] = ACTIONS(3041),
    [sym_int_literal] = ACTIONS(3041),
    [sym_float_literal] = ACTIONS(3041),
    [sym_rune_literal] = ACTIONS(3041),
    [anon_sym_SQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE] = ACTIONS(3041),
    [anon_sym_c_SQUOTE] = ACTIONS(3041),
    [anon_sym_c_DQUOTE] = ACTIONS(3041),
    [anon_sym_r_SQUOTE] = ACTIONS(3041),
    [anon_sym_r_DQUOTE] = ACTIONS(3041),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3041),
    [anon_sym_shared] = ACTIONS(3041),
    [anon_sym_map_LBRACK] = ACTIONS(3041),
    [anon_sym_chan] = ACTIONS(3041),
    [anon_sym_thread] = ACTIONS(3041),
    [anon_sym_atomic] = ACTIONS(3041),
    [anon_sym_assert] = ACTIONS(3041),
    [anon_sym_defer] = ACTIONS(3041),
    [anon_sym_goto] = ACTIONS(3041),
    [anon_sym_break] = ACTIONS(3041),
    [anon_sym_continue] = ACTIONS(3041),
    [anon_sym_return] = ACTIONS(3041),
    [anon_sym_DOLLARfor] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3041),
    [anon_sym_POUND] = ACTIONS(3041),
    [anon_sym_asm] = ACTIONS(3041),
    [anon_sym_AT_LBRACK] = ACTIONS(3041),
  },
  [1834] = {
    [sym_line_comment] = STATE(1834),
    [sym_block_comment] = STATE(1834),
    [ts_builtin_sym_end] = ACTIONS(3047),
    [sym_identifier] = ACTIONS(3049),
    [anon_sym_LF] = ACTIONS(3049),
    [anon_sym_CR] = ACTIONS(3049),
    [anon_sym_CR_LF] = ACTIONS(3049),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_const] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [anon_sym___global] = ACTIONS(3049),
    [anon_sym_type] = ACTIONS(3049),
    [anon_sym_fn] = ACTIONS(3049),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_STAR] = ACTIONS(3049),
    [anon_sym_struct] = ACTIONS(3049),
    [anon_sym_union] = ACTIONS(3049),
    [anon_sym_pub] = ACTIONS(3049),
    [anon_sym_mut] = ACTIONS(3049),
    [anon_sym_enum] = ACTIONS(3049),
    [anon_sym_interface] = ACTIONS(3049),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_BANG] = ACTIONS(3049),
    [anon_sym_go] = ACTIONS(3049),
    [anon_sym_spawn] = ACTIONS(3049),
    [anon_sym_json_DOTdecode] = ACTIONS(3049),
    [anon_sym_LBRACK2] = ACTIONS(3049),
    [anon_sym_TILDE] = ACTIONS(3049),
    [anon_sym_CARET] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_LT_DASH] = ACTIONS(3049),
    [sym_none] = ACTIONS(3049),
    [sym_true] = ACTIONS(3049),
    [sym_false] = ACTIONS(3049),
    [sym_nil] = ACTIONS(3049),
    [anon_sym_if] = ACTIONS(3049),
    [anon_sym_DOLLARif] = ACTIONS(3049),
    [anon_sym_match] = ACTIONS(3049),
    [anon_sym_select] = ACTIONS(3049),
    [anon_sym_lock] = ACTIONS(3049),
    [anon_sym_rlock] = ACTIONS(3049),
    [anon_sym_unsafe] = ACTIONS(3049),
    [anon_sym_sql] = ACTIONS(3049),
    [sym_int_literal] = ACTIONS(3049),
    [sym_float_literal] = ACTIONS(3049),
    [sym_rune_literal] = ACTIONS(3049),
    [anon_sym_SQUOTE] = ACTIONS(3049),
    [anon_sym_DQUOTE] = ACTIONS(3049),
    [anon_sym_c_SQUOTE] = ACTIONS(3049),
    [anon_sym_c_DQUOTE] = ACTIONS(3049),
    [anon_sym_r_SQUOTE] = ACTIONS(3049),
    [anon_sym_r_DQUOTE] = ACTIONS(3049),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3049),
    [anon_sym_shared] = ACTIONS(3049),
    [anon_sym_map_LBRACK] = ACTIONS(3049),
    [anon_sym_chan] = ACTIONS(3049),
    [anon_sym_thread] = ACTIONS(3049),
    [anon_sym_atomic] = ACTIONS(3049),
    [anon_sym_assert] = ACTIONS(3049),
    [anon_sym_defer] = ACTIONS(3049),
    [anon_sym_goto] = ACTIONS(3049),
    [anon_sym_break] = ACTIONS(3049),
    [anon_sym_continue] = ACTIONS(3049),
    [anon_sym_return] = ACTIONS(3049),
    [anon_sym_DOLLARfor] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3049),
    [anon_sym_POUND] = ACTIONS(3049),
    [anon_sym_asm] = ACTIONS(3049),
    [anon_sym_AT_LBRACK] = ACTIONS(3049),
  },
  [1835] = {
    [sym_line_comment] = STATE(1835),
    [sym_block_comment] = STATE(1835),
    [ts_builtin_sym_end] = ACTIONS(4709),
    [sym_identifier] = ACTIONS(4711),
    [anon_sym_LF] = ACTIONS(4711),
    [anon_sym_CR] = ACTIONS(4711),
    [anon_sym_CR_LF] = ACTIONS(4711),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4711),
    [anon_sym_LBRACE] = ACTIONS(4711),
    [anon_sym_const] = ACTIONS(4711),
    [anon_sym_LPAREN] = ACTIONS(4711),
    [anon_sym___global] = ACTIONS(4711),
    [anon_sym_type] = ACTIONS(4711),
    [anon_sym_fn] = ACTIONS(4711),
    [anon_sym_PLUS] = ACTIONS(4711),
    [anon_sym_DASH] = ACTIONS(4711),
    [anon_sym_STAR] = ACTIONS(4711),
    [anon_sym_struct] = ACTIONS(4711),
    [anon_sym_union] = ACTIONS(4711),
    [anon_sym_pub] = ACTIONS(4711),
    [anon_sym_mut] = ACTIONS(4711),
    [anon_sym_enum] = ACTIONS(4711),
    [anon_sym_interface] = ACTIONS(4711),
    [anon_sym_QMARK] = ACTIONS(4711),
    [anon_sym_BANG] = ACTIONS(4711),
    [anon_sym_go] = ACTIONS(4711),
    [anon_sym_spawn] = ACTIONS(4711),
    [anon_sym_json_DOTdecode] = ACTIONS(4711),
    [anon_sym_LBRACK2] = ACTIONS(4711),
    [anon_sym_TILDE] = ACTIONS(4711),
    [anon_sym_CARET] = ACTIONS(4711),
    [anon_sym_AMP] = ACTIONS(4711),
    [anon_sym_LT_DASH] = ACTIONS(4711),
    [sym_none] = ACTIONS(4711),
    [sym_true] = ACTIONS(4711),
    [sym_false] = ACTIONS(4711),
    [sym_nil] = ACTIONS(4711),
    [anon_sym_if] = ACTIONS(4711),
    [anon_sym_DOLLARif] = ACTIONS(4711),
    [anon_sym_match] = ACTIONS(4711),
    [anon_sym_select] = ACTIONS(4711),
    [anon_sym_lock] = ACTIONS(4711),
    [anon_sym_rlock] = ACTIONS(4711),
    [anon_sym_unsafe] = ACTIONS(4711),
    [anon_sym_sql] = ACTIONS(4711),
    [sym_int_literal] = ACTIONS(4711),
    [sym_float_literal] = ACTIONS(4711),
    [sym_rune_literal] = ACTIONS(4711),
    [anon_sym_SQUOTE] = ACTIONS(4711),
    [anon_sym_DQUOTE] = ACTIONS(4711),
    [anon_sym_c_SQUOTE] = ACTIONS(4711),
    [anon_sym_c_DQUOTE] = ACTIONS(4711),
    [anon_sym_r_SQUOTE] = ACTIONS(4711),
    [anon_sym_r_DQUOTE] = ACTIONS(4711),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4711),
    [anon_sym_shared] = ACTIONS(4711),
    [anon_sym_map_LBRACK] = ACTIONS(4711),
    [anon_sym_chan] = ACTIONS(4711),
    [anon_sym_thread] = ACTIONS(4711),
    [anon_sym_atomic] = ACTIONS(4711),
    [anon_sym_assert] = ACTIONS(4711),
    [anon_sym_defer] = ACTIONS(4711),
    [anon_sym_goto] = ACTIONS(4711),
    [anon_sym_break] = ACTIONS(4711),
    [anon_sym_continue] = ACTIONS(4711),
    [anon_sym_return] = ACTIONS(4711),
    [anon_sym_DOLLARfor] = ACTIONS(4711),
    [anon_sym_for] = ACTIONS(4711),
    [anon_sym_POUND] = ACTIONS(4711),
    [anon_sym_asm] = ACTIONS(4711),
    [anon_sym_AT_LBRACK] = ACTIONS(4711),
  },
  [1836] = {
    [sym_line_comment] = STATE(1836),
    [sym_block_comment] = STATE(1836),
    [ts_builtin_sym_end] = ACTIONS(3053),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_LF] = ACTIONS(3055),
    [anon_sym_CR] = ACTIONS(3055),
    [anon_sym_CR_LF] = ACTIONS(3055),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_const] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym___global] = ACTIONS(3055),
    [anon_sym_type] = ACTIONS(3055),
    [anon_sym_fn] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3055),
    [anon_sym_struct] = ACTIONS(3055),
    [anon_sym_union] = ACTIONS(3055),
    [anon_sym_pub] = ACTIONS(3055),
    [anon_sym_mut] = ACTIONS(3055),
    [anon_sym_enum] = ACTIONS(3055),
    [anon_sym_interface] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_BANG] = ACTIONS(3055),
    [anon_sym_go] = ACTIONS(3055),
    [anon_sym_spawn] = ACTIONS(3055),
    [anon_sym_json_DOTdecode] = ACTIONS(3055),
    [anon_sym_LBRACK2] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3055),
    [anon_sym_CARET] = ACTIONS(3055),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT_DASH] = ACTIONS(3055),
    [sym_none] = ACTIONS(3055),
    [sym_true] = ACTIONS(3055),
    [sym_false] = ACTIONS(3055),
    [sym_nil] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_DOLLARif] = ACTIONS(3055),
    [anon_sym_match] = ACTIONS(3055),
    [anon_sym_select] = ACTIONS(3055),
    [anon_sym_lock] = ACTIONS(3055),
    [anon_sym_rlock] = ACTIONS(3055),
    [anon_sym_unsafe] = ACTIONS(3055),
    [anon_sym_sql] = ACTIONS(3055),
    [sym_int_literal] = ACTIONS(3055),
    [sym_float_literal] = ACTIONS(3055),
    [sym_rune_literal] = ACTIONS(3055),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_c_SQUOTE] = ACTIONS(3055),
    [anon_sym_c_DQUOTE] = ACTIONS(3055),
    [anon_sym_r_SQUOTE] = ACTIONS(3055),
    [anon_sym_r_DQUOTE] = ACTIONS(3055),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3055),
    [anon_sym_shared] = ACTIONS(3055),
    [anon_sym_map_LBRACK] = ACTIONS(3055),
    [anon_sym_chan] = ACTIONS(3055),
    [anon_sym_thread] = ACTIONS(3055),
    [anon_sym_atomic] = ACTIONS(3055),
    [anon_sym_assert] = ACTIONS(3055),
    [anon_sym_defer] = ACTIONS(3055),
    [anon_sym_goto] = ACTIONS(3055),
    [anon_sym_break] = ACTIONS(3055),
    [anon_sym_continue] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_DOLLARfor] = ACTIONS(3055),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_POUND] = ACTIONS(3055),
    [anon_sym_asm] = ACTIONS(3055),
    [anon_sym_AT_LBRACK] = ACTIONS(3055),
  },
  [1837] = {
    [sym_line_comment] = STATE(1837),
    [sym_block_comment] = STATE(1837),
    [ts_builtin_sym_end] = ACTIONS(4713),
    [sym_identifier] = ACTIONS(4715),
    [anon_sym_LF] = ACTIONS(4715),
    [anon_sym_CR] = ACTIONS(4715),
    [anon_sym_CR_LF] = ACTIONS(4715),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4715),
    [anon_sym_LBRACE] = ACTIONS(4715),
    [anon_sym_const] = ACTIONS(4715),
    [anon_sym_LPAREN] = ACTIONS(4715),
    [anon_sym___global] = ACTIONS(4715),
    [anon_sym_type] = ACTIONS(4715),
    [anon_sym_fn] = ACTIONS(4715),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_DASH] = ACTIONS(4715),
    [anon_sym_STAR] = ACTIONS(4715),
    [anon_sym_struct] = ACTIONS(4715),
    [anon_sym_union] = ACTIONS(4715),
    [anon_sym_pub] = ACTIONS(4715),
    [anon_sym_mut] = ACTIONS(4715),
    [anon_sym_enum] = ACTIONS(4715),
    [anon_sym_interface] = ACTIONS(4715),
    [anon_sym_QMARK] = ACTIONS(4715),
    [anon_sym_BANG] = ACTIONS(4715),
    [anon_sym_go] = ACTIONS(4715),
    [anon_sym_spawn] = ACTIONS(4715),
    [anon_sym_json_DOTdecode] = ACTIONS(4715),
    [anon_sym_LBRACK2] = ACTIONS(4715),
    [anon_sym_TILDE] = ACTIONS(4715),
    [anon_sym_CARET] = ACTIONS(4715),
    [anon_sym_AMP] = ACTIONS(4715),
    [anon_sym_LT_DASH] = ACTIONS(4715),
    [sym_none] = ACTIONS(4715),
    [sym_true] = ACTIONS(4715),
    [sym_false] = ACTIONS(4715),
    [sym_nil] = ACTIONS(4715),
    [anon_sym_if] = ACTIONS(4715),
    [anon_sym_DOLLARif] = ACTIONS(4715),
    [anon_sym_match] = ACTIONS(4715),
    [anon_sym_select] = ACTIONS(4715),
    [anon_sym_lock] = ACTIONS(4715),
    [anon_sym_rlock] = ACTIONS(4715),
    [anon_sym_unsafe] = ACTIONS(4715),
    [anon_sym_sql] = ACTIONS(4715),
    [sym_int_literal] = ACTIONS(4715),
    [sym_float_literal] = ACTIONS(4715),
    [sym_rune_literal] = ACTIONS(4715),
    [anon_sym_SQUOTE] = ACTIONS(4715),
    [anon_sym_DQUOTE] = ACTIONS(4715),
    [anon_sym_c_SQUOTE] = ACTIONS(4715),
    [anon_sym_c_DQUOTE] = ACTIONS(4715),
    [anon_sym_r_SQUOTE] = ACTIONS(4715),
    [anon_sym_r_DQUOTE] = ACTIONS(4715),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4715),
    [anon_sym_shared] = ACTIONS(4715),
    [anon_sym_map_LBRACK] = ACTIONS(4715),
    [anon_sym_chan] = ACTIONS(4715),
    [anon_sym_thread] = ACTIONS(4715),
    [anon_sym_atomic] = ACTIONS(4715),
    [anon_sym_assert] = ACTIONS(4715),
    [anon_sym_defer] = ACTIONS(4715),
    [anon_sym_goto] = ACTIONS(4715),
    [anon_sym_break] = ACTIONS(4715),
    [anon_sym_continue] = ACTIONS(4715),
    [anon_sym_return] = ACTIONS(4715),
    [anon_sym_DOLLARfor] = ACTIONS(4715),
    [anon_sym_for] = ACTIONS(4715),
    [anon_sym_POUND] = ACTIONS(4715),
    [anon_sym_asm] = ACTIONS(4715),
    [anon_sym_AT_LBRACK] = ACTIONS(4715),
  },
  [1838] = {
    [sym_line_comment] = STATE(1838),
    [sym_block_comment] = STATE(1838),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2489),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_LF] = ACTIONS(851),
    [anon_sym_CR] = ACTIONS(851),
    [anon_sym_CR_LF] = ACTIONS(851),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(851),
    [anon_sym_DOT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(851),
    [anon_sym_SLASH] = ACTIONS(851),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_PLUS_PLUS] = ACTIONS(851),
    [anon_sym_DASH_DASH] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PIPE] = ACTIONS(851),
    [anon_sym_LBRACK2] = ACTIONS(851),
    [anon_sym_CARET] = ACTIONS(851),
    [anon_sym_AMP] = ACTIONS(851),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_CARET] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(851),
    [anon_sym_PIPE_PIPE] = ACTIONS(851),
    [anon_sym_or] = ACTIONS(851),
    [anon_sym_QMARK_DOT] = ACTIONS(851),
    [anon_sym_POUND_LBRACK] = ACTIONS(851),
    [anon_sym_is] = ACTIONS(851),
    [anon_sym_BANGis] = ACTIONS(851),
    [anon_sym_in] = ACTIONS(851),
    [anon_sym_BANGin] = ACTIONS(851),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(351),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [1839] = {
    [sym_line_comment] = STATE(1839),
    [sym_block_comment] = STATE(1839),
    [ts_builtin_sym_end] = ACTIONS(2839),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_LF] = ACTIONS(2841),
    [anon_sym_CR] = ACTIONS(2841),
    [anon_sym_CR_LF] = ACTIONS(2841),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_const] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2841),
    [anon_sym___global] = ACTIONS(2841),
    [anon_sym_type] = ACTIONS(2841),
    [anon_sym_fn] = ACTIONS(2841),
    [anon_sym_PLUS] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(2841),
    [anon_sym_struct] = ACTIONS(2841),
    [anon_sym_union] = ACTIONS(2841),
    [anon_sym_pub] = ACTIONS(2841),
    [anon_sym_mut] = ACTIONS(2841),
    [anon_sym_enum] = ACTIONS(2841),
    [anon_sym_interface] = ACTIONS(2841),
    [anon_sym_QMARK] = ACTIONS(2841),
    [anon_sym_BANG] = ACTIONS(2841),
    [anon_sym_go] = ACTIONS(2841),
    [anon_sym_spawn] = ACTIONS(2841),
    [anon_sym_json_DOTdecode] = ACTIONS(2841),
    [anon_sym_LBRACK2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2841),
    [anon_sym_LT_DASH] = ACTIONS(2841),
    [sym_none] = ACTIONS(2841),
    [sym_true] = ACTIONS(2841),
    [sym_false] = ACTIONS(2841),
    [sym_nil] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2841),
    [anon_sym_DOLLARif] = ACTIONS(2841),
    [anon_sym_match] = ACTIONS(2841),
    [anon_sym_select] = ACTIONS(2841),
    [anon_sym_lock] = ACTIONS(2841),
    [anon_sym_rlock] = ACTIONS(2841),
    [anon_sym_unsafe] = ACTIONS(2841),
    [anon_sym_sql] = ACTIONS(2841),
    [sym_int_literal] = ACTIONS(2841),
    [sym_float_literal] = ACTIONS(2841),
    [sym_rune_literal] = ACTIONS(2841),
    [anon_sym_SQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE] = ACTIONS(2841),
    [anon_sym_c_SQUOTE] = ACTIONS(2841),
    [anon_sym_c_DQUOTE] = ACTIONS(2841),
    [anon_sym_r_SQUOTE] = ACTIONS(2841),
    [anon_sym_r_DQUOTE] = ACTIONS(2841),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2841),
    [anon_sym_shared] = ACTIONS(2841),
    [anon_sym_map_LBRACK] = ACTIONS(2841),
    [anon_sym_chan] = ACTIONS(2841),
    [anon_sym_thread] = ACTIONS(2841),
    [anon_sym_atomic] = ACTIONS(2841),
    [anon_sym_assert] = ACTIONS(2841),
    [anon_sym_defer] = ACTIONS(2841),
    [anon_sym_goto] = ACTIONS(2841),
    [anon_sym_break] = ACTIONS(2841),
    [anon_sym_continue] = ACTIONS(2841),
    [anon_sym_return] = ACTIONS(2841),
    [anon_sym_DOLLARfor] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2841),
    [anon_sym_POUND] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2841),
    [anon_sym_AT_LBRACK] = ACTIONS(2841),
  },
  [1840] = {
    [sym_line_comment] = STATE(1840),
    [sym_block_comment] = STATE(1840),
    [ts_builtin_sym_end] = ACTIONS(4717),
    [sym_identifier] = ACTIONS(4719),
    [anon_sym_LF] = ACTIONS(4719),
    [anon_sym_CR] = ACTIONS(4719),
    [anon_sym_CR_LF] = ACTIONS(4719),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4719),
    [anon_sym_LBRACE] = ACTIONS(4719),
    [anon_sym_const] = ACTIONS(4719),
    [anon_sym_LPAREN] = ACTIONS(4719),
    [anon_sym___global] = ACTIONS(4719),
    [anon_sym_type] = ACTIONS(4719),
    [anon_sym_fn] = ACTIONS(4719),
    [anon_sym_PLUS] = ACTIONS(4719),
    [anon_sym_DASH] = ACTIONS(4719),
    [anon_sym_STAR] = ACTIONS(4719),
    [anon_sym_struct] = ACTIONS(4719),
    [anon_sym_union] = ACTIONS(4719),
    [anon_sym_pub] = ACTIONS(4719),
    [anon_sym_mut] = ACTIONS(4719),
    [anon_sym_enum] = ACTIONS(4719),
    [anon_sym_interface] = ACTIONS(4719),
    [anon_sym_QMARK] = ACTIONS(4719),
    [anon_sym_BANG] = ACTIONS(4719),
    [anon_sym_go] = ACTIONS(4719),
    [anon_sym_spawn] = ACTIONS(4719),
    [anon_sym_json_DOTdecode] = ACTIONS(4719),
    [anon_sym_LBRACK2] = ACTIONS(4719),
    [anon_sym_TILDE] = ACTIONS(4719),
    [anon_sym_CARET] = ACTIONS(4719),
    [anon_sym_AMP] = ACTIONS(4719),
    [anon_sym_LT_DASH] = ACTIONS(4719),
    [sym_none] = ACTIONS(4719),
    [sym_true] = ACTIONS(4719),
    [sym_false] = ACTIONS(4719),
    [sym_nil] = ACTIONS(4719),
    [anon_sym_if] = ACTIONS(4719),
    [anon_sym_DOLLARif] = ACTIONS(4719),
    [anon_sym_match] = ACTIONS(4719),
    [anon_sym_select] = ACTIONS(4719),
    [anon_sym_lock] = ACTIONS(4719),
    [anon_sym_rlock] = ACTIONS(4719),
    [anon_sym_unsafe] = ACTIONS(4719),
    [anon_sym_sql] = ACTIONS(4719),
    [sym_int_literal] = ACTIONS(4719),
    [sym_float_literal] = ACTIONS(4719),
    [sym_rune_literal] = ACTIONS(4719),
    [anon_sym_SQUOTE] = ACTIONS(4719),
    [anon_sym_DQUOTE] = ACTIONS(4719),
    [anon_sym_c_SQUOTE] = ACTIONS(4719),
    [anon_sym_c_DQUOTE] = ACTIONS(4719),
    [anon_sym_r_SQUOTE] = ACTIONS(4719),
    [anon_sym_r_DQUOTE] = ACTIONS(4719),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4719),
    [anon_sym_shared] = ACTIONS(4719),
    [anon_sym_map_LBRACK] = ACTIONS(4719),
    [anon_sym_chan] = ACTIONS(4719),
    [anon_sym_thread] = ACTIONS(4719),
    [anon_sym_atomic] = ACTIONS(4719),
    [anon_sym_assert] = ACTIONS(4719),
    [anon_sym_defer] = ACTIONS(4719),
    [anon_sym_goto] = ACTIONS(4719),
    [anon_sym_break] = ACTIONS(4719),
    [anon_sym_continue] = ACTIONS(4719),
    [anon_sym_return] = ACTIONS(4719),
    [anon_sym_DOLLARfor] = ACTIONS(4719),
    [anon_sym_for] = ACTIONS(4719),
    [anon_sym_POUND] = ACTIONS(4719),
    [anon_sym_asm] = ACTIONS(4719),
    [anon_sym_AT_LBRACK] = ACTIONS(4719),
  },
  [1841] = {
    [sym_line_comment] = STATE(1841),
    [sym_block_comment] = STATE(1841),
    [ts_builtin_sym_end] = ACTIONS(4721),
    [sym_identifier] = ACTIONS(4723),
    [anon_sym_LF] = ACTIONS(4723),
    [anon_sym_CR] = ACTIONS(4723),
    [anon_sym_CR_LF] = ACTIONS(4723),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4723),
    [anon_sym_LBRACE] = ACTIONS(4723),
    [anon_sym_const] = ACTIONS(4723),
    [anon_sym_LPAREN] = ACTIONS(4723),
    [anon_sym___global] = ACTIONS(4723),
    [anon_sym_type] = ACTIONS(4723),
    [anon_sym_fn] = ACTIONS(4723),
    [anon_sym_PLUS] = ACTIONS(4723),
    [anon_sym_DASH] = ACTIONS(4723),
    [anon_sym_STAR] = ACTIONS(4723),
    [anon_sym_struct] = ACTIONS(4723),
    [anon_sym_union] = ACTIONS(4723),
    [anon_sym_pub] = ACTIONS(4723),
    [anon_sym_mut] = ACTIONS(4723),
    [anon_sym_enum] = ACTIONS(4723),
    [anon_sym_interface] = ACTIONS(4723),
    [anon_sym_QMARK] = ACTIONS(4723),
    [anon_sym_BANG] = ACTIONS(4723),
    [anon_sym_go] = ACTIONS(4723),
    [anon_sym_spawn] = ACTIONS(4723),
    [anon_sym_json_DOTdecode] = ACTIONS(4723),
    [anon_sym_LBRACK2] = ACTIONS(4723),
    [anon_sym_TILDE] = ACTIONS(4723),
    [anon_sym_CARET] = ACTIONS(4723),
    [anon_sym_AMP] = ACTIONS(4723),
    [anon_sym_LT_DASH] = ACTIONS(4723),
    [sym_none] = ACTIONS(4723),
    [sym_true] = ACTIONS(4723),
    [sym_false] = ACTIONS(4723),
    [sym_nil] = ACTIONS(4723),
    [anon_sym_if] = ACTIONS(4723),
    [anon_sym_DOLLARif] = ACTIONS(4723),
    [anon_sym_match] = ACTIONS(4723),
    [anon_sym_select] = ACTIONS(4723),
    [anon_sym_lock] = ACTIONS(4723),
    [anon_sym_rlock] = ACTIONS(4723),
    [anon_sym_unsafe] = ACTIONS(4723),
    [anon_sym_sql] = ACTIONS(4723),
    [sym_int_literal] = ACTIONS(4723),
    [sym_float_literal] = ACTIONS(4723),
    [sym_rune_literal] = ACTIONS(4723),
    [anon_sym_SQUOTE] = ACTIONS(4723),
    [anon_sym_DQUOTE] = ACTIONS(4723),
    [anon_sym_c_SQUOTE] = ACTIONS(4723),
    [anon_sym_c_DQUOTE] = ACTIONS(4723),
    [anon_sym_r_SQUOTE] = ACTIONS(4723),
    [anon_sym_r_DQUOTE] = ACTIONS(4723),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4723),
    [anon_sym_shared] = ACTIONS(4723),
    [anon_sym_map_LBRACK] = ACTIONS(4723),
    [anon_sym_chan] = ACTIONS(4723),
    [anon_sym_thread] = ACTIONS(4723),
    [anon_sym_atomic] = ACTIONS(4723),
    [anon_sym_assert] = ACTIONS(4723),
    [anon_sym_defer] = ACTIONS(4723),
    [anon_sym_goto] = ACTIONS(4723),
    [anon_sym_break] = ACTIONS(4723),
    [anon_sym_continue] = ACTIONS(4723),
    [anon_sym_return] = ACTIONS(4723),
    [anon_sym_DOLLARfor] = ACTIONS(4723),
    [anon_sym_for] = ACTIONS(4723),
    [anon_sym_POUND] = ACTIONS(4723),
    [anon_sym_asm] = ACTIONS(4723),
    [anon_sym_AT_LBRACK] = ACTIONS(4723),
  },
  [1842] = {
    [sym_line_comment] = STATE(1842),
    [sym_block_comment] = STATE(1842),
    [ts_builtin_sym_end] = ACTIONS(2399),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_LF] = ACTIONS(2401),
    [anon_sym_CR] = ACTIONS(2401),
    [anon_sym_CR_LF] = ACTIONS(2401),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(2401),
    [anon_sym_const] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2401),
    [anon_sym___global] = ACTIONS(2401),
    [anon_sym_type] = ACTIONS(2401),
    [anon_sym_fn] = ACTIONS(2401),
    [anon_sym_PLUS] = ACTIONS(2401),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_STAR] = ACTIONS(2401),
    [anon_sym_struct] = ACTIONS(2401),
    [anon_sym_union] = ACTIONS(2401),
    [anon_sym_pub] = ACTIONS(2401),
    [anon_sym_mut] = ACTIONS(2401),
    [anon_sym_enum] = ACTIONS(2401),
    [anon_sym_interface] = ACTIONS(2401),
    [anon_sym_QMARK] = ACTIONS(2401),
    [anon_sym_BANG] = ACTIONS(2401),
    [anon_sym_go] = ACTIONS(2401),
    [anon_sym_spawn] = ACTIONS(2401),
    [anon_sym_json_DOTdecode] = ACTIONS(2401),
    [anon_sym_LBRACK2] = ACTIONS(2401),
    [anon_sym_TILDE] = ACTIONS(2401),
    [anon_sym_CARET] = ACTIONS(2401),
    [anon_sym_AMP] = ACTIONS(2401),
    [anon_sym_LT_DASH] = ACTIONS(2401),
    [sym_none] = ACTIONS(2401),
    [sym_true] = ACTIONS(2401),
    [sym_false] = ACTIONS(2401),
    [sym_nil] = ACTIONS(2401),
    [anon_sym_if] = ACTIONS(2401),
    [anon_sym_DOLLARif] = ACTIONS(2401),
    [anon_sym_match] = ACTIONS(2401),
    [anon_sym_select] = ACTIONS(2401),
    [anon_sym_lock] = ACTIONS(2401),
    [anon_sym_rlock] = ACTIONS(2401),
    [anon_sym_unsafe] = ACTIONS(2401),
    [anon_sym_sql] = ACTIONS(2401),
    [sym_int_literal] = ACTIONS(2401),
    [sym_float_literal] = ACTIONS(2401),
    [sym_rune_literal] = ACTIONS(2401),
    [anon_sym_SQUOTE] = ACTIONS(2401),
    [anon_sym_DQUOTE] = ACTIONS(2401),
    [anon_sym_c_SQUOTE] = ACTIONS(2401),
    [anon_sym_c_DQUOTE] = ACTIONS(2401),
    [anon_sym_r_SQUOTE] = ACTIONS(2401),
    [anon_sym_r_DQUOTE] = ACTIONS(2401),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2401),
    [anon_sym_shared] = ACTIONS(2401),
    [anon_sym_map_LBRACK] = ACTIONS(2401),
    [anon_sym_chan] = ACTIONS(2401),
    [anon_sym_thread] = ACTIONS(2401),
    [anon_sym_atomic] = ACTIONS(2401),
    [anon_sym_assert] = ACTIONS(2401),
    [anon_sym_defer] = ACTIONS(2401),
    [anon_sym_goto] = ACTIONS(2401),
    [anon_sym_break] = ACTIONS(2401),
    [anon_sym_continue] = ACTIONS(2401),
    [anon_sym_return] = ACTIONS(2401),
    [anon_sym_DOLLARfor] = ACTIONS(2401),
    [anon_sym_for] = ACTIONS(2401),
    [anon_sym_POUND] = ACTIONS(2401),
    [anon_sym_asm] = ACTIONS(2401),
    [anon_sym_AT_LBRACK] = ACTIONS(2401),
  },
  [1843] = {
    [sym_line_comment] = STATE(1843),
    [sym_block_comment] = STATE(1843),
    [ts_builtin_sym_end] = ACTIONS(4725),
    [sym_identifier] = ACTIONS(4727),
    [anon_sym_LF] = ACTIONS(4727),
    [anon_sym_CR] = ACTIONS(4727),
    [anon_sym_CR_LF] = ACTIONS(4727),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4727),
    [anon_sym_LBRACE] = ACTIONS(4727),
    [anon_sym_const] = ACTIONS(4727),
    [anon_sym_LPAREN] = ACTIONS(4727),
    [anon_sym___global] = ACTIONS(4727),
    [anon_sym_type] = ACTIONS(4727),
    [anon_sym_fn] = ACTIONS(4727),
    [anon_sym_PLUS] = ACTIONS(4727),
    [anon_sym_DASH] = ACTIONS(4727),
    [anon_sym_STAR] = ACTIONS(4727),
    [anon_sym_struct] = ACTIONS(4727),
    [anon_sym_union] = ACTIONS(4727),
    [anon_sym_pub] = ACTIONS(4727),
    [anon_sym_mut] = ACTIONS(4727),
    [anon_sym_enum] = ACTIONS(4727),
    [anon_sym_interface] = ACTIONS(4727),
    [anon_sym_QMARK] = ACTIONS(4727),
    [anon_sym_BANG] = ACTIONS(4727),
    [anon_sym_go] = ACTIONS(4727),
    [anon_sym_spawn] = ACTIONS(4727),
    [anon_sym_json_DOTdecode] = ACTIONS(4727),
    [anon_sym_LBRACK2] = ACTIONS(4727),
    [anon_sym_TILDE] = ACTIONS(4727),
    [anon_sym_CARET] = ACTIONS(4727),
    [anon_sym_AMP] = ACTIONS(4727),
    [anon_sym_LT_DASH] = ACTIONS(4727),
    [sym_none] = ACTIONS(4727),
    [sym_true] = ACTIONS(4727),
    [sym_false] = ACTIONS(4727),
    [sym_nil] = ACTIONS(4727),
    [anon_sym_if] = ACTIONS(4727),
    [anon_sym_DOLLARif] = ACTIONS(4727),
    [anon_sym_match] = ACTIONS(4727),
    [anon_sym_select] = ACTIONS(4727),
    [anon_sym_lock] = ACTIONS(4727),
    [anon_sym_rlock] = ACTIONS(4727),
    [anon_sym_unsafe] = ACTIONS(4727),
    [anon_sym_sql] = ACTIONS(4727),
    [sym_int_literal] = ACTIONS(4727),
    [sym_float_literal] = ACTIONS(4727),
    [sym_rune_literal] = ACTIONS(4727),
    [anon_sym_SQUOTE] = ACTIONS(4727),
    [anon_sym_DQUOTE] = ACTIONS(4727),
    [anon_sym_c_SQUOTE] = ACTIONS(4727),
    [anon_sym_c_DQUOTE] = ACTIONS(4727),
    [anon_sym_r_SQUOTE] = ACTIONS(4727),
    [anon_sym_r_DQUOTE] = ACTIONS(4727),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4727),
    [anon_sym_shared] = ACTIONS(4727),
    [anon_sym_map_LBRACK] = ACTIONS(4727),
    [anon_sym_chan] = ACTIONS(4727),
    [anon_sym_thread] = ACTIONS(4727),
    [anon_sym_atomic] = ACTIONS(4727),
    [anon_sym_assert] = ACTIONS(4727),
    [anon_sym_defer] = ACTIONS(4727),
    [anon_sym_goto] = ACTIONS(4727),
    [anon_sym_break] = ACTIONS(4727),
    [anon_sym_continue] = ACTIONS(4727),
    [anon_sym_return] = ACTIONS(4727),
    [anon_sym_DOLLARfor] = ACTIONS(4727),
    [anon_sym_for] = ACTIONS(4727),
    [anon_sym_POUND] = ACTIONS(4727),
    [anon_sym_asm] = ACTIONS(4727),
    [anon_sym_AT_LBRACK] = ACTIONS(4727),
  },
  [1844] = {
    [sym_line_comment] = STATE(1844),
    [sym_block_comment] = STATE(1844),
    [ts_builtin_sym_end] = ACTIONS(3244),
    [sym_identifier] = ACTIONS(3246),
    [anon_sym_LF] = ACTIONS(3246),
    [anon_sym_CR] = ACTIONS(3246),
    [anon_sym_CR_LF] = ACTIONS(3246),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3246),
    [anon_sym_LBRACE] = ACTIONS(3246),
    [anon_sym_const] = ACTIONS(3246),
    [anon_sym_LPAREN] = ACTIONS(3246),
    [anon_sym___global] = ACTIONS(3246),
    [anon_sym_type] = ACTIONS(3246),
    [anon_sym_fn] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3246),
    [anon_sym_DASH] = ACTIONS(3246),
    [anon_sym_STAR] = ACTIONS(3246),
    [anon_sym_struct] = ACTIONS(3246),
    [anon_sym_union] = ACTIONS(3246),
    [anon_sym_pub] = ACTIONS(3246),
    [anon_sym_mut] = ACTIONS(3246),
    [anon_sym_enum] = ACTIONS(3246),
    [anon_sym_interface] = ACTIONS(3246),
    [anon_sym_QMARK] = ACTIONS(3246),
    [anon_sym_BANG] = ACTIONS(3246),
    [anon_sym_go] = ACTIONS(3246),
    [anon_sym_spawn] = ACTIONS(3246),
    [anon_sym_json_DOTdecode] = ACTIONS(3246),
    [anon_sym_LBRACK2] = ACTIONS(3246),
    [anon_sym_TILDE] = ACTIONS(3246),
    [anon_sym_CARET] = ACTIONS(3246),
    [anon_sym_AMP] = ACTIONS(3246),
    [anon_sym_LT_DASH] = ACTIONS(3246),
    [sym_none] = ACTIONS(3246),
    [sym_true] = ACTIONS(3246),
    [sym_false] = ACTIONS(3246),
    [sym_nil] = ACTIONS(3246),
    [anon_sym_if] = ACTIONS(3246),
    [anon_sym_DOLLARif] = ACTIONS(3246),
    [anon_sym_match] = ACTIONS(3246),
    [anon_sym_select] = ACTIONS(3246),
    [anon_sym_lock] = ACTIONS(3246),
    [anon_sym_rlock] = ACTIONS(3246),
    [anon_sym_unsafe] = ACTIONS(3246),
    [anon_sym_sql] = ACTIONS(3246),
    [sym_int_literal] = ACTIONS(3246),
    [sym_float_literal] = ACTIONS(3246),
    [sym_rune_literal] = ACTIONS(3246),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_DQUOTE] = ACTIONS(3246),
    [anon_sym_c_SQUOTE] = ACTIONS(3246),
    [anon_sym_c_DQUOTE] = ACTIONS(3246),
    [anon_sym_r_SQUOTE] = ACTIONS(3246),
    [anon_sym_r_DQUOTE] = ACTIONS(3246),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3246),
    [anon_sym_shared] = ACTIONS(3246),
    [anon_sym_map_LBRACK] = ACTIONS(3246),
    [anon_sym_chan] = ACTIONS(3246),
    [anon_sym_thread] = ACTIONS(3246),
    [anon_sym_atomic] = ACTIONS(3246),
    [anon_sym_assert] = ACTIONS(3246),
    [anon_sym_defer] = ACTIONS(3246),
    [anon_sym_goto] = ACTIONS(3246),
    [anon_sym_break] = ACTIONS(3246),
    [anon_sym_continue] = ACTIONS(3246),
    [anon_sym_return] = ACTIONS(3246),
    [anon_sym_DOLLARfor] = ACTIONS(3246),
    [anon_sym_for] = ACTIONS(3246),
    [anon_sym_POUND] = ACTIONS(3246),
    [anon_sym_asm] = ACTIONS(3246),
    [anon_sym_AT_LBRACK] = ACTIONS(3246),
  },
  [1845] = {
    [sym_line_comment] = STATE(1845),
    [sym_block_comment] = STATE(1845),
    [ts_builtin_sym_end] = ACTIONS(4729),
    [sym_identifier] = ACTIONS(4731),
    [anon_sym_LF] = ACTIONS(4731),
    [anon_sym_CR] = ACTIONS(4731),
    [anon_sym_CR_LF] = ACTIONS(4731),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4731),
    [anon_sym_LBRACE] = ACTIONS(4731),
    [anon_sym_const] = ACTIONS(4731),
    [anon_sym_LPAREN] = ACTIONS(4731),
    [anon_sym___global] = ACTIONS(4731),
    [anon_sym_type] = ACTIONS(4731),
    [anon_sym_fn] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4731),
    [anon_sym_struct] = ACTIONS(4731),
    [anon_sym_union] = ACTIONS(4731),
    [anon_sym_pub] = ACTIONS(4731),
    [anon_sym_mut] = ACTIONS(4731),
    [anon_sym_enum] = ACTIONS(4731),
    [anon_sym_interface] = ACTIONS(4731),
    [anon_sym_QMARK] = ACTIONS(4731),
    [anon_sym_BANG] = ACTIONS(4731),
    [anon_sym_go] = ACTIONS(4731),
    [anon_sym_spawn] = ACTIONS(4731),
    [anon_sym_json_DOTdecode] = ACTIONS(4731),
    [anon_sym_LBRACK2] = ACTIONS(4731),
    [anon_sym_TILDE] = ACTIONS(4731),
    [anon_sym_CARET] = ACTIONS(4731),
    [anon_sym_AMP] = ACTIONS(4731),
    [anon_sym_LT_DASH] = ACTIONS(4731),
    [sym_none] = ACTIONS(4731),
    [sym_true] = ACTIONS(4731),
    [sym_false] = ACTIONS(4731),
    [sym_nil] = ACTIONS(4731),
    [anon_sym_if] = ACTIONS(4731),
    [anon_sym_DOLLARif] = ACTIONS(4731),
    [anon_sym_match] = ACTIONS(4731),
    [anon_sym_select] = ACTIONS(4731),
    [anon_sym_lock] = ACTIONS(4731),
    [anon_sym_rlock] = ACTIONS(4731),
    [anon_sym_unsafe] = ACTIONS(4731),
    [anon_sym_sql] = ACTIONS(4731),
    [sym_int_literal] = ACTIONS(4731),
    [sym_float_literal] = ACTIONS(4731),
    [sym_rune_literal] = ACTIONS(4731),
    [anon_sym_SQUOTE] = ACTIONS(4731),
    [anon_sym_DQUOTE] = ACTIONS(4731),
    [anon_sym_c_SQUOTE] = ACTIONS(4731),
    [anon_sym_c_DQUOTE] = ACTIONS(4731),
    [anon_sym_r_SQUOTE] = ACTIONS(4731),
    [anon_sym_r_DQUOTE] = ACTIONS(4731),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4731),
    [anon_sym_shared] = ACTIONS(4731),
    [anon_sym_map_LBRACK] = ACTIONS(4731),
    [anon_sym_chan] = ACTIONS(4731),
    [anon_sym_thread] = ACTIONS(4731),
    [anon_sym_atomic] = ACTIONS(4731),
    [anon_sym_assert] = ACTIONS(4731),
    [anon_sym_defer] = ACTIONS(4731),
    [anon_sym_goto] = ACTIONS(4731),
    [anon_sym_break] = ACTIONS(4731),
    [anon_sym_continue] = ACTIONS(4731),
    [anon_sym_return] = ACTIONS(4731),
    [anon_sym_DOLLARfor] = ACTIONS(4731),
    [anon_sym_for] = ACTIONS(4731),
    [anon_sym_POUND] = ACTIONS(4731),
    [anon_sym_asm] = ACTIONS(4731),
    [anon_sym_AT_LBRACK] = ACTIONS(4731),
  },
  [1846] = {
    [sym_line_comment] = STATE(1846),
    [sym_block_comment] = STATE(1846),
    [ts_builtin_sym_end] = ACTIONS(4733),
    [sym_identifier] = ACTIONS(4735),
    [anon_sym_LF] = ACTIONS(4735),
    [anon_sym_CR] = ACTIONS(4735),
    [anon_sym_CR_LF] = ACTIONS(4735),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4735),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [anon_sym_const] = ACTIONS(4735),
    [anon_sym_LPAREN] = ACTIONS(4735),
    [anon_sym___global] = ACTIONS(4735),
    [anon_sym_type] = ACTIONS(4735),
    [anon_sym_fn] = ACTIONS(4735),
    [anon_sym_PLUS] = ACTIONS(4735),
    [anon_sym_DASH] = ACTIONS(4735),
    [anon_sym_STAR] = ACTIONS(4735),
    [anon_sym_struct] = ACTIONS(4735),
    [anon_sym_union] = ACTIONS(4735),
    [anon_sym_pub] = ACTIONS(4735),
    [anon_sym_mut] = ACTIONS(4735),
    [anon_sym_enum] = ACTIONS(4735),
    [anon_sym_interface] = ACTIONS(4735),
    [anon_sym_QMARK] = ACTIONS(4735),
    [anon_sym_BANG] = ACTIONS(4735),
    [anon_sym_go] = ACTIONS(4735),
    [anon_sym_spawn] = ACTIONS(4735),
    [anon_sym_json_DOTdecode] = ACTIONS(4735),
    [anon_sym_LBRACK2] = ACTIONS(4735),
    [anon_sym_TILDE] = ACTIONS(4735),
    [anon_sym_CARET] = ACTIONS(4735),
    [anon_sym_AMP] = ACTIONS(4735),
    [anon_sym_LT_DASH] = ACTIONS(4735),
    [sym_none] = ACTIONS(4735),
    [sym_true] = ACTIONS(4735),
    [sym_false] = ACTIONS(4735),
    [sym_nil] = ACTIONS(4735),
    [anon_sym_if] = ACTIONS(4735),
    [anon_sym_DOLLARif] = ACTIONS(4735),
    [anon_sym_match] = ACTIONS(4735),
    [anon_sym_select] = ACTIONS(4735),
    [anon_sym_lock] = ACTIONS(4735),
    [anon_sym_rlock] = ACTIONS(4735),
    [anon_sym_unsafe] = ACTIONS(4735),
    [anon_sym_sql] = ACTIONS(4735),
    [sym_int_literal] = ACTIONS(4735),
    [sym_float_literal] = ACTIONS(4735),
    [sym_rune_literal] = ACTIONS(4735),
    [anon_sym_SQUOTE] = ACTIONS(4735),
    [anon_sym_DQUOTE] = ACTIONS(4735),
    [anon_sym_c_SQUOTE] = ACTIONS(4735),
    [anon_sym_c_DQUOTE] = ACTIONS(4735),
    [anon_sym_r_SQUOTE] = ACTIONS(4735),
    [anon_sym_r_DQUOTE] = ACTIONS(4735),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4735),
    [anon_sym_shared] = ACTIONS(4735),
    [anon_sym_map_LBRACK] = ACTIONS(4735),
    [anon_sym_chan] = ACTIONS(4735),
    [anon_sym_thread] = ACTIONS(4735),
    [anon_sym_atomic] = ACTIONS(4735),
    [anon_sym_assert] = ACTIONS(4735),
    [anon_sym_defer] = ACTIONS(4735),
    [anon_sym_goto] = ACTIONS(4735),
    [anon_sym_break] = ACTIONS(4735),
    [anon_sym_continue] = ACTIONS(4735),
    [anon_sym_return] = ACTIONS(4735),
    [anon_sym_DOLLARfor] = ACTIONS(4735),
    [anon_sym_for] = ACTIONS(4735),
    [anon_sym_POUND] = ACTIONS(4735),
    [anon_sym_asm] = ACTIONS(4735),
    [anon_sym_AT_LBRACK] = ACTIONS(4735),
  },
  [1847] = {
    [sym_line_comment] = STATE(1847),
    [sym_block_comment] = STATE(1847),
    [ts_builtin_sym_end] = ACTIONS(4737),
    [sym_identifier] = ACTIONS(4739),
    [anon_sym_LF] = ACTIONS(4739),
    [anon_sym_CR] = ACTIONS(4739),
    [anon_sym_CR_LF] = ACTIONS(4739),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4739),
    [anon_sym_LBRACE] = ACTIONS(4739),
    [anon_sym_const] = ACTIONS(4739),
    [anon_sym_LPAREN] = ACTIONS(4739),
    [anon_sym___global] = ACTIONS(4739),
    [anon_sym_type] = ACTIONS(4739),
    [anon_sym_fn] = ACTIONS(4739),
    [anon_sym_PLUS] = ACTIONS(4739),
    [anon_sym_DASH] = ACTIONS(4739),
    [anon_sym_STAR] = ACTIONS(4739),
    [anon_sym_struct] = ACTIONS(4739),
    [anon_sym_union] = ACTIONS(4739),
    [anon_sym_pub] = ACTIONS(4739),
    [anon_sym_mut] = ACTIONS(4739),
    [anon_sym_enum] = ACTIONS(4739),
    [anon_sym_interface] = ACTIONS(4739),
    [anon_sym_QMARK] = ACTIONS(4739),
    [anon_sym_BANG] = ACTIONS(4739),
    [anon_sym_go] = ACTIONS(4739),
    [anon_sym_spawn] = ACTIONS(4739),
    [anon_sym_json_DOTdecode] = ACTIONS(4739),
    [anon_sym_LBRACK2] = ACTIONS(4739),
    [anon_sym_TILDE] = ACTIONS(4739),
    [anon_sym_CARET] = ACTIONS(4739),
    [anon_sym_AMP] = ACTIONS(4739),
    [anon_sym_LT_DASH] = ACTIONS(4739),
    [sym_none] = ACTIONS(4739),
    [sym_true] = ACTIONS(4739),
    [sym_false] = ACTIONS(4739),
    [sym_nil] = ACTIONS(4739),
    [anon_sym_if] = ACTIONS(4739),
    [anon_sym_DOLLARif] = ACTIONS(4739),
    [anon_sym_match] = ACTIONS(4739),
    [anon_sym_select] = ACTIONS(4739),
    [anon_sym_lock] = ACTIONS(4739),
    [anon_sym_rlock] = ACTIONS(4739),
    [anon_sym_unsafe] = ACTIONS(4739),
    [anon_sym_sql] = ACTIONS(4739),
    [sym_int_literal] = ACTIONS(4739),
    [sym_float_literal] = ACTIONS(4739),
    [sym_rune_literal] = ACTIONS(4739),
    [anon_sym_SQUOTE] = ACTIONS(4739),
    [anon_sym_DQUOTE] = ACTIONS(4739),
    [anon_sym_c_SQUOTE] = ACTIONS(4739),
    [anon_sym_c_DQUOTE] = ACTIONS(4739),
    [anon_sym_r_SQUOTE] = ACTIONS(4739),
    [anon_sym_r_DQUOTE] = ACTIONS(4739),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4739),
    [anon_sym_shared] = ACTIONS(4739),
    [anon_sym_map_LBRACK] = ACTIONS(4739),
    [anon_sym_chan] = ACTIONS(4739),
    [anon_sym_thread] = ACTIONS(4739),
    [anon_sym_atomic] = ACTIONS(4739),
    [anon_sym_assert] = ACTIONS(4739),
    [anon_sym_defer] = ACTIONS(4739),
    [anon_sym_goto] = ACTIONS(4739),
    [anon_sym_break] = ACTIONS(4739),
    [anon_sym_continue] = ACTIONS(4739),
    [anon_sym_return] = ACTIONS(4739),
    [anon_sym_DOLLARfor] = ACTIONS(4739),
    [anon_sym_for] = ACTIONS(4739),
    [anon_sym_POUND] = ACTIONS(4739),
    [anon_sym_asm] = ACTIONS(4739),
    [anon_sym_AT_LBRACK] = ACTIONS(4739),
  },
  [1848] = {
    [sym_line_comment] = STATE(1848),
    [sym_block_comment] = STATE(1848),
    [ts_builtin_sym_end] = ACTIONS(3354),
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_LF] = ACTIONS(3356),
    [anon_sym_CR] = ACTIONS(3356),
    [anon_sym_CR_LF] = ACTIONS(3356),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3356),
    [anon_sym_const] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3356),
    [anon_sym___global] = ACTIONS(3356),
    [anon_sym_type] = ACTIONS(3356),
    [anon_sym_fn] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_STAR] = ACTIONS(3356),
    [anon_sym_struct] = ACTIONS(3356),
    [anon_sym_union] = ACTIONS(3356),
    [anon_sym_pub] = ACTIONS(3356),
    [anon_sym_mut] = ACTIONS(3356),
    [anon_sym_enum] = ACTIONS(3356),
    [anon_sym_interface] = ACTIONS(3356),
    [anon_sym_QMARK] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3356),
    [anon_sym_go] = ACTIONS(3356),
    [anon_sym_spawn] = ACTIONS(3356),
    [anon_sym_json_DOTdecode] = ACTIONS(3356),
    [anon_sym_LBRACK2] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3356),
    [anon_sym_CARET] = ACTIONS(3356),
    [anon_sym_AMP] = ACTIONS(3356),
    [anon_sym_LT_DASH] = ACTIONS(3356),
    [sym_none] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_nil] = ACTIONS(3356),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_DOLLARif] = ACTIONS(3356),
    [anon_sym_match] = ACTIONS(3356),
    [anon_sym_select] = ACTIONS(3356),
    [anon_sym_lock] = ACTIONS(3356),
    [anon_sym_rlock] = ACTIONS(3356),
    [anon_sym_unsafe] = ACTIONS(3356),
    [anon_sym_sql] = ACTIONS(3356),
    [sym_int_literal] = ACTIONS(3356),
    [sym_float_literal] = ACTIONS(3356),
    [sym_rune_literal] = ACTIONS(3356),
    [anon_sym_SQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [anon_sym_c_SQUOTE] = ACTIONS(3356),
    [anon_sym_c_DQUOTE] = ACTIONS(3356),
    [anon_sym_r_SQUOTE] = ACTIONS(3356),
    [anon_sym_r_DQUOTE] = ACTIONS(3356),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3356),
    [anon_sym_shared] = ACTIONS(3356),
    [anon_sym_map_LBRACK] = ACTIONS(3356),
    [anon_sym_chan] = ACTIONS(3356),
    [anon_sym_thread] = ACTIONS(3356),
    [anon_sym_atomic] = ACTIONS(3356),
    [anon_sym_assert] = ACTIONS(3356),
    [anon_sym_defer] = ACTIONS(3356),
    [anon_sym_goto] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_DOLLARfor] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_POUND] = ACTIONS(3356),
    [anon_sym_asm] = ACTIONS(3356),
    [anon_sym_AT_LBRACK] = ACTIONS(3356),
  },
  [1849] = {
    [sym_line_comment] = STATE(1849),
    [sym_block_comment] = STATE(1849),
    [ts_builtin_sym_end] = ACTIONS(4741),
    [sym_identifier] = ACTIONS(4743),
    [anon_sym_LF] = ACTIONS(4743),
    [anon_sym_CR] = ACTIONS(4743),
    [anon_sym_CR_LF] = ACTIONS(4743),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4743),
    [anon_sym_LBRACE] = ACTIONS(4743),
    [anon_sym_const] = ACTIONS(4743),
    [anon_sym_LPAREN] = ACTIONS(4743),
    [anon_sym___global] = ACTIONS(4743),
    [anon_sym_type] = ACTIONS(4743),
    [anon_sym_fn] = ACTIONS(4743),
    [anon_sym_PLUS] = ACTIONS(4743),
    [anon_sym_DASH] = ACTIONS(4743),
    [anon_sym_STAR] = ACTIONS(4743),
    [anon_sym_struct] = ACTIONS(4743),
    [anon_sym_union] = ACTIONS(4743),
    [anon_sym_pub] = ACTIONS(4743),
    [anon_sym_mut] = ACTIONS(4743),
    [anon_sym_enum] = ACTIONS(4743),
    [anon_sym_interface] = ACTIONS(4743),
    [anon_sym_QMARK] = ACTIONS(4743),
    [anon_sym_BANG] = ACTIONS(4743),
    [anon_sym_go] = ACTIONS(4743),
    [anon_sym_spawn] = ACTIONS(4743),
    [anon_sym_json_DOTdecode] = ACTIONS(4743),
    [anon_sym_LBRACK2] = ACTIONS(4743),
    [anon_sym_TILDE] = ACTIONS(4743),
    [anon_sym_CARET] = ACTIONS(4743),
    [anon_sym_AMP] = ACTIONS(4743),
    [anon_sym_LT_DASH] = ACTIONS(4743),
    [sym_none] = ACTIONS(4743),
    [sym_true] = ACTIONS(4743),
    [sym_false] = ACTIONS(4743),
    [sym_nil] = ACTIONS(4743),
    [anon_sym_if] = ACTIONS(4743),
    [anon_sym_DOLLARif] = ACTIONS(4743),
    [anon_sym_match] = ACTIONS(4743),
    [anon_sym_select] = ACTIONS(4743),
    [anon_sym_lock] = ACTIONS(4743),
    [anon_sym_rlock] = ACTIONS(4743),
    [anon_sym_unsafe] = ACTIONS(4743),
    [anon_sym_sql] = ACTIONS(4743),
    [sym_int_literal] = ACTIONS(4743),
    [sym_float_literal] = ACTIONS(4743),
    [sym_rune_literal] = ACTIONS(4743),
    [anon_sym_SQUOTE] = ACTIONS(4743),
    [anon_sym_DQUOTE] = ACTIONS(4743),
    [anon_sym_c_SQUOTE] = ACTIONS(4743),
    [anon_sym_c_DQUOTE] = ACTIONS(4743),
    [anon_sym_r_SQUOTE] = ACTIONS(4743),
    [anon_sym_r_DQUOTE] = ACTIONS(4743),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4743),
    [anon_sym_shared] = ACTIONS(4743),
    [anon_sym_map_LBRACK] = ACTIONS(4743),
    [anon_sym_chan] = ACTIONS(4743),
    [anon_sym_thread] = ACTIONS(4743),
    [anon_sym_atomic] = ACTIONS(4743),
    [anon_sym_assert] = ACTIONS(4743),
    [anon_sym_defer] = ACTIONS(4743),
    [anon_sym_goto] = ACTIONS(4743),
    [anon_sym_break] = ACTIONS(4743),
    [anon_sym_continue] = ACTIONS(4743),
    [anon_sym_return] = ACTIONS(4743),
    [anon_sym_DOLLARfor] = ACTIONS(4743),
    [anon_sym_for] = ACTIONS(4743),
    [anon_sym_POUND] = ACTIONS(4743),
    [anon_sym_asm] = ACTIONS(4743),
    [anon_sym_AT_LBRACK] = ACTIONS(4743),
  },
  [1850] = {
    [sym_line_comment] = STATE(1850),
    [sym_block_comment] = STATE(1850),
    [ts_builtin_sym_end] = ACTIONS(4745),
    [sym_identifier] = ACTIONS(4747),
    [anon_sym_LF] = ACTIONS(4747),
    [anon_sym_CR] = ACTIONS(4747),
    [anon_sym_CR_LF] = ACTIONS(4747),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4747),
    [anon_sym_LBRACE] = ACTIONS(4747),
    [anon_sym_const] = ACTIONS(4747),
    [anon_sym_LPAREN] = ACTIONS(4747),
    [anon_sym___global] = ACTIONS(4747),
    [anon_sym_type] = ACTIONS(4747),
    [anon_sym_fn] = ACTIONS(4747),
    [anon_sym_PLUS] = ACTIONS(4747),
    [anon_sym_DASH] = ACTIONS(4747),
    [anon_sym_STAR] = ACTIONS(4747),
    [anon_sym_struct] = ACTIONS(4747),
    [anon_sym_union] = ACTIONS(4747),
    [anon_sym_pub] = ACTIONS(4747),
    [anon_sym_mut] = ACTIONS(4747),
    [anon_sym_enum] = ACTIONS(4747),
    [anon_sym_interface] = ACTIONS(4747),
    [anon_sym_QMARK] = ACTIONS(4747),
    [anon_sym_BANG] = ACTIONS(4747),
    [anon_sym_go] = ACTIONS(4747),
    [anon_sym_spawn] = ACTIONS(4747),
    [anon_sym_json_DOTdecode] = ACTIONS(4747),
    [anon_sym_LBRACK2] = ACTIONS(4747),
    [anon_sym_TILDE] = ACTIONS(4747),
    [anon_sym_CARET] = ACTIONS(4747),
    [anon_sym_AMP] = ACTIONS(4747),
    [anon_sym_LT_DASH] = ACTIONS(4747),
    [sym_none] = ACTIONS(4747),
    [sym_true] = ACTIONS(4747),
    [sym_false] = ACTIONS(4747),
    [sym_nil] = ACTIONS(4747),
    [anon_sym_if] = ACTIONS(4747),
    [anon_sym_DOLLARif] = ACTIONS(4747),
    [anon_sym_match] = ACTIONS(4747),
    [anon_sym_select] = ACTIONS(4747),
    [anon_sym_lock] = ACTIONS(4747),
    [anon_sym_rlock] = ACTIONS(4747),
    [anon_sym_unsafe] = ACTIONS(4747),
    [anon_sym_sql] = ACTIONS(4747),
    [sym_int_literal] = ACTIONS(4747),
    [sym_float_literal] = ACTIONS(4747),
    [sym_rune_literal] = ACTIONS(4747),
    [anon_sym_SQUOTE] = ACTIONS(4747),
    [anon_sym_DQUOTE] = ACTIONS(4747),
    [anon_sym_c_SQUOTE] = ACTIONS(4747),
    [anon_sym_c_DQUOTE] = ACTIONS(4747),
    [anon_sym_r_SQUOTE] = ACTIONS(4747),
    [anon_sym_r_DQUOTE] = ACTIONS(4747),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4747),
    [anon_sym_shared] = ACTIONS(4747),
    [anon_sym_map_LBRACK] = ACTIONS(4747),
    [anon_sym_chan] = ACTIONS(4747),
    [anon_sym_thread] = ACTIONS(4747),
    [anon_sym_atomic] = ACTIONS(4747),
    [anon_sym_assert] = ACTIONS(4747),
    [anon_sym_defer] = ACTIONS(4747),
    [anon_sym_goto] = ACTIONS(4747),
    [anon_sym_break] = ACTIONS(4747),
    [anon_sym_continue] = ACTIONS(4747),
    [anon_sym_return] = ACTIONS(4747),
    [anon_sym_DOLLARfor] = ACTIONS(4747),
    [anon_sym_for] = ACTIONS(4747),
    [anon_sym_POUND] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4747),
    [anon_sym_AT_LBRACK] = ACTIONS(4747),
  },
  [1851] = {
    [sym_line_comment] = STATE(1851),
    [sym_block_comment] = STATE(1851),
    [ts_builtin_sym_end] = ACTIONS(2965),
    [sym_identifier] = ACTIONS(2967),
    [anon_sym_LF] = ACTIONS(2967),
    [anon_sym_CR] = ACTIONS(2967),
    [anon_sym_CR_LF] = ACTIONS(2967),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(2967),
    [anon_sym___global] = ACTIONS(2967),
    [anon_sym_type] = ACTIONS(2967),
    [anon_sym_fn] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2967),
    [anon_sym_struct] = ACTIONS(2967),
    [anon_sym_union] = ACTIONS(2967),
    [anon_sym_pub] = ACTIONS(2967),
    [anon_sym_mut] = ACTIONS(2967),
    [anon_sym_enum] = ACTIONS(2967),
    [anon_sym_interface] = ACTIONS(2967),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_BANG] = ACTIONS(2967),
    [anon_sym_go] = ACTIONS(2967),
    [anon_sym_spawn] = ACTIONS(2967),
    [anon_sym_json_DOTdecode] = ACTIONS(2967),
    [anon_sym_LBRACK2] = ACTIONS(2967),
    [anon_sym_TILDE] = ACTIONS(2967),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_AMP] = ACTIONS(2967),
    [anon_sym_LT_DASH] = ACTIONS(2967),
    [sym_none] = ACTIONS(2967),
    [sym_true] = ACTIONS(2967),
    [sym_false] = ACTIONS(2967),
    [sym_nil] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_DOLLARif] = ACTIONS(2967),
    [anon_sym_match] = ACTIONS(2967),
    [anon_sym_select] = ACTIONS(2967),
    [anon_sym_lock] = ACTIONS(2967),
    [anon_sym_rlock] = ACTIONS(2967),
    [anon_sym_unsafe] = ACTIONS(2967),
    [anon_sym_sql] = ACTIONS(2967),
    [sym_int_literal] = ACTIONS(2967),
    [sym_float_literal] = ACTIONS(2967),
    [sym_rune_literal] = ACTIONS(2967),
    [anon_sym_SQUOTE] = ACTIONS(2967),
    [anon_sym_DQUOTE] = ACTIONS(2967),
    [anon_sym_c_SQUOTE] = ACTIONS(2967),
    [anon_sym_c_DQUOTE] = ACTIONS(2967),
    [anon_sym_r_SQUOTE] = ACTIONS(2967),
    [anon_sym_r_DQUOTE] = ACTIONS(2967),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2967),
    [anon_sym_shared] = ACTIONS(2967),
    [anon_sym_map_LBRACK] = ACTIONS(2967),
    [anon_sym_chan] = ACTIONS(2967),
    [anon_sym_thread] = ACTIONS(2967),
    [anon_sym_atomic] = ACTIONS(2967),
    [anon_sym_assert] = ACTIONS(2967),
    [anon_sym_defer] = ACTIONS(2967),
    [anon_sym_goto] = ACTIONS(2967),
    [anon_sym_break] = ACTIONS(2967),
    [anon_sym_continue] = ACTIONS(2967),
    [anon_sym_return] = ACTIONS(2967),
    [anon_sym_DOLLARfor] = ACTIONS(2967),
    [anon_sym_for] = ACTIONS(2967),
    [anon_sym_POUND] = ACTIONS(2967),
    [anon_sym_asm] = ACTIONS(2967),
    [anon_sym_AT_LBRACK] = ACTIONS(2967),
  },
  [1852] = {
    [sym_line_comment] = STATE(1852),
    [sym_block_comment] = STATE(1852),
    [ts_builtin_sym_end] = ACTIONS(2145),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_CR] = ACTIONS(2147),
    [anon_sym_CR_LF] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_const] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym___global] = ACTIONS(2147),
    [anon_sym_type] = ACTIONS(2147),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_union] = ACTIONS(2147),
    [anon_sym_pub] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_enum] = ACTIONS(2147),
    [anon_sym_interface] = ACTIONS(2147),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2147),
    [sym_rune_literal] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_c_SQUOTE] = ACTIONS(2147),
    [anon_sym_c_DQUOTE] = ACTIONS(2147),
    [anon_sym_r_SQUOTE] = ACTIONS(2147),
    [anon_sym_r_DQUOTE] = ACTIONS(2147),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2147),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
    [anon_sym_assert] = ACTIONS(2147),
    [anon_sym_defer] = ACTIONS(2147),
    [anon_sym_goto] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_continue] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2147),
    [anon_sym_DOLLARfor] = ACTIONS(2147),
    [anon_sym_for] = ACTIONS(2147),
    [anon_sym_POUND] = ACTIONS(2147),
    [anon_sym_asm] = ACTIONS(2147),
    [anon_sym_AT_LBRACK] = ACTIONS(2147),
  },
  [1853] = {
    [sym_line_comment] = STATE(1853),
    [sym_block_comment] = STATE(1853),
    [ts_builtin_sym_end] = ACTIONS(3248),
    [sym_identifier] = ACTIONS(3250),
    [anon_sym_LF] = ACTIONS(3250),
    [anon_sym_CR] = ACTIONS(3250),
    [anon_sym_CR_LF] = ACTIONS(3250),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_LPAREN] = ACTIONS(3250),
    [anon_sym___global] = ACTIONS(3250),
    [anon_sym_type] = ACTIONS(3250),
    [anon_sym_fn] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_STAR] = ACTIONS(3250),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_union] = ACTIONS(3250),
    [anon_sym_pub] = ACTIONS(3250),
    [anon_sym_mut] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [anon_sym_interface] = ACTIONS(3250),
    [anon_sym_QMARK] = ACTIONS(3250),
    [anon_sym_BANG] = ACTIONS(3250),
    [anon_sym_go] = ACTIONS(3250),
    [anon_sym_spawn] = ACTIONS(3250),
    [anon_sym_json_DOTdecode] = ACTIONS(3250),
    [anon_sym_LBRACK2] = ACTIONS(3250),
    [anon_sym_TILDE] = ACTIONS(3250),
    [anon_sym_CARET] = ACTIONS(3250),
    [anon_sym_AMP] = ACTIONS(3250),
    [anon_sym_LT_DASH] = ACTIONS(3250),
    [sym_none] = ACTIONS(3250),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [sym_nil] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_DOLLARif] = ACTIONS(3250),
    [anon_sym_match] = ACTIONS(3250),
    [anon_sym_select] = ACTIONS(3250),
    [anon_sym_lock] = ACTIONS(3250),
    [anon_sym_rlock] = ACTIONS(3250),
    [anon_sym_unsafe] = ACTIONS(3250),
    [anon_sym_sql] = ACTIONS(3250),
    [sym_int_literal] = ACTIONS(3250),
    [sym_float_literal] = ACTIONS(3250),
    [sym_rune_literal] = ACTIONS(3250),
    [anon_sym_SQUOTE] = ACTIONS(3250),
    [anon_sym_DQUOTE] = ACTIONS(3250),
    [anon_sym_c_SQUOTE] = ACTIONS(3250),
    [anon_sym_c_DQUOTE] = ACTIONS(3250),
    [anon_sym_r_SQUOTE] = ACTIONS(3250),
    [anon_sym_r_DQUOTE] = ACTIONS(3250),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3250),
    [anon_sym_shared] = ACTIONS(3250),
    [anon_sym_map_LBRACK] = ACTIONS(3250),
    [anon_sym_chan] = ACTIONS(3250),
    [anon_sym_thread] = ACTIONS(3250),
    [anon_sym_atomic] = ACTIONS(3250),
    [anon_sym_assert] = ACTIONS(3250),
    [anon_sym_defer] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_DOLLARfor] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_POUND] = ACTIONS(3250),
    [anon_sym_asm] = ACTIONS(3250),
    [anon_sym_AT_LBRACK] = ACTIONS(3250),
  },
  [1854] = {
    [sym_line_comment] = STATE(1854),
    [sym_block_comment] = STATE(1854),
    [ts_builtin_sym_end] = ACTIONS(4389),
    [sym_identifier] = ACTIONS(4391),
    [anon_sym_LF] = ACTIONS(4391),
    [anon_sym_CR] = ACTIONS(4391),
    [anon_sym_CR_LF] = ACTIONS(4391),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(4391),
    [anon_sym_const] = ACTIONS(4391),
    [anon_sym_LPAREN] = ACTIONS(4391),
    [anon_sym___global] = ACTIONS(4391),
    [anon_sym_type] = ACTIONS(4391),
    [anon_sym_fn] = ACTIONS(4391),
    [anon_sym_PLUS] = ACTIONS(4391),
    [anon_sym_DASH] = ACTIONS(4391),
    [anon_sym_STAR] = ACTIONS(4391),
    [anon_sym_struct] = ACTIONS(4391),
    [anon_sym_union] = ACTIONS(4391),
    [anon_sym_pub] = ACTIONS(4391),
    [anon_sym_mut] = ACTIONS(4391),
    [anon_sym_enum] = ACTIONS(4391),
    [anon_sym_interface] = ACTIONS(4391),
    [anon_sym_QMARK] = ACTIONS(4391),
    [anon_sym_BANG] = ACTIONS(4391),
    [anon_sym_go] = ACTIONS(4391),
    [anon_sym_spawn] = ACTIONS(4391),
    [anon_sym_json_DOTdecode] = ACTIONS(4391),
    [anon_sym_LBRACK2] = ACTIONS(4391),
    [anon_sym_TILDE] = ACTIONS(4391),
    [anon_sym_CARET] = ACTIONS(4391),
    [anon_sym_AMP] = ACTIONS(4391),
    [anon_sym_LT_DASH] = ACTIONS(4391),
    [sym_none] = ACTIONS(4391),
    [sym_true] = ACTIONS(4391),
    [sym_false] = ACTIONS(4391),
    [sym_nil] = ACTIONS(4391),
    [anon_sym_if] = ACTIONS(4391),
    [anon_sym_DOLLARif] = ACTIONS(4391),
    [anon_sym_match] = ACTIONS(4391),
    [anon_sym_select] = ACTIONS(4391),
    [anon_sym_lock] = ACTIONS(4391),
    [anon_sym_rlock] = ACTIONS(4391),
    [anon_sym_unsafe] = ACTIONS(4391),
    [anon_sym_sql] = ACTIONS(4391),
    [sym_int_literal] = ACTIONS(4391),
    [sym_float_literal] = ACTIONS(4391),
    [sym_rune_literal] = ACTIONS(4391),
    [anon_sym_SQUOTE] = ACTIONS(4391),
    [anon_sym_DQUOTE] = ACTIONS(4391),
    [anon_sym_c_SQUOTE] = ACTIONS(4391),
    [anon_sym_c_DQUOTE] = ACTIONS(4391),
    [anon_sym_r_SQUOTE] = ACTIONS(4391),
    [anon_sym_r_DQUOTE] = ACTIONS(4391),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4391),
    [anon_sym_shared] = ACTIONS(4391),
    [anon_sym_map_LBRACK] = ACTIONS(4391),
    [anon_sym_chan] = ACTIONS(4391),
    [anon_sym_thread] = ACTIONS(4391),
    [anon_sym_atomic] = ACTIONS(4391),
    [anon_sym_assert] = ACTIONS(4391),
    [anon_sym_defer] = ACTIONS(4391),
    [anon_sym_goto] = ACTIONS(4391),
    [anon_sym_break] = ACTIONS(4391),
    [anon_sym_continue] = ACTIONS(4391),
    [anon_sym_return] = ACTIONS(4391),
    [anon_sym_DOLLARfor] = ACTIONS(4391),
    [anon_sym_for] = ACTIONS(4391),
    [anon_sym_POUND] = ACTIONS(4391),
    [anon_sym_asm] = ACTIONS(4391),
    [anon_sym_AT_LBRACK] = ACTIONS(4391),
  },
  [1855] = {
    [sym_line_comment] = STATE(1855),
    [sym_block_comment] = STATE(1855),
    [ts_builtin_sym_end] = ACTIONS(4749),
    [sym_identifier] = ACTIONS(4751),
    [anon_sym_LF] = ACTIONS(4751),
    [anon_sym_CR] = ACTIONS(4751),
    [anon_sym_CR_LF] = ACTIONS(4751),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4751),
    [anon_sym_LBRACE] = ACTIONS(4751),
    [anon_sym_const] = ACTIONS(4751),
    [anon_sym_LPAREN] = ACTIONS(4751),
    [anon_sym___global] = ACTIONS(4751),
    [anon_sym_type] = ACTIONS(4751),
    [anon_sym_fn] = ACTIONS(4751),
    [anon_sym_PLUS] = ACTIONS(4751),
    [anon_sym_DASH] = ACTIONS(4751),
    [anon_sym_STAR] = ACTIONS(4751),
    [anon_sym_struct] = ACTIONS(4751),
    [anon_sym_union] = ACTIONS(4751),
    [anon_sym_pub] = ACTIONS(4751),
    [anon_sym_mut] = ACTIONS(4751),
    [anon_sym_enum] = ACTIONS(4751),
    [anon_sym_interface] = ACTIONS(4751),
    [anon_sym_QMARK] = ACTIONS(4751),
    [anon_sym_BANG] = ACTIONS(4751),
    [anon_sym_go] = ACTIONS(4751),
    [anon_sym_spawn] = ACTIONS(4751),
    [anon_sym_json_DOTdecode] = ACTIONS(4751),
    [anon_sym_LBRACK2] = ACTIONS(4751),
    [anon_sym_TILDE] = ACTIONS(4751),
    [anon_sym_CARET] = ACTIONS(4751),
    [anon_sym_AMP] = ACTIONS(4751),
    [anon_sym_LT_DASH] = ACTIONS(4751),
    [sym_none] = ACTIONS(4751),
    [sym_true] = ACTIONS(4751),
    [sym_false] = ACTIONS(4751),
    [sym_nil] = ACTIONS(4751),
    [anon_sym_if] = ACTIONS(4751),
    [anon_sym_DOLLARif] = ACTIONS(4751),
    [anon_sym_match] = ACTIONS(4751),
    [anon_sym_select] = ACTIONS(4751),
    [anon_sym_lock] = ACTIONS(4751),
    [anon_sym_rlock] = ACTIONS(4751),
    [anon_sym_unsafe] = ACTIONS(4751),
    [anon_sym_sql] = ACTIONS(4751),
    [sym_int_literal] = ACTIONS(4751),
    [sym_float_literal] = ACTIONS(4751),
    [sym_rune_literal] = ACTIONS(4751),
    [anon_sym_SQUOTE] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4751),
    [anon_sym_c_SQUOTE] = ACTIONS(4751),
    [anon_sym_c_DQUOTE] = ACTIONS(4751),
    [anon_sym_r_SQUOTE] = ACTIONS(4751),
    [anon_sym_r_DQUOTE] = ACTIONS(4751),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4751),
    [anon_sym_shared] = ACTIONS(4751),
    [anon_sym_map_LBRACK] = ACTIONS(4751),
    [anon_sym_chan] = ACTIONS(4751),
    [anon_sym_thread] = ACTIONS(4751),
    [anon_sym_atomic] = ACTIONS(4751),
    [anon_sym_assert] = ACTIONS(4751),
    [anon_sym_defer] = ACTIONS(4751),
    [anon_sym_goto] = ACTIONS(4751),
    [anon_sym_break] = ACTIONS(4751),
    [anon_sym_continue] = ACTIONS(4751),
    [anon_sym_return] = ACTIONS(4751),
    [anon_sym_DOLLARfor] = ACTIONS(4751),
    [anon_sym_for] = ACTIONS(4751),
    [anon_sym_POUND] = ACTIONS(4751),
    [anon_sym_asm] = ACTIONS(4751),
    [anon_sym_AT_LBRACK] = ACTIONS(4751),
  },
  [1856] = {
    [sym_line_comment] = STATE(1856),
    [sym_block_comment] = STATE(1856),
    [ts_builtin_sym_end] = ACTIONS(2999),
    [sym_identifier] = ACTIONS(3001),
    [anon_sym_LF] = ACTIONS(3001),
    [anon_sym_CR] = ACTIONS(3001),
    [anon_sym_CR_LF] = ACTIONS(3001),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_const] = ACTIONS(3001),
    [anon_sym_LPAREN] = ACTIONS(3001),
    [anon_sym___global] = ACTIONS(3001),
    [anon_sym_type] = ACTIONS(3001),
    [anon_sym_fn] = ACTIONS(3001),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_STAR] = ACTIONS(3001),
    [anon_sym_struct] = ACTIONS(3001),
    [anon_sym_union] = ACTIONS(3001),
    [anon_sym_pub] = ACTIONS(3001),
    [anon_sym_mut] = ACTIONS(3001),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_interface] = ACTIONS(3001),
    [anon_sym_QMARK] = ACTIONS(3001),
    [anon_sym_BANG] = ACTIONS(3001),
    [anon_sym_go] = ACTIONS(3001),
    [anon_sym_spawn] = ACTIONS(3001),
    [anon_sym_json_DOTdecode] = ACTIONS(3001),
    [anon_sym_LBRACK2] = ACTIONS(3001),
    [anon_sym_TILDE] = ACTIONS(3001),
    [anon_sym_CARET] = ACTIONS(3001),
    [anon_sym_AMP] = ACTIONS(3001),
    [anon_sym_LT_DASH] = ACTIONS(3001),
    [sym_none] = ACTIONS(3001),
    [sym_true] = ACTIONS(3001),
    [sym_false] = ACTIONS(3001),
    [sym_nil] = ACTIONS(3001),
    [anon_sym_if] = ACTIONS(3001),
    [anon_sym_DOLLARif] = ACTIONS(3001),
    [anon_sym_match] = ACTIONS(3001),
    [anon_sym_select] = ACTIONS(3001),
    [anon_sym_lock] = ACTIONS(3001),
    [anon_sym_rlock] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(3001),
    [anon_sym_sql] = ACTIONS(3001),
    [sym_int_literal] = ACTIONS(3001),
    [sym_float_literal] = ACTIONS(3001),
    [sym_rune_literal] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3001),
    [anon_sym_DQUOTE] = ACTIONS(3001),
    [anon_sym_c_SQUOTE] = ACTIONS(3001),
    [anon_sym_c_DQUOTE] = ACTIONS(3001),
    [anon_sym_r_SQUOTE] = ACTIONS(3001),
    [anon_sym_r_DQUOTE] = ACTIONS(3001),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3001),
    [anon_sym_shared] = ACTIONS(3001),
    [anon_sym_map_LBRACK] = ACTIONS(3001),
    [anon_sym_chan] = ACTIONS(3001),
    [anon_sym_thread] = ACTIONS(3001),
    [anon_sym_atomic] = ACTIONS(3001),
    [anon_sym_assert] = ACTIONS(3001),
    [anon_sym_defer] = ACTIONS(3001),
    [anon_sym_goto] = ACTIONS(3001),
    [anon_sym_break] = ACTIONS(3001),
    [anon_sym_continue] = ACTIONS(3001),
    [anon_sym_return] = ACTIONS(3001),
    [anon_sym_DOLLARfor] = ACTIONS(3001),
    [anon_sym_for] = ACTIONS(3001),
    [anon_sym_POUND] = ACTIONS(3001),
    [anon_sym_asm] = ACTIONS(3001),
    [anon_sym_AT_LBRACK] = ACTIONS(3001),
  },
  [1857] = {
    [sym_line_comment] = STATE(1857),
    [sym_block_comment] = STATE(1857),
    [ts_builtin_sym_end] = ACTIONS(4753),
    [sym_identifier] = ACTIONS(4755),
    [anon_sym_LF] = ACTIONS(4755),
    [anon_sym_CR] = ACTIONS(4755),
    [anon_sym_CR_LF] = ACTIONS(4755),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4755),
    [anon_sym_LBRACE] = ACTIONS(4755),
    [anon_sym_const] = ACTIONS(4755),
    [anon_sym_LPAREN] = ACTIONS(4755),
    [anon_sym___global] = ACTIONS(4755),
    [anon_sym_type] = ACTIONS(4755),
    [anon_sym_fn] = ACTIONS(4755),
    [anon_sym_PLUS] = ACTIONS(4755),
    [anon_sym_DASH] = ACTIONS(4755),
    [anon_sym_STAR] = ACTIONS(4755),
    [anon_sym_struct] = ACTIONS(4755),
    [anon_sym_union] = ACTIONS(4755),
    [anon_sym_pub] = ACTIONS(4755),
    [anon_sym_mut] = ACTIONS(4755),
    [anon_sym_enum] = ACTIONS(4755),
    [anon_sym_interface] = ACTIONS(4755),
    [anon_sym_QMARK] = ACTIONS(4755),
    [anon_sym_BANG] = ACTIONS(4755),
    [anon_sym_go] = ACTIONS(4755),
    [anon_sym_spawn] = ACTIONS(4755),
    [anon_sym_json_DOTdecode] = ACTIONS(4755),
    [anon_sym_LBRACK2] = ACTIONS(4755),
    [anon_sym_TILDE] = ACTIONS(4755),
    [anon_sym_CARET] = ACTIONS(4755),
    [anon_sym_AMP] = ACTIONS(4755),
    [anon_sym_LT_DASH] = ACTIONS(4755),
    [sym_none] = ACTIONS(4755),
    [sym_true] = ACTIONS(4755),
    [sym_false] = ACTIONS(4755),
    [sym_nil] = ACTIONS(4755),
    [anon_sym_if] = ACTIONS(4755),
    [anon_sym_DOLLARif] = ACTIONS(4755),
    [anon_sym_match] = ACTIONS(4755),
    [anon_sym_select] = ACTIONS(4755),
    [anon_sym_lock] = ACTIONS(4755),
    [anon_sym_rlock] = ACTIONS(4755),
    [anon_sym_unsafe] = ACTIONS(4755),
    [anon_sym_sql] = ACTIONS(4755),
    [sym_int_literal] = ACTIONS(4755),
    [sym_float_literal] = ACTIONS(4755),
    [sym_rune_literal] = ACTIONS(4755),
    [anon_sym_SQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_c_SQUOTE] = ACTIONS(4755),
    [anon_sym_c_DQUOTE] = ACTIONS(4755),
    [anon_sym_r_SQUOTE] = ACTIONS(4755),
    [anon_sym_r_DQUOTE] = ACTIONS(4755),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4755),
    [anon_sym_shared] = ACTIONS(4755),
    [anon_sym_map_LBRACK] = ACTIONS(4755),
    [anon_sym_chan] = ACTIONS(4755),
    [anon_sym_thread] = ACTIONS(4755),
    [anon_sym_atomic] = ACTIONS(4755),
    [anon_sym_assert] = ACTIONS(4755),
    [anon_sym_defer] = ACTIONS(4755),
    [anon_sym_goto] = ACTIONS(4755),
    [anon_sym_break] = ACTIONS(4755),
    [anon_sym_continue] = ACTIONS(4755),
    [anon_sym_return] = ACTIONS(4755),
    [anon_sym_DOLLARfor] = ACTIONS(4755),
    [anon_sym_for] = ACTIONS(4755),
    [anon_sym_POUND] = ACTIONS(4755),
    [anon_sym_asm] = ACTIONS(4755),
    [anon_sym_AT_LBRACK] = ACTIONS(4755),
  },
  [1858] = {
    [sym_line_comment] = STATE(1858),
    [sym_block_comment] = STATE(1858),
    [ts_builtin_sym_end] = ACTIONS(3298),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_LF] = ACTIONS(3300),
    [anon_sym_CR] = ACTIONS(3300),
    [anon_sym_CR_LF] = ACTIONS(3300),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3300),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_const] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym___global] = ACTIONS(3300),
    [anon_sym_type] = ACTIONS(3300),
    [anon_sym_fn] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_struct] = ACTIONS(3300),
    [anon_sym_union] = ACTIONS(3300),
    [anon_sym_pub] = ACTIONS(3300),
    [anon_sym_mut] = ACTIONS(3300),
    [anon_sym_enum] = ACTIONS(3300),
    [anon_sym_interface] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_go] = ACTIONS(3300),
    [anon_sym_spawn] = ACTIONS(3300),
    [anon_sym_json_DOTdecode] = ACTIONS(3300),
    [anon_sym_LBRACK2] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [anon_sym_CARET] = ACTIONS(3300),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LT_DASH] = ACTIONS(3300),
    [sym_none] = ACTIONS(3300),
    [sym_true] = ACTIONS(3300),
    [sym_false] = ACTIONS(3300),
    [sym_nil] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_DOLLARif] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_select] = ACTIONS(3300),
    [anon_sym_lock] = ACTIONS(3300),
    [anon_sym_rlock] = ACTIONS(3300),
    [anon_sym_unsafe] = ACTIONS(3300),
    [anon_sym_sql] = ACTIONS(3300),
    [sym_int_literal] = ACTIONS(3300),
    [sym_float_literal] = ACTIONS(3300),
    [sym_rune_literal] = ACTIONS(3300),
    [anon_sym_SQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_c_SQUOTE] = ACTIONS(3300),
    [anon_sym_c_DQUOTE] = ACTIONS(3300),
    [anon_sym_r_SQUOTE] = ACTIONS(3300),
    [anon_sym_r_DQUOTE] = ACTIONS(3300),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3300),
    [anon_sym_shared] = ACTIONS(3300),
    [anon_sym_map_LBRACK] = ACTIONS(3300),
    [anon_sym_chan] = ACTIONS(3300),
    [anon_sym_thread] = ACTIONS(3300),
    [anon_sym_atomic] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_defer] = ACTIONS(3300),
    [anon_sym_goto] = ACTIONS(3300),
    [anon_sym_break] = ACTIONS(3300),
    [anon_sym_continue] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_DOLLARfor] = ACTIONS(3300),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_POUND] = ACTIONS(3300),
    [anon_sym_asm] = ACTIONS(3300),
    [anon_sym_AT_LBRACK] = ACTIONS(3300),
  },
  [1859] = {
    [sym_line_comment] = STATE(1859),
    [sym_block_comment] = STATE(1859),
    [ts_builtin_sym_end] = ACTIONS(3316),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LF] = ACTIONS(3318),
    [anon_sym_CR] = ACTIONS(3318),
    [anon_sym_CR_LF] = ACTIONS(3318),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3318),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym___global] = ACTIONS(3318),
    [anon_sym_type] = ACTIONS(3318),
    [anon_sym_fn] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_struct] = ACTIONS(3318),
    [anon_sym_union] = ACTIONS(3318),
    [anon_sym_pub] = ACTIONS(3318),
    [anon_sym_mut] = ACTIONS(3318),
    [anon_sym_enum] = ACTIONS(3318),
    [anon_sym_interface] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_BANG] = ACTIONS(3318),
    [anon_sym_go] = ACTIONS(3318),
    [anon_sym_spawn] = ACTIONS(3318),
    [anon_sym_json_DOTdecode] = ACTIONS(3318),
    [anon_sym_LBRACK2] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3318),
    [anon_sym_CARET] = ACTIONS(3318),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LT_DASH] = ACTIONS(3318),
    [sym_none] = ACTIONS(3318),
    [sym_true] = ACTIONS(3318),
    [sym_false] = ACTIONS(3318),
    [sym_nil] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_DOLLARif] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_select] = ACTIONS(3318),
    [anon_sym_lock] = ACTIONS(3318),
    [anon_sym_rlock] = ACTIONS(3318),
    [anon_sym_unsafe] = ACTIONS(3318),
    [anon_sym_sql] = ACTIONS(3318),
    [sym_int_literal] = ACTIONS(3318),
    [sym_float_literal] = ACTIONS(3318),
    [sym_rune_literal] = ACTIONS(3318),
    [anon_sym_SQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_c_SQUOTE] = ACTIONS(3318),
    [anon_sym_c_DQUOTE] = ACTIONS(3318),
    [anon_sym_r_SQUOTE] = ACTIONS(3318),
    [anon_sym_r_DQUOTE] = ACTIONS(3318),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3318),
    [anon_sym_shared] = ACTIONS(3318),
    [anon_sym_map_LBRACK] = ACTIONS(3318),
    [anon_sym_chan] = ACTIONS(3318),
    [anon_sym_thread] = ACTIONS(3318),
    [anon_sym_atomic] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_defer] = ACTIONS(3318),
    [anon_sym_goto] = ACTIONS(3318),
    [anon_sym_break] = ACTIONS(3318),
    [anon_sym_continue] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_DOLLARfor] = ACTIONS(3318),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_POUND] = ACTIONS(3318),
    [anon_sym_asm] = ACTIONS(3318),
    [anon_sym_AT_LBRACK] = ACTIONS(3318),
  },
  [1860] = {
    [sym_line_comment] = STATE(1860),
    [sym_block_comment] = STATE(1860),
    [ts_builtin_sym_end] = ACTIONS(4757),
    [sym_identifier] = ACTIONS(4759),
    [anon_sym_LF] = ACTIONS(4759),
    [anon_sym_CR] = ACTIONS(4759),
    [anon_sym_CR_LF] = ACTIONS(4759),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4759),
    [anon_sym_LBRACE] = ACTIONS(4759),
    [anon_sym_const] = ACTIONS(4759),
    [anon_sym_LPAREN] = ACTIONS(4759),
    [anon_sym___global] = ACTIONS(4759),
    [anon_sym_type] = ACTIONS(4759),
    [anon_sym_fn] = ACTIONS(4759),
    [anon_sym_PLUS] = ACTIONS(4759),
    [anon_sym_DASH] = ACTIONS(4759),
    [anon_sym_STAR] = ACTIONS(4759),
    [anon_sym_struct] = ACTIONS(4759),
    [anon_sym_union] = ACTIONS(4759),
    [anon_sym_pub] = ACTIONS(4759),
    [anon_sym_mut] = ACTIONS(4759),
    [anon_sym_enum] = ACTIONS(4759),
    [anon_sym_interface] = ACTIONS(4759),
    [anon_sym_QMARK] = ACTIONS(4759),
    [anon_sym_BANG] = ACTIONS(4759),
    [anon_sym_go] = ACTIONS(4759),
    [anon_sym_spawn] = ACTIONS(4759),
    [anon_sym_json_DOTdecode] = ACTIONS(4759),
    [anon_sym_LBRACK2] = ACTIONS(4759),
    [anon_sym_TILDE] = ACTIONS(4759),
    [anon_sym_CARET] = ACTIONS(4759),
    [anon_sym_AMP] = ACTIONS(4759),
    [anon_sym_LT_DASH] = ACTIONS(4759),
    [sym_none] = ACTIONS(4759),
    [sym_true] = ACTIONS(4759),
    [sym_false] = ACTIONS(4759),
    [sym_nil] = ACTIONS(4759),
    [anon_sym_if] = ACTIONS(4759),
    [anon_sym_DOLLARif] = ACTIONS(4759),
    [anon_sym_match] = ACTIONS(4759),
    [anon_sym_select] = ACTIONS(4759),
    [anon_sym_lock] = ACTIONS(4759),
    [anon_sym_rlock] = ACTIONS(4759),
    [anon_sym_unsafe] = ACTIONS(4759),
    [anon_sym_sql] = ACTIONS(4759),
    [sym_int_literal] = ACTIONS(4759),
    [sym_float_literal] = ACTIONS(4759),
    [sym_rune_literal] = ACTIONS(4759),
    [anon_sym_SQUOTE] = ACTIONS(4759),
    [anon_sym_DQUOTE] = ACTIONS(4759),
    [anon_sym_c_SQUOTE] = ACTIONS(4759),
    [anon_sym_c_DQUOTE] = ACTIONS(4759),
    [anon_sym_r_SQUOTE] = ACTIONS(4759),
    [anon_sym_r_DQUOTE] = ACTIONS(4759),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4759),
    [anon_sym_shared] = ACTIONS(4759),
    [anon_sym_map_LBRACK] = ACTIONS(4759),
    [anon_sym_chan] = ACTIONS(4759),
    [anon_sym_thread] = ACTIONS(4759),
    [anon_sym_atomic] = ACTIONS(4759),
    [anon_sym_assert] = ACTIONS(4759),
    [anon_sym_defer] = ACTIONS(4759),
    [anon_sym_goto] = ACTIONS(4759),
    [anon_sym_break] = ACTIONS(4759),
    [anon_sym_continue] = ACTIONS(4759),
    [anon_sym_return] = ACTIONS(4759),
    [anon_sym_DOLLARfor] = ACTIONS(4759),
    [anon_sym_for] = ACTIONS(4759),
    [anon_sym_POUND] = ACTIONS(4759),
    [anon_sym_asm] = ACTIONS(4759),
    [anon_sym_AT_LBRACK] = ACTIONS(4759),
  },
  [1861] = {
    [sym_line_comment] = STATE(1861),
    [sym_block_comment] = STATE(1861),
    [ts_builtin_sym_end] = ACTIONS(3348),
    [sym_identifier] = ACTIONS(3350),
    [anon_sym_LF] = ACTIONS(3350),
    [anon_sym_CR] = ACTIONS(3350),
    [anon_sym_CR_LF] = ACTIONS(3350),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3350),
    [anon_sym_LBRACE] = ACTIONS(3350),
    [anon_sym_const] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(3350),
    [anon_sym___global] = ACTIONS(3350),
    [anon_sym_type] = ACTIONS(3350),
    [anon_sym_fn] = ACTIONS(3350),
    [anon_sym_PLUS] = ACTIONS(3350),
    [anon_sym_DASH] = ACTIONS(3350),
    [anon_sym_STAR] = ACTIONS(3350),
    [anon_sym_struct] = ACTIONS(3350),
    [anon_sym_union] = ACTIONS(3350),
    [anon_sym_pub] = ACTIONS(3350),
    [anon_sym_mut] = ACTIONS(3350),
    [anon_sym_enum] = ACTIONS(3350),
    [anon_sym_interface] = ACTIONS(3350),
    [anon_sym_QMARK] = ACTIONS(3350),
    [anon_sym_BANG] = ACTIONS(3350),
    [anon_sym_go] = ACTIONS(3350),
    [anon_sym_spawn] = ACTIONS(3350),
    [anon_sym_json_DOTdecode] = ACTIONS(3350),
    [anon_sym_LBRACK2] = ACTIONS(3350),
    [anon_sym_TILDE] = ACTIONS(3350),
    [anon_sym_CARET] = ACTIONS(3350),
    [anon_sym_AMP] = ACTIONS(3350),
    [anon_sym_LT_DASH] = ACTIONS(3350),
    [sym_none] = ACTIONS(3350),
    [sym_true] = ACTIONS(3350),
    [sym_false] = ACTIONS(3350),
    [sym_nil] = ACTIONS(3350),
    [anon_sym_if] = ACTIONS(3350),
    [anon_sym_DOLLARif] = ACTIONS(3350),
    [anon_sym_match] = ACTIONS(3350),
    [anon_sym_select] = ACTIONS(3350),
    [anon_sym_lock] = ACTIONS(3350),
    [anon_sym_rlock] = ACTIONS(3350),
    [anon_sym_unsafe] = ACTIONS(3350),
    [anon_sym_sql] = ACTIONS(3350),
    [sym_int_literal] = ACTIONS(3350),
    [sym_float_literal] = ACTIONS(3350),
    [sym_rune_literal] = ACTIONS(3350),
    [anon_sym_SQUOTE] = ACTIONS(3350),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [anon_sym_c_SQUOTE] = ACTIONS(3350),
    [anon_sym_c_DQUOTE] = ACTIONS(3350),
    [anon_sym_r_SQUOTE] = ACTIONS(3350),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3350),
    [anon_sym_shared] = ACTIONS(3350),
    [anon_sym_map_LBRACK] = ACTIONS(3350),
    [anon_sym_chan] = ACTIONS(3350),
    [anon_sym_thread] = ACTIONS(3350),
    [anon_sym_atomic] = ACTIONS(3350),
    [anon_sym_assert] = ACTIONS(3350),
    [anon_sym_defer] = ACTIONS(3350),
    [anon_sym_goto] = ACTIONS(3350),
    [anon_sym_break] = ACTIONS(3350),
    [anon_sym_continue] = ACTIONS(3350),
    [anon_sym_return] = ACTIONS(3350),
    [anon_sym_DOLLARfor] = ACTIONS(3350),
    [anon_sym_for] = ACTIONS(3350),
    [anon_sym_POUND] = ACTIONS(3350),
    [anon_sym_asm] = ACTIONS(3350),
    [anon_sym_AT_LBRACK] = ACTIONS(3350),
  },
  [1862] = {
    [sym_line_comment] = STATE(1862),
    [sym_block_comment] = STATE(1862),
    [ts_builtin_sym_end] = ACTIONS(3268),
    [sym_identifier] = ACTIONS(3270),
    [anon_sym_LF] = ACTIONS(3270),
    [anon_sym_CR] = ACTIONS(3270),
    [anon_sym_CR_LF] = ACTIONS(3270),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3270),
    [anon_sym_LBRACE] = ACTIONS(3270),
    [anon_sym_const] = ACTIONS(3270),
    [anon_sym_LPAREN] = ACTIONS(3270),
    [anon_sym___global] = ACTIONS(3270),
    [anon_sym_type] = ACTIONS(3270),
    [anon_sym_fn] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3270),
    [anon_sym_DASH] = ACTIONS(3270),
    [anon_sym_STAR] = ACTIONS(3270),
    [anon_sym_struct] = ACTIONS(3270),
    [anon_sym_union] = ACTIONS(3270),
    [anon_sym_pub] = ACTIONS(3270),
    [anon_sym_mut] = ACTIONS(3270),
    [anon_sym_enum] = ACTIONS(3270),
    [anon_sym_interface] = ACTIONS(3270),
    [anon_sym_QMARK] = ACTIONS(3270),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_go] = ACTIONS(3270),
    [anon_sym_spawn] = ACTIONS(3270),
    [anon_sym_json_DOTdecode] = ACTIONS(3270),
    [anon_sym_LBRACK2] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3270),
    [anon_sym_CARET] = ACTIONS(3270),
    [anon_sym_AMP] = ACTIONS(3270),
    [anon_sym_LT_DASH] = ACTIONS(3270),
    [sym_none] = ACTIONS(3270),
    [sym_true] = ACTIONS(3270),
    [sym_false] = ACTIONS(3270),
    [sym_nil] = ACTIONS(3270),
    [anon_sym_if] = ACTIONS(3270),
    [anon_sym_DOLLARif] = ACTIONS(3270),
    [anon_sym_match] = ACTIONS(3270),
    [anon_sym_select] = ACTIONS(3270),
    [anon_sym_lock] = ACTIONS(3270),
    [anon_sym_rlock] = ACTIONS(3270),
    [anon_sym_unsafe] = ACTIONS(3270),
    [anon_sym_sql] = ACTIONS(3270),
    [sym_int_literal] = ACTIONS(3270),
    [sym_float_literal] = ACTIONS(3270),
    [sym_rune_literal] = ACTIONS(3270),
    [anon_sym_SQUOTE] = ACTIONS(3270),
    [anon_sym_DQUOTE] = ACTIONS(3270),
    [anon_sym_c_SQUOTE] = ACTIONS(3270),
    [anon_sym_c_DQUOTE] = ACTIONS(3270),
    [anon_sym_r_SQUOTE] = ACTIONS(3270),
    [anon_sym_r_DQUOTE] = ACTIONS(3270),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3270),
    [anon_sym_shared] = ACTIONS(3270),
    [anon_sym_map_LBRACK] = ACTIONS(3270),
    [anon_sym_chan] = ACTIONS(3270),
    [anon_sym_thread] = ACTIONS(3270),
    [anon_sym_atomic] = ACTIONS(3270),
    [anon_sym_assert] = ACTIONS(3270),
    [anon_sym_defer] = ACTIONS(3270),
    [anon_sym_goto] = ACTIONS(3270),
    [anon_sym_break] = ACTIONS(3270),
    [anon_sym_continue] = ACTIONS(3270),
    [anon_sym_return] = ACTIONS(3270),
    [anon_sym_DOLLARfor] = ACTIONS(3270),
    [anon_sym_for] = ACTIONS(3270),
    [anon_sym_POUND] = ACTIONS(3270),
    [anon_sym_asm] = ACTIONS(3270),
    [anon_sym_AT_LBRACK] = ACTIONS(3270),
  },
  [1863] = {
    [sym_line_comment] = STATE(1863),
    [sym_block_comment] = STATE(1863),
    [ts_builtin_sym_end] = ACTIONS(4761),
    [sym_identifier] = ACTIONS(4763),
    [anon_sym_LF] = ACTIONS(4763),
    [anon_sym_CR] = ACTIONS(4763),
    [anon_sym_CR_LF] = ACTIONS(4763),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4763),
    [anon_sym_LBRACE] = ACTIONS(4763),
    [anon_sym_const] = ACTIONS(4763),
    [anon_sym_LPAREN] = ACTIONS(4763),
    [anon_sym___global] = ACTIONS(4763),
    [anon_sym_type] = ACTIONS(4763),
    [anon_sym_fn] = ACTIONS(4763),
    [anon_sym_PLUS] = ACTIONS(4763),
    [anon_sym_DASH] = ACTIONS(4763),
    [anon_sym_STAR] = ACTIONS(4763),
    [anon_sym_struct] = ACTIONS(4763),
    [anon_sym_union] = ACTIONS(4763),
    [anon_sym_pub] = ACTIONS(4763),
    [anon_sym_mut] = ACTIONS(4763),
    [anon_sym_enum] = ACTIONS(4763),
    [anon_sym_interface] = ACTIONS(4763),
    [anon_sym_QMARK] = ACTIONS(4763),
    [anon_sym_BANG] = ACTIONS(4763),
    [anon_sym_go] = ACTIONS(4763),
    [anon_sym_spawn] = ACTIONS(4763),
    [anon_sym_json_DOTdecode] = ACTIONS(4763),
    [anon_sym_LBRACK2] = ACTIONS(4763),
    [anon_sym_TILDE] = ACTIONS(4763),
    [anon_sym_CARET] = ACTIONS(4763),
    [anon_sym_AMP] = ACTIONS(4763),
    [anon_sym_LT_DASH] = ACTIONS(4763),
    [sym_none] = ACTIONS(4763),
    [sym_true] = ACTIONS(4763),
    [sym_false] = ACTIONS(4763),
    [sym_nil] = ACTIONS(4763),
    [anon_sym_if] = ACTIONS(4763),
    [anon_sym_DOLLARif] = ACTIONS(4763),
    [anon_sym_match] = ACTIONS(4763),
    [anon_sym_select] = ACTIONS(4763),
    [anon_sym_lock] = ACTIONS(4763),
    [anon_sym_rlock] = ACTIONS(4763),
    [anon_sym_unsafe] = ACTIONS(4763),
    [anon_sym_sql] = ACTIONS(4763),
    [sym_int_literal] = ACTIONS(4763),
    [sym_float_literal] = ACTIONS(4763),
    [sym_rune_literal] = ACTIONS(4763),
    [anon_sym_SQUOTE] = ACTIONS(4763),
    [anon_sym_DQUOTE] = ACTIONS(4763),
    [anon_sym_c_SQUOTE] = ACTIONS(4763),
    [anon_sym_c_DQUOTE] = ACTIONS(4763),
    [anon_sym_r_SQUOTE] = ACTIONS(4763),
    [anon_sym_r_DQUOTE] = ACTIONS(4763),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4763),
    [anon_sym_shared] = ACTIONS(4763),
    [anon_sym_map_LBRACK] = ACTIONS(4763),
    [anon_sym_chan] = ACTIONS(4763),
    [anon_sym_thread] = ACTIONS(4763),
    [anon_sym_atomic] = ACTIONS(4763),
    [anon_sym_assert] = ACTIONS(4763),
    [anon_sym_defer] = ACTIONS(4763),
    [anon_sym_goto] = ACTIONS(4763),
    [anon_sym_break] = ACTIONS(4763),
    [anon_sym_continue] = ACTIONS(4763),
    [anon_sym_return] = ACTIONS(4763),
    [anon_sym_DOLLARfor] = ACTIONS(4763),
    [anon_sym_for] = ACTIONS(4763),
    [anon_sym_POUND] = ACTIONS(4763),
    [anon_sym_asm] = ACTIONS(4763),
    [anon_sym_AT_LBRACK] = ACTIONS(4763),
  },
  [1864] = {
    [sym_line_comment] = STATE(1864),
    [sym_block_comment] = STATE(1864),
    [ts_builtin_sym_end] = ACTIONS(4765),
    [sym_identifier] = ACTIONS(4767),
    [anon_sym_LF] = ACTIONS(4767),
    [anon_sym_CR] = ACTIONS(4767),
    [anon_sym_CR_LF] = ACTIONS(4767),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4767),
    [anon_sym_LBRACE] = ACTIONS(4767),
    [anon_sym_const] = ACTIONS(4767),
    [anon_sym_LPAREN] = ACTIONS(4767),
    [anon_sym___global] = ACTIONS(4767),
    [anon_sym_type] = ACTIONS(4767),
    [anon_sym_fn] = ACTIONS(4767),
    [anon_sym_PLUS] = ACTIONS(4767),
    [anon_sym_DASH] = ACTIONS(4767),
    [anon_sym_STAR] = ACTIONS(4767),
    [anon_sym_struct] = ACTIONS(4767),
    [anon_sym_union] = ACTIONS(4767),
    [anon_sym_pub] = ACTIONS(4767),
    [anon_sym_mut] = ACTIONS(4767),
    [anon_sym_enum] = ACTIONS(4767),
    [anon_sym_interface] = ACTIONS(4767),
    [anon_sym_QMARK] = ACTIONS(4767),
    [anon_sym_BANG] = ACTIONS(4767),
    [anon_sym_go] = ACTIONS(4767),
    [anon_sym_spawn] = ACTIONS(4767),
    [anon_sym_json_DOTdecode] = ACTIONS(4767),
    [anon_sym_LBRACK2] = ACTIONS(4767),
    [anon_sym_TILDE] = ACTIONS(4767),
    [anon_sym_CARET] = ACTIONS(4767),
    [anon_sym_AMP] = ACTIONS(4767),
    [anon_sym_LT_DASH] = ACTIONS(4767),
    [sym_none] = ACTIONS(4767),
    [sym_true] = ACTIONS(4767),
    [sym_false] = ACTIONS(4767),
    [sym_nil] = ACTIONS(4767),
    [anon_sym_if] = ACTIONS(4767),
    [anon_sym_DOLLARif] = ACTIONS(4767),
    [anon_sym_match] = ACTIONS(4767),
    [anon_sym_select] = ACTIONS(4767),
    [anon_sym_lock] = ACTIONS(4767),
    [anon_sym_rlock] = ACTIONS(4767),
    [anon_sym_unsafe] = ACTIONS(4767),
    [anon_sym_sql] = ACTIONS(4767),
    [sym_int_literal] = ACTIONS(4767),
    [sym_float_literal] = ACTIONS(4767),
    [sym_rune_literal] = ACTIONS(4767),
    [anon_sym_SQUOTE] = ACTIONS(4767),
    [anon_sym_DQUOTE] = ACTIONS(4767),
    [anon_sym_c_SQUOTE] = ACTIONS(4767),
    [anon_sym_c_DQUOTE] = ACTIONS(4767),
    [anon_sym_r_SQUOTE] = ACTIONS(4767),
    [anon_sym_r_DQUOTE] = ACTIONS(4767),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4767),
    [anon_sym_shared] = ACTIONS(4767),
    [anon_sym_map_LBRACK] = ACTIONS(4767),
    [anon_sym_chan] = ACTIONS(4767),
    [anon_sym_thread] = ACTIONS(4767),
    [anon_sym_atomic] = ACTIONS(4767),
    [anon_sym_assert] = ACTIONS(4767),
    [anon_sym_defer] = ACTIONS(4767),
    [anon_sym_goto] = ACTIONS(4767),
    [anon_sym_break] = ACTIONS(4767),
    [anon_sym_continue] = ACTIONS(4767),
    [anon_sym_return] = ACTIONS(4767),
    [anon_sym_DOLLARfor] = ACTIONS(4767),
    [anon_sym_for] = ACTIONS(4767),
    [anon_sym_POUND] = ACTIONS(4767),
    [anon_sym_asm] = ACTIONS(4767),
    [anon_sym_AT_LBRACK] = ACTIONS(4767),
  },
  [1865] = {
    [sym_line_comment] = STATE(1865),
    [sym_block_comment] = STATE(1865),
    [ts_builtin_sym_end] = ACTIONS(4769),
    [sym_identifier] = ACTIONS(4771),
    [anon_sym_LF] = ACTIONS(4771),
    [anon_sym_CR] = ACTIONS(4771),
    [anon_sym_CR_LF] = ACTIONS(4771),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4771),
    [anon_sym_LBRACE] = ACTIONS(4771),
    [anon_sym_const] = ACTIONS(4771),
    [anon_sym_LPAREN] = ACTIONS(4771),
    [anon_sym___global] = ACTIONS(4771),
    [anon_sym_type] = ACTIONS(4771),
    [anon_sym_fn] = ACTIONS(4771),
    [anon_sym_PLUS] = ACTIONS(4771),
    [anon_sym_DASH] = ACTIONS(4771),
    [anon_sym_STAR] = ACTIONS(4771),
    [anon_sym_struct] = ACTIONS(4771),
    [anon_sym_union] = ACTIONS(4771),
    [anon_sym_pub] = ACTIONS(4771),
    [anon_sym_mut] = ACTIONS(4771),
    [anon_sym_enum] = ACTIONS(4771),
    [anon_sym_interface] = ACTIONS(4771),
    [anon_sym_QMARK] = ACTIONS(4771),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_go] = ACTIONS(4771),
    [anon_sym_spawn] = ACTIONS(4771),
    [anon_sym_json_DOTdecode] = ACTIONS(4771),
    [anon_sym_LBRACK2] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [anon_sym_CARET] = ACTIONS(4771),
    [anon_sym_AMP] = ACTIONS(4771),
    [anon_sym_LT_DASH] = ACTIONS(4771),
    [sym_none] = ACTIONS(4771),
    [sym_true] = ACTIONS(4771),
    [sym_false] = ACTIONS(4771),
    [sym_nil] = ACTIONS(4771),
    [anon_sym_if] = ACTIONS(4771),
    [anon_sym_DOLLARif] = ACTIONS(4771),
    [anon_sym_match] = ACTIONS(4771),
    [anon_sym_select] = ACTIONS(4771),
    [anon_sym_lock] = ACTIONS(4771),
    [anon_sym_rlock] = ACTIONS(4771),
    [anon_sym_unsafe] = ACTIONS(4771),
    [anon_sym_sql] = ACTIONS(4771),
    [sym_int_literal] = ACTIONS(4771),
    [sym_float_literal] = ACTIONS(4771),
    [sym_rune_literal] = ACTIONS(4771),
    [anon_sym_SQUOTE] = ACTIONS(4771),
    [anon_sym_DQUOTE] = ACTIONS(4771),
    [anon_sym_c_SQUOTE] = ACTIONS(4771),
    [anon_sym_c_DQUOTE] = ACTIONS(4771),
    [anon_sym_r_SQUOTE] = ACTIONS(4771),
    [anon_sym_r_DQUOTE] = ACTIONS(4771),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4771),
    [anon_sym_shared] = ACTIONS(4771),
    [anon_sym_map_LBRACK] = ACTIONS(4771),
    [anon_sym_chan] = ACTIONS(4771),
    [anon_sym_thread] = ACTIONS(4771),
    [anon_sym_atomic] = ACTIONS(4771),
    [anon_sym_assert] = ACTIONS(4771),
    [anon_sym_defer] = ACTIONS(4771),
    [anon_sym_goto] = ACTIONS(4771),
    [anon_sym_break] = ACTIONS(4771),
    [anon_sym_continue] = ACTIONS(4771),
    [anon_sym_return] = ACTIONS(4771),
    [anon_sym_DOLLARfor] = ACTIONS(4771),
    [anon_sym_for] = ACTIONS(4771),
    [anon_sym_POUND] = ACTIONS(4771),
    [anon_sym_asm] = ACTIONS(4771),
    [anon_sym_AT_LBRACK] = ACTIONS(4771),
  },
  [1866] = {
    [sym_line_comment] = STATE(1866),
    [sym_block_comment] = STATE(1866),
    [ts_builtin_sym_end] = ACTIONS(4773),
    [sym_identifier] = ACTIONS(4775),
    [anon_sym_LF] = ACTIONS(4775),
    [anon_sym_CR] = ACTIONS(4775),
    [anon_sym_CR_LF] = ACTIONS(4775),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(4775),
    [anon_sym_const] = ACTIONS(4775),
    [anon_sym_LPAREN] = ACTIONS(4775),
    [anon_sym___global] = ACTIONS(4775),
    [anon_sym_type] = ACTIONS(4775),
    [anon_sym_fn] = ACTIONS(4775),
    [anon_sym_PLUS] = ACTIONS(4775),
    [anon_sym_DASH] = ACTIONS(4775),
    [anon_sym_STAR] = ACTIONS(4775),
    [anon_sym_struct] = ACTIONS(4775),
    [anon_sym_union] = ACTIONS(4775),
    [anon_sym_pub] = ACTIONS(4775),
    [anon_sym_mut] = ACTIONS(4775),
    [anon_sym_enum] = ACTIONS(4775),
    [anon_sym_interface] = ACTIONS(4775),
    [anon_sym_QMARK] = ACTIONS(4775),
    [anon_sym_BANG] = ACTIONS(4775),
    [anon_sym_go] = ACTIONS(4775),
    [anon_sym_spawn] = ACTIONS(4775),
    [anon_sym_json_DOTdecode] = ACTIONS(4775),
    [anon_sym_LBRACK2] = ACTIONS(4775),
    [anon_sym_TILDE] = ACTIONS(4775),
    [anon_sym_CARET] = ACTIONS(4775),
    [anon_sym_AMP] = ACTIONS(4775),
    [anon_sym_LT_DASH] = ACTIONS(4775),
    [sym_none] = ACTIONS(4775),
    [sym_true] = ACTIONS(4775),
    [sym_false] = ACTIONS(4775),
    [sym_nil] = ACTIONS(4775),
    [anon_sym_if] = ACTIONS(4775),
    [anon_sym_DOLLARif] = ACTIONS(4775),
    [anon_sym_match] = ACTIONS(4775),
    [anon_sym_select] = ACTIONS(4775),
    [anon_sym_lock] = ACTIONS(4775),
    [anon_sym_rlock] = ACTIONS(4775),
    [anon_sym_unsafe] = ACTIONS(4775),
    [anon_sym_sql] = ACTIONS(4775),
    [sym_int_literal] = ACTIONS(4775),
    [sym_float_literal] = ACTIONS(4775),
    [sym_rune_literal] = ACTIONS(4775),
    [anon_sym_SQUOTE] = ACTIONS(4775),
    [anon_sym_DQUOTE] = ACTIONS(4775),
    [anon_sym_c_SQUOTE] = ACTIONS(4775),
    [anon_sym_c_DQUOTE] = ACTIONS(4775),
    [anon_sym_r_SQUOTE] = ACTIONS(4775),
    [anon_sym_r_DQUOTE] = ACTIONS(4775),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4775),
    [anon_sym_shared] = ACTIONS(4775),
    [anon_sym_map_LBRACK] = ACTIONS(4775),
    [anon_sym_chan] = ACTIONS(4775),
    [anon_sym_thread] = ACTIONS(4775),
    [anon_sym_atomic] = ACTIONS(4775),
    [anon_sym_assert] = ACTIONS(4775),
    [anon_sym_defer] = ACTIONS(4775),
    [anon_sym_goto] = ACTIONS(4775),
    [anon_sym_break] = ACTIONS(4775),
    [anon_sym_continue] = ACTIONS(4775),
    [anon_sym_return] = ACTIONS(4775),
    [anon_sym_DOLLARfor] = ACTIONS(4775),
    [anon_sym_for] = ACTIONS(4775),
    [anon_sym_POUND] = ACTIONS(4775),
    [anon_sym_asm] = ACTIONS(4775),
    [anon_sym_AT_LBRACK] = ACTIONS(4775),
  },
  [1867] = {
    [sym_line_comment] = STATE(1867),
    [sym_block_comment] = STATE(1867),
    [ts_builtin_sym_end] = ACTIONS(4777),
    [sym_identifier] = ACTIONS(4779),
    [anon_sym_LF] = ACTIONS(4779),
    [anon_sym_CR] = ACTIONS(4779),
    [anon_sym_CR_LF] = ACTIONS(4779),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4779),
    [anon_sym_LBRACE] = ACTIONS(4779),
    [anon_sym_const] = ACTIONS(4779),
    [anon_sym_LPAREN] = ACTIONS(4779),
    [anon_sym___global] = ACTIONS(4779),
    [anon_sym_type] = ACTIONS(4779),
    [anon_sym_fn] = ACTIONS(4779),
    [anon_sym_PLUS] = ACTIONS(4779),
    [anon_sym_DASH] = ACTIONS(4779),
    [anon_sym_STAR] = ACTIONS(4779),
    [anon_sym_struct] = ACTIONS(4779),
    [anon_sym_union] = ACTIONS(4779),
    [anon_sym_pub] = ACTIONS(4779),
    [anon_sym_mut] = ACTIONS(4779),
    [anon_sym_enum] = ACTIONS(4779),
    [anon_sym_interface] = ACTIONS(4779),
    [anon_sym_QMARK] = ACTIONS(4779),
    [anon_sym_BANG] = ACTIONS(4779),
    [anon_sym_go] = ACTIONS(4779),
    [anon_sym_spawn] = ACTIONS(4779),
    [anon_sym_json_DOTdecode] = ACTIONS(4779),
    [anon_sym_LBRACK2] = ACTIONS(4779),
    [anon_sym_TILDE] = ACTIONS(4779),
    [anon_sym_CARET] = ACTIONS(4779),
    [anon_sym_AMP] = ACTIONS(4779),
    [anon_sym_LT_DASH] = ACTIONS(4779),
    [sym_none] = ACTIONS(4779),
    [sym_true] = ACTIONS(4779),
    [sym_false] = ACTIONS(4779),
    [sym_nil] = ACTIONS(4779),
    [anon_sym_if] = ACTIONS(4779),
    [anon_sym_DOLLARif] = ACTIONS(4779),
    [anon_sym_match] = ACTIONS(4779),
    [anon_sym_select] = ACTIONS(4779),
    [anon_sym_lock] = ACTIONS(4779),
    [anon_sym_rlock] = ACTIONS(4779),
    [anon_sym_unsafe] = ACTIONS(4779),
    [anon_sym_sql] = ACTIONS(4779),
    [sym_int_literal] = ACTIONS(4779),
    [sym_float_literal] = ACTIONS(4779),
    [sym_rune_literal] = ACTIONS(4779),
    [anon_sym_SQUOTE] = ACTIONS(4779),
    [anon_sym_DQUOTE] = ACTIONS(4779),
    [anon_sym_c_SQUOTE] = ACTIONS(4779),
    [anon_sym_c_DQUOTE] = ACTIONS(4779),
    [anon_sym_r_SQUOTE] = ACTIONS(4779),
    [anon_sym_r_DQUOTE] = ACTIONS(4779),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4779),
    [anon_sym_shared] = ACTIONS(4779),
    [anon_sym_map_LBRACK] = ACTIONS(4779),
    [anon_sym_chan] = ACTIONS(4779),
    [anon_sym_thread] = ACTIONS(4779),
    [anon_sym_atomic] = ACTIONS(4779),
    [anon_sym_assert] = ACTIONS(4779),
    [anon_sym_defer] = ACTIONS(4779),
    [anon_sym_goto] = ACTIONS(4779),
    [anon_sym_break] = ACTIONS(4779),
    [anon_sym_continue] = ACTIONS(4779),
    [anon_sym_return] = ACTIONS(4779),
    [anon_sym_DOLLARfor] = ACTIONS(4779),
    [anon_sym_for] = ACTIONS(4779),
    [anon_sym_POUND] = ACTIONS(4779),
    [anon_sym_asm] = ACTIONS(4779),
    [anon_sym_AT_LBRACK] = ACTIONS(4779),
  },
  [1868] = {
    [sym_line_comment] = STATE(1868),
    [sym_block_comment] = STATE(1868),
    [ts_builtin_sym_end] = ACTIONS(4781),
    [sym_identifier] = ACTIONS(4783),
    [anon_sym_LF] = ACTIONS(4783),
    [anon_sym_CR] = ACTIONS(4783),
    [anon_sym_CR_LF] = ACTIONS(4783),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4783),
    [anon_sym_LBRACE] = ACTIONS(4783),
    [anon_sym_const] = ACTIONS(4783),
    [anon_sym_LPAREN] = ACTIONS(4783),
    [anon_sym___global] = ACTIONS(4783),
    [anon_sym_type] = ACTIONS(4783),
    [anon_sym_fn] = ACTIONS(4783),
    [anon_sym_PLUS] = ACTIONS(4783),
    [anon_sym_DASH] = ACTIONS(4783),
    [anon_sym_STAR] = ACTIONS(4783),
    [anon_sym_struct] = ACTIONS(4783),
    [anon_sym_union] = ACTIONS(4783),
    [anon_sym_pub] = ACTIONS(4783),
    [anon_sym_mut] = ACTIONS(4783),
    [anon_sym_enum] = ACTIONS(4783),
    [anon_sym_interface] = ACTIONS(4783),
    [anon_sym_QMARK] = ACTIONS(4783),
    [anon_sym_BANG] = ACTIONS(4783),
    [anon_sym_go] = ACTIONS(4783),
    [anon_sym_spawn] = ACTIONS(4783),
    [anon_sym_json_DOTdecode] = ACTIONS(4783),
    [anon_sym_LBRACK2] = ACTIONS(4783),
    [anon_sym_TILDE] = ACTIONS(4783),
    [anon_sym_CARET] = ACTIONS(4783),
    [anon_sym_AMP] = ACTIONS(4783),
    [anon_sym_LT_DASH] = ACTIONS(4783),
    [sym_none] = ACTIONS(4783),
    [sym_true] = ACTIONS(4783),
    [sym_false] = ACTIONS(4783),
    [sym_nil] = ACTIONS(4783),
    [anon_sym_if] = ACTIONS(4783),
    [anon_sym_DOLLARif] = ACTIONS(4783),
    [anon_sym_match] = ACTIONS(4783),
    [anon_sym_select] = ACTIONS(4783),
    [anon_sym_lock] = ACTIONS(4783),
    [anon_sym_rlock] = ACTIONS(4783),
    [anon_sym_unsafe] = ACTIONS(4783),
    [anon_sym_sql] = ACTIONS(4783),
    [sym_int_literal] = ACTIONS(4783),
    [sym_float_literal] = ACTIONS(4783),
    [sym_rune_literal] = ACTIONS(4783),
    [anon_sym_SQUOTE] = ACTIONS(4783),
    [anon_sym_DQUOTE] = ACTIONS(4783),
    [anon_sym_c_SQUOTE] = ACTIONS(4783),
    [anon_sym_c_DQUOTE] = ACTIONS(4783),
    [anon_sym_r_SQUOTE] = ACTIONS(4783),
    [anon_sym_r_DQUOTE] = ACTIONS(4783),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4783),
    [anon_sym_shared] = ACTIONS(4783),
    [anon_sym_map_LBRACK] = ACTIONS(4783),
    [anon_sym_chan] = ACTIONS(4783),
    [anon_sym_thread] = ACTIONS(4783),
    [anon_sym_atomic] = ACTIONS(4783),
    [anon_sym_assert] = ACTIONS(4783),
    [anon_sym_defer] = ACTIONS(4783),
    [anon_sym_goto] = ACTIONS(4783),
    [anon_sym_break] = ACTIONS(4783),
    [anon_sym_continue] = ACTIONS(4783),
    [anon_sym_return] = ACTIONS(4783),
    [anon_sym_DOLLARfor] = ACTIONS(4783),
    [anon_sym_for] = ACTIONS(4783),
    [anon_sym_POUND] = ACTIONS(4783),
    [anon_sym_asm] = ACTIONS(4783),
    [anon_sym_AT_LBRACK] = ACTIONS(4783),
  },
  [1869] = {
    [sym_line_comment] = STATE(1869),
    [sym_block_comment] = STATE(1869),
    [ts_builtin_sym_end] = ACTIONS(4785),
    [sym_identifier] = ACTIONS(4787),
    [anon_sym_LF] = ACTIONS(4787),
    [anon_sym_CR] = ACTIONS(4787),
    [anon_sym_CR_LF] = ACTIONS(4787),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4787),
    [anon_sym_LBRACE] = ACTIONS(4787),
    [anon_sym_const] = ACTIONS(4787),
    [anon_sym_LPAREN] = ACTIONS(4787),
    [anon_sym___global] = ACTIONS(4787),
    [anon_sym_type] = ACTIONS(4787),
    [anon_sym_fn] = ACTIONS(4787),
    [anon_sym_PLUS] = ACTIONS(4787),
    [anon_sym_DASH] = ACTIONS(4787),
    [anon_sym_STAR] = ACTIONS(4787),
    [anon_sym_struct] = ACTIONS(4787),
    [anon_sym_union] = ACTIONS(4787),
    [anon_sym_pub] = ACTIONS(4787),
    [anon_sym_mut] = ACTIONS(4787),
    [anon_sym_enum] = ACTIONS(4787),
    [anon_sym_interface] = ACTIONS(4787),
    [anon_sym_QMARK] = ACTIONS(4787),
    [anon_sym_BANG] = ACTIONS(4787),
    [anon_sym_go] = ACTIONS(4787),
    [anon_sym_spawn] = ACTIONS(4787),
    [anon_sym_json_DOTdecode] = ACTIONS(4787),
    [anon_sym_LBRACK2] = ACTIONS(4787),
    [anon_sym_TILDE] = ACTIONS(4787),
    [anon_sym_CARET] = ACTIONS(4787),
    [anon_sym_AMP] = ACTIONS(4787),
    [anon_sym_LT_DASH] = ACTIONS(4787),
    [sym_none] = ACTIONS(4787),
    [sym_true] = ACTIONS(4787),
    [sym_false] = ACTIONS(4787),
    [sym_nil] = ACTIONS(4787),
    [anon_sym_if] = ACTIONS(4787),
    [anon_sym_DOLLARif] = ACTIONS(4787),
    [anon_sym_match] = ACTIONS(4787),
    [anon_sym_select] = ACTIONS(4787),
    [anon_sym_lock] = ACTIONS(4787),
    [anon_sym_rlock] = ACTIONS(4787),
    [anon_sym_unsafe] = ACTIONS(4787),
    [anon_sym_sql] = ACTIONS(4787),
    [sym_int_literal] = ACTIONS(4787),
    [sym_float_literal] = ACTIONS(4787),
    [sym_rune_literal] = ACTIONS(4787),
    [anon_sym_SQUOTE] = ACTIONS(4787),
    [anon_sym_DQUOTE] = ACTIONS(4787),
    [anon_sym_c_SQUOTE] = ACTIONS(4787),
    [anon_sym_c_DQUOTE] = ACTIONS(4787),
    [anon_sym_r_SQUOTE] = ACTIONS(4787),
    [anon_sym_r_DQUOTE] = ACTIONS(4787),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4787),
    [anon_sym_shared] = ACTIONS(4787),
    [anon_sym_map_LBRACK] = ACTIONS(4787),
    [anon_sym_chan] = ACTIONS(4787),
    [anon_sym_thread] = ACTIONS(4787),
    [anon_sym_atomic] = ACTIONS(4787),
    [anon_sym_assert] = ACTIONS(4787),
    [anon_sym_defer] = ACTIONS(4787),
    [anon_sym_goto] = ACTIONS(4787),
    [anon_sym_break] = ACTIONS(4787),
    [anon_sym_continue] = ACTIONS(4787),
    [anon_sym_return] = ACTIONS(4787),
    [anon_sym_DOLLARfor] = ACTIONS(4787),
    [anon_sym_for] = ACTIONS(4787),
    [anon_sym_POUND] = ACTIONS(4787),
    [anon_sym_asm] = ACTIONS(4787),
    [anon_sym_AT_LBRACK] = ACTIONS(4787),
  },
  [1870] = {
    [sym_line_comment] = STATE(1870),
    [sym_block_comment] = STATE(1870),
    [ts_builtin_sym_end] = ACTIONS(3344),
    [sym_identifier] = ACTIONS(3346),
    [anon_sym_LF] = ACTIONS(3346),
    [anon_sym_CR] = ACTIONS(3346),
    [anon_sym_CR_LF] = ACTIONS(3346),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3346),
    [anon_sym___global] = ACTIONS(3346),
    [anon_sym_type] = ACTIONS(3346),
    [anon_sym_fn] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_struct] = ACTIONS(3346),
    [anon_sym_union] = ACTIONS(3346),
    [anon_sym_pub] = ACTIONS(3346),
    [anon_sym_mut] = ACTIONS(3346),
    [anon_sym_enum] = ACTIONS(3346),
    [anon_sym_interface] = ACTIONS(3346),
    [anon_sym_QMARK] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_go] = ACTIONS(3346),
    [anon_sym_spawn] = ACTIONS(3346),
    [anon_sym_json_DOTdecode] = ACTIONS(3346),
    [anon_sym_LBRACK2] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_CARET] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym_LT_DASH] = ACTIONS(3346),
    [sym_none] = ACTIONS(3346),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [sym_nil] = ACTIONS(3346),
    [anon_sym_if] = ACTIONS(3346),
    [anon_sym_DOLLARif] = ACTIONS(3346),
    [anon_sym_match] = ACTIONS(3346),
    [anon_sym_select] = ACTIONS(3346),
    [anon_sym_lock] = ACTIONS(3346),
    [anon_sym_rlock] = ACTIONS(3346),
    [anon_sym_unsafe] = ACTIONS(3346),
    [anon_sym_sql] = ACTIONS(3346),
    [sym_int_literal] = ACTIONS(3346),
    [sym_float_literal] = ACTIONS(3346),
    [sym_rune_literal] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [anon_sym_c_SQUOTE] = ACTIONS(3346),
    [anon_sym_c_DQUOTE] = ACTIONS(3346),
    [anon_sym_r_SQUOTE] = ACTIONS(3346),
    [anon_sym_r_DQUOTE] = ACTIONS(3346),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3346),
    [anon_sym_shared] = ACTIONS(3346),
    [anon_sym_map_LBRACK] = ACTIONS(3346),
    [anon_sym_chan] = ACTIONS(3346),
    [anon_sym_thread] = ACTIONS(3346),
    [anon_sym_atomic] = ACTIONS(3346),
    [anon_sym_assert] = ACTIONS(3346),
    [anon_sym_defer] = ACTIONS(3346),
    [anon_sym_goto] = ACTIONS(3346),
    [anon_sym_break] = ACTIONS(3346),
    [anon_sym_continue] = ACTIONS(3346),
    [anon_sym_return] = ACTIONS(3346),
    [anon_sym_DOLLARfor] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3346),
    [anon_sym_POUND] = ACTIONS(3346),
    [anon_sym_asm] = ACTIONS(3346),
    [anon_sym_AT_LBRACK] = ACTIONS(3346),
  },
  [1871] = {
    [sym_line_comment] = STATE(1871),
    [sym_block_comment] = STATE(1871),
    [ts_builtin_sym_end] = ACTIONS(4789),
    [sym_identifier] = ACTIONS(4791),
    [anon_sym_LF] = ACTIONS(4791),
    [anon_sym_CR] = ACTIONS(4791),
    [anon_sym_CR_LF] = ACTIONS(4791),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4791),
    [anon_sym_LBRACE] = ACTIONS(4791),
    [anon_sym_const] = ACTIONS(4791),
    [anon_sym_LPAREN] = ACTIONS(4791),
    [anon_sym___global] = ACTIONS(4791),
    [anon_sym_type] = ACTIONS(4791),
    [anon_sym_fn] = ACTIONS(4791),
    [anon_sym_PLUS] = ACTIONS(4791),
    [anon_sym_DASH] = ACTIONS(4791),
    [anon_sym_STAR] = ACTIONS(4791),
    [anon_sym_struct] = ACTIONS(4791),
    [anon_sym_union] = ACTIONS(4791),
    [anon_sym_pub] = ACTIONS(4791),
    [anon_sym_mut] = ACTIONS(4791),
    [anon_sym_enum] = ACTIONS(4791),
    [anon_sym_interface] = ACTIONS(4791),
    [anon_sym_QMARK] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_go] = ACTIONS(4791),
    [anon_sym_spawn] = ACTIONS(4791),
    [anon_sym_json_DOTdecode] = ACTIONS(4791),
    [anon_sym_LBRACK2] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [anon_sym_CARET] = ACTIONS(4791),
    [anon_sym_AMP] = ACTIONS(4791),
    [anon_sym_LT_DASH] = ACTIONS(4791),
    [sym_none] = ACTIONS(4791),
    [sym_true] = ACTIONS(4791),
    [sym_false] = ACTIONS(4791),
    [sym_nil] = ACTIONS(4791),
    [anon_sym_if] = ACTIONS(4791),
    [anon_sym_DOLLARif] = ACTIONS(4791),
    [anon_sym_match] = ACTIONS(4791),
    [anon_sym_select] = ACTIONS(4791),
    [anon_sym_lock] = ACTIONS(4791),
    [anon_sym_rlock] = ACTIONS(4791),
    [anon_sym_unsafe] = ACTIONS(4791),
    [anon_sym_sql] = ACTIONS(4791),
    [sym_int_literal] = ACTIONS(4791),
    [sym_float_literal] = ACTIONS(4791),
    [sym_rune_literal] = ACTIONS(4791),
    [anon_sym_SQUOTE] = ACTIONS(4791),
    [anon_sym_DQUOTE] = ACTIONS(4791),
    [anon_sym_c_SQUOTE] = ACTIONS(4791),
    [anon_sym_c_DQUOTE] = ACTIONS(4791),
    [anon_sym_r_SQUOTE] = ACTIONS(4791),
    [anon_sym_r_DQUOTE] = ACTIONS(4791),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4791),
    [anon_sym_shared] = ACTIONS(4791),
    [anon_sym_map_LBRACK] = ACTIONS(4791),
    [anon_sym_chan] = ACTIONS(4791),
    [anon_sym_thread] = ACTIONS(4791),
    [anon_sym_atomic] = ACTIONS(4791),
    [anon_sym_assert] = ACTIONS(4791),
    [anon_sym_defer] = ACTIONS(4791),
    [anon_sym_goto] = ACTIONS(4791),
    [anon_sym_break] = ACTIONS(4791),
    [anon_sym_continue] = ACTIONS(4791),
    [anon_sym_return] = ACTIONS(4791),
    [anon_sym_DOLLARfor] = ACTIONS(4791),
    [anon_sym_for] = ACTIONS(4791),
    [anon_sym_POUND] = ACTIONS(4791),
    [anon_sym_asm] = ACTIONS(4791),
    [anon_sym_AT_LBRACK] = ACTIONS(4791),
  },
  [1872] = {
    [sym_line_comment] = STATE(1872),
    [sym_block_comment] = STATE(1872),
    [ts_builtin_sym_end] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4795),
    [anon_sym_LF] = ACTIONS(4795),
    [anon_sym_CR] = ACTIONS(4795),
    [anon_sym_CR_LF] = ACTIONS(4795),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4795),
    [anon_sym_LBRACE] = ACTIONS(4795),
    [anon_sym_const] = ACTIONS(4795),
    [anon_sym_LPAREN] = ACTIONS(4795),
    [anon_sym___global] = ACTIONS(4795),
    [anon_sym_type] = ACTIONS(4795),
    [anon_sym_fn] = ACTIONS(4795),
    [anon_sym_PLUS] = ACTIONS(4795),
    [anon_sym_DASH] = ACTIONS(4795),
    [anon_sym_STAR] = ACTIONS(4795),
    [anon_sym_struct] = ACTIONS(4795),
    [anon_sym_union] = ACTIONS(4795),
    [anon_sym_pub] = ACTIONS(4795),
    [anon_sym_mut] = ACTIONS(4795),
    [anon_sym_enum] = ACTIONS(4795),
    [anon_sym_interface] = ACTIONS(4795),
    [anon_sym_QMARK] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(4795),
    [anon_sym_go] = ACTIONS(4795),
    [anon_sym_spawn] = ACTIONS(4795),
    [anon_sym_json_DOTdecode] = ACTIONS(4795),
    [anon_sym_LBRACK2] = ACTIONS(4795),
    [anon_sym_TILDE] = ACTIONS(4795),
    [anon_sym_CARET] = ACTIONS(4795),
    [anon_sym_AMP] = ACTIONS(4795),
    [anon_sym_LT_DASH] = ACTIONS(4795),
    [sym_none] = ACTIONS(4795),
    [sym_true] = ACTIONS(4795),
    [sym_false] = ACTIONS(4795),
    [sym_nil] = ACTIONS(4795),
    [anon_sym_if] = ACTIONS(4795),
    [anon_sym_DOLLARif] = ACTIONS(4795),
    [anon_sym_match] = ACTIONS(4795),
    [anon_sym_select] = ACTIONS(4795),
    [anon_sym_lock] = ACTIONS(4795),
    [anon_sym_rlock] = ACTIONS(4795),
    [anon_sym_unsafe] = ACTIONS(4795),
    [anon_sym_sql] = ACTIONS(4795),
    [sym_int_literal] = ACTIONS(4795),
    [sym_float_literal] = ACTIONS(4795),
    [sym_rune_literal] = ACTIONS(4795),
    [anon_sym_SQUOTE] = ACTIONS(4795),
    [anon_sym_DQUOTE] = ACTIONS(4795),
    [anon_sym_c_SQUOTE] = ACTIONS(4795),
    [anon_sym_c_DQUOTE] = ACTIONS(4795),
    [anon_sym_r_SQUOTE] = ACTIONS(4795),
    [anon_sym_r_DQUOTE] = ACTIONS(4795),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4795),
    [anon_sym_shared] = ACTIONS(4795),
    [anon_sym_map_LBRACK] = ACTIONS(4795),
    [anon_sym_chan] = ACTIONS(4795),
    [anon_sym_thread] = ACTIONS(4795),
    [anon_sym_atomic] = ACTIONS(4795),
    [anon_sym_assert] = ACTIONS(4795),
    [anon_sym_defer] = ACTIONS(4795),
    [anon_sym_goto] = ACTIONS(4795),
    [anon_sym_break] = ACTIONS(4795),
    [anon_sym_continue] = ACTIONS(4795),
    [anon_sym_return] = ACTIONS(4795),
    [anon_sym_DOLLARfor] = ACTIONS(4795),
    [anon_sym_for] = ACTIONS(4795),
    [anon_sym_POUND] = ACTIONS(4795),
    [anon_sym_asm] = ACTIONS(4795),
    [anon_sym_AT_LBRACK] = ACTIONS(4795),
  },
  [1873] = {
    [sym_line_comment] = STATE(1873),
    [sym_block_comment] = STATE(1873),
    [ts_builtin_sym_end] = ACTIONS(4797),
    [sym_identifier] = ACTIONS(4799),
    [anon_sym_LF] = ACTIONS(4799),
    [anon_sym_CR] = ACTIONS(4799),
    [anon_sym_CR_LF] = ACTIONS(4799),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4799),
    [anon_sym_LBRACE] = ACTIONS(4799),
    [anon_sym_const] = ACTIONS(4799),
    [anon_sym_LPAREN] = ACTIONS(4799),
    [anon_sym___global] = ACTIONS(4799),
    [anon_sym_type] = ACTIONS(4799),
    [anon_sym_fn] = ACTIONS(4799),
    [anon_sym_PLUS] = ACTIONS(4799),
    [anon_sym_DASH] = ACTIONS(4799),
    [anon_sym_STAR] = ACTIONS(4799),
    [anon_sym_struct] = ACTIONS(4799),
    [anon_sym_union] = ACTIONS(4799),
    [anon_sym_pub] = ACTIONS(4799),
    [anon_sym_mut] = ACTIONS(4799),
    [anon_sym_enum] = ACTIONS(4799),
    [anon_sym_interface] = ACTIONS(4799),
    [anon_sym_QMARK] = ACTIONS(4799),
    [anon_sym_BANG] = ACTIONS(4799),
    [anon_sym_go] = ACTIONS(4799),
    [anon_sym_spawn] = ACTIONS(4799),
    [anon_sym_json_DOTdecode] = ACTIONS(4799),
    [anon_sym_LBRACK2] = ACTIONS(4799),
    [anon_sym_TILDE] = ACTIONS(4799),
    [anon_sym_CARET] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(4799),
    [anon_sym_LT_DASH] = ACTIONS(4799),
    [sym_none] = ACTIONS(4799),
    [sym_true] = ACTIONS(4799),
    [sym_false] = ACTIONS(4799),
    [sym_nil] = ACTIONS(4799),
    [anon_sym_if] = ACTIONS(4799),
    [anon_sym_DOLLARif] = ACTIONS(4799),
    [anon_sym_match] = ACTIONS(4799),
    [anon_sym_select] = ACTIONS(4799),
    [anon_sym_lock] = ACTIONS(4799),
    [anon_sym_rlock] = ACTIONS(4799),
    [anon_sym_unsafe] = ACTIONS(4799),
    [anon_sym_sql] = ACTIONS(4799),
    [sym_int_literal] = ACTIONS(4799),
    [sym_float_literal] = ACTIONS(4799),
    [sym_rune_literal] = ACTIONS(4799),
    [anon_sym_SQUOTE] = ACTIONS(4799),
    [anon_sym_DQUOTE] = ACTIONS(4799),
    [anon_sym_c_SQUOTE] = ACTIONS(4799),
    [anon_sym_c_DQUOTE] = ACTIONS(4799),
    [anon_sym_r_SQUOTE] = ACTIONS(4799),
    [anon_sym_r_DQUOTE] = ACTIONS(4799),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4799),
    [anon_sym_shared] = ACTIONS(4799),
    [anon_sym_map_LBRACK] = ACTIONS(4799),
    [anon_sym_chan] = ACTIONS(4799),
    [anon_sym_thread] = ACTIONS(4799),
    [anon_sym_atomic] = ACTIONS(4799),
    [anon_sym_assert] = ACTIONS(4799),
    [anon_sym_defer] = ACTIONS(4799),
    [anon_sym_goto] = ACTIONS(4799),
    [anon_sym_break] = ACTIONS(4799),
    [anon_sym_continue] = ACTIONS(4799),
    [anon_sym_return] = ACTIONS(4799),
    [anon_sym_DOLLARfor] = ACTIONS(4799),
    [anon_sym_for] = ACTIONS(4799),
    [anon_sym_POUND] = ACTIONS(4799),
    [anon_sym_asm] = ACTIONS(4799),
    [anon_sym_AT_LBRACK] = ACTIONS(4799),
  },
  [1874] = {
    [sym_line_comment] = STATE(1874),
    [sym_block_comment] = STATE(1874),
    [ts_builtin_sym_end] = ACTIONS(4801),
    [sym_identifier] = ACTIONS(4803),
    [anon_sym_LF] = ACTIONS(4803),
    [anon_sym_CR] = ACTIONS(4803),
    [anon_sym_CR_LF] = ACTIONS(4803),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4803),
    [anon_sym_LBRACE] = ACTIONS(4803),
    [anon_sym_const] = ACTIONS(4803),
    [anon_sym_LPAREN] = ACTIONS(4803),
    [anon_sym___global] = ACTIONS(4803),
    [anon_sym_type] = ACTIONS(4803),
    [anon_sym_fn] = ACTIONS(4803),
    [anon_sym_PLUS] = ACTIONS(4803),
    [anon_sym_DASH] = ACTIONS(4803),
    [anon_sym_STAR] = ACTIONS(4803),
    [anon_sym_struct] = ACTIONS(4803),
    [anon_sym_union] = ACTIONS(4803),
    [anon_sym_pub] = ACTIONS(4803),
    [anon_sym_mut] = ACTIONS(4803),
    [anon_sym_enum] = ACTIONS(4803),
    [anon_sym_interface] = ACTIONS(4803),
    [anon_sym_QMARK] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(4803),
    [anon_sym_go] = ACTIONS(4803),
    [anon_sym_spawn] = ACTIONS(4803),
    [anon_sym_json_DOTdecode] = ACTIONS(4803),
    [anon_sym_LBRACK2] = ACTIONS(4803),
    [anon_sym_TILDE] = ACTIONS(4803),
    [anon_sym_CARET] = ACTIONS(4803),
    [anon_sym_AMP] = ACTIONS(4803),
    [anon_sym_LT_DASH] = ACTIONS(4803),
    [sym_none] = ACTIONS(4803),
    [sym_true] = ACTIONS(4803),
    [sym_false] = ACTIONS(4803),
    [sym_nil] = ACTIONS(4803),
    [anon_sym_if] = ACTIONS(4803),
    [anon_sym_DOLLARif] = ACTIONS(4803),
    [anon_sym_match] = ACTIONS(4803),
    [anon_sym_select] = ACTIONS(4803),
    [anon_sym_lock] = ACTIONS(4803),
    [anon_sym_rlock] = ACTIONS(4803),
    [anon_sym_unsafe] = ACTIONS(4803),
    [anon_sym_sql] = ACTIONS(4803),
    [sym_int_literal] = ACTIONS(4803),
    [sym_float_literal] = ACTIONS(4803),
    [sym_rune_literal] = ACTIONS(4803),
    [anon_sym_SQUOTE] = ACTIONS(4803),
    [anon_sym_DQUOTE] = ACTIONS(4803),
    [anon_sym_c_SQUOTE] = ACTIONS(4803),
    [anon_sym_c_DQUOTE] = ACTIONS(4803),
    [anon_sym_r_SQUOTE] = ACTIONS(4803),
    [anon_sym_r_DQUOTE] = ACTIONS(4803),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4803),
    [anon_sym_shared] = ACTIONS(4803),
    [anon_sym_map_LBRACK] = ACTIONS(4803),
    [anon_sym_chan] = ACTIONS(4803),
    [anon_sym_thread] = ACTIONS(4803),
    [anon_sym_atomic] = ACTIONS(4803),
    [anon_sym_assert] = ACTIONS(4803),
    [anon_sym_defer] = ACTIONS(4803),
    [anon_sym_goto] = ACTIONS(4803),
    [anon_sym_break] = ACTIONS(4803),
    [anon_sym_continue] = ACTIONS(4803),
    [anon_sym_return] = ACTIONS(4803),
    [anon_sym_DOLLARfor] = ACTIONS(4803),
    [anon_sym_for] = ACTIONS(4803),
    [anon_sym_POUND] = ACTIONS(4803),
    [anon_sym_asm] = ACTIONS(4803),
    [anon_sym_AT_LBRACK] = ACTIONS(4803),
  },
  [1875] = {
    [sym_line_comment] = STATE(1875),
    [sym_block_comment] = STATE(1875),
    [ts_builtin_sym_end] = ACTIONS(2891),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LF] = ACTIONS(2893),
    [anon_sym_CR] = ACTIONS(2893),
    [anon_sym_CR_LF] = ACTIONS(2893),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2893),
    [anon_sym___global] = ACTIONS(2893),
    [anon_sym_type] = ACTIONS(2893),
    [anon_sym_fn] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [anon_sym_pub] = ACTIONS(2893),
    [anon_sym_mut] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_interface] = ACTIONS(2893),
    [anon_sym_QMARK] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_go] = ACTIONS(2893),
    [anon_sym_spawn] = ACTIONS(2893),
    [anon_sym_json_DOTdecode] = ACTIONS(2893),
    [anon_sym_LBRACK2] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_LT_DASH] = ACTIONS(2893),
    [sym_none] = ACTIONS(2893),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [sym_nil] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_DOLLARif] = ACTIONS(2893),
    [anon_sym_match] = ACTIONS(2893),
    [anon_sym_select] = ACTIONS(2893),
    [anon_sym_lock] = ACTIONS(2893),
    [anon_sym_rlock] = ACTIONS(2893),
    [anon_sym_unsafe] = ACTIONS(2893),
    [anon_sym_sql] = ACTIONS(2893),
    [sym_int_literal] = ACTIONS(2893),
    [sym_float_literal] = ACTIONS(2893),
    [sym_rune_literal] = ACTIONS(2893),
    [anon_sym_SQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(2893),
    [anon_sym_c_SQUOTE] = ACTIONS(2893),
    [anon_sym_c_DQUOTE] = ACTIONS(2893),
    [anon_sym_r_SQUOTE] = ACTIONS(2893),
    [anon_sym_r_DQUOTE] = ACTIONS(2893),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_map_LBRACK] = ACTIONS(2893),
    [anon_sym_chan] = ACTIONS(2893),
    [anon_sym_thread] = ACTIONS(2893),
    [anon_sym_atomic] = ACTIONS(2893),
    [anon_sym_assert] = ACTIONS(2893),
    [anon_sym_defer] = ACTIONS(2893),
    [anon_sym_goto] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_DOLLARfor] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_POUND] = ACTIONS(2893),
    [anon_sym_asm] = ACTIONS(2893),
    [anon_sym_AT_LBRACK] = ACTIONS(2893),
  },
  [1876] = {
    [sym_line_comment] = STATE(1876),
    [sym_block_comment] = STATE(1876),
    [ts_builtin_sym_end] = ACTIONS(4805),
    [sym_identifier] = ACTIONS(4807),
    [anon_sym_LF] = ACTIONS(4807),
    [anon_sym_CR] = ACTIONS(4807),
    [anon_sym_CR_LF] = ACTIONS(4807),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4807),
    [anon_sym_LBRACE] = ACTIONS(4807),
    [anon_sym_const] = ACTIONS(4807),
    [anon_sym_LPAREN] = ACTIONS(4807),
    [anon_sym___global] = ACTIONS(4807),
    [anon_sym_type] = ACTIONS(4807),
    [anon_sym_fn] = ACTIONS(4807),
    [anon_sym_PLUS] = ACTIONS(4807),
    [anon_sym_DASH] = ACTIONS(4807),
    [anon_sym_STAR] = ACTIONS(4807),
    [anon_sym_struct] = ACTIONS(4807),
    [anon_sym_union] = ACTIONS(4807),
    [anon_sym_pub] = ACTIONS(4807),
    [anon_sym_mut] = ACTIONS(4807),
    [anon_sym_enum] = ACTIONS(4807),
    [anon_sym_interface] = ACTIONS(4807),
    [anon_sym_QMARK] = ACTIONS(4807),
    [anon_sym_BANG] = ACTIONS(4807),
    [anon_sym_go] = ACTIONS(4807),
    [anon_sym_spawn] = ACTIONS(4807),
    [anon_sym_json_DOTdecode] = ACTIONS(4807),
    [anon_sym_LBRACK2] = ACTIONS(4807),
    [anon_sym_TILDE] = ACTIONS(4807),
    [anon_sym_CARET] = ACTIONS(4807),
    [anon_sym_AMP] = ACTIONS(4807),
    [anon_sym_LT_DASH] = ACTIONS(4807),
    [sym_none] = ACTIONS(4807),
    [sym_true] = ACTIONS(4807),
    [sym_false] = ACTIONS(4807),
    [sym_nil] = ACTIONS(4807),
    [anon_sym_if] = ACTIONS(4807),
    [anon_sym_DOLLARif] = ACTIONS(4807),
    [anon_sym_match] = ACTIONS(4807),
    [anon_sym_select] = ACTIONS(4807),
    [anon_sym_lock] = ACTIONS(4807),
    [anon_sym_rlock] = ACTIONS(4807),
    [anon_sym_unsafe] = ACTIONS(4807),
    [anon_sym_sql] = ACTIONS(4807),
    [sym_int_literal] = ACTIONS(4807),
    [sym_float_literal] = ACTIONS(4807),
    [sym_rune_literal] = ACTIONS(4807),
    [anon_sym_SQUOTE] = ACTIONS(4807),
    [anon_sym_DQUOTE] = ACTIONS(4807),
    [anon_sym_c_SQUOTE] = ACTIONS(4807),
    [anon_sym_c_DQUOTE] = ACTIONS(4807),
    [anon_sym_r_SQUOTE] = ACTIONS(4807),
    [anon_sym_r_DQUOTE] = ACTIONS(4807),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4807),
    [anon_sym_shared] = ACTIONS(4807),
    [anon_sym_map_LBRACK] = ACTIONS(4807),
    [anon_sym_chan] = ACTIONS(4807),
    [anon_sym_thread] = ACTIONS(4807),
    [anon_sym_atomic] = ACTIONS(4807),
    [anon_sym_assert] = ACTIONS(4807),
    [anon_sym_defer] = ACTIONS(4807),
    [anon_sym_goto] = ACTIONS(4807),
    [anon_sym_break] = ACTIONS(4807),
    [anon_sym_continue] = ACTIONS(4807),
    [anon_sym_return] = ACTIONS(4807),
    [anon_sym_DOLLARfor] = ACTIONS(4807),
    [anon_sym_for] = ACTIONS(4807),
    [anon_sym_POUND] = ACTIONS(4807),
    [anon_sym_asm] = ACTIONS(4807),
    [anon_sym_AT_LBRACK] = ACTIONS(4807),
  },
  [1877] = {
    [sym_line_comment] = STATE(1877),
    [sym_block_comment] = STATE(1877),
    [ts_builtin_sym_end] = ACTIONS(4407),
    [sym_identifier] = ACTIONS(4409),
    [anon_sym_LF] = ACTIONS(4409),
    [anon_sym_CR] = ACTIONS(4409),
    [anon_sym_CR_LF] = ACTIONS(4409),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4409),
    [anon_sym_LBRACE] = ACTIONS(4409),
    [anon_sym_const] = ACTIONS(4409),
    [anon_sym_LPAREN] = ACTIONS(4409),
    [anon_sym___global] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_fn] = ACTIONS(4409),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_DASH] = ACTIONS(4409),
    [anon_sym_STAR] = ACTIONS(4409),
    [anon_sym_struct] = ACTIONS(4409),
    [anon_sym_union] = ACTIONS(4409),
    [anon_sym_pub] = ACTIONS(4409),
    [anon_sym_mut] = ACTIONS(4409),
    [anon_sym_enum] = ACTIONS(4409),
    [anon_sym_interface] = ACTIONS(4409),
    [anon_sym_QMARK] = ACTIONS(4409),
    [anon_sym_BANG] = ACTIONS(4409),
    [anon_sym_go] = ACTIONS(4409),
    [anon_sym_spawn] = ACTIONS(4409),
    [anon_sym_json_DOTdecode] = ACTIONS(4409),
    [anon_sym_LBRACK2] = ACTIONS(4409),
    [anon_sym_TILDE] = ACTIONS(4409),
    [anon_sym_CARET] = ACTIONS(4409),
    [anon_sym_AMP] = ACTIONS(4409),
    [anon_sym_LT_DASH] = ACTIONS(4409),
    [sym_none] = ACTIONS(4409),
    [sym_true] = ACTIONS(4409),
    [sym_false] = ACTIONS(4409),
    [sym_nil] = ACTIONS(4409),
    [anon_sym_if] = ACTIONS(4409),
    [anon_sym_DOLLARif] = ACTIONS(4409),
    [anon_sym_match] = ACTIONS(4409),
    [anon_sym_select] = ACTIONS(4409),
    [anon_sym_lock] = ACTIONS(4409),
    [anon_sym_rlock] = ACTIONS(4409),
    [anon_sym_unsafe] = ACTIONS(4409),
    [anon_sym_sql] = ACTIONS(4409),
    [sym_int_literal] = ACTIONS(4409),
    [sym_float_literal] = ACTIONS(4409),
    [sym_rune_literal] = ACTIONS(4409),
    [anon_sym_SQUOTE] = ACTIONS(4409),
    [anon_sym_DQUOTE] = ACTIONS(4409),
    [anon_sym_c_SQUOTE] = ACTIONS(4409),
    [anon_sym_c_DQUOTE] = ACTIONS(4409),
    [anon_sym_r_SQUOTE] = ACTIONS(4409),
    [anon_sym_r_DQUOTE] = ACTIONS(4409),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4409),
    [anon_sym_shared] = ACTIONS(4409),
    [anon_sym_map_LBRACK] = ACTIONS(4409),
    [anon_sym_chan] = ACTIONS(4409),
    [anon_sym_thread] = ACTIONS(4409),
    [anon_sym_atomic] = ACTIONS(4409),
    [anon_sym_assert] = ACTIONS(4409),
    [anon_sym_defer] = ACTIONS(4409),
    [anon_sym_goto] = ACTIONS(4409),
    [anon_sym_break] = ACTIONS(4409),
    [anon_sym_continue] = ACTIONS(4409),
    [anon_sym_return] = ACTIONS(4409),
    [anon_sym_DOLLARfor] = ACTIONS(4409),
    [anon_sym_for] = ACTIONS(4409),
    [anon_sym_POUND] = ACTIONS(4409),
    [anon_sym_asm] = ACTIONS(4409),
    [anon_sym_AT_LBRACK] = ACTIONS(4409),
  },
  [1878] = {
    [sym_line_comment] = STATE(1878),
    [sym_block_comment] = STATE(1878),
    [ts_builtin_sym_end] = ACTIONS(3322),
    [sym_identifier] = ACTIONS(3324),
    [anon_sym_LF] = ACTIONS(3324),
    [anon_sym_CR] = ACTIONS(3324),
    [anon_sym_CR_LF] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3324),
    [anon_sym_const] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3324),
    [anon_sym___global] = ACTIONS(3324),
    [anon_sym_type] = ACTIONS(3324),
    [anon_sym_fn] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3324),
    [anon_sym_DASH] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3324),
    [anon_sym_struct] = ACTIONS(3324),
    [anon_sym_union] = ACTIONS(3324),
    [anon_sym_pub] = ACTIONS(3324),
    [anon_sym_mut] = ACTIONS(3324),
    [anon_sym_enum] = ACTIONS(3324),
    [anon_sym_interface] = ACTIONS(3324),
    [anon_sym_QMARK] = ACTIONS(3324),
    [anon_sym_BANG] = ACTIONS(3324),
    [anon_sym_go] = ACTIONS(3324),
    [anon_sym_spawn] = ACTIONS(3324),
    [anon_sym_json_DOTdecode] = ACTIONS(3324),
    [anon_sym_LBRACK2] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3324),
    [anon_sym_LT_DASH] = ACTIONS(3324),
    [sym_none] = ACTIONS(3324),
    [sym_true] = ACTIONS(3324),
    [sym_false] = ACTIONS(3324),
    [sym_nil] = ACTIONS(3324),
    [anon_sym_if] = ACTIONS(3324),
    [anon_sym_DOLLARif] = ACTIONS(3324),
    [anon_sym_match] = ACTIONS(3324),
    [anon_sym_select] = ACTIONS(3324),
    [anon_sym_lock] = ACTIONS(3324),
    [anon_sym_rlock] = ACTIONS(3324),
    [anon_sym_unsafe] = ACTIONS(3324),
    [anon_sym_sql] = ACTIONS(3324),
    [sym_int_literal] = ACTIONS(3324),
    [sym_float_literal] = ACTIONS(3324),
    [sym_rune_literal] = ACTIONS(3324),
    [anon_sym_SQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE] = ACTIONS(3324),
    [anon_sym_c_SQUOTE] = ACTIONS(3324),
    [anon_sym_c_DQUOTE] = ACTIONS(3324),
    [anon_sym_r_SQUOTE] = ACTIONS(3324),
    [anon_sym_r_DQUOTE] = ACTIONS(3324),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3324),
    [anon_sym_shared] = ACTIONS(3324),
    [anon_sym_map_LBRACK] = ACTIONS(3324),
    [anon_sym_chan] = ACTIONS(3324),
    [anon_sym_thread] = ACTIONS(3324),
    [anon_sym_atomic] = ACTIONS(3324),
    [anon_sym_assert] = ACTIONS(3324),
    [anon_sym_defer] = ACTIONS(3324),
    [anon_sym_goto] = ACTIONS(3324),
    [anon_sym_break] = ACTIONS(3324),
    [anon_sym_continue] = ACTIONS(3324),
    [anon_sym_return] = ACTIONS(3324),
    [anon_sym_DOLLARfor] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3324),
    [anon_sym_POUND] = ACTIONS(3324),
    [anon_sym_asm] = ACTIONS(3324),
    [anon_sym_AT_LBRACK] = ACTIONS(3324),
  },
  [1879] = {
    [sym_line_comment] = STATE(1879),
    [sym_block_comment] = STATE(1879),
    [ts_builtin_sym_end] = ACTIONS(4809),
    [sym_identifier] = ACTIONS(4811),
    [anon_sym_LF] = ACTIONS(4811),
    [anon_sym_CR] = ACTIONS(4811),
    [anon_sym_CR_LF] = ACTIONS(4811),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4811),
    [anon_sym_LBRACE] = ACTIONS(4811),
    [anon_sym_const] = ACTIONS(4811),
    [anon_sym_LPAREN] = ACTIONS(4811),
    [anon_sym___global] = ACTIONS(4811),
    [anon_sym_type] = ACTIONS(4811),
    [anon_sym_fn] = ACTIONS(4811),
    [anon_sym_PLUS] = ACTIONS(4811),
    [anon_sym_DASH] = ACTIONS(4811),
    [anon_sym_STAR] = ACTIONS(4811),
    [anon_sym_struct] = ACTIONS(4811),
    [anon_sym_union] = ACTIONS(4811),
    [anon_sym_pub] = ACTIONS(4811),
    [anon_sym_mut] = ACTIONS(4811),
    [anon_sym_enum] = ACTIONS(4811),
    [anon_sym_interface] = ACTIONS(4811),
    [anon_sym_QMARK] = ACTIONS(4811),
    [anon_sym_BANG] = ACTIONS(4811),
    [anon_sym_go] = ACTIONS(4811),
    [anon_sym_spawn] = ACTIONS(4811),
    [anon_sym_json_DOTdecode] = ACTIONS(4811),
    [anon_sym_LBRACK2] = ACTIONS(4811),
    [anon_sym_TILDE] = ACTIONS(4811),
    [anon_sym_CARET] = ACTIONS(4811),
    [anon_sym_AMP] = ACTIONS(4811),
    [anon_sym_LT_DASH] = ACTIONS(4811),
    [sym_none] = ACTIONS(4811),
    [sym_true] = ACTIONS(4811),
    [sym_false] = ACTIONS(4811),
    [sym_nil] = ACTIONS(4811),
    [anon_sym_if] = ACTIONS(4811),
    [anon_sym_DOLLARif] = ACTIONS(4811),
    [anon_sym_match] = ACTIONS(4811),
    [anon_sym_select] = ACTIONS(4811),
    [anon_sym_lock] = ACTIONS(4811),
    [anon_sym_rlock] = ACTIONS(4811),
    [anon_sym_unsafe] = ACTIONS(4811),
    [anon_sym_sql] = ACTIONS(4811),
    [sym_int_literal] = ACTIONS(4811),
    [sym_float_literal] = ACTIONS(4811),
    [sym_rune_literal] = ACTIONS(4811),
    [anon_sym_SQUOTE] = ACTIONS(4811),
    [anon_sym_DQUOTE] = ACTIONS(4811),
    [anon_sym_c_SQUOTE] = ACTIONS(4811),
    [anon_sym_c_DQUOTE] = ACTIONS(4811),
    [anon_sym_r_SQUOTE] = ACTIONS(4811),
    [anon_sym_r_DQUOTE] = ACTIONS(4811),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4811),
    [anon_sym_shared] = ACTIONS(4811),
    [anon_sym_map_LBRACK] = ACTIONS(4811),
    [anon_sym_chan] = ACTIONS(4811),
    [anon_sym_thread] = ACTIONS(4811),
    [anon_sym_atomic] = ACTIONS(4811),
    [anon_sym_assert] = ACTIONS(4811),
    [anon_sym_defer] = ACTIONS(4811),
    [anon_sym_goto] = ACTIONS(4811),
    [anon_sym_break] = ACTIONS(4811),
    [anon_sym_continue] = ACTIONS(4811),
    [anon_sym_return] = ACTIONS(4811),
    [anon_sym_DOLLARfor] = ACTIONS(4811),
    [anon_sym_for] = ACTIONS(4811),
    [anon_sym_POUND] = ACTIONS(4811),
    [anon_sym_asm] = ACTIONS(4811),
    [anon_sym_AT_LBRACK] = ACTIONS(4811),
  },
  [1880] = {
    [sym_line_comment] = STATE(1880),
    [sym_block_comment] = STATE(1880),
    [ts_builtin_sym_end] = ACTIONS(4813),
    [sym_identifier] = ACTIONS(4815),
    [anon_sym_LF] = ACTIONS(4815),
    [anon_sym_CR] = ACTIONS(4815),
    [anon_sym_CR_LF] = ACTIONS(4815),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4815),
    [anon_sym_LBRACE] = ACTIONS(4815),
    [anon_sym_const] = ACTIONS(4815),
    [anon_sym_LPAREN] = ACTIONS(4815),
    [anon_sym___global] = ACTIONS(4815),
    [anon_sym_type] = ACTIONS(4815),
    [anon_sym_fn] = ACTIONS(4815),
    [anon_sym_PLUS] = ACTIONS(4815),
    [anon_sym_DASH] = ACTIONS(4815),
    [anon_sym_STAR] = ACTIONS(4815),
    [anon_sym_struct] = ACTIONS(4815),
    [anon_sym_union] = ACTIONS(4815),
    [anon_sym_pub] = ACTIONS(4815),
    [anon_sym_mut] = ACTIONS(4815),
    [anon_sym_enum] = ACTIONS(4815),
    [anon_sym_interface] = ACTIONS(4815),
    [anon_sym_QMARK] = ACTIONS(4815),
    [anon_sym_BANG] = ACTIONS(4815),
    [anon_sym_go] = ACTIONS(4815),
    [anon_sym_spawn] = ACTIONS(4815),
    [anon_sym_json_DOTdecode] = ACTIONS(4815),
    [anon_sym_LBRACK2] = ACTIONS(4815),
    [anon_sym_TILDE] = ACTIONS(4815),
    [anon_sym_CARET] = ACTIONS(4815),
    [anon_sym_AMP] = ACTIONS(4815),
    [anon_sym_LT_DASH] = ACTIONS(4815),
    [sym_none] = ACTIONS(4815),
    [sym_true] = ACTIONS(4815),
    [sym_false] = ACTIONS(4815),
    [sym_nil] = ACTIONS(4815),
    [anon_sym_if] = ACTIONS(4815),
    [anon_sym_DOLLARif] = ACTIONS(4815),
    [anon_sym_match] = ACTIONS(4815),
    [anon_sym_select] = ACTIONS(4815),
    [anon_sym_lock] = ACTIONS(4815),
    [anon_sym_rlock] = ACTIONS(4815),
    [anon_sym_unsafe] = ACTIONS(4815),
    [anon_sym_sql] = ACTIONS(4815),
    [sym_int_literal] = ACTIONS(4815),
    [sym_float_literal] = ACTIONS(4815),
    [sym_rune_literal] = ACTIONS(4815),
    [anon_sym_SQUOTE] = ACTIONS(4815),
    [anon_sym_DQUOTE] = ACTIONS(4815),
    [anon_sym_c_SQUOTE] = ACTIONS(4815),
    [anon_sym_c_DQUOTE] = ACTIONS(4815),
    [anon_sym_r_SQUOTE] = ACTIONS(4815),
    [anon_sym_r_DQUOTE] = ACTIONS(4815),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4815),
    [anon_sym_shared] = ACTIONS(4815),
    [anon_sym_map_LBRACK] = ACTIONS(4815),
    [anon_sym_chan] = ACTIONS(4815),
    [anon_sym_thread] = ACTIONS(4815),
    [anon_sym_atomic] = ACTIONS(4815),
    [anon_sym_assert] = ACTIONS(4815),
    [anon_sym_defer] = ACTIONS(4815),
    [anon_sym_goto] = ACTIONS(4815),
    [anon_sym_break] = ACTIONS(4815),
    [anon_sym_continue] = ACTIONS(4815),
    [anon_sym_return] = ACTIONS(4815),
    [anon_sym_DOLLARfor] = ACTIONS(4815),
    [anon_sym_for] = ACTIONS(4815),
    [anon_sym_POUND] = ACTIONS(4815),
    [anon_sym_asm] = ACTIONS(4815),
    [anon_sym_AT_LBRACK] = ACTIONS(4815),
  },
  [1881] = {
    [sym_line_comment] = STATE(1881),
    [sym_block_comment] = STATE(1881),
    [ts_builtin_sym_end] = ACTIONS(2185),
    [sym_identifier] = ACTIONS(2187),
    [anon_sym_LF] = ACTIONS(2187),
    [anon_sym_CR] = ACTIONS(2187),
    [anon_sym_CR_LF] = ACTIONS(2187),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_const] = ACTIONS(2187),
    [anon_sym_LPAREN] = ACTIONS(2187),
    [anon_sym___global] = ACTIONS(2187),
    [anon_sym_type] = ACTIONS(2187),
    [anon_sym_fn] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_struct] = ACTIONS(2187),
    [anon_sym_union] = ACTIONS(2187),
    [anon_sym_pub] = ACTIONS(2187),
    [anon_sym_mut] = ACTIONS(2187),
    [anon_sym_enum] = ACTIONS(2187),
    [anon_sym_interface] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_go] = ACTIONS(2187),
    [anon_sym_spawn] = ACTIONS(2187),
    [anon_sym_json_DOTdecode] = ACTIONS(2187),
    [anon_sym_LBRACK2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_LT_DASH] = ACTIONS(2187),
    [sym_none] = ACTIONS(2187),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [sym_nil] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_DOLLARif] = ACTIONS(2187),
    [anon_sym_match] = ACTIONS(2187),
    [anon_sym_select] = ACTIONS(2187),
    [anon_sym_lock] = ACTIONS(2187),
    [anon_sym_rlock] = ACTIONS(2187),
    [anon_sym_unsafe] = ACTIONS(2187),
    [anon_sym_sql] = ACTIONS(2187),
    [sym_int_literal] = ACTIONS(2187),
    [sym_float_literal] = ACTIONS(2187),
    [sym_rune_literal] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(2187),
    [anon_sym_DQUOTE] = ACTIONS(2187),
    [anon_sym_c_SQUOTE] = ACTIONS(2187),
    [anon_sym_c_DQUOTE] = ACTIONS(2187),
    [anon_sym_r_SQUOTE] = ACTIONS(2187),
    [anon_sym_r_DQUOTE] = ACTIONS(2187),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2187),
    [anon_sym_shared] = ACTIONS(2187),
    [anon_sym_map_LBRACK] = ACTIONS(2187),
    [anon_sym_chan] = ACTIONS(2187),
    [anon_sym_thread] = ACTIONS(2187),
    [anon_sym_atomic] = ACTIONS(2187),
    [anon_sym_assert] = ACTIONS(2187),
    [anon_sym_defer] = ACTIONS(2187),
    [anon_sym_goto] = ACTIONS(2187),
    [anon_sym_break] = ACTIONS(2187),
    [anon_sym_continue] = ACTIONS(2187),
    [anon_sym_return] = ACTIONS(2187),
    [anon_sym_DOLLARfor] = ACTIONS(2187),
    [anon_sym_for] = ACTIONS(2187),
    [anon_sym_POUND] = ACTIONS(2187),
    [anon_sym_asm] = ACTIONS(2187),
    [anon_sym_AT_LBRACK] = ACTIONS(2187),
  },
  [1882] = {
    [sym_line_comment] = STATE(1882),
    [sym_block_comment] = STATE(1882),
    [ts_builtin_sym_end] = ACTIONS(4817),
    [sym_identifier] = ACTIONS(4819),
    [anon_sym_LF] = ACTIONS(4819),
    [anon_sym_CR] = ACTIONS(4819),
    [anon_sym_CR_LF] = ACTIONS(4819),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4819),
    [anon_sym_LBRACE] = ACTIONS(4819),
    [anon_sym_const] = ACTIONS(4819),
    [anon_sym_LPAREN] = ACTIONS(4819),
    [anon_sym___global] = ACTIONS(4819),
    [anon_sym_type] = ACTIONS(4819),
    [anon_sym_fn] = ACTIONS(4819),
    [anon_sym_PLUS] = ACTIONS(4819),
    [anon_sym_DASH] = ACTIONS(4819),
    [anon_sym_STAR] = ACTIONS(4819),
    [anon_sym_struct] = ACTIONS(4819),
    [anon_sym_union] = ACTIONS(4819),
    [anon_sym_pub] = ACTIONS(4819),
    [anon_sym_mut] = ACTIONS(4819),
    [anon_sym_enum] = ACTIONS(4819),
    [anon_sym_interface] = ACTIONS(4819),
    [anon_sym_QMARK] = ACTIONS(4819),
    [anon_sym_BANG] = ACTIONS(4819),
    [anon_sym_go] = ACTIONS(4819),
    [anon_sym_spawn] = ACTIONS(4819),
    [anon_sym_json_DOTdecode] = ACTIONS(4819),
    [anon_sym_LBRACK2] = ACTIONS(4819),
    [anon_sym_TILDE] = ACTIONS(4819),
    [anon_sym_CARET] = ACTIONS(4819),
    [anon_sym_AMP] = ACTIONS(4819),
    [anon_sym_LT_DASH] = ACTIONS(4819),
    [sym_none] = ACTIONS(4819),
    [sym_true] = ACTIONS(4819),
    [sym_false] = ACTIONS(4819),
    [sym_nil] = ACTIONS(4819),
    [anon_sym_if] = ACTIONS(4819),
    [anon_sym_DOLLARif] = ACTIONS(4819),
    [anon_sym_match] = ACTIONS(4819),
    [anon_sym_select] = ACTIONS(4819),
    [anon_sym_lock] = ACTIONS(4819),
    [anon_sym_rlock] = ACTIONS(4819),
    [anon_sym_unsafe] = ACTIONS(4819),
    [anon_sym_sql] = ACTIONS(4819),
    [sym_int_literal] = ACTIONS(4819),
    [sym_float_literal] = ACTIONS(4819),
    [sym_rune_literal] = ACTIONS(4819),
    [anon_sym_SQUOTE] = ACTIONS(4819),
    [anon_sym_DQUOTE] = ACTIONS(4819),
    [anon_sym_c_SQUOTE] = ACTIONS(4819),
    [anon_sym_c_DQUOTE] = ACTIONS(4819),
    [anon_sym_r_SQUOTE] = ACTIONS(4819),
    [anon_sym_r_DQUOTE] = ACTIONS(4819),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4819),
    [anon_sym_shared] = ACTIONS(4819),
    [anon_sym_map_LBRACK] = ACTIONS(4819),
    [anon_sym_chan] = ACTIONS(4819),
    [anon_sym_thread] = ACTIONS(4819),
    [anon_sym_atomic] = ACTIONS(4819),
    [anon_sym_assert] = ACTIONS(4819),
    [anon_sym_defer] = ACTIONS(4819),
    [anon_sym_goto] = ACTIONS(4819),
    [anon_sym_break] = ACTIONS(4819),
    [anon_sym_continue] = ACTIONS(4819),
    [anon_sym_return] = ACTIONS(4819),
    [anon_sym_DOLLARfor] = ACTIONS(4819),
    [anon_sym_for] = ACTIONS(4819),
    [anon_sym_POUND] = ACTIONS(4819),
    [anon_sym_asm] = ACTIONS(4819),
    [anon_sym_AT_LBRACK] = ACTIONS(4819),
  },
  [1883] = {
    [sym_line_comment] = STATE(1883),
    [sym_block_comment] = STATE(1883),
    [ts_builtin_sym_end] = ACTIONS(3290),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_LF] = ACTIONS(3292),
    [anon_sym_CR] = ACTIONS(3292),
    [anon_sym_CR_LF] = ACTIONS(3292),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3292),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_const] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym___global] = ACTIONS(3292),
    [anon_sym_type] = ACTIONS(3292),
    [anon_sym_fn] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_struct] = ACTIONS(3292),
    [anon_sym_union] = ACTIONS(3292),
    [anon_sym_pub] = ACTIONS(3292),
    [anon_sym_mut] = ACTIONS(3292),
    [anon_sym_enum] = ACTIONS(3292),
    [anon_sym_interface] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3292),
    [anon_sym_BANG] = ACTIONS(3292),
    [anon_sym_go] = ACTIONS(3292),
    [anon_sym_spawn] = ACTIONS(3292),
    [anon_sym_json_DOTdecode] = ACTIONS(3292),
    [anon_sym_LBRACK2] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3292),
    [anon_sym_CARET] = ACTIONS(3292),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LT_DASH] = ACTIONS(3292),
    [sym_none] = ACTIONS(3292),
    [sym_true] = ACTIONS(3292),
    [sym_false] = ACTIONS(3292),
    [sym_nil] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_DOLLARif] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_select] = ACTIONS(3292),
    [anon_sym_lock] = ACTIONS(3292),
    [anon_sym_rlock] = ACTIONS(3292),
    [anon_sym_unsafe] = ACTIONS(3292),
    [anon_sym_sql] = ACTIONS(3292),
    [sym_int_literal] = ACTIONS(3292),
    [sym_float_literal] = ACTIONS(3292),
    [sym_rune_literal] = ACTIONS(3292),
    [anon_sym_SQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_c_SQUOTE] = ACTIONS(3292),
    [anon_sym_c_DQUOTE] = ACTIONS(3292),
    [anon_sym_r_SQUOTE] = ACTIONS(3292),
    [anon_sym_r_DQUOTE] = ACTIONS(3292),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3292),
    [anon_sym_shared] = ACTIONS(3292),
    [anon_sym_map_LBRACK] = ACTIONS(3292),
    [anon_sym_chan] = ACTIONS(3292),
    [anon_sym_thread] = ACTIONS(3292),
    [anon_sym_atomic] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_defer] = ACTIONS(3292),
    [anon_sym_goto] = ACTIONS(3292),
    [anon_sym_break] = ACTIONS(3292),
    [anon_sym_continue] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_DOLLARfor] = ACTIONS(3292),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_POUND] = ACTIONS(3292),
    [anon_sym_asm] = ACTIONS(3292),
    [anon_sym_AT_LBRACK] = ACTIONS(3292),
  },
  [1884] = {
    [sym_line_comment] = STATE(1884),
    [sym_block_comment] = STATE(1884),
    [ts_builtin_sym_end] = ACTIONS(4821),
    [sym_identifier] = ACTIONS(4823),
    [anon_sym_LF] = ACTIONS(4823),
    [anon_sym_CR] = ACTIONS(4823),
    [anon_sym_CR_LF] = ACTIONS(4823),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4823),
    [anon_sym_LBRACE] = ACTIONS(4823),
    [anon_sym_const] = ACTIONS(4823),
    [anon_sym_LPAREN] = ACTIONS(4823),
    [anon_sym___global] = ACTIONS(4823),
    [anon_sym_type] = ACTIONS(4823),
    [anon_sym_fn] = ACTIONS(4823),
    [anon_sym_PLUS] = ACTIONS(4823),
    [anon_sym_DASH] = ACTIONS(4823),
    [anon_sym_STAR] = ACTIONS(4823),
    [anon_sym_struct] = ACTIONS(4823),
    [anon_sym_union] = ACTIONS(4823),
    [anon_sym_pub] = ACTIONS(4823),
    [anon_sym_mut] = ACTIONS(4823),
    [anon_sym_enum] = ACTIONS(4823),
    [anon_sym_interface] = ACTIONS(4823),
    [anon_sym_QMARK] = ACTIONS(4823),
    [anon_sym_BANG] = ACTIONS(4823),
    [anon_sym_go] = ACTIONS(4823),
    [anon_sym_spawn] = ACTIONS(4823),
    [anon_sym_json_DOTdecode] = ACTIONS(4823),
    [anon_sym_LBRACK2] = ACTIONS(4823),
    [anon_sym_TILDE] = ACTIONS(4823),
    [anon_sym_CARET] = ACTIONS(4823),
    [anon_sym_AMP] = ACTIONS(4823),
    [anon_sym_LT_DASH] = ACTIONS(4823),
    [sym_none] = ACTIONS(4823),
    [sym_true] = ACTIONS(4823),
    [sym_false] = ACTIONS(4823),
    [sym_nil] = ACTIONS(4823),
    [anon_sym_if] = ACTIONS(4823),
    [anon_sym_DOLLARif] = ACTIONS(4823),
    [anon_sym_match] = ACTIONS(4823),
    [anon_sym_select] = ACTIONS(4823),
    [anon_sym_lock] = ACTIONS(4823),
    [anon_sym_rlock] = ACTIONS(4823),
    [anon_sym_unsafe] = ACTIONS(4823),
    [anon_sym_sql] = ACTIONS(4823),
    [sym_int_literal] = ACTIONS(4823),
    [sym_float_literal] = ACTIONS(4823),
    [sym_rune_literal] = ACTIONS(4823),
    [anon_sym_SQUOTE] = ACTIONS(4823),
    [anon_sym_DQUOTE] = ACTIONS(4823),
    [anon_sym_c_SQUOTE] = ACTIONS(4823),
    [anon_sym_c_DQUOTE] = ACTIONS(4823),
    [anon_sym_r_SQUOTE] = ACTIONS(4823),
    [anon_sym_r_DQUOTE] = ACTIONS(4823),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4823),
    [anon_sym_shared] = ACTIONS(4823),
    [anon_sym_map_LBRACK] = ACTIONS(4823),
    [anon_sym_chan] = ACTIONS(4823),
    [anon_sym_thread] = ACTIONS(4823),
    [anon_sym_atomic] = ACTIONS(4823),
    [anon_sym_assert] = ACTIONS(4823),
    [anon_sym_defer] = ACTIONS(4823),
    [anon_sym_goto] = ACTIONS(4823),
    [anon_sym_break] = ACTIONS(4823),
    [anon_sym_continue] = ACTIONS(4823),
    [anon_sym_return] = ACTIONS(4823),
    [anon_sym_DOLLARfor] = ACTIONS(4823),
    [anon_sym_for] = ACTIONS(4823),
    [anon_sym_POUND] = ACTIONS(4823),
    [anon_sym_asm] = ACTIONS(4823),
    [anon_sym_AT_LBRACK] = ACTIONS(4823),
  },
  [1885] = {
    [sym_line_comment] = STATE(1885),
    [sym_block_comment] = STATE(1885),
    [ts_builtin_sym_end] = ACTIONS(4825),
    [sym_identifier] = ACTIONS(4827),
    [anon_sym_LF] = ACTIONS(4827),
    [anon_sym_CR] = ACTIONS(4827),
    [anon_sym_CR_LF] = ACTIONS(4827),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4827),
    [anon_sym_LBRACE] = ACTIONS(4827),
    [anon_sym_const] = ACTIONS(4827),
    [anon_sym_LPAREN] = ACTIONS(4827),
    [anon_sym___global] = ACTIONS(4827),
    [anon_sym_type] = ACTIONS(4827),
    [anon_sym_fn] = ACTIONS(4827),
    [anon_sym_PLUS] = ACTIONS(4827),
    [anon_sym_DASH] = ACTIONS(4827),
    [anon_sym_STAR] = ACTIONS(4827),
    [anon_sym_struct] = ACTIONS(4827),
    [anon_sym_union] = ACTIONS(4827),
    [anon_sym_pub] = ACTIONS(4827),
    [anon_sym_mut] = ACTIONS(4827),
    [anon_sym_enum] = ACTIONS(4827),
    [anon_sym_interface] = ACTIONS(4827),
    [anon_sym_QMARK] = ACTIONS(4827),
    [anon_sym_BANG] = ACTIONS(4827),
    [anon_sym_go] = ACTIONS(4827),
    [anon_sym_spawn] = ACTIONS(4827),
    [anon_sym_json_DOTdecode] = ACTIONS(4827),
    [anon_sym_LBRACK2] = ACTIONS(4827),
    [anon_sym_TILDE] = ACTIONS(4827),
    [anon_sym_CARET] = ACTIONS(4827),
    [anon_sym_AMP] = ACTIONS(4827),
    [anon_sym_LT_DASH] = ACTIONS(4827),
    [sym_none] = ACTIONS(4827),
    [sym_true] = ACTIONS(4827),
    [sym_false] = ACTIONS(4827),
    [sym_nil] = ACTIONS(4827),
    [anon_sym_if] = ACTIONS(4827),
    [anon_sym_DOLLARif] = ACTIONS(4827),
    [anon_sym_match] = ACTIONS(4827),
    [anon_sym_select] = ACTIONS(4827),
    [anon_sym_lock] = ACTIONS(4827),
    [anon_sym_rlock] = ACTIONS(4827),
    [anon_sym_unsafe] = ACTIONS(4827),
    [anon_sym_sql] = ACTIONS(4827),
    [sym_int_literal] = ACTIONS(4827),
    [sym_float_literal] = ACTIONS(4827),
    [sym_rune_literal] = ACTIONS(4827),
    [anon_sym_SQUOTE] = ACTIONS(4827),
    [anon_sym_DQUOTE] = ACTIONS(4827),
    [anon_sym_c_SQUOTE] = ACTIONS(4827),
    [anon_sym_c_DQUOTE] = ACTIONS(4827),
    [anon_sym_r_SQUOTE] = ACTIONS(4827),
    [anon_sym_r_DQUOTE] = ACTIONS(4827),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4827),
    [anon_sym_shared] = ACTIONS(4827),
    [anon_sym_map_LBRACK] = ACTIONS(4827),
    [anon_sym_chan] = ACTIONS(4827),
    [anon_sym_thread] = ACTIONS(4827),
    [anon_sym_atomic] = ACTIONS(4827),
    [anon_sym_assert] = ACTIONS(4827),
    [anon_sym_defer] = ACTIONS(4827),
    [anon_sym_goto] = ACTIONS(4827),
    [anon_sym_break] = ACTIONS(4827),
    [anon_sym_continue] = ACTIONS(4827),
    [anon_sym_return] = ACTIONS(4827),
    [anon_sym_DOLLARfor] = ACTIONS(4827),
    [anon_sym_for] = ACTIONS(4827),
    [anon_sym_POUND] = ACTIONS(4827),
    [anon_sym_asm] = ACTIONS(4827),
    [anon_sym_AT_LBRACK] = ACTIONS(4827),
  },
  [1886] = {
    [sym_line_comment] = STATE(1886),
    [sym_block_comment] = STATE(1886),
    [ts_builtin_sym_end] = ACTIONS(4829),
    [sym_identifier] = ACTIONS(4831),
    [anon_sym_LF] = ACTIONS(4831),
    [anon_sym_CR] = ACTIONS(4831),
    [anon_sym_CR_LF] = ACTIONS(4831),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4831),
    [anon_sym_LBRACE] = ACTIONS(4831),
    [anon_sym_const] = ACTIONS(4831),
    [anon_sym_LPAREN] = ACTIONS(4831),
    [anon_sym___global] = ACTIONS(4831),
    [anon_sym_type] = ACTIONS(4831),
    [anon_sym_fn] = ACTIONS(4831),
    [anon_sym_PLUS] = ACTIONS(4831),
    [anon_sym_DASH] = ACTIONS(4831),
    [anon_sym_STAR] = ACTIONS(4831),
    [anon_sym_struct] = ACTIONS(4831),
    [anon_sym_union] = ACTIONS(4831),
    [anon_sym_pub] = ACTIONS(4831),
    [anon_sym_mut] = ACTIONS(4831),
    [anon_sym_enum] = ACTIONS(4831),
    [anon_sym_interface] = ACTIONS(4831),
    [anon_sym_QMARK] = ACTIONS(4831),
    [anon_sym_BANG] = ACTIONS(4831),
    [anon_sym_go] = ACTIONS(4831),
    [anon_sym_spawn] = ACTIONS(4831),
    [anon_sym_json_DOTdecode] = ACTIONS(4831),
    [anon_sym_LBRACK2] = ACTIONS(4831),
    [anon_sym_TILDE] = ACTIONS(4831),
    [anon_sym_CARET] = ACTIONS(4831),
    [anon_sym_AMP] = ACTIONS(4831),
    [anon_sym_LT_DASH] = ACTIONS(4831),
    [sym_none] = ACTIONS(4831),
    [sym_true] = ACTIONS(4831),
    [sym_false] = ACTIONS(4831),
    [sym_nil] = ACTIONS(4831),
    [anon_sym_if] = ACTIONS(4831),
    [anon_sym_DOLLARif] = ACTIONS(4831),
    [anon_sym_match] = ACTIONS(4831),
    [anon_sym_select] = ACTIONS(4831),
    [anon_sym_lock] = ACTIONS(4831),
    [anon_sym_rlock] = ACTIONS(4831),
    [anon_sym_unsafe] = ACTIONS(4831),
    [anon_sym_sql] = ACTIONS(4831),
    [sym_int_literal] = ACTIONS(4831),
    [sym_float_literal] = ACTIONS(4831),
    [sym_rune_literal] = ACTIONS(4831),
    [anon_sym_SQUOTE] = ACTIONS(4831),
    [anon_sym_DQUOTE] = ACTIONS(4831),
    [anon_sym_c_SQUOTE] = ACTIONS(4831),
    [anon_sym_c_DQUOTE] = ACTIONS(4831),
    [anon_sym_r_SQUOTE] = ACTIONS(4831),
    [anon_sym_r_DQUOTE] = ACTIONS(4831),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4831),
    [anon_sym_shared] = ACTIONS(4831),
    [anon_sym_map_LBRACK] = ACTIONS(4831),
    [anon_sym_chan] = ACTIONS(4831),
    [anon_sym_thread] = ACTIONS(4831),
    [anon_sym_atomic] = ACTIONS(4831),
    [anon_sym_assert] = ACTIONS(4831),
    [anon_sym_defer] = ACTIONS(4831),
    [anon_sym_goto] = ACTIONS(4831),
    [anon_sym_break] = ACTIONS(4831),
    [anon_sym_continue] = ACTIONS(4831),
    [anon_sym_return] = ACTIONS(4831),
    [anon_sym_DOLLARfor] = ACTIONS(4831),
    [anon_sym_for] = ACTIONS(4831),
    [anon_sym_POUND] = ACTIONS(4831),
    [anon_sym_asm] = ACTIONS(4831),
    [anon_sym_AT_LBRACK] = ACTIONS(4831),
  },
  [1887] = {
    [sym_line_comment] = STATE(1887),
    [sym_block_comment] = STATE(1887),
    [ts_builtin_sym_end] = ACTIONS(4833),
    [sym_identifier] = ACTIONS(4835),
    [anon_sym_LF] = ACTIONS(4835),
    [anon_sym_CR] = ACTIONS(4835),
    [anon_sym_CR_LF] = ACTIONS(4835),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4835),
    [anon_sym_LBRACE] = ACTIONS(4835),
    [anon_sym_const] = ACTIONS(4835),
    [anon_sym_LPAREN] = ACTIONS(4835),
    [anon_sym___global] = ACTIONS(4835),
    [anon_sym_type] = ACTIONS(4835),
    [anon_sym_fn] = ACTIONS(4835),
    [anon_sym_PLUS] = ACTIONS(4835),
    [anon_sym_DASH] = ACTIONS(4835),
    [anon_sym_STAR] = ACTIONS(4835),
    [anon_sym_struct] = ACTIONS(4835),
    [anon_sym_union] = ACTIONS(4835),
    [anon_sym_pub] = ACTIONS(4835),
    [anon_sym_mut] = ACTIONS(4835),
    [anon_sym_enum] = ACTIONS(4835),
    [anon_sym_interface] = ACTIONS(4835),
    [anon_sym_QMARK] = ACTIONS(4835),
    [anon_sym_BANG] = ACTIONS(4835),
    [anon_sym_go] = ACTIONS(4835),
    [anon_sym_spawn] = ACTIONS(4835),
    [anon_sym_json_DOTdecode] = ACTIONS(4835),
    [anon_sym_LBRACK2] = ACTIONS(4835),
    [anon_sym_TILDE] = ACTIONS(4835),
    [anon_sym_CARET] = ACTIONS(4835),
    [anon_sym_AMP] = ACTIONS(4835),
    [anon_sym_LT_DASH] = ACTIONS(4835),
    [sym_none] = ACTIONS(4835),
    [sym_true] = ACTIONS(4835),
    [sym_false] = ACTIONS(4835),
    [sym_nil] = ACTIONS(4835),
    [anon_sym_if] = ACTIONS(4835),
    [anon_sym_DOLLARif] = ACTIONS(4835),
    [anon_sym_match] = ACTIONS(4835),
    [anon_sym_select] = ACTIONS(4835),
    [anon_sym_lock] = ACTIONS(4835),
    [anon_sym_rlock] = ACTIONS(4835),
    [anon_sym_unsafe] = ACTIONS(4835),
    [anon_sym_sql] = ACTIONS(4835),
    [sym_int_literal] = ACTIONS(4835),
    [sym_float_literal] = ACTIONS(4835),
    [sym_rune_literal] = ACTIONS(4835),
    [anon_sym_SQUOTE] = ACTIONS(4835),
    [anon_sym_DQUOTE] = ACTIONS(4835),
    [anon_sym_c_SQUOTE] = ACTIONS(4835),
    [anon_sym_c_DQUOTE] = ACTIONS(4835),
    [anon_sym_r_SQUOTE] = ACTIONS(4835),
    [anon_sym_r_DQUOTE] = ACTIONS(4835),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4835),
    [anon_sym_shared] = ACTIONS(4835),
    [anon_sym_map_LBRACK] = ACTIONS(4835),
    [anon_sym_chan] = ACTIONS(4835),
    [anon_sym_thread] = ACTIONS(4835),
    [anon_sym_atomic] = ACTIONS(4835),
    [anon_sym_assert] = ACTIONS(4835),
    [anon_sym_defer] = ACTIONS(4835),
    [anon_sym_goto] = ACTIONS(4835),
    [anon_sym_break] = ACTIONS(4835),
    [anon_sym_continue] = ACTIONS(4835),
    [anon_sym_return] = ACTIONS(4835),
    [anon_sym_DOLLARfor] = ACTIONS(4835),
    [anon_sym_for] = ACTIONS(4835),
    [anon_sym_POUND] = ACTIONS(4835),
    [anon_sym_asm] = ACTIONS(4835),
    [anon_sym_AT_LBRACK] = ACTIONS(4835),
  },
  [1888] = {
    [sym_line_comment] = STATE(1888),
    [sym_block_comment] = STATE(1888),
    [ts_builtin_sym_end] = ACTIONS(4837),
    [sym_identifier] = ACTIONS(4839),
    [anon_sym_LF] = ACTIONS(4839),
    [anon_sym_CR] = ACTIONS(4839),
    [anon_sym_CR_LF] = ACTIONS(4839),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4839),
    [anon_sym_LBRACE] = ACTIONS(4839),
    [anon_sym_const] = ACTIONS(4839),
    [anon_sym_LPAREN] = ACTIONS(4839),
    [anon_sym___global] = ACTIONS(4839),
    [anon_sym_type] = ACTIONS(4839),
    [anon_sym_fn] = ACTIONS(4839),
    [anon_sym_PLUS] = ACTIONS(4839),
    [anon_sym_DASH] = ACTIONS(4839),
    [anon_sym_STAR] = ACTIONS(4839),
    [anon_sym_struct] = ACTIONS(4839),
    [anon_sym_union] = ACTIONS(4839),
    [anon_sym_pub] = ACTIONS(4839),
    [anon_sym_mut] = ACTIONS(4839),
    [anon_sym_enum] = ACTIONS(4839),
    [anon_sym_interface] = ACTIONS(4839),
    [anon_sym_QMARK] = ACTIONS(4839),
    [anon_sym_BANG] = ACTIONS(4839),
    [anon_sym_go] = ACTIONS(4839),
    [anon_sym_spawn] = ACTIONS(4839),
    [anon_sym_json_DOTdecode] = ACTIONS(4839),
    [anon_sym_LBRACK2] = ACTIONS(4839),
    [anon_sym_TILDE] = ACTIONS(4839),
    [anon_sym_CARET] = ACTIONS(4839),
    [anon_sym_AMP] = ACTIONS(4839),
    [anon_sym_LT_DASH] = ACTIONS(4839),
    [sym_none] = ACTIONS(4839),
    [sym_true] = ACTIONS(4839),
    [sym_false] = ACTIONS(4839),
    [sym_nil] = ACTIONS(4839),
    [anon_sym_if] = ACTIONS(4839),
    [anon_sym_DOLLARif] = ACTIONS(4839),
    [anon_sym_match] = ACTIONS(4839),
    [anon_sym_select] = ACTIONS(4839),
    [anon_sym_lock] = ACTIONS(4839),
    [anon_sym_rlock] = ACTIONS(4839),
    [anon_sym_unsafe] = ACTIONS(4839),
    [anon_sym_sql] = ACTIONS(4839),
    [sym_int_literal] = ACTIONS(4839),
    [sym_float_literal] = ACTIONS(4839),
    [sym_rune_literal] = ACTIONS(4839),
    [anon_sym_SQUOTE] = ACTIONS(4839),
    [anon_sym_DQUOTE] = ACTIONS(4839),
    [anon_sym_c_SQUOTE] = ACTIONS(4839),
    [anon_sym_c_DQUOTE] = ACTIONS(4839),
    [anon_sym_r_SQUOTE] = ACTIONS(4839),
    [anon_sym_r_DQUOTE] = ACTIONS(4839),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4839),
    [anon_sym_shared] = ACTIONS(4839),
    [anon_sym_map_LBRACK] = ACTIONS(4839),
    [anon_sym_chan] = ACTIONS(4839),
    [anon_sym_thread] = ACTIONS(4839),
    [anon_sym_atomic] = ACTIONS(4839),
    [anon_sym_assert] = ACTIONS(4839),
    [anon_sym_defer] = ACTIONS(4839),
    [anon_sym_goto] = ACTIONS(4839),
    [anon_sym_break] = ACTIONS(4839),
    [anon_sym_continue] = ACTIONS(4839),
    [anon_sym_return] = ACTIONS(4839),
    [anon_sym_DOLLARfor] = ACTIONS(4839),
    [anon_sym_for] = ACTIONS(4839),
    [anon_sym_POUND] = ACTIONS(4839),
    [anon_sym_asm] = ACTIONS(4839),
    [anon_sym_AT_LBRACK] = ACTIONS(4839),
  },
  [1889] = {
    [sym_line_comment] = STATE(1889),
    [sym_block_comment] = STATE(1889),
    [ts_builtin_sym_end] = ACTIONS(4841),
    [sym_identifier] = ACTIONS(4843),
    [anon_sym_LF] = ACTIONS(4843),
    [anon_sym_CR] = ACTIONS(4843),
    [anon_sym_CR_LF] = ACTIONS(4843),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(4843),
    [anon_sym_const] = ACTIONS(4843),
    [anon_sym_LPAREN] = ACTIONS(4843),
    [anon_sym___global] = ACTIONS(4843),
    [anon_sym_type] = ACTIONS(4843),
    [anon_sym_fn] = ACTIONS(4843),
    [anon_sym_PLUS] = ACTIONS(4843),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4843),
    [anon_sym_struct] = ACTIONS(4843),
    [anon_sym_union] = ACTIONS(4843),
    [anon_sym_pub] = ACTIONS(4843),
    [anon_sym_mut] = ACTIONS(4843),
    [anon_sym_enum] = ACTIONS(4843),
    [anon_sym_interface] = ACTIONS(4843),
    [anon_sym_QMARK] = ACTIONS(4843),
    [anon_sym_BANG] = ACTIONS(4843),
    [anon_sym_go] = ACTIONS(4843),
    [anon_sym_spawn] = ACTIONS(4843),
    [anon_sym_json_DOTdecode] = ACTIONS(4843),
    [anon_sym_LBRACK2] = ACTIONS(4843),
    [anon_sym_TILDE] = ACTIONS(4843),
    [anon_sym_CARET] = ACTIONS(4843),
    [anon_sym_AMP] = ACTIONS(4843),
    [anon_sym_LT_DASH] = ACTIONS(4843),
    [sym_none] = ACTIONS(4843),
    [sym_true] = ACTIONS(4843),
    [sym_false] = ACTIONS(4843),
    [sym_nil] = ACTIONS(4843),
    [anon_sym_if] = ACTIONS(4843),
    [anon_sym_DOLLARif] = ACTIONS(4843),
    [anon_sym_match] = ACTIONS(4843),
    [anon_sym_select] = ACTIONS(4843),
    [anon_sym_lock] = ACTIONS(4843),
    [anon_sym_rlock] = ACTIONS(4843),
    [anon_sym_unsafe] = ACTIONS(4843),
    [anon_sym_sql] = ACTIONS(4843),
    [sym_int_literal] = ACTIONS(4843),
    [sym_float_literal] = ACTIONS(4843),
    [sym_rune_literal] = ACTIONS(4843),
    [anon_sym_SQUOTE] = ACTIONS(4843),
    [anon_sym_DQUOTE] = ACTIONS(4843),
    [anon_sym_c_SQUOTE] = ACTIONS(4843),
    [anon_sym_c_DQUOTE] = ACTIONS(4843),
    [anon_sym_r_SQUOTE] = ACTIONS(4843),
    [anon_sym_r_DQUOTE] = ACTIONS(4843),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4843),
    [anon_sym_shared] = ACTIONS(4843),
    [anon_sym_map_LBRACK] = ACTIONS(4843),
    [anon_sym_chan] = ACTIONS(4843),
    [anon_sym_thread] = ACTIONS(4843),
    [anon_sym_atomic] = ACTIONS(4843),
    [anon_sym_assert] = ACTIONS(4843),
    [anon_sym_defer] = ACTIONS(4843),
    [anon_sym_goto] = ACTIONS(4843),
    [anon_sym_break] = ACTIONS(4843),
    [anon_sym_continue] = ACTIONS(4843),
    [anon_sym_return] = ACTIONS(4843),
    [anon_sym_DOLLARfor] = ACTIONS(4843),
    [anon_sym_for] = ACTIONS(4843),
    [anon_sym_POUND] = ACTIONS(4843),
    [anon_sym_asm] = ACTIONS(4843),
    [anon_sym_AT_LBRACK] = ACTIONS(4843),
  },
  [1890] = {
    [sym_line_comment] = STATE(1890),
    [sym_block_comment] = STATE(1890),
    [ts_builtin_sym_end] = ACTIONS(4845),
    [sym_identifier] = ACTIONS(4847),
    [anon_sym_LF] = ACTIONS(4847),
    [anon_sym_CR] = ACTIONS(4847),
    [anon_sym_CR_LF] = ACTIONS(4847),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4847),
    [anon_sym_LBRACE] = ACTIONS(4847),
    [anon_sym_const] = ACTIONS(4847),
    [anon_sym_LPAREN] = ACTIONS(4847),
    [anon_sym___global] = ACTIONS(4847),
    [anon_sym_type] = ACTIONS(4847),
    [anon_sym_fn] = ACTIONS(4847),
    [anon_sym_PLUS] = ACTIONS(4847),
    [anon_sym_DASH] = ACTIONS(4847),
    [anon_sym_STAR] = ACTIONS(4847),
    [anon_sym_struct] = ACTIONS(4847),
    [anon_sym_union] = ACTIONS(4847),
    [anon_sym_pub] = ACTIONS(4847),
    [anon_sym_mut] = ACTIONS(4847),
    [anon_sym_enum] = ACTIONS(4847),
    [anon_sym_interface] = ACTIONS(4847),
    [anon_sym_QMARK] = ACTIONS(4847),
    [anon_sym_BANG] = ACTIONS(4847),
    [anon_sym_go] = ACTIONS(4847),
    [anon_sym_spawn] = ACTIONS(4847),
    [anon_sym_json_DOTdecode] = ACTIONS(4847),
    [anon_sym_LBRACK2] = ACTIONS(4847),
    [anon_sym_TILDE] = ACTIONS(4847),
    [anon_sym_CARET] = ACTIONS(4847),
    [anon_sym_AMP] = ACTIONS(4847),
    [anon_sym_LT_DASH] = ACTIONS(4847),
    [sym_none] = ACTIONS(4847),
    [sym_true] = ACTIONS(4847),
    [sym_false] = ACTIONS(4847),
    [sym_nil] = ACTIONS(4847),
    [anon_sym_if] = ACTIONS(4847),
    [anon_sym_DOLLARif] = ACTIONS(4847),
    [anon_sym_match] = ACTIONS(4847),
    [anon_sym_select] = ACTIONS(4847),
    [anon_sym_lock] = ACTIONS(4847),
    [anon_sym_rlock] = ACTIONS(4847),
    [anon_sym_unsafe] = ACTIONS(4847),
    [anon_sym_sql] = ACTIONS(4847),
    [sym_int_literal] = ACTIONS(4847),
    [sym_float_literal] = ACTIONS(4847),
    [sym_rune_literal] = ACTIONS(4847),
    [anon_sym_SQUOTE] = ACTIONS(4847),
    [anon_sym_DQUOTE] = ACTIONS(4847),
    [anon_sym_c_SQUOTE] = ACTIONS(4847),
    [anon_sym_c_DQUOTE] = ACTIONS(4847),
    [anon_sym_r_SQUOTE] = ACTIONS(4847),
    [anon_sym_r_DQUOTE] = ACTIONS(4847),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4847),
    [anon_sym_shared] = ACTIONS(4847),
    [anon_sym_map_LBRACK] = ACTIONS(4847),
    [anon_sym_chan] = ACTIONS(4847),
    [anon_sym_thread] = ACTIONS(4847),
    [anon_sym_atomic] = ACTIONS(4847),
    [anon_sym_assert] = ACTIONS(4847),
    [anon_sym_defer] = ACTIONS(4847),
    [anon_sym_goto] = ACTIONS(4847),
    [anon_sym_break] = ACTIONS(4847),
    [anon_sym_continue] = ACTIONS(4847),
    [anon_sym_return] = ACTIONS(4847),
    [anon_sym_DOLLARfor] = ACTIONS(4847),
    [anon_sym_for] = ACTIONS(4847),
    [anon_sym_POUND] = ACTIONS(4847),
    [anon_sym_asm] = ACTIONS(4847),
    [anon_sym_AT_LBRACK] = ACTIONS(4847),
  },
  [1891] = {
    [sym_line_comment] = STATE(1891),
    [sym_block_comment] = STATE(1891),
    [ts_builtin_sym_end] = ACTIONS(3306),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_LF] = ACTIONS(3308),
    [anon_sym_CR] = ACTIONS(3308),
    [anon_sym_CR_LF] = ACTIONS(3308),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3308),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym___global] = ACTIONS(3308),
    [anon_sym_type] = ACTIONS(3308),
    [anon_sym_fn] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_struct] = ACTIONS(3308),
    [anon_sym_union] = ACTIONS(3308),
    [anon_sym_pub] = ACTIONS(3308),
    [anon_sym_mut] = ACTIONS(3308),
    [anon_sym_enum] = ACTIONS(3308),
    [anon_sym_interface] = ACTIONS(3308),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_BANG] = ACTIONS(3308),
    [anon_sym_go] = ACTIONS(3308),
    [anon_sym_spawn] = ACTIONS(3308),
    [anon_sym_json_DOTdecode] = ACTIONS(3308),
    [anon_sym_LBRACK2] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3308),
    [anon_sym_CARET] = ACTIONS(3308),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LT_DASH] = ACTIONS(3308),
    [sym_none] = ACTIONS(3308),
    [sym_true] = ACTIONS(3308),
    [sym_false] = ACTIONS(3308),
    [sym_nil] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_DOLLARif] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_select] = ACTIONS(3308),
    [anon_sym_lock] = ACTIONS(3308),
    [anon_sym_rlock] = ACTIONS(3308),
    [anon_sym_unsafe] = ACTIONS(3308),
    [anon_sym_sql] = ACTIONS(3308),
    [sym_int_literal] = ACTIONS(3308),
    [sym_float_literal] = ACTIONS(3308),
    [sym_rune_literal] = ACTIONS(3308),
    [anon_sym_SQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_c_SQUOTE] = ACTIONS(3308),
    [anon_sym_c_DQUOTE] = ACTIONS(3308),
    [anon_sym_r_SQUOTE] = ACTIONS(3308),
    [anon_sym_r_DQUOTE] = ACTIONS(3308),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3308),
    [anon_sym_shared] = ACTIONS(3308),
    [anon_sym_map_LBRACK] = ACTIONS(3308),
    [anon_sym_chan] = ACTIONS(3308),
    [anon_sym_thread] = ACTIONS(3308),
    [anon_sym_atomic] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_defer] = ACTIONS(3308),
    [anon_sym_goto] = ACTIONS(3308),
    [anon_sym_break] = ACTIONS(3308),
    [anon_sym_continue] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_DOLLARfor] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_POUND] = ACTIONS(3308),
    [anon_sym_asm] = ACTIONS(3308),
    [anon_sym_AT_LBRACK] = ACTIONS(3308),
  },
  [1892] = {
    [sym_line_comment] = STATE(1892),
    [sym_block_comment] = STATE(1892),
    [ts_builtin_sym_end] = ACTIONS(4849),
    [sym_identifier] = ACTIONS(4851),
    [anon_sym_LF] = ACTIONS(4851),
    [anon_sym_CR] = ACTIONS(4851),
    [anon_sym_CR_LF] = ACTIONS(4851),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4851),
    [anon_sym_LBRACE] = ACTIONS(4851),
    [anon_sym_const] = ACTIONS(4851),
    [anon_sym_LPAREN] = ACTIONS(4851),
    [anon_sym___global] = ACTIONS(4851),
    [anon_sym_type] = ACTIONS(4851),
    [anon_sym_fn] = ACTIONS(4851),
    [anon_sym_PLUS] = ACTIONS(4851),
    [anon_sym_DASH] = ACTIONS(4851),
    [anon_sym_STAR] = ACTIONS(4851),
    [anon_sym_struct] = ACTIONS(4851),
    [anon_sym_union] = ACTIONS(4851),
    [anon_sym_pub] = ACTIONS(4851),
    [anon_sym_mut] = ACTIONS(4851),
    [anon_sym_enum] = ACTIONS(4851),
    [anon_sym_interface] = ACTIONS(4851),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_BANG] = ACTIONS(4851),
    [anon_sym_go] = ACTIONS(4851),
    [anon_sym_spawn] = ACTIONS(4851),
    [anon_sym_json_DOTdecode] = ACTIONS(4851),
    [anon_sym_LBRACK2] = ACTIONS(4851),
    [anon_sym_TILDE] = ACTIONS(4851),
    [anon_sym_CARET] = ACTIONS(4851),
    [anon_sym_AMP] = ACTIONS(4851),
    [anon_sym_LT_DASH] = ACTIONS(4851),
    [sym_none] = ACTIONS(4851),
    [sym_true] = ACTIONS(4851),
    [sym_false] = ACTIONS(4851),
    [sym_nil] = ACTIONS(4851),
    [anon_sym_if] = ACTIONS(4851),
    [anon_sym_DOLLARif] = ACTIONS(4851),
    [anon_sym_match] = ACTIONS(4851),
    [anon_sym_select] = ACTIONS(4851),
    [anon_sym_lock] = ACTIONS(4851),
    [anon_sym_rlock] = ACTIONS(4851),
    [anon_sym_unsafe] = ACTIONS(4851),
    [anon_sym_sql] = ACTIONS(4851),
    [sym_int_literal] = ACTIONS(4851),
    [sym_float_literal] = ACTIONS(4851),
    [sym_rune_literal] = ACTIONS(4851),
    [anon_sym_SQUOTE] = ACTIONS(4851),
    [anon_sym_DQUOTE] = ACTIONS(4851),
    [anon_sym_c_SQUOTE] = ACTIONS(4851),
    [anon_sym_c_DQUOTE] = ACTIONS(4851),
    [anon_sym_r_SQUOTE] = ACTIONS(4851),
    [anon_sym_r_DQUOTE] = ACTIONS(4851),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4851),
    [anon_sym_shared] = ACTIONS(4851),
    [anon_sym_map_LBRACK] = ACTIONS(4851),
    [anon_sym_chan] = ACTIONS(4851),
    [anon_sym_thread] = ACTIONS(4851),
    [anon_sym_atomic] = ACTIONS(4851),
    [anon_sym_assert] = ACTIONS(4851),
    [anon_sym_defer] = ACTIONS(4851),
    [anon_sym_goto] = ACTIONS(4851),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_continue] = ACTIONS(4851),
    [anon_sym_return] = ACTIONS(4851),
    [anon_sym_DOLLARfor] = ACTIONS(4851),
    [anon_sym_for] = ACTIONS(4851),
    [anon_sym_POUND] = ACTIONS(4851),
    [anon_sym_asm] = ACTIONS(4851),
    [anon_sym_AT_LBRACK] = ACTIONS(4851),
  },
  [1893] = {
    [sym_line_comment] = STATE(1893),
    [sym_block_comment] = STATE(1893),
    [ts_builtin_sym_end] = ACTIONS(4853),
    [sym_identifier] = ACTIONS(4855),
    [anon_sym_LF] = ACTIONS(4855),
    [anon_sym_CR] = ACTIONS(4855),
    [anon_sym_CR_LF] = ACTIONS(4855),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4855),
    [anon_sym_LBRACE] = ACTIONS(4855),
    [anon_sym_const] = ACTIONS(4855),
    [anon_sym_LPAREN] = ACTIONS(4855),
    [anon_sym___global] = ACTIONS(4855),
    [anon_sym_type] = ACTIONS(4855),
    [anon_sym_fn] = ACTIONS(4855),
    [anon_sym_PLUS] = ACTIONS(4855),
    [anon_sym_DASH] = ACTIONS(4855),
    [anon_sym_STAR] = ACTIONS(4855),
    [anon_sym_struct] = ACTIONS(4855),
    [anon_sym_union] = ACTIONS(4855),
    [anon_sym_pub] = ACTIONS(4855),
    [anon_sym_mut] = ACTIONS(4855),
    [anon_sym_enum] = ACTIONS(4855),
    [anon_sym_interface] = ACTIONS(4855),
    [anon_sym_QMARK] = ACTIONS(4855),
    [anon_sym_BANG] = ACTIONS(4855),
    [anon_sym_go] = ACTIONS(4855),
    [anon_sym_spawn] = ACTIONS(4855),
    [anon_sym_json_DOTdecode] = ACTIONS(4855),
    [anon_sym_LBRACK2] = ACTIONS(4855),
    [anon_sym_TILDE] = ACTIONS(4855),
    [anon_sym_CARET] = ACTIONS(4855),
    [anon_sym_AMP] = ACTIONS(4855),
    [anon_sym_LT_DASH] = ACTIONS(4855),
    [sym_none] = ACTIONS(4855),
    [sym_true] = ACTIONS(4855),
    [sym_false] = ACTIONS(4855),
    [sym_nil] = ACTIONS(4855),
    [anon_sym_if] = ACTIONS(4855),
    [anon_sym_DOLLARif] = ACTIONS(4855),
    [anon_sym_match] = ACTIONS(4855),
    [anon_sym_select] = ACTIONS(4855),
    [anon_sym_lock] = ACTIONS(4855),
    [anon_sym_rlock] = ACTIONS(4855),
    [anon_sym_unsafe] = ACTIONS(4855),
    [anon_sym_sql] = ACTIONS(4855),
    [sym_int_literal] = ACTIONS(4855),
    [sym_float_literal] = ACTIONS(4855),
    [sym_rune_literal] = ACTIONS(4855),
    [anon_sym_SQUOTE] = ACTIONS(4855),
    [anon_sym_DQUOTE] = ACTIONS(4855),
    [anon_sym_c_SQUOTE] = ACTIONS(4855),
    [anon_sym_c_DQUOTE] = ACTIONS(4855),
    [anon_sym_r_SQUOTE] = ACTIONS(4855),
    [anon_sym_r_DQUOTE] = ACTIONS(4855),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4855),
    [anon_sym_shared] = ACTIONS(4855),
    [anon_sym_map_LBRACK] = ACTIONS(4855),
    [anon_sym_chan] = ACTIONS(4855),
    [anon_sym_thread] = ACTIONS(4855),
    [anon_sym_atomic] = ACTIONS(4855),
    [anon_sym_assert] = ACTIONS(4855),
    [anon_sym_defer] = ACTIONS(4855),
    [anon_sym_goto] = ACTIONS(4855),
    [anon_sym_break] = ACTIONS(4855),
    [anon_sym_continue] = ACTIONS(4855),
    [anon_sym_return] = ACTIONS(4855),
    [anon_sym_DOLLARfor] = ACTIONS(4855),
    [anon_sym_for] = ACTIONS(4855),
    [anon_sym_POUND] = ACTIONS(4855),
    [anon_sym_asm] = ACTIONS(4855),
    [anon_sym_AT_LBRACK] = ACTIONS(4855),
  },
  [1894] = {
    [sym_line_comment] = STATE(1894),
    [sym_block_comment] = STATE(1894),
    [ts_builtin_sym_end] = ACTIONS(4857),
    [sym_identifier] = ACTIONS(4859),
    [anon_sym_LF] = ACTIONS(4859),
    [anon_sym_CR] = ACTIONS(4859),
    [anon_sym_CR_LF] = ACTIONS(4859),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4859),
    [anon_sym_LBRACE] = ACTIONS(4859),
    [anon_sym_const] = ACTIONS(4859),
    [anon_sym_LPAREN] = ACTIONS(4859),
    [anon_sym___global] = ACTIONS(4859),
    [anon_sym_type] = ACTIONS(4859),
    [anon_sym_fn] = ACTIONS(4859),
    [anon_sym_PLUS] = ACTIONS(4859),
    [anon_sym_DASH] = ACTIONS(4859),
    [anon_sym_STAR] = ACTIONS(4859),
    [anon_sym_struct] = ACTIONS(4859),
    [anon_sym_union] = ACTIONS(4859),
    [anon_sym_pub] = ACTIONS(4859),
    [anon_sym_mut] = ACTIONS(4859),
    [anon_sym_enum] = ACTIONS(4859),
    [anon_sym_interface] = ACTIONS(4859),
    [anon_sym_QMARK] = ACTIONS(4859),
    [anon_sym_BANG] = ACTIONS(4859),
    [anon_sym_go] = ACTIONS(4859),
    [anon_sym_spawn] = ACTIONS(4859),
    [anon_sym_json_DOTdecode] = ACTIONS(4859),
    [anon_sym_LBRACK2] = ACTIONS(4859),
    [anon_sym_TILDE] = ACTIONS(4859),
    [anon_sym_CARET] = ACTIONS(4859),
    [anon_sym_AMP] = ACTIONS(4859),
    [anon_sym_LT_DASH] = ACTIONS(4859),
    [sym_none] = ACTIONS(4859),
    [sym_true] = ACTIONS(4859),
    [sym_false] = ACTIONS(4859),
    [sym_nil] = ACTIONS(4859),
    [anon_sym_if] = ACTIONS(4859),
    [anon_sym_DOLLARif] = ACTIONS(4859),
    [anon_sym_match] = ACTIONS(4859),
    [anon_sym_select] = ACTIONS(4859),
    [anon_sym_lock] = ACTIONS(4859),
    [anon_sym_rlock] = ACTIONS(4859),
    [anon_sym_unsafe] = ACTIONS(4859),
    [anon_sym_sql] = ACTIONS(4859),
    [sym_int_literal] = ACTIONS(4859),
    [sym_float_literal] = ACTIONS(4859),
    [sym_rune_literal] = ACTIONS(4859),
    [anon_sym_SQUOTE] = ACTIONS(4859),
    [anon_sym_DQUOTE] = ACTIONS(4859),
    [anon_sym_c_SQUOTE] = ACTIONS(4859),
    [anon_sym_c_DQUOTE] = ACTIONS(4859),
    [anon_sym_r_SQUOTE] = ACTIONS(4859),
    [anon_sym_r_DQUOTE] = ACTIONS(4859),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4859),
    [anon_sym_shared] = ACTIONS(4859),
    [anon_sym_map_LBRACK] = ACTIONS(4859),
    [anon_sym_chan] = ACTIONS(4859),
    [anon_sym_thread] = ACTIONS(4859),
    [anon_sym_atomic] = ACTIONS(4859),
    [anon_sym_assert] = ACTIONS(4859),
    [anon_sym_defer] = ACTIONS(4859),
    [anon_sym_goto] = ACTIONS(4859),
    [anon_sym_break] = ACTIONS(4859),
    [anon_sym_continue] = ACTIONS(4859),
    [anon_sym_return] = ACTIONS(4859),
    [anon_sym_DOLLARfor] = ACTIONS(4859),
    [anon_sym_for] = ACTIONS(4859),
    [anon_sym_POUND] = ACTIONS(4859),
    [anon_sym_asm] = ACTIONS(4859),
    [anon_sym_AT_LBRACK] = ACTIONS(4859),
  },
  [1895] = {
    [sym_line_comment] = STATE(1895),
    [sym_block_comment] = STATE(1895),
    [ts_builtin_sym_end] = ACTIONS(4861),
    [sym_identifier] = ACTIONS(4863),
    [anon_sym_LF] = ACTIONS(4863),
    [anon_sym_CR] = ACTIONS(4863),
    [anon_sym_CR_LF] = ACTIONS(4863),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4863),
    [anon_sym_LBRACE] = ACTIONS(4863),
    [anon_sym_const] = ACTIONS(4863),
    [anon_sym_LPAREN] = ACTIONS(4863),
    [anon_sym___global] = ACTIONS(4863),
    [anon_sym_type] = ACTIONS(4863),
    [anon_sym_fn] = ACTIONS(4863),
    [anon_sym_PLUS] = ACTIONS(4863),
    [anon_sym_DASH] = ACTIONS(4863),
    [anon_sym_STAR] = ACTIONS(4863),
    [anon_sym_struct] = ACTIONS(4863),
    [anon_sym_union] = ACTIONS(4863),
    [anon_sym_pub] = ACTIONS(4863),
    [anon_sym_mut] = ACTIONS(4863),
    [anon_sym_enum] = ACTIONS(4863),
    [anon_sym_interface] = ACTIONS(4863),
    [anon_sym_QMARK] = ACTIONS(4863),
    [anon_sym_BANG] = ACTIONS(4863),
    [anon_sym_go] = ACTIONS(4863),
    [anon_sym_spawn] = ACTIONS(4863),
    [anon_sym_json_DOTdecode] = ACTIONS(4863),
    [anon_sym_LBRACK2] = ACTIONS(4863),
    [anon_sym_TILDE] = ACTIONS(4863),
    [anon_sym_CARET] = ACTIONS(4863),
    [anon_sym_AMP] = ACTIONS(4863),
    [anon_sym_LT_DASH] = ACTIONS(4863),
    [sym_none] = ACTIONS(4863),
    [sym_true] = ACTIONS(4863),
    [sym_false] = ACTIONS(4863),
    [sym_nil] = ACTIONS(4863),
    [anon_sym_if] = ACTIONS(4863),
    [anon_sym_DOLLARif] = ACTIONS(4863),
    [anon_sym_match] = ACTIONS(4863),
    [anon_sym_select] = ACTIONS(4863),
    [anon_sym_lock] = ACTIONS(4863),
    [anon_sym_rlock] = ACTIONS(4863),
    [anon_sym_unsafe] = ACTIONS(4863),
    [anon_sym_sql] = ACTIONS(4863),
    [sym_int_literal] = ACTIONS(4863),
    [sym_float_literal] = ACTIONS(4863),
    [sym_rune_literal] = ACTIONS(4863),
    [anon_sym_SQUOTE] = ACTIONS(4863),
    [anon_sym_DQUOTE] = ACTIONS(4863),
    [anon_sym_c_SQUOTE] = ACTIONS(4863),
    [anon_sym_c_DQUOTE] = ACTIONS(4863),
    [anon_sym_r_SQUOTE] = ACTIONS(4863),
    [anon_sym_r_DQUOTE] = ACTIONS(4863),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4863),
    [anon_sym_shared] = ACTIONS(4863),
    [anon_sym_map_LBRACK] = ACTIONS(4863),
    [anon_sym_chan] = ACTIONS(4863),
    [anon_sym_thread] = ACTIONS(4863),
    [anon_sym_atomic] = ACTIONS(4863),
    [anon_sym_assert] = ACTIONS(4863),
    [anon_sym_defer] = ACTIONS(4863),
    [anon_sym_goto] = ACTIONS(4863),
    [anon_sym_break] = ACTIONS(4863),
    [anon_sym_continue] = ACTIONS(4863),
    [anon_sym_return] = ACTIONS(4863),
    [anon_sym_DOLLARfor] = ACTIONS(4863),
    [anon_sym_for] = ACTIONS(4863),
    [anon_sym_POUND] = ACTIONS(4863),
    [anon_sym_asm] = ACTIONS(4863),
    [anon_sym_AT_LBRACK] = ACTIONS(4863),
  },
  [1896] = {
    [sym_line_comment] = STATE(1896),
    [sym_block_comment] = STATE(1896),
    [ts_builtin_sym_end] = ACTIONS(4865),
    [sym_identifier] = ACTIONS(4867),
    [anon_sym_LF] = ACTIONS(4867),
    [anon_sym_CR] = ACTIONS(4867),
    [anon_sym_CR_LF] = ACTIONS(4867),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4867),
    [anon_sym_LBRACE] = ACTIONS(4867),
    [anon_sym_const] = ACTIONS(4867),
    [anon_sym_LPAREN] = ACTIONS(4867),
    [anon_sym___global] = ACTIONS(4867),
    [anon_sym_type] = ACTIONS(4867),
    [anon_sym_fn] = ACTIONS(4867),
    [anon_sym_PLUS] = ACTIONS(4867),
    [anon_sym_DASH] = ACTIONS(4867),
    [anon_sym_STAR] = ACTIONS(4867),
    [anon_sym_struct] = ACTIONS(4867),
    [anon_sym_union] = ACTIONS(4867),
    [anon_sym_pub] = ACTIONS(4867),
    [anon_sym_mut] = ACTIONS(4867),
    [anon_sym_enum] = ACTIONS(4867),
    [anon_sym_interface] = ACTIONS(4867),
    [anon_sym_QMARK] = ACTIONS(4867),
    [anon_sym_BANG] = ACTIONS(4867),
    [anon_sym_go] = ACTIONS(4867),
    [anon_sym_spawn] = ACTIONS(4867),
    [anon_sym_json_DOTdecode] = ACTIONS(4867),
    [anon_sym_LBRACK2] = ACTIONS(4867),
    [anon_sym_TILDE] = ACTIONS(4867),
    [anon_sym_CARET] = ACTIONS(4867),
    [anon_sym_AMP] = ACTIONS(4867),
    [anon_sym_LT_DASH] = ACTIONS(4867),
    [sym_none] = ACTIONS(4867),
    [sym_true] = ACTIONS(4867),
    [sym_false] = ACTIONS(4867),
    [sym_nil] = ACTIONS(4867),
    [anon_sym_if] = ACTIONS(4867),
    [anon_sym_DOLLARif] = ACTIONS(4867),
    [anon_sym_match] = ACTIONS(4867),
    [anon_sym_select] = ACTIONS(4867),
    [anon_sym_lock] = ACTIONS(4867),
    [anon_sym_rlock] = ACTIONS(4867),
    [anon_sym_unsafe] = ACTIONS(4867),
    [anon_sym_sql] = ACTIONS(4867),
    [sym_int_literal] = ACTIONS(4867),
    [sym_float_literal] = ACTIONS(4867),
    [sym_rune_literal] = ACTIONS(4867),
    [anon_sym_SQUOTE] = ACTIONS(4867),
    [anon_sym_DQUOTE] = ACTIONS(4867),
    [anon_sym_c_SQUOTE] = ACTIONS(4867),
    [anon_sym_c_DQUOTE] = ACTIONS(4867),
    [anon_sym_r_SQUOTE] = ACTIONS(4867),
    [anon_sym_r_DQUOTE] = ACTIONS(4867),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4867),
    [anon_sym_shared] = ACTIONS(4867),
    [anon_sym_map_LBRACK] = ACTIONS(4867),
    [anon_sym_chan] = ACTIONS(4867),
    [anon_sym_thread] = ACTIONS(4867),
    [anon_sym_atomic] = ACTIONS(4867),
    [anon_sym_assert] = ACTIONS(4867),
    [anon_sym_defer] = ACTIONS(4867),
    [anon_sym_goto] = ACTIONS(4867),
    [anon_sym_break] = ACTIONS(4867),
    [anon_sym_continue] = ACTIONS(4867),
    [anon_sym_return] = ACTIONS(4867),
    [anon_sym_DOLLARfor] = ACTIONS(4867),
    [anon_sym_for] = ACTIONS(4867),
    [anon_sym_POUND] = ACTIONS(4867),
    [anon_sym_asm] = ACTIONS(4867),
    [anon_sym_AT_LBRACK] = ACTIONS(4867),
  },
  [1897] = {
    [sym_line_comment] = STATE(1897),
    [sym_block_comment] = STATE(1897),
    [ts_builtin_sym_end] = ACTIONS(4869),
    [sym_identifier] = ACTIONS(4871),
    [anon_sym_LF] = ACTIONS(4871),
    [anon_sym_CR] = ACTIONS(4871),
    [anon_sym_CR_LF] = ACTIONS(4871),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4871),
    [anon_sym_LBRACE] = ACTIONS(4871),
    [anon_sym_const] = ACTIONS(4871),
    [anon_sym_LPAREN] = ACTIONS(4871),
    [anon_sym___global] = ACTIONS(4871),
    [anon_sym_type] = ACTIONS(4871),
    [anon_sym_fn] = ACTIONS(4871),
    [anon_sym_PLUS] = ACTIONS(4871),
    [anon_sym_DASH] = ACTIONS(4871),
    [anon_sym_STAR] = ACTIONS(4871),
    [anon_sym_struct] = ACTIONS(4871),
    [anon_sym_union] = ACTIONS(4871),
    [anon_sym_pub] = ACTIONS(4871),
    [anon_sym_mut] = ACTIONS(4871),
    [anon_sym_enum] = ACTIONS(4871),
    [anon_sym_interface] = ACTIONS(4871),
    [anon_sym_QMARK] = ACTIONS(4871),
    [anon_sym_BANG] = ACTIONS(4871),
    [anon_sym_go] = ACTIONS(4871),
    [anon_sym_spawn] = ACTIONS(4871),
    [anon_sym_json_DOTdecode] = ACTIONS(4871),
    [anon_sym_LBRACK2] = ACTIONS(4871),
    [anon_sym_TILDE] = ACTIONS(4871),
    [anon_sym_CARET] = ACTIONS(4871),
    [anon_sym_AMP] = ACTIONS(4871),
    [anon_sym_LT_DASH] = ACTIONS(4871),
    [sym_none] = ACTIONS(4871),
    [sym_true] = ACTIONS(4871),
    [sym_false] = ACTIONS(4871),
    [sym_nil] = ACTIONS(4871),
    [anon_sym_if] = ACTIONS(4871),
    [anon_sym_DOLLARif] = ACTIONS(4871),
    [anon_sym_match] = ACTIONS(4871),
    [anon_sym_select] = ACTIONS(4871),
    [anon_sym_lock] = ACTIONS(4871),
    [anon_sym_rlock] = ACTIONS(4871),
    [anon_sym_unsafe] = ACTIONS(4871),
    [anon_sym_sql] = ACTIONS(4871),
    [sym_int_literal] = ACTIONS(4871),
    [sym_float_literal] = ACTIONS(4871),
    [sym_rune_literal] = ACTIONS(4871),
    [anon_sym_SQUOTE] = ACTIONS(4871),
    [anon_sym_DQUOTE] = ACTIONS(4871),
    [anon_sym_c_SQUOTE] = ACTIONS(4871),
    [anon_sym_c_DQUOTE] = ACTIONS(4871),
    [anon_sym_r_SQUOTE] = ACTIONS(4871),
    [anon_sym_r_DQUOTE] = ACTIONS(4871),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4871),
    [anon_sym_shared] = ACTIONS(4871),
    [anon_sym_map_LBRACK] = ACTIONS(4871),
    [anon_sym_chan] = ACTIONS(4871),
    [anon_sym_thread] = ACTIONS(4871),
    [anon_sym_atomic] = ACTIONS(4871),
    [anon_sym_assert] = ACTIONS(4871),
    [anon_sym_defer] = ACTIONS(4871),
    [anon_sym_goto] = ACTIONS(4871),
    [anon_sym_break] = ACTIONS(4871),
    [anon_sym_continue] = ACTIONS(4871),
    [anon_sym_return] = ACTIONS(4871),
    [anon_sym_DOLLARfor] = ACTIONS(4871),
    [anon_sym_for] = ACTIONS(4871),
    [anon_sym_POUND] = ACTIONS(4871),
    [anon_sym_asm] = ACTIONS(4871),
    [anon_sym_AT_LBRACK] = ACTIONS(4871),
  },
  [1898] = {
    [sym_line_comment] = STATE(1898),
    [sym_block_comment] = STATE(1898),
    [ts_builtin_sym_end] = ACTIONS(4873),
    [sym_identifier] = ACTIONS(4875),
    [anon_sym_LF] = ACTIONS(4875),
    [anon_sym_CR] = ACTIONS(4875),
    [anon_sym_CR_LF] = ACTIONS(4875),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4875),
    [anon_sym_LBRACE] = ACTIONS(4875),
    [anon_sym_const] = ACTIONS(4875),
    [anon_sym_LPAREN] = ACTIONS(4875),
    [anon_sym___global] = ACTIONS(4875),
    [anon_sym_type] = ACTIONS(4875),
    [anon_sym_fn] = ACTIONS(4875),
    [anon_sym_PLUS] = ACTIONS(4875),
    [anon_sym_DASH] = ACTIONS(4875),
    [anon_sym_STAR] = ACTIONS(4875),
    [anon_sym_struct] = ACTIONS(4875),
    [anon_sym_union] = ACTIONS(4875),
    [anon_sym_pub] = ACTIONS(4875),
    [anon_sym_mut] = ACTIONS(4875),
    [anon_sym_enum] = ACTIONS(4875),
    [anon_sym_interface] = ACTIONS(4875),
    [anon_sym_QMARK] = ACTIONS(4875),
    [anon_sym_BANG] = ACTIONS(4875),
    [anon_sym_go] = ACTIONS(4875),
    [anon_sym_spawn] = ACTIONS(4875),
    [anon_sym_json_DOTdecode] = ACTIONS(4875),
    [anon_sym_LBRACK2] = ACTIONS(4875),
    [anon_sym_TILDE] = ACTIONS(4875),
    [anon_sym_CARET] = ACTIONS(4875),
    [anon_sym_AMP] = ACTIONS(4875),
    [anon_sym_LT_DASH] = ACTIONS(4875),
    [sym_none] = ACTIONS(4875),
    [sym_true] = ACTIONS(4875),
    [sym_false] = ACTIONS(4875),
    [sym_nil] = ACTIONS(4875),
    [anon_sym_if] = ACTIONS(4875),
    [anon_sym_DOLLARif] = ACTIONS(4875),
    [anon_sym_match] = ACTIONS(4875),
    [anon_sym_select] = ACTIONS(4875),
    [anon_sym_lock] = ACTIONS(4875),
    [anon_sym_rlock] = ACTIONS(4875),
    [anon_sym_unsafe] = ACTIONS(4875),
    [anon_sym_sql] = ACTIONS(4875),
    [sym_int_literal] = ACTIONS(4875),
    [sym_float_literal] = ACTIONS(4875),
    [sym_rune_literal] = ACTIONS(4875),
    [anon_sym_SQUOTE] = ACTIONS(4875),
    [anon_sym_DQUOTE] = ACTIONS(4875),
    [anon_sym_c_SQUOTE] = ACTIONS(4875),
    [anon_sym_c_DQUOTE] = ACTIONS(4875),
    [anon_sym_r_SQUOTE] = ACTIONS(4875),
    [anon_sym_r_DQUOTE] = ACTIONS(4875),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4875),
    [anon_sym_shared] = ACTIONS(4875),
    [anon_sym_map_LBRACK] = ACTIONS(4875),
    [anon_sym_chan] = ACTIONS(4875),
    [anon_sym_thread] = ACTIONS(4875),
    [anon_sym_atomic] = ACTIONS(4875),
    [anon_sym_assert] = ACTIONS(4875),
    [anon_sym_defer] = ACTIONS(4875),
    [anon_sym_goto] = ACTIONS(4875),
    [anon_sym_break] = ACTIONS(4875),
    [anon_sym_continue] = ACTIONS(4875),
    [anon_sym_return] = ACTIONS(4875),
    [anon_sym_DOLLARfor] = ACTIONS(4875),
    [anon_sym_for] = ACTIONS(4875),
    [anon_sym_POUND] = ACTIONS(4875),
    [anon_sym_asm] = ACTIONS(4875),
    [anon_sym_AT_LBRACK] = ACTIONS(4875),
  },
  [1899] = {
    [sym_line_comment] = STATE(1899),
    [sym_block_comment] = STATE(1899),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2458),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(861),
    [anon_sym_DOT] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(865),
    [anon_sym_LPAREN] = ACTIONS(3968),
    [anon_sym_RPAREN] = ACTIONS(861),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_STAR] = ACTIONS(3970),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(861),
    [anon_sym_BANG_EQ] = ACTIONS(861),
    [anon_sym_LT_EQ] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_RBRACK] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_PLUS_PLUS] = ACTIONS(861),
    [anon_sym_DASH_DASH] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(4877),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_LBRACK2] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(865),
    [anon_sym_GT_GT_GT] = ACTIONS(861),
    [anon_sym_AMP_CARET] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_QMARK_DOT] = ACTIONS(861),
    [anon_sym_POUND_LBRACK] = ACTIONS(861),
    [anon_sym_is] = ACTIONS(865),
    [anon_sym_BANGis] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(865),
    [anon_sym_BANGin] = ACTIONS(861),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(861),
  },
  [1900] = {
    [sym_line_comment] = STATE(1900),
    [sym_block_comment] = STATE(1900),
    [ts_builtin_sym_end] = ACTIONS(4879),
    [sym_identifier] = ACTIONS(4881),
    [anon_sym_LF] = ACTIONS(4881),
    [anon_sym_CR] = ACTIONS(4881),
    [anon_sym_CR_LF] = ACTIONS(4881),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(4881),
    [anon_sym_const] = ACTIONS(4881),
    [anon_sym_LPAREN] = ACTIONS(4881),
    [anon_sym___global] = ACTIONS(4881),
    [anon_sym_type] = ACTIONS(4881),
    [anon_sym_fn] = ACTIONS(4881),
    [anon_sym_PLUS] = ACTIONS(4881),
    [anon_sym_DASH] = ACTIONS(4881),
    [anon_sym_STAR] = ACTIONS(4881),
    [anon_sym_struct] = ACTIONS(4881),
    [anon_sym_union] = ACTIONS(4881),
    [anon_sym_pub] = ACTIONS(4881),
    [anon_sym_mut] = ACTIONS(4881),
    [anon_sym_enum] = ACTIONS(4881),
    [anon_sym_interface] = ACTIONS(4881),
    [anon_sym_QMARK] = ACTIONS(4881),
    [anon_sym_BANG] = ACTIONS(4881),
    [anon_sym_go] = ACTIONS(4881),
    [anon_sym_spawn] = ACTIONS(4881),
    [anon_sym_json_DOTdecode] = ACTIONS(4881),
    [anon_sym_LBRACK2] = ACTIONS(4881),
    [anon_sym_TILDE] = ACTIONS(4881),
    [anon_sym_CARET] = ACTIONS(4881),
    [anon_sym_AMP] = ACTIONS(4881),
    [anon_sym_LT_DASH] = ACTIONS(4881),
    [sym_none] = ACTIONS(4881),
    [sym_true] = ACTIONS(4881),
    [sym_false] = ACTIONS(4881),
    [sym_nil] = ACTIONS(4881),
    [anon_sym_if] = ACTIONS(4881),
    [anon_sym_DOLLARif] = ACTIONS(4881),
    [anon_sym_match] = ACTIONS(4881),
    [anon_sym_select] = ACTIONS(4881),
    [anon_sym_lock] = ACTIONS(4881),
    [anon_sym_rlock] = ACTIONS(4881),
    [anon_sym_unsafe] = ACTIONS(4881),
    [anon_sym_sql] = ACTIONS(4881),
    [sym_int_literal] = ACTIONS(4881),
    [sym_float_literal] = ACTIONS(4881),
    [sym_rune_literal] = ACTIONS(4881),
    [anon_sym_SQUOTE] = ACTIONS(4881),
    [anon_sym_DQUOTE] = ACTIONS(4881),
    [anon_sym_c_SQUOTE] = ACTIONS(4881),
    [anon_sym_c_DQUOTE] = ACTIONS(4881),
    [anon_sym_r_SQUOTE] = ACTIONS(4881),
    [anon_sym_r_DQUOTE] = ACTIONS(4881),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4881),
    [anon_sym_shared] = ACTIONS(4881),
    [anon_sym_map_LBRACK] = ACTIONS(4881),
    [anon_sym_chan] = ACTIONS(4881),
    [anon_sym_thread] = ACTIONS(4881),
    [anon_sym_atomic] = ACTIONS(4881),
    [anon_sym_assert] = ACTIONS(4881),
    [anon_sym_defer] = ACTIONS(4881),
    [anon_sym_goto] = ACTIONS(4881),
    [anon_sym_break] = ACTIONS(4881),
    [anon_sym_continue] = ACTIONS(4881),
    [anon_sym_return] = ACTIONS(4881),
    [anon_sym_DOLLARfor] = ACTIONS(4881),
    [anon_sym_for] = ACTIONS(4881),
    [anon_sym_POUND] = ACTIONS(4881),
    [anon_sym_asm] = ACTIONS(4881),
    [anon_sym_AT_LBRACK] = ACTIONS(4881),
  },
  [1901] = {
    [sym_line_comment] = STATE(1901),
    [sym_block_comment] = STATE(1901),
    [ts_builtin_sym_end] = ACTIONS(4883),
    [sym_identifier] = ACTIONS(4885),
    [anon_sym_LF] = ACTIONS(4885),
    [anon_sym_CR] = ACTIONS(4885),
    [anon_sym_CR_LF] = ACTIONS(4885),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4885),
    [anon_sym_LBRACE] = ACTIONS(4885),
    [anon_sym_const] = ACTIONS(4885),
    [anon_sym_LPAREN] = ACTIONS(4885),
    [anon_sym___global] = ACTIONS(4885),
    [anon_sym_type] = ACTIONS(4885),
    [anon_sym_fn] = ACTIONS(4885),
    [anon_sym_PLUS] = ACTIONS(4885),
    [anon_sym_DASH] = ACTIONS(4885),
    [anon_sym_STAR] = ACTIONS(4885),
    [anon_sym_struct] = ACTIONS(4885),
    [anon_sym_union] = ACTIONS(4885),
    [anon_sym_pub] = ACTIONS(4885),
    [anon_sym_mut] = ACTIONS(4885),
    [anon_sym_enum] = ACTIONS(4885),
    [anon_sym_interface] = ACTIONS(4885),
    [anon_sym_QMARK] = ACTIONS(4885),
    [anon_sym_BANG] = ACTIONS(4885),
    [anon_sym_go] = ACTIONS(4885),
    [anon_sym_spawn] = ACTIONS(4885),
    [anon_sym_json_DOTdecode] = ACTIONS(4885),
    [anon_sym_LBRACK2] = ACTIONS(4885),
    [anon_sym_TILDE] = ACTIONS(4885),
    [anon_sym_CARET] = ACTIONS(4885),
    [anon_sym_AMP] = ACTIONS(4885),
    [anon_sym_LT_DASH] = ACTIONS(4885),
    [sym_none] = ACTIONS(4885),
    [sym_true] = ACTIONS(4885),
    [sym_false] = ACTIONS(4885),
    [sym_nil] = ACTIONS(4885),
    [anon_sym_if] = ACTIONS(4885),
    [anon_sym_DOLLARif] = ACTIONS(4885),
    [anon_sym_match] = ACTIONS(4885),
    [anon_sym_select] = ACTIONS(4885),
    [anon_sym_lock] = ACTIONS(4885),
    [anon_sym_rlock] = ACTIONS(4885),
    [anon_sym_unsafe] = ACTIONS(4885),
    [anon_sym_sql] = ACTIONS(4885),
    [sym_int_literal] = ACTIONS(4885),
    [sym_float_literal] = ACTIONS(4885),
    [sym_rune_literal] = ACTIONS(4885),
    [anon_sym_SQUOTE] = ACTIONS(4885),
    [anon_sym_DQUOTE] = ACTIONS(4885),
    [anon_sym_c_SQUOTE] = ACTIONS(4885),
    [anon_sym_c_DQUOTE] = ACTIONS(4885),
    [anon_sym_r_SQUOTE] = ACTIONS(4885),
    [anon_sym_r_DQUOTE] = ACTIONS(4885),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4885),
    [anon_sym_shared] = ACTIONS(4885),
    [anon_sym_map_LBRACK] = ACTIONS(4885),
    [anon_sym_chan] = ACTIONS(4885),
    [anon_sym_thread] = ACTIONS(4885),
    [anon_sym_atomic] = ACTIONS(4885),
    [anon_sym_assert] = ACTIONS(4885),
    [anon_sym_defer] = ACTIONS(4885),
    [anon_sym_goto] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4885),
    [anon_sym_continue] = ACTIONS(4885),
    [anon_sym_return] = ACTIONS(4885),
    [anon_sym_DOLLARfor] = ACTIONS(4885),
    [anon_sym_for] = ACTIONS(4885),
    [anon_sym_POUND] = ACTIONS(4885),
    [anon_sym_asm] = ACTIONS(4885),
    [anon_sym_AT_LBRACK] = ACTIONS(4885),
  },
  [1902] = {
    [sym_line_comment] = STATE(1902),
    [sym_block_comment] = STATE(1902),
    [ts_builtin_sym_end] = ACTIONS(4887),
    [sym_identifier] = ACTIONS(4889),
    [anon_sym_LF] = ACTIONS(4889),
    [anon_sym_CR] = ACTIONS(4889),
    [anon_sym_CR_LF] = ACTIONS(4889),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4889),
    [anon_sym_LBRACE] = ACTIONS(4889),
    [anon_sym_const] = ACTIONS(4889),
    [anon_sym_LPAREN] = ACTIONS(4889),
    [anon_sym___global] = ACTIONS(4889),
    [anon_sym_type] = ACTIONS(4889),
    [anon_sym_fn] = ACTIONS(4889),
    [anon_sym_PLUS] = ACTIONS(4889),
    [anon_sym_DASH] = ACTIONS(4889),
    [anon_sym_STAR] = ACTIONS(4889),
    [anon_sym_struct] = ACTIONS(4889),
    [anon_sym_union] = ACTIONS(4889),
    [anon_sym_pub] = ACTIONS(4889),
    [anon_sym_mut] = ACTIONS(4889),
    [anon_sym_enum] = ACTIONS(4889),
    [anon_sym_interface] = ACTIONS(4889),
    [anon_sym_QMARK] = ACTIONS(4889),
    [anon_sym_BANG] = ACTIONS(4889),
    [anon_sym_go] = ACTIONS(4889),
    [anon_sym_spawn] = ACTIONS(4889),
    [anon_sym_json_DOTdecode] = ACTIONS(4889),
    [anon_sym_LBRACK2] = ACTIONS(4889),
    [anon_sym_TILDE] = ACTIONS(4889),
    [anon_sym_CARET] = ACTIONS(4889),
    [anon_sym_AMP] = ACTIONS(4889),
    [anon_sym_LT_DASH] = ACTIONS(4889),
    [sym_none] = ACTIONS(4889),
    [sym_true] = ACTIONS(4889),
    [sym_false] = ACTIONS(4889),
    [sym_nil] = ACTIONS(4889),
    [anon_sym_if] = ACTIONS(4889),
    [anon_sym_DOLLARif] = ACTIONS(4889),
    [anon_sym_match] = ACTIONS(4889),
    [anon_sym_select] = ACTIONS(4889),
    [anon_sym_lock] = ACTIONS(4889),
    [anon_sym_rlock] = ACTIONS(4889),
    [anon_sym_unsafe] = ACTIONS(4889),
    [anon_sym_sql] = ACTIONS(4889),
    [sym_int_literal] = ACTIONS(4889),
    [sym_float_literal] = ACTIONS(4889),
    [sym_rune_literal] = ACTIONS(4889),
    [anon_sym_SQUOTE] = ACTIONS(4889),
    [anon_sym_DQUOTE] = ACTIONS(4889),
    [anon_sym_c_SQUOTE] = ACTIONS(4889),
    [anon_sym_c_DQUOTE] = ACTIONS(4889),
    [anon_sym_r_SQUOTE] = ACTIONS(4889),
    [anon_sym_r_DQUOTE] = ACTIONS(4889),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4889),
    [anon_sym_shared] = ACTIONS(4889),
    [anon_sym_map_LBRACK] = ACTIONS(4889),
    [anon_sym_chan] = ACTIONS(4889),
    [anon_sym_thread] = ACTIONS(4889),
    [anon_sym_atomic] = ACTIONS(4889),
    [anon_sym_assert] = ACTIONS(4889),
    [anon_sym_defer] = ACTIONS(4889),
    [anon_sym_goto] = ACTIONS(4889),
    [anon_sym_break] = ACTIONS(4889),
    [anon_sym_continue] = ACTIONS(4889),
    [anon_sym_return] = ACTIONS(4889),
    [anon_sym_DOLLARfor] = ACTIONS(4889),
    [anon_sym_for] = ACTIONS(4889),
    [anon_sym_POUND] = ACTIONS(4889),
    [anon_sym_asm] = ACTIONS(4889),
    [anon_sym_AT_LBRACK] = ACTIONS(4889),
  },
  [1903] = {
    [sym_line_comment] = STATE(1903),
    [sym_block_comment] = STATE(1903),
    [ts_builtin_sym_end] = ACTIONS(3310),
    [sym_identifier] = ACTIONS(3312),
    [anon_sym_LF] = ACTIONS(3312),
    [anon_sym_CR] = ACTIONS(3312),
    [anon_sym_CR_LF] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_const] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3312),
    [anon_sym___global] = ACTIONS(3312),
    [anon_sym_type] = ACTIONS(3312),
    [anon_sym_fn] = ACTIONS(3312),
    [anon_sym_PLUS] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_struct] = ACTIONS(3312),
    [anon_sym_union] = ACTIONS(3312),
    [anon_sym_pub] = ACTIONS(3312),
    [anon_sym_mut] = ACTIONS(3312),
    [anon_sym_enum] = ACTIONS(3312),
    [anon_sym_interface] = ACTIONS(3312),
    [anon_sym_QMARK] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_go] = ACTIONS(3312),
    [anon_sym_spawn] = ACTIONS(3312),
    [anon_sym_json_DOTdecode] = ACTIONS(3312),
    [anon_sym_LBRACK2] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_CARET] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3312),
    [anon_sym_LT_DASH] = ACTIONS(3312),
    [sym_none] = ACTIONS(3312),
    [sym_true] = ACTIONS(3312),
    [sym_false] = ACTIONS(3312),
    [sym_nil] = ACTIONS(3312),
    [anon_sym_if] = ACTIONS(3312),
    [anon_sym_DOLLARif] = ACTIONS(3312),
    [anon_sym_match] = ACTIONS(3312),
    [anon_sym_select] = ACTIONS(3312),
    [anon_sym_lock] = ACTIONS(3312),
    [anon_sym_rlock] = ACTIONS(3312),
    [anon_sym_unsafe] = ACTIONS(3312),
    [anon_sym_sql] = ACTIONS(3312),
    [sym_int_literal] = ACTIONS(3312),
    [sym_float_literal] = ACTIONS(3312),
    [sym_rune_literal] = ACTIONS(3312),
    [anon_sym_SQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3312),
    [anon_sym_c_SQUOTE] = ACTIONS(3312),
    [anon_sym_c_DQUOTE] = ACTIONS(3312),
    [anon_sym_r_SQUOTE] = ACTIONS(3312),
    [anon_sym_r_DQUOTE] = ACTIONS(3312),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3312),
    [anon_sym_shared] = ACTIONS(3312),
    [anon_sym_map_LBRACK] = ACTIONS(3312),
    [anon_sym_chan] = ACTIONS(3312),
    [anon_sym_thread] = ACTIONS(3312),
    [anon_sym_atomic] = ACTIONS(3312),
    [anon_sym_assert] = ACTIONS(3312),
    [anon_sym_defer] = ACTIONS(3312),
    [anon_sym_goto] = ACTIONS(3312),
    [anon_sym_break] = ACTIONS(3312),
    [anon_sym_continue] = ACTIONS(3312),
    [anon_sym_return] = ACTIONS(3312),
    [anon_sym_DOLLARfor] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3312),
    [anon_sym_POUND] = ACTIONS(3312),
    [anon_sym_asm] = ACTIONS(3312),
    [anon_sym_AT_LBRACK] = ACTIONS(3312),
  },
  [1904] = {
    [sym_line_comment] = STATE(1904),
    [sym_block_comment] = STATE(1904),
    [ts_builtin_sym_end] = ACTIONS(4891),
    [sym_identifier] = ACTIONS(4893),
    [anon_sym_LF] = ACTIONS(4893),
    [anon_sym_CR] = ACTIONS(4893),
    [anon_sym_CR_LF] = ACTIONS(4893),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4893),
    [anon_sym_LBRACE] = ACTIONS(4893),
    [anon_sym_const] = ACTIONS(4893),
    [anon_sym_LPAREN] = ACTIONS(4893),
    [anon_sym___global] = ACTIONS(4893),
    [anon_sym_type] = ACTIONS(4893),
    [anon_sym_fn] = ACTIONS(4893),
    [anon_sym_PLUS] = ACTIONS(4893),
    [anon_sym_DASH] = ACTIONS(4893),
    [anon_sym_STAR] = ACTIONS(4893),
    [anon_sym_struct] = ACTIONS(4893),
    [anon_sym_union] = ACTIONS(4893),
    [anon_sym_pub] = ACTIONS(4893),
    [anon_sym_mut] = ACTIONS(4893),
    [anon_sym_enum] = ACTIONS(4893),
    [anon_sym_interface] = ACTIONS(4893),
    [anon_sym_QMARK] = ACTIONS(4893),
    [anon_sym_BANG] = ACTIONS(4893),
    [anon_sym_go] = ACTIONS(4893),
    [anon_sym_spawn] = ACTIONS(4893),
    [anon_sym_json_DOTdecode] = ACTIONS(4893),
    [anon_sym_LBRACK2] = ACTIONS(4893),
    [anon_sym_TILDE] = ACTIONS(4893),
    [anon_sym_CARET] = ACTIONS(4893),
    [anon_sym_AMP] = ACTIONS(4893),
    [anon_sym_LT_DASH] = ACTIONS(4893),
    [sym_none] = ACTIONS(4893),
    [sym_true] = ACTIONS(4893),
    [sym_false] = ACTIONS(4893),
    [sym_nil] = ACTIONS(4893),
    [anon_sym_if] = ACTIONS(4893),
    [anon_sym_DOLLARif] = ACTIONS(4893),
    [anon_sym_match] = ACTIONS(4893),
    [anon_sym_select] = ACTIONS(4893),
    [anon_sym_lock] = ACTIONS(4893),
    [anon_sym_rlock] = ACTIONS(4893),
    [anon_sym_unsafe] = ACTIONS(4893),
    [anon_sym_sql] = ACTIONS(4893),
    [sym_int_literal] = ACTIONS(4893),
    [sym_float_literal] = ACTIONS(4893),
    [sym_rune_literal] = ACTIONS(4893),
    [anon_sym_SQUOTE] = ACTIONS(4893),
    [anon_sym_DQUOTE] = ACTIONS(4893),
    [anon_sym_c_SQUOTE] = ACTIONS(4893),
    [anon_sym_c_DQUOTE] = ACTIONS(4893),
    [anon_sym_r_SQUOTE] = ACTIONS(4893),
    [anon_sym_r_DQUOTE] = ACTIONS(4893),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4893),
    [anon_sym_shared] = ACTIONS(4893),
    [anon_sym_map_LBRACK] = ACTIONS(4893),
    [anon_sym_chan] = ACTIONS(4893),
    [anon_sym_thread] = ACTIONS(4893),
    [anon_sym_atomic] = ACTIONS(4893),
    [anon_sym_assert] = ACTIONS(4893),
    [anon_sym_defer] = ACTIONS(4893),
    [anon_sym_goto] = ACTIONS(4893),
    [anon_sym_break] = ACTIONS(4893),
    [anon_sym_continue] = ACTIONS(4893),
    [anon_sym_return] = ACTIONS(4893),
    [anon_sym_DOLLARfor] = ACTIONS(4893),
    [anon_sym_for] = ACTIONS(4893),
    [anon_sym_POUND] = ACTIONS(4893),
    [anon_sym_asm] = ACTIONS(4893),
    [anon_sym_AT_LBRACK] = ACTIONS(4893),
  },
  [1905] = {
    [sym_line_comment] = STATE(1905),
    [sym_block_comment] = STATE(1905),
    [ts_builtin_sym_end] = ACTIONS(4393),
    [sym_identifier] = ACTIONS(4395),
    [anon_sym_LF] = ACTIONS(4395),
    [anon_sym_CR] = ACTIONS(4395),
    [anon_sym_CR_LF] = ACTIONS(4395),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_DOT] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(4395),
    [anon_sym_const] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym___global] = ACTIONS(4395),
    [anon_sym_type] = ACTIONS(4395),
    [anon_sym_fn] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4395),
    [anon_sym_DASH] = ACTIONS(4395),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_struct] = ACTIONS(4395),
    [anon_sym_union] = ACTIONS(4395),
    [anon_sym_pub] = ACTIONS(4395),
    [anon_sym_mut] = ACTIONS(4395),
    [anon_sym_enum] = ACTIONS(4395),
    [anon_sym_interface] = ACTIONS(4395),
    [anon_sym_QMARK] = ACTIONS(4395),
    [anon_sym_BANG] = ACTIONS(4395),
    [anon_sym_go] = ACTIONS(4395),
    [anon_sym_spawn] = ACTIONS(4395),
    [anon_sym_json_DOTdecode] = ACTIONS(4395),
    [anon_sym_LBRACK2] = ACTIONS(4395),
    [anon_sym_TILDE] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_AMP] = ACTIONS(4395),
    [anon_sym_LT_DASH] = ACTIONS(4395),
    [sym_none] = ACTIONS(4395),
    [sym_true] = ACTIONS(4395),
    [sym_false] = ACTIONS(4395),
    [sym_nil] = ACTIONS(4395),
    [anon_sym_if] = ACTIONS(4395),
    [anon_sym_DOLLARif] = ACTIONS(4395),
    [anon_sym_match] = ACTIONS(4395),
    [anon_sym_select] = ACTIONS(4395),
    [anon_sym_lock] = ACTIONS(4395),
    [anon_sym_rlock] = ACTIONS(4395),
    [anon_sym_unsafe] = ACTIONS(4395),
    [anon_sym_sql] = ACTIONS(4395),
    [sym_int_literal] = ACTIONS(4395),
    [sym_float_literal] = ACTIONS(4395),
    [sym_rune_literal] = ACTIONS(4395),
    [anon_sym_SQUOTE] = ACTIONS(4395),
    [anon_sym_DQUOTE] = ACTIONS(4395),
    [anon_sym_c_SQUOTE] = ACTIONS(4395),
    [anon_sym_c_DQUOTE] = ACTIONS(4395),
    [anon_sym_r_SQUOTE] = ACTIONS(4395),
    [anon_sym_r_DQUOTE] = ACTIONS(4395),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4395),
    [anon_sym_shared] = ACTIONS(4395),
    [anon_sym_map_LBRACK] = ACTIONS(4395),
    [anon_sym_chan] = ACTIONS(4395),
    [anon_sym_thread] = ACTIONS(4395),
    [anon_sym_atomic] = ACTIONS(4395),
    [anon_sym_assert] = ACTIONS(4395),
    [anon_sym_defer] = ACTIONS(4395),
    [anon_sym_goto] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4395),
    [anon_sym_continue] = ACTIONS(4395),
    [anon_sym_return] = ACTIONS(4395),
    [anon_sym_DOLLARfor] = ACTIONS(4395),
    [anon_sym_for] = ACTIONS(4395),
    [anon_sym_POUND] = ACTIONS(4395),
    [anon_sym_asm] = ACTIONS(4395),
    [anon_sym_AT_LBRACK] = ACTIONS(4395),
  },
  [1906] = {
    [sym_line_comment] = STATE(1906),
    [sym_block_comment] = STATE(1906),
    [sym_reference_expression] = STATE(4553),
    [sym_type_reference_expression] = STATE(2589),
    [sym_plain_type] = STATE(2757),
    [sym__plain_type_without_special] = STATE(2747),
    [sym_anon_struct_type] = STATE(2748),
    [sym_multi_return_type] = STATE(2747),
    [sym_result_type] = STATE(2747),
    [sym_option_type] = STATE(2747),
    [sym_qualified_type] = STATE(2589),
    [sym_fixed_array_type] = STATE(2748),
    [sym_array_type] = STATE(2748),
    [sym_pointer_type] = STATE(2748),
    [sym_wrong_pointer_type] = STATE(2748),
    [sym_map_type] = STATE(2748),
    [sym_channel_type] = STATE(2748),
    [sym_shared_type] = STATE(2748),
    [sym_thread_type] = STATE(2748),
    [sym_atomic_type] = STATE(2748),
    [sym_generic_type] = STATE(2748),
    [sym_function_type] = STATE(2748),
    [sym_identifier] = ACTIONS(4895),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(821),
    [anon_sym_as] = ACTIONS(821),
    [anon_sym_LBRACE] = ACTIONS(817),
    [anon_sym_COMMA] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(4897),
    [anon_sym_fn] = ACTIONS(4899),
    [anon_sym_PLUS] = ACTIONS(821),
    [anon_sym_DASH] = ACTIONS(821),
    [anon_sym_STAR] = ACTIONS(4901),
    [anon_sym_SLASH] = ACTIONS(821),
    [anon_sym_PERCENT] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(821),
    [anon_sym_GT] = ACTIONS(821),
    [anon_sym_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(817),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(817),
    [anon_sym_LBRACK] = ACTIONS(817),
    [anon_sym_struct] = ACTIONS(4903),
    [anon_sym_PLUS_PLUS] = ACTIONS(817),
    [anon_sym_DASH_DASH] = ACTIONS(817),
    [anon_sym_QMARK] = ACTIONS(4905),
    [anon_sym_BANG] = ACTIONS(4907),
    [anon_sym_PIPE] = ACTIONS(821),
    [anon_sym_LBRACK2] = ACTIONS(4909),
    [anon_sym_CARET] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(4911),
    [anon_sym_LT_LT] = ACTIONS(817),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_GT_GT_GT] = ACTIONS(817),
    [anon_sym_AMP_CARET] = ACTIONS(817),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_or] = ACTIONS(821),
    [anon_sym_QMARK_DOT] = ACTIONS(817),
    [anon_sym_POUND_LBRACK] = ACTIONS(817),
    [anon_sym_is] = ACTIONS(821),
    [anon_sym_BANGis] = ACTIONS(817),
    [anon_sym_in] = ACTIONS(821),
    [anon_sym_BANGin] = ACTIONS(817),
    [anon_sym_shared] = ACTIONS(4913),
    [anon_sym_map_LBRACK] = ACTIONS(4915),
    [anon_sym_chan] = ACTIONS(4917),
    [anon_sym_thread] = ACTIONS(4919),
    [anon_sym_atomic] = ACTIONS(4921),
    [anon_sym_DOT_DOT] = ACTIONS(821),
  },
  [1907] = {
    [sym_line_comment] = STATE(1907),
    [sym_block_comment] = STATE(1907),
    [sym_reference_expression] = STATE(4553),
    [sym_type_reference_expression] = STATE(2589),
    [sym_plain_type] = STATE(2769),
    [sym__plain_type_without_special] = STATE(2747),
    [sym_anon_struct_type] = STATE(2748),
    [sym_multi_return_type] = STATE(2747),
    [sym_result_type] = STATE(2747),
    [sym_option_type] = STATE(2747),
    [sym_qualified_type] = STATE(2589),
    [sym_fixed_array_type] = STATE(2748),
    [sym_array_type] = STATE(2748),
    [sym_pointer_type] = STATE(2748),
    [sym_wrong_pointer_type] = STATE(2748),
    [sym_map_type] = STATE(2748),
    [sym_channel_type] = STATE(2748),
    [sym_shared_type] = STATE(2748),
    [sym_thread_type] = STATE(2748),
    [sym_atomic_type] = STATE(2748),
    [sym_generic_type] = STATE(2748),
    [sym_function_type] = STATE(2748),
    [sym_identifier] = ACTIONS(4895),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(859),
    [anon_sym_as] = ACTIONS(859),
    [anon_sym_LBRACE] = ACTIONS(857),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(4897),
    [anon_sym_fn] = ACTIONS(4899),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(4901),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_EQ_EQ] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(857),
    [anon_sym_LT_EQ] = ACTIONS(857),
    [anon_sym_GT_EQ] = ACTIONS(857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(857),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_struct] = ACTIONS(4903),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_QMARK] = ACTIONS(4905),
    [anon_sym_BANG] = ACTIONS(4907),
    [anon_sym_PIPE] = ACTIONS(859),
    [anon_sym_LBRACK2] = ACTIONS(4909),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(4911),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_GT_GT_GT] = ACTIONS(857),
    [anon_sym_AMP_CARET] = ACTIONS(857),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [anon_sym_or] = ACTIONS(859),
    [anon_sym_QMARK_DOT] = ACTIONS(857),
    [anon_sym_POUND_LBRACK] = ACTIONS(857),
    [anon_sym_is] = ACTIONS(859),
    [anon_sym_BANGis] = ACTIONS(857),
    [anon_sym_in] = ACTIONS(859),
    [anon_sym_BANGin] = ACTIONS(857),
    [anon_sym_shared] = ACTIONS(4913),
    [anon_sym_map_LBRACK] = ACTIONS(4915),
    [anon_sym_chan] = ACTIONS(4917),
    [anon_sym_thread] = ACTIONS(4919),
    [anon_sym_atomic] = ACTIONS(4921),
    [anon_sym_DOT_DOT] = ACTIONS(859),
  },
  [1908] = {
    [sym_line_comment] = STATE(1908),
    [sym_block_comment] = STATE(1908),
    [sym_reference_expression] = STATE(4553),
    [sym_type_reference_expression] = STATE(2589),
    [sym_plain_type] = STATE(2773),
    [sym__plain_type_without_special] = STATE(2747),
    [sym_anon_struct_type] = STATE(2748),
    [sym_multi_return_type] = STATE(2747),
    [sym_result_type] = STATE(2747),
    [sym_option_type] = STATE(2747),
    [sym_qualified_type] = STATE(2589),
    [sym_fixed_array_type] = STATE(2748),
    [sym_array_type] = STATE(2748),
    [sym_pointer_type] = STATE(2748),
    [sym_wrong_pointer_type] = STATE(2748),
    [sym_map_type] = STATE(2748),
    [sym_channel_type] = STATE(2748),
    [sym_shared_type] = STATE(2748),
    [sym_thread_type] = STATE(2748),
    [sym_atomic_type] = STATE(2748),
    [sym_generic_type] = STATE(2748),
    [sym_function_type] = STATE(2748),
    [sym_identifier] = ACTIONS(4895),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(855),
    [anon_sym_as] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(853),
    [anon_sym_COMMA] = ACTIONS(853),
    [anon_sym_LPAREN] = ACTIONS(4897),
    [anon_sym_fn] = ACTIONS(4899),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(4901),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_PERCENT] = ACTIONS(853),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_GT] = ACTIONS(855),
    [anon_sym_EQ_EQ] = ACTIONS(853),
    [anon_sym_BANG_EQ] = ACTIONS(853),
    [anon_sym_LT_EQ] = ACTIONS(853),
    [anon_sym_GT_EQ] = ACTIONS(853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_struct] = ACTIONS(4903),
    [anon_sym_PLUS_PLUS] = ACTIONS(853),
    [anon_sym_DASH_DASH] = ACTIONS(853),
    [anon_sym_QMARK] = ACTIONS(4905),
    [anon_sym_BANG] = ACTIONS(4907),
    [anon_sym_PIPE] = ACTIONS(855),
    [anon_sym_LBRACK2] = ACTIONS(4909),
    [anon_sym_CARET] = ACTIONS(853),
    [anon_sym_AMP] = ACTIONS(4911),
    [anon_sym_LT_LT] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_GT_GT_GT] = ACTIONS(853),
    [anon_sym_AMP_CARET] = ACTIONS(853),
    [anon_sym_AMP_AMP] = ACTIONS(853),
    [anon_sym_PIPE_PIPE] = ACTIONS(853),
    [anon_sym_or] = ACTIONS(855),
    [anon_sym_QMARK_DOT] = ACTIONS(853),
    [anon_sym_POUND_LBRACK] = ACTIONS(853),
    [anon_sym_is] = ACTIONS(855),
    [anon_sym_BANGis] = ACTIONS(853),
    [anon_sym_in] = ACTIONS(855),
    [anon_sym_BANGin] = ACTIONS(853),
    [anon_sym_shared] = ACTIONS(4913),
    [anon_sym_map_LBRACK] = ACTIONS(4915),
    [anon_sym_chan] = ACTIONS(4917),
    [anon_sym_thread] = ACTIONS(4919),
    [anon_sym_atomic] = ACTIONS(4921),
    [anon_sym_DOT_DOT] = ACTIONS(855),
  },
  [1909] = {
    [sym_line_comment] = STATE(1909),
    [sym_block_comment] = STATE(1909),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2458),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_LF] = ACTIONS(865),
    [anon_sym_CR] = ACTIONS(865),
    [anon_sym_CR_LF] = ACTIONS(865),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(865),
    [anon_sym_LPAREN] = ACTIONS(867),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_STAR] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_PERCENT] = ACTIONS(865),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(865),
    [anon_sym_BANG_EQ] = ACTIONS(865),
    [anon_sym_LT_EQ] = ACTIONS(865),
    [anon_sym_GT_EQ] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_PLUS_PLUS] = ACTIONS(865),
    [anon_sym_DASH_DASH] = ACTIONS(865),
    [anon_sym_QMARK] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(4923),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_LBRACK2] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(865),
    [anon_sym_GT_GT] = ACTIONS(865),
    [anon_sym_GT_GT_GT] = ACTIONS(865),
    [anon_sym_AMP_CARET] = ACTIONS(865),
    [anon_sym_AMP_AMP] = ACTIONS(865),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_QMARK_DOT] = ACTIONS(865),
    [anon_sym_POUND_LBRACK] = ACTIONS(865),
    [anon_sym_is] = ACTIONS(865),
    [anon_sym_BANGis] = ACTIONS(865),
    [anon_sym_in] = ACTIONS(865),
    [anon_sym_BANGin] = ACTIONS(865),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(351),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [1910] = {
    [sym_line_comment] = STATE(1910),
    [sym_block_comment] = STATE(1910),
    [sym_reference_expression] = STATE(4557),
    [sym_type_reference_expression] = STATE(2609),
    [sym_plain_type] = STATE(2844),
    [sym__plain_type_without_special] = STATE(2888),
    [sym_anon_struct_type] = STATE(2889),
    [sym_multi_return_type] = STATE(2888),
    [sym_result_type] = STATE(2888),
    [sym_option_type] = STATE(2888),
    [sym_qualified_type] = STATE(2609),
    [sym_fixed_array_type] = STATE(2889),
    [sym_array_type] = STATE(2889),
    [sym_pointer_type] = STATE(2889),
    [sym_wrong_pointer_type] = STATE(2889),
    [sym_map_type] = STATE(2889),
    [sym_channel_type] = STATE(2889),
    [sym_shared_type] = STATE(2889),
    [sym_thread_type] = STATE(2889),
    [sym_atomic_type] = STATE(2889),
    [sym_generic_type] = STATE(2889),
    [sym_function_type] = STATE(2889),
    [sym_identifier] = ACTIONS(4925),
    [anon_sym_LF] = ACTIONS(855),
    [anon_sym_CR] = ACTIONS(855),
    [anon_sym_CR_LF] = ACTIONS(855),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(855),
    [anon_sym_DOT] = ACTIONS(855),
    [anon_sym_as] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(4927),
    [anon_sym_fn] = ACTIONS(4929),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(4931),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_PERCENT] = ACTIONS(855),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_GT] = ACTIONS(855),
    [anon_sym_EQ_EQ] = ACTIONS(855),
    [anon_sym_BANG_EQ] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(855),
    [anon_sym_GT_EQ] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_struct] = ACTIONS(4933),
    [anon_sym_PLUS_PLUS] = ACTIONS(855),
    [anon_sym_DASH_DASH] = ACTIONS(855),
    [anon_sym_QMARK] = ACTIONS(4935),
    [anon_sym_BANG] = ACTIONS(4937),
    [anon_sym_PIPE] = ACTIONS(855),
    [anon_sym_LBRACK2] = ACTIONS(4939),
    [anon_sym_CARET] = ACTIONS(855),
    [anon_sym_AMP] = ACTIONS(4941),
    [anon_sym_LT_LT] = ACTIONS(855),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_GT_GT_GT] = ACTIONS(855),
    [anon_sym_AMP_CARET] = ACTIONS(855),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_PIPE_PIPE] = ACTIONS(855),
    [anon_sym_or] = ACTIONS(855),
    [anon_sym_QMARK_DOT] = ACTIONS(855),
    [anon_sym_POUND_LBRACK] = ACTIONS(855),
    [anon_sym_is] = ACTIONS(855),
    [anon_sym_BANGis] = ACTIONS(855),
    [anon_sym_in] = ACTIONS(855),
    [anon_sym_BANGin] = ACTIONS(855),
    [anon_sym_shared] = ACTIONS(4943),
    [anon_sym_map_LBRACK] = ACTIONS(4945),
    [anon_sym_chan] = ACTIONS(4947),
    [anon_sym_thread] = ACTIONS(4949),
    [anon_sym_atomic] = ACTIONS(4951),
  },
  [1911] = {
    [sym_line_comment] = STATE(1911),
    [sym_block_comment] = STATE(1911),
    [sym_reference_expression] = STATE(4557),
    [sym_type_reference_expression] = STATE(2609),
    [sym_plain_type] = STATE(2848),
    [sym__plain_type_without_special] = STATE(2888),
    [sym_anon_struct_type] = STATE(2889),
    [sym_multi_return_type] = STATE(2888),
    [sym_result_type] = STATE(2888),
    [sym_option_type] = STATE(2888),
    [sym_qualified_type] = STATE(2609),
    [sym_fixed_array_type] = STATE(2889),
    [sym_array_type] = STATE(2889),
    [sym_pointer_type] = STATE(2889),
    [sym_wrong_pointer_type] = STATE(2889),
    [sym_map_type] = STATE(2889),
    [sym_channel_type] = STATE(2889),
    [sym_shared_type] = STATE(2889),
    [sym_thread_type] = STATE(2889),
    [sym_atomic_type] = STATE(2889),
    [sym_generic_type] = STATE(2889),
    [sym_function_type] = STATE(2889),
    [sym_identifier] = ACTIONS(4925),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_CR] = ACTIONS(859),
    [anon_sym_CR_LF] = ACTIONS(859),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(859),
    [anon_sym_as] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(4927),
    [anon_sym_fn] = ACTIONS(4929),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(4931),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_struct] = ACTIONS(4933),
    [anon_sym_PLUS_PLUS] = ACTIONS(859),
    [anon_sym_DASH_DASH] = ACTIONS(859),
    [anon_sym_QMARK] = ACTIONS(4935),
    [anon_sym_BANG] = ACTIONS(4937),
    [anon_sym_PIPE] = ACTIONS(859),
    [anon_sym_LBRACK2] = ACTIONS(4939),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(4941),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_GT_GT_GT] = ACTIONS(859),
    [anon_sym_AMP_CARET] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_or] = ACTIONS(859),
    [anon_sym_QMARK_DOT] = ACTIONS(859),
    [anon_sym_POUND_LBRACK] = ACTIONS(859),
    [anon_sym_is] = ACTIONS(859),
    [anon_sym_BANGis] = ACTIONS(859),
    [anon_sym_in] = ACTIONS(859),
    [anon_sym_BANGin] = ACTIONS(859),
    [anon_sym_shared] = ACTIONS(4943),
    [anon_sym_map_LBRACK] = ACTIONS(4945),
    [anon_sym_chan] = ACTIONS(4947),
    [anon_sym_thread] = ACTIONS(4949),
    [anon_sym_atomic] = ACTIONS(4951),
  },
  [1912] = {
    [sym_line_comment] = STATE(1912),
    [sym_block_comment] = STATE(1912),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2489),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(849),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_as] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(853),
    [anon_sym_COMMA] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(849),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(849),
    [anon_sym_SLASH] = ACTIONS(851),
    [anon_sym_PERCENT] = ACTIONS(849),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(849),
    [anon_sym_BANG_EQ] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_PLUS_PLUS] = ACTIONS(849),
    [anon_sym_DASH_DASH] = ACTIONS(849),
    [anon_sym_QMARK] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_PIPE] = ACTIONS(851),
    [anon_sym_LBRACK2] = ACTIONS(851),
    [anon_sym_CARET] = ACTIONS(849),
    [anon_sym_AMP] = ACTIONS(851),
    [anon_sym_LT_LT] = ACTIONS(849),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_GT_GT_GT] = ACTIONS(849),
    [anon_sym_AMP_CARET] = ACTIONS(849),
    [anon_sym_AMP_AMP] = ACTIONS(849),
    [anon_sym_PIPE_PIPE] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(851),
    [anon_sym_QMARK_DOT] = ACTIONS(849),
    [anon_sym_POUND_LBRACK] = ACTIONS(849),
    [anon_sym_is] = ACTIONS(851),
    [anon_sym_BANGis] = ACTIONS(849),
    [anon_sym_in] = ACTIONS(851),
    [anon_sym_BANGin] = ACTIONS(849),
    [anon_sym_COLON_EQ] = ACTIONS(849),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [1913] = {
    [sym_line_comment] = STATE(1913),
    [sym_block_comment] = STATE(1913),
    [sym_reference_expression] = STATE(4557),
    [sym_type_reference_expression] = STATE(2609),
    [sym_plain_type] = STATE(2897),
    [sym__plain_type_without_special] = STATE(2888),
    [sym_anon_struct_type] = STATE(2889),
    [sym_multi_return_type] = STATE(2888),
    [sym_result_type] = STATE(2888),
    [sym_option_type] = STATE(2888),
    [sym_qualified_type] = STATE(2609),
    [sym_fixed_array_type] = STATE(2889),
    [sym_array_type] = STATE(2889),
    [sym_pointer_type] = STATE(2889),
    [sym_wrong_pointer_type] = STATE(2889),
    [sym_map_type] = STATE(2889),
    [sym_channel_type] = STATE(2889),
    [sym_shared_type] = STATE(2889),
    [sym_thread_type] = STATE(2889),
    [sym_atomic_type] = STATE(2889),
    [sym_generic_type] = STATE(2889),
    [sym_function_type] = STATE(2889),
    [sym_identifier] = ACTIONS(4925),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_CR] = ACTIONS(821),
    [anon_sym_CR_LF] = ACTIONS(821),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(821),
    [anon_sym_DOT] = ACTIONS(821),
    [anon_sym_as] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(4927),
    [anon_sym_fn] = ACTIONS(4929),
    [anon_sym_PLUS] = ACTIONS(821),
    [anon_sym_DASH] = ACTIONS(821),
    [anon_sym_STAR] = ACTIONS(4931),
    [anon_sym_SLASH] = ACTIONS(821),
    [anon_sym_PERCENT] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(821),
    [anon_sym_GT] = ACTIONS(821),
    [anon_sym_EQ_EQ] = ACTIONS(821),
    [anon_sym_BANG_EQ] = ACTIONS(821),
    [anon_sym_LT_EQ] = ACTIONS(821),
    [anon_sym_GT_EQ] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(817),
    [anon_sym_struct] = ACTIONS(4933),
    [anon_sym_PLUS_PLUS] = ACTIONS(821),
    [anon_sym_DASH_DASH] = ACTIONS(821),
    [anon_sym_QMARK] = ACTIONS(4935),
    [anon_sym_BANG] = ACTIONS(4937),
    [anon_sym_PIPE] = ACTIONS(821),
    [anon_sym_LBRACK2] = ACTIONS(4939),
    [anon_sym_CARET] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(4941),
    [anon_sym_LT_LT] = ACTIONS(821),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_GT_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_CARET] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_or] = ACTIONS(821),
    [anon_sym_QMARK_DOT] = ACTIONS(821),
    [anon_sym_POUND_LBRACK] = ACTIONS(821),
    [anon_sym_is] = ACTIONS(821),
    [anon_sym_BANGis] = ACTIONS(821),
    [anon_sym_in] = ACTIONS(821),
    [anon_sym_BANGin] = ACTIONS(821),
    [anon_sym_shared] = ACTIONS(4943),
    [anon_sym_map_LBRACK] = ACTIONS(4945),
    [anon_sym_chan] = ACTIONS(4947),
    [anon_sym_thread] = ACTIONS(4949),
    [anon_sym_atomic] = ACTIONS(4951),
  },
  [1914] = {
    [sym_line_comment] = STATE(1914),
    [sym_block_comment] = STATE(1914),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2458),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(861),
    [anon_sym_COMMA] = ACTIONS(861),
    [anon_sym_LPAREN] = ACTIONS(3968),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_STAR] = ACTIONS(3970),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(861),
    [anon_sym_BANG_EQ] = ACTIONS(861),
    [anon_sym_LT_EQ] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_PLUS_PLUS] = ACTIONS(861),
    [anon_sym_DASH_DASH] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(4953),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_LBRACK2] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(865),
    [anon_sym_GT_GT_GT] = ACTIONS(861),
    [anon_sym_AMP_CARET] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_QMARK_DOT] = ACTIONS(861),
    [anon_sym_POUND_LBRACK] = ACTIONS(861),
    [anon_sym_is] = ACTIONS(865),
    [anon_sym_BANGis] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(865),
    [anon_sym_BANGin] = ACTIONS(861),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(865),
  },
  [1915] = {
    [sym_line_comment] = STATE(1915),
    [sym_block_comment] = STATE(1915),
    [ts_builtin_sym_end] = ACTIONS(4955),
    [sym_identifier] = ACTIONS(4957),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_module] = ACTIONS(4957),
    [anon_sym_import] = ACTIONS(4957),
    [anon_sym_DOT] = ACTIONS(4957),
    [anon_sym_LBRACE] = ACTIONS(4955),
    [anon_sym_const] = ACTIONS(4957),
    [anon_sym_LPAREN] = ACTIONS(4955),
    [anon_sym___global] = ACTIONS(4957),
    [anon_sym_type] = ACTIONS(4957),
    [anon_sym_fn] = ACTIONS(4957),
    [anon_sym_PLUS] = ACTIONS(4955),
    [anon_sym_DASH] = ACTIONS(4955),
    [anon_sym_STAR] = ACTIONS(4955),
    [anon_sym_struct] = ACTIONS(4957),
    [anon_sym_union] = ACTIONS(4957),
    [anon_sym_pub] = ACTIONS(4957),
    [anon_sym_mut] = ACTIONS(4957),
    [anon_sym_enum] = ACTIONS(4957),
    [anon_sym_interface] = ACTIONS(4957),
    [anon_sym_QMARK] = ACTIONS(4955),
    [anon_sym_BANG] = ACTIONS(4955),
    [anon_sym_go] = ACTIONS(4957),
    [anon_sym_spawn] = ACTIONS(4957),
    [anon_sym_json_DOTdecode] = ACTIONS(4955),
    [anon_sym_LBRACK2] = ACTIONS(4955),
    [anon_sym_TILDE] = ACTIONS(4955),
    [anon_sym_CARET] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4955),
    [anon_sym_LT_DASH] = ACTIONS(4955),
    [sym_none] = ACTIONS(4957),
    [sym_true] = ACTIONS(4957),
    [sym_false] = ACTIONS(4957),
    [sym_nil] = ACTIONS(4957),
    [anon_sym_if] = ACTIONS(4957),
    [anon_sym_DOLLARif] = ACTIONS(4957),
    [anon_sym_match] = ACTIONS(4957),
    [anon_sym_select] = ACTIONS(4957),
    [anon_sym_lock] = ACTIONS(4957),
    [anon_sym_rlock] = ACTIONS(4957),
    [anon_sym_unsafe] = ACTIONS(4957),
    [anon_sym_sql] = ACTIONS(4957),
    [sym_int_literal] = ACTIONS(4957),
    [sym_float_literal] = ACTIONS(4955),
    [sym_rune_literal] = ACTIONS(4955),
    [anon_sym_SQUOTE] = ACTIONS(4955),
    [anon_sym_DQUOTE] = ACTIONS(4955),
    [anon_sym_c_SQUOTE] = ACTIONS(4955),
    [anon_sym_c_DQUOTE] = ACTIONS(4955),
    [anon_sym_r_SQUOTE] = ACTIONS(4955),
    [anon_sym_r_DQUOTE] = ACTIONS(4955),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4957),
    [anon_sym_shared] = ACTIONS(4957),
    [anon_sym_map_LBRACK] = ACTIONS(4955),
    [anon_sym_chan] = ACTIONS(4957),
    [anon_sym_thread] = ACTIONS(4957),
    [anon_sym_atomic] = ACTIONS(4957),
    [anon_sym_assert] = ACTIONS(4957),
    [anon_sym_defer] = ACTIONS(4957),
    [anon_sym_goto] = ACTIONS(4957),
    [anon_sym_break] = ACTIONS(4957),
    [anon_sym_continue] = ACTIONS(4957),
    [anon_sym_return] = ACTIONS(4957),
    [anon_sym_DOLLARfor] = ACTIONS(4957),
    [anon_sym_for] = ACTIONS(4957),
    [anon_sym_POUND] = ACTIONS(4955),
    [anon_sym_asm] = ACTIONS(4957),
    [anon_sym_AT_LBRACK] = ACTIONS(4955),
  },
  [1916] = {
    [sym_line_comment] = STATE(1916),
    [sym_block_comment] = STATE(1916),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2484),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(4959),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4959),
    [anon_sym_LBRACE] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4961),
    [anon_sym_fn] = ACTIONS(4959),
    [anon_sym_PLUS] = ACTIONS(4961),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_STAR] = ACTIONS(4961),
    [anon_sym_struct] = ACTIONS(4959),
    [anon_sym_mut] = ACTIONS(4959),
    [anon_sym_QMARK] = ACTIONS(4961),
    [anon_sym_BANG] = ACTIONS(4961),
    [anon_sym_go] = ACTIONS(4959),
    [anon_sym_spawn] = ACTIONS(4959),
    [anon_sym_json_DOTdecode] = ACTIONS(4961),
    [anon_sym_LBRACK2] = ACTIONS(4961),
    [anon_sym_TILDE] = ACTIONS(4961),
    [anon_sym_CARET] = ACTIONS(4961),
    [anon_sym_AMP] = ACTIONS(4961),
    [anon_sym_LT_DASH] = ACTIONS(4961),
    [sym_none] = ACTIONS(4959),
    [sym_true] = ACTIONS(4959),
    [sym_false] = ACTIONS(4959),
    [sym_nil] = ACTIONS(4959),
    [anon_sym_if] = ACTIONS(4959),
    [anon_sym_DOLLARif] = ACTIONS(4959),
    [anon_sym_match] = ACTIONS(4959),
    [anon_sym_select] = ACTIONS(4959),
    [anon_sym_lock] = ACTIONS(4959),
    [anon_sym_rlock] = ACTIONS(4959),
    [anon_sym_unsafe] = ACTIONS(4959),
    [anon_sym_sql] = ACTIONS(4959),
    [sym_int_literal] = ACTIONS(4959),
    [sym_float_literal] = ACTIONS(4961),
    [sym_rune_literal] = ACTIONS(4961),
    [anon_sym_SQUOTE] = ACTIONS(4961),
    [anon_sym_DQUOTE] = ACTIONS(4961),
    [anon_sym_c_SQUOTE] = ACTIONS(4961),
    [anon_sym_c_DQUOTE] = ACTIONS(4961),
    [anon_sym_r_SQUOTE] = ACTIONS(4961),
    [anon_sym_r_DQUOTE] = ACTIONS(4961),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4959),
    [anon_sym_shared] = ACTIONS(4959),
    [anon_sym_map_LBRACK] = ACTIONS(4961),
    [anon_sym_chan] = ACTIONS(4959),
    [anon_sym_thread] = ACTIONS(4959),
    [anon_sym_atomic] = ACTIONS(4959),
  },
  [1917] = {
    [sym_line_comment] = STATE(1917),
    [sym_block_comment] = STATE(1917),
    [ts_builtin_sym_end] = ACTIONS(4963),
    [sym_identifier] = ACTIONS(4965),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(4965),
    [anon_sym_DOT] = ACTIONS(4965),
    [anon_sym_LBRACE] = ACTIONS(4963),
    [anon_sym_const] = ACTIONS(4965),
    [anon_sym_LPAREN] = ACTIONS(4963),
    [anon_sym___global] = ACTIONS(4965),
    [anon_sym_type] = ACTIONS(4965),
    [anon_sym_fn] = ACTIONS(4965),
    [anon_sym_PLUS] = ACTIONS(4963),
    [anon_sym_DASH] = ACTIONS(4963),
    [anon_sym_STAR] = ACTIONS(4963),
    [anon_sym_struct] = ACTIONS(4965),
    [anon_sym_union] = ACTIONS(4965),
    [anon_sym_pub] = ACTIONS(4965),
    [anon_sym_mut] = ACTIONS(4965),
    [anon_sym_enum] = ACTIONS(4965),
    [anon_sym_interface] = ACTIONS(4965),
    [anon_sym_QMARK] = ACTIONS(4963),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_go] = ACTIONS(4965),
    [anon_sym_spawn] = ACTIONS(4965),
    [anon_sym_json_DOTdecode] = ACTIONS(4963),
    [anon_sym_LBRACK2] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [anon_sym_CARET] = ACTIONS(4963),
    [anon_sym_AMP] = ACTIONS(4963),
    [anon_sym_LT_DASH] = ACTIONS(4963),
    [sym_none] = ACTIONS(4965),
    [sym_true] = ACTIONS(4965),
    [sym_false] = ACTIONS(4965),
    [sym_nil] = ACTIONS(4965),
    [anon_sym_if] = ACTIONS(4965),
    [anon_sym_DOLLARif] = ACTIONS(4965),
    [anon_sym_match] = ACTIONS(4965),
    [anon_sym_select] = ACTIONS(4965),
    [anon_sym_lock] = ACTIONS(4965),
    [anon_sym_rlock] = ACTIONS(4965),
    [anon_sym_unsafe] = ACTIONS(4965),
    [anon_sym_sql] = ACTIONS(4965),
    [sym_int_literal] = ACTIONS(4965),
    [sym_float_literal] = ACTIONS(4963),
    [sym_rune_literal] = ACTIONS(4963),
    [anon_sym_SQUOTE] = ACTIONS(4963),
    [anon_sym_DQUOTE] = ACTIONS(4963),
    [anon_sym_c_SQUOTE] = ACTIONS(4963),
    [anon_sym_c_DQUOTE] = ACTIONS(4963),
    [anon_sym_r_SQUOTE] = ACTIONS(4963),
    [anon_sym_r_DQUOTE] = ACTIONS(4963),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4965),
    [anon_sym_shared] = ACTIONS(4965),
    [anon_sym_map_LBRACK] = ACTIONS(4963),
    [anon_sym_chan] = ACTIONS(4965),
    [anon_sym_thread] = ACTIONS(4965),
    [anon_sym_atomic] = ACTIONS(4965),
    [anon_sym_assert] = ACTIONS(4965),
    [anon_sym_defer] = ACTIONS(4965),
    [anon_sym_goto] = ACTIONS(4965),
    [anon_sym_break] = ACTIONS(4965),
    [anon_sym_continue] = ACTIONS(4965),
    [anon_sym_return] = ACTIONS(4965),
    [anon_sym_DOLLARfor] = ACTIONS(4965),
    [anon_sym_for] = ACTIONS(4965),
    [anon_sym_POUND] = ACTIONS(4963),
    [anon_sym_asm] = ACTIONS(4965),
    [anon_sym_AT_LBRACK] = ACTIONS(4963),
  },
  [1918] = {
    [sym_line_comment] = STATE(1918),
    [sym_block_comment] = STATE(1918),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2458),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_as] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(861),
    [anon_sym_COMMA] = ACTIONS(861),
    [anon_sym_LPAREN] = ACTIONS(3968),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_STAR] = ACTIONS(3970),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(861),
    [anon_sym_BANG_EQ] = ACTIONS(861),
    [anon_sym_LT_EQ] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_PLUS_PLUS] = ACTIONS(861),
    [anon_sym_DASH_DASH] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(4953),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_LBRACK2] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(865),
    [anon_sym_GT_GT_GT] = ACTIONS(861),
    [anon_sym_AMP_CARET] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_QMARK_DOT] = ACTIONS(861),
    [anon_sym_POUND_LBRACK] = ACTIONS(861),
    [anon_sym_is] = ACTIONS(865),
    [anon_sym_BANGis] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(865),
    [anon_sym_BANGin] = ACTIONS(861),
    [anon_sym_COLON_EQ] = ACTIONS(861),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [1919] = {
    [sym_line_comment] = STATE(1919),
    [sym_block_comment] = STATE(1919),
    [sym_reference_expression] = STATE(4609),
    [sym_type_reference_expression] = STATE(3649),
    [sym_plain_type] = STATE(2458),
    [sym__plain_type_without_special] = STATE(2416),
    [sym_anon_struct_type] = STATE(2417),
    [sym_multi_return_type] = STATE(2416),
    [sym_result_type] = STATE(2416),
    [sym_option_type] = STATE(2416),
    [sym_qualified_type] = STATE(3649),
    [sym_fixed_array_type] = STATE(2417),
    [sym_array_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_wrong_pointer_type] = STATE(2417),
    [sym_map_type] = STATE(2417),
    [sym_channel_type] = STATE(2417),
    [sym_shared_type] = STATE(2417),
    [sym_thread_type] = STATE(2417),
    [sym_atomic_type] = STATE(2417),
    [sym_generic_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(861),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_as] = ACTIONS(865),
    [anon_sym_COMMA] = ACTIONS(861),
    [anon_sym_LPAREN] = ACTIONS(3968),
    [anon_sym_fn] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_STAR] = ACTIONS(3970),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(861),
    [anon_sym_BANG_EQ] = ACTIONS(861),
    [anon_sym_LT_EQ] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_PLUS_PLUS] = ACTIONS(861),
    [anon_sym_DASH_DASH] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(4967),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_LBRACK2] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(865),
    [anon_sym_GT_GT_GT] = ACTIONS(861),
    [anon_sym_AMP_CARET] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_QMARK_DOT] = ACTIONS(861),
    [anon_sym_POUND_LBRACK] = ACTIONS(861),
    [anon_sym_is] = ACTIONS(865),
    [anon_sym_BANGis] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(865),
    [anon_sym_BANGin] = ACTIONS(861),
    [anon_sym_COLON_EQ] = ACTIONS(861),
    [anon_sym_shared] = ACTIONS(881),
    [anon_sym_map_LBRACK] = ACTIONS(97),
    [anon_sym_chan] = ACTIONS(99),
    [anon_sym_thread] = ACTIONS(101),
    [anon_sym_atomic] = ACTIONS(103),
  },
  [1920] = {
    [sym_line_comment] = STATE(1920),
    [sym_block_comment] = STATE(1920),
    [ts_builtin_sym_end] = ACTIONS(4969),
    [sym_identifier] = ACTIONS(4971),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(4971),
    [anon_sym_DOT] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(4969),
    [anon_sym_const] = ACTIONS(4971),
    [anon_sym_LPAREN] = ACTIONS(4969),
    [anon_sym___global] = ACTIONS(4971),
    [anon_sym_type] = ACTIONS(4971),
    [anon_sym_fn] = ACTIONS(4971),
    [anon_sym_PLUS] = ACTIONS(4969),
    [anon_sym_DASH] = ACTIONS(4969),
    [anon_sym_STAR] = ACTIONS(4969),
    [anon_sym_struct] = ACTIONS(4971),
    [anon_sym_union] = ACTIONS(4971),
    [anon_sym_pub] = ACTIONS(4971),
    [anon_sym_mut] = ACTIONS(4971),
    [anon_sym_enum] = ACTIONS(4971),
    [anon_sym_interface] = ACTIONS(4971),
    [anon_sym_QMARK] = ACTIONS(4969),
    [anon_sym_BANG] = ACTIONS(4969),
    [anon_sym_go] = ACTIONS(4971),
    [anon_sym_spawn] = ACTIONS(4971),
    [anon_sym_json_DOTdecode] = ACTIONS(4969),
    [anon_sym_LBRACK2] = ACTIONS(4969),
    [anon_sym_TILDE] = ACTIONS(4969),
    [anon_sym_CARET] = ACTIONS(4969),
    [anon_sym_AMP] = ACTIONS(4969),
    [anon_sym_LT_DASH] = ACTIONS(4969),
    [sym_none] = ACTIONS(4971),
    [sym_true] = ACTIONS(4971),
    [sym_false] = ACTIONS(4971),
    [sym_nil] = ACTIONS(4971),
    [anon_sym_if] = ACTIONS(4971),
    [anon_sym_DOLLARif] = ACTIONS(4971),
    [anon_sym_match] = ACTIONS(4971),
    [anon_sym_select] = ACTIONS(4971),
    [anon_sym_lock] = ACTIONS(4971),
    [anon_sym_rlock] = ACTIONS(4971),
    [anon_sym_unsafe] = ACTIONS(4971),
    [anon_sym_sql] = ACTIONS(4971),
    [sym_int_literal] = ACTIONS(4971),
    [sym_float_literal] = ACTIONS(4969),
    [sym_rune_literal] = ACTIONS(4969),
    [anon_sym_SQUOTE] = ACTIONS(4969),
    [anon_sym_DQUOTE] = ACTIONS(4969),
    [anon_sym_c_SQUOTE] = ACTIONS(4969),
    [anon_sym_c_DQUOTE] = ACTIONS(4969),
    [anon_sym_r_SQUOTE] = ACTIONS(4969),
    [anon_sym_r_DQUOTE] = ACTIONS(4969),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4971),
    [anon_sym_shared] = ACTIONS(4971),
    [anon_sym_map_LBRACK] = ACTIONS(4969),
    [anon_sym_chan] = ACTIONS(4971),
    [anon_sym_thread] = ACTIONS(4971),
    [anon_sym_atomic] = ACTIONS(4971),
    [anon_sym_assert] = ACTIONS(4971),
    [anon_sym_defer] = ACTIONS(4971),
    [anon_sym_goto] = ACTIONS(4971),
    [anon_sym_break] = ACTIONS(4971),
    [anon_sym_continue] = ACTIONS(4971),
    [anon_sym_return] = ACTIONS(4971),
    [anon_sym_DOLLARfor] = ACTIONS(4971),
    [anon_sym_for] = ACTIONS(4971),
    [anon_sym_POUND] = ACTIONS(4969),
    [anon_sym_asm] = ACTIONS(4971),
    [anon_sym_AT_LBRACK] = ACTIONS(4969),
  },
  [1921] = {
    [sym_line_comment] = STATE(1921),
    [sym_block_comment] = STATE(1921),
    [ts_builtin_sym_end] = ACTIONS(4973),
    [sym_identifier] = ACTIONS(4975),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(4975),
    [anon_sym_DOT] = ACTIONS(4975),
    [anon_sym_LBRACE] = ACTIONS(4973),
    [anon_sym_const] = ACTIONS(4975),
    [anon_sym_LPAREN] = ACTIONS(4973),
    [anon_sym___global] = ACTIONS(4975),
    [anon_sym_type] = ACTIONS(4975),
    [anon_sym_fn] = ACTIONS(4975),
    [anon_sym_PLUS] = ACTIONS(4973),
    [anon_sym_DASH] = ACTIONS(4973),
    [anon_sym_STAR] = ACTIONS(4973),
    [anon_sym_struct] = ACTIONS(4975),
    [anon_sym_union] = ACTIONS(4975),
    [anon_sym_pub] = ACTIONS(4975),
    [anon_sym_mut] = ACTIONS(4975),
    [anon_sym_enum] = ACTIONS(4975),
    [anon_sym_interface] = ACTIONS(4975),
    [anon_sym_QMARK] = ACTIONS(4973),
    [anon_sym_BANG] = ACTIONS(4973),
    [anon_sym_go] = ACTIONS(4975),
    [anon_sym_spawn] = ACTIONS(4975),
    [anon_sym_json_DOTdecode] = ACTIONS(4973),
    [anon_sym_LBRACK2] = ACTIONS(4973),
    [anon_sym_TILDE] = ACTIONS(4973),
    [anon_sym_CARET] = ACTIONS(4973),
    [anon_sym_AMP] = ACTIONS(4973),
    [anon_sym_LT_DASH] = ACTIONS(4973),
    [sym_none] = ACTIONS(4975),
    [sym_true] = ACTIONS(4975),
    [sym_false] = ACTIONS(4975),
    [sym_nil] = ACTIONS(4975),
    [anon_sym_if] = ACTIONS(4975),
    [anon_sym_DOLLARif] = ACTIONS(4975),
    [anon_sym_match] = ACTIONS(4975),
    [anon_sym_select] = ACTIONS(4975),
    [anon_sym_lock] = ACTIONS(4975),
    [anon_sym_rlock] = ACTIONS(4975),
    [anon_sym_unsafe] = ACTIONS(4975),
    [anon_sym_sql] = ACTIONS(4975),
    [sym_int_literal] = ACTIONS(4975),
    [sym_float_literal] = ACTIONS(4973),
    [sym_rune_literal] = ACTIONS(4973),
    [anon_sym_SQUOTE] = ACTIONS(4973),
    [anon_sym_DQUOTE] = ACTIONS(4973),
    [anon_sym_c_SQUOTE] = ACTIONS(4973),
    [anon_sym_c_DQUOTE] = ACTIONS(4973),
    [anon_sym_r_SQUOTE] = ACTIONS(4973),
    [anon_sym_r_DQUOTE] = ACTIONS(4973),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4975),
    [anon_sym_shared] = ACTIONS(4975),
    [anon_sym_map_LBRACK] = ACTIONS(4973),
    [anon_sym_chan] = ACTIONS(4975),
    [anon_sym_thread] = ACTIONS(4975),
    [anon_sym_atomic] = ACTIONS(4975),
    [anon_sym_assert] = ACTIONS(4975),
    [anon_sym_defer] = ACTIONS(4975),
    [anon_sym_goto] = ACTIONS(4975),
    [anon_sym_break] = ACTIONS(4975),
    [anon_sym_continue] = ACTIONS(4975),
    [anon_sym_return] = ACTIONS(4975),
    [anon_sym_DOLLARfor] = ACTIONS(4975),
    [anon_sym_for] = ACTIONS(4975),
    [anon_sym_POUND] = ACTIONS(4973),
    [anon_sym_asm] = ACTIONS(4975),
    [anon_sym_AT_LBRACK] = ACTIONS(4973),
  },
  [1922] = {
    [sym_line_comment] = STATE(1922),
    [sym_block_comment] = STATE(1922),
    [ts_builtin_sym_end] = ACTIONS(4977),
    [sym_identifier] = ACTIONS(4979),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(4979),
    [anon_sym_DOT] = ACTIONS(4979),
    [anon_sym_LBRACE] = ACTIONS(4977),
    [anon_sym_const] = ACTIONS(4979),
    [anon_sym_LPAREN] = ACTIONS(4977),
    [anon_sym___global] = ACTIONS(4979),
    [anon_sym_type] = ACTIONS(4979),
    [anon_sym_fn] = ACTIONS(4979),
    [anon_sym_PLUS] = ACTIONS(4977),
    [anon_sym_DASH] = ACTIONS(4977),
    [anon_sym_STAR] = ACTIONS(4977),
    [anon_sym_struct] = ACTIONS(4979),
    [anon_sym_union] = ACTIONS(4979),
    [anon_sym_pub] = ACTIONS(4979),
    [anon_sym_mut] = ACTIONS(4979),
    [anon_sym_enum] = ACTIONS(4979),
    [anon_sym_interface] = ACTIONS(4979),
    [anon_sym_QMARK] = ACTIONS(4977),
    [anon_sym_BANG] = ACTIONS(4977),
    [anon_sym_go] = ACTIONS(4979),
    [anon_sym_spawn] = ACTIONS(4979),
    [anon_sym_json_DOTdecode] = ACTIONS(4977),
    [anon_sym_LBRACK2] = ACTIONS(4977),
    [anon_sym_TILDE] = ACTIONS(4977),
    [anon_sym_CARET] = ACTIONS(4977),
    [anon_sym_AMP] = ACTIONS(4977),
    [anon_sym_LT_DASH] = ACTIONS(4977),
    [sym_none] = ACTIONS(4979),
    [sym_true] = ACTIONS(4979),
    [sym_false] = ACTIONS(4979),
    [sym_nil] = ACTIONS(4979),
    [anon_sym_if] = ACTIONS(4979),
    [anon_sym_DOLLARif] = ACTIONS(4979),
    [anon_sym_match] = ACTIONS(4979),
    [anon_sym_select] = ACTIONS(4979),
    [anon_sym_lock] = ACTIONS(4979),
    [anon_sym_rlock] = ACTIONS(4979),
    [anon_sym_unsafe] = ACTIONS(4979),
    [anon_sym_sql] = ACTIONS(4979),
    [sym_int_literal] = ACTIONS(4979),
    [sym_float_literal] = ACTIONS(4977),
    [sym_rune_literal] = ACTIONS(4977),
    [anon_sym_SQUOTE] = ACTIONS(4977),
    [anon_sym_DQUOTE] = ACTIONS(4977),
    [anon_sym_c_SQUOTE] = ACTIONS(4977),
    [anon_sym_c_DQUOTE] = ACTIONS(4977),
    [anon_sym_r_SQUOTE] = ACTIONS(4977),
    [anon_sym_r_DQUOTE] = ACTIONS(4977),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4979),
    [anon_sym_shared] = ACTIONS(4979),
    [anon_sym_map_LBRACK] = ACTIONS(4977),
    [anon_sym_chan] = ACTIONS(4979),
    [anon_sym_thread] = ACTIONS(4979),
    [anon_sym_atomic] = ACTIONS(4979),
    [anon_sym_assert] = ACTIONS(4979),
    [anon_sym_defer] = ACTIONS(4979),
    [anon_sym_goto] = ACTIONS(4979),
    [anon_sym_break] = ACTIONS(4979),
    [anon_sym_continue] = ACTIONS(4979),
    [anon_sym_return] = ACTIONS(4979),
    [anon_sym_DOLLARfor] = ACTIONS(4979),
    [anon_sym_for] = ACTIONS(4979),
    [anon_sym_POUND] = ACTIONS(4977),
    [anon_sym_asm] = ACTIONS(4979),
    [anon_sym_AT_LBRACK] = ACTIONS(4977),
  },
  [1923] = {
    [sym_line_comment] = STATE(1923),
    [sym_block_comment] = STATE(1923),
    [ts_builtin_sym_end] = ACTIONS(137),
    [sym_identifier] = ACTIONS(4981),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(4981),
    [anon_sym_LBRACE] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(4981),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym___global] = ACTIONS(4981),
    [anon_sym_type] = ACTIONS(4981),
    [anon_sym_fn] = ACTIONS(4981),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_struct] = ACTIONS(4981),
    [anon_sym_union] = ACTIONS(4981),
    [anon_sym_pub] = ACTIONS(4981),
    [anon_sym_mut] = ACTIONS(4981),
    [anon_sym_enum] = ACTIONS(4981),
    [anon_sym_interface] = ACTIONS(4981),
    [anon_sym_QMARK] = ACTIONS(137),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_go] = ACTIONS(4981),
    [anon_sym_spawn] = ACTIONS(4981),
    [anon_sym_json_DOTdecode] = ACTIONS(137),
    [anon_sym_LBRACK2] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_LT_DASH] = ACTIONS(137),
    [sym_none] = ACTIONS(4981),
    [sym_true] = ACTIONS(4981),
    [sym_false] = ACTIONS(4981),
    [sym_nil] = ACTIONS(4981),
    [anon_sym_if] = ACTIONS(4981),
    [anon_sym_DOLLARif] = ACTIONS(4981),
    [anon_sym_match] = ACTIONS(4981),
    [anon_sym_select] = ACTIONS(4981),
    [anon_sym_lock] = ACTIONS(4981),
    [anon_sym_rlock] = ACTIONS(4981),
    [anon_sym_unsafe] = ACTIONS(4981),
    [anon_sym_sql] = ACTIONS(4981),
    [sym_int_literal] = ACTIONS(4981),
    [sym_float_literal] = ACTIONS(137),
    [sym_rune_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [anon_sym_c_SQUOTE] = ACTIONS(137),
    [anon_sym_c_DQUOTE] = ACTIONS(137),
    [anon_sym_r_SQUOTE] = ACTIONS(137),
    [anon_sym_r_DQUOTE] = ACTIONS(137),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4981),
    [anon_sym_shared] = ACTIONS(4981),
    [anon_sym_map_LBRACK] = ACTIONS(137),
    [anon_sym_chan] = ACTIONS(4981),
    [anon_sym_thread] = ACTIONS(4981),
    [anon_sym_atomic] = ACTIONS(4981),
    [anon_sym_assert] = ACTIONS(4981),
    [anon_sym_defer] = ACTIONS(4981),
    [anon_sym_goto] = ACTIONS(4981),
    [anon_sym_break] = ACTIONS(4981),
    [anon_sym_continue] = ACTIONS(4981),
    [anon_sym_return] = ACTIONS(4981),
    [anon_sym_DOLLARfor] = ACTIONS(4981),
    [anon_sym_for] = ACTIONS(4981),
    [anon_sym_POUND] = ACTIONS(137),
    [anon_sym_asm] = ACTIONS(4981),
    [anon_sym_AT_LBRACK] = ACTIONS(137),
  },
  [1924] = {
    [sym_line_comment] = STATE(1924),
    [sym_block_comment] = STATE(1924),
    [aux_sym_strictly_expression_list_repeat1] = STATE(1925),
    [sym_identifier] = ACTIONS(4430),
    [anon_sym_LF] = ACTIONS(4430),
    [anon_sym_CR] = ACTIONS(4430),
    [anon_sym_CR_LF] = ACTIONS(4430),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4430),
    [anon_sym_DOT] = ACTIONS(4430),
    [anon_sym_LBRACE] = ACTIONS(4430),
    [anon_sym_COMMA] = ACTIONS(3984),
    [anon_sym_RBRACE] = ACTIONS(4430),
    [anon_sym_LPAREN] = ACTIONS(4430),
    [anon_sym_fn] = ACTIONS(4430),
    [anon_sym_PLUS] = ACTIONS(4430),
    [anon_sym_DASH] = ACTIONS(4430),
    [anon_sym_STAR] = ACTIONS(4430),
    [anon_sym_struct] = ACTIONS(4430),
    [anon_sym_mut] = ACTIONS(4430),
    [anon_sym_QMARK] = ACTIONS(4430),
    [anon_sym_BANG] = ACTIONS(4430),
    [anon_sym_go] = ACTIONS(4430),
    [anon_sym_spawn] = ACTIONS(4430),
    [anon_sym_json_DOTdecode] = ACTIONS(4430),
    [anon_sym_LBRACK2] = ACTIONS(4430),
    [anon_sym_TILDE] = ACTIONS(4430),
    [anon_sym_CARET] = ACTIONS(4430),
    [anon_sym_AMP] = ACTIONS(4430),
    [anon_sym_LT_DASH] = ACTIONS(4430),
    [sym_none] = ACTIONS(4430),
    [sym_true] = ACTIONS(4430),
    [sym_false] = ACTIONS(4430),
    [sym_nil] = ACTIONS(4430),
    [anon_sym_if] = ACTIONS(4430),
    [anon_sym_DOLLARif] = ACTIONS(4430),
    [anon_sym_match] = ACTIONS(4430),
    [anon_sym_select] = ACTIONS(4430),
    [anon_sym_lock] = ACTIONS(4430),
    [anon_sym_rlock] = ACTIONS(4430),
    [anon_sym_unsafe] = ACTIONS(4430),
    [anon_sym_sql] = ACTIONS(4430),
    [sym_int_literal] = ACTIONS(4430),
    [sym_float_literal] = ACTIONS(4430),
    [sym_rune_literal] = ACTIONS(4430),
    [anon_sym_SQUOTE] = ACTIONS(4430),
    [anon_sym_DQUOTE] = ACTIONS(4430),
    [anon_sym_c_SQUOTE] = ACTIONS(4430),
    [anon_sym_c_DQUOTE] = ACTIONS(4430),
    [anon_sym_r_SQUOTE] = ACTIONS(4430),
    [anon_sym_r_DQUOTE] = ACTIONS(4430),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4430),
    [anon_sym_shared] = ACTIONS(4430),
    [anon_sym_map_LBRACK] = ACTIONS(4430),
    [anon_sym_chan] = ACTIONS(4430),
    [anon_sym_thread] = ACTIONS(4430),
    [anon_sym_atomic] = ACTIONS(4430),
    [anon_sym_assert] = ACTIONS(4430),
    [anon_sym_defer] = ACTIONS(4430),
    [anon_sym_goto] = ACTIONS(4430),
    [anon_sym_break] = ACTIONS(4430),
    [anon_sym_continue] = ACTIONS(4430),
    [anon_sym_return] = ACTIONS(4430),
    [anon_sym_DOLLARfor] = ACTIONS(4430),
    [anon_sym_for] = ACTIONS(4430),
    [anon_sym_POUND] = ACTIONS(4430),
    [anon_sym_asm] = ACTIONS(4430),
  },
  [1925] = {
    [sym_line_comment] = STATE(1925),
    [sym_block_comment] = STATE(1925),
    [aux_sym_strictly_expression_list_repeat1] = STATE(1925),
    [sym_identifier] = ACTIONS(2001),
    [anon_sym_LF] = ACTIONS(2001),
    [anon_sym_CR] = ACTIONS(2001),
    [anon_sym_CR_LF] = ACTIONS(2001),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2001),
    [anon_sym_DOT] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(4983),
    [anon_sym_RBRACE] = ACTIONS(2001),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [anon_sym_fn] = ACTIONS(2001),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_struct] = ACTIONS(2001),
    [anon_sym_mut] = ACTIONS(2001),
    [anon_sym_QMARK] = ACTIONS(2001),
    [anon_sym_BANG] = ACTIONS(2001),
    [anon_sym_go] = ACTIONS(2001),
    [anon_sym_spawn] = ACTIONS(2001),
    [anon_sym_json_DOTdecode] = ACTIONS(2001),
    [anon_sym_LBRACK2] = ACTIONS(2001),
    [anon_sym_TILDE] = ACTIONS(2001),
    [anon_sym_CARET] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_LT_DASH] = ACTIONS(2001),
    [sym_none] = ACTIONS(2001),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_nil] = ACTIONS(2001),
    [anon_sym_if] = ACTIONS(2001),
    [anon_sym_DOLLARif] = ACTIONS(2001),
    [anon_sym_match] = ACTIONS(2001),
    [anon_sym_select] = ACTIONS(2001),
    [anon_sym_lock] = ACTIONS(2001),
    [anon_sym_rlock] = ACTIONS(2001),
    [anon_sym_unsafe] = ACTIONS(2001),
    [anon_sym_sql] = ACTIONS(2001),
    [sym_int_literal] = ACTIONS(2001),
    [sym_float_literal] = ACTIONS(2001),
    [sym_rune_literal] = ACTIONS(2001),
    [anon_sym_SQUOTE] = ACTIONS(2001),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_c_SQUOTE] = ACTIONS(2001),
    [anon_sym_c_DQUOTE] = ACTIONS(2001),
    [anon_sym_r_SQUOTE] = ACTIONS(2001),
    [anon_sym_r_DQUOTE] = ACTIONS(2001),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2001),
    [anon_sym_shared] = ACTIONS(2001),
    [anon_sym_map_LBRACK] = ACTIONS(2001),
    [anon_sym_chan] = ACTIONS(2001),
    [anon_sym_thread] = ACTIONS(2001),
    [anon_sym_atomic] = ACTIONS(2001),
    [anon_sym_assert] = ACTIONS(2001),
    [anon_sym_defer] = ACTIONS(2001),
    [anon_sym_goto] = ACTIONS(2001),
    [anon_sym_break] = ACTIONS(2001),
    [anon_sym_continue] = ACTIONS(2001),
    [anon_sym_return] = ACTIONS(2001),
    [anon_sym_DOLLARfor] = ACTIONS(2001),
    [anon_sym_for] = ACTIONS(2001),
    [anon_sym_POUND] = ACTIONS(2001),
    [anon_sym_asm] = ACTIONS(2001),
  },
  [1926] = {
    [sym_line_comment] = STATE(1926),
    [sym_block_comment] = STATE(1926),
    [aux_sym_strictly_expression_list_repeat1] = STATE(1927),
    [sym_identifier] = ACTIONS(2041),
    [anon_sym_LF] = ACTIONS(2041),
    [anon_sym_CR] = ACTIONS(2041),
    [anon_sym_CR_LF] = ACTIONS(2041),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2041),
    [anon_sym_DOT] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2041),
    [anon_sym_COMMA] = ACTIONS(3984),
    [anon_sym_RBRACE] = ACTIONS(2041),
    [anon_sym_LPAREN] = ACTIONS(2041),
    [anon_sym_fn] = ACTIONS(2041),
    [anon_sym_PLUS] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_struct] = ACTIONS(2041),
    [anon_sym_mut] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2041),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_go] = ACTIONS(2041),
    [anon_sym_spawn] = ACTIONS(2041),
    [anon_sym_json_DOTdecode] = ACTIONS(2041),
    [anon_sym_LBRACK2] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT_DASH] = ACTIONS(2041),
    [sym_none] = ACTIONS(2041),
    [sym_true] = ACTIONS(2041),
    [sym_false] = ACTIONS(2041),
    [sym_nil] = ACTIONS(2041),
    [anon_sym_if] = ACTIONS(2041),
    [anon_sym_DOLLARif] = ACTIONS(2041),
    [anon_sym_match] = ACTIONS(2041),
    [anon_sym_select] = ACTIONS(2041),
    [anon_sym_lock] = ACTIONS(2041),
    [anon_sym_rlock] = ACTIONS(2041),
    [anon_sym_unsafe] = ACTIONS(2041),
    [anon_sym_sql] = ACTIONS(2041),
    [sym_int_literal] = ACTIONS(2041),
    [sym_float_literal] = ACTIONS(2041),
    [sym_rune_literal] = ACTIONS(2041),
    [anon_sym_SQUOTE] = ACTIONS(2041),
    [anon_sym_DQUOTE] = ACTIONS(2041),
    [anon_sym_c_SQUOTE] = ACTIONS(2041),
    [anon_sym_c_DQUOTE] = ACTIONS(2041),
    [anon_sym_r_SQUOTE] = ACTIONS(2041),
    [anon_sym_r_DQUOTE] = ACTIONS(2041),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2041),
    [anon_sym_shared] = ACTIONS(2041),
    [anon_sym_map_LBRACK] = ACTIONS(2041),
    [anon_sym_chan] = ACTIONS(2041),
    [anon_sym_thread] = ACTIONS(2041),
    [anon_sym_atomic] = ACTIONS(2041),
    [anon_sym_assert] = ACTIONS(2041),
    [anon_sym_defer] = ACTIONS(2041),
    [anon_sym_goto] = ACTIONS(2041),
    [anon_sym_break] = ACTIONS(2041),
    [anon_sym_continue] = ACTIONS(2041),
    [anon_sym_return] = ACTIONS(2041),
    [anon_sym_DOLLARfor] = ACTIONS(2041),
    [anon_sym_for] = ACTIONS(2041),
    [anon_sym_POUND] = ACTIONS(2041),
    [anon_sym_asm] = ACTIONS(2041),
  },
  [1927] = {
    [sym_line_comment] = STATE(1927),
    [sym_block_comment] = STATE(1927),
    [aux_sym_strictly_expression_list_repeat1] = STATE(1925),
    [sym_identifier] = ACTIONS(4426),
    [anon_sym_LF] = ACTIONS(4426),
    [anon_sym_CR] = ACTIONS(4426),
    [anon_sym_CR_LF] = ACTIONS(4426),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4426),
    [anon_sym_DOT] = ACTIONS(4426),
    [anon_sym_LBRACE] = ACTIONS(4426),
    [anon_sym_COMMA] = ACTIONS(3984),
    [anon_sym_RBRACE] = ACTIONS(4426),
    [anon_sym_LPAREN] = ACTIONS(4426),
    [anon_sym_fn] = ACTIONS(4426),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_DASH] = ACTIONS(4426),
    [anon_sym_STAR] = ACTIONS(4426),
    [anon_sym_struct] = ACTIONS(4426),
    [anon_sym_mut] = ACTIONS(4426),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_BANG] = ACTIONS(4426),
    [anon_sym_go] = ACTIONS(4426),
    [anon_sym_spawn] = ACTIONS(4426),
    [anon_sym_json_DOTdecode] = ACTIONS(4426),
    [anon_sym_LBRACK2] = ACTIONS(4426),
    [anon_sym_TILDE] = ACTIONS(4426),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4426),
    [anon_sym_LT_DASH] = ACTIONS(4426),
    [sym_none] = ACTIONS(4426),
    [sym_true] = ACTIONS(4426),
    [sym_false] = ACTIONS(4426),
    [sym_nil] = ACTIONS(4426),
    [anon_sym_if] = ACTIONS(4426),
    [anon_sym_DOLLARif] = ACTIONS(4426),
    [anon_sym_match] = ACTIONS(4426),
    [anon_sym_select] = ACTIONS(4426),
    [anon_sym_lock] = ACTIONS(4426),
    [anon_sym_rlock] = ACTIONS(4426),
    [anon_sym_unsafe] = ACTIONS(4426),
    [anon_sym_sql] = ACTIONS(4426),
    [sym_int_literal] = ACTIONS(4426),
    [sym_float_literal] = ACTIONS(4426),
    [sym_rune_literal] = ACTIONS(4426),
    [anon_sym_SQUOTE] = ACTIONS(4426),
    [anon_sym_DQUOTE] = ACTIONS(4426),
    [anon_sym_c_SQUOTE] = ACTIONS(4426),
    [anon_sym_c_DQUOTE] = ACTIONS(4426),
    [anon_sym_r_SQUOTE] = ACTIONS(4426),
    [anon_sym_r_DQUOTE] = ACTIONS(4426),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4426),
    [anon_sym_shared] = ACTIONS(4426),
    [anon_sym_map_LBRACK] = ACTIONS(4426),
    [anon_sym_chan] = ACTIONS(4426),
    [anon_sym_thread] = ACTIONS(4426),
    [anon_sym_atomic] = ACTIONS(4426),
    [anon_sym_assert] = ACTIONS(4426),
    [anon_sym_defer] = ACTIONS(4426),
    [anon_sym_goto] = ACTIONS(4426),
    [anon_sym_break] = ACTIONS(4426),
    [anon_sym_continue] = ACTIONS(4426),
    [anon_sym_return] = ACTIONS(4426),
    [anon_sym_DOLLARfor] = ACTIONS(4426),
    [anon_sym_for] = ACTIONS(4426),
    [anon_sym_POUND] = ACTIONS(4426),
    [anon_sym_asm] = ACTIONS(4426),
  },
  [1928] = {
    [sym_line_comment] = STATE(1928),
    [sym_block_comment] = STATE(1928),
    [sym_label_reference] = STATE(1942),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LF] = ACTIONS(4526),
    [anon_sym_CR] = ACTIONS(4526),
    [anon_sym_CR_LF] = ACTIONS(4526),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4526),
    [anon_sym_DOT] = ACTIONS(4526),
    [anon_sym_LBRACE] = ACTIONS(4526),
    [anon_sym_RBRACE] = ACTIONS(4526),
    [anon_sym_LPAREN] = ACTIONS(4526),
    [anon_sym_fn] = ACTIONS(4526),
    [anon_sym_PLUS] = ACTIONS(4526),
    [anon_sym_DASH] = ACTIONS(4526),
    [anon_sym_STAR] = ACTIONS(4526),
    [anon_sym_struct] = ACTIONS(4526),
    [anon_sym_mut] = ACTIONS(4526),
    [anon_sym_QMARK] = ACTIONS(4526),
    [anon_sym_BANG] = ACTIONS(4526),
    [anon_sym_go] = ACTIONS(4526),
    [anon_sym_spawn] = ACTIONS(4526),
    [anon_sym_json_DOTdecode] = ACTIONS(4526),
    [anon_sym_LBRACK2] = ACTIONS(4526),
    [anon_sym_TILDE] = ACTIONS(4526),
    [anon_sym_CARET] = ACTIONS(4526),
    [anon_sym_AMP] = ACTIONS(4526),
    [anon_sym_LT_DASH] = ACTIONS(4526),
    [sym_none] = ACTIONS(4526),
    [sym_true] = ACTIONS(4526),
    [sym_false] = ACTIONS(4526),
    [sym_nil] = ACTIONS(4526),
    [anon_sym_if] = ACTIONS(4526),
    [anon_sym_DOLLARif] = ACTIONS(4526),
    [anon_sym_match] = ACTIONS(4526),
    [anon_sym_select] = ACTIONS(4526),
    [anon_sym_lock] = ACTIONS(4526),
    [anon_sym_rlock] = ACTIONS(4526),
    [anon_sym_unsafe] = ACTIONS(4526),
    [anon_sym_sql] = ACTIONS(4526),
    [sym_int_literal] = ACTIONS(4526),
    [sym_float_literal] = ACTIONS(4526),
    [sym_rune_literal] = ACTIONS(4526),
    [anon_sym_SQUOTE] = ACTIONS(4526),
    [anon_sym_DQUOTE] = ACTIONS(4526),
    [anon_sym_c_SQUOTE] = ACTIONS(4526),
    [anon_sym_c_DQUOTE] = ACTIONS(4526),
    [anon_sym_r_SQUOTE] = ACTIONS(4526),
    [anon_sym_r_DQUOTE] = ACTIONS(4526),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4526),
    [anon_sym_shared] = ACTIONS(4526),
    [anon_sym_map_LBRACK] = ACTIONS(4526),
    [anon_sym_chan] = ACTIONS(4526),
    [anon_sym_thread] = ACTIONS(4526),
    [anon_sym_atomic] = ACTIONS(4526),
    [anon_sym_assert] = ACTIONS(4526),
    [anon_sym_defer] = ACTIONS(4526),
    [anon_sym_goto] = ACTIONS(4526),
    [anon_sym_break] = ACTIONS(4526),
    [anon_sym_continue] = ACTIONS(4526),
    [anon_sym_return] = ACTIONS(4526),
    [anon_sym_DOLLARfor] = ACTIONS(4526),
    [anon_sym_for] = ACTIONS(4526),
    [anon_sym_POUND] = ACTIONS(4526),
    [anon_sym_asm] = ACTIONS(4526),
  },
  [1929] = {
    [sym_line_comment] = STATE(1929),
    [sym_block_comment] = STATE(1929),
    [sym_label_reference] = STATE(1938),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LF] = ACTIONS(4534),
    [anon_sym_CR] = ACTIONS(4534),
    [anon_sym_CR_LF] = ACTIONS(4534),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4534),
    [anon_sym_DOT] = ACTIONS(4534),
    [anon_sym_LBRACE] = ACTIONS(4534),
    [anon_sym_RBRACE] = ACTIONS(4534),
    [anon_sym_LPAREN] = ACTIONS(4534),
    [anon_sym_fn] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_DASH] = ACTIONS(4534),
    [anon_sym_STAR] = ACTIONS(4534),
    [anon_sym_struct] = ACTIONS(4534),
    [anon_sym_mut] = ACTIONS(4534),
    [anon_sym_QMARK] = ACTIONS(4534),
    [anon_sym_BANG] = ACTIONS(4534),
    [anon_sym_go] = ACTIONS(4534),
    [anon_sym_spawn] = ACTIONS(4534),
    [anon_sym_json_DOTdecode] = ACTIONS(4534),
    [anon_sym_LBRACK2] = ACTIONS(4534),
    [anon_sym_TILDE] = ACTIONS(4534),
    [anon_sym_CARET] = ACTIONS(4534),
    [anon_sym_AMP] = ACTIONS(4534),
    [anon_sym_LT_DASH] = ACTIONS(4534),
    [sym_none] = ACTIONS(4534),
    [sym_true] = ACTIONS(4534),
    [sym_false] = ACTIONS(4534),
    [sym_nil] = ACTIONS(4534),
    [anon_sym_if] = ACTIONS(4534),
    [anon_sym_DOLLARif] = ACTIONS(4534),
    [anon_sym_match] = ACTIONS(4534),
    [anon_sym_select] = ACTIONS(4534),
    [anon_sym_lock] = ACTIONS(4534),
    [anon_sym_rlock] = ACTIONS(4534),
    [anon_sym_unsafe] = ACTIONS(4534),
    [anon_sym_sql] = ACTIONS(4534),
    [sym_int_literal] = ACTIONS(4534),
    [sym_float_literal] = ACTIONS(4534),
    [sym_rune_literal] = ACTIONS(4534),
    [anon_sym_SQUOTE] = ACTIONS(4534),
    [anon_sym_DQUOTE] = ACTIONS(4534),
    [anon_sym_c_SQUOTE] = ACTIONS(4534),
    [anon_sym_c_DQUOTE] = ACTIONS(4534),
    [anon_sym_r_SQUOTE] = ACTIONS(4534),
    [anon_sym_r_DQUOTE] = ACTIONS(4534),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4534),
    [anon_sym_shared] = ACTIONS(4534),
    [anon_sym_map_LBRACK] = ACTIONS(4534),
    [anon_sym_chan] = ACTIONS(4534),
    [anon_sym_thread] = ACTIONS(4534),
    [anon_sym_atomic] = ACTIONS(4534),
    [anon_sym_assert] = ACTIONS(4534),
    [anon_sym_defer] = ACTIONS(4534),
    [anon_sym_goto] = ACTIONS(4534),
    [anon_sym_break] = ACTIONS(4534),
    [anon_sym_continue] = ACTIONS(4534),
    [anon_sym_return] = ACTIONS(4534),
    [anon_sym_DOLLARfor] = ACTIONS(4534),
    [anon_sym_for] = ACTIONS(4534),
    [anon_sym_POUND] = ACTIONS(4534),
    [anon_sym_asm] = ACTIONS(4534),
  },
  [1930] = {
    [sym_line_comment] = STATE(1930),
    [sym_block_comment] = STATE(1930),
    [sym_identifier] = ACTIONS(2001),
    [anon_sym_LF] = ACTIONS(2001),
    [anon_sym_CR] = ACTIONS(2001),
    [anon_sym_CR_LF] = ACTIONS(2001),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2001),
    [anon_sym_DOT] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(2001),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [anon_sym_fn] = ACTIONS(2001),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_struct] = ACTIONS(2001),
    [anon_sym_mut] = ACTIONS(2001),
    [anon_sym_QMARK] = ACTIONS(2001),
    [anon_sym_BANG] = ACTIONS(2001),
    [anon_sym_go] = ACTIONS(2001),
    [anon_sym_spawn] = ACTIONS(2001),
    [anon_sym_json_DOTdecode] = ACTIONS(2001),
    [anon_sym_LBRACK2] = ACTIONS(2001),
    [anon_sym_TILDE] = ACTIONS(2001),
    [anon_sym_CARET] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_LT_DASH] = ACTIONS(2001),
    [sym_none] = ACTIONS(2001),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_nil] = ACTIONS(2001),
    [anon_sym_if] = ACTIONS(2001),
    [anon_sym_DOLLARif] = ACTIONS(2001),
    [anon_sym_match] = ACTIONS(2001),
    [anon_sym_select] = ACTIONS(2001),
    [anon_sym_lock] = ACTIONS(2001),
    [anon_sym_rlock] = ACTIONS(2001),
    [anon_sym_unsafe] = ACTIONS(2001),
    [anon_sym_sql] = ACTIONS(2001),
    [sym_int_literal] = ACTIONS(2001),
    [sym_float_literal] = ACTIONS(2001),
    [sym_rune_literal] = ACTIONS(2001),
    [anon_sym_SQUOTE] = ACTIONS(2001),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_c_SQUOTE] = ACTIONS(2001),
    [anon_sym_c_DQUOTE] = ACTIONS(2001),
    [anon_sym_r_SQUOTE] = ACTIONS(2001),
    [anon_sym_r_DQUOTE] = ACTIONS(2001),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2001),
    [anon_sym_shared] = ACTIONS(2001),
    [anon_sym_map_LBRACK] = ACTIONS(2001),
    [anon_sym_chan] = ACTIONS(2001),
    [anon_sym_thread] = ACTIONS(2001),
    [anon_sym_atomic] = ACTIONS(2001),
    [anon_sym_assert] = ACTIONS(2001),
    [anon_sym_defer] = ACTIONS(2001),
    [anon_sym_goto] = ACTIONS(2001),
    [anon_sym_break] = ACTIONS(2001),
    [anon_sym_continue] = ACTIONS(2001),
    [anon_sym_return] = ACTIONS(2001),
    [anon_sym_DOLLARfor] = ACTIONS(2001),
    [anon_sym_for] = ACTIONS(2001),
    [anon_sym_POUND] = ACTIONS(2001),
    [anon_sym_asm] = ACTIONS(2001),
  },
  [1931] = {
    [sym_line_comment] = STATE(1931),
    [sym_block_comment] = STATE(1931),
    [sym_identifier] = ACTIONS(4583),
    [anon_sym_LF] = ACTIONS(4583),
    [anon_sym_CR] = ACTIONS(4583),
    [anon_sym_CR_LF] = ACTIONS(4583),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4583),
    [anon_sym_DOT] = ACTIONS(4583),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_RBRACE] = ACTIONS(4583),
    [anon_sym_LPAREN] = ACTIONS(4583),
    [anon_sym_fn] = ACTIONS(4583),
    [anon_sym_PLUS] = ACTIONS(4583),
    [anon_sym_DASH] = ACTIONS(4583),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_struct] = ACTIONS(4583),
    [anon_sym_mut] = ACTIONS(4583),
    [anon_sym_QMARK] = ACTIONS(4583),
    [anon_sym_BANG] = ACTIONS(4583),
    [anon_sym_go] = ACTIONS(4583),
    [anon_sym_spawn] = ACTIONS(4583),
    [anon_sym_json_DOTdecode] = ACTIONS(4583),
    [anon_sym_LBRACK2] = ACTIONS(4583),
    [anon_sym_TILDE] = ACTIONS(4583),
    [anon_sym_CARET] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4583),
    [anon_sym_LT_DASH] = ACTIONS(4583),
    [sym_none] = ACTIONS(4583),
    [sym_true] = ACTIONS(4583),
    [sym_false] = ACTIONS(4583),
    [sym_nil] = ACTIONS(4583),
    [anon_sym_if] = ACTIONS(4583),
    [anon_sym_DOLLARif] = ACTIONS(4583),
    [anon_sym_match] = ACTIONS(4583),
    [anon_sym_select] = ACTIONS(4583),
    [anon_sym_lock] = ACTIONS(4583),
    [anon_sym_rlock] = ACTIONS(4583),
    [anon_sym_unsafe] = ACTIONS(4583),
    [anon_sym_sql] = ACTIONS(4583),
    [sym_int_literal] = ACTIONS(4583),
    [sym_float_literal] = ACTIONS(4583),
    [sym_rune_literal] = ACTIONS(4583),
    [anon_sym_SQUOTE] = ACTIONS(4583),
    [anon_sym_DQUOTE] = ACTIONS(4583),
    [anon_sym_c_SQUOTE] = ACTIONS(4583),
    [anon_sym_c_DQUOTE] = ACTIONS(4583),
    [anon_sym_r_SQUOTE] = ACTIONS(4583),
    [anon_sym_r_DQUOTE] = ACTIONS(4583),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4583),
    [anon_sym_shared] = ACTIONS(4583),
    [anon_sym_map_LBRACK] = ACTIONS(4583),
    [anon_sym_chan] = ACTIONS(4583),
    [anon_sym_thread] = ACTIONS(4583),
    [anon_sym_atomic] = ACTIONS(4583),
    [anon_sym_assert] = ACTIONS(4583),
    [anon_sym_defer] = ACTIONS(4583),
    [anon_sym_goto] = ACTIONS(4583),
    [anon_sym_break] = ACTIONS(4583),
    [anon_sym_continue] = ACTIONS(4583),
    [anon_sym_return] = ACTIONS(4583),
    [anon_sym_DOLLARfor] = ACTIONS(4583),
    [anon_sym_for] = ACTIONS(4583),
    [anon_sym_POUND] = ACTIONS(4583),
    [anon_sym_asm] = ACTIONS(4583),
  },
  [1932] = {
    [sym_line_comment] = STATE(1932),
    [sym_block_comment] = STATE(1932),
    [sym_identifier] = ACTIONS(4988),
    [anon_sym_LF] = ACTIONS(4990),
    [anon_sym_CR] = ACTIONS(4990),
    [anon_sym_CR_LF] = ACTIONS(4990),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4990),
    [anon_sym_DOT] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4988),
    [anon_sym_RBRACE] = ACTIONS(4988),
    [anon_sym_LPAREN] = ACTIONS(4988),
    [anon_sym_fn] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(4988),
    [anon_sym_struct] = ACTIONS(4988),
    [anon_sym_mut] = ACTIONS(4988),
    [anon_sym_QMARK] = ACTIONS(4988),
    [anon_sym_BANG] = ACTIONS(4988),
    [anon_sym_go] = ACTIONS(4988),
    [anon_sym_spawn] = ACTIONS(4988),
    [anon_sym_json_DOTdecode] = ACTIONS(4988),
    [anon_sym_LBRACK2] = ACTIONS(4988),
    [anon_sym_TILDE] = ACTIONS(4988),
    [anon_sym_CARET] = ACTIONS(4988),
    [anon_sym_AMP] = ACTIONS(4988),
    [anon_sym_LT_DASH] = ACTIONS(4988),
    [sym_none] = ACTIONS(4988),
    [sym_true] = ACTIONS(4988),
    [sym_false] = ACTIONS(4988),
    [sym_nil] = ACTIONS(4988),
    [anon_sym_if] = ACTIONS(4988),
    [anon_sym_DOLLARif] = ACTIONS(4988),
    [anon_sym_match] = ACTIONS(4988),
    [anon_sym_select] = ACTIONS(4988),
    [anon_sym_lock] = ACTIONS(4988),
    [anon_sym_rlock] = ACTIONS(4988),
    [anon_sym_unsafe] = ACTIONS(4988),
    [anon_sym_sql] = ACTIONS(4988),
    [sym_int_literal] = ACTIONS(4988),
    [sym_float_literal] = ACTIONS(4988),
    [sym_rune_literal] = ACTIONS(4988),
    [anon_sym_SQUOTE] = ACTIONS(4988),
    [anon_sym_DQUOTE] = ACTIONS(4988),
    [anon_sym_c_SQUOTE] = ACTIONS(4988),
    [anon_sym_c_DQUOTE] = ACTIONS(4988),
    [anon_sym_r_SQUOTE] = ACTIONS(4988),
    [anon_sym_r_DQUOTE] = ACTIONS(4988),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4988),
    [anon_sym_shared] = ACTIONS(4988),
    [anon_sym_map_LBRACK] = ACTIONS(4988),
    [anon_sym_chan] = ACTIONS(4988),
    [anon_sym_thread] = ACTIONS(4988),
    [anon_sym_atomic] = ACTIONS(4988),
    [anon_sym_assert] = ACTIONS(4988),
    [anon_sym_defer] = ACTIONS(4988),
    [anon_sym_goto] = ACTIONS(4988),
    [anon_sym_break] = ACTIONS(4988),
    [anon_sym_continue] = ACTIONS(4988),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_DOLLARfor] = ACTIONS(4988),
    [anon_sym_for] = ACTIONS(4988),
    [anon_sym_POUND] = ACTIONS(4988),
    [anon_sym_asm] = ACTIONS(4988),
  },
  [1933] = {
    [sym_line_comment] = STATE(1933),
    [sym_block_comment] = STATE(1933),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_LF] = ACTIONS(2037),
    [anon_sym_CR] = ACTIONS(2037),
    [anon_sym_CR_LF] = ACTIONS(2037),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2037),
    [anon_sym_DOT] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(2037),
    [anon_sym_RBRACE] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(2037),
    [anon_sym_fn] = ACTIONS(2037),
    [anon_sym_PLUS] = ACTIONS(2037),
    [anon_sym_DASH] = ACTIONS(2037),
    [anon_sym_STAR] = ACTIONS(2037),
    [anon_sym_struct] = ACTIONS(2037),
    [anon_sym_mut] = ACTIONS(2037),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_go] = ACTIONS(2037),
    [anon_sym_spawn] = ACTIONS(2037),
    [anon_sym_json_DOTdecode] = ACTIONS(2037),
    [anon_sym_LBRACK2] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_LT_DASH] = ACTIONS(2037),
    [sym_none] = ACTIONS(2037),
    [sym_true] = ACTIONS(2037),
    [sym_false] = ACTIONS(2037),
    [sym_nil] = ACTIONS(2037),
    [anon_sym_if] = ACTIONS(2037),
    [anon_sym_DOLLARif] = ACTIONS(2037),
    [anon_sym_match] = ACTIONS(2037),
    [anon_sym_select] = ACTIONS(2037),
    [anon_sym_lock] = ACTIONS(2037),
    [anon_sym_rlock] = ACTIONS(2037),
    [anon_sym_unsafe] = ACTIONS(2037),
    [anon_sym_sql] = ACTIONS(2037),
    [sym_int_literal] = ACTIONS(2037),
    [sym_float_literal] = ACTIONS(2037),
    [sym_rune_literal] = ACTIONS(2037),
    [anon_sym_SQUOTE] = ACTIONS(2037),
    [anon_sym_DQUOTE] = ACTIONS(2037),
    [anon_sym_c_SQUOTE] = ACTIONS(2037),
    [anon_sym_c_DQUOTE] = ACTIONS(2037),
    [anon_sym_r_SQUOTE] = ACTIONS(2037),
    [anon_sym_r_DQUOTE] = ACTIONS(2037),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2037),
    [anon_sym_shared] = ACTIONS(2037),
    [anon_sym_map_LBRACK] = ACTIONS(2037),
    [anon_sym_chan] = ACTIONS(2037),
    [anon_sym_thread] = ACTIONS(2037),
    [anon_sym_atomic] = ACTIONS(2037),
    [anon_sym_assert] = ACTIONS(2037),
    [anon_sym_defer] = ACTIONS(2037),
    [anon_sym_goto] = ACTIONS(2037),
    [anon_sym_break] = ACTIONS(2037),
    [anon_sym_continue] = ACTIONS(2037),
    [anon_sym_return] = ACTIONS(2037),
    [anon_sym_DOLLARfor] = ACTIONS(2037),
    [anon_sym_for] = ACTIONS(2037),
    [anon_sym_POUND] = ACTIONS(2037),
    [anon_sym_asm] = ACTIONS(2037),
  },
  [1934] = {
    [sym_line_comment] = STATE(1934),
    [sym_block_comment] = STATE(1934),
    [sym_identifier] = ACTIONS(4647),
    [anon_sym_LF] = ACTIONS(4647),
    [anon_sym_CR] = ACTIONS(4647),
    [anon_sym_CR_LF] = ACTIONS(4647),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4647),
    [anon_sym_DOT] = ACTIONS(4647),
    [anon_sym_LBRACE] = ACTIONS(4647),
    [anon_sym_RBRACE] = ACTIONS(4647),
    [anon_sym_LPAREN] = ACTIONS(4647),
    [anon_sym_fn] = ACTIONS(4647),
    [anon_sym_PLUS] = ACTIONS(4647),
    [anon_sym_DASH] = ACTIONS(4647),
    [anon_sym_STAR] = ACTIONS(4647),
    [anon_sym_struct] = ACTIONS(4647),
    [anon_sym_mut] = ACTIONS(4647),
    [anon_sym_QMARK] = ACTIONS(4647),
    [anon_sym_BANG] = ACTIONS(4647),
    [anon_sym_go] = ACTIONS(4647),
    [anon_sym_spawn] = ACTIONS(4647),
    [anon_sym_json_DOTdecode] = ACTIONS(4647),
    [anon_sym_LBRACK2] = ACTIONS(4647),
    [anon_sym_TILDE] = ACTIONS(4647),
    [anon_sym_CARET] = ACTIONS(4647),
    [anon_sym_AMP] = ACTIONS(4647),
    [anon_sym_LT_DASH] = ACTIONS(4647),
    [sym_none] = ACTIONS(4647),
    [sym_true] = ACTIONS(4647),
    [sym_false] = ACTIONS(4647),
    [sym_nil] = ACTIONS(4647),
    [anon_sym_if] = ACTIONS(4647),
    [anon_sym_DOLLARif] = ACTIONS(4647),
    [anon_sym_match] = ACTIONS(4647),
    [anon_sym_select] = ACTIONS(4647),
    [anon_sym_lock] = ACTIONS(4647),
    [anon_sym_rlock] = ACTIONS(4647),
    [anon_sym_unsafe] = ACTIONS(4647),
    [anon_sym_sql] = ACTIONS(4647),
    [sym_int_literal] = ACTIONS(4647),
    [sym_float_literal] = ACTIONS(4647),
    [sym_rune_literal] = ACTIONS(4647),
    [anon_sym_SQUOTE] = ACTIONS(4647),
    [anon_sym_DQUOTE] = ACTIONS(4647),
    [anon_sym_c_SQUOTE] = ACTIONS(4647),
    [anon_sym_c_DQUOTE] = ACTIONS(4647),
    [anon_sym_r_SQUOTE] = ACTIONS(4647),
    [anon_sym_r_DQUOTE] = ACTIONS(4647),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4647),
    [anon_sym_shared] = ACTIONS(4647),
    [anon_sym_map_LBRACK] = ACTIONS(4647),
    [anon_sym_chan] = ACTIONS(4647),
    [anon_sym_thread] = ACTIONS(4647),
    [anon_sym_atomic] = ACTIONS(4647),
    [anon_sym_assert] = ACTIONS(4647),
    [anon_sym_defer] = ACTIONS(4647),
    [anon_sym_goto] = ACTIONS(4647),
    [anon_sym_break] = ACTIONS(4647),
    [anon_sym_continue] = ACTIONS(4647),
    [anon_sym_return] = ACTIONS(4647),
    [anon_sym_DOLLARfor] = ACTIONS(4647),
    [anon_sym_for] = ACTIONS(4647),
    [anon_sym_POUND] = ACTIONS(4647),
    [anon_sym_asm] = ACTIONS(4647),
  },
  [1935] = {
    [sym_line_comment] = STATE(1935),
    [sym_block_comment] = STATE(1935),
    [sym_identifier] = ACTIONS(4550),
    [anon_sym_LF] = ACTIONS(4550),
    [anon_sym_CR] = ACTIONS(4550),
    [anon_sym_CR_LF] = ACTIONS(4550),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4550),
    [anon_sym_DOT] = ACTIONS(4550),
    [anon_sym_LBRACE] = ACTIONS(4550),
    [anon_sym_RBRACE] = ACTIONS(4550),
    [anon_sym_LPAREN] = ACTIONS(4550),
    [anon_sym_fn] = ACTIONS(4550),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_DASH] = ACTIONS(4550),
    [anon_sym_STAR] = ACTIONS(4550),
    [anon_sym_struct] = ACTIONS(4550),
    [anon_sym_mut] = ACTIONS(4550),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_BANG] = ACTIONS(4550),
    [anon_sym_go] = ACTIONS(4550),
    [anon_sym_spawn] = ACTIONS(4550),
    [anon_sym_json_DOTdecode] = ACTIONS(4550),
    [anon_sym_LBRACK2] = ACTIONS(4550),
    [anon_sym_TILDE] = ACTIONS(4550),
    [anon_sym_CARET] = ACTIONS(4550),
    [anon_sym_AMP] = ACTIONS(4550),
    [anon_sym_LT_DASH] = ACTIONS(4550),
    [sym_none] = ACTIONS(4550),
    [sym_true] = ACTIONS(4550),
    [sym_false] = ACTIONS(4550),
    [sym_nil] = ACTIONS(4550),
    [anon_sym_if] = ACTIONS(4550),
    [anon_sym_DOLLARif] = ACTIONS(4550),
    [anon_sym_match] = ACTIONS(4550),
    [anon_sym_select] = ACTIONS(4550),
    [anon_sym_lock] = ACTIONS(4550),
    [anon_sym_rlock] = ACTIONS(4550),
    [anon_sym_unsafe] = ACTIONS(4550),
    [anon_sym_sql] = ACTIONS(4550),
    [sym_int_literal] = ACTIONS(4550),
    [sym_float_literal] = ACTIONS(4550),
    [sym_rune_literal] = ACTIONS(4550),
    [anon_sym_SQUOTE] = ACTIONS(4550),
    [anon_sym_DQUOTE] = ACTIONS(4550),
    [anon_sym_c_SQUOTE] = ACTIONS(4550),
    [anon_sym_c_DQUOTE] = ACTIONS(4550),
    [anon_sym_r_SQUOTE] = ACTIONS(4550),
    [anon_sym_r_DQUOTE] = ACTIONS(4550),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4550),
    [anon_sym_shared] = ACTIONS(4550),
    [anon_sym_map_LBRACK] = ACTIONS(4550),
    [anon_sym_chan] = ACTIONS(4550),
    [anon_sym_thread] = ACTIONS(4550),
    [anon_sym_atomic] = ACTIONS(4550),
    [anon_sym_assert] = ACTIONS(4550),
    [anon_sym_defer] = ACTIONS(4550),
    [anon_sym_goto] = ACTIONS(4550),
    [anon_sym_break] = ACTIONS(4550),
    [anon_sym_continue] = ACTIONS(4550),
    [anon_sym_return] = ACTIONS(4550),
    [anon_sym_DOLLARfor] = ACTIONS(4550),
    [anon_sym_for] = ACTIONS(4550),
    [anon_sym_POUND] = ACTIONS(4550),
    [anon_sym_asm] = ACTIONS(4550),
  },
  [1936] = {
    [sym_line_comment] = STATE(1936),
    [sym_block_comment] = STATE(1936),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_LF] = ACTIONS(2169),
    [anon_sym_CR] = ACTIONS(2169),
    [anon_sym_CR_LF] = ACTIONS(2169),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_RBRACE] = ACTIONS(2169),
    [anon_sym_LPAREN] = ACTIONS(2169),
    [anon_sym_fn] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_mut] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_go] = ACTIONS(2169),
    [anon_sym_spawn] = ACTIONS(2169),
    [anon_sym_json_DOTdecode] = ACTIONS(2169),
    [anon_sym_LBRACK2] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT_DASH] = ACTIONS(2169),
    [sym_none] = ACTIONS(2169),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [sym_nil] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_DOLLARif] = ACTIONS(2169),
    [anon_sym_match] = ACTIONS(2169),
    [anon_sym_select] = ACTIONS(2169),
    [anon_sym_lock] = ACTIONS(2169),
    [anon_sym_rlock] = ACTIONS(2169),
    [anon_sym_unsafe] = ACTIONS(2169),
    [anon_sym_sql] = ACTIONS(2169),
    [sym_int_literal] = ACTIONS(2169),
    [sym_float_literal] = ACTIONS(2169),
    [sym_rune_literal] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [anon_sym_c_SQUOTE] = ACTIONS(2169),
    [anon_sym_c_DQUOTE] = ACTIONS(2169),
    [anon_sym_r_SQUOTE] = ACTIONS(2169),
    [anon_sym_r_DQUOTE] = ACTIONS(2169),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_map_LBRACK] = ACTIONS(2169),
    [anon_sym_chan] = ACTIONS(2169),
    [anon_sym_thread] = ACTIONS(2169),
    [anon_sym_atomic] = ACTIONS(2169),
    [anon_sym_assert] = ACTIONS(2169),
    [anon_sym_defer] = ACTIONS(2169),
    [anon_sym_goto] = ACTIONS(2169),
    [anon_sym_break] = ACTIONS(2169),
    [anon_sym_continue] = ACTIONS(2169),
    [anon_sym_return] = ACTIONS(2169),
    [anon_sym_DOLLARfor] = ACTIONS(2169),
    [anon_sym_for] = ACTIONS(2169),
    [anon_sym_POUND] = ACTIONS(2169),
    [anon_sym_asm] = ACTIONS(2169),
  },
  [1937] = {
    [sym_line_comment] = STATE(1937),
    [sym_block_comment] = STATE(1937),
    [sym_identifier] = ACTIONS(4619),
    [anon_sym_LF] = ACTIONS(4619),
    [anon_sym_CR] = ACTIONS(4619),
    [anon_sym_CR_LF] = ACTIONS(4619),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4619),
    [anon_sym_DOT] = ACTIONS(4619),
    [anon_sym_LBRACE] = ACTIONS(4619),
    [anon_sym_RBRACE] = ACTIONS(4619),
    [anon_sym_LPAREN] = ACTIONS(4619),
    [anon_sym_fn] = ACTIONS(4619),
    [anon_sym_PLUS] = ACTIONS(4619),
    [anon_sym_DASH] = ACTIONS(4619),
    [anon_sym_STAR] = ACTIONS(4619),
    [anon_sym_struct] = ACTIONS(4619),
    [anon_sym_mut] = ACTIONS(4619),
    [anon_sym_QMARK] = ACTIONS(4619),
    [anon_sym_BANG] = ACTIONS(4619),
    [anon_sym_go] = ACTIONS(4619),
    [anon_sym_spawn] = ACTIONS(4619),
    [anon_sym_json_DOTdecode] = ACTIONS(4619),
    [anon_sym_LBRACK2] = ACTIONS(4619),
    [anon_sym_TILDE] = ACTIONS(4619),
    [anon_sym_CARET] = ACTIONS(4619),
    [anon_sym_AMP] = ACTIONS(4619),
    [anon_sym_LT_DASH] = ACTIONS(4619),
    [sym_none] = ACTIONS(4619),
    [sym_true] = ACTIONS(4619),
    [sym_false] = ACTIONS(4619),
    [sym_nil] = ACTIONS(4619),
    [anon_sym_if] = ACTIONS(4619),
    [anon_sym_DOLLARif] = ACTIONS(4619),
    [anon_sym_match] = ACTIONS(4619),
    [anon_sym_select] = ACTIONS(4619),
    [anon_sym_lock] = ACTIONS(4619),
    [anon_sym_rlock] = ACTIONS(4619),
    [anon_sym_unsafe] = ACTIONS(4619),
    [anon_sym_sql] = ACTIONS(4619),
    [sym_int_literal] = ACTIONS(4619),
    [sym_float_literal] = ACTIONS(4619),
    [sym_rune_literal] = ACTIONS(4619),
    [anon_sym_SQUOTE] = ACTIONS(4619),
    [anon_sym_DQUOTE] = ACTIONS(4619),
    [anon_sym_c_SQUOTE] = ACTIONS(4619),
    [anon_sym_c_DQUOTE] = ACTIONS(4619),
    [anon_sym_r_SQUOTE] = ACTIONS(4619),
    [anon_sym_r_DQUOTE] = ACTIONS(4619),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4619),
    [anon_sym_shared] = ACTIONS(4619),
    [anon_sym_map_LBRACK] = ACTIONS(4619),
    [anon_sym_chan] = ACTIONS(4619),
    [anon_sym_thread] = ACTIONS(4619),
    [anon_sym_atomic] = ACTIONS(4619),
    [anon_sym_assert] = ACTIONS(4619),
    [anon_sym_defer] = ACTIONS(4619),
    [anon_sym_goto] = ACTIONS(4619),
    [anon_sym_break] = ACTIONS(4619),
    [anon_sym_continue] = ACTIONS(4619),
    [anon_sym_return] = ACTIONS(4619),
    [anon_sym_DOLLARfor] = ACTIONS(4619),
    [anon_sym_for] = ACTIONS(4619),
    [anon_sym_POUND] = ACTIONS(4619),
    [anon_sym_asm] = ACTIONS(4619),
  },
  [1938] = {
    [sym_line_comment] = STATE(1938),
    [sym_block_comment] = STATE(1938),
    [sym_identifier] = ACTIONS(4881),
    [anon_sym_LF] = ACTIONS(4881),
    [anon_sym_CR] = ACTIONS(4881),
    [anon_sym_CR_LF] = ACTIONS(4881),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4881),
    [anon_sym_DOT] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(4881),
    [anon_sym_RBRACE] = ACTIONS(4881),
    [anon_sym_LPAREN] = ACTIONS(4881),
    [anon_sym_fn] = ACTIONS(4881),
    [anon_sym_PLUS] = ACTIONS(4881),
    [anon_sym_DASH] = ACTIONS(4881),
    [anon_sym_STAR] = ACTIONS(4881),
    [anon_sym_struct] = ACTIONS(4881),
    [anon_sym_mut] = ACTIONS(4881),
    [anon_sym_QMARK] = ACTIONS(4881),
    [anon_sym_BANG] = ACTIONS(4881),
    [anon_sym_go] = ACTIONS(4881),
    [anon_sym_spawn] = ACTIONS(4881),
    [anon_sym_json_DOTdecode] = ACTIONS(4881),
    [anon_sym_LBRACK2] = ACTIONS(4881),
    [anon_sym_TILDE] = ACTIONS(4881),
    [anon_sym_CARET] = ACTIONS(4881),
    [anon_sym_AMP] = ACTIONS(4881),
    [anon_sym_LT_DASH] = ACTIONS(4881),
    [sym_none] = ACTIONS(4881),
    [sym_true] = ACTIONS(4881),
    [sym_false] = ACTIONS(4881),
    [sym_nil] = ACTIONS(4881),
    [anon_sym_if] = ACTIONS(4881),
    [anon_sym_DOLLARif] = ACTIONS(4881),
    [anon_sym_match] = ACTIONS(4881),
    [anon_sym_select] = ACTIONS(4881),
    [anon_sym_lock] = ACTIONS(4881),
    [anon_sym_rlock] = ACTIONS(4881),
    [anon_sym_unsafe] = ACTIONS(4881),
    [anon_sym_sql] = ACTIONS(4881),
    [sym_int_literal] = ACTIONS(4881),
    [sym_float_literal] = ACTIONS(4881),
    [sym_rune_literal] = ACTIONS(4881),
    [anon_sym_SQUOTE] = ACTIONS(4881),
    [anon_sym_DQUOTE] = ACTIONS(4881),
    [anon_sym_c_SQUOTE] = ACTIONS(4881),
    [anon_sym_c_DQUOTE] = ACTIONS(4881),
    [anon_sym_r_SQUOTE] = ACTIONS(4881),
    [anon_sym_r_DQUOTE] = ACTIONS(4881),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4881),
    [anon_sym_shared] = ACTIONS(4881),
    [anon_sym_map_LBRACK] = ACTIONS(4881),
    [anon_sym_chan] = ACTIONS(4881),
    [anon_sym_thread] = ACTIONS(4881),
    [anon_sym_atomic] = ACTIONS(4881),
    [anon_sym_assert] = ACTIONS(4881),
    [anon_sym_defer] = ACTIONS(4881),
    [anon_sym_goto] = ACTIONS(4881),
    [anon_sym_break] = ACTIONS(4881),
    [anon_sym_continue] = ACTIONS(4881),
    [anon_sym_return] = ACTIONS(4881),
    [anon_sym_DOLLARfor] = ACTIONS(4881),
    [anon_sym_for] = ACTIONS(4881),
    [anon_sym_POUND] = ACTIONS(4881),
    [anon_sym_asm] = ACTIONS(4881),
  },
  [1939] = {
    [sym_line_comment] = STATE(1939),
    [sym_block_comment] = STATE(1939),
    [sym_identifier] = ACTIONS(4851),
    [anon_sym_LF] = ACTIONS(4851),
    [anon_sym_CR] = ACTIONS(4851),
    [anon_sym_CR_LF] = ACTIONS(4851),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4851),
    [anon_sym_DOT] = ACTIONS(4851),
    [anon_sym_LBRACE] = ACTIONS(4851),
    [anon_sym_RBRACE] = ACTIONS(4851),
    [anon_sym_LPAREN] = ACTIONS(4851),
    [anon_sym_fn] = ACTIONS(4851),
    [anon_sym_PLUS] = ACTIONS(4851),
    [anon_sym_DASH] = ACTIONS(4851),
    [anon_sym_STAR] = ACTIONS(4851),
    [anon_sym_struct] = ACTIONS(4851),
    [anon_sym_mut] = ACTIONS(4851),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_BANG] = ACTIONS(4851),
    [anon_sym_go] = ACTIONS(4851),
    [anon_sym_spawn] = ACTIONS(4851),
    [anon_sym_json_DOTdecode] = ACTIONS(4851),
    [anon_sym_LBRACK2] = ACTIONS(4851),
    [anon_sym_TILDE] = ACTIONS(4851),
    [anon_sym_CARET] = ACTIONS(4851),
    [anon_sym_AMP] = ACTIONS(4851),
    [anon_sym_LT_DASH] = ACTIONS(4851),
    [sym_none] = ACTIONS(4851),
    [sym_true] = ACTIONS(4851),
    [sym_false] = ACTIONS(4851),
    [sym_nil] = ACTIONS(4851),
    [anon_sym_if] = ACTIONS(4851),
    [anon_sym_DOLLARif] = ACTIONS(4851),
    [anon_sym_match] = ACTIONS(4851),
    [anon_sym_select] = ACTIONS(4851),
    [anon_sym_lock] = ACTIONS(4851),
    [anon_sym_rlock] = ACTIONS(4851),
    [anon_sym_unsafe] = ACTIONS(4851),
    [anon_sym_sql] = ACTIONS(4851),
    [sym_int_literal] = ACTIONS(4851),
    [sym_float_literal] = ACTIONS(4851),
    [sym_rune_literal] = ACTIONS(4851),
    [anon_sym_SQUOTE] = ACTIONS(4851),
    [anon_sym_DQUOTE] = ACTIONS(4851),
    [anon_sym_c_SQUOTE] = ACTIONS(4851),
    [anon_sym_c_DQUOTE] = ACTIONS(4851),
    [anon_sym_r_SQUOTE] = ACTIONS(4851),
    [anon_sym_r_DQUOTE] = ACTIONS(4851),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4851),
    [anon_sym_shared] = ACTIONS(4851),
    [anon_sym_map_LBRACK] = ACTIONS(4851),
    [anon_sym_chan] = ACTIONS(4851),
    [anon_sym_thread] = ACTIONS(4851),
    [anon_sym_atomic] = ACTIONS(4851),
    [anon_sym_assert] = ACTIONS(4851),
    [anon_sym_defer] = ACTIONS(4851),
    [anon_sym_goto] = ACTIONS(4851),
    [anon_sym_break] = ACTIONS(4851),
    [anon_sym_continue] = ACTIONS(4851),
    [anon_sym_return] = ACTIONS(4851),
    [anon_sym_DOLLARfor] = ACTIONS(4851),
    [anon_sym_for] = ACTIONS(4851),
    [anon_sym_POUND] = ACTIONS(4851),
    [anon_sym_asm] = ACTIONS(4851),
  },
  [1940] = {
    [sym_line_comment] = STATE(1940),
    [sym_block_comment] = STATE(1940),
    [sym_identifier] = ACTIONS(4807),
    [anon_sym_LF] = ACTIONS(4807),
    [anon_sym_CR] = ACTIONS(4807),
    [anon_sym_CR_LF] = ACTIONS(4807),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4807),
    [anon_sym_DOT] = ACTIONS(4807),
    [anon_sym_LBRACE] = ACTIONS(4807),
    [anon_sym_RBRACE] = ACTIONS(4807),
    [anon_sym_LPAREN] = ACTIONS(4807),
    [anon_sym_fn] = ACTIONS(4807),
    [anon_sym_PLUS] = ACTIONS(4807),
    [anon_sym_DASH] = ACTIONS(4807),
    [anon_sym_STAR] = ACTIONS(4807),
    [anon_sym_struct] = ACTIONS(4807),
    [anon_sym_mut] = ACTIONS(4807),
    [anon_sym_QMARK] = ACTIONS(4807),
    [anon_sym_BANG] = ACTIONS(4807),
    [anon_sym_go] = ACTIONS(4807),
    [anon_sym_spawn] = ACTIONS(4807),
    [anon_sym_json_DOTdecode] = ACTIONS(4807),
    [anon_sym_LBRACK2] = ACTIONS(4807),
    [anon_sym_TILDE] = ACTIONS(4807),
    [anon_sym_CARET] = ACTIONS(4807),
    [anon_sym_AMP] = ACTIONS(4807),
    [anon_sym_LT_DASH] = ACTIONS(4807),
    [sym_none] = ACTIONS(4807),
    [sym_true] = ACTIONS(4807),
    [sym_false] = ACTIONS(4807),
    [sym_nil] = ACTIONS(4807),
    [anon_sym_if] = ACTIONS(4807),
    [anon_sym_DOLLARif] = ACTIONS(4807),
    [anon_sym_match] = ACTIONS(4807),
    [anon_sym_select] = ACTIONS(4807),
    [anon_sym_lock] = ACTIONS(4807),
    [anon_sym_rlock] = ACTIONS(4807),
    [anon_sym_unsafe] = ACTIONS(4807),
    [anon_sym_sql] = ACTIONS(4807),
    [sym_int_literal] = ACTIONS(4807),
    [sym_float_literal] = ACTIONS(4807),
    [sym_rune_literal] = ACTIONS(4807),
    [anon_sym_SQUOTE] = ACTIONS(4807),
    [anon_sym_DQUOTE] = ACTIONS(4807),
    [anon_sym_c_SQUOTE] = ACTIONS(4807),
    [anon_sym_c_DQUOTE] = ACTIONS(4807),
    [anon_sym_r_SQUOTE] = ACTIONS(4807),
    [anon_sym_r_DQUOTE] = ACTIONS(4807),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4807),
    [anon_sym_shared] = ACTIONS(4807),
    [anon_sym_map_LBRACK] = ACTIONS(4807),
    [anon_sym_chan] = ACTIONS(4807),
    [anon_sym_thread] = ACTIONS(4807),
    [anon_sym_atomic] = ACTIONS(4807),
    [anon_sym_assert] = ACTIONS(4807),
    [anon_sym_defer] = ACTIONS(4807),
    [anon_sym_goto] = ACTIONS(4807),
    [anon_sym_break] = ACTIONS(4807),
    [anon_sym_continue] = ACTIONS(4807),
    [anon_sym_return] = ACTIONS(4807),
    [anon_sym_DOLLARfor] = ACTIONS(4807),
    [anon_sym_for] = ACTIONS(4807),
    [anon_sym_POUND] = ACTIONS(4807),
    [anon_sym_asm] = ACTIONS(4807),
  },
  [1941] = {
    [sym_line_comment] = STATE(1941),
    [sym_block_comment] = STATE(1941),
    [sym_identifier] = ACTIONS(3250),
    [anon_sym_LF] = ACTIONS(3250),
    [anon_sym_CR] = ACTIONS(3250),
    [anon_sym_CR_LF] = ACTIONS(3250),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(3250),
    [anon_sym_DOT] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3250),
    [anon_sym_RBRACE] = ACTIONS(3250),
    [anon_sym_LPAREN] = ACTIONS(3250),
    [anon_sym_fn] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_STAR] = ACTIONS(3250),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_mut] = ACTIONS(3250),
    [anon_sym_QMARK] = ACTIONS(3250),
    [anon_sym_BANG] = ACTIONS(3250),
    [anon_sym_go] = ACTIONS(3250),
    [anon_sym_spawn] = ACTIONS(3250),
    [anon_sym_json_DOTdecode] = ACTIONS(3250),
    [anon_sym_LBRACK2] = ACTIONS(3250),
    [anon_sym_TILDE] = ACTIONS(3250),
    [anon_sym_CARET] = ACTIONS(3250),
    [anon_sym_AMP] = ACTIONS(3250),
    [anon_sym_LT_DASH] = ACTIONS(3250),
    [sym_none] = ACTIONS(3250),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [sym_nil] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_DOLLARif] = ACTIONS(3250),
    [anon_sym_match] = ACTIONS(3250),
    [anon_sym_select] = ACTIONS(3250),
    [anon_sym_lock] = ACTIONS(3250),
    [anon_sym_rlock] = ACTIONS(3250),
    [anon_sym_unsafe] = ACTIONS(3250),
    [anon_sym_sql] = ACTIONS(3250),
    [sym_int_literal] = ACTIONS(3250),
    [sym_float_literal] = ACTIONS(3250),
    [sym_rune_literal] = ACTIONS(3250),
    [anon_sym_SQUOTE] = ACTIONS(3250),
    [anon_sym_DQUOTE] = ACTIONS(3250),
    [anon_sym_c_SQUOTE] = ACTIONS(3250),
    [anon_sym_c_DQUOTE] = ACTIONS(3250),
    [anon_sym_r_SQUOTE] = ACTIONS(3250),
    [anon_sym_r_DQUOTE] = ACTIONS(3250),
    [sym_pseudo_compile_time_identifier] = ACTIONS(3250),
    [anon_sym_shared] = ACTIONS(3250),
    [anon_sym_map_LBRACK] = ACTIONS(3250),
    [anon_sym_chan] = ACTIONS(3250),
    [anon_sym_thread] = ACTIONS(3250),
    [anon_sym_atomic] = ACTIONS(3250),
    [anon_sym_assert] = ACTIONS(3250),
    [anon_sym_defer] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_DOLLARfor] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_POUND] = ACTIONS(3250),
    [anon_sym_asm] = ACTIONS(3250),
  },
  [1942] = {
    [sym_line_comment] = STATE(1942),
    [sym_block_comment] = STATE(1942),
    [sym_identifier] = ACTIONS(4885),
    [anon_sym_LF] = ACTIONS(4885),
    [anon_sym_CR] = ACTIONS(4885),
    [anon_sym_CR_LF] = ACTIONS(4885),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4885),
    [anon_sym_DOT] = ACTIONS(4885),
    [anon_sym_LBRACE] = ACTIONS(4885),
    [anon_sym_RBRACE] = ACTIONS(4885),
    [anon_sym_LPAREN] = ACTIONS(4885),
    [anon_sym_fn] = ACTIONS(4885),
    [anon_sym_PLUS] = ACTIONS(4885),
    [anon_sym_DASH] = ACTIONS(4885),
    [anon_sym_STAR] = ACTIONS(4885),
    [anon_sym_struct] = ACTIONS(4885),
    [anon_sym_mut] = ACTIONS(4885),
    [anon_sym_QMARK] = ACTIONS(4885),
    [anon_sym_BANG] = ACTIONS(4885),
    [anon_sym_go] = ACTIONS(4885),
    [anon_sym_spawn] = ACTIONS(4885),
    [anon_sym_json_DOTdecode] = ACTIONS(4885),
    [anon_sym_LBRACK2] = ACTIONS(4885),
    [anon_sym_TILDE] = ACTIONS(4885),
    [anon_sym_CARET] = ACTIONS(4885),
    [anon_sym_AMP] = ACTIONS(4885),
    [anon_sym_LT_DASH] = ACTIONS(4885),
    [sym_none] = ACTIONS(4885),
    [sym_true] = ACTIONS(4885),
    [sym_false] = ACTIONS(4885),
    [sym_nil] = ACTIONS(4885),
    [anon_sym_if] = ACTIONS(4885),
    [anon_sym_DOLLARif] = ACTIONS(4885),
    [anon_sym_match] = ACTIONS(4885),
    [anon_sym_select] = ACTIONS(4885),
    [anon_sym_lock] = ACTIONS(4885),
    [anon_sym_rlock] = ACTIONS(4885),
    [anon_sym_unsafe] = ACTIONS(4885),
    [anon_sym_sql] = ACTIONS(4885),
    [sym_int_literal] = ACTIONS(4885),
    [sym_float_literal] = ACTIONS(4885),
    [sym_rune_literal] = ACTIONS(4885),
    [anon_sym_SQUOTE] = ACTIONS(4885),
    [anon_sym_DQUOTE] = ACTIONS(4885),
    [anon_sym_c_SQUOTE] = ACTIONS(4885),
    [anon_sym_c_DQUOTE] = ACTIONS(4885),
    [anon_sym_r_SQUOTE] = ACTIONS(4885),
    [anon_sym_r_DQUOTE] = ACTIONS(4885),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4885),
    [anon_sym_shared] = ACTIONS(4885),
    [anon_sym_map_LBRACK] = ACTIONS(4885),
    [anon_sym_chan] = ACTIONS(4885),
    [anon_sym_thread] = ACTIONS(4885),
    [anon_sym_atomic] = ACTIONS(4885),
    [anon_sym_assert] = ACTIONS(4885),
    [anon_sym_defer] = ACTIONS(4885),
    [anon_sym_goto] = ACTIONS(4885),
    [anon_sym_break] = ACTIONS(4885),
    [anon_sym_continue] = ACTIONS(4885),
    [anon_sym_return] = ACTIONS(4885),
    [anon_sym_DOLLARfor] = ACTIONS(4885),
    [anon_sym_for] = ACTIONS(4885),
    [anon_sym_POUND] = ACTIONS(4885),
    [anon_sym_asm] = ACTIONS(4885),
  },
  [1943] = {
    [sym_line_comment] = STATE(1943),
    [sym_block_comment] = STATE(1943),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_CR] = ACTIONS(2147),
    [anon_sym_CR_LF] = ACTIONS(2147),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_DOT] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_RBRACE] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym_fn] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_struct] = ACTIONS(2147),
    [anon_sym_mut] = ACTIONS(2147),
    [anon_sym_QMARK] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_go] = ACTIONS(2147),
    [anon_sym_spawn] = ACTIONS(2147),
    [anon_sym_json_DOTdecode] = ACTIONS(2147),
    [anon_sym_LBRACK2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_LT_DASH] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_nil] = ACTIONS(2147),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_DOLLARif] = ACTIONS(2147),
    [anon_sym_match] = ACTIONS(2147),
    [anon_sym_select] = ACTIONS(2147),
    [anon_sym_lock] = ACTIONS(2147),
    [anon_sym_rlock] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2147),
    [anon_sym_sql] = ACTIONS(2147),
    [sym_int_literal] = ACTIONS(2147),
    [sym_float_literal] = ACTIONS(2147),
    [sym_rune_literal] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_c_SQUOTE] = ACTIONS(2147),
    [anon_sym_c_DQUOTE] = ACTIONS(2147),
    [anon_sym_r_SQUOTE] = ACTIONS(2147),
    [anon_sym_r_DQUOTE] = ACTIONS(2147),
    [sym_pseudo_compile_time_identifier] = ACTIONS(2147),
    [anon_sym_shared] = ACTIONS(2147),
    [anon_sym_map_LBRACK] = ACTIONS(2147),
    [anon_sym_chan] = ACTIONS(2147),
    [anon_sym_thread] = ACTIONS(2147),
    [anon_sym_atomic] = ACTIONS(2147),
    [anon_sym_assert] = ACTIONS(2147),
    [anon_sym_defer] = ACTIONS(2147),
    [anon_sym_goto] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_continue] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2147),
    [anon_sym_DOLLARfor] = ACTIONS(2147),
    [anon_sym_for] = ACTIONS(2147),
    [anon_sym_POUND] = ACTIONS(2147),
    [anon_sym_asm] = ACTIONS(2147),
  },
  [1944] = {
    [sym_line_comment] = STATE(1944),
    [sym_block_comment] = STATE(1944),
    [sym_identifier] = ACTIONS(4671),
    [anon_sym_LF] = ACTIONS(4671),
    [anon_sym_CR] = ACTIONS(4671),
    [anon_sym_CR_LF] = ACTIONS(4671),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4671),
    [anon_sym_DOT] = ACTIONS(4671),
    [anon_sym_LBRACE] = ACTIONS(4671),
    [anon_sym_RBRACE] = ACTIONS(4671),
    [anon_sym_LPAREN] = ACTIONS(4671),
    [anon_sym_fn] = ACTIONS(4671),
    [anon_sym_PLUS] = ACTIONS(4671),
    [anon_sym_DASH] = ACTIONS(4671),
    [anon_sym_STAR] = ACTIONS(4671),
    [anon_sym_struct] = ACTIONS(4671),
    [anon_sym_mut] = ACTIONS(4671),
    [anon_sym_QMARK] = ACTIONS(4671),
    [anon_sym_BANG] = ACTIONS(4671),
    [anon_sym_go] = ACTIONS(4671),
    [anon_sym_spawn] = ACTIONS(4671),
    [anon_sym_json_DOTdecode] = ACTIONS(4671),
    [anon_sym_LBRACK2] = ACTIONS(4671),
    [anon_sym_TILDE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4671),
    [anon_sym_AMP] = ACTIONS(4671),
    [anon_sym_LT_DASH] = ACTIONS(4671),
    [sym_none] = ACTIONS(4671),
    [sym_true] = ACTIONS(4671),
    [sym_false] = ACTIONS(4671),
    [sym_nil] = ACTIONS(4671),
    [anon_sym_if] = ACTIONS(4671),
    [anon_sym_DOLLARif] = ACTIONS(4671),
    [anon_sym_match] = ACTIONS(4671),
    [anon_sym_select] = ACTIONS(4671),
    [anon_sym_lock] = ACTIONS(4671),
    [anon_sym_rlock] = ACTIONS(4671),
    [anon_sym_unsafe] = ACTIONS(4671),
    [anon_sym_sql] = ACTIONS(4671),
    [sym_int_literal] = ACTIONS(4671),
    [sym_float_literal] = ACTIONS(4671),
    [sym_rune_literal] = ACTIONS(4671),
    [anon_sym_SQUOTE] = ACTIONS(4671),
    [anon_sym_DQUOTE] = ACTIONS(4671),
    [anon_sym_c_SQUOTE] = ACTIONS(4671),
    [anon_sym_c_DQUOTE] = ACTIONS(4671),
    [anon_sym_r_SQUOTE] = ACTIONS(4671),
    [anon_sym_r_DQUOTE] = ACTIONS(4671),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4671),
    [anon_sym_shared] = ACTIONS(4671),
    [anon_sym_map_LBRACK] = ACTIONS(4671),
    [anon_sym_chan] = ACTIONS(4671),
    [anon_sym_thread] = ACTIONS(4671),
    [anon_sym_atomic] = ACTIONS(4671),
    [anon_sym_assert] = ACTIONS(4671),
    [anon_sym_defer] = ACTIONS(4671),
    [anon_sym_goto] = ACTIONS(4671),
    [anon_sym_break] = ACTIONS(4671),
    [anon_sym_continue] = ACTIONS(4671),
    [anon_sym_return] = ACTIONS(4671),
    [anon_sym_DOLLARfor] = ACTIONS(4671),
    [anon_sym_for] = ACTIONS(4671),
    [anon_sym_POUND] = ACTIONS(4671),
    [anon_sym_asm] = ACTIONS(4671),
  },
  [1945] = {
    [sym_line_comment] = STATE(1945),
    [sym_block_comment] = STATE(1945),
    [sym_identifier] = ACTIONS(4595),
    [anon_sym_LF] = ACTIONS(4595),
    [anon_sym_CR] = ACTIONS(4595),
    [anon_sym_CR_LF] = ACTIONS(4595),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4595),
    [anon_sym_DOT] = ACTIONS(4595),
    [anon_sym_LBRACE] = ACTIONS(4595),
    [anon_sym_RBRACE] = ACTIONS(4595),
    [anon_sym_LPAREN] = ACTIONS(4595),
    [anon_sym_fn] = ACTIONS(4595),
    [anon_sym_PLUS] = ACTIONS(4595),
    [anon_sym_DASH] = ACTIONS(4595),
    [anon_sym_STAR] = ACTIONS(4595),
    [anon_sym_struct] = ACTIONS(4595),
    [anon_sym_mut] = ACTIONS(4595),
    [anon_sym_QMARK] = ACTIONS(4595),
    [anon_sym_BANG] = ACTIONS(4595),
    [anon_sym_go] = ACTIONS(4595),
    [anon_sym_spawn] = ACTIONS(4595),
    [anon_sym_json_DOTdecode] = ACTIONS(4595),
    [anon_sym_LBRACK2] = ACTIONS(4595),
    [anon_sym_TILDE] = ACTIONS(4595),
    [anon_sym_CARET] = ACTIONS(4595),
    [anon_sym_AMP] = ACTIONS(4595),
    [anon_sym_LT_DASH] = ACTIONS(4595),
    [sym_none] = ACTIONS(4595),
    [sym_true] = ACTIONS(4595),
    [sym_false] = ACTIONS(4595),
    [sym_nil] = ACTIONS(4595),
    [anon_sym_if] = ACTIONS(4595),
    [anon_sym_DOLLARif] = ACTIONS(4595),
    [anon_sym_match] = ACTIONS(4595),
    [anon_sym_select] = ACTIONS(4595),
    [anon_sym_lock] = ACTIONS(4595),
    [anon_sym_rlock] = ACTIONS(4595),
    [anon_sym_unsafe] = ACTIONS(4595),
    [anon_sym_sql] = ACTIONS(4595),
    [sym_int_literal] = ACTIONS(4595),
    [sym_float_literal] = ACTIONS(4595),
    [sym_rune_literal] = ACTIONS(4595),
    [anon_sym_SQUOTE] = ACTIONS(4595),
    [anon_sym_DQUOTE] = ACTIONS(4595),
    [anon_sym_c_SQUOTE] = ACTIONS(4595),
    [anon_sym_c_DQUOTE] = ACTIONS(4595),
    [anon_sym_r_SQUOTE] = ACTIONS(4595),
    [anon_sym_r_DQUOTE] = ACTIONS(4595),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4595),
    [anon_sym_shared] = ACTIONS(4595),
    [anon_sym_map_LBRACK] = ACTIONS(4595),
    [anon_sym_chan] = ACTIONS(4595),
    [anon_sym_thread] = ACTIONS(4595),
    [anon_sym_atomic] = ACTIONS(4595),
    [anon_sym_assert] = ACTIONS(4595),
    [anon_sym_defer] = ACTIONS(4595),
    [anon_sym_goto] = ACTIONS(4595),
    [anon_sym_break] = ACTIONS(4595),
    [anon_sym_continue] = ACTIONS(4595),
    [anon_sym_return] = ACTIONS(4595),
    [anon_sym_DOLLARfor] = ACTIONS(4595),
    [anon_sym_for] = ACTIONS(4595),
    [anon_sym_POUND] = ACTIONS(4595),
    [anon_sym_asm] = ACTIONS(4595),
  },
  [1946] = {
    [sym_line_comment] = STATE(1946),
    [sym_block_comment] = STATE(1946),
    [sym_identifier] = ACTIONS(4639),
    [anon_sym_LF] = ACTIONS(4639),
    [anon_sym_CR] = ACTIONS(4639),
    [anon_sym_CR_LF] = ACTIONS(4639),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4639),
    [anon_sym_DOT] = ACTIONS(4639),
    [anon_sym_LBRACE] = ACTIONS(4639),
    [anon_sym_RBRACE] = ACTIONS(4639),
    [anon_sym_LPAREN] = ACTIONS(4639),
    [anon_sym_fn] = ACTIONS(4639),
    [anon_sym_PLUS] = ACTIONS(4639),
    [anon_sym_DASH] = ACTIONS(4639),
    [anon_sym_STAR] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4639),
    [anon_sym_mut] = ACTIONS(4639),
    [anon_sym_QMARK] = ACTIONS(4639),
    [anon_sym_BANG] = ACTIONS(4639),
    [anon_sym_go] = ACTIONS(4639),
    [anon_sym_spawn] = ACTIONS(4639),
    [anon_sym_json_DOTdecode] = ACTIONS(4639),
    [anon_sym_LBRACK2] = ACTIONS(4639),
    [anon_sym_TILDE] = ACTIONS(4639),
    [anon_sym_CARET] = ACTIONS(4639),
    [anon_sym_AMP] = ACTIONS(4639),
    [anon_sym_LT_DASH] = ACTIONS(4639),
    [sym_none] = ACTIONS(4639),
    [sym_true] = ACTIONS(4639),
    [sym_false] = ACTIONS(4639),
    [sym_nil] = ACTIONS(4639),
    [anon_sym_if] = ACTIONS(4639),
    [anon_sym_DOLLARif] = ACTIONS(4639),
    [anon_sym_match] = ACTIONS(4639),
    [anon_sym_select] = ACTIONS(4639),
    [anon_sym_lock] = ACTIONS(4639),
    [anon_sym_rlock] = ACTIONS(4639),
    [anon_sym_unsafe] = ACTIONS(4639),
    [anon_sym_sql] = ACTIONS(4639),
    [sym_int_literal] = ACTIONS(4639),
    [sym_float_literal] = ACTIONS(4639),
    [sym_rune_literal] = ACTIONS(4639),
    [anon_sym_SQUOTE] = ACTIONS(4639),
    [anon_sym_DQUOTE] = ACTIONS(4639),
    [anon_sym_c_SQUOTE] = ACTIONS(4639),
    [anon_sym_c_DQUOTE] = ACTIONS(4639),
    [anon_sym_r_SQUOTE] = ACTIONS(4639),
    [anon_sym_r_DQUOTE] = ACTIONS(4639),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4639),
    [anon_sym_shared] = ACTIONS(4639),
    [anon_sym_map_LBRACK] = ACTIONS(4639),
    [anon_sym_chan] = ACTIONS(4639),
    [anon_sym_thread] = ACTIONS(4639),
    [anon_sym_atomic] = ACTIONS(4639),
    [anon_sym_assert] = ACTIONS(4639),
    [anon_sym_defer] = ACTIONS(4639),
    [anon_sym_goto] = ACTIONS(4639),
    [anon_sym_break] = ACTIONS(4639),
    [anon_sym_continue] = ACTIONS(4639),
    [anon_sym_return] = ACTIONS(4639),
    [anon_sym_DOLLARfor] = ACTIONS(4639),
    [anon_sym_for] = ACTIONS(4639),
    [anon_sym_POUND] = ACTIONS(4639),
    [anon_sym_asm] = ACTIONS(4639),
  },
  [1947] = {
    [sym_line_comment] = STATE(1947),
    [sym_block_comment] = STATE(1947),
    [sym_identifier] = ACTIONS(4655),
    [anon_sym_LF] = ACTIONS(4655),
    [anon_sym_CR] = ACTIONS(4655),
    [anon_sym_CR_LF] = ACTIONS(4655),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4655),
    [anon_sym_DOT] = ACTIONS(4655),
    [anon_sym_LBRACE] = ACTIONS(4655),
    [anon_sym_RBRACE] = ACTIONS(4655),
    [anon_sym_LPAREN] = ACTIONS(4655),
    [anon_sym_fn] = ACTIONS(4655),
    [anon_sym_PLUS] = ACTIONS(4655),
    [anon_sym_DASH] = ACTIONS(4655),
    [anon_sym_STAR] = ACTIONS(4655),
    [anon_sym_struct] = ACTIONS(4655),
    [anon_sym_mut] = ACTIONS(4655),
    [anon_sym_QMARK] = ACTIONS(4655),
    [anon_sym_BANG] = ACTIONS(4655),
    [anon_sym_go] = ACTIONS(4655),
    [anon_sym_spawn] = ACTIONS(4655),
    [anon_sym_json_DOTdecode] = ACTIONS(4655),
    [anon_sym_LBRACK2] = ACTIONS(4655),
    [anon_sym_TILDE] = ACTIONS(4655),
    [anon_sym_CARET] = ACTIONS(4655),
    [anon_sym_AMP] = ACTIONS(4655),
    [anon_sym_LT_DASH] = ACTIONS(4655),
    [sym_none] = ACTIONS(4655),
    [sym_true] = ACTIONS(4655),
    [sym_false] = ACTIONS(4655),
    [sym_nil] = ACTIONS(4655),
    [anon_sym_if] = ACTIONS(4655),
    [anon_sym_DOLLARif] = ACTIONS(4655),
    [anon_sym_match] = ACTIONS(4655),
    [anon_sym_select] = ACTIONS(4655),
    [anon_sym_lock] = ACTIONS(4655),
    [anon_sym_rlock] = ACTIONS(4655),
    [anon_sym_unsafe] = ACTIONS(4655),
    [anon_sym_sql] = ACTIONS(4655),
    [sym_int_literal] = ACTIONS(4655),
    [sym_float_literal] = ACTIONS(4655),
    [sym_rune_literal] = ACTIONS(4655),
    [anon_sym_SQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4655),
    [anon_sym_c_SQUOTE] = ACTIONS(4655),
    [anon_sym_c_DQUOTE] = ACTIONS(4655),
    [anon_sym_r_SQUOTE] = ACTIONS(4655),
    [anon_sym_r_DQUOTE] = ACTIONS(4655),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4655),
    [anon_sym_shared] = ACTIONS(4655),
    [anon_sym_map_LBRACK] = ACTIONS(4655),
    [anon_sym_chan] = ACTIONS(4655),
    [anon_sym_thread] = ACTIONS(4655),
    [anon_sym_atomic] = ACTIONS(4655),
    [anon_sym_assert] = ACTIONS(4655),
    [anon_sym_defer] = ACTIONS(4655),
    [anon_sym_goto] = ACTIONS(4655),
    [anon_sym_break] = ACTIONS(4655),
    [anon_sym_continue] = ACTIONS(4655),
    [anon_sym_return] = ACTIONS(4655),
    [anon_sym_DOLLARfor] = ACTIONS(4655),
    [anon_sym_for] = ACTIONS(4655),
    [anon_sym_POUND] = ACTIONS(4655),
    [anon_sym_asm] = ACTIONS(4655),
  },
  [1948] = {
    [sym_line_comment] = STATE(1948),
    [sym_block_comment] = STATE(1948),
    [sym_identifier] = ACTIONS(4591),
    [anon_sym_LF] = ACTIONS(4591),
    [anon_sym_CR] = ACTIONS(4591),
    [anon_sym_CR_LF] = ACTIONS(4591),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4591),
    [anon_sym_DOT] = ACTIONS(4591),
    [anon_sym_LBRACE] = ACTIONS(4591),
    [anon_sym_RBRACE] = ACTIONS(4591),
    [anon_sym_LPAREN] = ACTIONS(4591),
    [anon_sym_fn] = ACTIONS(4591),
    [anon_sym_PLUS] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4591),
    [anon_sym_STAR] = ACTIONS(4591),
    [anon_sym_struct] = ACTIONS(4591),
    [anon_sym_mut] = ACTIONS(4591),
    [anon_sym_QMARK] = ACTIONS(4591),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_go] = ACTIONS(4591),
    [anon_sym_spawn] = ACTIONS(4591),
    [anon_sym_json_DOTdecode] = ACTIONS(4591),
    [anon_sym_LBRACK2] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_CARET] = ACTIONS(4591),
    [anon_sym_AMP] = ACTIONS(4591),
    [anon_sym_LT_DASH] = ACTIONS(4591),
    [sym_none] = ACTIONS(4591),
    [sym_true] = ACTIONS(4591),
    [sym_false] = ACTIONS(4591),
    [sym_nil] = ACTIONS(4591),
    [anon_sym_if] = ACTIONS(4591),
    [anon_sym_DOLLARif] = ACTIONS(4591),
    [anon_sym_match] = ACTIONS(4591),
    [anon_sym_select] = ACTIONS(4591),
    [anon_sym_lock] = ACTIONS(4591),
    [anon_sym_rlock] = ACTIONS(4591),
    [anon_sym_unsafe] = ACTIONS(4591),
    [anon_sym_sql] = ACTIONS(4591),
    [sym_int_literal] = ACTIONS(4591),
    [sym_float_literal] = ACTIONS(4591),
    [sym_rune_literal] = ACTIONS(4591),
    [anon_sym_SQUOTE] = ACTIONS(4591),
    [anon_sym_DQUOTE] = ACTIONS(4591),
    [anon_sym_c_SQUOTE] = ACTIONS(4591),
    [anon_sym_c_DQUOTE] = ACTIONS(4591),
    [anon_sym_r_SQUOTE] = ACTIONS(4591),
    [anon_sym_r_DQUOTE] = ACTIONS(4591),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4591),
    [anon_sym_shared] = ACTIONS(4591),
    [anon_sym_map_LBRACK] = ACTIONS(4591),
    [anon_sym_chan] = ACTIONS(4591),
    [anon_sym_thread] = ACTIONS(4591),
    [anon_sym_atomic] = ACTIONS(4591),
    [anon_sym_assert] = ACTIONS(4591),
    [anon_sym_defer] = ACTIONS(4591),
    [anon_sym_goto] = ACTIONS(4591),
    [anon_sym_break] = ACTIONS(4591),
    [anon_sym_continue] = ACTIONS(4591),
    [anon_sym_return] = ACTIONS(4591),
    [anon_sym_DOLLARfor] = ACTIONS(4591),
    [anon_sym_for] = ACTIONS(4591),
    [anon_sym_POUND] = ACTIONS(4591),
    [anon_sym_asm] = ACTIONS(4591),
  },
  [1949] = {
    [sym_line_comment] = STATE(1949),
    [sym_block_comment] = STATE(1949),
    [sym_identifier] = ACTIONS(4803),
    [anon_sym_LF] = ACTIONS(4803),
    [anon_sym_CR] = ACTIONS(4803),
    [anon_sym_CR_LF] = ACTIONS(4803),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4803),
    [anon_sym_DOT] = ACTIONS(4803),
    [anon_sym_LBRACE] = ACTIONS(4803),
    [anon_sym_RBRACE] = ACTIONS(4803),
    [anon_sym_LPAREN] = ACTIONS(4803),
    [anon_sym_fn] = ACTIONS(4803),
    [anon_sym_PLUS] = ACTIONS(4803),
    [anon_sym_DASH] = ACTIONS(4803),
    [anon_sym_STAR] = ACTIONS(4803),
    [anon_sym_struct] = ACTIONS(4803),
    [anon_sym_mut] = ACTIONS(4803),
    [anon_sym_QMARK] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(4803),
    [anon_sym_go] = ACTIONS(4803),
    [anon_sym_spawn] = ACTIONS(4803),
    [anon_sym_json_DOTdecode] = ACTIONS(4803),
    [anon_sym_LBRACK2] = ACTIONS(4803),
    [anon_sym_TILDE] = ACTIONS(4803),
    [anon_sym_CARET] = ACTIONS(4803),
    [anon_sym_AMP] = ACTIONS(4803),
    [anon_sym_LT_DASH] = ACTIONS(4803),
    [sym_none] = ACTIONS(4803),
    [sym_true] = ACTIONS(4803),
    [sym_false] = ACTIONS(4803),
    [sym_nil] = ACTIONS(4803),
    [anon_sym_if] = ACTIONS(4803),
    [anon_sym_DOLLARif] = ACTIONS(4803),
    [anon_sym_match] = ACTIONS(4803),
    [anon_sym_select] = ACTIONS(4803),
    [anon_sym_lock] = ACTIONS(4803),
    [anon_sym_rlock] = ACTIONS(4803),
    [anon_sym_unsafe] = ACTIONS(4803),
    [anon_sym_sql] = ACTIONS(4803),
    [sym_int_literal] = ACTIONS(4803),
    [sym_float_literal] = ACTIONS(4803),
    [sym_rune_literal] = ACTIONS(4803),
    [anon_sym_SQUOTE] = ACTIONS(4803),
    [anon_sym_DQUOTE] = ACTIONS(4803),
    [anon_sym_c_SQUOTE] = ACTIONS(4803),
    [anon_sym_c_DQUOTE] = ACTIONS(4803),
    [anon_sym_r_SQUOTE] = ACTIONS(4803),
    [anon_sym_r_DQUOTE] = ACTIONS(4803),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4803),
    [anon_sym_shared] = ACTIONS(4803),
    [anon_sym_map_LBRACK] = ACTIONS(4803),
    [anon_sym_chan] = ACTIONS(4803),
    [anon_sym_thread] = ACTIONS(4803),
    [anon_sym_atomic] = ACTIONS(4803),
    [anon_sym_assert] = ACTIONS(4803),
    [anon_sym_defer] = ACTIONS(4803),
    [anon_sym_goto] = ACTIONS(4803),
    [anon_sym_break] = ACTIONS(4803),
    [anon_sym_continue] = ACTIONS(4803),
    [anon_sym_return] = ACTIONS(4803),
    [anon_sym_DOLLARfor] = ACTIONS(4803),
    [anon_sym_for] = ACTIONS(4803),
    [anon_sym_POUND] = ACTIONS(4803),
    [anon_sym_asm] = ACTIONS(4803),
  },
  [1950] = {
    [sym_line_comment] = STATE(1950),
    [sym_block_comment] = STATE(1950),
    [sym_identifier] = ACTIONS(4627),
    [anon_sym_LF] = ACTIONS(4627),
    [anon_sym_CR] = ACTIONS(4627),
    [anon_sym_CR_LF] = ACTIONS(4627),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4627),
    [anon_sym_DOT] = ACTIONS(4627),
    [anon_sym_LBRACE] = ACTIONS(4627),
    [anon_sym_RBRACE] = ACTIONS(4627),
    [anon_sym_LPAREN] = ACTIONS(4627),
    [anon_sym_fn] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4627),
    [anon_sym_struct] = ACTIONS(4627),
    [anon_sym_mut] = ACTIONS(4627),
    [anon_sym_QMARK] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4627),
    [anon_sym_go] = ACTIONS(4627),
    [anon_sym_spawn] = ACTIONS(4627),
    [anon_sym_json_DOTdecode] = ACTIONS(4627),
    [anon_sym_LBRACK2] = ACTIONS(4627),
    [anon_sym_TILDE] = ACTIONS(4627),
    [anon_sym_CARET] = ACTIONS(4627),
    [anon_sym_AMP] = ACTIONS(4627),
    [anon_sym_LT_DASH] = ACTIONS(4627),
    [sym_none] = ACTIONS(4627),
    [sym_true] = ACTIONS(4627),
    [sym_false] = ACTIONS(4627),
    [sym_nil] = ACTIONS(4627),
    [anon_sym_if] = ACTIONS(4627),
    [anon_sym_DOLLARif] = ACTIONS(4627),
    [anon_sym_match] = ACTIONS(4627),
    [anon_sym_select] = ACTIONS(4627),
    [anon_sym_lock] = ACTIONS(4627),
    [anon_sym_rlock] = ACTIONS(4627),
    [anon_sym_unsafe] = ACTIONS(4627),
    [anon_sym_sql] = ACTIONS(4627),
    [sym_int_literal] = ACTIONS(4627),
    [sym_float_literal] = ACTIONS(4627),
    [sym_rune_literal] = ACTIONS(4627),
    [anon_sym_SQUOTE] = ACTIONS(4627),
    [anon_sym_DQUOTE] = ACTIONS(4627),
    [anon_sym_c_SQUOTE] = ACTIONS(4627),
    [anon_sym_c_DQUOTE] = ACTIONS(4627),
    [anon_sym_r_SQUOTE] = ACTIONS(4627),
    [anon_sym_r_DQUOTE] = ACTIONS(4627),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4627),
    [anon_sym_shared] = ACTIONS(4627),
    [anon_sym_map_LBRACK] = ACTIONS(4627),
    [anon_sym_chan] = ACTIONS(4627),
    [anon_sym_thread] = ACTIONS(4627),
    [anon_sym_atomic] = ACTIONS(4627),
    [anon_sym_assert] = ACTIONS(4627),
    [anon_sym_defer] = ACTIONS(4627),
    [anon_sym_goto] = ACTIONS(4627),
    [anon_sym_break] = ACTIONS(4627),
    [anon_sym_continue] = ACTIONS(4627),
    [anon_sym_return] = ACTIONS(4627),
    [anon_sym_DOLLARfor] = ACTIONS(4627),
    [anon_sym_for] = ACTIONS(4627),
    [anon_sym_POUND] = ACTIONS(4627),
    [anon_sym_asm] = ACTIONS(4627),
  },
  [1951] = {
    [sym_line_comment] = STATE(1951),
    [sym_block_comment] = STATE(1951),
    [sym_identifier] = ACTIONS(4651),
    [anon_sym_LF] = ACTIONS(4651),
    [anon_sym_CR] = ACTIONS(4651),
    [anon_sym_CR_LF] = ACTIONS(4651),
    [anon_sym_SLASH_SLASH] = ACTIONS(311),
    [anon_sym_SLASH_STAR] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(4651),
    [anon_sym_DOT] = ACTIONS(4651),
    [anon_sym_LBRACE] = ACTIONS(4651),
    [anon_sym_RBRACE] = ACTIONS(4651),
    [anon_sym_LPAREN] = ACTIONS(4651),
    [anon_sym_fn] = ACTIONS(4651),
    [anon_sym_PLUS] = ACTIONS(4651),
    [anon_sym_DASH] = ACTIONS(4651),
    [anon_sym_STAR] = ACTIONS(4651),
    [anon_sym_struct] = ACTIONS(4651),
    [anon_sym_mut] = ACTIONS(4651),
    [anon_sym_QMARK] = ACTIONS(4651),
    [anon_sym_BANG] = ACTIONS(4651),
    [anon_sym_go] = ACTIONS(4651),
    [anon_sym_spawn] = ACTIONS(4651),
    [anon_sym_json_DOTdecode] = ACTIONS(4651),
    [anon_sym_LBRACK2] = ACTIONS(4651),
    [anon_sym_TILDE] = ACTIONS(4651),
    [anon_sym_CARET] = ACTIONS(4651),
    [anon_sym_AMP] = ACTIONS(4651),
    [anon_sym_LT_DASH] = ACTIONS(4651),
    [sym_none] = ACTIONS(4651),
    [sym_true] = ACTIONS(4651),
    [sym_false] = ACTIONS(4651),
    [sym_nil] = ACTIONS(4651),
    [anon_sym_if] = ACTIONS(4651),
    [anon_sym_DOLLARif] = ACTIONS(4651),
    [anon_sym_match] = ACTIONS(4651),
    [anon_sym_select] = ACTIONS(4651),
    [anon_sym_lock] = ACTIONS(4651),
    [anon_sym_rlock] = ACTIONS(4651),
    [anon_sym_unsafe] = ACTIONS(4651),
    [anon_sym_sql] = ACTIONS(4651),
    [sym_int_literal] = ACTIONS(4651),
    [sym_float_literal] = ACTIONS(4651),
    [sym_rune_literal] = ACTIONS(4651),
    [anon_sym_SQUOTE] = ACTIONS(4651),
    [anon_sym_DQUOTE] = ACTIONS(4651),
    [anon_sym_c_SQUOTE] = ACTIONS(4651),
    [anon_sym_c_DQUOTE] = ACTIONS(4651),
    [anon_sym_r_SQUOTE] = ACTIONS(4651),
    [anon_sym_r_DQUOTE] = ACTIONS(4651),
    [sym_pseudo_compile_time_identifier] = ACTIONS(4651),
    [anon_sym_shared] = ACTIONS(4651),
    [anon_sym_map_LBRACK] = ACTIONS(4651),
    [anon_sym_chan] = ACTIONS(4651),
    [anon_sym_thread] = ACTIONS(4651),
    [anon_sym_atomic] = ACTIONS(4651),
    [anon_sym_assert] = ACTIONS(4651),
    [anon_sym_defer] = ACTIONS(4651),
    [anon_sym_goto] = ACTIONS(4651),
    [anon_sym_break] = ACTIONS(4651),
    [anon_sym_continue] = ACTIONS(4651),
    [anon_sym_return] = ACTIONS(4651),
    [anon_sym_DOLLARfor] = ACTIONS(4651),
    [anon_sym_for] = ACTIONS(4651),
    [anon_sym_POUND] = ACTIONS(4651),
    [anon_sym_asm] = ACTIONS(4651),
  },
  [1952] = {
    [sym_line_comment] = STATE(1952),
    [sym_block_comment] = STATE(1952),
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_DOT] = ACTIONS(2667),
    [anon_sym_as] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_COMMA] = ACTIONS(2667),
    [anon_sym_LPAREN] = ACTIONS(2667),
    [anon_sym_EQ] = ACTIONS(2669),
    [anon_sym_fn] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2669),
    [anon_sym_SLASH] = ACTIONS(2669),
    [anon_sym_PERCENT] = ACTIONS(2669),
    [anon_sym_LT] = ACTIONS(2669),
    [anon_sym_GT] = ACTIONS(2669),
    [anon_sym_EQ_EQ] = ACTIONS(2667),
    [anon_sym_BANG_EQ] = ACTIONS(2667),
    [anon_sym_LT_EQ] = ACTIONS(2667),
    [anon_sym_GT_EQ] = ACTIONS(2667),
    [anon_sym_LBRACK] = ACTIONS(2667),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_PLUS_PLUS] = ACTIONS(2667),
    [anon_sym_DASH_DASH] = ACTIONS(2667),
    [anon_sym_QMARK] = ACTIONS(2669),
    [anon_sym_BANG] = ACTIONS(2669),
    [anon_sym_PIPE] = ACTIONS(2669),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_CARET] = ACTIONS(2669),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_LT_LT] = ACTIONS(2669),
    [anon_sym_GT_GT] = ACTIONS(2669),
    [anon_sym_GT_GT_GT] = ACTIONS(2669),
    [anon_sym_AMP_CARET] = ACTIONS(2669),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_PIPE_PIPE] = ACTIONS(2667),
    [anon_sym_or] = ACTIONS(2669),
    [anon_sym_QMARK_DOT] = ACTIONS(2667),
    [anon_sym_POUND_LBRACK] = ACTIONS(2667),
    [anon_sym_is] = ACTIONS(2669),
    [anon_sym_BANGis] = ACTIONS(2667),
    [anon_sym_in] = ACTIONS(2669),
    [anon_sym_BANGin] = ACTIONS(2667),
    [anon_sym_STAR_EQ] = ACTIONS(2667),
    [anon_sym_SLASH_EQ] = ACTIONS(2667),
    [anon_sym_PERCENT_EQ] = ACTIONS(2667),
    [anon_sym_LT_LT_EQ] = ACTIONS(2667),
    [anon_sym_GT_GT_EQ] = ACTIONS(2667),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2667),
    [anon_sym_AMP_EQ] = ACTIONS(2667),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2667),
    [anon_sym_PLUS_EQ] = ACTIONS(2667),
    [anon_sym_DASH_EQ] = ACTIONS(2667),
    [anon_sym_PIPE_EQ] = ACTIONS(2667),
    [anon_sym_CARET_EQ] = ACTIONS(2667),
    [anon_sym_COLON_EQ] = ACTIONS(2667),
    [anon_sym_shared] = ACTIONS(2669),
    [anon_sym_map_LBRACK] = ACTIONS(2667),
    [anon_sym_chan] = ACTIONS(2669),
    [anon_sym_thread] = ACTIONS(2669),
    [anon_sym_atomic] = ACTIONS(2669),
  },
  [1953] = {
    [sym_line_comment] = STATE(1953),
    [sym_block_comment] = STATE(1953),
    [sym_identifier] = ACTIONS(3049),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3047),
    [anon_sym_as] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_COMMA] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym_fn] = ACTIONS(3049),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_STAR] = ACTIONS(3049),
    [anon_sym_SLASH] = ACTIONS(3049),
    [anon_sym_PERCENT] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_GT] = ACTIONS(3049),
    [anon_sym_EQ_EQ] = ACTIONS(3047),
    [anon_sym_BANG_EQ] = ACTIONS(3047),
    [anon_sym_LT_EQ] = ACTIONS(3047),
    [anon_sym_GT_EQ] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_struct] = ACTIONS(3049),
    [anon_sym_COLON] = ACTIONS(3047),
    [anon_sym_PLUS_PLUS] = ACTIONS(3047),
    [anon_sym_DASH_DASH] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_BANG] = ACTIONS(3049),
    [anon_sym_PIPE] = ACTIONS(3049),
    [anon_sym_LBRACK2] = ACTIONS(3049),
    [anon_sym_CARET] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_LT_DASH] = ACTIONS(3047),
    [anon_sym_LT_LT] = ACTIONS(3049),
    [anon_sym_GT_GT] = ACTIONS(3049),
    [anon_sym_GT_GT_GT] = ACTIONS(3049),
    [anon_sym_AMP_CARET] = ACTIONS(3049),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3047),
    [anon_sym_or] = ACTIONS(3049),
    [anon_sym_QMARK_DOT] = ACTIONS(3047),
    [anon_sym_POUND_LBRACK] = ACTIONS(3047),
    [anon_sym_is] = ACTIONS(3049),
    [anon_sym_BANGis] = ACTIONS(3047),
    [anon_sym_in] = ACTIONS(3049),
    [anon_sym_BANGin] = ACTIONS(3047),
    [anon_sym_STAR_EQ] = ACTIONS(3047),
    [anon_sym_SLASH_EQ] = ACTIONS(3047),
    [anon_sym_PERCENT_EQ] = ACTIONS(3047),
    [anon_sym_LT_LT_EQ] = ACTIONS(3047),
    [anon_sym_GT_GT_EQ] = ACTIONS(3047),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3047),
    [anon_sym_AMP_EQ] = ACTIONS(3047),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3047),
    [anon_sym_PLUS_EQ] = ACTIONS(3047),
    [anon_sym_DASH_EQ] = ACTIONS(3047),
    [anon_sym_PIPE_EQ] = ACTIONS(3047),
    [anon_sym_CARET_EQ] = ACTIONS(3047),
    [anon_sym_shared] = ACTIONS(3049),
    [anon_sym_map_LBRACK] = ACTIONS(3047),
    [anon_sym_chan] = ACTIONS(3049),
    [anon_sym_thread] = ACTIONS(3049),
    [anon_sym_atomic] = ACTIONS(3049),
  },
  [1954] = {
    [sym_line_comment] = STATE(1954),
    [sym_block_comment] = STATE(1954),
    [sym_identifier] = ACTIONS(3350),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(3348),
    [anon_sym_DOT] = ACTIONS(3348),
    [anon_sym_as] = ACTIONS(3350),
    [anon_sym_LBRACE] = ACTIONS(3348),
    [anon_sym_COMMA] = ACTIONS(3348),
    [anon_sym_LPAREN] = ACTIONS(3348),
    [anon_sym_EQ] = ACTIONS(3350),
    [anon_sym_fn] = ACTIONS(3350),
    [anon_sym_PLUS] = ACTIONS(3350),
    [anon_sym_DASH] = ACTIONS(3350),
    [anon_sym_STAR] = ACTIONS(3350),
    [anon_sym_SLASH] = ACTIONS(3350),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_LT] = ACTIONS(3350),
    [anon_sym_GT] = ACTIONS(3350),
    [anon_sym_EQ_EQ] = ACTIONS(3348),
    [anon_sym_BANG_EQ] = ACTIONS(3348),
    [anon_sym_LT_EQ] = ACTIONS(3348),
    [anon_sym_GT_EQ] = ACTIONS(3348),
    [anon_sym_LBRACK] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3350),
    [anon_sym_PLUS_PLUS] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3348),
    [anon_sym_QMARK] = ACTIONS(3350),
    [anon_sym_BANG] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3350),
    [anon_sym_LBRACK2] = ACTIONS(3350),
    [anon_sym_CARET] = ACTIONS(3350),
    [anon_sym_AMP] = ACTIONS(3350),
    [anon_sym_LT_LT] = ACTIONS(3350),
    [anon_sym_GT_GT] = ACTIONS(3350),
    [anon_sym_GT_GT_GT] = ACTIONS(3350),
    [anon_sym_AMP_CARET] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3348),
    [anon_sym_PIPE_PIPE] = ACTIONS(3348),
    [anon_sym_or] = ACTIONS(3350),
    [anon_sym_QMARK_DOT] = ACTIONS(3348),
    [anon_sym_POUND_LBRACK] = ACTIONS(3348),
    [anon_sym_is] = ACTIONS(3350),
    [anon_sym_BANGis] = ACTIONS(3348),
    [anon_sym_in] = ACTIONS(3350),
    [anon_sym_BANGin] = ACTIONS(3348),
    [anon_sym_STAR_EQ] = ACTIONS(3348),
    [anon_sym_SLASH_EQ] = ACTIONS(3348),
    [anon_sym_PERCENT_EQ] = ACTIONS(3348),
    [anon_sym_LT_LT_EQ] = ACTIONS(3348),
    [anon_sym_GT_GT_EQ] = ACTIONS(3348),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3348),
    [anon_sym_AMP_EQ] = ACTIONS(3348),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3348),
    [anon_sym_PLUS_EQ] = ACTIONS(3348),
    [anon_sym_DASH_EQ] = ACTIONS(3348),
    [anon_sym_PIPE_EQ] = ACTIONS(3348),
    [anon_sym_CARET_EQ] = ACTIONS(3348),
    [anon_sym_COLON_EQ] = ACTIONS(3348),
    [anon_sym_shared] = ACTIONS(3350),
    [anon_sym_map_LBRACK] = ACTIONS(3348),
    [anon_sym_chan] = ACTIONS(3350),
    [anon_sym_thread] = ACTIONS(3350),
    [anon_sym_atomic] = ACTIONS(3350),
  },
  [1955] = {
    [sym_line_comment] = STATE(1955),
    [sym_block_comment] = STATE(1955),
    [sym_identifier] = ACTIONS(2985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2983),
    [anon_sym_as] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_EQ] = ACTIONS(2985),
    [anon_sym_fn] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2985),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_PERCENT] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_EQ_EQ] = ACTIONS(2983),
    [anon_sym_BANG_EQ] = ACTIONS(2983),
    [anon_sym_LT_EQ] = ACTIONS(2983),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_COLON] = ACTIONS(2983),
    [anon_sym_PLUS_PLUS] = ACTIONS(2983),
    [anon_sym_DASH_DASH] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_CARET] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_DASH] = ACTIONS(2983),
    [anon_sym_LT_LT] = ACTIONS(2985),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_GT_GT_GT] = ACTIONS(2985),
    [anon_sym_AMP_CARET] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_or] = ACTIONS(2985),
    [anon_sym_QMARK_DOT] = ACTIONS(2983),
    [anon_sym_POUND_LBRACK] = ACTIONS(2983),
    [anon_sym_is] = ACTIONS(2985),
    [anon_sym_BANGis] = ACTIONS(2983),
    [anon_sym_in] = ACTIONS(2985),
    [anon_sym_BANGin] = ACTIONS(2983),
    [anon_sym_STAR_EQ] = ACTIONS(2983),
    [anon_sym_SLASH_EQ] = ACTIONS(2983),
    [anon_sym_PERCENT_EQ] = ACTIONS(2983),
    [anon_sym_LT_LT_EQ] = ACTIONS(2983),
    [anon_sym_GT_GT_EQ] = ACTIONS(2983),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2983),
    [anon_sym_AMP_EQ] = ACTIONS(2983),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2983),
    [anon_sym_PLUS_EQ] = ACTIONS(2983),
    [anon_sym_DASH_EQ] = ACTIONS(2983),
    [anon_sym_PIPE_EQ] = ACTIONS(2983),
    [anon_sym_CARET_EQ] = ACTIONS(2983),
    [anon_sym_shared] = ACTIONS(2985),
    [anon_sym_map_LBRACK] = ACTIONS(2983),
    [anon_sym_chan] = ACTIONS(2985),
    [anon_sym_thread] = ACTIONS(2985),
    [anon_sym_atomic] = ACTIONS(2985),
  },
  [1956] = {
    [sym_line_comment] = STATE(1956),
    [sym_block_comment] = STATE(1956),
    [sym_identifier] = ACTIONS(3049),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(3047),
    [anon_sym_DOT] = ACTIONS(3047),
    [anon_sym_as] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_COMMA] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym_fn] = ACTIONS(3049),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_STAR] = ACTIONS(3049),
    [anon_sym_SLASH] = ACTIONS(3049),
    [anon_sym_PERCENT] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_GT] = ACTIONS(3049),
    [anon_sym_EQ_EQ] = ACTIONS(3047),
    [anon_sym_BANG_EQ] = ACTIONS(3047),
    [anon_sym_LT_EQ] = ACTIONS(3047),
    [anon_sym_GT_EQ] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_struct] = ACTIONS(3049),
    [anon_sym_PLUS_PLUS] = ACTIONS(3047),
    [anon_sym_DASH_DASH] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_BANG] = ACTIONS(3049),
    [anon_sym_PIPE] = ACTIONS(3049),
    [anon_sym_LBRACK2] = ACTIONS(3049),
    [anon_sym_CARET] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_LT_LT] = ACTIONS(3049),
    [anon_sym_GT_GT] = ACTIONS(3049),
    [anon_sym_GT_GT_GT] = ACTIONS(3049),
    [anon_sym_AMP_CARET] = ACTIONS(3049),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3047),
    [anon_sym_or] = ACTIONS(3049),
    [anon_sym_QMARK_DOT] = ACTIONS(3047),
    [anon_sym_POUND_LBRACK] = ACTIONS(3047),
    [anon_sym_is] = ACTIONS(3049),
    [anon_sym_BANGis] = ACTIONS(3047),
    [anon_sym_in] = ACTIONS(3049),
    [anon_sym_BANGin] = ACTIONS(3047),
    [anon_sym_STAR_EQ] = ACTIONS(3047),
    [anon_sym_SLASH_EQ] = ACTIONS(3047),
    [anon_sym_PERCENT_EQ] = ACTIONS(3047),
    [anon_sym_LT_LT_EQ] = ACTIONS(3047),
    [anon_sym_GT_GT_EQ] = ACTIONS(3047),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3047),
    [anon_sym_AMP_EQ] = ACTIONS(3047),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3047),
    [anon_sym_PLUS_EQ] = ACTIONS(3047),
    [anon_sym_DASH_EQ] = ACTIONS(3047),
    [anon_sym_PIPE_EQ] = ACTIONS(3047),
    [anon_sym_CARET_EQ] = ACTIONS(3047),
    [anon_sym_COLON_EQ] = ACTIONS(3047),
    [anon_sym_shared] = ACTIONS(3049),
    [anon_sym_map_LBRACK] = ACTIONS(3047),
    [anon_sym_chan] = ACTIONS(3049),
    [anon_sym_thread] = ACTIONS(3049),
    [anon_sym_atomic] = ACTIONS(3049),
  },
  [1957] = {
    [sym_line_comment] = STATE(1957),
    [sym_block_comment] = STATE(1957),
    [sym_identifier] = ACTIONS(2985),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_DOT] = ACTIONS(2983),
    [anon_sym_as] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_EQ] = ACTIONS(2985),
    [anon_sym_fn] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2985),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_PERCENT] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_EQ_EQ] = ACTIONS(2983),
    [anon_sym_BANG_EQ] = ACTIONS(2983),
    [anon_sym_LT_EQ] = ACTIONS(2983),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_PLUS_PLUS] = ACTIONS(2983),
    [anon_sym_DASH_DASH] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_CARET] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2985),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_GT_GT_GT] = ACTIONS(2985),
    [anon_sym_AMP_CARET] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_or] = ACTIONS(2985),
    [anon_sym_QMARK_DOT] = ACTIONS(2983),
    [anon_sym_POUND_LBRACK] = ACTIONS(2983),
    [anon_sym_is] = ACTIONS(2985),
    [anon_sym_BANGis] = ACTIONS(2983),
    [anon_sym_in] = ACTIONS(2985),
    [anon_sym_BANGin] = ACTIONS(2983),
    [anon_sym_STAR_EQ] = ACTIONS(2983),
    [anon_sym_SLASH_EQ] = ACTIONS(2983),
    [anon_sym_PERCENT_EQ] = ACTIONS(2983),
    [anon_sym_LT_LT_EQ] = ACTIONS(2983),
    [anon_sym_GT_GT_EQ] = ACTIONS(2983),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2983),
    [anon_sym_AMP_EQ] = ACTIONS(2983),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2983),
    [anon_sym_PLUS_EQ] = ACTIONS(2983),
    [anon_sym_DASH_EQ] = ACTIONS(2983),
    [anon_sym_PIPE_EQ] = ACTIONS(2983),
    [anon_sym_CARET_EQ] = ACTIONS(2983),
    [anon_sym_COLON_EQ] = ACTIONS(2983),
    [anon_sym_shared] = ACTIONS(2985),
    [anon_sym_map_LBRACK] = ACTIONS(2983),
    [anon_sym_chan] = ACTIONS(2985),
    [anon_sym_thread] = ACTIONS(2985),
    [anon_sym_atomic] = ACTIONS(2985),
  },
  [1958] = {
    [sym_line_comment] = STATE(1958),
    [sym_block_comment] = STATE(1958),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(3053),
    [anon_sym_DOT] = ACTIONS(3053),
    [anon_sym_as] = ACTIONS(3055),
    [anon_sym_LBRACE] = ACTIONS(3053),
    [anon_sym_COMMA] = ACTIONS(3053),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_EQ] = ACTIONS(3055),
    [anon_sym_fn] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3055),
    [anon_sym_SLASH] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(3055),
    [anon_sym_GT] = ACTIONS(3055),
    [anon_sym_EQ_EQ] = ACTIONS(3053),
    [anon_sym_BANG_EQ] = ACTIONS(3053),
    [anon_sym_LT_EQ] = ACTIONS(3053),
    [anon_sym_GT_EQ] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_struct] = ACTIONS(3055),
    [anon_sym_PLUS_PLUS] = ACTIONS(3053),
    [anon_sym_DASH_DASH] = ACTIONS(3053),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_BANG] = ACTIONS(3055),
    [anon_sym_PIPE] = ACTIONS(3055),
    [anon_sym_LBRACK2] = ACTIONS(3055),
    [anon_sym_CARET] = ACTIONS(3055),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT_LT] = ACTIONS(3055),
    [anon_sym_GT_GT] = ACTIONS(3055),
    [anon_sym_GT_GT_GT] = ACTIONS(3055),
    [anon_sym_AMP_CARET] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3053),
    [anon_sym_PIPE_PIPE] = ACTIONS(3053),
    [anon_sym_or] = ACTIONS(3055),
    [anon_sym_QMARK_DOT] = ACTIONS(3053),
    [anon_sym_POUND_LBRACK] = ACTIONS(3053),
    [anon_sym_is] = ACTIONS(3055),
    [anon_sym_BANGis] = ACTIONS(3053),
    [anon_sym_in] = ACTIONS(3055),
    [anon_sym_BANGin] = ACTIONS(3053),
    [anon_sym_STAR_EQ] = ACTIONS(3053),
    [anon_sym_SLASH_EQ] = ACTIONS(3053),
    [anon_sym_PERCENT_EQ] = ACTIONS(3053),
    [anon_sym_LT_LT_EQ] = ACTIONS(3053),
    [anon_sym_GT_GT_EQ] = ACTIONS(3053),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3053),
    [anon_sym_AMP_EQ] = ACTIONS(3053),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3053),
    [anon_sym_PLUS_EQ] = ACTIONS(3053),
    [anon_sym_DASH_EQ] = ACTIONS(3053),
    [anon_sym_PIPE_EQ] = ACTIONS(3053),
    [anon_sym_CARET_EQ] = ACTIONS(3053),
    [anon_sym_COLON_EQ] = ACTIONS(3053),
    [anon_sym_shared] = ACTIONS(3055),
    [anon_sym_map_LBRACK] = ACTIONS(3053),
    [anon_sym_chan] = ACTIONS(3055),
    [anon_sym_thread] = ACTIONS(3055),
    [anon_sym_atomic] = ACTIONS(3055),
  },
  [1959] = {
    [sym_line_comment] = STATE(1959),
    [sym_block_comment] = STATE(1959),
    [sym_identifier] = ACTIONS(3350),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3348),
    [anon_sym_as] = ACTIONS(3350),
    [anon_sym_LBRACE] = ACTIONS(3348),
    [anon_sym_COMMA] = ACTIONS(3348),
    [anon_sym_LPAREN] = ACTIONS(3348),
    [anon_sym_EQ] = ACTIONS(3350),
    [anon_sym_fn] = ACTIONS(3350),
    [anon_sym_PLUS] = ACTIONS(3350),
    [anon_sym_DASH] = ACTIONS(3350),
    [anon_sym_STAR] = ACTIONS(3350),
    [anon_sym_SLASH] = ACTIONS(3350),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_LT] = ACTIONS(3350),
    [anon_sym_GT] = ACTIONS(3350),
    [anon_sym_EQ_EQ] = ACTIONS(3348),
    [anon_sym_BANG_EQ] = ACTIONS(3348),
    [anon_sym_LT_EQ] = ACTIONS(3348),
    [anon_sym_GT_EQ] = ACTIONS(3348),
    [anon_sym_LBRACK] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3350),
    [anon_sym_COLON] = ACTIONS(3348),
    [anon_sym_PLUS_PLUS] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3348),
    [anon_sym_QMARK] = ACTIONS(3350),
    [anon_sym_BANG] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3350),
    [anon_sym_LBRACK2] = ACTIONS(3350),
    [anon_sym_CARET] = ACTIONS(3350),
    [anon_sym_AMP] = ACTIONS(3350),
    [anon_sym_LT_DASH] = ACTIONS(3348),
    [anon_sym_LT_LT] = ACTIONS(3350),
    [anon_sym_GT_GT] = ACTIONS(3350),
    [anon_sym_GT_GT_GT] = ACTIONS(3350),
    [anon_sym_AMP_CARET] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3348),
    [anon_sym_PIPE_PIPE] = ACTIONS(3348),
    [anon_sym_or] = ACTIONS(3350),
    [anon_sym_QMARK_DOT] = ACTIONS(3348),
    [anon_sym_POUND_LBRACK] = ACTIONS(3348),
    [anon_sym_is] = ACTIONS(3350),
    [anon_sym_BANGis] = ACTIONS(3348),
    [anon_sym_in] = ACTIONS(3350),
    [anon_sym_BANGin] = ACTIONS(3348),
    [anon_sym_STAR_EQ] = ACTIONS(3348),
    [anon_sym_SLASH_EQ] = ACTIONS(3348),
    [anon_sym_PERCENT_EQ] = ACTIONS(3348),
    [anon_sym_LT_LT_EQ] = ACTIONS(3348),
    [anon_sym_GT_GT_EQ] = ACTIONS(3348),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3348),
    [anon_sym_AMP_EQ] = ACTIONS(3348),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3348),
    [anon_sym_PLUS_EQ] = ACTIONS(3348),
    [anon_sym_DASH_EQ] = ACTIONS(3348),
    [anon_sym_PIPE_EQ] = ACTIONS(3348),
    [anon_sym_CARET_EQ] = ACTIONS(3348),
    [anon_sym_shared] = ACTIONS(3350),
    [anon_sym_map_LBRACK] = ACTIONS(3348),
    [anon_sym_chan] = ACTIONS(3350),
    [anon_sym_thread] = ACTIONS(3350),
    [anon_sym_atomic] = ACTIONS(3350),
  },
  [1960] = {
    [sym_line_comment] = STATE(1960),
    [sym_block_comment] = STATE(1960),
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(2667),
    [anon_sym_as] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_COMMA] = ACTIONS(2667),
    [anon_sym_LPAREN] = ACTIONS(2667),
    [anon_sym_EQ] = ACTIONS(2669),
    [anon_sym_fn] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2669),
    [anon_sym_SLASH] = ACTIONS(2669),
    [anon_sym_PERCENT] = ACTIONS(2669),
    [anon_sym_LT] = ACTIONS(2669),
    [anon_sym_GT] = ACTIONS(2669),
    [anon_sym_EQ_EQ] = ACTIONS(2667),
    [anon_sym_BANG_EQ] = ACTIONS(2667),
    [anon_sym_LT_EQ] = ACTIONS(2667),
    [anon_sym_GT_EQ] = ACTIONS(2667),
    [anon_sym_LBRACK] = ACTIONS(2667),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_COLON] = ACTIONS(2667),
    [anon_sym_PLUS_PLUS] = ACTIONS(2667),
    [anon_sym_DASH_DASH] = ACTIONS(2667),
    [anon_sym_QMARK] = ACTIONS(2669),
    [anon_sym_BANG] = ACTIONS(2669),
    [anon_sym_PIPE] = ACTIONS(2669),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_CARET] = ACTIONS(2669),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_LT_DASH] = ACTIONS(2667),
    [anon_sym_LT_LT] = ACTIONS(2669),
    [anon_sym_GT_GT] = ACTIONS(2669),
    [anon_sym_GT_GT_GT] = ACTIONS(2669),
    [anon_sym_AMP_CARET] = ACTIONS(2669),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_PIPE_PIPE] = ACTIONS(2667),
    [anon_sym_or] = ACTIONS(2669),
    [anon_sym_QMARK_DOT] = ACTIONS(2667),
    [anon_sym_POUND_LBRACK] = ACTIONS(2667),
    [anon_sym_is] = ACTIONS(2669),
    [anon_sym_BANGis] = ACTIONS(2667),
    [anon_sym_in] = ACTIONS(2669),
    [anon_sym_BANGin] = ACTIONS(2667),
    [anon_sym_STAR_EQ] = ACTIONS(2667),
    [anon_sym_SLASH_EQ] = ACTIONS(2667),
    [anon_sym_PERCENT_EQ] = ACTIONS(2667),
    [anon_sym_LT_LT_EQ] = ACTIONS(2667),
    [anon_sym_GT_GT_EQ] = ACTIONS(2667),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2667),
    [anon_sym_AMP_EQ] = ACTIONS(2667),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(2667),
    [anon_sym_PLUS_EQ] = ACTIONS(2667),
    [anon_sym_DASH_EQ] = ACTIONS(2667),
    [anon_sym_PIPE_EQ] = ACTIONS(2667),
    [anon_sym_CARET_EQ] = ACTIONS(2667),
    [anon_sym_shared] = ACTIONS(2669),
    [anon_sym_map_LBRACK] = ACTIONS(2667),
    [anon_sym_chan] = ACTIONS(2669),
    [anon_sym_thread] = ACTIONS(2669),
    [anon_sym_atomic] = ACTIONS(2669),
  },
  [1961] = {
    [sym_line_comment] = STATE(1961),
    [sym_block_comment] = STATE(1961),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(3053),
    [anon_sym_as] = ACTIONS(3055),
    [anon_sym_LBRACE] = ACTIONS(3053),
    [anon_sym_COMMA] = ACTIONS(3053),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_EQ] = ACTIONS(3055),
    [anon_sym_fn] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3055),
    [anon_sym_SLASH] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(3055),
    [anon_sym_GT] = ACTIONS(3055),
    [anon_sym_EQ_EQ] = ACTIONS(3053),
    [anon_sym_BANG_EQ] = ACTIONS(3053),
    [anon_sym_LT_EQ] = ACTIONS(3053),
    [anon_sym_GT_EQ] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_struct] = ACTIONS(3055),
    [anon_sym_COLON] = ACTIONS(3053),
    [anon_sym_PLUS_PLUS] = ACTIONS(3053),
    [anon_sym_DASH_DASH] = ACTIONS(3053),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_BANG] = ACTIONS(3055),
    [anon_sym_PIPE] = ACTIONS(3055),
    [anon_sym_LBRACK2] = ACTIONS(3055),
    [anon_sym_CARET] = ACTIONS(3055),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT_DASH] = ACTIONS(3053),
    [anon_sym_LT_LT] = ACTIONS(3055),
    [anon_sym_GT_GT] = ACTIONS(3055),
    [anon_sym_GT_GT_GT] = ACTIONS(3055),
    [anon_sym_AMP_CARET] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3053),
    [anon_sym_PIPE_PIPE] = ACTIONS(3053),
    [anon_sym_or] = ACTIONS(3055),
    [anon_sym_QMARK_DOT] = ACTIONS(3053),
    [anon_sym_POUND_LBRACK] = ACTIONS(3053),
    [anon_sym_is] = ACTIONS(3055),
    [anon_sym_BANGis] = ACTIONS(3053),
    [anon_sym_in] = ACTIONS(3055),
    [anon_sym_BANGin] = ACTIONS(3053),
    [anon_sym_STAR_EQ] = ACTIONS(3053),
    [anon_sym_SLASH_EQ] = ACTIONS(3053),
    [anon_sym_PERCENT_EQ] = ACTIONS(3053),
    [anon_sym_LT_LT_EQ] = ACTIONS(3053),
    [anon_sym_GT_GT_EQ] = ACTIONS(3053),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3053),
    [anon_sym_AMP_EQ] = ACTIONS(3053),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(3053),
    [anon_sym_PLUS_EQ] = ACTIONS(3053),
    [anon_sym_DASH_EQ] = ACTIONS(3053),
    [anon_sym_PIPE_EQ] = ACTIONS(3053),
    [anon_sym_CARET_EQ] = ACTIONS(3053),
    [anon_sym_shared] = ACTIONS(3055),
    [anon_sym_map_LBRACK] = ACTIONS(3053),
    [anon_sym_chan] = ACTIONS(3055),
    [anon_sym_thread] = ACTIONS(3055),
    [anon_sym_atomic] = ACTIONS(3055),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(1962), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(602), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_json_DOTdecode,
      anon_sym_LBRACK2,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_DASH,
      sym_float_literal,
      sym_rune_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_c_SQUOTE,
      anon_sym_c_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_map_LBRACK,
      anon_sym_POUND,
    ACTIONS(4992), 34,
      anon_sym_DOT,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_mut,
      anon_sym_go,
      anon_sym_spawn,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      anon_sym_if,
      anon_sym_DOLLARif,
      anon_sym_match,
      anon_sym_select,
      anon_sym_lock,
      anon_sym_rlock,
      anon_sym_unsafe,
      anon_sym_sql,
      sym_int_literal,
      sym_pseudo_compile_time_identifier,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
      anon_sym_assert,
      anon_sym_defer,
      anon_sym_goto,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_return,
      anon_sym_DOLLARfor,
      anon_sym_for,
      anon_sym_asm,
  [73] = 32,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2035), 1,
      anon_sym_SEMI,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(4996), 1,
      anon_sym_as,
    ACTIONS(4998), 1,
      anon_sym_LBRACE,
    ACTIONS(5000), 1,
      anon_sym_COMMA,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5014), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5016), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5024), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5026), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5028), 1,
      anon_sym_or,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    STATE(1792), 1,
      sym_block,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(3389), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5032), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5034), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(1963), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5004), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5010), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5006), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3862), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [200] = 32,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2035), 1,
      anon_sym_SEMI,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(4996), 1,
      anon_sym_as,
    ACTIONS(5000), 1,
      anon_sym_COMMA,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5014), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5016), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5024), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5026), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5028), 1,
      anon_sym_or,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5036), 1,
      anon_sym_LBRACE,
    STATE(1948), 1,
      sym_block,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(3389), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5032), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5034), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(1964), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5004), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5010), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5006), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3862), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [327] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5040), 1,
      anon_sym_LPAREN,
    ACTIONS(5044), 1,
      anon_sym_LBRACK,
    ACTIONS(5046), 1,
      anon_sym_QMARK,
    ACTIONS(5048), 1,
      anon_sym_BANG,
    ACTIONS(5050), 1,
      anon_sym_LBRACK2,
    ACTIONS(5052), 1,
      anon_sym_POUND_LBRACK,
    STATE(2072), 1,
      sym_argument_list,
    STATE(2073), 1,
      sym_or_block,
    STATE(4173), 1,
      sym_type_parameters,
    ACTIONS(5038), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(1965), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2053), 7,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5042), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [420] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2075), 1,
      anon_sym_EQ,
    ACTIONS(5040), 1,
      anon_sym_LPAREN,
    ACTIONS(5044), 1,
      anon_sym_LBRACK,
    ACTIONS(5046), 1,
      anon_sym_QMARK,
    ACTIONS(5048), 1,
      anon_sym_BANG,
    ACTIONS(5050), 1,
      anon_sym_LBRACK2,
    ACTIONS(5052), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5054), 1,
      anon_sym_as,
    ACTIONS(5062), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5064), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5070), 1,
      anon_sym_or,
    STATE(2072), 1,
      sym_argument_list,
    STATE(2073), 1,
      sym_or_block,
    STATE(4173), 1,
      sym_type_parameters,
    ACTIONS(5038), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5058), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5072), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5074), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(1966), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5056), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5060), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5042), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2073), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LT_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [535] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(1967), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2061), 15,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2059), 30,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [626] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(1968), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2053), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5004), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5006), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 30,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [721] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2053), 1,
      anon_sym_EQ,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5034), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(1969), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5004), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5010), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5006), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 24,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [822] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5040), 1,
      anon_sym_LPAREN,
    ACTIONS(5044), 1,
      anon_sym_LBRACK,
    ACTIONS(5046), 1,
      anon_sym_QMARK,
    ACTIONS(5048), 1,
      anon_sym_BANG,
    ACTIONS(5050), 1,
      anon_sym_LBRACK2,
    ACTIONS(5052), 1,
      anon_sym_POUND_LBRACK,
    STATE(2072), 1,
      sym_argument_list,
    STATE(2073), 1,
      sym_or_block,
    STATE(4173), 1,
      sym_type_parameters,
    ACTIONS(5038), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(1970), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2057), 15,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2055), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [913] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5040), 1,
      anon_sym_LPAREN,
    ACTIONS(5044), 1,
      anon_sym_LBRACK,
    ACTIONS(5046), 1,
      anon_sym_QMARK,
    ACTIONS(5048), 1,
      anon_sym_BANG,
    ACTIONS(5050), 1,
      anon_sym_LBRACK2,
    ACTIONS(5052), 1,
      anon_sym_POUND_LBRACK,
    STATE(2072), 1,
      sym_argument_list,
    STATE(2073), 1,
      sym_or_block,
    STATE(4173), 1,
      sym_type_parameters,
    ACTIONS(5038), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(1971), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2053), 15,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [1004] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2075), 1,
      anon_sym_EQ,
    ACTIONS(4996), 1,
      anon_sym_as,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5014), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5016), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5024), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5026), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5028), 1,
      anon_sym_or,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5032), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5034), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(1972), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5004), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5010), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5006), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2073), 16,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [1119] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2065), 1,
      anon_sym_EQ,
    ACTIONS(4996), 1,
      anon_sym_as,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5014), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5016), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5024), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5026), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5028), 1,
      anon_sym_or,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5032), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5034), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(1973), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5004), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5010), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5006), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2063), 16,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [1234] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(1974), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2049), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5004), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5006), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2047), 30,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [1329] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5040), 1,
      anon_sym_LPAREN,
    ACTIONS(5044), 1,
      anon_sym_LBRACK,
    ACTIONS(5046), 1,
      anon_sym_QMARK,
    ACTIONS(5048), 1,
      anon_sym_BANG,
    ACTIONS(5050), 1,
      anon_sym_LBRACK2,
    ACTIONS(5052), 1,
      anon_sym_POUND_LBRACK,
    STATE(2072), 1,
      sym_argument_list,
    STATE(2073), 1,
      sym_or_block,
    STATE(4173), 1,
      sym_type_parameters,
    ACTIONS(5038), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(1975), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2053), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5056), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5042), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [1424] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2035), 1,
      anon_sym_LBRACE,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(4996), 1,
      anon_sym_as,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5014), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5016), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5024), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5026), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5028), 1,
      anon_sym_or,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5076), 1,
      anon_sym_COMMA,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(3389), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5032), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5034), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(1976), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5004), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5010), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5006), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3862), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [1545] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2053), 1,
      anon_sym_EQ,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5024), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5034), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(1977), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5004), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5010), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5006), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 23,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [1648] = 29,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1993), 1,
      anon_sym_LBRACE,
    ACTIONS(2001), 1,
      anon_sym_EQ,
    ACTIONS(4996), 1,
      anon_sym_as,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5014), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5016), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5024), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5026), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5028), 1,
      anon_sym_or,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(3941), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5032), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5034), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(1978), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5004), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5010), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5006), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3908), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [1767] = 29,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1993), 1,
      anon_sym_SEMI,
    ACTIONS(2001), 1,
      anon_sym_EQ,
    ACTIONS(4996), 1,
      anon_sym_as,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5014), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5016), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5028), 1,
      anon_sym_or,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5086), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5088), 1,
      anon_sym_PIPE_PIPE,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4013), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5032), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5090), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(1979), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5078), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5084), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5080), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3908), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [1886] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2065), 1,
      anon_sym_EQ,
    ACTIONS(5040), 1,
      anon_sym_LPAREN,
    ACTIONS(5044), 1,
      anon_sym_LBRACK,
    ACTIONS(5046), 1,
      anon_sym_QMARK,
    ACTIONS(5048), 1,
      anon_sym_BANG,
    ACTIONS(5050), 1,
      anon_sym_LBRACK2,
    ACTIONS(5052), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5054), 1,
      anon_sym_as,
    ACTIONS(5062), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5064), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5070), 1,
      anon_sym_or,
    STATE(2072), 1,
      sym_argument_list,
    STATE(2073), 1,
      sym_or_block,
    STATE(4173), 1,
      sym_type_parameters,
    ACTIONS(5038), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5058), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5072), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5074), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(1980), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5056), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5060), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5042), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2063), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LT_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [2001] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(1981), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2053), 7,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5006), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 30,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [2094] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5040), 1,
      anon_sym_LPAREN,
    ACTIONS(5044), 1,
      anon_sym_LBRACK,
    ACTIONS(5046), 1,
      anon_sym_QMARK,
    ACTIONS(5048), 1,
      anon_sym_BANG,
    ACTIONS(5050), 1,
      anon_sym_LBRACK2,
    ACTIONS(5052), 1,
      anon_sym_POUND_LBRACK,
    STATE(2072), 1,
      sym_argument_list,
    STATE(2073), 1,
      sym_or_block,
    STATE(4173), 1,
      sym_type_parameters,
    ACTIONS(5038), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(1982), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2061), 15,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2059), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [2185] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(1983), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2053), 15,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 30,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [2276] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5040), 1,
      anon_sym_LPAREN,
    ACTIONS(5044), 1,
      anon_sym_LBRACK,
    ACTIONS(5046), 1,
      anon_sym_QMARK,
    ACTIONS(5048), 1,
      anon_sym_BANG,
    ACTIONS(5050), 1,
      anon_sym_LBRACK2,
    ACTIONS(5052), 1,
      anon_sym_POUND_LBRACK,
    STATE(2072), 1,
      sym_argument_list,
    STATE(2073), 1,
      sym_or_block,
    STATE(4173), 1,
      sym_type_parameters,
    ACTIONS(5038), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(1984), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2049), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5056), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5042), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2047), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [2371] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(1985), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2057), 15,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2055), 30,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [2462] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2053), 1,
      anon_sym_EQ,
    ACTIONS(5040), 1,
      anon_sym_LPAREN,
    ACTIONS(5044), 1,
      anon_sym_LBRACK,
    ACTIONS(5046), 1,
      anon_sym_QMARK,
    ACTIONS(5048), 1,
      anon_sym_BANG,
    ACTIONS(5050), 1,
      anon_sym_LBRACK2,
    ACTIONS(5052), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5066), 1,
      anon_sym_AMP_AMP,
    STATE(2072), 1,
      sym_argument_list,
    STATE(2073), 1,
      sym_or_block,
    STATE(4173), 1,
      sym_type_parameters,
    ACTIONS(5038), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5058), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5074), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(1986), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5056), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5060), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5042), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 23,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [2565] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2053), 1,
      anon_sym_EQ,
    ACTIONS(5040), 1,
      anon_sym_LPAREN,
    ACTIONS(5044), 1,
      anon_sym_LBRACK,
    ACTIONS(5046), 1,
      anon_sym_QMARK,
    ACTIONS(5048), 1,
      anon_sym_BANG,
    ACTIONS(5050), 1,
      anon_sym_LBRACK2,
    ACTIONS(5052), 1,
      anon_sym_POUND_LBRACK,
    STATE(2072), 1,
      sym_argument_list,
    STATE(2073), 1,
      sym_or_block,
    STATE(4173), 1,
      sym_type_parameters,
    ACTIONS(5038), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5058), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5074), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(1987), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5056), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5060), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5042), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [2666] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2667), 1,
      anon_sym_LBRACK,
    STATE(1988), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2669), 54,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_fn,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_struct,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_shared,
      anon_sym_map_LBRACK,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
      anon_sym_AT_LBRACK,
  [2736] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2065), 1,
      anon_sym_EQ,
    ACTIONS(4996), 1,
      anon_sym_as,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5014), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5016), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5028), 1,
      anon_sym_or,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5086), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5088), 1,
      anon_sym_PIPE_PIPE,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5032), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5090), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(1989), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5078), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5084), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5080), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2063), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [2850] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2983), 1,
      anon_sym_LBRACK,
    STATE(1990), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2985), 54,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_fn,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_struct,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_shared,
      anon_sym_map_LBRACK,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
      anon_sym_AT_LBRACK,
  [2920] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3348), 1,
      anon_sym_LBRACK,
    STATE(1991), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3350), 54,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_fn,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_struct,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_shared,
      anon_sym_map_LBRACK,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
      anon_sym_AT_LBRACK,
  [2990] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(1992), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2049), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5078), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5080), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2047), 29,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [3084] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2069), 1,
      anon_sym_EQ,
    ACTIONS(4996), 1,
      anon_sym_as,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5014), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5016), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5028), 1,
      anon_sym_or,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5086), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5088), 1,
      anon_sym_PIPE_PIPE,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5090), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5092), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(1993), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5078), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5084), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5080), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2067), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [3198] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(1994), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2169), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2167), 37,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_else,
      anon_sym_DOLLARelse,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [3268] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2053), 1,
      anon_sym_EQ,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5090), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(1995), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5078), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5084), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5080), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 23,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [3368] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5094), 1,
      anon_sym_else,
    STATE(2077), 1,
      sym_else_branch,
    STATE(1996), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2089), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2087), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [3442] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(1997), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2053), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5078), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5080), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 29,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [3536] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(1998), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2053), 7,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5080), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 29,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [3628] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5094), 1,
      anon_sym_else,
    STATE(2070), 1,
      sym_else_branch,
    STATE(1999), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2083), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2081), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [3702] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2075), 1,
      anon_sym_EQ,
    ACTIONS(4996), 1,
      anon_sym_as,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5014), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5016), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5028), 1,
      anon_sym_or,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5086), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5088), 1,
      anon_sym_PIPE_PIPE,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5032), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5090), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2000), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5078), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5084), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5080), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2073), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [3816] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5096), 1,
      anon_sym_else,
    STATE(2194), 1,
      sym_else_branch,
    STATE(2001), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2089), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2087), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [3890] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3047), 1,
      anon_sym_LBRACK,
    STATE(2002), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3049), 54,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_fn,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_struct,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_shared,
      anon_sym_map_LBRACK,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
      anon_sym_AT_LBRACK,
  [3960] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2003), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2169), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2167), 37,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_else,
      anon_sym_DOLLARelse,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [4030] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2004), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2147), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2145), 37,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_else,
      anon_sym_DOLLARelse,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [4100] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2053), 1,
      anon_sym_EQ,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5086), 1,
      anon_sym_AMP_AMP,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5090), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2005), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5078), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5084), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5080), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 22,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [4202] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2006), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2147), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2145), 37,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_else,
      anon_sym_DOLLARelse,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [4272] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5096), 1,
      anon_sym_else,
    STATE(2195), 1,
      sym_else_branch,
    STATE(2007), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2083), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2081), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [4346] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5098), 1,
      anon_sym_COMMA,
    ACTIONS(5100), 1,
      anon_sym_COLON_EQ,
    STATE(4033), 1,
      aux_sym_identifier_list_repeat1,
    ACTIONS(2180), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    STATE(2008), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2175), 19,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2173), 31,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [4424] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3053), 1,
      anon_sym_LBRACK,
    STATE(2009), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3055), 54,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_fn,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_struct,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_shared,
      anon_sym_map_LBRACK,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
      anon_sym_AT_LBRACK,
  [4494] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2069), 1,
      anon_sym_EQ,
    ACTIONS(4996), 1,
      anon_sym_as,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5014), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5016), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5024), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5026), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5028), 1,
      anon_sym_or,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5034), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5092), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(2010), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5004), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5010), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5006), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2067), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [4608] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2001), 1,
      anon_sym_EQ,
    ACTIONS(4996), 1,
      anon_sym_as,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5014), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5016), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5028), 1,
      anon_sym_or,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5086), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5088), 1,
      anon_sym_PIPE_PIPE,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5032), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5090), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2011), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5078), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5084), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5080), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3908), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [4721] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5102), 1,
      anon_sym_DOLLARelse,
    STATE(2012), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2105), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2103), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [4792] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5106), 1,
      anon_sym_COMMA,
    ACTIONS(5108), 1,
      anon_sym_EQ,
    STATE(3388), 1,
      aux_sym_expression_without_blocks_list_repeat1,
    STATE(2013), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5104), 13,
      anon_sym_LBRACE,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3035), 17,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3033), 21,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [4869] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5110), 1,
      anon_sym_DOLLARelse,
    STATE(2014), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2105), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2103), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [4940] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5112), 1,
      anon_sym_DOLLARelse,
    STATE(2015), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2093), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2091), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [5011] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5114), 1,
      anon_sym_DOLLARelse,
    STATE(2016), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2093), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2091), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [5082] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2132), 1,
      sym_type_parameters,
    STATE(2017), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2187), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2185), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [5153] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(2018), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4134), 54,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_fn,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_struct,
      anon_sym_mut,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_go,
      anon_sym_spawn,
      anon_sym_json_DOTdecode,
      anon_sym_LBRACK2,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_DASH,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      anon_sym_if,
      anon_sym_DOLLARif,
      anon_sym_match,
      anon_sym_select,
      anon_sym_lock,
      anon_sym_rlock,
      anon_sym_unsafe,
      anon_sym_sql,
      sym_int_literal,
      sym_float_literal,
      sym_rune_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_c_SQUOTE,
      anon_sym_c_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_r_DQUOTE,
      sym_pseudo_compile_time_identifier,
      sym_identifier,
      anon_sym_shared,
      anon_sym_map_LBRACK,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
  [5220] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2030), 1,
      sym_type_parameters,
    STATE(2019), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2187), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2185), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [5291] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2069), 1,
      anon_sym_EQ,
    ACTIONS(4996), 1,
      anon_sym_as,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5014), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5016), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5028), 1,
      anon_sym_or,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5086), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5088), 1,
      anon_sym_PIPE_PIPE,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5090), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5116), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(2020), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5078), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5084), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5080), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2067), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [5404] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2069), 1,
      anon_sym_EQ,
    ACTIONS(4996), 1,
      anon_sym_as,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5014), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5016), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5028), 1,
      anon_sym_or,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5086), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5088), 1,
      anon_sym_PIPE_PIPE,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5090), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5118), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(2021), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5078), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5084), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5080), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2067), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [5517] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(2022), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5122), 5,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(5120), 49,
      anon_sym_DOT,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_fn,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_struct,
      anon_sym_mut,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_go,
      anon_sym_spawn,
      anon_sym_json_DOTdecode,
      anon_sym_LBRACK2,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_DASH,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      anon_sym_if,
      anon_sym_DOLLARif,
      anon_sym_match,
      anon_sym_select,
      anon_sym_lock,
      anon_sym_rlock,
      anon_sym_unsafe,
      anon_sym_sql,
      sym_int_literal,
      sym_float_literal,
      sym_rune_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_c_SQUOTE,
      anon_sym_c_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_r_DQUOTE,
      sym_pseudo_compile_time_identifier,
      sym_identifier,
      anon_sym_shared,
      anon_sym_map_LBRACK,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
  [5586] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2069), 1,
      anon_sym_EQ,
    ACTIONS(4996), 1,
      anon_sym_as,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5014), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5016), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5028), 1,
      anon_sym_or,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5086), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5088), 1,
      anon_sym_PIPE_PIPE,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5090), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5124), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(2023), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5078), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5084), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5080), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2067), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [5699] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2024), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2993), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2991), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [5767] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2025), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2961), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2959), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [5835] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2026), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2849), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2847), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [5903] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2027), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3043), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [5971] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    STATE(2028), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3043), 34,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [6041] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2029), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3332), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3330), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [6109] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2030), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2841), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2839), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [6177] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2031), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2863), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [6245] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2032), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3296), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3294), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [6313] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2033), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3292), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3290), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [6381] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2034), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3328), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3326), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [6449] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2441), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(2035), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2445), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2448), 33,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [6519] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2036), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3270), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3268), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [6587] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2037), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3266), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3264), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [6655] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2038), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2383), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2381), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [6723] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2039), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2881), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2879), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [6791] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2040), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3041), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3039), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [6859] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2041), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3246), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3244), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [6927] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2042), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3250), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3248), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [6995] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2043), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2957), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2955), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [7063] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2044), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3262), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3260), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [7131] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2045), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2967), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2965), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [7199] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2046), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3035), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3033), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [7267] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2047), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3240), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3238), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [7335] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2048), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2175), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2173), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [7403] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2049), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2929), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2927), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [7471] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2050), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2445), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2448), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [7539] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2051), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2187), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2185), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [7607] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2052), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2893), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2891), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [7675] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2053), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2147), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2145), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [7743] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2054), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3043), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [7811] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2055), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3007), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3005), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [7879] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2056), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2981), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2979), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [7947] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2057), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2977), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2975), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [8015] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2058), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3069), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3067), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [8083] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2059), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3328), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3326), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [8151] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2060), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3300), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3298), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [8219] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2061), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3304), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3302), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [8287] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2062), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3084), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3082), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [8355] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2063), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3308), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3306), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [8423] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2064), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2863), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [8491] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2065), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2833), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2831), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [8559] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2066), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2829), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2827), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [8627] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2067), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2821), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [8695] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2068), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2819), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2817), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [8763] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2069), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2957), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2955), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [8831] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2070), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3336), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3334), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [8899] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2071), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3312), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3310), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [8967] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2072), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2659), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2657), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [9035] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2073), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2655), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2653), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [9103] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2074), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3318), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3316), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [9171] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2075), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3324), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3322), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [9239] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2076), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2837), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2835), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [9307] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2077), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3340), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3338), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [9375] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2078), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3346), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3344), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [9443] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2079), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3256), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3254), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [9511] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2080), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2397), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2395), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [9579] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2081), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3356), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3354), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [9647] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2082), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3035), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3033), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [9715] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2083), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2429), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2427), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [9783] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2084), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3031), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3029), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [9851] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2085), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3240), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3238), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [9919] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2086), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2457), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2455), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [9987] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2087), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2373), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2371), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [10055] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2088), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3023), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3021), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [10123] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2089), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2951), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2949), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [10191] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2090), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3027), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3025), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [10259] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2091), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2453), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2451), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [10327] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2092), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3019), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3017), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [10395] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2093), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3001), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2999), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [10463] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5129), 1,
      anon_sym_BANG,
    STATE(2094), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2697), 17,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2695), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [10533] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2095), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3015), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3013), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [10601] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2096), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3007), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3005), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [10669] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5131), 1,
      anon_sym_LBRACE,
    STATE(2097), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3043), 34,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [10739] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2337), 1,
      anon_sym_LBRACE,
    STATE(2098), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2837), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2835), 34,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [10809] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2099), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2981), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2979), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [10877] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2100), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2401), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2399), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [10945] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2180), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5133), 2,
      anon_sym_COMMA,
      anon_sym_in,
    STATE(2101), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2175), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2173), 31,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [11017] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2102), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2917), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2915), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [11085] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2103), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2921), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2919), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [11153] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2104), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2925), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2923), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [11221] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2105), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2977), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2975), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [11289] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2106), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2989), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2987), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [11357] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2107), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3280), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3278), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [11425] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2108), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2997), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2995), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [11493] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2109), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3250), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3248), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [11561] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2110), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2893), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2891), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [11629] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2111), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2187), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2185), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [11697] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2112), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2377), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2375), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [11765] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2113), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2885), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2883), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [11833] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2114), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3061), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3059), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [11901] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2115), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3065), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3063), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [11969] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2116), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2833), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2831), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [12037] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2117), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3073), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3071), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [12105] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2118), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2829), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2827), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [12173] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2119), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2821), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [12241] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2120), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2819), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2817), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [12309] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2121), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2967), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2965), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [12377] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2122), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3286), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3284), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [12445] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2123), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3246), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3244), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [12513] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2124), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2889), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2887), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [12581] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2125), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2877), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2875), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [12649] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2126), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3266), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3264), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [12717] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2127), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3270), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3268), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [12785] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2128), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3292), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3290), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [12853] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2129), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2947), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2945), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [12921] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2130), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3296), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3294), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [12989] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2131), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3080), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3078), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [13057] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2132), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2841), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2839), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [13125] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2133), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3356), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3354), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [13193] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2134), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2659), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2657), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [13261] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2135), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2655), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2653), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [13329] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2136), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3346), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3344), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [13397] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2137), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3324), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3322), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [13465] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2138), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3318), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3316), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [13533] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2139), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3312), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3310), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [13601] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2140), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2973), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2971), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [13669] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2141), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3274), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3272), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [13737] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2142), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2471), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2469), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [13805] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2143), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2935), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2933), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [13873] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2443), 1,
      anon_sym_EQ,
    STATE(2144), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2441), 16,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
    ACTIONS(2445), 17,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2448), 19,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [13945] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2145), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2873), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2871), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [14013] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2146), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2435), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2433), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [14081] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2147), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3308), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3306), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [14149] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2148), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2397), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2395), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [14217] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2149), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2429), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2427), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [14285] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2150), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2465), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2463), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [14353] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2151), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3304), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3302), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [14421] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2152), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3300), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3298), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [14489] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2180), 1,
      anon_sym_LBRACK,
    ACTIONS(2371), 1,
      anon_sym_LBRACE,
    STATE(2153), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2175), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2173), 33,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [14561] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5135), 1,
      anon_sym_BANG,
    STATE(2154), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2697), 17,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2695), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [14631] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2155), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2373), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2371), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [14699] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2156), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2457), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2455), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [14767] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2157), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2951), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2949), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [14835] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2158), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2873), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2871), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [14903] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2159), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3280), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3278), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [14971] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2160), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3084), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3082), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [15039] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2161), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3069), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3067), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [15107] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2162), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2885), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2883), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [15175] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2180), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    STATE(2163), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2175), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2173), 33,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [15245] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2164), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3286), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3284), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [15313] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2165), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2917), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2915), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [15381] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2166), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3080), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3078), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [15449] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2167), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3041), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3039), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [15517] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2168), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2175), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2173), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [15585] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2180), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    STATE(2169), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2175), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2173), 33,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [15655] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2170), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2335), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2337), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [15723] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    STATE(2171), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2373), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2371), 34,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [15793] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2172), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3031), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3029), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [15861] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    STATE(2173), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2373), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2371), 34,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [15931] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2174), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2335), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2337), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [15999] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2175), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3027), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3025), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [16067] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2176), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2465), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2463), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [16135] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2177), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2147), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2145), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [16203] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2178), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2925), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2923), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [16271] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2179), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2989), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2987), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [16339] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2180), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2377), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2375), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [16407] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2181), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2435), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2433), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [16475] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2182), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2993), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2991), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [16543] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2183), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2997), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2995), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [16611] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2184), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3061), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3059), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [16679] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2185), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3065), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3063), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [16747] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2186), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2471), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2469), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [16815] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2187), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2947), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2945), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [16883] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2188), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2837), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2835), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [16951] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2337), 1,
      anon_sym_LBRACE,
    STATE(2189), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2147), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2145), 34,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [17021] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2190), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2453), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2451), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [17089] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2443), 1,
      anon_sym_EQ,
    STATE(2191), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2441), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LT_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2445), 17,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2448), 19,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [17161] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2192), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3001), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2999), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [17229] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2193), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2973), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2971), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [17297] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2194), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3340), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3338), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [17365] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2195), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3336), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3334), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [17433] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2196), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2639), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2637), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [17501] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2197), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3332), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3330), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [17569] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2198), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3274), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3272), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [17637] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(2199), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5139), 5,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(5137), 48,
      anon_sym_DOT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_fn,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_mut,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_go,
      anon_sym_spawn,
      anon_sym_json_DOTdecode,
      anon_sym_LBRACK2,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_DASH,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      anon_sym_if,
      anon_sym_DOLLARif,
      anon_sym_match,
      anon_sym_select,
      anon_sym_lock,
      anon_sym_rlock,
      anon_sym_unsafe,
      anon_sym_sql,
      sym_int_literal,
      sym_float_literal,
      sym_rune_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_c_SQUOTE,
      anon_sym_c_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_r_DQUOTE,
      sym_pseudo_compile_time_identifier,
      sym_identifier,
      anon_sym_shared,
      anon_sym_map_LBRACK,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
  [17705] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    STATE(2200), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3043), 34,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [17775] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2201), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3256), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3254), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [17843] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2202), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2631), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2629), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [17911] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2203), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2627), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2625), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [17979] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2204), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3073), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3071), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [18047] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2205), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2921), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2919), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [18115] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2206), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3262), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3260), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [18183] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2207), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2647), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2645), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [18251] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2208), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2651), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2649), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [18319] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2209), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2845), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2843), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [18387] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2210), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2647), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2645), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [18455] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2211), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2401), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2399), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [18523] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2212), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2961), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2959), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [18591] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2213), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2889), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2887), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [18659] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2214), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3015), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3013), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [18727] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2215), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3019), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3017), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [18795] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2216), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3023), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3021), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [18863] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2217), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2651), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2649), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [18931] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2218), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2877), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2875), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [18999] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2219), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2935), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2933), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [19067] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2220), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2849), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2847), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [19135] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2221), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2627), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2625), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [19203] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2222), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2631), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2629), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [19271] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2223), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2639), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2637), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [19339] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2224), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2845), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2843), 35,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [19407] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2225), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2383), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2381), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [19475] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2226), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2881), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2879), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [19543] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2227), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2929), 18,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2927), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LT_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [19611] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2228), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2669), 24,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_fn,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_struct,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_is,
      anon_sym_in,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
    ACTIONS(2667), 28,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_BANGis,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_map_LBRACK,
      anon_sym_DOT_DOT,
  [19678] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2229), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2985), 24,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_fn,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_struct,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_is,
      anon_sym_in,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
    ACTIONS(2983), 28,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_BANGis,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_map_LBRACK,
      anon_sym_DOT_DOT,
  [19745] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2230), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3350), 24,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_fn,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_struct,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_is,
      anon_sym_in,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
    ACTIONS(3348), 28,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_BANGis,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_map_LBRACK,
      anon_sym_DOT_DOT,
  [19812] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2231), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3049), 24,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_fn,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_struct,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_is,
      anon_sym_in,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
    ACTIONS(3047), 28,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_BANGis,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_map_LBRACK,
      anon_sym_DOT_DOT,
  [19879] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2232), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3055), 24,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_fn,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_struct,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_is,
      anon_sym_in,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
    ACTIONS(3053), 28,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_BANGis,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_map_LBRACK,
      anon_sym_DOT_DOT,
  [19946] = 13,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_QMARK,
    ACTIONS(5149), 1,
      anon_sym_BANG,
    STATE(2338), 1,
      sym_or_block,
    STATE(2340), 1,
      sym_argument_list,
    STATE(4346), 1,
      sym_type_parameters,
    ACTIONS(5141), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5151), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    STATE(2233), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2061), 40,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [20028] = 13,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_QMARK,
    ACTIONS(5149), 1,
      anon_sym_BANG,
    STATE(2338), 1,
      sym_or_block,
    STATE(2340), 1,
      sym_argument_list,
    STATE(4346), 1,
      sym_type_parameters,
    ACTIONS(5141), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5151), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    STATE(2234), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2053), 40,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [20110] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5155), 1,
      anon_sym_EQ,
    STATE(2235), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5153), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3035), 17,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(3033), 19,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [20180] = 13,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_QMARK,
    ACTIONS(5149), 1,
      anon_sym_BANG,
    STATE(2338), 1,
      sym_or_block,
    STATE(2340), 1,
      sym_argument_list,
    STATE(4346), 1,
      sym_type_parameters,
    ACTIONS(5141), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5151), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    STATE(2236), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2057), 40,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [20262] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2941), 1,
      anon_sym_static,
    ACTIONS(2943), 1,
      anon_sym_volatile,
    ACTIONS(5157), 1,
      anon_sym_COLON,
    STATE(2237), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4961), 22,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_json_DOTdecode,
      anon_sym_LBRACK2,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_DASH,
      sym_float_literal,
      sym_rune_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_c_SQUOTE,
      anon_sym_c_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_map_LBRACK,
    ACTIONS(4959), 25,
      anon_sym_DOT,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_mut,
      anon_sym_go,
      anon_sym_spawn,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      anon_sym_if,
      anon_sym_DOLLARif,
      anon_sym_match,
      anon_sym_select,
      anon_sym_lock,
      anon_sym_rlock,
      anon_sym_unsafe,
      anon_sym_sql,
      sym_int_literal,
      sym_pseudo_compile_time_identifier,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
  [20333] = 7,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2087), 1,
      anon_sym_LBRACK,
    ACTIONS(5159), 1,
      anon_sym_else,
    STATE(2274), 1,
      sym_else_branch,
    STATE(2238), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2089), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [20402] = 7,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2081), 1,
      anon_sym_LBRACK,
    ACTIONS(5159), 1,
      anon_sym_else,
    STATE(2275), 1,
      sym_else_branch,
    STATE(2239), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2083), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [20471] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2240), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5163), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_json_DOTdecode,
      anon_sym_LBRACK2,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_DASH,
      sym_float_literal,
      sym_rune_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_c_SQUOTE,
      anon_sym_c_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_map_LBRACK,
    ACTIONS(5161), 26,
      anon_sym_DOT,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_mut,
      anon_sym_go,
      anon_sym_spawn,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      anon_sym_if,
      anon_sym_else,
      anon_sym_DOLLARif,
      anon_sym_match,
      anon_sym_select,
      anon_sym_lock,
      anon_sym_rlock,
      anon_sym_unsafe,
      anon_sym_sql,
      sym_int_literal,
      sym_pseudo_compile_time_identifier,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
  [20535] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2103), 1,
      anon_sym_LBRACK,
    ACTIONS(5165), 1,
      anon_sym_DOLLARelse,
    STATE(2241), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2105), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [20601] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2167), 1,
      anon_sym_LBRACK,
    STATE(2242), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2169), 48,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_DOLLARelse,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [20665] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2243), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5169), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_json_DOTdecode,
      anon_sym_LBRACK2,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_DASH,
      sym_float_literal,
      sym_rune_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_c_SQUOTE,
      anon_sym_c_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_map_LBRACK,
    ACTIONS(5167), 26,
      anon_sym_DOT,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_mut,
      anon_sym_go,
      anon_sym_spawn,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      anon_sym_if,
      anon_sym_else,
      anon_sym_DOLLARif,
      anon_sym_match,
      anon_sym_select,
      anon_sym_lock,
      anon_sym_rlock,
      anon_sym_unsafe,
      anon_sym_sql,
      sym_int_literal,
      sym_pseudo_compile_time_identifier,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
  [20729] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2185), 1,
      anon_sym_LBRACK,
    STATE(2337), 1,
      sym_type_parameters,
    STATE(2244), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2187), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [20795] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2245), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5173), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_json_DOTdecode,
      anon_sym_LBRACK2,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_DASH,
      sym_float_literal,
      sym_rune_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_c_SQUOTE,
      anon_sym_c_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_map_LBRACK,
    ACTIONS(5171), 26,
      anon_sym_DOT,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_mut,
      anon_sym_go,
      anon_sym_spawn,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      anon_sym_if,
      anon_sym_else,
      anon_sym_DOLLARif,
      anon_sym_match,
      anon_sym_select,
      anon_sym_lock,
      anon_sym_rlock,
      anon_sym_unsafe,
      anon_sym_sql,
      sym_int_literal,
      sym_pseudo_compile_time_identifier,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
  [20859] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2246), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5177), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_json_DOTdecode,
      anon_sym_LBRACK2,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_DASH,
      sym_float_literal,
      sym_rune_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_c_SQUOTE,
      anon_sym_c_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_map_LBRACK,
    ACTIONS(5175), 26,
      anon_sym_DOT,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_mut,
      anon_sym_go,
      anon_sym_spawn,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      anon_sym_if,
      anon_sym_else,
      anon_sym_DOLLARif,
      anon_sym_match,
      anon_sym_select,
      anon_sym_lock,
      anon_sym_rlock,
      anon_sym_unsafe,
      anon_sym_sql,
      sym_int_literal,
      sym_pseudo_compile_time_identifier,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
  [20923] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2145), 1,
      anon_sym_LBRACK,
    STATE(2247), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2147), 48,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_DOLLARelse,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [20987] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2941), 1,
      anon_sym_static,
    ACTIONS(2943), 1,
      anon_sym_volatile,
    STATE(2248), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4961), 22,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_json_DOTdecode,
      anon_sym_LBRACK2,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_DASH,
      sym_float_literal,
      sym_rune_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_c_SQUOTE,
      anon_sym_c_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_map_LBRACK,
    ACTIONS(4959), 25,
      anon_sym_DOT,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_mut,
      anon_sym_go,
      anon_sym_spawn,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      anon_sym_if,
      anon_sym_DOLLARif,
      anon_sym_match,
      anon_sym_select,
      anon_sym_lock,
      anon_sym_rlock,
      anon_sym_unsafe,
      anon_sym_sql,
      sym_int_literal,
      sym_pseudo_compile_time_identifier,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
  [21055] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2249), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5181), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_json_DOTdecode,
      anon_sym_LBRACK2,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_DASH,
      sym_float_literal,
      sym_rune_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_c_SQUOTE,
      anon_sym_c_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_map_LBRACK,
    ACTIONS(5179), 26,
      anon_sym_DOT,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_mut,
      anon_sym_go,
      anon_sym_spawn,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      anon_sym_if,
      anon_sym_else,
      anon_sym_DOLLARif,
      anon_sym_match,
      anon_sym_select,
      anon_sym_lock,
      anon_sym_rlock,
      anon_sym_unsafe,
      anon_sym_sql,
      sym_int_literal,
      sym_pseudo_compile_time_identifier,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
  [21119] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2250), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2145), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_json_DOTdecode,
      anon_sym_LBRACK2,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_DASH,
      sym_float_literal,
      sym_rune_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_c_SQUOTE,
      anon_sym_c_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_map_LBRACK,
    ACTIONS(2147), 26,
      anon_sym_DOT,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_mut,
      anon_sym_go,
      anon_sym_spawn,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      anon_sym_if,
      anon_sym_else,
      anon_sym_DOLLARif,
      anon_sym_match,
      anon_sym_select,
      anon_sym_lock,
      anon_sym_rlock,
      anon_sym_unsafe,
      anon_sym_sql,
      sym_int_literal,
      sym_pseudo_compile_time_identifier,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
  [21183] = 27,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_QMARK,
    ACTIONS(5149), 1,
      anon_sym_BANG,
    ACTIONS(5151), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5185), 1,
      anon_sym_as,
    ACTIONS(5193), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5195), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5197), 1,
      anon_sym_LBRACK2,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5201), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5203), 1,
      anon_sym_or,
    ACTIONS(5209), 1,
      anon_sym_AT_LBRACK,
    STATE(2338), 1,
      sym_or_block,
    STATE(2340), 1,
      sym_argument_list,
    STATE(3503), 1,
      sym_attribute,
    STATE(4346), 1,
      sym_type_parameters,
    ACTIONS(5141), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5205), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5207), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2251), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5187), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5191), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5183), 8,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
    ACTIONS(5189), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [21291] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2145), 1,
      anon_sym_LBRACK,
    STATE(2252), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2147), 48,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_else,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [21355] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2167), 1,
      anon_sym_LBRACK,
    STATE(2253), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2169), 48,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_else,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [21419] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2254), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1802), 24,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_json_DOTdecode,
      anon_sym_LBRACK2,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_DASH,
      sym_float_literal,
      sym_rune_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_c_SQUOTE,
      anon_sym_c_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_map_LBRACK,
    ACTIONS(5211), 25,
      anon_sym_DOT,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_mut,
      anon_sym_go,
      anon_sym_spawn,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      anon_sym_if,
      anon_sym_DOLLARif,
      anon_sym_match,
      anon_sym_select,
      anon_sym_lock,
      anon_sym_rlock,
      anon_sym_unsafe,
      anon_sym_sql,
      sym_int_literal,
      sym_pseudo_compile_time_identifier,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
  [21483] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2255), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2167), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_json_DOTdecode,
      anon_sym_LBRACK2,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_DASH,
      sym_float_literal,
      sym_rune_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_c_SQUOTE,
      anon_sym_c_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_map_LBRACK,
    ACTIONS(2169), 26,
      anon_sym_DOT,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_mut,
      anon_sym_go,
      anon_sym_spawn,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      anon_sym_if,
      anon_sym_else,
      anon_sym_DOLLARif,
      anon_sym_match,
      anon_sym_select,
      anon_sym_lock,
      anon_sym_rlock,
      anon_sym_unsafe,
      anon_sym_sql,
      sym_int_literal,
      sym_pseudo_compile_time_identifier,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
  [21547] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2180), 1,
      anon_sym_LBRACK,
    ACTIONS(2373), 1,
      anon_sym_LBRACE,
    STATE(2256), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2175), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [21613] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2091), 1,
      anon_sym_LBRACK,
    ACTIONS(5213), 1,
      anon_sym_DOLLARelse,
    STATE(2257), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2093), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [21679] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2821), 1,
      anon_sym_LBRACK,
    STATE(2258), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [21742] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3344), 1,
      anon_sym_LBRACK,
    STATE(2259), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3346), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [21805] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2371), 1,
      anon_sym_LBRACK,
    STATE(2260), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2373), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [21868] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2455), 1,
      anon_sym_LBRACK,
    STATE(2261), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2457), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [21931] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    STATE(2262), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3262), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [21994] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3082), 1,
      anon_sym_LBRACK,
    STATE(2263), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3084), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [22057] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2264), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2722), 23,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_json_DOTdecode,
      anon_sym_LBRACK2,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_DASH,
      sym_float_literal,
      sym_rune_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_c_SQUOTE,
      anon_sym_c_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_map_LBRACK,
    ACTIONS(5215), 25,
      anon_sym_DOT,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_mut,
      anon_sym_go,
      anon_sym_spawn,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      anon_sym_if,
      anon_sym_DOLLARif,
      anon_sym_match,
      anon_sym_select,
      anon_sym_lock,
      anon_sym_rlock,
      anon_sym_unsafe,
      anon_sym_sql,
      sym_int_literal,
      sym_pseudo_compile_time_identifier,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
  [22120] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2173), 1,
      anon_sym_LBRACK,
    STATE(2265), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2175), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [22183] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2887), 1,
      anon_sym_LBRACK,
    STATE(2266), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2889), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [22246] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2875), 1,
      anon_sym_LBRACK,
    STATE(2267), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2877), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [22309] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2847), 1,
      anon_sym_LBRACK,
    STATE(2268), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2849), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [22372] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2843), 1,
      anon_sym_LBRACK,
    STATE(2269), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2845), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [22435] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3039), 1,
      anon_sym_LBRACK,
    STATE(2270), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3041), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [22498] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2945), 1,
      anon_sym_LBRACK,
    STATE(2271), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2947), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [22561] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3029), 1,
      anon_sym_LBRACK,
    STATE(2272), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3031), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [22624] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3078), 1,
      anon_sym_LBRACK,
    STATE(2273), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3080), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [22687] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3338), 1,
      anon_sym_LBRACK,
    STATE(2274), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3340), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [22750] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3334), 1,
      anon_sym_LBRACK,
    STATE(2275), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3336), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [22813] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2863), 1,
      anon_sym_LBRACK,
    STATE(2276), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [22876] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    STATE(2277), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3332), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [22939] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3272), 1,
      anon_sym_LBRACK,
    STATE(2278), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3274), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [23002] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3254), 1,
      anon_sym_LBRACK,
    STATE(2279), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3256), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [23065] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3063), 1,
      anon_sym_LBRACK,
    STATE(2280), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3065), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [23128] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3025), 1,
      anon_sym_LBRACK,
    STATE(2281), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3027), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [23191] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2971), 1,
      anon_sym_LBRACK,
    STATE(2282), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2973), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [23254] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_LBRACK,
    STATE(2283), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2961), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [23317] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2451), 1,
      anon_sym_LBRACK,
    STATE(2284), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2453), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [23380] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2933), 1,
      anon_sym_LBRACK,
    STATE(2285), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2935), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [23443] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3059), 1,
      anon_sym_LBRACK,
    STATE(2286), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3061), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [23506] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2649), 1,
      anon_sym_LBRACK,
    STATE(2287), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2651), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [23569] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2645), 1,
      anon_sym_LBRACK,
    STATE(2288), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2647), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [23632] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2999), 1,
      anon_sym_LBRACK,
    STATE(2289), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3001), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [23695] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2290), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3053), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_BANGis,
      anon_sym_BANGin,
      anon_sym_map_LBRACK,
    ACTIONS(3055), 24,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_fn,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_struct,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_is,
      anon_sym_in,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
      anon_sym_DOT_DOT,
  [23758] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2995), 1,
      anon_sym_LBRACK,
    STATE(2291), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2997), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [23821] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2463), 1,
      anon_sym_LBRACK,
    STATE(2292), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2465), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [23884] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2625), 1,
      anon_sym_LBRACK,
    STATE(2293), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2627), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [23947] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2629), 1,
      anon_sym_LBRACK,
    STATE(2294), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2631), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [24010] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2637), 1,
      anon_sym_LBRACK,
    STATE(2295), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2639), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [24073] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2381), 1,
      anon_sym_LBRACK,
    STATE(2296), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2383), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [24136] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2879), 1,
      anon_sym_LBRACK,
    STATE(2297), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2881), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [24199] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2927), 1,
      anon_sym_LBRACK,
    STATE(2298), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2929), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [24262] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2949), 1,
      anon_sym_LBRACK,
    STATE(2299), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2951), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [24325] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2399), 1,
      anon_sym_LBRACK,
    STATE(2300), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2401), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [24388] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3278), 1,
      anon_sym_LBRACK,
    STATE(2301), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3280), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [24451] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2375), 1,
      anon_sym_LBRACK,
    STATE(2302), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2377), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [24514] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3284), 1,
      anon_sym_LBRACK,
    STATE(2303), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3286), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [24577] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2304), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3047), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_BANGis,
      anon_sym_BANGin,
      anon_sym_map_LBRACK,
    ACTIONS(3049), 24,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_fn,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_struct,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_is,
      anon_sym_in,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
      anon_sym_DOT_DOT,
  [24640] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2991), 1,
      anon_sym_LBRACK,
    STATE(2305), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2993), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [24703] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2306), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2667), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_BANGis,
      anon_sym_BANGin,
      anon_sym_map_LBRACK,
    ACTIONS(2669), 24,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_fn,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_struct,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_is,
      anon_sym_in,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
      anon_sym_DOT_DOT,
  [24766] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2987), 1,
      anon_sym_LBRACK,
    STATE(2307), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2989), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [24829] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2308), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2983), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_BANGis,
      anon_sym_BANGin,
      anon_sym_map_LBRACK,
    ACTIONS(2985), 24,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_fn,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_struct,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_is,
      anon_sym_in,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
      anon_sym_DOT_DOT,
  [24892] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2309), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3348), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_BANGis,
      anon_sym_BANGin,
      anon_sym_map_LBRACK,
    ACTIONS(3350), 24,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_fn,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_struct,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_is,
      anon_sym_in,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
      anon_sym_DOT_DOT,
  [24955] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2923), 1,
      anon_sym_LBRACK,
    STATE(2310), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2925), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [25018] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2919), 1,
      anon_sym_LBRACK,
    STATE(2311), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2921), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [25081] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2915), 1,
      anon_sym_LBRACK,
    STATE(2312), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2917), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [25144] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2883), 1,
      anon_sym_LBRACK,
    STATE(2313), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2885), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [25207] = 15,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_QMARK,
    ACTIONS(5149), 1,
      anon_sym_BANG,
    STATE(2338), 1,
      sym_or_block,
    STATE(2340), 1,
      sym_argument_list,
    STATE(4346), 1,
      sym_type_parameters,
    ACTIONS(5141), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5151), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    STATE(2314), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5187), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5189), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2049), 25,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [25290] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2871), 1,
      anon_sym_LBRACK,
    STATE(2315), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2873), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [25353] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    STATE(2316), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2697), 46,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [25418] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3298), 1,
      anon_sym_LBRACK,
    STATE(2317), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3300), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [25481] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3302), 1,
      anon_sym_LBRACK,
    STATE(2318), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3304), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [25544] = 24,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_QMARK,
    ACTIONS(5149), 1,
      anon_sym_BANG,
    ACTIONS(5185), 1,
      anon_sym_as,
    ACTIONS(5193), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5195), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5201), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5203), 1,
      anon_sym_or,
    STATE(2338), 1,
      sym_or_block,
    STATE(2340), 1,
      sym_argument_list,
    STATE(4346), 1,
      sym_type_parameters,
    ACTIONS(5141), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5151), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    ACTIONS(5205), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5207), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2319), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5187), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5191), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5189), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2075), 9,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [25645] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2320), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2226), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_json_DOTdecode,
      anon_sym_LBRACK2,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_DASH,
      sym_float_literal,
      sym_rune_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_c_SQUOTE,
      anon_sym_c_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_map_LBRACK,
    ACTIONS(5219), 25,
      anon_sym_DOT,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_mut,
      anon_sym_go,
      anon_sym_spawn,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      anon_sym_if,
      anon_sym_DOLLARif,
      anon_sym_match,
      anon_sym_select,
      anon_sym_lock,
      anon_sym_rlock,
      anon_sym_unsafe,
      anon_sym_sql,
      sym_int_literal,
      sym_pseudo_compile_time_identifier,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
  [25708] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3306), 1,
      anon_sym_LBRACK,
    STATE(2321), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3308), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [25771] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3310), 1,
      anon_sym_LBRACK,
    STATE(2322), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3312), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [25834] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3316), 1,
      anon_sym_LBRACK,
    STATE(2323), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3318), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [25897] = 14,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_QMARK,
    ACTIONS(5149), 1,
      anon_sym_BANG,
    STATE(2338), 1,
      sym_or_block,
    STATE(2340), 1,
      sym_argument_list,
    STATE(4346), 1,
      sym_type_parameters,
    ACTIONS(5141), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5151), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    STATE(2324), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5189), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2053), 29,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [25978] = 15,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_QMARK,
    ACTIONS(5149), 1,
      anon_sym_BANG,
    STATE(2338), 1,
      sym_or_block,
    STATE(2340), 1,
      sym_argument_list,
    STATE(4346), 1,
      sym_type_parameters,
    ACTIONS(5141), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5151), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    STATE(2325), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5187), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5189), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2053), 25,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [26061] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3322), 1,
      anon_sym_LBRACK,
    STATE(2326), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3324), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [26124] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3071), 1,
      anon_sym_LBRACK,
    STATE(2327), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3073), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [26187] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3248), 1,
      anon_sym_LBRACK,
    STATE(2328), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3250), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [26250] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2427), 1,
      anon_sym_LBRACK,
    STATE(2329), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2429), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [26313] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3354), 1,
      anon_sym_LBRACK,
    STATE(2330), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3356), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [26376] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5225), 1,
      anon_sym_volatile,
    STATE(2331), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5223), 22,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_json_DOTdecode,
      anon_sym_LBRACK2,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_DASH,
      sym_float_literal,
      sym_rune_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_c_SQUOTE,
      anon_sym_c_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_map_LBRACK,
    ACTIONS(5221), 25,
      anon_sym_DOT,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_mut,
      anon_sym_go,
      anon_sym_spawn,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      anon_sym_if,
      anon_sym_DOLLARif,
      anon_sym_match,
      anon_sym_select,
      anon_sym_lock,
      anon_sym_rlock,
      anon_sym_unsafe,
      anon_sym_sql,
      sym_int_literal,
      sym_pseudo_compile_time_identifier,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
  [26441] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2395), 1,
      anon_sym_LBRACK,
    STATE(2332), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2397), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [26504] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2337), 1,
      anon_sym_LBRACK,
    STATE(2333), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2335), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [26567] = 17,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_QMARK,
    ACTIONS(5149), 1,
      anon_sym_BANG,
    STATE(2338), 1,
      sym_or_block,
    STATE(2340), 1,
      sym_argument_list,
    STATE(4346), 1,
      sym_type_parameters,
    ACTIONS(5141), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5151), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    ACTIONS(5207), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2334), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5187), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5191), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5189), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2053), 17,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [26654] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2433), 1,
      anon_sym_LBRACK,
    STATE(2335), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2435), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [26717] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    STATE(2336), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2471), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [26780] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2839), 1,
      anon_sym_LBRACK,
    STATE(2337), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2841), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [26843] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2653), 1,
      anon_sym_LBRACK,
    STATE(2338), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2655), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [26906] = 18,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_QMARK,
    ACTIONS(5149), 1,
      anon_sym_BANG,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    STATE(2338), 1,
      sym_or_block,
    STATE(2340), 1,
      sym_argument_list,
    STATE(4346), 1,
      sym_type_parameters,
    ACTIONS(5141), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5151), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    ACTIONS(5207), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2339), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5187), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5191), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5189), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2053), 16,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [26995] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2657), 1,
      anon_sym_LBRACK,
    STATE(2340), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2659), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [27058] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2817), 1,
      anon_sym_LBRACK,
    STATE(2341), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2819), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [27121] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2827), 1,
      anon_sym_LBRACK,
    STATE(2342), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2829), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [27184] = 29,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2175), 1,
      anon_sym_DOT,
    ACTIONS(2371), 1,
      anon_sym_LBRACK,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(3808), 1,
      anon_sym_fn,
    ACTIONS(3810), 1,
      anon_sym_STAR,
    ACTIONS(3812), 1,
      anon_sym_struct,
    ACTIONS(3814), 1,
      anon_sym_QMARK,
    ACTIONS(3816), 1,
      anon_sym_BANG,
    ACTIONS(3818), 1,
      anon_sym_LBRACK2,
    ACTIONS(3820), 1,
      anon_sym_AMP,
    ACTIONS(3822), 1,
      anon_sym_shared,
    ACTIONS(3824), 1,
      anon_sym_map_LBRACK,
    ACTIONS(3826), 1,
      anon_sym_chan,
    ACTIONS(3828), 1,
      anon_sym_thread,
    ACTIONS(3830), 1,
      anon_sym_atomic,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5229), 1,
      anon_sym_LT2,
    STATE(3452), 1,
      sym_plain_type,
    STATE(3454), 1,
      sym_signature,
    STATE(3772), 1,
      sym_generic_parameters,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(2343), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2532), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3458), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    ACTIONS(2373), 7,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
    STATE(3459), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [27295] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2831), 1,
      anon_sym_LBRACK,
    STATE(2344), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2833), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [27358] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2345), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5233), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_json_DOTdecode,
      anon_sym_LBRACK2,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_DASH,
      sym_float_literal,
      sym_rune_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_c_SQUOTE,
      anon_sym_c_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_map_LBRACK,
    ACTIONS(5231), 25,
      anon_sym_DOT,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_mut,
      anon_sym_go,
      anon_sym_spawn,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      anon_sym_if,
      anon_sym_DOLLARif,
      anon_sym_match,
      anon_sym_select,
      anon_sym_lock,
      anon_sym_rlock,
      anon_sym_unsafe,
      anon_sym_sql,
      sym_int_literal,
      sym_pseudo_compile_time_identifier,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
  [27421] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3294), 1,
      anon_sym_LBRACK,
    STATE(2346), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3296), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [27484] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3290), 1,
      anon_sym_LBRACK,
    STATE(2347), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3292), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [27547] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3268), 1,
      anon_sym_LBRACK,
    STATE(2348), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3270), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [27610] = 24,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_QMARK,
    ACTIONS(5149), 1,
      anon_sym_BANG,
    ACTIONS(5185), 1,
      anon_sym_as,
    ACTIONS(5193), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5195), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5201), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5203), 1,
      anon_sym_or,
    STATE(2338), 1,
      sym_or_block,
    STATE(2340), 1,
      sym_argument_list,
    STATE(4346), 1,
      sym_type_parameters,
    ACTIONS(5141), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5151), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    ACTIONS(5205), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5207), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2349), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5187), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5191), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5189), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2065), 9,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [27711] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3264), 1,
      anon_sym_LBRACK,
    STATE(2350), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3266), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [27774] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2975), 1,
      anon_sym_LBRACK,
    STATE(2351), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2977), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [27837] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2979), 1,
      anon_sym_LBRACK,
    STATE(2352), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2981), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [27900] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3005), 1,
      anon_sym_LBRACK,
    STATE(2353), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3007), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [27963] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3013), 1,
      anon_sym_LBRACK,
    STATE(2354), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3015), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [28026] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3017), 1,
      anon_sym_LBRACK,
    STATE(2355), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3019), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [28089] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3021), 1,
      anon_sym_LBRACK,
    STATE(2356), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3023), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [28152] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3238), 1,
      anon_sym_LBRACK,
    STATE(2357), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3240), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [28215] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_LBRACK,
    STATE(2358), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2957), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [28278] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3033), 1,
      anon_sym_LBRACK,
    STATE(2359), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3035), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [28341] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2448), 1,
      anon_sym_LBRACK,
    STATE(2360), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2443), 12,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
      anon_sym_AT_LBRACK,
    ACTIONS(2445), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [28406] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3244), 1,
      anon_sym_LBRACK,
    STATE(2361), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3246), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [28469] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2965), 1,
      anon_sym_LBRACK,
    STATE(2362), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2967), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [28532] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3326), 1,
      anon_sym_LBRACK,
    STATE(2363), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3328), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [28595] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2177), 1,
      anon_sym_DOT,
    ACTIONS(2371), 1,
      anon_sym_LBRACK,
    STATE(2364), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2373), 46,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [28660] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2185), 1,
      anon_sym_LBRACK,
    STATE(2365), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2187), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [28723] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2891), 1,
      anon_sym_LBRACK,
    STATE(2366), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2893), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [28786] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3043), 1,
      anon_sym_LBRACK,
    ACTIONS(3075), 1,
      anon_sym_DOT,
    STATE(2367), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 46,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [28851] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    STATE(2368), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3069), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [28914] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3043), 1,
      anon_sym_LBRACK,
    STATE(2369), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 47,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [28977] = 15,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_QMARK,
    ACTIONS(5149), 1,
      anon_sym_BANG,
    STATE(2338), 1,
      sym_or_block,
    STATE(2340), 1,
      sym_argument_list,
    STATE(4346), 1,
      sym_type_parameters,
    ACTIONS(5141), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5151), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    STATE(2370), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5235), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5237), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2053), 24,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
  [29059] = 24,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_QMARK,
    ACTIONS(5149), 1,
      anon_sym_BANG,
    ACTIONS(5185), 1,
      anon_sym_as,
    ACTIONS(5193), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5195), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5203), 1,
      anon_sym_or,
    ACTIONS(5241), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5243), 1,
      anon_sym_PIPE_PIPE,
    STATE(2338), 1,
      sym_or_block,
    STATE(2340), 1,
      sym_argument_list,
    STATE(4346), 1,
      sym_type_parameters,
    ACTIONS(5141), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5151), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    ACTIONS(5205), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5245), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2371), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5235), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5239), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(4136), 8,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
    ACTIONS(5237), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [29159] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2372), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2169), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2167), 34,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_else,
      anon_sym_DOLLARelse,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [29221] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2373), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2147), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2145), 34,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_else,
      anon_sym_DOLLARelse,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [29283] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2374), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5249), 22,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_json_DOTdecode,
      anon_sym_LBRACK2,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_DASH,
      sym_float_literal,
      sym_rune_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_c_SQUOTE,
      anon_sym_c_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_map_LBRACK,
    ACTIONS(5247), 25,
      anon_sym_DOT,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_mut,
      anon_sym_go,
      anon_sym_spawn,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      anon_sym_if,
      anon_sym_DOLLARif,
      anon_sym_match,
      anon_sym_select,
      anon_sym_lock,
      anon_sym_rlock,
      anon_sym_unsafe,
      anon_sym_sql,
      sym_int_literal,
      sym_pseudo_compile_time_identifier,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
  [29345] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    STATE(2375), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2061), 9,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2059), 27,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [29429] = 24,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_QMARK,
    ACTIONS(5149), 1,
      anon_sym_BANG,
    ACTIONS(5185), 1,
      anon_sym_as,
    ACTIONS(5193), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5195), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5203), 1,
      anon_sym_or,
    ACTIONS(5241), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5243), 1,
      anon_sym_PIPE_PIPE,
    STATE(2338), 1,
      sym_or_block,
    STATE(2340), 1,
      sym_argument_list,
    STATE(4346), 1,
      sym_type_parameters,
    ACTIONS(5141), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5151), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    ACTIONS(5205), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5245), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2376), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5235), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5239), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(4132), 8,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
    ACTIONS(5237), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [29529] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2145), 1,
      anon_sym_LBRACK,
    ACTIONS(2335), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    STATE(2377), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2147), 44,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [29593] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    STATE(2378), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2057), 9,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2055), 27,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [29677] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2835), 1,
      anon_sym_LBRACK,
    ACTIONS(2335), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    STATE(2379), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2837), 44,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym___global,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [29741] = 17,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_QMARK,
    ACTIONS(5149), 1,
      anon_sym_BANG,
    STATE(2338), 1,
      sym_or_block,
    STATE(2340), 1,
      sym_argument_list,
    STATE(4346), 1,
      sym_type_parameters,
    ACTIONS(5141), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5151), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    ACTIONS(5245), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2380), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5235), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5239), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5237), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2053), 16,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      sym_identifier,
  [29827] = 14,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_QMARK,
    ACTIONS(5149), 1,
      anon_sym_BANG,
    STATE(2338), 1,
      sym_or_block,
    STATE(2340), 1,
      sym_argument_list,
    STATE(4346), 1,
      sym_type_parameters,
    ACTIONS(5141), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5151), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    STATE(2381), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5237), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2053), 28,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
  [29907] = 24,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_QMARK,
    ACTIONS(5149), 1,
      anon_sym_BANG,
    ACTIONS(5185), 1,
      anon_sym_as,
    ACTIONS(5193), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5195), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5203), 1,
      anon_sym_or,
    ACTIONS(5241), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5243), 1,
      anon_sym_PIPE_PIPE,
    STATE(2338), 1,
      sym_or_block,
    STATE(2340), 1,
      sym_argument_list,
    STATE(4346), 1,
      sym_type_parameters,
    ACTIONS(5141), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5151), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    ACTIONS(5205), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5245), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2382), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5235), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5239), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2065), 8,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
    ACTIONS(5237), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [30007] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    STATE(2383), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2053), 9,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2051), 27,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [30091] = 24,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_QMARK,
    ACTIONS(5149), 1,
      anon_sym_BANG,
    ACTIONS(5185), 1,
      anon_sym_as,
    ACTIONS(5193), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5195), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5203), 1,
      anon_sym_or,
    ACTIONS(5241), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5243), 1,
      anon_sym_PIPE_PIPE,
    STATE(2338), 1,
      sym_or_block,
    STATE(2340), 1,
      sym_argument_list,
    STATE(4346), 1,
      sym_type_parameters,
    ACTIONS(5141), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5151), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    ACTIONS(5205), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5245), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2384), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5235), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5239), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2075), 8,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
    ACTIONS(5237), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [30191] = 18,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_QMARK,
    ACTIONS(5149), 1,
      anon_sym_BANG,
    ACTIONS(5241), 1,
      anon_sym_AMP_AMP,
    STATE(2338), 1,
      sym_or_block,
    STATE(2340), 1,
      sym_argument_list,
    STATE(4346), 1,
      sym_type_parameters,
    ACTIONS(5141), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5151), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    ACTIONS(5245), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2385), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5235), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5239), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5237), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2053), 15,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      sym_identifier,
  [30279] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2386), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5223), 22,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_json_DOTdecode,
      anon_sym_LBRACK2,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_DASH,
      sym_float_literal,
      sym_rune_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_c_SQUOTE,
      anon_sym_c_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_map_LBRACK,
    ACTIONS(5221), 25,
      anon_sym_DOT,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_mut,
      anon_sym_go,
      anon_sym_spawn,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      anon_sym_if,
      anon_sym_DOLLARif,
      anon_sym_match,
      anon_sym_select,
      anon_sym_lock,
      anon_sym_rlock,
      anon_sym_unsafe,
      anon_sym_sql,
      sym_int_literal,
      sym_pseudo_compile_time_identifier,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
  [30341] = 15,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_QMARK,
    ACTIONS(5149), 1,
      anon_sym_BANG,
    STATE(2338), 1,
      sym_or_block,
    STATE(2340), 1,
      sym_argument_list,
    STATE(4346), 1,
      sym_type_parameters,
    ACTIONS(5141), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5151), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    STATE(2387), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5235), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5237), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2049), 24,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
  [30423] = 27,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_QMARK,
    ACTIONS(5149), 1,
      anon_sym_BANG,
    ACTIONS(5151), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5185), 1,
      anon_sym_as,
    ACTIONS(5193), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5195), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5197), 1,
      anon_sym_LBRACK2,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5201), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5203), 1,
      anon_sym_or,
    ACTIONS(5209), 1,
      anon_sym_AT_LBRACK,
    STATE(2338), 1,
      sym_or_block,
    STATE(2340), 1,
      sym_argument_list,
    STATE(3666), 1,
      sym_attribute,
    STATE(4346), 1,
      sym_type_parameters,
    ACTIONS(5141), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5205), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5207), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2388), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5187), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5267), 5,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(5191), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5189), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [30528] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5269), 1,
      anon_sym_else,
    STATE(2450), 1,
      sym_else_branch,
    STATE(2389), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2083), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2081), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [30593] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5269), 1,
      anon_sym_else,
    STATE(2449), 1,
      sym_else_branch,
    STATE(2390), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2089), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2087), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [30658] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2335), 1,
      anon_sym_LBRACE,
    ACTIONS(2835), 1,
      anon_sym_LBRACK,
    STATE(2391), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2837), 43,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
  [30720] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5271), 1,
      anon_sym_DOLLARelse,
    STATE(2392), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2093), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2091), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [30782] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5273), 1,
      anon_sym_DOLLARelse,
    STATE(2393), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2105), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2103), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [30844] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2145), 1,
      anon_sym_LBRACK,
    ACTIONS(2335), 1,
      anon_sym_LBRACE,
    STATE(2394), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2147), 43,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      sym_identifier,
  [30906] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2423), 1,
      sym_type_parameters,
    STATE(2395), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2187), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2185), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [30968] = 32,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3862), 1,
      anon_sym_COLON_EQ,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(5279), 1,
      anon_sym_COMMA,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    ACTIONS(5297), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5301), 1,
      anon_sym_or,
    STATE(2001), 1,
      sym_block,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(3980), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2396), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [31081] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2397), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2651), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2649), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [31140] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2398), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2457), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2455), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [31199] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2399), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2921), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2919), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [31258] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2400), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2917), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2915), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [31317] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2401), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2885), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2883), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [31376] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2402), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2429), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2427), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [31435] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2403), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2873), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2871), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [31494] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2404), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2397), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2395), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [31553] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2405), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3356), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3354), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [31612] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2406), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2335), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2337), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [31671] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5307), 1,
      anon_sym_BANG,
    STATE(2407), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2697), 12,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2695), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [31732] = 32,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3862), 1,
      anon_sym_COLON_EQ,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5279), 1,
      anon_sym_COMMA,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    ACTIONS(5297), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5309), 1,
      anon_sym_LBRACE,
    STATE(1139), 1,
      sym_block,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(3980), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2408), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [31845] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2409), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2435), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2433), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [31904] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2410), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2373), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2371), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [31963] = 32,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3862), 1,
      anon_sym_COLON_EQ,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5279), 1,
      anon_sym_COMMA,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    ACTIONS(5297), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5311), 1,
      anon_sym_LBRACE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_block,
    STATE(3980), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2411), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [32076] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2412), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2997), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2995), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [32135] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2413), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3065), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3063), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [32194] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2414), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2993), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2991), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [32253] = 32,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3862), 1,
      anon_sym_COLON_EQ,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5279), 1,
      anon_sym_COMMA,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    ACTIONS(5297), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5313), 1,
      anon_sym_LBRACE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(2556), 1,
      sym_block,
    STATE(3980), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2415), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [32366] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2416), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2893), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2891), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [32425] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2417), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2187), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2185), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [32484] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2418), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3001), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2999), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [32543] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2419), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2471), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2469), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [32602] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2420), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2989), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2987), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [32661] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2421), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3061), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3059), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [32720] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2422), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3027), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3025), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [32779] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2423), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2841), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2839), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [32838] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2424), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2655), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2653), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [32897] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2425), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3324), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3322), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [32956] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2426), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2659), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2657), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [33015] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2427), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3262), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3260), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [33074] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2428), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2819), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2817), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [33133] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2429), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2821), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [33192] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2430), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3031), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3029), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [33251] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2431), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2829), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2827), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [33310] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2432), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2833), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2831), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [33369] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2433), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2889), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2887), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [33428] = 32,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3862), 1,
      anon_sym_COLON_EQ,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5279), 1,
      anon_sym_COMMA,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    ACTIONS(5297), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5315), 1,
      anon_sym_LBRACE,
    STATE(1423), 1,
      sym_block,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(3980), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2434), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [33541] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2435), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2967), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2965), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [33600] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2436), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2877), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2875), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [33659] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2437), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2849), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2847), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [33718] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2438), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2845), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2843), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [33777] = 32,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3862), 1,
      anon_sym_COLON_EQ,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5279), 1,
      anon_sym_COMMA,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    ACTIONS(5297), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5317), 1,
      anon_sym_LBRACE,
    STATE(995), 1,
      sym_block,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(3980), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2439), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [33890] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2440), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3073), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3071), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [33949] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2441), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3346), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3344), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [34008] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2442), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2947), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2945), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [34067] = 32,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3862), 1,
      anon_sym_COLON_EQ,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5279), 1,
      anon_sym_COMMA,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    ACTIONS(5297), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5319), 1,
      anon_sym_LBRACE,
    STATE(2238), 1,
      sym_block,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(3980), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2443), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [34180] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2444), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3286), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3284), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [34239] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2445), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3246), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3244), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [34298] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2446), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3080), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3078), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [34357] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2177), 1,
      anon_sym_DOT,
    STATE(2447), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2373), 12,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2371), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [34418] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2448), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2863), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [34477] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2449), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3340), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3338), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [34536] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2450), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3336), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3334), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [34595] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2451), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2957), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2955), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [34654] = 32,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3862), 1,
      anon_sym_COLON_EQ,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5279), 1,
      anon_sym_COMMA,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    ACTIONS(5297), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(2550), 1,
      sym_block,
    STATE(3980), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2452), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [34767] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2453), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2401), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2399), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [34826] = 32,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3862), 1,
      anon_sym_COLON_EQ,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5279), 1,
      anon_sym_COMMA,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    ACTIONS(5297), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    STATE(258), 1,
      sym_block,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(3980), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2454), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [34939] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2455), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3312), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3310), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [34998] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2456), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2383), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2381), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [35057] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2457), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3332), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3330), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [35116] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2458), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3300), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3298), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [35175] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2459), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3041), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3039), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [35234] = 32,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3862), 1,
      anon_sym_COLON_EQ,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5279), 1,
      anon_sym_COMMA,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    ACTIONS(5297), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5325), 1,
      anon_sym_LBRACE,
    STATE(2390), 1,
      sym_block,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(3980), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2460), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [35347] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2461), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3274), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3272), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [35406] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2462), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3035), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3033), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [35465] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2463), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3256), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3254), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [35524] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2464), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3250), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3248), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [35583] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2465), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2175), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2173), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [35642] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2466), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [35701] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2467), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2977), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2975), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [35760] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2468), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2981), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2979), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [35819] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2469), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2377), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2375), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [35878] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2470), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3069), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3067), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [35937] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2471), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3007), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3005), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [35996] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2472), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3015), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3013), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [36055] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3075), 1,
      anon_sym_DOT,
    STATE(2473), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 12,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [36116] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2474), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3019), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3017), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [36175] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2475), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3023), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3021), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [36234] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2476), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2973), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2971), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [36293] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2477), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3328), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3326), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [36352] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2478), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3280), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3278), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [36411] = 32,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3862), 1,
      anon_sym_COLON_EQ,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5279), 1,
      anon_sym_COMMA,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    ACTIONS(5297), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5327), 1,
      anon_sym_LBRACE,
    STATE(1996), 1,
      sym_block,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(3980), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2479), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [36524] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2480), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2951), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2949), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [36583] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2481), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2961), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2959), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [36642] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2482), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2929), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2927), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [36701] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2483), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3304), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3302), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [36760] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2484), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3266), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3264), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [36819] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2485), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3270), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3268), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [36878] = 32,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3862), 1,
      anon_sym_COLON_EQ,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5279), 1,
      anon_sym_COMMA,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    ACTIONS(5297), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5329), 1,
      anon_sym_LBRACE,
    STATE(1279), 1,
      sym_block,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(3980), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2486), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [36991] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2487), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2935), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2933), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [37050] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2488), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2453), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2451), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [37109] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2489), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3308), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3306), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [37168] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2443), 1,
      anon_sym_COLON,
    STATE(2490), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2441), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
    ACTIONS(2445), 12,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2448), 26,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
  [37231] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2491), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2881), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2879), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [37290] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2492), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2465), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2463), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [37349] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2493), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3292), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3290), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [37408] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2494), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2647), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2645), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [37467] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2495), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3296), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3294), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [37526] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2496), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2639), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2637), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [37585] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2497), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2631), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2629), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [37644] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2498), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3084), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3082), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [37703] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2499), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2925), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2923), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [37762] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2500), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3240), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3238), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [37821] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2501), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2627), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2625), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [37880] = 32,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3862), 1,
      anon_sym_COLON_EQ,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5279), 1,
      anon_sym_COMMA,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    ACTIONS(5297), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5331), 1,
      anon_sym_LBRACE,
    STATE(1559), 1,
      sym_block,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(3980), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2502), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [37993] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2503), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3318), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3316), 31,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT,
  [38052] = 14,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5335), 1,
      anon_sym_LPAREN,
    ACTIONS(5339), 1,
      anon_sym_LBRACK,
    ACTIONS(5341), 1,
      anon_sym_QMARK,
    ACTIONS(5343), 1,
      anon_sym_BANG,
    STATE(2621), 1,
      sym_or_block,
    STATE(2858), 1,
      sym_argument_list,
    STATE(4231), 1,
      sym_type_parameters,
    ACTIONS(5333), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5345), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    STATE(2504), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5337), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2053), 24,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [38128] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2065), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5347), 1,
      anon_sym_DOT,
    ACTIONS(5349), 1,
      anon_sym_as,
    ACTIONS(5351), 1,
      anon_sym_LPAREN,
    ACTIONS(5363), 1,
      anon_sym_LBRACK,
    ACTIONS(5365), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5367), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5369), 1,
      anon_sym_QMARK,
    ACTIONS(5371), 1,
      anon_sym_BANG,
    ACTIONS(5373), 1,
      anon_sym_LBRACK2,
    ACTIONS(5375), 1,
      anon_sym_CARET,
    ACTIONS(5377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5379), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5381), 1,
      anon_sym_or,
    ACTIONS(5383), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5385), 1,
      anon_sym_POUND_LBRACK,
    STATE(2730), 1,
      sym_or_block,
    STATE(2731), 1,
      sym_argument_list,
    STATE(4341), 1,
      sym_type_parameters,
    ACTIONS(5359), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5387), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5389), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2505), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2063), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5353), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5357), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5361), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5355), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [38236] = 29,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2506), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2073), 4,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [38342] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(2049), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(2507), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2047), 18,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_DOT_DOT,
  [38430] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2508), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 11,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_DOT_DOT,
  [38524] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2509), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 12,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_DOT_DOT,
  [38616] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(2053), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(2510), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 18,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_DOT_DOT,
  [38704] = 15,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5335), 1,
      anon_sym_LPAREN,
    ACTIONS(5339), 1,
      anon_sym_LBRACK,
    ACTIONS(5341), 1,
      anon_sym_QMARK,
    ACTIONS(5343), 1,
      anon_sym_BANG,
    STATE(2621), 1,
      sym_or_block,
    STATE(2858), 1,
      sym_argument_list,
    STATE(4231), 1,
      sym_type_parameters,
    ACTIONS(5333), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5345), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    STATE(2511), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5409), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5337), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2049), 20,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [38782] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    STATE(2512), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2053), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 19,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_DOT_DOT,
  [38866] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5347), 1,
      anon_sym_DOT,
    ACTIONS(5351), 1,
      anon_sym_LPAREN,
    ACTIONS(5363), 1,
      anon_sym_LBRACK,
    ACTIONS(5369), 1,
      anon_sym_QMARK,
    ACTIONS(5371), 1,
      anon_sym_BANG,
    ACTIONS(5373), 1,
      anon_sym_LBRACK2,
    ACTIONS(5383), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5385), 1,
      anon_sym_POUND_LBRACK,
    STATE(2730), 1,
      sym_or_block,
    STATE(2731), 1,
      sym_argument_list,
    STATE(4341), 1,
      sym_type_parameters,
    STATE(2513), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2061), 9,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2059), 23,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [38946] = 29,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2514), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2063), 4,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [39052] = 24,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5335), 1,
      anon_sym_LPAREN,
    ACTIONS(5339), 1,
      anon_sym_LBRACK,
    ACTIONS(5341), 1,
      anon_sym_QMARK,
    ACTIONS(5343), 1,
      anon_sym_BANG,
    ACTIONS(5411), 1,
      anon_sym_as,
    ACTIONS(5415), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5417), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5423), 1,
      anon_sym_or,
    STATE(2621), 1,
      sym_or_block,
    STATE(2858), 1,
      sym_argument_list,
    STATE(4231), 1,
      sym_type_parameters,
    ACTIONS(5333), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5345), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    ACTIONS(5425), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5427), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2515), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3938), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
    ACTIONS(5409), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5413), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5337), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [39148] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2337), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    STATE(2516), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2837), 12,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2835), 29,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_DOT_DOT,
  [39208] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2075), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5347), 1,
      anon_sym_DOT,
    ACTIONS(5349), 1,
      anon_sym_as,
    ACTIONS(5351), 1,
      anon_sym_LPAREN,
    ACTIONS(5363), 1,
      anon_sym_LBRACK,
    ACTIONS(5365), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5367), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5369), 1,
      anon_sym_QMARK,
    ACTIONS(5371), 1,
      anon_sym_BANG,
    ACTIONS(5373), 1,
      anon_sym_LBRACK2,
    ACTIONS(5375), 1,
      anon_sym_CARET,
    ACTIONS(5377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5379), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5381), 1,
      anon_sym_or,
    ACTIONS(5383), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5385), 1,
      anon_sym_POUND_LBRACK,
    STATE(2730), 1,
      sym_or_block,
    STATE(2731), 1,
      sym_argument_list,
    STATE(4341), 1,
      sym_type_parameters,
    ACTIONS(5359), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5387), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5389), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2517), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2073), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5353), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5357), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5361), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5355), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [39316] = 13,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5335), 1,
      anon_sym_LPAREN,
    ACTIONS(5339), 1,
      anon_sym_LBRACK,
    ACTIONS(5341), 1,
      anon_sym_QMARK,
    ACTIONS(5343), 1,
      anon_sym_BANG,
    STATE(2621), 1,
      sym_or_block,
    STATE(2858), 1,
      sym_argument_list,
    STATE(4231), 1,
      sym_type_parameters,
    ACTIONS(5333), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5345), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    STATE(2518), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2061), 32,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [39390] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2180), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2371), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    STATE(2519), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2175), 12,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2173), 27,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_DOT_DOT,
  [39452] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5347), 1,
      anon_sym_DOT,
    ACTIONS(5351), 1,
      anon_sym_LPAREN,
    ACTIONS(5363), 1,
      anon_sym_LBRACK,
    ACTIONS(5369), 1,
      anon_sym_QMARK,
    ACTIONS(5371), 1,
      anon_sym_BANG,
    ACTIONS(5373), 1,
      anon_sym_LBRACK2,
    ACTIONS(5383), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5385), 1,
      anon_sym_POUND_LBRACK,
    STATE(2730), 1,
      sym_or_block,
    STATE(2731), 1,
      sym_argument_list,
    STATE(4341), 1,
      sym_type_parameters,
    STATE(2520), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2057), 9,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2055), 23,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [39532] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2337), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    STATE(2521), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2147), 12,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2145), 29,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_DOT_DOT,
  [39592] = 18,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5335), 1,
      anon_sym_LPAREN,
    ACTIONS(5339), 1,
      anon_sym_LBRACK,
    ACTIONS(5341), 1,
      anon_sym_QMARK,
    ACTIONS(5343), 1,
      anon_sym_BANG,
    ACTIONS(5419), 1,
      anon_sym_AMP_AMP,
    STATE(2621), 1,
      sym_or_block,
    STATE(2858), 1,
      sym_argument_list,
    STATE(4231), 1,
      sym_type_parameters,
    ACTIONS(5333), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5345), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    ACTIONS(5427), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2522), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5409), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5413), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5337), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2053), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
  [39676] = 17,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5335), 1,
      anon_sym_LPAREN,
    ACTIONS(5339), 1,
      anon_sym_LBRACK,
    ACTIONS(5341), 1,
      anon_sym_QMARK,
    ACTIONS(5343), 1,
      anon_sym_BANG,
    STATE(2621), 1,
      sym_or_block,
    STATE(2858), 1,
      sym_argument_list,
    STATE(4231), 1,
      sym_type_parameters,
    ACTIONS(5333), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5345), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    ACTIONS(5427), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2523), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5409), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5413), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5337), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2053), 12,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
  [39758] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2180), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    STATE(2524), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2175), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2173), 28,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
  [39818] = 25,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2175), 1,
      anon_sym_DOT,
    ACTIONS(2371), 1,
      anon_sym_LBRACK,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(3806), 1,
      anon_sym_LPAREN,
    ACTIONS(3808), 1,
      anon_sym_fn,
    ACTIONS(3810), 1,
      anon_sym_STAR,
    ACTIONS(3812), 1,
      anon_sym_struct,
    ACTIONS(3814), 1,
      anon_sym_QMARK,
    ACTIONS(3816), 1,
      anon_sym_BANG,
    ACTIONS(3818), 1,
      anon_sym_LBRACK2,
    ACTIONS(3820), 1,
      anon_sym_AMP,
    ACTIONS(3822), 1,
      anon_sym_shared,
    ACTIONS(3824), 1,
      anon_sym_map_LBRACK,
    ACTIONS(3826), 1,
      anon_sym_chan,
    ACTIONS(3828), 1,
      anon_sym_thread,
    ACTIONS(3830), 1,
      anon_sym_atomic,
    STATE(3452), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(2525), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3458), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    ACTIONS(2373), 7,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
    STATE(3459), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [39916] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5347), 1,
      anon_sym_DOT,
    ACTIONS(5351), 1,
      anon_sym_LPAREN,
    ACTIONS(5363), 1,
      anon_sym_LBRACK,
    ACTIONS(5369), 1,
      anon_sym_QMARK,
    ACTIONS(5371), 1,
      anon_sym_BANG,
    ACTIONS(5373), 1,
      anon_sym_LBRACK2,
    ACTIONS(5383), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5385), 1,
      anon_sym_POUND_LBRACK,
    STATE(2730), 1,
      sym_or_block,
    STATE(2731), 1,
      sym_argument_list,
    STATE(4341), 1,
      sym_type_parameters,
    STATE(2526), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2053), 9,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2051), 23,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [39996] = 24,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5335), 1,
      anon_sym_LPAREN,
    ACTIONS(5339), 1,
      anon_sym_LBRACK,
    ACTIONS(5341), 1,
      anon_sym_QMARK,
    ACTIONS(5343), 1,
      anon_sym_BANG,
    ACTIONS(5411), 1,
      anon_sym_as,
    ACTIONS(5415), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5417), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5423), 1,
      anon_sym_or,
    STATE(2621), 1,
      sym_or_block,
    STATE(2858), 1,
      sym_argument_list,
    STATE(4231), 1,
      sym_type_parameters,
    ACTIONS(5333), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5345), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    ACTIONS(5425), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5427), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2527), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3934), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
    ACTIONS(5409), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5413), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5337), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [40092] = 13,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5335), 1,
      anon_sym_LPAREN,
    ACTIONS(5339), 1,
      anon_sym_LBRACK,
    ACTIONS(5341), 1,
      anon_sym_QMARK,
    ACTIONS(5343), 1,
      anon_sym_BANG,
    STATE(2621), 1,
      sym_or_block,
    STATE(2858), 1,
      sym_argument_list,
    STATE(4231), 1,
      sym_type_parameters,
    ACTIONS(5333), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5345), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    STATE(2528), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2057), 32,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [40166] = 23,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(3806), 1,
      anon_sym_LPAREN,
    ACTIONS(3808), 1,
      anon_sym_fn,
    ACTIONS(3810), 1,
      anon_sym_STAR,
    ACTIONS(3812), 1,
      anon_sym_struct,
    ACTIONS(3814), 1,
      anon_sym_QMARK,
    ACTIONS(3816), 1,
      anon_sym_BANG,
    ACTIONS(3818), 1,
      anon_sym_LBRACK2,
    ACTIONS(3820), 1,
      anon_sym_AMP,
    ACTIONS(3822), 1,
      anon_sym_shared,
    ACTIONS(3824), 1,
      anon_sym_map_LBRACK,
    ACTIONS(3826), 1,
      anon_sym_chan,
    ACTIONS(3828), 1,
      anon_sym_thread,
    ACTIONS(3830), 1,
      anon_sym_atomic,
    STATE(3461), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(2529), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3458), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    ACTIONS(821), 9,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_AT_LBRACK,
    STATE(3459), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [40260] = 15,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5335), 1,
      anon_sym_LPAREN,
    ACTIONS(5339), 1,
      anon_sym_LBRACK,
    ACTIONS(5341), 1,
      anon_sym_QMARK,
    ACTIONS(5343), 1,
      anon_sym_BANG,
    STATE(2621), 1,
      sym_or_block,
    STATE(2858), 1,
      sym_argument_list,
    STATE(4231), 1,
      sym_type_parameters,
    ACTIONS(5333), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5345), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    STATE(2530), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5409), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5337), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2053), 20,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [40338] = 24,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5335), 1,
      anon_sym_LPAREN,
    ACTIONS(5339), 1,
      anon_sym_LBRACK,
    ACTIONS(5341), 1,
      anon_sym_QMARK,
    ACTIONS(5343), 1,
      anon_sym_BANG,
    ACTIONS(5411), 1,
      anon_sym_as,
    ACTIONS(5415), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5417), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5423), 1,
      anon_sym_or,
    STATE(2621), 1,
      sym_or_block,
    STATE(2858), 1,
      sym_argument_list,
    STATE(4231), 1,
      sym_type_parameters,
    ACTIONS(5333), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5345), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    ACTIONS(5425), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5427), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2531), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2065), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
    ACTIONS(5409), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5413), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5337), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [40434] = 23,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(3806), 1,
      anon_sym_LPAREN,
    ACTIONS(3808), 1,
      anon_sym_fn,
    ACTIONS(3810), 1,
      anon_sym_STAR,
    ACTIONS(3812), 1,
      anon_sym_struct,
    ACTIONS(3814), 1,
      anon_sym_QMARK,
    ACTIONS(3816), 1,
      anon_sym_BANG,
    ACTIONS(3818), 1,
      anon_sym_LBRACK2,
    ACTIONS(3820), 1,
      anon_sym_AMP,
    ACTIONS(3822), 1,
      anon_sym_shared,
    ACTIONS(3824), 1,
      anon_sym_map_LBRACK,
    ACTIONS(3826), 1,
      anon_sym_chan,
    ACTIONS(3828), 1,
      anon_sym_thread,
    ACTIONS(3830), 1,
      anon_sym_atomic,
    STATE(3478), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(2532), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3458), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    ACTIONS(859), 9,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_AT_LBRACK,
    STATE(3459), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [40528] = 23,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(3806), 1,
      anon_sym_LPAREN,
    ACTIONS(3808), 1,
      anon_sym_fn,
    ACTIONS(3810), 1,
      anon_sym_STAR,
    ACTIONS(3812), 1,
      anon_sym_struct,
    ACTIONS(3814), 1,
      anon_sym_QMARK,
    ACTIONS(3816), 1,
      anon_sym_BANG,
    ACTIONS(3818), 1,
      anon_sym_LBRACK2,
    ACTIONS(3820), 1,
      anon_sym_AMP,
    ACTIONS(3822), 1,
      anon_sym_shared,
    ACTIONS(3824), 1,
      anon_sym_map_LBRACK,
    ACTIONS(3826), 1,
      anon_sym_chan,
    ACTIONS(3828), 1,
      anon_sym_thread,
    ACTIONS(3830), 1,
      anon_sym_atomic,
    STATE(3456), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(2533), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3458), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    ACTIONS(855), 9,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_AT_LBRACK,
    STATE(3459), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [40622] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5347), 1,
      anon_sym_DOT,
    ACTIONS(5351), 1,
      anon_sym_LPAREN,
    ACTIONS(5363), 1,
      anon_sym_LBRACK,
    ACTIONS(5369), 1,
      anon_sym_QMARK,
    ACTIONS(5371), 1,
      anon_sym_BANG,
    ACTIONS(5373), 1,
      anon_sym_LBRACK2,
    ACTIONS(5383), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5385), 1,
      anon_sym_POUND_LBRACK,
    STATE(2730), 1,
      sym_or_block,
    STATE(2731), 1,
      sym_argument_list,
    STATE(4341), 1,
      sym_type_parameters,
    STATE(2534), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5357), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5355), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2053), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(2051), 18,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [40706] = 13,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5335), 1,
      anon_sym_LPAREN,
    ACTIONS(5339), 1,
      anon_sym_LBRACK,
    ACTIONS(5341), 1,
      anon_sym_QMARK,
    ACTIONS(5343), 1,
      anon_sym_BANG,
    STATE(2621), 1,
      sym_or_block,
    STATE(2858), 1,
      sym_argument_list,
    STATE(4231), 1,
      sym_type_parameters,
    ACTIONS(5333), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5345), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    STATE(2535), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2053), 32,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [40780] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5347), 1,
      anon_sym_DOT,
    ACTIONS(5351), 1,
      anon_sym_LPAREN,
    ACTIONS(5363), 1,
      anon_sym_LBRACK,
    ACTIONS(5369), 1,
      anon_sym_QMARK,
    ACTIONS(5371), 1,
      anon_sym_BANG,
    ACTIONS(5373), 1,
      anon_sym_LBRACK2,
    ACTIONS(5375), 1,
      anon_sym_CARET,
    ACTIONS(5383), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5385), 1,
      anon_sym_POUND_LBRACK,
    STATE(2730), 1,
      sym_or_block,
    STATE(2731), 1,
      sym_argument_list,
    STATE(4341), 1,
      sym_type_parameters,
    STATE(2536), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2053), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT_DOT,
    ACTIONS(5353), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5357), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5355), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [40868] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5347), 1,
      anon_sym_DOT,
    ACTIONS(5351), 1,
      anon_sym_LPAREN,
    ACTIONS(5363), 1,
      anon_sym_LBRACK,
    ACTIONS(5369), 1,
      anon_sym_QMARK,
    ACTIONS(5371), 1,
      anon_sym_BANG,
    ACTIONS(5373), 1,
      anon_sym_LBRACK2,
    ACTIONS(5375), 1,
      anon_sym_CARET,
    ACTIONS(5383), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5385), 1,
      anon_sym_POUND_LBRACK,
    STATE(2730), 1,
      sym_or_block,
    STATE(2731), 1,
      sym_argument_list,
    STATE(4341), 1,
      sym_type_parameters,
    ACTIONS(5359), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5389), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2537), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5353), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5357), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5361), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5355), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 11,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
  [40962] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5347), 1,
      anon_sym_DOT,
    ACTIONS(5351), 1,
      anon_sym_LPAREN,
    ACTIONS(5363), 1,
      anon_sym_LBRACK,
    ACTIONS(5369), 1,
      anon_sym_QMARK,
    ACTIONS(5371), 1,
      anon_sym_BANG,
    ACTIONS(5373), 1,
      anon_sym_LBRACK2,
    ACTIONS(5375), 1,
      anon_sym_CARET,
    ACTIONS(5377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5385), 1,
      anon_sym_POUND_LBRACK,
    STATE(2730), 1,
      sym_or_block,
    STATE(2731), 1,
      sym_argument_list,
    STATE(4341), 1,
      sym_type_parameters,
    ACTIONS(5359), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5389), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2538), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5353), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5357), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5361), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5355), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 10,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
  [41058] = 24,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5335), 1,
      anon_sym_LPAREN,
    ACTIONS(5339), 1,
      anon_sym_LBRACK,
    ACTIONS(5341), 1,
      anon_sym_QMARK,
    ACTIONS(5343), 1,
      anon_sym_BANG,
    ACTIONS(5411), 1,
      anon_sym_as,
    ACTIONS(5415), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5417), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5423), 1,
      anon_sym_or,
    STATE(2621), 1,
      sym_or_block,
    STATE(2858), 1,
      sym_argument_list,
    STATE(4231), 1,
      sym_type_parameters,
    ACTIONS(5333), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5345), 2,
      anon_sym_LBRACK2,
      anon_sym_POUND_LBRACK,
    ACTIONS(5425), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5427), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2539), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2075), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
    ACTIONS(5409), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(5413), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5337), 8,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [41154] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5347), 1,
      anon_sym_DOT,
    ACTIONS(5351), 1,
      anon_sym_LPAREN,
    ACTIONS(5363), 1,
      anon_sym_LBRACK,
    ACTIONS(5369), 1,
      anon_sym_QMARK,
    ACTIONS(5371), 1,
      anon_sym_BANG,
    ACTIONS(5373), 1,
      anon_sym_LBRACK2,
    ACTIONS(5375), 1,
      anon_sym_CARET,
    ACTIONS(5383), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5385), 1,
      anon_sym_POUND_LBRACK,
    STATE(2730), 1,
      sym_or_block,
    STATE(2731), 1,
      sym_argument_list,
    STATE(4341), 1,
      sym_type_parameters,
    STATE(2540), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2049), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT_DOT,
    ACTIONS(5353), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5357), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5355), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2047), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [41242] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5435), 1,
      anon_sym_CARET,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(2049), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(2541), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5429), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5433), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5431), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2047), 17,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
  [41327] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    ACTIONS(5297), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5301), 1,
      anon_sym_or,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2542), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2063), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [41430] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(2049), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(2543), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2047), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
  [41515] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    ACTIONS(5297), 1,
      anon_sym_AMP_AMP,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2544), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 10,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_COLON_EQ,
  [41606] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2545), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2147), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2145), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_else,
      anon_sym_DOLLARelse,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [41663] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2546), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 11,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_COLON_EQ,
  [41752] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(2053), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(2547), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
  [41837] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2443), 1,
      anon_sym_DOT_DOT,
    STATE(2548), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2441), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_EQ,
    ACTIONS(2445), 12,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2448), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [41898] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5437), 1,
      anon_sym_else,
    STATE(2665), 1,
      sym_else_branch,
    STATE(2549), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2083), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2081), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [41959] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5437), 1,
      anon_sym_else,
    STATE(2664), 1,
      sym_else_branch,
    STATE(2550), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2089), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2087), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [42020] = 31,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5347), 1,
      anon_sym_DOT,
    ACTIONS(5349), 1,
      anon_sym_as,
    ACTIONS(5351), 1,
      anon_sym_LPAREN,
    ACTIONS(5363), 1,
      anon_sym_LBRACK,
    ACTIONS(5365), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5367), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5369), 1,
      anon_sym_QMARK,
    ACTIONS(5371), 1,
      anon_sym_BANG,
    ACTIONS(5373), 1,
      anon_sym_LBRACK2,
    ACTIONS(5381), 1,
      anon_sym_or,
    ACTIONS(5383), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5385), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5439), 1,
      anon_sym_LBRACE,
    ACTIONS(5451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5453), 1,
      anon_sym_CARET,
    ACTIONS(5455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5457), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5461), 1,
      anon_sym_DOT_DOT,
    STATE(2730), 1,
      sym_or_block,
    STATE(2731), 1,
      sym_argument_list,
    STATE(4341), 1,
      sym_type_parameters,
    ACTIONS(5387), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5447), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5459), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2551), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5441), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5445), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5449), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5443), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [42129] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(2552), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2053), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 18,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
  [42210] = 7,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2081), 1,
      anon_sym_LBRACK,
    ACTIONS(5463), 1,
      anon_sym_else,
    STATE(2675), 1,
      sym_else_branch,
    STATE(2553), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2083), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [42271] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5435), 1,
      anon_sym_CARET,
    ACTIONS(5469), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5471), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5465), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5473), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2554), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2073), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
    ACTIONS(5429), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5433), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5467), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5431), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [42374] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5435), 1,
      anon_sym_CARET,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5465), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5473), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2555), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5429), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5433), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5467), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5431), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 11,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_COLON_EQ,
  [42463] = 7,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2087), 1,
      anon_sym_LBRACK,
    ACTIONS(5463), 1,
      anon_sym_else,
    STATE(2676), 1,
      sym_else_branch,
    STATE(2556), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2089), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [42524] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2075), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5347), 1,
      anon_sym_DOT,
    ACTIONS(5349), 1,
      anon_sym_as,
    ACTIONS(5351), 1,
      anon_sym_LPAREN,
    ACTIONS(5363), 1,
      anon_sym_LBRACK,
    ACTIONS(5365), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5367), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5369), 1,
      anon_sym_QMARK,
    ACTIONS(5371), 1,
      anon_sym_BANG,
    ACTIONS(5373), 1,
      anon_sym_LBRACK2,
    ACTIONS(5381), 1,
      anon_sym_or,
    ACTIONS(5383), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5385), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5453), 1,
      anon_sym_CARET,
    ACTIONS(5455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5457), 1,
      anon_sym_PIPE_PIPE,
    STATE(2730), 1,
      sym_or_block,
    STATE(2731), 1,
      sym_argument_list,
    STATE(4341), 1,
      sym_type_parameters,
    ACTIONS(2073), 2,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5387), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5447), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5459), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2557), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5441), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5445), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5449), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5443), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [42631] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3862), 1,
      anon_sym_LBRACE,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    ACTIONS(5297), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5475), 1,
      anon_sym_COMMA,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(3907), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2558), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [42738] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5435), 1,
      anon_sym_CARET,
    ACTIONS(5469), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5471), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5465), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5473), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2559), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3908), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
    ACTIONS(5429), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5433), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5467), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5431), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [42841] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5435), 1,
      anon_sym_CARET,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(2053), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(2560), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5429), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5433), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5431), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 17,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
  [42926] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2835), 1,
      anon_sym_LBRACK,
    ACTIONS(2335), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    STATE(2561), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2837), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [42985] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5435), 1,
      anon_sym_CARET,
    ACTIONS(5469), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5471), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5465), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5473), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2562), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2063), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
    ACTIONS(5429), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5433), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5467), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5431), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [43088] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(2563), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5433), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2053), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
    ACTIONS(5431), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 18,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
  [43169] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2145), 1,
      anon_sym_LBRACK,
    ACTIONS(2335), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    STATE(2564), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2147), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [43228] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3862), 1,
      anon_sym_SEMI,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5435), 1,
      anon_sym_CARET,
    ACTIONS(5469), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5471), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5477), 1,
      anon_sym_COMMA,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4066), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5465), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5473), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2565), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5429), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5433), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5467), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5431), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [43335] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5347), 1,
      anon_sym_DOT,
    ACTIONS(5351), 1,
      anon_sym_LPAREN,
    ACTIONS(5363), 1,
      anon_sym_LBRACK,
    ACTIONS(5369), 1,
      anon_sym_QMARK,
    ACTIONS(5371), 1,
      anon_sym_BANG,
    ACTIONS(5373), 1,
      anon_sym_LBRACK2,
    ACTIONS(5383), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5385), 1,
      anon_sym_POUND_LBRACK,
    STATE(2730), 1,
      sym_or_block,
    STATE(2731), 1,
      sym_argument_list,
    STATE(4341), 1,
      sym_type_parameters,
    STATE(2566), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5445), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5443), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2053), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(2051), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [43418] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5347), 1,
      anon_sym_DOT,
    ACTIONS(5351), 1,
      anon_sym_LPAREN,
    ACTIONS(5363), 1,
      anon_sym_LBRACK,
    ACTIONS(5369), 1,
      anon_sym_QMARK,
    ACTIONS(5371), 1,
      anon_sym_BANG,
    ACTIONS(5373), 1,
      anon_sym_LBRACK2,
    ACTIONS(5383), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5385), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5453), 1,
      anon_sym_CARET,
    STATE(2730), 1,
      sym_or_block,
    STATE(2731), 1,
      sym_argument_list,
    STATE(4341), 1,
      sym_type_parameters,
    STATE(2567), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2053), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT_DOT,
    ACTIONS(5441), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5445), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5443), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [43505] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5347), 1,
      anon_sym_DOT,
    ACTIONS(5351), 1,
      anon_sym_LPAREN,
    ACTIONS(5363), 1,
      anon_sym_LBRACK,
    ACTIONS(5369), 1,
      anon_sym_QMARK,
    ACTIONS(5371), 1,
      anon_sym_BANG,
    ACTIONS(5373), 1,
      anon_sym_LBRACK2,
    ACTIONS(5383), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5385), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5453), 1,
      anon_sym_CARET,
    STATE(2730), 1,
      sym_or_block,
    STATE(2731), 1,
      sym_argument_list,
    STATE(4341), 1,
      sym_type_parameters,
    ACTIONS(5447), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5459), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2568), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5441), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5445), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5449), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5443), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 10,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
  [43598] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2569), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2169), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2167), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_else,
      anon_sym_DOLLARelse,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [43655] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5435), 1,
      anon_sym_CARET,
    ACTIONS(5469), 1,
      anon_sym_AMP_AMP,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5465), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5473), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2570), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5429), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5433), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5467), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5431), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 10,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_COLON_EQ,
  [43746] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2167), 1,
      anon_sym_LBRACK,
    STATE(2571), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2169), 41,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_else,
      anon_sym_DOLLARelse,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [43803] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2145), 1,
      anon_sym_LBRACK,
    STATE(2572), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2147), 41,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_else,
      anon_sym_DOLLARelse,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [43860] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5347), 1,
      anon_sym_DOT,
    ACTIONS(5351), 1,
      anon_sym_LPAREN,
    ACTIONS(5363), 1,
      anon_sym_LBRACK,
    ACTIONS(5369), 1,
      anon_sym_QMARK,
    ACTIONS(5371), 1,
      anon_sym_BANG,
    ACTIONS(5373), 1,
      anon_sym_LBRACK2,
    ACTIONS(5383), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5385), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5453), 1,
      anon_sym_CARET,
    ACTIONS(5455), 1,
      anon_sym_AMP_AMP,
    STATE(2730), 1,
      sym_or_block,
    STATE(2731), 1,
      sym_argument_list,
    STATE(4341), 1,
      sym_type_parameters,
    ACTIONS(5447), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5459), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2573), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5441), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5445), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5449), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5443), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 9,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
  [43955] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2065), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5347), 1,
      anon_sym_DOT,
    ACTIONS(5349), 1,
      anon_sym_as,
    ACTIONS(5351), 1,
      anon_sym_LPAREN,
    ACTIONS(5363), 1,
      anon_sym_LBRACK,
    ACTIONS(5365), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5367), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5369), 1,
      anon_sym_QMARK,
    ACTIONS(5371), 1,
      anon_sym_BANG,
    ACTIONS(5373), 1,
      anon_sym_LBRACK2,
    ACTIONS(5381), 1,
      anon_sym_or,
    ACTIONS(5383), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5385), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5453), 1,
      anon_sym_CARET,
    ACTIONS(5455), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5457), 1,
      anon_sym_PIPE_PIPE,
    STATE(2730), 1,
      sym_or_block,
    STATE(2731), 1,
      sym_argument_list,
    STATE(4341), 1,
      sym_type_parameters,
    ACTIONS(2063), 2,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5387), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5447), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5459), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2574), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5441), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5445), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5449), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5443), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [44062] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    ACTIONS(5297), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5301), 1,
      anon_sym_or,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2575), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2073), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [44165] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5347), 1,
      anon_sym_DOT,
    ACTIONS(5351), 1,
      anon_sym_LPAREN,
    ACTIONS(5363), 1,
      anon_sym_LBRACK,
    ACTIONS(5369), 1,
      anon_sym_QMARK,
    ACTIONS(5371), 1,
      anon_sym_BANG,
    ACTIONS(5373), 1,
      anon_sym_LBRACK2,
    ACTIONS(5383), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5385), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5453), 1,
      anon_sym_CARET,
    STATE(2730), 1,
      sym_or_block,
    STATE(2731), 1,
      sym_argument_list,
    STATE(4341), 1,
      sym_type_parameters,
    STATE(2576), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2049), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT_DOT,
    ACTIONS(5441), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5445), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5443), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2047), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [44252] = 29,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5489), 1,
      anon_sym_QMARK,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    STATE(2014), 1,
      sym_block,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2577), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [44356] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5347), 1,
      anon_sym_DOT,
    ACTIONS(5349), 1,
      anon_sym_as,
    ACTIONS(5351), 1,
      anon_sym_LPAREN,
    ACTIONS(5363), 1,
      anon_sym_LBRACK,
    ACTIONS(5365), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5367), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5369), 1,
      anon_sym_QMARK,
    ACTIONS(5371), 1,
      anon_sym_BANG,
    ACTIONS(5373), 1,
      anon_sym_LBRACK2,
    ACTIONS(5375), 1,
      anon_sym_CARET,
    ACTIONS(5377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5379), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5381), 1,
      anon_sym_or,
    ACTIONS(5383), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5385), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5499), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5501), 1,
      anon_sym_DOT_DOT,
    STATE(2730), 1,
      sym_or_block,
    STATE(2731), 1,
      sym_argument_list,
    STATE(4341), 1,
      sym_type_parameters,
    ACTIONS(5359), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5387), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5389), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2578), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5353), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5357), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5361), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5355), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [44462] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5503), 1,
      anon_sym_LBRACE,
    ACTIONS(5505), 1,
      anon_sym_COMMA,
    STATE(3920), 1,
      aux_sym_match_expression_list_repeat1,
    STATE(2579), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3035), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3033), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [44524] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    ACTIONS(5297), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5301), 1,
      anon_sym_or,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(2067), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5507), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(2580), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [44626] = 29,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5509), 1,
      anon_sym_LBRACE,
    ACTIONS(5511), 1,
      anon_sym_QMARK,
    STATE(1561), 1,
      sym_block,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2581), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [44730] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5513), 1,
      anon_sym_RBRACK,
    ACTIONS(5515), 1,
      anon_sym_DOT_DOT,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2582), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [44836] = 29,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5517), 1,
      anon_sym_LBRACE,
    ACTIONS(5519), 1,
      anon_sym_QMARK,
    STATE(1430), 1,
      sym_block,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2583), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [44940] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5521), 1,
      anon_sym_RBRACK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2584), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [45046] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2091), 1,
      anon_sym_LBRACK,
    ACTIONS(5523), 1,
      anon_sym_DOLLARelse,
    STATE(2585), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2093), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [45104] = 29,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5525), 1,
      anon_sym_LBRACE,
    ACTIONS(5527), 1,
      anon_sym_QMARK,
    STATE(999), 1,
      sym_block,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2586), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [45208] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5435), 1,
      anon_sym_CARET,
    ACTIONS(5469), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5471), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(2067), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5465), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5473), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5507), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(2587), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5429), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5433), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5467), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5431), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [45310] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5529), 1,
      anon_sym_RBRACK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2588), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [45416] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2764), 1,
      sym_type_parameters,
    STATE(2589), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2187), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2185), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [45474] = 29,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5531), 1,
      anon_sym_QMARK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(2591), 1,
      sym_block,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2590), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [45578] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5533), 1,
      anon_sym_DOLLARelse,
    STATE(2591), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2105), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2103), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [45636] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5535), 1,
      anon_sym_RBRACK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2592), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [45742] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5537), 1,
      anon_sym_RBRACK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2593), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [45848] = 29,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5313), 1,
      anon_sym_LBRACE,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5539), 1,
      anon_sym_QMARK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(2611), 1,
      sym_block,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2594), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [45952] = 29,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5040), 1,
      anon_sym_LPAREN,
    ACTIONS(5044), 1,
      anon_sym_LBRACK,
    ACTIONS(5046), 1,
      anon_sym_QMARK,
    ACTIONS(5048), 1,
      anon_sym_BANG,
    ACTIONS(5050), 1,
      anon_sym_LBRACK2,
    ACTIONS(5052), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5054), 1,
      anon_sym_as,
    ACTIONS(5062), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5064), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5070), 1,
      anon_sym_or,
    ACTIONS(5543), 1,
      anon_sym_COLON,
    ACTIONS(5545), 1,
      anon_sym_CARET,
    ACTIONS(5547), 1,
      anon_sym_LT_DASH,
    STATE(2072), 1,
      sym_argument_list,
    STATE(2073), 1,
      sym_or_block,
    STATE(4173), 1,
      sym_type_parameters,
    ACTIONS(5038), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5058), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5072), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5074), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2595), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5042), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5056), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5060), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5541), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [46056] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5551), 1,
      anon_sym_QMARK,
    ACTIONS(5549), 2,
      anon_sym_SEMI,
      anon_sym_RBRACK,
    STATE(2596), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 10,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
  [46118] = 29,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5325), 1,
      anon_sym_LBRACE,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5553), 1,
      anon_sym_QMARK,
    STATE(2393), 1,
      sym_block,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2597), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [46222] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5435), 1,
      anon_sym_CARET,
    ACTIONS(5469), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5471), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(2067), 2,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5465), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5473), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5555), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(2598), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5429), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5433), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5467), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5431), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [46324] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2599), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2837), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2835), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
  [46380] = 29,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5311), 1,
      anon_sym_LBRACE,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5557), 1,
      anon_sym_QMARK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(2918), 1,
      sym_block,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2600), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [46484] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5559), 1,
      anon_sym_DOLLARelse,
    STATE(2601), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2093), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2091), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [46542] = 29,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5561), 1,
      anon_sym_LBRACE,
    ACTIONS(5563), 1,
      anon_sym_QMARK,
    STATE(1157), 1,
      sym_block,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2602), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [46646] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5565), 1,
      anon_sym_RBRACK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2603), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [46752] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5567), 1,
      anon_sym_RBRACK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2604), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [46858] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5569), 1,
      anon_sym_RBRACK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2605), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [46964] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2606), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2147), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2145), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
  [47020] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5571), 1,
      anon_sym_RBRACK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2607), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [47126] = 29,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5573), 1,
      anon_sym_LBRACE,
    ACTIONS(5575), 1,
      anon_sym_QMARK,
    STATE(261), 1,
      sym_block,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2608), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [47230] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2185), 1,
      anon_sym_LBRACK,
    STATE(2857), 1,
      sym_type_parameters,
    STATE(2609), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2187), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [47288] = 29,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5577), 1,
      anon_sym_LBRACE,
    ACTIONS(5579), 1,
      anon_sym_QMARK,
    STATE(2241), 1,
      sym_block,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2610), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [47392] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2103), 1,
      anon_sym_LBRACK,
    ACTIONS(5581), 1,
      anon_sym_DOLLARelse,
    STATE(2611), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2105), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [47450] = 29,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5583), 1,
      anon_sym_LBRACE,
    ACTIONS(5585), 1,
      anon_sym_QMARK,
    STATE(1294), 1,
      sym_block,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2612), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [47554] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5587), 1,
      anon_sym_RBRACK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2613), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [47660] = 29,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5327), 1,
      anon_sym_LBRACE,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5589), 1,
      anon_sym_QMARK,
    STATE(2012), 1,
      sym_block,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2614), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [47764] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    ACTIONS(5297), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5301), 1,
      anon_sym_or,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5591), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    STATE(2615), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [47866] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5593), 1,
      anon_sym_RBRACK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2616), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [47972] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2180), 1,
      anon_sym_LBRACK,
    ACTIONS(2371), 1,
      anon_sym_LBRACE,
    STATE(2617), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2175), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2173), 28,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
  [48032] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2180), 1,
      anon_sym_LBRACK,
    ACTIONS(2373), 1,
      anon_sym_LBRACE,
    STATE(2618), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2175), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [48090] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5251), 1,
      anon_sym_DOT,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5263), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5595), 1,
      anon_sym_RBRACK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2619), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [48196] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    ACTIONS(5297), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5301), 1,
      anon_sym_or,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(3908), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2620), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [48298] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2653), 1,
      anon_sym_LBRACK,
    STATE(2621), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2655), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [48353] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2831), 1,
      anon_sym_LBRACK,
    STATE(2622), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2833), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [48408] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2623), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2961), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2959), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [48463] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2624), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2935), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2933), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [48518] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2649), 1,
      anon_sym_LBRACK,
    STATE(2625), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2651), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [48573] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2645), 1,
      anon_sym_LBRACK,
    STATE(2626), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2647), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [48628] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2627), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2465), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2463), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [48683] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2625), 1,
      anon_sym_LBRACK,
    STATE(2628), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2627), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [48738] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2629), 1,
      anon_sym_LBRACK,
    STATE(2629), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2631), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [48793] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2637), 1,
      anon_sym_LBRACK,
    STATE(2630), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2639), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [48848] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2381), 1,
      anon_sym_LBRACK,
    STATE(2631), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2383), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [48903] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2879), 1,
      anon_sym_LBRACK,
    STATE(2632), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2881), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [48958] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2927), 1,
      anon_sym_LBRACK,
    STATE(2633), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2929), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [49013] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2634), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2951), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2949), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [49068] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2635), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3280), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3278), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [49123] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2375), 1,
      anon_sym_LBRACK,
    STATE(2636), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2377), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [49178] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3284), 1,
      anon_sym_LBRACK,
    STATE(2637), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3286), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [49233] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2337), 1,
      anon_sym_COMMA,
    STATE(2638), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2147), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2145), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [49290] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5597), 1,
      sym_identifier,
    ACTIONS(5599), 1,
      anon_sym_RPAREN,
    ACTIONS(5601), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5603), 1,
      anon_sym_mut,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5611), 1,
      anon_sym_shared,
    STATE(3092), 1,
      sym_mutability_modifiers,
    STATE(3849), 1,
      sym_type_parameter_declaration,
    STATE(3853), 1,
      sym_parameter_declaration,
    STATE(4379), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2639), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [49391] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5613), 1,
      anon_sym_LBRACE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2640), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [49492] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2641), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3035), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3033), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [49547] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2642), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3069), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3067), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [49602] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5615), 1,
      anon_sym_RPAREN,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2643), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [49703] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5635), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2644), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [49804] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5597), 1,
      sym_identifier,
    ACTIONS(5601), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5603), 1,
      anon_sym_mut,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5611), 1,
      anon_sym_shared,
    ACTIONS(5637), 1,
      anon_sym_RPAREN,
    STATE(3092), 1,
      sym_mutability_modifiers,
    STATE(4044), 1,
      sym_type_parameter_declaration,
    STATE(4048), 1,
      sym_parameter_declaration,
    STATE(4379), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2645), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [49905] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5639), 1,
      anon_sym_LBRACE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2646), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [50006] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5641), 1,
      anon_sym_LBRACE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2647), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [50107] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2648), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3023), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3021), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [50162] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2649), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3019), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3017), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [50217] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2650), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3015), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3013), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [50272] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2651), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2471), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2469), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [50327] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5643), 1,
      anon_sym_LBRACE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2652), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [50428] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2653), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2435), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2433), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [50483] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2654), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2335), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2337), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [50538] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5543), 1,
      anon_sym_COLON,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2655), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [50639] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5645), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2656), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [50740] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2337), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    STATE(2657), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2837), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2835), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [50797] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2658), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2873), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2871), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [50852] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2659), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2885), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2883), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [50907] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5647), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    STATE(2660), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3035), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3033), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [50964] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2661), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3262), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3260), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [51019] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2662), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2849), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2847), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [51074] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2663), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2845), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2843), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [51129] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2664), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3340), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3338), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [51184] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2665), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3336), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3334), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [51239] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2666), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3332), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3330), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [51294] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2667), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3274), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3272), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [51349] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2668), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3256), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3254), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [51404] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3254), 1,
      anon_sym_LBRACK,
    STATE(2669), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3256), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [51459] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5597), 1,
      sym_identifier,
    ACTIONS(5601), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5603), 1,
      anon_sym_mut,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5611), 1,
      anon_sym_shared,
    ACTIONS(5649), 1,
      anon_sym_RPAREN,
    STATE(3092), 1,
      sym_mutability_modifiers,
    STATE(3895), 1,
      sym_type_parameter_declaration,
    STATE(3899), 1,
      sym_parameter_declaration,
    STATE(4379), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2670), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [51560] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3272), 1,
      anon_sym_LBRACK,
    STATE(2671), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3274), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [51615] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2672), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2651), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2649), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [51670] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2673), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2647), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2645), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [51725] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    STATE(2674), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3332), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [51780] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3334), 1,
      anon_sym_LBRACK,
    STATE(2675), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3336), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [51835] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3338), 1,
      anon_sym_LBRACK,
    STATE(2676), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3340), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [51890] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2677), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2627), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2625), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [51945] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2678), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2631), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2629), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [52000] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2679), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2639), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2637), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [52055] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2680), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2383), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2381), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [52110] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2681), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2881), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2879), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [52165] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2682), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2929), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2927), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [52220] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2683), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3080), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3078), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [52275] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2684), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2377), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2375), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [52330] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2685), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3286), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3284), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [52385] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2686), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2947), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2945), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [52440] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3075), 1,
      anon_sym_DOT,
    STATE(2687), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4315), 3,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_COLON,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_DOT_DOT,
  [52499] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5651), 1,
      anon_sym_LBRACE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2688), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [52600] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5653), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2689), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [52701] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2843), 1,
      anon_sym_LBRACK,
    STATE(2690), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2845), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [52756] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2847), 1,
      anon_sym_LBRACK,
    STATE(2691), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2849), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [52811] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2692), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2877), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2875), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [52866] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2693), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2175), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2173), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [52921] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2337), 1,
      anon_sym_LBRACE,
    STATE(2694), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2147), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2145), 28,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
  [52978] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2695), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2889), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2887), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [53033] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    STATE(2696), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3262), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [53088] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2697), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3073), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3071), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [53143] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5655), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2698), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [53244] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2699), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3065), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3063), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [53299] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5657), 1,
      anon_sym_LBRACE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2700), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [53400] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5659), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2701), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [53501] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2702), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3061), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3059), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [53556] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5661), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2703), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [53657] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5663), 1,
      anon_sym_LBRACE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2704), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [53758] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2705), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2997), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2995), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [53813] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2706), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2993), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2991), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [53868] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2707), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2989), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2987), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [53923] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2337), 1,
      anon_sym_COMMA,
    STATE(2708), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2837), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2835), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [53980] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2709), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2925), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2923), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [54035] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5665), 1,
      anon_sym_LBRACE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2710), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [54136] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2711), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2169), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2167), 29,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_else,
      anon_sym_DOLLARelse,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [54191] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2712), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2921), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [54246] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2713), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2917), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2915), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [54301] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2883), 1,
      anon_sym_LBRACK,
    STATE(2714), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2885), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [54356] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2871), 1,
      anon_sym_LBRACK,
    STATE(2715), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2873), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [54411] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2337), 1,
      anon_sym_LBRACE,
    STATE(2716), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2837), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2835), 28,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_COLON_EQ,
  [54468] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5667), 1,
      anon_sym_BANG,
    STATE(2717), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2697), 12,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2695), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [54525] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5597), 1,
      sym_identifier,
    ACTIONS(5601), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5603), 1,
      anon_sym_mut,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5611), 1,
      anon_sym_shared,
    ACTIONS(5669), 1,
      anon_sym_RPAREN,
    STATE(3092), 1,
      sym_mutability_modifiers,
    STATE(3875), 1,
      sym_type_parameter_declaration,
    STATE(3880), 1,
      sym_parameter_declaration,
    STATE(4379), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2718), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [54626] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5597), 1,
      sym_identifier,
    ACTIONS(5601), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5603), 1,
      anon_sym_mut,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5611), 1,
      anon_sym_shared,
    ACTIONS(5671), 1,
      anon_sym_RPAREN,
    STATE(3092), 1,
      sym_mutability_modifiers,
    STATE(3867), 1,
      sym_parameter_declaration,
    STATE(3868), 1,
      sym_type_parameter_declaration,
    STATE(4379), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2719), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [54727] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5673), 1,
      anon_sym_LBRACE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2720), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [54828] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2721), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2429), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2427), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [54883] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2722), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2397), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2395), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [54938] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2173), 1,
      anon_sym_LBRACK,
    STATE(2723), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2175), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [54993] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2337), 1,
      anon_sym_LBRACK,
    STATE(2724), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2335), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [55048] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2725), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2147), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2145), 29,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_else,
      anon_sym_DOLLARelse,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [55103] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5675), 1,
      anon_sym_LBRACE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2726), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [55204] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2433), 1,
      anon_sym_LBRACK,
    STATE(2727), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2435), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [55259] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5677), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2728), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [55360] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    STATE(2729), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2471), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [55415] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2730), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2655), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2653), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [55470] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2731), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2659), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2657), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [55525] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2732), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2819), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2817), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [55580] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2733), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2821), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [55635] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3248), 1,
      anon_sym_LBRACK,
    STATE(2734), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3250), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [55690] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2735), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2829), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2827), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [55745] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2736), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2833), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2831), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [55800] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2737), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2977), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2975), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [55855] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2738), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2981), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2979), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [55910] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2739), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3007), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3005), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [55965] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3013), 1,
      anon_sym_LBRACK,
    STATE(2740), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3015), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [56020] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3017), 1,
      anon_sym_LBRACK,
    STATE(2741), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3019), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [56075] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3021), 1,
      anon_sym_LBRACK,
    STATE(2742), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3023), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [56130] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5679), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2743), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [56231] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5681), 1,
      anon_sym_LBRACE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2744), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [56332] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5683), 1,
      anon_sym_SEMI,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2745), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [56433] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5685), 1,
      anon_sym_else,
    STATE(2961), 1,
      sym_else_branch,
    STATE(2746), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2089), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2087), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [56492] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2747), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2893), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2891), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [56547] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2748), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2187), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2185), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [56602] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2337), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    STATE(2749), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2147), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2145), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [56659] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5597), 1,
      sym_identifier,
    ACTIONS(5601), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5603), 1,
      anon_sym_mut,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5611), 1,
      anon_sym_shared,
    ACTIONS(5687), 1,
      anon_sym_RPAREN,
    STATE(3092), 1,
      sym_mutability_modifiers,
    STATE(3939), 1,
      sym_parameter_declaration,
    STATE(3940), 1,
      sym_type_parameter_declaration,
    STATE(4379), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2750), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [56760] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2751), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3240), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3238), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [56815] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2752), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2967), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2965), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [56870] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5689), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2753), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [56971] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5685), 1,
      anon_sym_else,
    STATE(2964), 1,
      sym_else_branch,
    STATE(2754), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2083), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2081), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [57030] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5691), 1,
      anon_sym_RBRACK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2755), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [57131] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2067), 1,
      anon_sym_LBRACE,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5507), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(2756), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [57232] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2757), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3246), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3244), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [57287] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5693), 1,
      anon_sym_LBRACE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2758), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [57388] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5695), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2759), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [57489] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2760), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3266), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3264), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [57544] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2761), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3270), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3268), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [57599] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2762), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3292), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3290), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [57654] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2763), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3296), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3294), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [57709] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2764), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2841), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2839), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [57764] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5697), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2765), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [57865] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5699), 1,
      anon_sym_LBRACE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2766), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [57966] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2767), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3356), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3354), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [58021] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5597), 1,
      sym_identifier,
    ACTIONS(5601), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5603), 1,
      anon_sym_mut,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5611), 1,
      anon_sym_shared,
    ACTIONS(5701), 1,
      anon_sym_RPAREN,
    STATE(3092), 1,
      sym_mutability_modifiers,
    STATE(3855), 1,
      sym_type_parameter_declaration,
    STATE(3858), 1,
      sym_parameter_declaration,
    STATE(4379), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2768), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [58122] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2769), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3346), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3344), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [58177] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2770), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3324), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3322), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [58232] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2771), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3318), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3316), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [58287] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2772), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3312), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3310), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [58342] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2773), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3308), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3306), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [58397] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5703), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2774), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [58498] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2775), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3304), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3302), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [58553] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2776), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3300), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3298), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [58608] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5705), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2777), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [58709] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2778), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3328), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3326), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [58764] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3910), 1,
      anon_sym_LBRACE,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2779), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [58865] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5597), 1,
      sym_identifier,
    ACTIONS(5601), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5603), 1,
      anon_sym_mut,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5611), 1,
      anon_sym_shared,
    ACTIONS(5707), 1,
      anon_sym_RPAREN,
    STATE(3092), 1,
      sym_mutability_modifiers,
    STATE(3910), 1,
      sym_parameter_declaration,
    STATE(3911), 1,
      sym_type_parameter_declaration,
    STATE(4379), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2780), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [58966] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2781), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2373), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2371), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [59021] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2782), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2457), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2455), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [59076] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2783), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3084), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3082), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [59131] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3075), 1,
      anon_sym_DOT,
    STATE(2784), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 12,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3043), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [59188] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    STATE(2785), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3069), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [59243] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2786), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3041), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3039), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [59298] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2787), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3031), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3029), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [59353] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2788), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3250), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3248), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [59408] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2789), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3027), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3025), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [59463] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2790), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2453), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2451), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [59518] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2791), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3043), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [59573] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2792), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3001), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2999), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [59628] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3033), 1,
      anon_sym_LBRACK,
    STATE(2793), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3035), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [59683] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5709), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2794), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [59784] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2795), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2401), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2399), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [59839] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5597), 1,
      sym_identifier,
    ACTIONS(5601), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5603), 1,
      anon_sym_mut,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5611), 1,
      anon_sym_shared,
    ACTIONS(5711), 1,
      anon_sym_RPAREN,
    STATE(3092), 1,
      sym_mutability_modifiers,
    STATE(4019), 1,
      sym_parameter_declaration,
    STATE(4020), 1,
      sym_type_parameter_declaration,
    STATE(4379), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2796), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [59940] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2463), 1,
      anon_sym_LBRACK,
    STATE(2797), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2465), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [59995] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2798), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2957), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2955), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [60050] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2799), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2973), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2971), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [60105] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5040), 1,
      anon_sym_LPAREN,
    ACTIONS(5044), 1,
      anon_sym_LBRACK,
    ACTIONS(5046), 1,
      anon_sym_QMARK,
    ACTIONS(5048), 1,
      anon_sym_BANG,
    ACTIONS(5050), 1,
      anon_sym_LBRACK2,
    ACTIONS(5052), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5054), 1,
      anon_sym_as,
    ACTIONS(5062), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5064), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5070), 1,
      anon_sym_or,
    ACTIONS(5545), 1,
      anon_sym_CARET,
    ACTIONS(5547), 1,
      anon_sym_LT_DASH,
    STATE(2072), 1,
      sym_argument_list,
    STATE(2073), 1,
      sym_or_block,
    STATE(4173), 1,
      sym_type_parameters,
    ACTIONS(5038), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5058), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5072), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5074), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2800), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5042), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5056), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5060), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5541), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [60206] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(2049), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(2801), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2047), 15,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [60289] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2802), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2863), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [60344] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3278), 1,
      anon_sym_LBRACK,
    STATE(2803), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3280), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [60399] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2399), 1,
      anon_sym_LBRACK,
    STATE(2804), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2401), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [60454] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2949), 1,
      anon_sym_LBRACK,
    STATE(2805), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2951), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [60509] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2806), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 8,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
  [60598] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2807), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 9,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
  [60685] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2999), 1,
      anon_sym_LBRACK,
    STATE(2808), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3001), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [60740] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2933), 1,
      anon_sym_LBRACK,
    STATE(2809), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2935), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [60795] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2451), 1,
      anon_sym_LBRACK,
    STATE(2810), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2453), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [60850] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_LBRACK,
    STATE(2811), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2961), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [60905] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2971), 1,
      anon_sym_LBRACK,
    STATE(2812), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2973), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [60960] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3025), 1,
      anon_sym_LBRACK,
    STATE(2813), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3027), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [61015] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5597), 1,
      sym_identifier,
    ACTIONS(5601), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5603), 1,
      anon_sym_mut,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5611), 1,
      anon_sym_shared,
    ACTIONS(5713), 1,
      anon_sym_RPAREN,
    STATE(3092), 1,
      sym_mutability_modifiers,
    STATE(4043), 1,
      sym_type_parameter_declaration,
    STATE(4045), 1,
      sym_parameter_declaration,
    STATE(4379), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2814), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [61116] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3078), 1,
      anon_sym_LBRACK,
    STATE(2815), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3080), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [61171] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3029), 1,
      anon_sym_LBRACK,
    STATE(2816), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3031), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [61226] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2945), 1,
      anon_sym_LBRACK,
    STATE(2817), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2947), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [61281] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3039), 1,
      anon_sym_LBRACK,
    STATE(2818), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3041), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [61336] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2875), 1,
      anon_sym_LBRACK,
    STATE(2819), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2877), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [61391] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2887), 1,
      anon_sym_LBRACK,
    STATE(2820), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2889), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [61446] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3082), 1,
      anon_sym_LBRACK,
    STATE(2821), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3084), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [61501] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2455), 1,
      anon_sym_LBRACK,
    STATE(2822), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2457), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [61556] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2371), 1,
      anon_sym_LBRACK,
    STATE(2823), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2373), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [61611] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3071), 1,
      anon_sym_LBRACK,
    STATE(2824), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3073), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [61666] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3063), 1,
      anon_sym_LBRACK,
    STATE(2825), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3065), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [61721] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3059), 1,
      anon_sym_LBRACK,
    STATE(2826), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3061), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [61776] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2995), 1,
      anon_sym_LBRACK,
    STATE(2827), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2997), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [61831] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2991), 1,
      anon_sym_LBRACK,
    STATE(2828), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2993), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [61886] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2448), 1,
      anon_sym_LBRACK,
    STATE(2829), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2443), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
    ACTIONS(2445), 35,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [61943] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2987), 1,
      anon_sym_LBRACK,
    STATE(2830), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2989), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [61998] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2831), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2180), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2175), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2173), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [62055] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5599), 1,
      anon_sym_RPAREN,
    ACTIONS(5601), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5603), 1,
      anon_sym_mut,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5611), 1,
      anon_sym_shared,
    ACTIONS(5715), 1,
      sym_identifier,
    STATE(3074), 1,
      sym_mutability_modifiers,
    STATE(3849), 1,
      sym_type_parameter_declaration,
    STATE(3853), 1,
      sym_parameter_declaration,
    STATE(4379), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2832), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [62156] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2337), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    STATE(2833), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2837), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2835), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [62213] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2923), 1,
      anon_sym_LBRACK,
    STATE(2834), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2925), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [62268] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5717), 1,
      anon_sym_SEMI,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2835), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [62369] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2919), 1,
      anon_sym_LBRACK,
    STATE(2836), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2921), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [62424] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2915), 1,
      anon_sym_LBRACK,
    STATE(2837), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2917), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [62479] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(5719), 1,
      anon_sym_BANG,
    STATE(2838), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2697), 38,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [62536] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5721), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2839), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [62637] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3298), 1,
      anon_sym_LBRACK,
    STATE(2840), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3300), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [62692] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2337), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    STATE(2841), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2147), 13,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2145), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [62749] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3302), 1,
      anon_sym_LBRACK,
    STATE(2842), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3304), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [62804] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5723), 1,
      anon_sym_RBRACK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2843), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [62905] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3306), 1,
      anon_sym_LBRACK,
    STATE(2844), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3308), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [62960] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3310), 1,
      anon_sym_LBRACK,
    STATE(2845), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3312), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [63015] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3316), 1,
      anon_sym_LBRACK,
    STATE(2846), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3318), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [63070] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3322), 1,
      anon_sym_LBRACK,
    STATE(2847), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3324), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [63125] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3344), 1,
      anon_sym_LBRACK,
    STATE(2848), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3346), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [63180] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2427), 1,
      anon_sym_LBRACK,
    STATE(2849), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2429), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [63235] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3354), 1,
      anon_sym_LBRACK,
    STATE(2850), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3356), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [63290] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2177), 1,
      anon_sym_DOT,
    ACTIONS(2371), 1,
      anon_sym_LBRACK,
    STATE(2851), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2373), 38,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [63347] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2180), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2371), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    STATE(2852), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2175), 12,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2173), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_DOT_DOT,
  [63406] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2177), 1,
      anon_sym_DOT,
    STATE(2853), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2373), 12,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2371), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [63463] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2863), 1,
      anon_sym_LBRACK,
    STATE(2854), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [63518] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2395), 1,
      anon_sym_LBRACK,
    STATE(2855), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2397), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [63573] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(2856), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2053), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [63652] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2839), 1,
      anon_sym_LBRACK,
    STATE(2857), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2841), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [63707] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2657), 1,
      anon_sym_LBRACK,
    STATE(2858), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2659), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [63762] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2817), 1,
      anon_sym_LBRACK,
    STATE(2859), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2819), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [63817] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2821), 1,
      anon_sym_LBRACK,
    STATE(2860), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [63872] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(2053), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(2861), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [63955] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2827), 1,
      anon_sym_LBRACK,
    STATE(2862), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2829), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [64010] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2863), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 9,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
  [64097] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3294), 1,
      anon_sym_LBRACK,
    STATE(2864), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3296), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [64152] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5591), 1,
      anon_sym_LBRACE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2865), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [64253] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2866), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 8,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
  [64342] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5725), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2867), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [64443] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5597), 1,
      sym_identifier,
    ACTIONS(5601), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5603), 1,
      anon_sym_mut,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5611), 1,
      anon_sym_shared,
    ACTIONS(5711), 1,
      anon_sym_RPAREN,
    STATE(3092), 1,
      sym_mutability_modifiers,
    STATE(3969), 1,
      sym_plain_type,
    STATE(4019), 1,
      sym_parameter_declaration,
    STATE(4020), 1,
      sym_type_parameter_declaration,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2868), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [64544] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5727), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2869), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [64645] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(2049), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(2870), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2047), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [64728] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5729), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2871), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [64829] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5731), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2872), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [64930] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3290), 1,
      anon_sym_LBRACK,
    STATE(2873), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3292), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [64985] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5597), 1,
      sym_identifier,
    ACTIONS(5601), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5603), 1,
      anon_sym_mut,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5611), 1,
      anon_sym_shared,
    ACTIONS(5733), 1,
      anon_sym_RPAREN,
    STATE(3092), 1,
      sym_mutability_modifiers,
    STATE(4029), 1,
      sym_type_parameter_declaration,
    STATE(4034), 1,
      sym_parameter_declaration,
    STATE(4379), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2874), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [65086] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5735), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2875), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [65187] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3268), 1,
      anon_sym_LBRACK,
    STATE(2876), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3270), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [65242] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_LBRACK,
    STATE(2877), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2957), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [65297] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3264), 1,
      anon_sym_LBRACK,
    STATE(2878), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3266), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [65352] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5597), 1,
      sym_identifier,
    ACTIONS(5601), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5603), 1,
      anon_sym_mut,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5611), 1,
      anon_sym_shared,
    ACTIONS(5737), 1,
      anon_sym_RPAREN,
    STATE(3092), 1,
      sym_mutability_modifiers,
    STATE(4007), 1,
      sym_parameter_declaration,
    STATE(4008), 1,
      sym_type_parameter_declaration,
    STATE(4379), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2879), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [65453] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3043), 1,
      anon_sym_LBRACK,
    STATE(2880), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [65508] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2975), 1,
      anon_sym_LBRACK,
    STATE(2881), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2977), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [65563] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2979), 1,
      anon_sym_LBRACK,
    STATE(2882), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2981), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [65618] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3005), 1,
      anon_sym_LBRACK,
    STATE(2883), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3007), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [65673] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3043), 1,
      anon_sym_LBRACK,
    ACTIONS(3075), 1,
      anon_sym_DOT,
    STATE(2884), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 38,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [65730] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5739), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2885), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [65831] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5597), 1,
      sym_identifier,
    ACTIONS(5601), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5603), 1,
      anon_sym_mut,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5611), 1,
      anon_sym_shared,
    ACTIONS(5741), 1,
      anon_sym_RPAREN,
    STATE(3092), 1,
      sym_mutability_modifiers,
    STATE(4067), 1,
      sym_type_parameter_declaration,
    STATE(4068), 1,
      sym_parameter_declaration,
    STATE(4379), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2886), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [65932] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(2053), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(2887), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 15,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [66015] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2891), 1,
      anon_sym_LBRACK,
    STATE(2888), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2893), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [66070] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2185), 1,
      anon_sym_LBRACK,
    STATE(2889), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2187), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [66125] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(2890), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2053), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(2051), 16,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [66204] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3326), 1,
      anon_sym_LBRACK,
    STATE(2891), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3328), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [66259] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2063), 1,
      anon_sym_RPAREN,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2892), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [66360] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5743), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2893), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [66461] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5597), 1,
      sym_identifier,
    ACTIONS(5601), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5603), 1,
      anon_sym_mut,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5611), 1,
      anon_sym_shared,
    ACTIONS(5745), 1,
      anon_sym_RPAREN,
    STATE(3092), 1,
      sym_mutability_modifiers,
    STATE(4027), 1,
      sym_type_parameter_declaration,
    STATE(4030), 1,
      sym_parameter_declaration,
    STATE(4379), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2894), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [66562] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3238), 1,
      anon_sym_LBRACK,
    STATE(2895), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3240), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [66617] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2896), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [66718] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3244), 1,
      anon_sym_LBRACK,
    STATE(2897), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3246), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [66773] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2073), 1,
      anon_sym_LBRACE,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5491), 1,
      anon_sym_CARET,
    ACTIONS(5493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5485), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2898), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5479), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5483), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5487), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5481), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [66874] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5597), 1,
      sym_identifier,
    ACTIONS(5601), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5603), 1,
      anon_sym_mut,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5611), 1,
      anon_sym_shared,
    ACTIONS(5747), 1,
      anon_sym_RPAREN,
    STATE(3092), 1,
      sym_mutability_modifiers,
    STATE(4079), 1,
      sym_parameter_declaration,
    STATE(4080), 1,
      sym_type_parameter_declaration,
    STATE(4379), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2899), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [66975] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2073), 1,
      anon_sym_RPAREN,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2900), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [67076] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5749), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2901), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [67177] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2965), 1,
      anon_sym_LBRACK,
    STATE(2902), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2967), 39,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [67232] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2180), 1,
      anon_sym_LBRACK,
    ACTIONS(2371), 1,
      anon_sym_LBRACE,
    ACTIONS(5751), 2,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
    STATE(2903), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2175), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2173), 24,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [67292] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5753), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(2904), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [67390] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(877), 1,
      anon_sym_LBRACK2,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(2175), 1,
      anon_sym_DOT,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5755), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(4247), 1,
      sym_plain_type,
    STATE(4249), 1,
      sym__plain_type_without_special,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2905), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    ACTIONS(2371), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    STATE(2416), 3,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [67486] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5757), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(2906), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [67584] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5759), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(2907), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [67682] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4320), 2,
      anon_sym_SEMI,
      anon_sym_RBRACK,
    STATE(2908), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2957), 12,
      anon_sym_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2955), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
      anon_sym_DOT_DOT,
  [67738] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(877), 1,
      anon_sym_LBRACK2,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(2175), 1,
      anon_sym_DOT,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5761), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(4254), 1,
      sym__plain_type_without_special,
    STATE(4257), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2909), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    ACTIONS(2371), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    STATE(2416), 3,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [67834] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5295), 1,
      anon_sym_CARET,
    ACTIONS(5297), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5301), 1,
      anon_sym_or,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5305), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2910), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5281), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5285), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5289), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5283), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [67932] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5763), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(2911), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [68030] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5765), 1,
      anon_sym_DOLLARelse,
    STATE(2912), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2093), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2091), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [68086] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5767), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(2913), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [68184] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5769), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(2914), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [68282] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5771), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(2915), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [68380] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(877), 1,
      anon_sym_LBRACK2,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(2175), 1,
      anon_sym_DOT,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5761), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(4257), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2916), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    ACTIONS(2371), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [68474] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4996), 1,
      anon_sym_as,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(5014), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5016), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5018), 1,
      anon_sym_QMARK,
    ACTIONS(5020), 1,
      anon_sym_BANG,
    ACTIONS(5022), 1,
      anon_sym_LBRACK2,
    ACTIONS(5024), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5026), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5028), 1,
      anon_sym_or,
    ACTIONS(5030), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5775), 1,
      anon_sym_CARET,
    STATE(2134), 1,
      sym_argument_list,
    STATE(2135), 1,
      sym_or_block,
    STATE(4203), 1,
      sym_type_parameters,
    ACTIONS(4994), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5032), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5034), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2917), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5004), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5006), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5010), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5773), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [68572] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5777), 1,
      anon_sym_DOLLARelse,
    STATE(2918), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2105), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2103), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [68628] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2919), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2445), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2448), 28,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [68682] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5779), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(2920), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [68780] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5633), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2921), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5617), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5621), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5625), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5619), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [68878] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5555), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(2922), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [68976] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5781), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(2923), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [69074] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5783), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(2924), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [69172] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5303), 2,
      anon_sym_is,
      anon_sym_BANGis,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    STATE(2925), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [69270] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5104), 1,
      anon_sym_LBRACE,
    ACTIONS(5785), 1,
      anon_sym_COMMA,
    STATE(3977), 1,
      aux_sym_expression_without_blocks_list_repeat1,
    STATE(2926), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3035), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3033), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [69330] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5787), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(2927), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [69428] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    ACTIONS(5255), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_BANG,
    ACTIONS(5261), 1,
      anon_sym_LBRACK2,
    ACTIONS(5265), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_as,
    ACTIONS(5291), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(5293), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5301), 1,
      anon_sym_or,
    ACTIONS(5401), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5405), 1,
      anon_sym_PIPE_PIPE,
    STATE(2424), 1,
      sym_or_block,
    STATE(2426), 1,
      sym_argument_list,
    STATE(4331), 1,
      sym_type_parameters,
    ACTIONS(5263), 2,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(5397), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5407), 2,
      anon_sym_in,
      anon_sym_BANGin,
    ACTIONS(5789), 2,
      anon_sym_is,
      anon_sym_BANGis,
    STATE(2928), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(5395), 3,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5399), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(5393), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
  [69526] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(877), 1,
      anon_sym_LBRACK2,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(2175), 1,
      anon_sym_DOT,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5755), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(4247), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2929), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    ACTIONS(2371), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [69620] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2912), 1,
      sym_block,
    STATE(2930), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2821), 26,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [69675] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5601), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5603), 1,
      anon_sym_mut,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5611), 1,
      anon_sym_shared,
    STATE(3068), 1,
      sym_mutability_modifiers,
    STATE(4195), 1,
      sym_type_parameter_declaration,
    STATE(4379), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2931), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [69770] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2932), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3023), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3021), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [69823] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(1432), 1,
      sym_block,
    STATE(2933), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2821), 26,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [69878] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(259), 1,
      sym_block,
    STATE(2934), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2821), 26,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [69933] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2935), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3069), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3067), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [69986] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5153), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    STATE(2936), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3035), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3033), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [70041] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2937), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3019), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3017), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [70094] = 23,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(5791), 1,
      anon_sym_fn,
    ACTIONS(5793), 1,
      anon_sym_STAR,
    ACTIONS(5795), 1,
      anon_sym_QMARK,
    ACTIONS(5797), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_LBRACK2,
    ACTIONS(5801), 1,
      anon_sym_AMP,
    ACTIONS(5803), 1,
      anon_sym_shared,
    ACTIONS(5805), 1,
      anon_sym_map_LBRACK,
    ACTIONS(5807), 1,
      anon_sym_chan,
    ACTIONS(5809), 1,
      anon_sym_thread,
    ACTIONS(5811), 1,
      anon_sym_atomic,
    STATE(1084), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(2938), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    ACTIONS(855), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [70183] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2939), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3015), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3013), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [70236] = 23,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(5791), 1,
      anon_sym_fn,
    ACTIONS(5793), 1,
      anon_sym_STAR,
    ACTIONS(5795), 1,
      anon_sym_QMARK,
    ACTIONS(5797), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_LBRACK2,
    ACTIONS(5801), 1,
      anon_sym_AMP,
    ACTIONS(5803), 1,
      anon_sym_shared,
    ACTIONS(5805), 1,
      anon_sym_map_LBRACK,
    ACTIONS(5807), 1,
      anon_sym_chan,
    ACTIONS(5809), 1,
      anon_sym_thread,
    ACTIONS(5811), 1,
      anon_sym_atomic,
    STATE(1088), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(2940), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    ACTIONS(859), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [70325] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(2441), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2941), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    ACTIONS(857), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [70414] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2942), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2335), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2337), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [70467] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(1573), 1,
      sym_block,
    STATE(2943), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2821), 26,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [70522] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(998), 1,
      sym_block,
    STATE(2944), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2821), 26,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [70577] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(1295), 1,
      sym_block,
    STATE(2945), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2821), 26,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [70632] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2601), 1,
      sym_block,
    STATE(2946), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2821), 26,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [70687] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2947), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2471), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2469), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [70740] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2180), 1,
      anon_sym_LBRACK,
    ACTIONS(2371), 1,
      anon_sym_LBRACE,
    ACTIONS(5813), 2,
      anon_sym_COMMA,
      anon_sym_in,
    STATE(2948), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2175), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2173), 23,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_BANGin,
  [70799] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2949), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3250), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3248), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [70852] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(1155), 1,
      sym_block,
    STATE(2950), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2821), 26,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [70907] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2016), 1,
      sym_block,
    STATE(2951), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2821), 26,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [70962] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2952), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2873), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2871), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [71015] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(2445), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2953), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    ACTIONS(817), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [71104] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2954), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3035), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3033), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [71157] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2955), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2885), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2883), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [71210] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2956), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3286), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3284), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [71263] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2957), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2845), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2843), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [71316] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2015), 1,
      sym_block,
    STATE(2958), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2821), 26,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [71371] = 23,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(5791), 1,
      anon_sym_fn,
    ACTIONS(5793), 1,
      anon_sym_STAR,
    ACTIONS(5795), 1,
      anon_sym_QMARK,
    ACTIONS(5797), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_LBRACK2,
    ACTIONS(5801), 1,
      anon_sym_AMP,
    ACTIONS(5803), 1,
      anon_sym_shared,
    ACTIONS(5805), 1,
      anon_sym_map_LBRACK,
    ACTIONS(5807), 1,
      anon_sym_chan,
    ACTIONS(5809), 1,
      anon_sym_thread,
    ACTIONS(5811), 1,
      anon_sym_atomic,
    STATE(1110), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(2959), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    ACTIONS(821), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [71460] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2585), 1,
      sym_block,
    STATE(2960), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2821), 26,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [71515] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2961), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3340), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3338), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [71568] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2962), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2435), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2433), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [71621] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(2489), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2963), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    ACTIONS(853), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [71710] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2964), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3336), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3334), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [71763] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2965), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2849), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2847), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [71816] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2966), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2377), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2375), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [71869] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2392), 1,
      sym_block,
    STATE(2967), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2821), 26,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [71924] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2968), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2929), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2927), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [71977] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2969), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2881), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2879), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [72030] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2970), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2383), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2381), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [72083] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2971), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2639), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2637), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [72136] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2972), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3262), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3260), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [72189] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2973), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2631), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2629), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [72242] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2257), 1,
      sym_block,
    STATE(2974), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2821), 26,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [72297] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2975), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2627), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2625), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [72350] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2976), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2647), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2645), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [72403] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2977), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2651), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2649), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [72456] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2978), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3256), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3254), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [72509] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2979), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3274), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3272), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [72562] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2980), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3332), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3330), 27,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_DASH,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [72615] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5815), 1,
      anon_sym_RBRACK,
    STATE(2981), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [72671] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5817), 1,
      anon_sym_RBRACK,
    STATE(2982), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [72727] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5819), 1,
      anon_sym_RPAREN,
    STATE(2983), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [72781] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5821), 1,
      anon_sym_RBRACK,
    STATE(2984), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [72835] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5823), 1,
      anon_sym_RBRACK,
    STATE(2985), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [72889] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5823), 1,
      anon_sym_RBRACK,
    STATE(2986), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2863), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [72943] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5825), 1,
      anon_sym_RBRACK,
    STATE(2987), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2863), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [72997] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5827), 1,
      anon_sym_RPAREN,
    STATE(2988), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3035), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3033), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [73051] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5825), 1,
      anon_sym_RBRACK,
    STATE(2989), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [73105] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5825), 1,
      anon_sym_RBRACK,
    STATE(2990), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [73161] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5829), 1,
      anon_sym_RPAREN,
    STATE(2991), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [73217] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5829), 1,
      anon_sym_RPAREN,
    STATE(2992), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [73271] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5831), 1,
      anon_sym_RBRACK,
    STATE(2993), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [73327] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5831), 1,
      anon_sym_RBRACK,
    STATE(2994), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [73381] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5833), 1,
      anon_sym_RPAREN,
    STATE(2995), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [73435] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5833), 1,
      anon_sym_RPAREN,
    STATE(2996), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [73491] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5831), 1,
      anon_sym_RBRACK,
    STATE(2997), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2863), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [73545] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5819), 1,
      anon_sym_RPAREN,
    STATE(2998), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [73601] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5835), 1,
      anon_sym_RPAREN,
    STATE(2999), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3035), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3033), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [73655] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5837), 1,
      anon_sym_RPAREN,
    STATE(3000), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [73709] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5839), 1,
      anon_sym_RBRACK,
    STATE(3001), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2863), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [73763] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5817), 1,
      anon_sym_RBRACK,
    STATE(3002), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2863), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [73817] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5817), 1,
      anon_sym_RBRACK,
    STATE(3003), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [73871] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5841), 1,
      anon_sym_RBRACK,
    STATE(3004), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2863), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [73925] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5843), 1,
      anon_sym_RBRACK,
    STATE(3005), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [73979] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5845), 1,
      anon_sym_RBRACK,
    STATE(3006), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2863), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [74033] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5845), 1,
      anon_sym_RBRACK,
    STATE(3007), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [74087] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5843), 1,
      anon_sym_RBRACK,
    STATE(3008), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [74143] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5847), 1,
      anon_sym_RPAREN,
    STATE(3009), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [74197] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5845), 1,
      anon_sym_RBRACK,
    STATE(3010), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [74253] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5847), 1,
      anon_sym_RPAREN,
    STATE(3011), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [74309] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5823), 1,
      anon_sym_RBRACK,
    STATE(3012), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [74365] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5841), 1,
      anon_sym_RBRACK,
    STATE(3013), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [74419] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5849), 1,
      anon_sym_RBRACK,
    STATE(3014), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2863), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [74473] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5851), 1,
      anon_sym_RBRACK,
    STATE(3015), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2863), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [74527] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5849), 1,
      anon_sym_RBRACK,
    STATE(3016), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [74581] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5853), 1,
      anon_sym_RBRACK,
    STATE(3017), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2863), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [74635] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5853), 1,
      anon_sym_RBRACK,
    STATE(3018), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [74689] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5855), 1,
      anon_sym_LBRACE,
    STATE(3019), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [74743] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5851), 1,
      anon_sym_RBRACK,
    STATE(3020), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [74797] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5851), 1,
      anon_sym_RBRACK,
    STATE(3021), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [74853] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5857), 1,
      anon_sym_RBRACK,
    STATE(3022), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2863), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [74907] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5859), 1,
      anon_sym_RBRACK,
    STATE(3023), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2863), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [74961] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5859), 1,
      anon_sym_RBRACK,
    STATE(3024), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [75015] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5859), 1,
      anon_sym_RBRACK,
    STATE(3025), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [75071] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5861), 1,
      anon_sym_RPAREN,
    STATE(3026), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [75125] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5821), 1,
      anon_sym_RBRACK,
    STATE(3027), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [75181] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5863), 1,
      anon_sym_RPAREN,
    STATE(3028), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [75237] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5861), 1,
      anon_sym_RPAREN,
    STATE(3029), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [75293] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5857), 1,
      anon_sym_RBRACK,
    STATE(3030), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [75347] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5849), 1,
      anon_sym_RBRACK,
    STATE(3031), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [75403] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5863), 1,
      anon_sym_RPAREN,
    STATE(3032), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [75457] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5865), 1,
      anon_sym_RPAREN,
    STATE(3033), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3035), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3033), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [75511] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5867), 1,
      anon_sym_RPAREN,
    STATE(3034), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [75567] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5839), 1,
      anon_sym_RBRACK,
    STATE(3035), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [75623] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5815), 1,
      anon_sym_RBRACK,
    STATE(3036), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2863), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [75677] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5815), 1,
      anon_sym_RBRACK,
    STATE(3037), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [75731] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5843), 1,
      anon_sym_RBRACK,
    STATE(3038), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2863), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [75785] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5853), 1,
      anon_sym_RBRACK,
    STATE(3039), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [75841] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5869), 1,
      anon_sym_RBRACK,
    STATE(3040), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2863), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [75895] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5869), 1,
      anon_sym_RBRACK,
    STATE(3041), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [75949] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5869), 1,
      anon_sym_RBRACK,
    STATE(3042), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [76005] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5841), 1,
      anon_sym_RBRACK,
    STATE(3043), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [76061] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5867), 1,
      anon_sym_RPAREN,
    STATE(3044), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [76115] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5871), 1,
      anon_sym_RPAREN,
    STATE(3045), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [76169] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5821), 1,
      anon_sym_RBRACK,
    STATE(3046), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2863), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [76223] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5873), 1,
      anon_sym_RPAREN,
    STATE(3047), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [76277] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5873), 1,
      anon_sym_RPAREN,
    STATE(3048), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [76333] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5875), 1,
      anon_sym_RPAREN,
    STATE(3049), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [76389] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5875), 1,
      anon_sym_RPAREN,
    STATE(3050), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [76443] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5877), 1,
      anon_sym_RPAREN,
    STATE(3051), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [76497] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5877), 1,
      anon_sym_RPAREN,
    STATE(3052), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [76553] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5857), 1,
      anon_sym_RBRACK,
    STATE(3053), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [76609] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5871), 1,
      anon_sym_RPAREN,
    STATE(3054), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [76665] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5879), 1,
      anon_sym_RBRACK,
    STATE(3055), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2865), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2863), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [76719] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5879), 1,
      anon_sym_RBRACK,
    STATE(3056), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [76773] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5837), 1,
      anon_sym_RPAREN,
    STATE(3057), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [76829] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5839), 1,
      anon_sym_RBRACK,
    STATE(3058), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 25,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [76883] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5126), 1,
      anon_sym_DOT,
    ACTIONS(5879), 1,
      anon_sym_RBRACK,
    STATE(3059), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3045), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(3043), 24,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
      anon_sym_QMARK_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_is,
      anon_sym_BANGis,
      anon_sym_in,
      anon_sym_BANGin,
  [76939] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(5791), 1,
      anon_sym_fn,
    ACTIONS(5803), 1,
      anon_sym_shared,
    ACTIONS(5807), 1,
      anon_sym_chan,
    ACTIONS(5809), 1,
      anon_sym_thread,
    ACTIONS(5811), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(5883), 1,
      anon_sym_EQ,
    ACTIONS(5885), 1,
      anon_sym_STAR,
    ACTIONS(5887), 1,
      anon_sym_QMARK,
    ACTIONS(5889), 1,
      anon_sym_BANG,
    ACTIONS(5891), 1,
      anon_sym_LBRACK2,
    ACTIONS(5893), 1,
      anon_sym_AMP,
    ACTIONS(5895), 1,
      anon_sym_map_LBRACK,
    STATE(3778), 1,
      sym__global_var_value,
    STATE(3786), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(3060), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [77028] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4066), 1,
      sym_identifier,
    ACTIONS(4070), 1,
      anon_sym_fn,
    ACTIONS(4074), 1,
      anon_sym_struct,
    ACTIONS(4084), 1,
      anon_sym_shared,
    ACTIONS(4088), 1,
      anon_sym_chan,
    ACTIONS(4090), 1,
      anon_sym_thread,
    ACTIONS(4092), 1,
      anon_sym_atomic,
    ACTIONS(5897), 1,
      anon_sym_LPAREN,
    ACTIONS(5899), 1,
      anon_sym_EQ,
    ACTIONS(5901), 1,
      anon_sym_STAR,
    ACTIONS(5903), 1,
      anon_sym_QMARK,
    ACTIONS(5905), 1,
      anon_sym_BANG,
    ACTIONS(5907), 1,
      anon_sym_LBRACK2,
    ACTIONS(5909), 1,
      anon_sym_AMP,
    ACTIONS(5911), 1,
      anon_sym_map_LBRACK,
    STATE(1835), 1,
      sym__global_var_value,
    STATE(1840), 1,
      sym_plain_type,
    STATE(4601), 1,
      sym_reference_expression,
    STATE(1730), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3061), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1875), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1881), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [77117] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5913), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3062), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [77203] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5915), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3063), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [77289] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4022), 1,
      sym_identifier,
    ACTIONS(4026), 1,
      anon_sym_fn,
    ACTIONS(4030), 1,
      anon_sym_struct,
    ACTIONS(4040), 1,
      anon_sym_shared,
    ACTIONS(4044), 1,
      anon_sym_chan,
    ACTIONS(4046), 1,
      anon_sym_thread,
    ACTIONS(4048), 1,
      anon_sym_atomic,
    ACTIONS(5917), 1,
      anon_sym_LPAREN,
    ACTIONS(5919), 1,
      anon_sym_STAR,
    ACTIONS(5921), 1,
      anon_sym_QMARK,
    ACTIONS(5923), 1,
      anon_sym_BANG,
    ACTIONS(5925), 1,
      anon_sym_LBRACK2,
    ACTIONS(5927), 1,
      anon_sym_AMP,
    ACTIONS(5929), 1,
      anon_sym_map_LBRACK,
    STATE(1707), 1,
      sym_plain_type,
    STATE(1877), 1,
      sym_sum_type,
    STATE(4425), 1,
      sym_reference_expression,
    STATE(1699), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3064), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1719), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1721), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [77375] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5931), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3065), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [77461] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5933), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3066), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [77547] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5935), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3067), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [77633] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5937), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(4232), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3068), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [77719] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5939), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3069), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [77805] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5941), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3070), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [77891] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2484), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3071), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    ACTIONS(4959), 7,
      anon_sym_fn,
      anon_sym_struct,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
    ACTIONS(4961), 8,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_map_LBRACK,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [77951] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5943), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3072), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [78037] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5755), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(4247), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3073), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [78123] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5937), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5945), 1,
      sym_identifier,
    STATE(4232), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3074), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [78209] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5947), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3075), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [78295] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5949), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3076), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [78381] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5951), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3077), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [78467] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5953), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3078), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [78553] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5955), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3079), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [78639] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5957), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3080), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [78725] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5959), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3081), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [78811] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5961), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3082), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [78897] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3083), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [78983] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4022), 1,
      sym_identifier,
    ACTIONS(4026), 1,
      anon_sym_fn,
    ACTIONS(4030), 1,
      anon_sym_struct,
    ACTIONS(4040), 1,
      anon_sym_shared,
    ACTIONS(4044), 1,
      anon_sym_chan,
    ACTIONS(4046), 1,
      anon_sym_thread,
    ACTIONS(4048), 1,
      anon_sym_atomic,
    ACTIONS(5917), 1,
      anon_sym_LPAREN,
    ACTIONS(5919), 1,
      anon_sym_STAR,
    ACTIONS(5921), 1,
      anon_sym_QMARK,
    ACTIONS(5923), 1,
      anon_sym_BANG,
    ACTIONS(5925), 1,
      anon_sym_LBRACK2,
    ACTIONS(5927), 1,
      anon_sym_AMP,
    ACTIONS(5929), 1,
      anon_sym_map_LBRACK,
    STATE(1703), 1,
      sym_plain_type,
    STATE(1854), 1,
      sym_sum_type,
    STATE(4425), 1,
      sym_reference_expression,
    STATE(1699), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3084), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1719), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1721), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [79069] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5965), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3085), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [79155] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5967), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3086), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [79241] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5969), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3087), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [79327] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5971), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3088), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [79413] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5973), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3089), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [79499] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5761), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(4257), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3090), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [79585] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5975), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3091), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [79671] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5937), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5977), 1,
      sym_identifier,
    STATE(4232), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3092), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [79757] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5979), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3093), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [79843] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5981), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3094), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [79929] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5983), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3095), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [80015] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4022), 1,
      sym_identifier,
    ACTIONS(4026), 1,
      anon_sym_fn,
    ACTIONS(4030), 1,
      anon_sym_struct,
    ACTIONS(4040), 1,
      anon_sym_shared,
    ACTIONS(4044), 1,
      anon_sym_chan,
    ACTIONS(4046), 1,
      anon_sym_thread,
    ACTIONS(4048), 1,
      anon_sym_atomic,
    ACTIONS(5917), 1,
      anon_sym_LPAREN,
    ACTIONS(5919), 1,
      anon_sym_STAR,
    ACTIONS(5921), 1,
      anon_sym_QMARK,
    ACTIONS(5923), 1,
      anon_sym_BANG,
    ACTIONS(5925), 1,
      anon_sym_LBRACK2,
    ACTIONS(5927), 1,
      anon_sym_AMP,
    ACTIONS(5929), 1,
      anon_sym_map_LBRACK,
    STATE(1704), 1,
      sym_plain_type,
    STATE(1905), 1,
      sym_sum_type,
    STATE(4425), 1,
      sym_reference_expression,
    STATE(1699), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3096), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1719), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1721), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [80101] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5985), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3097), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [80187] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5987), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3098), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [80273] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4022), 1,
      sym_identifier,
    ACTIONS(4026), 1,
      anon_sym_fn,
    ACTIONS(4030), 1,
      anon_sym_struct,
    ACTIONS(4040), 1,
      anon_sym_shared,
    ACTIONS(4044), 1,
      anon_sym_chan,
    ACTIONS(4046), 1,
      anon_sym_thread,
    ACTIONS(4048), 1,
      anon_sym_atomic,
    ACTIONS(5917), 1,
      anon_sym_LPAREN,
    ACTIONS(5919), 1,
      anon_sym_STAR,
    ACTIONS(5921), 1,
      anon_sym_QMARK,
    ACTIONS(5923), 1,
      anon_sym_BANG,
    ACTIONS(5925), 1,
      anon_sym_LBRACK2,
    ACTIONS(5927), 1,
      anon_sym_AMP,
    ACTIONS(5929), 1,
      anon_sym_map_LBRACK,
    STATE(1708), 1,
      sym_plain_type,
    STATE(1784), 1,
      sym_sum_type,
    STATE(4425), 1,
      sym_reference_expression,
    STATE(1699), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3099), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1719), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1721), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [80359] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5989), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3100), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [80445] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    ACTIONS(5991), 1,
      anon_sym_RPAREN,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3101), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [80531] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(3844), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3102), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [80614] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4925), 1,
      sym_identifier,
    ACTIONS(4929), 1,
      anon_sym_fn,
    ACTIONS(4933), 1,
      anon_sym_struct,
    ACTIONS(4943), 1,
      anon_sym_shared,
    ACTIONS(4947), 1,
      anon_sym_chan,
    ACTIONS(4949), 1,
      anon_sym_thread,
    ACTIONS(4951), 1,
      anon_sym_atomic,
    ACTIONS(5993), 1,
      anon_sym_LPAREN,
    ACTIONS(5995), 1,
      anon_sym_STAR,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_BANG,
    ACTIONS(6001), 1,
      anon_sym_LBRACK2,
    ACTIONS(6003), 1,
      anon_sym_AMP,
    ACTIONS(6005), 1,
      anon_sym_map_LBRACK,
    STATE(2876), 1,
      sym_plain_type,
    STATE(4557), 1,
      sym_reference_expression,
    STATE(2609), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3103), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2888), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2889), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [80697] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4190), 1,
      sym_identifier,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_fn,
    ACTIONS(4198), 1,
      anon_sym_struct,
    ACTIONS(4208), 1,
      anon_sym_shared,
    ACTIONS(4210), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4212), 1,
      anon_sym_chan,
    ACTIONS(4214), 1,
      anon_sym_thread,
    ACTIONS(4216), 1,
      anon_sym_atomic,
    ACTIONS(6007), 1,
      anon_sym_STAR,
    ACTIONS(6009), 1,
      anon_sym_QMARK,
    ACTIONS(6011), 1,
      anon_sym_BANG,
    ACTIONS(6013), 1,
      anon_sym_LBRACK2,
    ACTIONS(6015), 1,
      anon_sym_AMP,
    STATE(2128), 1,
      sym_plain_type,
    STATE(4528), 1,
      sym_reference_expression,
    STATE(2017), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3104), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2110), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2111), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [80780] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3406), 1,
      sym_identifier,
    ACTIONS(3410), 1,
      anon_sym_fn,
    ACTIONS(3414), 1,
      anon_sym_struct,
    ACTIONS(3424), 1,
      anon_sym_shared,
    ACTIONS(3428), 1,
      anon_sym_chan,
    ACTIONS(3430), 1,
      anon_sym_thread,
    ACTIONS(3432), 1,
      anon_sym_atomic,
    ACTIONS(6017), 1,
      anon_sym_LPAREN,
    ACTIONS(6019), 1,
      anon_sym_STAR,
    ACTIONS(6021), 1,
      anon_sym_QMARK,
    ACTIONS(6023), 1,
      anon_sym_BANG,
    ACTIONS(6025), 1,
      anon_sym_LBRACK2,
    ACTIONS(6027), 1,
      anon_sym_AMP,
    ACTIONS(6029), 1,
      anon_sym_map_LBRACK,
    STATE(1357), 1,
      sym_plain_type,
    STATE(4486), 1,
      sym_reference_expression,
    STATE(1298), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3105), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1327), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1324), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [80863] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4190), 1,
      sym_identifier,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_fn,
    ACTIONS(4198), 1,
      anon_sym_struct,
    ACTIONS(4208), 1,
      anon_sym_shared,
    ACTIONS(4210), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4212), 1,
      anon_sym_chan,
    ACTIONS(4214), 1,
      anon_sym_thread,
    ACTIONS(4216), 1,
      anon_sym_atomic,
    ACTIONS(6007), 1,
      anon_sym_STAR,
    ACTIONS(6009), 1,
      anon_sym_QMARK,
    ACTIONS(6011), 1,
      anon_sym_BANG,
    ACTIONS(6013), 1,
      anon_sym_LBRACK2,
    ACTIONS(6015), 1,
      anon_sym_AMP,
    STATE(2115), 1,
      sym_plain_type,
    STATE(4528), 1,
      sym_reference_expression,
    STATE(2017), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3106), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2110), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2111), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [80946] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3406), 1,
      sym_identifier,
    ACTIONS(3410), 1,
      anon_sym_fn,
    ACTIONS(3414), 1,
      anon_sym_struct,
    ACTIONS(3424), 1,
      anon_sym_shared,
    ACTIONS(3428), 1,
      anon_sym_chan,
    ACTIONS(3430), 1,
      anon_sym_thread,
    ACTIONS(3432), 1,
      anon_sym_atomic,
    ACTIONS(6017), 1,
      anon_sym_LPAREN,
    ACTIONS(6019), 1,
      anon_sym_STAR,
    ACTIONS(6021), 1,
      anon_sym_QMARK,
    ACTIONS(6023), 1,
      anon_sym_BANG,
    ACTIONS(6025), 1,
      anon_sym_LBRACK2,
    ACTIONS(6027), 1,
      anon_sym_AMP,
    ACTIONS(6029), 1,
      anon_sym_map_LBRACK,
    STATE(1392), 1,
      sym_plain_type,
    STATE(4486), 1,
      sym_reference_expression,
    STATE(1298), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3107), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1327), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1324), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [81029] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3940), 1,
      sym_identifier,
    ACTIONS(3942), 1,
      anon_sym_LPAREN,
    ACTIONS(3944), 1,
      anon_sym_fn,
    ACTIONS(3946), 1,
      anon_sym_STAR,
    ACTIONS(3948), 1,
      anon_sym_struct,
    ACTIONS(3958), 1,
      anon_sym_shared,
    ACTIONS(3960), 1,
      anon_sym_map_LBRACK,
    ACTIONS(3962), 1,
      anon_sym_chan,
    ACTIONS(3964), 1,
      anon_sym_thread,
    ACTIONS(3966), 1,
      anon_sym_atomic,
    ACTIONS(6031), 1,
      anon_sym_QMARK,
    ACTIONS(6033), 1,
      anon_sym_BANG,
    ACTIONS(6035), 1,
      anon_sym_LBRACK2,
    ACTIONS(6037), 1,
      anon_sym_AMP,
    STATE(1685), 1,
      sym_plain_type,
    STATE(4423), 1,
      sym_reference_expression,
    STATE(1563), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3108), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1655), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1657), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [81112] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3406), 1,
      sym_identifier,
    ACTIONS(3410), 1,
      anon_sym_fn,
    ACTIONS(3414), 1,
      anon_sym_struct,
    ACTIONS(3424), 1,
      anon_sym_shared,
    ACTIONS(3428), 1,
      anon_sym_chan,
    ACTIONS(3430), 1,
      anon_sym_thread,
    ACTIONS(3432), 1,
      anon_sym_atomic,
    ACTIONS(6017), 1,
      anon_sym_LPAREN,
    ACTIONS(6019), 1,
      anon_sym_STAR,
    ACTIONS(6021), 1,
      anon_sym_QMARK,
    ACTIONS(6023), 1,
      anon_sym_BANG,
    ACTIONS(6025), 1,
      anon_sym_LBRACK2,
    ACTIONS(6027), 1,
      anon_sym_AMP,
    ACTIONS(6029), 1,
      anon_sym_map_LBRACK,
    STATE(1316), 1,
      sym_plain_type,
    STATE(4486), 1,
      sym_reference_expression,
    STATE(1298), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3109), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1327), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1324), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [81195] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4190), 1,
      sym_identifier,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_fn,
    ACTIONS(4198), 1,
      anon_sym_struct,
    ACTIONS(4208), 1,
      anon_sym_shared,
    ACTIONS(4210), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4212), 1,
      anon_sym_chan,
    ACTIONS(4214), 1,
      anon_sym_thread,
    ACTIONS(4216), 1,
      anon_sym_atomic,
    ACTIONS(6007), 1,
      anon_sym_STAR,
    ACTIONS(6009), 1,
      anon_sym_QMARK,
    ACTIONS(6011), 1,
      anon_sym_BANG,
    ACTIONS(6013), 1,
      anon_sym_LBRACK2,
    ACTIONS(6015), 1,
      anon_sym_AMP,
    STATE(2130), 1,
      sym_plain_type,
    STATE(4528), 1,
      sym_reference_expression,
    STATE(2017), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3110), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2110), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2111), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [81278] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4190), 1,
      sym_identifier,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_fn,
    ACTIONS(4198), 1,
      anon_sym_struct,
    ACTIONS(4208), 1,
      anon_sym_shared,
    ACTIONS(4210), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4212), 1,
      anon_sym_chan,
    ACTIONS(4214), 1,
      anon_sym_thread,
    ACTIONS(4216), 1,
      anon_sym_atomic,
    ACTIONS(6007), 1,
      anon_sym_STAR,
    ACTIONS(6009), 1,
      anon_sym_QMARK,
    ACTIONS(6011), 1,
      anon_sym_BANG,
    ACTIONS(6013), 1,
      anon_sym_LBRACK2,
    ACTIONS(6015), 1,
      anon_sym_AMP,
    STATE(2139), 1,
      sym_plain_type,
    STATE(4528), 1,
      sym_reference_expression,
    STATE(2017), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3111), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2110), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2111), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [81361] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4190), 1,
      sym_identifier,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_fn,
    ACTIONS(4198), 1,
      anon_sym_struct,
    ACTIONS(4208), 1,
      anon_sym_shared,
    ACTIONS(4210), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4212), 1,
      anon_sym_chan,
    ACTIONS(4214), 1,
      anon_sym_thread,
    ACTIONS(4216), 1,
      anon_sym_atomic,
    ACTIONS(6007), 1,
      anon_sym_STAR,
    ACTIONS(6009), 1,
      anon_sym_QMARK,
    ACTIONS(6011), 1,
      anon_sym_BANG,
    ACTIONS(6013), 1,
      anon_sym_LBRACK2,
    ACTIONS(6015), 1,
      anon_sym_AMP,
    STATE(2024), 1,
      sym_plain_type,
    STATE(4528), 1,
      sym_reference_expression,
    STATE(2017), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3112), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2110), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2111), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [81444] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3406), 1,
      sym_identifier,
    ACTIONS(3410), 1,
      anon_sym_fn,
    ACTIONS(3414), 1,
      anon_sym_struct,
    ACTIONS(3424), 1,
      anon_sym_shared,
    ACTIONS(3428), 1,
      anon_sym_chan,
    ACTIONS(3430), 1,
      anon_sym_thread,
    ACTIONS(3432), 1,
      anon_sym_atomic,
    ACTIONS(6017), 1,
      anon_sym_LPAREN,
    ACTIONS(6019), 1,
      anon_sym_STAR,
    ACTIONS(6021), 1,
      anon_sym_QMARK,
    ACTIONS(6023), 1,
      anon_sym_BANG,
    ACTIONS(6025), 1,
      anon_sym_LBRACK2,
    ACTIONS(6027), 1,
      anon_sym_AMP,
    ACTIONS(6029), 1,
      anon_sym_map_LBRACK,
    STATE(1359), 1,
      sym_plain_type,
    STATE(4486), 1,
      sym_reference_expression,
    STATE(1298), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3113), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1327), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1324), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [81527] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4022), 1,
      sym_identifier,
    ACTIONS(4026), 1,
      anon_sym_fn,
    ACTIONS(4030), 1,
      anon_sym_struct,
    ACTIONS(4040), 1,
      anon_sym_shared,
    ACTIONS(4044), 1,
      anon_sym_chan,
    ACTIONS(4046), 1,
      anon_sym_thread,
    ACTIONS(4048), 1,
      anon_sym_atomic,
    ACTIONS(5917), 1,
      anon_sym_LPAREN,
    ACTIONS(5919), 1,
      anon_sym_STAR,
    ACTIONS(5921), 1,
      anon_sym_QMARK,
    ACTIONS(5923), 1,
      anon_sym_BANG,
    ACTIONS(5925), 1,
      anon_sym_LBRACK2,
    ACTIONS(5927), 1,
      anon_sym_AMP,
    ACTIONS(5929), 1,
      anon_sym_map_LBRACK,
    STATE(1734), 1,
      sym_plain_type,
    STATE(4425), 1,
      sym_reference_expression,
    STATE(1699), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3114), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1719), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1721), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [81610] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(819), 1,
      sym_identifier,
    ACTIONS(825), 1,
      anon_sym_fn,
    ACTIONS(829), 1,
      anon_sym_struct,
    ACTIONS(839), 1,
      anon_sym_shared,
    ACTIONS(843), 1,
      anon_sym_chan,
    ACTIONS(845), 1,
      anon_sym_thread,
    ACTIONS(847), 1,
      anon_sym_atomic,
    ACTIONS(6039), 1,
      anon_sym_LPAREN,
    ACTIONS(6041), 1,
      anon_sym_STAR,
    ACTIONS(6043), 1,
      anon_sym_QMARK,
    ACTIONS(6045), 1,
      anon_sym_BANG,
    ACTIONS(6047), 1,
      anon_sym_LBRACK2,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_map_LBRACK,
    STATE(515), 1,
      sym_plain_type,
    STATE(4523), 1,
      sym_reference_expression,
    STATE(291), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3115), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(429), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(442), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [81693] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(4611), 1,
      sym_plain_type,
    STATE(3116), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [81776] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(4357), 1,
      sym_identifier,
    ACTIONS(4359), 1,
      anon_sym_fn,
    ACTIONS(4361), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_shared,
    ACTIONS(4373), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4375), 1,
      anon_sym_chan,
    ACTIONS(4377), 1,
      anon_sym_thread,
    ACTIONS(4379), 1,
      anon_sym_atomic,
    ACTIONS(6053), 1,
      anon_sym_QMARK,
    ACTIONS(6055), 1,
      anon_sym_BANG,
    ACTIONS(6057), 1,
      anon_sym_LBRACK2,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    STATE(2414), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2395), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3117), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [81859] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3940), 1,
      sym_identifier,
    ACTIONS(3942), 1,
      anon_sym_LPAREN,
    ACTIONS(3944), 1,
      anon_sym_fn,
    ACTIONS(3946), 1,
      anon_sym_STAR,
    ACTIONS(3948), 1,
      anon_sym_struct,
    ACTIONS(3958), 1,
      anon_sym_shared,
    ACTIONS(3960), 1,
      anon_sym_map_LBRACK,
    ACTIONS(3962), 1,
      anon_sym_chan,
    ACTIONS(3964), 1,
      anon_sym_thread,
    ACTIONS(3966), 1,
      anon_sym_atomic,
    ACTIONS(6031), 1,
      anon_sym_QMARK,
    ACTIONS(6033), 1,
      anon_sym_BANG,
    ACTIONS(6035), 1,
      anon_sym_LBRACK2,
    ACTIONS(6037), 1,
      anon_sym_AMP,
    STATE(1646), 1,
      sym_plain_type,
    STATE(4423), 1,
      sym_reference_expression,
    STATE(1563), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3118), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1655), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1657), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [81942] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3940), 1,
      sym_identifier,
    ACTIONS(3942), 1,
      anon_sym_LPAREN,
    ACTIONS(3944), 1,
      anon_sym_fn,
    ACTIONS(3946), 1,
      anon_sym_STAR,
    ACTIONS(3948), 1,
      anon_sym_struct,
    ACTIONS(3958), 1,
      anon_sym_shared,
    ACTIONS(3960), 1,
      anon_sym_map_LBRACK,
    ACTIONS(3962), 1,
      anon_sym_chan,
    ACTIONS(3964), 1,
      anon_sym_thread,
    ACTIONS(3966), 1,
      anon_sym_atomic,
    ACTIONS(6031), 1,
      anon_sym_QMARK,
    ACTIONS(6033), 1,
      anon_sym_BANG,
    ACTIONS(6035), 1,
      anon_sym_LBRACK2,
    ACTIONS(6037), 1,
      anon_sym_AMP,
    STATE(1648), 1,
      sym_plain_type,
    STATE(4423), 1,
      sym_reference_expression,
    STATE(1563), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3119), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1655), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1657), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [82025] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4072), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3120), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [82108] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(4357), 1,
      sym_identifier,
    ACTIONS(4359), 1,
      anon_sym_fn,
    ACTIONS(4361), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_shared,
    ACTIONS(4373), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4375), 1,
      anon_sym_chan,
    ACTIONS(4377), 1,
      anon_sym_thread,
    ACTIONS(4379), 1,
      anon_sym_atomic,
    ACTIONS(6053), 1,
      anon_sym_QMARK,
    ACTIONS(6055), 1,
      anon_sym_BANG,
    ACTIONS(6057), 1,
      anon_sym_LBRACK2,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    STATE(2413), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2395), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3121), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [82191] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4190), 1,
      sym_identifier,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_fn,
    ACTIONS(4198), 1,
      anon_sym_struct,
    ACTIONS(4208), 1,
      anon_sym_shared,
    ACTIONS(4210), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4212), 1,
      anon_sym_chan,
    ACTIONS(4214), 1,
      anon_sym_thread,
    ACTIONS(4216), 1,
      anon_sym_atomic,
    ACTIONS(6007), 1,
      anon_sym_STAR,
    ACTIONS(6009), 1,
      anon_sym_QMARK,
    ACTIONS(6011), 1,
      anon_sym_BANG,
    ACTIONS(6013), 1,
      anon_sym_LBRACK2,
    ACTIONS(6015), 1,
      anon_sym_AMP,
    STATE(2151), 1,
      sym_plain_type,
    STATE(4528), 1,
      sym_reference_expression,
    STATE(2017), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3122), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2110), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2111), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [82274] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(819), 1,
      sym_identifier,
    ACTIONS(825), 1,
      anon_sym_fn,
    ACTIONS(829), 1,
      anon_sym_struct,
    ACTIONS(839), 1,
      anon_sym_shared,
    ACTIONS(843), 1,
      anon_sym_chan,
    ACTIONS(845), 1,
      anon_sym_thread,
    ACTIONS(847), 1,
      anon_sym_atomic,
    ACTIONS(6039), 1,
      anon_sym_LPAREN,
    ACTIONS(6041), 1,
      anon_sym_STAR,
    ACTIONS(6043), 1,
      anon_sym_QMARK,
    ACTIONS(6045), 1,
      anon_sym_BANG,
    ACTIONS(6047), 1,
      anon_sym_LBRACK2,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_map_LBRACK,
    STATE(513), 1,
      sym_plain_type,
    STATE(4523), 1,
      sym_reference_expression,
    STATE(291), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3123), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(429), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(442), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [82357] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3940), 1,
      sym_identifier,
    ACTIONS(3942), 1,
      anon_sym_LPAREN,
    ACTIONS(3944), 1,
      anon_sym_fn,
    ACTIONS(3946), 1,
      anon_sym_STAR,
    ACTIONS(3948), 1,
      anon_sym_struct,
    ACTIONS(3958), 1,
      anon_sym_shared,
    ACTIONS(3960), 1,
      anon_sym_map_LBRACK,
    ACTIONS(3962), 1,
      anon_sym_chan,
    ACTIONS(3964), 1,
      anon_sym_thread,
    ACTIONS(3966), 1,
      anon_sym_atomic,
    ACTIONS(6031), 1,
      anon_sym_QMARK,
    ACTIONS(6033), 1,
      anon_sym_BANG,
    ACTIONS(6035), 1,
      anon_sym_LBRACK2,
    ACTIONS(6037), 1,
      anon_sym_AMP,
    STATE(1677), 1,
      sym_plain_type,
    STATE(4423), 1,
      sym_reference_expression,
    STATE(1563), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3124), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1655), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1657), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [82440] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3940), 1,
      sym_identifier,
    ACTIONS(3942), 1,
      anon_sym_LPAREN,
    ACTIONS(3944), 1,
      anon_sym_fn,
    ACTIONS(3946), 1,
      anon_sym_STAR,
    ACTIONS(3948), 1,
      anon_sym_struct,
    ACTIONS(3958), 1,
      anon_sym_shared,
    ACTIONS(3960), 1,
      anon_sym_map_LBRACK,
    ACTIONS(3962), 1,
      anon_sym_chan,
    ACTIONS(3964), 1,
      anon_sym_thread,
    ACTIONS(3966), 1,
      anon_sym_atomic,
    ACTIONS(6031), 1,
      anon_sym_QMARK,
    ACTIONS(6033), 1,
      anon_sym_BANG,
    ACTIONS(6035), 1,
      anon_sym_LBRACK2,
    ACTIONS(6037), 1,
      anon_sym_AMP,
    STATE(1678), 1,
      sym_plain_type,
    STATE(4423), 1,
      sym_reference_expression,
    STATE(1563), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3125), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1655), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1657), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [82523] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(819), 1,
      sym_identifier,
    ACTIONS(825), 1,
      anon_sym_fn,
    ACTIONS(829), 1,
      anon_sym_struct,
    ACTIONS(839), 1,
      anon_sym_shared,
    ACTIONS(843), 1,
      anon_sym_chan,
    ACTIONS(845), 1,
      anon_sym_thread,
    ACTIONS(847), 1,
      anon_sym_atomic,
    ACTIONS(6039), 1,
      anon_sym_LPAREN,
    ACTIONS(6041), 1,
      anon_sym_STAR,
    ACTIONS(6043), 1,
      anon_sym_QMARK,
    ACTIONS(6045), 1,
      anon_sym_BANG,
    ACTIONS(6047), 1,
      anon_sym_LBRACK2,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_map_LBRACK,
    STATE(501), 1,
      sym_plain_type,
    STATE(4523), 1,
      sym_reference_expression,
    STATE(291), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3126), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(429), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(442), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [82606] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3406), 1,
      sym_identifier,
    ACTIONS(3410), 1,
      anon_sym_fn,
    ACTIONS(3414), 1,
      anon_sym_struct,
    ACTIONS(3424), 1,
      anon_sym_shared,
    ACTIONS(3428), 1,
      anon_sym_chan,
    ACTIONS(3430), 1,
      anon_sym_thread,
    ACTIONS(3432), 1,
      anon_sym_atomic,
    ACTIONS(6017), 1,
      anon_sym_LPAREN,
    ACTIONS(6019), 1,
      anon_sym_STAR,
    ACTIONS(6021), 1,
      anon_sym_QMARK,
    ACTIONS(6023), 1,
      anon_sym_BANG,
    ACTIONS(6025), 1,
      anon_sym_LBRACK2,
    ACTIONS(6027), 1,
      anon_sym_AMP,
    ACTIONS(6029), 1,
      anon_sym_map_LBRACK,
    STATE(1306), 1,
      sym_plain_type,
    STATE(4486), 1,
      sym_reference_expression,
    STATE(1298), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3127), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1327), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1324), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [82689] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(3938), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3128), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [82772] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3406), 1,
      sym_identifier,
    ACTIONS(3410), 1,
      anon_sym_fn,
    ACTIONS(3414), 1,
      anon_sym_struct,
    ACTIONS(3424), 1,
      anon_sym_shared,
    ACTIONS(3428), 1,
      anon_sym_chan,
    ACTIONS(3430), 1,
      anon_sym_thread,
    ACTIONS(3432), 1,
      anon_sym_atomic,
    ACTIONS(6017), 1,
      anon_sym_LPAREN,
    ACTIONS(6019), 1,
      anon_sym_STAR,
    ACTIONS(6021), 1,
      anon_sym_QMARK,
    ACTIONS(6023), 1,
      anon_sym_BANG,
    ACTIONS(6025), 1,
      anon_sym_LBRACK2,
    ACTIONS(6027), 1,
      anon_sym_AMP,
    ACTIONS(6029), 1,
      anon_sym_map_LBRACK,
    STATE(1403), 1,
      sym_plain_type,
    STATE(4486), 1,
      sym_reference_expression,
    STATE(1298), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3129), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1327), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1324), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [82855] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4501), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3130), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [82938] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(3916), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3131), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [83021] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3406), 1,
      sym_identifier,
    ACTIONS(3410), 1,
      anon_sym_fn,
    ACTIONS(3414), 1,
      anon_sym_struct,
    ACTIONS(3424), 1,
      anon_sym_shared,
    ACTIONS(3428), 1,
      anon_sym_chan,
    ACTIONS(3430), 1,
      anon_sym_thread,
    ACTIONS(3432), 1,
      anon_sym_atomic,
    ACTIONS(6017), 1,
      anon_sym_LPAREN,
    ACTIONS(6019), 1,
      anon_sym_STAR,
    ACTIONS(6021), 1,
      anon_sym_QMARK,
    ACTIONS(6023), 1,
      anon_sym_BANG,
    ACTIONS(6025), 1,
      anon_sym_LBRACK2,
    ACTIONS(6027), 1,
      anon_sym_AMP,
    ACTIONS(6029), 1,
      anon_sym_map_LBRACK,
    STATE(1307), 1,
      sym_plain_type,
    STATE(4486), 1,
      sym_reference_expression,
    STATE(1298), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3132), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1327), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1324), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [83104] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4190), 1,
      sym_identifier,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_fn,
    ACTIONS(4198), 1,
      anon_sym_struct,
    ACTIONS(4208), 1,
      anon_sym_shared,
    ACTIONS(4210), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4212), 1,
      anon_sym_chan,
    ACTIONS(4214), 1,
      anon_sym_thread,
    ACTIONS(4216), 1,
      anon_sym_atomic,
    ACTIONS(6007), 1,
      anon_sym_STAR,
    ACTIONS(6009), 1,
      anon_sym_QMARK,
    ACTIONS(6011), 1,
      anon_sym_BANG,
    ACTIONS(6013), 1,
      anon_sym_LBRACK2,
    ACTIONS(6015), 1,
      anon_sym_AMP,
    STATE(2126), 1,
      sym_plain_type,
    STATE(4528), 1,
      sym_reference_expression,
    STATE(2017), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3133), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2110), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2111), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [83187] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3940), 1,
      sym_identifier,
    ACTIONS(3942), 1,
      anon_sym_LPAREN,
    ACTIONS(3944), 1,
      anon_sym_fn,
    ACTIONS(3946), 1,
      anon_sym_STAR,
    ACTIONS(3948), 1,
      anon_sym_struct,
    ACTIONS(3958), 1,
      anon_sym_shared,
    ACTIONS(3960), 1,
      anon_sym_map_LBRACK,
    ACTIONS(3962), 1,
      anon_sym_chan,
    ACTIONS(3964), 1,
      anon_sym_thread,
    ACTIONS(3966), 1,
      anon_sym_atomic,
    ACTIONS(6031), 1,
      anon_sym_QMARK,
    ACTIONS(6033), 1,
      anon_sym_BANG,
    ACTIONS(6035), 1,
      anon_sym_LBRACK2,
    ACTIONS(6037), 1,
      anon_sym_AMP,
    STATE(1679), 1,
      sym_plain_type,
    STATE(4423), 1,
      sym_reference_expression,
    STATE(1563), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3134), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1655), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1657), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [83270] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4022), 1,
      sym_identifier,
    ACTIONS(4026), 1,
      anon_sym_fn,
    ACTIONS(4030), 1,
      anon_sym_struct,
    ACTIONS(4040), 1,
      anon_sym_shared,
    ACTIONS(4044), 1,
      anon_sym_chan,
    ACTIONS(4046), 1,
      anon_sym_thread,
    ACTIONS(4048), 1,
      anon_sym_atomic,
    ACTIONS(5917), 1,
      anon_sym_LPAREN,
    ACTIONS(5919), 1,
      anon_sym_STAR,
    ACTIONS(5921), 1,
      anon_sym_QMARK,
    ACTIONS(5923), 1,
      anon_sym_BANG,
    ACTIONS(5925), 1,
      anon_sym_LBRACK2,
    ACTIONS(5927), 1,
      anon_sym_AMP,
    ACTIONS(5929), 1,
      anon_sym_map_LBRACK,
    STATE(1742), 1,
      sym_plain_type,
    STATE(4425), 1,
      sym_reference_expression,
    STATE(1699), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3135), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1719), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1721), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [83353] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4190), 1,
      sym_identifier,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_fn,
    ACTIONS(4198), 1,
      anon_sym_struct,
    ACTIONS(4208), 1,
      anon_sym_shared,
    ACTIONS(4210), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4212), 1,
      anon_sym_chan,
    ACTIONS(4214), 1,
      anon_sym_thread,
    ACTIONS(4216), 1,
      anon_sym_atomic,
    ACTIONS(6007), 1,
      anon_sym_STAR,
    ACTIONS(6009), 1,
      anon_sym_QMARK,
    ACTIONS(6011), 1,
      anon_sym_BANG,
    ACTIONS(6013), 1,
      anon_sym_LBRACK2,
    ACTIONS(6015), 1,
      anon_sym_AMP,
    STATE(2152), 1,
      sym_plain_type,
    STATE(4528), 1,
      sym_reference_expression,
    STATE(2017), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3136), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2110), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2111), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [83436] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4022), 1,
      sym_identifier,
    ACTIONS(4026), 1,
      anon_sym_fn,
    ACTIONS(4030), 1,
      anon_sym_struct,
    ACTIONS(4040), 1,
      anon_sym_shared,
    ACTIONS(4044), 1,
      anon_sym_chan,
    ACTIONS(4046), 1,
      anon_sym_thread,
    ACTIONS(4048), 1,
      anon_sym_atomic,
    ACTIONS(5917), 1,
      anon_sym_LPAREN,
    ACTIONS(5919), 1,
      anon_sym_STAR,
    ACTIONS(5921), 1,
      anon_sym_QMARK,
    ACTIONS(5923), 1,
      anon_sym_BANG,
    ACTIONS(5925), 1,
      anon_sym_LBRACK2,
    ACTIONS(5927), 1,
      anon_sym_AMP,
    ACTIONS(5929), 1,
      anon_sym_map_LBRACK,
    STATE(1743), 1,
      sym_plain_type,
    STATE(4425), 1,
      sym_reference_expression,
    STATE(1699), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3137), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1719), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1721), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [83519] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4022), 1,
      sym_identifier,
    ACTIONS(4026), 1,
      anon_sym_fn,
    ACTIONS(4030), 1,
      anon_sym_struct,
    ACTIONS(4040), 1,
      anon_sym_shared,
    ACTIONS(4044), 1,
      anon_sym_chan,
    ACTIONS(4046), 1,
      anon_sym_thread,
    ACTIONS(4048), 1,
      anon_sym_atomic,
    ACTIONS(5917), 1,
      anon_sym_LPAREN,
    ACTIONS(5919), 1,
      anon_sym_STAR,
    ACTIONS(5921), 1,
      anon_sym_QMARK,
    ACTIONS(5923), 1,
      anon_sym_BANG,
    ACTIONS(5925), 1,
      anon_sym_LBRACK2,
    ACTIONS(5927), 1,
      anon_sym_AMP,
    ACTIONS(5929), 1,
      anon_sym_map_LBRACK,
    STATE(1712), 1,
      sym_plain_type,
    STATE(4425), 1,
      sym_reference_expression,
    STATE(1699), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3138), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1719), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1721), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [83602] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(2495), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3139), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [83685] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(4357), 1,
      sym_identifier,
    ACTIONS(4359), 1,
      anon_sym_fn,
    ACTIONS(4361), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_shared,
    ACTIONS(4373), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4375), 1,
      anon_sym_chan,
    ACTIONS(4377), 1,
      anon_sym_thread,
    ACTIONS(4379), 1,
      anon_sym_atomic,
    ACTIONS(6053), 1,
      anon_sym_QMARK,
    ACTIONS(6055), 1,
      anon_sym_BANG,
    ACTIONS(6057), 1,
      anon_sym_LBRACK2,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    STATE(2490), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2395), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3140), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [83768] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1015), 1,
      sym_identifier,
    ACTIONS(1019), 1,
      anon_sym_fn,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(1033), 1,
      anon_sym_shared,
    ACTIONS(1037), 1,
      anon_sym_chan,
    ACTIONS(1039), 1,
      anon_sym_thread,
    ACTIONS(1041), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(6061), 1,
      anon_sym_STAR,
    ACTIONS(6063), 1,
      anon_sym_QMARK,
    ACTIONS(6065), 1,
      anon_sym_BANG,
    ACTIONS(6067), 1,
      anon_sym_LBRACK2,
    ACTIONS(6069), 1,
      anon_sym_AMP,
    ACTIONS(6071), 1,
      anon_sym_map_LBRACK,
    STATE(1063), 1,
      sym_plain_type,
    STATE(4500), 1,
      sym_reference_expression,
    STATE(1003), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3141), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [83851] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4150), 1,
      sym_identifier,
    ACTIONS(4152), 1,
      anon_sym_LPAREN,
    ACTIONS(4154), 1,
      anon_sym_fn,
    ACTIONS(4158), 1,
      anon_sym_struct,
    ACTIONS(4168), 1,
      anon_sym_shared,
    ACTIONS(4170), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4172), 1,
      anon_sym_chan,
    ACTIONS(4174), 1,
      anon_sym_thread,
    ACTIONS(4176), 1,
      anon_sym_atomic,
    ACTIONS(6073), 1,
      anon_sym_STAR,
    ACTIONS(6075), 1,
      anon_sym_QMARK,
    ACTIONS(6077), 1,
      anon_sym_BANG,
    ACTIONS(6079), 1,
      anon_sym_LBRACK2,
    ACTIONS(6081), 1,
      anon_sym_AMP,
    STATE(2035), 1,
      sym_plain_type,
    STATE(4465), 1,
      sym_reference_expression,
    STATE(2019), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3142), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2052), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2051), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [83934] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(2493), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3143), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [84017] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4514), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3144), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [84100] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(819), 1,
      sym_identifier,
    ACTIONS(825), 1,
      anon_sym_fn,
    ACTIONS(829), 1,
      anon_sym_struct,
    ACTIONS(839), 1,
      anon_sym_shared,
    ACTIONS(843), 1,
      anon_sym_chan,
    ACTIONS(845), 1,
      anon_sym_thread,
    ACTIONS(847), 1,
      anon_sym_atomic,
    ACTIONS(6039), 1,
      anon_sym_LPAREN,
    ACTIONS(6041), 1,
      anon_sym_STAR,
    ACTIONS(6043), 1,
      anon_sym_QMARK,
    ACTIONS(6045), 1,
      anon_sym_BANG,
    ACTIONS(6047), 1,
      anon_sym_LBRACK2,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_map_LBRACK,
    STATE(512), 1,
      sym_plain_type,
    STATE(4523), 1,
      sym_reference_expression,
    STATE(291), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3145), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(429), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(442), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [84183] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4190), 1,
      sym_identifier,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_fn,
    ACTIONS(4198), 1,
      anon_sym_struct,
    ACTIONS(4208), 1,
      anon_sym_shared,
    ACTIONS(4210), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4212), 1,
      anon_sym_chan,
    ACTIONS(4214), 1,
      anon_sym_thread,
    ACTIONS(4216), 1,
      anon_sym_atomic,
    ACTIONS(6007), 1,
      anon_sym_STAR,
    ACTIONS(6009), 1,
      anon_sym_QMARK,
    ACTIONS(6011), 1,
      anon_sym_BANG,
    ACTIONS(6013), 1,
      anon_sym_LBRACK2,
    ACTIONS(6015), 1,
      anon_sym_AMP,
    STATE(2172), 1,
      sym_plain_type,
    STATE(4528), 1,
      sym_reference_expression,
    STATE(2017), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3146), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2110), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2111), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [84266] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(819), 1,
      sym_identifier,
    ACTIONS(825), 1,
      anon_sym_fn,
    ACTIONS(829), 1,
      anon_sym_struct,
    ACTIONS(839), 1,
      anon_sym_shared,
    ACTIONS(843), 1,
      anon_sym_chan,
    ACTIONS(845), 1,
      anon_sym_thread,
    ACTIONS(847), 1,
      anon_sym_atomic,
    ACTIONS(6039), 1,
      anon_sym_LPAREN,
    ACTIONS(6041), 1,
      anon_sym_STAR,
    ACTIONS(6043), 1,
      anon_sym_QMARK,
    ACTIONS(6045), 1,
      anon_sym_BANG,
    ACTIONS(6047), 1,
      anon_sym_LBRACK2,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_map_LBRACK,
    STATE(470), 1,
      sym_plain_type,
    STATE(4523), 1,
      sym_reference_expression,
    STATE(291), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3147), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(429), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(442), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [84349] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(4680), 1,
      sym_plain_type,
    STATE(3148), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [84432] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4261), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3149), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [84515] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3940), 1,
      sym_identifier,
    ACTIONS(3942), 1,
      anon_sym_LPAREN,
    ACTIONS(3944), 1,
      anon_sym_fn,
    ACTIONS(3946), 1,
      anon_sym_STAR,
    ACTIONS(3948), 1,
      anon_sym_struct,
    ACTIONS(3958), 1,
      anon_sym_shared,
    ACTIONS(3960), 1,
      anon_sym_map_LBRACK,
    ACTIONS(3962), 1,
      anon_sym_chan,
    ACTIONS(3964), 1,
      anon_sym_thread,
    ACTIONS(3966), 1,
      anon_sym_atomic,
    ACTIONS(6031), 1,
      anon_sym_QMARK,
    ACTIONS(6033), 1,
      anon_sym_BANG,
    ACTIONS(6035), 1,
      anon_sym_LBRACK2,
    ACTIONS(6037), 1,
      anon_sym_AMP,
    STATE(1625), 1,
      sym_plain_type,
    STATE(4423), 1,
      sym_reference_expression,
    STATE(1563), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3150), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1655), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1657), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [84598] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4022), 1,
      sym_identifier,
    ACTIONS(4026), 1,
      anon_sym_fn,
    ACTIONS(4030), 1,
      anon_sym_struct,
    ACTIONS(4040), 1,
      anon_sym_shared,
    ACTIONS(4044), 1,
      anon_sym_chan,
    ACTIONS(4046), 1,
      anon_sym_thread,
    ACTIONS(4048), 1,
      anon_sym_atomic,
    ACTIONS(5917), 1,
      anon_sym_LPAREN,
    ACTIONS(5919), 1,
      anon_sym_STAR,
    ACTIONS(5921), 1,
      anon_sym_QMARK,
    ACTIONS(5923), 1,
      anon_sym_BANG,
    ACTIONS(5925), 1,
      anon_sym_LBRACK2,
    ACTIONS(5927), 1,
      anon_sym_AMP,
    ACTIONS(5929), 1,
      anon_sym_map_LBRACK,
    STATE(1727), 1,
      sym_plain_type,
    STATE(4425), 1,
      sym_reference_expression,
    STATE(1699), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3151), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1719), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1721), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [84681] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4022), 1,
      sym_identifier,
    ACTIONS(4026), 1,
      anon_sym_fn,
    ACTIONS(4030), 1,
      anon_sym_struct,
    ACTIONS(4040), 1,
      anon_sym_shared,
    ACTIONS(4044), 1,
      anon_sym_chan,
    ACTIONS(4046), 1,
      anon_sym_thread,
    ACTIONS(4048), 1,
      anon_sym_atomic,
    ACTIONS(5917), 1,
      anon_sym_LPAREN,
    ACTIONS(5919), 1,
      anon_sym_STAR,
    ACTIONS(5921), 1,
      anon_sym_QMARK,
    ACTIONS(5923), 1,
      anon_sym_BANG,
    ACTIONS(5925), 1,
      anon_sym_LBRACK2,
    ACTIONS(5927), 1,
      anon_sym_AMP,
    ACTIONS(5929), 1,
      anon_sym_map_LBRACK,
    STATE(1744), 1,
      sym_plain_type,
    STATE(4425), 1,
      sym_reference_expression,
    STATE(1699), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3152), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1719), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1721), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [84764] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4022), 1,
      sym_identifier,
    ACTIONS(4026), 1,
      anon_sym_fn,
    ACTIONS(4030), 1,
      anon_sym_struct,
    ACTIONS(4040), 1,
      anon_sym_shared,
    ACTIONS(4044), 1,
      anon_sym_chan,
    ACTIONS(4046), 1,
      anon_sym_thread,
    ACTIONS(4048), 1,
      anon_sym_atomic,
    ACTIONS(5917), 1,
      anon_sym_LPAREN,
    ACTIONS(5919), 1,
      anon_sym_STAR,
    ACTIONS(5921), 1,
      anon_sym_QMARK,
    ACTIONS(5923), 1,
      anon_sym_BANG,
    ACTIONS(5925), 1,
      anon_sym_LBRACK2,
    ACTIONS(5927), 1,
      anon_sym_AMP,
    ACTIONS(5929), 1,
      anon_sym_map_LBRACK,
    STATE(1748), 1,
      sym_plain_type,
    STATE(4425), 1,
      sym_reference_expression,
    STATE(1699), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3153), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1719), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1721), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [84847] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(819), 1,
      sym_identifier,
    ACTIONS(825), 1,
      anon_sym_fn,
    ACTIONS(829), 1,
      anon_sym_struct,
    ACTIONS(839), 1,
      anon_sym_shared,
    ACTIONS(843), 1,
      anon_sym_chan,
    ACTIONS(845), 1,
      anon_sym_thread,
    ACTIONS(847), 1,
      anon_sym_atomic,
    ACTIONS(6039), 1,
      anon_sym_LPAREN,
    ACTIONS(6041), 1,
      anon_sym_STAR,
    ACTIONS(6043), 1,
      anon_sym_QMARK,
    ACTIONS(6045), 1,
      anon_sym_BANG,
    ACTIONS(6047), 1,
      anon_sym_LBRACK2,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_map_LBRACK,
    STATE(469), 1,
      sym_plain_type,
    STATE(4523), 1,
      sym_reference_expression,
    STATE(291), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3154), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(429), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(442), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [84930] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4022), 1,
      sym_identifier,
    ACTIONS(4026), 1,
      anon_sym_fn,
    ACTIONS(4030), 1,
      anon_sym_struct,
    ACTIONS(4040), 1,
      anon_sym_shared,
    ACTIONS(4044), 1,
      anon_sym_chan,
    ACTIONS(4046), 1,
      anon_sym_thread,
    ACTIONS(4048), 1,
      anon_sym_atomic,
    ACTIONS(5917), 1,
      anon_sym_LPAREN,
    ACTIONS(5919), 1,
      anon_sym_STAR,
    ACTIONS(5921), 1,
      anon_sym_QMARK,
    ACTIONS(5923), 1,
      anon_sym_BANG,
    ACTIONS(5925), 1,
      anon_sym_LBRACK2,
    ACTIONS(5927), 1,
      anon_sym_AMP,
    ACTIONS(5929), 1,
      anon_sym_map_LBRACK,
    STATE(1735), 1,
      sym_plain_type,
    STATE(4425), 1,
      sym_reference_expression,
    STATE(1699), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3155), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1719), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1721), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [85013] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4022), 1,
      sym_identifier,
    ACTIONS(4026), 1,
      anon_sym_fn,
    ACTIONS(4030), 1,
      anon_sym_struct,
    ACTIONS(4040), 1,
      anon_sym_shared,
    ACTIONS(4044), 1,
      anon_sym_chan,
    ACTIONS(4046), 1,
      anon_sym_thread,
    ACTIONS(4048), 1,
      anon_sym_atomic,
    ACTIONS(5917), 1,
      anon_sym_LPAREN,
    ACTIONS(5919), 1,
      anon_sym_STAR,
    ACTIONS(5921), 1,
      anon_sym_QMARK,
    ACTIONS(5923), 1,
      anon_sym_BANG,
    ACTIONS(5925), 1,
      anon_sym_LBRACK2,
    ACTIONS(5927), 1,
      anon_sym_AMP,
    ACTIONS(5929), 1,
      anon_sym_map_LBRACK,
    STATE(1732), 1,
      sym_plain_type,
    STATE(4425), 1,
      sym_reference_expression,
    STATE(1699), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3156), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1719), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1721), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [85096] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(4695), 1,
      sym_plain_type,
    STATE(3157), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [85179] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4022), 1,
      sym_identifier,
    ACTIONS(4026), 1,
      anon_sym_fn,
    ACTIONS(4030), 1,
      anon_sym_struct,
    ACTIONS(4040), 1,
      anon_sym_shared,
    ACTIONS(4044), 1,
      anon_sym_chan,
    ACTIONS(4046), 1,
      anon_sym_thread,
    ACTIONS(4048), 1,
      anon_sym_atomic,
    ACTIONS(5917), 1,
      anon_sym_LPAREN,
    ACTIONS(5919), 1,
      anon_sym_STAR,
    ACTIONS(5921), 1,
      anon_sym_QMARK,
    ACTIONS(5923), 1,
      anon_sym_BANG,
    ACTIONS(5925), 1,
      anon_sym_LBRACK2,
    ACTIONS(5927), 1,
      anon_sym_AMP,
    ACTIONS(5929), 1,
      anon_sym_map_LBRACK,
    STATE(1728), 1,
      sym_plain_type,
    STATE(4425), 1,
      sym_reference_expression,
    STATE(1699), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3158), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1719), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1721), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [85262] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(819), 1,
      sym_identifier,
    ACTIONS(825), 1,
      anon_sym_fn,
    ACTIONS(829), 1,
      anon_sym_struct,
    ACTIONS(839), 1,
      anon_sym_shared,
    ACTIONS(843), 1,
      anon_sym_chan,
    ACTIONS(845), 1,
      anon_sym_thread,
    ACTIONS(847), 1,
      anon_sym_atomic,
    ACTIONS(6039), 1,
      anon_sym_LPAREN,
    ACTIONS(6041), 1,
      anon_sym_STAR,
    ACTIONS(6043), 1,
      anon_sym_QMARK,
    ACTIONS(6045), 1,
      anon_sym_BANG,
    ACTIONS(6047), 1,
      anon_sym_LBRACK2,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_map_LBRACK,
    STATE(511), 1,
      sym_plain_type,
    STATE(4523), 1,
      sym_reference_expression,
    STATE(291), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3159), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(429), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(442), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [85345] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1015), 1,
      sym_identifier,
    ACTIONS(1019), 1,
      anon_sym_fn,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(1033), 1,
      anon_sym_shared,
    ACTIONS(1037), 1,
      anon_sym_chan,
    ACTIONS(1039), 1,
      anon_sym_thread,
    ACTIONS(1041), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(6061), 1,
      anon_sym_STAR,
    ACTIONS(6063), 1,
      anon_sym_QMARK,
    ACTIONS(6065), 1,
      anon_sym_BANG,
    ACTIONS(6067), 1,
      anon_sym_LBRACK2,
    ACTIONS(6069), 1,
      anon_sym_AMP,
    ACTIONS(6071), 1,
      anon_sym_map_LBRACK,
    STATE(1075), 1,
      sym_plain_type,
    STATE(4500), 1,
      sym_reference_expression,
    STATE(1003), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3160), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [85428] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4075), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3161), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [85511] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(3951), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3162), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [85594] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4190), 1,
      sym_identifier,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_fn,
    ACTIONS(4198), 1,
      anon_sym_struct,
    ACTIONS(4208), 1,
      anon_sym_shared,
    ACTIONS(4210), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4212), 1,
      anon_sym_chan,
    ACTIONS(4214), 1,
      anon_sym_thread,
    ACTIONS(4216), 1,
      anon_sym_atomic,
    ACTIONS(6007), 1,
      anon_sym_STAR,
    ACTIONS(6009), 1,
      anon_sym_QMARK,
    ACTIONS(6011), 1,
      anon_sym_BANG,
    ACTIONS(6013), 1,
      anon_sym_LBRACK2,
    ACTIONS(6015), 1,
      anon_sym_AMP,
    STATE(2175), 1,
      sym_plain_type,
    STATE(4528), 1,
      sym_reference_expression,
    STATE(2017), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3163), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2110), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2111), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [85677] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3836), 1,
      anon_sym_fn,
    ACTIONS(3840), 1,
      anon_sym_struct,
    ACTIONS(3850), 1,
      anon_sym_shared,
    ACTIONS(3854), 1,
      anon_sym_chan,
    ACTIONS(3856), 1,
      anon_sym_thread,
    ACTIONS(3858), 1,
      anon_sym_atomic,
    ACTIONS(6083), 1,
      anon_sym_LPAREN,
    ACTIONS(6085), 1,
      anon_sym_STAR,
    ACTIONS(6087), 1,
      anon_sym_QMARK,
    ACTIONS(6089), 1,
      anon_sym_BANG,
    ACTIONS(6091), 1,
      anon_sym_LBRACK2,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_map_LBRACK,
    STATE(1535), 1,
      sym_plain_type,
    STATE(4507), 1,
      sym_reference_expression,
    STATE(1426), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3164), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1528), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1529), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [85760] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(2485), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3165), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [85843] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3406), 1,
      sym_identifier,
    ACTIONS(3410), 1,
      anon_sym_fn,
    ACTIONS(3414), 1,
      anon_sym_struct,
    ACTIONS(3424), 1,
      anon_sym_shared,
    ACTIONS(3428), 1,
      anon_sym_chan,
    ACTIONS(3430), 1,
      anon_sym_thread,
    ACTIONS(3432), 1,
      anon_sym_atomic,
    ACTIONS(6017), 1,
      anon_sym_LPAREN,
    ACTIONS(6019), 1,
      anon_sym_STAR,
    ACTIONS(6021), 1,
      anon_sym_QMARK,
    ACTIONS(6023), 1,
      anon_sym_BANG,
    ACTIONS(6025), 1,
      anon_sym_LBRACK2,
    ACTIONS(6027), 1,
      anon_sym_AMP,
    ACTIONS(6029), 1,
      anon_sym_map_LBRACK,
    STATE(1353), 1,
      sym_plain_type,
    STATE(4486), 1,
      sym_reference_expression,
    STATE(1298), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3166), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1327), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1324), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [85926] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4325), 1,
      sym_identifier,
    ACTIONS(4329), 1,
      anon_sym_fn,
    ACTIONS(4333), 1,
      anon_sym_struct,
    ACTIONS(4343), 1,
      anon_sym_shared,
    ACTIONS(4347), 1,
      anon_sym_chan,
    ACTIONS(4349), 1,
      anon_sym_thread,
    ACTIONS(4351), 1,
      anon_sym_atomic,
    ACTIONS(6097), 1,
      anon_sym_LPAREN,
    ACTIONS(6099), 1,
      anon_sym_STAR,
    ACTIONS(6101), 1,
      anon_sym_QMARK,
    ACTIONS(6103), 1,
      anon_sym_BANG,
    ACTIONS(6105), 1,
      anon_sym_LBRACK2,
    ACTIONS(6107), 1,
      anon_sym_AMP,
    ACTIONS(6109), 1,
      anon_sym_map_LBRACK,
    STATE(2348), 1,
      sym_plain_type,
    STATE(4545), 1,
      sym_reference_expression,
    STATE(2244), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3167), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2366), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2365), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [86009] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3406), 1,
      sym_identifier,
    ACTIONS(3410), 1,
      anon_sym_fn,
    ACTIONS(3414), 1,
      anon_sym_struct,
    ACTIONS(3424), 1,
      anon_sym_shared,
    ACTIONS(3428), 1,
      anon_sym_chan,
    ACTIONS(3430), 1,
      anon_sym_thread,
    ACTIONS(3432), 1,
      anon_sym_atomic,
    ACTIONS(6017), 1,
      anon_sym_LPAREN,
    ACTIONS(6019), 1,
      anon_sym_STAR,
    ACTIONS(6021), 1,
      anon_sym_QMARK,
    ACTIONS(6023), 1,
      anon_sym_BANG,
    ACTIONS(6025), 1,
      anon_sym_LBRACK2,
    ACTIONS(6027), 1,
      anon_sym_AMP,
    ACTIONS(6029), 1,
      anon_sym_map_LBRACK,
    STATE(1394), 1,
      sym_plain_type,
    STATE(4486), 1,
      sym_reference_expression,
    STATE(1298), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3168), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1327), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1324), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [86092] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(819), 1,
      sym_identifier,
    ACTIONS(825), 1,
      anon_sym_fn,
    ACTIONS(829), 1,
      anon_sym_struct,
    ACTIONS(839), 1,
      anon_sym_shared,
    ACTIONS(843), 1,
      anon_sym_chan,
    ACTIONS(845), 1,
      anon_sym_thread,
    ACTIONS(847), 1,
      anon_sym_atomic,
    ACTIONS(6039), 1,
      anon_sym_LPAREN,
    ACTIONS(6041), 1,
      anon_sym_STAR,
    ACTIONS(6043), 1,
      anon_sym_QMARK,
    ACTIONS(6045), 1,
      anon_sym_BANG,
    ACTIONS(6047), 1,
      anon_sym_LBRACK2,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_map_LBRACK,
    STATE(510), 1,
      sym_plain_type,
    STATE(4523), 1,
      sym_reference_expression,
    STATE(291), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3169), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(429), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(442), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [86175] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4150), 1,
      sym_identifier,
    ACTIONS(4152), 1,
      anon_sym_LPAREN,
    ACTIONS(4154), 1,
      anon_sym_fn,
    ACTIONS(4158), 1,
      anon_sym_struct,
    ACTIONS(4168), 1,
      anon_sym_shared,
    ACTIONS(4170), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4172), 1,
      anon_sym_chan,
    ACTIONS(4174), 1,
      anon_sym_thread,
    ACTIONS(4176), 1,
      anon_sym_atomic,
    ACTIONS(6073), 1,
      anon_sym_STAR,
    ACTIONS(6075), 1,
      anon_sym_QMARK,
    ACTIONS(6077), 1,
      anon_sym_BANG,
    ACTIONS(6079), 1,
      anon_sym_LBRACK2,
    ACTIONS(6081), 1,
      anon_sym_AMP,
    STATE(2071), 1,
      sym_plain_type,
    STATE(4465), 1,
      sym_reference_expression,
    STATE(2019), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3170), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2052), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2051), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [86258] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4429), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3171), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [86341] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(819), 1,
      sym_identifier,
    ACTIONS(825), 1,
      anon_sym_fn,
    ACTIONS(829), 1,
      anon_sym_struct,
    ACTIONS(839), 1,
      anon_sym_shared,
    ACTIONS(843), 1,
      anon_sym_chan,
    ACTIONS(845), 1,
      anon_sym_thread,
    ACTIONS(847), 1,
      anon_sym_atomic,
    ACTIONS(6039), 1,
      anon_sym_LPAREN,
    ACTIONS(6041), 1,
      anon_sym_STAR,
    ACTIONS(6043), 1,
      anon_sym_QMARK,
    ACTIONS(6045), 1,
      anon_sym_BANG,
    ACTIONS(6047), 1,
      anon_sym_LBRACK2,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_map_LBRACK,
    STATE(502), 1,
      sym_plain_type,
    STATE(4523), 1,
      sym_reference_expression,
    STATE(291), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3172), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(429), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(442), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [86424] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3836), 1,
      anon_sym_fn,
    ACTIONS(3840), 1,
      anon_sym_struct,
    ACTIONS(3850), 1,
      anon_sym_shared,
    ACTIONS(3854), 1,
      anon_sym_chan,
    ACTIONS(3856), 1,
      anon_sym_thread,
    ACTIONS(3858), 1,
      anon_sym_atomic,
    ACTIONS(6083), 1,
      anon_sym_LPAREN,
    ACTIONS(6085), 1,
      anon_sym_STAR,
    ACTIONS(6087), 1,
      anon_sym_QMARK,
    ACTIONS(6089), 1,
      anon_sym_BANG,
    ACTIONS(6091), 1,
      anon_sym_LBRACK2,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_map_LBRACK,
    STATE(1540), 1,
      sym_plain_type,
    STATE(4507), 1,
      sym_reference_expression,
    STATE(1426), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3173), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1528), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1529), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [86507] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(3963), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3174), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [86590] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4150), 1,
      sym_identifier,
    ACTIONS(4152), 1,
      anon_sym_LPAREN,
    ACTIONS(4154), 1,
      anon_sym_fn,
    ACTIONS(4158), 1,
      anon_sym_struct,
    ACTIONS(4168), 1,
      anon_sym_shared,
    ACTIONS(4170), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4172), 1,
      anon_sym_chan,
    ACTIONS(4174), 1,
      anon_sym_thread,
    ACTIONS(4176), 1,
      anon_sym_atomic,
    ACTIONS(6073), 1,
      anon_sym_STAR,
    ACTIONS(6075), 1,
      anon_sym_QMARK,
    ACTIONS(6077), 1,
      anon_sym_BANG,
    ACTIONS(6079), 1,
      anon_sym_LBRACK2,
    ACTIONS(6081), 1,
      anon_sym_AMP,
    STATE(2090), 1,
      sym_plain_type,
    STATE(4465), 1,
      sym_reference_expression,
    STATE(2019), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3175), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2052), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2051), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [86673] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4325), 1,
      sym_identifier,
    ACTIONS(4329), 1,
      anon_sym_fn,
    ACTIONS(4333), 1,
      anon_sym_struct,
    ACTIONS(4343), 1,
      anon_sym_shared,
    ACTIONS(4347), 1,
      anon_sym_chan,
    ACTIONS(4349), 1,
      anon_sym_thread,
    ACTIONS(4351), 1,
      anon_sym_atomic,
    ACTIONS(6097), 1,
      anon_sym_LPAREN,
    ACTIONS(6099), 1,
      anon_sym_STAR,
    ACTIONS(6101), 1,
      anon_sym_QMARK,
    ACTIONS(6103), 1,
      anon_sym_BANG,
    ACTIONS(6105), 1,
      anon_sym_LBRACK2,
    ACTIONS(6107), 1,
      anon_sym_AMP,
    ACTIONS(6109), 1,
      anon_sym_map_LBRACK,
    STATE(2347), 1,
      sym_plain_type,
    STATE(4545), 1,
      sym_reference_expression,
    STATE(2244), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3176), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2366), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2365), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [86756] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4150), 1,
      sym_identifier,
    ACTIONS(4152), 1,
      anon_sym_LPAREN,
    ACTIONS(4154), 1,
      anon_sym_fn,
    ACTIONS(4158), 1,
      anon_sym_struct,
    ACTIONS(4168), 1,
      anon_sym_shared,
    ACTIONS(4170), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4172), 1,
      anon_sym_chan,
    ACTIONS(4174), 1,
      anon_sym_thread,
    ACTIONS(4176), 1,
      anon_sym_atomic,
    ACTIONS(6073), 1,
      anon_sym_STAR,
    ACTIONS(6075), 1,
      anon_sym_QMARK,
    ACTIONS(6077), 1,
      anon_sym_BANG,
    ACTIONS(6079), 1,
      anon_sym_LBRACK2,
    ACTIONS(6081), 1,
      anon_sym_AMP,
    STATE(2084), 1,
      sym_plain_type,
    STATE(4465), 1,
      sym_reference_expression,
    STATE(2019), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3177), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2052), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2051), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [86839] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4325), 1,
      sym_identifier,
    ACTIONS(4329), 1,
      anon_sym_fn,
    ACTIONS(4333), 1,
      anon_sym_struct,
    ACTIONS(4343), 1,
      anon_sym_shared,
    ACTIONS(4347), 1,
      anon_sym_chan,
    ACTIONS(4349), 1,
      anon_sym_thread,
    ACTIONS(4351), 1,
      anon_sym_atomic,
    ACTIONS(6097), 1,
      anon_sym_LPAREN,
    ACTIONS(6099), 1,
      anon_sym_STAR,
    ACTIONS(6101), 1,
      anon_sym_QMARK,
    ACTIONS(6103), 1,
      anon_sym_BANG,
    ACTIONS(6105), 1,
      anon_sym_LBRACK2,
    ACTIONS(6107), 1,
      anon_sym_AMP,
    ACTIONS(6109), 1,
      anon_sym_map_LBRACK,
    STATE(2346), 1,
      sym_plain_type,
    STATE(4545), 1,
      sym_reference_expression,
    STATE(2244), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3178), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2366), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2365), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [86922] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(3992), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3179), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [87005] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4022), 1,
      sym_identifier,
    ACTIONS(4026), 1,
      anon_sym_fn,
    ACTIONS(4030), 1,
      anon_sym_struct,
    ACTIONS(4040), 1,
      anon_sym_shared,
    ACTIONS(4044), 1,
      anon_sym_chan,
    ACTIONS(4046), 1,
      anon_sym_thread,
    ACTIONS(4048), 1,
      anon_sym_atomic,
    ACTIONS(5917), 1,
      anon_sym_LPAREN,
    ACTIONS(5919), 1,
      anon_sym_STAR,
    ACTIONS(5921), 1,
      anon_sym_QMARK,
    ACTIONS(5923), 1,
      anon_sym_BANG,
    ACTIONS(5925), 1,
      anon_sym_LBRACK2,
    ACTIONS(5927), 1,
      anon_sym_AMP,
    ACTIONS(5929), 1,
      anon_sym_map_LBRACK,
    STATE(1736), 1,
      sym_plain_type,
    STATE(4425), 1,
      sym_reference_expression,
    STATE(1699), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3180), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1719), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1721), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [87088] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(819), 1,
      sym_identifier,
    ACTIONS(825), 1,
      anon_sym_fn,
    ACTIONS(829), 1,
      anon_sym_struct,
    ACTIONS(839), 1,
      anon_sym_shared,
    ACTIONS(843), 1,
      anon_sym_chan,
    ACTIONS(845), 1,
      anon_sym_thread,
    ACTIONS(847), 1,
      anon_sym_atomic,
    ACTIONS(6039), 1,
      anon_sym_LPAREN,
    ACTIONS(6041), 1,
      anon_sym_STAR,
    ACTIONS(6043), 1,
      anon_sym_QMARK,
    ACTIONS(6045), 1,
      anon_sym_BANG,
    ACTIONS(6047), 1,
      anon_sym_LBRACK2,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_map_LBRACK,
    STATE(480), 1,
      sym_plain_type,
    STATE(4523), 1,
      sym_reference_expression,
    STATE(291), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3181), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(429), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(442), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [87171] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3940), 1,
      sym_identifier,
    ACTIONS(3942), 1,
      anon_sym_LPAREN,
    ACTIONS(3944), 1,
      anon_sym_fn,
    ACTIONS(3946), 1,
      anon_sym_STAR,
    ACTIONS(3948), 1,
      anon_sym_struct,
    ACTIONS(3958), 1,
      anon_sym_shared,
    ACTIONS(3960), 1,
      anon_sym_map_LBRACK,
    ACTIONS(3962), 1,
      anon_sym_chan,
    ACTIONS(3964), 1,
      anon_sym_thread,
    ACTIONS(3966), 1,
      anon_sym_atomic,
    ACTIONS(6031), 1,
      anon_sym_QMARK,
    ACTIONS(6033), 1,
      anon_sym_BANG,
    ACTIONS(6035), 1,
      anon_sym_LBRACK2,
    ACTIONS(6037), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_plain_type,
    STATE(4423), 1,
      sym_reference_expression,
    STATE(1563), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3182), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1655), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1657), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [87254] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4150), 1,
      sym_identifier,
    ACTIONS(4152), 1,
      anon_sym_LPAREN,
    ACTIONS(4154), 1,
      anon_sym_fn,
    ACTIONS(4158), 1,
      anon_sym_struct,
    ACTIONS(4168), 1,
      anon_sym_shared,
    ACTIONS(4170), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4172), 1,
      anon_sym_chan,
    ACTIONS(4174), 1,
      anon_sym_thread,
    ACTIONS(4176), 1,
      anon_sym_atomic,
    ACTIONS(6073), 1,
      anon_sym_STAR,
    ACTIONS(6075), 1,
      anon_sym_QMARK,
    ACTIONS(6077), 1,
      anon_sym_BANG,
    ACTIONS(6079), 1,
      anon_sym_LBRACK2,
    ACTIONS(6081), 1,
      anon_sym_AMP,
    STATE(2060), 1,
      sym_plain_type,
    STATE(4465), 1,
      sym_reference_expression,
    STATE(2019), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3183), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2052), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2051), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [87337] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(3937), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3184), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [87420] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4325), 1,
      sym_identifier,
    ACTIONS(4329), 1,
      anon_sym_fn,
    ACTIONS(4333), 1,
      anon_sym_struct,
    ACTIONS(4343), 1,
      anon_sym_shared,
    ACTIONS(4347), 1,
      anon_sym_chan,
    ACTIONS(4349), 1,
      anon_sym_thread,
    ACTIONS(4351), 1,
      anon_sym_atomic,
    ACTIONS(6097), 1,
      anon_sym_LPAREN,
    ACTIONS(6099), 1,
      anon_sym_STAR,
    ACTIONS(6101), 1,
      anon_sym_QMARK,
    ACTIONS(6103), 1,
      anon_sym_BANG,
    ACTIONS(6105), 1,
      anon_sym_LBRACK2,
    ACTIONS(6107), 1,
      anon_sym_AMP,
    ACTIONS(6109), 1,
      anon_sym_map_LBRACK,
    STATE(2322), 1,
      sym_plain_type,
    STATE(4545), 1,
      sym_reference_expression,
    STATE(2244), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3185), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2366), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2365), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [87503] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(5791), 1,
      anon_sym_fn,
    ACTIONS(5803), 1,
      anon_sym_shared,
    ACTIONS(5807), 1,
      anon_sym_chan,
    ACTIONS(5809), 1,
      anon_sym_thread,
    ACTIONS(5811), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(5885), 1,
      anon_sym_STAR,
    ACTIONS(5887), 1,
      anon_sym_QMARK,
    ACTIONS(5889), 1,
      anon_sym_BANG,
    ACTIONS(5891), 1,
      anon_sym_LBRACK2,
    ACTIONS(5893), 1,
      anon_sym_AMP,
    ACTIONS(5895), 1,
      anon_sym_map_LBRACK,
    STATE(1070), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(3186), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [87586] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4581), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3187), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [87669] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1754), 1,
      sym_identifier,
    ACTIONS(1758), 1,
      anon_sym_fn,
    ACTIONS(1762), 1,
      anon_sym_struct,
    ACTIONS(1772), 1,
      anon_sym_shared,
    ACTIONS(1776), 1,
      anon_sym_chan,
    ACTIONS(1778), 1,
      anon_sym_thread,
    ACTIONS(1780), 1,
      anon_sym_atomic,
    ACTIONS(6111), 1,
      anon_sym_LPAREN,
    ACTIONS(6113), 1,
      anon_sym_STAR,
    ACTIONS(6115), 1,
      anon_sym_QMARK,
    ACTIONS(6117), 1,
      anon_sym_BANG,
    ACTIONS(6119), 1,
      anon_sym_LBRACK2,
    ACTIONS(6121), 1,
      anon_sym_AMP,
    ACTIONS(6123), 1,
      anon_sym_map_LBRACK,
    STATE(1235), 1,
      sym_plain_type,
    STATE(4444), 1,
      sym_reference_expression,
    STATE(1148), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3188), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1214), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1215), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [87752] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(5791), 1,
      anon_sym_fn,
    ACTIONS(5803), 1,
      anon_sym_shared,
    ACTIONS(5807), 1,
      anon_sym_chan,
    ACTIONS(5809), 1,
      anon_sym_thread,
    ACTIONS(5811), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(5885), 1,
      anon_sym_STAR,
    ACTIONS(5887), 1,
      anon_sym_QMARK,
    ACTIONS(5889), 1,
      anon_sym_BANG,
    ACTIONS(5891), 1,
      anon_sym_LBRACK2,
    ACTIONS(5893), 1,
      anon_sym_AMP,
    ACTIONS(5895), 1,
      anon_sym_map_LBRACK,
    STATE(1071), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(3189), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [87835] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(4684), 1,
      sym_plain_type,
    STATE(3190), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [87918] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4925), 1,
      sym_identifier,
    ACTIONS(4929), 1,
      anon_sym_fn,
    ACTIONS(4933), 1,
      anon_sym_struct,
    ACTIONS(4943), 1,
      anon_sym_shared,
    ACTIONS(4947), 1,
      anon_sym_chan,
    ACTIONS(4949), 1,
      anon_sym_thread,
    ACTIONS(4951), 1,
      anon_sym_atomic,
    ACTIONS(5993), 1,
      anon_sym_LPAREN,
    ACTIONS(5995), 1,
      anon_sym_STAR,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_BANG,
    ACTIONS(6001), 1,
      anon_sym_LBRACK2,
    ACTIONS(6003), 1,
      anon_sym_AMP,
    ACTIONS(6005), 1,
      anon_sym_map_LBRACK,
    STATE(2825), 1,
      sym_plain_type,
    STATE(4557), 1,
      sym_reference_expression,
    STATE(2609), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3191), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2888), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2889), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [88001] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4325), 1,
      sym_identifier,
    ACTIONS(4329), 1,
      anon_sym_fn,
    ACTIONS(4333), 1,
      anon_sym_struct,
    ACTIONS(4343), 1,
      anon_sym_shared,
    ACTIONS(4347), 1,
      anon_sym_chan,
    ACTIONS(4349), 1,
      anon_sym_thread,
    ACTIONS(4351), 1,
      anon_sym_atomic,
    ACTIONS(6097), 1,
      anon_sym_LPAREN,
    ACTIONS(6099), 1,
      anon_sym_STAR,
    ACTIONS(6101), 1,
      anon_sym_QMARK,
    ACTIONS(6103), 1,
      anon_sym_BANG,
    ACTIONS(6105), 1,
      anon_sym_LBRACK2,
    ACTIONS(6107), 1,
      anon_sym_AMP,
    ACTIONS(6109), 1,
      anon_sym_map_LBRACK,
    STATE(2318), 1,
      sym_plain_type,
    STATE(4545), 1,
      sym_reference_expression,
    STATE(2244), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3192), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2366), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2365), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [88084] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(3854), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3193), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [88167] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4325), 1,
      sym_identifier,
    ACTIONS(4329), 1,
      anon_sym_fn,
    ACTIONS(4333), 1,
      anon_sym_struct,
    ACTIONS(4343), 1,
      anon_sym_shared,
    ACTIONS(4347), 1,
      anon_sym_chan,
    ACTIONS(4349), 1,
      anon_sym_thread,
    ACTIONS(4351), 1,
      anon_sym_atomic,
    ACTIONS(6097), 1,
      anon_sym_LPAREN,
    ACTIONS(6099), 1,
      anon_sym_STAR,
    ACTIONS(6101), 1,
      anon_sym_QMARK,
    ACTIONS(6103), 1,
      anon_sym_BANG,
    ACTIONS(6105), 1,
      anon_sym_LBRACK2,
    ACTIONS(6107), 1,
      anon_sym_AMP,
    ACTIONS(6109), 1,
      anon_sym_map_LBRACK,
    STATE(2350), 1,
      sym_plain_type,
    STATE(4545), 1,
      sym_reference_expression,
    STATE(2244), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3194), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2366), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2365), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [88250] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3836), 1,
      anon_sym_fn,
    ACTIONS(3840), 1,
      anon_sym_struct,
    ACTIONS(3850), 1,
      anon_sym_shared,
    ACTIONS(3854), 1,
      anon_sym_chan,
    ACTIONS(3856), 1,
      anon_sym_thread,
    ACTIONS(3858), 1,
      anon_sym_atomic,
    ACTIONS(6083), 1,
      anon_sym_LPAREN,
    ACTIONS(6085), 1,
      anon_sym_STAR,
    ACTIONS(6087), 1,
      anon_sym_QMARK,
    ACTIONS(6089), 1,
      anon_sym_BANG,
    ACTIONS(6091), 1,
      anon_sym_LBRACK2,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_map_LBRACK,
    STATE(1460), 1,
      sym_plain_type,
    STATE(4507), 1,
      sym_reference_expression,
    STATE(1426), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3195), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1528), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1529), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [88333] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4325), 1,
      sym_identifier,
    ACTIONS(4329), 1,
      anon_sym_fn,
    ACTIONS(4333), 1,
      anon_sym_struct,
    ACTIONS(4343), 1,
      anon_sym_shared,
    ACTIONS(4347), 1,
      anon_sym_chan,
    ACTIONS(4349), 1,
      anon_sym_thread,
    ACTIONS(4351), 1,
      anon_sym_atomic,
    ACTIONS(6097), 1,
      anon_sym_LPAREN,
    ACTIONS(6099), 1,
      anon_sym_STAR,
    ACTIONS(6101), 1,
      anon_sym_QMARK,
    ACTIONS(6103), 1,
      anon_sym_BANG,
    ACTIONS(6105), 1,
      anon_sym_LBRACK2,
    ACTIONS(6107), 1,
      anon_sym_AMP,
    ACTIONS(6109), 1,
      anon_sym_map_LBRACK,
    STATE(2305), 1,
      sym_plain_type,
    STATE(4545), 1,
      sym_reference_expression,
    STATE(2244), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3196), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2366), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2365), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [88416] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4325), 1,
      sym_identifier,
    ACTIONS(4329), 1,
      anon_sym_fn,
    ACTIONS(4333), 1,
      anon_sym_struct,
    ACTIONS(4343), 1,
      anon_sym_shared,
    ACTIONS(4347), 1,
      anon_sym_chan,
    ACTIONS(4349), 1,
      anon_sym_thread,
    ACTIONS(4351), 1,
      anon_sym_atomic,
    ACTIONS(6097), 1,
      anon_sym_LPAREN,
    ACTIONS(6099), 1,
      anon_sym_STAR,
    ACTIONS(6101), 1,
      anon_sym_QMARK,
    ACTIONS(6103), 1,
      anon_sym_BANG,
    ACTIONS(6105), 1,
      anon_sym_LBRACK2,
    ACTIONS(6107), 1,
      anon_sym_AMP,
    ACTIONS(6109), 1,
      anon_sym_map_LBRACK,
    STATE(2280), 1,
      sym_plain_type,
    STATE(4545), 1,
      sym_reference_expression,
    STATE(2244), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3197), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2366), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2365), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [88499] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4925), 1,
      sym_identifier,
    ACTIONS(4929), 1,
      anon_sym_fn,
    ACTIONS(4933), 1,
      anon_sym_struct,
    ACTIONS(4943), 1,
      anon_sym_shared,
    ACTIONS(4947), 1,
      anon_sym_chan,
    ACTIONS(4949), 1,
      anon_sym_thread,
    ACTIONS(4951), 1,
      anon_sym_atomic,
    ACTIONS(5993), 1,
      anon_sym_LPAREN,
    ACTIONS(5995), 1,
      anon_sym_STAR,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_BANG,
    ACTIONS(6001), 1,
      anon_sym_LBRACK2,
    ACTIONS(6003), 1,
      anon_sym_AMP,
    ACTIONS(6005), 1,
      anon_sym_map_LBRACK,
    STATE(2828), 1,
      sym_plain_type,
    STATE(4557), 1,
      sym_reference_expression,
    STATE(2609), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3198), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2888), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2889), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [88582] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1754), 1,
      sym_identifier,
    ACTIONS(1758), 1,
      anon_sym_fn,
    ACTIONS(1762), 1,
      anon_sym_struct,
    ACTIONS(1772), 1,
      anon_sym_shared,
    ACTIONS(1776), 1,
      anon_sym_chan,
    ACTIONS(1778), 1,
      anon_sym_thread,
    ACTIONS(1780), 1,
      anon_sym_atomic,
    ACTIONS(6111), 1,
      anon_sym_LPAREN,
    ACTIONS(6113), 1,
      anon_sym_STAR,
    ACTIONS(6115), 1,
      anon_sym_QMARK,
    ACTIONS(6117), 1,
      anon_sym_BANG,
    ACTIONS(6119), 1,
      anon_sym_LBRACK2,
    ACTIONS(6121), 1,
      anon_sym_AMP,
    ACTIONS(6123), 1,
      anon_sym_map_LBRACK,
    STATE(1236), 1,
      sym_plain_type,
    STATE(4444), 1,
      sym_reference_expression,
    STATE(1148), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3199), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1214), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1215), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [88665] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3940), 1,
      sym_identifier,
    ACTIONS(3942), 1,
      anon_sym_LPAREN,
    ACTIONS(3944), 1,
      anon_sym_fn,
    ACTIONS(3946), 1,
      anon_sym_STAR,
    ACTIONS(3948), 1,
      anon_sym_struct,
    ACTIONS(3958), 1,
      anon_sym_shared,
    ACTIONS(3960), 1,
      anon_sym_map_LBRACK,
    ACTIONS(3962), 1,
      anon_sym_chan,
    ACTIONS(3964), 1,
      anon_sym_thread,
    ACTIONS(3966), 1,
      anon_sym_atomic,
    ACTIONS(6031), 1,
      anon_sym_QMARK,
    ACTIONS(6033), 1,
      anon_sym_BANG,
    ACTIONS(6035), 1,
      anon_sym_LBRACK2,
    ACTIONS(6037), 1,
      anon_sym_AMP,
    STATE(1651), 1,
      sym_plain_type,
    STATE(4423), 1,
      sym_reference_expression,
    STATE(1563), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3200), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1655), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1657), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [88748] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(4357), 1,
      sym_identifier,
    ACTIONS(4359), 1,
      anon_sym_fn,
    ACTIONS(4361), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_shared,
    ACTIONS(4373), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4375), 1,
      anon_sym_chan,
    ACTIONS(4377), 1,
      anon_sym_thread,
    ACTIONS(4379), 1,
      anon_sym_atomic,
    ACTIONS(6053), 1,
      anon_sym_QMARK,
    ACTIONS(6055), 1,
      anon_sym_BANG,
    ACTIONS(6057), 1,
      anon_sym_LBRACK2,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    STATE(2919), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2395), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3201), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [88831] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4041), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3202), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [88914] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3940), 1,
      sym_identifier,
    ACTIONS(3942), 1,
      anon_sym_LPAREN,
    ACTIONS(3944), 1,
      anon_sym_fn,
    ACTIONS(3946), 1,
      anon_sym_STAR,
    ACTIONS(3948), 1,
      anon_sym_struct,
    ACTIONS(3958), 1,
      anon_sym_shared,
    ACTIONS(3960), 1,
      anon_sym_map_LBRACK,
    ACTIONS(3962), 1,
      anon_sym_chan,
    ACTIONS(3964), 1,
      anon_sym_thread,
    ACTIONS(3966), 1,
      anon_sym_atomic,
    ACTIONS(6031), 1,
      anon_sym_QMARK,
    ACTIONS(6033), 1,
      anon_sym_BANG,
    ACTIONS(6035), 1,
      anon_sym_LBRACK2,
    ACTIONS(6037), 1,
      anon_sym_AMP,
    STATE(1641), 1,
      sym_plain_type,
    STATE(4423), 1,
      sym_reference_expression,
    STATE(1563), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3203), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1655), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1657), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [88997] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4150), 1,
      sym_identifier,
    ACTIONS(4152), 1,
      anon_sym_LPAREN,
    ACTIONS(4154), 1,
      anon_sym_fn,
    ACTIONS(4158), 1,
      anon_sym_struct,
    ACTIONS(4168), 1,
      anon_sym_shared,
    ACTIONS(4170), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4172), 1,
      anon_sym_chan,
    ACTIONS(4174), 1,
      anon_sym_thread,
    ACTIONS(4176), 1,
      anon_sym_atomic,
    ACTIONS(6073), 1,
      anon_sym_STAR,
    ACTIONS(6075), 1,
      anon_sym_QMARK,
    ACTIONS(6077), 1,
      anon_sym_BANG,
    ACTIONS(6079), 1,
      anon_sym_LBRACK2,
    ACTIONS(6081), 1,
      anon_sym_AMP,
    STATE(2037), 1,
      sym_plain_type,
    STATE(4465), 1,
      sym_reference_expression,
    STATE(2019), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3204), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2052), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2051), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [89080] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4150), 1,
      sym_identifier,
    ACTIONS(4152), 1,
      anon_sym_LPAREN,
    ACTIONS(4154), 1,
      anon_sym_fn,
    ACTIONS(4158), 1,
      anon_sym_struct,
    ACTIONS(4168), 1,
      anon_sym_shared,
    ACTIONS(4170), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4172), 1,
      anon_sym_chan,
    ACTIONS(4174), 1,
      anon_sym_thread,
    ACTIONS(4176), 1,
      anon_sym_atomic,
    ACTIONS(6073), 1,
      anon_sym_STAR,
    ACTIONS(6075), 1,
      anon_sym_QMARK,
    ACTIONS(6077), 1,
      anon_sym_BANG,
    ACTIONS(6079), 1,
      anon_sym_LBRACK2,
    ACTIONS(6081), 1,
      anon_sym_AMP,
    STATE(2061), 1,
      sym_plain_type,
    STATE(4465), 1,
      sym_reference_expression,
    STATE(2019), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3205), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2052), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2051), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [89163] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(5791), 1,
      anon_sym_fn,
    ACTIONS(5803), 1,
      anon_sym_shared,
    ACTIONS(5807), 1,
      anon_sym_chan,
    ACTIONS(5809), 1,
      anon_sym_thread,
    ACTIONS(5811), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(5885), 1,
      anon_sym_STAR,
    ACTIONS(5887), 1,
      anon_sym_QMARK,
    ACTIONS(5889), 1,
      anon_sym_BANG,
    ACTIONS(5891), 1,
      anon_sym_LBRACK2,
    ACTIONS(5893), 1,
      anon_sym_AMP,
    ACTIONS(5895), 1,
      anon_sym_map_LBRACK,
    STATE(1079), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(3206), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [89246] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1754), 1,
      sym_identifier,
    ACTIONS(1758), 1,
      anon_sym_fn,
    ACTIONS(1762), 1,
      anon_sym_struct,
    ACTIONS(1772), 1,
      anon_sym_shared,
    ACTIONS(1776), 1,
      anon_sym_chan,
    ACTIONS(1778), 1,
      anon_sym_thread,
    ACTIONS(1780), 1,
      anon_sym_atomic,
    ACTIONS(6111), 1,
      anon_sym_LPAREN,
    ACTIONS(6113), 1,
      anon_sym_STAR,
    ACTIONS(6115), 1,
      anon_sym_QMARK,
    ACTIONS(6117), 1,
      anon_sym_BANG,
    ACTIONS(6119), 1,
      anon_sym_LBRACK2,
    ACTIONS(6121), 1,
      anon_sym_AMP,
    ACTIONS(6123), 1,
      anon_sym_map_LBRACK,
    STATE(1203), 1,
      sym_plain_type,
    STATE(4444), 1,
      sym_reference_expression,
    STATE(1148), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3207), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1214), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1215), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [89329] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(4357), 1,
      sym_identifier,
    ACTIONS(4359), 1,
      anon_sym_fn,
    ACTIONS(4361), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_shared,
    ACTIONS(4373), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4375), 1,
      anon_sym_chan,
    ACTIONS(4377), 1,
      anon_sym_thread,
    ACTIONS(4379), 1,
      anon_sym_atomic,
    ACTIONS(6053), 1,
      anon_sym_QMARK,
    ACTIONS(6055), 1,
      anon_sym_BANG,
    ACTIONS(6057), 1,
      anon_sym_LBRACK2,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    STATE(2548), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2395), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3208), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [89412] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1754), 1,
      sym_identifier,
    ACTIONS(1758), 1,
      anon_sym_fn,
    ACTIONS(1762), 1,
      anon_sym_struct,
    ACTIONS(1772), 1,
      anon_sym_shared,
    ACTIONS(1776), 1,
      anon_sym_chan,
    ACTIONS(1778), 1,
      anon_sym_thread,
    ACTIONS(1780), 1,
      anon_sym_atomic,
    ACTIONS(6111), 1,
      anon_sym_LPAREN,
    ACTIONS(6113), 1,
      anon_sym_STAR,
    ACTIONS(6115), 1,
      anon_sym_QMARK,
    ACTIONS(6117), 1,
      anon_sym_BANG,
    ACTIONS(6119), 1,
      anon_sym_LBRACK2,
    ACTIONS(6121), 1,
      anon_sym_AMP,
    ACTIONS(6123), 1,
      anon_sym_map_LBRACK,
    STATE(1237), 1,
      sym_plain_type,
    STATE(4444), 1,
      sym_reference_expression,
    STATE(1148), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3209), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1214), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1215), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [89495] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(3928), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3210), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [89578] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3836), 1,
      anon_sym_fn,
    ACTIONS(3840), 1,
      anon_sym_struct,
    ACTIONS(3850), 1,
      anon_sym_shared,
    ACTIONS(3854), 1,
      anon_sym_chan,
    ACTIONS(3856), 1,
      anon_sym_thread,
    ACTIONS(3858), 1,
      anon_sym_atomic,
    ACTIONS(6083), 1,
      anon_sym_LPAREN,
    ACTIONS(6085), 1,
      anon_sym_STAR,
    ACTIONS(6087), 1,
      anon_sym_QMARK,
    ACTIONS(6089), 1,
      anon_sym_BANG,
    ACTIONS(6091), 1,
      anon_sym_LBRACK2,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_map_LBRACK,
    STATE(1461), 1,
      sym_plain_type,
    STATE(4507), 1,
      sym_reference_expression,
    STATE(1426), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3211), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1528), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1529), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [89661] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4325), 1,
      sym_identifier,
    ACTIONS(4329), 1,
      anon_sym_fn,
    ACTIONS(4333), 1,
      anon_sym_struct,
    ACTIONS(4343), 1,
      anon_sym_shared,
    ACTIONS(4347), 1,
      anon_sym_chan,
    ACTIONS(4349), 1,
      anon_sym_thread,
    ACTIONS(4351), 1,
      anon_sym_atomic,
    ACTIONS(6097), 1,
      anon_sym_LPAREN,
    ACTIONS(6099), 1,
      anon_sym_STAR,
    ACTIONS(6101), 1,
      anon_sym_QMARK,
    ACTIONS(6103), 1,
      anon_sym_BANG,
    ACTIONS(6105), 1,
      anon_sym_LBRACK2,
    ACTIONS(6107), 1,
      anon_sym_AMP,
    ACTIONS(6109), 1,
      anon_sym_map_LBRACK,
    STATE(2317), 1,
      sym_plain_type,
    STATE(4545), 1,
      sym_reference_expression,
    STATE(2244), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3212), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2366), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2365), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [89744] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1015), 1,
      sym_identifier,
    ACTIONS(1019), 1,
      anon_sym_fn,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(1033), 1,
      anon_sym_shared,
    ACTIONS(1037), 1,
      anon_sym_chan,
    ACTIONS(1039), 1,
      anon_sym_thread,
    ACTIONS(1041), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(6061), 1,
      anon_sym_STAR,
    ACTIONS(6063), 1,
      anon_sym_QMARK,
    ACTIONS(6065), 1,
      anon_sym_BANG,
    ACTIONS(6067), 1,
      anon_sym_LBRACK2,
    ACTIONS(6069), 1,
      anon_sym_AMP,
    ACTIONS(6071), 1,
      anon_sym_map_LBRACK,
    STATE(1082), 1,
      sym_plain_type,
    STATE(4500), 1,
      sym_reference_expression,
    STATE(1003), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3213), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [89827] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(4634), 1,
      sym_plain_type,
    STATE(3214), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [89910] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4286), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3215), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [89993] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(3887), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3216), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [90076] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(2455), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3217), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [90159] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(3989), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3218), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [90242] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4190), 1,
      sym_identifier,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_fn,
    ACTIONS(4198), 1,
      anon_sym_struct,
    ACTIONS(4208), 1,
      anon_sym_shared,
    ACTIONS(4210), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4212), 1,
      anon_sym_chan,
    ACTIONS(4214), 1,
      anon_sym_thread,
    ACTIONS(4216), 1,
      anon_sym_atomic,
    ACTIONS(6007), 1,
      anon_sym_STAR,
    ACTIONS(6009), 1,
      anon_sym_QMARK,
    ACTIONS(6011), 1,
      anon_sym_BANG,
    ACTIONS(6013), 1,
      anon_sym_LBRACK2,
    ACTIONS(6015), 1,
      anon_sym_AMP,
    STATE(2191), 1,
      sym_plain_type,
    STATE(4528), 1,
      sym_reference_expression,
    STATE(2017), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3219), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2110), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2111), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [90325] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(4696), 1,
      sym_plain_type,
    STATE(3220), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [90408] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3836), 1,
      anon_sym_fn,
    ACTIONS(3840), 1,
      anon_sym_struct,
    ACTIONS(3850), 1,
      anon_sym_shared,
    ACTIONS(3854), 1,
      anon_sym_chan,
    ACTIONS(3856), 1,
      anon_sym_thread,
    ACTIONS(3858), 1,
      anon_sym_atomic,
    ACTIONS(6083), 1,
      anon_sym_LPAREN,
    ACTIONS(6085), 1,
      anon_sym_STAR,
    ACTIONS(6087), 1,
      anon_sym_QMARK,
    ACTIONS(6089), 1,
      anon_sym_BANG,
    ACTIONS(6091), 1,
      anon_sym_LBRACK2,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_map_LBRACK,
    STATE(1504), 1,
      sym_plain_type,
    STATE(4507), 1,
      sym_reference_expression,
    STATE(1426), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3221), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1528), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1529), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [90491] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(2483), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3222), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [90574] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1754), 1,
      sym_identifier,
    ACTIONS(1758), 1,
      anon_sym_fn,
    ACTIONS(1762), 1,
      anon_sym_struct,
    ACTIONS(1772), 1,
      anon_sym_shared,
    ACTIONS(1776), 1,
      anon_sym_chan,
    ACTIONS(1778), 1,
      anon_sym_thread,
    ACTIONS(1780), 1,
      anon_sym_atomic,
    ACTIONS(6111), 1,
      anon_sym_LPAREN,
    ACTIONS(6113), 1,
      anon_sym_STAR,
    ACTIONS(6115), 1,
      anon_sym_QMARK,
    ACTIONS(6117), 1,
      anon_sym_BANG,
    ACTIONS(6119), 1,
      anon_sym_LBRACK2,
    ACTIONS(6121), 1,
      anon_sym_AMP,
    ACTIONS(6123), 1,
      anon_sym_map_LBRACK,
    STATE(1217), 1,
      sym_plain_type,
    STATE(4444), 1,
      sym_reference_expression,
    STATE(1148), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3223), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1214), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1215), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [90657] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(819), 1,
      sym_identifier,
    ACTIONS(825), 1,
      anon_sym_fn,
    ACTIONS(829), 1,
      anon_sym_struct,
    ACTIONS(839), 1,
      anon_sym_shared,
    ACTIONS(843), 1,
      anon_sym_chan,
    ACTIONS(845), 1,
      anon_sym_thread,
    ACTIONS(847), 1,
      anon_sym_atomic,
    ACTIONS(6039), 1,
      anon_sym_LPAREN,
    ACTIONS(6041), 1,
      anon_sym_STAR,
    ACTIONS(6043), 1,
      anon_sym_QMARK,
    ACTIONS(6045), 1,
      anon_sym_BANG,
    ACTIONS(6047), 1,
      anon_sym_LBRACK2,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_map_LBRACK,
    STATE(448), 1,
      sym_plain_type,
    STATE(4523), 1,
      sym_reference_expression,
    STATE(291), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3224), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(429), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(442), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [90740] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(2484), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3225), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [90823] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4066), 1,
      sym_identifier,
    ACTIONS(4070), 1,
      anon_sym_fn,
    ACTIONS(4074), 1,
      anon_sym_struct,
    ACTIONS(4084), 1,
      anon_sym_shared,
    ACTIONS(4088), 1,
      anon_sym_chan,
    ACTIONS(4090), 1,
      anon_sym_thread,
    ACTIONS(4092), 1,
      anon_sym_atomic,
    ACTIONS(5897), 1,
      anon_sym_LPAREN,
    ACTIONS(5901), 1,
      anon_sym_STAR,
    ACTIONS(5903), 1,
      anon_sym_QMARK,
    ACTIONS(5905), 1,
      anon_sym_BANG,
    ACTIONS(5907), 1,
      anon_sym_LBRACK2,
    ACTIONS(5909), 1,
      anon_sym_AMP,
    ACTIONS(5911), 1,
      anon_sym_map_LBRACK,
    STATE(1811), 1,
      sym_plain_type,
    STATE(4601), 1,
      sym_reference_expression,
    STATE(1730), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3226), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1875), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1881), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [90906] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4150), 1,
      sym_identifier,
    ACTIONS(4152), 1,
      anon_sym_LPAREN,
    ACTIONS(4154), 1,
      anon_sym_fn,
    ACTIONS(4158), 1,
      anon_sym_struct,
    ACTIONS(4168), 1,
      anon_sym_shared,
    ACTIONS(4170), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4172), 1,
      anon_sym_chan,
    ACTIONS(4174), 1,
      anon_sym_thread,
    ACTIONS(4176), 1,
      anon_sym_atomic,
    ACTIONS(6073), 1,
      anon_sym_STAR,
    ACTIONS(6075), 1,
      anon_sym_QMARK,
    ACTIONS(6077), 1,
      anon_sym_BANG,
    ACTIONS(6079), 1,
      anon_sym_LBRACK2,
    ACTIONS(6081), 1,
      anon_sym_AMP,
    STATE(2185), 1,
      sym_plain_type,
    STATE(4465), 1,
      sym_reference_expression,
    STATE(2019), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3227), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2052), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2051), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [90989] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(4636), 1,
      sym_plain_type,
    STATE(3228), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [91072] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3836), 1,
      anon_sym_fn,
    ACTIONS(3840), 1,
      anon_sym_struct,
    ACTIONS(3850), 1,
      anon_sym_shared,
    ACTIONS(3854), 1,
      anon_sym_chan,
    ACTIONS(3856), 1,
      anon_sym_thread,
    ACTIONS(3858), 1,
      anon_sym_atomic,
    ACTIONS(6083), 1,
      anon_sym_LPAREN,
    ACTIONS(6085), 1,
      anon_sym_STAR,
    ACTIONS(6087), 1,
      anon_sym_QMARK,
    ACTIONS(6089), 1,
      anon_sym_BANG,
    ACTIONS(6091), 1,
      anon_sym_LBRACK2,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_map_LBRACK,
    STATE(1551), 1,
      sym_plain_type,
    STATE(4507), 1,
      sym_reference_expression,
    STATE(1426), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3229), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1528), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1529), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [91155] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4066), 1,
      sym_identifier,
    ACTIONS(4070), 1,
      anon_sym_fn,
    ACTIONS(4074), 1,
      anon_sym_struct,
    ACTIONS(4084), 1,
      anon_sym_shared,
    ACTIONS(4088), 1,
      anon_sym_chan,
    ACTIONS(4090), 1,
      anon_sym_thread,
    ACTIONS(4092), 1,
      anon_sym_atomic,
    ACTIONS(5897), 1,
      anon_sym_LPAREN,
    ACTIONS(5901), 1,
      anon_sym_STAR,
    ACTIONS(5903), 1,
      anon_sym_QMARK,
    ACTIONS(5905), 1,
      anon_sym_BANG,
    ACTIONS(5907), 1,
      anon_sym_LBRACK2,
    ACTIONS(5909), 1,
      anon_sym_AMP,
    ACTIONS(5911), 1,
      anon_sym_map_LBRACK,
    STATE(1830), 1,
      sym_plain_type,
    STATE(4601), 1,
      sym_reference_expression,
    STATE(1730), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3230), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1875), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1881), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [91238] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4150), 1,
      sym_identifier,
    ACTIONS(4152), 1,
      anon_sym_LPAREN,
    ACTIONS(4154), 1,
      anon_sym_fn,
    ACTIONS(4158), 1,
      anon_sym_struct,
    ACTIONS(4168), 1,
      anon_sym_shared,
    ACTIONS(4170), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4172), 1,
      anon_sym_chan,
    ACTIONS(4174), 1,
      anon_sym_thread,
    ACTIONS(4176), 1,
      anon_sym_atomic,
    ACTIONS(6073), 1,
      anon_sym_STAR,
    ACTIONS(6075), 1,
      anon_sym_QMARK,
    ACTIONS(6077), 1,
      anon_sym_BANG,
    ACTIONS(6079), 1,
      anon_sym_LBRACK2,
    ACTIONS(6081), 1,
      anon_sym_AMP,
    STATE(2182), 1,
      sym_plain_type,
    STATE(4465), 1,
      sym_reference_expression,
    STATE(2019), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3231), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2052), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2051), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [91321] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4066), 1,
      sym_identifier,
    ACTIONS(4070), 1,
      anon_sym_fn,
    ACTIONS(4074), 1,
      anon_sym_struct,
    ACTIONS(4084), 1,
      anon_sym_shared,
    ACTIONS(4088), 1,
      anon_sym_chan,
    ACTIONS(4090), 1,
      anon_sym_thread,
    ACTIONS(4092), 1,
      anon_sym_atomic,
    ACTIONS(5897), 1,
      anon_sym_LPAREN,
    ACTIONS(5901), 1,
      anon_sym_STAR,
    ACTIONS(5903), 1,
      anon_sym_QMARK,
    ACTIONS(5905), 1,
      anon_sym_BANG,
    ACTIONS(5907), 1,
      anon_sym_LBRACK2,
    ACTIONS(5909), 1,
      anon_sym_AMP,
    ACTIONS(5911), 1,
      anon_sym_map_LBRACK,
    STATE(1858), 1,
      sym_plain_type,
    STATE(4601), 1,
      sym_reference_expression,
    STATE(1730), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3232), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1875), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1881), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [91404] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1015), 1,
      sym_identifier,
    ACTIONS(1019), 1,
      anon_sym_fn,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(1033), 1,
      anon_sym_shared,
    ACTIONS(1037), 1,
      anon_sym_chan,
    ACTIONS(1039), 1,
      anon_sym_thread,
    ACTIONS(1041), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(6061), 1,
      anon_sym_STAR,
    ACTIONS(6063), 1,
      anon_sym_QMARK,
    ACTIONS(6065), 1,
      anon_sym_BANG,
    ACTIONS(6067), 1,
      anon_sym_LBRACK2,
    ACTIONS(6069), 1,
      anon_sym_AMP,
    ACTIONS(6071), 1,
      anon_sym_map_LBRACK,
    STATE(1031), 1,
      sym_plain_type,
    STATE(4500), 1,
      sym_reference_expression,
    STATE(1003), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3233), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [91487] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(819), 1,
      sym_identifier,
    ACTIONS(825), 1,
      anon_sym_fn,
    ACTIONS(829), 1,
      anon_sym_struct,
    ACTIONS(839), 1,
      anon_sym_shared,
    ACTIONS(843), 1,
      anon_sym_chan,
    ACTIONS(845), 1,
      anon_sym_thread,
    ACTIONS(847), 1,
      anon_sym_atomic,
    ACTIONS(6039), 1,
      anon_sym_LPAREN,
    ACTIONS(6041), 1,
      anon_sym_STAR,
    ACTIONS(6043), 1,
      anon_sym_QMARK,
    ACTIONS(6045), 1,
      anon_sym_BANG,
    ACTIONS(6047), 1,
      anon_sym_LBRACK2,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_map_LBRACK,
    STATE(357), 1,
      sym_plain_type,
    STATE(4523), 1,
      sym_reference_expression,
    STATE(291), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3234), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(429), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(442), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [91570] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4325), 1,
      sym_identifier,
    ACTIONS(4329), 1,
      anon_sym_fn,
    ACTIONS(4333), 1,
      anon_sym_struct,
    ACTIONS(4343), 1,
      anon_sym_shared,
    ACTIONS(4347), 1,
      anon_sym_chan,
    ACTIONS(4349), 1,
      anon_sym_thread,
    ACTIONS(4351), 1,
      anon_sym_atomic,
    ACTIONS(6097), 1,
      anon_sym_LPAREN,
    ACTIONS(6099), 1,
      anon_sym_STAR,
    ACTIONS(6101), 1,
      anon_sym_QMARK,
    ACTIONS(6103), 1,
      anon_sym_BANG,
    ACTIONS(6105), 1,
      anon_sym_LBRACK2,
    ACTIONS(6107), 1,
      anon_sym_AMP,
    ACTIONS(6109), 1,
      anon_sym_map_LBRACK,
    STATE(2272), 1,
      sym_plain_type,
    STATE(4545), 1,
      sym_reference_expression,
    STATE(2244), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3235), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2366), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2365), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [91653] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3940), 1,
      sym_identifier,
    ACTIONS(3942), 1,
      anon_sym_LPAREN,
    ACTIONS(3944), 1,
      anon_sym_fn,
    ACTIONS(3946), 1,
      anon_sym_STAR,
    ACTIONS(3948), 1,
      anon_sym_struct,
    ACTIONS(3958), 1,
      anon_sym_shared,
    ACTIONS(3960), 1,
      anon_sym_map_LBRACK,
    ACTIONS(3962), 1,
      anon_sym_chan,
    ACTIONS(3964), 1,
      anon_sym_thread,
    ACTIONS(3966), 1,
      anon_sym_atomic,
    ACTIONS(6031), 1,
      anon_sym_QMARK,
    ACTIONS(6033), 1,
      anon_sym_BANG,
    ACTIONS(6035), 1,
      anon_sym_LBRACK2,
    ACTIONS(6037), 1,
      anon_sym_AMP,
    STATE(1643), 1,
      sym_plain_type,
    STATE(4423), 1,
      sym_reference_expression,
    STATE(1563), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3236), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1655), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1657), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [91736] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1015), 1,
      sym_identifier,
    ACTIONS(1019), 1,
      anon_sym_fn,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(1033), 1,
      anon_sym_shared,
    ACTIONS(1037), 1,
      anon_sym_chan,
    ACTIONS(1039), 1,
      anon_sym_thread,
    ACTIONS(1041), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(6061), 1,
      anon_sym_STAR,
    ACTIONS(6063), 1,
      anon_sym_QMARK,
    ACTIONS(6065), 1,
      anon_sym_BANG,
    ACTIONS(6067), 1,
      anon_sym_LBRACK2,
    ACTIONS(6069), 1,
      anon_sym_AMP,
    ACTIONS(6071), 1,
      anon_sym_map_LBRACK,
    STATE(1113), 1,
      sym_plain_type,
    STATE(4500), 1,
      sym_reference_expression,
    STATE(1003), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3237), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [91819] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4530), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3238), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [91902] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1015), 1,
      sym_identifier,
    ACTIONS(1019), 1,
      anon_sym_fn,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(1033), 1,
      anon_sym_shared,
    ACTIONS(1037), 1,
      anon_sym_chan,
    ACTIONS(1039), 1,
      anon_sym_thread,
    ACTIONS(1041), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(6061), 1,
      anon_sym_STAR,
    ACTIONS(6063), 1,
      anon_sym_QMARK,
    ACTIONS(6065), 1,
      anon_sym_BANG,
    ACTIONS(6067), 1,
      anon_sym_LBRACK2,
    ACTIONS(6069), 1,
      anon_sym_AMP,
    ACTIONS(6071), 1,
      anon_sym_map_LBRACK,
    STATE(1107), 1,
      sym_plain_type,
    STATE(4500), 1,
      sym_reference_expression,
    STATE(1003), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3239), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [91985] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(4681), 1,
      sym_plain_type,
    STATE(3240), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [92068] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(2430), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3241), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [92151] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3836), 1,
      anon_sym_fn,
    ACTIONS(3840), 1,
      anon_sym_struct,
    ACTIONS(3850), 1,
      anon_sym_shared,
    ACTIONS(3854), 1,
      anon_sym_chan,
    ACTIONS(3856), 1,
      anon_sym_thread,
    ACTIONS(3858), 1,
      anon_sym_atomic,
    ACTIONS(6083), 1,
      anon_sym_LPAREN,
    ACTIONS(6085), 1,
      anon_sym_STAR,
    ACTIONS(6087), 1,
      anon_sym_QMARK,
    ACTIONS(6089), 1,
      anon_sym_BANG,
    ACTIONS(6091), 1,
      anon_sym_LBRACK2,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_map_LBRACK,
    STATE(1512), 1,
      sym_plain_type,
    STATE(4507), 1,
      sym_reference_expression,
    STATE(1426), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3242), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1528), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1529), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [92234] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1015), 1,
      sym_identifier,
    ACTIONS(1019), 1,
      anon_sym_fn,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(1033), 1,
      anon_sym_shared,
    ACTIONS(1037), 1,
      anon_sym_chan,
    ACTIONS(1039), 1,
      anon_sym_thread,
    ACTIONS(1041), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(6061), 1,
      anon_sym_STAR,
    ACTIONS(6063), 1,
      anon_sym_QMARK,
    ACTIONS(6065), 1,
      anon_sym_BANG,
    ACTIONS(6067), 1,
      anon_sym_LBRACK2,
    ACTIONS(6069), 1,
      anon_sym_AMP,
    ACTIONS(6071), 1,
      anon_sym_map_LBRACK,
    STATE(1102), 1,
      sym_plain_type,
    STATE(4500), 1,
      sym_reference_expression,
    STATE(1003), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3243), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [92317] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1015), 1,
      sym_identifier,
    ACTIONS(1019), 1,
      anon_sym_fn,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(1033), 1,
      anon_sym_shared,
    ACTIONS(1037), 1,
      anon_sym_chan,
    ACTIONS(1039), 1,
      anon_sym_thread,
    ACTIONS(1041), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(6061), 1,
      anon_sym_STAR,
    ACTIONS(6063), 1,
      anon_sym_QMARK,
    ACTIONS(6065), 1,
      anon_sym_BANG,
    ACTIONS(6067), 1,
      anon_sym_LBRACK2,
    ACTIONS(6069), 1,
      anon_sym_AMP,
    ACTIONS(6071), 1,
      anon_sym_map_LBRACK,
    STATE(1099), 1,
      sym_plain_type,
    STATE(4500), 1,
      sym_reference_expression,
    STATE(1003), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3244), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [92400] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4325), 1,
      sym_identifier,
    ACTIONS(4329), 1,
      anon_sym_fn,
    ACTIONS(4333), 1,
      anon_sym_struct,
    ACTIONS(4343), 1,
      anon_sym_shared,
    ACTIONS(4347), 1,
      anon_sym_chan,
    ACTIONS(4349), 1,
      anon_sym_thread,
    ACTIONS(4351), 1,
      anon_sym_atomic,
    ACTIONS(6097), 1,
      anon_sym_LPAREN,
    ACTIONS(6099), 1,
      anon_sym_STAR,
    ACTIONS(6101), 1,
      anon_sym_QMARK,
    ACTIONS(6103), 1,
      anon_sym_BANG,
    ACTIONS(6105), 1,
      anon_sym_LBRACK2,
    ACTIONS(6107), 1,
      anon_sym_AMP,
    ACTIONS(6109), 1,
      anon_sym_map_LBRACK,
    STATE(2360), 1,
      sym_plain_type,
    STATE(4545), 1,
      sym_reference_expression,
    STATE(2244), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3245), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2366), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2365), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [92483] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(4652), 1,
      sym_plain_type,
    STATE(3246), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [92566] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1754), 1,
      sym_identifier,
    ACTIONS(1758), 1,
      anon_sym_fn,
    ACTIONS(1762), 1,
      anon_sym_struct,
    ACTIONS(1772), 1,
      anon_sym_shared,
    ACTIONS(1776), 1,
      anon_sym_chan,
    ACTIONS(1778), 1,
      anon_sym_thread,
    ACTIONS(1780), 1,
      anon_sym_atomic,
    ACTIONS(6111), 1,
      anon_sym_LPAREN,
    ACTIONS(6113), 1,
      anon_sym_STAR,
    ACTIONS(6115), 1,
      anon_sym_QMARK,
    ACTIONS(6117), 1,
      anon_sym_BANG,
    ACTIONS(6119), 1,
      anon_sym_LBRACK2,
    ACTIONS(6121), 1,
      anon_sym_AMP,
    ACTIONS(6123), 1,
      anon_sym_map_LBRACK,
    STATE(1158), 1,
      sym_plain_type,
    STATE(4444), 1,
      sym_reference_expression,
    STATE(1148), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3247), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1214), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1215), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [92649] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1754), 1,
      sym_identifier,
    ACTIONS(1758), 1,
      anon_sym_fn,
    ACTIONS(1762), 1,
      anon_sym_struct,
    ACTIONS(1772), 1,
      anon_sym_shared,
    ACTIONS(1776), 1,
      anon_sym_chan,
    ACTIONS(1778), 1,
      anon_sym_thread,
    ACTIONS(1780), 1,
      anon_sym_atomic,
    ACTIONS(6111), 1,
      anon_sym_LPAREN,
    ACTIONS(6113), 1,
      anon_sym_STAR,
    ACTIONS(6115), 1,
      anon_sym_QMARK,
    ACTIONS(6117), 1,
      anon_sym_BANG,
    ACTIONS(6119), 1,
      anon_sym_LBRACK2,
    ACTIONS(6121), 1,
      anon_sym_AMP,
    ACTIONS(6123), 1,
      anon_sym_map_LBRACK,
    STATE(1259), 1,
      sym_plain_type,
    STATE(4444), 1,
      sym_reference_expression,
    STATE(1148), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3248), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1214), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1215), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [92732] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1754), 1,
      sym_identifier,
    ACTIONS(1758), 1,
      anon_sym_fn,
    ACTIONS(1762), 1,
      anon_sym_struct,
    ACTIONS(1772), 1,
      anon_sym_shared,
    ACTIONS(1776), 1,
      anon_sym_chan,
    ACTIONS(1778), 1,
      anon_sym_thread,
    ACTIONS(1780), 1,
      anon_sym_atomic,
    ACTIONS(6111), 1,
      anon_sym_LPAREN,
    ACTIONS(6113), 1,
      anon_sym_STAR,
    ACTIONS(6115), 1,
      anon_sym_QMARK,
    ACTIONS(6117), 1,
      anon_sym_BANG,
    ACTIONS(6119), 1,
      anon_sym_LBRACK2,
    ACTIONS(6121), 1,
      anon_sym_AMP,
    ACTIONS(6123), 1,
      anon_sym_map_LBRACK,
    STATE(1234), 1,
      sym_plain_type,
    STATE(4444), 1,
      sym_reference_expression,
    STATE(1148), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3249), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1214), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1215), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [92815] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(4643), 1,
      sym_plain_type,
    STATE(3250), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [92898] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(3873), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3251), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [92981] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4925), 1,
      sym_identifier,
    ACTIONS(4929), 1,
      anon_sym_fn,
    ACTIONS(4933), 1,
      anon_sym_struct,
    ACTIONS(4943), 1,
      anon_sym_shared,
    ACTIONS(4947), 1,
      anon_sym_chan,
    ACTIONS(4949), 1,
      anon_sym_thread,
    ACTIONS(4951), 1,
      anon_sym_atomic,
    ACTIONS(5993), 1,
      anon_sym_LPAREN,
    ACTIONS(5995), 1,
      anon_sym_STAR,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_BANG,
    ACTIONS(6001), 1,
      anon_sym_LBRACK2,
    ACTIONS(6003), 1,
      anon_sym_AMP,
    ACTIONS(6005), 1,
      anon_sym_map_LBRACK,
    STATE(2813), 1,
      sym_plain_type,
    STATE(4557), 1,
      sym_reference_expression,
    STATE(2609), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3252), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2888), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2889), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [93064] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4325), 1,
      sym_identifier,
    ACTIONS(4329), 1,
      anon_sym_fn,
    ACTIONS(4333), 1,
      anon_sym_struct,
    ACTIONS(4343), 1,
      anon_sym_shared,
    ACTIONS(4347), 1,
      anon_sym_chan,
    ACTIONS(4349), 1,
      anon_sym_thread,
    ACTIONS(4351), 1,
      anon_sym_atomic,
    ACTIONS(6097), 1,
      anon_sym_LPAREN,
    ACTIONS(6099), 1,
      anon_sym_STAR,
    ACTIONS(6101), 1,
      anon_sym_QMARK,
    ACTIONS(6103), 1,
      anon_sym_BANG,
    ACTIONS(6105), 1,
      anon_sym_LBRACK2,
    ACTIONS(6107), 1,
      anon_sym_AMP,
    ACTIONS(6109), 1,
      anon_sym_map_LBRACK,
    STATE(2281), 1,
      sym_plain_type,
    STATE(4545), 1,
      sym_reference_expression,
    STATE(2244), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3253), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2366), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2365), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [93147] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4895), 1,
      sym_identifier,
    ACTIONS(4897), 1,
      anon_sym_LPAREN,
    ACTIONS(4899), 1,
      anon_sym_fn,
    ACTIONS(4901), 1,
      anon_sym_STAR,
    ACTIONS(4903), 1,
      anon_sym_struct,
    ACTIONS(4913), 1,
      anon_sym_shared,
    ACTIONS(4915), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4917), 1,
      anon_sym_chan,
    ACTIONS(4919), 1,
      anon_sym_thread,
    ACTIONS(4921), 1,
      anon_sym_atomic,
    ACTIONS(6125), 1,
      anon_sym_QMARK,
    ACTIONS(6127), 1,
      anon_sym_BANG,
    ACTIONS(6129), 1,
      anon_sym_LBRACK2,
    ACTIONS(6131), 1,
      anon_sym_AMP,
    STATE(2548), 1,
      sym_plain_type,
    STATE(4553), 1,
      sym_reference_expression,
    STATE(2589), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3254), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2747), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2748), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [93230] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3406), 1,
      sym_identifier,
    ACTIONS(3410), 1,
      anon_sym_fn,
    ACTIONS(3414), 1,
      anon_sym_struct,
    ACTIONS(3424), 1,
      anon_sym_shared,
    ACTIONS(3428), 1,
      anon_sym_chan,
    ACTIONS(3430), 1,
      anon_sym_thread,
    ACTIONS(3432), 1,
      anon_sym_atomic,
    ACTIONS(6017), 1,
      anon_sym_LPAREN,
    ACTIONS(6019), 1,
      anon_sym_STAR,
    ACTIONS(6021), 1,
      anon_sym_QMARK,
    ACTIONS(6023), 1,
      anon_sym_BANG,
    ACTIONS(6025), 1,
      anon_sym_LBRACK2,
    ACTIONS(6027), 1,
      anon_sym_AMP,
    ACTIONS(6029), 1,
      anon_sym_map_LBRACK,
    STATE(1336), 1,
      sym_plain_type,
    STATE(4486), 1,
      sym_reference_expression,
    STATE(1298), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3255), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1327), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1324), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [93313] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4150), 1,
      sym_identifier,
    ACTIONS(4152), 1,
      anon_sym_LPAREN,
    ACTIONS(4154), 1,
      anon_sym_fn,
    ACTIONS(4158), 1,
      anon_sym_struct,
    ACTIONS(4168), 1,
      anon_sym_shared,
    ACTIONS(4170), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4172), 1,
      anon_sym_chan,
    ACTIONS(4174), 1,
      anon_sym_thread,
    ACTIONS(4176), 1,
      anon_sym_atomic,
    ACTIONS(6073), 1,
      anon_sym_STAR,
    ACTIONS(6075), 1,
      anon_sym_QMARK,
    ACTIONS(6077), 1,
      anon_sym_BANG,
    ACTIONS(6079), 1,
      anon_sym_LBRACK2,
    ACTIONS(6081), 1,
      anon_sym_AMP,
    STATE(2032), 1,
      sym_plain_type,
    STATE(4465), 1,
      sym_reference_expression,
    STATE(2019), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3256), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2052), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2051), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [93396] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1015), 1,
      sym_identifier,
    ACTIONS(1019), 1,
      anon_sym_fn,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(1033), 1,
      anon_sym_shared,
    ACTIONS(1037), 1,
      anon_sym_chan,
    ACTIONS(1039), 1,
      anon_sym_thread,
    ACTIONS(1041), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(6061), 1,
      anon_sym_STAR,
    ACTIONS(6063), 1,
      anon_sym_QMARK,
    ACTIONS(6065), 1,
      anon_sym_BANG,
    ACTIONS(6067), 1,
      anon_sym_LBRACK2,
    ACTIONS(6069), 1,
      anon_sym_AMP,
    ACTIONS(6071), 1,
      anon_sym_map_LBRACK,
    STATE(1085), 1,
      sym_plain_type,
    STATE(4500), 1,
      sym_reference_expression,
    STATE(1003), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3257), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [93479] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1015), 1,
      sym_identifier,
    ACTIONS(1019), 1,
      anon_sym_fn,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(1033), 1,
      anon_sym_shared,
    ACTIONS(1037), 1,
      anon_sym_chan,
    ACTIONS(1039), 1,
      anon_sym_thread,
    ACTIONS(1041), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(6061), 1,
      anon_sym_STAR,
    ACTIONS(6063), 1,
      anon_sym_QMARK,
    ACTIONS(6065), 1,
      anon_sym_BANG,
    ACTIONS(6067), 1,
      anon_sym_LBRACK2,
    ACTIONS(6069), 1,
      anon_sym_AMP,
    ACTIONS(6071), 1,
      anon_sym_map_LBRACK,
    STATE(1081), 1,
      sym_plain_type,
    STATE(4500), 1,
      sym_reference_expression,
    STATE(1003), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3258), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [93562] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1015), 1,
      sym_identifier,
    ACTIONS(1019), 1,
      anon_sym_fn,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(1033), 1,
      anon_sym_shared,
    ACTIONS(1037), 1,
      anon_sym_chan,
    ACTIONS(1039), 1,
      anon_sym_thread,
    ACTIONS(1041), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(6061), 1,
      anon_sym_STAR,
    ACTIONS(6063), 1,
      anon_sym_QMARK,
    ACTIONS(6065), 1,
      anon_sym_BANG,
    ACTIONS(6067), 1,
      anon_sym_LBRACK2,
    ACTIONS(6069), 1,
      anon_sym_AMP,
    ACTIONS(6071), 1,
      anon_sym_map_LBRACK,
    STATE(1108), 1,
      sym_plain_type,
    STATE(4500), 1,
      sym_reference_expression,
    STATE(1003), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3259), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [93645] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4925), 1,
      sym_identifier,
    ACTIONS(4929), 1,
      anon_sym_fn,
    ACTIONS(4933), 1,
      anon_sym_struct,
    ACTIONS(4943), 1,
      anon_sym_shared,
    ACTIONS(4947), 1,
      anon_sym_chan,
    ACTIONS(4949), 1,
      anon_sym_thread,
    ACTIONS(4951), 1,
      anon_sym_atomic,
    ACTIONS(5993), 1,
      anon_sym_LPAREN,
    ACTIONS(5995), 1,
      anon_sym_STAR,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_BANG,
    ACTIONS(6001), 1,
      anon_sym_LBRACK2,
    ACTIONS(6003), 1,
      anon_sym_AMP,
    ACTIONS(6005), 1,
      anon_sym_map_LBRACK,
    STATE(2816), 1,
      sym_plain_type,
    STATE(4557), 1,
      sym_reference_expression,
    STATE(2609), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3260), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2888), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2889), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [93728] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4925), 1,
      sym_identifier,
    ACTIONS(4929), 1,
      anon_sym_fn,
    ACTIONS(4933), 1,
      anon_sym_struct,
    ACTIONS(4943), 1,
      anon_sym_shared,
    ACTIONS(4947), 1,
      anon_sym_chan,
    ACTIONS(4949), 1,
      anon_sym_thread,
    ACTIONS(4951), 1,
      anon_sym_atomic,
    ACTIONS(5993), 1,
      anon_sym_LPAREN,
    ACTIONS(5995), 1,
      anon_sym_STAR,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_BANG,
    ACTIONS(6001), 1,
      anon_sym_LBRACK2,
    ACTIONS(6003), 1,
      anon_sym_AMP,
    ACTIONS(6005), 1,
      anon_sym_map_LBRACK,
    STATE(2840), 1,
      sym_plain_type,
    STATE(4557), 1,
      sym_reference_expression,
    STATE(2609), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3261), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2888), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2889), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [93811] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4587), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3262), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [93894] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4150), 1,
      sym_identifier,
    ACTIONS(4152), 1,
      anon_sym_LPAREN,
    ACTIONS(4154), 1,
      anon_sym_fn,
    ACTIONS(4158), 1,
      anon_sym_struct,
    ACTIONS(4168), 1,
      anon_sym_shared,
    ACTIONS(4170), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4172), 1,
      anon_sym_chan,
    ACTIONS(4174), 1,
      anon_sym_thread,
    ACTIONS(4176), 1,
      anon_sym_atomic,
    ACTIONS(6073), 1,
      anon_sym_STAR,
    ACTIONS(6075), 1,
      anon_sym_QMARK,
    ACTIONS(6077), 1,
      anon_sym_BANG,
    ACTIONS(6079), 1,
      anon_sym_LBRACK2,
    ACTIONS(6081), 1,
      anon_sym_AMP,
    STATE(2050), 1,
      sym_plain_type,
    STATE(4465), 1,
      sym_reference_expression,
    STATE(2019), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3263), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2052), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2051), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [93977] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(5791), 1,
      anon_sym_fn,
    ACTIONS(5803), 1,
      anon_sym_shared,
    ACTIONS(5807), 1,
      anon_sym_chan,
    ACTIONS(5809), 1,
      anon_sym_thread,
    ACTIONS(5811), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(5885), 1,
      anon_sym_STAR,
    ACTIONS(5887), 1,
      anon_sym_QMARK,
    ACTIONS(5889), 1,
      anon_sym_BANG,
    ACTIONS(5891), 1,
      anon_sym_LBRACK2,
    ACTIONS(5893), 1,
      anon_sym_AMP,
    ACTIONS(5895), 1,
      anon_sym_map_LBRACK,
    STATE(1108), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(3264), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [94060] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(5791), 1,
      anon_sym_fn,
    ACTIONS(5803), 1,
      anon_sym_shared,
    ACTIONS(5807), 1,
      anon_sym_chan,
    ACTIONS(5809), 1,
      anon_sym_thread,
    ACTIONS(5811), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(5885), 1,
      anon_sym_STAR,
    ACTIONS(5887), 1,
      anon_sym_QMARK,
    ACTIONS(5889), 1,
      anon_sym_BANG,
    ACTIONS(5891), 1,
      anon_sym_LBRACK2,
    ACTIONS(5893), 1,
      anon_sym_AMP,
    ACTIONS(5895), 1,
      anon_sym_map_LBRACK,
    STATE(1081), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(3265), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [94143] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3406), 1,
      sym_identifier,
    ACTIONS(3410), 1,
      anon_sym_fn,
    ACTIONS(3414), 1,
      anon_sym_struct,
    ACTIONS(3424), 1,
      anon_sym_shared,
    ACTIONS(3428), 1,
      anon_sym_chan,
    ACTIONS(3430), 1,
      anon_sym_thread,
    ACTIONS(3432), 1,
      anon_sym_atomic,
    ACTIONS(6017), 1,
      anon_sym_LPAREN,
    ACTIONS(6019), 1,
      anon_sym_STAR,
    ACTIONS(6021), 1,
      anon_sym_QMARK,
    ACTIONS(6023), 1,
      anon_sym_BANG,
    ACTIONS(6025), 1,
      anon_sym_LBRACK2,
    ACTIONS(6027), 1,
      anon_sym_AMP,
    ACTIONS(6029), 1,
      anon_sym_map_LBRACK,
    STATE(1332), 1,
      sym_plain_type,
    STATE(4486), 1,
      sym_reference_expression,
    STATE(1298), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3266), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1327), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1324), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [94226] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4066), 1,
      sym_identifier,
    ACTIONS(4070), 1,
      anon_sym_fn,
    ACTIONS(4074), 1,
      anon_sym_struct,
    ACTIONS(4084), 1,
      anon_sym_shared,
    ACTIONS(4088), 1,
      anon_sym_chan,
    ACTIONS(4090), 1,
      anon_sym_thread,
    ACTIONS(4092), 1,
      anon_sym_atomic,
    ACTIONS(5897), 1,
      anon_sym_LPAREN,
    ACTIONS(5901), 1,
      anon_sym_STAR,
    ACTIONS(5903), 1,
      anon_sym_QMARK,
    ACTIONS(5905), 1,
      anon_sym_BANG,
    ACTIONS(5907), 1,
      anon_sym_LBRACK2,
    ACTIONS(5909), 1,
      anon_sym_AMP,
    ACTIONS(5911), 1,
      anon_sym_map_LBRACK,
    STATE(1862), 1,
      sym_plain_type,
    STATE(4601), 1,
      sym_reference_expression,
    STATE(1730), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3267), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1875), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1881), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [94309] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4150), 1,
      sym_identifier,
    ACTIONS(4152), 1,
      anon_sym_LPAREN,
    ACTIONS(4154), 1,
      anon_sym_fn,
    ACTIONS(4158), 1,
      anon_sym_struct,
    ACTIONS(4168), 1,
      anon_sym_shared,
    ACTIONS(4170), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4172), 1,
      anon_sym_chan,
    ACTIONS(4174), 1,
      anon_sym_thread,
    ACTIONS(4176), 1,
      anon_sym_atomic,
    ACTIONS(6073), 1,
      anon_sym_STAR,
    ACTIONS(6075), 1,
      anon_sym_QMARK,
    ACTIONS(6077), 1,
      anon_sym_BANG,
    ACTIONS(6079), 1,
      anon_sym_LBRACK2,
    ACTIONS(6081), 1,
      anon_sym_AMP,
    STATE(2144), 1,
      sym_plain_type,
    STATE(4465), 1,
      sym_reference_expression,
    STATE(2019), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3268), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2052), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2051), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [94392] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4066), 1,
      sym_identifier,
    ACTIONS(4070), 1,
      anon_sym_fn,
    ACTIONS(4074), 1,
      anon_sym_struct,
    ACTIONS(4084), 1,
      anon_sym_shared,
    ACTIONS(4088), 1,
      anon_sym_chan,
    ACTIONS(4090), 1,
      anon_sym_thread,
    ACTIONS(4092), 1,
      anon_sym_atomic,
    ACTIONS(5897), 1,
      anon_sym_LPAREN,
    ACTIONS(5901), 1,
      anon_sym_STAR,
    ACTIONS(5903), 1,
      anon_sym_QMARK,
    ACTIONS(5905), 1,
      anon_sym_BANG,
    ACTIONS(5907), 1,
      anon_sym_LBRACK2,
    ACTIONS(5909), 1,
      anon_sym_AMP,
    ACTIONS(5911), 1,
      anon_sym_map_LBRACK,
    STATE(1883), 1,
      sym_plain_type,
    STATE(4601), 1,
      sym_reference_expression,
    STATE(1730), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3269), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1875), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1881), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [94475] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4895), 1,
      sym_identifier,
    ACTIONS(4897), 1,
      anon_sym_LPAREN,
    ACTIONS(4899), 1,
      anon_sym_fn,
    ACTIONS(4901), 1,
      anon_sym_STAR,
    ACTIONS(4903), 1,
      anon_sym_struct,
    ACTIONS(4913), 1,
      anon_sym_shared,
    ACTIONS(4915), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4917), 1,
      anon_sym_chan,
    ACTIONS(4919), 1,
      anon_sym_thread,
    ACTIONS(4921), 1,
      anon_sym_atomic,
    ACTIONS(6125), 1,
      anon_sym_QMARK,
    ACTIONS(6127), 1,
      anon_sym_BANG,
    ACTIONS(6129), 1,
      anon_sym_LBRACK2,
    ACTIONS(6131), 1,
      anon_sym_AMP,
    STATE(2761), 1,
      sym_plain_type,
    STATE(4553), 1,
      sym_reference_expression,
    STATE(2589), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3270), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2747), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2748), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [94558] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4895), 1,
      sym_identifier,
    ACTIONS(4897), 1,
      anon_sym_LPAREN,
    ACTIONS(4899), 1,
      anon_sym_fn,
    ACTIONS(4901), 1,
      anon_sym_STAR,
    ACTIONS(4903), 1,
      anon_sym_struct,
    ACTIONS(4913), 1,
      anon_sym_shared,
    ACTIONS(4915), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4917), 1,
      anon_sym_chan,
    ACTIONS(4919), 1,
      anon_sym_thread,
    ACTIONS(4921), 1,
      anon_sym_atomic,
    ACTIONS(6125), 1,
      anon_sym_QMARK,
    ACTIONS(6127), 1,
      anon_sym_BANG,
    ACTIONS(6129), 1,
      anon_sym_LBRACK2,
    ACTIONS(6131), 1,
      anon_sym_AMP,
    STATE(2762), 1,
      sym_plain_type,
    STATE(4553), 1,
      sym_reference_expression,
    STATE(2589), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3271), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2747), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2748), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [94641] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4925), 1,
      sym_identifier,
    ACTIONS(4929), 1,
      anon_sym_fn,
    ACTIONS(4933), 1,
      anon_sym_struct,
    ACTIONS(4943), 1,
      anon_sym_shared,
    ACTIONS(4947), 1,
      anon_sym_chan,
    ACTIONS(4949), 1,
      anon_sym_thread,
    ACTIONS(4951), 1,
      anon_sym_atomic,
    ACTIONS(5993), 1,
      anon_sym_LPAREN,
    ACTIONS(5995), 1,
      anon_sym_STAR,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_BANG,
    ACTIONS(6001), 1,
      anon_sym_LBRACK2,
    ACTIONS(6003), 1,
      anon_sym_AMP,
    ACTIONS(6005), 1,
      anon_sym_map_LBRACK,
    STATE(2878), 1,
      sym_plain_type,
    STATE(4557), 1,
      sym_reference_expression,
    STATE(2609), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3272), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2888), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2889), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [94724] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4925), 1,
      sym_identifier,
    ACTIONS(4929), 1,
      anon_sym_fn,
    ACTIONS(4933), 1,
      anon_sym_struct,
    ACTIONS(4943), 1,
      anon_sym_shared,
    ACTIONS(4947), 1,
      anon_sym_chan,
    ACTIONS(4949), 1,
      anon_sym_thread,
    ACTIONS(4951), 1,
      anon_sym_atomic,
    ACTIONS(5993), 1,
      anon_sym_LPAREN,
    ACTIONS(5995), 1,
      anon_sym_STAR,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_BANG,
    ACTIONS(6001), 1,
      anon_sym_LBRACK2,
    ACTIONS(6003), 1,
      anon_sym_AMP,
    ACTIONS(6005), 1,
      anon_sym_map_LBRACK,
    STATE(2829), 1,
      sym_plain_type,
    STATE(4557), 1,
      sym_reference_expression,
    STATE(2609), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3273), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2888), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2889), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [94807] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4925), 1,
      sym_identifier,
    ACTIONS(4929), 1,
      anon_sym_fn,
    ACTIONS(4933), 1,
      anon_sym_struct,
    ACTIONS(4943), 1,
      anon_sym_shared,
    ACTIONS(4947), 1,
      anon_sym_chan,
    ACTIONS(4949), 1,
      anon_sym_thread,
    ACTIONS(4951), 1,
      anon_sym_atomic,
    ACTIONS(5993), 1,
      anon_sym_LPAREN,
    ACTIONS(5995), 1,
      anon_sym_STAR,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_BANG,
    ACTIONS(6001), 1,
      anon_sym_LBRACK2,
    ACTIONS(6003), 1,
      anon_sym_AMP,
    ACTIONS(6005), 1,
      anon_sym_map_LBRACK,
    STATE(2842), 1,
      sym_plain_type,
    STATE(4557), 1,
      sym_reference_expression,
    STATE(2609), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3274), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2888), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2889), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [94890] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(3884), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3275), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [94973] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(5791), 1,
      anon_sym_fn,
    ACTIONS(5803), 1,
      anon_sym_shared,
    ACTIONS(5807), 1,
      anon_sym_chan,
    ACTIONS(5809), 1,
      anon_sym_thread,
    ACTIONS(5811), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(5885), 1,
      anon_sym_STAR,
    ACTIONS(5887), 1,
      anon_sym_QMARK,
    ACTIONS(5889), 1,
      anon_sym_BANG,
    ACTIONS(5891), 1,
      anon_sym_LBRACK2,
    ACTIONS(5893), 1,
      anon_sym_AMP,
    ACTIONS(5895), 1,
      anon_sym_map_LBRACK,
    STATE(1085), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(3276), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [95056] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3406), 1,
      sym_identifier,
    ACTIONS(3410), 1,
      anon_sym_fn,
    ACTIONS(3414), 1,
      anon_sym_struct,
    ACTIONS(3424), 1,
      anon_sym_shared,
    ACTIONS(3428), 1,
      anon_sym_chan,
    ACTIONS(3430), 1,
      anon_sym_thread,
    ACTIONS(3432), 1,
      anon_sym_atomic,
    ACTIONS(6017), 1,
      anon_sym_LPAREN,
    ACTIONS(6019), 1,
      anon_sym_STAR,
    ACTIONS(6021), 1,
      anon_sym_QMARK,
    ACTIONS(6023), 1,
      anon_sym_BANG,
    ACTIONS(6025), 1,
      anon_sym_LBRACK2,
    ACTIONS(6027), 1,
      anon_sym_AMP,
    ACTIONS(6029), 1,
      anon_sym_map_LBRACK,
    STATE(1368), 1,
      sym_plain_type,
    STATE(4486), 1,
      sym_reference_expression,
    STATE(1298), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3277), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1327), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1324), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [95139] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4925), 1,
      sym_identifier,
    ACTIONS(4929), 1,
      anon_sym_fn,
    ACTIONS(4933), 1,
      anon_sym_struct,
    ACTIONS(4943), 1,
      anon_sym_shared,
    ACTIONS(4947), 1,
      anon_sym_chan,
    ACTIONS(4949), 1,
      anon_sym_thread,
    ACTIONS(4951), 1,
      anon_sym_atomic,
    ACTIONS(5993), 1,
      anon_sym_LPAREN,
    ACTIONS(5995), 1,
      anon_sym_STAR,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_BANG,
    ACTIONS(6001), 1,
      anon_sym_LBRACK2,
    ACTIONS(6003), 1,
      anon_sym_AMP,
    ACTIONS(6005), 1,
      anon_sym_map_LBRACK,
    STATE(2845), 1,
      sym_plain_type,
    STATE(4557), 1,
      sym_reference_expression,
    STATE(2609), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3278), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2888), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2889), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [95222] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3836), 1,
      anon_sym_fn,
    ACTIONS(3840), 1,
      anon_sym_struct,
    ACTIONS(3850), 1,
      anon_sym_shared,
    ACTIONS(3854), 1,
      anon_sym_chan,
    ACTIONS(3856), 1,
      anon_sym_thread,
    ACTIONS(3858), 1,
      anon_sym_atomic,
    ACTIONS(6083), 1,
      anon_sym_LPAREN,
    ACTIONS(6085), 1,
      anon_sym_STAR,
    ACTIONS(6087), 1,
      anon_sym_QMARK,
    ACTIONS(6089), 1,
      anon_sym_BANG,
    ACTIONS(6091), 1,
      anon_sym_LBRACK2,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_map_LBRACK,
    STATE(1541), 1,
      sym_plain_type,
    STATE(4507), 1,
      sym_reference_expression,
    STATE(1426), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3279), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1528), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1529), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [95305] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4925), 1,
      sym_identifier,
    ACTIONS(4929), 1,
      anon_sym_fn,
    ACTIONS(4933), 1,
      anon_sym_struct,
    ACTIONS(4943), 1,
      anon_sym_shared,
    ACTIONS(4947), 1,
      anon_sym_chan,
    ACTIONS(4949), 1,
      anon_sym_thread,
    ACTIONS(4951), 1,
      anon_sym_atomic,
    ACTIONS(5993), 1,
      anon_sym_LPAREN,
    ACTIONS(5995), 1,
      anon_sym_STAR,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_BANG,
    ACTIONS(6001), 1,
      anon_sym_LBRACK2,
    ACTIONS(6003), 1,
      anon_sym_AMP,
    ACTIONS(6005), 1,
      anon_sym_map_LBRACK,
    STATE(2864), 1,
      sym_plain_type,
    STATE(4557), 1,
      sym_reference_expression,
    STATE(2609), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3280), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2888), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2889), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [95388] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3836), 1,
      anon_sym_fn,
    ACTIONS(3840), 1,
      anon_sym_struct,
    ACTIONS(3850), 1,
      anon_sym_shared,
    ACTIONS(3854), 1,
      anon_sym_chan,
    ACTIONS(3856), 1,
      anon_sym_thread,
    ACTIONS(3858), 1,
      anon_sym_atomic,
    ACTIONS(6083), 1,
      anon_sym_LPAREN,
    ACTIONS(6085), 1,
      anon_sym_STAR,
    ACTIONS(6087), 1,
      anon_sym_QMARK,
    ACTIONS(6089), 1,
      anon_sym_BANG,
    ACTIONS(6091), 1,
      anon_sym_LBRACK2,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_map_LBRACK,
    STATE(1513), 1,
      sym_plain_type,
    STATE(4507), 1,
      sym_reference_expression,
    STATE(1426), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3281), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1528), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1529), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [95471] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(2458), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3282), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [95554] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(3948), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3283), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [95637] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4925), 1,
      sym_identifier,
    ACTIONS(4929), 1,
      anon_sym_fn,
    ACTIONS(4933), 1,
      anon_sym_struct,
    ACTIONS(4943), 1,
      anon_sym_shared,
    ACTIONS(4947), 1,
      anon_sym_chan,
    ACTIONS(4949), 1,
      anon_sym_thread,
    ACTIONS(4951), 1,
      anon_sym_atomic,
    ACTIONS(5993), 1,
      anon_sym_LPAREN,
    ACTIONS(5995), 1,
      anon_sym_STAR,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_BANG,
    ACTIONS(6001), 1,
      anon_sym_LBRACK2,
    ACTIONS(6003), 1,
      anon_sym_AMP,
    ACTIONS(6005), 1,
      anon_sym_map_LBRACK,
    STATE(2873), 1,
      sym_plain_type,
    STATE(4557), 1,
      sym_reference_expression,
    STATE(2609), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3284), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2888), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2889), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [95720] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4150), 1,
      sym_identifier,
    ACTIONS(4152), 1,
      anon_sym_LPAREN,
    ACTIONS(4154), 1,
      anon_sym_fn,
    ACTIONS(4158), 1,
      anon_sym_struct,
    ACTIONS(4168), 1,
      anon_sym_shared,
    ACTIONS(4170), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4172), 1,
      anon_sym_chan,
    ACTIONS(4174), 1,
      anon_sym_thread,
    ACTIONS(4176), 1,
      anon_sym_atomic,
    ACTIONS(6073), 1,
      anon_sym_STAR,
    ACTIONS(6075), 1,
      anon_sym_QMARK,
    ACTIONS(6077), 1,
      anon_sym_BANG,
    ACTIONS(6079), 1,
      anon_sym_LBRACK2,
    ACTIONS(6081), 1,
      anon_sym_AMP,
    STATE(2033), 1,
      sym_plain_type,
    STATE(4465), 1,
      sym_reference_expression,
    STATE(2019), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3285), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2052), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2051), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [95803] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4234), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3286), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [95886] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1015), 1,
      sym_identifier,
    ACTIONS(1019), 1,
      anon_sym_fn,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(1033), 1,
      anon_sym_shared,
    ACTIONS(1037), 1,
      anon_sym_chan,
    ACTIONS(1039), 1,
      anon_sym_thread,
    ACTIONS(1041), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(6061), 1,
      anon_sym_STAR,
    ACTIONS(6063), 1,
      anon_sym_QMARK,
    ACTIONS(6065), 1,
      anon_sym_BANG,
    ACTIONS(6067), 1,
      anon_sym_LBRACK2,
    ACTIONS(6069), 1,
      anon_sym_AMP,
    ACTIONS(6071), 1,
      anon_sym_map_LBRACK,
    STATE(1079), 1,
      sym_plain_type,
    STATE(4500), 1,
      sym_reference_expression,
    STATE(1003), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3287), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [95969] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4895), 1,
      sym_identifier,
    ACTIONS(4897), 1,
      anon_sym_LPAREN,
    ACTIONS(4899), 1,
      anon_sym_fn,
    ACTIONS(4901), 1,
      anon_sym_STAR,
    ACTIONS(4903), 1,
      anon_sym_struct,
    ACTIONS(4913), 1,
      anon_sym_shared,
    ACTIONS(4915), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4917), 1,
      anon_sym_chan,
    ACTIONS(4919), 1,
      anon_sym_thread,
    ACTIONS(4921), 1,
      anon_sym_atomic,
    ACTIONS(6125), 1,
      anon_sym_QMARK,
    ACTIONS(6127), 1,
      anon_sym_BANG,
    ACTIONS(6129), 1,
      anon_sym_LBRACK2,
    ACTIONS(6131), 1,
      anon_sym_AMP,
    STATE(2699), 1,
      sym_plain_type,
    STATE(4553), 1,
      sym_reference_expression,
    STATE(2589), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3288), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2747), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2748), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [96052] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1015), 1,
      sym_identifier,
    ACTIONS(1019), 1,
      anon_sym_fn,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(1033), 1,
      anon_sym_shared,
    ACTIONS(1037), 1,
      anon_sym_chan,
    ACTIONS(1039), 1,
      anon_sym_thread,
    ACTIONS(1041), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(6061), 1,
      anon_sym_STAR,
    ACTIONS(6063), 1,
      anon_sym_QMARK,
    ACTIONS(6065), 1,
      anon_sym_BANG,
    ACTIONS(6067), 1,
      anon_sym_LBRACK2,
    ACTIONS(6069), 1,
      anon_sym_AMP,
    ACTIONS(6071), 1,
      anon_sym_map_LBRACK,
    STATE(1071), 1,
      sym_plain_type,
    STATE(4500), 1,
      sym_reference_expression,
    STATE(1003), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3289), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [96135] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(5791), 1,
      anon_sym_fn,
    ACTIONS(5803), 1,
      anon_sym_shared,
    ACTIONS(5807), 1,
      anon_sym_chan,
    ACTIONS(5809), 1,
      anon_sym_thread,
    ACTIONS(5811), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(5885), 1,
      anon_sym_STAR,
    ACTIONS(5887), 1,
      anon_sym_QMARK,
    ACTIONS(5889), 1,
      anon_sym_BANG,
    ACTIONS(5891), 1,
      anon_sym_LBRACK2,
    ACTIONS(5893), 1,
      anon_sym_AMP,
    ACTIONS(5895), 1,
      anon_sym_map_LBRACK,
    STATE(1099), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(3290), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [96218] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1015), 1,
      sym_identifier,
    ACTIONS(1019), 1,
      anon_sym_fn,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(1033), 1,
      anon_sym_shared,
    ACTIONS(1037), 1,
      anon_sym_chan,
    ACTIONS(1039), 1,
      anon_sym_thread,
    ACTIONS(1041), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(6061), 1,
      anon_sym_STAR,
    ACTIONS(6063), 1,
      anon_sym_QMARK,
    ACTIONS(6065), 1,
      anon_sym_BANG,
    ACTIONS(6067), 1,
      anon_sym_LBRACK2,
    ACTIONS(6069), 1,
      anon_sym_AMP,
    ACTIONS(6071), 1,
      anon_sym_map_LBRACK,
    STATE(1070), 1,
      sym_plain_type,
    STATE(4500), 1,
      sym_reference_expression,
    STATE(1003), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3291), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [96301] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(5791), 1,
      anon_sym_fn,
    ACTIONS(5803), 1,
      anon_sym_shared,
    ACTIONS(5807), 1,
      anon_sym_chan,
    ACTIONS(5809), 1,
      anon_sym_thread,
    ACTIONS(5811), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(5885), 1,
      anon_sym_STAR,
    ACTIONS(5887), 1,
      anon_sym_QMARK,
    ACTIONS(5889), 1,
      anon_sym_BANG,
    ACTIONS(5891), 1,
      anon_sym_LBRACK2,
    ACTIONS(5893), 1,
      anon_sym_AMP,
    ACTIONS(5895), 1,
      anon_sym_map_LBRACK,
    STATE(1102), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(3292), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [96384] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1023), 1,
      anon_sym_struct,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(5791), 1,
      anon_sym_fn,
    ACTIONS(5803), 1,
      anon_sym_shared,
    ACTIONS(5807), 1,
      anon_sym_chan,
    ACTIONS(5809), 1,
      anon_sym_thread,
    ACTIONS(5811), 1,
      anon_sym_atomic,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(5885), 1,
      anon_sym_STAR,
    ACTIONS(5887), 1,
      anon_sym_QMARK,
    ACTIONS(5889), 1,
      anon_sym_BANG,
    ACTIONS(5891), 1,
      anon_sym_LBRACK2,
    ACTIONS(5893), 1,
      anon_sym_AMP,
    ACTIONS(5895), 1,
      anon_sym_map_LBRACK,
    STATE(1107), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(3293), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(1005), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1059), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [96467] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4524), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3294), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [96550] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(4357), 1,
      sym_identifier,
    ACTIONS(4359), 1,
      anon_sym_fn,
    ACTIONS(4361), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_shared,
    ACTIONS(4373), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4375), 1,
      anon_sym_chan,
    ACTIONS(4377), 1,
      anon_sym_thread,
    ACTIONS(4379), 1,
      anon_sym_atomic,
    ACTIONS(6053), 1,
      anon_sym_QMARK,
    ACTIONS(6055), 1,
      anon_sym_BANG,
    ACTIONS(6057), 1,
      anon_sym_LBRACK2,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    STATE(2430), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2395), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3295), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [96633] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(2422), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3296), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [96716] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4895), 1,
      sym_identifier,
    ACTIONS(4897), 1,
      anon_sym_LPAREN,
    ACTIONS(4899), 1,
      anon_sym_fn,
    ACTIONS(4901), 1,
      anon_sym_STAR,
    ACTIONS(4903), 1,
      anon_sym_struct,
    ACTIONS(4913), 1,
      anon_sym_shared,
    ACTIONS(4915), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4917), 1,
      anon_sym_chan,
    ACTIONS(4919), 1,
      anon_sym_thread,
    ACTIONS(4921), 1,
      anon_sym_atomic,
    ACTIONS(6125), 1,
      anon_sym_QMARK,
    ACTIONS(6127), 1,
      anon_sym_BANG,
    ACTIONS(6129), 1,
      anon_sym_LBRACK2,
    ACTIONS(6131), 1,
      anon_sym_AMP,
    STATE(2763), 1,
      sym_plain_type,
    STATE(4553), 1,
      sym_reference_expression,
    STATE(2589), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3297), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2747), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2748), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [96799] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4895), 1,
      sym_identifier,
    ACTIONS(4897), 1,
      anon_sym_LPAREN,
    ACTIONS(4899), 1,
      anon_sym_fn,
    ACTIONS(4901), 1,
      anon_sym_STAR,
    ACTIONS(4903), 1,
      anon_sym_struct,
    ACTIONS(4913), 1,
      anon_sym_shared,
    ACTIONS(4915), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4917), 1,
      anon_sym_chan,
    ACTIONS(4919), 1,
      anon_sym_thread,
    ACTIONS(4921), 1,
      anon_sym_atomic,
    ACTIONS(6125), 1,
      anon_sym_QMARK,
    ACTIONS(6127), 1,
      anon_sym_BANG,
    ACTIONS(6129), 1,
      anon_sym_LBRACK2,
    ACTIONS(6131), 1,
      anon_sym_AMP,
    STATE(2772), 1,
      sym_plain_type,
    STATE(4553), 1,
      sym_reference_expression,
    STATE(2589), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3298), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2747), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2748), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [96882] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3836), 1,
      anon_sym_fn,
    ACTIONS(3840), 1,
      anon_sym_struct,
    ACTIONS(3850), 1,
      anon_sym_shared,
    ACTIONS(3854), 1,
      anon_sym_chan,
    ACTIONS(3856), 1,
      anon_sym_thread,
    ACTIONS(3858), 1,
      anon_sym_atomic,
    ACTIONS(6083), 1,
      anon_sym_LPAREN,
    ACTIONS(6085), 1,
      anon_sym_STAR,
    ACTIONS(6087), 1,
      anon_sym_QMARK,
    ACTIONS(6089), 1,
      anon_sym_BANG,
    ACTIONS(6091), 1,
      anon_sym_LBRACK2,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_map_LBRACK,
    STATE(1534), 1,
      sym_plain_type,
    STATE(4507), 1,
      sym_reference_expression,
    STATE(1426), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3299), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1528), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1529), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [96965] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4895), 1,
      sym_identifier,
    ACTIONS(4897), 1,
      anon_sym_LPAREN,
    ACTIONS(4899), 1,
      anon_sym_fn,
    ACTIONS(4901), 1,
      anon_sym_STAR,
    ACTIONS(4903), 1,
      anon_sym_struct,
    ACTIONS(4913), 1,
      anon_sym_shared,
    ACTIONS(4915), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4917), 1,
      anon_sym_chan,
    ACTIONS(4919), 1,
      anon_sym_thread,
    ACTIONS(4921), 1,
      anon_sym_atomic,
    ACTIONS(6125), 1,
      anon_sym_QMARK,
    ACTIONS(6127), 1,
      anon_sym_BANG,
    ACTIONS(6129), 1,
      anon_sym_LBRACK2,
    ACTIONS(6131), 1,
      anon_sym_AMP,
    STATE(2775), 1,
      sym_plain_type,
    STATE(4553), 1,
      sym_reference_expression,
    STATE(2589), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3300), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2747), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2748), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [97048] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3406), 1,
      sym_identifier,
    ACTIONS(3410), 1,
      anon_sym_fn,
    ACTIONS(3414), 1,
      anon_sym_struct,
    ACTIONS(3424), 1,
      anon_sym_shared,
    ACTIONS(3428), 1,
      anon_sym_chan,
    ACTIONS(3430), 1,
      anon_sym_thread,
    ACTIONS(3432), 1,
      anon_sym_atomic,
    ACTIONS(6017), 1,
      anon_sym_LPAREN,
    ACTIONS(6019), 1,
      anon_sym_STAR,
    ACTIONS(6021), 1,
      anon_sym_QMARK,
    ACTIONS(6023), 1,
      anon_sym_BANG,
    ACTIONS(6025), 1,
      anon_sym_LBRACK2,
    ACTIONS(6027), 1,
      anon_sym_AMP,
    ACTIONS(6029), 1,
      anon_sym_map_LBRACK,
    STATE(1383), 1,
      sym_plain_type,
    STATE(4486), 1,
      sym_reference_expression,
    STATE(1298), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3301), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1327), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1324), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [97131] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1754), 1,
      sym_identifier,
    ACTIONS(1758), 1,
      anon_sym_fn,
    ACTIONS(1762), 1,
      anon_sym_struct,
    ACTIONS(1772), 1,
      anon_sym_shared,
    ACTIONS(1776), 1,
      anon_sym_chan,
    ACTIONS(1778), 1,
      anon_sym_thread,
    ACTIONS(1780), 1,
      anon_sym_atomic,
    ACTIONS(6111), 1,
      anon_sym_LPAREN,
    ACTIONS(6113), 1,
      anon_sym_STAR,
    ACTIONS(6115), 1,
      anon_sym_QMARK,
    ACTIONS(6117), 1,
      anon_sym_BANG,
    ACTIONS(6119), 1,
      anon_sym_LBRACK2,
    ACTIONS(6121), 1,
      anon_sym_AMP,
    ACTIONS(6123), 1,
      anon_sym_map_LBRACK,
    STATE(1224), 1,
      sym_plain_type,
    STATE(4444), 1,
      sym_reference_expression,
    STATE(1148), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3302), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1214), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1215), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [97214] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1754), 1,
      sym_identifier,
    ACTIONS(1758), 1,
      anon_sym_fn,
    ACTIONS(1762), 1,
      anon_sym_struct,
    ACTIONS(1772), 1,
      anon_sym_shared,
    ACTIONS(1776), 1,
      anon_sym_chan,
    ACTIONS(1778), 1,
      anon_sym_thread,
    ACTIONS(1780), 1,
      anon_sym_atomic,
    ACTIONS(6111), 1,
      anon_sym_LPAREN,
    ACTIONS(6113), 1,
      anon_sym_STAR,
    ACTIONS(6115), 1,
      anon_sym_QMARK,
    ACTIONS(6117), 1,
      anon_sym_BANG,
    ACTIONS(6119), 1,
      anon_sym_LBRACK2,
    ACTIONS(6121), 1,
      anon_sym_AMP,
    ACTIONS(6123), 1,
      anon_sym_map_LBRACK,
    STATE(1260), 1,
      sym_plain_type,
    STATE(4444), 1,
      sym_reference_expression,
    STATE(1148), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3303), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1214), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1215), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [97297] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1754), 1,
      sym_identifier,
    ACTIONS(1758), 1,
      anon_sym_fn,
    ACTIONS(1762), 1,
      anon_sym_struct,
    ACTIONS(1772), 1,
      anon_sym_shared,
    ACTIONS(1776), 1,
      anon_sym_chan,
    ACTIONS(1778), 1,
      anon_sym_thread,
    ACTIONS(1780), 1,
      anon_sym_atomic,
    ACTIONS(6111), 1,
      anon_sym_LPAREN,
    ACTIONS(6113), 1,
      anon_sym_STAR,
    ACTIONS(6115), 1,
      anon_sym_QMARK,
    ACTIONS(6117), 1,
      anon_sym_BANG,
    ACTIONS(6119), 1,
      anon_sym_LBRACK2,
    ACTIONS(6121), 1,
      anon_sym_AMP,
    ACTIONS(6123), 1,
      anon_sym_map_LBRACK,
    STATE(1201), 1,
      sym_plain_type,
    STATE(4444), 1,
      sym_reference_expression,
    STATE(1148), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3304), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1214), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1215), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [97380] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(4357), 1,
      sym_identifier,
    ACTIONS(4359), 1,
      anon_sym_fn,
    ACTIONS(4361), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_shared,
    ACTIONS(4373), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4375), 1,
      anon_sym_chan,
    ACTIONS(4377), 1,
      anon_sym_thread,
    ACTIONS(4379), 1,
      anon_sym_atomic,
    ACTIONS(6053), 1,
      anon_sym_QMARK,
    ACTIONS(6055), 1,
      anon_sym_BANG,
    ACTIONS(6057), 1,
      anon_sym_LBRACK2,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    STATE(2422), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2395), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3305), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [97463] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4895), 1,
      sym_identifier,
    ACTIONS(4897), 1,
      anon_sym_LPAREN,
    ACTIONS(4899), 1,
      anon_sym_fn,
    ACTIONS(4901), 1,
      anon_sym_STAR,
    ACTIONS(4903), 1,
      anon_sym_struct,
    ACTIONS(4913), 1,
      anon_sym_shared,
    ACTIONS(4915), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4917), 1,
      anon_sym_chan,
    ACTIONS(4919), 1,
      anon_sym_thread,
    ACTIONS(4921), 1,
      anon_sym_atomic,
    ACTIONS(6125), 1,
      anon_sym_QMARK,
    ACTIONS(6127), 1,
      anon_sym_BANG,
    ACTIONS(6129), 1,
      anon_sym_LBRACK2,
    ACTIONS(6131), 1,
      anon_sym_AMP,
    STATE(2760), 1,
      sym_plain_type,
    STATE(4553), 1,
      sym_reference_expression,
    STATE(2589), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3306), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2747), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2748), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [97546] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1754), 1,
      sym_identifier,
    ACTIONS(1758), 1,
      anon_sym_fn,
    ACTIONS(1762), 1,
      anon_sym_struct,
    ACTIONS(1772), 1,
      anon_sym_shared,
    ACTIONS(1776), 1,
      anon_sym_chan,
    ACTIONS(1778), 1,
      anon_sym_thread,
    ACTIONS(1780), 1,
      anon_sym_atomic,
    ACTIONS(6111), 1,
      anon_sym_LPAREN,
    ACTIONS(6113), 1,
      anon_sym_STAR,
    ACTIONS(6115), 1,
      anon_sym_QMARK,
    ACTIONS(6117), 1,
      anon_sym_BANG,
    ACTIONS(6119), 1,
      anon_sym_LBRACK2,
    ACTIONS(6121), 1,
      anon_sym_AMP,
    ACTIONS(6123), 1,
      anon_sym_map_LBRACK,
    STATE(1198), 1,
      sym_plain_type,
    STATE(4444), 1,
      sym_reference_expression,
    STATE(1148), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3307), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1214), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1215), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [97629] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(4357), 1,
      sym_identifier,
    ACTIONS(4359), 1,
      anon_sym_fn,
    ACTIONS(4361), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_shared,
    ACTIONS(4373), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4375), 1,
      anon_sym_chan,
    ACTIONS(4377), 1,
      anon_sym_thread,
    ACTIONS(4379), 1,
      anon_sym_atomic,
    ACTIONS(6053), 1,
      anon_sym_QMARK,
    ACTIONS(6055), 1,
      anon_sym_BANG,
    ACTIONS(6057), 1,
      anon_sym_LBRACK2,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    STATE(2493), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2395), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3308), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [97712] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4190), 1,
      sym_identifier,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_fn,
    ACTIONS(4198), 1,
      anon_sym_struct,
    ACTIONS(4208), 1,
      anon_sym_shared,
    ACTIONS(4210), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4212), 1,
      anon_sym_chan,
    ACTIONS(4214), 1,
      anon_sym_thread,
    ACTIONS(4216), 1,
      anon_sym_atomic,
    ACTIONS(6007), 1,
      anon_sym_STAR,
    ACTIONS(6009), 1,
      anon_sym_QMARK,
    ACTIONS(6011), 1,
      anon_sym_BANG,
    ACTIONS(6013), 1,
      anon_sym_LBRACK2,
    ACTIONS(6015), 1,
      anon_sym_AMP,
    STATE(2127), 1,
      sym_plain_type,
    STATE(4528), 1,
      sym_reference_expression,
    STATE(2017), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3309), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2110), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2111), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [97795] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(4357), 1,
      sym_identifier,
    ACTIONS(4359), 1,
      anon_sym_fn,
    ACTIONS(4361), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_shared,
    ACTIONS(4373), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4375), 1,
      anon_sym_chan,
    ACTIONS(4377), 1,
      anon_sym_thread,
    ACTIONS(4379), 1,
      anon_sym_atomic,
    ACTIONS(6053), 1,
      anon_sym_QMARK,
    ACTIONS(6055), 1,
      anon_sym_BANG,
    ACTIONS(6057), 1,
      anon_sym_LBRACK2,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    STATE(2485), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2395), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3310), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [97878] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3836), 1,
      anon_sym_fn,
    ACTIONS(3840), 1,
      anon_sym_struct,
    ACTIONS(3850), 1,
      anon_sym_shared,
    ACTIONS(3854), 1,
      anon_sym_chan,
    ACTIONS(3856), 1,
      anon_sym_thread,
    ACTIONS(3858), 1,
      anon_sym_atomic,
    ACTIONS(6083), 1,
      anon_sym_LPAREN,
    ACTIONS(6085), 1,
      anon_sym_STAR,
    ACTIONS(6087), 1,
      anon_sym_QMARK,
    ACTIONS(6089), 1,
      anon_sym_BANG,
    ACTIONS(6091), 1,
      anon_sym_LBRACK2,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_map_LBRACK,
    STATE(1519), 1,
      sym_plain_type,
    STATE(4507), 1,
      sym_reference_expression,
    STATE(1426), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3311), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1528), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1529), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [97961] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(3808), 1,
      anon_sym_fn,
    ACTIONS(3812), 1,
      anon_sym_struct,
    ACTIONS(3822), 1,
      anon_sym_shared,
    ACTIONS(3826), 1,
      anon_sym_chan,
    ACTIONS(3828), 1,
      anon_sym_thread,
    ACTIONS(3830), 1,
      anon_sym_atomic,
    ACTIONS(6133), 1,
      anon_sym_LPAREN,
    ACTIONS(6135), 1,
      anon_sym_STAR,
    ACTIONS(6137), 1,
      anon_sym_QMARK,
    ACTIONS(6139), 1,
      anon_sym_BANG,
    ACTIONS(6141), 1,
      anon_sym_LBRACK2,
    ACTIONS(6143), 1,
      anon_sym_AMP,
    ACTIONS(6145), 1,
      anon_sym_map_LBRACK,
    STATE(3466), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(3312), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3458), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(3459), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [98044] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(4357), 1,
      sym_identifier,
    ACTIONS(4359), 1,
      anon_sym_fn,
    ACTIONS(4361), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_shared,
    ACTIONS(4373), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4375), 1,
      anon_sym_chan,
    ACTIONS(4377), 1,
      anon_sym_thread,
    ACTIONS(4379), 1,
      anon_sym_atomic,
    ACTIONS(6053), 1,
      anon_sym_QMARK,
    ACTIONS(6055), 1,
      anon_sym_BANG,
    ACTIONS(6057), 1,
      anon_sym_LBRACK2,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    STATE(2495), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2395), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3313), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [98127] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4895), 1,
      sym_identifier,
    ACTIONS(4897), 1,
      anon_sym_LPAREN,
    ACTIONS(4899), 1,
      anon_sym_fn,
    ACTIONS(4901), 1,
      anon_sym_STAR,
    ACTIONS(4903), 1,
      anon_sym_struct,
    ACTIONS(4913), 1,
      anon_sym_shared,
    ACTIONS(4915), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4917), 1,
      anon_sym_chan,
    ACTIONS(4919), 1,
      anon_sym_thread,
    ACTIONS(4921), 1,
      anon_sym_atomic,
    ACTIONS(6125), 1,
      anon_sym_QMARK,
    ACTIONS(6127), 1,
      anon_sym_BANG,
    ACTIONS(6129), 1,
      anon_sym_LBRACK2,
    ACTIONS(6131), 1,
      anon_sym_AMP,
    STATE(2776), 1,
      sym_plain_type,
    STATE(4553), 1,
      sym_reference_expression,
    STATE(2589), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3314), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2747), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2748), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [98210] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4066), 1,
      sym_identifier,
    ACTIONS(4070), 1,
      anon_sym_fn,
    ACTIONS(4074), 1,
      anon_sym_struct,
    ACTIONS(4084), 1,
      anon_sym_shared,
    ACTIONS(4088), 1,
      anon_sym_chan,
    ACTIONS(4090), 1,
      anon_sym_thread,
    ACTIONS(4092), 1,
      anon_sym_atomic,
    ACTIONS(5897), 1,
      anon_sym_LPAREN,
    ACTIONS(5901), 1,
      anon_sym_STAR,
    ACTIONS(5903), 1,
      anon_sym_QMARK,
    ACTIONS(5905), 1,
      anon_sym_BANG,
    ACTIONS(5907), 1,
      anon_sym_LBRACK2,
    ACTIONS(5909), 1,
      anon_sym_AMP,
    ACTIONS(5911), 1,
      anon_sym_map_LBRACK,
    STATE(1819), 1,
      sym_plain_type,
    STATE(4601), 1,
      sym_reference_expression,
    STATE(1730), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3315), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1875), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1881), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [98293] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(819), 1,
      sym_identifier,
    ACTIONS(825), 1,
      anon_sym_fn,
    ACTIONS(829), 1,
      anon_sym_struct,
    ACTIONS(839), 1,
      anon_sym_shared,
    ACTIONS(843), 1,
      anon_sym_chan,
    ACTIONS(845), 1,
      anon_sym_thread,
    ACTIONS(847), 1,
      anon_sym_atomic,
    ACTIONS(6039), 1,
      anon_sym_LPAREN,
    ACTIONS(6041), 1,
      anon_sym_STAR,
    ACTIONS(6043), 1,
      anon_sym_QMARK,
    ACTIONS(6045), 1,
      anon_sym_BANG,
    ACTIONS(6047), 1,
      anon_sym_LBRACK2,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_map_LBRACK,
    STATE(388), 1,
      sym_plain_type,
    STATE(4523), 1,
      sym_reference_expression,
    STATE(291), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3316), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(429), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(442), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [98376] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3836), 1,
      anon_sym_fn,
    ACTIONS(3840), 1,
      anon_sym_struct,
    ACTIONS(3850), 1,
      anon_sym_shared,
    ACTIONS(3854), 1,
      anon_sym_chan,
    ACTIONS(3856), 1,
      anon_sym_thread,
    ACTIONS(3858), 1,
      anon_sym_atomic,
    ACTIONS(6083), 1,
      anon_sym_LPAREN,
    ACTIONS(6085), 1,
      anon_sym_STAR,
    ACTIONS(6087), 1,
      anon_sym_QMARK,
    ACTIONS(6089), 1,
      anon_sym_BANG,
    ACTIONS(6091), 1,
      anon_sym_LBRACK2,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_map_LBRACK,
    STATE(1455), 1,
      sym_plain_type,
    STATE(4507), 1,
      sym_reference_expression,
    STATE(1426), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3317), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1528), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1529), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [98459] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(4357), 1,
      sym_identifier,
    ACTIONS(4359), 1,
      anon_sym_fn,
    ACTIONS(4361), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_shared,
    ACTIONS(4373), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4375), 1,
      anon_sym_chan,
    ACTIONS(4377), 1,
      anon_sym_thread,
    ACTIONS(4379), 1,
      anon_sym_atomic,
    ACTIONS(6053), 1,
      anon_sym_QMARK,
    ACTIONS(6055), 1,
      anon_sym_BANG,
    ACTIONS(6057), 1,
      anon_sym_LBRACK2,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    STATE(2455), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2395), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3318), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [98542] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(4662), 1,
      sym_plain_type,
    STATE(3319), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [98625] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(3917), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3320), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [98708] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4895), 1,
      sym_identifier,
    ACTIONS(4897), 1,
      anon_sym_LPAREN,
    ACTIONS(4899), 1,
      anon_sym_fn,
    ACTIONS(4901), 1,
      anon_sym_STAR,
    ACTIONS(4903), 1,
      anon_sym_struct,
    ACTIONS(4913), 1,
      anon_sym_shared,
    ACTIONS(4915), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4917), 1,
      anon_sym_chan,
    ACTIONS(4919), 1,
      anon_sym_thread,
    ACTIONS(4921), 1,
      anon_sym_atomic,
    ACTIONS(6125), 1,
      anon_sym_QMARK,
    ACTIONS(6127), 1,
      anon_sym_BANG,
    ACTIONS(6129), 1,
      anon_sym_LBRACK2,
    ACTIONS(6131), 1,
      anon_sym_AMP,
    STATE(2706), 1,
      sym_plain_type,
    STATE(4553), 1,
      sym_reference_expression,
    STATE(2589), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3321), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2747), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2748), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [98791] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3836), 1,
      anon_sym_fn,
    ACTIONS(3840), 1,
      anon_sym_struct,
    ACTIONS(3850), 1,
      anon_sym_shared,
    ACTIONS(3854), 1,
      anon_sym_chan,
    ACTIONS(3856), 1,
      anon_sym_thread,
    ACTIONS(3858), 1,
      anon_sym_atomic,
    ACTIONS(6083), 1,
      anon_sym_LPAREN,
    ACTIONS(6085), 1,
      anon_sym_STAR,
    ACTIONS(6087), 1,
      anon_sym_QMARK,
    ACTIONS(6089), 1,
      anon_sym_BANG,
    ACTIONS(6091), 1,
      anon_sym_LBRACK2,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_map_LBRACK,
    STATE(1451), 1,
      sym_plain_type,
    STATE(4507), 1,
      sym_reference_expression,
    STATE(1426), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3322), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1528), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1529), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [98874] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(4357), 1,
      sym_identifier,
    ACTIONS(4359), 1,
      anon_sym_fn,
    ACTIONS(4361), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_shared,
    ACTIONS(4373), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4375), 1,
      anon_sym_chan,
    ACTIONS(4377), 1,
      anon_sym_thread,
    ACTIONS(4379), 1,
      anon_sym_atomic,
    ACTIONS(6053), 1,
      anon_sym_QMARK,
    ACTIONS(6055), 1,
      anon_sym_BANG,
    ACTIONS(6057), 1,
      anon_sym_LBRACK2,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    STATE(2458), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2395), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3323), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [98957] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(3808), 1,
      anon_sym_fn,
    ACTIONS(3812), 1,
      anon_sym_struct,
    ACTIONS(3822), 1,
      anon_sym_shared,
    ACTIONS(3826), 1,
      anon_sym_chan,
    ACTIONS(3828), 1,
      anon_sym_thread,
    ACTIONS(3830), 1,
      anon_sym_atomic,
    ACTIONS(6133), 1,
      anon_sym_LPAREN,
    ACTIONS(6135), 1,
      anon_sym_STAR,
    ACTIONS(6137), 1,
      anon_sym_QMARK,
    ACTIONS(6139), 1,
      anon_sym_BANG,
    ACTIONS(6141), 1,
      anon_sym_LBRACK2,
    ACTIONS(6143), 1,
      anon_sym_AMP,
    ACTIONS(6145), 1,
      anon_sym_map_LBRACK,
    STATE(3464), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(3324), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3458), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(3459), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [99040] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4895), 1,
      sym_identifier,
    ACTIONS(4897), 1,
      anon_sym_LPAREN,
    ACTIONS(4899), 1,
      anon_sym_fn,
    ACTIONS(4901), 1,
      anon_sym_STAR,
    ACTIONS(4903), 1,
      anon_sym_struct,
    ACTIONS(4913), 1,
      anon_sym_shared,
    ACTIONS(4915), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4917), 1,
      anon_sym_chan,
    ACTIONS(4919), 1,
      anon_sym_thread,
    ACTIONS(4921), 1,
      anon_sym_atomic,
    ACTIONS(6125), 1,
      anon_sym_QMARK,
    ACTIONS(6127), 1,
      anon_sym_BANG,
    ACTIONS(6129), 1,
      anon_sym_LBRACK2,
    ACTIONS(6131), 1,
      anon_sym_AMP,
    STATE(2787), 1,
      sym_plain_type,
    STATE(4553), 1,
      sym_reference_expression,
    STATE(2589), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3325), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2747), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2748), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [99123] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(3896), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3326), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [99206] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(3808), 1,
      anon_sym_fn,
    ACTIONS(3812), 1,
      anon_sym_struct,
    ACTIONS(3822), 1,
      anon_sym_shared,
    ACTIONS(3826), 1,
      anon_sym_chan,
    ACTIONS(3828), 1,
      anon_sym_thread,
    ACTIONS(3830), 1,
      anon_sym_atomic,
    ACTIONS(6133), 1,
      anon_sym_LPAREN,
    ACTIONS(6135), 1,
      anon_sym_STAR,
    ACTIONS(6137), 1,
      anon_sym_QMARK,
    ACTIONS(6139), 1,
      anon_sym_BANG,
    ACTIONS(6141), 1,
      anon_sym_LBRACK2,
    ACTIONS(6143), 1,
      anon_sym_AMP,
    ACTIONS(6145), 1,
      anon_sym_map_LBRACK,
    STATE(3469), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(3327), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3458), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(3459), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [99289] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1754), 1,
      sym_identifier,
    ACTIONS(1758), 1,
      anon_sym_fn,
    ACTIONS(1762), 1,
      anon_sym_struct,
    ACTIONS(1772), 1,
      anon_sym_shared,
    ACTIONS(1776), 1,
      anon_sym_chan,
    ACTIONS(1778), 1,
      anon_sym_thread,
    ACTIONS(1780), 1,
      anon_sym_atomic,
    ACTIONS(6111), 1,
      anon_sym_LPAREN,
    ACTIONS(6113), 1,
      anon_sym_STAR,
    ACTIONS(6115), 1,
      anon_sym_QMARK,
    ACTIONS(6117), 1,
      anon_sym_BANG,
    ACTIONS(6119), 1,
      anon_sym_LBRACK2,
    ACTIONS(6121), 1,
      anon_sym_AMP,
    ACTIONS(6123), 1,
      anon_sym_map_LBRACK,
    STATE(1222), 1,
      sym_plain_type,
    STATE(4444), 1,
      sym_reference_expression,
    STATE(1148), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3328), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1214), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1215), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [99372] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4895), 1,
      sym_identifier,
    ACTIONS(4897), 1,
      anon_sym_LPAREN,
    ACTIONS(4899), 1,
      anon_sym_fn,
    ACTIONS(4901), 1,
      anon_sym_STAR,
    ACTIONS(4903), 1,
      anon_sym_struct,
    ACTIONS(4913), 1,
      anon_sym_shared,
    ACTIONS(4915), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4917), 1,
      anon_sym_chan,
    ACTIONS(4919), 1,
      anon_sym_thread,
    ACTIONS(4921), 1,
      anon_sym_atomic,
    ACTIONS(6125), 1,
      anon_sym_QMARK,
    ACTIONS(6127), 1,
      anon_sym_BANG,
    ACTIONS(6129), 1,
      anon_sym_LBRACK2,
    ACTIONS(6131), 1,
      anon_sym_AMP,
    STATE(2789), 1,
      sym_plain_type,
    STATE(4553), 1,
      sym_reference_expression,
    STATE(2589), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3329), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2747), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2748), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [99455] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4066), 1,
      sym_identifier,
    ACTIONS(4070), 1,
      anon_sym_fn,
    ACTIONS(4074), 1,
      anon_sym_struct,
    ACTIONS(4084), 1,
      anon_sym_shared,
    ACTIONS(4088), 1,
      anon_sym_chan,
    ACTIONS(4090), 1,
      anon_sym_thread,
    ACTIONS(4092), 1,
      anon_sym_atomic,
    ACTIONS(5897), 1,
      anon_sym_LPAREN,
    ACTIONS(5901), 1,
      anon_sym_STAR,
    ACTIONS(5903), 1,
      anon_sym_QMARK,
    ACTIONS(5905), 1,
      anon_sym_BANG,
    ACTIONS(5907), 1,
      anon_sym_LBRACK2,
    ACTIONS(5909), 1,
      anon_sym_AMP,
    ACTIONS(5911), 1,
      anon_sym_map_LBRACK,
    STATE(1779), 1,
      sym_plain_type,
    STATE(4601), 1,
      sym_reference_expression,
    STATE(1730), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3330), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1875), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1881), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [99538] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(3808), 1,
      anon_sym_fn,
    ACTIONS(3812), 1,
      anon_sym_struct,
    ACTIONS(3822), 1,
      anon_sym_shared,
    ACTIONS(3826), 1,
      anon_sym_chan,
    ACTIONS(3828), 1,
      anon_sym_thread,
    ACTIONS(3830), 1,
      anon_sym_atomic,
    ACTIONS(6133), 1,
      anon_sym_LPAREN,
    ACTIONS(6135), 1,
      anon_sym_STAR,
    ACTIONS(6137), 1,
      anon_sym_QMARK,
    ACTIONS(6139), 1,
      anon_sym_BANG,
    ACTIONS(6141), 1,
      anon_sym_LBRACK2,
    ACTIONS(6143), 1,
      anon_sym_AMP,
    ACTIONS(6145), 1,
      anon_sym_map_LBRACK,
    STATE(3465), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(3331), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3458), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(3459), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [99621] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(4357), 1,
      sym_identifier,
    ACTIONS(4359), 1,
      anon_sym_fn,
    ACTIONS(4361), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_shared,
    ACTIONS(4373), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4375), 1,
      anon_sym_chan,
    ACTIONS(4377), 1,
      anon_sym_thread,
    ACTIONS(4379), 1,
      anon_sym_atomic,
    ACTIONS(6053), 1,
      anon_sym_QMARK,
    ACTIONS(6055), 1,
      anon_sym_BANG,
    ACTIONS(6057), 1,
      anon_sym_LBRACK2,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    STATE(2484), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2395), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3332), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [99704] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(4357), 1,
      sym_identifier,
    ACTIONS(4359), 1,
      anon_sym_fn,
    ACTIONS(4361), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_shared,
    ACTIONS(4373), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4375), 1,
      anon_sym_chan,
    ACTIONS(4377), 1,
      anon_sym_thread,
    ACTIONS(4379), 1,
      anon_sym_atomic,
    ACTIONS(6053), 1,
      anon_sym_QMARK,
    ACTIONS(6055), 1,
      anon_sym_BANG,
    ACTIONS(6057), 1,
      anon_sym_LBRACK2,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    STATE(2483), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(2395), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3333), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [99787] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(3808), 1,
      anon_sym_fn,
    ACTIONS(3812), 1,
      anon_sym_struct,
    ACTIONS(3822), 1,
      anon_sym_shared,
    ACTIONS(3826), 1,
      anon_sym_chan,
    ACTIONS(3828), 1,
      anon_sym_thread,
    ACTIONS(3830), 1,
      anon_sym_atomic,
    ACTIONS(6133), 1,
      anon_sym_LPAREN,
    ACTIONS(6135), 1,
      anon_sym_STAR,
    ACTIONS(6137), 1,
      anon_sym_QMARK,
    ACTIONS(6139), 1,
      anon_sym_BANG,
    ACTIONS(6141), 1,
      anon_sym_LBRACK2,
    ACTIONS(6143), 1,
      anon_sym_AMP,
    ACTIONS(6145), 1,
      anon_sym_map_LBRACK,
    STATE(3463), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(3334), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3458), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(3459), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [99870] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3940), 1,
      sym_identifier,
    ACTIONS(3942), 1,
      anon_sym_LPAREN,
    ACTIONS(3944), 1,
      anon_sym_fn,
    ACTIONS(3946), 1,
      anon_sym_STAR,
    ACTIONS(3948), 1,
      anon_sym_struct,
    ACTIONS(3958), 1,
      anon_sym_shared,
    ACTIONS(3960), 1,
      anon_sym_map_LBRACK,
    ACTIONS(3962), 1,
      anon_sym_chan,
    ACTIONS(3964), 1,
      anon_sym_thread,
    ACTIONS(3966), 1,
      anon_sym_atomic,
    ACTIONS(6031), 1,
      anon_sym_QMARK,
    ACTIONS(6033), 1,
      anon_sym_BANG,
    ACTIONS(6035), 1,
      anon_sym_LBRACK2,
    ACTIONS(6037), 1,
      anon_sym_AMP,
    STATE(1649), 1,
      sym_plain_type,
    STATE(4423), 1,
      sym_reference_expression,
    STATE(1563), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3335), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1655), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1657), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [99953] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(3808), 1,
      anon_sym_fn,
    ACTIONS(3812), 1,
      anon_sym_struct,
    ACTIONS(3822), 1,
      anon_sym_shared,
    ACTIONS(3826), 1,
      anon_sym_chan,
    ACTIONS(3828), 1,
      anon_sym_thread,
    ACTIONS(3830), 1,
      anon_sym_atomic,
    ACTIONS(6133), 1,
      anon_sym_LPAREN,
    ACTIONS(6135), 1,
      anon_sym_STAR,
    ACTIONS(6137), 1,
      anon_sym_QMARK,
    ACTIONS(6139), 1,
      anon_sym_BANG,
    ACTIONS(6141), 1,
      anon_sym_LBRACK2,
    ACTIONS(6143), 1,
      anon_sym_AMP,
    ACTIONS(6145), 1,
      anon_sym_map_LBRACK,
    STATE(3467), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(3336), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3458), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(3459), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [100036] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(3808), 1,
      anon_sym_fn,
    ACTIONS(3812), 1,
      anon_sym_struct,
    ACTIONS(3822), 1,
      anon_sym_shared,
    ACTIONS(3826), 1,
      anon_sym_chan,
    ACTIONS(3828), 1,
      anon_sym_thread,
    ACTIONS(3830), 1,
      anon_sym_atomic,
    ACTIONS(6133), 1,
      anon_sym_LPAREN,
    ACTIONS(6135), 1,
      anon_sym_STAR,
    ACTIONS(6137), 1,
      anon_sym_QMARK,
    ACTIONS(6139), 1,
      anon_sym_BANG,
    ACTIONS(6141), 1,
      anon_sym_LBRACK2,
    ACTIONS(6143), 1,
      anon_sym_AMP,
    ACTIONS(6145), 1,
      anon_sym_map_LBRACK,
    STATE(3474), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(3337), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3458), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(3459), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [100119] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(3808), 1,
      anon_sym_fn,
    ACTIONS(3812), 1,
      anon_sym_struct,
    ACTIONS(3822), 1,
      anon_sym_shared,
    ACTIONS(3826), 1,
      anon_sym_chan,
    ACTIONS(3828), 1,
      anon_sym_thread,
    ACTIONS(3830), 1,
      anon_sym_atomic,
    ACTIONS(6133), 1,
      anon_sym_LPAREN,
    ACTIONS(6135), 1,
      anon_sym_STAR,
    ACTIONS(6137), 1,
      anon_sym_QMARK,
    ACTIONS(6139), 1,
      anon_sym_BANG,
    ACTIONS(6141), 1,
      anon_sym_LBRACK2,
    ACTIONS(6143), 1,
      anon_sym_AMP,
    ACTIONS(6145), 1,
      anon_sym_map_LBRACK,
    STATE(3473), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(3338), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3458), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(3459), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [100202] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3804), 1,
      sym_identifier,
    ACTIONS(3808), 1,
      anon_sym_fn,
    ACTIONS(3812), 1,
      anon_sym_struct,
    ACTIONS(3822), 1,
      anon_sym_shared,
    ACTIONS(3826), 1,
      anon_sym_chan,
    ACTIONS(3828), 1,
      anon_sym_thread,
    ACTIONS(3830), 1,
      anon_sym_atomic,
    ACTIONS(6133), 1,
      anon_sym_LPAREN,
    ACTIONS(6135), 1,
      anon_sym_STAR,
    ACTIONS(6137), 1,
      anon_sym_QMARK,
    ACTIONS(6139), 1,
      anon_sym_BANG,
    ACTIONS(6141), 1,
      anon_sym_LBRACK2,
    ACTIONS(6143), 1,
      anon_sym_AMP,
    ACTIONS(6145), 1,
      anon_sym_map_LBRACK,
    STATE(3471), 1,
      sym_plain_type,
    STATE(4454), 1,
      sym_reference_expression,
    STATE(3339), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3423), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3458), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(3459), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [100285] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4066), 1,
      sym_identifier,
    ACTIONS(4070), 1,
      anon_sym_fn,
    ACTIONS(4074), 1,
      anon_sym_struct,
    ACTIONS(4084), 1,
      anon_sym_shared,
    ACTIONS(4088), 1,
      anon_sym_chan,
    ACTIONS(4090), 1,
      anon_sym_thread,
    ACTIONS(4092), 1,
      anon_sym_atomic,
    ACTIONS(5897), 1,
      anon_sym_LPAREN,
    ACTIONS(5901), 1,
      anon_sym_STAR,
    ACTIONS(5903), 1,
      anon_sym_QMARK,
    ACTIONS(5905), 1,
      anon_sym_BANG,
    ACTIONS(5907), 1,
      anon_sym_LBRACK2,
    ACTIONS(5909), 1,
      anon_sym_AMP,
    ACTIONS(5911), 1,
      anon_sym_map_LBRACK,
    STATE(1903), 1,
      sym_plain_type,
    STATE(4601), 1,
      sym_reference_expression,
    STATE(1730), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3340), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1875), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1881), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [100368] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4150), 1,
      sym_identifier,
    ACTIONS(4152), 1,
      anon_sym_LPAREN,
    ACTIONS(4154), 1,
      anon_sym_fn,
    ACTIONS(4158), 1,
      anon_sym_struct,
    ACTIONS(4168), 1,
      anon_sym_shared,
    ACTIONS(4170), 1,
      anon_sym_map_LBRACK,
    ACTIONS(4172), 1,
      anon_sym_chan,
    ACTIONS(4174), 1,
      anon_sym_thread,
    ACTIONS(4176), 1,
      anon_sym_atomic,
    ACTIONS(6073), 1,
      anon_sym_STAR,
    ACTIONS(6075), 1,
      anon_sym_QMARK,
    ACTIONS(6077), 1,
      anon_sym_BANG,
    ACTIONS(6079), 1,
      anon_sym_LBRACK2,
    ACTIONS(6081), 1,
      anon_sym_AMP,
    STATE(2036), 1,
      sym_plain_type,
    STATE(4465), 1,
      sym_reference_expression,
    STATE(2019), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3341), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2052), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2051), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [100451] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4001), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3342), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [100534] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(47), 1,
      anon_sym_QMARK,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5605), 1,
      anon_sym_BANG,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4150), 1,
      sym_plain_type,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3343), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2416), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [100617] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(819), 1,
      sym_identifier,
    ACTIONS(825), 1,
      anon_sym_fn,
    ACTIONS(829), 1,
      anon_sym_struct,
    ACTIONS(839), 1,
      anon_sym_shared,
    ACTIONS(843), 1,
      anon_sym_chan,
    ACTIONS(845), 1,
      anon_sym_thread,
    ACTIONS(847), 1,
      anon_sym_atomic,
    ACTIONS(6039), 1,
      anon_sym_LPAREN,
    ACTIONS(6041), 1,
      anon_sym_STAR,
    ACTIONS(6043), 1,
      anon_sym_QMARK,
    ACTIONS(6045), 1,
      anon_sym_BANG,
    ACTIONS(6047), 1,
      anon_sym_LBRACK2,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_map_LBRACK,
    STATE(457), 1,
      sym_plain_type,
    STATE(4523), 1,
      sym_reference_expression,
    STATE(291), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3344), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(429), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(442), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [100700] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4066), 1,
      sym_identifier,
    ACTIONS(4070), 1,
      anon_sym_fn,
    ACTIONS(4074), 1,
      anon_sym_struct,
    ACTIONS(4084), 1,
      anon_sym_shared,
    ACTIONS(4088), 1,
      anon_sym_chan,
    ACTIONS(4090), 1,
      anon_sym_thread,
    ACTIONS(4092), 1,
      anon_sym_atomic,
    ACTIONS(5897), 1,
      anon_sym_LPAREN,
    ACTIONS(5901), 1,
      anon_sym_STAR,
    ACTIONS(5903), 1,
      anon_sym_QMARK,
    ACTIONS(5905), 1,
      anon_sym_BANG,
    ACTIONS(5907), 1,
      anon_sym_LBRACK2,
    ACTIONS(5909), 1,
      anon_sym_AMP,
    ACTIONS(5911), 1,
      anon_sym_map_LBRACK,
    STATE(1807), 1,
      sym_plain_type,
    STATE(4601), 1,
      sym_reference_expression,
    STATE(1730), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3345), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1875), 4,
      sym__plain_type_without_special,
      sym_multi_return_type,
      sym_result_type,
      sym_option_type,
    STATE(1881), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [100783] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(4705), 1,
      sym__plain_type_without_special,
    STATE(3346), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [100851] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1965), 1,
      anon_sym_SQUOTE,
    ACTIONS(1967), 1,
      anon_sym_DQUOTE,
    ACTIONS(1969), 1,
      anon_sym_c_SQUOTE,
    ACTIONS(1971), 1,
      anon_sym_c_DQUOTE,
    ACTIONS(1973), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(1975), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(6147), 1,
      sym_identifier,
    ACTIONS(6149), 1,
      anon_sym_if,
    ACTIONS(6151), 1,
      anon_sym_unsafe,
    STATE(3944), 1,
      sym_reference_expression,
    STATE(3975), 1,
      sym_value_attribute,
    STATE(3976), 1,
      sym_attribute_expression,
    STATE(4285), 1,
      sym_literal,
    ACTIONS(1963), 2,
      sym_float_literal,
      sym_rune_literal,
    STATE(3347), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(4242), 2,
      sym_if_attribute,
      sym__plain_attribute,
    STATE(4244), 2,
      sym_literal_attribute,
      sym_key_value_attribute,
    STATE(2448), 3,
      sym_interpreted_string_literal,
      sym_c_string_literal,
      sym_raw_string_literal,
    ACTIONS(1947), 5,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      sym_int_literal,
  [100925] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4321), 1,
      sym__plain_type_without_special,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3348), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [100993] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4367), 1,
      sym__plain_type_without_special,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3349), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [101061] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4202), 1,
      sym__plain_type_without_special,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3350), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [101129] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4393), 1,
      sym__plain_type_without_special,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3351), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [101197] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4438), 1,
      sym__plain_type_without_special,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3352), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [101265] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4209), 1,
      sym__plain_type_without_special,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3353), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [101333] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4192), 1,
      sym__plain_type_without_special,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3354), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [101401] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1965), 1,
      anon_sym_SQUOTE,
    ACTIONS(1967), 1,
      anon_sym_DQUOTE,
    ACTIONS(1969), 1,
      anon_sym_c_SQUOTE,
    ACTIONS(1971), 1,
      anon_sym_c_DQUOTE,
    ACTIONS(1973), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(1975), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(6147), 1,
      sym_identifier,
    ACTIONS(6149), 1,
      anon_sym_if,
    ACTIONS(6151), 1,
      anon_sym_unsafe,
    STATE(3944), 1,
      sym_reference_expression,
    STATE(3975), 1,
      sym_value_attribute,
    STATE(4198), 1,
      sym_attribute_expression,
    STATE(4285), 1,
      sym_literal,
    ACTIONS(1963), 2,
      sym_float_literal,
      sym_rune_literal,
    STATE(3355), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(4242), 2,
      sym_if_attribute,
      sym__plain_attribute,
    STATE(4244), 2,
      sym_literal_attribute,
      sym_key_value_attribute,
    STATE(2448), 3,
      sym_interpreted_string_literal,
      sym_c_string_literal,
      sym_raw_string_literal,
    ACTIONS(1947), 5,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      sym_int_literal,
  [101475] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4290), 1,
      sym__plain_type_without_special,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3356), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [101543] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4347), 1,
      sym__plain_type_without_special,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3357), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [101611] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4364), 1,
      sym__plain_type_without_special,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3358), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [101679] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4369), 1,
      sym__plain_type_without_special,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3359), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [101747] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4211), 1,
      sym__plain_type_without_special,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3360), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [101815] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(97), 1,
      anon_sym_map_LBRACK,
    ACTIONS(99), 1,
      anon_sym_chan,
    ACTIONS(101), 1,
      anon_sym_thread,
    ACTIONS(103), 1,
      anon_sym_atomic,
    ACTIONS(863), 1,
      sym_identifier,
    ACTIONS(869), 1,
      anon_sym_fn,
    ACTIONS(873), 1,
      anon_sym_struct,
    ACTIONS(881), 1,
      anon_sym_shared,
    ACTIONS(3970), 1,
      anon_sym_STAR,
    ACTIONS(5607), 1,
      anon_sym_LBRACK2,
    ACTIONS(5609), 1,
      anon_sym_AMP,
    STATE(4175), 1,
      sym__plain_type_without_special,
    STATE(4609), 1,
      sym_reference_expression,
    STATE(3361), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3649), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(2417), 12,
      sym_anon_struct_type,
      sym_fixed_array_type,
      sym_array_type,
      sym_pointer_type,
      sym_wrong_pointer_type,
      sym_map_type,
      sym_channel_type,
      sym_shared_type,
      sym_thread_type,
      sym_atomic_type,
      sym_generic_type,
      sym_function_type,
  [101883] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5229), 1,
      anon_sym_LBRACK,
    ACTIONS(6153), 1,
      sym_identifier,
    ACTIONS(6155), 1,
      anon_sym_LPAREN,
    ACTIONS(6161), 1,
      anon_sym_LT2,
    ACTIONS(6163), 1,
      anon_sym_LBRACK2,
    STATE(3416), 1,
      sym_receiver,
    STATE(3540), 1,
      sym__function_name,
    STATE(3543), 1,
      sym_capture_list,
    STATE(3736), 1,
      sym_generic_parameters,
    STATE(4016), 1,
      sym_overridable_operator,
    STATE(4220), 1,
      sym_signature,
    STATE(4621), 1,
      sym_reference_expression,
    STATE(4629), 1,
      sym_static_receiver,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3362), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6159), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6157), 8,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [101952] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3363), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3055), 24,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_fn,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      sym_identifier,
      anon_sym_shared,
      anon_sym_map_LBRACK,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
      anon_sym_AT_LBRACK,
  [101989] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3364), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3049), 24,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_fn,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      sym_identifier,
      anon_sym_shared,
      anon_sym_map_LBRACK,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
      anon_sym_AT_LBRACK,
  [102026] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3365), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3350), 24,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_fn,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      sym_identifier,
      anon_sym_shared,
      anon_sym_map_LBRACK,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
      anon_sym_AT_LBRACK,
  [102063] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3366), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2669), 24,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_fn,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      sym_identifier,
      anon_sym_shared,
      anon_sym_map_LBRACK,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
      anon_sym_AT_LBRACK,
  [102100] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3367), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2985), 24,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_fn,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      sym_identifier,
      anon_sym_shared,
      anon_sym_map_LBRACK,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
      anon_sym_AT_LBRACK,
  [102137] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3368), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3049), 7,
      anon_sym_fn,
      anon_sym_struct,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
    ACTIONS(3047), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_map_LBRACK,
  [102170] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3369), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2985), 7,
      anon_sym_fn,
      anon_sym_struct,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
    ACTIONS(2983), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_map_LBRACK,
  [102203] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3370), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2669), 7,
      anon_sym_fn,
      anon_sym_struct,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
    ACTIONS(2667), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_map_LBRACK,
  [102236] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6153), 1,
      sym_identifier,
    ACTIONS(6165), 1,
      anon_sym_LPAREN,
    STATE(3443), 1,
      sym_receiver,
    STATE(3556), 1,
      sym__function_name,
    STATE(4016), 1,
      sym_overridable_operator,
    STATE(4621), 1,
      sym_reference_expression,
    STATE(4694), 1,
      sym_static_receiver,
    STATE(3371), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6159), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6157), 8,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [102283] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6153), 1,
      sym_identifier,
    ACTIONS(6165), 1,
      anon_sym_LPAREN,
    STATE(3442), 1,
      sym_receiver,
    STATE(3611), 1,
      sym__function_name,
    STATE(4016), 1,
      sym_overridable_operator,
    STATE(4561), 1,
      sym_static_receiver,
    STATE(4621), 1,
      sym_reference_expression,
    STATE(3372), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6159), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6157), 8,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [102330] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1965), 1,
      anon_sym_SQUOTE,
    ACTIONS(1967), 1,
      anon_sym_DQUOTE,
    ACTIONS(1969), 1,
      anon_sym_c_SQUOTE,
    ACTIONS(1971), 1,
      anon_sym_c_DQUOTE,
    ACTIONS(1973), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(1975), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(6167), 1,
      sym_identifier,
    STATE(4193), 1,
      sym_literal,
    ACTIONS(1963), 2,
      sym_float_literal,
      sym_rune_literal,
    STATE(3373), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2448), 3,
      sym_interpreted_string_literal,
      sym_c_string_literal,
      sym_raw_string_literal,
    ACTIONS(1947), 5,
      sym_none,
      sym_true,
      sym_false,
      sym_nil,
      sym_int_literal,
  [102381] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3374), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3350), 7,
      anon_sym_fn,
      anon_sym_struct,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
    ACTIONS(3348), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_map_LBRACK,
  [102414] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3375), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3055), 7,
      anon_sym_fn,
      anon_sym_struct,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
    ACTIONS(3053), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_map_LBRACK,
  [102447] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6153), 1,
      sym_identifier,
    ACTIONS(6165), 1,
      anon_sym_LPAREN,
    STATE(3441), 1,
      sym_receiver,
    STATE(3615), 1,
      sym__function_name,
    STATE(4016), 1,
      sym_overridable_operator,
    STATE(4546), 1,
      sym_static_receiver,
    STATE(4621), 1,
      sym_reference_expression,
    STATE(3376), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6159), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6157), 8,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [102494] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3377), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3908), 17,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [102524] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3378), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6169), 17,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_module,
      anon_sym_RBRACE,
      anon_sym_const,
      anon_sym___global,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [102554] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1993), 1,
      anon_sym_SEMI,
    STATE(4013), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(3379), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3908), 15,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [102588] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1993), 1,
      anon_sym_LBRACE,
    STATE(3941), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(3380), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3908), 15,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [102622] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3381), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6171), 17,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_module,
      anon_sym_RBRACE,
      anon_sym_const,
      anon_sym___global,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [102652] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6173), 1,
      anon_sym_static,
    ACTIONS(6175), 1,
      anon_sym_volatile,
    STATE(3382), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4959), 7,
      anon_sym_fn,
      anon_sym_struct,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
    ACTIONS(4961), 8,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_map_LBRACK,
  [102688] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6177), 1,
      anon_sym_COMMA,
    STATE(3389), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(3383), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3862), 14,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [102721] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6179), 1,
      anon_sym_volatile,
    STATE(3384), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5221), 7,
      anon_sym_fn,
      anon_sym_struct,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
    ACTIONS(5223), 8,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_map_LBRACK,
  [102754] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6181), 1,
      anon_sym_COMMA,
    STATE(3385), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_strictly_expression_list_repeat1,
    ACTIONS(3908), 14,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [102785] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5076), 1,
      anon_sym_COMMA,
    STATE(3389), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(3386), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3862), 14,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [102818] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5000), 1,
      anon_sym_COMMA,
    STATE(3389), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(3387), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3862), 14,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [102851] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5106), 1,
      anon_sym_COMMA,
    STATE(3391), 1,
      aux_sym_expression_without_blocks_list_repeat1,
    STATE(3388), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6184), 14,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [102884] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6186), 1,
      anon_sym_COMMA,
    STATE(3385), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(3389), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4424), 14,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [102917] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6188), 1,
      anon_sym_COMMA,
    STATE(3389), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(3390), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3862), 14,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_COLON_EQ,
  [102950] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6190), 1,
      anon_sym_COMMA,
    STATE(3391), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_expression_without_blocks_list_repeat1,
    ACTIONS(5153), 14,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [102981] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6193), 1,
      anon_sym_LBRACE,
    STATE(4663), 1,
      sym__select_arm_assignment_statement,
    STATE(3392), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6195), 13,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [103013] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3393), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5221), 7,
      anon_sym_fn,
      anon_sym_struct,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
    ACTIONS(5223), 8,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_map_LBRACK,
  [103043] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3394), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5247), 7,
      anon_sym_fn,
      anon_sym_struct,
      sym_identifier,
      anon_sym_shared,
      anon_sym_chan,
      anon_sym_thread,
      anon_sym_atomic,
    ACTIONS(5249), 8,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_LBRACK2,
      anon_sym_AMP,
      anon_sym_map_LBRACK,
  [103073] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6197), 1,
      sym_identifier,
    ACTIONS(6199), 1,
      anon_sym_RBRACE,
    STATE(3397), 1,
      aux_sym__interface_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3395), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3517), 3,
      sym_struct_field_scope,
      sym_struct_field_declaration,
      sym_interface_method_definition,
  [103121] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6201), 1,
      sym_identifier,
    ACTIONS(6204), 1,
      anon_sym_RBRACE,
    ACTIONS(6209), 1,
      anon_sym_pub,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(6206), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3396), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym__interface_body_repeat1,
    STATE(3517), 3,
      sym_struct_field_scope,
      sym_struct_field_declaration,
      sym_interface_method_definition,
  [103167] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6197), 1,
      sym_identifier,
    ACTIONS(6212), 1,
      anon_sym_RBRACE,
    STATE(3396), 1,
      aux_sym__interface_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3397), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3517), 3,
      sym_struct_field_scope,
      sym_struct_field_declaration,
      sym_interface_method_definition,
  [103215] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6216), 1,
      anon_sym_RBRACE,
    STATE(3444), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3398), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [103262] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2371), 1,
      anon_sym_LBRACK,
    STATE(3399), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2373), 13,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [103291] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6218), 1,
      anon_sym_RBRACE,
    STATE(3427), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3400), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [103338] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6220), 1,
      anon_sym_RBRACE,
    STATE(3438), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3401), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [103385] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6222), 1,
      sym_identifier,
    ACTIONS(6225), 1,
      anon_sym_RBRACE,
    ACTIONS(6230), 1,
      anon_sym_pub,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(6227), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
    STATE(3402), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym__struct_body_repeat1,
  [103430] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(949), 1,
      anon_sym_RBRACE,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    STATE(3420), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3403), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [103477] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6235), 1,
      anon_sym_COLON_EQ,
    STATE(3404), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6233), 13,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [103506] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6237), 1,
      anon_sym_RBRACE,
    STATE(3408), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3405), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [103553] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2175), 1,
      anon_sym_DOT,
    ACTIONS(2371), 1,
      anon_sym_LBRACK,
    STATE(3406), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2373), 12,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [103584] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3407), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6239), 3,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    ACTIONS(6241), 11,
      anon_sym_module,
      anon_sym_const,
      anon_sym___global,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_pub,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_LBRACK2,
      anon_sym_AT_LBRACK,
  [103613] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6243), 1,
      anon_sym_RBRACE,
    STATE(3402), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3408), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [103660] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6245), 1,
      anon_sym_RBRACE,
    STATE(3419), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3409), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [103707] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6247), 1,
      anon_sym_RBRACE,
    STATE(3425), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3410), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [103754] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6249), 1,
      anon_sym_RBRACE,
    STATE(3402), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3411), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [103801] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6251), 1,
      anon_sym_RBRACE,
    STATE(3402), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3412), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [103848] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6253), 1,
      anon_sym_RBRACE,
    STATE(3414), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3413), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [103895] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6255), 1,
      anon_sym_RBRACE,
    STATE(3402), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3414), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [103942] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6257), 1,
      anon_sym_RBRACE,
    STATE(3435), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3415), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [103989] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6259), 1,
      sym_identifier,
    STATE(3610), 1,
      sym__function_name,
    STATE(4016), 1,
      sym_overridable_operator,
    STATE(3416), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6159), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6157), 8,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [104024] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6261), 1,
      anon_sym_RBRACE,
    STATE(3412), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3417), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [104071] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6263), 1,
      anon_sym_RBRACE,
    STATE(3402), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3418), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [104118] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6265), 1,
      anon_sym_RBRACE,
    STATE(3402), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3419), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [104165] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6267), 1,
      anon_sym_RBRACE,
    STATE(3402), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3420), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [104212] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6269), 1,
      anon_sym_RBRACE,
    STATE(3402), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3421), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [104259] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6271), 1,
      anon_sym_RBRACE,
    STATE(3411), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3422), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [104306] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6273), 1,
      anon_sym_LBRACK,
    STATE(3448), 1,
      sym_type_parameters,
    STATE(3423), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2187), 12,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [104337] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2455), 1,
      anon_sym_LBRACK,
    STATE(3424), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2457), 13,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [104366] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6275), 1,
      anon_sym_RBRACE,
    STATE(3402), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3425), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [104413] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6277), 1,
      anon_sym_RBRACE,
    STATE(3418), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3426), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [104460] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6279), 1,
      anon_sym_RBRACE,
    STATE(3402), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3427), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [104507] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6281), 1,
      anon_sym_RBRACE,
    STATE(3402), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3428), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [104554] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6283), 1,
      anon_sym_RBRACE,
    STATE(3402), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3429), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [104601] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6259), 1,
      sym_identifier,
    STATE(3561), 1,
      sym__function_name,
    STATE(4016), 1,
      sym_overridable_operator,
    STATE(3430), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6159), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6157), 8,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [104636] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6287), 1,
      anon_sym_COLON_EQ,
    STATE(3431), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6285), 13,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [104665] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6259), 1,
      sym_identifier,
    STATE(3605), 1,
      sym__function_name,
    STATE(4016), 1,
      sym_overridable_operator,
    STATE(3432), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6159), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6157), 8,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [104700] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6259), 1,
      sym_identifier,
    STATE(3630), 1,
      sym__function_name,
    STATE(4016), 1,
      sym_overridable_operator,
    STATE(3433), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6159), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6157), 8,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [104735] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6289), 1,
      anon_sym_RBRACE,
    STATE(3429), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3434), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [104782] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6291), 1,
      anon_sym_RBRACE,
    STATE(3402), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3435), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [104829] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6295), 1,
      anon_sym_COLON_EQ,
    STATE(3436), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6293), 13,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [104858] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6297), 1,
      anon_sym_RBRACE,
    STATE(3428), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3437), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [104905] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6299), 1,
      anon_sym_RBRACE,
    STATE(3402), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3438), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [104952] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6301), 1,
      anon_sym_RBRACE,
    STATE(3421), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3439), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [104999] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6259), 1,
      sym_identifier,
    STATE(3629), 1,
      sym__function_name,
    STATE(4016), 1,
      sym_overridable_operator,
    STATE(3440), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6159), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6157), 8,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [105034] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6259), 1,
      sym_identifier,
    STATE(3532), 1,
      sym__function_name,
    STATE(4016), 1,
      sym_overridable_operator,
    STATE(3441), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6159), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6157), 8,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [105069] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6259), 1,
      sym_identifier,
    STATE(3526), 1,
      sym__function_name,
    STATE(4016), 1,
      sym_overridable_operator,
    STATE(3442), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6159), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6157), 8,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [105104] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6259), 1,
      sym_identifier,
    STATE(3646), 1,
      sym__function_name,
    STATE(4016), 1,
      sym_overridable_operator,
    STATE(3443), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6159), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6157), 8,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [105139] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(965), 1,
      anon_sym_pub,
    ACTIONS(6214), 1,
      sym_identifier,
    ACTIONS(6303), 1,
      anon_sym_RBRACE,
    STATE(3402), 1,
      aux_sym__struct_body_repeat1,
    STATE(3500), 1,
      sym_generic_type,
    STATE(3507), 1,
      sym__struct_field_definition,
    STATE(3508), 1,
      sym_embedded_definition,
    STATE(4454), 1,
      sym_reference_expression,
    ACTIONS(953), 2,
      anon_sym___global,
      anon_sym_mut,
    STATE(3444), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3481), 2,
      sym_type_reference_expression,
      sym_qualified_type,
    STATE(3506), 2,
      sym_struct_field_scope,
      sym_struct_field_declaration,
  [105186] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6307), 1,
      anon_sym_COLON_EQ,
    STATE(3445), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6305), 13,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [105215] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3407), 1,
      sym_attribute,
    ACTIONS(6311), 2,
      anon_sym_LBRACK2,
      anon_sym_AT_LBRACK,
    STATE(3446), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_attributes_repeat1,
    ACTIONS(6309), 9,
      anon_sym_module,
      anon_sym_const,
      anon_sym___global,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_pub,
      anon_sym_enum,
      anon_sym_interface,
  [105245] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3447), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2401), 13,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105271] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3448), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2841), 13,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105297] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3407), 1,
      sym_attribute,
    STATE(3446), 1,
      aux_sym_attributes_repeat1,
    ACTIONS(125), 2,
      anon_sym_LBRACK2,
      anon_sym_AT_LBRACK,
    STATE(3449), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6314), 9,
      anon_sym_module,
      anon_sym_const,
      anon_sym___global,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_pub,
      anon_sym_enum,
      anon_sym_interface,
  [105329] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3450), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2453), 13,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105355] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3451), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6318), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6316), 9,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_identifier,
  [105382] = 7,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6322), 1,
      anon_sym_EQ,
    STATE(3501), 1,
      sym_attribute,
    ACTIONS(5209), 2,
      anon_sym_LBRACK2,
      anon_sym_AT_LBRACK,
    STATE(3452), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6320), 8,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
  [105413] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3453), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6326), 3,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6324), 9,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_identifier,
  [105440] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3505), 1,
      sym_attribute,
    ACTIONS(5209), 2,
      anon_sym_LBRACK2,
      anon_sym_AT_LBRACK,
    STATE(3454), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6328), 8,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
  [105468] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3455), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3324), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105492] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3456), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3308), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105516] = 7,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2187), 1,
      anon_sym_LBRACE,
    ACTIONS(6273), 1,
      anon_sym_LBRACK,
    STATE(3448), 1,
      sym_type_parameters,
    STATE(3457), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6330), 8,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
  [105546] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3458), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2893), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105570] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3459), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2187), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105594] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3460), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2967), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105618] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3461), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3246), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105642] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3462), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3041), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105666] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3463), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3304), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105690] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3464), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3031), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105714] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3465), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3266), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105738] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3466), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3027), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105762] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3467), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3312), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105786] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3468), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3001), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105810] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3469), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3300), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105834] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3470), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6309), 11,
      anon_sym_module,
      anon_sym_const,
      anon_sym___global,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_pub,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_LBRACK2,
      anon_sym_AT_LBRACK,
  [105858] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3471), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3270), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105882] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3472), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3084), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105906] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3473), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3292), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105930] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3474), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3296), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105954] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3475), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3356), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [105978] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3476), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3318), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [106002] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3504), 1,
      sym_attribute,
    ACTIONS(5209), 2,
      anon_sym_LBRACK2,
      anon_sym_AT_LBRACK,
    STATE(3477), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6332), 8,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
  [106030] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3478), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3346), 11,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      anon_sym_LBRACK2,
      sym_identifier,
      anon_sym_AT_LBRACK,
  [106054] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6334), 1,
      sym_identifier,
    ACTIONS(6338), 1,
      anon_sym_LPAREN,
    STATE(1798), 1,
      sym_global_var_definition,
    STATE(3479), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6336), 7,
      anon_sym_const,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_enum,
      anon_sym_interface,
  [106083] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6340), 1,
      anon_sym_module,
    ACTIONS(6342), 1,
      anon_sym_const,
    ACTIONS(6344), 1,
      anon_sym___global,
    ACTIONS(6346), 1,
      anon_sym_fn,
    ACTIONS(6350), 1,
      anon_sym_pub,
    ACTIONS(6352), 1,
      anon_sym_enum,
    ACTIONS(6354), 1,
      anon_sym_interface,
    STATE(3652), 1,
      sym_visibility_modifiers,
    ACTIONS(6348), 2,
      anon_sym_struct,
      anon_sym_union,
    STATE(3480), 2,
      sym_line_comment,
      sym_block_comment,
  [106122] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6273), 1,
      anon_sym_LBRACK,
    STATE(3448), 1,
      sym_type_parameters,
    STATE(3481), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6330), 8,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
  [106149] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6163), 1,
      anon_sym_LBRACK2,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3614), 1,
      sym_capture_list,
    STATE(3823), 1,
      sym_generic_parameters,
    STATE(4104), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3482), 2,
      sym_line_comment,
      sym_block_comment,
  [106183] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4186), 1,
      anon_sym_COLON,
    STATE(3483), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4184), 3,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
    ACTIONS(6358), 5,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [106209] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6163), 1,
      anon_sym_LBRACK2,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3584), 1,
      sym_capture_list,
    STATE(3810), 1,
      sym_generic_parameters,
    STATE(4337), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3484), 2,
      sym_line_comment,
      sym_block_comment,
  [106243] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6163), 1,
      anon_sym_LBRACK2,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3536), 1,
      sym_capture_list,
    STATE(3805), 1,
      sym_generic_parameters,
    STATE(3877), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3485), 2,
      sym_line_comment,
      sym_block_comment,
  [106277] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6163), 1,
      anon_sym_LBRACK2,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3631), 1,
      sym_capture_list,
    STATE(3796), 1,
      sym_generic_parameters,
    STATE(4384), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3486), 2,
      sym_line_comment,
      sym_block_comment,
  [106311] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6342), 1,
      anon_sym_const,
    ACTIONS(6344), 1,
      anon_sym___global,
    ACTIONS(6346), 1,
      anon_sym_fn,
    ACTIONS(6350), 1,
      anon_sym_pub,
    ACTIONS(6352), 1,
      anon_sym_enum,
    ACTIONS(6354), 1,
      anon_sym_interface,
    STATE(3652), 1,
      sym_visibility_modifiers,
    ACTIONS(6348), 2,
      anon_sym_struct,
      anon_sym_union,
    STATE(3487), 2,
      sym_line_comment,
      sym_block_comment,
  [106347] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6163), 1,
      anon_sym_LBRACK2,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3587), 1,
      sym_capture_list,
    STATE(3741), 1,
      sym_generic_parameters,
    STATE(4152), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3488), 2,
      sym_line_comment,
      sym_block_comment,
  [106381] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2187), 1,
      anon_sym_LBRACE,
    STATE(3489), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6330), 8,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
  [106405] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6163), 1,
      anon_sym_LBRACK2,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3602), 1,
      sym_capture_list,
    STATE(3837), 1,
      sym_generic_parameters,
    STATE(4336), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3490), 2,
      sym_line_comment,
      sym_block_comment,
  [106439] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6163), 1,
      anon_sym_LBRACK2,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3562), 1,
      sym_capture_list,
    STATE(3816), 1,
      sym_generic_parameters,
    STATE(4296), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3491), 2,
      sym_line_comment,
      sym_block_comment,
  [106473] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6163), 1,
      anon_sym_LBRACK2,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3535), 1,
      sym_capture_list,
    STATE(3793), 1,
      sym_generic_parameters,
    STATE(4267), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3492), 2,
      sym_line_comment,
      sym_block_comment,
  [106507] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6163), 1,
      anon_sym_LBRACK2,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3564), 1,
      sym_capture_list,
    STATE(3832), 1,
      sym_generic_parameters,
    STATE(4098), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3493), 2,
      sym_line_comment,
      sym_block_comment,
  [106541] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3494), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2175), 9,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON,
      sym_identifier,
  [106563] = 7,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6362), 1,
      anon_sym_EQ,
    STATE(3680), 1,
      sym_attribute,
    ACTIONS(5209), 2,
      anon_sym_LBRACK2,
      anon_sym_AT_LBRACK,
    STATE(3495), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6360), 5,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      sym_identifier,
  [106591] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6163), 1,
      anon_sym_LBRACK2,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3638), 1,
      sym_capture_list,
    STATE(3817), 1,
      sym_generic_parameters,
    STATE(4226), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3496), 2,
      sym_line_comment,
      sym_block_comment,
  [106625] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6334), 1,
      sym_identifier,
    ACTIONS(6364), 1,
      anon_sym_LPAREN,
    STATE(1826), 1,
      sym_global_var_definition,
    STATE(3497), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6336), 6,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_enum,
      anon_sym_interface,
  [106653] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6163), 1,
      anon_sym_LBRACK2,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3543), 1,
      sym_capture_list,
    STATE(3736), 1,
      sym_generic_parameters,
    STATE(4220), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3498), 2,
      sym_line_comment,
      sym_block_comment,
  [106687] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6163), 1,
      anon_sym_LBRACK2,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3621), 1,
      sym_capture_list,
    STATE(3686), 1,
      sym_signature,
    STATE(3790), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3499), 2,
      sym_line_comment,
      sym_block_comment,
  [106721] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3500), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6330), 8,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
  [106742] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3501), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6366), 8,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
  [106763] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6370), 1,
      anon_sym_DOT,
    STATE(3511), 1,
      aux_sym_import_path_repeat1,
    STATE(3502), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6368), 6,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
  [106788] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3503), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6372), 8,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
  [106809] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3504), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6374), 8,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
  [106830] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3505), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6376), 8,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
  [106851] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3506), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6380), 3,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    ACTIONS(6378), 5,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
  [106874] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3507), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6382), 8,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
  [106895] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3508), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6384), 8,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
  [106916] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3509), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4184), 3,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
    ACTIONS(6358), 5,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [106939] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(961), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6386), 1,
      sym_identifier,
    ACTIONS(6388), 1,
      anon_sym_RBRACE,
    STATE(3483), 1,
      sym_reference_expression,
    STATE(3515), 1,
      aux_sym_element_list_repeat1,
    STATE(4418), 1,
      sym_field_name,
    STATE(3509), 2,
      sym_keyed_element,
      sym_spread_expression,
    STATE(3510), 2,
      sym_line_comment,
      sym_block_comment,
  [106972] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6392), 1,
      anon_sym_DOT,
    STATE(3511), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_import_path_repeat1,
    ACTIONS(6390), 6,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
  [106995] = 8,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6399), 1,
      anon_sym_LBRACE,
    STATE(3655), 1,
      sym_import_alias,
    STATE(3806), 1,
      sym_selective_import_list,
    STATE(3512), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6395), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
  [107024] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6370), 1,
      anon_sym_DOT,
    STATE(3502), 1,
      aux_sym_import_path_repeat1,
    STATE(3513), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6401), 6,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_as,
      anon_sym_LBRACE,
  [107049] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3514), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6403), 8,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
  [107070] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6405), 1,
      sym_identifier,
    ACTIONS(6408), 1,
      anon_sym_RBRACE,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(3483), 1,
      sym_reference_expression,
    STATE(4418), 1,
      sym_field_name,
    STATE(3509), 2,
      sym_keyed_element,
      sym_spread_expression,
    STATE(3515), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_element_list_repeat1,
  [107101] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3516), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6413), 8,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
  [107122] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3517), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6417), 3,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    ACTIONS(6415), 5,
      anon_sym_RBRACE,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
  [107145] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3518), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6390), 7,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
  [107165] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6421), 1,
      anon_sym_SQUOTE,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3519), 2,
      sym_line_comment,
      sym_block_comment,
  [107195] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6427), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3520), 2,
      sym_line_comment,
      sym_block_comment,
  [107225] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6431), 1,
      anon_sym_DQUOTE,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3521), 2,
      sym_line_comment,
      sym_block_comment,
  [107255] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6437), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3522), 2,
      sym_line_comment,
      sym_block_comment,
  [107285] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6437), 1,
      anon_sym_DQUOTE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3523), 2,
      sym_line_comment,
      sym_block_comment,
  [107315] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6439), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3524), 2,
      sym_line_comment,
      sym_block_comment,
  [107345] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6439), 1,
      anon_sym_DQUOTE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3525), 2,
      sym_line_comment,
      sym_block_comment,
  [107375] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1771), 1,
      sym_signature,
    STATE(3824), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3526), 2,
      sym_line_comment,
      sym_block_comment,
  [107403] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6443), 1,
      anon_sym_DQUOTE,
    STATE(3597), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3527), 2,
      sym_line_comment,
      sym_block_comment,
  [107433] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6443), 1,
      anon_sym_SQUOTE,
    STATE(3639), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3528), 2,
      sym_line_comment,
      sym_block_comment,
  [107463] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6445), 1,
      anon_sym_DQUOTE,
    STATE(3637), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3529), 2,
      sym_line_comment,
      sym_block_comment,
  [107493] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6445), 1,
      anon_sym_SQUOTE,
    STATE(3640), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3530), 2,
      sym_line_comment,
      sym_block_comment,
  [107523] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3531), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6447), 7,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_LBRACE,
  [107543] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1751), 1,
      sym_signature,
    STATE(3828), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3532), 2,
      sym_line_comment,
      sym_block_comment,
  [107571] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6449), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3533), 2,
      sym_line_comment,
      sym_block_comment,
  [107601] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6449), 1,
      anon_sym_DQUOTE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3534), 2,
      sym_line_comment,
      sym_block_comment,
  [107631] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3789), 1,
      sym_generic_parameters,
    STATE(4224), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3535), 2,
      sym_line_comment,
      sym_block_comment,
  [107659] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3795), 1,
      sym_generic_parameters,
    STATE(4329), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3536), 2,
      sym_line_comment,
      sym_block_comment,
  [107687] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6451), 1,
      anon_sym_DQUOTE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3537), 2,
      sym_line_comment,
      sym_block_comment,
  [107717] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6453), 1,
      anon_sym_DQUOTE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3538), 2,
      sym_line_comment,
      sym_block_comment,
  [107747] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6453), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3539), 2,
      sym_line_comment,
      sym_block_comment,
  [107777] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1756), 1,
      sym_signature,
    STATE(3835), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3540), 2,
      sym_line_comment,
      sym_block_comment,
  [107805] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6455), 1,
      anon_sym_DQUOTE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3541), 2,
      sym_line_comment,
      sym_block_comment,
  [107835] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6455), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3542), 2,
      sym_line_comment,
      sym_block_comment,
  [107865] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3829), 1,
      sym_generic_parameters,
    STATE(4400), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3543), 2,
      sym_line_comment,
      sym_block_comment,
  [107893] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6451), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3544), 2,
      sym_line_comment,
      sym_block_comment,
  [107923] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6457), 1,
      anon_sym_DQUOTE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3545), 2,
      sym_line_comment,
      sym_block_comment,
  [107953] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6459), 1,
      anon_sym_DQUOTE,
    STATE(3593), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3546), 2,
      sym_line_comment,
      sym_block_comment,
  [107983] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6147), 1,
      sym_identifier,
    ACTIONS(6461), 1,
      anon_sym_RBRACK,
    ACTIONS(6463), 1,
      anon_sym_mut,
    ACTIONS(6465), 1,
      anon_sym_shared,
    STATE(4269), 1,
      sym_capture,
    STATE(4386), 1,
      sym_reference_expression,
    STATE(4387), 1,
      sym_mutability_modifiers,
    STATE(3547), 2,
      sym_line_comment,
      sym_block_comment,
  [108015] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6467), 1,
      anon_sym_DQUOTE,
    STATE(3538), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3548), 2,
      sym_line_comment,
      sym_block_comment,
  [108045] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6467), 1,
      anon_sym_SQUOTE,
    STATE(3539), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3549), 2,
      sym_line_comment,
      sym_block_comment,
  [108075] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6469), 1,
      anon_sym_DQUOTE,
    STATE(3541), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3550), 2,
      sym_line_comment,
      sym_block_comment,
  [108105] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6469), 1,
      anon_sym_SQUOTE,
    STATE(3542), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3551), 2,
      sym_line_comment,
      sym_block_comment,
  [108135] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6459), 1,
      anon_sym_SQUOTE,
    STATE(3591), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3552), 2,
      sym_line_comment,
      sym_block_comment,
  [108165] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6471), 1,
      anon_sym_DQUOTE,
    STATE(3604), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3553), 2,
      sym_line_comment,
      sym_block_comment,
  [108195] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6471), 1,
      anon_sym_SQUOTE,
    STATE(3578), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3554), 2,
      sym_line_comment,
      sym_block_comment,
  [108225] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6473), 1,
      anon_sym_DQUOTE,
    STATE(3523), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3555), 2,
      sym_line_comment,
      sym_block_comment,
  [108255] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1750), 1,
      sym_signature,
    STATE(3803), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3556), 2,
      sym_line_comment,
      sym_block_comment,
  [108283] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6473), 1,
      anon_sym_SQUOTE,
    STATE(3522), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3557), 2,
      sym_line_comment,
      sym_block_comment,
  [108313] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6475), 1,
      anon_sym_DQUOTE,
    STATE(3521), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3558), 2,
      sym_line_comment,
      sym_block_comment,
  [108343] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6475), 1,
      anon_sym_SQUOTE,
    STATE(3596), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3559), 2,
      sym_line_comment,
      sym_block_comment,
  [108373] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6457), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3560), 2,
      sym_line_comment,
      sym_block_comment,
  [108403] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1767), 1,
      sym_signature,
    STATE(3769), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3561), 2,
      sym_line_comment,
      sym_block_comment,
  [108431] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3807), 1,
      sym_generic_parameters,
    STATE(4361), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3562), 2,
      sym_line_comment,
      sym_block_comment,
  [108459] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3563), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6477), 7,
      anon_sym_const,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_enum,
      anon_sym_interface,
  [108479] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3827), 1,
      sym_generic_parameters,
    STATE(4183), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3564), 2,
      sym_line_comment,
      sym_block_comment,
  [108507] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6427), 1,
      anon_sym_DQUOTE,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3565), 2,
      sym_line_comment,
      sym_block_comment,
  [108537] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6479), 1,
      anon_sym_SQUOTE,
    STATE(3588), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3566), 2,
      sym_line_comment,
      sym_block_comment,
  [108567] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6481), 1,
      anon_sym_DQUOTE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3567), 2,
      sym_line_comment,
      sym_block_comment,
  [108597] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6483), 1,
      anon_sym_SQUOTE,
    STATE(3628), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3568), 2,
      sym_line_comment,
      sym_block_comment,
  [108627] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6481), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3569), 2,
      sym_line_comment,
      sym_block_comment,
  [108657] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6485), 1,
      anon_sym_SQUOTE,
    STATE(3598), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3570), 2,
      sym_line_comment,
      sym_block_comment,
  [108687] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6485), 1,
      anon_sym_DQUOTE,
    STATE(3599), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3571), 2,
      sym_line_comment,
      sym_block_comment,
  [108717] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6487), 1,
      anon_sym_SQUOTE,
    STATE(3600), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3572), 2,
      sym_line_comment,
      sym_block_comment,
  [108747] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6487), 1,
      anon_sym_DQUOTE,
    STATE(3601), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3573), 2,
      sym_line_comment,
      sym_block_comment,
  [108777] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6483), 1,
      anon_sym_DQUOTE,
    STATE(3633), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3574), 2,
      sym_line_comment,
      sym_block_comment,
  [108807] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6489), 1,
      anon_sym_DQUOTE,
    STATE(3537), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3575), 2,
      sym_line_comment,
      sym_block_comment,
  [108837] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6489), 1,
      anon_sym_SQUOTE,
    STATE(3544), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3576), 2,
      sym_line_comment,
      sym_block_comment,
  [108867] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6491), 1,
      anon_sym_DQUOTE,
    STATE(3545), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3577), 2,
      sym_line_comment,
      sym_block_comment,
  [108897] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6493), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3578), 2,
      sym_line_comment,
      sym_block_comment,
  [108927] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6147), 1,
      sym_identifier,
    ACTIONS(6463), 1,
      anon_sym_mut,
    ACTIONS(6465), 1,
      anon_sym_shared,
    ACTIONS(6495), 1,
      anon_sym_RBRACK,
    STATE(4269), 1,
      sym_capture,
    STATE(4386), 1,
      sym_reference_expression,
    STATE(4387), 1,
      sym_mutability_modifiers,
    STATE(3579), 2,
      sym_line_comment,
      sym_block_comment,
  [108959] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6497), 1,
      anon_sym_DQUOTE,
    STATE(3565), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3580), 2,
      sym_line_comment,
      sym_block_comment,
  [108989] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6497), 1,
      anon_sym_SQUOTE,
    STATE(3520), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3581), 2,
      sym_line_comment,
      sym_block_comment,
  [109019] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6499), 1,
      anon_sym_DQUOTE,
    STATE(3567), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3582), 2,
      sym_line_comment,
      sym_block_comment,
  [109049] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6499), 1,
      anon_sym_SQUOTE,
    STATE(3569), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3583), 2,
      sym_line_comment,
      sym_block_comment,
  [109079] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3813), 1,
      sym_generic_parameters,
    STATE(4298), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3584), 2,
      sym_line_comment,
      sym_block_comment,
  [109107] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6491), 1,
      anon_sym_SQUOTE,
    STATE(3560), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3585), 2,
      sym_line_comment,
      sym_block_comment,
  [109137] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6501), 1,
      anon_sym_DQUOTE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3586), 2,
      sym_line_comment,
      sym_block_comment,
  [109167] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3754), 1,
      sym_generic_parameters,
    STATE(4197), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3587), 2,
      sym_line_comment,
      sym_block_comment,
  [109195] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6501), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3588), 2,
      sym_line_comment,
      sym_block_comment,
  [109225] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6503), 1,
      anon_sym_SQUOTE,
    STATE(3519), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3589), 2,
      sym_line_comment,
      sym_block_comment,
  [109255] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6505), 1,
      anon_sym_DQUOTE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3590), 2,
      sym_line_comment,
      sym_block_comment,
  [109285] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6507), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3591), 2,
      sym_line_comment,
      sym_block_comment,
  [109315] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6505), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3592), 2,
      sym_line_comment,
      sym_block_comment,
  [109345] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6507), 1,
      anon_sym_DQUOTE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3593), 2,
      sym_line_comment,
      sym_block_comment,
  [109375] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6503), 1,
      anon_sym_DQUOTE,
    STATE(3641), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3594), 2,
      sym_line_comment,
      sym_block_comment,
  [109405] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6509), 1,
      sym_identifier,
    STATE(3668), 1,
      sym_reference_expression,
    STATE(3595), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6511), 5,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [109429] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6431), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3596), 2,
      sym_line_comment,
      sym_block_comment,
  [109459] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6513), 1,
      anon_sym_DQUOTE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3597), 2,
      sym_line_comment,
      sym_block_comment,
  [109489] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6515), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3598), 2,
      sym_line_comment,
      sym_block_comment,
  [109519] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6515), 1,
      anon_sym_DQUOTE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3599), 2,
      sym_line_comment,
      sym_block_comment,
  [109549] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6517), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3600), 2,
      sym_line_comment,
      sym_block_comment,
  [109579] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6517), 1,
      anon_sym_DQUOTE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3601), 2,
      sym_line_comment,
      sym_block_comment,
  [109609] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3841), 1,
      sym_generic_parameters,
    STATE(4381), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3602), 2,
      sym_line_comment,
      sym_block_comment,
  [109637] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6479), 1,
      anon_sym_DQUOTE,
    STATE(3586), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3603), 2,
      sym_line_comment,
      sym_block_comment,
  [109667] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6493), 1,
      anon_sym_DQUOTE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3604), 2,
      sym_line_comment,
      sym_block_comment,
  [109697] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1762), 1,
      sym_signature,
    STATE(3762), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3605), 2,
      sym_line_comment,
      sym_block_comment,
  [109725] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6519), 1,
      anon_sym_SQUOTE,
    STATE(3645), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3606), 2,
      sym_line_comment,
      sym_block_comment,
  [109755] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6521), 1,
      anon_sym_DQUOTE,
    STATE(3590), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3607), 2,
      sym_line_comment,
      sym_block_comment,
  [109785] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6519), 1,
      anon_sym_DQUOTE,
    STATE(3644), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3608), 2,
      sym_line_comment,
      sym_block_comment,
  [109815] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6521), 1,
      anon_sym_SQUOTE,
    STATE(3592), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3609), 2,
      sym_line_comment,
      sym_block_comment,
  [109845] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1776), 1,
      sym_signature,
    STATE(3734), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3610), 2,
      sym_line_comment,
      sym_block_comment,
  [109873] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1769), 1,
      sym_signature,
    STATE(3703), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3611), 2,
      sym_line_comment,
      sym_block_comment,
  [109901] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6523), 1,
      anon_sym_SQUOTE,
    STATE(3643), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3612), 2,
      sym_line_comment,
      sym_block_comment,
  [109931] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6523), 1,
      anon_sym_DQUOTE,
    STATE(3642), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3613), 2,
      sym_line_comment,
      sym_block_comment,
  [109961] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3831), 1,
      sym_generic_parameters,
    STATE(4196), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3614), 2,
      sym_line_comment,
      sym_block_comment,
  [109989] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1757), 1,
      sym_signature,
    STATE(3707), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3615), 2,
      sym_line_comment,
      sym_block_comment,
  [110017] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6525), 1,
      anon_sym_const,
    ACTIONS(6527), 1,
      anon_sym_type,
    ACTIONS(6529), 1,
      anon_sym_fn,
    ACTIONS(6533), 1,
      anon_sym_enum,
    ACTIONS(6535), 1,
      anon_sym_interface,
    ACTIONS(6531), 2,
      anon_sym_struct,
      anon_sym_union,
    STATE(3616), 2,
      sym_line_comment,
      sym_block_comment,
  [110047] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6537), 1,
      anon_sym_DQUOTE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3617), 2,
      sym_line_comment,
      sym_block_comment,
  [110077] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6537), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3618), 2,
      sym_line_comment,
      sym_block_comment,
  [110107] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6539), 1,
      anon_sym_DQUOTE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3619), 2,
      sym_line_comment,
      sym_block_comment,
  [110137] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6539), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3620), 2,
      sym_line_comment,
      sym_block_comment,
  [110167] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3792), 1,
      sym_generic_parameters,
    STATE(4334), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3621), 2,
      sym_line_comment,
      sym_block_comment,
  [110195] = 8,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6544), 1,
      anon_sym_DQUOTE,
    ACTIONS(6546), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6549), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6541), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3622), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_interpreted_string_literal_repeat2,
  [110223] = 8,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6555), 1,
      anon_sym_SQUOTE,
    ACTIONS(6557), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6560), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6552), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3623), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_interpreted_string_literal_repeat1,
  [110251] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6563), 1,
      anon_sym_DQUOTE,
    STATE(3617), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3624), 2,
      sym_line_comment,
      sym_block_comment,
  [110281] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6563), 1,
      anon_sym_SQUOTE,
    STATE(3618), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3625), 2,
      sym_line_comment,
      sym_block_comment,
  [110311] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_DQUOTE,
    STATE(3619), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3626), 2,
      sym_line_comment,
      sym_block_comment,
  [110341] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_SQUOTE,
    STATE(3620), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3627), 2,
      sym_line_comment,
      sym_block_comment,
  [110371] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6567), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3628), 2,
      sym_line_comment,
      sym_block_comment,
  [110401] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1754), 1,
      sym_signature,
    STATE(3702), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3629), 2,
      sym_line_comment,
      sym_block_comment,
  [110429] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1764), 1,
      sym_signature,
    STATE(3697), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3630), 2,
      sym_line_comment,
      sym_block_comment,
  [110457] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3800), 1,
      sym_generic_parameters,
    STATE(4396), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3631), 2,
      sym_line_comment,
      sym_block_comment,
  [110485] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6569), 1,
      anon_sym_SQUOTE,
    STATE(3524), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3632), 2,
      sym_line_comment,
      sym_block_comment,
  [110515] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6567), 1,
      anon_sym_DQUOTE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3633), 2,
      sym_line_comment,
      sym_block_comment,
  [110545] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6569), 1,
      anon_sym_DQUOTE,
    STATE(3525), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3634), 2,
      sym_line_comment,
      sym_block_comment,
  [110575] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6571), 1,
      anon_sym_SQUOTE,
    STATE(3533), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3635), 2,
      sym_line_comment,
      sym_block_comment,
  [110605] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6571), 1,
      anon_sym_DQUOTE,
    STATE(3534), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3636), 2,
      sym_line_comment,
      sym_block_comment,
  [110635] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6573), 1,
      anon_sym_DQUOTE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3637), 2,
      sym_line_comment,
      sym_block_comment,
  [110665] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(3819), 1,
      sym_generic_parameters,
    STATE(4184), 1,
      sym_signature,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3638), 2,
      sym_line_comment,
      sym_block_comment,
  [110693] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6513), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3639), 2,
      sym_line_comment,
      sym_block_comment,
  [110723] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6573), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3640), 2,
      sym_line_comment,
      sym_block_comment,
  [110753] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6421), 1,
      anon_sym_DQUOTE,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3641), 2,
      sym_line_comment,
      sym_block_comment,
  [110783] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6575), 1,
      anon_sym_DQUOTE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3642), 2,
      sym_line_comment,
      sym_block_comment,
  [110813] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6575), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3643), 2,
      sym_line_comment,
      sym_block_comment,
  [110843] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      aux_sym_interpreted_string_literal_token2,
    ACTIONS(6435), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6577), 1,
      anon_sym_DQUOTE,
    STATE(3622), 1,
      aux_sym_interpreted_string_literal_repeat2,
    STATE(3664), 1,
      sym_string_interpolation,
    ACTIONS(6429), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3644), 2,
      sym_line_comment,
      sym_block_comment,
  [110873] = 9,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      aux_sym_interpreted_string_literal_token1,
    ACTIONS(6425), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6577), 1,
      anon_sym_SQUOTE,
    STATE(3623), 1,
      aux_sym_interpreted_string_literal_repeat1,
    STATE(3677), 1,
      sym_string_interpolation,
    ACTIONS(6419), 2,
      sym_escape_sequence,
      anon_sym_DOLLAR,
    STATE(3645), 2,
      sym_line_comment,
      sym_block_comment,
  [110903] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1761), 1,
      sym_signature,
    STATE(3787), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3646), 2,
      sym_line_comment,
      sym_block_comment,
  [110931] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6147), 1,
      sym_identifier,
    ACTIONS(6463), 1,
      anon_sym_mut,
    ACTIONS(6465), 1,
      anon_sym_shared,
    STATE(4269), 1,
      sym_capture,
    STATE(4386), 1,
      sym_reference_expression,
    STATE(4387), 1,
      sym_mutability_modifiers,
    STATE(3647), 2,
      sym_line_comment,
      sym_block_comment,
  [110960] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6581), 1,
      anon_sym_RBRACE,
    STATE(3653), 1,
      aux_sym_selective_import_list_repeat1,
    STATE(3648), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6579), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_COMMA,
  [110983] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6583), 1,
      anon_sym_LBRACK,
    STATE(2423), 1,
      sym_type_parameters,
    STATE(3649), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2185), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [111006] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6585), 1,
      anon_sym_DOT,
    ACTIONS(6587), 1,
      anon_sym_RBRACE,
    ACTIONS(6589), 1,
      sym_int_literal,
    ACTIONS(6591), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(6593), 1,
      aux_sym_format_specifier_token2,
    ACTIONS(6595), 1,
      anon_sym_0,
    STATE(3650), 2,
      sym_line_comment,
      sym_block_comment,
  [111035] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2173), 1,
      anon_sym_DOT,
    STATE(3651), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2371), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [111056] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6597), 1,
      anon_sym_const,
    ACTIONS(6599), 1,
      anon_sym_fn,
    ACTIONS(6603), 1,
      anon_sym_enum,
    ACTIONS(6605), 1,
      anon_sym_interface,
    ACTIONS(6601), 2,
      anon_sym_struct,
      anon_sym_union,
    STATE(3652), 2,
      sym_line_comment,
      sym_block_comment,
  [111083] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6610), 1,
      anon_sym_RBRACE,
    STATE(3653), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_selective_import_list_repeat1,
    ACTIONS(6607), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_COMMA,
  [111104] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6147), 1,
      sym_identifier,
    ACTIONS(6463), 1,
      anon_sym_mut,
    ACTIONS(6465), 1,
      anon_sym_shared,
    STATE(3852), 1,
      sym_capture,
    STATE(4386), 1,
      sym_reference_expression,
    STATE(4387), 1,
      sym_mutability_modifiers,
    STATE(3654), 2,
      sym_line_comment,
      sym_block_comment,
  [111133] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6399), 1,
      anon_sym_LBRACE,
    STATE(3764), 1,
      sym_selective_import_list,
    STATE(3655), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6612), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
  [111156] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6614), 1,
      anon_sym_RBRACE,
    STATE(3648), 1,
      aux_sym_selective_import_list_repeat1,
    STATE(3656), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6579), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_COMMA,
  [111179] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6618), 1,
      aux_sym_interpreted_string_literal_token1,
    STATE(3657), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6616), 4,
      sym_escape_sequence,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      anon_sym_DOLLAR_LBRACE,
  [111199] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6204), 1,
      anon_sym_RBRACE,
    STATE(3658), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6620), 4,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
  [111219] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6622), 1,
      anon_sym_LBRACE,
    STATE(1789), 1,
      sym__interface_body,
    STATE(4109), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(3659), 2,
      sym_line_comment,
      sym_block_comment,
  [111243] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6624), 1,
      sym_identifier,
    ACTIONS(6626), 1,
      anon_sym_mut,
    STATE(3947), 1,
      sym_var_definition,
    STATE(4177), 1,
      sym_range_clause,
    STATE(4578), 1,
      sym_var_definition_list,
    STATE(3660), 2,
      sym_line_comment,
      sym_block_comment,
  [111269] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6628), 1,
      anon_sym_LBRACE,
    STATE(1781), 1,
      sym__struct_body,
    STATE(4094), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(3661), 2,
      sym_line_comment,
      sym_block_comment,
  [111293] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2419), 1,
      sym_type_initializer_body,
    STATE(3662), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3310), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [111313] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6632), 1,
      aux_sym_interpreted_string_literal_token2,
    STATE(3663), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6630), 4,
      sym_escape_sequence,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [111333] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6636), 1,
      aux_sym_interpreted_string_literal_token2,
    STATE(3664), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6634), 4,
      sym_escape_sequence,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [111353] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6622), 1,
      anon_sym_LBRACE,
    STATE(1871), 1,
      sym__interface_body,
    STATE(4307), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(3665), 2,
      sym_line_comment,
      sym_block_comment,
  [111377] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3666), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6638), 5,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      sym_identifier,
  [111395] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6463), 1,
      anon_sym_mut,
    ACTIONS(6465), 1,
      anon_sym_shared,
    ACTIONS(6640), 1,
      sym_identifier,
    STATE(4160), 1,
      sym_parameter_declaration,
    STATE(4672), 1,
      sym_mutability_modifiers,
    STATE(3667), 2,
      sym_line_comment,
      sym_block_comment,
  [111421] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3668), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6610), 5,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111439] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3669), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2173), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_PIPE,
  [111457] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6644), 1,
      aux_sym_interpreted_string_literal_token2,
    STATE(3670), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6642), 4,
      sym_escape_sequence,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [111477] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3671), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6646), 5,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [111495] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6225), 1,
      anon_sym_RBRACE,
    STATE(3672), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6648), 4,
      anon_sym___global,
      anon_sym_pub,
      anon_sym_mut,
      sym_identifier,
  [111515] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5331), 1,
      anon_sym_LBRACE,
    STATE(1668), 1,
      sym_block,
    STATE(3673), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6650), 3,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [111537] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6628), 1,
      anon_sym_LBRACE,
    STATE(1822), 1,
      sym__struct_body,
    STATE(4111), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(3674), 2,
      sym_line_comment,
      sym_block_comment,
  [111561] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6652), 2,
      anon_sym_RBRACE,
      sym_identifier,
    STATE(3675), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6654), 3,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [111581] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6628), 1,
      anon_sym_LBRACE,
    STATE(1886), 1,
      sym__struct_body,
    STATE(4314), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(3676), 2,
      sym_line_comment,
      sym_block_comment,
  [111605] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6658), 1,
      aux_sym_interpreted_string_literal_token1,
    STATE(3677), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6656), 4,
      sym_escape_sequence,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      anon_sym_DOLLAR_LBRACE,
  [111625] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6463), 1,
      anon_sym_mut,
    ACTIONS(6465), 1,
      anon_sym_shared,
    ACTIONS(6660), 1,
      sym_identifier,
    STATE(4345), 1,
      sym_mutable_identifier,
    STATE(4478), 1,
      sym_mutability_modifiers,
    STATE(3678), 2,
      sym_line_comment,
      sym_block_comment,
  [111651] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6622), 1,
      anon_sym_LBRACE,
    STATE(1787), 1,
      sym__interface_body,
    STATE(4127), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(3679), 2,
      sym_line_comment,
      sym_block_comment,
  [111675] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3680), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6662), 5,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      sym_identifier,
  [111693] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6622), 1,
      anon_sym_LBRACE,
    STATE(1803), 1,
      sym__interface_body,
    STATE(4373), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(3681), 2,
      sym_line_comment,
      sym_block_comment,
  [111717] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6628), 1,
      anon_sym_LBRACE,
    STATE(1888), 1,
      sym__struct_body,
    STATE(4390), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(3682), 2,
      sym_line_comment,
      sym_block_comment,
  [111741] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6664), 1,
      anon_sym_LBRACE,
    STATE(2419), 1,
      sym_type_initializer_body,
    STATE(3683), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3306), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [111763] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6618), 1,
      aux_sym_interpreted_string_literal_token2,
    STATE(3684), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6616), 4,
      sym_escape_sequence,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [111783] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6632), 1,
      aux_sym_interpreted_string_literal_token1,
    STATE(3685), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6630), 4,
      sym_escape_sequence,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      anon_sym_DOLLAR_LBRACE,
  [111803] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5325), 1,
      anon_sym_LBRACE,
    STATE(2402), 1,
      sym_block,
    STATE(3686), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3316), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [111825] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5325), 1,
      anon_sym_LBRACE,
    STATE(2474), 1,
      sym_block,
    STATE(3687), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6650), 3,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [111847] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6664), 1,
      anon_sym_LBRACE,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(6668), 1,
      anon_sym_RBRACK,
    STATE(2419), 1,
      sym_type_initializer_body,
    STATE(4058), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3688), 2,
      sym_line_comment,
      sym_block_comment,
  [111873] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6664), 1,
      anon_sym_LBRACE,
    ACTIONS(6670), 1,
      anon_sym_COMMA,
    ACTIONS(6672), 1,
      anon_sym_RPAREN,
    STATE(2419), 1,
      sym_type_initializer_body,
    STATE(3860), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3689), 2,
      sym_line_comment,
      sym_block_comment,
  [111899] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6644), 1,
      aux_sym_interpreted_string_literal_token1,
    STATE(3690), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6642), 4,
      sym_escape_sequence,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      anon_sym_DOLLAR_LBRACE,
  [111919] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6624), 1,
      sym_identifier,
    ACTIONS(6626), 1,
      anon_sym_mut,
    STATE(3947), 1,
      sym_var_definition,
    STATE(4278), 1,
      sym_range_clause,
    STATE(4578), 1,
      sym_var_definition_list,
    STATE(3691), 2,
      sym_line_comment,
      sym_block_comment,
  [111945] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2419), 1,
      sym_type_initializer_body,
    STATE(3692), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3302), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [111965] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6674), 1,
      anon_sym_LPAREN,
    STATE(2846), 1,
      sym_signature,
    STATE(1911), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3693), 2,
      sym_line_comment,
      sym_block_comment,
  [111986] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6676), 1,
      sym_identifier,
    ACTIONS(6678), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(2179), 2,
      sym_reference_expression,
      sym_compile_time_selector_expression,
    STATE(3694), 2,
      sym_line_comment,
      sym_block_comment,
  [112007] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6682), 1,
      anon_sym_STAR_SLASH,
    STATE(3719), 1,
      aux_sym_block_comment_repeat1,
    ACTIONS(6680), 2,
      aux_sym_block_comment_token1,
      aux_sym_block_comment_token2,
    STATE(3695), 2,
      sym_line_comment,
      sym_block_comment,
  [112028] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6684), 1,
      sym_identifier,
    STATE(3512), 1,
      sym_import_path,
    STATE(3513), 1,
      sym_import_name,
    STATE(3723), 1,
      sym_import_spec,
    STATE(3696), 2,
      sym_line_comment,
      sym_block_comment,
  [112051] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1759), 1,
      sym_signature,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3697), 2,
      sym_line_comment,
      sym_block_comment,
  [112072] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5313), 1,
      anon_sym_LBRACE,
    ACTIONS(6686), 1,
      anon_sym_DOLLARif,
    STATE(2636), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3698), 2,
      sym_line_comment,
      sym_block_comment,
  [112093] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5313), 1,
      anon_sym_LBRACE,
    ACTIONS(6686), 1,
      anon_sym_DOLLARif,
    STATE(2630), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3699), 2,
      sym_line_comment,
      sym_block_comment,
  [112114] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6688), 1,
      anon_sym_LPAREN,
    STATE(1650), 1,
      sym_signature,
    STATE(1152), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3700), 2,
      sym_line_comment,
      sym_block_comment,
  [112135] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5313), 1,
      anon_sym_LBRACE,
    ACTIONS(6690), 1,
      anon_sym_if,
    STATE(2628), 1,
      sym_if_expression,
    STATE(2629), 1,
      sym_block,
    STATE(3701), 2,
      sym_line_comment,
      sym_block_comment,
  [112158] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1749), 1,
      sym_signature,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3702), 2,
      sym_line_comment,
      sym_block_comment,
  [112179] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1755), 1,
      sym_signature,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3703), 2,
      sym_line_comment,
      sym_block_comment,
  [112200] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6692), 1,
      sym_identifier,
    ACTIONS(6694), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(2420), 2,
      sym_reference_expression,
      sym_compile_time_selector_expression,
    STATE(3704), 2,
      sym_line_comment,
      sym_block_comment,
  [112221] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6696), 1,
      anon_sym_LPAREN,
    STATE(1745), 1,
      sym_signature,
    STATE(1281), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3705), 2,
      sym_line_comment,
      sym_block_comment,
  [112242] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6698), 1,
      sym_identifier,
    ACTIONS(6700), 1,
      anon_sym_RPAREN,
    STATE(3760), 1,
      aux_sym_const_declaration_repeat1,
    STATE(3814), 1,
      sym_const_definition,
    STATE(3706), 2,
      sym_line_comment,
      sym_block_comment,
  [112265] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1765), 1,
      sym_signature,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3707), 2,
      sym_line_comment,
      sym_block_comment,
  [112286] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6698), 1,
      sym_identifier,
    ACTIONS(6702), 1,
      anon_sym_RPAREN,
    STATE(3760), 1,
      aux_sym_const_declaration_repeat1,
    STATE(3814), 1,
      sym_const_definition,
    STATE(3708), 2,
      sym_line_comment,
      sym_block_comment,
  [112309] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6704), 1,
      anon_sym_LPAREN,
    STATE(2138), 1,
      sym_signature,
    STATE(1488), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3709), 2,
      sym_line_comment,
      sym_block_comment,
  [112330] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6698), 1,
      sym_identifier,
    ACTIONS(6706), 1,
      anon_sym_RPAREN,
    STATE(3760), 1,
      aux_sym_const_declaration_repeat1,
    STATE(3814), 1,
      sym_const_definition,
    STATE(3710), 2,
      sym_line_comment,
      sym_block_comment,
  [112353] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1859), 1,
      sym_signature,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3711), 2,
      sym_line_comment,
      sym_block_comment,
  [112374] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6708), 1,
      sym_identifier,
    ACTIONS(6710), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(1450), 2,
      sym_reference_expression,
      sym_compile_time_selector_expression,
    STATE(3712), 2,
      sym_line_comment,
      sym_block_comment,
  [112395] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6698), 1,
      sym_identifier,
    ACTIONS(6700), 1,
      anon_sym_RPAREN,
    STATE(3708), 1,
      aux_sym_const_declaration_repeat1,
    STATE(3814), 1,
      sym_const_definition,
    STATE(3713), 2,
      sym_line_comment,
      sym_block_comment,
  [112418] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5327), 1,
      anon_sym_LBRACE,
    ACTIONS(6712), 1,
      anon_sym_DOLLARif,
    STATE(2112), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3714), 2,
      sym_line_comment,
      sym_block_comment,
  [112439] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6714), 1,
      anon_sym_LPAREN,
    STATE(1536), 1,
      sym_signature,
    STATE(1114), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3715), 2,
      sym_line_comment,
      sym_block_comment,
  [112460] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6716), 1,
      anon_sym_as,
    ACTIONS(6718), 1,
      anon_sym_LBRACE,
    STATE(1780), 1,
      sym__enum_body,
    STATE(4312), 1,
      sym_enum_backed_type,
    STATE(3716), 2,
      sym_line_comment,
      sym_block_comment,
  [112483] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5327), 1,
      anon_sym_LBRACE,
    ACTIONS(6712), 1,
      anon_sym_DOLLARif,
    STATE(2196), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3717), 2,
      sym_line_comment,
      sym_block_comment,
  [112504] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3718), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6720), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
  [112521] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6722), 1,
      anon_sym_STAR_SLASH,
    STATE(3801), 1,
      aux_sym_block_comment_repeat1,
    ACTIONS(6680), 2,
      aux_sym_block_comment_token1,
      aux_sym_block_comment_token2,
    STATE(3719), 2,
      sym_line_comment,
      sym_block_comment,
  [112542] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5327), 1,
      anon_sym_LBRACE,
    ACTIONS(6724), 1,
      anon_sym_if,
    STATE(2202), 1,
      sym_block,
    STATE(2203), 1,
      sym_if_expression,
    STATE(3720), 2,
      sym_line_comment,
      sym_block_comment,
  [112565] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6674), 1,
      anon_sym_LPAREN,
    STATE(2323), 1,
      sym_signature,
    STATE(1695), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3721), 2,
      sym_line_comment,
      sym_block_comment,
  [112586] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(6726), 1,
      anon_sym_DOLLARif,
    STATE(2180), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3722), 2,
      sym_line_comment,
      sym_block_comment,
  [112607] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3723), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6728), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
  [112624] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(6726), 1,
      anon_sym_DOLLARif,
    STATE(2223), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3724), 2,
      sym_line_comment,
      sym_block_comment,
  [112645] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6698), 1,
      sym_identifier,
    ACTIONS(6730), 1,
      anon_sym_RPAREN,
    STATE(3814), 1,
      sym_const_definition,
    STATE(3818), 1,
      aux_sym_const_declaration_repeat1,
    STATE(3725), 2,
      sym_line_comment,
      sym_block_comment,
  [112668] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    ACTIONS(6732), 1,
      anon_sym_if,
    STATE(2221), 1,
      sym_if_expression,
    STATE(2222), 1,
      sym_block,
    STATE(3726), 2,
      sym_line_comment,
      sym_block_comment,
  [112691] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6734), 1,
      anon_sym_LPAREN,
    STATE(2771), 1,
      sym_signature,
    STATE(1907), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3727), 2,
      sym_line_comment,
      sym_block_comment,
  [112712] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6736), 1,
      sym_identifier,
    ACTIONS(6738), 1,
      anon_sym_RPAREN,
    STATE(3825), 1,
      sym_global_var_definition,
    STATE(3826), 1,
      aux_sym_global_var_declaration_repeat1,
    STATE(3728), 2,
      sym_line_comment,
      sym_block_comment,
  [112735] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6740), 1,
      anon_sym_EQ,
    STATE(4471), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(3729), 2,
      sym_line_comment,
      sym_block_comment,
  [112756] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    ACTIONS(6742), 1,
      anon_sym_DOLLARif,
    STATE(383), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3730), 2,
      sym_line_comment,
      sym_block_comment,
  [112777] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    ACTIONS(6744), 1,
      anon_sym_if,
    STATE(379), 1,
      sym_if_expression,
    STATE(380), 1,
      sym_block,
    STATE(3731), 2,
      sym_line_comment,
      sym_block_comment,
  [112800] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2173), 1,
      anon_sym_DOT,
    STATE(3732), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6746), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT2,
  [112819] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6748), 1,
      sym_identifier,
    ACTIONS(6750), 1,
      anon_sym_RBRACE,
    STATE(3675), 1,
      sym_enum_field_definition,
    STATE(3766), 1,
      aux_sym__enum_body_repeat1,
    STATE(3733), 2,
      sym_line_comment,
      sym_block_comment,
  [112842] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1772), 1,
      sym_signature,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3734), 2,
      sym_line_comment,
      sym_block_comment,
  [112863] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6752), 1,
      anon_sym_LPAREN,
    STATE(1086), 1,
      sym_signature,
    STATE(2940), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3735), 2,
      sym_line_comment,
      sym_block_comment,
  [112884] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4398), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3736), 2,
      sym_line_comment,
      sym_block_comment,
  [112905] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6754), 1,
      anon_sym_COMMA,
    STATE(3757), 1,
      aux_sym_generic_parameters_repeat1,
    ACTIONS(6756), 2,
      anon_sym_GT,
      anon_sym_RBRACK,
    STATE(3737), 2,
      sym_line_comment,
      sym_block_comment,
  [112926] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6758), 1,
      sym_identifier,
    STATE(3981), 1,
      sym_generic_parameter,
    ACTIONS(6756), 2,
      anon_sym_GT,
      anon_sym_RBRACK,
    STATE(3738), 2,
      sym_line_comment,
      sym_block_comment,
  [112947] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6716), 1,
      anon_sym_as,
    ACTIONS(6718), 1,
      anon_sym_LBRACE,
    STATE(1799), 1,
      sym__enum_body,
    STATE(4385), 1,
      sym_enum_backed_type,
    STATE(3739), 2,
      sym_line_comment,
      sym_block_comment,
  [112970] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6760), 1,
      sym_identifier,
    ACTIONS(6762), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(1302), 2,
      sym_reference_expression,
      sym_compile_time_selector_expression,
    STATE(3740), 2,
      sym_line_comment,
      sym_block_comment,
  [112991] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4194), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3741), 2,
      sym_line_comment,
      sym_block_comment,
  [113012] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5309), 1,
      anon_sym_LBRACE,
    ACTIONS(6764), 1,
      anon_sym_DOLLARif,
    STATE(1162), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3742), 2,
      sym_line_comment,
      sym_block_comment,
  [113033] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5311), 1,
      anon_sym_LBRACE,
    ACTIONS(6766), 1,
      anon_sym_if,
    STATE(2973), 1,
      sym_block,
    STATE(2975), 1,
      sym_if_expression,
    STATE(3743), 2,
      sym_line_comment,
      sym_block_comment,
  [113056] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5311), 1,
      anon_sym_LBRACE,
    ACTIONS(6768), 1,
      anon_sym_DOLLARif,
    STATE(2971), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3744), 2,
      sym_line_comment,
      sym_block_comment,
  [113077] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(2503), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3745), 2,
      sym_line_comment,
      sym_block_comment,
  [113098] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6758), 1,
      sym_identifier,
    STATE(3981), 1,
      sym_generic_parameter,
    ACTIONS(6770), 2,
      anon_sym_GT,
      anon_sym_RBRACK,
    STATE(3746), 2,
      sym_line_comment,
      sym_block_comment,
  [113119] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5317), 1,
      anon_sym_LBRACE,
    ACTIONS(6772), 1,
      anon_sym_if,
    STATE(1044), 1,
      sym_block,
    STATE(1046), 1,
      sym_if_expression,
    STATE(3747), 2,
      sym_line_comment,
      sym_block_comment,
  [113142] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5317), 1,
      anon_sym_LBRACE,
    ACTIONS(6774), 1,
      anon_sym_DOLLARif,
    STATE(1043), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3748), 2,
      sym_line_comment,
      sym_block_comment,
  [113163] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5309), 1,
      anon_sym_LBRACE,
    ACTIONS(6764), 1,
      anon_sym_DOLLARif,
    STATE(1168), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3749), 2,
      sym_line_comment,
      sym_block_comment,
  [113184] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6776), 1,
      anon_sym_LPAREN,
    STATE(1406), 1,
      sym_signature,
    STATE(544), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3750), 2,
      sym_line_comment,
      sym_block_comment,
  [113205] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5311), 1,
      anon_sym_LBRACE,
    ACTIONS(6768), 1,
      anon_sym_DOLLARif,
    STATE(2966), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3751), 2,
      sym_line_comment,
      sym_block_comment,
  [113226] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5309), 1,
      anon_sym_LBRACE,
    ACTIONS(6778), 1,
      anon_sym_if,
    STATE(1169), 1,
      sym_block,
    STATE(1172), 1,
      sym_if_expression,
    STATE(3752), 2,
      sym_line_comment,
      sym_block_comment,
  [113249] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6780), 1,
      sym_identifier,
    ACTIONS(6782), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(2707), 2,
      sym_reference_expression,
      sym_compile_time_selector_expression,
    STATE(3753), 2,
      sym_line_comment,
      sym_block_comment,
  [113270] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4235), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3754), 2,
      sym_line_comment,
      sym_block_comment,
  [113291] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6784), 1,
      sym_identifier,
    ACTIONS(6787), 1,
      anon_sym_RPAREN,
    STATE(3825), 1,
      sym_global_var_definition,
    STATE(3755), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_global_var_declaration_repeat1,
  [113312] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5329), 1,
      anon_sym_LBRACE,
    ACTIONS(6789), 1,
      anon_sym_if,
    STATE(1300), 1,
      sym_block,
    STATE(1354), 1,
      sym_if_expression,
    STATE(3756), 2,
      sym_line_comment,
      sym_block_comment,
  [113335] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6791), 1,
      anon_sym_COMMA,
    ACTIONS(6794), 2,
      anon_sym_GT,
      anon_sym_RBRACK,
    STATE(3757), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_generic_parameters_repeat1,
  [113354] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5329), 1,
      anon_sym_LBRACE,
    ACTIONS(6796), 1,
      anon_sym_DOLLARif,
    STATE(1352), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3758), 2,
      sym_line_comment,
      sym_block_comment,
  [113375] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6798), 1,
      anon_sym_COMMA,
    ACTIONS(6801), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(3759), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_type_parameters_repeat1,
  [113394] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6803), 1,
      sym_identifier,
    ACTIONS(6806), 1,
      anon_sym_RPAREN,
    STATE(3814), 1,
      sym_const_definition,
    STATE(3760), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_const_declaration_repeat1,
  [113415] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5317), 1,
      anon_sym_LBRACE,
    ACTIONS(6774), 1,
      anon_sym_DOLLARif,
    STATE(1034), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3761), 2,
      sym_line_comment,
      sym_block_comment,
  [113436] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1760), 1,
      sym_signature,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3762), 2,
      sym_line_comment,
      sym_block_comment,
  [113457] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5329), 1,
      anon_sym_LBRACE,
    ACTIONS(6796), 1,
      anon_sym_DOLLARif,
    STATE(1345), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3763), 2,
      sym_line_comment,
      sym_block_comment,
  [113478] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3764), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6808), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
  [113495] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6810), 1,
      sym_identifier,
    ACTIONS(6812), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(2106), 2,
      sym_reference_expression,
      sym_compile_time_selector_expression,
    STATE(3765), 2,
      sym_line_comment,
      sym_block_comment,
  [113516] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6814), 1,
      sym_identifier,
    ACTIONS(6817), 1,
      anon_sym_RBRACE,
    STATE(3675), 1,
      sym_enum_field_definition,
    STATE(3766), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym__enum_body_repeat1,
  [113537] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    ACTIONS(6819), 1,
      anon_sym_DOLLARif,
    STATE(2684), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3767), 2,
      sym_line_comment,
      sym_block_comment,
  [113558] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6716), 1,
      anon_sym_as,
    ACTIONS(6718), 1,
      anon_sym_LBRACE,
    STATE(1786), 1,
      sym__enum_body,
    STATE(4118), 1,
      sym_enum_backed_type,
    STATE(3768), 2,
      sym_line_comment,
      sym_block_comment,
  [113581] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1770), 1,
      sym_signature,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3769), 2,
      sym_line_comment,
      sym_block_comment,
  [113602] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6736), 1,
      sym_identifier,
    ACTIONS(6821), 1,
      anon_sym_RPAREN,
    STATE(3797), 1,
      aux_sym_global_var_declaration_repeat1,
    STATE(3825), 1,
      sym_global_var_definition,
    STATE(3770), 2,
      sym_line_comment,
      sym_block_comment,
  [113625] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6698), 1,
      sym_identifier,
    ACTIONS(6823), 1,
      anon_sym_RPAREN,
    STATE(3706), 1,
      aux_sym_const_declaration_repeat1,
    STATE(3814), 1,
      sym_const_definition,
    STATE(3771), 2,
      sym_line_comment,
      sym_block_comment,
  [113648] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6752), 1,
      anon_sym_LPAREN,
    STATE(3477), 1,
      sym_signature,
    STATE(2532), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3772), 2,
      sym_line_comment,
      sym_block_comment,
  [113669] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6825), 1,
      sym_identifier,
    ACTIONS(6827), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(456), 2,
      sym_reference_expression,
      sym_compile_time_selector_expression,
    STATE(3773), 2,
      sym_line_comment,
      sym_block_comment,
  [113690] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6716), 1,
      anon_sym_as,
    ACTIONS(6718), 1,
      anon_sym_LBRACE,
    STATE(1816), 1,
      sym__enum_body,
    STATE(4110), 1,
      sym_enum_backed_type,
    STATE(3774), 2,
      sym_line_comment,
      sym_block_comment,
  [113713] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    ACTIONS(6819), 1,
      anon_sym_DOLLARif,
    STATE(2679), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3775), 2,
      sym_line_comment,
      sym_block_comment,
  [113734] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    ACTIONS(6829), 1,
      anon_sym_if,
    STATE(2677), 1,
      sym_if_expression,
    STATE(2678), 1,
      sym_block,
    STATE(3776), 2,
      sym_line_comment,
      sym_block_comment,
  [113757] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6831), 1,
      sym_identifier,
    ACTIONS(6833), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(2307), 2,
      sym_reference_expression,
      sym_compile_time_selector_expression,
    STATE(3777), 2,
      sym_line_comment,
      sym_block_comment,
  [113778] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3778), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4711), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
  [113795] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6463), 1,
      anon_sym_mut,
    ACTIONS(6465), 1,
      anon_sym_shared,
    ACTIONS(6835), 1,
      sym_identifier,
    STATE(4698), 1,
      sym_mutability_modifiers,
    STATE(3779), 2,
      sym_line_comment,
      sym_block_comment,
  [113818] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6837), 1,
      anon_sym_EQ,
    STATE(4697), 1,
      sym_generic_parameters,
    ACTIONS(5229), 2,
      anon_sym_LBRACK,
      anon_sym_LT2,
    STATE(3780), 2,
      sym_line_comment,
      sym_block_comment,
  [113839] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5315), 1,
      anon_sym_LBRACE,
    ACTIONS(6839), 1,
      anon_sym_DOLLARif,
    STATE(1524), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3781), 2,
      sym_line_comment,
      sym_block_comment,
  [113860] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6841), 1,
      anon_sym_LPAREN,
    STATE(1255), 1,
      sym_signature,
    STATE(236), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3782), 2,
      sym_line_comment,
      sym_block_comment,
  [113881] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6843), 1,
      anon_sym_LPAREN,
    STATE(517), 1,
      sym_signature,
    STATE(93), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3783), 2,
      sym_line_comment,
      sym_block_comment,
  [113902] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3784), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6845), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
  [113919] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6698), 1,
      sym_identifier,
    ACTIONS(6847), 1,
      anon_sym_RPAREN,
    STATE(3710), 1,
      aux_sym_const_declaration_repeat1,
    STATE(3814), 1,
      sym_const_definition,
    STATE(3785), 2,
      sym_line_comment,
      sym_block_comment,
  [113942] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3786), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4719), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
  [113959] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1768), 1,
      sym_signature,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3787), 2,
      sym_line_comment,
      sym_block_comment,
  [113980] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6849), 1,
      sym_identifier,
    ACTIONS(6851), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(1062), 2,
      sym_reference_expression,
      sym_compile_time_selector_expression,
    STATE(3788), 2,
      sym_line_comment,
      sym_block_comment,
  [114001] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4179), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3789), 2,
      sym_line_comment,
      sym_block_comment,
  [114022] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4333), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3790), 2,
      sym_line_comment,
      sym_block_comment,
  [114043] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6853), 1,
      anon_sym_LPAREN,
    STATE(2503), 1,
      sym_signature,
    STATE(1700), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3791), 2,
      sym_line_comment,
      sym_block_comment,
  [114064] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4365), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3792), 2,
      sym_line_comment,
      sym_block_comment,
  [114085] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4225), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3793), 2,
      sym_line_comment,
      sym_block_comment,
  [114106] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6752), 1,
      anon_sym_LPAREN,
    STATE(3476), 1,
      sym_signature,
    STATE(2532), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3794), 2,
      sym_line_comment,
      sym_block_comment,
  [114127] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4305), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3795), 2,
      sym_line_comment,
      sym_block_comment,
  [114148] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4397), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3796), 2,
      sym_line_comment,
      sym_block_comment,
  [114169] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6736), 1,
      sym_identifier,
    ACTIONS(6855), 1,
      anon_sym_RPAREN,
    STATE(3755), 1,
      aux_sym_global_var_declaration_repeat1,
    STATE(3825), 1,
      sym_global_var_definition,
    STATE(3797), 2,
      sym_line_comment,
      sym_block_comment,
  [114192] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5315), 1,
      anon_sym_LBRACE,
    ACTIONS(6839), 1,
      anon_sym_DOLLARif,
    STATE(1510), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3798), 2,
      sym_line_comment,
      sym_block_comment,
  [114213] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5331), 1,
      anon_sym_LBRACE,
    ACTIONS(6857), 1,
      anon_sym_DOLLARif,
    STATE(1623), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3799), 2,
      sym_line_comment,
      sym_block_comment,
  [114234] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4371), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3800), 2,
      sym_line_comment,
      sym_block_comment,
  [114255] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6862), 1,
      anon_sym_STAR_SLASH,
    ACTIONS(6859), 2,
      aux_sym_block_comment_token1,
      aux_sym_block_comment_token2,
    STATE(3801), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_block_comment_repeat1,
  [114274] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5315), 1,
      anon_sym_LBRACE,
    ACTIONS(6864), 1,
      anon_sym_if,
    STATE(1435), 1,
      sym_if_expression,
    STATE(1509), 1,
      sym_block,
    STATE(3802), 2,
      sym_line_comment,
      sym_block_comment,
  [114297] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1758), 1,
      sym_signature,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3803), 2,
      sym_line_comment,
      sym_block_comment,
  [114318] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6866), 1,
      sym_identifier,
    ACTIONS(6868), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(1658), 2,
      sym_reference_expression,
      sym_compile_time_selector_expression,
    STATE(3804), 2,
      sym_line_comment,
      sym_block_comment,
  [114339] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4287), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3805), 2,
      sym_line_comment,
      sym_block_comment,
  [114360] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3806), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6612), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
  [114377] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4378), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3807), 2,
      sym_line_comment,
      sym_block_comment,
  [114398] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5331), 1,
      anon_sym_LBRACE,
    ACTIONS(6857), 1,
      anon_sym_DOLLARif,
    STATE(1600), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3808), 2,
      sym_line_comment,
      sym_block_comment,
  [114419] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5331), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_if,
    STATE(1601), 1,
      sym_block,
    STATE(1602), 1,
      sym_if_expression,
    STATE(3809), 2,
      sym_line_comment,
      sym_block_comment,
  [114442] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4299), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3810), 2,
      sym_line_comment,
      sym_block_comment,
  [114463] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6748), 1,
      sym_identifier,
    ACTIONS(6872), 1,
      anon_sym_RBRACE,
    STATE(3675), 1,
      sym_enum_field_definition,
    STATE(3733), 1,
      aux_sym__enum_body_repeat1,
    STATE(3811), 2,
      sym_line_comment,
      sym_block_comment,
  [114486] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6874), 1,
      anon_sym_LPAREN,
    STATE(2074), 1,
      sym_signature,
    STATE(1443), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3812), 2,
      sym_line_comment,
      sym_block_comment,
  [114507] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4265), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3813), 2,
      sym_line_comment,
      sym_block_comment,
  [114528] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3814), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6876), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
  [114545] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6878), 1,
      anon_sym_DOT,
    ACTIONS(6880), 1,
      anon_sym_RBRACE,
    ACTIONS(6882), 1,
      sym_int_literal,
    ACTIONS(6884), 1,
      aux_sym_format_specifier_token1,
    STATE(3815), 2,
      sym_line_comment,
      sym_block_comment,
  [114568] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4360), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3816), 2,
      sym_line_comment,
      sym_block_comment,
  [114589] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4190), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3817), 2,
      sym_line_comment,
      sym_block_comment,
  [114610] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6698), 1,
      sym_identifier,
    ACTIONS(6847), 1,
      anon_sym_RPAREN,
    STATE(3760), 1,
      aux_sym_const_declaration_repeat1,
    STATE(3814), 1,
      sym_const_definition,
    STATE(3818), 2,
      sym_line_comment,
      sym_block_comment,
  [114633] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4145), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3819), 2,
      sym_line_comment,
      sym_block_comment,
  [114654] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5325), 1,
      anon_sym_LBRACE,
    ACTIONS(6886), 1,
      anon_sym_if,
    STATE(2497), 1,
      sym_block,
    STATE(2501), 1,
      sym_if_expression,
    STATE(3820), 2,
      sym_line_comment,
      sym_block_comment,
  [114677] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5325), 1,
      anon_sym_LBRACE,
    ACTIONS(6888), 1,
      anon_sym_DOLLARif,
    STATE(2496), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3821), 2,
      sym_line_comment,
      sym_block_comment,
  [114698] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    ACTIONS(6742), 1,
      anon_sym_DOLLARif,
    STATE(334), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3822), 2,
      sym_line_comment,
      sym_block_comment,
  [114719] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4189), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3823), 2,
      sym_line_comment,
      sym_block_comment,
  [114740] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1753), 1,
      sym_signature,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3824), 2,
      sym_line_comment,
      sym_block_comment,
  [114761] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(3825), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6890), 4,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_SEMI,
  [114778] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6736), 1,
      sym_identifier,
    ACTIONS(6892), 1,
      anon_sym_RPAREN,
    STATE(3755), 1,
      aux_sym_global_var_declaration_repeat1,
    STATE(3825), 1,
      sym_global_var_definition,
    STATE(3826), 2,
      sym_line_comment,
      sym_block_comment,
  [114801] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4228), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3827), 2,
      sym_line_comment,
      sym_block_comment,
  [114822] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1763), 1,
      sym_signature,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3828), 2,
      sym_line_comment,
      sym_block_comment,
  [114843] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4219), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3829), 2,
      sym_line_comment,
      sym_block_comment,
  [114864] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5325), 1,
      anon_sym_LBRACE,
    ACTIONS(6888), 1,
      anon_sym_DOLLARif,
    STATE(2469), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3830), 2,
      sym_line_comment,
      sym_block_comment,
  [114885] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4263), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3831), 2,
      sym_line_comment,
      sym_block_comment,
  [114906] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4181), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3832), 2,
      sym_line_comment,
      sym_block_comment,
  [114927] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6894), 1,
      sym_identifier,
    ACTIONS(6896), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(1202), 2,
      sym_reference_expression,
      sym_compile_time_selector_expression,
    STATE(3833), 2,
      sym_line_comment,
      sym_block_comment,
  [114948] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6898), 1,
      anon_sym_LPAREN,
    STATE(1086), 1,
      sym_signature,
    STATE(101), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3834), 2,
      sym_line_comment,
      sym_block_comment,
  [114969] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_LPAREN,
    STATE(1778), 1,
      sym_signature,
    STATE(1340), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3835), 2,
      sym_line_comment,
      sym_block_comment,
  [114990] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6900), 1,
      sym_identifier,
    ACTIONS(6902), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(2830), 2,
      sym_reference_expression,
      sym_compile_time_selector_expression,
    STATE(3836), 2,
      sym_line_comment,
      sym_block_comment,
  [115011] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4391), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3837), 2,
      sym_line_comment,
      sym_block_comment,
  [115032] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5319), 1,
      anon_sym_LBRACE,
    ACTIONS(6904), 1,
      anon_sym_DOLLARif,
    STATE(2302), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3838), 2,
      sym_line_comment,
      sym_block_comment,
  [115053] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5319), 1,
      anon_sym_LBRACE,
    ACTIONS(6906), 1,
      anon_sym_if,
    STATE(2293), 1,
      sym_if_expression,
    STATE(2294), 1,
      sym_block,
    STATE(3839), 2,
      sym_line_comment,
      sym_block_comment,
  [115076] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5319), 1,
      anon_sym_LBRACE,
    ACTIONS(6904), 1,
      anon_sym_DOLLARif,
    STATE(2295), 2,
      sym_compile_time_if_expression,
      sym_block,
    STATE(3840), 2,
      sym_line_comment,
      sym_block_comment,
  [115097] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    STATE(4344), 1,
      sym_signature,
    STATE(2941), 2,
      sym_parameter_list,
      sym_type_parameter_list,
    STATE(3841), 2,
      sym_line_comment,
      sym_block_comment,
  [115118] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6908), 1,
      anon_sym_COMMA,
    STATE(3737), 1,
      aux_sym_generic_parameters_repeat1,
    ACTIONS(6910), 2,
      anon_sym_GT,
      anon_sym_RBRACK,
    STATE(3842), 2,
      sym_line_comment,
      sym_block_comment,
  [115139] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3843), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6912), 3,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACK,
  [115155] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6914), 1,
      anon_sym_COMMA,
    ACTIONS(6916), 1,
      anon_sym_RPAREN,
    STATE(4035), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3844), 2,
      sym_line_comment,
      sym_block_comment,
  [115175] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6918), 1,
      sym_identifier,
    ACTIONS(6920), 1,
      anon_sym_LBRACE,
    STATE(1670), 1,
      sym__content_block,
    STATE(3845), 2,
      sym_line_comment,
      sym_block_comment,
  [115195] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6922), 1,
      anon_sym_SQUOTE,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    STATE(3861), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(3846), 2,
      sym_line_comment,
      sym_block_comment,
  [115215] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(6926), 1,
      anon_sym_RBRACK,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3847), 2,
      sym_line_comment,
      sym_block_comment,
  [115235] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6922), 1,
      anon_sym_DQUOTE,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    STATE(3863), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(3848), 2,
      sym_line_comment,
      sym_block_comment,
  [115255] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(6932), 1,
      anon_sym_RPAREN,
    STATE(3996), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(3849), 2,
      sym_line_comment,
      sym_block_comment,
  [115275] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(6934), 1,
      anon_sym_RPAREN,
    STATE(4003), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(3850), 2,
      sym_line_comment,
      sym_block_comment,
  [115295] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(6938), 1,
      anon_sym_RPAREN,
    STATE(4023), 1,
      aux_sym_parameter_list_repeat1,
    STATE(3851), 2,
      sym_line_comment,
      sym_block_comment,
  [115315] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6940), 1,
      anon_sym_COMMA,
    ACTIONS(6942), 1,
      anon_sym_RBRACK,
    STATE(4009), 1,
      aux_sym_capture_list_repeat1,
    STATE(3852), 2,
      sym_line_comment,
      sym_block_comment,
  [115335] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(6944), 1,
      anon_sym_RPAREN,
    STATE(3991), 1,
      aux_sym_parameter_list_repeat1,
    STATE(3853), 2,
      sym_line_comment,
      sym_block_comment,
  [115355] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6946), 1,
      anon_sym_COMMA,
    ACTIONS(6948), 1,
      anon_sym_RPAREN,
    STATE(3881), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3854), 2,
      sym_line_comment,
      sym_block_comment,
  [115375] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(6950), 1,
      anon_sym_RPAREN,
    STATE(3890), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(3855), 2,
      sym_line_comment,
      sym_block_comment,
  [115395] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6952), 1,
      anon_sym_COMMA,
    ACTIONS(6954), 1,
      anon_sym_PIPE,
    STATE(4077), 1,
      aux_sym_short_lambda_repeat1,
    STATE(3856), 2,
      sym_line_comment,
      sym_block_comment,
  [115415] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(6956), 1,
      anon_sym_RBRACK,
    STATE(3847), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3857), 2,
      sym_line_comment,
      sym_block_comment,
  [115435] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(6958), 1,
      anon_sym_RPAREN,
    STATE(3888), 1,
      aux_sym_parameter_list_repeat1,
    STATE(3858), 2,
      sym_line_comment,
      sym_block_comment,
  [115455] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(6960), 1,
      anon_sym_RBRACK,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3859), 2,
      sym_line_comment,
      sym_block_comment,
  [115475] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5981), 1,
      anon_sym_RPAREN,
    ACTIONS(6962), 1,
      anon_sym_COMMA,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3860), 2,
      sym_line_comment,
      sym_block_comment,
  [115495] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(6964), 1,
      anon_sym_SQUOTE,
    STATE(3953), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(3861), 2,
      sym_line_comment,
      sym_block_comment,
  [115515] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5989), 1,
      anon_sym_RPAREN,
    ACTIONS(6966), 1,
      anon_sym_COMMA,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3862), 2,
      sym_line_comment,
      sym_block_comment,
  [115535] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(6964), 1,
      anon_sym_DQUOTE,
    STATE(3913), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(3863), 2,
      sym_line_comment,
      sym_block_comment,
  [115555] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6968), 1,
      sym_identifier,
    ACTIONS(6970), 1,
      anon_sym_LBRACE,
    STATE(2650), 1,
      sym__content_block,
    STATE(3864), 2,
      sym_line_comment,
      sym_block_comment,
  [115575] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(6972), 1,
      anon_sym_RBRACK,
    STATE(3922), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3865), 2,
      sym_line_comment,
      sym_block_comment,
  [115595] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5941), 1,
      anon_sym_RPAREN,
    ACTIONS(6974), 1,
      anon_sym_COMMA,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3866), 2,
      sym_line_comment,
      sym_block_comment,
  [115615] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(6976), 1,
      anon_sym_RPAREN,
    STATE(3912), 1,
      aux_sym_parameter_list_repeat1,
    STATE(3867), 2,
      sym_line_comment,
      sym_block_comment,
  [115635] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(6978), 1,
      anon_sym_RPAREN,
    STATE(3886), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(3868), 2,
      sym_line_comment,
      sym_block_comment,
  [115655] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(6980), 1,
      anon_sym_SQUOTE,
    STATE(3897), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(3869), 2,
      sym_line_comment,
      sym_block_comment,
  [115675] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(6980), 1,
      anon_sym_DQUOTE,
    STATE(3898), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(3870), 2,
      sym_line_comment,
      sym_block_comment,
  [115695] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(6982), 1,
      anon_sym_RPAREN,
    STATE(4003), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(3871), 2,
      sym_line_comment,
      sym_block_comment,
  [115715] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(6984), 1,
      anon_sym_RPAREN,
    STATE(4023), 1,
      aux_sym_parameter_list_repeat1,
    STATE(3872), 2,
      sym_line_comment,
      sym_block_comment,
  [115735] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6986), 1,
      anon_sym_COMMA,
    ACTIONS(6988), 1,
      anon_sym_RPAREN,
    STATE(4017), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3873), 2,
      sym_line_comment,
      sym_block_comment,
  [115755] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6878), 1,
      anon_sym_DOT,
    ACTIONS(6880), 1,
      anon_sym_RBRACE,
    ACTIONS(6884), 1,
      aux_sym_format_specifier_token1,
    STATE(3874), 2,
      sym_line_comment,
      sym_block_comment,
  [115775] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(6990), 1,
      anon_sym_RPAREN,
    STATE(3850), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(3875), 2,
      sym_line_comment,
      sym_block_comment,
  [115795] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(6992), 1,
      anon_sym_DQUOTE,
    STATE(3913), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(3876), 2,
      sym_line_comment,
      sym_block_comment,
  [115815] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3316), 1,
      anon_sym_COMMA,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    STATE(2721), 1,
      sym_block,
    STATE(3877), 2,
      sym_line_comment,
      sym_block_comment,
  [115835] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2651), 1,
      sym_type_initializer_body,
    ACTIONS(3310), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    STATE(3878), 2,
      sym_line_comment,
      sym_block_comment,
  [115853] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(6992), 1,
      anon_sym_SQUOTE,
    STATE(3953), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(3879), 2,
      sym_line_comment,
      sym_block_comment,
  [115873] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(6994), 1,
      anon_sym_RPAREN,
    STATE(3851), 1,
      aux_sym_parameter_list_repeat1,
    STATE(3880), 2,
      sym_line_comment,
      sym_block_comment,
  [115893] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5959), 1,
      anon_sym_RPAREN,
    ACTIONS(6996), 1,
      anon_sym_COMMA,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3881), 2,
      sym_line_comment,
      sym_block_comment,
  [115913] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(6998), 1,
      anon_sym_RBRACK,
    STATE(3893), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3882), 2,
      sym_line_comment,
      sym_block_comment,
  [115933] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3306), 1,
      anon_sym_COMMA,
    ACTIONS(7000), 1,
      anon_sym_LBRACE,
    STATE(2651), 1,
      sym_type_initializer_body,
    STATE(3883), 2,
      sym_line_comment,
      sym_block_comment,
  [115953] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7002), 1,
      anon_sym_RBRACK,
    STATE(3859), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3884), 2,
      sym_line_comment,
      sym_block_comment,
  [115973] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2651), 1,
      sym_type_initializer_body,
    ACTIONS(3302), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    STATE(3885), 2,
      sym_line_comment,
      sym_block_comment,
  [115991] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7004), 1,
      anon_sym_RPAREN,
    STATE(4003), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(3886), 2,
      sym_line_comment,
      sym_block_comment,
  [116011] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6670), 1,
      anon_sym_COMMA,
    ACTIONS(6672), 1,
      anon_sym_RPAREN,
    STATE(3860), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3887), 2,
      sym_line_comment,
      sym_block_comment,
  [116031] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7006), 1,
      anon_sym_RPAREN,
    STATE(4023), 1,
      aux_sym_parameter_list_repeat1,
    STATE(3888), 2,
      sym_line_comment,
      sym_block_comment,
  [116051] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7008), 1,
      anon_sym_COMMA,
    ACTIONS(7011), 1,
      anon_sym_COLON_EQ,
    STATE(3889), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_identifier_list_repeat1,
  [116069] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7013), 1,
      anon_sym_RPAREN,
    STATE(4003), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(3890), 2,
      sym_line_comment,
      sym_block_comment,
  [116089] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(7015), 1,
      anon_sym_DQUOTE,
    STATE(3913), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(3891), 2,
      sym_line_comment,
      sym_block_comment,
  [116109] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7017), 1,
      anon_sym_SEMI,
    ACTIONS(7019), 1,
      anon_sym_RBRACK,
    STATE(4018), 1,
      aux_sym_attribute_repeat1,
    STATE(3892), 2,
      sym_line_comment,
      sym_block_comment,
  [116129] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7021), 1,
      anon_sym_RBRACK,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3893), 2,
      sym_line_comment,
      sym_block_comment,
  [116149] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(7015), 1,
      anon_sym_SQUOTE,
    STATE(3953), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(3894), 2,
      sym_line_comment,
      sym_block_comment,
  [116169] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7023), 1,
      anon_sym_RPAREN,
    STATE(3871), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(3895), 2,
      sym_line_comment,
      sym_block_comment,
  [116189] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7025), 1,
      anon_sym_COMMA,
    ACTIONS(7027), 1,
      anon_sym_RPAREN,
    STATE(3909), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3896), 2,
      sym_line_comment,
      sym_block_comment,
  [116209] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(7029), 1,
      anon_sym_SQUOTE,
    STATE(3953), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(3897), 2,
      sym_line_comment,
      sym_block_comment,
  [116229] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(7029), 1,
      anon_sym_DQUOTE,
    STATE(3913), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(3898), 2,
      sym_line_comment,
      sym_block_comment,
  [116249] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7031), 1,
      anon_sym_RPAREN,
    STATE(3872), 1,
      aux_sym_parameter_list_repeat1,
    STATE(3899), 2,
      sym_line_comment,
      sym_block_comment,
  [116269] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5098), 1,
      anon_sym_COMMA,
    ACTIONS(5100), 1,
      anon_sym_COLON_EQ,
    STATE(4033), 1,
      aux_sym_identifier_list_repeat1,
    STATE(3900), 2,
      sym_line_comment,
      sym_block_comment,
  [116289] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7033), 1,
      sym_identifier,
    ACTIONS(7035), 1,
      anon_sym_LBRACE,
    STATE(1241), 1,
      sym__content_block,
    STATE(3901), 2,
      sym_line_comment,
      sym_block_comment,
  [116309] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(7037), 1,
      anon_sym_SQUOTE,
    STATE(3915), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(3902), 2,
      sym_line_comment,
      sym_block_comment,
  [116329] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5915), 1,
      anon_sym_RPAREN,
    ACTIONS(7039), 1,
      anon_sym_COMMA,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3903), 2,
      sym_line_comment,
      sym_block_comment,
  [116349] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(7041), 1,
      anon_sym_DQUOTE,
    STATE(3913), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(3904), 2,
      sym_line_comment,
      sym_block_comment,
  [116369] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(7037), 1,
      anon_sym_DQUOTE,
    STATE(3921), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(3905), 2,
      sym_line_comment,
      sym_block_comment,
  [116389] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5505), 1,
      anon_sym_COMMA,
    ACTIONS(7043), 1,
      anon_sym_LBRACE,
    STATE(4011), 1,
      aux_sym_match_expression_list_repeat1,
    STATE(3906), 2,
      sym_line_comment,
      sym_block_comment,
  [116409] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4424), 1,
      anon_sym_LBRACE,
    ACTIONS(5475), 1,
      anon_sym_COMMA,
    STATE(3970), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(3907), 2,
      sym_line_comment,
      sym_block_comment,
  [116429] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(7041), 1,
      anon_sym_SQUOTE,
    STATE(3953), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(3908), 2,
      sym_line_comment,
      sym_block_comment,
  [116449] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5967), 1,
      anon_sym_RPAREN,
    ACTIONS(7045), 1,
      anon_sym_COMMA,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3909), 2,
      sym_line_comment,
      sym_block_comment,
  [116469] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7047), 1,
      anon_sym_RPAREN,
    STATE(3934), 1,
      aux_sym_parameter_list_repeat1,
    STATE(3910), 2,
      sym_line_comment,
      sym_block_comment,
  [116489] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7049), 1,
      anon_sym_RPAREN,
    STATE(3935), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(3911), 2,
      sym_line_comment,
      sym_block_comment,
  [116509] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7051), 1,
      anon_sym_RPAREN,
    STATE(4023), 1,
      aux_sym_parameter_list_repeat1,
    STATE(3912), 2,
      sym_line_comment,
      sym_block_comment,
  [116529] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7053), 1,
      anon_sym_DQUOTE,
    ACTIONS(7055), 1,
      aux_sym_raw_string_literal_token2,
    STATE(3913), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_raw_string_literal_repeat2,
  [116547] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7058), 1,
      sym_identifier,
    ACTIONS(7060), 1,
      anon_sym_LPAREN,
    STATE(1825), 1,
      sym_const_definition,
    STATE(3914), 2,
      sym_line_comment,
      sym_block_comment,
  [116567] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(7062), 1,
      anon_sym_SQUOTE,
    STATE(3953), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(3915), 2,
      sym_line_comment,
      sym_block_comment,
  [116587] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7064), 1,
      anon_sym_COMMA,
    ACTIONS(7066), 1,
      anon_sym_RPAREN,
    STATE(4040), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3916), 2,
      sym_line_comment,
      sym_block_comment,
  [116607] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7068), 1,
      anon_sym_COMMA,
    ACTIONS(7070), 1,
      anon_sym_RPAREN,
    STATE(3862), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3917), 2,
      sym_line_comment,
      sym_block_comment,
  [116627] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6624), 1,
      sym_identifier,
    ACTIONS(6626), 1,
      anon_sym_mut,
    STATE(4148), 1,
      sym_var_definition,
    STATE(3918), 2,
      sym_line_comment,
      sym_block_comment,
  [116647] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7072), 1,
      anon_sym_COMMA,
    ACTIONS(7074), 1,
      anon_sym_in,
    STATE(4050), 1,
      aux_sym_var_definition_list_repeat1,
    STATE(3919), 2,
      sym_line_comment,
      sym_block_comment,
  [116667] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5505), 1,
      anon_sym_COMMA,
    ACTIONS(7076), 1,
      anon_sym_LBRACE,
    STATE(4011), 1,
      aux_sym_match_expression_list_repeat1,
    STATE(3920), 2,
      sym_line_comment,
      sym_block_comment,
  [116687] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(7062), 1,
      anon_sym_DQUOTE,
    STATE(3913), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(3921), 2,
      sym_line_comment,
      sym_block_comment,
  [116707] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7078), 1,
      anon_sym_RBRACK,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3922), 2,
      sym_line_comment,
      sym_block_comment,
  [116727] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(7080), 1,
      anon_sym_DQUOTE,
    STATE(3876), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(3923), 2,
      sym_line_comment,
      sym_block_comment,
  [116747] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7082), 1,
      anon_sym_QMARK,
    ACTIONS(5549), 2,
      anon_sym_SEMI,
      anon_sym_RBRACK,
    STATE(3924), 2,
      sym_line_comment,
      sym_block_comment,
  [116765] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7084), 1,
      sym_identifier,
    ACTIONS(7086), 1,
      anon_sym_PIPE,
    STATE(4057), 1,
      sym_reference_expression,
    STATE(3925), 2,
      sym_line_comment,
      sym_block_comment,
  [116785] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(7080), 1,
      anon_sym_SQUOTE,
    STATE(3879), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(3926), 2,
      sym_line_comment,
      sym_block_comment,
  [116805] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7088), 1,
      sym_identifier,
    ACTIONS(7090), 1,
      anon_sym_LBRACE,
    STATE(1489), 1,
      sym__content_block,
    STATE(3927), 2,
      sym_line_comment,
      sym_block_comment,
  [116825] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(6668), 1,
      anon_sym_RBRACK,
    STATE(4058), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3928), 2,
      sym_line_comment,
      sym_block_comment,
  [116845] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7092), 1,
      anon_sym_RBRACK,
    STATE(3945), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3929), 2,
      sym_line_comment,
      sym_block_comment,
  [116865] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7058), 1,
      sym_identifier,
    ACTIONS(7094), 1,
      anon_sym_LPAREN,
    STATE(1829), 1,
      sym_const_definition,
    STATE(3930), 2,
      sym_line_comment,
      sym_block_comment,
  [116885] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(7096), 1,
      anon_sym_DQUOTE,
    STATE(3904), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(3931), 2,
      sym_line_comment,
      sym_block_comment,
  [116905] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(7096), 1,
      anon_sym_SQUOTE,
    STATE(3908), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(3932), 2,
      sym_line_comment,
      sym_block_comment,
  [116925] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7098), 1,
      sym_identifier,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    STATE(2472), 1,
      sym__content_block,
    STATE(3933), 2,
      sym_line_comment,
      sym_block_comment,
  [116945] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7102), 1,
      anon_sym_RPAREN,
    STATE(4023), 1,
      aux_sym_parameter_list_repeat1,
    STATE(3934), 2,
      sym_line_comment,
      sym_block_comment,
  [116965] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7104), 1,
      anon_sym_RPAREN,
    STATE(4003), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(3935), 2,
      sym_line_comment,
      sym_block_comment,
  [116985] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5963), 1,
      anon_sym_RPAREN,
    ACTIONS(7106), 1,
      anon_sym_COMMA,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3936), 2,
      sym_line_comment,
      sym_block_comment,
  [117005] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7108), 1,
      anon_sym_COMMA,
    ACTIONS(7110), 1,
      anon_sym_RPAREN,
    STATE(4046), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3937), 2,
      sym_line_comment,
      sym_block_comment,
  [117025] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7112), 1,
      anon_sym_COMMA,
    ACTIONS(7114), 1,
      anon_sym_RPAREN,
    STATE(4051), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3938), 2,
      sym_line_comment,
      sym_block_comment,
  [117045] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7116), 1,
      anon_sym_RPAREN,
    STATE(3964), 1,
      aux_sym_parameter_list_repeat1,
    STATE(3939), 2,
      sym_line_comment,
      sym_block_comment,
  [117065] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7118), 1,
      anon_sym_RPAREN,
    STATE(3965), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(3940), 2,
      sym_line_comment,
      sym_block_comment,
  [117085] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4428), 1,
      anon_sym_LBRACE,
    ACTIONS(5475), 1,
      anon_sym_COMMA,
    STATE(3970), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(3941), 2,
      sym_line_comment,
      sym_block_comment,
  [117105] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(7120), 1,
      anon_sym_DQUOTE,
    STATE(3891), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(3942), 2,
      sym_line_comment,
      sym_block_comment,
  [117125] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(7120), 1,
      anon_sym_SQUOTE,
    STATE(3894), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(3943), 2,
      sym_line_comment,
      sym_block_comment,
  [117145] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3944), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4315), 3,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [117161] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7122), 1,
      anon_sym_RBRACK,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3945), 2,
      sym_line_comment,
      sym_block_comment,
  [117181] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3946), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6650), 3,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [117197] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7072), 1,
      anon_sym_COMMA,
    ACTIONS(7124), 1,
      anon_sym_in,
    STATE(3919), 1,
      aux_sym_var_definition_list_repeat1,
    STATE(3947), 2,
      sym_line_comment,
      sym_block_comment,
  [117217] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7126), 1,
      anon_sym_COMMA,
    ACTIONS(7128), 1,
      anon_sym_RPAREN,
    STATE(3936), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3948), 2,
      sym_line_comment,
      sym_block_comment,
  [117237] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7058), 1,
      sym_identifier,
    ACTIONS(7130), 1,
      anon_sym_LPAREN,
    STATE(1794), 1,
      sym_const_definition,
    STATE(3949), 2,
      sym_line_comment,
      sym_block_comment,
  [117257] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(7132), 1,
      anon_sym_DQUOTE,
    STATE(4069), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(3950), 2,
      sym_line_comment,
      sym_block_comment,
  [117277] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7134), 1,
      anon_sym_COMMA,
    ACTIONS(7136), 1,
      anon_sym_RPAREN,
    STATE(4070), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3951), 2,
      sym_line_comment,
      sym_block_comment,
  [117297] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7138), 1,
      sym_identifier,
    ACTIONS(7140), 1,
      anon_sym_LBRACE,
    STATE(2354), 1,
      sym__content_block,
    STATE(3952), 2,
      sym_line_comment,
      sym_block_comment,
  [117317] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7142), 1,
      anon_sym_SQUOTE,
    ACTIONS(7144), 1,
      aux_sym_raw_string_literal_token1,
    STATE(3953), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_raw_string_literal_repeat1,
  [117335] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(7147), 1,
      anon_sym_DQUOTE,
    STATE(3913), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(3954), 2,
      sym_line_comment,
      sym_block_comment,
  [117355] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(7147), 1,
      anon_sym_SQUOTE,
    STATE(3953), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(3955), 2,
      sym_line_comment,
      sym_block_comment,
  [117375] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7149), 1,
      anon_sym_RBRACK,
    STATE(3984), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3956), 2,
      sym_line_comment,
      sym_block_comment,
  [117395] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3957), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(7151), 3,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ,
  [117411] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5153), 1,
      anon_sym_LBRACE,
    ACTIONS(7153), 1,
      anon_sym_COMMA,
    STATE(3958), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_expression_without_blocks_list_repeat1,
  [117429] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7156), 1,
      anon_sym_COMMA,
    ACTIONS(7159), 1,
      anon_sym_RBRACK,
    STATE(3959), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_capture_list_repeat1,
  [117447] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3960), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(7161), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT2,
  [117463] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7163), 1,
      sym_identifier,
    ACTIONS(7165), 1,
      anon_sym_LBRACE,
    STATE(2214), 1,
      sym__content_block,
    STATE(3961), 2,
      sym_line_comment,
      sym_block_comment,
  [117483] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7167), 1,
      anon_sym_RBRACK,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3962), 2,
      sym_line_comment,
      sym_block_comment,
  [117503] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3963), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6801), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [117519] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7169), 1,
      anon_sym_RPAREN,
    STATE(4023), 1,
      aux_sym_parameter_list_repeat1,
    STATE(3964), 2,
      sym_line_comment,
      sym_block_comment,
  [117539] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7171), 1,
      anon_sym_RPAREN,
    STATE(4003), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(3965), 2,
      sym_line_comment,
      sym_block_comment,
  [117559] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(7173), 1,
      anon_sym_SQUOTE,
    STATE(3994), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(3966), 2,
      sym_line_comment,
      sym_block_comment,
  [117579] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(7173), 1,
      anon_sym_DQUOTE,
    STATE(3995), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(3967), 2,
      sym_line_comment,
      sym_block_comment,
  [117599] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7175), 1,
      anon_sym_RBRACK,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3968), 2,
      sym_line_comment,
      sym_block_comment,
  [117619] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(4017), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(7177), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(3969), 2,
      sym_line_comment,
      sym_block_comment,
  [117637] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3908), 1,
      anon_sym_LBRACE,
    ACTIONS(7179), 1,
      anon_sym_COMMA,
    STATE(3970), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_strictly_expression_list_repeat1,
  [117655] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3971), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(7182), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT2,
  [117671] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3862), 1,
      anon_sym_COLON_EQ,
    ACTIONS(5279), 1,
      anon_sym_COMMA,
    STATE(3980), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(3972), 2,
      sym_line_comment,
      sym_block_comment,
  [117691] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7184), 1,
      sym_identifier,
    ACTIONS(7186), 1,
      anon_sym_LBRACE,
    STATE(2939), 1,
      sym__content_block,
    STATE(3973), 2,
      sym_line_comment,
      sym_block_comment,
  [117711] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(7132), 1,
      anon_sym_SQUOTE,
    STATE(4071), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(3974), 2,
      sym_line_comment,
      sym_block_comment,
  [117731] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7190), 1,
      anon_sym_COLON,
    ACTIONS(7188), 2,
      anon_sym_SEMI,
      anon_sym_RBRACK,
    STATE(3975), 2,
      sym_line_comment,
      sym_block_comment,
  [117749] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7017), 1,
      anon_sym_SEMI,
    ACTIONS(7192), 1,
      anon_sym_RBRACK,
    STATE(3892), 1,
      aux_sym_attribute_repeat1,
    STATE(3976), 2,
      sym_line_comment,
      sym_block_comment,
  [117769] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5785), 1,
      anon_sym_COMMA,
    ACTIONS(6184), 1,
      anon_sym_LBRACE,
    STATE(3958), 1,
      aux_sym_expression_without_blocks_list_repeat1,
    STATE(3977), 2,
      sym_line_comment,
      sym_block_comment,
  [117789] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7194), 1,
      anon_sym_RBRACK,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3978), 2,
      sym_line_comment,
      sym_block_comment,
  [117809] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7196), 1,
      anon_sym_RPAREN,
    STATE(4003), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(3979), 2,
      sym_line_comment,
      sym_block_comment,
  [117829] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4424), 1,
      anon_sym_COLON_EQ,
    ACTIONS(5279), 1,
      anon_sym_COMMA,
    STATE(4010), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(3980), 2,
      sym_line_comment,
      sym_block_comment,
  [117849] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3981), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6794), 3,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACK,
  [117865] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3862), 1,
      anon_sym_LBRACE,
    ACTIONS(5475), 1,
      anon_sym_COMMA,
    STATE(3907), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(3982), 2,
      sym_line_comment,
      sym_block_comment,
  [117885] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(3983), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(7198), 3,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ,
  [117901] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7200), 1,
      anon_sym_RBRACK,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3984), 2,
      sym_line_comment,
      sym_block_comment,
  [117921] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7202), 1,
      anon_sym_RPAREN,
    STATE(4023), 1,
      aux_sym_parameter_list_repeat1,
    STATE(3985), 2,
      sym_line_comment,
      sym_block_comment,
  [117941] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7204), 1,
      anon_sym_RPAREN,
    STATE(4003), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(3986), 2,
      sym_line_comment,
      sym_block_comment,
  [117961] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7206), 1,
      anon_sym_RPAREN,
    STATE(4023), 1,
      aux_sym_parameter_list_repeat1,
    STATE(3987), 2,
      sym_line_comment,
      sym_block_comment,
  [117981] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7208), 1,
      anon_sym_RPAREN,
    STATE(4003), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(3988), 2,
      sym_line_comment,
      sym_block_comment,
  [118001] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7210), 1,
      anon_sym_COMMA,
    ACTIONS(7212), 1,
      anon_sym_RPAREN,
    STATE(4006), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3989), 2,
      sym_line_comment,
      sym_block_comment,
  [118021] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7214), 1,
      anon_sym_RPAREN,
    STATE(4023), 1,
      aux_sym_parameter_list_repeat1,
    STATE(3990), 2,
      sym_line_comment,
      sym_block_comment,
  [118041] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7216), 1,
      anon_sym_RPAREN,
    STATE(4023), 1,
      aux_sym_parameter_list_repeat1,
    STATE(3991), 2,
      sym_line_comment,
      sym_block_comment,
  [118061] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7218), 1,
      anon_sym_COMMA,
    ACTIONS(7220), 1,
      anon_sym_RPAREN,
    STATE(3866), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3992), 2,
      sym_line_comment,
      sym_block_comment,
  [118081] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7222), 1,
      anon_sym_RBRACK,
    STATE(3962), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3993), 2,
      sym_line_comment,
      sym_block_comment,
  [118101] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(7224), 1,
      anon_sym_SQUOTE,
    STATE(3953), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(3994), 2,
      sym_line_comment,
      sym_block_comment,
  [118121] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(7224), 1,
      anon_sym_DQUOTE,
    STATE(3913), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(3995), 2,
      sym_line_comment,
      sym_block_comment,
  [118141] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7226), 1,
      anon_sym_RPAREN,
    STATE(4003), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(3996), 2,
      sym_line_comment,
      sym_block_comment,
  [118161] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7228), 1,
      sym_identifier,
    ACTIONS(7230), 1,
      anon_sym_LBRACE,
    STATE(2095), 1,
      sym__content_block,
    STATE(3997), 2,
      sym_line_comment,
      sym_block_comment,
  [118181] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(7232), 1,
      anon_sym_SQUOTE,
    STATE(4014), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(3998), 2,
      sym_line_comment,
      sym_block_comment,
  [118201] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(7232), 1,
      anon_sym_DQUOTE,
    STATE(4015), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(3999), 2,
      sym_line_comment,
      sym_block_comment,
  [118221] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4959), 1,
      sym_identifier,
    ACTIONS(7234), 1,
      anon_sym_static,
    ACTIONS(7236), 1,
      anon_sym_volatile,
    STATE(4000), 2,
      sym_line_comment,
      sym_block_comment,
  [118241] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7238), 1,
      anon_sym_RBRACK,
    STATE(3968), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4001), 2,
      sym_line_comment,
      sym_block_comment,
  [118261] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(4002), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(7240), 3,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ,
  [118277] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7242), 1,
      anon_sym_COMMA,
    ACTIONS(7245), 1,
      anon_sym_RPAREN,
    STATE(4003), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_type_parameter_list_repeat1,
  [118295] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7247), 1,
      anon_sym_RBRACK,
    STATE(3978), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4004), 2,
      sym_line_comment,
      sym_block_comment,
  [118315] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(4005), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(7249), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT2,
  [118331] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5931), 1,
      anon_sym_RPAREN,
    ACTIONS(7251), 1,
      anon_sym_COMMA,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4006), 2,
      sym_line_comment,
      sym_block_comment,
  [118351] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7253), 1,
      anon_sym_RPAREN,
    STATE(4031), 1,
      aux_sym_parameter_list_repeat1,
    STATE(4007), 2,
      sym_line_comment,
      sym_block_comment,
  [118371] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7255), 1,
      anon_sym_RPAREN,
    STATE(4032), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(4008), 2,
      sym_line_comment,
      sym_block_comment,
  [118391] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6495), 1,
      anon_sym_RBRACK,
    ACTIONS(7257), 1,
      anon_sym_COMMA,
    STATE(3959), 1,
      aux_sym_capture_list_repeat1,
    STATE(4009), 2,
      sym_line_comment,
      sym_block_comment,
  [118411] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3908), 1,
      anon_sym_COLON_EQ,
    ACTIONS(7259), 1,
      anon_sym_COMMA,
    STATE(4010), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_strictly_expression_list_repeat1,
  [118429] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5647), 1,
      anon_sym_LBRACE,
    ACTIONS(7262), 1,
      anon_sym_COMMA,
    STATE(4011), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_match_expression_list_repeat1,
  [118447] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(4012), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6408), 3,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [118463] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4428), 1,
      anon_sym_SEMI,
    ACTIONS(5477), 1,
      anon_sym_COMMA,
    STATE(4021), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4013), 2,
      sym_line_comment,
      sym_block_comment,
  [118483] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(7265), 1,
      anon_sym_SQUOTE,
    STATE(3953), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(4014), 2,
      sym_line_comment,
      sym_block_comment,
  [118503] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(7265), 1,
      anon_sym_DQUOTE,
    STATE(3913), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(4015), 2,
      sym_line_comment,
      sym_block_comment,
  [118523] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(4016), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6746), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT2,
  [118539] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5991), 1,
      anon_sym_RPAREN,
    ACTIONS(7267), 1,
      anon_sym_COMMA,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4017), 2,
      sym_line_comment,
      sym_block_comment,
  [118559] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7269), 1,
      anon_sym_SEMI,
    ACTIONS(7272), 1,
      anon_sym_RBRACK,
    STATE(4018), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_attribute_repeat1,
  [118577] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7274), 1,
      anon_sym_RPAREN,
    STATE(4047), 1,
      aux_sym_parameter_list_repeat1,
    STATE(4019), 2,
      sym_line_comment,
      sym_block_comment,
  [118597] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7276), 1,
      anon_sym_RPAREN,
    STATE(4049), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(4020), 2,
      sym_line_comment,
      sym_block_comment,
  [118617] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3908), 1,
      anon_sym_SEMI,
    ACTIONS(7278), 1,
      anon_sym_COMMA,
    STATE(4021), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_strictly_expression_list_repeat1,
  [118635] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(4022), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(7281), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT2,
  [118651] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7283), 1,
      anon_sym_COMMA,
    ACTIONS(7286), 1,
      anon_sym_RPAREN,
    STATE(4023), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_parameter_list_repeat1,
  [118669] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5503), 1,
      anon_sym_LBRACE,
    ACTIONS(5505), 1,
      anon_sym_COMMA,
    STATE(3920), 1,
      aux_sym_match_expression_list_repeat1,
    STATE(4024), 2,
      sym_line_comment,
      sym_block_comment,
  [118689] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    STATE(2651), 1,
      sym_type_initializer_body,
    ACTIONS(7288), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    STATE(4025), 2,
      sym_line_comment,
      sym_block_comment,
  [118707] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7290), 1,
      anon_sym_RBRACK,
    STATE(4042), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4026), 2,
      sym_line_comment,
      sym_block_comment,
  [118727] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7292), 1,
      anon_sym_RPAREN,
    STATE(3988), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(4027), 2,
      sym_line_comment,
      sym_block_comment,
  [118747] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5505), 1,
      anon_sym_COMMA,
    ACTIONS(7294), 1,
      anon_sym_LBRACE,
    STATE(3906), 1,
      aux_sym_match_expression_list_repeat1,
    STATE(4028), 2,
      sym_line_comment,
      sym_block_comment,
  [118767] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7296), 1,
      anon_sym_RPAREN,
    STATE(3979), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(4029), 2,
      sym_line_comment,
      sym_block_comment,
  [118787] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7298), 1,
      anon_sym_RPAREN,
    STATE(3990), 1,
      aux_sym_parameter_list_repeat1,
    STATE(4030), 2,
      sym_line_comment,
      sym_block_comment,
  [118807] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7300), 1,
      anon_sym_RPAREN,
    STATE(4023), 1,
      aux_sym_parameter_list_repeat1,
    STATE(4031), 2,
      sym_line_comment,
      sym_block_comment,
  [118827] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7302), 1,
      anon_sym_RPAREN,
    STATE(4003), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(4032), 2,
      sym_line_comment,
      sym_block_comment,
  [118847] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5098), 1,
      anon_sym_COMMA,
    ACTIONS(7304), 1,
      anon_sym_COLON_EQ,
    STATE(3889), 1,
      aux_sym_identifier_list_repeat1,
    STATE(4033), 2,
      sym_line_comment,
      sym_block_comment,
  [118867] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7306), 1,
      anon_sym_RPAREN,
    STATE(3985), 1,
      aux_sym_parameter_list_repeat1,
    STATE(4034), 2,
      sym_line_comment,
      sym_block_comment,
  [118887] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5913), 1,
      anon_sym_RPAREN,
    ACTIONS(7308), 1,
      anon_sym_COMMA,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4035), 2,
      sym_line_comment,
      sym_block_comment,
  [118907] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7310), 1,
      anon_sym_RBRACK,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4036), 2,
      sym_line_comment,
      sym_block_comment,
  [118927] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7312), 1,
      anon_sym_RPAREN,
    STATE(4003), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(4037), 2,
      sym_line_comment,
      sym_block_comment,
  [118947] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7314), 1,
      anon_sym_RPAREN,
    STATE(4023), 1,
      aux_sym_parameter_list_repeat1,
    STATE(4038), 2,
      sym_line_comment,
      sym_block_comment,
  [118967] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7316), 1,
      anon_sym_RBRACK,
    STATE(4036), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4039), 2,
      sym_line_comment,
      sym_block_comment,
  [118987] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5983), 1,
      anon_sym_RPAREN,
    ACTIONS(7318), 1,
      anon_sym_COMMA,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4040), 2,
      sym_line_comment,
      sym_block_comment,
  [119007] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7320), 1,
      anon_sym_RBRACK,
    STATE(4064), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4041), 2,
      sym_line_comment,
      sym_block_comment,
  [119027] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7322), 1,
      anon_sym_RBRACK,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4042), 2,
      sym_line_comment,
      sym_block_comment,
  [119047] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7324), 1,
      anon_sym_RPAREN,
    STATE(4037), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(4043), 2,
      sym_line_comment,
      sym_block_comment,
  [119067] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7326), 1,
      anon_sym_RPAREN,
    STATE(3986), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(4044), 2,
      sym_line_comment,
      sym_block_comment,
  [119087] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7328), 1,
      anon_sym_RPAREN,
    STATE(4038), 1,
      aux_sym_parameter_list_repeat1,
    STATE(4045), 2,
      sym_line_comment,
      sym_block_comment,
  [119107] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5965), 1,
      anon_sym_RPAREN,
    ACTIONS(7330), 1,
      anon_sym_COMMA,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4046), 2,
      sym_line_comment,
      sym_block_comment,
  [119127] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7332), 1,
      anon_sym_RPAREN,
    STATE(4023), 1,
      aux_sym_parameter_list_repeat1,
    STATE(4047), 2,
      sym_line_comment,
      sym_block_comment,
  [119147] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7334), 1,
      anon_sym_RPAREN,
    STATE(3987), 1,
      aux_sym_parameter_list_repeat1,
    STATE(4048), 2,
      sym_line_comment,
      sym_block_comment,
  [119167] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7336), 1,
      anon_sym_RPAREN,
    STATE(4003), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(4049), 2,
      sym_line_comment,
      sym_block_comment,
  [119187] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7338), 1,
      anon_sym_COMMA,
    ACTIONS(7341), 1,
      anon_sym_in,
    STATE(4050), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_var_definition_list_repeat1,
  [119205] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5975), 1,
      anon_sym_RPAREN,
    ACTIONS(7343), 1,
      anon_sym_COMMA,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4051), 2,
      sym_line_comment,
      sym_block_comment,
  [119225] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(7345), 1,
      anon_sym_DQUOTE,
    STATE(3913), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(4052), 2,
      sym_line_comment,
      sym_block_comment,
  [119245] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(7345), 1,
      anon_sym_SQUOTE,
    STATE(3953), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(4053), 2,
      sym_line_comment,
      sym_block_comment,
  [119265] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    STATE(4054), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(7347), 3,
      aux_sym_block_comment_token1,
      aux_sym_block_comment_token2,
      anon_sym_STAR_SLASH,
  [119281] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(7349), 1,
      anon_sym_DQUOTE,
    STATE(3913), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(4055), 2,
      sym_line_comment,
      sym_block_comment,
  [119301] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LBRACE,
    STATE(2740), 1,
      sym__content_block,
    STATE(4056), 2,
      sym_line_comment,
      sym_block_comment,
  [119321] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6952), 1,
      anon_sym_COMMA,
    ACTIONS(7355), 1,
      anon_sym_PIPE,
    STATE(3856), 1,
      aux_sym_short_lambda_repeat1,
    STATE(4057), 2,
      sym_line_comment,
      sym_block_comment,
  [119341] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7357), 1,
      anon_sym_RBRACK,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4058), 2,
      sym_line_comment,
      sym_block_comment,
  [119361] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7359), 1,
      anon_sym_RBRACK,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4059), 2,
      sym_line_comment,
      sym_block_comment,
  [119381] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(7349), 1,
      anon_sym_SQUOTE,
    STATE(3953), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(4060), 2,
      sym_line_comment,
      sym_block_comment,
  [119401] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7361), 1,
      anon_sym_RPAREN,
    STATE(4003), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(4061), 2,
      sym_line_comment,
      sym_block_comment,
  [119421] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7363), 1,
      anon_sym_RPAREN,
    STATE(4023), 1,
      aux_sym_parameter_list_repeat1,
    STATE(4062), 2,
      sym_line_comment,
      sym_block_comment,
  [119441] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7365), 1,
      anon_sym_DOT,
    ACTIONS(7367), 1,
      anon_sym_RBRACE,
    ACTIONS(7369), 1,
      aux_sym_format_specifier_token1,
    STATE(4063), 2,
      sym_line_comment,
      sym_block_comment,
  [119461] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7371), 1,
      anon_sym_RBRACK,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4064), 2,
      sym_line_comment,
      sym_block_comment,
  [119481] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7373), 1,
      anon_sym_RBRACK,
    STATE(4059), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4065), 2,
      sym_line_comment,
      sym_block_comment,
  [119501] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4424), 1,
      anon_sym_SEMI,
    ACTIONS(5477), 1,
      anon_sym_COMMA,
    STATE(4021), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4066), 2,
      sym_line_comment,
      sym_block_comment,
  [119521] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7375), 1,
      anon_sym_RPAREN,
    STATE(4061), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(4067), 2,
      sym_line_comment,
      sym_block_comment,
  [119541] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7377), 1,
      anon_sym_RPAREN,
    STATE(4062), 1,
      aux_sym_parameter_list_repeat1,
    STATE(4068), 2,
      sym_line_comment,
      sym_block_comment,
  [119561] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(7379), 1,
      anon_sym_DQUOTE,
    STATE(3913), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(4069), 2,
      sym_line_comment,
      sym_block_comment,
  [119581] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5957), 1,
      anon_sym_RPAREN,
    ACTIONS(7381), 1,
      anon_sym_COMMA,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4070), 2,
      sym_line_comment,
      sym_block_comment,
  [119601] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(7379), 1,
      anon_sym_SQUOTE,
    STATE(3953), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(4071), 2,
      sym_line_comment,
      sym_block_comment,
  [119621] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7383), 1,
      anon_sym_COMMA,
    ACTIONS(7385), 1,
      anon_sym_RPAREN,
    STATE(4078), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4072), 2,
      sym_line_comment,
      sym_block_comment,
  [119641] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(7387), 1,
      anon_sym_DQUOTE,
    STATE(3954), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(4073), 2,
      sym_line_comment,
      sym_block_comment,
  [119661] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(7387), 1,
      anon_sym_SQUOTE,
    STATE(3955), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(4074), 2,
      sym_line_comment,
      sym_block_comment,
  [119681] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7389), 1,
      anon_sym_COMMA,
    ACTIONS(7391), 1,
      anon_sym_RPAREN,
    STATE(3903), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4075), 2,
      sym_line_comment,
      sym_block_comment,
  [119701] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7393), 1,
      sym_identifier,
    ACTIONS(7395), 1,
      anon_sym_LBRACE,
    STATE(466), 1,
      sym__content_block,
    STATE(4076), 2,
      sym_line_comment,
      sym_block_comment,
  [119721] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7397), 1,
      anon_sym_COMMA,
    ACTIONS(7400), 1,
      anon_sym_PIPE,
    STATE(4077), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_short_lambda_repeat1,
  [119739] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5987), 1,
      anon_sym_RPAREN,
    ACTIONS(7402), 1,
      anon_sym_COMMA,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4078), 2,
      sym_line_comment,
      sym_block_comment,
  [119759] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7404), 1,
      anon_sym_RPAREN,
    STATE(4087), 1,
      aux_sym_parameter_list_repeat1,
    STATE(4079), 2,
      sym_line_comment,
      sym_block_comment,
  [119779] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7406), 1,
      anon_sym_RPAREN,
    STATE(4088), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(4080), 2,
      sym_line_comment,
      sym_block_comment,
  [119799] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(7408), 1,
      anon_sym_DQUOTE,
    STATE(4055), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(4081), 2,
      sym_line_comment,
      sym_block_comment,
  [119819] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(7408), 1,
      anon_sym_SQUOTE,
    STATE(4060), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(4082), 2,
      sym_line_comment,
      sym_block_comment,
  [119839] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3862), 1,
      anon_sym_SEMI,
    ACTIONS(5477), 1,
      anon_sym_COMMA,
    STATE(4066), 1,
      aux_sym_strictly_expression_list_repeat1,
    STATE(4083), 2,
      sym_line_comment,
      sym_block_comment,
  [119859] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7410), 1,
      anon_sym_RBRACK,
    STATE(4092), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4084), 2,
      sym_line_comment,
      sym_block_comment,
  [119879] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6928), 1,
      aux_sym_raw_string_literal_token2,
    ACTIONS(7412), 1,
      anon_sym_DQUOTE,
    STATE(4052), 1,
      aux_sym_raw_string_literal_repeat2,
    STATE(4085), 2,
      sym_line_comment,
      sym_block_comment,
  [119899] = 6,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6924), 1,
      aux_sym_raw_string_literal_token1,
    ACTIONS(7412), 1,
      anon_sym_SQUOTE,
    STATE(4053), 1,
      aux_sym_raw_string_literal_repeat1,
    STATE(4086), 2,
      sym_line_comment,
      sym_block_comment,
  [119919] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6936), 1,
      anon_sym_COMMA,
    ACTIONS(7414), 1,
      anon_sym_RPAREN,
    STATE(4023), 1,
      aux_sym_parameter_list_repeat1,
    STATE(4087), 2,
      sym_line_comment,
      sym_block_comment,
  [119939] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    ACTIONS(7416), 1,
      anon_sym_RPAREN,
    STATE(4003), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(4088), 2,
      sym_line_comment,
      sym_block_comment,
  [119959] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7418), 1,
      sym_identifier,
    ACTIONS(7420), 1,
      anon_sym_LBRACE,
    STATE(1054), 1,
      sym__content_block,
    STATE(4089), 2,
      sym_line_comment,
      sym_block_comment,
  [119979] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7422), 1,
      sym_identifier,
    ACTIONS(7424), 1,
      anon_sym_LBRACE,
    STATE(2435), 1,
      sym__struct_body,
    STATE(4090), 2,
      sym_line_comment,
      sym_block_comment,
  [119999] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7426), 1,
      sym_identifier,
    ACTIONS(7428), 1,
      anon_sym_LBRACE,
    STATE(1330), 1,
      sym__content_block,
    STATE(4091), 2,
      sym_line_comment,
      sym_block_comment,
  [120019] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    ACTIONS(7430), 1,
      anon_sym_RBRACK,
    STATE(3759), 1,
      aux_sym_type_parameters_repeat1,
    STATE(4092), 2,
      sym_line_comment,
      sym_block_comment,
  [120039] = 6,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7058), 1,
      sym_identifier,
    ACTIONS(7432), 1,
      anon_sym_LPAREN,
    STATE(1797), 1,
      sym_const_definition,
    STATE(4093), 2,
      sym_line_comment,
      sym_block_comment,
  [120059] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6628), 1,
      anon_sym_LBRACE,
    STATE(1855), 1,
      sym__struct_body,
    STATE(4094), 2,
      sym_line_comment,
      sym_block_comment,
  [120076] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5325), 1,
      anon_sym_LBRACE,
    STATE(2474), 1,
      sym_block,
    STATE(4095), 2,
      sym_line_comment,
      sym_block_comment,
  [120093] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7400), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
    STATE(4096), 2,
      sym_line_comment,
      sym_block_comment,
  [120108] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7434), 1,
      anon_sym_LBRACE,
    STATE(1367), 1,
      sym_type_initializer_body,
    STATE(4097), 2,
      sym_line_comment,
      sym_block_comment,
  [120125] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    STATE(2083), 1,
      sym_block,
    STATE(4098), 2,
      sym_line_comment,
      sym_block_comment,
  [120142] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6825), 1,
      sym_identifier,
    STATE(520), 1,
      sym_reference_expression,
    STATE(4099), 2,
      sym_line_comment,
      sym_block_comment,
  [120159] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3310), 1,
      anon_sym_LBRACE,
    STATE(2186), 1,
      sym_type_initializer_body,
    STATE(4100), 2,
      sym_line_comment,
      sym_block_comment,
  [120176] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7436), 1,
      anon_sym_LPAREN,
    STATE(1069), 1,
      sym_special_argument_list,
    STATE(4101), 2,
      sym_line_comment,
      sym_block_comment,
  [120193] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5317), 1,
      anon_sym_LBRACE,
    STATE(1058), 1,
      sym_block,
    STATE(4102), 2,
      sym_line_comment,
      sym_block_comment,
  [120210] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3310), 1,
      anon_sym_LBRACE,
    STATE(1367), 1,
      sym_type_initializer_body,
    STATE(4103), 2,
      sym_line_comment,
      sym_block_comment,
  [120227] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5329), 1,
      anon_sym_LBRACE,
    STATE(1390), 1,
      sym_block,
    STATE(4104), 2,
      sym_line_comment,
      sym_block_comment,
  [120244] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    STATE(2045), 1,
      sym__struct_body,
    STATE(4105), 2,
      sym_line_comment,
      sym_block_comment,
  [120261] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7440), 1,
      anon_sym_LBRACE,
    STATE(2186), 1,
      sym_type_initializer_body,
    STATE(4106), 2,
      sym_line_comment,
      sym_block_comment,
  [120278] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7442), 1,
      anon_sym_LBRACE,
    STATE(2435), 1,
      sym__struct_body,
    STATE(4107), 2,
      sym_line_comment,
      sym_block_comment,
  [120295] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3302), 1,
      anon_sym_LBRACE,
    STATE(2186), 1,
      sym_type_initializer_body,
    STATE(4108), 2,
      sym_line_comment,
      sym_block_comment,
  [120312] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6622), 1,
      anon_sym_LBRACE,
    STATE(1895), 1,
      sym__interface_body,
    STATE(4109), 2,
      sym_line_comment,
      sym_block_comment,
  [120329] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6718), 1,
      anon_sym_LBRACE,
    STATE(1894), 1,
      sym__enum_body,
    STATE(4110), 2,
      sym_line_comment,
      sym_block_comment,
  [120346] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6628), 1,
      anon_sym_LBRACE,
    STATE(1893), 1,
      sym__struct_body,
    STATE(4111), 2,
      sym_line_comment,
      sym_block_comment,
  [120363] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5329), 1,
      anon_sym_LBRACE,
    STATE(1329), 1,
      sym_block,
    STATE(4112), 2,
      sym_line_comment,
      sym_block_comment,
  [120380] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7444), 1,
      anon_sym_LBRACE,
    STATE(1663), 1,
      sym__struct_body,
    STATE(4113), 2,
      sym_line_comment,
      sym_block_comment,
  [120397] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7446), 1,
      anon_sym_LBRACE,
    STATE(2435), 1,
      sym__struct_body,
    STATE(4114), 2,
      sym_line_comment,
      sym_block_comment,
  [120414] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5311), 1,
      anon_sym_LBRACE,
    STATE(2754), 1,
      sym_block,
    STATE(4115), 2,
      sym_line_comment,
      sym_block_comment,
  [120431] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4649), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(4116), 2,
      sym_line_comment,
      sym_block_comment,
  [120446] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7448), 1,
      anon_sym_LPAREN,
    STATE(1323), 1,
      sym_special_argument_list,
    STATE(4117), 2,
      sym_line_comment,
      sym_block_comment,
  [120463] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6718), 1,
      anon_sym_LBRACE,
    STATE(1791), 1,
      sym__enum_body,
    STATE(4118), 2,
      sym_line_comment,
      sym_block_comment,
  [120480] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7450), 1,
      anon_sym_LBRACE,
    STATE(2752), 1,
      sym__struct_body,
    STATE(4119), 2,
      sym_line_comment,
      sym_block_comment,
  [120497] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7452), 1,
      anon_sym_LBRACE,
    STATE(2435), 1,
      sym__struct_body,
    STATE(4120), 2,
      sym_line_comment,
      sym_block_comment,
  [120514] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6760), 1,
      sym_identifier,
    STATE(1321), 1,
      sym_reference_expression,
    STATE(4121), 2,
      sym_line_comment,
      sym_block_comment,
  [120531] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7454), 1,
      sym_identifier,
    STATE(2261), 1,
      sym_type_reference_expression,
    STATE(4122), 2,
      sym_line_comment,
      sym_block_comment,
  [120548] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7456), 1,
      anon_sym_LPAREN,
    STATE(490), 1,
      sym_special_argument_list,
    STATE(4123), 2,
      sym_line_comment,
      sym_block_comment,
  [120565] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7458), 1,
      sym_identifier,
    STATE(2782), 1,
      sym_type_reference_expression,
    STATE(4124), 2,
      sym_line_comment,
      sym_block_comment,
  [120582] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    STATE(467), 1,
      sym_block,
    STATE(4125), 2,
      sym_line_comment,
      sym_block_comment,
  [120599] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7353), 1,
      anon_sym_LBRACE,
    STATE(2714), 1,
      sym__content_block,
    STATE(4126), 2,
      sym_line_comment,
      sym_block_comment,
  [120616] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6622), 1,
      anon_sym_LBRACE,
    STATE(1785), 1,
      sym__interface_body,
    STATE(4127), 2,
      sym_line_comment,
      sym_block_comment,
  [120633] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5313), 1,
      anon_sym_LBRACE,
    STATE(2715), 1,
      sym_block,
    STATE(4128), 2,
      sym_line_comment,
      sym_block_comment,
  [120650] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7460), 1,
      anon_sym_LBRACE,
    STATE(2435), 1,
      sym__struct_body,
    STATE(4129), 2,
      sym_line_comment,
      sym_block_comment,
  [120667] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5311), 1,
      anon_sym_LBRACE,
    STATE(2952), 1,
      sym_block,
    STATE(4130), 2,
      sym_line_comment,
      sym_block_comment,
  [120684] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5313), 1,
      anon_sym_LBRACE,
    STATE(2553), 1,
      sym_block,
    STATE(4131), 2,
      sym_line_comment,
      sym_block_comment,
  [120701] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5036), 1,
      anon_sym_LBRACE,
    STATE(1934), 1,
      sym_block,
    STATE(4132), 2,
      sym_line_comment,
      sym_block_comment,
  [120718] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3302), 1,
      anon_sym_LBRACE,
    STATE(1367), 1,
      sym_type_initializer_body,
    STATE(4133), 2,
      sym_line_comment,
      sym_block_comment,
  [120735] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5329), 1,
      anon_sym_LBRACE,
    STATE(1278), 1,
      sym_block,
    STATE(4134), 2,
      sym_line_comment,
      sym_block_comment,
  [120752] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7462), 1,
      anon_sym_LBRACE,
    STATE(2435), 1,
      sym__struct_body,
    STATE(4135), 2,
      sym_line_comment,
      sym_block_comment,
  [120769] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7464), 1,
      anon_sym_LBRACE,
    STATE(2362), 1,
      sym__struct_body,
    STATE(4136), 2,
      sym_line_comment,
      sym_block_comment,
  [120786] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7434), 1,
      anon_sym_LBRACE,
    STATE(1367), 1,
      sym_type_initializer_body,
    STATE(4137), 2,
      sym_line_comment,
      sym_block_comment,
  [120803] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5329), 1,
      anon_sym_LBRACE,
    STATE(1395), 1,
      sym_block,
    STATE(4138), 2,
      sym_line_comment,
      sym_block_comment,
  [120820] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5221), 1,
      sym_identifier,
    ACTIONS(7466), 1,
      anon_sym_volatile,
    STATE(4139), 2,
      sym_line_comment,
      sym_block_comment,
  [120837] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7468), 1,
      sym_identifier,
    STATE(1945), 1,
      sym_label_reference,
    STATE(4140), 2,
      sym_line_comment,
      sym_block_comment,
  [120854] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7470), 1,
      anon_sym_LBRACE,
    STATE(2435), 1,
      sym__struct_body,
    STATE(4141), 2,
      sym_line_comment,
      sym_block_comment,
  [120871] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7428), 1,
      anon_sym_LBRACE,
    STATE(1398), 1,
      sym__content_block,
    STATE(4142), 2,
      sym_line_comment,
      sym_block_comment,
  [120888] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7472), 1,
      anon_sym_LBRACE,
    STATE(2729), 1,
      sym_type_initializer_body,
    STATE(4143), 2,
      sym_line_comment,
      sym_block_comment,
  [120905] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5313), 1,
      anon_sym_LBRACE,
    STATE(2741), 1,
      sym_block,
    STATE(4144), 2,
      sym_line_comment,
      sym_block_comment,
  [120922] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5327), 1,
      anon_sym_LBRACE,
    STATE(2176), 1,
      sym_block,
    STATE(4145), 2,
      sym_line_comment,
      sym_block_comment,
  [120939] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7474), 1,
      anon_sym_LBRACE,
    STATE(1021), 1,
      sym_type_initializer_body,
    STATE(4146), 2,
      sym_line_comment,
      sym_block_comment,
  [120956] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7476), 1,
      anon_sym_LBRACE,
    STATE(2435), 1,
      sym__struct_body,
    STATE(4147), 2,
      sym_line_comment,
      sym_block_comment,
  [120973] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7341), 2,
      anon_sym_COMMA,
      anon_sym_in,
    STATE(4148), 2,
      sym_line_comment,
      sym_block_comment,
  [120988] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7186), 1,
      anon_sym_LBRACE,
    STATE(2955), 1,
      sym__content_block,
    STATE(4149), 2,
      sym_line_comment,
      sym_block_comment,
  [121005] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7478), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(4150), 2,
      sym_line_comment,
      sym_block_comment,
  [121020] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7480), 1,
      anon_sym_LBRACE,
    STATE(2902), 1,
      sym__struct_body,
    STATE(4151), 2,
      sym_line_comment,
      sym_block_comment,
  [121037] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5317), 1,
      anon_sym_LBRACE,
    STATE(1030), 1,
      sym_block,
    STATE(4152), 2,
      sym_line_comment,
      sym_block_comment,
  [121054] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5329), 1,
      anon_sym_LBRACE,
    STATE(1310), 1,
      sym_block,
    STATE(4153), 2,
      sym_line_comment,
      sym_block_comment,
  [121071] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7482), 1,
      anon_sym_LBRACE,
    STATE(2435), 1,
      sym__struct_body,
    STATE(4154), 2,
      sym_line_comment,
      sym_block_comment,
  [121088] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3310), 1,
      anon_sym_LBRACE,
    STATE(1021), 1,
      sym_type_initializer_body,
    STATE(4155), 2,
      sym_line_comment,
      sym_block_comment,
  [121105] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7484), 1,
      sym_identifier,
    STATE(2822), 1,
      sym_type_reference_expression,
    STATE(4156), 2,
      sym_line_comment,
      sym_block_comment,
  [121122] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7486), 1,
      anon_sym_LBRACE,
    STATE(2435), 1,
      sym__struct_body,
    STATE(4157), 2,
      sym_line_comment,
      sym_block_comment,
  [121139] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6628), 1,
      anon_sym_LBRACE,
    STATE(1851), 1,
      sym__struct_body,
    STATE(4158), 2,
      sym_line_comment,
      sym_block_comment,
  [121156] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7488), 1,
      anon_sym_LPAREN,
    STATE(1365), 1,
      sym_argument_list,
    STATE(4159), 2,
      sym_line_comment,
      sym_block_comment,
  [121173] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7286), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(4160), 2,
      sym_line_comment,
      sym_block_comment,
  [121188] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4998), 1,
      anon_sym_LBRACE,
    STATE(1813), 1,
      sym_block,
    STATE(4161), 2,
      sym_line_comment,
      sym_block_comment,
  [121205] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7490), 1,
      sym_identifier,
    STATE(1635), 1,
      sym_type_reference_expression,
    STATE(4162), 2,
      sym_line_comment,
      sym_block_comment,
  [121222] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7492), 1,
      anon_sym_LBRACE,
    STATE(2435), 1,
      sym__struct_body,
    STATE(4163), 2,
      sym_line_comment,
      sym_block_comment,
  [121239] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2035), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(4164), 2,
      sym_line_comment,
      sym_block_comment,
  [121254] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7494), 1,
      sym_identifier,
    STATE(1793), 1,
      sym_label_reference,
    STATE(4165), 2,
      sym_line_comment,
      sym_block_comment,
  [121271] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7474), 1,
      anon_sym_LBRACE,
    STATE(1021), 1,
      sym_type_initializer_body,
    STATE(4166), 2,
      sym_line_comment,
      sym_block_comment,
  [121288] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7424), 1,
      anon_sym_LBRACE,
    STATE(2435), 1,
      sym__struct_body,
    STATE(4167), 2,
      sym_line_comment,
      sym_block_comment,
  [121305] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3302), 1,
      anon_sym_LBRACE,
    STATE(1021), 1,
      sym_type_initializer_body,
    STATE(4168), 2,
      sym_line_comment,
      sym_block_comment,
  [121322] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5317), 1,
      anon_sym_LBRACE,
    STATE(996), 1,
      sym_block,
    STATE(4169), 2,
      sym_line_comment,
      sym_block_comment,
  [121339] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5317), 1,
      anon_sym_LBRACE,
    STATE(1051), 1,
      sym_block,
    STATE(4170), 2,
      sym_line_comment,
      sym_block_comment,
  [121356] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    STATE(2114), 1,
      sym_block,
    STATE(4171), 2,
      sym_line_comment,
      sym_block_comment,
  [121373] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7420), 1,
      anon_sym_LBRACE,
    STATE(1053), 1,
      sym__content_block,
    STATE(4172), 2,
      sym_line_comment,
      sym_block_comment,
  [121390] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5040), 1,
      anon_sym_LPAREN,
    STATE(2117), 1,
      sym_argument_list,
    STATE(4173), 2,
      sym_line_comment,
      sym_block_comment,
  [121407] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7496), 1,
      sym_identifier,
    STATE(2086), 1,
      sym_type_reference_expression,
    STATE(4174), 2,
      sym_line_comment,
      sym_block_comment,
  [121424] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7498), 1,
      anon_sym_COMMA,
    ACTIONS(7500), 1,
      anon_sym_RPAREN,
    STATE(4175), 2,
      sym_line_comment,
      sym_block_comment,
  [121441] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7502), 1,
      anon_sym_LBRACE,
    STATE(370), 1,
      sym_type_initializer_body,
    STATE(4176), 2,
      sym_line_comment,
      sym_block_comment,
  [121458] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5036), 1,
      anon_sym_LBRACE,
    STATE(1937), 1,
      sym_block,
    STATE(4177), 2,
      sym_line_comment,
      sym_block_comment,
  [121475] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5036), 1,
      anon_sym_LBRACE,
    STATE(1948), 1,
      sym_block,
    STATE(4178), 2,
      sym_line_comment,
      sym_block_comment,
  [121492] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5313), 1,
      anon_sym_LBRACE,
    STATE(2797), 1,
      sym_block,
    STATE(4179), 2,
      sym_line_comment,
      sym_block_comment,
  [121509] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7504), 1,
      anon_sym_LBRACE,
    STATE(1931), 1,
      sym__content_block,
    STATE(4180), 2,
      sym_line_comment,
      sym_block_comment,
  [121526] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    STATE(2124), 1,
      sym_block,
    STATE(4181), 2,
      sym_line_comment,
      sym_block_comment,
  [121543] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5317), 1,
      anon_sym_LBRACE,
    STATE(1074), 1,
      sym_block,
    STATE(4182), 2,
      sym_line_comment,
      sym_block_comment,
  [121560] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    STATE(2125), 1,
      sym_block,
    STATE(4183), 2,
      sym_line_comment,
      sym_block_comment,
  [121577] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5327), 1,
      anon_sym_LBRACE,
    STATE(2218), 1,
      sym_block,
    STATE(4184), 2,
      sym_line_comment,
      sym_block_comment,
  [121594] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7506), 1,
      anon_sym_LPAREN,
    STATE(1077), 1,
      sym_argument_list,
    STATE(4185), 2,
      sym_line_comment,
      sym_block_comment,
  [121611] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7508), 1,
      anon_sym_LBRACE,
    STATE(2240), 1,
      sym_block,
    STATE(4186), 2,
      sym_line_comment,
      sym_block_comment,
  [121628] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7510), 1,
      sym_identifier,
    STATE(1774), 1,
      sym_type_reference_expression,
    STATE(4187), 2,
      sym_line_comment,
      sym_block_comment,
  [121645] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7508), 1,
      anon_sym_LBRACE,
    STATE(2249), 1,
      sym_block,
    STATE(4188), 2,
      sym_line_comment,
      sym_block_comment,
  [121662] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5329), 1,
      anon_sym_LBRACE,
    STATE(1402), 1,
      sym_block,
    STATE(4189), 2,
      sym_line_comment,
      sym_block_comment,
  [121679] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5327), 1,
      anon_sym_LBRACE,
    STATE(2213), 1,
      sym_block,
    STATE(4190), 2,
      sym_line_comment,
      sym_block_comment,
  [121696] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7512), 1,
      anon_sym_LBRACE,
    STATE(2435), 1,
      sym__struct_body,
    STATE(4191), 2,
      sym_line_comment,
      sym_block_comment,
  [121713] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7514), 1,
      anon_sym_COMMA,
    ACTIONS(7516), 1,
      anon_sym_RPAREN,
    STATE(4192), 2,
      sym_line_comment,
      sym_block_comment,
  [121730] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7518), 2,
      anon_sym_SEMI,
      anon_sym_RBRACK,
    STATE(4193), 2,
      sym_line_comment,
      sym_block_comment,
  [121745] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5317), 1,
      anon_sym_LBRACE,
    STATE(1089), 1,
      sym_block,
    STATE(4194), 2,
      sym_line_comment,
      sym_block_comment,
  [121762] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7245), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(4195), 2,
      sym_line_comment,
      sym_block_comment,
  [121777] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5329), 1,
      anon_sym_LBRACE,
    STATE(1401), 1,
      sym_block,
    STATE(4196), 2,
      sym_line_comment,
      sym_block_comment,
  [121794] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5317), 1,
      anon_sym_LBRACE,
    STATE(1090), 1,
      sym_block,
    STATE(4197), 2,
      sym_line_comment,
      sym_block_comment,
  [121811] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7272), 2,
      anon_sym_SEMI,
      anon_sym_RBRACK,
    STATE(4198), 2,
      sym_line_comment,
      sym_block_comment,
  [121826] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7520), 2,
      anon_sym_SEMI,
      anon_sym_RBRACK,
    STATE(4199), 2,
      sym_line_comment,
      sym_block_comment,
  [121841] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5331), 1,
      anon_sym_LBRACE,
    STATE(1668), 1,
      sym_block,
    STATE(4200), 2,
      sym_line_comment,
      sym_block_comment,
  [121858] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7522), 1,
      sym_identifier,
    STATE(1711), 1,
      sym_type_reference_expression,
    STATE(4201), 2,
      sym_line_comment,
      sym_block_comment,
  [121875] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7524), 1,
      anon_sym_COMMA,
    ACTIONS(7526), 1,
      anon_sym_RPAREN,
    STATE(4202), 2,
      sym_line_comment,
      sym_block_comment,
  [121892] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5002), 1,
      anon_sym_LPAREN,
    STATE(2204), 1,
      sym_argument_list,
    STATE(4203), 2,
      sym_line_comment,
      sym_block_comment,
  [121909] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5327), 1,
      anon_sym_LBRACE,
    STATE(2184), 1,
      sym_block,
    STATE(4204), 2,
      sym_line_comment,
      sym_block_comment,
  [121926] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4653), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(4205), 2,
      sym_line_comment,
      sym_block_comment,
  [121941] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7367), 1,
      anon_sym_RBRACE,
    ACTIONS(7369), 1,
      aux_sym_format_specifier_token1,
    STATE(4206), 2,
      sym_line_comment,
      sym_block_comment,
  [121958] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5751), 2,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
    STATE(4207), 2,
      sym_line_comment,
      sym_block_comment,
  [121973] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6817), 2,
      anon_sym_RBRACE,
      sym_identifier,
    STATE(4208), 2,
      sym_line_comment,
      sym_block_comment,
  [121988] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7528), 1,
      anon_sym_COMMA,
    ACTIONS(7530), 1,
      anon_sym_RPAREN,
    STATE(4209), 2,
      sym_line_comment,
      sym_block_comment,
  [122005] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7230), 1,
      anon_sym_LBRACE,
    STATE(2162), 1,
      sym__content_block,
    STATE(4210), 2,
      sym_line_comment,
      sym_block_comment,
  [122022] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7534), 1,
      anon_sym_RPAREN,
    STATE(4211), 2,
      sym_line_comment,
      sym_block_comment,
  [122039] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5327), 1,
      anon_sym_LBRACE,
    STATE(2158), 1,
      sym_block,
    STATE(4212), 2,
      sym_line_comment,
      sym_block_comment,
  [122056] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6758), 1,
      sym_identifier,
    STATE(3842), 1,
      sym_generic_parameter,
    STATE(4213), 2,
      sym_line_comment,
      sym_block_comment,
  [122073] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5327), 1,
      anon_sym_LBRACE,
    STATE(1999), 1,
      sym_block,
    STATE(4214), 2,
      sym_line_comment,
      sym_block_comment,
  [122090] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3302), 1,
      anon_sym_LBRACE,
    STATE(2142), 1,
      sym_type_initializer_body,
    STATE(4215), 2,
      sym_line_comment,
      sym_block_comment,
  [122107] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7536), 1,
      anon_sym_LBRACE,
    STATE(2142), 1,
      sym_type_initializer_body,
    STATE(4216), 2,
      sym_line_comment,
      sym_block_comment,
  [122124] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7538), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    STATE(4217), 2,
      sym_line_comment,
      sym_block_comment,
  [122139] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7540), 1,
      anon_sym_LBRACE,
    STATE(3460), 1,
      sym__struct_body,
    STATE(4218), 2,
      sym_line_comment,
      sym_block_comment,
  [122156] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    STATE(367), 1,
      sym_block,
    STATE(4219), 2,
      sym_line_comment,
      sym_block_comment,
  [122173] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    STATE(348), 1,
      sym_block,
    STATE(4220), 2,
      sym_line_comment,
      sym_block_comment,
  [122190] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3310), 1,
      anon_sym_LBRACE,
    STATE(370), 1,
      sym_type_initializer_body,
    STATE(4221), 2,
      sym_line_comment,
      sym_block_comment,
  [122207] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3310), 1,
      anon_sym_LBRACE,
    STATE(2142), 1,
      sym_type_initializer_body,
    STATE(4222), 2,
      sym_line_comment,
      sym_block_comment,
  [122224] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7542), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(4223), 2,
      sym_line_comment,
      sym_block_comment,
  [122239] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5313), 1,
      anon_sym_LBRACE,
    STATE(2819), 1,
      sym_block,
    STATE(4224), 2,
      sym_line_comment,
      sym_block_comment,
  [122256] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5313), 1,
      anon_sym_LBRACE,
    STATE(2820), 1,
      sym_block,
    STATE(4225), 2,
      sym_line_comment,
      sym_block_comment,
  [122273] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5327), 1,
      anon_sym_LBRACE,
    STATE(2149), 1,
      sym_block,
    STATE(4226), 2,
      sym_line_comment,
      sym_block_comment,
  [122290] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7536), 1,
      anon_sym_LBRACE,
    STATE(2142), 1,
      sym_type_initializer_body,
    STATE(4227), 2,
      sym_line_comment,
      sym_block_comment,
  [122307] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    STATE(2150), 1,
      sym_block,
    STATE(4228), 2,
      sym_line_comment,
      sym_block_comment,
  [122324] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7544), 1,
      anon_sym_LBRACE,
    STATE(2435), 1,
      sym__struct_body,
    STATE(4229), 2,
      sym_line_comment,
      sym_block_comment,
  [122341] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7546), 1,
      sym_identifier,
    STATE(2156), 1,
      sym_type_reference_expression,
    STATE(4230), 2,
      sym_line_comment,
      sym_block_comment,
  [122358] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7548), 1,
      anon_sym_LPAREN,
    STATE(2824), 1,
      sym_argument_list,
    STATE(4231), 2,
      sym_line_comment,
      sym_block_comment,
  [122375] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7550), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(4232), 2,
      sym_line_comment,
      sym_block_comment,
  [122390] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5313), 1,
      anon_sym_LBRACE,
    STATE(2826), 1,
      sym_block,
    STATE(4233), 2,
      sym_line_comment,
      sym_block_comment,
  [122407] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7552), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(4234), 2,
      sym_line_comment,
      sym_block_comment,
  [122422] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5317), 1,
      anon_sym_LBRACE,
    STATE(1060), 1,
      sym_block,
    STATE(4235), 2,
      sym_line_comment,
      sym_block_comment,
  [122439] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7554), 1,
      anon_sym_LBRACE,
    STATE(1227), 1,
      sym_type_initializer_body,
    STATE(4236), 2,
      sym_line_comment,
      sym_block_comment,
  [122456] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5647), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    STATE(4237), 2,
      sym_line_comment,
      sym_block_comment,
  [122471] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7502), 1,
      anon_sym_LBRACE,
    STATE(370), 1,
      sym_type_initializer_body,
    STATE(4238), 2,
      sym_line_comment,
      sym_block_comment,
  [122488] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7556), 1,
      anon_sym_LPAREN,
    STATE(2085), 1,
      sym_special_argument_list,
    STATE(4239), 2,
      sym_line_comment,
      sym_block_comment,
  [122505] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6676), 1,
      sym_identifier,
    STATE(2059), 1,
      sym_reference_expression,
    STATE(4240), 2,
      sym_line_comment,
      sym_block_comment,
  [122522] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6831), 1,
      sym_identifier,
    STATE(2363), 1,
      sym_reference_expression,
    STATE(4241), 2,
      sym_line_comment,
      sym_block_comment,
  [122539] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7558), 2,
      anon_sym_SEMI,
      anon_sym_RBRACK,
    STATE(4242), 2,
      sym_line_comment,
      sym_block_comment,
  [122554] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7165), 1,
      anon_sym_LBRACE,
    STATE(2113), 1,
      sym__content_block,
    STATE(4243), 2,
      sym_line_comment,
      sym_block_comment,
  [122571] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7188), 2,
      anon_sym_SEMI,
      anon_sym_RBRACK,
    STATE(4244), 2,
      sym_line_comment,
      sym_block_comment,
  [122586] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    STATE(2145), 1,
      sym_block,
    STATE(4245), 2,
      sym_line_comment,
      sym_block_comment,
  [122603] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5311), 1,
      anon_sym_LBRACE,
    STATE(2937), 1,
      sym_block,
    STATE(4246), 2,
      sym_line_comment,
      sym_block_comment,
  [122620] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7560), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(4247), 2,
      sym_line_comment,
      sym_block_comment,
  [122635] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3302), 1,
      anon_sym_LBRACE,
    STATE(370), 1,
      sym_type_initializer_body,
    STATE(4248), 2,
      sym_line_comment,
      sym_block_comment,
  [122652] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2891), 1,
      anon_sym_COMMA,
    ACTIONS(7562), 1,
      anon_sym_RPAREN,
    STATE(4249), 2,
      sym_line_comment,
      sym_block_comment,
  [122669] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    STATE(257), 1,
      sym_block,
    STATE(4250), 2,
      sym_line_comment,
      sym_block_comment,
  [122686] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    STATE(2007), 1,
      sym_block,
    STATE(4251), 2,
      sym_line_comment,
      sym_block_comment,
  [122703] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    STATE(424), 1,
      sym_block,
    STATE(4252), 2,
      sym_line_comment,
      sym_block_comment,
  [122720] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7395), 1,
      anon_sym_LBRACE,
    STATE(427), 1,
      sym__content_block,
    STATE(4253), 2,
      sym_line_comment,
      sym_block_comment,
  [122737] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2891), 1,
      anon_sym_COMMA,
    ACTIONS(7564), 1,
      anon_sym_RPAREN,
    STATE(4254), 2,
      sym_line_comment,
      sym_block_comment,
  [122754] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7566), 1,
      anon_sym_LBRACE,
    STATE(2947), 1,
      sym_type_initializer_body,
    STATE(4255), 2,
      sym_line_comment,
      sym_block_comment,
  [122771] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6758), 1,
      sym_identifier,
    STATE(3981), 1,
      sym_generic_parameter,
    STATE(4256), 2,
      sym_line_comment,
      sym_block_comment,
  [122788] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7568), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(4257), 2,
      sym_line_comment,
      sym_block_comment,
  [122803] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7570), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_special_argument_list,
    STATE(4258), 2,
      sym_line_comment,
      sym_block_comment,
  [122820] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3302), 1,
      anon_sym_LBRACE,
    STATE(2729), 1,
      sym_type_initializer_body,
    STATE(4259), 2,
      sym_line_comment,
      sym_block_comment,
  [122837] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7472), 1,
      anon_sym_LBRACE,
    STATE(2729), 1,
      sym_type_initializer_body,
    STATE(4260), 2,
      sym_line_comment,
      sym_block_comment,
  [122854] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7572), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(4261), 2,
      sym_line_comment,
      sym_block_comment,
  [122869] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7574), 1,
      anon_sym_LBRACE,
    STATE(2121), 1,
      sym__struct_body,
    STATE(4262), 2,
      sym_line_comment,
      sym_block_comment,
  [122886] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5329), 1,
      anon_sym_LBRACE,
    STATE(1356), 1,
      sym_block,
    STATE(4263), 2,
      sym_line_comment,
      sym_block_comment,
  [122903] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6849), 1,
      sym_identifier,
    STATE(1032), 1,
      sym_reference_expression,
    STATE(4264), 2,
      sym_line_comment,
      sym_block_comment,
  [122920] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5309), 1,
      anon_sym_LBRACE,
    STATE(1173), 1,
      sym_block,
    STATE(4265), 2,
      sym_line_comment,
      sym_block_comment,
  [122937] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3310), 1,
      anon_sym_LBRACE,
    STATE(2729), 1,
      sym_type_initializer_body,
    STATE(4266), 2,
      sym_line_comment,
      sym_block_comment,
  [122954] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5313), 1,
      anon_sym_LBRACE,
    STATE(2849), 1,
      sym_block,
    STATE(4267), 2,
      sym_line_comment,
      sym_block_comment,
  [122971] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6787), 2,
      anon_sym_RPAREN,
      sym_identifier,
    STATE(4268), 2,
      sym_line_comment,
      sym_block_comment,
  [122986] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7159), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(4269), 2,
      sym_line_comment,
      sym_block_comment,
  [123001] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7000), 1,
      anon_sym_LBRACE,
    STATE(2651), 1,
      sym_type_initializer_body,
    STATE(4270), 2,
      sym_line_comment,
      sym_block_comment,
  [123018] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7576), 1,
      anon_sym_SQUOTE,
    ACTIONS(7578), 1,
      aux_sym_raw_string_literal_token1,
    STATE(4271), 2,
      sym_line_comment,
      sym_block_comment,
  [123035] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5319), 1,
      anon_sym_LBRACE,
    STATE(2355), 1,
      sym_block,
    STATE(4272), 2,
      sym_line_comment,
      sym_block_comment,
  [123052] = 5,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7580), 1,
      anon_sym_DQUOTE,
    ACTIONS(7582), 1,
      aux_sym_raw_string_literal_token2,
    STATE(4273), 2,
      sym_line_comment,
      sym_block_comment,
  [123069] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6806), 2,
      anon_sym_RPAREN,
      sym_identifier,
    STATE(4274), 2,
      sym_line_comment,
      sym_block_comment,
  [123084] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7584), 1,
      anon_sym_RBRACE,
    ACTIONS(7586), 1,
      aux_sym_format_specifier_token1,
    STATE(4275), 2,
      sym_line_comment,
      sym_block_comment,
  [123101] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5133), 2,
      anon_sym_COMMA,
      anon_sym_in,
    STATE(4276), 2,
      sym_line_comment,
      sym_block_comment,
  [123116] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5277), 1,
      anon_sym_LBRACE,
    STATE(2215), 1,
      sym_block,
    STATE(4277), 2,
      sym_line_comment,
      sym_block_comment,
  [123133] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4998), 1,
      anon_sym_LBRACE,
    STATE(1800), 1,
      sym_block,
    STATE(4278), 2,
      sym_line_comment,
      sym_block_comment,
  [123150] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7588), 1,
      anon_sym_LPAREN,
    STATE(2895), 1,
      sym_special_argument_list,
    STATE(4279), 2,
      sym_line_comment,
      sym_block_comment,
  [123167] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4998), 1,
      anon_sym_LBRACE,
    STATE(1792), 1,
      sym_block,
    STATE(4280), 2,
      sym_line_comment,
      sym_block_comment,
  [123184] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7590), 1,
      anon_sym_LBRACE,
    STATE(1790), 1,
      sym__content_block,
    STATE(4281), 2,
      sym_line_comment,
      sym_block_comment,
  [123201] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7084), 1,
      sym_identifier,
    STATE(3924), 1,
      sym_reference_expression,
    STATE(4282), 2,
      sym_line_comment,
      sym_block_comment,
  [123218] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7592), 1,
      anon_sym_LBRACE,
    STATE(2435), 1,
      sym__struct_body,
    STATE(4283), 2,
      sym_line_comment,
      sym_block_comment,
  [123235] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7594), 1,
      anon_sym_LBRACE,
    STATE(2336), 1,
      sym_type_initializer_body,
    STATE(4284), 2,
      sym_line_comment,
      sym_block_comment,
  [123252] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4320), 2,
      anon_sym_SEMI,
      anon_sym_RBRACK,
    STATE(4285), 2,
      sym_line_comment,
      sym_block_comment,
  [123267] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7596), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(4286), 2,
      sym_line_comment,
      sym_block_comment,
  [123282] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    STATE(2695), 1,
      sym_block,
    STATE(4287), 2,
      sym_line_comment,
      sym_block_comment,
  [123299] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6900), 1,
      sym_identifier,
    STATE(2891), 1,
      sym_reference_expression,
    STATE(4288), 2,
      sym_line_comment,
      sym_block_comment,
  [123316] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6810), 1,
      sym_identifier,
    STATE(2034), 1,
      sym_reference_expression,
    STATE(4289), 2,
      sym_line_comment,
      sym_block_comment,
  [123333] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7598), 1,
      anon_sym_COMMA,
    ACTIONS(7600), 1,
      anon_sym_RPAREN,
    STATE(4290), 2,
      sym_line_comment,
      sym_block_comment,
  [123350] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6692), 1,
      sym_identifier,
    STATE(2477), 1,
      sym_reference_expression,
    STATE(4291), 2,
      sym_line_comment,
      sym_block_comment,
  [123367] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7602), 1,
      anon_sym_LPAREN,
    STATE(2500), 1,
      sym_special_argument_list,
    STATE(4292), 2,
      sym_line_comment,
      sym_block_comment,
  [123384] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7604), 1,
      anon_sym_LPAREN,
    STATE(482), 1,
      sym_argument_list,
    STATE(4293), 2,
      sym_line_comment,
      sym_block_comment,
  [123401] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6708), 1,
      sym_identifier,
    STATE(1506), 1,
      sym_reference_expression,
    STATE(4294), 2,
      sym_line_comment,
      sym_block_comment,
  [123418] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7606), 1,
      anon_sym_LPAREN,
    STATE(1543), 1,
      sym_special_argument_list,
    STATE(4295), 2,
      sym_line_comment,
      sym_block_comment,
  [123435] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5319), 1,
      anon_sym_LBRACE,
    STATE(2329), 1,
      sym_block,
    STATE(4296), 2,
      sym_line_comment,
      sym_block_comment,
  [123452] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3310), 1,
      anon_sym_LBRACE,
    STATE(2336), 1,
      sym_type_initializer_body,
    STATE(4297), 2,
      sym_line_comment,
      sym_block_comment,
  [123469] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5309), 1,
      anon_sym_LBRACE,
    STATE(1193), 1,
      sym_block,
    STATE(4298), 2,
      sym_line_comment,
      sym_block_comment,
  [123486] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5309), 1,
      anon_sym_LBRACE,
    STATE(1194), 1,
      sym_block,
    STATE(4299), 2,
      sym_line_comment,
      sym_block_comment,
  [123503] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7608), 1,
      sym_identifier,
    STATE(2398), 1,
      sym_type_reference_expression,
    STATE(4300), 2,
      sym_line_comment,
      sym_block_comment,
  [123520] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7610), 1,
      anon_sym_LBRACE,
    STATE(1315), 1,
      sym__struct_body,
    STATE(4301), 2,
      sym_line_comment,
      sym_block_comment,
  [123537] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7612), 1,
      anon_sym_LBRACE,
    STATE(1684), 1,
      sym_type_initializer_body,
    STATE(4302), 2,
      sym_line_comment,
      sym_block_comment,
  [123554] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7594), 1,
      anon_sym_LBRACE,
    STATE(2336), 1,
      sym_type_initializer_body,
    STATE(4303), 2,
      sym_line_comment,
      sym_block_comment,
  [123571] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7614), 1,
      anon_sym_LBRACE,
    STATE(450), 1,
      sym__struct_body,
    STATE(4304), 2,
      sym_line_comment,
      sym_block_comment,
  [123588] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    STATE(2627), 1,
      sym_block,
    STATE(4305), 2,
      sym_line_comment,
      sym_block_comment,
  [123605] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3302), 1,
      anon_sym_LBRACE,
    STATE(2336), 1,
      sym_type_initializer_body,
    STATE(4306), 2,
      sym_line_comment,
      sym_block_comment,
  [123622] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6622), 1,
      anon_sym_LBRACE,
    STATE(1827), 1,
      sym__interface_body,
    STATE(4307), 2,
      sym_line_comment,
      sym_block_comment,
  [123639] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5315), 1,
      anon_sym_LBRACE,
    STATE(1495), 1,
      sym_block,
    STATE(4308), 2,
      sym_line_comment,
      sym_block_comment,
  [123656] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7616), 1,
      sym_identifier,
    STATE(1024), 1,
      sym_type_reference_expression,
    STATE(4309), 2,
      sym_line_comment,
      sym_block_comment,
  [123673] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5319), 1,
      anon_sym_LBRACE,
    STATE(2239), 1,
      sym_block,
    STATE(4310), 2,
      sym_line_comment,
      sym_block_comment,
  [123690] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7618), 1,
      anon_sym_LPAREN,
    STATE(1197), 1,
      sym_argument_list,
    STATE(4311), 2,
      sym_line_comment,
      sym_block_comment,
  [123707] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6718), 1,
      anon_sym_LBRACE,
    STATE(1832), 1,
      sym__enum_body,
    STATE(4312), 2,
      sym_line_comment,
      sym_block_comment,
  [123724] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5325), 1,
      anon_sym_LBRACE,
    STATE(2389), 1,
      sym_block,
    STATE(4313), 2,
      sym_line_comment,
      sym_block_comment,
  [123741] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6628), 1,
      anon_sym_LBRACE,
    STATE(1812), 1,
      sym__struct_body,
    STATE(4314), 2,
      sym_line_comment,
      sym_block_comment,
  [123758] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5309), 1,
      anon_sym_LBRACE,
    STATE(1199), 1,
      sym_block,
    STATE(4315), 2,
      sym_line_comment,
      sym_block_comment,
  [123775] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5325), 1,
      anon_sym_LBRACE,
    STATE(2403), 1,
      sym_block,
    STATE(4316), 2,
      sym_line_comment,
      sym_block_comment,
  [123792] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    STATE(2401), 1,
      sym__content_block,
    STATE(4317), 2,
      sym_line_comment,
      sym_block_comment,
  [123809] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5319), 1,
      anon_sym_LBRACE,
    STATE(2315), 1,
      sym_block,
    STATE(4318), 2,
      sym_line_comment,
      sym_block_comment,
  [123826] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7620), 1,
      anon_sym_LBRACE,
    STATE(1471), 1,
      sym_type_initializer_body,
    STATE(4319), 2,
      sym_line_comment,
      sym_block_comment,
  [123843] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5813), 2,
      anon_sym_COMMA,
      anon_sym_in,
    STATE(4320), 2,
      sym_line_comment,
      sym_block_comment,
  [123858] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7622), 1,
      anon_sym_COMMA,
    ACTIONS(7624), 1,
      anon_sym_RPAREN,
    STATE(4321), 2,
      sym_line_comment,
      sym_block_comment,
  [123875] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7035), 1,
      anon_sym_LBRACE,
    STATE(1208), 1,
      sym__content_block,
    STATE(4322), 2,
      sym_line_comment,
      sym_block_comment,
  [123892] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5309), 1,
      anon_sym_LBRACE,
    STATE(1211), 1,
      sym_block,
    STATE(4323), 2,
      sym_line_comment,
      sym_block_comment,
  [123909] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5309), 1,
      anon_sym_LBRACE,
    STATE(1135), 1,
      sym_block,
    STATE(4324), 2,
      sym_line_comment,
      sym_block_comment,
  [123926] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7626), 1,
      anon_sym_RBRACE,
    ACTIONS(7628), 1,
      aux_sym_format_specifier_token1,
    STATE(4325), 2,
      sym_line_comment,
      sym_block_comment,
  [123943] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3302), 1,
      anon_sym_LBRACE,
    STATE(1227), 1,
      sym_type_initializer_body,
    STATE(4326), 2,
      sym_line_comment,
      sym_block_comment,
  [123960] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7140), 1,
      anon_sym_LBRACE,
    STATE(2313), 1,
      sym__content_block,
    STATE(4327), 2,
      sym_line_comment,
      sym_block_comment,
  [123977] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5325), 1,
      anon_sym_LBRACE,
    STATE(2421), 1,
      sym_block,
    STATE(4328), 2,
      sym_line_comment,
      sym_block_comment,
  [123994] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    STATE(2692), 1,
      sym_block,
    STATE(4329), 2,
      sym_line_comment,
      sym_block_comment,
  [124011] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7630), 1,
      anon_sym_LBRACE,
    STATE(1722), 1,
      sym__struct_body,
    STATE(4330), 2,
      sym_line_comment,
      sym_block_comment,
  [124028] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_LPAREN,
    STATE(2440), 1,
      sym_argument_list,
    STATE(4331), 2,
      sym_line_comment,
      sym_block_comment,
  [124045] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7632), 1,
      sym_identifier,
    STATE(3424), 1,
      sym_type_reference_expression,
    STATE(4332), 2,
      sym_line_comment,
      sym_block_comment,
  [124062] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5325), 1,
      anon_sym_LBRACE,
    STATE(2433), 1,
      sym_block,
    STATE(4333), 2,
      sym_line_comment,
      sym_block_comment,
  [124079] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5325), 1,
      anon_sym_LBRACE,
    STATE(2436), 1,
      sym_block,
    STATE(4334), 2,
      sym_line_comment,
      sym_block_comment,
  [124096] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3310), 1,
      anon_sym_LBRACE,
    STATE(1227), 1,
      sym_type_initializer_body,
    STATE(4335), 2,
      sym_line_comment,
      sym_block_comment,
  [124113] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5315), 1,
      anon_sym_LBRACE,
    STATE(1508), 1,
      sym_block,
    STATE(4336), 2,
      sym_line_comment,
      sym_block_comment,
  [124130] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5309), 1,
      anon_sym_LBRACE,
    STATE(1220), 1,
      sym_block,
    STATE(4337), 2,
      sym_line_comment,
      sym_block_comment,
  [124147] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7554), 1,
      anon_sym_LBRACE,
    STATE(1227), 1,
      sym_type_initializer_body,
    STATE(4338), 2,
      sym_line_comment,
      sym_block_comment,
  [124164] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3310), 1,
      anon_sym_LBRACE,
    STATE(1471), 1,
      sym_type_initializer_body,
    STATE(4339), 2,
      sym_line_comment,
      sym_block_comment,
  [124181] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7634), 1,
      sym_identifier,
    STATE(1482), 1,
      sym_type_reference_expression,
    STATE(4340), 2,
      sym_line_comment,
      sym_block_comment,
  [124198] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5351), 1,
      anon_sym_LPAREN,
    STATE(2697), 1,
      sym_argument_list,
    STATE(4341), 2,
      sym_line_comment,
      sym_block_comment,
  [124215] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5319), 1,
      anon_sym_LBRACE,
    STATE(2286), 1,
      sym_block,
    STATE(4342), 2,
      sym_line_comment,
      sym_block_comment,
  [124232] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    STATE(2702), 1,
      sym_block,
    STATE(4343), 2,
      sym_line_comment,
      sym_block_comment,
  [124249] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5315), 1,
      anon_sym_LBRACE,
    STATE(1507), 1,
      sym_block,
    STATE(4344), 2,
      sym_line_comment,
      sym_block_comment,
  [124266] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7011), 2,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
    STATE(4345), 2,
      sym_line_comment,
      sym_block_comment,
  [124281] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7636), 1,
      anon_sym_LPAREN,
    STATE(2327), 1,
      sym_argument_list,
    STATE(4346), 2,
      sym_line_comment,
      sym_block_comment,
  [124298] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7638), 1,
      anon_sym_COMMA,
    ACTIONS(7640), 1,
      anon_sym_RPAREN,
    STATE(4347), 2,
      sym_line_comment,
      sym_block_comment,
  [124315] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7508), 1,
      anon_sym_LBRACE,
    STATE(2246), 1,
      sym_block,
    STATE(4348), 2,
      sym_line_comment,
      sym_block_comment,
  [124332] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5325), 1,
      anon_sym_LBRACE,
    STATE(4658), 1,
      sym_block,
    STATE(4349), 2,
      sym_line_comment,
      sym_block_comment,
  [124349] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5327), 1,
      anon_sym_LBRACE,
    STATE(2092), 1,
      sym_block,
    STATE(4350), 2,
      sym_line_comment,
      sym_block_comment,
  [124366] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7642), 1,
      anon_sym_LPAREN,
    STATE(1244), 1,
      sym_special_argument_list,
    STATE(4351), 2,
      sym_line_comment,
      sym_block_comment,
  [124383] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6894), 1,
      sym_identifier,
    STATE(1248), 1,
      sym_reference_expression,
    STATE(4352), 2,
      sym_line_comment,
      sym_block_comment,
  [124400] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7644), 1,
      anon_sym_LBRACE,
    STATE(1218), 1,
      sym__struct_body,
    STATE(4353), 2,
      sym_line_comment,
      sym_block_comment,
  [124417] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6684), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_import_name,
    STATE(4354), 2,
      sym_line_comment,
      sym_block_comment,
  [124434] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7620), 1,
      anon_sym_LBRACE,
    STATE(1471), 1,
      sym_type_initializer_body,
    STATE(4355), 2,
      sym_line_comment,
      sym_block_comment,
  [124451] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6849), 1,
      sym_identifier,
    STATE(3656), 1,
      sym_reference_expression,
    STATE(4356), 2,
      sym_line_comment,
      sym_block_comment,
  [124468] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7646), 1,
      sym_identifier,
    STATE(1378), 1,
      sym_type_reference_expression,
    STATE(4357), 2,
      sym_line_comment,
      sym_block_comment,
  [124485] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3302), 1,
      anon_sym_LBRACE,
    STATE(1471), 1,
      sym_type_initializer_body,
    STATE(4358), 2,
      sym_line_comment,
      sym_block_comment,
  [124502] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6684), 1,
      sym_identifier,
    STATE(3518), 1,
      sym_import_name,
    STATE(4359), 2,
      sym_line_comment,
      sym_block_comment,
  [124519] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5319), 1,
      anon_sym_LBRACE,
    STATE(2266), 1,
      sym_block,
    STATE(4360), 2,
      sym_line_comment,
      sym_block_comment,
  [124536] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5319), 1,
      anon_sym_LBRACE,
    STATE(2267), 1,
      sym_block,
    STATE(4361), 2,
      sym_line_comment,
      sym_block_comment,
  [124553] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5315), 1,
      anon_sym_LBRACE,
    STATE(1424), 1,
      sym_block,
    STATE(4362), 2,
      sym_line_comment,
      sym_block_comment,
  [124570] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5315), 1,
      anon_sym_LBRACE,
    STATE(1439), 1,
      sym_block,
    STATE(4363), 2,
      sym_line_comment,
      sym_block_comment,
  [124587] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7648), 1,
      anon_sym_COMMA,
    ACTIONS(7650), 1,
      anon_sym_RPAREN,
    STATE(4364), 2,
      sym_line_comment,
      sym_block_comment,
  [124604] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5325), 1,
      anon_sym_LBRACE,
    STATE(2492), 1,
      sym_block,
    STATE(4365), 2,
      sym_line_comment,
      sym_block_comment,
  [124621] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6970), 1,
      anon_sym_LBRACE,
    STATE(2659), 1,
      sym__content_block,
    STATE(4366), 2,
      sym_line_comment,
      sym_block_comment,
  [124638] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7652), 1,
      anon_sym_COMMA,
    ACTIONS(7654), 1,
      anon_sym_RPAREN,
    STATE(4367), 2,
      sym_line_comment,
      sym_block_comment,
  [124655] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7656), 1,
      anon_sym_LPAREN,
    STATE(2357), 1,
      sym_special_argument_list,
    STATE(4368), 2,
      sym_line_comment,
      sym_block_comment,
  [124672] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7658), 1,
      anon_sym_COMMA,
    ACTIONS(7660), 1,
      anon_sym_RPAREN,
    STATE(4369), 2,
      sym_line_comment,
      sym_block_comment,
  [124689] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    STATE(2658), 1,
      sym_block,
    STATE(4370), 2,
      sym_line_comment,
      sym_block_comment,
  [124706] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5331), 1,
      anon_sym_LBRACE,
    STATE(1603), 1,
      sym_block,
    STATE(4371), 2,
      sym_line_comment,
      sym_block_comment,
  [124723] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7090), 1,
      anon_sym_LBRACE,
    STATE(1442), 1,
      sym__content_block,
    STATE(4372), 2,
      sym_line_comment,
      sym_block_comment,
  [124740] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6622), 1,
      anon_sym_LBRACE,
    STATE(1866), 1,
      sym__interface_body,
    STATE(4373), 2,
      sym_line_comment,
      sym_block_comment,
  [124757] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    STATE(2549), 1,
      sym_block,
    STATE(4374), 2,
      sym_line_comment,
      sym_block_comment,
  [124774] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7662), 1,
      anon_sym_LPAREN,
    STATE(1664), 1,
      sym_special_argument_list,
    STATE(4375), 2,
      sym_line_comment,
      sym_block_comment,
  [124791] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    STATE(479), 1,
      sym_block,
    STATE(4376), 2,
      sym_line_comment,
      sym_block_comment,
  [124808] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6866), 1,
      sym_identifier,
    STATE(1660), 1,
      sym_reference_expression,
    STATE(4377), 2,
      sym_line_comment,
      sym_block_comment,
  [124825] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5319), 1,
      anon_sym_LBRACE,
    STATE(2292), 1,
      sym_block,
    STATE(4378), 2,
      sym_line_comment,
      sym_block_comment,
  [124842] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7177), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(4379), 2,
      sym_line_comment,
      sym_block_comment,
  [124857] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5309), 1,
      anon_sym_LBRACE,
    STATE(1242), 1,
      sym_block,
    STATE(4380), 2,
      sym_line_comment,
      sym_block_comment,
  [124874] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5315), 1,
      anon_sym_LBRACE,
    STATE(1474), 1,
      sym_block,
    STATE(4381), 2,
      sym_line_comment,
      sym_block_comment,
  [124891] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6780), 1,
      sym_identifier,
    STATE(2778), 1,
      sym_reference_expression,
    STATE(4382), 2,
      sym_line_comment,
      sym_block_comment,
  [124908] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6664), 1,
      anon_sym_LBRACE,
    STATE(2419), 1,
      sym_type_initializer_body,
    STATE(4383), 2,
      sym_line_comment,
      sym_block_comment,
  [124925] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5331), 1,
      anon_sym_LBRACE,
    STATE(1666), 1,
      sym_block,
    STATE(4384), 2,
      sym_line_comment,
      sym_block_comment,
  [124942] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6718), 1,
      anon_sym_LBRACE,
    STATE(1885), 1,
      sym__enum_body,
    STATE(4385), 2,
      sym_line_comment,
      sym_block_comment,
  [124959] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7664), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(4386), 2,
      sym_line_comment,
      sym_block_comment,
  [124974] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6692), 1,
      sym_identifier,
    STATE(4223), 1,
      sym_reference_expression,
    STATE(4387), 2,
      sym_line_comment,
      sym_block_comment,
  [124991] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3310), 1,
      anon_sym_LBRACE,
    STATE(1684), 1,
      sym_type_initializer_body,
    STATE(4388), 2,
      sym_line_comment,
      sym_block_comment,
  [125008] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7666), 1,
      anon_sym_LBRACE,
    STATE(1531), 1,
      sym__struct_body,
    STATE(4389), 2,
      sym_line_comment,
      sym_block_comment,
  [125025] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6628), 1,
      anon_sym_LBRACE,
    STATE(1850), 1,
      sym__struct_body,
    STATE(4390), 2,
      sym_line_comment,
      sym_block_comment,
  [125042] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5315), 1,
      anon_sym_LBRACE,
    STATE(1472), 1,
      sym_block,
    STATE(4391), 2,
      sym_line_comment,
      sym_block_comment,
  [125059] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7084), 1,
      sym_identifier,
    STATE(4096), 1,
      sym_reference_expression,
    STATE(4392), 2,
      sym_line_comment,
      sym_block_comment,
  [125076] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    ACTIONS(7670), 1,
      anon_sym_RPAREN,
    STATE(4393), 2,
      sym_line_comment,
      sym_block_comment,
  [125093] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7672), 1,
      anon_sym_LPAREN,
    STATE(2751), 1,
      sym_special_argument_list,
    STATE(4394), 2,
      sym_line_comment,
      sym_block_comment,
  [125110] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7674), 1,
      anon_sym_LBRACE,
    STATE(1067), 1,
      sym__struct_body,
    STATE(4395), 2,
      sym_line_comment,
      sym_block_comment,
  [125127] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5331), 1,
      anon_sym_LBRACE,
    STATE(1637), 1,
      sym_block,
    STATE(4396), 2,
      sym_line_comment,
      sym_block_comment,
  [125144] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5331), 1,
      anon_sym_LBRACE,
    STATE(1638), 1,
      sym_block,
    STATE(4397), 2,
      sym_line_comment,
      sym_block_comment,
  [125161] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    STATE(428), 1,
      sym_block,
    STATE(4398), 2,
      sym_line_comment,
      sym_block_comment,
  [125178] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7440), 1,
      anon_sym_LBRACE,
    STATE(2186), 1,
      sym_type_initializer_body,
    STATE(4399), 2,
      sym_line_comment,
      sym_block_comment,
  [125195] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    STATE(425), 1,
      sym_block,
    STATE(4400), 2,
      sym_line_comment,
      sym_block_comment,
  [125212] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7612), 1,
      anon_sym_LBRACE,
    STATE(1684), 1,
      sym_type_initializer_body,
    STATE(4401), 2,
      sym_line_comment,
      sym_block_comment,
  [125229] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5315), 1,
      anon_sym_LBRACE,
    STATE(1454), 1,
      sym_block,
    STATE(4402), 2,
      sym_line_comment,
      sym_block_comment,
  [125246] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7676), 1,
      sym_identifier,
    STATE(359), 1,
      sym_type_reference_expression,
    STATE(4403), 2,
      sym_line_comment,
      sym_block_comment,
  [125263] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3302), 1,
      anon_sym_LBRACE,
    STATE(1684), 1,
      sym_type_initializer_body,
    STATE(4404), 2,
      sym_line_comment,
      sym_block_comment,
  [125280] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5331), 1,
      anon_sym_LBRACE,
    STATE(1557), 1,
      sym_block,
    STATE(4405), 2,
      sym_line_comment,
      sym_block_comment,
  [125297] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5331), 1,
      anon_sym_LBRACE,
    STATE(1662), 1,
      sym_block,
    STATE(4406), 2,
      sym_line_comment,
      sym_block_comment,
  [125314] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6920), 1,
      anon_sym_LBRACE,
    STATE(1644), 1,
      sym__content_block,
    STATE(4407), 2,
      sym_line_comment,
      sym_block_comment,
  [125331] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5157), 1,
      anon_sym_COLON,
    ACTIONS(7678), 1,
      anon_sym_mut,
    STATE(4408), 2,
      sym_line_comment,
      sym_block_comment,
  [125348] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    STATE(1640), 1,
      sym_argument_list,
    STATE(4409), 2,
      sym_line_comment,
      sym_block_comment,
  [125365] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5331), 1,
      anon_sym_LBRACE,
    STATE(1612), 1,
      sym_block,
    STATE(4410), 2,
      sym_line_comment,
      sym_block_comment,
  [125382] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7680), 1,
      anon_sym_LPAREN,
    STATE(1456), 1,
      sym_argument_list,
    STATE(4411), 2,
      sym_line_comment,
      sym_block_comment,
  [125399] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    STATE(2649), 1,
      sym_block,
    STATE(4412), 2,
      sym_line_comment,
      sym_block_comment,
  [125416] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7682), 1,
      sym_identifier,
    STATE(1261), 1,
      sym_type_reference_expression,
    STATE(4413), 2,
      sym_line_comment,
      sym_block_comment,
  [125433] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7684), 1,
      anon_sym_RBRACE,
    STATE(4414), 2,
      sym_line_comment,
      sym_block_comment,
  [125447] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7584), 1,
      anon_sym_RBRACE,
    STATE(4415), 2,
      sym_line_comment,
      sym_block_comment,
  [125461] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7686), 1,
      anon_sym_RBRACE,
    STATE(4416), 2,
      sym_line_comment,
      sym_block_comment,
  [125475] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5157), 1,
      anon_sym_COLON,
    STATE(4417), 2,
      sym_line_comment,
      sym_block_comment,
  [125489] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7688), 1,
      anon_sym_COLON,
    STATE(4418), 2,
      sym_line_comment,
      sym_block_comment,
  [125503] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7690), 1,
      aux_sym__content_block_token1,
    STATE(4419), 2,
      sym_line_comment,
      sym_block_comment,
  [125517] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7692), 1,
      anon_sym_LBRACE,
    STATE(4420), 2,
      sym_line_comment,
      sym_block_comment,
  [125531] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7694), 1,
      anon_sym_LBRACE,
    STATE(4421), 2,
      sym_line_comment,
      sym_block_comment,
  [125545] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7696), 1,
      anon_sym_LBRACE,
    STATE(4422), 2,
      sym_line_comment,
      sym_block_comment,
  [125559] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7698), 1,
      anon_sym_DOT,
    STATE(4423), 2,
      sym_line_comment,
      sym_block_comment,
  [125573] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5665), 1,
      anon_sym_LBRACE,
    STATE(4424), 2,
      sym_line_comment,
      sym_block_comment,
  [125587] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7700), 1,
      anon_sym_DOT,
    STATE(4425), 2,
      sym_line_comment,
      sym_block_comment,
  [125601] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5663), 1,
      anon_sym_LBRACE,
    STATE(4426), 2,
      sym_line_comment,
      sym_block_comment,
  [125615] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    STATE(4427), 2,
      sym_line_comment,
      sym_block_comment,
  [125629] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7704), 1,
      aux_sym__content_block_token1,
    STATE(4428), 2,
      sym_line_comment,
      sym_block_comment,
  [125643] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7706), 1,
      anon_sym_RBRACK,
    STATE(4429), 2,
      sym_line_comment,
      sym_block_comment,
  [125657] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6880), 1,
      anon_sym_RBRACE,
    STATE(4430), 2,
      sym_line_comment,
      sym_block_comment,
  [125671] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7708), 1,
      anon_sym_RBRACE,
    STATE(4431), 2,
      sym_line_comment,
      sym_block_comment,
  [125685] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7710), 1,
      anon_sym_RBRACE,
    STATE(4432), 2,
      sym_line_comment,
      sym_block_comment,
  [125699] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7712), 1,
      sym_int_literal,
    STATE(4433), 2,
      sym_line_comment,
      sym_block_comment,
  [125713] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1219), 1,
      anon_sym_RBRACE,
    STATE(4434), 2,
      sym_line_comment,
      sym_block_comment,
  [125727] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7714), 1,
      anon_sym_RBRACE,
    STATE(4435), 2,
      sym_line_comment,
      sym_block_comment,
  [125741] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1784), 1,
      anon_sym_RPAREN,
    STATE(4436), 2,
      sym_line_comment,
      sym_block_comment,
  [125755] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7716), 1,
      anon_sym_RBRACE,
    STATE(4437), 2,
      sym_line_comment,
      sym_block_comment,
  [125769] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7564), 1,
      anon_sym_RPAREN,
    STATE(4438), 2,
      sym_line_comment,
      sym_block_comment,
  [125783] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7718), 1,
      aux_sym__content_block_token1,
    STATE(4439), 2,
      sym_line_comment,
      sym_block_comment,
  [125797] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7720), 1,
      anon_sym_LBRACE,
    STATE(4440), 2,
      sym_line_comment,
      sym_block_comment,
  [125811] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5673), 1,
      anon_sym_LBRACE,
    STATE(4441), 2,
      sym_line_comment,
      sym_block_comment,
  [125825] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7722), 1,
      anon_sym_RBRACE,
    STATE(4442), 2,
      sym_line_comment,
      sym_block_comment,
  [125839] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4961), 1,
      sym_identifier,
    STATE(4443), 2,
      sym_line_comment,
      sym_block_comment,
  [125853] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7724), 1,
      anon_sym_DOT,
    STATE(4444), 2,
      sym_line_comment,
      sym_block_comment,
  [125867] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7726), 1,
      anon_sym_RBRACK,
    STATE(4445), 2,
      sym_line_comment,
      sym_block_comment,
  [125881] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7728), 1,
      anon_sym_RBRACE,
    STATE(4446), 2,
      sym_line_comment,
      sym_block_comment,
  [125895] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5657), 1,
      anon_sym_LBRACE,
    STATE(4447), 2,
      sym_line_comment,
      sym_block_comment,
  [125909] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7730), 1,
      anon_sym_LBRACE,
    STATE(4448), 2,
      sym_line_comment,
      sym_block_comment,
  [125923] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7732), 1,
      aux_sym__content_block_token1,
    STATE(4449), 2,
      sym_line_comment,
      sym_block_comment,
  [125937] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7734), 1,
      anon_sym_RBRACE,
    STATE(4450), 2,
      sym_line_comment,
      sym_block_comment,
  [125951] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1249), 1,
      anon_sym_RBRACE,
    STATE(4451), 2,
      sym_line_comment,
      sym_block_comment,
  [125965] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7736), 1,
      anon_sym_LBRACE,
    STATE(4452), 2,
      sym_line_comment,
      sym_block_comment,
  [125979] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7738), 1,
      anon_sym_RBRACE,
    STATE(4453), 2,
      sym_line_comment,
      sym_block_comment,
  [125993] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7740), 1,
      anon_sym_DOT,
    STATE(4454), 2,
      sym_line_comment,
      sym_block_comment,
  [126007] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7742), 1,
      anon_sym_RBRACE,
    STATE(4455), 2,
      sym_line_comment,
      sym_block_comment,
  [126021] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7744), 1,
      anon_sym_RBRACE,
    STATE(4456), 2,
      sym_line_comment,
      sym_block_comment,
  [126035] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7746), 1,
      anon_sym_RBRACE,
    STATE(4457), 2,
      sym_line_comment,
      sym_block_comment,
  [126049] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7748), 1,
      anon_sym_RBRACE,
    STATE(4458), 2,
      sym_line_comment,
      sym_block_comment,
  [126063] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1267), 1,
      anon_sym_RBRACE,
    STATE(4459), 2,
      sym_line_comment,
      sym_block_comment,
  [126077] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7750), 1,
      anon_sym_RBRACE,
    STATE(4460), 2,
      sym_line_comment,
      sym_block_comment,
  [126091] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7752), 1,
      anon_sym_RBRACE,
    STATE(4461), 2,
      sym_line_comment,
      sym_block_comment,
  [126105] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1283), 1,
      anon_sym_RBRACE,
    STATE(4462), 2,
      sym_line_comment,
      sym_block_comment,
  [126119] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7754), 1,
      anon_sym_RBRACE,
    STATE(4463), 2,
      sym_line_comment,
      sym_block_comment,
  [126133] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7756), 1,
      anon_sym_LBRACE,
    STATE(4464), 2,
      sym_line_comment,
      sym_block_comment,
  [126147] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7758), 1,
      anon_sym_DOT,
    STATE(4465), 2,
      sym_line_comment,
      sym_block_comment,
  [126161] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7760), 1,
      anon_sym_RBRACK,
    STATE(4466), 2,
      sym_line_comment,
      sym_block_comment,
  [126175] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1291), 1,
      anon_sym_RBRACE,
    STATE(4467), 2,
      sym_line_comment,
      sym_block_comment,
  [126189] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5613), 1,
      anon_sym_LBRACE,
    STATE(4468), 2,
      sym_line_comment,
      sym_block_comment,
  [126203] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7762), 1,
      anon_sym_LBRACE,
    STATE(4469), 2,
      sym_line_comment,
      sym_block_comment,
  [126217] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7764), 1,
      aux_sym__content_block_token1,
    STATE(4470), 2,
      sym_line_comment,
      sym_block_comment,
  [126231] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7766), 1,
      anon_sym_EQ,
    STATE(4471), 2,
      sym_line_comment,
      sym_block_comment,
  [126245] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7768), 1,
      anon_sym_RBRACE,
    STATE(4472), 2,
      sym_line_comment,
      sym_block_comment,
  [126259] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7770), 1,
      anon_sym_RBRACE,
    STATE(4473), 2,
      sym_line_comment,
      sym_block_comment,
  [126273] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1563), 1,
      anon_sym_RPAREN,
    STATE(4474), 2,
      sym_line_comment,
      sym_block_comment,
  [126287] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1782), 1,
      anon_sym_RPAREN,
    STATE(4475), 2,
      sym_line_comment,
      sym_block_comment,
  [126301] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7772), 1,
      anon_sym_RBRACE,
    STATE(4476), 2,
      sym_line_comment,
      sym_block_comment,
  [126315] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7774), 1,
      anon_sym_RBRACE,
    STATE(4477), 2,
      sym_line_comment,
      sym_block_comment,
  [126329] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7776), 1,
      sym_identifier,
    STATE(4478), 2,
      sym_line_comment,
      sym_block_comment,
  [126343] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7778), 1,
      anon_sym_RBRACK,
    STATE(4479), 2,
      sym_line_comment,
      sym_block_comment,
  [126357] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7780), 1,
      anon_sym_RBRACE,
    STATE(4480), 2,
      sym_line_comment,
      sym_block_comment,
  [126371] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7782), 1,
      anon_sym_RBRACE,
    STATE(4481), 2,
      sym_line_comment,
      sym_block_comment,
  [126385] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1227), 1,
      anon_sym_RBRACE,
    STATE(4482), 2,
      sym_line_comment,
      sym_block_comment,
  [126399] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7784), 1,
      anon_sym_RBRACE,
    STATE(4483), 2,
      sym_line_comment,
      sym_block_comment,
  [126413] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7786), 1,
      anon_sym_RBRACE,
    STATE(4484), 2,
      sym_line_comment,
      sym_block_comment,
  [126427] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7788), 1,
      aux_sym__content_block_token1,
    STATE(4485), 2,
      sym_line_comment,
      sym_block_comment,
  [126441] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7790), 1,
      anon_sym_DOT,
    STATE(4486), 2,
      sym_line_comment,
      sym_block_comment,
  [126455] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7792), 1,
      anon_sym_RBRACE,
    STATE(4487), 2,
      sym_line_comment,
      sym_block_comment,
  [126469] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7794), 1,
      anon_sym_RBRACE,
    STATE(4488), 2,
      sym_line_comment,
      sym_block_comment,
  [126483] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5639), 1,
      anon_sym_LBRACE,
    STATE(4489), 2,
      sym_line_comment,
      sym_block_comment,
  [126497] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7796), 1,
      anon_sym_LBRACE,
    STATE(4490), 2,
      sym_line_comment,
      sym_block_comment,
  [126511] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7798), 1,
      anon_sym_RBRACE,
    STATE(4491), 2,
      sym_line_comment,
      sym_block_comment,
  [126525] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7800), 1,
      anon_sym_LBRACE,
    STATE(4492), 2,
      sym_line_comment,
      sym_block_comment,
  [126539] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7802), 1,
      anon_sym_RBRACK,
    STATE(4493), 2,
      sym_line_comment,
      sym_block_comment,
  [126553] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1786), 1,
      anon_sym_RPAREN,
    STATE(4494), 2,
      sym_line_comment,
      sym_block_comment,
  [126567] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7804), 1,
      anon_sym_RBRACE,
    STATE(4495), 2,
      sym_line_comment,
      sym_block_comment,
  [126581] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7806), 1,
      anon_sym_RBRACE,
    STATE(4496), 2,
      sym_line_comment,
      sym_block_comment,
  [126595] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5675), 1,
      anon_sym_LBRACE,
    STATE(4497), 2,
      sym_line_comment,
      sym_block_comment,
  [126609] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7808), 1,
      anon_sym_RBRACE,
    STATE(4498), 2,
      sym_line_comment,
      sym_block_comment,
  [126623] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1237), 1,
      anon_sym_RBRACE,
    STATE(4499), 2,
      sym_line_comment,
      sym_block_comment,
  [126637] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7810), 1,
      anon_sym_DOT,
    STATE(4500), 2,
      sym_line_comment,
      sym_block_comment,
  [126651] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7812), 1,
      anon_sym_RBRACK,
    STATE(4501), 2,
      sym_line_comment,
      sym_block_comment,
  [126665] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6193), 1,
      anon_sym_LBRACE,
    STATE(4502), 2,
      sym_line_comment,
      sym_block_comment,
  [126679] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7814), 1,
      anon_sym_RBRACE,
    STATE(4503), 2,
      sym_line_comment,
      sym_block_comment,
  [126693] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1285), 1,
      anon_sym_RBRACE,
    STATE(4504), 2,
      sym_line_comment,
      sym_block_comment,
  [126707] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7816), 1,
      anon_sym_COLON_EQ,
    STATE(4505), 2,
      sym_line_comment,
      sym_block_comment,
  [126721] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7818), 1,
      anon_sym_RBRACE,
    STATE(4506), 2,
      sym_line_comment,
      sym_block_comment,
  [126735] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7820), 1,
      anon_sym_DOT,
    STATE(4507), 2,
      sym_line_comment,
      sym_block_comment,
  [126749] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7822), 1,
      anon_sym_RBRACE,
    STATE(4508), 2,
      sym_line_comment,
      sym_block_comment,
  [126763] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7824), 1,
      aux_sym__content_block_token1,
    STATE(4509), 2,
      sym_line_comment,
      sym_block_comment,
  [126777] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5641), 1,
      anon_sym_LBRACE,
    STATE(4510), 2,
      sym_line_comment,
      sym_block_comment,
  [126791] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7826), 1,
      anon_sym_LBRACE,
    STATE(4511), 2,
      sym_line_comment,
      sym_block_comment,
  [126805] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7828), 1,
      aux_sym__content_block_token1,
    STATE(4512), 2,
      sym_line_comment,
      sym_block_comment,
  [126819] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1273), 1,
      anon_sym_RBRACE,
    STATE(4513), 2,
      sym_line_comment,
      sym_block_comment,
  [126833] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7830), 1,
      anon_sym_RBRACK,
    STATE(4514), 2,
      sym_line_comment,
      sym_block_comment,
  [126847] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7832), 1,
      anon_sym_RBRACE,
    STATE(4515), 2,
      sym_line_comment,
      sym_block_comment,
  [126861] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7834), 1,
      anon_sym_RBRACE,
    STATE(4516), 2,
      sym_line_comment,
      sym_block_comment,
  [126875] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1289), 1,
      anon_sym_RBRACE,
    STATE(4517), 2,
      sym_line_comment,
      sym_block_comment,
  [126889] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7836), 1,
      anon_sym_LBRACE,
    STATE(4518), 2,
      sym_line_comment,
      sym_block_comment,
  [126903] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7838), 1,
      sym_identifier,
    STATE(4519), 2,
      sym_line_comment,
      sym_block_comment,
  [126917] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7840), 1,
      sym_identifier,
    STATE(4520), 2,
      sym_line_comment,
      sym_block_comment,
  [126931] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7842), 1,
      sym_identifier,
    STATE(4521), 2,
      sym_line_comment,
      sym_block_comment,
  [126945] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5681), 1,
      anon_sym_LBRACE,
    STATE(4522), 2,
      sym_line_comment,
      sym_block_comment,
  [126959] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7844), 1,
      anon_sym_DOT,
    STATE(4523), 2,
      sym_line_comment,
      sym_block_comment,
  [126973] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7846), 1,
      anon_sym_RBRACK,
    STATE(4524), 2,
      sym_line_comment,
      sym_block_comment,
  [126987] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7848), 1,
      anon_sym_RBRACE,
    STATE(4525), 2,
      sym_line_comment,
      sym_block_comment,
  [127001] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7850), 1,
      anon_sym_RBRACE,
    STATE(4526), 2,
      sym_line_comment,
      sym_block_comment,
  [127015] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1221), 1,
      anon_sym_RBRACE,
    STATE(4527), 2,
      sym_line_comment,
      sym_block_comment,
  [127029] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7852), 1,
      anon_sym_DOT,
    STATE(4528), 2,
      sym_line_comment,
      sym_block_comment,
  [127043] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7854), 1,
      anon_sym_RBRACE,
    STATE(4529), 2,
      sym_line_comment,
      sym_block_comment,
  [127057] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7856), 1,
      anon_sym_RBRACK,
    STATE(4530), 2,
      sym_line_comment,
      sym_block_comment,
  [127071] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5643), 1,
      anon_sym_LBRACE,
    STATE(4531), 2,
      sym_line_comment,
      sym_block_comment,
  [127085] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7858), 1,
      anon_sym_LBRACE,
    STATE(4532), 2,
      sym_line_comment,
      sym_block_comment,
  [127099] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7860), 1,
      aux_sym__content_block_token1,
    STATE(4533), 2,
      sym_line_comment,
      sym_block_comment,
  [127113] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1909), 1,
      anon_sym_RPAREN,
    STATE(4534), 2,
      sym_line_comment,
      sym_block_comment,
  [127127] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7862), 1,
      sym_identifier,
    STATE(4535), 2,
      sym_line_comment,
      sym_block_comment,
  [127141] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7864), 1,
      anon_sym_RBRACK,
    STATE(4536), 2,
      sym_line_comment,
      sym_block_comment,
  [127155] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1788), 1,
      anon_sym_RPAREN,
    STATE(4537), 2,
      sym_line_comment,
      sym_block_comment,
  [127169] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7866), 1,
      sym_identifier,
    STATE(4538), 2,
      sym_line_comment,
      sym_block_comment,
  [127183] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7868), 1,
      sym_identifier,
    STATE(4539), 2,
      sym_line_comment,
      sym_block_comment,
  [127197] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7870), 1,
      sym_identifier,
    STATE(4540), 2,
      sym_line_comment,
      sym_block_comment,
  [127211] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7872), 1,
      anon_sym_RBRACK,
    STATE(4541), 2,
      sym_line_comment,
      sym_block_comment,
  [127225] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7874), 1,
      sym_identifier,
    STATE(4542), 2,
      sym_line_comment,
      sym_block_comment,
  [127239] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7876), 1,
      anon_sym_RBRACE,
    STATE(4543), 2,
      sym_line_comment,
      sym_block_comment,
  [127253] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7878), 1,
      anon_sym_RBRACE,
    STATE(4544), 2,
      sym_line_comment,
      sym_block_comment,
  [127267] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7880), 1,
      anon_sym_DOT,
    STATE(4545), 2,
      sym_line_comment,
      sym_block_comment,
  [127281] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    STATE(4546), 2,
      sym_line_comment,
      sym_block_comment,
  [127295] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5651), 1,
      anon_sym_LBRACE,
    STATE(4547), 2,
      sym_line_comment,
      sym_block_comment,
  [127309] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7884), 1,
      anon_sym_LBRACE,
    STATE(4548), 2,
      sym_line_comment,
      sym_block_comment,
  [127323] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7886), 1,
      aux_sym__content_block_token1,
    STATE(4549), 2,
      sym_line_comment,
      sym_block_comment,
  [127337] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7888), 1,
      anon_sym_RBRACE,
    STATE(4550), 2,
      sym_line_comment,
      sym_block_comment,
  [127351] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7890), 1,
      anon_sym_RBRACE,
    STATE(4551), 2,
      sym_line_comment,
      sym_block_comment,
  [127365] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1259), 1,
      anon_sym_RBRACE,
    STATE(4552), 2,
      sym_line_comment,
      sym_block_comment,
  [127379] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7892), 1,
      anon_sym_DOT,
    STATE(4553), 2,
      sym_line_comment,
      sym_block_comment,
  [127393] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7894), 1,
      aux_sym__content_block_token1,
    STATE(4554), 2,
      sym_line_comment,
      sym_block_comment,
  [127407] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5223), 1,
      sym_identifier,
    STATE(4555), 2,
      sym_line_comment,
      sym_block_comment,
  [127421] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7896), 1,
      anon_sym_RBRACE,
    STATE(4556), 2,
      sym_line_comment,
      sym_block_comment,
  [127435] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7898), 1,
      anon_sym_DOT,
    STATE(4557), 2,
      sym_line_comment,
      sym_block_comment,
  [127449] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7900), 1,
      aux_sym__content_block_token1,
    STATE(4558), 2,
      sym_line_comment,
      sym_block_comment,
  [127463] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7902), 1,
      anon_sym_RBRACE,
    STATE(4559), 2,
      sym_line_comment,
      sym_block_comment,
  [127477] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7904), 1,
      anon_sym_RBRACE,
    STATE(4560), 2,
      sym_line_comment,
      sym_block_comment,
  [127491] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7906), 1,
      anon_sym_DOT,
    STATE(4561), 2,
      sym_line_comment,
      sym_block_comment,
  [127505] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7908), 1,
      anon_sym_RBRACE,
    STATE(4562), 2,
      sym_line_comment,
      sym_block_comment,
  [127519] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7910), 1,
      anon_sym_RBRACE,
    STATE(4563), 2,
      sym_line_comment,
      sym_block_comment,
  [127533] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7912), 1,
      anon_sym_RBRACE,
    STATE(4564), 2,
      sym_line_comment,
      sym_block_comment,
  [127547] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7914), 1,
      anon_sym_RBRACE,
    STATE(4565), 2,
      sym_line_comment,
      sym_block_comment,
  [127561] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7916), 1,
      aux_sym__content_block_token1,
    STATE(4566), 2,
      sym_line_comment,
      sym_block_comment,
  [127575] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7918), 1,
      anon_sym_RBRACE,
    STATE(4567), 2,
      sym_line_comment,
      sym_block_comment,
  [127589] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7920), 1,
      sym_identifier,
    STATE(4568), 2,
      sym_line_comment,
      sym_block_comment,
  [127603] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7922), 1,
      sym_identifier,
    STATE(4569), 2,
      sym_line_comment,
      sym_block_comment,
  [127617] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7626), 1,
      anon_sym_RBRACE,
    STATE(4570), 2,
      sym_line_comment,
      sym_block_comment,
  [127631] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7924), 1,
      sym_identifier,
    STATE(4571), 2,
      sym_line_comment,
      sym_block_comment,
  [127645] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1263), 1,
      anon_sym_RBRACE,
    STATE(4572), 2,
      sym_line_comment,
      sym_block_comment,
  [127659] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7926), 1,
      anon_sym_RBRACE,
    STATE(4573), 2,
      sym_line_comment,
      sym_block_comment,
  [127673] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1911), 1,
      anon_sym_RPAREN,
    STATE(4574), 2,
      sym_line_comment,
      sym_block_comment,
  [127687] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7928), 1,
      anon_sym_SEMI,
    STATE(4575), 2,
      sym_line_comment,
      sym_block_comment,
  [127701] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7930), 1,
      anon_sym_RBRACK,
    STATE(4576), 2,
      sym_line_comment,
      sym_block_comment,
  [127715] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7932), 1,
      sym_int_literal,
    STATE(4577), 2,
      sym_line_comment,
      sym_block_comment,
  [127729] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7934), 1,
      anon_sym_in,
    STATE(4578), 2,
      sym_line_comment,
      sym_block_comment,
  [127743] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7936), 1,
      anon_sym_RBRACE,
    STATE(4579), 2,
      sym_line_comment,
      sym_block_comment,
  [127757] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7938), 1,
      sym_identifier,
    STATE(4580), 2,
      sym_line_comment,
      sym_block_comment,
  [127771] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7940), 1,
      anon_sym_RBRACK,
    STATE(4581), 2,
      sym_line_comment,
      sym_block_comment,
  [127785] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7942), 1,
      anon_sym_RBRACE,
    STATE(4582), 2,
      sym_line_comment,
      sym_block_comment,
  [127799] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1239), 1,
      anon_sym_RBRACE,
    STATE(4583), 2,
      sym_line_comment,
      sym_block_comment,
  [127813] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7944), 1,
      anon_sym_RBRACE,
    STATE(4584), 2,
      sym_line_comment,
      sym_block_comment,
  [127827] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7946), 1,
      anon_sym_RBRACE,
    STATE(4585), 2,
      sym_line_comment,
      sym_block_comment,
  [127841] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7948), 1,
      anon_sym_COLON,
    STATE(4586), 2,
      sym_line_comment,
      sym_block_comment,
  [127855] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7950), 1,
      anon_sym_RBRACK,
    STATE(4587), 2,
      sym_line_comment,
      sym_block_comment,
  [127869] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7952), 1,
      aux_sym__content_block_token1,
    STATE(4588), 2,
      sym_line_comment,
      sym_block_comment,
  [127883] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7954), 1,
      anon_sym_LBRACE,
    STATE(4589), 2,
      sym_line_comment,
      sym_block_comment,
  [127897] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7956), 1,
      anon_sym_RBRACE,
    STATE(4590), 2,
      sym_line_comment,
      sym_block_comment,
  [127911] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1243), 1,
      anon_sym_RBRACE,
    STATE(4591), 2,
      sym_line_comment,
      sym_block_comment,
  [127925] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5693), 1,
      anon_sym_LBRACE,
    STATE(4592), 2,
      sym_line_comment,
      sym_block_comment,
  [127939] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7958), 1,
      aux_sym__content_block_token1,
    STATE(4593), 2,
      sym_line_comment,
      sym_block_comment,
  [127953] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7960), 1,
      anon_sym_RBRACE,
    STATE(4594), 2,
      sym_line_comment,
      sym_block_comment,
  [127967] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7962), 1,
      anon_sym_LBRACE,
    STATE(4595), 2,
      sym_line_comment,
      sym_block_comment,
  [127981] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5699), 1,
      anon_sym_LBRACE,
    STATE(4596), 2,
      sym_line_comment,
      sym_block_comment,
  [127995] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7964), 1,
      anon_sym_RBRACE,
    STATE(4597), 2,
      sym_line_comment,
      sym_block_comment,
  [128009] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1241), 1,
      anon_sym_RBRACE,
    STATE(4598), 2,
      sym_line_comment,
      sym_block_comment,
  [128023] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6295), 1,
      anon_sym_COLON_EQ,
    STATE(4599), 2,
      sym_line_comment,
      sym_block_comment,
  [128037] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7966), 1,
      anon_sym_RBRACE,
    STATE(4600), 2,
      sym_line_comment,
      sym_block_comment,
  [128051] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7968), 1,
      anon_sym_DOT,
    STATE(4601), 2,
      sym_line_comment,
      sym_block_comment,
  [128065] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7970), 1,
      anon_sym_RBRACE,
    STATE(4602), 2,
      sym_line_comment,
      sym_block_comment,
  [128079] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7972), 1,
      anon_sym_EQ,
    STATE(4603), 2,
      sym_line_comment,
      sym_block_comment,
  [128093] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7974), 1,
      anon_sym_RBRACE,
    STATE(4604), 2,
      sym_line_comment,
      sym_block_comment,
  [128107] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7976), 1,
      sym_identifier,
    STATE(4605), 2,
      sym_line_comment,
      sym_block_comment,
  [128121] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7978), 1,
      anon_sym_RBRACE,
    STATE(4606), 2,
      sym_line_comment,
      sym_block_comment,
  [128135] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7980), 1,
      anon_sym_RBRACE,
    STATE(4607), 2,
      sym_line_comment,
      sym_block_comment,
  [128149] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7982), 1,
      anon_sym_RBRACE,
    STATE(4608), 2,
      sym_line_comment,
      sym_block_comment,
  [128163] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7984), 1,
      anon_sym_DOT,
    STATE(4609), 2,
      sym_line_comment,
      sym_block_comment,
  [128177] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7986), 1,
      anon_sym_RBRACE,
    STATE(4610), 2,
      sym_line_comment,
      sym_block_comment,
  [128191] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7988), 1,
      anon_sym_RBRACK,
    STATE(4611), 2,
      sym_line_comment,
      sym_block_comment,
  [128205] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7990), 1,
      anon_sym_RBRACK,
    STATE(4612), 2,
      sym_line_comment,
      sym_block_comment,
  [128219] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1915), 1,
      anon_sym_RPAREN,
    STATE(4613), 2,
      sym_line_comment,
      sym_block_comment,
  [128233] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1257), 1,
      anon_sym_RBRACE,
    STATE(4614), 2,
      sym_line_comment,
      sym_block_comment,
  [128247] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7992), 1,
      anon_sym_RBRACE,
    STATE(4615), 2,
      sym_line_comment,
      sym_block_comment,
  [128261] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7994), 1,
      anon_sym_RBRACE,
    STATE(4616), 2,
      sym_line_comment,
      sym_block_comment,
  [128275] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7996), 1,
      anon_sym_RBRACE,
    STATE(4617), 2,
      sym_line_comment,
      sym_block_comment,
  [128289] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7998), 1,
      anon_sym_RBRACE,
    STATE(4618), 2,
      sym_line_comment,
      sym_block_comment,
  [128303] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8000), 1,
      anon_sym_RBRACE,
    STATE(4619), 2,
      sym_line_comment,
      sym_block_comment,
  [128317] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8002), 1,
      anon_sym_RBRACE,
    STATE(4620), 2,
      sym_line_comment,
      sym_block_comment,
  [128331] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8004), 1,
      anon_sym_DOT,
    STATE(4621), 2,
      sym_line_comment,
      sym_block_comment,
  [128345] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8006), 1,
      anon_sym_RBRACE,
    STATE(4622), 2,
      sym_line_comment,
      sym_block_comment,
  [128359] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8008), 1,
      anon_sym_RBRACE,
    STATE(4623), 2,
      sym_line_comment,
      sym_block_comment,
  [128373] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8010), 1,
      anon_sym_RBRACK,
    STATE(4624), 2,
      sym_line_comment,
      sym_block_comment,
  [128387] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8012), 1,
      anon_sym_RBRACE,
    STATE(4625), 2,
      sym_line_comment,
      sym_block_comment,
  [128401] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8014), 1,
      aux_sym_shebang_token1,
    STATE(4626), 2,
      sym_line_comment,
      sym_block_comment,
  [128415] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8016), 1,
      anon_sym_COLON,
    STATE(4627), 2,
      sym_line_comment,
      sym_block_comment,
  [128429] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8018), 1,
      anon_sym_RBRACK,
    STATE(4628), 2,
      sym_line_comment,
      sym_block_comment,
  [128443] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8020), 1,
      anon_sym_DOT,
    STATE(4629), 2,
      sym_line_comment,
      sym_block_comment,
  [128457] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1913), 1,
      anon_sym_RPAREN,
    STATE(4630), 2,
      sym_line_comment,
      sym_block_comment,
  [128471] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1633), 1,
      anon_sym_RPAREN,
    STATE(4631), 2,
      sym_line_comment,
      sym_block_comment,
  [128485] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8022), 1,
      anon_sym_RBRACE,
    STATE(4632), 2,
      sym_line_comment,
      sym_block_comment,
  [128499] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1247), 1,
      anon_sym_RBRACE,
    STATE(4633), 2,
      sym_line_comment,
      sym_block_comment,
  [128513] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8024), 1,
      anon_sym_RBRACK,
    STATE(4634), 2,
      sym_line_comment,
      sym_block_comment,
  [128527] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8026), 1,
      anon_sym_RBRACE,
    STATE(4635), 2,
      sym_line_comment,
      sym_block_comment,
  [128541] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8028), 1,
      anon_sym_LBRACE,
    STATE(4636), 2,
      sym_line_comment,
      sym_block_comment,
  [128555] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1293), 1,
      anon_sym_RBRACE,
    STATE(4637), 2,
      sym_line_comment,
      sym_block_comment,
  [128569] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1279), 1,
      anon_sym_RBRACE,
    STATE(4638), 2,
      sym_line_comment,
      sym_block_comment,
  [128583] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8030), 1,
      anon_sym_RBRACE,
    STATE(4639), 2,
      sym_line_comment,
      sym_block_comment,
  [128597] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8032), 1,
      anon_sym_RBRACE,
    STATE(4640), 2,
      sym_line_comment,
      sym_block_comment,
  [128611] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8034), 1,
      anon_sym_RBRACE,
    STATE(4641), 2,
      sym_line_comment,
      sym_block_comment,
  [128625] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1231), 1,
      anon_sym_RBRACE,
    STATE(4642), 2,
      sym_line_comment,
      sym_block_comment,
  [128639] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8036), 1,
      anon_sym_RBRACK,
    STATE(4643), 2,
      sym_line_comment,
      sym_block_comment,
  [128653] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8038), 1,
      sym_int_literal,
    STATE(4644), 2,
      sym_line_comment,
      sym_block_comment,
  [128667] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8040), 1,
      anon_sym_RBRACE,
    STATE(4645), 2,
      sym_line_comment,
      sym_block_comment,
  [128681] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    STATE(4646), 2,
      sym_line_comment,
      sym_block_comment,
  [128695] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8044), 1,
      anon_sym_RBRACE,
    STATE(4647), 2,
      sym_line_comment,
      sym_block_comment,
  [128709] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1983), 1,
      anon_sym_RPAREN,
    STATE(4648), 2,
      sym_line_comment,
      sym_block_comment,
  [128723] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8046), 1,
      anon_sym_RBRACE,
    STATE(4649), 2,
      sym_line_comment,
      sym_block_comment,
  [128737] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8048), 1,
      anon_sym_RBRACE,
    STATE(4650), 2,
      sym_line_comment,
      sym_block_comment,
  [128751] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8050), 1,
      anon_sym_RBRACK,
    STATE(4651), 2,
      sym_line_comment,
      sym_block_comment,
  [128765] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8052), 1,
      anon_sym_RBRACK,
    STATE(4652), 2,
      sym_line_comment,
      sym_block_comment,
  [128779] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8054), 1,
      anon_sym_RBRACE,
    STATE(4653), 2,
      sym_line_comment,
      sym_block_comment,
  [128793] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8056), 1,
      anon_sym_RBRACE,
    STATE(4654), 2,
      sym_line_comment,
      sym_block_comment,
  [128807] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8058), 1,
      aux_sym_shebang_token1,
    STATE(4655), 2,
      sym_line_comment,
      sym_block_comment,
  [128821] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7367), 1,
      anon_sym_RBRACE,
    STATE(4656), 2,
      sym_line_comment,
      sym_block_comment,
  [128835] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8060), 1,
      sym_identifier,
    STATE(4657), 2,
      sym_line_comment,
      sym_block_comment,
  [128849] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8062), 1,
      anon_sym_RBRACE,
    STATE(4658), 2,
      sym_line_comment,
      sym_block_comment,
  [128863] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8064), 1,
      anon_sym_RBRACE,
    STATE(4659), 2,
      sym_line_comment,
      sym_block_comment,
  [128877] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8066), 1,
      anon_sym_RBRACE,
    STATE(4660), 2,
      sym_line_comment,
      sym_block_comment,
  [128891] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8068), 1,
      anon_sym_RBRACE,
    STATE(4661), 2,
      sym_line_comment,
      sym_block_comment,
  [128905] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8070), 1,
      anon_sym_RBRACK,
    STATE(4662), 2,
      sym_line_comment,
      sym_block_comment,
  [128919] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8072), 1,
      anon_sym_LBRACE,
    STATE(4663), 2,
      sym_line_comment,
      sym_block_comment,
  [128933] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1235), 1,
      anon_sym_RBRACE,
    STATE(4664), 2,
      sym_line_comment,
      sym_block_comment,
  [128947] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8074), 1,
      anon_sym_RBRACE,
    STATE(4665), 2,
      sym_line_comment,
      sym_block_comment,
  [128961] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1225), 1,
      anon_sym_RBRACE,
    STATE(4666), 2,
      sym_line_comment,
      sym_block_comment,
  [128975] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8076), 1,
      ts_builtin_sym_end,
    STATE(4667), 2,
      sym_line_comment,
      sym_block_comment,
  [128989] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8078), 1,
      anon_sym_RBRACE,
    STATE(4668), 2,
      sym_line_comment,
      sym_block_comment,
  [129003] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8080), 1,
      anon_sym_RBRACE,
    STATE(4669), 2,
      sym_line_comment,
      sym_block_comment,
  [129017] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1223), 1,
      anon_sym_RBRACE,
    STATE(4670), 2,
      sym_line_comment,
      sym_block_comment,
  [129031] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8082), 1,
      sym_identifier,
    STATE(4671), 2,
      sym_line_comment,
      sym_block_comment,
  [129045] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8084), 1,
      sym_identifier,
    STATE(4672), 2,
      sym_line_comment,
      sym_block_comment,
  [129059] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8086), 1,
      aux_sym_hash_statement_token1,
    STATE(4673), 2,
      sym_line_comment,
      sym_block_comment,
  [129073] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1565), 1,
      anon_sym_RPAREN,
    STATE(4674), 2,
      sym_line_comment,
      sym_block_comment,
  [129087] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8088), 1,
      anon_sym_RBRACK,
    STATE(4675), 2,
      sym_line_comment,
      sym_block_comment,
  [129101] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8090), 1,
      anon_sym_RBRACE,
    STATE(4676), 2,
      sym_line_comment,
      sym_block_comment,
  [129115] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8092), 1,
      anon_sym_RBRACE,
    STATE(4677), 2,
      sym_line_comment,
      sym_block_comment,
  [129129] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8094), 1,
      anon_sym_RBRACE,
    STATE(4678), 2,
      sym_line_comment,
      sym_block_comment,
  [129143] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8096), 1,
      anon_sym_RBRACE,
    STATE(4679), 2,
      sym_line_comment,
      sym_block_comment,
  [129157] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8098), 1,
      anon_sym_RBRACK,
    STATE(4680), 2,
      sym_line_comment,
      sym_block_comment,
  [129171] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8100), 1,
      anon_sym_RBRACK,
    STATE(4681), 2,
      sym_line_comment,
      sym_block_comment,
  [129185] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8102), 1,
      anon_sym_RBRACE,
    STATE(4682), 2,
      sym_line_comment,
      sym_block_comment,
  [129199] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8104), 1,
      anon_sym_LBRACE,
    STATE(4683), 2,
      sym_line_comment,
      sym_block_comment,
  [129213] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8106), 1,
      anon_sym_RBRACK,
    STATE(4684), 2,
      sym_line_comment,
      sym_block_comment,
  [129227] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8108), 1,
      anon_sym_PIPE2,
    STATE(4685), 2,
      sym_line_comment,
      sym_block_comment,
  [129241] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8110), 1,
      anon_sym_LBRACE,
    STATE(4686), 2,
      sym_line_comment,
      sym_block_comment,
  [129255] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8112), 1,
      anon_sym_LBRACE,
    STATE(4687), 2,
      sym_line_comment,
      sym_block_comment,
  [129269] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8114), 1,
      anon_sym_RBRACE,
    STATE(4688), 2,
      sym_line_comment,
      sym_block_comment,
  [129283] = 4,
    ACTIONS(311), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(313), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8116), 1,
      aux_sym_hash_statement_token1,
    STATE(4689), 2,
      sym_line_comment,
      sym_block_comment,
  [129297] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8118), 1,
      anon_sym_RBRACE,
    STATE(4690), 2,
      sym_line_comment,
      sym_block_comment,
  [129311] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1261), 1,
      anon_sym_RBRACE,
    STATE(4691), 2,
      sym_line_comment,
      sym_block_comment,
  [129325] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8120), 1,
      anon_sym_RBRACE,
    STATE(4692), 2,
      sym_line_comment,
      sym_block_comment,
  [129339] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8122), 1,
      anon_sym_RBRACE,
    STATE(4693), 2,
      sym_line_comment,
      sym_block_comment,
  [129353] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8124), 1,
      anon_sym_DOT,
    STATE(4694), 2,
      sym_line_comment,
      sym_block_comment,
  [129367] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8126), 1,
      anon_sym_RBRACK,
    STATE(4695), 2,
      sym_line_comment,
      sym_block_comment,
  [129381] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8128), 1,
      anon_sym_RBRACK,
    STATE(4696), 2,
      sym_line_comment,
      sym_block_comment,
  [129395] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8130), 1,
      anon_sym_EQ,
    STATE(4697), 2,
      sym_line_comment,
      sym_block_comment,
  [129409] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8132), 1,
      sym_identifier,
    STATE(4698), 2,
      sym_line_comment,
      sym_block_comment,
  [129423] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8134), 1,
      sym_identifier,
    STATE(4699), 2,
      sym_line_comment,
      sym_block_comment,
  [129437] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5249), 1,
      sym_identifier,
    STATE(4700), 2,
      sym_line_comment,
      sym_block_comment,
  [129451] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8136), 1,
      sym_identifier,
    STATE(4701), 2,
      sym_line_comment,
      sym_block_comment,
  [129465] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8138), 1,
      anon_sym_RBRACE,
    STATE(4702), 2,
      sym_line_comment,
      sym_block_comment,
  [129479] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8140), 1,
      anon_sym_RBRACE,
    STATE(4703), 2,
      sym_line_comment,
      sym_block_comment,
  [129493] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7422), 1,
      sym_identifier,
    STATE(4704), 2,
      sym_line_comment,
      sym_block_comment,
  [129507] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7562), 1,
      anon_sym_RPAREN,
    STATE(4705), 2,
      sym_line_comment,
      sym_block_comment,
  [129521] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8142), 1,
      anon_sym_RBRACE,
    STATE(4706), 2,
      sym_line_comment,
      sym_block_comment,
  [129535] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8144), 1,
      anon_sym_RBRACE,
    STATE(4707), 2,
      sym_line_comment,
      sym_block_comment,
  [129549] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1281), 1,
      anon_sym_RBRACE,
    STATE(4708), 2,
      sym_line_comment,
      sym_block_comment,
  [129563] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8146), 1,
      sym_identifier,
    STATE(4709), 2,
      sym_line_comment,
      sym_block_comment,
  [129577] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8148), 1,
      anon_sym_RBRACE,
    STATE(4710), 2,
      sym_line_comment,
      sym_block_comment,
  [129591] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8150), 1,
      anon_sym_RBRACE,
    STATE(4711), 2,
      sym_line_comment,
      sym_block_comment,
  [129605] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8152), 1,
      anon_sym_RBRACE,
    STATE(4712), 2,
      sym_line_comment,
      sym_block_comment,
  [129619] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(8154), 1,
      anon_sym_RBRACE,
    STATE(4713), 2,
      sym_line_comment,
      sym_block_comment,
  [129633] = 1,
    ACTIONS(8156), 1,
      ts_builtin_sym_end,
  [129637] = 1,
    ACTIONS(8158), 1,
      ts_builtin_sym_end,
  [129641] = 1,
    ACTIONS(8160), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(1962)] = 0,
  [SMALL_STATE(1963)] = 73,
  [SMALL_STATE(1964)] = 200,
  [SMALL_STATE(1965)] = 327,
  [SMALL_STATE(1966)] = 420,
  [SMALL_STATE(1967)] = 535,
  [SMALL_STATE(1968)] = 626,
  [SMALL_STATE(1969)] = 721,
  [SMALL_STATE(1970)] = 822,
  [SMALL_STATE(1971)] = 913,
  [SMALL_STATE(1972)] = 1004,
  [SMALL_STATE(1973)] = 1119,
  [SMALL_STATE(1974)] = 1234,
  [SMALL_STATE(1975)] = 1329,
  [SMALL_STATE(1976)] = 1424,
  [SMALL_STATE(1977)] = 1545,
  [SMALL_STATE(1978)] = 1648,
  [SMALL_STATE(1979)] = 1767,
  [SMALL_STATE(1980)] = 1886,
  [SMALL_STATE(1981)] = 2001,
  [SMALL_STATE(1982)] = 2094,
  [SMALL_STATE(1983)] = 2185,
  [SMALL_STATE(1984)] = 2276,
  [SMALL_STATE(1985)] = 2371,
  [SMALL_STATE(1986)] = 2462,
  [SMALL_STATE(1987)] = 2565,
  [SMALL_STATE(1988)] = 2666,
  [SMALL_STATE(1989)] = 2736,
  [SMALL_STATE(1990)] = 2850,
  [SMALL_STATE(1991)] = 2920,
  [SMALL_STATE(1992)] = 2990,
  [SMALL_STATE(1993)] = 3084,
  [SMALL_STATE(1994)] = 3198,
  [SMALL_STATE(1995)] = 3268,
  [SMALL_STATE(1996)] = 3368,
  [SMALL_STATE(1997)] = 3442,
  [SMALL_STATE(1998)] = 3536,
  [SMALL_STATE(1999)] = 3628,
  [SMALL_STATE(2000)] = 3702,
  [SMALL_STATE(2001)] = 3816,
  [SMALL_STATE(2002)] = 3890,
  [SMALL_STATE(2003)] = 3960,
  [SMALL_STATE(2004)] = 4030,
  [SMALL_STATE(2005)] = 4100,
  [SMALL_STATE(2006)] = 4202,
  [SMALL_STATE(2007)] = 4272,
  [SMALL_STATE(2008)] = 4346,
  [SMALL_STATE(2009)] = 4424,
  [SMALL_STATE(2010)] = 4494,
  [SMALL_STATE(2011)] = 4608,
  [SMALL_STATE(2012)] = 4721,
  [SMALL_STATE(2013)] = 4792,
  [SMALL_STATE(2014)] = 4869,
  [SMALL_STATE(2015)] = 4940,
  [SMALL_STATE(2016)] = 5011,
  [SMALL_STATE(2017)] = 5082,
  [SMALL_STATE(2018)] = 5153,
  [SMALL_STATE(2019)] = 5220,
  [SMALL_STATE(2020)] = 5291,
  [SMALL_STATE(2021)] = 5404,
  [SMALL_STATE(2022)] = 5517,
  [SMALL_STATE(2023)] = 5586,
  [SMALL_STATE(2024)] = 5699,
  [SMALL_STATE(2025)] = 5767,
  [SMALL_STATE(2026)] = 5835,
  [SMALL_STATE(2027)] = 5903,
  [SMALL_STATE(2028)] = 5971,
  [SMALL_STATE(2029)] = 6041,
  [SMALL_STATE(2030)] = 6109,
  [SMALL_STATE(2031)] = 6177,
  [SMALL_STATE(2032)] = 6245,
  [SMALL_STATE(2033)] = 6313,
  [SMALL_STATE(2034)] = 6381,
  [SMALL_STATE(2035)] = 6449,
  [SMALL_STATE(2036)] = 6519,
  [SMALL_STATE(2037)] = 6587,
  [SMALL_STATE(2038)] = 6655,
  [SMALL_STATE(2039)] = 6723,
  [SMALL_STATE(2040)] = 6791,
  [SMALL_STATE(2041)] = 6859,
  [SMALL_STATE(2042)] = 6927,
  [SMALL_STATE(2043)] = 6995,
  [SMALL_STATE(2044)] = 7063,
  [SMALL_STATE(2045)] = 7131,
  [SMALL_STATE(2046)] = 7199,
  [SMALL_STATE(2047)] = 7267,
  [SMALL_STATE(2048)] = 7335,
  [SMALL_STATE(2049)] = 7403,
  [SMALL_STATE(2050)] = 7471,
  [SMALL_STATE(2051)] = 7539,
  [SMALL_STATE(2052)] = 7607,
  [SMALL_STATE(2053)] = 7675,
  [SMALL_STATE(2054)] = 7743,
  [SMALL_STATE(2055)] = 7811,
  [SMALL_STATE(2056)] = 7879,
  [SMALL_STATE(2057)] = 7947,
  [SMALL_STATE(2058)] = 8015,
  [SMALL_STATE(2059)] = 8083,
  [SMALL_STATE(2060)] = 8151,
  [SMALL_STATE(2061)] = 8219,
  [SMALL_STATE(2062)] = 8287,
  [SMALL_STATE(2063)] = 8355,
  [SMALL_STATE(2064)] = 8423,
  [SMALL_STATE(2065)] = 8491,
  [SMALL_STATE(2066)] = 8559,
  [SMALL_STATE(2067)] = 8627,
  [SMALL_STATE(2068)] = 8695,
  [SMALL_STATE(2069)] = 8763,
  [SMALL_STATE(2070)] = 8831,
  [SMALL_STATE(2071)] = 8899,
  [SMALL_STATE(2072)] = 8967,
  [SMALL_STATE(2073)] = 9035,
  [SMALL_STATE(2074)] = 9103,
  [SMALL_STATE(2075)] = 9171,
  [SMALL_STATE(2076)] = 9239,
  [SMALL_STATE(2077)] = 9307,
  [SMALL_STATE(2078)] = 9375,
  [SMALL_STATE(2079)] = 9443,
  [SMALL_STATE(2080)] = 9511,
  [SMALL_STATE(2081)] = 9579,
  [SMALL_STATE(2082)] = 9647,
  [SMALL_STATE(2083)] = 9715,
  [SMALL_STATE(2084)] = 9783,
  [SMALL_STATE(2085)] = 9851,
  [SMALL_STATE(2086)] = 9919,
  [SMALL_STATE(2087)] = 9987,
  [SMALL_STATE(2088)] = 10055,
  [SMALL_STATE(2089)] = 10123,
  [SMALL_STATE(2090)] = 10191,
  [SMALL_STATE(2091)] = 10259,
  [SMALL_STATE(2092)] = 10327,
  [SMALL_STATE(2093)] = 10395,
  [SMALL_STATE(2094)] = 10463,
  [SMALL_STATE(2095)] = 10533,
  [SMALL_STATE(2096)] = 10601,
  [SMALL_STATE(2097)] = 10669,
  [SMALL_STATE(2098)] = 10739,
  [SMALL_STATE(2099)] = 10809,
  [SMALL_STATE(2100)] = 10877,
  [SMALL_STATE(2101)] = 10945,
  [SMALL_STATE(2102)] = 11017,
  [SMALL_STATE(2103)] = 11085,
  [SMALL_STATE(2104)] = 11153,
  [SMALL_STATE(2105)] = 11221,
  [SMALL_STATE(2106)] = 11289,
  [SMALL_STATE(2107)] = 11357,
  [SMALL_STATE(2108)] = 11425,
  [SMALL_STATE(2109)] = 11493,
  [SMALL_STATE(2110)] = 11561,
  [SMALL_STATE(2111)] = 11629,
  [SMALL_STATE(2112)] = 11697,
  [SMALL_STATE(2113)] = 11765,
  [SMALL_STATE(2114)] = 11833,
  [SMALL_STATE(2115)] = 11901,
  [SMALL_STATE(2116)] = 11969,
  [SMALL_STATE(2117)] = 12037,
  [SMALL_STATE(2118)] = 12105,
  [SMALL_STATE(2119)] = 12173,
  [SMALL_STATE(2120)] = 12241,
  [SMALL_STATE(2121)] = 12309,
  [SMALL_STATE(2122)] = 12377,
  [SMALL_STATE(2123)] = 12445,
  [SMALL_STATE(2124)] = 12513,
  [SMALL_STATE(2125)] = 12581,
  [SMALL_STATE(2126)] = 12649,
  [SMALL_STATE(2127)] = 12717,
  [SMALL_STATE(2128)] = 12785,
  [SMALL_STATE(2129)] = 12853,
  [SMALL_STATE(2130)] = 12921,
  [SMALL_STATE(2131)] = 12989,
  [SMALL_STATE(2132)] = 13057,
  [SMALL_STATE(2133)] = 13125,
  [SMALL_STATE(2134)] = 13193,
  [SMALL_STATE(2135)] = 13261,
  [SMALL_STATE(2136)] = 13329,
  [SMALL_STATE(2137)] = 13397,
  [SMALL_STATE(2138)] = 13465,
  [SMALL_STATE(2139)] = 13533,
  [SMALL_STATE(2140)] = 13601,
  [SMALL_STATE(2141)] = 13669,
  [SMALL_STATE(2142)] = 13737,
  [SMALL_STATE(2143)] = 13805,
  [SMALL_STATE(2144)] = 13873,
  [SMALL_STATE(2145)] = 13945,
  [SMALL_STATE(2146)] = 14013,
  [SMALL_STATE(2147)] = 14081,
  [SMALL_STATE(2148)] = 14149,
  [SMALL_STATE(2149)] = 14217,
  [SMALL_STATE(2150)] = 14285,
  [SMALL_STATE(2151)] = 14353,
  [SMALL_STATE(2152)] = 14421,
  [SMALL_STATE(2153)] = 14489,
  [SMALL_STATE(2154)] = 14561,
  [SMALL_STATE(2155)] = 14631,
  [SMALL_STATE(2156)] = 14699,
  [SMALL_STATE(2157)] = 14767,
  [SMALL_STATE(2158)] = 14835,
  [SMALL_STATE(2159)] = 14903,
  [SMALL_STATE(2160)] = 14971,
  [SMALL_STATE(2161)] = 15039,
  [SMALL_STATE(2162)] = 15107,
  [SMALL_STATE(2163)] = 15175,
  [SMALL_STATE(2164)] = 15245,
  [SMALL_STATE(2165)] = 15313,
  [SMALL_STATE(2166)] = 15381,
  [SMALL_STATE(2167)] = 15449,
  [SMALL_STATE(2168)] = 15517,
  [SMALL_STATE(2169)] = 15585,
  [SMALL_STATE(2170)] = 15655,
  [SMALL_STATE(2171)] = 15723,
  [SMALL_STATE(2172)] = 15793,
  [SMALL_STATE(2173)] = 15861,
  [SMALL_STATE(2174)] = 15931,
  [SMALL_STATE(2175)] = 15999,
  [SMALL_STATE(2176)] = 16067,
  [SMALL_STATE(2177)] = 16135,
  [SMALL_STATE(2178)] = 16203,
  [SMALL_STATE(2179)] = 16271,
  [SMALL_STATE(2180)] = 16339,
  [SMALL_STATE(2181)] = 16407,
  [SMALL_STATE(2182)] = 16475,
  [SMALL_STATE(2183)] = 16543,
  [SMALL_STATE(2184)] = 16611,
  [SMALL_STATE(2185)] = 16679,
  [SMALL_STATE(2186)] = 16747,
  [SMALL_STATE(2187)] = 16815,
  [SMALL_STATE(2188)] = 16883,
  [SMALL_STATE(2189)] = 16951,
  [SMALL_STATE(2190)] = 17021,
  [SMALL_STATE(2191)] = 17089,
  [SMALL_STATE(2192)] = 17161,
  [SMALL_STATE(2193)] = 17229,
  [SMALL_STATE(2194)] = 17297,
  [SMALL_STATE(2195)] = 17365,
  [SMALL_STATE(2196)] = 17433,
  [SMALL_STATE(2197)] = 17501,
  [SMALL_STATE(2198)] = 17569,
  [SMALL_STATE(2199)] = 17637,
  [SMALL_STATE(2200)] = 17705,
  [SMALL_STATE(2201)] = 17775,
  [SMALL_STATE(2202)] = 17843,
  [SMALL_STATE(2203)] = 17911,
  [SMALL_STATE(2204)] = 17979,
  [SMALL_STATE(2205)] = 18047,
  [SMALL_STATE(2206)] = 18115,
  [SMALL_STATE(2207)] = 18183,
  [SMALL_STATE(2208)] = 18251,
  [SMALL_STATE(2209)] = 18319,
  [SMALL_STATE(2210)] = 18387,
  [SMALL_STATE(2211)] = 18455,
  [SMALL_STATE(2212)] = 18523,
  [SMALL_STATE(2213)] = 18591,
  [SMALL_STATE(2214)] = 18659,
  [SMALL_STATE(2215)] = 18727,
  [SMALL_STATE(2216)] = 18795,
  [SMALL_STATE(2217)] = 18863,
  [SMALL_STATE(2218)] = 18931,
  [SMALL_STATE(2219)] = 18999,
  [SMALL_STATE(2220)] = 19067,
  [SMALL_STATE(2221)] = 19135,
  [SMALL_STATE(2222)] = 19203,
  [SMALL_STATE(2223)] = 19271,
  [SMALL_STATE(2224)] = 19339,
  [SMALL_STATE(2225)] = 19407,
  [SMALL_STATE(2226)] = 19475,
  [SMALL_STATE(2227)] = 19543,
  [SMALL_STATE(2228)] = 19611,
  [SMALL_STATE(2229)] = 19678,
  [SMALL_STATE(2230)] = 19745,
  [SMALL_STATE(2231)] = 19812,
  [SMALL_STATE(2232)] = 19879,
  [SMALL_STATE(2233)] = 19946,
  [SMALL_STATE(2234)] = 20028,
  [SMALL_STATE(2235)] = 20110,
  [SMALL_STATE(2236)] = 20180,
  [SMALL_STATE(2237)] = 20262,
  [SMALL_STATE(2238)] = 20333,
  [SMALL_STATE(2239)] = 20402,
  [SMALL_STATE(2240)] = 20471,
  [SMALL_STATE(2241)] = 20535,
  [SMALL_STATE(2242)] = 20601,
  [SMALL_STATE(2243)] = 20665,
  [SMALL_STATE(2244)] = 20729,
  [SMALL_STATE(2245)] = 20795,
  [SMALL_STATE(2246)] = 20859,
  [SMALL_STATE(2247)] = 20923,
  [SMALL_STATE(2248)] = 20987,
  [SMALL_STATE(2249)] = 21055,
  [SMALL_STATE(2250)] = 21119,
  [SMALL_STATE(2251)] = 21183,
  [SMALL_STATE(2252)] = 21291,
  [SMALL_STATE(2253)] = 21355,
  [SMALL_STATE(2254)] = 21419,
  [SMALL_STATE(2255)] = 21483,
  [SMALL_STATE(2256)] = 21547,
  [SMALL_STATE(2257)] = 21613,
  [SMALL_STATE(2258)] = 21679,
  [SMALL_STATE(2259)] = 21742,
  [SMALL_STATE(2260)] = 21805,
  [SMALL_STATE(2261)] = 21868,
  [SMALL_STATE(2262)] = 21931,
  [SMALL_STATE(2263)] = 21994,
  [SMALL_STATE(2264)] = 22057,
  [SMALL_STATE(2265)] = 22120,
  [SMALL_STATE(2266)] = 22183,
  [SMALL_STATE(2267)] = 22246,
  [SMALL_STATE(2268)] = 22309,
  [SMALL_STATE(2269)] = 22372,
  [SMALL_STATE(2270)] = 22435,
  [SMALL_STATE(2271)] = 22498,
  [SMALL_STATE(2272)] = 22561,
  [SMALL_STATE(2273)] = 22624,
  [SMALL_STATE(2274)] = 22687,
  [SMALL_STATE(2275)] = 22750,
  [SMALL_STATE(2276)] = 22813,
  [SMALL_STATE(2277)] = 22876,
  [SMALL_STATE(2278)] = 22939,
  [SMALL_STATE(2279)] = 23002,
  [SMALL_STATE(2280)] = 23065,
  [SMALL_STATE(2281)] = 23128,
  [SMALL_STATE(2282)] = 23191,
  [SMALL_STATE(2283)] = 23254,
  [SMALL_STATE(2284)] = 23317,
  [SMALL_STATE(2285)] = 23380,
  [SMALL_STATE(2286)] = 23443,
  [SMALL_STATE(2287)] = 23506,
  [SMALL_STATE(2288)] = 23569,
  [SMALL_STATE(2289)] = 23632,
  [SMALL_STATE(2290)] = 23695,
  [SMALL_STATE(2291)] = 23758,
  [SMALL_STATE(2292)] = 23821,
  [SMALL_STATE(2293)] = 23884,
  [SMALL_STATE(2294)] = 23947,
  [SMALL_STATE(2295)] = 24010,
  [SMALL_STATE(2296)] = 24073,
  [SMALL_STATE(2297)] = 24136,
  [SMALL_STATE(2298)] = 24199,
  [SMALL_STATE(2299)] = 24262,
  [SMALL_STATE(2300)] = 24325,
  [SMALL_STATE(2301)] = 24388,
  [SMALL_STATE(2302)] = 24451,
  [SMALL_STATE(2303)] = 24514,
  [SMALL_STATE(2304)] = 24577,
  [SMALL_STATE(2305)] = 24640,
  [SMALL_STATE(2306)] = 24703,
  [SMALL_STATE(2307)] = 24766,
  [SMALL_STATE(2308)] = 24829,
  [SMALL_STATE(2309)] = 24892,
  [SMALL_STATE(2310)] = 24955,
  [SMALL_STATE(2311)] = 25018,
  [SMALL_STATE(2312)] = 25081,
  [SMALL_STATE(2313)] = 25144,
  [SMALL_STATE(2314)] = 25207,
  [SMALL_STATE(2315)] = 25290,
  [SMALL_STATE(2316)] = 25353,
  [SMALL_STATE(2317)] = 25418,
  [SMALL_STATE(2318)] = 25481,
  [SMALL_STATE(2319)] = 25544,
  [SMALL_STATE(2320)] = 25645,
  [SMALL_STATE(2321)] = 25708,
  [SMALL_STATE(2322)] = 25771,
  [SMALL_STATE(2323)] = 25834,
  [SMALL_STATE(2324)] = 25897,
  [SMALL_STATE(2325)] = 25978,
  [SMALL_STATE(2326)] = 26061,
  [SMALL_STATE(2327)] = 26124,
  [SMALL_STATE(2328)] = 26187,
  [SMALL_STATE(2329)] = 26250,
  [SMALL_STATE(2330)] = 26313,
  [SMALL_STATE(2331)] = 26376,
  [SMALL_STATE(2332)] = 26441,
  [SMALL_STATE(2333)] = 26504,
  [SMALL_STATE(2334)] = 26567,
  [SMALL_STATE(2335)] = 26654,
  [SMALL_STATE(2336)] = 26717,
  [SMALL_STATE(2337)] = 26780,
  [SMALL_STATE(2338)] = 26843,
  [SMALL_STATE(2339)] = 26906,
  [SMALL_STATE(2340)] = 26995,
  [SMALL_STATE(2341)] = 27058,
  [SMALL_STATE(2342)] = 27121,
  [SMALL_STATE(2343)] = 27184,
  [SMALL_STATE(2344)] = 27295,
  [SMALL_STATE(2345)] = 27358,
  [SMALL_STATE(2346)] = 27421,
  [SMALL_STATE(2347)] = 27484,
  [SMALL_STATE(2348)] = 27547,
  [SMALL_STATE(2349)] = 27610,
  [SMALL_STATE(2350)] = 27711,
  [SMALL_STATE(2351)] = 27774,
  [SMALL_STATE(2352)] = 27837,
  [SMALL_STATE(2353)] = 27900,
  [SMALL_STATE(2354)] = 27963,
  [SMALL_STATE(2355)] = 28026,
  [SMALL_STATE(2356)] = 28089,
  [SMALL_STATE(2357)] = 28152,
  [SMALL_STATE(2358)] = 28215,
  [SMALL_STATE(2359)] = 28278,
  [SMALL_STATE(2360)] = 28341,
  [SMALL_STATE(2361)] = 28406,
  [SMALL_STATE(2362)] = 28469,
  [SMALL_STATE(2363)] = 28532,
  [SMALL_STATE(2364)] = 28595,
  [SMALL_STATE(2365)] = 28660,
  [SMALL_STATE(2366)] = 28723,
  [SMALL_STATE(2367)] = 28786,
  [SMALL_STATE(2368)] = 28851,
  [SMALL_STATE(2369)] = 28914,
  [SMALL_STATE(2370)] = 28977,
  [SMALL_STATE(2371)] = 29059,
  [SMALL_STATE(2372)] = 29159,
  [SMALL_STATE(2373)] = 29221,
  [SMALL_STATE(2374)] = 29283,
  [SMALL_STATE(2375)] = 29345,
  [SMALL_STATE(2376)] = 29429,
  [SMALL_STATE(2377)] = 29529,
  [SMALL_STATE(2378)] = 29593,
  [SMALL_STATE(2379)] = 29677,
  [SMALL_STATE(2380)] = 29741,
  [SMALL_STATE(2381)] = 29827,
  [SMALL_STATE(2382)] = 29907,
  [SMALL_STATE(2383)] = 30007,
  [SMALL_STATE(2384)] = 30091,
  [SMALL_STATE(2385)] = 30191,
  [SMALL_STATE(2386)] = 30279,
  [SMALL_STATE(2387)] = 30341,
  [SMALL_STATE(2388)] = 30423,
  [SMALL_STATE(2389)] = 30528,
  [SMALL_STATE(2390)] = 30593,
  [SMALL_STATE(2391)] = 30658,
  [SMALL_STATE(2392)] = 30720,
  [SMALL_STATE(2393)] = 30782,
  [SMALL_STATE(2394)] = 30844,
  [SMALL_STATE(2395)] = 30906,
  [SMALL_STATE(2396)] = 30968,
  [SMALL_STATE(2397)] = 31081,
  [SMALL_STATE(2398)] = 31140,
  [SMALL_STATE(2399)] = 31199,
  [SMALL_STATE(2400)] = 31258,
  [SMALL_STATE(2401)] = 31317,
  [SMALL_STATE(2402)] = 31376,
  [SMALL_STATE(2403)] = 31435,
  [SMALL_STATE(2404)] = 31494,
  [SMALL_STATE(2405)] = 31553,
  [SMALL_STATE(2406)] = 31612,
  [SMALL_STATE(2407)] = 31671,
  [SMALL_STATE(2408)] = 31732,
  [SMALL_STATE(2409)] = 31845,
  [SMALL_STATE(2410)] = 31904,
  [SMALL_STATE(2411)] = 31963,
  [SMALL_STATE(2412)] = 32076,
  [SMALL_STATE(2413)] = 32135,
  [SMALL_STATE(2414)] = 32194,
  [SMALL_STATE(2415)] = 32253,
  [SMALL_STATE(2416)] = 32366,
  [SMALL_STATE(2417)] = 32425,
  [SMALL_STATE(2418)] = 32484,
  [SMALL_STATE(2419)] = 32543,
  [SMALL_STATE(2420)] = 32602,
  [SMALL_STATE(2421)] = 32661,
  [SMALL_STATE(2422)] = 32720,
  [SMALL_STATE(2423)] = 32779,
  [SMALL_STATE(2424)] = 32838,
  [SMALL_STATE(2425)] = 32897,
  [SMALL_STATE(2426)] = 32956,
  [SMALL_STATE(2427)] = 33015,
  [SMALL_STATE(2428)] = 33074,
  [SMALL_STATE(2429)] = 33133,
  [SMALL_STATE(2430)] = 33192,
  [SMALL_STATE(2431)] = 33251,
  [SMALL_STATE(2432)] = 33310,
  [SMALL_STATE(2433)] = 33369,
  [SMALL_STATE(2434)] = 33428,
  [SMALL_STATE(2435)] = 33541,
  [SMALL_STATE(2436)] = 33600,
  [SMALL_STATE(2437)] = 33659,
  [SMALL_STATE(2438)] = 33718,
  [SMALL_STATE(2439)] = 33777,
  [SMALL_STATE(2440)] = 33890,
  [SMALL_STATE(2441)] = 33949,
  [SMALL_STATE(2442)] = 34008,
  [SMALL_STATE(2443)] = 34067,
  [SMALL_STATE(2444)] = 34180,
  [SMALL_STATE(2445)] = 34239,
  [SMALL_STATE(2446)] = 34298,
  [SMALL_STATE(2447)] = 34357,
  [SMALL_STATE(2448)] = 34418,
  [SMALL_STATE(2449)] = 34477,
  [SMALL_STATE(2450)] = 34536,
  [SMALL_STATE(2451)] = 34595,
  [SMALL_STATE(2452)] = 34654,
  [SMALL_STATE(2453)] = 34767,
  [SMALL_STATE(2454)] = 34826,
  [SMALL_STATE(2455)] = 34939,
  [SMALL_STATE(2456)] = 34998,
  [SMALL_STATE(2457)] = 35057,
  [SMALL_STATE(2458)] = 35116,
  [SMALL_STATE(2459)] = 35175,
  [SMALL_STATE(2460)] = 35234,
  [SMALL_STATE(2461)] = 35347,
  [SMALL_STATE(2462)] = 35406,
  [SMALL_STATE(2463)] = 35465,
  [SMALL_STATE(2464)] = 35524,
  [SMALL_STATE(2465)] = 35583,
  [SMALL_STATE(2466)] = 35642,
  [SMALL_STATE(2467)] = 35701,
  [SMALL_STATE(2468)] = 35760,
  [SMALL_STATE(2469)] = 35819,
  [SMALL_STATE(2470)] = 35878,
  [SMALL_STATE(2471)] = 35937,
  [SMALL_STATE(2472)] = 35996,
  [SMALL_STATE(2473)] = 36055,
  [SMALL_STATE(2474)] = 36116,
  [SMALL_STATE(2475)] = 36175,
  [SMALL_STATE(2476)] = 36234,
  [SMALL_STATE(2477)] = 36293,
  [SMALL_STATE(2478)] = 36352,
  [SMALL_STATE(2479)] = 36411,
  [SMALL_STATE(2480)] = 36524,
  [SMALL_STATE(2481)] = 36583,
  [SMALL_STATE(2482)] = 36642,
  [SMALL_STATE(2483)] = 36701,
  [SMALL_STATE(2484)] = 36760,
  [SMALL_STATE(2485)] = 36819,
  [SMALL_STATE(2486)] = 36878,
  [SMALL_STATE(2487)] = 36991,
  [SMALL_STATE(2488)] = 37050,
  [SMALL_STATE(2489)] = 37109,
  [SMALL_STATE(2490)] = 37168,
  [SMALL_STATE(2491)] = 37231,
  [SMALL_STATE(2492)] = 37290,
  [SMALL_STATE(2493)] = 37349,
  [SMALL_STATE(2494)] = 37408,
  [SMALL_STATE(2495)] = 37467,
  [SMALL_STATE(2496)] = 37526,
  [SMALL_STATE(2497)] = 37585,
  [SMALL_STATE(2498)] = 37644,
  [SMALL_STATE(2499)] = 37703,
  [SMALL_STATE(2500)] = 37762,
  [SMALL_STATE(2501)] = 37821,
  [SMALL_STATE(2502)] = 37880,
  [SMALL_STATE(2503)] = 37993,
  [SMALL_STATE(2504)] = 38052,
  [SMALL_STATE(2505)] = 38128,
  [SMALL_STATE(2506)] = 38236,
  [SMALL_STATE(2507)] = 38342,
  [SMALL_STATE(2508)] = 38430,
  [SMALL_STATE(2509)] = 38524,
  [SMALL_STATE(2510)] = 38616,
  [SMALL_STATE(2511)] = 38704,
  [SMALL_STATE(2512)] = 38782,
  [SMALL_STATE(2513)] = 38866,
  [SMALL_STATE(2514)] = 38946,
  [SMALL_STATE(2515)] = 39052,
  [SMALL_STATE(2516)] = 39148,
  [SMALL_STATE(2517)] = 39208,
  [SMALL_STATE(2518)] = 39316,
  [SMALL_STATE(2519)] = 39390,
  [SMALL_STATE(2520)] = 39452,
  [SMALL_STATE(2521)] = 39532,
  [SMALL_STATE(2522)] = 39592,
  [SMALL_STATE(2523)] = 39676,
  [SMALL_STATE(2524)] = 39758,
  [SMALL_STATE(2525)] = 39818,
  [SMALL_STATE(2526)] = 39916,
  [SMALL_STATE(2527)] = 39996,
  [SMALL_STATE(2528)] = 40092,
  [SMALL_STATE(2529)] = 40166,
  [SMALL_STATE(2530)] = 40260,
  [SMALL_STATE(2531)] = 40338,
  [SMALL_STATE(2532)] = 40434,
  [SMALL_STATE(2533)] = 40528,
  [SMALL_STATE(2534)] = 40622,
  [SMALL_STATE(2535)] = 40706,
  [SMALL_STATE(2536)] = 40780,
  [SMALL_STATE(2537)] = 40868,
  [SMALL_STATE(2538)] = 40962,
  [SMALL_STATE(2539)] = 41058,
  [SMALL_STATE(2540)] = 41154,
  [SMALL_STATE(2541)] = 41242,
  [SMALL_STATE(2542)] = 41327,
  [SMALL_STATE(2543)] = 41430,
  [SMALL_STATE(2544)] = 41515,
  [SMALL_STATE(2545)] = 41606,
  [SMALL_STATE(2546)] = 41663,
  [SMALL_STATE(2547)] = 41752,
  [SMALL_STATE(2548)] = 41837,
  [SMALL_STATE(2549)] = 41898,
  [SMALL_STATE(2550)] = 41959,
  [SMALL_STATE(2551)] = 42020,
  [SMALL_STATE(2552)] = 42129,
  [SMALL_STATE(2553)] = 42210,
  [SMALL_STATE(2554)] = 42271,
  [SMALL_STATE(2555)] = 42374,
  [SMALL_STATE(2556)] = 42463,
  [SMALL_STATE(2557)] = 42524,
  [SMALL_STATE(2558)] = 42631,
  [SMALL_STATE(2559)] = 42738,
  [SMALL_STATE(2560)] = 42841,
  [SMALL_STATE(2561)] = 42926,
  [SMALL_STATE(2562)] = 42985,
  [SMALL_STATE(2563)] = 43088,
  [SMALL_STATE(2564)] = 43169,
  [SMALL_STATE(2565)] = 43228,
  [SMALL_STATE(2566)] = 43335,
  [SMALL_STATE(2567)] = 43418,
  [SMALL_STATE(2568)] = 43505,
  [SMALL_STATE(2569)] = 43598,
  [SMALL_STATE(2570)] = 43655,
  [SMALL_STATE(2571)] = 43746,
  [SMALL_STATE(2572)] = 43803,
  [SMALL_STATE(2573)] = 43860,
  [SMALL_STATE(2574)] = 43955,
  [SMALL_STATE(2575)] = 44062,
  [SMALL_STATE(2576)] = 44165,
  [SMALL_STATE(2577)] = 44252,
  [SMALL_STATE(2578)] = 44356,
  [SMALL_STATE(2579)] = 44462,
  [SMALL_STATE(2580)] = 44524,
  [SMALL_STATE(2581)] = 44626,
  [SMALL_STATE(2582)] = 44730,
  [SMALL_STATE(2583)] = 44836,
  [SMALL_STATE(2584)] = 44940,
  [SMALL_STATE(2585)] = 45046,
  [SMALL_STATE(2586)] = 45104,
  [SMALL_STATE(2587)] = 45208,
  [SMALL_STATE(2588)] = 45310,
  [SMALL_STATE(2589)] = 45416,
  [SMALL_STATE(2590)] = 45474,
  [SMALL_STATE(2591)] = 45578,
  [SMALL_STATE(2592)] = 45636,
  [SMALL_STATE(2593)] = 45742,
  [SMALL_STATE(2594)] = 45848,
  [SMALL_STATE(2595)] = 45952,
  [SMALL_STATE(2596)] = 46056,
  [SMALL_STATE(2597)] = 46118,
  [SMALL_STATE(2598)] = 46222,
  [SMALL_STATE(2599)] = 46324,
  [SMALL_STATE(2600)] = 46380,
  [SMALL_STATE(2601)] = 46484,
  [SMALL_STATE(2602)] = 46542,
  [SMALL_STATE(2603)] = 46646,
  [SMALL_STATE(2604)] = 46752,
  [SMALL_STATE(2605)] = 46858,
  [SMALL_STATE(2606)] = 46964,
  [SMALL_STATE(2607)] = 47020,
  [SMALL_STATE(2608)] = 47126,
  [SMALL_STATE(2609)] = 47230,
  [SMALL_STATE(2610)] = 47288,
  [SMALL_STATE(2611)] = 47392,
  [SMALL_STATE(2612)] = 47450,
  [SMALL_STATE(2613)] = 47554,
  [SMALL_STATE(2614)] = 47660,
  [SMALL_STATE(2615)] = 47764,
  [SMALL_STATE(2616)] = 47866,
  [SMALL_STATE(2617)] = 47972,
  [SMALL_STATE(2618)] = 48032,
  [SMALL_STATE(2619)] = 48090,
  [SMALL_STATE(2620)] = 48196,
  [SMALL_STATE(2621)] = 48298,
  [SMALL_STATE(2622)] = 48353,
  [SMALL_STATE(2623)] = 48408,
  [SMALL_STATE(2624)] = 48463,
  [SMALL_STATE(2625)] = 48518,
  [SMALL_STATE(2626)] = 48573,
  [SMALL_STATE(2627)] = 48628,
  [SMALL_STATE(2628)] = 48683,
  [SMALL_STATE(2629)] = 48738,
  [SMALL_STATE(2630)] = 48793,
  [SMALL_STATE(2631)] = 48848,
  [SMALL_STATE(2632)] = 48903,
  [SMALL_STATE(2633)] = 48958,
  [SMALL_STATE(2634)] = 49013,
  [SMALL_STATE(2635)] = 49068,
  [SMALL_STATE(2636)] = 49123,
  [SMALL_STATE(2637)] = 49178,
  [SMALL_STATE(2638)] = 49233,
  [SMALL_STATE(2639)] = 49290,
  [SMALL_STATE(2640)] = 49391,
  [SMALL_STATE(2641)] = 49492,
  [SMALL_STATE(2642)] = 49547,
  [SMALL_STATE(2643)] = 49602,
  [SMALL_STATE(2644)] = 49703,
  [SMALL_STATE(2645)] = 49804,
  [SMALL_STATE(2646)] = 49905,
  [SMALL_STATE(2647)] = 50006,
  [SMALL_STATE(2648)] = 50107,
  [SMALL_STATE(2649)] = 50162,
  [SMALL_STATE(2650)] = 50217,
  [SMALL_STATE(2651)] = 50272,
  [SMALL_STATE(2652)] = 50327,
  [SMALL_STATE(2653)] = 50428,
  [SMALL_STATE(2654)] = 50483,
  [SMALL_STATE(2655)] = 50538,
  [SMALL_STATE(2656)] = 50639,
  [SMALL_STATE(2657)] = 50740,
  [SMALL_STATE(2658)] = 50797,
  [SMALL_STATE(2659)] = 50852,
  [SMALL_STATE(2660)] = 50907,
  [SMALL_STATE(2661)] = 50964,
  [SMALL_STATE(2662)] = 51019,
  [SMALL_STATE(2663)] = 51074,
  [SMALL_STATE(2664)] = 51129,
  [SMALL_STATE(2665)] = 51184,
  [SMALL_STATE(2666)] = 51239,
  [SMALL_STATE(2667)] = 51294,
  [SMALL_STATE(2668)] = 51349,
  [SMALL_STATE(2669)] = 51404,
  [SMALL_STATE(2670)] = 51459,
  [SMALL_STATE(2671)] = 51560,
  [SMALL_STATE(2672)] = 51615,
  [SMALL_STATE(2673)] = 51670,
  [SMALL_STATE(2674)] = 51725,
  [SMALL_STATE(2675)] = 51780,
  [SMALL_STATE(2676)] = 51835,
  [SMALL_STATE(2677)] = 51890,
  [SMALL_STATE(2678)] = 51945,
  [SMALL_STATE(2679)] = 52000,
  [SMALL_STATE(2680)] = 52055,
  [SMALL_STATE(2681)] = 52110,
  [SMALL_STATE(2682)] = 52165,
  [SMALL_STATE(2683)] = 52220,
  [SMALL_STATE(2684)] = 52275,
  [SMALL_STATE(2685)] = 52330,
  [SMALL_STATE(2686)] = 52385,
  [SMALL_STATE(2687)] = 52440,
  [SMALL_STATE(2688)] = 52499,
  [SMALL_STATE(2689)] = 52600,
  [SMALL_STATE(2690)] = 52701,
  [SMALL_STATE(2691)] = 52756,
  [SMALL_STATE(2692)] = 52811,
  [SMALL_STATE(2693)] = 52866,
  [SMALL_STATE(2694)] = 52921,
  [SMALL_STATE(2695)] = 52978,
  [SMALL_STATE(2696)] = 53033,
  [SMALL_STATE(2697)] = 53088,
  [SMALL_STATE(2698)] = 53143,
  [SMALL_STATE(2699)] = 53244,
  [SMALL_STATE(2700)] = 53299,
  [SMALL_STATE(2701)] = 53400,
  [SMALL_STATE(2702)] = 53501,
  [SMALL_STATE(2703)] = 53556,
  [SMALL_STATE(2704)] = 53657,
  [SMALL_STATE(2705)] = 53758,
  [SMALL_STATE(2706)] = 53813,
  [SMALL_STATE(2707)] = 53868,
  [SMALL_STATE(2708)] = 53923,
  [SMALL_STATE(2709)] = 53980,
  [SMALL_STATE(2710)] = 54035,
  [SMALL_STATE(2711)] = 54136,
  [SMALL_STATE(2712)] = 54191,
  [SMALL_STATE(2713)] = 54246,
  [SMALL_STATE(2714)] = 54301,
  [SMALL_STATE(2715)] = 54356,
  [SMALL_STATE(2716)] = 54411,
  [SMALL_STATE(2717)] = 54468,
  [SMALL_STATE(2718)] = 54525,
  [SMALL_STATE(2719)] = 54626,
  [SMALL_STATE(2720)] = 54727,
  [SMALL_STATE(2721)] = 54828,
  [SMALL_STATE(2722)] = 54883,
  [SMALL_STATE(2723)] = 54938,
  [SMALL_STATE(2724)] = 54993,
  [SMALL_STATE(2725)] = 55048,
  [SMALL_STATE(2726)] = 55103,
  [SMALL_STATE(2727)] = 55204,
  [SMALL_STATE(2728)] = 55259,
  [SMALL_STATE(2729)] = 55360,
  [SMALL_STATE(2730)] = 55415,
  [SMALL_STATE(2731)] = 55470,
  [SMALL_STATE(2732)] = 55525,
  [SMALL_STATE(2733)] = 55580,
  [SMALL_STATE(2734)] = 55635,
  [SMALL_STATE(2735)] = 55690,
  [SMALL_STATE(2736)] = 55745,
  [SMALL_STATE(2737)] = 55800,
  [SMALL_STATE(2738)] = 55855,
  [SMALL_STATE(2739)] = 55910,
  [SMALL_STATE(2740)] = 55965,
  [SMALL_STATE(2741)] = 56020,
  [SMALL_STATE(2742)] = 56075,
  [SMALL_STATE(2743)] = 56130,
  [SMALL_STATE(2744)] = 56231,
  [SMALL_STATE(2745)] = 56332,
  [SMALL_STATE(2746)] = 56433,
  [SMALL_STATE(2747)] = 56492,
  [SMALL_STATE(2748)] = 56547,
  [SMALL_STATE(2749)] = 56602,
  [SMALL_STATE(2750)] = 56659,
  [SMALL_STATE(2751)] = 56760,
  [SMALL_STATE(2752)] = 56815,
  [SMALL_STATE(2753)] = 56870,
  [SMALL_STATE(2754)] = 56971,
  [SMALL_STATE(2755)] = 57030,
  [SMALL_STATE(2756)] = 57131,
  [SMALL_STATE(2757)] = 57232,
  [SMALL_STATE(2758)] = 57287,
  [SMALL_STATE(2759)] = 57388,
  [SMALL_STATE(2760)] = 57489,
  [SMALL_STATE(2761)] = 57544,
  [SMALL_STATE(2762)] = 57599,
  [SMALL_STATE(2763)] = 57654,
  [SMALL_STATE(2764)] = 57709,
  [SMALL_STATE(2765)] = 57764,
  [SMALL_STATE(2766)] = 57865,
  [SMALL_STATE(2767)] = 57966,
  [SMALL_STATE(2768)] = 58021,
  [SMALL_STATE(2769)] = 58122,
  [SMALL_STATE(2770)] = 58177,
  [SMALL_STATE(2771)] = 58232,
  [SMALL_STATE(2772)] = 58287,
  [SMALL_STATE(2773)] = 58342,
  [SMALL_STATE(2774)] = 58397,
  [SMALL_STATE(2775)] = 58498,
  [SMALL_STATE(2776)] = 58553,
  [SMALL_STATE(2777)] = 58608,
  [SMALL_STATE(2778)] = 58709,
  [SMALL_STATE(2779)] = 58764,
  [SMALL_STATE(2780)] = 58865,
  [SMALL_STATE(2781)] = 58966,
  [SMALL_STATE(2782)] = 59021,
  [SMALL_STATE(2783)] = 59076,
  [SMALL_STATE(2784)] = 59131,
  [SMALL_STATE(2785)] = 59188,
  [SMALL_STATE(2786)] = 59243,
  [SMALL_STATE(2787)] = 59298,
  [SMALL_STATE(2788)] = 59353,
  [SMALL_STATE(2789)] = 59408,
  [SMALL_STATE(2790)] = 59463,
  [SMALL_STATE(2791)] = 59518,
  [SMALL_STATE(2792)] = 59573,
  [SMALL_STATE(2793)] = 59628,
  [SMALL_STATE(2794)] = 59683,
  [SMALL_STATE(2795)] = 59784,
  [SMALL_STATE(2796)] = 59839,
  [SMALL_STATE(2797)] = 59940,
  [SMALL_STATE(2798)] = 59995,
  [SMALL_STATE(2799)] = 60050,
  [SMALL_STATE(2800)] = 60105,
  [SMALL_STATE(2801)] = 60206,
  [SMALL_STATE(2802)] = 60289,
  [SMALL_STATE(2803)] = 60344,
  [SMALL_STATE(2804)] = 60399,
  [SMALL_STATE(2805)] = 60454,
  [SMALL_STATE(2806)] = 60509,
  [SMALL_STATE(2807)] = 60598,
  [SMALL_STATE(2808)] = 60685,
  [SMALL_STATE(2809)] = 60740,
  [SMALL_STATE(2810)] = 60795,
  [SMALL_STATE(2811)] = 60850,
  [SMALL_STATE(2812)] = 60905,
  [SMALL_STATE(2813)] = 60960,
  [SMALL_STATE(2814)] = 61015,
  [SMALL_STATE(2815)] = 61116,
  [SMALL_STATE(2816)] = 61171,
  [SMALL_STATE(2817)] = 61226,
  [SMALL_STATE(2818)] = 61281,
  [SMALL_STATE(2819)] = 61336,
  [SMALL_STATE(2820)] = 61391,
  [SMALL_STATE(2821)] = 61446,
  [SMALL_STATE(2822)] = 61501,
  [SMALL_STATE(2823)] = 61556,
  [SMALL_STATE(2824)] = 61611,
  [SMALL_STATE(2825)] = 61666,
  [SMALL_STATE(2826)] = 61721,
  [SMALL_STATE(2827)] = 61776,
  [SMALL_STATE(2828)] = 61831,
  [SMALL_STATE(2829)] = 61886,
  [SMALL_STATE(2830)] = 61943,
  [SMALL_STATE(2831)] = 61998,
  [SMALL_STATE(2832)] = 62055,
  [SMALL_STATE(2833)] = 62156,
  [SMALL_STATE(2834)] = 62213,
  [SMALL_STATE(2835)] = 62268,
  [SMALL_STATE(2836)] = 62369,
  [SMALL_STATE(2837)] = 62424,
  [SMALL_STATE(2838)] = 62479,
  [SMALL_STATE(2839)] = 62536,
  [SMALL_STATE(2840)] = 62637,
  [SMALL_STATE(2841)] = 62692,
  [SMALL_STATE(2842)] = 62749,
  [SMALL_STATE(2843)] = 62804,
  [SMALL_STATE(2844)] = 62905,
  [SMALL_STATE(2845)] = 62960,
  [SMALL_STATE(2846)] = 63015,
  [SMALL_STATE(2847)] = 63070,
  [SMALL_STATE(2848)] = 63125,
  [SMALL_STATE(2849)] = 63180,
  [SMALL_STATE(2850)] = 63235,
  [SMALL_STATE(2851)] = 63290,
  [SMALL_STATE(2852)] = 63347,
  [SMALL_STATE(2853)] = 63406,
  [SMALL_STATE(2854)] = 63463,
  [SMALL_STATE(2855)] = 63518,
  [SMALL_STATE(2856)] = 63573,
  [SMALL_STATE(2857)] = 63652,
  [SMALL_STATE(2858)] = 63707,
  [SMALL_STATE(2859)] = 63762,
  [SMALL_STATE(2860)] = 63817,
  [SMALL_STATE(2861)] = 63872,
  [SMALL_STATE(2862)] = 63955,
  [SMALL_STATE(2863)] = 64010,
  [SMALL_STATE(2864)] = 64097,
  [SMALL_STATE(2865)] = 64152,
  [SMALL_STATE(2866)] = 64253,
  [SMALL_STATE(2867)] = 64342,
  [SMALL_STATE(2868)] = 64443,
  [SMALL_STATE(2869)] = 64544,
  [SMALL_STATE(2870)] = 64645,
  [SMALL_STATE(2871)] = 64728,
  [SMALL_STATE(2872)] = 64829,
  [SMALL_STATE(2873)] = 64930,
  [SMALL_STATE(2874)] = 64985,
  [SMALL_STATE(2875)] = 65086,
  [SMALL_STATE(2876)] = 65187,
  [SMALL_STATE(2877)] = 65242,
  [SMALL_STATE(2878)] = 65297,
  [SMALL_STATE(2879)] = 65352,
  [SMALL_STATE(2880)] = 65453,
  [SMALL_STATE(2881)] = 65508,
  [SMALL_STATE(2882)] = 65563,
  [SMALL_STATE(2883)] = 65618,
  [SMALL_STATE(2884)] = 65673,
  [SMALL_STATE(2885)] = 65730,
  [SMALL_STATE(2886)] = 65831,
  [SMALL_STATE(2887)] = 65932,
  [SMALL_STATE(2888)] = 66015,
  [SMALL_STATE(2889)] = 66070,
  [SMALL_STATE(2890)] = 66125,
  [SMALL_STATE(2891)] = 66204,
  [SMALL_STATE(2892)] = 66259,
  [SMALL_STATE(2893)] = 66360,
  [SMALL_STATE(2894)] = 66461,
  [SMALL_STATE(2895)] = 66562,
  [SMALL_STATE(2896)] = 66617,
  [SMALL_STATE(2897)] = 66718,
  [SMALL_STATE(2898)] = 66773,
  [SMALL_STATE(2899)] = 66874,
  [SMALL_STATE(2900)] = 66975,
  [SMALL_STATE(2901)] = 67076,
  [SMALL_STATE(2902)] = 67177,
  [SMALL_STATE(2903)] = 67232,
  [SMALL_STATE(2904)] = 67292,
  [SMALL_STATE(2905)] = 67390,
  [SMALL_STATE(2906)] = 67486,
  [SMALL_STATE(2907)] = 67584,
  [SMALL_STATE(2908)] = 67682,
  [SMALL_STATE(2909)] = 67738,
  [SMALL_STATE(2910)] = 67834,
  [SMALL_STATE(2911)] = 67932,
  [SMALL_STATE(2912)] = 68030,
  [SMALL_STATE(2913)] = 68086,
  [SMALL_STATE(2914)] = 68184,
  [SMALL_STATE(2915)] = 68282,
  [SMALL_STATE(2916)] = 68380,
  [SMALL_STATE(2917)] = 68474,
  [SMALL_STATE(2918)] = 68572,
  [SMALL_STATE(2919)] = 68628,
  [SMALL_STATE(2920)] = 68682,
  [SMALL_STATE(2921)] = 68780,
  [SMALL_STATE(2922)] = 68878,
  [SMALL_STATE(2923)] = 68976,
  [SMALL_STATE(2924)] = 69074,
  [SMALL_STATE(2925)] = 69172,
  [SMALL_STATE(2926)] = 69270,
  [SMALL_STATE(2927)] = 69330,
  [SMALL_STATE(2928)] = 69428,
  [SMALL_STATE(2929)] = 69526,
  [SMALL_STATE(2930)] = 69620,
  [SMALL_STATE(2931)] = 69675,
  [SMALL_STATE(2932)] = 69770,
  [SMALL_STATE(2933)] = 69823,
  [SMALL_STATE(2934)] = 69878,
  [SMALL_STATE(2935)] = 69933,
  [SMALL_STATE(2936)] = 69986,
  [SMALL_STATE(2937)] = 70041,
  [SMALL_STATE(2938)] = 70094,
  [SMALL_STATE(2939)] = 70183,
  [SMALL_STATE(2940)] = 70236,
  [SMALL_STATE(2941)] = 70325,
  [SMALL_STATE(2942)] = 70414,
  [SMALL_STATE(2943)] = 70467,
  [SMALL_STATE(2944)] = 70522,
  [SMALL_STATE(2945)] = 70577,
  [SMALL_STATE(2946)] = 70632,
  [SMALL_STATE(2947)] = 70687,
  [SMALL_STATE(2948)] = 70740,
  [SMALL_STATE(2949)] = 70799,
  [SMALL_STATE(2950)] = 70852,
  [SMALL_STATE(2951)] = 70907,
  [SMALL_STATE(2952)] = 70962,
  [SMALL_STATE(2953)] = 71015,
  [SMALL_STATE(2954)] = 71104,
  [SMALL_STATE(2955)] = 71157,
  [SMALL_STATE(2956)] = 71210,
  [SMALL_STATE(2957)] = 71263,
  [SMALL_STATE(2958)] = 71316,
  [SMALL_STATE(2959)] = 71371,
  [SMALL_STATE(2960)] = 71460,
  [SMALL_STATE(2961)] = 71515,
  [SMALL_STATE(2962)] = 71568,
  [SMALL_STATE(2963)] = 71621,
  [SMALL_STATE(2964)] = 71710,
  [SMALL_STATE(2965)] = 71763,
  [SMALL_STATE(2966)] = 71816,
  [SMALL_STATE(2967)] = 71869,
  [SMALL_STATE(2968)] = 71924,
  [SMALL_STATE(2969)] = 71977,
  [SMALL_STATE(2970)] = 72030,
  [SMALL_STATE(2971)] = 72083,
  [SMALL_STATE(2972)] = 72136,
  [SMALL_STATE(2973)] = 72189,
  [SMALL_STATE(2974)] = 72242,
  [SMALL_STATE(2975)] = 72297,
  [SMALL_STATE(2976)] = 72350,
  [SMALL_STATE(2977)] = 72403,
  [SMALL_STATE(2978)] = 72456,
  [SMALL_STATE(2979)] = 72509,
  [SMALL_STATE(2980)] = 72562,
  [SMALL_STATE(2981)] = 72615,
  [SMALL_STATE(2982)] = 72671,
  [SMALL_STATE(2983)] = 72727,
  [SMALL_STATE(2984)] = 72781,
  [SMALL_STATE(2985)] = 72835,
  [SMALL_STATE(2986)] = 72889,
  [SMALL_STATE(2987)] = 72943,
  [SMALL_STATE(2988)] = 72997,
  [SMALL_STATE(2989)] = 73051,
  [SMALL_STATE(2990)] = 73105,
  [SMALL_STATE(2991)] = 73161,
  [SMALL_STATE(2992)] = 73217,
  [SMALL_STATE(2993)] = 73271,
  [SMALL_STATE(2994)] = 73327,
  [SMALL_STATE(2995)] = 73381,
  [SMALL_STATE(2996)] = 73435,
  [SMALL_STATE(2997)] = 73491,
  [SMALL_STATE(2998)] = 73545,
  [SMALL_STATE(2999)] = 73601,
  [SMALL_STATE(3000)] = 73655,
  [SMALL_STATE(3001)] = 73709,
  [SMALL_STATE(3002)] = 73763,
  [SMALL_STATE(3003)] = 73817,
  [SMALL_STATE(3004)] = 73871,
  [SMALL_STATE(3005)] = 73925,
  [SMALL_STATE(3006)] = 73979,
  [SMALL_STATE(3007)] = 74033,
  [SMALL_STATE(3008)] = 74087,
  [SMALL_STATE(3009)] = 74143,
  [SMALL_STATE(3010)] = 74197,
  [SMALL_STATE(3011)] = 74253,
  [SMALL_STATE(3012)] = 74309,
  [SMALL_STATE(3013)] = 74365,
  [SMALL_STATE(3014)] = 74419,
  [SMALL_STATE(3015)] = 74473,
  [SMALL_STATE(3016)] = 74527,
  [SMALL_STATE(3017)] = 74581,
  [SMALL_STATE(3018)] = 74635,
  [SMALL_STATE(3019)] = 74689,
  [SMALL_STATE(3020)] = 74743,
  [SMALL_STATE(3021)] = 74797,
  [SMALL_STATE(3022)] = 74853,
  [SMALL_STATE(3023)] = 74907,
  [SMALL_STATE(3024)] = 74961,
  [SMALL_STATE(3025)] = 75015,
  [SMALL_STATE(3026)] = 75071,
  [SMALL_STATE(3027)] = 75125,
  [SMALL_STATE(3028)] = 75181,
  [SMALL_STATE(3029)] = 75237,
  [SMALL_STATE(3030)] = 75293,
  [SMALL_STATE(3031)] = 75347,
  [SMALL_STATE(3032)] = 75403,
  [SMALL_STATE(3033)] = 75457,
  [SMALL_STATE(3034)] = 75511,
  [SMALL_STATE(3035)] = 75567,
  [SMALL_STATE(3036)] = 75623,
  [SMALL_STATE(3037)] = 75677,
  [SMALL_STATE(3038)] = 75731,
  [SMALL_STATE(3039)] = 75785,
  [SMALL_STATE(3040)] = 75841,
  [SMALL_STATE(3041)] = 75895,
  [SMALL_STATE(3042)] = 75949,
  [SMALL_STATE(3043)] = 76005,
  [SMALL_STATE(3044)] = 76061,
  [SMALL_STATE(3045)] = 76115,
  [SMALL_STATE(3046)] = 76169,
  [SMALL_STATE(3047)] = 76223,
  [SMALL_STATE(3048)] = 76277,
  [SMALL_STATE(3049)] = 76333,
  [SMALL_STATE(3050)] = 76389,
  [SMALL_STATE(3051)] = 76443,
  [SMALL_STATE(3052)] = 76497,
  [SMALL_STATE(3053)] = 76553,
  [SMALL_STATE(3054)] = 76609,
  [SMALL_STATE(3055)] = 76665,
  [SMALL_STATE(3056)] = 76719,
  [SMALL_STATE(3057)] = 76773,
  [SMALL_STATE(3058)] = 76829,
  [SMALL_STATE(3059)] = 76883,
  [SMALL_STATE(3060)] = 76939,
  [SMALL_STATE(3061)] = 77028,
  [SMALL_STATE(3062)] = 77117,
  [SMALL_STATE(3063)] = 77203,
  [SMALL_STATE(3064)] = 77289,
  [SMALL_STATE(3065)] = 77375,
  [SMALL_STATE(3066)] = 77461,
  [SMALL_STATE(3067)] = 77547,
  [SMALL_STATE(3068)] = 77633,
  [SMALL_STATE(3069)] = 77719,
  [SMALL_STATE(3070)] = 77805,
  [SMALL_STATE(3071)] = 77891,
  [SMALL_STATE(3072)] = 77951,
  [SMALL_STATE(3073)] = 78037,
  [SMALL_STATE(3074)] = 78123,
  [SMALL_STATE(3075)] = 78209,
  [SMALL_STATE(3076)] = 78295,
  [SMALL_STATE(3077)] = 78381,
  [SMALL_STATE(3078)] = 78467,
  [SMALL_STATE(3079)] = 78553,
  [SMALL_STATE(3080)] = 78639,
  [SMALL_STATE(3081)] = 78725,
  [SMALL_STATE(3082)] = 78811,
  [SMALL_STATE(3083)] = 78897,
  [SMALL_STATE(3084)] = 78983,
  [SMALL_STATE(3085)] = 79069,
  [SMALL_STATE(3086)] = 79155,
  [SMALL_STATE(3087)] = 79241,
  [SMALL_STATE(3088)] = 79327,
  [SMALL_STATE(3089)] = 79413,
  [SMALL_STATE(3090)] = 79499,
  [SMALL_STATE(3091)] = 79585,
  [SMALL_STATE(3092)] = 79671,
  [SMALL_STATE(3093)] = 79757,
  [SMALL_STATE(3094)] = 79843,
  [SMALL_STATE(3095)] = 79929,
  [SMALL_STATE(3096)] = 80015,
  [SMALL_STATE(3097)] = 80101,
  [SMALL_STATE(3098)] = 80187,
  [SMALL_STATE(3099)] = 80273,
  [SMALL_STATE(3100)] = 80359,
  [SMALL_STATE(3101)] = 80445,
  [SMALL_STATE(3102)] = 80531,
  [SMALL_STATE(3103)] = 80614,
  [SMALL_STATE(3104)] = 80697,
  [SMALL_STATE(3105)] = 80780,
  [SMALL_STATE(3106)] = 80863,
  [SMALL_STATE(3107)] = 80946,
  [SMALL_STATE(3108)] = 81029,
  [SMALL_STATE(3109)] = 81112,
  [SMALL_STATE(3110)] = 81195,
  [SMALL_STATE(3111)] = 81278,
  [SMALL_STATE(3112)] = 81361,
  [SMALL_STATE(3113)] = 81444,
  [SMALL_STATE(3114)] = 81527,
  [SMALL_STATE(3115)] = 81610,
  [SMALL_STATE(3116)] = 81693,
  [SMALL_STATE(3117)] = 81776,
  [SMALL_STATE(3118)] = 81859,
  [SMALL_STATE(3119)] = 81942,
  [SMALL_STATE(3120)] = 82025,
  [SMALL_STATE(3121)] = 82108,
  [SMALL_STATE(3122)] = 82191,
  [SMALL_STATE(3123)] = 82274,
  [SMALL_STATE(3124)] = 82357,
  [SMALL_STATE(3125)] = 82440,
  [SMALL_STATE(3126)] = 82523,
  [SMALL_STATE(3127)] = 82606,
  [SMALL_STATE(3128)] = 82689,
  [SMALL_STATE(3129)] = 82772,
  [SMALL_STATE(3130)] = 82855,
  [SMALL_STATE(3131)] = 82938,
  [SMALL_STATE(3132)] = 83021,
  [SMALL_STATE(3133)] = 83104,
  [SMALL_STATE(3134)] = 83187,
  [SMALL_STATE(3135)] = 83270,
  [SMALL_STATE(3136)] = 83353,
  [SMALL_STATE(3137)] = 83436,
  [SMALL_STATE(3138)] = 83519,
  [SMALL_STATE(3139)] = 83602,
  [SMALL_STATE(3140)] = 83685,
  [SMALL_STATE(3141)] = 83768,
  [SMALL_STATE(3142)] = 83851,
  [SMALL_STATE(3143)] = 83934,
  [SMALL_STATE(3144)] = 84017,
  [SMALL_STATE(3145)] = 84100,
  [SMALL_STATE(3146)] = 84183,
  [SMALL_STATE(3147)] = 84266,
  [SMALL_STATE(3148)] = 84349,
  [SMALL_STATE(3149)] = 84432,
  [SMALL_STATE(3150)] = 84515,
  [SMALL_STATE(3151)] = 84598,
  [SMALL_STATE(3152)] = 84681,
  [SMALL_STATE(3153)] = 84764,
  [SMALL_STATE(3154)] = 84847,
  [SMALL_STATE(3155)] = 84930,
  [SMALL_STATE(3156)] = 85013,
  [SMALL_STATE(3157)] = 85096,
  [SMALL_STATE(3158)] = 85179,
  [SMALL_STATE(3159)] = 85262,
  [SMALL_STATE(3160)] = 85345,
  [SMALL_STATE(3161)] = 85428,
  [SMALL_STATE(3162)] = 85511,
  [SMALL_STATE(3163)] = 85594,
  [SMALL_STATE(3164)] = 85677,
  [SMALL_STATE(3165)] = 85760,
  [SMALL_STATE(3166)] = 85843,
  [SMALL_STATE(3167)] = 85926,
  [SMALL_STATE(3168)] = 86009,
  [SMALL_STATE(3169)] = 86092,
  [SMALL_STATE(3170)] = 86175,
  [SMALL_STATE(3171)] = 86258,
  [SMALL_STATE(3172)] = 86341,
  [SMALL_STATE(3173)] = 86424,
  [SMALL_STATE(3174)] = 86507,
  [SMALL_STATE(3175)] = 86590,
  [SMALL_STATE(3176)] = 86673,
  [SMALL_STATE(3177)] = 86756,
  [SMALL_STATE(3178)] = 86839,
  [SMALL_STATE(3179)] = 86922,
  [SMALL_STATE(3180)] = 87005,
  [SMALL_STATE(3181)] = 87088,
  [SMALL_STATE(3182)] = 87171,
  [SMALL_STATE(3183)] = 87254,
  [SMALL_STATE(3184)] = 87337,
  [SMALL_STATE(3185)] = 87420,
  [SMALL_STATE(3186)] = 87503,
  [SMALL_STATE(3187)] = 87586,
  [SMALL_STATE(3188)] = 87669,
  [SMALL_STATE(3189)] = 87752,
  [SMALL_STATE(3190)] = 87835,
  [SMALL_STATE(3191)] = 87918,
  [SMALL_STATE(3192)] = 88001,
  [SMALL_STATE(3193)] = 88084,
  [SMALL_STATE(3194)] = 88167,
  [SMALL_STATE(3195)] = 88250,
  [SMALL_STATE(3196)] = 88333,
  [SMALL_STATE(3197)] = 88416,
  [SMALL_STATE(3198)] = 88499,
  [SMALL_STATE(3199)] = 88582,
  [SMALL_STATE(3200)] = 88665,
  [SMALL_STATE(3201)] = 88748,
  [SMALL_STATE(3202)] = 88831,
  [SMALL_STATE(3203)] = 88914,
  [SMALL_STATE(3204)] = 88997,
  [SMALL_STATE(3205)] = 89080,
  [SMALL_STATE(3206)] = 89163,
  [SMALL_STATE(3207)] = 89246,
  [SMALL_STATE(3208)] = 89329,
  [SMALL_STATE(3209)] = 89412,
  [SMALL_STATE(3210)] = 89495,
  [SMALL_STATE(3211)] = 89578,
  [SMALL_STATE(3212)] = 89661,
  [SMALL_STATE(3213)] = 89744,
  [SMALL_STATE(3214)] = 89827,
  [SMALL_STATE(3215)] = 89910,
  [SMALL_STATE(3216)] = 89993,
  [SMALL_STATE(3217)] = 90076,
  [SMALL_STATE(3218)] = 90159,
  [SMALL_STATE(3219)] = 90242,
  [SMALL_STATE(3220)] = 90325,
  [SMALL_STATE(3221)] = 90408,
  [SMALL_STATE(3222)] = 90491,
  [SMALL_STATE(3223)] = 90574,
  [SMALL_STATE(3224)] = 90657,
  [SMALL_STATE(3225)] = 90740,
  [SMALL_STATE(3226)] = 90823,
  [SMALL_STATE(3227)] = 90906,
  [SMALL_STATE(3228)] = 90989,
  [SMALL_STATE(3229)] = 91072,
  [SMALL_STATE(3230)] = 91155,
  [SMALL_STATE(3231)] = 91238,
  [SMALL_STATE(3232)] = 91321,
  [SMALL_STATE(3233)] = 91404,
  [SMALL_STATE(3234)] = 91487,
  [SMALL_STATE(3235)] = 91570,
  [SMALL_STATE(3236)] = 91653,
  [SMALL_STATE(3237)] = 91736,
  [SMALL_STATE(3238)] = 91819,
  [SMALL_STATE(3239)] = 91902,
  [SMALL_STATE(3240)] = 91985,
  [SMALL_STATE(3241)] = 92068,
  [SMALL_STATE(3242)] = 92151,
  [SMALL_STATE(3243)] = 92234,
  [SMALL_STATE(3244)] = 92317,
  [SMALL_STATE(3245)] = 92400,
  [SMALL_STATE(3246)] = 92483,
  [SMALL_STATE(3247)] = 92566,
  [SMALL_STATE(3248)] = 92649,
  [SMALL_STATE(3249)] = 92732,
  [SMALL_STATE(3250)] = 92815,
  [SMALL_STATE(3251)] = 92898,
  [SMALL_STATE(3252)] = 92981,
  [SMALL_STATE(3253)] = 93064,
  [SMALL_STATE(3254)] = 93147,
  [SMALL_STATE(3255)] = 93230,
  [SMALL_STATE(3256)] = 93313,
  [SMALL_STATE(3257)] = 93396,
  [SMALL_STATE(3258)] = 93479,
  [SMALL_STATE(3259)] = 93562,
  [SMALL_STATE(3260)] = 93645,
  [SMALL_STATE(3261)] = 93728,
  [SMALL_STATE(3262)] = 93811,
  [SMALL_STATE(3263)] = 93894,
  [SMALL_STATE(3264)] = 93977,
  [SMALL_STATE(3265)] = 94060,
  [SMALL_STATE(3266)] = 94143,
  [SMALL_STATE(3267)] = 94226,
  [SMALL_STATE(3268)] = 94309,
  [SMALL_STATE(3269)] = 94392,
  [SMALL_STATE(3270)] = 94475,
  [SMALL_STATE(3271)] = 94558,
  [SMALL_STATE(3272)] = 94641,
  [SMALL_STATE(3273)] = 94724,
  [SMALL_STATE(3274)] = 94807,
  [SMALL_STATE(3275)] = 94890,
  [SMALL_STATE(3276)] = 94973,
  [SMALL_STATE(3277)] = 95056,
  [SMALL_STATE(3278)] = 95139,
  [SMALL_STATE(3279)] = 95222,
  [SMALL_STATE(3280)] = 95305,
  [SMALL_STATE(3281)] = 95388,
  [SMALL_STATE(3282)] = 95471,
  [SMALL_STATE(3283)] = 95554,
  [SMALL_STATE(3284)] = 95637,
  [SMALL_STATE(3285)] = 95720,
  [SMALL_STATE(3286)] = 95803,
  [SMALL_STATE(3287)] = 95886,
  [SMALL_STATE(3288)] = 95969,
  [SMALL_STATE(3289)] = 96052,
  [SMALL_STATE(3290)] = 96135,
  [SMALL_STATE(3291)] = 96218,
  [SMALL_STATE(3292)] = 96301,
  [SMALL_STATE(3293)] = 96384,
  [SMALL_STATE(3294)] = 96467,
  [SMALL_STATE(3295)] = 96550,
  [SMALL_STATE(3296)] = 96633,
  [SMALL_STATE(3297)] = 96716,
  [SMALL_STATE(3298)] = 96799,
  [SMALL_STATE(3299)] = 96882,
  [SMALL_STATE(3300)] = 96965,
  [SMALL_STATE(3301)] = 97048,
  [SMALL_STATE(3302)] = 97131,
  [SMALL_STATE(3303)] = 97214,
  [SMALL_STATE(3304)] = 97297,
  [SMALL_STATE(3305)] = 97380,
  [SMALL_STATE(3306)] = 97463,
  [SMALL_STATE(3307)] = 97546,
  [SMALL_STATE(3308)] = 97629,
  [SMALL_STATE(3309)] = 97712,
  [SMALL_STATE(3310)] = 97795,
  [SMALL_STATE(3311)] = 97878,
  [SMALL_STATE(3312)] = 97961,
  [SMALL_STATE(3313)] = 98044,
  [SMALL_STATE(3314)] = 98127,
  [SMALL_STATE(3315)] = 98210,
  [SMALL_STATE(3316)] = 98293,
  [SMALL_STATE(3317)] = 98376,
  [SMALL_STATE(3318)] = 98459,
  [SMALL_STATE(3319)] = 98542,
  [SMALL_STATE(3320)] = 98625,
  [SMALL_STATE(3321)] = 98708,
  [SMALL_STATE(3322)] = 98791,
  [SMALL_STATE(3323)] = 98874,
  [SMALL_STATE(3324)] = 98957,
  [SMALL_STATE(3325)] = 99040,
  [SMALL_STATE(3326)] = 99123,
  [SMALL_STATE(3327)] = 99206,
  [SMALL_STATE(3328)] = 99289,
  [SMALL_STATE(3329)] = 99372,
  [SMALL_STATE(3330)] = 99455,
  [SMALL_STATE(3331)] = 99538,
  [SMALL_STATE(3332)] = 99621,
  [SMALL_STATE(3333)] = 99704,
  [SMALL_STATE(3334)] = 99787,
  [SMALL_STATE(3335)] = 99870,
  [SMALL_STATE(3336)] = 99953,
  [SMALL_STATE(3337)] = 100036,
  [SMALL_STATE(3338)] = 100119,
  [SMALL_STATE(3339)] = 100202,
  [SMALL_STATE(3340)] = 100285,
  [SMALL_STATE(3341)] = 100368,
  [SMALL_STATE(3342)] = 100451,
  [SMALL_STATE(3343)] = 100534,
  [SMALL_STATE(3344)] = 100617,
  [SMALL_STATE(3345)] = 100700,
  [SMALL_STATE(3346)] = 100783,
  [SMALL_STATE(3347)] = 100851,
  [SMALL_STATE(3348)] = 100925,
  [SMALL_STATE(3349)] = 100993,
  [SMALL_STATE(3350)] = 101061,
  [SMALL_STATE(3351)] = 101129,
  [SMALL_STATE(3352)] = 101197,
  [SMALL_STATE(3353)] = 101265,
  [SMALL_STATE(3354)] = 101333,
  [SMALL_STATE(3355)] = 101401,
  [SMALL_STATE(3356)] = 101475,
  [SMALL_STATE(3357)] = 101543,
  [SMALL_STATE(3358)] = 101611,
  [SMALL_STATE(3359)] = 101679,
  [SMALL_STATE(3360)] = 101747,
  [SMALL_STATE(3361)] = 101815,
  [SMALL_STATE(3362)] = 101883,
  [SMALL_STATE(3363)] = 101952,
  [SMALL_STATE(3364)] = 101989,
  [SMALL_STATE(3365)] = 102026,
  [SMALL_STATE(3366)] = 102063,
  [SMALL_STATE(3367)] = 102100,
  [SMALL_STATE(3368)] = 102137,
  [SMALL_STATE(3369)] = 102170,
  [SMALL_STATE(3370)] = 102203,
  [SMALL_STATE(3371)] = 102236,
  [SMALL_STATE(3372)] = 102283,
  [SMALL_STATE(3373)] = 102330,
  [SMALL_STATE(3374)] = 102381,
  [SMALL_STATE(3375)] = 102414,
  [SMALL_STATE(3376)] = 102447,
  [SMALL_STATE(3377)] = 102494,
  [SMALL_STATE(3378)] = 102524,
  [SMALL_STATE(3379)] = 102554,
  [SMALL_STATE(3380)] = 102588,
  [SMALL_STATE(3381)] = 102622,
  [SMALL_STATE(3382)] = 102652,
  [SMALL_STATE(3383)] = 102688,
  [SMALL_STATE(3384)] = 102721,
  [SMALL_STATE(3385)] = 102754,
  [SMALL_STATE(3386)] = 102785,
  [SMALL_STATE(3387)] = 102818,
  [SMALL_STATE(3388)] = 102851,
  [SMALL_STATE(3389)] = 102884,
  [SMALL_STATE(3390)] = 102917,
  [SMALL_STATE(3391)] = 102950,
  [SMALL_STATE(3392)] = 102981,
  [SMALL_STATE(3393)] = 103013,
  [SMALL_STATE(3394)] = 103043,
  [SMALL_STATE(3395)] = 103073,
  [SMALL_STATE(3396)] = 103121,
  [SMALL_STATE(3397)] = 103167,
  [SMALL_STATE(3398)] = 103215,
  [SMALL_STATE(3399)] = 103262,
  [SMALL_STATE(3400)] = 103291,
  [SMALL_STATE(3401)] = 103338,
  [SMALL_STATE(3402)] = 103385,
  [SMALL_STATE(3403)] = 103430,
  [SMALL_STATE(3404)] = 103477,
  [SMALL_STATE(3405)] = 103506,
  [SMALL_STATE(3406)] = 103553,
  [SMALL_STATE(3407)] = 103584,
  [SMALL_STATE(3408)] = 103613,
  [SMALL_STATE(3409)] = 103660,
  [SMALL_STATE(3410)] = 103707,
  [SMALL_STATE(3411)] = 103754,
  [SMALL_STATE(3412)] = 103801,
  [SMALL_STATE(3413)] = 103848,
  [SMALL_STATE(3414)] = 103895,
  [SMALL_STATE(3415)] = 103942,
  [SMALL_STATE(3416)] = 103989,
  [SMALL_STATE(3417)] = 104024,
  [SMALL_STATE(3418)] = 104071,
  [SMALL_STATE(3419)] = 104118,
  [SMALL_STATE(3420)] = 104165,
  [SMALL_STATE(3421)] = 104212,
  [SMALL_STATE(3422)] = 104259,
  [SMALL_STATE(3423)] = 104306,
  [SMALL_STATE(3424)] = 104337,
  [SMALL_STATE(3425)] = 104366,
  [SMALL_STATE(3426)] = 104413,
  [SMALL_STATE(3427)] = 104460,
  [SMALL_STATE(3428)] = 104507,
  [SMALL_STATE(3429)] = 104554,
  [SMALL_STATE(3430)] = 104601,
  [SMALL_STATE(3431)] = 104636,
  [SMALL_STATE(3432)] = 104665,
  [SMALL_STATE(3433)] = 104700,
  [SMALL_STATE(3434)] = 104735,
  [SMALL_STATE(3435)] = 104782,
  [SMALL_STATE(3436)] = 104829,
  [SMALL_STATE(3437)] = 104858,
  [SMALL_STATE(3438)] = 104905,
  [SMALL_STATE(3439)] = 104952,
  [SMALL_STATE(3440)] = 104999,
  [SMALL_STATE(3441)] = 105034,
  [SMALL_STATE(3442)] = 105069,
  [SMALL_STATE(3443)] = 105104,
  [SMALL_STATE(3444)] = 105139,
  [SMALL_STATE(3445)] = 105186,
  [SMALL_STATE(3446)] = 105215,
  [SMALL_STATE(3447)] = 105245,
  [SMALL_STATE(3448)] = 105271,
  [SMALL_STATE(3449)] = 105297,
  [SMALL_STATE(3450)] = 105329,
  [SMALL_STATE(3451)] = 105355,
  [SMALL_STATE(3452)] = 105382,
  [SMALL_STATE(3453)] = 105413,
  [SMALL_STATE(3454)] = 105440,
  [SMALL_STATE(3455)] = 105468,
  [SMALL_STATE(3456)] = 105492,
  [SMALL_STATE(3457)] = 105516,
  [SMALL_STATE(3458)] = 105546,
  [SMALL_STATE(3459)] = 105570,
  [SMALL_STATE(3460)] = 105594,
  [SMALL_STATE(3461)] = 105618,
  [SMALL_STATE(3462)] = 105642,
  [SMALL_STATE(3463)] = 105666,
  [SMALL_STATE(3464)] = 105690,
  [SMALL_STATE(3465)] = 105714,
  [SMALL_STATE(3466)] = 105738,
  [SMALL_STATE(3467)] = 105762,
  [SMALL_STATE(3468)] = 105786,
  [SMALL_STATE(3469)] = 105810,
  [SMALL_STATE(3470)] = 105834,
  [SMALL_STATE(3471)] = 105858,
  [SMALL_STATE(3472)] = 105882,
  [SMALL_STATE(3473)] = 105906,
  [SMALL_STATE(3474)] = 105930,
  [SMALL_STATE(3475)] = 105954,
  [SMALL_STATE(3476)] = 105978,
  [SMALL_STATE(3477)] = 106002,
  [SMALL_STATE(3478)] = 106030,
  [SMALL_STATE(3479)] = 106054,
  [SMALL_STATE(3480)] = 106083,
  [SMALL_STATE(3481)] = 106122,
  [SMALL_STATE(3482)] = 106149,
  [SMALL_STATE(3483)] = 106183,
  [SMALL_STATE(3484)] = 106209,
  [SMALL_STATE(3485)] = 106243,
  [SMALL_STATE(3486)] = 106277,
  [SMALL_STATE(3487)] = 106311,
  [SMALL_STATE(3488)] = 106347,
  [SMALL_STATE(3489)] = 106381,
  [SMALL_STATE(3490)] = 106405,
  [SMALL_STATE(3491)] = 106439,
  [SMALL_STATE(3492)] = 106473,
  [SMALL_STATE(3493)] = 106507,
  [SMALL_STATE(3494)] = 106541,
  [SMALL_STATE(3495)] = 106563,
  [SMALL_STATE(3496)] = 106591,
  [SMALL_STATE(3497)] = 106625,
  [SMALL_STATE(3498)] = 106653,
  [SMALL_STATE(3499)] = 106687,
  [SMALL_STATE(3500)] = 106721,
  [SMALL_STATE(3501)] = 106742,
  [SMALL_STATE(3502)] = 106763,
  [SMALL_STATE(3503)] = 106788,
  [SMALL_STATE(3504)] = 106809,
  [SMALL_STATE(3505)] = 106830,
  [SMALL_STATE(3506)] = 106851,
  [SMALL_STATE(3507)] = 106874,
  [SMALL_STATE(3508)] = 106895,
  [SMALL_STATE(3509)] = 106916,
  [SMALL_STATE(3510)] = 106939,
  [SMALL_STATE(3511)] = 106972,
  [SMALL_STATE(3512)] = 106995,
  [SMALL_STATE(3513)] = 107024,
  [SMALL_STATE(3514)] = 107049,
  [SMALL_STATE(3515)] = 107070,
  [SMALL_STATE(3516)] = 107101,
  [SMALL_STATE(3517)] = 107122,
  [SMALL_STATE(3518)] = 107145,
  [SMALL_STATE(3519)] = 107165,
  [SMALL_STATE(3520)] = 107195,
  [SMALL_STATE(3521)] = 107225,
  [SMALL_STATE(3522)] = 107255,
  [SMALL_STATE(3523)] = 107285,
  [SMALL_STATE(3524)] = 107315,
  [SMALL_STATE(3525)] = 107345,
  [SMALL_STATE(3526)] = 107375,
  [SMALL_STATE(3527)] = 107403,
  [SMALL_STATE(3528)] = 107433,
  [SMALL_STATE(3529)] = 107463,
  [SMALL_STATE(3530)] = 107493,
  [SMALL_STATE(3531)] = 107523,
  [SMALL_STATE(3532)] = 107543,
  [SMALL_STATE(3533)] = 107571,
  [SMALL_STATE(3534)] = 107601,
  [SMALL_STATE(3535)] = 107631,
  [SMALL_STATE(3536)] = 107659,
  [SMALL_STATE(3537)] = 107687,
  [SMALL_STATE(3538)] = 107717,
  [SMALL_STATE(3539)] = 107747,
  [SMALL_STATE(3540)] = 107777,
  [SMALL_STATE(3541)] = 107805,
  [SMALL_STATE(3542)] = 107835,
  [SMALL_STATE(3543)] = 107865,
  [SMALL_STATE(3544)] = 107893,
  [SMALL_STATE(3545)] = 107923,
  [SMALL_STATE(3546)] = 107953,
  [SMALL_STATE(3547)] = 107983,
  [SMALL_STATE(3548)] = 108015,
  [SMALL_STATE(3549)] = 108045,
  [SMALL_STATE(3550)] = 108075,
  [SMALL_STATE(3551)] = 108105,
  [SMALL_STATE(3552)] = 108135,
  [SMALL_STATE(3553)] = 108165,
  [SMALL_STATE(3554)] = 108195,
  [SMALL_STATE(3555)] = 108225,
  [SMALL_STATE(3556)] = 108255,
  [SMALL_STATE(3557)] = 108283,
  [SMALL_STATE(3558)] = 108313,
  [SMALL_STATE(3559)] = 108343,
  [SMALL_STATE(3560)] = 108373,
  [SMALL_STATE(3561)] = 108403,
  [SMALL_STATE(3562)] = 108431,
  [SMALL_STATE(3563)] = 108459,
  [SMALL_STATE(3564)] = 108479,
  [SMALL_STATE(3565)] = 108507,
  [SMALL_STATE(3566)] = 108537,
  [SMALL_STATE(3567)] = 108567,
  [SMALL_STATE(3568)] = 108597,
  [SMALL_STATE(3569)] = 108627,
  [SMALL_STATE(3570)] = 108657,
  [SMALL_STATE(3571)] = 108687,
  [SMALL_STATE(3572)] = 108717,
  [SMALL_STATE(3573)] = 108747,
  [SMALL_STATE(3574)] = 108777,
  [SMALL_STATE(3575)] = 108807,
  [SMALL_STATE(3576)] = 108837,
  [SMALL_STATE(3577)] = 108867,
  [SMALL_STATE(3578)] = 108897,
  [SMALL_STATE(3579)] = 108927,
  [SMALL_STATE(3580)] = 108959,
  [SMALL_STATE(3581)] = 108989,
  [SMALL_STATE(3582)] = 109019,
  [SMALL_STATE(3583)] = 109049,
  [SMALL_STATE(3584)] = 109079,
  [SMALL_STATE(3585)] = 109107,
  [SMALL_STATE(3586)] = 109137,
  [SMALL_STATE(3587)] = 109167,
  [SMALL_STATE(3588)] = 109195,
  [SMALL_STATE(3589)] = 109225,
  [SMALL_STATE(3590)] = 109255,
  [SMALL_STATE(3591)] = 109285,
  [SMALL_STATE(3592)] = 109315,
  [SMALL_STATE(3593)] = 109345,
  [SMALL_STATE(3594)] = 109375,
  [SMALL_STATE(3595)] = 109405,
  [SMALL_STATE(3596)] = 109429,
  [SMALL_STATE(3597)] = 109459,
  [SMALL_STATE(3598)] = 109489,
  [SMALL_STATE(3599)] = 109519,
  [SMALL_STATE(3600)] = 109549,
  [SMALL_STATE(3601)] = 109579,
  [SMALL_STATE(3602)] = 109609,
  [SMALL_STATE(3603)] = 109637,
  [SMALL_STATE(3604)] = 109667,
  [SMALL_STATE(3605)] = 109697,
  [SMALL_STATE(3606)] = 109725,
  [SMALL_STATE(3607)] = 109755,
  [SMALL_STATE(3608)] = 109785,
  [SMALL_STATE(3609)] = 109815,
  [SMALL_STATE(3610)] = 109845,
  [SMALL_STATE(3611)] = 109873,
  [SMALL_STATE(3612)] = 109901,
  [SMALL_STATE(3613)] = 109931,
  [SMALL_STATE(3614)] = 109961,
  [SMALL_STATE(3615)] = 109989,
  [SMALL_STATE(3616)] = 110017,
  [SMALL_STATE(3617)] = 110047,
  [SMALL_STATE(3618)] = 110077,
  [SMALL_STATE(3619)] = 110107,
  [SMALL_STATE(3620)] = 110137,
  [SMALL_STATE(3621)] = 110167,
  [SMALL_STATE(3622)] = 110195,
  [SMALL_STATE(3623)] = 110223,
  [SMALL_STATE(3624)] = 110251,
  [SMALL_STATE(3625)] = 110281,
  [SMALL_STATE(3626)] = 110311,
  [SMALL_STATE(3627)] = 110341,
  [SMALL_STATE(3628)] = 110371,
  [SMALL_STATE(3629)] = 110401,
  [SMALL_STATE(3630)] = 110429,
  [SMALL_STATE(3631)] = 110457,
  [SMALL_STATE(3632)] = 110485,
  [SMALL_STATE(3633)] = 110515,
  [SMALL_STATE(3634)] = 110545,
  [SMALL_STATE(3635)] = 110575,
  [SMALL_STATE(3636)] = 110605,
  [SMALL_STATE(3637)] = 110635,
  [SMALL_STATE(3638)] = 110665,
  [SMALL_STATE(3639)] = 110693,
  [SMALL_STATE(3640)] = 110723,
  [SMALL_STATE(3641)] = 110753,
  [SMALL_STATE(3642)] = 110783,
  [SMALL_STATE(3643)] = 110813,
  [SMALL_STATE(3644)] = 110843,
  [SMALL_STATE(3645)] = 110873,
  [SMALL_STATE(3646)] = 110903,
  [SMALL_STATE(3647)] = 110931,
  [SMALL_STATE(3648)] = 110960,
  [SMALL_STATE(3649)] = 110983,
  [SMALL_STATE(3650)] = 111006,
  [SMALL_STATE(3651)] = 111035,
  [SMALL_STATE(3652)] = 111056,
  [SMALL_STATE(3653)] = 111083,
  [SMALL_STATE(3654)] = 111104,
  [SMALL_STATE(3655)] = 111133,
  [SMALL_STATE(3656)] = 111156,
  [SMALL_STATE(3657)] = 111179,
  [SMALL_STATE(3658)] = 111199,
  [SMALL_STATE(3659)] = 111219,
  [SMALL_STATE(3660)] = 111243,
  [SMALL_STATE(3661)] = 111269,
  [SMALL_STATE(3662)] = 111293,
  [SMALL_STATE(3663)] = 111313,
  [SMALL_STATE(3664)] = 111333,
  [SMALL_STATE(3665)] = 111353,
  [SMALL_STATE(3666)] = 111377,
  [SMALL_STATE(3667)] = 111395,
  [SMALL_STATE(3668)] = 111421,
  [SMALL_STATE(3669)] = 111439,
  [SMALL_STATE(3670)] = 111457,
  [SMALL_STATE(3671)] = 111477,
  [SMALL_STATE(3672)] = 111495,
  [SMALL_STATE(3673)] = 111515,
  [SMALL_STATE(3674)] = 111537,
  [SMALL_STATE(3675)] = 111561,
  [SMALL_STATE(3676)] = 111581,
  [SMALL_STATE(3677)] = 111605,
  [SMALL_STATE(3678)] = 111625,
  [SMALL_STATE(3679)] = 111651,
  [SMALL_STATE(3680)] = 111675,
  [SMALL_STATE(3681)] = 111693,
  [SMALL_STATE(3682)] = 111717,
  [SMALL_STATE(3683)] = 111741,
  [SMALL_STATE(3684)] = 111763,
  [SMALL_STATE(3685)] = 111783,
  [SMALL_STATE(3686)] = 111803,
  [SMALL_STATE(3687)] = 111825,
  [SMALL_STATE(3688)] = 111847,
  [SMALL_STATE(3689)] = 111873,
  [SMALL_STATE(3690)] = 111899,
  [SMALL_STATE(3691)] = 111919,
  [SMALL_STATE(3692)] = 111945,
  [SMALL_STATE(3693)] = 111965,
  [SMALL_STATE(3694)] = 111986,
  [SMALL_STATE(3695)] = 112007,
  [SMALL_STATE(3696)] = 112028,
  [SMALL_STATE(3697)] = 112051,
  [SMALL_STATE(3698)] = 112072,
  [SMALL_STATE(3699)] = 112093,
  [SMALL_STATE(3700)] = 112114,
  [SMALL_STATE(3701)] = 112135,
  [SMALL_STATE(3702)] = 112158,
  [SMALL_STATE(3703)] = 112179,
  [SMALL_STATE(3704)] = 112200,
  [SMALL_STATE(3705)] = 112221,
  [SMALL_STATE(3706)] = 112242,
  [SMALL_STATE(3707)] = 112265,
  [SMALL_STATE(3708)] = 112286,
  [SMALL_STATE(3709)] = 112309,
  [SMALL_STATE(3710)] = 112330,
  [SMALL_STATE(3711)] = 112353,
  [SMALL_STATE(3712)] = 112374,
  [SMALL_STATE(3713)] = 112395,
  [SMALL_STATE(3714)] = 112418,
  [SMALL_STATE(3715)] = 112439,
  [SMALL_STATE(3716)] = 112460,
  [SMALL_STATE(3717)] = 112483,
  [SMALL_STATE(3718)] = 112504,
  [SMALL_STATE(3719)] = 112521,
  [SMALL_STATE(3720)] = 112542,
  [SMALL_STATE(3721)] = 112565,
  [SMALL_STATE(3722)] = 112586,
  [SMALL_STATE(3723)] = 112607,
  [SMALL_STATE(3724)] = 112624,
  [SMALL_STATE(3725)] = 112645,
  [SMALL_STATE(3726)] = 112668,
  [SMALL_STATE(3727)] = 112691,
  [SMALL_STATE(3728)] = 112712,
  [SMALL_STATE(3729)] = 112735,
  [SMALL_STATE(3730)] = 112756,
  [SMALL_STATE(3731)] = 112777,
  [SMALL_STATE(3732)] = 112800,
  [SMALL_STATE(3733)] = 112819,
  [SMALL_STATE(3734)] = 112842,
  [SMALL_STATE(3735)] = 112863,
  [SMALL_STATE(3736)] = 112884,
  [SMALL_STATE(3737)] = 112905,
  [SMALL_STATE(3738)] = 112926,
  [SMALL_STATE(3739)] = 112947,
  [SMALL_STATE(3740)] = 112970,
  [SMALL_STATE(3741)] = 112991,
  [SMALL_STATE(3742)] = 113012,
  [SMALL_STATE(3743)] = 113033,
  [SMALL_STATE(3744)] = 113056,
  [SMALL_STATE(3745)] = 113077,
  [SMALL_STATE(3746)] = 113098,
  [SMALL_STATE(3747)] = 113119,
  [SMALL_STATE(3748)] = 113142,
  [SMALL_STATE(3749)] = 113163,
  [SMALL_STATE(3750)] = 113184,
  [SMALL_STATE(3751)] = 113205,
  [SMALL_STATE(3752)] = 113226,
  [SMALL_STATE(3753)] = 113249,
  [SMALL_STATE(3754)] = 113270,
  [SMALL_STATE(3755)] = 113291,
  [SMALL_STATE(3756)] = 113312,
  [SMALL_STATE(3757)] = 113335,
  [SMALL_STATE(3758)] = 113354,
  [SMALL_STATE(3759)] = 113375,
  [SMALL_STATE(3760)] = 113394,
  [SMALL_STATE(3761)] = 113415,
  [SMALL_STATE(3762)] = 113436,
  [SMALL_STATE(3763)] = 113457,
  [SMALL_STATE(3764)] = 113478,
  [SMALL_STATE(3765)] = 113495,
  [SMALL_STATE(3766)] = 113516,
  [SMALL_STATE(3767)] = 113537,
  [SMALL_STATE(3768)] = 113558,
  [SMALL_STATE(3769)] = 113581,
  [SMALL_STATE(3770)] = 113602,
  [SMALL_STATE(3771)] = 113625,
  [SMALL_STATE(3772)] = 113648,
  [SMALL_STATE(3773)] = 113669,
  [SMALL_STATE(3774)] = 113690,
  [SMALL_STATE(3775)] = 113713,
  [SMALL_STATE(3776)] = 113734,
  [SMALL_STATE(3777)] = 113757,
  [SMALL_STATE(3778)] = 113778,
  [SMALL_STATE(3779)] = 113795,
  [SMALL_STATE(3780)] = 113818,
  [SMALL_STATE(3781)] = 113839,
  [SMALL_STATE(3782)] = 113860,
  [SMALL_STATE(3783)] = 113881,
  [SMALL_STATE(3784)] = 113902,
  [SMALL_STATE(3785)] = 113919,
  [SMALL_STATE(3786)] = 113942,
  [SMALL_STATE(3787)] = 113959,
  [SMALL_STATE(3788)] = 113980,
  [SMALL_STATE(3789)] = 114001,
  [SMALL_STATE(3790)] = 114022,
  [SMALL_STATE(3791)] = 114043,
  [SMALL_STATE(3792)] = 114064,
  [SMALL_STATE(3793)] = 114085,
  [SMALL_STATE(3794)] = 114106,
  [SMALL_STATE(3795)] = 114127,
  [SMALL_STATE(3796)] = 114148,
  [SMALL_STATE(3797)] = 114169,
  [SMALL_STATE(3798)] = 114192,
  [SMALL_STATE(3799)] = 114213,
  [SMALL_STATE(3800)] = 114234,
  [SMALL_STATE(3801)] = 114255,
  [SMALL_STATE(3802)] = 114274,
  [SMALL_STATE(3803)] = 114297,
  [SMALL_STATE(3804)] = 114318,
  [SMALL_STATE(3805)] = 114339,
  [SMALL_STATE(3806)] = 114360,
  [SMALL_STATE(3807)] = 114377,
  [SMALL_STATE(3808)] = 114398,
  [SMALL_STATE(3809)] = 114419,
  [SMALL_STATE(3810)] = 114442,
  [SMALL_STATE(3811)] = 114463,
  [SMALL_STATE(3812)] = 114486,
  [SMALL_STATE(3813)] = 114507,
  [SMALL_STATE(3814)] = 114528,
  [SMALL_STATE(3815)] = 114545,
  [SMALL_STATE(3816)] = 114568,
  [SMALL_STATE(3817)] = 114589,
  [SMALL_STATE(3818)] = 114610,
  [SMALL_STATE(3819)] = 114633,
  [SMALL_STATE(3820)] = 114654,
  [SMALL_STATE(3821)] = 114677,
  [SMALL_STATE(3822)] = 114698,
  [SMALL_STATE(3823)] = 114719,
  [SMALL_STATE(3824)] = 114740,
  [SMALL_STATE(3825)] = 114761,
  [SMALL_STATE(3826)] = 114778,
  [SMALL_STATE(3827)] = 114801,
  [SMALL_STATE(3828)] = 114822,
  [SMALL_STATE(3829)] = 114843,
  [SMALL_STATE(3830)] = 114864,
  [SMALL_STATE(3831)] = 114885,
  [SMALL_STATE(3832)] = 114906,
  [SMALL_STATE(3833)] = 114927,
  [SMALL_STATE(3834)] = 114948,
  [SMALL_STATE(3835)] = 114969,
  [SMALL_STATE(3836)] = 114990,
  [SMALL_STATE(3837)] = 115011,
  [SMALL_STATE(3838)] = 115032,
  [SMALL_STATE(3839)] = 115053,
  [SMALL_STATE(3840)] = 115076,
  [SMALL_STATE(3841)] = 115097,
  [SMALL_STATE(3842)] = 115118,
  [SMALL_STATE(3843)] = 115139,
  [SMALL_STATE(3844)] = 115155,
  [SMALL_STATE(3845)] = 115175,
  [SMALL_STATE(3846)] = 115195,
  [SMALL_STATE(3847)] = 115215,
  [SMALL_STATE(3848)] = 115235,
  [SMALL_STATE(3849)] = 115255,
  [SMALL_STATE(3850)] = 115275,
  [SMALL_STATE(3851)] = 115295,
  [SMALL_STATE(3852)] = 115315,
  [SMALL_STATE(3853)] = 115335,
  [SMALL_STATE(3854)] = 115355,
  [SMALL_STATE(3855)] = 115375,
  [SMALL_STATE(3856)] = 115395,
  [SMALL_STATE(3857)] = 115415,
  [SMALL_STATE(3858)] = 115435,
  [SMALL_STATE(3859)] = 115455,
  [SMALL_STATE(3860)] = 115475,
  [SMALL_STATE(3861)] = 115495,
  [SMALL_STATE(3862)] = 115515,
  [SMALL_STATE(3863)] = 115535,
  [SMALL_STATE(3864)] = 115555,
  [SMALL_STATE(3865)] = 115575,
  [SMALL_STATE(3866)] = 115595,
  [SMALL_STATE(3867)] = 115615,
  [SMALL_STATE(3868)] = 115635,
  [SMALL_STATE(3869)] = 115655,
  [SMALL_STATE(3870)] = 115675,
  [SMALL_STATE(3871)] = 115695,
  [SMALL_STATE(3872)] = 115715,
  [SMALL_STATE(3873)] = 115735,
  [SMALL_STATE(3874)] = 115755,
  [SMALL_STATE(3875)] = 115775,
  [SMALL_STATE(3876)] = 115795,
  [SMALL_STATE(3877)] = 115815,
  [SMALL_STATE(3878)] = 115835,
  [SMALL_STATE(3879)] = 115853,
  [SMALL_STATE(3880)] = 115873,
  [SMALL_STATE(3881)] = 115893,
  [SMALL_STATE(3882)] = 115913,
  [SMALL_STATE(3883)] = 115933,
  [SMALL_STATE(3884)] = 115953,
  [SMALL_STATE(3885)] = 115973,
  [SMALL_STATE(3886)] = 115991,
  [SMALL_STATE(3887)] = 116011,
  [SMALL_STATE(3888)] = 116031,
  [SMALL_STATE(3889)] = 116051,
  [SMALL_STATE(3890)] = 116069,
  [SMALL_STATE(3891)] = 116089,
  [SMALL_STATE(3892)] = 116109,
  [SMALL_STATE(3893)] = 116129,
  [SMALL_STATE(3894)] = 116149,
  [SMALL_STATE(3895)] = 116169,
  [SMALL_STATE(3896)] = 116189,
  [SMALL_STATE(3897)] = 116209,
  [SMALL_STATE(3898)] = 116229,
  [SMALL_STATE(3899)] = 116249,
  [SMALL_STATE(3900)] = 116269,
  [SMALL_STATE(3901)] = 116289,
  [SMALL_STATE(3902)] = 116309,
  [SMALL_STATE(3903)] = 116329,
  [SMALL_STATE(3904)] = 116349,
  [SMALL_STATE(3905)] = 116369,
  [SMALL_STATE(3906)] = 116389,
  [SMALL_STATE(3907)] = 116409,
  [SMALL_STATE(3908)] = 116429,
  [SMALL_STATE(3909)] = 116449,
  [SMALL_STATE(3910)] = 116469,
  [SMALL_STATE(3911)] = 116489,
  [SMALL_STATE(3912)] = 116509,
  [SMALL_STATE(3913)] = 116529,
  [SMALL_STATE(3914)] = 116547,
  [SMALL_STATE(3915)] = 116567,
  [SMALL_STATE(3916)] = 116587,
  [SMALL_STATE(3917)] = 116607,
  [SMALL_STATE(3918)] = 116627,
  [SMALL_STATE(3919)] = 116647,
  [SMALL_STATE(3920)] = 116667,
  [SMALL_STATE(3921)] = 116687,
  [SMALL_STATE(3922)] = 116707,
  [SMALL_STATE(3923)] = 116727,
  [SMALL_STATE(3924)] = 116747,
  [SMALL_STATE(3925)] = 116765,
  [SMALL_STATE(3926)] = 116785,
  [SMALL_STATE(3927)] = 116805,
  [SMALL_STATE(3928)] = 116825,
  [SMALL_STATE(3929)] = 116845,
  [SMALL_STATE(3930)] = 116865,
  [SMALL_STATE(3931)] = 116885,
  [SMALL_STATE(3932)] = 116905,
  [SMALL_STATE(3933)] = 116925,
  [SMALL_STATE(3934)] = 116945,
  [SMALL_STATE(3935)] = 116965,
  [SMALL_STATE(3936)] = 116985,
  [SMALL_STATE(3937)] = 117005,
  [SMALL_STATE(3938)] = 117025,
  [SMALL_STATE(3939)] = 117045,
  [SMALL_STATE(3940)] = 117065,
  [SMALL_STATE(3941)] = 117085,
  [SMALL_STATE(3942)] = 117105,
  [SMALL_STATE(3943)] = 117125,
  [SMALL_STATE(3944)] = 117145,
  [SMALL_STATE(3945)] = 117161,
  [SMALL_STATE(3946)] = 117181,
  [SMALL_STATE(3947)] = 117197,
  [SMALL_STATE(3948)] = 117217,
  [SMALL_STATE(3949)] = 117237,
  [SMALL_STATE(3950)] = 117257,
  [SMALL_STATE(3951)] = 117277,
  [SMALL_STATE(3952)] = 117297,
  [SMALL_STATE(3953)] = 117317,
  [SMALL_STATE(3954)] = 117335,
  [SMALL_STATE(3955)] = 117355,
  [SMALL_STATE(3956)] = 117375,
  [SMALL_STATE(3957)] = 117395,
  [SMALL_STATE(3958)] = 117411,
  [SMALL_STATE(3959)] = 117429,
  [SMALL_STATE(3960)] = 117447,
  [SMALL_STATE(3961)] = 117463,
  [SMALL_STATE(3962)] = 117483,
  [SMALL_STATE(3963)] = 117503,
  [SMALL_STATE(3964)] = 117519,
  [SMALL_STATE(3965)] = 117539,
  [SMALL_STATE(3966)] = 117559,
  [SMALL_STATE(3967)] = 117579,
  [SMALL_STATE(3968)] = 117599,
  [SMALL_STATE(3969)] = 117619,
  [SMALL_STATE(3970)] = 117637,
  [SMALL_STATE(3971)] = 117655,
  [SMALL_STATE(3972)] = 117671,
  [SMALL_STATE(3973)] = 117691,
  [SMALL_STATE(3974)] = 117711,
  [SMALL_STATE(3975)] = 117731,
  [SMALL_STATE(3976)] = 117749,
  [SMALL_STATE(3977)] = 117769,
  [SMALL_STATE(3978)] = 117789,
  [SMALL_STATE(3979)] = 117809,
  [SMALL_STATE(3980)] = 117829,
  [SMALL_STATE(3981)] = 117849,
  [SMALL_STATE(3982)] = 117865,
  [SMALL_STATE(3983)] = 117885,
  [SMALL_STATE(3984)] = 117901,
  [SMALL_STATE(3985)] = 117921,
  [SMALL_STATE(3986)] = 117941,
  [SMALL_STATE(3987)] = 117961,
  [SMALL_STATE(3988)] = 117981,
  [SMALL_STATE(3989)] = 118001,
  [SMALL_STATE(3990)] = 118021,
  [SMALL_STATE(3991)] = 118041,
  [SMALL_STATE(3992)] = 118061,
  [SMALL_STATE(3993)] = 118081,
  [SMALL_STATE(3994)] = 118101,
  [SMALL_STATE(3995)] = 118121,
  [SMALL_STATE(3996)] = 118141,
  [SMALL_STATE(3997)] = 118161,
  [SMALL_STATE(3998)] = 118181,
  [SMALL_STATE(3999)] = 118201,
  [SMALL_STATE(4000)] = 118221,
  [SMALL_STATE(4001)] = 118241,
  [SMALL_STATE(4002)] = 118261,
  [SMALL_STATE(4003)] = 118277,
  [SMALL_STATE(4004)] = 118295,
  [SMALL_STATE(4005)] = 118315,
  [SMALL_STATE(4006)] = 118331,
  [SMALL_STATE(4007)] = 118351,
  [SMALL_STATE(4008)] = 118371,
  [SMALL_STATE(4009)] = 118391,
  [SMALL_STATE(4010)] = 118411,
  [SMALL_STATE(4011)] = 118429,
  [SMALL_STATE(4012)] = 118447,
  [SMALL_STATE(4013)] = 118463,
  [SMALL_STATE(4014)] = 118483,
  [SMALL_STATE(4015)] = 118503,
  [SMALL_STATE(4016)] = 118523,
  [SMALL_STATE(4017)] = 118539,
  [SMALL_STATE(4018)] = 118559,
  [SMALL_STATE(4019)] = 118577,
  [SMALL_STATE(4020)] = 118597,
  [SMALL_STATE(4021)] = 118617,
  [SMALL_STATE(4022)] = 118635,
  [SMALL_STATE(4023)] = 118651,
  [SMALL_STATE(4024)] = 118669,
  [SMALL_STATE(4025)] = 118689,
  [SMALL_STATE(4026)] = 118707,
  [SMALL_STATE(4027)] = 118727,
  [SMALL_STATE(4028)] = 118747,
  [SMALL_STATE(4029)] = 118767,
  [SMALL_STATE(4030)] = 118787,
  [SMALL_STATE(4031)] = 118807,
  [SMALL_STATE(4032)] = 118827,
  [SMALL_STATE(4033)] = 118847,
  [SMALL_STATE(4034)] = 118867,
  [SMALL_STATE(4035)] = 118887,
  [SMALL_STATE(4036)] = 118907,
  [SMALL_STATE(4037)] = 118927,
  [SMALL_STATE(4038)] = 118947,
  [SMALL_STATE(4039)] = 118967,
  [SMALL_STATE(4040)] = 118987,
  [SMALL_STATE(4041)] = 119007,
  [SMALL_STATE(4042)] = 119027,
  [SMALL_STATE(4043)] = 119047,
  [SMALL_STATE(4044)] = 119067,
  [SMALL_STATE(4045)] = 119087,
  [SMALL_STATE(4046)] = 119107,
  [SMALL_STATE(4047)] = 119127,
  [SMALL_STATE(4048)] = 119147,
  [SMALL_STATE(4049)] = 119167,
  [SMALL_STATE(4050)] = 119187,
  [SMALL_STATE(4051)] = 119205,
  [SMALL_STATE(4052)] = 119225,
  [SMALL_STATE(4053)] = 119245,
  [SMALL_STATE(4054)] = 119265,
  [SMALL_STATE(4055)] = 119281,
  [SMALL_STATE(4056)] = 119301,
  [SMALL_STATE(4057)] = 119321,
  [SMALL_STATE(4058)] = 119341,
  [SMALL_STATE(4059)] = 119361,
  [SMALL_STATE(4060)] = 119381,
  [SMALL_STATE(4061)] = 119401,
  [SMALL_STATE(4062)] = 119421,
  [SMALL_STATE(4063)] = 119441,
  [SMALL_STATE(4064)] = 119461,
  [SMALL_STATE(4065)] = 119481,
  [SMALL_STATE(4066)] = 119501,
  [SMALL_STATE(4067)] = 119521,
  [SMALL_STATE(4068)] = 119541,
  [SMALL_STATE(4069)] = 119561,
  [SMALL_STATE(4070)] = 119581,
  [SMALL_STATE(4071)] = 119601,
  [SMALL_STATE(4072)] = 119621,
  [SMALL_STATE(4073)] = 119641,
  [SMALL_STATE(4074)] = 119661,
  [SMALL_STATE(4075)] = 119681,
  [SMALL_STATE(4076)] = 119701,
  [SMALL_STATE(4077)] = 119721,
  [SMALL_STATE(4078)] = 119739,
  [SMALL_STATE(4079)] = 119759,
  [SMALL_STATE(4080)] = 119779,
  [SMALL_STATE(4081)] = 119799,
  [SMALL_STATE(4082)] = 119819,
  [SMALL_STATE(4083)] = 119839,
  [SMALL_STATE(4084)] = 119859,
  [SMALL_STATE(4085)] = 119879,
  [SMALL_STATE(4086)] = 119899,
  [SMALL_STATE(4087)] = 119919,
  [SMALL_STATE(4088)] = 119939,
  [SMALL_STATE(4089)] = 119959,
  [SMALL_STATE(4090)] = 119979,
  [SMALL_STATE(4091)] = 119999,
  [SMALL_STATE(4092)] = 120019,
  [SMALL_STATE(4093)] = 120039,
  [SMALL_STATE(4094)] = 120059,
  [SMALL_STATE(4095)] = 120076,
  [SMALL_STATE(4096)] = 120093,
  [SMALL_STATE(4097)] = 120108,
  [SMALL_STATE(4098)] = 120125,
  [SMALL_STATE(4099)] = 120142,
  [SMALL_STATE(4100)] = 120159,
  [SMALL_STATE(4101)] = 120176,
  [SMALL_STATE(4102)] = 120193,
  [SMALL_STATE(4103)] = 120210,
  [SMALL_STATE(4104)] = 120227,
  [SMALL_STATE(4105)] = 120244,
  [SMALL_STATE(4106)] = 120261,
  [SMALL_STATE(4107)] = 120278,
  [SMALL_STATE(4108)] = 120295,
  [SMALL_STATE(4109)] = 120312,
  [SMALL_STATE(4110)] = 120329,
  [SMALL_STATE(4111)] = 120346,
  [SMALL_STATE(4112)] = 120363,
  [SMALL_STATE(4113)] = 120380,
  [SMALL_STATE(4114)] = 120397,
  [SMALL_STATE(4115)] = 120414,
  [SMALL_STATE(4116)] = 120431,
  [SMALL_STATE(4117)] = 120446,
  [SMALL_STATE(4118)] = 120463,
  [SMALL_STATE(4119)] = 120480,
  [SMALL_STATE(4120)] = 120497,
  [SMALL_STATE(4121)] = 120514,
  [SMALL_STATE(4122)] = 120531,
  [SMALL_STATE(4123)] = 120548,
  [SMALL_STATE(4124)] = 120565,
  [SMALL_STATE(4125)] = 120582,
  [SMALL_STATE(4126)] = 120599,
  [SMALL_STATE(4127)] = 120616,
  [SMALL_STATE(4128)] = 120633,
  [SMALL_STATE(4129)] = 120650,
  [SMALL_STATE(4130)] = 120667,
  [SMALL_STATE(4131)] = 120684,
  [SMALL_STATE(4132)] = 120701,
  [SMALL_STATE(4133)] = 120718,
  [SMALL_STATE(4134)] = 120735,
  [SMALL_STATE(4135)] = 120752,
  [SMALL_STATE(4136)] = 120769,
  [SMALL_STATE(4137)] = 120786,
  [SMALL_STATE(4138)] = 120803,
  [SMALL_STATE(4139)] = 120820,
  [SMALL_STATE(4140)] = 120837,
  [SMALL_STATE(4141)] = 120854,
  [SMALL_STATE(4142)] = 120871,
  [SMALL_STATE(4143)] = 120888,
  [SMALL_STATE(4144)] = 120905,
  [SMALL_STATE(4145)] = 120922,
  [SMALL_STATE(4146)] = 120939,
  [SMALL_STATE(4147)] = 120956,
  [SMALL_STATE(4148)] = 120973,
  [SMALL_STATE(4149)] = 120988,
  [SMALL_STATE(4150)] = 121005,
  [SMALL_STATE(4151)] = 121020,
  [SMALL_STATE(4152)] = 121037,
  [SMALL_STATE(4153)] = 121054,
  [SMALL_STATE(4154)] = 121071,
  [SMALL_STATE(4155)] = 121088,
  [SMALL_STATE(4156)] = 121105,
  [SMALL_STATE(4157)] = 121122,
  [SMALL_STATE(4158)] = 121139,
  [SMALL_STATE(4159)] = 121156,
  [SMALL_STATE(4160)] = 121173,
  [SMALL_STATE(4161)] = 121188,
  [SMALL_STATE(4162)] = 121205,
  [SMALL_STATE(4163)] = 121222,
  [SMALL_STATE(4164)] = 121239,
  [SMALL_STATE(4165)] = 121254,
  [SMALL_STATE(4166)] = 121271,
  [SMALL_STATE(4167)] = 121288,
  [SMALL_STATE(4168)] = 121305,
  [SMALL_STATE(4169)] = 121322,
  [SMALL_STATE(4170)] = 121339,
  [SMALL_STATE(4171)] = 121356,
  [SMALL_STATE(4172)] = 121373,
  [SMALL_STATE(4173)] = 121390,
  [SMALL_STATE(4174)] = 121407,
  [SMALL_STATE(4175)] = 121424,
  [SMALL_STATE(4176)] = 121441,
  [SMALL_STATE(4177)] = 121458,
  [SMALL_STATE(4178)] = 121475,
  [SMALL_STATE(4179)] = 121492,
  [SMALL_STATE(4180)] = 121509,
  [SMALL_STATE(4181)] = 121526,
  [SMALL_STATE(4182)] = 121543,
  [SMALL_STATE(4183)] = 121560,
  [SMALL_STATE(4184)] = 121577,
  [SMALL_STATE(4185)] = 121594,
  [SMALL_STATE(4186)] = 121611,
  [SMALL_STATE(4187)] = 121628,
  [SMALL_STATE(4188)] = 121645,
  [SMALL_STATE(4189)] = 121662,
  [SMALL_STATE(4190)] = 121679,
  [SMALL_STATE(4191)] = 121696,
  [SMALL_STATE(4192)] = 121713,
  [SMALL_STATE(4193)] = 121730,
  [SMALL_STATE(4194)] = 121745,
  [SMALL_STATE(4195)] = 121762,
  [SMALL_STATE(4196)] = 121777,
  [SMALL_STATE(4197)] = 121794,
  [SMALL_STATE(4198)] = 121811,
  [SMALL_STATE(4199)] = 121826,
  [SMALL_STATE(4200)] = 121841,
  [SMALL_STATE(4201)] = 121858,
  [SMALL_STATE(4202)] = 121875,
  [SMALL_STATE(4203)] = 121892,
  [SMALL_STATE(4204)] = 121909,
  [SMALL_STATE(4205)] = 121926,
  [SMALL_STATE(4206)] = 121941,
  [SMALL_STATE(4207)] = 121958,
  [SMALL_STATE(4208)] = 121973,
  [SMALL_STATE(4209)] = 121988,
  [SMALL_STATE(4210)] = 122005,
  [SMALL_STATE(4211)] = 122022,
  [SMALL_STATE(4212)] = 122039,
  [SMALL_STATE(4213)] = 122056,
  [SMALL_STATE(4214)] = 122073,
  [SMALL_STATE(4215)] = 122090,
  [SMALL_STATE(4216)] = 122107,
  [SMALL_STATE(4217)] = 122124,
  [SMALL_STATE(4218)] = 122139,
  [SMALL_STATE(4219)] = 122156,
  [SMALL_STATE(4220)] = 122173,
  [SMALL_STATE(4221)] = 122190,
  [SMALL_STATE(4222)] = 122207,
  [SMALL_STATE(4223)] = 122224,
  [SMALL_STATE(4224)] = 122239,
  [SMALL_STATE(4225)] = 122256,
  [SMALL_STATE(4226)] = 122273,
  [SMALL_STATE(4227)] = 122290,
  [SMALL_STATE(4228)] = 122307,
  [SMALL_STATE(4229)] = 122324,
  [SMALL_STATE(4230)] = 122341,
  [SMALL_STATE(4231)] = 122358,
  [SMALL_STATE(4232)] = 122375,
  [SMALL_STATE(4233)] = 122390,
  [SMALL_STATE(4234)] = 122407,
  [SMALL_STATE(4235)] = 122422,
  [SMALL_STATE(4236)] = 122439,
  [SMALL_STATE(4237)] = 122456,
  [SMALL_STATE(4238)] = 122471,
  [SMALL_STATE(4239)] = 122488,
  [SMALL_STATE(4240)] = 122505,
  [SMALL_STATE(4241)] = 122522,
  [SMALL_STATE(4242)] = 122539,
  [SMALL_STATE(4243)] = 122554,
  [SMALL_STATE(4244)] = 122571,
  [SMALL_STATE(4245)] = 122586,
  [SMALL_STATE(4246)] = 122603,
  [SMALL_STATE(4247)] = 122620,
  [SMALL_STATE(4248)] = 122635,
  [SMALL_STATE(4249)] = 122652,
  [SMALL_STATE(4250)] = 122669,
  [SMALL_STATE(4251)] = 122686,
  [SMALL_STATE(4252)] = 122703,
  [SMALL_STATE(4253)] = 122720,
  [SMALL_STATE(4254)] = 122737,
  [SMALL_STATE(4255)] = 122754,
  [SMALL_STATE(4256)] = 122771,
  [SMALL_STATE(4257)] = 122788,
  [SMALL_STATE(4258)] = 122803,
  [SMALL_STATE(4259)] = 122820,
  [SMALL_STATE(4260)] = 122837,
  [SMALL_STATE(4261)] = 122854,
  [SMALL_STATE(4262)] = 122869,
  [SMALL_STATE(4263)] = 122886,
  [SMALL_STATE(4264)] = 122903,
  [SMALL_STATE(4265)] = 122920,
  [SMALL_STATE(4266)] = 122937,
  [SMALL_STATE(4267)] = 122954,
  [SMALL_STATE(4268)] = 122971,
  [SMALL_STATE(4269)] = 122986,
  [SMALL_STATE(4270)] = 123001,
  [SMALL_STATE(4271)] = 123018,
  [SMALL_STATE(4272)] = 123035,
  [SMALL_STATE(4273)] = 123052,
  [SMALL_STATE(4274)] = 123069,
  [SMALL_STATE(4275)] = 123084,
  [SMALL_STATE(4276)] = 123101,
  [SMALL_STATE(4277)] = 123116,
  [SMALL_STATE(4278)] = 123133,
  [SMALL_STATE(4279)] = 123150,
  [SMALL_STATE(4280)] = 123167,
  [SMALL_STATE(4281)] = 123184,
  [SMALL_STATE(4282)] = 123201,
  [SMALL_STATE(4283)] = 123218,
  [SMALL_STATE(4284)] = 123235,
  [SMALL_STATE(4285)] = 123252,
  [SMALL_STATE(4286)] = 123267,
  [SMALL_STATE(4287)] = 123282,
  [SMALL_STATE(4288)] = 123299,
  [SMALL_STATE(4289)] = 123316,
  [SMALL_STATE(4290)] = 123333,
  [SMALL_STATE(4291)] = 123350,
  [SMALL_STATE(4292)] = 123367,
  [SMALL_STATE(4293)] = 123384,
  [SMALL_STATE(4294)] = 123401,
  [SMALL_STATE(4295)] = 123418,
  [SMALL_STATE(4296)] = 123435,
  [SMALL_STATE(4297)] = 123452,
  [SMALL_STATE(4298)] = 123469,
  [SMALL_STATE(4299)] = 123486,
  [SMALL_STATE(4300)] = 123503,
  [SMALL_STATE(4301)] = 123520,
  [SMALL_STATE(4302)] = 123537,
  [SMALL_STATE(4303)] = 123554,
  [SMALL_STATE(4304)] = 123571,
  [SMALL_STATE(4305)] = 123588,
  [SMALL_STATE(4306)] = 123605,
  [SMALL_STATE(4307)] = 123622,
  [SMALL_STATE(4308)] = 123639,
  [SMALL_STATE(4309)] = 123656,
  [SMALL_STATE(4310)] = 123673,
  [SMALL_STATE(4311)] = 123690,
  [SMALL_STATE(4312)] = 123707,
  [SMALL_STATE(4313)] = 123724,
  [SMALL_STATE(4314)] = 123741,
  [SMALL_STATE(4315)] = 123758,
  [SMALL_STATE(4316)] = 123775,
  [SMALL_STATE(4317)] = 123792,
  [SMALL_STATE(4318)] = 123809,
  [SMALL_STATE(4319)] = 123826,
  [SMALL_STATE(4320)] = 123843,
  [SMALL_STATE(4321)] = 123858,
  [SMALL_STATE(4322)] = 123875,
  [SMALL_STATE(4323)] = 123892,
  [SMALL_STATE(4324)] = 123909,
  [SMALL_STATE(4325)] = 123926,
  [SMALL_STATE(4326)] = 123943,
  [SMALL_STATE(4327)] = 123960,
  [SMALL_STATE(4328)] = 123977,
  [SMALL_STATE(4329)] = 123994,
  [SMALL_STATE(4330)] = 124011,
  [SMALL_STATE(4331)] = 124028,
  [SMALL_STATE(4332)] = 124045,
  [SMALL_STATE(4333)] = 124062,
  [SMALL_STATE(4334)] = 124079,
  [SMALL_STATE(4335)] = 124096,
  [SMALL_STATE(4336)] = 124113,
  [SMALL_STATE(4337)] = 124130,
  [SMALL_STATE(4338)] = 124147,
  [SMALL_STATE(4339)] = 124164,
  [SMALL_STATE(4340)] = 124181,
  [SMALL_STATE(4341)] = 124198,
  [SMALL_STATE(4342)] = 124215,
  [SMALL_STATE(4343)] = 124232,
  [SMALL_STATE(4344)] = 124249,
  [SMALL_STATE(4345)] = 124266,
  [SMALL_STATE(4346)] = 124281,
  [SMALL_STATE(4347)] = 124298,
  [SMALL_STATE(4348)] = 124315,
  [SMALL_STATE(4349)] = 124332,
  [SMALL_STATE(4350)] = 124349,
  [SMALL_STATE(4351)] = 124366,
  [SMALL_STATE(4352)] = 124383,
  [SMALL_STATE(4353)] = 124400,
  [SMALL_STATE(4354)] = 124417,
  [SMALL_STATE(4355)] = 124434,
  [SMALL_STATE(4356)] = 124451,
  [SMALL_STATE(4357)] = 124468,
  [SMALL_STATE(4358)] = 124485,
  [SMALL_STATE(4359)] = 124502,
  [SMALL_STATE(4360)] = 124519,
  [SMALL_STATE(4361)] = 124536,
  [SMALL_STATE(4362)] = 124553,
  [SMALL_STATE(4363)] = 124570,
  [SMALL_STATE(4364)] = 124587,
  [SMALL_STATE(4365)] = 124604,
  [SMALL_STATE(4366)] = 124621,
  [SMALL_STATE(4367)] = 124638,
  [SMALL_STATE(4368)] = 124655,
  [SMALL_STATE(4369)] = 124672,
  [SMALL_STATE(4370)] = 124689,
  [SMALL_STATE(4371)] = 124706,
  [SMALL_STATE(4372)] = 124723,
  [SMALL_STATE(4373)] = 124740,
  [SMALL_STATE(4374)] = 124757,
  [SMALL_STATE(4375)] = 124774,
  [SMALL_STATE(4376)] = 124791,
  [SMALL_STATE(4377)] = 124808,
  [SMALL_STATE(4378)] = 124825,
  [SMALL_STATE(4379)] = 124842,
  [SMALL_STATE(4380)] = 124857,
  [SMALL_STATE(4381)] = 124874,
  [SMALL_STATE(4382)] = 124891,
  [SMALL_STATE(4383)] = 124908,
  [SMALL_STATE(4384)] = 124925,
  [SMALL_STATE(4385)] = 124942,
  [SMALL_STATE(4386)] = 124959,
  [SMALL_STATE(4387)] = 124974,
  [SMALL_STATE(4388)] = 124991,
  [SMALL_STATE(4389)] = 125008,
  [SMALL_STATE(4390)] = 125025,
  [SMALL_STATE(4391)] = 125042,
  [SMALL_STATE(4392)] = 125059,
  [SMALL_STATE(4393)] = 125076,
  [SMALL_STATE(4394)] = 125093,
  [SMALL_STATE(4395)] = 125110,
  [SMALL_STATE(4396)] = 125127,
  [SMALL_STATE(4397)] = 125144,
  [SMALL_STATE(4398)] = 125161,
  [SMALL_STATE(4399)] = 125178,
  [SMALL_STATE(4400)] = 125195,
  [SMALL_STATE(4401)] = 125212,
  [SMALL_STATE(4402)] = 125229,
  [SMALL_STATE(4403)] = 125246,
  [SMALL_STATE(4404)] = 125263,
  [SMALL_STATE(4405)] = 125280,
  [SMALL_STATE(4406)] = 125297,
  [SMALL_STATE(4407)] = 125314,
  [SMALL_STATE(4408)] = 125331,
  [SMALL_STATE(4409)] = 125348,
  [SMALL_STATE(4410)] = 125365,
  [SMALL_STATE(4411)] = 125382,
  [SMALL_STATE(4412)] = 125399,
  [SMALL_STATE(4413)] = 125416,
  [SMALL_STATE(4414)] = 125433,
  [SMALL_STATE(4415)] = 125447,
  [SMALL_STATE(4416)] = 125461,
  [SMALL_STATE(4417)] = 125475,
  [SMALL_STATE(4418)] = 125489,
  [SMALL_STATE(4419)] = 125503,
  [SMALL_STATE(4420)] = 125517,
  [SMALL_STATE(4421)] = 125531,
  [SMALL_STATE(4422)] = 125545,
  [SMALL_STATE(4423)] = 125559,
  [SMALL_STATE(4424)] = 125573,
  [SMALL_STATE(4425)] = 125587,
  [SMALL_STATE(4426)] = 125601,
  [SMALL_STATE(4427)] = 125615,
  [SMALL_STATE(4428)] = 125629,
  [SMALL_STATE(4429)] = 125643,
  [SMALL_STATE(4430)] = 125657,
  [SMALL_STATE(4431)] = 125671,
  [SMALL_STATE(4432)] = 125685,
  [SMALL_STATE(4433)] = 125699,
  [SMALL_STATE(4434)] = 125713,
  [SMALL_STATE(4435)] = 125727,
  [SMALL_STATE(4436)] = 125741,
  [SMALL_STATE(4437)] = 125755,
  [SMALL_STATE(4438)] = 125769,
  [SMALL_STATE(4439)] = 125783,
  [SMALL_STATE(4440)] = 125797,
  [SMALL_STATE(4441)] = 125811,
  [SMALL_STATE(4442)] = 125825,
  [SMALL_STATE(4443)] = 125839,
  [SMALL_STATE(4444)] = 125853,
  [SMALL_STATE(4445)] = 125867,
  [SMALL_STATE(4446)] = 125881,
  [SMALL_STATE(4447)] = 125895,
  [SMALL_STATE(4448)] = 125909,
  [SMALL_STATE(4449)] = 125923,
  [SMALL_STATE(4450)] = 125937,
  [SMALL_STATE(4451)] = 125951,
  [SMALL_STATE(4452)] = 125965,
  [SMALL_STATE(4453)] = 125979,
  [SMALL_STATE(4454)] = 125993,
  [SMALL_STATE(4455)] = 126007,
  [SMALL_STATE(4456)] = 126021,
  [SMALL_STATE(4457)] = 126035,
  [SMALL_STATE(4458)] = 126049,
  [SMALL_STATE(4459)] = 126063,
  [SMALL_STATE(4460)] = 126077,
  [SMALL_STATE(4461)] = 126091,
  [SMALL_STATE(4462)] = 126105,
  [SMALL_STATE(4463)] = 126119,
  [SMALL_STATE(4464)] = 126133,
  [SMALL_STATE(4465)] = 126147,
  [SMALL_STATE(4466)] = 126161,
  [SMALL_STATE(4467)] = 126175,
  [SMALL_STATE(4468)] = 126189,
  [SMALL_STATE(4469)] = 126203,
  [SMALL_STATE(4470)] = 126217,
  [SMALL_STATE(4471)] = 126231,
  [SMALL_STATE(4472)] = 126245,
  [SMALL_STATE(4473)] = 126259,
  [SMALL_STATE(4474)] = 126273,
  [SMALL_STATE(4475)] = 126287,
  [SMALL_STATE(4476)] = 126301,
  [SMALL_STATE(4477)] = 126315,
  [SMALL_STATE(4478)] = 126329,
  [SMALL_STATE(4479)] = 126343,
  [SMALL_STATE(4480)] = 126357,
  [SMALL_STATE(4481)] = 126371,
  [SMALL_STATE(4482)] = 126385,
  [SMALL_STATE(4483)] = 126399,
  [SMALL_STATE(4484)] = 126413,
  [SMALL_STATE(4485)] = 126427,
  [SMALL_STATE(4486)] = 126441,
  [SMALL_STATE(4487)] = 126455,
  [SMALL_STATE(4488)] = 126469,
  [SMALL_STATE(4489)] = 126483,
  [SMALL_STATE(4490)] = 126497,
  [SMALL_STATE(4491)] = 126511,
  [SMALL_STATE(4492)] = 126525,
  [SMALL_STATE(4493)] = 126539,
  [SMALL_STATE(4494)] = 126553,
  [SMALL_STATE(4495)] = 126567,
  [SMALL_STATE(4496)] = 126581,
  [SMALL_STATE(4497)] = 126595,
  [SMALL_STATE(4498)] = 126609,
  [SMALL_STATE(4499)] = 126623,
  [SMALL_STATE(4500)] = 126637,
  [SMALL_STATE(4501)] = 126651,
  [SMALL_STATE(4502)] = 126665,
  [SMALL_STATE(4503)] = 126679,
  [SMALL_STATE(4504)] = 126693,
  [SMALL_STATE(4505)] = 126707,
  [SMALL_STATE(4506)] = 126721,
  [SMALL_STATE(4507)] = 126735,
  [SMALL_STATE(4508)] = 126749,
  [SMALL_STATE(4509)] = 126763,
  [SMALL_STATE(4510)] = 126777,
  [SMALL_STATE(4511)] = 126791,
  [SMALL_STATE(4512)] = 126805,
  [SMALL_STATE(4513)] = 126819,
  [SMALL_STATE(4514)] = 126833,
  [SMALL_STATE(4515)] = 126847,
  [SMALL_STATE(4516)] = 126861,
  [SMALL_STATE(4517)] = 126875,
  [SMALL_STATE(4518)] = 126889,
  [SMALL_STATE(4519)] = 126903,
  [SMALL_STATE(4520)] = 126917,
  [SMALL_STATE(4521)] = 126931,
  [SMALL_STATE(4522)] = 126945,
  [SMALL_STATE(4523)] = 126959,
  [SMALL_STATE(4524)] = 126973,
  [SMALL_STATE(4525)] = 126987,
  [SMALL_STATE(4526)] = 127001,
  [SMALL_STATE(4527)] = 127015,
  [SMALL_STATE(4528)] = 127029,
  [SMALL_STATE(4529)] = 127043,
  [SMALL_STATE(4530)] = 127057,
  [SMALL_STATE(4531)] = 127071,
  [SMALL_STATE(4532)] = 127085,
  [SMALL_STATE(4533)] = 127099,
  [SMALL_STATE(4534)] = 127113,
  [SMALL_STATE(4535)] = 127127,
  [SMALL_STATE(4536)] = 127141,
  [SMALL_STATE(4537)] = 127155,
  [SMALL_STATE(4538)] = 127169,
  [SMALL_STATE(4539)] = 127183,
  [SMALL_STATE(4540)] = 127197,
  [SMALL_STATE(4541)] = 127211,
  [SMALL_STATE(4542)] = 127225,
  [SMALL_STATE(4543)] = 127239,
  [SMALL_STATE(4544)] = 127253,
  [SMALL_STATE(4545)] = 127267,
  [SMALL_STATE(4546)] = 127281,
  [SMALL_STATE(4547)] = 127295,
  [SMALL_STATE(4548)] = 127309,
  [SMALL_STATE(4549)] = 127323,
  [SMALL_STATE(4550)] = 127337,
  [SMALL_STATE(4551)] = 127351,
  [SMALL_STATE(4552)] = 127365,
  [SMALL_STATE(4553)] = 127379,
  [SMALL_STATE(4554)] = 127393,
  [SMALL_STATE(4555)] = 127407,
  [SMALL_STATE(4556)] = 127421,
  [SMALL_STATE(4557)] = 127435,
  [SMALL_STATE(4558)] = 127449,
  [SMALL_STATE(4559)] = 127463,
  [SMALL_STATE(4560)] = 127477,
  [SMALL_STATE(4561)] = 127491,
  [SMALL_STATE(4562)] = 127505,
  [SMALL_STATE(4563)] = 127519,
  [SMALL_STATE(4564)] = 127533,
  [SMALL_STATE(4565)] = 127547,
  [SMALL_STATE(4566)] = 127561,
  [SMALL_STATE(4567)] = 127575,
  [SMALL_STATE(4568)] = 127589,
  [SMALL_STATE(4569)] = 127603,
  [SMALL_STATE(4570)] = 127617,
  [SMALL_STATE(4571)] = 127631,
  [SMALL_STATE(4572)] = 127645,
  [SMALL_STATE(4573)] = 127659,
  [SMALL_STATE(4574)] = 127673,
  [SMALL_STATE(4575)] = 127687,
  [SMALL_STATE(4576)] = 127701,
  [SMALL_STATE(4577)] = 127715,
  [SMALL_STATE(4578)] = 127729,
  [SMALL_STATE(4579)] = 127743,
  [SMALL_STATE(4580)] = 127757,
  [SMALL_STATE(4581)] = 127771,
  [SMALL_STATE(4582)] = 127785,
  [SMALL_STATE(4583)] = 127799,
  [SMALL_STATE(4584)] = 127813,
  [SMALL_STATE(4585)] = 127827,
  [SMALL_STATE(4586)] = 127841,
  [SMALL_STATE(4587)] = 127855,
  [SMALL_STATE(4588)] = 127869,
  [SMALL_STATE(4589)] = 127883,
  [SMALL_STATE(4590)] = 127897,
  [SMALL_STATE(4591)] = 127911,
  [SMALL_STATE(4592)] = 127925,
  [SMALL_STATE(4593)] = 127939,
  [SMALL_STATE(4594)] = 127953,
  [SMALL_STATE(4595)] = 127967,
  [SMALL_STATE(4596)] = 127981,
  [SMALL_STATE(4597)] = 127995,
  [SMALL_STATE(4598)] = 128009,
  [SMALL_STATE(4599)] = 128023,
  [SMALL_STATE(4600)] = 128037,
  [SMALL_STATE(4601)] = 128051,
  [SMALL_STATE(4602)] = 128065,
  [SMALL_STATE(4603)] = 128079,
  [SMALL_STATE(4604)] = 128093,
  [SMALL_STATE(4605)] = 128107,
  [SMALL_STATE(4606)] = 128121,
  [SMALL_STATE(4607)] = 128135,
  [SMALL_STATE(4608)] = 128149,
  [SMALL_STATE(4609)] = 128163,
  [SMALL_STATE(4610)] = 128177,
  [SMALL_STATE(4611)] = 128191,
  [SMALL_STATE(4612)] = 128205,
  [SMALL_STATE(4613)] = 128219,
  [SMALL_STATE(4614)] = 128233,
  [SMALL_STATE(4615)] = 128247,
  [SMALL_STATE(4616)] = 128261,
  [SMALL_STATE(4617)] = 128275,
  [SMALL_STATE(4618)] = 128289,
  [SMALL_STATE(4619)] = 128303,
  [SMALL_STATE(4620)] = 128317,
  [SMALL_STATE(4621)] = 128331,
  [SMALL_STATE(4622)] = 128345,
  [SMALL_STATE(4623)] = 128359,
  [SMALL_STATE(4624)] = 128373,
  [SMALL_STATE(4625)] = 128387,
  [SMALL_STATE(4626)] = 128401,
  [SMALL_STATE(4627)] = 128415,
  [SMALL_STATE(4628)] = 128429,
  [SMALL_STATE(4629)] = 128443,
  [SMALL_STATE(4630)] = 128457,
  [SMALL_STATE(4631)] = 128471,
  [SMALL_STATE(4632)] = 128485,
  [SMALL_STATE(4633)] = 128499,
  [SMALL_STATE(4634)] = 128513,
  [SMALL_STATE(4635)] = 128527,
  [SMALL_STATE(4636)] = 128541,
  [SMALL_STATE(4637)] = 128555,
  [SMALL_STATE(4638)] = 128569,
  [SMALL_STATE(4639)] = 128583,
  [SMALL_STATE(4640)] = 128597,
  [SMALL_STATE(4641)] = 128611,
  [SMALL_STATE(4642)] = 128625,
  [SMALL_STATE(4643)] = 128639,
  [SMALL_STATE(4644)] = 128653,
  [SMALL_STATE(4645)] = 128667,
  [SMALL_STATE(4646)] = 128681,
  [SMALL_STATE(4647)] = 128695,
  [SMALL_STATE(4648)] = 128709,
  [SMALL_STATE(4649)] = 128723,
  [SMALL_STATE(4650)] = 128737,
  [SMALL_STATE(4651)] = 128751,
  [SMALL_STATE(4652)] = 128765,
  [SMALL_STATE(4653)] = 128779,
  [SMALL_STATE(4654)] = 128793,
  [SMALL_STATE(4655)] = 128807,
  [SMALL_STATE(4656)] = 128821,
  [SMALL_STATE(4657)] = 128835,
  [SMALL_STATE(4658)] = 128849,
  [SMALL_STATE(4659)] = 128863,
  [SMALL_STATE(4660)] = 128877,
  [SMALL_STATE(4661)] = 128891,
  [SMALL_STATE(4662)] = 128905,
  [SMALL_STATE(4663)] = 128919,
  [SMALL_STATE(4664)] = 128933,
  [SMALL_STATE(4665)] = 128947,
  [SMALL_STATE(4666)] = 128961,
  [SMALL_STATE(4667)] = 128975,
  [SMALL_STATE(4668)] = 128989,
  [SMALL_STATE(4669)] = 129003,
  [SMALL_STATE(4670)] = 129017,
  [SMALL_STATE(4671)] = 129031,
  [SMALL_STATE(4672)] = 129045,
  [SMALL_STATE(4673)] = 129059,
  [SMALL_STATE(4674)] = 129073,
  [SMALL_STATE(4675)] = 129087,
  [SMALL_STATE(4676)] = 129101,
  [SMALL_STATE(4677)] = 129115,
  [SMALL_STATE(4678)] = 129129,
  [SMALL_STATE(4679)] = 129143,
  [SMALL_STATE(4680)] = 129157,
  [SMALL_STATE(4681)] = 129171,
  [SMALL_STATE(4682)] = 129185,
  [SMALL_STATE(4683)] = 129199,
  [SMALL_STATE(4684)] = 129213,
  [SMALL_STATE(4685)] = 129227,
  [SMALL_STATE(4686)] = 129241,
  [SMALL_STATE(4687)] = 129255,
  [SMALL_STATE(4688)] = 129269,
  [SMALL_STATE(4689)] = 129283,
  [SMALL_STATE(4690)] = 129297,
  [SMALL_STATE(4691)] = 129311,
  [SMALL_STATE(4692)] = 129325,
  [SMALL_STATE(4693)] = 129339,
  [SMALL_STATE(4694)] = 129353,
  [SMALL_STATE(4695)] = 129367,
  [SMALL_STATE(4696)] = 129381,
  [SMALL_STATE(4697)] = 129395,
  [SMALL_STATE(4698)] = 129409,
  [SMALL_STATE(4699)] = 129423,
  [SMALL_STATE(4700)] = 129437,
  [SMALL_STATE(4701)] = 129451,
  [SMALL_STATE(4702)] = 129465,
  [SMALL_STATE(4703)] = 129479,
  [SMALL_STATE(4704)] = 129493,
  [SMALL_STATE(4705)] = 129507,
  [SMALL_STATE(4706)] = 129521,
  [SMALL_STATE(4707)] = 129535,
  [SMALL_STATE(4708)] = 129549,
  [SMALL_STATE(4709)] = 129563,
  [SMALL_STATE(4710)] = 129577,
  [SMALL_STATE(4711)] = 129591,
  [SMALL_STATE(4712)] = 129605,
  [SMALL_STATE(4713)] = 129619,
  [SMALL_STATE(4714)] = 129633,
  [SMALL_STATE(4715)] = 129637,
  [SMALL_STATE(4716)] = 129641,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4626),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3695),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0, 0, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4655),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4657),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3696),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4099),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4093),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3479),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4709),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3362),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4090),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4704),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3563),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2248),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4701),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4699),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4123),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(951),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4125),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4076),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3554),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3553),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3552),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3546),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4074),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4073),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3165),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3143),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3139),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4161),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4165),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1773),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3691),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4673),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4671),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4673),
  [131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 2, 0, 0),
  [133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 4, 0, 0),
  [135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 3, 0, 0),
  [137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(290),
  [142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(4099),
  [145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(31),
  [148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(4093),
  [151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(981),
  [154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3479),
  [157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(4709),
  [160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3362),
  [163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(974),
  [166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(969),
  [169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(4090),
  [172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(4704),
  [175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3563),
  [178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2248),
  [181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(4701),
  [184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(4699),
  [187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2953),
  [190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(958),
  [193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(957),
  [196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(956),
  [199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(4123),
  [202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(220),
  [205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(954),
  [208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(953),
  [211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(421),
  [214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(301),
  [217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(951),
  [220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(571),
  [223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(423),
  [226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(292),
  [229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(4125),
  [232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(4076),
  [235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(421),
  [238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3554),
  [241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3553),
  [244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3552),
  [247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3546),
  [250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(4074),
  [253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(4073),
  [256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(446),
  [259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1916),
  [262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3187),
  [265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3165),
  [268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3143),
  [271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3139),
  [274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(942),
  [277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(4161),
  [280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(4165),
  [283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1773),
  [286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1777),
  [289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(89),
  [292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3691),
  [295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(121),
  [298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(4673),
  [301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(4671),
  [304] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3347),
  [307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 1, 0, 0),
  [309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 1, 0, 0),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4626),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3695),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3498),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4167),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2953),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4123),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3554),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3553),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3552),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3546),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4074),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4073),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3187),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4264),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3488),
  [363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4191),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4101),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4102),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4089),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3559),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3558),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3557),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3555),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4082),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4081),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4132),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4140),
  [419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1928),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3660),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4689),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4605),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4101),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3559),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3558),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3557),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3555),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4082),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4081),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4689),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1029),
  [596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4264),
  [599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(35),
  [602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0),
  [604] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(606),
  [607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3488),
  [610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(936),
  [613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(935),
  [616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4191),
  [619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2248),
  [622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2953),
  [625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(923),
  [628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(904),
  [631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(902),
  [634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4101),
  [637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(518),
  [640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(891),
  [643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(874),
  [646] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1007),
  [649] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(273),
  [652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(608),
  [655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(570),
  [658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(489),
  [661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(267),
  [664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4102),
  [667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4089),
  [670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1007),
  [673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3559),
  [676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3558),
  [679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3557),
  [682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3555),
  [685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4082),
  [688] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4081),
  [691] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1009),
  [694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1916),
  [697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3187),
  [700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3165),
  [703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3143),
  [706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3139),
  [709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(870),
  [712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4132),
  [715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4140),
  [718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1928),
  [721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1929),
  [724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(95),
  [727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3660),
  [730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(126),
  [733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4689),
  [736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4605),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1, 0, 0),
  [755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 1, 0, 0),
  [759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4352),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3484),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4157),
  [773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4351),
  [781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4380),
  [801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3901),
  [803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3627),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3626),
  [807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3625),
  [809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3624),
  [811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3902),
  [813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3905),
  [815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_option_type, 1, 0, 0),
  [819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_option_type, 1, 0, 0),
  [823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3161),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3783),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3115),
  [829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4304),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3123),
  [839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3126),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3294),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3172),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3169),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3159),
  [849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixed_array_creation, 3, 0, 0),
  [851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fixed_array_creation, 3, 0, 0),
  [853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_result_type, 1, 0, 0),
  [855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_result_type, 1, 0, 0),
  [857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 1, 0, 2),
  [859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_signature, 1, 0, 2),
  [861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation, 2, 0, 0),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3651),
  [865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation, 2, 0, 0),
  [867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3216),
  [869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3745),
  [871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3217),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4229),
  [875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3222),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3225),
  [883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4121),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3482),
  [893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4147),
  [899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(908),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4117),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(906),
  [913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4112),
  [927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4091),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3530),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3529),
  [933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3528),
  [935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3527),
  [937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4086),
  [939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4085),
  [941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4294),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4417),
  [955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3490),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4141),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4408),
  [967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2237),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4295),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1475),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4308),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3927),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3570),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3571),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3572),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3573),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3923),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3179),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3834),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3257),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4395),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3258),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3259),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3262),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3239),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3243),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3244),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2008),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4289),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3493),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4135),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4258),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [1079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4349),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [1087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [1089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4246),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3973),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3577),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3576),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3575),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3974),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3950),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [1117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2101),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4240),
  [1129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3496),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4154),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4239),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2031),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4350),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3997),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3583),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3582),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3581),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3998),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2043),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [1197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [1199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2669),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3925),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [1313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2008),
  [1316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4289),
  [1319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(326),
  [1322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0),
  [1324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(729),
  [1327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3493),
  [1330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(725),
  [1333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(686),
  [1336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4135),
  [1339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2248),
  [1342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2953),
  [1345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(684),
  [1348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(719),
  [1351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(717),
  [1354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4258),
  [1357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(356),
  [1360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(680),
  [1363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(715),
  [1366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2064),
  [1369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(331),
  [1372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0),
  [1374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(730),
  [1377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(568),
  [1380] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(382),
  [1383] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(278),
  [1386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4246),
  [1389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3973),
  [1392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2064),
  [1395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3585),
  [1398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3577),
  [1401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3576),
  [1404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3575),
  [1407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3974),
  [1410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3950),
  [1413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2069),
  [1416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1916),
  [1419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3187),
  [1422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3165),
  [1425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3143),
  [1428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3139),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [1445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2831),
  [1447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4382),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [1455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3485),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [1461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4120),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [1465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [1467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4394),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [1477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2802),
  [1479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [1481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4188),
  [1483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [1485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [1487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [1489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [1491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4412),
  [1493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3864),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3609),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3566),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3603),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3870),
  [1509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2798),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2980),
  [1525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [1533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2696),
  [1541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [1543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [1549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [1551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [1557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [1561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [1565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [1567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1580),
  [1569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4377),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [1575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3486),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [1581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4163),
  [1585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [1587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [1589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4375),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [1599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [1601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [1603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [1607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [1611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3673),
  [1613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3845),
  [1615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1686),
  [1617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [1619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3568),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3574),
  [1623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3589),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3594),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3846),
  [1629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3848),
  [1631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1642),
  [1633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [1635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(2831),
  [1638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(4382),
  [1641] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(282),
  [1644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0),
  [1646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(749),
  [1649] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(3485),
  [1652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(667),
  [1655] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(618),
  [1658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(4120),
  [1661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(2248),
  [1664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(2953),
  [1667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(535),
  [1670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(660),
  [1673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(658),
  [1676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(4394),
  [1679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(416),
  [1682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(613),
  [1685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(653),
  [1688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(2802),
  [1691] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(298),
  [1694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(4188),
  [1697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(750),
  [1700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(575),
  [1703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(394),
  [1706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(294),
  [1709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(4412),
  [1712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(3864),
  [1715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(2802),
  [1718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(3609),
  [1721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(3607),
  [1724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(3566),
  [1727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(3603),
  [1730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(3869),
  [1733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(3870),
  [1736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(2798),
  [1739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(1916),
  [1742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(3187),
  [1745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(3165),
  [1748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(3143),
  [1751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 2, 0, 0), SHIFT_REPEAT(3139),
  [1754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [1756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3320),
  [1758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3782),
  [1760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3247),
  [1762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4353),
  [1764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [1766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [1768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3248),
  [1772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3249),
  [1774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3144),
  [1776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3188),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3199),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3209),
  [1782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [1784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [1786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [1788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [1790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1428),
  [1793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4294),
  [1796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(322),
  [1799] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(722),
  [1802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [1804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3490),
  [1807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(804),
  [1810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(759),
  [1813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(846),
  [1816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4141),
  [1819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2248),
  [1822] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2953),
  [1825] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(758),
  [1828] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(800),
  [1831] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(797),
  [1834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4295),
  [1837] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(486),
  [1840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(748),
  [1843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(795),
  [1846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1475),
  [1849] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(316),
  [1852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(723),
  [1855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(563),
  [1858] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(361),
  [1861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(325),
  [1864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4308),
  [1867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3927),
  [1870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1475),
  [1873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3570),
  [1876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3571),
  [1879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3572),
  [1882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3573),
  [1885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3926),
  [1888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3923),
  [1891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1492),
  [1894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1916),
  [1897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3187),
  [1900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3165),
  [1903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3143),
  [1906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3139),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2799),
  [1911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [1913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [1915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [1917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2519),
  [1919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4291),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [1923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [1925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3499),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [1929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [1931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4283),
  [1933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [1935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [1937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4292),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [1947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2448),
  [1949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [1951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [1953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [1955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [1957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [1959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3687),
  [1961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3933),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3632),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3634),
  [1969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3635),
  [1971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3636),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3932),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3931),
  [1977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2451),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [1981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arms, 1, 0, 0),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [1985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2169),
  [1987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 4, 0, 96),
  [1989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, 0, 65),
  [1991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, 0, 58),
  [1993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_strictly_expression_list, 3, 0, 0),
  [1995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_strictly_expression_list, 3, 0, 0),
  [1997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3773),
  [1999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3344),
  [2001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_strictly_expression_list_repeat1, 2, 0, 0),
  [2003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [2005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [2007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [2009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [2013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [2015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [2017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [2019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [2021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [2023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [2025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [2027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4376),
  [2029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3181),
  [2031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [2033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 2, 0, 0),
  [2035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_statement, 1, 0, 0),
  [2037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_simple_statement, 1, 0, 0),
  [2039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [2041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 1, 0, 0),
  [2043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [2045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [2047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_in_expression, 3, 0, 33),
  [2049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_in_expression, 3, 0, 33),
  [2051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 30),
  [2053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 30),
  [2055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 3),
  [2057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 3),
  [2059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receive_expression, 2, 0, 3),
  [2061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receive_expression, 2, 0, 3),
  [2063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spawn_expression, 2, 0, 0),
  [2065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_spawn_expression, 2, 0, 0),
  [2067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mutable_expression, 2, 0, 0),
  [2069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mutable_expression, 2, 0, 0),
  [2071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3224),
  [2073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_go_expression, 2, 0, 0),
  [2075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_go_expression, 2, 0, 0),
  [2077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_append_statement, 3, 0, 33),
  [2079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_append_statement, 3, 0, 33),
  [2081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 3, 0, 22),
  [2083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 3, 0, 22),
  [2085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3731),
  [2087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 3, 0, 21),
  [2089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 3, 0, 21),
  [2091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compile_time_if_expression, 4, 0, 57),
  [2093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compile_time_if_expression, 4, 0, 57),
  [2095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3822),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [2099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [2101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4095),
  [2103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compile_time_if_expression, 3, 0, 21),
  [2105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compile_time_if_expression, 3, 0, 21),
  [2107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3730),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [2111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [2113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2524),
  [2115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [2121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [2123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [2125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [2127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [2129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [2131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [2133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [2135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [2139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [2141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [2143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [2145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [2147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [2155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [2159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [2161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [2163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [2165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [2167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 0),
  [2169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 0),
  [2171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [2173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_expression, 1, 0, 0),
  [2175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_expression, 1, 0, 0),
  [2177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_reference_expression, 1, 0, 0), REDUCE(sym_type_reference_expression, 1, 0, 0),
  [2180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_reference_expression, 1, 0, 0), REDUCE(sym_type_reference_expression, 1, 0, 0),
  [2183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1820),
  [2185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__plain_type_without_special, 1, 0, 0),
  [2187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__plain_type_without_special, 1, 0, 0),
  [2189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [2191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [2193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [2195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [2197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [2199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [2201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [2203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [2205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [2207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [2213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [2217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2519),
  [2220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4291),
  [2223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(324),
  [2226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0),
  [2228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(673),
  [2231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3499),
  [2234] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(860),
  [2237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(859),
  [2240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4283),
  [2243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2248),
  [2246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2953),
  [2249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(853),
  [2252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(852),
  [2255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(851),
  [2258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4292),
  [2261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(507),
  [2264] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(850),
  [2267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(849),
  [2270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2448),
  [2273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(293),
  [2276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(675),
  [2279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(553),
  [2282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(437),
  [2285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(311),
  [2288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4095),
  [2291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3933),
  [2294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2448),
  [2297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3632),
  [2300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3634),
  [2303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3635),
  [2306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3636),
  [2309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3932),
  [2312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3931),
  [2315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2451),
  [2318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1916),
  [2321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3187),
  [2324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3165),
  [2327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3143),
  [2330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3139),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [2335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map_init_expression, 2, 0, 0),
  [2337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_init_expression, 2, 0, 0),
  [2339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [2341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [2343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [2347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [2349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [2351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [2353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [2357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [2359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [2363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [2365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [2367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [2369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [2371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_reference_expression, 1, 0, 0),
  [2373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_reference_expression, 1, 0, 0),
  [2375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compile_time_if_expression, 6, 0, 118),
  [2377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compile_time_if_expression, 6, 0, 118),
  [2379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [2381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 5, 0, 58),
  [2383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 5, 0, 58),
  [2385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2852),
  [2387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [2389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [2391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [2393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [2395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 11),
  [2397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 11),
  [2399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4, 2, 0),
  [2401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4, 2, 0),
  [2403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2838),
  [2405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [2407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4200),
  [2409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [2411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [2413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [2417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [2419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [2421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [2423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [2425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [2427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_literal, 3, 0, 15),
  [2429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_literal, 3, 0, 15),
  [2431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [2433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_init_expression, 3, 0, 0),
  [2435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map_init_expression, 3, 0, 0),
  [2437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [2439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [2441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_expression, 4, 2, 72),
  [2443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_expression, 4, 2, 72),
  [2445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_is_expression, 3, 2, 33), REDUCE(sym_is_expression, 4, 2, 72),
  [2448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_is_expression, 3, 2, 33), REDUCE(sym_is_expression, 4, 2, 72),
  [2451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3, 2, 0),
  [2453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3, 2, 0),
  [2455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type, 3, 0, 36),
  [2457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type, 3, 0, 36),
  [2459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [2463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_literal, 5, 0, 86),
  [2465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_literal, 5, 0, 86),
  [2467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [2469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_initializer, 2, 0, 10),
  [2471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_initializer, 2, 0, 10),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [2477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [2479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [2481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [2483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4351),
  [2485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [2487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [2489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [2491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [2493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3627),
  [2495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [2497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [2499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3624),
  [2501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [2503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3905),
  [2505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_element_list, 1, 0, 0),
  [2507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1428),
  [2510] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4294),
  [2513] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(322),
  [2516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0),
  [2518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(722),
  [2521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3490),
  [2524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(804),
  [2527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(759),
  [2530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4141),
  [2533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2248),
  [2536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2953),
  [2539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(758),
  [2542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(800),
  [2545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(797),
  [2548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4295),
  [2551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(486),
  [2554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(748),
  [2557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(795),
  [2560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1475),
  [2563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(316),
  [2566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(723),
  [2569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(563),
  [2572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(361),
  [2575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(325),
  [2578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4308),
  [2581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3927),
  [2584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1475),
  [2587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3570),
  [2590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3571),
  [2593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3572),
  [2596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3573),
  [2599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3926),
  [2602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3923),
  [2605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1492),
  [2608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1916),
  [2611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3187),
  [2614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3165),
  [2617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3143),
  [2620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3139),
  [2623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [2625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_branch, 2, 0, 90),
  [2627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_branch, 2, 0, 90),
  [2629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_branch, 2, 0, 34),
  [2631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_branch, 2, 0, 34),
  [2633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [2637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compile_time_if_expression, 5, 0, 91),
  [2639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compile_time_if_expression, 5, 0, 91),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [2645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_initializer_body, 3, 0, 74),
  [2647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_initializer_body, 3, 0, 74),
  [2649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_initializer_body, 3, 0, 73),
  [2651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_initializer_body, 3, 0, 73),
  [2653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_or_block_expression, 2, 0, 0),
  [2655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_or_block_expression, 2, 0, 0),
  [2657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 9),
  [2659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 9),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [2667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [2669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [2673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2617),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [2681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [2683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [2691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [2693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [2695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation, 3, 0, 0),
  [2697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation, 3, 0, 0),
  [2699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [2701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(1580),
  [2704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(4377),
  [2707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(284),
  [2710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(681),
  [2713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(3486),
  [2716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(640),
  [2719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(639),
  [2722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0),
  [2724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(4163),
  [2727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(2248),
  [2730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(2953),
  [2733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(585),
  [2736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(631),
  [2739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(625),
  [2742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(4375),
  [2745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(516),
  [2748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(623),
  [2751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(622),
  [2754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(1564),
  [2757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(280),
  [2760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(685),
  [2763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(556),
  [2766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(406),
  [2769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(321),
  [2772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(4200),
  [2775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(3845),
  [2778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(1564),
  [2781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(3568),
  [2784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(3574),
  [2787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(3589),
  [2790] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(3594),
  [2793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(3846),
  [2796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(3848),
  [2799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(1642),
  [2802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(1916),
  [2805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(3187),
  [2808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(3165),
  [2811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(3143),
  [2814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0), SHIFT_REPEAT(3139),
  [2817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_result_propagation_expression, 2, 0, 0),
  [2819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_result_propagation_expression, 2, 0, 0),
  [2821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_option_propagation_expression, 2, 0, 0),
  [2823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_option_propagation_expression, 2, 0, 0),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [2827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dec_expression, 2, 0, 0),
  [2829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dec_expression, 2, 0, 0),
  [2831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inc_expression, 2, 0, 0),
  [2833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inc_expression, 2, 0, 0),
  [2835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_expression, 3, 0, 0),
  [2837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select_expression, 3, 0, 0),
  [2839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, 0, 0),
  [2841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, 0, 0),
  [2843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anon_struct_value_expression, 4, 0, 52),
  [2845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anon_struct_value_expression, 4, 0, 52),
  [2847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anon_struct_value_expression, 4, 0, 51),
  [2849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anon_struct_value_expression, 4, 0, 51),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [2855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [2857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [2863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal, 1, 0, 0),
  [2865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal, 1, 0, 0),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [2871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lock_expression, 3, 0, 23),
  [2873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lock_expression, 3, 0, 23),
  [2875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_literal, 4, 0, 50),
  [2877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_literal, 4, 0, 50),
  [2879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_expression, 5, 0, 0),
  [2881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select_expression, 5, 0, 0),
  [2883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sql_expression, 3, 0, 0),
  [2885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sql_expression, 3, 0, 0),
  [2887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_literal, 4, 0, 49),
  [2889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_literal, 4, 0, 49),
  [2891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_plain_type, 1, 0, 0),
  [2893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_plain_type, 1, 0, 0),
  [2895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3685),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [2899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [2901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [2903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [2905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(897),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [2911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [2913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [2915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpreted_string_literal, 3, 0, 0),
  [2917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpreted_string_literal, 3, 0, 0),
  [2919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_c_string_literal, 3, 0, 0),
  [2921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_c_string_literal, 3, 0, 0),
  [2923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 3, 0, 0),
  [2925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 3, 0, 0),
  [2927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_expression, 5, 0, 60),
  [2929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select_expression, 5, 0, 60),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [2933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 4, 0, 69),
  [2935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 4, 0, 69),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [2939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2948),
  [2941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2331),
  [2943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2386),
  [2945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special_argument_list, 3, 0, 54),
  [2947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special_argument_list, 3, 0, 54),
  [2949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compile_time_selector_expression, 3, 0, 97),
  [2951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compile_time_selector_expression, 3, 0, 97),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [2955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__max_group, 1, 0, 0),
  [2957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__max_group, 1, 0, 0),
  [2959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 4, -1, 67),
  [2961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 4, -1, 67),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [2965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anon_struct_type, 2, 0, 0),
  [2967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anon_struct_type, 2, 0, 0),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3663),
  [2971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [2973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [2975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 2, 0, 0),
  [2977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 2, 0, 0),
  [2979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_c_string_literal, 2, 0, 0),
  [2981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_c_string_literal, 2, 0, 0),
  [2983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 4, 0, 0),
  [2985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameter_list, 4, 0, 0),
  [2987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_selector_expression, 3, -1, 29),
  [2989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selector_expression, 3, -1, 29),
  [2991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_type_cast_expression, 3, 0, 0),
  [2993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_type_cast_expression, 3, 0, 0),
  [2995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [2997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [2999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multi_return_type, 5, 0, 0),
  [3001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multi_return_type, 5, 0, 0),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3690),
  [3005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpreted_string_literal, 2, 0, 0),
  [3007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpreted_string_literal, 2, 0, 0),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [3013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sql_expression, 2, 0, 0),
  [3015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sql_expression, 2, 0, 0),
  [3017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unsafe_expression, 2, 0, 0),
  [3019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unsafe_expression, 2, 0, 0),
  [3021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lock_expression, 2, 0, 7),
  [3023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lock_expression, 2, 0, 7),
  [3025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_type, 4, 0, 62),
  [3027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map_type, 4, 0, 62),
  [3029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixed_array_type, 4, 0, 55),
  [3031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fixed_array_type, 4, 0, 55),
  [3033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [3035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [3039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_body, 3, 0, 0),
  [3041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__struct_body, 3, 0, 0),
  [3043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_without_blocks, 1, 0, 0),
  [3045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_without_blocks, 1, 0, 0),
  [3047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 3, 0, 0),
  [3049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameter_list, 3, 0, 0),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [3053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [3055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [3059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_or_block, 2, 0, 34),
  [3061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_or_block, 2, 0, 34),
  [3063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_expression, 3, 2, 33),
  [3065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_expression, 3, 2, 33),
  [3067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_with_blocks, 1, 0, 0),
  [3069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_with_blocks, 1, 0, 0),
  [3071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, 0, 35),
  [3073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, 0, 35),
  [3075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_without_blocks, 1, 0, 0), SHIFT(4300),
  [3078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixed_array_creation, 4, 0, 0),
  [3080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fixed_array_creation, 4, 0, 0),
  [3082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multi_return_type, 4, 0, 0),
  [3084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multi_return_type, 4, 0, 0),
  [3086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [3088] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(1580),
  [3091] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(4377),
  [3094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(284),
  [3097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0),
  [3099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(681),
  [3102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(3486),
  [3105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(888),
  [3108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(889),
  [3111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(4163),
  [3114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(2248),
  [3117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(2953),
  [3120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(895),
  [3123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(896),
  [3126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(897),
  [3129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(4375),
  [3132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(516),
  [3135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(898),
  [3138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(899),
  [3141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(1564),
  [3144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(280),
  [3147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(685),
  [3150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(556),
  [3153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(384),
  [3156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(330),
  [3159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(4200),
  [3162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(3845),
  [3165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(1564),
  [3168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(3568),
  [3171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(3574),
  [3174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(3589),
  [3177] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(3594),
  [3180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(3846),
  [3183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(3848),
  [3186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(1642),
  [3189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(1916),
  [3192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(3187),
  [3195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(3165),
  [3198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(3143),
  [3201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_interpolation_repeat1, 2, 0, 0), SHIFT_REPEAT(3139),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [3212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4117),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [3218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [3224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3530),
  [3226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [3228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3527),
  [3232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4086),
  [3234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4085),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [3238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 4),
  [3240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 4),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3670),
  [3244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_option_type, 2, 0, 0),
  [3246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_option_type, 2, 0, 0),
  [3248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__content_block, 3, 0, 0),
  [3250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__content_block, 3, 0, 0),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [3254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_expression, 4, 0, 60),
  [3256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select_expression, 4, 0, 60),
  [3258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [3260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_initializer_body, 2, 0, 0),
  [3262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_initializer_body, 2, 0, 0),
  [3264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shared_type, 2, 0, 0),
  [3266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shared_type, 2, 0, 0),
  [3268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_channel_type, 2, 0, 0),
  [3270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_channel_type, 2, 0, 0),
  [3272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_expression, 4, 0, 0),
  [3274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select_expression, 4, 0, 0),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [3278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special_argument_list, 5, 0, 54),
  [3280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special_argument_list, 5, 0, 54),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [3284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_expression, 6, 0, 60),
  [3286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select_expression, 6, 0, 60),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [3290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_thread_type, 2, 0, 0),
  [3292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_thread_type, 2, 0, 0),
  [3294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_atomic_type, 2, 0, 0),
  [3296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_atomic_type, 2, 0, 0),
  [3298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 20),
  [3300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 20),
  [3302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 2, 0, 0),
  [3304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 2, 0, 0),
  [3306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_result_type, 2, 0, 0),
  [3308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_result_type, 2, 0, 0),
  [3310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wrong_pointer_type, 2, 0, 0),
  [3312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_wrong_pointer_type, 2, 0, 0),
  [3314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [3316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 2, 0, 1),
  [3318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 2, 0, 1),
  [3320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [3322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_body, 2, 0, 0),
  [3324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__struct_body, 2, 0, 0),
  [3326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_fetch, 2, -1, 0),
  [3328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_fetch, 2, -1, 0),
  [3330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 4, 0, 58),
  [3332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 4, 0, 58),
  [3334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 4, 0, 22),
  [3336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 4, 0, 22),
  [3338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 4, 0, 21),
  [3340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 4, 0, 21),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [3344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 2, 0, 16),
  [3346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_signature, 2, 0, 16),
  [3348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [3350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [3354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multi_return_type, 3, 0, 0),
  [3356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multi_return_type, 3, 0, 0),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3287),
  [3360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3006),
  [3362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2153),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [3368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [3372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [3374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [3378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [3380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [3382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [3384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3261),
  [3388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3040),
  [3390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [3392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [3396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3046),
  [3398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3314),
  [3400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3038),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [3404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3002),
  [3406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [3408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3193),
  [3410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3750),
  [3412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3107),
  [3414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4301),
  [3416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [3418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [3420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [3422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3105),
  [3424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3301),
  [3426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3116),
  [3428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3168),
  [3430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3166),
  [3432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3277),
  [3434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [3436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2986),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [3440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3022),
  [3442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3212),
  [3444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2997),
  [3446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [3448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [3450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3015),
  [3452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [3454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3036),
  [3456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range, 1, 0, 31),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [3460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [3464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [3466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [3472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [3474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [3476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [3480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3004),
  [3482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range, 2, 0, 68),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [3488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [3492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [3494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [3498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [3500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [3502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3183),
  [3506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3001),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [3510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3055),
  [3512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [3520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3023),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [3524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2987),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [3528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3014),
  [3530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [3532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3017),
  [3534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [3538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2618),
  [3540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4288),
  [3542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [3544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [3546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3492),
  [3548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [3550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [3552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4107),
  [3554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [3556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [3558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(629),
  [3560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4279),
  [3562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [3564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [3568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2854),
  [3570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [3572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [3574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [3576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [3578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [3580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4144),
  [3582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4056),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [3586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3551),
  [3588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3550),
  [3590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3549),
  [3592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3548),
  [3594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3966),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [3598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2877),
  [3600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2256),
  [3602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4241),
  [3604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [3606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [3608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3491),
  [3610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [3612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [3614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4129),
  [3616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [3618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [3620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [3622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4368),
  [3624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [3626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [3628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [3630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2276),
  [3632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [3634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [3636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [3638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [3640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [3642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4272),
  [3644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3952),
  [3646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [3648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3606),
  [3650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3608),
  [3652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [3654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3613),
  [3656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [3658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3942),
  [3660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2358),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [3664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [3666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [3668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [3670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [3672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [3674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [3676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(641),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [3680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [3682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [3684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [3686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [3688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [3692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [3694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [3696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [3700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [3702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [3704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [3710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [3712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [3714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [3716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [3718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [3722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [3724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [3726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [3728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2903),
  [3730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2163),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [3734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4114),
  [3736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [3738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [3740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [3742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [3744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [3746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4277),
  [3748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3961),
  [3750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3788),
  [3752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3141),
  [3754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [3756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [3758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [3760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [3762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [3764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [3766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [3768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [3770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [3772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [3774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [3776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [3778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [3780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [3782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [3784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [3786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4182),
  [3788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3160),
  [3790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [3792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3747),
  [3794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3237),
  [3796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3761),
  [3798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3748),
  [3800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [3802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [3804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3406),
  [3806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3251),
  [3808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3794),
  [3810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3336),
  [3812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4218),
  [3814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2529),
  [3816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2533),
  [3818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [3820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3334),
  [3822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3331),
  [3824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3171),
  [3826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3339),
  [3828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3338),
  [3830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3337),
  [3832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1476),
  [3834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3326),
  [3836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3715),
  [3838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3311),
  [3840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4389),
  [3842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1118),
  [3844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [3846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [3848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3242),
  [3850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3299),
  [3852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3157),
  [3854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3164),
  [3856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3279),
  [3858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3281),
  [3860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [3862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 1, 0, 0),
  [3864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3833),
  [3866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3304),
  [3868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [3870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [3872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [3874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [3876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [3878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [3880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [3882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [3884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1231),
  [3886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [3888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [3890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [3892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [3894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4315),
  [3896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3307),
  [3898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [3900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3223),
  [3902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 2, 0, 0),
  [3904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_statement, 2, 0, 0),
  [3906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [3908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_strictly_expression_list_repeat1, 2, 0, 0),
  [3910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_send_statement, 3, 0, 32),
  [3912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_send_statement, 3, 0, 32),
  [3914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [3916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [3918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [3920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [3922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [3924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [3926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3752),
  [3928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 4, 0, 0),
  [3930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_statement, 4, 0, 0),
  [3932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__global_var_value, 2, 0, 41),
  [3934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__global_var_value, 2, 0, 41),
  [3936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_definition, 3, 0, 40),
  [3938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_definition, 3, 0, 40),
  [3940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1628),
  [3942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [3944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3700),
  [3946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [3948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4113),
  [3950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [3952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [3954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [3956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3118),
  [3958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3108),
  [3960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [3962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3134),
  [3964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3125),
  [3966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3124),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3216),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [3972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [3974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3742),
  [3976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3749),
  [3978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [3980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3740),
  [3982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3113),
  [3984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [3986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [3988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [3990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [3992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [3994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [3996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [3998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [4000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [4002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [4004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [4006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [4008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [4010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4153),
  [4012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3109),
  [4014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(662),
  [4016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3132),
  [4018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(823),
  [4020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3756),
  [4022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1709),
  [4024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3283),
  [4026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3705),
  [4028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3153),
  [4030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4330),
  [4032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [4034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [4036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [4038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3152),
  [4040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3151),
  [4042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3190),
  [4044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3158),
  [4046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3156),
  [4048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3155),
  [4050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [4052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [4054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [4056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [4058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [4060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [4062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3758),
  [4064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3763),
  [4066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [4068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3102),
  [4070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3711),
  [4072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3340),
  [4074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4158),
  [4076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [4078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [4080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [4082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3345),
  [4084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3330),
  [4086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3319),
  [4088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3267),
  [4090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3269),
  [4092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3315),
  [4094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1389),
  [4096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3712),
  [4098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [4100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [4102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1530),
  [4104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [4106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [4108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [4110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [4112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [4114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [4116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3322),
  [4118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [4120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [4122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [4124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(775),
  [4126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4402),
  [4128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3317),
  [4130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3229),
  [4132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_spread_expression, 2, 0, 0),
  [4134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument, 1, 0, 0),
  [4136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyed_element, 3, 0, 39),
  [4138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3802),
  [4140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map_keyed_element, 3, 0, 39),
  [4142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3798),
  [4144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3781),
  [4146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 1, 0, 18),
  [4148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2345),
  [4150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [4152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [4154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3812),
  [4156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3170),
  [4158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4105),
  [4160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [4162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [4164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [4166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3205),
  [4168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3204),
  [4170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [4172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3341),
  [4174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3285),
  [4176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3256),
  [4178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_without_blocks, 1, 0, 0), REDUCE(aux_sym_element_list_repeat1, 1, 0, 0),
  [4181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_without_blocks, 1, 0, 0), SHIFT(4012),
  [4184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_element_list_repeat1, 1, 0, 0),
  [4186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_name, 1, 0, 0),
  [4188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1445),
  [4190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2173),
  [4192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [4194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3709),
  [4196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3111),
  [4198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4262),
  [4200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1517),
  [4202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [4204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [4206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3122),
  [4208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3133),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3220),
  [4212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3309),
  [4214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3104),
  [4216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3110),
  [4218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [4220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_without_blocks, 1, 0, 0), SHIFT(4332),
  [4223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [4225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3804),
  [4227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [4231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1674),
  [4233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1680),
  [4235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3804),
  [4239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [4241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [4243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_interpolation_repeat1, 1, 0, 25),
  [4245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3200),
  [4247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_interpolation_repeat1, 1, 0, 25),
  [4249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [4253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [4255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [4257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [4259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3650),
  [4261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [4265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [4269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [4271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4410),
  [4273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3203),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3203),
  [4277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [4281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3809),
  [4283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3808),
  [4285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [4289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [4291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [4301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [4303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [4305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3799),
  [4307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 1, 0, 0),
  [4309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__array_repeat1, 1, 0, 0),
  [4311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [4313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1629),
  [4315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_attribute, 1, 0, 6),
  [4317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_literal, 1, 0, 0), SHIFT(3241),
  [4320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_attribute, 1, 0, 0),
  [4322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_without_blocks, 1, 0, 0), SHIFT(3241),
  [4325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2364),
  [4327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3120),
  [4329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3721),
  [4331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3185),
  [4333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4136),
  [4335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1694),
  [4337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1696),
  [4339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [4341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3192),
  [4343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3194),
  [4345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3240),
  [4347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3167),
  [4349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3176),
  [4351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3178),
  [4353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1690),
  [4355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [4357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2447),
  [4359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3791),
  [4361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3318),
  [4363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1710),
  [4365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1706),
  [4367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [4369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3333),
  [4371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3332),
  [4373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [4375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3310),
  [4377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3308),
  [4379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3313),
  [4381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sum_type, 2, 0, 0),
  [4383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sum_type, 2, 0, 0),
  [4385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4685),
  [4387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3114),
  [4389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 6, 0, 121),
  [4391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 6, 0, 121),
  [4393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 4, 0, 42),
  [4395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 4, 0, 42),
  [4397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sum_type_repeat1, 2, 0, 0),
  [4399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sum_type_repeat1, 2, 0, 0),
  [4401] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sum_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4685),
  [4404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sum_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3114),
  [4407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 5, 0, 99),
  [4409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 5, 0, 99),
  [4411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 5, 0, 77),
  [4413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 5, 0, 77),
  [4415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_strictly_expression_list_repeat1, 2, 0, 0), SHIFT_REPEAT(574),
  [4418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [4420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sum_type_repeat1, 3, 0, 0),
  [4422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sum_type_repeat1, 3, 0, 0),
  [4424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 2, 0, 0),
  [4426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 2, 0, 0),
  [4428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_strictly_expression_list, 4, 0, 0),
  [4430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_strictly_expression_list, 4, 0, 0),
  [4432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_method_declaration, 7, 0, 139),
  [4434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_method_declaration, 7, 0, 139),
  [4436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [4438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 108),
  [4440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 108),
  [4442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 102),
  [4444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 102),
  [4446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 129),
  [4448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 129),
  [4450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_method_declaration, 6, 0, 122),
  [4452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_method_declaration, 6, 0, 122),
  [4454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 105),
  [4456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 105),
  [4458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 3, 0, 14),
  [4460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 3, 0, 14),
  [4462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 70),
  [4464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, 0, 70),
  [4466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 131),
  [4468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 131),
  [4470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_method_declaration, 7, 0, 142),
  [4472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_method_declaration, 7, 0, 142),
  [4474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_method_declaration, 6, 0, 113),
  [4476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_method_declaration, 6, 0, 113),
  [4478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 132),
  [4480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 132),
  [4482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_method_declaration, 5, 0, 82),
  [4484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_method_declaration, 5, 0, 82),
  [4486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 125),
  [4488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 125),
  [4490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_method_declaration, 6, 0, 126),
  [4492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_method_declaration, 6, 0, 126),
  [4494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 101),
  [4496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 101),
  [4498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_method_declaration, 7, 0, 144),
  [4500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_method_declaration, 7, 0, 144),
  [4502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 147),
  [4504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 7, 0, 147),
  [4506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 75),
  [4508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, 0, 75),
  [4510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_method_declaration, 8, 0, 151),
  [4512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_method_declaration, 8, 0, 151),
  [4514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 106),
  [4516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 106),
  [4518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 85),
  [4520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 85),
  [4522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 1, 0, 0),
  [4524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1810),
  [4526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 1, 0, 0),
  [4528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 48),
  [4530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, 0, 48),
  [4532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 1, 0, 0),
  [4534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 1, 0, 0),
  [4536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 47),
  [4538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, 0, 47),
  [4540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, 0, 109),
  [4542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, 0, 109),
  [4544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 4, 0, 76),
  [4546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 4, 0, 76),
  [4548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 2, 0, 0),
  [4550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 2, 0, 0),
  [4552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_list_repeat1, 2, 0, 0),
  [4554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_list_repeat1, 2, 0, 0),
  [4556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3696),
  [4559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, 0, 107),
  [4561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, 0, 107),
  [4563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, 0, 76),
  [4565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, 0, 76),
  [4567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, 0, 76),
  [4569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, 0, 76),
  [4571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1, 0, 0),
  [4573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1, 0, 0),
  [4575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1923),
  [4577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, 0, 71),
  [4579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, 0, 71),
  [4581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_statement, 3, 0, 0),
  [4583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asm_statement, 3, 0, 0),
  [4585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, 0, 76),
  [4587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, 0, 76),
  [4589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 3, 0, 27),
  [4591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 3, 0, 27),
  [4593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 2, 0, 0),
  [4595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 2, 0, 0),
  [4597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 4, 0, 38),
  [4599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 4, 0, 38),
  [4601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_var_declaration, 4, 0, 38),
  [4603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_var_declaration, 4, 0, 38),
  [4605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 2, 0, 0),
  [4607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 2, 0, 0),
  [4609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_var_declaration, 2, 0, 0),
  [4611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_var_declaration, 2, 0, 0),
  [4613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, 0, 19),
  [4615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, 0, 19),
  [4617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compile_time_for_statement, 3, 0, 27),
  [4619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compile_time_for_statement, 3, 0, 27),
  [4621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, 0, 19),
  [4623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, 0, 19),
  [4625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1, 0, 0),
  [4627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1, 0, 0),
  [4629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 1, 0, 0),
  [4631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_list, 1, 0, 0),
  [4633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_method_declaration, 7, 0, 134),
  [4635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_method_declaration, 7, 0, 134),
  [4637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label_reference, 1, 0, 0),
  [4639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label_reference, 1, 0, 0),
  [4641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, 0, 133),
  [4643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 6, 0, 133),
  [4645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defer_statement, 2, 0, 0),
  [4647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defer_statement, 2, 0, 0),
  [4649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_statement, 3, 0, 30),
  [4651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_statement, 3, 0, 30),
  [4653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 3, 0, 37),
  [4655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_declaration, 3, 0, 37),
  [4657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, 0, 71),
  [4659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, 0, 71),
  [4661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 8, 0, 152),
  [4663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 8, 0, 152),
  [4665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_method_declaration, 9, 0, 153),
  [4667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_method_declaration, 9, 0, 153),
  [4669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label_definition, 2, 0, 0),
  [4671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label_definition, 2, 0, 0),
  [4673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 83),
  [4675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 83),
  [4677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 4, 0, 71),
  [4679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 4, 0, 71),
  [4681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 84),
  [4683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 84),
  [4685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 3, 0, 38),
  [4687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 3, 0, 38),
  [4689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_var_declaration, 3, 0, 38),
  [4691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_var_declaration, 3, 0, 38),
  [4693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, 0, 133),
  [4695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, 0, 133),
  [4697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 3, 0, 0),
  [4699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 3, 0, 0),
  [4701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_var_declaration, 3, 0, 0),
  [4703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_var_declaration, 3, 0, 0),
  [4705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 6, 0, 109),
  [4707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 6, 0, 109),
  [4709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_var_definition, 2, 0, 12),
  [4711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_var_definition, 2, 0, 12),
  [4713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 130),
  [4715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 130),
  [4717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_var_definition, 2, 0, 6),
  [4719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_var_definition, 2, 0, 6),
  [4721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 6, 0, 38),
  [4723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 6, 0, 38),
  [4725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 128),
  [4727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 128),
  [4729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 127),
  [4731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 127),
  [4733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 124),
  [4735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 124),
  [4737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 123),
  [4739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 123),
  [4741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_body, 3, 0, 0),
  [4743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_body, 3, 0, 0),
  [4745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 4, 0, 53),
  [4747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 4, 0, 53),
  [4749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5, 0, 107),
  [4751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 5, 0, 107),
  [4753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interface_body, 3, 0, 0),
  [4755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interface_body, 3, 0, 0),
  [4757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 46),
  [4759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, 0, 46),
  [4761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 4, 0, 0),
  [4763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 4, 0, 0),
  [4765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 104),
  [4767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 104),
  [4769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 114),
  [4771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 114),
  [4773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, 0, 53),
  [4775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, 0, 53),
  [4777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_method_declaration, 6, 0, 112),
  [4779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_method_declaration, 6, 0, 112),
  [4781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_method_declaration, 7, 0, 138),
  [4783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_method_declaration, 7, 0, 138),
  [4785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 140),
  [4787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 7, 0, 140),
  [4789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, 0, 109),
  [4791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, 0, 109),
  [4793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 5, 0, 0),
  [4795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 5, 0, 0),
  [4797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_method_declaration, 7, 0, 141),
  [4799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_method_declaration, 7, 0, 141),
  [4801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_statement, 2, 0, 0),
  [4803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_statement, 2, 0, 0),
  [4805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 2, 0, 7),
  [4807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 2, 0, 7),
  [4809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 143),
  [4811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 7, 0, 143),
  [4813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interface_body, 2, 0, 0),
  [4815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interface_body, 2, 0, 0),
  [4817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 145),
  [4819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 7, 0, 145),
  [4821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 146),
  [4823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 7, 0, 146),
  [4825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, 0, 19),
  [4827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, 0, 19),
  [4829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5, 0, 109),
  [4831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 5, 0, 109),
  [4833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 100),
  [4835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 100),
  [4837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 3, 0, 19),
  [4839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 3, 0, 19),
  [4841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_method_declaration, 8, 0, 148),
  [4843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_method_declaration, 8, 0, 148),
  [4845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_body, 2, 0, 0),
  [4847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_body, 2, 0, 0),
  [4849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 8),
  [4851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 8),
  [4853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5, 0, 103),
  [4855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 5, 0, 103),
  [4857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, 0, 71),
  [4859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, 0, 71),
  [4861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, 0, 103),
  [4863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, 0, 103),
  [4865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 5, 0, 38),
  [4867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 5, 0, 38),
  [4869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_method_declaration, 8, 0, 149),
  [4871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_method_declaration, 8, 0, 149),
  [4873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_method_declaration, 8, 0, 150),
  [4875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_method_declaration, 8, 0, 150),
  [4877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1713),
  [4879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [4881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [4883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [4885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 0),
  [4887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_var_declaration, 5, 0, 38),
  [4889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_var_declaration, 5, 0, 38),
  [4891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_var_declaration, 4, 0, 0),
  [4893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_var_declaration, 4, 0, 0),
  [4895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2853),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [4899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3727),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [4903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4119),
  [4905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [4907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [4909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [4911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3300),
  [4913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3306),
  [4915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3246),
  [4917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3270),
  [4919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3271),
  [4921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3297),
  [4923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1838),
  [4925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2851),
  [4927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3184),
  [4929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3693),
  [4931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3278),
  [4933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4151),
  [4935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [4937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [4939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [4941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3274),
  [4943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3272),
  [4945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3250),
  [4947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3103),
  [4949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3284),
  [4951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3280),
  [4953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1824),
  [4955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shebang, 2, 0, 0),
  [4957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shebang, 2, 0, 0),
  [4959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mutability_modifiers, 1, 0, 0),
  [4961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mutability_modifiers, 1, 0, 0),
  [4963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_clause, 3, 0, 0),
  [4965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_clause, 3, 0, 0),
  [4967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1912),
  [4969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_list_repeat1, 1, 0, 0),
  [4971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_list_repeat1, 1, 0, 0),
  [4973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3, 0, 0),
  [4975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 3, 0, 0),
  [4977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_clause, 2, 0, 0),
  [4979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_clause, 2, 0, 0),
  [4981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [4983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_strictly_expression_list_repeat1, 2, 0, 0), SHIFT_REPEAT(577),
  [4986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1946),
  [4988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 1, 0, 0),
  [4990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [4992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0),
  [4994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [4996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [4998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [5000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [5004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [5006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [5008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [5010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [5012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [5014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [5016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [5018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2119),
  [5020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2120),
  [5022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [5024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [5026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [5028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4204),
  [5030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [5032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [5034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [5036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [5038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3765),
  [5040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [5042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [5044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [5046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [5048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [5050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [5052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [5054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3112),
  [5056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [5058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [5060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [5062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [5064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [5066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [5068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [5070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4171),
  [5072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3106),
  [5074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [5076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [5078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [5080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [5082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [5084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [5086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [5088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [5090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [5092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [5094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [5096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3726),
  [5098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3678),
  [5100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_list, 1, 0, 0),
  [5102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3717),
  [5104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_without_blocks_list, 1, 0, 0),
  [5106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [5108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_without_blocks_list, 1, 0, 0),
  [5110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [5112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [5114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [5116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [5118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [5120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 1, 0, 0),
  [5122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2254),
  [5124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [5126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_without_blocks, 1, 0, 0), SHIFT(4300),
  [5129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2131),
  [5131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_clause, 1, 0, 0),
  [5133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_definition, 1, 0, 6),
  [5135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2166),
  [5137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 1, 0, 0),
  [5139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2320),
  [5141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3777),
  [5143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [5145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [5147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2258),
  [5149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2341),
  [5151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [5153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_without_blocks_list_repeat1, 2, 0, 0),
  [5155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_expression_without_blocks_list_repeat1, 2, 0, 0),
  [5157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3514),
  [5159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3839),
  [5161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 2, 0, 92),
  [5163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 2, 0, 92),
  [5165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3840),
  [5167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_select_expression_repeat1, 1, 0, 0),
  [5169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 1, 0, 0),
  [5171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_match_arms_repeat1, 1, 0, 0),
  [5173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_arms_repeat1, 1, 0, 0),
  [5175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select_arm, 2, 0, 0),
  [5177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_arm, 2, 0, 0),
  [5179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_else_arm_clause, 2, 0, 34),
  [5181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_else_arm_clause, 2, 0, 34),
  [5183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__struct_field_definition, 4, 0, 115),
  [5185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3196),
  [5187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [5189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [5191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [5193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2344),
  [5195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2342),
  [5197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [5199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [5201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [5203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4342),
  [5205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3197),
  [5207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [5209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3347),
  [5211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [5213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3838),
  [5215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__array_repeat1, 2, 0, 0),
  [5217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2273),
  [5219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_map_init_expression_repeat1, 2, 0, 0),
  [5221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mutability_modifiers, 2, 0, 0),
  [5223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mutability_modifiers, 2, 0, 0),
  [5225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2374),
  [5227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2868),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4213),
  [5231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 18),
  [5233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_short_element_list_repeat1, 2, 0, 18),
  [5235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [5237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [5239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [5241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [5243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [5245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [5247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mutability_modifiers, 3, 0, 0),
  [5249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mutability_modifiers, 3, 0, 0),
  [5251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3704),
  [5253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [5255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [5257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2429),
  [5259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2428),
  [5261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [5263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3704),
  [5265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [5267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_field_definition, 3, 0, 40),
  [5269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3820),
  [5271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3830),
  [5273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3821),
  [5275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3117),
  [5277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [5279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [5281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [5283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [5285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [5287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [5289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [5291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [5293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [5295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [5297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [5299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [5301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4328),
  [5303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [5305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [5307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2446),
  [5309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [5311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [5313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [5315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [5317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [5319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [5321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [5325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [5329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [5331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [5333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3836),
  [5335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [5337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [5341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2860),
  [5343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2859),
  [5345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [5347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3753),
  [5349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [5351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [5353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [5355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [5357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(946),
  [5359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [5361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [5363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [5367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2735),
  [5369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2733),
  [5371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2732),
  [5373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [5375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4343),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3753),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [5389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [5391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [5393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [5395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [5397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [5399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [5401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [5403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [5405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [5407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [5409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [5411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3198),
  [5413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [5415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2622),
  [5417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2862),
  [5419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [5421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [5423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4233),
  [5425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3191),
  [5427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [5429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [5431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [5433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [5435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [5437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3776),
  [5439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_clause, 3, 0, 33),
  [5441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [5443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [5445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [5447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [5449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [5451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [5453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [5455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [5457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [5459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [5461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [5463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3701),
  [5465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [5467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [5469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [5473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [5475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [5477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [5479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [5481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [5483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [5485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [5487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [5489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2951),
  [5491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [5493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [5495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [5497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [5499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [5501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [5503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression_list, 1, 0, 0),
  [5505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [5507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3201),
  [5509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [5511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2943),
  [5513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2811),
  [5515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [5517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [5519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2933),
  [5521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [5523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3698),
  [5525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [5527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2944),
  [5529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [5531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2946),
  [5533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3775),
  [5535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [5537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [5539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2960),
  [5541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [5543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [5545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [5547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [5549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_attribute, 2, 0, 0),
  [5551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4199),
  [5553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2967),
  [5555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3140),
  [5557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2930),
  [5559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3767),
  [5561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [5563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2950),
  [5565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [5567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [5569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [5571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [5573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [5575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2934),
  [5577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [5579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2974),
  [5581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3699),
  [5583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [5585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2945),
  [5587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [5589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2958),
  [5591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__definite_range, 3, 0, 98),
  [5593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [5595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [5597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2916),
  [5599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [5601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [5603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3382),
  [5605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [5607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [5609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [5611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3071),
  [5613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [5615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [5617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [5619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [5621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [5623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [5625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [5627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [5629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [5631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [5633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [5635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [5637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [5639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [5641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [5643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [5645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [5647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_expression_list_repeat1, 2, 0, 0),
  [5649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [5651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [5653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [5655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [5657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [5659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [5661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [5663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [5665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [5667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2683),
  [5669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [5671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [5673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [5675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [5677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [5679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [5681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [5683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [5685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3743),
  [5687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [5689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [5691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range, 3, 0, 98),
  [5693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [5695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [5697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [5699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [5701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [5703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [5705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [5707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [5709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [5711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [5713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [5715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2909),
  [5717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [5719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2815),
  [5721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [5723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range, 2, 0, 66),
  [5725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [5727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [5729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [5731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [5733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [5735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [5737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [5739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [5741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [5743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [5745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [5747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [5749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [5751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mutable_identifier, 2, 0, 0),
  [5753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [5755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [5757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [5759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3208),
  [5761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3343),
  [5763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [5765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3751),
  [5767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [5769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [5771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [5773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [5775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [5777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3744),
  [5779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3233),
  [5781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [5783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [5785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [5787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [5789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [5791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3735),
  [5793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3276),
  [5795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2959),
  [5797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2938),
  [5799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [5801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3265),
  [5803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3264),
  [5805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3214),
  [5807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3293),
  [5809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3292),
  [5811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3290),
  [5813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_definition, 2, 0, 26),
  [5815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3230),
  [5819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2805),
  [5821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [5823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [5827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_lambda, 4, 0, 0),
  [5829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [5831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [5833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [5835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_lambda, 3, 0, 0),
  [5837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [5839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3177),
  [5841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3189),
  [5843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3325),
  [5845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [5847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [5849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [5851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3302),
  [5853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [5855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_clause, 2, 0, 28),
  [5857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [5859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [5861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [5863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [5865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_lambda, 5, 0, 0),
  [5867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [5869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [5871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [5873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [5875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [5877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [5879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [5881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3179),
  [5883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [5885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [5887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [5889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2938),
  [5891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [5893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [5895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3214),
  [5897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [5899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [5901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [5903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [5905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [5907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [5909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [5911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [5913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [5915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [5917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [5919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [5921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [5923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [5925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [5927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3152),
  [5929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [5931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [5933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [5935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [5937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3286),
  [5939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [5941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [5943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [5945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2905),
  [5947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [5949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [5951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [5953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [5955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [5957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [5959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [5961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2808),
  [5963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [5965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [5967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [5969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [5971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [5973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [5975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [5977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2929),
  [5979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [5981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [5983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [5985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [5987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [5989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [5991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3472),
  [5993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3184),
  [5995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [5997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [5999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [6001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [6003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3274),
  [6005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [6007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [6009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [6011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [6013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [6015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [6017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3193),
  [6019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [6021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [6023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [6025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [6027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3105),
  [6029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [6031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [6033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [6035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [6037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [6039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [6041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [6043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [6045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [6047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [6049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [6051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3294),
  [6053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [6055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [6057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [6059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [6061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [6063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [6065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [6067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [6069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [6071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3262),
  [6073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [6075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [6077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [6079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [6081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [6083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3326),
  [6085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3311),
  [6087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [6089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [6091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [6093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3242),
  [6095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3157),
  [6097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [6099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3185),
  [6101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [6103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [6105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [6107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [6109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [6111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [6113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3247),
  [6115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [6117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [6119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [6121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [6123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [6125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [6127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [6129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [6131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [6133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [6135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [6137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [6139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [6141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [6143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3334),
  [6145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [6147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2465),
  [6149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4282),
  [6151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3946),
  [6153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3732),
  [6155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2832),
  [6157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4022),
  [6159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4022),
  [6161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4213),
  [6163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3654),
  [6165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [6167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4193),
  [6169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 4, 0, 0),
  [6171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 3, 0, 0),
  [6173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3384),
  [6175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3393),
  [6177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [6179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3394),
  [6181] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_strictly_expression_list_repeat1, 2, 0, 0), SHIFT_REPEAT(537),
  [6184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_without_blocks_list, 2, 0, 0),
  [6186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [6188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [6190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_without_blocks_list_repeat1, 2, 0, 0), SHIFT_REPEAT(628),
  [6193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_arm_statement, 1, 0, 0),
  [6195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [6197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2343),
  [6199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [6201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interface_body_repeat1, 2, 0, 0), SHIFT_REPEAT(2343),
  [6204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interface_body_repeat1, 2, 0, 0),
  [6206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interface_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4417),
  [6209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interface_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4408),
  [6212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [6214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2525),
  [6216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [6218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [6220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [6222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__struct_body_repeat1, 2, 0, 0), SHIFT_REPEAT(2525),
  [6225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__struct_body_repeat1, 2, 0, 0),
  [6227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__struct_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4417),
  [6230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__struct_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4408),
  [6233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [6235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [6237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [6239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3470),
  [6241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributes_repeat1, 1, 0, 0),
  [6243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [6245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [6247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [6249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [6251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [6253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [6255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [6257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [6259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4016),
  [6261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [6263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [6265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [6267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [6269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3462),
  [6271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [6273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [6275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [6277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [6279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [6281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2818),
  [6283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [6285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [6287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [6289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [6291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [6293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [6295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [6297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2847),
  [6299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2786),
  [6301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3455),
  [6303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [6305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [6307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [6309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2, 0, 0),
  [6311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2, 0, 0), SHIFT_REPEAT(3347),
  [6314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributes, 1, 0, 0),
  [6316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receiver, 5, 0, 111),
  [6318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receiver, 5, 0, 111),
  [6320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__struct_field_definition, 2, 0, 44),
  [6322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [6324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receiver, 4, 0, 79),
  [6326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receiver, 4, 0, 79),
  [6328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_method_definition, 2, 0, 89),
  [6330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_embedded_definition, 1, 0, 0),
  [6332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_method_definition, 3, 0, 117),
  [6334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3061),
  [6336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility_modifiers, 1, 0, 0),
  [6338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3728),
  [6340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4535),
  [6342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3914),
  [6344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [6346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [6348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4521),
  [6350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3563),
  [6352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4520),
  [6354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4519),
  [6356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [6358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4012),
  [6360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_field_definition, 1, 0, 6),
  [6362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [6364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [6366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__struct_field_definition, 3, 0, 87),
  [6368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_path, 2, 0, 0),
  [6370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4359),
  [6372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__struct_field_definition, 5, 0, 135),
  [6374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_method_definition, 4, 0, 137),
  [6376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_method_definition, 3, 0, 116),
  [6378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__struct_body_repeat1, 1, 0, 0),
  [6380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3672),
  [6382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_field_declaration, 1, 0, 17),
  [6384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_field_declaration, 1, 0, 0),
  [6386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [6388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_list, 1, 0, 0),
  [6390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_path_repeat1, 2, 0, 0),
  [6392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_path_repeat1, 2, 0, 0), SHIFT_REPEAT(4359),
  [6395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec, 1, 0, 0),
  [6397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4354),
  [6399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4356),
  [6401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_path, 1, 0, 0),
  [6403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_field_scope, 2, 0, 0),
  [6405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3494),
  [6408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_element_list_repeat1, 2, 0, 0),
  [6410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_element_list_repeat1, 2, 0, 0), SHIFT_REPEAT(712),
  [6413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_field_scope, 3, 0, 0),
  [6415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interface_body_repeat1, 1, 0, 0),
  [6417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3658),
  [6419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3677),
  [6421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1577),
  [6423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [6425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [6427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2205),
  [6429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3664),
  [6431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [6433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [6435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [6437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [6439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2400),
  [6441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2874),
  [6443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [6445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1331),
  [6447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_name, 1, 0, 0),
  [6449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2399),
  [6451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [6453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2836),
  [6455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2837),
  [6457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [6459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [6461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3960),
  [6463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4000),
  [6465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4443),
  [6467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2882),
  [6469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2883),
  [6471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [6473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [6475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [6477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility_modifiers, 1, 0, 0),
  [6479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2738),
  [6481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [6483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1565),
  [6485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1463),
  [6487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [6489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2056),
  [6491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [6493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [6495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3971),
  [6497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [6499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2096),
  [6501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2712),
  [6503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1566),
  [6505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2713),
  [6507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [6509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [6511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_selective_import_list_repeat1, 1, 0, 0),
  [6513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [6515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1444),
  [6517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [6519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2353),
  [6521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2739),
  [6523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2352),
  [6525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3930),
  [6527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4542),
  [6529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [6531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4540),
  [6533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4539),
  [6535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4538),
  [6537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [6539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [6541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interpreted_string_literal_repeat2, 2, 0, 0), SHIFT_REPEAT(3664),
  [6544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_interpreted_string_literal_repeat2, 2, 0, 0),
  [6546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpreted_string_literal_repeat2, 2, 0, 0), SHIFT_REPEAT(3664),
  [6549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interpreted_string_literal_repeat2, 2, 0, 0), SHIFT_REPEAT(492),
  [6552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interpreted_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(3677),
  [6555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_interpreted_string_literal_repeat1, 2, 0, 0),
  [6557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpreted_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(3677),
  [6560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interpreted_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(462),
  [6563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [6565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [6567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1576),
  [6569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2471),
  [6571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2468),
  [6573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [6575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2311),
  [6577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [6579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3595),
  [6581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3784),
  [6583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [6585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4433),
  [6587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_specifier, 1, 0, 0),
  [6589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3874),
  [6591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4430),
  [6593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3815),
  [6595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3815),
  [6597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [6599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [6601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4568),
  [6603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4569),
  [6605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4571),
  [6607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_selective_import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3595),
  [6610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_selective_import_list_repeat1, 2, 0, 0),
  [6612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec, 2, 0, 0),
  [6614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3718),
  [6616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_interpolation, 4, 0, 93),
  [6618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_interpolation, 4, 0, 93),
  [6620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interface_body_repeat1, 2, 0, 0),
  [6622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [6624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4276),
  [6626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4580),
  [6628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [6630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_interpolation, 3, 0, 61),
  [6632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_interpolation, 3, 0, 61),
  [6634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_interpreted_string_literal_repeat2, 1, 0, 0),
  [6636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpreted_string_literal_repeat2, 1, 0, 0),
  [6638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_field_definition, 4, 0, 136),
  [6640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3090),
  [6642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_interpolation, 2, 0, 24),
  [6644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_interpolation, 2, 0, 24),
  [6646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_alias, 2, 0, 0),
  [6648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__struct_body_repeat1, 2, 0, 0),
  [6650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_attribute, 1, 0, 5),
  [6652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__enum_body_repeat1, 1, 0, 0),
  [6654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4208),
  [6656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_interpreted_string_literal_repeat1, 1, 0, 0),
  [6658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpreted_string_literal_repeat1, 1, 0, 0),
  [6660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4345),
  [6662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_field_definition, 2, 0, 88),
  [6664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [6666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [6668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [6670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [6672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [6674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [6676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [6678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [6680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4054),
  [6682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4715),
  [6684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [6690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [6692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [6694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [6696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [6698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4603),
  [6700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [6702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [6704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [6706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [6708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [6710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [6712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [6714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2879),
  [6716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [6718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3811),
  [6720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selective_import_list, 3, 0, 0),
  [6722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4716),
  [6724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [6726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [6728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1921),
  [6730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [6732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [6734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [6736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3060),
  [6738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [6740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [6742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [6744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [6746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name, 1, 0, 0),
  [6748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3495),
  [6750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [6752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2796),
  [6754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3746),
  [6756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3983),
  [6758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [6760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [6762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [6764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [6766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [6768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [6770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [6772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [6774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [6776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2780),
  [6778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [6780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2693),
  [6782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [6784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_var_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(3060),
  [6787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_global_var_declaration_repeat1, 2, 0, 0),
  [6789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [6791] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(4256),
  [6794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_parameters_repeat1, 2, 0, 0),
  [6796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [6798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(3174),
  [6801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, 0, 0),
  [6803] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_const_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(4603),
  [6806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_const_declaration_repeat1, 2, 0, 0),
  [6808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec, 3, 0, 0),
  [6810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [6812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [6814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__enum_body_repeat1, 2, 0, 0), SHIFT_REPEAT(3495),
  [6817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__enum_body_repeat1, 2, 0, 0),
  [6819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [6821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [6823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [6825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [6827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [6829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [6831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [6833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [6835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3352),
  [6837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3064),
  [6839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [6841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [6843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [6845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selective_import_list, 4, 0, 0),
  [6847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [6849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [6851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [6853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [6855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [6857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [6859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_comment_repeat1, 2, 0, 0), SHIFT_REPEAT(4054),
  [6862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_comment_repeat1, 2, 0, 0),
  [6864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [6866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [6868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [6870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [6872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [6874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [6876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4274),
  [6878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4644),
  [6880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_specifier, 2, 0, 0),
  [6882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4063),
  [6884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4656),
  [6886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [6888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [6890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4268),
  [6892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [6894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [6896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [6898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [6900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [6902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [6904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [6906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [6908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3738),
  [6910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4002),
  [6912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_parameter, 1, 0, 0),
  [6914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3062),
  [6916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [6918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4407),
  [6920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4485),
  [6922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1568),
  [6924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4271),
  [6926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [6928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4273),
  [6930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [6932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [6934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [6936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [6938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [6940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3579),
  [6942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4005),
  [6944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3375),
  [6946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [6948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [6950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [6952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4392),
  [6954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [6956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [6958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [6960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3447),
  [6962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [6964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1578),
  [6966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [6968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4366),
  [6970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4549),
  [6972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [6974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [6976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [6978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [6980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2737),
  [6982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [6984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [6986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [6988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [6990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [6992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [6994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [6996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [6998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [7000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [7002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3450),
  [7004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [7006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [7008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_identifier_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3678),
  [7011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_identifier_list_repeat1, 2, 0, 0),
  [7013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [7015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2310),
  [7017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3355),
  [7019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [7021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [7023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [7025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [7027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [7029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2709),
  [7031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [7033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4322),
  [7035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4439),
  [7037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [7041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2499),
  [7043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression_list, 2, 0, 59),
  [7045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [7047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [7049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [7051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [7053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_raw_string_literal_repeat2, 2, 0, 0),
  [7055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_raw_string_literal_repeat2, 2, 0, 0), SHIFT_REPEAT(4273),
  [7058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4646),
  [7060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3771),
  [7062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [7064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [7066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [7068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3100),
  [7070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [7072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [7074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_definition_list, 2, 0, 0),
  [7076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression_list, 2, 0, 0),
  [7078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [7080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1458),
  [7082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4199),
  [7084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3669),
  [7086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [7088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4372),
  [7090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4566),
  [7092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [7094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3785),
  [7096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2467),
  [7098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4317),
  [7100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4509),
  [7102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [7104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [7106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [7108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [7110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2850),
  [7112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3091),
  [7114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [7116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [7118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [7120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2351),
  [7122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [7124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_definition_list, 1, 0, 0),
  [7126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [7128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [7130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3713),
  [7132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2057),
  [7134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [7136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2767),
  [7138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4327),
  [7140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4533),
  [7142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_raw_string_literal_repeat1, 2, 0, 0),
  [7144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_raw_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(4271),
  [7147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [7149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [7151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_parameters, 5, 0, 0),
  [7153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_without_blocks_list_repeat1, 2, 0, 0), SHIFT_REPEAT(819),
  [7156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_capture_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3647),
  [7159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_capture_list_repeat1, 2, 0, 0),
  [7161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_capture_list, 5, 0, 0),
  [7163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4243),
  [7165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4554),
  [7167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [7169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [7171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [7173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2881),
  [7175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [7177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 1, 0, 13),
  [7179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_strictly_expression_list_repeat1, 2, 0, 0), SHIFT_REPEAT(550),
  [7182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_capture_list, 4, 0, 0),
  [7184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4149),
  [7186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4512),
  [7188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__plain_attribute, 1, 0, 0),
  [7190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [7192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [7194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [7196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [7198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_parameters, 4, 0, 0),
  [7200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [7202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [7204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [7206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [7208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [7210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [7212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [7214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [7216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3370),
  [7218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [7220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [7222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [7224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2834),
  [7226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [7228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4210),
  [7230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4419),
  [7232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2105),
  [7234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4139),
  [7236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4555),
  [7238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [7240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_parameters, 3, 0, 0),
  [7242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2931),
  [7245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_list_repeat1, 2, 0, 0),
  [7247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [7249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_capture_list, 3, 0, 0),
  [7251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [7253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [7255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [7257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [7259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_strictly_expression_list_repeat1, 2, 0, 0), SHIFT_REPEAT(576),
  [7262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_expression_list_repeat1, 2, 0, 0), SHIFT_REPEAT(392),
  [7265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2178),
  [7267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3087),
  [7269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_repeat1, 2, 0, 0), SHIFT_REPEAT(3355),
  [7272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_repeat1, 2, 0, 0),
  [7274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [7276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [7278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_strictly_expression_list_repeat1, 2, 0, 0), SHIFT_REPEAT(565),
  [7281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_overridable_operator, 1, 0, 0),
  [7283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3667),
  [7286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0),
  [7288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm_type, 1, 0, 0),
  [7290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [7292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [7294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression_list, 1, 0, 59),
  [7296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [7298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [7300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [7302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [7304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_list, 2, 0, 0),
  [7306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [7308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3089),
  [7310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [7312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [7314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [7316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2810),
  [7318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [7320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [7322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [7324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [7326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [7328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [7330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [7332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3366),
  [7334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [7336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3367),
  [7338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_var_definition_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3918),
  [7341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_var_definition_list_repeat1, 2, 0, 0),
  [7343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [7345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [7347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_comment_repeat1, 1, 0, 0),
  [7349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [7351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4126),
  [7353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4558),
  [7355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [7357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [7359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [7361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [7363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [7365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4577),
  [7367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_specifier, 3, 0, 0),
  [7369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4415),
  [7371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [7373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2790),
  [7375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [7377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [7379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [7381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [7383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3098),
  [7385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [7387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [7389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [7391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [7393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4253),
  [7395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4593),
  [7397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_short_lambda_repeat1, 2, 0, 0), SHIFT_REPEAT(4392),
  [7400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_short_lambda_repeat1, 2, 0, 0),
  [7402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [7404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [7406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [7408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [7410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [7412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [7414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [7416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [7418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4172),
  [7420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4588),
  [7422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [7424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [7426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4142),
  [7428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4449),
  [7430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [7432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3725),
  [7434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [7436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [7438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [7440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [7442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [7444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [7446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [7448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [7450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [7452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [7454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [7456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [7458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [7460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [7462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [7464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [7466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4700),
  [7468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [7470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [7472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [7474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [7476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [7478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 3, 0, 78),
  [7480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [7482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [7484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [7486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [7488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [7490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [7492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [7494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [7496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [7498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [7500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [7502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [7504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4470),
  [7506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [7508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [7510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [7512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [7514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [7516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [7518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_key_value_attribute, 3, 0, 56),
  [7520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_attribute, 3, 0, 0),
  [7522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [7524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [7526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [7528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [7530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2817),
  [7532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [7534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [7536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [7538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_expression_list_repeat1, 2, 0, 119),
  [7540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [7542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_capture, 2, 0, 0),
  [7544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3403),
  [7546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [7548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [7550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 2, 0, 45),
  [7552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 3, 0, 80),
  [7554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [7556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [7558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_expression, 1, 0, 0),
  [7560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 3, 0, 81),
  [7562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [7564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [7566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [7568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, 0, 44),
  [7570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [7572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 2, 0, 43),
  [7574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3400),
  [7576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_raw_string_literal_repeat1, 1, 0, 0),
  [7578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_raw_string_literal_repeat1, 1, 0, 0),
  [7580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_raw_string_literal_repeat2, 1, 0, 0),
  [7582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_raw_string_literal_repeat2, 1, 0, 0),
  [7584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_specifier, 4, 0, 0),
  [7586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4570),
  [7588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [7590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4428),
  [7592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [7594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [7596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 4, 0, 110),
  [7598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [7600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [7602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3357),
  [7604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [7606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [7608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [7610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3413),
  [7612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [7614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [7616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [7618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [7620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [7622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [7624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [7626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_specifier, 5, 0, 0),
  [7628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4477),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [7632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [7634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [7636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [7638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [7640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [7642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [7644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [7646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [7648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [7650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [7652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [7654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [7656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3349),
  [7658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [7660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [7662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [7664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_capture, 1, 0, 0),
  [7666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [7668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [7670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [7672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [7674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3426),
  [7676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [7678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4627),
  [7680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [7682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [7684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [7686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [7688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [7690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4668),
  [7692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 4, 0, 94),
  [7694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [7696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 4, 0, 95),
  [7698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4162),
  [7700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4201),
  [7702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [7704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4618),
  [7706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [7708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [7710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [7712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4206),
  [7714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [7716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [7718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4573),
  [7720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [7722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [7724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4413),
  [7726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [7728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [7730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [7732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4463),
  [7734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [7736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__select_arm_assignment_statement, 2, 0, 0),
  [7738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [7740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4332),
  [7742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [7744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [7746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [7748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [7750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [7752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [7754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [7756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_var_declaration, 3, 0, 37),
  [7758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4174),
  [7760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [7762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [7764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4632),
  [7766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [7768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [7770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [7772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [7774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_specifier, 6, 0, 0),
  [7776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4207),
  [7778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [7780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [7782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [7784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [7786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [7788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4435),
  [7790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4357),
  [7792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [7794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [7796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [7798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [7800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [7802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [7804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [7806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [7808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [7810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4309),
  [7812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [7814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [7816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [7818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [7820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4340),
  [7822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [7824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4496),
  [7826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [7828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4529),
  [7830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [7832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [7834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [7836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [7838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3679),
  [7840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3768),
  [7842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3661),
  [7844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4403),
  [7846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [7848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2662),
  [7850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [7852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4230),
  [7854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [7856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [7858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [7860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4645),
  [7862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [7864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [7866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3659),
  [7868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3774),
  [7870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [7872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [7874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [7876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2672),
  [7878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [7880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4122),
  [7882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3440),
  [7884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [7886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4712),
  [7888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2680),
  [7890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [7892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4124),
  [7894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4692),
  [7896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [7898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [7900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4676),
  [7902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [7904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [7906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3433),
  [7908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [7910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [7912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [7914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [7916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4476),
  [7918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [7920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3676),
  [7922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3716),
  [7924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3665),
  [7926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [7928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [7930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [7932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4325),
  [7934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [7936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [7938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4320),
  [7940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [7942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [7944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [7946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [7948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [7950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [7952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4635),
  [7954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [7956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3684),
  [7958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4506),
  [7960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [7962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [7964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [7966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [7968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4187),
  [7970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [7972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [7974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [7976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4180),
  [7978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [7980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [7982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [7984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4300),
  [7986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [7988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3266),
  [7990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [7992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [7994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [7996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [7998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [8000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [8002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [8004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_receiver, 1, 0, 0),
  [8006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [8008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [8010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [8012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [8014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4714),
  [8016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [8018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [8020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3432),
  [8022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [8024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [8026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [8028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_backed_type, 2, 0, 0),
  [8030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [8032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [8034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [8036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [8038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4275),
  [8040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [8042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [8044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [8046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [8048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [8050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2809),
  [8052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [8054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [8056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [8058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1915),
  [8060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [8062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_else_arn_clause, 2, 0, 0),
  [8064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [8066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [8068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [8070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [8072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_arm_statement, 2, 0, 0),
  [8074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [8076] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [8078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [8080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [8082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4281),
  [8084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [8086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1874),
  [8088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [8090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [8092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [8094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [8096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [8098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3182),
  [8100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [8102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [8104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_clause, 3, 0, 63),
  [8106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [8108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [8110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 5, 0, 120),
  [8112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, 0, 64),
  [8114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [8116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1949),
  [8118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [8120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [8122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [8124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3430),
  [8126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3195),
  [8128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [8130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3084),
  [8132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [8134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [8136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3739),
  [8138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [8140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [8142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2637),
  [8144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [8146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [8148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [8150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [8152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [8154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [8156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_line_comment, 2, 0, 0),
  [8158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 2, 0, 0),
  [8160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 3, 0, 0),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_v(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
